/*!--------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/(function(){var x=["require","exports","vs/base/common/lifecycle","vs/base/common/platform","vs/base/common/event","vs/platform/instantiation/common/instantiation","vs/platform/log/common/log","vs/base/common/uri","vs/base/common/path","vs/base/common/async","vs/base/common/network","vs/nls!vs/code/electron-main/main","vs/nls","vs/base/common/types","electron","vs/base/common/resources","vs/base/common/errors","vs/base/common/buffer","vs/platform/configuration/common/configuration","vs/platform/files/common/files","vs/platform/lifecycle/electron-main/lifecycleMainService","vs/base/node/pfs","vs/platform/product/common/productService","vs/base/common/cancellation","vs/platform/environment/electron-main/environmentMainService","vs/base/common/strings","os","vs/platform/workspaces/common/workspaces","fs","vs/platform/telemetry/common/telemetry","vs/base/common/arrays","vs/base/common/uuid","vs/base/common/extpath","vs/base/common/labels","vs/base/common/process","vs/base/parts/ipc/common/ipc","vs/platform/windows/electron-main/windows","vs/platform/state/electron-main/state","vs/base/common/json","vs/base/common/map","vs/platform/registry/common/platform","vs/platform/update/common/update","vs/base/common/functional","child_process","vs/base/common/errorMessage","vs/platform/workspaces/electron-main/workspacesManagementMainService","vs/base/common/decorators","vs/base/common/objects","vs/platform/environment/common/environment","vs/platform/request/common/request","vs/platform/backup/electron-main/backup","vs/platform/dialogs/electron-main/dialogMainService","vs/platform/native/electron-main/nativeHostMainService","vs/platform/environment/node/argvHelper","vs/platform/files/common/watcher","vs/platform/product/common/product","vs/platform/protocol/electron-main/protocol","vs/platform/configuration/common/configurationRegistry","vs/base/parts/ipc/node/ipc.net","vs/base/common/keybindings","vs/base/common/stream","crypto","net","vs/base/common/performance","vs/platform/remote/common/remoteHosts","vs/platform/telemetry/common/telemetryUtils","vs/platform/theme/electron-main/themeMainService","vs/platform/windows/common/windows","vs/platform/workspaces/electron-main/workspacesHistoryMainService","vs/base/common/iterator","vs/base/common/normalization","vs/base/node/id","vs/base/node/processes","vs/platform/instantiation/common/descriptors","vs/platform/diagnostics/common/diagnostics","vs/platform/instantiation/common/serviceCollection","vs/platform/sign/common/sign","vs/platform/update/electron-main/abstractUpdateService","vs/base/common/jsonEdit","vs/base/common/keyCodes","vs/base/common/processes","vs/base/common/hash","vs/base/node/extpath","vs/base/node/ps","vs/base/parts/ipc/common/ipc.net","vs/base/parts/ipc/electron-main/ipc.mp","vs/base/parts/storage/common/storage","vs/base/parts/ipc/node/ipc.cp","vs/platform/environment/node/argv","vs/platform/encryption/electron-main/encryptionMainService","vs/platform/externalTerminal/common/externalTerminal","vs/platform/environment/node/shellEnv","vs/platform/files/common/io","vs/platform/files/node/watcher/nodejs/watcherService","vs/platform/files/node/diskFileSystemProvider","vs/platform/log/common/bufferLog","vs/platform/log/node/spdlogLog","vs/platform/remote/common/tunnel","vs/platform/storage/common/storage","vs/platform/url/common/url","vs/platform/storage/electron-main/storageMainService","vs/platform/windows/electron-main/windowsFinder","vs/platform/workspaces/electron-main/workspaces","vs/platform/launch/electron-main/launchMainService","vs/base/common/assert","vs/base/common/jsonFormatter","vs/base/common/keybindingParser","vs/base/common/linkedList","vs/base/common/stopwatch","vs/base/common/codicons","vs/base/common/console","vs/base/common/marshalling","vs/base/common/uriIpc","vs/base/common/worker/simpleWorker","vs/base/node/crypto","vs/base/node/decoder","vs/base/node/macAddress","util","vs/base/node/ports","vs/base/node/powershell","vs/base/node/watcher","vs/base/parts/contextmenu/common/contextmenu","vs/base/parts/contextmenu/electron-main/contextmenu","vs/base/parts/ipc/common/ipc.electron","vs/base/parts/ipc/common/ipc.mp","vs/base/parts/ipc/electron-main/ipc.electron","vs/base/parts/storage/node/storage","vs/nls!vs/base/common/date","vs/base/common/date","vs/nls!vs/base/common/errorMessage","vs/nls!vs/base/common/keybindingLabels","vs/base/common/keybindingLabels","vs/nls!vs/base/node/processes","vs/base/node/shell","vs/nls!vs/code/electron-main/app","vs/nls!vs/platform/configuration/common/configurationRegistry","vs/nls!vs/platform/dialogs/electron-main/dialogMainService","vs/nls!vs/platform/environment/node/argv","vs/nls!vs/platform/environment/node/argvHelper","vs/nls!vs/platform/environment/node/shellEnv","vs/nls!vs/platform/extensionManagement/common/extensionManagement","vs/nls!vs/platform/extensions/common/extensionValidator","vs/nls!vs/platform/externalTerminal/node/externalTerminalService","vs/nls!vs/platform/files/common/fileService","vs/nls!vs/platform/files/common/files","vs/nls!vs/platform/files/common/io","vs/nls!vs/platform/files/electron-main/diskFileSystemProviderIpc","vs/nls!vs/platform/files/node/diskFileSystemProvider","vs/nls!vs/platform/issue/electron-main/issueMainService","vs/nls!vs/platform/menubar/electron-main/menubar","vs/nls!vs/platform/native/electron-main/nativeHostMainService","vs/nls!vs/platform/request/common/request","vs/nls!vs/platform/telemetry/common/telemetryService","vs/nls!vs/platform/update/common/update.config.contribution","vs/nls!vs/platform/windows/electron-main/window","vs/nls!vs/platform/windows/electron-main/windowsMainService","vs/nls!vs/platform/workspaces/common/workspaces","vs/nls!vs/platform/workspaces/electron-main/workspacesHistoryMainService","vs/nls!vs/platform/workspaces/electron-main/workspacesManagementMainService","vs/platform/debug/common/extensionHostDebugIpc","vs/platform/driver/common/driverIpc","vs/platform/environment/common/environmentService","vs/platform/debug/electron-main/extensionHostDebugIpc","vs/platform/environment/node/userDataPath","vs/platform/environment/node/environmentService","vs/platform/environment/node/wait","vs/platform/extensions/common/extensionValidator","vs/platform/files/node/diskFileSystemProviderIpc","vs/platform/instantiation/common/graph","vs/platform/extensionManagement/common/extensionManagement","vs/platform/extensionManagement/common/extensionUrlTrust","vs/platform/extensions/common/extensionHostStarter","vs/platform/externalTerminal/node/externalTerminalService","vs/platform/files/node/watcher/nsfw/watcherService","vs/platform/files/node/watcher/parcel/watcherService","vs/platform/instantiation/common/instantiationService","vs/platform/keybinding/common/baseResolvedKeybinding","vs/platform/keybinding/common/resolvedKeybindingItem","vs/platform/keybinding/common/usLayoutResolvedKeybinding","vs/platform/lifecycle/common/lifecycle","vs/platform/configuration/common/userConfigurationFileService","vs/platform/files/common/diskFileSystemProvider","vs/platform/files/common/fileService","vs/platform/files/electron-main/diskFileSystemProviderIpc","vs/platform/log/common/fileLog","vs/platform/log/common/logIpc","vs/platform/log/node/loggerService","vs/platform/menubar/common/menubar","vs/platform/extensionManagement/node/extensionUrlTrustService","vs/platform/protocol/electron-main/protocolMainService","vs/platform/jsonschemas/common/jsonContributionRegistry","vs/platform/configuration/common/configurationModels","vs/platform/configuration/common/configurationService","vs/platform/remote/common/remoteAuthorityResolver","vs/platform/remote/common/remoteAgentConnection","vs/platform/extensions/common/extensions","vs/platform/extensionManagement/common/extensionManagementUtil","vs/platform/request/node/proxy","url","vs/platform/serviceMachineId/common/serviceMachineId","vs/platform/sign/node/signService","vs/platform/keyboardLayout/electron-main/keyboardLayoutMainService","vs/platform/telemetry/common/commonProperties","vs/platform/diagnostics/node/diagnosticsService","vs/platform/telemetry/common/telemetryIpc","vs/platform/extensionManagement/common/extensionGalleryService","vs/platform/telemetry/common/telemetryService","vs/platform/theme/common/theme","vs/platform/theme/common/themeService","vs/platform/update/common/update.config.contribution","vs/platform/update/common/updateIpc","vs/platform/url/common/urlIpc","vs/platform/url/common/urlService","vs/platform/url/electron-main/electronUrlListener","vs/platform/webview/common/webviewManagerService","vs/platform/webview/electron-main/webviewProtocolProvider","vs/platform/webview/electron-main/webviewMainService","vs/platform/windows/node/windowTracker","vs/platform/workspace/common/workspace","vs/platform/storage/electron-main/storageIpc","vs/platform/storage/electron-main/storageMain","vs/platform/windows/electron-main/windowsStateHandler","vs/platform/extensions/electron-main/workerMainProcessExtensionHostStarter","zlib","vs/platform/driver/node/driver","vs/platform/driver/electron-main/driver","vs/platform/backup/electron-main/backupMainService","vs/platform/remote/node/nodeSocketFactory","vs/platform/remote/node/tunnelService","vs/platform/request/node/requestService","vs/platform/request/electron-main/requestMainService","vs/platform/sharedProcess/electron-main/sharedProcess","vs/platform/state/electron-main/stateMainService","vs/platform/update/electron-main/updateService.darwin","vs/platform/update/electron-main/updateService.snap","vs/code/electron-main/auth","vs/platform/issue/electron-main/issueMainService","vs/platform/update/electron-main/updateService.linux","vs/platform/update/electron-main/updateService.win32","vs/platform/windows/electron-main/window","vs/platform/menubar/electron-main/menubar","vs/platform/menubar/electron-main/menubarMainService","vs/platform/windows/electron-main/windowsMainService","vs/platform/workspaces/electron-main/workspacesMainService","vs/code/electron-main/app","string_decoder","minimist","path","assert","graceful-fs","worker_threads","vs/code/electron-main/main"],ee=function(V){for(var e=[],p=0,R=V.length;p<R;p++)e[p]=x[V[p]];return e};define(x[104],ee([0,1]),function(V,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ok=void 0;function p(R,C){if(!R)throw new Error(C?`Assertion failed (${C})`:"Assertion Failed")}e.ok=p}),define(x[46],ee([0,1]),function(V,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.throttle=e.debounce=e.memoize=e.createDecorator=void 0;function p(n){return(I,d,f)=>{let y=null,E=null;if(typeof f.value=="function"?(y="value",E=f.value):typeof f.get=="function"&&(y="get",E=f.get),!E)throw new Error("not supported");f[y]=n(E,d)}}e.createDecorator=p;function R(n,I,d){let f=null,y=null;if(typeof d.value=="function"?(f="value",y=d.value,y.length!==0&&console.warn("Memoize should only be used in functions with zero parameters")):typeof d.get=="function"&&(f="get",y=d.get),!y)throw new Error("not supported");const E=`$memoize$${I}`;d[f]=function(...g){return this.hasOwnProperty(E)||Object.defineProperty(this,E,{configurable:!1,enumerable:!1,writable:!1,value:y.apply(this,g)}),this[E]}}e.memoize=R;function C(n,I,d){return p((f,y)=>{const E=`$debounce$${y}`,g=`$debounce$result$${y}`;return function(...S){this[g]||(this[g]=d?d():void 0),clearTimeout(this[E]),I&&(this[g]=I(this[g],...S),S=[this[g]]),this[E]=setTimeout(()=>{f.apply(this,S),this[g]=d?d():void 0},n)}})}e.debounce=C;function k(n,I,d){return p((f,y)=>{const E=`$throttle$timer$${y}`,g=`$throttle$result$${y}`,S=`$throttle$lastRun$${y}`,t=`$throttle$pending$${y}`;return function(...m){if(this[g]||(this[g]=d?d():void 0),(this[S]===null||this[S]===void 0)&&(this[S]=-Number.MAX_VALUE),I&&(this[g]=I(this[g],...m)),this[t])return;const v=this[S]+n;v<=Date.now()?(this[S]=Date.now(),f.apply(this,[this[g]]),this[g]=d?d():void 0):(this[t]=!0,this[E]=setTimeout(()=>{this[t]=!1,this[S]=Date.now(),f.apply(this,[this[g]]),this[g]=d?d():void 0},v-Date.now()))}})}e.throttle=k}),define(x[16],ee([0,1]),function(V,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createErrorWithActions=e.isErrorWithActions=e.ExpectedError=e.NotSupportedError=e.NotImplementedError=e.getErrorMessage=e.disposed=e.readonly=e.illegalState=e.illegalArgument=e.canceled=e.CancellationError=e.isPromiseCanceledError=e.transformErrorForSerialization=e.onUnexpectedExternalError=e.onUnexpectedError=e.setUnexpectedErrorHandler=e.errorHandler=e.ErrorHandler=void 0;class p{constructor(){this.listeners=[],this.unexpectedErrorHandler=function(o){setTimeout(()=>{throw o.stack?new Error(o.message+`

`+o.stack):o},0)}}addListener(o){return this.listeners.push(o),()=>{this._removeListener(o)}}emit(o){this.listeners.forEach(u=>{u(o)})}_removeListener(o){this.listeners.splice(this.listeners.indexOf(o),1)}setUnexpectedErrorHandler(o){this.unexpectedErrorHandler=o}getUnexpectedErrorHandler(){return this.unexpectedErrorHandler}onUnexpectedError(o){this.unexpectedErrorHandler(o),this.emit(o)}onUnexpectedExternalError(o){this.unexpectedErrorHandler(o)}}e.ErrorHandler=p,e.errorHandler=new p;function R(l){e.errorHandler.setUnexpectedErrorHandler(l)}e.setUnexpectedErrorHandler=R;function C(l){d(l)||e.errorHandler.onUnexpectedError(l)}e.onUnexpectedError=C;function k(l){d(l)||e.errorHandler.onUnexpectedExternalError(l)}e.onUnexpectedExternalError=k;function n(l){if(l instanceof Error){let{name:o,message:u}=l;const r=l.stacktrace||l.stack;return{$isError:!0,name:o,message:u,stack:r}}return l}e.transformErrorForSerialization=n;const I="Canceled";function d(l){return l instanceof Error&&l.name===I&&l.message===I}e.isPromiseCanceledError=d;class f extends Error{constructor(){super(I);this.name=this.message}}e.CancellationError=f;function y(){const l=new Error(I);return l.name=l.message,l}e.canceled=y;function E(l){return l?new Error(`Illegal argument: ${l}`):new Error("Illegal argument")}e.illegalArgument=E;function g(l){return l?new Error(`Illegal state: ${l}`):new Error("Illegal state")}e.illegalState=g;function S(l){return l?new Error(`readonly property '${l} cannot be changed'`):new Error("readonly property cannot be changed")}e.readonly=S;function t(l){const o=new Error(`${l} has been disposed`);return o.name="DISPOSED",o}e.disposed=t;function m(l){return l?l.message?l.message:l.stack?l.stack.split(`
`)[0]:String(l):"Error"}e.getErrorMessage=m;class v extends Error{constructor(o){super("NotImplemented");o&&(this.message=o)}}e.NotImplementedError=v;class b extends Error{constructor(o){super("NotSupported");o&&(this.message=o)}}e.NotSupportedError=b;class P extends Error{constructor(){super(...arguments);this.isExpected=!0}}e.ExpectedError=P;function c(l){const o=l;return o instanceof Error&&Array.isArray(o.actions)}e.isErrorWithActions=c;function a(l,o=Object.create(null)){const u=new Error(l);return o.actions&&(u.actions=o.actions),u}e.createErrorWithActions=a}),define(x[30],ee([0,1,16]),function(V,e,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ArrayQueue=e.maxIndex=e.minIndex=e.splice=e.insertInto=e.mapFind=e.getRandomElement=e.asArray=e.mapArrayOrNot=e.pushToEnd=e.pushToStart=e.shuffle=e.arrayInsert=e.remove=e.insert=e.index=e.range=e.flatten=e.commonPrefixLength=e.firstOrDefault=e.lastIndex=e.findLast=e.uniqueFilter=e.distinct=e.isNonEmptyArray=e.isFalsyOrEmpty=e.move=e.coalesceInPlace=e.coalesce=e.topAsync=e.top=e.delta=e.sortedDiff=e.groupBy=e.quickSelect=e.findFirstInSorted=e.binarySearch=e.equals=e.tail2=e.tail=void 0;function R(O,D=0){return O[O.length-(1+D)]}e.tail=R;function C(O){if(O.length===0)throw new Error("Invalid tail call");return[O.slice(0,O.length-1),O[O.length-1]]}e.tail2=C;function k(O,D,T=(_,z)=>_===z){if(O===D)return!0;if(!O||!D||O.length!==D.length)return!1;for(let _=0,z=O.length;_<z;_++)if(!T(O[_],D[_]))return!1;return!0}e.equals=k;function n(O,D,T){let _=0,z=O.length-1;for(;_<=z;){const X=(_+z)/2|0,B=T(O[X],D);if(B<0)_=X+1;else if(B>0)z=X-1;else return X}return-(_+1)}e.binarySearch=n;function I(O,D){let T=0,_=O.length;if(_===0)return 0;for(;T<_;){const z=Math.floor((T+_)/2);D(O[z])?_=z:T=z+1}return T}e.findFirstInSorted=I;function d(O,D,T){if(O=O|0,O>=D.length)throw new TypeError("invalid index");let _=D[Math.floor(D.length*Math.random())],z=[],X=[],B=[];for(let q of D){const ne=T(q,_);ne<0?z.push(q):ne>0?X.push(q):B.push(q)}return O<z.length?d(O,z,T):O<z.length+B.length?B[0]:d(O-(z.length+B.length),X,T)}e.quickSelect=d;function f(O,D){const T=[];let _;for(const z of O.slice(0).sort(D))!_||D(_[0],z)!==0?(_=[z],T.push(_)):_.push(z);return T}e.groupBy=f;function y(O,D,T){const _=[];function z(q,ne,se){if(ne===0&&se.length===0)return;const oe=_[_.length-1];oe&&oe.start+oe.deleteCount===q?(oe.deleteCount+=ne,oe.toInsert.push(...se)):_.push({start:q,deleteCount:ne,toInsert:se})}let X=0,B=0;for(;;){if(X===O.length){z(X,0,D.slice(B));break}if(B===D.length){z(X,O.length-X,[]);break}const q=O[X],ne=D[B],se=T(q,ne);se===0?(X+=1,B+=1):se<0?(z(X,1,[]),X+=1):se>0&&(z(X,0,[ne]),B+=1)}return _}e.sortedDiff=y;function E(O,D,T){const _=y(O,D,T),z=[],X=[];for(const B of _)z.push(...O.slice(B.start,B.start+B.deleteCount)),X.push(...B.toInsert);return{removed:z,added:X}}e.delta=E;function g(O,D,T){if(T===0)return[];const _=O.slice(0,T).sort(D);return t(O,D,_,T,O.length),_}e.top=g;function S(O,D,T,_,z){return T===0?Promise.resolve([]):new Promise((X,B)=>{(async()=>{const q=O.length,ne=O.slice(0,T).sort(D);for(let se=T,oe=Math.min(T+_,q);se<q;se=oe,oe=Math.min(oe+_,q)){if(se>T&&await new Promise(Z=>setTimeout(Z)),z&&z.isCancellationRequested)throw(0,p.canceled)();t(O,D,ne,se,oe)}return ne})().then(X,B)})}e.topAsync=S;function t(O,D,T,_,z){for(const X=T.length;_<z;_++){const B=O[_];if(D(B,T[X-1])<0){T.pop();const q=I(T,ne=>D(B,ne)<0);T.splice(q,0,B)}}}function m(O){return O.filter(D=>!!D)}e.coalesce=m;function v(O){let D=0;for(let T=0;T<O.length;T++)O[T]&&(O[D]=O[T],D+=1);O.length=D}e.coalesceInPlace=v;function b(O,D,T){O.splice(T,0,O.splice(D,1)[0])}e.move=b;function P(O){return!Array.isArray(O)||O.length===0}e.isFalsyOrEmpty=P;function c(O){return Array.isArray(O)&&O.length>0}e.isNonEmptyArray=c;function a(O,D=T=>T){const T=new Set;return O.filter(_=>{const z=D(_);return T.has(z)?!1:(T.add(z),!0)})}e.distinct=a;function l(O){const D=Object.create(null);return T=>{const _=O(T);return D[_]?!1:(D[_]=!0,!0)}}e.uniqueFilter=l;function o(O,D){const T=u(O,D);if(T!==-1)return O[T]}e.findLast=o;function u(O,D){for(let T=O.length-1;T>=0;T--){const _=O[T];if(D(_))return T}return-1}e.lastIndex=u;function r(O,D){return O.length>0?O[0]:D}e.firstOrDefault=r;function i(O,D,T=(_,z)=>_===z){let _=0;for(let z=0,X=Math.min(O.length,D.length);z<X&&T(O[z],D[z]);z++)_++;return _}e.commonPrefixLength=i;function s(O){return[].concat(...O)}e.flatten=s;function h(O,D){let T=typeof D=="number"?O:0;typeof D=="number"?T=O:(T=0,D=O);const _=[];if(T<=D)for(let z=T;z<D;z++)_.push(z);else for(let z=T;z>D;z--)_.push(z);return _}e.range=h;function w(O,D,T){return O.reduce((_,z)=>(_[D(z)]=T?T(z):z,_),Object.create(null))}e.index=w;function M(O,D){return O.push(D),()=>A(O,D)}e.insert=M;function A(O,D){const T=O.indexOf(D);if(T>-1)return O.splice(T,1),D}e.remove=A;function L(O,D,T){const _=O.slice(0,D),z=O.slice(D);return _.concat(T,z)}e.arrayInsert=L;function F(O,D){let T;if(typeof D=="number"){let _=D;T=()=>{const z=Math.sin(_++)*179426549;return z-Math.floor(z)}}else T=Math.random;for(let _=O.length-1;_>0;_-=1){const z=Math.floor(T()*(_+1)),X=O[_];O[_]=O[z],O[z]=X}}e.shuffle=F;function U(O,D){const T=O.indexOf(D);T>-1&&(O.splice(T,1),O.unshift(D))}e.pushToStart=U;function Y(O,D){const T=O.indexOf(D);T>-1&&(O.splice(T,1),O.push(D))}e.pushToEnd=Y;function ie(O,D){return Array.isArray(O)?O.map(D):D(O)}e.mapArrayOrNot=ie;function re(O){return Array.isArray(O)?O:[O]}e.asArray=re;function K(O){return O[Math.floor(Math.random()*O.length)]}e.getRandomElement=K;function W(O,D){for(const T of O){const _=D(T);if(_!==void 0)return _}}e.mapFind=W;function N(O,D,T){const _=Q(O,D),z=O.length,X=T.length;O.length=z+X;for(let B=z-1;B>=_;B--)O[B+X]=O[B];for(let B=0;B<X;B++)O[B+_]=T[B]}e.insertInto=N;function G(O,D,T,_){const z=Q(O,D),X=O.splice(z,T);return N(O,z,_),X}e.splice=G;function Q(O,D){return D<0?Math.max(D+O.length,0):Math.min(D,O.length)}function H(O,D){let T=Number.MAX_SAFE_INTEGER,_=0;return O.forEach((z,X)=>{const B=D(z);B<T&&(T=B,_=X)}),_}e.minIndex=H;function $(O,D){let T=Number.MIN_SAFE_INTEGER,_=0;return O.forEach((z,X)=>{const B=D(z);B>T&&(T=B,_=X)}),_}e.maxIndex=$;class J{constructor(D){this.items=D,this.firstIdx=0,this.lastIdx=this.items.length-1}get length(){return this.lastIdx-this.firstIdx+1}takeWhile(D){let T=this.firstIdx;for(;T<this.items.length&&D(this.items[T]);)T++;const _=T===this.firstIdx?null:this.items.slice(this.firstIdx,T);return this.firstIdx=T,_}takeFromEndWhile(D){let T=this.lastIdx;for(;T>=0&&D(this.items[T]);)T--;const _=T===this.lastIdx?null:this.items.slice(T+1,this.lastIdx+1);return this.lastIdx=T,_}peek(){return this.items[this.firstIdx]}dequeue(){const D=this.items[this.firstIdx];return this.firstIdx++,D}takeCount(D){const T=this.items.slice(this.firstIdx,this.firstIdx+D);return this.firstIdx+=D,T}}e.ArrayQueue=J}),define(x[42],ee([0,1]),function(V,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.once=void 0;function p(R){const C=this;let k=!1,n;return function(){return k||(k=!0,n=R.apply(C,arguments)),n}}e.once=p}),define(x[69],ee([0,1]),function(V,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Iterable=void 0;var p;(function(R){function C(l){return l&&typeof l=="object"&&typeof l[Symbol.iterator]=="function"}R.is=C;const k=Object.freeze([]);function n(){return k}R.empty=n;function*I(l){yield l}R.single=I;function d(l){return l||k}R.from=d;function f(l){return!l||l[Symbol.iterator]().next().done===!0}R.isEmpty=f;function y(l){return l[Symbol.iterator]().next().value}R.first=y;function E(l,o){for(const u of l)if(o(u))return!0;return!1}R.some=E;function g(l,o){for(const u of l)if(o(u))return u}R.find=g;function*S(l,o){for(const u of l)o(u)&&(yield u)}R.filter=S;function*t(l,o){let u=0;for(const r of l)yield o(r,u++)}R.map=t;function*m(...l){for(const o of l)for(const u of o)yield u}R.concat=m;function*v(l){for(const o of l)for(const u of o)yield u}R.concatNested=v;function b(l,o,u){let r=u;for(const i of l)r=o(r,i);return r}R.reduce=b;function*P(l,o,u=l.length){for(o<0&&(o+=l.length),u<0?u+=l.length:u>l.length&&(u=l.length);o<u;o++)yield l[o]}R.slice=P;function c(l,o=Number.POSITIVE_INFINITY){const u=[];if(o===0)return[u,l];const r=l[Symbol.iterator]();for(let i=0;i<o;i++){const s=r.next();if(s.done)return[u,R.empty()];u.push(s.value)}return[u,{[Symbol.iterator](){return r}}]}R.consume=c;function a(l,o,u=(r,i)=>r===i){const r=l[Symbol.iterator](),i=o[Symbol.iterator]();for(;;){const s=r.next(),h=i.next();if(s.done!==h.done)return!1;if(s.done)return!0;if(!u(s.value,h.value))return!1}}R.equals=a})(p=e.Iterable||(e.Iterable={}))}),define(x[38],ee([0,1]),function(V,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getNodeType=e.stripComments=e.visit=e.findNodeAtOffset=e.contains=e.getNodeValue=e.getNodePath=e.findNodeAtLocation=e.parseTree=e.parse=e.getLocation=e.createScanner=e.ParseOptions=e.ParseErrorCode=e.SyntaxKind=e.ScanError=void 0;var p;(function(o){o[o.None=0]="None",o[o.UnexpectedEndOfComment=1]="UnexpectedEndOfComment",o[o.UnexpectedEndOfString=2]="UnexpectedEndOfString",o[o.UnexpectedEndOfNumber=3]="UnexpectedEndOfNumber",o[o.InvalidUnicode=4]="InvalidUnicode",o[o.InvalidEscapeCharacter=5]="InvalidEscapeCharacter",o[o.InvalidCharacter=6]="InvalidCharacter"})(p=e.ScanError||(e.ScanError={}));var R;(function(o){o[o.OpenBraceToken=1]="OpenBraceToken",o[o.CloseBraceToken=2]="CloseBraceToken",o[o.OpenBracketToken=3]="OpenBracketToken",o[o.CloseBracketToken=4]="CloseBracketToken",o[o.CommaToken=5]="CommaToken",o[o.ColonToken=6]="ColonToken",o[o.NullKeyword=7]="NullKeyword",o[o.TrueKeyword=8]="TrueKeyword",o[o.FalseKeyword=9]="FalseKeyword",o[o.StringLiteral=10]="StringLiteral",o[o.NumericLiteral=11]="NumericLiteral",o[o.LineCommentTrivia=12]="LineCommentTrivia",o[o.BlockCommentTrivia=13]="BlockCommentTrivia",o[o.LineBreakTrivia=14]="LineBreakTrivia",o[o.Trivia=15]="Trivia",o[o.Unknown=16]="Unknown",o[o.EOF=17]="EOF"})(R=e.SyntaxKind||(e.SyntaxKind={}));var C;(function(o){o[o.InvalidSymbol=1]="InvalidSymbol",o[o.InvalidNumberFormat=2]="InvalidNumberFormat",o[o.PropertyNameExpected=3]="PropertyNameExpected",o[o.ValueExpected=4]="ValueExpected",o[o.ColonExpected=5]="ColonExpected",o[o.CommaExpected=6]="CommaExpected",o[o.CloseBraceExpected=7]="CloseBraceExpected",o[o.CloseBracketExpected=8]="CloseBracketExpected",o[o.EndOfFileExpected=9]="EndOfFileExpected",o[o.InvalidCommentToken=10]="InvalidCommentToken",o[o.UnexpectedEndOfComment=11]="UnexpectedEndOfComment",o[o.UnexpectedEndOfString=12]="UnexpectedEndOfString",o[o.UnexpectedEndOfNumber=13]="UnexpectedEndOfNumber",o[o.InvalidUnicode=14]="InvalidUnicode",o[o.InvalidEscapeCharacter=15]="InvalidEscapeCharacter",o[o.InvalidCharacter=16]="InvalidCharacter"})(C=e.ParseErrorCode||(e.ParseErrorCode={}));var k;(function(o){o.DEFAULT={allowTrailingComma:!0}})(k=e.ParseOptions||(e.ParseOptions={}));function n(o,u=!1){let r=0,i=o.length,s="",h=0,w=16,M=0;function A(K){let W=0,N=0;for(;W<K;){const G=o.charCodeAt(r);if(G>=48&&G<=57)N=N*16+G-48;else if(G>=65&&G<=70)N=N*16+G-65+10;else if(G>=97&&G<=102)N=N*16+G-97+10;else break;r++,W++}return W<K&&(N=-1),N}function L(K){r=K,s="",h=0,w=16,M=0}function F(){const K=r;if(o.charCodeAt(r)===48)r++;else for(r++;r<o.length&&f(o.charCodeAt(r));)r++;if(r<o.length&&o.charCodeAt(r)===46)if(r++,r<o.length&&f(o.charCodeAt(r)))for(r++;r<o.length&&f(o.charCodeAt(r));)r++;else return M=3,o.substring(K,r);let W=r;if(r<o.length&&(o.charCodeAt(r)===69||o.charCodeAt(r)===101))if(r++,(r<o.length&&o.charCodeAt(r)===43||o.charCodeAt(r)===45)&&r++,r<o.length&&f(o.charCodeAt(r))){for(r++;r<o.length&&f(o.charCodeAt(r));)r++;W=r}else M=3;return o.substring(K,W)}function U(){let K="",W=r;for(;;){if(r>=i){K+=o.substring(W,r),M=2;break}const N=o.charCodeAt(r);if(N===34){K+=o.substring(W,r),r++;break}if(N===92){if(K+=o.substring(W,r),r++,r>=i){M=2;break}switch(o.charCodeAt(r++)){case 34:K+='"';break;case 92:K+="\\";break;case 47:K+="/";break;case 98:K+="\b";break;case 102:K+="\f";break;case 110:K+=`
`;break;case 114:K+="\r";break;case 116:K+="	";break;case 117:const Q=A(4);Q>=0?K+=String.fromCharCode(Q):M=4;break;default:M=5}W=r;continue}if(N>=0&&N<=31)if(d(N)){K+=o.substring(W,r),M=2;break}else M=6;r++}return K}function Y(){if(s="",M=0,h=r,r>=i)return h=i,w=17;let K=o.charCodeAt(r);if(I(K)){do r++,s+=String.fromCharCode(K),K=o.charCodeAt(r);while(I(K));return w=15}if(d(K))return r++,s+=String.fromCharCode(K),K===13&&o.charCodeAt(r)===10&&(r++,s+=`
`),w=14;switch(K){case 123:return r++,w=1;case 125:return r++,w=2;case 91:return r++,w=3;case 93:return r++,w=4;case 58:return r++,w=6;case 44:return r++,w=5;case 34:return r++,s=U(),w=10;case 47:const W=r-1;if(o.charCodeAt(r+1)===47){for(r+=2;r<i&&!d(o.charCodeAt(r));)r++;return s=o.substring(W,r),w=12}if(o.charCodeAt(r+1)===42){r+=2;const N=i-1;let G=!1;for(;r<N;){if(o.charCodeAt(r)===42&&o.charCodeAt(r+1)===47){r+=2,G=!0;break}r++}return G||(r++,M=1),s=o.substring(W,r),w=13}return s+=String.fromCharCode(K),r++,w=16;case 45:if(s+=String.fromCharCode(K),r++,r===i||!f(o.charCodeAt(r)))return w=16;case 48:case 49:case 50:case 51:case 52:case 53:case 54:case 55:case 56:case 57:return s+=F(),w=11;default:for(;r<i&&ie(K);)r++,K=o.charCodeAt(r);if(h!==r){switch(s=o.substring(h,r),s){case"true":return w=8;case"false":return w=9;case"null":return w=7}return w=16}return s+=String.fromCharCode(K),r++,w=16}}function ie(K){if(I(K)||d(K))return!1;switch(K){case 125:case 93:case 123:case 91:case 34:case 58:case 44:case 47:return!1}return!0}function re(){let K;do K=Y();while(K>=12&&K<=15);return K}return{setPosition:L,getPosition:()=>r,scan:u?re:Y,getToken:()=>w,getTokenValue:()=>s,getTokenOffset:()=>h,getTokenLength:()=>r-h,getTokenError:()=>M}}e.createScanner=n;function I(o){return o===32||o===9||o===11||o===12||o===160||o===5760||o>=8192&&o<=8203||o===8239||o===8287||o===12288||o===65279}function d(o){return o===10||o===13||o===8232||o===8233}function f(o){return o>=48&&o<=57}var y;(function(o){o[o.nullCharacter=0]="nullCharacter",o[o.maxAsciiCharacter=127]="maxAsciiCharacter",o[o.lineFeed=10]="lineFeed",o[o.carriageReturn=13]="carriageReturn",o[o.lineSeparator=8232]="lineSeparator",o[o.paragraphSeparator=8233]="paragraphSeparator",o[o.nextLine=133]="nextLine",o[o.space=32]="space",o[o.nonBreakingSpace=160]="nonBreakingSpace",o[o.enQuad=8192]="enQuad",o[o.emQuad=8193]="emQuad",o[o.enSpace=8194]="enSpace",o[o.emSpace=8195]="emSpace",o[o.threePerEmSpace=8196]="threePerEmSpace",o[o.fourPerEmSpace=8197]="fourPerEmSpace",o[o.sixPerEmSpace=8198]="sixPerEmSpace",o[o.figureSpace=8199]="figureSpace",o[o.punctuationSpace=8200]="punctuationSpace",o[o.thinSpace=8201]="thinSpace",o[o.hairSpace=8202]="hairSpace",o[o.zeroWidthSpace=8203]="zeroWidthSpace",o[o.narrowNoBreakSpace=8239]="narrowNoBreakSpace",o[o.ideographicSpace=12288]="ideographicSpace",o[o.mathematicalSpace=8287]="mathematicalSpace",o[o.ogham=5760]="ogham",o[o._=95]="_",o[o.$=36]="$",o[o._0=48]="_0",o[o._1=49]="_1",o[o._2=50]="_2",o[o._3=51]="_3",o[o._4=52]="_4",o[o._5=53]="_5",o[o._6=54]="_6",o[o._7=55]="_7",o[o._8=56]="_8",o[o._9=57]="_9",o[o.a=97]="a",o[o.b=98]="b",o[o.c=99]="c",o[o.d=100]="d",o[o.e=101]="e",o[o.f=102]="f",o[o.g=103]="g",o[o.h=104]="h",o[o.i=105]="i",o[o.j=106]="j",o[o.k=107]="k",o[o.l=108]="l",o[o.m=109]="m",o[o.n=110]="n",o[o.o=111]="o",o[o.p=112]="p",o[o.q=113]="q",o[o.r=114]="r",o[o.s=115]="s",o[o.t=116]="t",o[o.u=117]="u",o[o.v=118]="v",o[o.w=119]="w",o[o.x=120]="x",o[o.y=121]="y",o[o.z=122]="z",o[o.A=65]="A",o[o.B=66]="B",o[o.C=67]="C",o[o.D=68]="D",o[o.E=69]="E",o[o.F=70]="F",o[o.G=71]="G",o[o.H=72]="H",o[o.I=73]="I",o[o.J=74]="J",o[o.K=75]="K",o[o.L=76]="L",o[o.M=77]="M",o[o.N=78]="N",o[o.O=79]="O",o[o.P=80]="P",o[o.Q=81]="Q",o[o.R=82]="R",o[o.S=83]="S",o[o.T=84]="T",o[o.U=85]="U",o[o.V=86]="V",o[o.W=87]="W",o[o.X=88]="X",o[o.Y=89]="Y",o[o.Z=90]="Z",o[o.ampersand=38]="ampersand",o[o.asterisk=42]="asterisk",o[o.at=64]="at",o[o.backslash=92]="backslash",o[o.bar=124]="bar",o[o.caret=94]="caret",o[o.closeBrace=125]="closeBrace",o[o.closeBracket=93]="closeBracket",o[o.closeParen=41]="closeParen",o[o.colon=58]="colon",o[o.comma=44]="comma",o[o.dot=46]="dot",o[o.doubleQuote=34]="doubleQuote",o[o.equals=61]="equals",o[o.exclamation=33]="exclamation",o[o.greaterThan=62]="greaterThan",o[o.lessThan=60]="lessThan",o[o.minus=45]="minus",o[o.openBrace=123]="openBrace",o[o.openBracket=91]="openBracket",o[o.openParen=40]="openParen",o[o.percent=37]="percent",o[o.plus=43]="plus",o[o.question=63]="question",o[o.semicolon=59]="semicolon",o[o.singleQuote=39]="singleQuote",o[o.slash=47]="slash",o[o.tilde=126]="tilde",o[o.backspace=8]="backspace",o[o.formFeed=12]="formFeed",o[o.byteOrderMark=65279]="byteOrderMark",o[o.tab=9]="tab",o[o.verticalTab=11]="verticalTab"})(y||(y={}));function E(o,u){const r=[],i=new Object;let s;const h={value:{},offset:0,length:0,type:"object",parent:void 0};let w=!1;function M(A,L,F,U){h.value=A,h.offset=L,h.length=F,h.type=U,h.colonOffset=void 0,s=h}try{c(o,{onObjectBegin:(A,L)=>{if(u<=A)throw i;s=void 0,w=u>A,r.push("")},onObjectProperty:(A,L,F)=>{if(u<L||(M(A,L,F,"property"),r[r.length-1]=A,u<=L+F))throw i},onObjectEnd:(A,L)=>{if(u<=A)throw i;s=void 0,r.pop()},onArrayBegin:(A,L)=>{if(u<=A)throw i;s=void 0,r.push(0)},onArrayEnd:(A,L)=>{if(u<=A)throw i;s=void 0,r.pop()},onLiteralValue:(A,L,F)=>{if(u<L||(M(A,L,F,l(A)),u<=L+F))throw i},onSeparator:(A,L,F)=>{if(u<=L)throw i;if(A===":"&&s&&s.type==="property")s.colonOffset=L,w=!1,s=void 0;else if(A===","){const U=r[r.length-1];typeof U=="number"?r[r.length-1]=U+1:(w=!0,r[r.length-1]=""),s=void 0}}})}catch(A){if(A!==i)throw A}return{path:r,previousNode:s,isAtPropertyKey:w,matches:A=>{let L=0;for(let F=0;L<A.length&&F<r.length;F++)if(A[L]===r[F]||A[L]==="*")L++;else if(A[L]!=="**")return!1;return L===A.length}}}e.getLocation=E;function g(o,u=[],r=k.DEFAULT){let i=null,s=[];const h=[];function w(A){Array.isArray(s)?s.push(A):i!==null&&(s[i]=A)}return c(o,{onObjectBegin:()=>{const A={};w(A),h.push(s),s=A,i=null},onObjectProperty:A=>{i=A},onObjectEnd:()=>{s=h.pop()},onArrayBegin:()=>{const A=[];w(A),h.push(s),s=A,i=null},onArrayEnd:()=>{s=h.pop()},onLiteralValue:w,onError:(A,L,F)=>{u.push({error:A,offset:L,length:F})}},r),s[0]}e.parse=g;function S(o,u=[],r=k.DEFAULT){let i={type:"array",offset:-1,length:-1,children:[],parent:void 0};function s(A){i.type==="property"&&(i.length=A-i.offset,i=i.parent)}function h(A){return i.children.push(A),A}c(o,{onObjectBegin:A=>{i=h({type:"object",offset:A,length:-1,parent:i,children:[]})},onObjectProperty:(A,L,F)=>{i=h({type:"property",offset:L,length:-1,parent:i,children:[]}),i.children.push({type:"string",value:A,offset:L,length:F,parent:i})},onObjectEnd:(A,L)=>{i.length=A+L-i.offset,i=i.parent,s(A+L)},onArrayBegin:(A,L)=>{i=h({type:"array",offset:A,length:-1,parent:i,children:[]})},onArrayEnd:(A,L)=>{i.length=A+L-i.offset,i=i.parent,s(A+L)},onLiteralValue:(A,L,F)=>{h({type:l(A),offset:L,length:F,parent:i,value:A}),s(L+F)},onSeparator:(A,L,F)=>{i.type==="property"&&(A===":"?i.colonOffset=L:A===","&&s(L))},onError:(A,L,F)=>{u.push({error:A,offset:L,length:F})}},r);const M=i.children[0];return M&&delete M.parent,M}e.parseTree=S;function t(o,u){if(!o)return;let r=o;for(let i of u)if(typeof i=="string"){if(r.type!=="object"||!Array.isArray(r.children))return;let s=!1;for(const h of r.children)if(Array.isArray(h.children)&&h.children[0].value===i){r=h.children[1],s=!0;break}if(!s)return}else{const s=i;if(r.type!=="array"||s<0||!Array.isArray(r.children)||s>=r.children.length)return;r=r.children[s]}return r}e.findNodeAtLocation=t;function m(o){if(!o.parent||!o.parent.children)return[];const u=m(o.parent);if(o.parent.type==="property"){const r=o.parent.children[0].value;u.push(r)}else if(o.parent.type==="array"){const r=o.parent.children.indexOf(o);r!==-1&&u.push(r)}return u}e.getNodePath=m;function v(o){switch(o.type){case"array":return o.children.map(v);case"object":const u=Object.create(null);for(let r of o.children){const i=r.children[1];i&&(u[r.children[0].value]=v(i))}return u;case"null":case"string":case"number":case"boolean":return o.value;default:return}}e.getNodeValue=v;function b(o,u,r=!1){return u>=o.offset&&u<o.offset+o.length||r&&u===o.offset+o.length}e.contains=b;function P(o,u,r=!1){if(b(o,u,r)){const i=o.children;if(Array.isArray(i))for(let s=0;s<i.length&&i[s].offset<=u;s++){const h=P(i[s],u,r);if(h)return h}return o}}e.findNodeAtOffset=P;function c(o,u,r=k.DEFAULT){const i=n(o,!1);function s(T){return T?()=>T(i.getTokenOffset(),i.getTokenLength()):()=>!0}function h(T){return T?_=>T(_,i.getTokenOffset(),i.getTokenLength()):()=>!0}const w=s(u.onObjectBegin),M=h(u.onObjectProperty),A=s(u.onObjectEnd),L=s(u.onArrayBegin),F=s(u.onArrayEnd),U=h(u.onLiteralValue),Y=h(u.onSeparator),ie=s(u.onComment),re=h(u.onError),K=r&&r.disallowComments,W=r&&r.allowTrailingComma;function N(){for(;;){const T=i.scan();switch(i.getTokenError()){case 4:G(14);break;case 5:G(15);break;case 3:G(13);break;case 1:K||G(11);break;case 2:G(12);break;case 6:G(16);break}switch(T){case 12:case 13:K?G(10):ie();break;case 16:G(1);break;case 15:case 14:break;default:return T}}}function G(T,_=[],z=[]){if(re(T),_.length+z.length>0){let X=i.getToken();for(;X!==17;){if(_.indexOf(X)!==-1){N();break}else if(z.indexOf(X)!==-1)break;X=N()}}}function Q(T){const _=i.getTokenValue();return T?U(_):M(_),N(),!0}function H(){switch(i.getToken()){case 11:let T=0;try{T=JSON.parse(i.getTokenValue()),typeof T!="number"&&(G(2),T=0)}catch(_){G(2)}U(T);break;case 7:U(null);break;case 8:U(!0);break;case 9:U(!1);break;default:return!1}return N(),!0}function $(){return i.getToken()!==10?(G(3,[],[2,5]),!1):(Q(!1),i.getToken()===6?(Y(":"),N(),D()||G(4,[],[2,5])):G(5,[],[2,5]),!0)}function J(){w(),N();let T=!1;for(;i.getToken()!==2&&i.getToken()!==17;){if(i.getToken()===5){if(T||G(4,[],[]),Y(","),N(),i.getToken()===2&&W)break}else T&&G(6,[],[]);$()||G(4,[],[2,5]),T=!0}return A(),i.getToken()!==2?G(7,[2],[]):N(),!0}function O(){L(),N();let T=!1;for(;i.getToken()!==4&&i.getToken()!==17;){if(i.getToken()===5){if(T||G(4,[],[]),Y(","),N(),i.getToken()===4&&W)break}else T&&G(6,[],[]);D()||G(4,[],[4,5]),T=!0}return F(),i.getToken()!==4?G(8,[4],[]):N(),!0}function D(){switch(i.getToken()){case 3:return O();case 1:return J();case 10:return Q(!0);default:return H()}}return N(),i.getToken()===17?r.allowEmptyContent?!0:(G(4,[],[]),!1):D()?(i.getToken()!==17&&G(9,[],[]),!0):(G(4,[],[]),!1)}e.visit=c;function a(o,u){let r=n(o),i=[],s,h=0,w;do switch(w=r.getPosition(),s=r.scan(),s){case 12:case 13:case 17:h!==w&&i.push(o.substring(h,w)),u!==void 0&&i.push(r.getTokenValue().replace(/[^\r\n]/g,u)),h=r.getPosition();break}while(s!==17);return i.join("")}e.stripComments=a;function l(o){switch(typeof o){case"boolean":return"boolean";case"number":return"number";case"string":return"string";case"object":{if(o){if(Array.isArray(o))return"array"}else return"null";return"object"}default:return"null"}}e.getNodeType=l}),define(x[105],ee([0,1,38]),function(V,e,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isEOL=e.getEOL=e.format=void 0;function R(d,f,y){let E,g,S,t,m;if(f){for(t=f.offset,m=t+f.length,S=t;S>0&&!I(d,S-1);)S--;let h=m;for(;h<d.length&&!I(d,h);)h++;g=d.substring(S,h),E=k(g,y)}else g=d,E=0,S=0,t=0,m=d.length;const v=n(y,d);let b=!1,P=0,c;y.insertSpaces?c=C(" ",y.tabSize||4):c="	";const a=(0,p.createScanner)(g,!1);let l=!1;function o(){return v+C(c,E+P)}function u(){let h=a.scan();for(b=!1;h===15||h===14;)b=b||h===14,h=a.scan();return l=h===16||a.getTokenError()!==0,h}const r=[];function i(h,w,M){!l&&w<m&&M>t&&d.substring(w,M)!==h&&r.push({offset:w,length:M-w,content:h})}let s=u();if(s!==17){const h=a.getTokenOffset()+S,w=C(c,E);i(w,S,h)}for(;s!==17;){let h=a.getTokenOffset()+a.getTokenLength()+S,w=u(),M="";for(;!b&&(w===12||w===13);){const L=a.getTokenOffset()+S;i(" ",h,L),h=a.getTokenOffset()+a.getTokenLength()+S,M=w===12?o():"",w=u()}if(w===2)s!==1&&(P--,M=o());else if(w===4)s!==3&&(P--,M=o());else{switch(s){case 3:case 1:P++,M=o();break;case 5:case 12:M=o();break;case 13:b?M=o():M=" ";break;case 6:M=" ";break;case 10:if(w===6){M="";break}case 7:case 8:case 9:case 11:case 2:case 4:w===12||w===13?M=" ":w!==5&&w!==17&&(l=!0);break;case 16:l=!0;break}b&&(w===12||w===13)&&(M=o())}const A=a.getTokenOffset()+S;i(M,h,A),s=w}return r}e.format=R;function C(d,f){let y="";for(let E=0;E<f;E++)y+=d;return y}function k(d,f){let y=0,E=0;const g=f.tabSize||4;for(;y<d.length;){const S=d.charAt(y);if(S===" ")E++;else if(S==="	")E+=g;else break;y++}return Math.floor(E/g)}function n(d,f){for(let y=0;y<f.length;y++){const E=f.charAt(y);if(E==="\r")return y+1<f.length&&f.charAt(y+1)===`
`?`\r
`:"\r";if(E===`
`)return`
`}return d&&d.eol||`
`}e.getEOL=n;function I(d,f){return`\r
`.indexOf(d.charAt(f))!==-1}e.isEOL=I}),define(x[78],ee([0,1,38,105]),function(V,e,p,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.applyEdits=e.applyEdit=e.withFormatting=e.setProperty=e.removeProperty=void 0;function C(f,y,E){return k(f,y,void 0,E)}e.removeProperty=C;function k(f,y,E,g,S){const t=y.slice(),m=[],v=(0,p.parseTree)(f,m);let b,P;for(;t.length>0&&(P=t.pop(),b=(0,p.findNodeAtLocation)(v,t),b===void 0&&E!==void 0);)typeof P=="string"?E={[P]:E}:E=[E];if(b)if(b.type==="object"&&typeof P=="string"&&Array.isArray(b.children)){const c=(0,p.findNodeAtLocation)(b,[P]);if(c!==void 0)if(E===void 0){if(!c.parent)throw new Error("Malformed AST");const a=b.children.indexOf(c.parent);let l,o=c.parent.offset+c.parent.length;if(a>0){const u=b.children[a-1];l=u.offset+u.length}else l=b.offset+1,b.children.length>1&&(o=b.children[1].offset);return n(f,{offset:l,length:o-l,content:""},g)}else return n(f,{offset:c.offset,length:c.length,content:JSON.stringify(E)},g);else{if(E===void 0)return[];const a=`${JSON.stringify(P)}: ${JSON.stringify(E)}`,l=S?S(b.children.map(u=>u.children[0].value)):b.children.length;let o;if(l>0){const u=b.children[l-1];o={offset:u.offset+u.length,length:0,content:","+a}}else b.children.length===0?o={offset:b.offset+1,length:0,content:a}:o={offset:b.offset+1,length:0,content:a+","};return n(f,o,g)}}else if(b.type==="array"&&typeof P=="number"&&Array.isArray(b.children))if(E!==void 0){const c=`${JSON.stringify(E)}`;let a;if(b.children.length===0||P===0)a={offset:b.offset+1,length:0,content:b.children.length===0?c:c+","};else{const l=P===-1||P>b.children.length?b.children.length:P,o=b.children[l-1];a={offset:o.offset+o.length,length:0,content:","+c}}return n(f,a,g)}else{const c=P,a=b.children[c];let l;if(b.children.length===1)l={offset:b.offset+1,length:b.length-2,content:""};else if(b.children.length-1===c){const o=b.children[c-1],u=o.offset+o.length,r=b.offset+b.length;l={offset:u,length:r-2-u,content:""}}else l={offset:a.offset,length:b.children[c+1].offset-a.offset,content:""};return n(f,l,g)}else throw new Error(`Can not add ${typeof P!="number"?"index":"property"} to parent of type ${b.type}`);else{if(E===void 0)throw new Error("Can not delete in empty document");return n(f,{offset:v?v.offset:0,length:v?v.length:0,content:JSON.stringify(E)},g)}}e.setProperty=k;function n(f,y,E){let g=I(f,y),S=y.offset,t=y.offset+y.content.length;if(y.length===0||y.content.length===0){for(;S>0&&!(0,R.isEOL)(g,S-1);)S--;for(;t<g.length&&!(0,R.isEOL)(g,t);)t++}const m=(0,R.format)(g,{offset:S,length:t-S},E);for(let b=m.length-1;b>=0;b--){const P=m[b];g=I(g,P),S=Math.min(S,P.offset),t=Math.max(t,P.offset+P.length),t+=P.content.length-P.length}const v=f.length-(g.length-t)-S;return[{offset:S,length:v,content:g.substring(S,t)}]}e.withFormatting=n;function I(f,y){return f.substring(0,y.offset)+y.content+f.substring(y.offset+y.length)}e.applyEdit=I;function d(f,y){let E=y.slice(0).sort((S,t)=>{const m=S.offset-t.offset;return m===0?S.length-t.length:m}),g=f.length;for(let S=E.length-1;S>=0;S--){let t=E[S];if(t.offset+t.length<=g)f=I(f,t);else throw new Error("Overlapping edit");g=t.offset}return f}e.applyEdits=d}),define(x[79],ee([0,1]),function(V,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.KeyChord=e.KeyMod=e.KeyCodeUtils=e.IMMUTABLE_KEY_CODE_TO_CODE=e.IMMUTABLE_CODE_TO_KEY_CODE=e.ScanCodeUtils=e.NATIVE_WINDOWS_KEY_CODE_TO_KEY_CODE=e.EVENT_KEY_CODE_MAP=e.ScanCode=e.KeyCode=void 0;var p;(function(t){t[t.DependsOnKbLayout=-1]="DependsOnKbLayout",t[t.Unknown=0]="Unknown",t[t.Backspace=1]="Backspace",t[t.Tab=2]="Tab",t[t.Enter=3]="Enter",t[t.Shift=4]="Shift",t[t.Ctrl=5]="Ctrl",t[t.Alt=6]="Alt",t[t.PauseBreak=7]="PauseBreak",t[t.CapsLock=8]="CapsLock",t[t.Escape=9]="Escape",t[t.Space=10]="Space",t[t.PageUp=11]="PageUp",t[t.PageDown=12]="PageDown",t[t.End=13]="End",t[t.Home=14]="Home",t[t.LeftArrow=15]="LeftArrow",t[t.UpArrow=16]="UpArrow",t[t.RightArrow=17]="RightArrow",t[t.DownArrow=18]="DownArrow",t[t.Insert=19]="Insert",t[t.Delete=20]="Delete",t[t.Digit0=21]="Digit0",t[t.Digit1=22]="Digit1",t[t.Digit2=23]="Digit2",t[t.Digit3=24]="Digit3",t[t.Digit4=25]="Digit4",t[t.Digit5=26]="Digit5",t[t.Digit6=27]="Digit6",t[t.Digit7=28]="Digit7",t[t.Digit8=29]="Digit8",t[t.Digit9=30]="Digit9",t[t.KeyA=31]="KeyA",t[t.KeyB=32]="KeyB",t[t.KeyC=33]="KeyC",t[t.KeyD=34]="KeyD",t[t.KeyE=35]="KeyE",t[t.KeyF=36]="KeyF",t[t.KeyG=37]="KeyG",t[t.KeyH=38]="KeyH",t[t.KeyI=39]="KeyI",t[t.KeyJ=40]="KeyJ",t[t.KeyK=41]="KeyK",t[t.KeyL=42]="KeyL",t[t.KeyM=43]="KeyM",t[t.KeyN=44]="KeyN",t[t.KeyO=45]="KeyO",t[t.KeyP=46]="KeyP",t[t.KeyQ=47]="KeyQ",t[t.KeyR=48]="KeyR",t[t.KeyS=49]="KeyS",t[t.KeyT=50]="KeyT",t[t.KeyU=51]="KeyU",t[t.KeyV=52]="KeyV",t[t.KeyW=53]="KeyW",t[t.KeyX=54]="KeyX",t[t.KeyY=55]="KeyY",t[t.KeyZ=56]="KeyZ",t[t.Meta=57]="Meta",t[t.ContextMenu=58]="ContextMenu",t[t.F1=59]="F1",t[t.F2=60]="F2",t[t.F3=61]="F3",t[t.F4=62]="F4",t[t.F5=63]="F5",t[t.F6=64]="F6",t[t.F7=65]="F7",t[t.F8=66]="F8",t[t.F9=67]="F9",t[t.F10=68]="F10",t[t.F11=69]="F11",t[t.F12=70]="F12",t[t.F13=71]="F13",t[t.F14=72]="F14",t[t.F15=73]="F15",t[t.F16=74]="F16",t[t.F17=75]="F17",t[t.F18=76]="F18",t[t.F19=77]="F19",t[t.NumLock=78]="NumLock",t[t.ScrollLock=79]="ScrollLock",t[t.Semicolon=80]="Semicolon",t[t.Equal=81]="Equal",t[t.Comma=82]="Comma",t[t.Minus=83]="Minus",t[t.Period=84]="Period",t[t.Slash=85]="Slash",t[t.Backquote=86]="Backquote",t[t.BracketLeft=87]="BracketLeft",t[t.Backslash=88]="Backslash",t[t.BracketRight=89]="BracketRight",t[t.Quote=90]="Quote",t[t.OEM_8=91]="OEM_8",t[t.IntlBackslash=92]="IntlBackslash",t[t.Numpad0=93]="Numpad0",t[t.Numpad1=94]="Numpad1",t[t.Numpad2=95]="Numpad2",t[t.Numpad3=96]="Numpad3",t[t.Numpad4=97]="Numpad4",t[t.Numpad5=98]="Numpad5",t[t.Numpad6=99]="Numpad6",t[t.Numpad7=100]="Numpad7",t[t.Numpad8=101]="Numpad8",t[t.Numpad9=102]="Numpad9",t[t.NumpadMultiply=103]="NumpadMultiply",t[t.NumpadAdd=104]="NumpadAdd",t[t.NUMPAD_SEPARATOR=105]="NUMPAD_SEPARATOR",t[t.NumpadSubtract=106]="NumpadSubtract",t[t.NumpadDecimal=107]="NumpadDecimal",t[t.NumpadDivide=108]="NumpadDivide",t[t.KEY_IN_COMPOSITION=109]="KEY_IN_COMPOSITION",t[t.ABNT_C1=110]="ABNT_C1",t[t.ABNT_C2=111]="ABNT_C2",t[t.AudioVolumeMute=112]="AudioVolumeMute",t[t.AudioVolumeUp=113]="AudioVolumeUp",t[t.AudioVolumeDown=114]="AudioVolumeDown",t[t.BrowserSearch=115]="BrowserSearch",t[t.BrowserHome=116]="BrowserHome",t[t.BrowserBack=117]="BrowserBack",t[t.BrowserForward=118]="BrowserForward",t[t.MediaTrackNext=119]="MediaTrackNext",t[t.MediaTrackPrevious=120]="MediaTrackPrevious",t[t.MediaStop=121]="MediaStop",t[t.MediaPlayPause=122]="MediaPlayPause",t[t.LaunchMediaPlayer=123]="LaunchMediaPlayer",t[t.LaunchMail=124]="LaunchMail",t[t.LaunchApp2=125]="LaunchApp2",t[t.MAX_VALUE=126]="MAX_VALUE"})(p=e.KeyCode||(e.KeyCode={}));var R;(function(t){t[t.DependsOnKbLayout=-1]="DependsOnKbLayout",t[t.None=0]="None",t[t.Hyper=1]="Hyper",t[t.Super=2]="Super",t[t.Fn=3]="Fn",t[t.FnLock=4]="FnLock",t[t.Suspend=5]="Suspend",t[t.Resume=6]="Resume",t[t.Turbo=7]="Turbo",t[t.Sleep=8]="Sleep",t[t.WakeUp=9]="WakeUp",t[t.KeyA=10]="KeyA",t[t.KeyB=11]="KeyB",t[t.KeyC=12]="KeyC",t[t.KeyD=13]="KeyD",t[t.KeyE=14]="KeyE",t[t.KeyF=15]="KeyF",t[t.KeyG=16]="KeyG",t[t.KeyH=17]="KeyH",t[t.KeyI=18]="KeyI",t[t.KeyJ=19]="KeyJ",t[t.KeyK=20]="KeyK",t[t.KeyL=21]="KeyL",t[t.KeyM=22]="KeyM",t[t.KeyN=23]="KeyN",t[t.KeyO=24]="KeyO",t[t.KeyP=25]="KeyP",t[t.KeyQ=26]="KeyQ",t[t.KeyR=27]="KeyR",t[t.KeyS=28]="KeyS",t[t.KeyT=29]="KeyT",t[t.KeyU=30]="KeyU",t[t.KeyV=31]="KeyV",t[t.KeyW=32]="KeyW",t[t.KeyX=33]="KeyX",t[t.KeyY=34]="KeyY",t[t.KeyZ=35]="KeyZ",t[t.Digit1=36]="Digit1",t[t.Digit2=37]="Digit2",t[t.Digit3=38]="Digit3",t[t.Digit4=39]="Digit4",t[t.Digit5=40]="Digit5",t[t.Digit6=41]="Digit6",t[t.Digit7=42]="Digit7",t[t.Digit8=43]="Digit8",t[t.Digit9=44]="Digit9",t[t.Digit0=45]="Digit0",t[t.Enter=46]="Enter",t[t.Escape=47]="Escape",t[t.Backspace=48]="Backspace",t[t.Tab=49]="Tab",t[t.Space=50]="Space",t[t.Minus=51]="Minus",t[t.Equal=52]="Equal",t[t.BracketLeft=53]="BracketLeft",t[t.BracketRight=54]="BracketRight",t[t.Backslash=55]="Backslash",t[t.IntlHash=56]="IntlHash",t[t.Semicolon=57]="Semicolon",t[t.Quote=58]="Quote",t[t.Backquote=59]="Backquote",t[t.Comma=60]="Comma",t[t.Period=61]="Period",t[t.Slash=62]="Slash",t[t.CapsLock=63]="CapsLock",t[t.F1=64]="F1",t[t.F2=65]="F2",t[t.F3=66]="F3",t[t.F4=67]="F4",t[t.F5=68]="F5",t[t.F6=69]="F6",t[t.F7=70]="F7",t[t.F8=71]="F8",t[t.F9=72]="F9",t[t.F10=73]="F10",t[t.F11=74]="F11",t[t.F12=75]="F12",t[t.PrintScreen=76]="PrintScreen",t[t.ScrollLock=77]="ScrollLock",t[t.Pause=78]="Pause",t[t.Insert=79]="Insert",t[t.Home=80]="Home",t[t.PageUp=81]="PageUp",t[t.Delete=82]="Delete",t[t.End=83]="End",t[t.PageDown=84]="PageDown",t[t.ArrowRight=85]="ArrowRight",t[t.ArrowLeft=86]="ArrowLeft",t[t.ArrowDown=87]="ArrowDown",t[t.ArrowUp=88]="ArrowUp",t[t.NumLock=89]="NumLock",t[t.NumpadDivide=90]="NumpadDivide",t[t.NumpadMultiply=91]="NumpadMultiply",t[t.NumpadSubtract=92]="NumpadSubtract",t[t.NumpadAdd=93]="NumpadAdd",t[t.NumpadEnter=94]="NumpadEnter",t[t.Numpad1=95]="Numpad1",t[t.Numpad2=96]="Numpad2",t[t.Numpad3=97]="Numpad3",t[t.Numpad4=98]="Numpad4",t[t.Numpad5=99]="Numpad5",t[t.Numpad6=100]="Numpad6",t[t.Numpad7=101]="Numpad7",t[t.Numpad8=102]="Numpad8",t[t.Numpad9=103]="Numpad9",t[t.Numpad0=104]="Numpad0",t[t.NumpadDecimal=105]="NumpadDecimal",t[t.IntlBackslash=106]="IntlBackslash",t[t.ContextMenu=107]="ContextMenu",t[t.Power=108]="Power",t[t.NumpadEqual=109]="NumpadEqual",t[t.F13=110]="F13",t[t.F14=111]="F14",t[t.F15=112]="F15",t[t.F16=113]="F16",t[t.F17=114]="F17",t[t.F18=115]="F18",t[t.F19=116]="F19",t[t.F20=117]="F20",t[t.F21=118]="F21",t[t.F22=119]="F22",t[t.F23=120]="F23",t[t.F24=121]="F24",t[t.Open=122]="Open",t[t.Help=123]="Help",t[t.Select=124]="Select",t[t.Again=125]="Again",t[t.Undo=126]="Undo",t[t.Cut=127]="Cut",t[t.Copy=128]="Copy",t[t.Paste=129]="Paste",t[t.Find=130]="Find",t[t.AudioVolumeMute=131]="AudioVolumeMute",t[t.AudioVolumeUp=132]="AudioVolumeUp",t[t.AudioVolumeDown=133]="AudioVolumeDown",t[t.NumpadComma=134]="NumpadComma",t[t.IntlRo=135]="IntlRo",t[t.KanaMode=136]="KanaMode",t[t.IntlYen=137]="IntlYen",t[t.Convert=138]="Convert",t[t.NonConvert=139]="NonConvert",t[t.Lang1=140]="Lang1",t[t.Lang2=141]="Lang2",t[t.Lang3=142]="Lang3",t[t.Lang4=143]="Lang4",t[t.Lang5=144]="Lang5",t[t.Abort=145]="Abort",t[t.Props=146]="Props",t[t.NumpadParenLeft=147]="NumpadParenLeft",t[t.NumpadParenRight=148]="NumpadParenRight",t[t.NumpadBackspace=149]="NumpadBackspace",t[t.NumpadMemoryStore=150]="NumpadMemoryStore",t[t.NumpadMemoryRecall=151]="NumpadMemoryRecall",t[t.NumpadMemoryClear=152]="NumpadMemoryClear",t[t.NumpadMemoryAdd=153]="NumpadMemoryAdd",t[t.NumpadMemorySubtract=154]="NumpadMemorySubtract",t[t.NumpadClear=155]="NumpadClear",t[t.NumpadClearEntry=156]="NumpadClearEntry",t[t.ControlLeft=157]="ControlLeft",t[t.ShiftLeft=158]="ShiftLeft",t[t.AltLeft=159]="AltLeft",t[t.MetaLeft=160]="MetaLeft",t[t.ControlRight=161]="ControlRight",t[t.ShiftRight=162]="ShiftRight",t[t.AltRight=163]="AltRight",t[t.MetaRight=164]="MetaRight",t[t.BrightnessUp=165]="BrightnessUp",t[t.BrightnessDown=166]="BrightnessDown",t[t.MediaPlay=167]="MediaPlay",t[t.MediaRecord=168]="MediaRecord",t[t.MediaFastForward=169]="MediaFastForward",t[t.MediaRewind=170]="MediaRewind",t[t.MediaTrackNext=171]="MediaTrackNext",t[t.MediaTrackPrevious=172]="MediaTrackPrevious",t[t.MediaStop=173]="MediaStop",t[t.Eject=174]="Eject",t[t.MediaPlayPause=175]="MediaPlayPause",t[t.MediaSelect=176]="MediaSelect",t[t.LaunchMail=177]="LaunchMail",t[t.LaunchApp2=178]="LaunchApp2",t[t.LaunchApp1=179]="LaunchApp1",t[t.SelectTask=180]="SelectTask",t[t.LaunchScreenSaver=181]="LaunchScreenSaver",t[t.BrowserSearch=182]="BrowserSearch",t[t.BrowserHome=183]="BrowserHome",t[t.BrowserBack=184]="BrowserBack",t[t.BrowserForward=185]="BrowserForward",t[t.BrowserStop=186]="BrowserStop",t[t.BrowserRefresh=187]="BrowserRefresh",t[t.BrowserFavorites=188]="BrowserFavorites",t[t.ZoomToggle=189]="ZoomToggle",t[t.MailReply=190]="MailReply",t[t.MailForward=191]="MailForward",t[t.MailSend=192]="MailSend",t[t.MAX_VALUE=193]="MAX_VALUE"})(R=e.ScanCode||(e.ScanCode={}));class C{constructor(){this._keyCodeToStr=[],this._strToKeyCode=Object.create(null)}define(m,v){this._keyCodeToStr[m]=v,this._strToKeyCode[v.toLowerCase()]=m}keyCodeToStr(m){return this._keyCodeToStr[m]}strToKeyCode(m){return this._strToKeyCode[m.toLowerCase()]||0}}const k=new C,n=new C,I=new C;e.EVENT_KEY_CODE_MAP=new Array(230),e.NATIVE_WINDOWS_KEY_CODE_TO_KEY_CODE={};const d=[],f=Object.create(null),y=Object.create(null);e.ScanCodeUtils={lowerCaseToEnum:t=>y[t]||0,toEnum:t=>f[t]||0,toString:t=>d[t]||"None"},e.IMMUTABLE_CODE_TO_KEY_CODE=[],e.IMMUTABLE_KEY_CODE_TO_CODE=[];for(let t=0;t<=193;t++)e.IMMUTABLE_CODE_TO_KEY_CODE[t]=-1;for(let t=0;t<=126;t++)e.IMMUTABLE_KEY_CODE_TO_CODE[t]=-1;(function(){const t="",m=[[0,1,0,"None",0,"unknown",0,"VK_UNKNOWN",t,t],[0,1,1,"Hyper",0,t,0,t,t,t],[0,1,2,"Super",0,t,0,t,t,t],[0,1,3,"Fn",0,t,0,t,t,t],[0,1,4,"FnLock",0,t,0,t,t,t],[0,1,5,"Suspend",0,t,0,t,t,t],[0,1,6,"Resume",0,t,0,t,t,t],[0,1,7,"Turbo",0,t,0,t,t,t],[0,1,8,"Sleep",0,t,0,"VK_SLEEP",t,t],[0,1,9,"WakeUp",0,t,0,t,t,t],[31,0,10,"KeyA",31,"A",65,"VK_A",t,t],[32,0,11,"KeyB",32,"B",66,"VK_B",t,t],[33,0,12,"KeyC",33,"C",67,"VK_C",t,t],[34,0,13,"KeyD",34,"D",68,"VK_D",t,t],[35,0,14,"KeyE",35,"E",69,"VK_E",t,t],[36,0,15,"KeyF",36,"F",70,"VK_F",t,t],[37,0,16,"KeyG",37,"G",71,"VK_G",t,t],[38,0,17,"KeyH",38,"H",72,"VK_H",t,t],[39,0,18,"KeyI",39,"I",73,"VK_I",t,t],[40,0,19,"KeyJ",40,"J",74,"VK_J",t,t],[41,0,20,"KeyK",41,"K",75,"VK_K",t,t],[42,0,21,"KeyL",42,"L",76,"VK_L",t,t],[43,0,22,"KeyM",43,"M",77,"VK_M",t,t],[44,0,23,"KeyN",44,"N",78,"VK_N",t,t],[45,0,24,"KeyO",45,"O",79,"VK_O",t,t],[46,0,25,"KeyP",46,"P",80,"VK_P",t,t],[47,0,26,"KeyQ",47,"Q",81,"VK_Q",t,t],[48,0,27,"KeyR",48,"R",82,"VK_R",t,t],[49,0,28,"KeyS",49,"S",83,"VK_S",t,t],[50,0,29,"KeyT",50,"T",84,"VK_T",t,t],[51,0,30,"KeyU",51,"U",85,"VK_U",t,t],[52,0,31,"KeyV",52,"V",86,"VK_V",t,t],[53,0,32,"KeyW",53,"W",87,"VK_W",t,t],[54,0,33,"KeyX",54,"X",88,"VK_X",t,t],[55,0,34,"KeyY",55,"Y",89,"VK_Y",t,t],[56,0,35,"KeyZ",56,"Z",90,"VK_Z",t,t],[22,0,36,"Digit1",22,"1",49,"VK_1",t,t],[23,0,37,"Digit2",23,"2",50,"VK_2",t,t],[24,0,38,"Digit3",24,"3",51,"VK_3",t,t],[25,0,39,"Digit4",25,"4",52,"VK_4",t,t],[26,0,40,"Digit5",26,"5",53,"VK_5",t,t],[27,0,41,"Digit6",27,"6",54,"VK_6",t,t],[28,0,42,"Digit7",28,"7",55,"VK_7",t,t],[29,0,43,"Digit8",29,"8",56,"VK_8",t,t],[30,0,44,"Digit9",30,"9",57,"VK_9",t,t],[21,0,45,"Digit0",21,"0",48,"VK_0",t,t],[3,1,46,"Enter",3,"Enter",13,"VK_RETURN",t,t],[9,1,47,"Escape",9,"Escape",27,"VK_ESCAPE",t,t],[1,1,48,"Backspace",1,"Backspace",8,"VK_BACK",t,t],[2,1,49,"Tab",2,"Tab",9,"VK_TAB",t,t],[10,1,50,"Space",10,"Space",32,"VK_SPACE",t,t],[83,0,51,"Minus",83,"-",189,"VK_OEM_MINUS","-","OEM_MINUS"],[81,0,52,"Equal",81,"=",187,"VK_OEM_PLUS","=","OEM_PLUS"],[87,0,53,"BracketLeft",87,"[",219,"VK_OEM_4","[","OEM_4"],[89,0,54,"BracketRight",89,"]",221,"VK_OEM_6","]","OEM_6"],[88,0,55,"Backslash",88,"\\",220,"VK_OEM_5","\\","OEM_5"],[0,0,56,"IntlHash",0,t,0,t,t,t],[80,0,57,"Semicolon",80,";",186,"VK_OEM_1",";","OEM_1"],[90,0,58,"Quote",90,"'",222,"VK_OEM_7","'","OEM_7"],[86,0,59,"Backquote",86,"`",192,"VK_OEM_3","`","OEM_3"],[82,0,60,"Comma",82,",",188,"VK_OEM_COMMA",",","OEM_COMMA"],[84,0,61,"Period",84,".",190,"VK_OEM_PERIOD",".","OEM_PERIOD"],[85,0,62,"Slash",85,"/",191,"VK_OEM_2","/","OEM_2"],[8,1,63,"CapsLock",8,"CapsLock",20,"VK_CAPITAL",t,t],[59,1,64,"F1",59,"F1",112,"VK_F1",t,t],[60,1,65,"F2",60,"F2",113,"VK_F2",t,t],[61,1,66,"F3",61,"F3",114,"VK_F3",t,t],[62,1,67,"F4",62,"F4",115,"VK_F4",t,t],[63,1,68,"F5",63,"F5",116,"VK_F5",t,t],[64,1,69,"F6",64,"F6",117,"VK_F6",t,t],[65,1,70,"F7",65,"F7",118,"VK_F7",t,t],[66,1,71,"F8",66,"F8",119,"VK_F8",t,t],[67,1,72,"F9",67,"F9",120,"VK_F9",t,t],[68,1,73,"F10",68,"F10",121,"VK_F10",t,t],[69,1,74,"F11",69,"F11",122,"VK_F11",t,t],[70,1,75,"F12",70,"F12",123,"VK_F12",t,t],[0,1,76,"PrintScreen",0,t,0,t,t,t],[79,1,77,"ScrollLock",79,"ScrollLock",145,"VK_SCROLL",t,t],[7,1,78,"Pause",7,"PauseBreak",19,"VK_PAUSE",t,t],[19,1,79,"Insert",19,"Insert",45,"VK_INSERT",t,t],[14,1,80,"Home",14,"Home",36,"VK_HOME",t,t],[11,1,81,"PageUp",11,"PageUp",33,"VK_PRIOR",t,t],[20,1,82,"Delete",20,"Delete",46,"VK_DELETE",t,t],[13,1,83,"End",13,"End",35,"VK_END",t,t],[12,1,84,"PageDown",12,"PageDown",34,"VK_NEXT",t,t],[17,1,85,"ArrowRight",17,"RightArrow",39,"VK_RIGHT","Right",t],[15,1,86,"ArrowLeft",15,"LeftArrow",37,"VK_LEFT","Left",t],[18,1,87,"ArrowDown",18,"DownArrow",40,"VK_DOWN","Down",t],[16,1,88,"ArrowUp",16,"UpArrow",38,"VK_UP","Up",t],[78,1,89,"NumLock",78,"NumLock",144,"VK_NUMLOCK",t,t],[108,1,90,"NumpadDivide",108,"NumPad_Divide",111,"VK_DIVIDE",t,t],[103,1,91,"NumpadMultiply",103,"NumPad_Multiply",106,"VK_MULTIPLY",t,t],[106,1,92,"NumpadSubtract",106,"NumPad_Subtract",109,"VK_SUBTRACT",t,t],[104,1,93,"NumpadAdd",104,"NumPad_Add",107,"VK_ADD",t,t],[3,1,94,"NumpadEnter",3,t,0,t,t,t],[94,1,95,"Numpad1",94,"NumPad1",97,"VK_NUMPAD1",t,t],[95,1,96,"Numpad2",95,"NumPad2",98,"VK_NUMPAD2",t,t],[96,1,97,"Numpad3",96,"NumPad3",99,"VK_NUMPAD3",t,t],[97,1,98,"Numpad4",97,"NumPad4",100,"VK_NUMPAD4",t,t],[98,1,99,"Numpad5",98,"NumPad5",101,"VK_NUMPAD5",t,t],[99,1,100,"Numpad6",99,"NumPad6",102,"VK_NUMPAD6",t,t],[100,1,101,"Numpad7",100,"NumPad7",103,"VK_NUMPAD7",t,t],[101,1,102,"Numpad8",101,"NumPad8",104,"VK_NUMPAD8",t,t],[102,1,103,"Numpad9",102,"NumPad9",105,"VK_NUMPAD9",t,t],[93,1,104,"Numpad0",93,"NumPad0",96,"VK_NUMPAD0",t,t],[107,1,105,"NumpadDecimal",107,"NumPad_Decimal",110,"VK_DECIMAL",t,t],[92,0,106,"IntlBackslash",92,"OEM_102",226,"VK_OEM_102",t,t],[58,1,107,"ContextMenu",58,"ContextMenu",93,t,t,t],[0,1,108,"Power",0,t,0,t,t,t],[0,1,109,"NumpadEqual",0,t,0,t,t,t],[71,1,110,"F13",71,"F13",124,"VK_F13",t,t],[72,1,111,"F14",72,"F14",125,"VK_F14",t,t],[73,1,112,"F15",73,"F15",126,"VK_F15",t,t],[74,1,113,"F16",74,"F16",127,"VK_F16",t,t],[75,1,114,"F17",75,"F17",128,"VK_F17",t,t],[76,1,115,"F18",76,"F18",129,"VK_F18",t,t],[77,1,116,"F19",77,"F19",130,"VK_F19",t,t],[0,1,117,"F20",0,t,0,"VK_F20",t,t],[0,1,118,"F21",0,t,0,"VK_F21",t,t],[0,1,119,"F22",0,t,0,"VK_F22",t,t],[0,1,120,"F23",0,t,0,"VK_F23",t,t],[0,1,121,"F24",0,t,0,"VK_F24",t,t],[0,1,122,"Open",0,t,0,t,t,t],[0,1,123,"Help",0,t,0,t,t,t],[0,1,124,"Select",0,t,0,t,t,t],[0,1,125,"Again",0,t,0,t,t,t],[0,1,126,"Undo",0,t,0,t,t,t],[0,1,127,"Cut",0,t,0,t,t,t],[0,1,128,"Copy",0,t,0,t,t,t],[0,1,129,"Paste",0,t,0,t,t,t],[0,1,130,"Find",0,t,0,t,t,t],[0,1,131,"AudioVolumeMute",112,"AudioVolumeMute",173,"VK_VOLUME_MUTE",t,t],[0,1,132,"AudioVolumeUp",113,"AudioVolumeUp",175,"VK_VOLUME_UP",t,t],[0,1,133,"AudioVolumeDown",114,"AudioVolumeDown",174,"VK_VOLUME_DOWN",t,t],[105,1,134,"NumpadComma",105,"NumPad_Separator",108,"VK_SEPARATOR",t,t],[110,0,135,"IntlRo",110,"ABNT_C1",193,"VK_ABNT_C1",t,t],[0,1,136,"KanaMode",0,t,0,t,t,t],[0,0,137,"IntlYen",0,t,0,t,t,t],[0,1,138,"Convert",0,t,0,t,t,t],[0,1,139,"NonConvert",0,t,0,t,t,t],[0,1,140,"Lang1",0,t,0,t,t,t],[0,1,141,"Lang2",0,t,0,t,t,t],[0,1,142,"Lang3",0,t,0,t,t,t],[0,1,143,"Lang4",0,t,0,t,t,t],[0,1,144,"Lang5",0,t,0,t,t,t],[0,1,145,"Abort",0,t,0,t,t,t],[0,1,146,"Props",0,t,0,t,t,t],[0,1,147,"NumpadParenLeft",0,t,0,t,t,t],[0,1,148,"NumpadParenRight",0,t,0,t,t,t],[0,1,149,"NumpadBackspace",0,t,0,t,t,t],[0,1,150,"NumpadMemoryStore",0,t,0,t,t,t],[0,1,151,"NumpadMemoryRecall",0,t,0,t,t,t],[0,1,152,"NumpadMemoryClear",0,t,0,t,t,t],[0,1,153,"NumpadMemoryAdd",0,t,0,t,t,t],[0,1,154,"NumpadMemorySubtract",0,t,0,t,t,t],[0,1,155,"NumpadClear",0,t,0,t,t,t],[0,1,156,"NumpadClearEntry",0,t,0,t,t,t],[5,1,0,t,5,"Ctrl",17,"VK_CONTROL",t,t],[4,1,0,t,4,"Shift",16,"VK_SHIFT",t,t],[6,1,0,t,6,"Alt",18,"VK_MENU",t,t],[57,1,0,t,57,"Meta",0,"VK_COMMAND",t,t],[5,1,157,"ControlLeft",5,t,0,"VK_LCONTROL",t,t],[4,1,158,"ShiftLeft",4,t,0,"VK_LSHIFT",t,t],[6,1,159,"AltLeft",6,t,0,"VK_LMENU",t,t],[57,1,160,"MetaLeft",57,t,0,"VK_LWIN",t,t],[5,1,161,"ControlRight",5,t,0,"VK_RCONTROL",t,t],[4,1,162,"ShiftRight",4,t,0,"VK_RSHIFT",t,t],[6,1,163,"AltRight",6,t,0,"VK_RMENU",t,t],[57,1,164,"MetaRight",57,t,0,"VK_RWIN",t,t],[0,1,165,"BrightnessUp",0,t,0,t,t,t],[0,1,166,"BrightnessDown",0,t,0,t,t,t],[0,1,167,"MediaPlay",0,t,0,t,t,t],[0,1,168,"MediaRecord",0,t,0,t,t,t],[0,1,169,"MediaFastForward",0,t,0,t,t,t],[0,1,170,"MediaRewind",0,t,0,t,t,t],[114,1,171,"MediaTrackNext",119,"MediaTrackNext",176,"VK_MEDIA_NEXT_TRACK",t,t],[115,1,172,"MediaTrackPrevious",120,"MediaTrackPrevious",177,"VK_MEDIA_PREV_TRACK",t,t],[116,1,173,"MediaStop",121,"MediaStop",178,"VK_MEDIA_STOP",t,t],[0,1,174,"Eject",0,t,0,t,t,t],[117,1,175,"MediaPlayPause",122,"MediaPlayPause",179,"VK_MEDIA_PLAY_PAUSE",t,t],[0,1,176,"MediaSelect",123,"LaunchMediaPlayer",181,"VK_MEDIA_LAUNCH_MEDIA_SELECT",t,t],[0,1,177,"LaunchMail",124,"LaunchMail",180,"VK_MEDIA_LAUNCH_MAIL",t,t],[0,1,178,"LaunchApp2",125,"LaunchApp2",183,"VK_MEDIA_LAUNCH_APP2",t,t],[0,1,179,"LaunchApp1",0,t,0,"VK_MEDIA_LAUNCH_APP1",t,t],[0,1,180,"SelectTask",0,t,0,t,t,t],[0,1,181,"LaunchScreenSaver",0,t,0,t,t,t],[0,1,182,"BrowserSearch",115,"BrowserSearch",170,"VK_BROWSER_SEARCH",t,t],[0,1,183,"BrowserHome",116,"BrowserHome",172,"VK_BROWSER_HOME",t,t],[112,1,184,"BrowserBack",117,"BrowserBack",166,"VK_BROWSER_BACK",t,t],[113,1,185,"BrowserForward",118,"BrowserForward",167,"VK_BROWSER_FORWARD",t,t],[0,1,186,"BrowserStop",0,t,0,"VK_BROWSER_STOP",t,t],[0,1,187,"BrowserRefresh",0,t,0,"VK_BROWSER_REFRESH",t,t],[0,1,188,"BrowserFavorites",0,t,0,"VK_BROWSER_FAVORITES",t,t],[0,1,189,"ZoomToggle",0,t,0,t,t,t],[0,1,190,"MailReply",0,t,0,t,t,t],[0,1,191,"MailForward",0,t,0,t,t,t],[0,1,192,"MailSend",0,t,0,t,t,t],[109,1,0,t,109,"KeyInComposition",229,t,t,t],[111,1,0,t,111,"ABNT_C2",194,"VK_ABNT_C2",t,t],[91,1,0,t,91,"OEM_8",223,"VK_OEM_8",t,t],[0,1,0,t,0,t,0,"VK_CLEAR",t,t],[0,1,0,t,0,t,0,"VK_KANA",t,t],[0,1,0,t,0,t,0,"VK_HANGUL",t,t],[0,1,0,t,0,t,0,"VK_JUNJA",t,t],[0,1,0,t,0,t,0,"VK_FINAL",t,t],[0,1,0,t,0,t,0,"VK_HANJA",t,t],[0,1,0,t,0,t,0,"VK_KANJI",t,t],[0,1,0,t,0,t,0,"VK_CONVERT",t,t],[0,1,0,t,0,t,0,"VK_NONCONVERT",t,t],[0,1,0,t,0,t,0,"VK_ACCEPT",t,t],[0,1,0,t,0,t,0,"VK_MODECHANGE",t,t],[0,1,0,t,0,t,0,"VK_SELECT",t,t],[0,1,0,t,0,t,0,"VK_PRINT",t,t],[0,1,0,t,0,t,0,"VK_EXECUTE",t,t],[0,1,0,t,0,t,0,"VK_SNAPSHOT",t,t],[0,1,0,t,0,t,0,"VK_HELP",t,t],[0,1,0,t,0,t,0,"VK_APPS",t,t],[0,1,0,t,0,t,0,"VK_PROCESSKEY",t,t],[0,1,0,t,0,t,0,"VK_PACKET",t,t],[0,1,0,t,0,t,0,"VK_DBE_SBCSCHAR",t,t],[0,1,0,t,0,t,0,"VK_DBE_DBCSCHAR",t,t],[0,1,0,t,0,t,0,"VK_ATTN",t,t],[0,1,0,t,0,t,0,"VK_CRSEL",t,t],[0,1,0,t,0,t,0,"VK_EXSEL",t,t],[0,1,0,t,0,t,0,"VK_EREOF",t,t],[0,1,0,t,0,t,0,"VK_PLAY",t,t],[0,1,0,t,0,t,0,"VK_ZOOM",t,t],[0,1,0,t,0,t,0,"VK_NONAME",t,t],[0,1,0,t,0,t,0,"VK_PA1",t,t],[0,1,0,t,0,t,0,"VK_OEM_CLEAR",t,t]];let v=[],b=[];for(const P of m){const[c,a,l,o,u,r,i,s,h,w]=P;if(b[l]||(b[l]=!0,d[l]=o,f[o]=l,y[o.toLowerCase()]=l,a&&(e.IMMUTABLE_CODE_TO_KEY_CODE[l]=u,u!==0&&u!==3&&u!==5&&u!==4&&u!==6&&u!==57&&(e.IMMUTABLE_KEY_CODE_TO_CODE[u]=l))),!v[u]){if(v[u]=!0,!r)throw new Error(`String representation missing for key code ${u} around scan code ${o}`);k.define(u,r),n.define(u,h||r),I.define(u,w||h||r)}i&&(e.EVENT_KEY_CODE_MAP[i]=u),s&&(e.NATIVE_WINDOWS_KEY_CODE_TO_KEY_CODE[s]=u)}e.IMMUTABLE_KEY_CODE_TO_CODE[3]=46})();var E;(function(t){function m(l){return k.keyCodeToStr(l)}t.toString=m;function v(l){return k.strToKeyCode(l)}t.fromString=v;function b(l){return n.keyCodeToStr(l)}t.toUserSettingsUS=b;function P(l){return I.keyCodeToStr(l)}t.toUserSettingsGeneral=P;function c(l){return n.strToKeyCode(l)||I.strToKeyCode(l)}t.fromUserSettings=c;function a(l){if(l>=93&&l<=108)return null;switch(l){case 16:return"Up";case 18:return"Down";case 15:return"Left";case 17:return"Right"}return k.keyCodeToStr(l)}t.toElectronAccelerator=a})(E=e.KeyCodeUtils||(e.KeyCodeUtils={}));var g;(function(t){t[t.CtrlCmd=2048]="CtrlCmd",t[t.Shift=1024]="Shift",t[t.Alt=512]="Alt",t[t.WinCtrl=256]="WinCtrl"})(g=e.KeyMod||(e.KeyMod={}));function S(t,m){const v=(m&65535)<<16>>>0;return(t|v)>>>0}e.KeyChord=S}),define(x[59],ee([0,1,16]),function(V,e,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ResolvedKeybinding=e.ResolvedKeybindingPart=e.ScanCodeBinding=e.ChordKeybinding=e.SimpleKeybinding=e.createSimpleKeybinding=e.createKeybinding=void 0;var R;(function(E){E[E.CtrlCmd=2048]="CtrlCmd",E[E.Shift=1024]="Shift",E[E.Alt=512]="Alt",E[E.WinCtrl=256]="WinCtrl",E[E.KeyCode=255]="KeyCode"})(R||(R={}));function C(E,g){if(E===0)return null;const S=(E&65535)>>>0,t=(E&4294901760)>>>16;return t!==0?new I([k(S,g),k(t,g)]):new I([k(S,g)])}e.createKeybinding=C;function k(E,g){const S=!!(E&2048),t=!!(E&256),m=g===2?t:S,v=!!(E&1024),b=!!(E&512),P=g===2?S:t,c=E&255;return new n(m,v,b,P,c)}e.createSimpleKeybinding=k;class n{constructor(g,S,t,m,v){this.ctrlKey=g,this.shiftKey=S,this.altKey=t,this.metaKey=m,this.keyCode=v}equals(g){return this.ctrlKey===g.ctrlKey&&this.shiftKey===g.shiftKey&&this.altKey===g.altKey&&this.metaKey===g.metaKey&&this.keyCode===g.keyCode}getHashCode(){const g=this.ctrlKey?"1":"0",S=this.shiftKey?"1":"0",t=this.altKey?"1":"0",m=this.metaKey?"1":"0";return`${g}${S}${t}${m}${this.keyCode}`}isModifierKey(){return this.keyCode===0||this.keyCode===5||this.keyCode===57||this.keyCode===6||this.keyCode===4}toChord(){return new I([this])}isDuplicateModifierCase(){return this.ctrlKey&&this.keyCode===5||this.shiftKey&&this.keyCode===4||this.altKey&&this.keyCode===6||this.metaKey&&this.keyCode===57}}e.SimpleKeybinding=n;class I{constructor(g){if(g.length===0)throw(0,p.illegalArgument)("parts");this.parts=g}getHashCode(){let g="";for(let S=0,t=this.parts.length;S<t;S++)S!==0&&(g+=";"),g+=this.parts[S].getHashCode();return g}equals(g){if(g===null||this.parts.length!==g.parts.length)return!1;for(let S=0;S<this.parts.length;S++)if(!this.parts[S].equals(g.parts[S]))return!1;return!0}}e.ChordKeybinding=I;class d{constructor(g,S,t,m,v){this.ctrlKey=g,this.shiftKey=S,this.altKey=t,this.metaKey=m,this.scanCode=v}equals(g){return this.ctrlKey===g.ctrlKey&&this.shiftKey===g.shiftKey&&this.altKey===g.altKey&&this.metaKey===g.metaKey&&this.scanCode===g.scanCode}isDuplicateModifierCase(){return this.ctrlKey&&(this.scanCode===157||this.scanCode===161)||this.shiftKey&&(this.scanCode===158||this.scanCode===162)||this.altKey&&(this.scanCode===159||this.scanCode===163)||this.metaKey&&(this.scanCode===160||this.scanCode===164)}}e.ScanCodeBinding=d;class f{constructor(g,S,t,m,v,b){this.ctrlKey=g,this.shiftKey=S,this.altKey=t,this.metaKey=m,this.keyLabel=v,this.keyAriaLabel=b}}e.ResolvedKeybindingPart=f;class y{}e.ResolvedKeybinding=y}),define(x[106],ee([0,1,79,59]),function(V,e,p,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.KeybindingParser=void 0;class C{static _readModifiers(n){n=n.toLowerCase().trim();let I=!1,d=!1,f=!1,y=!1,E;do E=!1,/^ctrl(\+|\-)/.test(n)&&(I=!0,n=n.substr("ctrl-".length),E=!0),/^shift(\+|\-)/.test(n)&&(d=!0,n=n.substr("shift-".length),E=!0),/^alt(\+|\-)/.test(n)&&(f=!0,n=n.substr("alt-".length),E=!0),/^meta(\+|\-)/.test(n)&&(y=!0,n=n.substr("meta-".length),E=!0),/^win(\+|\-)/.test(n)&&(y=!0,n=n.substr("win-".length),E=!0),/^cmd(\+|\-)/.test(n)&&(y=!0,n=n.substr("cmd-".length),E=!0);while(E);let g;const S=n.indexOf(" ");return S>0?(g=n.substring(0,S),n=n.substring(S)):(g=n,n=""),{remains:n,ctrl:I,shift:d,alt:f,meta:y,key:g}}static parseSimpleKeybinding(n){const I=this._readModifiers(n),d=p.KeyCodeUtils.fromUserSettings(I.key);return[new R.SimpleKeybinding(I.ctrl,I.shift,I.alt,I.meta,d),I.remains]}static parseKeybinding(n,I){if(!n)return null;const d=[];let f;do[f,n]=this.parseSimpleKeybinding(n),d.push(f);while(n.length>0);return new R.ChordKeybinding(d)}static parseSimpleUserBinding(n){const I=this._readModifiers(n),d=I.key.match(/^\[([^\]]+)\]$/);if(d){const y=d[1],E=p.ScanCodeUtils.lowerCaseToEnum(y);return[new R.ScanCodeBinding(I.ctrl,I.shift,I.alt,I.meta,E),I.remains]}const f=p.KeyCodeUtils.fromUserSettings(I.key);return[new R.SimpleKeybinding(I.ctrl,I.shift,I.alt,I.meta,f),I.remains]}static parseUserBinding(n){if(!n)return[];const I=[];let d;for(;n.length>0;)[d,n]=this.parseSimpleUserBinding(n),I.push(d);return I}}e.KeybindingParser=C}),define(x[2],ee([0,1,42,69]),function(V,e,p,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.disposeOnReturn=e.ImmortalReference=e.AsyncReferenceCollection=e.ReferenceCollection=e.RefCountedDisposable=e.MutableDisposable=e.Disposable=e.DisposableStore=e.toDisposable=e.combinedDisposable=e.dispose=e.isDisposable=e.MultiDisposeError=e.markAsSingleton=e.setDisposableTracker=void 0;const C=!1;let k=null;function n(i){k=i}if(e.setDisposableTracker=n,C){const i="__is_disposable_tracked__";n(new class{trackDisposable(s){const h=new Error("Potentially leaked disposable").stack;setTimeout(()=>{s[i]||console.log(h)},3e3)}setParent(s,h){if(s&&s!==P.None)try{s[i]=!0}catch{}}markAsDisposed(s){if(s&&s!==P.None)try{s[i]=!0}catch{}}markAsSingleton(s){}})}function I(i){return k?.trackDisposable(i),i}function d(i){k?.markAsDisposed(i)}function f(i,s){k?.setParent(i,s)}function y(i,s){if(!!k)for(const h of i)k.setParent(h,s)}function E(i){return k?.markAsSingleton(i),i}e.markAsSingleton=E;class g extends Error{constructor(s){super(`Encountered errors while disposing of store. Errors: [${s.join(", ")}]`);this.errors=s}}e.MultiDisposeError=g;function S(i){return typeof i.dispose=="function"&&i.dispose.length===0}e.isDisposable=S;function t(i){if(R.Iterable.is(i)){let s=[];for(const h of i)if(h)try{h.dispose()}catch(w){s.push(w)}if(s.length===1)throw s[0];if(s.length>1)throw new g(s);return Array.isArray(i)?[]:i}else if(i)return i.dispose(),i}e.dispose=t;function m(...i){const s=v(()=>t(i));return y(i,s),s}e.combinedDisposable=m;function v(i){const s=I({dispose:(0,p.once)(()=>{d(s),i()})});return s}e.toDisposable=v;class b{constructor(){this._toDispose=new Set,this._isDisposed=!1,I(this)}dispose(){this._isDisposed||(d(this),this._isDisposed=!0,this.clear())}clear(){try{t(this._toDispose.values())}finally{this._toDispose.clear()}}add(s){if(!s)return s;if(s===this)throw new Error("Cannot register a disposable on itself!");return f(s,this),this._isDisposed?b.DISABLE_DISPOSED_WARNING||console.warn(new Error("Trying to add a disposable to a DisposableStore that has already been disposed of. The added object will be leaked!").stack):this._toDispose.add(s),s}}e.DisposableStore=b,b.DISABLE_DISPOSED_WARNING=!1;class P{constructor(){this._store=new b,I(this),f(this._store,this)}dispose(){d(this),this._store.dispose()}_register(s){if(s===this)throw new Error("Cannot register a disposable on itself!");return this._store.add(s)}}e.Disposable=P,P.None=Object.freeze({dispose(){}});class c{constructor(){this._isDisposed=!1,I(this)}get value(){return this._isDisposed?void 0:this._value}set value(s){this._isDisposed||s===this._value||(this._value?.dispose(),s&&f(s,this),this._value=s)}clear(){this.value=void 0}dispose(){this._isDisposed=!0,d(this),this._value?.dispose(),this._value=void 0}clearAndLeak(){const s=this._value;return this._value=void 0,s&&f(s,null),s}}e.MutableDisposable=c;class a{constructor(s){this._disposable=s,this._counter=1}acquire(){return this._counter++,this}release(){return--this._counter==0&&this._disposable.dispose(),this}}e.RefCountedDisposable=a;class l{constructor(){this.references=new Map}acquire(s,...h){let w=this.references.get(s);w||(w={counter:0,object:this.createReferencedObject(s,...h)},this.references.set(s,w));const{object:M}=w,A=(0,p.once)(()=>{--w.counter==0&&(this.destroyReferencedObject(s,w.object),this.references.delete(s))});return w.counter++,{object:M,dispose:A}}}e.ReferenceCollection=l;class o{constructor(s){this.referenceCollection=s}async acquire(s,...h){const w=this.referenceCollection.acquire(s,...h);try{return{object:await w.object,dispose:()=>w.dispose()}}catch(M){throw w.dispose(),M}}}e.AsyncReferenceCollection=o;class u{constructor(s){this.object=s}dispose(){}}e.ImmortalReference=u;function r(i){const s=new b;try{i(s)}finally{s.dispose()}}e.disposeOnReturn=r}),define(x[107],ee([0,1]),function(V,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LinkedList=void 0;class p{constructor(k){this.element=k,this.next=p.Undefined,this.prev=p.Undefined}}p.Undefined=new p(void 0);class R{constructor(){this._first=p.Undefined,this._last=p.Undefined,this._size=0}get size(){return this._size}isEmpty(){return this._first===p.Undefined}clear(){let k=this._first;for(;k!==p.Undefined;){const n=k.next;k.prev=p.Undefined,k.next=p.Undefined,k=n}this._first=p.Undefined,this._last=p.Undefined,this._size=0}unshift(k){return this._insert(k,!1)}push(k){return this._insert(k,!0)}_insert(k,n){const I=new p(k);if(this._first===p.Undefined)this._first=I,this._last=I;else if(n){const f=this._last;this._last=I,I.prev=f,f.next=I}else{const f=this._first;this._first=I,I.next=f,f.prev=I}this._size+=1;let d=!1;return()=>{d||(d=!0,this._remove(I))}}shift(){if(this._first!==p.Undefined){const k=this._first.element;return this._remove(this._first),k}}pop(){if(this._last!==p.Undefined){const k=this._last.element;return this._remove(this._last),k}}_remove(k){if(k.prev!==p.Undefined&&k.next!==p.Undefined){const n=k.prev;n.next=k.next,k.next.prev=n}else k.prev===p.Undefined&&k.next===p.Undefined?(this._first=p.Undefined,this._last=p.Undefined):k.next===p.Undefined?(this._last=this._last.prev,this._last.next=p.Undefined):k.prev===p.Undefined&&(this._first=this._first.next,this._first.prev=p.Undefined);this._size-=1}*[Symbol.iterator](){let k=this._first;for(;k!==p.Undefined;)yield k.element,k=k.next}}e.LinkedList=R}),function(){function V(C){const k=[];typeof C=="number"&&k.push("code/timeOrigin",C);function n(d){k.push(d,Date.now())}function I(){const d=[];for(let f=0;f<k.length;f+=2)d.push({name:k[f],startTime:k[f+1]});return d}return{mark:n,getMarks:I}}function e(){if(typeof performance=="object"&&typeof performance.mark=="function"&&!performance.nodeTiming)return typeof performance.timeOrigin!="number"&&!performance.timing?V():{mark(C){performance.mark(C)},getMarks(){let C=performance.timeOrigin;typeof C!="number"&&(C=performance.timing.navigationStart||performance.timing.redirectStart||performance.timing.fetchStart);const k=[{name:"code/timeOrigin",startTime:Math.round(C)}];for(const n of performance.getEntriesByType("mark"))k.push({name:n.name,startTime:Math.round(C+n.startTime)});return k}};if(typeof process=="object"){const C=Math.round((require.nodeRequire||require)("perf_hooks").performance.timeOrigin);return V(C)}else return console.trace("perf-util loaded in UNKNOWN environment"),V()}function p(C){return C.MonacoPerformanceMarks||(C.MonacoPerformanceMarks=e()),C.MonacoPerformanceMarks}var R;typeof global=="object"?R=global:typeof self=="object"?R=self:R={},typeof define=="function"?define("vs/base/common/performance",[],function(){return p(R)}):typeof module=="object"&&typeof module.exports=="object"?module.exports=p(R):(console.trace("perf-util defined in UNKNOWN context (neither requirejs or commonjs)"),R.perf=p(R))}(),define(x[3],ee([0,1]),function(V,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isLittleEndian=e.OS=e.OperatingSystem=e.setImmediate=e.setTimeout0=e.translationsConfigFile=e.locale=e.Language=e.language=e.userAgent=e.platform=e.isIOS=e.isWeb=e.isElectron=e.isNative=e.isLinuxSnap=e.isLinux=e.isMacintosh=e.isWindows=e.PlatformToString=e.Platform=e.isElectronSandboxed=e.globals=void 0;const p="en";let R=!1,C=!1,k=!1,n=!1,I=!1,d=!1,f=!1,y=!1,E,g=p,S,t;e.globals=typeof self=="object"?self:typeof global=="object"?global:{};let m;typeof e.globals.vscode!="undefined"&&typeof e.globals.vscode.process!="undefined"?m=e.globals.vscode.process:typeof process!="undefined"&&(m=process);const v=typeof m?.versions?.electron=="string",b=v&&m?.type==="renderer";if(e.isElectronSandboxed=b&&m?.sandboxed,typeof navigator=="object"&&!b)t=navigator.userAgent,R=t.indexOf("Windows")>=0,C=t.indexOf("Macintosh")>=0,y=(t.indexOf("Macintosh")>=0||t.indexOf("iPad")>=0||t.indexOf("iPhone")>=0)&&!!navigator.maxTouchPoints&&navigator.maxTouchPoints>0,k=t.indexOf("Linux")>=0,d=!0,E=navigator.language,g=E;else if(typeof m=="object"){R=m.platform==="win32",C=m.platform==="darwin",k=m.platform==="linux",n=k&&!!m.env.SNAP&&!!m.env.SNAP_REVISION,f=v,E=p,g=p;const s=m.env.VSCODE_NLS_CONFIG;if(s)try{const h=JSON.parse(s),w=h.availableLanguages["*"];E=h.locale,g=w||p,S=h._translationsConfigFile}catch(h){}I=!0}else console.error("Unable to resolve platform.");var P;(function(s){s[s.Web=0]="Web",s[s.Mac=1]="Mac",s[s.Linux=2]="Linux",s[s.Windows=3]="Windows"})(P=e.Platform||(e.Platform={}));function c(s){switch(s){case 0:return"Web";case 1:return"Mac";case 2:return"Linux";case 3:return"Windows"}}e.PlatformToString=c;let a=0;C?a=1:R?a=3:k&&(a=2),e.isWindows=R,e.isMacintosh=C,e.isLinux=k,e.isLinuxSnap=n,e.isNative=I,e.isElectron=f,e.isWeb=d,e.isIOS=y,e.platform=a,e.userAgent=t,e.language=g;var l;(function(s){function h(){return e.language}s.value=h;function w(){return e.language.length===2?e.language==="en":e.language.length>=3?e.language[0]==="e"&&e.language[1]==="n"&&e.language[2]==="-":!1}s.isDefaultVariant=w;function M(){return e.language==="en"}s.isDefault=M})(l=e.Language||(e.Language={})),e.locale=E,e.translationsConfigFile=S,e.setTimeout0=(()=>{if(typeof e.globals.postMessage=="function"&&!e.globals.importScripts){let s=[];e.globals.addEventListener("message",w=>{if(w.data&&w.data.vscodeScheduleAsyncWork)for(let M=0,A=s.length;M<A;M++){const L=s[M];if(L.id===w.data.vscodeScheduleAsyncWork){s.splice(M,1),L.callback();return}}});let h=0;return w=>{const M=++h;s.push({id:M,callback:w}),e.globals.postMessage({vscodeScheduleAsyncWork:M},"*")}}return s=>setTimeout(s)})(),e.setImmediate=function(){if(e.globals.setImmediate)return e.globals.setImmediate.bind(e.globals);if(typeof e.globals.postMessage=="function"&&!e.globals.importScripts)return e.setTimeout0;if(typeof m?.nextTick=="function")return m.nextTick.bind(m);const h=Promise.resolve();return w=>h.then(w)}();var o;(function(s){s[s.Windows=1]="Windows",s[s.Macintosh=2]="Macintosh",s[s.Linux=3]="Linux"})(o=e.OperatingSystem||(e.OperatingSystem={})),e.OS=C||y?2:R?1:3;let u=!0,r=!1;function i(){if(!r){r=!0;const s=new Uint8Array(2);s[0]=1,s[1]=2,u=new Uint16Array(s.buffer)[0]===(2<<8)+1}return u}e.isLittleEndian=i}),define(x[34],ee([0,1,3]),function(V,e,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.arch=e.platform=e.env=e.cwd=void 0;let R;if(typeof p.globals.vscode!="undefined"&&typeof p.globals.vscode.process!="undefined"){const C=p.globals.vscode.process;R={get platform(){return C.platform},get arch(){return C.arch},get env(){return C.env},cwd(){return C.cwd()}}}else typeof process!="undefined"?R={get platform(){return process.platform},get arch(){return process.arch},get env(){return process.env},cwd(){return process.env.VSCODE_CWD||process.cwd()}}:R={get platform(){return p.isWindows?"win32":p.isMacintosh?"darwin":"linux"},get arch(){},get env(){return{}},cwd(){return"/"}};e.cwd=R.cwd,e.env=R.env,e.platform=R.platform,e.arch=R.arch}),define(x[8],ee([0,1,34]),function(V,e,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.delimiter=e.sep=e.toNamespacedPath=e.parse=e.format=e.extname=e.basename=e.dirname=e.relative=e.resolve=e.join=e.isAbsolute=e.normalize=e.posix=e.win32=void 0;const R=65,C=97,k=90,n=122,I=46,d=47,f=92,y=58,E=63;class g extends Error{constructor(a,l,o){let u;typeof l=="string"&&l.indexOf("not ")===0?(u="must not be",l=l.replace(/^not /,"")):u="must be";const r=a.indexOf(".")!==-1?"property":"argument";let i=`The "${a}" ${r} ${u} of type ${l}`;i+=`. Received type ${typeof o}`,super(i),this.code="ERR_INVALID_ARG_TYPE"}}function S(c,a){if(typeof c!="string")throw new g(a,"string",c)}function t(c){return c===d||c===f}function m(c){return c===d}function v(c){return c>=R&&c<=k||c>=C&&c<=n}function b(c,a,l,o){let u="",r=0,i=-1,s=0,h=0;for(let w=0;w<=c.length;++w){if(w<c.length)h=c.charCodeAt(w);else{if(o(h))break;h=d}if(o(h)){if(!(i===w-1||s===1))if(s===2){if(u.length<2||r!==2||u.charCodeAt(u.length-1)!==I||u.charCodeAt(u.length-2)!==I){if(u.length>2){const M=u.lastIndexOf(l);M===-1?(u="",r=0):(u=u.slice(0,M),r=u.length-1-u.lastIndexOf(l)),i=w,s=0;continue}else if(u.length!==0){u="",r=0,i=w,s=0;continue}}a&&(u+=u.length>0?`${l}..`:"..",r=2)}else u.length>0?u+=`${l}${c.slice(i+1,w)}`:u=c.slice(i+1,w),r=w-i-1;i=w,s=0}else h===I&&s!==-1?++s:s=-1}return u}function P(c,a){if(a===null||typeof a!="object")throw new g("pathObject","Object",a);const l=a.dir||a.root,o=a.base||`${a.name||""}${a.ext||""}`;return l?l===a.root?`${l}${o}`:`${l}${c}${o}`:o}e.win32={resolve(...c){let a="",l="",o=!1;for(let u=c.length-1;u>=-1;u--){let r;if(u>=0){if(r=c[u],S(r,"path"),r.length===0)continue}else a.length===0?r=p.cwd():(r=p.env[`=${a}`]||p.cwd(),(r===void 0||r.slice(0,2).toLowerCase()!==a.toLowerCase()&&r.charCodeAt(2)===f)&&(r=`${a}\\`));const i=r.length;let s=0,h="",w=!1;const M=r.charCodeAt(0);if(i===1)t(M)&&(s=1,w=!0);else if(t(M))if(w=!0,t(r.charCodeAt(1))){let A=2,L=A;for(;A<i&&!t(r.charCodeAt(A));)A++;if(A<i&&A!==L){const F=r.slice(L,A);for(L=A;A<i&&t(r.charCodeAt(A));)A++;if(A<i&&A!==L){for(L=A;A<i&&!t(r.charCodeAt(A));)A++;(A===i||A!==L)&&(h=`\\\\${F}\\${r.slice(L,A)}`,s=A)}}}else s=1;else v(M)&&r.charCodeAt(1)===y&&(h=r.slice(0,2),s=2,i>2&&t(r.charCodeAt(2))&&(w=!0,s=3));if(h.length>0)if(a.length>0){if(h.toLowerCase()!==a.toLowerCase())continue}else a=h;if(o){if(a.length>0)break}else if(l=`${r.slice(s)}\\${l}`,o=w,w&&a.length>0)break}return l=b(l,!o,"\\",t),o?`${a}\\${l}`:`${a}${l}`||"."},normalize(c){S(c,"path");const a=c.length;if(a===0)return".";let l=0,o,u=!1;const r=c.charCodeAt(0);if(a===1)return m(r)?"\\":c;if(t(r))if(u=!0,t(c.charCodeAt(1))){let s=2,h=s;for(;s<a&&!t(c.charCodeAt(s));)s++;if(s<a&&s!==h){const w=c.slice(h,s);for(h=s;s<a&&t(c.charCodeAt(s));)s++;if(s<a&&s!==h){for(h=s;s<a&&!t(c.charCodeAt(s));)s++;if(s===a)return`\\\\${w}\\${c.slice(h)}\\`;s!==h&&(o=`\\\\${w}\\${c.slice(h,s)}`,l=s)}}}else l=1;else v(r)&&c.charCodeAt(1)===y&&(o=c.slice(0,2),l=2,a>2&&t(c.charCodeAt(2))&&(u=!0,l=3));let i=l<a?b(c.slice(l),!u,"\\",t):"";return i.length===0&&!u&&(i="."),i.length>0&&t(c.charCodeAt(a-1))&&(i+="\\"),o===void 0?u?`\\${i}`:i:u?`${o}\\${i}`:`${o}${i}`},isAbsolute(c){S(c,"path");const a=c.length;if(a===0)return!1;const l=c.charCodeAt(0);return t(l)||a>2&&v(l)&&c.charCodeAt(1)===y&&t(c.charCodeAt(2))},join(...c){if(c.length===0)return".";let a,l;for(let r=0;r<c.length;++r){const i=c[r];S(i,"path"),i.length>0&&(a===void 0?a=l=i:a+=`\\${i}`)}if(a===void 0)return".";let o=!0,u=0;if(typeof l=="string"&&t(l.charCodeAt(0))){++u;const r=l.length;r>1&&t(l.charCodeAt(1))&&(++u,r>2&&(t(l.charCodeAt(2))?++u:o=!1))}if(o){for(;u<a.length&&t(a.charCodeAt(u));)u++;u>=2&&(a=`\\${a.slice(u)}`)}return e.win32.normalize(a)},relative(c,a){if(S(c,"from"),S(a,"to"),c===a)return"";const l=e.win32.resolve(c),o=e.win32.resolve(a);if(l===o||(c=l.toLowerCase(),a=o.toLowerCase(),c===a))return"";let u=0;for(;u<c.length&&c.charCodeAt(u)===f;)u++;let r=c.length;for(;r-1>u&&c.charCodeAt(r-1)===f;)r--;const i=r-u;let s=0;for(;s<a.length&&a.charCodeAt(s)===f;)s++;let h=a.length;for(;h-1>s&&a.charCodeAt(h-1)===f;)h--;const w=h-s,M=i<w?i:w;let A=-1,L=0;for(;L<M;L++){const U=c.charCodeAt(u+L);if(U!==a.charCodeAt(s+L))break;U===f&&(A=L)}if(L!==M){if(A===-1)return o}else{if(w>M){if(a.charCodeAt(s+L)===f)return o.slice(s+L+1);if(L===2)return o.slice(s+L)}i>M&&(c.charCodeAt(u+L)===f?A=L:L===2&&(A=3)),A===-1&&(A=0)}let F="";for(L=u+A+1;L<=r;++L)(L===r||c.charCodeAt(L)===f)&&(F+=F.length===0?"..":"\\..");return s+=A,F.length>0?`${F}${o.slice(s,h)}`:(o.charCodeAt(s)===f&&++s,o.slice(s,h))},toNamespacedPath(c){if(typeof c!="string")return c;if(c.length===0)return"";const a=e.win32.resolve(c);if(a.length<=2)return c;if(a.charCodeAt(0)===f){if(a.charCodeAt(1)===f){const l=a.charCodeAt(2);if(l!==E&&l!==I)return`\\\\?\\UNC\\${a.slice(2)}`}}else if(v(a.charCodeAt(0))&&a.charCodeAt(1)===y&&a.charCodeAt(2)===f)return`\\\\?\\${a}`;return c},dirname(c){S(c,"path");const a=c.length;if(a===0)return".";let l=-1,o=0;const u=c.charCodeAt(0);if(a===1)return t(u)?c:".";if(t(u)){if(l=o=1,t(c.charCodeAt(1))){let s=2,h=s;for(;s<a&&!t(c.charCodeAt(s));)s++;if(s<a&&s!==h){for(h=s;s<a&&t(c.charCodeAt(s));)s++;if(s<a&&s!==h){for(h=s;s<a&&!t(c.charCodeAt(s));)s++;if(s===a)return c;s!==h&&(l=o=s+1)}}}}else v(u)&&c.charCodeAt(1)===y&&(l=a>2&&t(c.charCodeAt(2))?3:2,o=l);let r=-1,i=!0;for(let s=a-1;s>=o;--s)if(t(c.charCodeAt(s))){if(!i){r=s;break}}else i=!1;if(r===-1){if(l===-1)return".";r=l}return c.slice(0,r)},basename(c,a){a!==void 0&&S(a,"ext"),S(c,"path");let l=0,o=-1,u=!0,r;if(c.length>=2&&v(c.charCodeAt(0))&&c.charCodeAt(1)===y&&(l=2),a!==void 0&&a.length>0&&a.length<=c.length){if(a===c)return"";let i=a.length-1,s=-1;for(r=c.length-1;r>=l;--r){const h=c.charCodeAt(r);if(t(h)){if(!u){l=r+1;break}}else s===-1&&(u=!1,s=r+1),i>=0&&(h===a.charCodeAt(i)?--i==-1&&(o=r):(i=-1,o=s))}return l===o?o=s:o===-1&&(o=c.length),c.slice(l,o)}for(r=c.length-1;r>=l;--r)if(t(c.charCodeAt(r))){if(!u){l=r+1;break}}else o===-1&&(u=!1,o=r+1);return o===-1?"":c.slice(l,o)},extname(c){S(c,"path");let a=0,l=-1,o=0,u=-1,r=!0,i=0;c.length>=2&&c.charCodeAt(1)===y&&v(c.charCodeAt(0))&&(a=o=2);for(let s=c.length-1;s>=a;--s){const h=c.charCodeAt(s);if(t(h)){if(!r){o=s+1;break}continue}u===-1&&(r=!1,u=s+1),h===I?l===-1?l=s:i!==1&&(i=1):l!==-1&&(i=-1)}return l===-1||u===-1||i===0||i===1&&l===u-1&&l===o+1?"":c.slice(l,u)},format:P.bind(null,"\\"),parse(c){S(c,"path");const a={root:"",dir:"",base:"",ext:"",name:""};if(c.length===0)return a;const l=c.length;let o=0,u=c.charCodeAt(0);if(l===1)return t(u)?(a.root=a.dir=c,a):(a.base=a.name=c,a);if(t(u)){if(o=1,t(c.charCodeAt(1))){let A=2,L=A;for(;A<l&&!t(c.charCodeAt(A));)A++;if(A<l&&A!==L){for(L=A;A<l&&t(c.charCodeAt(A));)A++;if(A<l&&A!==L){for(L=A;A<l&&!t(c.charCodeAt(A));)A++;A===l?o=A:A!==L&&(o=A+1)}}}}else if(v(u)&&c.charCodeAt(1)===y){if(l<=2)return a.root=a.dir=c,a;if(o=2,t(c.charCodeAt(2))){if(l===3)return a.root=a.dir=c,a;o=3}}o>0&&(a.root=c.slice(0,o));let r=-1,i=o,s=-1,h=!0,w=c.length-1,M=0;for(;w>=o;--w){if(u=c.charCodeAt(w),t(u)){if(!h){i=w+1;break}continue}s===-1&&(h=!1,s=w+1),u===I?r===-1?r=w:M!==1&&(M=1):r!==-1&&(M=-1)}return s!==-1&&(r===-1||M===0||M===1&&r===s-1&&r===i+1?a.base=a.name=c.slice(i,s):(a.name=c.slice(i,r),a.base=c.slice(i,s),a.ext=c.slice(r,s))),i>0&&i!==o?a.dir=c.slice(0,i-1):a.dir=a.root,a},sep:"\\",delimiter:";",win32:null,posix:null},e.posix={resolve(...c){let a="",l=!1;for(let o=c.length-1;o>=-1&&!l;o--){const u=o>=0?c[o]:p.cwd();S(u,"path"),u.length!==0&&(a=`${u}/${a}`,l=u.charCodeAt(0)===d)}return a=b(a,!l,"/",m),l?`/${a}`:a.length>0?a:"."},normalize(c){if(S(c,"path"),c.length===0)return".";const a=c.charCodeAt(0)===d,l=c.charCodeAt(c.length-1)===d;return c=b(c,!a,"/",m),c.length===0?a?"/":l?"./":".":(l&&(c+="/"),a?`/${c}`:c)},isAbsolute(c){return S(c,"path"),c.length>0&&c.charCodeAt(0)===d},join(...c){if(c.length===0)return".";let a;for(let l=0;l<c.length;++l){const o=c[l];S(o,"path"),o.length>0&&(a===void 0?a=o:a+=`/${o}`)}return a===void 0?".":e.posix.normalize(a)},relative(c,a){if(S(c,"from"),S(a,"to"),c===a||(c=e.posix.resolve(c),a=e.posix.resolve(a),c===a))return"";const l=1,o=c.length,u=o-l,r=1,i=a.length-r,s=u<i?u:i;let h=-1,w=0;for(;w<s;w++){const A=c.charCodeAt(l+w);if(A!==a.charCodeAt(r+w))break;A===d&&(h=w)}if(w===s)if(i>s){if(a.charCodeAt(r+w)===d)return a.slice(r+w+1);if(w===0)return a.slice(r+w)}else u>s&&(c.charCodeAt(l+w)===d?h=w:w===0&&(h=0));let M="";for(w=l+h+1;w<=o;++w)(w===o||c.charCodeAt(w)===d)&&(M+=M.length===0?"..":"/..");return`${M}${a.slice(r+h)}`},toNamespacedPath(c){return c},dirname(c){if(S(c,"path"),c.length===0)return".";const a=c.charCodeAt(0)===d;let l=-1,o=!0;for(let u=c.length-1;u>=1;--u)if(c.charCodeAt(u)===d){if(!o){l=u;break}}else o=!1;return l===-1?a?"/":".":a&&l===1?"//":c.slice(0,l)},basename(c,a){a!==void 0&&S(a,"ext"),S(c,"path");let l=0,o=-1,u=!0,r;if(a!==void 0&&a.length>0&&a.length<=c.length){if(a===c)return"";let i=a.length-1,s=-1;for(r=c.length-1;r>=0;--r){const h=c.charCodeAt(r);if(h===d){if(!u){l=r+1;break}}else s===-1&&(u=!1,s=r+1),i>=0&&(h===a.charCodeAt(i)?--i==-1&&(o=r):(i=-1,o=s))}return l===o?o=s:o===-1&&(o=c.length),c.slice(l,o)}for(r=c.length-1;r>=0;--r)if(c.charCodeAt(r)===d){if(!u){l=r+1;break}}else o===-1&&(u=!1,o=r+1);return o===-1?"":c.slice(l,o)},extname(c){S(c,"path");let a=-1,l=0,o=-1,u=!0,r=0;for(let i=c.length-1;i>=0;--i){const s=c.charCodeAt(i);if(s===d){if(!u){l=i+1;break}continue}o===-1&&(u=!1,o=i+1),s===I?a===-1?a=i:r!==1&&(r=1):a!==-1&&(r=-1)}return a===-1||o===-1||r===0||r===1&&a===o-1&&a===l+1?"":c.slice(a,o)},format:P.bind(null,"/"),parse(c){S(c,"path");const a={root:"",dir:"",base:"",ext:"",name:""};if(c.length===0)return a;const l=c.charCodeAt(0)===d;let o;l?(a.root="/",o=1):o=0;let u=-1,r=0,i=-1,s=!0,h=c.length-1,w=0;for(;h>=o;--h){const M=c.charCodeAt(h);if(M===d){if(!s){r=h+1;break}continue}i===-1&&(s=!1,i=h+1),M===I?u===-1?u=h:w!==1&&(w=1):u!==-1&&(w=-1)}if(i!==-1){const M=r===0&&l?1:r;u===-1||w===0||w===1&&u===i-1&&u===r+1?a.base=a.name=c.slice(M,i):(a.name=c.slice(M,u),a.base=c.slice(M,i),a.ext=c.slice(u,i))}return r>0?a.dir=c.slice(0,r-1):l&&(a.dir="/"),a},sep:"/",delimiter:":",win32:null,posix:null},e.posix.win32=e.win32.win32=e.win32,e.posix.posix=e.win32.posix=e.posix,e.normalize=p.platform==="win32"?e.win32.normalize:e.posix.normalize,e.isAbsolute=p.platform==="win32"?e.win32.isAbsolute:e.posix.isAbsolute,e.join=p.platform==="win32"?e.win32.join:e.posix.join,e.resolve=p.platform==="win32"?e.win32.resolve:e.posix.resolve,e.relative=p.platform==="win32"?e.win32.relative:e.posix.relative,e.dirname=p.platform==="win32"?e.win32.dirname:e.posix.dirname,e.basename=p.platform==="win32"?e.win32.basename:e.posix.basename,e.extname=p.platform==="win32"?e.win32.extname:e.posix.extname,e.format=p.platform==="win32"?e.win32.format:e.posix.format,e.parse=p.platform==="win32"?e.win32.parse:e.posix.parse,e.toNamespacedPath=p.platform==="win32"?e.win32.toNamespacedPath:e.posix.toNamespacedPath,e.sep=p.platform==="win32"?e.win32.sep:e.posix.sep,e.delimiter=p.platform==="win32"?e.win32.delimiter:e.posix.delimiter}),define(x[80],ee([0,1]),function(V,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.sanitizeProcessEnvironment=e.TerminateResponseCode=e.Source=void 0;var p;(function(k){k[k.stdout=0]="stdout",k[k.stderr=1]="stderr"})(p=e.Source||(e.Source={}));var R;(function(k){k[k.Success=0]="Success",k[k.Unknown=1]="Unknown",k[k.AccessDenied=2]="AccessDenied",k[k.ProcessNotFound=3]="ProcessNotFound"})(R=e.TerminateResponseCode||(e.TerminateResponseCode={}));function C(k,...n){const I=n.reduce((y,E)=>(y[E]=!0,y),{}),d=[/^ELECTRON_.+$/,/^VSCODE_.+$/,/^SNAP(|_.*)$/,/^GDK_PIXBUF_.+$/];Object.keys(k).filter(y=>!I[y]).forEach(y=>{for(let E=0;E<d.length;E++)if(y.search(d[E])!==-1){delete k[y];break}})}e.sanitizeProcessEnvironment=C}),define(x[108],ee([0,1,3]),function(V,e,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StopWatch=void 0;const R=p.globals.performance&&typeof p.globals.performance.now=="function";class C{constructor(n){this._highResolution=R&&n,this._startTime=this._now(),this._stopTime=-1}static create(n=!0){return new C(n)}stop(){this._stopTime=this._now()}elapsed(){return this._stopTime!==-1?this._stopTime-this._startTime:this._now()-this._startTime}_now(){return this._highResolution?p.globals.performance.now():Date.now()}}e.StopWatch=C}),define(x[4],ee([0,1,16,42,2,107,108]),function(V,e,p,R,C,k,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Relay=e.EventBufferer=e.EventMultiplexer=e.MicrotaskEmitter=e.DebounceEmitter=e.PauseableEmitter=e.AsyncEmitter=e.Emitter=e.setGlobalLeakWarningThreshold=e.Event=void 0;var I;(function(a){a.None=()=>C.Disposable.None;function l(W){return(N,G=null,Q)=>{let H=!1,$;return $=W(J=>{if(!H)return $?$.dispose():H=!0,N.call(G,J)},null,Q),H&&$.dispose(),$}}a.once=l;function o(W,N){return w((G,Q=null,H)=>W($=>G.call(Q,N($)),null,H))}a.map=o;function u(W,N){return w((G,Q=null,H)=>W($=>{N($),G.call(Q,$)},null,H))}a.forEach=u;function r(W,N){return w((G,Q=null,H)=>W($=>N($)&&G.call(Q,$),null,H))}a.filter=r;function i(W){return W}a.signal=i;function s(...W){return(N,G=null,Q)=>(0,C.combinedDisposable)(...W.map(H=>H($=>N.call(G,$),null,Q)))}a.any=s;function h(W,N,G){let Q=G;return o(W,H=>(Q=N(Q,H),Q))}a.reduce=h;function w(W){let N;const G=new g({onFirstListenerAdd(){N=W(G.fire,G)},onLastListenerRemove(){N.dispose()}});return G.event}function M(W,N,G=100,Q=!1,H){let $,J,O,D=0;const T=new g({leakWarningThreshold:H,onFirstListenerAdd(){$=W(_=>{D++,J=N(J,_),Q&&!O&&(T.fire(J),J=void 0),clearTimeout(O),O=setTimeout(()=>{const z=J;J=void 0,O=void 0,(!Q||D>1)&&T.fire(z),D=0},G)})},onLastListenerRemove(){$.dispose()}});return T.event}a.debounce=M;function A(W,N=(G,Q)=>G===Q){let G=!0,Q;return r(W,H=>{const $=G||!N(H,Q);return G=!1,Q=H,$})}a.latch=A;function L(W,N){return[a.filter(W,N),a.filter(W,G=>!N(G))]}a.split=L;function F(W,N=!1,G=[]){let Q=G.slice(),H=W(O=>{Q?Q.push(O):J.fire(O)});const $=()=>{Q&&Q.forEach(O=>J.fire(O)),Q=null},J=new g({onFirstListenerAdd(){H||(H=W(O=>J.fire(O)))},onFirstListenerDidAdd(){Q&&(N?setTimeout($):$())},onLastListenerRemove(){H&&H.dispose(),H=null}});return J.event}a.buffer=F;class U{constructor(N){this.event=N}map(N){return new U(o(this.event,N))}forEach(N){return new U(u(this.event,N))}filter(N){return new U(r(this.event,N))}reduce(N,G){return new U(h(this.event,N,G))}latch(){return new U(A(this.event))}debounce(N,G=100,Q=!1,H){return new U(M(this.event,N,G,Q,H))}on(N,G,Q){return this.event(N,G,Q)}once(N,G,Q){return l(this.event)(N,G,Q)}}function Y(W){return new U(W)}a.chain=Y;function ie(W,N,G=Q=>Q){const Q=(...O)=>J.fire(G(...O)),H=()=>W.on(N,Q),$=()=>W.removeListener(N,Q),J=new g({onFirstListenerAdd:H,onLastListenerRemove:$});return J.event}a.fromNodeEventEmitter=ie;function re(W,N,G=Q=>Q){const Q=(...O)=>J.fire(G(...O)),H=()=>W.addEventListener(N,Q),$=()=>W.removeEventListener(N,Q),J=new g({onFirstListenerAdd:H,onLastListenerRemove:$});return J.event}a.fromDOMEventEmitter=re;function K(W){return new Promise(N=>l(W)(N))}a.toPromise=K})(I=e.Event||(e.Event={}));class d{constructor(l){this._listenerCount=0,this._invocationCount=0,this._elapsedOverall=0,this._name=`${l}_${d._idPool++}`}start(l){this._stopWatch=new n.StopWatch(!0),this._listenerCount=l}stop(){if(this._stopWatch){const l=this._stopWatch.elapsed();this._elapsedOverall+=l,this._invocationCount+=1,console.info(`did FIRE ${this._name}: elapsed_ms: ${l.toFixed(5)}, listener: ${this._listenerCount} (elapsed_overall: ${this._elapsedOverall.toFixed(2)}, invocations: ${this._invocationCount})`),this._stopWatch=void 0}}}d._idPool=0;let f=-1;function y(a){const l=f;return f=a,{dispose(){f=l}}}e.setGlobalLeakWarningThreshold=y;class E{constructor(l,o=Math.random().toString(18).slice(2,5)){this.customThreshold=l,this.name=o,this._warnCountdown=0}dispose(){this._stacks&&this._stacks.clear()}check(l){let o=f;if(typeof this.customThreshold=="number"&&(o=this.customThreshold),o<=0||l<o)return;this._stacks||(this._stacks=new Map);const u=new Error().stack.split(`
`).slice(3).join(`
`),r=this._stacks.get(u)||0;if(this._stacks.set(u,r+1),this._warnCountdown-=1,this._warnCountdown<=0){this._warnCountdown=o*.5;let i,s=0;for(const[h,w]of this._stacks)(!i||s<w)&&(i=h,s=w);console.warn(`[${this.name}] potential listener LEAK detected, having ${l} listeners already. MOST frequent listener (${s}):`),console.warn(i)}return()=>{const i=this._stacks.get(u)||0;this._stacks.set(u,i-1)}}}class g{constructor(l){this._disposed=!1,this._options=l,this._leakageMon=f>0?new E(this._options&&this._options.leakWarningThreshold):void 0,this._perfMon=this._options?._profName?new d(this._options._profName):void 0}get event(){return this._event||(this._event=(l,o,u)=>{this._listeners||(this._listeners=new k.LinkedList);const r=this._listeners.isEmpty();r&&this._options&&this._options.onFirstListenerAdd&&this._options.onFirstListenerAdd(this);const i=this._listeners.push(o?[l,o]:l);r&&this._options&&this._options.onFirstListenerDidAdd&&this._options.onFirstListenerDidAdd(this),this._options&&this._options.onListenerDidAdd&&this._options.onListenerDidAdd(this,l,o);const s=this._leakageMon?.check(this._listeners.size),h=(0,C.toDisposable)(()=>{s&&s(),this._disposed||(i(),this._options&&this._options.onLastListenerRemove&&(this._listeners&&!this._listeners.isEmpty()||this._options.onLastListenerRemove(this)))});return u instanceof C.DisposableStore?u.add(h):Array.isArray(u)&&u.push(h),h}),this._event}fire(l){if(this._listeners){this._deliveryQueue||(this._deliveryQueue=new k.LinkedList);for(let o of this._listeners)this._deliveryQueue.push([o,l]);for(this._perfMon?.start(this._deliveryQueue.size);this._deliveryQueue.size>0;){const[o,u]=this._deliveryQueue.shift();try{typeof o=="function"?o.call(void 0,u):o[0].call(o[1],u)}catch(r){(0,p.onUnexpectedError)(r)}}this._perfMon?.stop()}}dispose(){this._disposed||(this._disposed=!0,this._listeners?.clear(),this._deliveryQueue?.clear(),this._options?.onLastListenerRemove?.(),this._leakageMon?.dispose())}}e.Emitter=g;class S extends g{async fireAsync(l,o,u){if(!!this._listeners){this._asyncDeliveryQueue||(this._asyncDeliveryQueue=new k.LinkedList);for(const r of this._listeners)this._asyncDeliveryQueue.push([r,l]);for(;this._asyncDeliveryQueue.size>0&&!o.isCancellationRequested;){const[r,i]=this._asyncDeliveryQueue.shift(),s=[],h={...i,waitUntil:w=>{if(Object.isFrozen(s))throw new Error("waitUntil can NOT be called asynchronous");u&&(w=u(w,typeof r=="function"?r:r[0])),s.push(w)}};try{typeof r=="function"?r.call(void 0,h):r[0].call(r[1],h)}catch(w){(0,p.onUnexpectedError)(w);continue}Object.freeze(s),await Promise.allSettled(s).then(w=>{for(const M of w)M.status==="rejected"&&(0,p.onUnexpectedError)(M.reason)})}}}}e.AsyncEmitter=S;class t extends g{constructor(l){super(l);this._isPaused=0,this._eventQueue=new k.LinkedList,this._mergeFn=l?.merge}pause(){this._isPaused++}resume(){if(this._isPaused!==0&&--this._isPaused==0)if(this._mergeFn){const l=Array.from(this._eventQueue);this._eventQueue.clear(),super.fire(this._mergeFn(l))}else for(;!this._isPaused&&this._eventQueue.size!==0;)super.fire(this._eventQueue.shift())}fire(l){this._listeners&&(this._isPaused!==0?this._eventQueue.push(l):super.fire(l))}}e.PauseableEmitter=t;class m extends t{constructor(l){super(l);this._delay=l.delay??100}fire(l){this._handle||(this.pause(),this._handle=setTimeout(()=>{this._handle=void 0,this.resume()},this._delay)),super.fire(l)}}e.DebounceEmitter=m;class v extends g{constructor(l){super(l);this._queuedEvents=[],this._mergeFn=l?.merge}fire(l){this._queuedEvents.push(l),this._queuedEvents.length===1&&queueMicrotask(()=>{this._mergeFn?super.fire(this._mergeFn(this._queuedEvents)):this._queuedEvents.forEach(o=>super.fire(o)),this._queuedEvents=[]})}}e.MicrotaskEmitter=v;class b{constructor(){this.hasListeners=!1,this.events=[],this.emitter=new g({onFirstListenerAdd:()=>this.onFirstListenerAdd(),onLastListenerRemove:()=>this.onLastListenerRemove()})}get event(){return this.emitter.event}add(l){const o={event:l,listener:null};this.events.push(o),this.hasListeners&&this.hook(o);const u=()=>{this.hasListeners&&this.unhook(o);const r=this.events.indexOf(o);this.events.splice(r,1)};return(0,C.toDisposable)((0,R.once)(u))}onFirstListenerAdd(){this.hasListeners=!0,this.events.forEach(l=>this.hook(l))}onLastListenerRemove(){this.hasListeners=!1,this.events.forEach(l=>this.unhook(l))}hook(l){l.listener=l.event(o=>this.emitter.fire(o))}unhook(l){l.listener&&l.listener.dispose(),l.listener=null}dispose(){this.emitter.dispose()}}e.EventMultiplexer=b;class P{constructor(){this.buffers=[]}wrapEvent(l){return(o,u,r)=>l(i=>{const s=this.buffers[this.buffers.length-1];s?s.push(()=>o.call(u,i)):o.call(u,i)},void 0,r)}bufferEvents(l){const o=[];this.buffers.push(o);const u=l();return this.buffers.pop(),o.forEach(r=>r()),u}}e.EventBufferer=P;class c{constructor(){this.listening=!1,this.inputEvent=I.None,this.inputEventListener=C.Disposable.None,this.emitter=new g({onFirstListenerDidAdd:()=>{this.listening=!0,this.inputEventListener=this.inputEvent(this.emitter.fire,this.emitter)},onLastListenerRemove:()=>{this.listening=!1,this.inputEventListener.dispose()}}),this.event=this.emitter.event}set input(l){this.inputEvent=l,this.listening&&(this.inputEventListener.dispose(),this.inputEventListener=l(this.emitter.fire,this.emitter))}dispose(){this.inputEventListener.dispose(),this.emitter.dispose()}}e.Relay=c}),define(x[23],ee([0,1,4]),function(V,e,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CancellationTokenSource=e.CancellationToken=void 0;const R=Object.freeze(function(I,d){const f=setTimeout(I.bind(d),0);return{dispose(){clearTimeout(f)}}});var C;(function(I){function d(f){return f===I.None||f===I.Cancelled||f instanceof k?!0:!f||typeof f!="object"?!1:typeof f.isCancellationRequested=="boolean"&&typeof f.onCancellationRequested=="function"}I.isCancellationToken=d,I.None=Object.freeze({isCancellationRequested:!1,onCancellationRequested:p.Event.None}),I.Cancelled=Object.freeze({isCancellationRequested:!0,onCancellationRequested:R})})(C=e.CancellationToken||(e.CancellationToken={}));class k{constructor(){this._isCancelled=!1,this._emitter=null}cancel(){this._isCancelled||(this._isCancelled=!0,this._emitter&&(this._emitter.fire(void 0),this.dispose()))}get isCancellationRequested(){return this._isCancelled}get onCancellationRequested(){return this._isCancelled?R:(this._emitter||(this._emitter=new p.Emitter),this._emitter.event)}dispose(){this._emitter&&(this._emitter.dispose(),this._emitter=null)}}class n{constructor(d){this._token=void 0,this._parentListener=void 0,this._parentListener=d&&d.onCancellationRequested(this.cancel,this)}get token(){return this._token||(this._token=new k),this._token}cancel(){this._token?this._token instanceof k&&this._token.cancel():this._token=C.Cancelled}dispose(d=!1){d&&this.cancel(),this._parentListener&&this._parentListener.dispose(),this._token?this._token instanceof k&&this._token.dispose():this._token=C.None}}e.CancellationTokenSource=n}),define(x[109],ee([0,1,4]),function(V,e,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CSSIcon=e.getClassNamesArray=e.Codicon=e.getCodiconAriaLabel=e.iconRegistry=void 0;class R{constructor(){this._icons=new Map,this._onDidRegister=new p.Emitter}add(y){const E=this._icons.get(y.id);E?y.description?E.description=y.description:console.error(`Duplicate registration of codicon ${y.id}`):(this._icons.set(y.id,y),this._onDidRegister.fire(y))}get(y){return this._icons.get(y)}get all(){return this._icons.values()}get onDidRegister(){return this._onDidRegister.event}}const C=new R;e.iconRegistry=C;function k(f){return f?f.replace(/\$\((.*?)\)/g,(y,E)=>` ${E} `).trim():""}e.getCodiconAriaLabel=k;class n{constructor(y,E,g){this.id=y,this.definition=E,this.description=g,C.add(this)}get classNames(){return"codicon codicon-"+this.id}get classNamesArray(){return["codicon","codicon-"+this.id]}get cssSelector(){return".codicon.codicon-"+this.id}}e.Codicon=n,n.add=new n("add",{fontCharacter:"\\ea60"}),n.plus=new n("plus",n.add.definition),n.gistNew=new n("gist-new",n.add.definition),n.repoCreate=new n("repo-create",n.add.definition),n.lightbulb=new n("lightbulb",{fontCharacter:"\\ea61"}),n.lightBulb=new n("light-bulb",{fontCharacter:"\\ea61"}),n.repo=new n("repo",{fontCharacter:"\\ea62"}),n.repoDelete=new n("repo-delete",{fontCharacter:"\\ea62"}),n.gistFork=new n("gist-fork",{fontCharacter:"\\ea63"}),n.repoForked=new n("repo-forked",{fontCharacter:"\\ea63"}),n.gitPullRequest=new n("git-pull-request",{fontCharacter:"\\ea64"}),n.gitPullRequestAbandoned=new n("git-pull-request-abandoned",{fontCharacter:"\\ea64"}),n.recordKeys=new n("record-keys",{fontCharacter:"\\ea65"}),n.keyboard=new n("keyboard",{fontCharacter:"\\ea65"}),n.tag=new n("tag",{fontCharacter:"\\ea66"}),n.tagAdd=new n("tag-add",{fontCharacter:"\\ea66"}),n.tagRemove=new n("tag-remove",{fontCharacter:"\\ea66"}),n.person=new n("person",{fontCharacter:"\\ea67"}),n.personFollow=new n("person-follow",{fontCharacter:"\\ea67"}),n.personOutline=new n("person-outline",{fontCharacter:"\\ea67"}),n.personFilled=new n("person-filled",{fontCharacter:"\\ea67"}),n.gitBranch=new n("git-branch",{fontCharacter:"\\ea68"}),n.gitBranchCreate=new n("git-branch-create",{fontCharacter:"\\ea68"}),n.gitBranchDelete=new n("git-branch-delete",{fontCharacter:"\\ea68"}),n.sourceControl=new n("source-control",{fontCharacter:"\\ea68"}),n.mirror=new n("mirror",{fontCharacter:"\\ea69"}),n.mirrorPublic=new n("mirror-public",{fontCharacter:"\\ea69"}),n.star=new n("star",{fontCharacter:"\\ea6a"}),n.starAdd=new n("star-add",{fontCharacter:"\\ea6a"}),n.starDelete=new n("star-delete",{fontCharacter:"\\ea6a"}),n.starEmpty=new n("star-empty",{fontCharacter:"\\ea6a"}),n.comment=new n("comment",{fontCharacter:"\\ea6b"}),n.commentAdd=new n("comment-add",{fontCharacter:"\\ea6b"}),n.alert=new n("alert",{fontCharacter:"\\ea6c"}),n.warning=new n("warning",{fontCharacter:"\\ea6c"}),n.search=new n("search",{fontCharacter:"\\ea6d"}),n.searchSave=new n("search-save",{fontCharacter:"\\ea6d"}),n.logOut=new n("log-out",{fontCharacter:"\\ea6e"}),n.signOut=new n("sign-out",{fontCharacter:"\\ea6e"}),n.logIn=new n("log-in",{fontCharacter:"\\ea6f"}),n.signIn=new n("sign-in",{fontCharacter:"\\ea6f"}),n.eye=new n("eye",{fontCharacter:"\\ea70"}),n.eyeUnwatch=new n("eye-unwatch",{fontCharacter:"\\ea70"}),n.eyeWatch=new n("eye-watch",{fontCharacter:"\\ea70"}),n.circleFilled=new n("circle-filled",{fontCharacter:"\\ea71"}),n.primitiveDot=new n("primitive-dot",{fontCharacter:"\\ea71"}),n.closeDirty=new n("close-dirty",{fontCharacter:"\\ea71"}),n.debugBreakpoint=new n("debug-breakpoint",{fontCharacter:"\\ea71"}),n.debugBreakpointDisabled=new n("debug-breakpoint-disabled",{fontCharacter:"\\ea71"}),n.debugHint=new n("debug-hint",{fontCharacter:"\\ea71"}),n.primitiveSquare=new n("primitive-square",{fontCharacter:"\\ea72"}),n.edit=new n("edit",{fontCharacter:"\\ea73"}),n.pencil=new n("pencil",{fontCharacter:"\\ea73"}),n.info=new n("info",{fontCharacter:"\\ea74"}),n.issueOpened=new n("issue-opened",{fontCharacter:"\\ea74"}),n.gistPrivate=new n("gist-private",{fontCharacter:"\\ea75"}),n.gitForkPrivate=new n("git-fork-private",{fontCharacter:"\\ea75"}),n.lock=new n("lock",{fontCharacter:"\\ea75"}),n.mirrorPrivate=new n("mirror-private",{fontCharacter:"\\ea75"}),n.close=new n("close",{fontCharacter:"\\ea76"}),n.removeClose=new n("remove-close",{fontCharacter:"\\ea76"}),n.x=new n("x",{fontCharacter:"\\ea76"}),n.repoSync=new n("repo-sync",{fontCharacter:"\\ea77"}),n.sync=new n("sync",{fontCharacter:"\\ea77"}),n.clone=new n("clone",{fontCharacter:"\\ea78"}),n.desktopDownload=new n("desktop-download",{fontCharacter:"\\ea78"}),n.beaker=new n("beaker",{fontCharacter:"\\ea79"}),n.microscope=new n("microscope",{fontCharacter:"\\ea79"}),n.vm=new n("vm",{fontCharacter:"\\ea7a"}),n.deviceDesktop=new n("device-desktop",{fontCharacter:"\\ea7a"}),n.file=new n("file",{fontCharacter:"\\ea7b"}),n.fileText=new n("file-text",{fontCharacter:"\\ea7b"}),n.more=new n("more",{fontCharacter:"\\ea7c"}),n.ellipsis=new n("ellipsis",{fontCharacter:"\\ea7c"}),n.kebabHorizontal=new n("kebab-horizontal",{fontCharacter:"\\ea7c"}),n.mailReply=new n("mail-reply",{fontCharacter:"\\ea7d"}),n.reply=new n("reply",{fontCharacter:"\\ea7d"}),n.organization=new n("organization",{fontCharacter:"\\ea7e"}),n.organizationFilled=new n("organization-filled",{fontCharacter:"\\ea7e"}),n.organizationOutline=new n("organization-outline",{fontCharacter:"\\ea7e"}),n.newFile=new n("new-file",{fontCharacter:"\\ea7f"}),n.fileAdd=new n("file-add",{fontCharacter:"\\ea7f"}),n.newFolder=new n("new-folder",{fontCharacter:"\\ea80"}),n.fileDirectoryCreate=new n("file-directory-create",{fontCharacter:"\\ea80"}),n.trash=new n("trash",{fontCharacter:"\\ea81"}),n.trashcan=new n("trashcan",{fontCharacter:"\\ea81"}),n.history=new n("history",{fontCharacter:"\\ea82"}),n.clock=new n("clock",{fontCharacter:"\\ea82"}),n.folder=new n("folder",{fontCharacter:"\\ea83"}),n.fileDirectory=new n("file-directory",{fontCharacter:"\\ea83"}),n.symbolFolder=new n("symbol-folder",{fontCharacter:"\\ea83"}),n.logoGithub=new n("logo-github",{fontCharacter:"\\ea84"}),n.markGithub=new n("mark-github",{fontCharacter:"\\ea84"}),n.github=new n("github",{fontCharacter:"\\ea84"}),n.terminal=new n("terminal",{fontCharacter:"\\ea85"}),n.console=new n("console",{fontCharacter:"\\ea85"}),n.repl=new n("repl",{fontCharacter:"\\ea85"}),n.zap=new n("zap",{fontCharacter:"\\ea86"}),n.symbolEvent=new n("symbol-event",{fontCharacter:"\\ea86"}),n.error=new n("error",{fontCharacter:"\\ea87"}),n.stop=new n("stop",{fontCharacter:"\\ea87"}),n.variable=new n("variable",{fontCharacter:"\\ea88"}),n.symbolVariable=new n("symbol-variable",{fontCharacter:"\\ea88"}),n.array=new n("array",{fontCharacter:"\\ea8a"}),n.symbolArray=new n("symbol-array",{fontCharacter:"\\ea8a"}),n.symbolModule=new n("symbol-module",{fontCharacter:"\\ea8b"}),n.symbolPackage=new n("symbol-package",{fontCharacter:"\\ea8b"}),n.symbolNamespace=new n("symbol-namespace",{fontCharacter:"\\ea8b"}),n.symbolObject=new n("symbol-object",{fontCharacter:"\\ea8b"}),n.symbolMethod=new n("symbol-method",{fontCharacter:"\\ea8c"}),n.symbolFunction=new n("symbol-function",{fontCharacter:"\\ea8c"}),n.symbolConstructor=new n("symbol-constructor",{fontCharacter:"\\ea8c"}),n.symbolBoolean=new n("symbol-boolean",{fontCharacter:"\\ea8f"}),n.symbolNull=new n("symbol-null",{fontCharacter:"\\ea8f"}),n.symbolNumeric=new n("symbol-numeric",{fontCharacter:"\\ea90"}),n.symbolNumber=new n("symbol-number",{fontCharacter:"\\ea90"}),n.symbolStructure=new n("symbol-structure",{fontCharacter:"\\ea91"}),n.symbolStruct=new n("symbol-struct",{fontCharacter:"\\ea91"}),n.symbolParameter=new n("symbol-parameter",{fontCharacter:"\\ea92"}),n.symbolTypeParameter=new n("symbol-type-parameter",{fontCharacter:"\\ea92"}),n.symbolKey=new n("symbol-key",{fontCharacter:"\\ea93"}),n.symbolText=new n("symbol-text",{fontCharacter:"\\ea93"}),n.symbolReference=new n("symbol-reference",{fontCharacter:"\\ea94"}),n.goToFile=new n("go-to-file",{fontCharacter:"\\ea94"}),n.symbolEnum=new n("symbol-enum",{fontCharacter:"\\ea95"}),n.symbolValue=new n("symbol-value",{fontCharacter:"\\ea95"}),n.symbolRuler=new n("symbol-ruler",{fontCharacter:"\\ea96"}),n.symbolUnit=new n("symbol-unit",{fontCharacter:"\\ea96"}),n.activateBreakpoints=new n("activate-breakpoints",{fontCharacter:"\\ea97"}),n.archive=new n("archive",{fontCharacter:"\\ea98"}),n.arrowBoth=new n("arrow-both",{fontCharacter:"\\ea99"}),n.arrowDown=new n("arrow-down",{fontCharacter:"\\ea9a"}),n.arrowLeft=new n("arrow-left",{fontCharacter:"\\ea9b"}),n.arrowRight=new n("arrow-right",{fontCharacter:"\\ea9c"}),n.arrowSmallDown=new n("arrow-small-down",{fontCharacter:"\\ea9d"}),n.arrowSmallLeft=new n("arrow-small-left",{fontCharacter:"\\ea9e"}),n.arrowSmallRight=new n("arrow-small-right",{fontCharacter:"\\ea9f"}),n.arrowSmallUp=new n("arrow-small-up",{fontCharacter:"\\eaa0"}),n.arrowUp=new n("arrow-up",{fontCharacter:"\\eaa1"}),n.bell=new n("bell",{fontCharacter:"\\eaa2"}),n.bold=new n("bold",{fontCharacter:"\\eaa3"}),n.book=new n("book",{fontCharacter:"\\eaa4"}),n.bookmark=new n("bookmark",{fontCharacter:"\\eaa5"}),n.debugBreakpointConditionalUnverified=new n("debug-breakpoint-conditional-unverified",{fontCharacter:"\\eaa6"}),n.debugBreakpointConditional=new n("debug-breakpoint-conditional",{fontCharacter:"\\eaa7"}),n.debugBreakpointConditionalDisabled=new n("debug-breakpoint-conditional-disabled",{fontCharacter:"\\eaa7"}),n.debugBreakpointDataUnverified=new n("debug-breakpoint-data-unverified",{fontCharacter:"\\eaa8"}),n.debugBreakpointData=new n("debug-breakpoint-data",{fontCharacter:"\\eaa9"}),n.debugBreakpointDataDisabled=new n("debug-breakpoint-data-disabled",{fontCharacter:"\\eaa9"}),n.debugBreakpointLogUnverified=new n("debug-breakpoint-log-unverified",{fontCharacter:"\\eaaa"}),n.debugBreakpointLog=new n("debug-breakpoint-log",{fontCharacter:"\\eaab"}),n.debugBreakpointLogDisabled=new n("debug-breakpoint-log-disabled",{fontCharacter:"\\eaab"}),n.briefcase=new n("briefcase",{fontCharacter:"\\eaac"}),n.broadcast=new n("broadcast",{fontCharacter:"\\eaad"}),n.browser=new n("browser",{fontCharacter:"\\eaae"}),n.bug=new n("bug",{fontCharacter:"\\eaaf"}),n.calendar=new n("calendar",{fontCharacter:"\\eab0"}),n.caseSensitive=new n("case-sensitive",{fontCharacter:"\\eab1"}),n.check=new n("check",{fontCharacter:"\\eab2"}),n.checklist=new n("checklist",{fontCharacter:"\\eab3"}),n.chevronDown=new n("chevron-down",{fontCharacter:"\\eab4"}),n.dropDownButton=new n("drop-down-button",n.chevronDown.definition),n.chevronLeft=new n("chevron-left",{fontCharacter:"\\eab5"}),n.chevronRight=new n("chevron-right",{fontCharacter:"\\eab6"}),n.chevronUp=new n("chevron-up",{fontCharacter:"\\eab7"}),n.chromeClose=new n("chrome-close",{fontCharacter:"\\eab8"}),n.chromeMaximize=new n("chrome-maximize",{fontCharacter:"\\eab9"}),n.chromeMinimize=new n("chrome-minimize",{fontCharacter:"\\eaba"}),n.chromeRestore=new n("chrome-restore",{fontCharacter:"\\eabb"}),n.circleOutline=new n("circle-outline",{fontCharacter:"\\eabc"}),n.debugBreakpointUnverified=new n("debug-breakpoint-unverified",{fontCharacter:"\\eabc"}),n.circleSlash=new n("circle-slash",{fontCharacter:"\\eabd"}),n.circuitBoard=new n("circuit-board",{fontCharacter:"\\eabe"}),n.clearAll=new n("clear-all",{fontCharacter:"\\eabf"}),n.clippy=new n("clippy",{fontCharacter:"\\eac0"}),n.closeAll=new n("close-all",{fontCharacter:"\\eac1"}),n.cloudDownload=new n("cloud-download",{fontCharacter:"\\eac2"}),n.cloudUpload=new n("cloud-upload",{fontCharacter:"\\eac3"}),n.code=new n("code",{fontCharacter:"\\eac4"}),n.collapseAll=new n("collapse-all",{fontCharacter:"\\eac5"}),n.colorMode=new n("color-mode",{fontCharacter:"\\eac6"}),n.commentDiscussion=new n("comment-discussion",{fontCharacter:"\\eac7"}),n.compareChanges=new n("compare-changes",{fontCharacter:"\\eafd"}),n.creditCard=new n("credit-card",{fontCharacter:"\\eac9"}),n.dash=new n("dash",{fontCharacter:"\\eacc"}),n.dashboard=new n("dashboard",{fontCharacter:"\\eacd"}),n.database=new n("database",{fontCharacter:"\\eace"}),n.debugContinue=new n("debug-continue",{fontCharacter:"\\eacf"}),n.debugDisconnect=new n("debug-disconnect",{fontCharacter:"\\ead0"}),n.debugPause=new n("debug-pause",{fontCharacter:"\\ead1"}),n.debugRestart=new n("debug-restart",{fontCharacter:"\\ead2"}),n.debugStart=new n("debug-start",{fontCharacter:"\\ead3"}),n.debugStepInto=new n("debug-step-into",{fontCharacter:"\\ead4"}),n.debugStepOut=new n("debug-step-out",{fontCharacter:"\\ead5"}),n.debugStepOver=new n("debug-step-over",{fontCharacter:"\\ead6"}),n.debugStop=new n("debug-stop",{fontCharacter:"\\ead7"}),n.debug=new n("debug",{fontCharacter:"\\ead8"}),n.deviceCameraVideo=new n("device-camera-video",{fontCharacter:"\\ead9"}),n.deviceCamera=new n("device-camera",{fontCharacter:"\\eada"}),n.deviceMobile=new n("device-mobile",{fontCharacter:"\\eadb"}),n.diffAdded=new n("diff-added",{fontCharacter:"\\eadc"}),n.diffIgnored=new n("diff-ignored",{fontCharacter:"\\eadd"}),n.diffModified=new n("diff-modified",{fontCharacter:"\\eade"}),n.diffRemoved=new n("diff-removed",{fontCharacter:"\\eadf"}),n.diffRenamed=new n("diff-renamed",{fontCharacter:"\\eae0"}),n.diff=new n("diff",{fontCharacter:"\\eae1"}),n.discard=new n("discard",{fontCharacter:"\\eae2"}),n.editorLayout=new n("editor-layout",{fontCharacter:"\\eae3"}),n.emptyWindow=new n("empty-window",{fontCharacter:"\\eae4"}),n.exclude=new n("exclude",{fontCharacter:"\\eae5"}),n.extensions=new n("extensions",{fontCharacter:"\\eae6"}),n.eyeClosed=new n("eye-closed",{fontCharacter:"\\eae7"}),n.fileBinary=new n("file-binary",{fontCharacter:"\\eae8"}),n.fileCode=new n("file-code",{fontCharacter:"\\eae9"}),n.fileMedia=new n("file-media",{fontCharacter:"\\eaea"}),n.filePdf=new n("file-pdf",{fontCharacter:"\\eaeb"}),n.fileSubmodule=new n("file-submodule",{fontCharacter:"\\eaec"}),n.fileSymlinkDirectory=new n("file-symlink-directory",{fontCharacter:"\\eaed"}),n.fileSymlinkFile=new n("file-symlink-file",{fontCharacter:"\\eaee"}),n.fileZip=new n("file-zip",{fontCharacter:"\\eaef"}),n.files=new n("files",{fontCharacter:"\\eaf0"}),n.filter=new n("filter",{fontCharacter:"\\eaf1"}),n.flame=new n("flame",{fontCharacter:"\\eaf2"}),n.foldDown=new n("fold-down",{fontCharacter:"\\eaf3"}),n.foldUp=new n("fold-up",{fontCharacter:"\\eaf4"}),n.fold=new n("fold",{fontCharacter:"\\eaf5"}),n.folderActive=new n("folder-active",{fontCharacter:"\\eaf6"}),n.folderOpened=new n("folder-opened",{fontCharacter:"\\eaf7"}),n.gear=new n("gear",{fontCharacter:"\\eaf8"}),n.gift=new n("gift",{fontCharacter:"\\eaf9"}),n.gistSecret=new n("gist-secret",{fontCharacter:"\\eafa"}),n.gist=new n("gist",{fontCharacter:"\\eafb"}),n.gitCommit=new n("git-commit",{fontCharacter:"\\eafc"}),n.gitCompare=new n("git-compare",{fontCharacter:"\\eafd"}),n.gitMerge=new n("git-merge",{fontCharacter:"\\eafe"}),n.githubAction=new n("github-action",{fontCharacter:"\\eaff"}),n.githubAlt=new n("github-alt",{fontCharacter:"\\eb00"}),n.globe=new n("globe",{fontCharacter:"\\eb01"}),n.grabber=new n("grabber",{fontCharacter:"\\eb02"}),n.graph=new n("graph",{fontCharacter:"\\eb03"}),n.gripper=new n("gripper",{fontCharacter:"\\eb04"}),n.heart=new n("heart",{fontCharacter:"\\eb05"}),n.home=new n("home",{fontCharacter:"\\eb06"}),n.horizontalRule=new n("horizontal-rule",{fontCharacter:"\\eb07"}),n.hubot=new n("hubot",{fontCharacter:"\\eb08"}),n.inbox=new n("inbox",{fontCharacter:"\\eb09"}),n.issueClosed=new n("issue-closed",{fontCharacter:"\\eba4"}),n.issueReopened=new n("issue-reopened",{fontCharacter:"\\eb0b"}),n.issues=new n("issues",{fontCharacter:"\\eb0c"}),n.italic=new n("italic",{fontCharacter:"\\eb0d"}),n.jersey=new n("jersey",{fontCharacter:"\\eb0e"}),n.json=new n("json",{fontCharacter:"\\eb0f"}),n.kebabVertical=new n("kebab-vertical",{fontCharacter:"\\eb10"}),n.key=new n("key",{fontCharacter:"\\eb11"}),n.law=new n("law",{fontCharacter:"\\eb12"}),n.lightbulbAutofix=new n("lightbulb-autofix",{fontCharacter:"\\eb13"}),n.linkExternal=new n("link-external",{fontCharacter:"\\eb14"}),n.link=new n("link",{fontCharacter:"\\eb15"}),n.listOrdered=new n("list-ordered",{fontCharacter:"\\eb16"}),n.listUnordered=new n("list-unordered",{fontCharacter:"\\eb17"}),n.liveShare=new n("live-share",{fontCharacter:"\\eb18"}),n.loading=new n("loading",{fontCharacter:"\\eb19"}),n.location=new n("location",{fontCharacter:"\\eb1a"}),n.mailRead=new n("mail-read",{fontCharacter:"\\eb1b"}),n.mail=new n("mail",{fontCharacter:"\\eb1c"}),n.markdown=new n("markdown",{fontCharacter:"\\eb1d"}),n.megaphone=new n("megaphone",{fontCharacter:"\\eb1e"}),n.mention=new n("mention",{fontCharacter:"\\eb1f"}),n.milestone=new n("milestone",{fontCharacter:"\\eb20"}),n.mortarBoard=new n("mortar-board",{fontCharacter:"\\eb21"}),n.move=new n("move",{fontCharacter:"\\eb22"}),n.multipleWindows=new n("multiple-windows",{fontCharacter:"\\eb23"}),n.mute=new n("mute",{fontCharacter:"\\eb24"}),n.noNewline=new n("no-newline",{fontCharacter:"\\eb25"}),n.note=new n("note",{fontCharacter:"\\eb26"}),n.octoface=new n("octoface",{fontCharacter:"\\eb27"}),n.openPreview=new n("open-preview",{fontCharacter:"\\eb28"}),n.package_=new n("package",{fontCharacter:"\\eb29"}),n.paintcan=new n("paintcan",{fontCharacter:"\\eb2a"}),n.pin=new n("pin",{fontCharacter:"\\eb2b"}),n.play=new n("play",{fontCharacter:"\\eb2c"}),n.run=new n("run",{fontCharacter:"\\eb2c"}),n.plug=new n("plug",{fontCharacter:"\\eb2d"}),n.preserveCase=new n("preserve-case",{fontCharacter:"\\eb2e"}),n.preview=new n("preview",{fontCharacter:"\\eb2f"}),n.project=new n("project",{fontCharacter:"\\eb30"}),n.pulse=new n("pulse",{fontCharacter:"\\eb31"}),n.question=new n("question",{fontCharacter:"\\eb32"}),n.quote=new n("quote",{fontCharacter:"\\eb33"}),n.radioTower=new n("radio-tower",{fontCharacter:"\\eb34"}),n.reactions=new n("reactions",{fontCharacter:"\\eb35"}),n.references=new n("references",{fontCharacter:"\\eb36"}),n.refresh=new n("refresh",{fontCharacter:"\\eb37"}),n.regex=new n("regex",{fontCharacter:"\\eb38"}),n.remoteExplorer=new n("remote-explorer",{fontCharacter:"\\eb39"}),n.remote=new n("remote",{fontCharacter:"\\eb3a"}),n.remove=new n("remove",{fontCharacter:"\\eb3b"}),n.replaceAll=new n("replace-all",{fontCharacter:"\\eb3c"}),n.replace=new n("replace",{fontCharacter:"\\eb3d"}),n.repoClone=new n("repo-clone",{fontCharacter:"\\eb3e"}),n.repoForcePush=new n("repo-force-push",{fontCharacter:"\\eb3f"}),n.repoPull=new n("repo-pull",{fontCharacter:"\\eb40"}),n.repoPush=new n("repo-push",{fontCharacter:"\\eb41"}),n.report=new n("report",{fontCharacter:"\\eb42"}),n.requestChanges=new n("request-changes",{fontCharacter:"\\eb43"}),n.rocket=new n("rocket",{fontCharacter:"\\eb44"}),n.rootFolderOpened=new n("root-folder-opened",{fontCharacter:"\\eb45"}),n.rootFolder=new n("root-folder",{fontCharacter:"\\eb46"}),n.rss=new n("rss",{fontCharacter:"\\eb47"}),n.ruby=new n("ruby",{fontCharacter:"\\eb48"}),n.saveAll=new n("save-all",{fontCharacter:"\\eb49"}),n.saveAs=new n("save-as",{fontCharacter:"\\eb4a"}),n.save=new n("save",{fontCharacter:"\\eb4b"}),n.screenFull=new n("screen-full",{fontCharacter:"\\eb4c"}),n.screenNormal=new n("screen-normal",{fontCharacter:"\\eb4d"}),n.searchStop=new n("search-stop",{fontCharacter:"\\eb4e"}),n.server=new n("server",{fontCharacter:"\\eb50"}),n.settingsGear=new n("settings-gear",{fontCharacter:"\\eb51"}),n.settings=new n("settings",{fontCharacter:"\\eb52"}),n.shield=new n("shield",{fontCharacter:"\\eb53"}),n.smiley=new n("smiley",{fontCharacter:"\\eb54"}),n.sortPrecedence=new n("sort-precedence",{fontCharacter:"\\eb55"}),n.splitHorizontal=new n("split-horizontal",{fontCharacter:"\\eb56"}),n.splitVertical=new n("split-vertical",{fontCharacter:"\\eb57"}),n.squirrel=new n("squirrel",{fontCharacter:"\\eb58"}),n.starFull=new n("star-full",{fontCharacter:"\\eb59"}),n.starHalf=new n("star-half",{fontCharacter:"\\eb5a"}),n.symbolClass=new n("symbol-class",{fontCharacter:"\\eb5b"}),n.symbolColor=new n("symbol-color",{fontCharacter:"\\eb5c"}),n.symbolConstant=new n("symbol-constant",{fontCharacter:"\\eb5d"}),n.symbolEnumMember=new n("symbol-enum-member",{fontCharacter:"\\eb5e"}),n.symbolField=new n("symbol-field",{fontCharacter:"\\eb5f"}),n.symbolFile=new n("symbol-file",{fontCharacter:"\\eb60"}),n.symbolInterface=new n("symbol-interface",{fontCharacter:"\\eb61"}),n.symbolKeyword=new n("symbol-keyword",{fontCharacter:"\\eb62"}),n.symbolMisc=new n("symbol-misc",{fontCharacter:"\\eb63"}),n.symbolOperator=new n("symbol-operator",{fontCharacter:"\\eb64"}),n.symbolProperty=new n("symbol-property",{fontCharacter:"\\eb65"}),n.wrench=new n("wrench",{fontCharacter:"\\eb65"}),n.wrenchSubaction=new n("wrench-subaction",{fontCharacter:"\\eb65"}),n.symbolSnippet=new n("symbol-snippet",{fontCharacter:"\\eb66"}),n.tasklist=new n("tasklist",{fontCharacter:"\\eb67"}),n.telescope=new n("telescope",{fontCharacter:"\\eb68"}),n.textSize=new n("text-size",{fontCharacter:"\\eb69"}),n.threeBars=new n("three-bars",{fontCharacter:"\\eb6a"}),n.thumbsdown=new n("thumbsdown",{fontCharacter:"\\eb6b"}),n.thumbsup=new n("thumbsup",{fontCharacter:"\\eb6c"}),n.tools=new n("tools",{fontCharacter:"\\eb6d"}),n.triangleDown=new n("triangle-down",{fontCharacter:"\\eb6e"}),n.triangleLeft=new n("triangle-left",{fontCharacter:"\\eb6f"}),n.triangleRight=new n("triangle-right",{fontCharacter:"\\eb70"}),n.triangleUp=new n("triangle-up",{fontCharacter:"\\eb71"}),n.twitter=new n("twitter",{fontCharacter:"\\eb72"}),n.unfold=new n("unfold",{fontCharacter:"\\eb73"}),n.unlock=new n("unlock",{fontCharacter:"\\eb74"}),n.unmute=new n("unmute",{fontCharacter:"\\eb75"}),n.unverified=new n("unverified",{fontCharacter:"\\eb76"}),n.verified=new n("verified",{fontCharacter:"\\eb77"}),n.versions=new n("versions",{fontCharacter:"\\eb78"}),n.vmActive=new n("vm-active",{fontCharacter:"\\eb79"}),n.vmOutline=new n("vm-outline",{fontCharacter:"\\eb7a"}),n.vmRunning=new n("vm-running",{fontCharacter:"\\eb7b"}),n.watch=new n("watch",{fontCharacter:"\\eb7c"}),n.whitespace=new n("whitespace",{fontCharacter:"\\eb7d"}),n.wholeWord=new n("whole-word",{fontCharacter:"\\eb7e"}),n.window=new n("window",{fontCharacter:"\\eb7f"}),n.wordWrap=new n("word-wrap",{fontCharacter:"\\eb80"}),n.zoomIn=new n("zoom-in",{fontCharacter:"\\eb81"}),n.zoomOut=new n("zoom-out",{fontCharacter:"\\eb82"}),n.listFilter=new n("list-filter",{fontCharacter:"\\eb83"}),n.listFlat=new n("list-flat",{fontCharacter:"\\eb84"}),n.listSelection=new n("list-selection",{fontCharacter:"\\eb85"}),n.selection=new n("selection",{fontCharacter:"\\eb85"}),n.listTree=new n("list-tree",{fontCharacter:"\\eb86"}),n.debugBreakpointFunctionUnverified=new n("debug-breakpoint-function-unverified",{fontCharacter:"\\eb87"}),n.debugBreakpointFunction=new n("debug-breakpoint-function",{fontCharacter:"\\eb88"}),n.debugBreakpointFunctionDisabled=new n("debug-breakpoint-function-disabled",{fontCharacter:"\\eb88"}),n.debugStackframeActive=new n("debug-stackframe-active",{fontCharacter:"\\eb89"}),n.debugStackframeDot=new n("debug-stackframe-dot",{fontCharacter:"\\eb8a"}),n.debugStackframe=new n("debug-stackframe",{fontCharacter:"\\eb8b"}),n.debugStackframeFocused=new n("debug-stackframe-focused",{fontCharacter:"\\eb8b"}),n.debugBreakpointUnsupported=new n("debug-breakpoint-unsupported",{fontCharacter:"\\eb8c"}),n.symbolString=new n("symbol-string",{fontCharacter:"\\eb8d"}),n.debugReverseContinue=new n("debug-reverse-continue",{fontCharacter:"\\eb8e"}),n.debugStepBack=new n("debug-step-back",{fontCharacter:"\\eb8f"}),n.debugRestartFrame=new n("debug-restart-frame",{fontCharacter:"\\eb90"}),n.callIncoming=new n("call-incoming",{fontCharacter:"\\eb92"}),n.callOutgoing=new n("call-outgoing",{fontCharacter:"\\eb93"}),n.menu=new n("menu",{fontCharacter:"\\eb94"}),n.expandAll=new n("expand-all",{fontCharacter:"\\eb95"}),n.feedback=new n("feedback",{fontCharacter:"\\eb96"}),n.groupByRefType=new n("group-by-ref-type",{fontCharacter:"\\eb97"}),n.ungroupByRefType=new n("ungroup-by-ref-type",{fontCharacter:"\\eb98"}),n.account=new n("account",{fontCharacter:"\\eb99"}),n.bellDot=new n("bell-dot",{fontCharacter:"\\eb9a"}),n.debugConsole=new n("debug-console",{fontCharacter:"\\eb9b"}),n.library=new n("library",{fontCharacter:"\\eb9c"}),n.output=new n("output",{fontCharacter:"\\eb9d"}),n.runAll=new n("run-all",{fontCharacter:"\\eb9e"}),n.syncIgnored=new n("sync-ignored",{fontCharacter:"\\eb9f"}),n.pinned=new n("pinned",{fontCharacter:"\\eba0"}),n.githubInverted=new n("github-inverted",{fontCharacter:"\\eba1"}),n.debugAlt=new n("debug-alt",{fontCharacter:"\\eb91"}),n.serverProcess=new n("server-process",{fontCharacter:"\\eba2"}),n.serverEnvironment=new n("server-environment",{fontCharacter:"\\eba3"}),n.pass=new n("pass",{fontCharacter:"\\eba4"}),n.stopCircle=new n("stop-circle",{fontCharacter:"\\eba5"}),n.playCircle=new n("play-circle",{fontCharacter:"\\eba6"}),n.record=new n("record",{fontCharacter:"\\eba7"}),n.debugAltSmall=new n("debug-alt-small",{fontCharacter:"\\eba8"}),n.vmConnect=new n("vm-connect",{fontCharacter:"\\eba9"}),n.cloud=new n("cloud",{fontCharacter:"\\ebaa"}),n.merge=new n("merge",{fontCharacter:"\\ebab"}),n.exportIcon=new n("export",{fontCharacter:"\\ebac"}),n.graphLeft=new n("graph-left",{fontCharacter:"\\ebad"}),n.magnet=new n("magnet",{fontCharacter:"\\ebae"}),n.notebook=new n("notebook",{fontCharacter:"\\ebaf"}),n.redo=new n("redo",{fontCharacter:"\\ebb0"}),n.checkAll=new n("check-all",{fontCharacter:"\\ebb1"}),n.pinnedDirty=new n("pinned-dirty",{fontCharacter:"\\ebb2"}),n.passFilled=new n("pass-filled",{fontCharacter:"\\ebb3"}),n.circleLargeFilled=new n("circle-large-filled",{fontCharacter:"\\ebb4"}),n.circleLargeOutline=new n("circle-large-outline",{fontCharacter:"\\ebb5"}),n.combine=new n("combine",{fontCharacter:"\\ebb6"}),n.gather=new n("gather",{fontCharacter:"\\ebb6"}),n.table=new n("table",{fontCharacter:"\\ebb7"}),n.variableGroup=new n("variable-group",{fontCharacter:"\\ebb8"}),n.typeHierarchy=new n("type-hierarchy",{fontCharacter:"\\ebb9"}),n.typeHierarchySub=new n("type-hierarchy-sub",{fontCharacter:"\\ebba"}),n.typeHierarchySuper=new n("type-hierarchy-super",{fontCharacter:"\\ebbb"}),n.gitPullRequestCreate=new n("git-pull-request-create",{fontCharacter:"\\ebbc"}),n.runAbove=new n("run-above",{fontCharacter:"\\ebbd"}),n.runBelow=new n("run-below",{fontCharacter:"\\ebbe"}),n.notebookTemplate=new n("notebook-template",{fontCharacter:"\\ebbf"}),n.debugRerun=new n("debug-rerun",{fontCharacter:"\\ebc0"}),n.workspaceTrusted=new n("workspace-trusted",{fontCharacter:"\\ebc1"}),n.workspaceUntrusted=new n("workspace-untrusted",{fontCharacter:"\\ebc2"}),n.workspaceUnspecified=new n("workspace-unspecified",{fontCharacter:"\\ebc3"}),n.terminalCmd=new n("terminal-cmd",{fontCharacter:"\\ebc4"}),n.terminalDebian=new n("terminal-debian",{fontCharacter:"\\ebc5"}),n.terminalLinux=new n("terminal-linux",{fontCharacter:"\\ebc6"}),n.terminalPowershell=new n("terminal-powershell",{fontCharacter:"\\ebc7"}),n.terminalTmux=new n("terminal-tmux",{fontCharacter:"\\ebc8"}),n.terminalUbuntu=new n("terminal-ubuntu",{fontCharacter:"\\ebc9"}),n.terminalBash=new n("terminal-bash",{fontCharacter:"\\ebca"}),n.arrowSwap=new n("arrow-swap",{fontCharacter:"\\ebcb"}),n.copy=new n("copy",{fontCharacter:"\\ebcc"}),n.personAdd=new n("person-add",{fontCharacter:"\\ebcd"}),n.filterFilled=new n("filter-filled",{fontCharacter:"\\ebce"}),n.wand=new n("wand",{fontCharacter:"\\ebcf"}),n.debugLineByLine=new n("debug-line-by-line",{fontCharacter:"\\ebd0"}),n.inspect=new n("inspect",{fontCharacter:"\\ebd1"}),n.layers=new n("layers",{fontCharacter:"\\ebd2"}),n.layersDot=new n("layers-dot",{fontCharacter:"\\ebd3"}),n.layersActive=new n("layers-active",{fontCharacter:"\\ebd4"}),n.compass=new n("compass",{fontCharacter:"\\ebd5"}),n.compassDot=new n("compass-dot",{fontCharacter:"\\ebd6"}),n.compassActive=new n("compass-active",{fontCharacter:"\\ebd7"}),n.azure=new n("azure",{fontCharacter:"\\ebd8"}),n.issueDraft=new n("issue-draft",{fontCharacter:"\\ebd9"}),n.gitPullRequestClosed=new n("git-pull-request-closed",{fontCharacter:"\\ebda"}),n.gitPullRequestDraft=new n("git-pull-request-draft",{fontCharacter:"\\ebdb"}),n.debugAll=new n("debug-all",{fontCharacter:"\\ebdc"}),n.debugCoverage=new n("debug-coverage",{fontCharacter:"\\ebdd"}),n.runErrors=new n("run-errors",{fontCharacter:"\\ebde"}),n.folderLibrary=new n("folder-library",{fontCharacter:"\\ebdf"}),n.debugContinueSmall=new n("debug-continue-small",{fontCharacter:"\\ebe0"}),n.beakerStop=new n("beaker-stop",{fontCharacter:"\\ebe1"}),n.graphLine=new n("graph-line",{fontCharacter:"\\ebe2"}),n.graphScatter=new n("graph-scatter",{fontCharacter:"\\ebe3"}),n.pieChart=new n("pie-chart",{fontCharacter:"\\ebe4"}),n.bracket=new n("bracket",n.json.definition),n.bracketDot=new n("bracket-dot",{fontCharacter:"\\ebe5"}),n.bracketError=new n("bracket-error",{fontCharacter:"\\ebe6"}),n.lockSmall=new n("lock-small",{fontCharacter:"\\ebe7"}),n.azureDevops=new n("azure-devops",{fontCharacter:"\\ebe8"}),n.verifiedFilled=new n("verified-filled",{fontCharacter:"\\ebe9"}),n.newLine=new n("newline",{fontCharacter:"\\ebea"}),n.layout=new n("layout",{fontCharacter:"\\ebeb"}),n.dialogError=new n("dialog-error",n.error.definition),n.dialogWarning=new n("dialog-warning",n.warning.definition),n.dialogInfo=new n("dialog-info",n.info.definition),n.dialogClose=new n("dialog-close",n.close.definition),n.treeItemExpanded=new n("tree-item-expanded",n.chevronDown.definition),n.treeFilterOnTypeOn=new n("tree-filter-on-type-on",n.listFilter.definition),n.treeFilterOnTypeOff=new n("tree-filter-on-type-off",n.listSelection.definition),n.treeFilterClear=new n("tree-filter-clear",n.close.definition),n.treeItemLoading=new n("tree-item-loading",n.loading.definition),n.menuSelection=new n("menu-selection",n.check.definition),n.menuSubmenu=new n("menu-submenu",n.chevronRight.definition),n.menuBarMore=new n("menubar-more",n.more.definition),n.scrollbarButtonLeft=new n("scrollbar-button-left",n.triangleLeft.definition),n.scrollbarButtonRight=new n("scrollbar-button-right",n.triangleRight.definition),n.scrollbarButtonUp=new n("scrollbar-button-up",n.triangleUp.definition),n.scrollbarButtonDown=new n("scrollbar-button-down",n.triangleDown.definition),n.toolBarMore=new n("toolbar-more",n.more.definition),n.quickInputBack=new n("quick-input-back",n.arrowLeft.definition);function I(f,y){const E=["codicon","codicon-"+f];return y&&E.push("codicon-modifier-"+y),E}e.getClassNamesArray=I;var d;(function(f){f.iconNameSegment="[A-Za-z0-9]+",f.iconNameExpression="[A-Za-z0-9-]+",f.iconModifierExpression="~[A-Za-z]+",f.iconNameCharacter="[A-Za-z0-9~-]";const y=new RegExp(`^(${f.iconNameExpression})(${f.iconModifierExpression})?$`);function E(t){if(t instanceof n)return["codicon","codicon-"+t.id];const m=y.exec(t.id);if(!m)return E(n.error);let[,v,b]=m;const P=["codicon","codicon-"+v];return b&&P.push("codicon-modifier-"+b.substr(1)),P}f.asClassNameArray=E;function g(t){return E(t).join(" ")}f.asClassName=g;function S(t){return"."+E(t).join(".")}f.asCSSSelector=S})(d=e.CSSIcon||(e.CSSIcon={}))}),define(x[60],ee([0,1,16,2]),function(V,e,p,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.prefixedStream=e.prefixedReadable=e.transform=e.toReadable=e.emptyStream=e.toStream=e.peekStream=e.listenStream=e.consumeStream=e.peekReadable=e.consumeReadable=e.newWriteableStream=e.isReadableBufferedStream=e.isReadableStream=void 0;function C(c){const a=c;return a?[a.on,a.pause,a.resume,a.destroy].every(l=>typeof l=="function"):!1}e.isReadableStream=C;function k(c){const a=c;return a?C(a.stream)&&Array.isArray(a.buffer)&&typeof a.ended=="boolean":!1}e.isReadableBufferedStream=k;function n(c,a){return new I(c,a)}e.newWriteableStream=n;class I{constructor(a,l){this.reducer=a,this.options=l,this.state={flowing:!1,ended:!1,destroyed:!1},this.buffer={data:[],error:[]},this.listeners={data:[],error:[],end:[]},this.pendingWritePromises=[]}pause(){this.state.destroyed||(this.state.flowing=!1)}resume(){this.state.destroyed||this.state.flowing||(this.state.flowing=!0,this.flowData(),this.flowErrors(),this.flowEnd())}write(a){if(!this.state.destroyed){if(this.state.flowing)this.emitData(a);else if(this.buffer.data.push(a),typeof this.options?.highWaterMark=="number"&&this.buffer.data.length>this.options.highWaterMark)return new Promise(l=>this.pendingWritePromises.push(l))}}error(a){this.state.destroyed||(this.state.flowing?this.emitError(a):this.buffer.error.push(a))}end(a){this.state.destroyed||(typeof a!="undefined"&&this.write(a),this.state.flowing?(this.emitEnd(),this.destroy()):this.state.ended=!0)}emitData(a){this.listeners.data.slice(0).forEach(l=>l(a))}emitError(a){this.listeners.error.length===0?(0,p.onUnexpectedError)(a):this.listeners.error.slice(0).forEach(l=>l(a))}emitEnd(){this.listeners.end.slice(0).forEach(a=>a())}on(a,l){if(!this.state.destroyed)switch(a){case"data":this.listeners.data.push(l),this.resume();break;case"end":this.listeners.end.push(l),this.state.flowing&&this.flowEnd()&&this.destroy();break;case"error":this.listeners.error.push(l),this.state.flowing&&this.flowErrors();break}}removeListener(a,l){if(this.state.destroyed)return;let o;switch(a){case"data":o=this.listeners.data;break;case"end":o=this.listeners.end;break;case"error":o=this.listeners.error;break}if(o){const u=o.indexOf(l);u>=0&&o.splice(u,1)}}flowData(){if(this.buffer.data.length>0){const a=this.reducer(this.buffer.data);this.emitData(a),this.buffer.data.length=0;const l=[...this.pendingWritePromises];this.pendingWritePromises.length=0,l.forEach(o=>o())}}flowErrors(){if(this.listeners.error.length>0){for(const a of this.buffer.error)this.emitError(a);this.buffer.error.length=0}}flowEnd(){return this.state.ended?(this.emitEnd(),this.listeners.end.length>0):!1}destroy(){this.state.destroyed||(this.state.destroyed=!0,this.state.ended=!0,this.buffer.data.length=0,this.buffer.error.length=0,this.listeners.data.length=0,this.listeners.error.length=0,this.listeners.end.length=0,this.pendingWritePromises.length=0)}}function d(c,a){const l=[];let o;for(;(o=c.read())!==null;)l.push(o);return a(l)}e.consumeReadable=d;function f(c,a,l){const o=[];let u;for(;(u=c.read())!==null&&o.length<l;)o.push(u);return u===null&&o.length>0?a(o):{read:()=>{if(o.length>0)return o.shift();if(typeof u!="undefined"){const r=u;return u=void 0,r}return c.read()}}}e.peekReadable=f;function y(c,a){return new Promise((l,o)=>{const u=[];E(c,{onData:r=>{a&&u.push(r)},onError:r=>{a?o(r):l(void 0)},onEnd:()=>{l(a?a(u):void 0)}})})}e.consumeStream=y;function E(c,a){c.on("error",l=>a.onError(l)),c.on("end",()=>a.onEnd()),c.on("data",l=>a.onData(l))}e.listenStream=E;function g(c,a){return new Promise((l,o)=>{const u=new R.DisposableStore,r=[],i=w=>{if(r.push(w),r.length>a)return u.dispose(),c.pause(),l({stream:c,buffer:r,ended:!1})},s=w=>o(w),h=()=>l({stream:c,buffer:r,ended:!0});u.add((0,R.toDisposable)(()=>c.removeListener("error",s))),c.on("error",s),u.add((0,R.toDisposable)(()=>c.removeListener("end",h))),c.on("end",h),u.add((0,R.toDisposable)(()=>c.removeListener("data",i))),c.on("data",i)})}e.peekStream=g;function S(c,a){const l=n(a);return l.end(c),l}e.toStream=S;function t(){const c=n(()=>{throw new Error("not supported")});return c.end(),c}e.emptyStream=t;function m(c){let a=!1;return{read:()=>a?null:(a=!0,c)}}e.toReadable=m;function v(c,a,l){const o=n(l);return E(c,{onData:u=>o.write(a.data(u)),onError:u=>o.error(a.error?a.error(u):u),onEnd:()=>o.end()}),o}e.transform=v;function b(c,a,l){let o=!1;return{read:()=>{const u=a.read();return o?u:(o=!0,u!==null?l([c,u]):c)}}}e.prefixedReadable=b;function P(c,a,l){let o=!1;const u=n(l);return E(a,{onData:r=>o?u.write(r):(o=!0,u.write(l([c,r]))),onError:r=>u.error(r),onEnd:()=>{o||(o=!0,u.write(c)),u.end()}}),u}e.prefixedStream=P}),define(x[17],ee([0,1,60]),function(V,e,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.prefixedBufferStream=e.prefixedBufferReadable=e.newWriteableBufferStream=e.streamToBufferReadableStream=e.bufferToStream=e.bufferedStreamToBuffer=e.streamToBuffer=e.bufferToReadable=e.readableToBuffer=e.writeUInt8=e.readUInt8=e.writeUInt32LE=e.readUInt32LE=e.writeUInt32BE=e.readUInt32BE=e.writeUInt16LE=e.readUInt16LE=e.VSBuffer=void 0;const R=typeof Buffer!="undefined";let C,k;class n{constructor(i){this.buffer=i,this.byteLength=this.buffer.byteLength}static alloc(i){return R?new n(Buffer.allocUnsafe(i)):new n(new Uint8Array(i))}static wrap(i){return R&&!Buffer.isBuffer(i)&&(i=Buffer.from(i.buffer,i.byteOffset,i.byteLength)),new n(i)}static fromString(i,s){return!(s?.dontUseNodeBuffer||!1)&&R?new n(Buffer.from(i)):(C||(C=new TextEncoder),new n(C.encode(i)))}static fromByteArray(i){const s=n.alloc(i.length);for(let h=0,w=i.length;h<w;h++)s.buffer[h]=i[h];return s}static concat(i,s){if(typeof s=="undefined"){s=0;for(let M=0,A=i.length;M<A;M++)s+=i[M].byteLength}const h=n.alloc(s);let w=0;for(let M=0,A=i.length;M<A;M++){const L=i[M];h.set(L,w),w+=L.byteLength}return h}clone(){const i=n.alloc(this.byteLength);return i.set(this),i}toString(){return R?this.buffer.toString():(k||(k=new TextDecoder),k.decode(this.buffer))}slice(i,s){return new n(this.buffer.subarray(i,s))}set(i,s){if(i instanceof n)this.buffer.set(i.buffer,s);else if(i instanceof Uint8Array)this.buffer.set(i,s);else if(i instanceof ArrayBuffer)this.buffer.set(new Uint8Array(i),s);else if(ArrayBuffer.isView(i))this.buffer.set(new Uint8Array(i.buffer,i.byteOffset,i.byteLength),s);else throw new Error("Unkown argument 'array'")}readUInt32BE(i){return f(this.buffer,i)}writeUInt32BE(i,s){y(this.buffer,i,s)}readUInt32LE(i){return E(this.buffer,i)}writeUInt32LE(i,s){g(this.buffer,i,s)}readUInt8(i){return S(this.buffer,i)}writeUInt8(i,s){t(this.buffer,i,s)}}e.VSBuffer=n;function I(r,i){return r[i+0]<<0>>>0|r[i+1]<<8>>>0}e.readUInt16LE=I;function d(r,i,s){r[s+0]=i&255,i=i>>>8,r[s+1]=i&255}e.writeUInt16LE=d;function f(r,i){return r[i]*2**24+r[i+1]*2**16+r[i+2]*2**8+r[i+3]}e.readUInt32BE=f;function y(r,i,s){r[s+3]=i,i=i>>>8,r[s+2]=i,i=i>>>8,r[s+1]=i,i=i>>>8,r[s]=i}e.writeUInt32BE=y;function E(r,i){return r[i+0]<<0>>>0|r[i+1]<<8>>>0|r[i+2]<<16>>>0|r[i+3]<<24>>>0}e.readUInt32LE=E;function g(r,i,s){r[s+0]=i&255,i=i>>>8,r[s+1]=i&255,i=i>>>8,r[s+2]=i&255,i=i>>>8,r[s+3]=i&255}e.writeUInt32LE=g;function S(r,i){return r[i]}e.readUInt8=S;function t(r,i,s){r[s]=i}e.writeUInt8=t;function m(r){return p.consumeReadable(r,i=>n.concat(i))}e.readableToBuffer=m;function v(r){return p.toReadable(r)}e.bufferToReadable=v;function b(r){return p.consumeStream(r,i=>n.concat(i))}e.streamToBuffer=b;async function P(r){return r.ended?n.concat(r.buffer):n.concat([...r.buffer,await b(r.stream)])}e.bufferedStreamToBuffer=P;function c(r){return p.toStream(r,i=>n.concat(i))}e.bufferToStream=c;function a(r){return p.transform(r,{data:i=>typeof i=="string"?n.fromString(i):n.wrap(i)},i=>n.concat(i))}e.streamToBufferReadableStream=a;function l(r){return p.newWriteableStream(i=>n.concat(i),r)}e.newWriteableBufferStream=l;function o(r,i){return p.prefixedReadable(r,i,s=>n.concat(s))}e.prefixedBufferReadable=o;function u(r,i){return p.prefixedStream(r,i,s=>n.concat(s))}e.prefixedBufferStream=u}),define(x[25],ee([0,1,3]),function(V,e,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InvisibleCharacters=e.AmbiguousCharacters=e.noBreakWhitespace=e.getLeftDeleteOffset=e.GraphemeBreakType=e.breakBetweenGraphemeBreakType=e.getGraphemeBreakType=e.singleLetterHash=e.getNLines=e.uppercaseFirstLetter=e.containsUppercaseCharacter=e.fuzzyContains=e.stripUTF8BOM=e.startsWithUTF8BOM=e.UTF8_BOM_CHARACTER=e.removeAnsiEscapeCodes=e.lcut=e.isEmojiImprecise=e.isFullWidthCharacter=e.containsFullWidthCharacter=e.containsUnusualLineTerminators=e.UNUSUAL_LINE_TERMINATORS=e.isBasicASCII=e.containsEmoji=e.containsRTL=e.getCharContainingOffset=e.prevCharLength=e.nextCharLength=e.getNextCodePoint=e.computeCodePoint=e.isLowSurrogate=e.isHighSurrogate=e.commonSuffixLength=e.commonPrefixLength=e.startsWithIgnoreCase=e.equalsIgnoreCase=e.isUpperAsciiLetter=e.isLowerAsciiLetter=e.compareSubstringIgnoreCase=e.compareIgnoreCase=e.compareSubstring=e.compare=e.lastNonWhitespaceIndex=e.getLeadingWhitespace=e.firstNonWhitespaceIndex=e.splitLines=e.regExpFlags=e.regExpContainsBackreference=e.regExpLeadsToEndlessLoop=e.createRegExp=e.stripWildcards=e.convertSimple2RegExpPattern=e.rtrim=e.ltrim=e.trim=e.truncate=e.count=e.escapeRegExpCharacters=e.escape=e.format2=e.format=e.isFalsyOrWhitespace=void 0;function R(j){return!j||typeof j!="string"?!0:j.trim().length===0}e.isFalsyOrWhitespace=R;const C=/{(\d+)}/g;function k(j,...ae){return ae.length===0?j:j.replace(C,function(he,ve){const Ie=parseInt(ve,10);return isNaN(Ie)||Ie<0||Ie>=ae.length?he:ae[Ie]})}e.format=k;const n=/{([^}]+)}/g;function I(j,ae){return j.replace(n,(he,ve)=>ae[ve]??he)}e.format2=I;function d(j){return j.replace(/[<>&]/g,function(ae){switch(ae){case"<":return"&lt;";case">":return"&gt;";case"&":return"&amp;";default:return ae}})}e.escape=d;function f(j){return j.replace(/[\\\{\}\*\+\?\|\^\$\.\[\]\(\)]/g,"\\$&")}e.escapeRegExpCharacters=f;function y(j,ae){let he=0;const ve=ae.charCodeAt(0);for(let Ie=j.length-1;Ie>=0;Ie--)j.charCodeAt(Ie)===ve&&he++;return he}e.count=y;function E(j,ae,he="\u2026"){return j.length<=ae?j:`${j.substr(0,ae)}${he}`}e.truncate=E;function g(j,ae=" "){const he=S(j,ae);return t(he,ae)}e.trim=g;function S(j,ae){if(!j||!ae)return j;const he=ae.length;if(he===0||j.length===0)return j;let ve=0;for(;j.indexOf(ae,ve)===ve;)ve=ve+he;return j.substring(ve)}e.ltrim=S;function t(j,ae){if(!j||!ae)return j;const he=ae.length,ve=j.length;if(he===0||ve===0)return j;let Ie=ve,Ce=-1;for(;Ce=j.lastIndexOf(ae,Ie-1),!(Ce===-1||Ce+he!==Ie);){if(Ce===0)return"";Ie=Ce}return j.substring(0,Ie)}e.rtrim=t;function m(j){return j.replace(/[\-\\\{\}\+\?\|\^\$\.\,\[\]\(\)\#\s]/g,"\\$&").replace(/[\*]/g,".*")}e.convertSimple2RegExpPattern=m;function v(j){return j.replace(/\*/g,"")}e.stripWildcards=v;function b(j,ae,he={}){if(!j)throw new Error("Cannot create regex from empty string");ae||(j=f(j)),he.wholeWord&&(/\B/.test(j.charAt(0))||(j="\\b"+j),/\B/.test(j.charAt(j.length-1))||(j=j+"\\b"));let ve="";return he.global&&(ve+="g"),he.matchCase||(ve+="i"),he.multiline&&(ve+="m"),he.unicode&&(ve+="u"),new RegExp(j,ve)}e.createRegExp=b;function P(j){return j.source==="^"||j.source==="^$"||j.source==="$"||j.source==="^\\s*$"?!1:!!(j.exec("")&&j.lastIndex===0)}e.regExpLeadsToEndlessLoop=P;function c(j){return!!j.match(/([^\\]|^)(\\\\)*\\\d+/)}e.regExpContainsBackreference=c;function a(j){return(j.global?"g":"")+(j.ignoreCase?"i":"")+(j.multiline?"m":"")+(j.unicode?"u":"")}e.regExpFlags=a;function l(j){return j.split(/\r\n|\r|\n/)}e.splitLines=l;function o(j){for(let ae=0,he=j.length;ae<he;ae++){const ve=j.charCodeAt(ae);if(ve!==32&&ve!==9)return ae}return-1}e.firstNonWhitespaceIndex=o;function u(j,ae=0,he=j.length){for(let ve=ae;ve<he;ve++){const Ie=j.charCodeAt(ve);if(Ie!==32&&Ie!==9)return j.substring(ae,ve)}return j.substring(ae,he)}e.getLeadingWhitespace=u;function r(j,ae=j.length-1){for(let he=ae;he>=0;he--){const ve=j.charCodeAt(he);if(ve!==32&&ve!==9)return he}return-1}e.lastNonWhitespaceIndex=r;function i(j,ae){return j<ae?-1:j>ae?1:0}e.compare=i;function s(j,ae,he=0,ve=j.length,Ie=0,Ce=ae.length){for(;he<ve&&Ie<Ce;he++,Ie++){let Oe=j.charCodeAt(he),Ne=ae.charCodeAt(Ie);if(Oe<Ne)return-1;if(Oe>Ne)return 1}const Te=ve-he,We=Ce-Ie;return Te<We?-1:Te>We?1:0}e.compareSubstring=s;function h(j,ae){return w(j,ae,0,j.length,0,ae.length)}e.compareIgnoreCase=h;function w(j,ae,he=0,ve=j.length,Ie=0,Ce=ae.length){for(;he<ve&&Ie<Ce;he++,Ie++){let Oe=j.charCodeAt(he),Ne=ae.charCodeAt(Ie);if(Oe===Ne)continue;if(Oe>=128||Ne>=128)return s(j.toLowerCase(),ae.toLowerCase(),he,ve,Ie,Ce);M(Oe)&&(Oe-=32),M(Ne)&&(Ne-=32);const je=Oe-Ne;if(je!==0)return je}const Te=ve-he,We=Ce-Ie;return Te<We?-1:Te>We?1:0}e.compareSubstringIgnoreCase=w;function M(j){return j>=97&&j<=122}e.isLowerAsciiLetter=M;function A(j){return j>=65&&j<=90}e.isUpperAsciiLetter=A;function L(j,ae){return j.length===ae.length&&w(j,ae)===0}e.equalsIgnoreCase=L;function F(j,ae){const he=ae.length;return ae.length>j.length?!1:w(j,ae,0,he)===0}e.startsWithIgnoreCase=F;function U(j,ae){let he,ve=Math.min(j.length,ae.length);for(he=0;he<ve;he++)if(j.charCodeAt(he)!==ae.charCodeAt(he))return he;return ve}e.commonPrefixLength=U;function Y(j,ae){let he,ve=Math.min(j.length,ae.length);const Ie=j.length-1,Ce=ae.length-1;for(he=0;he<ve;he++)if(j.charCodeAt(Ie-he)!==ae.charCodeAt(Ce-he))return he;return ve}e.commonSuffixLength=Y;function ie(j){return 55296<=j&&j<=56319}e.isHighSurrogate=ie;function re(j){return 56320<=j&&j<=57343}e.isLowSurrogate=re;function K(j,ae){return(j-55296<<10)+(ae-56320)+65536}e.computeCodePoint=K;function W(j,ae,he){const ve=j.charCodeAt(he);if(ie(ve)&&he+1<ae){const Ie=j.charCodeAt(he+1);if(re(Ie))return K(ve,Ie)}return ve}e.getNextCodePoint=W;function N(j,ae){const he=j.charCodeAt(ae-1);if(re(he)&&ae>1){const ve=j.charCodeAt(ae-2);if(ie(ve))return K(ve,he)}return he}function G(j,ae){const he=ze.getInstance(),ve=ae,Ie=j.length,Ce=W(j,Ie,ae);ae+=Ce>=65536?2:1;let Te=he.getGraphemeBreakType(Ce);for(;ae<Ie;){const We=W(j,Ie,ae),Oe=he.getGraphemeBreakType(We);if(Fe(Te,Oe))break;ae+=We>=65536?2:1,Te=Oe}return ae-ve}e.nextCharLength=G;function Q(j,ae){const he=ze.getInstance(),ve=ae,Ie=N(j,ae);ae-=Ie>=65536?2:1;let Ce=he.getGraphemeBreakType(Ie);for(;ae>0;){const Te=N(j,ae),We=he.getGraphemeBreakType(Te);if(Fe(We,Ce))break;ae-=Te>=65536?2:1,Ce=We}return ve-ae}e.prevCharLength=Q;function H(j,ae){const he=ze.getInstance(),ve=j.length,Ie=ae,Ce=W(j,ve,ae),Te=he.getGraphemeBreakType(Ce);ae+=Ce>=65536?2:1;let We=Te;for(;ae<ve;){const Ne=W(j,ve,ae),je=he.getGraphemeBreakType(Ne);if(Fe(We,je))break;ae+=Ne>=65536?2:1,We=je}const Oe=ae;for(ae=Ie,We=Te;ae>0;){const Ne=N(j,ae),je=he.getGraphemeBreakType(Ne);if(Fe(je,We))break;ae-=Ne>=65536?2:1,We=je}return[ae,Oe]}function $(j,ae){return ae>0&&re(j.charCodeAt(ae))?H(j,ae-1):H(j,ae)}e.getCharContainingOffset=$;const J=/(?:[\u05BE\u05C0\u05C3\u05C6\u05D0-\u05F4\u0608\u060B\u060D\u061B-\u064A\u066D-\u066F\u0671-\u06D5\u06E5\u06E6\u06EE\u06EF\u06FA-\u0710\u0712-\u072F\u074D-\u07A5\u07B1-\u07EA\u07F4\u07F5\u07FA\u07FE-\u0815\u081A\u0824\u0828\u0830-\u0858\u085E-\u088E\u08A0-\u08C9\u200F\uFB1D\uFB1F-\uFB28\uFB2A-\uFD3D\uFD50-\uFDC7\uFDF0-\uFDFC\uFE70-\uFEFC]|\uD802[\uDC00-\uDD1B\uDD20-\uDE00\uDE10-\uDE35\uDE40-\uDEE4\uDEEB-\uDF35\uDF40-\uDFFF]|\uD803[\uDC00-\uDD23\uDE80-\uDEA9\uDEAD-\uDF45\uDF51-\uDF81\uDF86-\uDFF6]|\uD83A[\uDC00-\uDCCF\uDD00-\uDD43\uDD4B-\uDFFF]|\uD83B[\uDC00-\uDEBB])/;function O(j){return J.test(j)}e.containsRTL=O;const D=/(?:[\u231A\u231B\u23F0\u23F3\u2600-\u27BF\u2B50\u2B55]|\uD83C[\uDDE6-\uDDFF\uDF00-\uDFFF]|\uD83D[\uDC00-\uDE4F\uDE80-\uDEFC\uDFE0-\uDFF0]|\uD83E[\uDD00-\uDDFF\uDE70-\uDEF6])/;function T(j){return D.test(j)}e.containsEmoji=T;const _=/^[\t\n\r\x20-\x7E]*$/;function z(j){return _.test(j)}e.isBasicASCII=z,e.UNUSUAL_LINE_TERMINATORS=/[\u2028\u2029]/;function X(j){return e.UNUSUAL_LINE_TERMINATORS.test(j)}e.containsUnusualLineTerminators=X;function B(j){for(let ae=0,he=j.length;ae<he;ae++)if(q(j.charCodeAt(ae)))return!0;return!1}e.containsFullWidthCharacter=B;function q(j){return j>=11904&&j<=55215||j>=63744&&j<=64255||j>=65281&&j<=65374}e.isFullWidthCharacter=q;function ne(j){return j>=127462&&j<=127487||j===8986||j===8987||j===9200||j===9203||j>=9728&&j<=10175||j===11088||j===11093||j>=127744&&j<=128591||j>=128640&&j<=128764||j>=128992&&j<=129008||j>=129280&&j<=129535||j>=129648&&j<=129782}e.isEmojiImprecise=ne;function se(j,ae){if(j.length<ae)return j;const he=/\b/g;let ve=0;for(;he.test(j)&&!(j.length-he.lastIndex<ae);)ve=he.lastIndex,he.lastIndex+=1;return j.substring(ve).replace(/^\s/,"")}e.lcut=se;const oe=/\x1B\x5B[12]?K/g,Z=/\x1b\[\d+m/g,ce=/\x1b\[0?m/g;function le(j){return j&&(j=j.replace(oe,""),j=j.replace(Z,""),j=j.replace(ce,"")),j}e.removeAnsiEscapeCodes=le,e.UTF8_BOM_CHARACTER=String.fromCharCode(65279);function ue(j){return!!(j&&j.length>0&&j.charCodeAt(0)===65279)}e.startsWithUTF8BOM=ue;function me(j){return ue(j)?j.substr(1):j}e.stripUTF8BOM=me;function Ee(j,ae){if(!j||!ae||j.length<ae.length)return!1;const he=ae.length,ve=j.toLowerCase();let Ie=0,Ce=-1;for(;Ie<he;){const Te=ve.indexOf(ae[Ie],Ce+1);if(Te<0)return!1;Ce=Te,Ie++}return!0}e.fuzzyContains=Ee;function de(j,ae=!1){return j?(ae&&(j=j.replace(/\\./g,"")),j.toLowerCase()!==j):!1}e.containsUppercaseCharacter=de;function ge(j){return j.charAt(0).toUpperCase()+j.slice(1)}e.uppercaseFirstLetter=ge;function pe(j,ae=1){if(ae===0)return"";let he=-1;do he=j.indexOf(`
`,he+1),ae--;while(ae>0&&he>=0);return he===-1?j:(j[he-1]==="\r"&&he--,j.substr(0,he))}e.getNLines=pe;function ke(j){const ae=90-65+1;return j=j%(2*ae),j<ae?String.fromCharCode(97+j):String.fromCharCode(65+j-ae)}e.singleLetterHash=ke;function Re(j){return ze.getInstance().getGraphemeBreakType(j)}e.getGraphemeBreakType=Re;function Fe(j,ae){return j===0?ae!==5&&ae!==7:j===2&&ae===3?!1:j===4||j===2||j===3||ae===4||ae===2||ae===3?!0:!(j===8&&(ae===8||ae===9||ae===11||ae===12)||(j===11||j===9)&&(ae===9||ae===10)||(j===12||j===10)&&ae===10||ae===5||ae===13||ae===7||j===1||j===13&&ae===14||j===6&&ae===6)}e.breakBetweenGraphemeBreakType=Fe;var $e;(function(j){j[j.Other=0]="Other",j[j.Prepend=1]="Prepend",j[j.CR=2]="CR",j[j.LF=3]="LF",j[j.Control=4]="Control",j[j.Extend=5]="Extend",j[j.Regional_Indicator=6]="Regional_Indicator",j[j.SpacingMark=7]="SpacingMark",j[j.L=8]="L",j[j.V=9]="V",j[j.T=10]="T",j[j.LV=11]="LV",j[j.LVT=12]="LVT",j[j.ZWJ=13]="ZWJ",j[j.Extended_Pictographic=14]="Extended_Pictographic"})($e=e.GraphemeBreakType||(e.GraphemeBreakType={}));class ze{constructor(){this._data=Qe()}static getInstance(){return ze._INSTANCE||(ze._INSTANCE=new ze),ze._INSTANCE}getGraphemeBreakType(ae){if(ae<32)return ae===10?3:ae===13?2:4;if(ae<127)return 0;const he=this._data,ve=he.length/3;let Ie=1;for(;Ie<=ve;)if(ae<he[3*Ie])Ie=2*Ie;else if(ae>he[3*Ie+1])Ie=2*Ie+1;else return he[3*Ie+2];return 0}}ze._INSTANCE=null;function Qe(){return JSON.parse("[0,0,0,51229,51255,12,44061,44087,12,127462,127487,6,7083,7085,5,47645,47671,12,54813,54839,12,128678,128678,14,3270,3270,5,9919,9923,14,45853,45879,12,49437,49463,12,53021,53047,12,71216,71218,7,128398,128399,14,129360,129374,14,2519,2519,5,4448,4519,9,9742,9742,14,12336,12336,14,44957,44983,12,46749,46775,12,48541,48567,12,50333,50359,12,52125,52151,12,53917,53943,12,69888,69890,5,73018,73018,5,127990,127990,14,128558,128559,14,128759,128760,14,129653,129655,14,2027,2035,5,2891,2892,7,3761,3761,5,6683,6683,5,8293,8293,4,9825,9826,14,9999,9999,14,43452,43453,5,44509,44535,12,45405,45431,12,46301,46327,12,47197,47223,12,48093,48119,12,48989,49015,12,49885,49911,12,50781,50807,12,51677,51703,12,52573,52599,12,53469,53495,12,54365,54391,12,65279,65279,4,70471,70472,7,72145,72147,7,119173,119179,5,127799,127818,14,128240,128244,14,128512,128512,14,128652,128652,14,128721,128722,14,129292,129292,14,129445,129450,14,129734,129743,14,1476,1477,5,2366,2368,7,2750,2752,7,3076,3076,5,3415,3415,5,4141,4144,5,6109,6109,5,6964,6964,5,7394,7400,5,9197,9198,14,9770,9770,14,9877,9877,14,9968,9969,14,10084,10084,14,43052,43052,5,43713,43713,5,44285,44311,12,44733,44759,12,45181,45207,12,45629,45655,12,46077,46103,12,46525,46551,12,46973,46999,12,47421,47447,12,47869,47895,12,48317,48343,12,48765,48791,12,49213,49239,12,49661,49687,12,50109,50135,12,50557,50583,12,51005,51031,12,51453,51479,12,51901,51927,12,52349,52375,12,52797,52823,12,53245,53271,12,53693,53719,12,54141,54167,12,54589,54615,12,55037,55063,12,69506,69509,5,70191,70193,5,70841,70841,7,71463,71467,5,72330,72342,5,94031,94031,5,123628,123631,5,127763,127765,14,127941,127941,14,128043,128062,14,128302,128317,14,128465,128467,14,128539,128539,14,128640,128640,14,128662,128662,14,128703,128703,14,128745,128745,14,129004,129007,14,129329,129330,14,129402,129402,14,129483,129483,14,129686,129704,14,130048,131069,14,173,173,4,1757,1757,1,2200,2207,5,2434,2435,7,2631,2632,5,2817,2817,5,3008,3008,5,3201,3201,5,3387,3388,5,3542,3542,5,3902,3903,7,4190,4192,5,6002,6003,5,6439,6440,5,6765,6770,7,7019,7027,5,7154,7155,7,8205,8205,13,8505,8505,14,9654,9654,14,9757,9757,14,9792,9792,14,9852,9853,14,9890,9894,14,9937,9937,14,9981,9981,14,10035,10036,14,11035,11036,14,42654,42655,5,43346,43347,7,43587,43587,5,44006,44007,7,44173,44199,12,44397,44423,12,44621,44647,12,44845,44871,12,45069,45095,12,45293,45319,12,45517,45543,12,45741,45767,12,45965,45991,12,46189,46215,12,46413,46439,12,46637,46663,12,46861,46887,12,47085,47111,12,47309,47335,12,47533,47559,12,47757,47783,12,47981,48007,12,48205,48231,12,48429,48455,12,48653,48679,12,48877,48903,12,49101,49127,12,49325,49351,12,49549,49575,12,49773,49799,12,49997,50023,12,50221,50247,12,50445,50471,12,50669,50695,12,50893,50919,12,51117,51143,12,51341,51367,12,51565,51591,12,51789,51815,12,52013,52039,12,52237,52263,12,52461,52487,12,52685,52711,12,52909,52935,12,53133,53159,12,53357,53383,12,53581,53607,12,53805,53831,12,54029,54055,12,54253,54279,12,54477,54503,12,54701,54727,12,54925,54951,12,55149,55175,12,68101,68102,5,69762,69762,7,70067,70069,7,70371,70378,5,70720,70721,7,71087,71087,5,71341,71341,5,71995,71996,5,72249,72249,7,72850,72871,5,73109,73109,5,118576,118598,5,121505,121519,5,127245,127247,14,127568,127569,14,127777,127777,14,127872,127891,14,127956,127967,14,128015,128016,14,128110,128172,14,128259,128259,14,128367,128368,14,128424,128424,14,128488,128488,14,128530,128532,14,128550,128551,14,128566,128566,14,128647,128647,14,128656,128656,14,128667,128673,14,128691,128693,14,128715,128715,14,128728,128732,14,128752,128752,14,128765,128767,14,129096,129103,14,129311,129311,14,129344,129349,14,129394,129394,14,129413,129425,14,129466,129471,14,129511,129535,14,129664,129666,14,129719,129722,14,129760,129767,14,917536,917631,5,13,13,2,1160,1161,5,1564,1564,4,1807,1807,1,2085,2087,5,2307,2307,7,2382,2383,7,2497,2500,5,2563,2563,7,2677,2677,5,2763,2764,7,2879,2879,5,2914,2915,5,3021,3021,5,3142,3144,5,3263,3263,5,3285,3286,5,3398,3400,7,3530,3530,5,3633,3633,5,3864,3865,5,3974,3975,5,4155,4156,7,4229,4230,5,5909,5909,7,6078,6085,7,6277,6278,5,6451,6456,7,6744,6750,5,6846,6846,5,6972,6972,5,7074,7077,5,7146,7148,7,7222,7223,5,7416,7417,5,8234,8238,4,8417,8417,5,9000,9000,14,9203,9203,14,9730,9731,14,9748,9749,14,9762,9763,14,9776,9783,14,9800,9811,14,9831,9831,14,9872,9873,14,9882,9882,14,9900,9903,14,9929,9933,14,9941,9960,14,9974,9974,14,9989,9989,14,10006,10006,14,10062,10062,14,10160,10160,14,11647,11647,5,12953,12953,14,43019,43019,5,43232,43249,5,43443,43443,5,43567,43568,7,43696,43696,5,43765,43765,7,44013,44013,5,44117,44143,12,44229,44255,12,44341,44367,12,44453,44479,12,44565,44591,12,44677,44703,12,44789,44815,12,44901,44927,12,45013,45039,12,45125,45151,12,45237,45263,12,45349,45375,12,45461,45487,12,45573,45599,12,45685,45711,12,45797,45823,12,45909,45935,12,46021,46047,12,46133,46159,12,46245,46271,12,46357,46383,12,46469,46495,12,46581,46607,12,46693,46719,12,46805,46831,12,46917,46943,12,47029,47055,12,47141,47167,12,47253,47279,12,47365,47391,12,47477,47503,12,47589,47615,12,47701,47727,12,47813,47839,12,47925,47951,12,48037,48063,12,48149,48175,12,48261,48287,12,48373,48399,12,48485,48511,12,48597,48623,12,48709,48735,12,48821,48847,12,48933,48959,12,49045,49071,12,49157,49183,12,49269,49295,12,49381,49407,12,49493,49519,12,49605,49631,12,49717,49743,12,49829,49855,12,49941,49967,12,50053,50079,12,50165,50191,12,50277,50303,12,50389,50415,12,50501,50527,12,50613,50639,12,50725,50751,12,50837,50863,12,50949,50975,12,51061,51087,12,51173,51199,12,51285,51311,12,51397,51423,12,51509,51535,12,51621,51647,12,51733,51759,12,51845,51871,12,51957,51983,12,52069,52095,12,52181,52207,12,52293,52319,12,52405,52431,12,52517,52543,12,52629,52655,12,52741,52767,12,52853,52879,12,52965,52991,12,53077,53103,12,53189,53215,12,53301,53327,12,53413,53439,12,53525,53551,12,53637,53663,12,53749,53775,12,53861,53887,12,53973,53999,12,54085,54111,12,54197,54223,12,54309,54335,12,54421,54447,12,54533,54559,12,54645,54671,12,54757,54783,12,54869,54895,12,54981,55007,12,55093,55119,12,55243,55291,10,66045,66045,5,68325,68326,5,69688,69702,5,69817,69818,5,69957,69958,7,70089,70092,5,70198,70199,5,70462,70462,5,70502,70508,5,70750,70750,5,70846,70846,7,71100,71101,5,71230,71230,7,71351,71351,5,71737,71738,5,72000,72000,7,72160,72160,5,72273,72278,5,72752,72758,5,72882,72883,5,73031,73031,5,73461,73462,7,94192,94193,7,119149,119149,7,121403,121452,5,122915,122916,5,126980,126980,14,127358,127359,14,127535,127535,14,127759,127759,14,127771,127771,14,127792,127793,14,127825,127867,14,127897,127899,14,127945,127945,14,127985,127986,14,128000,128007,14,128021,128021,14,128066,128100,14,128184,128235,14,128249,128252,14,128266,128276,14,128335,128335,14,128379,128390,14,128407,128419,14,128444,128444,14,128481,128481,14,128499,128499,14,128526,128526,14,128536,128536,14,128543,128543,14,128556,128556,14,128564,128564,14,128577,128580,14,128643,128645,14,128649,128649,14,128654,128654,14,128660,128660,14,128664,128664,14,128675,128675,14,128686,128689,14,128695,128696,14,128705,128709,14,128717,128719,14,128725,128725,14,128736,128741,14,128747,128748,14,128755,128755,14,128762,128762,14,128981,128991,14,129009,129023,14,129160,129167,14,129296,129304,14,129320,129327,14,129340,129342,14,129356,129356,14,129388,129392,14,129399,129400,14,129404,129407,14,129432,129442,14,129454,129455,14,129473,129474,14,129485,129487,14,129648,129651,14,129659,129660,14,129671,129679,14,129709,129711,14,129728,129730,14,129751,129753,14,129776,129782,14,917505,917505,4,917760,917999,5,10,10,3,127,159,4,768,879,5,1471,1471,5,1536,1541,1,1648,1648,5,1767,1768,5,1840,1866,5,2070,2073,5,2137,2139,5,2274,2274,1,2363,2363,7,2377,2380,7,2402,2403,5,2494,2494,5,2507,2508,7,2558,2558,5,2622,2624,7,2641,2641,5,2691,2691,7,2759,2760,5,2786,2787,5,2876,2876,5,2881,2884,5,2901,2902,5,3006,3006,5,3014,3016,7,3072,3072,5,3134,3136,5,3157,3158,5,3260,3260,5,3266,3266,5,3274,3275,7,3328,3329,5,3391,3392,7,3405,3405,5,3457,3457,5,3536,3537,7,3551,3551,5,3636,3642,5,3764,3772,5,3895,3895,5,3967,3967,7,3993,4028,5,4146,4151,5,4182,4183,7,4226,4226,5,4253,4253,5,4957,4959,5,5940,5940,7,6070,6070,7,6087,6088,7,6158,6158,4,6432,6434,5,6448,6449,7,6679,6680,5,6742,6742,5,6754,6754,5,6783,6783,5,6912,6915,5,6966,6970,5,6978,6978,5,7042,7042,7,7080,7081,5,7143,7143,7,7150,7150,7,7212,7219,5,7380,7392,5,7412,7412,5,8203,8203,4,8232,8232,4,8265,8265,14,8400,8412,5,8421,8432,5,8617,8618,14,9167,9167,14,9200,9200,14,9410,9410,14,9723,9726,14,9733,9733,14,9745,9745,14,9752,9752,14,9760,9760,14,9766,9766,14,9774,9774,14,9786,9786,14,9794,9794,14,9823,9823,14,9828,9828,14,9833,9850,14,9855,9855,14,9875,9875,14,9880,9880,14,9885,9887,14,9896,9897,14,9906,9916,14,9926,9927,14,9935,9935,14,9939,9939,14,9962,9962,14,9972,9972,14,9978,9978,14,9986,9986,14,9997,9997,14,10002,10002,14,10017,10017,14,10055,10055,14,10071,10071,14,10133,10135,14,10548,10549,14,11093,11093,14,12330,12333,5,12441,12442,5,42608,42610,5,43010,43010,5,43045,43046,5,43188,43203,7,43302,43309,5,43392,43394,5,43446,43449,5,43493,43493,5,43571,43572,7,43597,43597,7,43703,43704,5,43756,43757,5,44003,44004,7,44009,44010,7,44033,44059,12,44089,44115,12,44145,44171,12,44201,44227,12,44257,44283,12,44313,44339,12,44369,44395,12,44425,44451,12,44481,44507,12,44537,44563,12,44593,44619,12,44649,44675,12,44705,44731,12,44761,44787,12,44817,44843,12,44873,44899,12,44929,44955,12,44985,45011,12,45041,45067,12,45097,45123,12,45153,45179,12,45209,45235,12,45265,45291,12,45321,45347,12,45377,45403,12,45433,45459,12,45489,45515,12,45545,45571,12,45601,45627,12,45657,45683,12,45713,45739,12,45769,45795,12,45825,45851,12,45881,45907,12,45937,45963,12,45993,46019,12,46049,46075,12,46105,46131,12,46161,46187,12,46217,46243,12,46273,46299,12,46329,46355,12,46385,46411,12,46441,46467,12,46497,46523,12,46553,46579,12,46609,46635,12,46665,46691,12,46721,46747,12,46777,46803,12,46833,46859,12,46889,46915,12,46945,46971,12,47001,47027,12,47057,47083,12,47113,47139,12,47169,47195,12,47225,47251,12,47281,47307,12,47337,47363,12,47393,47419,12,47449,47475,12,47505,47531,12,47561,47587,12,47617,47643,12,47673,47699,12,47729,47755,12,47785,47811,12,47841,47867,12,47897,47923,12,47953,47979,12,48009,48035,12,48065,48091,12,48121,48147,12,48177,48203,12,48233,48259,12,48289,48315,12,48345,48371,12,48401,48427,12,48457,48483,12,48513,48539,12,48569,48595,12,48625,48651,12,48681,48707,12,48737,48763,12,48793,48819,12,48849,48875,12,48905,48931,12,48961,48987,12,49017,49043,12,49073,49099,12,49129,49155,12,49185,49211,12,49241,49267,12,49297,49323,12,49353,49379,12,49409,49435,12,49465,49491,12,49521,49547,12,49577,49603,12,49633,49659,12,49689,49715,12,49745,49771,12,49801,49827,12,49857,49883,12,49913,49939,12,49969,49995,12,50025,50051,12,50081,50107,12,50137,50163,12,50193,50219,12,50249,50275,12,50305,50331,12,50361,50387,12,50417,50443,12,50473,50499,12,50529,50555,12,50585,50611,12,50641,50667,12,50697,50723,12,50753,50779,12,50809,50835,12,50865,50891,12,50921,50947,12,50977,51003,12,51033,51059,12,51089,51115,12,51145,51171,12,51201,51227,12,51257,51283,12,51313,51339,12,51369,51395,12,51425,51451,12,51481,51507,12,51537,51563,12,51593,51619,12,51649,51675,12,51705,51731,12,51761,51787,12,51817,51843,12,51873,51899,12,51929,51955,12,51985,52011,12,52041,52067,12,52097,52123,12,52153,52179,12,52209,52235,12,52265,52291,12,52321,52347,12,52377,52403,12,52433,52459,12,52489,52515,12,52545,52571,12,52601,52627,12,52657,52683,12,52713,52739,12,52769,52795,12,52825,52851,12,52881,52907,12,52937,52963,12,52993,53019,12,53049,53075,12,53105,53131,12,53161,53187,12,53217,53243,12,53273,53299,12,53329,53355,12,53385,53411,12,53441,53467,12,53497,53523,12,53553,53579,12,53609,53635,12,53665,53691,12,53721,53747,12,53777,53803,12,53833,53859,12,53889,53915,12,53945,53971,12,54001,54027,12,54057,54083,12,54113,54139,12,54169,54195,12,54225,54251,12,54281,54307,12,54337,54363,12,54393,54419,12,54449,54475,12,54505,54531,12,54561,54587,12,54617,54643,12,54673,54699,12,54729,54755,12,54785,54811,12,54841,54867,12,54897,54923,12,54953,54979,12,55009,55035,12,55065,55091,12,55121,55147,12,55177,55203,12,65024,65039,5,65520,65528,4,66422,66426,5,68152,68154,5,69291,69292,5,69633,69633,5,69747,69748,5,69811,69814,5,69826,69826,5,69932,69932,7,70016,70017,5,70079,70080,7,70095,70095,5,70196,70196,5,70367,70367,5,70402,70403,7,70464,70464,5,70487,70487,5,70709,70711,7,70725,70725,7,70833,70834,7,70843,70844,7,70849,70849,7,71090,71093,5,71103,71104,5,71227,71228,7,71339,71339,5,71344,71349,5,71458,71461,5,71727,71735,5,71985,71989,7,71998,71998,5,72002,72002,7,72154,72155,5,72193,72202,5,72251,72254,5,72281,72283,5,72344,72345,5,72766,72766,7,72874,72880,5,72885,72886,5,73023,73029,5,73104,73105,5,73111,73111,5,92912,92916,5,94095,94098,5,113824,113827,4,119142,119142,7,119155,119162,4,119362,119364,5,121476,121476,5,122888,122904,5,123184,123190,5,125252,125258,5,127183,127183,14,127340,127343,14,127377,127386,14,127491,127503,14,127548,127551,14,127744,127756,14,127761,127761,14,127769,127769,14,127773,127774,14,127780,127788,14,127796,127797,14,127820,127823,14,127869,127869,14,127894,127895,14,127902,127903,14,127943,127943,14,127947,127950,14,127972,127972,14,127988,127988,14,127992,127994,14,128009,128011,14,128019,128019,14,128023,128041,14,128064,128064,14,128102,128107,14,128174,128181,14,128238,128238,14,128246,128247,14,128254,128254,14,128264,128264,14,128278,128299,14,128329,128330,14,128348,128359,14,128371,128377,14,128392,128393,14,128401,128404,14,128421,128421,14,128433,128434,14,128450,128452,14,128476,128478,14,128483,128483,14,128495,128495,14,128506,128506,14,128519,128520,14,128528,128528,14,128534,128534,14,128538,128538,14,128540,128542,14,128544,128549,14,128552,128555,14,128557,128557,14,128560,128563,14,128565,128565,14,128567,128576,14,128581,128591,14,128641,128642,14,128646,128646,14,128648,128648,14,128650,128651,14,128653,128653,14,128655,128655,14,128657,128659,14,128661,128661,14,128663,128663,14,128665,128666,14,128674,128674,14,128676,128677,14,128679,128685,14,128690,128690,14,128694,128694,14,128697,128702,14,128704,128704,14,128710,128714,14,128716,128716,14,128720,128720,14,128723,128724,14,128726,128727,14,128733,128735,14,128742,128744,14,128746,128746,14,128749,128751,14,128753,128754,14,128756,128758,14,128761,128761,14,128763,128764,14,128884,128895,14,128992,129003,14,129008,129008,14,129036,129039,14,129114,129119,14,129198,129279,14,129293,129295,14,129305,129310,14,129312,129319,14,129328,129328,14,129331,129338,14,129343,129343,14,129351,129355,14,129357,129359,14,129375,129387,14,129393,129393,14,129395,129398,14,129401,129401,14,129403,129403,14,129408,129412,14,129426,129431,14,129443,129444,14,129451,129453,14,129456,129465,14,129472,129472,14,129475,129482,14,129484,129484,14,129488,129510,14,129536,129647,14,129652,129652,14,129656,129658,14,129661,129663,14,129667,129670,14,129680,129685,14,129705,129708,14,129712,129718,14,129723,129727,14,129731,129733,14,129744,129750,14,129754,129759,14,129768,129775,14,129783,129791,14,917504,917504,4,917506,917535,4,917632,917759,4,918000,921599,4,0,9,4,11,12,4,14,31,4,169,169,14,174,174,14,1155,1159,5,1425,1469,5,1473,1474,5,1479,1479,5,1552,1562,5,1611,1631,5,1750,1756,5,1759,1764,5,1770,1773,5,1809,1809,5,1958,1968,5,2045,2045,5,2075,2083,5,2089,2093,5,2192,2193,1,2250,2273,5,2275,2306,5,2362,2362,5,2364,2364,5,2369,2376,5,2381,2381,5,2385,2391,5,2433,2433,5,2492,2492,5,2495,2496,7,2503,2504,7,2509,2509,5,2530,2531,5,2561,2562,5,2620,2620,5,2625,2626,5,2635,2637,5,2672,2673,5,2689,2690,5,2748,2748,5,2753,2757,5,2761,2761,7,2765,2765,5,2810,2815,5,2818,2819,7,2878,2878,5,2880,2880,7,2887,2888,7,2893,2893,5,2903,2903,5,2946,2946,5,3007,3007,7,3009,3010,7,3018,3020,7,3031,3031,5,3073,3075,7,3132,3132,5,3137,3140,7,3146,3149,5,3170,3171,5,3202,3203,7,3262,3262,7,3264,3265,7,3267,3268,7,3271,3272,7,3276,3277,5,3298,3299,5,3330,3331,7,3390,3390,5,3393,3396,5,3402,3404,7,3406,3406,1,3426,3427,5,3458,3459,7,3535,3535,5,3538,3540,5,3544,3550,7,3570,3571,7,3635,3635,7,3655,3662,5,3763,3763,7,3784,3789,5,3893,3893,5,3897,3897,5,3953,3966,5,3968,3972,5,3981,3991,5,4038,4038,5,4145,4145,7,4153,4154,5,4157,4158,5,4184,4185,5,4209,4212,5,4228,4228,7,4237,4237,5,4352,4447,8,4520,4607,10,5906,5908,5,5938,5939,5,5970,5971,5,6068,6069,5,6071,6077,5,6086,6086,5,6089,6099,5,6155,6157,5,6159,6159,5,6313,6313,5,6435,6438,7,6441,6443,7,6450,6450,5,6457,6459,5,6681,6682,7,6741,6741,7,6743,6743,7,6752,6752,5,6757,6764,5,6771,6780,5,6832,6845,5,6847,6862,5,6916,6916,7,6965,6965,5,6971,6971,7,6973,6977,7,6979,6980,7,7040,7041,5,7073,7073,7,7078,7079,7,7082,7082,7,7142,7142,5,7144,7145,5,7149,7149,5,7151,7153,5,7204,7211,7,7220,7221,7,7376,7378,5,7393,7393,7,7405,7405,5,7415,7415,7,7616,7679,5,8204,8204,5,8206,8207,4,8233,8233,4,8252,8252,14,8288,8292,4,8294,8303,4,8413,8416,5,8418,8420,5,8482,8482,14,8596,8601,14,8986,8987,14,9096,9096,14,9193,9196,14,9199,9199,14,9201,9202,14,9208,9210,14,9642,9643,14,9664,9664,14,9728,9729,14,9732,9732,14,9735,9741,14,9743,9744,14,9746,9746,14,9750,9751,14,9753,9756,14,9758,9759,14,9761,9761,14,9764,9765,14,9767,9769,14,9771,9773,14,9775,9775,14,9784,9785,14,9787,9791,14,9793,9793,14,9795,9799,14,9812,9822,14,9824,9824,14,9827,9827,14,9829,9830,14,9832,9832,14,9851,9851,14,9854,9854,14,9856,9861,14,9874,9874,14,9876,9876,14,9878,9879,14,9881,9881,14,9883,9884,14,9888,9889,14,9895,9895,14,9898,9899,14,9904,9905,14,9917,9918,14,9924,9925,14,9928,9928,14,9934,9934,14,9936,9936,14,9938,9938,14,9940,9940,14,9961,9961,14,9963,9967,14,9970,9971,14,9973,9973,14,9975,9977,14,9979,9980,14,9982,9985,14,9987,9988,14,9992,9996,14,9998,9998,14,10000,10001,14,10004,10004,14,10013,10013,14,10024,10024,14,10052,10052,14,10060,10060,14,10067,10069,14,10083,10083,14,10085,10087,14,10145,10145,14,10175,10175,14,11013,11015,14,11088,11088,14,11503,11505,5,11744,11775,5,12334,12335,5,12349,12349,14,12951,12951,14,42607,42607,5,42612,42621,5,42736,42737,5,43014,43014,5,43043,43044,7,43047,43047,7,43136,43137,7,43204,43205,5,43263,43263,5,43335,43345,5,43360,43388,8,43395,43395,7,43444,43445,7,43450,43451,7,43454,43456,7,43561,43566,5,43569,43570,5,43573,43574,5,43596,43596,5,43644,43644,5,43698,43700,5,43710,43711,5,43755,43755,7,43758,43759,7,43766,43766,5,44005,44005,5,44008,44008,5,44012,44012,7,44032,44032,11,44060,44060,11,44088,44088,11,44116,44116,11,44144,44144,11,44172,44172,11,44200,44200,11,44228,44228,11,44256,44256,11,44284,44284,11,44312,44312,11,44340,44340,11,44368,44368,11,44396,44396,11,44424,44424,11,44452,44452,11,44480,44480,11,44508,44508,11,44536,44536,11,44564,44564,11,44592,44592,11,44620,44620,11,44648,44648,11,44676,44676,11,44704,44704,11,44732,44732,11,44760,44760,11,44788,44788,11,44816,44816,11,44844,44844,11,44872,44872,11,44900,44900,11,44928,44928,11,44956,44956,11,44984,44984,11,45012,45012,11,45040,45040,11,45068,45068,11,45096,45096,11,45124,45124,11,45152,45152,11,45180,45180,11,45208,45208,11,45236,45236,11,45264,45264,11,45292,45292,11,45320,45320,11,45348,45348,11,45376,45376,11,45404,45404,11,45432,45432,11,45460,45460,11,45488,45488,11,45516,45516,11,45544,45544,11,45572,45572,11,45600,45600,11,45628,45628,11,45656,45656,11,45684,45684,11,45712,45712,11,45740,45740,11,45768,45768,11,45796,45796,11,45824,45824,11,45852,45852,11,45880,45880,11,45908,45908,11,45936,45936,11,45964,45964,11,45992,45992,11,46020,46020,11,46048,46048,11,46076,46076,11,46104,46104,11,46132,46132,11,46160,46160,11,46188,46188,11,46216,46216,11,46244,46244,11,46272,46272,11,46300,46300,11,46328,46328,11,46356,46356,11,46384,46384,11,46412,46412,11,46440,46440,11,46468,46468,11,46496,46496,11,46524,46524,11,46552,46552,11,46580,46580,11,46608,46608,11,46636,46636,11,46664,46664,11,46692,46692,11,46720,46720,11,46748,46748,11,46776,46776,11,46804,46804,11,46832,46832,11,46860,46860,11,46888,46888,11,46916,46916,11,46944,46944,11,46972,46972,11,47000,47000,11,47028,47028,11,47056,47056,11,47084,47084,11,47112,47112,11,47140,47140,11,47168,47168,11,47196,47196,11,47224,47224,11,47252,47252,11,47280,47280,11,47308,47308,11,47336,47336,11,47364,47364,11,47392,47392,11,47420,47420,11,47448,47448,11,47476,47476,11,47504,47504,11,47532,47532,11,47560,47560,11,47588,47588,11,47616,47616,11,47644,47644,11,47672,47672,11,47700,47700,11,47728,47728,11,47756,47756,11,47784,47784,11,47812,47812,11,47840,47840,11,47868,47868,11,47896,47896,11,47924,47924,11,47952,47952,11,47980,47980,11,48008,48008,11,48036,48036,11,48064,48064,11,48092,48092,11,48120,48120,11,48148,48148,11,48176,48176,11,48204,48204,11,48232,48232,11,48260,48260,11,48288,48288,11,48316,48316,11,48344,48344,11,48372,48372,11,48400,48400,11,48428,48428,11,48456,48456,11,48484,48484,11,48512,48512,11,48540,48540,11,48568,48568,11,48596,48596,11,48624,48624,11,48652,48652,11,48680,48680,11,48708,48708,11,48736,48736,11,48764,48764,11,48792,48792,11,48820,48820,11,48848,48848,11,48876,48876,11,48904,48904,11,48932,48932,11,48960,48960,11,48988,48988,11,49016,49016,11,49044,49044,11,49072,49072,11,49100,49100,11,49128,49128,11,49156,49156,11,49184,49184,11,49212,49212,11,49240,49240,11,49268,49268,11,49296,49296,11,49324,49324,11,49352,49352,11,49380,49380,11,49408,49408,11,49436,49436,11,49464,49464,11,49492,49492,11,49520,49520,11,49548,49548,11,49576,49576,11,49604,49604,11,49632,49632,11,49660,49660,11,49688,49688,11,49716,49716,11,49744,49744,11,49772,49772,11,49800,49800,11,49828,49828,11,49856,49856,11,49884,49884,11,49912,49912,11,49940,49940,11,49968,49968,11,49996,49996,11,50024,50024,11,50052,50052,11,50080,50080,11,50108,50108,11,50136,50136,11,50164,50164,11,50192,50192,11,50220,50220,11,50248,50248,11,50276,50276,11,50304,50304,11,50332,50332,11,50360,50360,11,50388,50388,11,50416,50416,11,50444,50444,11,50472,50472,11,50500,50500,11,50528,50528,11,50556,50556,11,50584,50584,11,50612,50612,11,50640,50640,11,50668,50668,11,50696,50696,11,50724,50724,11,50752,50752,11,50780,50780,11,50808,50808,11,50836,50836,11,50864,50864,11,50892,50892,11,50920,50920,11,50948,50948,11,50976,50976,11,51004,51004,11,51032,51032,11,51060,51060,11,51088,51088,11,51116,51116,11,51144,51144,11,51172,51172,11,51200,51200,11,51228,51228,11,51256,51256,11,51284,51284,11,51312,51312,11,51340,51340,11,51368,51368,11,51396,51396,11,51424,51424,11,51452,51452,11,51480,51480,11,51508,51508,11,51536,51536,11,51564,51564,11,51592,51592,11,51620,51620,11,51648,51648,11,51676,51676,11,51704,51704,11,51732,51732,11,51760,51760,11,51788,51788,11,51816,51816,11,51844,51844,11,51872,51872,11,51900,51900,11,51928,51928,11,51956,51956,11,51984,51984,11,52012,52012,11,52040,52040,11,52068,52068,11,52096,52096,11,52124,52124,11,52152,52152,11,52180,52180,11,52208,52208,11,52236,52236,11,52264,52264,11,52292,52292,11,52320,52320,11,52348,52348,11,52376,52376,11,52404,52404,11,52432,52432,11,52460,52460,11,52488,52488,11,52516,52516,11,52544,52544,11,52572,52572,11,52600,52600,11,52628,52628,11,52656,52656,11,52684,52684,11,52712,52712,11,52740,52740,11,52768,52768,11,52796,52796,11,52824,52824,11,52852,52852,11,52880,52880,11,52908,52908,11,52936,52936,11,52964,52964,11,52992,52992,11,53020,53020,11,53048,53048,11,53076,53076,11,53104,53104,11,53132,53132,11,53160,53160,11,53188,53188,11,53216,53216,11,53244,53244,11,53272,53272,11,53300,53300,11,53328,53328,11,53356,53356,11,53384,53384,11,53412,53412,11,53440,53440,11,53468,53468,11,53496,53496,11,53524,53524,11,53552,53552,11,53580,53580,11,53608,53608,11,53636,53636,11,53664,53664,11,53692,53692,11,53720,53720,11,53748,53748,11,53776,53776,11,53804,53804,11,53832,53832,11,53860,53860,11,53888,53888,11,53916,53916,11,53944,53944,11,53972,53972,11,54000,54000,11,54028,54028,11,54056,54056,11,54084,54084,11,54112,54112,11,54140,54140,11,54168,54168,11,54196,54196,11,54224,54224,11,54252,54252,11,54280,54280,11,54308,54308,11,54336,54336,11,54364,54364,11,54392,54392,11,54420,54420,11,54448,54448,11,54476,54476,11,54504,54504,11,54532,54532,11,54560,54560,11,54588,54588,11,54616,54616,11,54644,54644,11,54672,54672,11,54700,54700,11,54728,54728,11,54756,54756,11,54784,54784,11,54812,54812,11,54840,54840,11,54868,54868,11,54896,54896,11,54924,54924,11,54952,54952,11,54980,54980,11,55008,55008,11,55036,55036,11,55064,55064,11,55092,55092,11,55120,55120,11,55148,55148,11,55176,55176,11,55216,55238,9,64286,64286,5,65056,65071,5,65438,65439,5,65529,65531,4,66272,66272,5,68097,68099,5,68108,68111,5,68159,68159,5,68900,68903,5,69446,69456,5,69632,69632,7,69634,69634,7,69744,69744,5,69759,69761,5,69808,69810,7,69815,69816,7,69821,69821,1,69837,69837,1,69927,69931,5,69933,69940,5,70003,70003,5,70018,70018,7,70070,70078,5,70082,70083,1,70094,70094,7,70188,70190,7,70194,70195,7,70197,70197,7,70206,70206,5,70368,70370,7,70400,70401,5,70459,70460,5,70463,70463,7,70465,70468,7,70475,70477,7,70498,70499,7,70512,70516,5,70712,70719,5,70722,70724,5,70726,70726,5,70832,70832,5,70835,70840,5,70842,70842,5,70845,70845,5,70847,70848,5,70850,70851,5,71088,71089,7,71096,71099,7,71102,71102,7,71132,71133,5,71219,71226,5,71229,71229,5,71231,71232,5,71340,71340,7,71342,71343,7,71350,71350,7,71453,71455,5,71462,71462,7,71724,71726,7,71736,71736,7,71984,71984,5,71991,71992,7,71997,71997,7,71999,71999,1,72001,72001,1,72003,72003,5,72148,72151,5,72156,72159,7,72164,72164,7,72243,72248,5,72250,72250,1,72263,72263,5,72279,72280,7,72324,72329,1,72343,72343,7,72751,72751,7,72760,72765,5,72767,72767,5,72873,72873,7,72881,72881,7,72884,72884,7,73009,73014,5,73020,73021,5,73030,73030,1,73098,73102,7,73107,73108,7,73110,73110,7,73459,73460,5,78896,78904,4,92976,92982,5,94033,94087,7,94180,94180,5,113821,113822,5,118528,118573,5,119141,119141,5,119143,119145,5,119150,119154,5,119163,119170,5,119210,119213,5,121344,121398,5,121461,121461,5,121499,121503,5,122880,122886,5,122907,122913,5,122918,122922,5,123566,123566,5,125136,125142,5,126976,126979,14,126981,127182,14,127184,127231,14,127279,127279,14,127344,127345,14,127374,127374,14,127405,127461,14,127489,127490,14,127514,127514,14,127538,127546,14,127561,127567,14,127570,127743,14,127757,127758,14,127760,127760,14,127762,127762,14,127766,127768,14,127770,127770,14,127772,127772,14,127775,127776,14,127778,127779,14,127789,127791,14,127794,127795,14,127798,127798,14,127819,127819,14,127824,127824,14,127868,127868,14,127870,127871,14,127892,127893,14,127896,127896,14,127900,127901,14,127904,127940,14,127942,127942,14,127944,127944,14,127946,127946,14,127951,127955,14,127968,127971,14,127973,127984,14,127987,127987,14,127989,127989,14,127991,127991,14,127995,127999,5,128008,128008,14,128012,128014,14,128017,128018,14,128020,128020,14,128022,128022,14,128042,128042,14,128063,128063,14,128065,128065,14,128101,128101,14,128108,128109,14,128173,128173,14,128182,128183,14,128236,128237,14,128239,128239,14,128245,128245,14,128248,128248,14,128253,128253,14,128255,128258,14,128260,128263,14,128265,128265,14,128277,128277,14,128300,128301,14,128326,128328,14,128331,128334,14,128336,128347,14,128360,128366,14,128369,128370,14,128378,128378,14,128391,128391,14,128394,128397,14,128400,128400,14,128405,128406,14,128420,128420,14,128422,128423,14,128425,128432,14,128435,128443,14,128445,128449,14,128453,128464,14,128468,128475,14,128479,128480,14,128482,128482,14,128484,128487,14,128489,128494,14,128496,128498,14,128500,128505,14,128507,128511,14,128513,128518,14,128521,128525,14,128527,128527,14,128529,128529,14,128533,128533,14,128535,128535,14,128537,128537,14]")}function Ge(j,ae){if(j===0)return 0;const he=gt(j,ae);if(he!==void 0)return he;const ve=N(ae,j);return j-=Je(ve),j}e.getLeftDeleteOffset=Ge;function gt(j,ae){let he=N(ae,j);for(j-=Je(he);at(he)||he===65039||he===8419;){if(j===0)return;he=N(ae,j),j-=Je(he)}if(!!ne(he)){if(j>=0){const ve=N(ae,j);ve===8205&&(j-=Je(ve))}return j}}function Je(j){return j>=65536?2:1}function at(j){return 127995<=j&&j<=127999}var ct;(function(j){j[j.zwj=8205]="zwj",j[j.emojiVariantSelector=65039]="emojiVariantSelector",j[j.enclosingKeyCap=8419]="enclosingKeyCap"})(ct||(ct={})),e.noBreakWhitespace="\xA0";class Ve{static getData(){return JSON.parse('{"_common":[8232,32,8233,32,5760,32,8192,32,8193,32,8194,32,8195,32,8196,32,8197,32,8198,32,8200,32,8201,32,8202,32,8287,32,8199,32,8239,32,2042,95,65101,95,65102,95,65103,95,8208,45,8209,45,8210,45,65112,45,1748,45,8259,45,727,45,8722,45,10134,45,11450,45,1549,44,1643,44,8218,44,184,44,42233,44,894,59,2307,58,2691,58,1417,58,1795,58,1796,58,5868,58,65072,58,6147,58,6153,58,8282,58,1475,58,760,58,42889,58,8758,58,720,58,42237,58,451,33,11601,33,660,63,577,63,2429,63,5038,63,42731,63,119149,46,8228,46,1793,46,1794,46,42510,46,68176,46,1632,46,1776,46,42232,46,1373,96,65287,96,8219,96,8242,96,1370,96,1523,96,8175,96,65344,96,900,96,8189,96,8125,96,8127,96,8190,96,697,96,884,96,712,96,714,96,715,96,756,96,699,96,701,96,700,96,702,96,42892,96,1497,96,2036,96,2037,96,5194,96,5836,96,94033,96,94034,96,65339,40,10088,40,10098,40,12308,40,64830,40,65341,41,10089,41,10099,41,12309,41,64831,41,10100,123,119060,123,10101,125,8270,42,1645,42,8727,42,66335,42,5941,47,8257,47,8725,47,8260,47,9585,47,10187,47,10744,47,119354,47,12755,47,12339,47,11462,47,20031,47,12035,47,65340,92,65128,92,8726,92,10189,92,10741,92,10745,92,119311,92,119355,92,12756,92,20022,92,12034,92,42872,38,708,94,710,94,5869,43,10133,43,66203,43,8249,60,10094,60,706,60,119350,60,5176,60,5810,60,5120,61,11840,61,12448,61,42239,61,8250,62,10095,62,707,62,119351,62,5171,62,94015,62,8275,126,732,126,8128,126,8764,126,120784,50,120794,50,120804,50,120814,50,120824,50,130034,50,42842,50,423,50,1000,50,42564,50,5311,50,42735,50,119302,51,120785,51,120795,51,120805,51,120815,51,120825,51,130035,51,42923,51,540,51,439,51,42858,51,11468,51,1248,51,94011,51,71882,51,120786,52,120796,52,120806,52,120816,52,120826,52,130036,52,5070,52,71855,52,120787,53,120797,53,120807,53,120817,53,120827,53,130037,53,444,53,71867,53,120788,54,120798,54,120808,54,120818,54,120828,54,130038,54,11474,54,5102,54,71893,54,119314,55,120789,55,120799,55,120809,55,120819,55,120829,55,130039,55,66770,55,71878,55,2819,56,2538,56,2666,56,125131,56,120790,56,120800,56,120810,56,120820,56,120830,56,130040,56,547,56,546,56,66330,56,2663,57,2920,57,2541,57,3437,57,120791,57,120801,57,120811,57,120821,57,120831,57,130041,57,42862,57,11466,57,71884,57,71852,57,71894,57,9082,97,65345,97,119834,97,119886,97,119938,97,119990,97,120042,97,120094,97,120146,97,120198,97,120250,97,120302,97,120354,97,120406,97,120458,97,593,97,945,97,120514,97,120572,97,120630,97,120688,97,120746,97,65313,65,119808,65,119860,65,119912,65,119964,65,120016,65,120068,65,120120,65,120172,65,120224,65,120276,65,120328,65,120380,65,120432,65,913,65,120488,65,120546,65,120604,65,120662,65,120720,65,5034,65,5573,65,42222,65,94016,65,66208,65,119835,98,119887,98,119939,98,119991,98,120043,98,120095,98,120147,98,120199,98,120251,98,120303,98,120355,98,120407,98,120459,98,388,98,5071,98,5234,98,5551,98,65314,66,8492,66,119809,66,119861,66,119913,66,120017,66,120069,66,120121,66,120173,66,120225,66,120277,66,120329,66,120381,66,120433,66,42932,66,914,66,120489,66,120547,66,120605,66,120663,66,120721,66,5108,66,5623,66,42192,66,66178,66,66209,66,66305,66,65347,99,8573,99,119836,99,119888,99,119940,99,119992,99,120044,99,120096,99,120148,99,120200,99,120252,99,120304,99,120356,99,120408,99,120460,99,7428,99,1010,99,11429,99,43951,99,66621,99,128844,67,71922,67,71913,67,65315,67,8557,67,8450,67,8493,67,119810,67,119862,67,119914,67,119966,67,120018,67,120174,67,120226,67,120278,67,120330,67,120382,67,120434,67,1017,67,11428,67,5087,67,42202,67,66210,67,66306,67,66581,67,66844,67,8574,100,8518,100,119837,100,119889,100,119941,100,119993,100,120045,100,120097,100,120149,100,120201,100,120253,100,120305,100,120357,100,120409,100,120461,100,1281,100,5095,100,5231,100,42194,100,8558,68,8517,68,119811,68,119863,68,119915,68,119967,68,120019,68,120071,68,120123,68,120175,68,120227,68,120279,68,120331,68,120383,68,120435,68,5024,68,5598,68,5610,68,42195,68,8494,101,65349,101,8495,101,8519,101,119838,101,119890,101,119942,101,120046,101,120098,101,120150,101,120202,101,120254,101,120306,101,120358,101,120410,101,120462,101,43826,101,1213,101,8959,69,65317,69,8496,69,119812,69,119864,69,119916,69,120020,69,120072,69,120124,69,120176,69,120228,69,120280,69,120332,69,120384,69,120436,69,917,69,120492,69,120550,69,120608,69,120666,69,120724,69,11577,69,5036,69,42224,69,71846,69,71854,69,66182,69,119839,102,119891,102,119943,102,119995,102,120047,102,120099,102,120151,102,120203,102,120255,102,120307,102,120359,102,120411,102,120463,102,43829,102,42905,102,383,102,7837,102,1412,102,119315,70,8497,70,119813,70,119865,70,119917,70,120021,70,120073,70,120125,70,120177,70,120229,70,120281,70,120333,70,120385,70,120437,70,42904,70,988,70,120778,70,5556,70,42205,70,71874,70,71842,70,66183,70,66213,70,66853,70,65351,103,8458,103,119840,103,119892,103,119944,103,120048,103,120100,103,120152,103,120204,103,120256,103,120308,103,120360,103,120412,103,120464,103,609,103,7555,103,397,103,1409,103,119814,71,119866,71,119918,71,119970,71,120022,71,120074,71,120126,71,120178,71,120230,71,120282,71,120334,71,120386,71,120438,71,1292,71,5056,71,5107,71,42198,71,65352,104,8462,104,119841,104,119945,104,119997,104,120049,104,120101,104,120153,104,120205,104,120257,104,120309,104,120361,104,120413,104,120465,104,1211,104,1392,104,5058,104,65320,72,8459,72,8460,72,8461,72,119815,72,119867,72,119919,72,120023,72,120179,72,120231,72,120283,72,120335,72,120387,72,120439,72,919,72,120494,72,120552,72,120610,72,120668,72,120726,72,11406,72,5051,72,5500,72,42215,72,66255,72,731,105,9075,105,65353,105,8560,105,8505,105,8520,105,119842,105,119894,105,119946,105,119998,105,120050,105,120102,105,120154,105,120206,105,120258,105,120310,105,120362,105,120414,105,120466,105,120484,105,618,105,617,105,953,105,8126,105,890,105,120522,105,120580,105,120638,105,120696,105,120754,105,1110,105,42567,105,1231,105,43893,105,5029,105,71875,105,65354,106,8521,106,119843,106,119895,106,119947,106,119999,106,120051,106,120103,106,120155,106,120207,106,120259,106,120311,106,120363,106,120415,106,120467,106,1011,106,1112,106,65322,74,119817,74,119869,74,119921,74,119973,74,120025,74,120077,74,120129,74,120181,74,120233,74,120285,74,120337,74,120389,74,120441,74,42930,74,895,74,1032,74,5035,74,5261,74,42201,74,119844,107,119896,107,119948,107,120000,107,120052,107,120104,107,120156,107,120208,107,120260,107,120312,107,120364,107,120416,107,120468,107,8490,75,65323,75,119818,75,119870,75,119922,75,119974,75,120026,75,120078,75,120130,75,120182,75,120234,75,120286,75,120338,75,120390,75,120442,75,922,75,120497,75,120555,75,120613,75,120671,75,120729,75,11412,75,5094,75,5845,75,42199,75,66840,75,1472,124,8739,124,9213,124,65512,124,1633,124,1777,124,66336,124,125127,124,120783,124,120793,124,120803,124,120813,124,120823,124,130033,124,65321,124,8544,124,8464,124,8465,124,119816,124,119868,124,119920,124,120024,124,120128,124,120180,124,120232,124,120284,124,120336,124,120388,124,120440,124,406,124,65356,124,8572,124,8467,124,119845,124,119897,124,119949,124,120001,124,120053,124,120105,124,120157,124,120209,124,120261,124,120313,124,120365,124,120417,124,120469,124,448,124,120496,124,120554,124,120612,124,120670,124,120728,124,11410,124,1030,124,1216,124,1493,124,1503,124,1575,124,126464,124,126592,124,65166,124,65165,124,1994,124,11599,124,5825,124,42226,124,93992,124,66186,124,66313,124,119338,76,8556,76,8466,76,119819,76,119871,76,119923,76,120027,76,120079,76,120131,76,120183,76,120235,76,120287,76,120339,76,120391,76,120443,76,11472,76,5086,76,5290,76,42209,76,93974,76,71843,76,71858,76,66587,76,66854,76,65325,77,8559,77,8499,77,119820,77,119872,77,119924,77,120028,77,120080,77,120132,77,120184,77,120236,77,120288,77,120340,77,120392,77,120444,77,924,77,120499,77,120557,77,120615,77,120673,77,120731,77,1018,77,11416,77,5047,77,5616,77,5846,77,42207,77,66224,77,66321,77,119847,110,119899,110,119951,110,120003,110,120055,110,120107,110,120159,110,120211,110,120263,110,120315,110,120367,110,120419,110,120471,110,1400,110,1404,110,65326,78,8469,78,119821,78,119873,78,119925,78,119977,78,120029,78,120081,78,120185,78,120237,78,120289,78,120341,78,120393,78,120445,78,925,78,120500,78,120558,78,120616,78,120674,78,120732,78,11418,78,42208,78,66835,78,3074,111,3202,111,3330,111,3458,111,2406,111,2662,111,2790,111,3046,111,3174,111,3302,111,3430,111,3664,111,3792,111,4160,111,1637,111,1781,111,65359,111,8500,111,119848,111,119900,111,119952,111,120056,111,120108,111,120160,111,120212,111,120264,111,120316,111,120368,111,120420,111,120472,111,7439,111,7441,111,43837,111,959,111,120528,111,120586,111,120644,111,120702,111,120760,111,963,111,120532,111,120590,111,120648,111,120706,111,120764,111,11423,111,4351,111,1413,111,1505,111,1607,111,126500,111,126564,111,126596,111,65259,111,65260,111,65258,111,65257,111,1726,111,64428,111,64429,111,64427,111,64426,111,1729,111,64424,111,64425,111,64423,111,64422,111,1749,111,3360,111,4125,111,66794,111,71880,111,71895,111,66604,111,1984,79,2534,79,2918,79,12295,79,70864,79,71904,79,120782,79,120792,79,120802,79,120812,79,120822,79,130032,79,65327,79,119822,79,119874,79,119926,79,119978,79,120030,79,120082,79,120134,79,120186,79,120238,79,120290,79,120342,79,120394,79,120446,79,927,79,120502,79,120560,79,120618,79,120676,79,120734,79,11422,79,1365,79,11604,79,4816,79,2848,79,66754,79,42227,79,71861,79,66194,79,66219,79,66564,79,66838,79,9076,112,65360,112,119849,112,119901,112,119953,112,120005,112,120057,112,120109,112,120161,112,120213,112,120265,112,120317,112,120369,112,120421,112,120473,112,961,112,120530,112,120544,112,120588,112,120602,112,120646,112,120660,112,120704,112,120718,112,120762,112,120776,112,11427,112,65328,80,8473,80,119823,80,119875,80,119927,80,119979,80,120031,80,120083,80,120187,80,120239,80,120291,80,120343,80,120395,80,120447,80,929,80,120504,80,120562,80,120620,80,120678,80,120736,80,11426,80,5090,80,5229,80,42193,80,66197,80,119850,113,119902,113,119954,113,120006,113,120058,113,120110,113,120162,113,120214,113,120266,113,120318,113,120370,113,120422,113,120474,113,1307,113,1379,113,1382,113,8474,81,119824,81,119876,81,119928,81,119980,81,120032,81,120084,81,120188,81,120240,81,120292,81,120344,81,120396,81,120448,81,11605,81,119851,114,119903,114,119955,114,120007,114,120059,114,120111,114,120163,114,120215,114,120267,114,120319,114,120371,114,120423,114,120475,114,43847,114,43848,114,7462,114,11397,114,43905,114,119318,82,8475,82,8476,82,8477,82,119825,82,119877,82,119929,82,120033,82,120189,82,120241,82,120293,82,120345,82,120397,82,120449,82,422,82,5025,82,5074,82,66740,82,5511,82,42211,82,94005,82,65363,115,119852,115,119904,115,119956,115,120008,115,120060,115,120112,115,120164,115,120216,115,120268,115,120320,115,120372,115,120424,115,120476,115,42801,115,445,115,1109,115,43946,115,71873,115,66632,115,65331,83,119826,83,119878,83,119930,83,119982,83,120034,83,120086,83,120138,83,120190,83,120242,83,120294,83,120346,83,120398,83,120450,83,1029,83,1359,83,5077,83,5082,83,42210,83,94010,83,66198,83,66592,83,119853,116,119905,116,119957,116,120009,116,120061,116,120113,116,120165,116,120217,116,120269,116,120321,116,120373,116,120425,116,120477,116,8868,84,10201,84,128872,84,65332,84,119827,84,119879,84,119931,84,119983,84,120035,84,120087,84,120139,84,120191,84,120243,84,120295,84,120347,84,120399,84,120451,84,932,84,120507,84,120565,84,120623,84,120681,84,120739,84,11430,84,5026,84,42196,84,93962,84,71868,84,66199,84,66225,84,66325,84,119854,117,119906,117,119958,117,120010,117,120062,117,120114,117,120166,117,120218,117,120270,117,120322,117,120374,117,120426,117,120478,117,42911,117,7452,117,43854,117,43858,117,651,117,965,117,120534,117,120592,117,120650,117,120708,117,120766,117,1405,117,66806,117,71896,117,8746,85,8899,85,119828,85,119880,85,119932,85,119984,85,120036,85,120088,85,120140,85,120192,85,120244,85,120296,85,120348,85,120400,85,120452,85,1357,85,4608,85,66766,85,5196,85,42228,85,94018,85,71864,85,8744,118,8897,118,65366,118,8564,118,119855,118,119907,118,119959,118,120011,118,120063,118,120115,118,120167,118,120219,118,120271,118,120323,118,120375,118,120427,118,120479,118,7456,118,957,118,120526,118,120584,118,120642,118,120700,118,120758,118,1141,118,1496,118,71430,118,43945,118,71872,118,119309,86,1639,86,1783,86,8548,86,119829,86,119881,86,119933,86,119985,86,120037,86,120089,86,120141,86,120193,86,120245,86,120297,86,120349,86,120401,86,120453,86,1140,86,11576,86,5081,86,5167,86,42719,86,42214,86,93960,86,71840,86,66845,86,623,119,119856,119,119908,119,119960,119,120012,119,120064,119,120116,119,120168,119,120220,119,120272,119,120324,119,120376,119,120428,119,120480,119,7457,119,1121,119,1309,119,1377,119,71434,119,71438,119,71439,119,43907,119,71919,87,71910,87,119830,87,119882,87,119934,87,119986,87,120038,87,120090,87,120142,87,120194,87,120246,87,120298,87,120350,87,120402,87,120454,87,1308,87,5043,87,5076,87,42218,87,5742,120,10539,120,10540,120,10799,120,65368,120,8569,120,119857,120,119909,120,119961,120,120013,120,120065,120,120117,120,120169,120,120221,120,120273,120,120325,120,120377,120,120429,120,120481,120,5441,120,5501,120,5741,88,9587,88,66338,88,71916,88,65336,88,8553,88,119831,88,119883,88,119935,88,119987,88,120039,88,120091,88,120143,88,120195,88,120247,88,120299,88,120351,88,120403,88,120455,88,42931,88,935,88,120510,88,120568,88,120626,88,120684,88,120742,88,11436,88,11613,88,5815,88,42219,88,66192,88,66228,88,66327,88,66855,88,611,121,7564,121,65369,121,119858,121,119910,121,119962,121,120014,121,120066,121,120118,121,120170,121,120222,121,120274,121,120326,121,120378,121,120430,121,120482,121,655,121,7935,121,43866,121,947,121,8509,121,120516,121,120574,121,120632,121,120690,121,120748,121,1199,121,4327,121,71900,121,65337,89,119832,89,119884,89,119936,89,119988,89,120040,89,120092,89,120144,89,120196,89,120248,89,120300,89,120352,89,120404,89,120456,89,933,89,978,89,120508,89,120566,89,120624,89,120682,89,120740,89,11432,89,1198,89,5033,89,5053,89,42220,89,94019,89,71844,89,66226,89,119859,122,119911,122,119963,122,120015,122,120067,122,120119,122,120171,122,120223,122,120275,122,120327,122,120379,122,120431,122,120483,122,7458,122,43923,122,71876,122,66293,90,71909,90,65338,90,8484,90,8488,90,119833,90,119885,90,119937,90,119989,90,120041,90,120197,90,120249,90,120301,90,120353,90,120405,90,120457,90,918,90,120493,90,120551,90,120609,90,120667,90,120725,90,5059,90,42204,90,71849,90],"_default":[160,32,8211,45,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,124,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89],"cs":[65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,124,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89],"de":[65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,124,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89],"es":[8211,45,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89],"fr":[65306,58,65281,33,8216,96,8245,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,124,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89],"it":[160,32,8211,45,65306,58,65281,33,8216,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,124,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89],"ja":[8211,45,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,124,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89],"ko":[8211,45,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,124,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89],"pl":[65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,124,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89],"pt-BR":[65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,124,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89],"qps-ploc":[160,32,8211,45,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,124,1052,77,1086,111,1054,79,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89],"ru":[65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,305,105,921,124,1009,112,215,120],"tr":[160,32,8211,45,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,1050,75,921,124,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89],"zh-hans":[65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,124,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89],"zh-hant":[8211,45,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,124,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89]}')}static getConfusablesForCurrentLocale(){if(!Ve.map){let ve=function(Te){const We=new Map;for(let Oe=0;Oe<Te.length;Oe+=2)We.set(Te[Oe],Te[Oe+1]);return We};const ae=Ve.getData();let he=p.locale;(!he||!(he in ae))&&(he=p.language),(!he||!(he in ae))&&(he="_default");const Ie=ve(ae._common),Ce=ve(ae[he]);for(const[Te,We]of Ce)Ie.set(Te,We);Ve.map=Ie}return Ve.map}static isAmbiguous(ae){return Ve.getConfusablesForCurrentLocale().has(ae)}static getPrimaryConfusable(ae){return Ve.getConfusablesForCurrentLocale().get(ae)}static getPrimaryConfusableCodePoints(){return new Set(Ve.getConfusablesForCurrentLocale().keys())}}e.AmbiguousCharacters=Ve;class He{static getRawData(){return JSON.parse("[9,10,11,12,13,32,127,160,173,847,1564,4447,4448,6068,6069,6155,6156,6157,6158,7355,7356,8192,8193,8194,8195,8196,8197,8198,8199,8200,8201,8202,8203,8204,8205,8206,8207,8234,8235,8236,8237,8238,8239,8287,8288,8289,8290,8291,8292,8293,8294,8295,8296,8297,8298,8299,8300,8301,8302,8303,10240,12288,12644,65024,65025,65026,65027,65028,65029,65030,65031,65032,65033,65034,65035,65036,65037,65038,65039,65279,65440,65520,65521,65522,65523,65524,65525,65526,65527,65528,65532,78844,119155,119156,119157,119158,119159,119160,119161,119162,917504,917505,917506,917507,917508,917509,917510,917511,917512,917513,917514,917515,917516,917517,917518,917519,917520,917521,917522,917523,917524,917525,917526,917527,917528,917529,917530,917531,917532,917533,917534,917535,917536,917537,917538,917539,917540,917541,917542,917543,917544,917545,917546,917547,917548,917549,917550,917551,917552,917553,917554,917555,917556,917557,917558,917559,917560,917561,917562,917563,917564,917565,917566,917567,917568,917569,917570,917571,917572,917573,917574,917575,917576,917577,917578,917579,917580,917581,917582,917583,917584,917585,917586,917587,917588,917589,917590,917591,917592,917593,917594,917595,917596,917597,917598,917599,917600,917601,917602,917603,917604,917605,917606,917607,917608,917609,917610,917611,917612,917613,917614,917615,917616,917617,917618,917619,917620,917621,917622,917623,917624,917625,917626,917627,917628,917629,917630,917631,917760,917761,917762,917763,917764,917765,917766,917767,917768,917769,917770,917771,917772,917773,917774,917775,917776,917777,917778,917779,917780,917781,917782,917783,917784,917785,917786,917787,917788,917789,917790,917791,917792,917793,917794,917795,917796,917797,917798,917799,917800,917801,917802,917803,917804,917805,917806,917807,917808,917809,917810,917811,917812,917813,917814,917815,917816,917817,917818,917819,917820,917821,917822,917823,917824,917825,917826,917827,917828,917829,917830,917831,917832,917833,917834,917835,917836,917837,917838,917839,917840,917841,917842,917843,917844,917845,917846,917847,917848,917849,917850,917851,917852,917853,917854,917855,917856,917857,917858,917859,917860,917861,917862,917863,917864,917865,917866,917867,917868,917869,917870,917871,917872,917873,917874,917875,917876,917877,917878,917879,917880,917881,917882,917883,917884,917885,917886,917887,917888,917889,917890,917891,917892,917893,917894,917895,917896,917897,917898,917899,917900,917901,917902,917903,917904,917905,917906,917907,917908,917909,917910,917911,917912,917913,917914,917915,917916,917917,917918,917919,917920,917921,917922,917923,917924,917925,917926,917927,917928,917929,917930,917931,917932,917933,917934,917935,917936,917937,917938,917939,917940,917941,917942,917943,917944,917945,917946,917947,917948,917949,917950,917951,917952,917953,917954,917955,917956,917957,917958,917959,917960,917961,917962,917963,917964,917965,917966,917967,917968,917969,917970,917971,917972,917973,917974,917975,917976,917977,917978,917979,917980,917981,917982,917983,917984,917985,917986,917987,917988,917989,917990,917991,917992,917993,917994,917995,917996,917997,917998,917999]")}static getData(){return this._data||(this._data=new Set(He.getRawData())),this._data}static isInvisibleCharacter(ae){return He.getData().has(ae)}static get codePoints(){return He.getData()}}e.InvisibleCharacters=He,He._data=void 0}),define(x[81],ee([0,1,25]),function(V,e,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StringSHA1=e.toHexString=e.Hasher=e.stringHash=e.numberHash=e.doHash=e.hash=void 0;function R(b){return C(b,0)}e.hash=R;function C(b,P){switch(typeof b){case"object":return b===null?k(349,P):Array.isArray(b)?d(b,P):f(b,P);case"string":return I(b,P);case"boolean":return n(b,P);case"number":return k(b,P);case"undefined":return k(937,P);default:return k(617,P)}}e.doHash=C;function k(b,P){return(P<<5)-P+b|0}e.numberHash=k;function n(b,P){return k(b?433:863,P)}function I(b,P){P=k(149417,P);for(let c=0,a=b.length;c<a;c++)P=k(b.charCodeAt(c),P);return P}e.stringHash=I;function d(b,P){return P=k(104579,P),b.reduce((c,a)=>C(a,c),P)}function f(b,P){return P=k(181387,P),Object.keys(b).sort().reduce((c,a)=>(c=I(a,c),C(b[a],c)),P)}class y{constructor(){this._value=0}get value(){return this._value}hash(P){return this._value=C(P,this._value),this._value}}e.Hasher=y;var E;(function(b){b[b.BLOCK_SIZE=64]="BLOCK_SIZE",b[b.UNICODE_REPLACEMENT=65533]="UNICODE_REPLACEMENT"})(E||(E={}));function g(b,P,c=32){const a=c-P,l=~((1<<a)-1);return(b<<P|(l&b)>>>a)>>>0}function S(b,P=0,c=b.byteLength,a=0){for(let l=0;l<c;l++)b[P+l]=a}function t(b,P,c="0"){for(;b.length<P;)b=c+b;return b}function m(b,P=32){return b instanceof ArrayBuffer?Array.from(new Uint8Array(b)).map(c=>c.toString(16).padStart(2,"0")).join(""):t((b>>>0).toString(16),P/4)}e.toHexString=m;class v{constructor(){this._h0=1732584193,this._h1=4023233417,this._h2=2562383102,this._h3=271733878,this._h4=3285377520,this._buff=new Uint8Array(64+3),this._buffDV=new DataView(this._buff.buffer),this._buffLen=0,this._totalLen=0,this._leftoverHighSurrogate=0,this._finished=!1}update(P){const c=P.length;if(c===0)return;const a=this._buff;let l=this._buffLen,o=this._leftoverHighSurrogate,u,r;for(o!==0?(u=o,r=-1,o=0):(u=P.charCodeAt(0),r=0);;){let i=u;if(p.isHighSurrogate(u))if(r+1<c){const s=P.charCodeAt(r+1);p.isLowSurrogate(s)?(r++,i=p.computeCodePoint(u,s)):i=65533}else{o=u;break}else p.isLowSurrogate(u)&&(i=65533);if(l=this._push(a,l,i),r++,r<c)u=P.charCodeAt(r);else break}this._buffLen=l,this._leftoverHighSurrogate=o}_push(P,c,a){return a<128?P[c++]=a:a<2048?(P[c++]=192|(a&1984)>>>6,P[c++]=128|(a&63)>>>0):a<65536?(P[c++]=224|(a&61440)>>>12,P[c++]=128|(a&4032)>>>6,P[c++]=128|(a&63)>>>0):(P[c++]=240|(a&1835008)>>>18,P[c++]=128|(a&258048)>>>12,P[c++]=128|(a&4032)>>>6,P[c++]=128|(a&63)>>>0),c>=64&&(this._step(),c-=64,this._totalLen+=64,P[0]=P[64+0],P[1]=P[64+1],P[2]=P[64+2]),c}digest(){return this._finished||(this._finished=!0,this._leftoverHighSurrogate&&(this._leftoverHighSurrogate=0,this._buffLen=this._push(this._buff,this._buffLen,65533)),this._totalLen+=this._buffLen,this._wrapUp()),m(this._h0)+m(this._h1)+m(this._h2)+m(this._h3)+m(this._h4)}_wrapUp(){this._buff[this._buffLen++]=128,S(this._buff,this._buffLen),this._buffLen>56&&(this._step(),S(this._buff));const P=8*this._totalLen;this._buffDV.setUint32(56,Math.floor(P/4294967296),!1),this._buffDV.setUint32(60,P%4294967296,!1),this._step()}_step(){const P=v._bigBlock32,c=this._buffDV;for(let w=0;w<64;w+=4)P.setUint32(w,c.getUint32(w,!1),!1);for(let w=64;w<320;w+=4)P.setUint32(w,g(P.getUint32(w-12,!1)^P.getUint32(w-32,!1)^P.getUint32(w-56,!1)^P.getUint32(w-64,!1),1),!1);let a=this._h0,l=this._h1,o=this._h2,u=this._h3,r=this._h4,i,s,h;for(let w=0;w<80;w++)w<20?(i=l&o|~l&u,s=1518500249):w<40?(i=l^o^u,s=1859775393):w<60?(i=l&o|l&u|o&u,s=2400959708):(i=l^o^u,s=3395469782),h=g(a,5)+i+r+s+P.getUint32(w*4,!1)&4294967295,r=u,u=o,o=g(l,30),l=a,a=h;this._h0=this._h0+a&4294967295,this._h1=this._h1+l&4294967295,this._h2=this._h2+o&4294967295,this._h3=this._h3+u&4294967295,this._h4=this._h4+r&4294967295}}e.StringSHA1=v,v._bigBlock32=new DataView(new ArrayBuffer(320))});var kt=this&&this.__classPrivateFieldSet||function(V,e,p,R,C){if(R==="m")throw new TypeError("Private method is not writable");if(R==="a"&&!C)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?V!==e||!C:!e.has(V))throw new TypeError("Cannot write private member to an object whose class did not declare it");return R==="a"?C.call(V,p):C?C.value=p:e.set(V,p),p},Ke=this&&this.__classPrivateFieldGet||function(V,e,p,R){if(p==="a"&&!R)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?V!==e||!R:!e.has(V))throw new TypeError("Cannot read private member from an object whose class did not declare it");return p==="m"?R:p==="a"?R.call(V):R?R.value:e.get(V)};define(x[39],ee([0,1,30,25]),function(V,e,p,R){"use strict";var C,k,n;Object.defineProperty(e,"__esModule",{value:!0}),e.ReadonlyMapView=e.LRUCache=e.LinkedMap=e.Touch=e.ResourceMap=e.TernarySearchTree=e.UriIterator=e.PathIterator=e.ConfigKeysIterator=e.StringIterator=e.setToString=e.mapToString=e.getOrSet=void 0;function I(r,i,s){let h=r.get(i);return h===void 0&&(h=s,r.set(i,h)),h}e.getOrSet=I;function d(r){const i=[];return r.forEach((s,h)=>{i.push(`${h} => ${s}`)}),`Map(${r.size}) {${i.join(", ")}}`}e.mapToString=d;function f(r){const i=[];return r.forEach(s=>{i.push(s)}),`Set(${r.size}) {${i.join(", ")}}`}e.setToString=f;class y{constructor(){this._value="",this._pos=0}reset(i){return this._value=i,this._pos=0,this}next(){return this._pos+=1,this}hasNext(){return this._pos<this._value.length-1}cmp(i){const s=i.charCodeAt(0),h=this._value.charCodeAt(this._pos);return s-h}value(){return this._value[this._pos]}}e.StringIterator=y;class E{constructor(i=!0){this._caseSensitive=i}reset(i){return this._value=i,this._from=0,this._to=0,this.next()}hasNext(){return this._to<this._value.length}next(){this._from=this._to;let i=!0;for(;this._to<this._value.length;this._to++)if(this._value.charCodeAt(this._to)===46)if(i)this._from++;else break;else i=!1;return this}cmp(i){return this._caseSensitive?(0,R.compareSubstring)(i,this._value,0,i.length,this._from,this._to):(0,R.compareSubstringIgnoreCase)(i,this._value,0,i.length,this._from,this._to)}value(){return this._value.substring(this._from,this._to)}}e.ConfigKeysIterator=E;class g{constructor(i=!0,s=!0){this._splitOnBackslash=i,this._caseSensitive=s}reset(i){return this._value=i.replace(/\\$|\/$/,""),this._from=0,this._to=0,this.next()}hasNext(){return this._to<this._value.length}next(){this._from=this._to;let i=!0;for(;this._to<this._value.length;this._to++){const s=this._value.charCodeAt(this._to);if(s===47||this._splitOnBackslash&&s===92)if(i)this._from++;else break;else i=!1}return this}cmp(i){return this._caseSensitive?(0,R.compareSubstring)(i,this._value,0,i.length,this._from,this._to):(0,R.compareSubstringIgnoreCase)(i,this._value,0,i.length,this._from,this._to)}value(){return this._value.substring(this._from,this._to)}}e.PathIterator=g;var S;(function(r){r[r.Scheme=1]="Scheme",r[r.Authority=2]="Authority",r[r.Path=3]="Path",r[r.Query=4]="Query",r[r.Fragment=5]="Fragment"})(S||(S={}));class t{constructor(i){this._ignorePathCasing=i,this._states=[],this._stateIdx=0}reset(i){return this._value=i,this._states=[],this._value.scheme&&this._states.push(1),this._value.authority&&this._states.push(2),this._value.path&&(this._pathIterator=new g(!1,!this._ignorePathCasing(i)),this._pathIterator.reset(i.path),this._pathIterator.value()&&this._states.push(3)),this._value.query&&this._states.push(4),this._value.fragment&&this._states.push(5),this._stateIdx=0,this}next(){return this._states[this._stateIdx]===3&&this._pathIterator.hasNext()?this._pathIterator.next():this._stateIdx+=1,this}hasNext(){return this._states[this._stateIdx]===3&&this._pathIterator.hasNext()||this._stateIdx<this._states.length-1}cmp(i){if(this._states[this._stateIdx]===1)return(0,R.compareIgnoreCase)(i,this._value.scheme);if(this._states[this._stateIdx]===2)return(0,R.compareIgnoreCase)(i,this._value.authority);if(this._states[this._stateIdx]===3)return this._pathIterator.cmp(i);if(this._states[this._stateIdx]===4)return(0,R.compare)(i,this._value.query);if(this._states[this._stateIdx]===5)return(0,R.compare)(i,this._value.fragment);throw new Error}value(){if(this._states[this._stateIdx]===1)return this._value.scheme;if(this._states[this._stateIdx]===2)return this._value.authority;if(this._states[this._stateIdx]===3)return this._pathIterator.value();if(this._states[this._stateIdx]===4)return this._value.query;if(this._states[this._stateIdx]===5)return this._value.fragment;throw new Error}}e.UriIterator=t;class m{constructor(){this.height=1}isEmpty(){return!this.left&&!this.mid&&!this.right&&!this.value}rotateLeft(){const i=this.right;return this.right=i.left,i.left=this,this.updateHeight(),i.updateHeight(),i}rotateRight(){const i=this.left;return this.left=i.right,i.right=this,this.updateHeight(),i.updateHeight(),i}updateHeight(){this.height=1+Math.max(this.heightLeft,this.heightRight)}balanceFactor(){return this.heightRight-this.heightLeft}get heightLeft(){return this.left?.height??0}get heightRight(){return this.right?.height??0}}var v;(function(r){r[r.Left=-1]="Left",r[r.Mid=0]="Mid",r[r.Right=1]="Right"})(v||(v={}));class b{constructor(i){this._iter=i}static forUris(i=()=>!1){return new b(new t(i))}static forPaths(){return new b(new g)}static forStrings(){return new b(new y)}static forConfigKeys(){return new b(new E)}clear(){this._root=void 0}fill(i,s){if(s){const h=s.slice(0);(0,p.shuffle)(h);for(let w of h)this.set(w,i)}else{const h=i.slice(0);(0,p.shuffle)(h);for(let w of h)this.set(w[0],w[1])}}set(i,s){const h=this._iter.reset(i);let w;this._root||(this._root=new m,this._root.segment=h.value());const M=[];for(w=this._root;;){const L=h.cmp(w.segment);if(L>0)w.left||(w.left=new m,w.left.segment=h.value()),M.push([-1,w]),w=w.left;else if(L<0)w.right||(w.right=new m,w.right.segment=h.value()),M.push([1,w]),w=w.right;else if(h.hasNext())h.next(),w.mid||(w.mid=new m,w.mid.segment=h.value()),M.push([0,w]),w=w.mid;else break}const A=w.value;w.value=s,w.key=i;for(let L=M.length-1;L>=0;L--){const F=M[L][1];F.updateHeight();const U=F.balanceFactor();if(U<-1||U>1){const Y=M[L][0],ie=M[L+1][0];if(Y===1&&ie===1)M[L][1]=F.rotateLeft();else if(Y===-1&&ie===-1)M[L][1]=F.rotateRight();else if(Y===1&&ie===-1)F.right=M[L+1][1]=M[L+1][1].rotateRight(),M[L][1]=F.rotateLeft();else if(Y===-1&&ie===1)F.left=M[L+1][1]=M[L+1][1].rotateLeft(),M[L][1]=F.rotateRight();else throw new Error;if(L>0)switch(M[L-1][0]){case-1:M[L-1][1].left=M[L][1];break;case 1:M[L-1][1].right=M[L][1];break;case 0:M[L-1][1].mid=M[L][1];break}else this._root=M[0][1]}}return A}get(i){return this._getNode(i)?.value}_getNode(i){const s=this._iter.reset(i);let h=this._root;for(;h;){const w=s.cmp(h.segment);if(w>0)h=h.left;else if(w<0)h=h.right;else if(s.hasNext())s.next(),h=h.mid;else break}return h}has(i){const s=this._getNode(i);return!(s?.value===void 0&&s?.mid===void 0)}delete(i){return this._delete(i,!1)}deleteSuperstr(i){return this._delete(i,!0)}_delete(i,s){const h=this._iter.reset(i),w=[];let M=this._root;for(;M;){const A=h.cmp(M.segment);if(A>0)w.push([-1,M]),M=M.left;else if(A<0)w.push([1,M]),M=M.right;else if(h.hasNext())h.next(),w.push([0,M]),M=M.mid;else break}if(!!M){if(s?(M.left=void 0,M.mid=void 0,M.right=void 0,M.height=1):(M.key=void 0,M.value=void 0),!M.mid&&!M.value)if(M.left&&M.right){const A=this._min(M.right),{key:L,value:F,segment:U}=A;this._delete(A.key,!1),M.key=L,M.value=F,M.segment=U}else{const A=M.left??M.right;if(w.length>0){const[L,F]=w[w.length-1];switch(L){case-1:F.left=A;break;case 0:F.mid=A;break;case 1:F.right=A;break}}else this._root=A}for(let A=w.length-1;A>=0;A--){const L=w[A][1];L.updateHeight();const F=L.balanceFactor();if(F>1?(L.right.balanceFactor()>=0||(L.right=w[A+1][1]=w[A+1][1].rotateRight()),w[A][1]=L.rotateLeft()):F<-1&&(L.left.balanceFactor()<=0||(L.left=w[A+1][1]=w[A+1][1].rotateLeft()),w[A][1]=L.rotateRight()),A>0)switch(w[A-1][0]){case-1:w[A-1][1].left=w[A][1];break;case 1:w[A-1][1].right=w[A][1];break;case 0:w[A-1][1].mid=w[A][1];break}else this._root=w[0][1]}}}_min(i){for(;i.left;)i=i.left;return i}findSubstr(i){const s=this._iter.reset(i);let h=this._root,w;for(;h;){const M=s.cmp(h.segment);if(M>0)h=h.left;else if(M<0)h=h.right;else if(s.hasNext())s.next(),w=h.value||w,h=h.mid;else break}return h&&h.value||w}findSuperstr(i){const s=this._iter.reset(i);let h=this._root;for(;h;){const w=s.cmp(h.segment);if(w>0)h=h.left;else if(w<0)h=h.right;else if(s.hasNext())s.next(),h=h.mid;else return h.mid?this._entries(h.mid):void 0}}forEach(i){for(const[s,h]of this)i(h,s)}*[Symbol.iterator](){yield*this._entries(this._root)}*_entries(i){!i||(i.left&&(yield*this._entries(i.left)),i.value&&(yield[i.key,i.value]),i.mid&&(yield*this._entries(i.mid)),i.right&&(yield*this._entries(i.right)))}_isBalanced(){const i=s=>{if(!s)return!0;const h=s.balanceFactor();return h<-1||h>1?!1:i(s.left)&&i(s.right)};return i(this._root)}}e.TernarySearchTree=b;class P{constructor(i,s){this.uri=i,this.value=s}}class c{constructor(i,s){this[C]="ResourceMap",i instanceof c?(this.map=new Map(i.map),this.toKey=s??c.defaultToKey):(this.map=new Map,this.toKey=i??c.defaultToKey)}set(i,s){return this.map.set(this.toKey(i),new P(i,s)),this}get(i){return this.map.get(this.toKey(i))?.value}has(i){return this.map.has(this.toKey(i))}get size(){return this.map.size}clear(){this.map.clear()}delete(i){return this.map.delete(this.toKey(i))}forEach(i,s){typeof s!="undefined"&&(i=i.bind(s));for(let[h,w]of this.map)i(w.value,w.uri,this)}*values(){for(let i of this.map.values())yield i.value}*keys(){for(let i of this.map.values())yield i.uri}*entries(){for(let i of this.map.values())yield[i.uri,i.value]}*[(C=Symbol.toStringTag,Symbol.iterator)](){for(let[,i]of this.map)yield[i.uri,i.value]}}e.ResourceMap=c,c.defaultToKey=r=>r.toString();var a;(function(r){r[r.None=0]="None",r[r.AsOld=1]="AsOld",r[r.AsNew=2]="AsNew"})(a=e.Touch||(e.Touch={}));class l{constructor(){this[k]="LinkedMap",this._map=new Map,this._head=void 0,this._tail=void 0,this._size=0,this._state=0}clear(){this._map.clear(),this._head=void 0,this._tail=void 0,this._size=0,this._state++}isEmpty(){return!this._head&&!this._tail}get size(){return this._size}get first(){return this._head?.value}get last(){return this._tail?.value}has(i){return this._map.has(i)}get(i,s=0){const h=this._map.get(i);if(!!h)return s!==0&&this.touch(h,s),h.value}set(i,s,h=0){let w=this._map.get(i);if(w)w.value=s,h!==0&&this.touch(w,h);else{switch(w={key:i,value:s,next:void 0,previous:void 0},h){case 0:this.addItemLast(w);break;case 1:this.addItemFirst(w);break;case 2:this.addItemLast(w);break;default:this.addItemLast(w);break}this._map.set(i,w),this._size++}return this}delete(i){return!!this.remove(i)}remove(i){const s=this._map.get(i);if(!!s)return this._map.delete(i),this.removeItem(s),this._size--,s.value}shift(){if(!this._head&&!this._tail)return;if(!this._head||!this._tail)throw new Error("Invalid list");const i=this._head;return this._map.delete(i.key),this.removeItem(i),this._size--,i.value}forEach(i,s){const h=this._state;let w=this._head;for(;w;){if(s?i.bind(s)(w.value,w.key,this):i(w.value,w.key,this),this._state!==h)throw new Error("LinkedMap got modified during iteration.");w=w.next}}keys(){const i=this,s=this._state;let h=this._head;const w={[Symbol.iterator](){return w},next(){if(i._state!==s)throw new Error("LinkedMap got modified during iteration.");if(h){const M={value:h.key,done:!1};return h=h.next,M}else return{value:void 0,done:!0}}};return w}values(){const i=this,s=this._state;let h=this._head;const w={[Symbol.iterator](){return w},next(){if(i._state!==s)throw new Error("LinkedMap got modified during iteration.");if(h){const M={value:h.value,done:!1};return h=h.next,M}else return{value:void 0,done:!0}}};return w}entries(){const i=this,s=this._state;let h=this._head;const w={[Symbol.iterator](){return w},next(){if(i._state!==s)throw new Error("LinkedMap got modified during iteration.");if(h){const M={value:[h.key,h.value],done:!1};return h=h.next,M}else return{value:void 0,done:!0}}};return w}[(k=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}trimOld(i){if(i>=this.size)return;if(i===0){this.clear();return}let s=this._head,h=this.size;for(;s&&h>i;)this._map.delete(s.key),s=s.next,h--;this._head=s,this._size=h,s&&(s.previous=void 0),this._state++}addItemFirst(i){if(!this._head&&!this._tail)this._tail=i;else if(this._head)i.next=this._head,this._head.previous=i;else throw new Error("Invalid list");this._head=i,this._state++}addItemLast(i){if(!this._head&&!this._tail)this._head=i;else if(this._tail)i.previous=this._tail,this._tail.next=i;else throw new Error("Invalid list");this._tail=i,this._state++}removeItem(i){if(i===this._head&&i===this._tail)this._head=void 0,this._tail=void 0;else if(i===this._head){if(!i.next)throw new Error("Invalid list");i.next.previous=void 0,this._head=i.next}else if(i===this._tail){if(!i.previous)throw new Error("Invalid list");i.previous.next=void 0,this._tail=i.previous}else{const s=i.next,h=i.previous;if(!s||!h)throw new Error("Invalid list");s.previous=h,h.next=s}i.next=void 0,i.previous=void 0,this._state++}touch(i,s){if(!this._head||!this._tail)throw new Error("Invalid list");if(!(s!==1&&s!==2)){if(s===1){if(i===this._head)return;const h=i.next,w=i.previous;i===this._tail?(w.next=void 0,this._tail=w):(h.previous=w,w.next=h),i.previous=void 0,i.next=this._head,this._head.previous=i,this._head=i,this._state++}else if(s===2){if(i===this._tail)return;const h=i.next,w=i.previous;i===this._head?(h.previous=void 0,this._head=h):(h.previous=w,w.next=h),i.next=void 0,i.previous=this._tail,this._tail.next=i,this._tail=i,this._state++}}}toJSON(){const i=[];return this.forEach((s,h)=>{i.push([h,s])}),i}fromJSON(i){this.clear();for(const[s,h]of i)this.set(s,h)}}e.LinkedMap=l;class o extends l{constructor(i,s=1){super();this._limit=i,this._ratio=Math.min(Math.max(0,s),1)}get limit(){return this._limit}set limit(i){this._limit=i,this.checkTrim()}get ratio(){return this._ratio}set ratio(i){this._ratio=Math.min(Math.max(0,i),1),this.checkTrim()}get(i,s=2){return super.get(i,s)}peek(i){return super.get(i,0)}set(i,s){return super.set(i,s,2),this.checkTrim(),this}checkTrim(){this.size>this._limit&&this.trimOld(Math.round(this._limit*this._ratio))}}e.LRUCache=o;class u{constructor(i){n.set(this,void 0),kt(this,n,i,"f")}get size(){return Ke(this,n,"f").size}forEach(i,s){Ke(this,n,"f").forEach(i,s)}get(i){return Ke(this,n,"f").get(i)}has(i){return Ke(this,n,"f").has(i)}entries(){return Ke(this,n,"f").entries()}keys(){return Ke(this,n,"f").keys()}values(){return Ke(this,n,"f").values()}[(n=new WeakMap,Symbol.iterator)](){return Ke(this,n,"f").entries()}}e.ReadonlyMapView=u}),define(x[70],ee([0,1,39]),function(V,e,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.removeAccents=e.normalizeNFD=e.normalizeNFC=void 0;const R=new p.LRUCache(1e4);function C(f){return d(f,"NFC",R)}e.normalizeNFC=C;const k=new p.LRUCache(1e4);function n(f){return d(f,"NFD",k)}e.normalizeNFD=n;const I=/[^\u0000-\u0080]/;function d(f,y,E){if(!f)return f;const g=E.get(f);if(g)return g;let S;return I.test(f)?S=f.normalize(y):S=f,E.set(f,S),S}e.removeAccents=function(){const f=/[\u0300-\u036f]/g;return function(y){return n(y).replace(f,"")}}()}),define(x[13],ee([0,1]),function(V,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isPromise=e.assertNever=e.NotImplementedProxy=e.withUndefinedAsNull=e.withNullAsUndefined=e.createProxyObject=e.getAllMethodNames=e.getAllPropertyNames=e.validateConstraint=e.validateConstraints=e.areFunctions=e.isFunction=e.isEmptyObject=e.assertAllDefined=e.assertIsDefined=e.assertType=e.isUndefinedOrNull=e.isDefined=e.isUndefined=e.isBoolean=e.isIterable=e.isNumber=e.isObject=e.isStringArray=e.isString=e.isArray=void 0;function p(M){return Array.isArray(M)}e.isArray=p;function R(M){return typeof M=="string"}e.isString=R;function C(M){return Array.isArray(M)&&M.every(A=>R(A))}e.isStringArray=C;function k(M){return typeof M=="object"&&M!==null&&!Array.isArray(M)&&!(M instanceof RegExp)&&!(M instanceof Date)}e.isObject=k;function n(M){return typeof M=="number"&&!isNaN(M)}e.isNumber=n;function I(M){return!!M&&typeof M[Symbol.iterator]=="function"}e.isIterable=I;function d(M){return M===!0||M===!1}e.isBoolean=d;function f(M){return typeof M=="undefined"}e.isUndefined=f;function y(M){return!E(M)}e.isDefined=y;function E(M){return f(M)||M===null}e.isUndefinedOrNull=E;function g(M,A){if(!M)throw new Error(A?`Unexpected type, expected '${A}'`:"Unexpected type")}e.assertType=g;function S(M){if(E(M))throw new Error("Assertion Failed: argument is undefined or null");return M}e.assertIsDefined=S;function t(...M){const A=[];for(let L=0;L<M.length;L++){const F=M[L];if(E(F))throw new Error(`Assertion Failed: argument at index ${L} is undefined or null`);A.push(F)}return A}e.assertAllDefined=t;const m=Object.prototype.hasOwnProperty;function v(M){if(!k(M))return!1;for(let A in M)if(m.call(M,A))return!1;return!0}e.isEmptyObject=v;function b(M){return typeof M=="function"}e.isFunction=b;function P(...M){return M.length>0&&M.every(b)}e.areFunctions=P;function c(M,A){const L=Math.min(M.length,A.length);for(let F=0;F<L;F++)a(M[F],A[F])}e.validateConstraints=c;function a(M,A){if(R(A)){if(typeof M!==A)throw new Error(`argument does not match constraint: typeof ${A}`)}else if(b(A)){try{if(M instanceof A)return}catch{}if(!E(M)&&M.constructor===A||A.length===1&&A.call(void 0,M)===!0)return;throw new Error("argument does not match one of these constraints: arg instanceof constraint, arg.constructor === constraint, nor constraint(arg) === true")}}e.validateConstraint=a;function l(M){let A=[],L=Object.getPrototypeOf(M);for(;Object.prototype!==L;)A=A.concat(Object.getOwnPropertyNames(L)),L=Object.getPrototypeOf(L);return A}e.getAllPropertyNames=l;function o(M){const A=[];for(const L of l(M))typeof M[L]=="function"&&A.push(L);return A}e.getAllMethodNames=o;function u(M,A){const L=U=>function(){const Y=Array.prototype.slice.call(arguments,0);return A(U,Y)};let F={};for(const U of M)F[U]=L(U);return F}e.createProxyObject=u;function r(M){return M===null?void 0:M}e.withNullAsUndefined=r;function i(M){return typeof M=="undefined"?null:M}e.withUndefinedAsNull=i;function s(M){return class{constructor(){return new Proxy({},{get(A,L){if(A[L])return A[L];throw new Error(`Not Implemented: ${M}->${String(L)}`)}})}}}e.NotImplementedProxy=s;function h(M,A="Unreachable"){throw new Error(A)}e.assertNever=h;function w(M){return!!M&&typeof M.then=="function"&&typeof M.catch=="function"}e.isPromise=w}),define(x[32],ee([0,1,8,3,25,13]),function(V,e,p,R,C,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parseLineAndColumnAware=e.indexOfPath=e.getDriveLetter=e.hasDriveLetter=e.isRootOrDriveLetter=e.sanitizeFilePath=e.isWindowsDriveLetter=e.isEqualOrParent=e.isEqual=e.isValidBasename=e.isUNC=e.getRoot=e.toPosixPath=e.toSlashes=e.isPathSeparator=void 0;function n(r){return r===47||r===92}e.isPathSeparator=n;function I(r){return r.replace(/[\\/]/g,p.posix.sep)}e.toSlashes=I;function d(r){return r.indexOf("/")===-1&&(r=I(r)),/^[a-zA-Z]:(\/|$)/.test(r)&&(r="/"+r),r}e.toPosixPath=d;function f(r,i=p.posix.sep){if(!r)return"";const s=r.length,h=r.charCodeAt(0);if(n(h)){if(n(r.charCodeAt(1))&&!n(r.charCodeAt(2))){let M=3;const A=M;for(;M<s&&!n(r.charCodeAt(M));M++);if(A!==M&&!n(r.charCodeAt(M+1))){for(M+=1;M<s;M++)if(n(r.charCodeAt(M)))return r.slice(0,M+1).replace(/[\\/]/g,i)}}return i}else if(b(h)&&r.charCodeAt(1)===58)return n(r.charCodeAt(2))?r.slice(0,2)+i:r.slice(0,2);let w=r.indexOf("://");if(w!==-1){for(w+=3;w<s;w++)if(n(r.charCodeAt(w)))return r.slice(0,w+1)}return""}e.getRoot=f;function y(r){if(!R.isWindows||!r||r.length<5)return!1;let i=r.charCodeAt(0);if(i!==92||(i=r.charCodeAt(1),i!==92))return!1;let s=2;const h=s;for(;s<r.length&&(i=r.charCodeAt(s),i!==92);s++);return!(h===s||(i=r.charCodeAt(s+1),isNaN(i)||i===92))}e.isUNC=y;const E=/[\\/:\*\?"<>\|]/g,g=/[\\/]/g,S=/^(con|prn|aux|clock\$|nul|lpt[0-9]|com[0-9])(\.(.*?))?$/i;function t(r,i=R.isWindows){const s=i?E:g;return!(!r||r.length===0||/^\s+$/.test(r)||(s.lastIndex=0,s.test(r))||i&&S.test(r)||r==="."||r===".."||i&&r[r.length-1]==="."||i&&r.length!==r.trim().length||r.length>255)}e.isValidBasename=t;function m(r,i,s){const h=r===i;return!s||h?h:!r||!i?!1:(0,C.equalsIgnoreCase)(r,i)}e.isEqual=m;function v(r,i,s,h=p.sep){if(r===i)return!0;if(!r||!i||i.length>r.length)return!1;if(s){if(!(0,C.startsWithIgnoreCase)(r,i))return!1;if(i.length===r.length)return!0;let M=i.length;return i.charAt(i.length-1)===h&&M--,r.charAt(M)===h}return i.charAt(i.length-1)!==h&&(i+=h),r.indexOf(i)===0}e.isEqualOrParent=v;function b(r){return r>=65&&r<=90||r>=97&&r<=122}e.isWindowsDriveLetter=b;function P(r,i){return R.isWindows&&r.endsWith(":")&&(r+=p.sep),(0,p.isAbsolute)(r)||(r=(0,p.join)(i,r)),r=(0,p.normalize)(r),R.isWindows?(r=(0,C.rtrim)(r,p.sep),r.endsWith(":")&&(r+=p.sep)):(r=(0,C.rtrim)(r,p.sep),r||(r=p.sep)),r}e.sanitizeFilePath=P;function c(r){const i=(0,p.normalize)(r);return R.isWindows?r.length>3?!1:a(i)&&(r.length===2||i.charCodeAt(2)===92):i===p.posix.sep}e.isRootOrDriveLetter=c;function a(r,i){return(i!==void 0?i:R.isWindows)?b(r.charCodeAt(0))&&r.charCodeAt(1)===58:!1}e.hasDriveLetter=a;function l(r){return a(r)?r[0]:void 0}e.getDriveLetter=l;function o(r,i,s){return i.length>r.length?-1:r===i?0:(s&&(r=r.toLowerCase(),i=i.toLowerCase()),r.indexOf(i))}e.indexOfPath=o;function u(r){const i=r.split(":");let s,h,w;if(i.forEach(M=>{const A=Number(M);(0,k.isNumber)(A)?h===void 0?h=A:w===void 0&&(w=A):s=s?[s,M].join(":"):M}),!s)throw new Error("Format for `--goto` should be: `FILE:LINE(:COLUMN)`");return{path:s,line:h!==void 0?h:void 0,column:w!==void 0?w:h!==void 0?1:void 0}}e.parseLineAndColumnAware=u}),define(x[47],ee([0,1,13]),function(V,e,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.filter=e.getCaseInsensitive=e.distinct=e.getOrDefault=e.safeStringify=e.equals=e.mixin=e.cloneAndChange=e.deepFreeze=e.deepClone=void 0;function R(m){if(!m||typeof m!="object"||m instanceof RegExp)return m;const v=Array.isArray(m)?[]:{};return Object.keys(m).forEach(b=>{m[b]&&typeof m[b]=="object"?v[b]=R(m[b]):v[b]=m[b]}),v}e.deepClone=R;function C(m){if(!m||typeof m!="object")return m;const v=[m];for(;v.length>0;){const b=v.shift();Object.freeze(b);for(const P in b)if(k.call(b,P)){const c=b[P];typeof c=="object"&&!Object.isFrozen(c)&&v.push(c)}}return m}e.deepFreeze=C;const k=Object.prototype.hasOwnProperty;function n(m,v){return I(m,v,new Set)}e.cloneAndChange=n;function I(m,v,b){if((0,p.isUndefinedOrNull)(m))return m;const P=v(m);if(typeof P!="undefined")return P;if((0,p.isArray)(m)){const c=[];for(const a of m)c.push(I(a,v,b));return c}if((0,p.isObject)(m)){if(b.has(m))throw new Error("Cannot clone recursive data-structure");b.add(m);const c={};for(let a in m)k.call(m,a)&&(c[a]=I(m[a],v,b));return b.delete(m),c}return m}function d(m,v,b=!0){return(0,p.isObject)(m)?((0,p.isObject)(v)&&Object.keys(v).forEach(P=>{P in m?b&&((0,p.isObject)(m[P])&&(0,p.isObject)(v[P])?d(m[P],v[P],b):m[P]=v[P]):m[P]=v[P]}),m):v}e.mixin=d;function f(m,v){if(m===v)return!0;if(m==null||v===null||v===void 0||typeof m!=typeof v||typeof m!="object"||Array.isArray(m)!==Array.isArray(v))return!1;let b,P;if(Array.isArray(m)){if(m.length!==v.length)return!1;for(b=0;b<m.length;b++)if(!f(m[b],v[b]))return!1}else{const c=[];for(P in m)c.push(P);c.sort();const a=[];for(P in v)a.push(P);if(a.sort(),!f(c,a))return!1;for(b=0;b<c.length;b++)if(!f(m[c[b]],v[c[b]]))return!1}return!0}e.equals=f;function y(m){const v=new Set;return JSON.stringify(m,(b,P)=>{if((0,p.isObject)(P)||Array.isArray(P)){if(v.has(P))return"[Circular]";v.add(P)}return P})}e.safeStringify=y;function E(m,v,b){const P=v(m);return typeof P=="undefined"?b:P}e.getOrDefault=E;function g(m,v){const b=Object.create(null);return!m||!v||Object.keys(v).forEach(c=>{const a=m[c],l=v[c];f(a,l)||(b[c]=l)}),b}e.distinct=g;function S(m,v){const b=v.toLowerCase(),P=Object.keys(m).find(c=>c.toLowerCase()===b);return P?m[P]:m[v]}e.getCaseInsensitive=S;function t(m,v){const b=Object.create(null);for(const[P,c]of Object.entries(m))v(P,c)&&(b[P]=c);return b}e.filter=t}),define(x[7],ee([0,1,8,3]),function(V,e,p,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.uriToFsPath=e.URI=void 0;const C=/^\w[\w\d+.-]*$/,k=/^\//,n=/^\/\//;function I(r,i){if(!r.scheme&&i)throw new Error(`[UriError]: Scheme is missing: {scheme: "", authority: "${r.authority}", path: "${r.path}", query: "${r.query}", fragment: "${r.fragment}"}`);if(r.scheme&&!C.test(r.scheme))throw new Error("[UriError]: Scheme contains illegal characters.");if(r.path){if(r.authority){if(!k.test(r.path))throw new Error('[UriError]: If a URI contains an authority component, then the path component must either be empty or begin with a slash ("/") character')}else if(n.test(r.path))throw new Error('[UriError]: If a URI does not contain an authority component, then the path cannot begin with two slash characters ("//")')}}function d(r,i){return!r&&!i?"file":r}function f(r,i){switch(r){case"https":case"http":case"file":i?i[0]!==E&&(i=E+i):i=E;break}return i}const y="",E="/",g=/^(([^:/?#]+?):)?(\/\/([^/?#]*))?([^?#]*)(\?([^#]*))?(#(.*))?/;class S{constructor(i,s,h,w,M,A=!1){typeof i=="object"?(this.scheme=i.scheme||y,this.authority=i.authority||y,this.path=i.path||y,this.query=i.query||y,this.fragment=i.fragment||y):(this.scheme=d(i,A),this.authority=s||y,this.path=f(this.scheme,h||y),this.query=w||y,this.fragment=M||y,I(this,A))}static isUri(i){return i instanceof S?!0:i?typeof i.authority=="string"&&typeof i.fragment=="string"&&typeof i.path=="string"&&typeof i.query=="string"&&typeof i.scheme=="string"&&typeof i.fsPath=="string"&&typeof i.with=="function"&&typeof i.toString=="function":!1}get fsPath(){return c(this,!1)}with(i){if(!i)return this;let{scheme:s,authority:h,path:w,query:M,fragment:A}=i;return s===void 0?s=this.scheme:s===null&&(s=y),h===void 0?h=this.authority:h===null&&(h=y),w===void 0?w=this.path:w===null&&(w=y),M===void 0?M=this.query:M===null&&(M=y),A===void 0?A=this.fragment:A===null&&(A=y),s===this.scheme&&h===this.authority&&w===this.path&&M===this.query&&A===this.fragment?this:new m(s,h,w,M,A)}static parse(i,s=!1){const h=g.exec(i);return h?new m(h[2]||y,u(h[4]||y),u(h[5]||y),u(h[7]||y),u(h[9]||y),s):new m(y,y,y,y,y)}static file(i){let s=y;if(R.isWindows&&(i=i.replace(/\\/g,E)),i[0]===E&&i[1]===E){const h=i.indexOf(E,2);h===-1?(s=i.substring(2),i=E):(s=i.substring(2,h),i=i.substring(h)||E)}return new m("file",s,i,y,y)}static from(i){const s=new m(i.scheme,i.authority,i.path,i.query,i.fragment);return I(s,!0),s}static joinPath(i,...s){if(!i.path)throw new Error("[UriError]: cannot call joinPath on URI without path");let h;return R.isWindows&&i.scheme==="file"?h=S.file(p.win32.join(c(i,!0),...s)).path:h=p.posix.join(i.path,...s),i.with({path:h})}toString(i=!1){return a(this,i)}toJSON(){return this}static revive(i){if(i){if(i instanceof S)return i;{const s=new m(i);return s._formatted=i.external,s._fsPath=i._sep===t?i.fsPath:null,s}}else return i}}e.URI=S;const t=R.isWindows?1:void 0;class m extends S{constructor(){super(...arguments);this._formatted=null,this._fsPath=null}get fsPath(){return this._fsPath||(this._fsPath=c(this,!1)),this._fsPath}toString(i=!1){return i?a(this,!0):(this._formatted||(this._formatted=a(this,!1)),this._formatted)}toJSON(){const i={$mid:1};return this._fsPath&&(i.fsPath=this._fsPath,i._sep=t),this._formatted&&(i.external=this._formatted),this.path&&(i.path=this.path),this.scheme&&(i.scheme=this.scheme),this.authority&&(i.authority=this.authority),this.query&&(i.query=this.query),this.fragment&&(i.fragment=this.fragment),i}}const v={[58]:"%3A",[47]:"%2F",[63]:"%3F",[35]:"%23",[91]:"%5B",[93]:"%5D",[64]:"%40",[33]:"%21",[36]:"%24",[38]:"%26",[39]:"%27",[40]:"%28",[41]:"%29",[42]:"%2A",[43]:"%2B",[44]:"%2C",[59]:"%3B",[61]:"%3D",[32]:"%20"};function b(r,i){let s,h=-1;for(let w=0;w<r.length;w++){const M=r.charCodeAt(w);if(M>=97&&M<=122||M>=65&&M<=90||M>=48&&M<=57||M===45||M===46||M===95||M===126||i&&M===47)h!==-1&&(s+=encodeURIComponent(r.substring(h,w)),h=-1),s!==void 0&&(s+=r.charAt(w));else{s===void 0&&(s=r.substr(0,w));const A=v[M];A!==void 0?(h!==-1&&(s+=encodeURIComponent(r.substring(h,w)),h=-1),s+=A):h===-1&&(h=w)}}return h!==-1&&(s+=encodeURIComponent(r.substring(h))),s!==void 0?s:r}function P(r){let i;for(let s=0;s<r.length;s++){const h=r.charCodeAt(s);h===35||h===63?(i===void 0&&(i=r.substr(0,s)),i+=v[h]):i!==void 0&&(i+=r[s])}return i!==void 0?i:r}function c(r,i){let s;return r.authority&&r.path.length>1&&r.scheme==="file"?s=`//${r.authority}${r.path}`:r.path.charCodeAt(0)===47&&(r.path.charCodeAt(1)>=65&&r.path.charCodeAt(1)<=90||r.path.charCodeAt(1)>=97&&r.path.charCodeAt(1)<=122)&&r.path.charCodeAt(2)===58?i?s=r.path.substr(1):s=r.path[1].toLowerCase()+r.path.substr(2):s=r.path,R.isWindows&&(s=s.replace(/\//g,"\\")),s}e.uriToFsPath=c;function a(r,i){const s=i?P:b;let h="",{scheme:w,authority:M,path:A,query:L,fragment:F}=r;if(w&&(h+=w,h+=":"),(M||w==="file")&&(h+=E,h+=E),M){let U=M.indexOf("@");if(U!==-1){const Y=M.substr(0,U);M=M.substr(U+1),U=Y.indexOf(":"),U===-1?h+=s(Y,!1):(h+=s(Y.substr(0,U),!1),h+=":",h+=s(Y.substr(U+1),!1)),h+="@"}M=M.toLowerCase(),U=M.indexOf(":"),U===-1?h+=s(M,!1):(h+=s(M.substr(0,U),!1),h+=M.substr(U))}if(A){if(A.length>=3&&A.charCodeAt(0)===47&&A.charCodeAt(2)===58){const U=A.charCodeAt(1);U>=65&&U<=90&&(A=`/${String.fromCharCode(U+32)}:${A.substr(3)}`)}else if(A.length>=2&&A.charCodeAt(1)===58){const U=A.charCodeAt(0);U>=65&&U<=90&&(A=`${String.fromCharCode(U+32)}:${A.substr(2)}`)}h+=s(A,!0)}return L&&(h+="?",h+=s(L,!1)),F&&(h+="#",h+=i?F:b(F,!1)),h}function l(r){try{return decodeURIComponent(r)}catch{return r.length>3?r.substr(0,3)+l(r.substr(3)):r}}const o=/(%[0-9A-Za-z][0-9A-Za-z])+/g;function u(r){return r.match(o)?r.replace(o,i=>l(i)):r}}),define(x[110],ee([0,1,7]),function(V,e,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.log=e.getFirstFrame=e.parse=e.isRemoteConsoleLog=void 0;function R(f){const y=f;return y&&typeof y.type=="string"&&typeof y.severity=="string"}e.isRemoteConsoleLog=R;function C(f){const y=[];let E;try{const g=JSON.parse(f.arguments),S=g[g.length-1];S&&S.__$stack&&(g.pop(),E=S.__$stack),y.push(...g)}catch(g){y.push("Unable to log remote console arguments",f.arguments)}return{args:y,stack:E}}e.parse=C;function k(f){if(typeof f!="string")return k(C(f).stack);const y=f;if(y){const E=n(y),g=/at [^\/]*((?:(?:[a-zA-Z]+:)|(?:[\/])|(?:\\\\))(?:.+)):(\d+):(\d+)/.exec(E||"");if(g&&g.length===4)return{uri:p.URI.file(g[1]),line:Number(g[2]),column:Number(g[3])}}}e.getFirstFrame=k;function n(f){if(!f)return f;const y=f.indexOf(`
`);return y===-1?f:f.substring(0,y)}function I(f,y){const{args:E,stack:g}=C(f),S=typeof E[0]=="string"&&E.length===1;let t=n(g);t&&(t=`(${t.trim()})`);let m=[];if(typeof E[0]=="string"?t&&S?m=[`%c[${y}] %c${E[0]} %c${t}`,d("blue"),d(""),d("grey")]:m=[`%c[${y}] %c${E[0]}`,d("blue"),d(""),...E.slice(1)]:m=[`%c[${y}]%`,d("blue"),...E],t&&!S&&m.push(t),typeof console[f.severity]!="function")throw new Error("Unknown console method");console[f.severity].apply(console,m)}e.log=I;function d(f){return`color: ${f}`}}),define(x[111],ee([0,1,17,25,7]),function(V,e,p,R,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.revive=e.MarshalledId=e.parse=e.stringify=void 0;function k(y){return JSON.stringify(y,d)}e.stringify=k;function n(y){let E=JSON.parse(y);return E=f(E),E}e.parse=n;var I;(function(y){y[y.Uri=1]="Uri",y[y.Regexp=2]="Regexp",y[y.ScmResource=3]="ScmResource",y[y.ScmResourceGroup=4]="ScmResourceGroup",y[y.ScmProvider=5]="ScmProvider",y[y.CommentController=6]="CommentController",y[y.CommentThread=7]="CommentThread",y[y.CommentThreadReply=8]="CommentThreadReply",y[y.CommentNode=9]="CommentNode",y[y.CommentThreadNode=10]="CommentThreadNode",y[y.TimelineActionContext=11]="TimelineActionContext",y[y.NotebookCellActionContext=12]="NotebookCellActionContext",y[y.TestItemContext=13]="TestItemContext"})(I=e.MarshalledId||(e.MarshalledId={}));function d(y,E){return E instanceof RegExp?{$mid:2,source:E.source,flags:(0,R.regExpFlags)(E)}:E}function f(y,E=0){if(!y||E>200)return y;if(typeof y=="object"){switch(y.$mid){case 1:return C.URI.revive(y);case 2:return new RegExp(y.source,y.flags)}if(y instanceof p.VSBuffer||y instanceof Uint8Array)return y;if(Array.isArray(y))for(let g=0;g<y.length;++g)y[g]=f(y[g],E+1);else for(const g in y)Object.hasOwnProperty.call(y,g)&&(y[g]=f(y[g],E+1))}return y}e.revive=f}),define(x[10],ee([0,1,3,7]),function(V,e,p,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileAccess=e.RemoteAuthorities=e.Schemas=void 0;var C;(function(I){I.inMemory="inmemory",I.vscode="vscode",I.internal="private",I.walkThrough="walkThrough",I.walkThroughSnippet="walkThroughSnippet",I.http="http",I.https="https",I.file="file",I.mailto="mailto",I.untitled="untitled",I.data="data",I.command="command",I.vscodeRemote="vscode-remote",I.vscodeRemoteResource="vscode-remote-resource",I.userData="vscode-userdata",I.vscodeCustomEditor="vscode-custom-editor",I.vscodeNotebook="vscode-notebook",I.vscodeNotebookCell="vscode-notebook-cell",I.vscodeNotebookCellMetadata="vscode-notebook-cell-metadata",I.vscodeNotebookCellOutput="vscode-notebook-cell-output",I.vscodeInteractive="vscode-interactive",I.vscodeInteractiveInput="vscode-interactive-input",I.vscodeSettings="vscode-settings",I.vscodeWorkspaceTrust="vscode-workspace-trust",I.vscodeTerminal="vscode-terminal",I.webviewPanel="webview-panel",I.vscodeWebview="vscode-webview",I.extension="extension",I.vscodeFileResource="vscode-file",I.tmp="tmp",I.vsls="vsls"})(C=e.Schemas||(e.Schemas={}));class k{constructor(){this._hosts=Object.create(null),this._ports=Object.create(null),this._connectionTokens=Object.create(null),this._preferredWebSchema="http",this._delegate=null}setPreferredWebSchema(d){this._preferredWebSchema=d}setDelegate(d){this._delegate=d}set(d,f,y){this._hosts[d]=f,this._ports[d]=y}setConnectionToken(d,f){this._connectionTokens[d]=f}rewrite(d){if(this._delegate)return this._delegate(d);const f=d.authority;let y=this._hosts[f];y&&y.indexOf(":")!==-1&&(y=`[${y}]`);const E=this._ports[f],g=this._connectionTokens[f];let S=`path=${encodeURIComponent(d.path)}`;return typeof g=="string"&&(S+=`&tkn=${encodeURIComponent(g)}`),R.URI.from({scheme:p.isWeb?this._preferredWebSchema:C.vscodeRemoteResource,authority:`${y}:${E}`,path:"/vscode-remote-resource",query:S})}}e.RemoteAuthorities=new k;class n{asBrowserUri(d,f){const y=this.toUri(d,f);return y.scheme===C.vscodeRemote?e.RemoteAuthorities.rewrite(y):y.scheme===C.file&&(p.isNative||typeof p.globals.importScripts=="function"&&p.globals.origin===`${C.vscodeFileResource}://${n.FALLBACK_AUTHORITY}`)?y.with({scheme:C.vscodeFileResource,authority:y.authority||n.FALLBACK_AUTHORITY,query:null,fragment:null}):y}asFileUri(d,f){const y=this.toUri(d,f);return y.scheme===C.vscodeFileResource?y.with({scheme:C.file,authority:y.authority!==n.FALLBACK_AUTHORITY?y.authority:null,query:null,fragment:null}):y}toUri(d,f){return R.URI.isUri(d)?d:R.URI.parse(f.toUrl(d))}}n.FALLBACK_AUTHORITY="vscode-app",e.FileAccess=new n}),define(x[15],ee([0,1,32,10,8,3,25,7]),function(V,e,p,R,C,k,n,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toLocalResource=e.DataUri=e.distinctParents=e.addTrailingPathSeparator=e.removeTrailingPathSeparator=e.hasTrailingPathSeparator=e.isEqualAuthority=e.isAbsolutePath=e.resolvePath=e.relativePath=e.normalizePath=e.joinPath=e.dirname=e.extname=e.basename=e.basenameOrAuthority=e.getComparisonKey=e.isEqualOrParent=e.isEqual=e.extUriIgnorePathCase=e.extUriBiasedIgnorePathCase=e.extUri=e.ExtUri=e.originalFSPath=void 0;function d(S){return(0,I.uriToFsPath)(S,!0)}e.originalFSPath=d;class f{constructor(t){this._ignorePathCasing=t}compare(t,m,v=!1){return t===m?0:(0,n.compare)(this.getComparisonKey(t,v),this.getComparisonKey(m,v))}isEqual(t,m,v=!1){return t===m?!0:!t||!m?!1:this.getComparisonKey(t,v)===this.getComparisonKey(m,v)}getComparisonKey(t,m=!1){return t.with({path:this._ignorePathCasing(t)?t.path.toLowerCase():void 0,fragment:m?null:void 0}).toString()}ignorePathCasing(t){return this._ignorePathCasing(t)}isEqualOrParent(t,m,v=!1){if(t.scheme===m.scheme){if(t.scheme===R.Schemas.file)return p.isEqualOrParent(d(t),d(m),this._ignorePathCasing(t))&&t.query===m.query&&(v||t.fragment===m.fragment);if((0,e.isEqualAuthority)(t.authority,m.authority))return p.isEqualOrParent(t.path,m.path,this._ignorePathCasing(t),"/")&&t.query===m.query&&(v||t.fragment===m.fragment)}return!1}joinPath(t,...m){return I.URI.joinPath(t,...m)}basenameOrAuthority(t){return(0,e.basename)(t)||t.authority}basename(t){return C.posix.basename(t.path)}extname(t){return C.posix.extname(t.path)}dirname(t){if(t.path.length===0)return t;let m;return t.scheme===R.Schemas.file?m=I.URI.file(C.dirname(d(t))).path:(m=C.posix.dirname(t.path),t.authority&&m.length&&m.charCodeAt(0)!==47&&(console.error(`dirname("${t.toString})) resulted in a relative path`),m="/")),t.with({path:m})}normalizePath(t){if(!t.path.length)return t;let m;return t.scheme===R.Schemas.file?m=I.URI.file(C.normalize(d(t))).path:m=C.posix.normalize(t.path),t.with({path:m})}relativePath(t,m){if(t.scheme!==m.scheme||!(0,e.isEqualAuthority)(t.authority,m.authority))return;if(t.scheme===R.Schemas.file){const P=C.relative(d(t),d(m));return k.isWindows?p.toSlashes(P):P}let v=t.path||"/",b=m.path||"/";if(this._ignorePathCasing(t)){let P=0;for(const c=Math.min(v.length,b.length);P<c&&!(v.charCodeAt(P)!==b.charCodeAt(P)&&v.charAt(P).toLowerCase()!==b.charAt(P).toLowerCase());P++);v=b.substr(0,P)+v.substr(P)}return C.posix.relative(v,b)}resolvePath(t,m){if(t.scheme===R.Schemas.file){const v=I.URI.file(C.resolve(d(t),m));return t.with({authority:v.authority,path:v.path})}return m=p.toPosixPath(m),t.with({path:C.posix.resolve(t.path,m)})}isAbsolutePath(t){return!!t.path&&t.path[0]==="/"}isEqualAuthority(t,m){return t===m||t!==void 0&&m!==void 0&&(0,n.equalsIgnoreCase)(t,m)}hasTrailingPathSeparator(t,m=C.sep){if(t.scheme===R.Schemas.file){const v=d(t);return v.length>p.getRoot(v).length&&v[v.length-1]===m}else{const v=t.path;return v.length>1&&v.charCodeAt(v.length-1)===47&&!/^[a-zA-Z]:(\/$|\\$)/.test(t.fsPath)}}removeTrailingPathSeparator(t,m=C.sep){return(0,e.hasTrailingPathSeparator)(t,m)?t.with({path:t.path.substr(0,t.path.length-1)}):t}addTrailingPathSeparator(t,m=C.sep){let v=!1;if(t.scheme===R.Schemas.file){const b=d(t);v=b!==void 0&&b.length===p.getRoot(b).length&&b[b.length-1]===m}else{m="/";const b=t.path;v=b.length===1&&b.charCodeAt(b.length-1)===47}return!v&&!(0,e.hasTrailingPathSeparator)(t,m)?t.with({path:t.path+"/"}):t}}e.ExtUri=f,e.extUri=new f(()=>!1),e.extUriBiasedIgnorePathCase=new f(S=>S.scheme===R.Schemas.file?!k.isLinux:!0),e.extUriIgnorePathCase=new f(S=>!0),e.isEqual=e.extUri.isEqual.bind(e.extUri),e.isEqualOrParent=e.extUri.isEqualOrParent.bind(e.extUri),e.getComparisonKey=e.extUri.getComparisonKey.bind(e.extUri),e.basenameOrAuthority=e.extUri.basenameOrAuthority.bind(e.extUri),e.basename=e.extUri.basename.bind(e.extUri),e.extname=e.extUri.extname.bind(e.extUri),e.dirname=e.extUri.dirname.bind(e.extUri),e.joinPath=e.extUri.joinPath.bind(e.extUri),e.normalizePath=e.extUri.normalizePath.bind(e.extUri),e.relativePath=e.extUri.relativePath.bind(e.extUri),e.resolvePath=e.extUri.resolvePath.bind(e.extUri),e.isAbsolutePath=e.extUri.isAbsolutePath.bind(e.extUri),e.isEqualAuthority=e.extUri.isEqualAuthority.bind(e.extUri),e.hasTrailingPathSeparator=e.extUri.hasTrailingPathSeparator.bind(e.extUri),e.removeTrailingPathSeparator=e.extUri.removeTrailingPathSeparator.bind(e.extUri),e.addTrailingPathSeparator=e.extUri.addTrailingPathSeparator.bind(e.extUri);function y(S,t){const m=[];for(let v=0;v<S.length;v++){const b=t(S[v]);S.some((P,c)=>c===v?!1:(0,e.isEqualOrParent)(b,t(P)))||m.push(S[v])}return m}e.distinctParents=y;var E;(function(S){S.META_DATA_LABEL="label",S.META_DATA_DESCRIPTION="description",S.META_DATA_SIZE="size",S.META_DATA_MIME="mime";function t(m){const v=new Map;m.path.substring(m.path.indexOf(";")+1,m.path.lastIndexOf(";")).split(";").forEach(c=>{const[a,l]=c.split(":");a&&l&&v.set(a,l)});const P=m.path.substring(0,m.path.indexOf(";"));return P&&v.set(S.META_DATA_MIME,P),v}S.parseMetaData=t})(E=e.DataUri||(e.DataUri={}));function g(S,t,m){if(t){let v=S.path;return v&&v[0]!==C.posix.sep&&(v=C.posix.sep+v),S.with({scheme:m,authority:t,path:v})}return S.with({scheme:m})}e.toLocalResource=g}),define(x[9],ee([0,1,23,16,4,2,15,3]),function(V,e,p,R,C,k,n,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createCancelableAsyncIterable=e.CancelableAsyncIterableObject=e.AsyncIterableObject=e.Promises=e.DeferredPromise=e.IntervalCounter=e.TaskSequentializer=e.retry=e.IdleValue=e.runWhenIdle=e.ThrottledWorker=e.RunOnceWorker=e.ProcessTimeRunOnceScheduler=e.RunOnceScheduler=e.IntervalTimer=e.TimeoutTimer=e.ResourceQueue=e.Queue=e.Limiter=e.firstParallel=e.first=e.sequence=e.disposableTimeout=e.timeout=e.AutoOpenBarrier=e.Barrier=e.ThrottledDelayer=e.Delayer=e.SequencerByKey=e.Sequencer=e.Throttler=e.asPromise=e.raceTimeout=e.raceCancellablePromises=e.raceCancellation=e.createCancelablePromise=e.isThenable=void 0;function d(O){return!!O&&typeof O.then=="function"}e.isThenable=d;function f(O){const D=new p.CancellationTokenSource,T=O(D.token),_=new Promise((z,X)=>{const B=D.token.onCancellationRequested(()=>{B.dispose(),D.dispose(),X((0,R.canceled)())});Promise.resolve(T).then(q=>{B.dispose(),D.dispose(),z(q)},q=>{B.dispose(),D.dispose(),X(q)})});return new class{cancel(){D.cancel()}then(z,X){return _.then(z,X)}catch(z){return this.then(void 0,z)}finally(z){return _.finally(z)}}}e.createCancelablePromise=f;function y(O,D,T){return Promise.race([O,new Promise(_=>D.onCancellationRequested(()=>_(T)))])}e.raceCancellation=y;async function E(O){let D=-1;const T=O.map((z,X)=>z.then(B=>(D=X,B))),_=await Promise.race(T);return O.forEach((z,X)=>{X!==D&&z.cancel()}),_}e.raceCancellablePromises=E;function g(O,D,T){let _;const z=setTimeout(()=>{_?.(void 0),T?.()},D);return Promise.race([O.finally(()=>clearTimeout(z)),new Promise(X=>_=X)])}e.raceTimeout=g;function S(O){return new Promise((D,T)=>{const _=O();d(_)?_.then(D,T):D(_)})}e.asPromise=S;class t{constructor(){this.activePromise=null,this.queuedPromise=null,this.queuedPromiseFactory=null}queue(D){if(this.activePromise){if(this.queuedPromiseFactory=D,!this.queuedPromise){const T=()=>{this.queuedPromise=null;const _=this.queue(this.queuedPromiseFactory);return this.queuedPromiseFactory=null,_};this.queuedPromise=new Promise(_=>{this.activePromise.then(T,T).then(_)})}return new Promise((T,_)=>{this.queuedPromise.then(T,_)})}return this.activePromise=D(),new Promise((T,_)=>{this.activePromise.then(z=>{this.activePromise=null,T(z)},z=>{this.activePromise=null,_(z)})})}}e.Throttler=t;class m{constructor(){this.current=Promise.resolve(null)}queue(D){return this.current=this.current.then(()=>D(),()=>D())}}e.Sequencer=m;class v{constructor(){this.promiseMap=new Map}queue(D,T){const z=(this.promiseMap.get(D)??Promise.resolve()).catch(()=>{}).then(T).finally(()=>{this.promiseMap.get(D)===z&&this.promiseMap.delete(D)});return this.promiseMap.set(D,z),z}}e.SequencerByKey=v;class b{constructor(D){this.defaultDelay=D,this.timeout=null,this.completionPromise=null,this.doResolve=null,this.doReject=null,this.task=null}trigger(D,T=this.defaultDelay){return this.task=D,this.cancelTimeout(),this.completionPromise||(this.completionPromise=new Promise((_,z)=>{this.doResolve=_,this.doReject=z}).then(()=>{if(this.completionPromise=null,this.doResolve=null,this.task){const _=this.task;return this.task=null,_()}})),this.timeout=setTimeout(()=>{this.timeout=null,this.doResolve&&this.doResolve(null)},T),this.completionPromise}isTriggered(){return this.timeout!==null}cancel(){this.cancelTimeout(),this.completionPromise&&(this.doReject&&this.doReject((0,R.canceled)()),this.completionPromise=null)}cancelTimeout(){this.timeout!==null&&(clearTimeout(this.timeout),this.timeout=null)}dispose(){this.cancel()}}e.Delayer=b;class P{constructor(D){this.delayer=new b(D),this.throttler=new t}trigger(D,T){return this.delayer.trigger(()=>this.throttler.queue(D),T)}isTriggered(){return this.delayer.isTriggered()}cancel(){this.delayer.cancel()}dispose(){this.delayer.dispose()}}e.ThrottledDelayer=P;class c{constructor(){this._isOpen=!1,this._promise=new Promise((D,T)=>{this._completePromise=D})}isOpen(){return this._isOpen}open(){this._isOpen=!0,this._completePromise(!0)}wait(){return this._promise}}e.Barrier=c;class a extends c{constructor(D){super();this._timeout=setTimeout(()=>this.open(),D)}open(){clearTimeout(this._timeout),super.open()}}e.AutoOpenBarrier=a;function l(O,D){return D?new Promise((T,_)=>{const z=setTimeout(()=>{X.dispose(),T()},O),X=D.onCancellationRequested(()=>{clearTimeout(z),X.dispose(),_((0,R.canceled)())})}):f(T=>l(O,T))}e.timeout=l;function o(O,D=0){const T=setTimeout(O,D);return(0,k.toDisposable)(()=>clearTimeout(T))}e.disposableTimeout=o;function u(O){const D=[];let T=0;const _=O.length;function z(){return T<_?O[T++]():null}function X(B){B!=null&&D.push(B);const q=z();return q?q.then(X):Promise.resolve(D)}return Promise.resolve(null).then(X)}e.sequence=u;function r(O,D=_=>!!_,T=null){let _=0;const z=O.length,X=()=>{if(_>=z)return Promise.resolve(T);const B=O[_++];return Promise.resolve(B()).then(ne=>D(ne)?Promise.resolve(ne):X())};return X()}e.first=r;function i(O,D=_=>!!_,T=null){if(O.length===0)return Promise.resolve(T);let _=O.length;const z=()=>{_=-1;for(const X of O)X.cancel?.()};return new Promise((X,B)=>{for(const q of O)q.then(ne=>{--_>=0&&D(ne)?(z(),X(ne)):_===0&&X(T)}).catch(ne=>{--_>=0&&(z(),B(ne))})})}e.firstParallel=i;class s{constructor(D){this._size=0,this.maxDegreeOfParalellism=D,this.outstandingPromises=[],this.runningPromises=0,this._onFinished=new C.Emitter}get onFinished(){return this._onFinished.event}get size(){return this._size}queue(D){return this._size++,new Promise((T,_)=>{this.outstandingPromises.push({factory:D,c:T,e:_}),this.consume()})}consume(){for(;this.outstandingPromises.length&&this.runningPromises<this.maxDegreeOfParalellism;){const D=this.outstandingPromises.shift();this.runningPromises++;const T=D.factory();T.then(D.c,D.e),T.then(()=>this.consumed(),()=>this.consumed())}}consumed(){this._size--,this.runningPromises--,this.outstandingPromises.length>0?this.consume():this._onFinished.fire()}dispose(){this._onFinished.dispose()}}e.Limiter=s;class h extends s{constructor(){super(1)}}e.Queue=h;class w{constructor(){this.queues=new Map}queueFor(D,T=n.extUri){const _=T.getComparisonKey(D);let z=this.queues.get(_);return z||(z=new h,C.Event.once(z.onFinished)(()=>{z?.dispose(),this.queues.delete(_)}),this.queues.set(_,z)),z}dispose(){this.queues.forEach(D=>D.dispose()),this.queues.clear()}}e.ResourceQueue=w;class M{constructor(D,T){this._token=-1,typeof D=="function"&&typeof T=="number"&&this.setIfNotSet(D,T)}dispose(){this.cancel()}cancel(){this._token!==-1&&(clearTimeout(this._token),this._token=-1)}cancelAndSet(D,T){this.cancel(),this._token=setTimeout(()=>{this._token=-1,D()},T)}setIfNotSet(D,T){this._token===-1&&(this._token=setTimeout(()=>{this._token=-1,D()},T))}}e.TimeoutTimer=M;class A{constructor(){this._token=-1}dispose(){this.cancel()}cancel(){this._token!==-1&&(clearInterval(this._token),this._token=-1)}cancelAndSet(D,T){this.cancel(),this._token=setInterval(()=>{D()},T)}}e.IntervalTimer=A;class L{constructor(D,T){this.timeoutToken=-1,this.runner=D,this.timeout=T,this.timeoutHandler=this.onTimeout.bind(this)}dispose(){this.cancel(),this.runner=null}cancel(){this.isScheduled()&&(clearTimeout(this.timeoutToken),this.timeoutToken=-1)}schedule(D=this.timeout){this.cancel(),this.timeoutToken=setTimeout(this.timeoutHandler,D)}get delay(){return this.timeout}set delay(D){this.timeout=D}isScheduled(){return this.timeoutToken!==-1}onTimeout(){this.timeoutToken=-1,this.runner&&this.doRun()}doRun(){this.runner&&this.runner()}}e.RunOnceScheduler=L;class F{constructor(D,T){T%1e3!=0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${T}ms is not a multiple of 1000ms.`),this.runner=D,this.timeout=T,this.counter=0,this.intervalToken=-1,this.intervalHandler=this.onInterval.bind(this)}dispose(){this.cancel(),this.runner=null}cancel(){this.isScheduled()&&(clearInterval(this.intervalToken),this.intervalToken=-1)}schedule(D=this.timeout){D%1e3!=0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${D}ms is not a multiple of 1000ms.`),this.cancel(),this.counter=Math.ceil(D/1e3),this.intervalToken=setInterval(this.intervalHandler,1e3)}isScheduled(){return this.intervalToken!==-1}onInterval(){this.counter--,!(this.counter>0)&&(clearInterval(this.intervalToken),this.intervalToken=-1,this.runner&&this.runner())}}e.ProcessTimeRunOnceScheduler=F;class U extends L{constructor(D,T){super(D,T);this.units=[]}work(D){this.units.push(D),this.isScheduled()||this.schedule()}doRun(){const D=this.units;this.units=[],this.runner&&this.runner(D)}dispose(){this.units=[],super.dispose()}}e.RunOnceWorker=U;class Y extends k.Disposable{constructor(D,T,_,z){super();this.maxWorkChunkSize=D,this.maxPendingWork=T,this.throttleDelay=_,this.handler=z,this.pendingWork=[],this.throttler=this._register(new k.MutableDisposable),this.disposed=!1}get pending(){return this.pendingWork.length}work(D){if(this.disposed)return!1;if(typeof this.maxPendingWork=="number"){if(this.throttler.value){if(this.pending+D.length>this.maxPendingWork)return!1}else if(this.pending+D.length-this.maxWorkChunkSize>this.maxPendingWork)return!1}return this.pendingWork.push(...D),this.throttler.value||this.doWork(),!0}doWork(){this.handler(this.pendingWork.splice(0,this.maxWorkChunkSize)),this.pendingWork.length>0&&(this.throttler.value=new L(()=>{this.throttler.clear(),this.doWork()},this.throttleDelay),this.throttler.value.schedule())}dispose(){super.dispose(),this.disposed=!0}}e.ThrottledWorker=Y,function(){typeof requestIdleCallback!="function"||typeof cancelIdleCallback!="function"?e.runWhenIdle=O=>{(0,I.setTimeout0)(()=>{if(D)return;const T=Date.now()+3;O(Object.freeze({didTimeout:!0,timeRemaining(){return Math.max(0,T-Date.now())}}))});let D=!1;return{dispose(){D||(D=!0)}}}:e.runWhenIdle=(O,D)=>{const T=requestIdleCallback(O,typeof D=="number"?{timeout:D}:void 0);let _=!1;return{dispose(){_||(_=!0,cancelIdleCallback(T))}}}}();class ie{constructor(D){this._didRun=!1,this._executor=()=>{try{this._value=D()}catch(T){this._error=T}finally{this._didRun=!0}},this._handle=(0,e.runWhenIdle)(()=>this._executor())}dispose(){this._handle.dispose()}get value(){if(this._didRun||(this._handle.dispose(),this._executor()),this._error)throw this._error;return this._value}get isInitialized(){return this._didRun}}e.IdleValue=ie;async function re(O,D,T){let _;for(let z=0;z<T;z++)try{return await O()}catch(X){_=X,await l(D)}throw _}e.retry=re;class K{hasPending(D){return this._pending?typeof D=="number"?this._pending.taskId===D:!!this._pending:!1}get pending(){return this._pending?this._pending.promise:void 0}cancelPending(){this._pending?.cancel()}setPending(D,T,_){return this._pending={taskId:D,cancel:()=>_?.(),promise:T},T.then(()=>this.donePending(D),()=>this.donePending(D)),T}donePending(D){this._pending&&D===this._pending.taskId&&(this._pending=void 0,this.triggerNext())}triggerNext(){if(this._next){const D=this._next;this._next=void 0,D.run().then(D.promiseResolve,D.promiseReject)}}setNext(D){if(this._next)this._next.run=D;else{let T,_;const z=new Promise((X,B)=>{T=X,_=B});this._next={run:D,promise:z,promiseResolve:T,promiseReject:_}}return this._next.promise}}e.TaskSequentializer=K;class W{constructor(D,T=()=>Date.now()){this.interval=D,this.nowFn=T,this.lastIncrementTime=0,this.value=0}increment(){const D=this.nowFn();return D-this.lastIncrementTime>this.interval&&(this.lastIncrementTime=D,this.value=0),this.value++,this.value}}e.IntervalCounter=W;class N{constructor(){this.rejected=!1,this.resolved=!1,this.p=new Promise((D,T)=>{this.completeCallback=D,this.errorCallback=T})}get isRejected(){return this.rejected}get isResolved(){return this.resolved}get isSettled(){return this.rejected||this.resolved}complete(D){return new Promise(T=>{this.completeCallback(D),this.resolved=!0,T()})}error(D){return new Promise(T=>{this.errorCallback(D),this.rejected=!0,T()})}cancel(){new Promise(D=>{this.errorCallback((0,R.canceled)()),this.rejected=!0,D()})}}e.DeferredPromise=N;var G;(function(O){async function D(_){let z;const X=await Promise.all(_.map(B=>B.then(q=>q,q=>{z||(z=q)})));if(typeof z!="undefined")throw z;return X}O.settled=D;function T(_){return new Promise(async(z,X)=>{try{await _(z,X)}catch(B){X(B)}})}O.withAsyncBody=T})(G=e.Promises||(e.Promises={}));var Q;(function(O){O[O.Initial=0]="Initial",O[O.DoneOK=1]="DoneOK",O[O.DoneError=2]="DoneError"})(Q||(Q={}));class H{constructor(D){this._state=0,this._results=[],this._error=null,this._onStateChanged=new C.Emitter,queueMicrotask(async()=>{const T={emitOne:_=>this.emitOne(_),emitMany:_=>this.emitMany(_),reject:_=>this.reject(_)};try{await Promise.resolve(D(T)),this.resolve()}catch(_){this.reject(_)}finally{T.emitOne=void 0,T.emitMany=void 0,T.reject=void 0}})}static fromArray(D){return new H(T=>{T.emitMany(D)})}static fromPromise(D){return new H(async T=>{T.emitMany(await D)})}static fromPromises(D){return new H(async T=>{await Promise.all(D.map(async _=>T.emitOne(await _)))})}static merge(D){return new H(async T=>{await Promise.all(D.map(async _=>{for await(const z of _)T.emitOne(z)}))})}[Symbol.asyncIterator](){let D=0;return{next:async()=>{do{if(this._state===2)throw this._error;if(D<this._results.length)return{done:!1,value:this._results[D++]};if(this._state===1)return{done:!0,value:void 0};await C.Event.toPromise(this._onStateChanged.event)}while(!0)}}}static map(D,T){return new H(async _=>{for await(const z of D)_.emitOne(T(z))})}map(D){return H.map(this,D)}static filter(D,T){return new H(async _=>{for await(const z of D)T(z)&&_.emitOne(z)})}filter(D){return H.filter(this,D)}static coalesce(D){return H.filter(D,T=>!!T)}coalesce(){return H.coalesce(this)}static async toPromise(D){const T=[];for await(const _ of D)T.push(_);return T}toPromise(){return H.toPromise(this)}emitOne(D){this._state===0&&(this._results.push(D),this._onStateChanged.fire())}emitMany(D){this._state===0&&(this._results=this._results.concat(D),this._onStateChanged.fire())}resolve(){this._state===0&&(this._state=1,this._onStateChanged.fire())}reject(D){this._state===0&&(this._state=2,this._error=D,this._onStateChanged.fire())}}e.AsyncIterableObject=H,H.EMPTY=H.fromArray([]);class $ extends H{constructor(D,T){super(T);this._source=D}cancel(){this._source.cancel()}}e.CancelableAsyncIterableObject=$;function J(O){const D=new p.CancellationTokenSource,T=O(D.token);return new $(D,async _=>{const z=D.token.onCancellationRequested(()=>{z.dispose(),D.dispose(),_.reject((0,R.canceled)())});try{for await(const X of T){if(D.token.isCancellationRequested)return;_.emitOne(X)}z.dispose(),D.dispose()}catch(X){z.dispose(),D.dispose(),_.reject(X)}})}e.createCancelableAsyncIterable=J}),define(x[33],ee([0,1,32,10,8,3,15,25,7]),function(V,e,p,R,C,k,n,I,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.splitName=e.unmnemonicLabel=e.mnemonicButtonLabel=e.mnemonicMenuLabel=e.template=e.shorten=e.untildify=e.tildify=e.normalizeDriveLetter=e.getBaseLabel=e.getPathLabel=void 0;function f(i,s,h){if(typeof i=="string"&&(i=d.URI.file(i)),h){const M=h.getWorkspaceFolder(i);if(M){const A=h.getWorkspace().folders.length>1;let L;if((0,n.isEqual)(M.uri,i)?L="":L=(0,n.relativePath)(M.uri,i),A){const F=M.name?M.name:(0,n.basename)(M.uri);L=L?F+" \u2022 "+L:F}return L}}if(i.scheme!==R.Schemas.file&&i.scheme!==R.Schemas.untitled)return i.with({query:null,fragment:null}).toString(!0);if((0,p.hasDriveLetter)(i.fsPath))return(0,C.normalize)(E(i.fsPath));let w=(0,C.normalize)(i.fsPath);return!k.isWindows&&s?.userHome&&(w=S(w,s.userHome.fsPath)),w}e.getPathLabel=f;function y(i){if(!i)return;typeof i=="string"&&(i=d.URI.file(i));const s=(0,n.basename)(i)||(i.scheme===R.Schemas.file?i.fsPath:i.path);return k.isWindows&&(0,p.isRootOrDriveLetter)(s)?E(s):s}e.getBaseLabel=y;function E(i,s){return(0,p.hasDriveLetter)(i,s)?i.charAt(0).toUpperCase()+i.slice(1):i}e.normalizeDriveLetter=E;let g=Object.create(null);function S(i,s){if(k.isWindows||!i||!s)return i;let h=g.original===s?g.normalized:void 0;return h||(h=`${(0,I.rtrim)(s,C.posix.sep)}${C.posix.sep}`,g={original:s,normalized:h}),(k.isLinux?i.startsWith(h):(0,I.startsWithIgnoreCase)(i,h))&&(i=`~/${i.substr(h.length)}`),i}e.tildify=S;function t(i,s){return i.replace(/^~($|\/|\\)/,`${s}$1`)}e.untildify=t;const m="\u2026",v="\\\\",b="~";function P(i,s=C.sep){const h=new Array(i.length);let w=!1;for(let M=0;M<i.length;M++){let A=i[M];if(A===""){h[M]=`.${s}`;continue}if(!A){h[M]=A;continue}w=!0;let L="";A.indexOf(v)===0?(L=A.substr(0,A.indexOf(v)+v.length),A=A.substr(A.indexOf(v)+v.length)):A.indexOf(s)===0?(L=A.substr(0,A.indexOf(s)+s.length),A=A.substr(A.indexOf(s)+s.length)):A.indexOf(b)===0&&(L=A.substr(0,A.indexOf(b)+b.length),A=A.substr(A.indexOf(b)+b.length));const F=A.split(s);for(let U=1;w&&U<=F.length;U++)for(let Y=F.length-U;w&&Y>=0;Y--){w=!1;let ie=F.slice(Y,Y+U).join(s);for(let re=0;!w&&re<i.length;re++)if(re!==M&&i[re]&&i[re].indexOf(ie)>-1){const K=Y+U===F.length,W=Y>0&&i[re].indexOf(s)>-1?s+ie:ie,N=i[re].endsWith(W);w=!K||N}if(!w){let re="";(F[0].endsWith(":")||L!=="")&&(Y===1&&(Y=0,U++,ie=F[0]+s+ie),Y>0&&(re=F[0]+s),re=L+re),Y>0&&(re=re+m+s),re=re+ie,Y+U<F.length&&(re=re+s+m),h[M]=re}}w&&(h[M]=A)}return h}e.shorten=P;var c;(function(i){i[i.TEXT=0]="TEXT",i[i.VARIABLE=1]="VARIABLE",i[i.SEPARATOR=2]="SEPARATOR"})(c||(c={}));function a(i,s=Object.create(null)){const h=[];let w=!1,M="";for(const A of i)if(A==="$"||w&&A==="{")M&&h.push({value:M,type:c.TEXT}),M="",w=!0;else if(A==="}"&&w){const L=s[M];if(typeof L=="string")L.length&&h.push({value:L,type:c.VARIABLE});else if(L){const F=h[h.length-1];(!F||F.type!==c.SEPARATOR)&&h.push({value:L.label,type:c.SEPARATOR})}M="",w=!1}else M+=A;return M&&!w&&h.push({value:M,type:c.TEXT}),h.filter((A,L)=>{if(A.type===c.SEPARATOR){const F=h[L-1],U=h[L+1];return[F,U].every(Y=>Y&&(Y.type===c.VARIABLE||Y.type===c.TEXT)&&Y.value.length>0)}return!0}).map(A=>A.value).join("")}e.template=a;function l(i,s){return k.isMacintosh||s?i.replace(/\(&&\w\)|&&/g,"").replace(/&/g,k.isMacintosh?"&":"&&"):i.replace(/&&|&/g,h=>h==="&"?"&&":"&")}e.mnemonicMenuLabel=l;function o(i,s){return k.isMacintosh||s?i.replace(/\(&&\w\)|&&/g,""):k.isWindows?i.replace(/&&|&/g,h=>h==="&"?"&&":"&"):i.replace(/&&/g,"_")}e.mnemonicButtonLabel=o;function u(i){return i.replace(/&/g,"&&")}e.unmnemonicLabel=u;function r(i){const s=i.indexOf("/")!==-1?C.posix:C.win32,h=s.basename(i),w=s.dirname(i);return h.length?{name:h,parentPath:w}:{name:w,parentPath:""}}e.splitName=r}),define(x[112],ee([0,1,7]),function(V,e,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.transformAndReviveIncomingURIs=e.transformIncomingURIs=e.transformOutgoingURIs=e.DefaultURITransformer=e.URITransformer=void 0;function R(y){return y.toJSON()}class C{constructor(E){this._uriTransformer=E}transformIncoming(E){const g=this._uriTransformer.transformIncoming(E);return g===E?E:R(p.URI.from(g))}transformOutgoing(E){const g=this._uriTransformer.transformOutgoing(E);return g===E?E:R(p.URI.from(g))}transformOutgoingURI(E){const g=this._uriTransformer.transformOutgoing(E);return g===E?E:p.URI.from(g)}transformOutgoingScheme(E){return this._uriTransformer.transformOutgoingScheme(E)}}e.URITransformer=C,e.DefaultURITransformer=new class{transformIncoming(y){return y}transformOutgoing(y){return y}transformOutgoingURI(y){return y}transformOutgoingScheme(y){return y}};function k(y,E,g){if(!y||g>200)return null;if(typeof y=="object"){if(y instanceof p.URI)return E.transformOutgoing(y);for(let S in y)if(Object.hasOwnProperty.call(y,S)){const t=k(y[S],E,g+1);t!==null&&(y[S]=t)}}return null}function n(y,E){const g=k(y,E,0);return g===null?y:g}e.transformOutgoingURIs=n;function I(y,E,g,S){if(!y||S>200)return null;if(typeof y=="object"){if(y.$mid===1)return g?p.URI.revive(E.transformIncoming(y)):E.transformIncoming(y);for(let t in y)if(Object.hasOwnProperty.call(y,t)){const m=I(y[t],E,g,S+1);m!==null&&(y[t]=m)}}return null}function d(y,E){const g=I(y,E,!1,0);return g===null?y:g}e.transformIncomingURIs=d;function f(y,E){const g=I(y,E,!0,0);return g===null?y:g}e.transformAndReviveIncomingURIs=f}),define(x[31],ee([0,1]),function(V,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.generateUuid=e.isUUID=void 0;const p=/^[0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12}$/i;function R(d){return p.test(d)}e.isUUID=R;const C=new Uint8Array(16),k=[];for(let d=0;d<256;d++)k.push(d.toString(16).padStart(2,"0"));let n;typeof crypto=="object"&&typeof crypto.getRandomValues=="function"?n=crypto.getRandomValues.bind(crypto):n=function(d){for(let f=0;f<d.length;f++)d[f]=Math.floor(Math.random()*256);return d};function I(){n(C),C[6]=C[6]&15|64,C[8]=C[8]&63|128;let d=0,f="";return f+=k[C[d++]],f+=k[C[d++]],f+=k[C[d++]],f+=k[C[d++]],f+="-",f+=k[C[d++]],f+=k[C[d++]],f+="-",f+=k[C[d++]],f+=k[C[d++]],f+="-",f+=k[C[d++]],f+=k[C[d++]],f+="-",f+=k[C[d++]],f+=k[C[d++]],f+=k[C[d++]],f+=k[C[d++]],f+=k[C[d++]],f+=k[C[d++]],f}e.generateUuid=I}),define(x[113],ee([0,1,16,4,2,3,13,25]),function(V,e,p,R,C,k,n,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.create=e.SimpleWorkerServer=e.SimpleWorkerClient=e.logOnceWebWorkerWarning=void 0;const d="$initialize";let f=!1;function y(r){!k.isWeb||(f||(f=!0,console.warn("Could not create web worker(s). Falling back to loading web worker code in main thread, which might cause UI freezes. Please see https://github.com/microsoft/monaco-editor#faq")),console.warn(r.message))}e.logOnceWebWorkerWarning=y;var E;(function(r){r[r.Request=0]="Request",r[r.Reply=1]="Reply",r[r.SubscribeEvent=2]="SubscribeEvent",r[r.Event=3]="Event",r[r.UnsubscribeEvent=4]="UnsubscribeEvent"})(E||(E={}));class g{constructor(i,s,h,w){this.vsWorker=i,this.req=s,this.method=h,this.args=w,this.type=0}}class S{constructor(i,s,h,w){this.vsWorker=i,this.seq=s,this.res=h,this.err=w,this.type=1}}class t{constructor(i,s,h,w){this.vsWorker=i,this.req=s,this.eventName=h,this.arg=w,this.type=2}}class m{constructor(i,s,h){this.vsWorker=i,this.req=s,this.event=h,this.type=3}}class v{constructor(i,s){this.vsWorker=i,this.req=s,this.type=4}}class b{constructor(i){this._workerId=-1,this._handler=i,this._lastSentReq=0,this._pendingReplies=Object.create(null),this._pendingEmitters=new Map,this._pendingEvents=new Map}setWorkerId(i){this._workerId=i}sendMessage(i,s){const h=String(++this._lastSentReq);return new Promise((w,M)=>{this._pendingReplies[h]={resolve:w,reject:M},this._send(new g(this._workerId,h,i,s))})}listen(i,s){let h=null;const w=new R.Emitter({onFirstListenerAdd:()=>{h=String(++this._lastSentReq),this._pendingEmitters.set(h,w),this._send(new t(this._workerId,h,i,s))},onLastListenerRemove:()=>{this._pendingEmitters.delete(h),this._send(new v(this._workerId,h)),h=null}});return w.event}handleMessage(i){!i||!i.vsWorker||this._workerId!==-1&&i.vsWorker!==this._workerId||this._handleMessage(i)}_handleMessage(i){switch(i.type){case 1:return this._handleReplyMessage(i);case 0:return this._handleRequestMessage(i);case 2:return this._handleSubscribeEventMessage(i);case 3:return this._handleEventMessage(i);case 4:return this._handleUnsubscribeEventMessage(i)}}_handleReplyMessage(i){if(!this._pendingReplies[i.seq]){console.warn("Got reply to unknown seq");return}let s=this._pendingReplies[i.seq];if(delete this._pendingReplies[i.seq],i.err){let h=i.err;i.err.$isError&&(h=new Error,h.name=i.err.name,h.message=i.err.message,h.stack=i.err.stack),s.reject(h);return}s.resolve(i.res)}_handleRequestMessage(i){let s=i.req;this._handler.handleMessage(i.method,i.args).then(w=>{this._send(new S(this._workerId,s,w,void 0))},w=>{w.detail instanceof Error&&(w.detail=(0,p.transformErrorForSerialization)(w.detail)),this._send(new S(this._workerId,s,void 0,(0,p.transformErrorForSerialization)(w)))})}_handleSubscribeEventMessage(i){const s=i.req,h=this._handler.handleEvent(i.eventName,i.arg)(w=>{this._send(new m(this._workerId,s,w))});this._pendingEvents.set(s,h)}_handleEventMessage(i){if(!this._pendingEmitters.has(i.req)){console.warn("Got event for unknown req");return}this._pendingEmitters.get(i.req).fire(i.event)}_handleUnsubscribeEventMessage(i){if(!this._pendingEvents.has(i.req)){console.warn("Got unsubscribe for unknown req");return}this._pendingEvents.get(i.req).dispose(),this._pendingEvents.delete(i.req)}_send(i){let s=[];if(i.type===0)for(let h=0;h<i.args.length;h++)i.args[h]instanceof ArrayBuffer&&s.push(i.args[h]);else i.type===1&&i.res instanceof ArrayBuffer&&s.push(i.res);this._handler.sendMessage(i,s)}}class P extends C.Disposable{constructor(i,s,h){super();let w=null;this._worker=this._register(i.create("vs/base/common/worker/simpleWorker",U=>{this._protocol.handleMessage(U)},U=>{w&&w(U)})),this._protocol=new b({sendMessage:(U,Y)=>{this._worker.postMessage(U,Y)},handleMessage:(U,Y)=>{if(typeof h[U]!="function")return Promise.reject(new Error("Missing method "+U+" on main thread host."));try{return Promise.resolve(h[U].apply(h,Y))}catch(ie){return Promise.reject(ie)}},handleEvent:(U,Y)=>{if(a(U)){const ie=h[U].call(h,Y);if(typeof ie!="function")throw new Error(`Missing dynamic event ${U} on main thread host.`);return ie}if(c(U)){const ie=h[U];if(typeof ie!="function")throw new Error(`Missing event ${U} on main thread host.`);return ie}throw new Error(`Malformed event name ${U}`)}}),this._protocol.setWorkerId(this._worker.getId());let M=null;typeof k.globals.require!="undefined"&&typeof k.globals.require.getConfig=="function"?M=k.globals.require.getConfig():typeof k.globals.requirejs!="undefined"&&(M=k.globals.requirejs.s.contexts._.config);const A=n.getAllMethodNames(h);this._onModuleLoaded=this._protocol.sendMessage(d,[this._worker.getId(),JSON.parse(JSON.stringify(M)),s,A]);const L=(U,Y)=>this._request(U,Y),F=(U,Y)=>this._protocol.listen(U,Y);this._lazyProxy=new Promise((U,Y)=>{w=Y,this._onModuleLoaded.then(ie=>{U(l(ie,L,F))},ie=>{Y(ie),this._onError("Worker failed to load "+s,ie)})})}getProxyObject(){return this._lazyProxy}_request(i,s){return new Promise((h,w)=>{this._onModuleLoaded.then(()=>{this._protocol.sendMessage(i,s).then(h,w)},w)})}_onError(i,s){console.error(i),console.info(s)}}e.SimpleWorkerClient=P;function c(r){return r[0]==="o"&&r[1]==="n"&&I.isUpperAsciiLetter(r.charCodeAt(2))}function a(r){return/^onDynamic/.test(r)&&I.isUpperAsciiLetter(r.charCodeAt(9))}function l(r,i,s){const h=A=>function(){const L=Array.prototype.slice.call(arguments,0);return i(A,L)},w=A=>function(L){return s(A,L)};let M={};for(const A of r){if(a(A)){M[A]=w(A);continue}if(c(A)){M[A]=s(A,void 0);continue}M[A]=h(A)}return M}class o{constructor(i,s){this._requestHandlerFactory=s,this._requestHandler=null,this._protocol=new b({sendMessage:(h,w)=>{i(h,w)},handleMessage:(h,w)=>this._handleMessage(h,w),handleEvent:(h,w)=>this._handleEvent(h,w)})}onmessage(i){this._protocol.handleMessage(i)}_handleMessage(i,s){if(i===d)return this.initialize(s[0],s[1],s[2],s[3]);if(!this._requestHandler||typeof this._requestHandler[i]!="function")return Promise.reject(new Error("Missing requestHandler or method: "+i));try{return Promise.resolve(this._requestHandler[i].apply(this._requestHandler,s))}catch(h){return Promise.reject(h)}}_handleEvent(i,s){if(!this._requestHandler)throw new Error("Missing requestHandler");if(a(i)){const h=this._requestHandler[i].call(this._requestHandler,s);if(typeof h!="function")throw new Error(`Missing dynamic event ${i} on request handler.`);return h}if(c(i)){const h=this._requestHandler[i];if(typeof h!="function")throw new Error(`Missing event ${i} on request handler.`);return h}throw new Error(`Malformed event name ${i}`)}initialize(i,s,h,w){this._protocol.setWorkerId(i);const L=l(w,(F,U)=>this._protocol.sendMessage(F,U),(F,U)=>this._protocol.listen(F,U));return this._requestHandlerFactory?(this._requestHandler=this._requestHandlerFactory(L),Promise.resolve(n.getAllMethodNames(this._requestHandler))):(s&&(typeof s.baseUrl!="undefined"&&delete s.baseUrl,typeof s.paths!="undefined"&&typeof s.paths.vs!="undefined"&&delete s.paths.vs,typeof s.trustedTypesPolicy!==void 0&&delete s.trustedTypesPolicy,s.catchError=!0,k.globals.require.config(s)),new Promise((F,U)=>{(k.globals.require||V)([h],ie=>{if(this._requestHandler=ie.create(L),!this._requestHandler){U(new Error("No RequestHandler!"));return}F(n.getAllMethodNames(this._requestHandler))},U)}))}}e.SimpleWorkerServer=o;function u(r){return new o(r,null)}e.create=u}),define(x[114],ee([0,1,61,28,42]),function(V,e,p,R,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.checksum=void 0;async function k(n,I){if(await new Promise((y,E)=>{const g=R.createReadStream(n),S=p.createHash("sha1");g.pipe(S);const t=(0,C.once)((m,v)=>{g.removeAllListeners(),S.removeAllListeners(),m?E(m):y(v)});g.once("error",t),g.once("end",t),S.once("error",t),S.once("data",m=>t(void 0,m.toString("hex")))})!==I)throw new Error("Hash mismatch")}e.checksum=k}),define(x[115],ee([0,1,245]),function(V,e,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LineDecoder=void 0;class R{constructor(k="utf8"){this.stringDecoder=new p.StringDecoder(k),this.remaining=null}write(k){const n=[],I=this.remaining?this.remaining+this.stringDecoder.write(k):this.stringDecoder.write(k);if(I.length<1)return n;let d=0,f,y=d;for(;y<I.length;)if(f=I.charCodeAt(y),f===13||f===10){if(n.push(I.substring(d,y)),y++,y<I.length){const E=f;f=I.charCodeAt(y),(E===13&&f===10||E===10&&f===13)&&y++}d=y}else y++;return this.remaining=d<I.length?I.substr(d):null,n}end(){return this.remaining}}e.LineDecoder=R}),define(x[116],ee([0,1,26]),function(V,e,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getMac=void 0;const R=new Set(["00:00:00:00:00:00","ff:ff:ff:ff:ff:ff","ac:de:48:00:11:22"]);function C(n){const I=n.replace(/\-/g,":").toLowerCase();return!R.has(I)}function k(){const n=(0,p.networkInterfaces)();for(let I in n){const d=n[I];if(d){for(const{mac:f}of d)if(C(f))return f}}throw new Error("Unable to retrieve mac address (unexpected format)")}e.getMac=k}),define(x[71],ee([0,1,26,16,39,31,116]),function(V,e,p,R,C,k,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getMachineId=e.virtualMachineHint=void 0,e.virtualMachineHint=new class{_isVirtualMachineMacAddress(y){return this._virtualMachineOUIs||(this._virtualMachineOUIs=C.TernarySearchTree.forStrings(),this._virtualMachineOUIs.set("00-50-56",!0),this._virtualMachineOUIs.set("00-0C-29",!0),this._virtualMachineOUIs.set("00-05-69",!0),this._virtualMachineOUIs.set("00-03-FF",!0),this._virtualMachineOUIs.set("00-1C-42",!0),this._virtualMachineOUIs.set("00-16-3E",!0),this._virtualMachineOUIs.set("08-00-27",!0),this._virtualMachineOUIs.set("00:50:56",!0),this._virtualMachineOUIs.set("00:0C:29",!0),this._virtualMachineOUIs.set("00:05:69",!0),this._virtualMachineOUIs.set("00:03:FF",!0),this._virtualMachineOUIs.set("00:1C:42",!0),this._virtualMachineOUIs.set("00:16:3E",!0),this._virtualMachineOUIs.set("08:00:27",!0)),!!this._virtualMachineOUIs.findSubstr(y)}value(){if(this._value===void 0){let y=0,E=0;const g=(0,p.networkInterfaces)();for(let S in g){const t=g[S];if(t)for(const{mac:m,internal:v}of t)v||(E+=1,this._isVirtualMachineMacAddress(m.toUpperCase())&&(y+=1))}this._value=E>0?y/E:0}return this._value}};let I;async function d(){return I||(I=(async()=>await f()||k.generateUuid())()),I}e.getMachineId=d;async function f(){try{const y=await new Promise((g,S)=>{V(["crypto"],g,S)}),E=(0,n.getMac)();return y.createHash("sha256").update(E,"utf8").digest("hex")}catch(y){R.onUnexpectedError(y);return}}}),define(x[21],ee([0,1,28,26,117,9,32,70,8,3,15,7,31]),function(V,e,p,R,C,k,n,I,d,f,y,E,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Promises=e.writeFileSync=e.SymlinkSupport=e.whenDeleted=e.readdirSync=e.rimrafSync=e.RimRafMode=void 0;var S;(function(W){W[W.UNLINK=0]="UNLINK",W[W.MOVE=1]="MOVE"})(S=e.RimRafMode||(e.RimRafMode={}));async function t(W,N=S.UNLINK){if((0,n.isRootOrDriveLetter)(W))throw new Error("rimraf - will refuse to recursively delete root");return N===S.UNLINK?v(W):m(W)}async function m(W){try{const N=(0,d.join)((0,R.tmpdir)(),(0,g.generateUuid)());try{await e.Promises.rename(W,N)}catch(G){return v(W)}v(N).catch(G=>{})}catch(N){if(N.code!=="ENOENT")throw N}}async function v(W){return e.Promises.rmdir(W,{recursive:!0,maxRetries:3})}function b(W){if((0,n.isRootOrDriveLetter)(W))throw new Error("rimraf - will refuse to recursively delete root");p.rmdirSync(W,{recursive:!0})}e.rimrafSync=b;async function P(W,N){return l(await(N?c(W):(0,C.promisify)(p.readdir)(W)))}async function c(W){try{return await(0,C.promisify)(p.readdir)(W,{withFileTypes:!0})}catch(Q){console.warn("[node.js fs] readdir with filetypes failed with error: ",Q)}const N=[],G=await P(W);for(const Q of G){let H=!1,$=!1,J=!1;try{const O=await e.Promises.lstat((0,d.join)(W,Q));H=O.isFile(),$=O.isDirectory(),J=O.isSymbolicLink()}catch(O){console.warn("[node.js fs] unexpected error from lstat after readdir: ",O)}N.push({name:Q,isFile:()=>H,isDirectory:()=>$,isSymbolicLink:()=>J})}return N}function a(W){return l(p.readdirSync(W))}e.readdirSync=a;function l(W){return W.map(N=>typeof N=="string"?f.isMacintosh?(0,I.normalizeNFC)(N):N:(N.name=f.isMacintosh?(0,I.normalizeNFC)(N.name):N.name,N))}async function o(W){const N=await P(W),G=[];for(const Q of N)await r.existsDirectory((0,d.join)(W,Q))&&G.push(Q);return G}function u(W,N=1e3){return new Promise(G=>{let Q=!1;const H=setInterval(()=>{Q||(Q=!0,p.access(W,$=>{Q=!1,$&&(clearInterval(H),G(void 0))}))},N)})}e.whenDeleted=u;var r;(function(W){async function N(H){let $;try{if($=await e.Promises.lstat(H),!$.isSymbolicLink())return{stat:$}}catch(J){}try{return{stat:await e.Promises.stat(H),symbolicLink:$?.isSymbolicLink()?{dangling:!1}:void 0}}catch(J){if(J.code==="ENOENT"&&$)return{stat:$,symbolicLink:{dangling:!0}};if(f.isWindows&&J.code==="EACCES")try{return{stat:await e.Promises.stat(await e.Promises.readlink(H)),symbolicLink:{dangling:!1}}}catch(O){if(O.code==="ENOENT"&&$)return{stat:$,symbolicLink:{dangling:!0}};throw O}throw J}}W.stat=N;async function G(H){try{const{stat:$,symbolicLink:J}=await W.stat(H);return $.isFile()&&J?.dangling!==!0}catch($){}return!1}W.existsFile=G;async function Q(H){try{const{stat:$,symbolicLink:J}=await W.stat(H);return $.isDirectory()&&J?.dangling!==!0}catch($){}return!1}W.existsDirectory=Q})(r=e.SymlinkSupport||(e.SymlinkSupport={}));const i=new k.ResourceQueue;function s(W,N,G){return i.queueFor(E.URI.file(W),y.extUriBiasedIgnorePathCase).queue(()=>{const Q=A(G);return new Promise((H,$)=>w(W,N,Q,J=>J?$(J):H()))})}let h=!0;function w(W,N,G,Q){if(!h)return p.writeFile(W,N,{mode:G.mode,flag:G.flag},Q);p.open(W,G.flag,G.mode,(H,$)=>{if(H)return Q(H);p.writeFile($,N,J=>{if(J)return p.close($,()=>Q(J));p.fdatasync($,O=>(O&&(console.warn("[node.js fs] fdatasync is now disabled for this session because it failed: ",O),h=!1),p.close($,D=>Q(D))))})})}function M(W,N,G){const Q=A(G);if(!h)return p.writeFileSync(W,N,{mode:Q.mode,flag:Q.flag});const H=p.openSync(W,Q.flag,Q.mode);try{p.writeFileSync(H,N);try{p.fdatasyncSync(H)}catch($){console.warn("[node.js fs] fdatasyncSync is now disabled for this session because it failed: ",$),h=!1}}finally{p.closeSync(H)}}e.writeFileSync=M;function A(W){return W?{mode:typeof W.mode=="number"?W.mode:438,flag:typeof W.flag=="string"?W.flag:"w"}:{mode:438,flag:"w"}}async function L(W,N){if(W===N)return;async function G(Q){try{const H=await e.Promises.lstat(Q);if(H.isDirectory()||H.isSymbolicLink())return;await e.Promises.utimes(Q,H.atime,new Date)}catch(H){}}try{await e.Promises.rename(W,N),await G(N)}catch(Q){if(W.toLowerCase()!==N.toLowerCase()&&Q.code==="EXDEV"||W.endsWith("."))await F(W,N,{preserveSymlinks:!1}),await t(W,S.MOVE),await G(N);else throw Q}}async function F(W,N,G){return Y(W,N,{root:{source:W,target:N},options:G,handledSourcePaths:new Set})}const U=511;async function Y(W,N,G){if(G.handledSourcePaths.has(W))return;G.handledSourcePaths.add(W);const{stat:Q,symbolicLink:H}=await r.stat(W);if(H){if(G.options.preserveSymlinks)try{return await K(W,N,G)}catch($){console.warn("[node.js fs] copy of symlink failed: ",$)}if(H.dangling)return}return Q.isDirectory()?ie(W,N,Q.mode&U,G):re(W,N,Q.mode&U)}async function ie(W,N,G,Q){await e.Promises.mkdir(N,{recursive:!0,mode:G});const H=await P(W);for(const $ of H)await Y((0,d.join)(W,$),(0,d.join)(N,$),Q)}async function re(W,N,G){await e.Promises.copyFile(W,N),await e.Promises.chmod(N,G)}async function K(W,N,G){let Q=await e.Promises.readlink(W);(0,n.isEqualOrParent)(Q,G.root.source,!f.isLinux)&&(Q=(0,d.join)(G.root.target,Q.substr(G.root.source.length+1))),await e.Promises.symlink(Q,N)}e.Promises=new class{get access(){return(0,C.promisify)(p.access)}get stat(){return(0,C.promisify)(p.stat)}get lstat(){return(0,C.promisify)(p.lstat)}get utimes(){return(0,C.promisify)(p.utimes)}get read(){return(0,C.promisify)(p.read)}get readFile(){return(0,C.promisify)(p.readFile)}get write(){return(0,C.promisify)(p.write)}get appendFile(){return(0,C.promisify)(p.appendFile)}get fdatasync(){return(0,C.promisify)(p.fdatasync)}get truncate(){return(0,C.promisify)(p.truncate)}get rename(){return(0,C.promisify)(p.rename)}get copyFile(){return(0,C.promisify)(p.copyFile)}get open(){return(0,C.promisify)(p.open)}get close(){return(0,C.promisify)(p.close)}get symlink(){return(0,C.promisify)(p.symlink)}get readlink(){return(0,C.promisify)(p.readlink)}get chmod(){return(0,C.promisify)(p.chmod)}get mkdir(){return(0,C.promisify)(p.mkdir)}get unlink(){return(0,C.promisify)(p.unlink)}get rmdir(){return(0,C.promisify)(p.rmdir)}get realpath(){return(0,C.promisify)(p.realpath)}async exists(W){try{return await e.Promises.access(W),!0}catch{return!1}}get readdir(){return P}get readDirsInDir(){return o}get writeFile(){return s}get rm(){return t}get move(){return L}get copy(){return F}}}),define(x[82],ee([0,1,28,8,25,21]),function(V,e,p,R,C,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.realpathSync=e.realpath=e.realcaseSync=void 0;function n(y){const E=(0,R.dirname)(y);if(y===E)return y;const g=((0,R.basename)(y)||y).toLowerCase();try{const t=(0,k.readdirSync)(E).filter(m=>m.toLowerCase()===g);if(t.length===1){const m=n(E);if(m)return(0,R.join)(m,t[0])}else if(t.length>1){const m=t.indexOf(g);if(m>=0){const v=n(E);if(v)return(0,R.join)(v,t[m])}}}catch(S){}return null}e.realcaseSync=n;async function I(y){try{return await k.Promises.realpath(y)}catch(E){const g=f(y);return await k.Promises.access(g,p.constants.R_OK),g}}e.realpath=I;function d(y){try{return p.realpathSync(y)}catch(E){const g=f(y);return p.accessSync(g,p.constants.R_OK),g}}e.realpathSync=d;function f(y){return(0,C.rtrim)((0,R.normalize)(y),R.sep)}}),define(x[118],ee([0,1,62]),function(V,e,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.findFreePortFaster=e.BROWSER_RESTRICTED_PORTS=e.findFreePort=void 0;function R(I,d,f,y=1){let E=!1;return new Promise(g=>{const S=setTimeout(()=>{if(!E)return E=!0,g(0)},f);C(I,d,y,t=>{if(!E)return E=!0,clearTimeout(S),g(t)})})}e.findFreePort=R;function C(I,d,f,y){if(d===0)return y(0);const E=new p.Socket;E.once("connect",()=>(n(E),C(I+f,d-1,f,y))),E.once("data",()=>{}),E.once("error",g=>(n(E),g.code!=="ECONNREFUSED"?C(I+f,d-1,f,y):y(I))),E.connect(I,"127.0.0.1")}e.BROWSER_RESTRICTED_PORTS={1:!0,7:!0,9:!0,11:!0,13:!0,15:!0,17:!0,19:!0,20:!0,21:!0,22:!0,23:!0,25:!0,37:!0,42:!0,43:!0,53:!0,69:!0,77:!0,79:!0,87:!0,95:!0,101:!0,102:!0,103:!0,104:!0,109:!0,110:!0,111:!0,113:!0,115:!0,117:!0,119:!0,123:!0,135:!0,137:!0,139:!0,143:!0,161:!0,179:!0,389:!0,427:!0,465:!0,512:!0,513:!0,514:!0,515:!0,526:!0,530:!0,531:!0,532:!0,540:!0,548:!0,554:!0,556:!0,563:!0,587:!0,601:!0,636:!0,989:!0,990:!0,993:!0,995:!0,1719:!0,1720:!0,1723:!0,2049:!0,3659:!0,4045:!0,5060:!0,5061:!0,6e3:!0,6566:!0,6665:!0,6666:!0,6667:!0,6668:!0,6669:!0,6697:!0,10080:!0};function k(I,d,f){let y=!1,E,g=1;const S=p.createServer({pauseOnConnect:!0});function t(m,v){y||(y=!0,S.removeAllListeners(),S.close(),E&&clearTimeout(E),v(m))}return new Promise(m=>{E=setTimeout(()=>{t(0,m)},f),S.on("listening",()=>{t(I,m)}),S.on("error",v=>{v&&(v.code==="EADDRINUSE"||v.code==="EACCES")&&g<d?(I++,g++,S.listen(I,"127.0.0.1")):t(0,m)}),S.on("close",()=>{t(0,m)}),S.listen(I,"127.0.0.1")})}e.findFreePortFaster=k;function n(I){try{I.removeAllListeners("connect"),I.removeAllListeners("error"),I.end(),I.destroy(),I.unref()}catch(d){console.error(d)}}}),define(x[119],ee([0,1,26,8,21]),function(V,e,p,R,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getFirstAvailablePowerShellInstallation=e.enumeratePowerShellInstallations=void 0;const k=/^\d+$/,n=/^Microsoft.PowerShell_.*/,I=/^Microsoft.PowerShellPreview_.*/;var d;(function(a){a[a.x64=0]="x64",a[a.x86=1]="x86",a[a.ARM=2]="ARM"})(d||(d={}));let f;switch(process.arch){case"ia32":case"x32":f=1;break;case"arm":case"arm64":f=2;break;default:f=0;break}let y;process.env.PROCESSOR_ARCHITEW6432?y=process.env.PROCESSOR_ARCHITEW6432==="ARM64"?2:0:process.env.PROCESSOR_ARCHITECTURE==="ARM64"?y=2:process.env.PROCESSOR_ARCHITECTURE==="X86"?y=1:y=0;class E{constructor(l,o,u){this.exePath=l,this.displayName=o,this.knownToExist=u}async exists(){return this.knownToExist===void 0&&(this.knownToExist=await C.SymlinkSupport.existsFile(this.exePath)),this.knownToExist}}function g({useAlternateBitness:a=!1}={}){return a?f===0?process.env["ProgramFiles(x86)"]||null:y===0&&process.env.ProgramW6432||null:process.env.ProgramFiles||null}async function S({useAlternateBitness:a=!1,findPreview:l=!1}={}){const o=g({useAlternateBitness:a});if(!o)return null;const u=R.join(o,"PowerShell");if(!await C.SymlinkSupport.existsDirectory(u))return null;let r=-1,i=null;for(const w of await C.Promises.readdir(u)){let M=-1;if(l){const L=w.indexOf("-");if(L<0)continue;const F=w.substring(0,L);if(!k.test(F)||w.substring(L+1)!=="preview")continue;M=parseInt(F,10)}else{if(!k.test(w))continue;M=parseInt(w,10)}if(M<=r)continue;const A=R.join(u,w,"pwsh.exe");!await C.SymlinkSupport.existsFile(A)||(i=A,r=M)}if(!i)return null;const s=o.includes("x86")?" (x86)":"",h=l?" Preview":"";return new E(i,`PowerShell${h}${s}`,!0)}async function t({findPreview:a}={}){if(!process.env.LOCALAPPDATA)return null;const l=R.join(process.env.LOCALAPPDATA,"Microsoft","WindowsApps");if(!await C.SymlinkSupport.existsDirectory(l))return null;const{pwshMsixDirRegex:o,pwshMsixName:u}=a?{pwshMsixDirRegex:I,pwshMsixName:"PowerShell Preview (Store)"}:{pwshMsixDirRegex:n,pwshMsixName:"PowerShell (Store)"};for(const r of await C.Promises.readdir(l))if(o.test(r)){const i=R.join(l,r,"pwsh.exe");return new E(i,u)}return null}function m(){const a=R.join(p.homedir(),".dotnet","tools","pwsh.exe");return new E(a,".NET Core PowerShell Global Tool")}function v(){const a=R.join(process.env.windir,f===1&&y!==1?"SysNative":"System32","WindowsPowerShell","v1.0","powershell.exe");return new E(a,"Windows PowerShell",!0)}async function*b(){let a=await S();a&&(yield a),a=await S({useAlternateBitness:!0}),a&&(yield a),a=await t(),a&&(yield a),a=m(),a&&(yield a),a=await S({findPreview:!0}),a&&(yield a),a=await t({findPreview:!0}),a&&(yield a),a=await S({useAlternateBitness:!0,findPreview:!0}),a&&(yield a),a=v(),a&&(yield a)}async function*P(){for await(const a of b())await a.exists()&&(yield a)}e.enumeratePowerShellInstallations=P;async function c(){for await(const a of P())return a;return null}e.getFirstAvailablePowerShellInstallation=c}),define(x[83],ee([0,1,43,10]),function(V,e,p,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.listProcesses=void 0;function C(n){return new Promise((I,d)=>{let f;const y=new Map;function E(S,t,m,v,b){const P=y.get(t);if(S===n||P){const c={name:g(m),cmd:m,pid:S,ppid:t,load:v,mem:b};y.set(S,c),S===n&&(f=c),P&&(P.children||(P.children=[]),P.children.push(c),P.children.length>1&&(P.children=P.children.sort((a,l)=>a.pid-l.pid)))}}function g(S){const t=/--vscode-window-kind=shared-process/,m=/--vscode-window-kind=issue-reporter/,v=/--vscode-window-kind=process-explorer/,b=/--utility-sub-type=network/,P=/--crashes-directory/,c=/\\pipe\\winpty-control/,a=/conhost\.exe/,l=/--type=([a-zA-Z-]+)/;if(P.exec(S))return"electron-crash-reporter";if(c.exec(S))return"winpty-process";if(a.exec(S))return"console-window-host (Windows internal process)";let o=l.exec(S);if(o&&o.length===2)return o[1]==="renderer"?t.exec(S)?"shared-process":m.exec(S)?"issue-reporter":v.exec(S)?"process-explorer":"window":o[1]==="utility"&&b.exec(S)?"utility-network-service":o[1];const u=/[a-zA-Z-]+\.js/g;let r="";do o=u.exec(S),o&&(r+=o+" ");while(o);return r&&S.indexOf("node ")<0&&S.indexOf("node.exe")<0?`electron_node ${r}`:S}if(process.platform==="win32"){const S=t=>t.indexOf("\\\\?\\")===0||t.indexOf("\\??\\")===0?t.substr(4):t.indexOf('"\\\\?\\')===0||t.indexOf('"\\??\\')===0?'"'+t.substr(5):t;new Promise((t,m)=>{V(["windows-process-tree"],t,m)}).then(t=>{t.getProcessList(n,m=>{t.getProcessCpuUsage(m,v=>{const b=new Map;v.forEach(P=>{const c=S(P.commandLine||"");b.set(P.pid,{name:g(c),cmd:c,pid:P.pid,ppid:P.ppid,load:P.cpu||0,mem:P.memory||0})}),f=b.get(n),f?(b.forEach(P=>{const c=b.get(P.ppid);c&&(c.children||(c.children=[]),c.children.push(P))}),b.forEach(P=>{P.children&&(P.children=P.children.sort((c,a)=>c.pid-a.pid))}),I(f)):d(new Error(`Root process ${n} not found`))})},t.ProcessDataFlag.CommandLine|t.ProcessDataFlag.Memory)})}else{let S=function(){let t=[f];const m=[];for(;t.length;){const b=t.shift();b&&(m.push(b.pid),b.children&&(t=t.concat(b.children)))}let v=JSON.stringify(R.FileAccess.asFileUri("vs/base/node/cpuUsage.sh",V).fsPath);v+=" "+m.join(" "),(0,p.exec)(v,{},(b,P,c)=>{if(b||c)d(b||new Error(c.toString()));else{const a=P.toString().split(`
`);for(let l=0;l<m.length;l++){const o=y.get(m[l]);o.load=parseFloat(a[l])}if(!f){d(new Error(`Root process ${n} not found`));return}I(f)}})};(0,p.exec)("which ps",{},(t,m,v)=>{if(t||v)if(process.platform!=="linux")d(t||new Error(v.toString()));else{const b=JSON.stringify(R.FileAccess.asFileUri("vs/base/node/ps.sh",V).fsPath);(0,p.exec)(b,{},(P,c,a)=>{P||a?d(P||new Error(a.toString())):(k(c,E),S())})}else{const b=m.toString().trim(),P="-ax -o pid=,ppid=,pcpu=,pmem=,command=";(0,p.exec)(`${b} ${P}`,{maxBuffer:1e3*1024,env:{LC_NUMERIC:"en_US.UTF-8"}},(c,a,l)=>{c||l&&!l.includes("screen size is bogus")?d(c||new Error(l.toString())):(k(a,E),process.platform==="linux"?S():f?I(f):d(new Error(`Root process ${n} not found`)))})}})}})}e.listProcesses=C;function k(n,I){const d=/^\s*([0-9]+)\s+([0-9]+)\s+([0-9]+\.[0-9]+)\s+([0-9]+\.[0-9]+)\s+(.+)$/,f=n.toString().split(`
`);for(const y of f){const E=d.exec(y.trim());E&&E.length===6&&I(parseInt(E[1]),parseInt(E[2]),E[5],parseFloat(E[3]),parseFloat(E[4]))}}}),define(x[120],ee([0,1,28,23,32,2,70,8,3,21]),function(V,e,p,R,C,k,n,I,d,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.watchFileContents=e.CHANGE_BUFFER_DELAY=e.watchFolder=e.watchFile=void 0;function y(t,m,v){return g({path:t,isDirectory:!1},m,v)}e.watchFile=y;function E(t,m,v){return g({path:t,isDirectory:!0},m,v)}e.watchFolder=E,e.CHANGE_BUFFER_DELAY=100;function g(t,m,v){if(d.isMacintosh&&(0,C.isEqualOrParent)(t.path,"/Volumes/"))return v(`Refusing to watch ${t.path} for changes using fs.watch() for possibly being a network share where watching is unreliable and unstable.`),k.Disposable.None;const b=(0,I.basename)(t.path),P=new Map;let c=!1,a=[(0,k.toDisposable)(()=>{P.forEach(l=>(0,k.dispose)(l)),P.clear()})];try{const l=(0,p.watch)(t.path);a.push((0,k.toDisposable)(()=>{l.removeAllListeners(),l.close()}));const o=new Set;t.isDirectory&&f.Promises.readdir(t.path).then(u=>u.forEach(r=>o.add(r))),l.on("error",(u,r)=>{c||v(`Failed to watch ${t.path} for changes using fs.watch() (${u}, ${r})`)}),l.on("change",(u,r)=>{if(c)return;let i="";if(r&&(i=r.toString(),d.isMacintosh&&(i=(0,n.normalizeNFC)(i))),!i||u!=="change"&&u!=="rename")return;const s=t.isDirectory?(0,I.join)(t.path,i):t.path;if(t.isDirectory)if(u==="rename"){const h=P.get(s);h&&(0,k.dispose)(h);const w=setTimeout(async()=>{P.delete(s);const M=await f.Promises.exists(s);if(c)return;let A;M?o.has(i)?A="changed":(A="added",o.add(i)):(o.delete(i),A="deleted"),m(A,s)},e.CHANGE_BUFFER_DELAY);P.set(s,(0,k.toDisposable)(()=>clearTimeout(w)))}else{let h;o.has(i)?h="changed":(h="added",o.add(i)),m(h,s)}else if(u==="rename"||i!==b){const h=setTimeout(async()=>{const w=await f.Promises.exists(s);c||(w?(m("changed",s),a=[g(t,m,v)]):m("deleted",s))},e.CHANGE_BUFFER_DELAY);(0,k.dispose)(a),a=[(0,k.toDisposable)(()=>clearTimeout(h))]}else m("changed",s)})}catch(l){f.Promises.exists(t.path).then(o=>{o&&!c&&v(`Failed to watch ${t.path} for changes using fs.watch() (${l.toString()})`)})}return(0,k.toDisposable)(()=>{c=!0,a=(0,k.dispose)(a)})}async function S(t,m,v,b=512){const P=await f.Promises.open(t,"r"),c=Buffer.allocUnsafe(b),a=new R.CancellationTokenSource(v);let l,o=!1;const u=y(t,async r=>{if(r==="changed"){if(o)return;o=!0;try{for(;!a.token.isCancellationRequested;){const{bytesRead:i}=await f.Promises.read(P,c,0,b,null);if(!i||a.token.isCancellationRequested)break;m(c.slice(0,i))}}catch(i){l=new Error(i),a.dispose(!0)}finally{o=!1}}},r=>{l=new Error(r),a.dispose(!0)});return new Promise((r,i)=>{a.token.onCancellationRequested(async()=>{u.dispose(),await f.Promises.close(P),l?i(l):r()})})}e.watchFileContents=S}),define(x[121],ee([0,1]),function(V,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CONTEXT_MENU_CLOSE_CHANNEL=e.CONTEXT_MENU_CHANNEL=void 0,e.CONTEXT_MENU_CHANNEL="vscode:contextmenu",e.CONTEXT_MENU_CLOSE_CHANNEL="vscode:onCloseContextMenu"}),define(x[122],ee([0,1,14,13,121]),function(V,e,p,R,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.registerContextMenuListener=void 0;function k(){p.ipcMain.on(C.CONTEXT_MENU_CHANNEL,(I,d,f,y,E)=>{const g=n(I,y,f);g.popup({window:(0,R.withNullAsUndefined)(p.BrowserWindow.fromWebContents(I.sender)),x:E?E.x:void 0,y:E?E.y:void 0,positioningItem:E?E.positioningItem:void 0,callback:()=>{g&&I.sender.send(C.CONTEXT_MENU_CLOSE_CHANNEL,d)}})})}e.registerContextMenuListener=k;function n(I,d,f){const y=new p.Menu;return f.forEach(E=>{let g;E.type==="separator"?g=new p.MenuItem({type:E.type}):Array.isArray(E.submenu)?g=new p.MenuItem({submenu:n(I,d,E.submenu),label:E.label}):g=new p.MenuItem({label:E.label,type:E.type,accelerator:E.accelerator,checked:E.checked,enabled:E.enabled,visible:E.visible,click:(S,t,m)=>I.sender.send(d,E.id,m)}),y.append(g)}),y}});var fe=this&&this.__decorate||function(V,e,p,R){var C=arguments.length,k=C<3?e:R===null?R=Object.getOwnPropertyDescriptor(e,p):R,n;if(typeof Reflect=="object"&&typeof Reflect.decorate=="function")k=Reflect.decorate(V,e,p,R);else for(var I=V.length-1;I>=0;I--)(n=V[I])&&(k=(C<3?n(k):C>3?n(e,p,k):n(e,p))||k);return C>3&&k&&Object.defineProperty(e,p,k),k};define(x[35],ee([0,1,30,9,17,23,46,16,4,2,111,25,13]),function(V,e,p,R,C,k,n,I,d,f,y,E,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IPCLogger=e.logWithColors=e.ProxyChannel=e.StaticRouter=e.getNextTickChannel=e.getDelayedChannel=e.IPCClient=e.IPCServer=e.ChannelClient=e.RequestInitiator=e.ChannelServer=e.ResponseType=e.RequestType=void 0;var S;(function(H){H[H.Promise=100]="Promise",H[H.PromiseCancel=101]="PromiseCancel",H[H.EventListen=102]="EventListen",H[H.EventDispose=103]="EventDispose"})(S=e.RequestType||(e.RequestType={}));function t(H){switch(H){case 100:return"req";case 101:return"cancel";case 102:return"subscribe";case 103:return"unsubscribe"}}var m;(function(H){H[H.Initialize=200]="Initialize",H[H.PromiseSuccess=201]="PromiseSuccess",H[H.PromiseError=202]="PromiseError",H[H.PromiseErrorObj=203]="PromiseErrorObj",H[H.EventFire=204]="EventFire"})(m=e.ResponseType||(e.ResponseType={}));function v(H){switch(H){case 200:return"init";case 201:return"reply:";case 202:case 203:return"replyErr:";case 204:return"event:"}}var b;(function(H){H[H.Uninitialized=0]="Uninitialized",H[H.Idle=1]="Idle"})(b||(b={}));class P{constructor($){this.buffer=$,this.pos=0}read($){const J=this.buffer.slice(this.pos,this.pos+$);return this.pos+=J.byteLength,J}}class c{constructor(){this.buffers=[]}get buffer(){return C.VSBuffer.concat(this.buffers)}write($){this.buffers.push($)}}var a;(function(H){H[H.Undefined=0]="Undefined",H[H.String=1]="String",H[H.Buffer=2]="Buffer",H[H.VSBuffer=3]="VSBuffer",H[H.Array=4]="Array",H[H.Object=5]="Object"})(a||(a={}));function l(H){const $=C.VSBuffer.alloc(4);return $.writeUInt32BE(H,0),$}function o(H){return H.read(4).readUInt32BE(0)}function u(H){const $=C.VSBuffer.alloc(1);return $.writeUInt8(H,0),$}const r={Undefined:u(a.Undefined),String:u(a.String),Buffer:u(a.Buffer),VSBuffer:u(a.VSBuffer),Array:u(a.Array),Object:u(a.Object)},i=typeof Buffer!="undefined";function s(H,$){if(typeof $=="undefined")H.write(r.Undefined);else if(typeof $=="string"){const J=C.VSBuffer.fromString($);H.write(r.String),H.write(l(J.byteLength)),H.write(J)}else if(i&&Buffer.isBuffer($)){const J=C.VSBuffer.wrap($);H.write(r.Buffer),H.write(l(J.byteLength)),H.write(J)}else if($ instanceof C.VSBuffer)H.write(r.VSBuffer),H.write(l($.byteLength)),H.write($);else if(Array.isArray($)){H.write(r.Array),H.write(l($.length));for(const J of $)s(H,J)}else{const J=C.VSBuffer.fromString(JSON.stringify($));H.write(r.Object),H.write(l(J.byteLength)),H.write(J)}}function h(H){switch(H.read(1).readUInt8(0)){case a.Undefined:return;case a.String:return H.read(o(H)).toString();case a.Buffer:return H.read(o(H)).buffer;case a.VSBuffer:return H.read(o(H));case a.Array:{const J=o(H),O=[];for(let D=0;D<J;D++)O.push(h(H));return O}case a.Object:return JSON.parse(H.read(o(H)).toString())}}class w{constructor($,J,O=null,D=1e3){this.protocol=$,this.ctx=J,this.logger=O,this.timeoutDelay=D,this.channels=new Map,this.activeRequests=new Map,this.pendingRequests=new Map,this.protocolListener=this.protocol.onMessage(T=>this.onRawMessage(T)),this.sendResponse({type:200})}registerChannel($,J){this.channels.set($,J),setTimeout(()=>this.flushPendingRequests($),0)}sendResponse($){switch($.type){case 200:{const J=this.send([$.type]);this.logger&&this.logger.logOutgoing(J,0,1,v($.type));return}case 201:case 202:case 204:case 203:{const J=this.send([$.type,$.id],$.data);this.logger&&this.logger.logOutgoing(J,$.id,1,v($.type),$.data);return}}}send($,J=void 0){const O=new c;return s(O,$),s(O,J),this.sendBuffer(O.buffer)}sendBuffer($){try{return this.protocol.send($),$.byteLength}catch(J){return 0}}onRawMessage($){const J=new P($),O=h(J),D=h(J),T=O[0];switch(T){case 100:return this.logger&&this.logger.logIncoming($.byteLength,O[1],1,`${t(T)}: ${O[2]}.${O[3]}`,D),this.onPromise({type:T,id:O[1],channelName:O[2],name:O[3],arg:D});case 102:return this.logger&&this.logger.logIncoming($.byteLength,O[1],1,`${t(T)}: ${O[2]}.${O[3]}`,D),this.onEventListen({type:T,id:O[1],channelName:O[2],name:O[3],arg:D});case 101:return this.logger&&this.logger.logIncoming($.byteLength,O[1],1,`${t(T)}`),this.disposeActiveRequest({type:T,id:O[1]});case 103:return this.logger&&this.logger.logIncoming($.byteLength,O[1],1,`${t(T)}`),this.disposeActiveRequest({type:T,id:O[1]})}}onPromise($){const J=this.channels.get($.channelName);if(!J){this.collectPendingRequest($);return}const O=new k.CancellationTokenSource;let D;try{D=J.call(this.ctx,$.name,$.arg,O.token)}catch(z){D=Promise.reject(z)}const T=$.id;D.then(z=>{this.sendResponse({id:T,data:z,type:201}),this.activeRequests.delete($.id)},z=>{z instanceof Error?this.sendResponse({id:T,data:{message:z.message,name:z.name,stack:z.stack?z.stack.split?z.stack.split(`
`):z.stack:void 0},type:202}):this.sendResponse({id:T,data:z,type:203}),this.activeRequests.delete($.id)});const _=(0,f.toDisposable)(()=>O.cancel());this.activeRequests.set($.id,_)}onEventListen($){const J=this.channels.get($.channelName);if(!J){this.collectPendingRequest($);return}const O=$.id,T=J.listen(this.ctx,$.name,$.arg)(_=>this.sendResponse({id:O,data:_,type:204}));this.activeRequests.set($.id,T)}disposeActiveRequest($){const J=this.activeRequests.get($.id);J&&(J.dispose(),this.activeRequests.delete($.id))}collectPendingRequest($){let J=this.pendingRequests.get($.channelName);J||(J=[],this.pendingRequests.set($.channelName,J));const O=setTimeout(()=>{console.error(`Unknown channel: ${$.channelName}`),$.type===100&&this.sendResponse({id:$.id,data:{name:"Unknown channel",message:`Channel name '${$.channelName}' timed out after ${this.timeoutDelay}ms`,stack:void 0},type:202})},this.timeoutDelay);J.push({request:$,timeoutTimer:O})}flushPendingRequests($){const J=this.pendingRequests.get($);if(J){for(const O of J)switch(clearTimeout(O.timeoutTimer),O.request.type){case 100:this.onPromise(O.request);break;case 102:this.onEventListen(O.request);break}this.pendingRequests.delete($)}}dispose(){this.protocolListener&&(this.protocolListener.dispose(),this.protocolListener=null),this.activeRequests.forEach($=>$.dispose()),this.activeRequests.clear()}}e.ChannelServer=w;var M;(function(H){H[H.LocalSide=0]="LocalSide",H[H.OtherSide=1]="OtherSide"})(M=e.RequestInitiator||(e.RequestInitiator={}));class A{constructor($,J=null){this.protocol=$,this.isDisposed=!1,this.state=b.Uninitialized,this.activeRequests=new Set,this.handlers=new Map,this.lastRequestId=0,this._onDidInitialize=new d.Emitter,this.onDidInitialize=this._onDidInitialize.event,this.protocolListener=this.protocol.onMessage(O=>this.onBuffer(O)),this.logger=J}getChannel($){const J=this;return{call(O,D,T){return J.isDisposed?Promise.reject(I.canceled()):J.requestPromise($,O,D,T)},listen(O,D){return J.isDisposed?Promise.reject(I.canceled()):J.requestEvent($,O,D)}}}requestPromise($,J,O,D=k.CancellationToken.None){const T=this.lastRequestId++,z={id:T,type:100,channelName:$,name:J,arg:O};if(D.isCancellationRequested)return Promise.reject(I.canceled());let X;return new Promise((q,ne)=>{if(D.isCancellationRequested)return ne(I.canceled());const se=()=>{const le=ue=>{switch(ue.type){case 201:this.handlers.delete(T),q(ue.data);break;case 202:this.handlers.delete(T);const me=new Error(ue.data.message);me.stack=ue.data.stack,me.name=ue.data.name,ne(me);break;case 203:this.handlers.delete(T),ne(ue.data);break}};this.handlers.set(T,le),this.sendRequest(z)};let oe=null;this.state===b.Idle?se():(oe=(0,R.createCancelablePromise)(le=>this.whenInitialized()),oe.then(()=>{oe=null,se()}));const Z=()=>{oe?(oe.cancel(),oe=null):this.sendRequest({id:T,type:101}),ne(I.canceled())},ce=D.onCancellationRequested(Z);X=(0,f.combinedDisposable)((0,f.toDisposable)(Z),ce),this.activeRequests.add(X)}).finally(()=>{this.activeRequests.delete(X)})}requestEvent($,J,O){const D=this.lastRequestId++,_={id:D,type:102,channelName:$,name:J,arg:O};let z=null;const X=new d.Emitter({onFirstListenerAdd:()=>{z=(0,R.createCancelablePromise)(q=>this.whenInitialized()),z.then(()=>{z=null,this.activeRequests.add(X),this.sendRequest(_)})},onLastListenerRemove:()=>{z?(z.cancel(),z=null):(this.activeRequests.delete(X),this.sendRequest({id:D,type:103}))}}),B=q=>X.fire(q.data);return this.handlers.set(D,B),X.event}sendRequest($){switch($.type){case 100:case 102:{const J=this.send([$.type,$.id,$.channelName,$.name],$.arg);this.logger&&this.logger.logOutgoing(J,$.id,0,`${t($.type)}: ${$.channelName}.${$.name}`,$.arg);return}case 101:case 103:{const J=this.send([$.type,$.id]);this.logger&&this.logger.logOutgoing(J,$.id,0,t($.type));return}}}send($,J=void 0){const O=new c;return s(O,$),s(O,J),this.sendBuffer(O.buffer)}sendBuffer($){try{return this.protocol.send($),$.byteLength}catch(J){return 0}}onBuffer($){const J=new P($),O=h(J),D=h(J),T=O[0];switch(T){case 200:return this.logger&&this.logger.logIncoming($.byteLength,0,0,v(T)),this.onResponse({type:O[0]});case 201:case 202:case 204:case 203:return this.logger&&this.logger.logIncoming($.byteLength,O[1],0,v(T),D),this.onResponse({type:O[0],id:O[1],data:D})}}onResponse($){if($.type===200){this.state=b.Idle,this._onDidInitialize.fire();return}const J=this.handlers.get($.id);J&&J($)}get onDidInitializePromise(){return d.Event.toPromise(this.onDidInitialize)}whenInitialized(){return this.state===b.Idle?Promise.resolve():this.onDidInitializePromise}dispose(){this.isDisposed=!0,this.protocolListener&&(this.protocolListener.dispose(),this.protocolListener=null),this.activeRequests.forEach($=>$.dispose()),this.activeRequests.clear()}}fe([n.memoize],A.prototype,"onDidInitializePromise",null),e.ChannelClient=A;class L{constructor($){this.channels=new Map,this._connections=new Set,this._onDidAddConnection=new d.Emitter,this.onDidAddConnection=this._onDidAddConnection.event,this._onDidRemoveConnection=new d.Emitter,this.onDidRemoveConnection=this._onDidRemoveConnection.event,$(({protocol:J,onDidClientDisconnect:O})=>{d.Event.once(J.onMessage)(T=>{const _=new P(T),z=h(_),X=new w(J,z),B=new A(J);this.channels.forEach((ne,se)=>X.registerChannel(se,ne));const q={channelServer:X,channelClient:B,ctx:z};this._connections.add(q),this._onDidAddConnection.fire(q),O(()=>{X.dispose(),B.dispose(),this._connections.delete(q),this._onDidRemoveConnection.fire(q)})})})}get connections(){const $=[];return this._connections.forEach(J=>$.push(J)),$}getChannel($,J){const O=this;return{call(D,T,_){let z;if((0,g.isFunction)(J)){let B=(0,p.getRandomElement)(O.connections.filter(J));z=B?Promise.resolve(B):d.Event.toPromise(d.Event.filter(O.onDidAddConnection,J))}else z=J.routeCall(O,D,T);const X=z.then(B=>B.channelClient.getChannel($));return U(X).call(D,T,_)},listen(D,T){if((0,g.isFunction)(J))return O.getMulticastEvent($,J,D,T);const _=J.routeEvent(O,D,T).then(z=>z.channelClient.getChannel($));return U(_).listen(D,T)}}}getMulticastEvent($,J,O,D){const T=this;let _=new f.DisposableStore;const z=new d.Emitter({onFirstListenerAdd:()=>{_=new f.DisposableStore;const X=new d.EventMultiplexer,B=new Map,q=se=>{const Z=se.channelClient.getChannel($).listen(O,D),ce=X.add(Z);B.set(se,ce)},ne=se=>{const oe=B.get(se);!oe||(oe.dispose(),B.delete(se))};T.connections.filter(J).forEach(q),d.Event.filter(T.onDidAddConnection,J)(q,void 0,_),T.onDidRemoveConnection(ne,void 0,_),X.event(z.fire,z,_),_.add(X)},onLastListenerRemove:()=>{_.dispose()}});return z.event}registerChannel($,J){this.channels.set($,J),this._connections.forEach(O=>{O.channelServer.registerChannel($,J)})}dispose(){this.channels.clear(),this._connections.clear(),this._onDidAddConnection.dispose(),this._onDidRemoveConnection.dispose()}}e.IPCServer=L;class F{constructor($,J,O=null){const D=new c;s(D,J),$.send(D.buffer),this.channelClient=new A($,O),this.channelServer=new w($,J,O)}getChannel($){return this.channelClient.getChannel($)}registerChannel($,J){this.channelServer.registerChannel($,J)}dispose(){this.channelClient.dispose(),this.channelServer.dispose()}}e.IPCClient=F;function U(H){return{call($,J,O){return H.then(D=>D.call($,J,O))},listen($,J){const O=new d.Relay;return H.then(D=>O.input=D.listen($,J)),O.event}}}e.getDelayedChannel=U;function Y(H){let $=!1;return{call(J,O,D){return $?H.call(J,O,D):(0,R.timeout)(0).then(()=>$=!0).then(()=>H.call(J,O,D))},listen(J,O){if($)return H.listen(J,O);const D=new d.Relay;return(0,R.timeout)(0).then(()=>$=!0).then(()=>D.input=H.listen(J,O)),D.event}}}e.getNextTickChannel=Y;class ie{constructor($){this.fn=$}routeCall($){return this.route($)}routeEvent($){return this.route($)}async route($){for(const J of $.connections)if(await Promise.resolve(this.fn(J.ctx)))return Promise.resolve(J);return await d.Event.toPromise($.onDidAddConnection),await this.route($)}}e.StaticRouter=ie;var re;(function(H){function $(T,_){const z=T,X=_&&_.disableMarshalling,B=new Map;for(const q in z)O(q)&&B.set(q,d.Event.buffer(z[q],!0));return new class{listen(q,ne,se){const oe=B.get(ne);if(oe)return oe;if(D(ne)){const Z=z[ne];if(typeof Z=="function")return Z.call(z,se)}throw new Error(`Event not found: ${ne}`)}call(q,ne,se){const oe=z[ne];if(typeof oe=="function"){if(!X&&Array.isArray(se))for(let Z=0;Z<se.length;Z++)se[Z]=(0,y.revive)(se[Z]);return oe.apply(z,se)}throw new Error(`Method not found: ${ne}`)}}}H.fromService=$;function J(T,_){const z=_&&_.disableMarshalling;return new Proxy({},{get(X,B){if(typeof B=="string")return _?.properties?.has(B)?_.properties.get(B):D(B)?function(q){return T.listen(B,q)}:O(B)?T.listen(B):async function(...q){let ne;_&&!(0,g.isUndefinedOrNull)(_.context)?ne=[_.context,...q]:ne=q;const se=await T.call(B,ne);return z?se:(0,y.revive)(se)};throw new Error(`Property not found: ${String(B)}`)}})}H.toService=J;function O(T){return T[0]==="o"&&T[1]==="n"&&E.isUpperAsciiLetter(T.charCodeAt(2))}function D(T){return/^onDynamic/.test(T)&&E.isUpperAsciiLetter(T.charCodeAt(9))}})(re=e.ProxyChannel||(e.ProxyChannel={}));const K=[["#2977B1","#FC802D","#34A13A","#D3282F","#9366BA"],["#8B564C","#E177C0","#7F7F7F","#BBBE3D","#2EBECD"]];function W(H){if(Array.isArray(H))return H;if(H&&typeof H=="object"&&typeof H.toString=="function"){let $=H.toString();if($!=="[object Object]")return $}return H}function N(H){return Array.isArray(H)?H.map(W):W(H)}function G(H,$,J,O,D,T,_){_=N(_);const z=K[D],X=z[O%z.length];let B=[`%c[${H}]%c[${String($).padStart(7," ")}]%c[len: ${String(J).padStart(5," ")}]%c${String(O).padStart(5," ")} - ${T}`,"color: darkgreen","color: grey","color: grey",`color: ${X}`];/\($/.test(T)?(B=B.concat(_),B.push(")")):B.push(_),console.log.apply(console,B)}e.logWithColors=G;class Q{constructor($,J){this._outgoingPrefix=$,this._incomingPrefix=J,this._totalIncoming=0,this._totalOutgoing=0}logOutgoing($,J,O,D,T){this._totalOutgoing+=$,G(this._outgoingPrefix,this._totalOutgoing,$,J,O,D,T)}logIncoming($,J,O,D,T){this._totalIncoming+=$,G(this._incomingPrefix,this._totalIncoming,$,J,O,D,T)}}e.IPCLogger=Q}),define(x[123],ee([0,1]),function(V,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Protocol=void 0;class p{constructor(C,k){this.sender=C,this.onMessage=k}send(C){try{this.sender.send("vscode:message",C.buffer)}catch(k){}}disconnect(){this.sender.send("vscode:disconnect",null)}}e.Protocol=p}),define(x[124],ee([0,1,17,4,35]),function(V,e,p,R,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Client=e.Protocol=void 0;class k{constructor(d){this.port=d,this.onMessage=R.Event.fromDOMEventEmitter(this.port,"message",f=>p.VSBuffer.wrap(f.data)),d.start()}send(d){this.port.postMessage(d.buffer)}disconnect(){this.port.close()}}e.Protocol=k;class n extends C.IPCClient{constructor(d,f){const y=new k(d);super(y,f);this.protocol=y}dispose(){this.protocol.disconnect()}}e.Client=n}),define(x[84],ee([0,1,17,4,2,35]),function(V,e,p,R,C,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PersistentProtocol=e.BufferedEmitter=e.Client=e.Protocol=e.ProtocolConstants=e.ChunkStream=e.SocketCloseEventType=e.SocketDiagnostics=e.SocketDiagnosticsEventType=void 0;var n;(function(i){i.Created="created",i.Read="read",i.Write="write",i.Open="open",i.Error="error",i.Close="close",i.BrowserWebSocketBlobReceived="browserWebSocketBlobReceived",i.NodeEndReceived="nodeEndReceived",i.NodeEndSent="nodeEndSent",i.NodeDrainBegin="nodeDrainBegin",i.NodeDrainEnd="nodeDrainEnd",i.zlibInflateError="zlibInflateError",i.zlibInflateData="zlibInflateData",i.zlibInflateInitialWrite="zlibInflateInitialWrite",i.zlibInflateInitialFlushFired="zlibInflateInitialFlushFired",i.zlibInflateWrite="zlibInflateWrite",i.zlibInflateFlushFired="zlibInflateFlushFired",i.zlibDeflateError="zlibDeflateError",i.zlibDeflateData="zlibDeflateData",i.zlibDeflateWrite="zlibDeflateWrite",i.zlibDeflateFlushFired="zlibDeflateFlushFired",i.WebSocketNodeSocketWrite="webSocketNodeSocketWrite",i.WebSocketNodeSocketPeekedHeader="webSocketNodeSocketPeekedHeader",i.WebSocketNodeSocketReadHeader="webSocketNodeSocketReadHeader",i.WebSocketNodeSocketReadData="webSocketNodeSocketReadData",i.WebSocketNodeSocketUnmaskedData="webSocketNodeSocketUnmaskedData",i.WebSocketNodeSocketDrainBegin="webSocketNodeSocketDrainBegin",i.WebSocketNodeSocketDrainEnd="webSocketNodeSocketDrainEnd",i.ProtocolHeaderRead="protocolHeaderRead",i.ProtocolMessageRead="protocolMessageRead",i.ProtocolHeaderWrite="protocolHeaderWrite",i.ProtocolMessageWrite="protocolMessageWrite",i.ProtocolWrite="protocolWrite"})(n=e.SocketDiagnosticsEventType||(e.SocketDiagnosticsEventType={}));var I;(function(i){i.enableDiagnostics=!1,i.records=[];const s=new WeakMap;let h=0;function w(A,L){if(!s.has(A)){const F=String(++h);s.set(A,F)}return s.get(A)}function M(A,L,F,U){if(!i.enableDiagnostics)return;const Y=w(A,L);if(U instanceof p.VSBuffer||U instanceof Uint8Array||U instanceof ArrayBuffer||ArrayBuffer.isView(U)){const ie=p.VSBuffer.alloc(U.byteLength);ie.set(U),i.records.push({timestamp:Date.now(),id:Y,label:L,type:F,buff:ie})}else i.records.push({timestamp:Date.now(),id:Y,label:L,type:F,data:U})}i.traceSocketEvent=M})(I=e.SocketDiagnostics||(e.SocketDiagnostics={}));var d;(function(i){i[i.NodeSocketCloseEvent=0]="NodeSocketCloseEvent",i[i.WebSocketCloseEvent=1]="WebSocketCloseEvent"})(d=e.SocketCloseEventType||(e.SocketCloseEventType={}));let f=null;function y(){return f||(f=p.VSBuffer.alloc(0)),f}class E{constructor(){this._chunks=[],this._totalLength=0}get byteLength(){return this._totalLength}acceptChunk(s){this._chunks.push(s),this._totalLength+=s.byteLength}read(s){return this._read(s,!0)}peek(s){return this._read(s,!1)}_read(s,h){if(s===0)return y();if(s>this._totalLength)throw new Error("Cannot read so many bytes!");if(this._chunks[0].byteLength===s){const L=this._chunks[0];return h&&(this._chunks.shift(),this._totalLength-=s),L}if(this._chunks[0].byteLength>s){const L=this._chunks[0].slice(0,s);return h&&(this._chunks[0]=this._chunks[0].slice(s),this._totalLength-=s),L}let w=p.VSBuffer.alloc(s),M=0,A=0;for(;s>0;){const L=this._chunks[A];if(L.byteLength>s){const F=L.slice(0,s);w.set(F,M),M+=s,h&&(this._chunks[A]=L.slice(s),this._totalLength-=s),s-=s}else w.set(L,M),M+=L.byteLength,h?(this._chunks.shift(),this._totalLength-=L.byteLength):A++,s-=L.byteLength}return w}}e.ChunkStream=E;var g;(function(i){i[i.None=0]="None",i[i.Regular=1]="Regular",i[i.Control=2]="Control",i[i.Ack=3]="Ack",i[i.Disconnect=5]="Disconnect",i[i.ReplayRequest=6]="ReplayRequest",i[i.Pause=7]="Pause",i[i.Resume=8]="Resume"})(g||(g={}));function S(i){switch(i){case 0:return"None";case 1:return"Regular";case 2:return"Control";case 3:return"Ack";case 5:return"Disconnect";case 6:return"ReplayRequest";case 7:return"PauseWriting";case 8:return"ResumeWriting"}}var t;(function(i){i[i.HeaderLength=13]="HeaderLength",i[i.AcknowledgeTime=2e3]="AcknowledgeTime",i[i.TimeoutTime=2e4]="TimeoutTime",i[i.ReconnectionGraceTime=108e5]="ReconnectionGraceTime",i[i.ReconnectionShortGraceTime=3e5]="ReconnectionShortGraceTime"})(t=e.ProtocolConstants||(e.ProtocolConstants={}));class m{constructor(s,h,w,M){this.type=s,this.id=h,this.ack=w,this.data=M,this.writtenTime=0}get size(){return this.data.byteLength}}class v extends C.Disposable{constructor(s){super();this._onMessage=this._register(new R.Emitter),this.onMessage=this._onMessage.event,this._state={readHead:!0,readLen:13,messageType:0,id:0,ack:0},this._socket=s,this._isDisposed=!1,this._incomingData=new E,this._register(this._socket.onData(h=>this.acceptChunk(h))),this.lastReadTime=Date.now()}acceptChunk(s){if(!(!s||s.byteLength===0))for(this.lastReadTime=Date.now(),this._incomingData.acceptChunk(s);this._incomingData.byteLength>=this._state.readLen;){const h=this._incomingData.read(this._state.readLen);if(this._state.readHead)this._state.readHead=!1,this._state.readLen=h.readUInt32BE(9),this._state.messageType=h.readUInt8(0),this._state.id=h.readUInt32BE(1),this._state.ack=h.readUInt32BE(5),this._socket.traceSocketEvent("protocolHeaderRead",{messageType:S(this._state.messageType),id:this._state.id,ack:this._state.ack,messageSize:this._state.readLen});else{const w=this._state.messageType,M=this._state.id,A=this._state.ack;if(this._state.readHead=!0,this._state.readLen=13,this._state.messageType=0,this._state.id=0,this._state.ack=0,this._socket.traceSocketEvent("protocolMessageRead",h),this._onMessage.fire(new m(w,M,A,h)),this._isDisposed)break}}}readEntireBuffer(){return this._incomingData.read(this._incomingData.byteLength)}dispose(){this._isDisposed=!0,super.dispose()}}class b{constructor(s){this._writeNowTimeout=null,this._isDisposed=!1,this._isPaused=!1,this._socket=s,this._data=[],this._totalLength=0,this.lastWriteTime=0}dispose(){try{this.flush()}catch(s){}this._isDisposed=!0}drain(){return this.flush(),this._socket.drain()}flush(){this._writeNow()}pause(){this._isPaused=!0}resume(){this._isPaused=!1,this._scheduleWriting()}write(s){if(this._isDisposed)return;s.writtenTime=Date.now(),this.lastWriteTime=Date.now();const h=p.VSBuffer.alloc(13);h.writeUInt8(s.type,0),h.writeUInt32BE(s.id,1),h.writeUInt32BE(s.ack,5),h.writeUInt32BE(s.data.byteLength,9),this._socket.traceSocketEvent("protocolHeaderWrite",{messageType:S(s.type),id:s.id,ack:s.ack,messageSize:s.data.byteLength}),this._socket.traceSocketEvent("protocolMessageWrite",s.data),this._writeSoon(h,s.data)}_bufferAdd(s,h){const w=this._totalLength===0;return this._data.push(s,h),this._totalLength+=s.byteLength+h.byteLength,w}_bufferTake(){const s=p.VSBuffer.concat(this._data,this._totalLength);return this._data.length=0,this._totalLength=0,s}_writeSoon(s,h){this._bufferAdd(s,h)&&this._scheduleWriting()}_scheduleWriting(){this._writeNowTimeout||(this._writeNowTimeout=setTimeout(()=>{this._writeNowTimeout=null,this._writeNow()}))}_writeNow(){if(this._totalLength===0||this._isPaused)return;const s=this._bufferTake();this._socket.traceSocketEvent("protocolWrite",{byteLength:s.byteLength}),this._socket.write(s)}}class P extends C.Disposable{constructor(s){super();this._onMessage=new R.Emitter,this.onMessage=this._onMessage.event,this._onDidDispose=new R.Emitter,this.onDidDispose=this._onDidDispose.event,this._socket=s,this._socketWriter=this._register(new b(this._socket)),this._socketReader=this._register(new v(this._socket)),this._register(this._socketReader.onMessage(h=>{h.type===1&&this._onMessage.fire(h.data)})),this._register(this._socket.onClose(()=>this._onDidDispose.fire()))}drain(){return this._socketWriter.drain()}getSocket(){return this._socket}sendDisconnect(){}send(s){this._socketWriter.write(new m(1,0,0,s))}}e.Protocol=P;class c extends k.IPCClient{constructor(s,h,w=null){super(s,h,w);this.protocol=s}static fromSocket(s,h){return new c(new P(s),h)}get onDidDispose(){return this.protocol.onDidDispose}dispose(){super.dispose();const s=this.protocol.getSocket();this.protocol.sendDisconnect(),this.protocol.dispose(),s.end()}}e.Client=c;class a{constructor(){this._hasListeners=!1,this._isDeliveringMessages=!1,this._bufferedMessages=[],this._emitter=new R.Emitter({onFirstListenerAdd:()=>{this._hasListeners=!0,queueMicrotask(()=>this._deliverMessages())},onLastListenerRemove:()=>{this._hasListeners=!1}}),this.event=this._emitter.event}_deliverMessages(){if(!this._isDeliveringMessages){for(this._isDeliveringMessages=!0;this._hasListeners&&this._bufferedMessages.length>0;)this._emitter.fire(this._bufferedMessages.shift());this._isDeliveringMessages=!1}}fire(s){this._hasListeners?this._bufferedMessages.length>0?this._bufferedMessages.push(s):this._emitter.fire(s):this._bufferedMessages.push(s)}flushBuffer(){this._bufferedMessages=[]}}e.BufferedEmitter=a;class l{constructor(s){this.data=s,this.next=null}}class o{constructor(){this._first=null,this._last=null}peek(){return this._first?this._first.data:null}toArray(){let s=[],h=0,w=this._first;for(;w;)s[h++]=w.data,w=w.next;return s}pop(){if(!!this._first){if(this._first===this._last){this._first=null,this._last=null;return}this._first=this._first.next}}push(s){const h=new l(s);if(!this._first){this._first=h,this._last=h;return}this._last.next=h,this._last=h}}class u{constructor(){this.lastRuns=[];const s=Date.now();for(let h=0;h<u._HISTORY_LENGTH;h++)this.lastRuns[h]=s-1e3*h;setInterval(()=>{for(let h=u._HISTORY_LENGTH;h>=1;h--)this.lastRuns[h]=this.lastRuns[h-1];this.lastRuns[0]=Date.now()},1e3)}static getInstance(){return u._INSTANCE||(u._INSTANCE=new u),u._INSTANCE}load(){const s=Date.now(),h=(1+u._HISTORY_LENGTH)*1e3;let w=0;for(let M=0;M<u._HISTORY_LENGTH;M++)s-this.lastRuns[M]<=h&&w++;return 1-w/u._HISTORY_LENGTH}hasHighLoad(){return this.load()>=.5}}u._HISTORY_LENGTH=10,u._INSTANCE=null;class r{constructor(s,h=null,w=u.getInstance()){this._onControlMessage=new a,this.onControlMessage=this._onControlMessage.event,this._onMessage=new a,this.onMessage=this._onMessage.event,this._onDidDispose=new a,this.onDidDispose=this._onDidDispose.event,this._onSocketClose=new a,this.onSocketClose=this._onSocketClose.event,this._onSocketTimeout=new a,this.onSocketTimeout=this._onSocketTimeout.event,this._loadEstimator=w,this._isReconnecting=!1,this._outgoingUnackMsg=new o,this._outgoingMsgId=0,this._outgoingAckId=0,this._outgoingAckTimeout=null,this._incomingMsgId=0,this._incomingAckId=0,this._incomingMsgLastTime=0,this._incomingAckTimeout=null,this._lastReplayRequestTime=0,this._lastSocketTimeoutTime=Date.now(),this._socketDisposables=[],this._socket=s,this._socketWriter=new b(this._socket),this._socketDisposables.push(this._socketWriter),this._socketReader=new v(this._socket),this._socketDisposables.push(this._socketReader),this._socketDisposables.push(this._socketReader.onMessage(M=>this._receiveMessage(M))),this._socketDisposables.push(this._socket.onClose(M=>this._onSocketClose.fire(M))),h&&this._socketReader.acceptChunk(h)}get unacknowledgedCount(){return this._outgoingMsgId-this._outgoingAckId}dispose(){this._outgoingAckTimeout&&(clearTimeout(this._outgoingAckTimeout),this._outgoingAckTimeout=null),this._incomingAckTimeout&&(clearTimeout(this._incomingAckTimeout),this._incomingAckTimeout=null),this._socketDisposables=(0,C.dispose)(this._socketDisposables)}drain(){return this._socketWriter.drain()}sendDisconnect(){const s=new m(5,0,0,y());this._socketWriter.write(s),this._socketWriter.flush()}sendPause(){const s=new m(7,0,0,y());this._socketWriter.write(s)}sendResume(){const s=new m(8,0,0,y());this._socketWriter.write(s)}pauseSocketWriting(){this._socketWriter.pause()}getSocket(){return this._socket}getMillisSinceLastIncomingData(){return Date.now()-this._socketReader.lastReadTime}beginAcceptReconnection(s,h){this._isReconnecting=!0,this._socketDisposables=(0,C.dispose)(this._socketDisposables),this._onControlMessage.flushBuffer(),this._onSocketClose.flushBuffer(),this._onSocketTimeout.flushBuffer(),this._socket.dispose(),this._lastReplayRequestTime=0,this._lastSocketTimeoutTime=Date.now(),this._socket=s,this._socketWriter=new b(this._socket),this._socketDisposables.push(this._socketWriter),this._socketReader=new v(this._socket),this._socketDisposables.push(this._socketReader),this._socketDisposables.push(this._socketReader.onMessage(w=>this._receiveMessage(w))),this._socketDisposables.push(this._socket.onClose(w=>this._onSocketClose.fire(w))),this._socketReader.acceptChunk(h)}endAcceptReconnection(){this._isReconnecting=!1,this._incomingAckId=this._incomingMsgId;const s=new m(3,0,this._incomingAckId,y());this._socketWriter.write(s);const h=this._outgoingUnackMsg.toArray();for(let w=0,M=h.length;w<M;w++)this._socketWriter.write(h[w]);this._recvAckCheck()}acceptDisconnect(){this._onDidDispose.fire()}_receiveMessage(s){if(s.ack>this._outgoingAckId){this._outgoingAckId=s.ack;do{const h=this._outgoingUnackMsg.peek();if(h&&h.id<=s.ack)this._outgoingUnackMsg.pop();else break}while(!0)}switch(s.type){case 0:break;case 1:{if(s.id>this._incomingMsgId)if(s.id!==this._incomingMsgId+1){const h=Date.now();h-this._lastReplayRequestTime>1e4&&(this._lastReplayRequestTime=h,this._socketWriter.write(new m(6,0,0,y())))}else this._incomingMsgId=s.id,this._incomingMsgLastTime=Date.now(),this._sendAckCheck(),this._onMessage.fire(s.data);break}case 2:{this._onControlMessage.fire(s.data);break}case 3:break;case 5:{this._onDidDispose.fire();break}case 6:{const h=this._outgoingUnackMsg.toArray();for(let w=0,M=h.length;w<M;w++)this._socketWriter.write(h[w]);this._recvAckCheck();break}case 7:{this._socketWriter.pause();break}case 8:{this._socketWriter.resume();break}}}readEntireBuffer(){return this._socketReader.readEntireBuffer()}flush(){this._socketWriter.flush()}send(s){const h=++this._outgoingMsgId;this._incomingAckId=this._incomingMsgId;const w=new m(1,h,this._incomingAckId,s);this._outgoingUnackMsg.push(w),this._isReconnecting||(this._socketWriter.write(w),this._recvAckCheck())}sendControl(s){const h=new m(2,0,0,s);this._socketWriter.write(h)}_sendAckCheck(){if(this._incomingMsgId<=this._incomingAckId||this._incomingAckTimeout)return;const s=Date.now()-this._incomingMsgLastTime;if(s>=2e3){this._sendAck();return}this._incomingAckTimeout=setTimeout(()=>{this._incomingAckTimeout=null,this._sendAckCheck()},2e3-s+5)}_recvAckCheck(){if(this._outgoingMsgId<=this._outgoingAckId||this._outgoingAckTimeout||this._isReconnecting)return;const s=this._outgoingUnackMsg.peek(),h=Date.now()-s.writtenTime,w=Date.now()-this._socketReader.lastReadTime,M=Date.now()-this._lastSocketTimeoutTime;if(h>=2e4&&w>=2e4&&M>=2e4&&!this._loadEstimator.hasHighLoad()){this._lastSocketTimeoutTime=Date.now(),this._onSocketTimeout.fire(void 0);return}const A=Math.max(2e4-h,2e4-w,2e4-M,500);this._outgoingAckTimeout=setTimeout(()=>{this._outgoingAckTimeout=null,this._recvAckCheck()},A)}_sendAck(){if(this._incomingMsgId<=this._incomingAckId)return;this._incomingAckId=this._incomingMsgId;const s=new m(3,0,this._incomingAckId,y());this._socketWriter.write(s)}}e.PersistentProtocol=r}),define(x[125],ee([0,1,14,17,4,2,35,123]),function(V,e,p,R,C,k,n,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Server=void 0;function d(y,E){const g=C.Event.fromNodeEventEmitter(p.ipcMain,E,(t,m)=>({event:t,message:m})),S=C.Event.filter(g,({event:t})=>t.sender.id===y);return C.Event.map(S,({message:t})=>t&&R.VSBuffer.wrap(t))}class f extends n.IPCServer{constructor(){super(f.getOnDidClientConnect())}static getOnDidClientConnect(){const E=C.Event.fromNodeEventEmitter(p.ipcMain,"vscode:hello",({sender:g})=>g);return C.Event.map(E,g=>{const S=g.id,t=f.Clients.get(S);t&&t.dispose();const m=new C.Emitter;f.Clients.set(S,(0,k.toDisposable)(()=>m.fire()));const v=d(S,"vscode:message"),b=C.Event.any(C.Event.signal(d(S,"vscode:disconnect")),m.event);return{protocol:new I.Protocol(g,v),onDidClientDisconnect:b}})}}e.Server=f,f.Clients=new Map}),define(x[85],ee([0,1,14,4,31,124]),function(V,e,p,R,C,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.connect=e.Client=void 0;class n extends k.Client{constructor(f,y){super({addEventListener:(E,g)=>f.addListener(E,g),removeEventListener:(E,g)=>f.removeListener(E,g),postMessage:E=>f.postMessage(E),start:()=>f.start(),close:()=>f.close()},y)}}e.Client=n;async function I(d){if(d.isDestroyed()||d.webContents.isDestroyed())throw new Error("ipc.mp#connect: Cannot talk to window because it is closed or destroyed");const f=(0,C.generateUuid)();d.webContents.send("vscode:createMessageChannel",f);const y=R.Event.fromNodeEventEmitter(p.ipcMain,"vscode:createMessageChannelResult",(g,S)=>({nonce:S,port:g.ports[0]})),{port:E}=await R.Event.toPromise(R.Event.once(R.Event.filter(y,g=>g.nonce===f)));return E}e.connect=I}),define(x[86],ee([0,1,9,4,2,13]),function(V,e,p,R,C,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InMemoryStorageDatabase=e.Storage=e.isStorageItemsChangeEvent=e.StorageHint=void 0;var n;(function(E){E[E.STORAGE_DOES_NOT_EXIST=0]="STORAGE_DOES_NOT_EXIST"})(n=e.StorageHint||(e.StorageHint={}));function I(E){const g=E;return g?.changed instanceof Map||g?.deleted instanceof Set}e.isStorageItemsChangeEvent=I;var d;(function(E){E[E.None=0]="None",E[E.Initialized=1]="Initialized",E[E.Closed=2]="Closed"})(d||(d={}));class f extends C.Disposable{constructor(g,S=Object.create(null)){super();this.database=g,this.options=S,this._onDidChangeStorage=this._register(new R.Emitter),this.onDidChangeStorage=this._onDidChangeStorage.event,this.state=d.None,this.cache=new Map,this.flushDelayer=new p.ThrottledDelayer(f.DEFAULT_FLUSH_DELAY),this.pendingDeletes=new Set,this.pendingInserts=new Map,this.pendingClose=void 0,this.whenFlushedCallbacks=[],this.registerListeners()}registerListeners(){this._register(this.database.onDidChangeItemsExternal(g=>this.onDidChangeItemsExternal(g)))}onDidChangeItemsExternal(g){g.changed?.forEach((S,t)=>this.accept(t,S)),g.deleted?.forEach(S=>this.accept(S,void 0))}accept(g,S){if(this.state===d.Closed)return;let t=!1;(0,k.isUndefinedOrNull)(S)?t=this.cache.delete(g):this.cache.get(g)!==S&&(this.cache.set(g,S),t=!0),t&&this._onDidChangeStorage.fire(g)}get items(){return this.cache}get size(){return this.cache.size}async init(){this.state===d.None&&(this.state=d.Initialized,this.options.hint!==n.STORAGE_DOES_NOT_EXIST&&(this.cache=await this.database.getItems()))}get(g,S){const t=this.cache.get(g);return(0,k.isUndefinedOrNull)(t)?S:t}getBoolean(g,S){const t=this.get(g);return(0,k.isUndefinedOrNull)(t)?S:t==="true"}getNumber(g,S){const t=this.get(g);return(0,k.isUndefinedOrNull)(t)?S:parseInt(t,10)}async set(g,S){if(this.state===d.Closed)return;if((0,k.isUndefinedOrNull)(S))return this.delete(g);const t=String(S);if(this.cache.get(g)!==t)return this.cache.set(g,t),this.pendingInserts.set(g,t),this.pendingDeletes.delete(g),this._onDidChangeStorage.fire(g),this.doFlush()}async delete(g){if(!(this.state===d.Closed||!this.cache.delete(g)))return this.pendingDeletes.has(g)||this.pendingDeletes.add(g),this.pendingInserts.delete(g),this._onDidChangeStorage.fire(g),this.doFlush()}async close(){return this.pendingClose||(this.pendingClose=this.doClose()),this.pendingClose}async doClose(){this.state=d.Closed;try{await this.doFlush(0)}catch(g){}await this.database.close(()=>this.cache)}get hasPending(){return this.pendingInserts.size>0||this.pendingDeletes.size>0}async flushPending(){if(!this.hasPending)return;const g={insert:this.pendingInserts,delete:this.pendingDeletes};return this.pendingDeletes=new Set,this.pendingInserts=new Map,this.database.updateItems(g).finally(()=>{if(!this.hasPending)for(;this.whenFlushedCallbacks.length;)this.whenFlushedCallbacks.pop()?.()})}async flush(g){if(!!this.hasPending)return this.doFlush(g)}async doFlush(g){return this.flushDelayer.trigger(()=>this.flushPending(),g)}async whenFlushed(){if(!!this.hasPending)return new Promise(g=>this.whenFlushedCallbacks.push(g))}dispose(){this.flushDelayer.dispose(),super.dispose()}}e.Storage=f,f.DEFAULT_FLUSH_DELAY=100;class y{constructor(){this.onDidChangeItemsExternal=R.Event.None,this.items=new Map}async getItems(){return this.items}async updateItems(g){g.insert&&g.insert.forEach((S,t)=>this.items.set(t,S)),g.delete&&g.delete.forEach(S=>this.items.delete(S))}async close(){}}e.InMemoryStorageDatabase=y}),define(x[126],ee([0,1,9,4,39,8,21]),function(V,e,p,R,C,k,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SQLiteStorageDatabase=void 0;class I{constructor(y,E=Object.create(null)){this.path=y,this.options=E,this.name=(0,k.basename)(this.path),this.logger=new d(this.options.logging),this.whenConnected=this.connect(this.path)}get onDidChangeItemsExternal(){return R.Event.None}async getItems(){const y=await this.whenConnected,E=new Map;return(await this.all(y,"SELECT * FROM ItemTable")).forEach(S=>E.set(S.key,S.value)),this.logger.isTracing&&this.logger.trace(`[storage ${this.name}] getItems(): ${E.size} rows`),E}async updateItems(y){const E=await this.whenConnected;return this.doUpdateItems(E,y)}doUpdateItems(y,E){return this.logger.isTracing&&this.logger.trace(`[storage ${this.name}] updateItems(): insert(${E.insert?(0,C.mapToString)(E.insert):"0"}), delete(${E.delete?(0,C.setToString)(E.delete):"0"})`),this.transaction(y,()=>{const g=E.insert,S=E.delete;if(g&&g.size>0){const t=[];t.push([]);let m=0;g.forEach((v,b)=>{let P=t[m];P.length>I.MAX_HOST_PARAMETERS&&(m++,P=[],t.push(P)),P.push(b,v)}),t.forEach(v=>{this.prepare(y,`INSERT INTO ItemTable VALUES ${new Array(v.length/2).fill("(?,?)").join(",")}`,b=>b.run(v),()=>{const b=[];let P=0;return g.forEach((c,a)=>{b.push(a),P+=c.length}),`Keys: ${b.join(", ")} Length: ${P}`})})}if(S&&S.size){const t=[];t.push([]);let m=0;S.forEach(v=>{let b=t[m];b.length>I.MAX_HOST_PARAMETERS&&(m++,b=[],t.push(b)),b.push(v)}),t.forEach(v=>{this.prepare(y,`DELETE FROM ItemTable WHERE key IN (${new Array(v.length).fill("?").join(",")})`,b=>b.run(v),()=>{const b=[];return S.forEach(P=>{b.push(P)}),`Keys: ${b.join(", ")}`})})}})}async close(y){this.logger.trace(`[storage ${this.name}] close()`);const E=await this.whenConnected;return this.doClose(E,y)}doClose(y,E){return new Promise((g,S)=>{y.db.close(t=>(t&&this.handleSQLiteError(y,`[storage ${this.name}] close(): ${t}`),this.path===I.IN_MEMORY_PATH?g():!y.isErroneous&&!y.isInMemory?this.backup().then(g,m=>(this.logger.error(`[storage ${this.name}] backup(): ${m}`),g())):typeof E=="function"?n.Promises.unlink(this.path).then(()=>this.doConnect(this.path).then(m=>{const v=()=>this.doClose(m,void 0);return this.doUpdateItems(m,{insert:E()}).then(()=>v(),b=>(v(),Promise.reject(b)))})).then(g,S):S(t||new Error("Database has errors or is in-memory without recovery option"))))})}backup(){const y=this.toBackupPath(this.path);return n.Promises.copy(this.path,y,{preserveSymlinks:!1})}toBackupPath(y){return`${y}.backup`}async checkIntegrity(y){this.logger.trace(`[storage ${this.name}] checkIntegrity(full: ${y})`);const E=await this.whenConnected,g=await this.get(E,y?"PRAGMA integrity_check":"PRAGMA quick_check"),S=y?g.integrity_check:g.quick_check;return E.isErroneous?`${S} (last error: ${E.lastError})`:E.isInMemory?`${S} (in-memory!)`:S}async connect(y,E=!0){this.logger.trace(`[storage ${this.name}] open(${y}, retryOnBusy: ${E})`);try{return await this.doConnect(y)}catch(g){if(this.logger.error(`[storage ${this.name}] open(): Unable to open DB due to ${g}`),g.code==="SQLITE_BUSY"&&E)return await(0,p.timeout)(I.BUSY_OPEN_TIMEOUT),this.connect(y,!1);try{await n.Promises.unlink(y);try{await n.Promises.rename(this.toBackupPath(y),y)}catch(S){}return await this.doConnect(y)}catch(S){return this.logger.error(`[storage ${this.name}] open(): Unable to use backup due to ${S}`),this.doConnect(I.IN_MEMORY_PATH)}}}handleSQLiteError(y,E){y.isErroneous=!0,y.lastError=E,this.logger.error(E)}doConnect(y){return new Promise((E,g)=>{new Promise((S,t)=>{V(["@vscode/sqlite3"],S,t)}).then(S=>{const t={db:new(this.logger.isTracing?S.verbose().Database:S.Database)(y,m=>m?t.db?t.db.close(()=>g(m)):g(m):this.exec(t,["PRAGMA user_version = 1;","CREATE TABLE IF NOT EXISTS ItemTable (key TEXT UNIQUE ON CONFLICT REPLACE, value BLOB)"].join("")).then(()=>E(t),v=>t.db.close(()=>g(v)))),isInMemory:y===I.IN_MEMORY_PATH};t.db.on("error",m=>this.handleSQLiteError(t,`[storage ${this.name}] Error (event): ${m}`)),this.logger.isTracing&&t.db.on("trace",m=>this.logger.trace(`[storage ${this.name}] Trace (event): ${m}`))},g)})}exec(y,E){return new Promise((g,S)=>{y.db.exec(E,t=>t?(this.handleSQLiteError(y,`[storage ${this.name}] exec(): ${t}`),S(t)):g())})}get(y,E){return new Promise((g,S)=>{y.db.get(E,(t,m)=>t?(this.handleSQLiteError(y,`[storage ${this.name}] get(): ${t}`),S(t)):g(m))})}all(y,E){return new Promise((g,S)=>{y.db.all(E,(t,m)=>t?(this.handleSQLiteError(y,`[storage ${this.name}] all(): ${t}`),S(t)):g(m))})}transaction(y,E){return new Promise((g,S)=>{y.db.serialize(()=>{y.db.run("BEGIN TRANSACTION"),E(),y.db.run("END TRANSACTION",t=>t?(this.handleSQLiteError(y,`[storage ${this.name}] transaction(): ${t}`),S(t)):g())})})}prepare(y,E,g,S){const t=y.db.prepare(E),m=v=>{this.handleSQLiteError(y,`[storage ${this.name}] prepare(): ${v} (${E}). Details: ${S()}`)};t.on("error",m),g(t),t.finalize(v=>{v&&m(v),t.removeListener("error",m)})}}e.SQLiteStorageDatabase=I,I.IN_MEMORY_PATH=":memory:",I.BUSY_OPEN_TIMEOUT=2e3,I.MAX_HOST_PARAMETERS=256;class d{constructor(y){y&&typeof y.logTrace=="function"&&process.env[d.VSCODE_TRACE_STORAGE]&&(this.logTrace=y.logTrace),y&&typeof y.logError=="function"&&(this.logError=y.logError)}get isTracing(){return!!this.logTrace}trace(y){this.logTrace&&this.logTrace(y)}error(y){this.logError&&this.logError(y)}}d.VSCODE_TRACE_STORAGE="VSCODE_TRACE_STORAGE"}),define(x[127],ee([12,11]),function(V,e){return V.create("vs/base/common/date",e)}),define(x[128],ee([0,1,127]),function(V,e,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toLocalISOString=e.fromNow=void 0;const R=60,C=R*60,k=C*24,n=k*7,I=k*30,d=k*365;function f(E,g){typeof E!="number"&&(E=E.getTime());const S=Math.round((new Date().getTime()-E)/1e3);if(S<-30)return(0,p.localize)(0,null,f(new Date().getTime()+S*1e3,!1));if(S<30)return(0,p.localize)(1,null);let t;return S<R?(t=S,g?t===1?(0,p.localize)(2,null,t):(0,p.localize)(3,null,t):t===1?(0,p.localize)(4,null,t):(0,p.localize)(5,null,t)):S<C?(t=Math.floor(S/R),g?t===1?(0,p.localize)(6,null,t):(0,p.localize)(7,null,t):t===1?(0,p.localize)(8,null,t):(0,p.localize)(9,null,t)):S<k?(t=Math.floor(S/C),g?t===1?(0,p.localize)(10,null,t):(0,p.localize)(11,null,t):t===1?(0,p.localize)(12,null,t):(0,p.localize)(13,null,t)):S<n?(t=Math.floor(S/k),g?t===1?(0,p.localize)(14,null,t):(0,p.localize)(15,null,t):t===1?(0,p.localize)(16,null,t):(0,p.localize)(17,null,t)):S<I?(t=Math.floor(S/n),g?t===1?(0,p.localize)(18,null,t):(0,p.localize)(19,null,t):t===1?(0,p.localize)(20,null,t):(0,p.localize)(21,null,t)):S<d?(t=Math.floor(S/I),g?t===1?(0,p.localize)(22,null,t):(0,p.localize)(23,null,t):t===1?(0,p.localize)(24,null,t):(0,p.localize)(25,null,t)):(t=Math.floor(S/d),g?t===1?(0,p.localize)(26,null,t):(0,p.localize)(27,null,t):t===1?(0,p.localize)(28,null,t):(0,p.localize)(29,null,t))}e.fromNow=f;function y(E){return E.getFullYear()+"-"+String(E.getMonth()+1).padStart(2,"0")+"-"+String(E.getDate()).padStart(2,"0")+"T"+String(E.getHours()).padStart(2,"0")+":"+String(E.getMinutes()).padStart(2,"0")+":"+String(E.getSeconds()).padStart(2,"0")+"."+(E.getMilliseconds()/1e3).toFixed(3).slice(2,5)+"Z"}e.toLocalISOString=y}),define(x[129],ee([12,11]),function(V,e){return V.create("vs/base/common/errorMessage",e)}),define(x[44],ee([0,1,30,13,129]),function(V,e,p,R,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toErrorMessage=void 0;function k(f,y){return y&&(f.stack||f.stacktrace)?C.localize(0,null,I(f),n(f.stack)||n(f.stacktrace)):I(f)}function n(f){return Array.isArray(f)?f.join(`
`):f}function I(f){return typeof f.code=="string"&&typeof f.errno=="number"&&typeof f.syscall=="string"?C.localize(1,null,f.message):f.message||C.localize(2,null)}function d(f=null,y=!1){if(!f)return C.localize(3,null);if(Array.isArray(f)){const E=p.coalesce(f),g=d(E[0],y);return E.length>1?C.localize(4,null,g,E.length):g}if(R.isString(f))return f;if(f.detail){const E=f.detail;if(E.error)return k(E.error,y);if(E.exception)return k(E.exception,y)}return f.stack?k(f,y):f.message?f.message:C.localize(5,null)}e.toErrorMessage=d}),define(x[130],ee([12,11]),function(V,e){return V.create("vs/base/common/keybindingLabels",e)}),define(x[131],ee([0,1,130]),function(V,e,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserSettingsLabelProvider=e.ElectronAcceleratorLabelProvider=e.AriaLabelProvider=e.UILabelProvider=e.ModifierLabelProvider=void 0;class R{constructor(n,I,d=I){this.modifierLabels=[null],this.modifierLabels[2]=n,this.modifierLabels[1]=I,this.modifierLabels[3]=d}toLabel(n,I,d){if(I.length===0)return null;const f=[];for(let y=0,E=I.length;y<E;y++){const g=I[y],S=d(g);if(S===null)return null;f[y]=C(g,S,this.modifierLabels[n])}return f.join(" ")}}e.ModifierLabelProvider=R,e.UILabelProvider=new R({ctrlKey:"\u2303",shiftKey:"\u21E7",altKey:"\u2325",metaKey:"\u2318",separator:""},{ctrlKey:p.localize(0,null),shiftKey:p.localize(1,null),altKey:p.localize(2,null),metaKey:p.localize(3,null),separator:"+"},{ctrlKey:p.localize(4,null),shiftKey:p.localize(5,null),altKey:p.localize(6,null),metaKey:p.localize(7,null),separator:"+"}),e.AriaLabelProvider=new R({ctrlKey:p.localize(8,null),shiftKey:p.localize(9,null),altKey:p.localize(10,null),metaKey:p.localize(11,null),separator:"+"},{ctrlKey:p.localize(12,null),shiftKey:p.localize(13,null),altKey:p.localize(14,null),metaKey:p.localize(15,null),separator:"+"},{ctrlKey:p.localize(16,null),shiftKey:p.localize(17,null),altKey:p.localize(18,null),metaKey:p.localize(19,null),separator:"+"}),e.ElectronAcceleratorLabelProvider=new R({ctrlKey:"Ctrl",shiftKey:"Shift",altKey:"Alt",metaKey:"Cmd",separator:"+"},{ctrlKey:"Ctrl",shiftKey:"Shift",altKey:"Alt",metaKey:"Super",separator:"+"}),e.UserSettingsLabelProvider=new R({ctrlKey:"ctrl",shiftKey:"shift",altKey:"alt",metaKey:"cmd",separator:"+"},{ctrlKey:"ctrl",shiftKey:"shift",altKey:"alt",metaKey:"win",separator:"+"},{ctrlKey:"ctrl",shiftKey:"shift",altKey:"alt",metaKey:"meta",separator:"+"});function C(k,n,I){if(n===null)return"";const d=[];return k.ctrlKey&&d.push(I.ctrlKey),k.shiftKey&&d.push(I.shiftKey),k.altKey&&d.push(I.altKey),k.metaKey&&d.push(I.metaKey),n!==""&&d.push(n),d.join(I.separator)}}),define(x[132],ee([12,11]),function(V,e){return V.create("vs/base/node/processes",e)}),define(x[72],ee([0,1,43,32,10,47,8,3,34,80,13,115,21,132]),function(V,e,p,R,C,k,n,I,d,f,y,E,g,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.win32=e.createQueuedSender=e.LineProcess=e.AbstractProcess=e.getWindowsShell=e.removeDangerousEnvVariables=e.TerminateResponseCode=e.Source=void 0,Object.defineProperty(e,"Source",{enumerable:!0,get:function(){return f.Source}}),Object.defineProperty(e,"TerminateResponseCode",{enumerable:!0,get:function(){return f.TerminateResponseCode}});function t(o){switch(o){case 0:return 0;case 1:return 2;case 128:return 3;default:return 1}}function m(o,u){if(I.isWindows)try{const r={stdio:["pipe","pipe","ignore"]};u&&(r.cwd=u);const i=p.execFile("taskkill",["/T","/F","/PID",o.pid.toString()],r);return new Promise(s=>{i.once("error",h=>{s({success:!1,error:h})}),i.once("exit",(h,w)=>{s(h===0?{success:!0}:{success:!1,code:h!==null?h:1})})})}catch(r){return Promise.resolve({success:!1,error:r,code:r.status?t(r.status):1})}else if(I.isLinux||I.isMacintosh)try{const r=C.FileAccess.asFileUri("vs/base/node/terminateProcess.sh",V).fsPath;return new Promise(i=>{p.execFile(r,[o.pid.toString()],{encoding:"utf8",shell:!0},(s,h,w)=>{i(s?{success:!1,error:s}:{success:!0})})})}catch(r){return Promise.resolve({success:!1,error:r})}else o.kill("SIGKILL");return Promise.resolve({success:!0})}function v(o){!o||(delete o.DEBUG,I.isMacintosh&&delete o.DYLD_LIBRARY_PATH,I.isLinux&&delete o.LD_PRELOAD)}e.removeDangerousEnvVariables=v;function b(o=d.env){return o.comspec||"cmd.exe"}e.getWindowsShell=b;class P{constructor(u,r,i,s){if(r!==void 0&&i!==void 0&&s!==void 0)this.cmd=u,this.args=r,this.shell=i,this.options=s;else{const h=u;this.cmd=h.command,this.shell=h.isShellCommand,this.args=h.args.slice(0),this.options=h.options||{}}if(this.childProcess=null,this.childProcessPromise=null,this.terminateRequested=!1,this.options.env){const h=Object.create(null);Object.keys(d.env).forEach(w=>{h[w]=d.env[w]}),Object.keys(this.options.env).forEach(w=>{h[w]=this.options.env[w]}),this.options.env=h}}getSanitizedCommand(){let u=this.cmd.toLowerCase();const r=u.lastIndexOf(n.sep);return r!==-1&&(u=u.substring(r+1)),P.WellKnowCommands[u]?u:"other"}start(u){return I.isWindows&&(this.options&&this.options.cwd&&R.isUNC(this.options.cwd)||!this.options&&R.isUNC(d.cwd()))?Promise.reject(new Error(S.localize(0,null))):this.useExec().then(r=>{let i,s;const h=new Promise((w,M)=>{i=w,s=M});if(r){let w=this.cmd;this.args&&(w=w+" "+this.args.join(" ")),this.childProcess=p.exec(w,this.options,(M,A,L)=>{this.childProcess=null;const F=M;F&&F.killed?s({killed:this.terminateRequested,stdout:A.toString(),stderr:L.toString()}):this.handleExec(i,u,M,A,L)})}else{let w=null;const M=A=>{this.childProcess=null,this.childProcessPromise=null,this.handleClose(A,i,u,s);const L={terminated:this.terminateRequested};y.isNumber(A)&&(L.cmdCode=A),i(L)};if(this.shell&&I.isWindows){const A=k.deepClone(this.options);A.windowsVerbatimArguments=!0,A.detached=!1;let L=!1,F=!1;const U=[];let Y=this.ensureQuotes(this.cmd);U.push(Y.value),L=Y.quoted,this.args&&this.args.forEach(re=>{Y=this.ensureQuotes(re),U.push(Y.value),F=F&&Y.quoted});const ie=["/s","/c"];L?F?ie.push('"'+U.join(" ")+'"'):U.length>1?ie.push('"'+U[0]+'" '+U.slice(1).join(" ")):ie.push('"'+U[0]+'"'):ie.push(U.join(" ")),w=p.spawn(b(),ie,A)}else this.cmd&&(w=p.spawn(this.cmd,this.args,this.options));w&&(this.childProcess=w,this.childProcessPromise=Promise.resolve(w),this.pidResolve&&(this.pidResolve(y.isNumber(w.pid)?w.pid:-1),this.pidResolve=void 0),w.on("error",A=>{this.childProcess=null,s({terminated:this.terminateRequested,error:A})}),w.pid&&(this.childProcess.on("close",M),this.handleSpawn(w,i,u,s,!0)))}return h})}handleClose(u,r,i,s){}ensureQuotes(u){return P.regexp.test(u)?{value:'"'+u+'"',quoted:!0}:{value:u,quoted:u.length>0&&u[0]==='"'&&u[u.length-1]==='"'}}get pid(){return this.childProcessPromise?this.childProcessPromise.then(u=>u.pid,u=>-1):new Promise(u=>{this.pidResolve=u})}terminate(){return this.childProcessPromise?this.childProcessPromise.then(u=>(this.terminateRequested=!0,m(u,this.options.cwd).then(r=>(r.success&&(this.childProcess=null),r))),u=>({success:!0})):Promise.resolve({success:!0})}useExec(){return new Promise(u=>{if(!this.shell||!I.isWindows)return u(!1);const r=p.spawn(b(),["/s","/c"]);r.on("error",i=>u(!0)),r.on("exit",i=>u(!1))})}}e.AbstractProcess=P,P.WellKnowCommands={ant:!0,cmake:!0,eslint:!0,gradle:!0,grunt:!0,gulp:!0,jake:!0,jenkins:!0,jshint:!0,make:!0,maven:!0,msbuild:!0,msc:!0,nmake:!0,npm:!0,rake:!0,tsc:!0,xbuild:!0},P.regexp=/^[^"].* .*[^"]/;class c extends P{constructor(u,r,i,s){super(u,r,i,s);this.stdoutLineDecoder=null,this.stderrLineDecoder=null}handleExec(u,r,i,s,h){[s,h].forEach((w,M)=>{const A=new E.LineDecoder;A.write(w).forEach(U=>{r({line:U,source:M===0?0:1})});const F=A.end();F&&r({line:F,source:M===0?0:1})}),u({terminated:this.terminateRequested,error:i})}handleSpawn(u,r,i,s,h){const w=new E.LineDecoder,M=new E.LineDecoder;u.stdout.on("data",A=>{w.write(A).forEach(F=>i({line:F,source:0}))}),u.stderr.on("data",A=>{M.write(A).forEach(F=>i({line:F,source:1}))}),this.stdoutLineDecoder=w,this.stderrLineDecoder=M}handleClose(u,r,i,s){const h=this.stdoutLineDecoder?this.stdoutLineDecoder.end():null;h&&i({line:h,source:0});const w=this.stderrLineDecoder?this.stderrLineDecoder.end():null;w&&i({line:w,source:1})}}e.LineProcess=c;function a(o){let u=[],r=!1;const i=function(s){if(r){u.push(s);return}(!o.send(s,w=>{if(w&&console.error(w),r=!1,u.length>0){const M=u.slice(0);u=[],M.forEach(A=>i(A))}})||I.isWindows)&&(r=!0)};return{send:i}}e.createQueuedSender=a;var l;(function(o){async function u(r,i,s){if(n.isAbsolute(r))return r;if(i===void 0&&(i=d.cwd()),n.dirname(r)!=="."||(s===void 0&&y.isString(d.env.PATH)&&(s=d.env.PATH.split(n.delimiter)),s===void 0||s.length===0))return n.join(i,r);async function w(M){if(await g.Promises.exists(M)){let A;try{A=await g.Promises.stat(M)}catch(L){L.message.startsWith("EACCES")&&(A=await g.Promises.lstat(M))}return A?!A.isDirectory():!1}return!1}for(let M of s){let A;if(n.isAbsolute(M)?A=n.join(M,r):A=n.join(i,M,r),await w(A))return A;let L=A+".com";if(await w(L)||(L=A+".exe",await w(L)))return L}return n.join(i,r)}o.findExecutable=u})(l=e.win32||(e.win32={}))}),define(x[133],ee([0,1,26,3,119,72]),function(V,e,p,R,C,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getSystemShellSync=e.getSystemShell=void 0;async function n(S,t){return S===1?R.isWindows?E():k.getWindowsShell(t):f(S,t)}e.getSystemShell=n;function I(S,t){return S===1?R.isWindows?g(t):k.getWindowsShell(t):f(S,t)}e.getSystemShellSync=I;let d=null;function f(S,t){if(R.isLinux&&S===2||R.isMacintosh&&S===3)return"/bin/bash";if(!d){let m;if(R.isWindows)m="/bin/bash";else{if(m=t.SHELL,!m)try{m=(0,p.userInfo)().shell}catch(v){}m||(m="sh"),m==="/bin/false"&&(m="/bin/bash")}d=m}return d}let y=null;async function E(){return y||(y=(await(0,C.getFirstAvailablePowerShellInstallation)()).exePath),y}function g(S){if(y)return y;const t=R.isWindows&&parseFloat((0,p.release)())>=10,m=S.hasOwnProperty("PROCESSOR_ARCHITEW6432"),v=`${S.windir}\\${m?"Sysnative":"System32"}\\WindowsPowerShell\\v1.0\\powershell.exe`;return t?v:k.getWindowsShell(S)}}),define(x[87],ee([0,1,43,9,17,23,110,16,4,2,47,72,35]),function(V,e,p,R,C,k,n,I,d,f,y,E,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Client=e.Server=void 0;class S extends g.ChannelServer{constructor(v){super({send:b=>{try{process.send&&process.send(b.buffer.toString("base64"))}catch(P){}},onMessage:d.Event.fromNodeEventEmitter(process,"message",b=>C.VSBuffer.wrap(Buffer.from(b,"base64")))},v);process.once("disconnect",()=>this.dispose())}}e.Server=S;class t{constructor(v,b){this.modulePath=v,this.options=b,this.activeRequests=new Set,this.channels=new Map,this._onDidProcessExit=new d.Emitter,this.onDidProcessExit=this._onDidProcessExit.event;const P=b&&b.timeout?b.timeout:6e4;this.disposeDelayer=new R.Delayer(P),this.child=null,this._client=null}getChannel(v){const b=this;return{call(P,c,a){return b.requestPromise(v,P,c,a)},listen(P,c){return b.requestEvent(v,P,c)}}}requestPromise(v,b,P,c=k.CancellationToken.None){if(!this.disposeDelayer)return Promise.reject(new Error("disposed"));if(c.isCancellationRequested)return Promise.reject(I.canceled());this.disposeDelayer.cancel();const a=this.getCachedChannel(v),l=(0,R.createCancelablePromise)(r=>a.call(b,P,r)),o=c.onCancellationRequested(()=>l.cancel()),u=(0,f.toDisposable)(()=>l.cancel());return this.activeRequests.add(u),l.finally(()=>{o.dispose(),this.activeRequests.delete(u),this.activeRequests.size===0&&this.disposeDelayer&&this.disposeDelayer.trigger(()=>this.disposeClient())}),l}requestEvent(v,b,P){if(!this.disposeDelayer)return d.Event.None;this.disposeDelayer.cancel();let c;const a=new d.Emitter({onFirstListenerAdd:()=>{c=this.getCachedChannel(v).listen(b,P)(a.fire,a),this.activeRequests.add(c)},onLastListenerRemove:()=>{this.activeRequests.delete(c),c.dispose(),this.activeRequests.size===0&&this.disposeDelayer&&this.disposeDelayer.trigger(()=>this.disposeClient())}});return a.event}get client(){if(!this._client){const v=this.options&&this.options.args?this.options.args:[],b=Object.create(null);b.env={...(0,y.deepClone)(process.env),VSCODE_PARENT_PID:String(process.pid)},this.options&&this.options.env&&(b.env={...b.env,...this.options.env}),this.options&&this.options.freshExecArgv&&(b.execArgv=[]),this.options&&typeof this.options.debug=="number"&&(b.execArgv=["--nolazy","--inspect="+this.options.debug]),this.options&&typeof this.options.debugBrk=="number"&&(b.execArgv=["--nolazy","--inspect-brk="+this.options.debugBrk]),b.execArgv===void 0&&(b.execArgv=process.execArgv.filter(i=>!/^--inspect(-brk)?=/.test(i))),(0,E.removeDangerousEnvVariables)(b.env),this.child=(0,p.fork)(this.modulePath,v,b);const P=new d.Emitter;d.Event.fromNodeEventEmitter(this.child,"message",i=>i)(i=>{if((0,n.isRemoteConsoleLog)(i)){(0,n.log)(i,`IPC Library: ${this.options.serverName}`);return}P.fire(C.VSBuffer.wrap(Buffer.from(i,"base64")))});const a=this.options.useQueue?(0,E.createQueuedSender)(this.child):this.child,l=i=>this.child&&this.child.connected&&a.send(i.buffer.toString("base64")),o=P.event,u={send:l,onMessage:o};this._client=new g.ChannelClient(u);const r=()=>this.disposeClient();process.once("exit",r),this.child.on("error",i=>console.warn('IPC "'+this.options.serverName+'" errored with '+i)),this.child.on("exit",(i,s)=>{process.removeListener("exit",r),this.activeRequests.forEach(h=>(0,f.dispose)(h)),this.activeRequests.clear(),i!==0&&s!=="SIGTERM"&&console.warn('IPC "'+this.options.serverName+'" crashed with exit code '+i+" and signal "+s),this.disposeDelayer&&this.disposeDelayer.cancel(),this.disposeClient(),this._onDidProcessExit.fire({code:i,signal:s})})}return this._client}getCachedChannel(v){let b=this.channels.get(v);return b||(b=this.client.getChannel(v),this.channels.set(v,b)),b}disposeClient(){this._client&&(this.child&&(this.child.kill(),this.child=null),this._client=null,this.channels.clear())}dispose(){this._onDidProcessExit.dispose(),this.disposeDelayer&&(this.disposeDelayer.cancel(),this.disposeDelayer=void 0),this.disposeClient(),this.activeRequests.clear()}}e.Client=t}),define(x[134],ee([12,11]),function(V,e){return V.create("vs/code/electron-main/app",e)}),define(x[135],ee([12,11]),function(V,e){return V.create("vs/platform/configuration/common/configurationRegistry",e)}),define(x[136],ee([12,11]),function(V,e){return V.create("vs/platform/dialogs/electron-main/dialogMainService",e)}),define(x[137],ee([12,11]),function(V,e){return V.create("vs/platform/environment/node/argv",e)}),define(x[138],ee([12,11]),function(V,e){return V.create("vs/platform/environment/node/argvHelper",e)}),define(x[139],ee([12,11]),function(V,e){return V.create("vs/platform/environment/node/shellEnv",e)}),define(x[140],ee([12,11]),function(V,e){return V.create("vs/platform/extensionManagement/common/extensionManagement",e)}),define(x[141],ee([12,11]),function(V,e){return V.create("vs/platform/extensions/common/extensionValidator",e)}),define(x[142],ee([12,11]),function(V,e){return V.create("vs/platform/externalTerminal/node/externalTerminalService",e)}),define(x[143],ee([12,11]),function(V,e){return V.create("vs/platform/files/common/fileService",e)}),define(x[144],ee([12,11]),function(V,e){return V.create("vs/platform/files/common/files",e)}),define(x[145],ee([12,11]),function(V,e){return V.create("vs/platform/files/common/io",e)}),define(x[146],ee([12,11]),function(V,e){return V.create("vs/platform/files/electron-main/diskFileSystemProviderIpc",e)}),define(x[147],ee([12,11]),function(V,e){return V.create("vs/platform/files/node/diskFileSystemProvider",e)}),define(x[148],ee([12,11]),function(V,e){return V.create("vs/platform/issue/electron-main/issueMainService",e)}),define(x[149],ee([12,11]),function(V,e){return V.create("vs/platform/menubar/electron-main/menubar",e)}),define(x[150],ee([12,11]),function(V,e){return V.create("vs/platform/native/electron-main/nativeHostMainService",e)}),define(x[151],ee([12,11]),function(V,e){return V.create("vs/platform/request/common/request",e)}),define(x[152],ee([12,11]),function(V,e){return V.create("vs/platform/telemetry/common/telemetryService",e)}),define(x[153],ee([12,11]),function(V,e){return V.create("vs/platform/update/common/update.config.contribution",e)}),define(x[154],ee([12,11]),function(V,e){return V.create("vs/platform/windows/electron-main/window",e)}),define(x[155],ee([12,11]),function(V,e){return V.create("vs/platform/windows/electron-main/windowsMainService",e)}),define(x[156],ee([12,11]),function(V,e){return V.create("vs/platform/workspaces/common/workspaces",e)}),define(x[157],ee([12,11]),function(V,e){return V.create("vs/platform/workspaces/electron-main/workspacesHistoryMainService",e)}),define(x[158],ee([12,11]),function(V,e){return V.create("vs/platform/workspaces/electron-main/workspacesManagementMainService",e)}),define(x[159],ee([0,1,4,2]),function(V,e,p,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionHostDebugChannelClient=e.ExtensionHostDebugBroadcastChannel=void 0;class C{constructor(){this._onCloseEmitter=new p.Emitter,this._onReloadEmitter=new p.Emitter,this._onTerminateEmitter=new p.Emitter,this._onAttachEmitter=new p.Emitter}call(I,d,f){switch(d){case"close":return Promise.resolve(this._onCloseEmitter.fire({sessionId:f[0]}));case"reload":return Promise.resolve(this._onReloadEmitter.fire({sessionId:f[0]}));case"terminate":return Promise.resolve(this._onTerminateEmitter.fire({sessionId:f[0]}));case"attach":return Promise.resolve(this._onAttachEmitter.fire({sessionId:f[0],port:f[1],subId:f[2]}))}throw new Error("Method not implemented.")}listen(I,d,f){switch(d){case"close":return this._onCloseEmitter.event;case"reload":return this._onReloadEmitter.event;case"terminate":return this._onTerminateEmitter.event;case"attach":return this._onAttachEmitter.event}throw new Error("Method not implemented.")}}e.ExtensionHostDebugBroadcastChannel=C,C.ChannelName="extensionhostdebugservice";class k extends R.Disposable{constructor(I){super();this.channel=I}reload(I){this.channel.call("reload",[I])}get onReload(){return this.channel.listen("reload")}close(I){this.channel.call("close",[I])}get onClose(){return this.channel.listen("close")}attachSession(I,d,f){this.channel.call("attach",[I,d,f])}get onAttachSession(){return this.channel.listen("attach")}terminateSession(I,d){this.channel.call("terminate",[I,d])}get onTerminateSession(){return this.channel.listen("terminate")}openExtensionDevelopmentHostWindow(I,d){return this.channel.call("openExtensionDevelopmentHostWindow",[I,d])}}e.ExtensionHostDebugChannelClient=k}),define(x[160],ee([0,1]),function(V,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WindowDriverRegistryChannelClient=e.WindowDriverChannelClient=e.WindowDriverChannel=void 0;class p{constructor(n){this.driver=n}listen(n,I){throw new Error(`No event found: ${I}`)}call(n,I,d){switch(I){case"click":return this.driver.click(d[0],d[1],d[2]);case"doubleClick":return this.driver.doubleClick(d);case"setValue":return this.driver.setValue(d[0],d[1]);case"getTitle":return this.driver.getTitle();case"isActiveElement":return this.driver.isActiveElement(d);case"getElements":return this.driver.getElements(d[0],d[1]);case"getElementXY":return this.driver.getElementXY(d[0],d[1],d[2]);case"typeInEditor":return this.driver.typeInEditor(d[0],d[1]);case"getTerminalBuffer":return this.driver.getTerminalBuffer(d);case"writeInTerminal":return this.driver.writeInTerminal(d[0],d[1]);case"getLocaleInfo":return this.driver.getLocaleInfo();case"getLocalizedStrings":return this.driver.getLocalizedStrings()}throw new Error(`Call not found: ${I}`)}}e.WindowDriverChannel=p;class R{constructor(n){this.channel=n}click(n,I,d){return this.channel.call("click",[n,I,d])}doubleClick(n){return this.channel.call("doubleClick",n)}setValue(n,I){return this.channel.call("setValue",[n,I])}getTitle(){return this.channel.call("getTitle")}isActiveElement(n){return this.channel.call("isActiveElement",n)}getElements(n,I){return this.channel.call("getElements",[n,I])}getElementXY(n,I,d){return this.channel.call("getElementXY",[n,I,d])}typeInEditor(n,I){return this.channel.call("typeInEditor",[n,I])}getTerminalBuffer(n){return this.channel.call("getTerminalBuffer",n)}writeInTerminal(n,I){return this.channel.call("writeInTerminal",[n,I])}getLocaleInfo(){return this.channel.call("getLocaleInfo")}getLocalizedStrings(){return this.channel.call("getLocalizedStrings")}}e.WindowDriverChannelClient=R;class C{constructor(n){this.channel=n}registerWindowDriver(n){return this.channel.call("registerWindowDriver",n)}reloadWindowDriver(n){return this.channel.call("reloadWindowDriver",n)}}e.WindowDriverRegistryChannelClient=C}),define(x[161],ee([0,1,128,46,10,8,34,15,7]),function(V,e,p,R,C,k,n,I,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parsePtyHostPort=e.parseSearchPort=e.parseExtensionHostPort=e.AbstractNativeEnvironmentService=void 0;class f{constructor(m,v,b){this._args=m,this.paths=v,this.productService=b}get appRoot(){return(0,k.dirname)(C.FileAccess.asFileUri("",V).fsPath)}get userHome(){return d.URI.file(this.paths.homeDir)}get userDataPath(){return this.paths.userDataDir}get appSettingsHome(){return d.URI.file((0,k.join)(this.userDataPath,"User"))}get tmpDir(){return d.URI.file(this.paths.tmpDir)}get cacheHome(){return d.URI.file(this.userDataPath)}get userRoamingDataHome(){return this.appSettingsHome}get settingsResource(){return(0,I.joinPath)(this.userRoamingDataHome,"settings.json")}get userDataSyncHome(){return(0,I.joinPath)(this.userRoamingDataHome,"sync")}get logsPath(){if(!this.args.logsPath){const m=(0,p.toLocalISOString)(new Date).replace(/-|:|\.\d+Z$/g,"");this.args.logsPath=(0,k.join)(this.userDataPath,"logs",m)}return this.args.logsPath}get userDataSyncLogResource(){return d.URI.file((0,k.join)(this.logsPath,"userDataSync.log"))}get sync(){return this.args.sync}get machineSettingsResource(){return(0,I.joinPath)(d.URI.file((0,k.join)(this.userDataPath,"Machine")),"settings.json")}get globalStorageHome(){return d.URI.joinPath(this.appSettingsHome,"globalStorage")}get workspaceStorageHome(){return d.URI.joinPath(this.appSettingsHome,"workspaceStorage")}get keybindingsResource(){return(0,I.joinPath)(this.userRoamingDataHome,"keybindings.json")}get keyboardLayoutResource(){return(0,I.joinPath)(this.userRoamingDataHome,"keyboardLayout.json")}get argvResource(){const m=n.env.VSCODE_PORTABLE;return m?d.URI.file((0,k.join)(m,"argv.json")):(0,I.joinPath)(this.userHome,this.productService.dataFolderName,"argv.json")}get snippetsHome(){return(0,I.joinPath)(this.userRoamingDataHome,"snippets")}get isExtensionDevelopment(){return!!this.args.extensionDevelopmentPath}get untitledWorkspacesHome(){return d.URI.file((0,k.join)(this.userDataPath,"Workspaces"))}get installSourcePath(){return(0,k.join)(this.userDataPath,"installSource")}get builtinExtensionsPath(){const m=this.args["builtin-extensions-dir"];return m?(0,k.resolve)(m):(0,k.normalize)((0,k.join)(C.FileAccess.asFileUri("",V).fsPath,"..","extensions"))}get extensionsDownloadPath(){const m=this.args["extensions-download-dir"];return m?(0,k.resolve)(m):(0,k.join)(this.userDataPath,"CachedExtensionVSIXs")}get extensionsPath(){const m=this.args["extensions-dir"];if(m)return(0,k.resolve)(m);const v=n.env.VSCODE_EXTENSIONS;if(v)return v;const b=n.env.VSCODE_PORTABLE;return b?(0,k.join)(b,"extensions"):(0,I.joinPath)(this.userHome,this.productService.dataFolderName,"extensions").fsPath}get extensionDevelopmentLocationURI(){const m=this.args.extensionDevelopmentPath;if(Array.isArray(m))return m.map(v=>/^[^:/?#]+?:\/\//.test(v)?d.URI.parse(v):d.URI.file((0,k.normalize)(v)))}get extensionDevelopmentKind(){return this.args.extensionDevelopmentKind?.map(m=>m==="ui"||m==="workspace"||m==="web"?m:"workspace")}get extensionTestsLocationURI(){const m=this.args.extensionTestsPath;if(m)return/^[^:/?#]+?:\/\//.test(m)?d.URI.parse(m):d.URI.file((0,k.normalize)(m))}get disableExtensions(){if(this.args["disable-extensions"])return!0;const m=this.args["disable-extension"];if(m){if(typeof m=="string")return[m];if(Array.isArray(m)&&m.length>0)return m}return!1}get debugExtensionHost(){return y(this.args,this.isBuilt)}get debugRenderer(){return!!this.args.debugRenderer}get isBuilt(){return!n.env.VSCODE_DEV}get verbose(){return!!this.args.verbose}get logLevel(){return this.args.log}get serviceMachineIdResource(){return(0,I.joinPath)(d.URI.file(this.userDataPath),"machineid")}get crashReporterId(){return this.args["crash-reporter-id"]}get crashReporterDirectory(){return this.args["crash-reporter-directory"]}get driverHandle(){return this.args.driver}get telemetryLogResource(){return d.URI.file((0,k.join)(this.logsPath,"telemetry.log"))}get disableTelemetry(){return!!this.args["disable-telemetry"]}get disableWorkspaceTrust(){return!!this.args["disable-workspace-trust"]}get args(){return this._args}}fe([R.memoize],f.prototype,"appRoot",null),fe([R.memoize],f.prototype,"userHome",null),fe([R.memoize],f.prototype,"userDataPath",null),fe([R.memoize],f.prototype,"appSettingsHome",null),fe([R.memoize],f.prototype,"tmpDir",null),fe([R.memoize],f.prototype,"cacheHome",null),fe([R.memoize],f.prototype,"userRoamingDataHome",null),fe([R.memoize],f.prototype,"settingsResource",null),fe([R.memoize],f.prototype,"userDataSyncHome",null),fe([R.memoize],f.prototype,"userDataSyncLogResource",null),fe([R.memoize],f.prototype,"sync",null),fe([R.memoize],f.prototype,"machineSettingsResource",null),fe([R.memoize],f.prototype,"globalStorageHome",null),fe([R.memoize],f.prototype,"workspaceStorageHome",null),fe([R.memoize],f.prototype,"keybindingsResource",null),fe([R.memoize],f.prototype,"keyboardLayoutResource",null),fe([R.memoize],f.prototype,"argvResource",null),fe([R.memoize],f.prototype,"snippetsHome",null),fe([R.memoize],f.prototype,"isExtensionDevelopment",null),fe([R.memoize],f.prototype,"untitledWorkspacesHome",null),fe([R.memoize],f.prototype,"installSourcePath",null),fe([R.memoize],f.prototype,"builtinExtensionsPath",null),fe([R.memoize],f.prototype,"extensionsPath",null),fe([R.memoize],f.prototype,"extensionDevelopmentLocationURI",null),fe([R.memoize],f.prototype,"extensionDevelopmentKind",null),fe([R.memoize],f.prototype,"extensionTestsLocationURI",null),fe([R.memoize],f.prototype,"debugExtensionHost",null),fe([R.memoize],f.prototype,"serviceMachineIdResource",null),fe([R.memoize],f.prototype,"telemetryLogResource",null),fe([R.memoize],f.prototype,"disableWorkspaceTrust",null),e.AbstractNativeEnvironmentService=f;function y(t,m){return S(t["inspect-extensions"],t["inspect-brk-extensions"],5870,m,t.debugId,t.extensionEnvironment)}e.parseExtensionHostPort=y;function E(t,m){return S(t["inspect-search"],t["inspect-brk-search"],5876,m,t.extensionEnvironment)}e.parseSearchPort=E;function g(t,m){return S(t["inspect-ptyhost"],t["inspect-brk-ptyhost"],5877,m,t.extensionEnvironment)}e.parsePtyHostPort=g;function S(t,m,v,b,P,c){const l=Number(m||t)||(b?null:v),o=l?Boolean(!!m):!1;let u;if(c)try{u=JSON.parse(c)}catch{}return{port:l,break:o,debugId:P,env:u}}}),define(x[88],ee([0,1,246,3,137]),function(V,e,p,R,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.buildVersionMessage=e.buildHelpMessage=e.formatOptions=e.parseArgs=e.OPTIONS=void 0;const k={o:(0,C.localize)(0,null),e:(0,C.localize)(1,null),t:(0,C.localize)(2,null)};e.OPTIONS={diff:{type:"boolean",cat:"o",alias:"d",args:["file","file"],description:(0,C.localize)(3,null)},add:{type:"boolean",cat:"o",alias:"a",args:"folder",description:(0,C.localize)(4,null)},goto:{type:"boolean",cat:"o",alias:"g",args:"file:line[:character]",description:(0,C.localize)(5,null)},"new-window":{type:"boolean",cat:"o",alias:"n",description:(0,C.localize)(6,null)},"reuse-window":{type:"boolean",cat:"o",alias:"r",description:(0,C.localize)(7,null)},wait:{type:"boolean",cat:"o",alias:"w",description:(0,C.localize)(8,null)},waitMarkerFilePath:{type:"string"},locale:{type:"string",cat:"o",args:"locale",description:(0,C.localize)(9,null)},"user-data-dir":{type:"string",cat:"o",args:"dir",description:(0,C.localize)(10,null)},help:{type:"boolean",cat:"o",alias:"h",description:(0,C.localize)(11,null)},"extensions-dir":{type:"string",deprecates:"extensionHomePath",cat:"e",args:"dir",description:(0,C.localize)(12,null)},"extensions-download-dir":{type:"string"},"builtin-extensions-dir":{type:"string"},"list-extensions":{type:"boolean",cat:"e",description:(0,C.localize)(13,null)},"show-versions":{type:"boolean",cat:"e",description:(0,C.localize)(14,null)},category:{type:"string",cat:"e",description:(0,C.localize)(15,null),args:"category"},"install-extension":{type:"string[]",cat:"e",args:"extension-id[@version] | path-to-vsix",description:(0,C.localize)(16,null)},"pre-release":{type:"boolean",cat:"e",description:(0,C.localize)(17,null)},"uninstall-extension":{type:"string[]",cat:"e",args:"extension-id",description:(0,C.localize)(18,null)},"enable-proposed-api":{type:"string[]",cat:"e",args:"extension-id",description:(0,C.localize)(19,null)},version:{type:"boolean",cat:"t",alias:"v",description:(0,C.localize)(20,null)},verbose:{type:"boolean",cat:"t",description:(0,C.localize)(21,null)},log:{type:"string",cat:"t",args:"level",description:(0,C.localize)(22,null)},status:{type:"boolean",alias:"s",cat:"t",description:(0,C.localize)(23,null)},"prof-startup":{type:"boolean",cat:"t",description:(0,C.localize)(24,null)},"prof-append-timers":{type:"string"},"no-cached-data":{type:"boolean"},"prof-startup-prefix":{type:"string"},"prof-v8-extensions":{type:"boolean"},"disable-extensions":{type:"boolean",deprecates:"disableExtensions",cat:"t",description:(0,C.localize)(25,null)},"disable-extension":{type:"string[]",cat:"t",args:"extension-id",description:(0,C.localize)(26,null)},sync:{type:"string",cat:"t",description:(0,C.localize)(27,null),args:["on","off"]},"inspect-extensions":{type:"string",deprecates:"debugPluginHost",args:"port",cat:"t",description:(0,C.localize)(28,null)},"inspect-brk-extensions":{type:"string",deprecates:"debugBrkPluginHost",args:"port",cat:"t",description:(0,C.localize)(29,null)},"disable-gpu":{type:"boolean",cat:"t",description:(0,C.localize)(30,null)},"ms-enable-electron-run-as-node":{type:"boolean"},"max-memory":{type:"string",cat:"t",description:(0,C.localize)(31,null),args:"memory"},telemetry:{type:"boolean",cat:"t",description:(0,C.localize)(32,null)},remote:{type:"string"},"folder-uri":{type:"string[]",cat:"o",args:"uri"},"file-uri":{type:"string[]",cat:"o",args:"uri"},"locate-extension":{type:"string[]"},extensionDevelopmentPath:{type:"string[]"},extensionDevelopmentKind:{type:"string[]"},extensionTestsPath:{type:"string"},extensionEnvironment:{type:"string"},debugId:{type:"string"},debugRenderer:{type:"boolean"},"inspect-ptyhost":{type:"string"},"inspect-brk-ptyhost":{type:"string"},"inspect-search":{type:"string",deprecates:"debugSearch"},"inspect-brk-search":{type:"string",deprecates:"debugBrkSearch"},"export-default-configuration":{type:"string"},"install-source":{type:"string"},driver:{type:"string"},logExtensionHostCommunication:{type:"boolean"},"skip-release-notes":{type:"boolean"},"skip-welcome":{type:"boolean"},"disable-telemetry":{type:"boolean"},"disable-updates":{type:"boolean"},"disable-keytar":{type:"boolean"},"disable-workspace-trust":{type:"boolean"},"disable-crash-reporter":{type:"boolean"},"crash-reporter-directory":{type:"string"},"crash-reporter-id":{type:"string"},"skip-add-to-recently-opened":{type:"boolean"},"unity-launch":{type:"boolean"},"open-url":{type:"boolean"},"file-write":{type:"boolean"},"file-chmod":{type:"boolean"},"driver-verbose":{type:"boolean"},"install-builtin-extension":{type:"string[]"},force:{type:"boolean"},"do-not-sync":{type:"boolean"},trace:{type:"boolean"},"trace-category-filter":{type:"string"},"trace-options":{type:"string"},"force-user-env":{type:"boolean"},"force-disable-user-env":{type:"boolean"},"open-devtools":{type:"boolean"},__sandbox:{type:"boolean"},logsPath:{type:"string"},"no-proxy-server":{type:"boolean"},"no-sandbox":{type:"boolean",alias:"sandbox"},"proxy-server":{type:"string"},"proxy-bypass-list":{type:"string"},"proxy-pac-url":{type:"string"},"js-flags":{type:"string"},inspect:{type:"string"},"inspect-brk":{type:"string"},nolazy:{type:"boolean"},"force-device-scale-factor":{type:"string"},"force-renderer-accessibility":{type:"boolean"},"ignore-certificate-errors":{type:"boolean"},"allow-insecure-localhost":{type:"boolean"},"log-net-log":{type:"string"},vmodule:{type:"string"},_urls:{type:"string[]"},_:{type:"string[]"}};const n={onUnknownOption:()=>{},onMultipleValues:()=>{},onDeprecatedOption:()=>{}};function I(t,m,v=n){const b={},P=[],c=[];for(let u in m){const r=m[u];r.alias&&(b[u]=r.alias),r.type==="string"||r.type==="string[]"?(P.push(u),r.deprecates&&P.push(r.deprecates)):r.type==="boolean"&&(c.push(u),r.deprecates&&c.push(r.deprecates))}const a=p(t,{string:P,boolean:c,alias:b}),l={},o=a;l._=a._.map(u=>String(u)).filter(u=>u.length>0),delete o._;for(let u in m){const r=m[u];r.alias&&delete o[r.alias];let i=o[u];r.deprecates&&o.hasOwnProperty(r.deprecates)&&(i||(i=o[r.deprecates],i&&v.onDeprecatedOption(r.deprecates,u)),delete o[r.deprecates]),typeof i!="undefined"&&(r.type==="string[]"?i&&!Array.isArray(i)&&(i=[i]):r.type==="string"&&Array.isArray(i)&&(i=i.pop(),v.onMultipleValues(u,i)),l[u]=i),delete o[u]}for(let u in o)v.onUnknownOption(u);return l}e.parseArgs=I;function d(t,m){let v="";return m.args&&(Array.isArray(m.args)?v=` <${m.args.join("> <")}>`:v=` <${m.args}>`),m.alias?`-${m.alias} --${t}${v}`:`--${t}${v}`}function f(t,m){let v=0,b=[];for(const l in t){const o=t[l],u=d(l,o);v=Math.max(v,u.length),b.push([u,o.description])}let P=v+2+1;if(m-P<25)return b.reduce((l,o)=>l.concat([`  ${o[0]}`,`      ${o[1]}`]),[]);let c=m-P-1,a=[];for(const l of b){let o=l[0],u=E(l[1],c),r=y(P-o.length-2);a.push("  "+o+r+u[0]);for(let i=1;i<u.length;i++)a.push(y(P)+u[i])}return a}e.formatOptions=f;function y(t){return" ".repeat(t)}function E(t,m){let v=[];for(;t.length;){let b=t.length<m?t.length:t.lastIndexOf(" ",m),P=t.slice(0,b).trim();t=t.slice(b),v.push(P)}return v}function g(t,m,v,b,P){const c=process.stdout.isTTY&&process.stdout.columns||80,a=P?.noInputFiles!==!0?`[${(0,C.localize)(33,null)}...]`:"",l=[`${t} ${v}`];l.push(""),l.push(`${(0,C.localize)(34,null)}: ${m} [${(0,C.localize)(35,null)}]${a}`),l.push(""),P?.noPipe!==!0&&(R.isWindows?l.push((0,C.localize)(36,null,m)):l.push((0,C.localize)(37,null,m)),l.push(""));const o={};for(const u in b){const r=b[u];if(r.description&&r.cat){let i=o[r.cat];i||(o[r.cat]=i={}),i[u]=r}}for(let u in o){const r=u;let i=o[r];i&&(l.push(k[r]),l.push(...f(i,c)),l.push(""))}return l.join(`
`)}e.buildHelpMessage=g;function S(t,m){return`${t||(0,C.localize)(38,null)}
${m||(0,C.localize)(39,null)}
${process.arch}`}e.buildVersionMessage=S}),define(x[162],ee([0,1,62,159,88]),function(V,e,p,R,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ElectronExtensionHostDebugBroadcastChannel=void 0;class k extends R.ExtensionHostDebugBroadcastChannel{constructor(I){super();this.windowsMainService=I}call(I,d,f){return d==="openExtensionDevelopmentHostWindow"?this.openExtensionDevelopmentHostWindow(f[0],f[1]):super.call(I,d,f)}async openExtensionDevelopmentHostWindow(I,d){const f=(0,C.parseArgs)(I,C.OPTIONS);f.debugRenderer=d;const y=f.extensionDevelopmentPath;if(!y)return{success:!1};const[E]=this.windowsMainService.openExtensionDevelopmentHostWindow(y,{context:5,cli:f});if(!d)return{success:!0};const g=E.win;if(!g)return{success:!0};const S=g.webContents.debugger;let t=S.isAttached()?Infinity:0;const m=(0,p.createServer)(v=>{t++==0&&S.attach();let b=!1;const P=l=>{b||v.write(JSON.stringify(l)+"\0")},c=(l,o,u,r)=>P({method:o,params:u,sessionId:r});g.on("close",()=>{S.removeListener("message",c),v.end(),b=!0}),S.addListener("message",c);let a=Buffer.alloc(0);v.on("data",l=>{a=Buffer.concat([a,l]);for(let o=a.indexOf(0);o!==-1;o=a.indexOf(0)){let u;try{const r=a.slice(0,o).toString("utf8");a=a.slice(o+1),u=JSON.parse(r)}catch(r){console.error("error reading cdp line",r)}S.sendCommand(u.method,u.params,u.sessionId).then(r=>P({id:u.id,sessionId:u.sessionId,result:r})).catch(r=>P({id:u.id,sessionId:u.sessionId,error:{code:0,message:r.message}}))}}),v.on("error",l=>{console.error("error on cdp pipe:",l)}),v.on("close",()=>{b=!0,--t==0&&S.detach()})});return await new Promise(v=>m.listen(0,v)),g.on("close",()=>m.close()),{rendererDebugPort:m.address().port,success:!0}}}e.ElectronExtensionHostDebugBroadcastChannel=k}),function(){"use strict";function V(e,p,R,C){function k(I){const d=n(I),f=[d];return e.isAbsolute(d)||f.unshift(C),e.resolve(...f)}function n(I){const d=process.env.VSCODE_PORTABLE;if(d)return e.join(d,"user-data");let f=process.env.VSCODE_APPDATA;if(f)return e.join(f,R);const y=I["user-data-dir"];if(y)return y;switch(process.platform){case"win32":if(f=process.env.APPDATA,!f){const E=process.env.USERPROFILE;if(typeof E!="string")throw new Error("Windows: Unexpected undefined %USERPROFILE% environment variable");f=e.join(E,"AppData","Roaming")}break;case"darwin":f=e.join(p.homedir(),"Library","Application Support");break;case"linux":f=process.env.XDG_CONFIG_HOME||e.join(p.homedir(),".config");break;default:throw new Error("Platform not supported")}return e.join(f,R)}return{getUserDataPath:k}}if(typeof define=="function")define(x[163],ee([0,247,26,10,15,34]),function(e,p,R,C,k,n){const I=k.dirname(C.FileAccess.asFileUri("",e)),d=e.__$__nodeRequire(k.joinPath(I,"package.json").fsPath);return V(p,R,d.name,n.cwd())});else if(typeof module=="object"&&typeof module.exports=="object"){const e=require("../../../../../package.json"),p=require("path"),R=require("os");module.exports=V(p,R,e.name,process.env.VSCODE_CWD||process.cwd())}else throw new Error("Unknown context")}(),define(x[164],ee([0,1,26,161,163]),function(V,e,p,R,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeEnvironmentService=void 0;class k extends R.AbstractNativeEnvironmentService{constructor(I,d){super(I,{homeDir:(0,p.homedir)(),tmpDir:(0,p.tmpdir)(),userDataDir:(0,C.getUserDataPath)(I)},d)}}e.NativeEnvironmentService=k}),define(x[165],ee([0,1,28,26,8]),function(V,e,p,R,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createWaitMarkerFile=void 0;function k(n){const I=(0,C.join)((0,R.tmpdir)(),Math.random().toString(36).replace(/[^a-z]+/g,"").substr(0,10));try{return p.writeFileSync(I,""),n&&console.log(`Marker file for --wait created: ${I}`),I}catch(d){n&&console.error(`Failed to create marker file for --wait: ${d}`);return}}e.createWaitMarkerFile=k}),define(x[166],ee([0,1,141]),function(V,e,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isEngineValid=e.isValidExtensionVersion=e.isValidVersion=e.normalizeVersion=e.parseVersion=e.isValidVersionStr=void 0;const R=/^(\^|>=)?((\d+)|x)\.((\d+)|x)\.((\d+)|x)(\-.*)?$/,C=/^-(\d{4})(\d{2})(\d{2})$/;function k(g){return g=g.trim(),g==="*"||R.test(g)}e.isValidVersionStr=k;function n(g){if(!k(g))return null;if(g=g.trim(),g==="*")return{hasCaret:!1,hasGreaterEquals:!1,majorBase:0,majorMustEqual:!1,minorBase:0,minorMustEqual:!1,patchBase:0,patchMustEqual:!1,preRelease:null};let S=g.match(R);return S?{hasCaret:S[1]==="^",hasGreaterEquals:S[1]===">=",majorBase:S[2]==="x"?0:parseInt(S[2],10),majorMustEqual:S[2]!=="x",minorBase:S[4]==="x"?0:parseInt(S[4],10),minorMustEqual:S[4]!=="x",patchBase:S[6]==="x"?0:parseInt(S[6],10),patchMustEqual:S[6]!=="x",preRelease:S[8]||null}:null}e.parseVersion=n;function I(g){if(!g)return null;let S=g.majorBase,t=g.majorMustEqual,m=g.minorBase,v=g.minorMustEqual,b=g.patchBase,P=g.patchMustEqual;g.hasCaret&&(S===0||(v=!1),P=!1);let c=0;if(g.preRelease){const a=C.exec(g.preRelease);if(a){const[,l,o,u]=a;c=Date.UTC(Number(l),Number(o)-1,Number(u))}}return{majorBase:S,majorMustEqual:t,minorBase:m,minorMustEqual:v,patchBase:b,patchMustEqual:P,isMinimum:g.hasGreaterEquals,notBefore:c}}e.normalizeVersion=I;function d(g,S,t){let m;typeof g=="string"?m=I(n(g)):m=g;let v;S instanceof Date?v=S.getTime():typeof S=="string"&&(v=new Date(S).getTime());let b;if(typeof t=="string"?b=I(n(t)):b=t,!m||!b)return!1;let P=m.majorBase,c=m.minorBase,a=m.patchBase,l=b.majorBase,o=b.minorBase,u=b.patchBase,r=b.notBefore,i=b.majorMustEqual,s=b.minorMustEqual,h=b.patchMustEqual;return b.isMinimum?P>l?!0:P<l?!1:c>o?!0:c<o||v&&v<r?!1:a>=u:(P===1&&l===0&&(!i||!s||!h)&&(l=1,o=0,u=0,i=!0,s=!1,h=!1),P<l?!1:P>l?!i:c<o?!1:c>o?!s:a<u?!1:a>u?!h:!(v&&v<r))}e.isValidVersion=d;function f(g,S,t,m){return t.isBuiltin||typeof t.main=="undefined"?!0:E(g,S,t.engines.vscode,m)}e.isValidExtensionVersion=f;function y(g,S,t){return g==="*"||E(S,t,g)}e.isEngineValid=y;function E(g,S,t,m=[]){let v=I(n(t));if(!v)return m.push(p.localize(0,null,t)),!1;if(v.majorBase===0){if(!v.majorMustEqual||!v.minorMustEqual)return m.push(p.localize(1,null,t)),!1}else if(!v.majorMustEqual)return m.push(p.localize(2,null,t)),!1;return d(g,S,v)?!0:(m.push(p.localize(3,null,g,t)),!1)}}),define(x[167],ee([0,1,4,2,17,60,23]),function(V,e,p,R,C,k,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractDiskFileSystemProviderChannel=void 0;class I extends R.Disposable{constructor(f,y){super();this.provider=f,this.logService=y,this.sessionToWatcher=new Map,this.watchRequests=new Map}call(f,y,E){const g=this.getUriTransformer(f);switch(y){case"stat":return this.stat(g,E[0]);case"readdir":return this.readdir(g,E[0]);case"open":return this.open(g,E[0],E[1]);case"close":return this.close(E[0]);case"read":return this.read(E[0],E[1],E[2]);case"readFile":return this.readFile(g,E[0]);case"write":return this.write(E[0],E[1],E[2],E[3],E[4]);case"writeFile":return this.writeFile(g,E[0],E[1],E[2]);case"rename":return this.rename(g,E[0],E[1],E[2]);case"copy":return this.copy(g,E[0],E[1],E[2]);case"mkdir":return this.mkdir(g,E[0]);case"delete":return this.delete(g,E[0],E[1]);case"watch":return this.watch(g,E[0],E[1],E[2],E[3]);case"unwatch":return this.unwatch(E[0],E[1])}throw new Error(`IPC Command ${y} not found`)}listen(f,y,E){const g=this.getUriTransformer(f);switch(y){case"fileChange":return this.onFileChange(g,E[0]);case"readFileStream":return this.onReadFileStream(g,E[0],E[1])}throw new Error(`Unknown event ${y}`)}stat(f,y){const E=this.transformIncoming(f,y,!0);return this.provider.stat(E)}readdir(f,y){const E=this.transformIncoming(f,y);return this.provider.readdir(E)}async readFile(f,y){const E=this.transformIncoming(f,y,!0),g=await this.provider.readFile(E);return C.VSBuffer.wrap(g)}onReadFileStream(f,y,E){const g=this.transformIncoming(f,y,!0),S=new n.CancellationTokenSource,t=new p.Emitter({onLastListenerRemove:()=>{S.cancel()}}),m=this.provider.readFileStream(g,E,S.token);return(0,k.listenStream)(m,{onData:v=>t.fire(C.VSBuffer.wrap(v)),onError:v=>t.fire(v),onEnd:()=>{t.fire("end"),t.dispose(),S.dispose()}}),t.event}writeFile(f,y,E,g){const S=this.transformIncoming(f,y);return this.provider.writeFile(S,E.buffer,g)}open(f,y,E){const g=this.transformIncoming(f,y,!0);return this.provider.open(g,E)}close(f){return this.provider.close(f)}async read(f,y,E){const g=C.VSBuffer.alloc(E),S=0,t=await this.provider.read(f,y,g.buffer,S,E);return[g,t]}write(f,y,E,g,S){return this.provider.write(f,y,E.buffer,g,S)}mkdir(f,y){const E=this.transformIncoming(f,y);return this.provider.mkdir(E)}delete(f,y,E){const g=this.transformIncoming(f,y);return this.provider.delete(g,E)}rename(f,y,E,g){const S=this.transformIncoming(f,y),t=this.transformIncoming(f,E);return this.provider.rename(S,t,g)}copy(f,y,E,g){const S=this.transformIncoming(f,y),t=this.transformIncoming(f,E);return this.provider.copy(S,t,g)}onFileChange(f,y){const E=new p.Emitter({onFirstListenerAdd:()=>{this.sessionToWatcher.set(y,this.createSessionFileWatcher(f,E))},onLastListenerRemove:()=>{(0,R.dispose)(this.sessionToWatcher.get(y)),this.sessionToWatcher.delete(y)}});return E.event}async watch(f,y,E,g,S){const t=this.sessionToWatcher.get(y);if(t){const m=this.transformIncoming(f,g),v=t.watch(E,m,S);this.watchRequests.set(y+E,v)}}async unwatch(f,y){const E=f+y,g=this.watchRequests.get(E);g&&((0,R.dispose)(g),this.watchRequests.delete(E))}dispose(){super.dispose(),this.watchRequests.forEach(f=>(0,R.dispose)(f)),this.watchRequests.clear(),this.sessionToWatcher.forEach(f=>(0,R.dispose)(f)),this.sessionToWatcher.clear()}}e.AbstractDiskFileSystemProviderChannel=I}),define(x[73],ee([0,1]),function(V,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SyncDescriptor=void 0;class p{constructor(C,k=[],n=!1){this.ctor=C,this.staticArguments=k,this.supportsDelayedInstantiation=n}}e.SyncDescriptor=p}),define(x[168],ee([0,1]),function(V,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Graph=e.Node=void 0;class p{constructor(k){this.incoming=new Map,this.outgoing=new Map,this.data=k}}e.Node=p;class R{constructor(k){this._hashFn=k,this._nodes=new Map}roots(){const k=[];for(let n of this._nodes.values())n.outgoing.size===0&&k.push(n);return k}insertEdge(k,n){const I=this.lookupOrInsertNode(k),d=this.lookupOrInsertNode(n);I.outgoing.set(this._hashFn(n),d),d.incoming.set(this._hashFn(k),I)}removeNode(k){const n=this._hashFn(k);this._nodes.delete(n);for(let I of this._nodes.values())I.outgoing.delete(n),I.incoming.delete(n)}lookupOrInsertNode(k){const n=this._hashFn(k);let I=this._nodes.get(n);return I||(I=new p(k),this._nodes.set(n,I)),I}lookup(k){return this._nodes.get(this._hashFn(k))}isEmpty(){return this._nodes.size===0}toString(){let k=[];for(let[n,I]of this._nodes)k.push(`${n}, (incoming)[${[...I.incoming.keys()].join(", ")}], (outgoing)[${[...I.outgoing.keys()].join(",")}]`);return k.join(`
`)}findCycleSlow(){for(let[k,n]of this._nodes){const I=new Set([k]),d=this._findCycle(n,I);if(d)return d}}_findCycle(k,n){for(let[I,d]of k.outgoing){if(n.has(I))return[...n,I].join(" -> ");n.add(I);const f=this._findCycle(d,n);if(f)return f;n.delete(I)}}}e.Graph=R}),define(x[5],ee([0,1]),function(V,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.refineServiceDecorator=e.createDecorator=e.IInstantiationService=e._util=void 0;var p;(function(n){n.serviceIds=new Map,n.DI_TARGET="$di$target",n.DI_DEPENDENCIES="$di$dependencies";function I(d){return d[n.DI_DEPENDENCIES]||[]}n.getServiceDependencies=I})(p=e._util||(e._util={})),e.IInstantiationService=C("instantiationService");function R(n,I,d,f){I[p.DI_TARGET]===I?I[p.DI_DEPENDENCIES].push({id:n,index:d,optional:f}):(I[p.DI_DEPENDENCIES]=[{id:n,index:d,optional:f}],I[p.DI_TARGET]=I)}function C(n){if(p.serviceIds.has(n))return p.serviceIds.get(n);const I=function(d,f,y){if(arguments.length!==3)throw new Error("@IServiceName-decorator can only be used to decorate a parameter");R(I,d,y,!1)};return I.toString=()=>n,p.serviceIds.set(n,I),I}e.createDecorator=C;function k(n){return n}e.refineServiceDecorator=k}),define(x[18],ee([0,1,13,7,5]),function(V,e,p,R,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getMigratedSettingValue=e.merge=e.getConfigurationValue=e.removeFromValueTree=e.addToValueTree=e.toValuesTree=e.ConfigurationTargetToString=e.ConfigurationTarget=e.isConfigurationUpdateOverrides=e.isConfigurationOverrides=e.IConfigurationService=void 0,e.IConfigurationService=(0,C.createDecorator)("configurationService");function k(v){return v&&typeof v=="object"&&(!v.overrideIdentifier||typeof v.overrideIdentifier=="string")&&(!v.resource||v.resource instanceof R.URI)}e.isConfigurationOverrides=k;function n(v){return v&&typeof v=="object"&&(!v.overrideIdentifiers||p.isArray(v.overrideIdentifiers))&&!v.overrideIdentifier&&(!v.resource||v.resource instanceof R.URI)}e.isConfigurationUpdateOverrides=n;var I;(function(v){v[v.USER=1]="USER",v[v.USER_LOCAL=2]="USER_LOCAL",v[v.USER_REMOTE=3]="USER_REMOTE",v[v.WORKSPACE=4]="WORKSPACE",v[v.WORKSPACE_FOLDER=5]="WORKSPACE_FOLDER",v[v.DEFAULT=6]="DEFAULT",v[v.MEMORY=7]="MEMORY"})(I=e.ConfigurationTarget||(e.ConfigurationTarget={}));function d(v){switch(v){case 1:return"USER";case 2:return"USER_LOCAL";case 3:return"USER_REMOTE";case 4:return"WORKSPACE";case 5:return"WORKSPACE_FOLDER";case 6:return"DEFAULT";case 7:return"MEMORY"}}e.ConfigurationTargetToString=d;function f(v,b){const P=Object.create(null);for(let c in v)y(P,c,v[c],b);return P}e.toValuesTree=f;function y(v,b,P,c){const a=b.split("."),l=a.pop();let o=v;for(let u=0;u<a.length;u++){let r=a[u],i=o[r];switch(typeof i){case"undefined":i=o[r]=Object.create(null);break;case"object":break;default:c(`Ignoring ${b} as ${a.slice(0,u+1).join(".")} is ${JSON.stringify(i)}`);return}o=i}if(typeof o=="object"&&o!==null)try{o[l]=P}catch(u){c(`Ignoring ${b} as ${a.join(".")} is ${JSON.stringify(o)}`)}else c(`Ignoring ${b} as ${a.join(".")} is ${JSON.stringify(o)}`)}e.addToValueTree=y;function E(v,b){const P=b.split(".");g(v,P)}e.removeFromValueTree=E;function g(v,b){const P=b.shift();if(b.length===0){delete v[P];return}if(Object.keys(v).indexOf(P)!==-1){const c=v[P];typeof c=="object"&&!Array.isArray(c)&&(g(c,b),Object.keys(c).length===0&&delete v[P])}}function S(v,b,P){function c(o,u){let r=o;for(const i of u){if(typeof r!="object"||r===null)return;r=r[i]}return r}const a=b.split("."),l=c(v,a);return typeof l=="undefined"?P:l}e.getConfigurationValue=S;function t(v,b,P){Object.keys(b).forEach(c=>{c!=="__proto__"&&(c in v?p.isObject(v[c])&&p.isObject(b[c])?t(v[c],b[c],P):P&&(v[c]=b[c]):v[c]=b[c])})}e.merge=t;function m(v,b,P){const c=v.inspect(b),a=v.inspect(P);return typeof c.userValue!="undefined"||typeof c.workspaceValue!="undefined"||typeof c.workspaceFolderValue!="undefined"?c.value:typeof a.userValue!="undefined"||typeof a.workspaceValue!="undefined"||typeof a.workspaceFolderValue!="undefined"?a.value:c.defaultValue}e.getMigratedSettingValue=m}),define(x[74],ee([0,1,5]),function(V,e,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isRemoteDiagnosticError=e.IDiagnosticsService=e.ID=void 0,e.ID="diagnosticsService",e.IDiagnosticsService=(0,p.createDecorator)(e.ID);function R(C){return!!C.hostName&&!!C.errorMessage}e.isRemoteDiagnosticError=R}),define(x[89],ee([0,1,5]),function(V,e,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EncryptionMainService=e.IEncryptionMainService=void 0,e.IEncryptionMainService=(0,p.createDecorator)("encryptionMainService");class R{constructor(k){this.machineId=k}encryption(){return new Promise((k,n)=>V(["vscode-encrypt"],k,n))}async encrypt(k){try{return(await this.encryption()).encrypt(this.machineId,k)}catch(n){return k}}async decrypt(k){try{return(await this.encryption()).decrypt(this.machineId,k)}catch(n){return k}}}e.EncryptionMainService=R}),define(x[48],ee([0,1,5]),function(V,e,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.INativeEnvironmentService=e.IEnvironmentService=void 0,e.IEnvironmentService=(0,p.createDecorator)("environmentService"),e.INativeEnvironmentService=(0,p.refineServiceDecorator)(e.IEnvironmentService)}),define(x[169],ee([0,1,10,140,5]),function(V,e,p,R,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtensionManagementCLIService=e.PreferencesLocalizedLabel=e.PreferencesLabel=e.ExtensionsChannelId=e.ExtensionsLocalizedLabel=e.ExtensionsLabel=e.DefaultIconPath=e.IExtensionTipsService=e.IGlobalExtensionEnablementService=e.ENABLED_EXTENSIONS_STORAGE_PATH=e.DISABLED_EXTENSIONS_STORAGE_PATH=e.IExtensionManagementService=e.ExtensionManagementError=e.ExtensionManagementErrorCode=e.IExtensionGalleryService=e.InstallOperation=e.StatisticType=e.SortOrder=e.SortBy=e.isIExtensionIdentifier=e.getFallbackTargetPlarforms=e.isTargetPlatformCompatible=e.isNotWebExtensionInWebTargetPlatform=e.getTargetPlatform=e.toTargetPlatform=e.TargetPlatformToString=e.TargetPlatform=e.WEB_EXTENSION_TAG=e.EXTENSION_IDENTIFIER_REGEX=e.EXTENSION_IDENTIFIER_PATTERN=void 0,e.EXTENSION_IDENTIFIER_PATTERN="^([a-z0-9A-Z][a-z0-9-A-Z]*)\\.([a-z0-9A-Z][a-z0-9-A-Z]*)$",e.EXTENSION_IDENTIFIER_REGEX=new RegExp(e.EXTENSION_IDENTIFIER_PATTERN),e.WEB_EXTENSION_TAG="__web_extension";var k;(function(c){c.WIN32_X64="win32-x64",c.WIN32_IA32="win32-ia32",c.WIN32_ARM64="win32-arm64",c.LINUX_X64="linux-x64",c.LINUX_ARM64="linux-arm64",c.LINUX_ARMHF="linux-armhf",c.ALPINE_X64="alpine-x64",c.ALPINE_ARM64="alpine-arm64",c.DARWIN_X64="darwin-x64",c.DARWIN_ARM64="darwin-arm64",c.WEB="web",c.UNIVERSAL="universal",c.UNKNOWN="unknown",c.UNDEFINED="undefined"})(k=e.TargetPlatform||(e.TargetPlatform={}));function n(c){switch(c){case"win32-x64":return"Windows 64 bit";case"win32-ia32":return"Windows 32 bit";case"win32-arm64":return"Windows ARM";case"linux-x64":return"Linux 64 bit";case"linux-arm64":return"Linux ARM 64";case"linux-armhf":return"Linux ARM";case"alpine-x64":return"Alpine Linux 64 bit";case"alpine-arm64":return"Alpine ARM 64";case"darwin-x64":return"Mac";case"darwin-arm64":return"Mac Silicon";case"web":return"Web";case"universal":return"universal";case"unknown":return"unknown";case"undefined":return"undefined"}}e.TargetPlatformToString=n;function I(c){switch(c){case"win32-x64":return"win32-x64";case"win32-ia32":return"win32-ia32";case"win32-arm64":return"win32-arm64";case"linux-x64":return"linux-x64";case"linux-arm64":return"linux-arm64";case"linux-armhf":return"linux-armhf";case"alpine-x64":return"alpine-x64";case"alpine-arm64":return"alpine-arm64";case"darwin-x64":return"darwin-x64";case"darwin-arm64":return"darwin-arm64";case"web":return"web";case"universal":return"universal";default:return"unknown"}}e.toTargetPlatform=I;function d(c,a){switch(c){case 3:return a==="x64"?"win32-x64":a==="ia32"?"win32-ia32":a==="arm64"?"win32-arm64":"unknown";case 2:return a==="x64"?"linux-x64":a==="arm64"?"linux-arm64":a==="arm"?"linux-armhf":"unknown";case"alpine":return a==="x64"?"alpine-x64":a==="arm64"?"alpine-arm64":"unknown";case 1:return a==="x64"?"darwin-x64":a==="arm64"?"darwin-arm64":"unknown";case 0:return"web"}}e.getTargetPlatform=d;function f(c,a){return a==="web"&&!c.includes("web")}e.isNotWebExtensionInWebTargetPlatform=f;function y(c,a,l){return f(a,l)?!1:c==="undefined"||c==="universal"?!0:c==="unknown"?!1:c===l?!0:E(l).includes(c)}e.isTargetPlatformCompatible=y;function E(c){switch(c){case"win32-x64":return["win32-ia32"];case"win32-arm64":return["win32-ia32"]}return[]}e.getFallbackTargetPlarforms=E;function g(c){return c&&typeof c=="object"&&typeof c.id=="string"&&(!c.uuid||typeof c.uuid=="string")}e.isIExtensionIdentifier=g;var S;(function(c){c[c.NoneOrRelevance=0]="NoneOrRelevance",c[c.LastUpdatedDate=1]="LastUpdatedDate",c[c.Title=2]="Title",c[c.PublisherName=3]="PublisherName",c[c.InstallCount=4]="InstallCount",c[c.PublishedDate=10]="PublishedDate",c[c.AverageRating=6]="AverageRating",c[c.WeightedRating=12]="WeightedRating"})(S=e.SortBy||(e.SortBy={}));var t;(function(c){c[c.Default=0]="Default",c[c.Ascending=1]="Ascending",c[c.Descending=2]="Descending"})(t=e.SortOrder||(e.SortOrder={}));var m;(function(c){c.Install="install",c.Uninstall="uninstall"})(m=e.StatisticType||(e.StatisticType={}));var v;(function(c){c[c.None=1]="None",c[c.Install=2]="Install",c[c.Update=3]="Update",c[c.Migrate=4]="Migrate"})(v=e.InstallOperation||(e.InstallOperation={})),e.IExtensionGalleryService=(0,C.createDecorator)("extensionGalleryService");var b;(function(c){c.Unsupported="Unsupported",c.UnsupportedPreRelease="UnsupportedPreRelease",c.Malicious="Malicious",c.Incompatible="Incompatible",c.IncompatiblePreRelease="IncompatiblePreRelease",c.IncompatibleTargetPlatform="IncompatibleTargetPlatform",c.Invalid="Invalid",c.Download="Download",c.Extract="Extract",c.Delete="Delete",c.Rename="Rename",c.CorruptZip="CorruptZip",c.IncompleteZip="IncompleteZip",c.Internal="Internal"})(b=e.ExtensionManagementErrorCode||(e.ExtensionManagementErrorCode={}));class P extends Error{constructor(a,l){super(a);this.code=l,this.name=l}}e.ExtensionManagementError=P,e.IExtensionManagementService=(0,C.createDecorator)("extensionManagementService"),e.DISABLED_EXTENSIONS_STORAGE_PATH="extensionsIdentifiers/disabled",e.ENABLED_EXTENSIONS_STORAGE_PATH="extensionsIdentifiers/enabled",e.IGlobalExtensionEnablementService=(0,C.createDecorator)("IGlobalExtensionEnablementService"),e.IExtensionTipsService=(0,C.createDecorator)("IExtensionTipsService"),e.DefaultIconPath=p.FileAccess.asBrowserUri("./media/defaultIcon.png",V).toString(!0),e.ExtensionsLabel=(0,R.localize)(0,null),e.ExtensionsLocalizedLabel={value:e.ExtensionsLabel,original:"Extensions"},e.ExtensionsChannelId="extensions",e.PreferencesLabel=(0,R.localize)(1,null),e.PreferencesLocalizedLabel={value:e.PreferencesLabel,original:"Preferences"},e.IExtensionManagementCLIService=(0,C.createDecorator)("IExtensionManagementCLIService")}),define(x[170],ee([0,1,5]),function(V,e,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtensionUrlTrustService=void 0,e.IExtensionUrlTrustService=(0,p.createDecorator)("extensionUrlTrustService")}),define(x[171],ee([0,1,5]),function(V,e,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ipcExtensionHostStarterChannelName=e.IExtensionHostStarter=void 0,e.IExtensionHostStarter=(0,p.createDecorator)("extensionHostStarter"),e.ipcExtensionHostStarterChannelName="extensionHostStarter"}),define(x[90],ee([0,1,5]),function(V,e,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExternalTerminalMainService=e.DEFAULT_TERMINAL_OSX=e.IExternalTerminalService=void 0,e.IExternalTerminalService=(0,p.createDecorator)("externalTerminal"),e.DEFAULT_TERMINAL_OSX="Terminal.app",e.IExternalTerminalMainService=(0,p.createDecorator)("externalTerminal")}),define(x[172],ee([0,1,43,10,8,3,80,21,72,142,90]),function(V,e,p,R,C,k,n,I,d,f,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LinuxExternalTerminalService=e.MacExternalTerminalService=e.WindowsExternalTerminalService=void 0;const E=f.localize(0,null);class g{async getDefaultTerminalForPlatforms(){return{windows:S.getDefaultTerminalWindows(),linux:await m.getDefaultTerminalLinuxReady(),osx:"xterm"}}}class S extends g{openTerminal(a,l){return this.spawnTerminal(p,a,d.getWindowsShell(),l)}spawnTerminal(a,l,o,u){const r=l.windowsExec||S.getDefaultTerminalWindows();u&&u[1]===":"&&(u=u[0].toUpperCase()+u.substr(1));const i=C.basename(r).toLowerCase();if(i==="cmder"||i==="cmder.exe")return a.spawn(r,u?[u]:void 0),Promise.resolve(void 0);const s=["/c","start","/wait"];return r.indexOf(" ")>=0&&s.push('""'),s.push(r),(i==="wt"||i==="wt.exe")&&s.push("-d ."),new Promise((h,w)=>{const M=v(process),A=a.spawn(o,s,{cwd:u,env:M});A.on("error",w),A.on("exit",()=>h())})}runInTerminal(a,l,o,u,r){const i="windowsExec"in r&&r.windowsExec?r.windowsExec:S.getDefaultTerminalWindows();return new Promise((s,h)=>{const w=`"${l} - ${E}"`,M=`""${o.join('" "')}" & pause"`,A=["/c","start",w,"/wait",i,"/c",M],L=Object.assign({},v(process),u);Object.keys(L).filter(Y=>L[Y]===null).forEach(Y=>delete L[Y]);const F={cwd:l,env:L,windowsVerbatimArguments:!0};p.spawn(S.CMD,A,F).on("error",Y=>{h(b(Y))}),s(void 0)})}static getDefaultTerminalWindows(){if(!S._DEFAULT_TERMINAL_WINDOWS){const a=!!process.env.hasOwnProperty("PROCESSOR_ARCHITEW6432");S._DEFAULT_TERMINAL_WINDOWS=`${process.env.windir?process.env.windir:"C:\\Windows"}\\${a?"Sysnative":"System32"}\\cmd.exe`}return S._DEFAULT_TERMINAL_WINDOWS}}e.WindowsExternalTerminalService=S,S.CMD="cmd.exe";class t extends g{openTerminal(a,l){return this.spawnTerminal(p,a,l)}runInTerminal(a,l,o,u,r){const i=r.osxExec||y.DEFAULT_TERMINAL_OSX;return new Promise((s,h)=>{if(i===y.DEFAULT_TERMINAL_OSX||i==="iTerm.app"){const w=i===y.DEFAULT_TERMINAL_OSX?"TerminalHelper":"iTermHelper",A=[R.FileAccess.asFileUri(`vs/workbench/contrib/externalTerminal/node/${w}.scpt`,V).fsPath,"-t",a||E,"-w",l];for(let U of o)A.push("-a"),A.push(U);if(u){const U=Object.assign({},v(process),u);for(let Y in U){const ie=U[Y];ie===null?(A.push("-u"),A.push(Y)):(A.push("-e"),A.push(`${Y}=${ie}`))}}let L="";const F=p.spawn(t.OSASCRIPT,A);F.on("error",U=>{h(b(U))}),F.stderr.on("data",U=>{L+=U.toString()}),F.on("exit",U=>{if(U===0)s(void 0);else if(L){const Y=L.split(`
`,1);h(new Error(Y[0]))}else h(new Error(f.localize(1,null,w,U)))})}else h(new Error(f.localize(2,null,i)))})}spawnTerminal(a,l,o){const u=l.osxExec||y.DEFAULT_TERMINAL_OSX;return new Promise((r,i)=>{const s=["-a",u];o&&s.push(o);const h=v(process),w=a.spawn("/usr/bin/open",s,{cwd:o,env:h});w.on("error",i),w.on("exit",()=>r())})}}e.MacExternalTerminalService=t,t.OSASCRIPT="/usr/bin/osascript";class m extends g{openTerminal(a,l){return this.spawnTerminal(p,a,l)}runInTerminal(a,l,o,u,r){const i=r.linuxExec?Promise.resolve(r.linuxExec):m.getDefaultTerminalLinuxReady();return new Promise((s,h)=>{let w=[];i.then(M=>{M.indexOf("gnome-terminal")>=0?w.push("-x"):w.push("-e"),w.push("bash"),w.push("-c");const A=`${P(o)}; echo; read -p "${m.WAIT_MESSAGE}" -n1;`;w.push(`''${A}''`);const L=Object.assign({},v(process),u);Object.keys(L).filter(ie=>L[ie]===null).forEach(ie=>delete L[ie]);const F={cwd:l,env:L};let U="";const Y=p.spawn(M,w,F);Y.on("error",ie=>{h(b(ie))}),Y.stderr.on("data",ie=>{U+=ie.toString()}),Y.on("exit",ie=>{if(ie===0)s(void 0);else if(U){const re=U.split(`
`,1);h(new Error(re[0]))}else h(new Error(f.localize(4,null,M,ie)))})})})}static async getDefaultTerminalLinuxReady(){if(!m._DEFAULT_TERMINAL_LINUX_READY)if(!k.isLinux)m._DEFAULT_TERMINAL_LINUX_READY=Promise.resolve("xterm");else{const a=await I.Promises.exists("/etc/debian_version");m._DEFAULT_TERMINAL_LINUX_READY=new Promise(l=>{a?l("x-terminal-emulator"):process.env.DESKTOP_SESSION==="gnome"||process.env.DESKTOP_SESSION==="gnome-classic"?l("gnome-terminal"):process.env.DESKTOP_SESSION==="kde-plasma"?l("konsole"):process.env.COLORTERM?l(process.env.COLORTERM):process.env.TERM?l(process.env.TERM):l("xterm")})}return m._DEFAULT_TERMINAL_LINUX_READY}spawnTerminal(a,l,o){const u=l.linuxExec?Promise.resolve(l.linuxExec):m.getDefaultTerminalLinuxReady();return new Promise((r,i)=>{u.then(s=>{const h=v(process),w=a.spawn(s,[],{cwd:o,env:h});w.on("error",i),w.on("exit",()=>r())})})}}e.LinuxExternalTerminalService=m,m.WAIT_MESSAGE=f.localize(3,null);function v(c){const a={...c.env};return(0,n.sanitizeProcessEnvironment)(a),a}function b(c){return"errno"in c&&c.errno==="ENOENT"&&"path"in c&&typeof c.path=="string"?new Error(f.localize(5,null,c.path)):c}function P(c){let a="";for(let l of c)l.indexOf(" ")>=0?a+='"'+l+'"':a+=l,a+=" ";return a}}),define(x[19],ee([0,1,39,8,25,13,7,144,5]),function(V,e,p,R,C,k,n,I,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getPlatformLimits=e.Arch=e.ByteSize=e.FALLBACK_MAX_MEMORY_SIZE_MB=e.MIN_MAX_MEMORY_SIZE_MB=e.whenProviderRegistered=e.etag=e.ETAG_DISABLED=e.FileKind=e.FILES_EXCLUDE_CONFIG=e.FILES_ASSOCIATIONS_CONFIG=e.HotExitConfiguration=e.AutoSaveConfiguration=e.FileOperationResult=e.NotModifiedSinceFileOperationError=e.FileOperationError=e.isParent=e.FileChangesEvent=e.FileChangeType=e.FileOperationEvent=e.FileOperation=e.toFileOperationResult=e.toFileSystemProviderErrorCode=e.markAsFileSystemProviderError=e.ensureFileSystemProviderError=e.createFileSystemProviderError=e.FileSystemProviderError=e.FileSystemProviderErrorCode=e.hasFileReadStreamCapability=e.hasOpenReadWriteCloseCapability=e.hasFileFolderCopyCapability=e.hasReadWriteCapability=e.FileSystemProviderCapabilities=e.FilePermission=e.FileType=e.isFileOpenForWriteOptions=e.IFileService=void 0,e.IFileService=(0,d.createDecorator)("fileService");function f(W){return W.create===!0}e.isFileOpenForWriteOptions=f;var y;(function(W){W[W.Unknown=0]="Unknown",W[W.File=1]="File",W[W.Directory=2]="Directory",W[W.SymbolicLink=64]="SymbolicLink"})(y=e.FileType||(e.FileType={}));var E;(function(W){W[W.Readonly=1]="Readonly"})(E=e.FilePermission||(e.FilePermission={}));var g;(function(W){W[W.FileReadWrite=2]="FileReadWrite",W[W.FileOpenReadWriteClose=4]="FileOpenReadWriteClose",W[W.FileReadStream=16]="FileReadStream",W[W.FileFolderCopy=8]="FileFolderCopy",W[W.PathCaseSensitive=1024]="PathCaseSensitive",W[W.Readonly=2048]="Readonly",W[W.Trash=4096]="Trash",W[W.FileWriteUnlock=8192]="FileWriteUnlock"})(g=e.FileSystemProviderCapabilities||(e.FileSystemProviderCapabilities={}));function S(W){return!!(W.capabilities&2)}e.hasReadWriteCapability=S;function t(W){return!!(W.capabilities&8)}e.hasFileFolderCopyCapability=t;function m(W){return!!(W.capabilities&4)}e.hasOpenReadWriteCloseCapability=m;function v(W){return!!(W.capabilities&16)}e.hasFileReadStreamCapability=v;var b;(function(W){W.FileExists="EntryExists",W.FileNotFound="EntryNotFound",W.FileNotADirectory="EntryNotADirectory",W.FileIsADirectory="EntryIsADirectory",W.FileExceedsMemoryLimit="EntryExceedsMemoryLimit",W.FileTooLarge="EntryTooLarge",W.FileWriteLocked="EntryWriteLocked",W.NoPermissions="NoPermissions",W.Unavailable="Unavailable",W.Unknown="Unknown"})(b=e.FileSystemProviderErrorCode||(e.FileSystemProviderErrorCode={}));class P extends Error{constructor(N,G){super(N);this.code=G}}e.FileSystemProviderError=P;function c(W,N){const G=new P(W.toString(),N);return l(G,N),G}e.createFileSystemProviderError=c;function a(W){return W||c((0,I.localize)(0,null),b.Unknown)}e.ensureFileSystemProviderError=a;function l(W,N){return W.name=N?`${N} (FileSystemError)`:"FileSystemError",W}e.markAsFileSystemProviderError=l;function o(W){if(!W)return b.Unknown;if(W instanceof P)return W.code;const N=/^(.+) \(FileSystemError\)$/.exec(W.name);if(!N)return b.Unknown;switch(N[1]){case b.FileExists:return b.FileExists;case b.FileIsADirectory:return b.FileIsADirectory;case b.FileNotADirectory:return b.FileNotADirectory;case b.FileNotFound:return b.FileNotFound;case b.FileExceedsMemoryLimit:return b.FileExceedsMemoryLimit;case b.FileTooLarge:return b.FileTooLarge;case b.FileWriteLocked:return b.FileWriteLocked;case b.NoPermissions:return b.NoPermissions;case b.Unavailable:return b.Unavailable}return b.Unknown}e.toFileSystemProviderErrorCode=o;function u(W){if(W instanceof M)return W.fileOperationResult;switch(o(W)){case b.FileNotFound:return 1;case b.FileIsADirectory:return 0;case b.FileNotADirectory:return 10;case b.FileWriteLocked:return 5;case b.NoPermissions:return 6;case b.FileExists:return 4;case b.FileExceedsMemoryLimit:return 9;case b.FileTooLarge:return 7;default:return 11}}e.toFileOperationResult=u;var r;(function(W){W[W.CREATE=0]="CREATE",W[W.DELETE=1]="DELETE",W[W.MOVE=2]="MOVE",W[W.COPY=3]="COPY"})(r=e.FileOperation||(e.FileOperation={}));class i{constructor(N,G,Q){this.resource=N,this.operation=G,this.target=Q}isOperation(N){return this.operation===N}}e.FileOperationEvent=i;var s;(function(W){W[W.UPDATED=0]="UPDATED",W[W.ADDED=1]="ADDED",W[W.DELETED=2]="DELETED"})(s=e.FileChangeType||(e.FileChangeType={}));class h{constructor(N,G){this.added=void 0,this.updated=void 0,this.deleted=void 0;const Q=new Map;for(const H of N){const $=Q.get(H.type);$?$.push([H.resource,H]):Q.set(H.type,[[H.resource,H]])}for(const[H,$]of Q)switch(H){case 1:this.added=p.TernarySearchTree.forUris(()=>G),this.added.fill($);break;case 0:this.updated=p.TernarySearchTree.forUris(()=>G),this.updated.fill($);break;case 2:this.deleted=p.TernarySearchTree.forUris(()=>G),this.deleted.fill($);break}}contains(N,...G){return this.doContains(N,{includeChildren:!1},...G)}affects(N,...G){return this.doContains(N,{includeChildren:!0},...G)}doContains(N,G,...Q){if(!N)return!1;const H=Q.length>0;return!!((!H||Q.includes(1))&&(this.added?.get(N)||G.includeChildren&&this.added?.findSuperstr(N))||(!H||Q.includes(0))&&(this.updated?.get(N)||G.includeChildren&&this.updated?.findSuperstr(N))||(!H||Q.includes(2))&&(this.deleted?.findSubstr(N)||G.includeChildren&&this.deleted?.findSuperstr(N)))}gotAdded(){return!!this.added}gotDeleted(){return!!this.deleted}gotUpdated(){return!!this.updated}get rawAdded(){return this.added}get rawDeleted(){return this.deleted}}e.FileChangesEvent=h;function w(W,N,G){return!W||!N||W===N||N.length>W.length?!1:(N.charAt(N.length-1)!==R.sep&&(N+=R.sep),G?(0,C.startsWithIgnoreCase)(W,N):W.indexOf(N)===0)}e.isParent=w;class M extends Error{constructor(N,G,Q){super(N);this.fileOperationResult=G,this.options=Q}}e.FileOperationError=M;class A extends M{constructor(N,G,Q){super(N,2,Q);this.stat=G}}e.NotModifiedSinceFileOperationError=A;var L;(function(W){W[W.FILE_IS_DIRECTORY=0]="FILE_IS_DIRECTORY",W[W.FILE_NOT_FOUND=1]="FILE_NOT_FOUND",W[W.FILE_NOT_MODIFIED_SINCE=2]="FILE_NOT_MODIFIED_SINCE",W[W.FILE_MODIFIED_SINCE=3]="FILE_MODIFIED_SINCE",W[W.FILE_MOVE_CONFLICT=4]="FILE_MOVE_CONFLICT",W[W.FILE_WRITE_LOCKED=5]="FILE_WRITE_LOCKED",W[W.FILE_PERMISSION_DENIED=6]="FILE_PERMISSION_DENIED",W[W.FILE_TOO_LARGE=7]="FILE_TOO_LARGE",W[W.FILE_INVALID_PATH=8]="FILE_INVALID_PATH",W[W.FILE_EXCEEDS_MEMORY_LIMIT=9]="FILE_EXCEEDS_MEMORY_LIMIT",W[W.FILE_NOT_DIRECTORY=10]="FILE_NOT_DIRECTORY",W[W.FILE_OTHER_ERROR=11]="FILE_OTHER_ERROR"})(L=e.FileOperationResult||(e.FileOperationResult={})),e.AutoSaveConfiguration={OFF:"off",AFTER_DELAY:"afterDelay",ON_FOCUS_CHANGE:"onFocusChange",ON_WINDOW_CHANGE:"onWindowChange"},e.HotExitConfiguration={OFF:"off",ON_EXIT:"onExit",ON_EXIT_AND_WINDOW_CLOSE:"onExitAndWindowClose"},e.FILES_ASSOCIATIONS_CONFIG="files.associations",e.FILES_EXCLUDE_CONFIG="files.exclude";var F;(function(W){W[W.FILE=0]="FILE",W[W.FOLDER=1]="FOLDER",W[W.ROOT_FOLDER=2]="ROOT_FOLDER"})(F=e.FileKind||(e.FileKind={})),e.ETAG_DISABLED="";function U(W){if(!(typeof W.size!="number"||typeof W.mtime!="number"))return W.mtime.toString(29)+W.size.toString(31)}e.etag=U;async function Y(W,N){if(!N.hasProvider(n.URI.from({scheme:W.scheme})))return new Promise(G=>{const Q=N.onDidChangeFileSystemProviderRegistrations(H=>{H.scheme===W.scheme&&H.added&&(Q.dispose(),G())})})}e.whenProviderRegistered=Y,e.MIN_MAX_MEMORY_SIZE_MB=2048,e.FALLBACK_MAX_MEMORY_SIZE_MB=4096;class ie{static formatSize(N){return(0,k.isNumber)(N)||(N=0),N<ie.KB?(0,I.localize)(1,null,N.toFixed(0)):N<ie.MB?(0,I.localize)(2,null,(N/ie.KB).toFixed(2)):N<ie.GB?(0,I.localize)(3,null,(N/ie.MB).toFixed(2)):N<ie.TB?(0,I.localize)(4,null,(N/ie.GB).toFixed(2)):(0,I.localize)(5,null,(N/ie.TB).toFixed(2))}}e.ByteSize=ie,ie.KB=1024,ie.MB=ie.KB*ie.KB,ie.GB=ie.MB*ie.KB,ie.TB=ie.GB*ie.KB;var re;(function(W){W[W.IA32=0]="IA32",W[W.OTHER=1]="OTHER"})(re=e.Arch||(e.Arch={}));function K(W){return{maxFileSize:W===0?300*ie.MB:16*ie.GB,maxHeapSize:W===0?700*ie.MB:2*700*ie.MB}}e.getPlatformLimits=K}),define(x[53],ee([0,1,248,138,88,19]),function(V,e,p,R,C,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isLaunchedFromCli=e.addArg=e.parseCLIProcessArgv=e.parseMainProcessArgv=void 0;function n(g,S){const t={onUnknownOption:v=>{console.warn((0,R.localize)(0,null,v))},onMultipleValues:(v,b)=>{console.warn((0,R.localize)(1,null,v,b))},onDeprecatedOption:(v,b)=>{console.warn((0,R.localize)(2,null,v,b))}},m=(0,C.parseArgs)(g,C.OPTIONS,S?t:void 0);return m.goto&&m._.forEach(v=>p(/^(\w:)?[^:]+(:\d*){0,2}$/.test(v),(0,R.localize)(3,null))),m["max-memory"]&&p(parseInt(m["max-memory"])>=k.MIN_MAX_MEMORY_SIZE_MB,`The max-memory argument cannot be specified lower than ${k.MIN_MAX_MEMORY_SIZE_MB} MB.`),m}function I(g){const S=g.findIndex(t=>!/^-/.test(t));if(S>-1)return[...g.slice(0,S),...g.slice(S+1)]}function d(g){let[,...S]=g;process.env.VSCODE_DEV&&(S=I(S)||[]);const t=!E(process.env);return n(S,t)}e.parseMainProcessArgv=d;function f(g){const[,,...S]=g;return n(S,!0)}e.parseCLIProcessArgv=f;function y(g,...S){const t=g.indexOf("--");return t===-1?g.push(...S):g.splice(t,0,...S),g}e.addArg=y;function E(g){return g.VSCODE_CLI==="1"}e.isLaunchedFromCli=E}),define(x[91],ee([0,1,43,8,139,23,44,16,3,31,133,53,9]),function(V,e,p,R,C,k,n,I,d,f,y,E,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getResolvedShellEnv=void 0;const S=1e4;let t;async function m(b,P,c){return P["force-disable-user-env"]?(b.trace("resolveShellEnv(): skipped (--force-disable-user-env)"),{}):d.isWindows?(b.trace("resolveShellEnv(): skipped (Windows)"),{}):(0,E.isLaunchedFromCli)(c)&&!P["force-user-env"]?(b.trace("resolveShellEnv(): skipped (VSCODE_CLI is set)"),{}):((0,E.isLaunchedFromCli)(c)?b.trace("resolveShellEnv(): running (--force-user-env)"):b.trace("resolveShellEnv(): running (macOS/Linux)"),t||(t=g.Promises.withAsyncBody(async(a,l)=>{const o=new k.CancellationTokenSource,u=setTimeout(()=>{o.dispose(!0),l(new Error((0,C.localize)(0,null)))},S);try{a(await v(b,o.token))}catch(r){!(0,I.isPromiseCanceledError)(r)&&!o.token.isCancellationRequested?l(new Error((0,C.localize)(1,null,(0,n.toErrorMessage)(r)))):a({})}finally{clearTimeout(u),o.dispose()}})),t)}e.getResolvedShellEnv=m;async function v(b,P){const c=process.env.ELECTRON_RUN_AS_NODE;b.trace("getUnixShellEnvironment#runAsNode",c);const a=process.env.ELECTRON_NO_ATTACH_CONSOLE;b.trace("getUnixShellEnvironment#noAttach",a);const l=(0,f.generateUuid)().replace(/-/g,"").substr(0,12),o=new RegExp(l+"(.*)"+l),u={...process.env,ELECTRON_RUN_AS_NODE:"1",ELECTRON_NO_ATTACH_CONSOLE:"1"};b.trace("getUnixShellEnvironment#env",u);const r=await(0,y.getSystemShell)(d.OS,u);return b.trace("getUnixShellEnvironment#shell",r),new Promise((i,s)=>{if(P.isCancellationRequested)return s((0,I.canceled)());const h=(0,R.basename)(r);let w,M;const A=process.versions.electron&&process.versions["microsoft-build"]?"--ms-enable-electron-run-as-node":"";/^pwsh(-preview)?$/.test(h)?(w=`& '${process.execPath}' ${A} -p '''${l}'' + JSON.stringify(process.env) + ''${l}'''`,M=["-Login","-Command"]):(w=`'${process.execPath}' ${A} -p '"${l}" + JSON.stringify(process.env) + "${l}"'`,h==="tcsh"?M=["-ic"]:M=["-ilc"]),b.trace("getUnixShellEnvironment#spawn",JSON.stringify(M),w);const L=(0,p.spawn)(r,[...M,w],{detached:!0,stdio:["ignore","pipe","pipe"],env:u});P.onCancellationRequested(()=>(L.kill(),s((0,I.canceled)()))),L.on("error",Y=>{b.error("getUnixShellEnvironment#errorChildProcess",(0,n.toErrorMessage)(Y)),s(Y)});const F=[];L.stdout.on("data",Y=>F.push(Y));const U=[];L.stderr.on("data",Y=>U.push(Y)),L.on("close",(Y,ie)=>{const re=Buffer.concat(F).toString("utf8");b.trace("getUnixShellEnvironment#raw",re);const K=Buffer.concat(U).toString("utf8");if(K.trim()&&b.trace("getUnixShellEnvironment#stderr",K),Y||ie)return s(new Error((0,C.localize)(2,null,Y,ie)));const W=o.exec(re),N=W?W[1]:"{}";try{const G=JSON.parse(N);c?G.ELECTRON_RUN_AS_NODE=c:delete G.ELECTRON_RUN_AS_NODE,a?G.ELECTRON_NO_ATTACH_CONSOLE=a:delete G.ELECTRON_NO_ATTACH_CONSOLE,delete G.XDG_RUNTIME_DIR,b.trace("getUnixShellEnvironment#result",G),i(G)}catch(G){b.error("getUnixShellEnvironment#errorCaught",(0,n.toErrorMessage)(G)),s(G)}})})}}),define(x[92],ee([0,1,17,16,145,19]),function(V,e,p,R,C,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.readFileIntoStream=void 0;async function n(y,E,g,S,t,m){let v;try{await I(y,E,g,S,t,m)}catch(b){v=b}finally{v&&t.errorTransformer&&(v=t.errorTransformer(v)),typeof v!="undefined"&&g.error(v),g.end()}}e.readFileIntoStream=n;async function I(y,E,g,S,t,m){d(m);const v=await y.open(E,{create:!1});try{d(m);let b=0,P=0,c=t&&typeof t.length=="number"?t.length:void 0,a=p.VSBuffer.alloc(Math.min(t.bufferSize,typeof c=="number"?c:t.bufferSize)),l=t&&typeof t.position=="number"?t.position:0,o=0;do P=await y.read(v,l,a.buffer,o,a.byteLength-o),l+=P,o+=P,b+=P,typeof c=="number"&&(c-=P),o===a.byteLength&&(await g.write(S(a)),a=p.VSBuffer.alloc(Math.min(t.bufferSize,typeof c=="number"?c:t.bufferSize)),o=0);while(P>0&&(typeof c!="number"||c>0)&&d(m)&&f(b,t));if(o>0){let u=o;typeof c=="number"&&(u=Math.min(o,c)),g.write(S(a.slice(0,u)))}}catch(b){throw(0,k.ensureFileSystemProviderError)(b)}finally{await y.close(v)}}function d(y){if(y.isCancellationRequested)throw(0,R.canceled)();return!0}function f(y,E){if(E?.limits){if(typeof E.limits.memory=="number"&&y>E.limits.memory)throw(0,k.createFileSystemProviderError)((0,C.localize)(0,null),k.FileSystemProviderErrorCode.FileExceedsMemoryLimit);if(typeof E.limits.size=="number"&&y>E.limits.size)throw(0,k.createFileSystemProviderError)((0,C.localize)(1,null),k.FileSystemProviderErrorCode.FileTooLarge)}return!0}}),define(x[54],ee([0,1,2,3,7,19]),function(V,e,p,R,C,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.coalesceEvents=e.toFileChanges=e.WatcherService=e.AbstractWatcherService=void 0;class n extends p.Disposable{constructor(g,S,t){super();this.onFileChanges=g,this.onLogMessage=S,this.verboseLogging=t,this.serviceDisposables=this._register(new p.MutableDisposable),this.requests=void 0,this.restartCounter=0}init(){const g=new p.DisposableStore;this.serviceDisposables.value=g,this.service=this.createService(g),this.service.setVerboseLogging(this.verboseLogging),g.add(this.service.onDidChangeFile(S=>this.onFileChanges(S))),g.add(this.service.onDidLogMessage(S=>this.onLogMessage(S))),g.add(this.service.onDidError(S=>this.onError(S)))}onError(g){this.restartCounter<n.MAX_RESTARTS&&this.requests?(this.error(`restarting watcher after error: ${g}`),this.restart(this.requests)):this.error(`gave up attempting to restart watcher after error: ${g}`)}restart(g){this.restartCounter++,this.init(),this.watch(g)}async watch(g){this.requests=g,await this.service?.watch(g)}async setVerboseLogging(g){this.verboseLogging=g,await this.service?.setVerboseLogging(g)}error(g){this.onLogMessage({type:"error",message:`[File Watcher (parcel)] ${g}`})}dispose(){return this.service=void 0,super.dispose()}}e.AbstractWatcherService=n,n.MAX_RESTARTS=5;class I extends p.Disposable{}e.WatcherService=I;function d(E){return E.map(g=>({type:g.type,resource:C.URI.file(g.path)}))}e.toFileChanges=d;function f(E){const g=new y;for(const S of E)g.processEvent(S);return g.coalesce()}e.coalesceEvents=f;class y{constructor(){this.coalesced=new Set,this.mapPathToChange=new Map}toKey(g){return R.isLinux?g.path:g.path.toLowerCase()}processEvent(g){const S=this.mapPathToChange.get(this.toKey(g));let t=!1;if(S){const m=S.type,v=g.type;S.path!==g.path&&g.type===2?t=!0:m===1&&v===2?(this.mapPathToChange.delete(this.toKey(g)),this.coalesced.delete(S)):m===2&&v===1?S.type=0:m===1&&v===0||(S.type=v)}else t=!0;t&&(this.coalesced.add(g),this.mapPathToChange.set(this.toKey(g),g))}coalesce(){const g=[],S=[];return Array.from(this.coalesced).filter(t=>t.type!==2?(g.push(t),!1):!0).sort((t,m)=>t.path.length-m.path.length).filter(t=>S.some(m=>(0,k.isParent)(t.path,m,!R.isLinux))?!1:(S.push(t.path),!0)).concat(g)}}}),define(x[93],ee([0,1,9,2,8,82,21,120,54]),function(V,e,p,R,C,k,n,I,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileWatcher=void 0;class f extends R.Disposable{constructor(E,g,S,t){super();this.path=E,this.onDidFilesChange=g,this.onLogMessage=S,this.verboseLogging=t,this.fileChangesDelayer=this._register(new p.ThrottledDelayer(I.CHANGE_BUFFER_DELAY*2)),this.fileChangesBuffer=[],this.startWatching()}setVerboseLogging(E){this.verboseLogging=E}async startWatching(){try{const{stat:E,symbolicLink:g}=await n.SymlinkSupport.stat(this.path);if(this.isDisposed)return;let S=this.path;if(g)try{S=await(0,k.realpath)(S)}catch(t){if(this.onError(t),g.dangling)return}E.isDirectory()?this._register((0,I.watchFolder)(S,(t,m)=>{this.onFileChange({type:t==="changed"?0:t==="added"?1:2,path:(0,C.join)(this.path,(0,C.basename)(m))})},t=>this.onError(t))):this._register((0,I.watchFile)(S,t=>{this.onFileChange({type:t==="changed"?0:2,path:this.path})},t=>this.onError(t)))}catch(E){E.code!=="ENOENT"&&this.onError(E)}}onFileChange(E){this.fileChangesBuffer.push(E),this.verboseLogging&&this.onVerbose(`${E.type===1?"[ADDED]":E.type===2?"[DELETED]":"[CHANGED]"} ${E.path}`),this.fileChangesDelayer.trigger(async()=>{const g=this.fileChangesBuffer;this.fileChangesBuffer=[];const S=(0,d.coalesceEvents)(g);if(this.verboseLogging)for(const t of S)this.onVerbose(`>> normalized ${t.type===1?"[ADDED]":t.type===2?"[DELETED]":"[CHANGED]"} ${t.path}`);S.length>0&&this.onDidFilesChange(S)})}onError(E){this.isDisposed||this.onLogMessage({type:"error",message:`[File Watcher (node.js)] ${E}`})}onVerbose(E){this.isDisposed||this.onLogMessage({type:"trace",message:`[File Watcher (node.js)] ${E}`})}dispose(){this.isDisposed=!0,super.dispose()}}e.FileWatcher=f}),define(x[173],ee([0,1,10,35,87,54]),function(V,e,p,R,C,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileWatcher=void 0;class n extends k.WatcherService{constructor(d,f,y){super();this.onDidFilesChange=d,this.onLogMessage=f,this.verboseLogging=y,this.isDisposed=!1,this.startWatching()}startWatching(){const d=this._register(new C.Client(p.FileAccess.asFileUri("bootstrap-fork",V).fsPath,{serverName:"File Watcher (nsfw)",args:["--type=watcherServiceNSFW"],env:{VSCODE_AMD_ENTRYPOINT:"vs/platform/files/node/watcher/nsfw/watcherApp",VSCODE_PIPE_LOGGING:"true",VSCODE_VERBOSE_LOGGING:"true"}}));this.service=R.ProxyChannel.toService((0,R.getNextTickChannel)(d.getChannel("watcher"))),this.service.setVerboseLogging(this.verboseLogging),this._register(this.service.onDidChangeFile(f=>!this.isDisposed&&this.onDidFilesChange(f))),this._register(this.service.onDidLogMessage(f=>this.onLogMessage(f)))}async setVerboseLogging(d){this.verboseLogging=d,this.isDisposed||await this.service?.setVerboseLogging(d)}error(d){this.onLogMessage({type:"error",message:`[File Watcher (nsfw)] ${d}`})}async watch(d){this.isDisposed||await this.service?.watch(d)}dispose(){this.isDisposed=!0,super.dispose()}}e.FileWatcher=n}),define(x[174],ee([0,1,10,35,87,54]),function(V,e,p,R,C,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileWatcher=void 0;class n extends k.AbstractWatcherService{constructor(d,f,y){super(d,f,y);this.init()}createService(d){const f=d.add(new C.Client(p.FileAccess.asFileUri("bootstrap-fork",V).fsPath,{serverName:"File Watcher (parcel, node.js)",args:["--type=watcherServiceParcel"],env:{VSCODE_AMD_ENTRYPOINT:"vs/platform/files/node/watcher/parcel/watcherApp",VSCODE_PIPE_LOGGING:"true",VSCODE_VERBOSE_LOGGING:"true"}}));return d.add(f.onDidProcessExit(({code:y,signal:E})=>this.onError(`terminated by itself with code ${y}, signal: ${E}`))),R.ProxyChannel.toService((0,R.getNextTickChannel)(f.getChannel("watcher")))}}e.FileWatcher=n}),define(x[75],ee([0,1]),function(V,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ServiceCollection=void 0;class p{constructor(...C){this._entries=new Map;for(let[k,n]of C)this.set(k,n)}set(C,k){const n=this._entries.get(C);return this._entries.set(C,k),n}has(C){return this._entries.has(C)}get(C){return this._entries.get(C)}}e.ServiceCollection=p}),define(x[175],ee([0,1,9,16,73,168,5,75]),function(V,e,p,R,C,k,n,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InstantiationService=void 0;const d=!1;class f extends Error{constructor(t){super("cyclic dependency between services");this.message=t.findCycleSlow()??`UNABLE to detect cycle, dumping graph: 
${t.toString()}`}}class y{constructor(t=new I.ServiceCollection,m=!1,v){this._activeInstantiations=new Set,this._services=t,this._strict=m,this._parent=v,this._services.set(n.IInstantiationService,this)}createChild(t){return new y(t,this._strict,this)}invokeFunction(t,...m){let v=g.traceInvocation(t),b=!1;try{return t({get:c=>{if(b)throw(0,R.illegalState)("service accessor is only valid during the invocation of its target method");const a=this._getOrCreateServiceInstance(c,v);if(!a)throw new Error(`[invokeFunction] unknown service '${c}'`);return a}},...m)}finally{b=!0,v.stop()}}createInstance(t,...m){let v,b;return t instanceof C.SyncDescriptor?(v=g.traceCreation(t.ctor),b=this._createInstance(t.ctor,t.staticArguments.concat(m),v)):(v=g.traceCreation(t),b=this._createInstance(t,m,v)),v.stop(),b}_createInstance(t,m=[],v){let b=n._util.getServiceDependencies(t).sort((a,l)=>a.index-l.index),P=[];for(const a of b){let l=this._getOrCreateServiceInstance(a.id,v);if(!l&&this._strict&&!a.optional)throw new Error(`[createInstance] ${t.name} depends on UNKNOWN service ${a.id}.`);P.push(l)}let c=b.length>0?b[0].index:m.length;if(m.length!==c){console.warn(`[createInstance] First service dependency of ${t.name} at position ${c+1} conflicts with ${m.length} static arguments`);let a=c-m.length;a>0?m=m.concat(new Array(a)):m=m.slice(0,c)}return new t(...[...m,...P])}_setServiceInstance(t,m){if(this._services.get(t)instanceof C.SyncDescriptor)this._services.set(t,m);else if(this._parent)this._parent._setServiceInstance(t,m);else throw new Error("illegalState - setting UNKNOWN service instance")}_getServiceInstanceOrDescriptor(t){let m=this._services.get(t);return!m&&this._parent?this._parent._getServiceInstanceOrDescriptor(t):m}_getOrCreateServiceInstance(t,m){let v=this._getServiceInstanceOrDescriptor(t);return v instanceof C.SyncDescriptor?this._safeCreateAndCacheServiceInstance(t,v,m.branch(t,!0)):(m.branch(t,!1),v)}_safeCreateAndCacheServiceInstance(t,m,v){if(this._activeInstantiations.has(t))throw new Error(`illegal state - RECURSIVELY instantiating service '${t}'`);this._activeInstantiations.add(t);try{return this._createAndCacheServiceInstance(t,m,v)}finally{this._activeInstantiations.delete(t)}}_createAndCacheServiceInstance(t,m,v){const b=new k.Graph(a=>a.id.toString());let P=0;const c=[{id:t,desc:m,_trace:v}];for(;c.length;){const a=c.pop();if(b.lookupOrInsertNode(a),P++>1e3)throw new f(b);for(let l of n._util.getServiceDependencies(a.desc.ctor)){let o=this._getServiceInstanceOrDescriptor(l.id);if(!o&&!l.optional&&console.warn(`[createInstance] ${t} depends on ${l.id} which is NOT registered.`),o instanceof C.SyncDescriptor){const u={id:l.id,desc:o,_trace:a._trace.branch(l.id,!0)};b.insertEdge(a,u),c.push(u)}}}for(;;){const a=b.roots();if(a.length===0){if(!b.isEmpty())throw new f(b);break}for(const{data:l}of a){if(this._getServiceInstanceOrDescriptor(l.id)instanceof C.SyncDescriptor){const u=this._createServiceInstanceWithOwner(l.id,l.desc.ctor,l.desc.staticArguments,l.desc.supportsDelayedInstantiation,l._trace);this._setServiceInstance(l.id,u)}b.removeNode(l)}}return this._getServiceInstanceOrDescriptor(t)}_createServiceInstanceWithOwner(t,m,v=[],b,P){if(this._services.get(t)instanceof C.SyncDescriptor)return this._createServiceInstance(m,v,b,P);if(this._parent)return this._parent._createServiceInstanceWithOwner(t,m,v,b,P);throw new Error(`illegalState - creating UNKNOWN service instance ${m.name}`)}_createServiceInstance(t,m=[],v,b){if(v){const P=new p.IdleValue(()=>this._createInstance(t,m,b));return new Proxy(Object.create(null),{get(c,a){if(a in c)return c[a];let l=P.value,o=l[a];return typeof o!="function"||(o=o.bind(l),c[a]=o),o},set(c,a,l){return P.value[a]=l,!0}})}else return this._createInstance(t,m,b)}}e.InstantiationService=y;var E;(function(S){S[S.Creation=0]="Creation",S[S.Invocation=1]="Invocation",S[S.Branch=2]="Branch"})(E||(E={}));class g{constructor(t,m){this.type=t,this.name=m,this._start=Date.now(),this._dep=[]}static traceInvocation(t){return d?new g(1,t.name||t.toString().substring(0,42).replace(/\n/g,"")):g._None}static traceCreation(t){return d?new g(0,t.name):g._None}branch(t,m){let v=new g(2,t.toString());return this._dep.push([t,m,v]),v}stop(){let t=Date.now()-this._start;g._totals+=t;let m=!1;function v(P,c){let a=[],l=new Array(P+1).join("	");for(const[o,u,r]of c._dep)if(u&&r){m=!0,a.push(`${l}CREATES -> ${o}`);let i=v(P+1,r);i&&a.push(i)}else a.push(`${l}uses -> ${o}`);return a.join(`
`)}let b=[`${this.type===0?"CREATE":"CALL"} ${this.name}`,`${v(1,this)}`,`DONE, took ${t.toFixed(2)}ms (grand total ${g._totals.toFixed(2)}ms)`];(t>2||m)&&console.log(b.join(`
`))}}g._None=new class extends g{constructor(){super(-1,null)}stop(){}branch(){return this}},g._totals=0}),define(x[176],ee([0,1,16,131,59]),function(V,e,p,R,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.BaseResolvedKeybinding=void 0;class k extends C.ResolvedKeybinding{constructor(I,d){super();if(d.length===0)throw(0,p.illegalArgument)("parts");this._os=I,this._parts=d}getLabel(){return R.UILabelProvider.toLabel(this._os,this._parts,I=>this._getLabel(I))}getAriaLabel(){return R.AriaLabelProvider.toLabel(this._os,this._parts,I=>this._getAriaLabel(I))}getElectronAccelerator(){return this._parts.length>1||this._parts[0].isDuplicateModifierCase()?null:R.ElectronAcceleratorLabelProvider.toLabel(this._os,this._parts,I=>this._getElectronAccelerator(I))}getUserSettingsLabel(){return R.UserSettingsLabelProvider.toLabel(this._os,this._parts,I=>this._getUserSettingsLabel(I))}isWYSIWYG(){return this._parts.every(I=>this._isWYSIWYG(I))}isChord(){return this._parts.length>1}getParts(){return this._parts.map(I=>this._getPart(I))}_getPart(I){return new C.ResolvedKeybindingPart(I.ctrlKey,I.shiftKey,I.altKey,I.metaKey,this._getLabel(I),this._getAriaLabel(I))}getDispatchParts(){return this._parts.map(I=>this._getDispatchPart(I))}getSingleModifierDispatchParts(){return this._parts.map(I=>this._getSingleModifierDispatchPart(I))}}e.BaseResolvedKeybinding=k}),define(x[177],ee([0,1]),function(V,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.removeElementsAfterNulls=e.ResolvedKeybindingItem=void 0;class p{constructor(k,n,I,d,f,y,E){this._resolvedKeybindingItemBrand=void 0,this.resolvedKeybinding=k,this.keypressParts=k?R(k.getDispatchParts()):[],k&&this.keypressParts.length===0&&(this.keypressParts=R(k.getSingleModifierDispatchParts())),this.bubble=n?n.charCodeAt(0)===94:!1,this.command=this.bubble?n.substr(1):n,this.commandArgs=I,this.when=d,this.isDefault=f,this.extensionId=y,this.isBuiltinExtension=E}}e.ResolvedKeybindingItem=p;function R(C){let k=[];for(let n=0,I=C.length;n<I;n++){const d=C[n];if(!d)return k;k.push(d)}return k}e.removeElementsAfterNulls=R}),define(x[178],ee([0,1,79,59,176,177]),function(V,e,p,R,C,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.USLayoutResolvedKeybinding=void 0;class n extends C.BaseResolvedKeybinding{constructor(d,f){super(f,d.parts)}_keyCodeToUILabel(d){if(this._os===2)switch(d){case 15:return"\u2190";case 16:return"\u2191";case 17:return"\u2192";case 18:return"\u2193"}return p.KeyCodeUtils.toString(d)}_getLabel(d){return d.isDuplicateModifierCase()?"":this._keyCodeToUILabel(d.keyCode)}_getAriaLabel(d){return d.isDuplicateModifierCase()?"":p.KeyCodeUtils.toString(d.keyCode)}_getElectronAccelerator(d){return p.KeyCodeUtils.toElectronAccelerator(d.keyCode)}_getUserSettingsLabel(d){if(d.isDuplicateModifierCase())return"";const f=p.KeyCodeUtils.toUserSettingsUS(d.keyCode);return f&&f.toLowerCase()}_isWYSIWYG(){return!0}_getDispatchPart(d){return n.getDispatchStr(d)}static getDispatchStr(d){if(d.isModifierKey())return null;let f="";return d.ctrlKey&&(f+="ctrl+"),d.shiftKey&&(f+="shift+"),d.altKey&&(f+="alt+"),d.metaKey&&(f+="meta+"),f+=p.KeyCodeUtils.toString(d.keyCode),f}_getSingleModifierDispatchPart(d){return d.keyCode===5&&!d.shiftKey&&!d.altKey&&!d.metaKey?"ctrl":d.keyCode===4&&!d.ctrlKey&&!d.altKey&&!d.metaKey?"shift":d.keyCode===6&&!d.ctrlKey&&!d.shiftKey&&!d.metaKey?"alt":d.keyCode===57&&!d.ctrlKey&&!d.shiftKey&&!d.altKey?"meta":null}static _scanCodeToKeyCode(d){const f=p.IMMUTABLE_CODE_TO_KEY_CODE[d];if(f!==-1)return f;switch(d){case 10:return 31;case 11:return 32;case 12:return 33;case 13:return 34;case 14:return 35;case 15:return 36;case 16:return 37;case 17:return 38;case 18:return 39;case 19:return 40;case 20:return 41;case 21:return 42;case 22:return 43;case 23:return 44;case 24:return 45;case 25:return 46;case 26:return 47;case 27:return 48;case 28:return 49;case 29:return 50;case 30:return 51;case 31:return 52;case 32:return 53;case 33:return 54;case 34:return 55;case 35:return 56;case 36:return 22;case 37:return 23;case 38:return 24;case 39:return 25;case 40:return 26;case 41:return 27;case 42:return 28;case 43:return 29;case 44:return 30;case 45:return 21;case 51:return 83;case 52:return 81;case 53:return 87;case 54:return 89;case 55:return 88;case 56:return 0;case 57:return 80;case 58:return 90;case 59:return 86;case 60:return 82;case 61:return 84;case 62:return 85;case 106:return 92}return 0}static _resolveSimpleUserBinding(d){if(!d)return null;if(d instanceof R.SimpleKeybinding)return d;const f=this._scanCodeToKeyCode(d.scanCode);return f===0?null:new R.SimpleKeybinding(d.ctrlKey,d.shiftKey,d.altKey,d.metaKey,f)}static resolveUserBinding(d,f){const y=(0,k.removeElementsAfterNulls)(d.map(E=>this._resolveSimpleUserBinding(E)));return y.length>0?[new n(new R.ChordKeybinding(y),f)]:[]}}e.USLayoutResolvedKeybinding=n}),define(x[179],ee([0,1,9]),function(V,e,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.handleVetos=void 0;function R(C,k){if(C.length===0)return Promise.resolve(!1);const n=[];let I=!1;for(let d of C){if(d===!0)return Promise.resolve(!0);(0,p.isThenable)(d)&&n.push(d.then(f=>{f&&(I=!0)},f=>{k(f),I=!0}))}return p.Promises.settled(n).then(()=>I)}e.handleVetos=R}),define(x[6],ee([0,1,44,4,2,3,5]),function(V,e,p,R,C,k,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LogLevelToString=e.parseLogLevel=e.getLogLevel=e.NullLogService=e.AbstractLoggerService=e.LogService=e.MultiplexLogService=e.AdapterLogger=e.ConsoleLogger=e.ConsoleMainLogger=e.AbstractMessageLogger=e.AbstractLogger=e.format=e.log=e.DEFAULT_LOG_LEVEL=e.LogLevel=e.ILoggerService=e.ILogService=void 0,e.ILogService=(0,n.createDecorator)("logService"),e.ILoggerService=(0,n.createDecorator)("loggerService");function I(){return new Date().toISOString()}var d;(function(u){u[u.Trace=0]="Trace",u[u.Debug=1]="Debug",u[u.Info=2]="Info",u[u.Warning=3]="Warning",u[u.Error=4]="Error",u[u.Critical=5]="Critical",u[u.Off=6]="Off"})(d=e.LogLevel||(e.LogLevel={})),e.DEFAULT_LOG_LEVEL=d.Info;function f(u,r,i){switch(r){case d.Trace:u.trace(i);break;case d.Debug:u.debug(i);break;case d.Info:u.info(i);break;case d.Warning:u.warn(i);break;case d.Error:u.error(i);break;case d.Critical:u.critical(i);break;default:throw new Error("Invalid log level")}}e.log=f;function y(u){let r="";for(let i=0;i<u.length;i++){let s=u[i];if(typeof s=="object")try{s=JSON.stringify(s)}catch(h){}r+=(i>0?" ":"")+s}return r}e.format=y;class E extends C.Disposable{constructor(){super(...arguments);this.level=e.DEFAULT_LOG_LEVEL,this._onDidChangeLogLevel=this._register(new R.Emitter),this.onDidChangeLogLevel=this._onDidChangeLogLevel.event}setLevel(r){this.level!==r&&(this.level=r,this._onDidChangeLogLevel.fire(this.level))}getLevel(){return this.level}}e.AbstractLogger=E;class g extends E{constructor(r){super();this.logAlways=r}checkLogLevel(r){return this.logAlways||this.getLevel()<=r}trace(r,...i){this.checkLogLevel(d.Trace)&&this.log(d.Trace,y([r,...i]))}debug(r,...i){this.checkLogLevel(d.Debug)&&this.log(d.Debug,y([r,...i]))}info(r,...i){this.checkLogLevel(d.Info)&&this.log(d.Info,y([r,...i]))}warn(r,...i){this.checkLogLevel(d.Warning)&&this.log(d.Warning,y([r,...i]))}error(r,...i){if(this.checkLogLevel(d.Error))if(r instanceof Error){const s=Array.prototype.slice.call(arguments);s[0]=r.stack,this.log(d.Error,y(s))}else this.log(d.Error,y([r,...i]))}critical(r,...i){this.checkLogLevel(d.Critical)&&this.log(d.Critical,y([r,...i]))}flush(){}}e.AbstractMessageLogger=g;class S extends E{constructor(r=e.DEFAULT_LOG_LEVEL){super();this.setLevel(r),this.useColors=!k.isWindows}trace(r,...i){this.getLevel()<=d.Trace&&(this.useColors?console.log(`[90m[main ${I()}][0m`,r,...i):console.log(`[main ${I()}]`,r,...i))}debug(r,...i){this.getLevel()<=d.Debug&&(this.useColors?console.log(`[90m[main ${I()}][0m`,r,...i):console.log(`[main ${I()}]`,r,...i))}info(r,...i){this.getLevel()<=d.Info&&(this.useColors?console.log(`[90m[main ${I()}][0m`,r,...i):console.log(`[main ${I()}]`,r,...i))}warn(r,...i){this.getLevel()<=d.Warning&&(this.useColors?console.warn(`[93m[main ${I()}][0m`,r,...i):console.warn(`[main ${I()}]`,r,...i))}error(r,...i){this.getLevel()<=d.Error&&(this.useColors?console.error(`[91m[main ${I()}][0m`,r,...i):console.error(`[main ${I()}]`,r,...i))}critical(r,...i){this.getLevel()<=d.Critical&&(this.useColors?console.error(`[90m[main ${I()}][0m`,r,...i):console.error(`[main ${I()}]`,r,...i))}dispose(){}flush(){}}e.ConsoleMainLogger=S;class t extends E{constructor(r=e.DEFAULT_LOG_LEVEL){super();this.setLevel(r)}trace(r,...i){this.getLevel()<=d.Trace&&console.log("%cTRACE","color: #888",r,...i)}debug(r,...i){this.getLevel()<=d.Debug&&console.log("%cDEBUG","background: #eee; color: #888",r,...i)}info(r,...i){this.getLevel()<=d.Info&&console.log("%c INFO","color: #33f",r,...i)}warn(r,...i){this.getLevel()<=d.Warning&&console.log("%c WARN","color: #993",r,...i)}error(r,...i){this.getLevel()<=d.Error&&console.log("%c  ERR","color: #f33",r,...i)}critical(r,...i){this.getLevel()<=d.Critical&&console.log("%cCRITI","background: #f33; color: white",r,...i)}dispose(){}flush(){}}e.ConsoleLogger=t;class m extends E{constructor(r,i=e.DEFAULT_LOG_LEVEL){super();this.adapter=r,this.setLevel(i)}trace(r,...i){this.getLevel()<=d.Trace&&this.adapter.log(d.Trace,[this.extractMessage(r),...i])}debug(r,...i){this.getLevel()<=d.Debug&&this.adapter.log(d.Debug,[this.extractMessage(r),...i])}info(r,...i){this.getLevel()<=d.Info&&this.adapter.log(d.Info,[this.extractMessage(r),...i])}warn(r,...i){this.getLevel()<=d.Warning&&this.adapter.log(d.Warning,[this.extractMessage(r),...i])}error(r,...i){this.getLevel()<=d.Error&&this.adapter.log(d.Error,[this.extractMessage(r),...i])}critical(r,...i){this.getLevel()<=d.Critical&&this.adapter.log(d.Critical,[this.extractMessage(r),...i])}extractMessage(r){return typeof r=="string"?r:(0,p.toErrorMessage)(r,this.getLevel()<=d.Trace)}dispose(){}flush(){}}e.AdapterLogger=m;class v extends E{constructor(r){super();this.logServices=r,r.length&&this.setLevel(r[0].getLevel())}setLevel(r){for(const i of this.logServices)i.setLevel(r);super.setLevel(r)}trace(r,...i){for(const s of this.logServices)s.trace(r,...i)}debug(r,...i){for(const s of this.logServices)s.debug(r,...i)}info(r,...i){for(const s of this.logServices)s.info(r,...i)}warn(r,...i){for(const s of this.logServices)s.warn(r,...i)}error(r,...i){for(const s of this.logServices)s.error(r,...i)}critical(r,...i){for(const s of this.logServices)s.critical(r,...i)}flush(){for(const r of this.logServices)r.flush()}dispose(){for(const r of this.logServices)r.dispose()}}e.MultiplexLogService=v;class b extends C.Disposable{constructor(r){super();this.logger=r,this._register(r)}get onDidChangeLogLevel(){return this.logger.onDidChangeLogLevel}setLevel(r){this.logger.setLevel(r)}getLevel(){return this.logger.getLevel()}trace(r,...i){this.logger.trace(r,...i)}debug(r,...i){this.logger.debug(r,...i)}info(r,...i){this.logger.info(r,...i)}warn(r,...i){this.logger.warn(r,...i)}error(r,...i){this.logger.error(r,...i)}critical(r,...i){this.logger.critical(r,...i)}flush(){this.logger.flush()}}e.LogService=b;class P extends C.Disposable{constructor(r,i){super();this.logLevel=r,this.loggers=new Map,this.logLevelChangeableLoggers=[],this._register(i(s=>{this.logLevel=s,this.logLevelChangeableLoggers.forEach(h=>h.setLevel(s))}))}getLogger(r){return this.loggers.get(r.toString())}createLogger(r,i){let s=this.loggers.get(r.toString());return s||(s=this.doCreateLogger(r,i?.always?d.Trace:this.logLevel,i),this.loggers.set(r.toString(),s),i?.always||this.logLevelChangeableLoggers.push(s)),s}dispose(){this.logLevelChangeableLoggers.splice(0,this.logLevelChangeableLoggers.length),this.loggers.forEach(r=>r.dispose()),this.loggers.clear(),super.dispose()}}e.AbstractLoggerService=P;class c{constructor(){this.onDidChangeLogLevel=new R.Emitter().event}setLevel(r){}getLevel(){return d.Info}trace(r,...i){}debug(r,...i){}info(r,...i){}warn(r,...i){}error(r,...i){}critical(r,...i){}dispose(){}flush(){}}e.NullLogService=c;function a(u){if(u.verbose)return d.Trace;if(typeof u.logLevel=="string"){const r=l(u.logLevel.toLowerCase());if(r!==void 0)return r}return e.DEFAULT_LOG_LEVEL}e.getLogLevel=a;function l(u){switch(u){case"trace":return d.Trace;case"debug":return d.Debug;case"info":return d.Info;case"warn":return d.Warning;case"error":return d.Error;case"critical":return d.Critical;case"off":return d.Off}}e.parseLogLevel=l;function o(u){switch(u){case d.Trace:return"trace";case d.Debug:return"debug";case d.Info:return"info";case d.Warning:return"warn";case d.Error:return"error";case d.Critical:return"critical";case d.Off:return"off"}}e.LogLevelToString=o});var te=this&&this.__param||function(V,e){return function(p,R){e(p,R,V)}};define(x[180],ee([0,1,9,17,38,78,48,19,5,6]),function(V,e,p,R,C,k,n,I,d,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserConfigurationFileService=e.IUserConfigurationFileService=e.UserConfigurationFileServiceId=e.UserConfigurationErrorCode=void 0;var y;(function(g){g.ERROR_INVALID_FILE="ERROR_INVALID_FILE",g.ERROR_FILE_MODIFIED_SINCE="ERROR_FILE_MODIFIED_SINCE"})(y=e.UserConfigurationErrorCode||(e.UserConfigurationErrorCode={})),e.UserConfigurationFileServiceId="IUserConfigurationFileService",e.IUserConfigurationFileService=(0,d.createDecorator)(e.UserConfigurationFileServiceId);let E=class{constructor(S,t,m){this.environmentService=S,this.fileService=t,this.logService=m,this.queue=new p.Queue}async updateSettings(S,t){return this.queue.queue(()=>this.doWrite(S,t))}async doWrite(S,t){this.logService.trace(`${e.UserConfigurationFileServiceId}#write`,this.environmentService.settingsResource.toString(),S);const{value:m,mtime:v,etag:b}=await this.fileService.readFile(this.environmentService.settingsResource,{atomic:!0});let P=m.toString();const c=[];if((0,C.parse)(P,c,{allowTrailingComma:!0,allowEmptyContent:!0}),c.length)throw new Error("ERROR_INVALID_FILE");const a=this.getEdits(S,P,t)[0];if(a){P=P.substring(0,a.offset)+a.content+P.substring(a.offset+a.length);try{await this.fileService.writeFile(this.environmentService.settingsResource,R.VSBuffer.fromString(P),{etag:b,mtime:v})}catch(l){if(l.fileOperationResult===3)throw new Error("ERROR_FILE_MODIFIED_SINCE")}}}async write(S,t){return this.queue.queue(async()=>{await this.fileService.writeFile(this.environmentService.settingsResource,S,t)})}getEdits({value:S,path:t},m,v){return t.length?(0,k.setProperty)(m,t,S,v):[{content:JSON.stringify(S,null,v.insertSpaces&&v.tabSize?" ".repeat(v.tabSize):"	"),length:m.length,offset:0}]}};E=fe([te(0,n.IEnvironmentService),te(1,I.IFileService),te(2,f.ILogService)],E),e.UserConfigurationFileService=E}),define(x[181],ee([0,1,30,9,16,4,2,8,54,6]),function(V,e,p,R,C,k,n,I,d,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractDiskFileSystemProvider=void 0;class y extends n.Disposable{constructor(g){super();this.logService=g,this._onDidErrorOccur=this._register(new k.Emitter),this.onDidErrorOccur=this._onDidErrorOccur.event,this._onDidChangeFile=this._register(new k.Emitter),this.onDidChangeFile=this._onDidChangeFile.event,this.recursiveFoldersToWatch=[],this.recursiveWatchRequestDelayer=this._register(new R.ThrottledDelayer(0))}watch(g,S){return S.recursive?this.watchRecursive(g,S):this.watchNonRecursive(g)}watchRecursive(g,S){const t={path:this.toFilePath(g),excludes:S.excludes},m=(0,p.insert)(this.recursiveFoldersToWatch,t);return this.refreshRecursiveWatchers(),(0,n.toDisposable)(()=>{m(),this.refreshRecursiveWatchers()})}refreshRecursiveWatchers(){this.recursiveWatchRequestDelayer.trigger(()=>this.doRefreshRecursiveWatchers()).catch(g=>(0,C.onUnexpectedError)(g))}doRefreshRecursiveWatchers(){return this.recursiveWatcher||(this.recursiveWatcher=this._register(this.createRecursiveWatcher(g=>this._onDidChangeFile.fire((0,d.toFileChanges)(g)),g=>this.onWatcherLogMessage(g),this.logService.getLevel()===f.LogLevel.Trace)),this._register(this.logService.onDidChangeLogLevel(()=>{this.recursiveWatcher?.setVerboseLogging(this.logService.getLevel()===f.LogLevel.Trace)}))),this.doWatch(this.recursiveWatcher,this.recursiveFoldersToWatch)}doWatch(g,S){return g.watch(S)}watchNonRecursive(g){const S=this.createNonRecursiveWatcher(this.toFilePath(g),m=>this._onDidChangeFile.fire((0,d.toFileChanges)(m)),m=>this.onWatcherLogMessage(m),this.logService.getLevel()===f.LogLevel.Trace),t=this.logService.onDidChangeLogLevel(()=>{S.setVerboseLogging(this.logService.getLevel()===f.LogLevel.Trace)});return(0,n.combinedDisposable)(S,t)}onWatcherLogMessage(g){g.type==="error"&&this._onDidErrorOccur.fire(g.message),this.logService[g.type](g.message)}toFilePath(g){return(0,I.normalize)(g.fsPath)}}e.AbstractDiskFileSystemProvider=y}),define(x[182],ee([0,1,30,9,17,23,4,69,2,39,10,63,15,60,143,19,92,6]),function(V,e,p,R,C,k,n,I,d,f,y,E,g,S,t,m,v,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileService=void 0;let P=class Ye extends d.Disposable{constructor(a){super();this.logService=a,this.BUFFER_SIZE=256*1024,this._onDidChangeFileSystemProviderRegistrations=this._register(new n.Emitter),this.onDidChangeFileSystemProviderRegistrations=this._onDidChangeFileSystemProviderRegistrations.event,this._onWillActivateFileSystemProvider=this._register(new n.Emitter),this.onWillActivateFileSystemProvider=this._onWillActivateFileSystemProvider.event,this._onDidChangeFileSystemProviderCapabilities=this._register(new n.Emitter),this.onDidChangeFileSystemProviderCapabilities=this._onDidChangeFileSystemProviderCapabilities.event,this.provider=new Map,this._onDidRunOperation=this._register(new n.Emitter),this.onDidRunOperation=this._onDidRunOperation.event,this._onError=this._register(new n.Emitter),this.onError=this._onError.event,this._onDidFilesChange=this._register(new n.Emitter),this.onDidFilesChange=this._onDidFilesChange.event,this._onDidChangeFilesRaw=this._register(new n.Emitter),this.onDidChangeFilesRaw=this._onDidChangeFilesRaw.event,this.activeWatchers=new Map,this.caseSensitiveFileEventsWorker=this._register(new R.ThrottledWorker(Ye.FILE_EVENTS_THROTTLING.maxChangesChunkSize,Ye.FILE_EVENTS_THROTTLING.maxChangesBufferSize,Ye.FILE_EVENTS_THROTTLING.coolDownDelay,l=>this._onDidFilesChange.fire(new m.FileChangesEvent(l,!1)))),this.caseInsensitiveFileEventsWorker=this._register(new R.ThrottledWorker(Ye.FILE_EVENTS_THROTTLING.maxChangesChunkSize,Ye.FILE_EVENTS_THROTTLING.maxChangesBufferSize,Ye.FILE_EVENTS_THROTTLING.coolDownDelay,l=>this._onDidFilesChange.fire(new m.FileChangesEvent(l,!0)))),this.watchedResources=f.TernarySearchTree.forUris(l=>{const o=this.getProvider(l.scheme);return o?!this.isPathCaseSensitive(o):!1}),this.writeQueue=this._register(new R.ResourceQueue)}registerProvider(a,l){if(this.provider.has(a))throw new Error(`A filesystem provider for the scheme '${a}' is already registered.`);(0,E.mark)(`code/registerFilesystem/${a}`),this.provider.set(a,l),this._onDidChangeFileSystemProviderRegistrations.fire({added:!0,scheme:a,provider:l});const o=new d.DisposableStore;return o.add(l.onDidChangeFile(u=>this.onDidChangeFile(u,this.isPathCaseSensitive(l)))),o.add(l.onDidChangeCapabilities(()=>this._onDidChangeFileSystemProviderCapabilities.fire({provider:l,scheme:a}))),typeof l.onDidErrorOccur=="function"&&o.add(l.onDidErrorOccur(u=>this._onError.fire(new Error(u)))),(0,d.toDisposable)(()=>{this._onDidChangeFileSystemProviderRegistrations.fire({added:!1,scheme:a,provider:l}),this.provider.delete(a),(0,d.dispose)(o)})}getProvider(a){return this.provider.get(a)}async activateProvider(a){const l=[];this._onWillActivateFileSystemProvider.fire({scheme:a,join(o){l.push(o)}}),!this.provider.has(a)&&await R.Promises.settled(l)}async canHandleResource(a){return await this.activateProvider(a.scheme),this.hasProvider(a)}hasProvider(a){return this.provider.has(a.scheme)}hasCapability(a,l){const o=this.provider.get(a.scheme);return!!(o&&o.capabilities&l)}listCapabilities(){return I.Iterable.map(this.provider,([a,l])=>({scheme:a,capabilities:l.capabilities}))}async withProvider(a){if(!(0,g.isAbsolutePath)(a))throw new m.FileOperationError((0,t.localize)(0,null,this.resourceForError(a)),8);await this.activateProvider(a.scheme);const l=this.provider.get(a.scheme);if(!l){const o=new Error;throw o.name="ENOPRO",o.message=(0,t.localize)(1,null,a.toString()),o}return l}async withReadProvider(a){const l=await this.withProvider(a);if((0,m.hasOpenReadWriteCloseCapability)(l)||(0,m.hasReadWriteCapability)(l)||(0,m.hasFileReadStreamCapability)(l))return l;throw new Error(`Filesystem provider for scheme '${a.scheme}' neither has FileReadWrite, FileReadStream nor FileOpenReadWriteClose capability which is needed for the read operation.`)}async withWriteProvider(a){const l=await this.withProvider(a);if((0,m.hasOpenReadWriteCloseCapability)(l)||(0,m.hasReadWriteCapability)(l))return l;throw new Error(`Filesystem provider for scheme '${a.scheme}' neither has FileReadWrite nor FileOpenReadWriteClose capability which is needed for the write operation.`)}async resolve(a,l){try{return await this.doResolveFile(a,l)}catch(o){throw(0,m.toFileSystemProviderErrorCode)(o)===m.FileSystemProviderErrorCode.FileNotFound?new m.FileOperationError((0,t.localize)(2,null,this.resourceForError(a)),1):(0,m.ensureFileSystemProviderError)(o)}}async doResolveFile(a,l){const o=await this.withProvider(a),u=this.isPathCaseSensitive(o),r=l?.resolveTo,i=l?.resolveSingleChildDescendants,s=l?.resolveMetadata,h=await o.stat(a);let w;return this.toFileStat(o,a,h,void 0,!!s,(M,A)=>(w||(w=f.TernarySearchTree.forUris(()=>!u),w.set(a,!0),r&&w.fill(!0,r)),w.get(M.resource)||w.findSuperstr(M.resource.with({query:null,fragment:null}))?!0:M.isDirectory&&i?A===1:!1))}async toFileStat(a,l,o,u,r,i){const{providerExtUri:s}=this.getExtUri(a),h={resource:l,name:s.basename(l),isFile:(o.type&m.FileType.File)!=0,isDirectory:(o.type&m.FileType.Directory)!=0,isSymbolicLink:(o.type&m.FileType.SymbolicLink)!=0,mtime:o.mtime,ctime:o.ctime,size:o.size,readonly:Boolean((o.permissions??0)&m.FilePermission.Readonly)||Boolean(a.capabilities&2048),etag:(0,m.etag)({mtime:o.mtime,size:o.size})};if(h.isDirectory&&i(h,u)){try{const w=await a.readdir(l),M=await R.Promises.settled(w.map(async([A,L])=>{try{const F=s.joinPath(l,A),U=r?await a.stat(F):{type:L};return await this.toFileStat(a,F,U,w.length,r,i)}catch(F){return this.logService.trace(F),null}}));h.children=(0,p.coalesce)(M)}catch(w){this.logService.trace(w),h.children=[]}return h}return h}async resolveAll(a){return R.Promises.settled(a.map(async l=>{try{return{stat:await this.doResolveFile(l.resource,l.options),success:!0}}catch(o){return this.logService.trace(o),{stat:void 0,success:!1}}}))}async exists(a){const l=await this.withProvider(a);try{return!!await l.stat(a)}catch(o){return!1}}async canCreateFile(a,l){try{await this.doValidateCreateFile(a,l)}catch(o){return o}return!0}async doValidateCreateFile(a,l){if(!l?.overwrite&&await this.exists(a))throw new m.FileOperationError((0,t.localize)(3,null,this.resourceForError(a)),3,l)}async createFile(a,l=C.VSBuffer.fromString(""),o){await this.doValidateCreateFile(a,o);const u=await this.writeFile(a,l);return this._onDidRunOperation.fire(new m.FileOperationEvent(a,0,u)),u}async writeFile(a,l,o){const u=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(a),a),{providerExtUri:r}=this.getExtUri(u);try{await this.validateWriteFile(u,a,o)||await this.mkdirp(u,r.dirname(a));let s;if((0,m.hasReadWriteCapability)(u)&&!(l instanceof C.VSBuffer))if((0,S.isReadableStream)(l)){const h=await(0,S.peekStream)(l,3);h.ended?s=C.VSBuffer.concat(h.buffer):s=h}else s=(0,S.peekReadable)(l,h=>C.VSBuffer.concat(h),3);else s=l;!(0,m.hasOpenReadWriteCloseCapability)(u)||(0,m.hasReadWriteCapability)(u)&&s instanceof C.VSBuffer?await this.doWriteUnbuffered(u,a,o,s):await this.doWriteBuffered(u,a,o,s instanceof C.VSBuffer?(0,C.bufferToReadable)(s):s)}catch(i){throw new m.FileOperationError((0,t.localize)(4,null,this.resourceForError(a),(0,m.ensureFileSystemProviderError)(i).toString()),(0,m.toFileOperationResult)(i),o)}return this.resolve(a,{resolveMetadata:!0})}async validateWriteFile(a,l,o){if(!!o?.unlock&&!(a.capabilities&8192))throw new Error((0,t.localize)(5,null,this.resourceForError(l)));let r;try{r=await a.stat(l)}catch(i){return}if((r.type&m.FileType.Directory)!=0)throw new m.FileOperationError((0,t.localize)(6,null,this.resourceForError(l)),0,o);if(this.throwIfFileIsReadonly(l,r),typeof o?.mtime=="number"&&typeof o.etag=="string"&&o.etag!==m.ETAG_DISABLED&&typeof r.mtime=="number"&&typeof r.size=="number"&&o.mtime<r.mtime&&o.etag!==(0,m.etag)({mtime:o.mtime,size:r.size}))throw new m.FileOperationError((0,t.localize)(7,null),3,o);return r}async readFile(a,l){const o=await this.withReadProvider(a);return l?.atomic?this.doReadFileAtomic(o,a,l):this.doReadFile(o,a,l)}async doReadFileAtomic(a,l,o){return new Promise((u,r)=>{this.writeQueue.queueFor(l,this.getExtUri(a).providerExtUri).queue(async()=>{try{const i=await this.doReadFile(a,l,o);u(i)}catch(i){r(i)}})})}async doReadFile(a,l,o){const u=await this.doReadFileStream(a,l,{...o,preferUnbuffered:!0});return{...u,value:await(0,C.streamToBuffer)(u.value)}}async readFileStream(a,l){const o=await this.withReadProvider(a);return this.doReadFileStream(o,a,l)}async doReadFileStream(a,l,o){const u=new k.CancellationTokenSource,r=this.validateReadFile(l,o).then(s=>s,s=>{throw u.cancel(),s});let i;try{return typeof o?.etag=="string"&&o.etag!==m.ETAG_DISABLED&&await r,!((0,m.hasOpenReadWriteCloseCapability)(a)||(0,m.hasFileReadStreamCapability)(a))||(0,m.hasReadWriteCapability)(a)&&o?.preferUnbuffered?i=this.readFileUnbuffered(a,l,o):(0,m.hasFileReadStreamCapability)(a)?i=this.readFileStreamed(a,l,u.token,o):i=this.readFileBuffered(a,l,u.token,o),{...await r,value:i}}catch(s){i&&await(0,S.consumeStream)(i);const h=(0,t.localize)(8,null,this.resourceForError(l),(0,m.ensureFileSystemProviderError)(s).toString());throw s instanceof m.NotModifiedSinceFileOperationError?new m.NotModifiedSinceFileOperationError(h,s.stat,o):new m.FileOperationError(h,(0,m.toFileOperationResult)(s),o)}}readFileStreamed(a,l,o,u=Object.create(null)){const r=a.readFileStream(l,u,o);return(0,S.transform)(r,{data:i=>i instanceof C.VSBuffer?i:C.VSBuffer.wrap(i),error:i=>new m.FileOperationError((0,t.localize)(9,null,this.resourceForError(l),(0,m.ensureFileSystemProviderError)(i).toString()),(0,m.toFileOperationResult)(i),u)},i=>C.VSBuffer.concat(i))}readFileBuffered(a,l,o,u=Object.create(null)){const r=(0,C.newWriteableBufferStream)();return(0,v.readFileIntoStream)(a,l,r,i=>i,{...u,bufferSize:this.BUFFER_SIZE,errorTransformer:i=>new m.FileOperationError((0,t.localize)(10,null,this.resourceForError(l),(0,m.ensureFileSystemProviderError)(i).toString()),(0,m.toFileOperationResult)(i),u)},o),r}readFileUnbuffered(a,l,o){const u=(0,S.newWriteableStream)(r=>C.VSBuffer.concat(r));return(async()=>{try{let r=await a.readFile(l);typeof o?.position=="number"&&(r=r.slice(o.position)),typeof o?.length=="number"&&(r=r.slice(0,o.length)),this.validateReadFileLimits(l,r.byteLength,o),u.end(C.VSBuffer.wrap(r))}catch(r){u.error(r),u.end()}})(),u}async validateReadFile(a,l){const o=await this.resolve(a,{resolveMetadata:!0});if(o.isDirectory)throw new m.FileOperationError((0,t.localize)(11,null,this.resourceForError(a)),0,l);if(typeof l?.etag=="string"&&l.etag!==m.ETAG_DISABLED&&l.etag===o.etag)throw new m.NotModifiedSinceFileOperationError((0,t.localize)(12,null),o,l);return this.validateReadFileLimits(a,o.size,l),o}validateReadFileLimits(a,l,o){if(o?.limits){let u;if(typeof o.limits.memory=="number"&&l>o.limits.memory&&(u=9),typeof o.limits.size=="number"&&l>o.limits.size&&(u=7),typeof u=="number")throw new m.FileOperationError((0,t.localize)(13,null,this.resourceForError(a)),u)}}async canMove(a,l,o){return this.doCanMoveCopy(a,l,"move",o)}async canCopy(a,l,o){return this.doCanMoveCopy(a,l,"copy",o)}async doCanMoveCopy(a,l,o,u){if(a.toString()!==l.toString())try{const r=o==="move"?this.throwIfFileSystemIsReadonly(await this.withWriteProvider(a),a):await this.withReadProvider(a),i=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(l),l);await this.doValidateMoveCopy(r,a,i,l,o,u)}catch(r){return r}return!0}async move(a,l,o){const u=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(a),a),r=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(l),l),i=await this.doMoveCopy(u,a,r,l,"move",!!o),s=await this.resolve(l,{resolveMetadata:!0});return this._onDidRunOperation.fire(new m.FileOperationEvent(a,i==="move"?2:3,s)),s}async copy(a,l,o){const u=await this.withReadProvider(a),r=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(l),l),i=await this.doMoveCopy(u,a,r,l,"copy",!!o),s=await this.resolve(l,{resolveMetadata:!0});return this._onDidRunOperation.fire(new m.FileOperationEvent(a,i==="copy"?3:2,s)),s}async doMoveCopy(a,l,o,u,r,i){if(l.toString()===u.toString())return r;const{exists:s,isSameResourceWithDifferentPathCase:h}=await this.doValidateMoveCopy(a,l,o,u,r,i);if(s&&!h&&i&&await this.del(u,{recursive:!0}),await this.mkdirp(o,this.getExtUri(o).providerExtUri.dirname(u)),r==="copy"){if(a===o&&(0,m.hasFileFolderCopyCapability)(a))await a.copy(l,u,{overwrite:i});else{const w=await this.resolve(l);w.isDirectory?await this.doCopyFolder(a,w,o,u):await this.doCopyFile(a,l,o,u)}return r}else return a===o?(await a.rename(l,u,{overwrite:i}),r):(await this.doMoveCopy(a,l,o,u,"copy",i),await this.del(l,{recursive:!0}),"copy")}async doCopyFile(a,l,o,u){if((0,m.hasOpenReadWriteCloseCapability)(a)&&(0,m.hasOpenReadWriteCloseCapability)(o))return this.doPipeBuffered(a,l,o,u);if((0,m.hasOpenReadWriteCloseCapability)(a)&&(0,m.hasReadWriteCapability)(o))return this.doPipeBufferedToUnbuffered(a,l,o,u);if((0,m.hasReadWriteCapability)(a)&&(0,m.hasOpenReadWriteCloseCapability)(o))return this.doPipeUnbufferedToBuffered(a,l,o,u);if((0,m.hasReadWriteCapability)(a)&&(0,m.hasReadWriteCapability)(o))return this.doPipeUnbuffered(a,l,o,u)}async doCopyFolder(a,l,o,u){await o.mkdir(u),Array.isArray(l.children)&&await R.Promises.settled(l.children.map(async r=>{const i=this.getExtUri(o).providerExtUri.joinPath(u,r.name);return r.isDirectory?this.doCopyFolder(a,await this.resolve(r.resource),o,i):this.doCopyFile(a,r.resource,o,i)}))}async doValidateMoveCopy(a,l,o,u,r,i){let s=!1;if(a===o){const{providerExtUri:w,isPathCaseSensitive:M}=this.getExtUri(a);if(M||(s=w.isEqual(l,u)),s&&r==="copy")throw new Error((0,t.localize)(14,null,this.resourceForError(l),this.resourceForError(u)));if(!s&&w.isEqualOrParent(u,l))throw new Error((0,t.localize)(15,null,this.resourceForError(l),this.resourceForError(u)))}const h=await this.exists(u);if(h&&!s){if(!i)throw new m.FileOperationError((0,t.localize)(16,null,this.resourceForError(l),this.resourceForError(u)),4);if(a===o){const{providerExtUri:w}=this.getExtUri(a);if(w.isEqualOrParent(l,u))throw new Error((0,t.localize)(17,null,this.resourceForError(l),this.resourceForError(u)))}}return{exists:h,isSameResourceWithDifferentPathCase:s}}getExtUri(a){const l=this.isPathCaseSensitive(a);return{providerExtUri:l?g.extUri:g.extUriIgnorePathCase,isPathCaseSensitive:l}}isPathCaseSensitive(a){return!!(a.capabilities&1024)}async createFolder(a){const l=this.throwIfFileSystemIsReadonly(await this.withProvider(a),a);await this.mkdirp(l,a);const o=await this.resolve(a,{resolveMetadata:!0});return this._onDidRunOperation.fire(new m.FileOperationEvent(a,0,o)),o}async mkdirp(a,l){const o=[],{providerExtUri:u}=this.getExtUri(a);for(;!u.isEqual(l,u.dirname(l));)try{if(((await a.stat(l)).type&m.FileType.Directory)==0)throw new Error((0,t.localize)(18,null,this.resourceForError(l)));break}catch(r){if((0,m.toFileSystemProviderErrorCode)(r)!==m.FileSystemProviderErrorCode.FileNotFound)throw r;o.push(u.basename(l)),l=u.dirname(l)}for(let r=o.length-1;r>=0;r--){l=u.joinPath(l,o[r]);try{await a.mkdir(l)}catch(i){if((0,m.toFileSystemProviderErrorCode)(i)!==m.FileSystemProviderErrorCode.FileExists)throw i}}}async canDelete(a,l){try{await this.doValidateDelete(a,l)}catch(o){return o}return!0}async doValidateDelete(a,l){const o=this.throwIfFileSystemIsReadonly(await this.withProvider(a),a);if(!!l?.useTrash&&!(o.capabilities&4096))throw new Error((0,t.localize)(19,null,this.resourceForError(a)));let r;try{r=await o.stat(a)}catch(s){}if(r)this.throwIfFileIsReadonly(a,r);else throw new m.FileOperationError((0,t.localize)(20,null,this.resourceForError(a)),1);if(!!!l?.recursive){const s=await this.resolve(a);if(s.isDirectory&&Array.isArray(s.children)&&s.children.length>0)throw new Error((0,t.localize)(21,null,this.resourceForError(a)))}return o}async del(a,l){const o=await this.doValidateDelete(a,l),u=!!l?.useTrash,r=!!l?.recursive;await o.delete(a,{recursive:r,useTrash:u}),this._onDidRunOperation.fire(new m.FileOperationEvent(a,1))}onDidChangeFile(a,l){this._onDidChangeFilesRaw.fire({changes:a});let o,u;{for(const r of a)this.watchedResources.has(r.resource)?(o||(o=[]),o.push(r)):(u||(u=[]),u.push(r));o&&this._onDidFilesChange.fire(new m.FileChangesEvent(o,!l))}if(u){const r=l?this.caseSensitiveFileEventsWorker:this.caseInsensitiveFileEventsWorker;!r.work(u)&&Ye.FILE_EVENTS_THROTTLING.warningscounter++<10&&this.logService.warn(`[File watcher]: started ignoring events due to too many file change events at once (incoming: ${u.length}, most recent change: ${u[0].resource.toString()}). Use 'files.watcherExclude' setting to exclude folders with lots of changing files (e.g. compilation output).`),r.pending>0&&this.logService.trace(`[File watcher]: started throttling events due to large amount of file change events at once (pending: ${r.pending}, most recent change: ${u[0].resource.toString()}). Use 'files.watcherExclude' setting to exclude folders with lots of changing files (e.g. compilation output).`)}}watch(a,l={recursive:!1,excludes:[]}){const o=new d.DisposableStore;let u=!1,r=()=>{u=!0};return o.add((0,d.toDisposable)(()=>r())),this.doWatch(a,l).then(i=>{u?(0,d.dispose)(i):r=()=>(0,d.dispose)(i)},i=>this.logService.error(i)),l.recursive||(this.watchedResources.set(a,(this.watchedResources.get(a)??0)+1),o.add((0,d.toDisposable)(()=>{const i=this.watchedResources.get(a);typeof i=="number"&&(i<=1?this.watchedResources.delete(a):this.watchedResources.set(a,i-1))}))),o}async doWatch(a,l){const o=await this.withProvider(a),u=this.toWatchKey(o,a,l);let r=this.activeWatchers.get(u);return r||(r={count:0,disposable:o.watch(a,l)},this.activeWatchers.set(u,r)),r.count+=1,(0,d.toDisposable)(()=>{r&&(r.count--,r.count===0&&((0,d.dispose)(r.disposable),this.activeWatchers.delete(u)))})}toWatchKey(a,l,o){const{providerExtUri:u}=this.getExtUri(a);return[u.getComparisonKey(l),String(o.recursive),o.excludes.join()].join()}dispose(){super.dispose();for(const[,a]of this.activeWatchers)(0,d.dispose)(a.disposable);this.activeWatchers.clear()}async doWriteBuffered(a,l,o,u){return this.writeQueue.queueFor(l,this.getExtUri(a).providerExtUri).queue(async()=>{const r=await a.open(l,{create:!0,unlock:o?.unlock??!1});try{(0,S.isReadableStream)(u)||(0,S.isReadableBufferedStream)(u)?await this.doWriteStreamBufferedQueued(a,r,u):await this.doWriteReadableBufferedQueued(a,r,u)}catch(i){throw(0,m.ensureFileSystemProviderError)(i)}finally{await a.close(r)}})}async doWriteStreamBufferedQueued(a,l,o){let u=0,r;if((0,S.isReadableBufferedStream)(o)){if(o.buffer.length>0){const i=C.VSBuffer.concat(o.buffer);await this.doWriteBuffer(a,l,i,i.byteLength,u,0),u+=i.byteLength}if(o.ended)return;r=o.stream}else r=o;return new Promise((i,s)=>{(0,S.listenStream)(r,{onData:async h=>{r.pause();try{await this.doWriteBuffer(a,l,h,h.byteLength,u,0)}catch(w){return s(w)}u+=h.byteLength,setTimeout(()=>r.resume())},onError:h=>s(h),onEnd:()=>i()})})}async doWriteReadableBufferedQueued(a,l,o){let u=0,r;for(;(r=o.read())!==null;)await this.doWriteBuffer(a,l,r,r.byteLength,u,0),u+=r.byteLength}async doWriteBuffer(a,l,o,u,r,i){let s=0;for(;s<u;)s+=await a.write(l,r+s,o.buffer,i+s,u-s)}async doWriteUnbuffered(a,l,o,u){return this.writeQueue.queueFor(l,this.getExtUri(a).providerExtUri).queue(()=>this.doWriteUnbufferedQueued(a,l,o,u))}async doWriteUnbufferedQueued(a,l,o,u){let r;u instanceof C.VSBuffer?r=u:(0,S.isReadableStream)(u)?r=await(0,C.streamToBuffer)(u):(0,S.isReadableBufferedStream)(u)?r=await(0,C.bufferedStreamToBuffer)(u):r=(0,C.readableToBuffer)(u),await a.writeFile(l,r.buffer,{create:!0,overwrite:!0,unlock:o?.unlock??!1})}async doPipeBuffered(a,l,o,u){return this.writeQueue.queueFor(u,this.getExtUri(o).providerExtUri).queue(()=>this.doPipeBufferedQueued(a,l,o,u))}async doPipeBufferedQueued(a,l,o,u){let r,i;try{r=await a.open(l,{create:!1}),i=await o.open(u,{create:!0,unlock:!1});const s=C.VSBuffer.alloc(this.BUFFER_SIZE);let h=0,w=0,M=0;do M=await a.read(r,h,s.buffer,w,s.byteLength-w),await this.doWriteBuffer(o,i,s,M,h,w),h+=M,w+=M,w===s.byteLength&&(w=0);while(M>0)}catch(s){throw(0,m.ensureFileSystemProviderError)(s)}finally{await R.Promises.settled([typeof r=="number"?a.close(r):Promise.resolve(),typeof i=="number"?o.close(i):Promise.resolve()])}}async doPipeUnbuffered(a,l,o,u){return this.writeQueue.queueFor(u,this.getExtUri(o).providerExtUri).queue(()=>this.doPipeUnbufferedQueued(a,l,o,u))}async doPipeUnbufferedQueued(a,l,o,u){return o.writeFile(u,await a.readFile(l),{create:!0,overwrite:!0,unlock:!1})}async doPipeUnbufferedToBuffered(a,l,o,u){return this.writeQueue.queueFor(u,this.getExtUri(o).providerExtUri).queue(()=>this.doPipeUnbufferedToBufferedQueued(a,l,o,u))}async doPipeUnbufferedToBufferedQueued(a,l,o,u){const r=await o.open(u,{create:!0,unlock:!1});try{const i=await a.readFile(l);await this.doWriteBuffer(o,r,C.VSBuffer.wrap(i),i.byteLength,0,0)}catch(i){throw(0,m.ensureFileSystemProviderError)(i)}finally{await o.close(r)}}async doPipeBufferedToUnbuffered(a,l,o,u){const r=await(0,C.streamToBuffer)(this.readFileBuffered(a,l,k.CancellationToken.None));await this.doWriteUnbuffered(o,u,void 0,r)}throwIfFileSystemIsReadonly(a,l){if(a.capabilities&2048)throw new m.FileOperationError((0,t.localize)(22,null,this.resourceForError(l)),6);return a}throwIfFileIsReadonly(a,l){if((l.permissions??0)&m.FilePermission.Readonly)throw new m.FileOperationError((0,t.localize)(23,null,this.resourceForError(a)),6)}resourceForError(a){return a.scheme===y.Schemas.file?a.fsPath:a.toString(!0)}};P.FILE_EVENTS_THROTTLING={maxChangesChunkSize:500,maxChangesBufferSize:3e4,coolDownDelay:200,warningscounter:0},P=fe([te(0,b.ILogService)],P),e.FileService=P}),define(x[183],ee([0,1,14,146,3,7,19,93,8,2,54,6,167,112]),function(V,e,p,R,C,k,n,I,d,f,y,E,g,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DiskFileSystemProviderChannel=void 0;class t extends g.AbstractDiskFileSystemProviderChannel{constructor(b,P){super(b,P)}getUriTransformer(b){return S.DefaultURITransformer}transformIncoming(b,P){return k.URI.revive(P)}async delete(b,P,c){if(!c.useTrash)return super.delete(b,P,c);const a=this.transformIncoming(b,P),l=(0,d.normalize)(a.fsPath);try{await p.shell.trashItem(l)}catch(o){throw(0,n.createFileSystemProviderError)(C.isWindows?(0,R.localize)(0,null,(0,d.basename)(l)):(0,R.localize)(1,null,(0,d.basename)(l)),n.FileSystemProviderErrorCode.Unknown)}}createSessionFileWatcher(b,P){return new m(P,this.logService)}}e.DiskFileSystemProviderChannel=t;class m extends f.Disposable{constructor(b,P){super();this.sessionEmitter=b,this.logService=P,this.watcherRequests=new Map}watch(b,P,c){if(c.recursive)throw(0,n.createFileSystemProviderError)("Recursive watcher is not supported from main process",n.FileSystemProviderErrorCode.Unavailable);const a=new f.DisposableStore;this.watcherRequests.set(b,a),a.add((0,f.toDisposable)(()=>this.watcherRequests.delete(b)));const l=a.add(new I.FileWatcher((0,d.normalize)(P.fsPath),o=>this.sessionEmitter.fire((0,y.toFileChanges)(o)),o=>this.onWatcherLogMessage(o),this.logService.getLevel()===E.LogLevel.Trace));return a.add(this.logService.onDidChangeLogLevel(()=>{l.setVerboseLogging(this.logService.getLevel()===E.LogLevel.Trace)})),a}onWatcherLogMessage(b){b.type==="error"&&this.sessionEmitter.fire(b.message),this.logService[b.type](b.message)}dispose(){super.dispose(),this.watcherRequests.forEach(b=>(0,f.dispose)(b)),this.watcherRequests.clear()}}}),define(x[94],ee([0,1,28,249,9,17,4,32,8,3,15,60,21,147,19,92,93,173,174,181,44]),function(V,e,p,R,C,k,n,I,d,f,y,E,g,S,t,m,v,b,P,c,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DiskFileSystemProvider=void 0,(()=>{try{(0,R.gracefulify)(p)}catch(o){console.error(`Error enabling graceful-fs: ${(0,a.toErrorMessage)(o)}`)}})();class l extends c.AbstractDiskFileSystemProvider{constructor(u,r){super(u);this.options=r,this.onDidChangeCapabilities=n.Event.None,this.mapHandleToPos=new Map,this.writeHandles=new Map,this.canFlush=!0}get capabilities(){return this._capabilities||(this._capabilities=2|4|16|8|8192,f.isLinux&&(this._capabilities|=1024)),this._capabilities}async stat(u){try{const{stat:r,symbolicLink:i}=await g.SymlinkSupport.stat(this.toFilePath(u));return{type:this.toType(r,i),ctime:r.birthtime.getTime(),mtime:r.mtime.getTime(),size:r.size}}catch(r){throw this.toFileSystemProviderError(r)}}async readdir(u){try{const r=await g.Promises.readdir(this.toFilePath(u),{withFileTypes:!0}),i=[];return await Promise.all(r.map(async s=>{try{let h;s.isSymbolicLink()?h=(await this.stat((0,y.joinPath)(u,s.name))).type:h=this.toType(s),i.push([s.name,h])}catch(h){this.logService.trace(h)}})),i}catch(r){throw this.toFileSystemProviderError(r)}}toType(u,r){let i;return r?.dangling?i=t.FileType.Unknown:u.isFile()?i=t.FileType.File:u.isDirectory()?i=t.FileType.Directory:i=t.FileType.Unknown,r&&(i|=t.FileType.SymbolicLink),i}async readFile(u){try{const r=this.toFilePath(u);return await g.Promises.readFile(r)}catch(r){throw this.toFileSystemProviderError(r)}}readFileStream(u,r,i){const s=(0,E.newWriteableStream)(h=>k.VSBuffer.concat(h.map(w=>k.VSBuffer.wrap(w))).buffer);return(0,m.readFileIntoStream)(this,u,s,h=>h.buffer,{...r,bufferSize:256*1024},i),s}async writeFile(u,r,i){let s;try{const h=this.toFilePath(u);if(!i.create||!i.overwrite){if(await g.Promises.exists(h)){if(!i.overwrite)throw(0,t.createFileSystemProviderError)((0,S.localize)(0,null),t.FileSystemProviderErrorCode.FileExists)}else if(!i.create)throw(0,t.createFileSystemProviderError)((0,S.localize)(1,null),t.FileSystemProviderErrorCode.FileNotFound)}s=await this.open(u,{create:!0,unlock:i.unlock}),await this.write(s,0,r,0,r.byteLength)}catch(h){throw await this.toFileSystemProviderWriteError(u,h)}finally{typeof s=="number"&&await this.close(s)}}async open(u,r){try{const i=this.toFilePath(u);if((0,t.isFileOpenForWriteOptions)(r)&&r.unlock)try{const{stat:w}=await g.SymlinkSupport.stat(i);w.mode&128||await g.Promises.chmod(i,w.mode|128)}catch(w){this.logService.trace(w)}let s;if((0,t.isFileOpenForWriteOptions)(r)){if(f.isWindows)try{await g.Promises.truncate(i,0),s="r+"}catch(w){w.code!=="ENOENT"&&this.logService.trace(w)}s||(s="w")}else s="r";const h=await g.Promises.open(i,s);return this.mapHandleToPos.set(h,0),(0,t.isFileOpenForWriteOptions)(r)&&this.writeHandles.set(h,u),h}catch(i){throw(0,t.isFileOpenForWriteOptions)(r)?await this.toFileSystemProviderWriteError(u,i):this.toFileSystemProviderError(i)}}async close(u){try{if(this.mapHandleToPos.delete(u),this.writeHandles.delete(u)&&this.canFlush)try{await g.Promises.fdatasync(u)}catch(r){this.canFlush=!1,this.logService.error(r)}return await g.Promises.close(u)}catch(r){throw this.toFileSystemProviderError(r)}}async read(u,r,i,s,h){const w=this.normalizePos(u,r);let M=null;try{const A=await g.Promises.read(u,i,s,h,w);return typeof A=="number"?M=A:M=A.bytesRead,M}catch(A){throw this.toFileSystemProviderError(A)}finally{this.updatePos(u,w,M)}}normalizePos(u,r){return r===this.mapHandleToPos.get(u)?null:r}updatePos(u,r,i){const s=this.mapHandleToPos.get(u);typeof s=="number"&&(typeof r=="number"||(typeof i=="number"?this.mapHandleToPos.set(u,s+i):this.mapHandleToPos.delete(u)))}async write(u,r,i,s,h){return(0,C.retry)(()=>this.doWrite(u,r,i,s,h),100,3)}async doWrite(u,r,i,s,h){const w=this.normalizePos(u,r);let M=null;try{const A=await g.Promises.write(u,i,s,h,w);return typeof A=="number"?M=A:M=A.bytesWritten,M}catch(A){throw await this.toFileSystemProviderWriteError(this.writeHandles.get(u),A)}finally{this.updatePos(u,w,M)}}async mkdir(u){try{await g.Promises.mkdir(this.toFilePath(u))}catch(r){throw this.toFileSystemProviderError(r)}}async delete(u,r){try{const i=this.toFilePath(u);await this.doDelete(i,r)}catch(i){throw this.toFileSystemProviderError(i)}}async doDelete(u,r){r.recursive?await g.Promises.rm(u,g.RimRafMode.MOVE):await g.Promises.unlink(u)}async rename(u,r,i){const s=this.toFilePath(u),h=this.toFilePath(r);if(s!==h)try{await this.validateTargetDeleted(u,r,"move",i.overwrite),await g.Promises.move(s,h)}catch(w){throw(w.code==="EINVAL"||w.code==="EBUSY"||w.code==="ENAMETOOLONG")&&(w=new Error((0,S.localize)(2,null,(0,d.basename)(s),(0,d.basename)((0,d.dirname)(h)),w.toString()))),this.toFileSystemProviderError(w)}}async copy(u,r,i){const s=this.toFilePath(u),h=this.toFilePath(r);if(s!==h)try{await this.validateTargetDeleted(u,r,"copy",i.overwrite),await g.Promises.copy(s,h,{preserveSymlinks:!0})}catch(w){throw(w.code==="EINVAL"||w.code==="EBUSY"||w.code==="ENAMETOOLONG")&&(w=new Error((0,S.localize)(3,null,(0,d.basename)(s),(0,d.basename)((0,d.dirname)(h)),w.toString()))),this.toFileSystemProviderError(w)}}async validateTargetDeleted(u,r,i,s){const h=this.toFilePath(u),w=this.toFilePath(r);let M=!1;if(!!(this.capabilities&1024)||(M=(0,I.isEqual)(h,w,!0)),M&&i==="copy")throw(0,t.createFileSystemProviderError)((0,S.localize)(4,null),t.FileSystemProviderErrorCode.FileExists);if(!M&&await g.Promises.exists(w)){if(!s)throw(0,t.createFileSystemProviderError)((0,S.localize)(5,null),t.FileSystemProviderErrorCode.FileExists);await this.delete(r,{recursive:!0,useTrash:!1})}}createRecursiveWatcher(u,r,i){let s,h=!1;return this.options?.watcher?.usePolling?h=!1:h=this.options?.legacyWatcher==="on",h?s=b.FileWatcher:s=P.FileWatcher,new s(w=>u(w),w=>r(w),i,this.options?.watcher)}doWatch(u,r){const i=this.options?.watcher?.usePolling;if(i===!0)for(const s of r)s.pollingInterval=this.options?.watcher?.pollingInterval??5e3;else if(Array.isArray(i))for(const s of r)i.includes(s.path)&&(s.pollingInterval=this.options?.watcher?.pollingInterval??5e3);return super.doWatch(u,r)}createNonRecursiveWatcher(u,r,i,s){return new v.FileWatcher(u,h=>r(h),h=>i(h),s)}toFileSystemProviderError(u){if(u instanceof t.FileSystemProviderError)return u;let r;switch(u.code){case"ENOENT":r=t.FileSystemProviderErrorCode.FileNotFound;break;case"EISDIR":r=t.FileSystemProviderErrorCode.FileIsADirectory;break;case"ENOTDIR":r=t.FileSystemProviderErrorCode.FileNotADirectory;break;case"EEXIST":r=t.FileSystemProviderErrorCode.FileExists;break;case"EPERM":case"EACCES":r=t.FileSystemProviderErrorCode.NoPermissions;break;default:r=t.FileSystemProviderErrorCode.Unknown}return(0,t.createFileSystemProviderError)(u,r)}async toFileSystemProviderWriteError(u,r){let i=this.toFileSystemProviderError(r);if(u&&i.code===t.FileSystemProviderErrorCode.NoPermissions)try{const{stat:s}=await g.SymlinkSupport.stat(this.toFilePath(u));s.mode&128||(i=(0,t.createFileSystemProviderError)(r,t.FileSystemProviderErrorCode.FileWriteLocked))}catch(s){this.logService.trace(s)}return i}}e.DiskFileSystemProvider=l}),define(x[95],ee([0,1,6]),function(V,e,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.BufferLogService=void 0;function R(k,n){switch(n){case p.LogLevel.Trace:return k.trace;case p.LogLevel.Debug:return k.debug;case p.LogLevel.Info:return k.info;case p.LogLevel.Warning:return k.warn;case p.LogLevel.Error:return k.error;case p.LogLevel.Critical:return k.critical;default:throw new Error("Invalid log level")}}class C extends p.AbstractLogger{constructor(n=p.DEFAULT_LOG_LEVEL){super();this.buffer=[],this._logger=void 0,this.setLevel(n),this._register(this.onDidChangeLogLevel(I=>{this._logger&&this._logger.setLevel(I)}))}set logger(n){this._logger=n;for(const{level:I,args:d}of this.buffer)R(n,I).apply(n,d);this.buffer=[]}_log(n,...I){this._logger?R(this._logger,n).apply(this._logger,I):this.getLevel()<=n&&this.buffer.push({level:n,args:I})}trace(n,...I){this._log(p.LogLevel.Trace,n,...I)}debug(n,...I){this._log(p.LogLevel.Debug,n,...I)}info(n,...I){this._log(p.LogLevel.Info,n,...I)}warn(n,...I){this._log(p.LogLevel.Warning,n,...I)}error(n,...I){this._log(p.LogLevel.Error,n,...I)}critical(n,...I){this._log(p.LogLevel.Critical,n,...I)}dispose(){this._logger&&this._logger.dispose()}flush(){this._logger&&this._logger.flush()}}e.BufferLogService=C}),define(x[184],ee([0,1,9,17,15,19,5,95,6]),function(V,e,p,R,C,k,n,I,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileLoggerService=e.FileLogger=void 0;const f=5*k.ByteSize.MB;let y=class extends d.AbstractLogger{constructor(S,t,m,v,b){super();this.name=S,this.resource=t,this.donotUseFormatters=v,this.fileService=b,this.backupIndex=1,this.setLevel(m),this.queue=this._register(new p.Queue),this.initializePromise=this.initialize()}trace(){this.getLevel()<=d.LogLevel.Trace&&this._log(d.LogLevel.Trace,(0,d.format)(arguments))}debug(){this.getLevel()<=d.LogLevel.Debug&&this._log(d.LogLevel.Debug,(0,d.format)(arguments))}info(){this.getLevel()<=d.LogLevel.Info&&this._log(d.LogLevel.Info,(0,d.format)(arguments))}warn(){this.getLevel()<=d.LogLevel.Warning&&this._log(d.LogLevel.Warning,(0,d.format)(arguments))}error(){if(this.getLevel()<=d.LogLevel.Error){const S=arguments[0];if(S instanceof Error){const t=Array.prototype.slice.call(arguments);t[0]=S.stack,this._log(d.LogLevel.Error,(0,d.format)(t))}else this._log(d.LogLevel.Error,(0,d.format)(arguments))}}critical(){this.getLevel()<=d.LogLevel.Critical&&this._log(d.LogLevel.Critical,(0,d.format)(arguments))}flush(){}async initialize(){try{await this.fileService.createFile(this.resource)}catch(S){if(S.fileOperationResult!==3)throw S}}_log(S,t){this.queue.queue(async()=>{await this.initializePromise;let m=await this.loadContent();m.length>f&&(await this.fileService.writeFile(this.getBackupResource(),R.VSBuffer.fromString(m)),m=""),this.donotUseFormatters?m+=t:m+=`[${this.getCurrentTimestamp()}] [${this.name}] [${this.stringifyLogLevel(S)}] ${t}
`,await this.fileService.writeFile(this.resource,R.VSBuffer.fromString(m))})}getCurrentTimestamp(){const S=v=>v<10?`0${v}`:v,t=v=>v<10?`00${v}`:v<100?`0${v}`:v,m=new Date;return`${m.getFullYear()}-${S(m.getMonth()+1)}-${S(m.getDate())} ${S(m.getHours())}:${S(m.getMinutes())}:${S(m.getSeconds())}.${t(m.getMilliseconds())}`}getBackupResource(){return this.backupIndex=this.backupIndex>5?1:this.backupIndex,(0,C.joinPath)((0,C.dirname)(this.resource),`${(0,C.basename)(this.resource)}_${this.backupIndex++}`)}async loadContent(){try{return(await this.fileService.readFile(this.resource)).value.toString()}catch(S){return""}}stringifyLogLevel(S){switch(S){case d.LogLevel.Critical:return"critical";case d.LogLevel.Debug:return"debug";case d.LogLevel.Error:return"error";case d.LogLevel.Info:return"info";case d.LogLevel.Trace:return"trace";case d.LogLevel.Warning:return"warning"}return""}};y=fe([te(4,k.IFileService)],y),e.FileLogger=y;let E=class extends d.AbstractLoggerService{constructor(S,t,m){super(S.getLevel(),S.onDidChangeLogLevel);this.instantiationService=t,this.fileService=m}doCreateLogger(S,t,m){const v=new I.BufferLogService(t);return(0,k.whenProviderRegistered)(S,this.fileService).then(()=>v.logger=this.instantiationService.createInstance(y,m?.name||(0,C.basename)(S),S,v.getLevel(),!!m?.donotUseFormatters)),v}};E=fe([te(0,d.ILogService),te(1,n.IInstantiationService),te(2,k.IFileService)],E),e.FileLoggerService=E}),define(x[185],ee([0,1,4,7,6]),function(V,e,p,R,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FollowerLogService=e.LoggerChannelClient=e.LoggerChannel=e.LogLevelChannelClient=e.LogLevelChannel=void 0;class k{constructor(g){this.service=g,this.onDidChangeLogLevel=p.Event.buffer(g.onDidChangeLogLevel,!0)}listen(g,S){switch(S){case"onDidChangeLogLevel":return this.onDidChangeLogLevel}throw new Error(`Event not found: ${S}`)}async call(g,S,t){switch(S){case"setLevel":return this.service.setLevel(t)}throw new Error(`Call not found: ${S}`)}}e.LogLevelChannel=k;class n{constructor(g){this.channel=g}get onDidChangeLogLevel(){return this.channel.listen("onDidChangeLogLevel")}setLevel(g){n.setLevel(this.channel,g)}static setLevel(g,S){return g.call("setLevel",S)}}e.LogLevelChannelClient=n;class I{constructor(g){this.loggerService=g,this.loggers=new Map}listen(g,S){throw new Error(`Event not found: ${S}`)}async call(g,S,t){switch(S){case"createLogger":this.createLogger(R.URI.revive(t[0]),t[1]);return;case"log":return this.log(R.URI.revive(t[0]),t[1]);case"consoleLog":return this.consoleLog(t[0],t[1])}throw new Error(`Call not found: ${S}`)}createLogger(g,S){this.loggers.set(g.toString(),this.loggerService.createLogger(g,S))}consoleLog(g,S){let t=console.log;switch(g){case C.LogLevel.Error:t=console.error;break;case C.LogLevel.Warning:t=console.warn;break;case C.LogLevel.Info:t=console.info;break}t.call(console,...S)}log(g,S){const t=this.loggers.get(g.toString());if(!t)throw new Error("Create the logger before logging");for(const[m,v]of S)(0,C.log)(t,m,v)}}e.LoggerChannel=I;class d extends C.AbstractLoggerService{constructor(g,S,t){super(g,S);this.channel=t}createConsoleMainLogger(){return new C.AdapterLogger({log:(g,S)=>{this.channel.call("consoleLog",[g,S])}})}doCreateLogger(g,S,t){return new f(this.channel,g,S,t)}}e.LoggerChannelClient=d;class f extends C.AbstractMessageLogger{constructor(g,S,t,m){super(m?.always);this.channel=g,this.file=S,this.isLoggerCreated=!1,this.buffer=[],this.setLevel(t),this.channel.call("createLogger",[S,m]).then(()=>{this.doLog(this.buffer),this.isLoggerCreated=!0})}log(g,S){const t=[[g,S]];this.isLoggerCreated?this.doLog(t):this.buffer.push(...t)}doLog(g){this.channel.call("log",[this.file,g])}}class y extends C.LogService{constructor(g,S){super(S);this.parent=g,this._register(g.onDidChangeLogLevel(t=>S.setLevel(t)))}setLevel(g){super.setLevel(g),this.parent.setLevel(g)}}e.FollowerLogService=y}),define(x[96],ee([0,1,19,6]),function(V,e,p,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SpdLogLogger=void 0;async function C(I,d,f,y,E){try{const g=await new Promise((t,m)=>{V(["spdlog"],t,m)});g.setFlushOn(R.LogLevel.Trace);const S=await g.createAsyncRotatingLogger(I,d,f,y);return E&&S.clearFormatters(),S}catch(g){console.error(g)}return null}function k(I,d,f){switch(d){case R.LogLevel.Trace:I.trace(f);break;case R.LogLevel.Debug:I.debug(f);break;case R.LogLevel.Info:I.info(f);break;case R.LogLevel.Warning:I.warn(f);break;case R.LogLevel.Error:I.error(f);break;case R.LogLevel.Critical:I.critical(f);break;default:throw new Error("Invalid log level")}}class n extends R.AbstractMessageLogger{constructor(d,f,y,E,g){super();this.buffer=[],this.setLevel(g),this._loggerCreationPromise=this._createSpdLogLogger(d,f,y,E),this._register(this.onDidChangeLogLevel(S=>{this._logger&&this._logger.setLevel(S)}))}async _createSpdLogLogger(d,f,y,E){const g=y?6:1,S=30/g*p.ByteSize.MB,t=await C(d,f,S,g,E);if(t){this._logger=t,this._logger.setLevel(this.getLevel());for(const{level:m,message:v}of this.buffer)k(this._logger,m,v);this.buffer=[]}}log(d,f){this._logger?k(this._logger,d,f):this.getLevel()<=d&&this.buffer.push({level:d,message:f})}flush(){this._logger?this._logger.flush():this._loggerCreationPromise.then(()=>this.flush())}dispose(){this._logger?this.disposeLogger():this._loggerCreationPromise.then(()=>this.disposeLogger())}disposeLogger(){this._logger&&(this._logger.drop(),this._logger=void 0)}}e.SpdLogLogger=n}),define(x[186],ee([0,1,10,15,31,19,184,6,96]),function(V,e,p,R,C,k,n,I,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LoggerService=void 0;let f=class extends I.AbstractLoggerService{constructor(E,g){super(E.getLevel(),E.onDidChangeLogLevel);this.fileService=g}doCreateLogger(E,g,S){return E.scheme===p.Schemas.file?new d.SpdLogLogger(S?.name||(0,C.generateUuid)(),E.fsPath,!S?.donotRotate,!!S?.donotUseFormatters,g):new n.FileLogger(S?.name??(0,R.basename)(E),E,g,!!S?.donotUseFormatters,this.fileService)}};f=fe([te(0,I.ILogService),te(1,k.IFileService)],f),e.LoggerService=f}),define(x[187],ee([0,1]),function(V,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isMenubarMenuItemAction=e.isMenubarMenuItemRecentAction=e.isMenubarMenuItemSeparator=e.isMenubarMenuItemSubmenu=void 0;function p(n){return n.submenu!==void 0}e.isMenubarMenuItemSubmenu=p;function R(n){return n.id==="vscode.menubar.separator"}e.isMenubarMenuItemSeparator=R;function C(n){return n.uri!==void 0}e.isMenubarMenuItemRecentAction=C;function k(n){return!p(n)&&!R(n)&&!C(n)}e.isMenubarMenuItemAction=k}),define(x[55],ee([0,1,10,3,34,15]),function(V,e,p,R,C,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0});let n;if(typeof R.globals.vscode!="undefined"&&typeof R.globals.vscode.context!="undefined"){const I=R.globals.vscode.context.configuration();if(I)n=I.product;else throw new Error("Sandbox: unable to resolve product configuration from preload script.")}else if(typeof V?.__$__nodeRequire=="function"){const I=(0,k.dirname)(p.FileAccess.asFileUri("",V));n=V.__$__nodeRequire((0,k.joinPath)(I,"product.json").fsPath);const d=V.__$__nodeRequire((0,k.joinPath)(I,"package.json").fsPath);C.env.VSCODE_DEV&&Object.assign(n,{nameShort:`${n.nameShort} Dev`,nameLong:`${n.nameLong} Dev`,dataFolderName:`${n.dataFolderName}-dev`}),Object.assign(n,{version:d.version})}else n={},Object.keys(n).length===0&&Object.assign(n,{version:"1.63.0-dev",nameShort:"Code - OSS Dev",nameLong:"Code - OSS Dev",applicationName:"code-oss",dataFolderName:".vscode-oss",urlProtocol:"code-oss",reportIssueUrl:"https://github.com/microsoft/vscode/issues/new",licenseName:"MIT",licenseUrl:"https://github.com/microsoft/vscode/blob/main/LICENSE.txt",extensionAllowedProposedApi:["ms-vscode.vscode-js-profile-flame","ms-vscode.vscode-js-profile-table","GitHub.remotehub","GitHub.remotehub-insiders"]});e.default=n}),define(x[22],ee([0,1,5]),function(V,e,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IProductService=void 0,e.IProductService=(0,p.createDecorator)("productService")}),define(x[188],ee([0,1,61,6,22]),function(V,e,p,R,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionUrlTrustService=void 0;let k=class{constructor(I,d){this.productService=I,this.logService=d,this.trustedExtensionUrlPublicKeys=new Map}async isExtensionUrlTrusted(I,d){if(!this.productService.trustedExtensionUrlPublicKeys)return this.logService.trace("ExtensionUrlTrustService#isExtensionUrlTrusted","There are no configured trusted keys"),!1;const f=/^(.*)#([^#]+)$/.exec(d);if(!f)return this.logService.trace("ExtensionUrlTrustService#isExtensionUrlTrusted","Uri has no fragment",d),!1;const[,y,E]=f;let g=this.trustedExtensionUrlPublicKeys.get(I);if(!g){if(g=this.productService.trustedExtensionUrlPublicKeys[I],!g||g.length===0)return this.logService.trace("ExtensionUrlTrustService#isExtensionUrlTrusted","Extension doesn't have any trusted keys",I),!1;this.trustedExtensionUrlPublicKeys.set(I,[...g])}const S=Buffer.from(decodeURIComponent(E),"base64");if(S.length<=6)return this.logService.trace("ExtensionUrlTrustService#isExtensionUrlTrusted","Uri fragment is not a signature",d),!1;const t=S.slice(0,6),m=S.readUIntBE(0,6),v=Date.now()-m;if(v<0||v>36e5)return this.logService.trace("ExtensionUrlTrustService#isExtensionUrlTrusted","Signed uri has expired",d),!1;const b=S.slice(6),P=p.createVerify("SHA256");P.write(t),P.write(Buffer.from(y)),P.end();for(let c=0;c<g.length;c++){let a=g[c];if(a!==null){if(typeof a=="string")try{a=p.createPublicKey({key:Buffer.from(a,"base64"),format:"der",type:"spki"}),g[c]=a}catch(l){this.logService.warn("ExtensionUrlTrustService#isExtensionUrlTrusted",`Failed to parse trusted extension uri public key #${c+1} for ${I}:`,l),g[c]=null;continue}if(P.verify(a,b))return this.logService.trace("ExtensionUrlTrustService#isExtensionUrlTrusted","Signed uri is valid",d),!0}}return this.logService.trace("ExtensionUrlTrustService#isExtensionUrlTrusted","Signed uri could not be verified",d),!1}};k=fe([te(0,C.IProductService),te(1,R.ILogService)],k),e.ExtensionUrlTrustService=k}),define(x[56],ee([0,1,5]),function(V,e,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IProtocolMainService=void 0,e.IProtocolMainService=(0,p.createDecorator)("protocolMainService")}),define(x[189],ee([0,1,14,2,39,10,3,15,7,31,48,6]),function(V,e,p,R,C,k,n,I,d,f,y,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ProtocolMainService=void 0;let g=class extends R.Disposable{constructor(t,m){super();this.logService=m,this.validRoots=C.TernarySearchTree.forUris(()=>!n.isLinux),this.validExtensions=new Set([".svg",".png",".jpg",".jpeg",".gif",".bmp"]),this.addValidFileRoot(d.URI.file(t.appRoot)),this.addValidFileRoot(d.URI.file(t.extensionsPath)),this.addValidFileRoot(t.globalStorageHome),this.addValidFileRoot(t.workspaceStorageHome),this.handleProtocols()}handleProtocols(){const{defaultSession:t}=p.session;t.protocol.registerFileProtocol(k.Schemas.vscodeFileResource,(m,v)=>this.handleResourceRequest(m,v)),t.protocol.interceptFileProtocol(k.Schemas.file,(m,v)=>this.handleFileRequest(m,v)),this._register((0,R.toDisposable)(()=>{t.protocol.unregisterProtocol(k.Schemas.vscodeFileResource),t.protocol.uninterceptProtocol(k.Schemas.file)}))}addValidFileRoot(t){return this.validRoots.get(t)?R.Disposable.None:(this.validRoots.set(t,!0),(0,R.toDisposable)(()=>this.validRoots.delete(t)))}handleFileRequest(t,m){const v=d.URI.parse(t.url);return this.logService.error(`Refused to load resource ${v.fsPath} from ${k.Schemas.file}: protocol (original URL: ${t.url})`),m({error:-3})}handleResourceRequest(t,m){const v=d.URI.parse(t.url),b=k.FileAccess.asFileUri(v);return this.validRoots.findSubstr(b)?m({path:b.fsPath}):this.validExtensions.has((0,I.extname)(b))?m({path:b.fsPath}):(this.logService.error(`${k.Schemas.vscodeFileResource}: Refused to load resource ${b.fsPath} from ${k.Schemas.vscodeFileResource}: protocol (original URL: ${t.url})`),m({error:-3}))}createIPCObjectUrl(){let t;const m=d.URI.from({scheme:"vscode",path:(0,f.generateUuid)()}),v=m.toString(),b=async()=>t;return p.ipcMain.handle(v,b),this.logService.trace(`IPC Object URL: Registered new channel ${v}.`),{resource:m,update:P=>t=P,dispose:()=>{this.logService.trace(`IPC Object URL: Removed channel ${v}.`),p.ipcMain.removeHandler(v)}}}};g=fe([te(0,y.INativeEnvironmentService),te(1,E.ILogService)],g),e.ProtocolMainService=g}),define(x[40],ee([0,1,104,13]),function(V,e,p,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Registry=void 0;class C{constructor(){this.data=new Map}add(n,I){p.ok(R.isString(n)),p.ok(R.isObject(I)),p.ok(!this.data.has(n),"There is already an extension with this id"),this.data.set(n,I)}knows(n){return this.data.has(n)}as(n){return this.data.get(n)||null}}e.Registry=new C}),define(x[190],ee([0,1,4,40]),function(V,e,p,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Extensions=void 0,e.Extensions={JSONContribution:"base.contributions.json"};function C(I){return I.length>0&&I.charAt(I.length-1)==="#"?I.substring(0,I.length-1):I}class k{constructor(){this._onDidChangeSchema=new p.Emitter,this.onDidChangeSchema=this._onDidChangeSchema.event,this.schemasById={}}registerSchema(d,f){this.schemasById[C(d)]=f,this._onDidChangeSchema.fire(d)}notifySchemaChanged(d){this._onDidChangeSchema.fire(d)}getSchemaContributions(){return{schemas:this.schemasById}}}const n=new k;R.Registry.add(e.Extensions.JSONContribution,n)}),define(x[57],ee([0,1,30,4,13,135,190,40]),function(V,e,p,R,C,k,n,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getScopes=e.validateProperty=e.getDefaultValue=e.keyFromOverrideIdentifiers=e.overrideIdentifiersFromKey=e.OVERRIDE_PROPERTY_REGEX=e.OVERRIDE_PROPERTY_PATTERN=e.configurationDefaultsSchemaId=e.resourceLanguageSettingsSchemaId=e.resourceSettings=e.windowSettings=e.machineOverridableSettings=e.machineSettings=e.applicationSettings=e.allSettings=e.ConfigurationScope=e.Extensions=e.EditPresentationTypes=void 0;var d;(function(a){a.Multiline="multilineText",a.Singleline="singlelineText"})(d=e.EditPresentationTypes||(e.EditPresentationTypes={})),e.Extensions={Configuration:"base.contributions.configuration"};var f;(function(a){a[a.APPLICATION=1]="APPLICATION",a[a.MACHINE=2]="MACHINE",a[a.WINDOW=3]="WINDOW",a[a.RESOURCE=4]="RESOURCE",a[a.LANGUAGE_OVERRIDABLE=5]="LANGUAGE_OVERRIDABLE",a[a.MACHINE_OVERRIDABLE=6]="MACHINE_OVERRIDABLE"})(f=e.ConfigurationScope||(e.ConfigurationScope={})),e.allSettings={properties:{},patternProperties:{}},e.applicationSettings={properties:{},patternProperties:{}},e.machineSettings={properties:{},patternProperties:{}},e.machineOverridableSettings={properties:{},patternProperties:{}},e.windowSettings={properties:{},patternProperties:{}},e.resourceSettings={properties:{},patternProperties:{}},e.resourceLanguageSettingsSchemaId="vscode://schemas/settings/resourceLanguage",e.configurationDefaultsSchemaId="vscode://schemas/settings/configurationDefaults";const y=I.Registry.as(n.Extensions.JSONContribution);class E{constructor(){this.overrideIdentifiers=new Set,this._onDidSchemaChange=new R.Emitter,this.onDidSchemaChange=this._onDidSchemaChange.event,this._onDidUpdateConfiguration=new R.Emitter,this.onDidUpdateConfiguration=this._onDidUpdateConfiguration.event,this.configurationDefaultsOverrides=new Map,this.defaultLanguageConfigurationOverridesNode={id:"defaultOverrides",title:k.localize(0,null),properties:{}},this.configurationContributors=[this.defaultLanguageConfigurationOverridesNode],this.resourceLanguageSettingsSchema={properties:{},patternProperties:{},additionalProperties:!1,errorMessage:"Unknown editor configuration setting",allowTrailingCommas:!0,allowComments:!0},this.configurationProperties={},this.excludedConfigurationProperties={},y.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this.registerOverridePropertyPatternKey()}registerConfiguration(l,o=!0){this.registerConfigurations([l],o)}registerConfigurations(l,o=!0){const u=this.doRegisterConfigurations(l,o);y.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:u})}deregisterConfigurations(l){const o=this.doDeregisterConfigurations(l);y.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:o})}updateConfigurations({add:l,remove:o}){const u=[];u.push(...this.doDeregisterConfigurations(o)),u.push(...this.doRegisterConfigurations(l,!1)),y.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:(0,p.distinct)(u)})}registerDefaultConfigurations(l){const o=[],u=[];for(const{overrides:r,source:i}of l)for(const s in r)if(o.push(s),e.OVERRIDE_PROPERTY_REGEX.test(s)){const h={...this.configurationDefaultsOverrides.get(s)?.value||{},...r[s]};this.configurationDefaultsOverrides.set(s,{source:i,value:h});const w={type:"object",default:h,description:k.localize(1,null,s),$ref:e.resourceLanguageSettingsSchemaId,defaultDefaultValue:h,source:C.isString(i)?void 0:i};u.push(...t(s)),this.configurationProperties[s]=w,this.defaultLanguageConfigurationOverridesNode.properties[s]=w}else{this.configurationDefaultsOverrides.set(s,{value:r[s],source:i});const h=this.configurationProperties[s];h&&(this.updatePropertyDefaultValue(s,h),this.updateSchema(s,h))}this.registerOverrideIdentifiers(u),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:o,defaultsOverrides:!0})}deregisterDefaultConfigurations(l){const o=[];for(const{overrides:u,source:r}of l)for(const i in u){const s=this.configurationDefaultsOverrides.get(i),h=C.isString(r)?r:r?.id,w=C.isString(s?.source)?s?.source:s?.source?.id;if(h===w)if(o.push(i),this.configurationDefaultsOverrides.delete(i),e.OVERRIDE_PROPERTY_REGEX.test(i))delete this.configurationProperties[i],delete this.defaultLanguageConfigurationOverridesNode.properties[i];else{const M=this.configurationProperties[i];M&&(this.updatePropertyDefaultValue(i,M),this.updateSchema(i,M))}}this.updateOverridePropertyPatternKey(),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:o,defaultsOverrides:!0})}notifyConfigurationSchemaUpdated(...l){this._onDidSchemaChange.fire()}registerOverrideIdentifiers(l){for(const o of l)this.overrideIdentifiers.add(o);this.updateOverridePropertyPatternKey()}doRegisterConfigurations(l,o){const u=[];return l.forEach(r=>{u.push(...this.validateAndRegisterProperties(r,o,r.extensionInfo,r.restrictedProperties)),this.configurationContributors.push(r),this.registerJSONConfiguration(r)}),u}doDeregisterConfigurations(l){const o=[],u=r=>{if(r.properties)for(const i in r.properties)o.push(i),delete this.configurationProperties[i],this.removeFromSchema(i,r.properties[i]);r.allOf&&r.allOf.forEach(i=>u(i))};for(const r of l){u(r);const i=this.configurationContributors.indexOf(r);i!==-1&&this.configurationContributors.splice(i,1)}return o}validateAndRegisterProperties(l,o=!0,u,r,i=3){i=C.isUndefinedOrNull(l.scope)?i:l.scope;let s=[],h=l.properties;if(h)for(let M in h){if(o&&P(M)){delete h[M];continue}const A=h[M];if(A.source=u,A.defaultDefaultValue=h[M].default,this.updatePropertyDefaultValue(M,A),e.OVERRIDE_PROPERTY_REGEX.test(M)?A.scope=void 0:(A.scope=C.isUndefinedOrNull(A.scope)?i:A.scope,A.restricted=C.isUndefinedOrNull(A.restricted)?!!r?.includes(M):A.restricted),h[M].hasOwnProperty("included")&&!h[M].included){this.excludedConfigurationProperties[M]=h[M],delete h[M];continue}else this.configurationProperties[M]=h[M];!h[M].deprecationMessage&&h[M].markdownDeprecationMessage&&(h[M].deprecationMessage=h[M].markdownDeprecationMessage),s.push(M)}let w=l.allOf;if(w)for(let M of w)s.push(...this.validateAndRegisterProperties(M,o,u,r,i));return s}getConfigurations(){return this.configurationContributors}getConfigurationProperties(){return this.configurationProperties}getExcludedConfigurationProperties(){return this.excludedConfigurationProperties}getConfigurationDefaultsOverrides(){return this.configurationDefaultsOverrides}registerJSONConfiguration(l){const o=u=>{let r=u.properties;if(r)for(const s in r)this.updateSchema(s,r[s]);let i=u.allOf;i&&i.forEach(o)};o(l)}updateSchema(l,o){switch(e.allSettings.properties[l]=o,o.scope){case 1:e.applicationSettings.properties[l]=o;break;case 2:e.machineSettings.properties[l]=o;break;case 6:e.machineOverridableSettings.properties[l]=o;break;case 3:e.windowSettings.properties[l]=o;break;case 4:e.resourceSettings.properties[l]=o;break;case 5:e.resourceSettings.properties[l]=o,this.resourceLanguageSettingsSchema.properties[l]=o;break}}removeFromSchema(l,o){switch(delete e.allSettings.properties[l],o.scope){case 1:delete e.applicationSettings.properties[l];break;case 2:delete e.machineSettings.properties[l];break;case 6:delete e.machineOverridableSettings.properties[l];break;case 3:delete e.windowSettings.properties[l];break;case 4:case 5:delete e.resourceSettings.properties[l],delete this.resourceLanguageSettingsSchema.properties[l];break}}updateOverridePropertyPatternKey(){for(const l of this.overrideIdentifiers.values()){const o=`[${l}]`,u={type:"object",description:k.localize(2,null),errorMessage:k.localize(3,null),$ref:e.resourceLanguageSettingsSchemaId};this.updatePropertyDefaultValue(o,u),e.allSettings.properties[o]=u,e.applicationSettings.properties[o]=u,e.machineSettings.properties[o]=u,e.machineOverridableSettings.properties[o]=u,e.windowSettings.properties[o]=u,e.resourceSettings.properties[o]=u}this._onDidSchemaChange.fire()}registerOverridePropertyPatternKey(){const l={type:"object",description:k.localize(4,null),errorMessage:k.localize(5,null),$ref:e.resourceLanguageSettingsSchemaId};e.allSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=l,e.applicationSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=l,e.machineSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=l,e.machineOverridableSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=l,e.windowSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=l,e.resourceSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=l,this._onDidSchemaChange.fire()}updatePropertyDefaultValue(l,o){const u=this.configurationDefaultsOverrides.get(l);let r=u?.value,i=u?.source;C.isUndefined(r)&&(r=o.defaultDefaultValue,i=void 0),C.isUndefined(r)&&(r=v(o.type)),o.default=r,o.defaultValueSource=i}}const g="\\[([^\\]]+)\\]",S=new RegExp(g,"g");e.OVERRIDE_PROPERTY_PATTERN=`^(${g})+$`,e.OVERRIDE_PROPERTY_REGEX=new RegExp(e.OVERRIDE_PROPERTY_PATTERN);function t(a){const l=[];if(e.OVERRIDE_PROPERTY_REGEX.test(a)){let o=S.exec(a);for(;o?.length;){const u=o[1].trim();u&&l.push(u),o=S.exec(a)}}return(0,p.distinct)(l)}e.overrideIdentifiersFromKey=t;function m(a){return a.reduce((l,o)=>`${l}[${o}]`,"")}e.keyFromOverrideIdentifiers=m;function v(a){switch(Array.isArray(a)?a[0]:a){case"boolean":return!1;case"integer":case"number":return 0;case"string":return"";case"array":return[];case"object":return{};default:return null}}e.getDefaultValue=v;const b=new E;I.Registry.add(e.Extensions.Configuration,b);function P(a){return a.trim()?e.OVERRIDE_PROPERTY_REGEX.test(a)?k.localize(7,null,a):b.getConfigurationProperties()[a]!==void 0?k.localize(8,null,a):null:k.localize(6,null)}e.validateProperty=P;function c(){const a=[],l=b.getConfigurationProperties();for(const o of Object.keys(l))a.push([o,l[o].scope]);return a.push(["launch",4]),a.push(["task",4]),a}e.getScopes=c}),define(x[191],ee([0,1,30,4,38,2,39,47,13,7,18,57,40]),function(V,e,p,R,C,k,n,I,d,f,y,E,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AllKeysConfigurationChangeEvent=e.ConfigurationChangeEvent=e.mergeChanges=e.Configuration=e.UserSettings=e.ConfigurationModelParser=e.DefaultConfigurationModel=e.ConfigurationModel=void 0;class S{constructor(r={},i=[],s=[]){this._contents=r,this._keys=i,this._overrides=s,this.isFrozen=!1,this.overrideConfigurations=new Map}get contents(){return this.checkAndFreeze(this._contents)}get overrides(){return this.checkAndFreeze(this._overrides)}get keys(){return this.checkAndFreeze(this._keys)}isEmpty(){return this._keys.length===0&&Object.keys(this._contents).length===0&&this._overrides.length===0}getValue(r){return r?(0,y.getConfigurationValue)(this.contents,r):this.contents}getOverrideValue(r,i){const s=this.getContentsForOverrideIdentifer(i);return s?r?(0,y.getConfigurationValue)(s,r):s:void 0}getKeysForOverrideIdentifier(r){const i=[];for(const s of this.overrides)s.identifiers.includes(r)&&i.push(...s.keys);return p.distinct(i)}getAllOverrideIdentifiers(){const r=[];for(const i of this.overrides)r.push(...i.identifiers);return p.distinct(r)}override(r){let i=this.overrideConfigurations.get(r);return i||(i=this.createOverrideConfigurationModel(r),this.overrideConfigurations.set(r,i)),i}merge(...r){const i=I.deepClone(this.contents),s=I.deepClone(this.overrides),h=[...this.keys];for(const w of r){this.mergeContents(i,w.contents);for(const M of w.overrides){const[A]=s.filter(L=>p.equals(L.identifiers,M.identifiers));A?(this.mergeContents(A.contents,M.contents),A.keys.push(...M.keys),A.keys=p.distinct(A.keys)):s.push(I.deepClone(M))}for(const M of w.keys)h.indexOf(M)===-1&&h.push(M)}return new S(i,h,s)}freeze(){return this.isFrozen=!0,this}createOverrideConfigurationModel(r){const i=this.getContentsForOverrideIdentifer(r);if(!i||typeof i!="object"||!Object.keys(i).length)return this;let s={};for(const h of p.distinct([...Object.keys(this.contents),...Object.keys(i)])){let w=this.contents[h],M=i[h];M&&(typeof w=="object"&&typeof M=="object"?(w=I.deepClone(w),this.mergeContents(w,M)):w=M),s[h]=w}return new S(s,this.keys,this.overrides)}mergeContents(r,i){for(const s of Object.keys(i)){if(s in r&&d.isObject(r[s])&&d.isObject(i[s])){this.mergeContents(r[s],i[s]);continue}r[s]=I.deepClone(i[s])}}checkAndFreeze(r){return this.isFrozen&&!Object.isFrozen(r)?I.deepFreeze(r):r}getContentsForOverrideIdentifer(r){let i=null,s=null;const h=w=>{w&&(s?this.mergeContents(s,w):s=I.deepClone(w))};for(const w of this.overrides)p.equals(w.identifiers,[r])?i=w.contents:w.identifiers.includes(r)&&h(w.contents);return h(i),s}toJSON(){return{contents:this.contents,overrides:this.overrides,keys:this.keys}}setValue(r,i){this.addKey(r),(0,y.addToValueTree)(this.contents,r,i,s=>{throw new Error(s)})}removeValue(r){this.removeKey(r)&&(0,y.removeFromValueTree)(this.contents,r)}addKey(r){let i=this.keys.length;for(let s=0;s<i;s++)r.indexOf(this.keys[s])===0&&(i=s);this.keys.splice(i,1,r)}removeKey(r){let i=this.keys.indexOf(r);return i!==-1?(this.keys.splice(i,1),!0):!1}}e.ConfigurationModel=S;class t extends S{constructor(r={}){const i=g.Registry.as(E.Extensions.Configuration).getConfigurationProperties(),s=Object.keys(i),h=Object.create(null),w=[];for(const M in i){const A=r[M],L=A!==void 0?A:i[M].default;(0,y.addToValueTree)(h,M,L,F=>console.error(`Conflict in default settings: ${F}`))}for(const M of Object.keys(h))E.OVERRIDE_PROPERTY_REGEX.test(M)&&w.push({identifiers:(0,E.overrideIdentifiersFromKey)(M),keys:Object.keys(h[M]),contents:(0,y.toValuesTree)(h[M],A=>console.error(`Conflict in default settings file: ${A}`))});super(h,s,w)}}e.DefaultConfigurationModel=t;class m{constructor(r){this._name=r,this._raw=null,this._configurationModel=null,this._restrictedConfigurations=[],this._parseErrors=[]}get configurationModel(){return this._configurationModel||new S}get restrictedConfigurations(){return this._restrictedConfigurations}get errors(){return this._parseErrors}parse(r,i){if(!d.isUndefinedOrNull(r)){const s=this.doParseContent(r);this.parseRaw(s,i)}}reparse(r){this._raw&&this.parseRaw(this._raw,r)}parseRaw(r,i){this._raw=r;const{contents:s,keys:h,overrides:w,restricted:M}=this.doParseRaw(r,i);this._configurationModel=new S(s,h,w),this._restrictedConfigurations=M||[]}doParseContent(r){let i={},s=null,h=[],w=[],M=[];function A(F){Array.isArray(h)?h.push(F):s!==null&&(h[s]=F)}let L={onObjectBegin:()=>{let F={};A(F),w.push(h),h=F,s=null},onObjectProperty:F=>{s=F},onObjectEnd:()=>{h=w.pop()},onArrayBegin:()=>{let F=[];A(F),w.push(h),h=F,s=null},onArrayEnd:()=>{h=w.pop()},onLiteralValue:A,onError:(F,U,Y)=>{M.push({error:F,offset:U,length:Y})}};if(r)try{C.visit(r,L),i=h[0]||{}}catch(F){console.error(`Error while parsing settings file ${this._name}: ${F}`),this._parseErrors=[F]}return i}doParseRaw(r,i){const s=g.Registry.as(E.Extensions.Configuration).getConfigurationProperties(),h=this.filter(r,s,!0,i);r=h.raw;const w=(0,y.toValuesTree)(r,L=>console.error(`Conflict in settings file ${this._name}: ${L}`)),M=Object.keys(r),A=this.toOverrides(r,L=>console.error(`Conflict in settings file ${this._name}: ${L}`));return{contents:w,keys:M,overrides:A,restricted:h.restricted}}filter(r,i,s,h){if(!h?.scopes&&!h?.skipRestricted)return{raw:r,restricted:[]};const w={},M=[];for(let A in r)if(E.OVERRIDE_PROPERTY_REGEX.test(A)&&s){const L=this.filter(r[A],i,!1,h);w[A]=L.raw,M.push(...L.restricted)}else{const L=i[A],F=L?typeof L.scope!="undefined"?L.scope:3:void 0;L?.restricted&&M.push(A),(F===void 0||h.scopes===void 0||h.scopes.includes(F))&&(h.skipRestricted&&L?.restricted||(w[A]=r[A]))}return{raw:w,restricted:M}}toOverrides(r,i){const s=[];for(const h of Object.keys(r))if(E.OVERRIDE_PROPERTY_REGEX.test(h)){const w={};for(const M in r[h])w[M]=r[h][M];s.push({identifiers:(0,E.overrideIdentifiersFromKey)(h),keys:Object.keys(w),contents:(0,y.toValuesTree)(w,i)})}return s}}e.ConfigurationModelParser=m;class v extends k.Disposable{constructor(r,i,s,h){super();this.userSettingsResource=r,this.scopes=i,this.fileService=h,this._onDidChange=this._register(new R.Emitter),this.onDidChange=this._onDidChange.event,this.parser=new m(this.userSettingsResource.toString()),this.parseOptions={scopes:this.scopes},this._register(this.fileService.watch(s.dirname(this.userSettingsResource))),this._register(this.fileService.watch(this.userSettingsResource)),this._register(R.Event.filter(this.fileService.onDidFilesChange,w=>w.contains(this.userSettingsResource))(()=>this._onDidChange.fire()))}async loadConfiguration(){try{const r=await this.fileService.readFile(this.userSettingsResource);return this.parser.parse(r.value.toString()||"{}",this.parseOptions),this.parser.configurationModel}catch(r){return new S}}reparse(){return this.parser.reparse(this.parseOptions),this.parser.configurationModel}getRestrictedSettings(){return this.parser.restrictedConfigurations}}e.UserSettings=v;class b{constructor(r,i,s=new S,h=new S,w=new n.ResourceMap,M=new S,A=new n.ResourceMap,L=!0){this._defaultConfiguration=r,this._localUserConfiguration=i,this._remoteUserConfiguration=s,this._workspaceConfiguration=h,this._folderConfigurations=w,this._memoryConfiguration=M,this._memoryConfigurationByResource=A,this._freeze=L,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations=new n.ResourceMap,this._userConfiguration=null}getValue(r,i,s){return this.getConsolidateConfigurationModel(i,s).getValue(r)}updateValue(r,i,s={}){let h;s.resource?(h=this._memoryConfigurationByResource.get(s.resource),h||(h=new S,this._memoryConfigurationByResource.set(s.resource,h))):h=this._memoryConfiguration,i===void 0?h.removeValue(r):h.setValue(r,i),s.resource||(this._workspaceConsolidatedConfiguration=null)}inspect(r,i,s){const h=this.getConsolidateConfigurationModel(i,s),w=this.getFolderConfigurationModelForResource(i.resource,s),M=i.resource?this._memoryConfigurationByResource.get(i.resource)||this._memoryConfiguration:this._memoryConfiguration,A=i.overrideIdentifier?this._defaultConfiguration.freeze().override(i.overrideIdentifier).getValue(r):this._defaultConfiguration.freeze().getValue(r),L=i.overrideIdentifier?this.userConfiguration.freeze().override(i.overrideIdentifier).getValue(r):this.userConfiguration.freeze().getValue(r),F=i.overrideIdentifier?this.localUserConfiguration.freeze().override(i.overrideIdentifier).getValue(r):this.localUserConfiguration.freeze().getValue(r),U=i.overrideIdentifier?this.remoteUserConfiguration.freeze().override(i.overrideIdentifier).getValue(r):this.remoteUserConfiguration.freeze().getValue(r),Y=s?i.overrideIdentifier?this._workspaceConfiguration.freeze().override(i.overrideIdentifier).getValue(r):this._workspaceConfiguration.freeze().getValue(r):void 0,ie=w?i.overrideIdentifier?w.freeze().override(i.overrideIdentifier).getValue(r):w.freeze().getValue(r):void 0,re=i.overrideIdentifier?M.override(i.overrideIdentifier).getValue(r):M.getValue(r),K=h.getValue(r),W=p.distinct(p.flatten(h.overrides.map(N=>N.identifiers))).filter(N=>h.getOverrideValue(r,N)!==void 0);return{defaultValue:A,userValue:L,userLocalValue:F,userRemoteValue:U,workspaceValue:Y,workspaceFolderValue:ie,memoryValue:re,value:K,default:A!==void 0?{value:this._defaultConfiguration.freeze().getValue(r),override:i.overrideIdentifier?this._defaultConfiguration.freeze().getOverrideValue(r,i.overrideIdentifier):void 0}:void 0,user:L!==void 0?{value:this.userConfiguration.freeze().getValue(r),override:i.overrideIdentifier?this.userConfiguration.freeze().getOverrideValue(r,i.overrideIdentifier):void 0}:void 0,userLocal:F!==void 0?{value:this.localUserConfiguration.freeze().getValue(r),override:i.overrideIdentifier?this.localUserConfiguration.freeze().getOverrideValue(r,i.overrideIdentifier):void 0}:void 0,userRemote:U!==void 0?{value:this.remoteUserConfiguration.freeze().getValue(r),override:i.overrideIdentifier?this.remoteUserConfiguration.freeze().getOverrideValue(r,i.overrideIdentifier):void 0}:void 0,workspace:Y!==void 0?{value:this._workspaceConfiguration.freeze().getValue(r),override:i.overrideIdentifier?this._workspaceConfiguration.freeze().getOverrideValue(r,i.overrideIdentifier):void 0}:void 0,workspaceFolder:ie!==void 0?{value:w?.freeze().getValue(r),override:i.overrideIdentifier?w?.freeze().getOverrideValue(r,i.overrideIdentifier):void 0}:void 0,memory:re!==void 0?{value:M.getValue(r),override:i.overrideIdentifier?M.getOverrideValue(r,i.overrideIdentifier):void 0}:void 0,overrideIdentifiers:W.length?W:void 0}}keys(r){const i=this.getFolderConfigurationModelForResource(void 0,r);return{default:this._defaultConfiguration.freeze().keys,user:this.userConfiguration.freeze().keys,workspace:this._workspaceConfiguration.freeze().keys,workspaceFolder:i?i.freeze().keys:[]}}updateDefaultConfiguration(r){this._defaultConfiguration=r,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateLocalUserConfiguration(r){this._localUserConfiguration=r,this._userConfiguration=null,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateRemoteUserConfiguration(r){this._remoteUserConfiguration=r,this._userConfiguration=null,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateWorkspaceConfiguration(r){this._workspaceConfiguration=r,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateFolderConfiguration(r,i){this._folderConfigurations.set(r,i),this._foldersConsolidatedConfigurations.delete(r)}deleteFolderConfiguration(r){this.folderConfigurations.delete(r),this._foldersConsolidatedConfigurations.delete(r)}compareAndUpdateDefaultConfiguration(r,i){const s=[];if(!i){const{added:h,updated:w,removed:M}=l(this._defaultConfiguration,r);i=[...h,...w,...M]}for(const h of i)for(const w of(0,E.overrideIdentifiersFromKey)(h)){const M=this._defaultConfiguration.getKeysForOverrideIdentifier(w),A=r.getKeysForOverrideIdentifier(w),L=[...A.filter(F=>M.indexOf(F)===-1),...M.filter(F=>A.indexOf(F)===-1),...M.filter(F=>!I.equals(this._defaultConfiguration.override(w).getValue(F),r.override(w).getValue(F)))];s.push([w,L])}return this.updateDefaultConfiguration(r),{keys:i,overrides:s}}compareAndUpdateLocalUserConfiguration(r){const{added:i,updated:s,removed:h,overrides:w}=l(this.localUserConfiguration,r),M=[...i,...s,...h];return M.length&&this.updateLocalUserConfiguration(r),{keys:M,overrides:w}}compareAndUpdateRemoteUserConfiguration(r){const{added:i,updated:s,removed:h,overrides:w}=l(this.remoteUserConfiguration,r);let M=[...i,...s,...h];return M.length&&this.updateRemoteUserConfiguration(r),{keys:M,overrides:w}}compareAndUpdateWorkspaceConfiguration(r){const{added:i,updated:s,removed:h,overrides:w}=l(this.workspaceConfiguration,r);let M=[...i,...s,...h];return M.length&&this.updateWorkspaceConfiguration(r),{keys:M,overrides:w}}compareAndUpdateFolderConfiguration(r,i){const s=this.folderConfigurations.get(r),{added:h,updated:w,removed:M,overrides:A}=l(s,i);let L=[...h,...w,...M];return(L.length||!s)&&this.updateFolderConfiguration(r,i),{keys:L,overrides:A}}compareAndDeleteFolderConfiguration(r){const i=this.folderConfigurations.get(r);if(!i)throw new Error("Unknown folder");this.deleteFolderConfiguration(r);const{added:s,updated:h,removed:w,overrides:M}=l(i,void 0);return{keys:[...s,...h,...w],overrides:M}}get defaults(){return this._defaultConfiguration}get userConfiguration(){return this._userConfiguration||(this._userConfiguration=this._remoteUserConfiguration.isEmpty()?this._localUserConfiguration:this._localUserConfiguration.merge(this._remoteUserConfiguration),this._freeze&&this._userConfiguration.freeze()),this._userConfiguration}get localUserConfiguration(){return this._localUserConfiguration}get remoteUserConfiguration(){return this._remoteUserConfiguration}get workspaceConfiguration(){return this._workspaceConfiguration}get folderConfigurations(){return this._folderConfigurations}getConsolidateConfigurationModel(r,i){let s=this.getConsolidatedConfigurationModelForResource(r,i);return r.overrideIdentifier?s.override(r.overrideIdentifier):s}getConsolidatedConfigurationModelForResource({resource:r},i){let s=this.getWorkspaceConsolidatedConfiguration();if(i&&r){const h=i.getFolder(r);h&&(s=this.getFolderConsolidatedConfiguration(h.uri)||s);const w=this._memoryConfigurationByResource.get(r);w&&(s=s.merge(w))}return s}getWorkspaceConsolidatedConfiguration(){return this._workspaceConsolidatedConfiguration||(this._workspaceConsolidatedConfiguration=this._defaultConfiguration.merge(this.userConfiguration,this._workspaceConfiguration,this._memoryConfiguration),this._freeze&&(this._workspaceConfiguration=this._workspaceConfiguration.freeze())),this._workspaceConsolidatedConfiguration}getFolderConsolidatedConfiguration(r){let i=this._foldersConsolidatedConfigurations.get(r);if(!i){const s=this.getWorkspaceConsolidatedConfiguration(),h=this._folderConfigurations.get(r);h?(i=s.merge(h),this._freeze&&(i=i.freeze()),this._foldersConsolidatedConfigurations.set(r,i)):i=s}return i}getFolderConfigurationModelForResource(r,i){if(i&&r){const s=i.getFolder(r);if(s)return this._folderConfigurations.get(s.uri)}}toData(){return{defaults:{contents:this._defaultConfiguration.contents,overrides:this._defaultConfiguration.overrides,keys:this._defaultConfiguration.keys},user:{contents:this.userConfiguration.contents,overrides:this.userConfiguration.overrides,keys:this.userConfiguration.keys},workspace:{contents:this._workspaceConfiguration.contents,overrides:this._workspaceConfiguration.overrides,keys:this._workspaceConfiguration.keys},folders:[...this._folderConfigurations.keys()].reduce((r,i)=>{const{contents:s,overrides:h,keys:w}=this._folderConfigurations.get(i);return r.push([i,{contents:s,overrides:h,keys:w}]),r},[])}}allKeys(){const r=new Set;return this._defaultConfiguration.freeze().keys.forEach(i=>r.add(i)),this.userConfiguration.freeze().keys.forEach(i=>r.add(i)),this._workspaceConfiguration.freeze().keys.forEach(i=>r.add(i)),this._folderConfigurations.forEach(i=>i.freeze().keys.forEach(s=>r.add(s))),[...r.values()]}allOverrideIdentifiers(){const r=new Set;return this._defaultConfiguration.freeze().getAllOverrideIdentifiers().forEach(i=>r.add(i)),this.userConfiguration.freeze().getAllOverrideIdentifiers().forEach(i=>r.add(i)),this._workspaceConfiguration.freeze().getAllOverrideIdentifiers().forEach(i=>r.add(i)),this._folderConfigurations.forEach(i=>i.freeze().getAllOverrideIdentifiers().forEach(s=>r.add(s))),[...r.values()]}getAllKeysForOverrideIdentifier(r){const i=new Set;return this._defaultConfiguration.getKeysForOverrideIdentifier(r).forEach(s=>i.add(s)),this.userConfiguration.getKeysForOverrideIdentifier(r).forEach(s=>i.add(s)),this._workspaceConfiguration.getKeysForOverrideIdentifier(r).forEach(s=>i.add(s)),this._folderConfigurations.forEach(s=>s.getKeysForOverrideIdentifier(r).forEach(h=>i.add(h))),[...i.values()]}static parse(r){const i=this.parseConfigurationModel(r.defaults),s=this.parseConfigurationModel(r.user),h=this.parseConfigurationModel(r.workspace),w=r.folders.reduce((M,A)=>(M.set(f.URI.revive(A[0]),this.parseConfigurationModel(A[1])),M),new n.ResourceMap);return new b(i,s,new S,h,w,new S,new n.ResourceMap,!1)}static parseConfigurationModel(r){return new S(r.contents,r.keys,r.overrides).freeze()}}e.Configuration=b;function P(...u){if(u.length===0)return{keys:[],overrides:[]};if(u.length===1)return u[0];const r=new Set,i=new Map;for(const h of u)h.keys.forEach(w=>r.add(w)),h.overrides.forEach(([w,M])=>{const A=(0,n.getOrSet)(i,w,new Set);M.forEach(L=>A.add(L))});const s=[];return i.forEach((h,w)=>s.push([w,[...h.values()]])),{keys:[...r.values()],overrides:s}}e.mergeChanges=P;class c{constructor(r,i,s,h){this.change=r,this.previous=i,this.currentConfiguraiton=s,this.currentWorkspace=h,this._previousConfiguration=void 0;const w=new Set;r.keys.forEach(A=>w.add(A)),r.overrides.forEach(([,A])=>A.forEach(L=>w.add(L))),this.affectedKeys=[...w.values()];const M=new S;this.affectedKeys.forEach(A=>M.setValue(A,{})),this.affectedKeysTree=M.contents}get previousConfiguration(){return!this._previousConfiguration&&this.previous&&(this._previousConfiguration=b.parse(this.previous.data)),this._previousConfiguration}affectsConfiguration(r,i){if(this.doesAffectedKeysTreeContains(this.affectedKeysTree,r)){if(i){const s=this.previousConfiguration?this.previousConfiguration.getValue(r,i,this.previous?.workspace):void 0,h=this.currentConfiguraiton.getValue(r,i,this.currentWorkspace);return!I.equals(s,h)}return!0}return!1}doesAffectedKeysTreeContains(r,i){let s=(0,y.toValuesTree)({[i]:!0},()=>{}),h;for(;typeof s=="object"&&(h=Object.keys(s)[0]);){if(r=r[h],!r)return!1;s=s[h]}return!0}}e.ConfigurationChangeEvent=c;class a extends c{constructor(r,i,s,h){super({keys:r.allKeys(),overrides:[]},void 0,r,i);this.source=s,this.sourceConfig=h}}e.AllKeysConfigurationChangeEvent=a;function l(u,r){const{added:i,removed:s,updated:h}=o(r,u),w=[],M=u?.getAllOverrideIdentifiers()||[],A=r?.getAllOverrideIdentifiers()||[];if(r){const L=A.filter(F=>!M.includes(F));for(const F of L)w.push([F,r.getKeysForOverrideIdentifier(F)])}if(u){const L=M.filter(F=>!A.includes(F));for(const F of L)w.push([F,u.getKeysForOverrideIdentifier(F)])}if(r&&u){for(const L of M)if(A.includes(L)){const F=o({contents:u.getOverrideValue(void 0,L)||{},keys:u.getKeysForOverrideIdentifier(L)},{contents:r.getOverrideValue(void 0,L)||{},keys:r.getKeysForOverrideIdentifier(L)});w.push([L,[...F.added,...F.removed,...F.updated]])}}return{added:i,removed:s,updated:h,overrides:w}}function o(u,r){const i=u?r?u.keys.filter(w=>r.keys.indexOf(w)===-1):[...u.keys]:[],s=r?u?r.keys.filter(w=>u.keys.indexOf(w)===-1):[...r.keys]:[],h=[];if(u&&r){for(const w of r.keys)if(u.keys.indexOf(w)!==-1){const M=(0,y.getConfigurationValue)(r.contents,w),A=(0,y.getConfigurationValue)(u.contents,w);I.equals(M,A)||h.push(w)}}return{added:i,removed:s,updated:h}}}),define(x[192],ee([0,1,9,4,2,15,18,191,57,40]),function(V,e,p,R,C,k,n,I,d,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ConfigurationService=void 0;class y extends C.Disposable{constructor(g,S){super();this.settingsResource=g,this._onDidChangeConfiguration=this._register(new R.Emitter),this.onDidChangeConfiguration=this._onDidChangeConfiguration.event,this.userConfiguration=this._register(new I.UserSettings(this.settingsResource,void 0,k.extUriBiasedIgnorePathCase,S)),this.configuration=new I.Configuration(new I.DefaultConfigurationModel,new I.ConfigurationModel),this.reloadConfigurationScheduler=this._register(new p.RunOnceScheduler(()=>this.reloadConfiguration(),50)),this._register(f.Registry.as(d.Extensions.Configuration).onDidUpdateConfiguration(({properties:t})=>this.onDidDefaultConfigurationChange(t))),this._register(this.userConfiguration.onDidChange(()=>this.reloadConfigurationScheduler.schedule()))}async initialize(){const g=await this.userConfiguration.loadConfiguration();this.configuration=new I.Configuration(new I.DefaultConfigurationModel,g)}getConfigurationData(){return this.configuration.toData()}getValue(g,S){const t=typeof g=="string"?g:void 0,m=(0,n.isConfigurationOverrides)(g)?g:(0,n.isConfigurationOverrides)(S)?S:{};return this.configuration.getValue(t,m,void 0)}updateValue(g,S,t,m){return Promise.reject(new Error("not supported"))}inspect(g){return this.configuration.inspect(g,{},void 0)}keys(){return this.configuration.keys(void 0)}async reloadConfiguration(){const g=await this.userConfiguration.loadConfiguration();this.onDidChangeUserConfiguration(g)}onDidChangeUserConfiguration(g){const S=this.configuration.toData(),t=this.configuration.compareAndUpdateLocalUserConfiguration(g);this.trigger(t,S,1)}onDidDefaultConfigurationChange(g){const S=this.configuration.toData(),t=this.configuration.compareAndUpdateDefaultConfiguration(new I.DefaultConfigurationModel,g);this.trigger(t,S,6)}trigger(g,S,t){const m=new I.ConfigurationChangeEvent(g,{data:S},this.configuration);m.source=t,m.sourceConfig=this.getTargetConfiguration(t),this._onDidChangeConfiguration.fire(m)}getTargetConfiguration(g){switch(g){case 6:return this.configuration.defaults.contents;case 1:return this.configuration.localUserConfiguration.contents}return{}}}e.ConfigurationService=y}),define(x[193],ee([0,1,5]),function(V,e,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RemoteAuthorityResolverError=e.RemoteAuthorityResolverErrorCode=e.IRemoteAuthorityResolverService=void 0,e.IRemoteAuthorityResolverService=(0,p.createDecorator)("remoteAuthorityResolverService");var R;(function(k){k.Unknown="Unknown",k.NotAvailable="NotAvailable",k.TemporarilyNotAvailable="TemporarilyNotAvailable",k.NoResolverFound="NoResolverFound"})(R=e.RemoteAuthorityResolverErrorCode||(e.RemoteAuthorityResolverErrorCode={}));class C extends Error{constructor(n,I=R.Unknown,d){super(n);this._message=n,this._code=I,this._detail=d,this.isHandled=I===R.NotAvailable&&d===!0,typeof Object.setPrototypeOf=="function"&&Object.setPrototypeOf(this,C.prototype)}static isTemporarilyNotAvailable(n){return n instanceof C&&n._code===R.TemporarilyNotAvailable}static isNoResolverFound(n){return n instanceof C&&n._code===R.NoResolverFound}static isHandled(n){return n instanceof C&&n.isHandled}}e.RemoteAuthorityResolverError=C}),define(x[194],ee([0,1,9,17,23,16,4,2,31,84,193]),function(V,e,p,R,C,k,n,I,d,f,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionHostPersistentConnection=e.ManagementPersistentConnection=e.PersistentConnection=e.ReconnectionPermanentFailureEvent=e.ConnectionGainEvent=e.ReconnectionRunningEvent=e.ReconnectionWaitEvent=e.ConnectionLostEvent=e.PersistentConnectionEventType=e.connectRemoteAgentTunnel=e.connectRemoteAgentExtensionHost=e.connectRemoteAgentManagement=e.ConnectionType=void 0;const E=30*1e3;var g;(function(O){O[O.Management=1]="Management",O[O.ExtensionHost=2]="ExtensionHost",O[O.Tunnel=3]="Tunnel"})(g=e.ConnectionType||(e.ConnectionType={}));function S(O){switch(O){case 1:return"Management";case 2:return"ExtensionHost";case 3:return"Tunnel"}}function t(O){const D=new C.CancellationTokenSource;return setTimeout(()=>D.cancel(),O),D.token}function m(O,D){if(O.isCancellationRequested||D.isCancellationRequested)return C.CancellationToken.Cancelled;const T=new C.CancellationTokenSource;return O.onCancellationRequested(()=>T.cancel()),D.onCancellationRequested(()=>T.cancel()),T.token}class v{constructor(D){this._state="pending",this._disposables=new I.DisposableStore,this.promise=new Promise((T,_)=>{this._resolvePromise=T,this._rejectPromise=_}),D.isCancellationRequested?this._timeout():this._disposables.add(D.onCancellationRequested(()=>this._timeout()))}get didTimeout(){return this._state==="timedout"}registerDisposable(D){this._state==="pending"?this._disposables.add(D):D.dispose()}_timeout(){this._state==="pending"&&(this._disposables.dispose(),this._state="timedout",this._rejectPromise(this._createTimeoutError()))}_createTimeoutError(){const D=new Error("Time limit reached");return D.code="ETIMEDOUT",D.syscall="connect",D}resolve(D){this._state==="pending"&&(this._disposables.dispose(),this._state="resolved",this._resolvePromise(D))}reject(D){this._state==="pending"&&(this._disposables.dispose(),this._state="rejected",this._rejectPromise(D))}}function b(O,D){const T=new v(D);return T.registerDisposable(O.onControlMessage(_=>{const z=JSON.parse(_.toString()),X=G(z);X?T.reject(X):T.resolve(z)})),T.promise}function P(O,D,T,_,z,X,B){const q=new v(B);return D.connect(T,_,z,X,(ne,se)=>{q.didTimeout?(ne&&O.error(ne),se?.dispose()):ne||!se?q.reject(ne):q.resolve(se)}),q.promise}function c(O,D){const T=new v(D);return O.then(_=>{T.didTimeout||T.resolve(_)},_=>{T.didTimeout||T.reject(_)}),T.promise}async function a(O,D,T,_){const z=$(O,D);O.logService.trace(`${z} 1/6. invoking socketFactory.connect().`);let X;try{X=await P(O.logService,O.socketFactory,O.host,O.port,`reconnectionToken=${O.reconnectionToken}&reconnection=${O.reconnectionProtocol?"true":"false"}`,`renderer-${S(D)}-${O.reconnectionToken}`,_)}catch(oe){throw O.logService.error(`${z} socketFactory.connect() failed or timed out. Error:`),O.logService.error(oe),oe}O.logService.trace(`${z} 2/6. socketFactory.connect() was successful.`);let B,q;O.reconnectionProtocol?(O.reconnectionProtocol.beginAcceptReconnection(X,null),B=O.reconnectionProtocol,q=!1):(B=new f.PersistentProtocol(X,null),q=!0),O.logService.trace(`${z} 3/6. sending AuthRequest control message.`);const ne=await c(O.signService.createNewMessage((0,d.generateUuid)()),_),se={type:"auth",auth:O.connectionToken||"00000000000000000000",data:ne.data};B.sendControl(R.VSBuffer.fromString(JSON.stringify(se)));try{const oe=await b(B,m(_,t(1e4)));if(oe.type!=="sign"||typeof oe.data!="string"){const ue=new Error("Unexpected handshake message");throw ue.code="VSCODE_CONNECTION_ERROR",ue}if(O.logService.trace(`${z} 4/6. received SignRequest control message.`),!await c(O.signService.validate(ne,oe.signedData),_)){const ue=new Error("Refused to connect to unsupported server");throw ue.code="VSCODE_CONNECTION_ERROR",ue}const ce=await c(O.signService.sign(oe.data),_),le={type:"connectionType",commit:O.commit,signedData:ce,desiredConnectionType:D};return T&&(le.args=T),O.logService.trace(`${z} 5/6. sending ConnectionTypeRequest control message.`),B.sendControl(R.VSBuffer.fromString(JSON.stringify(le))),{protocol:B,ownsProtocol:q}}catch(oe){throw oe&&oe.code==="ETIMEDOUT"&&(O.logService.error(`${z} the handshake timed out. Error:`),O.logService.error(oe)),oe&&oe.code==="VSCODE_CONNECTION_ERROR"&&(O.logService.error(`${z} received error control message when negotiating connection. Error:`),O.logService.error(oe)),q&&N(B),oe}}async function l(O,D,T,_){const z=Date.now(),X=$(O,D),{protocol:B,ownsProtocol:q}=await a(O,D,T,_),ne=new v(_);return ne.registerDisposable(B.onControlMessage(se=>{const oe=JSON.parse(se.toString()),Z=G(oe);Z?(O.logService.error(`${X} received error control message when negotiating connection. Error:`),O.logService.error(Z),q&&N(B),ne.reject(Z)):(O.reconnectionProtocol&&O.reconnectionProtocol.endAcceptReconnection(),O.logService.trace(`${X} 6/6. handshake finished, connection is up and running after ${J(z)}!`),ne.resolve({protocol:B,firstMessage:oe}))})),ne.promise}async function o(O,D){const{protocol:T}=await l(O,1,void 0,D);return{protocol:T}}async function u(O,D,T){const{protocol:_,firstMessage:z}=await l(O,2,D,T),X=z&&z.debugPort;return{protocol:_,debugPort:X}}async function r(O,D,T){const _=Date.now(),z=$(O,3),{protocol:X}=await a(O,3,D,T);return O.logService.trace(`${z} 6/6. handshake finished, connection is up and running after ${J(_)}!`),X}async function i(O,D,T){const{host:_,port:z,connectionToken:X}=await O.addressProvider.getAddress();return{commit:O.commit,host:_,port:z,connectionToken:X,reconnectionToken:D,reconnectionProtocol:T,socketFactory:O.socketFactory,signService:O.signService,logService:O.logService}}async function s(O,D,T){try{const _=(0,d.generateUuid)(),z=await i(O,_,null),{protocol:X}=await o(z,C.CancellationToken.None);return new K(O,D,T,_,X)}catch(_){throw O.logService.error("[remote-connection] An error occurred in the very first connect attempt, it will be treated as a permanent error! Error:"),O.logService.error(_),re.triggerPermanentFailure(0,0,y.RemoteAuthorityResolverError.isHandled(_)),_}}e.connectRemoteAgentManagement=s;async function h(O,D){try{const T=(0,d.generateUuid)(),_=await i(O,T,null),{protocol:z,debugPort:X}=await u(_,D,C.CancellationToken.None);return new W(O,D,T,z,X)}catch(T){throw O.logService.error("[remote-connection] An error occurred in the very first connect attempt, it will be treated as a permanent error! Error:"),O.logService.error(T),re.triggerPermanentFailure(0,0,y.RemoteAuthorityResolverError.isHandled(T)),T}}e.connectRemoteAgentExtensionHost=h;async function w(O,D,T){const _=await i(O,(0,d.generateUuid)(),null);return await r(_,{host:D,port:T},C.CancellationToken.None)}e.connectRemoteAgentTunnel=w;function M(O){return(0,p.createCancelablePromise)(D=>new Promise((T,_)=>{const z=setTimeout(T,O*1e3);D.onCancellationRequested(()=>{clearTimeout(z),T()})}))}var A;(function(O){O[O.ConnectionLost=0]="ConnectionLost",O[O.ReconnectionWait=1]="ReconnectionWait",O[O.ReconnectionRunning=2]="ReconnectionRunning",O[O.ReconnectionPermanentFailure=3]="ReconnectionPermanentFailure",O[O.ConnectionGain=4]="ConnectionGain"})(A=e.PersistentConnectionEventType||(e.PersistentConnectionEventType={}));class L{constructor(D,T){this.reconnectionToken=D,this.millisSinceLastIncomingData=T,this.type=0}}e.ConnectionLostEvent=L;class F{constructor(D,T,_,z){this.reconnectionToken=D,this.millisSinceLastIncomingData=T,this.durationSeconds=_,this.cancellableTimer=z,this.type=1}skipWait(){this.cancellableTimer.cancel()}}e.ReconnectionWaitEvent=F;class U{constructor(D,T,_){this.reconnectionToken=D,this.millisSinceLastIncomingData=T,this.attempt=_,this.type=2}}e.ReconnectionRunningEvent=U;class Y{constructor(D,T,_){this.reconnectionToken=D,this.millisSinceLastIncomingData=T,this.attempt=_,this.type=4}}e.ConnectionGainEvent=Y;class ie{constructor(D,T,_,z){this.reconnectionToken=D,this.millisSinceLastIncomingData=T,this.attempt=_,this.handled=z,this.type=3}}e.ReconnectionPermanentFailureEvent=ie;class re extends I.Disposable{constructor(D,T,_,z){super();this._connectionType=D,this._onDidStateChange=this._register(new n.Emitter),this.onDidStateChange=this._onDidStateChange.event,this._options=T,this.reconnectionToken=_,this.protocol=z,this._isReconnecting=!1,this._onDidStateChange.fire(new Y(this.reconnectionToken,0,0)),this._register(z.onSocketClose(X=>{const B=H(this._connectionType,this.reconnectionToken,!0);X?X.type===0?(this._options.logService.info(`${B} received socket close event (hadError: ${X.hadError}).`),X.error&&this._options.logService.error(X.error)):(this._options.logService.info(`${B} received socket close event (wasClean: ${X.wasClean}, code: ${X.code}, reason: ${X.reason}).`),X.event&&this._options.logService.error(X.event)):this._options.logService.info(`${B} received socket close event.`),this._beginReconnecting()})),this._register(z.onSocketTimeout(()=>{const X=H(this._connectionType,this.reconnectionToken,!0);this._options.logService.info(`${X} received socket timeout event.`),this._beginReconnecting()})),re._instances.push(this),re._permanentFailure&&this._gotoPermanentFailure(re._permanentFailureMillisSinceLastIncomingData,re._permanentFailureAttempt,re._permanentFailureHandled)}static triggerPermanentFailure(D,T,_){this._permanentFailure=!0,this._permanentFailureMillisSinceLastIncomingData=D,this._permanentFailureAttempt=T,this._permanentFailureHandled=_,this._instances.forEach(z=>z._gotoPermanentFailure(this._permanentFailureMillisSinceLastIncomingData,this._permanentFailureAttempt,this._permanentFailureHandled))}static debugTriggerReconnection(){this._instances.forEach(D=>D._beginReconnecting())}static debugPauseSocketWriting(){this._instances.forEach(D=>D._pauseSocketWriting())}async _beginReconnecting(){if(!this._isReconnecting)try{this._isReconnecting=!0,await this._runReconnectingLoop()}finally{this._isReconnecting=!1}}async _runReconnectingLoop(){if(re._permanentFailure)return;const D=H(this._connectionType,this.reconnectionToken,!0);this._options.logService.info(`${D} starting reconnecting loop. You can get more information with the trace log level.`),this._onDidStateChange.fire(new L(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData()));const T=[0,5,5,10,10,10,10,10,30];let _=-1;do{_++;const z=_<T.length?T[_]:T[T.length-1];try{if(z>0){const B=M(z);this._onDidStateChange.fire(new F(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData(),z,B)),this._options.logService.info(`${D} waiting for ${z} seconds before reconnecting...`);try{await B}catch{}}if(re._permanentFailure){this._options.logService.error(`${D} permanent failure occurred while running the reconnecting loop.`);break}this._onDidStateChange.fire(new U(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData(),_+1)),this._options.logService.info(`${D} resolving connection...`);const X=await i(this._options,this.reconnectionToken,this.protocol);this._options.logService.info(`${D} connecting to ${X.host}:${X.port}...`),await this._reconnect(X,t(E)),this._options.logService.info(`${D} reconnected!`),this._onDidStateChange.fire(new Y(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData(),_+1));break}catch(X){if(X.code==="VSCODE_CONNECTION_ERROR"){this._options.logService.error(`${D} A permanent error occurred in the reconnecting loop! Will give up now! Error:`),this._options.logService.error(X),re.triggerPermanentFailure(this.protocol.getMillisSinceLastIncomingData(),_+1,!1);break}if(_>360){this._options.logService.error(`${D} An error occurred while reconnecting, but it will be treated as a permanent error because the reconnection grace time has expired! Will give up now! Error:`),this._options.logService.error(X),re.triggerPermanentFailure(this.protocol.getMillisSinceLastIncomingData(),_+1,!1);break}if(y.RemoteAuthorityResolverError.isTemporarilyNotAvailable(X)){this._options.logService.info(`${D} A temporarily not available error occurred while trying to reconnect, will try again...`),this._options.logService.trace(X);continue}if((X.code==="ETIMEDOUT"||X.code==="ENETUNREACH"||X.code==="ECONNREFUSED"||X.code==="ECONNRESET")&&X.syscall==="connect"){this._options.logService.info(`${D} A network error occurred while trying to reconnect, will try again...`),this._options.logService.trace(X);continue}if((0,k.isPromiseCanceledError)(X)){this._options.logService.info(`${D} A promise cancelation error occurred while trying to reconnect, will try again...`),this._options.logService.trace(X);continue}if(X instanceof y.RemoteAuthorityResolverError){this._options.logService.error(`${D} A RemoteAuthorityResolverError occurred while trying to reconnect. Will give up now! Error:`),this._options.logService.error(X),re.triggerPermanentFailure(this.protocol.getMillisSinceLastIncomingData(),_+1,y.RemoteAuthorityResolverError.isHandled(X));break}this._options.logService.error(`${D} An unknown error occurred while trying to reconnect, since this is an unknown case, it will be treated as a permanent error! Will give up now! Error:`),this._options.logService.error(X),re.triggerPermanentFailure(this.protocol.getMillisSinceLastIncomingData(),_+1,!1);break}}while(!re._permanentFailure)}_gotoPermanentFailure(D,T,_){this._onDidStateChange.fire(new ie(this.reconnectionToken,D,T,_)),N(this.protocol)}_pauseSocketWriting(){this.protocol.pauseSocketWriting()}}e.PersistentConnection=re,re._permanentFailure=!1,re._permanentFailureMillisSinceLastIncomingData=0,re._permanentFailureAttempt=0,re._permanentFailureHandled=!1,re._instances=[];class K extends re{constructor(D,T,_,z,X){super(1,D,z,X);this.client=this._register(new f.Client(X,{remoteAuthority:T,clientId:_},D.ipcLogger))}async _reconnect(D,T){await o(D,T)}}e.ManagementPersistentConnection=K;class W extends re{constructor(D,T,_,z,X){super(2,D,_,z);this._startArguments=T,this.debugPort=X}async _reconnect(D,T){await u(D,this._startArguments,T)}}e.ExtensionHostPersistentConnection=W;function N(O){try{O.acceptDisconnect();const D=O.getSocket();O.dispose(),D.dispose()}catch(D){(0,k.onUnexpectedError)(D)}}function G(O){if(O&&O.type==="error"){const D=new Error(`Connection error: ${O.reason}`);return D.code="VSCODE_CONNECTION_ERROR",D}return null}function Q(O,D){for(;O.length<D;)O+=" ";return O}function H(O,D,T){return`[remote-connection][${Q(S(O),13)}][${D.substr(0,5)}\u2026][${T?"reconnect":"initial"}]`}function $(O,D){return`${H(D,O.reconnectionToken,!!O.reconnectionProtocol)}[${O.host}:${O.port}]`}function J(O){return`${Date.now()-O} ms`}}),define(x[64],ee([0,1,10]),function(V,e,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isVirtualWorkspace=e.getVirtualWorkspaceScheme=e.getVirtualWorkspaceLocation=e.isVirtualResource=e.getRemoteName=e.getRemoteAuthority=void 0;function R(f){return f.scheme===p.Schemas.vscodeRemote?f.authority:void 0}e.getRemoteAuthority=R;function C(f){if(!f)return;const y=f.indexOf("+");return y<0?f:f.substr(0,y)}e.getRemoteName=C;function k(f){return f.scheme!==p.Schemas.file&&f.scheme!==p.Schemas.vscodeRemote}e.isVirtualResource=k;function n(f){if(f.folders.length)return f.folders.every(y=>k(y.uri))?f.folders[0].uri:void 0;if(f.configuration&&k(f.configuration))return f.configuration}e.getVirtualWorkspaceLocation=n;function I(f){return n(f)?.scheme}e.getVirtualWorkspaceScheme=I;function d(f){return n(f)!==void 0}e.isVirtualWorkspace=d}),define(x[195],ee([0,1,25,5,64]),function(V,e,p,R,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IBuiltinExtensionsScannerService=e.isResolverExtension=e.isAuthenticationProviderExtension=e.isLanguagePackExtension=e.ExtensionIdentifier=e.ExtensionType=e.EXTENSION_CATEGORIES=e.isIExtensionIdentifier=e.getWorkspaceSupportTypeMessage=e.ALL_EXTENSION_KINDS=e.BUILTIN_MANIFEST_CACHE_FILE=e.USER_MANIFEST_CACHE_FILE=e.MANIFEST_CACHE_FOLDER=void 0,e.MANIFEST_CACHE_FOLDER="CachedExtensions",e.USER_MANIFEST_CACHE_FILE="user",e.BUILTIN_MANIFEST_CACHE_FILE="builtin",e.ALL_EXTENSION_KINDS=["ui","workspace","web"];function k(g){if(typeof g=="object"&&g!==null&&g.supported!==!0)return g.description}e.getWorkspaceSupportTypeMessage=k;function n(g){return g&&typeof g=="object"&&typeof g.id=="string"&&(!g.uuid||typeof g.uuid=="string")}e.isIExtensionIdentifier=n,e.EXTENSION_CATEGORIES=["Azure","Data Science","Debuggers","Extension Packs","Education","Formatters","Keymaps","Language Packs","Linters","Machine Learning","Notebooks","Programming Languages","SCM Providers","Snippets","Testing","Themes","Visualization","Other"];var I;(function(g){g[g.System=0]="System",g[g.User=1]="User"})(I=e.ExtensionType||(e.ExtensionType={}));class d{constructor(S){this.value=S,this._lower=S.toLowerCase()}static equals(S,t){if(typeof S=="undefined"||S===null)return typeof t=="undefined"||t===null;if(typeof t=="undefined"||t===null)return!1;if(typeof S=="string"||typeof t=="string"){let m=typeof S=="string"?S:S.value,v=typeof t=="string"?t:t.value;return p.equalsIgnoreCase(m,v)}return S._lower===t._lower}static toKey(S){return typeof S=="string"?S.toLowerCase():S._lower}}e.ExtensionIdentifier=d;function f(g){return g.contributes&&g.contributes.localizations?g.contributes.localizations.length>0:!1}e.isLanguagePackExtension=f;function y(g){return g.contributes&&g.contributes.authentication?g.contributes.authentication.length>0:!1}e.isAuthenticationProviderExtension=y;function E(g,S){if(S){const t=`onResolveRemoteAuthority:${(0,C.getRemoteName)(S)}`;return g.activationEvents?.indexOf(t)!==-1}return!1}e.isResolverExtension=E,e.IBuiltinExtensionsScannerService=(0,R.createDecorator)("IBuiltinExtensionsScannerService")}),define(x[196],ee([0,1,25,195]),function(V,e,p,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getExtensionDependencies=e.getMaliciousExtensionsSet=e.BetterMergeId=e.getGalleryExtensionTelemetryData=e.getLocalExtensionTelemetryData=e.groupByExtension=e.getGalleryExtensionId=e.adoptToGalleryExtensionId=e.getExtensionId=e.ExtensionIdentifierWithVersion=e.areSameExtensions=void 0;function C(t,m){return t.uuid&&m.uuid?t.uuid===m.uuid:t.id===m.id?!0:(0,p.compareIgnoreCase)(t.id,m.id)===0}e.areSameExtensions=C;class k{constructor(m,v){this.version=v,this.id=m.id,this.uuid=m.uuid}key(){return`${this.id}-${this.version}`}equals(m){return m instanceof k?C(this,m)&&this.version===m.version:!1}}e.ExtensionIdentifierWithVersion=k;function n(t,m){return`${t}.${m}`}e.getExtensionId=n;function I(t){return t.toLocaleLowerCase()}e.adoptToGalleryExtensionId=I;function d(t,m){return I(n(t,m))}e.getGalleryExtensionId=d;function f(t,m){const v=[],b=P=>{for(const c of v)if(c.some(a=>C(m(a),m(P))))return c;return null};for(const P of t){const c=b(P);c?c.push(P):v.push([P])}return v}e.groupByExtension=f;function y(t){return{id:t.identifier.id,name:t.manifest.name,galleryId:null,publisherId:t.publisherId,publisherName:t.manifest.publisher,publisherDisplayName:t.publisherDisplayName,dependencies:t.manifest.extensionDependencies&&t.manifest.extensionDependencies.length>0}}e.getLocalExtensionTelemetryData=y;function E(t){return{id:t.identifier.id,name:t.name,galleryId:t.identifier.uuid,publisherId:t.publisherId,publisherName:t.publisher,publisherDisplayName:t.publisherDisplayName,isPreReleaseVersion:t.properties.isPreReleaseVersion,dependencies:!!(t.properties.dependencies&&t.properties.dependencies.length>0),...t.telemetryData}}e.getGalleryExtensionTelemetryData=E,e.BetterMergeId=new R.ExtensionIdentifier("pprice.better-merge");function g(t){const m=new Set;if(t.malicious)for(const v of t.malicious)m.add(v.id);return m}e.getMaliciousExtensionsSet=g;function S(t,m){const v=[],b=m.manifest.extensionDependencies?.slice(0)??[];for(;b.length;){const P=b.shift();if(P&&v.every(c=>!C(c.identifier,{id:P}))){const c=t.filter(a=>C(a.identifier,{id:P}));c.length===1&&(v.push(c[0]),b.push(...c[0].manifest.extensionDependencies?.slice(0)??[]))}}return v}e.getExtensionDependencies=S}),define(x[97],ee([0,1,4,3,5,6]),function(V,e,p,R,C,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractTunnelService=e.isPortPrivileged=e.isAllInterfaces=e.ALL_INTERFACES_ADDRESSES=e.isLocalhost=e.LOCALHOST_ADDRESSES=e.extractLocalHostUriMetaDataForPortMapping=e.ProvidedOnAutoForward=e.TunnelPrivacyId=e.TunnelProtocol=e.ISharedTunnelsService=e.ITunnelService=void 0,e.ITunnelService=(0,C.createDecorator)("tunnelService"),e.ISharedTunnelsService=(0,C.createDecorator)("sharedTunnelsService");var n;(function(t){t.Http="http",t.Https="https"})(n=e.TunnelProtocol||(e.TunnelProtocol={}));var I;(function(t){t.ConstantPrivate="constantPrivate",t.Private="private",t.Public="public"})(I=e.TunnelPrivacyId||(e.TunnelPrivacyId={}));var d;(function(t){t[t.Notify=1]="Notify",t[t.OpenBrowser=2]="OpenBrowser",t[t.OpenPreview=3]="OpenPreview",t[t.Silent=4]="Silent",t[t.Ignore=5]="Ignore",t[t.OpenBrowserOnce=6]="OpenBrowserOnce"})(d=e.ProvidedOnAutoForward||(e.ProvidedOnAutoForward={}));function f(t){if(t.scheme!=="http"&&t.scheme!=="https")return;const m=/^(localhost|127\.0\.0\.1|0\.0\.0\.0):(\d+)$/.exec(t.authority);if(!!m)return{address:m[1],port:+m[2]}}e.extractLocalHostUriMetaDataForPortMapping=f,e.LOCALHOST_ADDRESSES=["localhost","127.0.0.1","0:0:0:0:0:0:0:1","::1"];function y(t){return e.LOCALHOST_ADDRESSES.indexOf(t)>=0}e.isLocalhost=y,e.ALL_INTERFACES_ADDRESSES=["0.0.0.0","0:0:0:0:0:0:0:0","::"];function E(t){return e.ALL_INTERFACES_ADDRESSES.indexOf(t)>=0}e.isAllInterfaces=E;function g(t,m){return m?m!==1&&t<1024:!R.isWindows&&t<1024}e.isPortPrivileged=g;let S=class{constructor(m){this.logService=m,this._onTunnelOpened=new p.Emitter,this.onTunnelOpened=this._onTunnelOpened.event,this._onTunnelClosed=new p.Emitter,this.onTunnelClosed=this._onTunnelClosed.event,this._onAddedTunnelProvider=new p.Emitter,this.onAddedTunnelProvider=this._onAddedTunnelProvider.event,this._tunnels=new Map,this._canElevate=!1,this._privacyOptions=[]}get hasTunnelProvider(){return!!this._tunnelProvider}setTunnelProvider(m,v){return this._tunnelProvider=m,m?(this._canElevate=v.elevation,this._privacyOptions=v.privacyOptions,this._onAddedTunnelProvider.fire(),{dispose:()=>{this._tunnelProvider=void 0,this._canElevate=!1,this._privacyOptions=[]}}):(this._canElevate=!1,this._privacyOptions=[],this._onAddedTunnelProvider.fire(),{dispose:()=>{}})}get canElevate(){return this._canElevate}get canChangePrivacy(){return this._privacyOptions.length>0}get privacyOptions(){return this._privacyOptions}get tunnels(){return this.getTunnels()}async getTunnels(){const m=[],v=Array.from(this._tunnels.values());for(let b of v){const P=Array.from(b.values());for(let c of P){const a=await c.value;a&&m.push(a)}}return m}async dispose(){for(const m of this._tunnels.values()){for(const{value:v}of m.values())await v.then(b=>b?.dispose());m.clear()}this._tunnels.clear()}openTunnel(m,v,b,P,c=!1,a=I.Private,l){if(this.logService.trace(`ForwardedPorts: (TunnelService) openTunnel request for ${v}:${b} on local port ${P}.`),!m)return;v||(v="localhost");const o=this.retainOrCreateTunnel(m,v,b,P,c,a,l);return o?o.then(u=>{if(!u){this.logService.trace("ForwardedPorts: (TunnelService) New tunnel is undefined."),this.removeEmptyTunnelFromMap(v,b);return}this.logService.trace("ForwardedPorts: (TunnelService) New tunnel established.");const r=this.makeTunnel(u);return(u.tunnelRemoteHost!==v||u.tunnelRemotePort!==b)&&this.logService.warn("ForwardedPorts: (TunnelService) Created tunnel does not match requirements of requested tunnel. Host or port mismatch."),this._onTunnelOpened.fire(r),r}):(this.logService.trace("ForwardedPorts: (TunnelService) Tunnel was not created."),o)}makeTunnel(m){return{tunnelRemotePort:m.tunnelRemotePort,tunnelRemoteHost:m.tunnelRemoteHost,tunnelLocalPort:m.tunnelLocalPort,localAddress:m.localAddress,privacy:m.privacy,protocol:m.protocol,dispose:async()=>{this.logService.trace(`ForwardedPorts: (TunnelService) dispose request for ${m.tunnelRemoteHost}:${m.tunnelRemotePort} `);const v=this._tunnels.get(m.tunnelRemoteHost);if(v){const b=v.get(m.tunnelRemotePort);b&&(b.refcount--,await this.tryDisposeTunnel(m.tunnelRemoteHost,m.tunnelRemotePort,b))}}}}async tryDisposeTunnel(m,v,b){if(b.refcount<=0){this.logService.trace(`ForwardedPorts: (TunnelService) Tunnel is being disposed ${m}:${v}.`);const P=b.value.then(async c=>{c&&(await c.dispose(!0),this._onTunnelClosed.fire({host:c.tunnelRemoteHost,port:c.tunnelRemotePort}))});return this._tunnels.has(m)&&this._tunnels.get(m).delete(v),P}}async closeTunnel(m,v){this.logService.trace(`ForwardedPorts: (TunnelService) close request for ${m}:${v} `);const b=this._tunnels.get(m);if(b&&b.has(v)){const P=b.get(v);P.refcount=0,await this.tryDisposeTunnel(m,v,P)}}addTunnelToMap(m,v,b){this._tunnels.has(m)||this._tunnels.set(m,new Map),this._tunnels.get(m).set(v,{refcount:1,value:b})}async removeEmptyTunnelFromMap(m,v){const b=this._tunnels.get(m);b&&(await b.get(v)||b.delete(v),b.size===0&&this._tunnels.delete(m))}getTunnelFromMap(m,v){let b=[m];y(m)?(b.push(...e.LOCALHOST_ADDRESSES),b.push(...e.ALL_INTERFACES_ADDRESSES)):E(m)&&b.push(...e.ALL_INTERFACES_ADDRESSES);const P=b.map(c=>this._tunnels.get(c));for(const c of P){const a=c?.get(v);if(a)return a}}canTunnel(m){return!!f(m)}createWithProvider(m,v,b,P,c,a,l){this.logService.trace(`ForwardedPorts: (TunnelService) Creating tunnel with provider ${v}:${b} on local port ${P}.`);const u={elevationRequired:c?g(P===void 0?b:P):!1},r={remoteAddress:{host:v,port:b},localAddressPort:P,privacy:a,public:a!==I.Private,protocol:l},i=m.forwardPort(r,u);return this.logService.trace("ForwardedPorts: (TunnelService) Tunnel created by provider."),i&&this.addTunnelToMap(v,b,i),i}};S=fe([te(0,k.ILogService)],S),e.AbstractTunnelService=S}),define(x[49],ee([0,1,17,151,57,5,40]),function(V,e,p,R,C,k,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.updateProxyConfigurationsScope=e.asJson=e.asText=e.isSuccess=e.IRequestService=void 0,e.IRequestService=(0,k.createDecorator)("requestService");function I(t){return t.res.statusCode&&t.res.statusCode>=200&&t.res.statusCode<300||t.res.statusCode===1223}e.isSuccess=I;function d(t){return t.res.statusCode===204}async function f(t){if(!I(t))throw new Error("Server returned "+t.res.statusCode);return d(t)?null:(await(0,p.streamToBuffer)(t.stream)).toString()}e.asText=f;async function y(t){if(!I(t))throw new Error("Server returned "+t.res.statusCode);if(d(t))return null;const v=(await(0,p.streamToBuffer)(t.stream)).toString();try{return JSON.parse(v)}catch(b){throw b.message+=`:
`+v,b}}e.asJson=y;function E(t){S(t)}e.updateProxyConfigurationsScope=E;let g;function S(t){const m=n.Registry.as(C.Extensions.Configuration),v=g;g={id:"http",order:15,title:(0,R.localize)(0,null),type:"object",scope:t,properties:{"http.proxy":{type:"string",pattern:"^https?://([^:]*(:[^@]*)?@)?([^:]+|\\[[:0-9a-fA-F]+\\])(:\\d+)?/?$|^$",markdownDescription:(0,R.localize)(1,null),restricted:!0},"http.proxyStrictSSL":{type:"boolean",default:!0,description:(0,R.localize)(2,null),restricted:!0},"http.proxyAuthorization":{type:["null","string"],default:null,markdownDescription:(0,R.localize)(3,null),restricted:!0},"http.proxySupport":{type:"string",enum:["off","on","fallback","override"],enumDescriptions:[(0,R.localize)(4,null),(0,R.localize)(5,null),(0,R.localize)(6,null),(0,R.localize)(7,null)],default:"override",description:(0,R.localize)(8,null),restricted:!0},"http.systemCertificates":{type:"boolean",default:!0,description:(0,R.localize)(9,null),restricted:!0}}},m.updateConfigurations({add:[g],remove:v?[v]:[]})}S(2)}),define(x[197],ee([0,1,198,13]),function(V,e,p,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getProxyAgent=void 0;function C(n,I){return n.protocol==="http:"?I.HTTP_PROXY||I.http_proxy||null:n.protocol==="https:"&&(I.HTTPS_PROXY||I.https_proxy||I.HTTP_PROXY||I.http_proxy)||null}async function k(n,I,d={}){const f=(0,p.parse)(n),y=d.proxyUrl||C(f,I);if(!y)return null;const E=(0,p.parse)(y);if(!/^https?:$/.test(E.protocol||""))return null;const g={host:E.hostname||"",port:E.port||(E.protocol==="https"?"443":"80"),auth:E.auth,rejectUnauthorized:(0,R.isBoolean)(d.strictSSL)?d.strictSSL:!0};return f.protocol==="http:"?new(await new Promise((S,t)=>{V(["http-proxy-agent"],S,t)}))(g):new(await new Promise((S,t)=>{V(["https-proxy-agent"],S,t)}))(g)}e.getProxyAgent=k}),define(x[199],ee([0,1,17,31]),function(V,e,p,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getServiceMachineId=void 0;async function C(k,n,I){let d=I&&I.get("storage.serviceMachineId",0)||null;if(d)return d;try{const y=(await n.readFile(k.serviceMachineIdResource)).value.toString();d=(0,R.isUUID)(y)?y:null}catch(f){d=null}if(!d){d=(0,R.generateUuid)();try{await n.writeFile(k.serviceMachineIdResource,p.VSBuffer.fromString(d))}catch(f){}}return I&&I.store("storage.serviceMachineId",d,0,1),d}e.getServiceMachineId=C}),define(x[76],ee([0,1,5]),function(V,e,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ISignService=e.SIGN_SERVICE_ID=void 0,e.SIGN_SERVICE_ID="signService",e.ISignService=(0,p.createDecorator)(e.SIGN_SERVICE_ID)}),define(x[200],ee([0,1]),function(V,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SignService=void 0;class p{constructor(){this.validators=new Map}vsda(){return new Promise((C,k)=>V(["vsda"],C,k))}async createNewMessage(C){try{const k=await this.vsda(),n=new k.validator;if(n){const I=String(p._nextId++);return this.validators.set(I,n),{id:I,data:n.createNewMessage(C)}}}catch(k){}return{id:"",data:C}}async validate(C,k){if(!C.id)return!0;const n=this.validators.get(C.id);if(!n)return!1;this.validators.delete(C.id);try{return n.validate(k)==="ok"}catch(I){return!1}}async sign(C){try{const k=await this.vsda(),n=new k.signer;if(n)return n.sign(C)}catch(k){}return C}}e.SignService=p,p._nextId=1}),define(x[37],ee([0,1,5]),function(V,e,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IStateMainService=void 0,e.IStateMainService=(0,p.createDecorator)("stateMainService")}),define(x[20],ee([0,1,14,9,4,2,3,34,13,5,179,6,37]),function(V,e,p,R,C,k,n,I,d,f,y,E,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LifecycleMainService=e.LifecycleMainPhase=e.ILifecycleMainService=void 0,e.ILifecycleMainService=(0,f.createDecorator)("lifecycleMainService");var S;(function(m){m[m.Starting=1]="Starting",m[m.Ready=2]="Ready",m[m.AfterWindowOpen=3]="AfterWindowOpen"})(S=e.LifecycleMainPhase||(e.LifecycleMainPhase={}));let t=class dt extends k.Disposable{constructor(v,b){super();this.logService=v,this.stateMainService=b,this._onBeforeShutdown=this._register(new C.Emitter),this.onBeforeShutdown=this._onBeforeShutdown.event,this._onWillShutdown=this._register(new C.Emitter),this.onWillShutdown=this._onWillShutdown.event,this._onWillLoadWindow=this._register(new C.Emitter),this.onWillLoadWindow=this._onWillLoadWindow.event,this._onBeforeCloseWindow=this._register(new C.Emitter),this.onBeforeCloseWindow=this._onBeforeCloseWindow.event,this._onBeforeUnloadWindow=this._register(new C.Emitter),this.onBeforeUnloadWindow=this._onBeforeUnloadWindow.event,this._quitRequested=!1,this._wasRestarted=!1,this._phase=1,this.windowToCloseRequest=new Set,this.oneTimeListenerTokenGenerator=0,this.windowCounter=0,this.pendingQuitPromise=void 0,this.pendingQuitPromiseResolve=void 0,this.pendingWillShutdownPromise=void 0,this.phaseWhen=new Map,this.resolveRestarted(),this.when(2).then(()=>this.registerListeners())}get quitRequested(){return this._quitRequested}get wasRestarted(){return this._wasRestarted}get phase(){return this._phase}resolveRestarted(){this._wasRestarted=!!this.stateMainService.getItem(dt.QUIT_AND_RESTART_KEY),this._wasRestarted&&this.stateMainService.removeItem(dt.QUIT_AND_RESTART_KEY)}registerListeners(){const v=()=>{this._quitRequested||(this.logService.trace("Lifecycle#app.on(before-quit)"),this._quitRequested=!0,this.logService.trace("Lifecycle#onBeforeShutdown.fire()"),this._onBeforeShutdown.fire(),n.isMacintosh&&this.windowCounter===0&&this.fireOnWillShutdown())};p.app.addListener("before-quit",v);const b=()=>{this.logService.trace("Lifecycle#app.on(window-all-closed)"),(this._quitRequested||!n.isMacintosh)&&p.app.quit()};p.app.addListener("window-all-closed",b),p.app.once("will-quit",P=>{this.logService.trace("Lifecycle#app.on(will-quit)"),P.preventDefault(),this.fireOnWillShutdown().finally(()=>{this.resolvePendingQuitPromise(!1),p.app.removeListener("before-quit",v),p.app.removeListener("window-all-closed",b),p.app.quit()})})}fireOnWillShutdown(){if(this.pendingWillShutdownPromise)return this.pendingWillShutdownPromise;this.logService.trace("Lifecycle#onWillShutdown.fire()");const v=[];return this._onWillShutdown.fire({join(b){v.push(b)}}),this.pendingWillShutdownPromise=(async()=>{try{await R.Promises.settled(v)}catch(b){this.logService.error(b)}try{await this.stateMainService.close()}catch(b){this.logService.error(b)}})(),this.pendingWillShutdownPromise}set phase(v){if(v<this.phase)throw new Error("Lifecycle cannot go backwards");if(this._phase===v)return;this.logService.trace(`lifecycle (main): phase changed (value: ${v})`),this._phase=v;const b=this.phaseWhen.get(this._phase);b&&(b.open(),this.phaseWhen.delete(this._phase))}async when(v){if(v<=this._phase)return;let b=this.phaseWhen.get(v);b||(b=new R.Barrier,this.phaseWhen.set(v,b)),await b.wait()}registerWindow(v){const b=new k.DisposableStore;this.windowCounter++,b.add(v.onWillLoad(c=>this._onWillLoadWindow.fire({window:v,workspace:c.workspace,reason:c.reason})));const P=(0,d.assertIsDefined)(v.win);P.on("close",c=>{const a=v.id;if(this.windowToCloseRequest.has(a)){this.windowToCloseRequest.delete(a);return}this.logService.trace(`Lifecycle#window.on('close') - window ID ${v.id}`),c.preventDefault(),this.unload(v,1).then(l=>{if(l){this.windowToCloseRequest.delete(a);return}this.windowToCloseRequest.add(a),this.logService.trace(`Lifecycle#onBeforeCloseWindow.fire() - window ID ${a}`),this._onBeforeCloseWindow.fire(v),v.close()})}),P.on("closed",()=>{this.logService.trace(`Lifecycle#window.on('closed') - window ID ${v.id}`),this.windowCounter--,b.dispose(),this.windowCounter===0&&(!n.isMacintosh||this._quitRequested)&&this.fireOnWillShutdown()})}async reload(v,b){await this.unload(v,3)||v.reload(b)}async unload(v,b){if(!v.isReady)return!1;this.logService.trace(`Lifecycle#unload() - window ID ${v.id}`);const P=this._quitRequested?2:b;let c=await this.onBeforeUnloadWindowInRenderer(v,P);return c?(this.logService.trace(`Lifecycle#unload() - veto in renderer (window ID ${v.id})`),this.handleWindowUnloadVeto(c)):(c=await this.onBeforeUnloadWindowInMain(v,P),c?(this.logService.trace(`Lifecycle#unload() - veto in main (window ID ${v.id})`),this.handleWindowUnloadVeto(c)):(this.logService.trace(`Lifecycle#unload() - no veto (window ID ${v.id})`),await this.onWillUnloadWindowInRenderer(v,P),!1))}handleWindowUnloadVeto(v){return v?(this.resolvePendingQuitPromise(!0),this._quitRequested=!1,!0):!1}resolvePendingQuitPromise(v){this.pendingQuitPromiseResolve&&(this.pendingQuitPromiseResolve(v),this.pendingQuitPromiseResolve=void 0,this.pendingQuitPromise=void 0)}onBeforeUnloadWindowInRenderer(v,b){return new Promise(P=>{const c=this.oneTimeListenerTokenGenerator++,a=`vscode:ok${c}`,l=`vscode:cancel${c}`;p.ipcMain.once(a,()=>{P(!1)}),p.ipcMain.once(l,()=>{P(!0)}),v.send("vscode:onBeforeUnload",{okChannel:a,cancelChannel:l,reason:b})})}onBeforeUnloadWindowInMain(v,b){const P=[];return this._onBeforeUnloadWindow.fire({reason:b,window:v,veto(c){P.push(c)}}),(0,y.handleVetos)(P,c=>this.logService.error(c))}onWillUnloadWindowInRenderer(v,b){return new Promise(P=>{const a=`vscode:reply${this.oneTimeListenerTokenGenerator++}`;p.ipcMain.once(a,()=>P()),v.send("vscode:onWillUnload",{replyChannel:a,reason:b})})}quit(v){return this.pendingQuitPromise?this.pendingQuitPromise:(this.logService.trace(`Lifecycle#quit() - will restart: ${v}`),v&&this.stateMainService.setItem(dt.QUIT_AND_RESTART_KEY,!0),this.pendingQuitPromise=new Promise(b=>{this.pendingQuitPromiseResolve=b,this.logService.trace("Lifecycle#quit() - calling app.quit()"),p.app.quit()}),this.pendingQuitPromise)}async relaunch(v){this.logService.trace("Lifecycle#relaunch()");const b=process.argv.slice(1);if(v?.addArgs&&b.push(...v.addArgs),v?.removeArgs)for(const a of v.removeArgs){const l=b.indexOf(a);l>=0&&b.splice(l,1)}const P=()=>{try{if(n.isWindows){const a=(0,I.cwd)();a!==process.cwd()&&process.chdir(a)}}catch(a){this.logService.error(a)}this.logService.trace("Lifecycle#relaunch() - calling app.relaunch()"),p.app.relaunch({args:b})};p.app.once("quit",P),await this.quit(!0)&&p.app.removeListener("quit",P)}async kill(v){this.logService.trace("Lifecycle#kill()"),await this.fireOnWillShutdown(),await Promise.race([(0,R.timeout)(1e3),(async()=>{for(const b of p.BrowserWindow.getAllWindows())if(b&&!b.isDestroyed()){let P;b.webContents&&!b.webContents.isDestroyed()?P=new Promise(c=>b.once("closed",c)):P=Promise.resolve(),b.destroy(),await P}})()]),p.app.exit(v)}};t.QUIT_AND_RESTART_KEY="lifecycle.quitAndRestart",t=fe([te(0,E.ILogService),te(1,g.IStateMainService)],t),e.LifecycleMainService=t}),define(x[201],ee([0,1,4,2,5,20]),function(V,e,p,R,C,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.KeyboardLayoutMainService=e.IKeyboardLayoutMainService=void 0,e.IKeyboardLayoutMainService=(0,C.createDecorator)("keyboardLayoutMainService");let n=class extends R.Disposable{constructor(f){super();this._onDidChangeKeyboardLayout=this._register(new p.Emitter),this.onDidChangeKeyboardLayout=this._onDidChangeKeyboardLayout.event,this._initPromise=null,this._keyboardLayoutData=null,f.when(3).then(()=>this._initialize())}_initialize(){return this._initPromise||(this._initPromise=this._doInitialize()),this._initPromise}async _doInitialize(){const f=await new Promise((y,E)=>{V(["native-keymap"],y,E)});this._keyboardLayoutData=I(f),f.onDidChangeKeyboardLayout(()=>{this._keyboardLayoutData=I(f),this._onDidChangeKeyboardLayout.fire(this._keyboardLayoutData)})}async getKeyboardLayoutData(){return await this._initialize(),this._keyboardLayoutData}};n=fe([te(0,k.ILifecycleMainService)],n),e.KeyboardLayoutMainService=n;function I(d){const f=d.getKeyMap(),y=d.getCurrentKeyboardLayout();return{keyboardMapping:f,keyboardLayoutInfo:y}}}),define(x[98],ee([0,1,9,4,2,63,13,86,5]),function(V,e,p,R,C,k,n,I,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.logStorage=e.InMemoryStorageService=e.AbstractStorageService=e.StorageTarget=e.StorageScope=e.WillSaveStateReason=e.IStorageService=e.IS_NEW_KEY=void 0,e.IS_NEW_KEY="__$__isNewStorageMarker";const f="__$__targetStorageMarker";e.IStorageService=(0,d.createDecorator)("storageService");var y;(function(v){v[v.NONE=0]="NONE",v[v.SHUTDOWN=1]="SHUTDOWN"})(y=e.WillSaveStateReason||(e.WillSaveStateReason={}));var E;(function(v){v[v.GLOBAL=0]="GLOBAL",v[v.WORKSPACE=1]="WORKSPACE"})(E=e.StorageScope||(e.StorageScope={}));var g;(function(v){v[v.USER=0]="USER",v[v.MACHINE=1]="MACHINE"})(g=e.StorageTarget||(e.StorageTarget={}));class S extends C.Disposable{constructor(b={flushInterval:S.DEFAULT_FLUSH_INTERVAL}){super();this.options=b,this._onDidChangeValue=this._register(new R.PauseableEmitter),this.onDidChangeValue=this._onDidChangeValue.event,this._onDidChangeTarget=this._register(new R.PauseableEmitter),this.onDidChangeTarget=this._onDidChangeTarget.event,this._onWillSaveState=this._register(new R.Emitter),this.onWillSaveState=this._onWillSaveState.event,this.flushWhenIdleScheduler=this._register(new p.RunOnceScheduler(()=>this.doFlushWhenIdle(),this.options.flushInterval)),this.runFlushWhenIdle=this._register(new C.MutableDisposable),this._workspaceKeyTargets=void 0,this._globalKeyTargets=void 0}doFlushWhenIdle(){this.runFlushWhenIdle.value=(0,p.runWhenIdle)(()=>{this.shouldFlushWhenIdle()&&this.flush(),this.flushWhenIdleScheduler.schedule()})}shouldFlushWhenIdle(){return!0}stopFlushWhenIdle(){(0,C.dispose)([this.runFlushWhenIdle,this.flushWhenIdleScheduler])}initialize(){return this.initializationPromise||(this.initializationPromise=(async()=>{(0,k.mark)("code/willInitStorage");try{await this.doInitialize()}finally{(0,k.mark)("code/didInitStorage")}this.flushWhenIdleScheduler.schedule()})()),this.initializationPromise}emitDidChangeValue(b,P){P===f?(b===0?this._globalKeyTargets=void 0:b===1&&(this._workspaceKeyTargets=void 0),this._onDidChangeTarget.fire({scope:b})):this._onDidChangeValue.fire({scope:b,key:P,target:this.getKeyTargets(b)[P]})}emitWillSaveState(b){this._onWillSaveState.fire({reason:b})}get(b,P,c){return this.getStorage(P)?.get(b,c)}getBoolean(b,P,c){return this.getStorage(P)?.getBoolean(b,c)}getNumber(b,P,c){return this.getStorage(P)?.getNumber(b,c)}store(b,P,c,a){if((0,n.isUndefinedOrNull)(P)){this.remove(b,c);return}this.withPausedEmitters(()=>{this.updateKeyTarget(b,c,a),this.getStorage(c)?.set(b,P)})}remove(b,P){this.withPausedEmitters(()=>{this.updateKeyTarget(b,P,void 0),this.getStorage(P)?.delete(b)})}withPausedEmitters(b){this._onDidChangeValue.pause(),this._onDidChangeTarget.pause();try{b()}finally{this._onDidChangeValue.resume(),this._onDidChangeTarget.resume()}}keys(b,P){const c=[],a=this.getKeyTargets(b);for(const l of Object.keys(a))a[l]===P&&c.push(l);return c}updateKeyTarget(b,P,c){const a=this.getKeyTargets(P);typeof c=="number"?a[b]!==c&&(a[b]=c,this.getStorage(P)?.set(f,JSON.stringify(a))):typeof a[b]=="number"&&(delete a[b],this.getStorage(P)?.set(f,JSON.stringify(a)))}get workspaceKeyTargets(){return this._workspaceKeyTargets||(this._workspaceKeyTargets=this.loadKeyTargets(1)),this._workspaceKeyTargets}get globalKeyTargets(){return this._globalKeyTargets||(this._globalKeyTargets=this.loadKeyTargets(0)),this._globalKeyTargets}getKeyTargets(b){return b===0?this.globalKeyTargets:this.workspaceKeyTargets}loadKeyTargets(b){const P=this.get(f,b);if(P)try{return JSON.parse(P)}catch(c){}return Object.create(null)}isNew(b){return this.getBoolean(e.IS_NEW_KEY,b)===!0}async flush(b=y.NONE){this._onWillSaveState.fire({reason:b});const P=this.getStorage(0),c=this.getStorage(1);switch(b){case y.NONE:await p.Promises.settled([P?.whenFlushed()??Promise.resolve(),c?.whenFlushed()??Promise.resolve()]);break;case y.SHUTDOWN:await p.Promises.settled([P?.flush(0)??Promise.resolve(),c?.flush(0)??Promise.resolve()]);break}}async logStorage(){const b=this.getStorage(0)?.items??new Map,P=this.getStorage(1)?.items??new Map;return m(b,P,this.getLogDetails(0)??"",this.getLogDetails(1)??"")}}e.AbstractStorageService=S,S.DEFAULT_FLUSH_INTERVAL=60*1e3;class t extends S{constructor(){super();this.globalStorage=this._register(new I.Storage(new I.InMemoryStorageDatabase)),this.workspaceStorage=this._register(new I.Storage(new I.InMemoryStorageDatabase)),this._register(this.workspaceStorage.onDidChangeStorage(b=>this.emitDidChangeValue(1,b))),this._register(this.globalStorage.onDidChangeStorage(b=>this.emitDidChangeValue(0,b)))}getStorage(b){return b===0?this.globalStorage:this.workspaceStorage}getLogDetails(b){return b===0?"inMemory (global)":"inMemory (workspace)"}async doInitialize(){}async migrate(b){}}e.InMemoryStorageService=t;async function m(v,b,P,c){const a=h=>{try{return JSON.parse(h)}catch(w){return h}},l=new Map,o=new Map;v.forEach((h,w)=>{l.set(w,h),o.set(w,a(h))});const u=new Map,r=new Map;b.forEach((h,w)=>{u.set(w,h),r.set(w,a(h))}),console.group(`Storage: Global (path: ${P})`);let i=[];l.forEach((h,w)=>{i.push({key:w,value:h})}),console.table(i),console.groupEnd(),console.log(o),console.group(`Storage: Workspace (path: ${c})`);let s=[];u.forEach((h,w)=>{s.push({key:w,value:h})}),console.table(s),console.groupEnd(),console.log(r)}e.logStorage=m}),define(x[202],ee([0,1,3,34,7,31]),function(V,e,p,R,C,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.verifyMicrosoftInternalDomain=e.resolveCommonProperties=void 0;function n(f){if(p.platform===2&&/^penguin(\.|$)/i.test(f))return"chromebook"}async function I(f,y,E,g,S,t,m,v,b,P){const c=Object.create(null);c["common.machineId"]=m,c.sessionID=(0,k.generateUuid)()+Date.now(),c.commitHash=S,c.version=t,c["common.platformVersion"]=(y||"").replace(/^(\d+)(\.\d+)?(\.\d+)?(.*)/,"$1$2$3"),c["common.platform"]=(0,p.PlatformToString)(p.platform),c["common.nodePlatform"]=R.platform,c["common.nodeArch"]=g,c["common.product"]=P||"desktop";const a=d(v||[]);a&&(c["common.msftInternal"]=a);let l=0;const o=Date.now();Object.defineProperties(c,{timestamp:{get:()=>new Date,enumerable:!0},"common.timesincesessionstart":{get:()=>Date.now()-o,enumerable:!0},"common.sequence":{get:()=>l++,enumerable:!0}}),p.isLinuxSnap&&(c["common.snap"]="true");const u=n(E);u&&(c["common.platformDetail"]=u);try{const r=await f.readFile(C.URI.file(b));c["common.source"]=r.value.toString().slice(0,30)}catch(r){}return c}e.resolveCommonProperties=I;function d(f){const y=R.env.USERDNSDOMAIN;if(!y)return!1;const E=y.toLowerCase();return f.some(g=>E===g)}e.verifyMicrosoftInternalDomain=d}),define(x[29],ee([0,1,5]),function(V,e,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryConfiguration=e.TelemetryLevel=e.TELEMETRY_OLD_SETTING_ID=e.TELEMETRY_SETTING_ID=e.TELEMETRY_SECTION_ID=e.machineIdKey=e.lastSessionDateStorageKey=e.firstSessionDateStorageKey=e.currentSessionDateStorageKey=e.ICustomEndpointTelemetryService=e.ITelemetryService=void 0,e.ITelemetryService=(0,p.createDecorator)("telemetryService"),e.ICustomEndpointTelemetryService=(0,p.createDecorator)("customEndpointTelemetryService"),e.currentSessionDateStorageKey="telemetry.currentSessionDate",e.firstSessionDateStorageKey="telemetry.firstSessionDate",e.lastSessionDateStorageKey="telemetry.lastSessionDate",e.machineIdKey="telemetry.machineId",e.TELEMETRY_SECTION_ID="telemetry",e.TELEMETRY_SETTING_ID="telemetry.telemetryLevel",e.TELEMETRY_OLD_SETTING_ID="telemetry.enableTelemetry";var R;(function(k){k[k.NONE=0]="NONE",k[k.CRASH=1]="CRASH",k[k.ERROR=2]="ERROR",k[k.USAGE=3]="USAGE"})(R=e.TelemetryLevel||(e.TelemetryLevel={}));var C;(function(k){k.OFF="off",k.CRASH="crash",k.ERROR="error",k.ON="all"})(C=e.TelemetryConfiguration||(e.TelemetryConfiguration={}))}),define(x[203],ee([0,1,26,69,9,38,10,8,3,7,71,21,83,74,19,22,29]),function(V,e,p,R,C,k,n,I,d,f,y,E,g,S,t,m,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DiagnosticsService=e.collectLaunchConfigs=e.getMachineInfo=e.collectWorkspaceStats=void 0;async function b(o,u){const r=[{tag:"grunt.js",filePattern:/^gruntfile\.js$/i},{tag:"gulp.js",filePattern:/^gulpfile\.js$/i},{tag:"tsconfig.json",filePattern:/^tsconfig\.json$/i},{tag:"package.json",filePattern:/^package\.json$/i},{tag:"jsconfig.json",filePattern:/^jsconfig\.json$/i},{tag:"tslint.json",filePattern:/^tslint\.json$/i},{tag:"eslint.json",filePattern:/^eslint\.json$/i},{tag:"tasks.json",filePattern:/^tasks\.json$/i},{tag:"launch.json",filePattern:/^launch\.json$/i},{tag:"settings.json",filePattern:/^settings\.json$/i},{tag:"webpack.config.js",filePattern:/^webpack\.config\.js$/i},{tag:"project.json",filePattern:/^project\.json$/i},{tag:"makefile",filePattern:/^makefile$/i},{tag:"sln",filePattern:/^.+\.sln$/i},{tag:"csproj",filePattern:/^.+\.csproj$/i},{tag:"cmake",filePattern:/^.+\.cmake$/i},{tag:"github-actions",filePattern:/^.+\.ya?ml$/i,relativePathPattern:/^\.github(?:\/|\\)workflows$/i},{tag:"devcontainer.json",filePattern:/^devcontainer\.json$/i},{tag:"dockerfile",filePattern:/^(dockerfile|docker\-compose\.ya?ml)$/i}];let i;const s=p.homedir().toLowerCase();switch(process.platform){case"win32":i=[{tag:"gdrive",matcher:U=>/^[a-z]:\\(my drive|shared drives)\\/.test(U)||U.startsWith(s+"\\my drive\\")},{tag:"dropbox",matcher:U=>U.startsWith(s+"\\dropbox")},{tag:"onedrive",matcher:U=>U.startsWith(s+"\\onedrive")},{tag:"box",matcher:U=>U.startsWith(s+"\\box\\")},{tag:"nextcloud",matcher:U=>U.startsWith(s+"\\nextcloud\\")},{tag:"owncloud",matcher:U=>U.startsWith(s+"\\owncloud\\")}];break;case"darwin":i=[{tag:"gdrive",matcher:U=>U.startsWith("/volumes/googledrive/")||U.startsWith(s+"/my drive/")},{tag:"dropbox",matcher:U=>U.startsWith(s+"/dropbox")},{tag:"onedrive",matcher:U=>U.startsWith(s+"/onedrive")||U.startsWith(s+"/library/cloudstorage/onedrive")},{tag:"icloud",matcher:U=>U.startsWith(s+"/library/mobile documents/")},{tag:"box",matcher:U=>U.startsWith(s+"/box/")},{tag:"nextcloud",matcher:U=>U.startsWith(s+"/nextcloud/")},{tag:"owncloud",matcher:U=>U.startsWith(s+"/owncloud/")}];break}const h=new Map,w=new Map,M=2e4;function A(U,Y,ie,re){for(const W of i){const N=U.toLowerCase();W.matcher(N)&&w.set(W.tag,1)}const K=Y.substring(U.length+1);return C.Promises.withAsyncBody(async W=>{let N;try{N=await E.Promises.readdir(Y,{withFileTypes:!0})}catch(H){W();return}if(re.count>=M){re.count+=N.length,re.maxReached=!0,W();return}let G=N.length;if(G===0){W();return}let Q=N;re.count+N.length>M&&(re.maxReached=!0,G=M-re.count,Q=N.slice(0,G)),re.count+=N.length;for(const H of Q)if(H.isDirectory()){if(ie.includes(H.name)||await A(U,(0,I.join)(Y,H.name),ie,re),--G==0){W();return}}else{const $=H.name.lastIndexOf(".");if($>=0){const J=H.name.substring($+1);J&&h.set(J,(h.get(J)??0)+1)}for(const J of r)J.relativePathPattern?.test(K)!==!1&&J.filePattern.test(H.name)&&w.set(J.tag,(w.get(J.tag)??0)+1);if(--G==0){W();return}}})}const L={count:0,maxReached:!1};await A(o,o,u,L);const F=await a(o);return{configFiles:P(w),fileTypes:P(h),fileCount:L.count,maxFilesReached:L.maxReached,launchConfigFiles:F}}e.collectWorkspaceStats=b;function P(o){return[...R.Iterable.map(o.entries(),([u,r])=>({name:u,count:r}))].sort((u,r)=>r.count-u.count)}function c(){const o={os:`${p.type()} ${p.arch()} ${p.release()}`,memory:`${(p.totalmem()/t.ByteSize.GB).toFixed(2)}GB (${(p.freemem()/t.ByteSize.GB).toFixed(2)}GB free)`,vmHint:`${Math.round(y.virtualMachineHint.value()*100)}%`},u=p.cpus();return u&&u.length>0&&(o.cpus=`${u[0].model} (${u.length} x ${u[0].speed})`),o}e.getMachineInfo=c;async function a(o){try{const u=new Map,r=(0,I.join)(o,".vscode","launch.json"),i=await E.Promises.readFile(r),s=[],h=(0,k.parse)(i.toString(),s);if(s.length)return console.log(`Unable to parse ${r}`),[];if((0,k.getNodeType)(h)==="object"&&h.configurations)for(const w of h.configurations){const M=w.type;M&&(u.has(M)?u.set(M,u.get(M)+1):u.set(M,1))}return P(u)}catch(u){return[]}}e.collectLaunchConfigs=a;let l=class{constructor(u,r){this.telemetryService=u,this.productService=r}formatMachineInfo(u){const r=[];return r.push(`OS Version:       ${u.os}`),r.push(`CPUs:             ${u.cpus}`),r.push(`Memory (System):  ${u.memory}`),r.push(`VM:               ${u.vmHint}`),r.join(`
`)}formatEnvironment(u){const r=[];r.push(`Version:          ${this.productService.nameShort} ${this.productService.version} (${this.productService.commit||"Commit unknown"}, ${this.productService.date||"Date unknown"})`),r.push(`OS Version:       ${p.type()} ${p.arch()} ${p.release()}`);const i=p.cpus();return i&&i.length>0&&r.push(`CPUs:             ${i[0].model} (${i.length} x ${i[0].speed})`),r.push(`Memory (System):  ${(p.totalmem()/t.ByteSize.GB).toFixed(2)}GB (${(p.freemem()/t.ByteSize.GB).toFixed(2)}GB free)`),d.isWindows||r.push(`Load (avg):       ${p.loadavg().map(s=>Math.round(s)).join(", ")}`),r.push(`VM:               ${Math.round(y.virtualMachineHint.value()*100)}%`),r.push(`Screen Reader:    ${u.screenReader?"yes":"no"}`),r.push(`Process Argv:     ${u.mainArguments.join(" ")}`),r.push(`GPU Status:       ${this.expandGPUFeatures(u.gpuFeatureStatus)}`),r.join(`
`)}async getPerformanceInfo(u,r){return Promise.all([(0,g.listProcesses)(u.mainPID),this.formatWorkspaceMetadata(u)]).then(async i=>{let[s,h]=i,w=this.formatProcessList(u,s);return r.forEach(M=>{if((0,S.isRemoteDiagnosticError)(M))w+=`
${M.errorMessage}`,h+=`
${M.errorMessage}`;else if(w+=`

Remote: ${M.hostName}`,M.processes&&(w+=`
${this.formatProcessList(u,M.processes)}`),M.workspaceMetadata){h+=`
|  Remote: ${M.hostName}`;for(const A of Object.keys(M.workspaceMetadata)){const L=M.workspaceMetadata[A];let F=`${L.fileCount} files`;L.maxFilesReached&&(F=`more than ${F}`),h+=`|    Folder (${A}): ${F}`,h+=this.formatWorkspaceStats(L)}}}),{processInfo:w,workspaceInfo:h}})}async getSystemInfo(u,r){const{memory:i,vmHint:s,os:h,cpus:w}=c(),M={os:h,memory:i,cpus:w,vmHint:s,processArgs:`${u.mainArguments.join(" ")}`,gpuStatus:u.gpuFeatureStatus,screenReader:`${u.screenReader?"yes":"no"}`,remoteData:r};return d.isWindows||(M.load=`${p.loadavg().map(A=>Math.round(A)).join(", ")}`),d.isLinux&&(M.linuxEnv={desktopSession:process.env.DESKTOP_SESSION,xdgSessionDesktop:process.env.XDG_SESSION_DESKTOP,xdgCurrentDesktop:process.env.XDG_CURRENT_DESKTOP,xdgSessionType:process.env.XDG_SESSION_TYPE}),Promise.resolve(M)}async getDiagnostics(u,r){const i=[];return(0,g.listProcesses)(u.mainPID).then(async s=>(i.push(""),i.push(this.formatEnvironment(u)),i.push(""),i.push(this.formatProcessList(u,s)),u.windows.some(h=>h.folderURIs&&h.folderURIs.length>0&&!h.remoteAuthority)&&(i.push(""),i.push("Workspace Stats: "),i.push(await this.formatWorkspaceMetadata(u))),r.forEach(h=>{if((0,S.isRemoteDiagnosticError)(h))i.push(`
${h.errorMessage}`);else if(i.push(`

`),i.push(`Remote:           ${h.hostName}`),i.push(this.formatMachineInfo(h.machineInfo)),h.processes&&i.push(this.formatProcessList(u,h.processes)),h.workspaceMetadata)for(const w of Object.keys(h.workspaceMetadata)){const M=h.workspaceMetadata[w];let A=`${M.fileCount} files`;M.maxFilesReached&&(A=`more than ${A}`),i.push(`Folder (${w}): ${A}`),i.push(this.formatWorkspaceStats(M))}}),i.push(""),i.push(""),i.join(`
`)))}formatWorkspaceStats(u){const r=[],i=60;let s=0;const h=(L,F)=>{const U=` ${L}(${F})`;s+U.length>i?(r.push(w),w="|                 ",s=w.length):s+=U.length,w+=U};let w="|      File types:";const M=10;let A=u.fileTypes.length>M?M:u.fileTypes.length;for(let L=0;L<A;L++){const F=u.fileTypes[L];h(F.name,F.count)}if(r.push(w),u.configFiles.length>=0&&(w="|      Conf files:",s=0,u.configFiles.forEach(L=>{h(L.name,L.count)}),r.push(w)),u.launchConfigFiles.length>0){let L="|      Launch Configs:";u.launchConfigFiles.forEach(F=>{L+=F.count>1?` ${F.name}(${F.count})`:` ${F.name}`}),r.push(L)}return r.join(`
`)}expandGPUFeatures(u){const r=Math.max(...Object.keys(u).map(i=>i.length));return Object.keys(u).map(i=>`${i}:  ${" ".repeat(r-i.length)}  ${u[i]}`).join(`
                  `)}formatWorkspaceMetadata(u){const r=[],i=[];return u.windows.forEach(s=>{s.folderURIs.length===0||!!s.remoteAuthority||(r.push(`|  Window (${s.title})`),s.folderURIs.forEach(h=>{const w=f.URI.revive(h);if(w.scheme===n.Schemas.file){const M=w.fsPath;i.push(b(M,["node_modules",".git"]).then(A=>{let L=`${A.fileCount} files`;A.maxFilesReached&&(L=`more than ${L}`),r.push(`|    Folder (${(0,I.basename)(M)}): ${L}`),r.push(this.formatWorkspaceStats(A))}).catch(A=>{r.push(`|      Error: Unable to collect workspace stats for folder ${M} (${A.toString()})`)}))}else r.push(`|    Folder (${w.toString()}): Workspace stats not available.`)}))}),Promise.all(i).then(s=>r.join(`
`)).catch(s=>`Unable to collect workspace stats: ${s}`)}formatProcessList(u,r){const i=new Map;u.windows.forEach(h=>i.set(h.pid,h.title));const s=[];return s.push("CPU %	Mem MB	   PID	Process"),r&&this.formatProcessItem(u.mainPID,i,s,r,0),s.join(`
`)}formatProcessItem(u,r,i,s,h){const w=h===0;let M;w?M=s.pid===u?`${this.productService.applicationName} main`:"remote agent":(M=`${"  ".repeat(h)} ${s.name}`,s.name==="window"&&(M=`${M} (${r.get(s.pid)})`));const A=process.platform==="win32"?s.mem:p.totalmem()*(s.mem/100);i.push(`${s.load.toFixed(0).padStart(5," ")}	${(A/t.ByteSize.MB).toFixed(0).padStart(6," ")}	${s.pid.toFixed(0).padStart(6," ")}	${M}`),Array.isArray(s.children)&&s.children.forEach(L=>this.formatProcessItem(u,r,i,L,h+1))}async reportWorkspaceStats(u){for(const{uri:r}of u.folders){const i=f.URI.revive(r);if(i.scheme!==n.Schemas.file)continue;const s=i.fsPath;try{const h=await b(s,["node_modules",".git"]);this.telemetryService.publicLog2("workspace.stats",{"workspace.id":u.telemetryId,rendererSessionId:u.rendererSessionId}),h.fileTypes.forEach(w=>{this.telemetryService.publicLog2("workspace.stats.file",{rendererSessionId:u.rendererSessionId,type:w.name,count:w.count})}),h.launchConfigFiles.forEach(w=>{this.telemetryService.publicLog2("workspace.stats.launchConfigFile",{rendererSessionId:u.rendererSessionId,type:w.name,count:w.count})}),h.configFiles.forEach(w=>{this.telemetryService.publicLog2("workspace.stats.configFiles",{rendererSessionId:u.rendererSessionId,type:w.name,count:w.count})})}catch{}}}};l=fe([te(0,v.ITelemetryService),te(1,m.IProductService)],l),e.DiagnosticsService=l}),define(x[204],ee([0,1]),function(V,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryAppenderClient=e.TelemetryAppenderChannel=void 0;class p{constructor(k){this.appenders=k}listen(k,n){throw new Error(`Event not found: ${n}`)}call(k,n,{eventName:I,data:d}){return this.appenders.forEach(f=>f.log(I,d)),Promise.resolve(null)}}e.TelemetryAppenderChannel=p;class R{constructor(k){this.channel=k}log(k,n){return this.channel.call("log",{eventName:k,data:n}).then(void 0,I=>`Failed to log telemetry: ${console.warn(I)}`),Promise.resolve(null)}flush(){return Promise.resolve()}}e.TelemetryAppenderClient=R}),define(x[65],ee([0,1,47,13,18,29]),function(V,e,p,R,C,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.cleanRemoteAuthority=e.validateTelemetryData=e.getTelemetryLevel=e.supportsTelemetry=e.configurationTelemetry=e.NullAppender=e.NullEndpointTelemetryService=e.NullTelemetryService=e.NullTelemetryServiceShape=void 0;class n{constructor(){this.sendErrorTelemetry=!1,this.telemetryLevel=0}publicLog(b,P){return Promise.resolve(void 0)}publicLog2(b,P){return this.publicLog(b,P)}publicLogError(b,P){return Promise.resolve(void 0)}publicLogError2(b,P){return this.publicLogError(b,P)}setExperimentProperty(){}getTelemetryInfo(){return Promise.resolve({instanceId:"someValue.instanceId",sessionId:"someValue.sessionId",machineId:"someValue.machineId",firstSessionDate:"someValue.firstSessionDate"})}}e.NullTelemetryServiceShape=n,e.NullTelemetryService=new n;class I{async publicLog(b,P,c){}async publicLogError(b,P,c){}}e.NullEndpointTelemetryService=I,e.NullAppender={log:()=>null,flush:()=>Promise.resolve(null)};function d(v,b){return b.onDidChangeConfiguration(P=>{P.source!==6&&v.publicLog2("updateConfiguration",{configurationSource:(0,C.ConfigurationTargetToString)(P.source),configurationKeys:t(P.sourceConfig)})})}e.configurationTelemetry=d;function f(v,b){return!(b.disableTelemetry||!v.enableTelemetry)}e.supportsTelemetry=f;function y(v){const b=v.getValue(k.TELEMETRY_SETTING_ID),P=v.getValue("telemetry.enableCrashReporter");if(v.getValue(k.TELEMETRY_OLD_SETTING_ID)===!1||P===!1)return 0;switch(b??"all"){case"all":return 3;case"error":return 2;case"crash":return 1;case"off":return 0}}e.getTelemetryLevel=y;function E(v){const b=Object.create(null),P=Object.create(null),c=Object.create(null);S(v,c);for(let a in c){a=a.length>150?a.substr(a.length-149):a;const l=c[a];typeof l=="number"?P[a]=l:typeof l=="boolean"?P[a]=l?1:0:typeof l=="string"?(l.length>8192&&console.warn(`Telemetry property: ${a} has been trimmed to 8192, the original length is ${l.length}`),b[a]=l.substring(0,8191)):typeof l!="undefined"&&l!==null&&(b[a]=l)}return{properties:b,measurements:P}}e.validateTelemetryData=E;function g(v){if(!v)return"none";let b="other";return["ssh-remote","dev-container","attached-container","wsl"].forEach(c=>{v.indexOf(`${c}+`)===0&&(b=c)}),b}e.cleanRemoteAuthority=g;function S(v,b,P=0,c){if(!!v)for(let a of Object.getOwnPropertyNames(v)){const l=v[a],o=c?c+a:a;Array.isArray(l)?b[o]=(0,p.safeStringify)(l):l instanceof Date?b[o]=l.toISOString():(0,R.isObject)(l)?P<2?S(l,b,P+1,o+"."):b[o]=(0,p.safeStringify)(l):b[o]=l}}function t(v){if(!v)return[];const b=[];return m(b,"",v),b}function m(v,b,P){P&&typeof P=="object"&&!Array.isArray(P)?Object.keys(P).forEach(c=>m(v,b?`${b}.${c}`:c,P[c])):v.push(b)}}),define(x[205],ee([0,1,30,23,16,47,3,34,13,7,18,48,169,196,166,19,6,22,49,199,98,29,65]),function(V,e,p,R,C,k,n,I,d,f,y,E,g,S,t,m,v,b,P,c,a,l,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.resolveMarketplaceHeaders=e.ExtensionGalleryServiceWithNoStorageService=e.ExtensionGalleryService=e.sortExtensionVersions=void 0;const u=n.isWeb?"web":(0,g.getTargetPlatform)(n.platform,I.arch);var r;(function(B){B[B.None=0]="None",B[B.IncludeVersions=1]="IncludeVersions",B[B.IncludeFiles=2]="IncludeFiles",B[B.IncludeCategoryAndTags=4]="IncludeCategoryAndTags",B[B.IncludeSharedAccounts=8]="IncludeSharedAccounts",B[B.IncludeVersionProperties=16]="IncludeVersionProperties",B[B.ExcludeNonValidated=32]="ExcludeNonValidated",B[B.IncludeInstallationTargets=64]="IncludeInstallationTargets",B[B.IncludeAssetUri=128]="IncludeAssetUri",B[B.IncludeStatistics=256]="IncludeStatistics",B[B.IncludeLatestVersionOnly=512]="IncludeLatestVersionOnly",B[B.Unpublished=4096]="Unpublished"})(r||(r={}));function i(...B){return String(B.reduce((q,ne)=>q|ne,0))}var s;(function(B){B[B.Tag=1]="Tag",B[B.ExtensionId=4]="ExtensionId",B[B.Category=5]="Category",B[B.ExtensionName=7]="ExtensionName",B[B.Target=8]="Target",B[B.Featured=9]="Featured",B[B.SearchText=10]="SearchText",B[B.ExcludeWithFlags=12]="ExcludeWithFlags"})(s||(s={}));const h={Icon:"Microsoft.VisualStudio.Services.Icons.Default",Details:"Microsoft.VisualStudio.Services.Content.Details",Changelog:"Microsoft.VisualStudio.Services.Content.Changelog",Manifest:"Microsoft.VisualStudio.Code.Manifest",VSIX:"Microsoft.VisualStudio.Services.VSIXPackage",License:"Microsoft.VisualStudio.Services.Content.License",Repository:"Microsoft.VisualStudio.Services.Links.Source"},w={Dependency:"Microsoft.VisualStudio.Code.ExtensionDependencies",ExtensionPack:"Microsoft.VisualStudio.Code.ExtensionPack",Engine:"Microsoft.VisualStudio.Code.Engine",PreRelease:"Microsoft.VisualStudio.Code.PreRelease",LocalizedLanguages:"Microsoft.VisualStudio.Code.LocalizedLanguages",WebExtension:"Microsoft.VisualStudio.Code.WebExtension"},A={pageNumber:1,pageSize:10,sortBy:0,sortOrder:0,flags:r.None,criteria:[],assetTypes:[]};class L{constructor(q=A){this.state=q}get pageNumber(){return this.state.pageNumber}get pageSize(){return this.state.pageSize}get sortBy(){return this.state.sortBy}get sortOrder(){return this.state.sortOrder}get flags(){return this.state.flags}withPage(q,ne=this.state.pageSize){return new L({...this.state,pageNumber:q,pageSize:ne})}withFilter(q,...ne){const se=[...this.state.criteria,...ne.length?ne.map(oe=>({filterType:q,value:oe})):[{filterType:q}]];return new L({...this.state,criteria:se})}withSortBy(q){return new L({...this.state,sortBy:q})}withSortOrder(q){return new L({...this.state,sortOrder:q})}withFlags(...q){return new L({...this.state,flags:q.reduce((ne,se)=>ne|se,0)})}withAssetTypes(...q){return new L({...this.state,assetTypes:q})}get raw(){const{criteria:q,pageNumber:ne,pageSize:se,sortBy:oe,sortOrder:Z,flags:ce,assetTypes:le}=this.state;return{filters:[{criteria:q,pageNumber:ne,pageSize:se,sortBy:oe,sortOrder:Z}],assetTypes:le,flags:ce}}get searchText(){const q=this.state.criteria.filter(ne=>ne.filterType===s.SearchText)[0];return q&&q.value?q.value:""}get telemetryData(){return{filterTypes:this.state.criteria.map(q=>String(q.filterType)),sortBy:String(this.sortBy),sortOrder:String(this.sortOrder)}}}function F(B,q){const ne=(B||[]).filter(se=>se.statisticName===q)[0];return ne?ne.value:0}function U(B){const q="Microsoft.VisualStudio.Code.Translation.";return B.files.filter(se=>se.assetType.indexOf(q)===0).reduce((se,oe)=>{const Z=K(B,oe.assetType);return Z&&se.push([oe.assetType.substring(q.length),Z]),se},[])}function Y(B){if(B.properties){const q=B.properties.filter(oe=>oe.key===h.Repository),ne=new RegExp("((git|ssh|http(s)?)|(git@[\\w.]+))(:(//)?)([\\w.@:/\\-~]+)(.git)(/)?"),se=q.filter(oe=>ne.test(oe.value))[0];return se?{uri:se.value,fallbackUri:se.value}:null}return K(B,h.Repository)}function ie(B){return{uri:`${B.fallbackAssetUri}/${h.VSIX}?redirect=true${B.targetPlatform?`&targetPlatform=${B.targetPlatform}`:""}`,fallbackUri:`${B.fallbackAssetUri}/${h.VSIX}${B.targetPlatform?`?targetPlatform=${B.targetPlatform}`:""}`}}function re(B){const q=K(B,h.Icon);if(q)return q;const ne=g.DefaultIconPath;return{uri:ne,fallbackUri:ne}}function K(B,q){return B.files.filter(se=>se.assetType===q)[0]?{uri:`${B.assetUri}/${q}`,fallbackUri:`${B.fallbackAssetUri}/${q}`}:null}function W(B,q){const ne=B.properties?B.properties.filter(oe=>oe.key===q):[],se=ne.length>0&&ne[0].value;return se?se.split(",").map(oe=>(0,S.adoptToGalleryExtensionId)(oe)):[]}function N(B){const q=B.properties?B.properties.filter(ne=>ne.key===w.Engine):[];return q.length>0&&q[0].value||""}function G(B){const q=B.properties?B.properties.filter(ne=>ne.key===w.PreRelease):[];return q.length>0&&q[0].value==="true"}function Q(B){const q=B.properties?B.properties.filter(se=>se.key===w.LocalizedLanguages):[],ne=q.length>0&&q[0].value||"";return ne?ne.split(","):[]}function H(B){return B.indexOf("preview")!==-1}function $(B){return B.targetPlatform?(0,g.toTargetPlatform)(B.targetPlatform):"undefined"}function J(B){const q=(0,p.distinct)(B.versions.map($)),ne=!!B.tags?.includes(g.WEB_EXTENSION_TAG),se=q.indexOf("web");return ne?se===-1&&q.push("web"):se!==-1&&q.splice(se,1),q}function O(B,q){const ne=(0,g.getFallbackTargetPlarforms)(q);for(let se=0;se<B.length;se++){const oe=B[se];if(oe.version===B[se-1]?.version){let Z=se;const ce=$(oe);if(ce===q)for(;Z>0&&B[Z-1].version===oe.version;)Z--;else if(ne.includes(ce))for(;Z>0&&B[Z-1].version===oe.version&&$(B[Z-1])!==q;)Z--;Z!==se&&(B.splice(se,1),B.splice(Z,0,oe))}}return B}e.sortExtensionVersions=O;function D(B,q,ne,se,oe){const Z=B.versions[0],ce={manifest:K(q,h.Manifest),readme:K(q,h.Details),changelog:K(q,h.Changelog),license:K(q,h.License),repository:Y(q),download:ie(q),icon:re(q),coreTranslations:U(q)};return{identifier:{id:(0,S.getGalleryExtensionId)(B.publisher.publisherName,B.extensionName),uuid:B.extensionId},name:B.extensionName,version:q.version,displayName:B.displayName,publisherId:B.publisher.publisherId,publisher:B.publisher.publisherName,publisherDisplayName:B.publisher.displayName,publisherDomain:B.publisher.domain?{link:B.publisher.domain,verified:!!B.publisher.isDomainVerified}:void 0,description:B.shortDescription||"",installCount:F(B.statistics,"install"),rating:F(B.statistics,"averagerating"),ratingCount:F(B.statistics,"ratingcount"),categories:B.categories||[],tags:B.tags||[],releaseDate:Date.parse(B.releaseDate),lastUpdated:Date.parse(B.lastUpdated),allTargetPlatforms:ne,assets:ce,properties:{dependencies:W(q,w.Dependency),extensionPack:W(q,w.ExtensionPack),engine:N(q),localizedLanguages:Q(q),targetPlatform:$(q),isPreReleaseVersion:G(q)},hasPreReleaseVersion:G(Z),hasReleaseVersion:se,preview:H(B.flags),telemetryData:oe}}let T=class{constructor(q,ne,se,oe,Z,ce,le,ue){this.requestService=ne,this.logService=se,this.environmentService=oe,this.telemetryService=Z,this.fileService=ce,this.productService=le,this.configurationService=ue;const me=le.extensionsGallery;this.extensionsGalleryUrl=me&&me.serviceUrl,this.extensionsControlUrl=me&&me.controlUrl,this.commonHeadersPromise=X(le.version,le,this.environmentService,this.configurationService,this.fileService,q)}api(q=""){return`${this.extensionsGalleryUrl}${q}`}isEnabled(){return!!this.extensionsGalleryUrl}async getExtensions(q,ne,se){const oe=(0,d.isBoolean)(ne)?ne:!1,Z=(0,d.isBoolean)(ne)?se:ne;let ce=new L().withFlags(r.IncludeAssetUri,r.IncludeStatistics,r.IncludeCategoryAndTags,r.IncludeFiles,r.IncludeVersionProperties).withPage(1,q.length).withFilter(s.Target,"Microsoft.VisualStudio.Code").withFilter(s.ExtensionName,...q.map(({id:me})=>me.toLowerCase()));q.every(me=>!me.version)&&(ce=ce.withFlags(r.IncludeAssetUri,r.IncludeStatistics,r.IncludeCategoryAndTags,r.IncludeFiles,r.IncludeVersionProperties,r.IncludeLatestVersionOnly));const{galleryExtensions:le}=await this.queryGallery(ce,u,R.CancellationToken.None),ue=le.map(me=>{const Ee=(0,S.getGalleryExtensionId)(me.publisher.publisherName,me.extensionName);return{rawGalleryExtension:me,version:q.find(de=>(0,S.areSameExtensions)(de,{id:Ee}))?.version,preRelease:oe}});return this.converToGalleryExtensions(ue,u,()=>{},Z)}async getExtensions2(q){const ne=[],se=[];for(const le of q)le.uuid?se.push(le.uuid):ne.push(le.id.toLowerCase());let oe=new L().withFlags(r.IncludeAssetUri,r.IncludeStatistics,r.IncludeCategoryAndTags,r.IncludeFiles,r.IncludeVersionProperties,r.IncludeLatestVersionOnly).withPage(1,q.length).withFilter(s.Target,"Microsoft.VisualStudio.Code");se.length&&(oe=oe.withFilter(s.ExtensionId,...se)),ne.length&&(oe=oe.withFilter(s.ExtensionId,...ne));const{galleryExtensions:Z}=await this.queryGallery(oe,u,R.CancellationToken.None),ce=Z.map(le=>{const ue=(0,S.getGalleryExtensionId)(le.publisher.publisherName,le.extensionName),me=q.find(Ee=>(0,S.areSameExtensions)(Ee,{id:ue,uuid:le.extensionId}));return{rawGalleryExtension:le,preRelease:!!me?.preRelease}});return this.converToGalleryExtensions(ce,u,()=>{},R.CancellationToken.None)}async getCompatibleExtension(q,ne,se){const oe=(0,g.isIExtensionIdentifier)(q)?null:q;if(oe){if((0,g.isNotWebExtensionInWebTargetPlatform)(oe.allTargetPlatforms,se))return null;if(await this.isExtensionCompatible(oe,ne,se))return oe}const{id:Z,uuid:ce}=oe?oe.identifier:q;let le=new L().withFlags(r.IncludeAssetUri,r.IncludeStatistics,r.IncludeCategoryAndTags,r.IncludeFiles,r.IncludeVersionProperties).withPage(1,1).withFilter(s.Target,"Microsoft.VisualStudio.Code");ce?le=le.withFilter(s.ExtensionId,ce):le=le.withFilter(s.ExtensionName,Z);const{galleryExtensions:ue}=await this.queryGallery(le,se,R.CancellationToken.None),[me]=ue;if(!me||!me.versions.length)return null;const Ee=J(me);if((0,g.isNotWebExtensionInWebTargetPlatform)(Ee,se))return null;for(let de of me.versions){if(!N(de)){const ge=await this.getEngine(de);de={...de,properties:[...de.properties||[],{key:w.Engine,value:ge}]}}if(await this.isRawExtensionVersionCompatible(de,ne,Ee,se)){const ge=me.versions.some(pe=>!G(pe));return D(me,de,Ee,ge)}}return null}async isExtensionCompatible(q,ne,se){if(!(0,g.isTargetPlatformCompatible)(q.properties.targetPlatform,q.allTargetPlatforms,se)||!ne&&q.properties.isPreReleaseVersion)return!1;let oe=q.properties.engine;if(!oe){const Z=await this.getManifest(q,R.CancellationToken.None);if(!Z)throw new Error("Manifest was not found");oe=Z.engines.vscode}return(0,t.isEngineValid)(oe,this.productService.version,this.productService.date)}async isRawExtensionVersionCompatible(q,ne,se,oe){if(!(0,g.isTargetPlatformCompatible)($(q),se,oe)||!ne&&G(q))return!1;const Z=await this.getEngine(q);return(0,t.isEngineValid)(Z,this.productService.version,this.productService.date)}async query(q,ne){if(!this.isEnabled())throw new Error("No extension gallery service configured.");let se=q.text||"";const oe=(0,k.getOrDefault)(q,de=>de.pageSize,50);let Z=new L().withFlags(r.IncludeLatestVersionOnly,r.IncludeAssetUri,r.IncludeStatistics,r.IncludeCategoryAndTags,r.IncludeFiles,r.IncludeVersionProperties).withPage(1,oe).withFilter(s.Target,"Microsoft.VisualStudio.Code");se?(se=se.replace(/\bcategory:("([^"]*)"|([^"]\S*))(\s+|\b|$)/g,(de,ge,pe)=>(Z=Z.withFilter(s.Category,pe||ge),"")),se=se.replace(/\btag:("([^"]*)"|([^"]\S*))(\s+|\b|$)/g,(de,ge,pe)=>(Z=Z.withFilter(s.Tag,pe||ge),"")),se=se.replace(/\bfeatured(\s+|\b|$)/g,()=>(Z=Z.withFilter(s.Featured),"")),se=se.trim(),se&&(se=se.length<200?se:se.substring(0,200),Z=Z.withFilter(s.SearchText,se)),Z=Z.withSortBy(0)):q.ids?Z=Z.withFilter(s.ExtensionId,...q.ids):q.names?Z=Z.withFilter(s.ExtensionName,...q.names):Z=Z.withSortBy(4),typeof q.sortBy=="number"&&(Z=Z.withSortBy(q.sortBy)),typeof q.sortOrder=="number"&&(Z=Z.withSortOrder(q.sortOrder));const{galleryExtensions:ce,total:le}=await this.queryGallery(Z,u,ne),ue=de=>({index:(Z.pageNumber-1)*Z.pageSize+de,querySource:q.source}),me=await this.converToGalleryExtensions(ce.map(de=>({rawGalleryExtension:de,preRelease:!!q.includePreRelease})),u,ue,ne),Ee=async(de,ge)=>{if(ge.isCancellationRequested)throw(0,C.canceled)();const pe=Z.withPage(de+1),{galleryExtensions:ke}=await this.queryGallery(pe,u,ge);return await this.converToGalleryExtensions(ke.map(Re=>({rawGalleryExtension:Re,preRelease:!!q.includePreRelease})),u,ue,ne)};return{firstPage:me,total:le,pageSize:Z.pageSize,getPage:Ee}}async converToGalleryExtensions(q,ne,se,oe){const Z=(ue,me,Ee,de)=>{const ge=J(ue);let pe=ue.versions[0];return pe=ue.versions.find(ke=>ke.version===pe.version&&(0,g.isTargetPlatformCompatible)($(ke),ge,ne))||pe,G(pe)&&!de&&(pe=ue.versions.find(ke=>ke.version!==pe.version&&!G(ke))||pe),D(ue,pe,ge,Ee,se(me))},ce=[],le=new Map;for(let ue=0;ue<q.length;ue++){const{rawGalleryExtension:me,version:Ee,preRelease:de}=q[ue],ge=me.versions.some(pe=>!G(pe));if(Ee){const pe=me.versions.find(ke=>ke.version===Ee);pe&&ce.push([ue,D(me,pe,J(me),ge)])}else{const pe=Z(me,ue,ge,de);pe.properties.isPreReleaseVersion?le.set(pe.identifier.uuid,{index:ue,preRelease:de}):ce.push([ue,pe])}}if(le.size){const ue=new Date().getTime(),me=new L().withFlags(r.IncludeVersions,r.IncludeAssetUri,r.IncludeStatistics,r.IncludeCategoryAndTags,r.IncludeFiles,r.IncludeVersionProperties).withPage(1,le.size).withFilter(s.Target,"Microsoft.VisualStudio.Code").withFilter(s.ExtensionId,...le.keys()),{galleryExtensions:Ee}=await this.queryGallery(me,ne,oe);if(this.telemetryService.publicLog2("galleryService:preReleasesQuery",{duration:new Date().getTime()-ue,count:le.size}),Ee.length!==le.size)throw new Error("Not all extensions with latest versions are returned");for(const de of Ee){const ge=de.versions.some(Fe=>!G(Fe)),{index:pe,preRelease:ke}=le.get(de.extensionId),Re=Z(de,pe,ge,ke);ce.push([pe,Re])}}return ce.sort((ue,me)=>ue[0]-me[0]).map(([,ue])=>ue)}async queryGallery(q,ne,se){if(!this.isEnabled())throw new Error("No extension gallery service configured.");q=q.withFlags(q.flags,r.ExcludeNonValidated).withFilter(s.ExcludeWithFlags,i(r.Unpublished));const oe=await this.commonHeadersPromise,Z=JSON.stringify(q.raw),ce={...oe,"Content-Type":"application/json",Accept:"application/json;api-version=3.0-preview.1","Accept-Encoding":"gzip","Content-Length":String(Z.length)},le=new Date().getTime();let ue,me,Ee=0;try{if(ue=await this.requestService.request({type:"POST",url:this.api("/extensionquery"),data:Z,headers:ce},se),ue.res.statusCode&&ue.res.statusCode>=400&&ue.res.statusCode<500)return{galleryExtensions:[],total:Ee};const de=await(0,P.asJson)(ue);if(de){const ge=de.results[0],pe=ge.extensions;pe.forEach(Re=>O(Re.versions,ne));const ke=ge.resultMetadata&&ge.resultMetadata.filter(Re=>Re.metadataType==="ResultCount")[0];return Ee=ke&&ke.metadataItems.filter(Re=>Re.name==="TotalCount")[0].count||0,{galleryExtensions:pe,total:Ee}}return{galleryExtensions:[],total:Ee}}catch(de){throw me=de,de}finally{this.telemetryService.publicLog2("galleryService:query",{...q.telemetryData,requestBodySize:String(Z.length),duration:new Date().getTime()-le,success:!!ue&&(0,P.isSuccess)(ue),responseBodySize:ue?.res.headers["Content-Length"],statusCode:ue?String(ue.res.statusCode):void 0,errorCode:me?(0,C.isPromiseCanceledError)(me)?"canceled":(0,C.getErrorMessage)(me).startsWith("XHR timeout")?"timeout":"failed":void 0,count:String(Ee)})}}async reportStatistic(q,ne,se,oe){if(!this.isEnabled())return;const Z=n.isWeb?this.api(`/itemName/${q}.${ne}/version/${se}/statType/${oe==="install"?"1":"3"}/vscodewebextension`):this.api(`/publishers/${q}/extensions/${ne}/${se}/stats?statType=${oe}`),ce=n.isWeb?"api-version=6.1-preview.1":"*/*;api-version=4.0-preview.1",ue={...await this.commonHeadersPromise,Accept:ce};try{await this.requestService.request({type:"POST",url:Z,headers:ue},R.CancellationToken.None)}catch(me){}}async download(q,ne,se){this.logService.trace("ExtensionGalleryService#download",q.identifier.id);const oe=(0,S.getGalleryExtensionTelemetryData)(q),Z=new Date().getTime(),ce=Ee=>this.telemetryService.publicLog("galleryService:downloadVSIX",{...oe,duration:Ee}),le=se===2?"install":se===3?"update":"",ue=le?{uri:`${q.assets.download.uri}${f.URI.parse(q.assets.download.uri).query?"&":"?"}${le}=true`,fallbackUri:`${q.assets.download.fallbackUri}${f.URI.parse(q.assets.download.fallbackUri).query?"&":"?"}${le}=true`}:q.assets.download,me=await this.getAsset(ue);await this.fileService.writeFile(ne,me.stream),ce(new Date().getTime()-Z)}async getReadme(q,ne){if(q.assets.readme){const se=await this.getAsset(q.assets.readme,{},ne);return await(0,P.asText)(se)||""}return""}async getManifest(q,ne){if(q.assets.manifest){const se=await this.getAsset(q.assets.manifest,{},ne),oe=await(0,P.asText)(se);return oe?JSON.parse(oe):null}return null}async getManifestFromRawExtensionVersion(q,ne){const se=K(q,h.Manifest);if(!se)throw new Error("Manifest was not found");const oe={"Accept-Encoding":"gzip"},Z=await this.getAsset(se,{headers:oe});return await(0,P.asJson)(Z)}async getCoreTranslation(q,ne){const se=q.assets.coreTranslations.filter(oe=>oe[0]===ne.toUpperCase())[0];if(se){const oe=await this.getAsset(se[1]),Z=await(0,P.asText)(oe);return Z?JSON.parse(Z):null}return null}async getChangelog(q,ne){if(q.assets.changelog){const se=await this.getAsset(q.assets.changelog,{},ne);return await(0,P.asText)(se)||""}return""}async getAllCompatibleVersions(q,ne,se){let oe=new L().withFlags(r.IncludeVersions,r.IncludeCategoryAndTags,r.IncludeFiles,r.IncludeVersionProperties).withPage(1,1).withFilter(s.Target,"Microsoft.VisualStudio.Code");q.identifier.uuid?oe=oe.withFilter(s.ExtensionId,q.identifier.uuid):oe=oe.withFilter(s.ExtensionName,q.identifier.id);const{galleryExtensions:Z}=await this.queryGallery(oe,se,R.CancellationToken.None);if(!Z.length)return[];const ce=J(Z[0]);if((0,g.isNotWebExtensionInWebTargetPlatform)(ce,se))return[];const le=[];for(const ue of Z[0].versions)try{le[le.length-1]?.version!==ue.version&&await this.isRawExtensionVersionCompatible(ue,ne,ce,se)&&le.push({version:ue.version,date:ue.lastUpdated,isPreReleaseVersion:G(ue)})}catch(me){}return le}async getAsset(q,ne={},se=R.CancellationToken.None){const oe=await this.commonHeadersPromise,Z={type:"GET"},ce={...oe,...ne.headers||{}};ne={...ne,...Z,headers:ce};const le=q.uri,ue=q.fallbackUri,me={...ne,url:le};try{const Ee=await this.requestService.request(me,se);if(Ee.res.statusCode===200)return Ee;const de=await(0,P.asText)(Ee);throw new Error(`Expected 200, got back ${Ee.res.statusCode} instead.

${de}`)}catch(Ee){if((0,C.isPromiseCanceledError)(Ee))throw Ee;const de=(0,C.getErrorMessage)(Ee);this.telemetryService.publicLog2("galleryService:cdnFallback",{url:le,message:de});const ge={...ne,url:ue};return this.requestService.request(ge,se)}}async getEngine(q){let ne=N(q);if(!ne){const se=await this.getManifestFromRawExtensionVersion(q,R.CancellationToken.None);if(!se)throw new Error("Manifest was not found");ne=se.engines.vscode}return ne}async getExtensionsControlManifest(){if(!this.isEnabled())throw new Error("No extension gallery service configured.");if(!this.extensionsControlUrl)return{malicious:[]};const q=await this.requestService.request({type:"GET",url:this.extensionsControlUrl},R.CancellationToken.None);if(q.res.statusCode!==200)throw new Error("Could not get extensions report.");const ne=await(0,P.asJson)(q),se=[],oe={};if(ne){for(const Z of ne.malicious)se.push({id:Z});if(ne.unsupported)for(const Z of Object.keys(ne.unsupported)){const ce=ne.unsupported[Z];(0,d.isBoolean)(ce)||(oe[Z.toLowerCase()]=ce.preReleaseExtension)}}return{malicious:se,unsupportedPreReleaseExtensions:oe}}};T=fe([te(1,P.IRequestService),te(2,v.ILogService),te(3,E.IEnvironmentService),te(4,l.ITelemetryService),te(5,m.IFileService),te(6,b.IProductService),te(7,y.IConfigurationService)],T);let _=class extends T{constructor(q,ne,se,oe,Z,ce,le,ue){super(q,ne,se,oe,Z,ce,le,ue)}};_=fe([te(0,a.IStorageService),te(1,P.IRequestService),te(2,v.ILogService),te(3,E.IEnvironmentService),te(4,l.ITelemetryService),te(5,m.IFileService),te(6,b.IProductService),te(7,y.IConfigurationService)],_),e.ExtensionGalleryService=_;let z=class extends T{constructor(q,ne,se,oe,Z,ce,le){super(void 0,q,ne,se,oe,Z,ce,le)}};z=fe([te(0,P.IRequestService),te(1,v.ILogService),te(2,E.IEnvironmentService),te(3,l.ITelemetryService),te(4,m.IFileService),te(5,b.IProductService),te(6,y.IConfigurationService)],z),e.ExtensionGalleryServiceWithNoStorageService=z;async function X(B,q,ne,se,oe,Z){const ce={"X-Market-Client-Id":`VSCode ${B}`,"User-Agent":`VSCode ${B}`},le=await(0,c.getServiceMachineId)(ne,oe,Z);return(0,o.supportsTelemetry)(q,ne)&&(0,o.getTelemetryLevel)(se)===3&&(ce["X-Market-User-Id"]=le),ce}e.resolveMarketplaceHeaders=X}),define(x[206],ee([0,1,2,47,3,25,152,18,57,55,40,29,65]),function(V,e,p,R,C,k,n,I,d,f,y,E,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryService=void 0;let S=class{constructor(v,b){this._configurationService=b,this._experimentProperties={},this._disposables=new p.DisposableStore,this._cleanupPatterns=[],this._appenders=v.appenders,this._commonProperties=v.commonProperties||Promise.resolve({}),this._piiPaths=v.piiPaths||[],this._telemetryLevel=3,this.sendErrorTelemetry=!!v.sendErrorTelemetry,this._cleanupPatterns=[/file:\/\/\/.*?\/resources\/app\//gi];for(let P of this._piiPaths)this._cleanupPatterns.push(new RegExp((0,k.escapeRegExpCharacters)(P),"gi"));this._updateTelemetryLevel(),this._configurationService.onDidChangeConfiguration(this._updateTelemetryLevel,this,this._disposables),this.publicLog2("optInStatus",{optIn:this._telemetryLevel===3}),this._commonProperties.then(P=>{const c=/^[a-f0-9]+$/i.test(P["common.machineId"]);this.publicLog2("machineIdFallback",{usingFallbackGuid:!c})})}setExperimentProperty(v,b){this._experimentProperties[v]=b}_updateTelemetryLevel(){this._telemetryLevel=(0,g.getTelemetryLevel)(this._configurationService)}get telemetryLevel(){return this._telemetryLevel}async getTelemetryInfo(){const v=await this._commonProperties;let b=v.sessionID,P=v["common.machineId"],c=v["common.firstSessionDate"],a=v["common.msftInternal"];return{sessionId:b,machineId:P,firstSessionDate:c,msftInternal:a}}dispose(){this._disposables.dispose()}_log(v,b,P,c){return this.telemetryLevel<b?Promise.resolve(void 0):this._commonProperties.then(a=>{P=(0,R.mixin)(P,a),P=(0,R.mixin)(P,this._experimentProperties),P=(0,R.cloneAndChange)(P,l=>{if(typeof l=="string")return this._cleanupInfo(l,c)}),this._appenders.forEach(l=>l.log(v,P))},a=>{console.error(a)})}publicLog(v,b,P){return this._log(v,3,b,P)}publicLog2(v,b,P){return this.publicLog(v,b,P)}publicLogError(v,b){return this.sendErrorTelemetry?this._log(v,2,b,!0):Promise.resolve(void 0)}publicLogError2(v,b){return this.publicLogError(v,b)}_anonymizeFilePaths(v){let b=v;const P=[];for(let o of this._cleanupPatterns)for(;;){const u=o.exec(v);if(!u)break;P.push([u.index,o.lastIndex])}const c=/^[\\\/]?(node_modules|node_modules\.asar)[\\\/]/,a=/(file:\/\/)?([a-zA-Z]:(\\\\|\\|\/)|(\\\\|\\|\/))?([\w-\._]+(\\\\|\\|\/))+[\w-\._]*/g;let l=0;for(b="";;){const o=a.exec(v);if(!o)break;!c.test(o[0])&&P.every(([u,r])=>o.index<u||o.index>=r)&&(b+=v.substring(l,o.index)+"<REDACTED: user-file-path>",l=a.lastIndex)}return l<v.length&&(b+=v.substr(l)),b}_removePropertiesWithPossibleUserInfo(v){if(!v)return v;const b=v.toLowerCase(),P=/@[a-zA-Z0-9-.]+/;return/(key|token|sig|signature|password|passwd|pwd)[="':\s]/.test(b)?"<REDACTED: secret>":P.test(b)?"<REDACTED: email>":v}_cleanupInfo(v,b){let P=v;b&&(P=this._anonymizeFilePaths(P));for(let c of this._cleanupPatterns)P=P.replace(c,"");return P=this._removePropertiesWithPossibleUserInfo(P),P}};S.IDLE_START_EVENT_NAME="UserIdleStart",S.IDLE_STOP_EVENT_NAME="UserIdleStop",S=fe([te(1,I.IConfigurationService)],S),e.TelemetryService=S;function t(){const m=(0,n.localize)(0,null,f.default.nameLong),v=f.default.privacyStatementUrl?(0,n.localize)(2,null,"https://aka.ms/vscode-telemetry",f.default.privacyStatementUrl):(0,n.localize)(1,null,"https://aka.ms/vscode-telemetry"),b=C.isWeb?"":(0,n.localize)(3,null),P=(0,n.localize)(4,null),c=(0,n.localize)(5,null),a=(0,n.localize)(6,null),l=(0,n.localize)(7,null),o=`
|       | ${P} | ${c} | ${a} |
|:------|:---------------------:|:---------------:|:--------------:|
| all   |            \u2713          |        \u2713        |        \u2713       |
| error |            \u2713          |        \u2713        |        -       |
| crash |            \u2713          |        -        |        -       |
| off   |            -          |        -        |        -       |
`,u=(0,n.localize)(8,null);return`
${m} ${v} ${b}

&nbsp;

${l}
${o}

&nbsp;

${u}
`}y.Registry.as(d.Extensions.Configuration).registerConfiguration({id:E.TELEMETRY_SECTION_ID,order:110,type:"object",title:(0,n.localize)(9,null),properties:{[E.TELEMETRY_SETTING_ID]:{type:"string",enum:["all","error","crash","off"],enumDescriptions:[(0,n.localize)(10,null),(0,n.localize)(11,null),(0,n.localize)(12,null),(0,n.localize)(13,null)],markdownDescription:t(),default:"all",restricted:!0,scope:1,tags:["usesOnlineServices","telemetry"]}}}),y.Registry.as(d.Extensions.Configuration).registerConfiguration({id:E.TELEMETRY_SECTION_ID,order:110,type:"object",title:(0,n.localize)(14,null),properties:{[E.TELEMETRY_OLD_SETTING_ID]:{type:"boolean",markdownDescription:f.default.privacyStatementUrl?(0,n.localize)(16,null,f.default.nameLong,f.default.privacyStatementUrl):(0,n.localize)(15,null,f.default.nameLong),default:!0,restricted:!0,markdownDeprecationMessage:(0,n.localize)(17,null,`\`#${E.TELEMETRY_SETTING_ID}#\``),scope:1,tags:["usesOnlineServices","telemetry"]}}})}),define(x[207],ee([0,1]),function(V,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ColorScheme=void 0;var p;(function(R){R.DARK="dark",R.LIGHT="light",R.HIGH_CONTRAST="hc"})(p=e.ColorScheme||(e.ColorScheme={}))}),define(x[208],ee([0,1,109,4,2,5,40,207]),function(V,e,p,R,C,k,n,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Themable=e.registerThemingParticipant=e.Extensions=e.getThemeTypeSelector=e.FolderThemeIcon=e.FileThemeIcon=e.ThemeIcon=e.themeColorFromId=e.ThemeColor=e.IThemeService=void 0,e.IThemeService=(0,k.createDecorator)("themeService");var d;(function(v){function b(P){return P&&typeof P=="object"&&typeof P.id=="string"}v.isThemeColor=b})(d=e.ThemeColor||(e.ThemeColor={}));function f(v){return{id:v}}e.themeColorFromId=f;var y;(function(v){function b(r){return r&&typeof r=="object"&&typeof r.id=="string"&&(typeof r.color=="undefined"||d.isThemeColor(r.color))}v.isThemeIcon=b;const P=new RegExp(`^\\$\\((${p.CSSIcon.iconNameExpression}(?:${p.CSSIcon.iconModifierExpression})?)\\)$`);function c(r){const i=P.exec(r);if(!i)return;let[,s]=i;return{id:s}}v.fromString=c;function a(r,i){let s=r.id;const h=s.lastIndexOf("~");return h!==-1&&(s=s.substring(0,h)),i&&(s=`${s}~${i}`),{id:s}}v.modify=a;function l(r){const i=r.id.lastIndexOf("~");if(i!==-1)return r.id.substring(i+1)}v.getModifier=l;function o(r,i){return r.id===i.id&&r.color?.id===i.color?.id}v.isEqual=o;function u(r,i){return{id:r.id,color:i?f(i):void 0}}v.asThemeIcon=u,v.asClassNameArray=p.CSSIcon.asClassNameArray,v.asClassName=p.CSSIcon.asClassName,v.asCSSSelector=p.CSSIcon.asCSSSelector})(y=e.ThemeIcon||(e.ThemeIcon={})),e.FileThemeIcon=p.Codicon.file,e.FolderThemeIcon=p.Codicon.folder;function E(v){switch(v){case I.ColorScheme.DARK:return"vs-dark";case I.ColorScheme.HIGH_CONTRAST:return"hc-black";default:return"vs"}}e.getThemeTypeSelector=E,e.Extensions={ThemingContribution:"base.contributions.theming"};class g{constructor(){this.themingParticipants=[],this.themingParticipants=[],this.onThemingParticipantAddedEmitter=new R.Emitter}onColorThemeChange(b){return this.themingParticipants.push(b),this.onThemingParticipantAddedEmitter.fire(b),(0,C.toDisposable)(()=>{const P=this.themingParticipants.indexOf(b);this.themingParticipants.splice(P,1)})}get onThemingParticipantAdded(){return this.onThemingParticipantAddedEmitter.event}getThemingParticipants(){return this.themingParticipants}}let S=new g;n.Registry.add(e.Extensions.ThemingContribution,S);function t(v){return S.onColorThemeChange(v)}e.registerThemingParticipant=t;class m extends C.Disposable{constructor(b){super();this.themeService=b,this.theme=b.getColorTheme(),this._register(this.themeService.onDidColorThemeChange(P=>this.onThemeChange(P)))}onThemeChange(b){this.theme=b,this.updateStyles()}updateStyles(){}getColor(b,P){let c=this.theme.getColor(b);return c&&P&&(c=P(c,this.theme)),c?c.toString():null}}e.Themable=m}),define(x[66],ee([0,1,14,3,5,37]),function(V,e,p,R,C,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ThemeMainService=e.IThemeMainService=void 0;const n="#FFFFFF",I="#1E1E1E",d="#000000",f="theme",y="themeBackground",E="windowSplash";e.IThemeMainService=(0,C.createDecorator)("themeMainService");let g=class{constructor(t){this.stateMainService=t}getBackgroundColor(){if((R.isWindows||R.isMacintosh)&&p.nativeTheme.shouldUseInvertedColorScheme)return d;let t=this.stateMainService.getItem(y,null);if(!t){let m;(R.isWindows||R.isMacintosh)&&p.nativeTheme.shouldUseInvertedColorScheme?m="hc-black":m=this.stateMainService.getItem(f,"vs-dark").split(" ")[0],t=m==="hc-black"?d:m==="vs"?n:I}return R.isMacintosh&&t.toUpperCase()===I&&(t="#171717"),t}saveWindowSplash(t,m){this.stateMainService.setItems([{key:f,data:m.baseTheme},{key:y,data:m.colorInfo.background},{key:E,data:m}]),typeof t=="number"&&this.updateBackgroundColor(t,m)}updateBackgroundColor(t,m){for(const v of p.BrowserWindow.getAllWindows())if(v.id===t){v.setBackgroundColor(m.colorInfo.background);break}}getWindowSplash(){return this.stateMainService.getItem(E)}};g=fe([te(0,k.IStateMainService)],g),e.ThemeMainService=g}),define(x[41],ee([0,1,5]),function(V,e,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IUpdateService=e.State=e.UpdateType=e.StateType=void 0;var R;(function(k){k.Uninitialized="uninitialized",k.Idle="idle",k.CheckingForUpdates="checking for updates",k.AvailableForDownload="available for download",k.Downloading="downloading",k.Downloaded="downloaded",k.Updating="updating",k.Ready="ready"})(R=e.StateType||(e.StateType={}));var C;(function(k){k[k.Setup=0]="Setup",k[k.Archive=1]="Archive",k[k.Snap=2]="Snap"})(C=e.UpdateType||(e.UpdateType={})),e.State={Uninitialized:{type:"uninitialized"},Idle:(k,n)=>({type:"idle",updateType:k,error:n}),CheckingForUpdates:k=>({type:"checking for updates",explicit:k}),AvailableForDownload:k=>({type:"available for download",update:k}),Downloading:k=>({type:"downloading",update:k}),Downloaded:k=>({type:"downloaded",update:k}),Updating:k=>({type:"updating",update:k}),Ready:k=>({type:"ready",update:k})},e.IUpdateService=(0,p.createDecorator)("updateService")}),define(x[209],ee([0,1,3,153,57,40]),function(V,e,p,R,C,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),k.Registry.as(C.Extensions.Configuration).registerConfiguration({id:"update",order:15,title:(0,R.localize)(0,null),type:"object",properties:{"update.mode":{type:"string",enum:["none","manual","start","default"],default:"default",scope:1,description:(0,R.localize)(1,null),tags:["usesOnlineServices"],enumDescriptions:[(0,R.localize)(2,null),(0,R.localize)(3,null),(0,R.localize)(4,null),(0,R.localize)(5,null)]},"update.channel":{type:"string",default:"default",scope:1,description:(0,R.localize)(6,null),deprecationMessage:(0,R.localize)(7,null,"update.mode")},"update.enableWindowsBackgroundUpdates":{type:"boolean",default:!0,scope:1,title:(0,R.localize)(8,null),description:(0,R.localize)(9,null),included:p.isWindows&&!p.isWeb},"update.showReleaseNotes":{type:"boolean",default:!0,scope:1,description:(0,R.localize)(10,null),tags:["usesOnlineServices"]}}})}),define(x[210],ee([0,1,4,41]),function(V,e,p,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UpdateChannelClient=e.UpdateChannel=void 0;class C{constructor(I){this.service=I}listen(I,d){switch(d){case"onStateChange":return this.service.onStateChange}throw new Error(`Event not found: ${d}`)}call(I,d,f){switch(d){case"checkForUpdates":return this.service.checkForUpdates(f);case"downloadUpdate":return this.service.downloadUpdate();case"applyUpdate":return this.service.applyUpdate();case"quitAndInstall":return this.service.quitAndInstall();case"_getInitialState":return Promise.resolve(this.service.state);case"isLatestVersion":return this.service.isLatestVersion()}throw new Error(`Call not found: ${d}`)}}e.UpdateChannel=C;class k{constructor(I){this.channel=I,this._onStateChange=new p.Emitter,this.onStateChange=this._onStateChange.event,this._state=R.State.Uninitialized,this.channel.listen("onStateChange")(d=>this.state=d),this.channel.call("_getInitialState").then(d=>this.state=d)}get state(){return this._state}set state(I){this._state=I,this._onStateChange.fire(I)}checkForUpdates(I){return this.channel.call("checkForUpdates",I)}downloadUpdate(){return this.channel.call("downloadUpdate")}applyUpdate(){return this.channel.call("applyUpdate")}quitAndInstall(){return this.channel.call("quitAndInstall")}isLatestVersion(){return this.channel.call("isLatestVersion")}}e.UpdateChannelClient=k}),define(x[99],ee([0,1,5]),function(V,e,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IURLService=void 0,e.IURLService=(0,p.createDecorator)("urlService")}),define(x[211],ee([0,1,7]),function(V,e,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.URLHandlerRouter=e.URLHandlerChannelClient=e.URLHandlerChannel=void 0;class R{constructor(I){this.handler=I}listen(I,d){throw new Error(`Event not found: ${d}`)}call(I,d,f){switch(d){case"handleURL":return this.handler.handleURL(p.URI.revive(f[0]),f[1])}throw new Error(`Call not found: ${d}`)}}e.URLHandlerChannel=R;class C{constructor(I){this.channel=I}handleURL(I,d){return this.channel.call("handleURL",[I.toJSON(),d])}}e.URLHandlerChannelClient=C;class k{constructor(I){this.next=I}async routeCall(I,d,f,y){if(d!=="handleURL")throw new Error(`Call not found: ${d}`);if(f){const E=p.URI.revive(f);if(E&&E.query){const g=/\bwindowId=(\d+)/.exec(E.query);if(g){const S=g[1],t=new RegExp(`window:${S}`),m=I.connections.find(v=>t.test(v.ctx));if(m)return m}}}return this.next.routeCall(I,d,f,y)}routeEvent(I,d){throw new Error(`Event not found: ${d}`)}}e.URLHandlerRouter=k}),define(x[212],ee([0,1,9,2,7,22]),function(V,e,p,R,C,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeURLService=e.AbstractURLService=void 0;class n extends R.Disposable{constructor(){super(...arguments);this.handlers=new Set}open(f,y){const E=[...this.handlers.values()];return(0,p.first)(E.map(g=>()=>g.handleURL(f,y)),void 0,!1).then(g=>g||!1)}registerHandler(f){return this.handlers.add(f),(0,R.toDisposable)(()=>this.handlers.delete(f))}}e.AbstractURLService=n;let I=class extends n{constructor(f){super();this.productService=f}create(f){let{authority:y,path:E,query:g,fragment:S}=f||{authority:void 0,path:void 0,query:void 0,fragment:void 0};return y&&E&&E.indexOf("/")!==0&&(E=`/${E}`),C.URI.from({scheme:this.productService.urlProtocol,authority:y,path:E,query:g,fragment:S})}};I=fe([te(0,k.IProductService)],I),e.NativeURLService=I}),define(x[213],ee([0,1,14,9,4,2,3,7]),function(V,e,p,R,C,k,n,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ElectronURLListener=void 0;function d(y){try{return I.URI.parse(y)}catch(E){return null}}class f{constructor(E,g,S,t,m){if(this.urlService=g,this.uris=[],this.retryCount=0,this.flushDisposable=k.Disposable.None,this.disposables=new k.DisposableStore,this.uris=E,n.isWindows){const P=t.isBuilt?[]:[`"${t.appRoot}"`];P.push("--open-url","--"),p.app.setAsDefaultProtocolClient(m.urlProtocol,process.execPath,P)}const v=C.Event.map(C.Event.fromNodeEventEmitter(p.app,"open-url",(P,c)=>({event:P,url:c})),({event:P,url:c})=>(P.preventDefault(),c));this.disposables.add(v(P=>{const c=d(P);!c||this.urlService.open(c,{originalUrl:P})})),S.getWindows().filter(P=>P.isReady).length>0?this.flush():C.Event.once(S.onDidSignalReadyWindow)(this.flush,this,this.disposables)}async flush(){if(this.retryCount++>10)return;const E=[];for(const g of this.uris)await this.urlService.open(g.uri,{originalUrl:g.url})||E.push(g);E.length!==0&&(this.uris=E,this.flushDisposable=(0,R.disposableTimeout)(()=>this.flush(),500))}dispose(){this.disposables.dispose(),this.flushDisposable.dispose()}}e.ElectronURLListener=f}),define(x[214],ee([0,1,5]),function(V,e,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IWebviewManagerService=void 0,e.IWebviewManagerService=(0,p.createDecorator)("webviewManagerService")}),define(x[215],ee([0,1,14,2,10,7]),function(V,e,p,R,C,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WebviewProtocolProvider=void 0;class n extends R.Disposable{constructor(){super();const d=this.handleWebviewRequest.bind(this);p.protocol.registerFileProtocol(C.Schemas.vscodeWebview,d)}handleWebviewRequest(d,f){try{const y=k.URI.parse(d.url),E=n.validWebviewFilePaths.get(y.path);if(typeof E=="string"){const g=`vs/workbench/contrib/webview/browser/pre/${E}`,S=C.FileAccess.asFileUri(g,V);return f(decodeURIComponent(S.fsPath))}else return f({error:-10})}catch{}return f({error:-2})}}e.WebviewProtocolProvider=n,n.validWebviewFilePaths=new Map([["/index.html","index.html"],["/fake.html","fake.html"],["/main.js","main.js"],["/service-worker.js","service-worker.js"]])}),define(x[67],ee([0,1,3]),function(V,e,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.zoomLevelToZoomFactor=e.getTitleBarStyle=e.getMenuBarVisibility=e.isFileToOpen=e.isFolderToOpen=e.isWorkspaceToOpen=e.WindowMinimumSize=void 0,e.WindowMinimumSize={WIDTH:400,WIDTH_WITH_VERTICAL_PANEL:600,HEIGHT:270};function R(f){return!!f.workspaceUri}e.isWorkspaceToOpen=R;function C(f){return!!f.folderUri}e.isFolderToOpen=C;function k(f){return!!f.fileUri}e.isFileToOpen=k;function n(f){const y=I(f),E=f.getValue("window.menuBarVisibility");return E==="default"||y==="native"&&E==="compact"||p.isMacintosh&&p.isNative?"classic":E}e.getMenuBarVisibility=n;function I(f){if(p.isWeb)return"custom";const y=f.getValue("window");if(y){if(p.isMacintosh&&y.nativeTabs===!0||p.isMacintosh&&y.nativeFullScreen===!1)return"native";const S=f.getValue("workbench.colorCustomizations");if(S?.["window.activeBorder"]||S?.["window.inactiveBorder"])return"custom";const t=y.titleBarStyle;if(t==="native"||t==="custom")return t}return p.isLinux?"native":"custom"}e.getTitleBarStyle=I;function d(f=0){return Math.pow(1.2,f)}e.zoomLevelToZoomFactor=d}),define(x[36],ee([0,1,5]),function(V,e,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IWindowsMainService=e.WindowError=e.WindowMode=e.defaultWindowState=e.OpenContext=e.UnloadReason=e.LoadReason=void 0;var R;(function(f){f[f.INITIAL=1]="INITIAL",f[f.LOAD=2]="LOAD",f[f.RELOAD=3]="RELOAD"})(R=e.LoadReason||(e.LoadReason={}));var C;(function(f){f[f.CLOSE=1]="CLOSE",f[f.QUIT=2]="QUIT",f[f.RELOAD=3]="RELOAD",f[f.LOAD=4]="LOAD"})(C=e.UnloadReason||(e.UnloadReason={}));var k;(function(f){f[f.CLI=0]="CLI",f[f.DOCK=1]="DOCK",f[f.MENU=2]="MENU",f[f.DIALOG=3]="DIALOG",f[f.DESKTOP=4]="DESKTOP",f[f.API=5]="API"})(k=e.OpenContext||(e.OpenContext={}));const n=function(f=1){return{width:1024,height:768,mode:f}};e.defaultWindowState=n;var I;(function(f){f[f.Maximized=0]="Maximized",f[f.Normal=1]="Normal",f[f.Minimized=2]="Minimized",f[f.Fullscreen=3]="Fullscreen"})(I=e.WindowMode||(e.WindowMode={}));var d;(function(f){f[f.UNRESPONSIVE=1]="UNRESPONSIVE",f[f.CRASHED=2]="CRASHED",f[f.LOAD=3]="LOAD"})(d=e.WindowError||(e.WindowError={})),e.IWindowsMainService=(0,p.createDecorator)("windowsMainService")}),define(x[216],ee([0,1,14,4,2,215,36]),function(V,e,p,R,C,k,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WebviewMainService=void 0;let I=class extends C.Disposable{constructor(f){super();this.windowsMainService=f,this._onFoundInFrame=this._register(new R.Emitter),this.onFoundInFrame=this._onFoundInFrame.event,this._register(new k.WebviewProtocolProvider)}async setIgnoreMenuShortcuts(f,y){let E;if(typeof f.windowId=="number"){const{windowId:g}=f,S=this.windowsMainService.getWindowById(g);if(!S?.win)throw new Error(`Invalid windowId: ${g}`);E=S.win.webContents}else{const{webContentsId:g}=f;if(E=p.webContents.fromId(g),!E)throw new Error(`Invalid webContentsId: ${g}`)}E.isDestroyed()||E.setIgnoreMenuShortcuts(y)}async findInFrame(f,y,E,g){const S=this.getFrameByName(f,y),t=S;if(typeof t.findInFrame=="function"){t.findInFrame(E,{findNext:g.findNext,forward:g.forward});const m=(v,b)=>{b.finalUpdate&&(this._onFoundInFrame.fire(b),S.removeListener("found-in-frame",m))};S.on("found-in-frame",m)}}async stopFindInFrame(f,y,E){const S=this.getFrameByName(f,y);typeof S.stopFindInFrame=="function"&&S.stopFindInFrame(E.keepSelection?"keepSelection":"clearSelection")}getFrameByName(f,y){const E=this.windowsMainService.getWindowById(f.windowId);if(!E?.win)throw new Error(`Invalid windowId: ${f}`);const g=E.win.webContents.mainFrame.framesInSubtree.find(S=>S.name===y);if(!g)throw new Error(`Unknown frame: ${y}`);return g}};I=fe([te(0,n.IWindowsMainService)],I),e.WebviewMainService=I}),define(x[217],ee([0,1,9,4,2]),function(V,e,p,R,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ActiveWindowManager=void 0;class k extends C.Disposable{constructor({onDidOpenWindow:I,onDidFocusWindow:d,getActiveWindowId:f}){super();this.disposables=this._register(new C.DisposableStore),R.Event.latch(R.Event.any(I,d))(this.setActiveWindow,this,this.disposables),this.firstActiveWindowIdPromise=(0,p.createCancelablePromise)(()=>f()),(async()=>{try{const E=await this.firstActiveWindowIdPromise;this.activeWindowId=typeof this.activeWindowId=="number"?this.activeWindowId:E}catch(E){}finally{this.firstActiveWindowIdPromise=void 0}})()}setActiveWindow(I){this.firstActiveWindowIdPromise&&(this.firstActiveWindowIdPromise.cancel(),this.firstActiveWindowIdPromise=void 0),this.activeWindowId=I}async getActiveClientId(){return`window:${this.firstActiveWindowIdPromise?await this.firstActiveWindowIdPromise:this.activeWindowId}`}}e.ActiveWindowManager=k}),define(x[218],ee([0,1,39,15,7,5]),function(V,e,p,R,C,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toWorkspaceFolder=e.WorkspaceFolder=e.Workspace=e.isWorkspaceFolder=e.isWorkspace=e.WorkbenchState=e.IWorkspaceContextService=void 0,e.IWorkspaceContextService=(0,k.createDecorator)("contextService");var n;(function(g){g[g.EMPTY=1]="EMPTY",g[g.FOLDER=2]="FOLDER",g[g.WORKSPACE=3]="WORKSPACE"})(n=e.WorkbenchState||(e.WorkbenchState={}));function I(g){const S=g;return!!(S&&typeof S=="object"&&typeof S.id=="string"&&Array.isArray(S.folders))}e.isWorkspace=I;function d(g){const S=g;return!!(S&&typeof S=="object"&&C.URI.isUri(S.uri)&&typeof S.name=="string"&&typeof S.toResource=="function")}e.isWorkspaceFolder=d;class f{constructor(S,t,m,v,b){this._id=S,this._transient=m,this._configuration=v,this._ignorePathCasing=b,this._foldersMap=p.TernarySearchTree.forUris(this._ignorePathCasing),this.folders=t}update(S){this._id=S.id,this._configuration=S.configuration,this._transient=S.transient,this._ignorePathCasing=S._ignorePathCasing,this.folders=S.folders}get folders(){return this._folders}set folders(S){this._folders=S,this.updateFoldersMap()}get id(){return this._id}get transient(){return this._transient}get configuration(){return this._configuration}set configuration(S){this._configuration=S}getFolder(S){return S&&this._foldersMap.findSubstr(S.with({scheme:S.scheme,authority:S.authority,path:S.path}))||null}updateFoldersMap(){this._foldersMap=p.TernarySearchTree.forUris(this._ignorePathCasing);for(const S of this.folders)this._foldersMap.set(S.uri,S)}toJSON(){return{id:this.id,folders:this.folders,transient:this.transient,configuration:this.configuration}}}e.Workspace=f;class y{constructor(S,t){this.raw=t,this.uri=S.uri,this.index=S.index,this.name=S.name}toResource(S){return(0,R.joinPath)(this.uri,S)}toJSON(){return{uri:this.uri,name:this.name,index:this.index}}}e.WorkspaceFolder=y;function E(g){return new y({uri:g,index:0,name:(0,R.basenameOrAuthority)(g)},{uri:g.toString()})}e.toWorkspaceFolder=E}),define(x[27],ee([0,1,32,38,78,33,10,8,3,15,7,156,5,64,218]),function(V,e,p,R,C,k,n,I,d,f,y,E,g,S,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toStoreData=e.restoreRecentlyOpened=e.useSlashForPath=e.rewriteWorkspaceFileForNewLocation=e.toWorkspaceFolders=e.getStoredWorkspaceFolder=e.isRawUriWorkspaceFolder=e.isRawFileWorkspaceFolder=e.isStoredWorkspaceFolder=e.isUntitledWorkspace=e.reviveIdentifier=e.isWorkspaceIdentifier=e.toWorkspaceIdentifier=e.isSingleFolderWorkspaceIdentifier=e.isRecentFile=e.isRecentFolder=e.isRecentWorkspace=e.IWorkspacesService=e.hasWorkspaceFileExtension=e.UNTITLED_WORKSPACE_NAME=e.WORKSPACE_FILTER=e.WORKSPACE_EXTENSION=void 0,e.WORKSPACE_EXTENSION="code-workspace";const m=`.${e.WORKSPACE_EXTENSION}`;e.WORKSPACE_FILTER=[{name:(0,E.localize)(0,null),extensions:[e.WORKSPACE_EXTENSION]}],e.UNTITLED_WORKSPACE_NAME="workspace.json";function v(W){return(typeof W=="string"?(0,I.extname)(W):(0,f.extname)(W))===m}e.hasWorkspaceFileExtension=v,e.IWorkspacesService=(0,g.createDecorator)("workspacesService");function b(W){return W.hasOwnProperty("workspace")}e.isRecentWorkspace=b;function P(W){return W.hasOwnProperty("folderUri")}e.isRecentFolder=P;function c(W){return W.hasOwnProperty("fileUri")}e.isRecentFile=c;function a(W){const N=W;return typeof N?.id=="string"&&y.URI.isUri(N.uri)}e.isSingleFolderWorkspaceIdentifier=a;function l(W){if(W.configuration)return{id:W.id,configPath:W.configuration};if(W.folders.length===1)return{id:W.id,uri:W.folders[0].uri}}e.toWorkspaceIdentifier=l;function o(W){const N=W;return typeof N?.id=="string"&&y.URI.isUri(N.configPath)}e.isWorkspaceIdentifier=o;function u(W){const N=W;if(N?.uri)return{id:N.id,uri:y.URI.revive(N.uri)};const G=W;if(G?.configPath)return{id:G.id,configPath:y.URI.revive(G.configPath)};if(W?.id)return{id:W.id}}e.reviveIdentifier=u;function r(W,N){return f.extUriBiasedIgnorePathCase.isEqualOrParent(W,N.untitledWorkspacesHome)}e.isUntitledWorkspace=r;function i(W){return s(W)||h(W)}e.isStoredWorkspaceFolder=i;function s(W){const N=W;return typeof N?.path=="string"&&(!N.name||typeof N.name=="string")}e.isRawFileWorkspaceFolder=s;function h(W){const N=W;return typeof N?.uri=="string"&&(!N.name||typeof N.name=="string")}e.isRawUriWorkspaceFolder=h;function w(W,N,G,Q,H=!d.isWindows,$){if(W.scheme!==Q.scheme)return{name:G,uri:W.toString(!0)};let J=N?void 0:$.relativePath(Q,W);if(J!==void 0)J.length===0?J=".":d.isWindows&&W.scheme===n.Schemas.file&&!H&&(J=J.replace(/\//g,"\\"));else if(W.scheme===n.Schemas.file)J=W.fsPath,d.isWindows&&(J=(0,k.normalizeDriveLetter)(J),H&&(J=(0,p.toSlashes)(J)));else{if(!$.isEqualAuthority(W.authority,Q.authority))return{name:G,uri:W.toString(!0)};J=W.path}return{name:G,path:J}}e.getStoredWorkspaceFolder=w;function M(W,N,G){let Q=[],H=new Set;const $=G.dirname(N);for(let J of W){let O;if(s(J))J.path&&(O=G.resolvePath($,J.path));else if(h(J))try{O=y.URI.parse(J.uri),O.path[0]!=="/"&&(O=O.with({path:"/"+O.path}))}catch(D){console.warn(D)}if(O){let D=G.getComparisonKey(O);if(!H.has(D)){H.add(D);const T=J.name||G.basenameOrAuthority(O);Q.push(new t.WorkspaceFolder({uri:O,name:T,index:Q.length},J))}}}return Q}e.toWorkspaceFolders=M;function A(W,N,G,Q,H){let $=L(N,W);const J=H.dirname(N),O=H.dirname(Q),D=[],T=F($.folders);for(const B of $.folders){const q=s(B)?H.resolvePath(J,B.path):y.URI.parse(B.uri);let ne;G?ne=!1:ne=!s(B)||(0,I.isAbsolute)(B.path),D.push(w(q,ne,B.name,O,T,H))}const _={insertSpaces:!1,tabSize:4,eol:d.isLinux||d.isMacintosh?`
`:`\r
`},z=C.setProperty(W,["folders"],D,_);let X=C.applyEdits(W,z);return(0,f.isEqualAuthority)($.remoteAuthority,(0,S.getRemoteAuthority)(Q))&&(X=C.applyEdits(X,C.removeProperty(X,["remoteAuthority"],_))),X}e.rewriteWorkspaceFileForNewLocation=A;function L(W,N){let G=R.parse(N);if(G&&Array.isArray(G.folders))G.folders=G.folders.filter(Q=>i(Q));else throw new Error(`${W} looks like an invalid workspace file.`);return G}function F(W){return d.isWindows?W.some(N=>s(N)&&N.path.indexOf("/")>=0):!0}e.useSlashForPath=F;function U(W){return W.workspace&&typeof W.workspace=="object"&&typeof W.workspace.id=="string"&&typeof W.workspace.configPath=="string"}function Y(W){return typeof W.folderUri=="string"}function ie(W){return typeof W.fileUri=="string"}function re(W,N){const G={workspaces:[],files:[]};if(W){const Q=function($,J){for(let O=0;O<$.length;O++)try{J($[O],O)}catch(D){N.warn(`Error restoring recent entry ${JSON.stringify($[O])}: ${D.toString()}. Skip entry.`)}},H=W;if(Array.isArray(H.entries))Q(H.entries,$=>{const J=$.label,O=$.remoteAuthority;U($)?G.workspaces.push({label:J,remoteAuthority:O,workspace:{id:$.workspace.id,configPath:y.URI.parse($.workspace.configPath)}}):Y($)?G.workspaces.push({label:J,remoteAuthority:O,folderUri:y.URI.parse($.folderUri)}):ie($)&&G.files.push({label:J,remoteAuthority:O,fileUri:y.URI.parse($.fileUri)})});else{const $=W;Array.isArray($.workspaces3)&&Q($.workspaces3,(J,O)=>{const D=Array.isArray($.workspaceLabels)&&$.workspaceLabels[O]||void 0;typeof J=="object"&&typeof J.id=="string"&&typeof J.configURIPath=="string"?G.workspaces.push({label:D,workspace:{id:J.id,configPath:y.URI.parse(J.configURIPath)}}):typeof J=="string"&&G.workspaces.push({label:D,folderUri:y.URI.parse(J)})}),Array.isArray($.files2)&&Q($.files2,(J,O)=>{const D=Array.isArray($.fileLabels)&&$.fileLabels[O]||void 0;typeof J=="string"&&G.files.push({label:D,fileUri:y.URI.parse(J)})})}}return G}e.restoreRecentlyOpened=re;function K(W){const N={entries:[]};for(const G of W.workspaces)P(G)?N.entries.push({folderUri:G.folderUri.toString(),label:G.label,remoteAuthority:G.remoteAuthority}):N.entries.push({workspace:{id:G.workspace.id,configPath:G.workspace.configPath.toString()},label:G.label,remoteAuthority:G.remoteAuthority});for(const G of W.files)N.entries.push({fileUri:G.fileUri.toString(),label:G.label,remoteAuthority:G.remoteAuthority});return N}e.toStoreData=K}),define(x[50],ee([0,1,5,27]),function(V,e,p,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isWorkspaceBackupInfo=e.IBackupMainService=void 0,e.IBackupMainService=(0,p.createDecorator)("backupMainService");function C(k){const n=k;return n&&(0,R.isWorkspaceIdentifier)(n.workspace)}e.isWorkspaceBackupInfo=C}),define(x[51],ee([0,1,14,9,81,33,2,70,8,3,13,21,136,5,6,37,27]),function(V,e,p,R,C,k,n,I,d,f,y,E,g,S,t,m,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DialogMainService=e.IDialogMainService=void 0,e.IDialogMainService=(0,S.createDecorator)("dialogMainService");let b=class vt{constructor(c,a){this.stateMainService=c,this.logService=a,this.windowFileDialogLocks=new Map,this.windowDialogQueues=new Map,this.noWindowDialogueQueue=new R.Queue}pickFileFolder(c,a){return this.doPick({...c,pickFolders:!0,pickFiles:!0,title:(0,g.localize)(0,null)},a)}pickFolder(c,a){return this.doPick({...c,pickFolders:!0,title:(0,g.localize)(1,null)},a)}pickFile(c,a){return this.doPick({...c,pickFiles:!0,title:(0,g.localize)(2,null)},a)}pickWorkspace(c,a){const l=(0,g.localize)(3,null),o=(0,k.mnemonicButtonLabel)((0,g.localize)(4,null)),u=v.WORKSPACE_FILTER;return this.doPick({...c,pickFiles:!0,title:l,filters:u,buttonLabel:o},a)}async doPick(c,a){const l={title:c.title,buttonLabel:c.buttonLabel,filters:c.filters};l.defaultPath=c.defaultPath||this.stateMainService.getItem(vt.workingDirPickerStorageKey),(typeof c.pickFiles=="boolean"||typeof c.pickFolders=="boolean")&&(l.properties=void 0,c.pickFiles&&c.pickFolders&&(l.properties=["multiSelections","openDirectory","openFile","createDirectory"])),l.properties||(l.properties=["multiSelections",c.pickFolders?"openDirectory":"openFile","createDirectory"]),f.isMacintosh&&l.properties.push("treatPackageAsDirectory");const o=a||p.BrowserWindow.getFocusedWindow(),u=await this.showOpenDialog(l,(0,y.withNullAsUndefined)(o));if(u&&u.filePaths&&u.filePaths.length>0)return this.stateMainService.setItem(vt.workingDirPickerStorageKey,(0,d.dirname)(u.filePaths[0])),u.filePaths}getWindowDialogQueue(c){if(c){let a=this.windowDialogQueues.get(c.id);return a||(a=new R.Queue,this.windowDialogQueues.set(c.id,a)),a}else return this.noWindowDialogueQueue}showMessageBox(c,a){return this.getWindowDialogQueue(a).queue(async()=>a?p.dialog.showMessageBox(a,c):p.dialog.showMessageBox(c))}async showSaveDialog(c,a){const l=this.acquireFileDialogLock(c,a);if(!l)return this.logService.error("[DialogMainService]: file save dialog is already or will be showing for the window with the same configuration"),{canceled:!0};try{return await this.getWindowDialogQueue(a).queue(async()=>{let o;return a?o=await p.dialog.showSaveDialog(a,c):o=await p.dialog.showSaveDialog(c),o.filePath=this.normalizePath(o.filePath),o})}finally{(0,n.dispose)(l)}}normalizePath(c){return c&&f.isMacintosh&&(c=(0,I.normalizeNFC)(c)),c}normalizePaths(c){return c.map(a=>this.normalizePath(a))}async showOpenDialog(c,a){c.defaultPath&&(await E.Promises.exists(c.defaultPath)||(c.defaultPath=void 0));const l=this.acquireFileDialogLock(c,a);if(!l)return this.logService.error("[DialogMainService]: file open dialog is already or will be showing for the window with the same configuration"),{canceled:!0,filePaths:[]};try{return await this.getWindowDialogQueue(a).queue(async()=>{let o;return a?o=await p.dialog.showOpenDialog(a,c):o=await p.dialog.showOpenDialog(c),o.filePaths=this.normalizePaths(o.filePaths),o})}finally{(0,n.dispose)(l)}}acquireFileDialogLock(c,a){if(!a)return n.Disposable.None;let l=this.windowFileDialogLocks.get(a.id);l||(l=new Set,this.windowFileDialogLocks.set(a.id,l));const o=(0,C.hash)(c);if(!l.has(o))return l.add(o),(0,n.toDisposable)(()=>{l?.delete(o),l?.size===0&&this.windowFileDialogLocks.delete(a.id)})}};b.workingDirPickerStorageKey="pickerWorkingDir",b=fe([te(0,m.IStateMainService),te(1,t.ILogService)],b),e.DialogMainService=b}),define(x[219],ee([0,1,4,2,27]),function(V,e,p,R,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StorageDatabaseChannel=void 0;class k extends R.Disposable{constructor(I,d){super();this.logService=I,this.storageMainService=d,this._onDidChangeGlobalStorage=this._register(new p.Emitter),this.onDidChangeGlobalStorage=this._onDidChangeGlobalStorage.event,this.registerGlobalStorageListeners()}registerGlobalStorageListeners(){this._register(p.Event.debounce(this.storageMainService.globalStorage.onDidChangeStorage,(I,d)=>(I?I.push(d):I=[d],I),k.STORAGE_CHANGE_DEBOUNCE_TIME)(I=>{I.length&&this._onDidChangeGlobalStorage.fire(this.serializeGlobalStorageEvents(I))}))}serializeGlobalStorageEvents(I){const d=new Map,f=new Set;return I.forEach(y=>{const E=this.storageMainService.globalStorage.get(y.key);typeof E=="string"?d.set(y.key,E):f.add(y.key)}),{changed:Array.from(d.entries()),deleted:Array.from(f.values())}}listen(I,d){switch(d){case"onDidChangeGlobalStorage":return this.onDidChangeGlobalStorage}throw new Error(`Event not found: ${d}`)}async call(I,d,f){const y=(0,C.reviveIdentifier)(f.workspace),E=await this.withStorageInitialized(y);switch(d){case"getItems":return Array.from(E.items.entries());case"updateItems":{const g=f;if(g.insert)for(const[S,t]of g.insert)E.set(S,t);g.delete&&g.delete.forEach(S=>E.delete(S));break}case"close":{if(y)return E.close();break}default:throw new Error(`Call not found: ${d}`)}}async withStorageInitialized(I){const d=I?this.storageMainService.workspaceStorage(I):this.storageMainService.globalStorage;try{await d.init()}catch(f){this.logService.error(`StorageIPC#init: Unable to init ${I?"workspace":"global"} storage due to ${f}`)}return d}}e.StorageDatabaseChannel=k,k.STORAGE_CHANGE_DEBOUNCE_TIME=100}),define(x[220],ee([0,1,4,2,8,21,86,126,6,98,29,27]),function(V,e,p,R,C,k,n,I,d,f,y,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WorkspaceStorageMain=e.GlobalStorageMain=void 0;class g extends R.Disposable{constructor(v){super();this.logService=v,this._onDidChangeStorage=this._register(new p.Emitter),this.onDidChangeStorage=this._onDidChangeStorage.event,this._onDidCloseStorage=this._register(new p.Emitter),this.onDidCloseStorage=this._onDidCloseStorage.event,this.storage=new n.Storage(new n.InMemoryStorageDatabase),this.initializePromise=void 0}init(){return this.initializePromise||(this.initializePromise=(async()=>{try{const v=await this.doCreate();this.storage.dispose(),this.storage=v,this._register(v.onDidChangeStorage(P=>this._onDidChangeStorage.fire({key:P}))),await this.doInit(v);const b=v.getBoolean(f.IS_NEW_KEY);b===void 0?v.set(f.IS_NEW_KEY,!0):b&&v.set(f.IS_NEW_KEY,!1)}catch(v){this.logService.error(`StorageMain#initialize(): Unable to init storage due to ${v}`)}})()),this.initializePromise}createLoggingOptions(){return{logTrace:this.logService.getLevel()===d.LogLevel.Trace?v=>this.logService.trace(v):void 0,logError:v=>this.logService.error(v)}}doInit(v){return v.init()}get items(){return this.storage.items}get(v,b){return this.storage.get(v,b)}set(v,b){return this.storage.set(v,b)}delete(v){return this.storage.delete(v)}async close(){this.initializePromise&&await this.initializePromise,await this.storage.close(),this._onDidCloseStorage.fire()}}class S extends g{constructor(v,b,P){super(b);this.options=v,this.environmentService=P}async doCreate(){let v;return this.options.useInMemoryStorage?v=I.SQLiteStorageDatabase.IN_MEMORY_PATH:v=(0,C.join)(this.environmentService.globalStorageHome.fsPath,S.STORAGE_NAME),new n.Storage(new I.SQLiteStorageDatabase(v,{logging:this.createLoggingOptions()}))}async doInit(v){await super.doInit(v),this.updateTelemetryState(v)}updateTelemetryState(v){v.get(y.firstSessionDateStorageKey,void 0)===void 0&&v.set(y.firstSessionDateStorageKey,new Date().toUTCString());const P=v.get(y.currentSessionDateStorageKey,void 0),c=new Date().toUTCString();v.set(y.lastSessionDateStorageKey,typeof P=="undefined"?null:P),v.set(y.currentSessionDateStorageKey,c)}}e.GlobalStorageMain=S,S.STORAGE_NAME="state.vscdb";class t extends g{constructor(v,b,P,c){super(P);this.workspace=v,this.options=b,this.environmentService=c}async doCreate(){const{storageFilePath:v,wasCreated:b}=await this.prepareWorkspaceStorageFolder();return new n.Storage(new I.SQLiteStorageDatabase(v,{logging:this.createLoggingOptions()}),{hint:b?n.StorageHint.STORAGE_DOES_NOT_EXIST:void 0})}async prepareWorkspaceStorageFolder(){if(this.options.useInMemoryStorage)return{storageFilePath:I.SQLiteStorageDatabase.IN_MEMORY_PATH,wasCreated:!0};const v=(0,C.join)(this.environmentService.workspaceStorageHome.fsPath,this.workspace.id),b=(0,C.join)(v,t.WORKSPACE_STORAGE_NAME);return await k.Promises.exists(v)?{storageFilePath:b,wasCreated:!1}:(await k.Promises.mkdir(v,{recursive:!0}),this.ensureWorkspaceStorageFolderMeta(v),{storageFilePath:b,wasCreated:!0})}async ensureWorkspaceStorageFolderMeta(v){let b;if((0,E.isSingleFolderWorkspaceIdentifier)(this.workspace)?b={folder:this.workspace.uri.toString()}:(0,E.isWorkspaceIdentifier)(this.workspace)&&(b={workspace:this.workspace.configPath.toString()}),b)try{const P=(0,C.join)(v,t.WORKSPACE_META_NAME);await k.Promises.exists(P)||await k.Promises.writeFile(P,JSON.stringify(b,void 0,2))}catch(P){this.logService.error(`StorageMain#ensureWorkspaceStorageFolderMeta(): Unable to create workspace storage metadata due to ${P}`)}}}e.WorkspaceStorageMain=t,t.WORKSPACE_STORAGE_NAME="state.vscdb",t.WORKSPACE_META_NAME="workspace.json"}),define(x[100],ee([0,1,42,2,48,5,20,6,220]),function(V,e,p,R,C,k,n,I,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StorageMainService=e.IStorageMainService=void 0,e.IStorageMainService=(0,k.createDecorator)("storageMainService");let f=class extends R.Disposable{constructor(E,g,S){super();this.logService=E,this.environmentService=g,this.lifecycleMainService=S,this.globalStorage=this.createGlobalStorage(),this.mapWorkspaceToStorage=new Map,this.registerListeners()}getStorageOptions(){return{useInMemoryStorage:!!this.environmentService.extensionTestsLocationURI}}registerListeners(){(async()=>{await this.lifecycleMainService.when(3),this.globalStorage.init()})(),this._register(this.lifecycleMainService.onWillLoadWindow(async E=>{E.workspace&&this.workspaceStorage(E.workspace).init()})),this._register(this.lifecycleMainService.onWillShutdown(E=>{E.join(this.globalStorage.close());for(const[,g]of this.mapWorkspaceToStorage)E.join(g.close())}))}createGlobalStorage(){if(this.globalStorage)return this.globalStorage;this.logService.trace("StorageMainService: creating global storage");const E=new d.GlobalStorageMain(this.getStorageOptions(),this.logService,this.environmentService);return(0,p.once)(E.onDidCloseStorage)(()=>{this.logService.trace("StorageMainService: closed global storage")}),E}createWorkspaceStorage(E){return new d.WorkspaceStorageMain(E,this.getStorageOptions(),this.logService,this.environmentService)}workspaceStorage(E){let g=this.mapWorkspaceToStorage.get(E.id);return g||(this.logService.trace(`StorageMainService: creating workspace storage (${E.id})`),g=this.createWorkspaceStorage(E),this.mapWorkspaceToStorage.set(E.id,g),(0,p.once)(g.onDidCloseStorage)(()=>{this.logService.trace(`StorageMainService: closed workspace storage (${E.id})`),this.mapWorkspaceToStorage.delete(E.id)})),g}};f=fe([te(0,I.ILogService),te(1,C.IEnvironmentService),te(2,n.ILifecycleMainService)],f),e.StorageMainService=f}),define(x[101],ee([0,1,15,7,27]),function(V,e,p,R,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.findWindowOnExtensionDevelopmentPath=e.findWindowOnWorkspaceOrFolder=e.findWindowOnFile=void 0;function k(d,f,y){for(const g of d){const S=g.openedWorkspace;if((0,C.isWorkspaceIdentifier)(S)){const t=y(S);if(t){if(t.folders.some(m=>p.extUriBiasedIgnorePathCase.isEqualOrParent(f,m.uri)))return g}else if(p.extUriBiasedIgnorePathCase.isEqualOrParent(f,S.configPath))return g}}const E=d.filter(g=>(0,C.isSingleFolderWorkspaceIdentifier)(g.openedWorkspace)&&p.extUriBiasedIgnorePathCase.isEqualOrParent(f,g.openedWorkspace.uri));if(E.length)return E.sort((g,S)=>-(g.openedWorkspace.uri.path.length-S.openedWorkspace.uri.path.length))[0]}e.findWindowOnFile=k;function n(d,f){for(const y of d)if((0,C.isWorkspaceIdentifier)(y.openedWorkspace)&&p.extUriBiasedIgnorePathCase.isEqual(y.openedWorkspace.configPath,f)||(0,C.isSingleFolderWorkspaceIdentifier)(y.openedWorkspace)&&p.extUriBiasedIgnorePathCase.isEqual(y.openedWorkspace.uri,f))return y}e.findWindowOnWorkspaceOrFolder=n;function I(d,f){const y=E=>f.some(g=>p.extUriBiasedIgnorePathCase.isEqual(R.URI.file(g),R.URI.file(E)));for(const E of d)if(E.config?.extensionDevelopmentPath?.some(g=>y(g)))return E}e.findWindowOnExtensionDevelopmentPath=I}),define(x[221],ee([0,1,14,2,3,15,7,18,20,6,37,36,27]),function(V,e,p,R,C,k,n,I,d,f,y,E,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getWindowsStateStoreData=e.restoreWindowsState=e.WindowsStateHandler=void 0;let S=class St extends R.Disposable{constructor(c,a,l,o,u){super();this.windowsMainService=c,this.stateMainService=a,this.lifecycleMainService=l,this.logService=o,this.configurationService=u,this._state=t(this.stateMainService.getItem(St.windowsStateStorageKey)),this.lastClosedState=void 0,this.shuttingDown=!1,this.registerListeners()}get state(){return this._state}registerListeners(){p.app.on("browser-window-blur",()=>{this.shuttingDown||this.saveWindowsState()}),this.lifecycleMainService.onBeforeCloseWindow(c=>this.onBeforeCloseWindow(c)),this.lifecycleMainService.onBeforeShutdown(()=>this.onBeforeShutdown()),this.windowsMainService.onDidChangeWindowsCount(c=>{c.newCount-c.oldCount>0&&(this.lastClosedState=void 0)}),this.windowsMainService.onDidDestroyWindow(c=>this.onBeforeCloseWindow(c))}onBeforeShutdown(){this.shuttingDown=!0,this.saveWindowsState()}saveWindowsState(){const c={openedWindows:[],lastPluginDevelopmentHostWindow:this._state.lastPluginDevelopmentHostWindow,lastActiveWindow:this.lastClosedState};if(!c.lastActiveWindow){let o=this.windowsMainService.getLastActiveWindow();(!o||o.isExtensionDevelopmentHost)&&(o=this.windowsMainService.getWindows().find(u=>!u.isExtensionDevelopmentHost)),o&&(c.lastActiveWindow=this.toWindowState(o))}const a=this.windowsMainService.getWindows().find(o=>o.isExtensionDevelopmentHost&&!o.isExtensionTestHost);a&&(c.lastPluginDevelopmentHostWindow=this.toWindowState(a)),this.windowsMainService.getWindowCount()>1&&(c.openedWindows=this.windowsMainService.getWindows().filter(o=>!o.isExtensionDevelopmentHost).map(o=>this.toWindowState(o)));const l=v(c);this.stateMainService.setItem(St.windowsStateStorageKey,l),this.shuttingDown&&this.logService.trace("[WindowsStateHandler] onBeforeShutdown",l)}onBeforeCloseWindow(c){if(this.lifecycleMainService.quitRequested)return;const a=this.toWindowState(c);c.isExtensionDevelopmentHost&&!c.isExtensionTestHost?this._state.lastPluginDevelopmentHostWindow=a:!c.isExtensionDevelopmentHost&&c.openedWorkspace&&this._state.openedWindows.forEach(l=>{const o=(0,g.isWorkspaceIdentifier)(c.openedWorkspace)&&l.workspace?.id===c.openedWorkspace.id,u=(0,g.isSingleFolderWorkspaceIdentifier)(c.openedWorkspace)&&l.folderUri&&k.extUriBiasedIgnorePathCase.isEqual(l.folderUri,c.openedWorkspace.uri);(o||u)&&(l.uiState=a.uiState)}),this.windowsMainService.getWindowCount()===1&&(this.lastClosedState=a)}toWindowState(c){return{workspace:(0,g.isWorkspaceIdentifier)(c.openedWorkspace)?c.openedWorkspace:void 0,folderUri:(0,g.isSingleFolderWorkspaceIdentifier)(c.openedWorkspace)?c.openedWorkspace.uri:void 0,backupPath:c.backupPath,remoteAuthority:c.remoteAuthority,uiState:c.serializeWindowState()}}getNewWindowState(c){const a=this.doGetNewWindowState(c),l=this.configurationService.getValue("window");let o;return a.hasDefaultState?o=!!(l?.newWindowDimensions&&["fullscreen","inherit","offset"].indexOf(l.newWindowDimensions)>=0):(o=!!(this.lifecycleMainService.wasRestarted||l?.restoreFullscreen),o&&C.isMacintosh&&this.windowsMainService.getWindows().some(u=>u.isFullScreen)&&(o=!1)),a.mode===3&&!o&&(a.mode=1),a}doGetNewWindowState(c){const a=this.windowsMainService.getLastActiveWindow();if(!c.extensionTestsPath){if(!!c.extensionDevelopmentPath&&this.state.lastPluginDevelopmentHostWindow)return this.state.lastPluginDevelopmentHostWindow.uiState;const s=c.workspace;if((0,g.isWorkspaceIdentifier)(s)){const w=this.state.openedWindows.filter(M=>M.workspace&&M.workspace.id===s.id).map(M=>M.uiState);if(w.length)return w[0]}if((0,g.isSingleFolderWorkspaceIdentifier)(s)){const w=this.state.openedWindows.filter(M=>M.folderUri&&k.extUriBiasedIgnorePathCase.isEqual(M.folderUri,s.uri)).map(M=>M.uiState);if(w.length)return w[0]}else if(c.backupPath){const w=this.state.openedWindows.filter(M=>M.backupPath===c.backupPath).map(M=>M.uiState);if(w.length)return w[0]}const h=this.lastClosedState||this.state.lastActiveWindow;if(!a&&h)return h.uiState}let l;const o=p.screen.getAllDisplays();if(o.length===1)l=o[0];else{if(C.isMacintosh){const s=p.screen.getCursorScreenPoint();l=p.screen.getDisplayNearestPoint(s)}!l&&a&&(l=p.screen.getDisplayMatching(a.getBounds())),l||(l=p.screen.getPrimaryDisplay()||o[0])}let u=(0,E.defaultWindowState)();u.x=Math.round(l.bounds.x+l.bounds.width/2-u.width/2),u.y=Math.round(l.bounds.y+l.bounds.height/2-u.height/2);const r=this.configurationService.getValue("window");let i=!0;if(r?.newWindowDimensions){if(r.newWindowDimensions==="maximized")u.mode=0,i=!1;else if(r.newWindowDimensions==="fullscreen")u.mode=3,i=!1;else if((r.newWindowDimensions==="inherit"||r.newWindowDimensions==="offset")&&a){const s=a.serializeWindowState();s.mode===3?u.mode=3:u=s,i=u.mode!==3&&r.newWindowDimensions==="offset"}}return i&&(u=this.ensureNoOverlap(u)),u.hasDefaultState=!0,u}ensureNoOverlap(c){if(this.windowsMainService.getWindows().length===0)return c;c.x=typeof c.x=="number"?c.x:0,c.y=typeof c.y=="number"?c.y:0;const a=this.windowsMainService.getWindows().map(l=>l.getBounds());for(;a.some(l=>l.x===c.x||l.y===c.y);)c.x+=30,c.y+=30;return c}};S.windowsStateStorageKey="windowsState",S=fe([te(0,E.IWindowsMainService),te(1,y.IStateMainService),te(2,d.ILifecycleMainService),te(3,f.ILogService),te(4,I.IConfigurationService)],S),e.WindowsStateHandler=S;function t(P){const c={openedWindows:[]},a=P||{openedWindows:[]};return a.lastActiveWindow&&(c.lastActiveWindow=m(a.lastActiveWindow)),a.lastPluginDevelopmentHostWindow&&(c.lastPluginDevelopmentHostWindow=m(a.lastPluginDevelopmentHostWindow)),Array.isArray(a.openedWindows)&&(c.openedWindows=a.openedWindows.map(l=>m(l))),c}e.restoreWindowsState=t;function m(P){const c={uiState:P.uiState};return P.backupPath&&(c.backupPath=P.backupPath),P.remoteAuthority&&(c.remoteAuthority=P.remoteAuthority),P.folder&&(c.folderUri=n.URI.parse(P.folder)),P.workspaceIdentifier&&(c.workspace={id:P.workspaceIdentifier.id,configPath:n.URI.parse(P.workspaceIdentifier.configURIPath)}),c}function v(P){return{lastActiveWindow:P.lastActiveWindow&&b(P.lastActiveWindow),lastPluginDevelopmentHostWindow:P.lastPluginDevelopmentHostWindow&&b(P.lastPluginDevelopmentHostWindow),openedWindows:P.openedWindows.map(c=>b(c))}}e.getWindowsStateStoreData=v;function b(P){return{workspaceIdentifier:P.workspace&&{id:P.workspace.id,configURIPath:P.workspace.configPath.toString()},folder:P.folderUri&&P.folderUri.toString(),backupPath:P.backupPath,remoteAuthority:P.remoteAuthority,uiState:P.uiState}}}),define(x[102],ee([0,1,61,28,10,3,15]),function(V,e,p,R,C,k,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getSingleFolderWorkspaceIdentifier=e.getWorkspaceIdentifier=void 0;function I(f){function y(){let E=f.scheme===C.Schemas.file?(0,n.originalFSPath)(f):f.toString();return k.isLinux||(E=E.toLowerCase()),(0,p.createHash)("md5").update(E).digest("hex")}return{id:y(),configPath:f}}e.getWorkspaceIdentifier=I;function d(f,y){function E(){if(f.scheme!==C.Schemas.file)return(0,p.createHash)("md5").update(f.toString()).digest("hex");if(!y)try{y=(0,R.statSync)(f.fsPath)}catch(t){return}let S;return k.isLinux?S=y.ino:k.isMacintosh?S=y.birthtime.getTime():k.isWindows&&(typeof y.birthtimeMs=="number"?S=Math.floor(y.birthtimeMs):S=y.birthtime.getTime()),(0,p.createHash)("md5").update(f.fsPath).update(S?String(S):"").digest("hex")}const g=E();if(typeof g=="string")return{id:g,uri:f}}e.getSingleFolderWorkspaceIdentifier=d}),define(x[222],ee([0,1,16,10,6,250,113,20]),function(V,e,p,R,C,k,n,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WorkerMainProcessExtensionHostStarter=void 0;class d{constructor(g,S){this._worker=new k.Worker(R.FileAccess.asFileUri("vs/platform/extensions/node/extensionHostStarterWorkerMain.js",V).fsPath),this._worker.on("message",g),this._worker.on("error",S)}getId(){return 1}postMessage(g,S){this._worker.postMessage(g,S)}dispose(){this._worker.terminate()}}let f=class{constructor(g){this._logService=g}async logInfo(g){this._logService.info(g)}};f=fe([te(0,C.ILogService)],f);let y=class{constructor(g,S){this._logService=g,this._shutdown=!1,this._proxy=null;const t={create:(m,v,b)=>{const P=new d(v,b);return P.postMessage(m,[]),P}};this._worker=new n.SimpleWorkerClient(t,"vs/platform/extensions/node/extensionHostStarterWorker",new f(this._logService)),this._initialize(),S.onWillShutdown(m=>{this._shutdown=!0,this._proxy&&m.join(this._proxy.waitForAllExit(6e3))})}dispose(){}async _initialize(){this._proxy=await this._worker.getProxyObject(),this._logService.info("ExtensionHostStarterWorker created")}onDynamicStdout(g){return this._proxy.onDynamicStdout(g)}onDynamicStderr(g){return this._proxy.onDynamicStderr(g)}onDynamicMessage(g){return this._proxy.onDynamicMessage(g)}onDynamicError(g){return this._proxy.onDynamicError(g)}onDynamicExit(g){return this._proxy.onDynamicExit(g)}async createExtensionHost(){const g=await this._worker.getProxyObject();if(this._shutdown)throw(0,p.canceled)();return g.createExtensionHost()}async start(g,S){const t=await this._worker.getProxyObject();if(this._shutdown)throw(0,p.canceled)();return t.start(g,S)}async enableInspectPort(g){const S=await this._worker.getProxyObject();if(this._shutdown)throw(0,p.canceled)();return S.enableInspectPort(g)}async kill(g){const S=await this._worker.getProxyObject();if(this._shutdown)throw(0,p.canceled)();return S.kill(g)}};y=fe([te(0,C.ILogService),te(1,I.ILifecycleMainService)],y),e.WorkerMainProcessExtensionHostStarter=y}),define(x[58],ee([0,1,61,62,26,17,16,4,2,8,3,31,35,84,223]),function(V,e,p,R,C,k,n,I,d,f,y,E,g,S,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.connect=e.serve=e.Server=e.createStaticIPCHandle=e.createRandomIPCHandle=e.XDG_RUNTIME_DIR=e.WebSocketNodeSocket=e.NodeSocket=void 0;class m{constructor(L,F=""){this.debugLabel=F,this.socket=L,this.traceSocketEvent("created",{type:"NodeSocket"}),this._errorListener=U=>{if(this.traceSocketEvent("error",{code:U?.code,message:U?.message}),U){if(U.code==="EPIPE")return;(0,n.onUnexpectedError)(U)}},this.socket.on("error",this._errorListener)}traceSocketEvent(L,F){S.SocketDiagnostics.traceSocketEvent(this.socket,this.debugLabel,L,F)}dispose(){this.socket.off("error",this._errorListener),this.socket.destroy()}onData(L){const F=U=>{this.traceSocketEvent("read",U),L(k.VSBuffer.wrap(U))};return this.socket.on("data",F),{dispose:()=>this.socket.off("data",F)}}onClose(L){const F=U=>{this.traceSocketEvent("close",{hadError:U}),L({type:0,hadError:U,error:void 0})};return this.socket.on("close",F),{dispose:()=>this.socket.off("close",F)}}onEnd(L){const F=()=>{this.traceSocketEvent("nodeEndReceived"),L()};return this.socket.on("end",F),{dispose:()=>this.socket.off("end",F)}}write(L){if(!this.socket.destroyed)try{this.traceSocketEvent("write",L),this.socket.write(L.buffer,F=>{if(F){if(F.code==="EPIPE")return;(0,n.onUnexpectedError)(F)}})}catch(F){if(F.code==="EPIPE")return;(0,n.onUnexpectedError)(F)}}end(){this.traceSocketEvent("nodeEndSent"),this.socket.end()}drain(){return this.traceSocketEvent("nodeDrainBegin"),new Promise((L,F)=>{if(this.socket.bufferSize===0){this.traceSocketEvent("nodeDrainEnd"),L();return}const U=()=>{this.socket.off("close",U),this.socket.off("end",U),this.socket.off("error",U),this.socket.off("timeout",U),this.socket.off("drain",U),this.traceSocketEvent("nodeDrainEnd"),L()};this.socket.on("close",U),this.socket.on("end",U),this.socket.on("error",U),this.socket.on("timeout",U),this.socket.on("drain",U)})}}e.NodeSocket=m;var v;(function(A){A[A.MinHeaderByteSize=2]="MinHeaderByteSize"})(v||(v={}));var b;(function(A){A[A.PeekHeader=1]="PeekHeader",A[A.ReadHeader=2]="ReadHeader",A[A.ReadBody=3]="ReadBody",A[A.Fin=4]="Fin"})(b||(b={}));class P extends d.Disposable{constructor(L,F,U,Y){super();this._onData=this._register(new I.Emitter),this._onClose=this._register(new I.Emitter),this._isEnded=!1,this._state={state:1,readLen:2,fin:0,compressed:!1,firstFrameOfMessage:!0,mask:0},this.socket=L,this.traceSocketEvent("created",{type:"WebSocketNodeSocket",permessageDeflate:F,inflateBytesLength:U?.byteLength||0,recordInflateBytes:Y}),this._flowManager=this._register(new c(this,F,U,Y,this._onData,(ie,re)=>this._write(ie,re))),this._register(this._flowManager.onError(ie=>{console.error(ie),(0,n.onUnexpectedError)(ie),this._onClose.fire({type:0,hadError:!0,error:ie})})),this._incomingData=new S.ChunkStream,this._register(this.socket.onData(ie=>this._acceptChunk(ie))),this._register(this.socket.onClose(ie=>this._onClose.fire(ie)))}get permessageDeflate(){return this._flowManager.permessageDeflate}get recordedInflateBytes(){return this._flowManager.recordedInflateBytes}traceSocketEvent(L,F){this.socket.traceSocketEvent(L,F)}dispose(){this._flowManager.isProcessingWriteQueue()?this._register(this._flowManager.onDidFinishProcessingWriteQueue(()=>{this.dispose()})):(this.socket.dispose(),super.dispose())}onData(L){return this._onData.event(L)}onClose(L){return this._onClose.event(L)}onEnd(L){return this.socket.onEnd(L)}write(L){this._flowManager.writeMessage(L)}_write(L,F){if(this._isEnded)return;this.traceSocketEvent("webSocketNodeSocketWrite",L);let U=2;L.byteLength<126?U+=0:L.byteLength<2**16?U+=2:U+=8;const Y=k.VSBuffer.alloc(U);if(F?Y.writeUInt8(194,0):Y.writeUInt8(130,0),L.byteLength<126)Y.writeUInt8(L.byteLength,1);else if(L.byteLength<2**16){Y.writeUInt8(126,1);let ie=1;Y.writeUInt8(L.byteLength>>>8&255,++ie),Y.writeUInt8(L.byteLength>>>0&255,++ie)}else{Y.writeUInt8(127,1);let ie=1;Y.writeUInt8(0,++ie),Y.writeUInt8(0,++ie),Y.writeUInt8(0,++ie),Y.writeUInt8(0,++ie),Y.writeUInt8(L.byteLength>>>24&255,++ie),Y.writeUInt8(L.byteLength>>>16&255,++ie),Y.writeUInt8(L.byteLength>>>8&255,++ie),Y.writeUInt8(L.byteLength>>>0&255,++ie)}this.socket.write(k.VSBuffer.concat([Y,L]))}end(){this._isEnded=!0,this.socket.end()}_acceptChunk(L){if(L.byteLength!==0){for(this._incomingData.acceptChunk(L);this._incomingData.byteLength>=this._state.readLen;)if(this._state.state===1){const F=this._incomingData.peek(this._state.readLen),U=F.readUInt8(0),Y=(U&128)>>>7,ie=(U&64)>>>6,re=F.readUInt8(1),K=(re&128)>>>7,W=re&127;this._state.state=2,this._state.readLen=2+(K?4:0)+(W===126?2:0)+(W===127?8:0),this._state.fin=Y,this._state.firstFrameOfMessage&&(this._state.compressed=Boolean(ie)),this._state.firstFrameOfMessage=Boolean(Y),this._state.mask=0,this.traceSocketEvent("webSocketNodeSocketPeekedHeader",{headerSize:this._state.readLen,compressed:this._state.compressed,fin:this._state.fin})}else if(this._state.state===2){const F=this._incomingData.read(this._state.readLen),U=F.readUInt8(1),Y=(U&128)>>>7;let ie=U&127,re=1;ie===126?ie=F.readUInt8(++re)*2**8+F.readUInt8(++re):ie===127&&(ie=F.readUInt8(++re)*0+F.readUInt8(++re)*0+F.readUInt8(++re)*0+F.readUInt8(++re)*0+F.readUInt8(++re)*2**24+F.readUInt8(++re)*2**16+F.readUInt8(++re)*2**8+F.readUInt8(++re));let K=0;Y&&(K=F.readUInt8(++re)*2**24+F.readUInt8(++re)*2**16+F.readUInt8(++re)*2**8+F.readUInt8(++re)),this._state.state=3,this._state.readLen=ie,this._state.mask=K,this.traceSocketEvent("webSocketNodeSocketPeekedHeader",{bodySize:this._state.readLen,compressed:this._state.compressed,fin:this._state.fin,mask:this._state.mask})}else if(this._state.state===3){const F=this._incomingData.read(this._state.readLen);this.traceSocketEvent("webSocketNodeSocketReadData",F),o(F,this._state.mask),this.traceSocketEvent("webSocketNodeSocketUnmaskedData",F),this._state.state=1,this._state.readLen=2,this._state.mask=0,this._flowManager.acceptFrame(F,this._state.compressed,!!this._state.fin)}}}async drain(){this.traceSocketEvent("webSocketNodeSocketDrainBegin"),this._flowManager.isProcessingWriteQueue()&&await I.Event.toPromise(this._flowManager.onDidFinishProcessingWriteQueue),await this.socket.drain(),this.traceSocketEvent("webSocketNodeSocketDrainEnd")}}e.WebSocketNodeSocket=P;class c extends d.Disposable{constructor(L,F,U,Y,ie,re){super();this._tracer=L,this._onData=ie,this._writeFn=re,this._onError=this._register(new I.Emitter),this.onError=this._onError.event,this._writeQueue=[],this._readQueue=[],this._onDidFinishProcessingWriteQueue=this._register(new I.Emitter),this.onDidFinishProcessingWriteQueue=this._onDidFinishProcessingWriteQueue.event,this._isProcessingWriteQueue=!1,this._isProcessingReadQueue=!1,F?(this._zlibInflateStream=this._register(new a(this._tracer,Y,U,{windowBits:15})),this._zlibDeflateStream=this._register(new l(this._tracer,{windowBits:15})),this._register(this._zlibInflateStream.onError(K=>this._onError.fire(K))),this._register(this._zlibDeflateStream.onError(K=>this._onError.fire(K)))):(this._zlibInflateStream=null,this._zlibDeflateStream=null)}get permessageDeflate(){return Boolean(this._zlibInflateStream&&this._zlibDeflateStream)}get recordedInflateBytes(){return this._zlibInflateStream?this._zlibInflateStream.recordedInflateBytes:k.VSBuffer.alloc(0)}writeMessage(L){this._writeQueue.push(L),this._processWriteQueue()}async _processWriteQueue(){if(!this._isProcessingWriteQueue){for(this._isProcessingWriteQueue=!0;this._writeQueue.length>0;){const L=this._writeQueue.shift();if(this._zlibDeflateStream){const F=await this._deflateMessage(this._zlibDeflateStream,L);this._writeFn(F,!0)}else this._writeFn(L,!1)}this._isProcessingWriteQueue=!1,this._onDidFinishProcessingWriteQueue.fire()}}isProcessingWriteQueue(){return this._isProcessingWriteQueue}_deflateMessage(L,F){return new Promise((U,Y)=>{L.write(F),L.flush(ie=>U(ie))})}acceptFrame(L,F,U){this._readQueue.push({data:L,isCompressed:F,isLastFrameOfMessage:U}),this._processReadQueue()}async _processReadQueue(){if(!this._isProcessingReadQueue){for(this._isProcessingReadQueue=!0;this._readQueue.length>0;){const L=this._readQueue.shift();if(this._zlibInflateStream&&L.isCompressed){const F=await this._inflateFrame(this._zlibInflateStream,L.data,L.isLastFrameOfMessage);this._onData.fire(F)}else this._onData.fire(L.data)}this._isProcessingReadQueue=!1}}_inflateFrame(L,F,U){return new Promise((Y,ie)=>{L.write(F),U&&L.write(k.VSBuffer.fromByteArray([0,0,255,255])),L.flush(re=>Y(re))})}}class a extends d.Disposable{constructor(L,F,U,Y){super();this._tracer=L,this._recordInflateBytes=F,this._onError=this._register(new I.Emitter),this.onError=this._onError.event,this._recordedInflateBytes=[],this._pendingInflateData=[],this._zlibInflate=t.createInflateRaw(Y),this._zlibInflate.on("error",ie=>{this._tracer.traceSocketEvent("zlibInflateError",{message:ie?.message,code:ie?.code}),this._onError.fire(ie)}),this._zlibInflate.on("data",ie=>{this._tracer.traceSocketEvent("zlibInflateData",ie),this._pendingInflateData.push(k.VSBuffer.wrap(ie))}),U&&(this._tracer.traceSocketEvent("zlibInflateInitialWrite",U.buffer),this._zlibInflate.write(U.buffer),this._zlibInflate.flush(()=>{this._tracer.traceSocketEvent("zlibInflateInitialFlushFired"),this._pendingInflateData.length=0}))}get recordedInflateBytes(){return this._recordInflateBytes?k.VSBuffer.concat(this._recordedInflateBytes):k.VSBuffer.alloc(0)}write(L){this._recordInflateBytes&&this._recordedInflateBytes.push(L.clone()),this._tracer.traceSocketEvent("zlibInflateWrite",L),this._zlibInflate.write(L.buffer)}flush(L){this._zlibInflate.flush(()=>{this._tracer.traceSocketEvent("zlibInflateFlushFired");const F=k.VSBuffer.concat(this._pendingInflateData);this._pendingInflateData.length=0,L(F)})}}class l extends d.Disposable{constructor(L,F){super();this._tracer=L,this._onError=this._register(new I.Emitter),this.onError=this._onError.event,this._pendingDeflateData=[],this._zlibDeflate=t.createDeflateRaw({windowBits:15}),this._zlibDeflate.on("error",U=>{this._tracer.traceSocketEvent("zlibDeflateError",{message:U?.message,code:U?.code}),this._onError.fire(U)}),this._zlibDeflate.on("data",U=>{this._tracer.traceSocketEvent("zlibDeflateData",U),this._pendingDeflateData.push(k.VSBuffer.wrap(U))})}write(L){this._tracer.traceSocketEvent("zlibDeflateWrite",L.buffer),this._zlibDeflate.write(L.buffer)}flush(L){this._zlibDeflate.flush(2,()=>{this._tracer.traceSocketEvent("zlibDeflateFlushFired");let F=k.VSBuffer.concat(this._pendingDeflateData);this._pendingDeflateData.length=0,F=F.slice(0,F.byteLength-4),L(F)})}}function o(A,L){if(L===0)return;let F=A.byteLength>>>2;for(let W=0;W<F;W++){const N=A.readUInt32BE(W*4);A.writeUInt32BE(N^L,W*4)}let U=F*4,Y=A.byteLength-U;const ie=L>>>24&255,re=L>>>16&255,K=L>>>8&255;Y>=1&&A.writeUInt8(A.readUInt8(U)^ie,U),Y>=2&&A.writeUInt8(A.readUInt8(U+1)^re,U+1),Y>=3&&A.writeUInt8(A.readUInt8(U+2)^K,U+2)}e.XDG_RUNTIME_DIR=process.env.XDG_RUNTIME_DIR;const u={[2]:107,[1]:103};function r(){const A=(0,E.generateUuid)();if(process.platform==="win32")return`\\\\.\\pipe\\vscode-ipc-${A}-sock`;let L;return e.XDG_RUNTIME_DIR?L=(0,f.join)(e.XDG_RUNTIME_DIR,`vscode-ipc-${A}.sock`):L=(0,f.join)((0,C.tmpdir)(),`vscode-ipc-${A}.sock`),s(L),L}e.createRandomIPCHandle=r;function i(A,L,F){const U=(0,p.createHash)("md5").update(A).digest("hex");if(process.platform==="win32")return`\\\\.\\pipe\\${U}-${F}-${L}-sock`;let Y;return e.XDG_RUNTIME_DIR&&!process.env.VSCODE_PORTABLE?Y=(0,f.join)(e.XDG_RUNTIME_DIR,`vscode-${U.substr(0,8)}-${F}-${L}.sock`):Y=(0,f.join)(A,`${F}-${L}.sock`),s(Y),Y}e.createStaticIPCHandle=i;function s(A){const L=u[y.platform];typeof L=="number"&&A.length>=L&&console.warn(`WARNING: IPC handle "${A}" is longer than ${L} chars, try a shorter --user-data-dir`)}class h extends g.IPCServer{constructor(L){super(h.toClientConnectionEvent(L));this.server=L}static toClientConnectionEvent(L){const F=I.Event.fromNodeEventEmitter(L,"connection");return I.Event.map(F,U=>({protocol:new S.Protocol(new m(U,"ipc-server-connection")),onDidClientDisconnect:I.Event.once(I.Event.fromNodeEventEmitter(U,"close"))}))}dispose(){super.dispose(),this.server&&(this.server.close(),this.server=null)}}e.Server=h;function w(A){return new Promise((L,F)=>{const U=(0,R.createServer)();U.on("error",F),U.listen(A,()=>{U.removeListener("error",F),L(new h(U))})})}e.serve=w;function M(A,L){return new Promise((F,U)=>{const Y=(0,R.createConnection)(A,()=>{Y.removeListener("error",U),F(S.Client.fromSocket(new m(Y,`ipc-client${L}`),L))});Y.once("error",U)})}e.connect=M}),define(x[224],ee([0,1,58]),function(V,e,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.connect=e.WindowDriverRegistryChannel=e.DriverChannelClient=e.DriverChannel=void 0;class R{constructor(d){this.driver=d}listen(d,f){throw new Error("No event found")}call(d,f,y){switch(f){case"getWindowIds":return this.driver.getWindowIds();case"capturePage":return this.driver.capturePage(y);case"reloadWindow":return this.driver.reloadWindow(y);case"exitApplication":return this.driver.exitApplication();case"dispatchKeybinding":return this.driver.dispatchKeybinding(y[0],y[1]);case"click":return this.driver.click(y[0],y[1],y[2],y[3]);case"doubleClick":return this.driver.doubleClick(y[0],y[1]);case"setValue":return this.driver.setValue(y[0],y[1],y[2]);case"getTitle":return this.driver.getTitle(y[0]);case"isActiveElement":return this.driver.isActiveElement(y[0],y[1]);case"getElements":return this.driver.getElements(y[0],y[1],y[2]);case"getElementXY":return this.driver.getElementXY(y[0],y[1],y[2]);case"typeInEditor":return this.driver.typeInEditor(y[0],y[1],y[2]);case"getTerminalBuffer":return this.driver.getTerminalBuffer(y[0],y[1]);case"writeInTerminal":return this.driver.writeInTerminal(y[0],y[1],y[2]);case"getLocaleInfo":return this.driver.getLocaleInfo(y);case"getLocalizedStrings":return this.driver.getLocalizedStrings(y)}throw new Error(`Call not found: ${f}`)}}e.DriverChannel=R;class C{constructor(d){this.channel=d}getWindowIds(){return this.channel.call("getWindowIds")}capturePage(d){return this.channel.call("capturePage",d)}reloadWindow(d){return this.channel.call("reloadWindow",d)}exitApplication(){return this.channel.call("exitApplication")}dispatchKeybinding(d,f){return this.channel.call("dispatchKeybinding",[d,f])}click(d,f,y,E){return this.channel.call("click",[d,f,y,E])}doubleClick(d,f){return this.channel.call("doubleClick",[d,f])}setValue(d,f,y){return this.channel.call("setValue",[d,f,y])}getTitle(d){return this.channel.call("getTitle",[d])}isActiveElement(d,f){return this.channel.call("isActiveElement",[d,f])}getElements(d,f,y){return this.channel.call("getElements",[d,f,y])}getElementXY(d,f,y,E){return this.channel.call("getElementXY",[d,f,y,E])}typeInEditor(d,f,y){return this.channel.call("typeInEditor",[d,f,y])}getTerminalBuffer(d,f){return this.channel.call("getTerminalBuffer",[d,f])}writeInTerminal(d,f,y){return this.channel.call("writeInTerminal",[d,f,y])}getLocaleInfo(d){return this.channel.call("getLocaleInfo",d)}getLocalizedStrings(d){return this.channel.call("getLocalizedStrings",d)}}e.DriverChannelClient=C;class k{constructor(d){this.registry=d}listen(d,f){throw new Error(`Event not found: ${f}`)}call(d,f,y){switch(f){case"registerWindowDriver":return this.registry.registerWindowDriver(y);case"reloadWindowDriver":return this.registry.reloadWindowDriver(y)}throw new Error(`Call not found: ${f}`)}}e.WindowDriverRegistryChannel=k;async function n(I){const d=await(0,p.connect)(I,"driverClient"),f=d.getChannel("driver"),y=new C(f);return{client:d,driver:y}}e.connect=n}),define(x[225],ee([0,1,9,4,106,59,2,3,35,58,160,224,178,20,36]),function(V,e,p,R,C,k,n,I,d,f,y,E,g,S,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.serve=e.Driver=void 0;function m(P){return P<21}let v=class{constructor(c,a,l,o){this.windowServer=c,this.options=a,this.windowsMainService=l,this.lifecycleMainService=o,this.registeredWindowIds=new Set,this.reloadingWindowIds=new Set,this.onDidReloadingChange=new R.Emitter}async registerWindowDriver(c){return this.registeredWindowIds.add(c),this.reloadingWindowIds.delete(c),this.onDidReloadingChange.fire(),this.options}async reloadWindowDriver(c){this.reloadingWindowIds.add(c)}async getWindowIds(){return this.windowsMainService.getWindows().map(c=>c.id).filter(c=>this.registeredWindowIds.has(c)&&!this.reloadingWindowIds.has(c))}async capturePage(c){await this.whenUnfrozen(c);const a=this.windowsMainService.getWindowById(c);if(!a?.win)throw new Error("Invalid window");return(await a.win.webContents.capturePage()).toPNG().toString("base64")}async reloadWindow(c){await this.whenUnfrozen(c);const a=this.windowsMainService.getWindowById(c);if(!a)throw new Error("Invalid window");this.reloadingWindowIds.add(c),this.lifecycleMainService.reload(a)}exitApplication(){return this.lifecycleMainService.quit()}async dispatchKeybinding(c,a){await this.whenUnfrozen(c);const l=C.KeybindingParser.parseUserBinding(a);for(let o of l)await this._dispatchKeybinding(c,o)}async _dispatchKeybinding(c,a){if(a instanceof k.ScanCodeBinding)throw new Error("ScanCodeBindings not supported");const l=this.windowsMainService.getWindowById(c);if(!l?.win)throw new Error("Invalid window");const o=l.win.webContents,u=new k.SimpleKeybinding(!1,!1,!1,!1,a.keyCode),i=new g.USLayoutResolvedKeybinding(u.toChord(),I.OS).getElectronAccelerator(),s=[];a.ctrlKey&&s.push("ctrl"),a.metaKey&&s.push("meta"),a.shiftKey&&s.push("shift"),a.altKey&&s.push("alt"),o.sendInputEvent({type:"keyDown",keyCode:i,modifiers:s}),m(a.keyCode)||o.sendInputEvent({type:"char",keyCode:i,modifiers:s}),o.sendInputEvent({type:"keyUp",keyCode:i,modifiers:s}),await(0,p.timeout)(100)}async click(c,a,l,o){await(await this.getWindowDriver(c)).click(a,l,o)}async doubleClick(c,a){await(await this.getWindowDriver(c)).doubleClick(a)}async setValue(c,a,l){await(await this.getWindowDriver(c)).setValue(a,l)}async getTitle(c){return await(await this.getWindowDriver(c)).getTitle()}async isActiveElement(c,a){return await(await this.getWindowDriver(c)).isActiveElement(a)}async getElements(c,a,l){return await(await this.getWindowDriver(c)).getElements(a,l)}async getElementXY(c,a,l,o){return await(await this.getWindowDriver(c)).getElementXY(a,l,o)}async typeInEditor(c,a,l){await(await this.getWindowDriver(c)).typeInEditor(a,l)}async getTerminalBuffer(c,a){return await(await this.getWindowDriver(c)).getTerminalBuffer(a)}async writeInTerminal(c,a,l){await(await this.getWindowDriver(c)).writeInTerminal(a,l)}async getLocaleInfo(c){return await(await this.getWindowDriver(c)).getLocaleInfo()}async getLocalizedStrings(c){return await(await this.getWindowDriver(c)).getLocalizedStrings()}async getWindowDriver(c){await this.whenUnfrozen(c);const a=`window:${c}`,l=new d.StaticRouter(u=>u===a),o=this.windowServer.getChannel("windowDriver",l);return new y.WindowDriverChannelClient(o)}async whenUnfrozen(c){for(;this.reloadingWindowIds.has(c);)await R.Event.toPromise(this.onDidReloadingChange.event)}};v=fe([te(2,t.IWindowsMainService),te(3,S.ILifecycleMainService)],v),e.Driver=v;async function b(P,c,a,l){const o=a.driverVerbose,u=l.createInstance(v,P,{verbose:o}),r=new E.WindowDriverRegistryChannel(u);P.registerChannel("windowDriverRegistry",r);const i=await(0,f.serve)(c),s=new E.DriverChannel(u);return i.registerChannel("driver",s),(0,n.combinedDisposable)(i,P)}e.serve=b}),define(x[24],ee([0,1,46,8,58,48,164,5]),function(V,e,p,R,C,k,n,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EnvironmentMainService=e.IEnvironmentMainService=void 0,e.IEnvironmentMainService=(0,I.refineServiceDecorator)(k.IEnvironmentService);class d extends n.NativeEnvironmentService{get cachedLanguagesPath(){return(0,R.join)(this.userDataPath,"clp")}get backupHome(){return(0,R.join)(this.userDataPath,"Backups")}get backupWorkspacesPath(){return(0,R.join)(this.backupHome,"workspaces.json")}get mainIPCHandle(){return(0,C.createStaticIPCHandle)(this.userDataPath,"main",this.productService.version)}get mainLockfile(){return(0,R.join)(this.userDataPath,"code.lock")}get sandbox(){return!!this.args.__sandbox}get driverVerbose(){return!!this.args["driver-verbose"]}get disableUpdates(){return!!this.args["disable-updates"]}get disableKeytar(){return!!this.args["disable-keytar"]}get codeCachePath(){return process.env.VSCODE_CODE_CACHE_PATH||void 0}get useCodeCache(){return!!this.codeCachePath}}fe([p.memoize],d.prototype,"cachedLanguagesPath",null),fe([p.memoize],d.prototype,"backupHome",null),fe([p.memoize],d.prototype,"backupWorkspacesPath",null),fe([p.memoize],d.prototype,"mainIPCHandle",null),fe([p.memoize],d.prototype,"mainLockfile",null),fe([p.memoize],d.prototype,"sandbox",null),fe([p.memoize],d.prototype,"driverVerbose",null),fe([p.memoize],d.prototype,"disableUpdates",null),fe([p.memoize],d.prototype,"disableKeytar",null),fe([p.memoize],d.prototype,"codeCachePath",null),fe([p.memoize],d.prototype,"useCodeCache",null),e.EnvironmentMainService=d}),define(x[226],ee([0,1,61,28,32,10,8,3,15,7,21,50,18,24,19,6,27]),function(V,e,p,R,C,k,n,I,d,f,y,E,g,S,t,m,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.BackupMainService=void 0;let b=class{constructor(c,a,l){this.configurationService=a,this.logService=l,this.workspaces=[],this.folders=[],this.emptyWindows=[],this.backupUriComparer=d.extUriBiasedIgnorePathCase,this.backupPathComparer={isEqual:(o,u)=>(0,C.isEqual)(o,u,!I.isLinux)},this.backupHome=c.backupHome,this.workspacesJsonPath=c.backupWorkspacesPath}async initialize(){let c;try{c=JSON.parse(await y.Promises.readFile(this.workspacesJsonPath,"utf8"))}catch(o){c=Object.create(null)}this.emptyWindows=await this.validateEmptyWorkspaces(c.emptyWorkspaceInfos);let a=[];try{Array.isArray(c.rootURIWorkspaces)&&(a=c.rootURIWorkspaces.map(o=>({workspace:{id:o.id,configPath:f.URI.parse(o.configURIPath)},remoteAuthority:o.remoteAuthority})))}catch(o){}this.workspaces=await this.validateWorkspaces(a);let l=[];try{Array.isArray(c.folderURIWorkspaces)&&(l=c.folderURIWorkspaces.map(o=>f.URI.parse(o)))}catch(o){}this.folders=await this.validateFolders(l),await this.save()}getWorkspaceBackups(){return this.isHotExitOnExitAndWindowClose()?[]:this.workspaces.slice(0)}getFolderBackupPaths(){return this.isHotExitOnExitAndWindowClose()?[]:this.folders.slice(0)}isHotExitEnabled(){return this.getHotExitConfig()!==t.HotExitConfiguration.OFF}isHotExitOnExitAndWindowClose(){return this.getHotExitConfig()===t.HotExitConfiguration.ON_EXIT_AND_WINDOW_CLOSE}getHotExitConfig(){return this.configurationService.getValue()?.files?.hotExit||t.HotExitConfiguration.ON_EXIT}getEmptyWindowBackupPaths(){return this.emptyWindows.slice(0)}registerWorkspaceBackupSync(c,a){this.workspaces.some(o=>c.workspace.id===o.workspace.id)||(this.workspaces.push(c),this.saveSync());const l=this.getBackupPath(c.workspace.id);return a&&this.moveBackupFolderSync(l,a),l}moveBackupFolderSync(c,a){if(R.existsSync(c)&&this.convertToEmptyWindowBackupSync(c),R.existsSync(a))try{R.renameSync(a,c)}catch(l){this.logService.error(`Backup: Could not move backup folder to new location: ${l.toString()}`)}}unregisterWorkspaceBackupSync(c){const a=c.id,l=this.workspaces.findIndex(o=>o.workspace.id===a);l!==-1&&(this.workspaces.splice(l,1),this.saveSync())}registerFolderBackupSync(c){return this.folders.some(a=>this.backupUriComparer.isEqual(c,a))||(this.folders.push(c),this.saveSync()),this.getBackupPath(this.getFolderHash(c))}unregisterFolderBackupSync(c){const a=this.folders.findIndex(l=>this.backupUriComparer.isEqual(c,l));a!==-1&&(this.folders.splice(a,1),this.saveSync())}registerEmptyWindowBackupSync(c,a){const l=c||this.getRandomEmptyWindowId();return this.emptyWindows.some(o=>!!o.backupFolder&&this.backupPathComparer.isEqual(o.backupFolder,l))||(this.emptyWindows.push({backupFolder:l,remoteAuthority:a}),this.saveSync()),this.getBackupPath(l)}unregisterEmptyWindowBackupSync(c){const a=this.emptyWindows.findIndex(l=>!!l.backupFolder&&this.backupPathComparer.isEqual(l.backupFolder,c));a!==-1&&(this.emptyWindows.splice(a,1),this.saveSync())}getBackupPath(c){return(0,n.join)(this.backupHome,c)}async validateWorkspaces(c){if(!Array.isArray(c))return[];const a=new Set,l=[];for(let o of c){const u=o.workspace;if(!(0,v.isWorkspaceIdentifier)(u))return[];if(!a.has(u.id)){a.add(u.id);const r=this.getBackupPath(u.id);await this.doHasBackups(r)?u.configPath.scheme!==k.Schemas.file||await y.Promises.exists(u.configPath.fsPath)?l.push(o):await this.convertToEmptyWindowBackup(r):await this.deleteStaleBackup(r)}}return l}async validateFolders(c){if(!Array.isArray(c))return[];const a=[],l=new Set;for(let o of c){const u=this.backupUriComparer.getComparisonKey(o);if(!l.has(u)){l.add(u);const r=this.getBackupPath(this.getFolderHash(o));await this.doHasBackups(r)?o.scheme!==k.Schemas.file||await y.Promises.exists(o.fsPath)?a.push(o):await this.convertToEmptyWindowBackup(r):await this.deleteStaleBackup(r)}}return a}async validateEmptyWorkspaces(c){if(!Array.isArray(c))return[];const a=[],l=new Set;for(let o of c){const u=o.backupFolder;if(typeof u!="string")return[];if(!l.has(u)){l.add(u);const r=this.getBackupPath(u);await this.doHasBackups(r)?a.push(o):await this.deleteStaleBackup(r)}}return a}async deleteStaleBackup(c){try{await y.Promises.exists(c)&&await y.Promises.rm(c,y.RimRafMode.MOVE)}catch(a){this.logService.error(`Backup: Could not delete stale backup: ${a.toString()}`)}}async convertToEmptyWindowBackup(c){let a=this.getRandomEmptyWindowId();for(;this.emptyWindows.some(o=>!!o.backupFolder&&this.backupPathComparer.isEqual(o.backupFolder,a));)a=this.getRandomEmptyWindowId();const l=this.getBackupPath(a);try{await y.Promises.rename(c,l)}catch(o){return this.logService.error(`Backup: Could not rename backup folder: ${o.toString()}`),!1}return this.emptyWindows.push({backupFolder:a}),!0}convertToEmptyWindowBackupSync(c){let a=this.getRandomEmptyWindowId();for(;this.emptyWindows.some(o=>!!o.backupFolder&&this.backupPathComparer.isEqual(o.backupFolder,a));)a=this.getRandomEmptyWindowId();const l=this.getBackupPath(a);try{R.renameSync(c,l)}catch(o){return this.logService.error(`Backup: Could not rename backup folder: ${o.toString()}`),!1}return this.emptyWindows.push({backupFolder:a}),!0}async getDirtyWorkspaces(){const c=[];for(const a of this.workspaces)await this.hasBackups(a)&&c.push(a.workspace);for(const a of this.folders)await this.hasBackups(a)&&c.push(a);return c}hasBackups(c){let a;return f.URI.isUri(c)?a=this.getBackupPath(this.getFolderHash(c)):(0,E.isWorkspaceBackupInfo)(c)?a=this.getBackupPath(c.workspace.id):a=c.backupFolder,this.doHasBackups(a)}async doHasBackups(c){try{const a=await y.Promises.readdir(c);for(const l of a)try{if((await y.Promises.readdir((0,n.join)(c,l))).length>0)return!0}catch(o){}}catch(a){}return!1}saveSync(){try{(0,y.writeFileSync)(this.workspacesJsonPath,JSON.stringify(this.serializeBackups()))}catch(c){this.logService.error(`Backup: Could not save workspaces.json: ${c.toString()}`)}}async save(){try{await y.Promises.writeFile(this.workspacesJsonPath,JSON.stringify(this.serializeBackups()))}catch(c){this.logService.error(`Backup: Could not save workspaces.json: ${c.toString()}`)}}serializeBackups(){return{rootURIWorkspaces:this.workspaces.map(c=>({id:c.workspace.id,configURIPath:c.workspace.configPath.toString(),remoteAuthority:c.remoteAuthority})),folderURIWorkspaces:this.folders.map(c=>c.toString()),emptyWorkspaceInfos:this.emptyWindows}}getRandomEmptyWindowId(){return(Date.now()+Math.round(Math.random()*1e3)).toString()}getFolderHash(c){let a;return c.scheme===k.Schemas.file?a=I.isLinux?c.fsPath:c.fsPath.toLowerCase():a=c.toString().toLowerCase(),(0,p.createHash)("md5").update(a).digest("hex")}};b=fe([te(0,S.IEnvironmentMainService),te(1,g.IConfigurationService),te(2,m.ILogService)],b),e.BackupMainService=b}),define(x[227],ee([0,1,62,58]),function(V,e,p,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.nodeSocketFactory=void 0,e.nodeSocketFactory=new class{connect(C,k,n,I,d){const f=E=>d(E,void 0),y=p.createConnection({host:C,port:k},()=>{y.removeListener("error",f);const E=Buffer.alloc(16);for(let m=0;m<16;m++)E[m]=Math.round(Math.random()*256);const g=E.toString("base64"),S=[`GET ws://${/:/.test(C)?`[${C}]`:C}:${k}/?${n}&skipWebSocketFrames=true HTTP/1.1`,"Connection: Upgrade","Upgrade: websocket",`Sec-WebSocket-Key: ${g}`];y.write(S.join(`\r
`)+`\r
\r
`);const t=m=>{m.toString().indexOf(`\r
\r
`)>=0&&(y.off("data",t),d(void 0,new R.NodeSocket(y,I)))};y.on("data",t)});y.setNoDelay(!0),y.once("error",f)}}}),define(x[228],ee([0,1,62,118,227,9,2,18,6,22,194,97,76]),function(V,e,p,R,C,k,n,I,d,f,y,E,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SharedTunnelsService=e.TunnelService=e.BaseTunnelService=void 0;async function S(P,c,a,l,o){let u;for(let r=3;r&&(u&&u.dispose(),u=await new t(P,c,a,l,o).waitForReady(),!(o&&R.BROWSER_RESTRICTED_PORTS[o]||!R.BROWSER_RESTRICTED_PORTS[u.tunnelLocalPort]));r--);return u}class t extends n.Disposable{constructor(c,a,l,o,u){super();this.defaultTunnelHost=a,this.suggestedLocalPort=u,this.privacy=E.TunnelPrivacyId.Private,this._socketsDispose=new Map,this._options=c,this._server=p.createServer(),this._barrier=new k.Barrier,this._listeningListener=()=>this._barrier.open(),this._server.on("listening",this._listeningListener),this._connectionListener=r=>this._onConnection(r),this._server.on("connection",this._connectionListener),this._errorListener=()=>{},this._server.on("error",this._errorListener),this.tunnelRemotePort=o,this.tunnelRemoteHost=l}async dispose(){super.dispose(),this._server.removeListener("listening",this._listeningListener),this._server.removeListener("connection",this._connectionListener),this._server.removeListener("error",this._errorListener),this._server.close(),Array.from(this._socketsDispose.values()).forEach(a=>{a()})}async waitForReady(){let c=await(0,R.findFreePortFaster)(this.suggestedLocalPort??this.tunnelRemotePort,2,1e3),a=null;return this._server.listen(c,this.defaultTunnelHost),await this._barrier.wait(),a=this._server.address(),a||(c=0,this._server.listen(c,this.defaultTunnelHost),await this._barrier.wait(),a=this._server.address()),this.tunnelLocalPort=a.port,this.localAddress=`${this.tunnelRemoteHost==="127.0.0.1"?"127.0.0.1":"localhost"}:${a.port}`,this}async _onConnection(c){c.pause();const a=(0,E.isLocalhost)(this.tunnelRemoteHost)||(0,E.isAllInterfaces)(this.tunnelRemoteHost)?"localhost":this.tunnelRemoteHost,l=await(0,y.connectRemoteAgentTunnel)(this._options,a,this.tunnelRemotePort),o=l.getSocket().socket,u=l.readEntireBuffer();l.dispose(),u.byteLength>0&&c.write(u.buffer),c.on("end",()=>{this._socketsDispose.delete(c.localAddress),o.end()}),c.on("close",()=>o.end()),c.on("error",()=>{this._socketsDispose.delete(c.localAddress),o.destroy()}),o.on("end",()=>c.end()),o.on("close",()=>c.end()),o.on("error",()=>{c.destroy()}),c.pipe(o),o.pipe(c),this._socketsDispose.set(c.localAddress,()=>{c.end(),o.end()})}}let m=class extends E.AbstractTunnelService{constructor(c,a,l,o,u){super(a);this.socketFactory=c,this.signService=l,this.productService=o,this.configurationService=u}get defaultTunnelHost(){const c=this.configurationService.getValue("remote.localPortHost");return!c||c==="localhost"?"127.0.0.1":"0.0.0.0"}retainOrCreateTunnel(c,a,l,o,u,r,i){const s=this.getTunnelFromMap(a,l);if(s)return++s.refcount,s.value;if(this._tunnelProvider)return this.createWithProvider(this._tunnelProvider,a,l,o,u,r,i);{this.logService.trace(`ForwardedPorts: (TunnelService) Creating tunnel without provider ${a}:${l} on local port ${o}.`);const h={commit:this.productService.commit,socketFactory:this.socketFactory,addressProvider:c,signService:this.signService,logService:this.logService,ipcLogger:null},w=S(h,this.defaultTunnelHost,a,l,o);return this.logService.trace("ForwardedPorts: (TunnelService) Tunnel created without provider."),this.addTunnelToMap(a,l,w),w}}};m=fe([te(1,d.ILogService),te(2,g.ISignService),te(3,f.IProductService),te(4,I.IConfigurationService)],m),e.BaseTunnelService=m;let v=class extends m{constructor(c,a,l,o){super(C.nodeSocketFactory,c,a,l,o)}};v=fe([te(0,d.ILogService),te(1,g.ISignService),te(2,f.IProductService),te(3,I.IConfigurationService)],v),e.TunnelService=v;let b=class extends n.Disposable{constructor(c,a,l,o){super();this.logService=c,this.productService=a,this.signService=l,this.configurationService=o,this._tunnelServices=new Map}async openTunnel(c,a,l,o,u,r,i,s){if(this.logService.trace(`ForwardedPorts: (SharedTunnelService) openTunnel request for ${l}:${o} on local port ${u}.`),!this._tunnelServices.has(c)){const h=new v(this.logService,this.signService,this.productService,this.configurationService);this._register(h),this._tunnelServices.set(c,h),h.onTunnelClosed(async()=>{(await h.tunnels).length===0&&(h.dispose(),this._tunnelServices.delete(c))})}return this._tunnelServices.get(c).openTunnel(a,l,o,u,r,i,s)}};b=fe([te(0,d.ILogService),te(1,f.IProductService),te(2,g.ISignService),te(3,I.IConfigurationService)],b),e.SharedTunnelsService=b}),define(x[229],ee([0,1,198,9,17,16,2,13,18,48,91,6,197,223]),function(V,e,p,R,C,k,n,I,d,f,y,E,g,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RequestService=void 0;let t=class extends n.Disposable{constructor(v,b,P){super();this.environmentService=b,this.logService=P,this.configure(v.getValue()),this._register(v.onDidChangeConfiguration(()=>this.configure(v.getValue()),this))}configure(v){this.proxyUrl=v.http&&v.http.proxy,this.strictSSL=!!(v.http&&v.http.proxyStrictSSL),this.authorization=v.http&&v.http.proxyAuthorization}async request(v,b){this.logService.trace("RequestService#request",v.url);const{proxyUrl:P,strictSSL:c}=this;let a;try{a=await(0,y.getResolvedShellEnv)(this.logService,this.environmentService.args,process.env)}catch(u){this.shellEnvErrorLogged||(this.shellEnvErrorLogged=!0,this.logService.error("RequestService#request resolving shell environment failed",u))}const l={...process.env,...a},o=v.agent?v.agent:await(0,g.getProxyAgent)(v.url||"",l,{proxyUrl:P,strictSSL:c});return v.agent=o,v.strictSSL=c,this.authorization&&(v.headers={...v.headers||{},"Proxy-Authorization":this.authorization}),this._request(v,b)}async getNodeRequest(v){return((0,p.parse)(v.url).protocol==="https:"?await new Promise((c,a)=>{V(["https"],c,a)}):await new Promise((c,a)=>{V(["http"],c,a)})).request}_request(v,b){return R.Promises.withAsyncBody(async(P,c)=>{let a;const l=(0,p.parse)(v.url),o=v.getRawRequest?v.getRawRequest(v):await this.getNodeRequest(v),u={hostname:l.hostname,port:l.port?parseInt(l.port):l.protocol==="https:"?443:80,protocol:l.protocol,path:l.path,method:v.type||"GET",headers:v.headers,agent:v.agent,rejectUnauthorized:(0,I.isBoolean)(v.strictSSL)?v.strictSSL:!0};v.user&&v.password&&(u.auth=v.user+":"+v.password),a=o(u,r=>{const i=(0,I.isNumber)(v.followRedirects)?v.followRedirects:3;if(r.statusCode&&r.statusCode>=300&&r.statusCode<400&&i>0&&r.headers.location)this._request({...v,url:r.headers.location,followRedirects:i-1},b).then(P,c);else{let s=r;r.headers["content-encoding"]==="gzip"&&(s=r.pipe((0,S.createGunzip)())),P({res:r,stream:(0,C.streamToBufferReadableStream)(s)})}}),a.on("error",c),v.timeout&&a.setTimeout(v.timeout),v.data&&typeof v.data=="string"&&a.write(v.data),a.end(),b.onCancellationRequested(()=>{a.abort(),c((0,k.canceled)())})})}async resolveProxy(v){}};t=fe([te(0,d.IConfigurationService),te(1,f.INativeEnvironmentService),te(2,E.ILogService)],t),e.RequestService=t}),define(x[230],ee([0,1,14,229]),function(V,e,p,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RequestMainService=void 0;function C(n){return p.net.request}class k extends R.RequestService{request(I,d){return super.request({...I||{},getRawRequest:C},d)}}e.RequestMainService=k}),define(x[231],ee([0,1,14,9,4,2,10,13,85,24,20,6,55,56,66,44]),function(V,e,p,R,C,k,n,I,d,f,y,E,g,S,t,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SharedProcess=void 0;let v=class extends k.Disposable{constructor(P,c,a,l,o,u,r){super();this.machineId=P,this.userEnv=c,this.environmentMainService=a,this.lifecycleMainService=l,this.logService=o,this.themeMainService=u,this.protocolMainService=r,this.firstWindowConnectionBarrier=new R.Barrier,this.window=void 0,this.windowCloseListener=void 0,this._onDidError=this._register(new C.Emitter),this.onDidError=C.Event.buffer(this._onDidError.event),this._whenReady=void 0,this._whenIpcReady=void 0,this.registerListeners()}registerListeners(){p.ipcMain.on("vscode:createSharedProcessMessageChannel",(P,c)=>this.onWindowConnection(P,c)),p.ipcMain.on("vscode:relaySharedProcessWorkerMessageChannel",(P,c)=>this.onWorkerConnection(P,c)),this._register(this.lifecycleMainService.onWillShutdown(()=>this.onWillShutdown()))}async onWindowConnection(P,c){this.logService.trace("SharedProcess: on vscode:createSharedProcessMessageChannel"),this.firstWindowConnectionBarrier.isOpen()||this.firstWindowConnectionBarrier.open(),await this.whenReady();const a=await this.connect();if(P.sender.isDestroyed())return a.close();P.sender.postMessage("vscode:createSharedProcessMessageChannelResult",c,[a])}onWorkerConnection(P,c){this.logService.trace("SharedProcess: onWorkerConnection",c);const a=new k.DisposableStore,l=u=>{!this.isAlive()||(this.logService.trace(`SharedProcess: disposing worker (reason: '${u}')`,c),a.dispose(),this.send("vscode:electron-main->shared-process=disposeWorker",c))},o=p.BrowserWindow.fromId(c.reply.windowId);if(!o||o.isDestroyed()||o.webContents.isDestroyed()||!c.reply.channel){l("unavailable");return}a.add(C.Event.filter(this.lifecycleMainService.onWillLoadWindow,u=>u.window.win===o)(()=>l("load"))),a.add(C.Event.fromNodeEventEmitter(o,"closed")(()=>l("closed"))),o.webContents.postMessage(c.reply.channel,c.reply.nonce,P.ports)}onWillShutdown(){const P=this.window;!P||(this.send("vscode:electron-main->shared-process=exit"),this.windowCloseListener&&(P.removeListener("close",this.windowCloseListener),this.windowCloseListener=void 0),setTimeout(()=>{try{P.close()}catch(c){}this.window=void 0},0))}send(P,...c){if(!this.isAlive()){this.logService.warn(`Sending IPC message to channel '${P}' for shared process window that is destroyed`);return}try{this.window?.webContents.send(P,...c)}catch(a){this.logService.warn(`Error sending IPC message to channel '${P}' of shared process: ${(0,m.toErrorMessage)(a)}`)}}whenReady(){return this._whenReady||(this._whenReady=new Promise(P=>p.ipcMain.once("vscode:shared-process->electron-main=init-done",()=>{this.logService.trace("SharedProcess: Overall ready"),P()}))),this._whenReady}get whenIpcReady(){return this._whenIpcReady||(this._whenIpcReady=(async()=>{await this.firstWindowConnectionBarrier.wait(),this.createWindow(),this.registerWindowListeners(),await new Promise(P=>p.ipcMain.once("vscode:shared-process->electron-main=ipc-ready",()=>{this.logService.trace("SharedProcess: IPC ready"),P()}))})()),this._whenIpcReady}createWindow(){const P=this._register(this.protocolMainService.createIPCObjectUrl());this.window=new p.BrowserWindow({show:!1,backgroundColor:this.themeMainService.getBackgroundColor(),webPreferences:{preload:n.FileAccess.asFileUri("vs/base/parts/sandbox/electron-browser/preload.js",V).fsPath,additionalArguments:[`--vscode-window-config=${P.resource.toString()}`,"--vscode-window-kind=shared-process"],v8CacheOptions:this.environmentMainService.useCodeCache?"bypassHeatCheck":"none",nodeIntegration:!0,nodeIntegrationInWorker:!0,contextIsolation:!1,enableWebSQL:!1,spellcheck:!1,nativeWindowOpen:!0,images:!1,webgl:!1}}),P.update({machineId:this.machineId,windowId:this.window.id,appRoot:this.environmentMainService.appRoot,codeCachePath:this.environmentMainService.codeCachePath,backupWorkspacesPath:this.environmentMainService.backupWorkspacesPath,userEnv:this.userEnv,args:this.environmentMainService.args,logLevel:this.logService.getLevel(),product:g.default}),this.window.loadURL(n.FileAccess.asBrowserUri("vs/code/electron-browser/sharedProcess/sharedProcess.html",V).toString(!0))}registerWindowListeners(){!this.window||(this.windowCloseListener=P=>{this.logService.trace("SharedProcess#close prevented"),P.preventDefault(),this.window?.isVisible()&&this.window.hide()},this.window.on("close",this.windowCloseListener),this.window.webContents.on("render-process-gone",(P,c)=>this._onDidError.fire({type:2,details:c})),this.window.on("unresponsive",()=>this._onDidError.fire({type:1})),this.window.webContents.on("did-fail-load",(P,c,a)=>this._onDidError.fire({type:3,details:{reason:a,exitCode:c}})))}async connect(){await this.whenIpcReady;const P=(0,I.assertIsDefined)(this.window);return(0,d.connect)(P)}async toggle(){await this.whenIpcReady,!!this.window&&(this.window.isVisible()?(this.window.webContents.closeDevTools(),this.window.hide()):(this.window.show(),this.window.webContents.openDevTools()))}isVisible(){return this.window?.isVisible()??!1}isAlive(){const P=this.window;return P?!P.isDestroyed()&&!P.webContents.isDestroyed():!1}};v=fe([te(2,f.IEnvironmentMainService),te(3,y.ILifecycleMainService),te(4,E.ILogService),te(5,t.IThemeMainService),te(6,S.IProtocolMainService)],v),e.SharedProcess=v}),define(x[232],ee([0,1,9,17,8,13,7,24,19,6]),function(V,e,p,R,C,k,n,I,d,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StateMainService=e.FileStorage=void 0;class y{constructor(S,t,m){this.storagePath=S,this.logService=t,this.fileService=m,this.storage=Object.create(null),this.lastSavedStorageContents="",this.flushDelayer=new p.ThrottledDelayer(100),this.initializing=void 0,this.closing=void 0}init(){return this.initializing||(this.initializing=this.doInit()),this.initializing}async doInit(){try{this.lastSavedStorageContents=(await this.fileService.readFile(this.storagePath)).value.toString(),this.storage=JSON.parse(this.lastSavedStorageContents)}catch(S){S.fileOperationResult!==1&&this.logService.error(S)}}getItem(S,t){const m=this.storage[S];return(0,k.isUndefinedOrNull)(m)?t:m}setItem(S,t){this.setItems([{key:S,data:t}])}setItems(S){let t=!1;for(const{key:m,data:v}of S)this.storage[m]!==v&&((0,k.isUndefinedOrNull)(v)?(0,k.isUndefined)(this.storage[m])||(this.storage[m]=void 0,t=!0):(this.storage[m]=v,t=!0));t&&this.save()}removeItem(S){(0,k.isUndefined)(this.storage[S])||(this.storage[S]=void 0,this.save())}async save(S){if(!this.closing)return this.flushDelayer.trigger(()=>this.doSave(),S)}async doSave(){if(!this.initializing)return;await this.initializing;const S=JSON.stringify(this.storage,null,4);if(S!==this.lastSavedStorageContents)try{await this.fileService.writeFile(this.storagePath,R.VSBuffer.fromString(S)),this.lastSavedStorageContents=S}catch(t){this.logService.error(t)}}async close(){return this.closing||(this.closing=this.flushDelayer.trigger(()=>this.doSave(),0)),this.closing}}e.FileStorage=y;let E=class It{constructor(S,t,m){this.fileStorage=new y(n.URI.file((0,C.join)(S.userDataPath,It.STATE_FILE)),t,m)}async init(){return this.fileStorage.init()}getItem(S,t){return this.fileStorage.getItem(S,t)}setItem(S,t){this.fileStorage.setItem(S,t)}setItems(S){this.fileStorage.setItems(S)}removeItem(S){this.fileStorage.removeItem(S)}close(){return this.fileStorage.close()}};E.STATE_FILE="storage.json",E=fe([te(0,I.IEnvironmentMainService),te(1,f.ILogService),te(2,d.IFileService)],E),e.StateMainService=E}),define(x[77],ee([0,1,9,23,4,18,24,20,6,22,49,41]),function(V,e,p,R,C,k,n,I,d,f,y,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractUpdateService=e.createUpdateURL=void 0;function g(t,m,v){return`${v.updateUrl}/api/update/${t}/${m}/${v.commit}`}e.createUpdateURL=g;let S=class{constructor(m,v,b,P,c,a){this.lifecycleMainService=m,this.configurationService=v,this.environmentMainService=b,this.requestService=P,this.logService=c,this.productService=a,this._state=E.State.Uninitialized,this._onStateChange=new C.Emitter,this.onStateChange=this._onStateChange.event}get state(){return this._state}setState(m){this.logService.info("update#setState",m.type),this._state=m,this._onStateChange.fire(m)}initialize(){if(!this.environmentMainService.isBuilt)return;if(this.environmentMainService.disableUpdates){this.logService.info("update#ctor - updates are disabled by the environment");return}if(!this.productService.updateUrl||!this.productService.commit){this.logService.info("update#ctor - updates are disabled as there is no update URL");return}const m=this.getUpdateMode(),v=this.getProductQuality(m);if(!v){this.logService.info("update#ctor - updates are disabled by user preference");return}if(this.url=this.buildUpdateFeedUrl(v),!this.url){this.logService.info("update#ctor - updates are disabled as the update URL is badly formed");return}if(this.setState(E.State.Idle(this.getUpdateType())),m==="manual"){this.logService.info("update#ctor - manual checks only; automatic updates are disabled by user preference");return}m==="start"?(this.logService.info("update#ctor - startup checks only; automatic updates are disabled by user preference"),setTimeout(()=>this.checkForUpdates(!1),30*1e3)):this.scheduleCheckForUpdates(30*1e3).then(void 0,b=>this.logService.error(b))}getUpdateMode(){return(0,k.getMigratedSettingValue)(this.configurationService,"update.mode","update.channel")}getProductQuality(m){return m==="none"?void 0:this.productService.quality}scheduleCheckForUpdates(m=60*60*1e3){return(0,p.timeout)(m).then(()=>this.checkForUpdates(!1)).then(()=>this.scheduleCheckForUpdates(60*60*1e3))}async checkForUpdates(m){this.logService.trace("update#checkForUpdates, state = ",this.state.type),this.state.type==="idle"&&this.doCheckForUpdates(m)}async downloadUpdate(){this.logService.trace("update#downloadUpdate, state = ",this.state.type),this.state.type==="available for download"&&await this.doDownloadUpdate(this.state)}async doDownloadUpdate(m){}async applyUpdate(){this.logService.trace("update#applyUpdate, state = ",this.state.type),this.state.type==="downloaded"&&await this.doApplyUpdate()}async doApplyUpdate(){}quitAndInstall(){return this.logService.trace("update#quitAndInstall, state = ",this.state.type),this.state.type!=="ready"||(this.logService.trace("update#quitAndInstall(): before lifecycle quit()"),this.lifecycleMainService.quit(!0).then(m=>{this.logService.trace(`update#quitAndInstall(): after lifecycle quit() with veto: ${m}`),!m&&(this.logService.trace("update#quitAndInstall(): running raw#quitAndInstall()"),this.doQuitAndInstall())})),Promise.resolve(void 0)}async isLatestVersion(){if(this.url){if(this.getUpdateMode()==="none")return!1}else return;return(await this.requestService.request({url:this.url},R.CancellationToken.None)).res.statusCode===204}getUpdateType(){return 1}doQuitAndInstall(){}};S=fe([te(0,I.ILifecycleMainService),te(1,k.IConfigurationService),te(2,n.IEnvironmentMainService),te(3,y.IRequestService),te(4,d.ILogService),te(5,f.IProductService)],S),e.AbstractUpdateService=S}),define(x[233],ee([0,1,14,46,4,2,18,24,20,6,22,49,29,41,77]),function(V,e,p,R,C,k,n,I,d,f,y,E,g,S,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DarwinUpdateService=void 0;let m=class extends t.AbstractUpdateService{constructor(b,P,c,a,l,o,u){super(b,P,a,l,o,u);this.telemetryService=c,this.disposables=new k.DisposableStore}get onRawError(){return C.Event.fromNodeEventEmitter(p.autoUpdater,"error",(b,P)=>P)}get onRawUpdateNotAvailable(){return C.Event.fromNodeEventEmitter(p.autoUpdater,"update-not-available")}get onRawUpdateAvailable(){return C.Event.fromNodeEventEmitter(p.autoUpdater,"update-available",(b,P,c)=>({url:P,version:c,productVersion:c}))}get onRawUpdateDownloaded(){return C.Event.fromNodeEventEmitter(p.autoUpdater,"update-downloaded",(b,P,c,a)=>({releaseNotes:P,version:c,productVersion:c,date:a}))}initialize(){super.initialize(),this.onRawError(this.onError,this,this.disposables),this.onRawUpdateAvailable(this.onUpdateAvailable,this,this.disposables),this.onRawUpdateDownloaded(this.onUpdateDownloaded,this,this.disposables),this.onRawUpdateNotAvailable(this.onUpdateNotAvailable,this,this.disposables)}onError(b){this.logService.error("UpdateService error:",b);const c=(this.state.type==="checking for updates"?this.state.explicit:!0)?b:void 0;this.setState(S.State.Idle(1,c))}buildUpdateFeedUrl(b){let P;this.productService.darwinUniversalAssetId?P=this.productService.darwinUniversalAssetId:P=process.arch==="x64"?"darwin":"darwin-arm64";const c=(0,t.createUpdateURL)(P,b,this.productService);try{p.autoUpdater.setFeedURL({url:c})}catch(a){this.logService.error("Failed to set update feed URL",a);return}return c}doCheckForUpdates(b){this.setState(S.State.CheckingForUpdates(b)),p.autoUpdater.checkForUpdates()}onUpdateAvailable(b){this.state.type==="checking for updates"&&this.setState(S.State.Downloading(b))}onUpdateDownloaded(b){this.state.type==="downloading"&&(this.telemetryService.publicLog2("update:downloaded",{version:b.version}),this.setState(S.State.Ready(b)))}onUpdateNotAvailable(){this.state.type==="checking for updates"&&(this.telemetryService.publicLog2("update:notAvailable",{explicit:this.state.explicit}),this.setState(S.State.Idle(1)))}doQuitAndInstall(){this.logService.trace("update#quitAndInstall(): running raw#quitAndInstall()"),p.autoUpdater.quitAndInstall()}dispose(){this.disposables.dispose()}};fe([R.memoize],m.prototype,"onRawError",null),fe([R.memoize],m.prototype,"onRawUpdateNotAvailable",null),fe([R.memoize],m.prototype,"onRawUpdateAvailable",null),fe([R.memoize],m.prototype,"onRawUpdateDownloaded",null),m=fe([te(0,d.ILifecycleMainService),te(1,n.IConfigurationService),te(2,g.ITelemetryService),te(3,I.IEnvironmentMainService),te(4,E.IRequestService),te(5,f.ILogService),te(6,y.IProductService)],m),e.DarwinUpdateService=m}),define(x[234],ee([0,1,43,28,9,4,8,24,20,6,29,41]),function(V,e,p,R,C,k,n,I,d,f,y,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SnapUpdateService=void 0;let g=class{constructor(m,v,b){if(this.lifecycleMainService=m,this.logService=b,this._state=E.State.Uninitialized,this._onStateChange=new k.Emitter,this.onStateChange=this._onStateChange.event,v.disableUpdates){this.logService.info("update#ctor - updates are disabled");return}this.setState(E.State.Idle(this.getUpdateType())),this.scheduleCheckForUpdates(30*1e3).then(void 0,P=>this.logService.error(P))}get state(){return this._state}setState(m){this.logService.info("update#setState",m.type),this._state=m,this._onStateChange.fire(m)}scheduleCheckForUpdates(m=60*60*1e3){return(0,C.timeout)(m).then(()=>this.checkForUpdates(!1)).then(()=>this.scheduleCheckForUpdates(60*60*1e3))}async checkForUpdates(m){this.logService.trace("update#checkForUpdates, state = ",this.state.type),this.state.type==="idle"&&this.doCheckForUpdates(m)}async downloadUpdate(){this.logService.trace("update#downloadUpdate, state = ",this.state.type),this.state.type==="available for download"&&await this.doDownloadUpdate(this.state)}doDownloadUpdate(m){return Promise.resolve(void 0)}async applyUpdate(){this.logService.trace("update#applyUpdate, state = ",this.state.type),this.state.type==="downloaded"&&await this.doApplyUpdate()}doApplyUpdate(){return Promise.resolve(void 0)}quitAndInstall(){return this.logService.trace("update#quitAndInstall, state = ",this.state.type),this.state.type!=="ready"||(this.logService.trace("update#quitAndInstall(): before lifecycle quit()"),this.lifecycleMainService.quit(!0).then(m=>{this.logService.trace(`update#quitAndInstall(): after lifecycle quit() with veto: ${m}`),!m&&(this.logService.trace("update#quitAndInstall(): running raw#quitAndInstall()"),this.doQuitAndInstall())})),Promise.resolve(void 0)}getUpdateType(){return 2}doQuitAndInstall(){}};g=fe([te(0,d.ILifecycleMainService),te(1,I.IEnvironmentMainService),te(2,f.ILogService)],g);let S=class extends g{constructor(m,v,b,P,c,a){super(b,P,c);this.snap=m,this.snapRevision=v,this.telemetryService=a;const l=(0,R.watch)(n.dirname(this.snap)),o=k.Event.fromNodeEventEmitter(l,"change",(s,h)=>h),u=k.Event.filter(o,s=>s==="current"),i=k.Event.debounce(u,(s,h)=>h,2e3)(()=>this.checkForUpdates(!1));b.onWillShutdown(()=>{i.dispose(),l.close()})}doCheckForUpdates(){this.setState(E.State.CheckingForUpdates(!1)),this.isUpdateAvailable().then(m=>{m?this.setState(E.State.Ready({version:"something",productVersion:"something"})):(this.telemetryService.publicLog2("update:notAvailable",{explicit:!1}),this.setState(E.State.Idle(2)))},m=>{this.logService.error(m),this.telemetryService.publicLog2("update:notAvailable",{explicit:!1}),this.setState(E.State.Idle(2,m.message||m))})}doQuitAndInstall(){this.logService.trace("update#quitAndInstall(): running raw#quitAndInstall()"),(0,p.spawn)("sleep 3 && "+n.basename(process.argv[0]),{shell:!0,detached:!0,stdio:"ignore"})}async isUpdateAvailable(){const m=await new Promise((b,P)=>(0,R.realpath)(`${n.dirname(this.snap)}/current`,(c,a)=>c?P(c):b(a))),v=n.basename(m);return this.snapRevision!==v}isLatestVersion(){return this.isUpdateAvailable().then(void 0,m=>{this.logService.error("update#checkForSnapUpdate(): Could not get realpath of application.")})}};S=fe([te(2,d.ILifecycleMainService),te(3,I.IEnvironmentMainService),te(4,f.ILogService),te(5,y.ITelemetryService)],S),e.SnapUpdateService=S}),define(x[45],ee([0,1,14,28,4,38,33,2,10,8,3,15,13,21,158,50,51,24,5,6,22,101,27,102]),function(V,e,p,R,C,k,n,I,d,f,y,E,g,S,t,m,v,b,P,c,a,l,o,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WorkspacesManagementMainService=e.IWorkspacesManagementMainService=void 0,e.IWorkspacesManagementMainService=(0,P.createDecorator)("workspacesManagementMainService");let r=class extends I.Disposable{constructor(s,h,w,M,A){super();this.environmentMainService=s,this.logService=h,this.backupMainService=w,this.dialogMainService=M,this.productService=A,this.untitledWorkspacesHome=this.environmentMainService.untitledWorkspacesHome,this._onDidDeleteUntitledWorkspace=this._register(new C.Emitter),this.onDidDeleteUntitledWorkspace=this._onDidDeleteUntitledWorkspace.event,this._onDidEnterWorkspace=this._register(new C.Emitter),this.onDidEnterWorkspace=this._onDidEnterWorkspace.event}resolveLocalWorkspaceSync(s){return this.doResolveLocalWorkspace(s,h=>(0,R.readFileSync)(h,"utf8"))}resolveLocalWorkspace(s){return this.doResolveLocalWorkspace(s,h=>S.Promises.readFile(h,"utf8"))}doResolveLocalWorkspace(s,h){if(!!this.isWorkspacePath(s)&&s.scheme===d.Schemas.file)try{const w=h(s.fsPath);return w instanceof Promise?w.then(M=>this.doResolveWorkspace(s,M),M=>{}):this.doResolveWorkspace(s,w)}catch{return}}isWorkspacePath(s){return(0,o.isUntitledWorkspace)(s,this.environmentMainService)||(0,o.hasWorkspaceFileExtension)(s)}doResolveWorkspace(s,h){try{const w=this.doParseStoredWorkspace(s,h),M=(0,u.getWorkspaceIdentifier)(s);return{id:M.id,configPath:M.configPath,folders:(0,o.toWorkspaceFolders)(w.folders,M.configPath,E.extUriBiasedIgnorePathCase),remoteAuthority:w.remoteAuthority,transient:w.transient}}catch(w){this.logService.warn(w.toString())}}doParseStoredWorkspace(s,h){const w=(0,k.parse)(h);if(w&&Array.isArray(w.folders))w.folders=w.folders.filter(M=>(0,o.isStoredWorkspaceFolder)(M));else throw new Error(`${s.toString(!0)} looks like an invalid workspace file.`);return w}async createUntitledWorkspace(s,h){const{workspace:w,storedWorkspace:M}=this.newUntitledWorkspace(s,h),A=w.configPath.fsPath;return await S.Promises.mkdir((0,f.dirname)(A),{recursive:!0}),await S.Promises.writeFile(A,JSON.stringify(M,null,"	")),w}createUntitledWorkspaceSync(s,h){const{workspace:w,storedWorkspace:M}=this.newUntitledWorkspace(s,h),A=w.configPath.fsPath;return(0,R.mkdirSync)((0,f.dirname)(A),{recursive:!0}),(0,S.writeFileSync)(A,JSON.stringify(M,null,"	")),w}newUntitledWorkspace(s=[],h){const w=(Date.now()+Math.round(Math.random()*1e3)).toString(),M=(0,E.joinPath)(this.untitledWorkspacesHome,w),A=(0,E.joinPath)(M,o.UNTITLED_WORKSPACE_NAME),L=[];for(const F of s)L.push((0,o.getStoredWorkspaceFolder)(F.uri,!0,F.name,M,!y.isWindows,E.extUriBiasedIgnorePathCase));return{workspace:(0,u.getWorkspaceIdentifier)(A),storedWorkspace:{folders:L,remoteAuthority:h}}}async getWorkspaceIdentifier(s){return(0,u.getWorkspaceIdentifier)(s)}isUntitledWorkspace(s){return(0,o.isUntitledWorkspace)(s.configPath,this.environmentMainService)}deleteUntitledWorkspaceSync(s){!this.isUntitledWorkspace(s)||(this.doDeleteUntitledWorkspaceSync(s),this._onDidDeleteUntitledWorkspace.fire(s))}async deleteUntitledWorkspace(s){this.deleteUntitledWorkspaceSync(s)}doDeleteUntitledWorkspaceSync(s){const h=(0,E.originalFSPath)(s.configPath);try{(0,S.rimrafSync)((0,f.dirname)(h));const w=(0,f.join)(this.environmentMainService.workspaceStorageHome.fsPath,s.id);(0,R.existsSync)(w)&&(0,S.writeFileSync)((0,f.join)(w,"obsolete"),"")}catch(w){this.logService.warn(`Unable to delete untitled workspace ${h} (${w}).`)}}getUntitledWorkspacesSync(){const s=[];try{const h=(0,S.readdirSync)(this.untitledWorkspacesHome.fsPath).map(w=>(0,E.joinPath)(this.untitledWorkspacesHome,w,o.UNTITLED_WORKSPACE_NAME));for(const w of h){const M=(0,u.getWorkspaceIdentifier)(w),A=this.resolveLocalWorkspaceSync(w);A?s.push({workspace:M,remoteAuthority:A.remoteAuthority}):this.doDeleteUntitledWorkspaceSync(M)}}catch(h){h.code!=="ENOENT"&&this.logService.warn(`Unable to read folders in ${this.untitledWorkspacesHome} (${h}).`)}return s}async enterWorkspace(s,h,w){if(!s||!s.win||!s.isReady||!await this.isValidTargetWorkspacePath(s,h,w))return;const A=this.doEnterWorkspace(s,(0,u.getWorkspaceIdentifier)(w));if(!!A)return this._onDidEnterWorkspace.fire({window:s,workspace:A.workspace}),A}async isValidTargetWorkspacePath(s,h,w){if(!w)return!0;if((0,o.isWorkspaceIdentifier)(s.openedWorkspace)&&E.extUriBiasedIgnorePathCase.isEqual(s.openedWorkspace.configPath,w))return!1;if((0,l.findWindowOnWorkspaceOrFolder)(h,w)){const M={title:this.productService.nameLong,type:"info",buttons:[(0,n.mnemonicButtonLabel)((0,t.localize)(0,null))],message:(0,t.localize)(1,null,(0,E.basename)(w)),detail:(0,t.localize)(2,null),noLink:!0,defaultId:0};return await this.dialogMainService.showMessageBox(M,(0,g.withNullAsUndefined)(p.BrowserWindow.getFocusedWindow())),!1}return!0}doEnterWorkspace(s,h){if(!s.config)return;s.focus();let w;return s.config.extensionDevelopmentPath||(w=this.backupMainService.registerWorkspaceBackupSync({workspace:h,remoteAuthority:s.remoteAuthority},s.config.backupPath)),(0,o.isWorkspaceIdentifier)(s.openedWorkspace)&&this.isUntitledWorkspace(s.openedWorkspace)&&this.deleteUntitledWorkspaceSync(s.openedWorkspace),s.config.workspace=h,s.config.backupPath=w,{workspace:h,backupPath:w}}};r=fe([te(0,b.IEnvironmentMainService),te(1,c.ILogService),te(2,m.IBackupMainService),te(3,v.IDialogMainService),te(4,a.IProductService)],r),e.WorkspacesManagementMainService=r}),define(x[103],ee([0,1,14,30,23,3,13,7,21,18,53,5,6,99,36,27,45]),function(V,e,p,R,C,k,n,I,d,f,y,E,g,S,t,m,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LaunchMainService=e.ILaunchMainService=e.ID=void 0,e.ID="launchMainService",e.ILaunchMainService=(0,E.createDecorator)(e.ID);let b=class{constructor(c,a,l,o,u){this.logService=c,this.windowsMainService=a,this.urlService=l,this.workspacesManagementMainService=o,this.configurationService=u}async start(c,a){this.logService.trace("Received data from other instance: ",c,a),k.isMacintosh&&p.app.focus({steal:!0});const l=this.parseOpenUrl(c);if(l.length){let o=Promise.resolve();this.windowsMainService.getWindowCount()===0&&(o=this.windowsMainService.openEmptyWindow({context:4})[0].ready()),o.then(()=>{for(const{uri:u,url:r}of l)this.urlService.open(u,{originalUrl:r})})}else return this.startOpenWindow(c,a)}parseOpenUrl(c){return c["open-url"]&&c._urls&&c._urls.length>0?(0,R.coalesce)(c._urls.map(a=>{try{return{uri:I.URI.parse(a),url:a}}catch(l){return null}})):[]}async startOpenWindow(c,a){const l=(0,y.isLaunchedFromCli)(a)?0:4;let o=[];const u=c.wait&&c.waitMarkerFilePath?I.URI.file(c.waitMarkerFilePath):void 0,r=c.remote||void 0,i={context:l,cli:c,userEnv:a,waitMarkerFileURI:u,remoteAuthority:r};if(c.extensionDevelopmentPath)this.windowsMainService.openExtensionDevelopmentHostWindow(c.extensionDevelopmentPath,i);else if(!c._.length&&!c["folder-uri"]&&!c["file-uri"]){let s=!1;if(c["new-window"]||c["unity-launch"])s=!0;else if(c["reuse-window"])s=!1;else switch(this.configurationService.getValue("window")?.openWithoutArgumentsInNewWindow||"default"){case"on":s=!0;break;case"off":s=!1;break;default:s=!k.isMacintosh}if(s)o=this.windowsMainService.open({...i,forceNewWindow:!0,forceEmpty:!0});else{const h=this.windowsMainService.getLastActiveWindow();h?(this.windowsMainService.openExistingWindow(h,i),o=[h]):o=this.windowsMainService.open({...i,forceEmpty:!0})}}else o=this.windowsMainService.open({...i,forceNewWindow:c["new-window"],preferNewWindow:!c["reuse-window"]&&!c.wait,forceReuseWindow:c["reuse-window"],diffMode:c.diff,addMode:c.add,noRecentEntry:!!c["skip-add-to-recently-opened"],gotoLineMode:c.goto});if(u&&o.length===1&&o[0])return Promise.race([o[0].whenClosedOrLoaded,(0,d.whenDeleted)(u.fsPath)]).then(()=>{},()=>{})}async getMainProcessId(){return this.logService.trace("Received request for process ID from other instance."),process.pid}async getMainProcessInfo(){this.logService.trace("Received request for main process info from other instance.");const c=[];return p.BrowserWindow.getAllWindows().forEach(a=>{const l=this.windowsMainService.getWindowById(a.id);l?c.push(this.codeWindowToInfo(l)):c.push(this.browserWindowToInfo(a))}),{mainPID:process.pid,mainArguments:process.argv.slice(1),windows:c,screenReader:!!p.app.accessibilitySupportEnabled,gpuFeatureStatus:p.app.getGPUFeatureStatus()}}async getRemoteDiagnostics(c){const a=this.windowsMainService.getWindows();return(await Promise.all(a.map(o=>new Promise(u=>{const r=o.remoteAuthority;if(r){const i=`vscode:getDiagnosticInfoResponse${o.id}`,s={includeProcesses:c.includeProcesses,folders:c.includeWorkspaceMetadata?this.getFolderURIs(o):void 0};o.sendWhenReady("vscode:getDiagnosticInfo",C.CancellationToken.None,{replyChannel:i,args:s}),p.ipcMain.once(i,(h,w)=>{w||u({hostName:r,errorMessage:`Unable to resolve connection to '${r}'.`}),u(w)}),setTimeout(()=>{u({hostName:r,errorMessage:`Fetching remote diagnostics for '${r}' timed out.`})},5e3)}else u(void 0)})))).filter(o=>!!o)}getFolderURIs(c){const a=[],l=c.openedWorkspace;if((0,m.isSingleFolderWorkspaceIdentifier)(l))a.push(l.uri);else if((0,m.isWorkspaceIdentifier)(l)){const o=this.workspacesManagementMainService.resolveLocalWorkspaceSync(l.configPath);o&&o.folders.forEach(r=>{a.push(r.uri)})}return a}codeWindowToInfo(c){const a=this.getFolderURIs(c),l=(0,n.assertIsDefined)(c.win);return this.browserWindowToInfo(l,a,c.remoteAuthority)}browserWindowToInfo(c,a=[],l){return{pid:c.webContents.getOSProcessId(),title:c.getTitle(),folderURIs:a,remoteAuthority:l}}};b=fe([te(0,g.ILogService),te(1,t.IWindowsMainService),te(2,S.IURLService),te(3,v.IWorkspacesManagementMainService),te(4,f.IConfigurationService)],b),e.LaunchMainService=b}),define(x[52],ee([0,1,43,14,26,117,46,4,33,2,10,8,3,7,82,71,21,150,51,24,5,20,6,22,29,66,36,27,45]),function(V,e,p,R,C,k,n,I,d,f,y,E,g,S,t,m,v,b,P,c,a,l,o,u,r,i,s,h,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeHostMainService=e.INativeHostMainService=void 0,e.INativeHostMainService=(0,a.createDecorator)("nativeHostMainService");let M=class ft extends f.Disposable{constructor(L,F,U,Y,ie,re,K,W,N,G){super();this.sharedProcess=L,this.windowsMainService=F,this.dialogMainService=U,this.lifecycleMainService=Y,this.environmentMainService=ie,this.telemetryService=re,this.logService=K,this.productService=W,this.themeMainService=N,this.workspacesManagementMainService=G,this.onDidOpenWindow=I.Event.map(this.windowsMainService.onDidOpenWindow,Q=>Q.id),this.onDidMaximizeWindow=I.Event.filter(I.Event.fromNodeEventEmitter(R.app,"browser-window-maximize",(Q,H)=>H.id),Q=>!!this.windowsMainService.getWindowById(Q)),this.onDidUnmaximizeWindow=I.Event.filter(I.Event.fromNodeEventEmitter(R.app,"browser-window-unmaximize",(Q,H)=>H.id),Q=>!!this.windowsMainService.getWindowById(Q)),this.onDidBlurWindow=I.Event.filter(I.Event.fromNodeEventEmitter(R.app,"browser-window-blur",(Q,H)=>H.id),Q=>!!this.windowsMainService.getWindowById(Q)),this.onDidFocusWindow=I.Event.any(I.Event.map(I.Event.filter(I.Event.map(this.windowsMainService.onDidChangeWindowsCount,()=>this.windowsMainService.getLastActiveWindow()),Q=>!!Q),Q=>Q.id),I.Event.filter(I.Event.fromNodeEventEmitter(R.app,"browser-window-focus",(Q,H)=>H.id),Q=>!!this.windowsMainService.getWindowById(Q))),this.onDidResumeOS=I.Event.fromNodeEventEmitter(R.powerMonitor,"resume"),this._onDidChangeColorScheme=this._register(new I.Emitter),this.onDidChangeColorScheme=this._onDidChangeColorScheme.event,this._onDidChangePassword=this._register(new I.Emitter),this.onDidChangePassword=this._onDidChangePassword.event,this.onDidChangeDisplay=I.Event.debounce(I.Event.any(I.Event.filter(I.Event.fromNodeEventEmitter(R.screen,"display-metrics-changed",(Q,H,$)=>$),Q=>!(Array.isArray(Q)&&Q.length===1&&Q[0]==="workArea")),I.Event.fromNodeEventEmitter(R.screen,"display-added"),I.Event.fromNodeEventEmitter(R.screen,"display-removed")),()=>{},100),this.registerListeners()}registerListeners(){R.nativeTheme.on("updated",()=>{this._onDidChangeColorScheme.fire(this.osColorScheme)})}get windowId(){throw new Error("Not implemented in electron-main")}async getWindows(){return this.windowsMainService.getWindows().map(F=>({id:F.id,workspace:F.openedWorkspace,title:F.win?.getTitle()??"",filename:F.getRepresentedFilename(),dirty:F.isDocumentEdited()}))}async getWindowCount(L){return this.windowsMainService.getWindowCount()}async getActiveWindowId(L){const F=R.BrowserWindow.getFocusedWindow()||this.windowsMainService.getLastActiveWindow();if(F)return F.id}openWindow(L,F,U){return Array.isArray(F)?this.doOpenWindow(L,F,U):this.doOpenEmptyWindow(L,F)}async doOpenWindow(L,F,U=Object.create(null)){F.length>0&&this.windowsMainService.open({context:5,contextWindowId:L,urisToOpen:F,cli:this.environmentMainService.args,forceNewWindow:U.forceNewWindow,forceReuseWindow:U.forceReuseWindow,preferNewWindow:U.preferNewWindow,diffMode:U.diffMode,addMode:U.addMode,gotoLineMode:U.gotoLineMode,noRecentEntry:U.noRecentEntry,waitMarkerFileURI:U.waitMarkerFileURI,remoteAuthority:U.remoteAuthority||void 0})}async doOpenEmptyWindow(L,F){this.windowsMainService.openEmptyWindow({context:5,contextWindowId:L},F)}async toggleFullScreen(L){const F=this.windowById(L);F&&F.toggleFullScreen()}async handleTitleDoubleClick(L){const F=this.windowById(L);F&&F.handleTitleDoubleClick()}async isMaximized(L){const F=this.windowById(L);return F?.win?F.win.isMaximized():!1}async maximizeWindow(L){const F=this.windowById(L);F?.win&&F.win.maximize()}async unmaximizeWindow(L){const F=this.windowById(L);F?.win&&F.win.unmaximize()}async minimizeWindow(L){const F=this.windowById(L);F?.win&&F.win.minimize()}async focusWindow(L,F){F&&typeof F.windowId=="number"&&(L=F.windowId);const U=this.windowById(L);U&&U.focus({force:F?.force??!1})}async setMinimumSize(L,F,U){const Y=this.windowById(L);if(Y?.win){const[ie,re]=Y.win.getSize(),[K,W]=Y.win.getMinimumSize(),[N,G]=[F??K,U??W],[Q,H]=[Math.max(ie,N),Math.max(re,G)];(K!==N||W!==G)&&Y.win.setMinimumSize(N,G),(ie!==Q||re!==H)&&Y.win.setSize(Q,H)}}async saveWindowSplash(L,F){this.themeMainService.saveWindowSplash(L,F)}async installShellCommand(L){const{source:F,target:U}=await this.getShellCommandLink();try{const{symbolicLink:Y}=await v.SymlinkSupport.stat(F);if(Y&&!Y.dangling){const ie=await(0,t.realpath)(F);if(U===ie)return}await v.Promises.unlink(F)}catch(Y){if(Y.code!=="ENOENT")throw Y}try{await v.Promises.symlink(U,F)}catch(Y){if(Y.code!=="EACCES"&&Y.code!=="ENOENT")throw Y;const{response:ie}=await this.showMessageBox(L,{title:this.productService.nameLong,type:"info",message:(0,b.localize)(0,null,this.productService.nameShort),buttons:[(0,d.mnemonicButtonLabel)((0,b.localize)(1,null)),(0,d.mnemonicButtonLabel)((0,b.localize)(2,null))],noLink:!0,defaultId:0,cancelId:1});if(ie===0)try{const re=`osascript -e "do shell script \\"mkdir -p /usr/local/bin && ln -sf '${U}' '${F}'\\" with administrator privileges"`;await(0,k.promisify)(p.exec)(re)}catch(re){throw new Error((0,b.localize)(3,null,F))}}}async uninstallShellCommand(L){const{source:F}=await this.getShellCommandLink();try{await v.Promises.unlink(F)}catch(U){switch(U.code){case"EACCES":const{response:Y}=await this.showMessageBox(L,{title:this.productService.nameLong,type:"info",message:(0,b.localize)(4,null,this.productService.nameShort),buttons:[(0,d.mnemonicButtonLabel)((0,b.localize)(5,null)),(0,d.mnemonicButtonLabel)((0,b.localize)(6,null))],noLink:!0,defaultId:0,cancelId:1});if(Y===0)try{const ie=`osascript -e "do shell script \\"rm '${F}'\\" with administrator privileges"`;await(0,k.promisify)(p.exec)(ie)}catch(ie){throw new Error((0,b.localize)(7,null,F))}break;case"ENOENT":break;default:throw U}}}async getShellCommandLink(){const L=(0,E.resolve)(this.environmentMainService.appRoot,"bin","code"),F=`/usr/local/bin/${this.productService.applicationName}`;if(!await v.Promises.exists(L))throw new Error((0,b.localize)(8,null,L));return{source:F,target:L}}async showMessageBox(L,F){return this.dialogMainService.showMessageBox(F,this.toBrowserWindow(L))}async showSaveDialog(L,F){return this.dialogMainService.showSaveDialog(F,this.toBrowserWindow(L))}async showOpenDialog(L,F){return this.dialogMainService.showOpenDialog(F,this.toBrowserWindow(L))}toBrowserWindow(L){const F=this.windowById(L);if(F?.win)return F.win}async pickFileFolderAndOpen(L,F){const U=await this.dialogMainService.pickFileFolder(F);U&&(this.sendPickerTelemetry(U,F.telemetryEventName||"openFileFolder",F.telemetryExtraData),this.doOpenPicked(await Promise.all(U.map(async Y=>await v.SymlinkSupport.existsDirectory(Y)?{folderUri:S.URI.file(Y)}:{fileUri:S.URI.file(Y)})),F,L))}async pickFolderAndOpen(L,F){const U=await this.dialogMainService.pickFolder(F);U&&(this.sendPickerTelemetry(U,F.telemetryEventName||"openFolder",F.telemetryExtraData),this.doOpenPicked(U.map(Y=>({folderUri:S.URI.file(Y)})),F,L))}async pickFileAndOpen(L,F){const U=await this.dialogMainService.pickFile(F);U&&(this.sendPickerTelemetry(U,F.telemetryEventName||"openFile",F.telemetryExtraData),this.doOpenPicked(U.map(Y=>({fileUri:S.URI.file(Y)})),F,L))}async pickWorkspaceAndOpen(L,F){const U=await this.dialogMainService.pickWorkspace(F);U&&(this.sendPickerTelemetry(U,F.telemetryEventName||"openWorkspace",F.telemetryExtraData),this.doOpenPicked(U.map(Y=>({workspaceUri:S.URI.file(Y)})),F,L))}doOpenPicked(L,F,U){this.windowsMainService.open({context:3,contextWindowId:U,cli:this.environmentMainService.args,urisToOpen:L,forceNewWindow:F.forceNewWindow})}sendPickerTelemetry(L,F,U){const Y=L?L.length:0;this.telemetryService.publicLog(F,{...U,outcome:Y?"success":"canceled",numberOfPaths:Y})}async showItemInFolder(L,F){R.shell.showItemInFolder(F)}async setRepresentedFilename(L,F){const U=this.windowById(L);U&&U.setRepresentedFilename(F)}async setDocumentEdited(L,F){const U=this.windowById(L);U&&U.setDocumentEdited(F)}async openExternal(L,F){return g.isLinuxSnap?this.safeSnapOpenExternal(F):R.shell.openExternal(F),!0}safeSnapOpenExternal(L){const F=process.env.GDK_PIXBUF_MODULE_FILE,U=process.env.GDK_PIXBUF_MODULEDIR;delete process.env.GDK_PIXBUF_MODULE_FILE,delete process.env.GDK_PIXBUF_MODULEDIR,R.shell.openExternal(L),process.env.GDK_PIXBUF_MODULE_FILE=F,process.env.GDK_PIXBUF_MODULEDIR=U}moveItemToTrash(L,F){return R.shell.trashItem(F)}async isAdmin(){let L;return g.isWindows?L=(await new Promise((F,U)=>{V(["native-is-elevated"],F,U)}))():L=process.getuid()===0,L}async writeElevated(L,F,U,Y){const ie=await new Promise((re,K)=>{V(["@vscode/sudo-prompt"],re,K)});return new Promise((re,K)=>{const W=[`"${this.cliPath}"`];Y?.unlock&&W.push("--file-chmod"),W.push("--file-write",`"${F.fsPath}"`,`"${U.fsPath}"`);const N={name:this.productService.nameLong.replace("-",""),icns:g.isMacintosh&&this.environmentMainService.isBuilt?(0,E.join)((0,E.dirname)(this.environmentMainService.appRoot),`${this.productService.nameShort}.icns`):void 0};ie.exec(W.join(" "),N,(G,Q,H)=>{Q&&this.logService.trace(`[sudo-prompt] received stdout: ${Q}`),H&&this.logService.trace(`[sudo-prompt] received stderr: ${H}`),G?K(G):re(void 0)})})}get cliPath(){return g.isWindows?this.environmentMainService.isBuilt?(0,E.join)((0,E.dirname)(process.execPath),"bin",`${this.productService.applicationName}.cmd`):(0,E.join)(this.environmentMainService.appRoot,"scripts","code-cli.bat"):g.isLinux?this.environmentMainService.isBuilt?(0,E.join)((0,E.dirname)(process.execPath),"bin",`${this.productService.applicationName}`):(0,E.join)(this.environmentMainService.appRoot,"scripts","code-cli.sh"):this.environmentMainService.isBuilt?(0,E.join)(this.environmentMainService.appRoot,"bin","code"):(0,E.join)(this.environmentMainService.appRoot,"scripts","code-cli.sh")}async getOSStatistics(){return{totalmem:(0,C.totalmem)(),freemem:(0,C.freemem)(),loadavg:(0,C.loadavg)()}}async getOSProperties(){return{arch:(0,C.arch)(),platform:(0,C.platform)(),release:(0,C.release)(),type:(0,C.type)(),cpus:(0,C.cpus)()}}async getOSVirtualMachineHint(){return m.virtualMachineHint.value()}get osColorScheme(){return{highContrast:R.nativeTheme.shouldUseInvertedColorScheme||R.nativeTheme.shouldUseHighContrastColors,dark:R.nativeTheme.shouldUseDarkColors}}async getOSColorScheme(){return this.osColorScheme}async killProcess(L,F,U){process.kill(F,U)}async readClipboardText(L,F){return R.clipboard.readText(F)}async writeClipboardText(L,F,U){return R.clipboard.writeText(F,U)}async readClipboardFindText(L){return R.clipboard.readFindText()}async writeClipboardFindText(L,F){return R.clipboard.writeFindText(F)}async writeClipboardBuffer(L,F,U,Y){return R.clipboard.writeBuffer(F,Buffer.from(U),Y)}async readClipboardBuffer(L,F){return R.clipboard.readBuffer(F)}async hasClipboard(L,F,U){return R.clipboard.has(F,U)}async newWindowTab(){this.windowsMainService.open({context:5,cli:this.environmentMainService.args,forceNewTabbedWindow:!0,forceEmpty:!0,remoteAuthority:this.environmentMainService.args.remote||void 0})}async showPreviousWindowTab(){R.Menu.sendActionToFirstResponder("selectPreviousTab:")}async showNextWindowTab(){R.Menu.sendActionToFirstResponder("selectNextTab:")}async moveWindowTabToNewWindow(){R.Menu.sendActionToFirstResponder("moveTabToNewWindow:")}async mergeAllWindowTabs(){R.Menu.sendActionToFirstResponder("mergeAllWindows:")}async toggleWindowTabsBar(){R.Menu.sendActionToFirstResponder("toggleTabBar:")}async updateTouchBar(L,F){const U=this.windowById(L);U&&U.updateTouchBar(F)}async notifyReady(L){const F=this.windowById(L);F&&F.setReady()}async relaunch(L,F){return this.lifecycleMainService.relaunch(F)}async reload(L,F){const U=this.windowById(L);if(U){if((0,h.isWorkspaceIdentifier)(U.openedWorkspace)){const Y=U.openedWorkspace.configPath;if(Y.scheme===y.Schemas.file&&(await this.workspacesManagementMainService.resolveLocalWorkspace(Y))?.transient)return this.openWindow(U.id,{forceReuseWindow:!0})}return this.lifecycleMainService.reload(U,F?.disableExtensions!==void 0?{_:[],"disable-extensions":F.disableExtensions}:void 0)}}async closeWindow(L){this.closeWindowById(L,L)}async closeWindowById(L,F){const U=this.windowById(F);if(U?.win)return U.win.close()}async quit(L){const F=this.windowsMainService.getLastActiveWindow();F?.isExtensionDevelopmentHost&&this.windowsMainService.getWindowCount()>1&&F.win?F.win.close():this.lifecycleMainService.quit()}async exit(L,F){await this.lifecycleMainService.kill(F)}async resolveProxy(L,F){const Y=this.windowById(L)?.win?.webContents?.session;if(Y)return Y.resolveProxy(F)}async openDevTools(L,F){const U=this.windowById(L);U?.win&&U.win.webContents.openDevTools(F)}async toggleDevTools(L){const F=this.windowById(L);F?.win&&F.win.webContents.toggleDevTools()}async sendInputEvent(L,F){const U=this.windowById(L);U?.win&&(F.type==="mouseDown"||F.type==="mouseUp")&&U.win.webContents.sendInputEvent(F)}async toggleSharedProcessWindow(){return this.sharedProcess.toggle()}async windowsGetStringRegKey(L,F,U,Y){if(!g.isWindows)return;const ie=await new Promise((re,K)=>{V(["vscode-windows-registry"],re,K)});try{return ie.GetStringRegKey(F,U,Y)}catch{return}}async getPassword(L,F,U){const Y=await this.withKeytar(),ie=await Y.getPassword(F,U);if(ie)try{let{content:re,hasNextChunk:K}=JSON.parse(ie);if(!re||!K)return ie;let W=1;for(;K;){const N=await Y.getPassword(F,`${U}-${W}`),G=JSON.parse(N);re+=G.content,K=G.hasNextChunk,W++}return re}catch{return ie}return ie}async setPassword(L,F,U,Y){const ie=await this.withKeytar(),re=3,K=async(W,N,G)=>{let Q=0,H;for(;Q<re;)try{await ie.setPassword(W,N,G);return}catch($){H=$,this.logService.warn("Error attempting to set a password: ",$),Q++,await new Promise(J=>setTimeout(J,200))}throw H};if(g.isWindows&&Y.length>ft.MAX_PASSWORD_LENGTH){let W=0,N=0,G=!0;for(;G;){const Q=Y.substring(W,W+ft.PASSWORD_CHUNK_SIZE);W+=ft.PASSWORD_CHUNK_SIZE,G=Y.length-W>0;const H={content:Q,hasNextChunk:G};await K(F,N?`${U}-${N}`:U,JSON.stringify(H)),N++}}else await K(F,U,Y);this._onDidChangePassword.fire({service:F,account:U})}async deletePassword(L,F,U){const ie=await(await this.withKeytar()).deletePassword(F,U);return ie&&this._onDidChangePassword.fire({service:F,account:U}),ie}async findPassword(L,F){return(await this.withKeytar()).findPassword(F)}async findCredentials(L,F){return(await this.withKeytar()).findCredentials(F)}async withKeytar(){if(this.environmentMainService.disableKeytar)throw new Error("keytar has been disabled via --disable-keytar option");return await new Promise((L,F)=>{V(["keytar"],L,F)})}windowById(L){if(typeof L=="number")return this.windowsMainService.getWindowById(L)}};M.MAX_PASSWORD_LENGTH=2500,M.PASSWORD_CHUNK_SIZE=M.MAX_PASSWORD_LENGTH-100,fe([n.memoize],M.prototype,"cliPath",null),M=fe([te(1,s.IWindowsMainService),te(2,P.IDialogMainService),te(3,l.ILifecycleMainService),te(4,c.IEnvironmentMainService),te(5,r.ITelemetryService),te(6,o.ILogService),te(7,u.IProductService),te(8,i.IThemeMainService),te(9,w.IWorkspacesManagementMainService)],M),e.NativeHostMainService=M}),define(x[235],ee([0,1,14,23,4,81,2,31,89,6,52,22,36]),function(V,e,p,R,C,k,n,I,d,f,y,E,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ProxyAuthHandler=void 0;var S;(function(m){m[m.Initial=1]="Initial",m[m.StoredCredentialsUsed=2]="StoredCredentialsUsed",m[m.LoginDialogShown=3]="LoginDialogShown"})(S||(S={}));let t=class extends n.Disposable{constructor(v,b,P,c,a){super();this.logService=v,this.windowsMainService=b,this.nativeHostMainService=P,this.encryptionMainService=c,this.productService=a,this.PROXY_CREDENTIALS_SERVICE_KEY=`${this.productService.urlProtocol}.proxy-credentials`,this.pendingProxyResolve=void 0,this.state=S.Initial,this.sessionCredentials=void 0,this.registerListeners()}registerListeners(){const v=C.Event.fromNodeEventEmitter(p.app,"login",(b,P,c,a,l)=>({event:b,webContents:P,req:c,authInfo:a,callback:l}));this._register(v(this.onLogin,this))}async onLogin({event:v,authInfo:b,req:P,callback:c}){if(!b.isProxy)return;if(!this.pendingProxyResolve&&this.state===S.LoginDialogShown&&P.firstAuthAttempt){this.logService.trace("auth#onLogin (proxy) - exit - proxy dialog already shown");return}v.preventDefault();let a;if(this.pendingProxyResolve)this.logService.trace("auth#onLogin (proxy) - pending proxy handling found"),a=await this.pendingProxyResolve;else{this.logService.trace("auth#onLogin (proxy) - no pending proxy handling found, starting new"),this.pendingProxyResolve=this.resolveProxyCredentials(b);try{a=await this.pendingProxyResolve}finally{this.pendingProxyResolve=void 0}}c(a?.username,a?.password)}async resolveProxyCredentials(v){this.logService.trace("auth#resolveProxyCredentials (proxy) - enter");try{const b=await this.doResolveProxyCredentials(v);if(b)return this.logService.trace("auth#resolveProxyCredentials (proxy) - got credentials"),b;this.logService.trace("auth#resolveProxyCredentials (proxy) - did not get credentials")}finally{this.logService.trace("auth#resolveProxyCredentials (proxy) - exit")}}async doResolveProxyCredentials(v){this.logService.trace("auth#doResolveProxyCredentials - enter",v);const b=String((0,k.hash)({scheme:v.scheme,host:v.host,port:v.port}));let P,c;try{const u=await this.nativeHostMainService.getPassword(void 0,this.PROXY_CREDENTIALS_SERVICE_KEY,b);if(u){const r=JSON.parse(await this.encryptionMainService.decrypt(u));P=r.username,c=r.password}}catch(u){this.logService.error(u)}if(this.state!==S.StoredCredentialsUsed&&typeof P=="string"&&typeof c=="string")return this.logService.trace("auth#doResolveProxyCredentials (proxy) - exit - found stored credentials to use"),this.state=S.StoredCredentialsUsed,{username:P,password:c};const a=this.windowsMainService.getFocusedWindow()||this.windowsMainService.getLastActiveWindow();if(!a){this.logService.trace("auth#doResolveProxyCredentials (proxy) - exit - no opened window found to show dialog in");return}this.logService.trace(`auth#doResolveProxyCredentials (proxy) - asking window ${a.id} to handle proxy login`);const l={authInfo:v,username:this.sessionCredentials?.username??P,password:this.sessionCredentials?.password??c,replyChannel:`vscode:proxyAuthResponse:${(0,I.generateUuid)()}`};a.sendWhenReady("vscode:openProxyAuthenticationDialog",R.CancellationToken.None,l),this.state=S.LoginDialogShown;const o=await new Promise(u=>{const r=async(i,s,h)=>{if(s===l.replyChannel)if(this.logService.trace(`auth#doResolveProxyCredentials - exit - received credentials from window ${a.id}`),a.win?.webContents.off("ipc-message",r),h){const w={username:h.username,password:h.password};try{if(h.remember){const M=await this.encryptionMainService.encrypt(JSON.stringify(w));await this.nativeHostMainService.setPassword(void 0,this.PROXY_CREDENTIALS_SERVICE_KEY,b,M)}else await this.nativeHostMainService.deletePassword(void 0,this.PROXY_CREDENTIALS_SERVICE_KEY,b)}catch(M){this.logService.error(M)}u({username:w.username,password:w.password})}else u(void 0)};a.win?.webContents.on("ipc-message",r)});return this.sessionCredentials=o,o}};t=fe([te(0,f.ILogService),te(1,g.IWindowsMainService),te(2,y.INativeHostMainService),te(3,d.IEncryptionMainService),te(4,E.IProductService)],t),e.ProxyAuthHandler=t}),define(x[236],ee([0,1,14,26,33,2,10,3,83,148,74,51,24,5,103,6,52,55,22,56,67]),function(V,e,p,R,C,k,n,I,d,f,y,E,g,S,t,m,v,b,P,c,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IssueMainService=e.IIssueMainService=void 0,e.IIssueMainService=(0,S.createDecorator)("issueMainService");let l=class Pt{constructor(u,r,i,s,h,w,M,A,L){this.userEnv=u,this.environmentMainService=r,this.launchMainService=i,this.logService=s,this.diagnosticsService=h,this.dialogMainService=w,this.nativeHostMainService=M,this.protocolMainService=A,this.productService=L,this.issueReporterWindow=null,this.issueReporterParentWindow=null,this.processExplorerWindow=null,this.processExplorerParentWindow=null,this.registerListeners()}registerListeners(){p.ipcMain.on("vscode:issueSystemInfoRequest",async u=>{const[r,i]=await Promise.all([this.launchMainService.getMainProcessInfo(),this.launchMainService.getRemoteDiagnostics({includeProcesses:!1,includeWorkspaceMetadata:!1})]),s=await this.diagnosticsService.getSystemInfo(r,i);this.safeSend(u,"vscode:issueSystemInfoResponse",s)}),p.ipcMain.on("vscode:listProcesses",async u=>{const r=[];try{const i=await this.launchMainService.getMainProcessId();r.push({name:(0,f.localize)(0,null),rootProcess:await(0,d.listProcesses)(i)}),(await this.launchMainService.getRemoteDiagnostics({includeProcesses:!0})).forEach(h=>{(0,y.isRemoteDiagnosticError)(h)?r.push({name:h.hostName,rootProcess:h}):h.processes&&r.push({name:h.hostName,rootProcess:h.processes})})}catch(i){this.logService.error(`Listing processes failed: ${i}`)}this.safeSend(u,"vscode:listProcessesResponse",r)}),p.ipcMain.on("vscode:issueReporterClipboard",async u=>{const r={title:this.productService.nameLong,message:(0,f.localize)(1,null),type:"warning",buttons:[(0,C.mnemonicButtonLabel)((0,f.localize)(2,null)),(0,C.mnemonicButtonLabel)((0,f.localize)(3,null))],defaultId:0,cancelId:1,noLink:!0};if(this.issueReporterWindow){const i=await this.dialogMainService.showMessageBox(r,this.issueReporterWindow);this.safeSend(u,"vscode:issueReporterClipboardResponse",i.response===0)}}),p.ipcMain.on("vscode:issuePerformanceInfoRequest",async u=>{const r=await this.getPerformanceInfo();this.safeSend(u,"vscode:issuePerformanceInfoResponse",r)}),p.ipcMain.on("vscode:issueReporterConfirmClose",async()=>{const u={title:this.productService.nameLong,message:(0,f.localize)(4,null),type:"warning",buttons:[(0,C.mnemonicButtonLabel)((0,f.localize)(5,null)),(0,C.mnemonicButtonLabel)((0,f.localize)(6,null))],defaultId:0,cancelId:1,noLink:!0};this.issueReporterWindow&&(await this.dialogMainService.showMessageBox(u,this.issueReporterWindow)).response===0&&this.issueReporterWindow&&(this.issueReporterWindow.destroy(),this.issueReporterWindow=null)}),p.ipcMain.on("vscode:workbenchCommand",(u,r)=>{const{id:i,from:s,args:h}=r;let w;switch(s){case"issueReporter":w=this.issueReporterParentWindow;break;case"processExplorer":w=this.processExplorerParentWindow;break;default:throw new Error(`Unexpected command source: ${s}`)}w&&w.webContents.send("vscode:runAction",{id:i,from:s,args:h})}),p.ipcMain.on("vscode:openExternal",(u,r)=>{this.nativeHostMainService.openExternal(void 0,r)}),p.ipcMain.on("vscode:closeIssueReporter",u=>{this.issueReporterWindow&&this.issueReporterWindow.close()}),p.ipcMain.on("vscode:closeProcessExplorer",u=>{this.processExplorerWindow&&this.processExplorerWindow.close()}),p.ipcMain.on("vscode:windowsInfoRequest",async u=>{const r=await this.launchMainService.getMainProcessInfo();this.safeSend(u,"vscode:windowsInfoResponse",r.windows)})}safeSend(u,r,...i){u.sender.isDestroyed()||u.sender.send(r,...i)}async openReporter(u){if(!this.issueReporterWindow&&(this.issueReporterParentWindow=p.BrowserWindow.getFocusedWindow(),this.issueReporterParentWindow)){const r=new k.DisposableStore,i=r.add(this.protocolMainService.createIPCObjectUrl()),s=this.getWindowPosition(this.issueReporterParentWindow,700,800);this.issueReporterWindow=this.createBrowserWindow(s,i,{backgroundColor:u.styles.backgroundColor,title:(0,f.localize)(7,null),zoomLevel:u.zoomLevel,alwaysOnTop:!1},"issue-reporter"),i.update({appRoot:this.environmentMainService.appRoot,windowId:this.issueReporterWindow.id,userEnv:this.userEnv,data:u,disableExtensions:!!this.environmentMainService.disableExtensions,os:{type:(0,R.type)(),arch:(0,R.arch)(),release:(0,R.release)()},product:b.default}),this.issueReporterWindow.loadURL(n.FileAccess.asBrowserUri("vs/code/electron-sandbox/issue/issueReporter.html",V).toString(!0)),this.issueReporterWindow.on("close",()=>{this.issueReporterWindow=null,r.dispose()}),this.issueReporterParentWindow.on("closed",()=>{this.issueReporterWindow&&(this.issueReporterWindow.close(),this.issueReporterWindow=null,r.dispose())})}this.issueReporterWindow&&this.focusWindow(this.issueReporterWindow)}async openProcessExplorer(u){if(!this.processExplorerWindow&&(this.processExplorerParentWindow=p.BrowserWindow.getFocusedWindow(),this.processExplorerParentWindow)){const r=new k.DisposableStore,i=r.add(this.protocolMainService.createIPCObjectUrl()),s=this.getWindowPosition(this.processExplorerParentWindow,800,500);this.processExplorerWindow=this.createBrowserWindow(s,i,{backgroundColor:u.styles.backgroundColor,title:(0,f.localize)(8,null),zoomLevel:u.zoomLevel,alwaysOnTop:!0},"process-explorer"),i.update({appRoot:this.environmentMainService.appRoot,windowId:this.processExplorerWindow.id,userEnv:this.userEnv,data:u,product:b.default}),this.processExplorerWindow.loadURL(n.FileAccess.asBrowserUri("vs/code/electron-sandbox/processExplorer/processExplorer.html",V).toString(!0)),this.processExplorerWindow.on("close",()=>{this.processExplorerWindow=null,r.dispose()}),this.processExplorerParentWindow.on("close",()=>{this.processExplorerWindow&&(this.processExplorerWindow.close(),this.processExplorerWindow=null,r.dispose())})}this.processExplorerWindow&&this.focusWindow(this.processExplorerWindow)}focusWindow(u){u.isMinimized()&&u.restore(),u.focus()}createBrowserWindow(u,r,i,s){const h=new p.BrowserWindow({fullscreen:!1,skipTaskbar:!0,resizable:!0,width:u.width,height:u.height,minWidth:300,minHeight:200,x:u.x,y:u.y,title:i.title,backgroundColor:i.backgroundColor||Pt.DEFAULT_BACKGROUND_COLOR,webPreferences:{preload:n.FileAccess.asFileUri("vs/base/parts/sandbox/electron-browser/preload.js",V).fsPath,additionalArguments:[`--vscode-window-config=${r.resource.toString()}`,`--vscode-window-kind=${s}`],v8CacheOptions:this.environmentMainService.useCodeCache?"bypassHeatCheck":"none",enableWebSQL:!1,spellcheck:!1,nativeWindowOpen:!0,zoomFactor:(0,a.zoomLevelToZoomFactor)(i.zoomLevel),sandbox:!0,contextIsolation:!0},alwaysOnTop:i.alwaysOnTop});return h.setMenuBarVisibility(!1),h}async getSystemStatus(){const[u,r]=await Promise.all([this.launchMainService.getMainProcessInfo(),this.launchMainService.getRemoteDiagnostics({includeProcesses:!1,includeWorkspaceMetadata:!1})]);return this.diagnosticsService.getDiagnostics(u,r)}getWindowPosition(u,r,i){let s;const h=p.screen.getAllDisplays();if(h.length===1)s=h[0];else{if(I.isMacintosh){const A=p.screen.getCursorScreenPoint();s=p.screen.getDisplayNearestPoint(A)}!s&&u&&(s=p.screen.getDisplayMatching(u.getBounds())),s||(s=p.screen.getPrimaryDisplay()||h[0])}const w={width:r,height:i},M=s.bounds;return w.x=M.x+M.width/2-w.width/2,w.y=M.y+M.height/2-w.height/2,M.width>0&&M.height>0&&(w.x<M.x&&(w.x=M.x),w.y<M.y&&(w.y=M.y),w.x>M.x+M.width&&(w.x=M.x),w.y>M.y+M.height&&(w.y=M.y),w.width>M.width&&(w.width=M.width),w.height>M.height&&(w.height=M.height)),w}async getPerformanceInfo(){try{const[u,r]=await Promise.all([this.launchMainService.getMainProcessInfo(),this.launchMainService.getRemoteDiagnostics({includeProcesses:!0,includeWorkspaceMetadata:!0})]);return await this.diagnosticsService.getPerformanceInfo(u,r)}catch(u){throw this.logService.warn("issueService#getPerformanceInfo ",u.message),u}}};l.DEFAULT_BACKGROUND_COLOR="#1E1E1E",l=fe([te(1,g.IEnvironmentMainService),te(2,t.ILaunchMainService),te(3,m.ILogService),te(4,y.IDiagnosticsService),te(5,E.IDialogMainService),te(6,v.INativeHostMainService),te(7,c.IProtocolMainService),te(8,P.IProductService)],l),e.IssueMainService=l}),define(x[237],ee([0,1,23,18,24,20,6,52,22,49,29,41,77]),function(V,e,p,R,C,k,n,I,d,f,y,E,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LinuxUpdateService=void 0;let S=class extends g.AbstractUpdateService{constructor(m,v,b,P,c,a,l,o){super(m,v,P,c,a,o);this.telemetryService=b,this.nativeHostMainService=l}buildUpdateFeedUrl(m){return(0,g.createUpdateURL)(`linux-${process.arch}`,m,this.productService)}doCheckForUpdates(m){!this.url||(this.setState(E.State.CheckingForUpdates(m)),this.requestService.request({url:this.url},p.CancellationToken.None).then(f.asJson).then(v=>{!v||!v.url||!v.version||!v.productVersion?(this.telemetryService.publicLog2("update:notAvailable",{explicit:!!m}),this.setState(E.State.Idle(1))):this.setState(E.State.AvailableForDownload(v))}).then(void 0,v=>{this.logService.error(v),this.telemetryService.publicLog2("update:notAvailable",{explicit:!!m});const b=m?v.message||v:void 0;this.setState(E.State.Idle(1,b))}))}async doDownloadUpdate(m){this.productService.downloadUrl&&this.productService.downloadUrl.length>0?this.nativeHostMainService.openExternal(void 0,this.productService.downloadUrl):m.update.url&&this.nativeHostMainService.openExternal(void 0,m.update.url),this.setState(E.State.Idle(1))}};S=fe([te(0,k.ILifecycleMainService),te(1,R.IConfigurationService),te(2,y.ITelemetryService),te(3,C.IEnvironmentMainService),te(4,f.IRequestService),te(5,n.ILogService),te(6,I.INativeHostMainService),te(7,d.IProductService)],S),e.LinuxUpdateService=S}),define(x[238],ee([0,1,43,28,26,9,23,46,8,7,114,21,18,24,19,20,6,52,22,49,29,41,77]),function(V,e,p,R,C,k,n,I,d,f,y,E,g,S,t,m,v,b,P,c,a,l,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Win32UpdateService=void 0;async function u(h,w=1e3){for(;!h();)await(0,k.timeout)(w)}let r;function i(){return typeof r=="undefined"&&(r=R.existsSync(d.join(d.dirname(process.execPath),"unins000.exe"))?0:1),r}let s=class extends o.AbstractUpdateService{constructor(w,M,A,L,F,U,Y,ie,re){super(w,M,L,F,U,re);this.telemetryService=A,this.fileService=Y,this.nativeHostMainService=ie}get cachePath(){const w=d.join((0,C.tmpdir)(),`vscode-update-${this.productService.target}-${process.arch}`);return E.Promises.mkdir(w,{recursive:!0}).then(()=>w)}initialize(){super.initialize(),i()===0&&this.telemetryService.publicLog("update:win32SetupTarget",{target:this.productService.target})}buildUpdateFeedUrl(w){let M="win32";return process.arch!=="ia32"&&(M+=`-${process.arch}`),i()===1?M+="-archive":this.productService.target==="user"&&(M+="-user"),(0,o.createUpdateURL)(M,w,this.productService)}doCheckForUpdates(w){!this.url||(this.setState(l.State.CheckingForUpdates(w)),this.requestService.request({url:this.url},n.CancellationToken.None).then(c.asJson).then(M=>{const A=i();return!M||!M.url||!M.version||!M.productVersion?(this.telemetryService.publicLog2("update:notAvailable",{explicit:!!w}),this.setState(l.State.Idle(A)),Promise.resolve(null)):A===1?(this.setState(l.State.AvailableForDownload(M)),Promise.resolve(null)):(this.setState(l.State.Downloading(M)),this.cleanup(M.version).then(()=>this.getUpdatePackagePath(M.version).then(L=>E.Promises.exists(L).then(F=>{if(F)return Promise.resolve(L);const U=M.url,Y=M.hash,ie=`${L}.tmp`;return this.requestService.request({url:U},n.CancellationToken.None).then(re=>this.fileService.writeFile(f.URI.file(ie),re.stream)).then(Y?()=>(0,y.checksum)(ie,M.hash):()=>{}).then(()=>E.Promises.rename(ie,L)).then(()=>L)})).then(L=>{const F=this.configurationService.getValue("update.enableWindowsBackgroundUpdates");this.availableUpdate={packagePath:L},F&&M.supportsFastUpdate?this.productService.target==="user"?this.doApplyUpdate():this.setState(l.State.Downloaded(M)):this.setState(l.State.Ready(M))})))}).then(void 0,M=>{this.logService.error(M),this.telemetryService.publicLog2("update:notAvailable",{explicit:!!w});const A=w?M.message||M:void 0;this.setState(l.State.Idle(i(),A))}))}async doDownloadUpdate(w){w.update.url&&this.nativeHostMainService.openExternal(void 0,w.update.url),this.setState(l.State.Idle(i()))}async getUpdatePackagePath(w){const M=await this.cachePath;return d.join(M,`CodeSetup-${this.productService.quality}-${w}.exe`)}async cleanup(w=null){const M=w?U=>!new RegExp(`${this.productService.quality}-${w}\\.exe$`).test(U):()=>!0,A=await this.cachePath,F=(await E.Promises.readdir(A)).filter(M).map(async U=>{try{await E.Promises.unlink(d.join(A,U))}catch(Y){}});await Promise.all(F)}async doApplyUpdate(){if(this.state.type!=="downloaded"&&this.state.type!=="downloading"||!this.availableUpdate)return Promise.resolve(void 0);const w=this.state.update;this.setState(l.State.Updating(w));const M=await this.cachePath;this.availableUpdate.updateFilePath=d.join(M,`CodeSetup-${this.productService.quality}-${w.version}.flag`),await E.Promises.writeFile(this.availableUpdate.updateFilePath,"flag"),(0,p.spawn)(this.availableUpdate.packagePath,["/verysilent",`/update="${this.availableUpdate.updateFilePath}"`,"/nocloseapplications","/mergetasks=runcode,!desktopicon,!quicklaunchicon"],{detached:!0,stdio:["ignore","ignore","ignore"],windowsVerbatimArguments:!0}).once("exit",()=>{this.availableUpdate=void 0,this.setState(l.State.Idle(i()))});const L=`${this.productService.win32MutexName}-ready`,F=await new Promise((U,Y)=>{V(["windows-mutex"],U,Y)});u(()=>F.isActive(L)).then(()=>this.setState(l.State.Ready(w)))}doQuitAndInstall(){this.state.type!=="ready"||!this.availableUpdate||(this.logService.trace("update#quitAndInstall(): running raw#quitAndInstall()"),this.state.update.supportsFastUpdate&&this.availableUpdate.updateFilePath?R.unlinkSync(this.availableUpdate.updateFilePath):(0,p.spawn)(this.availableUpdate.packagePath,["/silent","/mergetasks=runcode,!desktopicon,!quicklaunchicon"],{detached:!0,stdio:["ignore","ignore","ignore"]}))}getUpdateType(){return i()}};fe([I.memoize],s.prototype,"cachePath",null),s=fe([te(0,m.ILifecycleMainService),te(1,g.IConfigurationService),te(2,a.ITelemetryService),te(3,S.IEnvironmentMainService),te(4,c.IRequestService),te(5,v.ILogService),te(6,t.IFileService),te(7,b.INativeHostMainService),te(8,P.IProductService)],s),e.Win32UpdateService=s}),define(x[239],ee([0,1,14,9,23,44,4,33,2,10,8,63,3,7,154,50,18,51,24,53,205,19,20,6,22,56,100,29,208,66,67,36,27,45]),function(V,e,p,R,C,k,n,I,d,f,y,E,g,S,t,m,v,b,P,c,a,l,o,u,r,i,s,h,w,M,A,L,F,U){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CodeWindow=void 0;var Y;(function(re){re[re.NONE=0]="NONE",re[re.LOADING=1]="LOADING",re[re.NAVIGATING=2]="NAVIGATING",re[re.READY=3]="READY"})(Y||(Y={}));let ie=class extends d.Disposable{constructor(K,W,N,G,Q,H,$,J,O,D,T,_,z,X,B){super();this.logService=W,this.environmentMainService=N,this.fileService=G,this.configurationService=H,this.themeMainService=$,this.workspacesManagementMainService=J,this.backupMainService=O,this.telemetryService=D,this.dialogMainService=T,this.lifecycleMainService=_,this.productService=z,this.protocolMainService=X,this.windowsMainService=B,this._onWillLoad=this._register(new n.Emitter),this.onWillLoad=this._onWillLoad.event,this._onDidSignalReady=this._register(new n.Emitter),this.onDidSignalReady=this._onDidSignalReady.event,this._onDidClose=this._register(new n.Emitter),this.onDidClose=this._onDidClose.event,this._onDidDestroy=this._register(new n.Emitter),this.onDidDestroy=this._onDidDestroy.event,this._lastFocusTime=-1,this.whenReadyCallbacks=[],this.touchBarGroups=[],this.currentHttpProxy=void 0,this.currentNoProxy=void 0,this.configObjectUrl=this._register(this.protocolMainService.createIPCObjectUrl()),this.wasLoaded=!1,this.readyState=0;{const[q,ne]=this.restoreWindowState(K.state);this.windowState=q,this.logService.trace("window#ctor: using window state",q);const se=this.windowState.mode===0||this.windowState.mode===3,oe=this.configurationService.getValue("window"),Z={width:this.windowState.width,height:this.windowState.height,x:this.windowState.x,y:this.windowState.y,backgroundColor:this.themeMainService.getBackgroundColor(),minWidth:A.WindowMinimumSize.WIDTH,minHeight:A.WindowMinimumSize.HEIGHT,show:!se,title:this.productService.nameLong,webPreferences:{preload:f.FileAccess.asFileUri("vs/base/parts/sandbox/electron-browser/preload.js",V).fsPath,additionalArguments:[`--vscode-window-config=${this.configObjectUrl.resource.toString()}`],v8CacheOptions:this.environmentMainService.useCodeCache?"bypassHeatCheck":"none",enableWebSQL:!1,spellcheck:!1,nativeWindowOpen:!0,zoomFactor:(0,A.zoomLevelToZoomFactor)(oe?.zoomLevel),...this.environmentMainService.sandbox?{sandbox:!0}:{nodeIntegration:!0,contextIsolation:!1}}};g.isLinux?Z.icon=(0,y.join)(this.environmentMainService.appRoot,"resources/linux/code.png"):g.isWindows&&!this.environmentMainService.isBuilt&&(Z.icon=(0,y.join)(this.environmentMainService.appRoot,"resources/win32/code_150x150.png")),g.isMacintosh&&!this.useNativeFullScreen()&&(Z.fullscreenable=!1),g.isMacintosh&&(Z.acceptFirstMouse=!0,oe?.clickThroughInactive===!1&&(Z.acceptFirstMouse=!1));const ce=g.isMacintosh&&oe?.nativeTabs===!0;ce&&(Z.tabbingIdentifier=this.productService.nameShort);const le=(0,A.getTitleBarStyle)(this.configurationService)==="custom";if(le&&(Z.titleBarStyle="hidden",this.hiddenTitleBarStyle=!0,g.isMacintosh||(Z.frame=!1)),(0,E.mark)("code/willCreateCodeBrowserWindow"),this._win=new p.BrowserWindow(Z),(0,E.mark)("code/didCreateCodeBrowserWindow"),this._id=this._win.id,this.environmentMainService.args["open-devtools"]===!0&&this._win.webContents.openDevTools(),g.isMacintosh&&le&&this._win.setSheetOffset(22),g.isMacintosh&&ne&&(!ce||p.BrowserWindow.getAllWindows().length===1)&&[this.windowState.width,this.windowState.height,this.windowState.x,this.windowState.y].every(ue=>typeof ue=="number")){const ue=this.windowState;this._win.setBounds({width:ue.width,height:ue.height,x:ue.x,y:ue.y})}se&&((0,E.mark)("code/willMaximizeCodeWindow"),this._win.maximize(),this.windowState.mode===3&&this.setFullScreen(!0),this._win.isVisible()||this._win.show(),(0,E.mark)("code/didMaximizeCodeWindow")),this._lastFocusTime=Date.now()}this.onConfigurationUpdated(),this.createTouchBar(),this.marketplaceHeadersPromise=(0,a.resolveMarketplaceHeaders)(this.productService.version,this.productService,this.environmentMainService,this.configurationService,this.fileService,{get:q=>Q.globalStorage.get(q),store:(q,ne)=>Q.globalStorage.set(q,ne)}),this.registerListeners()}get id(){return this._id}get win(){return this._win}get lastFocusTime(){return this._lastFocusTime}get backupPath(){return this.currentConfig?.backupPath}get openedWorkspace(){return this.currentConfig?.workspace}get remoteAuthority(){return this.currentConfig?.remoteAuthority}get config(){return this.currentConfig}get hasHiddenTitleBarStyle(){return!!this.hiddenTitleBarStyle}get isExtensionDevelopmentHost(){return!!this.currentConfig?.extensionDevelopmentPath}get isExtensionTestHost(){return!!this.currentConfig?.extensionTestsPath}get isExtensionDevelopmentTestFromCli(){return this.isExtensionDevelopmentHost&&this.isExtensionTestHost&&!this.currentConfig?.debugId}setRepresentedFilename(K){g.isMacintosh?this._win.setRepresentedFilename(K):this.representedFilename=K}getRepresentedFilename(){return g.isMacintosh?this._win.getRepresentedFilename():this.representedFilename}setDocumentEdited(K){g.isMacintosh&&this._win.setDocumentEdited(K),this.documentEdited=K}isDocumentEdited(){return g.isMacintosh?this._win.isDocumentEdited():!!this.documentEdited}focus(K){g.isMacintosh&&K?.force&&p.app.focus({steal:!0}),!!this._win&&(this._win.isMinimized()&&this._win.restore(),this._win.focus())}setReady(){for(this.readyState=3;this.whenReadyCallbacks.length;)this.whenReadyCallbacks.pop()(this);this._onDidSignalReady.fire()}ready(){return new Promise(K=>{if(this.isReady)return K(this);this.whenReadyCallbacks.push(K)})}get isReady(){return this.readyState===3}get whenClosedOrLoaded(){return new Promise(K=>{function W(){N.dispose(),G.dispose(),K()}const N=this.onDidClose(()=>W()),G=this.onWillLoad(()=>W())})}registerListeners(){this._win.on("unresponsive",()=>this.onWindowError(1)),this._win.webContents.on("render-process-gone",(Q,H)=>this.onWindowError(2,H)),this._win.webContents.on("did-fail-load",(Q,H,$)=>this.onWindowError(3,{reason:$,exitCode:H})),this._win.webContents.on("will-prevent-unload",Q=>{Q.preventDefault()}),this._win.on("closed",()=>{this._onDidClose.fire(),this.dispose()});const K=new Set([f.Schemas.file,f.Schemas.vscodeFileResource,f.Schemas.vscodeRemoteResource,"devtools"]),W=Q=>{for(let H=Q;H;H=H.parent)if(H.url.startsWith(`${f.Schemas.vscodeWebview}://`))return!0;return!1},N=Q=>Q.resourceType==="xhr"||W(Q.frame);this._win.webContents.session.webRequest.onBeforeRequest((Q,H)=>{const $=S.URI.parse(Q.url);return $.path.endsWith(".svg")&&!K.has($.scheme)?H({cancel:!N(Q)}):H({cancel:!1})}),this._win.webContents.session.webRequest.onHeadersReceived((Q,H)=>{const $=Q.responseHeaders,J=$["content-type"]||$["Content-Type"];if(J&&Array.isArray(J)){const O=S.URI.parse(Q.url);if(O.path.endsWith(".svg")&&K.has(O.scheme))return $["Content-Type"]=["image/svg+xml"],H({cancel:!1,responseHeaders:$});if(!O.path.includes(f.Schemas.vscodeRemoteResource)&&J.some(D=>D.toLowerCase().includes("image/svg")))return H({cancel:!N(Q)})}return H({cancel:!1})}),this._win.webContents.on("did-finish-load",()=>{this.readyState=1,this.pendingLoadConfig&&(this.currentConfig=this.pendingLoadConfig,this.pendingLoadConfig=void 0)}),this._win.on("focus",()=>{this._lastFocusTime=Date.now()}),this._win.on("maximize",Q=>{this.currentConfig&&(this.currentConfig.maximized=!0),p.app.emit("browser-window-maximize",Q,this._win)}),this._win.on("unmaximize",Q=>{this.currentConfig&&(this.currentConfig.maximized=!1),p.app.emit("browser-window-unmaximize",Q,this._win)}),this._win.on("enter-full-screen",()=>{this.sendWhenReady("vscode:enterFullScreen",C.CancellationToken.None)}),this._win.on("leave-full-screen",()=>{this.sendWhenReady("vscode:leaveFullScreen",C.CancellationToken.None)}),this._register(this.configurationService.onDidChangeConfiguration(()=>this.onConfigurationUpdated())),this._register(this.workspacesManagementMainService.onDidDeleteUntitledWorkspace(Q=>this.onDidDeleteUntitledWorkspace(Q)));const G=["https://marketplace.visualstudio.com/*","https://*.vsassets.io/*"];this._win.webContents.session.webRequest.onBeforeSendHeaders({urls:G},async(Q,H)=>{const $=await this.marketplaceHeadersPromise;H({cancel:!1,requestHeaders:Object.assign(Q.requestHeaders,$)})})}async onWindowError(K,W){switch(K){case 2:this.logService.error(`CodeWindow: renderer process crashed (reason: ${W?.reason||"<unknown>"}, code: ${W?.exitCode||"<unknown>"})`);break;case 1:this.logService.error("CodeWindow: detected unresponsive");break;case 3:this.logService.error(`CodeWindow: failed to load (reason: ${W?.reason||"<unknown>"}, code: ${W?.exitCode||"<unknown>"})`);break}switch(this.telemetryService.publicLog2("windowerror",{type:K,reason:W?.reason,code:W?.exitCode}),K){case 1:case 2:if(this.isExtensionDevelopmentTestFromCli){this.lifecycleMainService.kill(1);return}if(K===1){if(this.isExtensionDevelopmentHost||this.isExtensionTestHost||this._win&&this._win.webContents&&this._win.webContents.isDevToolsOpened())return;const N=await this.dialogMainService.showMessageBox({title:this.productService.nameLong,type:"warning",buttons:[(0,I.mnemonicButtonLabel)((0,t.localize)(0,null)),(0,I.mnemonicButtonLabel)((0,t.localize)(1,null)),(0,I.mnemonicButtonLabel)((0,t.localize)(2,null))],message:(0,t.localize)(3,null),detail:(0,t.localize)(4,null),noLink:!0,defaultId:0,cancelId:1},this._win);if(N.response!==1){const G=N.response===0;this.destroyWindow(G)}}else if(K===2){let N;W?N=(0,t.localize)(6,null,W.reason,W.exitCode??"<unknown>"):N=(0,t.localize)(5,null);const Q=(await this.dialogMainService.showMessageBox({title:this.productService.nameLong,type:"warning",buttons:[(0,I.mnemonicButtonLabel)((0,t.localize)(7,null)),(0,I.mnemonicButtonLabel)((0,t.localize)(8,null))],message:N,detail:(0,t.localize)(9,null),noLink:!0,defaultId:0},this._win)).response===0;this.destroyWindow(Q)}break}}destroyWindow(K){if(this._onDidDestroy.fire(),this._win?.destroy(),K&&this.config){let W,N;(0,F.isSingleFolderWorkspaceIdentifier)(this.openedWorkspace)?W={folderUri:this.openedWorkspace.uri}:(0,F.isWorkspaceIdentifier)(this.openedWorkspace)?W={workspaceUri:this.openedWorkspace.configPath}:N=!0;const[G]=this.windowsMainService.open({context:5,userEnv:this.config.userEnv,cli:{...this.environmentMainService.args,_:[]},urisToOpen:W?[W]:void 0,forceEmpty:N,forceNewWindow:!0});G.focus()}}onDidDeleteUntitledWorkspace(K){this.openedWorkspace?.id===K.id&&this.currentConfig&&(this.currentConfig.workspace=void 0)}onConfigurationUpdated(){const K=this.getMenuBarVisibility();K!==this.currentMenuBarVisibility&&(this.currentMenuBarVisibility=K,this.setMenuBarVisibility(K));let W=(this.configurationService.getValue("http.proxy")||"").trim()||(process.env.https_proxy||process.env.HTTPS_PROXY||process.env.http_proxy||process.env.HTTP_PROXY||"").trim()||void 0;W?.endsWith("/")&&(W=W.substr(0,W.length-1));const N=(process.env.no_proxy||process.env.NO_PROXY||"").trim()||void 0;if((W||"").indexOf("@")===-1&&(W!==this.currentHttpProxy||N!==this.currentNoProxy)){this.currentHttpProxy=W,this.currentNoProxy=N;const G=W||"",Q=N?`${N},<local>`:"<local>";this.logService.trace(`Setting proxy to '${G}', bypassing '${Q}'`),this._win.webContents.session.setProxy({proxyRules:G,proxyBypassRules:Q,pacScript:""})}}addTabbedWindow(K){g.isMacintosh&&K.win&&this._win.addTabbedWindow(K.win)}load(K,W=Object.create(null)){this.isDocumentEdited()&&(!W.isReload||!this.backupMainService.isHotExitEnabled())&&this.setDocumentEdited(!1),W.isReload||(this.getRepresentedFilename()&&this.setRepresentedFilename(""),this._win.setTitle(this.productService.nameLong)),this.updateConfiguration(K,W),this.readyState===0?this.currentConfig=K:(this.pendingLoadConfig=K,this.readyState=2),this._win.loadURL(f.FileAccess.asBrowserUri(this.environmentMainService.sandbox?"vs/code/electron-sandbox/workbench/workbench.html":"vs/code/electron-browser/workbench/workbench.html",V).toString(!0));const N=this.wasLoaded;this.wasLoaded=!0,!this.environmentMainService.isBuilt&&!this.environmentMainService.extensionTestsLocationURI&&this._register(new R.RunOnceScheduler(()=>{this._win&&!this._win.isVisible()&&!this._win.isMinimized()&&(this._win.show(),this.focus({force:!0}),this._win.webContents.openDevTools())},1e4)).schedule(),this._onWillLoad.fire({workspace:K.workspace,reason:W.isReload?3:N?2:1})}updateConfiguration(K,W){const N=(this.currentConfig??this.pendingLoadConfig)?.userEnv;if(N){const G=(0,c.isLaunchedFromCli)(N)&&!(0,c.isLaunchedFromCli)(K.userEnv),Q=this.isExtensionDevelopmentHost;(G||Q)&&(K.userEnv={...N,...K.userEnv})}process.env.CHROME_CRASHPAD_PIPE_NAME&&Object.assign(K.userEnv,{CHROME_CRASHPAD_PIPE_NAME:process.env.CHROME_CRASHPAD_PIPE_NAME}),W.disableExtensions!==void 0&&(K["disable-extensions"]=W.disableExtensions),K.fullscreen=this.isFullScreen,K.maximized=this._win.isMaximized(),K.partsSplash=this.themeMainService.getWindowSplash(),(0,E.mark)("code/willOpenNewWindow"),K.perfMarks=(0,E.getMarks)(),this.configObjectUrl.update(K)}async reload(K){const W=Object.assign({},this.currentConfig);W.workspace=await this.validateWorkspaceBeforeReload(W),delete W.filesToOpenOrCreate,delete W.filesToDiff,delete W.filesToWait,this.isExtensionDevelopmentHost&&K&&(W.verbose=K.verbose,W.debugId=K.debugId,W.extensionEnvironment=K.extensionEnvironment,W["inspect-extensions"]=K["inspect-extensions"],W["inspect-brk-extensions"]=K["inspect-brk-extensions"],W["extensions-dir"]=K["extensions-dir"]),W.isInitialStartup=!1,this.load(W,{isReload:!0,disableExtensions:K?.["disable-extensions"]})}async validateWorkspaceBeforeReload(K){if((0,F.isWorkspaceIdentifier)(K.workspace)){const W=K.workspace.configPath;if(W.scheme===f.Schemas.file&&!await this.fileService.exists(W))return}else if((0,F.isSingleFolderWorkspaceIdentifier)(K.workspace)){const W=K.workspace.uri;if(W.scheme===f.Schemas.file&&!await this.fileService.exists(W))return}return K.workspace}serializeWindowState(){if(!this._win)return(0,L.defaultWindowState)();if(this.isFullScreen){let N;try{N=p.screen.getDisplayMatching(this.getBounds())}catch(H){}const G=(0,L.defaultWindowState)();return{mode:3,display:N?N.id:void 0,width:this.windowState.width||G.width,height:this.windowState.height||G.height,x:this.windowState.x||0,y:this.windowState.y||0}}const K=Object.create(null);let W;if(!g.isMacintosh&&this._win.isMaximized()?W=0:W=1,W===0?K.mode=0:K.mode=1,W===1||W===0){let N;W===1?N=this.getBounds():N=this._win.getNormalBounds(),K.x=N.x,K.y=N.y,K.width=N.width,K.height=N.height}return K}restoreWindowState(K){(0,E.mark)("code/willRestoreCodeWindowState");let W=!1;if(K)try{const N=p.screen.getAllDisplays();W=N.length>1,K=this.validateWindowState(K,N)}catch(N){this.logService.warn(`Unexpected error validating window state: ${N}
${N.stack}`)}return(0,E.mark)("code/didRestoreCodeWindowState"),[K||(0,L.defaultWindowState)(),W]}validateWindowState(K,W){if(this.logService.trace(`window#validateWindowState: validating window state on ${W.length} display(s)`,K),typeof K.x!="number"||typeof K.y!="number"||typeof K.width!="number"||typeof K.height!="number"){this.logService.trace("window#validateWindowState: unexpected type of state values");return}if(K.width<=0||K.height<=0){this.logService.trace("window#validateWindowState: unexpected negative values");return}if(W.length===1){const Q=this.getWorkingArea(W[0]);if(Q){let H=function(){!K||typeof K.x!="number"||typeof K.y!="number"||!Q||(K.x<Q.x&&(K.x=Q.x),K.y<Q.y&&(K.y=Q.y))};this.logService.trace("window#validateWindowState: 1 monitor working area",Q),H(),K.width>Q.width&&(K.width=Q.width),K.height>Q.height&&(K.height=Q.height),K.x>Q.x+Q.width-128&&(K.x=Q.x+Q.width-K.width),K.y>Q.y+Q.height-128&&(K.y=Q.y+Q.height-K.height),H()}return K}if(K.display&&K.mode===3){const Q=W.find(H=>H.id===K.display);if(Q&&typeof Q.bounds?.x=="number"&&typeof Q.bounds?.y=="number"){this.logService.trace("window#validateWindowState: restoring fullscreen to previous display");const H=(0,L.defaultWindowState)(3);return H.x=Q.bounds.x,H.y=Q.bounds.y,H}}let N,G;try{N=p.screen.getDisplayMatching({x:K.x,y:K.y,width:K.width,height:K.height}),G=this.getWorkingArea(N)}catch(Q){}if(N&&G&&K.x+K.width>G.x&&K.y+K.height>G.y&&K.x<G.x+G.width&&K.y<G.y+G.height)return this.logService.trace("window#validateWindowState: multi-monitor working area",G),K}getWorkingArea(K){if(K.workArea.width>0&&K.workArea.height>0)return K.workArea;if(K.bounds.width>0&&K.bounds.height>0)return K.bounds}getBounds(){const[K,W]=this._win.getPosition(),[N,G]=this._win.getSize();return{x:K,y:W,width:N,height:G}}toggleFullScreen(){this.setFullScreen(!this.isFullScreen)}setFullScreen(K){this.useNativeFullScreen()?this.setNativeFullScreen(K):this.setSimpleFullScreen(K),this.sendWhenReady(K?"vscode:enterFullScreen":"vscode:leaveFullScreen",C.CancellationToken.None),this.currentMenuBarVisibility&&this.setMenuBarVisibility(this.currentMenuBarVisibility,!1)}get isFullScreen(){return this._win.isFullScreen()||this._win.isSimpleFullScreen()}setNativeFullScreen(K){this._win.isSimpleFullScreen()&&this._win.setSimpleFullScreen(!1),this._win.setFullScreen(K)}setSimpleFullScreen(K){this._win.isFullScreen()&&this._win.setFullScreen(!1),this._win.setSimpleFullScreen(K),this._win.webContents.focus()}useNativeFullScreen(){const K=this.configurationService.getValue("window");return!K||typeof K.nativeFullScreen!="boolean"||K.nativeTabs?!0:K.nativeFullScreen!==!1}isMinimized(){return this._win.isMinimized()}getMenuBarVisibility(){let K=(0,A.getMenuBarVisibility)(this.configurationService);return["visible","toggle","hidden"].indexOf(K)<0&&(K="classic"),K}setMenuBarVisibility(K,W=!0){g.isMacintosh||(K==="toggle"&&W&&this.send("vscode:showInfoMessage",(0,t.localize)(10,null)),K==="hidden"?setTimeout(()=>{this.doSetMenuBarVisibility(K)}):this.doSetMenuBarVisibility(K))}doSetMenuBarVisibility(K){const W=this.isFullScreen;switch(K){case"classic":this._win.setMenuBarVisibility(!W),this._win.autoHideMenuBar=W;break;case"visible":this._win.setMenuBarVisibility(!0),this._win.autoHideMenuBar=!1;break;case"toggle":this._win.setMenuBarVisibility(!1),this._win.autoHideMenuBar=!0;break;case"hidden":this._win.setMenuBarVisibility(!1),this._win.autoHideMenuBar=!1;break}}handleTitleDoubleClick(){if(g.isMacintosh)switch(p.systemPreferences.getUserDefault("AppleActionOnDoubleClick","string")){case"Minimize":this._win.minimize();break;case"None":break;case"Maximize":default:this._win.isMaximized()?this._win.unmaximize():this._win.maximize()}else this._win.isMaximized()?this._win.unmaximize():this._win.maximize()}close(){this._win&&this._win.close()}sendWhenReady(K,W,...N){this.isReady?this.send(K,...N):this.ready().then(()=>{W.isCancellationRequested||this.send(K,...N)})}send(K,...W){if(this._win){if(this._win.isDestroyed()||this._win.webContents.isDestroyed()){this.logService.warn(`Sending IPC message to channel '${K}' for window that is destroyed`);return}try{this._win.webContents.send(K,...W)}catch(N){this.logService.warn(`Error sending IPC message to channel '${K}' of window ${this._id}: ${(0,k.toErrorMessage)(N)}`)}}}updateTouchBar(K){!g.isMacintosh||this.touchBarGroups.forEach((W,N)=>{const G=K[N];W.segments=this.createTouchBarGroupSegments(G)})}createTouchBar(){if(!!g.isMacintosh){for(let K=0;K<10;K++){const W=this.createTouchBarGroup();this.touchBarGroups.push(W)}this._win.setTouchBar(new p.TouchBar({items:this.touchBarGroups}))}}createTouchBarGroup(K=[]){const W=this.createTouchBarGroupSegments(K),N=new p.TouchBar.TouchBarSegmentedControl({segments:W,mode:"buttons",segmentStyle:"automatic",change:G=>{this.sendWhenReady("vscode:runAction",C.CancellationToken.None,{id:N.segments[G].id,from:"touchbar"})}});return N}createTouchBarGroupSegments(K=[]){return K.map(N=>{let G;N.icon&&!w.ThemeIcon.isThemeIcon(N.icon)&&N.icon?.dark?.scheme===f.Schemas.file&&(G=p.nativeImage.createFromPath(S.URI.revive(N.icon.dark).fsPath),G.isEmpty()&&(G=void 0));let Q;return typeof N.title=="string"?Q=N.title:Q=N.title.value,{id:N.id,label:G?void 0:Q,icon:G}})}dispose(){super.dispose(),this._win=null}};ie=fe([te(1,u.ILogService),te(2,P.IEnvironmentMainService),te(3,l.IFileService),te(4,s.IStorageMainService),te(5,v.IConfigurationService),te(6,M.IThemeMainService),te(7,U.IWorkspacesManagementMainService),te(8,m.IBackupMainService),te(9,h.ITelemetryService),te(10,b.IDialogMainService),te(11,o.ILifecycleMainService),te(12,r.IProductService),te(13,i.IProtocolMainService),te(14,L.IWindowsMainService)],ie),e.CodeWindow=ie}),define(x[68],ee([0,1,14,30,9,4,33,2,10,3,15,7,21,157,5,20,6,37,27,45]),function(V,e,p,R,C,k,n,I,d,f,y,E,g,S,t,m,v,b,P,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WorkspacesHistoryMainService=e.IWorkspacesHistoryMainService=void 0,e.IWorkspacesHistoryMainService=(0,t.createDecorator)("workspacesHistoryMainService");let a=class qe extends I.Disposable{constructor(o,u,r,i){super();this.stateMainService=o,this.logService=u,this.workspacesManagementMainService=r,this.lifecycleMainService=i,this._onDidChangeRecentlyOpened=this._register(new k.Emitter),this.onDidChangeRecentlyOpened=this._onDidChangeRecentlyOpened.event,this.macOSRecentDocumentsUpdater=this._register(new C.ThrottledDelayer(800)),this.registerListeners()}registerListeners(){this.lifecycleMainService.when(3).then(()=>this.handleWindowsJumpList()),this._register(this.workspacesManagementMainService.onDidEnterWorkspace(o=>this.addRecentlyOpened([{workspace:o.workspace}])))}handleWindowsJumpList(){!f.isWindows||(this.updateWindowsJumpList(),this._register(this.onDidChangeRecentlyOpened(()=>this.updateWindowsJumpList())))}addRecentlyOpened(o){const u=[],r=[];for(let i of o)if((0,P.isRecentWorkspace)(i))!this.workspacesManagementMainService.isUntitledWorkspace(i.workspace)&&this.indexOfWorkspace(u,i.workspace)===-1&&u.push(i);else if((0,P.isRecentFolder)(i))this.indexOfFolder(u,i.folderUri)===-1&&u.push(i);else{const s=this.indexOfFile(r,i.fileUri)>=0,h=i.fileUri.scheme===d.Schemas.file&&qe.COMMON_FILES_FILTER.indexOf((0,y.basename)(i.fileUri))>=0;!s&&!h&&(r.push(i),f.isWindows&&i.fileUri.scheme===d.Schemas.file&&p.app.addRecentDocument(i.fileUri.fsPath))}this.addEntriesFromStorage(u,r),u.length>qe.MAX_TOTAL_RECENT_ENTRIES&&(u.length=qe.MAX_TOTAL_RECENT_ENTRIES),r.length>qe.MAX_TOTAL_RECENT_ENTRIES&&(r.length=qe.MAX_TOTAL_RECENT_ENTRIES),this.saveRecentlyOpened({workspaces:u,files:r}),this._onDidChangeRecentlyOpened.fire(),f.isMacintosh&&this.macOSRecentDocumentsUpdater.trigger(()=>this.updateMacOSRecentDocuments())}removeRecentlyOpened(o){const u=h=>{const w=this.location(h);for(const M of o)if(y.extUriBiasedIgnorePathCase.isEqual(M,w))return!1;return!0},r=this.getRecentlyOpened(),i=r.workspaces.filter(u),s=r.files.filter(u);(i.length!==r.workspaces.length||s.length!==r.files.length)&&(this.saveRecentlyOpened({files:s,workspaces:i}),this._onDidChangeRecentlyOpened.fire(),f.isMacintosh&&this.macOSRecentDocumentsUpdater.trigger(()=>this.updateMacOSRecentDocuments()))}async updateMacOSRecentDocuments(){if(!f.isMacintosh)return;p.app.clearRecentDocuments();const o=this.getRecentlyOpened(),u=[];let r=0;for(let s=0;s<o.workspaces.length&&r<qe.MAX_MACOS_DOCK_RECENT_WORKSPACES;s++){const h=this.location(o.workspaces[s]);if(h.scheme===d.Schemas.file){const w=(0,y.originalFSPath)(h);await g.Promises.exists(w)&&(u.push(w),r++)}}const i=[];for(let s=0;s<o.files.length&&r<qe.MAX_MACOS_DOCK_RECENT_ENTRIES_TOTAL;s++){const h=this.location(o.files[s]);if(h.scheme===d.Schemas.file){const w=(0,y.originalFSPath)(h);if(qe.COMMON_FILES_FILTER.includes((0,y.basename)(h))||u.includes(w))continue;await g.Promises.exists(w)&&(i.push(w),r++)}}i.reverse().forEach(s=>p.app.addRecentDocument(s)),u.reverse().forEach(s=>p.app.addRecentDocument(s))}clearRecentlyOpened(){this.saveRecentlyOpened({workspaces:[],files:[]}),p.app.clearRecentDocuments(),this._onDidChangeRecentlyOpened.fire()}getRecentlyOpened(o){const u=[],r=[],i=o?.config?.workspace;(0,P.isWorkspaceIdentifier)(i)&&!this.workspacesManagementMainService.isUntitledWorkspace(i)?u.push({workspace:i}):(0,P.isSingleFolderWorkspaceIdentifier)(i)&&u.push({folderUri:i.uri});const s=o?.config?.filesToOpenOrCreate;if(s)for(let h of s){const w=h.fileUri;w&&this.indexOfFile(r,w)===-1&&r.push({fileUri:w})}return this.addEntriesFromStorage(u,r),{workspaces:u,files:r}}addEntriesFromStorage(o,u){let r=this.getRecentlyOpenedFromStorage();for(let i of r.workspaces){let s=(0,P.isRecentFolder)(i)?this.indexOfFolder(o,i.folderUri):this.indexOfWorkspace(o,i.workspace);s>=0?o[s].label=o[s].label||i.label:o.push(i)}for(let i of r.files){let s=this.indexOfFile(u,i.fileUri);s>=0?u[s].label=u[s].label||i.label:u.push(i)}}getRecentlyOpenedFromStorage(){const o=this.stateMainService.getItem(qe.recentlyOpenedStorageKey);return(0,P.restoreRecentlyOpened)(o,this.logService)}saveRecentlyOpened(o){const u=(0,P.toStoreData)(o);this.stateMainService.setItem(qe.recentlyOpenedStorageKey,u)}updateWindowsJumpList(){if(!f.isWindows)return;const o=[];if(o.push({type:"tasks",items:[{type:"task",title:(0,S.localize)(0,null),description:(0,S.localize)(1,null),program:process.execPath,args:"-n",iconPath:process.execPath,iconIndex:0}]}),this.getRecentlyOpened().workspaces.length>0){let u=[];for(let s of p.app.getJumpListSettings().removedItems){const h=s.args;if(h){const w=/^--(folder|file)-uri\s+"([^"]+)"$/.exec(h);w&&u.push(E.URI.parse(w[2]))}}this.removeRecentlyOpened(u);let r=!1;const i=(0,R.coalesce)(this.getRecentlyOpened().workspaces.slice(0,qe.MAX_WINDOWS_JUMP_LIST_ENTRIES).map(s=>{const h=(0,P.isRecentWorkspace)(s)?s.workspace:s.folderUri,{title:w,description:M}=this.getWindowsJumpListLabel(h,s.label);let A;return E.URI.isUri(h)?A=`--folder-uri "${h.toString()}"`:(r=!0,A=`--file-uri "${h.configPath.toString()}"`),{type:"task",title:w.substr(0,255),description:M.substr(0,255),program:process.execPath,args:A,iconPath:"explorer.exe",iconIndex:0}}));i.length>0&&o.push({type:"custom",name:r?(0,S.localize)(2,null):(0,S.localize)(3,null),items:i})}o.push({type:"recent"});try{p.app.setJumpList(o)}catch(u){this.logService.warn("updateWindowsJumpList#setJumpList",u)}}getWindowsJumpListLabel(o,u){if(u)return{title:(0,n.splitName)(u).name,description:u};if(E.URI.isUri(o))return{title:(0,y.basename)(o),description:this.renderJumpListPathDescription(o)};if(this.workspacesManagementMainService.isUntitledWorkspace(o))return{title:(0,S.localize)(4,null),description:""};let r=(0,y.basename)(o.configPath);return r.endsWith(P.WORKSPACE_EXTENSION)&&(r=r.substr(0,r.length-P.WORKSPACE_EXTENSION.length-1)),{title:(0,S.localize)(5,null,r),description:this.renderJumpListPathDescription(o.configPath)}}renderJumpListPathDescription(o){return o.scheme==="file"?(0,n.normalizeDriveLetter)(o.fsPath):o.toString()}location(o){return(0,P.isRecentFolder)(o)?o.folderUri:(0,P.isRecentFile)(o)?o.fileUri:o.workspace.configPath}indexOfWorkspace(o,u){return o.findIndex(r=>(0,P.isRecentWorkspace)(r)&&r.workspace.id===u.id)}indexOfFolder(o,u){return o.findIndex(r=>(0,P.isRecentFolder)(r)&&y.extUriBiasedIgnorePathCase.isEqual(r.folderUri,u))}indexOfFile(o,u){return o.findIndex(r=>y.extUriBiasedIgnorePathCase.isEqual(r.fileUri,u))}};a.MAX_TOTAL_RECENT_ENTRIES=500,a.MAX_MACOS_DOCK_RECENT_WORKSPACES=7,a.MAX_MACOS_DOCK_RECENT_ENTRIES_TOTAL=10,a.MAX_WINDOWS_JUMP_LIST_ENTRIES=7,a.COMMON_FILES_FILTER=["COMMIT_EDITMSG","MERGE_MSG"],a.recentlyOpenedStorageKey="openedPathsList",a=fe([te(0,b.IStateMainService),te(1,v.ILogService),te(2,c.IWorkspacesManagementMainService),te(3,m.ILifecycleMainService)],a),e.WorkspacesHistoryMainService=a}),define(x[240],ee([0,1,14,9,23,33,3,7,149,18,24,20,6,187,52,22,37,29,41,67,36,68]),function(V,e,p,R,C,k,n,I,d,f,y,E,g,S,t,m,v,b,P,c,a,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Menubar=void 0;const o="menu";let u=class yt{constructor(s,h,w,M,A,L,F,U,Y,ie,re){this.updateService=s,this.configurationService=h,this.windowsMainService=w,this.environmentMainService=M,this.telemetryService=A,this.workspacesHistoryMainService=L,this.stateMainService=F,this.lifecycleMainService=U,this.logService=Y,this.nativeHostMainService=ie,this.productService=re,this.fallbackMenuHandlers=Object.create(null),this.menuUpdater=new R.RunOnceScheduler(()=>this.doUpdateMenu(),0),this.menuGC=new R.RunOnceScheduler(()=>{this.oldMenus=[]},1e4),this.menubarMenus=Object.create(null),this.keybindings=Object.create(null),(n.isMacintosh||(0,c.getTitleBarStyle)(this.configurationService)==="native")&&this.restoreCachedMenubarData(),this.addFallbackHandlers(),this.closedLastWindow=!1,this.noActiveWindow=!1,this.oldMenus=[],this.install(),this.registerListeners()}restoreCachedMenubarData(){const s=this.stateMainService.getItem(yt.lastKnownMenubarStorageKey);s&&(s.menus&&(this.menubarMenus=s.menus),s.keybindings&&(this.keybindings=s.keybindings))}addFallbackHandlers(){this.fallbackMenuHandlers["workbench.action.files.newUntitledFile"]=(L,F,U)=>this.windowsMainService.openEmptyWindow({context:2,contextWindowId:F?.id}),this.fallbackMenuHandlers["workbench.action.newWindow"]=(L,F,U)=>this.windowsMainService.openEmptyWindow({context:2,contextWindowId:F?.id}),this.fallbackMenuHandlers["workbench.action.files.openFileFolder"]=(L,F,U)=>this.nativeHostMainService.pickFileFolderAndOpen(void 0,{forceNewWindow:this.isOptionClick(U),telemetryExtraData:{from:o}}),this.fallbackMenuHandlers["workbench.action.openWorkspace"]=(L,F,U)=>this.nativeHostMainService.pickWorkspaceAndOpen(void 0,{forceNewWindow:this.isOptionClick(U),telemetryExtraData:{from:o}}),this.fallbackMenuHandlers["workbench.action.clearRecentFiles"]=()=>this.workspacesHistoryMainService.clearRecentlyOpened();const s=this.productService.twitterUrl;s&&(this.fallbackMenuHandlers["workbench.action.openTwitterUrl"]=()=>this.openUrl(s,"openTwitterUrl"));const h=this.productService.requestFeatureUrl;h&&(this.fallbackMenuHandlers["workbench.action.openRequestFeatureUrl"]=()=>this.openUrl(h,"openUserVoiceUrl"));const w=this.productService.reportIssueUrl;w&&(this.fallbackMenuHandlers["workbench.action.openIssueReporter"]=()=>this.openUrl(w,"openReportIssues"));const M=this.productService.licenseUrl;M&&(this.fallbackMenuHandlers["workbench.action.openLicenseUrl"]=()=>{if(n.language){const L=M.indexOf("?")>0?"&":"?";this.openUrl(`${M}${L}lang=${n.language}`,"openLicenseUrl")}else this.openUrl(M,"openLicenseUrl")});const A=this.productService.privacyStatementUrl;A&&M&&(this.fallbackMenuHandlers["workbench.action.openPrivacyStatementUrl"]=()=>{this.openUrl(A,"openPrivacyStatement")})}registerListeners(){this.lifecycleMainService.onWillShutdown(()=>this.willShutdown=!0),this.windowsMainService.onDidChangeWindowsCount(s=>this.onDidChangeWindowsCount(s)),this.nativeHostMainService.onDidBlurWindow(()=>this.onDidChangeWindowFocus()),this.nativeHostMainService.onDidFocusWindow(()=>this.onDidChangeWindowFocus())}get currentEnableMenuBarMnemonics(){let s=this.configurationService.getValue("window.enableMenuBarMnemonics");return typeof s!="boolean"?!0:s}get currentEnableNativeTabs(){if(!n.isMacintosh)return!1;let s=this.configurationService.getValue("window.nativeTabs");return typeof s!="boolean"?!1:s}updateMenu(s,h){this.menubarMenus=s.menus,this.keybindings=s.keybindings,this.stateMainService.setItem(yt.lastKnownMenubarStorageKey,s),this.scheduleUpdateMenu()}scheduleUpdateMenu(){this.menuUpdater.schedule()}doUpdateMenu(){this.willShutdown||setTimeout(()=>{this.willShutdown||this.install()},10)}onDidChangeWindowsCount(s){!n.isMacintosh||(s.oldCount===0&&s.newCount>0||s.oldCount>0&&s.newCount===0)&&(this.closedLastWindow=s.newCount===0,this.scheduleUpdateMenu())}onDidChangeWindowFocus(){!n.isMacintosh||(this.noActiveWindow=!p.BrowserWindow.getFocusedWindow(),this.scheduleUpdateMenu())}install(){const s=p.Menu.getApplicationMenu();if(s&&this.oldMenus.push(s),Object.keys(this.menubarMenus).length===0){p.Menu.setApplicationMenu(n.isMacintosh?new p.Menu:null);return}const h=new p.Menu;let w;if(n.isMacintosh){const A=new p.Menu;w=new p.MenuItem({label:this.productService.nameShort,submenu:A}),this.setMacApplicationMenu(A),h.append(w)}if(n.isMacintosh&&!this.appMenuInstalled){this.appMenuInstalled=!0;const A=new p.Menu;A.append(new p.MenuItem({label:this.mnemonicLabel(d.localize(0,null)),click:()=>this.windowsMainService.openEmptyWindow({context:1})})),p.app.dock.setMenu(A)}if(this.shouldDrawMenu("File")){const A=new p.Menu,L=new p.MenuItem({label:this.mnemonicLabel(d.localize(1,null)),submenu:A});this.setMenuById(A,"File"),h.append(L)}if(this.shouldDrawMenu("Edit")){const A=new p.Menu,L=new p.MenuItem({label:this.mnemonicLabel(d.localize(2,null)),submenu:A});this.setMenuById(A,"Edit"),h.append(L)}if(this.shouldDrawMenu("Selection")){const A=new p.Menu,L=new p.MenuItem({label:this.mnemonicLabel(d.localize(3,null)),submenu:A});this.setMenuById(A,"Selection"),h.append(L)}if(this.shouldDrawMenu("View")){const A=new p.Menu,L=new p.MenuItem({label:this.mnemonicLabel(d.localize(4,null)),submenu:A});this.setMenuById(A,"View"),h.append(L)}if(this.shouldDrawMenu("Go")){const A=new p.Menu,L=new p.MenuItem({label:this.mnemonicLabel(d.localize(5,null)),submenu:A});this.setMenuById(A,"Go"),h.append(L)}if(this.shouldDrawMenu("Run")){const A=new p.Menu,L=new p.MenuItem({label:this.mnemonicLabel(d.localize(6,null)),submenu:A});this.setMenuById(A,"Run"),h.append(L)}if(this.shouldDrawMenu("Terminal")){const A=new p.Menu,L=new p.MenuItem({label:this.mnemonicLabel(d.localize(7,null)),submenu:A});this.setMenuById(A,"Terminal"),h.append(L)}let M;if(this.shouldDrawMenu("Window")){const A=new p.Menu;M=new p.MenuItem({label:this.mnemonicLabel(d.localize(8,null)),submenu:A,role:"window"}),this.setMacWindowMenu(A)}if(M&&h.append(M),this.shouldDrawMenu("Help")){const A=new p.Menu,L=new p.MenuItem({label:this.mnemonicLabel(d.localize(9,null)),submenu:A,role:"help"});this.setMenuById(A,"Help"),h.append(L)}h.items&&h.items.length>0?p.Menu.setApplicationMenu(h):p.Menu.setApplicationMenu(null),this.menuGC.schedule()}setMacApplicationMenu(s){const h=this.createMenuItem(d.localize(10,null,this.productService.nameLong),"workbench.action.showAboutDialog"),w=this.getUpdateMenuItems();let M;if(this.shouldDrawMenu("Preferences")){const K=new p.Menu;this.setMenuById(K,"Preferences"),M=new p.MenuItem({label:this.mnemonicLabel(d.localize(11,null)),submenu:K})}const A=new p.Menu,L=new p.MenuItem({label:d.localize(12,null),role:"services",submenu:A}),F=new p.MenuItem({label:d.localize(13,null,this.productService.nameLong),role:"hide",accelerator:"Command+H"}),U=new p.MenuItem({label:d.localize(14,null),role:"hideOthers",accelerator:"Command+Alt+H"}),Y=new p.MenuItem({label:d.localize(15,null),role:"unhide"}),ie=new p.MenuItem(this.likeAction("workbench.action.quit",{label:d.localize(16,null,this.productService.nameLong),click:()=>{const K=this.windowsMainService.getLastActiveWindow();(this.windowsMainService.getWindowCount()===0||!!p.BrowserWindow.getFocusedWindow()||K?.isMinimized())&&this.nativeHostMainService.quit(void 0)}})),re=[h];re.push(...w),M&&re.push(r(),M),re.push(r(),L,r(),F,U,Y,r(),ie),re.forEach(K=>s.append(K))}shouldDrawMenu(s){if(!n.isMacintosh&&(0,c.getTitleBarStyle)(this.configurationService)==="custom")return!1;switch(s){case"File":case"Help":if(n.isMacintosh)return this.windowsMainService.getWindowCount()===0&&this.closedLastWindow||this.windowsMainService.getWindowCount()>0&&this.noActiveWindow||!!this.menubarMenus&&!!this.menubarMenus[s];case"Window":if(n.isMacintosh)return this.windowsMainService.getWindowCount()===0&&this.closedLastWindow||this.windowsMainService.getWindowCount()>0&&this.noActiveWindow||!!this.menubarMenus;default:return this.windowsMainService.getWindowCount()>0&&!!this.menubarMenus&&!!this.menubarMenus[s]}}setMenu(s,h){h.forEach(w=>{if((0,S.isMenubarMenuItemSeparator)(w))s.append(r());else if((0,S.isMenubarMenuItemSubmenu)(w)){const M=new p.Menu,A=new p.MenuItem({label:this.mnemonicLabel(w.label),submenu:M});this.setMenu(M,w.submenu.items),s.append(A)}else(0,S.isMenubarMenuItemRecentAction)(w)?s.append(this.createOpenRecentMenuItem(w)):(0,S.isMenubarMenuItemAction)(w)&&(w.id==="workbench.action.showAboutDialog"&&this.insertCheckForUpdatesItems(s),n.isMacintosh?this.windowsMainService.getWindowCount()===0&&this.closedLastWindow||this.windowsMainService.getWindowCount()>0&&this.noActiveWindow?this.fallbackMenuHandlers[w.id]?s.append(new p.MenuItem(this.likeAction(w.id,{label:this.mnemonicLabel(w.label),click:this.fallbackMenuHandlers[w.id]}))):s.append(this.createMenuItem(w.label,w.id,!1,w.checked)):s.append(this.createMenuItem(w.label,w.id,w.enabled!==!1,!!w.checked)):s.append(this.createMenuItem(w.label,w.id,w.enabled!==!1,!!w.checked)))})}setMenuById(s,h){this.menubarMenus&&this.menubarMenus[h]&&this.setMenu(s,this.menubarMenus[h].items)}insertCheckForUpdatesItems(s){const h=this.getUpdateMenuItems();h.length&&(h.forEach(w=>s.append(w)),s.append(r()))}createOpenRecentMenuItem(s){const h=I.URI.revive(s.uri),w=s.id,M=w==="openRecentFile"?{fileUri:h}:w==="openRecentWorkspace"?{workspaceUri:h}:{folderUri:h};return new p.MenuItem(this.likeAction(w,{label:s.label,click:(A,L,F)=>{const U=this.isOptionClick(F);this.windowsMainService.open({context:2,cli:this.environmentMainService.args,urisToOpen:[M],forceNewWindow:U,gotoLineMode:!1,remoteAuthority:s.remoteAuthority}).length>0||this.workspacesHistoryMainService.removeRecentlyOpened([h])}},!1))}isOptionClick(s){return!!(s&&(!n.isMacintosh&&(s.ctrlKey||s.shiftKey)||n.isMacintosh&&(s.metaKey||s.altKey)))}createRoleMenuItem(s,h,w){const M={label:this.mnemonicLabel(s),role:w,enabled:!0};return new p.MenuItem(this.withKeybinding(h,M))}setMacWindowMenu(s){const h=new p.MenuItem({label:d.localize(17,null),role:"minimize",accelerator:"Command+M",enabled:this.windowsMainService.getWindowCount()>0}),w=new p.MenuItem({label:d.localize(18,null),role:"zoom",enabled:this.windowsMainService.getWindowCount()>0}),M=new p.MenuItem({label:d.localize(19,null),role:"front",enabled:this.windowsMainService.getWindowCount()>0}),A=this.createMenuItem(d.localize(20,null),"workbench.action.switchWindow"),L=[];this.currentEnableNativeTabs&&(L.push(r()),L.push(this.createMenuItem(d.localize(21,null),"workbench.action.newWindowTab")),L.push(this.createRoleMenuItem(d.localize(22,null),"workbench.action.showPreviousWindowTab","selectPreviousTab")),L.push(this.createRoleMenuItem(d.localize(23,null),"workbench.action.showNextWindowTab","selectNextTab")),L.push(this.createRoleMenuItem(d.localize(24,null),"workbench.action.moveWindowTabToNewWindow","moveTabToNewWindow")),L.push(this.createRoleMenuItem(d.localize(25,null),"workbench.action.mergeAllWindowTabs","mergeAllWindows"))),[h,w,r(),A,...L,r(),M].forEach(F=>s.append(F))}getUpdateMenuItems(){switch(this.updateService.state.type){case"uninitialized":return[];case"idle":return[new p.MenuItem({label:this.mnemonicLabel(d.localize(26,null)),click:()=>setTimeout(()=>{this.reportMenuActionTelemetry("CheckForUpdate"),this.updateService.checkForUpdates(!0)},0)})];case"checking for updates":return[new p.MenuItem({label:d.localize(27,null),enabled:!1})];case"available for download":return[new p.MenuItem({label:this.mnemonicLabel(d.localize(28,null)),click:()=>{this.updateService.downloadUpdate()}})];case"downloading":return[new p.MenuItem({label:d.localize(29,null),enabled:!1})];case"downloaded":return[new p.MenuItem({label:this.mnemonicLabel(d.localize(30,null)),click:()=>{this.reportMenuActionTelemetry("InstallUpdate"),this.updateService.applyUpdate()}})];case"updating":return[new p.MenuItem({label:d.localize(31,null),enabled:!1})];case"ready":return[new p.MenuItem({label:this.mnemonicLabel(d.localize(32,null)),click:()=>{this.reportMenuActionTelemetry("RestartToUpdate"),this.updateService.quitAndInstall()}})]}}createMenuItem(s,h,w,M){const A=this.mnemonicLabel(s),L=typeof h=="function"?h:(re,K,W)=>{const N=re?re.userSettingsLabel:null;let G=h;Array.isArray(h)&&(G=this.isOptionClick(W)?h[1]:h[0]),N&&W.triggeredByAccelerator?this.runActionInRenderer({type:"keybinding",userSettingsLabel:N}):this.runActionInRenderer({type:"commandId",commandId:G})},F=typeof w=="boolean"?w:this.windowsMainService.getWindowCount()>0,U=typeof M=="boolean"?M:!1,Y={label:A,click:L,enabled:F};U&&(Y.type="checkbox",Y.checked=U);let ie;return typeof h=="string"?ie=h:Array.isArray(h)&&(ie=h[0]),n.isMacintosh&&(ie==="editor.action.clipboardCutAction"?Y.role="cut":ie==="editor.action.clipboardCopyAction"?Y.role="copy":ie==="editor.action.clipboardPasteAction"&&(Y.role="paste"),ie==="undo"?Y.click=this.makeContextAwareClickHandler(L,{inDevTools:re=>re.undo(),inNoWindow:()=>p.Menu.sendActionToFirstResponder("undo:")}):ie==="redo"?Y.click=this.makeContextAwareClickHandler(L,{inDevTools:re=>re.redo(),inNoWindow:()=>p.Menu.sendActionToFirstResponder("redo:")}):ie==="editor.action.selectAll"&&(Y.click=this.makeContextAwareClickHandler(L,{inDevTools:re=>re.selectAll(),inNoWindow:()=>p.Menu.sendActionToFirstResponder("selectAll:")}))),new p.MenuItem(this.withKeybinding(ie,Y))}makeContextAwareClickHandler(s,h){return(w,M,A)=>{const L=p.BrowserWindow.getFocusedWindow();if(!L)return h.inNoWindow();if(L.webContents.isDevToolsFocused()&&L.webContents.devToolsWebContents)return h.inDevTools(L.webContents.devToolsWebContents);s(w,M||L,A)}}runActionInRenderer(s){let h=p.BrowserWindow.getFocusedWindow();if(!h){const M=this.windowsMainService.getLastActiveWindow();M?.isMinimized()&&(h=M.win)}const w=h?this.windowsMainService.getWindowById(h.id):void 0;if(w){if(this.logService.trace("menubar#runActionInRenderer",s),n.isMacintosh&&!this.environmentMainService.isBuilt&&!w.isReady&&(s.type==="commandId"&&s.commandId==="workbench.action.toggleDevTools"||s.type!=="commandId"&&s.userSettingsLabel==="alt+cmd+i"))return;if(s.type==="commandId"){const M={id:s.commandId,from:"menu"};w.sendWhenReady("vscode:runAction",C.CancellationToken.None,M)}else{const M={userSettingsLabel:s.userSettingsLabel};w.sendWhenReady("vscode:runKeybinding",C.CancellationToken.None,M)}}else this.logService.trace("menubar#runActionInRenderer: no active window found",s)}withKeybinding(s,h){const w=typeof s=="string"?this.keybindings[s]:void 0;if(w?.label){if(w.isNative!==!1)h.accelerator=w.label,h.userSettingsLabel=w.userSettingsLabel;else if(typeof h.label=="string"){const M=h.label.indexOf("[");M>=0?h.label=`${h.label.substr(0,M)} [${w.label}]`:h.label=`${h.label} [${w.label}]`}}else h.accelerator=void 0;return h}likeAction(s,h,w=!h.accelerator){w&&(h=this.withKeybinding(s,h));const M=h.click;return h.click=(A,L,F)=>{this.reportMenuActionTelemetry(s),M&&M(A,L,F)},h}openUrl(s,h){this.nativeHostMainService.openExternal(void 0,s),this.reportMenuActionTelemetry(h)}reportMenuActionTelemetry(s){this.telemetryService.publicLog2("workbenchActionExecuted",{id:s,from:o})}mnemonicLabel(s){return(0,k.mnemonicMenuLabel)(s,!this.currentEnableMenuBarMnemonics)}};u.lastKnownMenubarStorageKey="lastKnownMenubarData",u=fe([te(0,P.IUpdateService),te(1,f.IConfigurationService),te(2,a.IWindowsMainService),te(3,y.IEnvironmentMainService),te(4,b.ITelemetryService),te(5,l.IWorkspacesHistoryMainService),te(6,v.IStateMainService),te(7,E.ILifecycleMainService),te(8,g.ILogService),te(9,t.INativeHostMainService),te(10,m.IProductService)],u),e.Menubar=u;function r(){return new p.MenuItem({type:"separator"})}}),define(x[241],ee([0,1,5,20,6,240]),function(V,e,p,R,C,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.MenubarMainService=e.IMenubarMainService=void 0,e.IMenubarMainService=(0,p.createDecorator)("menubarMainService");let n=class{constructor(d,f,y){this.instantiationService=d,this.lifecycleMainService=f,this.logService=y,this.menubar=this.installMenuBarAfterWindowOpen()}async installMenuBarAfterWindowOpen(){return await this.lifecycleMainService.when(3),this.instantiationService.createInstance(k.Menubar)}async updateMenubar(d,f){this.logService.trace("menubarService#updateMenubar",d),(await this.menubar).updateMenu(f,d)}};n=fe([te(0,p.IInstantiationService),te(1,R.ILifecycleMainService),te(2,C.ILogService)],n),e.MenubarMainService=n}),define(x[242],ee([0,1,14,28,26,30,23,4,32,42,33,2,10,8,63,3,34,15,13,7,155,50,18,51,24,19,5,20,6,55,22,56,64,37,67,239,101,221,27,102,68,45]),function(V,e,p,R,C,k,n,I,d,f,y,E,g,S,t,m,v,b,P,c,a,l,o,u,r,i,s,h,w,M,A,L,F,U,Y,ie,re,K,W,N,G,Q){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WindowsMainService=void 0;function H(O){return(0,W.isWorkspaceIdentifier)(O?.workspace)}function $(O){return(0,W.isSingleFolderWorkspaceIdentifier)(O?.workspace)}let J=class it extends E.Disposable{constructor(D,T,_,z,X,B,q,ne,se,oe,Z,ce,le,ue,me){super();this.machineId=D,this.initialUserEnv=T,this.logService=_,this.stateMainService=z,this.environmentMainService=X,this.lifecycleMainService=B,this.backupMainService=q,this.configurationService=ne,this.workspacesHistoryMainService=se,this.workspacesManagementMainService=oe,this.instantiationService=Z,this.dialogMainService=ce,this.fileService=le,this.productService=ue,this.protocolMainService=me,this._onDidOpenWindow=this._register(new I.Emitter),this.onDidOpenWindow=this._onDidOpenWindow.event,this._onDidSignalReadyWindow=this._register(new I.Emitter),this.onDidSignalReadyWindow=this._onDidSignalReadyWindow.event,this._onDidDestroyWindow=this._register(new I.Emitter),this.onDidDestroyWindow=this._onDidDestroyWindow.event,this._onDidChangeWindowsCount=this._register(new I.Emitter),this.onDidChangeWindowsCount=this._onDidChangeWindowsCount.event,this.windowsStateHandler=this._register(new K.WindowsStateHandler(this,this.stateMainService,this.lifecycleMainService,this.logService,this.configurationService)),this.registerListeners()}registerListeners(){this._register(this.workspacesManagementMainService.onDidEnterWorkspace(D=>this._onDidSignalReadyWindow.fire(D.window))),this._register(this.onDidSignalReadyWindow(D=>{if(D.config?.extensionDevelopmentPath||D.config?.extensionTestsPath){const T=new E.DisposableStore;if(T.add(I.Event.any(D.onDidClose,D.onDidDestroy)(()=>T.dispose())),D.config.extensionDevelopmentPath)for(const _ of D.config.extensionDevelopmentPath)T.add(this.protocolMainService.addValidFileRoot(c.URI.file(_)));D.config.extensionTestsPath&&T.add(this.protocolMainService.addValidFileRoot(c.URI.file(D.config.extensionTestsPath)))}}))}openEmptyWindow(D,T){let _=this.environmentMainService.args;const z=T?.remoteAuthority||void 0,X=!0,B=T?.forceReuseWindow,q=!B;return this.open({...D,cli:_,forceEmpty:X,forceNewWindow:q,forceReuseWindow:B,remoteAuthority:z})}openExistingWindow(D,T){D.focus(),this.handleWaitMarkerFile(T,[D])}open(D){this.logService.trace("windowsManager#open"),D.addMode&&(D.initialStartup||!this.getLastActiveWindow())&&(D.addMode=!1);const T=[],_=[],z=[],X=[],B=[];let q,ne=0;const se=this.getPathsToOpen(D);this.logService.trace("windowsManager#open pathsToOpen",se);for(const le of se)$(le)?D.addMode?T.push(le):_.push(le):H(le)?z.push(le):le.fileUri?(q||(q={filesToOpenOrCreate:[],filesToDiff:[],remoteAuthority:le.remoteAuthority}),q.filesToOpenOrCreate.push(le)):le.backupPath?B.push({backupFolder:(0,S.basename)(le.backupPath),remoteAuthority:le.remoteAuthority}):ne++;D.diffMode&&q&&q.filesToOpenOrCreate.length>=2&&(q.filesToDiff=q.filesToOpenOrCreate.slice(0,2),q.filesToOpenOrCreate=[]),q&&D.waitMarkerFileURI&&(q.filesToWait={paths:[...q.filesToDiff,...q.filesToOpenOrCreate],waitMarkerFileUri:D.waitMarkerFileURI}),D.initialStartup?(X.push(...this.workspacesManagementMainService.getUntitledWorkspacesSync()),z.push(...X),B.push(...this.backupMainService.getEmptyWindowBackupPaths())):B.length=0;const{windows:oe,filesOpenedInWindow:Z}=this.doOpen(D,z,_,B,ne,q,T);if(this.logService.trace(`windowsManager#open used window count ${oe.length} (workspacesToOpen: ${z.length}, foldersToOpen: ${_.length}, emptyToRestore: ${B.length}, emptyToOpen: ${ne})`),oe.length>1)if(Z)Z.focus();else{const le=this.windowsStateHandler.state.lastActiveWindow&&!D.forceEmpty&&!D.cli._.length&&!D.cli["file-uri"]&&!D.cli["folder-uri"]&&!(D.urisToOpen&&D.urisToOpen.length);let ue=!0,me=!0;if(le){const Ee=oe.filter(de=>this.windowsStateHandler.state.lastActiveWindow&&de.backupPath===this.windowsStateHandler.state.lastActiveWindow.backupPath);Ee.length&&(Ee[0].focus(),ue=!1,me=!1)}if(ue)for(let Ee=oe.length-1;Ee>=0;Ee--){const de=oe[Ee];if(!(de.openedWorkspace&&X.some(ge=>de.openedWorkspace&&ge.workspace.id===de.openedWorkspace.id)||de.backupPath&&B.some(ge=>de.backupPath&&ge.backupFolder===(0,S.basename)(de.backupPath)))){de.focus(),me=!1;break}}me&&oe[oe.length-1].focus()}const ce=q&&q.filesToDiff.length>0;if(!oe.some(le=>le.isExtensionDevelopmentHost)&&!ce&&!D.noRecentEntry){const le=[];for(const ue of se)H(ue)&&!ue.transient?le.push({label:ue.label,workspace:ue.workspace,remoteAuthority:ue.remoteAuthority}):$(ue)?le.push({label:ue.label,folderUri:ue.workspace.uri,remoteAuthority:ue.remoteAuthority}):ue.fileUri&&le.push({label:ue.label,fileUri:ue.fileUri,remoteAuthority:ue.remoteAuthority});this.workspacesHistoryMainService.addRecentlyOpened(le)}return this.handleWaitMarkerFile(D,oe),oe}handleWaitMarkerFile(D,T){const _=D.waitMarkerFileURI;D.context===0&&_&&T.length===1&&T[0]&&(async()=>{await T[0].whenClosedOrLoaded;try{await this.fileService.del(_)}catch(z){}})()}doOpen(D,T,_,z,X,B,q){const ne=[];let se;function oe(de,ge){ne.push(de),ge&&(se=de,B=void 0)}let{openFolderInNewWindow:Z,openFilesInNewWindow:ce}=this.shouldOpenNewWindow(D);if(!D.initialStartup&&q.length>0){const de=q[0].remoteAuthority,ge=this.getLastActiveWindowForAuthority(de);ge&&oe(this.doAddFoldersToExistingWindow(ge,q.map(pe=>pe.workspace.uri)))}const le=_.length+T.length+z.length;if(B&&le===0){const de=B.filesToOpenOrCreate[0]||B.filesToDiff[0],ge=this.getWindows().filter(ke=>B&&(0,b.isEqualAuthority)(ke.remoteAuthority,B.remoteAuthority));let pe;de?.fileUri&&!ce&&((D.context===4||D.context===0||D.context===1)&&(pe=(0,re.findWindowOnFile)(ge,de.fileUri,ke=>ke.configPath.scheme===g.Schemas.file?this.workspacesManagementMainService.resolveLocalWorkspaceSync(ke.configPath):void 0)),pe||(pe=this.doGetLastActiveWindow(ge))),pe?(0,W.isWorkspaceIdentifier)(pe.openedWorkspace)?T.push({workspace:pe.openedWorkspace,remoteAuthority:pe.remoteAuthority}):(0,W.isSingleFolderWorkspaceIdentifier)(pe.openedWorkspace)?_.push({workspace:pe.openedWorkspace,remoteAuthority:pe.remoteAuthority}):oe(this.doOpenFilesInExistingWindow(D,pe,B),!0):oe(this.openInBrowserWindow({userEnv:D.userEnv,cli:D.cli,initialStartup:D.initialStartup,filesToOpen:B,forceNewWindow:!0,remoteAuthority:B.remoteAuthority,forceNewTabbedWindow:D.forceNewTabbedWindow}),!0)}const ue=(0,k.distinct)(T,de=>de.workspace.id);if(ue.length>0){const de=(0,k.coalesce)(ue.map(ge=>(0,re.findWindowOnWorkspaceOrFolder)(this.getWindows(),ge.workspace.configPath)));if(de.length>0){const ge=de[0],pe=(0,b.isEqualAuthority)(B?.remoteAuthority,ge.remoteAuthority)?B:void 0;oe(this.doOpenFilesInExistingWindow(D,ge,pe),!!pe),Z=!0}ue.forEach(ge=>{if(de.some(Re=>Re.openedWorkspace&&Re.openedWorkspace.id===ge.workspace.id))return;const pe=ge.remoteAuthority,ke=(0,b.isEqualAuthority)(B?.remoteAuthority,pe)?B:void 0;oe(this.doOpenFolderOrWorkspace(D,ge,Z,ke),!!ke),Z=!0})}const me=(0,k.distinct)(_,de=>b.extUriBiasedIgnorePathCase.getComparisonKey(de.workspace.uri));if(me.length>0){const de=(0,k.coalesce)(me.map(ge=>(0,re.findWindowOnWorkspaceOrFolder)(this.getWindows(),ge.workspace.uri)));if(de.length>0){const ge=de[0],pe=(0,b.isEqualAuthority)(B?.remoteAuthority,ge.remoteAuthority)?B:void 0;oe(this.doOpenFilesInExistingWindow(D,ge,pe),!!pe),Z=!0}me.forEach(ge=>{if(de.some(Re=>(0,W.isSingleFolderWorkspaceIdentifier)(Re.openedWorkspace)&&b.extUriBiasedIgnorePathCase.isEqual(Re.openedWorkspace.uri,ge.workspace.uri)))return;const pe=ge.remoteAuthority,ke=(0,b.isEqualAuthority)(B?.remoteAuthority,pe)?B:void 0;oe(this.doOpenFolderOrWorkspace(D,ge,Z,ke),!!ke),Z=!0})}const Ee=(0,k.distinct)(z,de=>de.backupFolder);if(Ee.length>0&&Ee.forEach(de=>{const ge=de.remoteAuthority,pe=(0,b.isEqualAuthority)(B?.remoteAuthority,ge)?B:void 0;oe(this.doOpenEmpty(D,!0,ge,pe,de),!!pe),Z=!0}),ne.length===0||B){B&&!X&&X++;const de=B?B.remoteAuthority:D.remoteAuthority;for(let ge=0;ge<X;ge++)oe(this.doOpenEmpty(D,Z,de,B),!!B),Z=!0}return{windows:(0,k.distinct)(ne),filesOpenedInWindow:se}}doOpenFilesInExistingWindow(D,T,_){this.logService.trace("windowsManager#doOpenFilesInExistingWindow",{filesToOpen:_}),T.focus();const z={filesToOpenOrCreate:_?.filesToOpenOrCreate,filesToDiff:_?.filesToDiff,filesToWait:_?.filesToWait,termProgram:D?.userEnv?.TERM_PROGRAM};return T.sendWhenReady("vscode:openFiles",n.CancellationToken.None,z),T}doAddFoldersToExistingWindow(D,T){this.logService.trace("windowsManager#doAddFoldersToExistingWindow",{foldersToAdd:T}),D.focus();const _={foldersToAdd:T};return D.sendWhenReady("vscode:addFolders",n.CancellationToken.None,_),D}doOpenEmpty(D,T,_,z,X){this.logService.trace("windowsManager#doOpenEmpty",{restore:!!X,remoteAuthority:_,filesToOpen:z,forceNewWindow:T});let B;return!T&&typeof D.contextWindowId=="number"&&(B=this.getWindowById(D.contextWindowId)),this.openInBrowserWindow({userEnv:D.userEnv,cli:D.cli,initialStartup:D.initialStartup,remoteAuthority:_,forceNewWindow:T,forceNewTabbedWindow:D.forceNewTabbedWindow,filesToOpen:z,windowToUse:B,emptyWindowBackupInfo:X})}doOpenFolderOrWorkspace(D,T,_,z,X){return this.logService.trace("windowsManager#doOpenFolderOrWorkspace",{folderOrWorkspace:T,filesToOpen:z}),!_&&!X&&typeof D.contextWindowId=="number"&&(X=this.getWindowById(D.contextWindowId)),this.openInBrowserWindow({workspace:T.workspace,userEnv:D.userEnv,cli:D.cli,initialStartup:D.initialStartup,remoteAuthority:T.remoteAuthority,forceNewWindow:_,forceNewTabbedWindow:D.forceNewTabbedWindow,filesToOpen:z,windowToUse:X})}getPathsToOpen(D){let T,_=!1,z=!1;if(D.urisToOpen&&D.urisToOpen.length>0?(T=this.doExtractPathsFromAPI(D),_=!0):D.forceEmpty?T=[Object.create(null)]:D.cli._.length||D.cli["folder-uri"]||D.cli["file-uri"]?(T=this.doExtractPathsFromCLI(D.cli),T.length===0&&T.push(Object.create(null)),_=!0):(T=this.doGetPathsFromLastSession(),T.length===0&&T.push(Object.create(null)),z=!0),!D.addMode&&_){const X=T.filter(B=>$(B));if(X.length>1){const B=X[0].remoteAuthority;if(X.every(q=>(0,b.isEqualAuthority)(q.remoteAuthority,B))){const q=this.workspacesManagementMainService.createUntitledWorkspaceSync(X.map(ne=>({uri:ne.workspace.uri})));T.push({workspace:q,remoteAuthority:B}),T=T.filter(ne=>!$(ne))}}}return D.initialStartup&&!z&&this.configurationService.getValue("window")?.restoreWindows==="preserve"&&T.unshift(...this.doGetPathsFromLastSession().filter(X=>H(X)||$(X)||X.backupPath)),T}doExtractPathsFromAPI(D){const T=[],_={gotoLineMode:D.gotoLineMode,remoteAuthority:D.remoteAuthority};for(const z of(0,k.coalesce)(D.urisToOpen||[])){const X=this.resolveOpenable(z,_);if(X)X.label=z.label,T.push(X);else{const B=this.resourceFromOpenable(z),q={title:this.productService.nameLong,type:"info",buttons:[(0,y.mnemonicButtonLabel)((0,a.localize)(0,null))],defaultId:0,message:B.scheme===g.Schemas.file?(0,a.localize)(1,null):(0,a.localize)(2,null),detail:B.scheme===g.Schemas.file?(0,a.localize)(3,null,(0,y.getPathLabel)(B.fsPath,this.environmentMainService)):(0,a.localize)(4,null,B.toString()),noLink:!0};this.dialogMainService.showMessageBox(q,(0,P.withNullAsUndefined)(p.BrowserWindow.getFocusedWindow()))}}return T}doExtractPathsFromCLI(D){const T=[],_={ignoreFileNotFound:!0,gotoLineMode:D.goto,remoteAuthority:D.remote||void 0,forceOpenWorkspaceAsFile:!1},z=D["folder-uri"];if(z)for(const q of z){const ne=this.cliArgToUri(q);if(ne){const se=this.resolveOpenable({folderUri:ne},_);se&&T.push(se)}}const X=D["file-uri"];if(X)for(const q of X){const ne=this.cliArgToUri(q);if(ne){const se=this.resolveOpenable((0,W.hasWorkspaceFileExtension)(q)?{workspaceUri:ne}:{fileUri:ne},_);se&&T.push(se)}}const B=D._;for(const q of B){const ne=_.remoteAuthority?this.doResolvePathRemote(q,_):this.doResolveFilePath(q,_);ne&&T.push(ne)}return T}cliArgToUri(D){try{const T=c.URI.parse(D);if(!T.scheme){this.logService.error(`Invalid URI input string, scheme missing: ${D}`);return}return T}catch(T){this.logService.error(`Invalid URI input string: ${D}, ${T.message}`)}}doGetPathsFromLastSession(){const D=this.getRestoreWindowsSetting();switch(D){case"none":return[];case"one":case"all":case"preserve":case"folders":const T=[];D!=="one"&&T.push(...this.windowsStateHandler.state.openedWindows),this.windowsStateHandler.state.lastActiveWindow&&T.push(this.windowsStateHandler.state.lastActiveWindow);const _=[];for(const z of T)if(z.workspace){const X=this.resolveOpenable({workspaceUri:z.workspace.configPath},{remoteAuthority:z.remoteAuthority,rejectTransientWorkspaces:!0});H(X)&&_.push(X)}else if(z.folderUri){const X=this.resolveOpenable({folderUri:z.folderUri},{remoteAuthority:z.remoteAuthority});$(X)&&_.push(X)}else D!=="folders"&&z.backupPath&&_.push({backupPath:z.backupPath,remoteAuthority:z.remoteAuthority});return _}}getRestoreWindowsSetting(){let D;return this.lifecycleMainService.wasRestarted?D="all":(D=this.configurationService.getValue("window")?.restoreWindows||"all",["preserve","all","folders","one","none"].includes(D)||(D="all")),D}resolveOpenable(D,T=Object.create(null)){let _=this.resourceFromOpenable(D);return _.scheme===g.Schemas.file?((0,Y.isFileToOpen)(D)&&(T={...T,forceOpenWorkspaceAsFile:!0}),this.doResolveFilePath(_.fsPath,T)):this.doResolveRemoteOpenable(D,T)}doResolveRemoteOpenable(D,T){let _=this.resourceFromOpenable(D);const z=(0,F.getRemoteAuthority)(_)||T.remoteAuthority;if(_=(0,b.removeTrailingPathSeparator)((0,b.normalizePath)(_)),(0,Y.isFileToOpen)(D)){if(T.gotoLineMode){const{path:X,line:B,column:q}=(0,d.parseLineAndColumnAware)(_.path);return{fileUri:_.with({path:X}),selection:B?{startLineNumber:B,startColumn:q||1}:void 0,remoteAuthority:z}}return{fileUri:_,remoteAuthority:z}}else if((0,Y.isWorkspaceToOpen)(D))return{workspace:(0,N.getWorkspaceIdentifier)(_),remoteAuthority:z};return{workspace:(0,N.getSingleFolderWorkspaceIdentifier)(_),remoteAuthority:z}}resourceFromOpenable(D){return(0,Y.isWorkspaceToOpen)(D)?D.workspaceUri:(0,Y.isFolderToOpen)(D)?D.folderUri:D.fileUri}doResolveFilePath(D,T){let _,z;T.gotoLineMode&&({path:D,line:_,column:z}=(0,d.parseLineAndColumnAware)(D)),D=(0,d.sanitizeFilePath)((0,S.normalize)(D),(0,v.cwd)());try{const X=(0,R.statSync)(D);if(X.isFile()){if(!T.forceOpenWorkspaceAsFile){const B=this.workspacesManagementMainService.resolveLocalWorkspaceSync(c.URI.file(D));if(B)return B.transient&&T.rejectTransientWorkspaces?void 0:{workspace:{id:B.id,configPath:B.configPath},type:i.FileType.File,exists:!0,remoteAuthority:B.remoteAuthority,transient:B.transient}}return{fileUri:c.URI.file(D),type:i.FileType.File,exists:!0,selection:_?{startLineNumber:_,startColumn:z||1}:void 0}}else{if(X.isDirectory())return{workspace:(0,N.getSingleFolderWorkspaceIdentifier)(c.URI.file(D),X),type:i.FileType.Directory,exists:!0};if(!m.isWindows&&D==="/dev/null")return{fileUri:c.URI.file(D),type:i.FileType.File,exists:!0}}}catch(X){const B=c.URI.file(D);if(this.workspacesHistoryMainService.removeRecentlyOpened([B]),T.ignoreFileNotFound)return{fileUri:B,type:i.FileType.File,exists:!1}}}doResolvePathRemote(D,T){const _=D.charCodeAt(0),z=T.remoteAuthority;let X,B;T.gotoLineMode&&({path:D,line:X,column:B}=(0,d.parseLineAndColumnAware)(D)),_!==47&&((0,d.isWindowsDriveLetter)(_)&&D.charCodeAt(D.charCodeAt(1))===58&&(D=(0,d.toSlashes)(D)),D=`/${D}`);const q=c.URI.from({scheme:g.Schemas.vscodeRemote,authority:z,path:D});if(D.charCodeAt(D.length-1)!==47){if((0,W.hasWorkspaceFileExtension)(D))return T.forceOpenWorkspaceAsFile?{fileUri:q,selection:X?{startLineNumber:X,startColumn:B||1}:void 0,remoteAuthority:T.remoteAuthority}:{workspace:(0,N.getWorkspaceIdentifier)(q),remoteAuthority:z};if(T.gotoLineMode||S.posix.basename(D).indexOf(".")!==-1)return{fileUri:q,selection:X?{startLineNumber:X,startColumn:B||1}:void 0,remoteAuthority:z}}return{workspace:(0,N.getSingleFolderWorkspaceIdentifier)(q),remoteAuthority:z}}shouldOpenNewWindow(D){const T=this.configurationService.getValue("window"),_=T?.openFoldersInNewWindow||"default",z=T?.openFilesInNewWindow||"off";let X=(D.preferNewWindow||D.forceNewWindow)&&!D.forceReuseWindow;!D.forceNewWindow&&!D.forceReuseWindow&&(_==="on"||_==="off")&&(X=_==="on");let B=!1;return D.forceNewWindow||D.forceReuseWindow?B=!!D.forceNewWindow&&!D.forceReuseWindow:(m.isMacintosh?D.context===1&&(B=!0):D.context!==3&&D.context!==2&&!(D.userEnv&&D.userEnv.TERM_PROGRAM==="vscode")&&(B=!0),!D.cli.extensionDevelopmentPath&&(z==="on"||z==="off")&&(B=z==="on")),{openFolderInNewWindow:!!X,openFilesInNewWindow:B}}openExtensionDevelopmentHostWindow(D,T){const _=(0,re.findWindowOnExtensionDevelopmentPath)(this.getWindows(),D);if(_)return this.lifecycleMainService.reload(_,T.cli),_.focus(),[_];let z=T.cli["folder-uri"]||[],X=T.cli["file-uri"]||[],B=T.cli._;if(!B.length&&!z.length&&!X.length&&!T.cli.extensionTestsPath){const oe=this.windowsStateHandler.state.lastPluginDevelopmentHostWindow,Z=oe&&(oe.workspace||oe.folderUri);Z&&(c.URI.isUri(Z)?Z.scheme===g.Schemas.file?B=[Z.fsPath]:z=[Z.toString()]:Z.configPath.scheme===g.Schemas.file?B=[(0,b.originalFSPath)(Z.configPath)]:X=[Z.configPath.toString()])}let q=T.remoteAuthority;for(const oe of D)if(oe.match(/^[a-zA-Z][a-zA-Z0-9\+\-\.]+:/)){const Z=c.URI.parse(oe),ce=(0,F.getRemoteAuthority)(Z);ce&&(q?ce!==q&&this.logService.error("more than one extension development path authority"):q=ce)}B=B.filter(oe=>{const Z=c.URI.file(oe);return(0,re.findWindowOnWorkspaceOrFolder)(this.getWindows(),Z)?!1:(0,b.isEqualAuthority)((0,F.getRemoteAuthority)(Z),q)}),z=z.filter(oe=>{const Z=this.cliArgToUri(oe);return Z&&!!(0,re.findWindowOnWorkspaceOrFolder)(this.getWindows(),Z)?!1:Z?(0,b.isEqualAuthority)((0,F.getRemoteAuthority)(Z),q):!1}),X=X.filter(oe=>{const Z=this.cliArgToUri(oe);return Z&&!!(0,re.findWindowOnWorkspaceOrFolder)(this.getWindows(),Z)?!1:Z?(0,b.isEqualAuthority)((0,F.getRemoteAuthority)(Z),q):!1}),T.cli._=B,T.cli["folder-uri"]=z,T.cli["file-uri"]=X;const ne=!B.length&&!z.length&&!X.length,se={context:T.context,cli:T.cli,forceNewWindow:!0,forceEmpty:ne,userEnv:T.userEnv,noRecentEntry:!0,waitMarkerFileURI:T.waitMarkerFileURI,remoteAuthority:q};return this.open(se)}openInBrowserWindow(D){const T=this.configurationService.getValue("window"),_={...this.environmentMainService.args,...D.cli,machineId:this.machineId,windowId:-1,mainPid:process.pid,appRoot:this.environmentMainService.appRoot,execPath:process.execPath,codeCachePath:this.environmentMainService.codeCachePath,backupPath:D.emptyWindowBackupInfo?(0,S.join)(this.environmentMainService.backupHome,D.emptyWindowBackupInfo.backupFolder):void 0,homeDir:this.environmentMainService.userHome.fsPath,tmpDir:this.environmentMainService.tmpDir.fsPath,userDataDir:this.environmentMainService.userDataPath,remoteAuthority:D.remoteAuthority,workspace:D.workspace,userEnv:{...this.initialUserEnv,...D.userEnv},filesToOpenOrCreate:D.filesToOpen?.filesToOpenOrCreate,filesToDiff:D.filesToOpen?.filesToDiff,filesToWait:D.filesToOpen?.filesToWait,logLevel:this.logService.getLevel(),logsPath:this.environmentMainService.logsPath,product:M.default,isInitialStartup:D.initialStartup,perfMarks:(0,t.getMarks)(),os:{release:(0,C.release)(),hostname:(0,C.hostname)()},zoomLevel:typeof T?.zoomLevel=="number"?T.zoomLevel:void 0,legacyWatcher:this.configurationService.getValue("files.legacyWatcher"),experimentalSandboxedFileService:this.configurationService.getValue("files.experimentalSandboxedFileService"),autoDetectHighContrast:T?.autoDetectHighContrast??!0,accessibilitySupport:p.app.accessibilitySupportEnabled,colorScheme:{dark:p.nativeTheme.shouldUseDarkColors,highContrast:p.nativeTheme.shouldUseInvertedColorScheme||p.nativeTheme.shouldUseHighContrastColors}};let z;if(!D.forceNewWindow&&!D.forceNewTabbedWindow&&(z=D.windowToUse||this.getLastActiveWindow(),z&&z.focus()),z){const X=z.config;!_.extensionDevelopmentPath&&X&&!!X.extensionDevelopmentPath&&(_.extensionDevelopmentPath=X.extensionDevelopmentPath,_.verbose=X.verbose,_["inspect-brk-extensions"]=X["inspect-brk-extensions"],_.debugId=X.debugId,_.extensionEnvironment=X.extensionEnvironment,_["inspect-extensions"]=X["inspect-extensions"],_["extensions-dir"]=X["extensions-dir"])}else{const X=this.windowsStateHandler.getNewWindowState(_);(0,t.mark)("code/willCreateCodeWindow");const B=z=this.instantiationService.createInstance(ie.CodeWindow,{state:X,extensionDevelopmentPath:_.extensionDevelopmentPath,isExtensionTestHost:!!_.extensionTestsPath});if((0,t.mark)("code/didCreateCodeWindow"),D.forceNewTabbedWindow){const ne=this.getLastActiveWindow();ne&&ne.addTabbedWindow(B)}it.WINDOWS.push(B),this._onDidOpenWindow.fire(B),this._onDidChangeWindowsCount.fire({oldCount:this.getWindowCount()-1,newCount:this.getWindowCount()}),(0,f.once)(B.onDidSignalReady)(()=>this._onDidSignalReadyWindow.fire(B)),(0,f.once)(B.onDidClose)(()=>this.onWindowClosed(B)),(0,f.once)(B.onDidDestroy)(()=>this._onDidDestroyWindow.fire(B));const q=(0,P.assertIsDefined)(B.win?.webContents);q.removeAllListeners("devtools-reload-page"),q.on("devtools-reload-page",()=>this.lifecycleMainService.reload(B)),this.lifecycleMainService.registerWindow(B)}return _.windowId=z.id,z.isReady?this.lifecycleMainService.unload(z,4).then(X=>{X||this.doOpenInBrowserWindow(z,_,D)}):this.doOpenInBrowserWindow(z,_,D),z}doOpenInBrowserWindow(D,T,_){if(!T.extensionDevelopmentPath)if((0,W.isWorkspaceIdentifier)(T.workspace))T.backupPath=this.backupMainService.registerWorkspaceBackupSync({workspace:T.workspace,remoteAuthority:T.remoteAuthority});else if((0,W.isSingleFolderWorkspaceIdentifier)(T.workspace))T.backupPath=this.backupMainService.registerFolderBackupSync(T.workspace.uri);else{const z=_.emptyWindowBackupInfo&&_.emptyWindowBackupInfo.backupFolder;T.backupPath=this.backupMainService.registerEmptyWindowBackupSync(z,T.remoteAuthority)}D.load(T)}onWindowClosed(D){const T=it.WINDOWS.indexOf(D);it.WINDOWS.splice(T,1),this._onDidChangeWindowsCount.fire({oldCount:this.getWindowCount()+1,newCount:this.getWindowCount()})}getFocusedWindow(){const D=p.BrowserWindow.getFocusedWindow();if(D)return this.getWindowById(D.id)}getLastActiveWindow(){return this.doGetLastActiveWindow(this.getWindows())}getLastActiveWindowForAuthority(D){return this.doGetLastActiveWindow(this.getWindows().filter(T=>(0,b.isEqualAuthority)(T.remoteAuthority,D)))}doGetLastActiveWindow(D){const T=Math.max.apply(Math,D.map(_=>_.lastFocusTime));return D.find(_=>_.lastFocusTime===T)}sendToFocused(D,...T){const _=this.getFocusedWindow()||this.getLastActiveWindow();_&&_.sendWhenReady(D,n.CancellationToken.None,...T)}sendToAll(D,T,_){for(const z of this.getWindows())_&&_.indexOf(z.id)>=0||z.sendWhenReady(D,n.CancellationToken.None,T)}getWindows(){return it.WINDOWS}getWindowCount(){return it.WINDOWS.length}getWindowById(D){const T=this.getWindows().filter(_=>_.id===D);return(0,k.firstOrDefault)(T)}getWindowByWebContents(D){const T=p.BrowserWindow.fromWebContents(D);if(!!T)return this.getWindowById(T.id)}};J.WINDOWS=[],J=fe([te(2,w.ILogService),te(3,U.IStateMainService),te(4,r.IEnvironmentMainService),te(5,h.ILifecycleMainService),te(6,l.IBackupMainService),te(7,o.IConfigurationService),te(8,G.IWorkspacesHistoryMainService),te(9,Q.IWorkspacesManagementMainService),te(10,s.IInstantiationService),te(11,u.IDialogMainService),te(12,i.IFileService),te(13,A.IProductService),te(14,L.IProtocolMainService)],J),e.WindowsMainService=J}),define(x[243],ee([0,1,50,36,68,45]),function(V,e,p,R,C,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WorkspacesMainService=void 0;let n=class{constructor(d,f,y,E){this.workspacesManagementMainService=d,this.windowsMainService=f,this.workspacesHistoryMainService=y,this.backupMainService=E,this.onDidChangeRecentlyOpened=this.workspacesHistoryMainService.onDidChangeRecentlyOpened}async enterWorkspace(d,f){const y=this.windowsMainService.getWindowById(d);if(y)return this.workspacesManagementMainService.enterWorkspace(y,this.windowsMainService.getWindows(),f)}createUntitledWorkspace(d,f,y){return this.workspacesManagementMainService.createUntitledWorkspace(f,y)}deleteUntitledWorkspace(d,f){return this.workspacesManagementMainService.deleteUntitledWorkspace(f)}getWorkspaceIdentifier(d,f){return this.workspacesManagementMainService.getWorkspaceIdentifier(f)}async getRecentlyOpened(d){return this.workspacesHistoryMainService.getRecentlyOpened(this.windowsMainService.getWindowById(d))}async addRecentlyOpened(d,f){return this.workspacesHistoryMainService.addRecentlyOpened(f)}async removeRecentlyOpened(d,f){return this.workspacesHistoryMainService.removeRecentlyOpened(f)}async clearRecentlyOpened(d){return this.workspacesHistoryMainService.clearRecentlyOpened()}async getDirtyWorkspaces(){return this.backupMainService.getDirtyWorkspaces()}};n=fe([te(0,k.IWorkspacesManagementMainService),te(1,R.IWindowsMainService),te(2,C.IWorkspacesHistoryMainService),te(3,p.IBackupMainService)],n),e.WorkspacesMainService=n}),define(x[244],ee([0,1,14,28,26,17,44,16,32,42,38,33,2,10,8,3,15,13,7,31,71,122,35,125,85,235,134,50,226,18,180,162,74,51,225,89,24,53,91,170,188,171,222,90,172,19,183,94,73,5,75,236,201,103,20,6,185,241,52,22,64,231,76,37,219,100,202,29,204,206,65,41,210,233,237,234,238,99,211,212,213,214,216,36,242,217,27,68,243,45]),function(V,e,p,R,C,k,n,I,d,f,y,E,g,S,t,m,v,b,P,c,a,l,o,u,r,i,s,h,w,M,A,L,F,U,Y,ie,re,K,W,N,G,Q,H,$,J,O,D,T,_,z,X,B,q,ne,se,oe,Z,ce,le,ue,me,Ee,de,ge,pe,ke,Re,Fe,$e,ze,Qe,Ge,gt,Je,at,ct,Ve,He,j,ae,he,ve,Ie,Ce,Te,We,Oe,Ne,je,bt){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CodeApplication=void 0;let mt=class extends g.Disposable{constructor(we,ye,be,Se,Pe,De,Me,Le,Ae,Xe){super();this.mainProcessNodeIpcServer=we,this.userEnv=ye,this.mainInstantiationService=be,this.logService=Se,this.environmentMainService=Pe,this.lifecycleMainService=De,this.configurationService=Me,this.stateMainService=Le,this.fileService=Ae,this.productService=Xe,this.configureSession(),this.registerListeners()}configureSession(){const we=Se=>Se?.startsWith(`${S.Schemas.vscodeWebview}://`),ye=new Set(["clipboard-read","clipboard-sanitized-write"]);p.session.defaultSession.setPermissionRequestHandler((Se,Pe,De,Me)=>we(Me.requestingUrl)?De(ye.has(Pe)):De(!1)),p.session.defaultSession.setPermissionCheckHandler((Se,Pe,De,Me)=>we(Me.requestingUrl)?ye.has(Pe):!1);const be=p.session.defaultSession;typeof be.setCodeCachePath=="function"&&this.environmentMainService.codeCachePath&&be.setCodeCachePath((0,t.join)(this.environmentMainService.codeCachePath,"chrome"))}registerListeners(){(0,I.setUnexpectedErrorHandler)(be=>this.onUnexpectedError(be)),process.on("uncaughtException",be=>(0,I.onUnexpectedError)(be)),process.on("unhandledRejection",be=>(0,I.onUnexpectedError)(be)),this.lifecycleMainService.onWillShutdown(()=>this.dispose()),(0,l.registerContextMenuListener)(),p.app.on("accessibility-support-changed",(be,Se)=>{this.windowsMainService?.sendToAll("vscode:accessibilitySupportChanged",Se)}),p.app.on("activate",(be,Se)=>{this.logService.trace("app#activate"),Se||this.windowsMainService?.openEmptyWindow({context:1})}),p.app.on("web-contents-created",(be,Se)=>{Se.on("will-navigate",Pe=>{this.logService.error("webContents#will-navigate: Prevented webcontent navigation"),Pe.preventDefault()}),Se.setWindowOpenHandler(({url:Pe})=>(this.nativeHostMainService?.openExternal(void 0,Pe),{action:"deny"}))});let we=[],ye;p.app.on("open-file",(be,Se)=>{this.logService.trace("app#open-file: ",Se),be.preventDefault(),we.push(this.getWindowOpenableFromPathSync(Se)),ye!==void 0&&(clearTimeout(ye),ye=void 0),ye=setTimeout(()=>{this.windowsMainService?.open({context:1,cli:this.environmentMainService.args,urisToOpen:we,gotoLineMode:!1,preferNewWindow:!0}),we=[],ye=void 0},100)}),p.app.on("new-window-for-tab",()=>{this.windowsMainService?.openEmptyWindow({context:4})}),p.ipcMain.handle("vscode:fetchShellEnv",be=>{const Se=this.windowsMainService?.getWindowByWebContents(be.sender);let Pe,De;return Se?.config?(Pe=Se.config,De={...process.env,...Se.config.userEnv}):(Pe=this.environmentMainService.args,De=process.env),this.resolveShellEnvironment(Pe,De,!1)}),p.ipcMain.handle("vscode:writeNlsFile",(be,Se,Pe)=>{const De=this.validateNlsPath([Se]);if(!De||typeof Pe!="string")throw new Error("Invalid operation (vscode:writeNlsFile)");return this.fileService.writeFile(De,k.VSBuffer.fromString(Pe))}),p.ipcMain.handle("vscode:readNlsFile",async(be,...Se)=>{const Pe=this.validateNlsPath(Se);if(!Pe)throw new Error("Invalid operation (vscode:readNlsFile)");return(await this.fileService.readFile(Pe)).value.toString()}),p.ipcMain.on("vscode:toggleDevTools",be=>be.sender.toggleDevTools()),p.ipcMain.on("vscode:openDevTools",be=>be.sender.openDevTools()),p.ipcMain.on("vscode:reloadWindow",be=>be.sender.reload())}validateNlsPath(we){let ye;for(const be of we)typeof be=="string"&&(typeof ye!="string"?ye=be:ye=(0,t.join)(ye,be));if(!(typeof ye!="string"||!(0,t.isAbsolute)(ye)||!(0,d.isEqualOrParent)(ye,this.environmentMainService.cachedLanguagesPath,!m.isLinux)))return P.URI.file(ye)}onUnexpectedError(we){if(we){const ye={message:`[uncaught exception in main]: ${we.message}`,stack:we.stack};this.windowsMainService?.sendToFocused("vscode:reportError",JSON.stringify(ye))}this.logService.error(`[uncaught exception in main]: ${we}`),we.stack&&this.logService.error(we.stack)}async startup(){this.logService.debug("Starting VS Code"),this.logService.debug(`from: ${this.environmentMainService.appRoot}`),this.logService.debug("args:",this.environmentMainService.args);const we=this.productService.win32AppUserModelId;m.isWindows&&we&&p.app.setAppUserModelId(we);try{m.isMacintosh&&this.configurationService.getValue("window.nativeTabs")===!0&&!p.systemPreferences.getUserDefault("NSUseImprovedLayoutPass","boolean")&&p.systemPreferences.setUserDefault("NSUseImprovedLayoutPass","boolean",!0)}catch(Ae){this.logService.error(Ae)}const ye=new u.Server;this.logService.trace("Resolving machine identifier...");const be=await this.resolveMachineId();this.logService.trace(`Resolved machine identifier: ${be}`);const{sharedProcess:Se,sharedProcessReady:Pe,sharedProcessClient:De}=this.setupSharedProcess(be),Me=await this.initServices(be,Se,Pe);if(this.environmentMainService.driverHandle){const Ae=await(0,Y.serve)(ye,this.environmentMainService.driverHandle,this.environmentMainService,Me);this.logService.info("Driver started at:",this.environmentMainService.driverHandle),this._register(Ae)}this._register(Me.createInstance(i.ProxyAuthHandler)),Me.invokeFunction(Ae=>this.initChannels(Ae,ye,De));const Le=Me.invokeFunction(Ae=>this.openFirstWindow(Ae,ye));Me.invokeFunction(Ae=>this.afterWindowOpen(Ae,Se)),this.environmentMainService.args.trace&&Me.invokeFunction(Ae=>this.stopTracingEventually(Ae,Le))}async resolveMachineId(){let we=this.stateMainService.getItem(Fe.machineIdKey);return(!we||m.isMacintosh&&we==="6c9d2bc8f91b89624add29c0abeae7fb42bf539fa1cdb2e3e57cd668fa9bcead")&&(we=await(0,a.getMachineId)(),this.stateMainService.setItem(Fe.machineIdKey,we)),we}setupSharedProcess(we){const ye=this._register(this.mainInstantiationService.createInstance(Ee.SharedProcess,we,this.userEnv)),be=(async()=>{this.logService.trace("Main->SharedProcess#connect");const Pe=await ye.connect();return this.logService.trace("Main->SharedProcess#connect: connection established"),new r.Client(Pe,"main")})(),Se=(async()=>(await ye.whenReady(),be))();return{sharedProcess:ye,sharedProcessReady:Se,sharedProcessClient:be}}async initServices(we,ye,be){const Se=new X.ServiceCollection;switch(process.platform){case"win32":Se.set(Ge.IUpdateService,new _.SyncDescriptor(Ve.Win32UpdateService));break;case"linux":m.isLinuxSnap?Se.set(Ge.IUpdateService,new _.SyncDescriptor(ct.SnapUpdateService,[process.env.SNAP,process.env.SNAP_REVISION])):Se.set(Ge.IUpdateService,new _.SyncDescriptor(at.LinuxUpdateService));break;case"darwin":Se.set(Ge.IUpdateService,new _.SyncDescriptor(Je.DarwinUpdateService));break}Se.set(Ce.IWindowsMainService,new _.SyncDescriptor(Te.WindowsMainService,[we,this.userEnv])),Se.set(U.IDialogMainService,new _.SyncDescriptor(U.DialogMainService)),Se.set(ne.ILaunchMainService,new _.SyncDescriptor(ne.LaunchMainService)),Se.set(F.IDiagnosticsService,o.ProxyChannel.toService((0,o.getDelayedChannel)(be.then(De=>De.getChannel("diagnostics"))))),Se.set(B.IIssueMainService,new _.SyncDescriptor(B.IssueMainService,[this.userEnv])),Se.set(ie.IEncryptionMainService,new _.SyncDescriptor(ie.EncryptionMainService,[we])),Se.set(q.IKeyboardLayoutMainService,new _.SyncDescriptor(q.KeyboardLayoutMainService)),Se.set(le.INativeHostMainService,new _.SyncDescriptor(le.NativeHostMainService,[ye])),Se.set(ve.IWebviewManagerService,new _.SyncDescriptor(Ie.WebviewMainService)),Se.set(Oe.IWorkspacesService,new _.SyncDescriptor(je.WorkspacesMainService)),Se.set(bt.IWorkspacesManagementMainService,new _.SyncDescriptor(bt.WorkspacesManagementMainService)),Se.set(Ne.IWorkspacesHistoryMainService,new _.SyncDescriptor(Ne.WorkspacesHistoryMainService)),Se.set(ce.IMenubarMainService,new _.SyncDescriptor(ce.MenubarMainService)),Se.set(N.IExtensionUrlTrustService,new _.SyncDescriptor(G.ExtensionUrlTrustService)),Se.set(Q.IExtensionHostStarter,new _.SyncDescriptor(H.WorkerMainProcessExtensionHostStarter)),Se.set(ke.IStorageMainService,new _.SyncDescriptor(ke.StorageMainService)),m.isWindows?Se.set($.IExternalTerminalMainService,new _.SyncDescriptor(J.WindowsExternalTerminalService)):m.isMacintosh?Se.set($.IExternalTerminalMainService,new _.SyncDescriptor(J.MacExternalTerminalService)):m.isLinux&&Se.set($.IExternalTerminalMainService,new _.SyncDescriptor(J.LinuxExternalTerminalService));const Pe=new w.BackupMainService(this.environmentMainService,this.configurationService,this.logService);if(Se.set(h.IBackupMainService,Pe),Se.set(He.IURLService,new _.SyncDescriptor(ae.NativeURLService)),(0,Qe.supportsTelemetry)(this.productService,this.environmentMainService)){const De=(0,o.getDelayedChannel)(be.then(Ze=>Ze.getChannel("telemetryAppender"))),Me=new $e.TelemetryAppenderClient(De),Le=(0,Re.resolveCommonProperties)(this.fileService,(0,C.release)(),(0,C.hostname)(),process.arch,this.productService.commit,this.productService.version,we,this.productService.msftInternalDomains,this.environmentMainService.installSourcePath),Ae=[this.environmentMainService.appRoot,this.environmentMainService.extensionsPath],Xe={appenders:[Me],commonProperties:Le,piiPaths:Ae,sendErrorTelemetry:!0};Se.set(Fe.ITelemetryService,new _.SyncDescriptor(ze.TelemetryService,[Xe]))}else Se.set(Fe.ITelemetryService,Qe.NullTelemetryService);return await Pe.initialize(),this.mainInstantiationService.createChild(Se)}initChannels(we,ye,be){const Se=o.ProxyChannel.fromService(we.get(ne.ILaunchMainService),{disableMarshalling:!0});this.mainProcessNodeIpcServer.registerChannel("launch",Se);const Pe=this.fileService.getProvider(S.Schemas.file);(0,b.assertType)(Pe instanceof T.DiskFileSystemProvider);const De=new D.DiskFileSystemProviderChannel(Pe,this.logService);ye.registerChannel("localFilesystem",De);const Me=new A.UserConfigurationFileService(this.environmentMainService,this.fileService,this.logService);ye.registerChannel(A.UserConfigurationFileServiceId,o.ProxyChannel.fromService(Me)),be.then(Be=>Be.registerChannel(A.UserConfigurationFileServiceId,o.ProxyChannel.fromService(Me)));const Le=new gt.UpdateChannel(we.get(Ge.IUpdateService));ye.registerChannel("update",Le);const Ae=o.ProxyChannel.fromService(we.get(B.IIssueMainService));ye.registerChannel("issue",Ae);const Xe=o.ProxyChannel.fromService(we.get(ie.IEncryptionMainService));ye.registerChannel("encryption",Xe);const Ze=o.ProxyChannel.fromService(we.get(de.ISignService));ye.registerChannel("sign",Ze);const nt=o.ProxyChannel.fromService(we.get(q.IKeyboardLayoutMainService));ye.registerChannel("keyboardLayout",nt),this.nativeHostMainService=we.get(le.INativeHostMainService);const xe=o.ProxyChannel.fromService(this.nativeHostMainService);ye.registerChannel("nativeHost",xe),be.then(Be=>Be.registerChannel("nativeHost",xe));const wt=o.ProxyChannel.fromService(we.get(Oe.IWorkspacesService));ye.registerChannel("workspaces",wt);const Ue=o.ProxyChannel.fromService(we.get(ce.IMenubarMainService));ye.registerChannel("menubar",Ue);const lt=o.ProxyChannel.fromService(we.get(He.IURLService));ye.registerChannel("url",lt);const rt=o.ProxyChannel.fromService(we.get(N.IExtensionUrlTrustService));ye.registerChannel("extensionUrlTrust",rt);const st=o.ProxyChannel.fromService(we.get(ve.IWebviewManagerService));ye.registerChannel("webview",st);const ot=this._register(new pe.StorageDatabaseChannel(this.logService,we.get(ke.IStorageMainService)));ye.registerChannel("storage",ot),be.then(Be=>Be.registerChannel("storage",ot));const ut=o.ProxyChannel.fromService(we.get($.IExternalTerminalMainService));ye.registerChannel("externalTerminal",ut);const et=new Z.LogLevelChannel(we.get(oe.ILogService));ye.registerChannel("logLevel",et),be.then(Be=>Be.registerChannel("logLevel",et));const tt=new Z.LoggerChannel(we.get(oe.ILoggerService));ye.registerChannel("logger",tt),be.then(Be=>Be.registerChannel("logger",tt));const ht=new L.ElectronExtensionHostDebugBroadcastChannel(we.get(Ce.IWindowsMainService));ye.registerChannel("extensionhostdebugservice",ht);const _e=o.ProxyChannel.fromService(we.get(Q.IExtensionHostStarter));ye.registerChannel(Q.ipcExtensionHostStarterChannelName,_e)}openFirstWindow(we,ye){const be=this.windowsMainService=we.get(Ce.IWindowsMainService),Se=we.get(He.IURLService),Pe=we.get(le.INativeHostMainService);this.lifecycleMainService.phase=2;const De=[],Me=[...this.environmentMainService.args["open-url"]?this.environmentMainService.args._urls||[]:[],...global.getOpenUrls()||[]].map(_e=>{try{return{uri:P.URI.parse(_e),url:_e}}catch{return}}).filter(_e=>{if(!_e||this.shouldBlockURI(_e.uri))return!1;const Be=this.getWindowOpenableFromProtocolLink(_e.uri);return Be?(De.push(Be),!1):!0}),Le=this,Ae=this.environmentMainService,Xe=this.productService;Se.registerHandler({async handleURL(_e,Be){if(_e.scheme===Xe.urlProtocol&&_e.path==="workspace"&&(_e=_e.with({authority:"file",path:P.URI.parse(_e.query).path,query:""})),Le.shouldBlockURI(_e))return!0;const Et=Le.getWindowOpenableFromProtocolLink(_e);if(Et){const[pt]=be.open({context:5,cli:{...Ae.args},urisToOpen:[Et],gotoLineMode:!0});return pt.focus(),!0}if(m.isMacintosh&&be.getWindowCount()===0){const[pt]=be.open({context:5,cli:{...Ae.args},forceEmpty:!0,gotoLineMode:!0,remoteAuthority:(0,me.getRemoteAuthority)(_e)});return await pt.ready(),Se.open(_e,Be)}return!1}});const Ze=this._register(new We.ActiveWindowManager({onDidOpenWindow:Pe.onDidOpenWindow,onDidFocusWindow:Pe.onDidFocusWindow,getActiveWindowId:()=>Pe.getActiveWindowId(-1)})),nt=new o.StaticRouter(_e=>Ze.getActiveClientId().then(Be=>_e===Be)),xe=new j.URLHandlerRouter(nt),wt=ye.getChannel("urlHandler",xe);Se.registerHandler(new j.URLHandlerChannelClient(wt)),this._register(new he.ElectronURLListener(Me,Se,be,this.environmentMainService,this.productService));const Ue=this.environmentMainService.args,lt=global.macOpenFiles,rt=(0,K.isLaunchedFromCli)(process.env)?0:4,st=Ue._.length,ot=!!Ue["folder-uri"],ut=!!Ue["file-uri"],et=Ue["skip-add-to-recently-opened"]===!0,tt=Ue.wait&&Ue.waitMarkerFilePath?P.URI.file(Ue.waitMarkerFilePath):void 0,ht=Ue.remote||void 0;return De.length>0?be.open({context:rt,cli:Ue,urisToOpen:De,gotoLineMode:!0,initialStartup:!0}):Ue["new-window"]&&!st&&!ot&&!ut?be.open({context:rt,cli:Ue,forceNewWindow:!0,forceEmpty:!0,noRecentEntry:et,waitMarkerFileURI:tt,initialStartup:!0,remoteAuthority:ht}):lt.length&&!st&&!ot&&!ut?be.open({context:1,cli:Ue,urisToOpen:lt.map(_e=>this.getWindowOpenableFromPathSync(_e)),noRecentEntry:et,waitMarkerFileURI:tt,initialStartup:!0}):be.open({context:rt,cli:Ue,forceNewWindow:Ue["new-window"]||!st&&Ue["unity-launch"],diffMode:Ue.diff,noRecentEntry:et,waitMarkerFileURI:tt,gotoLineMode:Ue.goto,initialStartup:!0,remoteAuthority:ht})}shouldBlockURI(we){return!!(we.authority===S.Schemas.file&&m.isWindows&&p.dialog.showMessageBoxSync({title:this.productService.nameLong,type:"question",buttons:[(0,E.mnemonicButtonLabel)((0,s.localize)(0,null)),(0,E.mnemonicButtonLabel)((0,s.localize)(1,null))],defaultId:0,cancelId:1,message:(0,s.localize)(2,null,(0,E.getPathLabel)(we.fsPath,this.environmentMainService),this.productService.nameShort),detail:(0,s.localize)(3,null),noLink:!0})===1)}getWindowOpenableFromProtocolLink(we){if(!!we.path){if(we.authority===S.Schemas.file){const ye=P.URI.file(we.fsPath);return(0,Oe.hasWorkspaceFileExtension)(ye)?{workspaceUri:ye}:{fileUri:ye}}else if(we.authority===S.Schemas.vscodeRemote){const ye=we.path.indexOf(t.posix.sep,1);if(ye!==-1){const be=we.path.substring(1,ye),Se=we.path.substring(ye),Pe=P.URI.from({scheme:S.Schemas.vscodeRemote,authority:be,path:Se,query:we.query,fragment:we.fragment});return(0,Oe.hasWorkspaceFileExtension)(Se)?{workspaceUri:Pe}:/:[\d]+$/.test(Se)?{fileUri:Pe}:{folderUri:Pe}}}}}getWindowOpenableFromPathSync(we){try{if((0,R.statSync)(we).isDirectory())return{folderUri:P.URI.file(we)};if((0,Oe.hasWorkspaceFileExtension)(we))return{workspaceUri:P.URI.file(we)}}catch(ye){}return{fileUri:P.URI.file(we)}}async afterWindowOpen(we,ye){this.lifecycleMainService.phase=3;let be=!1;(0,f.once)(this.lifecycleMainService.onWillShutdown)(()=>be=!0);const Se=we.get(Fe.ITelemetryService);this._register(ye.onDidError(({type:Me,details:Le})=>{let Ae;switch(Me){case 1:Ae="SharedProcess: detected unresponsive window";break;case 2:Ae=`SharedProcess: crashed (detail: ${Le?.reason??"<unknown>"}, code: ${Le?.exitCode??"<unknown>"})`;break;case 3:Ae=`SharedProcess: failed to load (detail: ${Le?.reason??"<unknown>"}, code: ${Le?.exitCode??"<unknown>"})`;break}(0,I.onUnexpectedError)(new Error(Ae)),Se.publicLog2("sharedprocesserror",{type:Me,reason:Le?.reason,code:Le?.exitCode,visible:ye.isVisible(),shuttingdown:be})}));const Pe=this.productService.win32MutexName;if(m.isWindows&&Pe)try{const Me=V.__$__nodeRequire("windows-mutex").Mutex,Le=new Me(Pe);(0,f.once)(this.lifecycleMainService.onWillShutdown)(()=>Le.release())}catch(Me){this.logService.error(Me)}p.protocol.registerHttpProtocol(S.Schemas.vscodeRemoteResource,(Me,Le)=>{Le({url:Me.url.replace(/^vscode-remote-resource:/,"http:"),method:Me.method})});const De=we.get(Ge.IUpdateService);(De instanceof Ve.Win32UpdateService||De instanceof at.LinuxUpdateService||De instanceof Je.DarwinUpdateService)&&De.initialize(),this.resolveShellEnvironment(this.environmentMainService.args,process.env,!0);try{const Le=(await this.fileService.readFile(this.environmentMainService.argvResource)).value.toString();if(JSON.parse((0,y.stripComments)(Le))["enable-crash-reporter"]===void 0){const Ze=(0,Qe.getTelemetryLevel)(this.configurationService)>=1,nt=["","	// Allows to disable crash reporting.","	// Should restart the app if the value is changed.",`	"enable-crash-reporter": ${Ze},`,"","	// Unique id used for correlating crash reports sent from this instance.","	// Do not edit this value.",`	"crash-reporter-id": "${(0,c.generateUuid)()}"`,"}"],xe=Le.substring(0,Le.length-2).concat(`,
`,nt.join(`
`));await this.fileService.writeFile(this.environmentMainService.argvResource,k.VSBuffer.fromString(xe))}}catch(Me){this.logService.error(Me)}}async resolveShellEnvironment(we,ye,be){try{return await(0,W.getResolvedShellEnv)(this.logService,we,ye)}catch(Se){const Pe=(0,n.toErrorMessage)(Se);be?this.windowsMainService?.sendToFocused("vscode:showResolveShellEnvError",Pe):this.logService.error(Pe)}return{}}stopTracingEventually(we,ye){this.logService.info("Tracing: waiting for windows to get ready...");const be=we.get(U.IDialogMainService);let Se=!1;const Pe=async Me=>{if(Se)return;Se=!0;const Le=await p.contentTracing.stopRecording((0,v.joinPath)(this.environmentMainService.userHome,`${this.productService.applicationName}-${Math.random().toString(16).slice(-4)}.trace.txt`).fsPath);Me?this.logService.info(`Tracing: data recorded (after 30s timeout) to ${Le}`):be.showMessageBox({title:this.productService.nameLong,type:"info",message:(0,s.localize)(4,null),detail:(0,s.localize)(5,null,Le),buttons:[(0,E.mnemonicButtonLabel)((0,s.localize)(6,null))],defaultId:0,noLink:!0},(0,b.withNullAsUndefined)(p.BrowserWindow.getFocusedWindow()))},De=setTimeout(()=>Pe(!0),3e4);Promise.all(ye.map(Me=>Me.ready())).then(()=>{clearTimeout(De),Pe(!1)})}};mt=fe([te(2,z.IInstantiationService),te(3,oe.ILogService),te(4,re.IEnvironmentMainService),te(5,se.ILifecycleMainService),te(6,M.IConfigurationService),te(7,ge.IStateMainService),te(8,O.IFileService),te(9,ue.IProductService)],mt),e.CodeApplication=mt}),define(x[251],ee([0,1,14,28,30,9,44,16,32,42,33,10,8,63,3,34,25,21,35,58,244,11,18,192,203,24,53,165,19,182,94,73,175,75,20,95,6,186,96,55,22,56,189,97,228,49,230,76,200,37,232,65,66,209]),function(V,e,p,R,C,k,n,I,d,f,y,E,g,S,t,m,v,b,P,c,a,l,o,u,r,i,s,h,w,M,A,L,F,U,Y,ie,re,K,W,N,G,Q,H,$,J,O,D,T,_,z,X,B,q){"use strict";Object.defineProperty(e,"__esModule",{value:!0});class ne{main(){try{this.startup()}catch(Z){console.error(Z.message),p.app.exit(1)}}async startup(){(0,I.setUnexpectedErrorHandler)(ge=>console.error(ge));const[Z,ce,le,ue,me,Ee,de]=this.createServices();try{try{await this.initServices(le,ue,me)}catch(ge){throw this.handleStartupDataDirError(le,de.nameLong,ge),ge}await Z.invokeFunction(async ge=>{const pe=ge.get(re.ILogService),ke=ge.get(Y.ILifecycleMainService),Re=ge.get(w.IFileService),Fe=await this.claimInstance(pe,le,ke,Z,de,!0);return b.Promises.writeFile(le.mainLockfile,String(process.pid)).catch($e=>{pe.warn(`Error writing main lockfile: ${$e.stack}`)}),Ee.logger=new W.SpdLogLogger("main",(0,g.join)(le.logsPath,"main.log"),!0,!1,Ee.getLevel()),(0,f.once)(ke.onWillShutdown)($e=>{Re.dispose(),ue.dispose(),$e.join(b.Promises.unlink(le.mainLockfile).catch(()=>{}))}),Z.createInstance(a.CodeApplication,Fe,ce).startup()})}catch(ge){Z.invokeFunction(this.quit,ge)}}createServices(){const Z=new U.ServiceCollection,ce={_serviceBrand:void 0,...N.default};Z.set(G.IProductService,ce);const le=new i.EnvironmentMainService(this.resolveArgs(),ce),ue=this.patchEnvironment(le);Z.set(i.IEnvironmentMainService,le);const me=new ie.BufferLogService,Ee=new re.MultiplexLogService([new re.ConsoleMainLogger((0,re.getLogLevel)(le)),me]);process.once("exit",()=>Ee.dispose()),Z.set(re.ILogService,Ee);const de=new M.FileService(Ee);Z.set(w.IFileService,de);const ge=new A.DiskFileSystemProvider(Ee);de.registerProvider(E.Schemas.file,ge),Z.set(re.ILoggerService,new K.LoggerService(Ee,de));const pe=new u.ConfigurationService(le.settingsResource,de);Z.set(o.IConfigurationService,pe),Z.set(Y.ILifecycleMainService,new L.SyncDescriptor(Y.LifecycleMainService));const ke=new X.StateMainService(le,Ee,de);return Z.set(z.IStateMainService,ke),Z.set(O.IRequestService,new L.SyncDescriptor(D.RequestMainService)),Z.set(q.IThemeMainService,new L.SyncDescriptor(q.ThemeMainService)),Z.set(T.ISignService,new L.SyncDescriptor(_.SignService)),Z.set($.ITunnelService,new L.SyncDescriptor(J.TunnelService)),Z.set(Q.IProtocolMainService,new L.SyncDescriptor(H.ProtocolMainService)),[new F.InstantiationService(Z,!0),ue,le,pe,ke,me,ce]}patchEnvironment(Z){const ce={VSCODE_IPC_HOOK:Z.mainIPCHandle};return["VSCODE_NLS_CONFIG","VSCODE_PORTABLE"].forEach(le=>{const ue=process.env[le];typeof ue=="string"&&(ce[le]=ue)}),Object.assign(process.env,ce),ce}initServices(Z,ce,le){return k.Promises.settled([Promise.all([Z.extensionsPath,Z.codeCachePath,Z.logsPath,Z.globalStorageHome.fsPath,Z.workspaceStorageHome.fsPath,Z.backupHome].map(ue=>ue?b.Promises.mkdir(ue,{recursive:!0}):void 0)),ce.initialize(),le.init()])}async claimInstance(Z,ce,le,ue,me,Ee){let de;try{(0,S.mark)("code/willStartMainServer"),de=await(0,c.serve)(ce.mainIPCHandle),(0,S.mark)("code/didStartMainServer"),(0,f.once)(le.onWillShutdown)(()=>de.dispose())}catch(ge){if(ge.code!=="EADDRINUSE")throw this.handleStartupDataDirError(ce,me.nameLong,ge),ge;let pe;try{pe=await(0,c.connect)(ce.mainIPCHandle,"main")}catch(Fe){if(!Ee||t.isWindows||Fe.code!=="ECONNREFUSED")throw Fe.code==="EPERM"&&this.showStartupWarningDialog((0,l.localize)(0,null,me.nameShort),(0,l.localize)(1,null),me.nameLong),Fe;try{(0,R.unlinkSync)(ce.mainIPCHandle)}catch($e){throw Z.warn("Could not delete obsolete instance handle",$e),$e}return this.claimInstance(Z,ce,le,ue,me,!1)}if(ce.extensionTestsLocationURI&&!ce.debugExtensionHost.break){const Fe="Running extension tests from the command line is currently only supported if no other instance of Code is running.";throw Z.error(Fe),pe.dispose(),new Error(Fe)}let ke;!ce.args.wait&&!ce.args.status&&(ke=setTimeout(()=>{this.showStartupWarningDialog((0,l.localize)(2,null,me.nameShort),(0,l.localize)(3,null),me.nameLong)},1e4));const Re=P.ProxyChannel.toService(pe.getChannel("launch"),{disableMarshalling:!0});if(ce.args.status)return ue.invokeFunction(async()=>{const Fe=new r.DiagnosticsService(B.NullTelemetryService,me),$e=await Re.getMainProcessInfo(),ze=await Re.getRemoteDiagnostics({includeProcesses:!0,includeWorkspaceMetadata:!0}),Qe=await Fe.getDiagnostics($e,ze);throw console.log(Qe),new I.ExpectedError});throw t.isWindows&&await this.windowsAllowSetForegroundWindow(Re,Z),Z.trace("Sending env to running instance..."),await Re.start(ce.args,process.env),pe.dispose(),ke&&clearTimeout(ke),new I.ExpectedError("Sent env to running instance. Terminating...")}if(ce.args.status)throw Z.warn("Warning: The --status argument can only be used if Code is already running. Please run it again after Code has started."),new I.ExpectedError("Terminating...");return process.env.VSCODE_PID=String(process.pid),de}handleStartupDataDirError(Z,ce,le){if(le.code==="EACCES"||le.code==="EPERM"){const ue=(0,C.coalesce)([Z.userDataPath,Z.extensionsPath,c.XDG_RUNTIME_DIR]).map(me=>(0,y.getPathLabel)(me,Z));this.showStartupWarningDialog((0,l.localize)(4,null),(0,l.localize)(5,null,(0,n.toErrorMessage)(le),ue.join(`
`)),ce)}}showStartupWarningDialog(Z,ce,le){p.dialog.showMessageBoxSync({title:le,type:"warning",buttons:[(0,y.mnemonicButtonLabel)((0,l.localize)(6,null))],message:Z,detail:ce,defaultId:0,noLink:!0})}async windowsAllowSetForegroundWindow(Z,ce){if(t.isWindows){const le=await Z.getMainProcessId();ce.trace("Sending some foreground love to the running instance:",le);try{(await new Promise((ue,me)=>{V(["windows-foreground-love"],ue,me)})).allowSetForegroundWindow(le)}catch(ue){ce.error(ue)}}}quit(Z,ce){const le=Z.get(re.ILogService),ue=Z.get(Y.ILifecycleMainService);let me=0;ce&&(ce.isExpected?ce.message&&le.trace(ce.message):(me=1,ce.stack?le.error(ce.stack):le.error(`Startup error: ${ce.toString()}`))),ue.kill(me)}resolveArgs(){const Z=this.validatePaths((0,s.parseMainProcessArgv)(process.argv));if(Z.wait&&!Z.waitMarkerFilePath){const ce=(0,h.createWaitMarkerFile)(Z.verbose);ce&&((0,s.addArg)(process.argv,"--waitMarkerFilePath",ce),Z.waitMarkerFilePath=ce)}return Z}validatePaths(Z){if(Z["open-url"]&&(Z._urls=Z._,Z._=[]),!Z.remote){const ce=this.doValidatePaths(Z._,Z.goto);Z._=ce}return Z}doValidatePaths(Z,ce){const le=(0,m.cwd)(),ue=Z.map(de=>{let ge=String(de),pe;ce&&(pe=(0,d.parseLineAndColumnAware)(ge),ge=pe.path),ge&&(ge=this.preparePath(le,ge));const ke=(0,d.sanitizeFilePath)(ge,le),Re=(0,g.basename)(ke);return Re&&!(0,d.isValidBasename)(Re)?null:ce&&pe?(pe.path=ke,this.toPath(pe)):ke}),me=t.isWindows||t.isMacintosh,Ee=(0,C.distinct)(ue,de=>de&&me?de.toLowerCase():de||"");return(0,C.coalesce)(Ee)}preparePath(Z,ce){return t.isWindows&&(ce=(0,v.rtrim)(ce,'"')),ce=(0,v.trim)((0,v.trim)(ce," "),"	"),t.isWindows&&(ce=(0,g.resolve)(Z,ce),ce=(0,v.rtrim)(ce,".")),ce}toPath(Z){const ce=[Z.path];return typeof Z.line=="number"&&ce.push(String(Z.line)),typeof Z.column=="number"&&ce.push(String(Z.column)),ce.join(":")}}new ne().main()})}).call(this);

//# sourceMappingURL=https://ticino.blob.core.windows.net/sourcemaps/899d46d82c4c95423fb7e10e68eba52050e30ba3/core/vs/code/electron-main/main.js.map
