/*!--------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/(function(){var J=["require","exports","vs/base/common/lifecycle","vs/base/common/async","vs/nls","vs/nls!vs/code/node/cliProcessMain","vs/base/common/path","vs/base/common/errors","vs/base/common/types","vs/base/common/uri","vs/base/common/network","vs/base/common/event","vs/base/common/platform","vs/base/node/pfs","vs/platform/instantiation/common/instantiation","vs/platform/log/common/log","vs/platform/files/common/files","vs/base/common/buffer","vs/base/common/resources","vs/base/common/arrays","vs/platform/environment/common/environment","vs/base/common/objects","vs/platform/extensionManagement/common/extensionManagement","vs/platform/extensionManagement/common/extensionManagementUtil","vs/base/common/cancellation","vs/platform/configuration/common/configuration","vs/base/common/strings","vs/base/common/errorMessage","vs/base/common/process","vs/platform/registry/common/platform","vs/platform/telemetry/common/telemetry","vs/base/common/uuid","vs/platform/product/common/productService","os","vs/platform/files/common/watcher","vs/platform/configuration/common/configurationRegistry","vs/platform/telemetry/common/telemetryUtils","vs/platform/uriIdentity/common/uriIdentity","vs/base/common/stream","vs/base/parts/ipc/common/ipc","child_process","vs/platform/instantiation/common/descriptors","vs/platform/extensions/common/extensions","vs/base/common/semver/semver","vs/platform/request/common/request","vs/base/node/zip","vs/base/common/decorators","vs/base/common/extpath","fs","vs/base/node/processes","vs/base/parts/ipc/node/ipc.cp","vs/platform/extensions/common/extensionValidator","vs/platform/download/common/download","vs/platform/files/common/io","vs/platform/instantiation/common/serviceCollection","vs/platform/localizations/common/localizations","vs/base/common/assert","vs/base/common/json","vs/base/common/processes","vs/base/common/skipList","vs/base/common/console","vs/base/common/marshalling","vs/base/common/labels","vs/base/node/decoder","vs/base/node/extpath","vs/base/node/powershell","vs/base/parts/storage/common/storage","vs/nls!vs/base/common/date","vs/base/common/date","vs/nls!vs/base/common/errorMessage","vs/nls!vs/base/node/processes","vs/base/node/shell","vs/nls!vs/base/node/zip","vs/nls!vs/platform/configuration/common/configurationRegistry","vs/nls!vs/platform/environment/node/shellEnv","vs/nls!vs/platform/extensionManagement/common/abstractExtensionManagementService","vs/nls!vs/platform/extensionManagement/common/extensionManagement","vs/nls!vs/platform/extensionManagement/common/extensionManagementCLIService","vs/nls!vs/platform/extensionManagement/node/extensionManagementService","vs/nls!vs/platform/extensionManagement/node/extensionManagementUtil","vs/nls!vs/platform/extensionManagement/node/extensionsScanner","vs/nls!vs/platform/extensions/common/extensionValidator","vs/nls!vs/platform/files/common/fileService","vs/nls!vs/platform/files/common/io","vs/nls!vs/platform/files/node/diskFileSystemProvider","vs/nls!vs/platform/request/common/request","vs/nls!vs/platform/telemetry/common/telemetryService","vs/platform/environment/common/environmentService","vs/platform/environment/node/userDataPath","vs/platform/environment/node/environmentService","vs/platform/extensionManagement/common/extensionNls","vs/platform/instantiation/common/extensions","vs/platform/instantiation/common/graph","vs/platform/environment/node/shellEnv","vs/platform/files/node/watcher/nodejs/watcherService","vs/platform/files/node/watcher/nsfw/watcherService","vs/platform/files/node/watcher/parcel/watcherService","vs/platform/instantiation/common/instantiationService","vs/platform/extensionManagement/node/extensionLifecycle","vs/platform/files/common/diskFileSystemProvider","vs/platform/files/common/fileService","vs/base/common/map","vs/base/common/performance","vs/platform/files/node/diskFileSystemProvider","vs/platform/log/node/spdlogLog","vs/platform/jsonschemas/common/jsonContributionRegistry","vs/platform/configuration/common/configurationModels","vs/platform/configuration/common/configurationService","vs/platform/remote/common/remoteHosts","vs/platform/extensionManagement/common/extensionManagementCLIService","vs/platform/extensionManagement/node/extensionDownloader","vs/platform/extensionManagement/node/extensionsManifestCache","vs/platform/localizations/node/localizations","vs/platform/download/common/downloadService","vs/platform/request/node/proxy","url","vs/platform/serviceMachineId/common/serviceMachineId","vs/platform/storage/common/storage","vs/platform/telemetry/common/commonProperties","vs/platform/extensionManagement/common/abstractExtensionManagementService","vs/platform/extensionManagement/common/extensionGalleryService","vs/platform/telemetry/common/telemetryService","vs/platform/product/common/product","vs/platform/telemetry/node/appInsightsAppender","vs/platform/telemetry/node/telemetry","vs/platform/extensionManagement/node/extensionsWatcher","vs/platform/uriIdentity/common/uriIdentityService","vs/platform/extensionManagement/node/extensionManagementUtil","vs/platform/extensionManagement/node/extensionsScanner","vs/platform/extensionManagement/node/extensionManagementService","vs/platform/request/node/requestService","string_decoder","path","vs/platform/environment/node/argvHelper","vs/base/node/watcher","vs/base/common/iterator","graceful-fs","crypto","yauzl","yazl","zlib","vs/code/node/cliProcessMain"],Q=function(x){for(var i=[],T=0,P=x.length;T<P;T++)i[T]=J[x[T]];return i};define(J[56],Q([0,1]),function(x,i){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.ok=void 0;function T(P,b){if(!P)throw new Error(b?`Assertion failed (${b})`:"Assertion Failed")}i.ok=T}),define(J[46],Q([0,1]),function(x,i){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.throttle=i.debounce=i.memoize=i.createDecorator=void 0;function T(D){return(w,l,p)=>{let y=null,C=null;if(typeof p.value=="function"?(y="value",C=p.value):typeof p.get=="function"&&(y="get",C=p.get),!C)throw new Error("not supported");p[y]=D(C,l)}}i.createDecorator=T;function P(D,w,l){let p=null,y=null;if(typeof l.value=="function"?(p="value",y=l.value,y.length!==0&&console.warn("Memoize should only be used in functions with zero parameters")):typeof l.get=="function"&&(p="get",y=l.get),!y)throw new Error("not supported");const C=`$memoize$${w}`;l[p]=function(...c){return this.hasOwnProperty(C)||Object.defineProperty(this,C,{configurable:!1,enumerable:!1,writable:!1,value:y.apply(this,c)}),this[C]}}i.memoize=P;function b(D,w,l){return T((p,y)=>{const C=`$debounce$${y}`,c=`$debounce$result$${y}`;return function(...E){this[c]||(this[c]=l?l():void 0),clearTimeout(this[C]),w&&(this[c]=w(this[c],...E),E=[this[c]]),this[C]=setTimeout(()=>{p.apply(this,E),this[c]=l?l():void 0},D)}})}i.debounce=b;function R(D,w,l){return T((p,y)=>{const C=`$throttle$timer$${y}`,c=`$throttle$result$${y}`,E=`$throttle$lastRun$${y}`,u=`$throttle$pending$${y}`;return function(...h){if(this[c]||(this[c]=l?l():void 0),(this[E]===null||this[E]===void 0)&&(this[E]=-Number.MAX_VALUE),w&&(this[c]=w(this[c],...h)),this[u])return;const g=this[E]+D;g<=Date.now()?(this[E]=Date.now(),p.apply(this,[this[c]]),this[c]=l?l():void 0):(this[u]=!0,this[C]=setTimeout(()=>{this[u]=!1,this[E]=Date.now(),p.apply(this,[this[c]]),this[c]=l?l():void 0},g-Date.now()))}})}i.throttle=R}),define(J[57],Q([0,1]),function(x,i){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.getNodeType=i.stripComments=i.visit=i.findNodeAtOffset=i.contains=i.getNodeValue=i.getNodePath=i.findNodeAtLocation=i.parseTree=i.parse=i.getLocation=i.createScanner=i.ParseOptions=i.ParseErrorCode=i.SyntaxKind=i.ScanError=void 0;var T;(function(n){n[n.None=0]="None",n[n.UnexpectedEndOfComment=1]="UnexpectedEndOfComment",n[n.UnexpectedEndOfString=2]="UnexpectedEndOfString",n[n.UnexpectedEndOfNumber=3]="UnexpectedEndOfNumber",n[n.InvalidUnicode=4]="InvalidUnicode",n[n.InvalidEscapeCharacter=5]="InvalidEscapeCharacter",n[n.InvalidCharacter=6]="InvalidCharacter"})(T=i.ScanError||(i.ScanError={}));var P;(function(n){n[n.OpenBraceToken=1]="OpenBraceToken",n[n.CloseBraceToken=2]="CloseBraceToken",n[n.OpenBracketToken=3]="OpenBracketToken",n[n.CloseBracketToken=4]="CloseBracketToken",n[n.CommaToken=5]="CommaToken",n[n.ColonToken=6]="ColonToken",n[n.NullKeyword=7]="NullKeyword",n[n.TrueKeyword=8]="TrueKeyword",n[n.FalseKeyword=9]="FalseKeyword",n[n.StringLiteral=10]="StringLiteral",n[n.NumericLiteral=11]="NumericLiteral",n[n.LineCommentTrivia=12]="LineCommentTrivia",n[n.BlockCommentTrivia=13]="BlockCommentTrivia",n[n.LineBreakTrivia=14]="LineBreakTrivia",n[n.Trivia=15]="Trivia",n[n.Unknown=16]="Unknown",n[n.EOF=17]="EOF"})(P=i.SyntaxKind||(i.SyntaxKind={}));var b;(function(n){n[n.InvalidSymbol=1]="InvalidSymbol",n[n.InvalidNumberFormat=2]="InvalidNumberFormat",n[n.PropertyNameExpected=3]="PropertyNameExpected",n[n.ValueExpected=4]="ValueExpected",n[n.ColonExpected=5]="ColonExpected",n[n.CommaExpected=6]="CommaExpected",n[n.CloseBraceExpected=7]="CloseBraceExpected",n[n.CloseBracketExpected=8]="CloseBracketExpected",n[n.EndOfFileExpected=9]="EndOfFileExpected",n[n.InvalidCommentToken=10]="InvalidCommentToken",n[n.UnexpectedEndOfComment=11]="UnexpectedEndOfComment",n[n.UnexpectedEndOfString=12]="UnexpectedEndOfString",n[n.UnexpectedEndOfNumber=13]="UnexpectedEndOfNumber",n[n.InvalidUnicode=14]="InvalidUnicode",n[n.InvalidEscapeCharacter=15]="InvalidEscapeCharacter",n[n.InvalidCharacter=16]="InvalidCharacter"})(b=i.ParseErrorCode||(i.ParseErrorCode={}));var R;(function(n){n.DEFAULT={allowTrailingComma:!0}})(R=i.ParseOptions||(i.ParseOptions={}));function D(n,r=!1){let e=0,t=n.length,s="",f=0,v=16,L=0;function I(te){let he=0,W=0;for(;he<te;){const B=n.charCodeAt(e);if(B>=48&&B<=57)W=W*16+B-48;else if(B>=65&&B<=70)W=W*16+B-65+10;else if(B>=97&&B<=102)W=W*16+B-97+10;else break;e++,he++}return he<te&&(W=-1),W}function O(te){e=te,s="",f=0,v=16,L=0}function N(){const te=e;if(n.charCodeAt(e)===48)e++;else for(e++;e<n.length&&p(n.charCodeAt(e));)e++;if(e<n.length&&n.charCodeAt(e)===46)if(e++,e<n.length&&p(n.charCodeAt(e)))for(e++;e<n.length&&p(n.charCodeAt(e));)e++;else return L=3,n.substring(te,e);let he=e;if(e<n.length&&(n.charCodeAt(e)===69||n.charCodeAt(e)===101))if(e++,(e<n.length&&n.charCodeAt(e)===43||n.charCodeAt(e)===45)&&e++,e<n.length&&p(n.charCodeAt(e))){for(e++;e<n.length&&p(n.charCodeAt(e));)e++;he=e}else L=3;return n.substring(te,he)}function G(){let te="",he=e;for(;;){if(e>=t){te+=n.substring(he,e),L=2;break}const W=n.charCodeAt(e);if(W===34){te+=n.substring(he,e),e++;break}if(W===92){if(te+=n.substring(he,e),e++,e>=t){L=2;break}switch(n.charCodeAt(e++)){case 34:te+='"';break;case 92:te+="\\";break;case 47:te+="/";break;case 98:te+="\b";break;case 102:te+="\f";break;case 110:te+=`
`;break;case 114:te+="\r";break;case 116:te+="	";break;case 117:const ne=I(4);ne>=0?te+=String.fromCharCode(ne):L=4;break;default:L=5}he=e;continue}if(W>=0&&W<=31)if(l(W)){te+=n.substring(he,e),L=2;break}else L=6;e++}return te}function ee(){if(s="",L=0,f=e,e>=t)return f=t,v=17;let te=n.charCodeAt(e);if(w(te)){do e++,s+=String.fromCharCode(te),te=n.charCodeAt(e);while(w(te));return v=15}if(l(te))return e++,s+=String.fromCharCode(te),te===13&&n.charCodeAt(e)===10&&(e++,s+=`
`),v=14;switch(te){case 123:return e++,v=1;case 125:return e++,v=2;case 91:return e++,v=3;case 93:return e++,v=4;case 58:return e++,v=6;case 44:return e++,v=5;case 34:return e++,s=G(),v=10;case 47:const he=e-1;if(n.charCodeAt(e+1)===47){for(e+=2;e<t&&!l(n.charCodeAt(e));)e++;return s=n.substring(he,e),v=12}if(n.charCodeAt(e+1)===42){e+=2;const W=t-1;let B=!1;for(;e<W;){if(n.charCodeAt(e)===42&&n.charCodeAt(e+1)===47){e+=2,B=!0;break}e++}return B||(e++,L=1),s=n.substring(he,e),v=13}return s+=String.fromCharCode(te),e++,v=16;case 45:if(s+=String.fromCharCode(te),e++,e===t||!p(n.charCodeAt(e)))return v=16;case 48:case 49:case 50:case 51:case 52:case 53:case 54:case 55:case 56:case 57:return s+=N(),v=11;default:for(;e<t&&ge(te);)e++,te=n.charCodeAt(e);if(f!==e){switch(s=n.substring(f,e),s){case"true":return v=8;case"false":return v=9;case"null":return v=7}return v=16}return s+=String.fromCharCode(te),e++,v=16}}function ge(te){if(w(te)||l(te))return!1;switch(te){case 125:case 93:case 123:case 91:case 34:case 58:case 44:case 47:return!1}return!0}function ce(){let te;do te=ee();while(te>=12&&te<=15);return te}return{setPosition:O,getPosition:()=>e,scan:r?ce:ee,getToken:()=>v,getTokenValue:()=>s,getTokenOffset:()=>f,getTokenLength:()=>e-f,getTokenError:()=>L}}i.createScanner=D;function w(n){return n===32||n===9||n===11||n===12||n===160||n===5760||n>=8192&&n<=8203||n===8239||n===8287||n===12288||n===65279}function l(n){return n===10||n===13||n===8232||n===8233}function p(n){return n>=48&&n<=57}var y;(function(n){n[n.nullCharacter=0]="nullCharacter",n[n.maxAsciiCharacter=127]="maxAsciiCharacter",n[n.lineFeed=10]="lineFeed",n[n.carriageReturn=13]="carriageReturn",n[n.lineSeparator=8232]="lineSeparator",n[n.paragraphSeparator=8233]="paragraphSeparator",n[n.nextLine=133]="nextLine",n[n.space=32]="space",n[n.nonBreakingSpace=160]="nonBreakingSpace",n[n.enQuad=8192]="enQuad",n[n.emQuad=8193]="emQuad",n[n.enSpace=8194]="enSpace",n[n.emSpace=8195]="emSpace",n[n.threePerEmSpace=8196]="threePerEmSpace",n[n.fourPerEmSpace=8197]="fourPerEmSpace",n[n.sixPerEmSpace=8198]="sixPerEmSpace",n[n.figureSpace=8199]="figureSpace",n[n.punctuationSpace=8200]="punctuationSpace",n[n.thinSpace=8201]="thinSpace",n[n.hairSpace=8202]="hairSpace",n[n.zeroWidthSpace=8203]="zeroWidthSpace",n[n.narrowNoBreakSpace=8239]="narrowNoBreakSpace",n[n.ideographicSpace=12288]="ideographicSpace",n[n.mathematicalSpace=8287]="mathematicalSpace",n[n.ogham=5760]="ogham",n[n._=95]="_",n[n.$=36]="$",n[n._0=48]="_0",n[n._1=49]="_1",n[n._2=50]="_2",n[n._3=51]="_3",n[n._4=52]="_4",n[n._5=53]="_5",n[n._6=54]="_6",n[n._7=55]="_7",n[n._8=56]="_8",n[n._9=57]="_9",n[n.a=97]="a",n[n.b=98]="b",n[n.c=99]="c",n[n.d=100]="d",n[n.e=101]="e",n[n.f=102]="f",n[n.g=103]="g",n[n.h=104]="h",n[n.i=105]="i",n[n.j=106]="j",n[n.k=107]="k",n[n.l=108]="l",n[n.m=109]="m",n[n.n=110]="n",n[n.o=111]="o",n[n.p=112]="p",n[n.q=113]="q",n[n.r=114]="r",n[n.s=115]="s",n[n.t=116]="t",n[n.u=117]="u",n[n.v=118]="v",n[n.w=119]="w",n[n.x=120]="x",n[n.y=121]="y",n[n.z=122]="z",n[n.A=65]="A",n[n.B=66]="B",n[n.C=67]="C",n[n.D=68]="D",n[n.E=69]="E",n[n.F=70]="F",n[n.G=71]="G",n[n.H=72]="H",n[n.I=73]="I",n[n.J=74]="J",n[n.K=75]="K",n[n.L=76]="L",n[n.M=77]="M",n[n.N=78]="N",n[n.O=79]="O",n[n.P=80]="P",n[n.Q=81]="Q",n[n.R=82]="R",n[n.S=83]="S",n[n.T=84]="T",n[n.U=85]="U",n[n.V=86]="V",n[n.W=87]="W",n[n.X=88]="X",n[n.Y=89]="Y",n[n.Z=90]="Z",n[n.ampersand=38]="ampersand",n[n.asterisk=42]="asterisk",n[n.at=64]="at",n[n.backslash=92]="backslash",n[n.bar=124]="bar",n[n.caret=94]="caret",n[n.closeBrace=125]="closeBrace",n[n.closeBracket=93]="closeBracket",n[n.closeParen=41]="closeParen",n[n.colon=58]="colon",n[n.comma=44]="comma",n[n.dot=46]="dot",n[n.doubleQuote=34]="doubleQuote",n[n.equals=61]="equals",n[n.exclamation=33]="exclamation",n[n.greaterThan=62]="greaterThan",n[n.lessThan=60]="lessThan",n[n.minus=45]="minus",n[n.openBrace=123]="openBrace",n[n.openBracket=91]="openBracket",n[n.openParen=40]="openParen",n[n.percent=37]="percent",n[n.plus=43]="plus",n[n.question=63]="question",n[n.semicolon=59]="semicolon",n[n.singleQuote=39]="singleQuote",n[n.slash=47]="slash",n[n.tilde=126]="tilde",n[n.backspace=8]="backspace",n[n.formFeed=12]="formFeed",n[n.byteOrderMark=65279]="byteOrderMark",n[n.tab=9]="tab",n[n.verticalTab=11]="verticalTab"})(y||(y={}));function C(n,r){const e=[],t=new Object;let s;const f={value:{},offset:0,length:0,type:"object",parent:void 0};let v=!1;function L(I,O,N,G){f.value=I,f.offset=O,f.length=N,f.type=G,f.colonOffset=void 0,s=f}try{d(n,{onObjectBegin:(I,O)=>{if(r<=I)throw t;s=void 0,v=r>I,e.push("")},onObjectProperty:(I,O,N)=>{if(r<O||(L(I,O,N,"property"),e[e.length-1]=I,r<=O+N))throw t},onObjectEnd:(I,O)=>{if(r<=I)throw t;s=void 0,e.pop()},onArrayBegin:(I,O)=>{if(r<=I)throw t;s=void 0,e.push(0)},onArrayEnd:(I,O)=>{if(r<=I)throw t;s=void 0,e.pop()},onLiteralValue:(I,O,N)=>{if(r<O||(L(I,O,N,a(I)),r<=O+N))throw t},onSeparator:(I,O,N)=>{if(r<=O)throw t;if(I===":"&&s&&s.type==="property")s.colonOffset=O,v=!1,s=void 0;else if(I===","){const G=e[e.length-1];typeof G=="number"?e[e.length-1]=G+1:(v=!0,e[e.length-1]=""),s=void 0}}})}catch(I){if(I!==t)throw I}return{path:e,previousNode:s,isAtPropertyKey:v,matches:I=>{let O=0;for(let N=0;O<I.length&&N<e.length;N++)if(I[O]===e[N]||I[O]==="*")O++;else if(I[O]!=="**")return!1;return O===I.length}}}i.getLocation=C;function c(n,r=[],e=R.DEFAULT){let t=null,s=[];const f=[];function v(I){Array.isArray(s)?s.push(I):t!==null&&(s[t]=I)}return d(n,{onObjectBegin:()=>{const I={};v(I),f.push(s),s=I,t=null},onObjectProperty:I=>{t=I},onObjectEnd:()=>{s=f.pop()},onArrayBegin:()=>{const I=[];v(I),f.push(s),s=I,t=null},onArrayEnd:()=>{s=f.pop()},onLiteralValue:v,onError:(I,O,N)=>{r.push({error:I,offset:O,length:N})}},e),s[0]}i.parse=c;function E(n,r=[],e=R.DEFAULT){let t={type:"array",offset:-1,length:-1,children:[],parent:void 0};function s(I){t.type==="property"&&(t.length=I-t.offset,t=t.parent)}function f(I){return t.children.push(I),I}d(n,{onObjectBegin:I=>{t=f({type:"object",offset:I,length:-1,parent:t,children:[]})},onObjectProperty:(I,O,N)=>{t=f({type:"property",offset:O,length:-1,parent:t,children:[]}),t.children.push({type:"string",value:I,offset:O,length:N,parent:t})},onObjectEnd:(I,O)=>{t.length=I+O-t.offset,t=t.parent,s(I+O)},onArrayBegin:(I,O)=>{t=f({type:"array",offset:I,length:-1,parent:t,children:[]})},onArrayEnd:(I,O)=>{t.length=I+O-t.offset,t=t.parent,s(I+O)},onLiteralValue:(I,O,N)=>{f({type:a(I),offset:O,length:N,parent:t,value:I}),s(O+N)},onSeparator:(I,O,N)=>{t.type==="property"&&(I===":"?t.colonOffset=O:I===","&&s(O))},onError:(I,O,N)=>{r.push({error:I,offset:O,length:N})}},e);const L=t.children[0];return L&&delete L.parent,L}i.parseTree=E;function u(n,r){if(!n)return;let e=n;for(let t of r)if(typeof t=="string"){if(e.type!=="object"||!Array.isArray(e.children))return;let s=!1;for(const f of e.children)if(Array.isArray(f.children)&&f.children[0].value===t){e=f.children[1],s=!0;break}if(!s)return}else{const s=t;if(e.type!=="array"||s<0||!Array.isArray(e.children)||s>=e.children.length)return;e=e.children[s]}return e}i.findNodeAtLocation=u;function h(n){if(!n.parent||!n.parent.children)return[];const r=h(n.parent);if(n.parent.type==="property"){const e=n.parent.children[0].value;r.push(e)}else if(n.parent.type==="array"){const e=n.parent.children.indexOf(n);e!==-1&&r.push(e)}return r}i.getNodePath=h;function g(n){switch(n.type){case"array":return n.children.map(g);case"object":const r=Object.create(null);for(let e of n.children){const t=e.children[1];t&&(r[e.children[0].value]=g(t))}return r;case"null":case"string":case"number":case"boolean":return n.value;default:return}}i.getNodeValue=g;function m(n,r,e=!1){return r>=n.offset&&r<n.offset+n.length||e&&r===n.offset+n.length}i.contains=m;function S(n,r,e=!1){if(m(n,r,e)){const t=n.children;if(Array.isArray(t))for(let s=0;s<t.length&&t[s].offset<=r;s++){const f=S(t[s],r,e);if(f)return f}return n}}i.findNodeAtOffset=S;function d(n,r,e=R.DEFAULT){const t=D(n,!1);function s(K){return K?()=>K(t.getTokenOffset(),t.getTokenLength()):()=>!0}function f(K){return K?Z=>K(Z,t.getTokenOffset(),t.getTokenLength()):()=>!0}const v=s(r.onObjectBegin),L=f(r.onObjectProperty),I=s(r.onObjectEnd),O=s(r.onArrayBegin),N=s(r.onArrayEnd),G=f(r.onLiteralValue),ee=f(r.onSeparator),ge=s(r.onComment),ce=f(r.onError),te=e&&e.disallowComments,he=e&&e.allowTrailingComma;function W(){for(;;){const K=t.scan();switch(t.getTokenError()){case 4:B(14);break;case 5:B(15);break;case 3:B(13);break;case 1:te||B(11);break;case 2:B(12);break;case 6:B(16);break}switch(K){case 12:case 13:te?B(10):ge();break;case 16:B(1);break;case 15:case 14:break;default:return K}}}function B(K,Z=[],_=[]){if(ce(K),Z.length+_.length>0){let ue=t.getToken();for(;ue!==17;){if(Z.indexOf(ue)!==-1){W();break}else if(_.indexOf(ue)!==-1)break;ue=W()}}}function ne(K){const Z=t.getTokenValue();return K?G(Z):L(Z),W(),!0}function M(){switch(t.getToken()){case 11:let K=0;try{K=JSON.parse(t.getTokenValue()),typeof K!="number"&&(B(2),K=0)}catch(Z){B(2)}G(K);break;case 7:G(null);break;case 8:G(!0);break;case 9:G(!1);break;default:return!1}return W(),!0}function k(){return t.getToken()!==10?(B(3,[],[2,5]),!1):(ne(!1),t.getToken()===6?(ee(":"),W(),ie()||B(4,[],[2,5])):B(5,[],[2,5]),!0)}function j(){v(),W();let K=!1;for(;t.getToken()!==2&&t.getToken()!==17;){if(t.getToken()===5){if(K||B(4,[],[]),ee(","),W(),t.getToken()===2&&he)break}else K&&B(6,[],[]);k()||B(4,[],[2,5]),K=!0}return I(),t.getToken()!==2?B(7,[2],[]):W(),!0}function H(){O(),W();let K=!1;for(;t.getToken()!==4&&t.getToken()!==17;){if(t.getToken()===5){if(K||B(4,[],[]),ee(","),W(),t.getToken()===4&&he)break}else K&&B(6,[],[]);ie()||B(4,[],[4,5]),K=!0}return N(),t.getToken()!==4?B(8,[4],[]):W(),!0}function ie(){switch(t.getToken()){case 3:return H();case 1:return j();case 10:return ne(!0);default:return M()}}return W(),t.getToken()===17?e.allowEmptyContent?!0:(B(4,[],[]),!1):ie()?(t.getToken()!==17&&B(9,[],[]),!0):(B(4,[],[]),!1)}i.visit=d;function o(n,r){let e=D(n),t=[],s,f=0,v;do switch(v=e.getPosition(),s=e.scan(),s){case 12:case 13:case 17:f!==v&&t.push(n.substring(f,v)),r!==void 0&&t.push(e.getTokenValue().replace(/[^\r\n]/g,r)),f=e.getPosition();break}while(s!==17);return t.join("")}i.stripComments=o;function a(n){switch(typeof n){case"boolean":return"boolean";case"number":return"number";case"string":return"string";case"object":{if(n){if(Array.isArray(n))return"array"}else return"null";return"object"}default:return"null"}}i.getNodeType=a}),function(){function x(b){const R=[];typeof b=="number"&&R.push("code/timeOrigin",b);function D(l){R.push(l,Date.now())}function w(){const l=[];for(let p=0;p<R.length;p+=2)l.push({name:R[p],startTime:R[p+1]});return l}return{mark:D,getMarks:w}}function i(){if(typeof performance=="object"&&typeof performance.mark=="function"&&!performance.nodeTiming)return typeof performance.timeOrigin!="number"&&!performance.timing?x():{mark(b){performance.mark(b)},getMarks(){let b=performance.timeOrigin;typeof b!="number"&&(b=performance.timing.navigationStart||performance.timing.redirectStart||performance.timing.fetchStart);const R=[{name:"code/timeOrigin",startTime:Math.round(b)}];for(const D of performance.getEntriesByType("mark"))R.push({name:D.name,startTime:Math.round(b+D.startTime)});return R}};if(typeof process=="object"){const b=Math.round((require.nodeRequire||require)("perf_hooks").performance.timeOrigin);return x(b)}else return console.trace("perf-util loaded in UNKNOWN environment"),x()}function T(b){return b.MonacoPerformanceMarks||(b.MonacoPerformanceMarks=i()),b.MonacoPerformanceMarks}var P;typeof global=="object"?P=global:typeof self=="object"?P=self:P={},typeof define=="function"?define("vs/base/common/performance",[],function(){return T(P)}):typeof module=="object"&&typeof module.exports=="object"?module.exports=T(P):(console.trace("perf-util defined in UNKNOWN context (neither requirejs or commonjs)"),P.perf=T(P))}(),define(J[58],Q([0,1]),function(x,i){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.sanitizeProcessEnvironment=i.TerminateResponseCode=i.Source=void 0;var T;(function(R){R[R.stdout=0]="stdout",R[R.stderr=1]="stderr"})(T=i.Source||(i.Source={}));var P;(function(R){R[R.Success=0]="Success",R[R.Unknown=1]="Unknown",R[R.AccessDenied=2]="AccessDenied",R[R.ProcessNotFound=3]="ProcessNotFound"})(P=i.TerminateResponseCode||(i.TerminateResponseCode={}));function b(R,...D){const w=D.reduce((y,C)=>(y[C]=!0,y),{}),l=[/^ELECTRON_.+$/,/^VSCODE_.+$/,/^SNAP(|_.*)$/,/^GDK_PIXBUF_.+$/];Object.keys(R).filter(y=>!w[y]).forEach(y=>{for(let C=0;C<l.length;C++)if(y.search(l[C])!==-1){delete R[y];break}})}i.sanitizeProcessEnvironment=b}),function(x,i){if(typeof exports=="object"&&typeof module=="object")module.exports=i();else if(typeof define=="function"&&define.amd)define("vs/base/common/semver/semver",[],i);else{var T=i();for(var P in T)(typeof exports=="object"?exports:x)[P]=T[P]}}(typeof self!="undefined"?self:this,function(){return function(x){var i={};function T(P){if(i[P])return i[P].exports;var b=i[P]={i:P,l:!1,exports:{}};return x[P].call(b.exports,b,b.exports,T),b.l=!0,b.exports}return T.m=x,T.c=i,T.d=function(P,b,R){T.o(P,b)||Object.defineProperty(P,b,{enumerable:!0,get:R})},T.r=function(P){typeof Symbol!="undefined"&&Symbol.toStringTag&&Object.defineProperty(P,Symbol.toStringTag,{value:"Module"}),Object.defineProperty(P,"__esModule",{value:!0})},T.t=function(P,b){if(1&b&&(P=T(P)),8&b||4&b&&typeof P=="object"&&P&&P.__esModule)return P;var R=Object.create(null);if(T.r(R),Object.defineProperty(R,"default",{enumerable:!0,value:P}),2&b&&typeof P!="string")for(var D in P)T.d(R,D,function(w){return P[w]}.bind(null,D));return R},T.n=function(P){var b=P&&P.__esModule?function(){return P.default}:function(){return P};return T.d(b,"a",b),b},T.o=function(P,b){return Object.prototype.hasOwnProperty.call(P,b)},T.p="",T(T.s=0)}([function(x,i,T){(function(P){var b;i=x.exports=_,b=typeof P=="object"&&P.env&&P.env.NODE_DEBUG&&/\bsemver\b/i.test(P.env.NODE_DEBUG)?function(){var F=Array.prototype.slice.call(arguments,0);F.unshift("SEMVER"),console.log.apply(console,F)}:function(){},i.SEMVER_SPEC_VERSION="2.0.0";var R=256,D=Number.MAX_SAFE_INTEGER||9007199254740991,w=i.re=[],l=i.src=[],p=0,y=p++;l[y]="0|[1-9]\\d*";var C=p++;l[C]="[0-9]+";var c=p++;l[c]="\\d*[a-zA-Z-][a-zA-Z0-9-]*";var E=p++;l[E]="("+l[y]+")\\.("+l[y]+")\\.("+l[y]+")";var u=p++;l[u]="("+l[C]+")\\.("+l[C]+")\\.("+l[C]+")";var h=p++;l[h]="(?:"+l[y]+"|"+l[c]+")";var g=p++;l[g]="(?:"+l[C]+"|"+l[c]+")";var m=p++;l[m]="(?:-("+l[h]+"(?:\\."+l[h]+")*))";var S=p++;l[S]="(?:-?("+l[g]+"(?:\\."+l[g]+")*))";var d=p++;l[d]="[0-9A-Za-z-]+";var o=p++;l[o]="(?:\\+("+l[d]+"(?:\\."+l[d]+")*))";var a=p++,n="v?"+l[E]+l[m]+"?"+l[o]+"?";l[a]="^"+n+"$";var r="[v=\\s]*"+l[u]+l[S]+"?"+l[o]+"?",e=p++;l[e]="^"+r+"$";var t=p++;l[t]="((?:<|>)?=?)";var s=p++;l[s]=l[C]+"|x|X|\\*";var f=p++;l[f]=l[y]+"|x|X|\\*";var v=p++;l[v]="[v=\\s]*("+l[f]+")(?:\\.("+l[f]+")(?:\\.("+l[f]+")(?:"+l[m]+")?"+l[o]+"?)?)?";var L=p++;l[L]="[v=\\s]*("+l[s]+")(?:\\.("+l[s]+")(?:\\.("+l[s]+")(?:"+l[S]+")?"+l[o]+"?)?)?";var I=p++;l[I]="^"+l[t]+"\\s*"+l[v]+"$";var O=p++;l[O]="^"+l[t]+"\\s*"+l[L]+"$";var N=p++;l[N]="(?:^|[^\\d])(\\d{1,16})(?:\\.(\\d{1,16}))?(?:\\.(\\d{1,16}))?(?:$|[^\\d])";var G=p++;l[G]="(?:~>?)";var ee=p++;l[ee]="(\\s*)"+l[G]+"\\s+",w[ee]=new RegExp(l[ee],"g");var ge=p++;l[ge]="^"+l[G]+l[v]+"$";var ce=p++;l[ce]="^"+l[G]+l[L]+"$";var te=p++;l[te]="(?:\\^)";var he=p++;l[he]="(\\s*)"+l[te]+"\\s+",w[he]=new RegExp(l[he],"g");var W=p++;l[W]="^"+l[te]+l[v]+"$";var B=p++;l[B]="^"+l[te]+l[L]+"$";var ne=p++;l[ne]="^"+l[t]+"\\s*("+r+")$|^$";var M=p++;l[M]="^"+l[t]+"\\s*("+n+")$|^$";var k=p++;l[k]="(\\s*)"+l[t]+"\\s*("+r+"|"+l[v]+")",w[k]=new RegExp(l[k],"g");var j=p++;l[j]="^\\s*("+l[v]+")\\s+-\\s+("+l[v]+")\\s*$";var H=p++;l[H]="^\\s*("+l[L]+")\\s+-\\s+("+l[L]+")\\s*$";var ie=p++;l[ie]="(<|>)?=?\\s*\\*";for(var K=0;K<35;K++)b(K,l[K]),w[K]||(w[K]=new RegExp(l[K]));function Z(F,z){if(F instanceof _)return F;if(typeof F!="string"||F.length>R||!(z?w[e]:w[a]).test(F))return null;try{return new _(F,z)}catch(q){return null}}function _(F,z){if(F instanceof _){if(F.loose===z)return F;F=F.version}else if(typeof F!="string")throw new TypeError("Invalid Version: "+F);if(F.length>R)throw new TypeError("version is longer than "+R+" characters");if(!(this instanceof _))return new _(F,z);b("SemVer",F,z),this.loose=z;var q=F.trim().match(z?w[e]:w[a]);if(!q)throw new TypeError("Invalid Version: "+F);if(this.raw=F,this.major=+q[1],this.minor=+q[2],this.patch=+q[3],this.major>D||this.major<0)throw new TypeError("Invalid major version");if(this.minor>D||this.minor<0)throw new TypeError("Invalid minor version");if(this.patch>D||this.patch<0)throw new TypeError("Invalid patch version");q[4]?this.prerelease=q[4].split(".").map(function(fe){if(/^[0-9]+$/.test(fe)){var me=+fe;if(me>=0&&me<D)return me}return fe}):this.prerelease=[],this.build=q[5]?q[5].split("."):[],this.format()}i.parse=Z,i.valid=function(F,z){var q=Z(F,z);return q?q.version:null},i.clean=function(F,z){var q=Z(F.trim().replace(/^[=v]+/,""),z);return q?q.version:null},i.SemVer=_,_.prototype.format=function(){return this.version=this.major+"."+this.minor+"."+this.patch,this.prerelease.length&&(this.version+="-"+this.prerelease.join(".")),this.version},_.prototype.toString=function(){return this.version},_.prototype.compare=function(F){return b("SemVer.compare",this.version,this.loose,F),F instanceof _||(F=new _(F,this.loose)),this.compareMain(F)||this.comparePre(F)},_.prototype.compareMain=function(F){return F instanceof _||(F=new _(F,this.loose)),U(this.major,F.major)||U(this.minor,F.minor)||U(this.patch,F.patch)},_.prototype.comparePre=function(F){if(F instanceof _||(F=new _(F,this.loose)),this.prerelease.length&&!F.prerelease.length)return-1;if(!this.prerelease.length&&F.prerelease.length)return 1;if(!this.prerelease.length&&!F.prerelease.length)return 0;var z=0;do{var q=this.prerelease[z],fe=F.prerelease[z];if(b("prerelease compare",z,q,fe),q===void 0&&fe===void 0)return 0;if(fe===void 0)return 1;if(q===void 0)return-1;if(q!==fe)return U(q,fe)}while(++z)},_.prototype.inc=function(F,z){switch(F){case"premajor":this.prerelease.length=0,this.patch=0,this.minor=0,this.major++,this.inc("pre",z);break;case"preminor":this.prerelease.length=0,this.patch=0,this.minor++,this.inc("pre",z);break;case"prepatch":this.prerelease.length=0,this.inc("patch",z),this.inc("pre",z);break;case"prerelease":this.prerelease.length===0&&this.inc("patch",z),this.inc("pre",z);break;case"major":this.minor===0&&this.patch===0&&this.prerelease.length!==0||this.major++,this.minor=0,this.patch=0,this.prerelease=[];break;case"minor":this.patch===0&&this.prerelease.length!==0||this.minor++,this.patch=0,this.prerelease=[];break;case"patch":this.prerelease.length===0&&this.patch++,this.prerelease=[];break;case"pre":if(this.prerelease.length===0)this.prerelease=[0];else{for(var q=this.prerelease.length;--q>=0;)typeof this.prerelease[q]=="number"&&(this.prerelease[q]++,q=-2);q===-1&&this.prerelease.push(0)}z&&(this.prerelease[0]===z?isNaN(this.prerelease[1])&&(this.prerelease=[z,0]):this.prerelease=[z,0]);break;default:throw new Error("invalid increment argument: "+F)}return this.format(),this.raw=this.version,this},i.inc=function(F,z,q,fe){typeof q=="string"&&(fe=q,q=void 0);try{return new _(F,q).inc(z,fe).version}catch(me){return null}},i.diff=function(F,z){if(X(F,z))return null;var q=Z(F),fe=Z(z);if(q.prerelease.length||fe.prerelease.length){for(var me in q)if((me==="major"||me==="minor"||me==="patch")&&q[me]!==fe[me])return"pre"+me;return"prerelease"}for(var me in q)if((me==="major"||me==="minor"||me==="patch")&&q[me]!==fe[me])return me},i.compareIdentifiers=U;var ue=/^[0-9]+$/;function U(F,z){var q=ue.test(F),fe=ue.test(z);return q&&fe&&(F=+F,z=+z),q&&!fe?-1:fe&&!q?1:F<z?-1:F>z?1:0}function A(F,z,q){return new _(F,q).compare(new _(z,q))}function $(F,z,q){return A(F,z,q)>0}function V(F,z,q){return A(F,z,q)<0}function X(F,z,q){return A(F,z,q)===0}function Y(F,z,q){return A(F,z,q)!==0}function de(F,z,q){return A(F,z,q)>=0}function se(F,z,q){return A(F,z,q)<=0}function re(F,z,q,fe){var me;switch(z){case"===":typeof F=="object"&&(F=F.version),typeof q=="object"&&(q=q.version),me=F===q;break;case"!==":typeof F=="object"&&(F=F.version),typeof q=="object"&&(q=q.version),me=F!==q;break;case"":case"=":case"==":me=X(F,q,fe);break;case"!=":me=Y(F,q,fe);break;case">":me=$(F,q,fe);break;case">=":me=de(F,q,fe);break;case"<":me=V(F,q,fe);break;case"<=":me=se(F,q,fe);break;default:throw new TypeError("Invalid operator: "+z)}return me}function oe(F,z){if(F instanceof oe){if(F.loose===z)return F;F=F.value}if(!(this instanceof oe))return new oe(F,z);b("comparator",F,z),this.loose=z,this.parse(F),this.semver===ye?this.value="":this.value=this.operator+this.semver.version,b("comp",this)}i.rcompareIdentifiers=function(F,z){return U(z,F)},i.major=function(F,z){return new _(F,z).major},i.minor=function(F,z){return new _(F,z).minor},i.patch=function(F,z){return new _(F,z).patch},i.compare=A,i.compareLoose=function(F,z){return A(F,z,!0)},i.rcompare=function(F,z,q){return A(z,F,q)},i.sort=function(F,z){return F.sort(function(q,fe){return i.compare(q,fe,z)})},i.rsort=function(F,z){return F.sort(function(q,fe){return i.rcompare(q,fe,z)})},i.gt=$,i.lt=V,i.eq=X,i.neq=Y,i.gte=de,i.lte=se,i.cmp=re,i.Comparator=oe;var ye={};function le(F,z){if(F instanceof le)return F.loose===z?F:new le(F.raw,z);if(F instanceof oe)return new le(F.value,z);if(!(this instanceof le))return new le(F,z);if(this.loose=z,this.raw=F,this.set=F.split(/\s*\|\|\s*/).map(function(q){return this.parseRange(q.trim())},this).filter(function(q){return q.length}),!this.set.length)throw new TypeError("Invalid SemVer Range: "+F);this.format()}function Ee(F){return!F||F.toLowerCase()==="x"||F==="*"}function Se(F,z,q,fe,me,Ce,be,Ae,Re,ke,Ue,De,Te){return((z=Ee(q)?"":Ee(fe)?">="+q+".0.0":Ee(me)?">="+q+"."+fe+".0":">="+z)+" "+(Ae=Ee(Re)?"":Ee(ke)?"<"+(+Re+1)+".0.0":Ee(Ue)?"<"+Re+"."+(+ke+1)+".0":De?"<="+Re+"."+ke+"."+Ue+"-"+De:"<="+Ae)).trim()}function Oe(F,z){for(var q=0;q<F.length;q++)if(!F[q].test(z))return!1;if(z.prerelease.length){for(q=0;q<F.length;q++)if(b(F[q].semver),F[q].semver!==ye&&F[q].semver.prerelease.length>0){var fe=F[q].semver;if(fe.major===z.major&&fe.minor===z.minor&&fe.patch===z.patch)return!0}return!1}return!0}function Fe(F,z,q){try{z=new le(z,q)}catch(fe){return!1}return z.test(F)}function Ve(F,z,q,fe){var me,Ce,be,Ae,Re;switch(F=new _(F,fe),z=new le(z,fe),q){case">":me=$,Ce=se,be=V,Ae=">",Re=">=";break;case"<":me=V,Ce=de,be=$,Ae="<",Re="<=";break;default:throw new TypeError('Must provide a hilo val of "<" or ">"')}if(Fe(F,z,fe))return!1;for(var ke=0;ke<z.set.length;++ke){var Ue=z.set[ke],De=null,Te=null;if(Ue.forEach(function(Ne){Ne.semver===ye&&(Ne=new oe(">=0.0.0")),De=De||Ne,Te=Te||Ne,me(Ne.semver,De.semver,fe)?De=Ne:be(Ne.semver,Te.semver,fe)&&(Te=Ne)}),De.operator===Ae||De.operator===Re||(!Te.operator||Te.operator===Ae)&&Ce(F,Te.semver)||Te.operator===Re&&be(F,Te.semver))return!1}return!0}oe.prototype.parse=function(F){var z=this.loose?w[ne]:w[M],q=F.match(z);if(!q)throw new TypeError("Invalid comparator: "+F);this.operator=q[1],this.operator==="="&&(this.operator=""),q[2]?this.semver=new _(q[2],this.loose):this.semver=ye},oe.prototype.toString=function(){return this.value},oe.prototype.test=function(F){return b("Comparator.test",F,this.loose),this.semver===ye||(typeof F=="string"&&(F=new _(F,this.loose)),re(F,this.operator,this.semver,this.loose))},oe.prototype.intersects=function(F,z){if(!(F instanceof oe))throw new TypeError("a Comparator is required");var q;if(this.operator==="")return q=new le(F.value,z),Fe(this.value,q,z);if(F.operator==="")return q=new le(this.value,z),Fe(F.semver,q,z);var fe=!(this.operator!==">="&&this.operator!==">"||F.operator!==">="&&F.operator!==">"),me=!(this.operator!=="<="&&this.operator!=="<"||F.operator!=="<="&&F.operator!=="<"),Ce=this.semver.version===F.semver.version,be=!(this.operator!==">="&&this.operator!=="<="||F.operator!==">="&&F.operator!=="<="),Ae=re(this.semver,"<",F.semver,z)&&(this.operator===">="||this.operator===">")&&(F.operator==="<="||F.operator==="<"),Re=re(this.semver,">",F.semver,z)&&(this.operator==="<="||this.operator==="<")&&(F.operator===">="||F.operator===">");return fe||me||Ce&&be||Ae||Re},i.Range=le,le.prototype.format=function(){return this.range=this.set.map(function(F){return F.join(" ").trim()}).join("||").trim(),this.range},le.prototype.toString=function(){return this.range},le.prototype.parseRange=function(F){var z=this.loose;F=F.trim(),b("range",F,z);var q=z?w[H]:w[j];F=F.replace(q,Se),b("hyphen replace",F),F=F.replace(w[k],"$1$2$3"),b("comparator trim",F,w[k]),F=(F=(F=F.replace(w[ee],"$1~")).replace(w[he],"$1^")).split(/\s+/).join(" ");var fe=z?w[ne]:w[M],me=F.split(" ").map(function(Ce){return function(be,Ae){return b("comp",be),be=function(Re,ke){return Re.trim().split(/\s+/).map(function(Ue){return function(De,Te){b("caret",De,Te);var Ne=Te?w[B]:w[W];return De.replace(Ne,function(Me,pe,we,Ie,Pe){var Le;return b("caret",De,Me,pe,we,Ie,Pe),Ee(pe)?Le="":Ee(we)?Le=">="+pe+".0.0 <"+(+pe+1)+".0.0":Ee(Ie)?Le=pe==="0"?">="+pe+"."+we+".0 <"+pe+"."+(+we+1)+".0":">="+pe+"."+we+".0 <"+(+pe+1)+".0.0":Pe?(b("replaceCaret pr",Pe),Pe.charAt(0)!=="-"&&(Pe="-"+Pe),Le=pe==="0"?we==="0"?">="+pe+"."+we+"."+Ie+Pe+" <"+pe+"."+we+"."+(+Ie+1):">="+pe+"."+we+"."+Ie+Pe+" <"+pe+"."+(+we+1)+".0":">="+pe+"."+we+"."+Ie+Pe+" <"+(+pe+1)+".0.0"):(b("no pr"),Le=pe==="0"?we==="0"?">="+pe+"."+we+"."+Ie+" <"+pe+"."+we+"."+(+Ie+1):">="+pe+"."+we+"."+Ie+" <"+pe+"."+(+we+1)+".0":">="+pe+"."+we+"."+Ie+" <"+(+pe+1)+".0.0"),b("caret return",Le),Le})}(Ue,ke)}).join(" ")}(be,Ae),b("caret",be),be=function(Re,ke){return Re.trim().split(/\s+/).map(function(Ue){return function(De,Te){var Ne=Te?w[ce]:w[ge];return De.replace(Ne,function(Me,pe,we,Ie,Pe){var Le;return b("tilde",De,Me,pe,we,Ie,Pe),Ee(pe)?Le="":Ee(we)?Le=">="+pe+".0.0 <"+(+pe+1)+".0.0":Ee(Ie)?Le=">="+pe+"."+we+".0 <"+pe+"."+(+we+1)+".0":Pe?(b("replaceTilde pr",Pe),Pe.charAt(0)!=="-"&&(Pe="-"+Pe),Le=">="+pe+"."+we+"."+Ie+Pe+" <"+pe+"."+(+we+1)+".0"):Le=">="+pe+"."+we+"."+Ie+" <"+pe+"."+(+we+1)+".0",b("tilde return",Le),Le})}(Ue,ke)}).join(" ")}(be,Ae),b("tildes",be),be=function(Re,ke){return b("replaceXRanges",Re,ke),Re.split(/\s+/).map(function(Ue){return function(De,Te){De=De.trim();var Ne=Te?w[O]:w[I];return De.replace(Ne,function(Me,pe,we,Ie,Pe,Le){b("xRange",De,Me,pe,we,Ie,Pe,Le);var We=Ee(we),ze=We||Ee(Ie),je=ze||Ee(Pe);return pe==="="&&je&&(pe=""),We?Me=pe===">"||pe==="<"?"<0.0.0":"*":pe&&je?(ze&&(Ie=0),je&&(Pe=0),pe===">"?(pe=">=",ze?(we=+we+1,Ie=0,Pe=0):je&&(Ie=+Ie+1,Pe=0)):pe==="<="&&(pe="<",ze?we=+we+1:Ie=+Ie+1),Me=pe+we+"."+Ie+"."+Pe):ze?Me=">="+we+".0.0 <"+(+we+1)+".0.0":je&&(Me=">="+we+"."+Ie+".0 <"+we+"."+(+Ie+1)+".0"),b("xRange return",Me),Me})}(Ue,ke)}).join(" ")}(be,Ae),b("xrange",be),be=function(Re,ke){return b("replaceStars",Re,ke),Re.trim().replace(w[ie],"")}(be,Ae),b("stars",be),be}(Ce,z)}).join(" ").split(/\s+/);return this.loose&&(me=me.filter(function(Ce){return!!Ce.match(fe)})),me=me.map(function(Ce){return new oe(Ce,z)})},le.prototype.intersects=function(F,z){if(!(F instanceof le))throw new TypeError("a Range is required");return this.set.some(function(q){return q.every(function(fe){return F.set.some(function(me){return me.every(function(Ce){return fe.intersects(Ce,z)})})})})},i.toComparators=function(F,z){return new le(F,z).set.map(function(q){return q.map(function(fe){return fe.value}).join(" ").trim().split(" ")})},le.prototype.test=function(F){if(!F)return!1;typeof F=="string"&&(F=new _(F,this.loose));for(var z=0;z<this.set.length;z++)if(Oe(this.set[z],F))return!0;return!1},i.satisfies=Fe,i.maxSatisfying=function(F,z,q){var fe=null,me=null;try{var Ce=new le(z,q)}catch(be){return null}return F.forEach(function(be){Ce.test(be)&&(fe&&me.compare(be)!==-1||(me=new _(fe=be,q)))}),fe},i.minSatisfying=function(F,z,q){var fe=null,me=null;try{var Ce=new le(z,q)}catch(be){return null}return F.forEach(function(be){Ce.test(be)&&(fe&&me.compare(be)!==1||(me=new _(fe=be,q)))}),fe},i.validRange=function(F,z){try{return new le(F,z).range||"*"}catch(q){return null}},i.ltr=function(F,z,q){return Ve(F,z,"<",q)},i.gtr=function(F,z,q){return Ve(F,z,">",q)},i.outside=Ve,i.prerelease=function(F,z){var q=Z(F,z);return q&&q.prerelease.length?q.prerelease:null},i.intersects=function(F,z,q){return F=new le(F,q),z=new le(z,q),F.intersects(z)},i.coerce=function(F){if(F instanceof _)return F;if(typeof F!="string")return null;var z=F.match(w[N]);return z==null?null:Z((z[1]||"0")+"."+(z[2]||"0")+"."+(z[3]||"0"))}}).call(this,T(1))},function(x,i){var T,P,b=x.exports={};function R(){throw new Error("setTimeout has not been defined")}function D(){throw new Error("clearTimeout has not been defined")}function w(g){if(T===setTimeout)return setTimeout(g,0);if((T===R||!T)&&setTimeout)return T=setTimeout,setTimeout(g,0);try{return T(g,0)}catch(m){try{return T.call(null,g,0)}catch(S){return T.call(this,g,0)}}}(function(){try{T=typeof setTimeout=="function"?setTimeout:R}catch(g){T=R}try{P=typeof clearTimeout=="function"?clearTimeout:D}catch(g){P=D}})();var l,p=[],y=!1,C=-1;function c(){y&&l&&(y=!1,l.length?p=l.concat(p):C=-1,p.length&&E())}function E(){if(!y){var g=w(c);y=!0;for(var m=p.length;m;){for(l=p,p=[];++C<m;)l&&l[C].run();C=-1,m=p.length}l=null,y=!1,function(S){if(P===clearTimeout)return clearTimeout(S);if((P===D||!P)&&clearTimeout)return P=clearTimeout,clearTimeout(S);try{P(S)}catch(d){try{return P.call(null,S)}catch(o){return P.call(this,S)}}}(g)}}function u(g,m){this.fun=g,this.array=m}function h(){}b.nextTick=function(g){var m=new Array(arguments.length-1);if(arguments.length>1)for(var S=1;S<arguments.length;S++)m[S-1]=arguments[S];p.push(new u(g,m)),p.length!==1||y||w(E)},u.prototype.run=function(){this.fun.apply(null,this.array)},b.title="browser",b.browser=!0,b.env={},b.argv=[],b.version="",b.versions={},b.on=h,b.addListener=h,b.once=h,b.off=h,b.removeListener=h,b.removeAllListeners=h,b.emit=h,b.prependListener=h,b.prependOnceListener=h,b.listeners=function(g){return[]},b.binding=function(g){throw new Error("process.binding is not supported")},b.cwd=function(){return"/"},b.chdir=function(g){throw new Error("process.chdir is not supported")},b.umask=function(){return 0}}])}),define(J[59],Q([0,1]),function(x,i){"use strict";var T;Object.defineProperty(i,"__esModule",{value:!0}),i.SkipList=void 0;class P{constructor(w,l,p){this.level=w,this.key=l,this.value=p,this.forward=[]}}const b=void 0;class R{constructor(w,l=2**16){this.comparator=w,this[T]="SkipList",this._level=0,this._size=0,this._maxLevel=Math.max(1,Math.log2(l)|0),this._header=new P(this._maxLevel,b,b)}get size(){return this._size}clear(){this._header=new P(this._maxLevel,b,b)}has(w){return Boolean(R._search(this,w,this.comparator))}get(w){return R._search(this,w,this.comparator)?.value}set(w,l){return R._insert(this,w,l,this.comparator)&&(this._size+=1),this}delete(w){const l=R._delete(this,w,this.comparator);return l&&(this._size-=1),l}forEach(w,l){let p=this._header.forward[0];for(;p;)w.call(l,p.value,p.key,this),p=p.forward[0]}[(T=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}*entries(){let w=this._header.forward[0];for(;w;)yield[w.key,w.value],w=w.forward[0]}*keys(){let w=this._header.forward[0];for(;w;)yield w.key,w=w.forward[0]}*values(){let w=this._header.forward[0];for(;w;)yield w.value,w=w.forward[0]}toString(){let w="[SkipList]:",l=this._header.forward[0];for(;l;)w+=`node(${l.key}, ${l.value}, lvl:${l.level})`,l=l.forward[0];return w}static _search(w,l,p){let y=w._header;for(let C=w._level-1;C>=0;C--)for(;y.forward[C]&&p(y.forward[C].key,l)<0;)y=y.forward[C];if(y=y.forward[0],y&&p(y.key,l)===0)return y}static _insert(w,l,p,y){let C=[],c=w._header;for(let E=w._level-1;E>=0;E--){for(;c.forward[E]&&y(c.forward[E].key,l)<0;)c=c.forward[E];C[E]=c}if(c=c.forward[0],c&&y(c.key,l)===0)return c.value=p,!1;{let E=R._randomLevel(w);if(E>w._level){for(let u=w._level;u<E;u++)C[u]=w._header;w._level=E}c=new P(E,l,p);for(let u=0;u<E;u++)c.forward[u]=C[u].forward[u],C[u].forward[u]=c;return!0}}static _randomLevel(w,l=.5){let p=1;for(;Math.random()<l&&p<w._maxLevel;)p+=1;return p}static _delete(w,l,p){let y=[],C=w._header;for(let c=w._level-1;c>=0;c--){for(;C.forward[c]&&p(C.forward[c].key,l)<0;)C=C.forward[c];y[c]=C}if(C=C.forward[0],!C||p(C.key,l)!==0)return!1;for(let c=0;c<w._level&&y[c].forward[c]===C;c++)y[c].forward[c]=C.forward[c];for(;w._level>0&&w._header.forward[w._level-1]===b;)w._level-=1;return!0}}i.SkipList=R}),define(J[38],Q([0,1,7,2]),function(x,i,T,P){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.prefixedStream=i.prefixedReadable=i.transform=i.toReadable=i.emptyStream=i.toStream=i.peekStream=i.listenStream=i.consumeStream=i.peekReadable=i.consumeReadable=i.newWriteableStream=i.isReadableBufferedStream=i.isReadableStream=void 0;function b(d){const o=d;return o?[o.on,o.pause,o.resume,o.destroy].every(a=>typeof a=="function"):!1}i.isReadableStream=b;function R(d){const o=d;return o?b(o.stream)&&Array.isArray(o.buffer)&&typeof o.ended=="boolean":!1}i.isReadableBufferedStream=R;function D(d,o){return new w(d,o)}i.newWriteableStream=D;class w{constructor(o,a){this.reducer=o,this.options=a,this.state={flowing:!1,ended:!1,destroyed:!1},this.buffer={data:[],error:[]},this.listeners={data:[],error:[],end:[]},this.pendingWritePromises=[]}pause(){this.state.destroyed||(this.state.flowing=!1)}resume(){this.state.destroyed||this.state.flowing||(this.state.flowing=!0,this.flowData(),this.flowErrors(),this.flowEnd())}write(o){if(!this.state.destroyed){if(this.state.flowing)this.emitData(o);else if(this.buffer.data.push(o),typeof this.options?.highWaterMark=="number"&&this.buffer.data.length>this.options.highWaterMark)return new Promise(a=>this.pendingWritePromises.push(a))}}error(o){this.state.destroyed||(this.state.flowing?this.emitError(o):this.buffer.error.push(o))}end(o){this.state.destroyed||(typeof o!="undefined"&&this.write(o),this.state.flowing?(this.emitEnd(),this.destroy()):this.state.ended=!0)}emitData(o){this.listeners.data.slice(0).forEach(a=>a(o))}emitError(o){this.listeners.error.length===0?(0,T.onUnexpectedError)(o):this.listeners.error.slice(0).forEach(a=>a(o))}emitEnd(){this.listeners.end.slice(0).forEach(o=>o())}on(o,a){if(!this.state.destroyed)switch(o){case"data":this.listeners.data.push(a),this.resume();break;case"end":this.listeners.end.push(a),this.state.flowing&&this.flowEnd()&&this.destroy();break;case"error":this.listeners.error.push(a),this.state.flowing&&this.flowErrors();break}}removeListener(o,a){if(this.state.destroyed)return;let n;switch(o){case"data":n=this.listeners.data;break;case"end":n=this.listeners.end;break;case"error":n=this.listeners.error;break}if(n){const r=n.indexOf(a);r>=0&&n.splice(r,1)}}flowData(){if(this.buffer.data.length>0){const o=this.reducer(this.buffer.data);this.emitData(o),this.buffer.data.length=0;const a=[...this.pendingWritePromises];this.pendingWritePromises.length=0,a.forEach(n=>n())}}flowErrors(){if(this.listeners.error.length>0){for(const o of this.buffer.error)this.emitError(o);this.buffer.error.length=0}}flowEnd(){return this.state.ended?(this.emitEnd(),this.listeners.end.length>0):!1}destroy(){this.state.destroyed||(this.state.destroyed=!0,this.state.ended=!0,this.buffer.data.length=0,this.buffer.error.length=0,this.listeners.data.length=0,this.listeners.error.length=0,this.listeners.end.length=0,this.pendingWritePromises.length=0)}}function l(d,o){const a=[];let n;for(;(n=d.read())!==null;)a.push(n);return o(a)}i.consumeReadable=l;function p(d,o,a){const n=[];let r;for(;(r=d.read())!==null&&n.length<a;)n.push(r);return r===null&&n.length>0?o(n):{read:()=>{if(n.length>0)return n.shift();if(typeof r!="undefined"){const e=r;return r=void 0,e}return d.read()}}}i.peekReadable=p;function y(d,o){return new Promise((a,n)=>{const r=[];C(d,{onData:e=>{o&&r.push(e)},onError:e=>{o?n(e):a(void 0)},onEnd:()=>{a(o?o(r):void 0)}})})}i.consumeStream=y;function C(d,o){d.on("error",a=>o.onError(a)),d.on("end",()=>o.onEnd()),d.on("data",a=>o.onData(a))}i.listenStream=C;function c(d,o){return new Promise((a,n)=>{const r=new P.DisposableStore,e=[],t=v=>{if(e.push(v),e.length>o)return r.dispose(),d.pause(),a({stream:d,buffer:e,ended:!1})},s=v=>n(v),f=()=>a({stream:d,buffer:e,ended:!0});r.add((0,P.toDisposable)(()=>d.removeListener("error",s))),d.on("error",s),r.add((0,P.toDisposable)(()=>d.removeListener("end",f))),d.on("end",f),r.add((0,P.toDisposable)(()=>d.removeListener("data",t))),d.on("data",t)})}i.peekStream=c;function E(d,o){const a=D(o);return a.end(d),a}i.toStream=E;function u(){const d=D(()=>{throw new Error("not supported")});return d.end(),d}i.emptyStream=u;function h(d){let o=!1;return{read:()=>o?null:(o=!0,d)}}i.toReadable=h;function g(d,o,a){const n=D(a);return C(d,{onData:r=>n.write(o.data(r)),onError:r=>n.error(o.error?o.error(r):r),onEnd:()=>n.end()}),n}i.transform=g;function m(d,o,a){let n=!1;return{read:()=>{const r=o.read();return n?r:(n=!0,r!==null?a([d,r]):d)}}}i.prefixedReadable=m;function S(d,o,a){let n=!1;const r=D(a);return C(o,{onData:e=>n?r.write(e):(n=!0,r.write(a([d,e]))),onError:e=>r.error(e),onEnd:()=>{n||(n=!0,r.write(d)),r.end()}}),r}i.prefixedStream=S}),define(J[17],Q([0,1,38]),function(x,i,T){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.prefixedBufferStream=i.prefixedBufferReadable=i.newWriteableBufferStream=i.streamToBufferReadableStream=i.bufferToStream=i.bufferedStreamToBuffer=i.streamToBuffer=i.bufferToReadable=i.readableToBuffer=i.writeUInt8=i.readUInt8=i.writeUInt32LE=i.readUInt32LE=i.writeUInt32BE=i.readUInt32BE=i.writeUInt16LE=i.readUInt16LE=i.VSBuffer=void 0;const P=typeof Buffer!="undefined";let b,R;class D{constructor(t){this.buffer=t,this.byteLength=this.buffer.byteLength}static alloc(t){return P?new D(Buffer.allocUnsafe(t)):new D(new Uint8Array(t))}static wrap(t){return P&&!Buffer.isBuffer(t)&&(t=Buffer.from(t.buffer,t.byteOffset,t.byteLength)),new D(t)}static fromString(t,s){return!(s?.dontUseNodeBuffer||!1)&&P?new D(Buffer.from(t)):(b||(b=new TextEncoder),new D(b.encode(t)))}static fromByteArray(t){const s=D.alloc(t.length);for(let f=0,v=t.length;f<v;f++)s.buffer[f]=t[f];return s}static concat(t,s){if(typeof s=="undefined"){s=0;for(let L=0,I=t.length;L<I;L++)s+=t[L].byteLength}const f=D.alloc(s);let v=0;for(let L=0,I=t.length;L<I;L++){const O=t[L];f.set(O,v),v+=O.byteLength}return f}clone(){const t=D.alloc(this.byteLength);return t.set(this),t}toString(){return P?this.buffer.toString():(R||(R=new TextDecoder),R.decode(this.buffer))}slice(t,s){return new D(this.buffer.subarray(t,s))}set(t,s){if(t instanceof D)this.buffer.set(t.buffer,s);else if(t instanceof Uint8Array)this.buffer.set(t,s);else if(t instanceof ArrayBuffer)this.buffer.set(new Uint8Array(t),s);else if(ArrayBuffer.isView(t))this.buffer.set(new Uint8Array(t.buffer,t.byteOffset,t.byteLength),s);else throw new Error("Unkown argument 'array'")}readUInt32BE(t){return p(this.buffer,t)}writeUInt32BE(t,s){y(this.buffer,t,s)}readUInt32LE(t){return C(this.buffer,t)}writeUInt32LE(t,s){c(this.buffer,t,s)}readUInt8(t){return E(this.buffer,t)}writeUInt8(t,s){u(this.buffer,t,s)}}i.VSBuffer=D;function w(e,t){return e[t+0]<<0>>>0|e[t+1]<<8>>>0}i.readUInt16LE=w;function l(e,t,s){e[s+0]=t&255,t=t>>>8,e[s+1]=t&255}i.writeUInt16LE=l;function p(e,t){return e[t]*2**24+e[t+1]*2**16+e[t+2]*2**8+e[t+3]}i.readUInt32BE=p;function y(e,t,s){e[s+3]=t,t=t>>>8,e[s+2]=t,t=t>>>8,e[s+1]=t,t=t>>>8,e[s]=t}i.writeUInt32BE=y;function C(e,t){return e[t+0]<<0>>>0|e[t+1]<<8>>>0|e[t+2]<<16>>>0|e[t+3]<<24>>>0}i.readUInt32LE=C;function c(e,t,s){e[s+0]=t&255,t=t>>>8,e[s+1]=t&255,t=t>>>8,e[s+2]=t&255,t=t>>>8,e[s+3]=t&255}i.writeUInt32LE=c;function E(e,t){return e[t]}i.readUInt8=E;function u(e,t,s){e[s]=t}i.writeUInt8=u;function h(e){return T.consumeReadable(e,t=>D.concat(t))}i.readableToBuffer=h;function g(e){return T.toReadable(e)}i.bufferToReadable=g;function m(e){return T.consumeStream(e,t=>D.concat(t))}i.streamToBuffer=m;async function S(e){return e.ended?D.concat(e.buffer):D.concat([...e.buffer,await m(e.stream)])}i.bufferedStreamToBuffer=S;function d(e){return T.toStream(e,t=>D.concat(t))}i.bufferToStream=d;function o(e){return T.transform(e,{data:t=>typeof t=="string"?D.fromString(t):D.wrap(t)},t=>D.concat(t))}i.streamToBufferReadableStream=o;function a(e){return T.newWriteableStream(t=>D.concat(t),e)}i.newWriteableBufferStream=a;function n(e,t){return T.prefixedReadable(e,t,s=>D.concat(s))}i.prefixedBufferReadable=n;function r(e,t){return T.prefixedStream(e,t,s=>D.concat(s))}i.prefixedBufferStream=r}),define(J[21],Q([0,1,8]),function(x,i,T){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.filter=i.getCaseInsensitive=i.distinct=i.getOrDefault=i.safeStringify=i.equals=i.mixin=i.cloneAndChange=i.deepFreeze=i.deepClone=void 0;function P(h){if(!h||typeof h!="object"||h instanceof RegExp)return h;const g=Array.isArray(h)?[]:{};return Object.keys(h).forEach(m=>{h[m]&&typeof h[m]=="object"?g[m]=P(h[m]):g[m]=h[m]}),g}i.deepClone=P;function b(h){if(!h||typeof h!="object")return h;const g=[h];for(;g.length>0;){const m=g.shift();Object.freeze(m);for(const S in m)if(R.call(m,S)){const d=m[S];typeof d=="object"&&!Object.isFrozen(d)&&g.push(d)}}return h}i.deepFreeze=b;const R=Object.prototype.hasOwnProperty;function D(h,g){return w(h,g,new Set)}i.cloneAndChange=D;function w(h,g,m){if((0,T.isUndefinedOrNull)(h))return h;const S=g(h);if(typeof S!="undefined")return S;if((0,T.isArray)(h)){const d=[];for(const o of h)d.push(w(o,g,m));return d}if((0,T.isObject)(h)){if(m.has(h))throw new Error("Cannot clone recursive data-structure");m.add(h);const d={};for(let o in h)R.call(h,o)&&(d[o]=w(h[o],g,m));return m.delete(h),d}return h}function l(h,g,m=!0){return(0,T.isObject)(h)?((0,T.isObject)(g)&&Object.keys(g).forEach(S=>{S in h?m&&((0,T.isObject)(h[S])&&(0,T.isObject)(g[S])?l(h[S],g[S],m):h[S]=g[S]):h[S]=g[S]}),h):g}i.mixin=l;function p(h,g){if(h===g)return!0;if(h==null||g===null||g===void 0||typeof h!=typeof g||typeof h!="object"||Array.isArray(h)!==Array.isArray(g))return!1;let m,S;if(Array.isArray(h)){if(h.length!==g.length)return!1;for(m=0;m<h.length;m++)if(!p(h[m],g[m]))return!1}else{const d=[];for(S in h)d.push(S);d.sort();const o=[];for(S in g)o.push(S);if(o.sort(),!p(d,o))return!1;for(m=0;m<d.length;m++)if(!p(h[d[m]],g[d[m]]))return!1}return!0}i.equals=p;function y(h){const g=new Set;return JSON.stringify(h,(m,S)=>{if((0,T.isObject)(S)||Array.isArray(S)){if(g.has(S))return"[Circular]";g.add(S)}return S})}i.safeStringify=y;function C(h,g,m){const S=g(h);return typeof S=="undefined"?m:S}i.getOrDefault=C;function c(h,g){const m=Object.create(null);return!h||!g||Object.keys(g).forEach(d=>{const o=h[d],a=g[d];p(o,a)||(m[d]=a)}),m}i.distinct=c;function E(h,g){const m=g.toLowerCase(),S=Object.keys(h).find(d=>d.toLowerCase()===m);return S?h[S]:h[g]}i.getCaseInsensitive=E;function u(h,g){const m=Object.create(null);for(const[S,d]of Object.entries(h))g(S,d)&&(m[S]=d);return m}i.filter=u}),define(J[60],Q([0,1,9]),function(x,i,T){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.log=i.getFirstFrame=i.parse=i.isRemoteConsoleLog=void 0;function P(p){const y=p;return y&&typeof y.type=="string"&&typeof y.severity=="string"}i.isRemoteConsoleLog=P;function b(p){const y=[];let C;try{const c=JSON.parse(p.arguments),E=c[c.length-1];E&&E.__$stack&&(c.pop(),C=E.__$stack),y.push(...c)}catch(c){y.push("Unable to log remote console arguments",p.arguments)}return{args:y,stack:C}}i.parse=b;function R(p){if(typeof p!="string")return R(b(p).stack);const y=p;if(y){const C=D(y),c=/at [^\/]*((?:(?:[a-zA-Z]+:)|(?:[\/])|(?:\\\\))(?:.+)):(\d+):(\d+)/.exec(C||"");if(c&&c.length===4)return{uri:T.URI.file(c[1]),line:Number(c[2]),column:Number(c[3])}}}i.getFirstFrame=R;function D(p){if(!p)return p;const y=p.indexOf(`
`);return y===-1?p:p.substring(0,y)}function w(p,y){const{args:C,stack:c}=b(p),E=typeof C[0]=="string"&&C.length===1;let u=D(c);u&&(u=`(${u.trim()})`);let h=[];if(typeof C[0]=="string"?u&&E?h=[`%c[${y}] %c${C[0]} %c${u}`,l("blue"),l(""),l("grey")]:h=[`%c[${y}] %c${C[0]}`,l("blue"),l(""),...C.slice(1)]:h=[`%c[${y}]%`,l("blue"),...C],u&&!E&&h.push(u),typeof console[p.severity]!="function")throw new Error("Unknown console method");console[p.severity].apply(console,h)}i.log=w;function l(p){return`color: ${p}`}}),define(J[61],Q([0,1,17,26,9]),function(x,i,T,P,b){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.revive=i.MarshalledId=i.parse=i.stringify=void 0;function R(y){return JSON.stringify(y,l)}i.stringify=R;function D(y){let C=JSON.parse(y);return C=p(C),C}i.parse=D;var w;(function(y){y[y.Uri=1]="Uri",y[y.Regexp=2]="Regexp",y[y.ScmResource=3]="ScmResource",y[y.ScmResourceGroup=4]="ScmResourceGroup",y[y.ScmProvider=5]="ScmProvider",y[y.CommentController=6]="CommentController",y[y.CommentThread=7]="CommentThread",y[y.CommentThreadReply=8]="CommentThreadReply",y[y.CommentNode=9]="CommentNode",y[y.CommentThreadNode=10]="CommentThreadNode",y[y.TimelineActionContext=11]="TimelineActionContext",y[y.NotebookCellActionContext=12]="NotebookCellActionContext",y[y.TestItemContext=13]="TestItemContext"})(w=i.MarshalledId||(i.MarshalledId={}));function l(y,C){return C instanceof RegExp?{$mid:2,source:C.source,flags:(0,P.regExpFlags)(C)}:C}function p(y,C=0){if(!y||C>200)return y;if(typeof y=="object"){switch(y.$mid){case 1:return b.URI.revive(y);case 2:return new RegExp(y.source,y.flags)}if(y instanceof T.VSBuffer||y instanceof Uint8Array)return y;if(Array.isArray(y))for(let c=0;c<y.length;++c)y[c]=p(y[c],C+1);else for(const c in y)Object.hasOwnProperty.call(y,c)&&(y[c]=p(y[c],C+1))}return y}i.revive=p}),define(J[62],Q([0,1,47,10,6,12,18,26,9]),function(x,i,T,P,b,R,D,w,l){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.splitName=i.unmnemonicLabel=i.mnemonicButtonLabel=i.mnemonicMenuLabel=i.template=i.shorten=i.untildify=i.tildify=i.normalizeDriveLetter=i.getBaseLabel=i.getPathLabel=void 0;function p(t,s,f){if(typeof t=="string"&&(t=l.URI.file(t)),f){const L=f.getWorkspaceFolder(t);if(L){const I=f.getWorkspace().folders.length>1;let O;if((0,D.isEqual)(L.uri,t)?O="":O=(0,D.relativePath)(L.uri,t),I){const N=L.name?L.name:(0,D.basename)(L.uri);O=O?N+" \u2022 "+O:N}return O}}if(t.scheme!==P.Schemas.file&&t.scheme!==P.Schemas.untitled)return t.with({query:null,fragment:null}).toString(!0);if((0,T.hasDriveLetter)(t.fsPath))return(0,b.normalize)(C(t.fsPath));let v=(0,b.normalize)(t.fsPath);return!R.isWindows&&s?.userHome&&(v=E(v,s.userHome.fsPath)),v}i.getPathLabel=p;function y(t){if(!t)return;typeof t=="string"&&(t=l.URI.file(t));const s=(0,D.basename)(t)||(t.scheme===P.Schemas.file?t.fsPath:t.path);return R.isWindows&&(0,T.isRootOrDriveLetter)(s)?C(s):s}i.getBaseLabel=y;function C(t,s){return(0,T.hasDriveLetter)(t,s)?t.charAt(0).toUpperCase()+t.slice(1):t}i.normalizeDriveLetter=C;let c=Object.create(null);function E(t,s){if(R.isWindows||!t||!s)return t;let f=c.original===s?c.normalized:void 0;return f||(f=`${(0,w.rtrim)(s,b.posix.sep)}${b.posix.sep}`,c={original:s,normalized:f}),(R.isLinux?t.startsWith(f):(0,w.startsWithIgnoreCase)(t,f))&&(t=`~/${t.substr(f.length)}`),t}i.tildify=E;function u(t,s){return t.replace(/^~($|\/|\\)/,`${s}$1`)}i.untildify=u;const h="\u2026",g="\\\\",m="~";function S(t,s=b.sep){const f=new Array(t.length);let v=!1;for(let L=0;L<t.length;L++){let I=t[L];if(I===""){f[L]=`.${s}`;continue}if(!I){f[L]=I;continue}v=!0;let O="";I.indexOf(g)===0?(O=I.substr(0,I.indexOf(g)+g.length),I=I.substr(I.indexOf(g)+g.length)):I.indexOf(s)===0?(O=I.substr(0,I.indexOf(s)+s.length),I=I.substr(I.indexOf(s)+s.length)):I.indexOf(m)===0&&(O=I.substr(0,I.indexOf(m)+m.length),I=I.substr(I.indexOf(m)+m.length));const N=I.split(s);for(let G=1;v&&G<=N.length;G++)for(let ee=N.length-G;v&&ee>=0;ee--){v=!1;let ge=N.slice(ee,ee+G).join(s);for(let ce=0;!v&&ce<t.length;ce++)if(ce!==L&&t[ce]&&t[ce].indexOf(ge)>-1){const te=ee+G===N.length,he=ee>0&&t[ce].indexOf(s)>-1?s+ge:ge,W=t[ce].endsWith(he);v=!te||W}if(!v){let ce="";(N[0].endsWith(":")||O!=="")&&(ee===1&&(ee=0,G++,ge=N[0]+s+ge),ee>0&&(ce=N[0]+s),ce=O+ce),ee>0&&(ce=ce+h+s),ce=ce+ge,ee+G<N.length&&(ce=ce+s+h),f[L]=ce}}v&&(f[L]=I)}return f}i.shorten=S;var d;(function(t){t[t.TEXT=0]="TEXT",t[t.VARIABLE=1]="VARIABLE",t[t.SEPARATOR=2]="SEPARATOR"})(d||(d={}));function o(t,s=Object.create(null)){const f=[];let v=!1,L="";for(const I of t)if(I==="$"||v&&I==="{")L&&f.push({value:L,type:d.TEXT}),L="",v=!0;else if(I==="}"&&v){const O=s[L];if(typeof O=="string")O.length&&f.push({value:O,type:d.VARIABLE});else if(O){const N=f[f.length-1];(!N||N.type!==d.SEPARATOR)&&f.push({value:O.label,type:d.SEPARATOR})}L="",v=!1}else L+=I;return L&&!v&&f.push({value:L,type:d.TEXT}),f.filter((I,O)=>{if(I.type===d.SEPARATOR){const N=f[O-1],G=f[O+1];return[N,G].every(ee=>ee&&(ee.type===d.VARIABLE||ee.type===d.TEXT)&&ee.value.length>0)}return!0}).map(I=>I.value).join("")}i.template=o;function a(t,s){return R.isMacintosh||s?t.replace(/\(&&\w\)|&&/g,"").replace(/&/g,R.isMacintosh?"&":"&&"):t.replace(/&&|&/g,f=>f==="&"?"&&":"&")}i.mnemonicMenuLabel=a;function n(t,s){return R.isMacintosh||s?t.replace(/\(&&\w\)|&&/g,""):R.isWindows?t.replace(/&&|&/g,f=>f==="&"?"&&":"&"):t.replace(/&&/g,"_")}i.mnemonicButtonLabel=n;function r(t){return t.replace(/&/g,"&&")}i.unmnemonicLabel=r;function e(t){const s=t.indexOf("/")!==-1?b.posix:b.win32,f=s.basename(t),v=s.dirname(t);return f.length?{name:f,parentPath:v}:{name:v,parentPath:""}}i.splitName=e}),define(J[63],Q([0,1,131]),function(x,i,T){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.LineDecoder=void 0;class P{constructor(R="utf8"){this.stringDecoder=new T.StringDecoder(R),this.remaining=null}write(R){const D=[],w=this.remaining?this.remaining+this.stringDecoder.write(R):this.stringDecoder.write(R);if(w.length<1)return D;let l=0,p,y=l;for(;y<w.length;)if(p=w.charCodeAt(y),p===13||p===10){if(D.push(w.substring(l,y)),y++,y<w.length){const C=p;p=w.charCodeAt(y),(C===13&&p===10||C===10&&p===13)&&y++}l=y}else y++;return this.remaining=l<w.length?w.substr(l):null,D}end(){return this.remaining}}i.LineDecoder=P}),define(J[64],Q([0,1,48,6,26,13]),function(x,i,T,P,b,R){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.realpathSync=i.realpath=i.realcaseSync=void 0;function D(y){const C=(0,P.dirname)(y);if(y===C)return y;const c=((0,P.basename)(y)||y).toLowerCase();try{const u=(0,R.readdirSync)(C).filter(h=>h.toLowerCase()===c);if(u.length===1){const h=D(C);if(h)return(0,P.join)(h,u[0])}else if(u.length>1){const h=u.indexOf(c);if(h>=0){const g=D(C);if(g)return(0,P.join)(g,u[h])}}}catch(E){}return null}i.realcaseSync=D;async function w(y){try{return await R.Promises.realpath(y)}catch(C){const c=p(y);return await R.Promises.access(c,T.constants.R_OK),c}}i.realpath=w;function l(y){try{return T.realpathSync(y)}catch(C){const c=p(y);return T.accessSync(c,T.constants.R_OK),c}}i.realpathSync=l;function p(y){return(0,b.rtrim)((0,P.normalize)(y),P.sep)}}),define(J[65],Q([0,1,33,6,13]),function(x,i,T,P,b){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.getFirstAvailablePowerShellInstallation=i.enumeratePowerShellInstallations=void 0;const R=/^\d+$/,D=/^Microsoft.PowerShell_.*/,w=/^Microsoft.PowerShellPreview_.*/;var l;(function(o){o[o.x64=0]="x64",o[o.x86=1]="x86",o[o.ARM=2]="ARM"})(l||(l={}));let p;switch(process.arch){case"ia32":case"x32":p=1;break;case"arm":case"arm64":p=2;break;default:p=0;break}let y;process.env.PROCESSOR_ARCHITEW6432?y=process.env.PROCESSOR_ARCHITEW6432==="ARM64"?2:0:process.env.PROCESSOR_ARCHITECTURE==="ARM64"?y=2:process.env.PROCESSOR_ARCHITECTURE==="X86"?y=1:y=0;class C{constructor(a,n,r){this.exePath=a,this.displayName=n,this.knownToExist=r}async exists(){return this.knownToExist===void 0&&(this.knownToExist=await b.SymlinkSupport.existsFile(this.exePath)),this.knownToExist}}function c({useAlternateBitness:o=!1}={}){return o?p===0?process.env["ProgramFiles(x86)"]||null:y===0&&process.env.ProgramW6432||null:process.env.ProgramFiles||null}async function E({useAlternateBitness:o=!1,findPreview:a=!1}={}){const n=c({useAlternateBitness:o});if(!n)return null;const r=P.join(n,"PowerShell");if(!await b.SymlinkSupport.existsDirectory(r))return null;let e=-1,t=null;for(const v of await b.Promises.readdir(r)){let L=-1;if(a){const O=v.indexOf("-");if(O<0)continue;const N=v.substring(0,O);if(!R.test(N)||v.substring(O+1)!=="preview")continue;L=parseInt(N,10)}else{if(!R.test(v))continue;L=parseInt(v,10)}if(L<=e)continue;const I=P.join(r,v,"pwsh.exe");!await b.SymlinkSupport.existsFile(I)||(t=I,e=L)}if(!t)return null;const s=n.includes("x86")?" (x86)":"",f=a?" Preview":"";return new C(t,`PowerShell${f}${s}`,!0)}async function u({findPreview:o}={}){if(!process.env.LOCALAPPDATA)return null;const a=P.join(process.env.LOCALAPPDATA,"Microsoft","WindowsApps");if(!await b.SymlinkSupport.existsDirectory(a))return null;const{pwshMsixDirRegex:n,pwshMsixName:r}=o?{pwshMsixDirRegex:w,pwshMsixName:"PowerShell Preview (Store)"}:{pwshMsixDirRegex:D,pwshMsixName:"PowerShell (Store)"};for(const e of await b.Promises.readdir(a))if(n.test(e)){const t=P.join(a,e,"pwsh.exe");return new C(t,r)}return null}function h(){const o=P.join(T.homedir(),".dotnet","tools","pwsh.exe");return new C(o,".NET Core PowerShell Global Tool")}function g(){const o=P.join(process.env.windir,p===1&&y!==1?"SysNative":"System32","WindowsPowerShell","v1.0","powershell.exe");return new C(o,"Windows PowerShell",!0)}async function*m(){let o=await E();o&&(yield o),o=await E({useAlternateBitness:!0}),o&&(yield o),o=await u(),o&&(yield o),o=h(),o&&(yield o),o=await E({findPreview:!0}),o&&(yield o),o=await u({findPreview:!0}),o&&(yield o),o=await E({useAlternateBitness:!0,findPreview:!0}),o&&(yield o),o=g(),o&&(yield o)}async function*S(){for await(const o of m())await o.exists()&&(yield o)}i.enumeratePowerShellInstallations=S;async function d(){for await(const o of S())return o;return null}i.getFirstAvailablePowerShellInstallation=d});var ve=this&&this.__decorate||function(x,i,T,P){var b=arguments.length,R=b<3?i:P===null?P=Object.getOwnPropertyDescriptor(i,T):P,D;if(typeof Reflect=="object"&&typeof Reflect.decorate=="function")R=Reflect.decorate(x,i,T,P);else for(var w=x.length-1;w>=0;w--)(D=x[w])&&(R=(b<3?D(R):b>3?D(i,T,R):D(i,T))||R);return b>3&&R&&Object.defineProperty(i,T,R),R};define(J[39],Q([0,1,19,3,17,24,46,7,11,2,61,26,8]),function(x,i,T,P,b,R,D,w,l,p,y,C,c){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.IPCLogger=i.logWithColors=i.ProxyChannel=i.StaticRouter=i.getNextTickChannel=i.getDelayedChannel=i.IPCClient=i.IPCServer=i.ChannelClient=i.RequestInitiator=i.ChannelServer=i.ResponseType=i.RequestType=void 0;var E;(function(M){M[M.Promise=100]="Promise",M[M.PromiseCancel=101]="PromiseCancel",M[M.EventListen=102]="EventListen",M[M.EventDispose=103]="EventDispose"})(E=i.RequestType||(i.RequestType={}));function u(M){switch(M){case 100:return"req";case 101:return"cancel";case 102:return"subscribe";case 103:return"unsubscribe"}}var h;(function(M){M[M.Initialize=200]="Initialize",M[M.PromiseSuccess=201]="PromiseSuccess",M[M.PromiseError=202]="PromiseError",M[M.PromiseErrorObj=203]="PromiseErrorObj",M[M.EventFire=204]="EventFire"})(h=i.ResponseType||(i.ResponseType={}));function g(M){switch(M){case 200:return"init";case 201:return"reply:";case 202:case 203:return"replyErr:";case 204:return"event:"}}var m;(function(M){M[M.Uninitialized=0]="Uninitialized",M[M.Idle=1]="Idle"})(m||(m={}));class S{constructor(k){this.buffer=k,this.pos=0}read(k){const j=this.buffer.slice(this.pos,this.pos+k);return this.pos+=j.byteLength,j}}class d{constructor(){this.buffers=[]}get buffer(){return b.VSBuffer.concat(this.buffers)}write(k){this.buffers.push(k)}}var o;(function(M){M[M.Undefined=0]="Undefined",M[M.String=1]="String",M[M.Buffer=2]="Buffer",M[M.VSBuffer=3]="VSBuffer",M[M.Array=4]="Array",M[M.Object=5]="Object"})(o||(o={}));function a(M){const k=b.VSBuffer.alloc(4);return k.writeUInt32BE(M,0),k}function n(M){return M.read(4).readUInt32BE(0)}function r(M){const k=b.VSBuffer.alloc(1);return k.writeUInt8(M,0),k}const e={Undefined:r(o.Undefined),String:r(o.String),Buffer:r(o.Buffer),VSBuffer:r(o.VSBuffer),Array:r(o.Array),Object:r(o.Object)},t=typeof Buffer!="undefined";function s(M,k){if(typeof k=="undefined")M.write(e.Undefined);else if(typeof k=="string"){const j=b.VSBuffer.fromString(k);M.write(e.String),M.write(a(j.byteLength)),M.write(j)}else if(t&&Buffer.isBuffer(k)){const j=b.VSBuffer.wrap(k);M.write(e.Buffer),M.write(a(j.byteLength)),M.write(j)}else if(k instanceof b.VSBuffer)M.write(e.VSBuffer),M.write(a(k.byteLength)),M.write(k);else if(Array.isArray(k)){M.write(e.Array),M.write(a(k.length));for(const j of k)s(M,j)}else{const j=b.VSBuffer.fromString(JSON.stringify(k));M.write(e.Object),M.write(a(j.byteLength)),M.write(j)}}function f(M){switch(M.read(1).readUInt8(0)){case o.Undefined:return;case o.String:return M.read(n(M)).toString();case o.Buffer:return M.read(n(M)).buffer;case o.VSBuffer:return M.read(n(M));case o.Array:{const j=n(M),H=[];for(let ie=0;ie<j;ie++)H.push(f(M));return H}case o.Object:return JSON.parse(M.read(n(M)).toString())}}class v{constructor(k,j,H=null,ie=1e3){this.protocol=k,this.ctx=j,this.logger=H,this.timeoutDelay=ie,this.channels=new Map,this.activeRequests=new Map,this.pendingRequests=new Map,this.protocolListener=this.protocol.onMessage(K=>this.onRawMessage(K)),this.sendResponse({type:200})}registerChannel(k,j){this.channels.set(k,j),setTimeout(()=>this.flushPendingRequests(k),0)}sendResponse(k){switch(k.type){case 200:{const j=this.send([k.type]);this.logger&&this.logger.logOutgoing(j,0,1,g(k.type));return}case 201:case 202:case 204:case 203:{const j=this.send([k.type,k.id],k.data);this.logger&&this.logger.logOutgoing(j,k.id,1,g(k.type),k.data);return}}}send(k,j=void 0){const H=new d;return s(H,k),s(H,j),this.sendBuffer(H.buffer)}sendBuffer(k){try{return this.protocol.send(k),k.byteLength}catch(j){return 0}}onRawMessage(k){const j=new S(k),H=f(j),ie=f(j),K=H[0];switch(K){case 100:return this.logger&&this.logger.logIncoming(k.byteLength,H[1],1,`${u(K)}: ${H[2]}.${H[3]}`,ie),this.onPromise({type:K,id:H[1],channelName:H[2],name:H[3],arg:ie});case 102:return this.logger&&this.logger.logIncoming(k.byteLength,H[1],1,`${u(K)}: ${H[2]}.${H[3]}`,ie),this.onEventListen({type:K,id:H[1],channelName:H[2],name:H[3],arg:ie});case 101:return this.logger&&this.logger.logIncoming(k.byteLength,H[1],1,`${u(K)}`),this.disposeActiveRequest({type:K,id:H[1]});case 103:return this.logger&&this.logger.logIncoming(k.byteLength,H[1],1,`${u(K)}`),this.disposeActiveRequest({type:K,id:H[1]})}}onPromise(k){const j=this.channels.get(k.channelName);if(!j){this.collectPendingRequest(k);return}const H=new R.CancellationTokenSource;let ie;try{ie=j.call(this.ctx,k.name,k.arg,H.token)}catch(_){ie=Promise.reject(_)}const K=k.id;ie.then(_=>{this.sendResponse({id:K,data:_,type:201}),this.activeRequests.delete(k.id)},_=>{_ instanceof Error?this.sendResponse({id:K,data:{message:_.message,name:_.name,stack:_.stack?_.stack.split?_.stack.split(`
`):_.stack:void 0},type:202}):this.sendResponse({id:K,data:_,type:203}),this.activeRequests.delete(k.id)});const Z=(0,p.toDisposable)(()=>H.cancel());this.activeRequests.set(k.id,Z)}onEventListen(k){const j=this.channels.get(k.channelName);if(!j){this.collectPendingRequest(k);return}const H=k.id,K=j.listen(this.ctx,k.name,k.arg)(Z=>this.sendResponse({id:H,data:Z,type:204}));this.activeRequests.set(k.id,K)}disposeActiveRequest(k){const j=this.activeRequests.get(k.id);j&&(j.dispose(),this.activeRequests.delete(k.id))}collectPendingRequest(k){let j=this.pendingRequests.get(k.channelName);j||(j=[],this.pendingRequests.set(k.channelName,j));const H=setTimeout(()=>{console.error(`Unknown channel: ${k.channelName}`),k.type===100&&this.sendResponse({id:k.id,data:{name:"Unknown channel",message:`Channel name '${k.channelName}' timed out after ${this.timeoutDelay}ms`,stack:void 0},type:202})},this.timeoutDelay);j.push({request:k,timeoutTimer:H})}flushPendingRequests(k){const j=this.pendingRequests.get(k);if(j){for(const H of j)switch(clearTimeout(H.timeoutTimer),H.request.type){case 100:this.onPromise(H.request);break;case 102:this.onEventListen(H.request);break}this.pendingRequests.delete(k)}}dispose(){this.protocolListener&&(this.protocolListener.dispose(),this.protocolListener=null),this.activeRequests.forEach(k=>k.dispose()),this.activeRequests.clear()}}i.ChannelServer=v;var L;(function(M){M[M.LocalSide=0]="LocalSide",M[M.OtherSide=1]="OtherSide"})(L=i.RequestInitiator||(i.RequestInitiator={}));class I{constructor(k,j=null){this.protocol=k,this.isDisposed=!1,this.state=m.Uninitialized,this.activeRequests=new Set,this.handlers=new Map,this.lastRequestId=0,this._onDidInitialize=new l.Emitter,this.onDidInitialize=this._onDidInitialize.event,this.protocolListener=this.protocol.onMessage(H=>this.onBuffer(H)),this.logger=j}getChannel(k){const j=this;return{call(H,ie,K){return j.isDisposed?Promise.reject(w.canceled()):j.requestPromise(k,H,ie,K)},listen(H,ie){return j.isDisposed?Promise.reject(w.canceled()):j.requestEvent(k,H,ie)}}}requestPromise(k,j,H,ie=R.CancellationToken.None){const K=this.lastRequestId++,_={id:K,type:100,channelName:k,name:j,arg:H};if(ie.isCancellationRequested)return Promise.reject(w.canceled());let ue;return new Promise((A,$)=>{if(ie.isCancellationRequested)return $(w.canceled());const V=()=>{const se=re=>{switch(re.type){case 201:this.handlers.delete(K),A(re.data);break;case 202:this.handlers.delete(K);const oe=new Error(re.data.message);oe.stack=re.data.stack,oe.name=re.data.name,$(oe);break;case 203:this.handlers.delete(K),$(re.data);break}};this.handlers.set(K,se),this.sendRequest(_)};let X=null;this.state===m.Idle?V():(X=(0,P.createCancelablePromise)(se=>this.whenInitialized()),X.then(()=>{X=null,V()}));const Y=()=>{X?(X.cancel(),X=null):this.sendRequest({id:K,type:101}),$(w.canceled())},de=ie.onCancellationRequested(Y);ue=(0,p.combinedDisposable)((0,p.toDisposable)(Y),de),this.activeRequests.add(ue)}).finally(()=>{this.activeRequests.delete(ue)})}requestEvent(k,j,H){const ie=this.lastRequestId++,Z={id:ie,type:102,channelName:k,name:j,arg:H};let _=null;const ue=new l.Emitter({onFirstListenerAdd:()=>{_=(0,P.createCancelablePromise)(A=>this.whenInitialized()),_.then(()=>{_=null,this.activeRequests.add(ue),this.sendRequest(Z)})},onLastListenerRemove:()=>{_?(_.cancel(),_=null):(this.activeRequests.delete(ue),this.sendRequest({id:ie,type:103}))}}),U=A=>ue.fire(A.data);return this.handlers.set(ie,U),ue.event}sendRequest(k){switch(k.type){case 100:case 102:{const j=this.send([k.type,k.id,k.channelName,k.name],k.arg);this.logger&&this.logger.logOutgoing(j,k.id,0,`${u(k.type)}: ${k.channelName}.${k.name}`,k.arg);return}case 101:case 103:{const j=this.send([k.type,k.id]);this.logger&&this.logger.logOutgoing(j,k.id,0,u(k.type));return}}}send(k,j=void 0){const H=new d;return s(H,k),s(H,j),this.sendBuffer(H.buffer)}sendBuffer(k){try{return this.protocol.send(k),k.byteLength}catch(j){return 0}}onBuffer(k){const j=new S(k),H=f(j),ie=f(j),K=H[0];switch(K){case 200:return this.logger&&this.logger.logIncoming(k.byteLength,0,0,g(K)),this.onResponse({type:H[0]});case 201:case 202:case 204:case 203:return this.logger&&this.logger.logIncoming(k.byteLength,H[1],0,g(K),ie),this.onResponse({type:H[0],id:H[1],data:ie})}}onResponse(k){if(k.type===200){this.state=m.Idle,this._onDidInitialize.fire();return}const j=this.handlers.get(k.id);j&&j(k)}get onDidInitializePromise(){return l.Event.toPromise(this.onDidInitialize)}whenInitialized(){return this.state===m.Idle?Promise.resolve():this.onDidInitializePromise}dispose(){this.isDisposed=!0,this.protocolListener&&(this.protocolListener.dispose(),this.protocolListener=null),this.activeRequests.forEach(k=>k.dispose()),this.activeRequests.clear()}}ve([D.memoize],I.prototype,"onDidInitializePromise",null),i.ChannelClient=I;class O{constructor(k){this.channels=new Map,this._connections=new Set,this._onDidAddConnection=new l.Emitter,this.onDidAddConnection=this._onDidAddConnection.event,this._onDidRemoveConnection=new l.Emitter,this.onDidRemoveConnection=this._onDidRemoveConnection.event,k(({protocol:j,onDidClientDisconnect:H})=>{l.Event.once(j.onMessage)(K=>{const Z=new S(K),_=f(Z),ue=new v(j,_),U=new I(j);this.channels.forEach(($,V)=>ue.registerChannel(V,$));const A={channelServer:ue,channelClient:U,ctx:_};this._connections.add(A),this._onDidAddConnection.fire(A),H(()=>{ue.dispose(),U.dispose(),this._connections.delete(A),this._onDidRemoveConnection.fire(A)})})})}get connections(){const k=[];return this._connections.forEach(j=>k.push(j)),k}getChannel(k,j){const H=this;return{call(ie,K,Z){let _;if((0,c.isFunction)(j)){let U=(0,T.getRandomElement)(H.connections.filter(j));_=U?Promise.resolve(U):l.Event.toPromise(l.Event.filter(H.onDidAddConnection,j))}else _=j.routeCall(H,ie,K);const ue=_.then(U=>U.channelClient.getChannel(k));return G(ue).call(ie,K,Z)},listen(ie,K){if((0,c.isFunction)(j))return H.getMulticastEvent(k,j,ie,K);const Z=j.routeEvent(H,ie,K).then(_=>_.channelClient.getChannel(k));return G(Z).listen(ie,K)}}}getMulticastEvent(k,j,H,ie){const K=this;let Z=new p.DisposableStore;const _=new l.Emitter({onFirstListenerAdd:()=>{Z=new p.DisposableStore;const ue=new l.EventMultiplexer,U=new Map,A=V=>{const Y=V.channelClient.getChannel(k).listen(H,ie),de=ue.add(Y);U.set(V,de)},$=V=>{const X=U.get(V);!X||(X.dispose(),U.delete(V))};K.connections.filter(j).forEach(A),l.Event.filter(K.onDidAddConnection,j)(A,void 0,Z),K.onDidRemoveConnection($,void 0,Z),ue.event(_.fire,_,Z),Z.add(ue)},onLastListenerRemove:()=>{Z.dispose()}});return _.event}registerChannel(k,j){this.channels.set(k,j),this._connections.forEach(H=>{H.channelServer.registerChannel(k,j)})}dispose(){this.channels.clear(),this._connections.clear(),this._onDidAddConnection.dispose(),this._onDidRemoveConnection.dispose()}}i.IPCServer=O;class N{constructor(k,j,H=null){const ie=new d;s(ie,j),k.send(ie.buffer),this.channelClient=new I(k,H),this.channelServer=new v(k,j,H)}getChannel(k){return this.channelClient.getChannel(k)}registerChannel(k,j){this.channelServer.registerChannel(k,j)}dispose(){this.channelClient.dispose(),this.channelServer.dispose()}}i.IPCClient=N;function G(M){return{call(k,j,H){return M.then(ie=>ie.call(k,j,H))},listen(k,j){const H=new l.Relay;return M.then(ie=>H.input=ie.listen(k,j)),H.event}}}i.getDelayedChannel=G;function ee(M){let k=!1;return{call(j,H,ie){return k?M.call(j,H,ie):(0,P.timeout)(0).then(()=>k=!0).then(()=>M.call(j,H,ie))},listen(j,H){if(k)return M.listen(j,H);const ie=new l.Relay;return(0,P.timeout)(0).then(()=>k=!0).then(()=>ie.input=M.listen(j,H)),ie.event}}}i.getNextTickChannel=ee;class ge{constructor(k){this.fn=k}routeCall(k){return this.route(k)}routeEvent(k){return this.route(k)}async route(k){for(const j of k.connections)if(await Promise.resolve(this.fn(j.ctx)))return Promise.resolve(j);return await l.Event.toPromise(k.onDidAddConnection),await this.route(k)}}i.StaticRouter=ge;var ce;(function(M){function k(K,Z){const _=K,ue=Z&&Z.disableMarshalling,U=new Map;for(const A in _)H(A)&&U.set(A,l.Event.buffer(_[A],!0));return new class{listen(A,$,V){const X=U.get($);if(X)return X;if(ie($)){const Y=_[$];if(typeof Y=="function")return Y.call(_,V)}throw new Error(`Event not found: ${$}`)}call(A,$,V){const X=_[$];if(typeof X=="function"){if(!ue&&Array.isArray(V))for(let Y=0;Y<V.length;Y++)V[Y]=(0,y.revive)(V[Y]);return X.apply(_,V)}throw new Error(`Method not found: ${$}`)}}}M.fromService=k;function j(K,Z){const _=Z&&Z.disableMarshalling;return new Proxy({},{get(ue,U){if(typeof U=="string")return Z?.properties?.has(U)?Z.properties.get(U):ie(U)?function(A){return K.listen(U,A)}:H(U)?K.listen(U):async function(...A){let $;Z&&!(0,c.isUndefinedOrNull)(Z.context)?$=[Z.context,...A]:$=A;const V=await K.call(U,$);return _?V:(0,y.revive)(V)};throw new Error(`Property not found: ${String(U)}`)}})}M.toService=j;function H(K){return K[0]==="o"&&K[1]==="n"&&C.isUpperAsciiLetter(K.charCodeAt(2))}function ie(K){return/^onDynamic/.test(K)&&C.isUpperAsciiLetter(K.charCodeAt(9))}})(ce=i.ProxyChannel||(i.ProxyChannel={}));const te=[["#2977B1","#FC802D","#34A13A","#D3282F","#9366BA"],["#8B564C","#E177C0","#7F7F7F","#BBBE3D","#2EBECD"]];function he(M){if(Array.isArray(M))return M;if(M&&typeof M=="object"&&typeof M.toString=="function"){let k=M.toString();if(k!=="[object Object]")return k}return M}function W(M){return Array.isArray(M)?M.map(he):he(M)}function B(M,k,j,H,ie,K,Z){Z=W(Z);const _=te[ie],ue=_[H%_.length];let U=[`%c[${M}]%c[${String(k).padStart(7," ")}]%c[len: ${String(j).padStart(5," ")}]%c${String(H).padStart(5," ")} - ${K}`,"color: darkgreen","color: grey","color: grey",`color: ${ue}`];/\($/.test(K)?(U=U.concat(Z),U.push(")")):U.push(Z),console.log.apply(console,U)}i.logWithColors=B;class ne{constructor(k,j){this._outgoingPrefix=k,this._incomingPrefix=j,this._totalIncoming=0,this._totalOutgoing=0}logOutgoing(k,j,H,ie,K){this._totalOutgoing+=k,B(this._outgoingPrefix,this._totalOutgoing,k,j,H,ie,K)}logIncoming(k,j,H,ie,K){this._totalIncoming+=k,B(this._incomingPrefix,this._totalIncoming,k,j,H,ie,K)}}i.IPCLogger=ne}),define(J[66],Q([0,1,3,11,2,8]),function(x,i,T,P,b,R){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.InMemoryStorageDatabase=i.Storage=i.isStorageItemsChangeEvent=i.StorageHint=void 0;var D;(function(C){C[C.STORAGE_DOES_NOT_EXIST=0]="STORAGE_DOES_NOT_EXIST"})(D=i.StorageHint||(i.StorageHint={}));function w(C){const c=C;return c?.changed instanceof Map||c?.deleted instanceof Set}i.isStorageItemsChangeEvent=w;var l;(function(C){C[C.None=0]="None",C[C.Initialized=1]="Initialized",C[C.Closed=2]="Closed"})(l||(l={}));class p extends b.Disposable{constructor(c,E=Object.create(null)){super();this.database=c,this.options=E,this._onDidChangeStorage=this._register(new P.Emitter),this.onDidChangeStorage=this._onDidChangeStorage.event,this.state=l.None,this.cache=new Map,this.flushDelayer=new T.ThrottledDelayer(p.DEFAULT_FLUSH_DELAY),this.pendingDeletes=new Set,this.pendingInserts=new Map,this.pendingClose=void 0,this.whenFlushedCallbacks=[],this.registerListeners()}registerListeners(){this._register(this.database.onDidChangeItemsExternal(c=>this.onDidChangeItemsExternal(c)))}onDidChangeItemsExternal(c){c.changed?.forEach((E,u)=>this.accept(u,E)),c.deleted?.forEach(E=>this.accept(E,void 0))}accept(c,E){if(this.state===l.Closed)return;let u=!1;(0,R.isUndefinedOrNull)(E)?u=this.cache.delete(c):this.cache.get(c)!==E&&(this.cache.set(c,E),u=!0),u&&this._onDidChangeStorage.fire(c)}get items(){return this.cache}get size(){return this.cache.size}async init(){this.state===l.None&&(this.state=l.Initialized,this.options.hint!==D.STORAGE_DOES_NOT_EXIST&&(this.cache=await this.database.getItems()))}get(c,E){const u=this.cache.get(c);return(0,R.isUndefinedOrNull)(u)?E:u}getBoolean(c,E){const u=this.get(c);return(0,R.isUndefinedOrNull)(u)?E:u==="true"}getNumber(c,E){const u=this.get(c);return(0,R.isUndefinedOrNull)(u)?E:parseInt(u,10)}async set(c,E){if(this.state===l.Closed)return;if((0,R.isUndefinedOrNull)(E))return this.delete(c);const u=String(E);if(this.cache.get(c)!==u)return this.cache.set(c,u),this.pendingInserts.set(c,u),this.pendingDeletes.delete(c),this._onDidChangeStorage.fire(c),this.doFlush()}async delete(c){if(!(this.state===l.Closed||!this.cache.delete(c)))return this.pendingDeletes.has(c)||this.pendingDeletes.add(c),this.pendingInserts.delete(c),this._onDidChangeStorage.fire(c),this.doFlush()}async close(){return this.pendingClose||(this.pendingClose=this.doClose()),this.pendingClose}async doClose(){this.state=l.Closed;try{await this.doFlush(0)}catch(c){}await this.database.close(()=>this.cache)}get hasPending(){return this.pendingInserts.size>0||this.pendingDeletes.size>0}async flushPending(){if(!this.hasPending)return;const c={insert:this.pendingInserts,delete:this.pendingDeletes};return this.pendingDeletes=new Set,this.pendingInserts=new Map,this.database.updateItems(c).finally(()=>{if(!this.hasPending)for(;this.whenFlushedCallbacks.length;)this.whenFlushedCallbacks.pop()?.()})}async flush(c){if(!!this.hasPending)return this.doFlush(c)}async doFlush(c){return this.flushDelayer.trigger(()=>this.flushPending(),c)}async whenFlushed(){if(!!this.hasPending)return new Promise(c=>this.whenFlushedCallbacks.push(c))}dispose(){this.flushDelayer.dispose(),super.dispose()}}i.Storage=p,p.DEFAULT_FLUSH_DELAY=100;class y{constructor(){this.onDidChangeItemsExternal=P.Event.None,this.items=new Map}async getItems(){return this.items}async updateItems(c){c.insert&&c.insert.forEach((E,u)=>this.items.set(u,E)),c.delete&&c.delete.forEach(E=>this.items.delete(E))}async close(){}}i.InMemoryStorageDatabase=y}),define(J[67],Q([4,5]),function(x,i){return x.create("vs/base/common/date",i)}),define(J[68],Q([0,1,67]),function(x,i,T){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.toLocalISOString=i.fromNow=void 0;const P=60,b=P*60,R=b*24,D=R*7,w=R*30,l=R*365;function p(C,c){typeof C!="number"&&(C=C.getTime());const E=Math.round((new Date().getTime()-C)/1e3);if(E<-30)return(0,T.localize)(0,null,p(new Date().getTime()+E*1e3,!1));if(E<30)return(0,T.localize)(1,null);let u;return E<P?(u=E,c?u===1?(0,T.localize)(2,null,u):(0,T.localize)(3,null,u):u===1?(0,T.localize)(4,null,u):(0,T.localize)(5,null,u)):E<b?(u=Math.floor(E/P),c?u===1?(0,T.localize)(6,null,u):(0,T.localize)(7,null,u):u===1?(0,T.localize)(8,null,u):(0,T.localize)(9,null,u)):E<R?(u=Math.floor(E/b),c?u===1?(0,T.localize)(10,null,u):(0,T.localize)(11,null,u):u===1?(0,T.localize)(12,null,u):(0,T.localize)(13,null,u)):E<D?(u=Math.floor(E/R),c?u===1?(0,T.localize)(14,null,u):(0,T.localize)(15,null,u):u===1?(0,T.localize)(16,null,u):(0,T.localize)(17,null,u)):E<w?(u=Math.floor(E/D),c?u===1?(0,T.localize)(18,null,u):(0,T.localize)(19,null,u):u===1?(0,T.localize)(20,null,u):(0,T.localize)(21,null,u)):E<l?(u=Math.floor(E/w),c?u===1?(0,T.localize)(22,null,u):(0,T.localize)(23,null,u):u===1?(0,T.localize)(24,null,u):(0,T.localize)(25,null,u)):(u=Math.floor(E/l),c?u===1?(0,T.localize)(26,null,u):(0,T.localize)(27,null,u):u===1?(0,T.localize)(28,null,u):(0,T.localize)(29,null,u))}i.fromNow=p;function y(C){return C.getFullYear()+"-"+String(C.getMonth()+1).padStart(2,"0")+"-"+String(C.getDate()).padStart(2,"0")+"T"+String(C.getHours()).padStart(2,"0")+":"+String(C.getMinutes()).padStart(2,"0")+":"+String(C.getSeconds()).padStart(2,"0")+"."+(C.getMilliseconds()/1e3).toFixed(3).slice(2,5)+"Z"}i.toLocalISOString=y}),define(J[69],Q([4,5]),function(x,i){return x.create("vs/base/common/errorMessage",i)}),define(J[27],Q([0,1,19,8,69]),function(x,i,T,P,b){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.toErrorMessage=void 0;function R(p,y){return y&&(p.stack||p.stacktrace)?b.localize(0,null,w(p),D(p.stack)||D(p.stacktrace)):w(p)}function D(p){return Array.isArray(p)?p.join(`
`):p}function w(p){return typeof p.code=="string"&&typeof p.errno=="number"&&typeof p.syscall=="string"?b.localize(1,null,p.message):p.message||b.localize(2,null)}function l(p=null,y=!1){if(!p)return b.localize(3,null);if(Array.isArray(p)){const C=T.coalesce(p),c=l(C[0],y);return C.length>1?b.localize(4,null,c,C.length):c}if(P.isString(p))return p;if(p.detail){const C=p.detail;if(C.error)return R(C.error,y);if(C.exception)return R(C.exception,y)}return p.stack?R(p,y):p.message?p.message:b.localize(5,null)}i.toErrorMessage=l}),define(J[70],Q([4,5]),function(x,i){return x.create("vs/base/node/processes",i)}),define(J[49],Q([0,1,40,47,10,21,6,12,28,58,8,63,13,70]),function(x,i,T,P,b,R,D,w,l,p,y,C,c,E){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.win32=i.createQueuedSender=i.LineProcess=i.AbstractProcess=i.getWindowsShell=i.removeDangerousEnvVariables=i.TerminateResponseCode=i.Source=void 0,Object.defineProperty(i,"Source",{enumerable:!0,get:function(){return p.Source}}),Object.defineProperty(i,"TerminateResponseCode",{enumerable:!0,get:function(){return p.TerminateResponseCode}});function u(n){switch(n){case 0:return 0;case 1:return 2;case 128:return 3;default:return 1}}function h(n,r){if(w.isWindows)try{const e={stdio:["pipe","pipe","ignore"]};r&&(e.cwd=r);const t=T.execFile("taskkill",["/T","/F","/PID",n.pid.toString()],e);return new Promise(s=>{t.once("error",f=>{s({success:!1,error:f})}),t.once("exit",(f,v)=>{s(f===0?{success:!0}:{success:!1,code:f!==null?f:1})})})}catch(e){return Promise.resolve({success:!1,error:e,code:e.status?u(e.status):1})}else if(w.isLinux||w.isMacintosh)try{const e=b.FileAccess.asFileUri("vs/base/node/terminateProcess.sh",x).fsPath;return new Promise(t=>{T.execFile(e,[n.pid.toString()],{encoding:"utf8",shell:!0},(s,f,v)=>{t(s?{success:!1,error:s}:{success:!0})})})}catch(e){return Promise.resolve({success:!1,error:e})}else n.kill("SIGKILL");return Promise.resolve({success:!0})}function g(n){!n||(delete n.DEBUG,w.isMacintosh&&delete n.DYLD_LIBRARY_PATH,w.isLinux&&delete n.LD_PRELOAD)}i.removeDangerousEnvVariables=g;function m(n=l.env){return n.comspec||"cmd.exe"}i.getWindowsShell=m;class S{constructor(r,e,t,s){if(e!==void 0&&t!==void 0&&s!==void 0)this.cmd=r,this.args=e,this.shell=t,this.options=s;else{const f=r;this.cmd=f.command,this.shell=f.isShellCommand,this.args=f.args.slice(0),this.options=f.options||{}}if(this.childProcess=null,this.childProcessPromise=null,this.terminateRequested=!1,this.options.env){const f=Object.create(null);Object.keys(l.env).forEach(v=>{f[v]=l.env[v]}),Object.keys(this.options.env).forEach(v=>{f[v]=this.options.env[v]}),this.options.env=f}}getSanitizedCommand(){let r=this.cmd.toLowerCase();const e=r.lastIndexOf(D.sep);return e!==-1&&(r=r.substring(e+1)),S.WellKnowCommands[r]?r:"other"}start(r){return w.isWindows&&(this.options&&this.options.cwd&&P.isUNC(this.options.cwd)||!this.options&&P.isUNC(l.cwd()))?Promise.reject(new Error(E.localize(0,null))):this.useExec().then(e=>{let t,s;const f=new Promise((v,L)=>{t=v,s=L});if(e){let v=this.cmd;this.args&&(v=v+" "+this.args.join(" ")),this.childProcess=T.exec(v,this.options,(L,I,O)=>{this.childProcess=null;const N=L;N&&N.killed?s({killed:this.terminateRequested,stdout:I.toString(),stderr:O.toString()}):this.handleExec(t,r,L,I,O)})}else{let v=null;const L=I=>{this.childProcess=null,this.childProcessPromise=null,this.handleClose(I,t,r,s);const O={terminated:this.terminateRequested};y.isNumber(I)&&(O.cmdCode=I),t(O)};if(this.shell&&w.isWindows){const I=R.deepClone(this.options);I.windowsVerbatimArguments=!0,I.detached=!1;let O=!1,N=!1;const G=[];let ee=this.ensureQuotes(this.cmd);G.push(ee.value),O=ee.quoted,this.args&&this.args.forEach(ce=>{ee=this.ensureQuotes(ce),G.push(ee.value),N=N&&ee.quoted});const ge=["/s","/c"];O?N?ge.push('"'+G.join(" ")+'"'):G.length>1?ge.push('"'+G[0]+'" '+G.slice(1).join(" ")):ge.push('"'+G[0]+'"'):ge.push(G.join(" ")),v=T.spawn(m(),ge,I)}else this.cmd&&(v=T.spawn(this.cmd,this.args,this.options));v&&(this.childProcess=v,this.childProcessPromise=Promise.resolve(v),this.pidResolve&&(this.pidResolve(y.isNumber(v.pid)?v.pid:-1),this.pidResolve=void 0),v.on("error",I=>{this.childProcess=null,s({terminated:this.terminateRequested,error:I})}),v.pid&&(this.childProcess.on("close",L),this.handleSpawn(v,t,r,s,!0)))}return f})}handleClose(r,e,t,s){}ensureQuotes(r){return S.regexp.test(r)?{value:'"'+r+'"',quoted:!0}:{value:r,quoted:r.length>0&&r[0]==='"'&&r[r.length-1]==='"'}}get pid(){return this.childProcessPromise?this.childProcessPromise.then(r=>r.pid,r=>-1):new Promise(r=>{this.pidResolve=r})}terminate(){return this.childProcessPromise?this.childProcessPromise.then(r=>(this.terminateRequested=!0,h(r,this.options.cwd).then(e=>(e.success&&(this.childProcess=null),e))),r=>({success:!0})):Promise.resolve({success:!0})}useExec(){return new Promise(r=>{if(!this.shell||!w.isWindows)return r(!1);const e=T.spawn(m(),["/s","/c"]);e.on("error",t=>r(!0)),e.on("exit",t=>r(!1))})}}i.AbstractProcess=S,S.WellKnowCommands={ant:!0,cmake:!0,eslint:!0,gradle:!0,grunt:!0,gulp:!0,jake:!0,jenkins:!0,jshint:!0,make:!0,maven:!0,msbuild:!0,msc:!0,nmake:!0,npm:!0,rake:!0,tsc:!0,xbuild:!0},S.regexp=/^[^"].* .*[^"]/;class d extends S{constructor(r,e,t,s){super(r,e,t,s);this.stdoutLineDecoder=null,this.stderrLineDecoder=null}handleExec(r,e,t,s,f){[s,f].forEach((v,L)=>{const I=new C.LineDecoder;I.write(v).forEach(G=>{e({line:G,source:L===0?0:1})});const N=I.end();N&&e({line:N,source:L===0?0:1})}),r({terminated:this.terminateRequested,error:t})}handleSpawn(r,e,t,s,f){const v=new C.LineDecoder,L=new C.LineDecoder;r.stdout.on("data",I=>{v.write(I).forEach(N=>t({line:N,source:0}))}),r.stderr.on("data",I=>{L.write(I).forEach(N=>t({line:N,source:1}))}),this.stdoutLineDecoder=v,this.stderrLineDecoder=L}handleClose(r,e,t,s){const f=this.stdoutLineDecoder?this.stdoutLineDecoder.end():null;f&&t({line:f,source:0});const v=this.stderrLineDecoder?this.stderrLineDecoder.end():null;v&&t({line:v,source:1})}}i.LineProcess=d;function o(n){let r=[],e=!1;const t=function(s){if(e){r.push(s);return}(!n.send(s,v=>{if(v&&console.error(v),e=!1,r.length>0){const L=r.slice(0);r=[],L.forEach(I=>t(I))}})||w.isWindows)&&(e=!0)};return{send:t}}i.createQueuedSender=o;var a;(function(n){async function r(e,t,s){if(D.isAbsolute(e))return e;if(t===void 0&&(t=l.cwd()),D.dirname(e)!=="."||(s===void 0&&y.isString(l.env.PATH)&&(s=l.env.PATH.split(D.delimiter)),s===void 0||s.length===0))return D.join(t,e);async function v(L){if(await c.Promises.exists(L)){let I;try{I=await c.Promises.stat(L)}catch(O){O.message.startsWith("EACCES")&&(I=await c.Promises.lstat(L))}return I?!I.isDirectory():!1}return!1}for(let L of s){let I;if(D.isAbsolute(L)?I=D.join(L,e):I=D.join(t,L,e),await v(I))return I;let O=I+".com";if(await v(O)||(O=I+".exe",await v(O)))return O}return D.join(t,e)}n.findExecutable=r})(a=i.win32||(i.win32={}))}),define(J[71],Q([0,1,33,12,65,49]),function(x,i,T,P,b,R){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.getSystemShellSync=i.getSystemShell=void 0;async function D(E,u){return E===1?P.isWindows?C():R.getWindowsShell(u):p(E,u)}i.getSystemShell=D;function w(E,u){return E===1?P.isWindows?c(u):R.getWindowsShell(u):p(E,u)}i.getSystemShellSync=w;let l=null;function p(E,u){if(P.isLinux&&E===2||P.isMacintosh&&E===3)return"/bin/bash";if(!l){let h;if(P.isWindows)h="/bin/bash";else{if(h=u.SHELL,!h)try{h=(0,T.userInfo)().shell}catch(g){}h||(h="sh"),h==="/bin/false"&&(h="/bin/bash")}l=h}return l}let y=null;async function C(){return y||(y=(await(0,b.getFirstAvailablePowerShellInstallation)()).exePath),y}function c(E){if(y)return y;const u=P.isWindows&&parseFloat((0,T.release)())>=10,h=E.hasOwnProperty("PROCESSOR_ARCHITEW6432"),g=`${E.windir}\\${h?"Sysnative":"System32"}\\WindowsPowerShell\\v1.0\\powershell.exe`;return u?g:R.getWindowsShell(E)}}),define(J[50],Q([0,1,40,3,17,24,60,7,11,2,21,49,39]),function(x,i,T,P,b,R,D,w,l,p,y,C,c){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.Client=i.Server=void 0;class E extends c.ChannelServer{constructor(g){super({send:m=>{try{process.send&&process.send(m.buffer.toString("base64"))}catch(S){}},onMessage:l.Event.fromNodeEventEmitter(process,"message",m=>b.VSBuffer.wrap(Buffer.from(m,"base64")))},g);process.once("disconnect",()=>this.dispose())}}i.Server=E;class u{constructor(g,m){this.modulePath=g,this.options=m,this.activeRequests=new Set,this.channels=new Map,this._onDidProcessExit=new l.Emitter,this.onDidProcessExit=this._onDidProcessExit.event;const S=m&&m.timeout?m.timeout:6e4;this.disposeDelayer=new P.Delayer(S),this.child=null,this._client=null}getChannel(g){const m=this;return{call(S,d,o){return m.requestPromise(g,S,d,o)},listen(S,d){return m.requestEvent(g,S,d)}}}requestPromise(g,m,S,d=R.CancellationToken.None){if(!this.disposeDelayer)return Promise.reject(new Error("disposed"));if(d.isCancellationRequested)return Promise.reject(w.canceled());this.disposeDelayer.cancel();const o=this.getCachedChannel(g),a=(0,P.createCancelablePromise)(e=>o.call(m,S,e)),n=d.onCancellationRequested(()=>a.cancel()),r=(0,p.toDisposable)(()=>a.cancel());return this.activeRequests.add(r),a.finally(()=>{n.dispose(),this.activeRequests.delete(r),this.activeRequests.size===0&&this.disposeDelayer&&this.disposeDelayer.trigger(()=>this.disposeClient())}),a}requestEvent(g,m,S){if(!this.disposeDelayer)return l.Event.None;this.disposeDelayer.cancel();let d;const o=new l.Emitter({onFirstListenerAdd:()=>{d=this.getCachedChannel(g).listen(m,S)(o.fire,o),this.activeRequests.add(d)},onLastListenerRemove:()=>{this.activeRequests.delete(d),d.dispose(),this.activeRequests.size===0&&this.disposeDelayer&&this.disposeDelayer.trigger(()=>this.disposeClient())}});return o.event}get client(){if(!this._client){const g=this.options&&this.options.args?this.options.args:[],m=Object.create(null);m.env={...(0,y.deepClone)(process.env),VSCODE_PARENT_PID:String(process.pid)},this.options&&this.options.env&&(m.env={...m.env,...this.options.env}),this.options&&this.options.freshExecArgv&&(m.execArgv=[]),this.options&&typeof this.options.debug=="number"&&(m.execArgv=["--nolazy","--inspect="+this.options.debug]),this.options&&typeof this.options.debugBrk=="number"&&(m.execArgv=["--nolazy","--inspect-brk="+this.options.debugBrk]),m.execArgv===void 0&&(m.execArgv=process.execArgv.filter(t=>!/^--inspect(-brk)?=/.test(t))),(0,C.removeDangerousEnvVariables)(m.env),this.child=(0,T.fork)(this.modulePath,g,m);const S=new l.Emitter;l.Event.fromNodeEventEmitter(this.child,"message",t=>t)(t=>{if((0,D.isRemoteConsoleLog)(t)){(0,D.log)(t,`IPC Library: ${this.options.serverName}`);return}S.fire(b.VSBuffer.wrap(Buffer.from(t,"base64")))});const o=this.options.useQueue?(0,C.createQueuedSender)(this.child):this.child,a=t=>this.child&&this.child.connected&&o.send(t.buffer.toString("base64")),n=S.event,r={send:a,onMessage:n};this._client=new c.ChannelClient(r);const e=()=>this.disposeClient();process.once("exit",e),this.child.on("error",t=>console.warn('IPC "'+this.options.serverName+'" errored with '+t)),this.child.on("exit",(t,s)=>{process.removeListener("exit",e),this.activeRequests.forEach(f=>(0,p.dispose)(f)),this.activeRequests.clear(),t!==0&&s!=="SIGTERM"&&console.warn('IPC "'+this.options.serverName+'" crashed with exit code '+t+" and signal "+s),this.disposeDelayer&&this.disposeDelayer.cancel(),this.disposeClient(),this._onDidProcessExit.fire({code:t,signal:s})})}return this._client}getCachedChannel(g){let m=this.channels.get(g);return m||(m=this.client.getChannel(g),this.channels.set(g,m)),m}disposeClient(){this._client&&(this.child&&(this.child.kill(),this.child=null),this._client=null,this.channels.clear())}dispose(){this._onDidProcessExit.dispose(),this.disposeDelayer&&(this.disposeDelayer.cancel(),this.disposeDelayer=void 0),this.disposeClient(),this.activeRequests.clear()}}i.Client=u}),define(J[72],Q([4,5]),function(x,i){return x.create("vs/base/node/zip",i)}),define(J[73],Q([4,5]),function(x,i){return x.create("vs/platform/configuration/common/configurationRegistry",i)}),define(J[74],Q([4,5]),function(x,i){return x.create("vs/platform/environment/node/shellEnv",i)}),define(J[75],Q([4,5]),function(x,i){return x.create("vs/platform/extensionManagement/common/abstractExtensionManagementService",i)}),define(J[76],Q([4,5]),function(x,i){return x.create("vs/platform/extensionManagement/common/extensionManagement",i)}),define(J[77],Q([4,5]),function(x,i){return x.create("vs/platform/extensionManagement/common/extensionManagementCLIService",i)}),define(J[78],Q([4,5]),function(x,i){return x.create("vs/platform/extensionManagement/node/extensionManagementService",i)}),define(J[79],Q([4,5]),function(x,i){return x.create("vs/platform/extensionManagement/node/extensionManagementUtil",i)}),define(J[80],Q([4,5]),function(x,i){return x.create("vs/platform/extensionManagement/node/extensionsScanner",i)}),define(J[81],Q([4,5]),function(x,i){return x.create("vs/platform/extensions/common/extensionValidator",i)}),define(J[82],Q([4,5]),function(x,i){return x.create("vs/platform/files/common/fileService",i)}),define(J[83],Q([4,5]),function(x,i){return x.create("vs/platform/files/common/io",i)}),define(J[84],Q([4,5]),function(x,i){return x.create("vs/platform/files/node/diskFileSystemProvider",i)}),define(J[85],Q([4,5]),function(x,i){return x.create("vs/platform/request/common/request",i)}),define(J[86],Q([4,5]),function(x,i){return x.create("vs/platform/telemetry/common/telemetryService",i)}),define(J[87],Q([0,1,68,46,10,6,28,18,9]),function(x,i,T,P,b,R,D,w,l){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.parsePtyHostPort=i.parseSearchPort=i.parseExtensionHostPort=i.AbstractNativeEnvironmentService=void 0;class p{constructor(h,g,m){this._args=h,this.paths=g,this.productService=m}get appRoot(){return(0,R.dirname)(b.FileAccess.asFileUri("",x).fsPath)}get userHome(){return l.URI.file(this.paths.homeDir)}get userDataPath(){return this.paths.userDataDir}get appSettingsHome(){return l.URI.file((0,R.join)(this.userDataPath,"User"))}get tmpDir(){return l.URI.file(this.paths.tmpDir)}get cacheHome(){return l.URI.file(this.userDataPath)}get userRoamingDataHome(){return this.appSettingsHome}get settingsResource(){return(0,w.joinPath)(this.userRoamingDataHome,"settings.json")}get userDataSyncHome(){return(0,w.joinPath)(this.userRoamingDataHome,"sync")}get logsPath(){if(!this.args.logsPath){const h=(0,T.toLocalISOString)(new Date).replace(/-|:|\.\d+Z$/g,"");this.args.logsPath=(0,R.join)(this.userDataPath,"logs",h)}return this.args.logsPath}get userDataSyncLogResource(){return l.URI.file((0,R.join)(this.logsPath,"userDataSync.log"))}get sync(){return this.args.sync}get machineSettingsResource(){return(0,w.joinPath)(l.URI.file((0,R.join)(this.userDataPath,"Machine")),"settings.json")}get globalStorageHome(){return l.URI.joinPath(this.appSettingsHome,"globalStorage")}get workspaceStorageHome(){return l.URI.joinPath(this.appSettingsHome,"workspaceStorage")}get keybindingsResource(){return(0,w.joinPath)(this.userRoamingDataHome,"keybindings.json")}get keyboardLayoutResource(){return(0,w.joinPath)(this.userRoamingDataHome,"keyboardLayout.json")}get argvResource(){const h=D.env.VSCODE_PORTABLE;return h?l.URI.file((0,R.join)(h,"argv.json")):(0,w.joinPath)(this.userHome,this.productService.dataFolderName,"argv.json")}get snippetsHome(){return(0,w.joinPath)(this.userRoamingDataHome,"snippets")}get isExtensionDevelopment(){return!!this.args.extensionDevelopmentPath}get untitledWorkspacesHome(){return l.URI.file((0,R.join)(this.userDataPath,"Workspaces"))}get installSourcePath(){return(0,R.join)(this.userDataPath,"installSource")}get builtinExtensionsPath(){const h=this.args["builtin-extensions-dir"];return h?(0,R.resolve)(h):(0,R.normalize)((0,R.join)(b.FileAccess.asFileUri("",x).fsPath,"..","extensions"))}get extensionsDownloadPath(){const h=this.args["extensions-download-dir"];return h?(0,R.resolve)(h):(0,R.join)(this.userDataPath,"CachedExtensionVSIXs")}get extensionsPath(){const h=this.args["extensions-dir"];if(h)return(0,R.resolve)(h);const g=D.env.VSCODE_EXTENSIONS;if(g)return g;const m=D.env.VSCODE_PORTABLE;return m?(0,R.join)(m,"extensions"):(0,w.joinPath)(this.userHome,this.productService.dataFolderName,"extensions").fsPath}get extensionDevelopmentLocationURI(){const h=this.args.extensionDevelopmentPath;if(Array.isArray(h))return h.map(g=>/^[^:/?#]+?:\/\//.test(g)?l.URI.parse(g):l.URI.file((0,R.normalize)(g)))}get extensionDevelopmentKind(){return this.args.extensionDevelopmentKind?.map(h=>h==="ui"||h==="workspace"||h==="web"?h:"workspace")}get extensionTestsLocationURI(){const h=this.args.extensionTestsPath;if(h)return/^[^:/?#]+?:\/\//.test(h)?l.URI.parse(h):l.URI.file((0,R.normalize)(h))}get disableExtensions(){if(this.args["disable-extensions"])return!0;const h=this.args["disable-extension"];if(h){if(typeof h=="string")return[h];if(Array.isArray(h)&&h.length>0)return h}return!1}get debugExtensionHost(){return y(this.args,this.isBuilt)}get debugRenderer(){return!!this.args.debugRenderer}get isBuilt(){return!D.env.VSCODE_DEV}get verbose(){return!!this.args.verbose}get logLevel(){return this.args.log}get serviceMachineIdResource(){return(0,w.joinPath)(l.URI.file(this.userDataPath),"machineid")}get crashReporterId(){return this.args["crash-reporter-id"]}get crashReporterDirectory(){return this.args["crash-reporter-directory"]}get driverHandle(){return this.args.driver}get telemetryLogResource(){return l.URI.file((0,R.join)(this.logsPath,"telemetry.log"))}get disableTelemetry(){return!!this.args["disable-telemetry"]}get disableWorkspaceTrust(){return!!this.args["disable-workspace-trust"]}get args(){return this._args}}ve([P.memoize],p.prototype,"appRoot",null),ve([P.memoize],p.prototype,"userHome",null),ve([P.memoize],p.prototype,"userDataPath",null),ve([P.memoize],p.prototype,"appSettingsHome",null),ve([P.memoize],p.prototype,"tmpDir",null),ve([P.memoize],p.prototype,"cacheHome",null),ve([P.memoize],p.prototype,"userRoamingDataHome",null),ve([P.memoize],p.prototype,"settingsResource",null),ve([P.memoize],p.prototype,"userDataSyncHome",null),ve([P.memoize],p.prototype,"userDataSyncLogResource",null),ve([P.memoize],p.prototype,"sync",null),ve([P.memoize],p.prototype,"machineSettingsResource",null),ve([P.memoize],p.prototype,"globalStorageHome",null),ve([P.memoize],p.prototype,"workspaceStorageHome",null),ve([P.memoize],p.prototype,"keybindingsResource",null),ve([P.memoize],p.prototype,"keyboardLayoutResource",null),ve([P.memoize],p.prototype,"argvResource",null),ve([P.memoize],p.prototype,"snippetsHome",null),ve([P.memoize],p.prototype,"isExtensionDevelopment",null),ve([P.memoize],p.prototype,"untitledWorkspacesHome",null),ve([P.memoize],p.prototype,"installSourcePath",null),ve([P.memoize],p.prototype,"builtinExtensionsPath",null),ve([P.memoize],p.prototype,"extensionsPath",null),ve([P.memoize],p.prototype,"extensionDevelopmentLocationURI",null),ve([P.memoize],p.prototype,"extensionDevelopmentKind",null),ve([P.memoize],p.prototype,"extensionTestsLocationURI",null),ve([P.memoize],p.prototype,"debugExtensionHost",null),ve([P.memoize],p.prototype,"serviceMachineIdResource",null),ve([P.memoize],p.prototype,"telemetryLogResource",null),ve([P.memoize],p.prototype,"disableWorkspaceTrust",null),i.AbstractNativeEnvironmentService=p;function y(u,h){return E(u["inspect-extensions"],u["inspect-brk-extensions"],5870,h,u.debugId,u.extensionEnvironment)}i.parseExtensionHostPort=y;function C(u,h){return E(u["inspect-search"],u["inspect-brk-search"],5876,h,u.extensionEnvironment)}i.parseSearchPort=C;function c(u,h){return E(u["inspect-ptyhost"],u["inspect-brk-ptyhost"],5877,h,u.extensionEnvironment)}i.parsePtyHostPort=c;function E(u,h,g,m,S,d){const a=Number(h||u)||(m?null:g),n=a?Boolean(!!h):!1;let r;if(d)try{r=JSON.parse(d)}catch{}return{port:a,break:n,debugId:S,env:r}}}),function(){"use strict";function x(i,T,P,b){function R(w){const l=D(w),p=[l];return i.isAbsolute(l)||p.unshift(b),i.resolve(...p)}function D(w){const l=process.env.VSCODE_PORTABLE;if(l)return i.join(l,"user-data");let p=process.env.VSCODE_APPDATA;if(p)return i.join(p,P);const y=w["user-data-dir"];if(y)return y;switch(process.platform){case"win32":if(p=process.env.APPDATA,!p){const C=process.env.USERPROFILE;if(typeof C!="string")throw new Error("Windows: Unexpected undefined %USERPROFILE% environment variable");p=i.join(C,"AppData","Roaming")}break;case"darwin":p=i.join(T.homedir(),"Library","Application Support");break;case"linux":p=process.env.XDG_CONFIG_HOME||i.join(T.homedir(),".config");break;default:throw new Error("Platform not supported")}return i.join(p,P)}return{getUserDataPath:R}}if(typeof define=="function")define(J[88],Q([0,132,33,10,18,28]),function(i,T,P,b,R,D){const w=R.dirname(b.FileAccess.asFileUri("",i)),l=i.__$__nodeRequire(R.joinPath(w,"package.json").fsPath);return x(T,P,l.name,D.cwd())});else if(typeof module=="object"&&typeof module.exports=="object"){const i=require("../../../../../package.json"),T=require("path"),P=require("os");module.exports=x(T,P,i.name,process.env.VSCODE_CWD||process.cwd())}else throw new Error("Unknown context")}(),define(J[89],Q([0,1,33,87,88]),function(x,i,T,P,b){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.NativeEnvironmentService=void 0;class R extends P.AbstractNativeEnvironmentService{constructor(w,l){super(w,{homeDir:(0,T.homedir)(),tmpDir:(0,T.tmpdir)(),userDataDir:(0,b.getUserDataPath)(w)},l)}}i.NativeEnvironmentService=R}),define(J[90],Q([0,1,21]),function(x,i,T){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.localizeManifest=void 0;const P=/^%([\w\d.-]+)%$/i;function b(R,D){const w=l=>{if(typeof l!="string")return;const p=P.exec(l);if(!p)return;const y=D[p[1]]??l;return typeof y=="string"?y:typeof y.message=="string"?y.message:l};return(0,T.cloneAndChange)(R,w)}i.localizeManifest=b}),define(J[51],Q([0,1,81]),function(x,i,T){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.isEngineValid=i.isValidExtensionVersion=i.isValidVersion=i.normalizeVersion=i.parseVersion=i.isValidVersionStr=void 0;const P=/^(\^|>=)?((\d+)|x)\.((\d+)|x)\.((\d+)|x)(\-.*)?$/,b=/^-(\d{4})(\d{2})(\d{2})$/;function R(c){return c=c.trim(),c==="*"||P.test(c)}i.isValidVersionStr=R;function D(c){if(!R(c))return null;if(c=c.trim(),c==="*")return{hasCaret:!1,hasGreaterEquals:!1,majorBase:0,majorMustEqual:!1,minorBase:0,minorMustEqual:!1,patchBase:0,patchMustEqual:!1,preRelease:null};let E=c.match(P);return E?{hasCaret:E[1]==="^",hasGreaterEquals:E[1]===">=",majorBase:E[2]==="x"?0:parseInt(E[2],10),majorMustEqual:E[2]!=="x",minorBase:E[4]==="x"?0:parseInt(E[4],10),minorMustEqual:E[4]!=="x",patchBase:E[6]==="x"?0:parseInt(E[6],10),patchMustEqual:E[6]!=="x",preRelease:E[8]||null}:null}i.parseVersion=D;function w(c){if(!c)return null;let E=c.majorBase,u=c.majorMustEqual,h=c.minorBase,g=c.minorMustEqual,m=c.patchBase,S=c.patchMustEqual;c.hasCaret&&(E===0||(g=!1),S=!1);let d=0;if(c.preRelease){const o=b.exec(c.preRelease);if(o){const[,a,n,r]=o;d=Date.UTC(Number(a),Number(n)-1,Number(r))}}return{majorBase:E,majorMustEqual:u,minorBase:h,minorMustEqual:g,patchBase:m,patchMustEqual:S,isMinimum:c.hasGreaterEquals,notBefore:d}}i.normalizeVersion=w;function l(c,E,u){let h;typeof c=="string"?h=w(D(c)):h=c;let g;E instanceof Date?g=E.getTime():typeof E=="string"&&(g=new Date(E).getTime());let m;if(typeof u=="string"?m=w(D(u)):m=u,!h||!m)return!1;let S=h.majorBase,d=h.minorBase,o=h.patchBase,a=m.majorBase,n=m.minorBase,r=m.patchBase,e=m.notBefore,t=m.majorMustEqual,s=m.minorMustEqual,f=m.patchMustEqual;return m.isMinimum?S>a?!0:S<a?!1:d>n?!0:d<n||g&&g<e?!1:o>=r:(S===1&&a===0&&(!t||!s||!f)&&(a=1,n=0,r=0,t=!0,s=!1,f=!1),S<a?!1:S>a?!t:d<n?!1:d>n?!s:o<r?!1:o>r?!f:!(g&&g<e))}i.isValidVersion=l;function p(c,E,u,h){return u.isBuiltin||typeof u.main=="undefined"?!0:C(c,E,u.engines.vscode,h)}i.isValidExtensionVersion=p;function y(c,E,u){return c==="*"||C(E,u,c)}i.isEngineValid=y;function C(c,E,u,h=[]){let g=w(D(u));if(!g)return h.push(T.localize(0,null,u)),!1;if(g.majorBase===0){if(!g.majorMustEqual||!g.minorMustEqual)return h.push(T.localize(1,null,u)),!1}else if(!g.majorMustEqual)return h.push(T.localize(2,null,u)),!1;return l(c,E,g)?!0:(h.push(T.localize(3,null,c,u)),!1)}}),define(J[41],Q([0,1]),function(x,i){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.SyncDescriptor=void 0;class T{constructor(b,R=[],D=!1){this.ctor=b,this.staticArguments=R,this.supportsDelayedInstantiation=D}}i.SyncDescriptor=T}),define(J[91],Q([0,1,41]),function(x,i,T){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.getSingletonServiceDescriptors=i.registerSingleton=void 0;const P=[];function b(D,w,l){w instanceof T.SyncDescriptor||(w=new T.SyncDescriptor(w,[],l)),P.push([D,w])}i.registerSingleton=b;function R(){return P}i.getSingletonServiceDescriptors=R}),define(J[92],Q([0,1]),function(x,i){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.Graph=i.Node=void 0;class T{constructor(R){this.incoming=new Map,this.outgoing=new Map,this.data=R}}i.Node=T;class P{constructor(R){this._hashFn=R,this._nodes=new Map}roots(){const R=[];for(let D of this._nodes.values())D.outgoing.size===0&&R.push(D);return R}insertEdge(R,D){const w=this.lookupOrInsertNode(R),l=this.lookupOrInsertNode(D);w.outgoing.set(this._hashFn(D),l),l.incoming.set(this._hashFn(R),w)}removeNode(R){const D=this._hashFn(R);this._nodes.delete(D);for(let w of this._nodes.values())w.outgoing.delete(D),w.incoming.delete(D)}lookupOrInsertNode(R){const D=this._hashFn(R);let w=this._nodes.get(D);return w||(w=new T(R),this._nodes.set(D,w)),w}lookup(R){return this._nodes.get(this._hashFn(R))}isEmpty(){return this._nodes.size===0}toString(){let R=[];for(let[D,w]of this._nodes)R.push(`${D}, (incoming)[${[...w.incoming.keys()].join(", ")}], (outgoing)[${[...w.outgoing.keys()].join(",")}]`);return R.join(`
`)}findCycleSlow(){for(let[R,D]of this._nodes){const w=new Set([R]),l=this._findCycle(D,w);if(l)return l}}_findCycle(R,D){for(let[w,l]of R.outgoing){if(D.has(w))return[...D,w].join(" -> ");D.add(w);const p=this._findCycle(l,D);if(p)return p;D.delete(w)}}}i.Graph=P}),define(J[25],Q([0,1,8,9,14]),function(x,i,T,P,b){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.getMigratedSettingValue=i.merge=i.getConfigurationValue=i.removeFromValueTree=i.addToValueTree=i.toValuesTree=i.ConfigurationTargetToString=i.ConfigurationTarget=i.isConfigurationUpdateOverrides=i.isConfigurationOverrides=i.IConfigurationService=void 0,i.IConfigurationService=(0,b.createDecorator)("configurationService");function R(g){return g&&typeof g=="object"&&(!g.overrideIdentifier||typeof g.overrideIdentifier=="string")&&(!g.resource||g.resource instanceof P.URI)}i.isConfigurationOverrides=R;function D(g){return g&&typeof g=="object"&&(!g.overrideIdentifiers||T.isArray(g.overrideIdentifiers))&&!g.overrideIdentifier&&(!g.resource||g.resource instanceof P.URI)}i.isConfigurationUpdateOverrides=D;var w;(function(g){g[g.USER=1]="USER",g[g.USER_LOCAL=2]="USER_LOCAL",g[g.USER_REMOTE=3]="USER_REMOTE",g[g.WORKSPACE=4]="WORKSPACE",g[g.WORKSPACE_FOLDER=5]="WORKSPACE_FOLDER",g[g.DEFAULT=6]="DEFAULT",g[g.MEMORY=7]="MEMORY"})(w=i.ConfigurationTarget||(i.ConfigurationTarget={}));function l(g){switch(g){case 1:return"USER";case 2:return"USER_LOCAL";case 3:return"USER_REMOTE";case 4:return"WORKSPACE";case 5:return"WORKSPACE_FOLDER";case 6:return"DEFAULT";case 7:return"MEMORY"}}i.ConfigurationTargetToString=l;function p(g,m){const S=Object.create(null);for(let d in g)y(S,d,g[d],m);return S}i.toValuesTree=p;function y(g,m,S,d){const o=m.split("."),a=o.pop();let n=g;for(let r=0;r<o.length;r++){let e=o[r],t=n[e];switch(typeof t){case"undefined":t=n[e]=Object.create(null);break;case"object":break;default:d(`Ignoring ${m} as ${o.slice(0,r+1).join(".")} is ${JSON.stringify(t)}`);return}n=t}if(typeof n=="object"&&n!==null)try{n[a]=S}catch(r){d(`Ignoring ${m} as ${o.join(".")} is ${JSON.stringify(n)}`)}else d(`Ignoring ${m} as ${o.join(".")} is ${JSON.stringify(n)}`)}i.addToValueTree=y;function C(g,m){const S=m.split(".");c(g,S)}i.removeFromValueTree=C;function c(g,m){const S=m.shift();if(m.length===0){delete g[S];return}if(Object.keys(g).indexOf(S)!==-1){const d=g[S];typeof d=="object"&&!Array.isArray(d)&&(c(d,m),Object.keys(d).length===0&&delete g[S])}}function E(g,m,S){function d(n,r){let e=n;for(const t of r){if(typeof e!="object"||e===null)return;e=e[t]}return e}const o=m.split("."),a=d(g,o);return typeof a=="undefined"?S:a}i.getConfigurationValue=E;function u(g,m,S){Object.keys(m).forEach(d=>{d!=="__proto__"&&(d in g?T.isObject(g[d])&&T.isObject(m[d])?u(g[d],m[d],S):S&&(g[d]=m[d]):g[d]=m[d])})}i.merge=u;function h(g,m,S){const d=g.inspect(m),o=g.inspect(S);return typeof d.userValue!="undefined"||typeof d.workspaceValue!="undefined"||typeof d.workspaceFolderValue!="undefined"?d.value:typeof o.userValue!="undefined"||typeof o.workspaceValue!="undefined"||typeof o.workspaceFolderValue!="undefined"?o.value:d.defaultValue}i.getMigratedSettingValue=h}),define(J[52],Q([0,1,14]),function(x,i,T){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.IDownloadService=void 0,i.IDownloadService=(0,T.createDecorator)("downloadService")}),define(J[20],Q([0,1,14]),function(x,i,T){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.INativeEnvironmentService=i.IEnvironmentService=void 0,i.IEnvironmentService=(0,T.createDecorator)("environmentService"),i.INativeEnvironmentService=(0,T.refineServiceDecorator)(i.IEnvironmentService)}),define(J[22],Q([0,1,10,76,14]),function(x,i,T,P,b){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.IExtensionManagementCLIService=i.PreferencesLocalizedLabel=i.PreferencesLabel=i.ExtensionsChannelId=i.ExtensionsLocalizedLabel=i.ExtensionsLabel=i.DefaultIconPath=i.IExtensionTipsService=i.IGlobalExtensionEnablementService=i.ENABLED_EXTENSIONS_STORAGE_PATH=i.DISABLED_EXTENSIONS_STORAGE_PATH=i.IExtensionManagementService=i.ExtensionManagementError=i.ExtensionManagementErrorCode=i.IExtensionGalleryService=i.InstallOperation=i.StatisticType=i.SortOrder=i.SortBy=i.isIExtensionIdentifier=i.getFallbackTargetPlarforms=i.isTargetPlatformCompatible=i.isNotWebExtensionInWebTargetPlatform=i.getTargetPlatform=i.toTargetPlatform=i.TargetPlatformToString=i.TargetPlatform=i.WEB_EXTENSION_TAG=i.EXTENSION_IDENTIFIER_REGEX=i.EXTENSION_IDENTIFIER_PATTERN=void 0,i.EXTENSION_IDENTIFIER_PATTERN="^([a-z0-9A-Z][a-z0-9-A-Z]*)\\.([a-z0-9A-Z][a-z0-9-A-Z]*)$",i.EXTENSION_IDENTIFIER_REGEX=new RegExp(i.EXTENSION_IDENTIFIER_PATTERN),i.WEB_EXTENSION_TAG="__web_extension";var R;(function(d){d.WIN32_X64="win32-x64",d.WIN32_IA32="win32-ia32",d.WIN32_ARM64="win32-arm64",d.LINUX_X64="linux-x64",d.LINUX_ARM64="linux-arm64",d.LINUX_ARMHF="linux-armhf",d.ALPINE_X64="alpine-x64",d.ALPINE_ARM64="alpine-arm64",d.DARWIN_X64="darwin-x64",d.DARWIN_ARM64="darwin-arm64",d.WEB="web",d.UNIVERSAL="universal",d.UNKNOWN="unknown",d.UNDEFINED="undefined"})(R=i.TargetPlatform||(i.TargetPlatform={}));function D(d){switch(d){case"win32-x64":return"Windows 64 bit";case"win32-ia32":return"Windows 32 bit";case"win32-arm64":return"Windows ARM";case"linux-x64":return"Linux 64 bit";case"linux-arm64":return"Linux ARM 64";case"linux-armhf":return"Linux ARM";case"alpine-x64":return"Alpine Linux 64 bit";case"alpine-arm64":return"Alpine ARM 64";case"darwin-x64":return"Mac";case"darwin-arm64":return"Mac Silicon";case"web":return"Web";case"universal":return"universal";case"unknown":return"unknown";case"undefined":return"undefined"}}i.TargetPlatformToString=D;function w(d){switch(d){case"win32-x64":return"win32-x64";case"win32-ia32":return"win32-ia32";case"win32-arm64":return"win32-arm64";case"linux-x64":return"linux-x64";case"linux-arm64":return"linux-arm64";case"linux-armhf":return"linux-armhf";case"alpine-x64":return"alpine-x64";case"alpine-arm64":return"alpine-arm64";case"darwin-x64":return"darwin-x64";case"darwin-arm64":return"darwin-arm64";case"web":return"web";case"universal":return"universal";default:return"unknown"}}i.toTargetPlatform=w;function l(d,o){switch(d){case 3:return o==="x64"?"win32-x64":o==="ia32"?"win32-ia32":o==="arm64"?"win32-arm64":"unknown";case 2:return o==="x64"?"linux-x64":o==="arm64"?"linux-arm64":o==="arm"?"linux-armhf":"unknown";case"alpine":return o==="x64"?"alpine-x64":o==="arm64"?"alpine-arm64":"unknown";case 1:return o==="x64"?"darwin-x64":o==="arm64"?"darwin-arm64":"unknown";case 0:return"web"}}i.getTargetPlatform=l;function p(d,o){return o==="web"&&!d.includes("web")}i.isNotWebExtensionInWebTargetPlatform=p;function y(d,o,a){return p(o,a)?!1:d==="undefined"||d==="universal"?!0:d==="unknown"?!1:d===a?!0:C(a).includes(d)}i.isTargetPlatformCompatible=y;function C(d){switch(d){case"win32-x64":return["win32-ia32"];case"win32-arm64":return["win32-ia32"]}return[]}i.getFallbackTargetPlarforms=C;function c(d){return d&&typeof d=="object"&&typeof d.id=="string"&&(!d.uuid||typeof d.uuid=="string")}i.isIExtensionIdentifier=c;var E;(function(d){d[d.NoneOrRelevance=0]="NoneOrRelevance",d[d.LastUpdatedDate=1]="LastUpdatedDate",d[d.Title=2]="Title",d[d.PublisherName=3]="PublisherName",d[d.InstallCount=4]="InstallCount",d[d.PublishedDate=10]="PublishedDate",d[d.AverageRating=6]="AverageRating",d[d.WeightedRating=12]="WeightedRating"})(E=i.SortBy||(i.SortBy={}));var u;(function(d){d[d.Default=0]="Default",d[d.Ascending=1]="Ascending",d[d.Descending=2]="Descending"})(u=i.SortOrder||(i.SortOrder={}));var h;(function(d){d.Install="install",d.Uninstall="uninstall"})(h=i.StatisticType||(i.StatisticType={}));var g;(function(d){d[d.None=1]="None",d[d.Install=2]="Install",d[d.Update=3]="Update",d[d.Migrate=4]="Migrate"})(g=i.InstallOperation||(i.InstallOperation={})),i.IExtensionGalleryService=(0,b.createDecorator)("extensionGalleryService");var m;(function(d){d.Unsupported="Unsupported",d.UnsupportedPreRelease="UnsupportedPreRelease",d.Malicious="Malicious",d.Incompatible="Incompatible",d.IncompatiblePreRelease="IncompatiblePreRelease",d.IncompatibleTargetPlatform="IncompatibleTargetPlatform",d.Invalid="Invalid",d.Download="Download",d.Extract="Extract",d.Delete="Delete",d.Rename="Rename",d.CorruptZip="CorruptZip",d.IncompleteZip="IncompleteZip",d.Internal="Internal"})(m=i.ExtensionManagementErrorCode||(i.ExtensionManagementErrorCode={}));class S extends Error{constructor(o,a){super(o);this.code=a,this.name=a}}i.ExtensionManagementError=S,i.IExtensionManagementService=(0,b.createDecorator)("extensionManagementService"),i.DISABLED_EXTENSIONS_STORAGE_PATH="extensionsIdentifiers/disabled",i.ENABLED_EXTENSIONS_STORAGE_PATH="extensionsIdentifiers/enabled",i.IGlobalExtensionEnablementService=(0,b.createDecorator)("IGlobalExtensionEnablementService"),i.IExtensionTipsService=(0,b.createDecorator)("IExtensionTipsService"),i.DefaultIconPath=T.FileAccess.asBrowserUri("./media/defaultIcon.png",x).toString(!0),i.ExtensionsLabel=(0,P.localize)(0,null),i.ExtensionsLocalizedLabel={value:i.ExtensionsLabel,original:"Extensions"},i.ExtensionsChannelId="extensions",i.PreferencesLabel=(0,P.localize)(1,null),i.PreferencesLocalizedLabel={value:i.PreferencesLabel,original:"Preferences"},i.IExtensionManagementCLIService=(0,b.createDecorator)("IExtensionManagementCLIService")}),define(J[93],Q([0,1,40,6,74,24,27,7,12,31,71,133,3]),function(x,i,T,P,b,R,D,w,l,p,y,C,c){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.getResolvedShellEnv=void 0;const E=1e4;let u;async function h(m,S,d){return S["force-disable-user-env"]?(m.trace("resolveShellEnv(): skipped (--force-disable-user-env)"),{}):l.isWindows?(m.trace("resolveShellEnv(): skipped (Windows)"),{}):(0,C.isLaunchedFromCli)(d)&&!S["force-user-env"]?(m.trace("resolveShellEnv(): skipped (VSCODE_CLI is set)"),{}):((0,C.isLaunchedFromCli)(d)?m.trace("resolveShellEnv(): running (--force-user-env)"):m.trace("resolveShellEnv(): running (macOS/Linux)"),u||(u=c.Promises.withAsyncBody(async(o,a)=>{const n=new R.CancellationTokenSource,r=setTimeout(()=>{n.dispose(!0),a(new Error((0,b.localize)(0,null)))},E);try{o(await g(m,n.token))}catch(e){!(0,w.isPromiseCanceledError)(e)&&!n.token.isCancellationRequested?a(new Error((0,b.localize)(1,null,(0,D.toErrorMessage)(e)))):o({})}finally{clearTimeout(r),n.dispose()}})),u)}i.getResolvedShellEnv=h;async function g(m,S){const d=process.env.ELECTRON_RUN_AS_NODE;m.trace("getUnixShellEnvironment#runAsNode",d);const o=process.env.ELECTRON_NO_ATTACH_CONSOLE;m.trace("getUnixShellEnvironment#noAttach",o);const a=(0,p.generateUuid)().replace(/-/g,"").substr(0,12),n=new RegExp(a+"(.*)"+a),r={...process.env,ELECTRON_RUN_AS_NODE:"1",ELECTRON_NO_ATTACH_CONSOLE:"1"};m.trace("getUnixShellEnvironment#env",r);const e=await(0,y.getSystemShell)(l.OS,r);return m.trace("getUnixShellEnvironment#shell",e),new Promise((t,s)=>{if(S.isCancellationRequested)return s((0,w.canceled)());const f=(0,P.basename)(e);let v,L;const I=process.versions.electron&&process.versions["microsoft-build"]?"--ms-enable-electron-run-as-node":"";/^pwsh(-preview)?$/.test(f)?(v=`& '${process.execPath}' ${I} -p '''${a}'' + JSON.stringify(process.env) + ''${a}'''`,L=["-Login","-Command"]):(v=`'${process.execPath}' ${I} -p '"${a}" + JSON.stringify(process.env) + "${a}"'`,f==="tcsh"?L=["-ic"]:L=["-ilc"]),m.trace("getUnixShellEnvironment#spawn",JSON.stringify(L),v);const O=(0,T.spawn)(e,[...L,v],{detached:!0,stdio:["ignore","pipe","pipe"],env:r});S.onCancellationRequested(()=>(O.kill(),s((0,w.canceled)()))),O.on("error",ee=>{m.error("getUnixShellEnvironment#errorChildProcess",(0,D.toErrorMessage)(ee)),s(ee)});const N=[];O.stdout.on("data",ee=>N.push(ee));const G=[];O.stderr.on("data",ee=>G.push(ee)),O.on("close",(ee,ge)=>{const ce=Buffer.concat(N).toString("utf8");m.trace("getUnixShellEnvironment#raw",ce);const te=Buffer.concat(G).toString("utf8");if(te.trim()&&m.trace("getUnixShellEnvironment#stderr",te),ee||ge)return s(new Error((0,b.localize)(2,null,ee,ge)));const he=n.exec(ce),W=he?he[1]:"{}";try{const B=JSON.parse(W);d?B.ELECTRON_RUN_AS_NODE=d:delete B.ELECTRON_RUN_AS_NODE,o?B.ELECTRON_NO_ATTACH_CONSOLE=o:delete B.ELECTRON_NO_ATTACH_CONSOLE,delete B.XDG_RUNTIME_DIR,m.trace("getUnixShellEnvironment#result",B),t(B)}catch(B){m.error("getUnixShellEnvironment#errorCaught",(0,D.toErrorMessage)(B)),s(B)}})})}}),define(J[53],Q([0,1,17,7,83,16]),function(x,i,T,P,b,R){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.readFileIntoStream=void 0;async function D(y,C,c,E,u,h){let g;try{await w(y,C,c,E,u,h)}catch(m){g=m}finally{g&&u.errorTransformer&&(g=u.errorTransformer(g)),typeof g!="undefined"&&c.error(g),c.end()}}i.readFileIntoStream=D;async function w(y,C,c,E,u,h){l(h);const g=await y.open(C,{create:!1});try{l(h);let m=0,S=0,d=u&&typeof u.length=="number"?u.length:void 0,o=T.VSBuffer.alloc(Math.min(u.bufferSize,typeof d=="number"?d:u.bufferSize)),a=u&&typeof u.position=="number"?u.position:0,n=0;do S=await y.read(g,a,o.buffer,n,o.byteLength-n),a+=S,n+=S,m+=S,typeof d=="number"&&(d-=S),n===o.byteLength&&(await c.write(E(o)),o=T.VSBuffer.alloc(Math.min(u.bufferSize,typeof d=="number"?d:u.bufferSize)),n=0);while(S>0&&(typeof d!="number"||d>0)&&l(h)&&p(m,u));if(n>0){let r=n;typeof d=="number"&&(r=Math.min(n,d)),c.write(E(o.slice(0,r)))}}catch(m){throw(0,R.ensureFileSystemProviderError)(m)}finally{await y.close(g)}}function l(y){if(y.isCancellationRequested)throw(0,P.canceled)();return!0}function p(y,C){if(C?.limits){if(typeof C.limits.memory=="number"&&y>C.limits.memory)throw(0,R.createFileSystemProviderError)((0,b.localize)(0,null),R.FileSystemProviderErrorCode.FileExceedsMemoryLimit);if(typeof C.limits.size=="number"&&y>C.limits.size)throw(0,R.createFileSystemProviderError)((0,b.localize)(1,null),R.FileSystemProviderErrorCode.FileTooLarge)}return!0}}),define(J[34],Q([0,1,2,12,9,16]),function(x,i,T,P,b,R){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.coalesceEvents=i.toFileChanges=i.WatcherService=i.AbstractWatcherService=void 0;class D extends T.Disposable{constructor(c,E,u){super();this.onFileChanges=c,this.onLogMessage=E,this.verboseLogging=u,this.serviceDisposables=this._register(new T.MutableDisposable),this.requests=void 0,this.restartCounter=0}init(){const c=new T.DisposableStore;this.serviceDisposables.value=c,this.service=this.createService(c),this.service.setVerboseLogging(this.verboseLogging),c.add(this.service.onDidChangeFile(E=>this.onFileChanges(E))),c.add(this.service.onDidLogMessage(E=>this.onLogMessage(E))),c.add(this.service.onDidError(E=>this.onError(E)))}onError(c){this.restartCounter<D.MAX_RESTARTS&&this.requests?(this.error(`restarting watcher after error: ${c}`),this.restart(this.requests)):this.error(`gave up attempting to restart watcher after error: ${c}`)}restart(c){this.restartCounter++,this.init(),this.watch(c)}async watch(c){this.requests=c,await this.service?.watch(c)}async setVerboseLogging(c){this.verboseLogging=c,await this.service?.setVerboseLogging(c)}error(c){this.onLogMessage({type:"error",message:`[File Watcher (parcel)] ${c}`})}dispose(){return this.service=void 0,super.dispose()}}i.AbstractWatcherService=D,D.MAX_RESTARTS=5;class w extends T.Disposable{}i.WatcherService=w;function l(C){return C.map(c=>({type:c.type,resource:b.URI.file(c.path)}))}i.toFileChanges=l;function p(C){const c=new y;for(const E of C)c.processEvent(E);return c.coalesce()}i.coalesceEvents=p;class y{constructor(){this.coalesced=new Set,this.mapPathToChange=new Map}toKey(c){return P.isLinux?c.path:c.path.toLowerCase()}processEvent(c){const E=this.mapPathToChange.get(this.toKey(c));let u=!1;if(E){const h=E.type,g=c.type;E.path!==c.path&&c.type===2?u=!0:h===1&&g===2?(this.mapPathToChange.delete(this.toKey(c)),this.coalesced.delete(E)):h===2&&g===1?E.type=0:h===1&&g===0||(E.type=g)}else u=!0;u&&(this.coalesced.add(c),this.mapPathToChange.set(this.toKey(c),c))}coalesce(){const c=[],E=[];return Array.from(this.coalesced).filter(u=>u.type!==2?(c.push(u),!1):!0).sort((u,h)=>u.path.length-h.path.length).filter(u=>E.some(h=>(0,R.isParent)(u.path,h,!P.isLinux))?!1:(E.push(u.path),!0)).concat(c)}}}),define(J[94],Q([0,1,3,2,6,64,13,134,34]),function(x,i,T,P,b,R,D,w,l){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.FileWatcher=void 0;class p extends P.Disposable{constructor(C,c,E,u){super();this.path=C,this.onDidFilesChange=c,this.onLogMessage=E,this.verboseLogging=u,this.fileChangesDelayer=this._register(new T.ThrottledDelayer(w.CHANGE_BUFFER_DELAY*2)),this.fileChangesBuffer=[],this.startWatching()}setVerboseLogging(C){this.verboseLogging=C}async startWatching(){try{const{stat:C,symbolicLink:c}=await D.SymlinkSupport.stat(this.path);if(this.isDisposed)return;let E=this.path;if(c)try{E=await(0,R.realpath)(E)}catch(u){if(this.onError(u),c.dangling)return}C.isDirectory()?this._register((0,w.watchFolder)(E,(u,h)=>{this.onFileChange({type:u==="changed"?0:u==="added"?1:2,path:(0,b.join)(this.path,(0,b.basename)(h))})},u=>this.onError(u))):this._register((0,w.watchFile)(E,u=>{this.onFileChange({type:u==="changed"?0:2,path:this.path})},u=>this.onError(u)))}catch(C){C.code!=="ENOENT"&&this.onError(C)}}onFileChange(C){this.fileChangesBuffer.push(C),this.verboseLogging&&this.onVerbose(`${C.type===1?"[ADDED]":C.type===2?"[DELETED]":"[CHANGED]"} ${C.path}`),this.fileChangesDelayer.trigger(async()=>{const c=this.fileChangesBuffer;this.fileChangesBuffer=[];const E=(0,l.coalesceEvents)(c);if(this.verboseLogging)for(const u of E)this.onVerbose(`>> normalized ${u.type===1?"[ADDED]":u.type===2?"[DELETED]":"[CHANGED]"} ${u.path}`);E.length>0&&this.onDidFilesChange(E)})}onError(C){this.isDisposed||this.onLogMessage({type:"error",message:`[File Watcher (node.js)] ${C}`})}onVerbose(C){this.isDisposed||this.onLogMessage({type:"trace",message:`[File Watcher (node.js)] ${C}`})}dispose(){this.isDisposed=!0,super.dispose()}}i.FileWatcher=p}),define(J[95],Q([0,1,10,39,50,34]),function(x,i,T,P,b,R){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.FileWatcher=void 0;class D extends R.WatcherService{constructor(l,p,y){super();this.onDidFilesChange=l,this.onLogMessage=p,this.verboseLogging=y,this.isDisposed=!1,this.startWatching()}startWatching(){const l=this._register(new b.Client(T.FileAccess.asFileUri("bootstrap-fork",x).fsPath,{serverName:"File Watcher (nsfw)",args:["--type=watcherServiceNSFW"],env:{VSCODE_AMD_ENTRYPOINT:"vs/platform/files/node/watcher/nsfw/watcherApp",VSCODE_PIPE_LOGGING:"true",VSCODE_VERBOSE_LOGGING:"true"}}));this.service=P.ProxyChannel.toService((0,P.getNextTickChannel)(l.getChannel("watcher"))),this.service.setVerboseLogging(this.verboseLogging),this._register(this.service.onDidChangeFile(p=>!this.isDisposed&&this.onDidFilesChange(p))),this._register(this.service.onDidLogMessage(p=>this.onLogMessage(p)))}async setVerboseLogging(l){this.verboseLogging=l,this.isDisposed||await this.service?.setVerboseLogging(l)}error(l){this.onLogMessage({type:"error",message:`[File Watcher (nsfw)] ${l}`})}async watch(l){this.isDisposed||await this.service?.watch(l)}dispose(){this.isDisposed=!0,super.dispose()}}i.FileWatcher=D}),define(J[96],Q([0,1,10,39,50,34]),function(x,i,T,P,b,R){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.FileWatcher=void 0;class D extends R.AbstractWatcherService{constructor(l,p,y){super(l,p,y);this.init()}createService(l){const p=l.add(new b.Client(T.FileAccess.asFileUri("bootstrap-fork",x).fsPath,{serverName:"File Watcher (parcel, node.js)",args:["--type=watcherServiceParcel"],env:{VSCODE_AMD_ENTRYPOINT:"vs/platform/files/node/watcher/parcel/watcherApp",VSCODE_PIPE_LOGGING:"true",VSCODE_VERBOSE_LOGGING:"true"}}));return l.add(p.onDidProcessExit(({code:y,signal:C})=>this.onError(`terminated by itself with code ${y}, signal: ${C}`))),P.ProxyChannel.toService((0,P.getNextTickChannel)(p.getChannel("watcher")))}}i.FileWatcher=D}),define(J[54],Q([0,1]),function(x,i){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.ServiceCollection=void 0;class T{constructor(...b){this._entries=new Map;for(let[R,D]of b)this.set(R,D)}set(b,R){const D=this._entries.get(b);return this._entries.set(b,R),D}has(b){return this._entries.has(b)}get(b){return this._entries.get(b)}}i.ServiceCollection=T}),define(J[97],Q([0,1,3,7,41,92,14,54]),function(x,i,T,P,b,R,D,w){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.InstantiationService=void 0;const l=!1;class p extends Error{constructor(u){super("cyclic dependency between services");this.message=u.findCycleSlow()??`UNABLE to detect cycle, dumping graph: 
${u.toString()}`}}class y{constructor(u=new w.ServiceCollection,h=!1,g){this._activeInstantiations=new Set,this._services=u,this._strict=h,this._parent=g,this._services.set(D.IInstantiationService,this)}createChild(u){return new y(u,this._strict,this)}invokeFunction(u,...h){let g=c.traceInvocation(u),m=!1;try{return u({get:d=>{if(m)throw(0,P.illegalState)("service accessor is only valid during the invocation of its target method");const o=this._getOrCreateServiceInstance(d,g);if(!o)throw new Error(`[invokeFunction] unknown service '${d}'`);return o}},...h)}finally{m=!0,g.stop()}}createInstance(u,...h){let g,m;return u instanceof b.SyncDescriptor?(g=c.traceCreation(u.ctor),m=this._createInstance(u.ctor,u.staticArguments.concat(h),g)):(g=c.traceCreation(u),m=this._createInstance(u,h,g)),g.stop(),m}_createInstance(u,h=[],g){let m=D._util.getServiceDependencies(u).sort((o,a)=>o.index-a.index),S=[];for(const o of m){let a=this._getOrCreateServiceInstance(o.id,g);if(!a&&this._strict&&!o.optional)throw new Error(`[createInstance] ${u.name} depends on UNKNOWN service ${o.id}.`);S.push(a)}let d=m.length>0?m[0].index:h.length;if(h.length!==d){console.warn(`[createInstance] First service dependency of ${u.name} at position ${d+1} conflicts with ${h.length} static arguments`);let o=d-h.length;o>0?h=h.concat(new Array(o)):h=h.slice(0,d)}return new u(...[...h,...S])}_setServiceInstance(u,h){if(this._services.get(u)instanceof b.SyncDescriptor)this._services.set(u,h);else if(this._parent)this._parent._setServiceInstance(u,h);else throw new Error("illegalState - setting UNKNOWN service instance")}_getServiceInstanceOrDescriptor(u){let h=this._services.get(u);return!h&&this._parent?this._parent._getServiceInstanceOrDescriptor(u):h}_getOrCreateServiceInstance(u,h){let g=this._getServiceInstanceOrDescriptor(u);return g instanceof b.SyncDescriptor?this._safeCreateAndCacheServiceInstance(u,g,h.branch(u,!0)):(h.branch(u,!1),g)}_safeCreateAndCacheServiceInstance(u,h,g){if(this._activeInstantiations.has(u))throw new Error(`illegal state - RECURSIVELY instantiating service '${u}'`);this._activeInstantiations.add(u);try{return this._createAndCacheServiceInstance(u,h,g)}finally{this._activeInstantiations.delete(u)}}_createAndCacheServiceInstance(u,h,g){const m=new R.Graph(o=>o.id.toString());let S=0;const d=[{id:u,desc:h,_trace:g}];for(;d.length;){const o=d.pop();if(m.lookupOrInsertNode(o),S++>1e3)throw new p(m);for(let a of D._util.getServiceDependencies(o.desc.ctor)){let n=this._getServiceInstanceOrDescriptor(a.id);if(!n&&!a.optional&&console.warn(`[createInstance] ${u} depends on ${a.id} which is NOT registered.`),n instanceof b.SyncDescriptor){const r={id:a.id,desc:n,_trace:o._trace.branch(a.id,!0)};m.insertEdge(o,r),d.push(r)}}}for(;;){const o=m.roots();if(o.length===0){if(!m.isEmpty())throw new p(m);break}for(const{data:a}of o){if(this._getServiceInstanceOrDescriptor(a.id)instanceof b.SyncDescriptor){const r=this._createServiceInstanceWithOwner(a.id,a.desc.ctor,a.desc.staticArguments,a.desc.supportsDelayedInstantiation,a._trace);this._setServiceInstance(a.id,r)}m.removeNode(a)}}return this._getServiceInstanceOrDescriptor(u)}_createServiceInstanceWithOwner(u,h,g=[],m,S){if(this._services.get(u)instanceof b.SyncDescriptor)return this._createServiceInstance(h,g,m,S);if(this._parent)return this._parent._createServiceInstanceWithOwner(u,h,g,m,S);throw new Error(`illegalState - creating UNKNOWN service instance ${h.name}`)}_createServiceInstance(u,h=[],g,m){if(g){const S=new T.IdleValue(()=>this._createInstance(u,h,m));return new Proxy(Object.create(null),{get(d,o){if(o in d)return d[o];let a=S.value,n=a[o];return typeof n!="function"||(n=n.bind(a),d[o]=n),n},set(d,o,a){return S.value[o]=a,!0}})}else return this._createInstance(u,h,m)}}i.InstantiationService=y;var C;(function(E){E[E.Creation=0]="Creation",E[E.Invocation=1]="Invocation",E[E.Branch=2]="Branch"})(C||(C={}));class c{constructor(u,h){this.type=u,this.name=h,this._start=Date.now(),this._dep=[]}static traceInvocation(u){return l?new c(1,u.name||u.toString().substring(0,42).replace(/\n/g,"")):c._None}static traceCreation(u){return l?new c(0,u.name):c._None}branch(u,h){let g=new c(2,u.toString());return this._dep.push([u,h,g]),g}stop(){let u=Date.now()-this._start;c._totals+=u;let h=!1;function g(S,d){let o=[],a=new Array(S+1).join("	");for(const[n,r,e]of d._dep)if(r&&e){h=!0,o.push(`${a}CREATES -> ${n}`);let t=g(S+1,e);t&&o.push(t)}else o.push(`${a}uses -> ${n}`);return o.join(`
`)}let m=[`${this.type===0?"CREATE":"CALL"} ${this.name}`,`${g(1,this)}`,`DONE, took ${u.toFixed(2)}ms (grand total ${c._totals.toFixed(2)}ms)`];(u>2||h)&&console.log(m.join(`
`))}}c._None=new class extends c{constructor(){super(-1,null)}stop(){}branch(){return this}},c._totals=0}),define(J[55],Q([0,1,14]),function(x,i,T){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.isValidLocalization=i.ILocalizationsService=void 0,i.ILocalizationsService=(0,T.createDecorator)("localizationsService");function P(b){if(typeof b.languageId!="string"||!Array.isArray(b.translations)||b.translations.length===0)return!1;for(const R of b.translations)if(typeof R.id!="string"||typeof R.path!="string")return!1;return!(b.languageName&&typeof b.languageName!="string"||b.localizedLanguageName&&typeof b.localizedLanguageName!="string")}i.isValidLocalization=P}),define(J[15],Q([0,1,27,11,2,12,14]),function(x,i,T,P,b,R,D){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.LogLevelToString=i.parseLogLevel=i.getLogLevel=i.NullLogService=i.AbstractLoggerService=i.LogService=i.MultiplexLogService=i.AdapterLogger=i.ConsoleLogger=i.ConsoleMainLogger=i.AbstractMessageLogger=i.AbstractLogger=i.format=i.log=i.DEFAULT_LOG_LEVEL=i.LogLevel=i.ILoggerService=i.ILogService=void 0,i.ILogService=(0,D.createDecorator)("logService"),i.ILoggerService=(0,D.createDecorator)("loggerService");function w(){return new Date().toISOString()}var l;(function(r){r[r.Trace=0]="Trace",r[r.Debug=1]="Debug",r[r.Info=2]="Info",r[r.Warning=3]="Warning",r[r.Error=4]="Error",r[r.Critical=5]="Critical",r[r.Off=6]="Off"})(l=i.LogLevel||(i.LogLevel={})),i.DEFAULT_LOG_LEVEL=l.Info;function p(r,e,t){switch(e){case l.Trace:r.trace(t);break;case l.Debug:r.debug(t);break;case l.Info:r.info(t);break;case l.Warning:r.warn(t);break;case l.Error:r.error(t);break;case l.Critical:r.critical(t);break;default:throw new Error("Invalid log level")}}i.log=p;function y(r){let e="";for(let t=0;t<r.length;t++){let s=r[t];if(typeof s=="object")try{s=JSON.stringify(s)}catch(f){}e+=(t>0?" ":"")+s}return e}i.format=y;class C extends b.Disposable{constructor(){super(...arguments);this.level=i.DEFAULT_LOG_LEVEL,this._onDidChangeLogLevel=this._register(new P.Emitter),this.onDidChangeLogLevel=this._onDidChangeLogLevel.event}setLevel(e){this.level!==e&&(this.level=e,this._onDidChangeLogLevel.fire(this.level))}getLevel(){return this.level}}i.AbstractLogger=C;class c extends C{constructor(e){super();this.logAlways=e}checkLogLevel(e){return this.logAlways||this.getLevel()<=e}trace(e,...t){this.checkLogLevel(l.Trace)&&this.log(l.Trace,y([e,...t]))}debug(e,...t){this.checkLogLevel(l.Debug)&&this.log(l.Debug,y([e,...t]))}info(e,...t){this.checkLogLevel(l.Info)&&this.log(l.Info,y([e,...t]))}warn(e,...t){this.checkLogLevel(l.Warning)&&this.log(l.Warning,y([e,...t]))}error(e,...t){if(this.checkLogLevel(l.Error))if(e instanceof Error){const s=Array.prototype.slice.call(arguments);s[0]=e.stack,this.log(l.Error,y(s))}else this.log(l.Error,y([e,...t]))}critical(e,...t){this.checkLogLevel(l.Critical)&&this.log(l.Critical,y([e,...t]))}flush(){}}i.AbstractMessageLogger=c;class E extends C{constructor(e=i.DEFAULT_LOG_LEVEL){super();this.setLevel(e),this.useColors=!R.isWindows}trace(e,...t){this.getLevel()<=l.Trace&&(this.useColors?console.log(`[90m[main ${w()}][0m`,e,...t):console.log(`[main ${w()}]`,e,...t))}debug(e,...t){this.getLevel()<=l.Debug&&(this.useColors?console.log(`[90m[main ${w()}][0m`,e,...t):console.log(`[main ${w()}]`,e,...t))}info(e,...t){this.getLevel()<=l.Info&&(this.useColors?console.log(`[90m[main ${w()}][0m`,e,...t):console.log(`[main ${w()}]`,e,...t))}warn(e,...t){this.getLevel()<=l.Warning&&(this.useColors?console.warn(`[93m[main ${w()}][0m`,e,...t):console.warn(`[main ${w()}]`,e,...t))}error(e,...t){this.getLevel()<=l.Error&&(this.useColors?console.error(`[91m[main ${w()}][0m`,e,...t):console.error(`[main ${w()}]`,e,...t))}critical(e,...t){this.getLevel()<=l.Critical&&(this.useColors?console.error(`[90m[main ${w()}][0m`,e,...t):console.error(`[main ${w()}]`,e,...t))}dispose(){}flush(){}}i.ConsoleMainLogger=E;class u extends C{constructor(e=i.DEFAULT_LOG_LEVEL){super();this.setLevel(e)}trace(e,...t){this.getLevel()<=l.Trace&&console.log("%cTRACE","color: #888",e,...t)}debug(e,...t){this.getLevel()<=l.Debug&&console.log("%cDEBUG","background: #eee; color: #888",e,...t)}info(e,...t){this.getLevel()<=l.Info&&console.log("%c INFO","color: #33f",e,...t)}warn(e,...t){this.getLevel()<=l.Warning&&console.log("%c WARN","color: #993",e,...t)}error(e,...t){this.getLevel()<=l.Error&&console.log("%c  ERR","color: #f33",e,...t)}critical(e,...t){this.getLevel()<=l.Critical&&console.log("%cCRITI","background: #f33; color: white",e,...t)}dispose(){}flush(){}}i.ConsoleLogger=u;class h extends C{constructor(e,t=i.DEFAULT_LOG_LEVEL){super();this.adapter=e,this.setLevel(t)}trace(e,...t){this.getLevel()<=l.Trace&&this.adapter.log(l.Trace,[this.extractMessage(e),...t])}debug(e,...t){this.getLevel()<=l.Debug&&this.adapter.log(l.Debug,[this.extractMessage(e),...t])}info(e,...t){this.getLevel()<=l.Info&&this.adapter.log(l.Info,[this.extractMessage(e),...t])}warn(e,...t){this.getLevel()<=l.Warning&&this.adapter.log(l.Warning,[this.extractMessage(e),...t])}error(e,...t){this.getLevel()<=l.Error&&this.adapter.log(l.Error,[this.extractMessage(e),...t])}critical(e,...t){this.getLevel()<=l.Critical&&this.adapter.log(l.Critical,[this.extractMessage(e),...t])}extractMessage(e){return typeof e=="string"?e:(0,T.toErrorMessage)(e,this.getLevel()<=l.Trace)}dispose(){}flush(){}}i.AdapterLogger=h;class g extends C{constructor(e){super();this.logServices=e,e.length&&this.setLevel(e[0].getLevel())}setLevel(e){for(const t of this.logServices)t.setLevel(e);super.setLevel(e)}trace(e,...t){for(const s of this.logServices)s.trace(e,...t)}debug(e,...t){for(const s of this.logServices)s.debug(e,...t)}info(e,...t){for(const s of this.logServices)s.info(e,...t)}warn(e,...t){for(const s of this.logServices)s.warn(e,...t)}error(e,...t){for(const s of this.logServices)s.error(e,...t)}critical(e,...t){for(const s of this.logServices)s.critical(e,...t)}flush(){for(const e of this.logServices)e.flush()}dispose(){for(const e of this.logServices)e.dispose()}}i.MultiplexLogService=g;class m extends b.Disposable{constructor(e){super();this.logger=e,this._register(e)}get onDidChangeLogLevel(){return this.logger.onDidChangeLogLevel}setLevel(e){this.logger.setLevel(e)}getLevel(){return this.logger.getLevel()}trace(e,...t){this.logger.trace(e,...t)}debug(e,...t){this.logger.debug(e,...t)}info(e,...t){this.logger.info(e,...t)}warn(e,...t){this.logger.warn(e,...t)}error(e,...t){this.logger.error(e,...t)}critical(e,...t){this.logger.critical(e,...t)}flush(){this.logger.flush()}}i.LogService=m;class S extends b.Disposable{constructor(e,t){super();this.logLevel=e,this.loggers=new Map,this.logLevelChangeableLoggers=[],this._register(t(s=>{this.logLevel=s,this.logLevelChangeableLoggers.forEach(f=>f.setLevel(s))}))}getLogger(e){return this.loggers.get(e.toString())}createLogger(e,t){let s=this.loggers.get(e.toString());return s||(s=this.doCreateLogger(e,t?.always?l.Trace:this.logLevel,t),this.loggers.set(e.toString(),s),t?.always||this.logLevelChangeableLoggers.push(s)),s}dispose(){this.logLevelChangeableLoggers.splice(0,this.logLevelChangeableLoggers.length),this.loggers.forEach(e=>e.dispose()),this.loggers.clear(),super.dispose()}}i.AbstractLoggerService=S;class d{constructor(){this.onDidChangeLogLevel=new P.Emitter().event}setLevel(e){}getLevel(){return l.Info}trace(e,...t){}debug(e,...t){}info(e,...t){}warn(e,...t){}error(e,...t){}critical(e,...t){}dispose(){}flush(){}}i.NullLogService=d;function o(r){if(r.verbose)return l.Trace;if(typeof r.logLevel=="string"){const e=a(r.logLevel.toLowerCase());if(e!==void 0)return e}return i.DEFAULT_LOG_LEVEL}i.getLogLevel=o;function a(r){switch(r){case"trace":return l.Trace;case"debug":return l.Debug;case"info":return l.Info;case"warn":return l.Warning;case"error":return l.Error;case"critical":return l.Critical;case"off":return l.Off}}i.parseLogLevel=a;function n(r){switch(r){case l.Trace:return"trace";case l.Debug:return"debug";case l.Info:return"info";case l.Warning:return"warn";case l.Error:return"error";case l.Critical:return"critical";case l.Off:return"off"}}i.LogLevelToString=n});var ae=this&&this.__param||function(x,i){return function(T,P){i(T,P,x)}};define(J[98],Q([0,1,40,3,27,11,2,10,6,13,20,15]),function(x,i,T,P,b,R,D,w,l,p,y,C){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.ExtensionsLifecycle=void 0;let c=class extends D.Disposable{constructor(u,h){super();this.environmentService=u,this.logService=h,this.processesLimiter=new P.Limiter(5)}async postUninstall(u){const h=this.parseScript(u,"uninstall");return h&&(this.logService.info(u.identifier.id,u.manifest.version,"Running post uninstall script"),await this.processesLimiter.queue(()=>this.runLifecycleHook(h.script,"uninstall",h.args,!0,u).then(()=>this.logService.info(u.identifier.id,u.manifest.version,"Finished running post uninstall script"),g=>this.logService.error(u.identifier.id,u.manifest.version,`Failed to run post uninstall script: ${g}`)))),p.Promises.rm(this.getExtensionStoragePath(u)).then(void 0,g=>this.logService.error("Error while removing extension storage path",g))}parseScript(u,h){const g=`vscode:${h}`;if(u.location.scheme===w.Schemas.file&&u.manifest&&u.manifest.scripts&&typeof u.manifest.scripts[g]=="string"){const m=u.manifest.scripts[g].split(" ");return m.length<2||m[0]!=="node"||!m[1]?(this.logService.warn(u.identifier.id,u.manifest.version,`${g} should be a node script`),null):{script:(0,l.join)(u.location.fsPath,m[1]),args:m.slice(2)||[]}}return null}runLifecycleHook(u,h,g,m,S){return new Promise((d,o)=>{const a=this.start(u,h,g,S);let n;const r=e=>{n&&(clearTimeout(n),n=null),e?o(e):d(void 0)};a.on("error",e=>{r((0,b.toErrorMessage)(e)||"Unknown")}),a.on("exit",(e,t)=>{r(e?`post-${h} process exited with code ${e}`:void 0)}),m&&(n=setTimeout(()=>{n=null,a.kill(),o("timed out")},5e3))})}start(u,h,g,m){const S={silent:!0,execArgv:void 0},d=(0,T.fork)(u,[`--type=extension-post-${h}`,...g],S);d.stdout.setEncoding("utf8"),d.stderr.setEncoding("utf8");const o=R.Event.fromNodeEventEmitter(d.stdout,"data"),a=R.Event.fromNodeEventEmitter(d.stderr,"data");o(e=>this.logService.info(m.identifier.id,m.manifest.version,`post-${h}`,e)),a(e=>this.logService.error(m.identifier.id,m.manifest.version,`post-${h}`,e));const n=R.Event.any(R.Event.map(o,e=>({data:`%c${e}`,format:[""]})),R.Event.map(a,e=>({data:`%c${e}`,format:["color: red"]})));return R.Event.debounce(n,(e,t)=>e?{data:e.data+t.data,format:[...e.format,...t.format]}:{data:t.data,format:t.format},100)(e=>{console.group(m.identifier.id),console.log(e.data,...e.format),console.groupEnd()}),d}getExtensionStoragePath(u){return(0,l.join)(this.environmentService.globalStorageHome.fsPath,u.identifier.id.toLowerCase())}};c=ve([ae(0,y.IEnvironmentService),ae(1,C.ILogService)],c),i.ExtensionsLifecycle=c}),define(J[99],Q([0,1,19,3,7,11,2,6,34,15]),function(x,i,T,P,b,R,D,w,l,p){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.AbstractDiskFileSystemProvider=void 0;class y extends D.Disposable{constructor(c){super();this.logService=c,this._onDidErrorOccur=this._register(new R.Emitter),this.onDidErrorOccur=this._onDidErrorOccur.event,this._onDidChangeFile=this._register(new R.Emitter),this.onDidChangeFile=this._onDidChangeFile.event,this.recursiveFoldersToWatch=[],this.recursiveWatchRequestDelayer=this._register(new P.ThrottledDelayer(0))}watch(c,E){return E.recursive?this.watchRecursive(c,E):this.watchNonRecursive(c)}watchRecursive(c,E){const u={path:this.toFilePath(c),excludes:E.excludes},h=(0,T.insert)(this.recursiveFoldersToWatch,u);return this.refreshRecursiveWatchers(),(0,D.toDisposable)(()=>{h(),this.refreshRecursiveWatchers()})}refreshRecursiveWatchers(){this.recursiveWatchRequestDelayer.trigger(()=>this.doRefreshRecursiveWatchers()).catch(c=>(0,b.onUnexpectedError)(c))}doRefreshRecursiveWatchers(){return this.recursiveWatcher||(this.recursiveWatcher=this._register(this.createRecursiveWatcher(c=>this._onDidChangeFile.fire((0,l.toFileChanges)(c)),c=>this.onWatcherLogMessage(c),this.logService.getLevel()===p.LogLevel.Trace)),this._register(this.logService.onDidChangeLogLevel(()=>{this.recursiveWatcher?.setVerboseLogging(this.logService.getLevel()===p.LogLevel.Trace)}))),this.doWatch(this.recursiveWatcher,this.recursiveFoldersToWatch)}doWatch(c,E){return c.watch(E)}watchNonRecursive(c){const E=this.createNonRecursiveWatcher(this.toFilePath(c),h=>this._onDidChangeFile.fire((0,l.toFileChanges)(h)),h=>this.onWatcherLogMessage(h),this.logService.getLevel()===p.LogLevel.Trace),u=this.logService.onDidChangeLogLevel(()=>{E.setVerboseLogging(this.logService.getLevel()===p.LogLevel.Trace)});return(0,D.combinedDisposable)(E,u)}onWatcherLogMessage(c){c.type==="error"&&this._onDidErrorOccur.fire(c.message),this.logService[c.type](c.message)}toFilePath(c){return(0,w.normalize)(c.fsPath)}}i.AbstractDiskFileSystemProvider=y}),define(J[100],Q([0,1,19,3,17,24,11,135,2,101,10,102,18,38,82,16,53,15]),function(x,i,T,P,b,R,D,w,l,p,y,C,c,E,u,h,g,m){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.FileService=void 0;let S=class xe extends l.Disposable{constructor(o){super();this.logService=o,this.BUFFER_SIZE=256*1024,this._onDidChangeFileSystemProviderRegistrations=this._register(new D.Emitter),this.onDidChangeFileSystemProviderRegistrations=this._onDidChangeFileSystemProviderRegistrations.event,this._onWillActivateFileSystemProvider=this._register(new D.Emitter),this.onWillActivateFileSystemProvider=this._onWillActivateFileSystemProvider.event,this._onDidChangeFileSystemProviderCapabilities=this._register(new D.Emitter),this.onDidChangeFileSystemProviderCapabilities=this._onDidChangeFileSystemProviderCapabilities.event,this.provider=new Map,this._onDidRunOperation=this._register(new D.Emitter),this.onDidRunOperation=this._onDidRunOperation.event,this._onError=this._register(new D.Emitter),this.onError=this._onError.event,this._onDidFilesChange=this._register(new D.Emitter),this.onDidFilesChange=this._onDidFilesChange.event,this._onDidChangeFilesRaw=this._register(new D.Emitter),this.onDidChangeFilesRaw=this._onDidChangeFilesRaw.event,this.activeWatchers=new Map,this.caseSensitiveFileEventsWorker=this._register(new P.ThrottledWorker(xe.FILE_EVENTS_THROTTLING.maxChangesChunkSize,xe.FILE_EVENTS_THROTTLING.maxChangesBufferSize,xe.FILE_EVENTS_THROTTLING.coolDownDelay,a=>this._onDidFilesChange.fire(new h.FileChangesEvent(a,!1)))),this.caseInsensitiveFileEventsWorker=this._register(new P.ThrottledWorker(xe.FILE_EVENTS_THROTTLING.maxChangesChunkSize,xe.FILE_EVENTS_THROTTLING.maxChangesBufferSize,xe.FILE_EVENTS_THROTTLING.coolDownDelay,a=>this._onDidFilesChange.fire(new h.FileChangesEvent(a,!0)))),this.watchedResources=p.TernarySearchTree.forUris(a=>{const n=this.getProvider(a.scheme);return n?!this.isPathCaseSensitive(n):!1}),this.writeQueue=this._register(new P.ResourceQueue)}registerProvider(o,a){if(this.provider.has(o))throw new Error(`A filesystem provider for the scheme '${o}' is already registered.`);(0,C.mark)(`code/registerFilesystem/${o}`),this.provider.set(o,a),this._onDidChangeFileSystemProviderRegistrations.fire({added:!0,scheme:o,provider:a});const n=new l.DisposableStore;return n.add(a.onDidChangeFile(r=>this.onDidChangeFile(r,this.isPathCaseSensitive(a)))),n.add(a.onDidChangeCapabilities(()=>this._onDidChangeFileSystemProviderCapabilities.fire({provider:a,scheme:o}))),typeof a.onDidErrorOccur=="function"&&n.add(a.onDidErrorOccur(r=>this._onError.fire(new Error(r)))),(0,l.toDisposable)(()=>{this._onDidChangeFileSystemProviderRegistrations.fire({added:!1,scheme:o,provider:a}),this.provider.delete(o),(0,l.dispose)(n)})}getProvider(o){return this.provider.get(o)}async activateProvider(o){const a=[];this._onWillActivateFileSystemProvider.fire({scheme:o,join(n){a.push(n)}}),!this.provider.has(o)&&await P.Promises.settled(a)}async canHandleResource(o){return await this.activateProvider(o.scheme),this.hasProvider(o)}hasProvider(o){return this.provider.has(o.scheme)}hasCapability(o,a){const n=this.provider.get(o.scheme);return!!(n&&n.capabilities&a)}listCapabilities(){return w.Iterable.map(this.provider,([o,a])=>({scheme:o,capabilities:a.capabilities}))}async withProvider(o){if(!(0,c.isAbsolutePath)(o))throw new h.FileOperationError((0,u.localize)(0,null,this.resourceForError(o)),8);await this.activateProvider(o.scheme);const a=this.provider.get(o.scheme);if(!a){const n=new Error;throw n.name="ENOPRO",n.message=(0,u.localize)(1,null,o.toString()),n}return a}async withReadProvider(o){const a=await this.withProvider(o);if((0,h.hasOpenReadWriteCloseCapability)(a)||(0,h.hasReadWriteCapability)(a)||(0,h.hasFileReadStreamCapability)(a))return a;throw new Error(`Filesystem provider for scheme '${o.scheme}' neither has FileReadWrite, FileReadStream nor FileOpenReadWriteClose capability which is needed for the read operation.`)}async withWriteProvider(o){const a=await this.withProvider(o);if((0,h.hasOpenReadWriteCloseCapability)(a)||(0,h.hasReadWriteCapability)(a))return a;throw new Error(`Filesystem provider for scheme '${o.scheme}' neither has FileReadWrite nor FileOpenReadWriteClose capability which is needed for the write operation.`)}async resolve(o,a){try{return await this.doResolveFile(o,a)}catch(n){throw(0,h.toFileSystemProviderErrorCode)(n)===h.FileSystemProviderErrorCode.FileNotFound?new h.FileOperationError((0,u.localize)(2,null,this.resourceForError(o)),1):(0,h.ensureFileSystemProviderError)(n)}}async doResolveFile(o,a){const n=await this.withProvider(o),r=this.isPathCaseSensitive(n),e=a?.resolveTo,t=a?.resolveSingleChildDescendants,s=a?.resolveMetadata,f=await n.stat(o);let v;return this.toFileStat(n,o,f,void 0,!!s,(L,I)=>(v||(v=p.TernarySearchTree.forUris(()=>!r),v.set(o,!0),e&&v.fill(!0,e)),v.get(L.resource)||v.findSuperstr(L.resource.with({query:null,fragment:null}))?!0:L.isDirectory&&t?I===1:!1))}async toFileStat(o,a,n,r,e,t){const{providerExtUri:s}=this.getExtUri(o),f={resource:a,name:s.basename(a),isFile:(n.type&h.FileType.File)!=0,isDirectory:(n.type&h.FileType.Directory)!=0,isSymbolicLink:(n.type&h.FileType.SymbolicLink)!=0,mtime:n.mtime,ctime:n.ctime,size:n.size,readonly:Boolean((n.permissions??0)&h.FilePermission.Readonly)||Boolean(o.capabilities&2048),etag:(0,h.etag)({mtime:n.mtime,size:n.size})};if(f.isDirectory&&t(f,r)){try{const v=await o.readdir(a),L=await P.Promises.settled(v.map(async([I,O])=>{try{const N=s.joinPath(a,I),G=e?await o.stat(N):{type:O};return await this.toFileStat(o,N,G,v.length,e,t)}catch(N){return this.logService.trace(N),null}}));f.children=(0,T.coalesce)(L)}catch(v){this.logService.trace(v),f.children=[]}return f}return f}async resolveAll(o){return P.Promises.settled(o.map(async a=>{try{return{stat:await this.doResolveFile(a.resource,a.options),success:!0}}catch(n){return this.logService.trace(n),{stat:void 0,success:!1}}}))}async exists(o){const a=await this.withProvider(o);try{return!!await a.stat(o)}catch(n){return!1}}async canCreateFile(o,a){try{await this.doValidateCreateFile(o,a)}catch(n){return n}return!0}async doValidateCreateFile(o,a){if(!a?.overwrite&&await this.exists(o))throw new h.FileOperationError((0,u.localize)(3,null,this.resourceForError(o)),3,a)}async createFile(o,a=b.VSBuffer.fromString(""),n){await this.doValidateCreateFile(o,n);const r=await this.writeFile(o,a);return this._onDidRunOperation.fire(new h.FileOperationEvent(o,0,r)),r}async writeFile(o,a,n){const r=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(o),o),{providerExtUri:e}=this.getExtUri(r);try{await this.validateWriteFile(r,o,n)||await this.mkdirp(r,e.dirname(o));let s;if((0,h.hasReadWriteCapability)(r)&&!(a instanceof b.VSBuffer))if((0,E.isReadableStream)(a)){const f=await(0,E.peekStream)(a,3);f.ended?s=b.VSBuffer.concat(f.buffer):s=f}else s=(0,E.peekReadable)(a,f=>b.VSBuffer.concat(f),3);else s=a;!(0,h.hasOpenReadWriteCloseCapability)(r)||(0,h.hasReadWriteCapability)(r)&&s instanceof b.VSBuffer?await this.doWriteUnbuffered(r,o,n,s):await this.doWriteBuffered(r,o,n,s instanceof b.VSBuffer?(0,b.bufferToReadable)(s):s)}catch(t){throw new h.FileOperationError((0,u.localize)(4,null,this.resourceForError(o),(0,h.ensureFileSystemProviderError)(t).toString()),(0,h.toFileOperationResult)(t),n)}return this.resolve(o,{resolveMetadata:!0})}async validateWriteFile(o,a,n){if(!!n?.unlock&&!(o.capabilities&8192))throw new Error((0,u.localize)(5,null,this.resourceForError(a)));let e;try{e=await o.stat(a)}catch(t){return}if((e.type&h.FileType.Directory)!=0)throw new h.FileOperationError((0,u.localize)(6,null,this.resourceForError(a)),0,n);if(this.throwIfFileIsReadonly(a,e),typeof n?.mtime=="number"&&typeof n.etag=="string"&&n.etag!==h.ETAG_DISABLED&&typeof e.mtime=="number"&&typeof e.size=="number"&&n.mtime<e.mtime&&n.etag!==(0,h.etag)({mtime:n.mtime,size:e.size}))throw new h.FileOperationError((0,u.localize)(7,null),3,n);return e}async readFile(o,a){const n=await this.withReadProvider(o);return a?.atomic?this.doReadFileAtomic(n,o,a):this.doReadFile(n,o,a)}async doReadFileAtomic(o,a,n){return new Promise((r,e)=>{this.writeQueue.queueFor(a,this.getExtUri(o).providerExtUri).queue(async()=>{try{const t=await this.doReadFile(o,a,n);r(t)}catch(t){e(t)}})})}async doReadFile(o,a,n){const r=await this.doReadFileStream(o,a,{...n,preferUnbuffered:!0});return{...r,value:await(0,b.streamToBuffer)(r.value)}}async readFileStream(o,a){const n=await this.withReadProvider(o);return this.doReadFileStream(n,o,a)}async doReadFileStream(o,a,n){const r=new R.CancellationTokenSource,e=this.validateReadFile(a,n).then(s=>s,s=>{throw r.cancel(),s});let t;try{return typeof n?.etag=="string"&&n.etag!==h.ETAG_DISABLED&&await e,!((0,h.hasOpenReadWriteCloseCapability)(o)||(0,h.hasFileReadStreamCapability)(o))||(0,h.hasReadWriteCapability)(o)&&n?.preferUnbuffered?t=this.readFileUnbuffered(o,a,n):(0,h.hasFileReadStreamCapability)(o)?t=this.readFileStreamed(o,a,r.token,n):t=this.readFileBuffered(o,a,r.token,n),{...await e,value:t}}catch(s){t&&await(0,E.consumeStream)(t);const f=(0,u.localize)(8,null,this.resourceForError(a),(0,h.ensureFileSystemProviderError)(s).toString());throw s instanceof h.NotModifiedSinceFileOperationError?new h.NotModifiedSinceFileOperationError(f,s.stat,n):new h.FileOperationError(f,(0,h.toFileOperationResult)(s),n)}}readFileStreamed(o,a,n,r=Object.create(null)){const e=o.readFileStream(a,r,n);return(0,E.transform)(e,{data:t=>t instanceof b.VSBuffer?t:b.VSBuffer.wrap(t),error:t=>new h.FileOperationError((0,u.localize)(9,null,this.resourceForError(a),(0,h.ensureFileSystemProviderError)(t).toString()),(0,h.toFileOperationResult)(t),r)},t=>b.VSBuffer.concat(t))}readFileBuffered(o,a,n,r=Object.create(null)){const e=(0,b.newWriteableBufferStream)();return(0,g.readFileIntoStream)(o,a,e,t=>t,{...r,bufferSize:this.BUFFER_SIZE,errorTransformer:t=>new h.FileOperationError((0,u.localize)(10,null,this.resourceForError(a),(0,h.ensureFileSystemProviderError)(t).toString()),(0,h.toFileOperationResult)(t),r)},n),e}readFileUnbuffered(o,a,n){const r=(0,E.newWriteableStream)(e=>b.VSBuffer.concat(e));return(async()=>{try{let e=await o.readFile(a);typeof n?.position=="number"&&(e=e.slice(n.position)),typeof n?.length=="number"&&(e=e.slice(0,n.length)),this.validateReadFileLimits(a,e.byteLength,n),r.end(b.VSBuffer.wrap(e))}catch(e){r.error(e),r.end()}})(),r}async validateReadFile(o,a){const n=await this.resolve(o,{resolveMetadata:!0});if(n.isDirectory)throw new h.FileOperationError((0,u.localize)(11,null,this.resourceForError(o)),0,a);if(typeof a?.etag=="string"&&a.etag!==h.ETAG_DISABLED&&a.etag===n.etag)throw new h.NotModifiedSinceFileOperationError((0,u.localize)(12,null),n,a);return this.validateReadFileLimits(o,n.size,a),n}validateReadFileLimits(o,a,n){if(n?.limits){let r;if(typeof n.limits.memory=="number"&&a>n.limits.memory&&(r=9),typeof n.limits.size=="number"&&a>n.limits.size&&(r=7),typeof r=="number")throw new h.FileOperationError((0,u.localize)(13,null,this.resourceForError(o)),r)}}async canMove(o,a,n){return this.doCanMoveCopy(o,a,"move",n)}async canCopy(o,a,n){return this.doCanMoveCopy(o,a,"copy",n)}async doCanMoveCopy(o,a,n,r){if(o.toString()!==a.toString())try{const e=n==="move"?this.throwIfFileSystemIsReadonly(await this.withWriteProvider(o),o):await this.withReadProvider(o),t=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(a),a);await this.doValidateMoveCopy(e,o,t,a,n,r)}catch(e){return e}return!0}async move(o,a,n){const r=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(o),o),e=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(a),a),t=await this.doMoveCopy(r,o,e,a,"move",!!n),s=await this.resolve(a,{resolveMetadata:!0});return this._onDidRunOperation.fire(new h.FileOperationEvent(o,t==="move"?2:3,s)),s}async copy(o,a,n){const r=await this.withReadProvider(o),e=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(a),a),t=await this.doMoveCopy(r,o,e,a,"copy",!!n),s=await this.resolve(a,{resolveMetadata:!0});return this._onDidRunOperation.fire(new h.FileOperationEvent(o,t==="copy"?3:2,s)),s}async doMoveCopy(o,a,n,r,e,t){if(a.toString()===r.toString())return e;const{exists:s,isSameResourceWithDifferentPathCase:f}=await this.doValidateMoveCopy(o,a,n,r,e,t);if(s&&!f&&t&&await this.del(r,{recursive:!0}),await this.mkdirp(n,this.getExtUri(n).providerExtUri.dirname(r)),e==="copy"){if(o===n&&(0,h.hasFileFolderCopyCapability)(o))await o.copy(a,r,{overwrite:t});else{const v=await this.resolve(a);v.isDirectory?await this.doCopyFolder(o,v,n,r):await this.doCopyFile(o,a,n,r)}return e}else return o===n?(await o.rename(a,r,{overwrite:t}),e):(await this.doMoveCopy(o,a,n,r,"copy",t),await this.del(a,{recursive:!0}),"copy")}async doCopyFile(o,a,n,r){if((0,h.hasOpenReadWriteCloseCapability)(o)&&(0,h.hasOpenReadWriteCloseCapability)(n))return this.doPipeBuffered(o,a,n,r);if((0,h.hasOpenReadWriteCloseCapability)(o)&&(0,h.hasReadWriteCapability)(n))return this.doPipeBufferedToUnbuffered(o,a,n,r);if((0,h.hasReadWriteCapability)(o)&&(0,h.hasOpenReadWriteCloseCapability)(n))return this.doPipeUnbufferedToBuffered(o,a,n,r);if((0,h.hasReadWriteCapability)(o)&&(0,h.hasReadWriteCapability)(n))return this.doPipeUnbuffered(o,a,n,r)}async doCopyFolder(o,a,n,r){await n.mkdir(r),Array.isArray(a.children)&&await P.Promises.settled(a.children.map(async e=>{const t=this.getExtUri(n).providerExtUri.joinPath(r,e.name);return e.isDirectory?this.doCopyFolder(o,await this.resolve(e.resource),n,t):this.doCopyFile(o,e.resource,n,t)}))}async doValidateMoveCopy(o,a,n,r,e,t){let s=!1;if(o===n){const{providerExtUri:v,isPathCaseSensitive:L}=this.getExtUri(o);if(L||(s=v.isEqual(a,r)),s&&e==="copy")throw new Error((0,u.localize)(14,null,this.resourceForError(a),this.resourceForError(r)));if(!s&&v.isEqualOrParent(r,a))throw new Error((0,u.localize)(15,null,this.resourceForError(a),this.resourceForError(r)))}const f=await this.exists(r);if(f&&!s){if(!t)throw new h.FileOperationError((0,u.localize)(16,null,this.resourceForError(a),this.resourceForError(r)),4);if(o===n){const{providerExtUri:v}=this.getExtUri(o);if(v.isEqualOrParent(a,r))throw new Error((0,u.localize)(17,null,this.resourceForError(a),this.resourceForError(r)))}}return{exists:f,isSameResourceWithDifferentPathCase:s}}getExtUri(o){const a=this.isPathCaseSensitive(o);return{providerExtUri:a?c.extUri:c.extUriIgnorePathCase,isPathCaseSensitive:a}}isPathCaseSensitive(o){return!!(o.capabilities&1024)}async createFolder(o){const a=this.throwIfFileSystemIsReadonly(await this.withProvider(o),o);await this.mkdirp(a,o);const n=await this.resolve(o,{resolveMetadata:!0});return this._onDidRunOperation.fire(new h.FileOperationEvent(o,0,n)),n}async mkdirp(o,a){const n=[],{providerExtUri:r}=this.getExtUri(o);for(;!r.isEqual(a,r.dirname(a));)try{if(((await o.stat(a)).type&h.FileType.Directory)==0)throw new Error((0,u.localize)(18,null,this.resourceForError(a)));break}catch(e){if((0,h.toFileSystemProviderErrorCode)(e)!==h.FileSystemProviderErrorCode.FileNotFound)throw e;n.push(r.basename(a)),a=r.dirname(a)}for(let e=n.length-1;e>=0;e--){a=r.joinPath(a,n[e]);try{await o.mkdir(a)}catch(t){if((0,h.toFileSystemProviderErrorCode)(t)!==h.FileSystemProviderErrorCode.FileExists)throw t}}}async canDelete(o,a){try{await this.doValidateDelete(o,a)}catch(n){return n}return!0}async doValidateDelete(o,a){const n=this.throwIfFileSystemIsReadonly(await this.withProvider(o),o);if(!!a?.useTrash&&!(n.capabilities&4096))throw new Error((0,u.localize)(19,null,this.resourceForError(o)));let e;try{e=await n.stat(o)}catch(s){}if(e)this.throwIfFileIsReadonly(o,e);else throw new h.FileOperationError((0,u.localize)(20,null,this.resourceForError(o)),1);if(!!!a?.recursive){const s=await this.resolve(o);if(s.isDirectory&&Array.isArray(s.children)&&s.children.length>0)throw new Error((0,u.localize)(21,null,this.resourceForError(o)))}return n}async del(o,a){const n=await this.doValidateDelete(o,a),r=!!a?.useTrash,e=!!a?.recursive;await n.delete(o,{recursive:e,useTrash:r}),this._onDidRunOperation.fire(new h.FileOperationEvent(o,1))}onDidChangeFile(o,a){this._onDidChangeFilesRaw.fire({changes:o});let n,r;{for(const e of o)this.watchedResources.has(e.resource)?(n||(n=[]),n.push(e)):(r||(r=[]),r.push(e));n&&this._onDidFilesChange.fire(new h.FileChangesEvent(n,!a))}if(r){const e=a?this.caseSensitiveFileEventsWorker:this.caseInsensitiveFileEventsWorker;!e.work(r)&&xe.FILE_EVENTS_THROTTLING.warningscounter++<10&&this.logService.warn(`[File watcher]: started ignoring events due to too many file change events at once (incoming: ${r.length}, most recent change: ${r[0].resource.toString()}). Use 'files.watcherExclude' setting to exclude folders with lots of changing files (e.g. compilation output).`),e.pending>0&&this.logService.trace(`[File watcher]: started throttling events due to large amount of file change events at once (pending: ${e.pending}, most recent change: ${r[0].resource.toString()}). Use 'files.watcherExclude' setting to exclude folders with lots of changing files (e.g. compilation output).`)}}watch(o,a={recursive:!1,excludes:[]}){const n=new l.DisposableStore;let r=!1,e=()=>{r=!0};return n.add((0,l.toDisposable)(()=>e())),this.doWatch(o,a).then(t=>{r?(0,l.dispose)(t):e=()=>(0,l.dispose)(t)},t=>this.logService.error(t)),a.recursive||(this.watchedResources.set(o,(this.watchedResources.get(o)??0)+1),n.add((0,l.toDisposable)(()=>{const t=this.watchedResources.get(o);typeof t=="number"&&(t<=1?this.watchedResources.delete(o):this.watchedResources.set(o,t-1))}))),n}async doWatch(o,a){const n=await this.withProvider(o),r=this.toWatchKey(n,o,a);let e=this.activeWatchers.get(r);return e||(e={count:0,disposable:n.watch(o,a)},this.activeWatchers.set(r,e)),e.count+=1,(0,l.toDisposable)(()=>{e&&(e.count--,e.count===0&&((0,l.dispose)(e.disposable),this.activeWatchers.delete(r)))})}toWatchKey(o,a,n){const{providerExtUri:r}=this.getExtUri(o);return[r.getComparisonKey(a),String(n.recursive),n.excludes.join()].join()}dispose(){super.dispose();for(const[,o]of this.activeWatchers)(0,l.dispose)(o.disposable);this.activeWatchers.clear()}async doWriteBuffered(o,a,n,r){return this.writeQueue.queueFor(a,this.getExtUri(o).providerExtUri).queue(async()=>{const e=await o.open(a,{create:!0,unlock:n?.unlock??!1});try{(0,E.isReadableStream)(r)||(0,E.isReadableBufferedStream)(r)?await this.doWriteStreamBufferedQueued(o,e,r):await this.doWriteReadableBufferedQueued(o,e,r)}catch(t){throw(0,h.ensureFileSystemProviderError)(t)}finally{await o.close(e)}})}async doWriteStreamBufferedQueued(o,a,n){let r=0,e;if((0,E.isReadableBufferedStream)(n)){if(n.buffer.length>0){const t=b.VSBuffer.concat(n.buffer);await this.doWriteBuffer(o,a,t,t.byteLength,r,0),r+=t.byteLength}if(n.ended)return;e=n.stream}else e=n;return new Promise((t,s)=>{(0,E.listenStream)(e,{onData:async f=>{e.pause();try{await this.doWriteBuffer(o,a,f,f.byteLength,r,0)}catch(v){return s(v)}r+=f.byteLength,setTimeout(()=>e.resume())},onError:f=>s(f),onEnd:()=>t()})})}async doWriteReadableBufferedQueued(o,a,n){let r=0,e;for(;(e=n.read())!==null;)await this.doWriteBuffer(o,a,e,e.byteLength,r,0),r+=e.byteLength}async doWriteBuffer(o,a,n,r,e,t){let s=0;for(;s<r;)s+=await o.write(a,e+s,n.buffer,t+s,r-s)}async doWriteUnbuffered(o,a,n,r){return this.writeQueue.queueFor(a,this.getExtUri(o).providerExtUri).queue(()=>this.doWriteUnbufferedQueued(o,a,n,r))}async doWriteUnbufferedQueued(o,a,n,r){let e;r instanceof b.VSBuffer?e=r:(0,E.isReadableStream)(r)?e=await(0,b.streamToBuffer)(r):(0,E.isReadableBufferedStream)(r)?e=await(0,b.bufferedStreamToBuffer)(r):e=(0,b.readableToBuffer)(r),await o.writeFile(a,e.buffer,{create:!0,overwrite:!0,unlock:n?.unlock??!1})}async doPipeBuffered(o,a,n,r){return this.writeQueue.queueFor(r,this.getExtUri(n).providerExtUri).queue(()=>this.doPipeBufferedQueued(o,a,n,r))}async doPipeBufferedQueued(o,a,n,r){let e,t;try{e=await o.open(a,{create:!1}),t=await n.open(r,{create:!0,unlock:!1});const s=b.VSBuffer.alloc(this.BUFFER_SIZE);let f=0,v=0,L=0;do L=await o.read(e,f,s.buffer,v,s.byteLength-v),await this.doWriteBuffer(n,t,s,L,f,v),f+=L,v+=L,v===s.byteLength&&(v=0);while(L>0)}catch(s){throw(0,h.ensureFileSystemProviderError)(s)}finally{await P.Promises.settled([typeof e=="number"?o.close(e):Promise.resolve(),typeof t=="number"?n.close(t):Promise.resolve()])}}async doPipeUnbuffered(o,a,n,r){return this.writeQueue.queueFor(r,this.getExtUri(n).providerExtUri).queue(()=>this.doPipeUnbufferedQueued(o,a,n,r))}async doPipeUnbufferedQueued(o,a,n,r){return n.writeFile(r,await o.readFile(a),{create:!0,overwrite:!0,unlock:!1})}async doPipeUnbufferedToBuffered(o,a,n,r){return this.writeQueue.queueFor(r,this.getExtUri(n).providerExtUri).queue(()=>this.doPipeUnbufferedToBufferedQueued(o,a,n,r))}async doPipeUnbufferedToBufferedQueued(o,a,n,r){const e=await n.open(r,{create:!0,unlock:!1});try{const t=await o.readFile(a);await this.doWriteBuffer(n,e,b.VSBuffer.wrap(t),t.byteLength,0,0)}catch(t){throw(0,h.ensureFileSystemProviderError)(t)}finally{await n.close(e)}}async doPipeBufferedToUnbuffered(o,a,n,r){const e=await(0,b.streamToBuffer)(this.readFileBuffered(o,a,R.CancellationToken.None));await this.doWriteUnbuffered(n,r,void 0,e)}throwIfFileSystemIsReadonly(o,a){if(o.capabilities&2048)throw new h.FileOperationError((0,u.localize)(22,null,this.resourceForError(a)),6);return o}throwIfFileIsReadonly(o,a){if((a.permissions??0)&h.FilePermission.Readonly)throw new h.FileOperationError((0,u.localize)(23,null,this.resourceForError(o)),6)}resourceForError(o){return o.scheme===y.Schemas.file?o.fsPath:o.toString(!0)}};S.FILE_EVENTS_THROTTLING={maxChangesChunkSize:500,maxChangesBufferSize:3e4,coolDownDelay:200,warningscounter:0},S=ve([ae(0,m.ILogService)],S),i.FileService=S}),define(J[103],Q([0,1,48,136,3,17,11,47,6,12,18,38,13,84,16,53,94,95,96,99,27]),function(x,i,T,P,b,R,D,w,l,p,y,C,c,E,u,h,g,m,S,d,o){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.DiskFileSystemProvider=void 0,(()=>{try{(0,P.gracefulify)(T)}catch(n){console.error(`Error enabling graceful-fs: ${(0,o.toErrorMessage)(n)}`)}})();class a extends d.AbstractDiskFileSystemProvider{constructor(r,e){super(r);this.options=e,this.onDidChangeCapabilities=D.Event.None,this.mapHandleToPos=new Map,this.writeHandles=new Map,this.canFlush=!0}get capabilities(){return this._capabilities||(this._capabilities=2|4|16|8|8192,p.isLinux&&(this._capabilities|=1024)),this._capabilities}async stat(r){try{const{stat:e,symbolicLink:t}=await c.SymlinkSupport.stat(this.toFilePath(r));return{type:this.toType(e,t),ctime:e.birthtime.getTime(),mtime:e.mtime.getTime(),size:e.size}}catch(e){throw this.toFileSystemProviderError(e)}}async readdir(r){try{const e=await c.Promises.readdir(this.toFilePath(r),{withFileTypes:!0}),t=[];return await Promise.all(e.map(async s=>{try{let f;s.isSymbolicLink()?f=(await this.stat((0,y.joinPath)(r,s.name))).type:f=this.toType(s),t.push([s.name,f])}catch(f){this.logService.trace(f)}})),t}catch(e){throw this.toFileSystemProviderError(e)}}toType(r,e){let t;return e?.dangling?t=u.FileType.Unknown:r.isFile()?t=u.FileType.File:r.isDirectory()?t=u.FileType.Directory:t=u.FileType.Unknown,e&&(t|=u.FileType.SymbolicLink),t}async readFile(r){try{const e=this.toFilePath(r);return await c.Promises.readFile(e)}catch(e){throw this.toFileSystemProviderError(e)}}readFileStream(r,e,t){const s=(0,C.newWriteableStream)(f=>R.VSBuffer.concat(f.map(v=>R.VSBuffer.wrap(v))).buffer);return(0,h.readFileIntoStream)(this,r,s,f=>f.buffer,{...e,bufferSize:256*1024},t),s}async writeFile(r,e,t){let s;try{const f=this.toFilePath(r);if(!t.create||!t.overwrite){if(await c.Promises.exists(f)){if(!t.overwrite)throw(0,u.createFileSystemProviderError)((0,E.localize)(0,null),u.FileSystemProviderErrorCode.FileExists)}else if(!t.create)throw(0,u.createFileSystemProviderError)((0,E.localize)(1,null),u.FileSystemProviderErrorCode.FileNotFound)}s=await this.open(r,{create:!0,unlock:t.unlock}),await this.write(s,0,e,0,e.byteLength)}catch(f){throw await this.toFileSystemProviderWriteError(r,f)}finally{typeof s=="number"&&await this.close(s)}}async open(r,e){try{const t=this.toFilePath(r);if((0,u.isFileOpenForWriteOptions)(e)&&e.unlock)try{const{stat:v}=await c.SymlinkSupport.stat(t);v.mode&128||await c.Promises.chmod(t,v.mode|128)}catch(v){this.logService.trace(v)}let s;if((0,u.isFileOpenForWriteOptions)(e)){if(p.isWindows)try{await c.Promises.truncate(t,0),s="r+"}catch(v){v.code!=="ENOENT"&&this.logService.trace(v)}s||(s="w")}else s="r";const f=await c.Promises.open(t,s);return this.mapHandleToPos.set(f,0),(0,u.isFileOpenForWriteOptions)(e)&&this.writeHandles.set(f,r),f}catch(t){throw(0,u.isFileOpenForWriteOptions)(e)?await this.toFileSystemProviderWriteError(r,t):this.toFileSystemProviderError(t)}}async close(r){try{if(this.mapHandleToPos.delete(r),this.writeHandles.delete(r)&&this.canFlush)try{await c.Promises.fdatasync(r)}catch(e){this.canFlush=!1,this.logService.error(e)}return await c.Promises.close(r)}catch(e){throw this.toFileSystemProviderError(e)}}async read(r,e,t,s,f){const v=this.normalizePos(r,e);let L=null;try{const I=await c.Promises.read(r,t,s,f,v);return typeof I=="number"?L=I:L=I.bytesRead,L}catch(I){throw this.toFileSystemProviderError(I)}finally{this.updatePos(r,v,L)}}normalizePos(r,e){return e===this.mapHandleToPos.get(r)?null:e}updatePos(r,e,t){const s=this.mapHandleToPos.get(r);typeof s=="number"&&(typeof e=="number"||(typeof t=="number"?this.mapHandleToPos.set(r,s+t):this.mapHandleToPos.delete(r)))}async write(r,e,t,s,f){return(0,b.retry)(()=>this.doWrite(r,e,t,s,f),100,3)}async doWrite(r,e,t,s,f){const v=this.normalizePos(r,e);let L=null;try{const I=await c.Promises.write(r,t,s,f,v);return typeof I=="number"?L=I:L=I.bytesWritten,L}catch(I){throw await this.toFileSystemProviderWriteError(this.writeHandles.get(r),I)}finally{this.updatePos(r,v,L)}}async mkdir(r){try{await c.Promises.mkdir(this.toFilePath(r))}catch(e){throw this.toFileSystemProviderError(e)}}async delete(r,e){try{const t=this.toFilePath(r);await this.doDelete(t,e)}catch(t){throw this.toFileSystemProviderError(t)}}async doDelete(r,e){e.recursive?await c.Promises.rm(r,c.RimRafMode.MOVE):await c.Promises.unlink(r)}async rename(r,e,t){const s=this.toFilePath(r),f=this.toFilePath(e);if(s!==f)try{await this.validateTargetDeleted(r,e,"move",t.overwrite),await c.Promises.move(s,f)}catch(v){throw(v.code==="EINVAL"||v.code==="EBUSY"||v.code==="ENAMETOOLONG")&&(v=new Error((0,E.localize)(2,null,(0,l.basename)(s),(0,l.basename)((0,l.dirname)(f)),v.toString()))),this.toFileSystemProviderError(v)}}async copy(r,e,t){const s=this.toFilePath(r),f=this.toFilePath(e);if(s!==f)try{await this.validateTargetDeleted(r,e,"copy",t.overwrite),await c.Promises.copy(s,f,{preserveSymlinks:!0})}catch(v){throw(v.code==="EINVAL"||v.code==="EBUSY"||v.code==="ENAMETOOLONG")&&(v=new Error((0,E.localize)(3,null,(0,l.basename)(s),(0,l.basename)((0,l.dirname)(f)),v.toString()))),this.toFileSystemProviderError(v)}}async validateTargetDeleted(r,e,t,s){const f=this.toFilePath(r),v=this.toFilePath(e);let L=!1;if(!!(this.capabilities&1024)||(L=(0,w.isEqual)(f,v,!0)),L&&t==="copy")throw(0,u.createFileSystemProviderError)((0,E.localize)(4,null),u.FileSystemProviderErrorCode.FileExists);if(!L&&await c.Promises.exists(v)){if(!s)throw(0,u.createFileSystemProviderError)((0,E.localize)(5,null),u.FileSystemProviderErrorCode.FileExists);await this.delete(e,{recursive:!0,useTrash:!1})}}createRecursiveWatcher(r,e,t){let s,f=!1;return this.options?.watcher?.usePolling?f=!1:f=this.options?.legacyWatcher==="on",f?s=m.FileWatcher:s=S.FileWatcher,new s(v=>r(v),v=>e(v),t,this.options?.watcher)}doWatch(r,e){const t=this.options?.watcher?.usePolling;if(t===!0)for(const s of e)s.pollingInterval=this.options?.watcher?.pollingInterval??5e3;else if(Array.isArray(t))for(const s of e)t.includes(s.path)&&(s.pollingInterval=this.options?.watcher?.pollingInterval??5e3);return super.doWatch(r,e)}createNonRecursiveWatcher(r,e,t,s){return new g.FileWatcher(r,f=>e(f),f=>t(f),s)}toFileSystemProviderError(r){if(r instanceof u.FileSystemProviderError)return r;let e;switch(r.code){case"ENOENT":e=u.FileSystemProviderErrorCode.FileNotFound;break;case"EISDIR":e=u.FileSystemProviderErrorCode.FileIsADirectory;break;case"ENOTDIR":e=u.FileSystemProviderErrorCode.FileNotADirectory;break;case"EEXIST":e=u.FileSystemProviderErrorCode.FileExists;break;case"EPERM":case"EACCES":e=u.FileSystemProviderErrorCode.NoPermissions;break;default:e=u.FileSystemProviderErrorCode.Unknown}return(0,u.createFileSystemProviderError)(r,e)}async toFileSystemProviderWriteError(r,e){let t=this.toFileSystemProviderError(e);if(r&&t.code===u.FileSystemProviderErrorCode.NoPermissions)try{const{stat:s}=await c.SymlinkSupport.stat(this.toFilePath(r));s.mode&128||(t=(0,u.createFileSystemProviderError)(e,u.FileSystemProviderErrorCode.FileWriteLocked))}catch(s){this.logService.trace(s)}return t}}i.DiskFileSystemProvider=a}),define(J[104],Q([0,1,16,15]),function(x,i,T,P){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.SpdLogLogger=void 0;async function b(w,l,p,y,C){try{const c=await new Promise((u,h)=>{x(["spdlog"],u,h)});c.setFlushOn(P.LogLevel.Trace);const E=await c.createAsyncRotatingLogger(w,l,p,y);return C&&E.clearFormatters(),E}catch(c){console.error(c)}return null}function R(w,l,p){switch(l){case P.LogLevel.Trace:w.trace(p);break;case P.LogLevel.Debug:w.debug(p);break;case P.LogLevel.Info:w.info(p);break;case P.LogLevel.Warning:w.warn(p);break;case P.LogLevel.Error:w.error(p);break;case P.LogLevel.Critical:w.critical(p);break;default:throw new Error("Invalid log level")}}class D extends P.AbstractMessageLogger{constructor(l,p,y,C,c){super();this.buffer=[],this.setLevel(c),this._loggerCreationPromise=this._createSpdLogLogger(l,p,y,C),this._register(this.onDidChangeLogLevel(E=>{this._logger&&this._logger.setLevel(E)}))}async _createSpdLogLogger(l,p,y,C){const c=y?6:1,E=30/c*T.ByteSize.MB,u=await b(l,p,E,c,C);if(u){this._logger=u,this._logger.setLevel(this.getLevel());for(const{level:h,message:g}of this.buffer)R(this._logger,h,g);this.buffer=[]}}log(l,p){this._logger?R(this._logger,l,p):this.getLevel()<=l&&this.buffer.push({level:l,message:p})}flush(){this._logger?this._logger.flush():this._loggerCreationPromise.then(()=>this.flush())}dispose(){this._logger?this.disposeLogger():this._loggerCreationPromise.then(()=>this.disposeLogger())}disposeLogger(){this._logger&&(this._logger.drop(),this._logger=void 0)}}i.SpdLogLogger=D}),define(J[32],Q([0,1,14]),function(x,i,T){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.IProductService=void 0,i.IProductService=(0,T.createDecorator)("productService")}),define(J[29],Q([0,1,56,8]),function(x,i,T,P){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.Registry=void 0;class b{constructor(){this.data=new Map}add(D,w){T.ok(P.isString(D)),T.ok(P.isObject(w)),T.ok(!this.data.has(D),"There is already an extension with this id"),this.data.set(D,w)}knows(D){return this.data.has(D)}as(D){return this.data.get(D)||null}}i.Registry=new b}),define(J[105],Q([0,1,11,29]),function(x,i,T,P){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.Extensions=void 0,i.Extensions={JSONContribution:"base.contributions.json"};function b(w){return w.length>0&&w.charAt(w.length-1)==="#"?w.substring(0,w.length-1):w}class R{constructor(){this._onDidChangeSchema=new T.Emitter,this.onDidChangeSchema=this._onDidChangeSchema.event,this.schemasById={}}registerSchema(l,p){this.schemasById[b(l)]=p,this._onDidChangeSchema.fire(l)}notifySchemaChanged(l){this._onDidChangeSchema.fire(l)}getSchemaContributions(){return{schemas:this.schemasById}}}const D=new R;P.Registry.add(i.Extensions.JSONContribution,D)}),define(J[35],Q([0,1,19,11,8,73,105,29]),function(x,i,T,P,b,R,D,w){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.getScopes=i.validateProperty=i.getDefaultValue=i.keyFromOverrideIdentifiers=i.overrideIdentifiersFromKey=i.OVERRIDE_PROPERTY_REGEX=i.OVERRIDE_PROPERTY_PATTERN=i.configurationDefaultsSchemaId=i.resourceLanguageSettingsSchemaId=i.resourceSettings=i.windowSettings=i.machineOverridableSettings=i.machineSettings=i.applicationSettings=i.allSettings=i.ConfigurationScope=i.Extensions=i.EditPresentationTypes=void 0;var l;(function(o){o.Multiline="multilineText",o.Singleline="singlelineText"})(l=i.EditPresentationTypes||(i.EditPresentationTypes={})),i.Extensions={Configuration:"base.contributions.configuration"};var p;(function(o){o[o.APPLICATION=1]="APPLICATION",o[o.MACHINE=2]="MACHINE",o[o.WINDOW=3]="WINDOW",o[o.RESOURCE=4]="RESOURCE",o[o.LANGUAGE_OVERRIDABLE=5]="LANGUAGE_OVERRIDABLE",o[o.MACHINE_OVERRIDABLE=6]="MACHINE_OVERRIDABLE"})(p=i.ConfigurationScope||(i.ConfigurationScope={})),i.allSettings={properties:{},patternProperties:{}},i.applicationSettings={properties:{},patternProperties:{}},i.machineSettings={properties:{},patternProperties:{}},i.machineOverridableSettings={properties:{},patternProperties:{}},i.windowSettings={properties:{},patternProperties:{}},i.resourceSettings={properties:{},patternProperties:{}},i.resourceLanguageSettingsSchemaId="vscode://schemas/settings/resourceLanguage",i.configurationDefaultsSchemaId="vscode://schemas/settings/configurationDefaults";const y=w.Registry.as(D.Extensions.JSONContribution);class C{constructor(){this.overrideIdentifiers=new Set,this._onDidSchemaChange=new P.Emitter,this.onDidSchemaChange=this._onDidSchemaChange.event,this._onDidUpdateConfiguration=new P.Emitter,this.onDidUpdateConfiguration=this._onDidUpdateConfiguration.event,this.configurationDefaultsOverrides=new Map,this.defaultLanguageConfigurationOverridesNode={id:"defaultOverrides",title:R.localize(0,null),properties:{}},this.configurationContributors=[this.defaultLanguageConfigurationOverridesNode],this.resourceLanguageSettingsSchema={properties:{},patternProperties:{},additionalProperties:!1,errorMessage:"Unknown editor configuration setting",allowTrailingCommas:!0,allowComments:!0},this.configurationProperties={},this.excludedConfigurationProperties={},y.registerSchema(i.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this.registerOverridePropertyPatternKey()}registerConfiguration(a,n=!0){this.registerConfigurations([a],n)}registerConfigurations(a,n=!0){const r=this.doRegisterConfigurations(a,n);y.registerSchema(i.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:r})}deregisterConfigurations(a){const n=this.doDeregisterConfigurations(a);y.registerSchema(i.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:n})}updateConfigurations({add:a,remove:n}){const r=[];r.push(...this.doDeregisterConfigurations(n)),r.push(...this.doRegisterConfigurations(a,!1)),y.registerSchema(i.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:(0,T.distinct)(r)})}registerDefaultConfigurations(a){const n=[],r=[];for(const{overrides:e,source:t}of a)for(const s in e)if(n.push(s),i.OVERRIDE_PROPERTY_REGEX.test(s)){const f={...this.configurationDefaultsOverrides.get(s)?.value||{},...e[s]};this.configurationDefaultsOverrides.set(s,{source:t,value:f});const v={type:"object",default:f,description:R.localize(1,null,s),$ref:i.resourceLanguageSettingsSchemaId,defaultDefaultValue:f,source:b.isString(t)?void 0:t};r.push(...u(s)),this.configurationProperties[s]=v,this.defaultLanguageConfigurationOverridesNode.properties[s]=v}else{this.configurationDefaultsOverrides.set(s,{value:e[s],source:t});const f=this.configurationProperties[s];f&&(this.updatePropertyDefaultValue(s,f),this.updateSchema(s,f))}this.registerOverrideIdentifiers(r),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:n,defaultsOverrides:!0})}deregisterDefaultConfigurations(a){const n=[];for(const{overrides:r,source:e}of a)for(const t in r){const s=this.configurationDefaultsOverrides.get(t),f=b.isString(e)?e:e?.id,v=b.isString(s?.source)?s?.source:s?.source?.id;if(f===v)if(n.push(t),this.configurationDefaultsOverrides.delete(t),i.OVERRIDE_PROPERTY_REGEX.test(t))delete this.configurationProperties[t],delete this.defaultLanguageConfigurationOverridesNode.properties[t];else{const L=this.configurationProperties[t];L&&(this.updatePropertyDefaultValue(t,L),this.updateSchema(t,L))}}this.updateOverridePropertyPatternKey(),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:n,defaultsOverrides:!0})}notifyConfigurationSchemaUpdated(...a){this._onDidSchemaChange.fire()}registerOverrideIdentifiers(a){for(const n of a)this.overrideIdentifiers.add(n);this.updateOverridePropertyPatternKey()}doRegisterConfigurations(a,n){const r=[];return a.forEach(e=>{r.push(...this.validateAndRegisterProperties(e,n,e.extensionInfo,e.restrictedProperties)),this.configurationContributors.push(e),this.registerJSONConfiguration(e)}),r}doDeregisterConfigurations(a){const n=[],r=e=>{if(e.properties)for(const t in e.properties)n.push(t),delete this.configurationProperties[t],this.removeFromSchema(t,e.properties[t]);e.allOf&&e.allOf.forEach(t=>r(t))};for(const e of a){r(e);const t=this.configurationContributors.indexOf(e);t!==-1&&this.configurationContributors.splice(t,1)}return n}validateAndRegisterProperties(a,n=!0,r,e,t=3){t=b.isUndefinedOrNull(a.scope)?t:a.scope;let s=[],f=a.properties;if(f)for(let L in f){if(n&&S(L)){delete f[L];continue}const I=f[L];if(I.source=r,I.defaultDefaultValue=f[L].default,this.updatePropertyDefaultValue(L,I),i.OVERRIDE_PROPERTY_REGEX.test(L)?I.scope=void 0:(I.scope=b.isUndefinedOrNull(I.scope)?t:I.scope,I.restricted=b.isUndefinedOrNull(I.restricted)?!!e?.includes(L):I.restricted),f[L].hasOwnProperty("included")&&!f[L].included){this.excludedConfigurationProperties[L]=f[L],delete f[L];continue}else this.configurationProperties[L]=f[L];!f[L].deprecationMessage&&f[L].markdownDeprecationMessage&&(f[L].deprecationMessage=f[L].markdownDeprecationMessage),s.push(L)}let v=a.allOf;if(v)for(let L of v)s.push(...this.validateAndRegisterProperties(L,n,r,e,t));return s}getConfigurations(){return this.configurationContributors}getConfigurationProperties(){return this.configurationProperties}getExcludedConfigurationProperties(){return this.excludedConfigurationProperties}getConfigurationDefaultsOverrides(){return this.configurationDefaultsOverrides}registerJSONConfiguration(a){const n=r=>{let e=r.properties;if(e)for(const s in e)this.updateSchema(s,e[s]);let t=r.allOf;t&&t.forEach(n)};n(a)}updateSchema(a,n){switch(i.allSettings.properties[a]=n,n.scope){case 1:i.applicationSettings.properties[a]=n;break;case 2:i.machineSettings.properties[a]=n;break;case 6:i.machineOverridableSettings.properties[a]=n;break;case 3:i.windowSettings.properties[a]=n;break;case 4:i.resourceSettings.properties[a]=n;break;case 5:i.resourceSettings.properties[a]=n,this.resourceLanguageSettingsSchema.properties[a]=n;break}}removeFromSchema(a,n){switch(delete i.allSettings.properties[a],n.scope){case 1:delete i.applicationSettings.properties[a];break;case 2:delete i.machineSettings.properties[a];break;case 6:delete i.machineOverridableSettings.properties[a];break;case 3:delete i.windowSettings.properties[a];break;case 4:case 5:delete i.resourceSettings.properties[a],delete this.resourceLanguageSettingsSchema.properties[a];break}}updateOverridePropertyPatternKey(){for(const a of this.overrideIdentifiers.values()){const n=`[${a}]`,r={type:"object",description:R.localize(2,null),errorMessage:R.localize(3,null),$ref:i.resourceLanguageSettingsSchemaId};this.updatePropertyDefaultValue(n,r),i.allSettings.properties[n]=r,i.applicationSettings.properties[n]=r,i.machineSettings.properties[n]=r,i.machineOverridableSettings.properties[n]=r,i.windowSettings.properties[n]=r,i.resourceSettings.properties[n]=r}this._onDidSchemaChange.fire()}registerOverridePropertyPatternKey(){const a={type:"object",description:R.localize(4,null),errorMessage:R.localize(5,null),$ref:i.resourceLanguageSettingsSchemaId};i.allSettings.patternProperties[i.OVERRIDE_PROPERTY_PATTERN]=a,i.applicationSettings.patternProperties[i.OVERRIDE_PROPERTY_PATTERN]=a,i.machineSettings.patternProperties[i.OVERRIDE_PROPERTY_PATTERN]=a,i.machineOverridableSettings.patternProperties[i.OVERRIDE_PROPERTY_PATTERN]=a,i.windowSettings.patternProperties[i.OVERRIDE_PROPERTY_PATTERN]=a,i.resourceSettings.patternProperties[i.OVERRIDE_PROPERTY_PATTERN]=a,this._onDidSchemaChange.fire()}updatePropertyDefaultValue(a,n){const r=this.configurationDefaultsOverrides.get(a);let e=r?.value,t=r?.source;b.isUndefined(e)&&(e=n.defaultDefaultValue,t=void 0),b.isUndefined(e)&&(e=g(n.type)),n.default=e,n.defaultValueSource=t}}const c="\\[([^\\]]+)\\]",E=new RegExp(c,"g");i.OVERRIDE_PROPERTY_PATTERN=`^(${c})+$`,i.OVERRIDE_PROPERTY_REGEX=new RegExp(i.OVERRIDE_PROPERTY_PATTERN);function u(o){const a=[];if(i.OVERRIDE_PROPERTY_REGEX.test(o)){let n=E.exec(o);for(;n?.length;){const r=n[1].trim();r&&a.push(r),n=E.exec(o)}}return(0,T.distinct)(a)}i.overrideIdentifiersFromKey=u;function h(o){return o.reduce((a,n)=>`${a}[${n}]`,"")}i.keyFromOverrideIdentifiers=h;function g(o){switch(Array.isArray(o)?o[0]:o){case"boolean":return!1;case"integer":case"number":return 0;case"string":return"";case"array":return[];case"object":return{};default:return null}}i.getDefaultValue=g;const m=new C;w.Registry.add(i.Extensions.Configuration,m);function S(o){return o.trim()?i.OVERRIDE_PROPERTY_REGEX.test(o)?R.localize(7,null,o):m.getConfigurationProperties()[o]!==void 0?R.localize(8,null,o):null:R.localize(6,null)}i.validateProperty=S;function d(){const o=[],a=m.getConfigurationProperties();for(const n of Object.keys(a))o.push([n,a[n].scope]);return o.push(["launch",4]),o.push(["task",4]),o}i.getScopes=d}),define(J[106],Q([0,1,19,11,57,2,101,21,8,9,25,35,29]),function(x,i,T,P,b,R,D,w,l,p,y,C,c){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.AllKeysConfigurationChangeEvent=i.ConfigurationChangeEvent=i.mergeChanges=i.Configuration=i.UserSettings=i.ConfigurationModelParser=i.DefaultConfigurationModel=i.ConfigurationModel=void 0;class E{constructor(e={},t=[],s=[]){this._contents=e,this._keys=t,this._overrides=s,this.isFrozen=!1,this.overrideConfigurations=new Map}get contents(){return this.checkAndFreeze(this._contents)}get overrides(){return this.checkAndFreeze(this._overrides)}get keys(){return this.checkAndFreeze(this._keys)}isEmpty(){return this._keys.length===0&&Object.keys(this._contents).length===0&&this._overrides.length===0}getValue(e){return e?(0,y.getConfigurationValue)(this.contents,e):this.contents}getOverrideValue(e,t){const s=this.getContentsForOverrideIdentifer(t);return s?e?(0,y.getConfigurationValue)(s,e):s:void 0}getKeysForOverrideIdentifier(e){const t=[];for(const s of this.overrides)s.identifiers.includes(e)&&t.push(...s.keys);return T.distinct(t)}getAllOverrideIdentifiers(){const e=[];for(const t of this.overrides)e.push(...t.identifiers);return T.distinct(e)}override(e){let t=this.overrideConfigurations.get(e);return t||(t=this.createOverrideConfigurationModel(e),this.overrideConfigurations.set(e,t)),t}merge(...e){const t=w.deepClone(this.contents),s=w.deepClone(this.overrides),f=[...this.keys];for(const v of e){this.mergeContents(t,v.contents);for(const L of v.overrides){const[I]=s.filter(O=>T.equals(O.identifiers,L.identifiers));I?(this.mergeContents(I.contents,L.contents),I.keys.push(...L.keys),I.keys=T.distinct(I.keys)):s.push(w.deepClone(L))}for(const L of v.keys)f.indexOf(L)===-1&&f.push(L)}return new E(t,f,s)}freeze(){return this.isFrozen=!0,this}createOverrideConfigurationModel(e){const t=this.getContentsForOverrideIdentifer(e);if(!t||typeof t!="object"||!Object.keys(t).length)return this;let s={};for(const f of T.distinct([...Object.keys(this.contents),...Object.keys(t)])){let v=this.contents[f],L=t[f];L&&(typeof v=="object"&&typeof L=="object"?(v=w.deepClone(v),this.mergeContents(v,L)):v=L),s[f]=v}return new E(s,this.keys,this.overrides)}mergeContents(e,t){for(const s of Object.keys(t)){if(s in e&&l.isObject(e[s])&&l.isObject(t[s])){this.mergeContents(e[s],t[s]);continue}e[s]=w.deepClone(t[s])}}checkAndFreeze(e){return this.isFrozen&&!Object.isFrozen(e)?w.deepFreeze(e):e}getContentsForOverrideIdentifer(e){let t=null,s=null;const f=v=>{v&&(s?this.mergeContents(s,v):s=w.deepClone(v))};for(const v of this.overrides)T.equals(v.identifiers,[e])?t=v.contents:v.identifiers.includes(e)&&f(v.contents);return f(t),s}toJSON(){return{contents:this.contents,overrides:this.overrides,keys:this.keys}}setValue(e,t){this.addKey(e),(0,y.addToValueTree)(this.contents,e,t,s=>{throw new Error(s)})}removeValue(e){this.removeKey(e)&&(0,y.removeFromValueTree)(this.contents,e)}addKey(e){let t=this.keys.length;for(let s=0;s<t;s++)e.indexOf(this.keys[s])===0&&(t=s);this.keys.splice(t,1,e)}removeKey(e){let t=this.keys.indexOf(e);return t!==-1?(this.keys.splice(t,1),!0):!1}}i.ConfigurationModel=E;class u extends E{constructor(e={}){const t=c.Registry.as(C.Extensions.Configuration).getConfigurationProperties(),s=Object.keys(t),f=Object.create(null),v=[];for(const L in t){const I=e[L],O=I!==void 0?I:t[L].default;(0,y.addToValueTree)(f,L,O,N=>console.error(`Conflict in default settings: ${N}`))}for(const L of Object.keys(f))C.OVERRIDE_PROPERTY_REGEX.test(L)&&v.push({identifiers:(0,C.overrideIdentifiersFromKey)(L),keys:Object.keys(f[L]),contents:(0,y.toValuesTree)(f[L],I=>console.error(`Conflict in default settings file: ${I}`))});super(f,s,v)}}i.DefaultConfigurationModel=u;class h{constructor(e){this._name=e,this._raw=null,this._configurationModel=null,this._restrictedConfigurations=[],this._parseErrors=[]}get configurationModel(){return this._configurationModel||new E}get restrictedConfigurations(){return this._restrictedConfigurations}get errors(){return this._parseErrors}parse(e,t){if(!l.isUndefinedOrNull(e)){const s=this.doParseContent(e);this.parseRaw(s,t)}}reparse(e){this._raw&&this.parseRaw(this._raw,e)}parseRaw(e,t){this._raw=e;const{contents:s,keys:f,overrides:v,restricted:L}=this.doParseRaw(e,t);this._configurationModel=new E(s,f,v),this._restrictedConfigurations=L||[]}doParseContent(e){let t={},s=null,f=[],v=[],L=[];function I(N){Array.isArray(f)?f.push(N):s!==null&&(f[s]=N)}let O={onObjectBegin:()=>{let N={};I(N),v.push(f),f=N,s=null},onObjectProperty:N=>{s=N},onObjectEnd:()=>{f=v.pop()},onArrayBegin:()=>{let N=[];I(N),v.push(f),f=N,s=null},onArrayEnd:()=>{f=v.pop()},onLiteralValue:I,onError:(N,G,ee)=>{L.push({error:N,offset:G,length:ee})}};if(e)try{b.visit(e,O),t=f[0]||{}}catch(N){console.error(`Error while parsing settings file ${this._name}: ${N}`),this._parseErrors=[N]}return t}doParseRaw(e,t){const s=c.Registry.as(C.Extensions.Configuration).getConfigurationProperties(),f=this.filter(e,s,!0,t);e=f.raw;const v=(0,y.toValuesTree)(e,O=>console.error(`Conflict in settings file ${this._name}: ${O}`)),L=Object.keys(e),I=this.toOverrides(e,O=>console.error(`Conflict in settings file ${this._name}: ${O}`));return{contents:v,keys:L,overrides:I,restricted:f.restricted}}filter(e,t,s,f){if(!f?.scopes&&!f?.skipRestricted)return{raw:e,restricted:[]};const v={},L=[];for(let I in e)if(C.OVERRIDE_PROPERTY_REGEX.test(I)&&s){const O=this.filter(e[I],t,!1,f);v[I]=O.raw,L.push(...O.restricted)}else{const O=t[I],N=O?typeof O.scope!="undefined"?O.scope:3:void 0;O?.restricted&&L.push(I),(N===void 0||f.scopes===void 0||f.scopes.includes(N))&&(f.skipRestricted&&O?.restricted||(v[I]=e[I]))}return{raw:v,restricted:L}}toOverrides(e,t){const s=[];for(const f of Object.keys(e))if(C.OVERRIDE_PROPERTY_REGEX.test(f)){const v={};for(const L in e[f])v[L]=e[f][L];s.push({identifiers:(0,C.overrideIdentifiersFromKey)(f),keys:Object.keys(v),contents:(0,y.toValuesTree)(v,t)})}return s}}i.ConfigurationModelParser=h;class g extends R.Disposable{constructor(e,t,s,f){super();this.userSettingsResource=e,this.scopes=t,this.fileService=f,this._onDidChange=this._register(new P.Emitter),this.onDidChange=this._onDidChange.event,this.parser=new h(this.userSettingsResource.toString()),this.parseOptions={scopes:this.scopes},this._register(this.fileService.watch(s.dirname(this.userSettingsResource))),this._register(this.fileService.watch(this.userSettingsResource)),this._register(P.Event.filter(this.fileService.onDidFilesChange,v=>v.contains(this.userSettingsResource))(()=>this._onDidChange.fire()))}async loadConfiguration(){try{const e=await this.fileService.readFile(this.userSettingsResource);return this.parser.parse(e.value.toString()||"{}",this.parseOptions),this.parser.configurationModel}catch(e){return new E}}reparse(){return this.parser.reparse(this.parseOptions),this.parser.configurationModel}getRestrictedSettings(){return this.parser.restrictedConfigurations}}i.UserSettings=g;class m{constructor(e,t,s=new E,f=new E,v=new D.ResourceMap,L=new E,I=new D.ResourceMap,O=!0){this._defaultConfiguration=e,this._localUserConfiguration=t,this._remoteUserConfiguration=s,this._workspaceConfiguration=f,this._folderConfigurations=v,this._memoryConfiguration=L,this._memoryConfigurationByResource=I,this._freeze=O,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations=new D.ResourceMap,this._userConfiguration=null}getValue(e,t,s){return this.getConsolidateConfigurationModel(t,s).getValue(e)}updateValue(e,t,s={}){let f;s.resource?(f=this._memoryConfigurationByResource.get(s.resource),f||(f=new E,this._memoryConfigurationByResource.set(s.resource,f))):f=this._memoryConfiguration,t===void 0?f.removeValue(e):f.setValue(e,t),s.resource||(this._workspaceConsolidatedConfiguration=null)}inspect(e,t,s){const f=this.getConsolidateConfigurationModel(t,s),v=this.getFolderConfigurationModelForResource(t.resource,s),L=t.resource?this._memoryConfigurationByResource.get(t.resource)||this._memoryConfiguration:this._memoryConfiguration,I=t.overrideIdentifier?this._defaultConfiguration.freeze().override(t.overrideIdentifier).getValue(e):this._defaultConfiguration.freeze().getValue(e),O=t.overrideIdentifier?this.userConfiguration.freeze().override(t.overrideIdentifier).getValue(e):this.userConfiguration.freeze().getValue(e),N=t.overrideIdentifier?this.localUserConfiguration.freeze().override(t.overrideIdentifier).getValue(e):this.localUserConfiguration.freeze().getValue(e),G=t.overrideIdentifier?this.remoteUserConfiguration.freeze().override(t.overrideIdentifier).getValue(e):this.remoteUserConfiguration.freeze().getValue(e),ee=s?t.overrideIdentifier?this._workspaceConfiguration.freeze().override(t.overrideIdentifier).getValue(e):this._workspaceConfiguration.freeze().getValue(e):void 0,ge=v?t.overrideIdentifier?v.freeze().override(t.overrideIdentifier).getValue(e):v.freeze().getValue(e):void 0,ce=t.overrideIdentifier?L.override(t.overrideIdentifier).getValue(e):L.getValue(e),te=f.getValue(e),he=T.distinct(T.flatten(f.overrides.map(W=>W.identifiers))).filter(W=>f.getOverrideValue(e,W)!==void 0);return{defaultValue:I,userValue:O,userLocalValue:N,userRemoteValue:G,workspaceValue:ee,workspaceFolderValue:ge,memoryValue:ce,value:te,default:I!==void 0?{value:this._defaultConfiguration.freeze().getValue(e),override:t.overrideIdentifier?this._defaultConfiguration.freeze().getOverrideValue(e,t.overrideIdentifier):void 0}:void 0,user:O!==void 0?{value:this.userConfiguration.freeze().getValue(e),override:t.overrideIdentifier?this.userConfiguration.freeze().getOverrideValue(e,t.overrideIdentifier):void 0}:void 0,userLocal:N!==void 0?{value:this.localUserConfiguration.freeze().getValue(e),override:t.overrideIdentifier?this.localUserConfiguration.freeze().getOverrideValue(e,t.overrideIdentifier):void 0}:void 0,userRemote:G!==void 0?{value:this.remoteUserConfiguration.freeze().getValue(e),override:t.overrideIdentifier?this.remoteUserConfiguration.freeze().getOverrideValue(e,t.overrideIdentifier):void 0}:void 0,workspace:ee!==void 0?{value:this._workspaceConfiguration.freeze().getValue(e),override:t.overrideIdentifier?this._workspaceConfiguration.freeze().getOverrideValue(e,t.overrideIdentifier):void 0}:void 0,workspaceFolder:ge!==void 0?{value:v?.freeze().getValue(e),override:t.overrideIdentifier?v?.freeze().getOverrideValue(e,t.overrideIdentifier):void 0}:void 0,memory:ce!==void 0?{value:L.getValue(e),override:t.overrideIdentifier?L.getOverrideValue(e,t.overrideIdentifier):void 0}:void 0,overrideIdentifiers:he.length?he:void 0}}keys(e){const t=this.getFolderConfigurationModelForResource(void 0,e);return{default:this._defaultConfiguration.freeze().keys,user:this.userConfiguration.freeze().keys,workspace:this._workspaceConfiguration.freeze().keys,workspaceFolder:t?t.freeze().keys:[]}}updateDefaultConfiguration(e){this._defaultConfiguration=e,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateLocalUserConfiguration(e){this._localUserConfiguration=e,this._userConfiguration=null,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateRemoteUserConfiguration(e){this._remoteUserConfiguration=e,this._userConfiguration=null,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateWorkspaceConfiguration(e){this._workspaceConfiguration=e,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateFolderConfiguration(e,t){this._folderConfigurations.set(e,t),this._foldersConsolidatedConfigurations.delete(e)}deleteFolderConfiguration(e){this.folderConfigurations.delete(e),this._foldersConsolidatedConfigurations.delete(e)}compareAndUpdateDefaultConfiguration(e,t){const s=[];if(!t){const{added:f,updated:v,removed:L}=a(this._defaultConfiguration,e);t=[...f,...v,...L]}for(const f of t)for(const v of(0,C.overrideIdentifiersFromKey)(f)){const L=this._defaultConfiguration.getKeysForOverrideIdentifier(v),I=e.getKeysForOverrideIdentifier(v),O=[...I.filter(N=>L.indexOf(N)===-1),...L.filter(N=>I.indexOf(N)===-1),...L.filter(N=>!w.equals(this._defaultConfiguration.override(v).getValue(N),e.override(v).getValue(N)))];s.push([v,O])}return this.updateDefaultConfiguration(e),{keys:t,overrides:s}}compareAndUpdateLocalUserConfiguration(e){const{added:t,updated:s,removed:f,overrides:v}=a(this.localUserConfiguration,e),L=[...t,...s,...f];return L.length&&this.updateLocalUserConfiguration(e),{keys:L,overrides:v}}compareAndUpdateRemoteUserConfiguration(e){const{added:t,updated:s,removed:f,overrides:v}=a(this.remoteUserConfiguration,e);let L=[...t,...s,...f];return L.length&&this.updateRemoteUserConfiguration(e),{keys:L,overrides:v}}compareAndUpdateWorkspaceConfiguration(e){const{added:t,updated:s,removed:f,overrides:v}=a(this.workspaceConfiguration,e);let L=[...t,...s,...f];return L.length&&this.updateWorkspaceConfiguration(e),{keys:L,overrides:v}}compareAndUpdateFolderConfiguration(e,t){const s=this.folderConfigurations.get(e),{added:f,updated:v,removed:L,overrides:I}=a(s,t);let O=[...f,...v,...L];return(O.length||!s)&&this.updateFolderConfiguration(e,t),{keys:O,overrides:I}}compareAndDeleteFolderConfiguration(e){const t=this.folderConfigurations.get(e);if(!t)throw new Error("Unknown folder");this.deleteFolderConfiguration(e);const{added:s,updated:f,removed:v,overrides:L}=a(t,void 0);return{keys:[...s,...f,...v],overrides:L}}get defaults(){return this._defaultConfiguration}get userConfiguration(){return this._userConfiguration||(this._userConfiguration=this._remoteUserConfiguration.isEmpty()?this._localUserConfiguration:this._localUserConfiguration.merge(this._remoteUserConfiguration),this._freeze&&this._userConfiguration.freeze()),this._userConfiguration}get localUserConfiguration(){return this._localUserConfiguration}get remoteUserConfiguration(){return this._remoteUserConfiguration}get workspaceConfiguration(){return this._workspaceConfiguration}get folderConfigurations(){return this._folderConfigurations}getConsolidateConfigurationModel(e,t){let s=this.getConsolidatedConfigurationModelForResource(e,t);return e.overrideIdentifier?s.override(e.overrideIdentifier):s}getConsolidatedConfigurationModelForResource({resource:e},t){let s=this.getWorkspaceConsolidatedConfiguration();if(t&&e){const f=t.getFolder(e);f&&(s=this.getFolderConsolidatedConfiguration(f.uri)||s);const v=this._memoryConfigurationByResource.get(e);v&&(s=s.merge(v))}return s}getWorkspaceConsolidatedConfiguration(){return this._workspaceConsolidatedConfiguration||(this._workspaceConsolidatedConfiguration=this._defaultConfiguration.merge(this.userConfiguration,this._workspaceConfiguration,this._memoryConfiguration),this._freeze&&(this._workspaceConfiguration=this._workspaceConfiguration.freeze())),this._workspaceConsolidatedConfiguration}getFolderConsolidatedConfiguration(e){let t=this._foldersConsolidatedConfigurations.get(e);if(!t){const s=this.getWorkspaceConsolidatedConfiguration(),f=this._folderConfigurations.get(e);f?(t=s.merge(f),this._freeze&&(t=t.freeze()),this._foldersConsolidatedConfigurations.set(e,t)):t=s}return t}getFolderConfigurationModelForResource(e,t){if(t&&e){const s=t.getFolder(e);if(s)return this._folderConfigurations.get(s.uri)}}toData(){return{defaults:{contents:this._defaultConfiguration.contents,overrides:this._defaultConfiguration.overrides,keys:this._defaultConfiguration.keys},user:{contents:this.userConfiguration.contents,overrides:this.userConfiguration.overrides,keys:this.userConfiguration.keys},workspace:{contents:this._workspaceConfiguration.contents,overrides:this._workspaceConfiguration.overrides,keys:this._workspaceConfiguration.keys},folders:[...this._folderConfigurations.keys()].reduce((e,t)=>{const{contents:s,overrides:f,keys:v}=this._folderConfigurations.get(t);return e.push([t,{contents:s,overrides:f,keys:v}]),e},[])}}allKeys(){const e=new Set;return this._defaultConfiguration.freeze().keys.forEach(t=>e.add(t)),this.userConfiguration.freeze().keys.forEach(t=>e.add(t)),this._workspaceConfiguration.freeze().keys.forEach(t=>e.add(t)),this._folderConfigurations.forEach(t=>t.freeze().keys.forEach(s=>e.add(s))),[...e.values()]}allOverrideIdentifiers(){const e=new Set;return this._defaultConfiguration.freeze().getAllOverrideIdentifiers().forEach(t=>e.add(t)),this.userConfiguration.freeze().getAllOverrideIdentifiers().forEach(t=>e.add(t)),this._workspaceConfiguration.freeze().getAllOverrideIdentifiers().forEach(t=>e.add(t)),this._folderConfigurations.forEach(t=>t.freeze().getAllOverrideIdentifiers().forEach(s=>e.add(s))),[...e.values()]}getAllKeysForOverrideIdentifier(e){const t=new Set;return this._defaultConfiguration.getKeysForOverrideIdentifier(e).forEach(s=>t.add(s)),this.userConfiguration.getKeysForOverrideIdentifier(e).forEach(s=>t.add(s)),this._workspaceConfiguration.getKeysForOverrideIdentifier(e).forEach(s=>t.add(s)),this._folderConfigurations.forEach(s=>s.getKeysForOverrideIdentifier(e).forEach(f=>t.add(f))),[...t.values()]}static parse(e){const t=this.parseConfigurationModel(e.defaults),s=this.parseConfigurationModel(e.user),f=this.parseConfigurationModel(e.workspace),v=e.folders.reduce((L,I)=>(L.set(p.URI.revive(I[0]),this.parseConfigurationModel(I[1])),L),new D.ResourceMap);return new m(t,s,new E,f,v,new E,new D.ResourceMap,!1)}static parseConfigurationModel(e){return new E(e.contents,e.keys,e.overrides).freeze()}}i.Configuration=m;function S(...r){if(r.length===0)return{keys:[],overrides:[]};if(r.length===1)return r[0];const e=new Set,t=new Map;for(const f of r)f.keys.forEach(v=>e.add(v)),f.overrides.forEach(([v,L])=>{const I=(0,D.getOrSet)(t,v,new Set);L.forEach(O=>I.add(O))});const s=[];return t.forEach((f,v)=>s.push([v,[...f.values()]])),{keys:[...e.values()],overrides:s}}i.mergeChanges=S;class d{constructor(e,t,s,f){this.change=e,this.previous=t,this.currentConfiguraiton=s,this.currentWorkspace=f,this._previousConfiguration=void 0;const v=new Set;e.keys.forEach(I=>v.add(I)),e.overrides.forEach(([,I])=>I.forEach(O=>v.add(O))),this.affectedKeys=[...v.values()];const L=new E;this.affectedKeys.forEach(I=>L.setValue(I,{})),this.affectedKeysTree=L.contents}get previousConfiguration(){return!this._previousConfiguration&&this.previous&&(this._previousConfiguration=m.parse(this.previous.data)),this._previousConfiguration}affectsConfiguration(e,t){if(this.doesAffectedKeysTreeContains(this.affectedKeysTree,e)){if(t){const s=this.previousConfiguration?this.previousConfiguration.getValue(e,t,this.previous?.workspace):void 0,f=this.currentConfiguraiton.getValue(e,t,this.currentWorkspace);return!w.equals(s,f)}return!0}return!1}doesAffectedKeysTreeContains(e,t){let s=(0,y.toValuesTree)({[t]:!0},()=>{}),f;for(;typeof s=="object"&&(f=Object.keys(s)[0]);){if(e=e[f],!e)return!1;s=s[f]}return!0}}i.ConfigurationChangeEvent=d;class o extends d{constructor(e,t,s,f){super({keys:e.allKeys(),overrides:[]},void 0,e,t);this.source=s,this.sourceConfig=f}}i.AllKeysConfigurationChangeEvent=o;function a(r,e){const{added:t,removed:s,updated:f}=n(e,r),v=[],L=r?.getAllOverrideIdentifiers()||[],I=e?.getAllOverrideIdentifiers()||[];if(e){const O=I.filter(N=>!L.includes(N));for(const N of O)v.push([N,e.getKeysForOverrideIdentifier(N)])}if(r){const O=L.filter(N=>!I.includes(N));for(const N of O)v.push([N,r.getKeysForOverrideIdentifier(N)])}if(e&&r){for(const O of L)if(I.includes(O)){const N=n({contents:r.getOverrideValue(void 0,O)||{},keys:r.getKeysForOverrideIdentifier(O)},{contents:e.getOverrideValue(void 0,O)||{},keys:e.getKeysForOverrideIdentifier(O)});v.push([O,[...N.added,...N.removed,...N.updated]])}}return{added:t,removed:s,updated:f,overrides:v}}function n(r,e){const t=r?e?r.keys.filter(v=>e.keys.indexOf(v)===-1):[...r.keys]:[],s=e?r?e.keys.filter(v=>r.keys.indexOf(v)===-1):[...e.keys]:[],f=[];if(r&&e){for(const v of e.keys)if(r.keys.indexOf(v)!==-1){const L=(0,y.getConfigurationValue)(e.contents,v),I=(0,y.getConfigurationValue)(r.contents,v);w.equals(L,I)||f.push(v)}}return{added:t,removed:s,updated:f}}}),define(J[107],Q([0,1,3,11,2,18,25,106,35,29]),function(x,i,T,P,b,R,D,w,l,p){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.ConfigurationService=void 0;class y extends b.Disposable{constructor(c,E){super();this.settingsResource=c,this._onDidChangeConfiguration=this._register(new P.Emitter),this.onDidChangeConfiguration=this._onDidChangeConfiguration.event,this.userConfiguration=this._register(new w.UserSettings(this.settingsResource,void 0,R.extUriBiasedIgnorePathCase,E)),this.configuration=new w.Configuration(new w.DefaultConfigurationModel,new w.ConfigurationModel),this.reloadConfigurationScheduler=this._register(new T.RunOnceScheduler(()=>this.reloadConfiguration(),50)),this._register(p.Registry.as(l.Extensions.Configuration).onDidUpdateConfiguration(({properties:u})=>this.onDidDefaultConfigurationChange(u))),this._register(this.userConfiguration.onDidChange(()=>this.reloadConfigurationScheduler.schedule()))}async initialize(){const c=await this.userConfiguration.loadConfiguration();this.configuration=new w.Configuration(new w.DefaultConfigurationModel,c)}getConfigurationData(){return this.configuration.toData()}getValue(c,E){const u=typeof c=="string"?c:void 0,h=(0,D.isConfigurationOverrides)(c)?c:(0,D.isConfigurationOverrides)(E)?E:{};return this.configuration.getValue(u,h,void 0)}updateValue(c,E,u,h){return Promise.reject(new Error("not supported"))}inspect(c){return this.configuration.inspect(c,{},void 0)}keys(){return this.configuration.keys(void 0)}async reloadConfiguration(){const c=await this.userConfiguration.loadConfiguration();this.onDidChangeUserConfiguration(c)}onDidChangeUserConfiguration(c){const E=this.configuration.toData(),u=this.configuration.compareAndUpdateLocalUserConfiguration(c);this.trigger(u,E,1)}onDidDefaultConfigurationChange(c){const E=this.configuration.toData(),u=this.configuration.compareAndUpdateDefaultConfiguration(new w.DefaultConfigurationModel,c);this.trigger(u,E,6)}trigger(c,E,u){const h=new w.ConfigurationChangeEvent(c,{data:E},this.configuration);h.source=u,h.sourceConfig=this.getTargetConfiguration(u),this._onDidChangeConfiguration.fire(h)}getTargetConfiguration(c){switch(c){case 6:return this.configuration.defaults.contents;case 1:return this.configuration.localUserConfiguration.contents}return{}}}i.ConfigurationService=y}),define(J[108],Q([0,1,10]),function(x,i,T){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.isVirtualWorkspace=i.getVirtualWorkspaceScheme=i.getVirtualWorkspaceLocation=i.isVirtualResource=i.getRemoteName=i.getRemoteAuthority=void 0;function P(p){return p.scheme===T.Schemas.vscodeRemote?p.authority:void 0}i.getRemoteAuthority=P;function b(p){if(!p)return;const y=p.indexOf("+");return y<0?p:p.substr(0,y)}i.getRemoteName=b;function R(p){return p.scheme!==T.Schemas.file&&p.scheme!==T.Schemas.vscodeRemote}i.isVirtualResource=R;function D(p){if(p.folders.length)return p.folders.every(y=>R(y.uri))?p.folders[0].uri:void 0;if(p.configuration&&R(p.configuration))return p.configuration}i.getVirtualWorkspaceLocation=D;function w(p){return D(p)?.scheme}i.getVirtualWorkspaceScheme=w;function l(p){return D(p)!==void 0}i.isVirtualWorkspace=l}),define(J[42],Q([0,1,26,14,108]),function(x,i,T,P,b){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.IBuiltinExtensionsScannerService=i.isResolverExtension=i.isAuthenticationProviderExtension=i.isLanguagePackExtension=i.ExtensionIdentifier=i.ExtensionType=i.EXTENSION_CATEGORIES=i.isIExtensionIdentifier=i.getWorkspaceSupportTypeMessage=i.ALL_EXTENSION_KINDS=i.BUILTIN_MANIFEST_CACHE_FILE=i.USER_MANIFEST_CACHE_FILE=i.MANIFEST_CACHE_FOLDER=void 0,i.MANIFEST_CACHE_FOLDER="CachedExtensions",i.USER_MANIFEST_CACHE_FILE="user",i.BUILTIN_MANIFEST_CACHE_FILE="builtin",i.ALL_EXTENSION_KINDS=["ui","workspace","web"];function R(c){if(typeof c=="object"&&c!==null&&c.supported!==!0)return c.description}i.getWorkspaceSupportTypeMessage=R;function D(c){return c&&typeof c=="object"&&typeof c.id=="string"&&(!c.uuid||typeof c.uuid=="string")}i.isIExtensionIdentifier=D,i.EXTENSION_CATEGORIES=["Azure","Data Science","Debuggers","Extension Packs","Education","Formatters","Keymaps","Language Packs","Linters","Machine Learning","Notebooks","Programming Languages","SCM Providers","Snippets","Testing","Themes","Visualization","Other"];var w;(function(c){c[c.System=0]="System",c[c.User=1]="User"})(w=i.ExtensionType||(i.ExtensionType={}));class l{constructor(E){this.value=E,this._lower=E.toLowerCase()}static equals(E,u){if(typeof E=="undefined"||E===null)return typeof u=="undefined"||u===null;if(typeof u=="undefined"||u===null)return!1;if(typeof E=="string"||typeof u=="string"){let h=typeof E=="string"?E:E.value,g=typeof u=="string"?u:u.value;return T.equalsIgnoreCase(h,g)}return E._lower===u._lower}static toKey(E){return typeof E=="string"?E.toLowerCase():E._lower}}i.ExtensionIdentifier=l;function p(c){return c.contributes&&c.contributes.localizations?c.contributes.localizations.length>0:!1}i.isLanguagePackExtension=p;function y(c){return c.contributes&&c.contributes.authentication?c.contributes.authentication.length>0:!1}i.isAuthenticationProviderExtension=y;function C(c,E){if(E){const u=`onResolveRemoteAuthority:${(0,b.getRemoteName)(E)}`;return c.activationEvents?.indexOf(u)!==-1}return!1}i.isResolverExtension=C,i.IBuiltinExtensionsScannerService=(0,P.createDecorator)("IBuiltinExtensionsScannerService")}),define(J[23],Q([0,1,26,42]),function(x,i,T,P){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.getExtensionDependencies=i.getMaliciousExtensionsSet=i.BetterMergeId=i.getGalleryExtensionTelemetryData=i.getLocalExtensionTelemetryData=i.groupByExtension=i.getGalleryExtensionId=i.adoptToGalleryExtensionId=i.getExtensionId=i.ExtensionIdentifierWithVersion=i.areSameExtensions=void 0;function b(u,h){return u.uuid&&h.uuid?u.uuid===h.uuid:u.id===h.id?!0:(0,T.compareIgnoreCase)(u.id,h.id)===0}i.areSameExtensions=b;class R{constructor(h,g){this.version=g,this.id=h.id,this.uuid=h.uuid}key(){return`${this.id}-${this.version}`}equals(h){return h instanceof R?b(this,h)&&this.version===h.version:!1}}i.ExtensionIdentifierWithVersion=R;function D(u,h){return`${u}.${h}`}i.getExtensionId=D;function w(u){return u.toLocaleLowerCase()}i.adoptToGalleryExtensionId=w;function l(u,h){return w(D(u,h))}i.getGalleryExtensionId=l;function p(u,h){const g=[],m=S=>{for(const d of g)if(d.some(o=>b(h(o),h(S))))return d;return null};for(const S of u){const d=m(S);d?d.push(S):g.push([S])}return g}i.groupByExtension=p;function y(u){return{id:u.identifier.id,name:u.manifest.name,galleryId:null,publisherId:u.publisherId,publisherName:u.manifest.publisher,publisherDisplayName:u.publisherDisplayName,dependencies:u.manifest.extensionDependencies&&u.manifest.extensionDependencies.length>0}}i.getLocalExtensionTelemetryData=y;function C(u){return{id:u.identifier.id,name:u.name,galleryId:u.identifier.uuid,publisherId:u.publisherId,publisherName:u.publisher,publisherDisplayName:u.publisherDisplayName,isPreReleaseVersion:u.properties.isPreReleaseVersion,dependencies:!!(u.properties.dependencies&&u.properties.dependencies.length>0),...u.telemetryData}}i.getGalleryExtensionTelemetryData=C,i.BetterMergeId=new P.ExtensionIdentifier("pprice.better-merge");function c(u){const h=new Set;if(u.malicious)for(const g of u.malicious)h.add(g.id);return h}i.getMaliciousExtensionsSet=c;function E(u,h){const g=[],m=h.manifest.extensionDependencies?.slice(0)??[];for(;m.length;){const S=m.shift();if(S&&g.every(d=>!b(d.identifier,{id:S}))){const d=u.filter(o=>b(o.identifier,{id:S}));d.length===1&&(g.push(d[0]),m.push(...d[0].manifest.extensionDependencies?.slice(0)??[]))}}return g}i.getExtensionDependencies=E}),define(J[109],Q([0,1,24,7,62,10,43,9,77,22,23,42]),function(x,i,T,P,b,R,D,w,l,p,y,C){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.ExtensionManagementCLIService=i.getIdAndVersion=void 0;const c=S=>(0,l.localize)(0,null,S),E=(0,l.localize)(1,null,"ms-dotnettools.csharp");function u(S,d){return d?`${S.publisher}.${S.name}@${S.version}`:`${S.publisher}.${S.name}`}const h=/^([^.]+\..+)@(\d+\.\d+\.\d+(-.*)?)$/;function g(S){const d=h.exec(S);return d&&d[1]?[(0,y.adoptToGalleryExtensionId)(d[1]),d[2]]:[(0,y.adoptToGalleryExtensionId)(S),void 0]}i.getIdAndVersion=g;let m=class{constructor(d,o){this.extensionManagementService=d,this.extensionGalleryService=o}get location(){}async listExtensions(d,o,a=console){let n=await this.extensionManagementService.getInstalled(1);const r=C.EXTENSION_CATEGORIES.map(t=>t.toLowerCase());if(o&&o!==""){if(r.indexOf(o.toLowerCase())<0){a.log("Invalid category please enter a valid category. To list valid categories run --category without a category specified");return}n=n.filter(t=>t.manifest.categories?t.manifest.categories.map(f=>f.toLowerCase()).indexOf(o.toLowerCase())>-1:!1)}else if(o===""){a.log("Possible Categories: "),r.forEach(t=>{a.log(t)});return}this.location&&a.log((0,l.localize)(2,null,this.location)),n=n.sort((t,s)=>t.identifier.id.localeCompare(s.identifier.id));let e;for(let t of n)e!==t.identifier.id&&(e=t.identifier.id,a.log(u(t.manifest,d)))}async installExtensions(d,o,a,n,r=console){const e=[],t=[];d.length&&r.log(this.location?(0,l.localize)(3,null,this.location):(0,l.localize)(4,null));const s=await this.extensionManagementService.getInstalled(1),f=(I,O)=>{const N=s.find(G=>(0,y.areSameExtensions)(G.identifier,{id:I}));if(N){if(!O&&!n)return r.log((0,l.localize)(5,null,I,N.manifest.version,I)),!1;if(O&&N.manifest.version===O)return r.log((0,l.localize)(6,null,`${I}@${O}`)),!1}return!0},v=[],L=[];for(const I of d)if(I instanceof w.URI)v.push(I);else{const[O,N]=g(I);f(O,N)&&L.push({id:O,version:N,installOptions:{...a,isBuiltin:!1}})}for(const I of o){const[O,N]=g(I);f(O,N)&&L.push({id:O,version:N,installOptions:{...a,isBuiltin:!0}})}if(v.length&&await Promise.all(v.map(async I=>{try{const O=await this.installVSIX(I,{...a,isBuiltin:!1},n,r);O&&t.push(O)}catch(O){r.error(O.message||O.stack||O),e.push(I.toString())}})),L.length){const I=await this.getGalleryExtensions(L);await Promise.all(L.map(async O=>{const N=I.get(O.id.toLowerCase());if(N)try{const G=await this.installFromGallery(O,N,s,n,r);G&&t.push(G)}catch(G){r.error(G.message||G.stack||G),e.push(O.id)}else r.error(`${c(O.version?`${O.id}@${O.version}`:O.id)}
${E}`),e.push(O.id)}))}if(e.length)throw new Error((0,l.localize)(7,null,e.join(", ")))}async installVSIX(d,o,a,n){const r=await this.extensionManagementService.getManifest(d);if(!r)throw new Error("Invalid vsix");if(await this.validateVSIX(r,a,n))try{return await this.extensionManagementService.install(d,o),n.log((0,l.localize)(8,null,(0,b.getBaseLabel)(d))),r}catch(t){if((0,P.isPromiseCanceledError)(t))return n.log((0,l.localize)(9,null,(0,b.getBaseLabel)(d))),null;throw t}return null}async getGalleryExtensions(d){const o=new Map,a=await this.extensionGalleryService.getExtensions(d,d.some(n=>n.installOptions.installPreReleaseVersion),T.CancellationToken.None);for(const n of a)o.set(n.identifier.id.toLowerCase(),n);return o}async installFromGallery({id:d,version:o,installOptions:a},n,r,e,t){const s=await this.extensionGalleryService.getManifest(n,T.CancellationToken.None);if(s&&!this.validateExtensionKind(s,t))return null;const f=r.find(v=>(0,y.areSameExtensions)(v.identifier,n.identifier));if(f){if(n.version===f.manifest.version)return t.log((0,l.localize)(10,null,o?`${d}@${o}`:d)),null;t.log((0,l.localize)(11,null,d,n.version))}try{return a.isBuiltin?t.log(o?(0,l.localize)(12,null,d,o):(0,l.localize)(13,null,d)):t.log(o?(0,l.localize)(14,null,d,o):(0,l.localize)(15,null,d)),await this.extensionManagementService.installFromGallery(n,{...a,installGivenVersion:!!o}),t.log((0,l.localize)(16,null,d,n.version)),s}catch(v){if((0,P.isPromiseCanceledError)(v))return t.log((0,l.localize)(17,null,d)),null;throw v}}validateExtensionKind(d,o){return!0}async validateVSIX(d,o,a){const n={id:(0,y.getGalleryExtensionId)(d.publisher,d.name)},e=(await this.extensionManagementService.getInstalled(1)).find(t=>(0,y.areSameExtensions)(n,t.identifier)&&(0,D.gt)(t.manifest.version,d.version));return e&&!o?(a.log((0,l.localize)(18,null,e.identifier.id,e.manifest.version,d.version)),!1):this.validateExtensionKind(d,a)}async uninstallExtensions(d,o,a=console){const n=async e=>{if(e instanceof w.URI){const t=await this.extensionManagementService.getManifest(e);return u(t)}return e},r=[];for(const e of d){const t=await n(e),f=(await this.extensionManagementService.getInstalled()).filter(v=>(0,y.areSameExtensions)(v.identifier,{id:t}));if(!f.length)throw new Error(`${this.notInstalled(t)}
${E}`);if(f.some(v=>v.type===0)){a.log((0,l.localize)(19,null,t));return}if(!o&&f.some(v=>v.isBuiltin)){a.log((0,l.localize)(20,null,t));return}a.log((0,l.localize)(21,null,t));for(const v of f)await this.extensionManagementService.uninstall(v),r.push(v);this.location?a.log((0,l.localize)(22,null,t,this.location)):a.log((0,l.localize)(23,null,t))}}async locateExtension(d,o=console){const a=await this.extensionManagementService.getInstalled();d.forEach(n=>{a.forEach(r=>{if(r.identifier.id===n&&r.location.scheme===R.Schemas.file){o.log(r.location.fsPath);return}})})}notInstalled(d){return this.location?(0,l.localize)(24,null,d,this.location):(0,l.localize)(25,null,d)}};m=ve([ae(0,p.IExtensionManagementService),ae(1,p.IExtensionGalleryService)],m),i.ExtensionManagementCLIService=m}),define(J[110],Q([0,1,3,7,2,12,18,43,9,31,13,20,22,23,16,15]),function(x,i,T,P,b,R,D,w,l,p,y,C,c,E,u,h){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.ExtensionsDownloader=void 0;const g=/^([^.]+\..+)-(\d+\.\d+\.\d+)$/;let m=class extends b.Disposable{constructor(d,o,a,n){super();this.fileService=o,this.extensionGalleryService=a,this.logService=n,this.extensionsDownloadDir=l.URI.file(d.extensionsDownloadPath),this.cache=20,this.cleanUpPromise=this.cleanUp()}async downloadExtension(d,o){await this.cleanUpPromise;const a=this.getName(d),n=(0,D.joinPath)(this.extensionsDownloadDir,a);if(!await this.fileService.exists(n)){const r=(0,D.joinPath)(this.extensionsDownloadDir,`.${(0,p.generateUuid)()}`);await this.fileService.exists(r)||await this.extensionGalleryService.download(d,r,o);try{await this.rename(r,n,Date.now()+2*60*1e3)}catch(e){try{await this.fileService.del(r)}catch(t){}if(e.code==="ENOTEMPTY")this.logService.info("Rename failed because vsix was downloaded by another source. So ignoring renaming.",d.identifier.id);else throw this.logService.info(`Rename failed because of ${(0,P.getErrorMessage)(e)}. Deleted the vsix from downloaded location`,r.path),e}}return n}async delete(d){await this.cleanUpPromise,await this.fileService.del(d)}async rename(d,o,a){try{await y.Promises.rename(d.fsPath,o.fsPath)}catch(n){if(R.isWindows&&n&&n.code==="EPERM"&&Date.now()<a)return this.logService.info(`Failed renaming ${d} to ${o} with 'EPERM' error. Trying again...`),this.rename(d,o,a);throw n}}async cleanUp(){try{if(!await this.fileService.exists(this.extensionsDownloadDir)){this.logService.trace("Extension VSIX downlads cache dir does not exist");return}const d=await this.fileService.resolve(this.extensionsDownloadDir,{resolveMetadata:!0});if(d.children){const o=[],a=[];for(const e of d.children){const t=this.parse(e.name);t&&a.push([t,e])}const n=(0,E.groupByExtension)(a,([e])=>e),r=[];for(const e of n)e.sort((t,s)=>w.rcompare(t[0].version,s[0].version)),o.push(...e.slice(1).map(t=>t[1].resource)),r.push(e[0][1]);r.sort((e,t)=>e.mtime-t.mtime),o.push(...r.slice(0,Math.max(0,r.length-this.cache)).map(e=>e.resource)),await T.Promises.settled(o.map(e=>(this.logService.trace("Deleting vsix from cache",e.path),this.fileService.del(e))))}}catch(d){this.logService.error(d)}}getName(d){return this.cache?`${new E.ExtensionIdentifierWithVersion(d.identifier,d.version).key().toLowerCase()}${d.properties.targetPlatform!=="undefined"?`-${d.properties.targetPlatform}`:""}`:(0,p.generateUuid)()}parse(d){const o=g.exec(d);return o&&o[1]&&o[2]?new E.ExtensionIdentifierWithVersion({id:o[1]},o[2]):null}};m=ve([ae(0,C.INativeEnvironmentService),ae(1,u.IFileService),ae(2,c.IExtensionGalleryService),ae(3,h.ILogService)],m),i.ExtensionsDownloader=m}),define(J[111],Q([0,1,2,6,13,42]),function(x,i,T,P,b,R){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.ExtensionsManifestCache=void 0;class D extends T.Disposable{constructor(l,p){super();this.environmentService=l,this.extensionsManifestCache=(0,P.join)(this.environmentService.userDataPath,R.MANIFEST_CACHE_FOLDER,R.USER_MANIFEST_CACHE_FILE),this._register(p.onDidInstallExtensions(y=>this.onDidInstallExtensions(y))),this._register(p.onDidUninstallExtension(y=>this.onDidUnInstallExtension(y)))}onDidInstallExtensions(l){l.some(p=>!!p.local)&&this.invalidate()}onDidUnInstallExtension(l){l.error||this.invalidate()}invalidate(){b.Promises.rm(this.extensionsManifestCache,b.RimRafMode.MOVE).then(()=>{},()=>{})}}i.ExtensionsManifestCache=D}),define(J[112],Q([0,1,137,19,3,2,10,6,13,20,22,23,55,15]),function(x,i,T,P,b,R,D,w,l,p,y,C,c,E){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.LocalizationsService=void 0;let u=class extends R.Disposable{constructor(m,S,d){super();this.extensionManagementService=m,this.logService=d,this.cache=this._register(new h(S,d)),this.extensionManagementService.registerParticipant({postInstall:async o=>this.postInstallExtension(o),postUninstall:async o=>this.postUninstallExtension(o)})}async getLanguageIds(){const m=await this.cache.getLanguagePacks(),S=["en",...Object.keys(m)];return(0,P.distinct)(S)}async postInstallExtension(m){m&&m.manifest&&m.manifest.contributes&&m.manifest.contributes.localizations&&m.manifest.contributes.localizations.length&&(this.logService.info("Adding language packs from the extension",m.identifier.id),await this.update())}async postUninstallExtension(m){const S=await this.cache.getLanguagePacks();Object.keys(S).some(d=>S[d]&&S[d].extensions.some(o=>(0,C.areSameExtensions)(o.extensionIdentifier,m.identifier)))&&(this.logService.info("Removing language packs from the extension",m.identifier.id),await this.update())}async update(){const[m,S]=await Promise.all([this.cache.getLanguagePacks(),this.extensionManagementService.getInstalled()]),d=await this.cache.update(S);return!(0,P.equals)(Object.keys(m),Object.keys(d))}};u=ve([ae(0,y.IExtensionManagementService),ae(1,p.INativeEnvironmentService),ae(2,E.ILogService)],u),i.LocalizationsService=u;let h=class extends R.Disposable{constructor(m,S){super();this.logService=S,this.languagePacks={},this.languagePacksFilePath=(0,w.join)(m.userDataPath,"languagepacks.json"),this.languagePacksFileLimiter=new b.Queue}getLanguagePacks(){return this.languagePacksFileLimiter.size||!this.initializedCache?this.withLanguagePacks().then(()=>this.languagePacks):Promise.resolve(this.languagePacks)}update(m){return this.withLanguagePacks(S=>{Object.keys(S).forEach(d=>delete S[d]),this.createLanguagePacksFromExtensions(S,...m)}).then(()=>this.languagePacks)}createLanguagePacksFromExtensions(m,...S){for(const d of S)d&&d.manifest&&d.manifest.contributes&&d.manifest.contributes.localizations&&d.manifest.contributes.localizations.length&&this.createLanguagePacksFromExtension(m,d);Object.keys(m).forEach(d=>this.updateHash(m[d]))}createLanguagePacksFromExtension(m,S){const d=S.identifier,o=S.manifest.contributes&&S.manifest.contributes.localizations?S.manifest.contributes.localizations:[];for(const a of o)if(S.location.scheme===D.Schemas.file&&(0,c.isValidLocalization)(a)){let n=m[a.languageId];n||(n={hash:"",extensions:[],translations:{}},m[a.languageId]=n);let r=n.extensions.filter(e=>(0,C.areSameExtensions)(e.extensionIdentifier,d))[0];r?r.version=S.manifest.version:n.extensions.push({extensionIdentifier:d,version:S.manifest.version});for(const e of a.translations)n.translations[e.id]=(0,w.join)(S.location.fsPath,e.path)}}updateHash(m){if(m){const S=(0,T.createHash)("md5");for(const d of m.extensions)S.update(d.extensionIdentifier.uuid||d.extensionIdentifier.id).update(d.version);m.hash=S.digest("hex")}}withLanguagePacks(m=()=>null){return this.languagePacksFileLimiter.queue(()=>{let S=null;return l.Promises.readFile(this.languagePacksFilePath,"utf8").then(void 0,d=>d.code==="ENOENT"?Promise.resolve("{}"):Promise.reject(d)).then(d=>{try{return JSON.parse(d)}catch(o){return{}}}).then(d=>(S=m(d),d)).then(d=>{for(const a of Object.keys(d))d[a]||delete d[a];this.languagePacks=d,this.initializedCache=!0;const o=JSON.stringify(this.languagePacks);return this.logService.debug("Writing language packs",o),l.Promises.writeFile(this.languagePacksFilePath,o)}).then(()=>S,d=>this.logService.error(d))})}};h=ve([ae(0,p.INativeEnvironmentService),ae(1,E.ILogService)],h)}),define(J[44],Q([0,1,17,85,35,14,29]),function(x,i,T,P,b,R,D){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.updateProxyConfigurationsScope=i.asJson=i.asText=i.isSuccess=i.IRequestService=void 0,i.IRequestService=(0,R.createDecorator)("requestService");function w(u){return u.res.statusCode&&u.res.statusCode>=200&&u.res.statusCode<300||u.res.statusCode===1223}i.isSuccess=w;function l(u){return u.res.statusCode===204}async function p(u){if(!w(u))throw new Error("Server returned "+u.res.statusCode);return l(u)?null:(await(0,T.streamToBuffer)(u.stream)).toString()}i.asText=p;async function y(u){if(!w(u))throw new Error("Server returned "+u.res.statusCode);if(l(u))return null;const g=(await(0,T.streamToBuffer)(u.stream)).toString();try{return JSON.parse(g)}catch(m){throw m.message+=`:
`+g,m}}i.asJson=y;function C(u){E(u)}i.updateProxyConfigurationsScope=C;let c;function E(u){const h=D.Registry.as(b.Extensions.Configuration),g=c;c={id:"http",order:15,title:(0,P.localize)(0,null),type:"object",scope:u,properties:{"http.proxy":{type:"string",pattern:"^https?://([^:]*(:[^@]*)?@)?([^:]+|\\[[:0-9a-fA-F]+\\])(:\\d+)?/?$|^$",markdownDescription:(0,P.localize)(1,null),restricted:!0},"http.proxyStrictSSL":{type:"boolean",default:!0,description:(0,P.localize)(2,null),restricted:!0},"http.proxyAuthorization":{type:["null","string"],default:null,markdownDescription:(0,P.localize)(3,null),restricted:!0},"http.proxySupport":{type:"string",enum:["off","on","fallback","override"],enumDescriptions:[(0,P.localize)(4,null),(0,P.localize)(5,null),(0,P.localize)(6,null),(0,P.localize)(7,null)],default:"override",description:(0,P.localize)(8,null),restricted:!0},"http.systemCertificates":{type:"boolean",default:!0,description:(0,P.localize)(9,null),restricted:!0}}},h.updateConfigurations({add:[c],remove:g?[g]:[]})}E(2)}),define(J[113],Q([0,1,24,10,16,44]),function(x,i,T,P,b,R){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.DownloadService=void 0;let D=class{constructor(l,p){this.requestService=l,this.fileService=p}async download(l,p,y=T.CancellationToken.None){if(l.scheme===P.Schemas.file||l.scheme===P.Schemas.vscodeRemote){await this.fileService.copy(l,p);return}const C={type:"GET",url:l.toString()},c=await this.requestService.request(C,y);if(c.res.statusCode===200)await this.fileService.writeFile(p,c.stream);else{const E=await(0,R.asText)(c);throw new Error(`Expected 200, got back ${c.res.statusCode} instead.

${E}`)}}};D=ve([ae(0,R.IRequestService),ae(1,b.IFileService)],D),i.DownloadService=D}),define(J[114],Q([0,1,115,8]),function(x,i,T,P){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.getProxyAgent=void 0;function b(D,w){return D.protocol==="http:"?w.HTTP_PROXY||w.http_proxy||null:D.protocol==="https:"&&(w.HTTPS_PROXY||w.https_proxy||w.HTTP_PROXY||w.http_proxy)||null}async function R(D,w,l={}){const p=(0,T.parse)(D),y=l.proxyUrl||b(p,w);if(!y)return null;const C=(0,T.parse)(y);if(!/^https?:$/.test(C.protocol||""))return null;const c={host:C.hostname||"",port:C.port||(C.protocol==="https"?"443":"80"),auth:C.auth,rejectUnauthorized:(0,P.isBoolean)(l.strictSSL)?l.strictSSL:!0};return p.protocol==="http:"?new(await new Promise((E,u)=>{x(["http-proxy-agent"],E,u)}))(c):new(await new Promise((E,u)=>{x(["https-proxy-agent"],E,u)}))(c)}i.getProxyAgent=R}),define(J[116],Q([0,1,17,31]),function(x,i,T,P){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.getServiceMachineId=void 0;async function b(R,D,w){let l=w&&w.get("storage.serviceMachineId",0)||null;if(l)return l;try{const y=(await D.readFile(R.serviceMachineIdResource)).value.toString();l=(0,P.isUUID)(y)?y:null}catch(p){l=null}if(!l){l=(0,P.generateUuid)();try{await D.writeFile(R.serviceMachineIdResource,T.VSBuffer.fromString(l))}catch(p){}}return w&&w.store("storage.serviceMachineId",l,0,1),l}i.getServiceMachineId=b}),define(J[117],Q([0,1,3,11,2,102,8,66,14]),function(x,i,T,P,b,R,D,w,l){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.logStorage=i.InMemoryStorageService=i.AbstractStorageService=i.StorageTarget=i.StorageScope=i.WillSaveStateReason=i.IStorageService=i.IS_NEW_KEY=void 0,i.IS_NEW_KEY="__$__isNewStorageMarker";const p="__$__targetStorageMarker";i.IStorageService=(0,l.createDecorator)("storageService");var y;(function(g){g[g.NONE=0]="NONE",g[g.SHUTDOWN=1]="SHUTDOWN"})(y=i.WillSaveStateReason||(i.WillSaveStateReason={}));var C;(function(g){g[g.GLOBAL=0]="GLOBAL",g[g.WORKSPACE=1]="WORKSPACE"})(C=i.StorageScope||(i.StorageScope={}));var c;(function(g){g[g.USER=0]="USER",g[g.MACHINE=1]="MACHINE"})(c=i.StorageTarget||(i.StorageTarget={}));class E extends b.Disposable{constructor(m={flushInterval:E.DEFAULT_FLUSH_INTERVAL}){super();this.options=m,this._onDidChangeValue=this._register(new P.PauseableEmitter),this.onDidChangeValue=this._onDidChangeValue.event,this._onDidChangeTarget=this._register(new P.PauseableEmitter),this.onDidChangeTarget=this._onDidChangeTarget.event,this._onWillSaveState=this._register(new P.Emitter),this.onWillSaveState=this._onWillSaveState.event,this.flushWhenIdleScheduler=this._register(new T.RunOnceScheduler(()=>this.doFlushWhenIdle(),this.options.flushInterval)),this.runFlushWhenIdle=this._register(new b.MutableDisposable),this._workspaceKeyTargets=void 0,this._globalKeyTargets=void 0}doFlushWhenIdle(){this.runFlushWhenIdle.value=(0,T.runWhenIdle)(()=>{this.shouldFlushWhenIdle()&&this.flush(),this.flushWhenIdleScheduler.schedule()})}shouldFlushWhenIdle(){return!0}stopFlushWhenIdle(){(0,b.dispose)([this.runFlushWhenIdle,this.flushWhenIdleScheduler])}initialize(){return this.initializationPromise||(this.initializationPromise=(async()=>{(0,R.mark)("code/willInitStorage");try{await this.doInitialize()}finally{(0,R.mark)("code/didInitStorage")}this.flushWhenIdleScheduler.schedule()})()),this.initializationPromise}emitDidChangeValue(m,S){S===p?(m===0?this._globalKeyTargets=void 0:m===1&&(this._workspaceKeyTargets=void 0),this._onDidChangeTarget.fire({scope:m})):this._onDidChangeValue.fire({scope:m,key:S,target:this.getKeyTargets(m)[S]})}emitWillSaveState(m){this._onWillSaveState.fire({reason:m})}get(m,S,d){return this.getStorage(S)?.get(m,d)}getBoolean(m,S,d){return this.getStorage(S)?.getBoolean(m,d)}getNumber(m,S,d){return this.getStorage(S)?.getNumber(m,d)}store(m,S,d,o){if((0,D.isUndefinedOrNull)(S)){this.remove(m,d);return}this.withPausedEmitters(()=>{this.updateKeyTarget(m,d,o),this.getStorage(d)?.set(m,S)})}remove(m,S){this.withPausedEmitters(()=>{this.updateKeyTarget(m,S,void 0),this.getStorage(S)?.delete(m)})}withPausedEmitters(m){this._onDidChangeValue.pause(),this._onDidChangeTarget.pause();try{m()}finally{this._onDidChangeValue.resume(),this._onDidChangeTarget.resume()}}keys(m,S){const d=[],o=this.getKeyTargets(m);for(const a of Object.keys(o))o[a]===S&&d.push(a);return d}updateKeyTarget(m,S,d){const o=this.getKeyTargets(S);typeof d=="number"?o[m]!==d&&(o[m]=d,this.getStorage(S)?.set(p,JSON.stringify(o))):typeof o[m]=="number"&&(delete o[m],this.getStorage(S)?.set(p,JSON.stringify(o)))}get workspaceKeyTargets(){return this._workspaceKeyTargets||(this._workspaceKeyTargets=this.loadKeyTargets(1)),this._workspaceKeyTargets}get globalKeyTargets(){return this._globalKeyTargets||(this._globalKeyTargets=this.loadKeyTargets(0)),this._globalKeyTargets}getKeyTargets(m){return m===0?this.globalKeyTargets:this.workspaceKeyTargets}loadKeyTargets(m){const S=this.get(p,m);if(S)try{return JSON.parse(S)}catch(d){}return Object.create(null)}isNew(m){return this.getBoolean(i.IS_NEW_KEY,m)===!0}async flush(m=y.NONE){this._onWillSaveState.fire({reason:m});const S=this.getStorage(0),d=this.getStorage(1);switch(m){case y.NONE:await T.Promises.settled([S?.whenFlushed()??Promise.resolve(),d?.whenFlushed()??Promise.resolve()]);break;case y.SHUTDOWN:await T.Promises.settled([S?.flush(0)??Promise.resolve(),d?.flush(0)??Promise.resolve()]);break}}async logStorage(){const m=this.getStorage(0)?.items??new Map,S=this.getStorage(1)?.items??new Map;return h(m,S,this.getLogDetails(0)??"",this.getLogDetails(1)??"")}}i.AbstractStorageService=E,E.DEFAULT_FLUSH_INTERVAL=60*1e3;class u extends E{constructor(){super();this.globalStorage=this._register(new w.Storage(new w.InMemoryStorageDatabase)),this.workspaceStorage=this._register(new w.Storage(new w.InMemoryStorageDatabase)),this._register(this.workspaceStorage.onDidChangeStorage(m=>this.emitDidChangeValue(1,m))),this._register(this.globalStorage.onDidChangeStorage(m=>this.emitDidChangeValue(0,m)))}getStorage(m){return m===0?this.globalStorage:this.workspaceStorage}getLogDetails(m){return m===0?"inMemory (global)":"inMemory (workspace)"}async doInitialize(){}async migrate(m){}}i.InMemoryStorageService=u;async function h(g,m,S,d){const o=f=>{try{return JSON.parse(f)}catch(v){return f}},a=new Map,n=new Map;g.forEach((f,v)=>{a.set(v,f),n.set(v,o(f))});const r=new Map,e=new Map;m.forEach((f,v)=>{r.set(v,f),e.set(v,o(f))}),console.group(`Storage: Global (path: ${S})`);let t=[];a.forEach((f,v)=>{t.push({key:v,value:f})}),console.table(t),console.groupEnd(),console.log(n),console.group(`Storage: Workspace (path: ${d})`);let s=[];r.forEach((f,v)=>{s.push({key:v,value:f})}),console.table(s),console.groupEnd(),console.log(e)}i.logStorage=h}),define(J[118],Q([0,1,12,28,9,31]),function(x,i,T,P,b,R){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.verifyMicrosoftInternalDomain=i.resolveCommonProperties=void 0;function D(p){if(T.platform===2&&/^penguin(\.|$)/i.test(p))return"chromebook"}async function w(p,y,C,c,E,u,h,g,m,S){const d=Object.create(null);d["common.machineId"]=h,d.sessionID=(0,R.generateUuid)()+Date.now(),d.commitHash=E,d.version=u,d["common.platformVersion"]=(y||"").replace(/^(\d+)(\.\d+)?(\.\d+)?(.*)/,"$1$2$3"),d["common.platform"]=(0,T.PlatformToString)(T.platform),d["common.nodePlatform"]=P.platform,d["common.nodeArch"]=c,d["common.product"]=S||"desktop";const o=l(g||[]);o&&(d["common.msftInternal"]=o);let a=0;const n=Date.now();Object.defineProperties(d,{timestamp:{get:()=>new Date,enumerable:!0},"common.timesincesessionstart":{get:()=>Date.now()-n,enumerable:!0},"common.sequence":{get:()=>a++,enumerable:!0}}),T.isLinuxSnap&&(d["common.snap"]="true");const r=D(C);r&&(d["common.platformDetail"]=r);try{const e=await p.readFile(b.URI.file(m));d["common.source"]=e.value.toString().slice(0,30)}catch(e){}return d}i.resolveCommonProperties=w;function l(p){const y=P.env.USERDNSDOMAIN;if(!y)return!1;const C=y.toLowerCase();return p.some(c=>C===c)}i.verifyMicrosoftInternalDomain=l}),define(J[30],Q([0,1,14]),function(x,i,T){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.TelemetryConfiguration=i.TelemetryLevel=i.TELEMETRY_OLD_SETTING_ID=i.TELEMETRY_SETTING_ID=i.TELEMETRY_SECTION_ID=i.machineIdKey=i.lastSessionDateStorageKey=i.firstSessionDateStorageKey=i.currentSessionDateStorageKey=i.ICustomEndpointTelemetryService=i.ITelemetryService=void 0,i.ITelemetryService=(0,T.createDecorator)("telemetryService"),i.ICustomEndpointTelemetryService=(0,T.createDecorator)("customEndpointTelemetryService"),i.currentSessionDateStorageKey="telemetry.currentSessionDate",i.firstSessionDateStorageKey="telemetry.firstSessionDate",i.lastSessionDateStorageKey="telemetry.lastSessionDate",i.machineIdKey="telemetry.machineId",i.TELEMETRY_SECTION_ID="telemetry",i.TELEMETRY_SETTING_ID="telemetry.telemetryLevel",i.TELEMETRY_OLD_SETTING_ID="telemetry.enableTelemetry";var P;(function(R){R[R.NONE=0]="NONE",R[R.CRASH=1]="CRASH",R[R.ERROR=2]="ERROR",R[R.USAGE=3]="USAGE"})(P=i.TelemetryLevel||(i.TelemetryLevel={}));var b;(function(R){R.OFF="off",R.CRASH="crash",R.ERROR="error",R.ON="all"})(b=i.TelemetryConfiguration||(i.TelemetryConfiguration={}))}),define(J[119],Q([0,1,19,3,24,7,11,2,12,8,9,75,22,23,15,32,30]),function(x,i,T,P,b,R,D,w,l,p,y,C,c,E,u,h,g){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.AbstractExtensionTask=i.reportTelemetry=i.joinErrors=i.AbstractExtensionManagementService=void 0;let m=class extends w.Disposable{constructor(r,e,t,s){super();this.galleryService=r,this.telemetryService=e,this.logService=t,this.productService=s,this.lastReportTimestamp=0,this.installingExtensions=new Map,this.uninstallingExtensions=new Map,this._onInstallExtension=this._register(new D.Emitter),this.onInstallExtension=this._onInstallExtension.event,this._onDidInstallExtensions=this._register(new D.Emitter),this.onDidInstallExtensions=this._onDidInstallExtensions.event,this._onUninstallExtension=this._register(new D.Emitter),this.onUninstallExtension=this._onUninstallExtension.event,this._onDidUninstallExtension=this._register(new D.Emitter),this.onDidUninstallExtension=this._onDidUninstallExtension.event,this.participants=[],this._register((0,w.toDisposable)(()=>{this.installingExtensions.forEach(f=>f.cancel()),this.uninstallingExtensions.forEach(f=>f.cancel()),this.installingExtensions.clear(),this.uninstallingExtensions.clear()}))}async canInstall(r){const e=await this.getTargetPlatform();return r.allTargetPlatforms.some(t=>(0,c.isTargetPlatformCompatible)(t,r.allTargetPlatforms,e))}async installFromGallery(r,e={}){try{if(!this.galleryService.isEnabled())throw new c.ExtensionManagementError(C.localize(0,null),c.ExtensionManagementErrorCode.Internal);const t=await this.checkAndGetCompatibleVersion(r,!e.installGivenVersion,!!e.installPreReleaseVersion);return await this.installExtension(t.manifest,t.extension,e)}catch(t){throw o(this.telemetryService,"extensionGallery:install",(0,E.getGalleryExtensionTelemetryData)(r),void 0,t),this.logService.error("Failed to install extension.",r.identifier.id),this.logService.error(t),d(t)}}async migrateUnsupportedExtensions(){try{const r=await this.getExtensionsControlManifest();if(!r.unsupportedPreReleaseExtensions)return;const e=await this.getInstalled(1);for(const[t,s]of Object.entries(r.unsupportedPreReleaseExtensions)){const f=e.find(I=>(0,E.areSameExtensions)(I.identifier,{id:t}));if(!f)continue;const v=await this.galleryService.getCompatibleExtension({id:s.id},!0,await this.getTargetPlatform());if(!v){this.logService.info(`Skipping migrating '${f.identifier.id}' extension because, the comaptible target '${s.id}' extension is not found`);continue}const L=await this.galleryService.getManifest(v,b.CancellationToken.None);if(!L){this.logService.info(`Skipping migrating '${f.identifier.id}' extension because, the manifest for '${s.id}' extension is not found`);continue}try{this.logService.info(`Migrating '${f.identifier.id}' extension to '${s.id}' extension...`),await Promise.allSettled([this.uninstall(f),this.installExtension(L,v,{installPreReleaseVersion:!0,isMachineScoped:f.isMachineScoped,operation:4})]),this.logService.info(`Migrated '${f.identifier.id}' extension to '${s.id}' extension.`)}catch(I){this.logService.error(I)}}}catch(r){this.logService.error(r)}}async uninstall(r,e={}){return this.logService.trace("ExtensionManagementService#uninstall",r.identifier.id),this.unininstallExtension(r,e)}async reinstallFromGallery(r){if(this.logService.trace("ExtensionManagementService#reinstallFromGallery",r.identifier.id),!this.galleryService.isEnabled())throw new Error(C.localize(1,null));const e=await this.findGalleryExtension(r);if(!e)throw new Error(C.localize(2,null));await this.createUninstallExtensionTask(r,{remove:!0,versionOnly:!0}).run(),await this.installFromGallery(e)}getExtensionsControlManifest(){const r=new Date().getTime();return(!this.extensionsControlManifest||r-this.lastReportTimestamp>1e3*60*5)&&(this.extensionsControlManifest=this.updateControlCache(),this.lastReportTimestamp=r),this.extensionsControlManifest}registerParticipant(r){this.participants.push(r)}async installExtension(r,e,t){if(!y.URI.isUri(e)){let I=this.installingExtensions.get(new E.ExtensionIdentifierWithVersion(e.identifier,e.version).key());if(I)return this.logService.info("Extensions is already requested to install",e.identifier.id),I.waitUntilTaskIsFinished();t={...t,installOnlyNewlyAddedFromExtensionPack:!0}}const s=[],f=[],v=this.createInstallExtensionTask(r,e,t);y.URI.isUri(e)||this.installingExtensions.set(new E.ExtensionIdentifierWithVersion(v.identifier,r.version).key(),v),this._onInstallExtension.fire({identifier:v.identifier,source:e}),this.logService.info("Installing extension:",v.identifier.id),s.push({task:v,manifest:r});let L=!1;try{if(t.donotIncludePackAndDependencies)this.logService.info("Installing the extension without checking dependencies and pack",v.identifier.id);else try{const O=await this.getAllDepsAndPackExtensionsToInstall(v.identifier,r,!!t.installOnlyNewlyAddedFromExtensionPack,!!t.installPreReleaseVersion);for(const{gallery:N,manifest:G}of O)if(L=L||!!G.extensionDependencies?.some(ee=>(0,E.areSameExtensions)({id:ee},v.identifier)),this.installingExtensions.has(new E.ExtensionIdentifierWithVersion(N.identifier,N.version).key()))this.logService.info("Extension is already requested to install",N.identifier.id);else{const ee=this.createInstallExtensionTask(G,N,{...t,donotIncludePackAndDependencies:!0});this.installingExtensions.set(new E.ExtensionIdentifierWithVersion(ee.identifier,G.version).key(),ee),this._onInstallExtension.fire({identifier:ee.identifier,source:N}),this.logService.info("Installing extension:",ee.identifier.id),s.push({task:ee,manifest:G})}}catch(O){if(y.URI.isUri(v.source))(0,T.isNonEmptyArray)(r.extensionDependencies)&&this.logService.warn("Cannot install dependencies of extension:",v.identifier.id,O.message),(0,T.isNonEmptyArray)(r.extensionPack)&&this.logService.warn("Cannot install packed extensions of extension:",v.identifier.id,O.message);else throw this.logService.error("Error while preparing to install dependencies and extension packs of the extension:",v.identifier.id),O}const I=s.reduce((O,{task:N,manifest:G})=>(O.set(N.identifier.id.toLowerCase(),{task:N,manifest:G}),O),new Map);for(;I.size;){let O;const N=[...I.values()].filter(({manifest:G})=>!G.extensionDependencies?.some(ee=>I.has(ee.toLowerCase())));N.length?O=I.size===1?N:N.filter(({task:G})=>!(G===v&&!L)):(this.logService.info("Found extensions with circular dependencies",N.map(({task:G})=>G.identifier.id)),O=[...I.values()]),await this.joinAllSettled(O.map(async({task:G})=>{const ee=new Date().getTime(),ge=(0,p.isUndefined)(t.operation)?G.operation:t.operation;try{const ce=await G.run();if(await this.joinAllSettled(this.participants.map(te=>te.postInstall(ce,G.source,t,b.CancellationToken.None))),!y.URI.isUri(G.source)&&(o(this.telemetryService,ge===3?"extensionGallery:update":"extensionGallery:install",(0,E.getGalleryExtensionTelemetryData)(G.source),new Date().getTime()-ee,void 0),l.isWeb&&ge!==3))try{await this.galleryService.reportStatistic(ce.manifest.publisher,ce.manifest.name,ce.manifest.version,"install")}catch(te){}f.push({local:ce,identifier:G.identifier,operation:ge,source:G.source})}catch(ce){throw y.URI.isUri(G.source)||o(this.telemetryService,ge===3?"extensionGallery:update":"extensionGallery:install",(0,E.getGalleryExtensionTelemetryData)(G.source),new Date().getTime()-ee,ce),this.logService.error("Error while installing the extension:",G.identifier.id),ce}finally{I.delete(G.identifier.id.toLowerCase())}}))}return f.forEach(({identifier:O})=>this.logService.info("Extension installed successfully:",O.id)),this._onDidInstallExtensions.fire(f),f.filter(({identifier:O})=>(0,E.areSameExtensions)(O,v.identifier))[0].local}catch(I){if(s.forEach(({task:O})=>O.cancel()),f.length)try{const O=await Promise.allSettled(f.map(({local:N})=>this.createUninstallExtensionTask(N,{versionOnly:!0}).run()));for(let N=0;N<O.length;N++){const G=O[N],{identifier:ee}=f[N];G.status==="fulfilled"?this.logService.info("Rollback: Uninstalled extension",ee.id):this.logService.warn("Rollback: Error while uninstalling extension",ee.id,(0,R.getErrorMessage)(G.reason))}}catch(O){this.logService.warn("Error while rolling back extensions",(0,R.getErrorMessage)(O),f.map(({identifier:N})=>N.id))}throw this._onDidInstallExtensions.fire(s.map(({task:O})=>({identifier:O.identifier,operation:2,source:O.source}))),I}finally{for(const{task:I,manifest:O}of s)if(!y.URI.isUri(I.source)){const N=new E.ExtensionIdentifierWithVersion(I.identifier,O.version).key();this.installingExtensions.delete(N)||this.logService.warn("Installation task is not found in the cache",N)}}}async joinAllSettled(r){const e=[],t=[],s=await Promise.allSettled(r);for(const f of s)f.status==="fulfilled"?e.push(f.value):t.push(f.reason);if(t.length)throw S(t);return e}async getAllDepsAndPackExtensionsToInstall(r,e,t,s){if(!this.galleryService.isEnabled())return[];let f=await this.getInstalled();const v=[r,...f.map(O=>O.identifier)],L=[],I=async(O,N)=>{const G=N.extensionDependencies||[],ee=[...G];if(N.extensionPack){const ge=t?f.find(ce=>(0,E.areSameExtensions)(ce.identifier,O)):void 0;for(const ce of N.extensionPack)ge&&ge.manifest.extensionPack&&ge.manifest.extensionPack.some(te=>(0,E.areSameExtensions)({id:te},{id:ce}))||ee.every(te=>!(0,E.areSameExtensions)({id:te},{id:ce}))&&ee.push(ce)}if(ee.length){const ge=[...v,...L.map(te=>te.gallery.identifier)],ce=ee.filter(te=>ge.every(he=>!(0,E.areSameExtensions)(he,{id:te})));if(ce.length){const te=await this.galleryService.query({names:ce,pageSize:ee.length},b.CancellationToken.None);for(const he of te.firstPage){if(ge.find(ne=>(0,E.areSameExtensions)(ne,he.identifier)))continue;const W=G.some(ne=>(0,E.areSameExtensions)({id:ne},he.identifier));let B;try{B=await this.checkAndGetCompatibleVersion(he,!0,s)}catch(ne){if(ne instanceof c.ExtensionManagementError&&ne.code===c.ExtensionManagementErrorCode.IncompatibleTargetPlatform&&!W){this.logService.info("Skipping the packed extension as it cannot be installed",he.identifier.id);continue}else throw ne}L.push({gallery:B.extension,manifest:B.manifest}),await I(B.extension.identifier,N)}}}};return await I(r,e),f=await this.getInstalled(),L.filter(O=>!f.some(N=>(0,E.areSameExtensions)(N.identifier,O.gallery.identifier)))}async checkAndGetCompatibleVersion(r,e,t){const s=await this.getExtensionsControlManifest();if((0,E.getMaliciousExtensionsSet)(s).has(r.identifier.id))throw new c.ExtensionManagementError(C.localize(3,null,r.identifier.id),c.ExtensionManagementErrorCode.Malicious);if(!!s.unsupportedPreReleaseExtensions&&!!s.unsupportedPreReleaseExtensions[r.identifier.id])throw new c.ExtensionManagementError(C.localize(4,null,r.identifier.id,s.unsupportedPreReleaseExtensions[r.identifier.id].displayName),c.ExtensionManagementErrorCode.UnsupportedPreRelease);if(!await this.canInstall(r)){const L=await this.getTargetPlatform();throw new c.ExtensionManagementError(C.localize(5,null,r.identifier.id,this.productService.nameLong,(0,c.TargetPlatformToString)(L)),c.ExtensionManagementErrorCode.IncompatibleTargetPlatform)}const f=await this.getCompatibleVersion(r,e,t);if(f){if(t&&r.hasPreReleaseVersion&&!f.properties.isPreReleaseVersion)throw new c.ExtensionManagementError(C.localize(6,null,r.identifier.id,this.productService.nameLong,this.productService.version),c.ExtensionManagementErrorCode.IncompatiblePreRelease)}else throw new c.ExtensionManagementError(C.localize(7,null,r.identifier.id,this.productService.nameLong,this.productService.version),c.ExtensionManagementErrorCode.Incompatible);const v=await this.galleryService.getManifest(f,b.CancellationToken.None);if(v===null)throw new c.ExtensionManagementError(`Missing manifest for extension ${r.identifier.id}`,c.ExtensionManagementErrorCode.Invalid);if(v.version!==f.version)throw new c.ExtensionManagementError(`Cannot install '${r.identifier.id}' extension because of version mismatch in Marketplace`,c.ExtensionManagementErrorCode.Invalid);return{extension:f,manifest:v}}async getCompatibleVersion(r,e,t){const s=await this.getTargetPlatform();let f=null;return e&&r.hasPreReleaseVersion&&r.properties.isPreReleaseVersion!==t&&(f=await this.galleryService.getCompatibleExtension(r.identifier,t,s)),!f&&await this.galleryService.isExtensionCompatible(r,t,s)&&(f=r),!f&&e&&(f=await this.galleryService.getCompatibleExtension(r,t,s)),f}async unininstallExtension(r,e){const t=this.uninstallingExtensions.get(r.identifier.id.toLowerCase());if(t)return this.logService.info("Extensions is already requested to uninstall",r.identifier.id),t.waitUntilTaskIsFinished();const s=(I,O)=>{const N=this.createUninstallExtensionTask(I,O);return this.uninstallingExtensions.set(N.extension.identifier.id.toLowerCase(),N),this.logService.info("Uninstalling extension:",I.identifier.id),this._onUninstallExtension.fire(I.identifier),N},f=(I,O)=>{O?this.logService.error("Failed to uninstall extension:",I.identifier.id,O.message):this.logService.info("Successfully uninstalled extension:",I.identifier.id),o(this.telemetryService,"extensionGallery:uninstall",(0,E.getLocalExtensionTelemetryData)(I),void 0,O),this._onDidUninstallExtension.fire({identifier:I.identifier,error:O?.code})},v=[],L=[];try{v.push(s(r,{}));const I=await this.getInstalled(1);if(e.donotIncludePack)this.logService.info("Uninstalling the extension without including packed extension",r.identifier.id);else{const O=this.getAllPackExtensionsToUninstall(r,I);for(const N of O)this.uninstallingExtensions.has(N.identifier.id.toLowerCase())?this.logService.info("Extensions is already requested to uninstall",N.identifier.id):v.push(s(N,{}))}e.donotCheckDependents?this.logService.info("Uninstalling the extension without checking dependents",r.identifier.id):this.checkForDependents(v.map(O=>O.extension),I,r),await this.joinAllSettled(v.map(async O=>{try{if(await O.run(),await this.joinAllSettled(this.participants.map(N=>N.postUninstall(O.extension,e,b.CancellationToken.None))),O.extension.identifier.uuid)try{await this.galleryService.reportStatistic(O.extension.manifest.publisher,O.extension.manifest.name,O.extension.manifest.version,"uninstall")}catch(N){}f(O.extension)}catch(N){const G=N instanceof c.ExtensionManagementError?N:new c.ExtensionManagementError((0,R.getErrorMessage)(N),c.ExtensionManagementErrorCode.Internal);throw f(O.extension,G),G}finally{L.push(O)}}))}catch(I){const O=I instanceof c.ExtensionManagementError?I:new c.ExtensionManagementError((0,R.getErrorMessage)(I),c.ExtensionManagementErrorCode.Internal);for(const N of v){try{N.cancel()}catch(G){}L.includes(N)||f(N.extension,O)}throw O}finally{for(const I of v)this.uninstallingExtensions.delete(I.extension.identifier.id.toLowerCase())||this.logService.warn("Uninstallation task is not found in the cache",I.extension.identifier.id)}}checkForDependents(r,e,t){for(const s of r){const f=this.getDependents(s,e);if(f.length){const v=f.filter(L=>!r.some(I=>(0,E.areSameExtensions)(I.identifier,L.identifier)));if(v.length)throw new Error(this.getDependentsErrorMessage(s,v,t))}}}getDependentsErrorMessage(r,e,t){return t===r?e.length===1?C.localize(8,null,t.manifest.displayName||t.manifest.name,e[0].manifest.displayName||e[0].manifest.name):e.length===2?C.localize(9,null,t.manifest.displayName||t.manifest.name,e[0].manifest.displayName||e[0].manifest.name,e[1].manifest.displayName||e[1].manifest.name):C.localize(10,null,t.manifest.displayName||t.manifest.name,e[0].manifest.displayName||e[0].manifest.name,e[1].manifest.displayName||e[1].manifest.name):e.length===1?C.localize(11,null,t.manifest.displayName||t.manifest.name,r.manifest.displayName||r.manifest.name,e[0].manifest.displayName||e[0].manifest.name):e.length===2?C.localize(12,null,t.manifest.displayName||t.manifest.name,r.manifest.displayName||r.manifest.name,e[0].manifest.displayName||e[0].manifest.name,e[1].manifest.displayName||e[1].manifest.name):C.localize(13,null,t.manifest.displayName||t.manifest.name,r.manifest.displayName||r.manifest.name,e[0].manifest.displayName||e[0].manifest.name,e[1].manifest.displayName||e[1].manifest.name)}getAllPackExtensionsToUninstall(r,e,t=[]){if(t.indexOf(r)!==-1)return[];t.push(r);const s=r.manifest.extensionPack?r.manifest.extensionPack:[];if(s.length){const f=e.filter(L=>!L.isBuiltin&&s.some(I=>(0,E.areSameExtensions)({id:I},L.identifier))),v=[];for(const L of f)v.push(...this.getAllPackExtensionsToUninstall(L,e,t));return[...f,...v]}return[]}getDependents(r,e){return e.filter(t=>t.manifest.extensionDependencies&&t.manifest.extensionDependencies.some(s=>(0,E.areSameExtensions)({id:s},r.identifier)))}async findGalleryExtension(r){if(r.identifier.uuid){const e=await this.findGalleryExtensionById(r.identifier.uuid);return e||this.findGalleryExtensionByName(r.identifier.id)}return this.findGalleryExtensionByName(r.identifier.id)}async findGalleryExtensionById(r){return(await this.galleryService.query({ids:[r],pageSize:1},b.CancellationToken.None)).firstPage[0]}async findGalleryExtensionByName(r){return(await this.galleryService.query({names:[r],pageSize:1},b.CancellationToken.None)).firstPage[0]}async updateControlCache(){try{this.logService.trace("ExtensionManagementService.refreshReportedCache");const r=await this.galleryService.getExtensionsControlManifest();return this.logService.trace("ExtensionManagementService.refreshControlCache",r),r}catch(r){return this.logService.trace("ExtensionManagementService.refreshControlCache - failed to get extension control manifest"),{malicious:[]}}}};m=ve([ae(0,c.IExtensionGalleryService),ae(1,g.ITelemetryService),ae(2,u.ILogService),ae(3,h.IProductService)],m),i.AbstractExtensionManagementService=m;function S(n){const r=Array.isArray(n)?n:[n];return r.length===1?r[0]instanceof Error?r[0]:new Error(r[0]):r.reduce((e,t)=>new Error(`${e.message}${e.message?",":""}${t instanceof Error?t.message:t}`),new Error(""))}i.joinErrors=S;function d(n){if(n instanceof c.ExtensionManagementError)return n;const r=new c.ExtensionManagementError(n.message,c.ExtensionManagementErrorCode.Internal);return r.stack=n.stack,r}function o(n,r,e,t,s){const f=s?s instanceof c.ExtensionManagementError?s.code:c.ExtensionManagementErrorCode.Internal:void 0;n.publicLogError(r,{...e,success:!s,duration:t,errorcode:f})}i.reportTelemetry=o;class a{constructor(){this.barrier=new P.Barrier}async waitUntilTaskIsFinished(){return await this.barrier.wait(),this.cancellablePromise}async run(){return this.cancellablePromise||(this.cancellablePromise=(0,P.createCancelablePromise)(r=>this.doRun(r))),this.barrier.open(),this.cancellablePromise}cancel(){this.cancellablePromise||(this.cancellablePromise=(0,P.createCancelablePromise)(r=>new Promise((e,t)=>{const s=r.onCancellationRequested(()=>{s.dispose(),t((0,R.canceled)())})})),this.barrier.open()),this.cancellablePromise.cancel()}}i.AbstractExtensionTask=a}),define(J[36],Q([0,1,21,8,25,30]),function(x,i,T,P,b,R){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.cleanRemoteAuthority=i.validateTelemetryData=i.getTelemetryLevel=i.supportsTelemetry=i.configurationTelemetry=i.NullAppender=i.NullEndpointTelemetryService=i.NullTelemetryService=i.NullTelemetryServiceShape=void 0;class D{constructor(){this.sendErrorTelemetry=!1,this.telemetryLevel=0}publicLog(m,S){return Promise.resolve(void 0)}publicLog2(m,S){return this.publicLog(m,S)}publicLogError(m,S){return Promise.resolve(void 0)}publicLogError2(m,S){return this.publicLogError(m,S)}setExperimentProperty(){}getTelemetryInfo(){return Promise.resolve({instanceId:"someValue.instanceId",sessionId:"someValue.sessionId",machineId:"someValue.machineId",firstSessionDate:"someValue.firstSessionDate"})}}i.NullTelemetryServiceShape=D,i.NullTelemetryService=new D;class w{async publicLog(m,S,d){}async publicLogError(m,S,d){}}i.NullEndpointTelemetryService=w,i.NullAppender={log:()=>null,flush:()=>Promise.resolve(null)};function l(g,m){return m.onDidChangeConfiguration(S=>{S.source!==6&&g.publicLog2("updateConfiguration",{configurationSource:(0,b.ConfigurationTargetToString)(S.source),configurationKeys:u(S.sourceConfig)})})}i.configurationTelemetry=l;function p(g,m){return!(m.disableTelemetry||!g.enableTelemetry)}i.supportsTelemetry=p;function y(g){const m=g.getValue(R.TELEMETRY_SETTING_ID),S=g.getValue("telemetry.enableCrashReporter");if(g.getValue(R.TELEMETRY_OLD_SETTING_ID)===!1||S===!1)return 0;switch(m??"all"){case"all":return 3;case"error":return 2;case"crash":return 1;case"off":return 0}}i.getTelemetryLevel=y;function C(g){const m=Object.create(null),S=Object.create(null),d=Object.create(null);E(g,d);for(let o in d){o=o.length>150?o.substr(o.length-149):o;const a=d[o];typeof a=="number"?S[o]=a:typeof a=="boolean"?S[o]=a?1:0:typeof a=="string"?(a.length>8192&&console.warn(`Telemetry property: ${o} has been trimmed to 8192, the original length is ${a.length}`),m[o]=a.substring(0,8191)):typeof a!="undefined"&&a!==null&&(m[o]=a)}return{properties:m,measurements:S}}i.validateTelemetryData=C;function c(g){if(!g)return"none";let m="other";return["ssh-remote","dev-container","attached-container","wsl"].forEach(d=>{g.indexOf(`${d}+`)===0&&(m=d)}),m}i.cleanRemoteAuthority=c;function E(g,m,S=0,d){if(!!g)for(let o of Object.getOwnPropertyNames(g)){const a=g[o],n=d?d+o:o;Array.isArray(a)?m[n]=(0,T.safeStringify)(a):a instanceof Date?m[n]=a.toISOString():(0,P.isObject)(a)?S<2?E(a,m,S+1,n+"."):m[n]=(0,T.safeStringify)(a):m[n]=a}}function u(g){if(!g)return[];const m=[];return h(m,"",g),m}function h(g,m,S){S&&typeof S=="object"&&!Array.isArray(S)?Object.keys(S).forEach(d=>h(g,m?`${m}.${d}`:d,S[d])):g.push(m)}}),define(J[120],Q([0,1,19,24,7,21,12,28,8,9,25,20,22,23,51,16,15,32,44,116,117,30,36]),function(x,i,T,P,b,R,D,w,l,p,y,C,c,E,u,h,g,m,S,d,o,a,n){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.resolveMarketplaceHeaders=i.ExtensionGalleryServiceWithNoStorageService=i.ExtensionGalleryService=i.sortExtensionVersions=void 0;const r=D.isWeb?"web":(0,c.getTargetPlatform)(D.platform,w.arch);var e;(function(U){U[U.None=0]="None",U[U.IncludeVersions=1]="IncludeVersions",U[U.IncludeFiles=2]="IncludeFiles",U[U.IncludeCategoryAndTags=4]="IncludeCategoryAndTags",U[U.IncludeSharedAccounts=8]="IncludeSharedAccounts",U[U.IncludeVersionProperties=16]="IncludeVersionProperties",U[U.ExcludeNonValidated=32]="ExcludeNonValidated",U[U.IncludeInstallationTargets=64]="IncludeInstallationTargets",U[U.IncludeAssetUri=128]="IncludeAssetUri",U[U.IncludeStatistics=256]="IncludeStatistics",U[U.IncludeLatestVersionOnly=512]="IncludeLatestVersionOnly",U[U.Unpublished=4096]="Unpublished"})(e||(e={}));function t(...U){return String(U.reduce((A,$)=>A|$,0))}var s;(function(U){U[U.Tag=1]="Tag",U[U.ExtensionId=4]="ExtensionId",U[U.Category=5]="Category",U[U.ExtensionName=7]="ExtensionName",U[U.Target=8]="Target",U[U.Featured=9]="Featured",U[U.SearchText=10]="SearchText",U[U.ExcludeWithFlags=12]="ExcludeWithFlags"})(s||(s={}));const f={Icon:"Microsoft.VisualStudio.Services.Icons.Default",Details:"Microsoft.VisualStudio.Services.Content.Details",Changelog:"Microsoft.VisualStudio.Services.Content.Changelog",Manifest:"Microsoft.VisualStudio.Code.Manifest",VSIX:"Microsoft.VisualStudio.Services.VSIXPackage",License:"Microsoft.VisualStudio.Services.Content.License",Repository:"Microsoft.VisualStudio.Services.Links.Source"},v={Dependency:"Microsoft.VisualStudio.Code.ExtensionDependencies",ExtensionPack:"Microsoft.VisualStudio.Code.ExtensionPack",Engine:"Microsoft.VisualStudio.Code.Engine",PreRelease:"Microsoft.VisualStudio.Code.PreRelease",LocalizedLanguages:"Microsoft.VisualStudio.Code.LocalizedLanguages",WebExtension:"Microsoft.VisualStudio.Code.WebExtension"},I={pageNumber:1,pageSize:10,sortBy:0,sortOrder:0,flags:e.None,criteria:[],assetTypes:[]};class O{constructor(A=I){this.state=A}get pageNumber(){return this.state.pageNumber}get pageSize(){return this.state.pageSize}get sortBy(){return this.state.sortBy}get sortOrder(){return this.state.sortOrder}get flags(){return this.state.flags}withPage(A,$=this.state.pageSize){return new O({...this.state,pageNumber:A,pageSize:$})}withFilter(A,...$){const V=[...this.state.criteria,...$.length?$.map(X=>({filterType:A,value:X})):[{filterType:A}]];return new O({...this.state,criteria:V})}withSortBy(A){return new O({...this.state,sortBy:A})}withSortOrder(A){return new O({...this.state,sortOrder:A})}withFlags(...A){return new O({...this.state,flags:A.reduce(($,V)=>$|V,0)})}withAssetTypes(...A){return new O({...this.state,assetTypes:A})}get raw(){const{criteria:A,pageNumber:$,pageSize:V,sortBy:X,sortOrder:Y,flags:de,assetTypes:se}=this.state;return{filters:[{criteria:A,pageNumber:$,pageSize:V,sortBy:X,sortOrder:Y}],assetTypes:se,flags:de}}get searchText(){const A=this.state.criteria.filter($=>$.filterType===s.SearchText)[0];return A&&A.value?A.value:""}get telemetryData(){return{filterTypes:this.state.criteria.map(A=>String(A.filterType)),sortBy:String(this.sortBy),sortOrder:String(this.sortOrder)}}}function N(U,A){const $=(U||[]).filter(V=>V.statisticName===A)[0];return $?$.value:0}function G(U){const A="Microsoft.VisualStudio.Code.Translation.";return U.files.filter(V=>V.assetType.indexOf(A)===0).reduce((V,X)=>{const Y=te(U,X.assetType);return Y&&V.push([X.assetType.substring(A.length),Y]),V},[])}function ee(U){if(U.properties){const A=U.properties.filter(X=>X.key===f.Repository),$=new RegExp("((git|ssh|http(s)?)|(git@[\\w.]+))(:(//)?)([\\w.@:/\\-~]+)(.git)(/)?"),V=A.filter(X=>$.test(X.value))[0];return V?{uri:V.value,fallbackUri:V.value}:null}return te(U,f.Repository)}function ge(U){return{uri:`${U.fallbackAssetUri}/${f.VSIX}?redirect=true${U.targetPlatform?`&targetPlatform=${U.targetPlatform}`:""}`,fallbackUri:`${U.fallbackAssetUri}/${f.VSIX}${U.targetPlatform?`?targetPlatform=${U.targetPlatform}`:""}`}}function ce(U){const A=te(U,f.Icon);if(A)return A;const $=c.DefaultIconPath;return{uri:$,fallbackUri:$}}function te(U,A){return U.files.filter(V=>V.assetType===A)[0]?{uri:`${U.assetUri}/${A}`,fallbackUri:`${U.fallbackAssetUri}/${A}`}:null}function he(U,A){const $=U.properties?U.properties.filter(X=>X.key===A):[],V=$.length>0&&$[0].value;return V?V.split(",").map(X=>(0,E.adoptToGalleryExtensionId)(X)):[]}function W(U){const A=U.properties?U.properties.filter($=>$.key===v.Engine):[];return A.length>0&&A[0].value||""}function B(U){const A=U.properties?U.properties.filter($=>$.key===v.PreRelease):[];return A.length>0&&A[0].value==="true"}function ne(U){const A=U.properties?U.properties.filter(V=>V.key===v.LocalizedLanguages):[],$=A.length>0&&A[0].value||"";return $?$.split(","):[]}function M(U){return U.indexOf("preview")!==-1}function k(U){return U.targetPlatform?(0,c.toTargetPlatform)(U.targetPlatform):"undefined"}function j(U){const A=(0,T.distinct)(U.versions.map(k)),$=!!U.tags?.includes(c.WEB_EXTENSION_TAG),V=A.indexOf("web");return $?V===-1&&A.push("web"):V!==-1&&A.splice(V,1),A}function H(U,A){const $=(0,c.getFallbackTargetPlarforms)(A);for(let V=0;V<U.length;V++){const X=U[V];if(X.version===U[V-1]?.version){let Y=V;const de=k(X);if(de===A)for(;Y>0&&U[Y-1].version===X.version;)Y--;else if($.includes(de))for(;Y>0&&U[Y-1].version===X.version&&k(U[Y-1])!==A;)Y--;Y!==V&&(U.splice(V,1),U.splice(Y,0,X))}}return U}i.sortExtensionVersions=H;function ie(U,A,$,V,X){const Y=U.versions[0],de={manifest:te(A,f.Manifest),readme:te(A,f.Details),changelog:te(A,f.Changelog),license:te(A,f.License),repository:ee(A),download:ge(A),icon:ce(A),coreTranslations:G(A)};return{identifier:{id:(0,E.getGalleryExtensionId)(U.publisher.publisherName,U.extensionName),uuid:U.extensionId},name:U.extensionName,version:A.version,displayName:U.displayName,publisherId:U.publisher.publisherId,publisher:U.publisher.publisherName,publisherDisplayName:U.publisher.displayName,publisherDomain:U.publisher.domain?{link:U.publisher.domain,verified:!!U.publisher.isDomainVerified}:void 0,description:U.shortDescription||"",installCount:N(U.statistics,"install"),rating:N(U.statistics,"averagerating"),ratingCount:N(U.statistics,"ratingcount"),categories:U.categories||[],tags:U.tags||[],releaseDate:Date.parse(U.releaseDate),lastUpdated:Date.parse(U.lastUpdated),allTargetPlatforms:$,assets:de,properties:{dependencies:he(A,v.Dependency),extensionPack:he(A,v.ExtensionPack),engine:W(A),localizedLanguages:ne(A),targetPlatform:k(A),isPreReleaseVersion:B(A)},hasPreReleaseVersion:B(Y),hasReleaseVersion:V,preview:M(U.flags),telemetryData:X}}let K=class{constructor(A,$,V,X,Y,de,se,re){this.requestService=$,this.logService=V,this.environmentService=X,this.telemetryService=Y,this.fileService=de,this.productService=se,this.configurationService=re;const oe=se.extensionsGallery;this.extensionsGalleryUrl=oe&&oe.serviceUrl,this.extensionsControlUrl=oe&&oe.controlUrl,this.commonHeadersPromise=ue(se.version,se,this.environmentService,this.configurationService,this.fileService,A)}api(A=""){return`${this.extensionsGalleryUrl}${A}`}isEnabled(){return!!this.extensionsGalleryUrl}async getExtensions(A,$,V){const X=(0,l.isBoolean)($)?$:!1,Y=(0,l.isBoolean)($)?V:$;let de=new O().withFlags(e.IncludeAssetUri,e.IncludeStatistics,e.IncludeCategoryAndTags,e.IncludeFiles,e.IncludeVersionProperties).withPage(1,A.length).withFilter(s.Target,"Microsoft.VisualStudio.Code").withFilter(s.ExtensionName,...A.map(({id:oe})=>oe.toLowerCase()));A.every(oe=>!oe.version)&&(de=de.withFlags(e.IncludeAssetUri,e.IncludeStatistics,e.IncludeCategoryAndTags,e.IncludeFiles,e.IncludeVersionProperties,e.IncludeLatestVersionOnly));const{galleryExtensions:se}=await this.queryGallery(de,r,P.CancellationToken.None),re=se.map(oe=>{const ye=(0,E.getGalleryExtensionId)(oe.publisher.publisherName,oe.extensionName);return{rawGalleryExtension:oe,version:A.find(le=>(0,E.areSameExtensions)(le,{id:ye}))?.version,preRelease:X}});return this.converToGalleryExtensions(re,r,()=>{},Y)}async getExtensions2(A){const $=[],V=[];for(const se of A)se.uuid?V.push(se.uuid):$.push(se.id.toLowerCase());let X=new O().withFlags(e.IncludeAssetUri,e.IncludeStatistics,e.IncludeCategoryAndTags,e.IncludeFiles,e.IncludeVersionProperties,e.IncludeLatestVersionOnly).withPage(1,A.length).withFilter(s.Target,"Microsoft.VisualStudio.Code");V.length&&(X=X.withFilter(s.ExtensionId,...V)),$.length&&(X=X.withFilter(s.ExtensionId,...$));const{galleryExtensions:Y}=await this.queryGallery(X,r,P.CancellationToken.None),de=Y.map(se=>{const re=(0,E.getGalleryExtensionId)(se.publisher.publisherName,se.extensionName),oe=A.find(ye=>(0,E.areSameExtensions)(ye,{id:re,uuid:se.extensionId}));return{rawGalleryExtension:se,preRelease:!!oe?.preRelease}});return this.converToGalleryExtensions(de,r,()=>{},P.CancellationToken.None)}async getCompatibleExtension(A,$,V){const X=(0,c.isIExtensionIdentifier)(A)?null:A;if(X){if((0,c.isNotWebExtensionInWebTargetPlatform)(X.allTargetPlatforms,V))return null;if(await this.isExtensionCompatible(X,$,V))return X}const{id:Y,uuid:de}=X?X.identifier:A;let se=new O().withFlags(e.IncludeAssetUri,e.IncludeStatistics,e.IncludeCategoryAndTags,e.IncludeFiles,e.IncludeVersionProperties).withPage(1,1).withFilter(s.Target,"Microsoft.VisualStudio.Code");de?se=se.withFilter(s.ExtensionId,de):se=se.withFilter(s.ExtensionName,Y);const{galleryExtensions:re}=await this.queryGallery(se,V,P.CancellationToken.None),[oe]=re;if(!oe||!oe.versions.length)return null;const ye=j(oe);if((0,c.isNotWebExtensionInWebTargetPlatform)(ye,V))return null;for(let le of oe.versions){if(!W(le)){const Ee=await this.getEngine(le);le={...le,properties:[...le.properties||[],{key:v.Engine,value:Ee}]}}if(await this.isRawExtensionVersionCompatible(le,$,ye,V)){const Ee=oe.versions.some(Se=>!B(Se));return ie(oe,le,ye,Ee)}}return null}async isExtensionCompatible(A,$,V){if(!(0,c.isTargetPlatformCompatible)(A.properties.targetPlatform,A.allTargetPlatforms,V)||!$&&A.properties.isPreReleaseVersion)return!1;let X=A.properties.engine;if(!X){const Y=await this.getManifest(A,P.CancellationToken.None);if(!Y)throw new Error("Manifest was not found");X=Y.engines.vscode}return(0,u.isEngineValid)(X,this.productService.version,this.productService.date)}async isRawExtensionVersionCompatible(A,$,V,X){if(!(0,c.isTargetPlatformCompatible)(k(A),V,X)||!$&&B(A))return!1;const Y=await this.getEngine(A);return(0,u.isEngineValid)(Y,this.productService.version,this.productService.date)}async query(A,$){if(!this.isEnabled())throw new Error("No extension gallery service configured.");let V=A.text||"";const X=(0,R.getOrDefault)(A,le=>le.pageSize,50);let Y=new O().withFlags(e.IncludeLatestVersionOnly,e.IncludeAssetUri,e.IncludeStatistics,e.IncludeCategoryAndTags,e.IncludeFiles,e.IncludeVersionProperties).withPage(1,X).withFilter(s.Target,"Microsoft.VisualStudio.Code");V?(V=V.replace(/\bcategory:("([^"]*)"|([^"]\S*))(\s+|\b|$)/g,(le,Ee,Se)=>(Y=Y.withFilter(s.Category,Se||Ee),"")),V=V.replace(/\btag:("([^"]*)"|([^"]\S*))(\s+|\b|$)/g,(le,Ee,Se)=>(Y=Y.withFilter(s.Tag,Se||Ee),"")),V=V.replace(/\bfeatured(\s+|\b|$)/g,()=>(Y=Y.withFilter(s.Featured),"")),V=V.trim(),V&&(V=V.length<200?V:V.substring(0,200),Y=Y.withFilter(s.SearchText,V)),Y=Y.withSortBy(0)):A.ids?Y=Y.withFilter(s.ExtensionId,...A.ids):A.names?Y=Y.withFilter(s.ExtensionName,...A.names):Y=Y.withSortBy(4),typeof A.sortBy=="number"&&(Y=Y.withSortBy(A.sortBy)),typeof A.sortOrder=="number"&&(Y=Y.withSortOrder(A.sortOrder));const{galleryExtensions:de,total:se}=await this.queryGallery(Y,r,$),re=le=>({index:(Y.pageNumber-1)*Y.pageSize+le,querySource:A.source}),oe=await this.converToGalleryExtensions(de.map(le=>({rawGalleryExtension:le,preRelease:!!A.includePreRelease})),r,re,$),ye=async(le,Ee)=>{if(Ee.isCancellationRequested)throw(0,b.canceled)();const Se=Y.withPage(le+1),{galleryExtensions:Oe}=await this.queryGallery(Se,r,Ee);return await this.converToGalleryExtensions(Oe.map(Fe=>({rawGalleryExtension:Fe,preRelease:!!A.includePreRelease})),r,re,$)};return{firstPage:oe,total:se,pageSize:Y.pageSize,getPage:ye}}async converToGalleryExtensions(A,$,V,X){const Y=(re,oe,ye,le)=>{const Ee=j(re);let Se=re.versions[0];return Se=re.versions.find(Oe=>Oe.version===Se.version&&(0,c.isTargetPlatformCompatible)(k(Oe),Ee,$))||Se,B(Se)&&!le&&(Se=re.versions.find(Oe=>Oe.version!==Se.version&&!B(Oe))||Se),ie(re,Se,Ee,ye,V(oe))},de=[],se=new Map;for(let re=0;re<A.length;re++){const{rawGalleryExtension:oe,version:ye,preRelease:le}=A[re],Ee=oe.versions.some(Se=>!B(Se));if(ye){const Se=oe.versions.find(Oe=>Oe.version===ye);Se&&de.push([re,ie(oe,Se,j(oe),Ee)])}else{const Se=Y(oe,re,Ee,le);Se.properties.isPreReleaseVersion?se.set(Se.identifier.uuid,{index:re,preRelease:le}):de.push([re,Se])}}if(se.size){const re=new Date().getTime(),oe=new O().withFlags(e.IncludeVersions,e.IncludeAssetUri,e.IncludeStatistics,e.IncludeCategoryAndTags,e.IncludeFiles,e.IncludeVersionProperties).withPage(1,se.size).withFilter(s.Target,"Microsoft.VisualStudio.Code").withFilter(s.ExtensionId,...se.keys()),{galleryExtensions:ye}=await this.queryGallery(oe,$,X);if(this.telemetryService.publicLog2("galleryService:preReleasesQuery",{duration:new Date().getTime()-re,count:se.size}),ye.length!==se.size)throw new Error("Not all extensions with latest versions are returned");for(const le of ye){const Ee=le.versions.some(Ve=>!B(Ve)),{index:Se,preRelease:Oe}=se.get(le.extensionId),Fe=Y(le,Se,Ee,Oe);de.push([Se,Fe])}}return de.sort((re,oe)=>re[0]-oe[0]).map(([,re])=>re)}async queryGallery(A,$,V){if(!this.isEnabled())throw new Error("No extension gallery service configured.");A=A.withFlags(A.flags,e.ExcludeNonValidated).withFilter(s.ExcludeWithFlags,t(e.Unpublished));const X=await this.commonHeadersPromise,Y=JSON.stringify(A.raw),de={...X,"Content-Type":"application/json",Accept:"application/json;api-version=3.0-preview.1","Accept-Encoding":"gzip","Content-Length":String(Y.length)},se=new Date().getTime();let re,oe,ye=0;try{if(re=await this.requestService.request({type:"POST",url:this.api("/extensionquery"),data:Y,headers:de},V),re.res.statusCode&&re.res.statusCode>=400&&re.res.statusCode<500)return{galleryExtensions:[],total:ye};const le=await(0,S.asJson)(re);if(le){const Ee=le.results[0],Se=Ee.extensions;Se.forEach(Fe=>H(Fe.versions,$));const Oe=Ee.resultMetadata&&Ee.resultMetadata.filter(Fe=>Fe.metadataType==="ResultCount")[0];return ye=Oe&&Oe.metadataItems.filter(Fe=>Fe.name==="TotalCount")[0].count||0,{galleryExtensions:Se,total:ye}}return{galleryExtensions:[],total:ye}}catch(le){throw oe=le,le}finally{this.telemetryService.publicLog2("galleryService:query",{...A.telemetryData,requestBodySize:String(Y.length),duration:new Date().getTime()-se,success:!!re&&(0,S.isSuccess)(re),responseBodySize:re?.res.headers["Content-Length"],statusCode:re?String(re.res.statusCode):void 0,errorCode:oe?(0,b.isPromiseCanceledError)(oe)?"canceled":(0,b.getErrorMessage)(oe).startsWith("XHR timeout")?"timeout":"failed":void 0,count:String(ye)})}}async reportStatistic(A,$,V,X){if(!this.isEnabled())return;const Y=D.isWeb?this.api(`/itemName/${A}.${$}/version/${V}/statType/${X==="install"?"1":"3"}/vscodewebextension`):this.api(`/publishers/${A}/extensions/${$}/${V}/stats?statType=${X}`),de=D.isWeb?"api-version=6.1-preview.1":"*/*;api-version=4.0-preview.1",re={...await this.commonHeadersPromise,Accept:de};try{await this.requestService.request({type:"POST",url:Y,headers:re},P.CancellationToken.None)}catch(oe){}}async download(A,$,V){this.logService.trace("ExtensionGalleryService#download",A.identifier.id);const X=(0,E.getGalleryExtensionTelemetryData)(A),Y=new Date().getTime(),de=ye=>this.telemetryService.publicLog("galleryService:downloadVSIX",{...X,duration:ye}),se=V===2?"install":V===3?"update":"",re=se?{uri:`${A.assets.download.uri}${p.URI.parse(A.assets.download.uri).query?"&":"?"}${se}=true`,fallbackUri:`${A.assets.download.fallbackUri}${p.URI.parse(A.assets.download.fallbackUri).query?"&":"?"}${se}=true`}:A.assets.download,oe=await this.getAsset(re);await this.fileService.writeFile($,oe.stream),de(new Date().getTime()-Y)}async getReadme(A,$){if(A.assets.readme){const V=await this.getAsset(A.assets.readme,{},$);return await(0,S.asText)(V)||""}return""}async getManifest(A,$){if(A.assets.manifest){const V=await this.getAsset(A.assets.manifest,{},$),X=await(0,S.asText)(V);return X?JSON.parse(X):null}return null}async getManifestFromRawExtensionVersion(A,$){const V=te(A,f.Manifest);if(!V)throw new Error("Manifest was not found");const X={"Accept-Encoding":"gzip"},Y=await this.getAsset(V,{headers:X});return await(0,S.asJson)(Y)}async getCoreTranslation(A,$){const V=A.assets.coreTranslations.filter(X=>X[0]===$.toUpperCase())[0];if(V){const X=await this.getAsset(V[1]),Y=await(0,S.asText)(X);return Y?JSON.parse(Y):null}return null}async getChangelog(A,$){if(A.assets.changelog){const V=await this.getAsset(A.assets.changelog,{},$);return await(0,S.asText)(V)||""}return""}async getAllCompatibleVersions(A,$,V){let X=new O().withFlags(e.IncludeVersions,e.IncludeCategoryAndTags,e.IncludeFiles,e.IncludeVersionProperties).withPage(1,1).withFilter(s.Target,"Microsoft.VisualStudio.Code");A.identifier.uuid?X=X.withFilter(s.ExtensionId,A.identifier.uuid):X=X.withFilter(s.ExtensionName,A.identifier.id);const{galleryExtensions:Y}=await this.queryGallery(X,V,P.CancellationToken.None);if(!Y.length)return[];const de=j(Y[0]);if((0,c.isNotWebExtensionInWebTargetPlatform)(de,V))return[];const se=[];for(const re of Y[0].versions)try{se[se.length-1]?.version!==re.version&&await this.isRawExtensionVersionCompatible(re,$,de,V)&&se.push({version:re.version,date:re.lastUpdated,isPreReleaseVersion:B(re)})}catch(oe){}return se}async getAsset(A,$={},V=P.CancellationToken.None){const X=await this.commonHeadersPromise,Y={type:"GET"},de={...X,...$.headers||{}};$={...$,...Y,headers:de};const se=A.uri,re=A.fallbackUri,oe={...$,url:se};try{const ye=await this.requestService.request(oe,V);if(ye.res.statusCode===200)return ye;const le=await(0,S.asText)(ye);throw new Error(`Expected 200, got back ${ye.res.statusCode} instead.

${le}`)}catch(ye){if((0,b.isPromiseCanceledError)(ye))throw ye;const le=(0,b.getErrorMessage)(ye);this.telemetryService.publicLog2("galleryService:cdnFallback",{url:se,message:le});const Ee={...$,url:re};return this.requestService.request(Ee,V)}}async getEngine(A){let $=W(A);if(!$){const V=await this.getManifestFromRawExtensionVersion(A,P.CancellationToken.None);if(!V)throw new Error("Manifest was not found");$=V.engines.vscode}return $}async getExtensionsControlManifest(){if(!this.isEnabled())throw new Error("No extension gallery service configured.");if(!this.extensionsControlUrl)return{malicious:[]};const A=await this.requestService.request({type:"GET",url:this.extensionsControlUrl},P.CancellationToken.None);if(A.res.statusCode!==200)throw new Error("Could not get extensions report.");const $=await(0,S.asJson)(A),V=[],X={};if($){for(const Y of $.malicious)V.push({id:Y});if($.unsupported)for(const Y of Object.keys($.unsupported)){const de=$.unsupported[Y];(0,l.isBoolean)(de)||(X[Y.toLowerCase()]=de.preReleaseExtension)}}return{malicious:V,unsupportedPreReleaseExtensions:X}}};K=ve([ae(1,S.IRequestService),ae(2,g.ILogService),ae(3,C.IEnvironmentService),ae(4,a.ITelemetryService),ae(5,h.IFileService),ae(6,m.IProductService),ae(7,y.IConfigurationService)],K);let Z=class extends K{constructor(A,$,V,X,Y,de,se,re){super(A,$,V,X,Y,de,se,re)}};Z=ve([ae(0,o.IStorageService),ae(1,S.IRequestService),ae(2,g.ILogService),ae(3,C.IEnvironmentService),ae(4,a.ITelemetryService),ae(5,h.IFileService),ae(6,m.IProductService),ae(7,y.IConfigurationService)],Z),i.ExtensionGalleryService=Z;let _=class extends K{constructor(A,$,V,X,Y,de,se){super(void 0,A,$,V,X,Y,de,se)}};_=ve([ae(0,S.IRequestService),ae(1,g.ILogService),ae(2,C.IEnvironmentService),ae(3,a.ITelemetryService),ae(4,h.IFileService),ae(5,m.IProductService),ae(6,y.IConfigurationService)],_),i.ExtensionGalleryServiceWithNoStorageService=_;async function ue(U,A,$,V,X,Y){const de={"X-Market-Client-Id":`VSCode ${U}`,"User-Agent":`VSCode ${U}`},se=await(0,d.getServiceMachineId)($,X,Y);return(0,n.supportsTelemetry)(A,$)&&(0,n.getTelemetryLevel)(V)===3&&(de["X-Market-User-Id"]=se),de}i.resolveMarketplaceHeaders=ue}),define(J[121],Q([0,1,2,21,12,26,86,25,35,122,29,30,36]),function(x,i,T,P,b,R,D,w,l,p,y,C,c){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.TelemetryService=void 0;let E=class{constructor(g,m){this._configurationService=m,this._experimentProperties={},this._disposables=new T.DisposableStore,this._cleanupPatterns=[],this._appenders=g.appenders,this._commonProperties=g.commonProperties||Promise.resolve({}),this._piiPaths=g.piiPaths||[],this._telemetryLevel=3,this.sendErrorTelemetry=!!g.sendErrorTelemetry,this._cleanupPatterns=[/file:\/\/\/.*?\/resources\/app\//gi];for(let S of this._piiPaths)this._cleanupPatterns.push(new RegExp((0,R.escapeRegExpCharacters)(S),"gi"));this._updateTelemetryLevel(),this._configurationService.onDidChangeConfiguration(this._updateTelemetryLevel,this,this._disposables),this.publicLog2("optInStatus",{optIn:this._telemetryLevel===3}),this._commonProperties.then(S=>{const d=/^[a-f0-9]+$/i.test(S["common.machineId"]);this.publicLog2("machineIdFallback",{usingFallbackGuid:!d})})}setExperimentProperty(g,m){this._experimentProperties[g]=m}_updateTelemetryLevel(){this._telemetryLevel=(0,c.getTelemetryLevel)(this._configurationService)}get telemetryLevel(){return this._telemetryLevel}async getTelemetryInfo(){const g=await this._commonProperties;let m=g.sessionID,S=g["common.machineId"],d=g["common.firstSessionDate"],o=g["common.msftInternal"];return{sessionId:m,machineId:S,firstSessionDate:d,msftInternal:o}}dispose(){this._disposables.dispose()}_log(g,m,S,d){return this.telemetryLevel<m?Promise.resolve(void 0):this._commonProperties.then(o=>{S=(0,P.mixin)(S,o),S=(0,P.mixin)(S,this._experimentProperties),S=(0,P.cloneAndChange)(S,a=>{if(typeof a=="string")return this._cleanupInfo(a,d)}),this._appenders.forEach(a=>a.log(g,S))},o=>{console.error(o)})}publicLog(g,m,S){return this._log(g,3,m,S)}publicLog2(g,m,S){return this.publicLog(g,m,S)}publicLogError(g,m){return this.sendErrorTelemetry?this._log(g,2,m,!0):Promise.resolve(void 0)}publicLogError2(g,m){return this.publicLogError(g,m)}_anonymizeFilePaths(g){let m=g;const S=[];for(let n of this._cleanupPatterns)for(;;){const r=n.exec(g);if(!r)break;S.push([r.index,n.lastIndex])}const d=/^[\\\/]?(node_modules|node_modules\.asar)[\\\/]/,o=/(file:\/\/)?([a-zA-Z]:(\\\\|\\|\/)|(\\\\|\\|\/))?([\w-\._]+(\\\\|\\|\/))+[\w-\._]*/g;let a=0;for(m="";;){const n=o.exec(g);if(!n)break;!d.test(n[0])&&S.every(([r,e])=>n.index<r||n.index>=e)&&(m+=g.substring(a,n.index)+"<REDACTED: user-file-path>",a=o.lastIndex)}return a<g.length&&(m+=g.substr(a)),m}_removePropertiesWithPossibleUserInfo(g){if(!g)return g;const m=g.toLowerCase(),S=/@[a-zA-Z0-9-.]+/;return/(key|token|sig|signature|password|passwd|pwd)[="':\s]/.test(m)?"<REDACTED: secret>":S.test(m)?"<REDACTED: email>":g}_cleanupInfo(g,m){let S=g;m&&(S=this._anonymizeFilePaths(S));for(let d of this._cleanupPatterns)S=S.replace(d,"");return S=this._removePropertiesWithPossibleUserInfo(S),S}};E.IDLE_START_EVENT_NAME="UserIdleStart",E.IDLE_STOP_EVENT_NAME="UserIdleStop",E=ve([ae(1,w.IConfigurationService)],E),i.TelemetryService=E;function u(){const h=(0,D.localize)(0,null,p.default.nameLong),g=p.default.privacyStatementUrl?(0,D.localize)(2,null,"https://aka.ms/vscode-telemetry",p.default.privacyStatementUrl):(0,D.localize)(1,null,"https://aka.ms/vscode-telemetry"),m=b.isWeb?"":(0,D.localize)(3,null),S=(0,D.localize)(4,null),d=(0,D.localize)(5,null),o=(0,D.localize)(6,null),a=(0,D.localize)(7,null),n=`
|       | ${S} | ${d} | ${o} |
|:------|:---------------------:|:---------------:|:--------------:|
| all   |            \u2713          |        \u2713        |        \u2713       |
| error |            \u2713          |        \u2713        |        -       |
| crash |            \u2713          |        -        |        -       |
| off   |            -          |        -        |        -       |
`,r=(0,D.localize)(8,null);return`
${h} ${g} ${m}

&nbsp;

${a}
${n}

&nbsp;

${r}
`}y.Registry.as(l.Extensions.Configuration).registerConfiguration({id:C.TELEMETRY_SECTION_ID,order:110,type:"object",title:(0,D.localize)(9,null),properties:{[C.TELEMETRY_SETTING_ID]:{type:"string",enum:["all","error","crash","off"],enumDescriptions:[(0,D.localize)(10,null),(0,D.localize)(11,null),(0,D.localize)(12,null),(0,D.localize)(13,null)],markdownDescription:u(),default:"all",restricted:!0,scope:1,tags:["usesOnlineServices","telemetry"]}}}),y.Registry.as(l.Extensions.Configuration).registerConfiguration({id:C.TELEMETRY_SECTION_ID,order:110,type:"object",title:(0,D.localize)(14,null),properties:{[C.TELEMETRY_OLD_SETTING_ID]:{type:"boolean",markdownDescription:p.default.privacyStatementUrl?(0,D.localize)(16,null,p.default.nameLong,p.default.privacyStatementUrl):(0,D.localize)(15,null,p.default.nameLong),default:!0,restricted:!0,markdownDeprecationMessage:(0,D.localize)(17,null,`\`#${C.TELEMETRY_SETTING_ID}#\``),scope:1,tags:["usesOnlineServices","telemetry"]}}})}),define(J[123],Q([0,1,7,21,36]),function(x,i,T,P,b){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.AppInsightsAppender=void 0;async function R(w,l){const p=await new Promise((C,c)=>{x(["applicationinsights"],C,c)});let y;return p.defaultClient?(y=new p.TelemetryClient(w),y.channel.setUseDiskRetryCaching(!0)):(p.setup(w).setAutoCollectRequests(!1).setAutoCollectPerformance(!1).setAutoCollectExceptions(!1).setAutoCollectDependencies(!1).setAutoDependencyCorrelation(!1).setAutoCollectConsole(!1).setInternalLogging(!1,!1).setUseDiskRetryCaching(!0).start(),y=p.defaultClient),w.indexOf("AIF-")===0&&(y.config.endpointUrl=l?"https://mobile.events.data.microsoft.com/collect/v1":"https://vortex.data.microsoft.com/collect/v1"),y}class D{constructor(l,p,y,C,c){this._eventPrefix=l,this._defaultData=p,this.testCollector=C,this.mirrored=c,this._defaultData||(this._defaultData=Object.create(null)),typeof y=="function"?this._aiClient=y():this._aiClient=y,this._asyncAIClient=null}_withAIClient(l){if(!!this._aiClient){if(typeof this._aiClient!="string"){l(this._aiClient);return}this._asyncAIClient||(this._asyncAIClient=R(this._aiClient,this.testCollector??!1)),this._asyncAIClient.then(p=>{l(p)},p=>{(0,T.onUnexpectedError)(p),console.error(p)})}}log(l,p){!this._aiClient||(p=(0,P.mixin)(p,this._defaultData),p=(0,b.validateTelemetryData)(p),this.testCollector&&(p.properties["common.useragent"]=this.mirrored?"mirror-collector++":"collector++"),this._withAIClient(y=>y.trackEvent({name:this._eventPrefix+"/"+l,properties:p.properties,measurements:p.measurements})))}flush(){return this._aiClient?new Promise(l=>{this._withAIClient(p=>{p.flush({callback:()=>{this._aiClient=void 0,l(void 0)}})})}):Promise.resolve(void 0)}}i.AppInsightsAppender=D}),define(J[124],Q([0,1,6,13]),function(x,i,T,P){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.buildTelemetryMessage=void 0;async function b(R,D){const w=Object.create(null),l=(y,C)=>{const c=JSON.parse(y);w[C]=c};if(D){const y=[],C=await P.Promises.readdir(D);for(const E of C)try{(await P.Promises.stat((0,T.join)(D,E))).isDirectory()&&y.push(E)}catch{}const c=[];for(const E of y)(await P.Promises.readdir((0,T.join)(D,E))).filter(h=>h==="telemetry.json").length===1&&c.push(E);for(const E of c){const u=(await P.Promises.readFile((0,T.join)(D,E,"telemetry.json"))).toString();l(u,E)}}let p=(await P.Promises.readFile((0,T.join)(R,"telemetry-core.json"))).toString();return l(p,"vscode-core"),p=(await P.Promises.readFile((0,T.join)(R,"telemetry-extensions.json"))).toString(),l(p,"vscode-extensions"),JSON.stringify(w,null,4)}i.buildTelemetryMessage=b}),define(J[37],Q([0,1,14]),function(x,i,T){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.IUriIdentityService=void 0,i.IUriIdentityService=(0,T.createDecorator)("IUriIdentityService")}),define(J[125],Q([0,1,11,2,9,20,23,16,15,37]),function(x,i,T,P,b,R,D,w,l,p){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.ExtensionsWatcher=void 0;let y=class extends P.Disposable{constructor(c,E,u,h,g){super();this.extensionsManagementService=c,this.logService=h,this.uriIdentityService=g,this._onDidChangeExtensionsByAnotherSource=this._register(new T.Emitter),this.onDidChangeExtensionsByAnotherSource=this._onDidChangeExtensionsByAnotherSource.event,this.startTimestamp=0,this.installingExtensions=[],this.extensionsManagementService.getInstalled(1).then(S=>{this.installedExtensions=S.map(d=>d.identifier),this.startTimestamp=Date.now()}),this._register(c.onInstallExtension(S=>this.onInstallExtension(S))),this._register(c.onDidInstallExtensions(S=>this.onDidInstallExtensions(S))),this._register(c.onDidUninstallExtension(S=>this.onDidUninstallExtension(S)));const m=b.URI.file(u.extensionsPath);this._register(E.watch(m)),this._register(T.Event.filter(E.onDidChangeFilesRaw,S=>S.changes.some(d=>this.doesChangeAffects(d,m)))(()=>this.onDidChange()))}doesChangeAffects(c,E){return this.uriIdentityService.extUri.isEqual(this.uriIdentityService.extUri.dirname(c.resource),E)?this.uriIdentityService.extUri.isEqual(c.resource,this.uriIdentityService.extUri.joinPath(E,".obsolete"))?!0:!(c.type!==1&&c.type!==2||this.uriIdentityService.extUri.basename(c.resource).startsWith(".")):!1}onInstallExtension(c){this.addInstallingExtension(c.identifier)}onDidInstallExtensions(c){for(const E of c)this.removeInstallingExtension(E.identifier),E.local&&this.addInstalledExtension(E.identifier)}onDidUninstallExtension(c){c.error||this.removeInstalledExtension(c.identifier)}addInstallingExtension(c){this.removeInstallingExtension(c),this.installingExtensions.push(c)}removeInstallingExtension(c){this.installingExtensions=this.installingExtensions.filter(E=>!(0,D.areSameExtensions)(E,c))}addInstalledExtension(c){this.installedExtensions&&(this.removeInstalledExtension(c),this.installedExtensions.push(c))}removeInstalledExtension(c){this.installedExtensions&&(this.installedExtensions=this.installedExtensions.filter(E=>!(0,D.areSameExtensions)(E,c)))}async onDidChange(){if(this.installedExtensions){const c=await this.extensionsManagementService.getInstalled(1),E=c.filter(h=>[...this.installingExtensions,...this.installedExtensions].some(g=>(0,D.areSameExtensions)(g,h.identifier))?!1:h.installedTimestamp&&h.installedTimestamp>this.startTimestamp?(this.logService.info("Detected extension installed from another source",h.identifier.id),!0):(this.logService.info("Ignored extension installed by another source because of invalid timestamp",h.identifier.id),!1)),u=this.installedExtensions.filter(h=>this.installingExtensions.some(g=>(0,D.areSameExtensions)(g,h))?!1:c.every(g=>!(0,D.areSameExtensions)(g.identifier,h))?(this.logService.info("Detected extension removed from another source",h.id),!0):!1);this.installedExtensions=c.map(h=>h.identifier),(E.length||u.length)&&this._onDidChangeExtensionsByAnotherSource.fire({added:E,removed:u})}}};y=ve([ae(1,w.IFileService),ae(2,R.INativeEnvironmentService),ae(3,l.ILogService),ae(4,p.IUriIdentityService)],y),i.ExtensionsWatcher=y}),define(J[126],Q([0,1,37,91,16,18,59,11,2]),function(x,i,T,P,b,R,D,w,l){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.UriIdentityService=void 0;class p{constructor(c){this.uri=c,this.time=p._clock++}touch(){return this.time=p._clock++,this}}p._clock=0;let y=class{constructor(c){this._fileService=c,this._dispooables=new l.DisposableStore,this._limit=2**16;const E=new Map,u=h=>{let g=E.get(h.scheme);return g===void 0&&(g=c.hasProvider(h)&&!this._fileService.hasCapability(h,1024),E.set(h.scheme,g)),g};this._dispooables.add(w.Event.any(c.onDidChangeFileSystemProviderRegistrations,c.onDidChangeFileSystemProviderCapabilities)(h=>{E.delete(h.scheme)})),this.extUri=new R.ExtUri(u),this._canonicalUris=new D.SkipList((h,g)=>this.extUri.compare(h,g,!0),this._limit)}dispose(){this._dispooables.dispose(),this._canonicalUris.clear()}asCanonicalUri(c){this._fileService.hasProvider(c)&&(c=(0,R.normalizePath)(c));let E=this._canonicalUris.get(c);return E?E.touch().uri.with({fragment:c.fragment}):(this._canonicalUris.set(c,new p(c)),this._checkTrim(),c)}_checkTrim(){if(this._canonicalUris.size<this._limit)return;const c=[...this._canonicalUris.entries()].sort((u,h)=>u[1].touch<h[1].touch?1:u[1].touch>h[1].touch?-1:0);p._clock=0,this._canonicalUris.clear();const E=this._limit*.5;for(let u=0;u<E;u++)this._canonicalUris.set(c[u][0],c[u][1].touch())}};y=ve([ae(0,b.IFileService)],y),i.UriIdentityService=y,(0,P.registerSingleton)(T.IUriIdentityService,y,!0)}),define(J[45],Q([0,1,48,3,6,8,13,72,138,139]),function(x,i,T,P,b,R,D,w,l,p){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.buffer=i.extract=i.zip=i.ExtractError=void 0;class y extends Error{constructor(n,r){let e=r.message;switch(n){case"CorruptZip":e=`Corrupt ZIP: ${e}`;break}super(e);this.type=n,this.cause=r}}i.ExtractError=y;function C(a){const n=a.externalFileAttributes>>16||33188;return[448,56,7].map(r=>n&r).reduce((r,e)=>r+e,n&61440)}function c(a){if(a instanceof y)return a;let n;return/end of central directory record signature not found/.test(a.message)&&(n="CorruptZip"),new y(n,a)}function E(a,n,r,e,t,s){const f=b.dirname(n),v=b.join(e,f);if(!v.startsWith(e))return Promise.reject(new Error(w.localize(0,null,n)));const L=b.join(e,n);let I;return s.onCancellationRequested(()=>{I&&I.destroy()}),Promise.resolve(D.Promises.mkdir(v,{recursive:!0})).then(()=>new Promise((O,N)=>{if(!s.isCancellationRequested)try{I=(0,T.createWriteStream)(L,{mode:r}),I.once("close",()=>O()),I.once("error",N),a.once("error",N),a.pipe(I)}catch(G){N(G)}}))}function u(a,n,r,e){let t=(0,P.createCancelablePromise)(()=>Promise.resolve()),s=0;return e.onCancellationRequested(()=>{t.cancel(),a.close()}),new Promise((f,v)=>{const L=new P.Sequencer,I=O=>{O.isCancellationRequested||(s++,a.readEntry())};a.once("error",v),a.once("close",()=>t.then(()=>{e.isCancellationRequested||a.entryCount===s?f():v(new y("Incomplete",new Error(w.localize(1,null,s,a.entryCount))))},v)),a.readEntry(),a.on("entry",O=>{if(e.isCancellationRequested)return;if(!r.sourcePathRegex.test(O.fileName)){I(e);return}const N=O.fileName.replace(r.sourcePathRegex,"");if(/\/$/.test(N)){const ge=b.join(n,N);t=(0,P.createCancelablePromise)(ce=>D.Promises.mkdir(ge,{recursive:!0}).then(()=>I(ce)).then(void 0,v));return}const G=g(a,O),ee=C(O);t=(0,P.createCancelablePromise)(ge=>L.queue(()=>G.then(ce=>E(ce,N,ee,n,r,ge).then(()=>I(ge)))).then(null,v))})})}function h(a,n=!1){return new Promise((r,e)=>{(0,l.open)(a,n?{lazyEntries:!0}:void 0,(t,s)=>{t?e(c(t)):r((0,R.assertIsDefined)(s))})})}function g(a,n){return new Promise((r,e)=>{a.openReadStream(n,(t,s)=>{t?e(c(t)):r((0,R.assertIsDefined)(s))})})}function m(a,n){return new Promise((r,e)=>{const t=new p.ZipFile;n.forEach(f=>{f.contents?t.addBuffer(typeof f.contents=="string"?Buffer.from(f.contents,"utf8"):f.contents,f.path):f.localPath&&t.addFile(f.localPath,f.path)}),t.end();const s=(0,T.createWriteStream)(a);t.outputStream.pipe(s),t.outputStream.once("error",e),s.once("error",e),s.once("finish",()=>r(a))})}i.zip=m;function S(a,n,r={},e){const t=new RegExp(r.sourcePath?`^${r.sourcePath}`:"");let s=h(a,!0);return r.overwrite&&(s=s.then(f=>D.Promises.rm(n).then(()=>f))),s.then(f=>u(f,n,{sourcePathRegex:t},e))}i.extract=S;function d(a,n){return h(a).then(r=>new Promise((e,t)=>{r.on("entry",s=>{s.fileName===n&&g(r,s).then(f=>e(f),f=>t(f))}),r.once("close",()=>t(new Error(w.localize(2,null,n))))}))}function o(a,n){return d(a,n).then(r=>new Promise((e,t)=>{const s=[];r.once("error",t),r.on("data",f=>s.push(f)),r.on("end",()=>e(Buffer.concat(s)))}))}i.buffer=o}),define(J[127],Q([0,1,45,79]),function(x,i,T,P){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.getManifest=void 0;function b(R){return(0,T.buffer)(R,"extension/package.json").then(D=>{try{return JSON.parse(D.toString("utf8"))}catch(w){throw new Error((0,P.localize)(0,null))}})}i.getManifest=b}),define(J[128],Q([0,1,19,3,7,2,10,6,12,18,43,9,31,13,45,80,20,22,23,90,16,15,32]),function(x,i,T,P,b,R,D,w,l,p,y,C,c,E,u,h,g,m,S,d,o,a,n){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.ExtensionsScanner=void 0;let r=class extends R.Disposable{constructor(t,s,f,v,L){super();this.beforeRemovingExtension=t,this.fileService=s,this.logService=f,this.environmentService=v,this.productService=L,this._devSystemExtensionsPath=null,this.systemExtensionsPath=v.builtinExtensionsPath,this.extensionsPath=v.extensionsPath,this.uninstalledPath=w.join(this.extensionsPath,".obsolete"),this.uninstalledFileLimiter=new P.Queue}async cleanUp(){await this.removeUninstalledExtensions(),await this.removeOutdatedExtensions()}async scanExtensions(t){const s=[];(t===null||t===0)&&s.push(this.scanSystemExtensions().then(null,f=>Promise.reject(new m.ExtensionManagementError(this.joinErrors(f).message,m.ExtensionManagementErrorCode.Internal)))),(t===null||t===1)&&s.push(this.scanUserExtensions(!0).then(null,f=>Promise.reject(new m.ExtensionManagementError(this.joinErrors(f).message,m.ExtensionManagementErrorCode.Internal))));try{const f=await Promise.all(s);return(0,T.flatten)(f)}catch(f){throw this.joinErrors(f)}}async scanUserExtensions(t){this.logService.trace("Started scanning user extensions");let[s,f]=await Promise.all([this.getUninstalledExtensions(),this.scanAllUserExtensions()]);return f=f.filter(v=>!s[new S.ExtensionIdentifierWithVersion(v.identifier,v.manifest.version).key()]),t&&(f=(0,S.groupByExtension)(f,L=>L.identifier).map(L=>L.sort((I,O)=>y.rcompare(I.manifest.version,O.manifest.version))[0])),this.logService.trace("Scanned user extensions:",f.length),f}async scanAllUserExtensions(){return this.scanExtensionsInDir(this.extensionsPath,1)}async extractUserExtension(t,s,f,v){const L=t.key(),I=w.join(this.extensionsPath,`.${(0,c.generateUuid)()}`),O=w.join(this.extensionsPath,L);try{await E.Promises.rm(O)}catch(G){try{await E.Promises.rm(O)}catch(ee){}throw new m.ExtensionManagementError((0,h.localize)(0,null,O,t.id),m.ExtensionManagementErrorCode.Delete)}await this.extractAtLocation(t,s,I,v);let N=await this.scanExtension(C.URI.file(I),1);if(!N)throw new Error((0,h.localize)(1,null,I));await this.storeMetadata(N,{...f,installedTimestamp:Date.now()});try{await this.rename(t,I,O,Date.now()+2*60*1e3),this.logService.info("Renamed to",O)}catch(G){try{await E.Promises.rm(I)}catch(ee){}if(G.code==="ENOTEMPTY")this.logService.info("Rename failed because extension was installed by another source. So ignoring renaming.",t.id);else throw this.logService.info(`Rename failed because of ${(0,b.getErrorMessage)(G)}. Deleted from extracted location`,I),G}try{N=await this.scanExtension(C.URI.file(O),1)}catch(G){}if(N)return N;throw new Error((0,h.localize)(2,null,this.extensionsPath))}async saveMetadataForLocalExtension(t,s){return this.setMetadata(t,s),await this.storeMetadata(t,{...s,installedTimestamp:t.installedTimestamp}),t}async storeMetadata(t,s){s.isMachineScoped=s.isMachineScoped||void 0,s.isBuiltin=s.isBuiltin||void 0,s.installedTimestamp=s.installedTimestamp||void 0;const f=w.join(t.location.fsPath,"package.json"),v=await E.Promises.readFile(f,"utf8"),{manifest:L}=await this.parseManifest(v);return L.__metadata=s,await E.Promises.writeFile(f,JSON.stringify(L,null,"	")),t}getUninstalledExtensions(){return this.withUninstalledExtensions()}async setUninstalled(...t){const s=t.map(f=>new S.ExtensionIdentifierWithVersion(f.identifier,f.manifest.version));await this.withUninstalledExtensions(f=>{s.forEach(v=>f[v.key()]=!0)})}async setInstalled(t){await this.withUninstalledExtensions(v=>delete v[t.key()]);const f=(await this.scanExtensions(1)).find(v=>new S.ExtensionIdentifierWithVersion(v.identifier,v.manifest.version).equals(t))||null;return f?(await this.storeMetadata(f,{installedTimestamp:Date.now()}),this.scanExtension(f.location,1)):null}async withUninstalledExtensions(t){return this.uninstalledFileLimiter.queue(async()=>{let s;try{s=await E.Promises.readFile(this.uninstalledPath,"utf8")}catch(v){if(v.code!=="ENOENT")throw v}let f={};if(s)try{f=JSON.parse(s)}catch(v){}return t&&(t(f),Object.keys(f).length?await E.Promises.writeFile(this.uninstalledPath,JSON.stringify(f)):await E.Promises.rm(this.uninstalledPath)),f})}async removeExtension(t,s){this.logService.trace(`Deleting ${s} extension from disk`,t.identifier.id,t.location.fsPath),await E.Promises.rm(t.location.fsPath),this.logService.info("Deleted from disk",t.identifier.id,t.location.fsPath)}async removeUninstalledExtension(t){await this.removeExtension(t,"uninstalled"),await this.withUninstalledExtensions(s=>delete s[new S.ExtensionIdentifierWithVersion(t.identifier,t.manifest.version).key()])}async extractAtLocation(t,s,f,v){this.logService.trace(`Started extracting the extension from ${s} to ${f}`);try{await E.Promises.rm(f)}catch(L){throw new m.ExtensionManagementError(this.joinErrors(L).message,m.ExtensionManagementErrorCode.Delete)}try{await(0,u.extract)(s,f,{sourcePath:"extension",overwrite:!0},v),this.logService.info(`Extracted extension to ${f}:`,t.id)}catch(L){try{await E.Promises.rm(f)}catch(O){}let I=m.ExtensionManagementErrorCode.Extract;throw L instanceof u.ExtractError&&(L.type==="CorruptZip"?I=m.ExtensionManagementErrorCode.CorruptZip:L.type==="Incomplete"&&(I=m.ExtensionManagementErrorCode.IncompleteZip)),new m.ExtensionManagementError(L.message,I)}}async rename(t,s,f,v){try{await E.Promises.rename(s,f)}catch(L){if(l.isWindows&&L&&L.code==="EPERM"&&Date.now()<v)return this.logService.info(`Failed renaming ${s} to ${f} with 'EPERM' error. Trying again...`,t.id),this.rename(t,s,f,v);throw new m.ExtensionManagementError(L.message||(0,h.localize)(3,null,s,f),L.code||m.ExtensionManagementErrorCode.Rename)}}async scanSystemExtensions(){this.logService.trace("Started scanning system extensions");const t=this.scanDefaultSystemExtensions();if(this.environmentService.isBuilt)return t;const s=this.scanDevSystemExtensions(),[f,v]=await Promise.all([t,s]);return[...f,...v]}async scanExtensionsInDir(t,s){const f=new P.Limiter(10),v=await this.fileService.resolve(C.URI.file(t));return v.children?(await Promise.all(v.children.filter(I=>I.isDirectory).map(I=>f.queue(async()=>s===1&&(0,p.basename)(I.resource).indexOf(".")===0?null:this.scanExtension(I.resource,s))))).filter(I=>I&&I.identifier):[]}async scanExtension(t,s){try{const f=await this.fileService.resolve(t);if(f.children){const{manifest:v,metadata:L}=await this.readManifest(t.fsPath),I=f.children.find(({name:ee})=>/^readme(\.txt|\.md|)$/i.test(ee))?.resource,O=f.children.find(({name:ee})=>/^changelog(\.txt|\.md|)$/i.test(ee))?.resource,N={id:(0,S.getGalleryExtensionId)(v.publisher,v.name)},G={type:s,identifier:N,manifest:v,location:t,readmeUrl:I,changelogUrl:O,publisherDisplayName:null,publisherId:null,isMachineScoped:!1,isBuiltin:s===0};return this.setMetadata(G,L),G}}catch(f){s!==0&&this.logService.trace(f)}return null}async scanDefaultSystemExtensions(){const t=await this.scanExtensionsInDir(this.systemExtensionsPath,0);return this.logService.trace("Scanned system extensions:",t.length),t}async scanDevSystemExtensions(){const t=this.getDevSystemExtensionsList();if(t.length){const s=await this.scanExtensionsInDir(this.devSystemExtensionsPath,0);return this.logService.trace("Scanned dev system extensions:",s.length),s.filter(f=>t.some(v=>(0,S.areSameExtensions)(f.identifier,{id:v})))}else return[]}setMetadata(t,s){t.publisherDisplayName=s?.publisherDisplayName||null,t.publisherId=s?.publisherId||null,t.identifier.uuid=s?.id,t.isMachineScoped=!!s?.isMachineScoped,t.isPreReleaseVersion=!!s?.isPreReleaseVersion,t.preRelease=!!s?.preRelease,t.isBuiltin=t.type===0||!!s?.isBuiltin,t.installedTimestamp=s?.installedTimestamp}async removeUninstalledExtensions(){const t=await this.getUninstalledExtensions(),s=await this.scanAllUserExtensions(),f=new Set;for(const I of s)t[new S.ExtensionIdentifierWithVersion(I.identifier,I.manifest.version).key()]||f.add(I.identifier.id.toLowerCase());const v=(0,S.groupByExtension)(s,I=>I.identifier);await P.Promises.settled(v.map(async I=>{const O=I.sort((N,G)=>y.rcompare(N.manifest.version,G.manifest.version))[0];f.has(O.identifier.id.toLowerCase())||await this.beforeRemovingExtension(O)}));const L=s.filter(I=>t[new S.ExtensionIdentifierWithVersion(I.identifier,I.manifest.version).key()]);await P.Promises.settled(L.map(I=>this.removeUninstalledExtension(I)))}async removeOutdatedExtensions(){const t=await this.scanAllUserExtensions(),s=[],f=(0,S.groupByExtension)(t,v=>v.identifier);s.push(...(0,T.flatten)(f.map(v=>v.sort((L,I)=>y.rcompare(L.manifest.version,I.manifest.version)).slice(1)))),await P.Promises.settled(s.map(v=>this.removeExtension(v,"outdated")))}getDevSystemExtensionsList(){return(this.productService.builtInExtensions||[]).map(t=>t.name)}joinErrors(t){const s=Array.isArray(t)?t:[t];return s.length===1?s[0]instanceof Error?s[0]:new Error(s[0]):s.reduce((f,v)=>new Error(`${f.message}${f.message?",":""}${v instanceof Error?v.message:v}`),new Error(""))}get devSystemExtensionsPath(){return this._devSystemExtensionsPath||(this._devSystemExtensionsPath=w.normalize(w.join(D.FileAccess.asFileUri("",x).fsPath,"..",".build","builtInExtensions"))),this._devSystemExtensionsPath}async readManifest(t){const s=[E.Promises.readFile(w.join(t,"package.json"),"utf8").then(I=>this.parseManifest(I)),E.Promises.readFile(w.join(t,"package.nls.json"),"utf8").then(void 0,I=>I.code!=="ENOENT"?Promise.reject(I):"{}").then(I=>JSON.parse(I))],[{manifest:f,metadata:v},L]=await Promise.all(s);return{manifest:(0,d.localizeManifest)(f,L),metadata:v}}parseManifest(t){return new Promise((s,f)=>{try{const v=JSON.parse(t),L=v.__metadata||null;s({manifest:v,metadata:L})}catch(v){f(new Error((0,h.localize)(4,null)))}})}};r=ve([ae(1,o.IFileService),ae(2,a.ILogService),ae(3,g.INativeEnvironmentService),ae(4,n.IProductService)],r),i.ExtensionsScanner=r}),define(J[129],Q([0,1,27,7,10,6,12,28,18,43,9,31,13,45,78,52,20,119,22,23,110,98,127,111,128,125,51,16,14,15,32,30,37]),function(x,i,T,P,b,R,D,w,l,p,y,C,c,E,u,h,g,m,S,d,o,a,n,r,e,t,s,f,v,L,I,O,N){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.ExtensionManagementService=void 0;let G=class extends m.AbstractExtensionManagementService{constructor(W,B,ne,M,k,j,H,ie,K){super(W,B,ne,ie);this.environmentService=M,this.downloadService=k,this.fileService=H;const Z=this._register(j.createInstance(a.ExtensionsLifecycle));this.extensionsScanner=this._register(j.createInstance(e.ExtensionsScanner,ue=>Z.postUninstall(ue))),this.manifestCache=this._register(new r.ExtensionsManifestCache(M,this)),this.extensionsDownloader=this._register(j.createInstance(o.ExtensionsDownloader));const _=this._register(new t.ExtensionsWatcher(this,H,M,ne,K));this._register(_.onDidChangeExtensionsByAnotherSource(({added:ue,removed:U})=>{ue.length&&this._onDidInstallExtensions.fire(ue.map(A=>({identifier:A.identifier,operation:1,local:A}))),U.forEach(A=>this._onDidUninstallExtension.fire({identifier:A}))}))}getTargetPlatform(){return this._targetPlatformPromise||(this._targetPlatformPromise=(async()=>{const W=await this.isAlpineLinux(),B=(0,S.getTargetPlatform)(W?"alpine":D.platform,w.arch);return this.logService.debug("ExtensionManagementService#TargetPlatform:",B),B})()),this._targetPlatformPromise}async isAlpineLinux(){if(!D.isLinux)return!1;let W;try{W=(await this.fileService.readFile(y.URI.file("/etc/os-release"))).value.toString()}catch(B){try{W=(await this.fileService.readFile(y.URI.file("/usr/lib/os-release"))).value.toString()}catch(ne){this.logService.debug("Error while getting the os-release file.",(0,P.getErrorMessage)(ne))}}return!!W&&(W.match(/^ID=([^\u001b\r\n]*)/m)||[])[1]==="alpine"}async zip(W){this.logService.trace("ExtensionManagementService#zip",W.identifier.id);const B=await this.collectFiles(W),ne=await(0,E.zip)((0,l.joinPath)(this.environmentService.tmpDir,(0,C.generateUuid)()).fsPath,B);return y.URI.file(ne)}async unzip(W){return this.logService.trace("ExtensionManagementService#unzip",W.toString()),(await this.install(W)).identifier}async getManifest(W){const B=await this.downloadVsix(W),ne=R.resolve(B.fsPath);return(0,n.getManifest)(ne)}getInstalled(W=null){return this.extensionsScanner.scanExtensions(W)}async install(W,B={}){this.logService.trace("ExtensionManagementService#install",W.toString());const ne=await this.downloadVsix(W),M=await(0,n.getManifest)(R.resolve(ne.fsPath));if(M.engines&&M.engines.vscode&&!(0,s.isEngineValid)(M.engines.vscode,this.productService.version,this.productService.date))throw new Error(u.localize(0,null,(0,d.getGalleryExtensionId)(M.publisher,M.name),this.productService.version));return this.installExtension(M,ne,B)}async updateMetadata(W,B){this.logService.trace("ExtensionManagementService#updateMetadata",W.identifier.id);const ne={...W.manifest.__metadata||{},...B};return B.isPreReleaseVersion&&(ne.preRelease=!0),W=await this.extensionsScanner.saveMetadataForLocalExtension(W,ne),this.manifestCache.invalidate(),W}async updateExtensionScope(W,B){return this.logService.trace("ExtensionManagementService#updateExtensionScope",W.identifier.id),W=await this.extensionsScanner.saveMetadataForLocalExtension(W,{...W.manifest.__metadata||{},isMachineScoped:B}),this.manifestCache.invalidate(),W}removeDeprecatedExtensions(){return this.extensionsScanner.cleanUp()}async downloadVsix(W){if(W.scheme===b.Schemas.file)return W;const B=(0,l.joinPath)(this.environmentService.tmpDir,(0,C.generateUuid)());return await this.downloadService.download(W,B),B}createInstallExtensionTask(W,B,ne){return y.URI.isUri(B)?new ce(W,B,ne,this.galleryService,this.extensionsScanner,this.logService):new ge(B,ne,this.extensionsDownloader,this.extensionsScanner,this.logService)}createUninstallExtensionTask(W,B){return new te(W,B,this.extensionsScanner)}async collectFiles(W){const B=async M=>{let k=await c.Promises.readdir(M);k=k.map(ie=>R.join(M,ie));const j=await Promise.all(k.map(ie=>c.Promises.stat(ie)));let H=Promise.resolve([]);return j.forEach((ie,K)=>{const Z=k[K];ie.isFile()&&(H=H.then(_=>[..._,Z])),ie.isDirectory()&&(H=H.then(_=>B(Z).then(ue=>[..._,...ue])))}),H};return(await B(W.location.fsPath)).map(M=>({path:`extension/${R.relative(W.location.fsPath,M)}`,localPath:M}))}};G=ve([ae(0,S.IExtensionGalleryService),ae(1,O.ITelemetryService),ae(2,L.ILogService),ae(3,g.INativeEnvironmentService),ae(4,h.IDownloadService),ae(5,v.IInstantiationService),ae(6,f.IFileService),ae(7,I.IProductService),ae(8,N.IUriIdentityService)],G),i.ExtensionManagementService=G;class ee extends m.AbstractExtensionTask{constructor(W,B,ne,M){super();this.identifier=W,this.source=B,this.extensionsScanner=ne,this.logService=M,this._operation=2}get operation(){return this._operation}async installExtension(W,B){try{const ne=await this.unsetUninstalledAndGetLocal(W.identifierWithVersion);if(ne)return W.metadata?this.extensionsScanner.saveMetadataForLocalExtension(ne,{...ne.manifest.__metadata||{},...W.metadata}):ne}catch(ne){throw D.isMacintosh?new S.ExtensionManagementError(u.localize(1,null),S.ExtensionManagementErrorCode.Internal):new S.ExtensionManagementError(u.localize(2,null),S.ExtensionManagementErrorCode.Internal)}return this.extract(W,B)}async unsetUninstalledAndGetLocal(W){if(!await this.isUninstalled(W))return null;this.logService.trace("Removing the extension from uninstalled list:",W.id);const ne=await this.extensionsScanner.setInstalled(W);return this.logService.info("Removed the extension from uninstalled list:",W.id),ne}async isUninstalled(W){return!!(await this.extensionsScanner.getUninstalledExtensions())[W.key()]}async extract({zipPath:W,identifierWithVersion:B,metadata:ne},M){let k=await this.extensionsScanner.extractUserExtension(B,W,ne,M);return this.logService.info("Extracting completed.",B.id),k}}class ge extends ee{constructor(W,B,ne,M,k){super(W.identifier,W,M,k);this.gallery=W,this.options=B,this.extensionsDownloader=ne}async doRun(W){const ne=(await this.extensionsScanner.scanExtensions(null)).find(k=>(0,d.areSameExtensions)(k.identifier,this.gallery.identifier));ne&&(this._operation=3);const M=await this.downloadInstallableExtension(this.gallery,this._operation);M.metadata.isMachineScoped=this.options.isMachineScoped||ne?.isMachineScoped,M.metadata.isBuiltin=this.options.isBuiltin||ne?.isBuiltin,M.metadata.isPreReleaseVersion=this.gallery.properties.isPreReleaseVersion,M.metadata.preRelease=this.gallery.hasPreReleaseVersion?this.gallery.properties.isPreReleaseVersion:ne?.preRelease;try{const k=await this.installExtension(M,W);return ne&&p.neq(ne.manifest.version,this.gallery.version)&&await this.extensionsScanner.setUninstalled(ne),k}catch(k){throw await this.deleteDownloadedVSIX(M.zipPath),k}}async deleteDownloadedVSIX(W){try{await this.extensionsDownloader.delete(y.URI.file(W))}catch(B){this.logService.warn("Error while deleting the downloaded vsix",W.toString(),(0,P.getErrorMessage)(B))}}async downloadInstallableExtension(W,B){const ne={id:W.identifier.uuid,publisherId:W.publisherId,publisherDisplayName:W.publisherDisplayName};let M;try{this.logService.trace("Started downloading extension:",W.identifier.id),M=(await this.extensionsDownloader.downloadExtension(W,B)).fsPath,this.logService.info("Downloaded extension:",W.identifier.id,M)}catch(k){throw new S.ExtensionManagementError((0,m.joinErrors)(k).message,S.ExtensionManagementErrorCode.Download)}try{const k=await(0,n.getManifest)(M);return{zipPath:M,identifierWithVersion:new d.ExtensionIdentifierWithVersion(W.identifier,k.version),metadata:ne}}catch(k){throw await this.deleteDownloadedVSIX(M),new S.ExtensionManagementError((0,m.joinErrors)(k).message,S.ExtensionManagementErrorCode.Invalid)}}}class ce extends ee{constructor(W,B,ne,M,k,j){super({id:(0,d.getGalleryExtensionId)(W.publisher,W.name)},B,k,j);this.manifest=W,this.location=B,this.options=ne,this.galleryService=M}async doRun(W){const B=new d.ExtensionIdentifierWithVersion(this.identifier,this.manifest.version),M=(await this.extensionsScanner.scanExtensions(1)).find(j=>(0,d.areSameExtensions)(this.identifier,j.identifier)),k=await this.getMetadata(this.identifier.id,this.manifest.version,W);if(k.isMachineScoped=this.options.isMachineScoped||M?.isMachineScoped,k.isBuiltin=this.options.isBuiltin||M?.isBuiltin,M)if(this._operation=3,B.equals(new d.ExtensionIdentifierWithVersion(M.identifier,M.manifest.version)))try{await this.extensionsScanner.removeExtension(M,"existing")}catch(j){throw new Error(u.localize(3,null,this.manifest.displayName||this.manifest.name))}else p.gt(M.manifest.version,this.manifest.version)&&await this.extensionsScanner.setUninstalled(M);else{const j=await this.unsetUninstalledAndGetLocal(B);if(j)try{await this.extensionsScanner.removeExtension(j,"existing")}catch(H){throw new Error(u.localize(4,null,this.manifest.displayName||this.manifest.name))}}return this.installExtension({zipPath:R.resolve(this.location.fsPath),identifierWithVersion:B,metadata:k},W)}async getMetadata(W,B,ne){try{let[M]=await this.galleryService.getExtensions([{id:W,version:B}],ne);if(M||([M]=await this.galleryService.getExtensions([{id:W}],ne)),M)return{id:M.identifier.uuid,publisherDisplayName:M.publisherDisplayName,publisherId:M.publisherId,isPreReleaseVersion:M.properties.isPreReleaseVersion,preRelease:M.properties.isPreReleaseVersion}}catch(M){}return{}}}class te extends m.AbstractExtensionTask{constructor(W,B,ne){super();this.extension=W,this.options=B,this.extensionsScanner=ne}async doRun(W){const B=[],ne=await this.extensionsScanner.scanUserExtensions(!1);if(this.options.versionOnly){const M=new d.ExtensionIdentifierWithVersion(this.extension.identifier,this.extension.manifest.version);B.push(...ne.filter(k=>M.equals(new d.ExtensionIdentifierWithVersion(k.identifier,k.manifest.version))))}else B.push(...ne.filter(M=>(0,d.areSameExtensions)(M.identifier,this.extension.identifier)));if(!B.length)throw new Error(u.localize(5,null,this.extension.manifest.displayName||this.extension.manifest.name));if(await this.extensionsScanner.setUninstalled(...B),this.options.remove)for(const M of B)try{W.isCancellationRequested||await this.extensionsScanner.removeUninstalledExtension(M)}catch(k){throw new Error(u.localize(6,null,(0,T.toErrorMessage)(k)))}}}}),define(J[130],Q([0,1,115,3,17,7,2,8,25,20,93,15,114,140]),function(x,i,T,P,b,R,D,w,l,p,y,C,c,E){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.RequestService=void 0;let u=class extends D.Disposable{constructor(g,m,S){super();this.environmentService=m,this.logService=S,this.configure(g.getValue()),this._register(g.onDidChangeConfiguration(()=>this.configure(g.getValue()),this))}configure(g){this.proxyUrl=g.http&&g.http.proxy,this.strictSSL=!!(g.http&&g.http.proxyStrictSSL),this.authorization=g.http&&g.http.proxyAuthorization}async request(g,m){this.logService.trace("RequestService#request",g.url);const{proxyUrl:S,strictSSL:d}=this;let o;try{o=await(0,y.getResolvedShellEnv)(this.logService,this.environmentService.args,process.env)}catch(r){this.shellEnvErrorLogged||(this.shellEnvErrorLogged=!0,this.logService.error("RequestService#request resolving shell environment failed",r))}const a={...process.env,...o},n=g.agent?g.agent:await(0,c.getProxyAgent)(g.url||"",a,{proxyUrl:S,strictSSL:d});return g.agent=n,g.strictSSL=d,this.authorization&&(g.headers={...g.headers||{},"Proxy-Authorization":this.authorization}),this._request(g,m)}async getNodeRequest(g){return((0,T.parse)(g.url).protocol==="https:"?await new Promise((d,o)=>{x(["https"],d,o)}):await new Promise((d,o)=>{x(["http"],d,o)})).request}_request(g,m){return P.Promises.withAsyncBody(async(S,d)=>{let o;const a=(0,T.parse)(g.url),n=g.getRawRequest?g.getRawRequest(g):await this.getNodeRequest(g),r={hostname:a.hostname,port:a.port?parseInt(a.port):a.protocol==="https:"?443:80,protocol:a.protocol,path:a.path,method:g.type||"GET",headers:g.headers,agent:g.agent,rejectUnauthorized:(0,w.isBoolean)(g.strictSSL)?g.strictSSL:!0};g.user&&g.password&&(r.auth=g.user+":"+g.password),o=n(r,e=>{const t=(0,w.isNumber)(g.followRedirects)?g.followRedirects:3;if(e.statusCode&&e.statusCode>=300&&e.statusCode<400&&t>0&&e.headers.location)this._request({...g,url:e.headers.location,followRedirects:t-1},m).then(S,d);else{let s=e;e.headers["content-encoding"]==="gzip"&&(s=e.pipe((0,E.createGunzip)())),S({res:e,stream:(0,b.streamToBufferReadableStream)(s)})}}),o.on("error",d),g.timeout&&o.setTimeout(g.timeout),g.data&&typeof g.data=="string"&&o.write(g.data),o.end(),m.onCancellationRequested(()=>{o.abort(),d((0,R.canceled)())})})}async resolveProxy(g){}};u=ve([ae(0,l.IConfigurationService),ae(1,p.INativeEnvironmentService),ae(2,C.ILogService)],u),i.RequestService=u}),define(J[141],Q([0,1,33,3,17,27,7,2,10,6,28,9,13,25,107,52,113,20,89,120,22,109,129,16,100,103,41,97,54,55,112,15,104,122,32,44,130,118,30,121,36,123,124,37,126]),function(x,i,T,P,b,R,D,w,l,p,y,C,c,E,u,h,g,m,S,d,o,a,n,r,e,t,s,f,v,L,I,O,N,G,ee,ge,ce,te,he,W,B,ne,M,k,j){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.main=void 0;class H extends w.Disposable{constructor(Z){super();this.argv=Z,this.registerListeners()}registerListeners(){process.once("exit",()=>this.dispose())}async run(){const[Z,_]=await this.initServices();return Z.invokeFunction(async ue=>{const U=ue.get(O.ILogService),A=ue.get(r.IFileService),$=ue.get(m.INativeEnvironmentService),V=ue.get(o.IExtensionManagementCLIService);U.info("CLI main",this.argv),this.registerErrorHandler(U),await this.doRun($,V,A),await Promise.all(_.map(X=>{(0,P.raceTimeout)(X.flush(),1e3)}))})}async initServices(){const Z=new v.ServiceCollection,_={_serviceBrand:void 0,...G.default};Z.set(ee.IProductService,_);const ue=new S.NativeEnvironmentService(this.argv,_);Z.set(m.INativeEnvironmentService,ue),await Promise.all([ue.appSettingsHome.fsPath,ue.extensionsPath].map(se=>se?c.Promises.mkdir(se,{recursive:!0}):void 0));const U=(0,O.getLogLevel)(ue),A=[];A.push(new N.SpdLogLogger("cli",(0,p.join)(ue.logsPath,"cli.log"),!0,!1,U)),U===O.LogLevel.Trace&&A.push(new O.ConsoleLogger(U));const $=this._register(new O.MultiplexLogService(A));Z.set(O.ILogService,$);const V=this._register(new e.FileService($));Z.set(r.IFileService,V);const X=this._register(new t.DiskFileSystemProvider($));V.registerProvider(l.Schemas.file,X);const Y=this._register(new u.ConfigurationService(ue.settingsResource,V));Z.set(E.IConfigurationService,Y),await Y.initialize(),Z.set(k.IUriIdentityService,new j.UriIdentityService(V)),Z.set(ge.IRequestService,new s.SyncDescriptor(ce.RequestService)),Z.set(h.IDownloadService,new s.SyncDescriptor(g.DownloadService)),Z.set(o.IExtensionManagementService,new s.SyncDescriptor(n.ExtensionManagementService)),Z.set(o.IExtensionGalleryService,new s.SyncDescriptor(d.ExtensionGalleryServiceWithNoStorageService)),Z.set(o.IExtensionManagementCLIService,new s.SyncDescriptor(a.ExtensionManagementCLIService)),Z.set(L.ILocalizationsService,new s.SyncDescriptor(I.LocalizationsService));const de=[];if((0,B.supportsTelemetry)(_,ue)){_.aiConfig&&_.aiConfig.asimovKey&&de.push(new ne.AppInsightsAppender("monacoworkbench",null,_.aiConfig.asimovKey));const{appRoot:se,extensionsPath:re,installSourcePath:oe}=ue,ye={appenders:de,sendErrorTelemetry:!1,commonProperties:(async()=>{let le;try{const Ee=await c.Promises.readFile((0,p.join)(ue.userDataPath,"storage.json"));le=JSON.parse(Ee.toString())[he.machineIdKey]}catch(Ee){Ee.code!=="ENOENT"&&$.error(Ee)}return(0,te.resolveCommonProperties)(V,(0,T.release)(),(0,T.hostname)(),process.arch,_.commit,_.version,le,_.msftInternalDomains,oe)})(),piiPaths:[se,re]};Z.set(he.ITelemetryService,new s.SyncDescriptor(W.TelemetryService,[ye]))}else Z.set(he.ITelemetryService,B.NullTelemetryService);return[new f.InstantiationService(Z),de]}registerErrorHandler(Z){(0,D.setUnexpectedErrorHandler)(_=>{const ue=(0,R.toErrorMessage)(_,!0);!ue||Z.error(`[uncaught exception in CLI]: ${ue}`)}),process.on("uncaughtException",_=>(0,D.onUnexpectedError)(_)),process.on("unhandledRejection",_=>(0,D.onUnexpectedError)(_))}async doRun(Z,_,ue){if(this.argv["install-source"])return this.setInstallSource(Z,ue,this.argv["install-source"]);if(this.argv["list-extensions"])return _.listExtensions(!!this.argv["show-versions"],this.argv.category);if(this.argv["install-extension"]||this.argv["install-builtin-extension"]){const U={isMachineScoped:!!this.argv["do-not-sync"],installPreReleaseVersion:!!this.argv["pre-release"]};return _.installExtensions(this.asExtensionIdOrVSIX(this.argv["install-extension"]||[]),this.argv["install-builtin-extension"]||[],U,!!this.argv.force)}else{if(this.argv["uninstall-extension"])return _.uninstallExtensions(this.asExtensionIdOrVSIX(this.argv["uninstall-extension"]),!!this.argv.force);if(this.argv["locate-extension"])return _.locateExtension(this.argv["locate-extension"]);this.argv.telemetry&&console.log(await(0,M.buildTelemetryMessage)(Z.appRoot,Z.extensionsPath))}}asExtensionIdOrVSIX(Z){return Z.map(_=>/\.vsix$/i.test(_)?C.URI.file((0,p.isAbsolute)(_)?_:(0,p.join)((0,y.cwd)(),_)):_)}async setInstallSource(Z,_,ue){await _.writeFile(C.URI.file(Z.installSourcePath),b.VSBuffer.fromString(ue.slice(0,30)))}}async function ie(K){const Z=new H(K);try{await Z.run()}finally{Z.dispose()}}i.main=ie})}).call(this);

//# sourceMappingURL=https://ticino.blob.core.windows.net/sourcemaps/899d46d82c4c95423fb7e10e68eba52050e30ba3/core/vs/code/node/cliProcessMain.js.map
