/*!--------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/(function(){var pe=["require","exports","vs/base/common/uri","vs/base/common/event","vs/platform/instantiation/common/instantiation","vs/workbench/api/common/extHost.protocol","vs/base/common/lifecycle","vs/workbench/api/common/extHostTypes","vs/base/common/strings","vs/base/common/path","vs/base/common/network","vs/platform/log/common/log","vs/base/common/platform","vs/base/common/types","vs/workbench/api/common/extHostRpcService","vs/base/common/errors","vs/base/common/arrays","vs/workbench/api/common/extHostTypeConverters","vs/base/common/async","vs/nls","vs/nls!vs/workbench/services/extensions/node/extensionHostProcess","vs/base/common/cancellation","vs/base/common/buffer","vs/base/common/resources","vs/base/common/map","vs/base/common/objects","vs/workbench/api/common/extHostInitDataService","vs/platform/extensions/common/extensions","vs/base/node/pfs","vs/workbench/services/extensions/common/extensions","vs/base/common/extpath","vs/base/common/glob","vs/base/common/uuid","vs/workbench/services/search/common/search","vs/workbench/api/common/extHostTerminalService","vs/workbench/api/common/extHostWorkspace","vs/workbench/api/common/extHostConfiguration","child_process","vs/workbench/api/common/extHostCommands","vs/workbench/api/common/extHostExtensionService","vs/base/common/process","vs/editor/common/core/range","vs/platform/files/common/files","vs/platform/workspace/common/workspace","vs/workbench/api/common/extHostFileSystemInfo","vs/workbench/api/common/extHostDocumentsAndEditors","vs/base/common/stopwatch","vs/base/common/hash","vs/base/common/severity","vs/editor/common/core/position","vs/base/common/errorMessage","vs/platform/registry/common/platform","vs/workbench/api/common/extHostTunnelService","vs/workbench/services/extensions/common/proxyIdentifier","vs/workbench/api/common/extHostEditorTabs","vs/workbench/api/common/extHostDebugService","vs/base/common/assert","vs/base/common/decorators","vs/base/common/json","vs/base/common/marshalling","fs","vs/platform/contextkey/common/contextkey","vs/platform/remote/common/remoteHosts","vs/workbench/api/common/extHostTestingPrivateApi","vs/workbench/api/common/extHostUriTransformerService","vs/workbench/api/common/extHostApiDeprecationService","vs/workbench/api/common/extHostFileSystemConsumer","vs/workbench/api/common/extHostStoragePaths","vs/workbench/api/common/extHostWebview","vs/workbench/services/search/common/searchExtTypes","vs/workbench/api/common/extHostTask","vs/base/common/performance","vs/workbench/api/common/extHostSearch","vs/base/common/collections","vs/base/common/functional","vs/base/common/idGenerator","vs/base/common/iterator","vs/base/common/numbers","vs/base/common/codicons","vs/base/common/normalization","vs/base/common/labels","os","vs/editor/common/modes/languageSelector","vs/platform/instantiation/common/extensions","vs/editor/common/modes","vs/platform/instantiation/common/serviceCollection","vs/platform/theme/common/themeService","vs/workbench/api/common/cache","vs/workbench/api/common/shared/webview","vs/workbench/contrib/testing/common/testId","vs/workbench/api/common/exHostSecretState","vs/workbench/api/common/extHostStorage","vs/workbench/services/search/node/ripgrepSearchUtils","vs/base/common/linkedList","vs/base/common/processes","vs/base/common/stream","vs/base/common/filters","vs/base/common/htmlContent","vs/base/common/uint","vs/base/common/comparers","vs/base/common/fuzzyScorer","vs/base/common/mime","vs/base/common/uriIpc","string_decoder","vs/base/node/extpath","vs/base/parts/ipc/common/ipc","vs/base/parts/ipc/common/ipc.net","vs/editor/common/core/characterClassifier","vs/editor/common/model","vs/editor/common/model/wordHelper","vs/editor/common/services/semanticTokensDto","vs/editor/common/viewModel/prefixSumComputer","vs/base/node/processes","vs/editor/common/config/editorOptions","vs/platform/instantiation/common/descriptors","vs/platform/configuration/common/configuration","vs/platform/markers/common/markers","vs/platform/progress/common/progress","vs/platform/configuration/common/configurationRegistry","vs/platform/remote/common/remoteAuthorityResolver","vs/platform/remote/common/tunnel","vs/workbench/api/common/extHostTelemetry","vs/workbench/api/common/extHostDocumentData","vs/workbench/contrib/debug/common/abstractDebugAdapter","net","vs/workbench/contrib/notebook/common/notebookCommon","vs/workbench/contrib/testing/common/testCollection","vs/workbench/services/editor/common/editorGroupsService","vs/workbench/api/common/extHostNotebookEditor","vs/workbench/api/common/extHostTextEditor","vs/workbench/api/common/extHostDecorations","vs/workbench/api/common/extHostLoggerService","vs/workbench/api/common/extHostOutput","vs/workbench/api/common/extHostWindow","vs/workbench/services/search/common/textSearchManager","vs/workbench/services/search/node/textSearchManager","vs/workbench/services/search/node/ripgrepTextSearchEngine","vs/base/parts/ipc/node/ipc.net","vs/base/common/jsonFormatter","vs/base/common/jsonEdit","vs/base/common/lazy","vs/base/common/iconLabels","vs/base/node/decoder","vs/editor/common/controller/wordCharacterClassifier","vs/editor/common/core/selection","vs/editor/common/model/textModelSearch","vs/editor/common/modes/languageConfiguration","vs/editor/common/modes/linkComputer","vs/editor/common/modes/tokenizationRegistry","vs/editor/common/model/mirrorTextModel","vs/nls!vs/base/common/date","vs/base/common/date","vs/nls!vs/base/common/errorMessage","vs/nls!vs/base/node/processes","vs/nls!vs/editor/common/config/editorOptions","vs/nls!vs/platform/configuration/common/configurationRegistry","vs/nls!vs/platform/extensionManagement/common/extensionManagement","vs/nls!vs/platform/extensions/common/extensionValidator","vs/nls!vs/platform/externalTerminal/node/externalTerminalService","vs/nls!vs/platform/files/common/files","vs/nls!vs/platform/markers/common/markers","vs/nls!vs/platform/workspaces/common/workspaces","vs/nls!vs/workbench/api/common/extHostDiagnostics","vs/nls!vs/workbench/api/common/extHostExtensionService","vs/nls!vs/workbench/api/common/extHostProgress","vs/nls!vs/workbench/api/common/extHostStatusBar","vs/nls!vs/workbench/api/common/extHostTerminalService","vs/nls!vs/workbench/api/common/extHostTreeViews","vs/nls!vs/workbench/api/common/extHostWorkspace","vs/nls!vs/workbench/api/node/extHostDebugService","vs/nls!vs/workbench/api/node/extHostTunnelService","vs/nls!vs/workbench/common/editor","vs/nls!vs/workbench/contrib/debug/common/abstractDebugAdapter","vs/nls!vs/workbench/contrib/debug/node/debugAdapter","vs/nls!vs/workbench/contrib/search/common/queryBuilder","vs/nls!vs/workbench/contrib/tasks/common/taskService","vs/nls!vs/workbench/services/configurationResolver/common/variableResolver","vs/platform/editor/common/editor","vs/platform/extensions/common/extensionValidator","vs/platform/instantiation/common/graph","vs/editor/common/services/modelService","vs/editor/common/modes/languageFeatureRegistry","vs/platform/environment/common/environment","vs/platform/extensionManagement/common/extensionManagement","vs/platform/externalTerminal/common/externalTerminal","vs/platform/externalTerminal/node/externalTerminalService","vs/platform/instantiation/common/instantiationService","vs/platform/log/node/spdlogLog","vs/platform/notification/common/notification","vs/platform/opener/common/opener","vs/platform/product/common/product","vs/platform/jsonschemas/common/jsonContributionRegistry","vs/platform/configuration/common/configurationModels","vs/platform/extensionManagement/common/extensionManagementUtil","vs/platform/sign/node/signService","vs/platform/terminal/common/terminalDataBuffering","vs/platform/theme/common/theme","vs/platform/workspaces/common/workspaces","vs/workbench/api/common/extHostMemento","vs/workbench/api/common/extHostNotebookDocuments","vs/workbench/api/common/extHostSecrets","vs/workbench/api/common/extHostNotebookConcatDocument","vs/workbench/api/common/extHostTheming","vs/workbench/api/common/extHostWebviewMessaging","vs/workbench/api/common/shared/treeDataTransfer","vs/workbench/api/common/extHostCodeInsets","vs/workbench/common/editor","vs/workbench/contrib/debug/common/debugUtils","vs/workbench/contrib/debug/node/debugAdapter","vs/workbench/contrib/debug/node/terminals","vs/workbench/contrib/notebook/common/notebookExecutionService","vs/workbench/contrib/output/common/output","vs/workbench/contrib/tasks/common/taskService","vs/workbench/contrib/terminal/common/environmentVariableShared","vs/workbench/services/configurationResolver/common/variableResolver","vs/workbench/services/editor/common/editorService","vs/workbench/api/common/extHostDocumentSaveParticipant","vs/workbench/api/common/extHostFileSystemEventService","vs/workbench/api/common/extHostNotebookDocument","vs/workbench/api/common/extHostProgress","vs/workbench/api/common/extHostTreeViews","vs/workbench/contrib/testing/common/ownedTestCollection","vs/workbench/services/environment/common/environmentService","vs/workbench/services/extensions/common/extensionDescriptionRegistry","vs/workbench/services/extensions/common/extensionHostProtocol","vs/workbench/api/common/extHostExtensionActivator","vs/workbench/api/common/extHostLogService","vs/workbench/services/extensions/common/lazyPromise","vs/workbench/api/common/extHostAuthentication","vs/workbench/api/common/extHostBulkEdits","vs/workbench/api/common/extHostClipboard","vs/workbench/api/common/extHostApiCommands","vs/workbench/api/common/extHostComments","vs/workbench/api/common/extHostDiagnostics","vs/workbench/api/common/extHostDialogs","vs/workbench/api/common/extHostDocumentContentProviders","vs/workbench/api/common/extHostDocuments","vs/workbench/api/common/extHostFileSystem","vs/workbench/api/common/extHostInteractive","vs/workbench/api/common/extHostLabelService","vs/workbench/api/common/extHostLanguageFeatures","vs/workbench/api/common/extHostLanguages","vs/workbench/api/common/extHostMessageService","vs/workbench/api/common/extHostNotebook","vs/workbench/api/common/extHostNotebookEditors","vs/workbench/api/common/extHostNotebookKernels","vs/workbench/api/common/extHostNotebookRenderers","vs/workbench/api/common/extHostQuickOpen","vs/workbench/api/common/extHostSCM","vs/workbench/api/common/extHostStatusBar","vs/workbench/api/common/extHostTesting","vs/workbench/api/common/extHostTextEditors","vs/workbench/api/common/extHostTimeline","vs/workbench/api/common/extHostUriOpener","vs/workbench/api/common/extHostUrls","vs/workbench/api/common/extHostCustomEditors","vs/workbench/api/common/extHostWebviewPanels","vs/workbench/api/common/extHostWebviewView","vs/workbench/api/node/extHostDownloadService","vs/workbench/api/node/extHostLoggerService","vs/workbench/api/node/extHostStoragePaths","vs/workbench/api/node/extHostTerminalService","vs/workbench/api/node/extHostTunnelService","vs/workbench/services/extensions/common/rpcProtocol","vs/workbench/services/remote/common/remoteAgentService","vs/workbench/services/path/common/pathService","vs/workbench/contrib/search/common/queryBuilder","vs/workbench/api/common/shared/workspaceContains","vs/workbench/api/common/extHostRequireInterceptor","vs/workbench/api/node/extHostDebugService","vs/workbench/api/node/extHostTask","vs/workbench/services/extensions/common/extensionHostMain","vs/workbench/services/search/common/fileSearchManager","vs/workbench/api/common/extHost.api.impl","vs/workbench/api/common/extHost.common.services","vs/workbench/services/textfile/common/encoding","vs/workbench/services/extensions/node/proxyResolver","http","vs/workbench/services/search/node/ripgrepFileSearch","vscode-ripgrep","vs/workbench/services/search/node/fileSearch","vs/workbench/services/search/node/ripgrepSearchProvider","vs/workbench/services/search/node/textSearchAdapter","vs/workbench/services/search/node/rawSearchService","vs/workbench/api/node/extHostSearch","vs/workbench/api/node/extHostCLIServer","vs/workbench/api/node/extHostExtensionService","vs/workbench/api/node/extHost.node.services","vs/workbench/services/extensions/node/extensionHostProcessSetup","util","vs/base/common/marked/marked","https","tls","vscode-proxy-agent","events","vscode-regexpp","crypto","zlib","minimist","vs/workbench/services/extensions/node/extensionHostProcess"],ve=function(Y){for(var e=[],m=0,L=Y.length;m<L;m++)e[m]=pe[Y[m]];return e};define(pe[56],ve([0,1]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ok=void 0;function m(L,y){if(!L)throw new Error(y?`Assertion failed (${y})`:"Assertion Failed")}e.ok=m}),define(pe[73],ve([0,1]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SetMap=e.diffMaps=e.diffSets=e.fromMap=e.groupBy=e.forEach=e.values=void 0;const m=Object.prototype.hasOwnProperty;function L(R){const P=[];for(let u in R)m.call(R,u)&&P.push(R[u]);return P}e.values=L;function y(R,P){for(let u in R)if(m.call(R,u)&&P({key:u,value:R[u]},function(){delete R[u]})===!1)return}e.forEach=y;function C(R,P){const u=Object.create(null);for(const E of R){const f=P(E);let v=u[f];v||(v=u[f]=[]),v.push(E)}return u}e.groupBy=C;function i(R){const P=Object.create(null);return R&&R.forEach((u,E)=>{P[E]=u}),P}e.fromMap=i;function k(R,P){const u=[],E=[];for(let f of R)P.has(f)||u.push(f);for(let f of P)R.has(f)||E.push(f);return{removed:u,added:E}}e.diffSets=k;function S(R,P){const u=[],E=[];for(let[f,v]of R)P.has(f)||u.push(v);for(let[f,v]of P)R.has(f)||E.push(v);return{removed:u,added:E}}e.diffMaps=S;class D{constructor(){this.map=new Map}add(P,u){let E=this.map.get(P);E||(E=new Set,this.map.set(P,E)),E.add(u)}delete(P,u){const E=this.map.get(P);!E||(E.delete(u),E.size===0&&this.map.delete(P))}forEach(P,u){const E=this.map.get(P);!E||E.forEach(u)}}e.SetMap=D}),define(pe[57],ve([0,1]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.throttle=e.debounce=e.memoize=e.createDecorator=void 0;function m(i){return(k,S,D)=>{let R=null,P=null;if(typeof D.value=="function"?(R="value",P=D.value):typeof D.get=="function"&&(R="get",P=D.get),!P)throw new Error("not supported");D[R]=i(P,S)}}e.createDecorator=m;function L(i,k,S){let D=null,R=null;if(typeof S.value=="function"?(D="value",R=S.value,R.length!==0&&console.warn("Memoize should only be used in functions with zero parameters")):typeof S.get=="function"&&(D="get",R=S.get),!R)throw new Error("not supported");const P=`$memoize$${k}`;S[D]=function(...u){return this.hasOwnProperty(P)||Object.defineProperty(this,P,{configurable:!1,enumerable:!1,writable:!1,value:R.apply(this,u)}),this[P]}}e.memoize=L;function y(i,k,S){return m((D,R)=>{const P=`$debounce$${R}`,u=`$debounce$result$${R}`;return function(...E){this[u]||(this[u]=S?S():void 0),clearTimeout(this[P]),k&&(this[u]=k(this[u],...E),E=[this[u]]),this[P]=setTimeout(()=>{D.apply(this,E),this[u]=S?S():void 0},i)}})}e.debounce=y;function C(i,k,S){return m((D,R)=>{const P=`$throttle$timer$${R}`,u=`$throttle$result$${R}`,E=`$throttle$lastRun$${R}`,f=`$throttle$pending$${R}`;return function(...v){if(this[u]||(this[u]=S?S():void 0),(this[E]===null||this[E]===void 0)&&(this[E]=-Number.MAX_VALUE),k&&(this[u]=k(this[u],...v)),this[f])return;const w=this[E]+i;w<=Date.now()?(this[E]=Date.now(),D.apply(this,[this[u]]),this[u]=S?S():void 0):(this[f]=!0,this[P]=setTimeout(()=>{this[f]=!1,this[E]=Date.now(),D.apply(this,[this[u]]),this[u]=S?S():void 0},w-Date.now()))}})}e.throttle=C}),define(pe[15],ve([0,1]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createErrorWithActions=e.isErrorWithActions=e.ExpectedError=e.NotSupportedError=e.NotImplementedError=e.getErrorMessage=e.disposed=e.readonly=e.illegalState=e.illegalArgument=e.canceled=e.CancellationError=e.isPromiseCanceledError=e.transformErrorForSerialization=e.onUnexpectedExternalError=e.onUnexpectedError=e.setUnexpectedErrorHandler=e.errorHandler=e.ErrorHandler=void 0;class m{constructor(){this.listeners=[],this.unexpectedErrorHandler=function(a){setTimeout(()=>{throw a.stack?new Error(a.message+`

`+a.stack):a},0)}}addListener(a){return this.listeners.push(a),()=>{this._removeListener(a)}}emit(a){this.listeners.forEach(_=>{_(a)})}_removeListener(a){this.listeners.splice(this.listeners.indexOf(a),1)}setUnexpectedErrorHandler(a){this.unexpectedErrorHandler=a}getUnexpectedErrorHandler(){return this.unexpectedErrorHandler}onUnexpectedError(a){this.unexpectedErrorHandler(a),this.emit(a)}onUnexpectedExternalError(a){this.unexpectedErrorHandler(a)}}e.ErrorHandler=m,e.errorHandler=new m;function L(g){e.errorHandler.setUnexpectedErrorHandler(g)}e.setUnexpectedErrorHandler=L;function y(g){S(g)||e.errorHandler.onUnexpectedError(g)}e.onUnexpectedError=y;function C(g){S(g)||e.errorHandler.onUnexpectedExternalError(g)}e.onUnexpectedExternalError=C;function i(g){if(g instanceof Error){let{name:a,message:_}=g;const n=g.stacktrace||g.stack;return{$isError:!0,name:a,message:_,stack:n}}return g}e.transformErrorForSerialization=i;const k="Canceled";function S(g){return g instanceof Error&&g.name===k&&g.message===k}e.isPromiseCanceledError=S;class D extends Error{constructor(){super(k);this.name=this.message}}e.CancellationError=D;function R(){const g=new Error(k);return g.name=g.message,g}e.canceled=R;function P(g){return g?new Error(`Illegal argument: ${g}`):new Error("Illegal argument")}e.illegalArgument=P;function u(g){return g?new Error(`Illegal state: ${g}`):new Error("Illegal state")}e.illegalState=u;function E(g){return g?new Error(`readonly property '${g} cannot be changed'`):new Error("readonly property cannot be changed")}e.readonly=E;function f(g){const a=new Error(`${g} has been disposed`);return a.name="DISPOSED",a}e.disposed=f;function v(g){return g?g.message?g.message:g.stack?g.stack.split(`
`)[0]:String(g):"Error"}e.getErrorMessage=v;class w extends Error{constructor(a){super("NotImplemented");a&&(this.message=a)}}e.NotImplementedError=w;class I extends Error{constructor(a){super("NotSupported");a&&(this.message=a)}}e.NotSupportedError=I;class p extends Error{constructor(){super(...arguments);this.isExpected=!0}}e.ExpectedError=p;function s(g){const a=g;return a instanceof Error&&Array.isArray(a.actions)}e.isErrorWithActions=s;function r(g,a=Object.create(null)){const _=new Error(g);return a.actions&&(_.actions=a.actions),_}e.createErrorWithActions=r}),define(pe[16],ve([0,1,15]),function(Y,e,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ArrayQueue=e.maxIndex=e.minIndex=e.splice=e.insertInto=e.mapFind=e.getRandomElement=e.asArray=e.mapArrayOrNot=e.pushToEnd=e.pushToStart=e.shuffle=e.arrayInsert=e.remove=e.insert=e.index=e.range=e.flatten=e.commonPrefixLength=e.firstOrDefault=e.lastIndex=e.findLast=e.uniqueFilter=e.distinct=e.isNonEmptyArray=e.isFalsyOrEmpty=e.move=e.coalesceInPlace=e.coalesce=e.topAsync=e.top=e.delta=e.sortedDiff=e.groupBy=e.quickSelect=e.findFirstInSorted=e.binarySearch=e.equals=e.tail2=e.tail=void 0;function L(H,V=0){return H[H.length-(1+V)]}e.tail=L;function y(H){if(H.length===0)throw new Error("Invalid tail call");return[H.slice(0,H.length-1),H[H.length-1]]}e.tail2=y;function C(H,V,q=(ne,fe)=>ne===fe){if(H===V)return!0;if(!H||!V||H.length!==V.length)return!1;for(let ne=0,fe=H.length;ne<fe;ne++)if(!q(H[ne],V[ne]))return!1;return!0}e.equals=C;function i(H,V,q){let ne=0,fe=H.length-1;for(;ne<=fe;){const ye=(ne+fe)/2|0,ke=q(H[ye],V);if(ke<0)ne=ye+1;else if(ke>0)fe=ye-1;else return ye}return-(ne+1)}e.binarySearch=i;function k(H,V){let q=0,ne=H.length;if(ne===0)return 0;for(;q<ne;){const fe=Math.floor((q+ne)/2);V(H[fe])?ne=fe:q=fe+1}return q}e.findFirstInSorted=k;function S(H,V,q){if(H=H|0,H>=V.length)throw new TypeError("invalid index");let ne=V[Math.floor(V.length*Math.random())],fe=[],ye=[],ke=[];for(let Be of V){const We=q(Be,ne);We<0?fe.push(Be):We>0?ye.push(Be):ke.push(Be)}return H<fe.length?S(H,fe,q):H<fe.length+ke.length?ke[0]:S(H-(fe.length+ke.length),ye,q)}e.quickSelect=S;function D(H,V){const q=[];let ne;for(const fe of H.slice(0).sort(V))!ne||V(ne[0],fe)!==0?(ne=[fe],q.push(ne)):ne.push(fe);return q}e.groupBy=D;function R(H,V,q){const ne=[];function fe(Be,We,ze){if(We===0&&ze.length===0)return;const Q=ne[ne.length-1];Q&&Q.start+Q.deleteCount===Be?(Q.deleteCount+=We,Q.toInsert.push(...ze)):ne.push({start:Be,deleteCount:We,toInsert:ze})}let ye=0,ke=0;for(;;){if(ye===H.length){fe(ye,0,V.slice(ke));break}if(ke===V.length){fe(ye,H.length-ye,[]);break}const Be=H[ye],We=V[ke],ze=q(Be,We);ze===0?(ye+=1,ke+=1):ze<0?(fe(ye,1,[]),ye+=1):ze>0&&(fe(ye,0,[We]),ke+=1)}return ne}e.sortedDiff=R;function P(H,V,q){const ne=R(H,V,q),fe=[],ye=[];for(const ke of ne)fe.push(...H.slice(ke.start,ke.start+ke.deleteCount)),ye.push(...ke.toInsert);return{removed:fe,added:ye}}e.delta=P;function u(H,V,q){if(q===0)return[];const ne=H.slice(0,q).sort(V);return f(H,V,ne,q,H.length),ne}e.top=u;function E(H,V,q,ne,fe){return q===0?Promise.resolve([]):new Promise((ye,ke)=>{(async()=>{const Be=H.length,We=H.slice(0,q).sort(V);for(let ze=q,Q=Math.min(q+ne,Be);ze<Be;ze=Q,Q=Math.min(Q+ne,Be)){if(ze>q&&await new Promise(ee=>setTimeout(ee)),fe&&fe.isCancellationRequested)throw(0,m.canceled)();f(H,V,We,ze,Q)}return We})().then(ye,ke)})}e.topAsync=E;function f(H,V,q,ne,fe){for(const ye=q.length;ne<fe;ne++){const ke=H[ne];if(V(ke,q[ye-1])<0){q.pop();const Be=k(q,We=>V(ke,We)<0);q.splice(Be,0,ke)}}}function v(H){return H.filter(V=>!!V)}e.coalesce=v;function w(H){let V=0;for(let q=0;q<H.length;q++)H[q]&&(H[V]=H[q],V+=1);H.length=V}e.coalesceInPlace=w;function I(H,V,q){H.splice(q,0,H.splice(V,1)[0])}e.move=I;function p(H){return!Array.isArray(H)||H.length===0}e.isFalsyOrEmpty=p;function s(H){return Array.isArray(H)&&H.length>0}e.isNonEmptyArray=s;function r(H,V=q=>q){const q=new Set;return H.filter(ne=>{const fe=V(ne);return q.has(fe)?!1:(q.add(fe),!0)})}e.distinct=r;function g(H){const V=Object.create(null);return q=>{const ne=H(q);return V[ne]?!1:(V[ne]=!0,!0)}}e.uniqueFilter=g;function a(H,V){const q=_(H,V);if(q!==-1)return H[q]}e.findLast=a;function _(H,V){for(let q=H.length-1;q>=0;q--){const ne=H[q];if(V(ne))return q}return-1}e.lastIndex=_;function n(H,V){return H.length>0?H[0]:V}e.firstOrDefault=n;function t(H,V,q=(ne,fe)=>ne===fe){let ne=0;for(let fe=0,ye=Math.min(H.length,V.length);fe<ye&&q(H[fe],V[fe]);fe++)ne++;return ne}e.commonPrefixLength=t;function o(H){return[].concat(...H)}e.flatten=o;function d(H,V){let q=typeof V=="number"?H:0;typeof V=="number"?q=H:(q=0,V=H);const ne=[];if(q<=V)for(let fe=q;fe<V;fe++)ne.push(fe);else for(let fe=q;fe>V;fe--)ne.push(fe);return ne}e.range=d;function c(H,V,q){return H.reduce((ne,fe)=>(ne[V(fe)]=q?q(fe):fe,ne),Object.create(null))}e.index=c;function h(H,V){return H.push(V),()=>l(H,V)}e.insert=h;function l(H,V){const q=H.indexOf(V);if(q>-1)return H.splice(q,1),V}e.remove=l;function b(H,V,q){const ne=H.slice(0,V),fe=H.slice(V);return ne.concat(q,fe)}e.arrayInsert=b;function T(H,V){let q;if(typeof V=="number"){let ne=V;q=()=>{const fe=Math.sin(ne++)*179426549;return fe-Math.floor(fe)}}else q=Math.random;for(let ne=H.length-1;ne>0;ne-=1){const fe=Math.floor(q()*(ne+1)),ye=H[ne];H[ne]=H[fe],H[fe]=ye}}e.shuffle=T;function A(H,V){const q=H.indexOf(V);q>-1&&(H.splice(q,1),H.unshift(V))}e.pushToStart=A;function x(H,V){const q=H.indexOf(V);q>-1&&(H.splice(q,1),H.push(V))}e.pushToEnd=x;function O(H,V){return Array.isArray(H)?H.map(V):V(H)}e.mapArrayOrNot=O;function F(H){return Array.isArray(H)?H:[H]}e.asArray=F;function W(H){return H[Math.floor(Math.random()*H.length)]}e.getRandomElement=W;function M(H,V){for(const q of H){const ne=V(q);if(ne!==void 0)return ne}}e.mapFind=M;function B(H,V,q){const ne=z(H,V),fe=H.length,ye=q.length;H.length=fe+ye;for(let ke=fe-1;ke>=ne;ke--)H[ke+ye]=H[ke];for(let ke=0;ke<ye;ke++)H[ke+ne]=q[ke]}e.insertInto=B;function U(H,V,q,ne){const fe=z(H,V),ye=H.splice(fe,q);return B(H,fe,ne),ye}e.splice=U;function z(H,V){return V<0?Math.max(V+H.length,0):Math.min(V,H.length)}function K(H,V){let q=Number.MAX_SAFE_INTEGER,ne=0;return H.forEach((fe,ye)=>{const ke=V(fe);ke<q&&(q=ke,ne=ye)}),ne}e.minIndex=K;function N(H,V){let q=Number.MIN_SAFE_INTEGER,ne=0;return H.forEach((fe,ye)=>{const ke=V(fe);ke>q&&(q=ke,ne=ye)}),ne}e.maxIndex=N;class j{constructor(V){this.items=V,this.firstIdx=0,this.lastIdx=this.items.length-1}get length(){return this.lastIdx-this.firstIdx+1}takeWhile(V){let q=this.firstIdx;for(;q<this.items.length&&V(this.items[q]);)q++;const ne=q===this.firstIdx?null:this.items.slice(this.firstIdx,q);return this.firstIdx=q,ne}takeFromEndWhile(V){let q=this.lastIdx;for(;q>=0&&V(this.items[q]);)q--;const ne=q===this.lastIdx?null:this.items.slice(q+1,this.lastIdx+1);return this.lastIdx=q,ne}peek(){return this.items[this.firstIdx]}dequeue(){const V=this.items[this.firstIdx];return this.firstIdx++,V}takeCount(V){const q=this.items.slice(this.firstIdx,this.firstIdx+V);return this.firstIdx+=V,q}}e.ArrayQueue=j}),define(pe[74],ve([0,1]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.once=void 0;function m(L){const y=this;let C=!1,i;return function(){return C||(C=!0,i=L.apply(y,arguments)),i}}e.once=m}),define(pe[75],ve([0,1]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.defaultGenerator=e.IdGenerator=void 0;class m{constructor(y){this._prefix=y,this._lastId=0}nextId(){return this._prefix+ ++this._lastId}}e.IdGenerator=m,e.defaultGenerator=new m("id#")}),define(pe[76],ve([0,1]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Iterable=void 0;var m;(function(L){function y(g){return g&&typeof g=="object"&&typeof g[Symbol.iterator]=="function"}L.is=y;const C=Object.freeze([]);function i(){return C}L.empty=i;function*k(g){yield g}L.single=k;function S(g){return g||C}L.from=S;function D(g){return!g||g[Symbol.iterator]().next().done===!0}L.isEmpty=D;function R(g){return g[Symbol.iterator]().next().value}L.first=R;function P(g,a){for(const _ of g)if(a(_))return!0;return!1}L.some=P;function u(g,a){for(const _ of g)if(a(_))return _}L.find=u;function*E(g,a){for(const _ of g)a(_)&&(yield _)}L.filter=E;function*f(g,a){let _=0;for(const n of g)yield a(n,_++)}L.map=f;function*v(...g){for(const a of g)for(const _ of a)yield _}L.concat=v;function*w(g){for(const a of g)for(const _ of a)yield _}L.concatNested=w;function I(g,a,_){let n=_;for(const t of g)n=a(n,t);return n}L.reduce=I;function*p(g,a,_=g.length){for(a<0&&(a+=g.length),_<0?_+=g.length:_>g.length&&(_=g.length);a<_;a++)yield g[a]}L.slice=p;function s(g,a=Number.POSITIVE_INFINITY){const _=[];if(a===0)return[_,g];const n=g[Symbol.iterator]();for(let t=0;t<a;t++){const o=n.next();if(o.done)return[_,L.empty()];_.push(o.value)}return[_,{[Symbol.iterator](){return n}}]}L.consume=s;function r(g,a,_=(n,t)=>n===t){const n=g[Symbol.iterator](),t=a[Symbol.iterator]();for(;;){const o=n.next(),d=t.next();if(o.done!==d.done)return!1;if(o.done)return!0;if(!_(o.value,d.value))return!1}}L.equals=r})(m=e.Iterable||(e.Iterable={}))}),define(pe[58],ve([0,1]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getNodeType=e.stripComments=e.visit=e.findNodeAtOffset=e.contains=e.getNodeValue=e.getNodePath=e.findNodeAtLocation=e.parseTree=e.parse=e.getLocation=e.createScanner=e.ParseOptions=e.ParseErrorCode=e.SyntaxKind=e.ScanError=void 0;var m;(function(a){a[a.None=0]="None",a[a.UnexpectedEndOfComment=1]="UnexpectedEndOfComment",a[a.UnexpectedEndOfString=2]="UnexpectedEndOfString",a[a.UnexpectedEndOfNumber=3]="UnexpectedEndOfNumber",a[a.InvalidUnicode=4]="InvalidUnicode",a[a.InvalidEscapeCharacter=5]="InvalidEscapeCharacter",a[a.InvalidCharacter=6]="InvalidCharacter"})(m=e.ScanError||(e.ScanError={}));var L;(function(a){a[a.OpenBraceToken=1]="OpenBraceToken",a[a.CloseBraceToken=2]="CloseBraceToken",a[a.OpenBracketToken=3]="OpenBracketToken",a[a.CloseBracketToken=4]="CloseBracketToken",a[a.CommaToken=5]="CommaToken",a[a.ColonToken=6]="ColonToken",a[a.NullKeyword=7]="NullKeyword",a[a.TrueKeyword=8]="TrueKeyword",a[a.FalseKeyword=9]="FalseKeyword",a[a.StringLiteral=10]="StringLiteral",a[a.NumericLiteral=11]="NumericLiteral",a[a.LineCommentTrivia=12]="LineCommentTrivia",a[a.BlockCommentTrivia=13]="BlockCommentTrivia",a[a.LineBreakTrivia=14]="LineBreakTrivia",a[a.Trivia=15]="Trivia",a[a.Unknown=16]="Unknown",a[a.EOF=17]="EOF"})(L=e.SyntaxKind||(e.SyntaxKind={}));var y;(function(a){a[a.InvalidSymbol=1]="InvalidSymbol",a[a.InvalidNumberFormat=2]="InvalidNumberFormat",a[a.PropertyNameExpected=3]="PropertyNameExpected",a[a.ValueExpected=4]="ValueExpected",a[a.ColonExpected=5]="ColonExpected",a[a.CommaExpected=6]="CommaExpected",a[a.CloseBraceExpected=7]="CloseBraceExpected",a[a.CloseBracketExpected=8]="CloseBracketExpected",a[a.EndOfFileExpected=9]="EndOfFileExpected",a[a.InvalidCommentToken=10]="InvalidCommentToken",a[a.UnexpectedEndOfComment=11]="UnexpectedEndOfComment",a[a.UnexpectedEndOfString=12]="UnexpectedEndOfString",a[a.UnexpectedEndOfNumber=13]="UnexpectedEndOfNumber",a[a.InvalidUnicode=14]="InvalidUnicode",a[a.InvalidEscapeCharacter=15]="InvalidEscapeCharacter",a[a.InvalidCharacter=16]="InvalidCharacter"})(y=e.ParseErrorCode||(e.ParseErrorCode={}));var C;(function(a){a.DEFAULT={allowTrailingComma:!0}})(C=e.ParseOptions||(e.ParseOptions={}));function i(a,_=!1){let n=0,t=a.length,o="",d=0,c=16,h=0;function l(W){let M=0,B=0;for(;M<W;){const U=a.charCodeAt(n);if(U>=48&&U<=57)B=B*16+U-48;else if(U>=65&&U<=70)B=B*16+U-65+10;else if(U>=97&&U<=102)B=B*16+U-97+10;else break;n++,M++}return M<W&&(B=-1),B}function b(W){n=W,o="",d=0,c=16,h=0}function T(){const W=n;if(a.charCodeAt(n)===48)n++;else for(n++;n<a.length&&D(a.charCodeAt(n));)n++;if(n<a.length&&a.charCodeAt(n)===46)if(n++,n<a.length&&D(a.charCodeAt(n)))for(n++;n<a.length&&D(a.charCodeAt(n));)n++;else return h=3,a.substring(W,n);let M=n;if(n<a.length&&(a.charCodeAt(n)===69||a.charCodeAt(n)===101))if(n++,(n<a.length&&a.charCodeAt(n)===43||a.charCodeAt(n)===45)&&n++,n<a.length&&D(a.charCodeAt(n))){for(n++;n<a.length&&D(a.charCodeAt(n));)n++;M=n}else h=3;return a.substring(W,M)}function A(){let W="",M=n;for(;;){if(n>=t){W+=a.substring(M,n),h=2;break}const B=a.charCodeAt(n);if(B===34){W+=a.substring(M,n),n++;break}if(B===92){if(W+=a.substring(M,n),n++,n>=t){h=2;break}switch(a.charCodeAt(n++)){case 34:W+='"';break;case 92:W+="\\";break;case 47:W+="/";break;case 98:W+="\b";break;case 102:W+="\f";break;case 110:W+=`
`;break;case 114:W+="\r";break;case 116:W+="	";break;case 117:const z=l(4);z>=0?W+=String.fromCharCode(z):h=4;break;default:h=5}M=n;continue}if(B>=0&&B<=31)if(S(B)){W+=a.substring(M,n),h=2;break}else h=6;n++}return W}function x(){if(o="",h=0,d=n,n>=t)return d=t,c=17;let W=a.charCodeAt(n);if(k(W)){do n++,o+=String.fromCharCode(W),W=a.charCodeAt(n);while(k(W));return c=15}if(S(W))return n++,o+=String.fromCharCode(W),W===13&&a.charCodeAt(n)===10&&(n++,o+=`
`),c=14;switch(W){case 123:return n++,c=1;case 125:return n++,c=2;case 91:return n++,c=3;case 93:return n++,c=4;case 58:return n++,c=6;case 44:return n++,c=5;case 34:return n++,o=A(),c=10;case 47:const M=n-1;if(a.charCodeAt(n+1)===47){for(n+=2;n<t&&!S(a.charCodeAt(n));)n++;return o=a.substring(M,n),c=12}if(a.charCodeAt(n+1)===42){n+=2;const B=t-1;let U=!1;for(;n<B;){if(a.charCodeAt(n)===42&&a.charCodeAt(n+1)===47){n+=2,U=!0;break}n++}return U||(n++,h=1),o=a.substring(M,n),c=13}return o+=String.fromCharCode(W),n++,c=16;case 45:if(o+=String.fromCharCode(W),n++,n===t||!D(a.charCodeAt(n)))return c=16;case 48:case 49:case 50:case 51:case 52:case 53:case 54:case 55:case 56:case 57:return o+=T(),c=11;default:for(;n<t&&O(W);)n++,W=a.charCodeAt(n);if(d!==n){switch(o=a.substring(d,n),o){case"true":return c=8;case"false":return c=9;case"null":return c=7}return c=16}return o+=String.fromCharCode(W),n++,c=16}}function O(W){if(k(W)||S(W))return!1;switch(W){case 125:case 93:case 123:case 91:case 34:case 58:case 44:case 47:return!1}return!0}function F(){let W;do W=x();while(W>=12&&W<=15);return W}return{setPosition:b,getPosition:()=>n,scan:_?F:x,getToken:()=>c,getTokenValue:()=>o,getTokenOffset:()=>d,getTokenLength:()=>n-d,getTokenError:()=>h}}e.createScanner=i;function k(a){return a===32||a===9||a===11||a===12||a===160||a===5760||a>=8192&&a<=8203||a===8239||a===8287||a===12288||a===65279}function S(a){return a===10||a===13||a===8232||a===8233}function D(a){return a>=48&&a<=57}var R;(function(a){a[a.nullCharacter=0]="nullCharacter",a[a.maxAsciiCharacter=127]="maxAsciiCharacter",a[a.lineFeed=10]="lineFeed",a[a.carriageReturn=13]="carriageReturn",a[a.lineSeparator=8232]="lineSeparator",a[a.paragraphSeparator=8233]="paragraphSeparator",a[a.nextLine=133]="nextLine",a[a.space=32]="space",a[a.nonBreakingSpace=160]="nonBreakingSpace",a[a.enQuad=8192]="enQuad",a[a.emQuad=8193]="emQuad",a[a.enSpace=8194]="enSpace",a[a.emSpace=8195]="emSpace",a[a.threePerEmSpace=8196]="threePerEmSpace",a[a.fourPerEmSpace=8197]="fourPerEmSpace",a[a.sixPerEmSpace=8198]="sixPerEmSpace",a[a.figureSpace=8199]="figureSpace",a[a.punctuationSpace=8200]="punctuationSpace",a[a.thinSpace=8201]="thinSpace",a[a.hairSpace=8202]="hairSpace",a[a.zeroWidthSpace=8203]="zeroWidthSpace",a[a.narrowNoBreakSpace=8239]="narrowNoBreakSpace",a[a.ideographicSpace=12288]="ideographicSpace",a[a.mathematicalSpace=8287]="mathematicalSpace",a[a.ogham=5760]="ogham",a[a._=95]="_",a[a.$=36]="$",a[a._0=48]="_0",a[a._1=49]="_1",a[a._2=50]="_2",a[a._3=51]="_3",a[a._4=52]="_4",a[a._5=53]="_5",a[a._6=54]="_6",a[a._7=55]="_7",a[a._8=56]="_8",a[a._9=57]="_9",a[a.a=97]="a",a[a.b=98]="b",a[a.c=99]="c",a[a.d=100]="d",a[a.e=101]="e",a[a.f=102]="f",a[a.g=103]="g",a[a.h=104]="h",a[a.i=105]="i",a[a.j=106]="j",a[a.k=107]="k",a[a.l=108]="l",a[a.m=109]="m",a[a.n=110]="n",a[a.o=111]="o",a[a.p=112]="p",a[a.q=113]="q",a[a.r=114]="r",a[a.s=115]="s",a[a.t=116]="t",a[a.u=117]="u",a[a.v=118]="v",a[a.w=119]="w",a[a.x=120]="x",a[a.y=121]="y",a[a.z=122]="z",a[a.A=65]="A",a[a.B=66]="B",a[a.C=67]="C",a[a.D=68]="D",a[a.E=69]="E",a[a.F=70]="F",a[a.G=71]="G",a[a.H=72]="H",a[a.I=73]="I",a[a.J=74]="J",a[a.K=75]="K",a[a.L=76]="L",a[a.M=77]="M",a[a.N=78]="N",a[a.O=79]="O",a[a.P=80]="P",a[a.Q=81]="Q",a[a.R=82]="R",a[a.S=83]="S",a[a.T=84]="T",a[a.U=85]="U",a[a.V=86]="V",a[a.W=87]="W",a[a.X=88]="X",a[a.Y=89]="Y",a[a.Z=90]="Z",a[a.ampersand=38]="ampersand",a[a.asterisk=42]="asterisk",a[a.at=64]="at",a[a.backslash=92]="backslash",a[a.bar=124]="bar",a[a.caret=94]="caret",a[a.closeBrace=125]="closeBrace",a[a.closeBracket=93]="closeBracket",a[a.closeParen=41]="closeParen",a[a.colon=58]="colon",a[a.comma=44]="comma",a[a.dot=46]="dot",a[a.doubleQuote=34]="doubleQuote",a[a.equals=61]="equals",a[a.exclamation=33]="exclamation",a[a.greaterThan=62]="greaterThan",a[a.lessThan=60]="lessThan",a[a.minus=45]="minus",a[a.openBrace=123]="openBrace",a[a.openBracket=91]="openBracket",a[a.openParen=40]="openParen",a[a.percent=37]="percent",a[a.plus=43]="plus",a[a.question=63]="question",a[a.semicolon=59]="semicolon",a[a.singleQuote=39]="singleQuote",a[a.slash=47]="slash",a[a.tilde=126]="tilde",a[a.backspace=8]="backspace",a[a.formFeed=12]="formFeed",a[a.byteOrderMark=65279]="byteOrderMark",a[a.tab=9]="tab",a[a.verticalTab=11]="verticalTab"})(R||(R={}));function P(a,_){const n=[],t=new Object;let o;const d={value:{},offset:0,length:0,type:"object",parent:void 0};let c=!1;function h(l,b,T,A){d.value=l,d.offset=b,d.length=T,d.type=A,d.colonOffset=void 0,o=d}try{s(a,{onObjectBegin:(l,b)=>{if(_<=l)throw t;o=void 0,c=_>l,n.push("")},onObjectProperty:(l,b,T)=>{if(_<b||(h(l,b,T,"property"),n[n.length-1]=l,_<=b+T))throw t},onObjectEnd:(l,b)=>{if(_<=l)throw t;o=void 0,n.pop()},onArrayBegin:(l,b)=>{if(_<=l)throw t;o=void 0,n.push(0)},onArrayEnd:(l,b)=>{if(_<=l)throw t;o=void 0,n.pop()},onLiteralValue:(l,b,T)=>{if(_<b||(h(l,b,T,g(l)),_<=b+T))throw t},onSeparator:(l,b,T)=>{if(_<=b)throw t;if(l===":"&&o&&o.type==="property")o.colonOffset=b,c=!1,o=void 0;else if(l===","){const A=n[n.length-1];typeof A=="number"?n[n.length-1]=A+1:(c=!0,n[n.length-1]=""),o=void 0}}})}catch(l){if(l!==t)throw l}return{path:n,previousNode:o,isAtPropertyKey:c,matches:l=>{let b=0;for(let T=0;b<l.length&&T<n.length;T++)if(l[b]===n[T]||l[b]==="*")b++;else if(l[b]!=="**")return!1;return b===l.length}}}e.getLocation=P;function u(a,_=[],n=C.DEFAULT){let t=null,o=[];const d=[];function c(l){Array.isArray(o)?o.push(l):t!==null&&(o[t]=l)}return s(a,{onObjectBegin:()=>{const l={};c(l),d.push(o),o=l,t=null},onObjectProperty:l=>{t=l},onObjectEnd:()=>{o=d.pop()},onArrayBegin:()=>{const l=[];c(l),d.push(o),o=l,t=null},onArrayEnd:()=>{o=d.pop()},onLiteralValue:c,onError:(l,b,T)=>{_.push({error:l,offset:b,length:T})}},n),o[0]}e.parse=u;function E(a,_=[],n=C.DEFAULT){let t={type:"array",offset:-1,length:-1,children:[],parent:void 0};function o(l){t.type==="property"&&(t.length=l-t.offset,t=t.parent)}function d(l){return t.children.push(l),l}s(a,{onObjectBegin:l=>{t=d({type:"object",offset:l,length:-1,parent:t,children:[]})},onObjectProperty:(l,b,T)=>{t=d({type:"property",offset:b,length:-1,parent:t,children:[]}),t.children.push({type:"string",value:l,offset:b,length:T,parent:t})},onObjectEnd:(l,b)=>{t.length=l+b-t.offset,t=t.parent,o(l+b)},onArrayBegin:(l,b)=>{t=d({type:"array",offset:l,length:-1,parent:t,children:[]})},onArrayEnd:(l,b)=>{t.length=l+b-t.offset,t=t.parent,o(l+b)},onLiteralValue:(l,b,T)=>{d({type:g(l),offset:b,length:T,parent:t,value:l}),o(b+T)},onSeparator:(l,b,T)=>{t.type==="property"&&(l===":"?t.colonOffset=b:l===","&&o(b))},onError:(l,b,T)=>{_.push({error:l,offset:b,length:T})}},n);const h=t.children[0];return h&&delete h.parent,h}e.parseTree=E;function f(a,_){if(!a)return;let n=a;for(let t of _)if(typeof t=="string"){if(n.type!=="object"||!Array.isArray(n.children))return;let o=!1;for(const d of n.children)if(Array.isArray(d.children)&&d.children[0].value===t){n=d.children[1],o=!0;break}if(!o)return}else{const o=t;if(n.type!=="array"||o<0||!Array.isArray(n.children)||o>=n.children.length)return;n=n.children[o]}return n}e.findNodeAtLocation=f;function v(a){if(!a.parent||!a.parent.children)return[];const _=v(a.parent);if(a.parent.type==="property"){const n=a.parent.children[0].value;_.push(n)}else if(a.parent.type==="array"){const n=a.parent.children.indexOf(a);n!==-1&&_.push(n)}return _}e.getNodePath=v;function w(a){switch(a.type){case"array":return a.children.map(w);case"object":const _=Object.create(null);for(let n of a.children){const t=n.children[1];t&&(_[n.children[0].value]=w(t))}return _;case"null":case"string":case"number":case"boolean":return a.value;default:return}}e.getNodeValue=w;function I(a,_,n=!1){return _>=a.offset&&_<a.offset+a.length||n&&_===a.offset+a.length}e.contains=I;function p(a,_,n=!1){if(I(a,_,n)){const t=a.children;if(Array.isArray(t))for(let o=0;o<t.length&&t[o].offset<=_;o++){const d=p(t[o],_,n);if(d)return d}return a}}e.findNodeAtOffset=p;function s(a,_,n=C.DEFAULT){const t=i(a,!1);function o(q){return q?()=>q(t.getTokenOffset(),t.getTokenLength()):()=>!0}function d(q){return q?ne=>q(ne,t.getTokenOffset(),t.getTokenLength()):()=>!0}const c=o(_.onObjectBegin),h=d(_.onObjectProperty),l=o(_.onObjectEnd),b=o(_.onArrayBegin),T=o(_.onArrayEnd),A=d(_.onLiteralValue),x=d(_.onSeparator),O=o(_.onComment),F=d(_.onError),W=n&&n.disallowComments,M=n&&n.allowTrailingComma;function B(){for(;;){const q=t.scan();switch(t.getTokenError()){case 4:U(14);break;case 5:U(15);break;case 3:U(13);break;case 1:W||U(11);break;case 2:U(12);break;case 6:U(16);break}switch(q){case 12:case 13:W?U(10):O();break;case 16:U(1);break;case 15:case 14:break;default:return q}}}function U(q,ne=[],fe=[]){if(F(q),ne.length+fe.length>0){let ye=t.getToken();for(;ye!==17;){if(ne.indexOf(ye)!==-1){B();break}else if(fe.indexOf(ye)!==-1)break;ye=B()}}}function z(q){const ne=t.getTokenValue();return q?A(ne):h(ne),B(),!0}function K(){switch(t.getToken()){case 11:let q=0;try{q=JSON.parse(t.getTokenValue()),typeof q!="number"&&(U(2),q=0)}catch(ne){U(2)}A(q);break;case 7:A(null);break;case 8:A(!0);break;case 9:A(!1);break;default:return!1}return B(),!0}function N(){return t.getToken()!==10?(U(3,[],[2,5]),!1):(z(!1),t.getToken()===6?(x(":"),B(),V()||U(4,[],[2,5])):U(5,[],[2,5]),!0)}function j(){c(),B();let q=!1;for(;t.getToken()!==2&&t.getToken()!==17;){if(t.getToken()===5){if(q||U(4,[],[]),x(","),B(),t.getToken()===2&&M)break}else q&&U(6,[],[]);N()||U(4,[],[2,5]),q=!0}return l(),t.getToken()!==2?U(7,[2],[]):B(),!0}function H(){b(),B();let q=!1;for(;t.getToken()!==4&&t.getToken()!==17;){if(t.getToken()===5){if(q||U(4,[],[]),x(","),B(),t.getToken()===4&&M)break}else q&&U(6,[],[]);V()||U(4,[],[4,5]),q=!0}return T(),t.getToken()!==4?U(8,[4],[]):B(),!0}function V(){switch(t.getToken()){case 3:return H();case 1:return j();case 10:return z(!0);default:return K()}}return B(),t.getToken()===17?n.allowEmptyContent?!0:(U(4,[],[]),!1):V()?(t.getToken()!==17&&U(9,[],[]),!0):(U(4,[],[]),!1)}e.visit=s;function r(a,_){let n=i(a),t=[],o,d=0,c;do switch(c=n.getPosition(),o=n.scan(),o){case 12:case 13:case 17:d!==c&&t.push(a.substring(d,c)),_!==void 0&&t.push(n.getTokenValue().replace(/[^\r\n]/g,_)),d=n.getPosition();break}while(o!==17);return t.join("")}e.stripComments=r;function g(a){switch(typeof a){case"boolean":return"boolean";case"number":return"number";case"string":return"string";case"object":{if(a){if(Array.isArray(a))return"array"}else return"null";return"object"}default:return"null"}}e.getNodeType=g}),define(pe[138],ve([0,1,58]),function(Y,e,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isEOL=e.getEOL=e.format=void 0;function L(S,D,R){let P,u,E,f,v;if(D){for(f=D.offset,v=f+D.length,E=f;E>0&&!k(S,E-1);)E--;let d=v;for(;d<S.length&&!k(S,d);)d++;u=S.substring(E,d),P=C(u,R)}else u=S,P=0,E=0,f=0,v=S.length;const w=i(R,S);let I=!1,p=0,s;R.insertSpaces?s=y(" ",R.tabSize||4):s="	";const r=(0,m.createScanner)(u,!1);let g=!1;function a(){return w+y(s,P+p)}function _(){let d=r.scan();for(I=!1;d===15||d===14;)I=I||d===14,d=r.scan();return g=d===16||r.getTokenError()!==0,d}const n=[];function t(d,c,h){!g&&c<v&&h>f&&S.substring(c,h)!==d&&n.push({offset:c,length:h-c,content:d})}let o=_();if(o!==17){const d=r.getTokenOffset()+E,c=y(s,P);t(c,E,d)}for(;o!==17;){let d=r.getTokenOffset()+r.getTokenLength()+E,c=_(),h="";for(;!I&&(c===12||c===13);){const b=r.getTokenOffset()+E;t(" ",d,b),d=r.getTokenOffset()+r.getTokenLength()+E,h=c===12?a():"",c=_()}if(c===2)o!==1&&(p--,h=a());else if(c===4)o!==3&&(p--,h=a());else{switch(o){case 3:case 1:p++,h=a();break;case 5:case 12:h=a();break;case 13:I?h=a():h=" ";break;case 6:h=" ";break;case 10:if(c===6){h="";break}case 7:case 8:case 9:case 11:case 2:case 4:c===12||c===13?h=" ":c!==5&&c!==17&&(g=!0);break;case 16:g=!0;break}I&&(c===12||c===13)&&(h=a())}const l=r.getTokenOffset()+E;t(h,d,l),o=c}return n}e.format=L;function y(S,D){let R="";for(let P=0;P<D;P++)R+=S;return R}function C(S,D){let R=0,P=0;const u=D.tabSize||4;for(;R<S.length;){const E=S.charAt(R);if(E===" ")P++;else if(E==="	")P+=u;else break;R++}return Math.floor(P/u)}function i(S,D){for(let R=0;R<D.length;R++){const P=D.charAt(R);if(P==="\r")return R+1<D.length&&D.charAt(R+1)===`
`?`\r
`:"\r";if(P===`
`)return`
`}return S&&S.eol||`
`}e.getEOL=i;function k(S,D){return`\r
`.indexOf(S.charAt(D))!==-1}e.isEOL=k}),define(pe[139],ve([0,1,58,138]),function(Y,e,m,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.applyEdits=e.applyEdit=e.withFormatting=e.setProperty=e.removeProperty=void 0;function y(D,R,P){return C(D,R,void 0,P)}e.removeProperty=y;function C(D,R,P,u,E){const f=R.slice(),v=[],w=(0,m.parseTree)(D,v);let I,p;for(;f.length>0&&(p=f.pop(),I=(0,m.findNodeAtLocation)(w,f),I===void 0&&P!==void 0);)typeof p=="string"?P={[p]:P}:P=[P];if(I)if(I.type==="object"&&typeof p=="string"&&Array.isArray(I.children)){const s=(0,m.findNodeAtLocation)(I,[p]);if(s!==void 0)if(P===void 0){if(!s.parent)throw new Error("Malformed AST");const r=I.children.indexOf(s.parent);let g,a=s.parent.offset+s.parent.length;if(r>0){const _=I.children[r-1];g=_.offset+_.length}else g=I.offset+1,I.children.length>1&&(a=I.children[1].offset);return i(D,{offset:g,length:a-g,content:""},u)}else return i(D,{offset:s.offset,length:s.length,content:JSON.stringify(P)},u);else{if(P===void 0)return[];const r=`${JSON.stringify(p)}: ${JSON.stringify(P)}`,g=E?E(I.children.map(_=>_.children[0].value)):I.children.length;let a;if(g>0){const _=I.children[g-1];a={offset:_.offset+_.length,length:0,content:","+r}}else I.children.length===0?a={offset:I.offset+1,length:0,content:r}:a={offset:I.offset+1,length:0,content:r+","};return i(D,a,u)}}else if(I.type==="array"&&typeof p=="number"&&Array.isArray(I.children))if(P!==void 0){const s=`${JSON.stringify(P)}`;let r;if(I.children.length===0||p===0)r={offset:I.offset+1,length:0,content:I.children.length===0?s:s+","};else{const g=p===-1||p>I.children.length?I.children.length:p,a=I.children[g-1];r={offset:a.offset+a.length,length:0,content:","+s}}return i(D,r,u)}else{const s=p,r=I.children[s];let g;if(I.children.length===1)g={offset:I.offset+1,length:I.length-2,content:""};else if(I.children.length-1===s){const a=I.children[s-1],_=a.offset+a.length,n=I.offset+I.length;g={offset:_,length:n-2-_,content:""}}else g={offset:r.offset,length:I.children[s+1].offset-r.offset,content:""};return i(D,g,u)}else throw new Error(`Can not add ${typeof p!="number"?"index":"property"} to parent of type ${I.type}`);else{if(P===void 0)throw new Error("Can not delete in empty document");return i(D,{offset:w?w.offset:0,length:w?w.length:0,content:JSON.stringify(P)},u)}}e.setProperty=C;function i(D,R,P){let u=k(D,R),E=R.offset,f=R.offset+R.content.length;if(R.length===0||R.content.length===0){for(;E>0&&!(0,L.isEOL)(u,E-1);)E--;for(;f<u.length&&!(0,L.isEOL)(u,f);)f++}const v=(0,L.format)(u,{offset:E,length:f-E},P);for(let I=v.length-1;I>=0;I--){const p=v[I];u=k(u,p),E=Math.min(E,p.offset),f=Math.max(f,p.offset+p.length),f+=p.content.length-p.length}const w=D.length-(u.length-f)-E;return[{offset:E,length:w,content:u.substring(E,f)}]}e.withFormatting=i;function k(D,R){return D.substring(0,R.offset)+R.content+D.substring(R.offset+R.length)}e.applyEdit=k;function S(D,R){let P=R.slice(0).sort((E,f)=>{const v=E.offset-f.offset;return v===0?E.length-f.length:v}),u=D.length;for(let E=P.length-1;E>=0;E--){let f=P[E];if(f.offset+f.length<=u)D=k(D,f);else throw new Error("Overlapping edit");u=f.offset}return D}e.applyEdits=S}),define(pe[140],ve([0,1]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Lazy=void 0;class m{constructor(y){this.executor=y,this._didRun=!1}hasValue(){return this._didRun}getValue(){if(!this._didRun)try{this._value=this.executor()}catch(y){this._error=y}finally{this._didRun=!0}if(this._error)throw this._error;return this._value}get rawValue(){return this._value}map(y){return new m(()=>y(this.getValue()))}}e.Lazy=m}),define(pe[6],ve([0,1,74,76]),function(Y,e,m,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.disposeOnReturn=e.ImmortalReference=e.AsyncReferenceCollection=e.ReferenceCollection=e.RefCountedDisposable=e.MutableDisposable=e.Disposable=e.DisposableStore=e.toDisposable=e.combinedDisposable=e.dispose=e.isDisposable=e.MultiDisposeError=e.markAsSingleton=e.setDisposableTracker=void 0;const y=!1;let C=null;function i(t){C=t}if(e.setDisposableTracker=i,y){const t="__is_disposable_tracked__";i(new class{trackDisposable(o){const d=new Error("Potentially leaked disposable").stack;setTimeout(()=>{o[t]||console.log(d)},3e3)}setParent(o,d){if(o&&o!==p.None)try{o[t]=!0}catch{}}markAsDisposed(o){if(o&&o!==p.None)try{o[t]=!0}catch{}}markAsSingleton(o){}})}function k(t){return C?.trackDisposable(t),t}function S(t){C?.markAsDisposed(t)}function D(t,o){C?.setParent(t,o)}function R(t,o){if(!!C)for(const d of t)C.setParent(d,o)}function P(t){return C?.markAsSingleton(t),t}e.markAsSingleton=P;class u extends Error{constructor(o){super(`Encountered errors while disposing of store. Errors: [${o.join(", ")}]`);this.errors=o}}e.MultiDisposeError=u;function E(t){return typeof t.dispose=="function"&&t.dispose.length===0}e.isDisposable=E;function f(t){if(L.Iterable.is(t)){let o=[];for(const d of t)if(d)try{d.dispose()}catch(c){o.push(c)}if(o.length===1)throw o[0];if(o.length>1)throw new u(o);return Array.isArray(t)?[]:t}else if(t)return t.dispose(),t}e.dispose=f;function v(...t){const o=w(()=>f(t));return R(t,o),o}e.combinedDisposable=v;function w(t){const o=k({dispose:(0,m.once)(()=>{S(o),t()})});return o}e.toDisposable=w;class I{constructor(){this._toDispose=new Set,this._isDisposed=!1,k(this)}dispose(){this._isDisposed||(S(this),this._isDisposed=!0,this.clear())}clear(){try{f(this._toDispose.values())}finally{this._toDispose.clear()}}add(o){if(!o)return o;if(o===this)throw new Error("Cannot register a disposable on itself!");return D(o,this),this._isDisposed?I.DISABLE_DISPOSED_WARNING||console.warn(new Error("Trying to add a disposable to a DisposableStore that has already been disposed of. The added object will be leaked!").stack):this._toDispose.add(o),o}}e.DisposableStore=I,I.DISABLE_DISPOSED_WARNING=!1;class p{constructor(){this._store=new I,k(this),D(this._store,this)}dispose(){S(this),this._store.dispose()}_register(o){if(o===this)throw new Error("Cannot register a disposable on itself!");return this._store.add(o)}}e.Disposable=p,p.None=Object.freeze({dispose(){}});class s{constructor(){this._isDisposed=!1,k(this)}get value(){return this._isDisposed?void 0:this._value}set value(o){this._isDisposed||o===this._value||(this._value?.dispose(),o&&D(o,this),this._value=o)}clear(){this.value=void 0}dispose(){this._isDisposed=!0,S(this),this._value?.dispose(),this._value=void 0}clearAndLeak(){const o=this._value;return this._value=void 0,o&&D(o,null),o}}e.MutableDisposable=s;class r{constructor(o){this._disposable=o,this._counter=1}acquire(){return this._counter++,this}release(){return--this._counter==0&&this._disposable.dispose(),this}}e.RefCountedDisposable=r;class g{constructor(){this.references=new Map}acquire(o,...d){let c=this.references.get(o);c||(c={counter:0,object:this.createReferencedObject(o,...d)},this.references.set(o,c));const{object:h}=c,l=(0,m.once)(()=>{--c.counter==0&&(this.destroyReferencedObject(o,c.object),this.references.delete(o))});return c.counter++,{object:h,dispose:l}}}e.ReferenceCollection=g;class a{constructor(o){this.referenceCollection=o}async acquire(o,...d){const c=this.referenceCollection.acquire(o,...d);try{return{object:await c.object,dispose:()=>c.dispose()}}catch(h){throw c.dispose(),h}}}e.AsyncReferenceCollection=a;class _{constructor(o){this.object=o}dispose(){}}e.ImmortalReference=_;function n(t){const o=new I;try{t(o)}finally{o.dispose()}}e.disposeOnReturn=n}),define(pe[93],ve([0,1]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LinkedList=void 0;class m{constructor(C){this.element=C,this.next=m.Undefined,this.prev=m.Undefined}}m.Undefined=new m(void 0);class L{constructor(){this._first=m.Undefined,this._last=m.Undefined,this._size=0}get size(){return this._size}isEmpty(){return this._first===m.Undefined}clear(){let C=this._first;for(;C!==m.Undefined;){const i=C.next;C.prev=m.Undefined,C.next=m.Undefined,C=i}this._first=m.Undefined,this._last=m.Undefined,this._size=0}unshift(C){return this._insert(C,!1)}push(C){return this._insert(C,!0)}_insert(C,i){const k=new m(C);if(this._first===m.Undefined)this._first=k,this._last=k;else if(i){const D=this._last;this._last=k,k.prev=D,D.next=k}else{const D=this._first;this._first=k,k.next=D,D.prev=k}this._size+=1;let S=!1;return()=>{S||(S=!0,this._remove(k))}}shift(){if(this._first!==m.Undefined){const C=this._first.element;return this._remove(this._first),C}}pop(){if(this._last!==m.Undefined){const C=this._last.element;return this._remove(this._last),C}}_remove(C){if(C.prev!==m.Undefined&&C.next!==m.Undefined){const i=C.prev;i.next=C.next,C.next.prev=i}else C.prev===m.Undefined&&C.next===m.Undefined?(this._first=m.Undefined,this._last=m.Undefined):C.next===m.Undefined?(this._last=this._last.prev,this._last.next=m.Undefined):C.prev===m.Undefined&&(this._first=this._first.next,this._first.prev=m.Undefined);this._size-=1}*[Symbol.iterator](){let C=this._first;for(;C!==m.Undefined;)yield C.element,C=C.next}}e.LinkedList=L}),function(Y,e){typeof exports=="object"&&typeof module!="undefined"?module.exports=e():typeof define=="function"&&define.amd?define("vs/base/common/marked/marked",e):(Y=typeof globalThis!="undefined"?globalThis:Y||self,Y.marked=e())}(this,function(){"use strict";function Y(Te,Ie){for(var Se=0;Se<Ie.length;Se++){var le=Ie[Se];le.enumerable=le.enumerable||!1,le.configurable=!0,"value"in le&&(le.writable=!0),Object.defineProperty(Te,le.key,le)}}function e(Te,Ie,Se){return Ie&&Y(Te.prototype,Ie),Se&&Y(Te,Se),Te}function m(Te,Ie){if(!!Te){if(typeof Te=="string")return L(Te,Ie);var Se=Object.prototype.toString.call(Te).slice(8,-1);if(Se==="Object"&&Te.constructor&&(Se=Te.constructor.name),Se==="Map"||Se==="Set")return Array.from(Te);if(Se==="Arguments"||/^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(Se))return L(Te,Ie)}}function L(Te,Ie){(Ie==null||Ie>Te.length)&&(Ie=Te.length);for(var Se=0,le=new Array(Ie);Se<Ie;Se++)le[Se]=Te[Se];return le}function y(Te,Ie){var Se=typeof Symbol!="undefined"&&Te[Symbol.iterator]||Te["@@iterator"];if(Se)return(Se=Se.call(Te)).next.bind(Se);if(Array.isArray(Te)||(Se=m(Te))||Ie&&Te&&typeof Te.length=="number"){Se&&(Te=Se);var le=0;return function(){return le>=Te.length?{done:!0}:{done:!1,value:Te[le++]}}}throw new TypeError(`Invalid attempt to iterate non-iterable instance.
In order to be iterable, non-array objects must have a [Symbol.iterator]() method.`)}var C={exports:{}};function i(){return{baseUrl:null,breaks:!1,extensions:null,gfm:!0,headerIds:!0,headerPrefix:"",highlight:null,langPrefix:"language-",mangle:!0,pedantic:!1,renderer:null,sanitize:!1,sanitizer:null,silent:!1,smartLists:!1,smartypants:!1,tokenizer:null,walkTokens:null,xhtml:!1}}function k(Te){C.exports.defaults=Te}C.exports={defaults:i(),getDefaults:i,changeDefaults:k};var S=/[&<>"']/,D=/[&<>"']/g,R=/[<>"']|&(?!#?\w+;)/,P=/[<>"']|&(?!#?\w+;)/g,u={"&":"&amp;","<":"&lt;",">":"&gt;",'"':"&quot;","'":"&#39;"},E=function(Ie){return u[Ie]};function f(Te,Ie){if(Ie){if(S.test(Te))return Te.replace(D,E)}else if(R.test(Te))return Te.replace(P,E);return Te}var v=/&(#(?:\d+)|(?:#x[0-9A-Fa-f]+)|(?:\w+));?/ig;function w(Te){return Te.replace(v,function(Ie,Se){return Se=Se.toLowerCase(),Se==="colon"?":":Se.charAt(0)==="#"?Se.charAt(1)==="x"?String.fromCharCode(parseInt(Se.substring(2),16)):String.fromCharCode(+Se.substring(1)):""})}var I=/(^|[^\[])\^/g;function p(Te,Ie){Te=Te.source||Te,Ie=Ie||"";var Se={replace:function(ue,we){return we=we.source||we,we=we.replace(I,"$1"),Te=Te.replace(ue,we),Se},getRegex:function(){return new RegExp(Te,Ie)}};return Se}var s=/[^\w:]/g,r=/^$|^[a-z][a-z0-9+.-]*:|^[?#]/i;function g(Te,Ie,Se){if(Te){var le;try{le=decodeURIComponent(w(Se)).replace(s,"").toLowerCase()}catch(ue){return null}if(le.indexOf("javascript:")===0||le.indexOf("vbscript:")===0||le.indexOf("data:")===0)return null}Ie&&!r.test(Se)&&(Se=o(Ie,Se));try{Se=encodeURI(Se).replace(/%25/g,"%")}catch(ue){return null}return Se}var a={},_=/^[^:]+:\/*[^/]*$/,n=/^([^:]+:)[\s\S]*$/,t=/^([^:]+:\/*[^/]*)[\s\S]*$/;function o(Te,Ie){a[" "+Te]||(_.test(Te)?a[" "+Te]=Te+"/":a[" "+Te]=l(Te,"/",!0)),Te=a[" "+Te];var Se=Te.indexOf(":")===-1;return Ie.substring(0,2)==="//"?Se?Ie:Te.replace(n,"$1")+Ie:Ie.charAt(0)==="/"?Se?Ie:Te.replace(t,"$1")+Ie:Te+Ie}var d={exec:function(){}};function c(Te){for(var Ie=1,Se,le;Ie<arguments.length;Ie++){Se=arguments[Ie];for(le in Se)Object.prototype.hasOwnProperty.call(Se,le)&&(Te[le]=Se[le])}return Te}function h(Te,Ie){var Se=Te.replace(/\|/g,function(we,_e,Fe){for(var Ke=!1,$e=_e;--$e>=0&&Fe[$e]==="\\";)Ke=!Ke;return Ke?"|":" |"}),le=Se.split(/ \|/),ue=0;if(le[0].trim()||le.shift(),le[le.length-1].trim()||le.pop(),le.length>Ie)le.splice(Ie);else for(;le.length<Ie;)le.push("");for(;ue<le.length;ue++)le[ue]=le[ue].trim().replace(/\\\|/g,"|");return le}function l(Te,Ie,Se){var le=Te.length;if(le===0)return"";for(var ue=0;ue<le;){var we=Te.charAt(le-ue-1);if(we===Ie&&!Se)ue++;else if(we!==Ie&&Se)ue++;else break}return Te.substr(0,le-ue)}function b(Te,Ie){if(Te.indexOf(Ie[1])===-1)return-1;for(var Se=Te.length,le=0,ue=0;ue<Se;ue++)if(Te[ue]==="\\")ue++;else if(Te[ue]===Ie[0])le++;else if(Te[ue]===Ie[1]&&(le--,le<0))return ue;return-1}function T(Te){Te&&Te.sanitize&&!Te.silent&&console.warn("marked(): sanitize and sanitizer parameters are deprecated since version 0.7.0, should not be used and will be removed in the future. Read more here: https://marked.js.org/#/USING_ADVANCED.md#options")}function A(Te,Ie){if(Ie<1)return"";for(var Se="";Ie>1;)Ie&1&&(Se+=Te),Ie>>=1,Te+=Te;return Se+Te}var x={escape:f,unescape:w,edit:p,cleanUrl:g,resolveUrl:o,noopTest:d,merge:c,splitCells:h,rtrim:l,findClosingBracket:b,checkSanitizeDeprecation:T,repeatString:A},O=C.exports.defaults,F=x.rtrim,W=x.splitCells,M=x.escape,B=x.findClosingBracket;function U(Te,Ie,Se,le){var ue=Ie.href,we=Ie.title?M(Ie.title):null,_e=Te[1].replace(/\\([\[\]])/g,"$1");if(Te[0].charAt(0)!=="!"){le.state.inLink=!0;var Fe={type:"link",raw:Se,href:ue,title:we,text:_e,tokens:le.inlineTokens(_e,[])};return le.state.inLink=!1,Fe}else return{type:"image",raw:Se,href:ue,title:we,text:M(_e)}}function z(Te,Ie){var Se=Te.match(/^(\s+)(?:```)/);if(Se===null)return Ie;var le=Se[1];return Ie.split(`
`).map(function(ue){var we=ue.match(/^\s+/);if(we===null)return ue;var _e=we[0];return _e.length>=le.length?ue.slice(le.length):ue}).join(`
`)}var K=function(){function Te(Se){this.options=Se||O}var Ie=Te.prototype;return Ie.space=function(le){var ue=this.rules.block.newline.exec(le);if(ue)return ue[0].length>1?{type:"space",raw:ue[0]}:{raw:`
`}},Ie.code=function(le){var ue=this.rules.block.code.exec(le);if(ue){var we=ue[0].replace(/^ {1,4}/gm,"");return{type:"code",raw:ue[0],codeBlockStyle:"indented",text:this.options.pedantic?we:F(we,`
`)}}},Ie.fences=function(le){var ue=this.rules.block.fences.exec(le);if(ue){var we=ue[0],_e=z(we,ue[3]||"");return{type:"code",raw:we,lang:ue[2]?ue[2].trim():ue[2],text:_e}}},Ie.heading=function(le){var ue=this.rules.block.heading.exec(le);if(ue){var we=ue[2].trim();if(/#$/.test(we)){var _e=F(we,"#");(this.options.pedantic||!_e||/ $/.test(_e))&&(we=_e.trim())}var Fe={type:"heading",raw:ue[0],depth:ue[1].length,text:we,tokens:[]};return this.lexer.inline(Fe.text,Fe.tokens),Fe}},Ie.hr=function(le){var ue=this.rules.block.hr.exec(le);if(ue)return{type:"hr",raw:ue[0]}},Ie.blockquote=function(le){var ue=this.rules.block.blockquote.exec(le);if(ue){var we=ue[0].replace(/^ *> ?/gm,"");return{type:"blockquote",raw:ue[0],tokens:this.lexer.blockTokens(we,[]),text:we}}},Ie.list=function(le){var ue=this.rules.block.list.exec(le);if(ue){var we,_e,Fe,Ke,$e,Qe,st,at,de,Ce,ce=ue[1].trim(),X=ce.length>1,De={type:"list",raw:"",ordered:X,start:X?+ce.slice(0,-1):"",loose:!1,items:[]};ce=X?"\\d{1,9}\\"+ce.slice(-1):"\\"+ce,this.options.pedantic&&(ce=X?ce:"[*+-]");for(var Re=new RegExp("^( {0,3}"+ce+")((?: [^\\n]*| *)(?:\\n[^\\n]*)*(?:\\n|$))");le&&!(this.rules.block.hr.test(le)||!(ue=Re.exec(le)));){de=ue[2].split(`
`),this.options.pedantic?(Ke=2,Ce=de[0].trimLeft()):(Ke=ue[2].search(/[^ ]/),Ke=ue[1].length+(Ke>4?1:Ke),Ce=de[0].slice(Ke-ue[1].length)),Qe=!1,we=ue[0],!de[0]&&/^ *$/.test(de[1])&&(we=ue[1]+de.slice(0,2).join(`
`)+`
`,De.loose=!0,de=[]);var Ze=new RegExp("^ {0,"+Math.min(3,Ke-1)+"}(?:[*+-]|\\d{1,9}[.)])");for($e=1;$e<de.length;$e++){if(at=de[$e],this.options.pedantic&&(at=at.replace(/^ {1,4}(?=( {4})*[^ ])/g,"  ")),Ze.test(at)){we=ue[1]+de.slice(0,$e).join(`
`)+`
`;break}if(!Qe){at.trim()||(Qe=!0),at.search(/[^ ]/)>=Ke?Ce+=`
`+at.slice(Ke):Ce+=`
`+at;continue}if(at.search(/[^ ]/)>=Ke||!at.trim()){Ce+=`
`+at.slice(Ke);continue}else{we=ue[1]+de.slice(0,$e).join(`
`)+`
`;break}}De.loose||(st?De.loose=!0:/\n *\n *$/.test(we)&&(st=!0)),this.options.gfm&&(_e=/^\[[ xX]\] /.exec(Ce),_e&&(Fe=_e[0]!=="[ ] ",Ce=Ce.replace(/^\[[ xX]\] +/,""))),De.items.push({type:"list_item",raw:we,task:!!_e,checked:Fe,loose:!1,text:Ce}),De.raw+=we,le=le.slice(we.length)}De.items[De.items.length-1].raw=we.trimRight(),De.items[De.items.length-1].text=Ce.trimRight(),De.raw=De.raw.trimRight();var qe=De.items.length;for($e=0;$e<qe;$e++)this.lexer.state.top=!1,De.items[$e].tokens=this.lexer.blockTokens(De.items[$e].text,[]),De.items[$e].tokens.some(function(dt){return dt.type==="space"})&&(De.loose=!0,De.items[$e].loose=!0);return De}},Ie.html=function(le){var ue=this.rules.block.html.exec(le);if(ue){var we={type:"html",raw:ue[0],pre:!this.options.sanitizer&&(ue[1]==="pre"||ue[1]==="script"||ue[1]==="style"),text:ue[0]};return this.options.sanitize&&(we.type="paragraph",we.text=this.options.sanitizer?this.options.sanitizer(ue[0]):M(ue[0]),we.tokens=[],this.lexer.inline(we.text,we.tokens)),we}},Ie.def=function(le){var ue=this.rules.block.def.exec(le);if(ue){ue[3]&&(ue[3]=ue[3].substring(1,ue[3].length-1));var we=ue[1].toLowerCase().replace(/\s+/g," ");return{type:"def",tag:we,raw:ue[0],href:ue[2],title:ue[3]}}},Ie.table=function(le){var ue=this.rules.block.table.exec(le);if(ue){var we={type:"table",header:W(ue[1]).map(function(st){return{text:st}}),align:ue[2].replace(/^ *|\| *$/g,"").split(/ *\| */),rows:ue[3]?ue[3].replace(/\n$/,"").split(`
`):[]};if(we.header.length===we.align.length){we.raw=ue[0];var _e=we.align.length,Fe,Ke,$e,Qe;for(Fe=0;Fe<_e;Fe++)/^ *-+: *$/.test(we.align[Fe])?we.align[Fe]="right":/^ *:-+: *$/.test(we.align[Fe])?we.align[Fe]="center":/^ *:-+ *$/.test(we.align[Fe])?we.align[Fe]="left":we.align[Fe]=null;for(_e=we.rows.length,Fe=0;Fe<_e;Fe++)we.rows[Fe]=W(we.rows[Fe],we.header.length).map(function(st){return{text:st}});for(_e=we.header.length,Ke=0;Ke<_e;Ke++)we.header[Ke].tokens=[],this.lexer.inlineTokens(we.header[Ke].text,we.header[Ke].tokens);for(_e=we.rows.length,Ke=0;Ke<_e;Ke++)for(Qe=we.rows[Ke],$e=0;$e<Qe.length;$e++)Qe[$e].tokens=[],this.lexer.inlineTokens(Qe[$e].text,Qe[$e].tokens);return we}}},Ie.lheading=function(le){var ue=this.rules.block.lheading.exec(le);if(ue){var we={type:"heading",raw:ue[0],depth:ue[2].charAt(0)==="="?1:2,text:ue[1],tokens:[]};return this.lexer.inline(we.text,we.tokens),we}},Ie.paragraph=function(le){var ue=this.rules.block.paragraph.exec(le);if(ue){var we={type:"paragraph",raw:ue[0],text:ue[1].charAt(ue[1].length-1)===`
`?ue[1].slice(0,-1):ue[1],tokens:[]};return this.lexer.inline(we.text,we.tokens),we}},Ie.text=function(le){var ue=this.rules.block.text.exec(le);if(ue){var we={type:"text",raw:ue[0],text:ue[0],tokens:[]};return this.lexer.inline(we.text,we.tokens),we}},Ie.escape=function(le){var ue=this.rules.inline.escape.exec(le);if(ue)return{type:"escape",raw:ue[0],text:M(ue[1])}},Ie.tag=function(le){var ue=this.rules.inline.tag.exec(le);if(ue)return!this.lexer.state.inLink&&/^<a /i.test(ue[0])?this.lexer.state.inLink=!0:this.lexer.state.inLink&&/^<\/a>/i.test(ue[0])&&(this.lexer.state.inLink=!1),!this.lexer.state.inRawBlock&&/^<(pre|code|kbd|script)(\s|>)/i.test(ue[0])?this.lexer.state.inRawBlock=!0:this.lexer.state.inRawBlock&&/^<\/(pre|code|kbd|script)(\s|>)/i.test(ue[0])&&(this.lexer.state.inRawBlock=!1),{type:this.options.sanitize?"text":"html",raw:ue[0],inLink:this.lexer.state.inLink,inRawBlock:this.lexer.state.inRawBlock,text:this.options.sanitize?this.options.sanitizer?this.options.sanitizer(ue[0]):M(ue[0]):ue[0]}},Ie.link=function(le){var ue=this.rules.inline.link.exec(le);if(ue){var we=ue[2].trim();if(!this.options.pedantic&&/^</.test(we)){if(!/>$/.test(we))return;var _e=F(we.slice(0,-1),"\\");if((we.length-_e.length)%2==0)return}else{var Fe=B(ue[2],"()");if(Fe>-1){var Ke=ue[0].indexOf("!")===0?5:4,$e=Ke+ue[1].length+Fe;ue[2]=ue[2].substring(0,Fe),ue[0]=ue[0].substring(0,$e).trim(),ue[3]=""}}var Qe=ue[2],st="";if(this.options.pedantic){var at=/^([^'"]*[^\s])\s+(['"])(.*)\2/.exec(Qe);at&&(Qe=at[1],st=at[3])}else st=ue[3]?ue[3].slice(1,-1):"";return Qe=Qe.trim(),/^</.test(Qe)&&(this.options.pedantic&&!/>$/.test(we)?Qe=Qe.slice(1):Qe=Qe.slice(1,-1)),U(ue,{href:Qe&&Qe.replace(this.rules.inline._escapes,"$1"),title:st&&st.replace(this.rules.inline._escapes,"$1")},ue[0],this.lexer)}},Ie.reflink=function(le,ue){var we;if((we=this.rules.inline.reflink.exec(le))||(we=this.rules.inline.nolink.exec(le))){var _e=(we[2]||we[1]).replace(/\s+/g," ");if(_e=ue[_e.toLowerCase()],!_e||!_e.href){var Fe=we[0].charAt(0);return{type:"text",raw:Fe,text:Fe}}return U(we,_e,we[0],this.lexer)}},Ie.emStrong=function(le,ue,we){we===void 0&&(we="");var _e=this.rules.inline.emStrong.lDelim.exec(le);if(!!_e&&!(_e[3]&&we.match(/(?:[0-9A-Za-z\xAA\xB2\xB3\xB5\xB9\xBA\xBC-\xBE\xC0-\xD6\xD8-\xF6\xF8-\u02C1\u02C6-\u02D1\u02E0-\u02E4\u02EC\u02EE\u0370-\u0374\u0376\u0377\u037A-\u037D\u037F\u0386\u0388-\u038A\u038C\u038E-\u03A1\u03A3-\u03F5\u03F7-\u0481\u048A-\u052F\u0531-\u0556\u0559\u0560-\u0588\u05D0-\u05EA\u05EF-\u05F2\u0620-\u064A\u0660-\u0669\u066E\u066F\u0671-\u06D3\u06D5\u06E5\u06E6\u06EE-\u06FC\u06FF\u0710\u0712-\u072F\u074D-\u07A5\u07B1\u07C0-\u07EA\u07F4\u07F5\u07FA\u0800-\u0815\u081A\u0824\u0828\u0840-\u0858\u0860-\u086A\u08A0-\u08B4\u08B6-\u08C7\u0904-\u0939\u093D\u0950\u0958-\u0961\u0966-\u096F\u0971-\u0980\u0985-\u098C\u098F\u0990\u0993-\u09A8\u09AA-\u09B0\u09B2\u09B6-\u09B9\u09BD\u09CE\u09DC\u09DD\u09DF-\u09E1\u09E6-\u09F1\u09F4-\u09F9\u09FC\u0A05-\u0A0A\u0A0F\u0A10\u0A13-\u0A28\u0A2A-\u0A30\u0A32\u0A33\u0A35\u0A36\u0A38\u0A39\u0A59-\u0A5C\u0A5E\u0A66-\u0A6F\u0A72-\u0A74\u0A85-\u0A8D\u0A8F-\u0A91\u0A93-\u0AA8\u0AAA-\u0AB0\u0AB2\u0AB3\u0AB5-\u0AB9\u0ABD\u0AD0\u0AE0\u0AE1\u0AE6-\u0AEF\u0AF9\u0B05-\u0B0C\u0B0F\u0B10\u0B13-\u0B28\u0B2A-\u0B30\u0B32\u0B33\u0B35-\u0B39\u0B3D\u0B5C\u0B5D\u0B5F-\u0B61\u0B66-\u0B6F\u0B71-\u0B77\u0B83\u0B85-\u0B8A\u0B8E-\u0B90\u0B92-\u0B95\u0B99\u0B9A\u0B9C\u0B9E\u0B9F\u0BA3\u0BA4\u0BA8-\u0BAA\u0BAE-\u0BB9\u0BD0\u0BE6-\u0BF2\u0C05-\u0C0C\u0C0E-\u0C10\u0C12-\u0C28\u0C2A-\u0C39\u0C3D\u0C58-\u0C5A\u0C60\u0C61\u0C66-\u0C6F\u0C78-\u0C7E\u0C80\u0C85-\u0C8C\u0C8E-\u0C90\u0C92-\u0CA8\u0CAA-\u0CB3\u0CB5-\u0CB9\u0CBD\u0CDE\u0CE0\u0CE1\u0CE6-\u0CEF\u0CF1\u0CF2\u0D04-\u0D0C\u0D0E-\u0D10\u0D12-\u0D3A\u0D3D\u0D4E\u0D54-\u0D56\u0D58-\u0D61\u0D66-\u0D78\u0D7A-\u0D7F\u0D85-\u0D96\u0D9A-\u0DB1\u0DB3-\u0DBB\u0DBD\u0DC0-\u0DC6\u0DE6-\u0DEF\u0E01-\u0E30\u0E32\u0E33\u0E40-\u0E46\u0E50-\u0E59\u0E81\u0E82\u0E84\u0E86-\u0E8A\u0E8C-\u0EA3\u0EA5\u0EA7-\u0EB0\u0EB2\u0EB3\u0EBD\u0EC0-\u0EC4\u0EC6\u0ED0-\u0ED9\u0EDC-\u0EDF\u0F00\u0F20-\u0F33\u0F40-\u0F47\u0F49-\u0F6C\u0F88-\u0F8C\u1000-\u102A\u103F-\u1049\u1050-\u1055\u105A-\u105D\u1061\u1065\u1066\u106E-\u1070\u1075-\u1081\u108E\u1090-\u1099\u10A0-\u10C5\u10C7\u10CD\u10D0-\u10FA\u10FC-\u1248\u124A-\u124D\u1250-\u1256\u1258\u125A-\u125D\u1260-\u1288\u128A-\u128D\u1290-\u12B0\u12B2-\u12B5\u12B8-\u12BE\u12C0\u12C2-\u12C5\u12C8-\u12D6\u12D8-\u1310\u1312-\u1315\u1318-\u135A\u1369-\u137C\u1380-\u138F\u13A0-\u13F5\u13F8-\u13FD\u1401-\u166C\u166F-\u167F\u1681-\u169A\u16A0-\u16EA\u16EE-\u16F8\u1700-\u170C\u170E-\u1711\u1720-\u1731\u1740-\u1751\u1760-\u176C\u176E-\u1770\u1780-\u17B3\u17D7\u17DC\u17E0-\u17E9\u17F0-\u17F9\u1810-\u1819\u1820-\u1878\u1880-\u1884\u1887-\u18A8\u18AA\u18B0-\u18F5\u1900-\u191E\u1946-\u196D\u1970-\u1974\u1980-\u19AB\u19B0-\u19C9\u19D0-\u19DA\u1A00-\u1A16\u1A20-\u1A54\u1A80-\u1A89\u1A90-\u1A99\u1AA7\u1B05-\u1B33\u1B45-\u1B4B\u1B50-\u1B59\u1B83-\u1BA0\u1BAE-\u1BE5\u1C00-\u1C23\u1C40-\u1C49\u1C4D-\u1C7D\u1C80-\u1C88\u1C90-\u1CBA\u1CBD-\u1CBF\u1CE9-\u1CEC\u1CEE-\u1CF3\u1CF5\u1CF6\u1CFA\u1D00-\u1DBF\u1E00-\u1F15\u1F18-\u1F1D\u1F20-\u1F45\u1F48-\u1F4D\u1F50-\u1F57\u1F59\u1F5B\u1F5D\u1F5F-\u1F7D\u1F80-\u1FB4\u1FB6-\u1FBC\u1FBE\u1FC2-\u1FC4\u1FC6-\u1FCC\u1FD0-\u1FD3\u1FD6-\u1FDB\u1FE0-\u1FEC\u1FF2-\u1FF4\u1FF6-\u1FFC\u2070\u2071\u2074-\u2079\u207F-\u2089\u2090-\u209C\u2102\u2107\u210A-\u2113\u2115\u2119-\u211D\u2124\u2126\u2128\u212A-\u212D\u212F-\u2139\u213C-\u213F\u2145-\u2149\u214E\u2150-\u2189\u2460-\u249B\u24EA-\u24FF\u2776-\u2793\u2C00-\u2C2E\u2C30-\u2C5E\u2C60-\u2CE4\u2CEB-\u2CEE\u2CF2\u2CF3\u2CFD\u2D00-\u2D25\u2D27\u2D2D\u2D30-\u2D67\u2D6F\u2D80-\u2D96\u2DA0-\u2DA6\u2DA8-\u2DAE\u2DB0-\u2DB6\u2DB8-\u2DBE\u2DC0-\u2DC6\u2DC8-\u2DCE\u2DD0-\u2DD6\u2DD8-\u2DDE\u2E2F\u3005-\u3007\u3021-\u3029\u3031-\u3035\u3038-\u303C\u3041-\u3096\u309D-\u309F\u30A1-\u30FA\u30FC-\u30FF\u3105-\u312F\u3131-\u318E\u3192-\u3195\u31A0-\u31BF\u31F0-\u31FF\u3220-\u3229\u3248-\u324F\u3251-\u325F\u3280-\u3289\u32B1-\u32BF\u3400-\u4DBF\u4E00-\u9FFC\uA000-\uA48C\uA4D0-\uA4FD\uA500-\uA60C\uA610-\uA62B\uA640-\uA66E\uA67F-\uA69D\uA6A0-\uA6EF\uA717-\uA71F\uA722-\uA788\uA78B-\uA7BF\uA7C2-\uA7CA\uA7F5-\uA801\uA803-\uA805\uA807-\uA80A\uA80C-\uA822\uA830-\uA835\uA840-\uA873\uA882-\uA8B3\uA8D0-\uA8D9\uA8F2-\uA8F7\uA8FB\uA8FD\uA8FE\uA900-\uA925\uA930-\uA946\uA960-\uA97C\uA984-\uA9B2\uA9CF-\uA9D9\uA9E0-\uA9E4\uA9E6-\uA9FE\uAA00-\uAA28\uAA40-\uAA42\uAA44-\uAA4B\uAA50-\uAA59\uAA60-\uAA76\uAA7A\uAA7E-\uAAAF\uAAB1\uAAB5\uAAB6\uAAB9-\uAABD\uAAC0\uAAC2\uAADB-\uAADD\uAAE0-\uAAEA\uAAF2-\uAAF4\uAB01-\uAB06\uAB09-\uAB0E\uAB11-\uAB16\uAB20-\uAB26\uAB28-\uAB2E\uAB30-\uAB5A\uAB5C-\uAB69\uAB70-\uABE2\uABF0-\uABF9\uAC00-\uD7A3\uD7B0-\uD7C6\uD7CB-\uD7FB\uF900-\uFA6D\uFA70-\uFAD9\uFB00-\uFB06\uFB13-\uFB17\uFB1D\uFB1F-\uFB28\uFB2A-\uFB36\uFB38-\uFB3C\uFB3E\uFB40\uFB41\uFB43\uFB44\uFB46-\uFBB1\uFBD3-\uFD3D\uFD50-\uFD8F\uFD92-\uFDC7\uFDF0-\uFDFB\uFE70-\uFE74\uFE76-\uFEFC\uFF10-\uFF19\uFF21-\uFF3A\uFF41-\uFF5A\uFF66-\uFFBE\uFFC2-\uFFC7\uFFCA-\uFFCF\uFFD2-\uFFD7\uFFDA-\uFFDC]|\uD800[\uDC00-\uDC0B\uDC0D-\uDC26\uDC28-\uDC3A\uDC3C\uDC3D\uDC3F-\uDC4D\uDC50-\uDC5D\uDC80-\uDCFA\uDD07-\uDD33\uDD40-\uDD78\uDD8A\uDD8B\uDE80-\uDE9C\uDEA0-\uDED0\uDEE1-\uDEFB\uDF00-\uDF23\uDF2D-\uDF4A\uDF50-\uDF75\uDF80-\uDF9D\uDFA0-\uDFC3\uDFC8-\uDFCF\uDFD1-\uDFD5]|\uD801[\uDC00-\uDC9D\uDCA0-\uDCA9\uDCB0-\uDCD3\uDCD8-\uDCFB\uDD00-\uDD27\uDD30-\uDD63\uDE00-\uDF36\uDF40-\uDF55\uDF60-\uDF67]|\uD802[\uDC00-\uDC05\uDC08\uDC0A-\uDC35\uDC37\uDC38\uDC3C\uDC3F-\uDC55\uDC58-\uDC76\uDC79-\uDC9E\uDCA7-\uDCAF\uDCE0-\uDCF2\uDCF4\uDCF5\uDCFB-\uDD1B\uDD20-\uDD39\uDD80-\uDDB7\uDDBC-\uDDCF\uDDD2-\uDE00\uDE10-\uDE13\uDE15-\uDE17\uDE19-\uDE35\uDE40-\uDE48\uDE60-\uDE7E\uDE80-\uDE9F\uDEC0-\uDEC7\uDEC9-\uDEE4\uDEEB-\uDEEF\uDF00-\uDF35\uDF40-\uDF55\uDF58-\uDF72\uDF78-\uDF91\uDFA9-\uDFAF]|\uD803[\uDC00-\uDC48\uDC80-\uDCB2\uDCC0-\uDCF2\uDCFA-\uDD23\uDD30-\uDD39\uDE60-\uDE7E\uDE80-\uDEA9\uDEB0\uDEB1\uDF00-\uDF27\uDF30-\uDF45\uDF51-\uDF54\uDFB0-\uDFCB\uDFE0-\uDFF6]|\uD804[\uDC03-\uDC37\uDC52-\uDC6F\uDC83-\uDCAF\uDCD0-\uDCE8\uDCF0-\uDCF9\uDD03-\uDD26\uDD36-\uDD3F\uDD44\uDD47\uDD50-\uDD72\uDD76\uDD83-\uDDB2\uDDC1-\uDDC4\uDDD0-\uDDDA\uDDDC\uDDE1-\uDDF4\uDE00-\uDE11\uDE13-\uDE2B\uDE80-\uDE86\uDE88\uDE8A-\uDE8D\uDE8F-\uDE9D\uDE9F-\uDEA8\uDEB0-\uDEDE\uDEF0-\uDEF9\uDF05-\uDF0C\uDF0F\uDF10\uDF13-\uDF28\uDF2A-\uDF30\uDF32\uDF33\uDF35-\uDF39\uDF3D\uDF50\uDF5D-\uDF61]|\uD805[\uDC00-\uDC34\uDC47-\uDC4A\uDC50-\uDC59\uDC5F-\uDC61\uDC80-\uDCAF\uDCC4\uDCC5\uDCC7\uDCD0-\uDCD9\uDD80-\uDDAE\uDDD8-\uDDDB\uDE00-\uDE2F\uDE44\uDE50-\uDE59\uDE80-\uDEAA\uDEB8\uDEC0-\uDEC9\uDF00-\uDF1A\uDF30-\uDF3B]|\uD806[\uDC00-\uDC2B\uDCA0-\uDCF2\uDCFF-\uDD06\uDD09\uDD0C-\uDD13\uDD15\uDD16\uDD18-\uDD2F\uDD3F\uDD41\uDD50-\uDD59\uDDA0-\uDDA7\uDDAA-\uDDD0\uDDE1\uDDE3\uDE00\uDE0B-\uDE32\uDE3A\uDE50\uDE5C-\uDE89\uDE9D\uDEC0-\uDEF8]|\uD807[\uDC00-\uDC08\uDC0A-\uDC2E\uDC40\uDC50-\uDC6C\uDC72-\uDC8F\uDD00-\uDD06\uDD08\uDD09\uDD0B-\uDD30\uDD46\uDD50-\uDD59\uDD60-\uDD65\uDD67\uDD68\uDD6A-\uDD89\uDD98\uDDA0-\uDDA9\uDEE0-\uDEF2\uDFB0\uDFC0-\uDFD4]|\uD808[\uDC00-\uDF99]|\uD809[\uDC00-\uDC6E\uDC80-\uDD43]|[\uD80C\uD81C-\uD820\uD822\uD840-\uD868\uD86A-\uD86C\uD86F-\uD872\uD874-\uD879\uD880-\uD883][\uDC00-\uDFFF]|\uD80D[\uDC00-\uDC2E]|\uD811[\uDC00-\uDE46]|\uD81A[\uDC00-\uDE38\uDE40-\uDE5E\uDE60-\uDE69\uDED0-\uDEED\uDF00-\uDF2F\uDF40-\uDF43\uDF50-\uDF59\uDF5B-\uDF61\uDF63-\uDF77\uDF7D-\uDF8F]|\uD81B[\uDE40-\uDE96\uDF00-\uDF4A\uDF50\uDF93-\uDF9F\uDFE0\uDFE1\uDFE3]|\uD821[\uDC00-\uDFF7]|\uD823[\uDC00-\uDCD5\uDD00-\uDD08]|\uD82C[\uDC00-\uDD1E\uDD50-\uDD52\uDD64-\uDD67\uDD70-\uDEFB]|\uD82F[\uDC00-\uDC6A\uDC70-\uDC7C\uDC80-\uDC88\uDC90-\uDC99]|\uD834[\uDEE0-\uDEF3\uDF60-\uDF78]|\uD835[\uDC00-\uDC54\uDC56-\uDC9C\uDC9E\uDC9F\uDCA2\uDCA5\uDCA6\uDCA9-\uDCAC\uDCAE-\uDCB9\uDCBB\uDCBD-\uDCC3\uDCC5-\uDD05\uDD07-\uDD0A\uDD0D-\uDD14\uDD16-\uDD1C\uDD1E-\uDD39\uDD3B-\uDD3E\uDD40-\uDD44\uDD46\uDD4A-\uDD50\uDD52-\uDEA5\uDEA8-\uDEC0\uDEC2-\uDEDA\uDEDC-\uDEFA\uDEFC-\uDF14\uDF16-\uDF34\uDF36-\uDF4E\uDF50-\uDF6E\uDF70-\uDF88\uDF8A-\uDFA8\uDFAA-\uDFC2\uDFC4-\uDFCB\uDFCE-\uDFFF]|\uD838[\uDD00-\uDD2C\uDD37-\uDD3D\uDD40-\uDD49\uDD4E\uDEC0-\uDEEB\uDEF0-\uDEF9]|\uD83A[\uDC00-\uDCC4\uDCC7-\uDCCF\uDD00-\uDD43\uDD4B\uDD50-\uDD59]|\uD83B[\uDC71-\uDCAB\uDCAD-\uDCAF\uDCB1-\uDCB4\uDD01-\uDD2D\uDD2F-\uDD3D\uDE00-\uDE03\uDE05-\uDE1F\uDE21\uDE22\uDE24\uDE27\uDE29-\uDE32\uDE34-\uDE37\uDE39\uDE3B\uDE42\uDE47\uDE49\uDE4B\uDE4D-\uDE4F\uDE51\uDE52\uDE54\uDE57\uDE59\uDE5B\uDE5D\uDE5F\uDE61\uDE62\uDE64\uDE67-\uDE6A\uDE6C-\uDE72\uDE74-\uDE77\uDE79-\uDE7C\uDE7E\uDE80-\uDE89\uDE8B-\uDE9B\uDEA1-\uDEA3\uDEA5-\uDEA9\uDEAB-\uDEBB]|\uD83C[\uDD00-\uDD0C]|\uD83E[\uDFF0-\uDFF9]|\uD869[\uDC00-\uDEDD\uDF00-\uDFFF]|\uD86D[\uDC00-\uDF34\uDF40-\uDFFF]|\uD86E[\uDC00-\uDC1D\uDC20-\uDFFF]|\uD873[\uDC00-\uDEA1\uDEB0-\uDFFF]|\uD87A[\uDC00-\uDFE0]|\uD87E[\uDC00-\uDE1D]|\uD884[\uDC00-\uDF4A])/))){var Fe=_e[1]||_e[2]||"";if(!Fe||Fe&&(we===""||this.rules.inline.punctuation.exec(we))){var Ke=_e[0].length-1,$e,Qe,st=Ke,at=0,de=_e[0][0]==="*"?this.rules.inline.emStrong.rDelimAst:this.rules.inline.emStrong.rDelimUnd;for(de.lastIndex=0,ue=ue.slice(-1*le.length+Ke);(_e=de.exec(ue))!=null;)if($e=_e[1]||_e[2]||_e[3]||_e[4]||_e[5]||_e[6],!!$e){if(Qe=$e.length,_e[3]||_e[4]){st+=Qe;continue}else if((_e[5]||_e[6])&&Ke%3&&!((Ke+Qe)%3)){at+=Qe;continue}if(st-=Qe,!(st>0)){if(Qe=Math.min(Qe,Qe+st+at),Math.min(Ke,Qe)%2){var Ce=le.slice(1,Ke+_e.index+Qe);return{type:"em",raw:le.slice(0,Ke+_e.index+Qe+1),text:Ce,tokens:this.lexer.inlineTokens(Ce,[])}}var ce=le.slice(2,Ke+_e.index+Qe-1);return{type:"strong",raw:le.slice(0,Ke+_e.index+Qe+1),text:ce,tokens:this.lexer.inlineTokens(ce,[])}}}}}},Ie.codespan=function(le){var ue=this.rules.inline.code.exec(le);if(ue){var we=ue[2].replace(/\n/g," "),_e=/[^ ]/.test(we),Fe=/^ /.test(we)&&/ $/.test(we);return _e&&Fe&&(we=we.substring(1,we.length-1)),we=M(we,!0),{type:"codespan",raw:ue[0],text:we}}},Ie.br=function(le){var ue=this.rules.inline.br.exec(le);if(ue)return{type:"br",raw:ue[0]}},Ie.del=function(le){var ue=this.rules.inline.del.exec(le);if(ue)return{type:"del",raw:ue[0],text:ue[2],tokens:this.lexer.inlineTokens(ue[2],[])}},Ie.autolink=function(le,ue){var we=this.rules.inline.autolink.exec(le);if(we){var _e,Fe;return we[2]==="@"?(_e=M(this.options.mangle?ue(we[1]):we[1]),Fe="mailto:"+_e):(_e=M(we[1]),Fe=_e),{type:"link",raw:we[0],text:_e,href:Fe,tokens:[{type:"text",raw:_e,text:_e}]}}},Ie.url=function(le,ue){var we;if(we=this.rules.inline.url.exec(le)){var _e,Fe;if(we[2]==="@")_e=M(this.options.mangle?ue(we[0]):we[0]),Fe="mailto:"+_e;else{var Ke;do Ke=we[0],we[0]=this.rules.inline._backpedal.exec(we[0])[0];while(Ke!==we[0]);_e=M(we[0]),we[1]==="www."?Fe="http://"+_e:Fe=_e}return{type:"link",raw:we[0],text:_e,href:Fe,tokens:[{type:"text",raw:_e,text:_e}]}}},Ie.inlineText=function(le,ue){var we=this.rules.inline.text.exec(le);if(we){var _e;return this.lexer.state.inRawBlock?_e=this.options.sanitize?this.options.sanitizer?this.options.sanitizer(we[0]):M(we[0]):we[0]:_e=M(this.options.smartypants?ue(we[0]):we[0]),{type:"text",raw:we[0],text:_e}}},Te}(),N=x.noopTest,j=x.edit,H=x.merge,V={newline:/^(?: *(?:\n|$))+/,code:/^( {4}[^\n]+(?:\n(?: *(?:\n|$))*)?)+/,fences:/^ {0,3}(`{3,}(?=[^`\n]*\n)|~{3,})([^\n]*)\n(?:|([\s\S]*?)\n)(?: {0,3}\1[~`]* *(?=\n|$)|$)/,hr:/^ {0,3}((?:- *){3,}|(?:_ *){3,}|(?:\* *){3,})(?:\n+|$)/,heading:/^ {0,3}(#{1,6})(?=\s|$)(.*)(?:\n+|$)/,blockquote:/^( {0,3}> ?(paragraph|[^\n]*)(?:\n|$))+/,list:/^( {0,3}bull)( [^\n]+?)?(?:\n|$)/,html:"^ {0,3}(?:<(script|pre|style|textarea)[\\s>][\\s\\S]*?(?:</\\1>[^\\n]*\\n+|$)|comment[^\\n]*(\\n+|$)|<\\?[\\s\\S]*?(?:\\?>\\n*|$)|<![A-Z][\\s\\S]*?(?:>\\n*|$)|<!\\[CDATA\\[[\\s\\S]*?(?:\\]\\]>\\n*|$)|</?(tag)(?: +|\\n|/?>)[\\s\\S]*?(?:(?:\\n *)+\\n|$)|<(?!script|pre|style|textarea)([a-z][\\w-]*)(?:attribute)*? */?>(?=[ \\t]*(?:\\n|$))[\\s\\S]*?(?:(?:\\n *)+\\n|$)|</(?!script|pre|style|textarea)[a-z][\\w-]*\\s*>(?=[ \\t]*(?:\\n|$))[\\s\\S]*?(?:(?:\\n *)+\\n|$))",def:/^ {0,3}\[(label)\]: *\n? *<?([^\s>]+)>?(?:(?: +\n? *| *\n *)(title))? *(?:\n+|$)/,table:N,lheading:/^([^\n]+)\n {0,3}(=+|-+) *(?:\n+|$)/,_paragraph:/^([^\n]+(?:\n(?!hr|heading|lheading|blockquote|fences|list|html| +\n)[^\n]+)*)/,text:/^[^\n]+/};V._label=/(?!\s*\])(?:\\[\[\]]|[^\[\]])+/,V._title=/(?:"(?:\\"?|[^"\\])*"|'[^'\n]*(?:\n[^'\n]+)*\n?'|\([^()]*\))/,V.def=j(V.def).replace("label",V._label).replace("title",V._title).getRegex(),V.bullet=/(?:[*+-]|\d{1,9}[.)])/,V.listItemStart=j(/^( *)(bull) */).replace("bull",V.bullet).getRegex(),V.list=j(V.list).replace(/bull/g,V.bullet).replace("hr","\\n+(?=\\1?(?:(?:- *){3,}|(?:_ *){3,}|(?:\\* *){3,})(?:\\n+|$))").replace("def","\\n+(?="+V.def.source+")").getRegex(),V._tag="address|article|aside|base|basefont|blockquote|body|caption|center|col|colgroup|dd|details|dialog|dir|div|dl|dt|fieldset|figcaption|figure|footer|form|frame|frameset|h[1-6]|head|header|hr|html|iframe|legend|li|link|main|menu|menuitem|meta|nav|noframes|ol|optgroup|option|p|param|section|source|summary|table|tbody|td|tfoot|th|thead|title|tr|track|ul",V._comment=/<!--(?!-?>)[\s\S]*?(?:-->|$)/,V.html=j(V.html,"i").replace("comment",V._comment).replace("tag",V._tag).replace("attribute",/ +[a-zA-Z:_][\w.:-]*(?: *= *"[^"\n]*"| *= *'[^'\n]*'| *= *[^\s"'=<>`]+)?/).getRegex(),V.paragraph=j(V._paragraph).replace("hr",V.hr).replace("heading"," {0,3}#{1,6} ").replace("|lheading","").replace("blockquote"," {0,3}>").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",V._tag).getRegex(),V.blockquote=j(V.blockquote).replace("paragraph",V.paragraph).getRegex(),V.normal=H({},V),V.gfm=H({},V.normal,{table:"^ *([^\\n ].*\\|.*)\\n {0,3}(?:\\| *)?(:?-+:? *(?:\\| *:?-+:? *)*)\\|?(?:\\n((?:(?! *\\n|hr|heading|blockquote|code|fences|list|html).*(?:\\n|$))*)\\n*|$)"}),V.gfm.table=j(V.gfm.table).replace("hr",V.hr).replace("heading"," {0,3}#{1,6} ").replace("blockquote"," {0,3}>").replace("code"," {4}[^\\n]").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",V._tag).getRegex(),V.pedantic=H({},V.normal,{html:j(`^ *(?:comment *(?:\\n|\\s*$)|<(tag)[\\s\\S]+?</\\1> *(?:\\n{2,}|\\s*$)|<tag(?:"[^"]*"|'[^']*'|\\s[^'"/>\\s]*)*?/?> *(?:\\n{2,}|\\s*$))`).replace("comment",V._comment).replace(/tag/g,"(?!(?:a|em|strong|small|s|cite|q|dfn|abbr|data|time|code|var|samp|kbd|sub|sup|i|b|u|mark|ruby|rt|rp|bdi|bdo|span|br|wbr|ins|del|img)\\b)\\w+(?!:|[^\\w\\s@]*@)\\b").getRegex(),def:/^ *\[([^\]]+)\]: *<?([^\s>]+)>?(?: +(["(][^\n]+[")]))? *(?:\n+|$)/,heading:/^(#{1,6})(.*)(?:\n+|$)/,fences:N,paragraph:j(V.normal._paragraph).replace("hr",V.hr).replace("heading",` *#{1,6} *[^
]`).replace("lheading",V.lheading).replace("blockquote"," {0,3}>").replace("|fences","").replace("|list","").replace("|html","").getRegex()});var q={escape:/^\\([!"#$%&'()*+,\-./:;<=>?@\[\]\\^_`{|}~])/,autolink:/^<(scheme:[^\s\x00-\x1f<>]*|email)>/,url:N,tag:"^comment|^</[a-zA-Z][\\w:-]*\\s*>|^<[a-zA-Z][\\w-]*(?:attribute)*?\\s*/?>|^<\\?[\\s\\S]*?\\?>|^<![a-zA-Z]+\\s[\\s\\S]*?>|^<!\\[CDATA\\[[\\s\\S]*?\\]\\]>",link:/^!?\[(label)\]\(\s*(href)(?:\s+(title))?\s*\)/,reflink:/^!?\[(label)\]\[(?!\s*\])((?:\\[\[\]]?|[^\[\]\\])+)\]/,nolink:/^!?\[(?!\s*\])((?:\[[^\[\]]*\]|\\[\[\]]|[^\[\]])*)\](?:\[\])?/,reflinkSearch:"reflink|nolink(?!\\()",emStrong:{lDelim:/^(?:\*+(?:([punct_])|[^\s*]))|^_+(?:([punct*])|([^\s_]))/,rDelimAst:/\_\_[^_*]*?\*[^_*]*?\_\_|[punct_](\*+)(?=[\s]|$)|[^punct*_\s](\*+)(?=[punct_\s]|$)|[punct_\s](\*+)(?=[^punct*_\s])|[\s](\*+)(?=[punct_])|[punct_](\*+)(?=[punct_])|[^punct*_\s](\*+)(?=[^punct*_\s])/,rDelimUnd:/\*\*[^_*]*?\_[^_*]*?\*\*|[punct*](\_+)(?=[\s]|$)|[^punct*_\s](\_+)(?=[punct*\s]|$)|[punct*\s](\_+)(?=[^punct*_\s])|[\s](\_+)(?=[punct*])|[punct*](\_+)(?=[punct*])/},code:/^(`+)([^`]|[^`][\s\S]*?[^`])\1(?!`)/,br:/^( {2,}|\\)\n(?!\s*$)/,del:N,text:/^(`+|[^`])(?:(?= {2,}\n)|[\s\S]*?(?:(?=[\\<!\[`*_]|\b_|$)|[^ ](?= {2,}\n)))/,punctuation:/^([\spunctuation])/};q._punctuation="!\"#$%&'()+\\-.,/:;<=>?@\\[\\]`^{|}~",q.punctuation=j(q.punctuation).replace(/punctuation/g,q._punctuation).getRegex(),q.blockSkip=/\[[^\]]*?\]\([^\)]*?\)|`[^`]*?`|<[^>]*?>/g,q.escapedEmSt=/\\\*|\\_/g,q._comment=j(V._comment).replace("(?:-->|$)","-->").getRegex(),q.emStrong.lDelim=j(q.emStrong.lDelim).replace(/punct/g,q._punctuation).getRegex(),q.emStrong.rDelimAst=j(q.emStrong.rDelimAst,"g").replace(/punct/g,q._punctuation).getRegex(),q.emStrong.rDelimUnd=j(q.emStrong.rDelimUnd,"g").replace(/punct/g,q._punctuation).getRegex(),q._escapes=/\\([!"#$%&'()*+,\-./:;<=>?@\[\]\\^_`{|}~])/g,q._scheme=/[a-zA-Z][a-zA-Z0-9+.-]{1,31}/,q._email=/[a-zA-Z0-9.!#$%&'*+/=?^_`{|}~-]+(@)[a-zA-Z0-9](?:[a-zA-Z0-9-]{0,61}[a-zA-Z0-9])?(?:\.[a-zA-Z0-9](?:[a-zA-Z0-9-]{0,61}[a-zA-Z0-9])?)+(?![-_])/,q.autolink=j(q.autolink).replace("scheme",q._scheme).replace("email",q._email).getRegex(),q._attribute=/\s+[a-zA-Z:_][\w.:-]*(?:\s*=\s*"[^"]*"|\s*=\s*'[^']*'|\s*=\s*[^\s"'=<>`]+)?/,q.tag=j(q.tag).replace("comment",q._comment).replace("attribute",q._attribute).getRegex(),q._label=/(?:\[(?:\\.|[^\[\]\\])*\]|\\.|`[^`]*`|[^\[\]\\`])*?/,q._href=/<(?:\\.|[^\n<>\\])+>|[^\s\x00-\x1f]*/,q._title=/"(?:\\"?|[^"\\])*"|'(?:\\'?|[^'\\])*'|\((?:\\\)?|[^)\\])*\)/,q.link=j(q.link).replace("label",q._label).replace("href",q._href).replace("title",q._title).getRegex(),q.reflink=j(q.reflink).replace("label",q._label).getRegex(),q.reflinkSearch=j(q.reflinkSearch,"g").replace("reflink",q.reflink).replace("nolink",q.nolink).getRegex(),q.normal=H({},q),q.pedantic=H({},q.normal,{strong:{start:/^__|\*\*/,middle:/^__(?=\S)([\s\S]*?\S)__(?!_)|^\*\*(?=\S)([\s\S]*?\S)\*\*(?!\*)/,endAst:/\*\*(?!\*)/g,endUnd:/__(?!_)/g},em:{start:/^_|\*/,middle:/^()\*(?=\S)([\s\S]*?\S)\*(?!\*)|^_(?=\S)([\s\S]*?\S)_(?!_)/,endAst:/\*(?!\*)/g,endUnd:/_(?!_)/g},link:j(/^!?\[(label)\]\((.*?)\)/).replace("label",q._label).getRegex(),reflink:j(/^!?\[(label)\]\s*\[([^\]]*)\]/).replace("label",q._label).getRegex()}),q.gfm=H({},q.normal,{escape:j(q.escape).replace("])","~|])").getRegex(),_extended_email:/[A-Za-z0-9._+-]+(@)[a-zA-Z0-9-_]+(?:\.[a-zA-Z0-9-_]*[a-zA-Z0-9])+(?![-_])/,url:/^((?:ftp|https?):\/\/|www\.)(?:[a-zA-Z0-9\-]+\.?)+[^\s<]*|^email/,_backpedal:/(?:[^?!.,:;*_~()&]+|\([^)]*\)|&(?![a-zA-Z0-9]+;$)|[?!.,:;*_~)]+(?!$))+/,del:/^(~~?)(?=[^\s~])([\s\S]*?[^\s~])\1(?=[^~]|$)/,text:/^([`~]+|[^`~])(?:(?= {2,}\n)|(?=[a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-]+@)|[\s\S]*?(?:(?=[\\<!\[`*~_]|\b_|https?:\/\/|ftp:\/\/|www\.|$)|[^ ](?= {2,}\n)|[^a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-](?=[a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-]+@)))/}),q.gfm.url=j(q.gfm.url,"i").replace("email",q.gfm._extended_email).getRegex(),q.breaks=H({},q.gfm,{br:j(q.br).replace("{2,}","*").getRegex(),text:j(q.gfm.text).replace("\\b_","\\b_| {2,}\\n").replace(/\{2,\}/g,"*").getRegex()});var ne={block:V,inline:q},fe=K,ye=C.exports.defaults,ke=ne.block,Be=ne.inline,We=x.repeatString;function ze(Te){return Te.replace(/---/g,"\u2014").replace(/--/g,"\u2013").replace(/(^|[-\u2014/(\[{"\s])'/g,"$1\u2018").replace(/'/g,"\u2019").replace(/(^|[-\u2014/(\[{\u2018\s])"/g,"$1\u201C").replace(/"/g,"\u201D").replace(/\.{3}/g,"\u2026")}function Q(Te){var Ie="",Se,le,ue=Te.length;for(Se=0;Se<ue;Se++)le=Te.charCodeAt(Se),Math.random()>.5&&(le="x"+le.toString(16)),Ie+="&#"+le+";";return Ie}var ee=function(){function Te(Se){this.tokens=[],this.tokens.links=Object.create(null),this.options=Se||ye,this.options.tokenizer=this.options.tokenizer||new fe,this.tokenizer=this.options.tokenizer,this.tokenizer.options=this.options,this.tokenizer.lexer=this,this.inlineQueue=[],this.state={inLink:!1,inRawBlock:!1,top:!0};var le={block:ke.normal,inline:Be.normal};this.options.pedantic?(le.block=ke.pedantic,le.inline=Be.pedantic):this.options.gfm&&(le.block=ke.gfm,this.options.breaks?le.inline=Be.breaks:le.inline=Be.gfm),this.tokenizer.rules=le}Te.lex=function(le,ue){var we=new Te(ue);return we.lex(le)},Te.lexInline=function(le,ue){var we=new Te(ue);return we.inlineTokens(le)};var Ie=Te.prototype;return Ie.lex=function(le){le=le.replace(/\r\n|\r/g,`
`).replace(/\t/g,"    "),this.blockTokens(le,this.tokens);for(var ue;ue=this.inlineQueue.shift();)this.inlineTokens(ue.src,ue.tokens);return this.tokens},Ie.blockTokens=function(le,ue){var we=this;ue===void 0&&(ue=[]),this.options.pedantic&&(le=le.replace(/^ +$/gm,""));for(var _e,Fe,Ke,$e;le;)if(!(this.options.extensions&&this.options.extensions.block&&this.options.extensions.block.some(function(st){return(_e=st.call({lexer:we},le,ue))?(le=le.substring(_e.raw.length),ue.push(_e),!0):!1}))){if(_e=this.tokenizer.space(le)){le=le.substring(_e.raw.length),_e.type&&ue.push(_e);continue}if(_e=this.tokenizer.code(le)){le=le.substring(_e.raw.length),Fe=ue[ue.length-1],Fe&&(Fe.type==="paragraph"||Fe.type==="text")?(Fe.raw+=`
`+_e.raw,Fe.text+=`
`+_e.text,this.inlineQueue[this.inlineQueue.length-1].src=Fe.text):ue.push(_e);continue}if(_e=this.tokenizer.fences(le)){le=le.substring(_e.raw.length),ue.push(_e);continue}if(_e=this.tokenizer.heading(le)){le=le.substring(_e.raw.length),ue.push(_e);continue}if(_e=this.tokenizer.hr(le)){le=le.substring(_e.raw.length),ue.push(_e);continue}if(_e=this.tokenizer.blockquote(le)){le=le.substring(_e.raw.length),ue.push(_e);continue}if(_e=this.tokenizer.list(le)){le=le.substring(_e.raw.length),ue.push(_e);continue}if(_e=this.tokenizer.html(le)){le=le.substring(_e.raw.length),ue.push(_e);continue}if(_e=this.tokenizer.def(le)){le=le.substring(_e.raw.length),Fe=ue[ue.length-1],Fe&&(Fe.type==="paragraph"||Fe.type==="text")?(Fe.raw+=`
`+_e.raw,Fe.text+=`
`+_e.raw,this.inlineQueue[this.inlineQueue.length-1].src=Fe.text):this.tokens.links[_e.tag]||(this.tokens.links[_e.tag]={href:_e.href,title:_e.title});continue}if(_e=this.tokenizer.table(le)){le=le.substring(_e.raw.length),ue.push(_e);continue}if(_e=this.tokenizer.lheading(le)){le=le.substring(_e.raw.length),ue.push(_e);continue}if(Ke=le,this.options.extensions&&this.options.extensions.startBlock&&function(){var st=Infinity,at=le.slice(1),de=void 0;we.options.extensions.startBlock.forEach(function(Ce){de=Ce.call({lexer:this},at),typeof de=="number"&&de>=0&&(st=Math.min(st,de))}),st<Infinity&&st>=0&&(Ke=le.substring(0,st+1))}(),this.state.top&&(_e=this.tokenizer.paragraph(Ke))){Fe=ue[ue.length-1],$e&&Fe.type==="paragraph"?(Fe.raw+=`
`+_e.raw,Fe.text+=`
`+_e.text,this.inlineQueue.pop(),this.inlineQueue[this.inlineQueue.length-1].src=Fe.text):ue.push(_e),$e=Ke.length!==le.length,le=le.substring(_e.raw.length);continue}if(_e=this.tokenizer.text(le)){le=le.substring(_e.raw.length),Fe=ue[ue.length-1],Fe&&Fe.type==="text"?(Fe.raw+=`
`+_e.raw,Fe.text+=`
`+_e.text,this.inlineQueue.pop(),this.inlineQueue[this.inlineQueue.length-1].src=Fe.text):ue.push(_e);continue}if(le){var Qe="Infinite loop on byte: "+le.charCodeAt(0);if(this.options.silent){console.error(Qe);break}else throw new Error(Qe)}}return this.state.top=!0,ue},Ie.inline=function(le,ue){this.inlineQueue.push({src:le,tokens:ue})},Ie.inlineTokens=function(le,ue){var we=this;ue===void 0&&(ue=[]);var _e,Fe,Ke,$e=le,Qe,st,at;if(this.tokens.links){var de=Object.keys(this.tokens.links);if(de.length>0)for(;(Qe=this.tokenizer.rules.inline.reflinkSearch.exec($e))!=null;)de.includes(Qe[0].slice(Qe[0].lastIndexOf("[")+1,-1))&&($e=$e.slice(0,Qe.index)+"["+We("a",Qe[0].length-2)+"]"+$e.slice(this.tokenizer.rules.inline.reflinkSearch.lastIndex))}for(;(Qe=this.tokenizer.rules.inline.blockSkip.exec($e))!=null;)$e=$e.slice(0,Qe.index)+"["+We("a",Qe[0].length-2)+"]"+$e.slice(this.tokenizer.rules.inline.blockSkip.lastIndex);for(;(Qe=this.tokenizer.rules.inline.escapedEmSt.exec($e))!=null;)$e=$e.slice(0,Qe.index)+"++"+$e.slice(this.tokenizer.rules.inline.escapedEmSt.lastIndex);for(;le;)if(st||(at=""),st=!1,!(this.options.extensions&&this.options.extensions.inline&&this.options.extensions.inline.some(function(ce){return(_e=ce.call({lexer:we},le,ue))?(le=le.substring(_e.raw.length),ue.push(_e),!0):!1}))){if(_e=this.tokenizer.escape(le)){le=le.substring(_e.raw.length),ue.push(_e);continue}if(_e=this.tokenizer.tag(le)){le=le.substring(_e.raw.length),Fe=ue[ue.length-1],Fe&&_e.type==="text"&&Fe.type==="text"?(Fe.raw+=_e.raw,Fe.text+=_e.text):ue.push(_e);continue}if(_e=this.tokenizer.link(le)){le=le.substring(_e.raw.length),ue.push(_e);continue}if(_e=this.tokenizer.reflink(le,this.tokens.links)){le=le.substring(_e.raw.length),Fe=ue[ue.length-1],Fe&&_e.type==="text"&&Fe.type==="text"?(Fe.raw+=_e.raw,Fe.text+=_e.text):ue.push(_e);continue}if(_e=this.tokenizer.emStrong(le,$e,at)){le=le.substring(_e.raw.length),ue.push(_e);continue}if(_e=this.tokenizer.codespan(le)){le=le.substring(_e.raw.length),ue.push(_e);continue}if(_e=this.tokenizer.br(le)){le=le.substring(_e.raw.length),ue.push(_e);continue}if(_e=this.tokenizer.del(le)){le=le.substring(_e.raw.length),ue.push(_e);continue}if(_e=this.tokenizer.autolink(le,Q)){le=le.substring(_e.raw.length),ue.push(_e);continue}if(!this.state.inLink&&(_e=this.tokenizer.url(le,Q))){le=le.substring(_e.raw.length),ue.push(_e);continue}if(Ke=le,this.options.extensions&&this.options.extensions.startInline&&function(){var ce=Infinity,X=le.slice(1),De=void 0;we.options.extensions.startInline.forEach(function(Re){De=Re.call({lexer:this},X),typeof De=="number"&&De>=0&&(ce=Math.min(ce,De))}),ce<Infinity&&ce>=0&&(Ke=le.substring(0,ce+1))}(),_e=this.tokenizer.inlineText(Ke,ze)){le=le.substring(_e.raw.length),_e.raw.slice(-1)!=="_"&&(at=_e.raw.slice(-1)),st=!0,Fe=ue[ue.length-1],Fe&&Fe.type==="text"?(Fe.raw+=_e.raw,Fe.text+=_e.text):ue.push(_e);continue}if(le){var Ce="Infinite loop on byte: "+le.charCodeAt(0);if(this.options.silent){console.error(Ce);break}else throw new Error(Ce)}}return ue},e(Te,null,[{key:"rules",get:function(){return{block:ke,inline:Be}}}]),Te}(),re=C.exports.defaults,he=x.cleanUrl,Z=x.escape,oe=function(){function Te(Se){this.options=Se||re}var Ie=Te.prototype;return Ie.code=function(le,ue,we){var _e=(ue||"").match(/\S*/)[0];if(this.options.highlight){var Fe=this.options.highlight(le,_e);Fe!=null&&Fe!==le&&(we=!0,le=Fe)}return le=le.replace(/\n$/,"")+`
`,_e?'<pre><code class="'+this.options.langPrefix+Z(_e,!0)+'">'+(we?le:Z(le,!0))+`</code></pre>
`:"<pre><code>"+(we?le:Z(le,!0))+`</code></pre>
`},Ie.blockquote=function(le){return`<blockquote>
`+le+`</blockquote>
`},Ie.html=function(le){return le},Ie.heading=function(le,ue,we,_e){return this.options.headerIds?"<h"+ue+' id="'+this.options.headerPrefix+_e.slug(we)+'">'+le+"</h"+ue+`>
`:"<h"+ue+">"+le+"</h"+ue+`>
`},Ie.hr=function(){return this.options.xhtml?`<hr/>
`:`<hr>
`},Ie.list=function(le,ue,we){var _e=ue?"ol":"ul",Fe=ue&&we!==1?' start="'+we+'"':"";return"<"+_e+Fe+`>
`+le+"</"+_e+`>
`},Ie.listitem=function(le){return"<li>"+le+`</li>
`},Ie.checkbox=function(le){return"<input "+(le?'checked="" ':"")+'disabled="" type="checkbox"'+(this.options.xhtml?" /":"")+"> "},Ie.paragraph=function(le){return"<p>"+le+`</p>
`},Ie.table=function(le,ue){return ue&&(ue="<tbody>"+ue+"</tbody>"),`<table>
<thead>
`+le+`</thead>
`+ue+`</table>
`},Ie.tablerow=function(le){return`<tr>
`+le+`</tr>
`},Ie.tablecell=function(le,ue){var we=ue.header?"th":"td",_e=ue.align?"<"+we+' align="'+ue.align+'">':"<"+we+">";return _e+le+"</"+we+`>
`},Ie.strong=function(le){return"<strong>"+le+"</strong>"},Ie.em=function(le){return"<em>"+le+"</em>"},Ie.codespan=function(le){return"<code>"+le+"</code>"},Ie.br=function(){return this.options.xhtml?"<br/>":"<br>"},Ie.del=function(le){return"<del>"+le+"</del>"},Ie.link=function(le,ue,we){if(le=he(this.options.sanitize,this.options.baseUrl,le),le===null)return we;var _e='<a href="'+Z(le)+'"';return ue&&(_e+=' title="'+ue+'"'),_e+=">"+we+"</a>",_e},Ie.image=function(le,ue,we){if(le=he(this.options.sanitize,this.options.baseUrl,le),le===null)return we;var _e='<img src="'+le+'" alt="'+we+'"';return ue&&(_e+=' title="'+ue+'"'),_e+=this.options.xhtml?"/>":">",_e},Ie.text=function(le){return le},Te}(),be=function(){function Te(){}var Ie=Te.prototype;return Ie.strong=function(le){return le},Ie.em=function(le){return le},Ie.codespan=function(le){return le},Ie.del=function(le){return le},Ie.html=function(le){return le},Ie.text=function(le){return le},Ie.link=function(le,ue,we){return""+we},Ie.image=function(le,ue,we){return""+we},Ie.br=function(){return""},Te}(),Me=function(){function Te(){this.seen={}}var Ie=Te.prototype;return Ie.serialize=function(le){return le.toLowerCase().trim().replace(/<[!\/a-z].*?>/ig,"").replace(/[\u2000-\u206F\u2E00-\u2E7F\\'!"#$%&()*+,./:;<=>?@[\]^`{|}~]/g,"").replace(/\s/g,"-")},Ie.getNextSafeSlug=function(le,ue){var we=le,_e=0;if(this.seen.hasOwnProperty(we)){_e=this.seen[le];do _e++,we=le+"-"+_e;while(this.seen.hasOwnProperty(we))}return ue||(this.seen[le]=_e,this.seen[we]=0),we},Ie.slug=function(le,ue){ue===void 0&&(ue={});var we=this.serialize(le);return this.getNextSafeSlug(we,ue.dryrun)},Te}(),Ve=oe,Ge=be,Je=Me,tt=C.exports.defaults,ot=x.unescape,et=function(){function Te(Se){this.options=Se||tt,this.options.renderer=this.options.renderer||new Ve,this.renderer=this.options.renderer,this.renderer.options=this.options,this.textRenderer=new Ge,this.slugger=new Je}Te.parse=function(le,ue){var we=new Te(ue);return we.parse(le)},Te.parseInline=function(le,ue){var we=new Te(ue);return we.parseInline(le)};var Ie=Te.prototype;return Ie.parse=function(le,ue){ue===void 0&&(ue=!0);var we="",_e,Fe,Ke,$e,Qe,st,at,de,Ce,ce,X,De,Re,Ze,qe,dt,wt,yt,bt,ft=le.length;for(_e=0;_e<ft;_e++){if(ce=le[_e],this.options.extensions&&this.options.extensions.renderers&&this.options.extensions.renderers[ce.type]&&(bt=this.options.extensions.renderers[ce.type].call({parser:this},ce),bt!==!1||!["space","hr","heading","code","table","blockquote","list","html","paragraph","text"].includes(ce.type))){we+=bt||"";continue}switch(ce.type){case"space":continue;case"hr":{we+=this.renderer.hr();continue}case"heading":{we+=this.renderer.heading(this.parseInline(ce.tokens),ce.depth,ot(this.parseInline(ce.tokens,this.textRenderer)),this.slugger);continue}case"code":{we+=this.renderer.code(ce.text,ce.lang,ce.escaped);continue}case"table":{for(de="",at="",$e=ce.header.length,Fe=0;Fe<$e;Fe++)at+=this.renderer.tablecell(this.parseInline(ce.header[Fe].tokens),{header:!0,align:ce.align[Fe]});for(de+=this.renderer.tablerow(at),Ce="",$e=ce.rows.length,Fe=0;Fe<$e;Fe++){for(st=ce.rows[Fe],at="",Qe=st.length,Ke=0;Ke<Qe;Ke++)at+=this.renderer.tablecell(this.parseInline(st[Ke].tokens),{header:!1,align:ce.align[Ke]});Ce+=this.renderer.tablerow(at)}we+=this.renderer.table(de,Ce);continue}case"blockquote":{Ce=this.parse(ce.tokens),we+=this.renderer.blockquote(Ce);continue}case"list":{for(X=ce.ordered,De=ce.start,Re=ce.loose,$e=ce.items.length,Ce="",Fe=0;Fe<$e;Fe++)qe=ce.items[Fe],dt=qe.checked,wt=qe.task,Ze="",qe.task&&(yt=this.renderer.checkbox(dt),Re?qe.tokens.length>0&&qe.tokens[0].type==="paragraph"?(qe.tokens[0].text=yt+" "+qe.tokens[0].text,qe.tokens[0].tokens&&qe.tokens[0].tokens.length>0&&qe.tokens[0].tokens[0].type==="text"&&(qe.tokens[0].tokens[0].text=yt+" "+qe.tokens[0].tokens[0].text)):qe.tokens.unshift({type:"text",text:yt}):Ze+=yt),Ze+=this.parse(qe.tokens,Re),Ce+=this.renderer.listitem(Ze,wt,dt);we+=this.renderer.list(Ce,X,De);continue}case"html":{we+=this.renderer.html(ce.text);continue}case"paragraph":{we+=this.renderer.paragraph(this.parseInline(ce.tokens));continue}case"text":{for(Ce=ce.tokens?this.parseInline(ce.tokens):ce.text;_e+1<ft&&le[_e+1].type==="text";)ce=le[++_e],Ce+=`
`+(ce.tokens?this.parseInline(ce.tokens):ce.text);we+=ue?this.renderer.paragraph(Ce):Ce;continue}default:{var vt='Token with "'+ce.type+'" type was not found.';if(this.options.silent){console.error(vt);return}else throw new Error(vt)}}}return we},Ie.parseInline=function(le,ue){ue=ue||this.renderer;var we="",_e,Fe,Ke,$e=le.length;for(_e=0;_e<$e;_e++){if(Fe=le[_e],this.options.extensions&&this.options.extensions.renderers&&this.options.extensions.renderers[Fe.type]&&(Ke=this.options.extensions.renderers[Fe.type].call({parser:this},Fe),Ke!==!1||!["escape","html","link","image","strong","em","codespan","br","del","text"].includes(Fe.type))){we+=Ke||"";continue}switch(Fe.type){case"escape":{we+=ue.text(Fe.text);break}case"html":{we+=ue.html(Fe.text);break}case"link":{we+=ue.link(Fe.href,Fe.title,this.parseInline(Fe.tokens,ue));break}case"image":{we+=ue.image(Fe.href,Fe.title,Fe.text);break}case"strong":{we+=ue.strong(this.parseInline(Fe.tokens,ue));break}case"em":{we+=ue.em(this.parseInline(Fe.tokens,ue));break}case"codespan":{we+=ue.codespan(Fe.text);break}case"br":{we+=ue.br();break}case"del":{we+=ue.del(this.parseInline(Fe.tokens,ue));break}case"text":{we+=ue.text(Fe.text);break}default:{var Qe='Token with "'+Fe.type+'" type was not found.';if(this.options.silent){console.error(Qe);return}else throw new Error(Qe)}}}return we},Te}(),it=ee,ct=et,pt=K,Pt=oe,Ue=be,Rt=Me,J=x.merge,ie=x.checkSanitizeDeprecation,ge=x.escape,te=C.exports.getDefaults,Ee=C.exports.changeDefaults,Le=C.exports.defaults;function Oe(Te,Ie,Se){if(typeof Te=="undefined"||Te===null)throw new Error("marked(): input parameter is undefined or null");if(typeof Te!="string")throw new Error("marked(): input parameter is of type "+Object.prototype.toString.call(Te)+", string expected");if(typeof Ie=="function"&&(Se=Ie,Ie=null),Ie=J({},Oe.defaults,Ie||{}),ie(Ie),Se){var le=Ie.highlight,ue;try{ue=it.lex(Te,Ie)}catch(Ke){return Se(Ke)}var we=function($e){var Qe;if(!$e)try{Ie.walkTokens&&Oe.walkTokens(ue,Ie.walkTokens),Qe=ct.parse(ue,Ie)}catch(st){$e=st}return Ie.highlight=le,$e?Se($e):Se(null,Qe)};if(!le||le.length<3||(delete Ie.highlight,!ue.length))return we();var _e=0;Oe.walkTokens(ue,function(Ke){Ke.type==="code"&&(_e++,setTimeout(function(){le(Ke.text,Ke.lang,function($e,Qe){if($e)return we($e);Qe!=null&&Qe!==Ke.text&&(Ke.text=Qe,Ke.escaped=!0),_e--,_e===0&&we()})},0))}),_e===0&&we();return}try{var Fe=it.lex(Te,Ie);return Ie.walkTokens&&Oe.walkTokens(Fe,Ie.walkTokens),ct.parse(Fe,Ie)}catch(Ke){if(Ke.message+=`
Please report this to https://github.com/markedjs/marked.`,Ie.silent)return"<p>An error occurred:</p><pre>"+ge(Ke.message+"",!0)+"</pre>";throw Ke}}Oe.options=Oe.setOptions=function(Te){return J(Oe.defaults,Te),Ee(Oe.defaults),Oe},Oe.getDefaults=te,Oe.defaults=Le,Oe.use=function(){for(var Te=this,Ie=arguments.length,Se=new Array(Ie),le=0;le<Ie;le++)Se[le]=arguments[le];var ue=J.apply(void 0,[{}].concat(Se)),we=Oe.defaults.extensions||{renderers:{},childTokens:{}},_e;Se.forEach(function(Fe){if(Fe.extensions&&(_e=!0,Fe.extensions.forEach(function($e){if(!$e.name)throw new Error("extension name required");if($e.renderer){var Qe=we.renderers?we.renderers[$e.name]:null;Qe?we.renderers[$e.name]=function(){for(var st=arguments.length,at=new Array(st),de=0;de<st;de++)at[de]=arguments[de];var Ce=$e.renderer.apply(this,at);return Ce===!1&&(Ce=Qe.apply(this,at)),Ce}:we.renderers[$e.name]=$e.renderer}if($e.tokenizer){if(!$e.level||$e.level!=="block"&&$e.level!=="inline")throw new Error("extension level must be 'block' or 'inline'");we[$e.level]?we[$e.level].unshift($e.tokenizer):we[$e.level]=[$e.tokenizer],$e.start&&($e.level==="block"?we.startBlock?we.startBlock.push($e.start):we.startBlock=[$e.start]:$e.level==="inline"&&(we.startInline?we.startInline.push($e.start):we.startInline=[$e.start]))}$e.childTokens&&(we.childTokens[$e.name]=$e.childTokens)})),Fe.renderer&&function(){var $e=Oe.defaults.renderer||new Pt,Qe=function(de){var Ce=$e[de];$e[de]=function(){for(var ce=arguments.length,X=new Array(ce),De=0;De<ce;De++)X[De]=arguments[De];var Re=Fe.renderer[de].apply($e,X);return Re===!1&&(Re=Ce.apply($e,X)),Re}};for(var st in Fe.renderer)Qe(st);ue.renderer=$e}(),Fe.tokenizer&&function(){var $e=Oe.defaults.tokenizer||new pt,Qe=function(de){var Ce=$e[de];$e[de]=function(){for(var ce=arguments.length,X=new Array(ce),De=0;De<ce;De++)X[De]=arguments[De];var Re=Fe.tokenizer[de].apply($e,X);return Re===!1&&(Re=Ce.apply($e,X)),Re}};for(var st in Fe.tokenizer)Qe(st);ue.tokenizer=$e}(),Fe.walkTokens){var Ke=Oe.defaults.walkTokens;ue.walkTokens=function($e){Fe.walkTokens.call(Te,$e),Ke&&Ke($e)}}_e&&(ue.extensions=we),Oe.setOptions(ue)})},Oe.walkTokens=function(Te,Ie){for(var Se=function(){var _e=ue.value;switch(Ie(_e),_e.type){case"table":{for(var Fe=y(_e.header),Ke;!(Ke=Fe()).done;){var $e=Ke.value;Oe.walkTokens($e.tokens,Ie)}for(var Qe=y(_e.rows),st;!(st=Qe()).done;)for(var at=st.value,de=y(at),Ce;!(Ce=de()).done;){var ce=Ce.value;Oe.walkTokens(ce.tokens,Ie)}break}case"list":{Oe.walkTokens(_e.items,Ie);break}default:Oe.defaults.extensions&&Oe.defaults.extensions.childTokens&&Oe.defaults.extensions.childTokens[_e.type]?Oe.defaults.extensions.childTokens[_e.type].forEach(function(X){Oe.walkTokens(_e[X],Ie)}):_e.tokens&&Oe.walkTokens(_e.tokens,Ie)}},le=y(Te),ue;!(ue=le()).done;)Se()},Oe.parseInline=function(Te,Ie){if(typeof Te=="undefined"||Te===null)throw new Error("marked.parseInline(): input parameter is undefined or null");if(typeof Te!="string")throw new Error("marked.parseInline(): input parameter is of type "+Object.prototype.toString.call(Te)+", string expected");Ie=J({},Oe.defaults,Ie||{}),ie(Ie);try{var Se=it.lexInline(Te,Ie);return Ie.walkTokens&&Oe.walkTokens(Se,Ie.walkTokens),ct.parseInline(Se,Ie)}catch(le){if(le.message+=`
Please report this to https://github.com/markedjs/marked.`,Ie.silent)return"<p>An error occurred:</p><pre>"+ge(le.message+"",!0)+"</pre>";throw le}},Oe.Parser=ct,Oe.parser=ct.parse,Oe.Renderer=Pt,Oe.TextRenderer=Ue,Oe.Lexer=it,Oe.lexer=it.lex,Oe.Tokenizer=pt,Oe.Slugger=Rt,Oe.parse=Oe;var Xe=Oe;return Xe}),define(pe[77],ve([0,1]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.MovingAverage=e.Counter=e.rot=e.clamp=void 0;function m(i,k,S){return Math.min(Math.max(i,k),S)}e.clamp=m;function L(i,k){return(k+i%k)%k}e.rot=L;class y{constructor(){this._next=0}getNext(){return this._next++}}e.Counter=y;class C{constructor(){this._n=1,this._val=0}update(k){return this._val=this._val+(k-this._val)/this._n,this._n+=1,this}get value(){return this._val}}e.MovingAverage=C}),function(){function Y(y){const C=[];typeof y=="number"&&C.push("code/timeOrigin",y);function i(S){C.push(S,Date.now())}function k(){const S=[];for(let D=0;D<C.length;D+=2)S.push({name:C[D],startTime:C[D+1]});return S}return{mark:i,getMarks:k}}function e(){if(typeof performance=="object"&&typeof performance.mark=="function"&&!performance.nodeTiming)return typeof performance.timeOrigin!="number"&&!performance.timing?Y():{mark(y){performance.mark(y)},getMarks(){let y=performance.timeOrigin;typeof y!="number"&&(y=performance.timing.navigationStart||performance.timing.redirectStart||performance.timing.fetchStart);const C=[{name:"code/timeOrigin",startTime:Math.round(y)}];for(const i of performance.getEntriesByType("mark"))C.push({name:i.name,startTime:Math.round(y+i.startTime)});return C}};if(typeof process=="object"){const y=Math.round((require.nodeRequire||require)("perf_hooks").performance.timeOrigin);return Y(y)}else return console.trace("perf-util loaded in UNKNOWN environment"),Y()}function m(y){return y.MonacoPerformanceMarks||(y.MonacoPerformanceMarks=e()),y.MonacoPerformanceMarks}var L;typeof global=="object"?L=global:typeof self=="object"?L=self:L={},typeof define=="function"?define("vs/base/common/performance",[],function(){return m(L)}):typeof module=="object"&&typeof module.exports=="object"?module.exports=m(L):(console.trace("perf-util defined in UNKNOWN context (neither requirejs or commonjs)"),L.perf=m(L))}(),define(pe[12],ve([0,1]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isLittleEndian=e.OS=e.OperatingSystem=e.setImmediate=e.setTimeout0=e.translationsConfigFile=e.locale=e.Language=e.language=e.userAgent=e.platform=e.isIOS=e.isWeb=e.isElectron=e.isNative=e.isLinuxSnap=e.isLinux=e.isMacintosh=e.isWindows=e.PlatformToString=e.Platform=e.isElectronSandboxed=e.globals=void 0;const m="en";let L=!1,y=!1,C=!1,i=!1,k=!1,S=!1,D=!1,R=!1,P,u=m,E,f;e.globals=typeof self=="object"?self:typeof global=="object"?global:{};let v;typeof e.globals.vscode!="undefined"&&typeof e.globals.vscode.process!="undefined"?v=e.globals.vscode.process:typeof process!="undefined"&&(v=process);const w=typeof v?.versions?.electron=="string",I=w&&v?.type==="renderer";if(e.isElectronSandboxed=I&&v?.sandboxed,typeof navigator=="object"&&!I)f=navigator.userAgent,L=f.indexOf("Windows")>=0,y=f.indexOf("Macintosh")>=0,R=(f.indexOf("Macintosh")>=0||f.indexOf("iPad")>=0||f.indexOf("iPhone")>=0)&&!!navigator.maxTouchPoints&&navigator.maxTouchPoints>0,C=f.indexOf("Linux")>=0,S=!0,P=navigator.language,u=P;else if(typeof v=="object"){L=v.platform==="win32",y=v.platform==="darwin",C=v.platform==="linux",i=C&&!!v.env.SNAP&&!!v.env.SNAP_REVISION,D=w,P=m,u=m;const o=v.env.VSCODE_NLS_CONFIG;if(o)try{const d=JSON.parse(o),c=d.availableLanguages["*"];P=d.locale,u=c||m,E=d._translationsConfigFile}catch(d){}k=!0}else console.error("Unable to resolve platform.");var p;(function(o){o[o.Web=0]="Web",o[o.Mac=1]="Mac",o[o.Linux=2]="Linux",o[o.Windows=3]="Windows"})(p=e.Platform||(e.Platform={}));function s(o){switch(o){case 0:return"Web";case 1:return"Mac";case 2:return"Linux";case 3:return"Windows"}}e.PlatformToString=s;let r=0;y?r=1:L?r=3:C&&(r=2),e.isWindows=L,e.isMacintosh=y,e.isLinux=C,e.isLinuxSnap=i,e.isNative=k,e.isElectron=D,e.isWeb=S,e.isIOS=R,e.platform=r,e.userAgent=f,e.language=u;var g;(function(o){function d(){return e.language}o.value=d;function c(){return e.language.length===2?e.language==="en":e.language.length>=3?e.language[0]==="e"&&e.language[1]==="n"&&e.language[2]==="-":!1}o.isDefaultVariant=c;function h(){return e.language==="en"}o.isDefault=h})(g=e.Language||(e.Language={})),e.locale=P,e.translationsConfigFile=E,e.setTimeout0=(()=>{if(typeof e.globals.postMessage=="function"&&!e.globals.importScripts){let o=[];e.globals.addEventListener("message",c=>{if(c.data&&c.data.vscodeScheduleAsyncWork)for(let h=0,l=o.length;h<l;h++){const b=o[h];if(b.id===c.data.vscodeScheduleAsyncWork){o.splice(h,1),b.callback();return}}});let d=0;return c=>{const h=++d;o.push({id:h,callback:c}),e.globals.postMessage({vscodeScheduleAsyncWork:h},"*")}}return o=>setTimeout(o)})(),e.setImmediate=function(){if(e.globals.setImmediate)return e.globals.setImmediate.bind(e.globals);if(typeof e.globals.postMessage=="function"&&!e.globals.importScripts)return e.setTimeout0;if(typeof v?.nextTick=="function")return v.nextTick.bind(v);const d=Promise.resolve();return c=>d.then(c)}();var a;(function(o){o[o.Windows=1]="Windows",o[o.Macintosh=2]="Macintosh",o[o.Linux=3]="Linux"})(a=e.OperatingSystem||(e.OperatingSystem={})),e.OS=y||R?2:L?1:3;let _=!0,n=!1;function t(){if(!n){n=!0;const o=new Uint8Array(2);o[0]=1,o[1]=2,_=new Uint16Array(o.buffer)[0]===(2<<8)+1}return _}e.isLittleEndian=t}),define(pe[40],ve([0,1,12]),function(Y,e,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.arch=e.platform=e.env=e.cwd=void 0;let L;if(typeof m.globals.vscode!="undefined"&&typeof m.globals.vscode.process!="undefined"){const y=m.globals.vscode.process;L={get platform(){return y.platform},get arch(){return y.arch},get env(){return y.env},cwd(){return y.cwd()}}}else typeof process!="undefined"?L={get platform(){return process.platform},get arch(){return process.arch},get env(){return process.env},cwd(){return process.env.VSCODE_CWD||process.cwd()}}:L={get platform(){return m.isWindows?"win32":m.isMacintosh?"darwin":"linux"},get arch(){},get env(){return{}},cwd(){return"/"}};e.cwd=L.cwd,e.env=L.env,e.platform=L.platform,e.arch=L.arch}),define(pe[9],ve([0,1,40]),function(Y,e,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.delimiter=e.sep=e.toNamespacedPath=e.parse=e.format=e.extname=e.basename=e.dirname=e.relative=e.resolve=e.join=e.isAbsolute=e.normalize=e.posix=e.win32=void 0;const L=65,y=97,C=90,i=122,k=46,S=47,D=92,R=58,P=63;class u extends Error{constructor(r,g,a){let _;typeof g=="string"&&g.indexOf("not ")===0?(_="must not be",g=g.replace(/^not /,"")):_="must be";const n=r.indexOf(".")!==-1?"property":"argument";let t=`The "${r}" ${n} ${_} of type ${g}`;t+=`. Received type ${typeof a}`,super(t),this.code="ERR_INVALID_ARG_TYPE"}}function E(s,r){if(typeof s!="string")throw new u(r,"string",s)}function f(s){return s===S||s===D}function v(s){return s===S}function w(s){return s>=L&&s<=C||s>=y&&s<=i}function I(s,r,g,a){let _="",n=0,t=-1,o=0,d=0;for(let c=0;c<=s.length;++c){if(c<s.length)d=s.charCodeAt(c);else{if(a(d))break;d=S}if(a(d)){if(!(t===c-1||o===1))if(o===2){if(_.length<2||n!==2||_.charCodeAt(_.length-1)!==k||_.charCodeAt(_.length-2)!==k){if(_.length>2){const h=_.lastIndexOf(g);h===-1?(_="",n=0):(_=_.slice(0,h),n=_.length-1-_.lastIndexOf(g)),t=c,o=0;continue}else if(_.length!==0){_="",n=0,t=c,o=0;continue}}r&&(_+=_.length>0?`${g}..`:"..",n=2)}else _.length>0?_+=`${g}${s.slice(t+1,c)}`:_=s.slice(t+1,c),n=c-t-1;t=c,o=0}else d===k&&o!==-1?++o:o=-1}return _}function p(s,r){if(r===null||typeof r!="object")throw new u("pathObject","Object",r);const g=r.dir||r.root,a=r.base||`${r.name||""}${r.ext||""}`;return g?g===r.root?`${g}${a}`:`${g}${s}${a}`:a}e.win32={resolve(...s){let r="",g="",a=!1;for(let _=s.length-1;_>=-1;_--){let n;if(_>=0){if(n=s[_],E(n,"path"),n.length===0)continue}else r.length===0?n=m.cwd():(n=m.env[`=${r}`]||m.cwd(),(n===void 0||n.slice(0,2).toLowerCase()!==r.toLowerCase()&&n.charCodeAt(2)===D)&&(n=`${r}\\`));const t=n.length;let o=0,d="",c=!1;const h=n.charCodeAt(0);if(t===1)f(h)&&(o=1,c=!0);else if(f(h))if(c=!0,f(n.charCodeAt(1))){let l=2,b=l;for(;l<t&&!f(n.charCodeAt(l));)l++;if(l<t&&l!==b){const T=n.slice(b,l);for(b=l;l<t&&f(n.charCodeAt(l));)l++;if(l<t&&l!==b){for(b=l;l<t&&!f(n.charCodeAt(l));)l++;(l===t||l!==b)&&(d=`\\\\${T}\\${n.slice(b,l)}`,o=l)}}}else o=1;else w(h)&&n.charCodeAt(1)===R&&(d=n.slice(0,2),o=2,t>2&&f(n.charCodeAt(2))&&(c=!0,o=3));if(d.length>0)if(r.length>0){if(d.toLowerCase()!==r.toLowerCase())continue}else r=d;if(a){if(r.length>0)break}else if(g=`${n.slice(o)}\\${g}`,a=c,c&&r.length>0)break}return g=I(g,!a,"\\",f),a?`${r}\\${g}`:`${r}${g}`||"."},normalize(s){E(s,"path");const r=s.length;if(r===0)return".";let g=0,a,_=!1;const n=s.charCodeAt(0);if(r===1)return v(n)?"\\":s;if(f(n))if(_=!0,f(s.charCodeAt(1))){let o=2,d=o;for(;o<r&&!f(s.charCodeAt(o));)o++;if(o<r&&o!==d){const c=s.slice(d,o);for(d=o;o<r&&f(s.charCodeAt(o));)o++;if(o<r&&o!==d){for(d=o;o<r&&!f(s.charCodeAt(o));)o++;if(o===r)return`\\\\${c}\\${s.slice(d)}\\`;o!==d&&(a=`\\\\${c}\\${s.slice(d,o)}`,g=o)}}}else g=1;else w(n)&&s.charCodeAt(1)===R&&(a=s.slice(0,2),g=2,r>2&&f(s.charCodeAt(2))&&(_=!0,g=3));let t=g<r?I(s.slice(g),!_,"\\",f):"";return t.length===0&&!_&&(t="."),t.length>0&&f(s.charCodeAt(r-1))&&(t+="\\"),a===void 0?_?`\\${t}`:t:_?`${a}\\${t}`:`${a}${t}`},isAbsolute(s){E(s,"path");const r=s.length;if(r===0)return!1;const g=s.charCodeAt(0);return f(g)||r>2&&w(g)&&s.charCodeAt(1)===R&&f(s.charCodeAt(2))},join(...s){if(s.length===0)return".";let r,g;for(let n=0;n<s.length;++n){const t=s[n];E(t,"path"),t.length>0&&(r===void 0?r=g=t:r+=`\\${t}`)}if(r===void 0)return".";let a=!0,_=0;if(typeof g=="string"&&f(g.charCodeAt(0))){++_;const n=g.length;n>1&&f(g.charCodeAt(1))&&(++_,n>2&&(f(g.charCodeAt(2))?++_:a=!1))}if(a){for(;_<r.length&&f(r.charCodeAt(_));)_++;_>=2&&(r=`\\${r.slice(_)}`)}return e.win32.normalize(r)},relative(s,r){if(E(s,"from"),E(r,"to"),s===r)return"";const g=e.win32.resolve(s),a=e.win32.resolve(r);if(g===a||(s=g.toLowerCase(),r=a.toLowerCase(),s===r))return"";let _=0;for(;_<s.length&&s.charCodeAt(_)===D;)_++;let n=s.length;for(;n-1>_&&s.charCodeAt(n-1)===D;)n--;const t=n-_;let o=0;for(;o<r.length&&r.charCodeAt(o)===D;)o++;let d=r.length;for(;d-1>o&&r.charCodeAt(d-1)===D;)d--;const c=d-o,h=t<c?t:c;let l=-1,b=0;for(;b<h;b++){const A=s.charCodeAt(_+b);if(A!==r.charCodeAt(o+b))break;A===D&&(l=b)}if(b!==h){if(l===-1)return a}else{if(c>h){if(r.charCodeAt(o+b)===D)return a.slice(o+b+1);if(b===2)return a.slice(o+b)}t>h&&(s.charCodeAt(_+b)===D?l=b:b===2&&(l=3)),l===-1&&(l=0)}let T="";for(b=_+l+1;b<=n;++b)(b===n||s.charCodeAt(b)===D)&&(T+=T.length===0?"..":"\\..");return o+=l,T.length>0?`${T}${a.slice(o,d)}`:(a.charCodeAt(o)===D&&++o,a.slice(o,d))},toNamespacedPath(s){if(typeof s!="string")return s;if(s.length===0)return"";const r=e.win32.resolve(s);if(r.length<=2)return s;if(r.charCodeAt(0)===D){if(r.charCodeAt(1)===D){const g=r.charCodeAt(2);if(g!==P&&g!==k)return`\\\\?\\UNC\\${r.slice(2)}`}}else if(w(r.charCodeAt(0))&&r.charCodeAt(1)===R&&r.charCodeAt(2)===D)return`\\\\?\\${r}`;return s},dirname(s){E(s,"path");const r=s.length;if(r===0)return".";let g=-1,a=0;const _=s.charCodeAt(0);if(r===1)return f(_)?s:".";if(f(_)){if(g=a=1,f(s.charCodeAt(1))){let o=2,d=o;for(;o<r&&!f(s.charCodeAt(o));)o++;if(o<r&&o!==d){for(d=o;o<r&&f(s.charCodeAt(o));)o++;if(o<r&&o!==d){for(d=o;o<r&&!f(s.charCodeAt(o));)o++;if(o===r)return s;o!==d&&(g=a=o+1)}}}}else w(_)&&s.charCodeAt(1)===R&&(g=r>2&&f(s.charCodeAt(2))?3:2,a=g);let n=-1,t=!0;for(let o=r-1;o>=a;--o)if(f(s.charCodeAt(o))){if(!t){n=o;break}}else t=!1;if(n===-1){if(g===-1)return".";n=g}return s.slice(0,n)},basename(s,r){r!==void 0&&E(r,"ext"),E(s,"path");let g=0,a=-1,_=!0,n;if(s.length>=2&&w(s.charCodeAt(0))&&s.charCodeAt(1)===R&&(g=2),r!==void 0&&r.length>0&&r.length<=s.length){if(r===s)return"";let t=r.length-1,o=-1;for(n=s.length-1;n>=g;--n){const d=s.charCodeAt(n);if(f(d)){if(!_){g=n+1;break}}else o===-1&&(_=!1,o=n+1),t>=0&&(d===r.charCodeAt(t)?--t==-1&&(a=n):(t=-1,a=o))}return g===a?a=o:a===-1&&(a=s.length),s.slice(g,a)}for(n=s.length-1;n>=g;--n)if(f(s.charCodeAt(n))){if(!_){g=n+1;break}}else a===-1&&(_=!1,a=n+1);return a===-1?"":s.slice(g,a)},extname(s){E(s,"path");let r=0,g=-1,a=0,_=-1,n=!0,t=0;s.length>=2&&s.charCodeAt(1)===R&&w(s.charCodeAt(0))&&(r=a=2);for(let o=s.length-1;o>=r;--o){const d=s.charCodeAt(o);if(f(d)){if(!n){a=o+1;break}continue}_===-1&&(n=!1,_=o+1),d===k?g===-1?g=o:t!==1&&(t=1):g!==-1&&(t=-1)}return g===-1||_===-1||t===0||t===1&&g===_-1&&g===a+1?"":s.slice(g,_)},format:p.bind(null,"\\"),parse(s){E(s,"path");const r={root:"",dir:"",base:"",ext:"",name:""};if(s.length===0)return r;const g=s.length;let a=0,_=s.charCodeAt(0);if(g===1)return f(_)?(r.root=r.dir=s,r):(r.base=r.name=s,r);if(f(_)){if(a=1,f(s.charCodeAt(1))){let l=2,b=l;for(;l<g&&!f(s.charCodeAt(l));)l++;if(l<g&&l!==b){for(b=l;l<g&&f(s.charCodeAt(l));)l++;if(l<g&&l!==b){for(b=l;l<g&&!f(s.charCodeAt(l));)l++;l===g?a=l:l!==b&&(a=l+1)}}}}else if(w(_)&&s.charCodeAt(1)===R){if(g<=2)return r.root=r.dir=s,r;if(a=2,f(s.charCodeAt(2))){if(g===3)return r.root=r.dir=s,r;a=3}}a>0&&(r.root=s.slice(0,a));let n=-1,t=a,o=-1,d=!0,c=s.length-1,h=0;for(;c>=a;--c){if(_=s.charCodeAt(c),f(_)){if(!d){t=c+1;break}continue}o===-1&&(d=!1,o=c+1),_===k?n===-1?n=c:h!==1&&(h=1):n!==-1&&(h=-1)}return o!==-1&&(n===-1||h===0||h===1&&n===o-1&&n===t+1?r.base=r.name=s.slice(t,o):(r.name=s.slice(t,n),r.base=s.slice(t,o),r.ext=s.slice(n,o))),t>0&&t!==a?r.dir=s.slice(0,t-1):r.dir=r.root,r},sep:"\\",delimiter:";",win32:null,posix:null},e.posix={resolve(...s){let r="",g=!1;for(let a=s.length-1;a>=-1&&!g;a--){const _=a>=0?s[a]:m.cwd();E(_,"path"),_.length!==0&&(r=`${_}/${r}`,g=_.charCodeAt(0)===S)}return r=I(r,!g,"/",v),g?`/${r}`:r.length>0?r:"."},normalize(s){if(E(s,"path"),s.length===0)return".";const r=s.charCodeAt(0)===S,g=s.charCodeAt(s.length-1)===S;return s=I(s,!r,"/",v),s.length===0?r?"/":g?"./":".":(g&&(s+="/"),r?`/${s}`:s)},isAbsolute(s){return E(s,"path"),s.length>0&&s.charCodeAt(0)===S},join(...s){if(s.length===0)return".";let r;for(let g=0;g<s.length;++g){const a=s[g];E(a,"path"),a.length>0&&(r===void 0?r=a:r+=`/${a}`)}return r===void 0?".":e.posix.normalize(r)},relative(s,r){if(E(s,"from"),E(r,"to"),s===r||(s=e.posix.resolve(s),r=e.posix.resolve(r),s===r))return"";const g=1,a=s.length,_=a-g,n=1,t=r.length-n,o=_<t?_:t;let d=-1,c=0;for(;c<o;c++){const l=s.charCodeAt(g+c);if(l!==r.charCodeAt(n+c))break;l===S&&(d=c)}if(c===o)if(t>o){if(r.charCodeAt(n+c)===S)return r.slice(n+c+1);if(c===0)return r.slice(n+c)}else _>o&&(s.charCodeAt(g+c)===S?d=c:c===0&&(d=0));let h="";for(c=g+d+1;c<=a;++c)(c===a||s.charCodeAt(c)===S)&&(h+=h.length===0?"..":"/..");return`${h}${r.slice(n+d)}`},toNamespacedPath(s){return s},dirname(s){if(E(s,"path"),s.length===0)return".";const r=s.charCodeAt(0)===S;let g=-1,a=!0;for(let _=s.length-1;_>=1;--_)if(s.charCodeAt(_)===S){if(!a){g=_;break}}else a=!1;return g===-1?r?"/":".":r&&g===1?"//":s.slice(0,g)},basename(s,r){r!==void 0&&E(r,"ext"),E(s,"path");let g=0,a=-1,_=!0,n;if(r!==void 0&&r.length>0&&r.length<=s.length){if(r===s)return"";let t=r.length-1,o=-1;for(n=s.length-1;n>=0;--n){const d=s.charCodeAt(n);if(d===S){if(!_){g=n+1;break}}else o===-1&&(_=!1,o=n+1),t>=0&&(d===r.charCodeAt(t)?--t==-1&&(a=n):(t=-1,a=o))}return g===a?a=o:a===-1&&(a=s.length),s.slice(g,a)}for(n=s.length-1;n>=0;--n)if(s.charCodeAt(n)===S){if(!_){g=n+1;break}}else a===-1&&(_=!1,a=n+1);return a===-1?"":s.slice(g,a)},extname(s){E(s,"path");let r=-1,g=0,a=-1,_=!0,n=0;for(let t=s.length-1;t>=0;--t){const o=s.charCodeAt(t);if(o===S){if(!_){g=t+1;break}continue}a===-1&&(_=!1,a=t+1),o===k?r===-1?r=t:n!==1&&(n=1):r!==-1&&(n=-1)}return r===-1||a===-1||n===0||n===1&&r===a-1&&r===g+1?"":s.slice(r,a)},format:p.bind(null,"/"),parse(s){E(s,"path");const r={root:"",dir:"",base:"",ext:"",name:""};if(s.length===0)return r;const g=s.charCodeAt(0)===S;let a;g?(r.root="/",a=1):a=0;let _=-1,n=0,t=-1,o=!0,d=s.length-1,c=0;for(;d>=a;--d){const h=s.charCodeAt(d);if(h===S){if(!o){n=d+1;break}continue}t===-1&&(o=!1,t=d+1),h===k?_===-1?_=d:c!==1&&(c=1):_!==-1&&(c=-1)}if(t!==-1){const h=n===0&&g?1:n;_===-1||c===0||c===1&&_===t-1&&_===n+1?r.base=r.name=s.slice(h,t):(r.name=s.slice(h,_),r.base=s.slice(h,t),r.ext=s.slice(_,t))}return n>0?r.dir=s.slice(0,n-1):g&&(r.dir="/"),r},sep:"/",delimiter:":",win32:null,posix:null},e.posix.win32=e.win32.win32=e.win32,e.posix.posix=e.win32.posix=e.posix,e.normalize=m.platform==="win32"?e.win32.normalize:e.posix.normalize,e.isAbsolute=m.platform==="win32"?e.win32.isAbsolute:e.posix.isAbsolute,e.join=m.platform==="win32"?e.win32.join:e.posix.join,e.resolve=m.platform==="win32"?e.win32.resolve:e.posix.resolve,e.relative=m.platform==="win32"?e.win32.relative:e.posix.relative,e.dirname=m.platform==="win32"?e.win32.dirname:e.posix.dirname,e.basename=m.platform==="win32"?e.win32.basename:e.posix.basename,e.extname=m.platform==="win32"?e.win32.extname:e.posix.extname,e.format=m.platform==="win32"?e.win32.format:e.posix.format,e.parse=m.platform==="win32"?e.win32.parse:e.posix.parse,e.toNamespacedPath=m.platform==="win32"?e.win32.toNamespacedPath:e.posix.toNamespacedPath,e.sep=m.platform==="win32"?e.win32.sep:e.posix.sep,e.delimiter=m.platform==="win32"?e.win32.delimiter:e.posix.delimiter}),define(pe[94],ve([0,1]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.sanitizeProcessEnvironment=e.TerminateResponseCode=e.Source=void 0;var m;(function(C){C[C.stdout=0]="stdout",C[C.stderr=1]="stderr"})(m=e.Source||(e.Source={}));var L;(function(C){C[C.Success=0]="Success",C[C.Unknown=1]="Unknown",C[C.AccessDenied=2]="AccessDenied",C[C.ProcessNotFound=3]="ProcessNotFound"})(L=e.TerminateResponseCode||(e.TerminateResponseCode={}));function y(C,...i){const k=i.reduce((R,P)=>(R[P]=!0,R),{}),S=[/^ELECTRON_.+$/,/^VSCODE_.+$/,/^SNAP(|_.*)$/,/^GDK_PIXBUF_.+$/];Object.keys(C).filter(R=>!k[R]).forEach(R=>{for(let P=0;P<S.length;P++)if(R.search(S[P])!==-1){delete C[R];break}})}e.sanitizeProcessEnvironment=y}),define(pe[46],ve([0,1,12]),function(Y,e,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StopWatch=void 0;const L=m.globals.performance&&typeof m.globals.performance.now=="function";class y{constructor(i){this._highResolution=L&&i,this._startTime=this._now(),this._stopTime=-1}static create(i=!0){return new y(i)}stop(){this._stopTime=this._now()}elapsed(){return this._stopTime!==-1?this._stopTime-this._startTime:this._now()-this._startTime}_now(){return this._highResolution?m.globals.performance.now():Date.now()}}e.StopWatch=y}),define(pe[3],ve([0,1,15,74,6,93,46]),function(Y,e,m,L,y,C,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Relay=e.EventBufferer=e.EventMultiplexer=e.MicrotaskEmitter=e.DebounceEmitter=e.PauseableEmitter=e.AsyncEmitter=e.Emitter=e.setGlobalLeakWarningThreshold=e.Event=void 0;var k;(function(r){r.None=()=>y.Disposable.None;function g(M){return(B,U=null,z)=>{let K=!1,N;return N=M(j=>{if(!K)return N?N.dispose():K=!0,B.call(U,j)},null,z),K&&N.dispose(),N}}r.once=g;function a(M,B){return c((U,z=null,K)=>M(N=>U.call(z,B(N)),null,K))}r.map=a;function _(M,B){return c((U,z=null,K)=>M(N=>{B(N),U.call(z,N)},null,K))}r.forEach=_;function n(M,B){return c((U,z=null,K)=>M(N=>B(N)&&U.call(z,N),null,K))}r.filter=n;function t(M){return M}r.signal=t;function o(...M){return(B,U=null,z)=>(0,y.combinedDisposable)(...M.map(K=>K(N=>B.call(U,N),null,z)))}r.any=o;function d(M,B,U){let z=U;return a(M,K=>(z=B(z,K),z))}r.reduce=d;function c(M){let B;const U=new u({onFirstListenerAdd(){B=M(U.fire,U)},onLastListenerRemove(){B.dispose()}});return U.event}function h(M,B,U=100,z=!1,K){let N,j,H,V=0;const q=new u({leakWarningThreshold:K,onFirstListenerAdd(){N=M(ne=>{V++,j=B(j,ne),z&&!H&&(q.fire(j),j=void 0),clearTimeout(H),H=setTimeout(()=>{const fe=j;j=void 0,H=void 0,(!z||V>1)&&q.fire(fe),V=0},U)})},onLastListenerRemove(){N.dispose()}});return q.event}r.debounce=h;function l(M,B=(U,z)=>U===z){let U=!0,z;return n(M,K=>{const N=U||!B(K,z);return U=!1,z=K,N})}r.latch=l;function b(M,B){return[r.filter(M,B),r.filter(M,U=>!B(U))]}r.split=b;function T(M,B=!1,U=[]){let z=U.slice(),K=M(H=>{z?z.push(H):j.fire(H)});const N=()=>{z&&z.forEach(H=>j.fire(H)),z=null},j=new u({onFirstListenerAdd(){K||(K=M(H=>j.fire(H)))},onFirstListenerDidAdd(){z&&(B?setTimeout(N):N())},onLastListenerRemove(){K&&K.dispose(),K=null}});return j.event}r.buffer=T;class A{constructor(B){this.event=B}map(B){return new A(a(this.event,B))}forEach(B){return new A(_(this.event,B))}filter(B){return new A(n(this.event,B))}reduce(B,U){return new A(d(this.event,B,U))}latch(){return new A(l(this.event))}debounce(B,U=100,z=!1,K){return new A(h(this.event,B,U,z,K))}on(B,U,z){return this.event(B,U,z)}once(B,U,z){return g(this.event)(B,U,z)}}function x(M){return new A(M)}r.chain=x;function O(M,B,U=z=>z){const z=(...H)=>j.fire(U(...H)),K=()=>M.on(B,z),N=()=>M.removeListener(B,z),j=new u({onFirstListenerAdd:K,onLastListenerRemove:N});return j.event}r.fromNodeEventEmitter=O;function F(M,B,U=z=>z){const z=(...H)=>j.fire(U(...H)),K=()=>M.addEventListener(B,z),N=()=>M.removeEventListener(B,z),j=new u({onFirstListenerAdd:K,onLastListenerRemove:N});return j.event}r.fromDOMEventEmitter=F;function W(M){return new Promise(B=>g(M)(B))}r.toPromise=W})(k=e.Event||(e.Event={}));class S{constructor(g){this._listenerCount=0,this._invocationCount=0,this._elapsedOverall=0,this._name=`${g}_${S._idPool++}`}start(g){this._stopWatch=new i.StopWatch(!0),this._listenerCount=g}stop(){if(this._stopWatch){const g=this._stopWatch.elapsed();this._elapsedOverall+=g,this._invocationCount+=1,console.info(`did FIRE ${this._name}: elapsed_ms: ${g.toFixed(5)}, listener: ${this._listenerCount} (elapsed_overall: ${this._elapsedOverall.toFixed(2)}, invocations: ${this._invocationCount})`),this._stopWatch=void 0}}}S._idPool=0;let D=-1;function R(r){const g=D;return D=r,{dispose(){D=g}}}e.setGlobalLeakWarningThreshold=R;class P{constructor(g,a=Math.random().toString(18).slice(2,5)){this.customThreshold=g,this.name=a,this._warnCountdown=0}dispose(){this._stacks&&this._stacks.clear()}check(g){let a=D;if(typeof this.customThreshold=="number"&&(a=this.customThreshold),a<=0||g<a)return;this._stacks||(this._stacks=new Map);const _=new Error().stack.split(`
`).slice(3).join(`
`),n=this._stacks.get(_)||0;if(this._stacks.set(_,n+1),this._warnCountdown-=1,this._warnCountdown<=0){this._warnCountdown=a*.5;let t,o=0;for(const[d,c]of this._stacks)(!t||o<c)&&(t=d,o=c);console.warn(`[${this.name}] potential listener LEAK detected, having ${g} listeners already. MOST frequent listener (${o}):`),console.warn(t)}return()=>{const t=this._stacks.get(_)||0;this._stacks.set(_,t-1)}}}class u{constructor(g){this._disposed=!1,this._options=g,this._leakageMon=D>0?new P(this._options&&this._options.leakWarningThreshold):void 0,this._perfMon=this._options?._profName?new S(this._options._profName):void 0}get event(){return this._event||(this._event=(g,a,_)=>{this._listeners||(this._listeners=new C.LinkedList);const n=this._listeners.isEmpty();n&&this._options&&this._options.onFirstListenerAdd&&this._options.onFirstListenerAdd(this);const t=this._listeners.push(a?[g,a]:g);n&&this._options&&this._options.onFirstListenerDidAdd&&this._options.onFirstListenerDidAdd(this),this._options&&this._options.onListenerDidAdd&&this._options.onListenerDidAdd(this,g,a);const o=this._leakageMon?.check(this._listeners.size),d=(0,y.toDisposable)(()=>{o&&o(),this._disposed||(t(),this._options&&this._options.onLastListenerRemove&&(this._listeners&&!this._listeners.isEmpty()||this._options.onLastListenerRemove(this)))});return _ instanceof y.DisposableStore?_.add(d):Array.isArray(_)&&_.push(d),d}),this._event}fire(g){if(this._listeners){this._deliveryQueue||(this._deliveryQueue=new C.LinkedList);for(let a of this._listeners)this._deliveryQueue.push([a,g]);for(this._perfMon?.start(this._deliveryQueue.size);this._deliveryQueue.size>0;){const[a,_]=this._deliveryQueue.shift();try{typeof a=="function"?a.call(void 0,_):a[0].call(a[1],_)}catch(n){(0,m.onUnexpectedError)(n)}}this._perfMon?.stop()}}dispose(){this._disposed||(this._disposed=!0,this._listeners?.clear(),this._deliveryQueue?.clear(),this._options?.onLastListenerRemove?.(),this._leakageMon?.dispose())}}e.Emitter=u;class E extends u{async fireAsync(g,a,_){if(!!this._listeners){this._asyncDeliveryQueue||(this._asyncDeliveryQueue=new C.LinkedList);for(const n of this._listeners)this._asyncDeliveryQueue.push([n,g]);for(;this._asyncDeliveryQueue.size>0&&!a.isCancellationRequested;){const[n,t]=this._asyncDeliveryQueue.shift(),o=[],d={...t,waitUntil:c=>{if(Object.isFrozen(o))throw new Error("waitUntil can NOT be called asynchronous");_&&(c=_(c,typeof n=="function"?n:n[0])),o.push(c)}};try{typeof n=="function"?n.call(void 0,d):n[0].call(n[1],d)}catch(c){(0,m.onUnexpectedError)(c);continue}Object.freeze(o),await Promise.allSettled(o).then(c=>{for(const h of c)h.status==="rejected"&&(0,m.onUnexpectedError)(h.reason)})}}}}e.AsyncEmitter=E;class f extends u{constructor(g){super(g);this._isPaused=0,this._eventQueue=new C.LinkedList,this._mergeFn=g?.merge}pause(){this._isPaused++}resume(){if(this._isPaused!==0&&--this._isPaused==0)if(this._mergeFn){const g=Array.from(this._eventQueue);this._eventQueue.clear(),super.fire(this._mergeFn(g))}else for(;!this._isPaused&&this._eventQueue.size!==0;)super.fire(this._eventQueue.shift())}fire(g){this._listeners&&(this._isPaused!==0?this._eventQueue.push(g):super.fire(g))}}e.PauseableEmitter=f;class v extends f{constructor(g){super(g);this._delay=g.delay??100}fire(g){this._handle||(this.pause(),this._handle=setTimeout(()=>{this._handle=void 0,this.resume()},this._delay)),super.fire(g)}}e.DebounceEmitter=v;class w extends u{constructor(g){super(g);this._queuedEvents=[],this._mergeFn=g?.merge}fire(g){this._queuedEvents.push(g),this._queuedEvents.length===1&&queueMicrotask(()=>{this._mergeFn?super.fire(this._mergeFn(this._queuedEvents)):this._queuedEvents.forEach(a=>super.fire(a)),this._queuedEvents=[]})}}e.MicrotaskEmitter=w;class I{constructor(){this.hasListeners=!1,this.events=[],this.emitter=new u({onFirstListenerAdd:()=>this.onFirstListenerAdd(),onLastListenerRemove:()=>this.onLastListenerRemove()})}get event(){return this.emitter.event}add(g){const a={event:g,listener:null};this.events.push(a),this.hasListeners&&this.hook(a);const _=()=>{this.hasListeners&&this.unhook(a);const n=this.events.indexOf(a);this.events.splice(n,1)};return(0,y.toDisposable)((0,L.once)(_))}onFirstListenerAdd(){this.hasListeners=!0,this.events.forEach(g=>this.hook(g))}onLastListenerRemove(){this.hasListeners=!1,this.events.forEach(g=>this.unhook(g))}hook(g){g.listener=g.event(a=>this.emitter.fire(a))}unhook(g){g.listener&&g.listener.dispose(),g.listener=null}dispose(){this.emitter.dispose()}}e.EventMultiplexer=I;class p{constructor(){this.buffers=[]}wrapEvent(g){return(a,_,n)=>g(t=>{const o=this.buffers[this.buffers.length-1];o?o.push(()=>a.call(_,t)):a.call(_,t)},void 0,n)}bufferEvents(g){const a=[];this.buffers.push(a);const _=g();return this.buffers.pop(),a.forEach(n=>n()),_}}e.EventBufferer=p;class s{constructor(){this.listening=!1,this.inputEvent=k.None,this.inputEventListener=y.Disposable.None,this.emitter=new u({onFirstListenerDidAdd:()=>{this.listening=!0,this.inputEventListener=this.inputEvent(this.emitter.fire,this.emitter)},onLastListenerRemove:()=>{this.listening=!1,this.inputEventListener.dispose()}}),this.event=this.emitter.event}set input(g){this.inputEvent=g,this.listening&&(this.inputEventListener.dispose(),this.inputEventListener=g(this.emitter.fire,this.emitter))}dispose(){this.inputEventListener.dispose(),this.emitter.dispose()}}e.Relay=s}),define(pe[21],ve([0,1,3]),function(Y,e,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CancellationTokenSource=e.CancellationToken=void 0;const L=Object.freeze(function(k,S){const D=setTimeout(k.bind(S),0);return{dispose(){clearTimeout(D)}}});var y;(function(k){function S(D){return D===k.None||D===k.Cancelled||D instanceof C?!0:!D||typeof D!="object"?!1:typeof D.isCancellationRequested=="boolean"&&typeof D.onCancellationRequested=="function"}k.isCancellationToken=S,k.None=Object.freeze({isCancellationRequested:!1,onCancellationRequested:m.Event.None}),k.Cancelled=Object.freeze({isCancellationRequested:!0,onCancellationRequested:L})})(y=e.CancellationToken||(e.CancellationToken={}));class C{constructor(){this._isCancelled=!1,this._emitter=null}cancel(){this._isCancelled||(this._isCancelled=!0,this._emitter&&(this._emitter.fire(void 0),this.dispose()))}get isCancellationRequested(){return this._isCancelled}get onCancellationRequested(){return this._isCancelled?L:(this._emitter||(this._emitter=new m.Emitter),this._emitter.event)}dispose(){this._emitter&&(this._emitter.dispose(),this._emitter=null)}}class i{constructor(S){this._token=void 0,this._parentListener=void 0,this._parentListener=S&&S.onCancellationRequested(this.cancel,this)}get token(){return this._token||(this._token=new C),this._token}cancel(){this._token?this._token instanceof C&&this._token.cancel():this._token=y.Cancelled}dispose(S=!1){S&&this.cancel(),this._parentListener&&this._parentListener.dispose(),this._token?this._token instanceof C&&this._token.dispose():this._token=y.None}}e.CancellationTokenSource=i}),define(pe[78],ve([0,1,3]),function(Y,e,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CSSIcon=e.getClassNamesArray=e.Codicon=e.getCodiconAriaLabel=e.iconRegistry=void 0;class L{constructor(){this._icons=new Map,this._onDidRegister=new m.Emitter}add(R){const P=this._icons.get(R.id);P?R.description?P.description=R.description:console.error(`Duplicate registration of codicon ${R.id}`):(this._icons.set(R.id,R),this._onDidRegister.fire(R))}get(R){return this._icons.get(R)}get all(){return this._icons.values()}get onDidRegister(){return this._onDidRegister.event}}const y=new L;e.iconRegistry=y;function C(D){return D?D.replace(/\$\((.*?)\)/g,(R,P)=>` ${P} `).trim():""}e.getCodiconAriaLabel=C;class i{constructor(R,P,u){this.id=R,this.definition=P,this.description=u,y.add(this)}get classNames(){return"codicon codicon-"+this.id}get classNamesArray(){return["codicon","codicon-"+this.id]}get cssSelector(){return".codicon.codicon-"+this.id}}e.Codicon=i,i.add=new i("add",{fontCharacter:"\\ea60"}),i.plus=new i("plus",i.add.definition),i.gistNew=new i("gist-new",i.add.definition),i.repoCreate=new i("repo-create",i.add.definition),i.lightbulb=new i("lightbulb",{fontCharacter:"\\ea61"}),i.lightBulb=new i("light-bulb",{fontCharacter:"\\ea61"}),i.repo=new i("repo",{fontCharacter:"\\ea62"}),i.repoDelete=new i("repo-delete",{fontCharacter:"\\ea62"}),i.gistFork=new i("gist-fork",{fontCharacter:"\\ea63"}),i.repoForked=new i("repo-forked",{fontCharacter:"\\ea63"}),i.gitPullRequest=new i("git-pull-request",{fontCharacter:"\\ea64"}),i.gitPullRequestAbandoned=new i("git-pull-request-abandoned",{fontCharacter:"\\ea64"}),i.recordKeys=new i("record-keys",{fontCharacter:"\\ea65"}),i.keyboard=new i("keyboard",{fontCharacter:"\\ea65"}),i.tag=new i("tag",{fontCharacter:"\\ea66"}),i.tagAdd=new i("tag-add",{fontCharacter:"\\ea66"}),i.tagRemove=new i("tag-remove",{fontCharacter:"\\ea66"}),i.person=new i("person",{fontCharacter:"\\ea67"}),i.personFollow=new i("person-follow",{fontCharacter:"\\ea67"}),i.personOutline=new i("person-outline",{fontCharacter:"\\ea67"}),i.personFilled=new i("person-filled",{fontCharacter:"\\ea67"}),i.gitBranch=new i("git-branch",{fontCharacter:"\\ea68"}),i.gitBranchCreate=new i("git-branch-create",{fontCharacter:"\\ea68"}),i.gitBranchDelete=new i("git-branch-delete",{fontCharacter:"\\ea68"}),i.sourceControl=new i("source-control",{fontCharacter:"\\ea68"}),i.mirror=new i("mirror",{fontCharacter:"\\ea69"}),i.mirrorPublic=new i("mirror-public",{fontCharacter:"\\ea69"}),i.star=new i("star",{fontCharacter:"\\ea6a"}),i.starAdd=new i("star-add",{fontCharacter:"\\ea6a"}),i.starDelete=new i("star-delete",{fontCharacter:"\\ea6a"}),i.starEmpty=new i("star-empty",{fontCharacter:"\\ea6a"}),i.comment=new i("comment",{fontCharacter:"\\ea6b"}),i.commentAdd=new i("comment-add",{fontCharacter:"\\ea6b"}),i.alert=new i("alert",{fontCharacter:"\\ea6c"}),i.warning=new i("warning",{fontCharacter:"\\ea6c"}),i.search=new i("search",{fontCharacter:"\\ea6d"}),i.searchSave=new i("search-save",{fontCharacter:"\\ea6d"}),i.logOut=new i("log-out",{fontCharacter:"\\ea6e"}),i.signOut=new i("sign-out",{fontCharacter:"\\ea6e"}),i.logIn=new i("log-in",{fontCharacter:"\\ea6f"}),i.signIn=new i("sign-in",{fontCharacter:"\\ea6f"}),i.eye=new i("eye",{fontCharacter:"\\ea70"}),i.eyeUnwatch=new i("eye-unwatch",{fontCharacter:"\\ea70"}),i.eyeWatch=new i("eye-watch",{fontCharacter:"\\ea70"}),i.circleFilled=new i("circle-filled",{fontCharacter:"\\ea71"}),i.primitiveDot=new i("primitive-dot",{fontCharacter:"\\ea71"}),i.closeDirty=new i("close-dirty",{fontCharacter:"\\ea71"}),i.debugBreakpoint=new i("debug-breakpoint",{fontCharacter:"\\ea71"}),i.debugBreakpointDisabled=new i("debug-breakpoint-disabled",{fontCharacter:"\\ea71"}),i.debugHint=new i("debug-hint",{fontCharacter:"\\ea71"}),i.primitiveSquare=new i("primitive-square",{fontCharacter:"\\ea72"}),i.edit=new i("edit",{fontCharacter:"\\ea73"}),i.pencil=new i("pencil",{fontCharacter:"\\ea73"}),i.info=new i("info",{fontCharacter:"\\ea74"}),i.issueOpened=new i("issue-opened",{fontCharacter:"\\ea74"}),i.gistPrivate=new i("gist-private",{fontCharacter:"\\ea75"}),i.gitForkPrivate=new i("git-fork-private",{fontCharacter:"\\ea75"}),i.lock=new i("lock",{fontCharacter:"\\ea75"}),i.mirrorPrivate=new i("mirror-private",{fontCharacter:"\\ea75"}),i.close=new i("close",{fontCharacter:"\\ea76"}),i.removeClose=new i("remove-close",{fontCharacter:"\\ea76"}),i.x=new i("x",{fontCharacter:"\\ea76"}),i.repoSync=new i("repo-sync",{fontCharacter:"\\ea77"}),i.sync=new i("sync",{fontCharacter:"\\ea77"}),i.clone=new i("clone",{fontCharacter:"\\ea78"}),i.desktopDownload=new i("desktop-download",{fontCharacter:"\\ea78"}),i.beaker=new i("beaker",{fontCharacter:"\\ea79"}),i.microscope=new i("microscope",{fontCharacter:"\\ea79"}),i.vm=new i("vm",{fontCharacter:"\\ea7a"}),i.deviceDesktop=new i("device-desktop",{fontCharacter:"\\ea7a"}),i.file=new i("file",{fontCharacter:"\\ea7b"}),i.fileText=new i("file-text",{fontCharacter:"\\ea7b"}),i.more=new i("more",{fontCharacter:"\\ea7c"}),i.ellipsis=new i("ellipsis",{fontCharacter:"\\ea7c"}),i.kebabHorizontal=new i("kebab-horizontal",{fontCharacter:"\\ea7c"}),i.mailReply=new i("mail-reply",{fontCharacter:"\\ea7d"}),i.reply=new i("reply",{fontCharacter:"\\ea7d"}),i.organization=new i("organization",{fontCharacter:"\\ea7e"}),i.organizationFilled=new i("organization-filled",{fontCharacter:"\\ea7e"}),i.organizationOutline=new i("organization-outline",{fontCharacter:"\\ea7e"}),i.newFile=new i("new-file",{fontCharacter:"\\ea7f"}),i.fileAdd=new i("file-add",{fontCharacter:"\\ea7f"}),i.newFolder=new i("new-folder",{fontCharacter:"\\ea80"}),i.fileDirectoryCreate=new i("file-directory-create",{fontCharacter:"\\ea80"}),i.trash=new i("trash",{fontCharacter:"\\ea81"}),i.trashcan=new i("trashcan",{fontCharacter:"\\ea81"}),i.history=new i("history",{fontCharacter:"\\ea82"}),i.clock=new i("clock",{fontCharacter:"\\ea82"}),i.folder=new i("folder",{fontCharacter:"\\ea83"}),i.fileDirectory=new i("file-directory",{fontCharacter:"\\ea83"}),i.symbolFolder=new i("symbol-folder",{fontCharacter:"\\ea83"}),i.logoGithub=new i("logo-github",{fontCharacter:"\\ea84"}),i.markGithub=new i("mark-github",{fontCharacter:"\\ea84"}),i.github=new i("github",{fontCharacter:"\\ea84"}),i.terminal=new i("terminal",{fontCharacter:"\\ea85"}),i.console=new i("console",{fontCharacter:"\\ea85"}),i.repl=new i("repl",{fontCharacter:"\\ea85"}),i.zap=new i("zap",{fontCharacter:"\\ea86"}),i.symbolEvent=new i("symbol-event",{fontCharacter:"\\ea86"}),i.error=new i("error",{fontCharacter:"\\ea87"}),i.stop=new i("stop",{fontCharacter:"\\ea87"}),i.variable=new i("variable",{fontCharacter:"\\ea88"}),i.symbolVariable=new i("symbol-variable",{fontCharacter:"\\ea88"}),i.array=new i("array",{fontCharacter:"\\ea8a"}),i.symbolArray=new i("symbol-array",{fontCharacter:"\\ea8a"}),i.symbolModule=new i("symbol-module",{fontCharacter:"\\ea8b"}),i.symbolPackage=new i("symbol-package",{fontCharacter:"\\ea8b"}),i.symbolNamespace=new i("symbol-namespace",{fontCharacter:"\\ea8b"}),i.symbolObject=new i("symbol-object",{fontCharacter:"\\ea8b"}),i.symbolMethod=new i("symbol-method",{fontCharacter:"\\ea8c"}),i.symbolFunction=new i("symbol-function",{fontCharacter:"\\ea8c"}),i.symbolConstructor=new i("symbol-constructor",{fontCharacter:"\\ea8c"}),i.symbolBoolean=new i("symbol-boolean",{fontCharacter:"\\ea8f"}),i.symbolNull=new i("symbol-null",{fontCharacter:"\\ea8f"}),i.symbolNumeric=new i("symbol-numeric",{fontCharacter:"\\ea90"}),i.symbolNumber=new i("symbol-number",{fontCharacter:"\\ea90"}),i.symbolStructure=new i("symbol-structure",{fontCharacter:"\\ea91"}),i.symbolStruct=new i("symbol-struct",{fontCharacter:"\\ea91"}),i.symbolParameter=new i("symbol-parameter",{fontCharacter:"\\ea92"}),i.symbolTypeParameter=new i("symbol-type-parameter",{fontCharacter:"\\ea92"}),i.symbolKey=new i("symbol-key",{fontCharacter:"\\ea93"}),i.symbolText=new i("symbol-text",{fontCharacter:"\\ea93"}),i.symbolReference=new i("symbol-reference",{fontCharacter:"\\ea94"}),i.goToFile=new i("go-to-file",{fontCharacter:"\\ea94"}),i.symbolEnum=new i("symbol-enum",{fontCharacter:"\\ea95"}),i.symbolValue=new i("symbol-value",{fontCharacter:"\\ea95"}),i.symbolRuler=new i("symbol-ruler",{fontCharacter:"\\ea96"}),i.symbolUnit=new i("symbol-unit",{fontCharacter:"\\ea96"}),i.activateBreakpoints=new i("activate-breakpoints",{fontCharacter:"\\ea97"}),i.archive=new i("archive",{fontCharacter:"\\ea98"}),i.arrowBoth=new i("arrow-both",{fontCharacter:"\\ea99"}),i.arrowDown=new i("arrow-down",{fontCharacter:"\\ea9a"}),i.arrowLeft=new i("arrow-left",{fontCharacter:"\\ea9b"}),i.arrowRight=new i("arrow-right",{fontCharacter:"\\ea9c"}),i.arrowSmallDown=new i("arrow-small-down",{fontCharacter:"\\ea9d"}),i.arrowSmallLeft=new i("arrow-small-left",{fontCharacter:"\\ea9e"}),i.arrowSmallRight=new i("arrow-small-right",{fontCharacter:"\\ea9f"}),i.arrowSmallUp=new i("arrow-small-up",{fontCharacter:"\\eaa0"}),i.arrowUp=new i("arrow-up",{fontCharacter:"\\eaa1"}),i.bell=new i("bell",{fontCharacter:"\\eaa2"}),i.bold=new i("bold",{fontCharacter:"\\eaa3"}),i.book=new i("book",{fontCharacter:"\\eaa4"}),i.bookmark=new i("bookmark",{fontCharacter:"\\eaa5"}),i.debugBreakpointConditionalUnverified=new i("debug-breakpoint-conditional-unverified",{fontCharacter:"\\eaa6"}),i.debugBreakpointConditional=new i("debug-breakpoint-conditional",{fontCharacter:"\\eaa7"}),i.debugBreakpointConditionalDisabled=new i("debug-breakpoint-conditional-disabled",{fontCharacter:"\\eaa7"}),i.debugBreakpointDataUnverified=new i("debug-breakpoint-data-unverified",{fontCharacter:"\\eaa8"}),i.debugBreakpointData=new i("debug-breakpoint-data",{fontCharacter:"\\eaa9"}),i.debugBreakpointDataDisabled=new i("debug-breakpoint-data-disabled",{fontCharacter:"\\eaa9"}),i.debugBreakpointLogUnverified=new i("debug-breakpoint-log-unverified",{fontCharacter:"\\eaaa"}),i.debugBreakpointLog=new i("debug-breakpoint-log",{fontCharacter:"\\eaab"}),i.debugBreakpointLogDisabled=new i("debug-breakpoint-log-disabled",{fontCharacter:"\\eaab"}),i.briefcase=new i("briefcase",{fontCharacter:"\\eaac"}),i.broadcast=new i("broadcast",{fontCharacter:"\\eaad"}),i.browser=new i("browser",{fontCharacter:"\\eaae"}),i.bug=new i("bug",{fontCharacter:"\\eaaf"}),i.calendar=new i("calendar",{fontCharacter:"\\eab0"}),i.caseSensitive=new i("case-sensitive",{fontCharacter:"\\eab1"}),i.check=new i("check",{fontCharacter:"\\eab2"}),i.checklist=new i("checklist",{fontCharacter:"\\eab3"}),i.chevronDown=new i("chevron-down",{fontCharacter:"\\eab4"}),i.dropDownButton=new i("drop-down-button",i.chevronDown.definition),i.chevronLeft=new i("chevron-left",{fontCharacter:"\\eab5"}),i.chevronRight=new i("chevron-right",{fontCharacter:"\\eab6"}),i.chevronUp=new i("chevron-up",{fontCharacter:"\\eab7"}),i.chromeClose=new i("chrome-close",{fontCharacter:"\\eab8"}),i.chromeMaximize=new i("chrome-maximize",{fontCharacter:"\\eab9"}),i.chromeMinimize=new i("chrome-minimize",{fontCharacter:"\\eaba"}),i.chromeRestore=new i("chrome-restore",{fontCharacter:"\\eabb"}),i.circleOutline=new i("circle-outline",{fontCharacter:"\\eabc"}),i.debugBreakpointUnverified=new i("debug-breakpoint-unverified",{fontCharacter:"\\eabc"}),i.circleSlash=new i("circle-slash",{fontCharacter:"\\eabd"}),i.circuitBoard=new i("circuit-board",{fontCharacter:"\\eabe"}),i.clearAll=new i("clear-all",{fontCharacter:"\\eabf"}),i.clippy=new i("clippy",{fontCharacter:"\\eac0"}),i.closeAll=new i("close-all",{fontCharacter:"\\eac1"}),i.cloudDownload=new i("cloud-download",{fontCharacter:"\\eac2"}),i.cloudUpload=new i("cloud-upload",{fontCharacter:"\\eac3"}),i.code=new i("code",{fontCharacter:"\\eac4"}),i.collapseAll=new i("collapse-all",{fontCharacter:"\\eac5"}),i.colorMode=new i("color-mode",{fontCharacter:"\\eac6"}),i.commentDiscussion=new i("comment-discussion",{fontCharacter:"\\eac7"}),i.compareChanges=new i("compare-changes",{fontCharacter:"\\eafd"}),i.creditCard=new i("credit-card",{fontCharacter:"\\eac9"}),i.dash=new i("dash",{fontCharacter:"\\eacc"}),i.dashboard=new i("dashboard",{fontCharacter:"\\eacd"}),i.database=new i("database",{fontCharacter:"\\eace"}),i.debugContinue=new i("debug-continue",{fontCharacter:"\\eacf"}),i.debugDisconnect=new i("debug-disconnect",{fontCharacter:"\\ead0"}),i.debugPause=new i("debug-pause",{fontCharacter:"\\ead1"}),i.debugRestart=new i("debug-restart",{fontCharacter:"\\ead2"}),i.debugStart=new i("debug-start",{fontCharacter:"\\ead3"}),i.debugStepInto=new i("debug-step-into",{fontCharacter:"\\ead4"}),i.debugStepOut=new i("debug-step-out",{fontCharacter:"\\ead5"}),i.debugStepOver=new i("debug-step-over",{fontCharacter:"\\ead6"}),i.debugStop=new i("debug-stop",{fontCharacter:"\\ead7"}),i.debug=new i("debug",{fontCharacter:"\\ead8"}),i.deviceCameraVideo=new i("device-camera-video",{fontCharacter:"\\ead9"}),i.deviceCamera=new i("device-camera",{fontCharacter:"\\eada"}),i.deviceMobile=new i("device-mobile",{fontCharacter:"\\eadb"}),i.diffAdded=new i("diff-added",{fontCharacter:"\\eadc"}),i.diffIgnored=new i("diff-ignored",{fontCharacter:"\\eadd"}),i.diffModified=new i("diff-modified",{fontCharacter:"\\eade"}),i.diffRemoved=new i("diff-removed",{fontCharacter:"\\eadf"}),i.diffRenamed=new i("diff-renamed",{fontCharacter:"\\eae0"}),i.diff=new i("diff",{fontCharacter:"\\eae1"}),i.discard=new i("discard",{fontCharacter:"\\eae2"}),i.editorLayout=new i("editor-layout",{fontCharacter:"\\eae3"}),i.emptyWindow=new i("empty-window",{fontCharacter:"\\eae4"}),i.exclude=new i("exclude",{fontCharacter:"\\eae5"}),i.extensions=new i("extensions",{fontCharacter:"\\eae6"}),i.eyeClosed=new i("eye-closed",{fontCharacter:"\\eae7"}),i.fileBinary=new i("file-binary",{fontCharacter:"\\eae8"}),i.fileCode=new i("file-code",{fontCharacter:"\\eae9"}),i.fileMedia=new i("file-media",{fontCharacter:"\\eaea"}),i.filePdf=new i("file-pdf",{fontCharacter:"\\eaeb"}),i.fileSubmodule=new i("file-submodule",{fontCharacter:"\\eaec"}),i.fileSymlinkDirectory=new i("file-symlink-directory",{fontCharacter:"\\eaed"}),i.fileSymlinkFile=new i("file-symlink-file",{fontCharacter:"\\eaee"}),i.fileZip=new i("file-zip",{fontCharacter:"\\eaef"}),i.files=new i("files",{fontCharacter:"\\eaf0"}),i.filter=new i("filter",{fontCharacter:"\\eaf1"}),i.flame=new i("flame",{fontCharacter:"\\eaf2"}),i.foldDown=new i("fold-down",{fontCharacter:"\\eaf3"}),i.foldUp=new i("fold-up",{fontCharacter:"\\eaf4"}),i.fold=new i("fold",{fontCharacter:"\\eaf5"}),i.folderActive=new i("folder-active",{fontCharacter:"\\eaf6"}),i.folderOpened=new i("folder-opened",{fontCharacter:"\\eaf7"}),i.gear=new i("gear",{fontCharacter:"\\eaf8"}),i.gift=new i("gift",{fontCharacter:"\\eaf9"}),i.gistSecret=new i("gist-secret",{fontCharacter:"\\eafa"}),i.gist=new i("gist",{fontCharacter:"\\eafb"}),i.gitCommit=new i("git-commit",{fontCharacter:"\\eafc"}),i.gitCompare=new i("git-compare",{fontCharacter:"\\eafd"}),i.gitMerge=new i("git-merge",{fontCharacter:"\\eafe"}),i.githubAction=new i("github-action",{fontCharacter:"\\eaff"}),i.githubAlt=new i("github-alt",{fontCharacter:"\\eb00"}),i.globe=new i("globe",{fontCharacter:"\\eb01"}),i.grabber=new i("grabber",{fontCharacter:"\\eb02"}),i.graph=new i("graph",{fontCharacter:"\\eb03"}),i.gripper=new i("gripper",{fontCharacter:"\\eb04"}),i.heart=new i("heart",{fontCharacter:"\\eb05"}),i.home=new i("home",{fontCharacter:"\\eb06"}),i.horizontalRule=new i("horizontal-rule",{fontCharacter:"\\eb07"}),i.hubot=new i("hubot",{fontCharacter:"\\eb08"}),i.inbox=new i("inbox",{fontCharacter:"\\eb09"}),i.issueClosed=new i("issue-closed",{fontCharacter:"\\eba4"}),i.issueReopened=new i("issue-reopened",{fontCharacter:"\\eb0b"}),i.issues=new i("issues",{fontCharacter:"\\eb0c"}),i.italic=new i("italic",{fontCharacter:"\\eb0d"}),i.jersey=new i("jersey",{fontCharacter:"\\eb0e"}),i.json=new i("json",{fontCharacter:"\\eb0f"}),i.kebabVertical=new i("kebab-vertical",{fontCharacter:"\\eb10"}),i.key=new i("key",{fontCharacter:"\\eb11"}),i.law=new i("law",{fontCharacter:"\\eb12"}),i.lightbulbAutofix=new i("lightbulb-autofix",{fontCharacter:"\\eb13"}),i.linkExternal=new i("link-external",{fontCharacter:"\\eb14"}),i.link=new i("link",{fontCharacter:"\\eb15"}),i.listOrdered=new i("list-ordered",{fontCharacter:"\\eb16"}),i.listUnordered=new i("list-unordered",{fontCharacter:"\\eb17"}),i.liveShare=new i("live-share",{fontCharacter:"\\eb18"}),i.loading=new i("loading",{fontCharacter:"\\eb19"}),i.location=new i("location",{fontCharacter:"\\eb1a"}),i.mailRead=new i("mail-read",{fontCharacter:"\\eb1b"}),i.mail=new i("mail",{fontCharacter:"\\eb1c"}),i.markdown=new i("markdown",{fontCharacter:"\\eb1d"}),i.megaphone=new i("megaphone",{fontCharacter:"\\eb1e"}),i.mention=new i("mention",{fontCharacter:"\\eb1f"}),i.milestone=new i("milestone",{fontCharacter:"\\eb20"}),i.mortarBoard=new i("mortar-board",{fontCharacter:"\\eb21"}),i.move=new i("move",{fontCharacter:"\\eb22"}),i.multipleWindows=new i("multiple-windows",{fontCharacter:"\\eb23"}),i.mute=new i("mute",{fontCharacter:"\\eb24"}),i.noNewline=new i("no-newline",{fontCharacter:"\\eb25"}),i.note=new i("note",{fontCharacter:"\\eb26"}),i.octoface=new i("octoface",{fontCharacter:"\\eb27"}),i.openPreview=new i("open-preview",{fontCharacter:"\\eb28"}),i.package_=new i("package",{fontCharacter:"\\eb29"}),i.paintcan=new i("paintcan",{fontCharacter:"\\eb2a"}),i.pin=new i("pin",{fontCharacter:"\\eb2b"}),i.play=new i("play",{fontCharacter:"\\eb2c"}),i.run=new i("run",{fontCharacter:"\\eb2c"}),i.plug=new i("plug",{fontCharacter:"\\eb2d"}),i.preserveCase=new i("preserve-case",{fontCharacter:"\\eb2e"}),i.preview=new i("preview",{fontCharacter:"\\eb2f"}),i.project=new i("project",{fontCharacter:"\\eb30"}),i.pulse=new i("pulse",{fontCharacter:"\\eb31"}),i.question=new i("question",{fontCharacter:"\\eb32"}),i.quote=new i("quote",{fontCharacter:"\\eb33"}),i.radioTower=new i("radio-tower",{fontCharacter:"\\eb34"}),i.reactions=new i("reactions",{fontCharacter:"\\eb35"}),i.references=new i("references",{fontCharacter:"\\eb36"}),i.refresh=new i("refresh",{fontCharacter:"\\eb37"}),i.regex=new i("regex",{fontCharacter:"\\eb38"}),i.remoteExplorer=new i("remote-explorer",{fontCharacter:"\\eb39"}),i.remote=new i("remote",{fontCharacter:"\\eb3a"}),i.remove=new i("remove",{fontCharacter:"\\eb3b"}),i.replaceAll=new i("replace-all",{fontCharacter:"\\eb3c"}),i.replace=new i("replace",{fontCharacter:"\\eb3d"}),i.repoClone=new i("repo-clone",{fontCharacter:"\\eb3e"}),i.repoForcePush=new i("repo-force-push",{fontCharacter:"\\eb3f"}),i.repoPull=new i("repo-pull",{fontCharacter:"\\eb40"}),i.repoPush=new i("repo-push",{fontCharacter:"\\eb41"}),i.report=new i("report",{fontCharacter:"\\eb42"}),i.requestChanges=new i("request-changes",{fontCharacter:"\\eb43"}),i.rocket=new i("rocket",{fontCharacter:"\\eb44"}),i.rootFolderOpened=new i("root-folder-opened",{fontCharacter:"\\eb45"}),i.rootFolder=new i("root-folder",{fontCharacter:"\\eb46"}),i.rss=new i("rss",{fontCharacter:"\\eb47"}),i.ruby=new i("ruby",{fontCharacter:"\\eb48"}),i.saveAll=new i("save-all",{fontCharacter:"\\eb49"}),i.saveAs=new i("save-as",{fontCharacter:"\\eb4a"}),i.save=new i("save",{fontCharacter:"\\eb4b"}),i.screenFull=new i("screen-full",{fontCharacter:"\\eb4c"}),i.screenNormal=new i("screen-normal",{fontCharacter:"\\eb4d"}),i.searchStop=new i("search-stop",{fontCharacter:"\\eb4e"}),i.server=new i("server",{fontCharacter:"\\eb50"}),i.settingsGear=new i("settings-gear",{fontCharacter:"\\eb51"}),i.settings=new i("settings",{fontCharacter:"\\eb52"}),i.shield=new i("shield",{fontCharacter:"\\eb53"}),i.smiley=new i("smiley",{fontCharacter:"\\eb54"}),i.sortPrecedence=new i("sort-precedence",{fontCharacter:"\\eb55"}),i.splitHorizontal=new i("split-horizontal",{fontCharacter:"\\eb56"}),i.splitVertical=new i("split-vertical",{fontCharacter:"\\eb57"}),i.squirrel=new i("squirrel",{fontCharacter:"\\eb58"}),i.starFull=new i("star-full",{fontCharacter:"\\eb59"}),i.starHalf=new i("star-half",{fontCharacter:"\\eb5a"}),i.symbolClass=new i("symbol-class",{fontCharacter:"\\eb5b"}),i.symbolColor=new i("symbol-color",{fontCharacter:"\\eb5c"}),i.symbolConstant=new i("symbol-constant",{fontCharacter:"\\eb5d"}),i.symbolEnumMember=new i("symbol-enum-member",{fontCharacter:"\\eb5e"}),i.symbolField=new i("symbol-field",{fontCharacter:"\\eb5f"}),i.symbolFile=new i("symbol-file",{fontCharacter:"\\eb60"}),i.symbolInterface=new i("symbol-interface",{fontCharacter:"\\eb61"}),i.symbolKeyword=new i("symbol-keyword",{fontCharacter:"\\eb62"}),i.symbolMisc=new i("symbol-misc",{fontCharacter:"\\eb63"}),i.symbolOperator=new i("symbol-operator",{fontCharacter:"\\eb64"}),i.symbolProperty=new i("symbol-property",{fontCharacter:"\\eb65"}),i.wrench=new i("wrench",{fontCharacter:"\\eb65"}),i.wrenchSubaction=new i("wrench-subaction",{fontCharacter:"\\eb65"}),i.symbolSnippet=new i("symbol-snippet",{fontCharacter:"\\eb66"}),i.tasklist=new i("tasklist",{fontCharacter:"\\eb67"}),i.telescope=new i("telescope",{fontCharacter:"\\eb68"}),i.textSize=new i("text-size",{fontCharacter:"\\eb69"}),i.threeBars=new i("three-bars",{fontCharacter:"\\eb6a"}),i.thumbsdown=new i("thumbsdown",{fontCharacter:"\\eb6b"}),i.thumbsup=new i("thumbsup",{fontCharacter:"\\eb6c"}),i.tools=new i("tools",{fontCharacter:"\\eb6d"}),i.triangleDown=new i("triangle-down",{fontCharacter:"\\eb6e"}),i.triangleLeft=new i("triangle-left",{fontCharacter:"\\eb6f"}),i.triangleRight=new i("triangle-right",{fontCharacter:"\\eb70"}),i.triangleUp=new i("triangle-up",{fontCharacter:"\\eb71"}),i.twitter=new i("twitter",{fontCharacter:"\\eb72"}),i.unfold=new i("unfold",{fontCharacter:"\\eb73"}),i.unlock=new i("unlock",{fontCharacter:"\\eb74"}),i.unmute=new i("unmute",{fontCharacter:"\\eb75"}),i.unverified=new i("unverified",{fontCharacter:"\\eb76"}),i.verified=new i("verified",{fontCharacter:"\\eb77"}),i.versions=new i("versions",{fontCharacter:"\\eb78"}),i.vmActive=new i("vm-active",{fontCharacter:"\\eb79"}),i.vmOutline=new i("vm-outline",{fontCharacter:"\\eb7a"}),i.vmRunning=new i("vm-running",{fontCharacter:"\\eb7b"}),i.watch=new i("watch",{fontCharacter:"\\eb7c"}),i.whitespace=new i("whitespace",{fontCharacter:"\\eb7d"}),i.wholeWord=new i("whole-word",{fontCharacter:"\\eb7e"}),i.window=new i("window",{fontCharacter:"\\eb7f"}),i.wordWrap=new i("word-wrap",{fontCharacter:"\\eb80"}),i.zoomIn=new i("zoom-in",{fontCharacter:"\\eb81"}),i.zoomOut=new i("zoom-out",{fontCharacter:"\\eb82"}),i.listFilter=new i("list-filter",{fontCharacter:"\\eb83"}),i.listFlat=new i("list-flat",{fontCharacter:"\\eb84"}),i.listSelection=new i("list-selection",{fontCharacter:"\\eb85"}),i.selection=new i("selection",{fontCharacter:"\\eb85"}),i.listTree=new i("list-tree",{fontCharacter:"\\eb86"}),i.debugBreakpointFunctionUnverified=new i("debug-breakpoint-function-unverified",{fontCharacter:"\\eb87"}),i.debugBreakpointFunction=new i("debug-breakpoint-function",{fontCharacter:"\\eb88"}),i.debugBreakpointFunctionDisabled=new i("debug-breakpoint-function-disabled",{fontCharacter:"\\eb88"}),i.debugStackframeActive=new i("debug-stackframe-active",{fontCharacter:"\\eb89"}),i.debugStackframeDot=new i("debug-stackframe-dot",{fontCharacter:"\\eb8a"}),i.debugStackframe=new i("debug-stackframe",{fontCharacter:"\\eb8b"}),i.debugStackframeFocused=new i("debug-stackframe-focused",{fontCharacter:"\\eb8b"}),i.debugBreakpointUnsupported=new i("debug-breakpoint-unsupported",{fontCharacter:"\\eb8c"}),i.symbolString=new i("symbol-string",{fontCharacter:"\\eb8d"}),i.debugReverseContinue=new i("debug-reverse-continue",{fontCharacter:"\\eb8e"}),i.debugStepBack=new i("debug-step-back",{fontCharacter:"\\eb8f"}),i.debugRestartFrame=new i("debug-restart-frame",{fontCharacter:"\\eb90"}),i.callIncoming=new i("call-incoming",{fontCharacter:"\\eb92"}),i.callOutgoing=new i("call-outgoing",{fontCharacter:"\\eb93"}),i.menu=new i("menu",{fontCharacter:"\\eb94"}),i.expandAll=new i("expand-all",{fontCharacter:"\\eb95"}),i.feedback=new i("feedback",{fontCharacter:"\\eb96"}),i.groupByRefType=new i("group-by-ref-type",{fontCharacter:"\\eb97"}),i.ungroupByRefType=new i("ungroup-by-ref-type",{fontCharacter:"\\eb98"}),i.account=new i("account",{fontCharacter:"\\eb99"}),i.bellDot=new i("bell-dot",{fontCharacter:"\\eb9a"}),i.debugConsole=new i("debug-console",{fontCharacter:"\\eb9b"}),i.library=new i("library",{fontCharacter:"\\eb9c"}),i.output=new i("output",{fontCharacter:"\\eb9d"}),i.runAll=new i("run-all",{fontCharacter:"\\eb9e"}),i.syncIgnored=new i("sync-ignored",{fontCharacter:"\\eb9f"}),i.pinned=new i("pinned",{fontCharacter:"\\eba0"}),i.githubInverted=new i("github-inverted",{fontCharacter:"\\eba1"}),i.debugAlt=new i("debug-alt",{fontCharacter:"\\eb91"}),i.serverProcess=new i("server-process",{fontCharacter:"\\eba2"}),i.serverEnvironment=new i("server-environment",{fontCharacter:"\\eba3"}),i.pass=new i("pass",{fontCharacter:"\\eba4"}),i.stopCircle=new i("stop-circle",{fontCharacter:"\\eba5"}),i.playCircle=new i("play-circle",{fontCharacter:"\\eba6"}),i.record=new i("record",{fontCharacter:"\\eba7"}),i.debugAltSmall=new i("debug-alt-small",{fontCharacter:"\\eba8"}),i.vmConnect=new i("vm-connect",{fontCharacter:"\\eba9"}),i.cloud=new i("cloud",{fontCharacter:"\\ebaa"}),i.merge=new i("merge",{fontCharacter:"\\ebab"}),i.exportIcon=new i("export",{fontCharacter:"\\ebac"}),i.graphLeft=new i("graph-left",{fontCharacter:"\\ebad"}),i.magnet=new i("magnet",{fontCharacter:"\\ebae"}),i.notebook=new i("notebook",{fontCharacter:"\\ebaf"}),i.redo=new i("redo",{fontCharacter:"\\ebb0"}),i.checkAll=new i("check-all",{fontCharacter:"\\ebb1"}),i.pinnedDirty=new i("pinned-dirty",{fontCharacter:"\\ebb2"}),i.passFilled=new i("pass-filled",{fontCharacter:"\\ebb3"}),i.circleLargeFilled=new i("circle-large-filled",{fontCharacter:"\\ebb4"}),i.circleLargeOutline=new i("circle-large-outline",{fontCharacter:"\\ebb5"}),i.combine=new i("combine",{fontCharacter:"\\ebb6"}),i.gather=new i("gather",{fontCharacter:"\\ebb6"}),i.table=new i("table",{fontCharacter:"\\ebb7"}),i.variableGroup=new i("variable-group",{fontCharacter:"\\ebb8"}),i.typeHierarchy=new i("type-hierarchy",{fontCharacter:"\\ebb9"}),i.typeHierarchySub=new i("type-hierarchy-sub",{fontCharacter:"\\ebba"}),i.typeHierarchySuper=new i("type-hierarchy-super",{fontCharacter:"\\ebbb"}),i.gitPullRequestCreate=new i("git-pull-request-create",{fontCharacter:"\\ebbc"}),i.runAbove=new i("run-above",{fontCharacter:"\\ebbd"}),i.runBelow=new i("run-below",{fontCharacter:"\\ebbe"}),i.notebookTemplate=new i("notebook-template",{fontCharacter:"\\ebbf"}),i.debugRerun=new i("debug-rerun",{fontCharacter:"\\ebc0"}),i.workspaceTrusted=new i("workspace-trusted",{fontCharacter:"\\ebc1"}),i.workspaceUntrusted=new i("workspace-untrusted",{fontCharacter:"\\ebc2"}),i.workspaceUnspecified=new i("workspace-unspecified",{fontCharacter:"\\ebc3"}),i.terminalCmd=new i("terminal-cmd",{fontCharacter:"\\ebc4"}),i.terminalDebian=new i("terminal-debian",{fontCharacter:"\\ebc5"}),i.terminalLinux=new i("terminal-linux",{fontCharacter:"\\ebc6"}),i.terminalPowershell=new i("terminal-powershell",{fontCharacter:"\\ebc7"}),i.terminalTmux=new i("terminal-tmux",{fontCharacter:"\\ebc8"}),i.terminalUbuntu=new i("terminal-ubuntu",{fontCharacter:"\\ebc9"}),i.terminalBash=new i("terminal-bash",{fontCharacter:"\\ebca"}),i.arrowSwap=new i("arrow-swap",{fontCharacter:"\\ebcb"}),i.copy=new i("copy",{fontCharacter:"\\ebcc"}),i.personAdd=new i("person-add",{fontCharacter:"\\ebcd"}),i.filterFilled=new i("filter-filled",{fontCharacter:"\\ebce"}),i.wand=new i("wand",{fontCharacter:"\\ebcf"}),i.debugLineByLine=new i("debug-line-by-line",{fontCharacter:"\\ebd0"}),i.inspect=new i("inspect",{fontCharacter:"\\ebd1"}),i.layers=new i("layers",{fontCharacter:"\\ebd2"}),i.layersDot=new i("layers-dot",{fontCharacter:"\\ebd3"}),i.layersActive=new i("layers-active",{fontCharacter:"\\ebd4"}),i.compass=new i("compass",{fontCharacter:"\\ebd5"}),i.compassDot=new i("compass-dot",{fontCharacter:"\\ebd6"}),i.compassActive=new i("compass-active",{fontCharacter:"\\ebd7"}),i.azure=new i("azure",{fontCharacter:"\\ebd8"}),i.issueDraft=new i("issue-draft",{fontCharacter:"\\ebd9"}),i.gitPullRequestClosed=new i("git-pull-request-closed",{fontCharacter:"\\ebda"}),i.gitPullRequestDraft=new i("git-pull-request-draft",{fontCharacter:"\\ebdb"}),i.debugAll=new i("debug-all",{fontCharacter:"\\ebdc"}),i.debugCoverage=new i("debug-coverage",{fontCharacter:"\\ebdd"}),i.runErrors=new i("run-errors",{fontCharacter:"\\ebde"}),i.folderLibrary=new i("folder-library",{fontCharacter:"\\ebdf"}),i.debugContinueSmall=new i("debug-continue-small",{fontCharacter:"\\ebe0"}),i.beakerStop=new i("beaker-stop",{fontCharacter:"\\ebe1"}),i.graphLine=new i("graph-line",{fontCharacter:"\\ebe2"}),i.graphScatter=new i("graph-scatter",{fontCharacter:"\\ebe3"}),i.pieChart=new i("pie-chart",{fontCharacter:"\\ebe4"}),i.bracket=new i("bracket",i.json.definition),i.bracketDot=new i("bracket-dot",{fontCharacter:"\\ebe5"}),i.bracketError=new i("bracket-error",{fontCharacter:"\\ebe6"}),i.lockSmall=new i("lock-small",{fontCharacter:"\\ebe7"}),i.azureDevops=new i("azure-devops",{fontCharacter:"\\ebe8"}),i.verifiedFilled=new i("verified-filled",{fontCharacter:"\\ebe9"}),i.newLine=new i("newline",{fontCharacter:"\\ebea"}),i.layout=new i("layout",{fontCharacter:"\\ebeb"}),i.dialogError=new i("dialog-error",i.error.definition),i.dialogWarning=new i("dialog-warning",i.warning.definition),i.dialogInfo=new i("dialog-info",i.info.definition),i.dialogClose=new i("dialog-close",i.close.definition),i.treeItemExpanded=new i("tree-item-expanded",i.chevronDown.definition),i.treeFilterOnTypeOn=new i("tree-filter-on-type-on",i.listFilter.definition),i.treeFilterOnTypeOff=new i("tree-filter-on-type-off",i.listSelection.definition),i.treeFilterClear=new i("tree-filter-clear",i.close.definition),i.treeItemLoading=new i("tree-item-loading",i.loading.definition),i.menuSelection=new i("menu-selection",i.check.definition),i.menuSubmenu=new i("menu-submenu",i.chevronRight.definition),i.menuBarMore=new i("menubar-more",i.more.definition),i.scrollbarButtonLeft=new i("scrollbar-button-left",i.triangleLeft.definition),i.scrollbarButtonRight=new i("scrollbar-button-right",i.triangleRight.definition),i.scrollbarButtonUp=new i("scrollbar-button-up",i.triangleUp.definition),i.scrollbarButtonDown=new i("scrollbar-button-down",i.triangleDown.definition),i.toolBarMore=new i("toolbar-more",i.more.definition),i.quickInputBack=new i("quick-input-back",i.arrowLeft.definition);function k(D,R){const P=["codicon","codicon-"+D];return R&&P.push("codicon-modifier-"+R),P}e.getClassNamesArray=k;var S;(function(D){D.iconNameSegment="[A-Za-z0-9]+",D.iconNameExpression="[A-Za-z0-9-]+",D.iconModifierExpression="~[A-Za-z]+",D.iconNameCharacter="[A-Za-z0-9~-]";const R=new RegExp(`^(${D.iconNameExpression})(${D.iconModifierExpression})?$`);function P(f){if(f instanceof i)return["codicon","codicon-"+f.id];const v=R.exec(f.id);if(!v)return P(i.error);let[,w,I]=v;const p=["codicon","codicon-"+w];return I&&p.push("codicon-modifier-"+I.substr(1)),p}D.asClassNameArray=P;function u(f){return P(f).join(" ")}D.asClassName=u;function E(f){return"."+P(f).join(".")}D.asCSSSelector=E})(S=e.CSSIcon||(e.CSSIcon={}))}),define(pe[95],ve([0,1,15,6]),function(Y,e,m,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.prefixedStream=e.prefixedReadable=e.transform=e.toReadable=e.emptyStream=e.toStream=e.peekStream=e.listenStream=e.consumeStream=e.peekReadable=e.consumeReadable=e.newWriteableStream=e.isReadableBufferedStream=e.isReadableStream=void 0;function y(s){const r=s;return r?[r.on,r.pause,r.resume,r.destroy].every(g=>typeof g=="function"):!1}e.isReadableStream=y;function C(s){const r=s;return r?y(r.stream)&&Array.isArray(r.buffer)&&typeof r.ended=="boolean":!1}e.isReadableBufferedStream=C;function i(s,r){return new k(s,r)}e.newWriteableStream=i;class k{constructor(r,g){this.reducer=r,this.options=g,this.state={flowing:!1,ended:!1,destroyed:!1},this.buffer={data:[],error:[]},this.listeners={data:[],error:[],end:[]},this.pendingWritePromises=[]}pause(){this.state.destroyed||(this.state.flowing=!1)}resume(){this.state.destroyed||this.state.flowing||(this.state.flowing=!0,this.flowData(),this.flowErrors(),this.flowEnd())}write(r){if(!this.state.destroyed){if(this.state.flowing)this.emitData(r);else if(this.buffer.data.push(r),typeof this.options?.highWaterMark=="number"&&this.buffer.data.length>this.options.highWaterMark)return new Promise(g=>this.pendingWritePromises.push(g))}}error(r){this.state.destroyed||(this.state.flowing?this.emitError(r):this.buffer.error.push(r))}end(r){this.state.destroyed||(typeof r!="undefined"&&this.write(r),this.state.flowing?(this.emitEnd(),this.destroy()):this.state.ended=!0)}emitData(r){this.listeners.data.slice(0).forEach(g=>g(r))}emitError(r){this.listeners.error.length===0?(0,m.onUnexpectedError)(r):this.listeners.error.slice(0).forEach(g=>g(r))}emitEnd(){this.listeners.end.slice(0).forEach(r=>r())}on(r,g){if(!this.state.destroyed)switch(r){case"data":this.listeners.data.push(g),this.resume();break;case"end":this.listeners.end.push(g),this.state.flowing&&this.flowEnd()&&this.destroy();break;case"error":this.listeners.error.push(g),this.state.flowing&&this.flowErrors();break}}removeListener(r,g){if(this.state.destroyed)return;let a;switch(r){case"data":a=this.listeners.data;break;case"end":a=this.listeners.end;break;case"error":a=this.listeners.error;break}if(a){const _=a.indexOf(g);_>=0&&a.splice(_,1)}}flowData(){if(this.buffer.data.length>0){const r=this.reducer(this.buffer.data);this.emitData(r),this.buffer.data.length=0;const g=[...this.pendingWritePromises];this.pendingWritePromises.length=0,g.forEach(a=>a())}}flowErrors(){if(this.listeners.error.length>0){for(const r of this.buffer.error)this.emitError(r);this.buffer.error.length=0}}flowEnd(){return this.state.ended?(this.emitEnd(),this.listeners.end.length>0):!1}destroy(){this.state.destroyed||(this.state.destroyed=!0,this.state.ended=!0,this.buffer.data.length=0,this.buffer.error.length=0,this.listeners.data.length=0,this.listeners.error.length=0,this.listeners.end.length=0,this.pendingWritePromises.length=0)}}function S(s,r){const g=[];let a;for(;(a=s.read())!==null;)g.push(a);return r(g)}e.consumeReadable=S;function D(s,r,g){const a=[];let _;for(;(_=s.read())!==null&&a.length<g;)a.push(_);return _===null&&a.length>0?r(a):{read:()=>{if(a.length>0)return a.shift();if(typeof _!="undefined"){const n=_;return _=void 0,n}return s.read()}}}e.peekReadable=D;function R(s,r){return new Promise((g,a)=>{const _=[];P(s,{onData:n=>{r&&_.push(n)},onError:n=>{r?a(n):g(void 0)},onEnd:()=>{g(r?r(_):void 0)}})})}e.consumeStream=R;function P(s,r){s.on("error",g=>r.onError(g)),s.on("end",()=>r.onEnd()),s.on("data",g=>r.onData(g))}e.listenStream=P;function u(s,r){return new Promise((g,a)=>{const _=new L.DisposableStore,n=[],t=c=>{if(n.push(c),n.length>r)return _.dispose(),s.pause(),g({stream:s,buffer:n,ended:!1})},o=c=>a(c),d=()=>g({stream:s,buffer:n,ended:!0});_.add((0,L.toDisposable)(()=>s.removeListener("error",o))),s.on("error",o),_.add((0,L.toDisposable)(()=>s.removeListener("end",d))),s.on("end",d),_.add((0,L.toDisposable)(()=>s.removeListener("data",t))),s.on("data",t)})}e.peekStream=u;function E(s,r){const g=i(r);return g.end(s),g}e.toStream=E;function f(){const s=i(()=>{throw new Error("not supported")});return s.end(),s}e.emptyStream=f;function v(s){let r=!1;return{read:()=>r?null:(r=!0,s)}}e.toReadable=v;function w(s,r,g){const a=i(g);return P(s,{onData:_=>a.write(r.data(_)),onError:_=>a.error(r.error?r.error(_):_),onEnd:()=>a.end()}),a}e.transform=w;function I(s,r,g){let a=!1;return{read:()=>{const _=r.read();return a?_:(a=!0,_!==null?g([s,_]):s)}}}e.prefixedReadable=I;function p(s,r,g){let a=!1;const _=i(g);return P(r,{onData:n=>a?_.write(n):(a=!0,_.write(g([s,n]))),onError:n=>_.error(n),onEnd:()=>{a||(a=!0,_.write(s)),_.end()}}),_}e.prefixedStream=p}),define(pe[22],ve([0,1,95]),function(Y,e,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.prefixedBufferStream=e.prefixedBufferReadable=e.newWriteableBufferStream=e.streamToBufferReadableStream=e.bufferToStream=e.bufferedStreamToBuffer=e.streamToBuffer=e.bufferToReadable=e.readableToBuffer=e.writeUInt8=e.readUInt8=e.writeUInt32LE=e.readUInt32LE=e.writeUInt32BE=e.readUInt32BE=e.writeUInt16LE=e.readUInt16LE=e.VSBuffer=void 0;const L=typeof Buffer!="undefined";let y,C;class i{constructor(t){this.buffer=t,this.byteLength=this.buffer.byteLength}static alloc(t){return L?new i(Buffer.allocUnsafe(t)):new i(new Uint8Array(t))}static wrap(t){return L&&!Buffer.isBuffer(t)&&(t=Buffer.from(t.buffer,t.byteOffset,t.byteLength)),new i(t)}static fromString(t,o){return!(o?.dontUseNodeBuffer||!1)&&L?new i(Buffer.from(t)):(y||(y=new TextEncoder),new i(y.encode(t)))}static fromByteArray(t){const o=i.alloc(t.length);for(let d=0,c=t.length;d<c;d++)o.buffer[d]=t[d];return o}static concat(t,o){if(typeof o=="undefined"){o=0;for(let h=0,l=t.length;h<l;h++)o+=t[h].byteLength}const d=i.alloc(o);let c=0;for(let h=0,l=t.length;h<l;h++){const b=t[h];d.set(b,c),c+=b.byteLength}return d}clone(){const t=i.alloc(this.byteLength);return t.set(this),t}toString(){return L?this.buffer.toString():(C||(C=new TextDecoder),C.decode(this.buffer))}slice(t,o){return new i(this.buffer.subarray(t,o))}set(t,o){if(t instanceof i)this.buffer.set(t.buffer,o);else if(t instanceof Uint8Array)this.buffer.set(t,o);else if(t instanceof ArrayBuffer)this.buffer.set(new Uint8Array(t),o);else if(ArrayBuffer.isView(t))this.buffer.set(new Uint8Array(t.buffer,t.byteOffset,t.byteLength),o);else throw new Error("Unkown argument 'array'")}readUInt32BE(t){return D(this.buffer,t)}writeUInt32BE(t,o){R(this.buffer,t,o)}readUInt32LE(t){return P(this.buffer,t)}writeUInt32LE(t,o){u(this.buffer,t,o)}readUInt8(t){return E(this.buffer,t)}writeUInt8(t,o){f(this.buffer,t,o)}}e.VSBuffer=i;function k(n,t){return n[t+0]<<0>>>0|n[t+1]<<8>>>0}e.readUInt16LE=k;function S(n,t,o){n[o+0]=t&255,t=t>>>8,n[o+1]=t&255}e.writeUInt16LE=S;function D(n,t){return n[t]*2**24+n[t+1]*2**16+n[t+2]*2**8+n[t+3]}e.readUInt32BE=D;function R(n,t,o){n[o+3]=t,t=t>>>8,n[o+2]=t,t=t>>>8,n[o+1]=t,t=t>>>8,n[o]=t}e.writeUInt32BE=R;function P(n,t){return n[t+0]<<0>>>0|n[t+1]<<8>>>0|n[t+2]<<16>>>0|n[t+3]<<24>>>0}e.readUInt32LE=P;function u(n,t,o){n[o+0]=t&255,t=t>>>8,n[o+1]=t&255,t=t>>>8,n[o+2]=t&255,t=t>>>8,n[o+3]=t&255}e.writeUInt32LE=u;function E(n,t){return n[t]}e.readUInt8=E;function f(n,t,o){n[o]=t}e.writeUInt8=f;function v(n){return m.consumeReadable(n,t=>i.concat(t))}e.readableToBuffer=v;function w(n){return m.toReadable(n)}e.bufferToReadable=w;function I(n){return m.consumeStream(n,t=>i.concat(t))}e.streamToBuffer=I;async function p(n){return n.ended?i.concat(n.buffer):i.concat([...n.buffer,await I(n.stream)])}e.bufferedStreamToBuffer=p;function s(n){return m.toStream(n,t=>i.concat(t))}e.bufferToStream=s;function r(n){return m.transform(n,{data:t=>typeof t=="string"?i.fromString(t):i.wrap(t)},t=>i.concat(t))}e.streamToBufferReadableStream=r;function g(n){return m.newWriteableStream(t=>i.concat(t),n)}e.newWriteableBufferStream=g;function a(n,t){return m.prefixedReadable(n,t,o=>i.concat(o))}e.prefixedBufferReadable=a;function _(n,t){return m.prefixedStream(n,t,o=>i.concat(o))}e.prefixedBufferStream=_}),define(pe[8],ve([0,1,12]),function(Y,e,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InvisibleCharacters=e.AmbiguousCharacters=e.noBreakWhitespace=e.getLeftDeleteOffset=e.GraphemeBreakType=e.breakBetweenGraphemeBreakType=e.getGraphemeBreakType=e.singleLetterHash=e.getNLines=e.uppercaseFirstLetter=e.containsUppercaseCharacter=e.fuzzyContains=e.stripUTF8BOM=e.startsWithUTF8BOM=e.UTF8_BOM_CHARACTER=e.removeAnsiEscapeCodes=e.lcut=e.isEmojiImprecise=e.isFullWidthCharacter=e.containsFullWidthCharacter=e.containsUnusualLineTerminators=e.UNUSUAL_LINE_TERMINATORS=e.isBasicASCII=e.containsEmoji=e.containsRTL=e.getCharContainingOffset=e.prevCharLength=e.nextCharLength=e.getNextCodePoint=e.computeCodePoint=e.isLowSurrogate=e.isHighSurrogate=e.commonSuffixLength=e.commonPrefixLength=e.startsWithIgnoreCase=e.equalsIgnoreCase=e.isUpperAsciiLetter=e.isLowerAsciiLetter=e.compareSubstringIgnoreCase=e.compareIgnoreCase=e.compareSubstring=e.compare=e.lastNonWhitespaceIndex=e.getLeadingWhitespace=e.firstNonWhitespaceIndex=e.splitLines=e.regExpFlags=e.regExpContainsBackreference=e.regExpLeadsToEndlessLoop=e.createRegExp=e.stripWildcards=e.convertSimple2RegExpPattern=e.rtrim=e.ltrim=e.trim=e.truncate=e.count=e.escapeRegExpCharacters=e.escape=e.format2=e.format=e.isFalsyOrWhitespace=void 0;function L(te){return!te||typeof te!="string"?!0:te.trim().length===0}e.isFalsyOrWhitespace=L;const y=/{(\d+)}/g;function C(te,...Ee){return Ee.length===0?te:te.replace(y,function(Le,Oe){const Xe=parseInt(Oe,10);return isNaN(Xe)||Xe<0||Xe>=Ee.length?Le:Ee[Xe]})}e.format=C;const i=/{([^}]+)}/g;function k(te,Ee){return te.replace(i,(Le,Oe)=>Ee[Oe]??Le)}e.format2=k;function S(te){return te.replace(/[<>&]/g,function(Ee){switch(Ee){case"<":return"&lt;";case">":return"&gt;";case"&":return"&amp;";default:return Ee}})}e.escape=S;function D(te){return te.replace(/[\\\{\}\*\+\?\|\^\$\.\[\]\(\)]/g,"\\$&")}e.escapeRegExpCharacters=D;function R(te,Ee){let Le=0;const Oe=Ee.charCodeAt(0);for(let Xe=te.length-1;Xe>=0;Xe--)te.charCodeAt(Xe)===Oe&&Le++;return Le}e.count=R;function P(te,Ee,Le="\u2026"){return te.length<=Ee?te:`${te.substr(0,Ee)}${Le}`}e.truncate=P;function u(te,Ee=" "){const Le=E(te,Ee);return f(Le,Ee)}e.trim=u;function E(te,Ee){if(!te||!Ee)return te;const Le=Ee.length;if(Le===0||te.length===0)return te;let Oe=0;for(;te.indexOf(Ee,Oe)===Oe;)Oe=Oe+Le;return te.substring(Oe)}e.ltrim=E;function f(te,Ee){if(!te||!Ee)return te;const Le=Ee.length,Oe=te.length;if(Le===0||Oe===0)return te;let Xe=Oe,Te=-1;for(;Te=te.lastIndexOf(Ee,Xe-1),!(Te===-1||Te+Le!==Xe);){if(Te===0)return"";Xe=Te}return te.substring(0,Xe)}e.rtrim=f;function v(te){return te.replace(/[\-\\\{\}\+\?\|\^\$\.\,\[\]\(\)\#\s]/g,"\\$&").replace(/[\*]/g,".*")}e.convertSimple2RegExpPattern=v;function w(te){return te.replace(/\*/g,"")}e.stripWildcards=w;function I(te,Ee,Le={}){if(!te)throw new Error("Cannot create regex from empty string");Ee||(te=D(te)),Le.wholeWord&&(/\B/.test(te.charAt(0))||(te="\\b"+te),/\B/.test(te.charAt(te.length-1))||(te=te+"\\b"));let Oe="";return Le.global&&(Oe+="g"),Le.matchCase||(Oe+="i"),Le.multiline&&(Oe+="m"),Le.unicode&&(Oe+="u"),new RegExp(te,Oe)}e.createRegExp=I;function p(te){return te.source==="^"||te.source==="^$"||te.source==="$"||te.source==="^\\s*$"?!1:!!(te.exec("")&&te.lastIndex===0)}e.regExpLeadsToEndlessLoop=p;function s(te){return!!te.match(/([^\\]|^)(\\\\)*\\\d+/)}e.regExpContainsBackreference=s;function r(te){return(te.global?"g":"")+(te.ignoreCase?"i":"")+(te.multiline?"m":"")+(te.unicode?"u":"")}e.regExpFlags=r;function g(te){return te.split(/\r\n|\r|\n/)}e.splitLines=g;function a(te){for(let Ee=0,Le=te.length;Ee<Le;Ee++){const Oe=te.charCodeAt(Ee);if(Oe!==32&&Oe!==9)return Ee}return-1}e.firstNonWhitespaceIndex=a;function _(te,Ee=0,Le=te.length){for(let Oe=Ee;Oe<Le;Oe++){const Xe=te.charCodeAt(Oe);if(Xe!==32&&Xe!==9)return te.substring(Ee,Oe)}return te.substring(Ee,Le)}e.getLeadingWhitespace=_;function n(te,Ee=te.length-1){for(let Le=Ee;Le>=0;Le--){const Oe=te.charCodeAt(Le);if(Oe!==32&&Oe!==9)return Le}return-1}e.lastNonWhitespaceIndex=n;function t(te,Ee){return te<Ee?-1:te>Ee?1:0}e.compare=t;function o(te,Ee,Le=0,Oe=te.length,Xe=0,Te=Ee.length){for(;Le<Oe&&Xe<Te;Le++,Xe++){let le=te.charCodeAt(Le),ue=Ee.charCodeAt(Xe);if(le<ue)return-1;if(le>ue)return 1}const Ie=Oe-Le,Se=Te-Xe;return Ie<Se?-1:Ie>Se?1:0}e.compareSubstring=o;function d(te,Ee){return c(te,Ee,0,te.length,0,Ee.length)}e.compareIgnoreCase=d;function c(te,Ee,Le=0,Oe=te.length,Xe=0,Te=Ee.length){for(;Le<Oe&&Xe<Te;Le++,Xe++){let le=te.charCodeAt(Le),ue=Ee.charCodeAt(Xe);if(le===ue)continue;if(le>=128||ue>=128)return o(te.toLowerCase(),Ee.toLowerCase(),Le,Oe,Xe,Te);h(le)&&(le-=32),h(ue)&&(ue-=32);const we=le-ue;if(we!==0)return we}const Ie=Oe-Le,Se=Te-Xe;return Ie<Se?-1:Ie>Se?1:0}e.compareSubstringIgnoreCase=c;function h(te){return te>=97&&te<=122}e.isLowerAsciiLetter=h;function l(te){return te>=65&&te<=90}e.isUpperAsciiLetter=l;function b(te,Ee){return te.length===Ee.length&&c(te,Ee)===0}e.equalsIgnoreCase=b;function T(te,Ee){const Le=Ee.length;return Ee.length>te.length?!1:c(te,Ee,0,Le)===0}e.startsWithIgnoreCase=T;function A(te,Ee){let Le,Oe=Math.min(te.length,Ee.length);for(Le=0;Le<Oe;Le++)if(te.charCodeAt(Le)!==Ee.charCodeAt(Le))return Le;return Oe}e.commonPrefixLength=A;function x(te,Ee){let Le,Oe=Math.min(te.length,Ee.length);const Xe=te.length-1,Te=Ee.length-1;for(Le=0;Le<Oe;Le++)if(te.charCodeAt(Xe-Le)!==Ee.charCodeAt(Te-Le))return Le;return Oe}e.commonSuffixLength=x;function O(te){return 55296<=te&&te<=56319}e.isHighSurrogate=O;function F(te){return 56320<=te&&te<=57343}e.isLowSurrogate=F;function W(te,Ee){return(te-55296<<10)+(Ee-56320)+65536}e.computeCodePoint=W;function M(te,Ee,Le){const Oe=te.charCodeAt(Le);if(O(Oe)&&Le+1<Ee){const Xe=te.charCodeAt(Le+1);if(F(Xe))return W(Oe,Xe)}return Oe}e.getNextCodePoint=M;function B(te,Ee){const Le=te.charCodeAt(Ee-1);if(F(Le)&&Ee>1){const Oe=te.charCodeAt(Ee-2);if(O(Oe))return W(Oe,Le)}return Le}function U(te,Ee){const Le=it.getInstance(),Oe=Ee,Xe=te.length,Te=M(te,Xe,Ee);Ee+=Te>=65536?2:1;let Ie=Le.getGraphemeBreakType(Te);for(;Ee<Xe;){const Se=M(te,Xe,Ee),le=Le.getGraphemeBreakType(Se);if(ot(Ie,le))break;Ee+=Se>=65536?2:1,Ie=le}return Ee-Oe}e.nextCharLength=U;function z(te,Ee){const Le=it.getInstance(),Oe=Ee,Xe=B(te,Ee);Ee-=Xe>=65536?2:1;let Te=Le.getGraphemeBreakType(Xe);for(;Ee>0;){const Ie=B(te,Ee),Se=Le.getGraphemeBreakType(Ie);if(ot(Se,Te))break;Ee-=Ie>=65536?2:1,Te=Se}return Oe-Ee}e.prevCharLength=z;function K(te,Ee){const Le=it.getInstance(),Oe=te.length,Xe=Ee,Te=M(te,Oe,Ee),Ie=Le.getGraphemeBreakType(Te);Ee+=Te>=65536?2:1;let Se=Ie;for(;Ee<Oe;){const ue=M(te,Oe,Ee),we=Le.getGraphemeBreakType(ue);if(ot(Se,we))break;Ee+=ue>=65536?2:1,Se=we}const le=Ee;for(Ee=Xe,Se=Ie;Ee>0;){const ue=B(te,Ee),we=Le.getGraphemeBreakType(ue);if(ot(we,Se))break;Ee-=ue>=65536?2:1,Se=we}return[Ee,le]}function N(te,Ee){return Ee>0&&F(te.charCodeAt(Ee))?K(te,Ee-1):K(te,Ee)}e.getCharContainingOffset=N;const j=/(?:[\u05BE\u05C0\u05C3\u05C6\u05D0-\u05F4\u0608\u060B\u060D\u061B-\u064A\u066D-\u066F\u0671-\u06D5\u06E5\u06E6\u06EE\u06EF\u06FA-\u0710\u0712-\u072F\u074D-\u07A5\u07B1-\u07EA\u07F4\u07F5\u07FA\u07FE-\u0815\u081A\u0824\u0828\u0830-\u0858\u085E-\u088E\u08A0-\u08C9\u200F\uFB1D\uFB1F-\uFB28\uFB2A-\uFD3D\uFD50-\uFDC7\uFDF0-\uFDFC\uFE70-\uFEFC]|\uD802[\uDC00-\uDD1B\uDD20-\uDE00\uDE10-\uDE35\uDE40-\uDEE4\uDEEB-\uDF35\uDF40-\uDFFF]|\uD803[\uDC00-\uDD23\uDE80-\uDEA9\uDEAD-\uDF45\uDF51-\uDF81\uDF86-\uDFF6]|\uD83A[\uDC00-\uDCCF\uDD00-\uDD43\uDD4B-\uDFFF]|\uD83B[\uDC00-\uDEBB])/;function H(te){return j.test(te)}e.containsRTL=H;const V=/(?:[\u231A\u231B\u23F0\u23F3\u2600-\u27BF\u2B50\u2B55]|\uD83C[\uDDE6-\uDDFF\uDF00-\uDFFF]|\uD83D[\uDC00-\uDE4F\uDE80-\uDEFC\uDFE0-\uDFF0]|\uD83E[\uDD00-\uDDFF\uDE70-\uDEF6])/;function q(te){return V.test(te)}e.containsEmoji=q;const ne=/^[\t\n\r\x20-\x7E]*$/;function fe(te){return ne.test(te)}e.isBasicASCII=fe,e.UNUSUAL_LINE_TERMINATORS=/[\u2028\u2029]/;function ye(te){return e.UNUSUAL_LINE_TERMINATORS.test(te)}e.containsUnusualLineTerminators=ye;function ke(te){for(let Ee=0,Le=te.length;Ee<Le;Ee++)if(Be(te.charCodeAt(Ee)))return!0;return!1}e.containsFullWidthCharacter=ke;function Be(te){return te>=11904&&te<=55215||te>=63744&&te<=64255||te>=65281&&te<=65374}e.isFullWidthCharacter=Be;function We(te){return te>=127462&&te<=127487||te===8986||te===8987||te===9200||te===9203||te>=9728&&te<=10175||te===11088||te===11093||te>=127744&&te<=128591||te>=128640&&te<=128764||te>=128992&&te<=129008||te>=129280&&te<=129535||te>=129648&&te<=129782}e.isEmojiImprecise=We;function ze(te,Ee){if(te.length<Ee)return te;const Le=/\b/g;let Oe=0;for(;Le.test(te)&&!(te.length-Le.lastIndex<Ee);)Oe=Le.lastIndex,Le.lastIndex+=1;return te.substring(Oe).replace(/^\s/,"")}e.lcut=ze;const Q=/\x1B\x5B[12]?K/g,ee=/\x1b\[\d+m/g,re=/\x1b\[0?m/g;function he(te){return te&&(te=te.replace(Q,""),te=te.replace(ee,""),te=te.replace(re,"")),te}e.removeAnsiEscapeCodes=he,e.UTF8_BOM_CHARACTER=String.fromCharCode(65279);function Z(te){return!!(te&&te.length>0&&te.charCodeAt(0)===65279)}e.startsWithUTF8BOM=Z;function oe(te){return Z(te)?te.substr(1):te}e.stripUTF8BOM=oe;function be(te,Ee){if(!te||!Ee||te.length<Ee.length)return!1;const Le=Ee.length,Oe=te.toLowerCase();let Xe=0,Te=-1;for(;Xe<Le;){const Ie=Oe.indexOf(Ee[Xe],Te+1);if(Ie<0)return!1;Te=Ie,Xe++}return!0}e.fuzzyContains=be;function Me(te,Ee=!1){return te?(Ee&&(te=te.replace(/\\./g,"")),te.toLowerCase()!==te):!1}e.containsUppercaseCharacter=Me;function Ve(te){return te.charAt(0).toUpperCase()+te.slice(1)}e.uppercaseFirstLetter=Ve;function Ge(te,Ee=1){if(Ee===0)return"";let Le=-1;do Le=te.indexOf(`
`,Le+1),Ee--;while(Ee>0&&Le>=0);return Le===-1?te:(te[Le-1]==="\r"&&Le--,te.substr(0,Le))}e.getNLines=Ge;function Je(te){const Ee=90-65+1;return te=te%(2*Ee),te<Ee?String.fromCharCode(97+te):String.fromCharCode(65+te-Ee)}e.singleLetterHash=Je;function tt(te){return it.getInstance().getGraphemeBreakType(te)}e.getGraphemeBreakType=tt;function ot(te,Ee){return te===0?Ee!==5&&Ee!==7:te===2&&Ee===3?!1:te===4||te===2||te===3||Ee===4||Ee===2||Ee===3?!0:!(te===8&&(Ee===8||Ee===9||Ee===11||Ee===12)||(te===11||te===9)&&(Ee===9||Ee===10)||(te===12||te===10)&&Ee===10||Ee===5||Ee===13||Ee===7||te===1||te===13&&Ee===14||te===6&&Ee===6)}e.breakBetweenGraphemeBreakType=ot;var et;(function(te){te[te.Other=0]="Other",te[te.Prepend=1]="Prepend",te[te.CR=2]="CR",te[te.LF=3]="LF",te[te.Control=4]="Control",te[te.Extend=5]="Extend",te[te.Regional_Indicator=6]="Regional_Indicator",te[te.SpacingMark=7]="SpacingMark",te[te.L=8]="L",te[te.V=9]="V",te[te.T=10]="T",te[te.LV=11]="LV",te[te.LVT=12]="LVT",te[te.ZWJ=13]="ZWJ",te[te.Extended_Pictographic=14]="Extended_Pictographic"})(et=e.GraphemeBreakType||(e.GraphemeBreakType={}));class it{constructor(){this._data=ct()}static getInstance(){return it._INSTANCE||(it._INSTANCE=new it),it._INSTANCE}getGraphemeBreakType(Ee){if(Ee<32)return Ee===10?3:Ee===13?2:4;if(Ee<127)return 0;const Le=this._data,Oe=Le.length/3;let Xe=1;for(;Xe<=Oe;)if(Ee<Le[3*Xe])Xe=2*Xe;else if(Ee>Le[3*Xe+1])Xe=2*Xe+1;else return Le[3*Xe+2];return 0}}it._INSTANCE=null;function ct(){return JSON.parse("[0,0,0,51229,51255,12,44061,44087,12,127462,127487,6,7083,7085,5,47645,47671,12,54813,54839,12,128678,128678,14,3270,3270,5,9919,9923,14,45853,45879,12,49437,49463,12,53021,53047,12,71216,71218,7,128398,128399,14,129360,129374,14,2519,2519,5,4448,4519,9,9742,9742,14,12336,12336,14,44957,44983,12,46749,46775,12,48541,48567,12,50333,50359,12,52125,52151,12,53917,53943,12,69888,69890,5,73018,73018,5,127990,127990,14,128558,128559,14,128759,128760,14,129653,129655,14,2027,2035,5,2891,2892,7,3761,3761,5,6683,6683,5,8293,8293,4,9825,9826,14,9999,9999,14,43452,43453,5,44509,44535,12,45405,45431,12,46301,46327,12,47197,47223,12,48093,48119,12,48989,49015,12,49885,49911,12,50781,50807,12,51677,51703,12,52573,52599,12,53469,53495,12,54365,54391,12,65279,65279,4,70471,70472,7,72145,72147,7,119173,119179,5,127799,127818,14,128240,128244,14,128512,128512,14,128652,128652,14,128721,128722,14,129292,129292,14,129445,129450,14,129734,129743,14,1476,1477,5,2366,2368,7,2750,2752,7,3076,3076,5,3415,3415,5,4141,4144,5,6109,6109,5,6964,6964,5,7394,7400,5,9197,9198,14,9770,9770,14,9877,9877,14,9968,9969,14,10084,10084,14,43052,43052,5,43713,43713,5,44285,44311,12,44733,44759,12,45181,45207,12,45629,45655,12,46077,46103,12,46525,46551,12,46973,46999,12,47421,47447,12,47869,47895,12,48317,48343,12,48765,48791,12,49213,49239,12,49661,49687,12,50109,50135,12,50557,50583,12,51005,51031,12,51453,51479,12,51901,51927,12,52349,52375,12,52797,52823,12,53245,53271,12,53693,53719,12,54141,54167,12,54589,54615,12,55037,55063,12,69506,69509,5,70191,70193,5,70841,70841,7,71463,71467,5,72330,72342,5,94031,94031,5,123628,123631,5,127763,127765,14,127941,127941,14,128043,128062,14,128302,128317,14,128465,128467,14,128539,128539,14,128640,128640,14,128662,128662,14,128703,128703,14,128745,128745,14,129004,129007,14,129329,129330,14,129402,129402,14,129483,129483,14,129686,129704,14,130048,131069,14,173,173,4,1757,1757,1,2200,2207,5,2434,2435,7,2631,2632,5,2817,2817,5,3008,3008,5,3201,3201,5,3387,3388,5,3542,3542,5,3902,3903,7,4190,4192,5,6002,6003,5,6439,6440,5,6765,6770,7,7019,7027,5,7154,7155,7,8205,8205,13,8505,8505,14,9654,9654,14,9757,9757,14,9792,9792,14,9852,9853,14,9890,9894,14,9937,9937,14,9981,9981,14,10035,10036,14,11035,11036,14,42654,42655,5,43346,43347,7,43587,43587,5,44006,44007,7,44173,44199,12,44397,44423,12,44621,44647,12,44845,44871,12,45069,45095,12,45293,45319,12,45517,45543,12,45741,45767,12,45965,45991,12,46189,46215,12,46413,46439,12,46637,46663,12,46861,46887,12,47085,47111,12,47309,47335,12,47533,47559,12,47757,47783,12,47981,48007,12,48205,48231,12,48429,48455,12,48653,48679,12,48877,48903,12,49101,49127,12,49325,49351,12,49549,49575,12,49773,49799,12,49997,50023,12,50221,50247,12,50445,50471,12,50669,50695,12,50893,50919,12,51117,51143,12,51341,51367,12,51565,51591,12,51789,51815,12,52013,52039,12,52237,52263,12,52461,52487,12,52685,52711,12,52909,52935,12,53133,53159,12,53357,53383,12,53581,53607,12,53805,53831,12,54029,54055,12,54253,54279,12,54477,54503,12,54701,54727,12,54925,54951,12,55149,55175,12,68101,68102,5,69762,69762,7,70067,70069,7,70371,70378,5,70720,70721,7,71087,71087,5,71341,71341,5,71995,71996,5,72249,72249,7,72850,72871,5,73109,73109,5,118576,118598,5,121505,121519,5,127245,127247,14,127568,127569,14,127777,127777,14,127872,127891,14,127956,127967,14,128015,128016,14,128110,128172,14,128259,128259,14,128367,128368,14,128424,128424,14,128488,128488,14,128530,128532,14,128550,128551,14,128566,128566,14,128647,128647,14,128656,128656,14,128667,128673,14,128691,128693,14,128715,128715,14,128728,128732,14,128752,128752,14,128765,128767,14,129096,129103,14,129311,129311,14,129344,129349,14,129394,129394,14,129413,129425,14,129466,129471,14,129511,129535,14,129664,129666,14,129719,129722,14,129760,129767,14,917536,917631,5,13,13,2,1160,1161,5,1564,1564,4,1807,1807,1,2085,2087,5,2307,2307,7,2382,2383,7,2497,2500,5,2563,2563,7,2677,2677,5,2763,2764,7,2879,2879,5,2914,2915,5,3021,3021,5,3142,3144,5,3263,3263,5,3285,3286,5,3398,3400,7,3530,3530,5,3633,3633,5,3864,3865,5,3974,3975,5,4155,4156,7,4229,4230,5,5909,5909,7,6078,6085,7,6277,6278,5,6451,6456,7,6744,6750,5,6846,6846,5,6972,6972,5,7074,7077,5,7146,7148,7,7222,7223,5,7416,7417,5,8234,8238,4,8417,8417,5,9000,9000,14,9203,9203,14,9730,9731,14,9748,9749,14,9762,9763,14,9776,9783,14,9800,9811,14,9831,9831,14,9872,9873,14,9882,9882,14,9900,9903,14,9929,9933,14,9941,9960,14,9974,9974,14,9989,9989,14,10006,10006,14,10062,10062,14,10160,10160,14,11647,11647,5,12953,12953,14,43019,43019,5,43232,43249,5,43443,43443,5,43567,43568,7,43696,43696,5,43765,43765,7,44013,44013,5,44117,44143,12,44229,44255,12,44341,44367,12,44453,44479,12,44565,44591,12,44677,44703,12,44789,44815,12,44901,44927,12,45013,45039,12,45125,45151,12,45237,45263,12,45349,45375,12,45461,45487,12,45573,45599,12,45685,45711,12,45797,45823,12,45909,45935,12,46021,46047,12,46133,46159,12,46245,46271,12,46357,46383,12,46469,46495,12,46581,46607,12,46693,46719,12,46805,46831,12,46917,46943,12,47029,47055,12,47141,47167,12,47253,47279,12,47365,47391,12,47477,47503,12,47589,47615,12,47701,47727,12,47813,47839,12,47925,47951,12,48037,48063,12,48149,48175,12,48261,48287,12,48373,48399,12,48485,48511,12,48597,48623,12,48709,48735,12,48821,48847,12,48933,48959,12,49045,49071,12,49157,49183,12,49269,49295,12,49381,49407,12,49493,49519,12,49605,49631,12,49717,49743,12,49829,49855,12,49941,49967,12,50053,50079,12,50165,50191,12,50277,50303,12,50389,50415,12,50501,50527,12,50613,50639,12,50725,50751,12,50837,50863,12,50949,50975,12,51061,51087,12,51173,51199,12,51285,51311,12,51397,51423,12,51509,51535,12,51621,51647,12,51733,51759,12,51845,51871,12,51957,51983,12,52069,52095,12,52181,52207,12,52293,52319,12,52405,52431,12,52517,52543,12,52629,52655,12,52741,52767,12,52853,52879,12,52965,52991,12,53077,53103,12,53189,53215,12,53301,53327,12,53413,53439,12,53525,53551,12,53637,53663,12,53749,53775,12,53861,53887,12,53973,53999,12,54085,54111,12,54197,54223,12,54309,54335,12,54421,54447,12,54533,54559,12,54645,54671,12,54757,54783,12,54869,54895,12,54981,55007,12,55093,55119,12,55243,55291,10,66045,66045,5,68325,68326,5,69688,69702,5,69817,69818,5,69957,69958,7,70089,70092,5,70198,70199,5,70462,70462,5,70502,70508,5,70750,70750,5,70846,70846,7,71100,71101,5,71230,71230,7,71351,71351,5,71737,71738,5,72000,72000,7,72160,72160,5,72273,72278,5,72752,72758,5,72882,72883,5,73031,73031,5,73461,73462,7,94192,94193,7,119149,119149,7,121403,121452,5,122915,122916,5,126980,126980,14,127358,127359,14,127535,127535,14,127759,127759,14,127771,127771,14,127792,127793,14,127825,127867,14,127897,127899,14,127945,127945,14,127985,127986,14,128000,128007,14,128021,128021,14,128066,128100,14,128184,128235,14,128249,128252,14,128266,128276,14,128335,128335,14,128379,128390,14,128407,128419,14,128444,128444,14,128481,128481,14,128499,128499,14,128526,128526,14,128536,128536,14,128543,128543,14,128556,128556,14,128564,128564,14,128577,128580,14,128643,128645,14,128649,128649,14,128654,128654,14,128660,128660,14,128664,128664,14,128675,128675,14,128686,128689,14,128695,128696,14,128705,128709,14,128717,128719,14,128725,128725,14,128736,128741,14,128747,128748,14,128755,128755,14,128762,128762,14,128981,128991,14,129009,129023,14,129160,129167,14,129296,129304,14,129320,129327,14,129340,129342,14,129356,129356,14,129388,129392,14,129399,129400,14,129404,129407,14,129432,129442,14,129454,129455,14,129473,129474,14,129485,129487,14,129648,129651,14,129659,129660,14,129671,129679,14,129709,129711,14,129728,129730,14,129751,129753,14,129776,129782,14,917505,917505,4,917760,917999,5,10,10,3,127,159,4,768,879,5,1471,1471,5,1536,1541,1,1648,1648,5,1767,1768,5,1840,1866,5,2070,2073,5,2137,2139,5,2274,2274,1,2363,2363,7,2377,2380,7,2402,2403,5,2494,2494,5,2507,2508,7,2558,2558,5,2622,2624,7,2641,2641,5,2691,2691,7,2759,2760,5,2786,2787,5,2876,2876,5,2881,2884,5,2901,2902,5,3006,3006,5,3014,3016,7,3072,3072,5,3134,3136,5,3157,3158,5,3260,3260,5,3266,3266,5,3274,3275,7,3328,3329,5,3391,3392,7,3405,3405,5,3457,3457,5,3536,3537,7,3551,3551,5,3636,3642,5,3764,3772,5,3895,3895,5,3967,3967,7,3993,4028,5,4146,4151,5,4182,4183,7,4226,4226,5,4253,4253,5,4957,4959,5,5940,5940,7,6070,6070,7,6087,6088,7,6158,6158,4,6432,6434,5,6448,6449,7,6679,6680,5,6742,6742,5,6754,6754,5,6783,6783,5,6912,6915,5,6966,6970,5,6978,6978,5,7042,7042,7,7080,7081,5,7143,7143,7,7150,7150,7,7212,7219,5,7380,7392,5,7412,7412,5,8203,8203,4,8232,8232,4,8265,8265,14,8400,8412,5,8421,8432,5,8617,8618,14,9167,9167,14,9200,9200,14,9410,9410,14,9723,9726,14,9733,9733,14,9745,9745,14,9752,9752,14,9760,9760,14,9766,9766,14,9774,9774,14,9786,9786,14,9794,9794,14,9823,9823,14,9828,9828,14,9833,9850,14,9855,9855,14,9875,9875,14,9880,9880,14,9885,9887,14,9896,9897,14,9906,9916,14,9926,9927,14,9935,9935,14,9939,9939,14,9962,9962,14,9972,9972,14,9978,9978,14,9986,9986,14,9997,9997,14,10002,10002,14,10017,10017,14,10055,10055,14,10071,10071,14,10133,10135,14,10548,10549,14,11093,11093,14,12330,12333,5,12441,12442,5,42608,42610,5,43010,43010,5,43045,43046,5,43188,43203,7,43302,43309,5,43392,43394,5,43446,43449,5,43493,43493,5,43571,43572,7,43597,43597,7,43703,43704,5,43756,43757,5,44003,44004,7,44009,44010,7,44033,44059,12,44089,44115,12,44145,44171,12,44201,44227,12,44257,44283,12,44313,44339,12,44369,44395,12,44425,44451,12,44481,44507,12,44537,44563,12,44593,44619,12,44649,44675,12,44705,44731,12,44761,44787,12,44817,44843,12,44873,44899,12,44929,44955,12,44985,45011,12,45041,45067,12,45097,45123,12,45153,45179,12,45209,45235,12,45265,45291,12,45321,45347,12,45377,45403,12,45433,45459,12,45489,45515,12,45545,45571,12,45601,45627,12,45657,45683,12,45713,45739,12,45769,45795,12,45825,45851,12,45881,45907,12,45937,45963,12,45993,46019,12,46049,46075,12,46105,46131,12,46161,46187,12,46217,46243,12,46273,46299,12,46329,46355,12,46385,46411,12,46441,46467,12,46497,46523,12,46553,46579,12,46609,46635,12,46665,46691,12,46721,46747,12,46777,46803,12,46833,46859,12,46889,46915,12,46945,46971,12,47001,47027,12,47057,47083,12,47113,47139,12,47169,47195,12,47225,47251,12,47281,47307,12,47337,47363,12,47393,47419,12,47449,47475,12,47505,47531,12,47561,47587,12,47617,47643,12,47673,47699,12,47729,47755,12,47785,47811,12,47841,47867,12,47897,47923,12,47953,47979,12,48009,48035,12,48065,48091,12,48121,48147,12,48177,48203,12,48233,48259,12,48289,48315,12,48345,48371,12,48401,48427,12,48457,48483,12,48513,48539,12,48569,48595,12,48625,48651,12,48681,48707,12,48737,48763,12,48793,48819,12,48849,48875,12,48905,48931,12,48961,48987,12,49017,49043,12,49073,49099,12,49129,49155,12,49185,49211,12,49241,49267,12,49297,49323,12,49353,49379,12,49409,49435,12,49465,49491,12,49521,49547,12,49577,49603,12,49633,49659,12,49689,49715,12,49745,49771,12,49801,49827,12,49857,49883,12,49913,49939,12,49969,49995,12,50025,50051,12,50081,50107,12,50137,50163,12,50193,50219,12,50249,50275,12,50305,50331,12,50361,50387,12,50417,50443,12,50473,50499,12,50529,50555,12,50585,50611,12,50641,50667,12,50697,50723,12,50753,50779,12,50809,50835,12,50865,50891,12,50921,50947,12,50977,51003,12,51033,51059,12,51089,51115,12,51145,51171,12,51201,51227,12,51257,51283,12,51313,51339,12,51369,51395,12,51425,51451,12,51481,51507,12,51537,51563,12,51593,51619,12,51649,51675,12,51705,51731,12,51761,51787,12,51817,51843,12,51873,51899,12,51929,51955,12,51985,52011,12,52041,52067,12,52097,52123,12,52153,52179,12,52209,52235,12,52265,52291,12,52321,52347,12,52377,52403,12,52433,52459,12,52489,52515,12,52545,52571,12,52601,52627,12,52657,52683,12,52713,52739,12,52769,52795,12,52825,52851,12,52881,52907,12,52937,52963,12,52993,53019,12,53049,53075,12,53105,53131,12,53161,53187,12,53217,53243,12,53273,53299,12,53329,53355,12,53385,53411,12,53441,53467,12,53497,53523,12,53553,53579,12,53609,53635,12,53665,53691,12,53721,53747,12,53777,53803,12,53833,53859,12,53889,53915,12,53945,53971,12,54001,54027,12,54057,54083,12,54113,54139,12,54169,54195,12,54225,54251,12,54281,54307,12,54337,54363,12,54393,54419,12,54449,54475,12,54505,54531,12,54561,54587,12,54617,54643,12,54673,54699,12,54729,54755,12,54785,54811,12,54841,54867,12,54897,54923,12,54953,54979,12,55009,55035,12,55065,55091,12,55121,55147,12,55177,55203,12,65024,65039,5,65520,65528,4,66422,66426,5,68152,68154,5,69291,69292,5,69633,69633,5,69747,69748,5,69811,69814,5,69826,69826,5,69932,69932,7,70016,70017,5,70079,70080,7,70095,70095,5,70196,70196,5,70367,70367,5,70402,70403,7,70464,70464,5,70487,70487,5,70709,70711,7,70725,70725,7,70833,70834,7,70843,70844,7,70849,70849,7,71090,71093,5,71103,71104,5,71227,71228,7,71339,71339,5,71344,71349,5,71458,71461,5,71727,71735,5,71985,71989,7,71998,71998,5,72002,72002,7,72154,72155,5,72193,72202,5,72251,72254,5,72281,72283,5,72344,72345,5,72766,72766,7,72874,72880,5,72885,72886,5,73023,73029,5,73104,73105,5,73111,73111,5,92912,92916,5,94095,94098,5,113824,113827,4,119142,119142,7,119155,119162,4,119362,119364,5,121476,121476,5,122888,122904,5,123184,123190,5,125252,125258,5,127183,127183,14,127340,127343,14,127377,127386,14,127491,127503,14,127548,127551,14,127744,127756,14,127761,127761,14,127769,127769,14,127773,127774,14,127780,127788,14,127796,127797,14,127820,127823,14,127869,127869,14,127894,127895,14,127902,127903,14,127943,127943,14,127947,127950,14,127972,127972,14,127988,127988,14,127992,127994,14,128009,128011,14,128019,128019,14,128023,128041,14,128064,128064,14,128102,128107,14,128174,128181,14,128238,128238,14,128246,128247,14,128254,128254,14,128264,128264,14,128278,128299,14,128329,128330,14,128348,128359,14,128371,128377,14,128392,128393,14,128401,128404,14,128421,128421,14,128433,128434,14,128450,128452,14,128476,128478,14,128483,128483,14,128495,128495,14,128506,128506,14,128519,128520,14,128528,128528,14,128534,128534,14,128538,128538,14,128540,128542,14,128544,128549,14,128552,128555,14,128557,128557,14,128560,128563,14,128565,128565,14,128567,128576,14,128581,128591,14,128641,128642,14,128646,128646,14,128648,128648,14,128650,128651,14,128653,128653,14,128655,128655,14,128657,128659,14,128661,128661,14,128663,128663,14,128665,128666,14,128674,128674,14,128676,128677,14,128679,128685,14,128690,128690,14,128694,128694,14,128697,128702,14,128704,128704,14,128710,128714,14,128716,128716,14,128720,128720,14,128723,128724,14,128726,128727,14,128733,128735,14,128742,128744,14,128746,128746,14,128749,128751,14,128753,128754,14,128756,128758,14,128761,128761,14,128763,128764,14,128884,128895,14,128992,129003,14,129008,129008,14,129036,129039,14,129114,129119,14,129198,129279,14,129293,129295,14,129305,129310,14,129312,129319,14,129328,129328,14,129331,129338,14,129343,129343,14,129351,129355,14,129357,129359,14,129375,129387,14,129393,129393,14,129395,129398,14,129401,129401,14,129403,129403,14,129408,129412,14,129426,129431,14,129443,129444,14,129451,129453,14,129456,129465,14,129472,129472,14,129475,129482,14,129484,129484,14,129488,129510,14,129536,129647,14,129652,129652,14,129656,129658,14,129661,129663,14,129667,129670,14,129680,129685,14,129705,129708,14,129712,129718,14,129723,129727,14,129731,129733,14,129744,129750,14,129754,129759,14,129768,129775,14,129783,129791,14,917504,917504,4,917506,917535,4,917632,917759,4,918000,921599,4,0,9,4,11,12,4,14,31,4,169,169,14,174,174,14,1155,1159,5,1425,1469,5,1473,1474,5,1479,1479,5,1552,1562,5,1611,1631,5,1750,1756,5,1759,1764,5,1770,1773,5,1809,1809,5,1958,1968,5,2045,2045,5,2075,2083,5,2089,2093,5,2192,2193,1,2250,2273,5,2275,2306,5,2362,2362,5,2364,2364,5,2369,2376,5,2381,2381,5,2385,2391,5,2433,2433,5,2492,2492,5,2495,2496,7,2503,2504,7,2509,2509,5,2530,2531,5,2561,2562,5,2620,2620,5,2625,2626,5,2635,2637,5,2672,2673,5,2689,2690,5,2748,2748,5,2753,2757,5,2761,2761,7,2765,2765,5,2810,2815,5,2818,2819,7,2878,2878,5,2880,2880,7,2887,2888,7,2893,2893,5,2903,2903,5,2946,2946,5,3007,3007,7,3009,3010,7,3018,3020,7,3031,3031,5,3073,3075,7,3132,3132,5,3137,3140,7,3146,3149,5,3170,3171,5,3202,3203,7,3262,3262,7,3264,3265,7,3267,3268,7,3271,3272,7,3276,3277,5,3298,3299,5,3330,3331,7,3390,3390,5,3393,3396,5,3402,3404,7,3406,3406,1,3426,3427,5,3458,3459,7,3535,3535,5,3538,3540,5,3544,3550,7,3570,3571,7,3635,3635,7,3655,3662,5,3763,3763,7,3784,3789,5,3893,3893,5,3897,3897,5,3953,3966,5,3968,3972,5,3981,3991,5,4038,4038,5,4145,4145,7,4153,4154,5,4157,4158,5,4184,4185,5,4209,4212,5,4228,4228,7,4237,4237,5,4352,4447,8,4520,4607,10,5906,5908,5,5938,5939,5,5970,5971,5,6068,6069,5,6071,6077,5,6086,6086,5,6089,6099,5,6155,6157,5,6159,6159,5,6313,6313,5,6435,6438,7,6441,6443,7,6450,6450,5,6457,6459,5,6681,6682,7,6741,6741,7,6743,6743,7,6752,6752,5,6757,6764,5,6771,6780,5,6832,6845,5,6847,6862,5,6916,6916,7,6965,6965,5,6971,6971,7,6973,6977,7,6979,6980,7,7040,7041,5,7073,7073,7,7078,7079,7,7082,7082,7,7142,7142,5,7144,7145,5,7149,7149,5,7151,7153,5,7204,7211,7,7220,7221,7,7376,7378,5,7393,7393,7,7405,7405,5,7415,7415,7,7616,7679,5,8204,8204,5,8206,8207,4,8233,8233,4,8252,8252,14,8288,8292,4,8294,8303,4,8413,8416,5,8418,8420,5,8482,8482,14,8596,8601,14,8986,8987,14,9096,9096,14,9193,9196,14,9199,9199,14,9201,9202,14,9208,9210,14,9642,9643,14,9664,9664,14,9728,9729,14,9732,9732,14,9735,9741,14,9743,9744,14,9746,9746,14,9750,9751,14,9753,9756,14,9758,9759,14,9761,9761,14,9764,9765,14,9767,9769,14,9771,9773,14,9775,9775,14,9784,9785,14,9787,9791,14,9793,9793,14,9795,9799,14,9812,9822,14,9824,9824,14,9827,9827,14,9829,9830,14,9832,9832,14,9851,9851,14,9854,9854,14,9856,9861,14,9874,9874,14,9876,9876,14,9878,9879,14,9881,9881,14,9883,9884,14,9888,9889,14,9895,9895,14,9898,9899,14,9904,9905,14,9917,9918,14,9924,9925,14,9928,9928,14,9934,9934,14,9936,9936,14,9938,9938,14,9940,9940,14,9961,9961,14,9963,9967,14,9970,9971,14,9973,9973,14,9975,9977,14,9979,9980,14,9982,9985,14,9987,9988,14,9992,9996,14,9998,9998,14,10000,10001,14,10004,10004,14,10013,10013,14,10024,10024,14,10052,10052,14,10060,10060,14,10067,10069,14,10083,10083,14,10085,10087,14,10145,10145,14,10175,10175,14,11013,11015,14,11088,11088,14,11503,11505,5,11744,11775,5,12334,12335,5,12349,12349,14,12951,12951,14,42607,42607,5,42612,42621,5,42736,42737,5,43014,43014,5,43043,43044,7,43047,43047,7,43136,43137,7,43204,43205,5,43263,43263,5,43335,43345,5,43360,43388,8,43395,43395,7,43444,43445,7,43450,43451,7,43454,43456,7,43561,43566,5,43569,43570,5,43573,43574,5,43596,43596,5,43644,43644,5,43698,43700,5,43710,43711,5,43755,43755,7,43758,43759,7,43766,43766,5,44005,44005,5,44008,44008,5,44012,44012,7,44032,44032,11,44060,44060,11,44088,44088,11,44116,44116,11,44144,44144,11,44172,44172,11,44200,44200,11,44228,44228,11,44256,44256,11,44284,44284,11,44312,44312,11,44340,44340,11,44368,44368,11,44396,44396,11,44424,44424,11,44452,44452,11,44480,44480,11,44508,44508,11,44536,44536,11,44564,44564,11,44592,44592,11,44620,44620,11,44648,44648,11,44676,44676,11,44704,44704,11,44732,44732,11,44760,44760,11,44788,44788,11,44816,44816,11,44844,44844,11,44872,44872,11,44900,44900,11,44928,44928,11,44956,44956,11,44984,44984,11,45012,45012,11,45040,45040,11,45068,45068,11,45096,45096,11,45124,45124,11,45152,45152,11,45180,45180,11,45208,45208,11,45236,45236,11,45264,45264,11,45292,45292,11,45320,45320,11,45348,45348,11,45376,45376,11,45404,45404,11,45432,45432,11,45460,45460,11,45488,45488,11,45516,45516,11,45544,45544,11,45572,45572,11,45600,45600,11,45628,45628,11,45656,45656,11,45684,45684,11,45712,45712,11,45740,45740,11,45768,45768,11,45796,45796,11,45824,45824,11,45852,45852,11,45880,45880,11,45908,45908,11,45936,45936,11,45964,45964,11,45992,45992,11,46020,46020,11,46048,46048,11,46076,46076,11,46104,46104,11,46132,46132,11,46160,46160,11,46188,46188,11,46216,46216,11,46244,46244,11,46272,46272,11,46300,46300,11,46328,46328,11,46356,46356,11,46384,46384,11,46412,46412,11,46440,46440,11,46468,46468,11,46496,46496,11,46524,46524,11,46552,46552,11,46580,46580,11,46608,46608,11,46636,46636,11,46664,46664,11,46692,46692,11,46720,46720,11,46748,46748,11,46776,46776,11,46804,46804,11,46832,46832,11,46860,46860,11,46888,46888,11,46916,46916,11,46944,46944,11,46972,46972,11,47000,47000,11,47028,47028,11,47056,47056,11,47084,47084,11,47112,47112,11,47140,47140,11,47168,47168,11,47196,47196,11,47224,47224,11,47252,47252,11,47280,47280,11,47308,47308,11,47336,47336,11,47364,47364,11,47392,47392,11,47420,47420,11,47448,47448,11,47476,47476,11,47504,47504,11,47532,47532,11,47560,47560,11,47588,47588,11,47616,47616,11,47644,47644,11,47672,47672,11,47700,47700,11,47728,47728,11,47756,47756,11,47784,47784,11,47812,47812,11,47840,47840,11,47868,47868,11,47896,47896,11,47924,47924,11,47952,47952,11,47980,47980,11,48008,48008,11,48036,48036,11,48064,48064,11,48092,48092,11,48120,48120,11,48148,48148,11,48176,48176,11,48204,48204,11,48232,48232,11,48260,48260,11,48288,48288,11,48316,48316,11,48344,48344,11,48372,48372,11,48400,48400,11,48428,48428,11,48456,48456,11,48484,48484,11,48512,48512,11,48540,48540,11,48568,48568,11,48596,48596,11,48624,48624,11,48652,48652,11,48680,48680,11,48708,48708,11,48736,48736,11,48764,48764,11,48792,48792,11,48820,48820,11,48848,48848,11,48876,48876,11,48904,48904,11,48932,48932,11,48960,48960,11,48988,48988,11,49016,49016,11,49044,49044,11,49072,49072,11,49100,49100,11,49128,49128,11,49156,49156,11,49184,49184,11,49212,49212,11,49240,49240,11,49268,49268,11,49296,49296,11,49324,49324,11,49352,49352,11,49380,49380,11,49408,49408,11,49436,49436,11,49464,49464,11,49492,49492,11,49520,49520,11,49548,49548,11,49576,49576,11,49604,49604,11,49632,49632,11,49660,49660,11,49688,49688,11,49716,49716,11,49744,49744,11,49772,49772,11,49800,49800,11,49828,49828,11,49856,49856,11,49884,49884,11,49912,49912,11,49940,49940,11,49968,49968,11,49996,49996,11,50024,50024,11,50052,50052,11,50080,50080,11,50108,50108,11,50136,50136,11,50164,50164,11,50192,50192,11,50220,50220,11,50248,50248,11,50276,50276,11,50304,50304,11,50332,50332,11,50360,50360,11,50388,50388,11,50416,50416,11,50444,50444,11,50472,50472,11,50500,50500,11,50528,50528,11,50556,50556,11,50584,50584,11,50612,50612,11,50640,50640,11,50668,50668,11,50696,50696,11,50724,50724,11,50752,50752,11,50780,50780,11,50808,50808,11,50836,50836,11,50864,50864,11,50892,50892,11,50920,50920,11,50948,50948,11,50976,50976,11,51004,51004,11,51032,51032,11,51060,51060,11,51088,51088,11,51116,51116,11,51144,51144,11,51172,51172,11,51200,51200,11,51228,51228,11,51256,51256,11,51284,51284,11,51312,51312,11,51340,51340,11,51368,51368,11,51396,51396,11,51424,51424,11,51452,51452,11,51480,51480,11,51508,51508,11,51536,51536,11,51564,51564,11,51592,51592,11,51620,51620,11,51648,51648,11,51676,51676,11,51704,51704,11,51732,51732,11,51760,51760,11,51788,51788,11,51816,51816,11,51844,51844,11,51872,51872,11,51900,51900,11,51928,51928,11,51956,51956,11,51984,51984,11,52012,52012,11,52040,52040,11,52068,52068,11,52096,52096,11,52124,52124,11,52152,52152,11,52180,52180,11,52208,52208,11,52236,52236,11,52264,52264,11,52292,52292,11,52320,52320,11,52348,52348,11,52376,52376,11,52404,52404,11,52432,52432,11,52460,52460,11,52488,52488,11,52516,52516,11,52544,52544,11,52572,52572,11,52600,52600,11,52628,52628,11,52656,52656,11,52684,52684,11,52712,52712,11,52740,52740,11,52768,52768,11,52796,52796,11,52824,52824,11,52852,52852,11,52880,52880,11,52908,52908,11,52936,52936,11,52964,52964,11,52992,52992,11,53020,53020,11,53048,53048,11,53076,53076,11,53104,53104,11,53132,53132,11,53160,53160,11,53188,53188,11,53216,53216,11,53244,53244,11,53272,53272,11,53300,53300,11,53328,53328,11,53356,53356,11,53384,53384,11,53412,53412,11,53440,53440,11,53468,53468,11,53496,53496,11,53524,53524,11,53552,53552,11,53580,53580,11,53608,53608,11,53636,53636,11,53664,53664,11,53692,53692,11,53720,53720,11,53748,53748,11,53776,53776,11,53804,53804,11,53832,53832,11,53860,53860,11,53888,53888,11,53916,53916,11,53944,53944,11,53972,53972,11,54000,54000,11,54028,54028,11,54056,54056,11,54084,54084,11,54112,54112,11,54140,54140,11,54168,54168,11,54196,54196,11,54224,54224,11,54252,54252,11,54280,54280,11,54308,54308,11,54336,54336,11,54364,54364,11,54392,54392,11,54420,54420,11,54448,54448,11,54476,54476,11,54504,54504,11,54532,54532,11,54560,54560,11,54588,54588,11,54616,54616,11,54644,54644,11,54672,54672,11,54700,54700,11,54728,54728,11,54756,54756,11,54784,54784,11,54812,54812,11,54840,54840,11,54868,54868,11,54896,54896,11,54924,54924,11,54952,54952,11,54980,54980,11,55008,55008,11,55036,55036,11,55064,55064,11,55092,55092,11,55120,55120,11,55148,55148,11,55176,55176,11,55216,55238,9,64286,64286,5,65056,65071,5,65438,65439,5,65529,65531,4,66272,66272,5,68097,68099,5,68108,68111,5,68159,68159,5,68900,68903,5,69446,69456,5,69632,69632,7,69634,69634,7,69744,69744,5,69759,69761,5,69808,69810,7,69815,69816,7,69821,69821,1,69837,69837,1,69927,69931,5,69933,69940,5,70003,70003,5,70018,70018,7,70070,70078,5,70082,70083,1,70094,70094,7,70188,70190,7,70194,70195,7,70197,70197,7,70206,70206,5,70368,70370,7,70400,70401,5,70459,70460,5,70463,70463,7,70465,70468,7,70475,70477,7,70498,70499,7,70512,70516,5,70712,70719,5,70722,70724,5,70726,70726,5,70832,70832,5,70835,70840,5,70842,70842,5,70845,70845,5,70847,70848,5,70850,70851,5,71088,71089,7,71096,71099,7,71102,71102,7,71132,71133,5,71219,71226,5,71229,71229,5,71231,71232,5,71340,71340,7,71342,71343,7,71350,71350,7,71453,71455,5,71462,71462,7,71724,71726,7,71736,71736,7,71984,71984,5,71991,71992,7,71997,71997,7,71999,71999,1,72001,72001,1,72003,72003,5,72148,72151,5,72156,72159,7,72164,72164,7,72243,72248,5,72250,72250,1,72263,72263,5,72279,72280,7,72324,72329,1,72343,72343,7,72751,72751,7,72760,72765,5,72767,72767,5,72873,72873,7,72881,72881,7,72884,72884,7,73009,73014,5,73020,73021,5,73030,73030,1,73098,73102,7,73107,73108,7,73110,73110,7,73459,73460,5,78896,78904,4,92976,92982,5,94033,94087,7,94180,94180,5,113821,113822,5,118528,118573,5,119141,119141,5,119143,119145,5,119150,119154,5,119163,119170,5,119210,119213,5,121344,121398,5,121461,121461,5,121499,121503,5,122880,122886,5,122907,122913,5,122918,122922,5,123566,123566,5,125136,125142,5,126976,126979,14,126981,127182,14,127184,127231,14,127279,127279,14,127344,127345,14,127374,127374,14,127405,127461,14,127489,127490,14,127514,127514,14,127538,127546,14,127561,127567,14,127570,127743,14,127757,127758,14,127760,127760,14,127762,127762,14,127766,127768,14,127770,127770,14,127772,127772,14,127775,127776,14,127778,127779,14,127789,127791,14,127794,127795,14,127798,127798,14,127819,127819,14,127824,127824,14,127868,127868,14,127870,127871,14,127892,127893,14,127896,127896,14,127900,127901,14,127904,127940,14,127942,127942,14,127944,127944,14,127946,127946,14,127951,127955,14,127968,127971,14,127973,127984,14,127987,127987,14,127989,127989,14,127991,127991,14,127995,127999,5,128008,128008,14,128012,128014,14,128017,128018,14,128020,128020,14,128022,128022,14,128042,128042,14,128063,128063,14,128065,128065,14,128101,128101,14,128108,128109,14,128173,128173,14,128182,128183,14,128236,128237,14,128239,128239,14,128245,128245,14,128248,128248,14,128253,128253,14,128255,128258,14,128260,128263,14,128265,128265,14,128277,128277,14,128300,128301,14,128326,128328,14,128331,128334,14,128336,128347,14,128360,128366,14,128369,128370,14,128378,128378,14,128391,128391,14,128394,128397,14,128400,128400,14,128405,128406,14,128420,128420,14,128422,128423,14,128425,128432,14,128435,128443,14,128445,128449,14,128453,128464,14,128468,128475,14,128479,128480,14,128482,128482,14,128484,128487,14,128489,128494,14,128496,128498,14,128500,128505,14,128507,128511,14,128513,128518,14,128521,128525,14,128527,128527,14,128529,128529,14,128533,128533,14,128535,128535,14,128537,128537,14]")}function pt(te,Ee){if(te===0)return 0;const Le=Pt(te,Ee);if(Le!==void 0)return Le;const Oe=B(Ee,te);return te-=Ue(Oe),te}e.getLeftDeleteOffset=pt;function Pt(te,Ee){let Le=B(Ee,te);for(te-=Ue(Le);Rt(Le)||Le===65039||Le===8419;){if(te===0)return;Le=B(Ee,te),te-=Ue(Le)}if(!!We(Le)){if(te>=0){const Oe=B(Ee,te);Oe===8205&&(te-=Ue(Oe))}return te}}function Ue(te){return te>=65536?2:1}function Rt(te){return 127995<=te&&te<=127999}var J;(function(te){te[te.zwj=8205]="zwj",te[te.emojiVariantSelector=65039]="emojiVariantSelector",te[te.enclosingKeyCap=8419]="enclosingKeyCap"})(J||(J={})),e.noBreakWhitespace="\xA0";class ie{static getData(){return JSON.parse('{"_common":[8232,32,8233,32,5760,32,8192,32,8193,32,8194,32,8195,32,8196,32,8197,32,8198,32,8200,32,8201,32,8202,32,8287,32,8199,32,8239,32,2042,95,65101,95,65102,95,65103,95,8208,45,8209,45,8210,45,65112,45,1748,45,8259,45,727,45,8722,45,10134,45,11450,45,1549,44,1643,44,8218,44,184,44,42233,44,894,59,2307,58,2691,58,1417,58,1795,58,1796,58,5868,58,65072,58,6147,58,6153,58,8282,58,1475,58,760,58,42889,58,8758,58,720,58,42237,58,451,33,11601,33,660,63,577,63,2429,63,5038,63,42731,63,119149,46,8228,46,1793,46,1794,46,42510,46,68176,46,1632,46,1776,46,42232,46,1373,96,65287,96,8219,96,8242,96,1370,96,1523,96,8175,96,65344,96,900,96,8189,96,8125,96,8127,96,8190,96,697,96,884,96,712,96,714,96,715,96,756,96,699,96,701,96,700,96,702,96,42892,96,1497,96,2036,96,2037,96,5194,96,5836,96,94033,96,94034,96,65339,40,10088,40,10098,40,12308,40,64830,40,65341,41,10089,41,10099,41,12309,41,64831,41,10100,123,119060,123,10101,125,8270,42,1645,42,8727,42,66335,42,5941,47,8257,47,8725,47,8260,47,9585,47,10187,47,10744,47,119354,47,12755,47,12339,47,11462,47,20031,47,12035,47,65340,92,65128,92,8726,92,10189,92,10741,92,10745,92,119311,92,119355,92,12756,92,20022,92,12034,92,42872,38,708,94,710,94,5869,43,10133,43,66203,43,8249,60,10094,60,706,60,119350,60,5176,60,5810,60,5120,61,11840,61,12448,61,42239,61,8250,62,10095,62,707,62,119351,62,5171,62,94015,62,8275,126,732,126,8128,126,8764,126,120784,50,120794,50,120804,50,120814,50,120824,50,130034,50,42842,50,423,50,1000,50,42564,50,5311,50,42735,50,119302,51,120785,51,120795,51,120805,51,120815,51,120825,51,130035,51,42923,51,540,51,439,51,42858,51,11468,51,1248,51,94011,51,71882,51,120786,52,120796,52,120806,52,120816,52,120826,52,130036,52,5070,52,71855,52,120787,53,120797,53,120807,53,120817,53,120827,53,130037,53,444,53,71867,53,120788,54,120798,54,120808,54,120818,54,120828,54,130038,54,11474,54,5102,54,71893,54,119314,55,120789,55,120799,55,120809,55,120819,55,120829,55,130039,55,66770,55,71878,55,2819,56,2538,56,2666,56,125131,56,120790,56,120800,56,120810,56,120820,56,120830,56,130040,56,547,56,546,56,66330,56,2663,57,2920,57,2541,57,3437,57,120791,57,120801,57,120811,57,120821,57,120831,57,130041,57,42862,57,11466,57,71884,57,71852,57,71894,57,9082,97,65345,97,119834,97,119886,97,119938,97,119990,97,120042,97,120094,97,120146,97,120198,97,120250,97,120302,97,120354,97,120406,97,120458,97,593,97,945,97,120514,97,120572,97,120630,97,120688,97,120746,97,65313,65,119808,65,119860,65,119912,65,119964,65,120016,65,120068,65,120120,65,120172,65,120224,65,120276,65,120328,65,120380,65,120432,65,913,65,120488,65,120546,65,120604,65,120662,65,120720,65,5034,65,5573,65,42222,65,94016,65,66208,65,119835,98,119887,98,119939,98,119991,98,120043,98,120095,98,120147,98,120199,98,120251,98,120303,98,120355,98,120407,98,120459,98,388,98,5071,98,5234,98,5551,98,65314,66,8492,66,119809,66,119861,66,119913,66,120017,66,120069,66,120121,66,120173,66,120225,66,120277,66,120329,66,120381,66,120433,66,42932,66,914,66,120489,66,120547,66,120605,66,120663,66,120721,66,5108,66,5623,66,42192,66,66178,66,66209,66,66305,66,65347,99,8573,99,119836,99,119888,99,119940,99,119992,99,120044,99,120096,99,120148,99,120200,99,120252,99,120304,99,120356,99,120408,99,120460,99,7428,99,1010,99,11429,99,43951,99,66621,99,128844,67,71922,67,71913,67,65315,67,8557,67,8450,67,8493,67,119810,67,119862,67,119914,67,119966,67,120018,67,120174,67,120226,67,120278,67,120330,67,120382,67,120434,67,1017,67,11428,67,5087,67,42202,67,66210,67,66306,67,66581,67,66844,67,8574,100,8518,100,119837,100,119889,100,119941,100,119993,100,120045,100,120097,100,120149,100,120201,100,120253,100,120305,100,120357,100,120409,100,120461,100,1281,100,5095,100,5231,100,42194,100,8558,68,8517,68,119811,68,119863,68,119915,68,119967,68,120019,68,120071,68,120123,68,120175,68,120227,68,120279,68,120331,68,120383,68,120435,68,5024,68,5598,68,5610,68,42195,68,8494,101,65349,101,8495,101,8519,101,119838,101,119890,101,119942,101,120046,101,120098,101,120150,101,120202,101,120254,101,120306,101,120358,101,120410,101,120462,101,43826,101,1213,101,8959,69,65317,69,8496,69,119812,69,119864,69,119916,69,120020,69,120072,69,120124,69,120176,69,120228,69,120280,69,120332,69,120384,69,120436,69,917,69,120492,69,120550,69,120608,69,120666,69,120724,69,11577,69,5036,69,42224,69,71846,69,71854,69,66182,69,119839,102,119891,102,119943,102,119995,102,120047,102,120099,102,120151,102,120203,102,120255,102,120307,102,120359,102,120411,102,120463,102,43829,102,42905,102,383,102,7837,102,1412,102,119315,70,8497,70,119813,70,119865,70,119917,70,120021,70,120073,70,120125,70,120177,70,120229,70,120281,70,120333,70,120385,70,120437,70,42904,70,988,70,120778,70,5556,70,42205,70,71874,70,71842,70,66183,70,66213,70,66853,70,65351,103,8458,103,119840,103,119892,103,119944,103,120048,103,120100,103,120152,103,120204,103,120256,103,120308,103,120360,103,120412,103,120464,103,609,103,7555,103,397,103,1409,103,119814,71,119866,71,119918,71,119970,71,120022,71,120074,71,120126,71,120178,71,120230,71,120282,71,120334,71,120386,71,120438,71,1292,71,5056,71,5107,71,42198,71,65352,104,8462,104,119841,104,119945,104,119997,104,120049,104,120101,104,120153,104,120205,104,120257,104,120309,104,120361,104,120413,104,120465,104,1211,104,1392,104,5058,104,65320,72,8459,72,8460,72,8461,72,119815,72,119867,72,119919,72,120023,72,120179,72,120231,72,120283,72,120335,72,120387,72,120439,72,919,72,120494,72,120552,72,120610,72,120668,72,120726,72,11406,72,5051,72,5500,72,42215,72,66255,72,731,105,9075,105,65353,105,8560,105,8505,105,8520,105,119842,105,119894,105,119946,105,119998,105,120050,105,120102,105,120154,105,120206,105,120258,105,120310,105,120362,105,120414,105,120466,105,120484,105,618,105,617,105,953,105,8126,105,890,105,120522,105,120580,105,120638,105,120696,105,120754,105,1110,105,42567,105,1231,105,43893,105,5029,105,71875,105,65354,106,8521,106,119843,106,119895,106,119947,106,119999,106,120051,106,120103,106,120155,106,120207,106,120259,106,120311,106,120363,106,120415,106,120467,106,1011,106,1112,106,65322,74,119817,74,119869,74,119921,74,119973,74,120025,74,120077,74,120129,74,120181,74,120233,74,120285,74,120337,74,120389,74,120441,74,42930,74,895,74,1032,74,5035,74,5261,74,42201,74,119844,107,119896,107,119948,107,120000,107,120052,107,120104,107,120156,107,120208,107,120260,107,120312,107,120364,107,120416,107,120468,107,8490,75,65323,75,119818,75,119870,75,119922,75,119974,75,120026,75,120078,75,120130,75,120182,75,120234,75,120286,75,120338,75,120390,75,120442,75,922,75,120497,75,120555,75,120613,75,120671,75,120729,75,11412,75,5094,75,5845,75,42199,75,66840,75,1472,124,8739,124,9213,124,65512,124,1633,124,1777,124,66336,124,125127,124,120783,124,120793,124,120803,124,120813,124,120823,124,130033,124,65321,124,8544,124,8464,124,8465,124,119816,124,119868,124,119920,124,120024,124,120128,124,120180,124,120232,124,120284,124,120336,124,120388,124,120440,124,406,124,65356,124,8572,124,8467,124,119845,124,119897,124,119949,124,120001,124,120053,124,120105,124,120157,124,120209,124,120261,124,120313,124,120365,124,120417,124,120469,124,448,124,120496,124,120554,124,120612,124,120670,124,120728,124,11410,124,1030,124,1216,124,1493,124,1503,124,1575,124,126464,124,126592,124,65166,124,65165,124,1994,124,11599,124,5825,124,42226,124,93992,124,66186,124,66313,124,119338,76,8556,76,8466,76,119819,76,119871,76,119923,76,120027,76,120079,76,120131,76,120183,76,120235,76,120287,76,120339,76,120391,76,120443,76,11472,76,5086,76,5290,76,42209,76,93974,76,71843,76,71858,76,66587,76,66854,76,65325,77,8559,77,8499,77,119820,77,119872,77,119924,77,120028,77,120080,77,120132,77,120184,77,120236,77,120288,77,120340,77,120392,77,120444,77,924,77,120499,77,120557,77,120615,77,120673,77,120731,77,1018,77,11416,77,5047,77,5616,77,5846,77,42207,77,66224,77,66321,77,119847,110,119899,110,119951,110,120003,110,120055,110,120107,110,120159,110,120211,110,120263,110,120315,110,120367,110,120419,110,120471,110,1400,110,1404,110,65326,78,8469,78,119821,78,119873,78,119925,78,119977,78,120029,78,120081,78,120185,78,120237,78,120289,78,120341,78,120393,78,120445,78,925,78,120500,78,120558,78,120616,78,120674,78,120732,78,11418,78,42208,78,66835,78,3074,111,3202,111,3330,111,3458,111,2406,111,2662,111,2790,111,3046,111,3174,111,3302,111,3430,111,3664,111,3792,111,4160,111,1637,111,1781,111,65359,111,8500,111,119848,111,119900,111,119952,111,120056,111,120108,111,120160,111,120212,111,120264,111,120316,111,120368,111,120420,111,120472,111,7439,111,7441,111,43837,111,959,111,120528,111,120586,111,120644,111,120702,111,120760,111,963,111,120532,111,120590,111,120648,111,120706,111,120764,111,11423,111,4351,111,1413,111,1505,111,1607,111,126500,111,126564,111,126596,111,65259,111,65260,111,65258,111,65257,111,1726,111,64428,111,64429,111,64427,111,64426,111,1729,111,64424,111,64425,111,64423,111,64422,111,1749,111,3360,111,4125,111,66794,111,71880,111,71895,111,66604,111,1984,79,2534,79,2918,79,12295,79,70864,79,71904,79,120782,79,120792,79,120802,79,120812,79,120822,79,130032,79,65327,79,119822,79,119874,79,119926,79,119978,79,120030,79,120082,79,120134,79,120186,79,120238,79,120290,79,120342,79,120394,79,120446,79,927,79,120502,79,120560,79,120618,79,120676,79,120734,79,11422,79,1365,79,11604,79,4816,79,2848,79,66754,79,42227,79,71861,79,66194,79,66219,79,66564,79,66838,79,9076,112,65360,112,119849,112,119901,112,119953,112,120005,112,120057,112,120109,112,120161,112,120213,112,120265,112,120317,112,120369,112,120421,112,120473,112,961,112,120530,112,120544,112,120588,112,120602,112,120646,112,120660,112,120704,112,120718,112,120762,112,120776,112,11427,112,65328,80,8473,80,119823,80,119875,80,119927,80,119979,80,120031,80,120083,80,120187,80,120239,80,120291,80,120343,80,120395,80,120447,80,929,80,120504,80,120562,80,120620,80,120678,80,120736,80,11426,80,5090,80,5229,80,42193,80,66197,80,119850,113,119902,113,119954,113,120006,113,120058,113,120110,113,120162,113,120214,113,120266,113,120318,113,120370,113,120422,113,120474,113,1307,113,1379,113,1382,113,8474,81,119824,81,119876,81,119928,81,119980,81,120032,81,120084,81,120188,81,120240,81,120292,81,120344,81,120396,81,120448,81,11605,81,119851,114,119903,114,119955,114,120007,114,120059,114,120111,114,120163,114,120215,114,120267,114,120319,114,120371,114,120423,114,120475,114,43847,114,43848,114,7462,114,11397,114,43905,114,119318,82,8475,82,8476,82,8477,82,119825,82,119877,82,119929,82,120033,82,120189,82,120241,82,120293,82,120345,82,120397,82,120449,82,422,82,5025,82,5074,82,66740,82,5511,82,42211,82,94005,82,65363,115,119852,115,119904,115,119956,115,120008,115,120060,115,120112,115,120164,115,120216,115,120268,115,120320,115,120372,115,120424,115,120476,115,42801,115,445,115,1109,115,43946,115,71873,115,66632,115,65331,83,119826,83,119878,83,119930,83,119982,83,120034,83,120086,83,120138,83,120190,83,120242,83,120294,83,120346,83,120398,83,120450,83,1029,83,1359,83,5077,83,5082,83,42210,83,94010,83,66198,83,66592,83,119853,116,119905,116,119957,116,120009,116,120061,116,120113,116,120165,116,120217,116,120269,116,120321,116,120373,116,120425,116,120477,116,8868,84,10201,84,128872,84,65332,84,119827,84,119879,84,119931,84,119983,84,120035,84,120087,84,120139,84,120191,84,120243,84,120295,84,120347,84,120399,84,120451,84,932,84,120507,84,120565,84,120623,84,120681,84,120739,84,11430,84,5026,84,42196,84,93962,84,71868,84,66199,84,66225,84,66325,84,119854,117,119906,117,119958,117,120010,117,120062,117,120114,117,120166,117,120218,117,120270,117,120322,117,120374,117,120426,117,120478,117,42911,117,7452,117,43854,117,43858,117,651,117,965,117,120534,117,120592,117,120650,117,120708,117,120766,117,1405,117,66806,117,71896,117,8746,85,8899,85,119828,85,119880,85,119932,85,119984,85,120036,85,120088,85,120140,85,120192,85,120244,85,120296,85,120348,85,120400,85,120452,85,1357,85,4608,85,66766,85,5196,85,42228,85,94018,85,71864,85,8744,118,8897,118,65366,118,8564,118,119855,118,119907,118,119959,118,120011,118,120063,118,120115,118,120167,118,120219,118,120271,118,120323,118,120375,118,120427,118,120479,118,7456,118,957,118,120526,118,120584,118,120642,118,120700,118,120758,118,1141,118,1496,118,71430,118,43945,118,71872,118,119309,86,1639,86,1783,86,8548,86,119829,86,119881,86,119933,86,119985,86,120037,86,120089,86,120141,86,120193,86,120245,86,120297,86,120349,86,120401,86,120453,86,1140,86,11576,86,5081,86,5167,86,42719,86,42214,86,93960,86,71840,86,66845,86,623,119,119856,119,119908,119,119960,119,120012,119,120064,119,120116,119,120168,119,120220,119,120272,119,120324,119,120376,119,120428,119,120480,119,7457,119,1121,119,1309,119,1377,119,71434,119,71438,119,71439,119,43907,119,71919,87,71910,87,119830,87,119882,87,119934,87,119986,87,120038,87,120090,87,120142,87,120194,87,120246,87,120298,87,120350,87,120402,87,120454,87,1308,87,5043,87,5076,87,42218,87,5742,120,10539,120,10540,120,10799,120,65368,120,8569,120,119857,120,119909,120,119961,120,120013,120,120065,120,120117,120,120169,120,120221,120,120273,120,120325,120,120377,120,120429,120,120481,120,5441,120,5501,120,5741,88,9587,88,66338,88,71916,88,65336,88,8553,88,119831,88,119883,88,119935,88,119987,88,120039,88,120091,88,120143,88,120195,88,120247,88,120299,88,120351,88,120403,88,120455,88,42931,88,935,88,120510,88,120568,88,120626,88,120684,88,120742,88,11436,88,11613,88,5815,88,42219,88,66192,88,66228,88,66327,88,66855,88,611,121,7564,121,65369,121,119858,121,119910,121,119962,121,120014,121,120066,121,120118,121,120170,121,120222,121,120274,121,120326,121,120378,121,120430,121,120482,121,655,121,7935,121,43866,121,947,121,8509,121,120516,121,120574,121,120632,121,120690,121,120748,121,1199,121,4327,121,71900,121,65337,89,119832,89,119884,89,119936,89,119988,89,120040,89,120092,89,120144,89,120196,89,120248,89,120300,89,120352,89,120404,89,120456,89,933,89,978,89,120508,89,120566,89,120624,89,120682,89,120740,89,11432,89,1198,89,5033,89,5053,89,42220,89,94019,89,71844,89,66226,89,119859,122,119911,122,119963,122,120015,122,120067,122,120119,122,120171,122,120223,122,120275,122,120327,122,120379,122,120431,122,120483,122,7458,122,43923,122,71876,122,66293,90,71909,90,65338,90,8484,90,8488,90,119833,90,119885,90,119937,90,119989,90,120041,90,120197,90,120249,90,120301,90,120353,90,120405,90,120457,90,918,90,120493,90,120551,90,120609,90,120667,90,120725,90,5059,90,42204,90,71849,90],"_default":[160,32,8211,45,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,124,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89],"cs":[65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,124,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89],"de":[65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,124,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89],"es":[8211,45,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89],"fr":[65306,58,65281,33,8216,96,8245,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,124,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89],"it":[160,32,8211,45,65306,58,65281,33,8216,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,124,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89],"ja":[8211,45,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,124,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89],"ko":[8211,45,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,124,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89],"pl":[65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,124,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89],"pt-BR":[65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,124,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89],"qps-ploc":[160,32,8211,45,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,124,1052,77,1086,111,1054,79,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89],"ru":[65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,305,105,921,124,1009,112,215,120],"tr":[160,32,8211,45,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,1050,75,921,124,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89],"zh-hans":[65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,124,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89],"zh-hant":[8211,45,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,124,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89]}')}static getConfusablesForCurrentLocale(){if(!ie.map){let Oe=function(Ie){const Se=new Map;for(let le=0;le<Ie.length;le+=2)Se.set(Ie[le],Ie[le+1]);return Se};const Ee=ie.getData();let Le=m.locale;(!Le||!(Le in Ee))&&(Le=m.language),(!Le||!(Le in Ee))&&(Le="_default");const Xe=Oe(Ee._common),Te=Oe(Ee[Le]);for(const[Ie,Se]of Te)Xe.set(Ie,Se);ie.map=Xe}return ie.map}static isAmbiguous(Ee){return ie.getConfusablesForCurrentLocale().has(Ee)}static getPrimaryConfusable(Ee){return ie.getConfusablesForCurrentLocale().get(Ee)}static getPrimaryConfusableCodePoints(){return new Set(ie.getConfusablesForCurrentLocale().keys())}}e.AmbiguousCharacters=ie;class ge{static getRawData(){return JSON.parse("[9,10,11,12,13,32,127,160,173,847,1564,4447,4448,6068,6069,6155,6156,6157,6158,7355,7356,8192,8193,8194,8195,8196,8197,8198,8199,8200,8201,8202,8203,8204,8205,8206,8207,8234,8235,8236,8237,8238,8239,8287,8288,8289,8290,8291,8292,8293,8294,8295,8296,8297,8298,8299,8300,8301,8302,8303,10240,12288,12644,65024,65025,65026,65027,65028,65029,65030,65031,65032,65033,65034,65035,65036,65037,65038,65039,65279,65440,65520,65521,65522,65523,65524,65525,65526,65527,65528,65532,78844,119155,119156,119157,119158,119159,119160,119161,119162,917504,917505,917506,917507,917508,917509,917510,917511,917512,917513,917514,917515,917516,917517,917518,917519,917520,917521,917522,917523,917524,917525,917526,917527,917528,917529,917530,917531,917532,917533,917534,917535,917536,917537,917538,917539,917540,917541,917542,917543,917544,917545,917546,917547,917548,917549,917550,917551,917552,917553,917554,917555,917556,917557,917558,917559,917560,917561,917562,917563,917564,917565,917566,917567,917568,917569,917570,917571,917572,917573,917574,917575,917576,917577,917578,917579,917580,917581,917582,917583,917584,917585,917586,917587,917588,917589,917590,917591,917592,917593,917594,917595,917596,917597,917598,917599,917600,917601,917602,917603,917604,917605,917606,917607,917608,917609,917610,917611,917612,917613,917614,917615,917616,917617,917618,917619,917620,917621,917622,917623,917624,917625,917626,917627,917628,917629,917630,917631,917760,917761,917762,917763,917764,917765,917766,917767,917768,917769,917770,917771,917772,917773,917774,917775,917776,917777,917778,917779,917780,917781,917782,917783,917784,917785,917786,917787,917788,917789,917790,917791,917792,917793,917794,917795,917796,917797,917798,917799,917800,917801,917802,917803,917804,917805,917806,917807,917808,917809,917810,917811,917812,917813,917814,917815,917816,917817,917818,917819,917820,917821,917822,917823,917824,917825,917826,917827,917828,917829,917830,917831,917832,917833,917834,917835,917836,917837,917838,917839,917840,917841,917842,917843,917844,917845,917846,917847,917848,917849,917850,917851,917852,917853,917854,917855,917856,917857,917858,917859,917860,917861,917862,917863,917864,917865,917866,917867,917868,917869,917870,917871,917872,917873,917874,917875,917876,917877,917878,917879,917880,917881,917882,917883,917884,917885,917886,917887,917888,917889,917890,917891,917892,917893,917894,917895,917896,917897,917898,917899,917900,917901,917902,917903,917904,917905,917906,917907,917908,917909,917910,917911,917912,917913,917914,917915,917916,917917,917918,917919,917920,917921,917922,917923,917924,917925,917926,917927,917928,917929,917930,917931,917932,917933,917934,917935,917936,917937,917938,917939,917940,917941,917942,917943,917944,917945,917946,917947,917948,917949,917950,917951,917952,917953,917954,917955,917956,917957,917958,917959,917960,917961,917962,917963,917964,917965,917966,917967,917968,917969,917970,917971,917972,917973,917974,917975,917976,917977,917978,917979,917980,917981,917982,917983,917984,917985,917986,917987,917988,917989,917990,917991,917992,917993,917994,917995,917996,917997,917998,917999]")}static getData(){return this._data||(this._data=new Set(ge.getRawData())),this._data}static isInvisibleCharacter(Ee){return ge.getData().has(Ee)}static get codePoints(){return ge.getData()}}e.InvisibleCharacters=ge,ge._data=void 0}),define(pe[47],ve([0,1,8]),function(Y,e,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StringSHA1=e.toHexString=e.Hasher=e.stringHash=e.numberHash=e.doHash=e.hash=void 0;function L(I){return y(I,0)}e.hash=L;function y(I,p){switch(typeof I){case"object":return I===null?C(349,p):Array.isArray(I)?S(I,p):D(I,p);case"string":return k(I,p);case"boolean":return i(I,p);case"number":return C(I,p);case"undefined":return C(937,p);default:return C(617,p)}}e.doHash=y;function C(I,p){return(p<<5)-p+I|0}e.numberHash=C;function i(I,p){return C(I?433:863,p)}function k(I,p){p=C(149417,p);for(let s=0,r=I.length;s<r;s++)p=C(I.charCodeAt(s),p);return p}e.stringHash=k;function S(I,p){return p=C(104579,p),I.reduce((s,r)=>y(r,s),p)}function D(I,p){return p=C(181387,p),Object.keys(I).sort().reduce((s,r)=>(s=k(r,s),y(I[r],s)),p)}class R{constructor(){this._value=0}get value(){return this._value}hash(p){return this._value=y(p,this._value),this._value}}e.Hasher=R;var P;(function(I){I[I.BLOCK_SIZE=64]="BLOCK_SIZE",I[I.UNICODE_REPLACEMENT=65533]="UNICODE_REPLACEMENT"})(P||(P={}));function u(I,p,s=32){const r=s-p,g=~((1<<r)-1);return(I<<p|(g&I)>>>r)>>>0}function E(I,p=0,s=I.byteLength,r=0){for(let g=0;g<s;g++)I[p+g]=r}function f(I,p,s="0"){for(;I.length<p;)I=s+I;return I}function v(I,p=32){return I instanceof ArrayBuffer?Array.from(new Uint8Array(I)).map(s=>s.toString(16).padStart(2,"0")).join(""):f((I>>>0).toString(16),p/4)}e.toHexString=v;class w{constructor(){this._h0=1732584193,this._h1=4023233417,this._h2=2562383102,this._h3=271733878,this._h4=3285377520,this._buff=new Uint8Array(64+3),this._buffDV=new DataView(this._buff.buffer),this._buffLen=0,this._totalLen=0,this._leftoverHighSurrogate=0,this._finished=!1}update(p){const s=p.length;if(s===0)return;const r=this._buff;let g=this._buffLen,a=this._leftoverHighSurrogate,_,n;for(a!==0?(_=a,n=-1,a=0):(_=p.charCodeAt(0),n=0);;){let t=_;if(m.isHighSurrogate(_))if(n+1<s){const o=p.charCodeAt(n+1);m.isLowSurrogate(o)?(n++,t=m.computeCodePoint(_,o)):t=65533}else{a=_;break}else m.isLowSurrogate(_)&&(t=65533);if(g=this._push(r,g,t),n++,n<s)_=p.charCodeAt(n);else break}this._buffLen=g,this._leftoverHighSurrogate=a}_push(p,s,r){return r<128?p[s++]=r:r<2048?(p[s++]=192|(r&1984)>>>6,p[s++]=128|(r&63)>>>0):r<65536?(p[s++]=224|(r&61440)>>>12,p[s++]=128|(r&4032)>>>6,p[s++]=128|(r&63)>>>0):(p[s++]=240|(r&1835008)>>>18,p[s++]=128|(r&258048)>>>12,p[s++]=128|(r&4032)>>>6,p[s++]=128|(r&63)>>>0),s>=64&&(this._step(),s-=64,this._totalLen+=64,p[0]=p[64+0],p[1]=p[64+1],p[2]=p[64+2]),s}digest(){return this._finished||(this._finished=!0,this._leftoverHighSurrogate&&(this._leftoverHighSurrogate=0,this._buffLen=this._push(this._buff,this._buffLen,65533)),this._totalLen+=this._buffLen,this._wrapUp()),v(this._h0)+v(this._h1)+v(this._h2)+v(this._h3)+v(this._h4)}_wrapUp(){this._buff[this._buffLen++]=128,E(this._buff,this._buffLen),this._buffLen>56&&(this._step(),E(this._buff));const p=8*this._totalLen;this._buffDV.setUint32(56,Math.floor(p/4294967296),!1),this._buffDV.setUint32(60,p%4294967296,!1),this._step()}_step(){const p=w._bigBlock32,s=this._buffDV;for(let c=0;c<64;c+=4)p.setUint32(c,s.getUint32(c,!1),!1);for(let c=64;c<320;c+=4)p.setUint32(c,u(p.getUint32(c-12,!1)^p.getUint32(c-32,!1)^p.getUint32(c-56,!1)^p.getUint32(c-64,!1),1),!1);let r=this._h0,g=this._h1,a=this._h2,_=this._h3,n=this._h4,t,o,d;for(let c=0;c<80;c++)c<20?(t=g&a|~g&_,o=1518500249):c<40?(t=g^a^_,o=1859775393):c<60?(t=g&a|g&_|a&_,o=2400959708):(t=g^a^_,o=3395469782),d=u(r,5)+t+n+o+p.getUint32(c*4,!1)&4294967295,n=_,_=a,a=u(g,30),g=r,r=d;this._h0=this._h0+r&4294967295,this._h1=this._h1+g&4294967295,this._h2=this._h2+a&4294967295,this._h3=this._h3+_&4294967295,this._h4=this._h4+n&4294967295}}e.StringSHA1=w,w._bigBlock32=new DataView(new ArrayBuffer(320))});var nt=this&&this.__classPrivateFieldSet||function(Y,e,m,L,y){if(L==="m")throw new TypeError("Private method is not writable");if(L==="a"&&!y)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?Y!==e||!y:!e.has(Y))throw new TypeError("Cannot write private member to an object whose class did not declare it");return L==="a"?y.call(Y,m):y?y.value=m:e.set(Y,m),m},Ne=this&&this.__classPrivateFieldGet||function(Y,e,m,L){if(m==="a"&&!L)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?Y!==e||!L:!e.has(Y))throw new TypeError("Cannot read private member from an object whose class did not declare it");return m==="m"?L:m==="a"?L.call(Y):L?L.value:e.get(Y)};define(pe[24],ve([0,1,16,8]),function(Y,e,m,L){"use strict";var y,C,i;Object.defineProperty(e,"__esModule",{value:!0}),e.ReadonlyMapView=e.LRUCache=e.LinkedMap=e.Touch=e.ResourceMap=e.TernarySearchTree=e.UriIterator=e.PathIterator=e.ConfigKeysIterator=e.StringIterator=e.setToString=e.mapToString=e.getOrSet=void 0;function k(n,t,o){let d=n.get(t);return d===void 0&&(d=o,n.set(t,d)),d}e.getOrSet=k;function S(n){const t=[];return n.forEach((o,d)=>{t.push(`${d} => ${o}`)}),`Map(${n.size}) {${t.join(", ")}}`}e.mapToString=S;function D(n){const t=[];return n.forEach(o=>{t.push(o)}),`Set(${n.size}) {${t.join(", ")}}`}e.setToString=D;class R{constructor(){this._value="",this._pos=0}reset(t){return this._value=t,this._pos=0,this}next(){return this._pos+=1,this}hasNext(){return this._pos<this._value.length-1}cmp(t){const o=t.charCodeAt(0),d=this._value.charCodeAt(this._pos);return o-d}value(){return this._value[this._pos]}}e.StringIterator=R;class P{constructor(t=!0){this._caseSensitive=t}reset(t){return this._value=t,this._from=0,this._to=0,this.next()}hasNext(){return this._to<this._value.length}next(){this._from=this._to;let t=!0;for(;this._to<this._value.length;this._to++)if(this._value.charCodeAt(this._to)===46)if(t)this._from++;else break;else t=!1;return this}cmp(t){return this._caseSensitive?(0,L.compareSubstring)(t,this._value,0,t.length,this._from,this._to):(0,L.compareSubstringIgnoreCase)(t,this._value,0,t.length,this._from,this._to)}value(){return this._value.substring(this._from,this._to)}}e.ConfigKeysIterator=P;class u{constructor(t=!0,o=!0){this._splitOnBackslash=t,this._caseSensitive=o}reset(t){return this._value=t.replace(/\\$|\/$/,""),this._from=0,this._to=0,this.next()}hasNext(){return this._to<this._value.length}next(){this._from=this._to;let t=!0;for(;this._to<this._value.length;this._to++){const o=this._value.charCodeAt(this._to);if(o===47||this._splitOnBackslash&&o===92)if(t)this._from++;else break;else t=!1}return this}cmp(t){return this._caseSensitive?(0,L.compareSubstring)(t,this._value,0,t.length,this._from,this._to):(0,L.compareSubstringIgnoreCase)(t,this._value,0,t.length,this._from,this._to)}value(){return this._value.substring(this._from,this._to)}}e.PathIterator=u;var E;(function(n){n[n.Scheme=1]="Scheme",n[n.Authority=2]="Authority",n[n.Path=3]="Path",n[n.Query=4]="Query",n[n.Fragment=5]="Fragment"})(E||(E={}));class f{constructor(t){this._ignorePathCasing=t,this._states=[],this._stateIdx=0}reset(t){return this._value=t,this._states=[],this._value.scheme&&this._states.push(1),this._value.authority&&this._states.push(2),this._value.path&&(this._pathIterator=new u(!1,!this._ignorePathCasing(t)),this._pathIterator.reset(t.path),this._pathIterator.value()&&this._states.push(3)),this._value.query&&this._states.push(4),this._value.fragment&&this._states.push(5),this._stateIdx=0,this}next(){return this._states[this._stateIdx]===3&&this._pathIterator.hasNext()?this._pathIterator.next():this._stateIdx+=1,this}hasNext(){return this._states[this._stateIdx]===3&&this._pathIterator.hasNext()||this._stateIdx<this._states.length-1}cmp(t){if(this._states[this._stateIdx]===1)return(0,L.compareIgnoreCase)(t,this._value.scheme);if(this._states[this._stateIdx]===2)return(0,L.compareIgnoreCase)(t,this._value.authority);if(this._states[this._stateIdx]===3)return this._pathIterator.cmp(t);if(this._states[this._stateIdx]===4)return(0,L.compare)(t,this._value.query);if(this._states[this._stateIdx]===5)return(0,L.compare)(t,this._value.fragment);throw new Error}value(){if(this._states[this._stateIdx]===1)return this._value.scheme;if(this._states[this._stateIdx]===2)return this._value.authority;if(this._states[this._stateIdx]===3)return this._pathIterator.value();if(this._states[this._stateIdx]===4)return this._value.query;if(this._states[this._stateIdx]===5)return this._value.fragment;throw new Error}}e.UriIterator=f;class v{constructor(){this.height=1}isEmpty(){return!this.left&&!this.mid&&!this.right&&!this.value}rotateLeft(){const t=this.right;return this.right=t.left,t.left=this,this.updateHeight(),t.updateHeight(),t}rotateRight(){const t=this.left;return this.left=t.right,t.right=this,this.updateHeight(),t.updateHeight(),t}updateHeight(){this.height=1+Math.max(this.heightLeft,this.heightRight)}balanceFactor(){return this.heightRight-this.heightLeft}get heightLeft(){return this.left?.height??0}get heightRight(){return this.right?.height??0}}var w;(function(n){n[n.Left=-1]="Left",n[n.Mid=0]="Mid",n[n.Right=1]="Right"})(w||(w={}));class I{constructor(t){this._iter=t}static forUris(t=()=>!1){return new I(new f(t))}static forPaths(){return new I(new u)}static forStrings(){return new I(new R)}static forConfigKeys(){return new I(new P)}clear(){this._root=void 0}fill(t,o){if(o){const d=o.slice(0);(0,m.shuffle)(d);for(let c of d)this.set(c,t)}else{const d=t.slice(0);(0,m.shuffle)(d);for(let c of d)this.set(c[0],c[1])}}set(t,o){const d=this._iter.reset(t);let c;this._root||(this._root=new v,this._root.segment=d.value());const h=[];for(c=this._root;;){const b=d.cmp(c.segment);if(b>0)c.left||(c.left=new v,c.left.segment=d.value()),h.push([-1,c]),c=c.left;else if(b<0)c.right||(c.right=new v,c.right.segment=d.value()),h.push([1,c]),c=c.right;else if(d.hasNext())d.next(),c.mid||(c.mid=new v,c.mid.segment=d.value()),h.push([0,c]),c=c.mid;else break}const l=c.value;c.value=o,c.key=t;for(let b=h.length-1;b>=0;b--){const T=h[b][1];T.updateHeight();const A=T.balanceFactor();if(A<-1||A>1){const x=h[b][0],O=h[b+1][0];if(x===1&&O===1)h[b][1]=T.rotateLeft();else if(x===-1&&O===-1)h[b][1]=T.rotateRight();else if(x===1&&O===-1)T.right=h[b+1][1]=h[b+1][1].rotateRight(),h[b][1]=T.rotateLeft();else if(x===-1&&O===1)T.left=h[b+1][1]=h[b+1][1].rotateLeft(),h[b][1]=T.rotateRight();else throw new Error;if(b>0)switch(h[b-1][0]){case-1:h[b-1][1].left=h[b][1];break;case 1:h[b-1][1].right=h[b][1];break;case 0:h[b-1][1].mid=h[b][1];break}else this._root=h[0][1]}}return l}get(t){return this._getNode(t)?.value}_getNode(t){const o=this._iter.reset(t);let d=this._root;for(;d;){const c=o.cmp(d.segment);if(c>0)d=d.left;else if(c<0)d=d.right;else if(o.hasNext())o.next(),d=d.mid;else break}return d}has(t){const o=this._getNode(t);return!(o?.value===void 0&&o?.mid===void 0)}delete(t){return this._delete(t,!1)}deleteSuperstr(t){return this._delete(t,!0)}_delete(t,o){const d=this._iter.reset(t),c=[];let h=this._root;for(;h;){const l=d.cmp(h.segment);if(l>0)c.push([-1,h]),h=h.left;else if(l<0)c.push([1,h]),h=h.right;else if(d.hasNext())d.next(),c.push([0,h]),h=h.mid;else break}if(!!h){if(o?(h.left=void 0,h.mid=void 0,h.right=void 0,h.height=1):(h.key=void 0,h.value=void 0),!h.mid&&!h.value)if(h.left&&h.right){const l=this._min(h.right),{key:b,value:T,segment:A}=l;this._delete(l.key,!1),h.key=b,h.value=T,h.segment=A}else{const l=h.left??h.right;if(c.length>0){const[b,T]=c[c.length-1];switch(b){case-1:T.left=l;break;case 0:T.mid=l;break;case 1:T.right=l;break}}else this._root=l}for(let l=c.length-1;l>=0;l--){const b=c[l][1];b.updateHeight();const T=b.balanceFactor();if(T>1?(b.right.balanceFactor()>=0||(b.right=c[l+1][1]=c[l+1][1].rotateRight()),c[l][1]=b.rotateLeft()):T<-1&&(b.left.balanceFactor()<=0||(b.left=c[l+1][1]=c[l+1][1].rotateLeft()),c[l][1]=b.rotateRight()),l>0)switch(c[l-1][0]){case-1:c[l-1][1].left=c[l][1];break;case 1:c[l-1][1].right=c[l][1];break;case 0:c[l-1][1].mid=c[l][1];break}else this._root=c[0][1]}}}_min(t){for(;t.left;)t=t.left;return t}findSubstr(t){const o=this._iter.reset(t);let d=this._root,c;for(;d;){const h=o.cmp(d.segment);if(h>0)d=d.left;else if(h<0)d=d.right;else if(o.hasNext())o.next(),c=d.value||c,d=d.mid;else break}return d&&d.value||c}findSuperstr(t){const o=this._iter.reset(t);let d=this._root;for(;d;){const c=o.cmp(d.segment);if(c>0)d=d.left;else if(c<0)d=d.right;else if(o.hasNext())o.next(),d=d.mid;else return d.mid?this._entries(d.mid):void 0}}forEach(t){for(const[o,d]of this)t(d,o)}*[Symbol.iterator](){yield*this._entries(this._root)}*_entries(t){!t||(t.left&&(yield*this._entries(t.left)),t.value&&(yield[t.key,t.value]),t.mid&&(yield*this._entries(t.mid)),t.right&&(yield*this._entries(t.right)))}_isBalanced(){const t=o=>{if(!o)return!0;const d=o.balanceFactor();return d<-1||d>1?!1:t(o.left)&&t(o.right)};return t(this._root)}}e.TernarySearchTree=I;class p{constructor(t,o){this.uri=t,this.value=o}}class s{constructor(t,o){this[y]="ResourceMap",t instanceof s?(this.map=new Map(t.map),this.toKey=o??s.defaultToKey):(this.map=new Map,this.toKey=t??s.defaultToKey)}set(t,o){return this.map.set(this.toKey(t),new p(t,o)),this}get(t){return this.map.get(this.toKey(t))?.value}has(t){return this.map.has(this.toKey(t))}get size(){return this.map.size}clear(){this.map.clear()}delete(t){return this.map.delete(this.toKey(t))}forEach(t,o){typeof o!="undefined"&&(t=t.bind(o));for(let[d,c]of this.map)t(c.value,c.uri,this)}*values(){for(let t of this.map.values())yield t.value}*keys(){for(let t of this.map.values())yield t.uri}*entries(){for(let t of this.map.values())yield[t.uri,t.value]}*[(y=Symbol.toStringTag,Symbol.iterator)](){for(let[,t]of this.map)yield[t.uri,t.value]}}e.ResourceMap=s,s.defaultToKey=n=>n.toString();var r;(function(n){n[n.None=0]="None",n[n.AsOld=1]="AsOld",n[n.AsNew=2]="AsNew"})(r=e.Touch||(e.Touch={}));class g{constructor(){this[C]="LinkedMap",this._map=new Map,this._head=void 0,this._tail=void 0,this._size=0,this._state=0}clear(){this._map.clear(),this._head=void 0,this._tail=void 0,this._size=0,this._state++}isEmpty(){return!this._head&&!this._tail}get size(){return this._size}get first(){return this._head?.value}get last(){return this._tail?.value}has(t){return this._map.has(t)}get(t,o=0){const d=this._map.get(t);if(!!d)return o!==0&&this.touch(d,o),d.value}set(t,o,d=0){let c=this._map.get(t);if(c)c.value=o,d!==0&&this.touch(c,d);else{switch(c={key:t,value:o,next:void 0,previous:void 0},d){case 0:this.addItemLast(c);break;case 1:this.addItemFirst(c);break;case 2:this.addItemLast(c);break;default:this.addItemLast(c);break}this._map.set(t,c),this._size++}return this}delete(t){return!!this.remove(t)}remove(t){const o=this._map.get(t);if(!!o)return this._map.delete(t),this.removeItem(o),this._size--,o.value}shift(){if(!this._head&&!this._tail)return;if(!this._head||!this._tail)throw new Error("Invalid list");const t=this._head;return this._map.delete(t.key),this.removeItem(t),this._size--,t.value}forEach(t,o){const d=this._state;let c=this._head;for(;c;){if(o?t.bind(o)(c.value,c.key,this):t(c.value,c.key,this),this._state!==d)throw new Error("LinkedMap got modified during iteration.");c=c.next}}keys(){const t=this,o=this._state;let d=this._head;const c={[Symbol.iterator](){return c},next(){if(t._state!==o)throw new Error("LinkedMap got modified during iteration.");if(d){const h={value:d.key,done:!1};return d=d.next,h}else return{value:void 0,done:!0}}};return c}values(){const t=this,o=this._state;let d=this._head;const c={[Symbol.iterator](){return c},next(){if(t._state!==o)throw new Error("LinkedMap got modified during iteration.");if(d){const h={value:d.value,done:!1};return d=d.next,h}else return{value:void 0,done:!0}}};return c}entries(){const t=this,o=this._state;let d=this._head;const c={[Symbol.iterator](){return c},next(){if(t._state!==o)throw new Error("LinkedMap got modified during iteration.");if(d){const h={value:[d.key,d.value],done:!1};return d=d.next,h}else return{value:void 0,done:!0}}};return c}[(C=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}trimOld(t){if(t>=this.size)return;if(t===0){this.clear();return}let o=this._head,d=this.size;for(;o&&d>t;)this._map.delete(o.key),o=o.next,d--;this._head=o,this._size=d,o&&(o.previous=void 0),this._state++}addItemFirst(t){if(!this._head&&!this._tail)this._tail=t;else if(this._head)t.next=this._head,this._head.previous=t;else throw new Error("Invalid list");this._head=t,this._state++}addItemLast(t){if(!this._head&&!this._tail)this._head=t;else if(this._tail)t.previous=this._tail,this._tail.next=t;else throw new Error("Invalid list");this._tail=t,this._state++}removeItem(t){if(t===this._head&&t===this._tail)this._head=void 0,this._tail=void 0;else if(t===this._head){if(!t.next)throw new Error("Invalid list");t.next.previous=void 0,this._head=t.next}else if(t===this._tail){if(!t.previous)throw new Error("Invalid list");t.previous.next=void 0,this._tail=t.previous}else{const o=t.next,d=t.previous;if(!o||!d)throw new Error("Invalid list");o.previous=d,d.next=o}t.next=void 0,t.previous=void 0,this._state++}touch(t,o){if(!this._head||!this._tail)throw new Error("Invalid list");if(!(o!==1&&o!==2)){if(o===1){if(t===this._head)return;const d=t.next,c=t.previous;t===this._tail?(c.next=void 0,this._tail=c):(d.previous=c,c.next=d),t.previous=void 0,t.next=this._head,this._head.previous=t,this._head=t,this._state++}else if(o===2){if(t===this._tail)return;const d=t.next,c=t.previous;t===this._head?(d.previous=void 0,this._head=d):(d.previous=c,c.next=d),t.next=void 0,t.previous=this._tail,this._tail.next=t,this._tail=t,this._state++}}}toJSON(){const t=[];return this.forEach((o,d)=>{t.push([d,o])}),t}fromJSON(t){this.clear();for(const[o,d]of t)this.set(o,d)}}e.LinkedMap=g;class a extends g{constructor(t,o=1){super();this._limit=t,this._ratio=Math.min(Math.max(0,o),1)}get limit(){return this._limit}set limit(t){this._limit=t,this.checkTrim()}get ratio(){return this._ratio}set ratio(t){this._ratio=Math.min(Math.max(0,t),1),this.checkTrim()}get(t,o=2){return super.get(t,o)}peek(t){return super.get(t,0)}set(t,o){return super.set(t,o,2),this.checkTrim(),this}checkTrim(){this.size>this._limit&&this.trimOld(Math.round(this._limit*this._ratio))}}e.LRUCache=a;class _{constructor(t){i.set(this,void 0),nt(this,i,t,"f")}get size(){return Ne(this,i,"f").size}forEach(t,o){Ne(this,i,"f").forEach(t,o)}get(t){return Ne(this,i,"f").get(t)}has(t){return Ne(this,i,"f").has(t)}entries(){return Ne(this,i,"f").entries()}keys(){return Ne(this,i,"f").keys()}values(){return Ne(this,i,"f").values()}[(i=new WeakMap,Symbol.iterator)](){return Ne(this,i,"f").entries()}}e.ReadonlyMapView=_}),define(pe[96],ve([0,1,24,8]),function(Y,e,m,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.fuzzyScoreGraceful=e.fuzzyScoreGracefulAggressive=e.fuzzyScore=e.FuzzyScore=e.isPatternInWord=e.createMatches=e.anyScore=e.matchesFuzzy2=e.matchesFuzzy=e.matchesWords=e.matchesCamelCase=e.isUpper=e.matchesSubString=e.matchesContiguousSubString=e.matchesPrefix=e.matchesStrictPrefix=e.or=void 0;function y(...Z){return function(oe,be){for(let Me=0,Ve=Z.length;Me<Ve;Me++){const Ge=Z[Me](oe,be);if(Ge)return Ge}return null}}e.or=y,e.matchesStrictPrefix=C.bind(void 0,!1),e.matchesPrefix=C.bind(void 0,!0);function C(Z,oe,be){if(!be||be.length<oe.length)return null;let Me;return Z?Me=L.startsWithIgnoreCase(be,oe):Me=be.indexOf(oe)===0,Me?oe.length>0?[{start:0,end:oe.length}]:[]:null}function i(Z,oe){const be=oe.toLowerCase().indexOf(Z.toLowerCase());return be===-1?null:[{start:be,end:be+Z.length}]}e.matchesContiguousSubString=i;function k(Z,oe){return S(Z.toLowerCase(),oe.toLowerCase(),0,0)}e.matchesSubString=k;function S(Z,oe,be,Me){if(be===Z.length)return[];if(Me===oe.length)return null;if(Z[be]===oe[Me]){let Ve=null;return(Ve=S(Z,oe,be+1,Me+1))?I({start:Me,end:Me+1},Ve):null}return S(Z,oe,be,Me+1)}function D(Z){return 97<=Z&&Z<=122}function R(Z){return 65<=Z&&Z<=90}e.isUpper=R;function P(Z){return 48<=Z&&Z<=57}function u(Z){return Z===32||Z===9||Z===10||Z===13}const E=new Set;"()[]{}<>`'\"-/;:,.?!".split("").forEach(Z=>E.add(Z.charCodeAt(0)));function f(Z){return u(Z)||E.has(Z)}function v(Z,oe){return Z===oe||f(Z)&&f(oe)}function w(Z){return D(Z)||R(Z)||P(Z)}function I(Z,oe){return oe.length===0?oe=[Z]:Z.end===oe[0].start?oe[0].start=Z.start:oe.unshift(Z),oe}function p(Z,oe){for(let be=oe;be<Z.length;be++){const Me=Z.charCodeAt(be);if(R(Me)||P(Me)||be>0&&!w(Z.charCodeAt(be-1)))return be}return Z.length}function s(Z,oe,be,Me){if(be===Z.length)return[];if(Me===oe.length)return null;if(Z[be]!==oe[Me].toLowerCase())return null;{let Ve=null,Ge=Me+1;for(Ve=s(Z,oe,be+1,Me+1);!Ve&&(Ge=p(oe,Ge))<oe.length;)Ve=s(Z,oe,be+1,Ge),Ge++;return Ve===null?null:I({start:Me,end:Me+1},Ve)}}function r(Z){let oe=0,be=0,Me=0,Ve=0,Ge=0;for(let it=0;it<Z.length;it++)Ge=Z.charCodeAt(it),R(Ge)&&oe++,D(Ge)&&be++,w(Ge)&&Me++,P(Ge)&&Ve++;const Je=oe/Z.length,tt=be/Z.length,ot=Me/Z.length,et=Ve/Z.length;return{upperPercent:Je,lowerPercent:tt,alphaPercent:ot,numericPercent:et}}function g(Z){const{upperPercent:oe,lowerPercent:be}=Z;return be===0&&oe>.6}function a(Z){const{upperPercent:oe,lowerPercent:be,alphaPercent:Me,numericPercent:Ve}=Z;return be>.2&&oe<.8&&Me>.6&&Ve<.2}function _(Z){let oe=0,be=0,Me=0,Ve=0;for(let Ge=0;Ge<Z.length;Ge++)Me=Z.charCodeAt(Ge),R(Me)&&oe++,D(Me)&&be++,u(Me)&&Ve++;return(oe===0||be===0)&&Ve===0?Z.length<=30:oe<=5}function n(Z,oe){if(!oe||(oe=oe.trim(),oe.length===0)||!_(Z)||oe.length>60)return null;const be=r(oe);if(!a(be)){if(!g(be))return null;oe=oe.toLowerCase()}let Me=null,Ve=0;for(Z=Z.toLowerCase();Ve<oe.length&&(Me=s(Z,oe,0,Ve))===null;)Ve=p(oe,Ve+1);return Me}e.matchesCamelCase=n;function t(Z,oe,be=!1){if(!oe||oe.length===0)return null;let Me=null,Ve=0;for(Z=Z.toLowerCase(),oe=oe.toLowerCase();Ve<oe.length&&(Me=o(Z,oe,0,Ve,be))===null;)Ve=d(oe,Ve+1);return Me}e.matchesWords=t;function o(Z,oe,be,Me,Ve){if(be===Z.length)return[];if(Me===oe.length)return null;if(v(Z.charCodeAt(be),oe.charCodeAt(Me))){let Ge=null,Je=Me+1;if(Ge=o(Z,oe,be+1,Me+1,Ve),!Ve)for(;!Ge&&(Je=d(oe,Je))<oe.length;)Ge=o(Z,oe,be+1,Je,Ve),Je++;return Ge===null?null:I({start:Me,end:Me+1},Ge)}else return null}function d(Z,oe){for(let be=oe;be<Z.length;be++)if(f(Z.charCodeAt(be))||be>0&&f(Z.charCodeAt(be-1)))return be;return Z.length}const c=y(e.matchesPrefix,n,i),h=y(e.matchesPrefix,n,k),l=new m.LRUCache(1e4);function b(Z,oe,be=!1){if(typeof Z!="string"||typeof oe!="string")return null;let Me=l.get(Z);Me||(Me=new RegExp(L.convertSimple2RegExpPattern(Z),"i"),l.set(Z,Me));const Ve=Me.exec(oe);return Ve?[{start:Ve.index,end:Ve.index+Ve[0].length}]:be?h(Z,oe):c(Z,oe)}e.matchesFuzzy=b;function T(Z,oe){const be=Be(Z,Z.toLowerCase(),0,oe,oe.toLowerCase(),0,!0);return be?x(be):null}e.matchesFuzzy2=T;function A(Z,oe,be,Me,Ve,Ge){const Je=Math.min(13,Z.length);for(;be<Je;be++){const tt=Be(Z,oe,be,Me,Ve,Ge,!1);if(tt)return tt}return[0,Ge]}e.anyScore=A;function x(Z){if(typeof Z=="undefined")return[];const oe=[],be=Z[1];for(let Me=Z.length-1;Me>1;Me--){const Ve=Z[Me]+be,Ge=oe[oe.length-1];Ge&&Ge.end===Ve?Ge.end=Ve+1:oe.push({start:Ve,end:Ve+1})}return oe}e.createMatches=x;const O=128;function F(){const Z=[],oe=[];for(let be=0;be<=O;be++)oe[be]=0;for(let be=0;be<=O;be++)Z.push(oe.slice(0));return Z}function W(Z){const oe=[];for(let be=0;be<=Z;be++)oe[be]=0;return oe}const M=W(2*O),B=W(2*O),U=F(),z=F(),K=F(),N=!1;function j(Z,oe,be,Me,Ve){function Ge(tt,ot,et=" "){for(;tt.length<ot;)tt=et+tt;return tt}let Je=` |   |${Me.split("").map(tt=>Ge(tt,3)).join("|")}
`;for(let tt=0;tt<=be;tt++)tt===0?Je+=" |":Je+=`${oe[tt-1]}|`,Je+=Z[tt].slice(0,Ve+1).map(ot=>Ge(ot.toString(),3)).join("|")+`
`;return Je}function H(Z,oe,be,Me){Z=Z.substr(oe),be=be.substr(Me),console.log(j(z,Z,Z.length,be,be.length)),console.log(j(K,Z,Z.length,be,be.length)),console.log(j(U,Z,Z.length,be,be.length))}function V(Z,oe){if(oe<0||oe>=Z.length)return!1;const be=Z.codePointAt(oe);switch(be){case 95:case 45:case 46:case 32:case 47:case 92:case 39:case 34:case 58:case 36:case 60:case 40:case 91:return!0;case void 0:return!1;default:return!!L.isEmojiImprecise(be)}}function q(Z,oe){if(oe<0||oe>=Z.length)return!1;switch(Z.charCodeAt(oe)){case 32:case 9:return!0;default:return!1}}function ne(Z,oe,be){return oe[Z]!==be[Z]}function fe(Z,oe,be,Me,Ve,Ge,Je=!1){for(;oe<be&&Ve<Ge;)Z[oe]===Me[Ve]&&(Je&&(M[oe]=Ve),oe+=1),Ve+=1;return oe===be}e.isPatternInWord=fe;var ye;(function(Z){Z[Z.Diag=1]="Diag",Z[Z.Left=2]="Left",Z[Z.LeftLeft=3]="LeftLeft"})(ye||(ye={}));var ke;(function(Z){Z.Default=[-100,0];function oe(be){return!be||be.length===2&&be[0]===-100&&be[1]===0}Z.isDefault=oe})(ke=e.FuzzyScore||(e.FuzzyScore={}));function Be(Z,oe,be,Me,Ve,Ge,Je){const tt=Z.length>O?O:Z.length,ot=Me.length>O?O:Me.length;if(be>=tt||Ge>=ot||tt-be>ot-Ge||!fe(oe,be,tt,Ve,Ge,ot,!0))return;We(tt,ot,be,Ge,oe,Ve);let et=1,it=1,ct=be,pt=Ge;const Pt=[!1];for(et=1,ct=be;ct<tt;et++,ct++){const ge=M[ct],te=B[ct],Ee=ct+1<tt?B[ct+1]:ot;for(it=ge-Ge+1,pt=ge;pt<Ee;it++,pt++){let Le=Number.MIN_SAFE_INTEGER,Oe=!1;pt<=te&&(Le=ze(Z,oe,ct,be,Me,Ve,pt,ot,Ge,U[et-1][it-1]===0,Pt));let Xe=0;Le!==Number.MAX_SAFE_INTEGER&&(Oe=!0,Xe=Le+z[et-1][it-1]);const Te=pt>ge,Ie=Te?z[et][it-1]+(U[et][it-1]>0?-5:0):0,Se=pt>ge+1&&U[et][it-1]>0,le=Se?z[et][it-2]+(U[et][it-2]>0?-5:0):0;if(Se&&(!Te||le>=Ie)&&(!Oe||le>=Xe))z[et][it]=le,K[et][it]=3,U[et][it]=0;else if(Te&&(!Oe||Ie>=Xe))z[et][it]=Ie,K[et][it]=2,U[et][it]=0;else if(Oe)z[et][it]=Xe,K[et][it]=1,U[et][it]=U[et-1][it-1]+1;else throw new Error("not possible")}}if(N&&H(Z,be,Me,Ge),!Pt[0]&&!Je)return;et--,it--;const Ue=[z[et][it],Ge];let Rt=0,J=0;for(;et>=1;){let ge=it;do{const te=K[et][ge];if(te===3)ge=ge-2;else if(te===2)ge=ge-1;else break}while(ge>=1);Rt>1&&oe[be+et-1]===Ve[Ge+it-1]&&!ne(ge+Ge-1,Me,Ve)&&Rt+1>U[et][ge]&&(ge=it),ge===it?Rt++:Rt=1,J||(J=ge),et--,it=ge-1,Ue.push(it)}ot===tt&&(Ue[0]+=2);const ie=J-tt;return Ue[0]-=ie,Ue}e.fuzzyScore=Be;function We(Z,oe,be,Me,Ve,Ge){let Je=Z-1,tt=oe-1;for(;Je>=be&&tt>=Me;)Ve[Je]===Ge[tt]&&(B[Je]=tt,Je--),tt--}function ze(Z,oe,be,Me,Ve,Ge,Je,tt,ot,et,it){if(oe[be]!==Ge[Je])return Number.MIN_SAFE_INTEGER;let ct=1,pt=!1;return Je===be-Me?ct=Z[be]===Ve[Je]?7:5:ne(Je,Ve,Ge)&&(Je===0||!ne(Je-1,Ve,Ge))?(ct=Z[be]===Ve[Je]?7:5,pt=!0):V(Ge,Je)&&(Je===0||!V(Ge,Je-1))?ct=5:(V(Ge,Je-1)||q(Ge,Je-1))&&(ct=5,pt=!0),ct>1&&be===Me&&(it[0]=!0),pt||(pt=ne(Je,Ve,Ge)||V(Ge,Je-1)||q(Ge,Je-1)),be===Me?Je>ot&&(ct-=pt?3:5):et?ct+=pt?2:0:ct+=pt?0:1,Je+1===tt&&(ct-=pt?3:5),ct}function Q(Z,oe,be,Me,Ve,Ge,Je){return re(Z,oe,be,Me,Ve,Ge,!0,Je)}e.fuzzyScoreGracefulAggressive=Q;function ee(Z,oe,be,Me,Ve,Ge,Je){return re(Z,oe,be,Me,Ve,Ge,!1,Je)}e.fuzzyScoreGraceful=ee;function re(Z,oe,be,Me,Ve,Ge,Je,tt){let ot=Be(Z,oe,be,Me,Ve,Ge,tt);if(ot&&!Je)return ot;if(Z.length>=3){const et=Math.min(7,Z.length-1);for(let it=be+1;it<et;it++){const ct=he(Z,it);if(ct){const pt=Be(ct,ct.toLowerCase(),be,Me,Ve,Ge,tt);pt&&(pt[0]-=3,(!ot||pt[0]>ot[0])&&(ot=pt))}}}return ot}function he(Z,oe){if(oe+1>=Z.length)return;const be=Z[oe],Me=Z[oe+1];if(be!==Me)return Z.slice(0,oe)+Me+be+Z.slice(oe+2)}}),define(pe[141],ve([0,1,78,96,8]),function(Y,e,m,L,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.matchesFuzzyIconAware=e.parseLabelWithIcons=e.stripIcons=e.markdownEscapeEscapedIcons=e.escapeIcons=e.iconStartMarker=void 0,e.iconStartMarker="$(";const C=new RegExp(`\\$\\(${m.CSSIcon.iconNameExpression}(?:${m.CSSIcon.iconModifierExpression})?\\)`,"g"),i=new RegExp(m.CSSIcon.iconNameCharacter),k=new RegExp(`(\\\\)?${C.source}`,"g");function S(w){return w.replace(k,(I,p)=>p?I:`\\${I}`)}e.escapeIcons=S;const D=new RegExp(`\\\\${C.source}`,"g");function R(w){return w.replace(D,I=>`\\${I}`)}e.markdownEscapeEscapedIcons=R;const P=new RegExp(`(\\s)?(\\\\)?${C.source}(\\s)?`,"g");function u(w){return w.indexOf(e.iconStartMarker)===-1?w:w.replace(P,(I,p,s,r)=>s?I:p||r||"")}e.stripIcons=u;function E(w){const I=w.indexOf(e.iconStartMarker);return I===-1?{text:w}:f(w,I)}e.parseLabelWithIcons=E;function f(w,I){const p=[];let s="";function r(c){if(c){s+=c;for(const h of c)p.push(_)}}let g=-1,a="",_=0,n,t,o=I;const d=w.length;for(r(w.substr(0,I));o<d;)n=w[o],t=w[o+1],n===e.iconStartMarker[0]&&t===e.iconStartMarker[1]?(g=o,r(a),a=e.iconStartMarker,o++):n===")"&&g!==-1?(_+=o-g+1,g=-1,a=""):g!==-1?i.test(n)?a+=n:(r(a),g=-1,a=""):r(n),o++;return r(a),{text:s,iconOffsets:p}}function v(w,I,p=!1){const{text:s,iconOffsets:r}=I;if(!r||r.length===0)return(0,L.matchesFuzzy)(w,s,p);const g=(0,y.ltrim)(s," "),a=s.length-g.length,_=(0,L.matchesFuzzy)(w,g,p);if(_)for(const n of _){const t=r[n.start+a]+a;n.start+=t,n.end+=t}return _}e.matchesFuzzyIconAware=v}),define(pe[97],ve([0,1,15,141]),function(Y,e,m,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parseHrefAndDimensions=e.removeMarkdownEscapes=e.escapeMarkdownSyntaxTokens=e.markdownStringEqual=e.isMarkdownString=e.isEmptyMarkdownString=e.MarkdownString=e.MarkdownStringTextNewlineStyle=void 0;var y;(function(u){u[u.Paragraph=0]="Paragraph",u[u.Break=1]="Break"})(y=e.MarkdownStringTextNewlineStyle||(e.MarkdownStringTextNewlineStyle={}));class C{constructor(E="",f=!1){if(this.value=E,typeof this.value!="string")throw(0,m.illegalArgument)("value");typeof f=="boolean"?(this.isTrusted=f,this.supportThemeIcons=!1,this.supportHtml=!1):(this.isTrusted=f.isTrusted??void 0,this.supportThemeIcons=f.supportThemeIcons??!1,this.supportHtml=f.supportHtml??!1)}appendText(E,f=0){return this.value+=D(this.supportThemeIcons?(0,L.escapeIcons)(E):E).replace(/([ \t]+)/g,(v,w)=>"&nbsp;".repeat(w.length)).replace(/\>/gm,"\\>").replace(/\n/g,f===1?`\\
`:`

`),this}appendMarkdown(E){return this.value+=E,this}appendCodeblock(E,f){return this.value+="\n```",this.value+=E,this.value+=`
`,this.value+=f,this.value+="\n```\n",this}}e.MarkdownString=C;function i(u){return k(u)?!u.value:Array.isArray(u)?u.every(i):!0}e.isEmptyMarkdownString=i;function k(u){return u instanceof C?!0:u&&typeof u=="object"?typeof u.value=="string"&&(typeof u.isTrusted=="boolean"||u.isTrusted===void 0)&&(typeof u.supportThemeIcons=="boolean"||u.supportThemeIcons===void 0):!1}e.isMarkdownString=k;function S(u,E){return u===E?!0:!u||!E?!1:u.value===E.value&&u.isTrusted===E.isTrusted&&u.supportThemeIcons===E.supportThemeIcons}e.markdownStringEqual=S;function D(u){return u.replace(/[\\`*_{}[\]()#+\-!]/g,"\\$&")}e.escapeMarkdownSyntaxTokens=D;function R(u){return u&&u.replace(/\\([\\`*_{}[\]()#+\-.!])/g,"$1")}e.removeMarkdownEscapes=R;function P(u){const E=[],f=u.split("|").map(w=>w.trim());u=f[0];const v=f[1];if(v){const w=/height=(\d+)/.exec(v),I=/width=(\d+)/.exec(v),p=w?w[1]:"",s=I?I[1]:"",r=isFinite(parseInt(s)),g=isFinite(parseInt(p));r&&E.push(`width="${s}"`),g&&E.push(`height="${p}"`)}return{href:u,dimensions:E}}e.parseHrefAndDimensions=P}),define(pe[79],ve([0,1,24]),function(Y,e,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.removeAccents=e.normalizeNFD=e.normalizeNFC=void 0;const L=new m.LRUCache(1e4);function y(D){return S(D,"NFC",L)}e.normalizeNFC=y;const C=new m.LRUCache(1e4);function i(D){return S(D,"NFD",C)}e.normalizeNFD=i;const k=/[^\u0000-\u0080]/;function S(D,R,P){if(!D)return D;const u=P.get(D);if(u)return u;let E;return k.test(D)?E=D.normalize(R):E=D,P.set(D,E),E}e.removeAccents=function(){const D=/[\u0300-\u036f]/g;return function(R){return i(R).replace(D,"")}}()}),define(pe[48],ve([0,1,8]),function(Y,e,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0});var L;(function(y){y[y.Ignore=0]="Ignore",y[y.Info=1]="Info",y[y.Warning=2]="Warning",y[y.Error=3]="Error"})(L||(L={})),function(y){const C="error",i="warning",k="warn",S="info",D="ignore";function R(u){return u?m.equalsIgnoreCase(C,u)?y.Error:m.equalsIgnoreCase(i,u)||m.equalsIgnoreCase(k,u)?y.Warning:m.equalsIgnoreCase(S,u)?y.Info:y.Ignore:y.Ignore}y.fromValue=R;function P(u){switch(u){case y.Error:return C;case y.Warning:return i;case y.Info:return S;default:return D}}y.toString=P}(L||(L={})),e.default=L}),define(pe[13],ve([0,1]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isPromise=e.assertNever=e.NotImplementedProxy=e.withUndefinedAsNull=e.withNullAsUndefined=e.createProxyObject=e.getAllMethodNames=e.getAllPropertyNames=e.validateConstraint=e.validateConstraints=e.areFunctions=e.isFunction=e.isEmptyObject=e.assertAllDefined=e.assertIsDefined=e.assertType=e.isUndefinedOrNull=e.isDefined=e.isUndefined=e.isBoolean=e.isIterable=e.isNumber=e.isObject=e.isStringArray=e.isString=e.isArray=void 0;function m(h){return Array.isArray(h)}e.isArray=m;function L(h){return typeof h=="string"}e.isString=L;function y(h){return Array.isArray(h)&&h.every(l=>L(l))}e.isStringArray=y;function C(h){return typeof h=="object"&&h!==null&&!Array.isArray(h)&&!(h instanceof RegExp)&&!(h instanceof Date)}e.isObject=C;function i(h){return typeof h=="number"&&!isNaN(h)}e.isNumber=i;function k(h){return!!h&&typeof h[Symbol.iterator]=="function"}e.isIterable=k;function S(h){return h===!0||h===!1}e.isBoolean=S;function D(h){return typeof h=="undefined"}e.isUndefined=D;function R(h){return!P(h)}e.isDefined=R;function P(h){return D(h)||h===null}e.isUndefinedOrNull=P;function u(h,l){if(!h)throw new Error(l?`Unexpected type, expected '${l}'`:"Unexpected type")}e.assertType=u;function E(h){if(P(h))throw new Error("Assertion Failed: argument is undefined or null");return h}e.assertIsDefined=E;function f(...h){const l=[];for(let b=0;b<h.length;b++){const T=h[b];if(P(T))throw new Error(`Assertion Failed: argument at index ${b} is undefined or null`);l.push(T)}return l}e.assertAllDefined=f;const v=Object.prototype.hasOwnProperty;function w(h){if(!C(h))return!1;for(let l in h)if(v.call(h,l))return!1;return!0}e.isEmptyObject=w;function I(h){return typeof h=="function"}e.isFunction=I;function p(...h){return h.length>0&&h.every(I)}e.areFunctions=p;function s(h,l){const b=Math.min(h.length,l.length);for(let T=0;T<b;T++)r(h[T],l[T])}e.validateConstraints=s;function r(h,l){if(L(l)){if(typeof h!==l)throw new Error(`argument does not match constraint: typeof ${l}`)}else if(I(l)){try{if(h instanceof l)return}catch{}if(!P(h)&&h.constructor===l||l.length===1&&l.call(void 0,h)===!0)return;throw new Error("argument does not match one of these constraints: arg instanceof constraint, arg.constructor === constraint, nor constraint(arg) === true")}}e.validateConstraint=r;function g(h){let l=[],b=Object.getPrototypeOf(h);for(;Object.prototype!==b;)l=l.concat(Object.getOwnPropertyNames(b)),b=Object.getPrototypeOf(b);return l}e.getAllPropertyNames=g;function a(h){const l=[];for(const b of g(h))typeof h[b]=="function"&&l.push(b);return l}e.getAllMethodNames=a;function _(h,l){const b=A=>function(){const x=Array.prototype.slice.call(arguments,0);return l(A,x)};let T={};for(const A of h)T[A]=b(A);return T}e.createProxyObject=_;function n(h){return h===null?void 0:h}e.withNullAsUndefined=n;function t(h){return typeof h=="undefined"?null:h}e.withUndefinedAsNull=t;function o(h){return class{constructor(){return new Proxy({},{get(l,b){if(l[b])return l[b];throw new Error(`Not Implemented: ${h}->${String(b)}`)}})}}}e.NotImplementedProxy=o;function d(h,l="Unreachable"){throw new Error(l)}e.assertNever=d;function c(h){return!!h&&typeof h.then=="function"&&typeof h.catch=="function"}e.isPromise=c}),define(pe[30],ve([0,1,9,12,8,13]),function(Y,e,m,L,y,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parseLineAndColumnAware=e.indexOfPath=e.getDriveLetter=e.hasDriveLetter=e.isRootOrDriveLetter=e.sanitizeFilePath=e.isWindowsDriveLetter=e.isEqualOrParent=e.isEqual=e.isValidBasename=e.isUNC=e.getRoot=e.toPosixPath=e.toSlashes=e.isPathSeparator=void 0;function i(n){return n===47||n===92}e.isPathSeparator=i;function k(n){return n.replace(/[\\/]/g,m.posix.sep)}e.toSlashes=k;function S(n){return n.indexOf("/")===-1&&(n=k(n)),/^[a-zA-Z]:(\/|$)/.test(n)&&(n="/"+n),n}e.toPosixPath=S;function D(n,t=m.posix.sep){if(!n)return"";const o=n.length,d=n.charCodeAt(0);if(i(d)){if(i(n.charCodeAt(1))&&!i(n.charCodeAt(2))){let h=3;const l=h;for(;h<o&&!i(n.charCodeAt(h));h++);if(l!==h&&!i(n.charCodeAt(h+1))){for(h+=1;h<o;h++)if(i(n.charCodeAt(h)))return n.slice(0,h+1).replace(/[\\/]/g,t)}}return t}else if(I(d)&&n.charCodeAt(1)===58)return i(n.charCodeAt(2))?n.slice(0,2)+t:n.slice(0,2);let c=n.indexOf("://");if(c!==-1){for(c+=3;c<o;c++)if(i(n.charCodeAt(c)))return n.slice(0,c+1)}return""}e.getRoot=D;function R(n){if(!L.isWindows||!n||n.length<5)return!1;let t=n.charCodeAt(0);if(t!==92||(t=n.charCodeAt(1),t!==92))return!1;let o=2;const d=o;for(;o<n.length&&(t=n.charCodeAt(o),t!==92);o++);return!(d===o||(t=n.charCodeAt(o+1),isNaN(t)||t===92))}e.isUNC=R;const P=/[\\/:\*\?"<>\|]/g,u=/[\\/]/g,E=/^(con|prn|aux|clock\$|nul|lpt[0-9]|com[0-9])(\.(.*?))?$/i;function f(n,t=L.isWindows){const o=t?P:u;return!(!n||n.length===0||/^\s+$/.test(n)||(o.lastIndex=0,o.test(n))||t&&E.test(n)||n==="."||n===".."||t&&n[n.length-1]==="."||t&&n.length!==n.trim().length||n.length>255)}e.isValidBasename=f;function v(n,t,o){const d=n===t;return!o||d?d:!n||!t?!1:(0,y.equalsIgnoreCase)(n,t)}e.isEqual=v;function w(n,t,o,d=m.sep){if(n===t)return!0;if(!n||!t||t.length>n.length)return!1;if(o){if(!(0,y.startsWithIgnoreCase)(n,t))return!1;if(t.length===n.length)return!0;let h=t.length;return t.charAt(t.length-1)===d&&h--,n.charAt(h)===d}return t.charAt(t.length-1)!==d&&(t+=d),n.indexOf(t)===0}e.isEqualOrParent=w;function I(n){return n>=65&&n<=90||n>=97&&n<=122}e.isWindowsDriveLetter=I;function p(n,t){return L.isWindows&&n.endsWith(":")&&(n+=m.sep),(0,m.isAbsolute)(n)||(n=(0,m.join)(t,n)),n=(0,m.normalize)(n),L.isWindows?(n=(0,y.rtrim)(n,m.sep),n.endsWith(":")&&(n+=m.sep)):(n=(0,y.rtrim)(n,m.sep),n||(n=m.sep)),n}e.sanitizeFilePath=p;function s(n){const t=(0,m.normalize)(n);return L.isWindows?n.length>3?!1:r(t)&&(n.length===2||t.charCodeAt(2)===92):t===m.posix.sep}e.isRootOrDriveLetter=s;function r(n,t){return(t!==void 0?t:L.isWindows)?I(n.charCodeAt(0))&&n.charCodeAt(1)===58:!1}e.hasDriveLetter=r;function g(n){return r(n)?n[0]:void 0}e.getDriveLetter=g;function a(n,t,o){return t.length>n.length?-1:n===t?0:(o&&(n=n.toLowerCase(),t=t.toLowerCase()),n.indexOf(t))}e.indexOfPath=a;function _(n){const t=n.split(":");let o,d,c;if(t.forEach(h=>{const l=Number(h);(0,C.isNumber)(l)?d===void 0?d=l:c===void 0&&(c=l):o=o?[o,h].join(":"):h}),!o)throw new Error("Format for `--goto` should be: `FILE:LINE(:COLUMN)`");return{path:o,line:d!==void 0?d:void 0,column:c!==void 0?c:d!==void 0?1:void 0}}e.parseLineAndColumnAware=_}),define(pe[25],ve([0,1,13]),function(Y,e,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.filter=e.getCaseInsensitive=e.distinct=e.getOrDefault=e.safeStringify=e.equals=e.mixin=e.cloneAndChange=e.deepFreeze=e.deepClone=void 0;function L(v){if(!v||typeof v!="object"||v instanceof RegExp)return v;const w=Array.isArray(v)?[]:{};return Object.keys(v).forEach(I=>{v[I]&&typeof v[I]=="object"?w[I]=L(v[I]):w[I]=v[I]}),w}e.deepClone=L;function y(v){if(!v||typeof v!="object")return v;const w=[v];for(;w.length>0;){const I=w.shift();Object.freeze(I);for(const p in I)if(C.call(I,p)){const s=I[p];typeof s=="object"&&!Object.isFrozen(s)&&w.push(s)}}return v}e.deepFreeze=y;const C=Object.prototype.hasOwnProperty;function i(v,w){return k(v,w,new Set)}e.cloneAndChange=i;function k(v,w,I){if((0,m.isUndefinedOrNull)(v))return v;const p=w(v);if(typeof p!="undefined")return p;if((0,m.isArray)(v)){const s=[];for(const r of v)s.push(k(r,w,I));return s}if((0,m.isObject)(v)){if(I.has(v))throw new Error("Cannot clone recursive data-structure");I.add(v);const s={};for(let r in v)C.call(v,r)&&(s[r]=k(v[r],w,I));return I.delete(v),s}return v}function S(v,w,I=!0){return(0,m.isObject)(v)?((0,m.isObject)(w)&&Object.keys(w).forEach(p=>{p in v?I&&((0,m.isObject)(v[p])&&(0,m.isObject)(w[p])?S(v[p],w[p],I):v[p]=w[p]):v[p]=w[p]}),v):w}e.mixin=S;function D(v,w){if(v===w)return!0;if(v==null||w===null||w===void 0||typeof v!=typeof w||typeof v!="object"||Array.isArray(v)!==Array.isArray(w))return!1;let I,p;if(Array.isArray(v)){if(v.length!==w.length)return!1;for(I=0;I<v.length;I++)if(!D(v[I],w[I]))return!1}else{const s=[];for(p in v)s.push(p);s.sort();const r=[];for(p in w)r.push(p);if(r.sort(),!D(s,r))return!1;for(I=0;I<s.length;I++)if(!D(v[s[I]],w[s[I]]))return!1}return!0}e.equals=D;function R(v){const w=new Set;return JSON.stringify(v,(I,p)=>{if((0,m.isObject)(p)||Array.isArray(p)){if(w.has(p))return"[Circular]";w.add(p)}return p})}e.safeStringify=R;function P(v,w,I){const p=w(v);return typeof p=="undefined"?I:p}e.getOrDefault=P;function u(v,w){const I=Object.create(null);return!v||!w||Object.keys(w).forEach(s=>{const r=v[s],g=w[s];D(r,g)||(I[s]=g)}),I}e.distinct=u;function E(v,w){const I=w.toLowerCase(),p=Object.keys(v).find(s=>s.toLowerCase()===I);return p?v[p]:v[w]}e.getCaseInsensitive=E;function f(v,w){const I=Object.create(null);for(const[p,s]of Object.entries(v))w(p,s)&&(I[p]=s);return I}e.filter=f}),define(pe[98],ve([0,1]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toUint32=e.toUint8=e.Constants=void 0;var m;(function(C){C[C.MAX_SAFE_SMALL_INTEGER=1073741824]="MAX_SAFE_SMALL_INTEGER",C[C.MIN_SAFE_SMALL_INTEGER=-1073741824]="MIN_SAFE_SMALL_INTEGER",C[C.MAX_UINT_8=255]="MAX_UINT_8",C[C.MAX_UINT_16=65535]="MAX_UINT_16",C[C.MAX_UINT_32=4294967295]="MAX_UINT_32",C[C.UNICODE_SUPPLEMENTARY_PLANE_BEGIN=65536]="UNICODE_SUPPLEMENTARY_PLANE_BEGIN"})(m=e.Constants||(e.Constants={}));function L(C){return C<0?0:C>255?255:C|0}e.toUint8=L;function y(C){return C<0?0:C>4294967295?4294967295:C|0}e.toUint32=y}),define(pe[2],ve([0,1,9,12]),function(Y,e,m,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.uriToFsPath=e.URI=void 0;const y=/^\w[\w\d+.-]*$/,C=/^\//,i=/^\/\//;function k(n,t){if(!n.scheme&&t)throw new Error(`[UriError]: Scheme is missing: {scheme: "", authority: "${n.authority}", path: "${n.path}", query: "${n.query}", fragment: "${n.fragment}"}`);if(n.scheme&&!y.test(n.scheme))throw new Error("[UriError]: Scheme contains illegal characters.");if(n.path){if(n.authority){if(!C.test(n.path))throw new Error('[UriError]: If a URI contains an authority component, then the path component must either be empty or begin with a slash ("/") character')}else if(i.test(n.path))throw new Error('[UriError]: If a URI does not contain an authority component, then the path cannot begin with two slash characters ("//")')}}function S(n,t){return!n&&!t?"file":n}function D(n,t){switch(n){case"https":case"http":case"file":t?t[0]!==P&&(t=P+t):t=P;break}return t}const R="",P="/",u=/^(([^:/?#]+?):)?(\/\/([^/?#]*))?([^?#]*)(\?([^#]*))?(#(.*))?/;class E{constructor(t,o,d,c,h,l=!1){typeof t=="object"?(this.scheme=t.scheme||R,this.authority=t.authority||R,this.path=t.path||R,this.query=t.query||R,this.fragment=t.fragment||R):(this.scheme=S(t,l),this.authority=o||R,this.path=D(this.scheme,d||R),this.query=c||R,this.fragment=h||R,k(this,l))}static isUri(t){return t instanceof E?!0:t?typeof t.authority=="string"&&typeof t.fragment=="string"&&typeof t.path=="string"&&typeof t.query=="string"&&typeof t.scheme=="string"&&typeof t.fsPath=="string"&&typeof t.with=="function"&&typeof t.toString=="function":!1}get fsPath(){return s(this,!1)}with(t){if(!t)return this;let{scheme:o,authority:d,path:c,query:h,fragment:l}=t;return o===void 0?o=this.scheme:o===null&&(o=R),d===void 0?d=this.authority:d===null&&(d=R),c===void 0?c=this.path:c===null&&(c=R),h===void 0?h=this.query:h===null&&(h=R),l===void 0?l=this.fragment:l===null&&(l=R),o===this.scheme&&d===this.authority&&c===this.path&&h===this.query&&l===this.fragment?this:new v(o,d,c,h,l)}static parse(t,o=!1){const d=u.exec(t);return d?new v(d[2]||R,_(d[4]||R),_(d[5]||R),_(d[7]||R),_(d[9]||R),o):new v(R,R,R,R,R)}static file(t){let o=R;if(L.isWindows&&(t=t.replace(/\\/g,P)),t[0]===P&&t[1]===P){const d=t.indexOf(P,2);d===-1?(o=t.substring(2),t=P):(o=t.substring(2,d),t=t.substring(d)||P)}return new v("file",o,t,R,R)}static from(t){const o=new v(t.scheme,t.authority,t.path,t.query,t.fragment);return k(o,!0),o}static joinPath(t,...o){if(!t.path)throw new Error("[UriError]: cannot call joinPath on URI without path");let d;return L.isWindows&&t.scheme==="file"?d=E.file(m.win32.join(s(t,!0),...o)).path:d=m.posix.join(t.path,...o),t.with({path:d})}toString(t=!1){return r(this,t)}toJSON(){return this}static revive(t){if(t){if(t instanceof E)return t;{const o=new v(t);return o._formatted=t.external,o._fsPath=t._sep===f?t.fsPath:null,o}}else return t}}e.URI=E;const f=L.isWindows?1:void 0;class v extends E{constructor(){super(...arguments);this._formatted=null,this._fsPath=null}get fsPath(){return this._fsPath||(this._fsPath=s(this,!1)),this._fsPath}toString(t=!1){return t?r(this,!0):(this._formatted||(this._formatted=r(this,!1)),this._formatted)}toJSON(){const t={$mid:1};return this._fsPath&&(t.fsPath=this._fsPath,t._sep=f),this._formatted&&(t.external=this._formatted),this.path&&(t.path=this.path),this.scheme&&(t.scheme=this.scheme),this.authority&&(t.authority=this.authority),this.query&&(t.query=this.query),this.fragment&&(t.fragment=this.fragment),t}}const w={[58]:"%3A",[47]:"%2F",[63]:"%3F",[35]:"%23",[91]:"%5B",[93]:"%5D",[64]:"%40",[33]:"%21",[36]:"%24",[38]:"%26",[39]:"%27",[40]:"%28",[41]:"%29",[42]:"%2A",[43]:"%2B",[44]:"%2C",[59]:"%3B",[61]:"%3D",[32]:"%20"};function I(n,t){let o,d=-1;for(let c=0;c<n.length;c++){const h=n.charCodeAt(c);if(h>=97&&h<=122||h>=65&&h<=90||h>=48&&h<=57||h===45||h===46||h===95||h===126||t&&h===47)d!==-1&&(o+=encodeURIComponent(n.substring(d,c)),d=-1),o!==void 0&&(o+=n.charAt(c));else{o===void 0&&(o=n.substr(0,c));const l=w[h];l!==void 0?(d!==-1&&(o+=encodeURIComponent(n.substring(d,c)),d=-1),o+=l):d===-1&&(d=c)}}return d!==-1&&(o+=encodeURIComponent(n.substring(d))),o!==void 0?o:n}function p(n){let t;for(let o=0;o<n.length;o++){const d=n.charCodeAt(o);d===35||d===63?(t===void 0&&(t=n.substr(0,o)),t+=w[d]):t!==void 0&&(t+=n[o])}return t!==void 0?t:n}function s(n,t){let o;return n.authority&&n.path.length>1&&n.scheme==="file"?o=`//${n.authority}${n.path}`:n.path.charCodeAt(0)===47&&(n.path.charCodeAt(1)>=65&&n.path.charCodeAt(1)<=90||n.path.charCodeAt(1)>=97&&n.path.charCodeAt(1)<=122)&&n.path.charCodeAt(2)===58?t?o=n.path.substr(1):o=n.path[1].toLowerCase()+n.path.substr(2):o=n.path,L.isWindows&&(o=o.replace(/\//g,"\\")),o}e.uriToFsPath=s;function r(n,t){const o=t?p:I;let d="",{scheme:c,authority:h,path:l,query:b,fragment:T}=n;if(c&&(d+=c,d+=":"),(h||c==="file")&&(d+=P,d+=P),h){let A=h.indexOf("@");if(A!==-1){const x=h.substr(0,A);h=h.substr(A+1),A=x.indexOf(":"),A===-1?d+=o(x,!1):(d+=o(x.substr(0,A),!1),d+=":",d+=o(x.substr(A+1),!1)),d+="@"}h=h.toLowerCase(),A=h.indexOf(":"),A===-1?d+=o(h,!1):(d+=o(h.substr(0,A),!1),d+=h.substr(A))}if(l){if(l.length>=3&&l.charCodeAt(0)===47&&l.charCodeAt(2)===58){const A=l.charCodeAt(1);A>=65&&A<=90&&(l=`/${String.fromCharCode(A+32)}:${l.substr(3)}`)}else if(l.length>=2&&l.charCodeAt(1)===58){const A=l.charCodeAt(0);A>=65&&A<=90&&(l=`${String.fromCharCode(A+32)}:${l.substr(2)}`)}d+=o(l,!0)}return b&&(d+="?",d+=o(b,!1)),T&&(d+="#",d+=t?T:I(T,!1)),d}function g(n){try{return decodeURIComponent(n)}catch{return n.length>3?n.substr(0,3)+g(n.substr(3)):n}}const a=/(%[0-9A-Za-z][0-9A-Za-z])+/g;function _(n){return n.match(a)?n.replace(a,t=>g(t)):n}}),define(pe[59],ve([0,1,22,8,2]),function(Y,e,m,L,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.revive=e.MarshalledId=e.parse=e.stringify=void 0;function C(R){return JSON.stringify(R,S)}e.stringify=C;function i(R){let P=JSON.parse(R);return P=D(P),P}e.parse=i;var k;(function(R){R[R.Uri=1]="Uri",R[R.Regexp=2]="Regexp",R[R.ScmResource=3]="ScmResource",R[R.ScmResourceGroup=4]="ScmResourceGroup",R[R.ScmProvider=5]="ScmProvider",R[R.CommentController=6]="CommentController",R[R.CommentThread=7]="CommentThread",R[R.CommentThreadReply=8]="CommentThreadReply",R[R.CommentNode=9]="CommentNode",R[R.CommentThreadNode=10]="CommentThreadNode",R[R.TimelineActionContext=11]="TimelineActionContext",R[R.NotebookCellActionContext=12]="NotebookCellActionContext",R[R.TestItemContext=13]="TestItemContext"})(k=e.MarshalledId||(e.MarshalledId={}));function S(R,P){return P instanceof RegExp?{$mid:2,source:P.source,flags:(0,L.regExpFlags)(P)}:P}function D(R,P=0){if(!R||P>200)return R;if(typeof R=="object"){switch(R.$mid){case 1:return y.URI.revive(R);case 2:return new RegExp(R.source,R.flags)}if(R instanceof m.VSBuffer||R instanceof Uint8Array)return R;if(Array.isArray(R))for(let u=0;u<R.length;++u)R[u]=D(R[u],P+1);else for(const u in R)Object.hasOwnProperty.call(R,u)&&(R[u]=D(R[u],P+1))}return R}e.revive=D}),define(pe[10],ve([0,1,12,2]),function(Y,e,m,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileAccess=e.RemoteAuthorities=e.Schemas=void 0;var y;(function(k){k.inMemory="inmemory",k.vscode="vscode",k.internal="private",k.walkThrough="walkThrough",k.walkThroughSnippet="walkThroughSnippet",k.http="http",k.https="https",k.file="file",k.mailto="mailto",k.untitled="untitled",k.data="data",k.command="command",k.vscodeRemote="vscode-remote",k.vscodeRemoteResource="vscode-remote-resource",k.userData="vscode-userdata",k.vscodeCustomEditor="vscode-custom-editor",k.vscodeNotebook="vscode-notebook",k.vscodeNotebookCell="vscode-notebook-cell",k.vscodeNotebookCellMetadata="vscode-notebook-cell-metadata",k.vscodeNotebookCellOutput="vscode-notebook-cell-output",k.vscodeInteractive="vscode-interactive",k.vscodeInteractiveInput="vscode-interactive-input",k.vscodeSettings="vscode-settings",k.vscodeWorkspaceTrust="vscode-workspace-trust",k.vscodeTerminal="vscode-terminal",k.webviewPanel="webview-panel",k.vscodeWebview="vscode-webview",k.extension="extension",k.vscodeFileResource="vscode-file",k.tmp="tmp",k.vsls="vsls"})(y=e.Schemas||(e.Schemas={}));class C{constructor(){this._hosts=Object.create(null),this._ports=Object.create(null),this._connectionTokens=Object.create(null),this._preferredWebSchema="http",this._delegate=null}setPreferredWebSchema(S){this._preferredWebSchema=S}setDelegate(S){this._delegate=S}set(S,D,R){this._hosts[S]=D,this._ports[S]=R}setConnectionToken(S,D){this._connectionTokens[S]=D}rewrite(S){if(this._delegate)return this._delegate(S);const D=S.authority;let R=this._hosts[D];R&&R.indexOf(":")!==-1&&(R=`[${R}]`);const P=this._ports[D],u=this._connectionTokens[D];let E=`path=${encodeURIComponent(S.path)}`;return typeof u=="string"&&(E+=`&tkn=${encodeURIComponent(u)}`),L.URI.from({scheme:m.isWeb?this._preferredWebSchema:y.vscodeRemoteResource,authority:`${R}:${P}`,path:"/vscode-remote-resource",query:E})}}e.RemoteAuthorities=new C;class i{asBrowserUri(S,D){const R=this.toUri(S,D);return R.scheme===y.vscodeRemote?e.RemoteAuthorities.rewrite(R):R.scheme===y.file&&(m.isNative||typeof m.globals.importScripts=="function"&&m.globals.origin===`${y.vscodeFileResource}://${i.FALLBACK_AUTHORITY}`)?R.with({scheme:y.vscodeFileResource,authority:R.authority||i.FALLBACK_AUTHORITY,query:null,fragment:null}):R}asFileUri(S,D){const R=this.toUri(S,D);return R.scheme===y.vscodeFileResource?R.with({scheme:y.file,authority:R.authority!==i.FALLBACK_AUTHORITY?R.authority:null,query:null,fragment:null}):R}toUri(S,D){return L.URI.isUri(S)?S:L.URI.parse(D.toUrl(S))}}i.FALLBACK_AUTHORITY="vscode-app",e.FileAccess=new i}),define(pe[23],ve([0,1,30,10,9,12,8,2]),function(Y,e,m,L,y,C,i,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toLocalResource=e.DataUri=e.distinctParents=e.addTrailingPathSeparator=e.removeTrailingPathSeparator=e.hasTrailingPathSeparator=e.isEqualAuthority=e.isAbsolutePath=e.resolvePath=e.relativePath=e.normalizePath=e.joinPath=e.dirname=e.extname=e.basename=e.basenameOrAuthority=e.getComparisonKey=e.isEqualOrParent=e.isEqual=e.extUriIgnorePathCase=e.extUriBiasedIgnorePathCase=e.extUri=e.ExtUri=e.originalFSPath=void 0;function S(E){return(0,k.uriToFsPath)(E,!0)}e.originalFSPath=S;class D{constructor(f){this._ignorePathCasing=f}compare(f,v,w=!1){return f===v?0:(0,i.compare)(this.getComparisonKey(f,w),this.getComparisonKey(v,w))}isEqual(f,v,w=!1){return f===v?!0:!f||!v?!1:this.getComparisonKey(f,w)===this.getComparisonKey(v,w)}getComparisonKey(f,v=!1){return f.with({path:this._ignorePathCasing(f)?f.path.toLowerCase():void 0,fragment:v?null:void 0}).toString()}ignorePathCasing(f){return this._ignorePathCasing(f)}isEqualOrParent(f,v,w=!1){if(f.scheme===v.scheme){if(f.scheme===L.Schemas.file)return m.isEqualOrParent(S(f),S(v),this._ignorePathCasing(f))&&f.query===v.query&&(w||f.fragment===v.fragment);if((0,e.isEqualAuthority)(f.authority,v.authority))return m.isEqualOrParent(f.path,v.path,this._ignorePathCasing(f),"/")&&f.query===v.query&&(w||f.fragment===v.fragment)}return!1}joinPath(f,...v){return k.URI.joinPath(f,...v)}basenameOrAuthority(f){return(0,e.basename)(f)||f.authority}basename(f){return y.posix.basename(f.path)}extname(f){return y.posix.extname(f.path)}dirname(f){if(f.path.length===0)return f;let v;return f.scheme===L.Schemas.file?v=k.URI.file(y.dirname(S(f))).path:(v=y.posix.dirname(f.path),f.authority&&v.length&&v.charCodeAt(0)!==47&&(console.error(`dirname("${f.toString})) resulted in a relative path`),v="/")),f.with({path:v})}normalizePath(f){if(!f.path.length)return f;let v;return f.scheme===L.Schemas.file?v=k.URI.file(y.normalize(S(f))).path:v=y.posix.normalize(f.path),f.with({path:v})}relativePath(f,v){if(f.scheme!==v.scheme||!(0,e.isEqualAuthority)(f.authority,v.authority))return;if(f.scheme===L.Schemas.file){const p=y.relative(S(f),S(v));return C.isWindows?m.toSlashes(p):p}let w=f.path||"/",I=v.path||"/";if(this._ignorePathCasing(f)){let p=0;for(const s=Math.min(w.length,I.length);p<s&&!(w.charCodeAt(p)!==I.charCodeAt(p)&&w.charAt(p).toLowerCase()!==I.charAt(p).toLowerCase());p++);w=I.substr(0,p)+w.substr(p)}return y.posix.relative(w,I)}resolvePath(f,v){if(f.scheme===L.Schemas.file){const w=k.URI.file(y.resolve(S(f),v));return f.with({authority:w.authority,path:w.path})}return v=m.toPosixPath(v),f.with({path:y.posix.resolve(f.path,v)})}isAbsolutePath(f){return!!f.path&&f.path[0]==="/"}isEqualAuthority(f,v){return f===v||f!==void 0&&v!==void 0&&(0,i.equalsIgnoreCase)(f,v)}hasTrailingPathSeparator(f,v=y.sep){if(f.scheme===L.Schemas.file){const w=S(f);return w.length>m.getRoot(w).length&&w[w.length-1]===v}else{const w=f.path;return w.length>1&&w.charCodeAt(w.length-1)===47&&!/^[a-zA-Z]:(\/$|\\$)/.test(f.fsPath)}}removeTrailingPathSeparator(f,v=y.sep){return(0,e.hasTrailingPathSeparator)(f,v)?f.with({path:f.path.substr(0,f.path.length-1)}):f}addTrailingPathSeparator(f,v=y.sep){let w=!1;if(f.scheme===L.Schemas.file){const I=S(f);w=I!==void 0&&I.length===m.getRoot(I).length&&I[I.length-1]===v}else{v="/";const I=f.path;w=I.length===1&&I.charCodeAt(I.length-1)===47}return!w&&!(0,e.hasTrailingPathSeparator)(f,v)?f.with({path:f.path+"/"}):f}}e.ExtUri=D,e.extUri=new D(()=>!1),e.extUriBiasedIgnorePathCase=new D(E=>E.scheme===L.Schemas.file?!C.isLinux:!0),e.extUriIgnorePathCase=new D(E=>!0),e.isEqual=e.extUri.isEqual.bind(e.extUri),e.isEqualOrParent=e.extUri.isEqualOrParent.bind(e.extUri),e.getComparisonKey=e.extUri.getComparisonKey.bind(e.extUri),e.basenameOrAuthority=e.extUri.basenameOrAuthority.bind(e.extUri),e.basename=e.extUri.basename.bind(e.extUri),e.extname=e.extUri.extname.bind(e.extUri),e.dirname=e.extUri.dirname.bind(e.extUri),e.joinPath=e.extUri.joinPath.bind(e.extUri),e.normalizePath=e.extUri.normalizePath.bind(e.extUri),e.relativePath=e.extUri.relativePath.bind(e.extUri),e.resolvePath=e.extUri.resolvePath.bind(e.extUri),e.isAbsolutePath=e.extUri.isAbsolutePath.bind(e.extUri),e.isEqualAuthority=e.extUri.isEqualAuthority.bind(e.extUri),e.hasTrailingPathSeparator=e.extUri.hasTrailingPathSeparator.bind(e.extUri),e.removeTrailingPathSeparator=e.extUri.removeTrailingPathSeparator.bind(e.extUri),e.addTrailingPathSeparator=e.extUri.addTrailingPathSeparator.bind(e.extUri);function R(E,f){const v=[];for(let w=0;w<E.length;w++){const I=f(E[w]);E.some((p,s)=>s===w?!1:(0,e.isEqualOrParent)(I,f(p)))||v.push(E[w])}return v}e.distinctParents=R;var P;(function(E){E.META_DATA_LABEL="label",E.META_DATA_DESCRIPTION="description",E.META_DATA_SIZE="size",E.META_DATA_MIME="mime";function f(v){const w=new Map;v.path.substring(v.path.indexOf(";")+1,v.path.lastIndexOf(";")).split(";").forEach(s=>{const[r,g]=s.split(":");r&&g&&w.set(r,g)});const p=v.path.substring(0,v.path.indexOf(";"));return p&&w.set(E.META_DATA_MIME,p),w}E.parseMetaData=f})(P=e.DataUri||(e.DataUri={}));function u(E,f,v){if(f){let w=E.path;return w&&w[0]!==y.posix.sep&&(w=y.posix.sep+w),E.with({scheme:v,authority:f,path:w})}return E.with({scheme:v})}e.toLocalResource=u}),define(pe[18],ve([0,1,21,15,3,6,23,12]),function(Y,e,m,L,y,C,i,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createCancelableAsyncIterable=e.CancelableAsyncIterableObject=e.AsyncIterableObject=e.Promises=e.DeferredPromise=e.IntervalCounter=e.TaskSequentializer=e.retry=e.IdleValue=e.runWhenIdle=e.ThrottledWorker=e.RunOnceWorker=e.ProcessTimeRunOnceScheduler=e.RunOnceScheduler=e.IntervalTimer=e.TimeoutTimer=e.ResourceQueue=e.Queue=e.Limiter=e.firstParallel=e.first=e.sequence=e.disposableTimeout=e.timeout=e.AutoOpenBarrier=e.Barrier=e.ThrottledDelayer=e.Delayer=e.SequencerByKey=e.Sequencer=e.Throttler=e.asPromise=e.raceTimeout=e.raceCancellablePromises=e.raceCancellation=e.createCancelablePromise=e.isThenable=void 0;function S(H){return!!H&&typeof H.then=="function"}e.isThenable=S;function D(H){const V=new m.CancellationTokenSource,q=H(V.token),ne=new Promise((fe,ye)=>{const ke=V.token.onCancellationRequested(()=>{ke.dispose(),V.dispose(),ye((0,L.canceled)())});Promise.resolve(q).then(Be=>{ke.dispose(),V.dispose(),fe(Be)},Be=>{ke.dispose(),V.dispose(),ye(Be)})});return new class{cancel(){V.cancel()}then(fe,ye){return ne.then(fe,ye)}catch(fe){return this.then(void 0,fe)}finally(fe){return ne.finally(fe)}}}e.createCancelablePromise=D;function R(H,V,q){return Promise.race([H,new Promise(ne=>V.onCancellationRequested(()=>ne(q)))])}e.raceCancellation=R;async function P(H){let V=-1;const q=H.map((fe,ye)=>fe.then(ke=>(V=ye,ke))),ne=await Promise.race(q);return H.forEach((fe,ye)=>{ye!==V&&fe.cancel()}),ne}e.raceCancellablePromises=P;function u(H,V,q){let ne;const fe=setTimeout(()=>{ne?.(void 0),q?.()},V);return Promise.race([H.finally(()=>clearTimeout(fe)),new Promise(ye=>ne=ye)])}e.raceTimeout=u;function E(H){return new Promise((V,q)=>{const ne=H();S(ne)?ne.then(V,q):V(ne)})}e.asPromise=E;class f{constructor(){this.activePromise=null,this.queuedPromise=null,this.queuedPromiseFactory=null}queue(V){if(this.activePromise){if(this.queuedPromiseFactory=V,!this.queuedPromise){const q=()=>{this.queuedPromise=null;const ne=this.queue(this.queuedPromiseFactory);return this.queuedPromiseFactory=null,ne};this.queuedPromise=new Promise(ne=>{this.activePromise.then(q,q).then(ne)})}return new Promise((q,ne)=>{this.queuedPromise.then(q,ne)})}return this.activePromise=V(),new Promise((q,ne)=>{this.activePromise.then(fe=>{this.activePromise=null,q(fe)},fe=>{this.activePromise=null,ne(fe)})})}}e.Throttler=f;class v{constructor(){this.current=Promise.resolve(null)}queue(V){return this.current=this.current.then(()=>V(),()=>V())}}e.Sequencer=v;class w{constructor(){this.promiseMap=new Map}queue(V,q){const fe=(this.promiseMap.get(V)??Promise.resolve()).catch(()=>{}).then(q).finally(()=>{this.promiseMap.get(V)===fe&&this.promiseMap.delete(V)});return this.promiseMap.set(V,fe),fe}}e.SequencerByKey=w;class I{constructor(V){this.defaultDelay=V,this.timeout=null,this.completionPromise=null,this.doResolve=null,this.doReject=null,this.task=null}trigger(V,q=this.defaultDelay){return this.task=V,this.cancelTimeout(),this.completionPromise||(this.completionPromise=new Promise((ne,fe)=>{this.doResolve=ne,this.doReject=fe}).then(()=>{if(this.completionPromise=null,this.doResolve=null,this.task){const ne=this.task;return this.task=null,ne()}})),this.timeout=setTimeout(()=>{this.timeout=null,this.doResolve&&this.doResolve(null)},q),this.completionPromise}isTriggered(){return this.timeout!==null}cancel(){this.cancelTimeout(),this.completionPromise&&(this.doReject&&this.doReject((0,L.canceled)()),this.completionPromise=null)}cancelTimeout(){this.timeout!==null&&(clearTimeout(this.timeout),this.timeout=null)}dispose(){this.cancel()}}e.Delayer=I;class p{constructor(V){this.delayer=new I(V),this.throttler=new f}trigger(V,q){return this.delayer.trigger(()=>this.throttler.queue(V),q)}isTriggered(){return this.delayer.isTriggered()}cancel(){this.delayer.cancel()}dispose(){this.delayer.dispose()}}e.ThrottledDelayer=p;class s{constructor(){this._isOpen=!1,this._promise=new Promise((V,q)=>{this._completePromise=V})}isOpen(){return this._isOpen}open(){this._isOpen=!0,this._completePromise(!0)}wait(){return this._promise}}e.Barrier=s;class r extends s{constructor(V){super();this._timeout=setTimeout(()=>this.open(),V)}open(){clearTimeout(this._timeout),super.open()}}e.AutoOpenBarrier=r;function g(H,V){return V?new Promise((q,ne)=>{const fe=setTimeout(()=>{ye.dispose(),q()},H),ye=V.onCancellationRequested(()=>{clearTimeout(fe),ye.dispose(),ne((0,L.canceled)())})}):D(q=>g(H,q))}e.timeout=g;function a(H,V=0){const q=setTimeout(H,V);return(0,C.toDisposable)(()=>clearTimeout(q))}e.disposableTimeout=a;function _(H){const V=[];let q=0;const ne=H.length;function fe(){return q<ne?H[q++]():null}function ye(ke){ke!=null&&V.push(ke);const Be=fe();return Be?Be.then(ye):Promise.resolve(V)}return Promise.resolve(null).then(ye)}e.sequence=_;function n(H,V=ne=>!!ne,q=null){let ne=0;const fe=H.length,ye=()=>{if(ne>=fe)return Promise.resolve(q);const ke=H[ne++];return Promise.resolve(ke()).then(We=>V(We)?Promise.resolve(We):ye())};return ye()}e.first=n;function t(H,V=ne=>!!ne,q=null){if(H.length===0)return Promise.resolve(q);let ne=H.length;const fe=()=>{ne=-1;for(const ye of H)ye.cancel?.()};return new Promise((ye,ke)=>{for(const Be of H)Be.then(We=>{--ne>=0&&V(We)?(fe(),ye(We)):ne===0&&ye(q)}).catch(We=>{--ne>=0&&(fe(),ke(We))})})}e.firstParallel=t;class o{constructor(V){this._size=0,this.maxDegreeOfParalellism=V,this.outstandingPromises=[],this.runningPromises=0,this._onFinished=new y.Emitter}get onFinished(){return this._onFinished.event}get size(){return this._size}queue(V){return this._size++,new Promise((q,ne)=>{this.outstandingPromises.push({factory:V,c:q,e:ne}),this.consume()})}consume(){for(;this.outstandingPromises.length&&this.runningPromises<this.maxDegreeOfParalellism;){const V=this.outstandingPromises.shift();this.runningPromises++;const q=V.factory();q.then(V.c,V.e),q.then(()=>this.consumed(),()=>this.consumed())}}consumed(){this._size--,this.runningPromises--,this.outstandingPromises.length>0?this.consume():this._onFinished.fire()}dispose(){this._onFinished.dispose()}}e.Limiter=o;class d extends o{constructor(){super(1)}}e.Queue=d;class c{constructor(){this.queues=new Map}queueFor(V,q=i.extUri){const ne=q.getComparisonKey(V);let fe=this.queues.get(ne);return fe||(fe=new d,y.Event.once(fe.onFinished)(()=>{fe?.dispose(),this.queues.delete(ne)}),this.queues.set(ne,fe)),fe}dispose(){this.queues.forEach(V=>V.dispose()),this.queues.clear()}}e.ResourceQueue=c;class h{constructor(V,q){this._token=-1,typeof V=="function"&&typeof q=="number"&&this.setIfNotSet(V,q)}dispose(){this.cancel()}cancel(){this._token!==-1&&(clearTimeout(this._token),this._token=-1)}cancelAndSet(V,q){this.cancel(),this._token=setTimeout(()=>{this._token=-1,V()},q)}setIfNotSet(V,q){this._token===-1&&(this._token=setTimeout(()=>{this._token=-1,V()},q))}}e.TimeoutTimer=h;class l{constructor(){this._token=-1}dispose(){this.cancel()}cancel(){this._token!==-1&&(clearInterval(this._token),this._token=-1)}cancelAndSet(V,q){this.cancel(),this._token=setInterval(()=>{V()},q)}}e.IntervalTimer=l;class b{constructor(V,q){this.timeoutToken=-1,this.runner=V,this.timeout=q,this.timeoutHandler=this.onTimeout.bind(this)}dispose(){this.cancel(),this.runner=null}cancel(){this.isScheduled()&&(clearTimeout(this.timeoutToken),this.timeoutToken=-1)}schedule(V=this.timeout){this.cancel(),this.timeoutToken=setTimeout(this.timeoutHandler,V)}get delay(){return this.timeout}set delay(V){this.timeout=V}isScheduled(){return this.timeoutToken!==-1}onTimeout(){this.timeoutToken=-1,this.runner&&this.doRun()}doRun(){this.runner&&this.runner()}}e.RunOnceScheduler=b;class T{constructor(V,q){q%1e3!=0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${q}ms is not a multiple of 1000ms.`),this.runner=V,this.timeout=q,this.counter=0,this.intervalToken=-1,this.intervalHandler=this.onInterval.bind(this)}dispose(){this.cancel(),this.runner=null}cancel(){this.isScheduled()&&(clearInterval(this.intervalToken),this.intervalToken=-1)}schedule(V=this.timeout){V%1e3!=0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${V}ms is not a multiple of 1000ms.`),this.cancel(),this.counter=Math.ceil(V/1e3),this.intervalToken=setInterval(this.intervalHandler,1e3)}isScheduled(){return this.intervalToken!==-1}onInterval(){this.counter--,!(this.counter>0)&&(clearInterval(this.intervalToken),this.intervalToken=-1,this.runner&&this.runner())}}e.ProcessTimeRunOnceScheduler=T;class A extends b{constructor(V,q){super(V,q);this.units=[]}work(V){this.units.push(V),this.isScheduled()||this.schedule()}doRun(){const V=this.units;this.units=[],this.runner&&this.runner(V)}dispose(){this.units=[],super.dispose()}}e.RunOnceWorker=A;class x extends C.Disposable{constructor(V,q,ne,fe){super();this.maxWorkChunkSize=V,this.maxPendingWork=q,this.throttleDelay=ne,this.handler=fe,this.pendingWork=[],this.throttler=this._register(new C.MutableDisposable),this.disposed=!1}get pending(){return this.pendingWork.length}work(V){if(this.disposed)return!1;if(typeof this.maxPendingWork=="number"){if(this.throttler.value){if(this.pending+V.length>this.maxPendingWork)return!1}else if(this.pending+V.length-this.maxWorkChunkSize>this.maxPendingWork)return!1}return this.pendingWork.push(...V),this.throttler.value||this.doWork(),!0}doWork(){this.handler(this.pendingWork.splice(0,this.maxWorkChunkSize)),this.pendingWork.length>0&&(this.throttler.value=new b(()=>{this.throttler.clear(),this.doWork()},this.throttleDelay),this.throttler.value.schedule())}dispose(){super.dispose(),this.disposed=!0}}e.ThrottledWorker=x,function(){typeof requestIdleCallback!="function"||typeof cancelIdleCallback!="function"?e.runWhenIdle=H=>{(0,k.setTimeout0)(()=>{if(V)return;const q=Date.now()+3;H(Object.freeze({didTimeout:!0,timeRemaining(){return Math.max(0,q-Date.now())}}))});let V=!1;return{dispose(){V||(V=!0)}}}:e.runWhenIdle=(H,V)=>{const q=requestIdleCallback(H,typeof V=="number"?{timeout:V}:void 0);let ne=!1;return{dispose(){ne||(ne=!0,cancelIdleCallback(q))}}}}();class O{constructor(V){this._didRun=!1,this._executor=()=>{try{this._value=V()}catch(q){this._error=q}finally{this._didRun=!0}},this._handle=(0,e.runWhenIdle)(()=>this._executor())}dispose(){this._handle.dispose()}get value(){if(this._didRun||(this._handle.dispose(),this._executor()),this._error)throw this._error;return this._value}get isInitialized(){return this._didRun}}e.IdleValue=O;async function F(H,V,q){let ne;for(let fe=0;fe<q;fe++)try{return await H()}catch(ye){ne=ye,await g(V)}throw ne}e.retry=F;class W{hasPending(V){return this._pending?typeof V=="number"?this._pending.taskId===V:!!this._pending:!1}get pending(){return this._pending?this._pending.promise:void 0}cancelPending(){this._pending?.cancel()}setPending(V,q,ne){return this._pending={taskId:V,cancel:()=>ne?.(),promise:q},q.then(()=>this.donePending(V),()=>this.donePending(V)),q}donePending(V){this._pending&&V===this._pending.taskId&&(this._pending=void 0,this.triggerNext())}triggerNext(){if(this._next){const V=this._next;this._next=void 0,V.run().then(V.promiseResolve,V.promiseReject)}}setNext(V){if(this._next)this._next.run=V;else{let q,ne;const fe=new Promise((ye,ke)=>{q=ye,ne=ke});this._next={run:V,promise:fe,promiseResolve:q,promiseReject:ne}}return this._next.promise}}e.TaskSequentializer=W;class M{constructor(V,q=()=>Date.now()){this.interval=V,this.nowFn=q,this.lastIncrementTime=0,this.value=0}increment(){const V=this.nowFn();return V-this.lastIncrementTime>this.interval&&(this.lastIncrementTime=V,this.value=0),this.value++,this.value}}e.IntervalCounter=M;class B{constructor(){this.rejected=!1,this.resolved=!1,this.p=new Promise((V,q)=>{this.completeCallback=V,this.errorCallback=q})}get isRejected(){return this.rejected}get isResolved(){return this.resolved}get isSettled(){return this.rejected||this.resolved}complete(V){return new Promise(q=>{this.completeCallback(V),this.resolved=!0,q()})}error(V){return new Promise(q=>{this.errorCallback(V),this.rejected=!0,q()})}cancel(){new Promise(V=>{this.errorCallback((0,L.canceled)()),this.rejected=!0,V()})}}e.DeferredPromise=B;var U;(function(H){async function V(ne){let fe;const ye=await Promise.all(ne.map(ke=>ke.then(Be=>Be,Be=>{fe||(fe=Be)})));if(typeof fe!="undefined")throw fe;return ye}H.settled=V;function q(ne){return new Promise(async(fe,ye)=>{try{await ne(fe,ye)}catch(ke){ye(ke)}})}H.withAsyncBody=q})(U=e.Promises||(e.Promises={}));var z;(function(H){H[H.Initial=0]="Initial",H[H.DoneOK=1]="DoneOK",H[H.DoneError=2]="DoneError"})(z||(z={}));class K{constructor(V){this._state=0,this._results=[],this._error=null,this._onStateChanged=new y.Emitter,queueMicrotask(async()=>{const q={emitOne:ne=>this.emitOne(ne),emitMany:ne=>this.emitMany(ne),reject:ne=>this.reject(ne)};try{await Promise.resolve(V(q)),this.resolve()}catch(ne){this.reject(ne)}finally{q.emitOne=void 0,q.emitMany=void 0,q.reject=void 0}})}static fromArray(V){return new K(q=>{q.emitMany(V)})}static fromPromise(V){return new K(async q=>{q.emitMany(await V)})}static fromPromises(V){return new K(async q=>{await Promise.all(V.map(async ne=>q.emitOne(await ne)))})}static merge(V){return new K(async q=>{await Promise.all(V.map(async ne=>{for await(const fe of ne)q.emitOne(fe)}))})}[Symbol.asyncIterator](){let V=0;return{next:async()=>{do{if(this._state===2)throw this._error;if(V<this._results.length)return{done:!1,value:this._results[V++]};if(this._state===1)return{done:!0,value:void 0};await y.Event.toPromise(this._onStateChanged.event)}while(!0)}}}static map(V,q){return new K(async ne=>{for await(const fe of V)ne.emitOne(q(fe))})}map(V){return K.map(this,V)}static filter(V,q){return new K(async ne=>{for await(const fe of V)q(fe)&&ne.emitOne(fe)})}filter(V){return K.filter(this,V)}static coalesce(V){return K.filter(V,q=>!!q)}coalesce(){return K.coalesce(this)}static async toPromise(V){const q=[];for await(const ne of V)q.push(ne);return q}toPromise(){return K.toPromise(this)}emitOne(V){this._state===0&&(this._results.push(V),this._onStateChanged.fire())}emitMany(V){this._state===0&&(this._results=this._results.concat(V),this._onStateChanged.fire())}resolve(){this._state===0&&(this._state=1,this._onStateChanged.fire())}reject(V){this._state===0&&(this._state=2,this._error=V,this._onStateChanged.fire())}}e.AsyncIterableObject=K,K.EMPTY=K.fromArray([]);class N extends K{constructor(V,q){super(q);this._source=V}cancel(){this._source.cancel()}}e.CancelableAsyncIterableObject=N;function j(H){const V=new m.CancellationTokenSource,q=H(V.token);return new N(V,async ne=>{const fe=V.token.onCancellationRequested(()=>{fe.dispose(),V.dispose(),ne.reject((0,L.canceled)())});try{for await(const ye of q){if(V.token.isCancellationRequested)return;ne.emitOne(ye)}fe.dispose(),V.dispose()}catch(ye){fe.dispose(),V.dispose(),ne.reject(ye)}})}e.createCancelableAsyncIterable=j}),define(pe[99],ve([0,1,18,9]),function(Y,e,m,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.compareByPrefix=e.compareAnything=e.comparePaths=e.compareFileExtensionsUnicode=e.compareFileExtensionsLower=e.compareFileExtensionsUpper=e.compareFileExtensionsDefault=e.compareFileExtensions=e.noIntlCompareFileNames=e.compareFileNamesUnicode=e.compareFileNamesLower=e.compareFileNamesUpper=e.compareFileNamesDefault=e.compareFileNames=void 0;const y=new m.IdleValue(()=>{const l=new Intl.Collator(void 0,{numeric:!0,sensitivity:"base"});return{collator:l,collatorIsNumeric:l.resolvedOptions().numeric}}),C=new m.IdleValue(()=>({collator:new Intl.Collator(void 0,{numeric:!0})})),i=new m.IdleValue(()=>({collator:new Intl.Collator(void 0,{numeric:!0,sensitivity:"accent"})}));function k(l,b,T=!1){const A=l||"",x=b||"",O=y.value.collator.compare(A,x);return y.value.collatorIsNumeric&&O===0&&A!==x?A<x?-1:1:O}e.compareFileNames=k;function S(l,b){const T=C.value.collator;return l=l||"",b=b||"",g(T,l,b)}e.compareFileNamesDefault=S;function D(l,b){const T=C.value.collator;return l=l||"",b=b||"",t(l,b)||g(T,l,b)}e.compareFileNamesUpper=D;function R(l,b){const T=C.value.collator;return l=l||"",b=b||"",n(l,b)||g(T,l,b)}e.compareFileNamesLower=R;function P(l,b){return l=l||"",b=b||"",l===b?0:l<b?-1:1}e.compareFileNamesUnicode=P;function u(l,b,T=!1){T||(l=l&&l.toLowerCase(),b=b&&b.toLowerCase());const[A,x]=s(l),[O,F]=s(b);return A!==O?A<O?-1:1:x===F?0:x<F?-1:1}e.noIntlCompareFileNames=u;function E(l,b){const[T,A]=s(l),[x,O]=s(b);let F=y.value.collator.compare(A,O);if(F===0){if(y.value.collatorIsNumeric&&A!==O)return A<O?-1:1;if(F=y.value.collator.compare(T,x),y.value.collatorIsNumeric&&F===0&&T!==x)return T<x?-1:1}return F}e.compareFileExtensions=E;function f(l,b){l=l||"",b=b||"";const T=r(l),A=r(b),x=C.value.collator,O=i.value.collator;return g(O,T,A)||g(x,l,b)}e.compareFileExtensionsDefault=f;function v(l,b){l=l||"",b=b||"";const T=r(l),A=r(b),x=C.value.collator,O=i.value.collator;return g(O,T,A)||t(l,b)||g(x,l,b)}e.compareFileExtensionsUpper=v;function w(l,b){l=l||"",b=b||"";const T=r(l),A=r(b),x=C.value.collator,O=i.value.collator;return g(O,T,A)||n(l,b)||g(x,l,b)}e.compareFileExtensionsLower=w;function I(l,b){l=l||"",b=b||"";const T=r(l).toLowerCase(),A=r(b).toLowerCase();return T!==A?T<A?-1:1:l!==b?l<b?-1:1:0}e.compareFileExtensionsUnicode=I;const p=/^(.*?)(\.([^.]*))?$/;function s(l,b=!1){const T=l?p.exec(l):[];let A=[T&&T[1]||"",T&&T[3]||""];return b&&(!A[0]&&A[1]||A[0]&&A[0].charAt(0)===".")&&(A=[A[0]+"."+A[1],""]),A}function r(l){const b=l?p.exec(l):[];return b&&b[1]&&b[1].charAt(0)!=="."&&b[3]||""}function g(l,b,T){let A=l.compare(b,T);return A!==0?A:b.length!==T.length?b.length<T.length?-1:1:0}function a(l){const b=l.charAt(0);return b.toLocaleUpperCase()!==b}function _(l){const b=l.charAt(0);return b.toLocaleLowerCase()!==b}function n(l,b){return a(l)&&_(b)?-1:_(l)&&a(b)?1:0}function t(l,b){return _(l)&&a(b)?-1:a(l)&&_(b)?1:0}function o(l,b,T=!1){return T||(l=l&&l.toLowerCase(),b=b&&b.toLowerCase()),l===b?0:l<b?-1:1}function d(l,b,T=!1){const A=l.split(L.sep),x=b.split(L.sep),O=A.length-1,F=x.length-1;let W,M;for(let B=0;;B++){if(W=O===B,M=F===B,W&&M)return k(A[B],x[B],T);if(W)return-1;if(M)return 1;const U=o(A[B],x[B],T);if(U!==0)return U}}e.comparePaths=d;function c(l,b,T){const A=l.toLowerCase(),x=b.toLowerCase(),O=h(l,b,T);if(O)return O;const F=A.endsWith(T),W=x.endsWith(T);if(F!==W)return F?-1:1;const M=k(A,x);return M!==0?M:A.localeCompare(x)}e.compareAnything=c;function h(l,b,T){const A=l.toLowerCase(),x=b.toLowerCase(),O=A.startsWith(T),F=x.startsWith(T);if(O!==F)return O?-1:1;if(O&&F){if(A.length<x.length)return-1;if(A.length>x.length)return 1}return 0}e.compareByPrefix=h}),define(pe[100],ve([0,1,99,96,47,9,12,8]),function(Y,e,m,L,y,C,i,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.pieceToQuery=e.prepareQuery=e.compareItemsByFuzzyScore=e.scoreItemFuzzy=e.scoreFuzzy2=e.scoreFuzzy=void 0;const S=0,D=[S,[]];function R(U,z,K,N){if(!U||!z)return D;const j=U.length,H=z.length;if(j<H)return D;const V=U.toLowerCase();return P(z,K,H,U,V,j,N)}e.scoreFuzzy=R;function P(U,z,K,N,j,H,V){const q=[],ne=[];for(let Be=0;Be<K;Be++){const We=Be*H,ze=We-H,Q=Be>0,ee=U[Be],re=z[Be];for(let he=0;he<H;he++){const Z=he>0,oe=We+he,be=oe-1,Me=ze+he-1,Ve=Z?q[be]:0,Ge=Q&&Z?q[Me]:0,Je=Q&&Z?ne[Me]:0;let tt;!Ge&&Q?tt=0:tt=u(ee,re,N,j,he,Je),tt&&Ge+tt>=Ve&&(V||Q||j.startsWith(z,he))?(ne[oe]=Je+1,q[oe]=Ge+tt):(ne[oe]=S,q[oe]=Ve)}}const fe=[];let ye=K-1,ke=H-1;for(;ye>=0&&ke>=0;){const Be=ye*H+ke;ne[Be]===S||(fe.push(ke),ye--),ke--}return[q[K*H-1],fe.reverse()]}function u(U,z,K,N,j,H){let V=0;if(!E(z,N[j]))return V;if(V+=1,H>0&&(V+=H*5),U===K[j]&&(V+=1),j===0)V+=8;else{const q=f(K.charCodeAt(j-1));q?V+=q:(0,L.isUpper)(K.charCodeAt(j))&&H===0&&(V+=2)}return V}function E(U,z){return U===z?!0:U==="/"||U==="\\"?z==="/"||z==="\\":!1}function f(U){switch(U){case 47:case 92:return 5;case 95:case 45:case 46:case 32:case 39:case 34:case 58:return 4;default:return 0}}const v=[void 0,[]];function w(U,z,K=0,N=0){const j=z;return j.values&&j.values.length>1?I(U,j.values,K,N):p(U,z,K,N)}e.scoreFuzzy2=w;function I(U,z,K,N){let j=0;const H=[];for(const V of z){const[q,ne]=p(U,V,K,N);if(typeof q!="number")return v;j+=q,H.push(...ne)}return[j,h(H)]}function p(U,z,K,N){const j=(0,L.fuzzyScore)(z.original,z.originalLowercase,K,U,U.toLowerCase(),N,!0);return j?[j[0],(0,L.createMatches)(j)]:v}const s=Object.freeze({score:0}),r=1<<18,g=1<<17,a=1<<16;function _(U,z,K,N){const j=N.values?N.values:[N];return(0,y.hash)({[N.normalized]:{values:j.map(V=>({value:V.normalized,expectContiguousMatch:V.expectContiguousMatch})),label:U,description:z,allowNonContiguousMatches:K}})}function n(U,z,K,N,j){if(!U||!z.normalized)return s;const H=N.getItemLabel(U);if(!H)return s;const V=N.getItemDescription(U),q=_(H,V,K,z),ne=j[q];if(ne)return ne;const fe=t(H,V,N.getItemPath(U),z,K);return j[q]=fe,fe}e.scoreItemFuzzy=n;function t(U,z,K,N,j){const H=!K||!N.containsPathSeparator;return K&&(i.isLinux?N.pathNormalized===K:(0,k.equalsIgnoreCase)(N.pathNormalized,K))?{score:r,labelMatch:[{start:0,end:U.length}],descriptionMatch:z?[{start:0,end:z.length}]:void 0}:N.values&&N.values.length>1?o(U,z,K,N.values,H,j):d(U,z,K,N,H,j)}function o(U,z,K,N,j,H){let V=0;const q=[],ne=[];for(const fe of N){const{score:ye,labelMatch:ke,descriptionMatch:Be}=d(U,z,K,fe,j,H);if(ye===S)return s;V+=ye,ke&&q.push(...ke),Be&&ne.push(...Be)}return{score:V,labelMatch:h(q),descriptionMatch:h(ne)}}function d(U,z,K,N,j,H){if(j||!z){const[V,q]=R(U,N.normalized,N.normalizedLowercase,H&&!N.expectContiguousMatch);if(V){const ne=(0,L.matchesPrefix)(N.normalized,U);let fe;return ne?(fe=g,fe+=Math.round(N.normalized.length/U.length*100)):fe=a,{score:fe+V,labelMatch:ne||c(q)}}}if(z){let V=z;K&&(V=`${z}${C.sep}`);const q=V.length,ne=`${V}${U}`,[fe,ye]=R(ne,N.normalized,N.normalizedLowercase,H&&!N.expectContiguousMatch);if(fe){const ke=c(ye),Be=[],We=[];return ke.forEach(ze=>{ze.start<q&&ze.end>q?(Be.push({start:0,end:ze.end-q}),We.push({start:ze.start,end:q})):ze.start>=q?Be.push({start:ze.start-q,end:ze.end-q}):We.push(ze)}),{score:fe,labelMatch:Be,descriptionMatch:We}}}return s}function c(U){const z=[];if(!U)return z;let K;for(const N of U)K&&K.end===N?K.end+=1:(K={start:N,end:N+1},z.push(K));return z}function h(U){const z=U.sort((j,H)=>j.start-H.start),K=[];let N;for(const j of z)!N||!l(N,j)?(N=j,K.push(j)):(N.start=Math.min(N.start,j.start),N.end=Math.max(N.end,j.end));return K}function l(U,z){return!(U.end<z.start||z.end<U.start)}function b(U,z,K,N,j,H){const V=n(U,K,N,j,H),q=n(z,K,N,j,H),ne=V.score,fe=q.score;if((ne===r||fe===r)&&ne!==fe)return ne===r?-1:1;if(ne>a||fe>a){if(ne!==fe)return ne>fe?-1:1;if(ne<g&&fe<g){const ee=A(V.labelMatch,q.labelMatch);if(ee!==0)return ee}const ze=j.getItemLabel(U)||"",Q=j.getItemLabel(z)||"";if(ze.length!==Q.length)return ze.length-Q.length}if(ne!==fe)return ne>fe?-1:1;const ye=Array.isArray(V.labelMatch)&&V.labelMatch.length>0,ke=Array.isArray(q.labelMatch)&&q.labelMatch.length>0;if(ye&&!ke)return-1;if(ke&&!ye)return 1;const Be=T(U,V,j),We=T(z,q,j);return Be&&We&&Be!==We?We>Be?-1:1:x(U,z,K,j)}e.compareItemsByFuzzyScore=b;function T(U,z,K){let N=-1,j=-1;if(z.descriptionMatch&&z.descriptionMatch.length?N=z.descriptionMatch[0].start:z.labelMatch&&z.labelMatch.length&&(N=z.labelMatch[0].start),z.labelMatch&&z.labelMatch.length){if(j=z.labelMatch[z.labelMatch.length-1].end,z.descriptionMatch&&z.descriptionMatch.length){const H=K.getItemDescription(U);H&&(j+=H.length)}}else z.descriptionMatch&&z.descriptionMatch.length&&(j=z.descriptionMatch[z.descriptionMatch.length-1].end);return j-N}function A(U,z){if(!U&&!z||(!U||!U.length)&&(!z||!z.length))return 0;if(!z||!z.length)return-1;if(!U||!U.length)return 1;const K=U[0].start,j=U[U.length-1].end-K,H=z[0].start,q=z[z.length-1].end-H;return j===q?0:q<j?1:-1}function x(U,z,K,N){const j=N.getItemLabel(U)||"",H=N.getItemLabel(z)||"",V=N.getItemDescription(U),q=N.getItemDescription(z),ne=j.length+(V?V.length:0),fe=H.length+(q?q.length:0);if(ne!==fe)return ne-fe;const ye=N.getItemPath(U),ke=N.getItemPath(z);return ye&&ke&&ye.length!==ke.length?ye.length-ke.length:j!==H?(0,m.compareAnything)(j,H,K.normalized):V&&q&&V!==q?(0,m.compareAnything)(V,q,K.normalized):ye&&ke&&ye!==ke?(0,m.compareAnything)(ye,ke,K.normalized):0}function O(U){return U.startsWith('"')&&U.endsWith('"')}const F=" ";function W(U){typeof U!="string"&&(U="");const z=U.toLowerCase(),{pathNormalized:K,normalized:N,normalizedLowercase:j}=M(U),H=K.indexOf(C.sep)>=0,V=O(U);let q;const ne=U.split(F);if(ne.length>1)for(const fe of ne){const ye=O(fe),{pathNormalized:ke,normalized:Be,normalizedLowercase:We}=M(fe);Be&&(q||(q=[]),q.push({original:fe,originalLowercase:fe.toLowerCase(),pathNormalized:ke,normalized:Be,normalizedLowercase:We,expectContiguousMatch:ye}))}return{original:U,originalLowercase:z,pathNormalized:K,normalized:N,normalizedLowercase:j,values:q,containsPathSeparator:H,expectContiguousMatch:V}}e.prepareQuery=W;function M(U){let z;i.isWindows?z=U.replace(/\//g,C.sep):z=U.replace(/\\/g,C.sep);const K=(0,k.stripWildcards)(z).replace(/\s|"/g,"");return{pathNormalized:z,normalized:K,normalizedLowercase:K.toLowerCase()}}function B(U){return Array.isArray(U)?W(U.map(z=>z.original).join(F)):W(U.original)}e.pieceToQuery=B}),define(pe[31],ve([0,1,18,30,24,9,8]),function(Y,e,m,L,y,C,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getPathTerms=e.getBasenameTerms=e.isRelativePattern=e.hasSiblingFn=e.hasSiblingPromiseFn=e.parse=e.match=e.splitGlobAware=e.getEmptyExpression=void 0;function k(){return Object.create(null)}e.getEmptyExpression=k;const S="**",D="/",R="[/\\\\]",P="[^/\\\\]",u=/\//g;function E(N){switch(N){case 0:return"";case 1:return`${P}*?`;default:return`(?:${R}|${P}+${R}|${R}${P}+)*?`}}function f(N,j){if(!N)return[];const H=[];let V=!1,q=!1,ne="";for(const fe of N){switch(fe){case j:if(!V&&!q){H.push(ne),ne="";continue}break;case"{":V=!0;break;case"}":V=!1;break;case"[":q=!0;break;case"]":q=!1;break}ne+=fe}return ne&&H.push(ne),H}e.splitGlobAware=f;function v(N){if(!N)return"";let j="";const H=f(N,D);if(H.every(V=>V===S))j=".*";else{let V=!1;H.forEach((q,ne)=>{if(q===S){V||(j+=E(2),V=!0);return}let fe=!1,ye="",ke=!1,Be="";for(const We of q){if(We!=="}"&&fe){ye+=We;continue}if(ke&&(We!=="]"||!Be)){let ze;We==="-"?ze=We:(We==="^"||We==="!")&&!Be?ze="^":We===D?ze="":ze=i.escapeRegExpCharacters(We),Be+=ze;continue}switch(We){case"{":fe=!0;continue;case"[":ke=!0;continue;case"}":j+=`(?:${f(ye,",").map(ee=>v(ee)).join("|")})`,fe=!1,ye="";break;case"]":j+="["+Be+"]",ke=!1,Be="";break;case"?":j+=P;continue;case"*":j+=E(1);continue;default:j+=i.escapeRegExpCharacters(We)}}ne<H.length-1&&(H[ne+1]!==S||ne+2<H.length)&&(j+=R),V=!1})}return j}const w=/^\*\*\/\*\.[\w\.-]+$/,I=/^\*\*\/([\w\.-]+)\/?$/,p=/^{\*\*\/[\*\.]?[\w\.-]+\/?(,\*\*\/[\*\.]?[\w\.-]+\/?)*}$/,s=/^{\*\*\/[\*\.]?[\w\.-]+(\/(\*\*)?)?(,\*\*\/[\*\.]?[\w\.-]+(\/(\*\*)?)?)*}$/,r=/^\*\*((\/[\w\.-]+)+)\/?$/,g=/^([\w\.-]+(\/[\w\.-]+)*)\/?$/,a=new y.LRUCache(1e4),_=function(){return!1},n=function(){return null};function t(N,j){if(!N)return n;let H;typeof N!="string"?H=N.pattern:H=N,H=H.trim();const V=`${H}_${!!j.trimForExclusions}`;let q=a.get(V);if(q)return o(q,N);let ne;if(w.test(H)){const fe=H.substr(4);q=function(ye,ke){return typeof ye=="string"&&ye.endsWith(fe)?H:null}}else(ne=I.exec(d(H,j)))?q=c(ne[1],H):(j.trimForExclusions?s:p).test(H)?q=h(H,j):(ne=r.exec(d(H,j)))?q=l(ne[1].substr(1),H,!0):(ne=g.exec(d(H,j)))?q=l(ne[1],H,!1):q=b(H);return a.set(V,q),o(q,N)}function o(N,j){return typeof j=="string"?N:function(H,V){return L.isEqualOrParent(H,j.base)?N(C.relative(j.base,H),V):null}}function d(N,j){return j.trimForExclusions&&N.endsWith("/**")?N.substr(0,N.length-2):N}function c(N,j){const H=`/${N}`,V=`\\${N}`,q=function(fe,ye){return typeof fe!="string"?null:ye?ye===N?j:null:fe===N||fe.endsWith(H)||fe.endsWith(V)?j:null},ne=[N];return q.basenames=ne,q.patterns=[j],q.allBasenames=ne,q}function h(N,j){const H=K(N.slice(1,-1).split(",").map(ye=>t(ye,j)).filter(ye=>ye!==n),N),V=H.length;if(!V)return n;if(V===1)return H[0];const q=function(ye,ke){for(let Be=0,We=H.length;Be<We;Be++)if(H[Be](ye,ke))return N;return null},ne=H.find(ye=>!!ye.allBasenames);ne&&(q.allBasenames=ne.allBasenames);const fe=H.reduce((ye,ke)=>ke.allPaths?ye.concat(ke.allPaths):ye,[]);return fe.length&&(q.allPaths=fe),q}function l(N,j,H){const V=C.sep===C.posix.sep,q=V?N:N.replace(u,C.sep),ne=C.sep+q,fe=C.posix.sep+N,ye=H?function(ke,Be){return typeof ke=="string"&&(ke===q||ke.endsWith(ne)||!V&&(ke===N||ke.endsWith(fe)))?j:null}:function(ke,Be){return typeof ke=="string"&&(ke===q||!V&&ke===N)?j:null};return ye.allPaths=[(H?"*/":"./")+N],ye}function b(N){try{const j=new RegExp(`^${v(N)}$`);return function(H){return j.lastIndex=0,typeof H=="string"&&j.test(H)?N:null}}catch(j){return n}}function T(N,j,H){return!N||typeof j!="string"?!1:A(N)(j,void 0,H)}e.match=T;function A(N,j={}){if(!N)return _;if(typeof N=="string"||W(N)){const H=t(N,j);if(H===n)return _;const V=function(q,ne){return!!H(q,ne)};return H.allBasenames&&(V.allBasenames=H.allBasenames),H.allPaths&&(V.allPaths=H.allPaths),V}return U(N,j)}e.parse=A;function x(N){if(!N)return;let j;return H=>(j||(j=(N()||Promise.resolve([])).then(V=>V?F(V):{})),j.then(V=>!!V[H]))}e.hasSiblingPromiseFn=x;function O(N){if(!N)return;let j;return H=>{if(!j){const V=N();j=V?F(V):{}}return!!j[H]}}e.hasSiblingFn=O;function F(N){const j={};for(const H of N)j[H]=!0;return j}function W(N){const j=N;return j&&typeof j.base=="string"&&typeof j.pattern=="string"}e.isRelativePattern=W;function M(N){return N.allBasenames||[]}e.getBasenameTerms=M;function B(N){return N.allPaths||[]}e.getPathTerms=B;function U(N,j){const H=K(Object.getOwnPropertyNames(N).map(ye=>z(ye,N[ye],j)).filter(ye=>ye!==n)),V=H.length;if(!V)return n;if(!H.some(ye=>!!ye.requiresSiblings)){if(V===1)return H[0];const ye=function(We,ze){for(let Q=0,ee=H.length;Q<ee;Q++){const re=H[Q](We,ze);if(re)return re}return null},ke=H.find(We=>!!We.allBasenames);ke&&(ye.allBasenames=ke.allBasenames);const Be=H.reduce((We,ze)=>ze.allPaths?We.concat(ze.allPaths):We,[]);return Be.length&&(ye.allPaths=Be),ye}const q=function(ye,ke,Be){let We;for(let ze=0,Q=H.length;ze<Q;ze++){const ee=H[ze];ee.requiresSiblings&&Be&&(ke||(ke=C.basename(ye)),We||(We=ke.substr(0,ke.length-C.extname(ye).length)));const re=ee(ye,ke,We,Be);if(re)return re}return null},ne=H.find(ye=>!!ye.allBasenames);ne&&(q.allBasenames=ne.allBasenames);const fe=H.reduce((ye,ke)=>ke.allPaths?ye.concat(ke.allPaths):ye,[]);return fe.length&&(q.allPaths=fe),q}function z(N,j,H){if(j===!1)return n;const V=t(N,H);if(V===n)return n;if(typeof j=="boolean")return V;if(j){const q=j.when;if(typeof q=="string"){const ne=(fe,ye,ke,Be)=>{if(!Be||!V(fe,ye))return null;const We=q.replace("$(basename)",ke),ze=Be(We);return(0,m.isThenable)(ze)?ze.then(Q=>Q?N:null):ze?N:null};return ne.requiresSiblings=!0,ne}}return V}function K(N,j){const H=N.filter(ye=>!!ye.basenames);if(H.length<2)return N;const V=H.reduce((ye,ke)=>{const Be=ke.basenames;return Be?ye.concat(Be):ye},[]);let q;if(j){q=[];for(let ye=0,ke=V.length;ye<ke;ye++)q.push(j)}else q=H.reduce((ye,ke)=>{const Be=ke.patterns;return Be?ye.concat(Be):ye},[]);const ne=function(ye,ke){if(typeof ye!="string")return null;if(!ke){let We;for(We=ye.length;We>0;We--){const ze=ye.charCodeAt(We-1);if(ze===47||ze===92)break}ke=ye.substr(We)}const Be=V.indexOf(ke);return Be!==-1?q[Be]:null};ne.basenames=V,ne.patterns=q,ne.allBasenames=V;const fe=N.filter(ye=>!ye.basenames);return fe.push(ne),fe}}),define(pe[80],ve([0,1,30,10,9,12,23,8,2]),function(Y,e,m,L,y,C,i,k,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.splitName=e.unmnemonicLabel=e.mnemonicButtonLabel=e.mnemonicMenuLabel=e.template=e.shorten=e.untildify=e.tildify=e.normalizeDriveLetter=e.getBaseLabel=e.getPathLabel=void 0;function D(t,o,d){if(typeof t=="string"&&(t=S.URI.file(t)),d){const h=d.getWorkspaceFolder(t);if(h){const l=d.getWorkspace().folders.length>1;let b;if((0,i.isEqual)(h.uri,t)?b="":b=(0,i.relativePath)(h.uri,t),l){const T=h.name?h.name:(0,i.basename)(h.uri);b=b?T+" \u2022 "+b:T}return b}}if(t.scheme!==L.Schemas.file&&t.scheme!==L.Schemas.untitled)return t.with({query:null,fragment:null}).toString(!0);if((0,m.hasDriveLetter)(t.fsPath))return(0,y.normalize)(P(t.fsPath));let c=(0,y.normalize)(t.fsPath);return!C.isWindows&&o?.userHome&&(c=E(c,o.userHome.fsPath)),c}e.getPathLabel=D;function R(t){if(!t)return;typeof t=="string"&&(t=S.URI.file(t));const o=(0,i.basename)(t)||(t.scheme===L.Schemas.file?t.fsPath:t.path);return C.isWindows&&(0,m.isRootOrDriveLetter)(o)?P(o):o}e.getBaseLabel=R;function P(t,o){return(0,m.hasDriveLetter)(t,o)?t.charAt(0).toUpperCase()+t.slice(1):t}e.normalizeDriveLetter=P;let u=Object.create(null);function E(t,o){if(C.isWindows||!t||!o)return t;let d=u.original===o?u.normalized:void 0;return d||(d=`${(0,k.rtrim)(o,y.posix.sep)}${y.posix.sep}`,u={original:o,normalized:d}),(C.isLinux?t.startsWith(d):(0,k.startsWithIgnoreCase)(t,d))&&(t=`~/${t.substr(d.length)}`),t}e.tildify=E;function f(t,o){return t.replace(/^~($|\/|\\)/,`${o}$1`)}e.untildify=f;const v="\u2026",w="\\\\",I="~";function p(t,o=y.sep){const d=new Array(t.length);let c=!1;for(let h=0;h<t.length;h++){let l=t[h];if(l===""){d[h]=`.${o}`;continue}if(!l){d[h]=l;continue}c=!0;let b="";l.indexOf(w)===0?(b=l.substr(0,l.indexOf(w)+w.length),l=l.substr(l.indexOf(w)+w.length)):l.indexOf(o)===0?(b=l.substr(0,l.indexOf(o)+o.length),l=l.substr(l.indexOf(o)+o.length)):l.indexOf(I)===0&&(b=l.substr(0,l.indexOf(I)+I.length),l=l.substr(l.indexOf(I)+I.length));const T=l.split(o);for(let A=1;c&&A<=T.length;A++)for(let x=T.length-A;c&&x>=0;x--){c=!1;let O=T.slice(x,x+A).join(o);for(let F=0;!c&&F<t.length;F++)if(F!==h&&t[F]&&t[F].indexOf(O)>-1){const W=x+A===T.length,M=x>0&&t[F].indexOf(o)>-1?o+O:O,B=t[F].endsWith(M);c=!W||B}if(!c){let F="";(T[0].endsWith(":")||b!=="")&&(x===1&&(x=0,A++,O=T[0]+o+O),x>0&&(F=T[0]+o),F=b+F),x>0&&(F=F+v+o),F=F+O,x+A<T.length&&(F=F+o+v),d[h]=F}}c&&(d[h]=l)}return d}e.shorten=p;var s;(function(t){t[t.TEXT=0]="TEXT",t[t.VARIABLE=1]="VARIABLE",t[t.SEPARATOR=2]="SEPARATOR"})(s||(s={}));function r(t,o=Object.create(null)){const d=[];let c=!1,h="";for(const l of t)if(l==="$"||c&&l==="{")h&&d.push({value:h,type:s.TEXT}),h="",c=!0;else if(l==="}"&&c){const b=o[h];if(typeof b=="string")b.length&&d.push({value:b,type:s.VARIABLE});else if(b){const T=d[d.length-1];(!T||T.type!==s.SEPARATOR)&&d.push({value:b.label,type:s.SEPARATOR})}h="",c=!1}else h+=l;return h&&!c&&d.push({value:h,type:s.TEXT}),d.filter((l,b)=>{if(l.type===s.SEPARATOR){const T=d[b-1],A=d[b+1];return[T,A].every(x=>x&&(x.type===s.VARIABLE||x.type===s.TEXT)&&x.value.length>0)}return!0}).map(l=>l.value).join("")}e.template=r;function g(t,o){return C.isMacintosh||o?t.replace(/\(&&\w\)|&&/g,"").replace(/&/g,C.isMacintosh?"&":"&&"):t.replace(/&&|&/g,d=>d==="&"?"&&":"&")}e.mnemonicMenuLabel=g;function a(t,o){return C.isMacintosh||o?t.replace(/\(&&\w\)|&&/g,""):C.isWindows?t.replace(/&&|&/g,d=>d==="&"?"&&":"&"):t.replace(/&&/g,"_")}e.mnemonicButtonLabel=a;function _(t){return t.replace(/&/g,"&&")}e.unmnemonicLabel=_;function n(t){const o=t.indexOf("/")!==-1?y.posix:y.win32,d=o.basename(t),c=o.dirname(t);return d.length?{name:d,parentPath:c}:{name:c,parentPath:""}}e.splitName=n}),define(pe[101],ve([0,1,31,10,9,23,8]),function(Y,e,m,L,y,C,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.normalizeMimeType=e.getExtensionForMimeType=e.getMediaMime=e.getMediaOrTextMime=e.isUnspecific=e.guessMimeTypes=e.clearTextMimes=e.registerTextMime=e.Mimes=void 0;var k;(function(t){t.text="text/plain",t.binary="application/octet-stream",t.unknown="application/unknown",t.markdown="text/markdown",t.latex="text/latex"})(k=e.Mimes||(e.Mimes={}));let S=[],D=[],R=[];function P(t,o=!1){const d=u(t);S.push(d),d.userConfigured?R.push(d):D.push(d),o&&!d.userConfigured&&S.forEach(c=>{c.mime===d.mime||c.userConfigured||(d.extension&&c.extension===d.extension&&console.warn(`Overwriting extension <<${d.extension}>> to now point to mime <<${d.mime}>>`),d.filename&&c.filename===d.filename&&console.warn(`Overwriting filename <<${d.filename}>> to now point to mime <<${d.mime}>>`),d.filepattern&&c.filepattern===d.filepattern&&console.warn(`Overwriting filepattern <<${d.filepattern}>> to now point to mime <<${d.mime}>>`),d.firstline&&c.firstline===d.firstline&&console.warn(`Overwriting firstline <<${d.firstline}>> to now point to mime <<${d.mime}>>`))})}e.registerTextMime=P;function u(t){return{id:t.id,mime:t.mime,filename:t.filename,extension:t.extension,filepattern:t.filepattern,firstline:t.firstline,userConfigured:t.userConfigured,filenameLowercase:t.filename?t.filename.toLowerCase():void 0,extensionLowercase:t.extension?t.extension.toLowerCase():void 0,filepatternLowercase:t.filepattern?(0,m.parse)(t.filepattern.toLowerCase()):void 0,filepatternOnPath:t.filepattern?t.filepattern.indexOf(y.posix.sep)>=0:!1}}function E(t){t?(S=S.filter(o=>!o.userConfigured),R=[]):(S=[],D=[],R=[])}e.clearTextMimes=E;function f(t,o){let d;if(t)switch(t.scheme){case L.Schemas.file:d=t.fsPath;break;case L.Schemas.data:d=C.DataUri.parseMetaData(t).get(C.DataUri.META_DATA_LABEL);break;default:d=t.path}if(!d)return[k.unknown];d=d.toLowerCase();const c=(0,y.basename)(d),h=v(d,c,R);if(h)return[h,k.text];const l=v(d,c,D);if(l)return[l,k.text];if(o){const b=w(o);if(b)return[b,k.text]}return[k.unknown]}e.guessMimeTypes=f;function v(t,o,d){let c=null,h=null,l=null;for(let b=d.length-1;b>=0;b--){const T=d[b];if(o===T.filenameLowercase){c=T;break}if(T.filepattern&&(!h||T.filepattern.length>h.filepattern.length)){const A=T.filepatternOnPath?t:o;T.filepatternLowercase?.(A)&&(h=T)}T.extension&&(!l||T.extension.length>l.extension.length)&&o.endsWith(T.extensionLowercase)&&(l=T)}return c?c.mime:h?h.mime:l?l.mime:null}function w(t){if((0,i.startsWithUTF8BOM)(t)&&(t=t.substr(1)),t.length>0)for(let o=S.length-1;o>=0;o--){const d=S[o];if(!d.firstline)continue;const c=t.match(d.firstline);if(c&&c.length>0)return d.mime}return null}function I(t){return t?typeof t=="string"?t===k.binary||t===k.text||t===k.unknown:t.length===1&&I(t[0]):!0}e.isUnspecific=I;const p={".css":"text/css",".csv":"text/csv",".htm":"text/html",".html":"text/html",".ics":"text/calendar",".js":"text/javascript",".mjs":"text/javascript",".txt":"text/plain",".xml":"text/xml"},s={".aac":"audio/x-aac",".avi":"video/x-msvideo",".bmp":"image/bmp",".flv":"video/x-flv",".gif":"image/gif",".ico":"image/x-icon",".jpe":"image/jpg",".jpeg":"image/jpg",".jpg":"image/jpg",".m1v":"video/mpeg",".m2a":"audio/mpeg",".m2v":"video/mpeg",".m3a":"audio/mpeg",".mid":"audio/midi",".midi":"audio/midi",".mk3d":"video/x-matroska",".mks":"video/x-matroska",".mkv":"video/x-matroska",".mov":"video/quicktime",".movie":"video/x-sgi-movie",".mp2":"audio/mpeg",".mp2a":"audio/mpeg",".mp3":"audio/mpeg",".mp4":"video/mp4",".mp4a":"audio/mp4",".mp4v":"video/mp4",".mpe":"video/mpeg",".mpeg":"video/mpeg",".mpg":"video/mpeg",".mpg4":"video/mp4",".mpga":"audio/mpeg",".oga":"audio/ogg",".ogg":"audio/ogg",".ogv":"video/ogg",".png":"image/png",".psd":"image/vnd.adobe.photoshop",".qt":"video/quicktime",".spx":"audio/ogg",".svg":"image/svg+xml",".tga":"image/x-tga",".tif":"image/tiff",".tiff":"image/tiff",".wav":"audio/x-wav",".webm":"video/webm",".webp":"image/webp",".wma":"audio/x-ms-wma",".wmv":"video/x-ms-wmv",".woff":"application/font-woff"};function r(t){const o=(0,y.extname)(t),d=p[o.toLowerCase()];return d!==void 0?d:g(t)}e.getMediaOrTextMime=r;function g(t){const o=(0,y.extname)(t);return s[o.toLowerCase()]}e.getMediaMime=g;function a(t){for(const o in s)if(s[o]===t)return o}e.getExtensionForMimeType=a;const _=/^(.+)\/(.+?)(;.+)?$/;function n(t,o){const d=_.exec(t);return d?`${d[1].toLowerCase()}/${d[2].toLowerCase()}${d[3]??""}`:o?void 0:t}e.normalizeMimeType=n}),define(pe[102],ve([0,1,2]),function(Y,e,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.transformAndReviveIncomingURIs=e.transformIncomingURIs=e.transformOutgoingURIs=e.DefaultURITransformer=e.URITransformer=void 0;function L(R){return R.toJSON()}class y{constructor(P){this._uriTransformer=P}transformIncoming(P){const u=this._uriTransformer.transformIncoming(P);return u===P?P:L(m.URI.from(u))}transformOutgoing(P){const u=this._uriTransformer.transformOutgoing(P);return u===P?P:L(m.URI.from(u))}transformOutgoingURI(P){const u=this._uriTransformer.transformOutgoing(P);return u===P?P:m.URI.from(u)}transformOutgoingScheme(P){return this._uriTransformer.transformOutgoingScheme(P)}}e.URITransformer=y,e.DefaultURITransformer=new class{transformIncoming(R){return R}transformOutgoing(R){return R}transformOutgoingURI(R){return R}transformOutgoingScheme(R){return R}};function C(R,P,u){if(!R||u>200)return null;if(typeof R=="object"){if(R instanceof m.URI)return P.transformOutgoing(R);for(let E in R)if(Object.hasOwnProperty.call(R,E)){const f=C(R[E],P,u+1);f!==null&&(R[E]=f)}}return null}function i(R,P){const u=C(R,P,0);return u===null?R:u}e.transformOutgoingURIs=i;function k(R,P,u,E){if(!R||E>200)return null;if(typeof R=="object"){if(R.$mid===1)return u?m.URI.revive(P.transformIncoming(R)):P.transformIncoming(R);for(let f in R)if(Object.hasOwnProperty.call(R,f)){const v=k(R[f],P,u,E+1);v!==null&&(R[f]=v)}}return null}function S(R,P){const u=k(R,P,!1,0);return u===null?R:u}e.transformIncomingURIs=S;function D(R,P){const u=k(R,P,!0,0);return u===null?R:u}e.transformAndReviveIncomingURIs=D}),define(pe[32],ve([0,1]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.generateUuid=e.isUUID=void 0;const m=/^[0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12}$/i;function L(S){return m.test(S)}e.isUUID=L;const y=new Uint8Array(16),C=[];for(let S=0;S<256;S++)C.push(S.toString(16).padStart(2,"0"));let i;typeof crypto=="object"&&typeof crypto.getRandomValues=="function"?i=crypto.getRandomValues.bind(crypto):i=function(S){for(let D=0;D<S.length;D++)S[D]=Math.floor(Math.random()*256);return S};function k(){i(y),y[6]=y[6]&15|64,y[8]=y[8]&63|128;let S=0,D="";return D+=C[y[S++]],D+=C[y[S++]],D+=C[y[S++]],D+=C[y[S++]],D+="-",D+=C[y[S++]],D+=C[y[S++]],D+="-",D+=C[y[S++]],D+=C[y[S++]],D+="-",D+=C[y[S++]],D+=C[y[S++]],D+="-",D+=C[y[S++]],D+=C[y[S++]],D+=C[y[S++]],D+=C[y[S++]],D+=C[y[S++]],D+=C[y[S++]],D}e.generateUuid=k}),define(pe[142],ve([0,1,103]),function(Y,e,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LineDecoder=void 0;class L{constructor(C="utf8"){this.stringDecoder=new m.StringDecoder(C),this.remaining=null}write(C){const i=[],k=this.remaining?this.remaining+this.stringDecoder.write(C):this.stringDecoder.write(C);if(k.length<1)return i;let S=0,D,R=S;for(;R<k.length;)if(D=k.charCodeAt(R),D===13||D===10){if(i.push(k.substring(S,R)),R++,R<k.length){const P=D;D=k.charCodeAt(R),(P===13&&D===10||P===10&&D===13)&&R++}S=R}else R++;return this.remaining=S<k.length?k.substr(S):null,i}end(){return this.remaining}}e.LineDecoder=L}),define(pe[28],ve([0,1,60,81,289,18,30,79,9,12,23,2,32]),function(Y,e,m,L,y,C,i,k,S,D,R,P,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Promises=e.writeFileSync=e.SymlinkSupport=e.whenDeleted=e.readdirSync=e.rimrafSync=e.RimRafMode=void 0;var E;(function(M){M[M.UNLINK=0]="UNLINK",M[M.MOVE=1]="MOVE"})(E=e.RimRafMode||(e.RimRafMode={}));async function f(M,B=E.UNLINK){if((0,i.isRootOrDriveLetter)(M))throw new Error("rimraf - will refuse to recursively delete root");return B===E.UNLINK?w(M):v(M)}async function v(M){try{const B=(0,S.join)((0,L.tmpdir)(),(0,u.generateUuid)());try{await e.Promises.rename(M,B)}catch(U){return w(M)}w(B).catch(U=>{})}catch(B){if(B.code!=="ENOENT")throw B}}async function w(M){return e.Promises.rmdir(M,{recursive:!0,maxRetries:3})}function I(M){if((0,i.isRootOrDriveLetter)(M))throw new Error("rimraf - will refuse to recursively delete root");m.rmdirSync(M,{recursive:!0})}e.rimrafSync=I;async function p(M,B){return g(await(B?s(M):(0,y.promisify)(m.readdir)(M)))}async function s(M){try{return await(0,y.promisify)(m.readdir)(M,{withFileTypes:!0})}catch(z){console.warn("[node.js fs] readdir with filetypes failed with error: ",z)}const B=[],U=await p(M);for(const z of U){let K=!1,N=!1,j=!1;try{const H=await e.Promises.lstat((0,S.join)(M,z));K=H.isFile(),N=H.isDirectory(),j=H.isSymbolicLink()}catch(H){console.warn("[node.js fs] unexpected error from lstat after readdir: ",H)}B.push({name:z,isFile:()=>K,isDirectory:()=>N,isSymbolicLink:()=>j})}return B}function r(M){return g(m.readdirSync(M))}e.readdirSync=r;function g(M){return M.map(B=>typeof B=="string"?D.isMacintosh?(0,k.normalizeNFC)(B):B:(B.name=D.isMacintosh?(0,k.normalizeNFC)(B.name):B.name,B))}async function a(M){const B=await p(M),U=[];for(const z of B)await n.existsDirectory((0,S.join)(M,z))&&U.push(z);return U}function _(M,B=1e3){return new Promise(U=>{let z=!1;const K=setInterval(()=>{z||(z=!0,m.access(M,N=>{z=!1,N&&(clearInterval(K),U(void 0))}))},B)})}e.whenDeleted=_;var n;(function(M){async function B(K){let N;try{if(N=await e.Promises.lstat(K),!N.isSymbolicLink())return{stat:N}}catch(j){}try{return{stat:await e.Promises.stat(K),symbolicLink:N?.isSymbolicLink()?{dangling:!1}:void 0}}catch(j){if(j.code==="ENOENT"&&N)return{stat:N,symbolicLink:{dangling:!0}};if(D.isWindows&&j.code==="EACCES")try{return{stat:await e.Promises.stat(await e.Promises.readlink(K)),symbolicLink:{dangling:!1}}}catch(H){if(H.code==="ENOENT"&&N)return{stat:N,symbolicLink:{dangling:!0}};throw H}throw j}}M.stat=B;async function U(K){try{const{stat:N,symbolicLink:j}=await M.stat(K);return N.isFile()&&j?.dangling!==!0}catch(N){}return!1}M.existsFile=U;async function z(K){try{const{stat:N,symbolicLink:j}=await M.stat(K);return N.isDirectory()&&j?.dangling!==!0}catch(N){}return!1}M.existsDirectory=z})(n=e.SymlinkSupport||(e.SymlinkSupport={}));const t=new C.ResourceQueue;function o(M,B,U){return t.queueFor(P.URI.file(M),R.extUriBiasedIgnorePathCase).queue(()=>{const z=l(U);return new Promise((K,N)=>c(M,B,z,j=>j?N(j):K()))})}let d=!0;function c(M,B,U,z){if(!d)return m.writeFile(M,B,{mode:U.mode,flag:U.flag},z);m.open(M,U.flag,U.mode,(K,N)=>{if(K)return z(K);m.writeFile(N,B,j=>{if(j)return m.close(N,()=>z(j));m.fdatasync(N,H=>(H&&(console.warn("[node.js fs] fdatasync is now disabled for this session because it failed: ",H),d=!1),m.close(N,V=>z(V))))})})}function h(M,B,U){const z=l(U);if(!d)return m.writeFileSync(M,B,{mode:z.mode,flag:z.flag});const K=m.openSync(M,z.flag,z.mode);try{m.writeFileSync(K,B);try{m.fdatasyncSync(K)}catch(N){console.warn("[node.js fs] fdatasyncSync is now disabled for this session because it failed: ",N),d=!1}}finally{m.closeSync(K)}}e.writeFileSync=h;function l(M){return M?{mode:typeof M.mode=="number"?M.mode:438,flag:typeof M.flag=="string"?M.flag:"w"}:{mode:438,flag:"w"}}async function b(M,B){if(M===B)return;async function U(z){try{const K=await e.Promises.lstat(z);if(K.isDirectory()||K.isSymbolicLink())return;await e.Promises.utimes(z,K.atime,new Date)}catch(K){}}try{await e.Promises.rename(M,B),await U(B)}catch(z){if(M.toLowerCase()!==B.toLowerCase()&&z.code==="EXDEV"||M.endsWith("."))await T(M,B,{preserveSymlinks:!1}),await f(M,E.MOVE),await U(B);else throw z}}async function T(M,B,U){return x(M,B,{root:{source:M,target:B},options:U,handledSourcePaths:new Set})}const A=511;async function x(M,B,U){if(U.handledSourcePaths.has(M))return;U.handledSourcePaths.add(M);const{stat:z,symbolicLink:K}=await n.stat(M);if(K){if(U.options.preserveSymlinks)try{return await W(M,B,U)}catch(N){console.warn("[node.js fs] copy of symlink failed: ",N)}if(K.dangling)return}return z.isDirectory()?O(M,B,z.mode&A,U):F(M,B,z.mode&A)}async function O(M,B,U,z){await e.Promises.mkdir(B,{recursive:!0,mode:U});const K=await p(M);for(const N of K)await x((0,S.join)(M,N),(0,S.join)(B,N),z)}async function F(M,B,U){await e.Promises.copyFile(M,B),await e.Promises.chmod(B,U)}async function W(M,B,U){let z=await e.Promises.readlink(M);(0,i.isEqualOrParent)(z,U.root.source,!D.isLinux)&&(z=(0,S.join)(U.root.target,z.substr(U.root.source.length+1))),await e.Promises.symlink(z,B)}e.Promises=new class{get access(){return(0,y.promisify)(m.access)}get stat(){return(0,y.promisify)(m.stat)}get lstat(){return(0,y.promisify)(m.lstat)}get utimes(){return(0,y.promisify)(m.utimes)}get read(){return(0,y.promisify)(m.read)}get readFile(){return(0,y.promisify)(m.readFile)}get write(){return(0,y.promisify)(m.write)}get appendFile(){return(0,y.promisify)(m.appendFile)}get fdatasync(){return(0,y.promisify)(m.fdatasync)}get truncate(){return(0,y.promisify)(m.truncate)}get rename(){return(0,y.promisify)(m.rename)}get copyFile(){return(0,y.promisify)(m.copyFile)}get open(){return(0,y.promisify)(m.open)}get close(){return(0,y.promisify)(m.close)}get symlink(){return(0,y.promisify)(m.symlink)}get readlink(){return(0,y.promisify)(m.readlink)}get chmod(){return(0,y.promisify)(m.chmod)}get mkdir(){return(0,y.promisify)(m.mkdir)}get unlink(){return(0,y.promisify)(m.unlink)}get rmdir(){return(0,y.promisify)(m.rmdir)}get realpath(){return(0,y.promisify)(m.realpath)}async exists(M){try{return await e.Promises.access(M),!0}catch{return!1}}get readdir(){return p}get readDirsInDir(){return a}get writeFile(){return o}get rm(){return f}get move(){return b}get copy(){return T}}}),define(pe[104],ve([0,1,60,9,8,28]),function(Y,e,m,L,y,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.realpathSync=e.realpath=e.realcaseSync=void 0;function i(R){const P=(0,L.dirname)(R);if(R===P)return R;const u=((0,L.basename)(R)||R).toLowerCase();try{const f=(0,C.readdirSync)(P).filter(v=>v.toLowerCase()===u);if(f.length===1){const v=i(P);if(v)return(0,L.join)(v,f[0])}else if(f.length>1){const v=f.indexOf(u);if(v>=0){const w=i(P);if(w)return(0,L.join)(w,f[v])}}}catch(E){}return null}e.realcaseSync=i;async function k(R){try{return await C.Promises.realpath(R)}catch(P){const u=D(R);return await C.Promises.access(u,m.constants.R_OK),u}}e.realpath=k;function S(R){try{return m.realpathSync(R)}catch(P){const u=D(R);return m.accessSync(u,m.constants.R_OK),u}}e.realpathSync=S;function D(R){return(0,y.rtrim)((0,L.normalize)(R),L.sep)}});var je=this&&this.__decorate||function(Y,e,m,L){var y=arguments.length,C=y<3?e:L===null?L=Object.getOwnPropertyDescriptor(e,m):L,i;if(typeof Reflect=="object"&&typeof Reflect.decorate=="function")C=Reflect.decorate(Y,e,m,L);else for(var k=Y.length-1;k>=0;k--)(i=Y[k])&&(C=(y<3?i(C):y>3?i(e,m,C):i(e,m))||C);return y>3&&C&&Object.defineProperty(e,m,C),C};define(pe[105],ve([0,1,16,18,22,21,57,15,3,6,59,8,13]),function(Y,e,m,L,y,C,i,k,S,D,R,P,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IPCLogger=e.logWithColors=e.ProxyChannel=e.StaticRouter=e.getNextTickChannel=e.getDelayedChannel=e.IPCClient=e.IPCServer=e.ChannelClient=e.RequestInitiator=e.ChannelServer=e.ResponseType=e.RequestType=void 0;var E;(function(K){K[K.Promise=100]="Promise",K[K.PromiseCancel=101]="PromiseCancel",K[K.EventListen=102]="EventListen",K[K.EventDispose=103]="EventDispose"})(E=e.RequestType||(e.RequestType={}));function f(K){switch(K){case 100:return"req";case 101:return"cancel";case 102:return"subscribe";case 103:return"unsubscribe"}}var v;(function(K){K[K.Initialize=200]="Initialize",K[K.PromiseSuccess=201]="PromiseSuccess",K[K.PromiseError=202]="PromiseError",K[K.PromiseErrorObj=203]="PromiseErrorObj",K[K.EventFire=204]="EventFire"})(v=e.ResponseType||(e.ResponseType={}));function w(K){switch(K){case 200:return"init";case 201:return"reply:";case 202:case 203:return"replyErr:";case 204:return"event:"}}var I;(function(K){K[K.Uninitialized=0]="Uninitialized",K[K.Idle=1]="Idle"})(I||(I={}));class p{constructor(N){this.buffer=N,this.pos=0}read(N){const j=this.buffer.slice(this.pos,this.pos+N);return this.pos+=j.byteLength,j}}class s{constructor(){this.buffers=[]}get buffer(){return y.VSBuffer.concat(this.buffers)}write(N){this.buffers.push(N)}}var r;(function(K){K[K.Undefined=0]="Undefined",K[K.String=1]="String",K[K.Buffer=2]="Buffer",K[K.VSBuffer=3]="VSBuffer",K[K.Array=4]="Array",K[K.Object=5]="Object"})(r||(r={}));function g(K){const N=y.VSBuffer.alloc(4);return N.writeUInt32BE(K,0),N}function a(K){return K.read(4).readUInt32BE(0)}function _(K){const N=y.VSBuffer.alloc(1);return N.writeUInt8(K,0),N}const n={Undefined:_(r.Undefined),String:_(r.String),Buffer:_(r.Buffer),VSBuffer:_(r.VSBuffer),Array:_(r.Array),Object:_(r.Object)},t=typeof Buffer!="undefined";function o(K,N){if(typeof N=="undefined")K.write(n.Undefined);else if(typeof N=="string"){const j=y.VSBuffer.fromString(N);K.write(n.String),K.write(g(j.byteLength)),K.write(j)}else if(t&&Buffer.isBuffer(N)){const j=y.VSBuffer.wrap(N);K.write(n.Buffer),K.write(g(j.byteLength)),K.write(j)}else if(N instanceof y.VSBuffer)K.write(n.VSBuffer),K.write(g(N.byteLength)),K.write(N);else if(Array.isArray(N)){K.write(n.Array),K.write(g(N.length));for(const j of N)o(K,j)}else{const j=y.VSBuffer.fromString(JSON.stringify(N));K.write(n.Object),K.write(g(j.byteLength)),K.write(j)}}function d(K){switch(K.read(1).readUInt8(0)){case r.Undefined:return;case r.String:return K.read(a(K)).toString();case r.Buffer:return K.read(a(K)).buffer;case r.VSBuffer:return K.read(a(K));case r.Array:{const j=a(K),H=[];for(let V=0;V<j;V++)H.push(d(K));return H}case r.Object:return JSON.parse(K.read(a(K)).toString())}}class c{constructor(N,j,H=null,V=1e3){this.protocol=N,this.ctx=j,this.logger=H,this.timeoutDelay=V,this.channels=new Map,this.activeRequests=new Map,this.pendingRequests=new Map,this.protocolListener=this.protocol.onMessage(q=>this.onRawMessage(q)),this.sendResponse({type:200})}registerChannel(N,j){this.channels.set(N,j),setTimeout(()=>this.flushPendingRequests(N),0)}sendResponse(N){switch(N.type){case 200:{const j=this.send([N.type]);this.logger&&this.logger.logOutgoing(j,0,1,w(N.type));return}case 201:case 202:case 204:case 203:{const j=this.send([N.type,N.id],N.data);this.logger&&this.logger.logOutgoing(j,N.id,1,w(N.type),N.data);return}}}send(N,j=void 0){const H=new s;return o(H,N),o(H,j),this.sendBuffer(H.buffer)}sendBuffer(N){try{return this.protocol.send(N),N.byteLength}catch(j){return 0}}onRawMessage(N){const j=new p(N),H=d(j),V=d(j),q=H[0];switch(q){case 100:return this.logger&&this.logger.logIncoming(N.byteLength,H[1],1,`${f(q)}: ${H[2]}.${H[3]}`,V),this.onPromise({type:q,id:H[1],channelName:H[2],name:H[3],arg:V});case 102:return this.logger&&this.logger.logIncoming(N.byteLength,H[1],1,`${f(q)}: ${H[2]}.${H[3]}`,V),this.onEventListen({type:q,id:H[1],channelName:H[2],name:H[3],arg:V});case 101:return this.logger&&this.logger.logIncoming(N.byteLength,H[1],1,`${f(q)}`),this.disposeActiveRequest({type:q,id:H[1]});case 103:return this.logger&&this.logger.logIncoming(N.byteLength,H[1],1,`${f(q)}`),this.disposeActiveRequest({type:q,id:H[1]})}}onPromise(N){const j=this.channels.get(N.channelName);if(!j){this.collectPendingRequest(N);return}const H=new C.CancellationTokenSource;let V;try{V=j.call(this.ctx,N.name,N.arg,H.token)}catch(fe){V=Promise.reject(fe)}const q=N.id;V.then(fe=>{this.sendResponse({id:q,data:fe,type:201}),this.activeRequests.delete(N.id)},fe=>{fe instanceof Error?this.sendResponse({id:q,data:{message:fe.message,name:fe.name,stack:fe.stack?fe.stack.split?fe.stack.split(`
`):fe.stack:void 0},type:202}):this.sendResponse({id:q,data:fe,type:203}),this.activeRequests.delete(N.id)});const ne=(0,D.toDisposable)(()=>H.cancel());this.activeRequests.set(N.id,ne)}onEventListen(N){const j=this.channels.get(N.channelName);if(!j){this.collectPendingRequest(N);return}const H=N.id,q=j.listen(this.ctx,N.name,N.arg)(ne=>this.sendResponse({id:H,data:ne,type:204}));this.activeRequests.set(N.id,q)}disposeActiveRequest(N){const j=this.activeRequests.get(N.id);j&&(j.dispose(),this.activeRequests.delete(N.id))}collectPendingRequest(N){let j=this.pendingRequests.get(N.channelName);j||(j=[],this.pendingRequests.set(N.channelName,j));const H=setTimeout(()=>{console.error(`Unknown channel: ${N.channelName}`),N.type===100&&this.sendResponse({id:N.id,data:{name:"Unknown channel",message:`Channel name '${N.channelName}' timed out after ${this.timeoutDelay}ms`,stack:void 0},type:202})},this.timeoutDelay);j.push({request:N,timeoutTimer:H})}flushPendingRequests(N){const j=this.pendingRequests.get(N);if(j){for(const H of j)switch(clearTimeout(H.timeoutTimer),H.request.type){case 100:this.onPromise(H.request);break;case 102:this.onEventListen(H.request);break}this.pendingRequests.delete(N)}}dispose(){this.protocolListener&&(this.protocolListener.dispose(),this.protocolListener=null),this.activeRequests.forEach(N=>N.dispose()),this.activeRequests.clear()}}e.ChannelServer=c;var h;(function(K){K[K.LocalSide=0]="LocalSide",K[K.OtherSide=1]="OtherSide"})(h=e.RequestInitiator||(e.RequestInitiator={}));class l{constructor(N,j=null){this.protocol=N,this.isDisposed=!1,this.state=I.Uninitialized,this.activeRequests=new Set,this.handlers=new Map,this.lastRequestId=0,this._onDidInitialize=new S.Emitter,this.onDidInitialize=this._onDidInitialize.event,this.protocolListener=this.protocol.onMessage(H=>this.onBuffer(H)),this.logger=j}getChannel(N){const j=this;return{call(H,V,q){return j.isDisposed?Promise.reject(k.canceled()):j.requestPromise(N,H,V,q)},listen(H,V){return j.isDisposed?Promise.reject(k.canceled()):j.requestEvent(N,H,V)}}}requestPromise(N,j,H,V=C.CancellationToken.None){const q=this.lastRequestId++,fe={id:q,type:100,channelName:N,name:j,arg:H};if(V.isCancellationRequested)return Promise.reject(k.canceled());let ye;return new Promise((Be,We)=>{if(V.isCancellationRequested)return We(k.canceled());const ze=()=>{const he=Z=>{switch(Z.type){case 201:this.handlers.delete(q),Be(Z.data);break;case 202:this.handlers.delete(q);const oe=new Error(Z.data.message);oe.stack=Z.data.stack,oe.name=Z.data.name,We(oe);break;case 203:this.handlers.delete(q),We(Z.data);break}};this.handlers.set(q,he),this.sendRequest(fe)};let Q=null;this.state===I.Idle?ze():(Q=(0,L.createCancelablePromise)(he=>this.whenInitialized()),Q.then(()=>{Q=null,ze()}));const ee=()=>{Q?(Q.cancel(),Q=null):this.sendRequest({id:q,type:101}),We(k.canceled())},re=V.onCancellationRequested(ee);ye=(0,D.combinedDisposable)((0,D.toDisposable)(ee),re),this.activeRequests.add(ye)}).finally(()=>{this.activeRequests.delete(ye)})}requestEvent(N,j,H){const V=this.lastRequestId++,ne={id:V,type:102,channelName:N,name:j,arg:H};let fe=null;const ye=new S.Emitter({onFirstListenerAdd:()=>{fe=(0,L.createCancelablePromise)(Be=>this.whenInitialized()),fe.then(()=>{fe=null,this.activeRequests.add(ye),this.sendRequest(ne)})},onLastListenerRemove:()=>{fe?(fe.cancel(),fe=null):(this.activeRequests.delete(ye),this.sendRequest({id:V,type:103}))}}),ke=Be=>ye.fire(Be.data);return this.handlers.set(V,ke),ye.event}sendRequest(N){switch(N.type){case 100:case 102:{const j=this.send([N.type,N.id,N.channelName,N.name],N.arg);this.logger&&this.logger.logOutgoing(j,N.id,0,`${f(N.type)}: ${N.channelName}.${N.name}`,N.arg);return}case 101:case 103:{const j=this.send([N.type,N.id]);this.logger&&this.logger.logOutgoing(j,N.id,0,f(N.type));return}}}send(N,j=void 0){const H=new s;return o(H,N),o(H,j),this.sendBuffer(H.buffer)}sendBuffer(N){try{return this.protocol.send(N),N.byteLength}catch(j){return 0}}onBuffer(N){const j=new p(N),H=d(j),V=d(j),q=H[0];switch(q){case 200:return this.logger&&this.logger.logIncoming(N.byteLength,0,0,w(q)),this.onResponse({type:H[0]});case 201:case 202:case 204:case 203:return this.logger&&this.logger.logIncoming(N.byteLength,H[1],0,w(q),V),this.onResponse({type:H[0],id:H[1],data:V})}}onResponse(N){if(N.type===200){this.state=I.Idle,this._onDidInitialize.fire();return}const j=this.handlers.get(N.id);j&&j(N)}get onDidInitializePromise(){return S.Event.toPromise(this.onDidInitialize)}whenInitialized(){return this.state===I.Idle?Promise.resolve():this.onDidInitializePromise}dispose(){this.isDisposed=!0,this.protocolListener&&(this.protocolListener.dispose(),this.protocolListener=null),this.activeRequests.forEach(N=>N.dispose()),this.activeRequests.clear()}}je([i.memoize],l.prototype,"onDidInitializePromise",null),e.ChannelClient=l;class b{constructor(N){this.channels=new Map,this._connections=new Set,this._onDidAddConnection=new S.Emitter,this.onDidAddConnection=this._onDidAddConnection.event,this._onDidRemoveConnection=new S.Emitter,this.onDidRemoveConnection=this._onDidRemoveConnection.event,N(({protocol:j,onDidClientDisconnect:H})=>{S.Event.once(j.onMessage)(q=>{const ne=new p(q),fe=d(ne),ye=new c(j,fe),ke=new l(j);this.channels.forEach((We,ze)=>ye.registerChannel(ze,We));const Be={channelServer:ye,channelClient:ke,ctx:fe};this._connections.add(Be),this._onDidAddConnection.fire(Be),H(()=>{ye.dispose(),ke.dispose(),this._connections.delete(Be),this._onDidRemoveConnection.fire(Be)})})})}get connections(){const N=[];return this._connections.forEach(j=>N.push(j)),N}getChannel(N,j){const H=this;return{call(V,q,ne){let fe;if((0,u.isFunction)(j)){let ke=(0,m.getRandomElement)(H.connections.filter(j));fe=ke?Promise.resolve(ke):S.Event.toPromise(S.Event.filter(H.onDidAddConnection,j))}else fe=j.routeCall(H,V,q);const ye=fe.then(ke=>ke.channelClient.getChannel(N));return A(ye).call(V,q,ne)},listen(V,q){if((0,u.isFunction)(j))return H.getMulticastEvent(N,j,V,q);const ne=j.routeEvent(H,V,q).then(fe=>fe.channelClient.getChannel(N));return A(ne).listen(V,q)}}}getMulticastEvent(N,j,H,V){const q=this;let ne=new D.DisposableStore;const fe=new S.Emitter({onFirstListenerAdd:()=>{ne=new D.DisposableStore;const ye=new S.EventMultiplexer,ke=new Map,Be=ze=>{const ee=ze.channelClient.getChannel(N).listen(H,V),re=ye.add(ee);ke.set(ze,re)},We=ze=>{const Q=ke.get(ze);!Q||(Q.dispose(),ke.delete(ze))};q.connections.filter(j).forEach(Be),S.Event.filter(q.onDidAddConnection,j)(Be,void 0,ne),q.onDidRemoveConnection(We,void 0,ne),ye.event(fe.fire,fe,ne),ne.add(ye)},onLastListenerRemove:()=>{ne.dispose()}});return fe.event}registerChannel(N,j){this.channels.set(N,j),this._connections.forEach(H=>{H.channelServer.registerChannel(N,j)})}dispose(){this.channels.clear(),this._connections.clear(),this._onDidAddConnection.dispose(),this._onDidRemoveConnection.dispose()}}e.IPCServer=b;class T{constructor(N,j,H=null){const V=new s;o(V,j),N.send(V.buffer),this.channelClient=new l(N,H),this.channelServer=new c(N,j,H)}getChannel(N){return this.channelClient.getChannel(N)}registerChannel(N,j){this.channelServer.registerChannel(N,j)}dispose(){this.channelClient.dispose(),this.channelServer.dispose()}}e.IPCClient=T;function A(K){return{call(N,j,H){return K.then(V=>V.call(N,j,H))},listen(N,j){const H=new S.Relay;return K.then(V=>H.input=V.listen(N,j)),H.event}}}e.getDelayedChannel=A;function x(K){let N=!1;return{call(j,H,V){return N?K.call(j,H,V):(0,L.timeout)(0).then(()=>N=!0).then(()=>K.call(j,H,V))},listen(j,H){if(N)return K.listen(j,H);const V=new S.Relay;return(0,L.timeout)(0).then(()=>N=!0).then(()=>V.input=K.listen(j,H)),V.event}}}e.getNextTickChannel=x;class O{constructor(N){this.fn=N}routeCall(N){return this.route(N)}routeEvent(N){return this.route(N)}async route(N){for(const j of N.connections)if(await Promise.resolve(this.fn(j.ctx)))return Promise.resolve(j);return await S.Event.toPromise(N.onDidAddConnection),await this.route(N)}}e.StaticRouter=O;var F;(function(K){function N(q,ne){const fe=q,ye=ne&&ne.disableMarshalling,ke=new Map;for(const Be in fe)H(Be)&&ke.set(Be,S.Event.buffer(fe[Be],!0));return new class{listen(Be,We,ze){const Q=ke.get(We);if(Q)return Q;if(V(We)){const ee=fe[We];if(typeof ee=="function")return ee.call(fe,ze)}throw new Error(`Event not found: ${We}`)}call(Be,We,ze){const Q=fe[We];if(typeof Q=="function"){if(!ye&&Array.isArray(ze))for(let ee=0;ee<ze.length;ee++)ze[ee]=(0,R.revive)(ze[ee]);return Q.apply(fe,ze)}throw new Error(`Method not found: ${We}`)}}}K.fromService=N;function j(q,ne){const fe=ne&&ne.disableMarshalling;return new Proxy({},{get(ye,ke){if(typeof ke=="string")return ne?.properties?.has(ke)?ne.properties.get(ke):V(ke)?function(Be){return q.listen(ke,Be)}:H(ke)?q.listen(ke):async function(...Be){let We;ne&&!(0,u.isUndefinedOrNull)(ne.context)?We=[ne.context,...Be]:We=Be;const ze=await q.call(ke,We);return fe?ze:(0,R.revive)(ze)};throw new Error(`Property not found: ${String(ke)}`)}})}K.toService=j;function H(q){return q[0]==="o"&&q[1]==="n"&&P.isUpperAsciiLetter(q.charCodeAt(2))}function V(q){return/^onDynamic/.test(q)&&P.isUpperAsciiLetter(q.charCodeAt(9))}})(F=e.ProxyChannel||(e.ProxyChannel={}));const W=[["#2977B1","#FC802D","#34A13A","#D3282F","#9366BA"],["#8B564C","#E177C0","#7F7F7F","#BBBE3D","#2EBECD"]];function M(K){if(Array.isArray(K))return K;if(K&&typeof K=="object"&&typeof K.toString=="function"){let N=K.toString();if(N!=="[object Object]")return N}return K}function B(K){return Array.isArray(K)?K.map(M):M(K)}function U(K,N,j,H,V,q,ne){ne=B(ne);const fe=W[V],ye=fe[H%fe.length];let ke=[`%c[${K}]%c[${String(N).padStart(7," ")}]%c[len: ${String(j).padStart(5," ")}]%c${String(H).padStart(5," ")} - ${q}`,"color: darkgreen","color: grey","color: grey",`color: ${ye}`];/\($/.test(q)?(ke=ke.concat(ne),ke.push(")")):ke.push(ne),console.log.apply(console,ke)}e.logWithColors=U;class z{constructor(N,j){this._outgoingPrefix=N,this._incomingPrefix=j,this._totalIncoming=0,this._totalOutgoing=0}logOutgoing(N,j,H,V,q){this._totalOutgoing+=N,U(this._outgoingPrefix,this._totalOutgoing,N,j,H,V,q)}logIncoming(N,j,H,V,q){this._totalIncoming+=N,U(this._incomingPrefix,this._totalIncoming,N,j,H,V,q)}}e.IPCLogger=z}),define(pe[106],ve([0,1,22,3,6,105]),function(Y,e,m,L,y,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PersistentProtocol=e.BufferedEmitter=e.Client=e.Protocol=e.ProtocolConstants=e.ChunkStream=e.SocketCloseEventType=e.SocketDiagnostics=e.SocketDiagnosticsEventType=void 0;var i;(function(t){t.Created="created",t.Read="read",t.Write="write",t.Open="open",t.Error="error",t.Close="close",t.BrowserWebSocketBlobReceived="browserWebSocketBlobReceived",t.NodeEndReceived="nodeEndReceived",t.NodeEndSent="nodeEndSent",t.NodeDrainBegin="nodeDrainBegin",t.NodeDrainEnd="nodeDrainEnd",t.zlibInflateError="zlibInflateError",t.zlibInflateData="zlibInflateData",t.zlibInflateInitialWrite="zlibInflateInitialWrite",t.zlibInflateInitialFlushFired="zlibInflateInitialFlushFired",t.zlibInflateWrite="zlibInflateWrite",t.zlibInflateFlushFired="zlibInflateFlushFired",t.zlibDeflateError="zlibDeflateError",t.zlibDeflateData="zlibDeflateData",t.zlibDeflateWrite="zlibDeflateWrite",t.zlibDeflateFlushFired="zlibDeflateFlushFired",t.WebSocketNodeSocketWrite="webSocketNodeSocketWrite",t.WebSocketNodeSocketPeekedHeader="webSocketNodeSocketPeekedHeader",t.WebSocketNodeSocketReadHeader="webSocketNodeSocketReadHeader",t.WebSocketNodeSocketReadData="webSocketNodeSocketReadData",t.WebSocketNodeSocketUnmaskedData="webSocketNodeSocketUnmaskedData",t.WebSocketNodeSocketDrainBegin="webSocketNodeSocketDrainBegin",t.WebSocketNodeSocketDrainEnd="webSocketNodeSocketDrainEnd",t.ProtocolHeaderRead="protocolHeaderRead",t.ProtocolMessageRead="protocolMessageRead",t.ProtocolHeaderWrite="protocolHeaderWrite",t.ProtocolMessageWrite="protocolMessageWrite",t.ProtocolWrite="protocolWrite"})(i=e.SocketDiagnosticsEventType||(e.SocketDiagnosticsEventType={}));var k;(function(t){t.enableDiagnostics=!1,t.records=[];const o=new WeakMap;let d=0;function c(l,b){if(!o.has(l)){const T=String(++d);o.set(l,T)}return o.get(l)}function h(l,b,T,A){if(!t.enableDiagnostics)return;const x=c(l,b);if(A instanceof m.VSBuffer||A instanceof Uint8Array||A instanceof ArrayBuffer||ArrayBuffer.isView(A)){const O=m.VSBuffer.alloc(A.byteLength);O.set(A),t.records.push({timestamp:Date.now(),id:x,label:b,type:T,buff:O})}else t.records.push({timestamp:Date.now(),id:x,label:b,type:T,data:A})}t.traceSocketEvent=h})(k=e.SocketDiagnostics||(e.SocketDiagnostics={}));var S;(function(t){t[t.NodeSocketCloseEvent=0]="NodeSocketCloseEvent",t[t.WebSocketCloseEvent=1]="WebSocketCloseEvent"})(S=e.SocketCloseEventType||(e.SocketCloseEventType={}));let D=null;function R(){return D||(D=m.VSBuffer.alloc(0)),D}class P{constructor(){this._chunks=[],this._totalLength=0}get byteLength(){return this._totalLength}acceptChunk(o){this._chunks.push(o),this._totalLength+=o.byteLength}read(o){return this._read(o,!0)}peek(o){return this._read(o,!1)}_read(o,d){if(o===0)return R();if(o>this._totalLength)throw new Error("Cannot read so many bytes!");if(this._chunks[0].byteLength===o){const b=this._chunks[0];return d&&(this._chunks.shift(),this._totalLength-=o),b}if(this._chunks[0].byteLength>o){const b=this._chunks[0].slice(0,o);return d&&(this._chunks[0]=this._chunks[0].slice(o),this._totalLength-=o),b}let c=m.VSBuffer.alloc(o),h=0,l=0;for(;o>0;){const b=this._chunks[l];if(b.byteLength>o){const T=b.slice(0,o);c.set(T,h),h+=o,d&&(this._chunks[l]=b.slice(o),this._totalLength-=o),o-=o}else c.set(b,h),h+=b.byteLength,d?(this._chunks.shift(),this._totalLength-=b.byteLength):l++,o-=b.byteLength}return c}}e.ChunkStream=P;var u;(function(t){t[t.None=0]="None",t[t.Regular=1]="Regular",t[t.Control=2]="Control",t[t.Ack=3]="Ack",t[t.Disconnect=5]="Disconnect",t[t.ReplayRequest=6]="ReplayRequest",t[t.Pause=7]="Pause",t[t.Resume=8]="Resume"})(u||(u={}));function E(t){switch(t){case 0:return"None";case 1:return"Regular";case 2:return"Control";case 3:return"Ack";case 5:return"Disconnect";case 6:return"ReplayRequest";case 7:return"PauseWriting";case 8:return"ResumeWriting"}}var f;(function(t){t[t.HeaderLength=13]="HeaderLength",t[t.AcknowledgeTime=2e3]="AcknowledgeTime",t[t.TimeoutTime=2e4]="TimeoutTime",t[t.ReconnectionGraceTime=108e5]="ReconnectionGraceTime",t[t.ReconnectionShortGraceTime=3e5]="ReconnectionShortGraceTime"})(f=e.ProtocolConstants||(e.ProtocolConstants={}));class v{constructor(o,d,c,h){this.type=o,this.id=d,this.ack=c,this.data=h,this.writtenTime=0}get size(){return this.data.byteLength}}class w extends y.Disposable{constructor(o){super();this._onMessage=this._register(new L.Emitter),this.onMessage=this._onMessage.event,this._state={readHead:!0,readLen:13,messageType:0,id:0,ack:0},this._socket=o,this._isDisposed=!1,this._incomingData=new P,this._register(this._socket.onData(d=>this.acceptChunk(d))),this.lastReadTime=Date.now()}acceptChunk(o){if(!(!o||o.byteLength===0))for(this.lastReadTime=Date.now(),this._incomingData.acceptChunk(o);this._incomingData.byteLength>=this._state.readLen;){const d=this._incomingData.read(this._state.readLen);if(this._state.readHead)this._state.readHead=!1,this._state.readLen=d.readUInt32BE(9),this._state.messageType=d.readUInt8(0),this._state.id=d.readUInt32BE(1),this._state.ack=d.readUInt32BE(5),this._socket.traceSocketEvent("protocolHeaderRead",{messageType:E(this._state.messageType),id:this._state.id,ack:this._state.ack,messageSize:this._state.readLen});else{const c=this._state.messageType,h=this._state.id,l=this._state.ack;if(this._state.readHead=!0,this._state.readLen=13,this._state.messageType=0,this._state.id=0,this._state.ack=0,this._socket.traceSocketEvent("protocolMessageRead",d),this._onMessage.fire(new v(c,h,l,d)),this._isDisposed)break}}}readEntireBuffer(){return this._incomingData.read(this._incomingData.byteLength)}dispose(){this._isDisposed=!0,super.dispose()}}class I{constructor(o){this._writeNowTimeout=null,this._isDisposed=!1,this._isPaused=!1,this._socket=o,this._data=[],this._totalLength=0,this.lastWriteTime=0}dispose(){try{this.flush()}catch(o){}this._isDisposed=!0}drain(){return this.flush(),this._socket.drain()}flush(){this._writeNow()}pause(){this._isPaused=!0}resume(){this._isPaused=!1,this._scheduleWriting()}write(o){if(this._isDisposed)return;o.writtenTime=Date.now(),this.lastWriteTime=Date.now();const d=m.VSBuffer.alloc(13);d.writeUInt8(o.type,0),d.writeUInt32BE(o.id,1),d.writeUInt32BE(o.ack,5),d.writeUInt32BE(o.data.byteLength,9),this._socket.traceSocketEvent("protocolHeaderWrite",{messageType:E(o.type),id:o.id,ack:o.ack,messageSize:o.data.byteLength}),this._socket.traceSocketEvent("protocolMessageWrite",o.data),this._writeSoon(d,o.data)}_bufferAdd(o,d){const c=this._totalLength===0;return this._data.push(o,d),this._totalLength+=o.byteLength+d.byteLength,c}_bufferTake(){const o=m.VSBuffer.concat(this._data,this._totalLength);return this._data.length=0,this._totalLength=0,o}_writeSoon(o,d){this._bufferAdd(o,d)&&this._scheduleWriting()}_scheduleWriting(){this._writeNowTimeout||(this._writeNowTimeout=setTimeout(()=>{this._writeNowTimeout=null,this._writeNow()}))}_writeNow(){if(this._totalLength===0||this._isPaused)return;const o=this._bufferTake();this._socket.traceSocketEvent("protocolWrite",{byteLength:o.byteLength}),this._socket.write(o)}}class p extends y.Disposable{constructor(o){super();this._onMessage=new L.Emitter,this.onMessage=this._onMessage.event,this._onDidDispose=new L.Emitter,this.onDidDispose=this._onDidDispose.event,this._socket=o,this._socketWriter=this._register(new I(this._socket)),this._socketReader=this._register(new w(this._socket)),this._register(this._socketReader.onMessage(d=>{d.type===1&&this._onMessage.fire(d.data)})),this._register(this._socket.onClose(()=>this._onDidDispose.fire()))}drain(){return this._socketWriter.drain()}getSocket(){return this._socket}sendDisconnect(){}send(o){this._socketWriter.write(new v(1,0,0,o))}}e.Protocol=p;class s extends C.IPCClient{constructor(o,d,c=null){super(o,d,c);this.protocol=o}static fromSocket(o,d){return new s(new p(o),d)}get onDidDispose(){return this.protocol.onDidDispose}dispose(){super.dispose();const o=this.protocol.getSocket();this.protocol.sendDisconnect(),this.protocol.dispose(),o.end()}}e.Client=s;class r{constructor(){this._hasListeners=!1,this._isDeliveringMessages=!1,this._bufferedMessages=[],this._emitter=new L.Emitter({onFirstListenerAdd:()=>{this._hasListeners=!0,queueMicrotask(()=>this._deliverMessages())},onLastListenerRemove:()=>{this._hasListeners=!1}}),this.event=this._emitter.event}_deliverMessages(){if(!this._isDeliveringMessages){for(this._isDeliveringMessages=!0;this._hasListeners&&this._bufferedMessages.length>0;)this._emitter.fire(this._bufferedMessages.shift());this._isDeliveringMessages=!1}}fire(o){this._hasListeners?this._bufferedMessages.length>0?this._bufferedMessages.push(o):this._emitter.fire(o):this._bufferedMessages.push(o)}flushBuffer(){this._bufferedMessages=[]}}e.BufferedEmitter=r;class g{constructor(o){this.data=o,this.next=null}}class a{constructor(){this._first=null,this._last=null}peek(){return this._first?this._first.data:null}toArray(){let o=[],d=0,c=this._first;for(;c;)o[d++]=c.data,c=c.next;return o}pop(){if(!!this._first){if(this._first===this._last){this._first=null,this._last=null;return}this._first=this._first.next}}push(o){const d=new g(o);if(!this._first){this._first=d,this._last=d;return}this._last.next=d,this._last=d}}class _{constructor(){this.lastRuns=[];const o=Date.now();for(let d=0;d<_._HISTORY_LENGTH;d++)this.lastRuns[d]=o-1e3*d;setInterval(()=>{for(let d=_._HISTORY_LENGTH;d>=1;d--)this.lastRuns[d]=this.lastRuns[d-1];this.lastRuns[0]=Date.now()},1e3)}static getInstance(){return _._INSTANCE||(_._INSTANCE=new _),_._INSTANCE}load(){const o=Date.now(),d=(1+_._HISTORY_LENGTH)*1e3;let c=0;for(let h=0;h<_._HISTORY_LENGTH;h++)o-this.lastRuns[h]<=d&&c++;return 1-c/_._HISTORY_LENGTH}hasHighLoad(){return this.load()>=.5}}_._HISTORY_LENGTH=10,_._INSTANCE=null;class n{constructor(o,d=null,c=_.getInstance()){this._onControlMessage=new r,this.onControlMessage=this._onControlMessage.event,this._onMessage=new r,this.onMessage=this._onMessage.event,this._onDidDispose=new r,this.onDidDispose=this._onDidDispose.event,this._onSocketClose=new r,this.onSocketClose=this._onSocketClose.event,this._onSocketTimeout=new r,this.onSocketTimeout=this._onSocketTimeout.event,this._loadEstimator=c,this._isReconnecting=!1,this._outgoingUnackMsg=new a,this._outgoingMsgId=0,this._outgoingAckId=0,this._outgoingAckTimeout=null,this._incomingMsgId=0,this._incomingAckId=0,this._incomingMsgLastTime=0,this._incomingAckTimeout=null,this._lastReplayRequestTime=0,this._lastSocketTimeoutTime=Date.now(),this._socketDisposables=[],this._socket=o,this._socketWriter=new I(this._socket),this._socketDisposables.push(this._socketWriter),this._socketReader=new w(this._socket),this._socketDisposables.push(this._socketReader),this._socketDisposables.push(this._socketReader.onMessage(h=>this._receiveMessage(h))),this._socketDisposables.push(this._socket.onClose(h=>this._onSocketClose.fire(h))),d&&this._socketReader.acceptChunk(d)}get unacknowledgedCount(){return this._outgoingMsgId-this._outgoingAckId}dispose(){this._outgoingAckTimeout&&(clearTimeout(this._outgoingAckTimeout),this._outgoingAckTimeout=null),this._incomingAckTimeout&&(clearTimeout(this._incomingAckTimeout),this._incomingAckTimeout=null),this._socketDisposables=(0,y.dispose)(this._socketDisposables)}drain(){return this._socketWriter.drain()}sendDisconnect(){const o=new v(5,0,0,R());this._socketWriter.write(o),this._socketWriter.flush()}sendPause(){const o=new v(7,0,0,R());this._socketWriter.write(o)}sendResume(){const o=new v(8,0,0,R());this._socketWriter.write(o)}pauseSocketWriting(){this._socketWriter.pause()}getSocket(){return this._socket}getMillisSinceLastIncomingData(){return Date.now()-this._socketReader.lastReadTime}beginAcceptReconnection(o,d){this._isReconnecting=!0,this._socketDisposables=(0,y.dispose)(this._socketDisposables),this._onControlMessage.flushBuffer(),this._onSocketClose.flushBuffer(),this._onSocketTimeout.flushBuffer(),this._socket.dispose(),this._lastReplayRequestTime=0,this._lastSocketTimeoutTime=Date.now(),this._socket=o,this._socketWriter=new I(this._socket),this._socketDisposables.push(this._socketWriter),this._socketReader=new w(this._socket),this._socketDisposables.push(this._socketReader),this._socketDisposables.push(this._socketReader.onMessage(c=>this._receiveMessage(c))),this._socketDisposables.push(this._socket.onClose(c=>this._onSocketClose.fire(c))),this._socketReader.acceptChunk(d)}endAcceptReconnection(){this._isReconnecting=!1,this._incomingAckId=this._incomingMsgId;const o=new v(3,0,this._incomingAckId,R());this._socketWriter.write(o);const d=this._outgoingUnackMsg.toArray();for(let c=0,h=d.length;c<h;c++)this._socketWriter.write(d[c]);this._recvAckCheck()}acceptDisconnect(){this._onDidDispose.fire()}_receiveMessage(o){if(o.ack>this._outgoingAckId){this._outgoingAckId=o.ack;do{const d=this._outgoingUnackMsg.peek();if(d&&d.id<=o.ack)this._outgoingUnackMsg.pop();else break}while(!0)}switch(o.type){case 0:break;case 1:{if(o.id>this._incomingMsgId)if(o.id!==this._incomingMsgId+1){const d=Date.now();d-this._lastReplayRequestTime>1e4&&(this._lastReplayRequestTime=d,this._socketWriter.write(new v(6,0,0,R())))}else this._incomingMsgId=o.id,this._incomingMsgLastTime=Date.now(),this._sendAckCheck(),this._onMessage.fire(o.data);break}case 2:{this._onControlMessage.fire(o.data);break}case 3:break;case 5:{this._onDidDispose.fire();break}case 6:{const d=this._outgoingUnackMsg.toArray();for(let c=0,h=d.length;c<h;c++)this._socketWriter.write(d[c]);this._recvAckCheck();break}case 7:{this._socketWriter.pause();break}case 8:{this._socketWriter.resume();break}}}readEntireBuffer(){return this._socketReader.readEntireBuffer()}flush(){this._socketWriter.flush()}send(o){const d=++this._outgoingMsgId;this._incomingAckId=this._incomingMsgId;const c=new v(1,d,this._incomingAckId,o);this._outgoingUnackMsg.push(c),this._isReconnecting||(this._socketWriter.write(c),this._recvAckCheck())}sendControl(o){const d=new v(2,0,0,o);this._socketWriter.write(d)}_sendAckCheck(){if(this._incomingMsgId<=this._incomingAckId||this._incomingAckTimeout)return;const o=Date.now()-this._incomingMsgLastTime;if(o>=2e3){this._sendAck();return}this._incomingAckTimeout=setTimeout(()=>{this._incomingAckTimeout=null,this._sendAckCheck()},2e3-o+5)}_recvAckCheck(){if(this._outgoingMsgId<=this._outgoingAckId||this._outgoingAckTimeout||this._isReconnecting)return;const o=this._outgoingUnackMsg.peek(),d=Date.now()-o.writtenTime,c=Date.now()-this._socketReader.lastReadTime,h=Date.now()-this._lastSocketTimeoutTime;if(d>=2e4&&c>=2e4&&h>=2e4&&!this._loadEstimator.hasHighLoad()){this._lastSocketTimeoutTime=Date.now(),this._onSocketTimeout.fire(void 0);return}const l=Math.max(2e4-d,2e4-c,2e4-h,500);this._outgoingAckTimeout=setTimeout(()=>{this._outgoingAckTimeout=null,this._recvAckCheck()},l)}_sendAck(){if(this._incomingMsgId<=this._incomingAckId)return;this._incomingAckId=this._incomingMsgId;const o=new v(3,0,this._incomingAckId,R());this._socketWriter.write(o)}}e.PersistentProtocol=n}),define(pe[107],ve([0,1,98]),function(Y,e,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CharacterSet=e.CharacterClassifier=void 0;class L{constructor(k){let S=(0,m.toUint8)(k);this._defaultValue=S,this._asciiMap=L._createAsciiMap(S),this._map=new Map}static _createAsciiMap(k){let S=new Uint8Array(256);for(let D=0;D<256;D++)S[D]=k;return S}set(k,S){let D=(0,m.toUint8)(S);k>=0&&k<256?this._asciiMap[k]=D:this._map.set(k,D)}get(k){return k>=0&&k<256?this._asciiMap[k]:this._map.get(k)||this._defaultValue}}e.CharacterClassifier=L;var y;(function(i){i[i.False=0]="False",i[i.True=1]="True"})(y||(y={}));class C{constructor(){this._actual=new L(0)}add(k){this._actual.set(k,1)}has(k){return this._actual.get(k)===1}}e.CharacterSet=C}),define(pe[143],ve([0,1,107]),function(Y,e,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getMapForWordSeparators=e.WordCharacterClassifier=e.WordCharacterClass=void 0;var L;(function(i){i[i.Regular=0]="Regular",i[i.Whitespace=1]="Whitespace",i[i.WordSeparator=2]="WordSeparator"})(L=e.WordCharacterClass||(e.WordCharacterClass={}));class y extends m.CharacterClassifier{constructor(k){super(0);for(let S=0,D=k.length;S<D;S++)this.set(k.charCodeAt(S),2);this.set(32,1),this.set(9,1)}}e.WordCharacterClassifier=y;function C(i){let k={};return S=>(k.hasOwnProperty(S)||(k[S]=i(S)),k[S])}e.getMapForWordSeparators=C(i=>new y(i))}),define(pe[49],ve([0,1]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Position=void 0;class m{constructor(y,C){this.lineNumber=y,this.column=C}with(y=this.lineNumber,C=this.column){return y===this.lineNumber&&C===this.column?this:new m(y,C)}delta(y=0,C=0){return this.with(this.lineNumber+y,this.column+C)}equals(y){return m.equals(this,y)}static equals(y,C){return!y&&!C?!0:!!y&&!!C&&y.lineNumber===C.lineNumber&&y.column===C.column}isBefore(y){return m.isBefore(this,y)}static isBefore(y,C){return y.lineNumber<C.lineNumber?!0:C.lineNumber<y.lineNumber?!1:y.column<C.column}isBeforeOrEqual(y){return m.isBeforeOrEqual(this,y)}static isBeforeOrEqual(y,C){return y.lineNumber<C.lineNumber?!0:C.lineNumber<y.lineNumber?!1:y.column<=C.column}static compare(y,C){let i=y.lineNumber|0,k=C.lineNumber|0;if(i===k){let S=y.column|0,D=C.column|0;return S-D}return i-k}clone(){return new m(this.lineNumber,this.column)}toString(){return"("+this.lineNumber+","+this.column+")"}static lift(y){return new m(y.lineNumber,y.column)}static isIPosition(y){return y&&typeof y.lineNumber=="number"&&typeof y.column=="number"}}e.Position=m}),define(pe[41],ve([0,1,49]),function(Y,e,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Range=void 0;class L{constructor(C,i,k,S){C>k||C===k&&i>S?(this.startLineNumber=k,this.startColumn=S,this.endLineNumber=C,this.endColumn=i):(this.startLineNumber=C,this.startColumn=i,this.endLineNumber=k,this.endColumn=S)}isEmpty(){return L.isEmpty(this)}static isEmpty(C){return C.startLineNumber===C.endLineNumber&&C.startColumn===C.endColumn}containsPosition(C){return L.containsPosition(this,C)}static containsPosition(C,i){return!(i.lineNumber<C.startLineNumber||i.lineNumber>C.endLineNumber||i.lineNumber===C.startLineNumber&&i.column<C.startColumn||i.lineNumber===C.endLineNumber&&i.column>C.endColumn)}static strictContainsPosition(C,i){return!(i.lineNumber<C.startLineNumber||i.lineNumber>C.endLineNumber||i.lineNumber===C.startLineNumber&&i.column<=C.startColumn||i.lineNumber===C.endLineNumber&&i.column>=C.endColumn)}containsRange(C){return L.containsRange(this,C)}static containsRange(C,i){return!(i.startLineNumber<C.startLineNumber||i.endLineNumber<C.startLineNumber||i.startLineNumber>C.endLineNumber||i.endLineNumber>C.endLineNumber||i.startLineNumber===C.startLineNumber&&i.startColumn<C.startColumn||i.endLineNumber===C.endLineNumber&&i.endColumn>C.endColumn)}strictContainsRange(C){return L.strictContainsRange(this,C)}static strictContainsRange(C,i){return!(i.startLineNumber<C.startLineNumber||i.endLineNumber<C.startLineNumber||i.startLineNumber>C.endLineNumber||i.endLineNumber>C.endLineNumber||i.startLineNumber===C.startLineNumber&&i.startColumn<=C.startColumn||i.endLineNumber===C.endLineNumber&&i.endColumn>=C.endColumn)}plusRange(C){return L.plusRange(this,C)}static plusRange(C,i){let k,S,D,R;return i.startLineNumber<C.startLineNumber?(k=i.startLineNumber,S=i.startColumn):i.startLineNumber===C.startLineNumber?(k=i.startLineNumber,S=Math.min(i.startColumn,C.startColumn)):(k=C.startLineNumber,S=C.startColumn),i.endLineNumber>C.endLineNumber?(D=i.endLineNumber,R=i.endColumn):i.endLineNumber===C.endLineNumber?(D=i.endLineNumber,R=Math.max(i.endColumn,C.endColumn)):(D=C.endLineNumber,R=C.endColumn),new L(k,S,D,R)}intersectRanges(C){return L.intersectRanges(this,C)}static intersectRanges(C,i){let k=C.startLineNumber,S=C.startColumn,D=C.endLineNumber,R=C.endColumn,P=i.startLineNumber,u=i.startColumn,E=i.endLineNumber,f=i.endColumn;return k<P?(k=P,S=u):k===P&&(S=Math.max(S,u)),D>E?(D=E,R=f):D===E&&(R=Math.min(R,f)),k>D||k===D&&S>R?null:new L(k,S,D,R)}equalsRange(C){return L.equalsRange(this,C)}static equalsRange(C,i){return!!C&&!!i&&C.startLineNumber===i.startLineNumber&&C.startColumn===i.startColumn&&C.endLineNumber===i.endLineNumber&&C.endColumn===i.endColumn}getEndPosition(){return L.getEndPosition(this)}static getEndPosition(C){return new m.Position(C.endLineNumber,C.endColumn)}getStartPosition(){return L.getStartPosition(this)}static getStartPosition(C){return new m.Position(C.startLineNumber,C.startColumn)}toString(){return"["+this.startLineNumber+","+this.startColumn+" -> "+this.endLineNumber+","+this.endColumn+"]"}setEndPosition(C,i){return new L(this.startLineNumber,this.startColumn,C,i)}setStartPosition(C,i){return new L(C,i,this.endLineNumber,this.endColumn)}collapseToStart(){return L.collapseToStart(this)}static collapseToStart(C){return new L(C.startLineNumber,C.startColumn,C.startLineNumber,C.startColumn)}static fromPositions(C,i=C){return new L(C.lineNumber,C.column,i.lineNumber,i.column)}static lift(C){return C?new L(C.startLineNumber,C.startColumn,C.endLineNumber,C.endColumn):null}static isIRange(C){return C&&typeof C.startLineNumber=="number"&&typeof C.startColumn=="number"&&typeof C.endLineNumber=="number"&&typeof C.endColumn=="number"}static areIntersectingOrTouching(C,i){return!(C.endLineNumber<i.startLineNumber||C.endLineNumber===i.startLineNumber&&C.endColumn<i.startColumn||i.endLineNumber<C.startLineNumber||i.endLineNumber===C.startLineNumber&&i.endColumn<C.startColumn)}static areIntersecting(C,i){return!(C.endLineNumber<i.startLineNumber||C.endLineNumber===i.startLineNumber&&C.endColumn<=i.startColumn||i.endLineNumber<C.startLineNumber||i.endLineNumber===C.startLineNumber&&i.endColumn<=C.startColumn)}static compareRangesUsingStarts(C,i){if(C&&i){const D=C.startLineNumber|0,R=i.startLineNumber|0;if(D===R){const P=C.startColumn|0,u=i.startColumn|0;if(P===u){const E=C.endLineNumber|0,f=i.endLineNumber|0;if(E===f){const v=C.endColumn|0,w=i.endColumn|0;return v-w}return E-f}return P-u}return D-R}return(C?1:0)-(i?1:0)}static compareRangesUsingEnds(C,i){return C.endLineNumber===i.endLineNumber?C.endColumn===i.endColumn?C.startLineNumber===i.startLineNumber?C.startColumn-i.startColumn:C.startLineNumber-i.startLineNumber:C.endColumn-i.endColumn:C.endLineNumber-i.endLineNumber}static spansMultipleLines(C){return C.endLineNumber>C.startLineNumber}}e.Range=L}),define(pe[144],ve([0,1,49,41]),function(Y,e,m,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Selection=e.SelectionDirection=void 0;var y;(function(i){i[i.LTR=0]="LTR",i[i.RTL=1]="RTL"})(y=e.SelectionDirection||(e.SelectionDirection={}));class C extends L.Range{constructor(k,S,D,R){super(k,S,D,R);this.selectionStartLineNumber=k,this.selectionStartColumn=S,this.positionLineNumber=D,this.positionColumn=R}toString(){return"["+this.selectionStartLineNumber+","+this.selectionStartColumn+" -> "+this.positionLineNumber+","+this.positionColumn+"]"}equalsSelection(k){return C.selectionsEqual(this,k)}static selectionsEqual(k,S){return k.selectionStartLineNumber===S.selectionStartLineNumber&&k.selectionStartColumn===S.selectionStartColumn&&k.positionLineNumber===S.positionLineNumber&&k.positionColumn===S.positionColumn}getDirection(){return this.selectionStartLineNumber===this.startLineNumber&&this.selectionStartColumn===this.startColumn?0:1}setEndPosition(k,S){return this.getDirection()===0?new C(this.startLineNumber,this.startColumn,k,S):new C(k,S,this.startLineNumber,this.startColumn)}getPosition(){return new m.Position(this.positionLineNumber,this.positionColumn)}getSelectionStart(){return new m.Position(this.selectionStartLineNumber,this.selectionStartColumn)}setStartPosition(k,S){return this.getDirection()===0?new C(k,S,this.endLineNumber,this.endColumn):new C(this.endLineNumber,this.endColumn,k,S)}static fromPositions(k,S=k){return new C(k.lineNumber,k.column,S.lineNumber,S.column)}static fromRange(k,S){return S===0?new C(k.startLineNumber,k.startColumn,k.endLineNumber,k.endColumn):new C(k.endLineNumber,k.endColumn,k.startLineNumber,k.startColumn)}static liftSelection(k){return new C(k.selectionStartLineNumber,k.selectionStartColumn,k.positionLineNumber,k.positionColumn)}static selectionsArrEqual(k,S){if(k&&!S||!k&&S)return!1;if(!k&&!S)return!0;if(k.length!==S.length)return!1;for(let D=0,R=k.length;D<R;D++)if(!this.selectionsEqual(k[D],S[D]))return!1;return!0}static isISelection(k){return k&&typeof k.selectionStartLineNumber=="number"&&typeof k.selectionStartColumn=="number"&&typeof k.positionLineNumber=="number"&&typeof k.positionColumn=="number"}static createWithDirection(k,S,D,R,P){return P===0?new C(k,S,D,R):new C(D,R,k,S)}}e.Selection=C}),define(pe[108],ve([0,1,25]),function(Y,e,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ApplyEditsResult=e.ValidAnnotatedEditOperation=e.ModelConstants=e.PositionAffinity=e.IndentGuideHorizontalLine=e.IndentGuide=e.HorizontalGuidesState=e.TrackedRangeStickiness=e.FindMatch=e.TextModelResolvedOptions=e.EndOfLineSequence=e.DefaultEndOfLine=e.EndOfLinePreference=e.MinimapPosition=e.OverviewRulerLane=void 0;var L;(function(p){p[p.Left=1]="Left",p[p.Center=2]="Center",p[p.Right=4]="Right",p[p.Full=7]="Full"})(L=e.OverviewRulerLane||(e.OverviewRulerLane={}));var y;(function(p){p[p.Inline=1]="Inline",p[p.Gutter=2]="Gutter"})(y=e.MinimapPosition||(e.MinimapPosition={}));var C;(function(p){p[p.TextDefined=0]="TextDefined",p[p.LF=1]="LF",p[p.CRLF=2]="CRLF"})(C=e.EndOfLinePreference||(e.EndOfLinePreference={}));var i;(function(p){p[p.LF=1]="LF",p[p.CRLF=2]="CRLF"})(i=e.DefaultEndOfLine||(e.DefaultEndOfLine={}));var k;(function(p){p[p.LF=0]="LF",p[p.CRLF=1]="CRLF"})(k=e.EndOfLineSequence||(e.EndOfLineSequence={}));class S{constructor(s){this._textModelResolvedOptionsBrand=void 0,this.tabSize=Math.max(1,s.tabSize|0),this.indentSize=s.tabSize|0,this.insertSpaces=Boolean(s.insertSpaces),this.defaultEOL=s.defaultEOL|0,this.trimAutoWhitespace=Boolean(s.trimAutoWhitespace),this.bracketPairColorizationOptions=s.bracketPairColorizationOptions}equals(s){return this.tabSize===s.tabSize&&this.indentSize===s.indentSize&&this.insertSpaces===s.insertSpaces&&this.defaultEOL===s.defaultEOL&&this.trimAutoWhitespace===s.trimAutoWhitespace&&(0,m.equals)(this.bracketPairColorizationOptions,s.bracketPairColorizationOptions)}createChangeEvent(s){return{tabSize:this.tabSize!==s.tabSize,indentSize:this.indentSize!==s.indentSize,insertSpaces:this.insertSpaces!==s.insertSpaces,trimAutoWhitespace:this.trimAutoWhitespace!==s.trimAutoWhitespace}}}e.TextModelResolvedOptions=S;class D{constructor(s,r){this._findMatchBrand=void 0,this.range=s,this.matches=r}}e.FindMatch=D;var R;(function(p){p[p.AlwaysGrowsWhenTypingAtEdges=0]="AlwaysGrowsWhenTypingAtEdges",p[p.NeverGrowsWhenTypingAtEdges=1]="NeverGrowsWhenTypingAtEdges",p[p.GrowsOnlyWhenTypingBefore=2]="GrowsOnlyWhenTypingBefore",p[p.GrowsOnlyWhenTypingAfter=3]="GrowsOnlyWhenTypingAfter"})(R=e.TrackedRangeStickiness||(e.TrackedRangeStickiness={}));var P;(function(p){p[p.Disabled=0]="Disabled",p[p.EnabledForActive=1]="EnabledForActive",p[p.Enabled=2]="Enabled"})(P=e.HorizontalGuidesState||(e.HorizontalGuidesState={}));class u{constructor(s,r,g){this.visibleColumn=s,this.className=r,this.horizontalLine=g}}e.IndentGuide=u;class E{constructor(s,r){this.top=s,this.endColumn=r}}e.IndentGuideHorizontalLine=E;var f;(function(p){p[p.Left=0]="Left",p[p.Right=1]="Right",p[p.None=2]="None"})(f=e.PositionAffinity||(e.PositionAffinity={}));var v;(function(p){p[p.FIRST_LINE_DETECTION_LENGTH_LIMIT=1e3]="FIRST_LINE_DETECTION_LENGTH_LIMIT"})(v=e.ModelConstants||(e.ModelConstants={}));class w{constructor(s,r,g,a,_,n){this.identifier=s,this.range=r,this.text=g,this.forceMoveMarkers=a,this.isAutoWhitespaceEdit=_,this._isTracked=n}}e.ValidAnnotatedEditOperation=w;class I{constructor(s,r,g){this.reverseEdits=s,this.changes=r,this.trimAutoWhitespaceLineNumbers=g}}e.ApplyEditsResult=I}),define(pe[145],ve([0,1,8,143,49,41,108]),function(Y,e,m,L,y,C,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Searcher=e.isValidMatch=e.TextModelSearch=e.createFindMatch=e.SearchData=e.isMultilineRegexSource=e.SearchParams=void 0;const k=999;class S{constructor(s,r,g,a){this.searchString=s,this.isRegex=r,this.matchCase=g,this.wordSeparators=a}parseSearchRequest(){if(this.searchString==="")return null;let s;this.isRegex?s=D(this.searchString):s=this.searchString.indexOf(`
`)>=0;let r=null;try{r=m.createRegExp(this.searchString,this.isRegex,{matchCase:this.matchCase,wholeWord:!1,multiline:s,global:!0,unicode:!0})}catch(a){return null}if(!r)return null;let g=!this.isRegex&&!s;return g&&this.searchString.toLowerCase()!==this.searchString.toUpperCase()&&(g=this.matchCase),new R(r,this.wordSeparators?(0,L.getMapForWordSeparators)(this.wordSeparators):null,g?this.searchString:null)}}e.SearchParams=S;function D(p){if(!p||p.length===0)return!1;for(let s=0,r=p.length;s<r;s++)if(p.charCodeAt(s)===92){if(s++,s>=r)break;const a=p.charCodeAt(s);if(a===110||a===114||a===87)return!0}return!1}e.isMultilineRegexSource=D;class R{constructor(s,r,g){this.regex=s,this.wordSeparators=r,this.simpleSearch=g}}e.SearchData=R;function P(p,s,r){if(!r)return new i.FindMatch(p,null);let g=[];for(let a=0,_=s.length;a<_;a++)g[a]=s[a];return new i.FindMatch(p,g)}e.createFindMatch=P;class u{constructor(s){let r=[],g=0;for(let a=0,_=s.length;a<_;a++)s.charCodeAt(a)===10&&(r[g++]=a);this._lineFeedsOffsets=r}findLineFeedCountBeforeOffset(s){const r=this._lineFeedsOffsets;let g=0,a=r.length-1;if(a===-1||s<=r[0])return 0;for(;g<a;){const _=g+((a-g)/2>>0);r[_]>=s?a=_-1:r[_+1]>=s?(g=_,a=_):g=_+1}return g+1}}class E{static findMatches(s,r,g,a,_){const n=r.parseSearchRequest();return n?n.regex.multiline?this._doFindMatchesMultiline(s,g,new I(n.wordSeparators,n.regex),a,_):this._doFindMatchesLineByLine(s,g,n,a,_):[]}static _getMultilineMatchRange(s,r,g,a,_,n){let t,o=0;a?(o=a.findLineFeedCountBeforeOffset(_),t=r+_+o):t=r+_;let d;if(a){let b=a.findLineFeedCountBeforeOffset(_+n.length)-o;d=t+n.length+b}else d=t+n.length;const c=s.getPositionAt(t),h=s.getPositionAt(d);return new C.Range(c.lineNumber,c.column,h.lineNumber,h.column)}static _doFindMatchesMultiline(s,r,g,a,_){const n=s.getOffsetAt(r.getStartPosition()),t=s.getValueInRange(r,1),o=s.getEOL()===`\r
`?new u(t):null,d=[];let c=0,h;for(g.reset(0);h=g.next(t);)if(d[c++]=P(this._getMultilineMatchRange(s,n,t,o,h.index,h[0]),h,a),c>=_)return d;return d}static _doFindMatchesLineByLine(s,r,g,a,_){const n=[];let t=0;if(r.startLineNumber===r.endLineNumber){const d=s.getLineContent(r.startLineNumber).substring(r.startColumn-1,r.endColumn-1);return t=this._findMatchesInLine(g,d,r.startLineNumber,r.startColumn-1,t,n,a,_),n}const o=s.getLineContent(r.startLineNumber).substring(r.startColumn-1);t=this._findMatchesInLine(g,o,r.startLineNumber,r.startColumn-1,t,n,a,_);for(let d=r.startLineNumber+1;d<r.endLineNumber&&t<_;d++)t=this._findMatchesInLine(g,s.getLineContent(d),d,0,t,n,a,_);if(t<_){const d=s.getLineContent(r.endLineNumber).substring(0,r.endColumn-1);t=this._findMatchesInLine(g,d,r.endLineNumber,0,t,n,a,_)}return n}static _findMatchesInLine(s,r,g,a,_,n,t,o){const d=s.wordSeparators;if(!t&&s.simpleSearch){const l=s.simpleSearch,b=l.length,T=r.length;let A=-b;for(;(A=r.indexOf(l,A+b))!==-1;)if((!d||w(d,r,T,A,b))&&(n[_++]=new i.FindMatch(new C.Range(g,A+1+a,g,A+1+b+a),null),_>=o))return _;return _}const c=new I(s.wordSeparators,s.regex);let h;c.reset(0);do if(h=c.next(r),h&&(n[_++]=P(new C.Range(g,h.index+1+a,g,h.index+1+h[0].length+a),h,t),_>=o))return _;while(h);return _}static findNextMatch(s,r,g,a){const _=r.parseSearchRequest();if(!_)return null;const n=new I(_.wordSeparators,_.regex);return _.regex.multiline?this._doFindNextMatchMultiline(s,g,n,a):this._doFindNextMatchLineByLine(s,g,n,a)}static _doFindNextMatchMultiline(s,r,g,a){const _=new y.Position(r.lineNumber,1),n=s.getOffsetAt(_),t=s.getLineCount(),o=s.getValueInRange(new C.Range(_.lineNumber,_.column,t,s.getLineMaxColumn(t)),1),d=s.getEOL()===`\r
`?new u(o):null;g.reset(r.column-1);let c=g.next(o);return c?P(this._getMultilineMatchRange(s,n,o,d,c.index,c[0]),c,a):r.lineNumber!==1||r.column!==1?this._doFindNextMatchMultiline(s,new y.Position(1,1),g,a):null}static _doFindNextMatchLineByLine(s,r,g,a){const _=s.getLineCount(),n=r.lineNumber,t=s.getLineContent(n),o=this._findFirstMatchInLine(g,t,n,r.column,a);if(o)return o;for(let d=1;d<=_;d++){const c=(n+d-1)%_,h=s.getLineContent(c+1),l=this._findFirstMatchInLine(g,h,c+1,1,a);if(l)return l}return null}static _findFirstMatchInLine(s,r,g,a,_){s.reset(a-1);const n=s.next(r);return n?P(new C.Range(g,n.index+1,g,n.index+1+n[0].length),n,_):null}static findPreviousMatch(s,r,g,a){const _=r.parseSearchRequest();if(!_)return null;const n=new I(_.wordSeparators,_.regex);return _.regex.multiline?this._doFindPreviousMatchMultiline(s,g,n,a):this._doFindPreviousMatchLineByLine(s,g,n,a)}static _doFindPreviousMatchMultiline(s,r,g,a){const _=this._doFindMatchesMultiline(s,new C.Range(1,1,r.lineNumber,r.column),g,a,10*k);if(_.length>0)return _[_.length-1];const n=s.getLineCount();return r.lineNumber!==n||r.column!==s.getLineMaxColumn(n)?this._doFindPreviousMatchMultiline(s,new y.Position(n,s.getLineMaxColumn(n)),g,a):null}static _doFindPreviousMatchLineByLine(s,r,g,a){const _=s.getLineCount(),n=r.lineNumber,t=s.getLineContent(n).substring(0,r.column-1),o=this._findLastMatchInLine(g,t,n,a);if(o)return o;for(let d=1;d<=_;d++){const c=(_+n-d-1)%_,h=s.getLineContent(c+1),l=this._findLastMatchInLine(g,h,c+1,a);if(l)return l}return null}static _findLastMatchInLine(s,r,g,a){let _=null,n;for(s.reset(0);n=s.next(r);)_=P(new C.Range(g,n.index+1,g,n.index+1+n[0].length),n,a);return _}}e.TextModelSearch=E;function f(p,s,r,g,a){if(g===0)return!0;const _=s.charCodeAt(g-1);if(p.get(_)!==0||_===13||_===10)return!0;if(a>0){const n=s.charCodeAt(g);if(p.get(n)!==0)return!0}return!1}function v(p,s,r,g,a){if(g+a===r)return!0;const _=s.charCodeAt(g+a);if(p.get(_)!==0||_===13||_===10)return!0;if(a>0){const n=s.charCodeAt(g+a-1);if(p.get(n)!==0)return!0}return!1}function w(p,s,r,g,a){return f(p,s,r,g,a)&&v(p,s,r,g,a)}e.isValidMatch=w;class I{constructor(s,r){this._wordSeparators=s,this._searchRegex=r,this._prevMatchStartIndex=-1,this._prevMatchLength=0}reset(s){this._searchRegex.lastIndex=s,this._prevMatchStartIndex=-1,this._prevMatchLength=0}next(s){const r=s.length;let g;do{if(this._prevMatchStartIndex+this._prevMatchLength===r||(g=this._searchRegex.exec(s),!g))return null;const a=g.index,_=g[0].length;if(a===this._prevMatchStartIndex&&_===this._prevMatchLength){if(_===0){m.getNextCodePoint(s,r,this._searchRegex.lastIndex)>65535?this._searchRegex.lastIndex+=2:this._searchRegex.lastIndex+=1;continue}return null}if(this._prevMatchStartIndex=a,this._prevMatchLength=_,!this._wordSeparators||w(this._wordSeparators,s,r,a,_))return g}while(g);return null}}e.Searcher=I}),define(pe[109],ve([0,1]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getWordAtText=e.ensureValidWordDefinition=e.DEFAULT_WORD_REGEXP=e.USUAL_WORD_SEPARATORS=void 0,e.USUAL_WORD_SEPARATORS="`~!@#$%^&*()-=+[{]}\\|;:'\",.<>/?";function m(k=""){let S="(-?\\d*\\.\\d\\w*)|([^";for(const D of e.USUAL_WORD_SEPARATORS)k.indexOf(D)>=0||(S+="\\"+D);return S+="\\s]+)",new RegExp(S,"g")}e.DEFAULT_WORD_REGEXP=m();function L(k){let S=e.DEFAULT_WORD_REGEXP;if(k&&k instanceof RegExp)if(k.global)S=k;else{let D="g";k.ignoreCase&&(D+="i"),k.multiline&&(D+="m"),k.unicode&&(D+="u"),S=new RegExp(k.source,D)}return S.lastIndex=0,S}e.ensureValidWordDefinition=L;const y={maxLen:1e3,windowSize:15,timeBudget:150};function C(k,S,D,R,P=y){if(D.length>P.maxLen){let w=k-P.maxLen/2;return w<0?w=0:R+=w,D=D.substring(w,k+P.maxLen/2),C(k,S,D,R,P)}const u=Date.now(),E=k-1-R;let f=-1,v=null;for(let w=1;!(Date.now()-u>=P.timeBudget);w++){const I=E-P.windowSize*w;S.lastIndex=Math.max(0,I);const p=i(S,D,E,f);if(!p&&v||(v=p,I<=0))break;f=I}if(v){let w={word:v[0],startColumn:R+1+v.index,endColumn:R+1+v.index+v[0].length};return S.lastIndex=0,w}return null}e.getWordAtText=C;function i(k,S,D,R){let P;for(;P=k.exec(S);){const u=P.index||0;if(u<=D&&k.lastIndex>=D)return P;if(R>0&&u>R)return null}return null}}),define(pe[146],ve([0,1]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AutoClosingPairs=e.StandardAutoClosingPairConditional=e.IndentAction=void 0;var m;(function(i){i[i.None=0]="None",i[i.Indent=1]="Indent",i[i.IndentOutdent=2]="IndentOutdent",i[i.Outdent=3]="Outdent"})(m=e.IndentAction||(e.IndentAction={}));class L{constructor(k){if(this._neutralCharacter=null,this._neutralCharacterSearched=!1,this.open=k.open,this.close=k.close,this._standardTokenMask=0,Array.isArray(k.notIn))for(let S=0,D=k.notIn.length;S<D;S++)switch(k.notIn[S]){case"string":this._standardTokenMask|=2;break;case"comment":this._standardTokenMask|=1;break;case"regex":this._standardTokenMask|=4;break}}isOK(k){return(this._standardTokenMask&k)==0}shouldAutoClose(k,S){if(k.getTokenCount()===0)return!0;const D=k.findTokenIndexAtOffset(S-2),R=k.getStandardTokenType(D);return this.isOK(R)}_findNeutralCharacterInRange(k,S){for(let D=k;D<=S;D++){const R=String.fromCharCode(D);if(!this.open.includes(R)&&!this.close.includes(R))return R}return null}findNeutralCharacter(){return this._neutralCharacterSearched||(this._neutralCharacterSearched=!0,this._neutralCharacter||(this._neutralCharacter=this._findNeutralCharacterInRange(48,57)),this._neutralCharacter||(this._neutralCharacter=this._findNeutralCharacterInRange(97,122)),this._neutralCharacter||(this._neutralCharacter=this._findNeutralCharacterInRange(65,90))),this._neutralCharacter}}e.StandardAutoClosingPairConditional=L;class y{constructor(k){this.autoClosingPairsOpenByStart=new Map,this.autoClosingPairsOpenByEnd=new Map,this.autoClosingPairsCloseByStart=new Map,this.autoClosingPairsCloseByEnd=new Map,this.autoClosingPairsCloseSingleChar=new Map;for(const S of k)C(this.autoClosingPairsOpenByStart,S.open.charAt(0),S),C(this.autoClosingPairsOpenByEnd,S.open.charAt(S.open.length-1),S),C(this.autoClosingPairsCloseByStart,S.close.charAt(0),S),C(this.autoClosingPairsCloseByEnd,S.close.charAt(S.close.length-1),S),S.close.length===1&&S.open.length===1&&C(this.autoClosingPairsCloseSingleChar,S.close,S)}}e.AutoClosingPairs=y;function C(i,k,S){i.has(k)?i.get(k).push(S):i.set(k,[S])}}),define(pe[82],ve([0,1,31,9]),function(Y,e,m,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.score=void 0;function y(C,i,k,S){if(Array.isArray(C)){let D=0;for(const R of C){const P=y(R,i,k,S);if(P===10)return P;P>D&&(D=P)}return D}else{if(typeof C=="string")return S?C==="*"?5:C===k?10:0:0;if(C){const{language:D,pattern:R,scheme:P,hasAccessToAllModels:u}=C;if(!S&&!u)return 0;let E=0;if(P)if(P===i.scheme)E=10;else if(P==="*")E=5;else return 0;if(D)if(D===k)E=10;else if(D==="*")E=Math.max(E,5);else return 0;if(R){let f;if(typeof R=="string"?f=R:f={...R,base:(0,L.normalize)(R.base)},f===i.fsPath||(0,m.match)(f,i.fsPath))E=10;else return 0}return E}else return 0}}e.score=y}),define(pe[147],ve([0,1,107]),function(Y,e,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.computeLinks=e.LinkComputer=e.StateMachine=e.Uint8Matrix=e.State=void 0;var L;(function(E){E[E.Invalid=0]="Invalid",E[E.Start=1]="Start",E[E.H=2]="H",E[E.HT=3]="HT",E[E.HTT=4]="HTT",E[E.HTTP=5]="HTTP",E[E.F=6]="F",E[E.FI=7]="FI",E[E.FIL=8]="FIL",E[E.BeforeColon=9]="BeforeColon",E[E.AfterColon=10]="AfterColon",E[E.AlmostThere=11]="AlmostThere",E[E.End=12]="End",E[E.Accept=13]="Accept",E[E.LastKnownState=14]="LastKnownState"})(L=e.State||(e.State={}));class y{constructor(f,v,w){const I=new Uint8Array(f*v);for(let p=0,s=f*v;p<s;p++)I[p]=w;this._data=I,this.rows=f,this.cols=v}get(f,v){return this._data[f*this.cols+v]}set(f,v,w){this._data[f*this.cols+v]=w}}e.Uint8Matrix=y;class C{constructor(f){let v=0,w=0;for(let p=0,s=f.length;p<s;p++){let[r,g,a]=f[p];g>v&&(v=g),r>w&&(w=r),a>w&&(w=a)}v++,w++;let I=new y(w,v,0);for(let p=0,s=f.length;p<s;p++){let[r,g,a]=f[p];I.set(r,g,a)}this._states=I,this._maxCharCode=v}nextState(f,v){return v<0||v>=this._maxCharCode?0:this._states.get(f,v)}}e.StateMachine=C;let i=null;function k(){return i===null&&(i=new C([[1,104,2],[1,72,2],[1,102,6],[1,70,6],[2,116,3],[2,84,3],[3,116,4],[3,84,4],[4,112,5],[4,80,5],[5,115,9],[5,83,9],[5,58,10],[6,105,7],[6,73,7],[7,108,8],[7,76,8],[8,101,9],[8,69,9],[9,58,10],[10,47,11],[11,47,12]])),i}var S;(function(E){E[E.None=0]="None",E[E.ForceTermination=1]="ForceTermination",E[E.CannotEndIn=2]="CannotEndIn"})(S||(S={}));let D=null;function R(){if(D===null){D=new m.CharacterClassifier(0);const E=` 	<>'"\u3001\u3002\uFF61\uFF64\uFF0C\uFF0E\uFF1A\uFF1B\u2018\u3008\u300C\u300E\u3014\uFF08\uFF3B\uFF5B\uFF62\uFF63\uFF5D\uFF3D\uFF09\u3015\u300F\u300D\u3009\u2019\uFF40\uFF5E\u2026`;for(let v=0;v<E.length;v++)D.set(E.charCodeAt(v),1);const f=".,;";for(let v=0;v<f.length;v++)D.set(f.charCodeAt(v),2)}return D}class P{static _createLink(f,v,w,I,p){let s=p-1;do{const r=v.charCodeAt(s);if(f.get(r)!==2)break;s--}while(s>I);if(I>0){const r=v.charCodeAt(I-1),g=v.charCodeAt(s);(r===40&&g===41||r===91&&g===93||r===123&&g===125)&&s--}return{range:{startLineNumber:w,startColumn:I+1,endLineNumber:w,endColumn:s+2},url:v.substring(I,s+1)}}static computeLinks(f,v=k()){const w=R();let I=[];for(let p=1,s=f.getLineCount();p<=s;p++){const r=f.getLineContent(p),g=r.length;let a=0,_=0,n=0,t=1,o=!1,d=!1,c=!1,h=!1;for(;a<g;){let l=!1;const b=r.charCodeAt(a);if(t===13){let T;switch(b){case 40:o=!0,T=0;break;case 41:T=o?0:1;break;case 91:c=!0,d=!0,T=0;break;case 93:c=!1,T=d?0:1;break;case 123:h=!0,T=0;break;case 125:T=h?0:1;break;case 39:T=n===34||n===96?0:1;break;case 34:T=n===39||n===96?0:1;break;case 96:T=n===39||n===34?0:1;break;case 42:T=n===42?1:0;break;case 124:T=n===124?1:0;break;case 32:T=c?0:1;break;default:T=w.get(b)}T===1&&(I.push(P._createLink(w,r,p,_,a)),l=!0)}else if(t===12){let T;b===91?(d=!0,T=0):T=w.get(b),T===1?l=!0:t=13}else t=v.nextState(t,b),t===0&&(l=!0);l&&(t=1,o=!1,d=!1,h=!1,_=a+1,n=b),a++}t===13&&I.push(P._createLink(w,r,p,_,g))}return I}}e.LinkComputer=P;function u(E){return!E||typeof E.getLineCount!="function"||typeof E.getLineContent!="function"?[]:P.computeLinks(E)}e.computeLinks=u}),define(pe[148],ve([0,1,3,6]),function(Y,e,m,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TokenizationRegistryImpl=void 0;class y{constructor(){this._map=new Map,this._promises=new Map,this._onDidChange=new m.Emitter,this.onDidChange=this._onDidChange.event,this._colorMap=null}fire(i){this._onDidChange.fire({changedLanguages:i,changedColorMap:!1})}register(i,k){return this._map.set(i,k),this.fire([i]),(0,L.toDisposable)(()=>{this._map.get(i)===k&&(this._map.delete(i),this.fire([i]))})}registerPromise(i,k){let S=null,D=!1;return this._promises.set(i,k.then(R=>{this._promises.delete(i),!(D||!R)&&(S=this.register(i,R))})),(0,L.toDisposable)(()=>{D=!0,S&&S.dispose()})}getPromise(i){const k=this.get(i);if(k)return Promise.resolve(k);const S=this._promises.get(i);return S?S.then(D=>this.get(i)):null}get(i){return this._map.get(i)||null}setColorMap(i){this._colorMap=i,this._onDidChange.fire({changedLanguages:Array.from(this._map.keys()),changedColorMap:!0})}getColorMap(){return this._colorMap}getDefaultBackground(){return this._colorMap&&this._colorMap.length>2?this._colorMap[2]:null}}e.TokenizationRegistryImpl=y}),define(pe[110],ve([0,1,22,12]),function(Y,e,m,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.decodeSemanticTokensDto=e.encodeSemanticTokensDto=void 0;var y;(function(P){P[P.Full=1]="Full",P[P.Delta=2]="Delta"})(y||(y={}));function C(P){for(let u=0,E=P.length;u<E;u+=4){const f=P[u+0],v=P[u+1],w=P[u+2],I=P[u+3];P[u+0]=I,P[u+1]=w,P[u+2]=v,P[u+3]=f}}function i(P){const u=new Uint8Array(P.buffer,P.byteOffset,P.length*4);return L.isLittleEndian()||C(u),m.VSBuffer.wrap(u)}function k(P){const u=P.buffer;if(L.isLittleEndian()||C(u),u.byteOffset%4==0)return new Uint32Array(u.buffer,u.byteOffset,u.length/4);{const E=new Uint8Array(u.byteLength);return E.set(u),new Uint32Array(E.buffer,E.byteOffset,E.length/4)}}function S(P){const u=new Uint32Array(D(P));let E=0;if(u[E++]=P.id,P.type==="full")u[E++]=1,u[E++]=P.data.length,u.set(P.data,E),E+=P.data.length;else{u[E++]=2,u[E++]=P.deltas.length;for(const f of P.deltas)u[E++]=f.start,u[E++]=f.deleteCount,f.data?(u[E++]=f.data.length,u.set(f.data,E),E+=f.data.length):u[E++]=0}return i(u)}e.encodeSemanticTokensDto=S;function D(P){let u=0;if(u+=1+1,P.type==="full")u+=1+P.data.length;else{u+=1,u+=(1+1+1)*P.deltas.length;for(const E of P.deltas)E.data&&(u+=E.data.length)}return u}function R(P){const u=k(P);let E=0;const f=u[E++];if(u[E++]===1){const p=u[E++],s=u.subarray(E,E+p);return E+=p,{id:f,type:"full",data:s}}const w=u[E++];let I=[];for(let p=0;p<w;p++){const s=u[E++],r=u[E++],g=u[E++];let a;g>0&&(a=u.subarray(E,E+g),E+=g),I[p]={start:s,deleteCount:r,data:a}}return{id:f,type:"delta",deltas:I}}e.decodeSemanticTokensDto=R}),define(pe[111],ve([0,1,16,98]),function(Y,e,m,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PrefixSumIndexOfResult=e.ConstantTimePrefixSumComputer=e.PrefixSumComputer=void 0;class y{constructor(S){this.values=S,this.prefixSum=new Uint32Array(S.length),this.prefixSumValidIndex=new Int32Array(1),this.prefixSumValidIndex[0]=-1}getCount(){return this.values.length}insertValues(S,D){S=(0,L.toUint32)(S);const R=this.values,P=this.prefixSum,u=D.length;return u===0?!1:(this.values=new Uint32Array(R.length+u),this.values.set(R.subarray(0,S),0),this.values.set(R.subarray(S),S+u),this.values.set(D,S),S-1<this.prefixSumValidIndex[0]&&(this.prefixSumValidIndex[0]=S-1),this.prefixSum=new Uint32Array(this.values.length),this.prefixSumValidIndex[0]>=0&&this.prefixSum.set(P.subarray(0,this.prefixSumValidIndex[0]+1)),!0)}setValue(S,D){return S=(0,L.toUint32)(S),D=(0,L.toUint32)(D),this.values[S]===D?!1:(this.values[S]=D,S-1<this.prefixSumValidIndex[0]&&(this.prefixSumValidIndex[0]=S-1),!0)}removeValues(S,D){S=(0,L.toUint32)(S),D=(0,L.toUint32)(D);const R=this.values,P=this.prefixSum;if(S>=R.length)return!1;let u=R.length-S;return D>=u&&(D=u),D===0?!1:(this.values=new Uint32Array(R.length-D),this.values.set(R.subarray(0,S),0),this.values.set(R.subarray(S+D),S),this.prefixSum=new Uint32Array(this.values.length),S-1<this.prefixSumValidIndex[0]&&(this.prefixSumValidIndex[0]=S-1),this.prefixSumValidIndex[0]>=0&&this.prefixSum.set(P.subarray(0,this.prefixSumValidIndex[0]+1)),!0)}getTotalSum(){return this.values.length===0?0:this._getPrefixSum(this.values.length-1)}getPrefixSum(S){return S<0?0:(S=(0,L.toUint32)(S),this._getPrefixSum(S))}_getPrefixSum(S){if(S<=this.prefixSumValidIndex[0])return this.prefixSum[S];let D=this.prefixSumValidIndex[0]+1;D===0&&(this.prefixSum[0]=this.values[0],D++),S>=this.values.length&&(S=this.values.length-1);for(let R=D;R<=S;R++)this.prefixSum[R]=this.prefixSum[R-1]+this.values[R];return this.prefixSumValidIndex[0]=Math.max(this.prefixSumValidIndex[0],S),this.prefixSum[S]}getIndexOf(S){S=Math.floor(S),this.getTotalSum();let D=0,R=this.values.length-1,P=0,u=0,E=0;for(;D<=R;)if(P=D+(R-D)/2|0,u=this.prefixSum[P],E=u-this.values[P],S<E)R=P-1;else if(S>=u)D=P+1;else break;return new i(P,S-E)}}e.PrefixSumComputer=y;class C{constructor(S){this._values=S,this._isValid=!1,this._validEndIndex=-1,this._prefixSum=[],this._indexBySum=[]}getTotalSum(){return this._ensureValid(),this._indexBySum.length}getPrefixSum(S){return this._ensureValid(),S===0?0:this._prefixSum[S-1]}getIndexOf(S){this._ensureValid();const D=this._indexBySum[S],R=D>0?this._prefixSum[D-1]:0;return new i(D,S-R)}removeValues(S,D){this._values.splice(S,D),this._invalidate(S)}insertValues(S,D){this._values=(0,m.arrayInsert)(this._values,S,D),this._invalidate(S)}_invalidate(S){this._isValid=!1,this._validEndIndex=Math.min(this._validEndIndex,S-1)}_ensureValid(){if(!this._isValid){for(let S=this._validEndIndex+1,D=this._values.length;S<D;S++){const R=this._values[S],P=S>0?this._prefixSum[S-1]:0;this._prefixSum[S]=P+R;for(let u=0;u<R;u++)this._indexBySum[P+u]=S}this._prefixSum.length=this._values.length,this._indexBySum.length=this._prefixSum[this._prefixSum.length-1],this._isValid=!0,this._validEndIndex=this._values.length-1}}setValue(S,D){this._values[S]!==D&&(this._values[S]=D,this._invalidate(S))}}e.ConstantTimePrefixSumComputer=C;class i{constructor(S,D){this.index=S,this.remainder=D,this._prefixSumIndexOfResultBrand=void 0,this.index=S,this.remainder=D}}e.PrefixSumIndexOfResult=i}),define(pe[149],ve([0,1,8,49,111]),function(Y,e,m,L,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.MirrorTextModel=void 0;class C{constructor(k,S,D,R){this._uri=k,this._lines=S,this._eol=D,this._versionId=R,this._lineStarts=null,this._cachedTextValue=null}dispose(){this._lines.length=0}get version(){return this._versionId}getText(){return this._cachedTextValue===null&&(this._cachedTextValue=this._lines.join(this._eol)),this._cachedTextValue}onEvents(k){k.eol&&k.eol!==this._eol&&(this._eol=k.eol,this._lineStarts=null);const S=k.changes;for(const D of S)this._acceptDeleteRange(D.range),this._acceptInsertText(new L.Position(D.range.startLineNumber,D.range.startColumn),D.text);this._versionId=k.versionId,this._cachedTextValue=null}_ensureLineStarts(){if(!this._lineStarts){const k=this._eol.length,S=this._lines.length,D=new Uint32Array(S);for(let R=0;R<S;R++)D[R]=this._lines[R].length+k;this._lineStarts=new y.PrefixSumComputer(D)}}_setLineText(k,S){this._lines[k]=S,this._lineStarts&&this._lineStarts.setValue(k,this._lines[k].length+this._eol.length)}_acceptDeleteRange(k){if(k.startLineNumber===k.endLineNumber){if(k.startColumn===k.endColumn)return;this._setLineText(k.startLineNumber-1,this._lines[k.startLineNumber-1].substring(0,k.startColumn-1)+this._lines[k.startLineNumber-1].substring(k.endColumn-1));return}this._setLineText(k.startLineNumber-1,this._lines[k.startLineNumber-1].substring(0,k.startColumn-1)+this._lines[k.endLineNumber-1].substring(k.endColumn-1)),this._lines.splice(k.startLineNumber,k.endLineNumber-k.startLineNumber),this._lineStarts&&this._lineStarts.removeValues(k.startLineNumber,k.endLineNumber-k.startLineNumber)}_acceptInsertText(k,S){if(S.length===0)return;let D=(0,m.splitLines)(S);if(D.length===1){this._setLineText(k.lineNumber-1,this._lines[k.lineNumber-1].substring(0,k.column-1)+D[0]+this._lines[k.lineNumber-1].substring(k.column-1));return}D[D.length-1]+=this._lines[k.lineNumber-1].substring(k.column-1),this._setLineText(k.lineNumber-1,this._lines[k.lineNumber-1].substring(0,k.column-1)+D[0]);let R=new Uint32Array(D.length-1);for(let P=1;P<D.length;P++)this._lines.splice(k.lineNumber+P-1,0,D[P]),R[P-1]=D[P].length+this._eol.length;this._lineStarts&&this._lineStarts.insertValues(k.lineNumber,R)}}e.MirrorTextModel=C}),define(pe[150],ve([19,20]),function(Y,e){return Y.create("vs/base/common/date",e)}),define(pe[151],ve([0,1,150]),function(Y,e,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toLocalISOString=e.fromNow=void 0;const L=60,y=L*60,C=y*24,i=C*7,k=C*30,S=C*365;function D(P,u){typeof P!="number"&&(P=P.getTime());const E=Math.round((new Date().getTime()-P)/1e3);if(E<-30)return(0,m.localize)(0,null,D(new Date().getTime()+E*1e3,!1));if(E<30)return(0,m.localize)(1,null);let f;return E<L?(f=E,u?f===1?(0,m.localize)(2,null,f):(0,m.localize)(3,null,f):f===1?(0,m.localize)(4,null,f):(0,m.localize)(5,null,f)):E<y?(f=Math.floor(E/L),u?f===1?(0,m.localize)(6,null,f):(0,m.localize)(7,null,f):f===1?(0,m.localize)(8,null,f):(0,m.localize)(9,null,f)):E<C?(f=Math.floor(E/y),u?f===1?(0,m.localize)(10,null,f):(0,m.localize)(11,null,f):f===1?(0,m.localize)(12,null,f):(0,m.localize)(13,null,f)):E<i?(f=Math.floor(E/C),u?f===1?(0,m.localize)(14,null,f):(0,m.localize)(15,null,f):f===1?(0,m.localize)(16,null,f):(0,m.localize)(17,null,f)):E<k?(f=Math.floor(E/i),u?f===1?(0,m.localize)(18,null,f):(0,m.localize)(19,null,f):f===1?(0,m.localize)(20,null,f):(0,m.localize)(21,null,f)):E<S?(f=Math.floor(E/k),u?f===1?(0,m.localize)(22,null,f):(0,m.localize)(23,null,f):f===1?(0,m.localize)(24,null,f):(0,m.localize)(25,null,f)):(f=Math.floor(E/S),u?f===1?(0,m.localize)(26,null,f):(0,m.localize)(27,null,f):f===1?(0,m.localize)(28,null,f):(0,m.localize)(29,null,f))}e.fromNow=D;function R(P){return P.getFullYear()+"-"+String(P.getMonth()+1).padStart(2,"0")+"-"+String(P.getDate()).padStart(2,"0")+"T"+String(P.getHours()).padStart(2,"0")+":"+String(P.getMinutes()).padStart(2,"0")+":"+String(P.getSeconds()).padStart(2,"0")+"."+(P.getMilliseconds()/1e3).toFixed(3).slice(2,5)+"Z"}e.toLocalISOString=R}),define(pe[152],ve([19,20]),function(Y,e){return Y.create("vs/base/common/errorMessage",e)}),define(pe[50],ve([0,1,16,13,152]),function(Y,e,m,L,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toErrorMessage=void 0;function C(D,R){return R&&(D.stack||D.stacktrace)?y.localize(0,null,k(D),i(D.stack)||i(D.stacktrace)):k(D)}function i(D){return Array.isArray(D)?D.join(`
`):D}function k(D){return typeof D.code=="string"&&typeof D.errno=="number"&&typeof D.syscall=="string"?y.localize(1,null,D.message):D.message||y.localize(2,null)}function S(D=null,R=!1){if(!D)return y.localize(3,null);if(Array.isArray(D)){const P=m.coalesce(D),u=S(P[0],R);return P.length>1?y.localize(4,null,u,P.length):u}if(L.isString(D))return D;if(D.detail){const P=D.detail;if(P.error)return C(P.error,R);if(P.exception)return C(P.exception,R)}return D.stack?C(D,R):D.message?D.message:y.localize(5,null)}e.toErrorMessage=S}),define(pe[153],ve([19,20]),function(Y,e){return Y.create("vs/base/node/processes",e)}),define(pe[112],ve([0,1,37,30,10,25,9,12,40,94,13,142,28,153]),function(Y,e,m,L,y,C,i,k,S,D,R,P,u,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.win32=e.createQueuedSender=e.LineProcess=e.AbstractProcess=e.getWindowsShell=e.removeDangerousEnvVariables=e.TerminateResponseCode=e.Source=void 0,Object.defineProperty(e,"Source",{enumerable:!0,get:function(){return D.Source}}),Object.defineProperty(e,"TerminateResponseCode",{enumerable:!0,get:function(){return D.TerminateResponseCode}});function f(a){switch(a){case 0:return 0;case 1:return 2;case 128:return 3;default:return 1}}function v(a,_){if(k.isWindows)try{const n={stdio:["pipe","pipe","ignore"]};_&&(n.cwd=_);const t=m.execFile("taskkill",["/T","/F","/PID",a.pid.toString()],n);return new Promise(o=>{t.once("error",d=>{o({success:!1,error:d})}),t.once("exit",(d,c)=>{o(d===0?{success:!0}:{success:!1,code:d!==null?d:1})})})}catch(n){return Promise.resolve({success:!1,error:n,code:n.status?f(n.status):1})}else if(k.isLinux||k.isMacintosh)try{const n=y.FileAccess.asFileUri("vs/base/node/terminateProcess.sh",Y).fsPath;return new Promise(t=>{m.execFile(n,[a.pid.toString()],{encoding:"utf8",shell:!0},(o,d,c)=>{t(o?{success:!1,error:o}:{success:!0})})})}catch(n){return Promise.resolve({success:!1,error:n})}else a.kill("SIGKILL");return Promise.resolve({success:!0})}function w(a){!a||(delete a.DEBUG,k.isMacintosh&&delete a.DYLD_LIBRARY_PATH,k.isLinux&&delete a.LD_PRELOAD)}e.removeDangerousEnvVariables=w;function I(a=S.env){return a.comspec||"cmd.exe"}e.getWindowsShell=I;class p{constructor(_,n,t,o){if(n!==void 0&&t!==void 0&&o!==void 0)this.cmd=_,this.args=n,this.shell=t,this.options=o;else{const d=_;this.cmd=d.command,this.shell=d.isShellCommand,this.args=d.args.slice(0),this.options=d.options||{}}if(this.childProcess=null,this.childProcessPromise=null,this.terminateRequested=!1,this.options.env){const d=Object.create(null);Object.keys(S.env).forEach(c=>{d[c]=S.env[c]}),Object.keys(this.options.env).forEach(c=>{d[c]=this.options.env[c]}),this.options.env=d}}getSanitizedCommand(){let _=this.cmd.toLowerCase();const n=_.lastIndexOf(i.sep);return n!==-1&&(_=_.substring(n+1)),p.WellKnowCommands[_]?_:"other"}start(_){return k.isWindows&&(this.options&&this.options.cwd&&L.isUNC(this.options.cwd)||!this.options&&L.isUNC(S.cwd()))?Promise.reject(new Error(E.localize(0,null))):this.useExec().then(n=>{let t,o;const d=new Promise((c,h)=>{t=c,o=h});if(n){let c=this.cmd;this.args&&(c=c+" "+this.args.join(" ")),this.childProcess=m.exec(c,this.options,(h,l,b)=>{this.childProcess=null;const T=h;T&&T.killed?o({killed:this.terminateRequested,stdout:l.toString(),stderr:b.toString()}):this.handleExec(t,_,h,l,b)})}else{let c=null;const h=l=>{this.childProcess=null,this.childProcessPromise=null,this.handleClose(l,t,_,o);const b={terminated:this.terminateRequested};R.isNumber(l)&&(b.cmdCode=l),t(b)};if(this.shell&&k.isWindows){const l=C.deepClone(this.options);l.windowsVerbatimArguments=!0,l.detached=!1;let b=!1,T=!1;const A=[];let x=this.ensureQuotes(this.cmd);A.push(x.value),b=x.quoted,this.args&&this.args.forEach(F=>{x=this.ensureQuotes(F),A.push(x.value),T=T&&x.quoted});const O=["/s","/c"];b?T?O.push('"'+A.join(" ")+'"'):A.length>1?O.push('"'+A[0]+'" '+A.slice(1).join(" ")):O.push('"'+A[0]+'"'):O.push(A.join(" ")),c=m.spawn(I(),O,l)}else this.cmd&&(c=m.spawn(this.cmd,this.args,this.options));c&&(this.childProcess=c,this.childProcessPromise=Promise.resolve(c),this.pidResolve&&(this.pidResolve(R.isNumber(c.pid)?c.pid:-1),this.pidResolve=void 0),c.on("error",l=>{this.childProcess=null,o({terminated:this.terminateRequested,error:l})}),c.pid&&(this.childProcess.on("close",h),this.handleSpawn(c,t,_,o,!0)))}return d})}handleClose(_,n,t,o){}ensureQuotes(_){return p.regexp.test(_)?{value:'"'+_+'"',quoted:!0}:{value:_,quoted:_.length>0&&_[0]==='"'&&_[_.length-1]==='"'}}get pid(){return this.childProcessPromise?this.childProcessPromise.then(_=>_.pid,_=>-1):new Promise(_=>{this.pidResolve=_})}terminate(){return this.childProcessPromise?this.childProcessPromise.then(_=>(this.terminateRequested=!0,v(_,this.options.cwd).then(n=>(n.success&&(this.childProcess=null),n))),_=>({success:!0})):Promise.resolve({success:!0})}useExec(){return new Promise(_=>{if(!this.shell||!k.isWindows)return _(!1);const n=m.spawn(I(),["/s","/c"]);n.on("error",t=>_(!0)),n.on("exit",t=>_(!1))})}}e.AbstractProcess=p,p.WellKnowCommands={ant:!0,cmake:!0,eslint:!0,gradle:!0,grunt:!0,gulp:!0,jake:!0,jenkins:!0,jshint:!0,make:!0,maven:!0,msbuild:!0,msc:!0,nmake:!0,npm:!0,rake:!0,tsc:!0,xbuild:!0},p.regexp=/^[^"].* .*[^"]/;class s extends p{constructor(_,n,t,o){super(_,n,t,o);this.stdoutLineDecoder=null,this.stderrLineDecoder=null}handleExec(_,n,t,o,d){[o,d].forEach((c,h)=>{const l=new P.LineDecoder;l.write(c).forEach(A=>{n({line:A,source:h===0?0:1})});const T=l.end();T&&n({line:T,source:h===0?0:1})}),_({terminated:this.terminateRequested,error:t})}handleSpawn(_,n,t,o,d){const c=new P.LineDecoder,h=new P.LineDecoder;_.stdout.on("data",l=>{c.write(l).forEach(T=>t({line:T,source:0}))}),_.stderr.on("data",l=>{h.write(l).forEach(T=>t({line:T,source:1}))}),this.stdoutLineDecoder=c,this.stderrLineDecoder=h}handleClose(_,n,t,o){const d=this.stdoutLineDecoder?this.stdoutLineDecoder.end():null;d&&t({line:d,source:0});const c=this.stderrLineDecoder?this.stderrLineDecoder.end():null;c&&t({line:c,source:1})}}e.LineProcess=s;function r(a){let _=[],n=!1;const t=function(o){if(n){_.push(o);return}(!a.send(o,c=>{if(c&&console.error(c),n=!1,_.length>0){const h=_.slice(0);_=[],h.forEach(l=>t(l))}})||k.isWindows)&&(n=!0)};return{send:t}}e.createQueuedSender=r;var g;(function(a){async function _(n,t,o){if(i.isAbsolute(n))return n;if(t===void 0&&(t=S.cwd()),i.dirname(n)!=="."||(o===void 0&&R.isString(S.env.PATH)&&(o=S.env.PATH.split(i.delimiter)),o===void 0||o.length===0))return i.join(t,n);async function c(h){if(await u.Promises.exists(h)){let l;try{l=await u.Promises.stat(h)}catch(b){b.message.startsWith("EACCES")&&(l=await u.Promises.lstat(h))}return l?!l.isDirectory():!1}return!1}for(let h of o){let l;if(i.isAbsolute(h)?l=i.join(h,n):l=i.join(t,h,n),await c(l))return l;let b=l+".com";if(await c(b)||(b=l+".exe",await c(b)))return b}return i.join(t,n)}a.findExecutable=_})(g=e.win32||(e.win32={}))}),define(pe[154],ve([19,20]),function(Y,e){return Y.create("vs/editor/common/config/editorOptions",e)}),define(pe[113],ve([0,1,154,12,109,16,25]),function(Y,e,m,L,y,C,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EditorOptions=e.EditorOption=e.editorOptionsRegistry=e.EDITOR_MODEL_DEFAULTS=e.EDITOR_FONT_DEFAULTS=e.WrappingIndent=e.unicodeHighlightConfigKeys=e.inUntrustedWorkspace=e.filterValidationDecorations=e.RenderLineNumbersType=e.EditorLayoutInfoComputer=e.RenderMinimap=e.EditorFontLigatures=e.cursorStyleToString=e.TextEditorCursorStyle=e.TextEditorCursorBlinkingStyle=e.stringSet=e.clampedInt=e.boolean=e.ApplyUpdateResult=e.ComputeOptionsMemory=e.ValidatedEditorOptions=e.ConfigurationChangedEvent=e.MINIMAP_GUTTER_WIDTH=e.EditorAutoIndentStrategy=void 0;var k;(function(J){J[J.None=0]="None",J[J.Keep=1]="Keep",J[J.Brackets=2]="Brackets",J[J.Advanced=3]="Advanced",J[J.Full=4]="Full"})(k=e.EditorAutoIndentStrategy||(e.EditorAutoIndentStrategy={})),e.MINIMAP_GUTTER_WIDTH=8;class S{constructor(ie){this._values=ie}hasChanged(ie){return this._values[ie]}}e.ConfigurationChangedEvent=S;class D{constructor(){this._values=[]}_read(ie){return this._values[ie]}get(ie){return this._values[ie]}_write(ie,ge){this._values[ie]=ge}}e.ValidatedEditorOptions=D;class R{constructor(){this.stableMinimapLayoutInput=null,this.stableFitMaxMinimapScale=0,this.stableFitRemainingWidth=0}}e.ComputeOptionsMemory=R;class P{constructor(ie,ge,te,Ee){this.id=ie,this.name=ge,this.defaultValue=te,this.schema=Ee}applyUpdate(ie,ge){return E(ie,ge)}compute(ie,ge,te){return te}}class u{constructor(ie,ge){this.newValue=ie,this.didChange=ge}}e.ApplyUpdateResult=u;function E(J,ie){if(typeof J!="object"||typeof ie!="object"||!J||!ie)return new u(ie,J!==ie);if(Array.isArray(J)||Array.isArray(ie)){const te=Array.isArray(J)&&Array.isArray(ie)&&C.equals(J,ie);return new u(ie,te)}let ge=!1;for(let te in ie)if(ie.hasOwnProperty(te)){const Ee=E(J[te],ie[te]);Ee.didChange&&(J[te]=Ee.newValue,ge=!0)}return new u(J,ge)}class f{constructor(ie,ge=null){this.schema=void 0,this.id=ie,this.name="_never_",this.defaultValue=void 0,this.deps=ge}applyUpdate(ie,ge){return E(ie,ge)}validate(ie){return this.defaultValue}}class v{constructor(ie,ge,te,Ee){this.id=ie,this.name=ge,this.defaultValue=te,this.schema=Ee}applyUpdate(ie,ge){return E(ie,ge)}validate(ie){return typeof ie=="undefined"?this.defaultValue:ie}compute(ie,ge,te){return te}}function w(J,ie){return typeof J=="undefined"?ie:J==="false"?!1:Boolean(J)}e.boolean=w;class I extends v{constructor(ie,ge,te,Ee=void 0){typeof Ee!="undefined"&&(Ee.type="boolean",Ee.default=te),super(ie,ge,te,Ee)}validate(ie){return w(ie,this.defaultValue)}}function p(J,ie,ge,te){if(typeof J=="undefined")return ie;let Ee=parseInt(J,10);return isNaN(Ee)?ie:(Ee=Math.max(ge,Ee),Ee=Math.min(te,Ee),Ee|0)}e.clampedInt=p;class s extends v{constructor(ie,ge,te,Ee,Le,Oe=void 0){typeof Oe!="undefined"&&(Oe.type="integer",Oe.default=te,Oe.minimum=Ee,Oe.maximum=Le),super(ie,ge,te,Oe),this.minimum=Ee,this.maximum=Le}static clampedInt(ie,ge,te,Ee){return p(ie,ge,te,Ee)}validate(ie){return s.clampedInt(ie,this.defaultValue,this.minimum,this.maximum)}}class r extends v{constructor(ie,ge,te,Ee,Le){typeof Le!="undefined"&&(Le.type="number",Le.default=te),super(ie,ge,te,Le),this.validationFn=Ee}static clamp(ie,ge,te){return ie<ge?ge:ie>te?te:ie}static float(ie,ge){if(typeof ie=="number")return ie;if(typeof ie=="undefined")return ge;const te=parseFloat(ie);return isNaN(te)?ge:te}validate(ie){return this.validationFn(r.float(ie,this.defaultValue))}}class g extends v{static string(ie,ge){return typeof ie!="string"?ge:ie}constructor(ie,ge,te,Ee=void 0){typeof Ee!="undefined"&&(Ee.type="string",Ee.default=te),super(ie,ge,te,Ee)}validate(ie){return g.string(ie,this.defaultValue)}}function a(J,ie,ge){return typeof J!="string"||ge.indexOf(J)===-1?ie:J}e.stringSet=a;class _ extends v{constructor(ie,ge,te,Ee,Le=void 0){typeof Le!="undefined"&&(Le.type="string",Le.enum=Ee,Le.default=te),super(ie,ge,te,Le),this._allowedValues=Ee}validate(ie){return a(ie,this.defaultValue,this._allowedValues)}}class n extends P{constructor(ie,ge,te,Ee,Le,Oe,Xe=void 0){typeof Xe!="undefined"&&(Xe.type="string",Xe.enum=Le,Xe.default=Ee),super(ie,ge,te,Xe),this._allowedValues=Le,this._convert=Oe}validate(ie){return typeof ie!="string"?this.defaultValue:this._allowedValues.indexOf(ie)===-1?this.defaultValue:this._convert(ie)}}function t(J){switch(J){case"none":return 0;case"keep":return 1;case"brackets":return 2;case"advanced":return 3;case"full":return 4}}class o extends P{constructor(){super(2,"accessibilitySupport",0,{type:"string",enum:["auto","on","off"],enumDescriptions:[m.localize(0,null),m.localize(1,null),m.localize(2,null)],default:"auto",description:m.localize(3,null)})}validate(ie){switch(ie){case"auto":return 0;case"off":return 1;case"on":return 2}return this.defaultValue}compute(ie,ge,te){return te===0?ie.accessibilitySupport:te}}class d extends P{constructor(){const ie={insertSpace:!0,ignoreEmptyLines:!0};super(19,"comments",ie,{"editor.comments.insertSpace":{type:"boolean",default:ie.insertSpace,description:m.localize(4,null)},"editor.comments.ignoreEmptyLines":{type:"boolean",default:ie.ignoreEmptyLines,description:m.localize(5,null)}})}validate(ie){if(!ie||typeof ie!="object")return this.defaultValue;const ge=ie;return{insertSpace:w(ge.insertSpace,this.defaultValue.insertSpace),ignoreEmptyLines:w(ge.ignoreEmptyLines,this.defaultValue.ignoreEmptyLines)}}}var c;(function(J){J[J.Hidden=0]="Hidden",J[J.Blink=1]="Blink",J[J.Smooth=2]="Smooth",J[J.Phase=3]="Phase",J[J.Expand=4]="Expand",J[J.Solid=5]="Solid"})(c=e.TextEditorCursorBlinkingStyle||(e.TextEditorCursorBlinkingStyle={}));function h(J){switch(J){case"blink":return 1;case"smooth":return 2;case"phase":return 3;case"expand":return 4;case"solid":return 5}}var l;(function(J){J[J.Line=1]="Line",J[J.Block=2]="Block",J[J.Underline=3]="Underline",J[J.LineThin=4]="LineThin",J[J.BlockOutline=5]="BlockOutline",J[J.UnderlineThin=6]="UnderlineThin"})(l=e.TextEditorCursorStyle||(e.TextEditorCursorStyle={}));function b(J){switch(J){case l.Line:return"line";case l.Block:return"block";case l.Underline:return"underline";case l.LineThin:return"line-thin";case l.BlockOutline:return"block-outline";case l.UnderlineThin:return"underline-thin"}}e.cursorStyleToString=b;function T(J){switch(J){case"line":return l.Line;case"block":return l.Block;case"underline":return l.Underline;case"line-thin":return l.LineThin;case"block-outline":return l.BlockOutline;case"underline-thin":return l.UnderlineThin}}class A extends f{constructor(){super(127,[65,33])}compute(ie,ge,te){const Ee=["monaco-editor"];return ge.get(33)&&Ee.push(ge.get(33)),ie.extraEditorClassName&&Ee.push(ie.extraEditorClassName),ge.get(65)==="default"?Ee.push("mouse-default"):ge.get(65)==="copy"&&Ee.push("mouse-copy"),ge.get(99)&&Ee.push("showUnused"),ge.get(125)&&Ee.push("showDeprecated"),Ee.join(" ")}}class x extends I{constructor(){super(32,"emptySelectionClipboard",!0,{description:m.localize(6,null)})}compute(ie,ge,te){return te&&ie.emptySelectionClipboard}}class O extends P{constructor(){const ie={cursorMoveOnType:!0,seedSearchStringFromSelection:"always",autoFindInSelection:"never",globalFindClipboard:!1,addExtraSpaceOnTop:!0,loop:!0};super(35,"find",ie,{"editor.find.cursorMoveOnType":{type:"boolean",default:ie.cursorMoveOnType,description:m.localize(7,null)},"editor.find.seedSearchStringFromSelection":{type:"string",enum:["never","always","selection"],default:ie.seedSearchStringFromSelection,enumDescriptions:[m.localize(8,null),m.localize(9,null),m.localize(10,null)],description:m.localize(11,null)},"editor.find.autoFindInSelection":{type:"string",enum:["never","always","multiline"],default:ie.autoFindInSelection,enumDescriptions:[m.localize(12,null),m.localize(13,null),m.localize(14,null)],description:m.localize(15,null)},"editor.find.globalFindClipboard":{type:"boolean",default:ie.globalFindClipboard,description:m.localize(16,null),included:L.isMacintosh},"editor.find.addExtraSpaceOnTop":{type:"boolean",default:ie.addExtraSpaceOnTop,description:m.localize(17,null)},"editor.find.loop":{type:"boolean",default:ie.loop,description:m.localize(18,null)}})}validate(ie){if(!ie||typeof ie!="object")return this.defaultValue;const ge=ie;return{cursorMoveOnType:w(ge.cursorMoveOnType,this.defaultValue.cursorMoveOnType),seedSearchStringFromSelection:typeof ie.seedSearchStringFromSelection=="boolean"?ie.seedSearchStringFromSelection?"always":"never":a(ge.seedSearchStringFromSelection,this.defaultValue.seedSearchStringFromSelection,["never","always","selection"]),autoFindInSelection:typeof ie.autoFindInSelection=="boolean"?ie.autoFindInSelection?"always":"never":a(ge.autoFindInSelection,this.defaultValue.autoFindInSelection,["never","always","multiline"]),globalFindClipboard:w(ge.globalFindClipboard,this.defaultValue.globalFindClipboard),addExtraSpaceOnTop:w(ge.addExtraSpaceOnTop,this.defaultValue.addExtraSpaceOnTop),loop:w(ge.loop,this.defaultValue.loop)}}}class F extends P{constructor(){super(44,"fontLigatures",F.OFF,{anyOf:[{type:"boolean",description:m.localize(19,null)},{type:"string",description:m.localize(20,null)}],description:m.localize(21,null),default:!1})}validate(ie){return typeof ie=="undefined"?this.defaultValue:typeof ie=="string"?ie==="false"?F.OFF:ie==="true"?F.ON:ie:Boolean(ie)?F.ON:F.OFF}}e.EditorFontLigatures=F,F.OFF='"liga" off, "calt" off',F.ON='"liga" on, "calt" on';class W extends f{constructor(){super(43)}compute(ie,ge,te){return ie.fontInfo}}class M extends v{constructor(){super(45,"fontSize",e.EDITOR_FONT_DEFAULTS.fontSize,{type:"number",minimum:6,maximum:100,default:e.EDITOR_FONT_DEFAULTS.fontSize,description:m.localize(22,null)})}validate(ie){let ge=r.float(ie,this.defaultValue);return ge===0?e.EDITOR_FONT_DEFAULTS.fontSize:r.clamp(ge,6,100)}compute(ie,ge,te){return ie.fontInfo.fontSize}}class B extends P{constructor(){super(46,"fontWeight",e.EDITOR_FONT_DEFAULTS.fontWeight,{anyOf:[{type:"number",minimum:B.MINIMUM_VALUE,maximum:B.MAXIMUM_VALUE,errorMessage:m.localize(23,null)},{type:"string",pattern:"^(normal|bold|1000|[1-9][0-9]{0,2})$"},{enum:B.SUGGESTION_VALUES}],default:e.EDITOR_FONT_DEFAULTS.fontWeight,description:m.localize(24,null)})}validate(ie){return ie==="normal"||ie==="bold"?ie:String(s.clampedInt(ie,e.EDITOR_FONT_DEFAULTS.fontWeight,B.MINIMUM_VALUE,B.MAXIMUM_VALUE))}}B.SUGGESTION_VALUES=["normal","bold","100","200","300","400","500","600","700","800","900"],B.MINIMUM_VALUE=1,B.MAXIMUM_VALUE=1e3;class U extends P{constructor(){const ie={multiple:"peek",multipleDefinitions:"peek",multipleTypeDefinitions:"peek",multipleDeclarations:"peek",multipleImplementations:"peek",multipleReferences:"peek",alternativeDefinitionCommand:"editor.action.goToReferences",alternativeTypeDefinitionCommand:"editor.action.goToReferences",alternativeDeclarationCommand:"editor.action.goToReferences",alternativeImplementationCommand:"",alternativeReferenceCommand:""},ge={type:"string",enum:["peek","gotoAndPeek","goto"],default:ie.multiple,enumDescriptions:[m.localize(25,null),m.localize(26,null),m.localize(27,null)]},te=["","editor.action.referenceSearch.trigger","editor.action.goToReferences","editor.action.peekImplementation","editor.action.goToImplementation","editor.action.peekTypeDefinition","editor.action.goToTypeDefinition","editor.action.peekDeclaration","editor.action.revealDeclaration","editor.action.peekDefinition","editor.action.revealDefinitionAside","editor.action.revealDefinition"];super(50,"gotoLocation",ie,{"editor.gotoLocation.multiple":{deprecationMessage:m.localize(28,null)},"editor.gotoLocation.multipleDefinitions":{description:m.localize(29,null),...ge},"editor.gotoLocation.multipleTypeDefinitions":{description:m.localize(30,null),...ge},"editor.gotoLocation.multipleDeclarations":{description:m.localize(31,null),...ge},"editor.gotoLocation.multipleImplementations":{description:m.localize(32,null),...ge},"editor.gotoLocation.multipleReferences":{description:m.localize(33,null),...ge},"editor.gotoLocation.alternativeDefinitionCommand":{type:"string",default:ie.alternativeDefinitionCommand,enum:te,description:m.localize(34,null)},"editor.gotoLocation.alternativeTypeDefinitionCommand":{type:"string",default:ie.alternativeTypeDefinitionCommand,enum:te,description:m.localize(35,null)},"editor.gotoLocation.alternativeDeclarationCommand":{type:"string",default:ie.alternativeDeclarationCommand,enum:te,description:m.localize(36,null)},"editor.gotoLocation.alternativeImplementationCommand":{type:"string",default:ie.alternativeImplementationCommand,enum:te,description:m.localize(37,null)},"editor.gotoLocation.alternativeReferenceCommand":{type:"string",default:ie.alternativeReferenceCommand,enum:te,description:m.localize(38,null)}})}validate(ie){if(!ie||typeof ie!="object")return this.defaultValue;const ge=ie;return{multiple:a(ge.multiple,this.defaultValue.multiple,["peek","gotoAndPeek","goto"]),multipleDefinitions:ge.multipleDefinitions??a(ge.multipleDefinitions,"peek",["peek","gotoAndPeek","goto"]),multipleTypeDefinitions:ge.multipleTypeDefinitions??a(ge.multipleTypeDefinitions,"peek",["peek","gotoAndPeek","goto"]),multipleDeclarations:ge.multipleDeclarations??a(ge.multipleDeclarations,"peek",["peek","gotoAndPeek","goto"]),multipleImplementations:ge.multipleImplementations??a(ge.multipleImplementations,"peek",["peek","gotoAndPeek","goto"]),multipleReferences:ge.multipleReferences??a(ge.multipleReferences,"peek",["peek","gotoAndPeek","goto"]),alternativeDefinitionCommand:g.string(ge.alternativeDefinitionCommand,this.defaultValue.alternativeDefinitionCommand),alternativeTypeDefinitionCommand:g.string(ge.alternativeTypeDefinitionCommand,this.defaultValue.alternativeTypeDefinitionCommand),alternativeDeclarationCommand:g.string(ge.alternativeDeclarationCommand,this.defaultValue.alternativeDeclarationCommand),alternativeImplementationCommand:g.string(ge.alternativeImplementationCommand,this.defaultValue.alternativeImplementationCommand),alternativeReferenceCommand:g.string(ge.alternativeReferenceCommand,this.defaultValue.alternativeReferenceCommand)}}}class z extends P{constructor(){const ie={enabled:!0,delay:300,sticky:!0,above:!0};super(52,"hover",ie,{"editor.hover.enabled":{type:"boolean",default:ie.enabled,description:m.localize(39,null)},"editor.hover.delay":{type:"number",default:ie.delay,description:m.localize(40,null)},"editor.hover.sticky":{type:"boolean",default:ie.sticky,description:m.localize(41,null)},"editor.hover.above":{type:"boolean",default:ie.above,description:m.localize(42,null)}})}validate(ie){if(!ie||typeof ie!="object")return this.defaultValue;const ge=ie;return{enabled:w(ge.enabled,this.defaultValue.enabled),delay:s.clampedInt(ge.delay,this.defaultValue.delay,0,1e4),sticky:w(ge.sticky,this.defaultValue.sticky),above:w(ge.above,this.defaultValue.above)}}}var K;(function(J){J[J.None=0]="None",J[J.Text=1]="Text",J[J.Blocks=2]="Blocks"})(K=e.RenderMinimap||(e.RenderMinimap={}));class N extends f{constructor(){super(130,[49,57,37,64,91,59,60,93,117,120,121,122,2])}compute(ie,ge,te){return N.computeLayout(ge,{memory:ie.memory,outerWidth:ie.outerWidth,outerHeight:ie.outerHeight,isDominatedByLongLines:ie.isDominatedByLongLines,lineHeight:ie.fontInfo.lineHeight,viewLineCount:ie.viewLineCount,lineNumbersDigitCount:ie.lineNumbersDigitCount,typicalHalfwidthCharacterWidth:ie.fontInfo.typicalHalfwidthCharacterWidth,maxDigitWidth:ie.fontInfo.maxDigitWidth,pixelRatio:ie.pixelRatio})}static computeContainedMinimapLineCount(ie){const ge=ie.height/ie.lineHeight,te=ie.scrollBeyondLastLine?ge-1:0,Ee=(ie.viewLineCount+te)/(ie.pixelRatio*ie.height),Le=Math.floor(ie.viewLineCount/Ee);return{typicalViewportLineCount:ge,extraLinesBeyondLastLine:te,desiredRatio:Ee,minimapLineCount:Le}}static _computeMinimapLayout(ie,ge){const te=ie.outerWidth,Ee=ie.outerHeight,Le=ie.pixelRatio;if(!ie.minimap.enabled)return{renderMinimap:0,minimapLeft:0,minimapWidth:0,minimapHeightIsEditorHeight:!1,minimapIsSampling:!1,minimapScale:1,minimapLineHeight:1,minimapCanvasInnerWidth:0,minimapCanvasInnerHeight:Math.floor(Le*Ee),minimapCanvasOuterWidth:0,minimapCanvasOuterHeight:Ee};const Oe=ge.stableMinimapLayoutInput,Xe=Oe&&ie.outerHeight===Oe.outerHeight&&ie.lineHeight===Oe.lineHeight&&ie.typicalHalfwidthCharacterWidth===Oe.typicalHalfwidthCharacterWidth&&ie.pixelRatio===Oe.pixelRatio&&ie.scrollBeyondLastLine===Oe.scrollBeyondLastLine&&ie.minimap.enabled===Oe.minimap.enabled&&ie.minimap.side===Oe.minimap.side&&ie.minimap.size===Oe.minimap.size&&ie.minimap.showSlider===Oe.minimap.showSlider&&ie.minimap.renderCharacters===Oe.minimap.renderCharacters&&ie.minimap.maxColumn===Oe.minimap.maxColumn&&ie.minimap.scale===Oe.minimap.scale&&ie.verticalScrollbarWidth===Oe.verticalScrollbarWidth&&ie.isViewportWrapping===Oe.isViewportWrapping,Te=ie.lineHeight,Ie=ie.typicalHalfwidthCharacterWidth,Se=ie.scrollBeyondLastLine,le=ie.minimap.renderCharacters;let ue=Le>=2?Math.round(ie.minimap.scale*2):ie.minimap.scale;const we=ie.minimap.maxColumn,_e=ie.minimap.size,Fe=ie.minimap.side,Ke=ie.verticalScrollbarWidth,$e=ie.viewLineCount,Qe=ie.remainingWidth,st=ie.isViewportWrapping,at=le?2:3;let de=Math.floor(Le*Ee);const Ce=de/Le;let ce=!1,X=!1,De=at*ue,Re=ue/Le,Ze=1;if(_e==="fill"||_e==="fit"){const{typicalViewportLineCount:vt,extraLinesBeyondLastLine:St,desiredRatio:Ot,minimapLineCount:It}=N.computeContainedMinimapLineCount({viewLineCount:$e,scrollBeyondLastLine:Se,height:Ee,lineHeight:Te,pixelRatio:Le});if($e/It>1)ce=!0,X=!0,ue=1,De=1,Re=ue/Le;else{let Lt=!1,_t=ue+1;if(_e==="fit"){const Mt=Math.ceil(($e+St)*De);st&&Xe&&Qe<=ge.stableFitRemainingWidth?(Lt=!0,_t=ge.stableFitMaxMinimapScale):Lt=Mt>de}if(_e==="fill"||Lt){ce=!0;const Mt=ue;De=Math.min(Te*Le,Math.max(1,Math.floor(1/Ot))),st&&Xe&&Qe<=ge.stableFitRemainingWidth&&(_t=ge.stableFitMaxMinimapScale),ue=Math.min(_t,Math.max(1,Math.floor(De/at))),ue>Mt&&(Ze=Math.min(2,ue/Mt)),Re=ue/Le/Ze,de=Math.ceil(Math.max(vt,$e+St)*De),st?(ge.stableMinimapLayoutInput=ie,ge.stableFitRemainingWidth=Qe,ge.stableFitMaxMinimapScale=ue):(ge.stableMinimapLayoutInput=null,ge.stableFitRemainingWidth=0)}}}const qe=Math.floor(we*Re),dt=Math.min(qe,Math.max(0,Math.floor((Qe-Ke-2)*Re/(Ie+Re)))+e.MINIMAP_GUTTER_WIDTH);let wt=Math.floor(Le*dt);const yt=wt/Le;wt=Math.floor(wt*Ze);const bt=le?1:2,ft=Fe==="left"?0:te-dt-Ke;return{renderMinimap:bt,minimapLeft:ft,minimapWidth:dt,minimapHeightIsEditorHeight:ce,minimapIsSampling:X,minimapScale:ue,minimapLineHeight:De,minimapCanvasInnerWidth:wt,minimapCanvasInnerHeight:de,minimapCanvasOuterWidth:yt,minimapCanvasOuterHeight:Ce}}static computeLayout(ie,ge){const te=ge.outerWidth|0,Ee=ge.outerHeight|0,Le=ge.lineHeight|0,Oe=ge.lineNumbersDigitCount|0,Xe=ge.typicalHalfwidthCharacterWidth,Te=ge.maxDigitWidth,Ie=ge.pixelRatio,Se=ge.viewLineCount,le=ie.get(122),ue=le==="inherit"?ie.get(121):le,we=ue==="inherit"?ie.get(117):ue,_e=ie.get(120),Fe=ie.get(2),Ke=ge.isDominatedByLongLines,$e=ie.get(49),Qe=ie.get(59).renderType!==0,st=ie.get(60),at=ie.get(93),de=ie.get(64),Ce=ie.get(91),ce=Ce.verticalScrollbarSize,X=Ce.verticalHasArrows,De=Ce.arrowSize,Re=Ce.horizontalScrollbarSize,Ze=ie.get(57),qe=ie.get(37);let dt;if(typeof Ze=="string"&&/^\d+(\.\d+)?ch$/.test(Ze)){const Wt=parseFloat(Ze.substr(0,Ze.length-2));dt=s.clampedInt(Wt*Xe,0,0,1e3)}else dt=s.clampedInt(Ze,0,0,1e3);qe&&(dt+=16);let wt=0;if(Qe){const Wt=Math.max(Oe,st);wt=Math.round(Wt*Te)}let yt=0;$e&&(yt=Le);let bt=0,ft=bt+yt,vt=ft+wt,St=vt+dt;const Ot=te-yt-wt-dt;let It=!1,Tt=!1,Lt=-1;Fe!==2&&(ue==="inherit"&&Ke?(It=!0,Tt=!0):we==="on"||we==="bounded"?Tt=!0:we==="wordWrapColumn"&&(Lt=_e));const _t=N._computeMinimapLayout({outerWidth:te,outerHeight:Ee,lineHeight:Le,typicalHalfwidthCharacterWidth:Xe,pixelRatio:Ie,scrollBeyondLastLine:at,minimap:de,verticalScrollbarWidth:ce,viewLineCount:Se,remainingWidth:Ot,isViewportWrapping:Tt},ge.memory||new R);_t.renderMinimap!==0&&_t.minimapLeft===0&&(bt+=_t.minimapWidth,ft+=_t.minimapWidth,vt+=_t.minimapWidth,St+=_t.minimapWidth);const Mt=Ot-_t.minimapWidth,Nt=Math.max(1,Math.floor((Mt-ce-2)/Xe)),Et=X?De:0;return Tt&&(Lt=Math.max(1,Nt),we==="bounded"&&(Lt=Math.min(Lt,_e))),{width:te,height:Ee,glyphMarginLeft:bt,glyphMarginWidth:yt,lineNumbersLeft:ft,lineNumbersWidth:wt,decorationsLeft:vt,decorationsWidth:dt,contentLeft:St,contentWidth:Mt,minimap:_t,viewportColumn:Nt,isWordWrapMinified:It,isViewportWrapping:Tt,wrappingColumn:Lt,verticalScrollbarWidth:ce,horizontalScrollbarHeight:Re,overviewRuler:{top:Et,width:ce,height:Ee-2*Et,right:0}}}}e.EditorLayoutInfoComputer=N;class j extends P{constructor(){const ie={enabled:!0};super(56,"lightbulb",ie,{"editor.lightbulb.enabled":{type:"boolean",default:ie.enabled,description:m.localize(43,null)}})}validate(ie){return!ie||typeof ie!="object"?this.defaultValue:{enabled:w(ie.enabled,this.defaultValue.enabled)}}}class H extends P{constructor(){const ie={enabled:!0,fontSize:0,fontFamily:""};super(126,"inlayHints",ie,{"editor.inlayHints.enabled":{type:"boolean",default:ie.enabled,description:m.localize(44,null)},"editor.inlayHints.fontSize":{type:"number",default:ie.fontSize,markdownDescription:m.localize(45,null)},"editor.inlayHints.fontFamily":{type:"string",default:ie.fontFamily,markdownDescription:m.localize(46,null)}})}validate(ie){if(!ie||typeof ie!="object")return this.defaultValue;const ge=ie;return{enabled:w(ge.enabled,this.defaultValue.enabled),fontSize:s.clampedInt(ge.fontSize,this.defaultValue.fontSize,0,100),fontFamily:g.string(ge.fontFamily,this.defaultValue.fontFamily)}}}class V extends r{constructor(){super(58,"lineHeight",e.EDITOR_FONT_DEFAULTS.lineHeight,ie=>r.clamp(ie,0,150),{markdownDescription:m.localize(47,null)})}compute(ie,ge,te){return ie.fontInfo.lineHeight}}class q extends P{constructor(){const ie={enabled:!0,size:"proportional",side:"right",showSlider:"mouseover",renderCharacters:!0,maxColumn:120,scale:1};super(64,"minimap",ie,{"editor.minimap.enabled":{type:"boolean",default:ie.enabled,description:m.localize(48,null)},"editor.minimap.size":{type:"string",enum:["proportional","fill","fit"],enumDescriptions:[m.localize(49,null),m.localize(50,null),m.localize(51,null)],default:ie.size,description:m.localize(52,null)},"editor.minimap.side":{type:"string",enum:["left","right"],default:ie.side,description:m.localize(53,null)},"editor.minimap.showSlider":{type:"string",enum:["always","mouseover"],default:ie.showSlider,description:m.localize(54,null)},"editor.minimap.scale":{type:"number",default:ie.scale,minimum:1,maximum:3,enum:[1,2,3],description:m.localize(55,null)},"editor.minimap.renderCharacters":{type:"boolean",default:ie.renderCharacters,description:m.localize(56,null)},"editor.minimap.maxColumn":{type:"number",default:ie.maxColumn,description:m.localize(57,null)}})}validate(ie){if(!ie||typeof ie!="object")return this.defaultValue;const ge=ie;return{enabled:w(ge.enabled,this.defaultValue.enabled),size:a(ge.size,this.defaultValue.size,["proportional","fill","fit"]),side:a(ge.side,this.defaultValue.side,["right","left"]),showSlider:a(ge.showSlider,this.defaultValue.showSlider,["always","mouseover"]),renderCharacters:w(ge.renderCharacters,this.defaultValue.renderCharacters),scale:s.clampedInt(ge.scale,1,1,3),maxColumn:s.clampedInt(ge.maxColumn,this.defaultValue.maxColumn,1,1e4)}}}function ne(J){return J==="ctrlCmd"?L.isMacintosh?"metaKey":"ctrlKey":"altKey"}class fe extends P{constructor(){super(74,"padding",{top:0,bottom:0},{"editor.padding.top":{type:"number",default:0,minimum:0,maximum:1e3,description:m.localize(58,null)},"editor.padding.bottom":{type:"number",default:0,minimum:0,maximum:1e3,description:m.localize(59,null)}})}validate(ie){if(!ie||typeof ie!="object")return this.defaultValue;const ge=ie;return{top:s.clampedInt(ge.top,0,0,1e3),bottom:s.clampedInt(ge.bottom,0,0,1e3)}}}class ye extends P{constructor(){const ie={enabled:!0,cycle:!1};super(75,"parameterHints",ie,{"editor.parameterHints.enabled":{type:"boolean",default:ie.enabled,description:m.localize(60,null)},"editor.parameterHints.cycle":{type:"boolean",default:ie.cycle,description:m.localize(61,null)}})}validate(ie){if(!ie||typeof ie!="object")return this.defaultValue;const ge=ie;return{enabled:w(ge.enabled,this.defaultValue.enabled),cycle:w(ge.cycle,this.defaultValue.cycle)}}}class ke extends f{constructor(){super(128)}compute(ie,ge,te){return ie.pixelRatio}}class Be extends P{constructor(){const ie={other:!0,comments:!1,strings:!1};super(78,"quickSuggestions",ie,{anyOf:[{type:"boolean"},{type:"object",properties:{strings:{type:"boolean",default:ie.strings,description:m.localize(62,null)},comments:{type:"boolean",default:ie.comments,description:m.localize(63,null)},other:{type:"boolean",default:ie.other,description:m.localize(64,null)}}}],default:ie,description:m.localize(65,null)});this.defaultValue=ie}validate(ie){if(typeof ie=="boolean")return ie;if(ie&&typeof ie=="object"){const ge=ie,te={other:w(ge.other,this.defaultValue.other),comments:w(ge.comments,this.defaultValue.comments),strings:w(ge.strings,this.defaultValue.strings)};return te.other&&te.comments&&te.strings?!0:!te.other&&!te.comments&&!te.strings?!1:te}return this.defaultValue}}var We;(function(J){J[J.Off=0]="Off",J[J.On=1]="On",J[J.Relative=2]="Relative",J[J.Interval=3]="Interval",J[J.Custom=4]="Custom"})(We=e.RenderLineNumbersType||(e.RenderLineNumbersType={}));class ze extends P{constructor(){super(59,"lineNumbers",{renderType:1,renderFn:null},{type:"string",enum:["off","on","relative","interval"],enumDescriptions:[m.localize(66,null),m.localize(67,null),m.localize(68,null),m.localize(69,null)],default:"on",description:m.localize(70,null)})}validate(ie){let ge=this.defaultValue.renderType,te=this.defaultValue.renderFn;return typeof ie!="undefined"&&(typeof ie=="function"?(ge=4,te=ie):ie==="interval"?ge=3:ie==="relative"?ge=2:ie==="on"?ge=1:ge=0),{renderType:ge,renderFn:te}}}function Q(J){const ie=J.get(86);return ie==="editable"?J.get(80):ie!=="on"}e.filterValidationDecorations=Q;class ee extends P{constructor(){const ie=[],ge={type:"number",description:m.localize(71,null)};super(90,"rulers",ie,{type:"array",items:{anyOf:[ge,{type:["object"],properties:{column:ge,color:{type:"string",description:m.localize(72,null),format:"color-hex"}}}]},default:ie,description:m.localize(73,null)})}validate(ie){if(Array.isArray(ie)){let ge=[];for(let te of ie)if(typeof te=="number")ge.push({column:s.clampedInt(te,0,0,1e4),color:null});else if(te&&typeof te=="object"){const Ee=te;ge.push({column:s.clampedInt(Ee.column,0,0,1e4),color:Ee.color})}return ge.sort((te,Ee)=>te.column-Ee.column),ge}return this.defaultValue}}function re(J,ie){if(typeof J!="string")return ie;switch(J){case"hidden":return 2;case"visible":return 3;default:return 1}}class he extends P{constructor(){const ie={vertical:1,horizontal:1,arrowSize:11,useShadows:!0,verticalHasArrows:!1,horizontalHasArrows:!1,horizontalScrollbarSize:12,horizontalSliderSize:12,verticalScrollbarSize:14,verticalSliderSize:14,handleMouseWheel:!0,alwaysConsumeMouseWheel:!0,scrollByPage:!1};super(91,"scrollbar",ie,{"editor.scrollbar.vertical":{type:"string",enum:["auto","visible","hidden"],enumDescriptions:[m.localize(74,null),m.localize(75,null),m.localize(76,null)],default:"auto",description:m.localize(77,null)},"editor.scrollbar.horizontal":{type:"string",enum:["auto","visible","hidden"],enumDescriptions:[m.localize(78,null),m.localize(79,null),m.localize(80,null)],default:"auto",description:m.localize(81,null)},"editor.scrollbar.verticalScrollbarSize":{type:"number",default:ie.verticalScrollbarSize,description:m.localize(82,null)},"editor.scrollbar.horizontalScrollbarSize":{type:"number",default:ie.horizontalScrollbarSize,description:m.localize(83,null)},"editor.scrollbar.scrollByPage":{type:"boolean",default:ie.scrollByPage,description:m.localize(84,null)}})}validate(ie){if(!ie||typeof ie!="object")return this.defaultValue;const ge=ie,te=s.clampedInt(ge.horizontalScrollbarSize,this.defaultValue.horizontalScrollbarSize,0,1e3),Ee=s.clampedInt(ge.verticalScrollbarSize,this.defaultValue.verticalScrollbarSize,0,1e3);return{arrowSize:s.clampedInt(ge.arrowSize,this.defaultValue.arrowSize,0,1e3),vertical:re(ge.vertical,this.defaultValue.vertical),horizontal:re(ge.horizontal,this.defaultValue.horizontal),useShadows:w(ge.useShadows,this.defaultValue.useShadows),verticalHasArrows:w(ge.verticalHasArrows,this.defaultValue.verticalHasArrows),horizontalHasArrows:w(ge.horizontalHasArrows,this.defaultValue.horizontalHasArrows),handleMouseWheel:w(ge.handleMouseWheel,this.defaultValue.handleMouseWheel),alwaysConsumeMouseWheel:w(ge.alwaysConsumeMouseWheel,this.defaultValue.alwaysConsumeMouseWheel),horizontalScrollbarSize:te,horizontalSliderSize:s.clampedInt(ge.horizontalSliderSize,te,0,1e3),verticalScrollbarSize:Ee,verticalSliderSize:s.clampedInt(ge.verticalSliderSize,Ee,0,1e3),scrollByPage:w(ge.scrollByPage,this.defaultValue.scrollByPage)}}}e.inUntrustedWorkspace="inUntrustedWorkspace",e.unicodeHighlightConfigKeys={allowedCharacters:"editor.unicodeHighlight.allowedCharacters",invisibleCharacters:"editor.unicodeHighlight.invisibleCharacters",nonBasicASCII:"editor.unicodeHighlight.nonBasicASCII",ambiguousCharacters:"editor.unicodeHighlight.ambiguousCharacters",includeComments:"editor.unicodeHighlight.includeComments"};class Z extends P{constructor(){const ie={nonBasicASCII:e.inUntrustedWorkspace,invisibleCharacters:!0,ambiguousCharacters:!0,includeComments:e.inUntrustedWorkspace,allowedCharacters:{}};super(112,"unicodeHighlight",ie,{[e.unicodeHighlightConfigKeys.nonBasicASCII]:{restricted:!0,type:["boolean","string"],enum:[!0,!1,e.inUntrustedWorkspace],default:ie.nonBasicASCII,description:m.localize(85,null)},[e.unicodeHighlightConfigKeys.invisibleCharacters]:{restricted:!0,type:"boolean",default:ie.invisibleCharacters,description:m.localize(86,null)},[e.unicodeHighlightConfigKeys.ambiguousCharacters]:{restricted:!0,type:"boolean",default:ie.ambiguousCharacters,description:m.localize(87,null)},[e.unicodeHighlightConfigKeys.includeComments]:{restricted:!0,type:["boolean","string"],enum:[!0,!1,e.inUntrustedWorkspace],default:ie.includeComments,description:m.localize(88,null)},[e.unicodeHighlightConfigKeys.allowedCharacters]:{restricted:!0,type:"object",default:ie.allowedCharacters,description:m.localize(89,null),additionalProperties:{type:"boolean"}}})}applyUpdate(ie,ge){let te=!1;ge.allowedCharacters&&(i.equals(ie.allowedCharacters,ge.allowedCharacters)||(ie={...ie,allowedCharacters:ge.allowedCharacters},te=!0));const Ee=super.applyUpdate(ie,ge);return te?new u(Ee.newValue,!0):Ee}validate(ie){if(!ie||typeof ie!="object")return this.defaultValue;const ge=ie;return{nonBasicASCII:Ve(ge.nonBasicASCII,e.inUntrustedWorkspace,[!0,!1,e.inUntrustedWorkspace]),invisibleCharacters:w(ge.invisibleCharacters,this.defaultValue.invisibleCharacters),ambiguousCharacters:w(ge.ambiguousCharacters,this.defaultValue.ambiguousCharacters),includeComments:Ve(ge.includeComments,e.inUntrustedWorkspace,[!0,!1,e.inUntrustedWorkspace]),allowedCharacters:this.validateAllowedCharacters(ie.allowedCharacters,this.defaultValue.allowedCharacters)}}validateAllowedCharacters(ie,ge){if(typeof ie!="object"||!ie)return ge;const te={};for(const[Ee,Le]of Object.entries(ie))Le===!0&&(te[Ee]=!0);return te}}class oe extends P{constructor(){const ie={enabled:!0,mode:"subwordSmart"};super(54,"inlineSuggest",ie,{"editor.inlineSuggest.enabled":{type:"boolean",default:ie.enabled,description:m.localize(90,null)}})}validate(ie){if(!ie||typeof ie!="object")return this.defaultValue;const ge=ie;return{enabled:w(ge.enabled,this.defaultValue.enabled),mode:a(ge.mode,this.defaultValue.mode,["prefix","subword","subwordSmart"])}}}class be extends P{constructor(){const ie={enabled:e.EDITOR_MODEL_DEFAULTS.bracketPairColorizationOptions.enabled};super(12,"bracketPairColorization",ie,{"editor.bracketPairColorization.enabled":{type:"boolean",default:ie.enabled,description:m.localize(91,null)}})}validate(ie){return!ie||typeof ie!="object"?this.defaultValue:{enabled:w(ie.enabled,this.defaultValue.enabled)}}}class Me extends P{constructor(){const ie={bracketPairs:!1,bracketPairsHorizontal:"active",highlightActiveBracketPair:!0,indentation:!0,highlightActiveIndentation:!0};super(13,"guides",ie,{"editor.guides.bracketPairs":{type:["boolean","string"],enum:[!0,"active",!1],enumDescriptions:[m.localize(92,null),m.localize(93,null),m.localize(94,null)],default:ie.bracketPairs,description:m.localize(95,null)},"editor.guides.bracketPairsHorizontal":{type:["boolean","string"],enum:[!0,"active",!1],enumDescriptions:[m.localize(96,null),m.localize(97,null),m.localize(98,null)],default:ie.bracketPairsHorizontal,description:m.localize(99,null)},"editor.guides.highlightActiveBracketPair":{type:"boolean",default:ie.highlightActiveBracketPair,description:m.localize(100,null)},"editor.guides.indentation":{type:"boolean",default:ie.indentation,description:m.localize(101,null)},"editor.guides.highlightActiveIndentation":{type:"boolean",default:ie.highlightActiveIndentation,description:m.localize(102,null)}})}validate(ie){if(!ie||typeof ie!="object")return this.defaultValue;const ge=ie;return{bracketPairs:Ve(ge.bracketPairs,this.defaultValue.bracketPairs,[!0,!1,"active"]),bracketPairsHorizontal:Ve(ge.bracketPairsHorizontal,this.defaultValue.bracketPairsHorizontal,[!0,!1,"active"]),highlightActiveBracketPair:w(ge.highlightActiveBracketPair,this.defaultValue.highlightActiveBracketPair),indentation:w(ge.indentation,this.defaultValue.indentation),highlightActiveIndentation:w(ge.highlightActiveIndentation,this.defaultValue.highlightActiveIndentation)}}}function Ve(J,ie,ge){const te=ge.indexOf(J);return te===-1?ie:ge[te]}class Ge extends P{constructor(){const ie={insertMode:"insert",filterGraceful:!0,snippetsPreventQuickSuggestions:!0,localityBonus:!1,shareSuggestSelections:!1,showIcons:!0,showStatusBar:!1,preview:!1,previewMode:"subwordSmart",showInlineDetails:!0,showMethods:!0,showFunctions:!0,showConstructors:!0,showDeprecated:!0,showFields:!0,showVariables:!0,showClasses:!0,showStructs:!0,showInterfaces:!0,showModules:!0,showProperties:!0,showEvents:!0,showOperators:!0,showUnits:!0,showValues:!0,showConstants:!0,showEnums:!0,showEnumMembers:!0,showKeywords:!0,showWords:!0,showColors:!0,showFiles:!0,showReferences:!0,showFolders:!0,showTypeParameters:!0,showSnippets:!0,showUsers:!0,showIssues:!0};super(105,"suggest",ie,{"editor.suggest.insertMode":{type:"string",enum:["insert","replace"],enumDescriptions:[m.localize(103,null),m.localize(104,null)],default:ie.insertMode,description:m.localize(105,null)},"editor.suggest.filterGraceful":{type:"boolean",default:ie.filterGraceful,description:m.localize(106,null)},"editor.suggest.localityBonus":{type:"boolean",default:ie.localityBonus,description:m.localize(107,null)},"editor.suggest.shareSuggestSelections":{type:"boolean",default:ie.shareSuggestSelections,markdownDescription:m.localize(108,null)},"editor.suggest.snippetsPreventQuickSuggestions":{type:"boolean",default:ie.snippetsPreventQuickSuggestions,description:m.localize(109,null)},"editor.suggest.showIcons":{type:"boolean",default:ie.showIcons,description:m.localize(110,null)},"editor.suggest.showStatusBar":{type:"boolean",default:ie.showStatusBar,description:m.localize(111,null)},"editor.suggest.preview":{type:"boolean",default:ie.preview,description:m.localize(112,null)},"editor.suggest.showInlineDetails":{type:"boolean",default:ie.showInlineDetails,description:m.localize(113,null)},"editor.suggest.maxVisibleSuggestions":{type:"number",deprecationMessage:m.localize(114,null)},"editor.suggest.filteredTypes":{type:"object",deprecationMessage:m.localize(115,null)},"editor.suggest.showMethods":{type:"boolean",default:!0,markdownDescription:m.localize(116,null)},"editor.suggest.showFunctions":{type:"boolean",default:!0,markdownDescription:m.localize(117,null)},"editor.suggest.showConstructors":{type:"boolean",default:!0,markdownDescription:m.localize(118,null)},"editor.suggest.showDeprecated":{type:"boolean",default:!0,markdownDescription:m.localize(119,null)},"editor.suggest.showFields":{type:"boolean",default:!0,markdownDescription:m.localize(120,null)},"editor.suggest.showVariables":{type:"boolean",default:!0,markdownDescription:m.localize(121,null)},"editor.suggest.showClasses":{type:"boolean",default:!0,markdownDescription:m.localize(122,null)},"editor.suggest.showStructs":{type:"boolean",default:!0,markdownDescription:m.localize(123,null)},"editor.suggest.showInterfaces":{type:"boolean",default:!0,markdownDescription:m.localize(124,null)},"editor.suggest.showModules":{type:"boolean",default:!0,markdownDescription:m.localize(125,null)},"editor.suggest.showProperties":{type:"boolean",default:!0,markdownDescription:m.localize(126,null)},"editor.suggest.showEvents":{type:"boolean",default:!0,markdownDescription:m.localize(127,null)},"editor.suggest.showOperators":{type:"boolean",default:!0,markdownDescription:m.localize(128,null)},"editor.suggest.showUnits":{type:"boolean",default:!0,markdownDescription:m.localize(129,null)},"editor.suggest.showValues":{type:"boolean",default:!0,markdownDescription:m.localize(130,null)},"editor.suggest.showConstants":{type:"boolean",default:!0,markdownDescription:m.localize(131,null)},"editor.suggest.showEnums":{type:"boolean",default:!0,markdownDescription:m.localize(132,null)},"editor.suggest.showEnumMembers":{type:"boolean",default:!0,markdownDescription:m.localize(133,null)},"editor.suggest.showKeywords":{type:"boolean",default:!0,markdownDescription:m.localize(134,null)},"editor.suggest.showWords":{type:"boolean",default:!0,markdownDescription:m.localize(135,null)},"editor.suggest.showColors":{type:"boolean",default:!0,markdownDescription:m.localize(136,null)},"editor.suggest.showFiles":{type:"boolean",default:!0,markdownDescription:m.localize(137,null)},"editor.suggest.showReferences":{type:"boolean",default:!0,markdownDescription:m.localize(138,null)},"editor.suggest.showCustomcolors":{type:"boolean",default:!0,markdownDescription:m.localize(139,null)},"editor.suggest.showFolders":{type:"boolean",default:!0,markdownDescription:m.localize(140,null)},"editor.suggest.showTypeParameters":{type:"boolean",default:!0,markdownDescription:m.localize(141,null)},"editor.suggest.showSnippets":{type:"boolean",default:!0,markdownDescription:m.localize(142,null)},"editor.suggest.showUsers":{type:"boolean",default:!0,markdownDescription:m.localize(143,null)},"editor.suggest.showIssues":{type:"boolean",default:!0,markdownDescription:m.localize(144,null)}})}validate(ie){if(!ie||typeof ie!="object")return this.defaultValue;const ge=ie;return{insertMode:a(ge.insertMode,this.defaultValue.insertMode,["insert","replace"]),filterGraceful:w(ge.filterGraceful,this.defaultValue.filterGraceful),snippetsPreventQuickSuggestions:w(ge.snippetsPreventQuickSuggestions,this.defaultValue.filterGraceful),localityBonus:w(ge.localityBonus,this.defaultValue.localityBonus),shareSuggestSelections:w(ge.shareSuggestSelections,this.defaultValue.shareSuggestSelections),showIcons:w(ge.showIcons,this.defaultValue.showIcons),showStatusBar:w(ge.showStatusBar,this.defaultValue.showStatusBar),preview:w(ge.preview,this.defaultValue.preview),previewMode:a(ge.previewMode,this.defaultValue.previewMode,["prefix","subword","subwordSmart"]),showInlineDetails:w(ge.showInlineDetails,this.defaultValue.showInlineDetails),showMethods:w(ge.showMethods,this.defaultValue.showMethods),showFunctions:w(ge.showFunctions,this.defaultValue.showFunctions),showConstructors:w(ge.showConstructors,this.defaultValue.showConstructors),showDeprecated:w(ge.showDeprecated,this.defaultValue.showDeprecated),showFields:w(ge.showFields,this.defaultValue.showFields),showVariables:w(ge.showVariables,this.defaultValue.showVariables),showClasses:w(ge.showClasses,this.defaultValue.showClasses),showStructs:w(ge.showStructs,this.defaultValue.showStructs),showInterfaces:w(ge.showInterfaces,this.defaultValue.showInterfaces),showModules:w(ge.showModules,this.defaultValue.showModules),showProperties:w(ge.showProperties,this.defaultValue.showProperties),showEvents:w(ge.showEvents,this.defaultValue.showEvents),showOperators:w(ge.showOperators,this.defaultValue.showOperators),showUnits:w(ge.showUnits,this.defaultValue.showUnits),showValues:w(ge.showValues,this.defaultValue.showValues),showConstants:w(ge.showConstants,this.defaultValue.showConstants),showEnums:w(ge.showEnums,this.defaultValue.showEnums),showEnumMembers:w(ge.showEnumMembers,this.defaultValue.showEnumMembers),showKeywords:w(ge.showKeywords,this.defaultValue.showKeywords),showWords:w(ge.showWords,this.defaultValue.showWords),showColors:w(ge.showColors,this.defaultValue.showColors),showFiles:w(ge.showFiles,this.defaultValue.showFiles),showReferences:w(ge.showReferences,this.defaultValue.showReferences),showFolders:w(ge.showFolders,this.defaultValue.showFolders),showTypeParameters:w(ge.showTypeParameters,this.defaultValue.showTypeParameters),showSnippets:w(ge.showSnippets,this.defaultValue.showSnippets),showUsers:w(ge.showUsers,this.defaultValue.showUsers),showIssues:w(ge.showIssues,this.defaultValue.showIssues)}}}class Je extends P{constructor(){super(101,"smartSelect",{selectLeadingAndTrailingWhitespace:!0},{"editor.smartSelect.selectLeadingAndTrailingWhitespace":{description:m.localize(145,null),default:!0,type:"boolean"}})}validate(ie){return!ie||typeof ie!="object"?this.defaultValue:{selectLeadingAndTrailingWhitespace:w(ie.selectLeadingAndTrailingWhitespace,this.defaultValue.selectLeadingAndTrailingWhitespace)}}}class tt extends f{constructor(){super(129,[80])}compute(ie,ge,te){return ge.get(80)?!0:ie.tabFocusMode}}var ot;(function(J){J[J.None=0]="None",J[J.Same=1]="Same",J[J.Indent=2]="Indent",J[J.DeepIndent=3]="DeepIndent"})(ot=e.WrappingIndent||(e.WrappingIndent={}));function et(J){switch(J){case"none":return 0;case"same":return 1;case"indent":return 2;case"deepIndent":return 3}}class it extends f{constructor(){super(131,[130])}compute(ie,ge,te){const Ee=ge.get(130);return{isDominatedByLongLines:ie.isDominatedByLongLines,isWordWrapMinified:Ee.isWordWrapMinified,isViewportWrapping:Ee.isViewportWrapping,wrappingColumn:Ee.wrappingColumn}}}const ct="Consolas, 'Courier New', monospace",pt="Menlo, Monaco, 'Courier New', monospace",Pt="'Droid Sans Mono', 'monospace', monospace, 'Droid Sans Fallback'";e.EDITOR_FONT_DEFAULTS={fontFamily:L.isMacintosh?pt:L.isLinux?Pt:ct,fontWeight:"normal",fontSize:L.isMacintosh?12:14,lineHeight:0,letterSpacing:0},e.EDITOR_MODEL_DEFAULTS={tabSize:4,indentSize:4,insertSpaces:!0,detectIndentation:!0,trimAutoWhitespace:!0,largeFileOptimizations:!0,bracketPairColorizationOptions:{enabled:!1}},e.editorOptionsRegistry=[];function Ue(J){return e.editorOptionsRegistry[J.id]=J,J}var Rt;(function(J){J[J.acceptSuggestionOnCommitCharacter=0]="acceptSuggestionOnCommitCharacter",J[J.acceptSuggestionOnEnter=1]="acceptSuggestionOnEnter",J[J.accessibilitySupport=2]="accessibilitySupport",J[J.accessibilityPageSize=3]="accessibilityPageSize",J[J.ariaLabel=4]="ariaLabel",J[J.autoClosingBrackets=5]="autoClosingBrackets",J[J.autoClosingDelete=6]="autoClosingDelete",J[J.autoClosingOvertype=7]="autoClosingOvertype",J[J.autoClosingQuotes=8]="autoClosingQuotes",J[J.autoIndent=9]="autoIndent",J[J.automaticLayout=10]="automaticLayout",J[J.autoSurround=11]="autoSurround",J[J.bracketPairColorization=12]="bracketPairColorization",J[J.guides=13]="guides",J[J.codeLens=14]="codeLens",J[J.codeLensFontFamily=15]="codeLensFontFamily",J[J.codeLensFontSize=16]="codeLensFontSize",J[J.colorDecorators=17]="colorDecorators",J[J.columnSelection=18]="columnSelection",J[J.comments=19]="comments",J[J.contextmenu=20]="contextmenu",J[J.copyWithSyntaxHighlighting=21]="copyWithSyntaxHighlighting",J[J.cursorBlinking=22]="cursorBlinking",J[J.cursorSmoothCaretAnimation=23]="cursorSmoothCaretAnimation",J[J.cursorStyle=24]="cursorStyle",J[J.cursorSurroundingLines=25]="cursorSurroundingLines",J[J.cursorSurroundingLinesStyle=26]="cursorSurroundingLinesStyle",J[J.cursorWidth=27]="cursorWidth",J[J.disableLayerHinting=28]="disableLayerHinting",J[J.disableMonospaceOptimizations=29]="disableMonospaceOptimizations",J[J.domReadOnly=30]="domReadOnly",J[J.dragAndDrop=31]="dragAndDrop",J[J.emptySelectionClipboard=32]="emptySelectionClipboard",J[J.extraEditorClassName=33]="extraEditorClassName",J[J.fastScrollSensitivity=34]="fastScrollSensitivity",J[J.find=35]="find",J[J.fixedOverflowWidgets=36]="fixedOverflowWidgets",J[J.folding=37]="folding",J[J.foldingStrategy=38]="foldingStrategy",J[J.foldingHighlight=39]="foldingHighlight",J[J.foldingImportsByDefault=40]="foldingImportsByDefault",J[J.unfoldOnClickAfterEndOfLine=41]="unfoldOnClickAfterEndOfLine",J[J.fontFamily=42]="fontFamily",J[J.fontInfo=43]="fontInfo",J[J.fontLigatures=44]="fontLigatures",J[J.fontSize=45]="fontSize",J[J.fontWeight=46]="fontWeight",J[J.formatOnPaste=47]="formatOnPaste",J[J.formatOnType=48]="formatOnType",J[J.glyphMargin=49]="glyphMargin",J[J.gotoLocation=50]="gotoLocation",J[J.hideCursorInOverviewRuler=51]="hideCursorInOverviewRuler",J[J.hover=52]="hover",J[J.inDiffEditor=53]="inDiffEditor",J[J.inlineSuggest=54]="inlineSuggest",J[J.letterSpacing=55]="letterSpacing",J[J.lightbulb=56]="lightbulb",J[J.lineDecorationsWidth=57]="lineDecorationsWidth",J[J.lineHeight=58]="lineHeight",J[J.lineNumbers=59]="lineNumbers",J[J.lineNumbersMinChars=60]="lineNumbersMinChars",J[J.linkedEditing=61]="linkedEditing",J[J.links=62]="links",J[J.matchBrackets=63]="matchBrackets",J[J.minimap=64]="minimap",J[J.mouseStyle=65]="mouseStyle",J[J.mouseWheelScrollSensitivity=66]="mouseWheelScrollSensitivity",J[J.mouseWheelZoom=67]="mouseWheelZoom",J[J.multiCursorMergeOverlapping=68]="multiCursorMergeOverlapping",J[J.multiCursorModifier=69]="multiCursorModifier",J[J.multiCursorPaste=70]="multiCursorPaste",J[J.occurrencesHighlight=71]="occurrencesHighlight",J[J.overviewRulerBorder=72]="overviewRulerBorder",J[J.overviewRulerLanes=73]="overviewRulerLanes",J[J.padding=74]="padding",J[J.parameterHints=75]="parameterHints",J[J.peekWidgetDefaultFocus=76]="peekWidgetDefaultFocus",J[J.definitionLinkOpensInPeek=77]="definitionLinkOpensInPeek",J[J.quickSuggestions=78]="quickSuggestions",J[J.quickSuggestionsDelay=79]="quickSuggestionsDelay",J[J.readOnly=80]="readOnly",J[J.renameOnType=81]="renameOnType",J[J.renderControlCharacters=82]="renderControlCharacters",J[J.renderFinalNewline=83]="renderFinalNewline",J[J.renderLineHighlight=84]="renderLineHighlight",J[J.renderLineHighlightOnlyWhenFocus=85]="renderLineHighlightOnlyWhenFocus",J[J.renderValidationDecorations=86]="renderValidationDecorations",J[J.renderWhitespace=87]="renderWhitespace",J[J.revealHorizontalRightPadding=88]="revealHorizontalRightPadding",J[J.roundedSelection=89]="roundedSelection",J[J.rulers=90]="rulers",J[J.scrollbar=91]="scrollbar",J[J.scrollBeyondLastColumn=92]="scrollBeyondLastColumn",J[J.scrollBeyondLastLine=93]="scrollBeyondLastLine",J[J.scrollPredominantAxis=94]="scrollPredominantAxis",J[J.selectionClipboard=95]="selectionClipboard",J[J.selectionHighlight=96]="selectionHighlight",J[J.selectOnLineNumbers=97]="selectOnLineNumbers",J[J.showFoldingControls=98]="showFoldingControls",J[J.showUnused=99]="showUnused",J[J.snippetSuggestions=100]="snippetSuggestions",J[J.smartSelect=101]="smartSelect",J[J.smoothScrolling=102]="smoothScrolling",J[J.stickyTabStops=103]="stickyTabStops",J[J.stopRenderingLineAfter=104]="stopRenderingLineAfter",J[J.suggest=105]="suggest",J[J.suggestFontSize=106]="suggestFontSize",J[J.suggestLineHeight=107]="suggestLineHeight",J[J.suggestOnTriggerCharacters=108]="suggestOnTriggerCharacters",J[J.suggestSelection=109]="suggestSelection",J[J.tabCompletion=110]="tabCompletion",J[J.tabIndex=111]="tabIndex",J[J.unicodeHighlighting=112]="unicodeHighlighting",J[J.unusualLineTerminators=113]="unusualLineTerminators",J[J.useShadowDOM=114]="useShadowDOM",J[J.useTabStops=115]="useTabStops",J[J.wordSeparators=116]="wordSeparators",J[J.wordWrap=117]="wordWrap",J[J.wordWrapBreakAfterCharacters=118]="wordWrapBreakAfterCharacters",J[J.wordWrapBreakBeforeCharacters=119]="wordWrapBreakBeforeCharacters",J[J.wordWrapColumn=120]="wordWrapColumn",J[J.wordWrapOverride1=121]="wordWrapOverride1",J[J.wordWrapOverride2=122]="wordWrapOverride2",J[J.wrappingIndent=123]="wrappingIndent",J[J.wrappingStrategy=124]="wrappingStrategy",J[J.showDeprecated=125]="showDeprecated",J[J.inlayHints=126]="inlayHints",J[J.editorClassName=127]="editorClassName",J[J.pixelRatio=128]="pixelRatio",J[J.tabFocusMode=129]="tabFocusMode",J[J.layoutInfo=130]="layoutInfo",J[J.wrappingInfo=131]="wrappingInfo"})(Rt=e.EditorOption||(e.EditorOption={})),e.EditorOptions={acceptSuggestionOnCommitCharacter:Ue(new I(0,"acceptSuggestionOnCommitCharacter",!0,{markdownDescription:m.localize(146,null)})),acceptSuggestionOnEnter:Ue(new _(1,"acceptSuggestionOnEnter","on",["on","smart","off"],{markdownEnumDescriptions:["",m.localize(147,null),""],markdownDescription:m.localize(148,null)})),accessibilitySupport:Ue(new o),accessibilityPageSize:Ue(new s(3,"accessibilityPageSize",10,1,1073741824,{description:m.localize(149,null)})),ariaLabel:Ue(new g(4,"ariaLabel",m.localize(150,null))),autoClosingBrackets:Ue(new _(5,"autoClosingBrackets","languageDefined",["always","languageDefined","beforeWhitespace","never"],{enumDescriptions:["",m.localize(151,null),m.localize(152,null),""],description:m.localize(153,null)})),autoClosingDelete:Ue(new _(6,"autoClosingDelete","auto",["always","auto","never"],{enumDescriptions:["",m.localize(154,null),""],description:m.localize(155,null)})),autoClosingOvertype:Ue(new _(7,"autoClosingOvertype","auto",["always","auto","never"],{enumDescriptions:["",m.localize(156,null),""],description:m.localize(157,null)})),autoClosingQuotes:Ue(new _(8,"autoClosingQuotes","languageDefined",["always","languageDefined","beforeWhitespace","never"],{enumDescriptions:["",m.localize(158,null),m.localize(159,null),""],description:m.localize(160,null)})),autoIndent:Ue(new n(9,"autoIndent",4,"full",["none","keep","brackets","advanced","full"],t,{enumDescriptions:[m.localize(161,null),m.localize(162,null),m.localize(163,null),m.localize(164,null),m.localize(165,null)],description:m.localize(166,null)})),automaticLayout:Ue(new I(10,"automaticLayout",!1)),autoSurround:Ue(new _(11,"autoSurround","languageDefined",["languageDefined","quotes","brackets","never"],{enumDescriptions:[m.localize(167,null),m.localize(168,null),m.localize(169,null),""],description:m.localize(170,null)})),bracketPairColorization:Ue(new be),bracketPairGuides:Ue(new Me),stickyTabStops:Ue(new I(103,"stickyTabStops",!1,{description:m.localize(171,null)})),codeLens:Ue(new I(14,"codeLens",!0,{description:m.localize(172,null)})),codeLensFontFamily:Ue(new g(15,"codeLensFontFamily","",{description:m.localize(173,null)})),codeLensFontSize:Ue(new s(16,"codeLensFontSize",0,0,100,{type:"number",default:0,minimum:0,maximum:100,markdownDescription:m.localize(174,null)})),colorDecorators:Ue(new I(17,"colorDecorators",!0,{description:m.localize(175,null)})),columnSelection:Ue(new I(18,"columnSelection",!1,{description:m.localize(176,null)})),comments:Ue(new d),contextmenu:Ue(new I(20,"contextmenu",!0)),copyWithSyntaxHighlighting:Ue(new I(21,"copyWithSyntaxHighlighting",!0,{description:m.localize(177,null)})),cursorBlinking:Ue(new n(22,"cursorBlinking",1,"blink",["blink","smooth","phase","expand","solid"],h,{description:m.localize(178,null)})),cursorSmoothCaretAnimation:Ue(new I(23,"cursorSmoothCaretAnimation",!1,{description:m.localize(179,null)})),cursorStyle:Ue(new n(24,"cursorStyle",l.Line,"line",["line","block","underline","line-thin","block-outline","underline-thin"],T,{description:m.localize(180,null)})),cursorSurroundingLines:Ue(new s(25,"cursorSurroundingLines",0,0,1073741824,{description:m.localize(181,null)})),cursorSurroundingLinesStyle:Ue(new _(26,"cursorSurroundingLinesStyle","default",["default","all"],{enumDescriptions:[m.localize(182,null),m.localize(183,null)],description:m.localize(184,null)})),cursorWidth:Ue(new s(27,"cursorWidth",0,0,1073741824,{markdownDescription:m.localize(185,null)})),disableLayerHinting:Ue(new I(28,"disableLayerHinting",!1)),disableMonospaceOptimizations:Ue(new I(29,"disableMonospaceOptimizations",!1)),domReadOnly:Ue(new I(30,"domReadOnly",!1)),dragAndDrop:Ue(new I(31,"dragAndDrop",!0,{description:m.localize(186,null)})),emptySelectionClipboard:Ue(new x),extraEditorClassName:Ue(new g(33,"extraEditorClassName","")),fastScrollSensitivity:Ue(new r(34,"fastScrollSensitivity",5,J=>J<=0?5:J,{markdownDescription:m.localize(187,null)})),find:Ue(new O),fixedOverflowWidgets:Ue(new I(36,"fixedOverflowWidgets",!1)),folding:Ue(new I(37,"folding",!0,{description:m.localize(188,null)})),foldingStrategy:Ue(new _(38,"foldingStrategy","auto",["auto","indentation"],{enumDescriptions:[m.localize(189,null),m.localize(190,null)],description:m.localize(191,null)})),foldingHighlight:Ue(new I(39,"foldingHighlight",!0,{description:m.localize(192,null)})),foldingImportsByDefault:Ue(new I(40,"foldingImportsByDefault",!1,{description:m.localize(193,null)})),unfoldOnClickAfterEndOfLine:Ue(new I(41,"unfoldOnClickAfterEndOfLine",!1,{description:m.localize(194,null)})),fontFamily:Ue(new g(42,"fontFamily",e.EDITOR_FONT_DEFAULTS.fontFamily,{description:m.localize(195,null)})),fontInfo:Ue(new W),fontLigatures2:Ue(new F),fontSize:Ue(new M),fontWeight:Ue(new B),formatOnPaste:Ue(new I(47,"formatOnPaste",!1,{description:m.localize(196,null)})),formatOnType:Ue(new I(48,"formatOnType",!1,{description:m.localize(197,null)})),glyphMargin:Ue(new I(49,"glyphMargin",!0,{description:m.localize(198,null)})),gotoLocation:Ue(new U),hideCursorInOverviewRuler:Ue(new I(51,"hideCursorInOverviewRuler",!1,{description:m.localize(199,null)})),hover:Ue(new z),inDiffEditor:Ue(new I(53,"inDiffEditor",!1)),letterSpacing:Ue(new r(55,"letterSpacing",e.EDITOR_FONT_DEFAULTS.letterSpacing,J=>r.clamp(J,-5,20),{description:m.localize(200,null)})),lightbulb:Ue(new j),lineDecorationsWidth:Ue(new v(57,"lineDecorationsWidth",10)),lineHeight:Ue(new V),lineNumbers:Ue(new ze),lineNumbersMinChars:Ue(new s(60,"lineNumbersMinChars",5,1,300)),linkedEditing:Ue(new I(61,"linkedEditing",!1,{description:m.localize(201,null)})),links:Ue(new I(62,"links",!0,{description:m.localize(202,null)})),matchBrackets:Ue(new _(63,"matchBrackets","always",["always","near","never"],{description:m.localize(203,null)})),minimap:Ue(new q),mouseStyle:Ue(new _(65,"mouseStyle","text",["text","default","copy"])),mouseWheelScrollSensitivity:Ue(new r(66,"mouseWheelScrollSensitivity",1,J=>J===0?1:J,{markdownDescription:m.localize(204,null)})),mouseWheelZoom:Ue(new I(67,"mouseWheelZoom",!1,{markdownDescription:m.localize(205,null)})),multiCursorMergeOverlapping:Ue(new I(68,"multiCursorMergeOverlapping",!0,{description:m.localize(206,null)})),multiCursorModifier:Ue(new n(69,"multiCursorModifier","altKey","alt",["ctrlCmd","alt"],ne,{markdownEnumDescriptions:[m.localize(207,null),m.localize(208,null)],markdownDescription:m.localize(209,null)})),multiCursorPaste:Ue(new _(70,"multiCursorPaste","spread",["spread","full"],{markdownEnumDescriptions:[m.localize(210,null),m.localize(211,null)],markdownDescription:m.localize(212,null)})),occurrencesHighlight:Ue(new I(71,"occurrencesHighlight",!0,{description:m.localize(213,null)})),overviewRulerBorder:Ue(new I(72,"overviewRulerBorder",!0,{description:m.localize(214,null)})),overviewRulerLanes:Ue(new s(73,"overviewRulerLanes",3,0,3)),padding:Ue(new fe),parameterHints:Ue(new ye),peekWidgetDefaultFocus:Ue(new _(76,"peekWidgetDefaultFocus","tree",["tree","editor"],{enumDescriptions:[m.localize(215,null),m.localize(216,null)],description:m.localize(217,null)})),definitionLinkOpensInPeek:Ue(new I(77,"definitionLinkOpensInPeek",!1,{description:m.localize(218,null)})),quickSuggestions:Ue(new Be),quickSuggestionsDelay:Ue(new s(79,"quickSuggestionsDelay",10,0,1073741824,{description:m.localize(219,null)})),readOnly:Ue(new I(80,"readOnly",!1)),renameOnType:Ue(new I(81,"renameOnType",!1,{description:m.localize(220,null),markdownDeprecationMessage:m.localize(221,null)})),renderControlCharacters:Ue(new I(82,"renderControlCharacters",!0,{description:m.localize(222,null),restricted:!0})),renderFinalNewline:Ue(new I(83,"renderFinalNewline",!0,{description:m.localize(223,null)})),renderLineHighlight:Ue(new _(84,"renderLineHighlight","line",["none","gutter","line","all"],{enumDescriptions:["","","",m.localize(224,null)],description:m.localize(225,null)})),renderLineHighlightOnlyWhenFocus:Ue(new I(85,"renderLineHighlightOnlyWhenFocus",!1,{description:m.localize(226,null)})),renderValidationDecorations:Ue(new _(86,"renderValidationDecorations","editable",["editable","on","off"])),renderWhitespace:Ue(new _(87,"renderWhitespace","selection",["none","boundary","selection","trailing","all"],{enumDescriptions:["",m.localize(227,null),m.localize(228,null),m.localize(229,null),""],description:m.localize(230,null)})),revealHorizontalRightPadding:Ue(new s(88,"revealHorizontalRightPadding",30,0,1e3)),roundedSelection:Ue(new I(89,"roundedSelection",!0,{description:m.localize(231,null)})),rulers:Ue(new ee),scrollbar:Ue(new he),scrollBeyondLastColumn:Ue(new s(92,"scrollBeyondLastColumn",5,0,1073741824,{description:m.localize(232,null)})),scrollBeyondLastLine:Ue(new I(93,"scrollBeyondLastLine",!0,{description:m.localize(233,null)})),scrollPredominantAxis:Ue(new I(94,"scrollPredominantAxis",!0,{description:m.localize(234,null)})),selectionClipboard:Ue(new I(95,"selectionClipboard",!0,{description:m.localize(235,null),included:L.isLinux})),selectionHighlight:Ue(new I(96,"selectionHighlight",!0,{description:m.localize(236,null)})),selectOnLineNumbers:Ue(new I(97,"selectOnLineNumbers",!0)),showFoldingControls:Ue(new _(98,"showFoldingControls","mouseover",["always","mouseover"],{enumDescriptions:[m.localize(237,null),m.localize(238,null)],description:m.localize(239,null)})),showUnused:Ue(new I(99,"showUnused",!0,{description:m.localize(240,null)})),showDeprecated:Ue(new I(125,"showDeprecated",!0,{description:m.localize(241,null)})),inlayHints:Ue(new H),snippetSuggestions:Ue(new _(100,"snippetSuggestions","inline",["top","bottom","inline","none"],{enumDescriptions:[m.localize(242,null),m.localize(243,null),m.localize(244,null),m.localize(245,null)],description:m.localize(246,null)})),smartSelect:Ue(new Je),smoothScrolling:Ue(new I(102,"smoothScrolling",!1,{description:m.localize(247,null)})),stopRenderingLineAfter:Ue(new s(104,"stopRenderingLineAfter",1e4,-1,1073741824)),suggest:Ue(new Ge),inlineSuggest:Ue(new oe),suggestFontSize:Ue(new s(106,"suggestFontSize",0,0,1e3,{markdownDescription:m.localize(248,null)})),suggestLineHeight:Ue(new s(107,"suggestLineHeight",0,0,1e3,{markdownDescription:m.localize(249,null)})),suggestOnTriggerCharacters:Ue(new I(108,"suggestOnTriggerCharacters",!0,{description:m.localize(250,null)})),suggestSelection:Ue(new _(109,"suggestSelection","recentlyUsed",["first","recentlyUsed","recentlyUsedByPrefix"],{markdownEnumDescriptions:[m.localize(251,null),m.localize(252,null),m.localize(253,null)],description:m.localize(254,null)})),tabCompletion:Ue(new _(110,"tabCompletion","off",["on","off","onlySnippets"],{enumDescriptions:[m.localize(255,null),m.localize(256,null),m.localize(257,null)],description:m.localize(258,null)})),tabIndex:Ue(new s(111,"tabIndex",0,-1,1073741824)),unicodeHighlight:Ue(new Z),unusualLineTerminators:Ue(new _(113,"unusualLineTerminators","prompt",["auto","off","prompt"],{enumDescriptions:[m.localize(259,null),m.localize(260,null),m.localize(261,null)],description:m.localize(262,null)})),useShadowDOM:Ue(new I(114,"useShadowDOM",!0)),useTabStops:Ue(new I(115,"useTabStops",!0,{description:m.localize(263,null)})),wordSeparators:Ue(new g(116,"wordSeparators",y.USUAL_WORD_SEPARATORS,{description:m.localize(264,null)})),wordWrap:Ue(new _(117,"wordWrap","off",["off","on","wordWrapColumn","bounded"],{markdownEnumDescriptions:[m.localize(265,null),m.localize(266,null),m.localize(267,null),m.localize(268,null)],description:m.localize(269,null)})),wordWrapBreakAfterCharacters:Ue(new g(118,"wordWrapBreakAfterCharacters"," 	})]?|/&.,;\xA2\xB0\u2032\u2033\u2030\u2103\u3001\u3002\uFF61\uFF64\uFFE0\uFF0C\uFF0E\uFF1A\uFF1B\uFF1F\uFF01\uFF05\u30FB\uFF65\u309D\u309E\u30FD\u30FE\u30FC\u30A1\u30A3\u30A5\u30A7\u30A9\u30C3\u30E3\u30E5\u30E7\u30EE\u30F5\u30F6\u3041\u3043\u3045\u3047\u3049\u3063\u3083\u3085\u3087\u308E\u3095\u3096\u31F0\u31F1\u31F2\u31F3\u31F4\u31F5\u31F6\u31F7\u31F8\u31F9\u31FA\u31FB\u31FC\u31FD\u31FE\u31FF\u3005\u303B\uFF67\uFF68\uFF69\uFF6A\uFF6B\uFF6C\uFF6D\uFF6E\uFF6F\uFF70\u201D\u3009\u300B\u300D\u300F\u3011\u3015\uFF09\uFF3D\uFF5D\uFF63")),wordWrapBreakBeforeCharacters:Ue(new g(119,"wordWrapBreakBeforeCharacters","([{\u2018\u201C\u3008\u300A\u300C\u300E\u3010\u3014\uFF08\uFF3B\uFF5B\uFF62\xA3\xA5\uFF04\uFFE1\uFFE5+\uFF0B")),wordWrapColumn:Ue(new s(120,"wordWrapColumn",80,1,1073741824,{markdownDescription:m.localize(270,null)})),wordWrapOverride1:Ue(new _(121,"wordWrapOverride1","inherit",["off","on","inherit"])),wordWrapOverride2:Ue(new _(122,"wordWrapOverride2","inherit",["off","on","inherit"])),wrappingIndent:Ue(new n(123,"wrappingIndent",1,"same",["none","same","indent","deepIndent"],et,{enumDescriptions:[m.localize(271,null),m.localize(272,null),m.localize(273,null),m.localize(274,null)],description:m.localize(275,null)})),wrappingStrategy:Ue(new _(124,"wrappingStrategy","simple",["simple","advanced"],{enumDescriptions:[m.localize(276,null),m.localize(277,null)],description:m.localize(278,null)})),editorClassName:Ue(new A),pixelRatio:Ue(new ke),tabFocusMode:Ue(new tt),layoutInfo:Ue(new N),wrappingInfo:Ue(new it)}}),define(pe[155],ve([19,20]),function(Y,e){return Y.create("vs/platform/configuration/common/configurationRegistry",e)}),define(pe[156],ve([19,20]),function(Y,e){return Y.create("vs/platform/extensionManagement/common/extensionManagement",e)}),define(pe[157],ve([19,20]),function(Y,e){return Y.create("vs/platform/extensions/common/extensionValidator",e)}),define(pe[158],ve([19,20]),function(Y,e){return Y.create("vs/platform/externalTerminal/node/externalTerminalService",e)}),define(pe[159],ve([19,20]),function(Y,e){return Y.create("vs/platform/files/common/files",e)}),define(pe[160],ve([19,20]),function(Y,e){return Y.create("vs/platform/markers/common/markers",e)}),define(pe[161],ve([19,20]),function(Y,e){return Y.create("vs/platform/workspaces/common/workspaces",e)}),define(pe[162],ve([19,20]),function(Y,e){return Y.create("vs/workbench/api/common/extHostDiagnostics",e)}),define(pe[163],ve([19,20]),function(Y,e){return Y.create("vs/workbench/api/common/extHostExtensionService",e)}),define(pe[164],ve([19,20]),function(Y,e){return Y.create("vs/workbench/api/common/extHostProgress",e)}),define(pe[165],ve([19,20]),function(Y,e){return Y.create("vs/workbench/api/common/extHostStatusBar",e)}),define(pe[166],ve([19,20]),function(Y,e){return Y.create("vs/workbench/api/common/extHostTerminalService",e)}),define(pe[167],ve([19,20]),function(Y,e){return Y.create("vs/workbench/api/common/extHostTreeViews",e)}),define(pe[168],ve([19,20]),function(Y,e){return Y.create("vs/workbench/api/common/extHostWorkspace",e)}),define(pe[169],ve([19,20]),function(Y,e){return Y.create("vs/workbench/api/node/extHostDebugService",e)}),define(pe[170],ve([19,20]),function(Y,e){return Y.create("vs/workbench/api/node/extHostTunnelService",e)}),define(pe[171],ve([19,20]),function(Y,e){return Y.create("vs/workbench/common/editor",e)}),define(pe[172],ve([19,20]),function(Y,e){return Y.create("vs/workbench/contrib/debug/common/abstractDebugAdapter",e)}),define(pe[173],ve([19,20]),function(Y,e){return Y.create("vs/workbench/contrib/debug/node/debugAdapter",e)}),define(pe[174],ve([19,20]),function(Y,e){return Y.create("vs/workbench/contrib/search/common/queryBuilder",e)}),define(pe[175],ve([19,20]),function(Y,e){return Y.create("vs/workbench/contrib/tasks/common/taskService",e)}),define(pe[176],ve([19,20]),function(Y,e){return Y.create("vs/workbench/services/configurationResolver/common/variableResolver",e)}),define(pe[177],ve([0,1]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TextEditorSelectionRevealType=e.EditorOpenContext=e.EditorResolution=e.EditorActivation=void 0;var m;(function(i){i[i.ACTIVATE=1]="ACTIVATE",i[i.RESTORE=2]="RESTORE",i[i.PRESERVE=3]="PRESERVE"})(m=e.EditorActivation||(e.EditorActivation={}));var L;(function(i){i[i.PICK=0]="PICK",i[i.DISABLED=1]="DISABLED",i[i.EXCLUSIVE_ONLY=2]="EXCLUSIVE_ONLY"})(L=e.EditorResolution||(e.EditorResolution={}));var y;(function(i){i[i.API=0]="API",i[i.USER=1]="USER"})(y=e.EditorOpenContext||(e.EditorOpenContext={}));var C;(function(i){i[i.Center=0]="Center",i[i.CenterIfOutsideViewport=1]="CenterIfOutsideViewport",i[i.NearTop=2]="NearTop",i[i.NearTopIfOutsideViewport=3]="NearTopIfOutsideViewport"})(C=e.TextEditorSelectionRevealType||(e.TextEditorSelectionRevealType={}))}),define(pe[178],ve([0,1,157]),function(Y,e,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isEngineValid=e.isValidExtensionVersion=e.isValidVersion=e.normalizeVersion=e.parseVersion=e.isValidVersionStr=void 0;const L=/^(\^|>=)?((\d+)|x)\.((\d+)|x)\.((\d+)|x)(\-.*)?$/,y=/^-(\d{4})(\d{2})(\d{2})$/;function C(u){return u=u.trim(),u==="*"||L.test(u)}e.isValidVersionStr=C;function i(u){if(!C(u))return null;if(u=u.trim(),u==="*")return{hasCaret:!1,hasGreaterEquals:!1,majorBase:0,majorMustEqual:!1,minorBase:0,minorMustEqual:!1,patchBase:0,patchMustEqual:!1,preRelease:null};let E=u.match(L);return E?{hasCaret:E[1]==="^",hasGreaterEquals:E[1]===">=",majorBase:E[2]==="x"?0:parseInt(E[2],10),majorMustEqual:E[2]!=="x",minorBase:E[4]==="x"?0:parseInt(E[4],10),minorMustEqual:E[4]!=="x",patchBase:E[6]==="x"?0:parseInt(E[6],10),patchMustEqual:E[6]!=="x",preRelease:E[8]||null}:null}e.parseVersion=i;function k(u){if(!u)return null;let E=u.majorBase,f=u.majorMustEqual,v=u.minorBase,w=u.minorMustEqual,I=u.patchBase,p=u.patchMustEqual;u.hasCaret&&(E===0||(w=!1),p=!1);let s=0;if(u.preRelease){const r=y.exec(u.preRelease);if(r){const[,g,a,_]=r;s=Date.UTC(Number(g),Number(a)-1,Number(_))}}return{majorBase:E,majorMustEqual:f,minorBase:v,minorMustEqual:w,patchBase:I,patchMustEqual:p,isMinimum:u.hasGreaterEquals,notBefore:s}}e.normalizeVersion=k;function S(u,E,f){let v;typeof u=="string"?v=k(i(u)):v=u;let w;E instanceof Date?w=E.getTime():typeof E=="string"&&(w=new Date(E).getTime());let I;if(typeof f=="string"?I=k(i(f)):I=f,!v||!I)return!1;let p=v.majorBase,s=v.minorBase,r=v.patchBase,g=I.majorBase,a=I.minorBase,_=I.patchBase,n=I.notBefore,t=I.majorMustEqual,o=I.minorMustEqual,d=I.patchMustEqual;return I.isMinimum?p>g?!0:p<g?!1:s>a?!0:s<a||w&&w<n?!1:r>=_:(p===1&&g===0&&(!t||!o||!d)&&(g=1,a=0,_=0,t=!0,o=!1,d=!1),p<g?!1:p>g?!t:s<a?!1:s>a?!o:r<_?!1:r>_?!d:!(w&&w<n))}e.isValidVersion=S;function D(u,E,f,v){return f.isBuiltin||typeof f.main=="undefined"?!0:P(u,E,f.engines.vscode,v)}e.isValidExtensionVersion=D;function R(u,E,f){return u==="*"||P(E,f,u)}e.isEngineValid=R;function P(u,E,f,v=[]){let w=k(i(f));if(!w)return v.push(m.localize(0,null,f)),!1;if(w.majorBase===0){if(!w.majorMustEqual||!w.minorMustEqual)return v.push(m.localize(1,null,f)),!1}else if(!w.majorMustEqual)return v.push(m.localize(2,null,f)),!1;return S(u,E,w)?!0:(v.push(m.localize(3,null,u,f)),!1)}}),define(pe[114],ve([0,1]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SyncDescriptor=void 0;class m{constructor(y,C=[],i=!1){this.ctor=y,this.staticArguments=C,this.supportsDelayedInstantiation=i}}e.SyncDescriptor=m}),define(pe[83],ve([0,1,114]),function(Y,e,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getSingletonServiceDescriptors=e.registerSingleton=void 0;const L=[];function y(i,k,S){k instanceof m.SyncDescriptor||(k=new m.SyncDescriptor(k,[],S)),L.push([i,k])}e.registerSingleton=y;function C(){return L}e.getSingletonServiceDescriptors=C}),define(pe[179],ve([0,1]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Graph=e.Node=void 0;class m{constructor(C){this.incoming=new Map,this.outgoing=new Map,this.data=C}}e.Node=m;class L{constructor(C){this._hashFn=C,this._nodes=new Map}roots(){const C=[];for(let i of this._nodes.values())i.outgoing.size===0&&C.push(i);return C}insertEdge(C,i){const k=this.lookupOrInsertNode(C),S=this.lookupOrInsertNode(i);k.outgoing.set(this._hashFn(i),S),S.incoming.set(this._hashFn(C),k)}removeNode(C){const i=this._hashFn(C);this._nodes.delete(i);for(let k of this._nodes.values())k.outgoing.delete(i),k.incoming.delete(i)}lookupOrInsertNode(C){const i=this._hashFn(C);let k=this._nodes.get(i);return k||(k=new m(C),this._nodes.set(i,k)),k}lookup(C){return this._nodes.get(this._hashFn(C))}isEmpty(){return this._nodes.size===0}toString(){let C=[];for(let[i,k]of this._nodes)C.push(`${i}, (incoming)[${[...k.incoming.keys()].join(", ")}], (outgoing)[${[...k.outgoing.keys()].join(",")}]`);return C.join(`
`)}findCycleSlow(){for(let[C,i]of this._nodes){const k=new Set([C]),S=this._findCycle(i,k);if(S)return S}}_findCycle(C,i){for(let[k,S]of C.outgoing){if(i.has(k))return[...i,k].join(" -> ");i.add(k);const D=this._findCycle(S,i);if(D)return D;i.delete(k)}}}e.Graph=L}),define(pe[4],ve([0,1]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.refineServiceDecorator=e.createDecorator=e.IInstantiationService=e._util=void 0;var m;(function(i){i.serviceIds=new Map,i.DI_TARGET="$di$target",i.DI_DEPENDENCIES="$di$dependencies";function k(S){return S[i.DI_DEPENDENCIES]||[]}i.getServiceDependencies=k})(m=e._util||(e._util={})),e.IInstantiationService=y("instantiationService");function L(i,k,S,D){k[m.DI_TARGET]===k?k[m.DI_DEPENDENCIES].push({id:i,index:S,optional:D}):(k[m.DI_DEPENDENCIES]=[{id:i,index:S,optional:D}],k[m.DI_TARGET]=k)}function y(i){if(m.serviceIds.has(i))return m.serviceIds.get(i);const k=function(S,D,R){if(arguments.length!==3)throw new Error("@IServiceName-decorator can only be used to decorate a parameter");L(k,S,R,!1)};return k.toString=()=>i,m.serviceIds.set(i,k),k}e.createDecorator=y;function C(i){return i}e.refineServiceDecorator=C}),define(pe[180],ve([0,1,4]),function(Y,e,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.shouldSynchronizeModel=e.IModelService=void 0,e.IModelService=(0,m.createDecorator)("modelService");function L(y){return!y.isTooLargeForSyncing()&&!y.isForSimpleWidget}e.shouldSynchronizeModel=L}),define(pe[181],ve([0,1,3,47,6,24,77,82,180]),function(Y,e,m,L,y,C,i,k,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LanguageFeatureRequestDelays=e.LanguageFeatureRegistry=void 0;function D(v){return typeof v=="string"?!1:Array.isArray(v)?v.every(D):!!v.exclusive}class R{constructor(){this._clock=0,this._entries=[],this._onDidChange=new m.Emitter}get onDidChange(){return this._onDidChange.event}register(w,I){let p={selector:w,provider:I,_score:-1,_time:this._clock++};return this._entries.push(p),this._lastCandidate=void 0,this._onDidChange.fire(this._entries.length),(0,y.toDisposable)(()=>{if(p){let s=this._entries.indexOf(p);s>=0&&(this._entries.splice(s,1),this._lastCandidate=void 0,this._onDidChange.fire(this._entries.length),p=void 0)}})}has(w){return this.all(w).length>0}all(w){if(!w)return[];this._updateScores(w);const I=[];for(let p of this._entries)p._score>0&&I.push(p.provider);return I}ordered(w){const I=[];return this._orderedForEach(w,p=>I.push(p.provider)),I}orderedGroups(w){const I=[];let p,s;return this._orderedForEach(w,r=>{p&&s===r._score?p.push(r.provider):(s=r._score,p=[r.provider],I.push(p))}),I}_orderedForEach(w,I){if(!!w){this._updateScores(w);for(const p of this._entries)p._score>0&&I(p)}}_updateScores(w){let I={uri:w.uri.toString(),language:w.getLanguageId()};if(!(this._lastCandidate&&this._lastCandidate.language===I.language&&this._lastCandidate.uri===I.uri)){this._lastCandidate=I;for(let p of this._entries)if(p._score=(0,k.score)(p.selector,w.uri,w.getLanguageId(),(0,S.shouldSynchronizeModel)(w)),D(p.selector)&&p._score>0){for(let s of this._entries)s._score=0;p._score=1e3;break}this._entries.sort(R._compareByScoreAndTime)}}static _compareByScoreAndTime(w,I){return w._score<I._score?1:w._score>I._score?-1:w._time<I._time?1:w._time>I._time?-1:0}}e.LanguageFeatureRegistry=R;const P=new WeakMap;let u=0;function E(v){let w=P.get(v);return w===void 0&&(w=++u,P.set(v,w)),w}class f{constructor(w,I,p=Number.MAX_SAFE_INTEGER){this._registry=w,this.min=I,this.max=p,this._cache=new C.LRUCache(50,.7)}_key(w){return w.id+this._registry.all(w).reduce((I,p)=>(0,L.doHash)(E(p),I),0)}_clamp(w){return w===void 0?this.min:Math.min(this.max,Math.max(this.min,Math.floor(w*1.3)))}get(w){const I=this._key(w),p=this._cache.get(I);return this._clamp(p?.value)}update(w,I){const p=this._key(w);let s=this._cache.get(p);return s||(s=new i.MovingAverage,this._cache.set(p,s)),s.update(I),this.get(w)}}e.LanguageFeatureRequestDelays=f}),define(pe[84],ve([0,1,2,41,181,148,78]),function(Y,e,m,L,y,C,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExternalUriOpenerPriority=e.TokenizationRegistry=e.DocumentRangeSemanticTokensProviderRegistry=e.DocumentSemanticTokensProviderRegistry=e.FoldingRangeProviderRegistry=e.SelectionRangeRegistry=e.ColorProviderRegistry=e.LinkProviderRegistry=e.OnTypeFormattingEditProviderRegistry=e.DocumentRangeFormattingEditProviderRegistry=e.DocumentFormattingEditProviderRegistry=e.CodeActionProviderRegistry=e.InlayHintsProviderRegistry=e.CodeLensProviderRegistry=e.TypeDefinitionProviderRegistry=e.ImplementationProviderRegistry=e.DeclarationProviderRegistry=e.DefinitionProviderRegistry=e.LinkedEditingRangeProviderRegistry=e.DocumentHighlightProviderRegistry=e.DocumentSymbolProviderRegistry=e.InlineValuesProviderRegistry=e.EvaluatableExpressionProviderRegistry=e.HoverProviderRegistry=e.SignatureHelpProviderRegistry=e.InlineCompletionsProviderRegistry=e.CompletionProviderRegistry=e.RenameProviderRegistry=e.ReferenceProviderRegistry=e.InlayHintKind=e.CommentMode=e.CommentThreadCollapsibleState=e.FoldingRangeKind=e.SymbolKinds=e.SymbolTag=e.SymbolKind=e.isLocationLink=e.DocumentHighlightKind=e.SignatureHelpTriggerKind=e.CodeActionTriggerType=e.InlineCompletionTriggerKind=e.CompletionTriggerKind=e.CompletionItemInsertTextRule=e.CompletionItemTag=e.completionKindFromString=e.completionKindToCssClass=e.CompletionItemKind=e.TokenMetadata=e.MetadataConsts=e.StandardTokenType=e.ColorId=e.FontStyle=e.LanguageId=void 0;var k;(function(l){l[l.Null=0]="Null",l[l.PlainText=1]="PlainText"})(k=e.LanguageId||(e.LanguageId={}));var S;(function(l){l[l.NotSet=-1]="NotSet",l[l.None=0]="None",l[l.Italic=1]="Italic",l[l.Bold=2]="Bold",l[l.Underline=4]="Underline"})(S=e.FontStyle||(e.FontStyle={}));var D;(function(l){l[l.None=0]="None",l[l.DefaultForeground=1]="DefaultForeground",l[l.DefaultBackground=2]="DefaultBackground"})(D=e.ColorId||(e.ColorId={}));var R;(function(l){l[l.Other=0]="Other",l[l.Comment=1]="Comment",l[l.String=2]="String",l[l.RegEx=4]="RegEx"})(R=e.StandardTokenType||(e.StandardTokenType={}));var P;(function(l){l[l.LANGUAGEID_MASK=255]="LANGUAGEID_MASK",l[l.TOKEN_TYPE_MASK=1792]="TOKEN_TYPE_MASK",l[l.FONT_STYLE_MASK=14336]="FONT_STYLE_MASK",l[l.FOREGROUND_MASK=8372224]="FOREGROUND_MASK",l[l.BACKGROUND_MASK=4286578688]="BACKGROUND_MASK",l[l.ITALIC_MASK=2048]="ITALIC_MASK",l[l.BOLD_MASK=4096]="BOLD_MASK",l[l.UNDERLINE_MASK=8192]="UNDERLINE_MASK",l[l.SEMANTIC_USE_ITALIC=1]="SEMANTIC_USE_ITALIC",l[l.SEMANTIC_USE_BOLD=2]="SEMANTIC_USE_BOLD",l[l.SEMANTIC_USE_UNDERLINE=4]="SEMANTIC_USE_UNDERLINE",l[l.SEMANTIC_USE_FOREGROUND=8]="SEMANTIC_USE_FOREGROUND",l[l.SEMANTIC_USE_BACKGROUND=16]="SEMANTIC_USE_BACKGROUND",l[l.LANGUAGEID_OFFSET=0]="LANGUAGEID_OFFSET",l[l.TOKEN_TYPE_OFFSET=8]="TOKEN_TYPE_OFFSET",l[l.FONT_STYLE_OFFSET=11]="FONT_STYLE_OFFSET",l[l.FOREGROUND_OFFSET=14]="FOREGROUND_OFFSET",l[l.BACKGROUND_OFFSET=23]="BACKGROUND_OFFSET"})(P=e.MetadataConsts||(e.MetadataConsts={}));class u{static getLanguageId(b){return(b&255)>>>0}static getTokenType(b){return(b&1792)>>>8}static getFontStyle(b){return(b&14336)>>>11}static getForeground(b){return(b&8372224)>>>14}static getBackground(b){return(b&4286578688)>>>23}static getClassNameFromMetadata(b){let T=this.getForeground(b),A="mtk"+T,x=this.getFontStyle(b);return x&1&&(A+=" mtki"),x&2&&(A+=" mtkb"),x&4&&(A+=" mtku"),A}static getInlineStyleFromMetadata(b,T){const A=this.getForeground(b),x=this.getFontStyle(b);let O=`color: ${T[A]};`;return x&1&&(O+="font-style: italic;"),x&2&&(O+="font-weight: bold;"),x&4&&(O+="text-decoration: underline;"),O}}e.TokenMetadata=u;var E;(function(l){l[l.Method=0]="Method",l[l.Function=1]="Function",l[l.Constructor=2]="Constructor",l[l.Field=3]="Field",l[l.Variable=4]="Variable",l[l.Class=5]="Class",l[l.Struct=6]="Struct",l[l.Interface=7]="Interface",l[l.Module=8]="Module",l[l.Property=9]="Property",l[l.Event=10]="Event",l[l.Operator=11]="Operator",l[l.Unit=12]="Unit",l[l.Value=13]="Value",l[l.Constant=14]="Constant",l[l.Enum=15]="Enum",l[l.EnumMember=16]="EnumMember",l[l.Keyword=17]="Keyword",l[l.Text=18]="Text",l[l.Color=19]="Color",l[l.File=20]="File",l[l.Reference=21]="Reference",l[l.Customcolor=22]="Customcolor",l[l.Folder=23]="Folder",l[l.TypeParameter=24]="TypeParameter",l[l.User=25]="User",l[l.Issue=26]="Issue",l[l.Snippet=27]="Snippet"})(E=e.CompletionItemKind||(e.CompletionItemKind={})),e.completionKindToCssClass=function(){let l=Object.create(null);return l[0]="symbol-method",l[1]="symbol-function",l[2]="symbol-constructor",l[3]="symbol-field",l[4]="symbol-variable",l[5]="symbol-class",l[6]="symbol-struct",l[7]="symbol-interface",l[8]="symbol-module",l[9]="symbol-property",l[10]="symbol-event",l[11]="symbol-operator",l[12]="symbol-unit",l[13]="symbol-value",l[14]="symbol-constant",l[15]="symbol-enum",l[16]="symbol-enum-member",l[17]="symbol-keyword",l[27]="symbol-snippet",l[18]="symbol-text",l[19]="symbol-color",l[20]="symbol-file",l[21]="symbol-reference",l[22]="symbol-customcolor",l[23]="symbol-folder",l[24]="symbol-type-parameter",l[25]="account",l[26]="issues",function(b){const T=l[b];let A=T&&i.iconRegistry.get(T);return A||(console.info("No codicon found for CompletionItemKind "+b),A=i.Codicon.symbolProperty),A.classNames}}(),e.completionKindFromString=function(){let l=Object.create(null);return l.method=0,l.function=1,l.constructor=2,l.field=3,l.variable=4,l.class=5,l.struct=6,l.interface=7,l.module=8,l.property=9,l.event=10,l.operator=11,l.unit=12,l.value=13,l.constant=14,l.enum=15,l["enum-member"]=16,l.enumMember=16,l.keyword=17,l.snippet=27,l.text=18,l.color=19,l.file=20,l.reference=21,l.customcolor=22,l.folder=23,l["type-parameter"]=24,l.typeParameter=24,l.account=25,l.issue=26,function(b,T){let A=l[b];return typeof A=="undefined"&&!T&&(A=9),A}}();var f;(function(l){l[l.Deprecated=1]="Deprecated"})(f=e.CompletionItemTag||(e.CompletionItemTag={}));var v;(function(l){l[l.KeepWhitespace=1]="KeepWhitespace",l[l.InsertAsSnippet=4]="InsertAsSnippet"})(v=e.CompletionItemInsertTextRule||(e.CompletionItemInsertTextRule={}));var w;(function(l){l[l.Invoke=0]="Invoke",l[l.TriggerCharacter=1]="TriggerCharacter",l[l.TriggerForIncompleteCompletions=2]="TriggerForIncompleteCompletions"})(w=e.CompletionTriggerKind||(e.CompletionTriggerKind={}));var I;(function(l){l[l.Automatic=0]="Automatic",l[l.Explicit=1]="Explicit"})(I=e.InlineCompletionTriggerKind||(e.InlineCompletionTriggerKind={}));var p;(function(l){l[l.Invoke=1]="Invoke",l[l.Auto=2]="Auto"})(p=e.CodeActionTriggerType||(e.CodeActionTriggerType={}));var s;(function(l){l[l.Invoke=1]="Invoke",l[l.TriggerCharacter=2]="TriggerCharacter",l[l.ContentChange=3]="ContentChange"})(s=e.SignatureHelpTriggerKind||(e.SignatureHelpTriggerKind={}));var r;(function(l){l[l.Text=0]="Text",l[l.Read=1]="Read",l[l.Write=2]="Write"})(r=e.DocumentHighlightKind||(e.DocumentHighlightKind={}));function g(l){return l&&m.URI.isUri(l.uri)&&L.Range.isIRange(l.range)&&(L.Range.isIRange(l.originSelectionRange)||L.Range.isIRange(l.targetSelectionRange))}e.isLocationLink=g;var a;(function(l){l[l.File=0]="File",l[l.Module=1]="Module",l[l.Namespace=2]="Namespace",l[l.Package=3]="Package",l[l.Class=4]="Class",l[l.Method=5]="Method",l[l.Property=6]="Property",l[l.Field=7]="Field",l[l.Constructor=8]="Constructor",l[l.Enum=9]="Enum",l[l.Interface=10]="Interface",l[l.Function=11]="Function",l[l.Variable=12]="Variable",l[l.Constant=13]="Constant",l[l.String=14]="String",l[l.Number=15]="Number",l[l.Boolean=16]="Boolean",l[l.Array=17]="Array",l[l.Object=18]="Object",l[l.Key=19]="Key",l[l.Null=20]="Null",l[l.EnumMember=21]="EnumMember",l[l.Struct=22]="Struct",l[l.Event=23]="Event",l[l.Operator=24]="Operator",l[l.TypeParameter=25]="TypeParameter"})(a=e.SymbolKind||(e.SymbolKind={}));var _;(function(l){l[l.Deprecated=1]="Deprecated"})(_=e.SymbolTag||(e.SymbolTag={}));var n;(function(l){const b=new Map;b.set("file",0),b.set("module",1),b.set("namespace",2),b.set("package",3),b.set("class",4),b.set("method",5),b.set("property",6),b.set("field",7),b.set("constructor",8),b.set("enum",9),b.set("interface",10),b.set("function",11),b.set("variable",12),b.set("constant",13),b.set("string",14),b.set("number",15),b.set("boolean",16),b.set("array",17),b.set("object",18),b.set("key",19),b.set("null",20),b.set("enum-member",21),b.set("struct",22),b.set("event",23),b.set("operator",24),b.set("type-parameter",25);const T=new Map;T.set(0,"file"),T.set(1,"module"),T.set(2,"namespace"),T.set(3,"package"),T.set(4,"class"),T.set(5,"method"),T.set(6,"property"),T.set(7,"field"),T.set(8,"constructor"),T.set(9,"enum"),T.set(10,"interface"),T.set(11,"function"),T.set(12,"variable"),T.set(13,"constant"),T.set(14,"string"),T.set(15,"number"),T.set(16,"boolean"),T.set(17,"array"),T.set(18,"object"),T.set(19,"key"),T.set(20,"null"),T.set(21,"enum-member"),T.set(22,"struct"),T.set(23,"event"),T.set(24,"operator"),T.set(25,"type-parameter");function A(F){return b.get(F)}l.fromString=A;function x(F){return T.get(F)}l.toString=x;function O(F,W){const M=T.get(F);let B=M&&i.iconRegistry.get("symbol-"+M);return B||(console.info("No codicon found for SymbolKind "+F),B=i.Codicon.symbolProperty),`${W?"inline":"block"} ${B.classNames}`}l.toCssClassName=O})(n=e.SymbolKinds||(e.SymbolKinds={}));class t{constructor(b){this.value=b}}e.FoldingRangeKind=t,t.Comment=new t("comment"),t.Imports=new t("imports"),t.Region=new t("region");var o;(function(l){l[l.Collapsed=0]="Collapsed",l[l.Expanded=1]="Expanded"})(o=e.CommentThreadCollapsibleState||(e.CommentThreadCollapsibleState={}));var d;(function(l){l[l.Editing=0]="Editing",l[l.Preview=1]="Preview"})(d=e.CommentMode||(e.CommentMode={}));var c;(function(l){l[l.Other=0]="Other",l[l.Type=1]="Type",l[l.Parameter=2]="Parameter"})(c=e.InlayHintKind||(e.InlayHintKind={})),e.ReferenceProviderRegistry=new y.LanguageFeatureRegistry,e.RenameProviderRegistry=new y.LanguageFeatureRegistry,e.CompletionProviderRegistry=new y.LanguageFeatureRegistry,e.InlineCompletionsProviderRegistry=new y.LanguageFeatureRegistry,e.SignatureHelpProviderRegistry=new y.LanguageFeatureRegistry,e.HoverProviderRegistry=new y.LanguageFeatureRegistry,e.EvaluatableExpressionProviderRegistry=new y.LanguageFeatureRegistry,e.InlineValuesProviderRegistry=new y.LanguageFeatureRegistry,e.DocumentSymbolProviderRegistry=new y.LanguageFeatureRegistry,e.DocumentHighlightProviderRegistry=new y.LanguageFeatureRegistry,e.LinkedEditingRangeProviderRegistry=new y.LanguageFeatureRegistry,e.DefinitionProviderRegistry=new y.LanguageFeatureRegistry,e.DeclarationProviderRegistry=new y.LanguageFeatureRegistry,e.ImplementationProviderRegistry=new y.LanguageFeatureRegistry,e.TypeDefinitionProviderRegistry=new y.LanguageFeatureRegistry,e.CodeLensProviderRegistry=new y.LanguageFeatureRegistry,e.InlayHintsProviderRegistry=new y.LanguageFeatureRegistry,e.CodeActionProviderRegistry=new y.LanguageFeatureRegistry,e.DocumentFormattingEditProviderRegistry=new y.LanguageFeatureRegistry,e.DocumentRangeFormattingEditProviderRegistry=new y.LanguageFeatureRegistry,e.OnTypeFormattingEditProviderRegistry=new y.LanguageFeatureRegistry,e.LinkProviderRegistry=new y.LanguageFeatureRegistry,e.ColorProviderRegistry=new y.LanguageFeatureRegistry,e.SelectionRangeRegistry=new y.LanguageFeatureRegistry,e.FoldingRangeProviderRegistry=new y.LanguageFeatureRegistry,e.DocumentSemanticTokensProviderRegistry=new y.LanguageFeatureRegistry,e.DocumentRangeSemanticTokensProviderRegistry=new y.LanguageFeatureRegistry,e.TokenizationRegistry=new C.TokenizationRegistryImpl;var h;(function(l){l[l.None=0]="None",l[l.Option=1]="Option",l[l.Default=2]="Default",l[l.Preferred=3]="Preferred"})(h=e.ExternalUriOpenerPriority||(e.ExternalUriOpenerPriority={}))}),define(pe[115],ve([0,1,13,2,4]),function(Y,e,m,L,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getMigratedSettingValue=e.merge=e.getConfigurationValue=e.removeFromValueTree=e.addToValueTree=e.toValuesTree=e.ConfigurationTargetToString=e.ConfigurationTarget=e.isConfigurationUpdateOverrides=e.isConfigurationOverrides=e.IConfigurationService=void 0,e.IConfigurationService=(0,y.createDecorator)("configurationService");function C(w){return w&&typeof w=="object"&&(!w.overrideIdentifier||typeof w.overrideIdentifier=="string")&&(!w.resource||w.resource instanceof L.URI)}e.isConfigurationOverrides=C;function i(w){return w&&typeof w=="object"&&(!w.overrideIdentifiers||m.isArray(w.overrideIdentifiers))&&!w.overrideIdentifier&&(!w.resource||w.resource instanceof L.URI)}e.isConfigurationUpdateOverrides=i;var k;(function(w){w[w.USER=1]="USER",w[w.USER_LOCAL=2]="USER_LOCAL",w[w.USER_REMOTE=3]="USER_REMOTE",w[w.WORKSPACE=4]="WORKSPACE",w[w.WORKSPACE_FOLDER=5]="WORKSPACE_FOLDER",w[w.DEFAULT=6]="DEFAULT",w[w.MEMORY=7]="MEMORY"})(k=e.ConfigurationTarget||(e.ConfigurationTarget={}));function S(w){switch(w){case 1:return"USER";case 2:return"USER_LOCAL";case 3:return"USER_REMOTE";case 4:return"WORKSPACE";case 5:return"WORKSPACE_FOLDER";case 6:return"DEFAULT";case 7:return"MEMORY"}}e.ConfigurationTargetToString=S;function D(w,I){const p=Object.create(null);for(let s in w)R(p,s,w[s],I);return p}e.toValuesTree=D;function R(w,I,p,s){const r=I.split("."),g=r.pop();let a=w;for(let _=0;_<r.length;_++){let n=r[_],t=a[n];switch(typeof t){case"undefined":t=a[n]=Object.create(null);break;case"object":break;default:s(`Ignoring ${I} as ${r.slice(0,_+1).join(".")} is ${JSON.stringify(t)}`);return}a=t}if(typeof a=="object"&&a!==null)try{a[g]=p}catch(_){s(`Ignoring ${I} as ${r.join(".")} is ${JSON.stringify(a)}`)}else s(`Ignoring ${I} as ${r.join(".")} is ${JSON.stringify(a)}`)}e.addToValueTree=R;function P(w,I){const p=I.split(".");u(w,p)}e.removeFromValueTree=P;function u(w,I){const p=I.shift();if(I.length===0){delete w[p];return}if(Object.keys(w).indexOf(p)!==-1){const s=w[p];typeof s=="object"&&!Array.isArray(s)&&(u(s,I),Object.keys(s).length===0&&delete w[p])}}function E(w,I,p){function s(a,_){let n=a;for(const t of _){if(typeof n!="object"||n===null)return;n=n[t]}return n}const r=I.split("."),g=s(w,r);return typeof g=="undefined"?p:g}e.getConfigurationValue=E;function f(w,I,p){Object.keys(I).forEach(s=>{s!=="__proto__"&&(s in w?m.isObject(w[s])&&m.isObject(I[s])?f(w[s],I[s],p):p&&(w[s]=I[s]):w[s]=I[s])})}e.merge=f;function v(w,I,p){const s=w.inspect(I),r=w.inspect(p);return typeof s.userValue!="undefined"||typeof s.workspaceValue!="undefined"||typeof s.workspaceFolderValue!="undefined"?s.value:typeof r.userValue!="undefined"||typeof r.workspaceValue!="undefined"||typeof r.workspaceFolderValue!="undefined"?r.value:s.defaultValue}e.getMigratedSettingValue=v}),define(pe[61],ve([0,1,12,8,4]),function(Y,e,m,L,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.implies=e.SET_CONTEXT_COMMAND_ID=e.IContextKeyService=e.RawContextKey=e.ContextKeyNotRegexExpr=e.ContextKeyRegexExpr=e.ContextKeySmallerEqualsExpr=e.ContextKeySmallerExpr=e.ContextKeyGreaterEqualsExpr=e.ContextKeyGreaterExpr=e.ContextKeyNotExpr=e.ContextKeyNotEqualsExpr=e.ContextKeyNotInExpr=e.ContextKeyInExpr=e.ContextKeyEqualsExpr=e.ContextKeyDefinedExpr=e.ContextKeyTrueExpr=e.ContextKeyFalseExpr=e.expressionsAreEqualWithConstantSubstitution=e.ContextKeyExpr=e.ContextKeyExprType=void 0;let C=m.userAgent||"";const i=new Map;i.set("false",!1),i.set("true",!0),i.set("isMac",m.isMacintosh),i.set("isLinux",m.isLinux),i.set("isWindows",m.isWindows),i.set("isWeb",m.isWeb),i.set("isMacNative",m.isMacintosh&&!m.isWeb),i.set("isEdge",C.indexOf("Edg/")>=0),i.set("isFirefox",C.indexOf("Firefox")>=0),i.set("isChrome",C.indexOf("Chrome")>=0),i.set("isSafari",C.indexOf("Safari")>=0);const k=Object.prototype.hasOwnProperty;var S;(function(O){O[O.False=0]="False",O[O.True=1]="True",O[O.Defined=2]="Defined",O[O.Not=3]="Not",O[O.Equals=4]="Equals",O[O.NotEquals=5]="NotEquals",O[O.And=6]="And",O[O.Regex=7]="Regex",O[O.NotRegex=8]="NotRegex",O[O.Or=9]="Or",O[O.In=10]="In",O[O.NotIn=11]="NotIn",O[O.Greater=12]="Greater",O[O.GreaterEquals=13]="GreaterEquals",O[O.Smaller=14]="Smaller",O[O.SmallerEquals=15]="SmallerEquals"})(S=e.ContextKeyExprType||(e.ContextKeyExprType={}));class D{static false(){return u.INSTANCE}static true(){return E.INSTANCE}static has(F){return f.create(F)}static equals(F,W){return v.create(F,W)}static notEquals(F,W){return p.create(F,W)}static regex(F,W){return t.create(F,W)}static in(F,W){return w.create(F,W)}static not(F){return s.create(F)}static and(...F){return c.create(F,null)}static or(...F){return h.create(F,null,!0)}static greater(F,W){return g.create(F,W)}static greaterEquals(F,W){return a.create(F,W)}static smaller(F,W){return _.create(F,W)}static smallerEquals(F,W){return n.create(F,W)}static deserialize(F,W=!1){if(!!F)return this._deserializeOrExpression(F,W)}static _deserializeOrExpression(F,W){let M=F.split("||");return h.create(M.map(B=>this._deserializeAndExpression(B,W)),null,!0)}static _deserializeAndExpression(F,W){let M=F.split("&&");return c.create(M.map(B=>this._deserializeOne(B,W)),null)}static _deserializeOne(F,W){if(F=F.trim(),F.indexOf("!=")>=0){let M=F.split("!=");return p.create(M[0].trim(),this._deserializeValue(M[1],W))}if(F.indexOf("==")>=0){let M=F.split("==");return v.create(M[0].trim(),this._deserializeValue(M[1],W))}if(F.indexOf("=~")>=0){let M=F.split("=~");return t.create(M[0].trim(),this._deserializeRegexValue(M[1],W))}if(F.indexOf(" in ")>=0){let M=F.split(" in ");return w.create(M[0].trim(),M[1].trim())}if(/^[^<=>]+>=[^<=>]+$/.test(F)){const M=F.split(">=");return a.create(M[0].trim(),M[1].trim())}if(/^[^<=>]+>[^<=>]+$/.test(F)){const M=F.split(">");return g.create(M[0].trim(),M[1].trim())}if(/^[^<=>]+<=[^<=>]+$/.test(F)){const M=F.split("<=");return n.create(M[0].trim(),M[1].trim())}if(/^[^<=>]+<[^<=>]+$/.test(F)){const M=F.split("<");return _.create(M[0].trim(),M[1].trim())}return/^\!\s*/.test(F)?s.create(F.substr(1).trim()):f.create(F)}static _deserializeValue(F,W){if(F=F.trim(),F==="true")return!0;if(F==="false")return!1;let M=/^'([^']*)'$/.exec(F);return M?M[1].trim():F}static _deserializeRegexValue(F,W){if((0,L.isFalsyOrWhitespace)(F)){if(W)throw new Error("missing regexp-value for =~-expression");return console.warn("missing regexp-value for =~-expression"),null}let M=F.indexOf("/"),B=F.lastIndexOf("/");if(M===B||M<0){if(W)throw new Error(`bad regexp-value '${F}', missing /-enclosure`);return console.warn(`bad regexp-value '${F}', missing /-enclosure`),null}let U=F.slice(M+1,B),z=F[B+1]==="i"?"i":"";try{return new RegExp(U,z)}catch(K){if(W)throw new Error(`bad regexp-value '${F}', parse error: ${K}`);return console.warn(`bad regexp-value '${F}', parse error: ${K}`),null}}}e.ContextKeyExpr=D;function R(O,F){const W=O?O.substituteConstants():void 0,M=F?F.substituteConstants():void 0;return!W&&!M?!0:!W||!M?!1:W.equals(M)}e.expressionsAreEqualWithConstantSubstitution=R;function P(O,F){return O.cmp(F)}class u{constructor(){this.type=0}cmp(F){return this.type-F.type}equals(F){return F.type===this.type}substituteConstants(){return this}evaluate(F){return!1}serialize(){return"false"}keys(){return[]}map(F){return this}negate(){return E.INSTANCE}}e.ContextKeyFalseExpr=u,u.INSTANCE=new u;class E{constructor(){this.type=1}cmp(F){return this.type-F.type}equals(F){return F.type===this.type}substituteConstants(){return this}evaluate(F){return!0}serialize(){return"true"}keys(){return[]}map(F){return this}negate(){return u.INSTANCE}}e.ContextKeyTrueExpr=E,E.INSTANCE=new E;class f{constructor(F,W){this.key=F,this.negated=W,this.type=2}static create(F,W=null){const M=i.get(F);return typeof M=="boolean"?M?E.INSTANCE:u.INSTANCE:new f(F,W)}cmp(F){return F.type!==this.type?this.type-F.type:b(this.key,F.key)}equals(F){return F.type===this.type?this.key===F.key:!1}substituteConstants(){const F=i.get(this.key);return typeof F=="boolean"?F?E.INSTANCE:u.INSTANCE:this}evaluate(F){return!!F.getValue(this.key)}serialize(){return this.key}keys(){return[this.key]}map(F){return F.mapDefined(this.key)}negate(){return this.negated||(this.negated=s.create(this.key,this)),this.negated}}e.ContextKeyDefinedExpr=f;class v{constructor(F,W,M){this.key=F,this.value=W,this.negated=M,this.type=4}static create(F,W,M=null){if(typeof W=="boolean")return W?f.create(F,M):s.create(F,M);const B=i.get(F);return typeof B=="boolean"?W===(B?"true":"false")?E.INSTANCE:u.INSTANCE:new v(F,W,M)}cmp(F){return F.type!==this.type?this.type-F.type:T(this.key,this.value,F.key,F.value)}equals(F){return F.type===this.type?this.key===F.key&&this.value===F.value:!1}substituteConstants(){const F=i.get(this.key);if(typeof F=="boolean"){const W=F?"true":"false";return this.value===W?E.INSTANCE:u.INSTANCE}return this}evaluate(F){return F.getValue(this.key)==this.value}serialize(){return`${this.key} == '${this.value}'`}keys(){return[this.key]}map(F){return F.mapEquals(this.key,this.value)}negate(){return this.negated||(this.negated=p.create(this.key,this.value,this)),this.negated}}e.ContextKeyEqualsExpr=v;class w{constructor(F,W){this.key=F,this.valueKey=W,this.type=10,this.negated=null}static create(F,W){return new w(F,W)}cmp(F){return F.type!==this.type?this.type-F.type:T(this.key,this.valueKey,F.key,F.valueKey)}equals(F){return F.type===this.type?this.key===F.key&&this.valueKey===F.valueKey:!1}substituteConstants(){return this}evaluate(F){const W=F.getValue(this.valueKey),M=F.getValue(this.key);return Array.isArray(W)?W.indexOf(M)>=0:typeof M=="string"&&typeof W=="object"&&W!==null?k.call(W,M):!1}serialize(){return`${this.key} in '${this.valueKey}'`}keys(){return[this.key,this.valueKey]}map(F){return F.mapIn(this.key,this.valueKey)}negate(){return this.negated||(this.negated=I.create(this)),this.negated}}e.ContextKeyInExpr=w;class I{constructor(F){this._actual=F,this.type=11}static create(F){return new I(F)}cmp(F){return F.type!==this.type?this.type-F.type:this._actual.cmp(F._actual)}equals(F){return F.type===this.type?this._actual.equals(F._actual):!1}substituteConstants(){return this}evaluate(F){return!this._actual.evaluate(F)}serialize(){throw new Error("Method not implemented.")}keys(){return this._actual.keys()}map(F){return new I(this._actual.map(F))}negate(){return this._actual}}e.ContextKeyNotInExpr=I;class p{constructor(F,W,M){this.key=F,this.value=W,this.negated=M,this.type=5}static create(F,W,M=null){if(typeof W=="boolean")return W?s.create(F,M):f.create(F,M);const B=i.get(F);return typeof B=="boolean"?W===(B?"true":"false")?u.INSTANCE:E.INSTANCE:new p(F,W,M)}cmp(F){return F.type!==this.type?this.type-F.type:T(this.key,this.value,F.key,F.value)}equals(F){return F.type===this.type?this.key===F.key&&this.value===F.value:!1}substituteConstants(){const F=i.get(this.key);if(typeof F=="boolean"){const W=F?"true":"false";return this.value===W?u.INSTANCE:E.INSTANCE}return this}evaluate(F){return F.getValue(this.key)!=this.value}serialize(){return`${this.key} != '${this.value}'`}keys(){return[this.key]}map(F){return F.mapNotEquals(this.key,this.value)}negate(){return this.negated||(this.negated=v.create(this.key,this.value,this)),this.negated}}e.ContextKeyNotEqualsExpr=p;class s{constructor(F,W){this.key=F,this.negated=W,this.type=3}static create(F,W=null){const M=i.get(F);return typeof M=="boolean"?M?u.INSTANCE:E.INSTANCE:new s(F,W)}cmp(F){return F.type!==this.type?this.type-F.type:b(this.key,F.key)}equals(F){return F.type===this.type?this.key===F.key:!1}substituteConstants(){const F=i.get(this.key);return typeof F=="boolean"?F?u.INSTANCE:E.INSTANCE:this}evaluate(F){return!F.getValue(this.key)}serialize(){return`!${this.key}`}keys(){return[this.key]}map(F){return F.mapNot(this.key)}negate(){return this.negated||(this.negated=f.create(this.key,this)),this.negated}}e.ContextKeyNotExpr=s;function r(O,F){if(typeof O=="string"){const W=parseFloat(O);isNaN(W)||(O=W)}return typeof O=="string"||typeof O=="number"?F(O):u.INSTANCE}class g{constructor(F,W,M){this.key=F,this.value=W,this.negated=M,this.type=12}static create(F,W,M=null){return r(W,B=>new g(F,B,M))}cmp(F){return F.type!==this.type?this.type-F.type:T(this.key,this.value,F.key,F.value)}equals(F){return F.type===this.type?this.key===F.key&&this.value===F.value:!1}substituteConstants(){return this}evaluate(F){return typeof this.value=="string"?!1:parseFloat(F.getValue(this.key))>this.value}serialize(){return`${this.key} > ${this.value}`}keys(){return[this.key]}map(F){return F.mapGreater(this.key,this.value)}negate(){return this.negated||(this.negated=n.create(this.key,this.value,this)),this.negated}}e.ContextKeyGreaterExpr=g;class a{constructor(F,W,M){this.key=F,this.value=W,this.negated=M,this.type=13}static create(F,W,M=null){return r(W,B=>new a(F,B,M))}cmp(F){return F.type!==this.type?this.type-F.type:T(this.key,this.value,F.key,F.value)}equals(F){return F.type===this.type?this.key===F.key&&this.value===F.value:!1}substituteConstants(){return this}evaluate(F){return typeof this.value=="string"?!1:parseFloat(F.getValue(this.key))>=this.value}serialize(){return`${this.key} >= ${this.value}`}keys(){return[this.key]}map(F){return F.mapGreaterEquals(this.key,this.value)}negate(){return this.negated||(this.negated=_.create(this.key,this.value,this)),this.negated}}e.ContextKeyGreaterEqualsExpr=a;class _{constructor(F,W,M){this.key=F,this.value=W,this.negated=M,this.type=14}static create(F,W,M=null){return r(W,B=>new _(F,B,M))}cmp(F){return F.type!==this.type?this.type-F.type:T(this.key,this.value,F.key,F.value)}equals(F){return F.type===this.type?this.key===F.key&&this.value===F.value:!1}substituteConstants(){return this}evaluate(F){return typeof this.value=="string"?!1:parseFloat(F.getValue(this.key))<this.value}serialize(){return`${this.key} < ${this.value}`}keys(){return[this.key]}map(F){return F.mapSmaller(this.key,this.value)}negate(){return this.negated||(this.negated=a.create(this.key,this.value,this)),this.negated}}e.ContextKeySmallerExpr=_;class n{constructor(F,W,M){this.key=F,this.value=W,this.negated=M,this.type=15}static create(F,W,M=null){return r(W,B=>new n(F,B,M))}cmp(F){return F.type!==this.type?this.type-F.type:T(this.key,this.value,F.key,F.value)}equals(F){return F.type===this.type?this.key===F.key&&this.value===F.value:!1}substituteConstants(){return this}evaluate(F){return typeof this.value=="string"?!1:parseFloat(F.getValue(this.key))<=this.value}serialize(){return`${this.key} <= ${this.value}`}keys(){return[this.key]}map(F){return F.mapSmallerEquals(this.key,this.value)}negate(){return this.negated||(this.negated=g.create(this.key,this.value,this)),this.negated}}e.ContextKeySmallerEqualsExpr=n;class t{constructor(F,W){this.key=F,this.regexp=W,this.type=7,this.negated=null}static create(F,W){return new t(F,W)}cmp(F){if(F.type!==this.type)return this.type-F.type;if(this.key<F.key)return-1;if(this.key>F.key)return 1;const W=this.regexp?this.regexp.source:"",M=F.regexp?F.regexp.source:"";return W<M?-1:W>M?1:0}equals(F){if(F.type===this.type){const W=this.regexp?this.regexp.source:"",M=F.regexp?F.regexp.source:"";return this.key===F.key&&W===M}return!1}substituteConstants(){return this}evaluate(F){let W=F.getValue(this.key);return this.regexp?this.regexp.test(W):!1}serialize(){const F=this.regexp?`/${this.regexp.source}/${this.regexp.ignoreCase?"i":""}`:"/invalid/";return`${this.key} =~ ${F}`}keys(){return[this.key]}map(F){return F.mapRegex(this.key,this.regexp)}negate(){return this.negated||(this.negated=o.create(this)),this.negated}}e.ContextKeyRegexExpr=t;class o{constructor(F){this._actual=F,this.type=8}static create(F){return new o(F)}cmp(F){return F.type!==this.type?this.type-F.type:this._actual.cmp(F._actual)}equals(F){return F.type===this.type?this._actual.equals(F._actual):!1}substituteConstants(){return this}evaluate(F){return!this._actual.evaluate(F)}serialize(){throw new Error("Method not implemented.")}keys(){return this._actual.keys()}map(F){return new o(this._actual.map(F))}negate(){return this._actual}}e.ContextKeyNotRegexExpr=o;function d(O){let F=null;for(let W=0,M=O.length;W<M;W++){const B=O[W].substituteConstants();if(O[W]!==B&&F===null){F=[];for(let U=0;U<W;U++)F[U]=O[U]}F!==null&&(F[W]=B)}return F===null?O:F}class c{constructor(F,W){this.expr=F,this.negated=W,this.type=6}static create(F,W){return c._normalizeArr(F,W)}cmp(F){if(F.type!==this.type)return this.type-F.type;if(this.expr.length<F.expr.length)return-1;if(this.expr.length>F.expr.length)return 1;for(let W=0,M=this.expr.length;W<M;W++){const B=P(this.expr[W],F.expr[W]);if(B!==0)return B}return 0}equals(F){if(F.type===this.type){if(this.expr.length!==F.expr.length)return!1;for(let W=0,M=this.expr.length;W<M;W++)if(!this.expr[W].equals(F.expr[W]))return!1;return!0}return!1}substituteConstants(){const F=d(this.expr);return F===this.expr?this:c.create(F,this.negated)}evaluate(F){for(let W=0,M=this.expr.length;W<M;W++)if(!this.expr[W].evaluate(F))return!1;return!0}static _normalizeArr(F,W){const M=[];let B=!1;for(const U of F)if(!!U){if(U.type===1){B=!0;continue}if(U.type===0)return u.INSTANCE;if(U.type===6){M.push(...U.expr);continue}M.push(U)}if(M.length===0&&B)return E.INSTANCE;if(M.length!==0){if(M.length===1)return M[0];M.sort(P);for(let U=1;U<M.length;U++)M[U-1].equals(M[U])&&(M.splice(U,1),U--);if(M.length===1)return M[0];for(;M.length>1;){const U=M[M.length-1];if(U.type!==9)break;M.pop();const z=M.pop(),K=M.length===0,N=h.create(U.expr.map(j=>c.create([j,z],null)),null,K);N&&(M.push(N),M.sort(P))}return M.length===1?M[0]:new c(M,W)}}serialize(){return this.expr.map(F=>F.serialize()).join(" && ")}keys(){const F=[];for(let W of this.expr)F.push(...W.keys());return F}map(F){return new c(this.expr.map(W=>W.map(F)),null)}negate(){if(!this.negated){const F=[];for(let W of this.expr)F.push(W.negate());this.negated=h.create(F,this,!0)}return this.negated}}class h{constructor(F,W){this.expr=F,this.negated=W,this.type=9}static create(F,W,M){return h._normalizeArr(F,W,M)}cmp(F){if(F.type!==this.type)return this.type-F.type;if(this.expr.length<F.expr.length)return-1;if(this.expr.length>F.expr.length)return 1;for(let W=0,M=this.expr.length;W<M;W++){const B=P(this.expr[W],F.expr[W]);if(B!==0)return B}return 0}equals(F){if(F.type===this.type){if(this.expr.length!==F.expr.length)return!1;for(let W=0,M=this.expr.length;W<M;W++)if(!this.expr[W].equals(F.expr[W]))return!1;return!0}return!1}substituteConstants(){const F=d(this.expr);return F===this.expr?this:h.create(F,this.negated,!1)}evaluate(F){for(let W=0,M=this.expr.length;W<M;W++)if(this.expr[W].evaluate(F))return!0;return!1}static _normalizeArr(F,W,M){let B=[],U=!1;if(F){for(let z=0,K=F.length;z<K;z++){const N=F[z];if(!!N){if(N.type===0){U=!0;continue}if(N.type===1)return E.INSTANCE;if(N.type===9){B=B.concat(N.expr);continue}B.push(N)}}if(B.length===0&&U)return u.INSTANCE;B.sort(P)}if(B.length!==0){if(B.length===1)return B[0];for(let z=1;z<B.length;z++)B[z-1].equals(B[z])&&(B.splice(z,1),z--);if(B.length===1)return B[0];if(M){for(let z=0;z<B.length;z++)for(let K=z+1;K<B.length;K++)A(B[z],B[K])&&(B.splice(K,1),K--);if(B.length===1)return B[0]}return new h(B,W)}}serialize(){return this.expr.map(F=>F.serialize()).join(" || ")}keys(){const F=[];for(let W of this.expr)F.push(...W.keys());return F}map(F){return new h(this.expr.map(W=>W.map(F)),null)}negate(){if(!this.negated){let F=[];for(let W of this.expr)F.push(W.negate());for(;F.length>1;){const W=F.shift(),M=F.shift(),B=[];for(const z of x(W))for(const K of x(M))B.push(c.create([z,K],null));const U=F.length===0;F.unshift(h.create(B,null,U))}this.negated=F[0]}return this.negated}}class l extends f{constructor(F,W,M){super(F,null);this._defaultValue=W,typeof M=="object"?l._info.push({...M,key:F}):M!==!0&&l._info.push({key:F,description:M,type:W!=null?typeof W:void 0})}static all(){return l._info.values()}bindTo(F){return F.createKey(this.key,this._defaultValue)}getValue(F){return F.getContextKeyValue(this.key)}toNegated(){return this.negate()}isEqualTo(F){return v.create(this.key,F)}notEqualsTo(F){return p.create(this.key,F)}}e.RawContextKey=l,l._info=[],e.IContextKeyService=(0,y.createDecorator)("contextKeyService"),e.SET_CONTEXT_COMMAND_ID="setContext";function b(O,F){return O<F?-1:O>F?1:0}function T(O,F,W,M){return O<W?-1:O>W?1:F<M?-1:F>M?1:0}function A(O,F){if(F.type===6&&O.type!==9&&O.type!==6){for(const B of F.expr)if(O.equals(B))return!0}const W=O.negate(),M=x(W).concat(x(F));M.sort(P);for(let B=0;B<M.length;B++){const z=M[B].negate();for(let K=B+1;K<M.length;K++){const N=M[K];if(z.equals(N))return!0}}return!1}e.implies=A;function x(O){return O.type===9?O.expr:[O]}}),define(pe[182],ve([0,1,4]),function(Y,e,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.INativeEnvironmentService=e.IEnvironmentService=void 0,e.IEnvironmentService=(0,m.createDecorator)("environmentService"),e.INativeEnvironmentService=(0,m.refineServiceDecorator)(e.IEnvironmentService)}),define(pe[183],ve([0,1,10,156,4]),function(Y,e,m,L,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtensionManagementCLIService=e.PreferencesLocalizedLabel=e.PreferencesLabel=e.ExtensionsChannelId=e.ExtensionsLocalizedLabel=e.ExtensionsLabel=e.DefaultIconPath=e.IExtensionTipsService=e.IGlobalExtensionEnablementService=e.ENABLED_EXTENSIONS_STORAGE_PATH=e.DISABLED_EXTENSIONS_STORAGE_PATH=e.IExtensionManagementService=e.ExtensionManagementError=e.ExtensionManagementErrorCode=e.IExtensionGalleryService=e.InstallOperation=e.StatisticType=e.SortOrder=e.SortBy=e.isIExtensionIdentifier=e.getFallbackTargetPlarforms=e.isTargetPlatformCompatible=e.isNotWebExtensionInWebTargetPlatform=e.getTargetPlatform=e.toTargetPlatform=e.TargetPlatformToString=e.TargetPlatform=e.WEB_EXTENSION_TAG=e.EXTENSION_IDENTIFIER_REGEX=e.EXTENSION_IDENTIFIER_PATTERN=void 0,e.EXTENSION_IDENTIFIER_PATTERN="^([a-z0-9A-Z][a-z0-9-A-Z]*)\\.([a-z0-9A-Z][a-z0-9-A-Z]*)$",e.EXTENSION_IDENTIFIER_REGEX=new RegExp(e.EXTENSION_IDENTIFIER_PATTERN),e.WEB_EXTENSION_TAG="__web_extension";var C;(function(s){s.WIN32_X64="win32-x64",s.WIN32_IA32="win32-ia32",s.WIN32_ARM64="win32-arm64",s.LINUX_X64="linux-x64",s.LINUX_ARM64="linux-arm64",s.LINUX_ARMHF="linux-armhf",s.ALPINE_X64="alpine-x64",s.ALPINE_ARM64="alpine-arm64",s.DARWIN_X64="darwin-x64",s.DARWIN_ARM64="darwin-arm64",s.WEB="web",s.UNIVERSAL="universal",s.UNKNOWN="unknown",s.UNDEFINED="undefined"})(C=e.TargetPlatform||(e.TargetPlatform={}));function i(s){switch(s){case"win32-x64":return"Windows 64 bit";case"win32-ia32":return"Windows 32 bit";case"win32-arm64":return"Windows ARM";case"linux-x64":return"Linux 64 bit";case"linux-arm64":return"Linux ARM 64";case"linux-armhf":return"Linux ARM";case"alpine-x64":return"Alpine Linux 64 bit";case"alpine-arm64":return"Alpine ARM 64";case"darwin-x64":return"Mac";case"darwin-arm64":return"Mac Silicon";case"web":return"Web";case"universal":return"universal";case"unknown":return"unknown";case"undefined":return"undefined"}}e.TargetPlatformToString=i;function k(s){switch(s){case"win32-x64":return"win32-x64";case"win32-ia32":return"win32-ia32";case"win32-arm64":return"win32-arm64";case"linux-x64":return"linux-x64";case"linux-arm64":return"linux-arm64";case"linux-armhf":return"linux-armhf";case"alpine-x64":return"alpine-x64";case"alpine-arm64":return"alpine-arm64";case"darwin-x64":return"darwin-x64";case"darwin-arm64":return"darwin-arm64";case"web":return"web";case"universal":return"universal";default:return"unknown"}}e.toTargetPlatform=k;function S(s,r){switch(s){case 3:return r==="x64"?"win32-x64":r==="ia32"?"win32-ia32":r==="arm64"?"win32-arm64":"unknown";case 2:return r==="x64"?"linux-x64":r==="arm64"?"linux-arm64":r==="arm"?"linux-armhf":"unknown";case"alpine":return r==="x64"?"alpine-x64":r==="arm64"?"alpine-arm64":"unknown";case 1:return r==="x64"?"darwin-x64":r==="arm64"?"darwin-arm64":"unknown";case 0:return"web"}}e.getTargetPlatform=S;function D(s,r){return r==="web"&&!s.includes("web")}e.isNotWebExtensionInWebTargetPlatform=D;function R(s,r,g){return D(r,g)?!1:s==="undefined"||s==="universal"?!0:s==="unknown"?!1:s===g?!0:P(g).includes(s)}e.isTargetPlatformCompatible=R;function P(s){switch(s){case"win32-x64":return["win32-ia32"];case"win32-arm64":return["win32-ia32"]}return[]}e.getFallbackTargetPlarforms=P;function u(s){return s&&typeof s=="object"&&typeof s.id=="string"&&(!s.uuid||typeof s.uuid=="string")}e.isIExtensionIdentifier=u;var E;(function(s){s[s.NoneOrRelevance=0]="NoneOrRelevance",s[s.LastUpdatedDate=1]="LastUpdatedDate",s[s.Title=2]="Title",s[s.PublisherName=3]="PublisherName",s[s.InstallCount=4]="InstallCount",s[s.PublishedDate=10]="PublishedDate",s[s.AverageRating=6]="AverageRating",s[s.WeightedRating=12]="WeightedRating"})(E=e.SortBy||(e.SortBy={}));var f;(function(s){s[s.Default=0]="Default",s[s.Ascending=1]="Ascending",s[s.Descending=2]="Descending"})(f=e.SortOrder||(e.SortOrder={}));var v;(function(s){s.Install="install",s.Uninstall="uninstall"})(v=e.StatisticType||(e.StatisticType={}));var w;(function(s){s[s.None=1]="None",s[s.Install=2]="Install",s[s.Update=3]="Update",s[s.Migrate=4]="Migrate"})(w=e.InstallOperation||(e.InstallOperation={})),e.IExtensionGalleryService=(0,y.createDecorator)("extensionGalleryService");var I;(function(s){s.Unsupported="Unsupported",s.UnsupportedPreRelease="UnsupportedPreRelease",s.Malicious="Malicious",s.Incompatible="Incompatible",s.IncompatiblePreRelease="IncompatiblePreRelease",s.IncompatibleTargetPlatform="IncompatibleTargetPlatform",s.Invalid="Invalid",s.Download="Download",s.Extract="Extract",s.Delete="Delete",s.Rename="Rename",s.CorruptZip="CorruptZip",s.IncompleteZip="IncompleteZip",s.Internal="Internal"})(I=e.ExtensionManagementErrorCode||(e.ExtensionManagementErrorCode={}));class p extends Error{constructor(r,g){super(r);this.code=g,this.name=g}}e.ExtensionManagementError=p,e.IExtensionManagementService=(0,y.createDecorator)("extensionManagementService"),e.DISABLED_EXTENSIONS_STORAGE_PATH="extensionsIdentifiers/disabled",e.ENABLED_EXTENSIONS_STORAGE_PATH="extensionsIdentifiers/enabled",e.IGlobalExtensionEnablementService=(0,y.createDecorator)("IGlobalExtensionEnablementService"),e.IExtensionTipsService=(0,y.createDecorator)("IExtensionTipsService"),e.DefaultIconPath=m.FileAccess.asBrowserUri("./media/defaultIcon.png",Y).toString(!0),e.ExtensionsLabel=(0,L.localize)(0,null),e.ExtensionsLocalizedLabel={value:e.ExtensionsLabel,original:"Extensions"},e.ExtensionsChannelId="extensions",e.PreferencesLabel=(0,L.localize)(1,null),e.PreferencesLocalizedLabel={value:e.PreferencesLabel,original:"Preferences"},e.IExtensionManagementCLIService=(0,y.createDecorator)("IExtensionManagementCLIService")}),define(pe[184],ve([0,1,4]),function(Y,e,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExternalTerminalMainService=e.DEFAULT_TERMINAL_OSX=e.IExternalTerminalService=void 0,e.IExternalTerminalService=(0,m.createDecorator)("externalTerminal"),e.DEFAULT_TERMINAL_OSX="Terminal.app",e.IExternalTerminalMainService=(0,m.createDecorator)("externalTerminal")}),define(pe[185],ve([0,1,37,10,9,12,94,28,112,158,184]),function(Y,e,m,L,y,C,i,k,S,D,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LinuxExternalTerminalService=e.MacExternalTerminalService=e.WindowsExternalTerminalService=void 0;const P=D.localize(0,null);class u{async getDefaultTerminalForPlatforms(){return{windows:E.getDefaultTerminalWindows(),linux:await v.getDefaultTerminalLinuxReady(),osx:"xterm"}}}class E extends u{openTerminal(r,g){return this.spawnTerminal(m,r,S.getWindowsShell(),g)}spawnTerminal(r,g,a,_){const n=g.windowsExec||E.getDefaultTerminalWindows();_&&_[1]===":"&&(_=_[0].toUpperCase()+_.substr(1));const t=y.basename(n).toLowerCase();if(t==="cmder"||t==="cmder.exe")return r.spawn(n,_?[_]:void 0),Promise.resolve(void 0);const o=["/c","start","/wait"];return n.indexOf(" ")>=0&&o.push('""'),o.push(n),(t==="wt"||t==="wt.exe")&&o.push("-d ."),new Promise((d,c)=>{const h=w(process),l=r.spawn(a,o,{cwd:_,env:h});l.on("error",c),l.on("exit",()=>d())})}runInTerminal(r,g,a,_,n){const t="windowsExec"in n&&n.windowsExec?n.windowsExec:E.getDefaultTerminalWindows();return new Promise((o,d)=>{const c=`"${g} - ${P}"`,h=`""${a.join('" "')}" & pause"`,l=["/c","start",c,"/wait",t,"/c",h],b=Object.assign({},w(process),_);Object.keys(b).filter(x=>b[x]===null).forEach(x=>delete b[x]);const T={cwd:g,env:b,windowsVerbatimArguments:!0};m.spawn(E.CMD,l,T).on("error",x=>{d(I(x))}),o(void 0)})}static getDefaultTerminalWindows(){if(!E._DEFAULT_TERMINAL_WINDOWS){const r=!!process.env.hasOwnProperty("PROCESSOR_ARCHITEW6432");E._DEFAULT_TERMINAL_WINDOWS=`${process.env.windir?process.env.windir:"C:\\Windows"}\\${r?"Sysnative":"System32"}\\cmd.exe`}return E._DEFAULT_TERMINAL_WINDOWS}}e.WindowsExternalTerminalService=E,E.CMD="cmd.exe";class f extends u{openTerminal(r,g){return this.spawnTerminal(m,r,g)}runInTerminal(r,g,a,_,n){const t=n.osxExec||R.DEFAULT_TERMINAL_OSX;return new Promise((o,d)=>{if(t===R.DEFAULT_TERMINAL_OSX||t==="iTerm.app"){const c=t===R.DEFAULT_TERMINAL_OSX?"TerminalHelper":"iTermHelper",l=[L.FileAccess.asFileUri(`vs/workbench/contrib/externalTerminal/node/${c}.scpt`,Y).fsPath,"-t",r||P,"-w",g];for(let A of a)l.push("-a"),l.push(A);if(_){const A=Object.assign({},w(process),_);for(let x in A){const O=A[x];O===null?(l.push("-u"),l.push(x)):(l.push("-e"),l.push(`${x}=${O}`))}}let b="";const T=m.spawn(f.OSASCRIPT,l);T.on("error",A=>{d(I(A))}),T.stderr.on("data",A=>{b+=A.toString()}),T.on("exit",A=>{if(A===0)o(void 0);else if(b){const x=b.split(`
`,1);d(new Error(x[0]))}else d(new Error(D.localize(1,null,c,A)))})}else d(new Error(D.localize(2,null,t)))})}spawnTerminal(r,g,a){const _=g.osxExec||R.DEFAULT_TERMINAL_OSX;return new Promise((n,t)=>{const o=["-a",_];a&&o.push(a);const d=w(process),c=r.spawn("/usr/bin/open",o,{cwd:a,env:d});c.on("error",t),c.on("exit",()=>n())})}}e.MacExternalTerminalService=f,f.OSASCRIPT="/usr/bin/osascript";class v extends u{openTerminal(r,g){return this.spawnTerminal(m,r,g)}runInTerminal(r,g,a,_,n){const t=n.linuxExec?Promise.resolve(n.linuxExec):v.getDefaultTerminalLinuxReady();return new Promise((o,d)=>{let c=[];t.then(h=>{h.indexOf("gnome-terminal")>=0?c.push("-x"):c.push("-e"),c.push("bash"),c.push("-c");const l=`${p(a)}; echo; read -p "${v.WAIT_MESSAGE}" -n1;`;c.push(`''${l}''`);const b=Object.assign({},w(process),_);Object.keys(b).filter(O=>b[O]===null).forEach(O=>delete b[O]);const T={cwd:g,env:b};let A="";const x=m.spawn(h,c,T);x.on("error",O=>{d(I(O))}),x.stderr.on("data",O=>{A+=O.toString()}),x.on("exit",O=>{if(O===0)o(void 0);else if(A){const F=A.split(`
`,1);d(new Error(F[0]))}else d(new Error(D.localize(4,null,h,O)))})})})}static async getDefaultTerminalLinuxReady(){if(!v._DEFAULT_TERMINAL_LINUX_READY)if(!C.isLinux)v._DEFAULT_TERMINAL_LINUX_READY=Promise.resolve("xterm");else{const r=await k.Promises.exists("/etc/debian_version");v._DEFAULT_TERMINAL_LINUX_READY=new Promise(g=>{r?g("x-terminal-emulator"):process.env.DESKTOP_SESSION==="gnome"||process.env.DESKTOP_SESSION==="gnome-classic"?g("gnome-terminal"):process.env.DESKTOP_SESSION==="kde-plasma"?g("konsole"):process.env.COLORTERM?g(process.env.COLORTERM):process.env.TERM?g(process.env.TERM):g("xterm")})}return v._DEFAULT_TERMINAL_LINUX_READY}spawnTerminal(r,g,a){const _=g.linuxExec?Promise.resolve(g.linuxExec):v.getDefaultTerminalLinuxReady();return new Promise((n,t)=>{_.then(o=>{const d=w(process),c=r.spawn(o,[],{cwd:a,env:d});c.on("error",t),c.on("exit",()=>n())})})}}e.LinuxExternalTerminalService=v,v.WAIT_MESSAGE=D.localize(3,null);function w(s){const r={...s.env};return(0,i.sanitizeProcessEnvironment)(r),r}function I(s){return"errno"in s&&s.errno==="ENOENT"&&"path"in s&&typeof s.path=="string"?new Error(D.localize(5,null,s.path)):s}function p(s){let r="";for(let g of s)g.indexOf(" ")>=0?r+='"'+g+'"':r+=g,r+=" ";return r}}),define(pe[42],ve([0,1,24,9,8,13,2,159,4]),function(Y,e,m,L,y,C,i,k,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getPlatformLimits=e.Arch=e.ByteSize=e.FALLBACK_MAX_MEMORY_SIZE_MB=e.MIN_MAX_MEMORY_SIZE_MB=e.whenProviderRegistered=e.etag=e.ETAG_DISABLED=e.FileKind=e.FILES_EXCLUDE_CONFIG=e.FILES_ASSOCIATIONS_CONFIG=e.HotExitConfiguration=e.AutoSaveConfiguration=e.FileOperationResult=e.NotModifiedSinceFileOperationError=e.FileOperationError=e.isParent=e.FileChangesEvent=e.FileChangeType=e.FileOperationEvent=e.FileOperation=e.toFileOperationResult=e.toFileSystemProviderErrorCode=e.markAsFileSystemProviderError=e.ensureFileSystemProviderError=e.createFileSystemProviderError=e.FileSystemProviderError=e.FileSystemProviderErrorCode=e.hasFileReadStreamCapability=e.hasOpenReadWriteCloseCapability=e.hasFileFolderCopyCapability=e.hasReadWriteCapability=e.FileSystemProviderCapabilities=e.FilePermission=e.FileType=e.isFileOpenForWriteOptions=e.IFileService=void 0,e.IFileService=(0,S.createDecorator)("fileService");function D(M){return M.create===!0}e.isFileOpenForWriteOptions=D;var R;(function(M){M[M.Unknown=0]="Unknown",M[M.File=1]="File",M[M.Directory=2]="Directory",M[M.SymbolicLink=64]="SymbolicLink"})(R=e.FileType||(e.FileType={}));var P;(function(M){M[M.Readonly=1]="Readonly"})(P=e.FilePermission||(e.FilePermission={}));var u;(function(M){M[M.FileReadWrite=2]="FileReadWrite",M[M.FileOpenReadWriteClose=4]="FileOpenReadWriteClose",M[M.FileReadStream=16]="FileReadStream",M[M.FileFolderCopy=8]="FileFolderCopy",M[M.PathCaseSensitive=1024]="PathCaseSensitive",M[M.Readonly=2048]="Readonly",M[M.Trash=4096]="Trash",M[M.FileWriteUnlock=8192]="FileWriteUnlock"})(u=e.FileSystemProviderCapabilities||(e.FileSystemProviderCapabilities={}));function E(M){return!!(M.capabilities&2)}e.hasReadWriteCapability=E;function f(M){return!!(M.capabilities&8)}e.hasFileFolderCopyCapability=f;function v(M){return!!(M.capabilities&4)}e.hasOpenReadWriteCloseCapability=v;function w(M){return!!(M.capabilities&16)}e.hasFileReadStreamCapability=w;var I;(function(M){M.FileExists="EntryExists",M.FileNotFound="EntryNotFound",M.FileNotADirectory="EntryNotADirectory",M.FileIsADirectory="EntryIsADirectory",M.FileExceedsMemoryLimit="EntryExceedsMemoryLimit",M.FileTooLarge="EntryTooLarge",M.FileWriteLocked="EntryWriteLocked",M.NoPermissions="NoPermissions",M.Unavailable="Unavailable",M.Unknown="Unknown"})(I=e.FileSystemProviderErrorCode||(e.FileSystemProviderErrorCode={}));class p extends Error{constructor(B,U){super(B);this.code=U}}e.FileSystemProviderError=p;function s(M,B){const U=new p(M.toString(),B);return g(U,B),U}e.createFileSystemProviderError=s;function r(M){return M||s((0,k.localize)(0,null),I.Unknown)}e.ensureFileSystemProviderError=r;function g(M,B){return M.name=B?`${B} (FileSystemError)`:"FileSystemError",M}e.markAsFileSystemProviderError=g;function a(M){if(!M)return I.Unknown;if(M instanceof p)return M.code;const B=/^(.+) \(FileSystemError\)$/.exec(M.name);if(!B)return I.Unknown;switch(B[1]){case I.FileExists:return I.FileExists;case I.FileIsADirectory:return I.FileIsADirectory;case I.FileNotADirectory:return I.FileNotADirectory;case I.FileNotFound:return I.FileNotFound;case I.FileExceedsMemoryLimit:return I.FileExceedsMemoryLimit;case I.FileTooLarge:return I.FileTooLarge;case I.FileWriteLocked:return I.FileWriteLocked;case I.NoPermissions:return I.NoPermissions;case I.Unavailable:return I.Unavailable}return I.Unknown}e.toFileSystemProviderErrorCode=a;function _(M){if(M instanceof h)return M.fileOperationResult;switch(a(M)){case I.FileNotFound:return 1;case I.FileIsADirectory:return 0;case I.FileNotADirectory:return 10;case I.FileWriteLocked:return 5;case I.NoPermissions:return 6;case I.FileExists:return 4;case I.FileExceedsMemoryLimit:return 9;case I.FileTooLarge:return 7;default:return 11}}e.toFileOperationResult=_;var n;(function(M){M[M.CREATE=0]="CREATE",M[M.DELETE=1]="DELETE",M[M.MOVE=2]="MOVE",M[M.COPY=3]="COPY"})(n=e.FileOperation||(e.FileOperation={}));class t{constructor(B,U,z){this.resource=B,this.operation=U,this.target=z}isOperation(B){return this.operation===B}}e.FileOperationEvent=t;var o;(function(M){M[M.UPDATED=0]="UPDATED",M[M.ADDED=1]="ADDED",M[M.DELETED=2]="DELETED"})(o=e.FileChangeType||(e.FileChangeType={}));class d{constructor(B,U){this.added=void 0,this.updated=void 0,this.deleted=void 0;const z=new Map;for(const K of B){const N=z.get(K.type);N?N.push([K.resource,K]):z.set(K.type,[[K.resource,K]])}for(const[K,N]of z)switch(K){case 1:this.added=m.TernarySearchTree.forUris(()=>U),this.added.fill(N);break;case 0:this.updated=m.TernarySearchTree.forUris(()=>U),this.updated.fill(N);break;case 2:this.deleted=m.TernarySearchTree.forUris(()=>U),this.deleted.fill(N);break}}contains(B,...U){return this.doContains(B,{includeChildren:!1},...U)}affects(B,...U){return this.doContains(B,{includeChildren:!0},...U)}doContains(B,U,...z){if(!B)return!1;const K=z.length>0;return!!((!K||z.includes(1))&&(this.added?.get(B)||U.includeChildren&&this.added?.findSuperstr(B))||(!K||z.includes(0))&&(this.updated?.get(B)||U.includeChildren&&this.updated?.findSuperstr(B))||(!K||z.includes(2))&&(this.deleted?.findSubstr(B)||U.includeChildren&&this.deleted?.findSuperstr(B)))}gotAdded(){return!!this.added}gotDeleted(){return!!this.deleted}gotUpdated(){return!!this.updated}get rawAdded(){return this.added}get rawDeleted(){return this.deleted}}e.FileChangesEvent=d;function c(M,B,U){return!M||!B||M===B||B.length>M.length?!1:(B.charAt(B.length-1)!==L.sep&&(B+=L.sep),U?(0,y.startsWithIgnoreCase)(M,B):M.indexOf(B)===0)}e.isParent=c;class h extends Error{constructor(B,U,z){super(B);this.fileOperationResult=U,this.options=z}}e.FileOperationError=h;class l extends h{constructor(B,U,z){super(B,2,z);this.stat=U}}e.NotModifiedSinceFileOperationError=l;var b;(function(M){M[M.FILE_IS_DIRECTORY=0]="FILE_IS_DIRECTORY",M[M.FILE_NOT_FOUND=1]="FILE_NOT_FOUND",M[M.FILE_NOT_MODIFIED_SINCE=2]="FILE_NOT_MODIFIED_SINCE",M[M.FILE_MODIFIED_SINCE=3]="FILE_MODIFIED_SINCE",M[M.FILE_MOVE_CONFLICT=4]="FILE_MOVE_CONFLICT",M[M.FILE_WRITE_LOCKED=5]="FILE_WRITE_LOCKED",M[M.FILE_PERMISSION_DENIED=6]="FILE_PERMISSION_DENIED",M[M.FILE_TOO_LARGE=7]="FILE_TOO_LARGE",M[M.FILE_INVALID_PATH=8]="FILE_INVALID_PATH",M[M.FILE_EXCEEDS_MEMORY_LIMIT=9]="FILE_EXCEEDS_MEMORY_LIMIT",M[M.FILE_NOT_DIRECTORY=10]="FILE_NOT_DIRECTORY",M[M.FILE_OTHER_ERROR=11]="FILE_OTHER_ERROR"})(b=e.FileOperationResult||(e.FileOperationResult={})),e.AutoSaveConfiguration={OFF:"off",AFTER_DELAY:"afterDelay",ON_FOCUS_CHANGE:"onFocusChange",ON_WINDOW_CHANGE:"onWindowChange"},e.HotExitConfiguration={OFF:"off",ON_EXIT:"onExit",ON_EXIT_AND_WINDOW_CLOSE:"onExitAndWindowClose"},e.FILES_ASSOCIATIONS_CONFIG="files.associations",e.FILES_EXCLUDE_CONFIG="files.exclude";var T;(function(M){M[M.FILE=0]="FILE",M[M.FOLDER=1]="FOLDER",M[M.ROOT_FOLDER=2]="ROOT_FOLDER"})(T=e.FileKind||(e.FileKind={})),e.ETAG_DISABLED="";function A(M){if(!(typeof M.size!="number"||typeof M.mtime!="number"))return M.mtime.toString(29)+M.size.toString(31)}e.etag=A;async function x(M,B){if(!B.hasProvider(i.URI.from({scheme:M.scheme})))return new Promise(U=>{const z=B.onDidChangeFileSystemProviderRegistrations(K=>{K.scheme===M.scheme&&K.added&&(z.dispose(),U())})})}e.whenProviderRegistered=x,e.MIN_MAX_MEMORY_SIZE_MB=2048,e.FALLBACK_MAX_MEMORY_SIZE_MB=4096;class O{static formatSize(B){return(0,C.isNumber)(B)||(B=0),B<O.KB?(0,k.localize)(1,null,B.toFixed(0)):B<O.MB?(0,k.localize)(2,null,(B/O.KB).toFixed(2)):B<O.GB?(0,k.localize)(3,null,(B/O.MB).toFixed(2)):B<O.TB?(0,k.localize)(4,null,(B/O.GB).toFixed(2)):(0,k.localize)(5,null,(B/O.TB).toFixed(2))}}e.ByteSize=O,O.KB=1024,O.MB=O.KB*O.KB,O.GB=O.MB*O.KB,O.TB=O.GB*O.KB;var F;(function(M){M[M.IA32=0]="IA32",M[M.OTHER=1]="OTHER"})(F=e.Arch||(e.Arch={}));function W(M){return{maxFileSize:M===0?300*O.MB:16*O.GB,maxHeapSize:M===0?700*O.MB:2*700*O.MB}}e.getPlatformLimits=W}),define(pe[85],ve([0,1]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ServiceCollection=void 0;class m{constructor(...y){this._entries=new Map;for(let[C,i]of y)this.set(C,i)}set(y,C){const i=this._entries.get(y);return this._entries.set(y,C),i}has(y){return this._entries.has(y)}get(y){return this._entries.get(y)}}e.ServiceCollection=m}),define(pe[186],ve([0,1,18,15,114,179,4,85]),function(Y,e,m,L,y,C,i,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InstantiationService=void 0;const S=!1;class D extends Error{constructor(f){super("cyclic dependency between services");this.message=f.findCycleSlow()??`UNABLE to detect cycle, dumping graph: 
${f.toString()}`}}class R{constructor(f=new k.ServiceCollection,v=!1,w){this._activeInstantiations=new Set,this._services=f,this._strict=v,this._parent=w,this._services.set(i.IInstantiationService,this)}createChild(f){return new R(f,this._strict,this)}invokeFunction(f,...v){let w=u.traceInvocation(f),I=!1;try{return f({get:s=>{if(I)throw(0,L.illegalState)("service accessor is only valid during the invocation of its target method");const r=this._getOrCreateServiceInstance(s,w);if(!r)throw new Error(`[invokeFunction] unknown service '${s}'`);return r}},...v)}finally{I=!0,w.stop()}}createInstance(f,...v){let w,I;return f instanceof y.SyncDescriptor?(w=u.traceCreation(f.ctor),I=this._createInstance(f.ctor,f.staticArguments.concat(v),w)):(w=u.traceCreation(f),I=this._createInstance(f,v,w)),w.stop(),I}_createInstance(f,v=[],w){let I=i._util.getServiceDependencies(f).sort((r,g)=>r.index-g.index),p=[];for(const r of I){let g=this._getOrCreateServiceInstance(r.id,w);if(!g&&this._strict&&!r.optional)throw new Error(`[createInstance] ${f.name} depends on UNKNOWN service ${r.id}.`);p.push(g)}let s=I.length>0?I[0].index:v.length;if(v.length!==s){console.warn(`[createInstance] First service dependency of ${f.name} at position ${s+1} conflicts with ${v.length} static arguments`);let r=s-v.length;r>0?v=v.concat(new Array(r)):v=v.slice(0,s)}return new f(...[...v,...p])}_setServiceInstance(f,v){if(this._services.get(f)instanceof y.SyncDescriptor)this._services.set(f,v);else if(this._parent)this._parent._setServiceInstance(f,v);else throw new Error("illegalState - setting UNKNOWN service instance")}_getServiceInstanceOrDescriptor(f){let v=this._services.get(f);return!v&&this._parent?this._parent._getServiceInstanceOrDescriptor(f):v}_getOrCreateServiceInstance(f,v){let w=this._getServiceInstanceOrDescriptor(f);return w instanceof y.SyncDescriptor?this._safeCreateAndCacheServiceInstance(f,w,v.branch(f,!0)):(v.branch(f,!1),w)}_safeCreateAndCacheServiceInstance(f,v,w){if(this._activeInstantiations.has(f))throw new Error(`illegal state - RECURSIVELY instantiating service '${f}'`);this._activeInstantiations.add(f);try{return this._createAndCacheServiceInstance(f,v,w)}finally{this._activeInstantiations.delete(f)}}_createAndCacheServiceInstance(f,v,w){const I=new C.Graph(r=>r.id.toString());let p=0;const s=[{id:f,desc:v,_trace:w}];for(;s.length;){const r=s.pop();if(I.lookupOrInsertNode(r),p++>1e3)throw new D(I);for(let g of i._util.getServiceDependencies(r.desc.ctor)){let a=this._getServiceInstanceOrDescriptor(g.id);if(!a&&!g.optional&&console.warn(`[createInstance] ${f} depends on ${g.id} which is NOT registered.`),a instanceof y.SyncDescriptor){const _={id:g.id,desc:a,_trace:r._trace.branch(g.id,!0)};I.insertEdge(r,_),s.push(_)}}}for(;;){const r=I.roots();if(r.length===0){if(!I.isEmpty())throw new D(I);break}for(const{data:g}of r){if(this._getServiceInstanceOrDescriptor(g.id)instanceof y.SyncDescriptor){const _=this._createServiceInstanceWithOwner(g.id,g.desc.ctor,g.desc.staticArguments,g.desc.supportsDelayedInstantiation,g._trace);this._setServiceInstance(g.id,_)}I.removeNode(g)}}return this._getServiceInstanceOrDescriptor(f)}_createServiceInstanceWithOwner(f,v,w=[],I,p){if(this._services.get(f)instanceof y.SyncDescriptor)return this._createServiceInstance(v,w,I,p);if(this._parent)return this._parent._createServiceInstanceWithOwner(f,v,w,I,p);throw new Error(`illegalState - creating UNKNOWN service instance ${v.name}`)}_createServiceInstance(f,v=[],w,I){if(w){const p=new m.IdleValue(()=>this._createInstance(f,v,I));return new Proxy(Object.create(null),{get(s,r){if(r in s)return s[r];let g=p.value,a=g[r];return typeof a!="function"||(a=a.bind(g),s[r]=a),a},set(s,r,g){return p.value[r]=g,!0}})}else return this._createInstance(f,v,I)}}e.InstantiationService=R;var P;(function(E){E[E.Creation=0]="Creation",E[E.Invocation=1]="Invocation",E[E.Branch=2]="Branch"})(P||(P={}));class u{constructor(f,v){this.type=f,this.name=v,this._start=Date.now(),this._dep=[]}static traceInvocation(f){return S?new u(1,f.name||f.toString().substring(0,42).replace(/\n/g,"")):u._None}static traceCreation(f){return S?new u(0,f.name):u._None}branch(f,v){let w=new u(2,f.toString());return this._dep.push([f,v,w]),w}stop(){let f=Date.now()-this._start;u._totals+=f;let v=!1;function w(p,s){let r=[],g=new Array(p+1).join("	");for(const[a,_,n]of s._dep)if(_&&n){v=!0,r.push(`${g}CREATES -> ${a}`);let t=w(p+1,n);t&&r.push(t)}else r.push(`${g}uses -> ${a}`);return r.join(`
`)}let I=[`${this.type===0?"CREATE":"CALL"} ${this.name}`,`${w(1,this)}`,`DONE, took ${f.toFixed(2)}ms (grand total ${u._totals.toFixed(2)}ms)`];(f>2||v)&&console.log(I.join(`
`))}}u._None=new class extends u{constructor(){super(-1,null)}stop(){}branch(){return this}},u._totals=0}),define(pe[11],ve([0,1,50,3,6,12,4]),function(Y,e,m,L,y,C,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LogLevelToString=e.parseLogLevel=e.getLogLevel=e.NullLogService=e.AbstractLoggerService=e.LogService=e.MultiplexLogService=e.AdapterLogger=e.ConsoleLogger=e.ConsoleMainLogger=e.AbstractMessageLogger=e.AbstractLogger=e.format=e.log=e.DEFAULT_LOG_LEVEL=e.LogLevel=e.ILoggerService=e.ILogService=void 0,e.ILogService=(0,i.createDecorator)("logService"),e.ILoggerService=(0,i.createDecorator)("loggerService");function k(){return new Date().toISOString()}var S;(function(_){_[_.Trace=0]="Trace",_[_.Debug=1]="Debug",_[_.Info=2]="Info",_[_.Warning=3]="Warning",_[_.Error=4]="Error",_[_.Critical=5]="Critical",_[_.Off=6]="Off"})(S=e.LogLevel||(e.LogLevel={})),e.DEFAULT_LOG_LEVEL=S.Info;function D(_,n,t){switch(n){case S.Trace:_.trace(t);break;case S.Debug:_.debug(t);break;case S.Info:_.info(t);break;case S.Warning:_.warn(t);break;case S.Error:_.error(t);break;case S.Critical:_.critical(t);break;default:throw new Error("Invalid log level")}}e.log=D;function R(_){let n="";for(let t=0;t<_.length;t++){let o=_[t];if(typeof o=="object")try{o=JSON.stringify(o)}catch(d){}n+=(t>0?" ":"")+o}return n}e.format=R;class P extends y.Disposable{constructor(){super(...arguments);this.level=e.DEFAULT_LOG_LEVEL,this._onDidChangeLogLevel=this._register(new L.Emitter),this.onDidChangeLogLevel=this._onDidChangeLogLevel.event}setLevel(n){this.level!==n&&(this.level=n,this._onDidChangeLogLevel.fire(this.level))}getLevel(){return this.level}}e.AbstractLogger=P;class u extends P{constructor(n){super();this.logAlways=n}checkLogLevel(n){return this.logAlways||this.getLevel()<=n}trace(n,...t){this.checkLogLevel(S.Trace)&&this.log(S.Trace,R([n,...t]))}debug(n,...t){this.checkLogLevel(S.Debug)&&this.log(S.Debug,R([n,...t]))}info(n,...t){this.checkLogLevel(S.Info)&&this.log(S.Info,R([n,...t]))}warn(n,...t){this.checkLogLevel(S.Warning)&&this.log(S.Warning,R([n,...t]))}error(n,...t){if(this.checkLogLevel(S.Error))if(n instanceof Error){const o=Array.prototype.slice.call(arguments);o[0]=n.stack,this.log(S.Error,R(o))}else this.log(S.Error,R([n,...t]))}critical(n,...t){this.checkLogLevel(S.Critical)&&this.log(S.Critical,R([n,...t]))}flush(){}}e.AbstractMessageLogger=u;class E extends P{constructor(n=e.DEFAULT_LOG_LEVEL){super();this.setLevel(n),this.useColors=!C.isWindows}trace(n,...t){this.getLevel()<=S.Trace&&(this.useColors?console.log(`[90m[main ${k()}][0m`,n,...t):console.log(`[main ${k()}]`,n,...t))}debug(n,...t){this.getLevel()<=S.Debug&&(this.useColors?console.log(`[90m[main ${k()}][0m`,n,...t):console.log(`[main ${k()}]`,n,...t))}info(n,...t){this.getLevel()<=S.Info&&(this.useColors?console.log(`[90m[main ${k()}][0m`,n,...t):console.log(`[main ${k()}]`,n,...t))}warn(n,...t){this.getLevel()<=S.Warning&&(this.useColors?console.warn(`[93m[main ${k()}][0m`,n,...t):console.warn(`[main ${k()}]`,n,...t))}error(n,...t){this.getLevel()<=S.Error&&(this.useColors?console.error(`[91m[main ${k()}][0m`,n,...t):console.error(`[main ${k()}]`,n,...t))}critical(n,...t){this.getLevel()<=S.Critical&&(this.useColors?console.error(`[90m[main ${k()}][0m`,n,...t):console.error(`[main ${k()}]`,n,...t))}dispose(){}flush(){}}e.ConsoleMainLogger=E;class f extends P{constructor(n=e.DEFAULT_LOG_LEVEL){super();this.setLevel(n)}trace(n,...t){this.getLevel()<=S.Trace&&console.log("%cTRACE","color: #888",n,...t)}debug(n,...t){this.getLevel()<=S.Debug&&console.log("%cDEBUG","background: #eee; color: #888",n,...t)}info(n,...t){this.getLevel()<=S.Info&&console.log("%c INFO","color: #33f",n,...t)}warn(n,...t){this.getLevel()<=S.Warning&&console.log("%c WARN","color: #993",n,...t)}error(n,...t){this.getLevel()<=S.Error&&console.log("%c  ERR","color: #f33",n,...t)}critical(n,...t){this.getLevel()<=S.Critical&&console.log("%cCRITI","background: #f33; color: white",n,...t)}dispose(){}flush(){}}e.ConsoleLogger=f;class v extends P{constructor(n,t=e.DEFAULT_LOG_LEVEL){super();this.adapter=n,this.setLevel(t)}trace(n,...t){this.getLevel()<=S.Trace&&this.adapter.log(S.Trace,[this.extractMessage(n),...t])}debug(n,...t){this.getLevel()<=S.Debug&&this.adapter.log(S.Debug,[this.extractMessage(n),...t])}info(n,...t){this.getLevel()<=S.Info&&this.adapter.log(S.Info,[this.extractMessage(n),...t])}warn(n,...t){this.getLevel()<=S.Warning&&this.adapter.log(S.Warning,[this.extractMessage(n),...t])}error(n,...t){this.getLevel()<=S.Error&&this.adapter.log(S.Error,[this.extractMessage(n),...t])}critical(n,...t){this.getLevel()<=S.Critical&&this.adapter.log(S.Critical,[this.extractMessage(n),...t])}extractMessage(n){return typeof n=="string"?n:(0,m.toErrorMessage)(n,this.getLevel()<=S.Trace)}dispose(){}flush(){}}e.AdapterLogger=v;class w extends P{constructor(n){super();this.logServices=n,n.length&&this.setLevel(n[0].getLevel())}setLevel(n){for(const t of this.logServices)t.setLevel(n);super.setLevel(n)}trace(n,...t){for(const o of this.logServices)o.trace(n,...t)}debug(n,...t){for(const o of this.logServices)o.debug(n,...t)}info(n,...t){for(const o of this.logServices)o.info(n,...t)}warn(n,...t){for(const o of this.logServices)o.warn(n,...t)}error(n,...t){for(const o of this.logServices)o.error(n,...t)}critical(n,...t){for(const o of this.logServices)o.critical(n,...t)}flush(){for(const n of this.logServices)n.flush()}dispose(){for(const n of this.logServices)n.dispose()}}e.MultiplexLogService=w;class I extends y.Disposable{constructor(n){super();this.logger=n,this._register(n)}get onDidChangeLogLevel(){return this.logger.onDidChangeLogLevel}setLevel(n){this.logger.setLevel(n)}getLevel(){return this.logger.getLevel()}trace(n,...t){this.logger.trace(n,...t)}debug(n,...t){this.logger.debug(n,...t)}info(n,...t){this.logger.info(n,...t)}warn(n,...t){this.logger.warn(n,...t)}error(n,...t){this.logger.error(n,...t)}critical(n,...t){this.logger.critical(n,...t)}flush(){this.logger.flush()}}e.LogService=I;class p extends y.Disposable{constructor(n,t){super();this.logLevel=n,this.loggers=new Map,this.logLevelChangeableLoggers=[],this._register(t(o=>{this.logLevel=o,this.logLevelChangeableLoggers.forEach(d=>d.setLevel(o))}))}getLogger(n){return this.loggers.get(n.toString())}createLogger(n,t){let o=this.loggers.get(n.toString());return o||(o=this.doCreateLogger(n,t?.always?S.Trace:this.logLevel,t),this.loggers.set(n.toString(),o),t?.always||this.logLevelChangeableLoggers.push(o)),o}dispose(){this.logLevelChangeableLoggers.splice(0,this.logLevelChangeableLoggers.length),this.loggers.forEach(n=>n.dispose()),this.loggers.clear(),super.dispose()}}e.AbstractLoggerService=p;class s{constructor(){this.onDidChangeLogLevel=new L.Emitter().event}setLevel(n){}getLevel(){return S.Info}trace(n,...t){}debug(n,...t){}info(n,...t){}warn(n,...t){}error(n,...t){}critical(n,...t){}dispose(){}flush(){}}e.NullLogService=s;function r(_){if(_.verbose)return S.Trace;if(typeof _.logLevel=="string"){const n=g(_.logLevel.toLowerCase());if(n!==void 0)return n}return e.DEFAULT_LOG_LEVEL}e.getLogLevel=r;function g(_){switch(_){case"trace":return S.Trace;case"debug":return S.Debug;case"info":return S.Info;case"warn":return S.Warning;case"error":return S.Error;case"critical":return S.Critical;case"off":return S.Off}}e.parseLogLevel=g;function a(_){switch(_){case S.Trace:return"trace";case S.Debug:return"debug";case S.Info:return"info";case S.Warning:return"warn";case S.Error:return"error";case S.Critical:return"critical";case S.Off:return"off"}}e.LogLevelToString=a}),define(pe[187],ve([0,1,42,11]),function(Y,e,m,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SpdLogLogger=void 0;async function y(k,S,D,R,P){try{const u=await new Promise((f,v)=>{Y(["spdlog"],f,v)});u.setFlushOn(L.LogLevel.Trace);const E=await u.createAsyncRotatingLogger(k,S,D,R);return P&&E.clearFormatters(),E}catch(u){console.error(u)}return null}function C(k,S,D){switch(S){case L.LogLevel.Trace:k.trace(D);break;case L.LogLevel.Debug:k.debug(D);break;case L.LogLevel.Info:k.info(D);break;case L.LogLevel.Warning:k.warn(D);break;case L.LogLevel.Error:k.error(D);break;case L.LogLevel.Critical:k.critical(D);break;default:throw new Error("Invalid log level")}}class i extends L.AbstractMessageLogger{constructor(S,D,R,P,u){super();this.buffer=[],this.setLevel(u),this._loggerCreationPromise=this._createSpdLogLogger(S,D,R,P),this._register(this.onDidChangeLogLevel(E=>{this._logger&&this._logger.setLevel(E)}))}async _createSpdLogLogger(S,D,R,P){const u=R?6:1,E=30/u*m.ByteSize.MB,f=await y(S,D,E,u,P);if(f){this._logger=f,this._logger.setLevel(this.getLevel());for(const{level:v,message:w}of this.buffer)C(this._logger,v,w);this.buffer=[]}}log(S,D){this._logger?C(this._logger,S,D):this.getLevel()<=S&&this.buffer.push({level:S,message:D})}flush(){this._logger?this._logger.flush():this._loggerCreationPromise.then(()=>this.flush())}dispose(){this._logger?this.disposeLogger():this._loggerCreationPromise.then(()=>this.disposeLogger())}disposeLogger(){this._logger&&(this._logger.drop(),this._logger=void 0)}}e.SpdLogLogger=i}),define(pe[116],ve([0,1,48,160,4]),function(Y,e,m,L,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IMarkerService=e.IMarkerData=e.MarkerSeverity=e.MarkerTag=void 0;var C;(function(S){S[S.Unnecessary=1]="Unnecessary",S[S.Deprecated=2]="Deprecated"})(C=e.MarkerTag||(e.MarkerTag={}));var i;(function(S){S[S.Hint=1]="Hint",S[S.Info=2]="Info",S[S.Warning=4]="Warning",S[S.Error=8]="Error"})(i=e.MarkerSeverity||(e.MarkerSeverity={})),function(S){function D(f,v){return v-f}S.compare=D;const R=Object.create(null);R[S.Error]=(0,L.localize)(0,null),R[S.Warning]=(0,L.localize)(1,null),R[S.Info]=(0,L.localize)(2,null);function P(f){return R[f]||""}S.toString=P;function u(f){switch(f){case m.default.Error:return S.Error;case m.default.Warning:return S.Warning;case m.default.Info:return S.Info;case m.default.Ignore:return S.Hint}}S.fromSeverity=u;function E(f){switch(f){case S.Error:return m.default.Error;case S.Warning:return m.default.Warning;case S.Info:return m.default.Info;case S.Hint:return m.default.Ignore}}S.toSeverity=E}(i=e.MarkerSeverity||(e.MarkerSeverity={}));var k;(function(S){const D="";function R(u){return P(u,!0)}S.makeKey=R;function P(u,E){let f=[D];return u.source?f.push(u.source.replace("\xA6","\\\xA6")):f.push(D),u.code?typeof u.code=="string"?f.push(u.code.replace("\xA6","\\\xA6")):f.push(u.code.value.replace("\xA6","\\\xA6")):f.push(D),u.severity!==void 0&&u.severity!==null?f.push(i.toString(u.severity)):f.push(D),u.message&&E?f.push(u.message.replace("\xA6","\\\xA6")):f.push(D),u.startLineNumber!==void 0&&u.startLineNumber!==null?f.push(u.startLineNumber.toString()):f.push(D),u.startColumn!==void 0&&u.startColumn!==null?f.push(u.startColumn.toString()):f.push(D),u.endLineNumber!==void 0&&u.endLineNumber!==null?f.push(u.endLineNumber.toString()):f.push(D),u.endColumn!==void 0&&u.endColumn!==null?f.push(u.endColumn.toString()):f.push(D),f.push(D),f.join("\xA6")}S.makeKeyOptionalMessage=P})(k=e.IMarkerData||(e.IMarkerData={})),e.IMarkerService=(0,y.createDecorator)("markerService")}),define(pe[188],ve([0,1,3,48,4]),function(Y,e,m,L,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NoOpProgress=e.NoOpNotification=e.NotificationsFilter=e.NeverShowAgainScope=e.INotificationService=e.Severity=void 0,e.Severity=L.default,e.INotificationService=(0,y.createDecorator)("notificationService");var C;(function(D){D[D.WORKSPACE=0]="WORKSPACE",D[D.GLOBAL=1]="GLOBAL"})(C=e.NeverShowAgainScope||(e.NeverShowAgainScope={}));var i;(function(D){D[D.OFF=0]="OFF",D[D.SILENT=1]="SILENT",D[D.ERROR=2]="ERROR"})(i=e.NotificationsFilter||(e.NotificationsFilter={}));class k{constructor(){this.progress=new S,this.onDidClose=m.Event.None,this.onDidChangeVisibility=m.Event.None}updateSeverity(R){}updateMessage(R){}updateActions(R){}close(){}}e.NoOpNotification=k;class S{infinite(){}done(){}total(R){}worked(R){}}e.NoOpProgress=S}),define(pe[189],ve([0,1,6,8,2,4]),function(Y,e,m,L,y,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.matchesSomeScheme=e.matchesScheme=e.NullOpenerService=e.IOpenerService=void 0,e.IOpenerService=(0,C.createDecorator)("openerService"),e.NullOpenerService=Object.freeze({_serviceBrand:void 0,registerOpener(){return m.Disposable.None},registerValidator(){return m.Disposable.None},registerExternalUriResolver(){return m.Disposable.None},setDefaultExternalOpener(){},registerExternalOpener(){return m.Disposable.None},async open(){return!1},async resolveExternalUri(S){return{resolved:S,dispose(){}}}});function i(S,D){return y.URI.isUri(S)?(0,L.equalsIgnoreCase)(S.scheme,D):(0,L.startsWithIgnoreCase)(S,D+":")}e.matchesScheme=i;function k(S,...D){return D.some(R=>i(S,R))}e.matchesSomeScheme=k}),define(pe[190],ve([0,1,10,12,40,23]),function(Y,e,m,L,y,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0});let i;if(typeof L.globals.vscode!="undefined"&&typeof L.globals.vscode.context!="undefined"){const k=L.globals.vscode.context.configuration();if(k)i=k.product;else throw new Error("Sandbox: unable to resolve product configuration from preload script.")}else if(typeof Y?.__$__nodeRequire=="function"){const k=(0,C.dirname)(m.FileAccess.asFileUri("",Y));i=Y.__$__nodeRequire((0,C.joinPath)(k,"product.json").fsPath);const S=Y.__$__nodeRequire((0,C.joinPath)(k,"package.json").fsPath);y.env.VSCODE_DEV&&Object.assign(i,{nameShort:`${i.nameShort} Dev`,nameLong:`${i.nameLong} Dev`,dataFolderName:`${i.dataFolderName}-dev`}),Object.assign(i,{version:S.version})}else i={},Object.keys(i).length===0&&Object.assign(i,{version:"1.63.0-dev",nameShort:"Code - OSS Dev",nameLong:"Code - OSS Dev",applicationName:"code-oss",dataFolderName:".vscode-oss",urlProtocol:"code-oss",reportIssueUrl:"https://github.com/microsoft/vscode/issues/new",licenseName:"MIT",licenseUrl:"https://github.com/microsoft/vscode/blob/main/LICENSE.txt",extensionAllowedProposedApi:["ms-vscode.vscode-js-profile-flame","ms-vscode.vscode-js-profile-table","GitHub.remotehub","GitHub.remotehub-insiders"]});e.default=i});var He=this&&this.__param||function(Y,e){return function(m,L){e(m,L,Y)}};define(pe[117],ve([0,1,18,21,6,4]),function(Y,e,m,L,y,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IEditorProgressService=e.LongRunningOperation=e.UnmanagedProgress=e.Progress=e.emptyProgressRunner=e.ProgressLocation=e.IProgressService=void 0,e.IProgressService=(0,C.createDecorator)("progressService");var i;(function(R){R[R.Explorer=1]="Explorer",R[R.Scm=3]="Scm",R[R.Extensions=5]="Extensions",R[R.Window=10]="Window",R[R.Notification=15]="Notification",R[R.Dialog=20]="Dialog"})(i=e.ProgressLocation||(e.ProgressLocation={})),e.emptyProgressRunner=Object.freeze({total(){},worked(){},done(){}});class k{constructor(P){this.callback=P}get value(){return this._value}report(P){this._value=P,this.callback(this._value)}}e.Progress=k,k.None=Object.freeze({report(){}});let S=class extends y.Disposable{constructor(P,u){super();this.deferred=new m.DeferredPromise,u.withProgress(P,E=>(this.reporter=E,this.lastStep&&E.report(this.lastStep),this.deferred.p)),this._register((0,y.toDisposable)(()=>this.deferred.complete()))}report(P){this.reporter?this.reporter.report(P):this.lastStep=P}};S=je([He(1,e.IProgressService)],S),e.UnmanagedProgress=S;class D extends y.Disposable{constructor(P){super();this.progressIndicator=P,this.currentOperationId=0,this.currentOperationDisposables=this._register(new y.DisposableStore)}start(P){this.stop();const u=++this.currentOperationId,E=new L.CancellationTokenSource;return this.currentProgressTimeout=setTimeout(()=>{u===this.currentOperationId&&(this.currentProgressRunner=this.progressIndicator.show(!0))},P),this.currentOperationDisposables.add((0,y.toDisposable)(()=>clearTimeout(this.currentProgressTimeout))),this.currentOperationDisposables.add((0,y.toDisposable)(()=>E.cancel())),this.currentOperationDisposables.add((0,y.toDisposable)(()=>this.currentProgressRunner?this.currentProgressRunner.done():void 0)),{id:u,token:E.token,stop:()=>this.doStop(u),isCurrent:()=>this.currentOperationId===u}}stop(){this.doStop(this.currentOperationId)}doStop(P){this.currentOperationId===P&&this.currentOperationDisposables.clear()}}e.LongRunningOperation=D,e.IEditorProgressService=(0,C.createDecorator)("editorProgressService")}),define(pe[51],ve([0,1,56,13]),function(Y,e,m,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Registry=void 0;class y{constructor(){this.data=new Map}add(i,k){m.ok(L.isString(i)),m.ok(L.isObject(k)),m.ok(!this.data.has(i),"There is already an extension with this id"),this.data.set(i,k)}knows(i){return this.data.has(i)}as(i){return this.data.get(i)||null}}e.Registry=new y}),define(pe[191],ve([0,1,3,51]),function(Y,e,m,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Extensions=void 0,e.Extensions={JSONContribution:"base.contributions.json"};function y(k){return k.length>0&&k.charAt(k.length-1)==="#"?k.substring(0,k.length-1):k}class C{constructor(){this._onDidChangeSchema=new m.Emitter,this.onDidChangeSchema=this._onDidChangeSchema.event,this.schemasById={}}registerSchema(S,D){this.schemasById[y(S)]=D,this._onDidChangeSchema.fire(S)}notifySchemaChanged(S){this._onDidChangeSchema.fire(S)}getSchemaContributions(){return{schemas:this.schemasById}}}const i=new C;L.Registry.add(e.Extensions.JSONContribution,i)}),define(pe[118],ve([0,1,16,3,13,155,191,51]),function(Y,e,m,L,y,C,i,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getScopes=e.validateProperty=e.getDefaultValue=e.keyFromOverrideIdentifiers=e.overrideIdentifiersFromKey=e.OVERRIDE_PROPERTY_REGEX=e.OVERRIDE_PROPERTY_PATTERN=e.configurationDefaultsSchemaId=e.resourceLanguageSettingsSchemaId=e.resourceSettings=e.windowSettings=e.machineOverridableSettings=e.machineSettings=e.applicationSettings=e.allSettings=e.ConfigurationScope=e.Extensions=e.EditPresentationTypes=void 0;var S;(function(r){r.Multiline="multilineText",r.Singleline="singlelineText"})(S=e.EditPresentationTypes||(e.EditPresentationTypes={})),e.Extensions={Configuration:"base.contributions.configuration"};var D;(function(r){r[r.APPLICATION=1]="APPLICATION",r[r.MACHINE=2]="MACHINE",r[r.WINDOW=3]="WINDOW",r[r.RESOURCE=4]="RESOURCE",r[r.LANGUAGE_OVERRIDABLE=5]="LANGUAGE_OVERRIDABLE",r[r.MACHINE_OVERRIDABLE=6]="MACHINE_OVERRIDABLE"})(D=e.ConfigurationScope||(e.ConfigurationScope={})),e.allSettings={properties:{},patternProperties:{}},e.applicationSettings={properties:{},patternProperties:{}},e.machineSettings={properties:{},patternProperties:{}},e.machineOverridableSettings={properties:{},patternProperties:{}},e.windowSettings={properties:{},patternProperties:{}},e.resourceSettings={properties:{},patternProperties:{}},e.resourceLanguageSettingsSchemaId="vscode://schemas/settings/resourceLanguage",e.configurationDefaultsSchemaId="vscode://schemas/settings/configurationDefaults";const R=k.Registry.as(i.Extensions.JSONContribution);class P{constructor(){this.overrideIdentifiers=new Set,this._onDidSchemaChange=new L.Emitter,this.onDidSchemaChange=this._onDidSchemaChange.event,this._onDidUpdateConfiguration=new L.Emitter,this.onDidUpdateConfiguration=this._onDidUpdateConfiguration.event,this.configurationDefaultsOverrides=new Map,this.defaultLanguageConfigurationOverridesNode={id:"defaultOverrides",title:C.localize(0,null),properties:{}},this.configurationContributors=[this.defaultLanguageConfigurationOverridesNode],this.resourceLanguageSettingsSchema={properties:{},patternProperties:{},additionalProperties:!1,errorMessage:"Unknown editor configuration setting",allowTrailingCommas:!0,allowComments:!0},this.configurationProperties={},this.excludedConfigurationProperties={},R.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this.registerOverridePropertyPatternKey()}registerConfiguration(g,a=!0){this.registerConfigurations([g],a)}registerConfigurations(g,a=!0){const _=this.doRegisterConfigurations(g,a);R.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:_})}deregisterConfigurations(g){const a=this.doDeregisterConfigurations(g);R.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:a})}updateConfigurations({add:g,remove:a}){const _=[];_.push(...this.doDeregisterConfigurations(a)),_.push(...this.doRegisterConfigurations(g,!1)),R.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:(0,m.distinct)(_)})}registerDefaultConfigurations(g){const a=[],_=[];for(const{overrides:n,source:t}of g)for(const o in n)if(a.push(o),e.OVERRIDE_PROPERTY_REGEX.test(o)){const d={...this.configurationDefaultsOverrides.get(o)?.value||{},...n[o]};this.configurationDefaultsOverrides.set(o,{source:t,value:d});const c={type:"object",default:d,description:C.localize(1,null,o),$ref:e.resourceLanguageSettingsSchemaId,defaultDefaultValue:d,source:y.isString(t)?void 0:t};_.push(...f(o)),this.configurationProperties[o]=c,this.defaultLanguageConfigurationOverridesNode.properties[o]=c}else{this.configurationDefaultsOverrides.set(o,{value:n[o],source:t});const d=this.configurationProperties[o];d&&(this.updatePropertyDefaultValue(o,d),this.updateSchema(o,d))}this.registerOverrideIdentifiers(_),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:a,defaultsOverrides:!0})}deregisterDefaultConfigurations(g){const a=[];for(const{overrides:_,source:n}of g)for(const t in _){const o=this.configurationDefaultsOverrides.get(t),d=y.isString(n)?n:n?.id,c=y.isString(o?.source)?o?.source:o?.source?.id;if(d===c)if(a.push(t),this.configurationDefaultsOverrides.delete(t),e.OVERRIDE_PROPERTY_REGEX.test(t))delete this.configurationProperties[t],delete this.defaultLanguageConfigurationOverridesNode.properties[t];else{const h=this.configurationProperties[t];h&&(this.updatePropertyDefaultValue(t,h),this.updateSchema(t,h))}}this.updateOverridePropertyPatternKey(),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:a,defaultsOverrides:!0})}notifyConfigurationSchemaUpdated(...g){this._onDidSchemaChange.fire()}registerOverrideIdentifiers(g){for(const a of g)this.overrideIdentifiers.add(a);this.updateOverridePropertyPatternKey()}doRegisterConfigurations(g,a){const _=[];return g.forEach(n=>{_.push(...this.validateAndRegisterProperties(n,a,n.extensionInfo,n.restrictedProperties)),this.configurationContributors.push(n),this.registerJSONConfiguration(n)}),_}doDeregisterConfigurations(g){const a=[],_=n=>{if(n.properties)for(const t in n.properties)a.push(t),delete this.configurationProperties[t],this.removeFromSchema(t,n.properties[t]);n.allOf&&n.allOf.forEach(t=>_(t))};for(const n of g){_(n);const t=this.configurationContributors.indexOf(n);t!==-1&&this.configurationContributors.splice(t,1)}return a}validateAndRegisterProperties(g,a=!0,_,n,t=3){t=y.isUndefinedOrNull(g.scope)?t:g.scope;let o=[],d=g.properties;if(d)for(let h in d){if(a&&p(h)){delete d[h];continue}const l=d[h];if(l.source=_,l.defaultDefaultValue=d[h].default,this.updatePropertyDefaultValue(h,l),e.OVERRIDE_PROPERTY_REGEX.test(h)?l.scope=void 0:(l.scope=y.isUndefinedOrNull(l.scope)?t:l.scope,l.restricted=y.isUndefinedOrNull(l.restricted)?!!n?.includes(h):l.restricted),d[h].hasOwnProperty("included")&&!d[h].included){this.excludedConfigurationProperties[h]=d[h],delete d[h];continue}else this.configurationProperties[h]=d[h];!d[h].deprecationMessage&&d[h].markdownDeprecationMessage&&(d[h].deprecationMessage=d[h].markdownDeprecationMessage),o.push(h)}let c=g.allOf;if(c)for(let h of c)o.push(...this.validateAndRegisterProperties(h,a,_,n,t));return o}getConfigurations(){return this.configurationContributors}getConfigurationProperties(){return this.configurationProperties}getExcludedConfigurationProperties(){return this.excludedConfigurationProperties}getConfigurationDefaultsOverrides(){return this.configurationDefaultsOverrides}registerJSONConfiguration(g){const a=_=>{let n=_.properties;if(n)for(const o in n)this.updateSchema(o,n[o]);let t=_.allOf;t&&t.forEach(a)};a(g)}updateSchema(g,a){switch(e.allSettings.properties[g]=a,a.scope){case 1:e.applicationSettings.properties[g]=a;break;case 2:e.machineSettings.properties[g]=a;break;case 6:e.machineOverridableSettings.properties[g]=a;break;case 3:e.windowSettings.properties[g]=a;break;case 4:e.resourceSettings.properties[g]=a;break;case 5:e.resourceSettings.properties[g]=a,this.resourceLanguageSettingsSchema.properties[g]=a;break}}removeFromSchema(g,a){switch(delete e.allSettings.properties[g],a.scope){case 1:delete e.applicationSettings.properties[g];break;case 2:delete e.machineSettings.properties[g];break;case 6:delete e.machineOverridableSettings.properties[g];break;case 3:delete e.windowSettings.properties[g];break;case 4:case 5:delete e.resourceSettings.properties[g],delete this.resourceLanguageSettingsSchema.properties[g];break}}updateOverridePropertyPatternKey(){for(const g of this.overrideIdentifiers.values()){const a=`[${g}]`,_={type:"object",description:C.localize(2,null),errorMessage:C.localize(3,null),$ref:e.resourceLanguageSettingsSchemaId};this.updatePropertyDefaultValue(a,_),e.allSettings.properties[a]=_,e.applicationSettings.properties[a]=_,e.machineSettings.properties[a]=_,e.machineOverridableSettings.properties[a]=_,e.windowSettings.properties[a]=_,e.resourceSettings.properties[a]=_}this._onDidSchemaChange.fire()}registerOverridePropertyPatternKey(){const g={type:"object",description:C.localize(4,null),errorMessage:C.localize(5,null),$ref:e.resourceLanguageSettingsSchemaId};e.allSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=g,e.applicationSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=g,e.machineSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=g,e.machineOverridableSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=g,e.windowSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=g,e.resourceSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=g,this._onDidSchemaChange.fire()}updatePropertyDefaultValue(g,a){const _=this.configurationDefaultsOverrides.get(g);let n=_?.value,t=_?.source;y.isUndefined(n)&&(n=a.defaultDefaultValue,t=void 0),y.isUndefined(n)&&(n=w(a.type)),a.default=n,a.defaultValueSource=t}}const u="\\[([^\\]]+)\\]",E=new RegExp(u,"g");e.OVERRIDE_PROPERTY_PATTERN=`^(${u})+$`,e.OVERRIDE_PROPERTY_REGEX=new RegExp(e.OVERRIDE_PROPERTY_PATTERN);function f(r){const g=[];if(e.OVERRIDE_PROPERTY_REGEX.test(r)){let a=E.exec(r);for(;a?.length;){const _=a[1].trim();_&&g.push(_),a=E.exec(r)}}return(0,m.distinct)(g)}e.overrideIdentifiersFromKey=f;function v(r){return r.reduce((g,a)=>`${g}[${a}]`,"")}e.keyFromOverrideIdentifiers=v;function w(r){switch(Array.isArray(r)?r[0]:r){case"boolean":return!1;case"integer":case"number":return 0;case"string":return"";case"array":return[];case"object":return{};default:return null}}e.getDefaultValue=w;const I=new P;k.Registry.add(e.Extensions.Configuration,I);function p(r){return r.trim()?e.OVERRIDE_PROPERTY_REGEX.test(r)?C.localize(7,null,r):I.getConfigurationProperties()[r]!==void 0?C.localize(8,null,r):null:C.localize(6,null)}e.validateProperty=p;function s(){const r=[],g=I.getConfigurationProperties();for(const a of Object.keys(g))r.push([a,g[a].scope]);return r.push(["launch",4]),r.push(["task",4]),r}e.getScopes=s}),define(pe[192],ve([0,1,16,3,58,6,24,25,13,2,115,118,51]),function(Y,e,m,L,y,C,i,k,S,D,R,P,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AllKeysConfigurationChangeEvent=e.ConfigurationChangeEvent=e.mergeChanges=e.Configuration=e.UserSettings=e.ConfigurationModelParser=e.DefaultConfigurationModel=e.ConfigurationModel=void 0;class E{constructor(n={},t=[],o=[]){this._contents=n,this._keys=t,this._overrides=o,this.isFrozen=!1,this.overrideConfigurations=new Map}get contents(){return this.checkAndFreeze(this._contents)}get overrides(){return this.checkAndFreeze(this._overrides)}get keys(){return this.checkAndFreeze(this._keys)}isEmpty(){return this._keys.length===0&&Object.keys(this._contents).length===0&&this._overrides.length===0}getValue(n){return n?(0,R.getConfigurationValue)(this.contents,n):this.contents}getOverrideValue(n,t){const o=this.getContentsForOverrideIdentifer(t);return o?n?(0,R.getConfigurationValue)(o,n):o:void 0}getKeysForOverrideIdentifier(n){const t=[];for(const o of this.overrides)o.identifiers.includes(n)&&t.push(...o.keys);return m.distinct(t)}getAllOverrideIdentifiers(){const n=[];for(const t of this.overrides)n.push(...t.identifiers);return m.distinct(n)}override(n){let t=this.overrideConfigurations.get(n);return t||(t=this.createOverrideConfigurationModel(n),this.overrideConfigurations.set(n,t)),t}merge(...n){const t=k.deepClone(this.contents),o=k.deepClone(this.overrides),d=[...this.keys];for(const c of n){this.mergeContents(t,c.contents);for(const h of c.overrides){const[l]=o.filter(b=>m.equals(b.identifiers,h.identifiers));l?(this.mergeContents(l.contents,h.contents),l.keys.push(...h.keys),l.keys=m.distinct(l.keys)):o.push(k.deepClone(h))}for(const h of c.keys)d.indexOf(h)===-1&&d.push(h)}return new E(t,d,o)}freeze(){return this.isFrozen=!0,this}createOverrideConfigurationModel(n){const t=this.getContentsForOverrideIdentifer(n);if(!t||typeof t!="object"||!Object.keys(t).length)return this;let o={};for(const d of m.distinct([...Object.keys(this.contents),...Object.keys(t)])){let c=this.contents[d],h=t[d];h&&(typeof c=="object"&&typeof h=="object"?(c=k.deepClone(c),this.mergeContents(c,h)):c=h),o[d]=c}return new E(o,this.keys,this.overrides)}mergeContents(n,t){for(const o of Object.keys(t)){if(o in n&&S.isObject(n[o])&&S.isObject(t[o])){this.mergeContents(n[o],t[o]);continue}n[o]=k.deepClone(t[o])}}checkAndFreeze(n){return this.isFrozen&&!Object.isFrozen(n)?k.deepFreeze(n):n}getContentsForOverrideIdentifer(n){let t=null,o=null;const d=c=>{c&&(o?this.mergeContents(o,c):o=k.deepClone(c))};for(const c of this.overrides)m.equals(c.identifiers,[n])?t=c.contents:c.identifiers.includes(n)&&d(c.contents);return d(t),o}toJSON(){return{contents:this.contents,overrides:this.overrides,keys:this.keys}}setValue(n,t){this.addKey(n),(0,R.addToValueTree)(this.contents,n,t,o=>{throw new Error(o)})}removeValue(n){this.removeKey(n)&&(0,R.removeFromValueTree)(this.contents,n)}addKey(n){let t=this.keys.length;for(let o=0;o<t;o++)n.indexOf(this.keys[o])===0&&(t=o);this.keys.splice(t,1,n)}removeKey(n){let t=this.keys.indexOf(n);return t!==-1?(this.keys.splice(t,1),!0):!1}}e.ConfigurationModel=E;class f extends E{constructor(n={}){const t=u.Registry.as(P.Extensions.Configuration).getConfigurationProperties(),o=Object.keys(t),d=Object.create(null),c=[];for(const h in t){const l=n[h],b=l!==void 0?l:t[h].default;(0,R.addToValueTree)(d,h,b,T=>console.error(`Conflict in default settings: ${T}`))}for(const h of Object.keys(d))P.OVERRIDE_PROPERTY_REGEX.test(h)&&c.push({identifiers:(0,P.overrideIdentifiersFromKey)(h),keys:Object.keys(d[h]),contents:(0,R.toValuesTree)(d[h],l=>console.error(`Conflict in default settings file: ${l}`))});super(d,o,c)}}e.DefaultConfigurationModel=f;class v{constructor(n){this._name=n,this._raw=null,this._configurationModel=null,this._restrictedConfigurations=[],this._parseErrors=[]}get configurationModel(){return this._configurationModel||new E}get restrictedConfigurations(){return this._restrictedConfigurations}get errors(){return this._parseErrors}parse(n,t){if(!S.isUndefinedOrNull(n)){const o=this.doParseContent(n);this.parseRaw(o,t)}}reparse(n){this._raw&&this.parseRaw(this._raw,n)}parseRaw(n,t){this._raw=n;const{contents:o,keys:d,overrides:c,restricted:h}=this.doParseRaw(n,t);this._configurationModel=new E(o,d,c),this._restrictedConfigurations=h||[]}doParseContent(n){let t={},o=null,d=[],c=[],h=[];function l(T){Array.isArray(d)?d.push(T):o!==null&&(d[o]=T)}let b={onObjectBegin:()=>{let T={};l(T),c.push(d),d=T,o=null},onObjectProperty:T=>{o=T},onObjectEnd:()=>{d=c.pop()},onArrayBegin:()=>{let T=[];l(T),c.push(d),d=T,o=null},onArrayEnd:()=>{d=c.pop()},onLiteralValue:l,onError:(T,A,x)=>{h.push({error:T,offset:A,length:x})}};if(n)try{y.visit(n,b),t=d[0]||{}}catch(T){console.error(`Error while parsing settings file ${this._name}: ${T}`),this._parseErrors=[T]}return t}doParseRaw(n,t){const o=u.Registry.as(P.Extensions.Configuration).getConfigurationProperties(),d=this.filter(n,o,!0,t);n=d.raw;const c=(0,R.toValuesTree)(n,b=>console.error(`Conflict in settings file ${this._name}: ${b}`)),h=Object.keys(n),l=this.toOverrides(n,b=>console.error(`Conflict in settings file ${this._name}: ${b}`));return{contents:c,keys:h,overrides:l,restricted:d.restricted}}filter(n,t,o,d){if(!d?.scopes&&!d?.skipRestricted)return{raw:n,restricted:[]};const c={},h=[];for(let l in n)if(P.OVERRIDE_PROPERTY_REGEX.test(l)&&o){const b=this.filter(n[l],t,!1,d);c[l]=b.raw,h.push(...b.restricted)}else{const b=t[l],T=b?typeof b.scope!="undefined"?b.scope:3:void 0;b?.restricted&&h.push(l),(T===void 0||d.scopes===void 0||d.scopes.includes(T))&&(d.skipRestricted&&b?.restricted||(c[l]=n[l]))}return{raw:c,restricted:h}}toOverrides(n,t){const o=[];for(const d of Object.keys(n))if(P.OVERRIDE_PROPERTY_REGEX.test(d)){const c={};for(const h in n[d])c[h]=n[d][h];o.push({identifiers:(0,P.overrideIdentifiersFromKey)(d),keys:Object.keys(c),contents:(0,R.toValuesTree)(c,t)})}return o}}e.ConfigurationModelParser=v;class w extends C.Disposable{constructor(n,t,o,d){super();this.userSettingsResource=n,this.scopes=t,this.fileService=d,this._onDidChange=this._register(new L.Emitter),this.onDidChange=this._onDidChange.event,this.parser=new v(this.userSettingsResource.toString()),this.parseOptions={scopes:this.scopes},this._register(this.fileService.watch(o.dirname(this.userSettingsResource))),this._register(this.fileService.watch(this.userSettingsResource)),this._register(L.Event.filter(this.fileService.onDidFilesChange,c=>c.contains(this.userSettingsResource))(()=>this._onDidChange.fire()))}async loadConfiguration(){try{const n=await this.fileService.readFile(this.userSettingsResource);return this.parser.parse(n.value.toString()||"{}",this.parseOptions),this.parser.configurationModel}catch(n){return new E}}reparse(){return this.parser.reparse(this.parseOptions),this.parser.configurationModel}getRestrictedSettings(){return this.parser.restrictedConfigurations}}e.UserSettings=w;class I{constructor(n,t,o=new E,d=new E,c=new i.ResourceMap,h=new E,l=new i.ResourceMap,b=!0){this._defaultConfiguration=n,this._localUserConfiguration=t,this._remoteUserConfiguration=o,this._workspaceConfiguration=d,this._folderConfigurations=c,this._memoryConfiguration=h,this._memoryConfigurationByResource=l,this._freeze=b,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations=new i.ResourceMap,this._userConfiguration=null}getValue(n,t,o){return this.getConsolidateConfigurationModel(t,o).getValue(n)}updateValue(n,t,o={}){let d;o.resource?(d=this._memoryConfigurationByResource.get(o.resource),d||(d=new E,this._memoryConfigurationByResource.set(o.resource,d))):d=this._memoryConfiguration,t===void 0?d.removeValue(n):d.setValue(n,t),o.resource||(this._workspaceConsolidatedConfiguration=null)}inspect(n,t,o){const d=this.getConsolidateConfigurationModel(t,o),c=this.getFolderConfigurationModelForResource(t.resource,o),h=t.resource?this._memoryConfigurationByResource.get(t.resource)||this._memoryConfiguration:this._memoryConfiguration,l=t.overrideIdentifier?this._defaultConfiguration.freeze().override(t.overrideIdentifier).getValue(n):this._defaultConfiguration.freeze().getValue(n),b=t.overrideIdentifier?this.userConfiguration.freeze().override(t.overrideIdentifier).getValue(n):this.userConfiguration.freeze().getValue(n),T=t.overrideIdentifier?this.localUserConfiguration.freeze().override(t.overrideIdentifier).getValue(n):this.localUserConfiguration.freeze().getValue(n),A=t.overrideIdentifier?this.remoteUserConfiguration.freeze().override(t.overrideIdentifier).getValue(n):this.remoteUserConfiguration.freeze().getValue(n),x=o?t.overrideIdentifier?this._workspaceConfiguration.freeze().override(t.overrideIdentifier).getValue(n):this._workspaceConfiguration.freeze().getValue(n):void 0,O=c?t.overrideIdentifier?c.freeze().override(t.overrideIdentifier).getValue(n):c.freeze().getValue(n):void 0,F=t.overrideIdentifier?h.override(t.overrideIdentifier).getValue(n):h.getValue(n),W=d.getValue(n),M=m.distinct(m.flatten(d.overrides.map(B=>B.identifiers))).filter(B=>d.getOverrideValue(n,B)!==void 0);return{defaultValue:l,userValue:b,userLocalValue:T,userRemoteValue:A,workspaceValue:x,workspaceFolderValue:O,memoryValue:F,value:W,default:l!==void 0?{value:this._defaultConfiguration.freeze().getValue(n),override:t.overrideIdentifier?this._defaultConfiguration.freeze().getOverrideValue(n,t.overrideIdentifier):void 0}:void 0,user:b!==void 0?{value:this.userConfiguration.freeze().getValue(n),override:t.overrideIdentifier?this.userConfiguration.freeze().getOverrideValue(n,t.overrideIdentifier):void 0}:void 0,userLocal:T!==void 0?{value:this.localUserConfiguration.freeze().getValue(n),override:t.overrideIdentifier?this.localUserConfiguration.freeze().getOverrideValue(n,t.overrideIdentifier):void 0}:void 0,userRemote:A!==void 0?{value:this.remoteUserConfiguration.freeze().getValue(n),override:t.overrideIdentifier?this.remoteUserConfiguration.freeze().getOverrideValue(n,t.overrideIdentifier):void 0}:void 0,workspace:x!==void 0?{value:this._workspaceConfiguration.freeze().getValue(n),override:t.overrideIdentifier?this._workspaceConfiguration.freeze().getOverrideValue(n,t.overrideIdentifier):void 0}:void 0,workspaceFolder:O!==void 0?{value:c?.freeze().getValue(n),override:t.overrideIdentifier?c?.freeze().getOverrideValue(n,t.overrideIdentifier):void 0}:void 0,memory:F!==void 0?{value:h.getValue(n),override:t.overrideIdentifier?h.getOverrideValue(n,t.overrideIdentifier):void 0}:void 0,overrideIdentifiers:M.length?M:void 0}}keys(n){const t=this.getFolderConfigurationModelForResource(void 0,n);return{default:this._defaultConfiguration.freeze().keys,user:this.userConfiguration.freeze().keys,workspace:this._workspaceConfiguration.freeze().keys,workspaceFolder:t?t.freeze().keys:[]}}updateDefaultConfiguration(n){this._defaultConfiguration=n,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateLocalUserConfiguration(n){this._localUserConfiguration=n,this._userConfiguration=null,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateRemoteUserConfiguration(n){this._remoteUserConfiguration=n,this._userConfiguration=null,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateWorkspaceConfiguration(n){this._workspaceConfiguration=n,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateFolderConfiguration(n,t){this._folderConfigurations.set(n,t),this._foldersConsolidatedConfigurations.delete(n)}deleteFolderConfiguration(n){this.folderConfigurations.delete(n),this._foldersConsolidatedConfigurations.delete(n)}compareAndUpdateDefaultConfiguration(n,t){const o=[];if(!t){const{added:d,updated:c,removed:h}=g(this._defaultConfiguration,n);t=[...d,...c,...h]}for(const d of t)for(const c of(0,P.overrideIdentifiersFromKey)(d)){const h=this._defaultConfiguration.getKeysForOverrideIdentifier(c),l=n.getKeysForOverrideIdentifier(c),b=[...l.filter(T=>h.indexOf(T)===-1),...h.filter(T=>l.indexOf(T)===-1),...h.filter(T=>!k.equals(this._defaultConfiguration.override(c).getValue(T),n.override(c).getValue(T)))];o.push([c,b])}return this.updateDefaultConfiguration(n),{keys:t,overrides:o}}compareAndUpdateLocalUserConfiguration(n){const{added:t,updated:o,removed:d,overrides:c}=g(this.localUserConfiguration,n),h=[...t,...o,...d];return h.length&&this.updateLocalUserConfiguration(n),{keys:h,overrides:c}}compareAndUpdateRemoteUserConfiguration(n){const{added:t,updated:o,removed:d,overrides:c}=g(this.remoteUserConfiguration,n);let h=[...t,...o,...d];return h.length&&this.updateRemoteUserConfiguration(n),{keys:h,overrides:c}}compareAndUpdateWorkspaceConfiguration(n){const{added:t,updated:o,removed:d,overrides:c}=g(this.workspaceConfiguration,n);let h=[...t,...o,...d];return h.length&&this.updateWorkspaceConfiguration(n),{keys:h,overrides:c}}compareAndUpdateFolderConfiguration(n,t){const o=this.folderConfigurations.get(n),{added:d,updated:c,removed:h,overrides:l}=g(o,t);let b=[...d,...c,...h];return(b.length||!o)&&this.updateFolderConfiguration(n,t),{keys:b,overrides:l}}compareAndDeleteFolderConfiguration(n){const t=this.folderConfigurations.get(n);if(!t)throw new Error("Unknown folder");this.deleteFolderConfiguration(n);const{added:o,updated:d,removed:c,overrides:h}=g(t,void 0);return{keys:[...o,...d,...c],overrides:h}}get defaults(){return this._defaultConfiguration}get userConfiguration(){return this._userConfiguration||(this._userConfiguration=this._remoteUserConfiguration.isEmpty()?this._localUserConfiguration:this._localUserConfiguration.merge(this._remoteUserConfiguration),this._freeze&&this._userConfiguration.freeze()),this._userConfiguration}get localUserConfiguration(){return this._localUserConfiguration}get remoteUserConfiguration(){return this._remoteUserConfiguration}get workspaceConfiguration(){return this._workspaceConfiguration}get folderConfigurations(){return this._folderConfigurations}getConsolidateConfigurationModel(n,t){let o=this.getConsolidatedConfigurationModelForResource(n,t);return n.overrideIdentifier?o.override(n.overrideIdentifier):o}getConsolidatedConfigurationModelForResource({resource:n},t){let o=this.getWorkspaceConsolidatedConfiguration();if(t&&n){const d=t.getFolder(n);d&&(o=this.getFolderConsolidatedConfiguration(d.uri)||o);const c=this._memoryConfigurationByResource.get(n);c&&(o=o.merge(c))}return o}getWorkspaceConsolidatedConfiguration(){return this._workspaceConsolidatedConfiguration||(this._workspaceConsolidatedConfiguration=this._defaultConfiguration.merge(this.userConfiguration,this._workspaceConfiguration,this._memoryConfiguration),this._freeze&&(this._workspaceConfiguration=this._workspaceConfiguration.freeze())),this._workspaceConsolidatedConfiguration}getFolderConsolidatedConfiguration(n){let t=this._foldersConsolidatedConfigurations.get(n);if(!t){const o=this.getWorkspaceConsolidatedConfiguration(),d=this._folderConfigurations.get(n);d?(t=o.merge(d),this._freeze&&(t=t.freeze()),this._foldersConsolidatedConfigurations.set(n,t)):t=o}return t}getFolderConfigurationModelForResource(n,t){if(t&&n){const o=t.getFolder(n);if(o)return this._folderConfigurations.get(o.uri)}}toData(){return{defaults:{contents:this._defaultConfiguration.contents,overrides:this._defaultConfiguration.overrides,keys:this._defaultConfiguration.keys},user:{contents:this.userConfiguration.contents,overrides:this.userConfiguration.overrides,keys:this.userConfiguration.keys},workspace:{contents:this._workspaceConfiguration.contents,overrides:this._workspaceConfiguration.overrides,keys:this._workspaceConfiguration.keys},folders:[...this._folderConfigurations.keys()].reduce((n,t)=>{const{contents:o,overrides:d,keys:c}=this._folderConfigurations.get(t);return n.push([t,{contents:o,overrides:d,keys:c}]),n},[])}}allKeys(){const n=new Set;return this._defaultConfiguration.freeze().keys.forEach(t=>n.add(t)),this.userConfiguration.freeze().keys.forEach(t=>n.add(t)),this._workspaceConfiguration.freeze().keys.forEach(t=>n.add(t)),this._folderConfigurations.forEach(t=>t.freeze().keys.forEach(o=>n.add(o))),[...n.values()]}allOverrideIdentifiers(){const n=new Set;return this._defaultConfiguration.freeze().getAllOverrideIdentifiers().forEach(t=>n.add(t)),this.userConfiguration.freeze().getAllOverrideIdentifiers().forEach(t=>n.add(t)),this._workspaceConfiguration.freeze().getAllOverrideIdentifiers().forEach(t=>n.add(t)),this._folderConfigurations.forEach(t=>t.freeze().getAllOverrideIdentifiers().forEach(o=>n.add(o))),[...n.values()]}getAllKeysForOverrideIdentifier(n){const t=new Set;return this._defaultConfiguration.getKeysForOverrideIdentifier(n).forEach(o=>t.add(o)),this.userConfiguration.getKeysForOverrideIdentifier(n).forEach(o=>t.add(o)),this._workspaceConfiguration.getKeysForOverrideIdentifier(n).forEach(o=>t.add(o)),this._folderConfigurations.forEach(o=>o.getKeysForOverrideIdentifier(n).forEach(d=>t.add(d))),[...t.values()]}static parse(n){const t=this.parseConfigurationModel(n.defaults),o=this.parseConfigurationModel(n.user),d=this.parseConfigurationModel(n.workspace),c=n.folders.reduce((h,l)=>(h.set(D.URI.revive(l[0]),this.parseConfigurationModel(l[1])),h),new i.ResourceMap);return new I(t,o,new E,d,c,new E,new i.ResourceMap,!1)}static parseConfigurationModel(n){return new E(n.contents,n.keys,n.overrides).freeze()}}e.Configuration=I;function p(..._){if(_.length===0)return{keys:[],overrides:[]};if(_.length===1)return _[0];const n=new Set,t=new Map;for(const d of _)d.keys.forEach(c=>n.add(c)),d.overrides.forEach(([c,h])=>{const l=(0,i.getOrSet)(t,c,new Set);h.forEach(b=>l.add(b))});const o=[];return t.forEach((d,c)=>o.push([c,[...d.values()]])),{keys:[...n.values()],overrides:o}}e.mergeChanges=p;class s{constructor(n,t,o,d){this.change=n,this.previous=t,this.currentConfiguraiton=o,this.currentWorkspace=d,this._previousConfiguration=void 0;const c=new Set;n.keys.forEach(l=>c.add(l)),n.overrides.forEach(([,l])=>l.forEach(b=>c.add(b))),this.affectedKeys=[...c.values()];const h=new E;this.affectedKeys.forEach(l=>h.setValue(l,{})),this.affectedKeysTree=h.contents}get previousConfiguration(){return!this._previousConfiguration&&this.previous&&(this._previousConfiguration=I.parse(this.previous.data)),this._previousConfiguration}affectsConfiguration(n,t){if(this.doesAffectedKeysTreeContains(this.affectedKeysTree,n)){if(t){const o=this.previousConfiguration?this.previousConfiguration.getValue(n,t,this.previous?.workspace):void 0,d=this.currentConfiguraiton.getValue(n,t,this.currentWorkspace);return!k.equals(o,d)}return!0}return!1}doesAffectedKeysTreeContains(n,t){let o=(0,R.toValuesTree)({[t]:!0},()=>{}),d;for(;typeof o=="object"&&(d=Object.keys(o)[0]);){if(n=n[d],!n)return!1;o=o[d]}return!0}}e.ConfigurationChangeEvent=s;class r extends s{constructor(n,t,o,d){super({keys:n.allKeys(),overrides:[]},void 0,n,t);this.source=o,this.sourceConfig=d}}e.AllKeysConfigurationChangeEvent=r;function g(_,n){const{added:t,removed:o,updated:d}=a(n,_),c=[],h=_?.getAllOverrideIdentifiers()||[],l=n?.getAllOverrideIdentifiers()||[];if(n){const b=l.filter(T=>!h.includes(T));for(const T of b)c.push([T,n.getKeysForOverrideIdentifier(T)])}if(_){const b=h.filter(T=>!l.includes(T));for(const T of b)c.push([T,_.getKeysForOverrideIdentifier(T)])}if(n&&_){for(const b of h)if(l.includes(b)){const T=a({contents:_.getOverrideValue(void 0,b)||{},keys:_.getKeysForOverrideIdentifier(b)},{contents:n.getOverrideValue(void 0,b)||{},keys:n.getKeysForOverrideIdentifier(b)});c.push([b,[...T.added,...T.removed,...T.updated]])}}return{added:t,removed:o,updated:d,overrides:c}}function a(_,n){const t=_?n?_.keys.filter(c=>n.keys.indexOf(c)===-1):[..._.keys]:[],o=n?_?n.keys.filter(c=>_.keys.indexOf(c)===-1):[...n.keys]:[],d=[];if(_&&n){for(const c of n.keys)if(_.keys.indexOf(c)!==-1){const h=(0,R.getConfigurationValue)(n.contents,c),l=(0,R.getConfigurationValue)(_.contents,c);k.equals(h,l)||d.push(c)}}return{added:t,removed:o,updated:d}}}),define(pe[119],ve([0,1,4]),function(Y,e,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RemoteAuthorityResolverError=e.RemoteAuthorityResolverErrorCode=e.IRemoteAuthorityResolverService=void 0,e.IRemoteAuthorityResolverService=(0,m.createDecorator)("remoteAuthorityResolverService");var L;(function(C){C.Unknown="Unknown",C.NotAvailable="NotAvailable",C.TemporarilyNotAvailable="TemporarilyNotAvailable",C.NoResolverFound="NoResolverFound"})(L=e.RemoteAuthorityResolverErrorCode||(e.RemoteAuthorityResolverErrorCode={}));class y extends Error{constructor(i,k=L.Unknown,S){super(i);this._message=i,this._code=k,this._detail=S,this.isHandled=k===L.NotAvailable&&S===!0,typeof Object.setPrototypeOf=="function"&&Object.setPrototypeOf(this,y.prototype)}static isTemporarilyNotAvailable(i){return i instanceof y&&i._code===L.TemporarilyNotAvailable}static isNoResolverFound(i){return i instanceof y&&i._code===L.NoResolverFound}static isHandled(i){return i instanceof y&&i.isHandled}}e.RemoteAuthorityResolverError=y}),define(pe[62],ve([0,1,10]),function(Y,e,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isVirtualWorkspace=e.getVirtualWorkspaceScheme=e.getVirtualWorkspaceLocation=e.isVirtualResource=e.getRemoteName=e.getRemoteAuthority=void 0;function L(D){return D.scheme===m.Schemas.vscodeRemote?D.authority:void 0}e.getRemoteAuthority=L;function y(D){if(!D)return;const R=D.indexOf("+");return R<0?D:D.substr(0,R)}e.getRemoteName=y;function C(D){return D.scheme!==m.Schemas.file&&D.scheme!==m.Schemas.vscodeRemote}e.isVirtualResource=C;function i(D){if(D.folders.length)return D.folders.every(R=>C(R.uri))?D.folders[0].uri:void 0;if(D.configuration&&C(D.configuration))return D.configuration}e.getVirtualWorkspaceLocation=i;function k(D){return i(D)?.scheme}e.getVirtualWorkspaceScheme=k;function S(D){return i(D)!==void 0}e.isVirtualWorkspace=S}),define(pe[27],ve([0,1,8,4,62]),function(Y,e,m,L,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IBuiltinExtensionsScannerService=e.isResolverExtension=e.isAuthenticationProviderExtension=e.isLanguagePackExtension=e.ExtensionIdentifier=e.ExtensionType=e.EXTENSION_CATEGORIES=e.isIExtensionIdentifier=e.getWorkspaceSupportTypeMessage=e.ALL_EXTENSION_KINDS=e.BUILTIN_MANIFEST_CACHE_FILE=e.USER_MANIFEST_CACHE_FILE=e.MANIFEST_CACHE_FOLDER=void 0,e.MANIFEST_CACHE_FOLDER="CachedExtensions",e.USER_MANIFEST_CACHE_FILE="user",e.BUILTIN_MANIFEST_CACHE_FILE="builtin",e.ALL_EXTENSION_KINDS=["ui","workspace","web"];function C(u){if(typeof u=="object"&&u!==null&&u.supported!==!0)return u.description}e.getWorkspaceSupportTypeMessage=C;function i(u){return u&&typeof u=="object"&&typeof u.id=="string"&&(!u.uuid||typeof u.uuid=="string")}e.isIExtensionIdentifier=i,e.EXTENSION_CATEGORIES=["Azure","Data Science","Debuggers","Extension Packs","Education","Formatters","Keymaps","Language Packs","Linters","Machine Learning","Notebooks","Programming Languages","SCM Providers","Snippets","Testing","Themes","Visualization","Other"];var k;(function(u){u[u.System=0]="System",u[u.User=1]="User"})(k=e.ExtensionType||(e.ExtensionType={}));class S{constructor(E){this.value=E,this._lower=E.toLowerCase()}static equals(E,f){if(typeof E=="undefined"||E===null)return typeof f=="undefined"||f===null;if(typeof f=="undefined"||f===null)return!1;if(typeof E=="string"||typeof f=="string"){let v=typeof E=="string"?E:E.value,w=typeof f=="string"?f:f.value;return m.equalsIgnoreCase(v,w)}return E._lower===f._lower}static toKey(E){return typeof E=="string"?E.toLowerCase():E._lower}}e.ExtensionIdentifier=S;function D(u){return u.contributes&&u.contributes.localizations?u.contributes.localizations.length>0:!1}e.isLanguagePackExtension=D;function R(u){return u.contributes&&u.contributes.authentication?u.contributes.authentication.length>0:!1}e.isAuthenticationProviderExtension=R;function P(u,E){if(E){const f=`onResolveRemoteAuthority:${(0,y.getRemoteName)(E)}`;return u.activationEvents?.indexOf(f)!==-1}return!1}e.isResolverExtension=P,e.IBuiltinExtensionsScannerService=(0,L.createDecorator)("IBuiltinExtensionsScannerService")}),define(pe[193],ve([0,1,8,27]),function(Y,e,m,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getExtensionDependencies=e.getMaliciousExtensionsSet=e.BetterMergeId=e.getGalleryExtensionTelemetryData=e.getLocalExtensionTelemetryData=e.groupByExtension=e.getGalleryExtensionId=e.adoptToGalleryExtensionId=e.getExtensionId=e.ExtensionIdentifierWithVersion=e.areSameExtensions=void 0;function y(f,v){return f.uuid&&v.uuid?f.uuid===v.uuid:f.id===v.id?!0:(0,m.compareIgnoreCase)(f.id,v.id)===0}e.areSameExtensions=y;class C{constructor(v,w){this.version=w,this.id=v.id,this.uuid=v.uuid}key(){return`${this.id}-${this.version}`}equals(v){return v instanceof C?y(this,v)&&this.version===v.version:!1}}e.ExtensionIdentifierWithVersion=C;function i(f,v){return`${f}.${v}`}e.getExtensionId=i;function k(f){return f.toLocaleLowerCase()}e.adoptToGalleryExtensionId=k;function S(f,v){return k(i(f,v))}e.getGalleryExtensionId=S;function D(f,v){const w=[],I=p=>{for(const s of w)if(s.some(r=>y(v(r),v(p))))return s;return null};for(const p of f){const s=I(p);s?s.push(p):w.push([p])}return w}e.groupByExtension=D;function R(f){return{id:f.identifier.id,name:f.manifest.name,galleryId:null,publisherId:f.publisherId,publisherName:f.manifest.publisher,publisherDisplayName:f.publisherDisplayName,dependencies:f.manifest.extensionDependencies&&f.manifest.extensionDependencies.length>0}}e.getLocalExtensionTelemetryData=R;function P(f){return{id:f.identifier.id,name:f.name,galleryId:f.identifier.uuid,publisherId:f.publisherId,publisherName:f.publisher,publisherDisplayName:f.publisherDisplayName,isPreReleaseVersion:f.properties.isPreReleaseVersion,dependencies:!!(f.properties.dependencies&&f.properties.dependencies.length>0),...f.telemetryData}}e.getGalleryExtensionTelemetryData=P,e.BetterMergeId=new L.ExtensionIdentifier("pprice.better-merge");function u(f){const v=new Set;if(f.malicious)for(const w of f.malicious)v.add(w.id);return v}e.getMaliciousExtensionsSet=u;function E(f,v){const w=[],I=v.manifest.extensionDependencies?.slice(0)??[];for(;I.length;){const p=I.shift();if(p&&w.every(s=>!y(s.identifier,{id:p}))){const s=f.filter(r=>y(r.identifier,{id:p}));s.length===1&&(w.push(s[0]),I.push(...s[0].manifest.extensionDependencies?.slice(0)??[]))}}return w}e.getExtensionDependencies=E}),define(pe[120],ve([0,1,3,12,4,11]),function(Y,e,m,L,y,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractTunnelService=e.isPortPrivileged=e.isAllInterfaces=e.ALL_INTERFACES_ADDRESSES=e.isLocalhost=e.LOCALHOST_ADDRESSES=e.extractLocalHostUriMetaDataForPortMapping=e.ProvidedOnAutoForward=e.TunnelPrivacyId=e.TunnelProtocol=e.ISharedTunnelsService=e.ITunnelService=void 0,e.ITunnelService=(0,y.createDecorator)("tunnelService"),e.ISharedTunnelsService=(0,y.createDecorator)("sharedTunnelsService");var i;(function(f){f.Http="http",f.Https="https"})(i=e.TunnelProtocol||(e.TunnelProtocol={}));var k;(function(f){f.ConstantPrivate="constantPrivate",f.Private="private",f.Public="public"})(k=e.TunnelPrivacyId||(e.TunnelPrivacyId={}));var S;(function(f){f[f.Notify=1]="Notify",f[f.OpenBrowser=2]="OpenBrowser",f[f.OpenPreview=3]="OpenPreview",f[f.Silent=4]="Silent",f[f.Ignore=5]="Ignore",f[f.OpenBrowserOnce=6]="OpenBrowserOnce"})(S=e.ProvidedOnAutoForward||(e.ProvidedOnAutoForward={}));function D(f){if(f.scheme!=="http"&&f.scheme!=="https")return;const v=/^(localhost|127\.0\.0\.1|0\.0\.0\.0):(\d+)$/.exec(f.authority);if(!!v)return{address:v[1],port:+v[2]}}e.extractLocalHostUriMetaDataForPortMapping=D,e.LOCALHOST_ADDRESSES=["localhost","127.0.0.1","0:0:0:0:0:0:0:1","::1"];function R(f){return e.LOCALHOST_ADDRESSES.indexOf(f)>=0}e.isLocalhost=R,e.ALL_INTERFACES_ADDRESSES=["0.0.0.0","0:0:0:0:0:0:0:0","::"];function P(f){return e.ALL_INTERFACES_ADDRESSES.indexOf(f)>=0}e.isAllInterfaces=P;function u(f,v){return v?v!==1&&f<1024:!L.isWindows&&f<1024}e.isPortPrivileged=u;let E=class{constructor(v){this.logService=v,this._onTunnelOpened=new m.Emitter,this.onTunnelOpened=this._onTunnelOpened.event,this._onTunnelClosed=new m.Emitter,this.onTunnelClosed=this._onTunnelClosed.event,this._onAddedTunnelProvider=new m.Emitter,this.onAddedTunnelProvider=this._onAddedTunnelProvider.event,this._tunnels=new Map,this._canElevate=!1,this._privacyOptions=[]}get hasTunnelProvider(){return!!this._tunnelProvider}setTunnelProvider(v,w){return this._tunnelProvider=v,v?(this._canElevate=w.elevation,this._privacyOptions=w.privacyOptions,this._onAddedTunnelProvider.fire(),{dispose:()=>{this._tunnelProvider=void 0,this._canElevate=!1,this._privacyOptions=[]}}):(this._canElevate=!1,this._privacyOptions=[],this._onAddedTunnelProvider.fire(),{dispose:()=>{}})}get canElevate(){return this._canElevate}get canChangePrivacy(){return this._privacyOptions.length>0}get privacyOptions(){return this._privacyOptions}get tunnels(){return this.getTunnels()}async getTunnels(){const v=[],w=Array.from(this._tunnels.values());for(let I of w){const p=Array.from(I.values());for(let s of p){const r=await s.value;r&&v.push(r)}}return v}async dispose(){for(const v of this._tunnels.values()){for(const{value:w}of v.values())await w.then(I=>I?.dispose());v.clear()}this._tunnels.clear()}openTunnel(v,w,I,p,s=!1,r=k.Private,g){if(this.logService.trace(`ForwardedPorts: (TunnelService) openTunnel request for ${w}:${I} on local port ${p}.`),!v)return;w||(w="localhost");const a=this.retainOrCreateTunnel(v,w,I,p,s,r,g);return a?a.then(_=>{if(!_){this.logService.trace("ForwardedPorts: (TunnelService) New tunnel is undefined."),this.removeEmptyTunnelFromMap(w,I);return}this.logService.trace("ForwardedPorts: (TunnelService) New tunnel established.");const n=this.makeTunnel(_);return(_.tunnelRemoteHost!==w||_.tunnelRemotePort!==I)&&this.logService.warn("ForwardedPorts: (TunnelService) Created tunnel does not match requirements of requested tunnel. Host or port mismatch."),this._onTunnelOpened.fire(n),n}):(this.logService.trace("ForwardedPorts: (TunnelService) Tunnel was not created."),a)}makeTunnel(v){return{tunnelRemotePort:v.tunnelRemotePort,tunnelRemoteHost:v.tunnelRemoteHost,tunnelLocalPort:v.tunnelLocalPort,localAddress:v.localAddress,privacy:v.privacy,protocol:v.protocol,dispose:async()=>{this.logService.trace(`ForwardedPorts: (TunnelService) dispose request for ${v.tunnelRemoteHost}:${v.tunnelRemotePort} `);const w=this._tunnels.get(v.tunnelRemoteHost);if(w){const I=w.get(v.tunnelRemotePort);I&&(I.refcount--,await this.tryDisposeTunnel(v.tunnelRemoteHost,v.tunnelRemotePort,I))}}}}async tryDisposeTunnel(v,w,I){if(I.refcount<=0){this.logService.trace(`ForwardedPorts: (TunnelService) Tunnel is being disposed ${v}:${w}.`);const p=I.value.then(async s=>{s&&(await s.dispose(!0),this._onTunnelClosed.fire({host:s.tunnelRemoteHost,port:s.tunnelRemotePort}))});return this._tunnels.has(v)&&this._tunnels.get(v).delete(w),p}}async closeTunnel(v,w){this.logService.trace(`ForwardedPorts: (TunnelService) close request for ${v}:${w} `);const I=this._tunnels.get(v);if(I&&I.has(w)){const p=I.get(w);p.refcount=0,await this.tryDisposeTunnel(v,w,p)}}addTunnelToMap(v,w,I){this._tunnels.has(v)||this._tunnels.set(v,new Map),this._tunnels.get(v).set(w,{refcount:1,value:I})}async removeEmptyTunnelFromMap(v,w){const I=this._tunnels.get(v);I&&(await I.get(w)||I.delete(w),I.size===0&&this._tunnels.delete(v))}getTunnelFromMap(v,w){let I=[v];R(v)?(I.push(...e.LOCALHOST_ADDRESSES),I.push(...e.ALL_INTERFACES_ADDRESSES)):P(v)&&I.push(...e.ALL_INTERFACES_ADDRESSES);const p=I.map(s=>this._tunnels.get(s));for(const s of p){const r=s?.get(w);if(r)return r}}canTunnel(v){return!!D(v)}createWithProvider(v,w,I,p,s,r,g){this.logService.trace(`ForwardedPorts: (TunnelService) Creating tunnel with provider ${w}:${I} on local port ${p}.`);const _={elevationRequired:s?u(p===void 0?I:p):!1},n={remoteAddress:{host:w,port:I},localAddressPort:p,privacy:r,public:r!==k.Private,protocol:g},t=v.forwardPort(n,_);return this.logService.trace("ForwardedPorts: (TunnelService) Tunnel created by provider."),t&&this.addTunnelToMap(w,I,t),t}};E=je([He(0,C.ILogService)],E),e.AbstractTunnelService=E}),define(pe[194],ve([0,1]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SignService=void 0;class m{constructor(){this.validators=new Map}vsda(){return new Promise((y,C)=>Y(["vsda"],y,C))}async createNewMessage(y){try{const C=await this.vsda(),i=new C.validator;if(i){const k=String(m._nextId++);return this.validators.set(k,i),{id:k,data:i.createNewMessage(y)}}}catch(C){}return{id:"",data:y}}async validate(y,C){if(!y.id)return!0;const i=this.validators.get(y.id);if(!i)return!1;this.validators.delete(y.id);try{return i.validate(C)==="ok"}catch(k){return!1}}async sign(y){try{const C=await this.vsda(),i=new C.signer;if(i)return i.sign(y)}catch(C){}return y}}e.SignService=m,m._nextId=1}),define(pe[195],ve([0,1]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TerminalDataBufferer=void 0;class m{constructor(y){this._callback=y,this._terminalBufferMap=new Map}dispose(){for(const y of this._terminalBufferMap.values())y.dispose()}startBuffering(y,C,i=5){let k;return k=C(S=>{const D=typeof S=="string"?S:S.data;let R=this._terminalBufferMap.get(y);if(R){R.data.push(D);return}const P=setTimeout(()=>this.flushBuffer(y),i);R={data:[D],timeoutId:P,dispose:()=>{clearTimeout(P),this.flushBuffer(y),k.dispose()}},this._terminalBufferMap.set(y,R)}),k}stopBuffering(y){const C=this._terminalBufferMap.get(y);C&&C.dispose()}flushBuffer(y){const C=this._terminalBufferMap.get(y);C&&(this._terminalBufferMap.delete(y),this._callback(y,C.data.join("")))}}e.TerminalDataBufferer=m}),define(pe[196],ve([0,1]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ColorScheme=void 0;var m;(function(L){L.DARK="dark",L.LIGHT="light",L.HIGH_CONTRAST="hc"})(m=e.ColorScheme||(e.ColorScheme={}))}),define(pe[86],ve([0,1,78,3,6,4,51,196]),function(Y,e,m,L,y,C,i,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Themable=e.registerThemingParticipant=e.Extensions=e.getThemeTypeSelector=e.FolderThemeIcon=e.FileThemeIcon=e.ThemeIcon=e.themeColorFromId=e.ThemeColor=e.IThemeService=void 0,e.IThemeService=(0,C.createDecorator)("themeService");var S;(function(w){function I(p){return p&&typeof p=="object"&&typeof p.id=="string"}w.isThemeColor=I})(S=e.ThemeColor||(e.ThemeColor={}));function D(w){return{id:w}}e.themeColorFromId=D;var R;(function(w){function I(n){return n&&typeof n=="object"&&typeof n.id=="string"&&(typeof n.color=="undefined"||S.isThemeColor(n.color))}w.isThemeIcon=I;const p=new RegExp(`^\\$\\((${m.CSSIcon.iconNameExpression}(?:${m.CSSIcon.iconModifierExpression})?)\\)$`);function s(n){const t=p.exec(n);if(!t)return;let[,o]=t;return{id:o}}w.fromString=s;function r(n,t){let o=n.id;const d=o.lastIndexOf("~");return d!==-1&&(o=o.substring(0,d)),t&&(o=`${o}~${t}`),{id:o}}w.modify=r;function g(n){const t=n.id.lastIndexOf("~");if(t!==-1)return n.id.substring(t+1)}w.getModifier=g;function a(n,t){return n.id===t.id&&n.color?.id===t.color?.id}w.isEqual=a;function _(n,t){return{id:n.id,color:t?D(t):void 0}}w.asThemeIcon=_,w.asClassNameArray=m.CSSIcon.asClassNameArray,w.asClassName=m.CSSIcon.asClassName,w.asCSSSelector=m.CSSIcon.asCSSSelector})(R=e.ThemeIcon||(e.ThemeIcon={})),e.FileThemeIcon=m.Codicon.file,e.FolderThemeIcon=m.Codicon.folder;function P(w){switch(w){case k.ColorScheme.DARK:return"vs-dark";case k.ColorScheme.HIGH_CONTRAST:return"hc-black";default:return"vs"}}e.getThemeTypeSelector=P,e.Extensions={ThemingContribution:"base.contributions.theming"};class u{constructor(){this.themingParticipants=[],this.themingParticipants=[],this.onThemingParticipantAddedEmitter=new L.Emitter}onColorThemeChange(I){return this.themingParticipants.push(I),this.onThemingParticipantAddedEmitter.fire(I),(0,y.toDisposable)(()=>{const p=this.themingParticipants.indexOf(I);this.themingParticipants.splice(p,1)})}get onThemingParticipantAdded(){return this.onThemingParticipantAddedEmitter.event}getThemingParticipants(){return this.themingParticipants}}let E=new u;i.Registry.add(e.Extensions.ThemingContribution,E);function f(w){return E.onColorThemeChange(w)}e.registerThemingParticipant=f;class v extends y.Disposable{constructor(I){super();this.themeService=I,this.theme=I.getColorTheme(),this._register(this.themeService.onDidColorThemeChange(p=>this.onThemeChange(p)))}onThemeChange(I){this.theme=I,this.updateStyles()}updateStyles(){}getColor(I,p){let s=this.theme.getColor(I);return s&&p&&(s=p(s,this.theme)),s?s.toString():null}}e.Themable=v}),define(pe[43],ve([0,1,24,23,2,4]),function(Y,e,m,L,y,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toWorkspaceFolder=e.WorkspaceFolder=e.Workspace=e.isWorkspaceFolder=e.isWorkspace=e.WorkbenchState=e.IWorkspaceContextService=void 0,e.IWorkspaceContextService=(0,C.createDecorator)("contextService");var i;(function(u){u[u.EMPTY=1]="EMPTY",u[u.FOLDER=2]="FOLDER",u[u.WORKSPACE=3]="WORKSPACE"})(i=e.WorkbenchState||(e.WorkbenchState={}));function k(u){const E=u;return!!(E&&typeof E=="object"&&typeof E.id=="string"&&Array.isArray(E.folders))}e.isWorkspace=k;function S(u){const E=u;return!!(E&&typeof E=="object"&&y.URI.isUri(E.uri)&&typeof E.name=="string"&&typeof E.toResource=="function")}e.isWorkspaceFolder=S;class D{constructor(E,f,v,w,I){this._id=E,this._transient=v,this._configuration=w,this._ignorePathCasing=I,this._foldersMap=m.TernarySearchTree.forUris(this._ignorePathCasing),this.folders=f}update(E){this._id=E.id,this._configuration=E.configuration,this._transient=E.transient,this._ignorePathCasing=E._ignorePathCasing,this.folders=E.folders}get folders(){return this._folders}set folders(E){this._folders=E,this.updateFoldersMap()}get id(){return this._id}get transient(){return this._transient}get configuration(){return this._configuration}set configuration(E){this._configuration=E}getFolder(E){return E&&this._foldersMap.findSubstr(E.with({scheme:E.scheme,authority:E.authority,path:E.path}))||null}updateFoldersMap(){this._foldersMap=m.TernarySearchTree.forUris(this._ignorePathCasing);for(const E of this.folders)this._foldersMap.set(E.uri,E)}toJSON(){return{id:this.id,folders:this.folders,transient:this.transient,configuration:this.configuration}}}e.Workspace=D;class R{constructor(E,f){this.raw=f,this.uri=E.uri,this.index=E.index,this.name=E.name}toResource(E){return(0,L.joinPath)(this.uri,E)}toJSON(){return{uri:this.uri,name:this.name,index:this.index}}}e.WorkspaceFolder=R;function P(u){return new R({uri:u,index:0,name:(0,L.basenameOrAuthority)(u)},{uri:u.toString()})}e.toWorkspaceFolder=P}),define(pe[197],ve([0,1,30,58,139,80,10,9,12,23,2,161,4,62,43]),function(Y,e,m,L,y,C,i,k,S,D,R,P,u,E,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toStoreData=e.restoreRecentlyOpened=e.useSlashForPath=e.rewriteWorkspaceFileForNewLocation=e.toWorkspaceFolders=e.getStoredWorkspaceFolder=e.isRawUriWorkspaceFolder=e.isRawFileWorkspaceFolder=e.isStoredWorkspaceFolder=e.isUntitledWorkspace=e.reviveIdentifier=e.isWorkspaceIdentifier=e.toWorkspaceIdentifier=e.isSingleFolderWorkspaceIdentifier=e.isRecentFile=e.isRecentFolder=e.isRecentWorkspace=e.IWorkspacesService=e.hasWorkspaceFileExtension=e.UNTITLED_WORKSPACE_NAME=e.WORKSPACE_FILTER=e.WORKSPACE_EXTENSION=void 0,e.WORKSPACE_EXTENSION="code-workspace";const v=`.${e.WORKSPACE_EXTENSION}`;e.WORKSPACE_FILTER=[{name:(0,P.localize)(0,null),extensions:[e.WORKSPACE_EXTENSION]}],e.UNTITLED_WORKSPACE_NAME="workspace.json";function w(M){return(typeof M=="string"?(0,k.extname)(M):(0,D.extname)(M))===v}e.hasWorkspaceFileExtension=w,e.IWorkspacesService=(0,u.createDecorator)("workspacesService");function I(M){return M.hasOwnProperty("workspace")}e.isRecentWorkspace=I;function p(M){return M.hasOwnProperty("folderUri")}e.isRecentFolder=p;function s(M){return M.hasOwnProperty("fileUri")}e.isRecentFile=s;function r(M){const B=M;return typeof B?.id=="string"&&R.URI.isUri(B.uri)}e.isSingleFolderWorkspaceIdentifier=r;function g(M){if(M.configuration)return{id:M.id,configPath:M.configuration};if(M.folders.length===1)return{id:M.id,uri:M.folders[0].uri}}e.toWorkspaceIdentifier=g;function a(M){const B=M;return typeof B?.id=="string"&&R.URI.isUri(B.configPath)}e.isWorkspaceIdentifier=a;function _(M){const B=M;if(B?.uri)return{id:B.id,uri:R.URI.revive(B.uri)};const U=M;if(U?.configPath)return{id:U.id,configPath:R.URI.revive(U.configPath)};if(M?.id)return{id:M.id}}e.reviveIdentifier=_;function n(M,B){return D.extUriBiasedIgnorePathCase.isEqualOrParent(M,B.untitledWorkspacesHome)}e.isUntitledWorkspace=n;function t(M){return o(M)||d(M)}e.isStoredWorkspaceFolder=t;function o(M){const B=M;return typeof B?.path=="string"&&(!B.name||typeof B.name=="string")}e.isRawFileWorkspaceFolder=o;function d(M){const B=M;return typeof B?.uri=="string"&&(!B.name||typeof B.name=="string")}e.isRawUriWorkspaceFolder=d;function c(M,B,U,z,K=!S.isWindows,N){if(M.scheme!==z.scheme)return{name:U,uri:M.toString(!0)};let j=B?void 0:N.relativePath(z,M);if(j!==void 0)j.length===0?j=".":S.isWindows&&M.scheme===i.Schemas.file&&!K&&(j=j.replace(/\//g,"\\"));else if(M.scheme===i.Schemas.file)j=M.fsPath,S.isWindows&&(j=(0,C.normalizeDriveLetter)(j),K&&(j=(0,m.toSlashes)(j)));else{if(!N.isEqualAuthority(M.authority,z.authority))return{name:U,uri:M.toString(!0)};j=M.path}return{name:U,path:j}}e.getStoredWorkspaceFolder=c;function h(M,B,U){let z=[],K=new Set;const N=U.dirname(B);for(let j of M){let H;if(o(j))j.path&&(H=U.resolvePath(N,j.path));else if(d(j))try{H=R.URI.parse(j.uri),H.path[0]!=="/"&&(H=H.with({path:"/"+H.path}))}catch(V){console.warn(V)}if(H){let V=U.getComparisonKey(H);if(!K.has(V)){K.add(V);const q=j.name||U.basenameOrAuthority(H);z.push(new f.WorkspaceFolder({uri:H,name:q,index:z.length},j))}}}return z}e.toWorkspaceFolders=h;function l(M,B,U,z,K){let N=b(B,M);const j=K.dirname(B),H=K.dirname(z),V=[],q=T(N.folders);for(const ke of N.folders){const Be=o(ke)?K.resolvePath(j,ke.path):R.URI.parse(ke.uri);let We;U?We=!1:We=!o(ke)||(0,k.isAbsolute)(ke.path),V.push(c(Be,We,ke.name,H,q,K))}const ne={insertSpaces:!1,tabSize:4,eol:S.isLinux||S.isMacintosh?`
`:`\r
`},fe=y.setProperty(M,["folders"],V,ne);let ye=y.applyEdits(M,fe);return(0,D.isEqualAuthority)(N.remoteAuthority,(0,E.getRemoteAuthority)(z))&&(ye=y.applyEdits(ye,y.removeProperty(ye,["remoteAuthority"],ne))),ye}e.rewriteWorkspaceFileForNewLocation=l;function b(M,B){let U=L.parse(B);if(U&&Array.isArray(U.folders))U.folders=U.folders.filter(z=>t(z));else throw new Error(`${M} looks like an invalid workspace file.`);return U}function T(M){return S.isWindows?M.some(B=>o(B)&&B.path.indexOf("/")>=0):!0}e.useSlashForPath=T;function A(M){return M.workspace&&typeof M.workspace=="object"&&typeof M.workspace.id=="string"&&typeof M.workspace.configPath=="string"}function x(M){return typeof M.folderUri=="string"}function O(M){return typeof M.fileUri=="string"}function F(M,B){const U={workspaces:[],files:[]};if(M){const z=function(N,j){for(let H=0;H<N.length;H++)try{j(N[H],H)}catch(V){B.warn(`Error restoring recent entry ${JSON.stringify(N[H])}: ${V.toString()}. Skip entry.`)}},K=M;if(Array.isArray(K.entries))z(K.entries,N=>{const j=N.label,H=N.remoteAuthority;A(N)?U.workspaces.push({label:j,remoteAuthority:H,workspace:{id:N.workspace.id,configPath:R.URI.parse(N.workspace.configPath)}}):x(N)?U.workspaces.push({label:j,remoteAuthority:H,folderUri:R.URI.parse(N.folderUri)}):O(N)&&U.files.push({label:j,remoteAuthority:H,fileUri:R.URI.parse(N.fileUri)})});else{const N=M;Array.isArray(N.workspaces3)&&z(N.workspaces3,(j,H)=>{const V=Array.isArray(N.workspaceLabels)&&N.workspaceLabels[H]||void 0;typeof j=="object"&&typeof j.id=="string"&&typeof j.configURIPath=="string"?U.workspaces.push({label:V,workspace:{id:j.id,configPath:R.URI.parse(j.configURIPath)}}):typeof j=="string"&&U.workspaces.push({label:V,folderUri:R.URI.parse(j)})}),Array.isArray(N.files2)&&z(N.files2,(j,H)=>{const V=Array.isArray(N.fileLabels)&&N.fileLabels[H]||void 0;typeof j=="string"&&U.files.push({label:V,fileUri:R.URI.parse(j)})})}}return U}e.restoreRecentlyOpened=F;function W(M){const B={entries:[]};for(const U of M.workspaces)p(U)?B.entries.push({folderUri:U.folderUri.toString(),label:U.label,remoteAuthority:U.remoteAuthority}):B.entries.push({workspace:{id:U.workspace.id,configPath:U.workspace.configPath.toString()},label:U.label,remoteAuthority:U.remoteAuthority});for(const U of M.files)B.entries.push({fileUri:U.fileUri.toString(),label:U.label,remoteAuthority:U.remoteAuthority});return B}e.toStoreData=W}),define(pe[87],ve([0,1]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Cache=void 0;class m{constructor(y){this.id=y,this._data=new Map,this._idPool=1}add(y){const C=this._idPool++;return this._data.set(C,y),this.logDebugInfo(),C}get(y,C){return this._data.has(y)?this._data.get(y)[C]:void 0}delete(y){this._data.delete(y),this.logDebugInfo()}logDebugInfo(){!m.enableDebugLogging||console.log(`${this.id} cache size - ${this._data.size}`)}}e.Cache=m,m.enableDebugLogging=!1}),define(pe[44],ve([0,1,10,23,4]),function(Y,e,m,L,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostFileSystemInfo=e.ExtHostFileSystemInfo=void 0;class C{constructor(){this._systemSchemes=new Set(Object.keys(m.Schemas)),this._providerInfo=new Map,this.extUri=new L.ExtUri(k=>{const S=this._providerInfo.get(k.scheme);return!(S===void 0||S&1024)})}$acceptProviderInfos(k,S){S===null?this._providerInfo.delete(k):this._providerInfo.set(k,S)}isFreeScheme(k){return!this._providerInfo.has(k)&&!this._systemSchemes.has(k)}getCapabilities(k){return this._providerInfo.get(k)}}e.ExtHostFileSystemInfo=C,e.IExtHostFileSystemInfo=(0,y.createDecorator)("IExtHostFileSystemInfo")}),define(pe[26],ve([0,1,4]),function(Y,e,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostInitDataService=void 0,e.IExtHostInitDataService=(0,m.createDecorator)("IExtHostInitDataService")}),define(pe[198],ve([0,1,18]),function(Y,e,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionGlobalMemento=e.ExtensionMemento=void 0;class L{constructor(i,k,S){this._deferredPromises=new Map,this._id=i,this._shared=k,this._storage=S,this._init=this._storage.getValue(this._shared,this._id,Object.create(null)).then(D=>(this._value=D,this)),this._storageListener=this._storage.onDidChangeStorage(D=>{D.shared===this._shared&&D.key===this._id&&(this._value=D.value)}),this._scheduler=new m.RunOnceScheduler(()=>{const D=this._deferredPromises;this._deferredPromises=new Map,(async()=>{try{await this._storage.setValue(this._shared,this._id,this._value);for(const R of D.values())R.complete()}catch(R){for(const P of D.values())P.error(R)}})()},0)}keys(){return Object.entries(this._value??{}).filter(([,i])=>i!==void 0).map(([i])=>i)}get whenReady(){return this._init}get(i,k){let S=this._value[i];return typeof S=="undefined"&&(S=k),S}update(i,k){this._value[i]=k;let S=this._deferredPromises.get(i);if(S!==void 0)return S.p;const D=new m.DeferredPromise;return this._deferredPromises.set(i,D),this._scheduler.isScheduled()||this._scheduler.schedule(),D.p}dispose(){this._storageListener.dispose()}}e.ExtensionMemento=L;class y extends L{constructor(i,k){super(i.identifier.value,!0,k);this._extension=i}setKeysForSync(i){this._storage.registerExtensionStorageKeysToSync({id:this._id,version:this._extension.version},i)}}e.ExtensionGlobalMemento=y}),define(pe[199],ve([0,1,3,2,11]),function(Y,e,m,L,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookDocuments=void 0;let C=class{constructor(k,S){this._logService=k,this._notebooksAndEditors=S,this._onDidChangeNotebookDocumentMetadata=new m.Emitter,this.onDidChangeNotebookDocumentMetadata=this._onDidChangeNotebookDocumentMetadata.event,this._onDidSaveNotebookDocument=new m.Emitter,this.onDidSaveNotebookDocument=this._onDidSaveNotebookDocument.event}$acceptModelChanged(k,S,D){this._notebooksAndEditors.getNotebookDocument(L.URI.revive(k)).acceptModelChanged(S.value,D)}$acceptDirtyStateChanged(k,S){this._notebooksAndEditors.getNotebookDocument(L.URI.revive(k)).acceptDirty(S)}$acceptModelSaved(k){const S=this._notebooksAndEditors.getNotebookDocument(L.URI.revive(k));this._onDidSaveNotebookDocument.fire(S.apiNotebook)}$acceptDocumentPropertiesChanged(k,S){this._logService.debug("ExtHostNotebook#$acceptDocumentPropertiesChanged",k.path,S);const D=this._notebooksAndEditors.getNotebookDocument(L.URI.revive(k));D.acceptDocumentPropertiesChanged(S),S.metadata&&this._onDidChangeNotebookDocumentMetadata.fire({document:D.apiNotebook})}};C=je([He(0,y.ILogService)],C),e.ExtHostNotebookDocuments=C}),define(pe[14],ve([0,1,4]),function(Y,e,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostRpcService=e.IExtHostRpcService=void 0,e.IExtHostRpcService=(0,m.createDecorator)("IExtHostRpcService");class L{constructor(C){this.getProxy=C.getProxy.bind(C),this.set=C.set.bind(C),this.assertRegistered=C.assertRegistered.bind(C),this.drain=C.drain.bind(C)}}e.ExtHostRpcService=L});var nt=this&&this.__classPrivateFieldSet||function(Y,e,m,L,y){if(L==="m")throw new TypeError("Private method is not writable");if(L==="a"&&!y)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?Y!==e||!y:!e.has(Y))throw new TypeError("Cannot write private member to an object whose class did not declare it");return L==="a"?y.call(Y,m):y?y.value=m:e.set(Y,m),m},Ne=this&&this.__classPrivateFieldGet||function(Y,e,m,L){if(m==="a"&&!L)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?Y!==e||!L:!e.has(Y))throw new TypeError("Cannot read private member from an object whose class did not declare it");return m==="m"?L:m==="a"?L.call(Y):L?L.value:e.get(Y)};define(pe[200],ve([0,1,27,3]),function(Y,e,m,L){"use strict";var y;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionSecrets=void 0;class C{constructor(k,S){y.set(this,void 0),this._onDidChange=new L.Emitter,this.onDidChange=this._onDidChange.event,this._id=m.ExtensionIdentifier.toKey(k.identifier),nt(this,y,S,"f"),Ne(this,y,"f").onDidChangePassword(D=>{D.extensionId===this._id&&this._onDidChange.fire({key:D.key})})}get(k){return Ne(this,y,"f").get(this._id,k)}store(k,S){return Ne(this,y,"f").store(this._id,k,S)}delete(k){return Ne(this,y,"f").delete(this._id,k)}}e.ExtensionSecrets=C,y=new WeakMap}),define(pe[121],ve([0,1,4,3]),function(Y,e,m,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostTelemetry=e.ExtHostTelemetry=void 0;class y{constructor(){this._onDidChangeTelemetryEnabled=new L.Emitter,this.onDidChangeTelemetryEnabled=this._onDidChangeTelemetryEnabled.event,this._enabled=!1}getTelemetryEnabled(){return this._enabled}$initializeTelemetryEnabled(i){this._enabled=i}$onDidChangeTelemetryEnabled(i){this._enabled=i,this._onDidChangeTelemetryEnabled.fire(i)}}e.ExtHostTelemetry=y,e.IExtHostTelemetry=(0,m.createDecorator)("IExtHostTelemetry")}),define(pe[63],ve([0,1]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TestItemRootImpl=e.TestItemImpl=e.MixedTestItemController=e.InvalidTestItemError=e.DuplicateTestItemError=e.diffTestItems=e.getPrivateApiFor=e.createPrivateApiFor=e.ExtHostTestItemEventOp=void 0;var m;(function(p){p[p.Upsert=0]="Upsert",p[p.RemoveChild=1]="RemoveChild",p[p.Invalidated=2]="Invalidated",p[p.SetProp=3]="SetProp",p[p.Bulk=4]="Bulk"})(m=e.ExtHostTestItemEventOp||(e.ExtHostTestItemEventOp={}));const L=new WeakMap,y=(p,s)=>{const r={controllerId:s};return L.set(p,r),r};e.createPrivateApiFor=y;const C=p=>L.get(p);e.getPrivateApiFor=C;const i=(p,s,r,g)=>{let a=r;return{enumerable:!0,configurable:!1,get(){return a},set(_){if(!g(a,_)){const n=a;a=_,p.listener?.({op:3,key:s,value:_,previous:n})}}}},k=(p,s)=>p===s,S={range:(p,s)=>p===s?!0:!p||!s?!1:p.isEqual(s),label:k,description:k,busy:k,error:k,canResolveChildren:k,tags:(p,s)=>!(p.length!==s.length||p.some(r=>!s.find(g=>r.id===g.id)))},D=Object.keys(S),R=(p,s)=>({range:i(p,"range",void 0,S.range),label:i(p,"label",s,S.label),description:i(p,"description",void 0,S.description),canResolveChildren:i(p,"canResolveChildren",!1,S.canResolveChildren),busy:i(p,"busy",!1,S.busy),error:i(p,"error",void 0,S.error),tags:i(p,"tags",[],S.tags)}),P=(p,s)=>{const r=new Map;for(const g of D)S[g](p[g],s[g])||r.set(g,s[g]);return r};e.diffTestItems=P;class u extends Error{constructor(s){super(`Attempted to insert a duplicate test item ID ${s}`)}}e.DuplicateTestItemError=u;class E extends Error{constructor(s){super(`TestItem with ID "${s}" is invalid. Make sure to create it from the createTestItem method.`)}}e.InvalidTestItemError=E;class f extends Error{constructor(s,r,g){super(`TestItem with ID "${s}" is from controller "${r}" and cannot be added as a child of an item from controller "${g}".`)}}e.MixedTestItemController=f;const v=p=>{const s=(0,e.getPrivateApiFor)(p);let r=new Map;return{get size(){return r.size},forEach(g,a){for(const _ of r.values())g.call(a,_,this)},replace(g){const a=new Map,_=new Set(r.keys()),n={op:4,ops:[]};for(const t of g){if(!(t instanceof w))throw new E(t.id);const o=(0,e.getPrivateApiFor)(t).controllerId;if(o!==s.controllerId)throw new f(t.id,o,s.controllerId);if(a.has(t.id))throw new u(t.id);a.set(t.id,t),_.delete(t.id),n.ops.push({op:0,item:t})}for(const t of _.keys())n.ops.push({op:1,id:t});s.listener?.(n),r=a},add(g){if(!(g instanceof w))throw new E(g.id);r.set(g.id,g),s.listener?.({op:0,item:g})},delete(g){r.delete(g)&&s.listener?.({op:1,id:g})},get(g){return r.get(g)},toJSON(){return Array.from(r.values())},[Symbol.iterator](){return r.values()}}};class w{constructor(s,r,g,a){if(r.includes("\0"))throw new Error(`Test IDs may not include the ${JSON.stringify(r)} symbol`);const _=(0,e.createPrivateApiFor)(this,s);Object.defineProperties(this,{id:{value:r,enumerable:!0,writable:!1},uri:{value:a,enumerable:!0,writable:!1},parent:{enumerable:!1,get(){return _.parent instanceof I?void 0:_.parent}},children:{value:v(this),enumerable:!0,writable:!1},...R(_,g)})}invalidateResults(){(0,e.getPrivateApiFor)(this).listener?.({op:2})}}e.TestItemImpl=w;class I extends w{constructor(s,r){super(s,s,r,void 0)}}e.TestItemRootImpl=I}),define(pe[52],ve([0,1,4,120,3,14]),function(Y,e,m,L,y,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTunnelService=e.IExtHostTunnelService=e.TunnelDto=void 0;var i;(function(S){function D(P){return{remoteAddress:P.remoteAddress,localAddress:P.localAddress,public:!!P.public,privacy:P.privacy??(P.public?L.TunnelPrivacyId.Public:L.TunnelPrivacyId.Private),protocol:P.protocol}}S.fromApiTunnel=D;function R(P){return{remoteAddress:{host:P.tunnelRemoteHost,port:P.tunnelRemotePort},localAddress:P.localAddress,public:P.privacy!==L.TunnelPrivacyId.ConstantPrivate&&P.privacy!==L.TunnelPrivacyId.ConstantPrivate,privacy:P.privacy,protocol:P.protocol}}S.fromServiceTunnel=R})(i=e.TunnelDto||(e.TunnelDto={})),e.IExtHostTunnelService=(0,m.createDecorator)("IExtHostTunnelService");let k=class{constructor(D){this.onDidChangeTunnels=new y.Emitter().event}async $applyCandidateFilter(D){return D}async openTunnel(D,R){}async getTunnels(){return[]}async setTunnelExtensionFunctions(D){return{dispose:()=>{}}}registerPortsAttributesProvider(D,R){return{dispose:()=>{}}}async $providePortAttributes(D,R,P,u,E){return[]}async $forwardPort(D,R){}async $closeTunnel(D){}async $onDidTunnelsChange(){}async $registerCandidateFinder(){}};k=je([He(0,C.IExtHostRpcService)],k),e.ExtHostTunnelService=k});var nt=this&&this.__classPrivateFieldSet||function(Y,e,m,L,y){if(L==="m")throw new TypeError("Private method is not writable");if(L==="a"&&!y)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?Y!==e||!y:!e.has(Y))throw new TypeError("Cannot write private member to an object whose class did not declare it");return L==="a"?y.call(Y,m):y?y.value=m:e.set(Y,m),m},Ne=this&&this.__classPrivateFieldGet||function(Y,e,m,L){if(m==="a"&&!L)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?Y!==e||!L:!e.has(Y))throw new TypeError("Cannot read private member from an object whose class did not declare it");return m==="m"?L:m==="a"?L.call(Y):L?L.value:e.get(Y)};define(pe[7],ve([0,1,16,15,97,24,101,8,13,2,32,42,119]),function(Y,e,m,L,y,C,i,k,S,D,R,P,u){"use strict";var E,f,v,w,I,p,s,r,g,a,_,n,t,o,d,c,h,l,b,T;Object.defineProperty(e,"__esModule",{value:!0}),e.TypeHierarchyItem=e.PortAutoForwardAction=e.WorkspaceTrustState=e.ExternalUriOpenerPriority=e.FunctionCoverage=e.BranchCoverage=e.StatementCoverage=e.FileCoverage=e.CoveredCount=e.TestTag=e.TestMessage=e.TestRunRequest=e.TestRunProfileKind=e.TestResultState=e.PortAttributes=e.LinkedEditingRanges=e.StandardTokenType=e.ExtensionRuntime=e.ExtensionMode=e.TimelineItem=e.NotebookRendererScript=e.NotebookControllerAffinity=e.NotebookCellStatusBarItem=e.NotebookEditorRevealType=e.NotebookCellStatusBarAlignment=e.NotebookCellExecutionState=e.NotebookCellKind=e.NotebookCellOutput=e.NotebookCellOutputItem=e.NotebookData=e.NotebookCellData=e.NotebookRange=e.ColorThemeKind=e.ColorTheme=e.FileDecoration=e.ExtensionKind=e.QuickPickItemKind=e.QuickInputButtons=e.DebugConfigurationProviderTriggerKind=e.DebugConsoleMode=e.SemanticTokensEdits=e.SemanticTokensEdit=e.SemanticTokens=e.SemanticTokensBuilder=e.SemanticTokensLegend=e.CommentMode=e.CommentThreadCollapsibleState=e.FoldingRangeKind=e.FoldingRange=e.FileSystemError=e.FileChangeType=e.InlineValueContext=e.InlineValueEvaluatableExpression=e.InlineValueVariableLookup=e.InlineValueText=e.InlineCompletionTriggerKind=e.EvaluatableExpression=e.DebugAdapterInlineImplementation=e.DebugAdapterNamedPipeServer=e.DebugAdapterServer=e.DebugAdapterExecutable=e.DataBreakpoint=e.FunctionBreakpoint=e.SourceBreakpoint=e.Breakpoint=e.RelativePattern=e.ConfigurationTarget=e.ThemeColor=e.ThemeIcon=e.TreeDataTransfer=e.TreeDataTransferItem=e.TreeItemCollapsibleState=e.TreeItem=e.ProgressLocation=e.Task=e.CustomExecution=e.TaskScope=e.ShellQuoting=e.ShellExecution=e.ProcessExecution=e.TaskGroup=e.TaskPanelKind=e.TaskRevealKind=e.TerminalProfile=e.TerminalLocation=e.TerminalLink=e.SourceControlInputBoxValidationType=e.ColorFormat=e.ColorPresentation=e.ColorInformation=e.Color=e.DocumentLink=e.DecorationRangeBehavior=e.TextDocumentChangeReason=e.TextEditorSelectionChangeKind=e.TextEditorRevealType=e.TextDocumentSaveReason=e.TextEditorLineNumbersStyle=e.StatusBarAlignment=e.ViewColumn=e.InlineSuggestions=e.InlineSuggestion=e.CompletionList=e.CompletionItem=e.CompletionItemTag=e.CompletionItemKind=e.CompletionTriggerKind=e.InlayHint=e.InlayHintKind=e.SignatureHelpTriggerKind=e.SignatureHelp=e.SignatureInformation=e.ParameterInformation=e.MarkdownString=e.CodeLens=e.LanguageStatusSeverity=e.CallHierarchyOutgoingCall=e.CallHierarchyIncomingCall=e.CallHierarchyItem=e.SelectionRange=e.CodeActionKind=e.CodeAction=e.CodeActionTriggerKind=e.DocumentSymbol=e.SymbolInformation=e.SymbolTag=e.SymbolKind=e.DocumentHighlight=e.DocumentHighlightKind=e.Hover=e.Diagnostic=e.DiagnosticRelatedInformation=e.Location=e.DiagnosticSeverity=e.DiagnosticTag=e.SnippetString=e.WorkspaceEdit=e.FileEditType=e.TextEdit=e.EnvironmentVariableMutatorType=e.EndOfLine=e.RemoteAuthorityResolverError=e.ResolvedAuthority=e.Selection=e.Range=e.Position=e.Disposable=void 0;function A(G){function $(){return Reflect.construct(G,arguments,this.constructor)}return Object.defineProperty($,"name",Object.getOwnPropertyDescriptor(G,"name")),Object.setPrototypeOf($,G),Object.setPrototypeOf($.prototype,G.prototype),$}let x=I=class{constructor($){E.set(this,void 0),nt(this,E,$,"f")}static from(...$){let ae=$;return new I(function(){if(ae){for(const Pe of ae)Pe&&typeof Pe.dispose=="function"&&Pe.dispose();ae=void 0}})}dispose(){typeof Ne(this,E,"f")=="function"&&(Ne(this,E,"f").call(this),nt(this,E,void 0,"f"))}};E=new WeakMap,x=I=je([A],x),e.Disposable=x;let O=p=class{constructor($,ae){if($<0)throw(0,L.illegalArgument)("line must be non-negative");if(ae<0)throw(0,L.illegalArgument)("character must be non-negative");this._line=$,this._character=ae}static Min(...$){if($.length===0)throw new TypeError;let ae=$[0];for(let Pe=1;Pe<$.length;Pe++){const Ye=$[Pe];Ye.isBefore(ae)&&(ae=Ye)}return ae}static Max(...$){if($.length===0)throw new TypeError;let ae=$[0];for(let Pe=1;Pe<$.length;Pe++){const Ye=$[Pe];Ye.isAfter(ae)&&(ae=Ye)}return ae}static isPosition($){if(!$)return!1;if($ instanceof p)return!0;let{line:ae,character:Pe}=$;return typeof ae=="number"&&typeof Pe=="number"}get line(){return this._line}get character(){return this._character}isBefore($){return this._line<$._line?!0:$._line<this._line?!1:this._character<$._character}isBeforeOrEqual($){return this._line<$._line?!0:$._line<this._line?!1:this._character<=$._character}isAfter($){return!this.isBeforeOrEqual($)}isAfterOrEqual($){return!this.isBefore($)}isEqual($){return this._line===$._line&&this._character===$._character}compareTo($){return this._line<$._line?-1:this._line>$.line?1:this._character<$._character?-1:this._character>$._character?1:0}translate($,ae=0){if($===null||ae===null)throw(0,L.illegalArgument)();let Pe;return typeof $=="undefined"?Pe=0:typeof $=="number"?Pe=$:(Pe=typeof $.lineDelta=="number"?$.lineDelta:0,ae=typeof $.characterDelta=="number"?$.characterDelta:0),Pe===0&&ae===0?this:new p(this.line+Pe,this.character+ae)}with($,ae=this.character){if($===null||ae===null)throw(0,L.illegalArgument)();let Pe;return typeof $=="undefined"?Pe=this.line:typeof $=="number"?Pe=$:(Pe=typeof $.line=="number"?$.line:this.line,ae=typeof $.character=="number"?$.character:this.character),Pe===this.line&&ae===this.character?this:new p(Pe,ae)}toJSON(){return{line:this.line,character:this.character}}};O=p=je([A],O),e.Position=O;let F=s=class{constructor($,ae,Pe,Ye){let rt,lt;if(typeof $=="number"&&typeof ae=="number"&&typeof Pe=="number"&&typeof Ye=="number"?(rt=new O($,ae),lt=new O(Pe,Ye)):$ instanceof O&&ae instanceof O&&(rt=$,lt=ae),!rt||!lt)throw new Error("Invalid arguments");rt.isBefore(lt)?(this._start=rt,this._end=lt):(this._start=lt,this._end=rt)}static isRange($){return $ instanceof s?!0:$?O.isPosition($.start)&&O.isPosition($.end):!1}get start(){return this._start}get end(){return this._end}contains($){return $ instanceof s?this.contains($._start)&&this.contains($._end):$ instanceof O?!($.isBefore(this._start)||this._end.isBefore($)):!1}isEqual($){return this._start.isEqual($._start)&&this._end.isEqual($._end)}intersection($){const ae=O.Max($.start,this._start),Pe=O.Min($.end,this._end);if(!ae.isAfter(Pe))return new s(ae,Pe)}union($){if(this.contains($))return this;if($.contains(this))return $;const ae=O.Min($.start,this._start),Pe=O.Max($.end,this.end);return new s(ae,Pe)}get isEmpty(){return this._start.isEqual(this._end)}get isSingleLine(){return this._start.line===this._end.line}with($,ae=this.end){if($===null||ae===null)throw(0,L.illegalArgument)();let Pe;return $?O.isPosition($)?Pe=$:(Pe=$.start||this.start,ae=$.end||this.end):Pe=this.start,Pe.isEqual(this._start)&&ae.isEqual(this.end)?this:new s(Pe,ae)}toJSON(){return[this.start,this.end]}};F=s=je([A],F),e.Range=F;let W=r=class extends F{constructor($,ae,Pe,Ye){let rt,lt;if(typeof $=="number"&&typeof ae=="number"&&typeof Pe=="number"&&typeof Ye=="number"?(rt=new O($,ae),lt=new O(Pe,Ye)):$ instanceof O&&ae instanceof O&&(rt=$,lt=ae),!rt||!lt)throw new Error("Invalid arguments");super(rt,lt);this._anchor=rt,this._active=lt}static isSelection($){return $ instanceof r?!0:$?F.isRange($)&&O.isPosition($.anchor)&&O.isPosition($.active)&&typeof $.isReversed=="boolean":!1}get anchor(){return this._anchor}get active(){return this._active}get isReversed(){return this._anchor===this._end}toJSON(){return{start:this.start,end:this.end,active:this.active,anchor:this.anchor}}};W=r=je([A],W),e.Selection=W;class M{constructor($,ae,Pe){if(typeof $!="string"||$.length===0)throw(0,L.illegalArgument)("host");if(typeof ae!="number"||ae===0||Math.round(ae)!==ae)throw(0,L.illegalArgument)("port");if(typeof Pe!="undefined"&&(typeof Pe!="string"||Pe.length===0||!/^[0-9A-Za-z\-]+$/.test(Pe)))throw(0,L.illegalArgument)("connectionToken");this.host=$,this.port=Math.round(ae),this.connectionToken=Pe}}e.ResolvedAuthority=M;class B extends Error{constructor($,ae=u.RemoteAuthorityResolverErrorCode.Unknown,Pe){super($);this._message=$,this._code=ae,this._detail=Pe,typeof Object.setPrototypeOf=="function"&&Object.setPrototypeOf(this,B.prototype)}static NotAvailable($,ae){return new B($,u.RemoteAuthorityResolverErrorCode.NotAvailable,ae)}static TemporarilyNotAvailable($){return new B($,u.RemoteAuthorityResolverErrorCode.TemporarilyNotAvailable)}}e.RemoteAuthorityResolverError=B;var U;(function(G){G[G.LF=1]="LF",G[G.CRLF=2]="CRLF"})(U=e.EndOfLine||(e.EndOfLine={}));var z;(function(G){G[G.Replace=1]="Replace",G[G.Append=2]="Append",G[G.Prepend=3]="Prepend"})(z=e.EnvironmentVariableMutatorType||(e.EnvironmentVariableMutatorType={}));let K=g=class{constructor($,ae){this._range=$,this._newText=ae}static isTextEdit($){return $ instanceof g?!0:$?F.isRange($)&&typeof $.newText=="string":!1}static replace($,ae){return new g($,ae)}static insert($,ae){return g.replace(new F($,$),ae)}static delete($){return g.replace($,"")}static setEndOfLine($){const ae=new g(new F(new O(0,0),new O(0,0)),"");return ae.newEol=$,ae}get range(){return this._range}set range($){if($&&!F.isRange($))throw(0,L.illegalArgument)("range");this._range=$}get newText(){return this._newText||""}set newText($){if($&&typeof $!="string")throw(0,L.illegalArgument)("newText");this._newText=$}get newEol(){return this._newEol}set newEol($){if($&&typeof $!="number")throw(0,L.illegalArgument)("newEol");this._newEol=$}toJSON(){return{range:this.range,newText:this.newText,newEol:this._newEol}}};K=g=je([A],K),e.TextEdit=K;var N;(function(G){G[G.File=1]="File",G[G.Text=2]="Text",G[G.Cell=3]="Cell",G[G.CellReplace=5]="CellReplace"})(N=e.FileEditType||(e.FileEditType={}));let j=class{constructor(){this._edits=[]}_allEntries(){return this._edits}renameFile($,ae,Pe,Ye){this._edits.push({_type:1,from:$,to:ae,options:Pe,metadata:Ye})}createFile($,ae,Pe){this._edits.push({_type:1,from:void 0,to:$,options:ae,metadata:Pe})}deleteFile($,ae,Pe){this._edits.push({_type:1,from:$,to:void 0,options:ae,metadata:Pe})}replaceNotebookMetadata($,ae,Pe){this._edits.push({_type:3,metadata:Pe,uri:$,edit:{editType:5,metadata:ae},notebookMetadata:ae})}replaceNotebookCells($,ae,Pe,Ye,rt){let lt,ht,kt=[],Ft;if(xe.isNotebookRange(ae)&&xt.isNotebookCellDataArray(Pe)&&!xt.isNotebookCellDataArray(Ye)?(lt=ae.start,ht=ae.end,kt=Pe,Ft=Ye):typeof ae=="number"&&typeof Pe=="number"&&xt.isNotebookCellDataArray(Ye)&&(lt=ae,ht=Pe,kt=Ye,Ft=rt),lt===void 0||ht===void 0)throw new Error("Invalid arguments");(lt!==ht||kt.length>0)&&this._edits.push({_type:5,uri:$,index:lt,count:ht-lt,cells:kt,metadata:Ft})}replaceNotebookCellMetadata($,ae,Pe,Ye){this._edits.push({_type:3,metadata:Ye,uri:$,edit:{editType:8,index:ae,metadata:Pe}})}replace($,ae,Pe,Ye){this._edits.push({_type:2,uri:$,edit:new K(ae,Pe),metadata:Ye})}insert($,ae,Pe,Ye){this.replace($,new F(ae,ae),Pe,Ye)}delete($,ae,Pe){this.replace($,ae,"",Pe)}has($){return this._edits.some(ae=>ae._type===2&&ae.uri.toString()===$.toString())}set($,ae){if(ae)for(const Pe of ae)Pe&&this._edits.push({_type:2,uri:$,edit:Pe});else{for(let Pe=0;Pe<this._edits.length;Pe++){const Ye=this._edits[Pe];Ye._type===2&&Ye.uri.toString()===$.toString()&&(this._edits[Pe]=void 0)}(0,m.coalesceInPlace)(this._edits)}}get($){const ae=[];for(let Pe of this._edits)Pe._type===2&&Pe.uri.toString()===$.toString()&&ae.push(Pe.edit);return ae}entries(){const $=new C.ResourceMap;for(let ae of this._edits)if(ae._type===2){let Pe=$.get(ae.uri);Pe||(Pe=[ae.uri,[]],$.set(ae.uri,Pe)),Pe[1].push(ae.edit)}return[...$.values()]}get size(){return this.entries().length}toJSON(){return this.entries()}};j=je([A],j),e.WorkspaceEdit=j;let H=a=class{constructor($){this._tabstop=1,this.value=$||""}static isSnippetString($){return $ instanceof a?!0:$?typeof $.value=="string":!1}static _escape($){return $.replace(/\$|}|\\/g,"\\$&")}appendText($){return this.value+=a._escape($),this}appendTabstop($=this._tabstop++){return this.value+="$",this.value+=$,this}appendPlaceholder($,ae=this._tabstop++){if(typeof $=="function"){const Pe=new a;Pe._tabstop=this._tabstop,$(Pe),this._tabstop=Pe._tabstop,$=Pe.value}else $=a._escape($);return this.value+="${",this.value+=ae,this.value+=":",this.value+=$,this.value+="}",this}appendChoice($,ae=this._tabstop++){const Pe=$.map(Ye=>Ye.replace(/\$|}|\\|,/g,"\\$&")).join(",");return this.value+="${",this.value+=ae,this.value+="|",this.value+=Pe,this.value+="|}",this}appendVariable($,ae){if(typeof ae=="function"){const Pe=new a;Pe._tabstop=this._tabstop,ae(Pe),this._tabstop=Pe._tabstop,ae=Pe.value}else typeof ae=="string"&&(ae=ae.replace(/\$|}/g,"\\$&"));return this.value+="${",this.value+=$,ae&&(this.value+=":",this.value+=ae),this.value+="}",this}};H=a=je([A],H),e.SnippetString=H;var V;(function(G){G[G.Unnecessary=1]="Unnecessary",G[G.Deprecated=2]="Deprecated"})(V=e.DiagnosticTag||(e.DiagnosticTag={}));var q;(function(G){G[G.Hint=3]="Hint",G[G.Information=2]="Information",G[G.Warning=1]="Warning",G[G.Error=0]="Error"})(q=e.DiagnosticSeverity||(e.DiagnosticSeverity={}));let ne=_=class{constructor($,ae){if(this.uri=$,ae)if(ae instanceof F)this.range=ae;else if(ae instanceof O)this.range=new F(ae,ae);else throw new Error("Illegal argument")}static isLocation($){return $ instanceof _?!0:$?F.isRange($.range)&&D.URI.isUri($.uri):!1}toJSON(){return{uri:this.uri,range:this.range}}};ne=_=je([A],ne),e.Location=ne;let fe=class{constructor($,ae){this.location=$,this.message=ae}static is($){return $?typeof $.message=="string"&&$.location&&F.isRange($.location.range)&&D.URI.isUri($.location.uri):!1}static isEqual($,ae){return $===ae?!0:!$||!ae?!1:$.message===ae.message&&$.location.range.isEqual(ae.location.range)&&$.location.uri.toString()===ae.location.uri.toString()}};fe=je([A],fe),e.DiagnosticRelatedInformation=fe;let ye=class{constructor($,ae,Pe=q.Error){if(!F.isRange($))throw new TypeError("range must be set");if(!ae)throw new TypeError("message must be set");this.range=$,this.message=ae,this.severity=Pe}toJSON(){return{severity:q[this.severity],message:this.message,range:this.range,source:this.source,code:this.code}}static isEqual($,ae){return $===ae?!0:!$||!ae?!1:$.message===ae.message&&$.severity===ae.severity&&$.code===ae.code&&$.severity===ae.severity&&$.source===ae.source&&$.range.isEqual(ae.range)&&(0,m.equals)($.tags,ae.tags)&&(0,m.equals)($.relatedInformation,ae.relatedInformation,fe.isEqual)}};ye=je([A],ye),e.Diagnostic=ye;let ke=class{constructor($,ae){if(!$)throw new Error("Illegal argument, contents must be defined");Array.isArray($)?this.contents=$:this.contents=[$],this.range=ae}};ke=je([A],ke),e.Hover=ke;var Be;(function(G){G[G.Text=0]="Text",G[G.Read=1]="Read",G[G.Write=2]="Write"})(Be=e.DocumentHighlightKind||(e.DocumentHighlightKind={}));let We=class{constructor($,ae=Be.Text){this.range=$,this.kind=ae}toJSON(){return{range:this.range,kind:Be[this.kind]}}};We=je([A],We),e.DocumentHighlight=We;var ze;(function(G){G[G.File=0]="File",G[G.Module=1]="Module",G[G.Namespace=2]="Namespace",G[G.Package=3]="Package",G[G.Class=4]="Class",G[G.Method=5]="Method",G[G.Property=6]="Property",G[G.Field=7]="Field",G[G.Constructor=8]="Constructor",G[G.Enum=9]="Enum",G[G.Interface=10]="Interface",G[G.Function=11]="Function",G[G.Variable=12]="Variable",G[G.Constant=13]="Constant",G[G.String=14]="String",G[G.Number=15]="Number",G[G.Boolean=16]="Boolean",G[G.Array=17]="Array",G[G.Object=18]="Object",G[G.Key=19]="Key",G[G.Null=20]="Null",G[G.EnumMember=21]="EnumMember",G[G.Struct=22]="Struct",G[G.Event=23]="Event",G[G.Operator=24]="Operator",G[G.TypeParameter=25]="TypeParameter"})(ze=e.SymbolKind||(e.SymbolKind={}));var Q;(function(G){G[G.Deprecated=1]="Deprecated"})(Q=e.SymbolTag||(e.SymbolTag={}));let ee=n=class{constructor($,ae,Pe,Ye,rt){this.name=$,this.kind=ae,this.containerName=rt,typeof Pe=="string"&&(this.containerName=Pe),Ye instanceof ne?this.location=Ye:Pe instanceof F&&(this.location=new ne(Ye,Pe)),n.validate(this)}static validate($){if(!$.name)throw new Error("name must not be falsy")}toJSON(){return{name:this.name,kind:ze[this.kind],location:this.location,containerName:this.containerName}}};ee=n=je([A],ee),e.SymbolInformation=ee;let re=t=class{constructor($,ae,Pe,Ye,rt){this.name=$,this.detail=ae,this.kind=Pe,this.range=Ye,this.selectionRange=rt,this.children=[],t.validate(this)}static validate($){if(!$.name)throw new Error("name must not be falsy");if(!$.range.contains($.selectionRange))throw new Error("selectionRange must be contained in fullRange");$.children&&$.children.forEach(t.validate)}};re=t=je([A],re),e.DocumentSymbol=re;var he;(function(G){G[G.Invoke=1]="Invoke",G[G.Automatic=2]="Automatic"})(he=e.CodeActionTriggerKind||(e.CodeActionTriggerKind={}));let Z=class{constructor($,ae){this.title=$,this.kind=ae}};Z=je([A],Z),e.CodeAction=Z;let oe=o=class{constructor($){this.value=$}append($){return new o(this.value?this.value+o.sep+$:$)}intersects($){return this.contains($)||$.contains(this)}contains($){return this.value===$.value||$.value.startsWith(this.value+o.sep)}};oe.sep=".",oe=o=je([A],oe),e.CodeActionKind=oe,oe.Empty=new oe(""),oe.QuickFix=oe.Empty.append("quickfix"),oe.Refactor=oe.Empty.append("refactor"),oe.RefactorExtract=oe.Refactor.append("extract"),oe.RefactorInline=oe.Refactor.append("inline"),oe.RefactorRewrite=oe.Refactor.append("rewrite"),oe.Source=oe.Empty.append("source"),oe.SourceOrganizeImports=oe.Source.append("organizeImports"),oe.SourceFixAll=oe.Source.append("fixAll");let be=class{constructor($,ae){if(this.range=$,this.parent=ae,ae&&!ae.range.contains(this.range))throw new Error("Invalid argument: parent must contain this range")}};be=je([A],be),e.SelectionRange=be;class Me{constructor($,ae,Pe,Ye,rt,lt){this.kind=$,this.name=ae,this.detail=Pe,this.uri=Ye,this.range=rt,this.selectionRange=lt}}e.CallHierarchyItem=Me;class Ve{constructor($,ae){this.fromRanges=ae,this.from=$}}e.CallHierarchyIncomingCall=Ve;class Ge{constructor($,ae){this.fromRanges=ae,this.to=$}}e.CallHierarchyOutgoingCall=Ge;var Je;(function(G){G[G.Information=0]="Information",G[G.Warning=1]="Warning",G[G.Error=2]="Error"})(Je=e.LanguageStatusSeverity||(e.LanguageStatusSeverity={}));let tt=class{constructor($,ae){this.range=$,this.command=ae}get isResolved(){return!!this.command}};tt=je([A],tt),e.CodeLens=tt;let ot=d=class{constructor($,ae=!1){f.set(this,void 0),nt(this,f,new y.MarkdownString($,{supportThemeIcons:ae}),"f")}static isMarkdownString($){return $ instanceof d?!0:$&&$.appendCodeblock&&$.appendMarkdown&&$.appendText&&$.value!==void 0}get value(){return Ne(this,f,"f").value}set value($){Ne(this,f,"f").value=$}get isTrusted(){return Ne(this,f,"f").isTrusted}set isTrusted($){Ne(this,f,"f").isTrusted=$}get supportThemeIcons(){return Ne(this,f,"f").supportThemeIcons}set supportThemeIcons($){Ne(this,f,"f").supportThemeIcons=$}get supportHtml(){return Ne(this,f,"f").supportHtml}set supportHtml($){Ne(this,f,"f").supportHtml=$}appendText($){return Ne(this,f,"f").appendText($),this}appendMarkdown($){return Ne(this,f,"f").appendMarkdown($),this}appendCodeblock($,ae){return Ne(this,f,"f").appendCodeblock(ae??"",$),this}};f=new WeakMap,ot=d=je([A],ot),e.MarkdownString=ot;let et=class{constructor($,ae){this.label=$,this.documentation=ae}};et=je([A],et),e.ParameterInformation=et;let it=class{constructor($,ae){this.label=$,this.documentation=ae,this.parameters=[]}};it=je([A],it),e.SignatureInformation=it;let ct=class{constructor(){this.activeSignature=0,this.activeParameter=0,this.signatures=[]}};ct=je([A],ct),e.SignatureHelp=ct;var pt;(function(G){G[G.Invoke=1]="Invoke",G[G.TriggerCharacter=2]="TriggerCharacter",G[G.ContentChange=3]="ContentChange"})(pt=e.SignatureHelpTriggerKind||(e.SignatureHelpTriggerKind={}));var Pt;(function(G){G[G.Other=0]="Other",G[G.Type=1]="Type",G[G.Parameter=2]="Parameter"})(Pt=e.InlayHintKind||(e.InlayHintKind={}));let Ue=class{constructor($,ae,Pe){this.text=$,this.position=ae,this.kind=Pe}};Ue=je([A],Ue),e.InlayHint=Ue;var Rt;(function(G){G[G.Invoke=0]="Invoke",G[G.TriggerCharacter=1]="TriggerCharacter",G[G.TriggerForIncompleteCompletions=2]="TriggerForIncompleteCompletions"})(Rt=e.CompletionTriggerKind||(e.CompletionTriggerKind={}));var J;(function(G){G[G.Text=0]="Text",G[G.Method=1]="Method",G[G.Function=2]="Function",G[G.Constructor=3]="Constructor",G[G.Field=4]="Field",G[G.Variable=5]="Variable",G[G.Class=6]="Class",G[G.Interface=7]="Interface",G[G.Module=8]="Module",G[G.Property=9]="Property",G[G.Unit=10]="Unit",G[G.Value=11]="Value",G[G.Enum=12]="Enum",G[G.Keyword=13]="Keyword",G[G.Snippet=14]="Snippet",G[G.Color=15]="Color",G[G.File=16]="File",G[G.Reference=17]="Reference",G[G.Folder=18]="Folder",G[G.EnumMember=19]="EnumMember",G[G.Constant=20]="Constant",G[G.Struct=21]="Struct",G[G.Event=22]="Event",G[G.Operator=23]="Operator",G[G.TypeParameter=24]="TypeParameter",G[G.User=25]="User",G[G.Issue=26]="Issue"})(J=e.CompletionItemKind||(e.CompletionItemKind={}));var ie;(function(G){G[G.Deprecated=1]="Deprecated"})(ie=e.CompletionItemTag||(e.CompletionItemTag={}));let ge=class{constructor($,ae){this.label=$,this.kind=ae}toJSON(){return{label:this.label,kind:this.kind&&J[this.kind],detail:this.detail,documentation:this.documentation,sortText:this.sortText,filterText:this.filterText,preselect:this.preselect,insertText:this.insertText,textEdit:this.textEdit}}};ge=je([A],ge),e.CompletionItem=ge;let te=class{constructor($=[],ae=!1){this.items=$,this.isIncomplete=ae}};te=je([A],te),e.CompletionList=te;let Ee=class{constructor($,ae,Pe){this.text=$,this.range=ae,this.command=Pe}};Ee=je([A],Ee),e.InlineSuggestion=Ee;let Le=class{constructor($){this.items=$}};Le=je([A],Le),e.InlineSuggestions=Le;var Oe;(function(G){G[G.Active=-1]="Active",G[G.Beside=-2]="Beside",G[G.One=1]="One",G[G.Two=2]="Two",G[G.Three=3]="Three",G[G.Four=4]="Four",G[G.Five=5]="Five",G[G.Six=6]="Six",G[G.Seven=7]="Seven",G[G.Eight=8]="Eight",G[G.Nine=9]="Nine"})(Oe=e.ViewColumn||(e.ViewColumn={}));var Xe;(function(G){G[G.Left=1]="Left",G[G.Right=2]="Right"})(Xe=e.StatusBarAlignment||(e.StatusBarAlignment={}));var Te;(function(G){G[G.Off=0]="Off",G[G.On=1]="On",G[G.Relative=2]="Relative"})(Te=e.TextEditorLineNumbersStyle||(e.TextEditorLineNumbersStyle={}));var Ie;(function(G){G[G.Manual=1]="Manual",G[G.AfterDelay=2]="AfterDelay",G[G.FocusOut=3]="FocusOut"})(Ie=e.TextDocumentSaveReason||(e.TextDocumentSaveReason={}));var Se;(function(G){G[G.Default=0]="Default",G[G.InCenter=1]="InCenter",G[G.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",G[G.AtTop=3]="AtTop"})(Se=e.TextEditorRevealType||(e.TextEditorRevealType={}));var le;(function(G){G[G.Keyboard=1]="Keyboard",G[G.Mouse=2]="Mouse",G[G.Command=3]="Command"})(le=e.TextEditorSelectionChangeKind||(e.TextEditorSelectionChangeKind={}));var ue;(function(G){G[G.Undo=1]="Undo",G[G.Redo=2]="Redo"})(ue=e.TextDocumentChangeReason||(e.TextDocumentChangeReason={}));var we;(function(G){G[G.OpenOpen=0]="OpenOpen",G[G.ClosedClosed=1]="ClosedClosed",G[G.OpenClosed=2]="OpenClosed",G[G.ClosedOpen=3]="ClosedOpen"})(we=e.DecorationRangeBehavior||(e.DecorationRangeBehavior={})),function(G){function $(ae){switch(ae){case"keyboard":return G.Keyboard;case"mouse":return G.Mouse;case"api":return G.Command}}G.fromValue=$}(le=e.TextEditorSelectionChangeKind||(e.TextEditorSelectionChangeKind={}));let _e=class{constructor($,ae){if(ae&&!D.URI.isUri(ae))throw(0,L.illegalArgument)("target");if(!F.isRange($)||$.isEmpty)throw(0,L.illegalArgument)("range");this.range=$,this.target=ae}};_e=je([A],_e),e.DocumentLink=_e;let Fe=class{constructor($,ae,Pe,Ye){this.red=$,this.green=ae,this.blue=Pe,this.alpha=Ye}};Fe=je([A],Fe),e.Color=Fe;let Ke=class{constructor($,ae){if(ae&&!(ae instanceof Fe))throw(0,L.illegalArgument)("color");if(!F.isRange($)||$.isEmpty)throw(0,L.illegalArgument)("range");this.range=$,this.color=ae}};Ke=je([A],Ke),e.ColorInformation=Ke;let $e=class{constructor($){if(!$||typeof $!="string")throw(0,L.illegalArgument)("label");this.label=$}};$e=je([A],$e),e.ColorPresentation=$e;var Qe;(function(G){G[G.RGB=0]="RGB",G[G.HEX=1]="HEX",G[G.HSL=2]="HSL"})(Qe=e.ColorFormat||(e.ColorFormat={}));var st;(function(G){G[G.Error=0]="Error",G[G.Warning=1]="Warning",G[G.Information=2]="Information"})(st=e.SourceControlInputBoxValidationType||(e.SourceControlInputBoxValidationType={}));class at{constructor($,ae,Pe){if(this.startIndex=$,this.length=ae,this.tooltip=Pe,typeof $!="number"||$<0)throw(0,L.illegalArgument)("startIndex");if(typeof ae!="number"||ae<1)throw(0,L.illegalArgument)("length");if(Pe!==void 0&&typeof Pe!="string")throw(0,L.illegalArgument)("tooltip")}}e.TerminalLink=at;var de;(function(G){G[G.Panel=1]="Panel",G[G.Editor=2]="Editor"})(de=e.TerminalLocation||(e.TerminalLocation={}));class Ce{constructor($){this.options=$,typeof $!="object"&&(0,L.illegalArgument)("options")}}e.TerminalProfile=Ce;var ce;(function(G){G[G.Always=1]="Always",G[G.Silent=2]="Silent",G[G.Never=3]="Never"})(ce=e.TaskRevealKind||(e.TaskRevealKind={}));var X;(function(G){G[G.Shared=1]="Shared",G[G.Dedicated=2]="Dedicated",G[G.New=3]="New"})(X=e.TaskPanelKind||(e.TaskPanelKind={}));let De=c=class{constructor($,ae){if(this.label=ae,typeof $!="string"||typeof ae!="string")throw(0,L.illegalArgument)("name");this._id=$}static from($){switch($){case"clean":return c.Clean;case"build":return c.Build;case"rebuild":return c.Rebuild;case"test":return c.Test;default:return}}get id(){return this._id}};De.Clean=new c("clean","Clean"),De.Build=new c("build","Build"),De.Rebuild=new c("rebuild","Rebuild"),De.Test=new c("test","Test"),De=c=je([A],De),e.TaskGroup=De;function Re(G){let $="";for(let ae=0;ae<G.length;ae++)$+=G[ae].replace(/,/g,",,")+",";return $}let Ze=class{constructor($,ae,Pe){if(typeof $!="string")throw(0,L.illegalArgument)("process");this._args=[],this._process=$,ae!==void 0&&(Array.isArray(ae)?(this._args=ae,this._options=Pe):this._options=ae)}get process(){return this._process}set process($){if(typeof $!="string")throw(0,L.illegalArgument)("process");this._process=$}get args(){return this._args}set args($){Array.isArray($)||($=[]),this._args=$}get options(){return this._options}set options($){this._options=$}computeId(){const $=[];if($.push("process"),this._process!==void 0&&$.push(this._process),this._args&&this._args.length>0)for(let ae of this._args)$.push(ae);return Re($)}};Ze=je([A],Ze),e.ProcessExecution=Ze;let qe=class{constructor($,ae,Pe){if(this._args=[],Array.isArray(ae)){if(!$)throw(0,L.illegalArgument)("command can't be undefined or null");if(typeof $!="string"&&typeof $.value!="string")throw(0,L.illegalArgument)("command");this._command=$,this._args=ae,this._options=Pe}else{if(typeof $!="string")throw(0,L.illegalArgument)("commandLine");this._commandLine=$,this._options=ae}}get commandLine(){return this._commandLine}set commandLine($){if(typeof $!="string")throw(0,L.illegalArgument)("commandLine");this._commandLine=$}get command(){return this._command?this._command:""}set command($){if(typeof $!="string"&&typeof $.value!="string")throw(0,L.illegalArgument)("command");this._command=$}get args(){return this._args}set args($){this._args=$||[]}get options(){return this._options}set options($){this._options=$}computeId(){const $=[];if($.push("shell"),this._commandLine!==void 0&&$.push(this._commandLine),this._command!==void 0&&$.push(typeof this._command=="string"?this._command:this._command.value),this._args&&this._args.length>0)for(let ae of this._args)$.push(typeof ae=="string"?ae:ae.value);return Re($)}};qe=je([A],qe),e.ShellExecution=qe;var dt;(function(G){G[G.Escape=1]="Escape",G[G.Strong=2]="Strong",G[G.Weak=3]="Weak"})(dt=e.ShellQuoting||(e.ShellQuoting={}));var wt;(function(G){G[G.Global=1]="Global",G[G.Workspace=2]="Workspace"})(wt=e.TaskScope||(e.TaskScope={}));class yt{constructor($){this._callback=$}computeId(){return"customExecution"+(0,R.generateUuid)()}set callback($){this._callback=$}get callback(){return this._callback}}e.CustomExecution=yt;let bt=h=class{constructor($,ae,Pe,Ye,rt,lt){this.__deprecated=!1,this._definition=this.definition=$;let ht;typeof ae=="string"?(this._name=this.name=ae,this._source=this.source=Pe,this.execution=Ye,ht=rt,this.__deprecated=!0):ae===wt.Global||ae===wt.Workspace?(this.target=ae,this._name=this.name=Pe,this._source=this.source=Ye,this.execution=rt,ht=lt):(this.target=ae,this._name=this.name=Pe,this._source=this.source=Ye,this.execution=rt,ht=lt),typeof ht=="string"?(this._problemMatchers=[ht],this._hasDefinedMatchers=!0):Array.isArray(ht)?(this._problemMatchers=ht,this._hasDefinedMatchers=!0):(this._problemMatchers=[],this._hasDefinedMatchers=!1),this._isBackground=!1,this._presentationOptions=Object.create(null),this._runOptions=Object.create(null)}get _id(){return this.__id}set _id($){this.__id=$}get _deprecated(){return this.__deprecated}clear(){this.__id!==void 0&&(this.__id=void 0,this._scope=void 0,this.computeDefinitionBasedOnExecution())}computeDefinitionBasedOnExecution(){this._execution instanceof Ze?this._definition={type:h.ProcessType,id:this._execution.computeId()}:this._execution instanceof qe?this._definition={type:h.ShellType,id:this._execution.computeId()}:this._execution instanceof yt?this._definition={type:h.ExtensionCallbackType,id:this._execution.computeId()}:this._definition={type:h.EmptyType,id:(0,R.generateUuid)()}}get definition(){return this._definition}set definition($){if($==null)throw(0,L.illegalArgument)("Kind can't be undefined or null");this.clear(),this._definition=$}get scope(){return this._scope}set target($){this.clear(),this._scope=$}get name(){return this._name}set name($){if(typeof $!="string")throw(0,L.illegalArgument)("name");this.clear(),this._name=$}get execution(){return this._execution}set execution($){$===null&&($=void 0),this.clear(),this._execution=$;const ae=this._definition.type;(h.EmptyType===ae||h.ProcessType===ae||h.ShellType===ae||h.ExtensionCallbackType===ae)&&this.computeDefinitionBasedOnExecution()}get problemMatchers(){return this._problemMatchers}set problemMatchers($){if(Array.isArray($))this.clear(),this._problemMatchers=$,this._hasDefinedMatchers=!0;else{this.clear(),this._problemMatchers=[],this._hasDefinedMatchers=!1;return}}get hasDefinedMatchers(){return this._hasDefinedMatchers}get isBackground(){return this._isBackground}set isBackground($){$!==!0&&$!==!1&&($=!1),this.clear(),this._isBackground=$}get source(){return this._source}set source($){if(typeof $!="string"||$.length===0)throw(0,L.illegalArgument)("source must be a string of length > 0");this.clear(),this._source=$}get group(){return this._group}set group($){$===null&&($=void 0),this.clear(),this._group=$}get detail(){return this._detail}set detail($){$===null&&($=void 0),this._detail=$}get presentationOptions(){return this._presentationOptions}set presentationOptions($){$==null&&($=Object.create(null)),this.clear(),this._presentationOptions=$}get runOptions(){return this._runOptions}set runOptions($){$==null&&($=Object.create(null)),this.clear(),this._runOptions=$}};bt.ExtensionCallbackType="customExecution",bt.ProcessType="process",bt.ShellType="shell",bt.EmptyType="$empty",bt=h=je([A],bt),e.Task=bt;var ft;(function(G){G[G.SourceControl=1]="SourceControl",G[G.Window=10]="Window",G[G.Notification=15]="Notification"})(ft=e.ProgressLocation||(e.ProgressLocation={}));let vt=class{constructor($,ae=St.None){this.collapsibleState=ae,D.URI.isUri($)?this.resourceUri=$:this.label=$}};vt=je([A],vt),e.TreeItem=vt;var St;(function(G){G[G.None=0]="None",G[G.Collapsed=1]="Collapsed",G[G.Expanded=2]="Expanded"})(St=e.TreeItemCollapsibleState||(e.TreeItemCollapsibleState={}));let Ot=class{constructor($){this._value=$}async asString(){return JSON.stringify(this._value)}};Ot=je([A],Ot),e.TreeDataTransferItem=Ot;let It=class{constructor(){this._items=new Map}get($){return this._items.get($)}set($,ae){this._items.set($,ae)}forEach($){this._items.forEach($)}};It=je([A],It),e.TreeDataTransfer=It;let Tt=class{constructor($,ae){this.id=$,this.color=ae}};Tt=je([A],Tt),e.ThemeIcon=Tt,Tt.File=new Tt("file"),Tt.Folder=new Tt("folder");let Lt=class{constructor($){this.id=$}};Lt=je([A],Lt),e.ThemeColor=Lt;var _t;(function(G){G[G.Global=1]="Global",G[G.Workspace=2]="Workspace",G[G.WorkspaceFolder=3]="WorkspaceFolder"})(_t=e.ConfigurationTarget||(e.ConfigurationTarget={}));let Mt=class{constructor($,ae){if(typeof $!="string"&&(!$||!D.URI.isUri($)&&!D.URI.isUri($.uri)))throw(0,L.illegalArgument)("base");if(typeof ae!="string")throw(0,L.illegalArgument)("pattern");typeof $=="string"?(this.baseFolder=D.URI.file($),this.base=$):D.URI.isUri($)?(this.baseFolder=$,this.base=$.fsPath):(this.baseFolder=$.uri,this.base=$.uri.fsPath),this.pattern=ae}};Mt=je([A],Mt),e.RelativePattern=Mt;let Nt=class{constructor($,ae,Pe,Ye){this.enabled=typeof $=="boolean"?$:!0,typeof ae=="string"&&(this.condition=ae),typeof Pe=="string"&&(this.hitCondition=Pe),typeof Ye=="string"&&(this.logMessage=Ye)}get id(){return this._id||(this._id=(0,R.generateUuid)()),this._id}};Nt=je([A],Nt),e.Breakpoint=Nt;let Et=class extends Nt{constructor($,ae,Pe,Ye,rt){super(ae,Pe,Ye,rt);if($===null)throw(0,L.illegalArgument)("location");this.location=$}};Et=je([A],Et),e.SourceBreakpoint=Et;let Wt=class extends Nt{constructor($,ae,Pe,Ye,rt){super(ae,Pe,Ye,rt);this.functionName=$}};Wt=je([A],Wt),e.FunctionBreakpoint=Wt;let jt=class extends Nt{constructor($,ae,Pe,Ye,rt,lt,ht){super(Ye,rt,lt,ht);if(!ae)throw(0,L.illegalArgument)("dataId");this.label=$,this.dataId=ae,this.canPersist=Pe}};jt=je([A],jt),e.DataBreakpoint=jt;let si=class{constructor($,ae,Pe){this.command=$,this.args=ae||[],this.options=Pe}};si=je([A],si),e.DebugAdapterExecutable=si;let oi=class{constructor($,ae){this.port=$,this.host=ae}};oi=je([A],oi),e.DebugAdapterServer=oi;let At=class{constructor($){this.path=$}};At=je([A],At),e.DebugAdapterNamedPipeServer=At;let Xt=class{constructor($){this.implementation=$}};Xt=je([A],Xt),e.DebugAdapterInlineImplementation=Xt;let ai=class{constructor($,ae){this.range=$,this.expression=ae}};ai=je([A],ai),e.EvaluatableExpression=ai;var Yt;(function(G){G[G.Automatic=0]="Automatic",G[G.Explicit=1]="Explicit"})(Yt=e.InlineCompletionTriggerKind||(e.InlineCompletionTriggerKind={}));let Vt=class{constructor($,ae){this.range=$,this.text=ae}};Vt=je([A],Vt),e.InlineValueText=Vt;let gt=class{constructor($,ae,Pe=!0){this.range=$,this.variableName=ae,this.caseSensitiveLookup=Pe}};gt=je([A],gt),e.InlineValueVariableLookup=gt;let ci=class{constructor($,ae){this.range=$,this.expression=ae}};ci=je([A],ci),e.InlineValueEvaluatableExpression=ci;let Ut=class{constructor($,ae){this.frameId=$,this.stoppedLocation=ae}};Ut=je([A],Ut),e.InlineValueContext=Ut;var qt;(function(G){G[G.Changed=1]="Changed",G[G.Created=2]="Created",G[G.Deleted=3]="Deleted"})(qt=e.FileChangeType||(e.FileChangeType={}));let Jt=l=class extends Error{constructor($,ae=P.FileSystemProviderErrorCode.Unknown,Pe){super(D.URI.isUri($)?$.toString(!0):$);this.code=Pe?.name??"Unknown",(0,P.markAsFileSystemProviderError)(this,ae),typeof Object.setPrototypeOf=="function"&&Object.setPrototypeOf(this,l.prototype),typeof Error.captureStackTrace=="function"&&typeof Pe=="function"&&Error.captureStackTrace(this,Pe)}static FileExists($){return new l($,P.FileSystemProviderErrorCode.FileExists,l.FileExists)}static FileNotFound($){return new l($,P.FileSystemProviderErrorCode.FileNotFound,l.FileNotFound)}static FileNotADirectory($){return new l($,P.FileSystemProviderErrorCode.FileNotADirectory,l.FileNotADirectory)}static FileIsADirectory($){return new l($,P.FileSystemProviderErrorCode.FileIsADirectory,l.FileIsADirectory)}static NoPermissions($){return new l($,P.FileSystemProviderErrorCode.NoPermissions,l.NoPermissions)}static Unavailable($){return new l($,P.FileSystemProviderErrorCode.Unavailable,l.Unavailable)}};Jt=l=je([A],Jt),e.FileSystemError=Jt;let li=class{constructor($,ae,Pe){this.start=$,this.end=ae,this.kind=Pe}};li=je([A],li),e.FoldingRange=li;var fi;(function(G){G[G.Comment=1]="Comment",G[G.Imports=2]="Imports",G[G.Region=3]="Region"})(fi=e.FoldingRangeKind||(e.FoldingRangeKind={}));var Ei;(function(G){G[G.Collapsed=0]="Collapsed",G[G.Expanded=1]="Expanded"})(Ei=e.CommentThreadCollapsibleState||(e.CommentThreadCollapsibleState={}));var mi;(function(G){G[G.Editing=0]="Editing",G[G.Preview=1]="Preview"})(mi=e.CommentMode||(e.CommentMode={}));class Zt{constructor($,ae=[]){this.tokenTypes=$,this.tokenModifiers=ae}}e.SemanticTokensLegend=Zt;function _i(G){return typeof G=="undefined"||(0,S.isStringArray)(G)}class Gt{constructor($){if(this._prevLine=0,this._prevChar=0,this._dataIsSortedAndDeltaEncoded=!0,this._data=[],this._dataLen=0,this._tokenTypeStrToInt=new Map,this._tokenModifierStrToInt=new Map,this._hasLegend=!1,$){this._hasLegend=!0;for(let ae=0,Pe=$.tokenTypes.length;ae<Pe;ae++)this._tokenTypeStrToInt.set($.tokenTypes[ae],ae);for(let ae=0,Pe=$.tokenModifiers.length;ae<Pe;ae++)this._tokenModifierStrToInt.set($.tokenModifiers[ae],ae)}}push($,ae,Pe,Ye,rt){if(typeof $=="number"&&typeof ae=="number"&&typeof Pe=="number"&&typeof Ye=="number"&&(typeof rt=="number"||typeof rt=="undefined"))return typeof rt=="undefined"&&(rt=0),this._pushEncoded($,ae,Pe,Ye,rt);if(F.isRange($)&&typeof ae=="string"&&_i(Pe))return this._push($,ae,Pe);throw(0,L.illegalArgument)()}_push($,ae,Pe){if(!this._hasLegend)throw new Error("Legend must be provided in constructor");if($.start.line!==$.end.line)throw new Error("`range` cannot span multiple lines");if(!this._tokenTypeStrToInt.has(ae))throw new Error("`tokenType` is not in the provided legend");const Ye=$.start.line,rt=$.start.character,lt=$.end.character-$.start.character,ht=this._tokenTypeStrToInt.get(ae);let kt=0;if(Pe)for(const Ft of Pe){if(!this._tokenModifierStrToInt.has(Ft))throw new Error("`tokenModifier` is not in the provided legend");const Bt=this._tokenModifierStrToInt.get(Ft);kt|=1<<Bt>>>0}this._pushEncoded(Ye,rt,lt,ht,kt)}_pushEncoded($,ae,Pe,Ye,rt){if(this._dataIsSortedAndDeltaEncoded&&($<this._prevLine||$===this._prevLine&&ae<this._prevChar)){this._dataIsSortedAndDeltaEncoded=!1;const kt=this._data.length/5|0;let Ft=0,Bt=0;for(let $t=0;$t<kt;$t++){let Ht=this._data[5*$t],di=this._data[5*$t+1];Ht===0?(Ht=Ft,di+=Bt):Ht+=Ft,this._data[5*$t]=Ht,this._data[5*$t+1]=di,Ft=Ht,Bt=di}}let lt=$,ht=ae;this._dataIsSortedAndDeltaEncoded&&this._dataLen>0&&(lt-=this._prevLine,lt===0&&(ht-=this._prevChar)),this._data[this._dataLen++]=lt,this._data[this._dataLen++]=ht,this._data[this._dataLen++]=Pe,this._data[this._dataLen++]=Ye,this._data[this._dataLen++]=rt,this._prevLine=$,this._prevChar=ae}static _sortAndDeltaEncode($){let ae=[];const Pe=$.length/5|0;for(let ht=0;ht<Pe;ht++)ae[ht]=ht;ae.sort((ht,kt)=>{const Ft=$[5*ht],Bt=$[5*kt];if(Ft===Bt){const $t=$[5*ht+1],Ht=$[5*kt+1];return $t-Ht}return Ft-Bt});const Ye=new Uint32Array($.length);let rt=0,lt=0;for(let ht=0;ht<Pe;ht++){const kt=5*ae[ht],Ft=$[kt+0],Bt=$[kt+1],$t=$[kt+2],Ht=$[kt+3],di=$[kt+4],$i=Ft-rt,Xi=$i===0?Bt-lt:Bt,hi=5*ht;Ye[hi+0]=$i,Ye[hi+1]=Xi,Ye[hi+2]=$t,Ye[hi+3]=Ht,Ye[hi+4]=di,rt=Ft,lt=Bt}return Ye}build($){return this._dataIsSortedAndDeltaEncoded?new Kt(new Uint32Array(this._data),$):new Kt(Gt._sortAndDeltaEncode(this._data),$)}}e.SemanticTokensBuilder=Gt;class Kt{constructor($,ae){this.resultId=ae,this.data=$}}e.SemanticTokens=Kt;class Si{constructor($,ae,Pe){this.start=$,this.deleteCount=ae,this.data=Pe}}e.SemanticTokensEdit=Si;class Ci{constructor($,ae){this.resultId=ae,this.edits=$}}e.SemanticTokensEdits=Ci;var Qt;(function(G){G[G.Separate=0]="Separate",G[G.MergeWithParent=1]="MergeWithParent"})(Qt=e.DebugConsoleMode||(e.DebugConsoleMode={}));var yi;(function(G){G[G.Initial=1]="Initial",G[G.Dynamic=2]="Dynamic"})(yi=e.DebugConfigurationProviderTriggerKind||(e.DebugConfigurationProviderTriggerKind={}));let ei=class{constructor(){}};ei.Back={iconPath:new Tt("arrow-left")},ei=je([A],ei),e.QuickInputButtons=ei;var Di;(function(G){G[G.Default=1]="Default",G[G.Separator=2]="Separator"})(Di=e.QuickPickItemKind||(e.QuickPickItemKind={}));var ki;(function(G){G[G.UI=1]="UI",G[G.Workspace=2]="Workspace"})(ki=e.ExtensionKind||(e.ExtensionKind={}));class ui{constructor($,ae,Pe){this.badge=$,this.tooltip=ae,this.color=Pe}static validate($){if($.badge){let ae=(0,k.nextCharLength)($.badge,0);if(ae<$.badge.length&&(ae+=(0,k.nextCharLength)($.badge,ae)),$.badge.length>ae)throw new Error("The 'badge'-property must be undefined or a short character")}if(!$.color&&!$.badge&&!$.tooltip)throw new Error("The decoration is empty");return!0}}e.FileDecoration=ui;let ti=class{constructor($){this.kind=$}};ti=je([A],ti),e.ColorTheme=ti;var gi;(function(G){G[G.Light=1]="Light",G[G.Dark=2]="Dark",G[G.HighContrast=3]="HighContrast"})(gi=e.ColorThemeKind||(e.ColorThemeKind={}));class xe{constructor($,ae){if($<0)throw(0,L.illegalArgument)("start must be positive");if(ae<0)throw(0,L.illegalArgument)("end must be positive");$<=ae?(this._start=$,this._end=ae):(this._start=ae,this._end=$)}static isNotebookRange($){return $ instanceof xe?!0:$?typeof $.start=="number"&&typeof $.end=="number":!1}get start(){return this._start}get end(){return this._end}get isEmpty(){return this._start===this._end}with($){let ae=this._start,Pe=this._end;return $.start!==void 0&&(ae=$.start),$.end!==void 0&&(Pe=$.end),ae===this._start&&Pe===this._end?this:new xe(ae,Pe)}}e.NotebookRange=xe;class xt{constructor($,ae,Pe,Ye,rt,lt,ht){this.kind=$,this.value=ae,this.languageId=Pe,this.mime=Ye,this.outputs=rt??[],this.metadata=lt,this.executionSummary=ht,xt.validate(this)}static validate($){if(typeof $.kind!="number")throw new Error("NotebookCellData MUST have 'kind' property");if(typeof $.value!="string")throw new Error("NotebookCellData MUST have 'value' property");if(typeof $.languageId!="string")throw new Error("NotebookCellData MUST have 'languageId' property")}static isNotebookCellDataArray($){return Array.isArray($)&&$.every(ae=>xt.isNotebookCellData(ae))}static isNotebookCellData($){return!0}}e.NotebookCellData=xt;class pi{constructor($){this.cells=$}}e.NotebookData=pi;class mt{constructor($,ae){this.data=$,this.mime=ae;const Pe=(0,i.normalizeMimeType)(ae,!0);if(!Pe)throw new Error(`INVALID mime type: ${ae}. Must be in the format "type/subtype[;optionalparameter]"`);this.mime=Pe}static isNotebookCellOutputItem($){return $ instanceof mt?!0:$?typeof $.mime=="string"&&$.data instanceof Uint8Array:!1}static error($){const ae={name:$.name,message:$.message,stack:$.stack};return mt.json(ae,"application/vnd.code.notebook.error")}static stdout($){return mt.text($,"application/vnd.code.notebook.stdout")}static stderr($){return mt.text($,"application/vnd.code.notebook.stderr")}static bytes($,ae="application/octet-stream"){return new mt($,ae)}static text($,ae=i.Mimes.text){const Pe=Ne(mt,v,"f",w).encode(String($));return new mt(Pe,ae)}static json($,ae="application/json"){const Pe=JSON.stringify($,void 0,"	");return mt.text(Pe,ae)}}e.NotebookCellOutputItem=mt,v=mt,w={value:new TextEncoder};class ii{constructor($,ae,Pe){this.items=ii.ensureUniqueMimeTypes($,!0),typeof ae=="string"?(this.id=ae,this.metadata=Pe):(this.id=(0,R.generateUuid)(),this.metadata=ae??Pe)}static isNotebookCellOutput($){return $ instanceof ii?!0:!$||typeof $!="object"?!1:typeof $.id=="string"&&(0,S.isArray)($.items)}static ensureUniqueMimeTypes($,ae=!1){const Pe=new Set,Ye=new Set;for(let rt=0;rt<$.length;rt++){const lt=$[rt],ht=(0,i.normalizeMimeType)(lt.mime);if(!Pe.has(ht)){Pe.add(ht);continue}Ye.add(rt),ae&&console.warn(`DUPLICATED mime type '${lt.mime}' will be dropped`)}return Ye.size===0?$:$.filter((rt,lt)=>!Ye.has(lt))}}e.NotebookCellOutput=ii;var Ii;(function(G){G[G.Markup=1]="Markup",G[G.Code=2]="Code"})(Ii=e.NotebookCellKind||(e.NotebookCellKind={}));var vi;(function(G){G[G.Idle=1]="Idle",G[G.Pending=2]="Pending",G[G.Executing=3]="Executing"})(vi=e.NotebookCellExecutionState||(e.NotebookCellExecutionState={}));var wi;(function(G){G[G.Left=1]="Left",G[G.Right=2]="Right"})(wi=e.NotebookCellStatusBarAlignment||(e.NotebookCellStatusBarAlignment={}));var Pi;(function(G){G[G.Default=0]="Default",G[G.InCenter=1]="InCenter",G[G.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",G[G.AtTop=3]="AtTop"})(Pi=e.NotebookEditorRevealType||(e.NotebookEditorRevealType={}));class Ti{constructor($,ae){this.text=$,this.alignment=ae}}e.NotebookCellStatusBarItem=Ti;var Ai;(function(G){G[G.Default=1]="Default",G[G.Preferred=2]="Preferred"})(Ai=e.NotebookControllerAffinity||(e.NotebookControllerAffinity={}));class Ri{constructor($,ae=[]){this.uri=$,this.provides=(0,m.asArray)(ae)}}e.NotebookRendererScript=Ri;let ni=class{constructor($,ae){this.label=$,this.timestamp=ae}};ni=je([A],ni),e.TimelineItem=ni;var Li;(function(G){G[G.Production=1]="Production",G[G.Development=2]="Development",G[G.Test=3]="Test"})(Li=e.ExtensionMode||(e.ExtensionMode={}));var Fi;(function(G){G[G.Node=1]="Node",G[G.Webworker=2]="Webworker"})(Fi=e.ExtensionRuntime||(e.ExtensionRuntime={}));var Mi;(function(G){G[G.Other=0]="Other",G[G.Comment=1]="Comment",G[G.String=2]="String",G[G.RegEx=4]="RegEx"})(Mi=e.StandardTokenType||(e.StandardTokenType={}));class Oi{constructor($,ae){this.ranges=$,this.wordPattern=ae}}e.LinkedEditingRanges=Oi;class Ni{constructor($,ae){this._port=$,this._autoForwardAction=ae}get port(){return this._port}get autoForwardAction(){return this._autoForwardAction}}e.PortAttributes=Ni;var se;(function(G){G[G.Queued=1]="Queued",G[G.Running=2]="Running",G[G.Passed=3]="Passed",G[G.Failed=4]="Failed",G[G.Skipped=5]="Skipped",G[G.Errored=6]="Errored"})(se=e.TestResultState||(e.TestResultState={}));var me;(function(G){G[G.Run=1]="Run",G[G.Debug=2]="Debug",G[G.Coverage=3]="Coverage"})(me=e.TestRunProfileKind||(e.TestRunProfileKind={}));let Ae=class{constructor($=void 0,ae=void 0,Pe=void 0){this.include=$,this.exclude=ae,this.profile=Pe}};Ae=je([A],Ae),e.TestRunRequest=Ae;let ut=b=class{constructor($){this.message=$}static diff($,ae,Pe){const Ye=new b($);return Ye.expectedOutput=ae,Ye.actualOutput=Pe,Ye}};ut=b=je([A],ut),e.TestMessage=ut;let Ct=class{constructor($){this.id=$}};Ct=je([A],Ct),e.TestTag=Ct;let Dt=class{constructor($,ae){this.covered=$,this.total=ae}};Dt=je([A],Dt),e.CoveredCount=Dt;let Ui=T=class{constructor($,ae,Pe,Ye){this.uri=$,this.statementCoverage=ae,this.branchCoverage=Pe,this.functionCoverage=Ye}static fromDetails($,ae){const Pe=new Dt(0,0),Ye=new Dt(0,0),rt=new Dt(0,0);for(const ht of ae)if("branches"in ht){Pe.total+=1,Pe.covered+=ht.executionCount>0?1:0;for(const kt of ht.branches)Ye.total+=1,Ye.covered+=kt.executionCount>0?1:0}else rt.total+=1,rt.covered+=ht.executionCount>0?1:0;const lt=new T($,Pe,Ye.total>0?Ye:void 0,rt.total>0?rt:void 0);return lt.detailedCoverage=ae,lt}};Ui=T=je([A],Ui),e.FileCoverage=Ui;let xi=class{constructor($,ae,Pe=[]){this.executionCount=$,this.location=ae,this.branches=Pe}};xi=je([A],xi),e.StatementCoverage=xi;let Bi=class{constructor($,ae){this.executionCount=$,this.location=ae}};Bi=je([A],Bi),e.BranchCoverage=Bi;let Wi=class{constructor($,ae){this.executionCount=$,this.location=ae}};Wi=je([A],Wi),e.FunctionCoverage=Wi;var qi;(function(G){G[G.None=0]="None",G[G.Option=1]="Option",G[G.Default=2]="Default",G[G.Preferred=3]="Preferred"})(qi=e.ExternalUriOpenerPriority||(e.ExternalUriOpenerPriority={}));var Gi;(function(G){G[G.Untrusted=0]="Untrusted",G[G.Trusted=1]="Trusted",G[G.Unspecified=2]="Unspecified"})(Gi=e.WorkspaceTrustState||(e.WorkspaceTrustState={}));var Ki;(function(G){G[G.Notify=1]="Notify",G[G.OpenBrowser=2]="OpenBrowser",G[G.OpenPreview=3]="OpenPreview",G[G.Silent=4]="Silent",G[G.Ignore=5]="Ignore",G[G.OpenBrowserOnce=6]="OpenBrowserOnce"})(Ki=e.PortAutoForwardAction||(e.PortAutoForwardAction={}));class Qi{constructor($,ae,Pe,Ye,rt,lt){this.kind=$,this.name=ae,this.detail=Pe,this.uri=Ye,this.range=rt,this.selectionRange=lt}}e.TypeHierarchyItem=Qi}),define(pe[122],ve([0,1,56,10,8,149,109,7,16]),function(Y,e,m,L,y,C,i,k,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDocumentLine=e.ExtHostDocumentData=e.getWordDefinitionFor=e.setWordDefinitionFor=void 0;const D=new Map;function R(f,v){v?D.set(f,v):D.delete(f)}e.setWordDefinitionFor=R;function P(f){return D.get(f)}e.getWordDefinitionFor=P;class u extends C.MirrorTextModel{constructor(v,w,I,p,s,r,g,a){super(w,I,p,s);this._proxy=v,this._languageId=r,this._isDirty=g,this._notebook=a,this._isDisposed=!1}dispose(){(0,m.ok)(!this._isDisposed),this._isDisposed=!0,this._isDirty=!1}equalLines(v){return(0,S.equals)(this._lines,v)}get document(){if(!this._document){const v=this;this._document={get uri(){return v._uri},get fileName(){return v._uri.fsPath},get isUntitled(){return v._uri.scheme===L.Schemas.untitled},get languageId(){return v._languageId},get version(){return v._versionId},get isClosed(){return v._isDisposed},get isDirty(){return v._isDirty},get notebook(){return v._notebook},save(){return v._save()},getText(w){return w?v._getTextInRange(w):v.getText()},get eol(){return v._eol===`
`?k.EndOfLine.LF:k.EndOfLine.CRLF},get lineCount(){return v._lines.length},lineAt(w){return v._lineAt(w)},offsetAt(w){return v._offsetAt(w)},positionAt(w){return v._positionAt(w)},validateRange(w){return v._validateRange(w)},validatePosition(w){return v._validatePosition(w)},getWordRangeAtPosition(w,I){return v._getWordRangeAtPosition(w,I)}}}return Object.freeze(this._document)}_acceptLanguageId(v){(0,m.ok)(!this._isDisposed),this._languageId=v}_acceptIsDirty(v){(0,m.ok)(!this._isDisposed),this._isDirty=v}_save(){return this._isDisposed?Promise.reject(new Error("Document has been closed")):this._proxy.$trySaveDocument(this._uri)}_getTextInRange(v){const w=this._validateRange(v);if(w.isEmpty)return"";if(w.isSingleLine)return this._lines[w.start.line].substring(w.start.character,w.end.character);const I=this._eol,p=w.start.line,s=w.end.line,r=[];r.push(this._lines[p].substring(w.start.character));for(let g=p+1;g<s;g++)r.push(this._lines[g]);return r.push(this._lines[s].substring(0,w.end.character)),r.join(I)}_lineAt(v){let w;if(v instanceof k.Position?w=v.line:typeof v=="number"&&(w=v),typeof w!="number"||w<0||w>=this._lines.length||Math.floor(w)!==w)throw new Error("Illegal value for `line`");return new E(w,this._lines[w],w===this._lines.length-1)}_offsetAt(v){return v=this._validatePosition(v),this._ensureLineStarts(),this._lineStarts.getPrefixSum(v.line-1)+v.character}_positionAt(v){v=Math.floor(v),v=Math.max(0,v),this._ensureLineStarts();const w=this._lineStarts.getIndexOf(v),I=this._lines[w.index].length;return new k.Position(w.index,Math.min(w.remainder,I))}_validateRange(v){if(!(v instanceof k.Range))throw new Error("Invalid argument");const w=this._validatePosition(v.start),I=this._validatePosition(v.end);return w===v.start&&I===v.end?v:new k.Range(w.line,w.character,I.line,I.character)}_validatePosition(v){if(!(v instanceof k.Position))throw new Error("Invalid argument");if(this._lines.length===0)return v.with(0,0);let{line:w,character:I}=v,p=!1;if(w<0)w=0,I=0,p=!0;else if(w>=this._lines.length)w=this._lines.length-1,I=this._lines[w].length,p=!0;else{const s=this._lines[w].length;I<0?(I=0,p=!0):I>s&&(I=s,p=!0)}return p?new k.Position(w,I):v}_getWordRangeAtPosition(v,w){const I=this._validatePosition(v);if(!w)w=P(this._languageId);else if((0,y.regExpLeadsToEndlessLoop)(w))throw new Error(`[getWordRangeAtPosition]: ignoring custom regexp '${w.source}' because it matches the empty string.`);const p=(0,i.getWordAtText)(I.character+1,(0,i.ensureValidWordDefinition)(w),this._lines[I.line],0);if(p)return new k.Range(I.line,p.startColumn-1,I.line,p.endColumn-1)}}e.ExtHostDocumentData=u;class E{constructor(v,w,I){this._line=v,this._text=w,this._isLastLine=I}get lineNumber(){return this._line}get text(){return this._text}get range(){return new k.Range(this._line,0,this._line,this._text.length)}get rangeIncludingLineBreak(){return this._isLastLine?this.range:new k.Range(this._line,0,this._line+1,0)}get firstNonWhitespaceCharacterIndex(){return/^(\s*)/.exec(this._text)[1].length}get isEmptyOrWhitespace(){return this.firstNonWhitespaceCharacterIndex===this._text.length}}e.ExtHostDocumentLine=E}),define(pe[201],ve([0,1,7,3,111,6,82,24,2,32]),function(Y,e,m,L,y,C,i,k,S,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookConcatDocument=void 0;class R{constructor(u,E,f,v){this._notebook=f,this._selector=v,this._disposables=new C.DisposableStore,this._isClosed=!1,this._versionId=0,this._onDidChange=new L.Emitter,this.onDidChange=this._onDidChange.event,this.uri=S.URI.from({scheme:"vscode-concat-doc",path:(0,D.generateUuid)()}),this._init(),this._disposables.add(E.onDidChangeDocument(I=>{const p=this._cellUris.get(I.document.uri);p!==void 0&&(this._cellLengths.setValue(p,this._cells[p].document.getText().length+1),this._cellLines.setValue(p,this._cells[p].document.lineCount),this._versionId+=1,this._onDidChange.fire(void 0))}));const w=I=>{I===this._notebook&&(this._init(),this._versionId+=1,this._onDidChange.fire(void 0))};this._disposables.add(u.onDidChangeNotebookCells(I=>w(I.document)))}dispose(){this._disposables.dispose(),this._isClosed=!0}get isClosed(){return this._isClosed}_init(){this._cells=[],this._cellUris=new k.ResourceMap;const u=[],E=[];for(const f of this._notebook.getCells())f.kind===m.NotebookCellKind.Code&&(!this._selector||(0,i.score)(this._selector,f.document.uri,f.document.languageId,!0))&&(this._cellUris.set(f.document.uri,this._cells.length),this._cells.push(f),u.push(f.document.getText().length+1),E.push(f.document.lineCount));this._cellLengths=new y.PrefixSumComputer(new Uint32Array(u)),this._cellLines=new y.PrefixSumComputer(new Uint32Array(E))}get version(){return this._versionId}getText(u){if(!u){let p="";for(const s of this._cells)p+=s.document.getText()+`
`;return p=p.slice(0,-1),p}if(u.isEmpty)return"";const E=this.locationAt(u.start),f=this.locationAt(u.end),v=this._cellUris.get(E.uri),w=this._cellUris.get(f.uri);if(v===void 0||w===void 0)return"";if(v===w)return this._cells[v].document.getText(new m.Range(E.range.start,f.range.end));const I=[this._cells[v].document.getText(new m.Range(E.range.start,new m.Position(this._cells[v].document.lineCount,0)))];for(let p=v+1;p<w;p++)I.push(this._cells[p].document.getText());return I.push(this._cells[w].document.getText(new m.Range(new m.Position(0,0),f.range.end))),I.join(`
`)}offsetAt(u){const E=this._cellLines.getIndexOf(u.line),f=this._cellLengths.getPrefixSum(E.index-1),v=this._cells[E.index].document.offsetAt(u.with(E.remainder));return f+v}positionAt(u){if(typeof u=="number"){const f=this._cellLengths.getIndexOf(u),v=this._cellLines.getPrefixSum(f.index-1);return this._cells[f.index].document.positionAt(f.remainder).translate(v)}const E=this._cellUris.get(u.uri);if(E!==void 0){const f=this._cellLines.getPrefixSum(E-1);return new m.Position(f+u.range.start.line,u.range.start.character)}return new m.Position(0,0)}locationAt(u){m.Range.isRange(u)||(u=new m.Range(u,u));const E=this._cellLines.getIndexOf(u.start.line);let f=E;u.isEmpty||(f=this._cellLines.getIndexOf(u.end.line));const v=new m.Position(E.remainder,u.start.character),w=new m.Position(f.remainder,u.end.character),I=new m.Range(v,w),p=this._cells[E.index];return new m.Location(p.document.uri,p.document.validateRange(I))}contains(u){return this._cellUris.has(u)}validateRange(u){const E=this.validatePosition(u.start),f=this.validatePosition(u.end);return u.with(E,f)}validatePosition(u){const E=this._cellLines.getIndexOf(u.line),f=new m.Position(E.remainder,u.character),v=this._cells[E.index].document.validatePosition(f),w=this._cellLines.getPrefixSum(E.index-1);return new m.Position(w+v.line,v.character)}}e.ExtHostNotebookConcatDocument=R}),define(pe[202],ve([0,1,7,14,3]),function(Y,e,m,L,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTheming=void 0;let C=class{constructor(k){this._actual=new m.ColorTheme(m.ColorThemeKind.Dark),this._onDidChangeActiveColorTheme=new y.Emitter}get activeColorTheme(){return this._actual}$onColorThemeChange(k){let S=k==="light"?m.ColorThemeKind.Light:k==="dark"?m.ColorThemeKind.Dark:m.ColorThemeKind.HighContrast;this._actual=new m.ColorTheme(S),this._onDidChangeActiveColorTheme.fire(this._actual)}get onDidChangeActiveColorTheme(){return this._onDidChangeActiveColorTheme.event}};C=je([He(0,L.IExtHostRpcService)],C),e.ExtHostTheming=C}),define(pe[64],ve([0,1,4]),function(Y,e,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.URITransformerService=e.IURITransformerService=void 0,e.IURITransformerService=(0,m.createDecorator)("IURITransformerService");class L{constructor(C){C?(this.transformIncoming=C.transformIncoming.bind(C),this.transformOutgoing=C.transformOutgoing.bind(C),this.transformOutgoingURI=C.transformOutgoingURI.bind(C),this.transformOutgoingScheme=C.transformOutgoingScheme.bind(C)):(this.transformIncoming=i=>i,this.transformOutgoing=i=>i,this.transformOutgoingURI=i=>i,this.transformOutgoingScheme=i=>i)}}e.URITransformerService=L}),define(pe[203],ve([0,1,22]),function(Y,e,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.deserializeWebviewMessage=e.serializeWebviewMessage=void 0;class L{constructor(){this.buffers=[]}add(S){let D=this.buffers.indexOf(S);return D<0&&(D=this.buffers.length,this.buffers.push(S)),D}}function y(k,S){if(S.serializeBuffersForPostMessage){const D=new L,R=(E,f)=>{if(f instanceof ArrayBuffer){const v=D.add(f);return{$$vscode_array_buffer_reference$$:!0,index:v}}else if(ArrayBuffer.isView(f)){const v=C(f);if(v){const w=D.add(f.buffer);return{$$vscode_array_buffer_reference$$:!0,index:w,view:{type:v,byteLength:f.byteLength,byteOffset:f.byteOffset}}}}return f},P=JSON.stringify(k,R),u=D.buffers.map(E=>{const f=new Uint8Array(E);return m.VSBuffer.wrap(f)});return{message:P,buffers:u}}else return{message:JSON.stringify(k),buffers:[]}}e.serializeWebviewMessage=y;function C(k){switch(k.constructor.name){case"Int8Array":return 1;case"Uint8Array":return 2;case"Uint8ClampedArray":return 3;case"Int16Array":return 4;case"Uint16Array":return 5;case"Int32Array":return 6;case"Uint32Array":return 7;case"Float32Array":return 8;case"Float64Array":return 9;case"BigInt64Array":return 10;case"BigUint64Array":return 11}}function i(k,S){const D=S.map(u=>{const E=new ArrayBuffer(u.byteLength);return new Uint8Array(E).set(u.buffer),E}),R=S.length?(u,E)=>{if(typeof E=="object"&&E.$$vscode_array_buffer_reference$$){const f=E,{index:v}=f,w=D[v];if(f.view)switch(f.view.type){case 1:return new Int8Array(w,f.view.byteOffset,f.view.byteLength/Int8Array.BYTES_PER_ELEMENT);case 2:return new Uint8Array(w,f.view.byteOffset,f.view.byteLength/Uint8Array.BYTES_PER_ELEMENT);case 3:return new Uint8ClampedArray(w,f.view.byteOffset,f.view.byteLength/Uint8ClampedArray.BYTES_PER_ELEMENT);case 4:return new Int16Array(w,f.view.byteOffset,f.view.byteLength/Int16Array.BYTES_PER_ELEMENT);case 5:return new Uint16Array(w,f.view.byteOffset,f.view.byteLength/Uint16Array.BYTES_PER_ELEMENT);case 6:return new Int32Array(w,f.view.byteOffset,f.view.byteLength/Int32Array.BYTES_PER_ELEMENT);case 7:return new Uint32Array(w,f.view.byteOffset,f.view.byteLength/Uint32Array.BYTES_PER_ELEMENT);case 8:return new Float32Array(w,f.view.byteOffset,f.view.byteLength/Float32Array.BYTES_PER_ELEMENT);case 9:return new Float64Array(w,f.view.byteOffset,f.view.byteLength/Float64Array.BYTES_PER_ELEMENT);case 10:return new BigInt64Array(w,f.view.byteOffset,f.view.byteLength/BigInt64Array.BYTES_PER_ELEMENT);case 11:return new BigUint64Array(w,f.view.byteOffset,f.view.byteLength/BigUint64Array.BYTES_PER_ELEMENT);default:throw new Error("Unknown array buffer view type")}return w}return E}:void 0;return{message:JSON.parse(k,R),arrayBuffers:D}}e.deserializeWebviewMessage=i}),define(pe[204],ve([0,1]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TreeDataTransferConverter=void 0;var m;(function(L){function y(i){const k=new Map;return i.types.forEach((S,D)=>{k.set(S,{asString:async()=>i.items[D].asString})}),k}L.toITreeDataTransfer=y;async function C(i){const k={types:[],items:[]},S=Array.from(i.entries());for(const D of S)k.types.push(D[0]),k.items.push({asString:await D[1].asString()});return k}L.toTreeDataTransferDTO=C})(m=e.TreeDataTransferConverter||(e.TreeDataTransferConverter={}))}),define(pe[88],ve([0,1,10,2]),function(Y,e,m,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.decodeAuthority=e.asWebviewUri=e.webviewGenericCspSource=e.webviewRootResourceAuthority=e.webviewResourceBaseHost=void 0,e.webviewResourceBaseHost="vscode-webview.net",e.webviewRootResourceAuthority=`vscode-resource.${e.webviewResourceBaseHost}`,e.webviewGenericCspSource=`https://*.${e.webviewResourceBaseHost}`;function y(k,S){return k.scheme===m.Schemas.http||k.scheme===m.Schemas.https?k:(S&&S.authority&&S.isRemote&&k.scheme===m.Schemas.file&&(k=L.URI.from({scheme:m.Schemas.vscodeRemote,authority:S.authority,path:k.path})),L.URI.from({scheme:m.Schemas.https,authority:`${k.scheme}+${C(k.authority)}.${e.webviewRootResourceAuthority}`,path:k.path,fragment:k.fragment,query:k.query}))}e.asWebviewUri=y;function C(k){return k.replace(/./g,S=>{const D=S.charCodeAt(0);return D>=97&&D<=122||D>=65&&D<=90||D>=48&&D<=57?S:"-"+D.toString(16).padStart(4,"0")})}function i(k){return k.replace(/-([0-9a-f]{4})/g,(S,D)=>String.fromCharCode(parseInt(D,16)))}e.decodeAuthority=i}),define(pe[205],ve([0,1,3,6,88]),function(Y,e,m,L,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostEditorInsets=void 0;class C{constructor(k,S,D){this._proxy=k,this._editors=S,this._initData=D,this._handlePool=0,this._disposables=new L.DisposableStore,this._insets=new Map,this._disposables.add(S.onDidChangeVisibleTextEditors(()=>{const R=S.getVisibleTextEditors();for(const P of this._insets.values())R.indexOf(P.editor)<0&&P.inset.dispose()}))}dispose(){this._insets.forEach(k=>k.inset.dispose()),this._disposables.dispose()}createWebviewEditorInset(k,S,D,R,P){let u;for(const s of this._editors.getVisibleTextEditors(!0))if(s.value===k){u=s;break}if(!u)throw new Error("not a visible editor");const E=this,f=this._handlePool++,v=new m.Emitter,w=new m.Emitter,I=new class{constructor(){this._html="",this._options=Object.create(null)}asWebviewUri(s){return(0,y.asWebviewUri)(s,E._initData.remote)}get cspSource(){return y.webviewGenericCspSource}set options(s){this._options=s,E._proxy.$setOptions(f,s)}get options(){return this._options}set html(s){this._html=s,E._proxy.$setHtml(f,s)}get html(){return this._html}get onDidReceiveMessage(){return v.event}postMessage(s){return E._proxy.$postMessage(f,s)}},p=new class{constructor(){this.editor=k,this.line=S,this.height=D,this.webview=I,this.onDidDispose=w.event}dispose(){E._insets.has(f)&&(E._insets.delete(f),E._proxy.$disposeEditorInset(f),w.fire(),w.dispose(),v.dispose())}};return this._proxy.$createEditorInset(f,u.id,u.value.document.uri,S+1,D,R||{},P.identifier,P.extensionLocation),this._insets.set(f,{editor:k,inset:p,onDidReceiveMessage:v}),p}$onDidDispose(k){const S=this._insets.get(k);S&&S.inset.dispose()}$onDidReceiveMessage(k,S){const D=this._insets.get(k);D&&D.onDidReceiveMessage.fire(S)}}e.ExtHostEditorInsets=C}),define(pe[206],ve([0,1,171,13,2,6,4,61,51,42,16,10]),function(Y,e,m,L,y,C,i,k,S,D,R,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EditorsOrder=e.pathsToEditors=e.CloseDirection=e.EditorResourceAccessor=e.SideBySideEditor=e.EditorCloseContext=e.isEditorIdentifier=e.isEditorInputWithOptionsAndGroup=e.isEditorInputWithOptions=e.isDiffEditorInput=e.isSideBySideEditorInput=e.isEditorInput=e.AbstractEditorInput=e.EditorInputCapabilities=e.SaveReason=e.Verbosity=e.isUntitledResourceEditorInput=e.isResourceSideBySideEditorInput=e.isResourceDiffEditorInput=e.isResourceEditorInput=e.findViewStateForEditor=e.BINARY_DIFF_EDITOR_ID=e.TEXT_DIFF_EDITOR_ID=e.SIDE_BY_SIDE_EDITOR_ID=e.EditorAreaVisibleContext=e.SplitEditorsVertically=e.IsCenteredLayoutContext=e.InEditorZenModeContext=e.EditorsVisibleContext=e.SingleEditorGroupsContext=e.MultipleEditorGroupsContext=e.ActiveEditorGroupLockedContext=e.ActiveEditorGroupLastContext=e.ActiveEditorGroupIndexContext=e.ActiveEditorGroupEmptyContext=e.EditorGroupEditorsCountContext=e.SideBySideEditorActiveContext=e.TextCompareEditorActiveContext=e.TextCompareEditorVisibleContext=e.ActiveEditorAvailableEditorIdsContext=e.ActiveEditorContext=e.ActiveEditorCanSplitInGroupContext=e.ActiveEditorCanRevertContext=e.ActiveEditorReadonlyContext=e.ActiveEditorStickyContext=e.ActiveEditorPinnedContext=e.ActiveEditorDirtyContext=e.DEFAULT_EDITOR_ASSOCIATION=e.EditorExtensions=void 0,e.EditorExtensions={EditorPane:"workbench.contributions.editors",EditorFactory:"workbench.contributions.editor.inputFactories"},e.DEFAULT_EDITOR_ASSOCIATION={id:"default",displayName:(0,m.localize)(0,null),providerDisplayName:(0,m.localize)(1,null)},e.ActiveEditorDirtyContext=new k.RawContextKey("activeEditorIsDirty",!1,(0,m.localize)(2,null)),e.ActiveEditorPinnedContext=new k.RawContextKey("activeEditorIsNotPreview",!1,(0,m.localize)(3,null)),e.ActiveEditorStickyContext=new k.RawContextKey("activeEditorIsPinned",!1,(0,m.localize)(4,null)),e.ActiveEditorReadonlyContext=new k.RawContextKey("activeEditorIsReadonly",!1,(0,m.localize)(5,null)),e.ActiveEditorCanRevertContext=new k.RawContextKey("activeEditorCanRevert",!1,(0,m.localize)(6,null)),e.ActiveEditorCanSplitInGroupContext=new k.RawContextKey("activeEditorCanSplitInGroup",!0),e.ActiveEditorContext=new k.RawContextKey("activeEditor",null,{type:"string",description:(0,m.localize)(7,null)}),e.ActiveEditorAvailableEditorIdsContext=new k.RawContextKey("activeEditorAvailableEditorIds","",(0,m.localize)(8,null)),e.TextCompareEditorVisibleContext=new k.RawContextKey("textCompareEditorVisible",!1,(0,m.localize)(9,null)),e.TextCompareEditorActiveContext=new k.RawContextKey("textCompareEditorActive",!1,(0,m.localize)(10,null)),e.SideBySideEditorActiveContext=new k.RawContextKey("sideBySideEditorActive",!1,(0,m.localize)(11,null)),e.EditorGroupEditorsCountContext=new k.RawContextKey("groupEditorsCount",0,(0,m.localize)(12,null)),e.ActiveEditorGroupEmptyContext=new k.RawContextKey("activeEditorGroupEmpty",!1,(0,m.localize)(13,null)),e.ActiveEditorGroupIndexContext=new k.RawContextKey("activeEditorGroupIndex",0,(0,m.localize)(14,null)),e.ActiveEditorGroupLastContext=new k.RawContextKey("activeEditorGroupLast",!1,(0,m.localize)(15,null)),e.ActiveEditorGroupLockedContext=new k.RawContextKey("activeEditorGroupLocked",!1,(0,m.localize)(16,null)),e.MultipleEditorGroupsContext=new k.RawContextKey("multipleEditorGroups",!1,(0,m.localize)(17,null)),e.SingleEditorGroupsContext=e.MultipleEditorGroupsContext.toNegated(),e.EditorsVisibleContext=new k.RawContextKey("editorIsOpen",!1,(0,m.localize)(18,null)),e.InEditorZenModeContext=new k.RawContextKey("inZenMode",!1,(0,m.localize)(19,null)),e.IsCenteredLayoutContext=new k.RawContextKey("isCenteredLayout",!1,(0,m.localize)(20,null)),e.SplitEditorsVertically=new k.RawContextKey("splitEditorsVertically",!1,(0,m.localize)(21,null)),e.EditorAreaVisibleContext=new k.RawContextKey("editorAreaVisible",!0,(0,m.localize)(22,null)),e.SIDE_BY_SIDE_EDITOR_ID="workbench.editor.sidebysideEditor",e.TEXT_DIFF_EDITOR_ID="workbench.editors.textDiffEditor",e.BINARY_DIFF_EDITOR_ID="workbench.editors.binaryResourceDiffEditor";function u(O,F,W){for(const M of W.visibleEditorPanes)if(M.group.id===F&&O.matches(M.input))return M.getViewState()}e.findViewStateForEditor=u;function E(O){if(g(O))return!1;const F=O;return y.URI.isUri(F?.resource)}e.isResourceEditorInput=E;function f(O){if(g(O))return!1;const F=O;return F?.original!==void 0&&F.modified!==void 0}e.isResourceDiffEditorInput=f;function v(O){if(g(O)||f(O))return!1;const F=O;return F?.primary!==void 0&&F.secondary!==void 0}e.isResourceSideBySideEditorInput=v;function w(O){if(g(O))return!1;const F=O;return F?F.resource===void 0||F.resource.scheme===P.Schemas.untitled||F.forceUntitled===!0:!1}e.isUntitledResourceEditorInput=w;var I;(function(O){O[O.SHORT=0]="SHORT",O[O.MEDIUM=1]="MEDIUM",O[O.LONG=2]="LONG"})(I=e.Verbosity||(e.Verbosity={}));var p;(function(O){O[O.EXPLICIT=1]="EXPLICIT",O[O.AUTO=2]="AUTO",O[O.FOCUS_CHANGE=3]="FOCUS_CHANGE",O[O.WINDOW_CHANGE=4]="WINDOW_CHANGE"})(p=e.SaveReason||(e.SaveReason={}));var s;(function(O){O[O.None=0]="None",O[O.Readonly=2]="Readonly",O[O.Untitled=4]="Untitled",O[O.Singleton=8]="Singleton",O[O.RequiresTrust=16]="RequiresTrust",O[O.CanSplitInGroup=32]="CanSplitInGroup",O[O.ForceDescription=64]="ForceDescription"})(s=e.EditorInputCapabilities||(e.EditorInputCapabilities={}));class r extends C.Disposable{}e.AbstractEditorInput=r;function g(O){return O instanceof r}e.isEditorInput=g;function a(O){const F=O;return y.URI.isUri(F?.preferredResource)}function _(O){const F=O;return g(F?.primary)&&g(F?.secondary)}e.isSideBySideEditorInput=_;function n(O){const F=O;return g(F?.modified)&&g(F?.original)}e.isDiffEditorInput=n;function t(O){return g(O?.editor)}e.isEditorInputWithOptions=t;function o(O){const F=O;return t(O)&&F?.group!==void 0}e.isEditorInputWithOptionsAndGroup=o;function d(O){const F=O;return typeof F?.groupId=="number"&&g(F.editor)}e.isEditorIdentifier=d;var c;(function(O){O[O.UNKNOWN=0]="UNKNOWN",O[O.REPLACE=1]="REPLACE",O[O.MOVE=2]="MOVE",O[O.UNPIN=3]="UNPIN"})(c=e.EditorCloseContext||(e.EditorCloseContext={}));var h;(function(O){O[O.PRIMARY=1]="PRIMARY",O[O.SECONDARY=2]="SECONDARY",O[O.BOTH=3]="BOTH",O[O.ANY=4]="ANY"})(h=e.SideBySideEditor||(e.SideBySideEditor={}));class l{getOriginalUri(F,W){if(!F)return;if(W?.supportSideBySide){const{primary:B,secondary:U}=this.getSideEditors(F);if(B&&U){if(W?.supportSideBySide===h.BOTH)return{primary:this.getOriginalUri(B,{filterByScheme:W.filterByScheme}),secondary:this.getOriginalUri(U,{filterByScheme:W.filterByScheme})};if(W?.supportSideBySide===h.ANY)return this.getOriginalUri(B,{filterByScheme:W.filterByScheme})??this.getOriginalUri(U,{filterByScheme:W.filterByScheme});F=W.supportSideBySide===h.PRIMARY?B:U}}if(f(F)||v(F))return;const M=a(F)?F.preferredResource:F.resource;return!M||!W||!W.filterByScheme?M:this.filterUri(M,W.filterByScheme)}getSideEditors(F){return _(F)||v(F)?{primary:F.primary,secondary:F.secondary}:n(F)||f(F)?{primary:F.modified,secondary:F.original}:{primary:void 0,secondary:void 0}}getCanonicalUri(F,W){if(!F)return;if(W?.supportSideBySide){const{primary:B,secondary:U}=this.getSideEditors(F);if(B&&U){if(W?.supportSideBySide===h.BOTH)return{primary:this.getCanonicalUri(B,{filterByScheme:W.filterByScheme}),secondary:this.getCanonicalUri(U,{filterByScheme:W.filterByScheme})};if(W?.supportSideBySide===h.ANY)return this.getCanonicalUri(B,{filterByScheme:W.filterByScheme})??this.getCanonicalUri(U,{filterByScheme:W.filterByScheme});F=W.supportSideBySide===h.PRIMARY?B:U}}if(f(F)||v(F))return;const M=F.resource;return!M||!W||!W.filterByScheme?M:this.filterUri(M,W.filterByScheme)}filterUri(F,W){if(Array.isArray(W)){if(W.some(M=>F.scheme===M))return F}else if(W===F.scheme)return F}}e.EditorResourceAccessor=new l;var b;(function(O){O[O.LEFT=0]="LEFT",O[O.RIGHT=1]="RIGHT"})(b=e.CloseDirection||(e.CloseDirection={}));class T{constructor(){this.editorSerializerConstructors=new Map,this.editorSerializerInstances=new Map}start(F){const W=this.instantiationService=F.get(i.IInstantiationService);for(const[M,B]of this.editorSerializerConstructors)this.createEditorSerializer(M,B,W);this.editorSerializerConstructors.clear()}createEditorSerializer(F,W,M){const B=M.createInstance(W);this.editorSerializerInstances.set(F,B)}registerFileEditorFactory(F){if(this.fileEditorFactory)throw new Error("Can only register one file editor factory.");this.fileEditorFactory=F}getFileEditorFactory(){return(0,L.assertIsDefined)(this.fileEditorFactory)}registerEditorSerializer(F,W){if(this.editorSerializerConstructors.has(F)||this.editorSerializerInstances.has(F))throw new Error(`A editor serializer with type ID '${F}' was already registered.`);return this.instantiationService?this.createEditorSerializer(F,W,this.instantiationService):this.editorSerializerConstructors.set(F,W),(0,C.toDisposable)(()=>{this.editorSerializerConstructors.delete(F),this.editorSerializerInstances.delete(F)})}getEditorSerializer(F){return this.editorSerializerInstances.get(typeof F=="string"?F:F.typeId)}}S.Registry.add(e.EditorExtensions.EditorFactory,new T);async function A(O,F){if(!O||!O.length)return[];const W=await Promise.all(O.map(async M=>{const B=y.URI.revive(M.fileUri);if(!B||!await F.canHandleResource(B))return;let z=M.exists,K=M.type;if(typeof z!="boolean"||typeof K!="number")try{K=(await F.resolve(B)).isDirectory?D.FileType.Directory:D.FileType.Unknown,z=!0}catch{z=!1}if(!z&&M.openOnlyIfExists||K===D.FileType.Directory)return;const N={selection:z?M.selection:void 0,pinned:!0,override:M.editorOverrideId};let j;return z?j={resource:B,options:N}:j={resource:B,options:N,forceUntitled:!0},j}));return(0,R.coalesce)(W)}e.pathsToEditors=A;var x;(function(O){O[O.MOST_RECENTLY_ACTIVE=0]="MOST_RECENTLY_ACTIVE",O[O.SEQUENTIAL=1]="SEQUENTIAL"})(x=e.EditorsOrder||(e.EditorsOrder={}))}),define(pe[123],ve([0,1,3,18,172]),function(Y,e,m,L,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractDebugAdapter=void 0;class C{constructor(){this.pendingRequests=new Map,this.queue=[],this._onError=new m.Emitter,this._onExit=new m.Emitter,this.sequence=1}get onError(){return this._onError.event}get onExit(){return this._onExit.event}onMessage(k){this.messageCallback&&this._onError.fire(new Error("attempt to set more than one 'Message' callback")),this.messageCallback=k}onEvent(k){this.eventCallback&&this._onError.fire(new Error("attempt to set more than one 'Event' callback")),this.eventCallback=k}onRequest(k){this.requestCallback&&this._onError.fire(new Error("attempt to set more than one 'Request' callback")),this.requestCallback=k}sendResponse(k){k.seq>0?this._onError.fire(new Error(`attempt to send more than one response for command ${k.command}`)):this.internalSend("response",k)}sendRequest(k,S,D,R){const P={command:k};if(S&&Object.keys(S).length>0&&(P.arguments=S),this.internalSend("request",P),typeof R=="number"){const u=setTimeout(()=>{clearTimeout(u);const E=this.pendingRequests.get(P.seq);if(E){this.pendingRequests.delete(P.seq);const f={type:"response",seq:0,request_seq:P.seq,success:!1,command:k,message:(0,y.localize)(0,null,R,k)};E(f)}},R)}return D&&this.pendingRequests.set(P.seq,D),P.seq}acceptMessage(k){this.messageCallback?this.messageCallback(k):(this.queue.push(k),this.queue.length===1&&this.processQueue())}needsTaskBoundaryBetween(k,S){return k.type!=="event"||S.type!=="event"}async processQueue(){let k;for(;this.queue.length;){if((!k||this.needsTaskBoundaryBetween(this.queue[0],k))&&await(0,L.timeout)(0),k=this.queue.shift(),!k)return;switch(k.type){case"event":this.eventCallback&&this.eventCallback(k);break;case"request":this.requestCallback&&this.requestCallback(k);break;case"response":const S=k,D=this.pendingRequests.get(S.request_seq);D&&(this.pendingRequests.delete(S.request_seq),D(S));break}}}internalSend(k,S){S.type=k,S.seq=this.sequence++,this.sendMessage(S)}async cancelPendingRequests(){if(this.pendingRequests.size===0)return Promise.resolve();const k=new Map;this.pendingRequests.forEach((S,D)=>k.set(D,S)),await(0,L.timeout)(500),k.forEach((S,D)=>{S({type:"response",seq:0,request_seq:D,success:!1,command:"canceled",message:"canceled"}),this.pendingRequests.delete(D)})}getPendingRequestIds(){return Array.from(this.pendingRequests.keys())}dispose(){this.queue=[]}}e.AbstractDebugAdapter=C}),define(pe[207],ve([0,1,8,2,9,25,10]),function(Y,e,m,L,y,C,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.saveAllBeforeDebugStart=e.getVisibleAndSorted=e.convertToVSCPaths=e.convertToDAPaths=e.isUri=e.getExactExpressionStartAndEnd=e.isDebuggerMainContribution=e.getExtensionHostDebugSession=e.isSessionAttach=e.filterExceptionsFromTelemetry=e.formatPII=void 0;const k=/{([^}]+)}/g;function S(n,t,o){return n.replace(k,function(d,c){return t&&c.length>0&&c[0]!=="_"?d:o&&o.hasOwnProperty(c)?o[c]:d})}e.formatPII=S;function D(n){const t={};for(const o of Object.keys(n))o.startsWith("!")||(t[o]=n[o]);return t}e.filterExceptionsFromTelemetry=D;function R(n){return n.configuration.request==="attach"&&!P(n)&&(!n.parentSession||R(n.parentSession))}e.isSessionAttach=R;function P(n){let t=n.configuration.type;if(!!t)return t==="vslsShare"&&(t=n.configuration.adapterProxy.configuration.type),(0,m.equalsIgnoreCase)(t,"extensionhost")||(0,m.equalsIgnoreCase)(t,"pwa-extensionhost")?n:n.parentSession?P(n.parentSession):void 0}e.getExtensionHostDebugSession=P;function u(n){return n.type&&(n.label||n.program||n.runtime)}e.isDebuggerMainContribution=u;function E(n,t,o){let d,c=0,h=/([^()\[\]{}<>\s+\-/%~#^;=|,`!]|\->)+/g,l=null;for(;l=h.exec(n);){let b=l.index+1,T=b+l[0].length;if(b<=t&&T>=o){d=l[0],c=b;break}}if(d){let b=/\w+/g,T=null;for(;(T=b.exec(d))&&!(T.index+1+c+T[0].length>=o););T&&(d=d.substring(0,b.lastIndex))}return d?{start:c,end:c+d.length-1}:{start:0,end:0}}e.getExactExpressionStartAndEnd=E;const f=/^[a-zA-Z][a-zA-Z0-9\+\-\.]+:/;function v(n){return!!(n&&n.match(f))}e.isUri=v;function w(n){if(typeof n.path=="string"&&!(typeof n.sourceReference=="number"&&n.sourceReference>0)){if(v(n.path))return L.URI.parse(n.path);if((0,y.isAbsolute)(n.path))return L.URI.file(n.path)}return n.path}function I(n){if(typeof n.path=="object"){const t=L.URI.revive(n.path);if(t)return t.scheme===i.Schemas.file?t.fsPath:t.toString()}return n.path}function p(n,t){const o=t?w:I,d=(0,C.deepClone)(n);return r(d,(c,h)=>{c&&h&&(h.path=o(h))}),d}e.convertToDAPaths=p;function s(n,t){const o=t?w:I,d=(0,C.deepClone)(n);return r(d,(c,h)=>{!c&&h&&(h.path=o(h))}),d}e.convertToVSCPaths=s;function r(n,t){switch(n.type){case"event":const o=n;switch(o.event){case"output":t(!1,o.body.source);break;case"loadedSource":t(!1,o.body.source);break;case"breakpoint":t(!1,o.body.breakpoint.source);break;default:break}break;case"request":const d=n;switch(d.command){case"setBreakpoints":t(!0,d.arguments.source);break;case"breakpointLocations":t(!0,d.arguments.source);break;case"source":t(!0,d.arguments.source);break;case"gotoTargets":t(!0,d.arguments.source);break;case"launchVSCode":d.arguments.args.forEach(h=>t(!1,h));break;default:break}break;case"response":const c=n;if(c.success&&c.body)switch(c.command){case"stackTrace":c.body.stackFrames.forEach(h=>t(!1,h.source));break;case"loadedSources":c.body.sources.forEach(h=>t(!1,h));break;case"scopes":c.body.scopes.forEach(h=>t(!1,h.source));break;case"setFunctionBreakpoints":c.body.breakpoints.forEach(h=>t(!1,h.source));break;case"setBreakpoints":c.body.breakpoints.forEach(h=>t(!1,h.source));break;default:break}break}}function g(n){return n.filter(t=>!t.presentation?.hidden).sort((t,o)=>t.presentation?o.presentation?t.presentation.group?o.presentation.group?t.presentation.group!==o.presentation.group?t.presentation.group.localeCompare(o.presentation.group):a(t.presentation.order,o.presentation.order):-1:o.presentation.group?1:a(t.presentation.order,o.presentation.order):-1:o.presentation?1:0)}e.getVisibleAndSorted=g;function a(n,t){return typeof n!="number"?typeof t!="number"?0:1:typeof t!="number"?-1:n-t}async function _(n,t){const o=n.getValue("debug.saveBeforeStart",{overrideIdentifier:t.activeTextEditorMode});if(o!=="none"&&(await t.saveAll(),o==="allEditorsInActiveGroup")){const d=t.activeEditorPane;d&&await t.save({editor:d.input,groupId:d.group.id})}await n.reloadConfiguration()}e.saveAllBeforeDebugStart=_}),define(pe[208],ve([0,1,28,37,173,124,9,8,25,12,183,123]),function(Y,e,m,L,y,C,i,k,S,D,R,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExecutableDebugAdapter=e.NamedPipeDebugAdapter=e.SocketDebugAdapter=e.NetworkDebugAdapter=e.StreamDebugAdapter=void 0;class u extends P.AbstractDebugAdapter{constructor(){super();this.rawData=Buffer.allocUnsafe(0),this.contentLength=-1}connect(p,s){this.outputStream=s,this.rawData=Buffer.allocUnsafe(0),this.contentLength=-1,p.on("data",r=>this.handleData(r))}sendMessage(p){if(this.outputStream){const s=JSON.stringify(p);this.outputStream.write(`Content-Length: ${Buffer.byteLength(s,"utf8")}${u.TWO_CRLF}${s}`,"utf8")}}handleData(p){for(this.rawData=Buffer.concat([this.rawData,p]);;){if(this.contentLength>=0){if(this.rawData.length>=this.contentLength){const s=this.rawData.toString("utf8",0,this.contentLength);if(this.rawData=this.rawData.slice(this.contentLength),this.contentLength=-1,s.length>0)try{this.acceptMessage(JSON.parse(s))}catch(r){this._onError.fire(new Error((r.message||r)+`
`+s))}continue}}else{const s=this.rawData.indexOf(u.TWO_CRLF);if(s!==-1){const g=this.rawData.toString("utf8",0,s).split(u.HEADER_LINESEPARATOR);for(const a of g){const _=a.split(u.HEADER_FIELDSEPARATOR);_[0]==="Content-Length"&&(this.contentLength=Number(_[1]))}this.rawData=this.rawData.slice(s+u.TWO_CRLF.length);continue}}break}}}e.StreamDebugAdapter=u,u.TWO_CRLF=`\r
\r
`,u.HEADER_LINESEPARATOR=/\r?\n/,u.HEADER_FIELDSEPARATOR=/: */;class E extends u{startSession(){return new Promise((p,s)=>{let r=!1;this.socket=this.createConnection(()=>{this.connect(this.socket,this.socket),p(),r=!0}),this.socket.on("close",()=>{r?this._onError.fire(new Error("connection closed")):s(new Error("connection closed"))}),this.socket.on("error",g=>{r?this._onError.fire(g):s(g)})})}async stopSession(){await this.cancelPendingRequests(),this.socket&&(this.socket.end(),this.socket=void 0)}}e.NetworkDebugAdapter=E;class f extends E{constructor(p){super();this.adapterServer=p}createConnection(p){return C.createConnection(this.adapterServer.port,this.adapterServer.host||"127.0.0.1",p)}}e.SocketDebugAdapter=f;class v extends E{constructor(p){super();this.adapterServer=p}createConnection(p){return C.createConnection(this.adapterServer.path,p)}}e.NamedPipeDebugAdapter=v;class w extends u{constructor(p,s,r){super();this.adapterExecutable=p,this.debugType=s,this.outputService=r}async startSession(){const p=this.adapterExecutable.command,s=this.adapterExecutable.args,r=this.adapterExecutable.options||{};try{if(p)if(i.isAbsolute(p)){if(!await m.Promises.exists(p))throw new Error(y.localize(0,null,p))}else p.indexOf("/")<0&&p.indexOf("\\")<0;else throw new Error(y.localize(1,null,this.debugType));let g=process.env;if(r.env&&Object.keys(r.env).length>0&&(g=S.mixin(S.deepClone(process.env),r.env)),p==="node")if(Array.isArray(s)&&s.length>0){const _=!!process.env.ELECTRON_RUN_AS_NODE||!!process.versions.electron,n={env:g,execArgv:_?["-e","delete process.env.ELECTRON_RUN_AS_NODE;require(process.argv[1])"]:[],silent:!0};r.cwd&&(n.cwd=r.cwd);const t=L.fork(s[0],s.slice(1),n);if(!t.pid)throw new Error(y.localize(2,null,s[0]));this.serverProcess=t}else throw new Error(y.localize(3,null));else{const _={env:g};r.cwd&&(_.cwd=r.cwd),this.serverProcess=L.spawn(p,s,_)}this.serverProcess.on("error",_=>{this._onError.fire(_)}),this.serverProcess.on("exit",(_,n)=>{this._onExit.fire(_)}),this.serverProcess.stdout.on("close",()=>{this._onError.fire(new Error("read error"))}),this.serverProcess.stdout.on("error",_=>{this._onError.fire(_)}),this.serverProcess.stdin.on("error",_=>{this._onError.fire(_)});const a=this.outputService;if(a){const _=n=>n.toString().replace(/\r?\n$/mg,"");this.serverProcess.stderr.on("data",n=>{const t=a.getChannel(R.ExtensionsChannelId);t&&t.append(_(n))})}else this.serverProcess.stderr.resume();this.connect(this.serverProcess.stdout,this.serverProcess.stdin)}catch(g){this._onError.fire(g)}}async stopSession(){return this.serverProcess?(await this.cancelPendingRequests(),D.isWindows?new Promise((p,s)=>{const r=L.exec(`taskkill /F /T /PID ${this.serverProcess.pid}`,function(g,a,_){if(g)return s(g)});r.on("exit",p),r.on("error",s)}):(this.serverProcess.kill("SIGTERM"),Promise.resolve(void 0))):Promise.resolve(void 0)}static extract(p,s){if(!p)return;const r=Object.create(null);p.runtime&&(p.runtime.indexOf("./")===0?r.runtime=i.join(s,p.runtime):r.runtime=p.runtime),p.runtimeArgs&&(r.runtimeArgs=p.runtimeArgs),p.program&&(i.isAbsolute(p.program)?r.program=p.program:r.program=i.join(s,p.program)),p.args&&(r.args=p.args);const g=p;return g.win&&(r.win=w.extract(g.win,s)),g.winx86&&(r.winx86=w.extract(g.winx86,s)),g.windows&&(r.windows=w.extract(g.windows,s)),g.osx&&(r.osx=w.extract(g.osx,s)),g.linux&&(r.linux=w.extract(g.linux,s)),r}static platformAdapterExecutable(p,s){let r=Object.create(null);s=s.toLowerCase();for(const o of p)if(o.contributes){const d=o.contributes.debuggers;d&&d.length>0&&d.filter(c=>typeof c.type=="string"&&k.equalsIgnoreCase(c.type,s)).forEach(c=>{const h=w.extract(c,o.extensionLocation.fsPath);r=S.mixin(r,h,o.isBuiltin)})}let g;D.isWindows&&!process.env.hasOwnProperty("PROCESSOR_ARCHITEW6432")?g=r.winx86||r.win||r.windows:D.isWindows?g=r.win||r.windows:D.isMacintosh?g=r.osx:D.isLinux&&(g=r.linux),g=g||r;let a=g.program||r.program;const _=g.args||r.args;let n=g.runtime||r.runtime;const t=g.runtimeArgs||r.runtimeArgs;if(n)return{type:"executable",command:n,args:(t||[]).concat(typeof a=="string"?[a]:[]).concat(_||[])};if(a)return{type:"executable",command:a,args:_||[]}}}e.ExecutableDebugAdapter=w}),define(pe[209],ve([0,1,37,12,30,185]),function(Y,e,m,L,y,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.prepareCommand=e.hasChildProcesses=e.runInExternalTerminal=void 0;function i(u,E){return new Promise((f,v)=>{let w="";const I=m.spawn(u,E);I.pid&&I.stdout.on("data",p=>{w+=p.toString()}),I.on("error",p=>{v(p)}),I.on("close",p=>{f(w)})})}let k;function S(u,E){if(!k)if(L.isWindows)k=new C.WindowsExternalTerminalService;else if(L.isMacintosh)k=new C.MacExternalTerminalService;else if(L.isLinux)k=new C.LinuxExternalTerminalService;else throw new Error("external terminals not supported on this platform");const f=E.getConfiguration("terminal");return k.runInTerminal(u.title,u.cwd,u.args,u.env||{},f.external||{})}e.runInExternalTerminal=S;async function D(u){if(u)if(L.isWindows){const E=await new Promise((f,v)=>{Y(["windows-process-tree"],f,v)});return new Promise(f=>{E.getProcessTree(u,v=>{f(v.children.length>0)})})}else return i("/usr/bin/pgrep",["-lP",String(u)]).then(E=>{const f=E.trim();return!(f.length===0||f.indexOf(" tmux")>=0)},E=>!0);return Promise.resolve(!0)}e.hasChildProcesses=D;var R;(function(u){u[u.cmd=0]="cmd",u[u.powershell=1]="powershell",u[u.bash=2]="bash"})(R||(R={}));function P(u,E,f,v){u=u.trim().toLowerCase();let w;u.indexOf("powershell")>=0||u.indexOf("pwsh")>=0?w=1:u.indexOf("cmd.exe")>=0?w=0:u.indexOf("bash")>=0?w=2:L.isWindows?w=0:w=2;let I,p=" ";switch(w){case 1:if(I=r=>(r=r.replace(/\'/g,"''"),r.length>0&&r.charAt(r.length-1)==="\\"?`'${r}\\'`:`'${r}'`),f){const r=(0,y.getDriveLetter)(f);r&&(p+=`${r}:; `),p+=`cd ${I(f)}; `}if(v)for(let r in v){const g=v[r];g===null?p+=`Remove-Item env:${r}; `:p+=`\${env:${r}}='${g}'; `}if(E.length>0){const r=I(E.shift());p+=r[0]==="'"?`& ${r} `:`${r} `;for(let g of E)p+=`${I(g)} `}break;case 0:if(I=r=>(r=r.replace(/\"/g,'""'),r.indexOf(" ")>=0||r.indexOf('"')>=0||r.length===0?`"${r}"`:r),f){const r=(0,y.getDriveLetter)(f);r&&(p+=`${r}: && `),p+=`cd ${I(f)} && `}if(v){p+='cmd /C "';for(let r in v){let g=v[r];g===null?p+=`set "${r}=" && `:(g=g.replace(/[\^\&\|\<\>]/g,a=>`^${a}`),p+=`set "${r}=${g}" && `)}}for(let r of E)p+=`${I(r)} `;v&&(p+='"');break;case 2:I=r=>(r=r.replace(/(["'\\\$])/g,"\\$1"),r.indexOf(" ")>=0||r.indexOf(";")>=0||r.length===0?`"${r}"`:r);const s=r=>/[^\w@%\/+=,.:^-]/.test(r)?`'${r.replace(/'/g,"'\\''")}'`:r;if(f&&(p+=`cd ${I(f)} ; `),v){p+="/usr/bin/env";for(let r in v){const g=v[r];g===null?p+=` -u ${s(r)}`:p+=` ${s(`${r}=${g}`)}`}p+=" "}for(let r of E)p+=`${I(r)} `;break}return p}e.prepareCommand=P}),define(pe[125],ve([0,1,31,76,101,10,9,12,61]),function(Y,e,m,L,y,C,i,k,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NotebookWorkingCopyTypeIdentifier=e.CellStatusbarAlignment=e.NotebookSetting=e.CellSequence=e.notebookDocumentFilterMatch=e.isDocumentExcludePattern=e.NotebookEditorPriority=e.NOTEBOOK_EDITOR_CURSOR_BOUNDARY=e.diff=e.MimeTypeDisplayOrder=e.mimeTypeIsMergeable=e.mimeTypeSupportedByCore=e.mimeTypeIsAlwaysSecure=e.CellUri=e.CellEditType=e.SelectionStateType=e.NotebookCellsChangeType=e.RendererMessagingSpec=e.NotebookRendererMatch=e.NotebookCellExecutionState=e.NotebookRunState=e.RENDERER_NOT_AVAILABLE=e.BUILTIN_RENDERER_ID=e.RENDERER_EQUIVALENT_EXTENSIONS=e.ACCESSIBLE_NOTEBOOK_DISPLAY_ORDER=e.NOTEBOOK_DISPLAY_ORDER=e.CellKind=void 0;var D;(function(b){b[b.Markup=1]="Markup",b[b.Code=2]="Code"})(D=e.CellKind||(e.CellKind={})),e.NOTEBOOK_DISPLAY_ORDER=["application/json","application/javascript","text/html","image/svg+xml",y.Mimes.latex,y.Mimes.markdown,"image/png","image/jpeg",y.Mimes.text],e.ACCESSIBLE_NOTEBOOK_DISPLAY_ORDER=[y.Mimes.latex,y.Mimes.markdown,"application/json",y.Mimes.text,"text/html","image/svg+xml","image/png","image/jpeg"],e.RENDERER_EQUIVALENT_EXTENSIONS=new Map([["ms-toolsai.jupyter",new Set(["jupyter-notebook","interactive"])],["ms-toolsai.jupyter-renderers",new Set(["jupyter-notebook","interactive"])]]),e.BUILTIN_RENDERER_ID="_builtin",e.RENDERER_NOT_AVAILABLE="_notAvailable";var R;(function(b){b[b.Running=1]="Running",b[b.Idle=2]="Idle"})(R=e.NotebookRunState||(e.NotebookRunState={}));var P;(function(b){b[b.Pending=2]="Pending",b[b.Executing=3]="Executing"})(P=e.NotebookCellExecutionState||(e.NotebookCellExecutionState={}));var u;(function(b){b[b.WithHardKernelDependency=0]="WithHardKernelDependency",b[b.WithOptionalKernelDependency=1]="WithOptionalKernelDependency",b[b.Pure=2]="Pure",b[b.Never=3]="Never"})(u=e.NotebookRendererMatch||(e.NotebookRendererMatch={}));var E;(function(b){b.Always="always",b.Never="never",b.Optional="optional"})(E=e.RendererMessagingSpec||(e.RendererMessagingSpec={}));var f;(function(b){b[b.ModelChange=1]="ModelChange",b[b.Move=2]="Move",b[b.ChangeLanguage=5]="ChangeLanguage",b[b.Initialize=6]="Initialize",b[b.ChangeCellMetadata=7]="ChangeCellMetadata",b[b.Output=8]="Output",b[b.OutputItem=9]="OutputItem",b[b.ChangeCellContent=10]="ChangeCellContent",b[b.ChangeDocumentMetadata=11]="ChangeDocumentMetadata",b[b.ChangeCellInternalMetadata=12]="ChangeCellInternalMetadata",b[b.ChangeCellMime=13]="ChangeCellMime",b[b.Unknown=100]="Unknown"})(f=e.NotebookCellsChangeType||(e.NotebookCellsChangeType={}));var v;(function(b){b[b.Handle=0]="Handle",b[b.Index=1]="Index"})(v=e.SelectionStateType||(e.SelectionStateType={}));var w;(function(b){b[b.Replace=1]="Replace",b[b.Output=2]="Output",b[b.Metadata=3]="Metadata",b[b.CellLanguage=4]="CellLanguage",b[b.DocumentMetadata=5]="DocumentMetadata",b[b.Move=6]="Move",b[b.OutputItems=7]="OutputItems",b[b.PartialMetadata=8]="PartialMetadata",b[b.PartialInternalMetadata=9]="PartialInternalMetadata"})(w=e.CellEditType||(e.CellEditType={}));var I;(function(b){b.scheme=C.Schemas.vscodeNotebookCell;const T=/^ch(\d{7,})/;function A(B,U){return B.with({scheme:b.scheme,fragment:`ch${U.toString().padStart(7,"0")}${B.scheme!==C.Schemas.file?B.scheme:""}`})}b.generate=A;function x(B){if(B.scheme!==b.scheme)return;const U=T.exec(B.fragment);return U?{handle:Number(U[1]),notebook:B.with({scheme:B.fragment.substr(U[0].length)||C.Schemas.file,fragment:null})}:void 0}b.parse=x;function O(B,U,z){return B.with({scheme:C.Schemas.vscodeNotebookCellOutput,fragment:`ch${U.toString().padStart(7,"0")},${z??""},${B.scheme!==C.Schemas.file?B.scheme:""}`})}b.generateCellOutputUri=O;function F(B){if(B.scheme!==C.Schemas.vscodeNotebookCellOutput)return;const U=/^ch(\d{7,})\,([0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12})?\,(.*)$/i.exec(B.fragment);if(!U)return;const z=Number(U[1]),K=U[2]&&U[2]!==""?U[2]:void 0,N=U[3];return{handle:z,outputId:K,notebook:B.with({scheme:N||C.Schemas.file,fragment:null})}}b.parseCellOutputUri=F;function W(B,U,z){return B.with({scheme:z,fragment:`ch${U.toString().padStart(7,"0")}${B.scheme!==C.Schemas.file?B.scheme:""}`})}b.generateCellUri=W;function M(B,U){if(B.scheme!==U)return;const z=T.exec(B.fragment);return z?{handle:Number(z[1]),notebook:B.with({scheme:B.fragment.substr(z[0].length)||C.Schemas.file,fragment:null})}:void 0}b.parseCellUri=M})(I=e.CellUri||(e.CellUri={}));const p=new Map([["application/javascript",{supportedByCore:!0}],["image/png",{alwaysSecure:!0,supportedByCore:!0}],["image/jpeg",{alwaysSecure:!0,supportedByCore:!0}],["image/git",{alwaysSecure:!0,supportedByCore:!0}],["image/svg+xml",{supportedByCore:!0}],["application/json",{alwaysSecure:!0,supportedByCore:!0}],[y.Mimes.latex,{alwaysSecure:!0,supportedByCore:!0}],[y.Mimes.text,{alwaysSecure:!0,supportedByCore:!0}],["text/html",{supportedByCore:!0}],["text/x-javascript",{alwaysSecure:!0,supportedByCore:!0}],["application/vnd.code.notebook.error",{alwaysSecure:!0,supportedByCore:!0}],["application/vnd.code.notebook.stdout",{alwaysSecure:!0,supportedByCore:!0,mergeable:!0}],["application/vnd.code.notebook.stderr",{alwaysSecure:!0,supportedByCore:!0,mergeable:!0}]]);function s(b){return p.get(b)?.alwaysSecure??!1}e.mimeTypeIsAlwaysSecure=s;function r(b){return p.get(b)?.supportedByCore??!1}e.mimeTypeSupportedByCore=r;function g(b){return p.get(b)?.mergeable??!1}e.mimeTypeIsMergeable=g;const a=b=>k.isWindows?b.replace(/\//g,"\\"):b;class _{constructor(T=[],A=e.NOTEBOOK_DISPLAY_ORDER){this.defaultOrder=A,this.order=[...new Set(T)].map(x=>({pattern:x,matches:m.parse(a(x))}))}sort(T){const A=new Map(L.Iterable.map(T,O=>[O,a(O)]));let x=[];for(const{matches:O}of this.order)for(const[F,W]of A)if(O(W)){x.push(F),A.delete(F);break}return A.size&&(x=x.concat([...A.keys()].sort((O,F)=>this.defaultOrder.indexOf(O)-this.defaultOrder.indexOf(F)))),x}prioritize(T,A){const x=this.findIndex(T);if(x===-1){this.order.unshift({pattern:T,matches:m.parse(a(T))});return}const O=new Set(A.map(W=>this.findIndex(W,x)));O.delete(-1);const F=Array.from(O).sort();this.order.splice(x+1,0,...F.map(W=>this.order[W]));for(let W=F.length-1;W>=0;W--)this.order.splice(F[W],1)}toArray(){return this.order.map(T=>T.pattern)}findIndex(T,A=this.order.length){const x=a(T);for(let O=0;O<A;O++)if(this.order[O].matches(x))return O;return-1}}e.MimeTypeDisplayOrder=_;function n(b,T,A,x=(O,F)=>O===F){const O=[];function F(B,U,z){if(U===0&&z.length===0)return;const K=O[O.length-1];K&&K.start+K.deleteCount===B?(K.deleteCount+=U,K.toInsert.push(...z)):O.push({start:B,deleteCount:U,toInsert:z})}let W=0,M=0;for(;;){if(W===b.length){F(W,0,T.slice(M));break}if(M===T.length){F(W,b.length-W,[]);break}const B=b[W],U=T[M];if(x(B,U)){W+=1,M+=1;continue}A(U)?(F(W,1,[]),W+=1):(F(W,0,[U]),M+=1)}return O}e.diff=n,e.NOTEBOOK_EDITOR_CURSOR_BOUNDARY=new S.RawContextKey("notebookEditorCursorAtBoundary","none");var t;(function(b){b.default="default",b.option="option"})(t=e.NotebookEditorPriority||(e.NotebookEditorPriority={}));function o(b){const T=b;return!!((typeof T.include=="string"||m.isRelativePattern(T.include))&&(typeof T.exclude=="string"||m.isRelativePattern(T.exclude)))}e.isDocumentExcludePattern=o;function d(b,T,A){if(Array.isArray(b.viewType)&&b.viewType.indexOf(T)>=0||b.viewType===T)return!0;if(b.filenamePattern){let x=o(b.filenamePattern)?b.filenamePattern.include:b.filenamePattern,O=o(b.filenamePattern)?b.filenamePattern.exclude:void 0;if(m.match(x,(0,i.basename)(A.fsPath).toLowerCase()))return!(O&&m.match(O,(0,i.basename)(A.fsPath).toLowerCase()))}return!1}e.notebookDocumentFilterMatch=d;class c{constructor(T){this.textModel=T}getElements(){const T=new Int32Array(this.textModel.cells.length);for(let A=0;A<this.textModel.cells.length;A++)T[A]=this.textModel.cells[A].getHashValue();return T}}e.CellSequence=c,e.NotebookSetting={displayOrder:"notebook.displayOrder",cellToolbarLocation:"notebook.cellToolbarLocation",cellToolbarVisibility:"notebook.cellToolbarVisibility",showCellStatusBar:"notebook.showCellStatusBar",textDiffEditorPreview:"notebook.diff.enablePreview",experimentalInsertToolbarAlignment:"notebook.experimental.insertToolbarAlignment",compactView:"notebook.compactView",focusIndicator:"notebook.cellFocusIndicator",insertToolbarLocation:"notebook.insertToolbarLocation",globalToolbar:"notebook.globalToolbar",undoRedoPerCell:"notebook.undoRedoPerCell",consolidatedOutputButton:"notebook.consolidatedOutputButton",showFoldingControls:"notebook.showFoldingControls",dragAndDropEnabled:"notebook.dragAndDropEnabled",cellEditorOptionsCustomizations:"notebook.editorOptionsCustomizations",consolidatedRunButton:"notebook.consolidatedRunButton",openGettingStarted:"notebook.experimental.openGettingStarted",textOutputLineLimit:"notebook.output.textLineLimit",globalToolbarShowLabel:"notebook.globalToolbarShowLabel",markupFontSize:"notebook.markup.fontSize"};var h;(function(b){b[b.Left=1]="Left",b[b.Right=2]="Right"})(h=e.CellStatusbarAlignment||(e.CellStatusbarAlignment={}));class l{static create(T){return`${l._prefix}${T}`}static parse(T){if(T.startsWith(l._prefix))return T.substr(l._prefix.length)}}e.NotebookWorkingCopyTypeIdentifier=l,l._prefix="notebook/"}),define(pe[210],ve([0,1,4]),function(Y,e,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.INotebookExecutionService=e.CellExecutionUpdateType=void 0;var L;(function(y){y[y.Output=1]="Output",y[y.OutputItems=2]="OutputItems",y[y.ExecutionState=3]="ExecutionState",y[y.Complete=4]="Complete"})(L=e.CellExecutionUpdateType||(e.CellExecutionUpdateType={})),e.INotebookExecutionService=(0,m.createDecorator)("INotebookExecutionService")}),define(pe[211],ve([0,1,4,61]),function(Y,e,m,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.OutputChannelUpdateMode=e.IOutputService=e.CONTEXT_OUTPUT_SCROLL_LOCK=e.CONTEXT_ACTIVE_LOG_OUTPUT=e.CONTEXT_IN_OUTPUT=e.MAX_OUTPUT_LENGTH=e.OUTPUT_SERVICE_ID=e.OUTPUT_VIEW_ID=e.LOG_MODE_ID=e.LOG_SCHEME=e.LOG_MIME=e.OUTPUT_MODE_ID=e.OUTPUT_SCHEME=e.OUTPUT_MIME=void 0,e.OUTPUT_MIME="text/x-code-output",e.OUTPUT_SCHEME="output",e.OUTPUT_MODE_ID="Log",e.LOG_MIME="text/x-code-log-output",e.LOG_SCHEME="log",e.LOG_MODE_ID="log",e.OUTPUT_VIEW_ID="workbench.panel.output",e.OUTPUT_SERVICE_ID="outputService",e.MAX_OUTPUT_LENGTH=1e4*100,e.CONTEXT_IN_OUTPUT=new L.RawContextKey("inOutput",!1),e.CONTEXT_ACTIVE_LOG_OUTPUT=new L.RawContextKey("activeLogOutput",!1),e.CONTEXT_OUTPUT_SCROLL_LOCK=new L.RawContextKey("outputView.scrollLock",!1),e.IOutputService=(0,m.createDecorator)(e.OUTPUT_SERVICE_ID);var y;(function(C){C[C.Append=1]="Append",C[C.Replace=2]="Replace",C[C.Clear=3]="Clear"})(y=e.OutputChannelUpdateMode||(e.OutputChannelUpdateMode={}))}),define(pe[212],ve([0,1,175,4,61]),function(Y,e,m,L,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.USER_TASKS_GROUP_KEY=e.ITaskService=e.ProcessExecutionSupportedContext=e.ShellExecutionSupportedContext=e.CustomExecutionSupportedContext=void 0,e.CustomExecutionSupportedContext=new y.RawContextKey("customExecutionSupported",!0,m.localize(0,null)),e.ShellExecutionSupportedContext=new y.RawContextKey("shellExecutionSupported",!1,m.localize(1,null)),e.ProcessExecutionSupportedContext=new y.RawContextKey("processExecutionSupported",!1,m.localize(2,null)),e.ITaskService=(0,L.createDecorator)("taskService"),e.USER_TASKS_GROUP_KEY="settings"}),define(pe[213],ve([0,1]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.deserializeEnvironmentVariableCollection=e.serializeEnvironmentVariableCollection=void 0;function m(y){return[...y.entries()]}e.serializeEnvironmentVariableCollection=m;function L(y){return new Map(y)}e.deserializeEnvironmentVariableCollection=L}),define(pe[126],ve([0,1]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractIncrementalTestCollection=e.IncrementalChangeCollector=e.TestDiffOpType=e.DetailType=e.applyTestItemUpdate=e.TestItemExpandState=e.TestMessageType=e.testRunProfileBitsetList=e.TestRunProfileBitset=e.TestResultState=void 0;var m;(function(P){P[P.Unset=0]="Unset",P[P.Queued=1]="Queued",P[P.Running=2]="Running",P[P.Passed=3]="Passed",P[P.Failed=4]="Failed",P[P.Skipped=5]="Skipped",P[P.Errored=6]="Errored"})(m=e.TestResultState||(e.TestResultState={}));var L;(function(P){P[P.Run=2]="Run",P[P.Debug=4]="Debug",P[P.Coverage=8]="Coverage",P[P.HasNonDefaultProfile=16]="HasNonDefaultProfile",P[P.HasConfigurable=32]="HasConfigurable"})(L=e.TestRunProfileBitset||(e.TestRunProfileBitset={})),e.testRunProfileBitsetList=[2,4,8,16];var y;(function(P){P[P.Error=0]="Error",P[P.Info=1]="Info"})(y=e.TestMessageType||(e.TestMessageType={}));var C;(function(P){P[P.NotExpandable=0]="NotExpandable",P[P.Expandable=1]="Expandable",P[P.BusyExpanding=2]="BusyExpanding",P[P.Expanded=3]="Expanded"})(C=e.TestItemExpandState||(e.TestItemExpandState={}));const i=(P,u)=>{u.expand!==void 0&&(P.expand=u.expand),u.item!==void 0&&(P.item=P.item?Object.assign(P.item,u.item):u.item)};e.applyTestItemUpdate=i;var k;(function(P){P[P.Function=0]="Function",P[P.Statement=1]="Statement"})(k=e.DetailType||(e.DetailType={}));var S;(function(P){P[P.Add=0]="Add",P[P.Update=1]="Update",P[P.Remove=2]="Remove",P[P.IncrementPendingExtHosts=3]="IncrementPendingExtHosts",P[P.Retire=4]="Retire",P[P.AddTag=5]="AddTag",P[P.RemoveTag=6]="RemoveTag"})(S=e.TestDiffOpType||(e.TestDiffOpType={}));class D{add(u){}update(u){}remove(u,E){}complete(){}}e.IncrementalChangeCollector=D;class R{constructor(){this._tags=new Map,this.items=new Map,this.roots=new Set,this.busyControllerCount=0,this.pendingRootCount=0,this.tags=this._tags}apply(u){const E=this.createChangeCollector();for(const f of u)switch(f[0]){case 0:{const v=f[1];if(v.parent){if(this.items.has(v.parent)){const w=this.items.get(v.parent);w.children.add(v.item.extId);const I=this.createItem(v,w);this.items.set(v.item.extId,I),E.add(I)}}else{const w=this.createItem(v);this.roots.add(w),this.items.set(v.item.extId,w),E.add(w)}v.expand===2&&this.busyControllerCount++;break}case 1:{const v=f[1],w=this.items.get(v.extId);if(!w)break;v.expand!==void 0&&(w.expand===2&&this.busyControllerCount--,v.expand===2&&this.busyControllerCount++),(0,e.applyTestItemUpdate)(w,v),E.update(w);break}case 2:{const v=this.items.get(f[1]);if(!v)break;v.parent?this.items.get(v.parent).children.delete(v.item.extId):this.roots.delete(v);const w=[[f[1]]];for(;w.length;)for(const I of w.pop()){const p=this.items.get(I);p&&(w.push(p.children),this.items.delete(I),E.remove(p,p!==v),p.expand===2&&this.busyControllerCount--)}break}case 4:this.retireTest(f[1]);break;case 3:this.updatePendingRoots(f[1]);break;case 5:this._tags.set(f[1].id,f[1]);break;case 6:this._tags.delete(f[1]);break}E.complete()}retireTest(u){}updatePendingRoots(u){this.pendingRootCount+=u}createChangeCollector(){return new D}}e.AbstractIncrementalTestCollection=R}),define(pe[89],ve([0,1]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TestId=e.TestPosition=e.TestIdPathParts=void 0;var m;(function(C){C.Delimiter="\0"})(m=e.TestIdPathParts||(e.TestIdPathParts={}));var L;(function(C){C[C.IsSame=0]="IsSame",C[C.Disconnected=1]="Disconnected",C[C.IsChild=2]="IsChild",C[C.IsParent=3]="IsParent"})(L=e.TestPosition||(e.TestPosition={}));class y{constructor(i,k=i.length){if(this.path=i,this.viewEnd=k,i.length===0||k<1)throw new Error("cannot create test with empty path")}static fromExtHostTestItem(i,k,S=i.parent){if(i.id===k)return new y([k]);let D=[i.id];for(let R=S;R&&R.id!==k;R=R.parent)D.push(R.id);return D.push(k),new y(D.reverse())}static isRoot(i){return!i.includes("\0")}static fromString(i){return new y(i.split("\0"))}static join(i,k){return new y([...i.path,k])}static joinToString(i,k){return i.toString()+"\0"+k}static compare(i,k){return i===k?0:k.startsWith(i+"\0")?2:i.startsWith(k+"\0")?3:1}get parentId(){return this.viewEnd>1?new y(this.path,this.viewEnd-1):this}get localId(){return this.path[this.viewEnd-1]}get controllerId(){return this.path[0]}get isRoot(){return this.viewEnd===1}*idsFromRoot(){for(let i=1;i<=this.viewEnd;i++)yield new y(this.path,i)}compare(i){if(typeof i=="string")return y.compare(this.toString(),i);for(let k=0;k<i.viewEnd&&k<this.viewEnd;k++)if(i.path[k]!==this.path[k])return 1;return i.viewEnd>this.viewEnd?2:i.viewEnd<this.viewEnd?3:0}toJSON(){return this.toString()}toString(){if(!this.stringifed){this.stringifed=this.path[0];for(let i=1;i<this.viewEnd;i++)this.stringifed+="\0",this.stringifed+=this.path[i]}return this.stringifed}}e.TestId=y}),define(pe[214],ve([0,1,9,40,13,25,12,80,176]),function(Y,e,m,L,y,C,i,k,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractVariableResolverService=void 0;class D{constructor(P,u,E){this._contributedVariables=new Map,this._context=P,this._labelService=u,E&&(this._envVariablesPromise=E.then(f=>this.prepareEnv(f)))}prepareEnv(P){if(i.isWindows){const u=Object.create(null);return Object.keys(P).forEach(E=>{u[E.toLowerCase()]=P[E]}),u}return P}resolveWithEnvironment(P,u,E){return this.recursiveResolve(this.prepareEnv(P),u?u.uri:void 0,E)}async resolveAsync(P,u){return this.recursiveResolve(await this._envVariablesPromise,P?P.uri:void 0,u)}async resolveAnyBase(P,u,E,f){const v=C.deepClone(u);return i.isWindows&&v.windows?Object.keys(v.windows).forEach(w=>v[w]=v.windows[w]):i.isMacintosh&&v.osx?Object.keys(v.osx).forEach(w=>v[w]=v.osx[w]):i.isLinux&&v.linux&&Object.keys(v.linux).forEach(w=>v[w]=v.linux[w]),delete v.windows,delete v.osx,delete v.linux,this.recursiveResolve(await this._envVariablesPromise,P?P.uri:void 0,v,E,f)}async resolveAnyAsync(P,u,E){return this.resolveAnyBase(P,u,E)}async resolveAnyMap(P,u,E){const f=new Map;return{newConfig:await this.resolveAnyBase(P,u,E,f),resolvedVariables:f}}resolveWithInteractionReplace(P,u,E,f){throw new Error("resolveWithInteractionReplace not implemented.")}resolveWithInteraction(P,u,E,f){throw new Error("resolveWithInteraction not implemented.")}contributeVariable(P,u){if(this._contributedVariables.has(P))throw new Error("Variable "+P+" is contributed twice.");this._contributedVariables.set(P,u)}recursiveResolve(P,u,E,f,v){if(y.isString(E))return this.resolveString(P,u,E,f,v);if(y.isArray(E))return E.map(w=>this.recursiveResolve(P,u,w,f,v));if(y.isObject(E)){let w=Object.create(null);return Object.keys(E).forEach(I=>{const p=this.resolveString(P,u,I,f,v);w[p]=this.recursiveResolve(P,u,E[I],f,v)}),w}return E}resolveString(P,u,E,f,v){return E.replace(D.VARIABLE_REGEXP,(I,p)=>{if(p.includes(D.VARIABLE_LHS))return I;let s=this.evaluateSingleVariable(P,I,p,u,f);return v&&v.set(p,s),s!==I&&y.isString(s)&&s.match(D.VARIABLE_REGEXP)&&(s=this.resolveString(P,u,s,f,v)),s})}fsPath(P){return this._labelService?this._labelService.getUriLabel(P,{noPrefix:!0}):P.fsPath}evaluateSingleVariable(P,u,E,f,v){let w;const I=E.split(":");I.length>1&&(E=I[0],w=I[1]);const p=()=>{const g=this._context.getFilePath();if(g)return g;throw new Error((0,S.localize)(0,null,u))},s=()=>{const g=p();if(this._context.getWorkspaceFolderPathForFile){const a=this._context.getWorkspaceFolderPathForFile();if(a)return a}throw new Error((0,S.localize)(1,null,u,m.basename(g)))},r=()=>{if(w){const g=this._context.getFolderUri(w);if(g)return g;throw new Error((0,S.localize)(2,null,u,w))}if(f)return f;throw this._context.getWorkspaceFolderCount()>1?new Error((0,S.localize)(3,null,u)):new Error((0,S.localize)(4,null,u))};switch(E){case"env":if(w){if(P){const g=P[i.isWindows?w.toLowerCase():w];if(y.isString(g))return g}return""}throw new Error((0,S.localize)(5,null,u));case"config":if(w){const g=this._context.getConfigurationValue(f,w);if(y.isUndefinedOrNull(g))throw new Error((0,S.localize)(6,null,u,w));if(y.isObject(g))throw new Error((0,S.localize)(7,null,u,w));return g}throw new Error((0,S.localize)(8,null,u));case"command":return this.resolveFromMap(u,w,v,"command");case"input":return this.resolveFromMap(u,w,v,"input");default:switch(E){case"workspaceRoot":case"workspaceFolder":return(0,k.normalizeDriveLetter)(this.fsPath(r()));case"cwd":return f||w?(0,k.normalizeDriveLetter)(this.fsPath(r())):L.cwd();case"workspaceRootFolderName":case"workspaceFolderBasename":return m.basename(this.fsPath(r()));case"lineNumber":const g=this._context.getLineNumber();if(g)return g;throw new Error((0,S.localize)(9,null,u));case"selectedText":const a=this._context.getSelectedText();if(a)return a;throw new Error((0,S.localize)(10,null,u));case"file":return p();case"fileWorkspaceFolder":return s();case"relativeFile":return f||w?m.relative(this.fsPath(r()),p()):p();case"relativeFileDirname":const _=m.dirname(p());if(f||w){const d=m.relative(this.fsPath(r()),_);return d.length===0?".":d}return _;case"fileDirname":return m.dirname(p());case"fileExtname":return m.extname(p());case"fileBasename":return m.basename(p());case"fileBasenameNoExtension":const n=m.basename(p());return n.slice(0,n.length-m.extname(n).length);case"fileDirnameBasename":return m.basename(m.dirname(p()));case"execPath":const t=this._context.getExecPath();return t||u;case"execInstallFolder":const o=this._context.getAppRoot();return o||u;case"pathSeparator":return m.sep;default:try{const d=w?`${E}:${w}`:E;return this.resolveFromMap(u,d,v,void 0)}catch(d){return u}}}}resolveFromMap(P,u,E,f){if(u&&E){const v=f===void 0?E[u]:E[f+":"+u];if(typeof v=="string")return v;throw new Error((0,S.localize)(11,null,P))}return P}}e.AbstractVariableResolverService=D,D.VARIABLE_LHS="${",D.VARIABLE_REGEXP=/\$\{(.*?)\}/g}),define(pe[127],ve([0,1,4,206]),function(Y,e,m,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.preferredSideBySideGroupDirection=e.isEditorGroup=e.OpenEditorContext=e.GroupChangeKind=e.GroupsOrder=e.isEditorReplacement=e.MergeGroupMode=e.GroupsArrangement=e.GroupLocation=e.GroupOrientation=e.GroupDirection=e.IEditorGroupsService=void 0,e.IEditorGroupsService=(0,m.createDecorator)("editorGroupsService");var y;(function(v){v[v.UP=0]="UP",v[v.DOWN=1]="DOWN",v[v.LEFT=2]="LEFT",v[v.RIGHT=3]="RIGHT"})(y=e.GroupDirection||(e.GroupDirection={}));var C;(function(v){v[v.HORIZONTAL=0]="HORIZONTAL",v[v.VERTICAL=1]="VERTICAL"})(C=e.GroupOrientation||(e.GroupOrientation={}));var i;(function(v){v[v.FIRST=0]="FIRST",v[v.LAST=1]="LAST",v[v.NEXT=2]="NEXT",v[v.PREVIOUS=3]="PREVIOUS"})(i=e.GroupLocation||(e.GroupLocation={}));var k;(function(v){v[v.MINIMIZE_OTHERS=0]="MINIMIZE_OTHERS",v[v.EVEN=1]="EVEN",v[v.TOGGLE=2]="TOGGLE"})(k=e.GroupsArrangement||(e.GroupsArrangement={}));var S;(function(v){v[v.COPY_EDITORS=0]="COPY_EDITORS",v[v.MOVE_EDITORS=1]="MOVE_EDITORS"})(S=e.MergeGroupMode||(e.MergeGroupMode={}));function D(v){const w=v;return(0,L.isEditorInput)(w?.editor)&&(0,L.isEditorInput)(w?.replacement)}e.isEditorReplacement=D;var R;(function(v){v[v.CREATION_TIME=0]="CREATION_TIME",v[v.MOST_RECENTLY_ACTIVE=1]="MOST_RECENTLY_ACTIVE",v[v.GRID_APPEARANCE=2]="GRID_APPEARANCE"})(R=e.GroupsOrder||(e.GroupsOrder={}));var P;(function(v){v[v.GROUP_ACTIVE=0]="GROUP_ACTIVE",v[v.GROUP_INDEX=1]="GROUP_INDEX",v[v.GROUP_LOCKED=2]="GROUP_LOCKED",v[v.EDITOR_OPEN=3]="EDITOR_OPEN",v[v.EDITOR_CLOSE=4]="EDITOR_CLOSE",v[v.EDITOR_MOVE=5]="EDITOR_MOVE",v[v.EDITOR_ACTIVE=6]="EDITOR_ACTIVE",v[v.EDITOR_LABEL=7]="EDITOR_LABEL",v[v.EDITOR_CAPABILITIES=8]="EDITOR_CAPABILITIES",v[v.EDITOR_PIN=9]="EDITOR_PIN",v[v.EDITOR_STICKY=10]="EDITOR_STICKY",v[v.EDITOR_DIRTY=11]="EDITOR_DIRTY"})(P=e.GroupChangeKind||(e.GroupChangeKind={}));var u;(function(v){v[v.NEW_EDITOR=1]="NEW_EDITOR",v[v.MOVE_EDITOR=2]="MOVE_EDITOR",v[v.COPY_EDITOR=3]="COPY_EDITOR"})(u=e.OpenEditorContext||(e.OpenEditorContext={}));function E(v){const w=v;return!!w&&typeof w.id=="number"&&Array.isArray(w.editors)}e.isEditorGroup=E;function f(v){return v.getValue("workbench.editor.openSideBySideDirection")==="down"?1:3}e.preferredSideBySideGroupDirection=f}),define(pe[215],ve([0,1,4,127]),function(Y,e,m,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isPreferredGroup=e.SIDE_GROUP=e.ACTIVE_GROUP=e.IEditorService=void 0,e.IEditorService=(0,m.createDecorator)("editorService"),e.ACTIVE_GROUP=-1,e.SIDE_GROUP=-2;function y(C){const i=C;return typeof C=="number"||(0,L.isEditorGroup)(i)}e.isPreferredGroup=y}),define(pe[17],ve([0,1,16,22,97,290,59,25,13,2,41,84,177,116,63,125,89,215,7]),function(Y,e,m,L,y,C,i,k,S,D,R,P,u,E,f,v,w,I,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TypeHierarchyItem=e.CodeActionTriggerKind=e.TestCoverage=e.TestResults=e.TestItem=e.TestTag=e.TestMessage=e.NotebookRendererScript=e.NotebookDocumentContentOptions=e.NotebookStatusBarItem=e.NotebookDecorationRenderOptions=e.NotebookExclusiveDocumentPattern=e.NotebookCellOutput=e.NotebookCellOutputItem=e.NotebookCellData=e.NotebookData=e.NotebookCellKind=e.NotebookCellExecutionSummary=e.NotebookRange=e.LanguageSelector=e.GlobPattern=e.TextEditorOpenOptions=e.FoldingRangeKind=e.FoldingRange=e.ProgressLocation=e.EndOfLine=e.TextEditorLineNumbersStyle=e.TextDocumentSaveReason=e.SelectionRange=e.Color=e.ColorPresentation=e.DocumentLink=e.InlayHintKind=e.InlayHint=e.SignatureHelp=e.SignatureInformation=e.ParameterInformation=e.CompletionItem=e.CompletionItemKind=e.CompletionItemTag=e.CompletionContext=e.CompletionTriggerKind=e.DocumentHighlight=e.InlineValueContext=e.InlineValue=e.EvaluatableExpression=e.Hover=e.DefinitionLink=e.location=e.CallHierarchyOutgoingCall=e.CallHierarchyIncomingCall=e.CallHierarchyItem=e.DocumentSymbol=e.WorkspaceSymbol=e.SymbolTag=e.SymbolKind=e.WorkspaceEdit=e.TextEdit=e.DecorationRenderOptions=e.DecorationRangeBehavior=e.ThemableDecorationRenderOptions=e.ThemableDecorationAttachmentRenderOptions=e.pathOrURIToURI=e.fromRangeOrRangeWithMessage=e.MarkdownString=e.isDecorationOptionsArr=e.ViewColumn=e.DiagnosticSeverity=e.DiagnosticRelatedInformation=e.Diagnostic=e.DiagnosticTag=e.DocumentSelector=e.Position=e.TokenType=e.Range=e.Selection=void 0;var s;(function(de){function Ce(X){const{selectionStartLineNumber:De,selectionStartColumn:Re,positionLineNumber:Ze,positionColumn:qe}=X,dt=new p.Position(De-1,Re-1),wt=new p.Position(Ze-1,qe-1);return new p.Selection(dt,wt)}de.to=Ce;function ce(X){const{anchor:De,active:Re}=X;return{selectionStartLineNumber:De.line+1,selectionStartColumn:De.character+1,positionLineNumber:Re.line+1,positionColumn:Re.character+1}}de.from=ce})(s=e.Selection||(e.Selection={}));var r;(function(de){function Ce(X){if(!X)return;const{start:De,end:Re}=X;return{startLineNumber:De.line+1,startColumn:De.character+1,endLineNumber:Re.line+1,endColumn:Re.character+1}}de.from=Ce;function ce(X){if(!X)return;const{startLineNumber:De,startColumn:Re,endLineNumber:Ze,endColumn:qe}=X;return new p.Range(De-1,Re-1,Ze-1,qe-1)}de.to=ce})(r=e.Range||(e.Range={}));var g;(function(de){function Ce(ce){switch(ce){case 1:return p.StandardTokenType.Comment;case 0:return p.StandardTokenType.Other;case 4:return p.StandardTokenType.RegEx;case 2:return p.StandardTokenType.String}}de.to=Ce})(g=e.TokenType||(e.TokenType={}));var a;(function(de){function Ce(X){return new p.Position(X.lineNumber-1,X.column-1)}de.to=Ce;function ce(X){return{lineNumber:X.line+1,column:X.character+1}}de.from=ce})(a=e.Position||(e.Position={}));var _;(function(de){function Ce(De,Re){return(0,m.coalesce)((0,m.asArray)(De).map(Ze=>ce(Ze,Re)))}de.from=Ce;function ce(De,Re){if(typeof De=="string")return{$serialized:!0,language:De};if(De)return{$serialized:!0,language:De.language,scheme:X(De.scheme,Re),pattern:typeof De.pattern=="undefined"?void 0:J.from(De.pattern),exclusive:De.exclusive}}function X(De,Re){return Re&&typeof De=="string"?Re.transformOutgoingScheme(De):De}})(_=e.DocumentSelector||(e.DocumentSelector={}));var n;(function(de){function Ce(X){switch(X){case p.DiagnosticTag.Unnecessary:return 1;case p.DiagnosticTag.Deprecated:return 2}}de.from=Ce;function ce(X){switch(X){case 1:return p.DiagnosticTag.Unnecessary;case 2:return p.DiagnosticTag.Deprecated;default:return}}de.to=ce})(n=e.DiagnosticTag||(e.DiagnosticTag={}));var t;(function(de){function Ce(X){let De;return X.code&&((0,S.isString)(X.code)||(0,S.isNumber)(X.code)?De=String(X.code):De={value:String(X.code.value),target:X.code.target}),{...r.from(X.range),message:X.message,source:X.source,code:De,severity:d.from(X.severity),relatedInformation:X.relatedInformation&&X.relatedInformation.map(o.from),tags:Array.isArray(X.tags)?(0,m.coalesce)(X.tags.map(n.from)):void 0}}de.from=Ce;function ce(X){const De=new p.Diagnostic(r.to(X),X.message,d.to(X.severity));return De.source=X.source,De.code=(0,S.isString)(X.code)?X.code:X.code?.value,De.relatedInformation=X.relatedInformation&&X.relatedInformation.map(o.to),De.tags=X.tags&&(0,m.coalesce)(X.tags.map(n.to)),De}de.to=ce})(t=e.Diagnostic||(e.Diagnostic={}));var o;(function(de){function Ce(X){return{...r.from(X.location.range),message:X.message,resource:X.location.uri}}de.from=Ce;function ce(X){return new p.DiagnosticRelatedInformation(new p.Location(X.resource,r.to(X)),X.message)}de.to=ce})(o=e.DiagnosticRelatedInformation||(e.DiagnosticRelatedInformation={}));var d;(function(de){function Ce(X){switch(X){case p.DiagnosticSeverity.Error:return E.MarkerSeverity.Error;case p.DiagnosticSeverity.Warning:return E.MarkerSeverity.Warning;case p.DiagnosticSeverity.Information:return E.MarkerSeverity.Info;case p.DiagnosticSeverity.Hint:return E.MarkerSeverity.Hint}return E.MarkerSeverity.Error}de.from=Ce;function ce(X){switch(X){case E.MarkerSeverity.Info:return p.DiagnosticSeverity.Information;case E.MarkerSeverity.Warning:return p.DiagnosticSeverity.Warning;case E.MarkerSeverity.Error:return p.DiagnosticSeverity.Error;case E.MarkerSeverity.Hint:return p.DiagnosticSeverity.Hint;default:return p.DiagnosticSeverity.Error}}de.to=ce})(d=e.DiagnosticSeverity||(e.DiagnosticSeverity={}));var c;(function(de){function Ce(X){return typeof X=="number"&&X>=p.ViewColumn.One?X-1:X===p.ViewColumn.Beside?I.SIDE_GROUP:I.ACTIVE_GROUP}de.from=Ce;function ce(X){if(typeof X=="number"&&X>=0)return X+1;throw new Error("invalid 'EditorGroupColumn'")}de.to=ce})(c=e.ViewColumn||(e.ViewColumn={}));function h(de){return typeof de.range!="undefined"}function l(de){return de.length===0?!0:!!h(de[0])}e.isDecorationOptionsArr=l;var b;(function(de){function Ce(qe){return qe.map(de.from)}de.fromMany=Ce;function ce(qe){return qe&&typeof qe=="object"&&typeof qe.language=="string"&&typeof qe.value=="string"}function X(qe){let dt;if(ce(qe)){const{language:ft,value:vt}=qe;dt={value:"```"+ft+`
`+vt+"\n```\n"}}else p.MarkdownString.isMarkdownString(qe)?dt={value:qe.value,isTrusted:qe.isTrusted,supportThemeIcons:qe.supportThemeIcons,supportHtml:qe.supportHtml}:typeof qe=="string"?dt={value:qe}:dt={value:""};const wt=Object.create(null);dt.uris=wt;const yt=ft=>{try{let vt=D.URI.parse(ft,!0);vt=vt.with({query:De(vt.query,wt)}),wt[ft]=vt}catch(vt){}return""},bt=new C.Renderer;return bt.link=yt,bt.image=ft=>yt(y.parseHrefAndDimensions(ft).href),C(dt.value,{renderer:bt}),dt}de.from=X;function De(qe,dt){if(!qe)return qe;let wt;try{wt=(0,i.parse)(qe)}catch(bt){}if(!wt)return qe;let yt=!1;return wt=(0,k.cloneAndChange)(wt,bt=>{if(D.URI.isUri(bt)){const ft=`__uri_${Math.random().toString(16).slice(2,8)}`;return dt[ft]=bt,yt=!0,ft}else return}),yt?JSON.stringify(wt):qe}function Re(qe){const dt=new p.MarkdownString(qe.value,qe.supportThemeIcons);return dt.isTrusted=qe.isTrusted,dt.supportHtml=qe.supportHtml,dt}de.to=Re;function Ze(qe){if(!!qe)return typeof qe=="string"?qe:de.from(qe)}de.fromStrict=Ze})(b=e.MarkdownString||(e.MarkdownString={}));function T(de){return l(de)?de.map(Ce=>({range:r.from(Ce.range),hoverMessage:Array.isArray(Ce.hoverMessage)?b.fromMany(Ce.hoverMessage):Ce.hoverMessage?b.from(Ce.hoverMessage):void 0,renderOptions:Ce.renderOptions})):de.map(Ce=>({range:r.from(Ce)}))}e.fromRangeOrRangeWithMessage=T;function A(de){return typeof de=="undefined"?de:typeof de=="string"?D.URI.file(de):de}e.pathOrURIToURI=A;var x;(function(de){function Ce(ce){return typeof ce=="undefined"?ce:{contentText:ce.contentText,contentIconPath:ce.contentIconPath?A(ce.contentIconPath):void 0,border:ce.border,borderColor:ce.borderColor,fontStyle:ce.fontStyle,fontWeight:ce.fontWeight,textDecoration:ce.textDecoration,color:ce.color,backgroundColor:ce.backgroundColor,margin:ce.margin,width:ce.width,height:ce.height}}de.from=Ce})(x=e.ThemableDecorationAttachmentRenderOptions||(e.ThemableDecorationAttachmentRenderOptions={}));var O;(function(de){function Ce(ce){return typeof ce=="undefined"?ce:{backgroundColor:ce.backgroundColor,outline:ce.outline,outlineColor:ce.outlineColor,outlineStyle:ce.outlineStyle,outlineWidth:ce.outlineWidth,border:ce.border,borderColor:ce.borderColor,borderRadius:ce.borderRadius,borderSpacing:ce.borderSpacing,borderStyle:ce.borderStyle,borderWidth:ce.borderWidth,fontStyle:ce.fontStyle,fontWeight:ce.fontWeight,textDecoration:ce.textDecoration,cursor:ce.cursor,color:ce.color,opacity:ce.opacity,letterSpacing:ce.letterSpacing,gutterIconPath:ce.gutterIconPath?A(ce.gutterIconPath):void 0,gutterIconSize:ce.gutterIconSize,overviewRulerColor:ce.overviewRulerColor,before:ce.before?x.from(ce.before):void 0,after:ce.after?x.from(ce.after):void 0}}de.from=Ce})(O=e.ThemableDecorationRenderOptions||(e.ThemableDecorationRenderOptions={}));var F;(function(de){function Ce(ce){if(typeof ce=="undefined")return ce;switch(ce){case p.DecorationRangeBehavior.OpenOpen:return 0;case p.DecorationRangeBehavior.ClosedClosed:return 1;case p.DecorationRangeBehavior.OpenClosed:return 2;case p.DecorationRangeBehavior.ClosedOpen:return 3}}de.from=Ce})(F=e.DecorationRangeBehavior||(e.DecorationRangeBehavior={}));var W;(function(de){function Ce(ce){return{isWholeLine:ce.isWholeLine,rangeBehavior:ce.rangeBehavior?F.from(ce.rangeBehavior):void 0,overviewRulerLane:ce.overviewRulerLane,light:ce.light?O.from(ce.light):void 0,dark:ce.dark?O.from(ce.dark):void 0,backgroundColor:ce.backgroundColor,outline:ce.outline,outlineColor:ce.outlineColor,outlineStyle:ce.outlineStyle,outlineWidth:ce.outlineWidth,border:ce.border,borderColor:ce.borderColor,borderRadius:ce.borderRadius,borderSpacing:ce.borderSpacing,borderStyle:ce.borderStyle,borderWidth:ce.borderWidth,fontStyle:ce.fontStyle,fontWeight:ce.fontWeight,textDecoration:ce.textDecoration,cursor:ce.cursor,color:ce.color,opacity:ce.opacity,letterSpacing:ce.letterSpacing,gutterIconPath:ce.gutterIconPath?A(ce.gutterIconPath):void 0,gutterIconSize:ce.gutterIconSize,overviewRulerColor:ce.overviewRulerColor,before:ce.before?x.from(ce.before):void 0,after:ce.after?x.from(ce.after):void 0}}de.from=Ce})(W=e.DecorationRenderOptions||(e.DecorationRenderOptions={}));var M;(function(de){function Ce(X){return{text:X.newText,eol:X.newEol&&ct.from(X.newEol),range:r.from(X.range)}}de.from=Ce;function ce(X){const De=new p.TextEdit(r.to(X.range),X.text);return De.newEol=typeof X.eol=="undefined"?void 0:ct.to(X.eol),De}de.to=ce})(M=e.TextEdit||(e.TextEdit={}));var B;(function(de){function Ce(X,De,Re){const Ze={edits:[]};if(X instanceof p.WorkspaceEdit)for(let qe of X._allEntries())if(qe._type===1)Ze.edits.push({_type:1,oldUri:qe.from,newUri:qe.to,options:qe.options,metadata:qe.metadata});else if(qe._type===2){const dt=De?.getDocument(qe.uri);Ze.edits.push({_type:2,resource:qe.uri,edit:M.from(qe.edit),modelVersionId:dt?.version,metadata:qe.metadata})}else qe._type===3?Ze.edits.push({_type:3,metadata:qe.metadata,resource:qe.uri,edit:qe.edit,notebookMetadata:qe.notebookMetadata,notebookVersionId:Re?.getNotebookDocument(qe.uri,!0)?.apiNotebook.version}):qe._type===5&&Ze.edits.push({_type:3,metadata:qe.metadata,resource:qe.uri,notebookVersionId:Re?.getNotebookDocument(qe.uri,!0)?.apiNotebook.version,edit:{editType:1,index:qe.index,count:qe.count,cells:qe.cells.map(Oe.from)}});return Ze}de.from=Ce;function ce(X){const De=new p.WorkspaceEdit;for(const Re of X.edits)Re.edit?De.replace(D.URI.revive(Re.resource),r.to(Re.edit.range),Re.edit.text):De.renameFile(D.URI.revive(Re.oldUri),D.URI.revive(Re.newUri),Re.options);return De}de.to=ce})(B=e.WorkspaceEdit||(e.WorkspaceEdit={}));var U;(function(de){const Ce=Object.create(null);Ce[p.SymbolKind.File]=0,Ce[p.SymbolKind.Module]=1,Ce[p.SymbolKind.Namespace]=2,Ce[p.SymbolKind.Package]=3,Ce[p.SymbolKind.Class]=4,Ce[p.SymbolKind.Method]=5,Ce[p.SymbolKind.Property]=6,Ce[p.SymbolKind.Field]=7,Ce[p.SymbolKind.Constructor]=8,Ce[p.SymbolKind.Enum]=9,Ce[p.SymbolKind.Interface]=10,Ce[p.SymbolKind.Function]=11,Ce[p.SymbolKind.Variable]=12,Ce[p.SymbolKind.Constant]=13,Ce[p.SymbolKind.String]=14,Ce[p.SymbolKind.Number]=15,Ce[p.SymbolKind.Boolean]=16,Ce[p.SymbolKind.Array]=17,Ce[p.SymbolKind.Object]=18,Ce[p.SymbolKind.Key]=19,Ce[p.SymbolKind.Null]=20,Ce[p.SymbolKind.EnumMember]=21,Ce[p.SymbolKind.Struct]=22,Ce[p.SymbolKind.Event]=23,Ce[p.SymbolKind.Operator]=24,Ce[p.SymbolKind.TypeParameter]=25;function ce(De){return typeof Ce[De]=="number"?Ce[De]:6}de.from=ce;function X(De){for(const Re in Ce)if(Ce[Re]===De)return Number(Re);return p.SymbolKind.Property}de.to=X})(U=e.SymbolKind||(e.SymbolKind={}));var z;(function(de){function Ce(X){switch(X){case p.SymbolTag.Deprecated:return 1}}de.from=Ce;function ce(X){switch(X){case 1:return p.SymbolTag.Deprecated}}de.to=ce})(z=e.SymbolTag||(e.SymbolTag={}));var K;(function(de){function Ce(X){return{name:X.name,kind:U.from(X.kind),tags:X.tags&&X.tags.map(z.from),containerName:X.containerName,location:q.from(X.location)}}de.from=Ce;function ce(X){const De=new p.SymbolInformation(X.name,U.to(X.kind),X.containerName,q.to(X.location));return De.tags=X.tags&&X.tags.map(z.to),De}de.to=ce})(K=e.WorkspaceSymbol||(e.WorkspaceSymbol={}));var N;(function(de){function Ce(X){const De={name:X.name||"!!MISSING: name!!",detail:X.detail,range:r.from(X.range),selectionRange:r.from(X.selectionRange),kind:U.from(X.kind),tags:X.tags?.map(z.from)??[]};return X.children&&(De.children=X.children.map(Ce)),De}de.from=Ce;function ce(X){const De=new p.DocumentSymbol(X.name,X.detail,U.to(X.kind),r.to(X.range),r.to(X.selectionRange));return(0,m.isNonEmptyArray)(X.tags)&&(De.tags=X.tags.map(z.to)),X.children&&(De.children=X.children.map(ce)),De}de.to=ce})(N=e.DocumentSymbol||(e.DocumentSymbol={}));var j;(function(de){function Ce(X){const De=new p.CallHierarchyItem(U.to(X.kind),X.name,X.detail||"",D.URI.revive(X.uri),r.to(X.range),r.to(X.selectionRange));return De._sessionId=X._sessionId,De._itemId=X._itemId,De}de.to=Ce;function ce(X,De,Re){if(De=De??X._sessionId,Re=Re??X._itemId,De===void 0||Re===void 0)throw new Error("invalid item");return{_sessionId:De,_itemId:Re,name:X.name,detail:X.detail,kind:U.from(X.kind),uri:X.uri,range:r.from(X.range),selectionRange:r.from(X.selectionRange),tags:X.tags?.map(z.from)}}de.from=ce})(j=e.CallHierarchyItem||(e.CallHierarchyItem={}));var H;(function(de){function Ce(ce){return new p.CallHierarchyIncomingCall(j.to(ce.from),ce.fromRanges.map(X=>r.to(X)))}de.to=Ce})(H=e.CallHierarchyIncomingCall||(e.CallHierarchyIncomingCall={}));var V;(function(de){function Ce(ce){return new p.CallHierarchyOutgoingCall(j.to(ce.to),ce.fromRanges.map(X=>r.to(X)))}de.to=Ce})(V=e.CallHierarchyOutgoingCall||(e.CallHierarchyOutgoingCall={}));var q;(function(de){function Ce(X){return{range:X.range&&r.from(X.range),uri:X.uri}}de.from=Ce;function ce(X){return new p.Location(D.URI.revive(X.uri),r.to(X.range))}de.to=ce})(q=e.location||(e.location={}));var ne;(function(de){function Ce(X){const De=X,Re=X;return{originSelectionRange:De.originSelectionRange?r.from(De.originSelectionRange):void 0,uri:De.targetUri?De.targetUri:Re.uri,range:r.from(De.targetRange?De.targetRange:Re.range),targetSelectionRange:De.targetSelectionRange?r.from(De.targetSelectionRange):void 0}}de.from=Ce;function ce(X){return{targetUri:D.URI.revive(X.uri),targetRange:r.to(X.range),targetSelectionRange:X.targetSelectionRange?r.to(X.targetSelectionRange):void 0,originSelectionRange:X.originSelectionRange?r.to(X.originSelectionRange):void 0}}de.to=ce})(ne=e.DefinitionLink||(e.DefinitionLink={}));var fe;(function(de){function Ce(X){return{range:r.from(X.range),contents:b.fromMany(X.contents)}}de.from=Ce;function ce(X){return new p.Hover(X.contents.map(b.to),r.to(X.range))}de.to=ce})(fe=e.Hover||(e.Hover={}));var ye;(function(de){function Ce(X){return{range:r.from(X.range),expression:X.expression}}de.from=Ce;function ce(X){return new p.EvaluatableExpression(r.to(X.range),X.expression)}de.to=ce})(ye=e.EvaluatableExpression||(e.EvaluatableExpression={}));var ke;(function(de){function Ce(X){if(X instanceof p.InlineValueText)return{type:"text",range:r.from(X.range),text:X.text};if(X instanceof p.InlineValueVariableLookup)return{type:"variable",range:r.from(X.range),variableName:X.variableName,caseSensitiveLookup:X.caseSensitiveLookup};if(X instanceof p.InlineValueEvaluatableExpression)return{type:"expression",range:r.from(X.range),expression:X.expression};throw new Error("Unknown 'InlineValue' type")}de.from=Ce;function ce(X){switch(X.type){case"text":return{range:r.to(X.range),text:X.text};case"variable":return{range:r.to(X.range),variableName:X.variableName,caseSensitiveLookup:X.caseSensitiveLookup};case"expression":return{range:r.to(X.range),expression:X.expression}}}de.to=ce})(ke=e.InlineValue||(e.InlineValue={}));var Be;(function(de){function Ce(X){return{frameId:X.frameId,stoppedLocation:r.from(X.stoppedLocation)}}de.from=Ce;function ce(X){return new p.InlineValueContext(X.frameId,r.to(X.stoppedLocation))}de.to=ce})(Be=e.InlineValueContext||(e.InlineValueContext={}));var We;(function(de){function Ce(X){return{range:r.from(X.range),kind:X.kind}}de.from=Ce;function ce(X){return new p.DocumentHighlight(r.to(X.range),X.kind)}de.to=ce})(We=e.DocumentHighlight||(e.DocumentHighlight={}));var ze;(function(de){function Ce(ce){switch(ce){case 1:return p.CompletionTriggerKind.TriggerCharacter;case 2:return p.CompletionTriggerKind.TriggerForIncompleteCompletions;case 0:default:return p.CompletionTriggerKind.Invoke}}de.to=Ce})(ze=e.CompletionTriggerKind||(e.CompletionTriggerKind={}));var Q;(function(de){function Ce(ce){return{triggerKind:ze.to(ce.triggerKind),triggerCharacter:ce.triggerCharacter}}de.to=Ce})(Q=e.CompletionContext||(e.CompletionContext={}));var ee;(function(de){function Ce(X){switch(X){case p.CompletionItemTag.Deprecated:return 1}}de.from=Ce;function ce(X){switch(X){case 1:return p.CompletionItemTag.Deprecated}}de.to=ce})(ee=e.CompletionItemTag||(e.CompletionItemTag={}));var re;(function(de){const Ce=new Map([[p.CompletionItemKind.Method,0],[p.CompletionItemKind.Function,1],[p.CompletionItemKind.Constructor,2],[p.CompletionItemKind.Field,3],[p.CompletionItemKind.Variable,4],[p.CompletionItemKind.Class,5],[p.CompletionItemKind.Interface,7],[p.CompletionItemKind.Struct,6],[p.CompletionItemKind.Module,8],[p.CompletionItemKind.Property,9],[p.CompletionItemKind.Unit,12],[p.CompletionItemKind.Value,13],[p.CompletionItemKind.Constant,14],[p.CompletionItemKind.Enum,15],[p.CompletionItemKind.EnumMember,16],[p.CompletionItemKind.Keyword,17],[p.CompletionItemKind.Snippet,27],[p.CompletionItemKind.Text,18],[p.CompletionItemKind.Color,19],[p.CompletionItemKind.File,20],[p.CompletionItemKind.Reference,21],[p.CompletionItemKind.Folder,23],[p.CompletionItemKind.Event,10],[p.CompletionItemKind.Operator,11],[p.CompletionItemKind.TypeParameter,24],[p.CompletionItemKind.Issue,26],[p.CompletionItemKind.User,25]]);function ce(Re){return Ce.get(Re)??9}de.from=ce;const X=new Map([[0,p.CompletionItemKind.Method],[1,p.CompletionItemKind.Function],[2,p.CompletionItemKind.Constructor],[3,p.CompletionItemKind.Field],[4,p.CompletionItemKind.Variable],[5,p.CompletionItemKind.Class],[7,p.CompletionItemKind.Interface],[6,p.CompletionItemKind.Struct],[8,p.CompletionItemKind.Module],[9,p.CompletionItemKind.Property],[12,p.CompletionItemKind.Unit],[13,p.CompletionItemKind.Value],[14,p.CompletionItemKind.Constant],[15,p.CompletionItemKind.Enum],[16,p.CompletionItemKind.EnumMember],[17,p.CompletionItemKind.Keyword],[27,p.CompletionItemKind.Snippet],[18,p.CompletionItemKind.Text],[19,p.CompletionItemKind.Color],[20,p.CompletionItemKind.File],[21,p.CompletionItemKind.Reference],[23,p.CompletionItemKind.Folder],[10,p.CompletionItemKind.Event],[11,p.CompletionItemKind.Operator],[24,p.CompletionItemKind.TypeParameter],[25,p.CompletionItemKind.User],[26,p.CompletionItemKind.Issue]]);function De(Re){return X.get(Re)??p.CompletionItemKind.Property}de.to=De})(re=e.CompletionItemKind||(e.CompletionItemKind={}));var he;(function(de){function Ce(ce,X){const De=new p.CompletionItem(ce.label);return De.insertText=ce.insertText,De.kind=re.to(ce.kind),De.tags=ce.tags?.map(ee.to),De.detail=ce.detail,De.documentation=y.isMarkdownString(ce.documentation)?b.to(ce.documentation):ce.documentation,De.sortText=ce.sortText,De.filterText=ce.filterText,De.preselect=ce.preselect,De.commitCharacters=ce.commitCharacters,R.Range.isIRange(ce.range)?De.range=r.to(ce.range):typeof ce.range=="object"&&(De.range={inserting:r.to(ce.range.insert),replacing:r.to(ce.range.replace)}),De.keepWhitespace=typeof ce.insertTextRules=="undefined"?!1:Boolean(ce.insertTextRules&1),typeof ce.insertTextRules!="undefined"&&ce.insertTextRules&4?De.insertText=new p.SnippetString(ce.insertText):(De.insertText=ce.insertText,De.textEdit=De.range instanceof p.Range?new p.TextEdit(De.range,De.insertText):void 0),ce.additionalTextEdits&&ce.additionalTextEdits.length>0&&(De.additionalTextEdits=ce.additionalTextEdits.map(Re=>M.to(Re))),De.command=X&&ce.command?X.fromInternal(ce.command):void 0,De}de.to=Ce})(he=e.CompletionItem||(e.CompletionItem={}));var Z;(function(de){function Ce(X){return{label:X.label,documentation:X.documentation?b.fromStrict(X.documentation):void 0}}de.from=Ce;function ce(X){return{label:X.label,documentation:y.isMarkdownString(X.documentation)?b.to(X.documentation):X.documentation}}de.to=ce})(Z=e.ParameterInformation||(e.ParameterInformation={}));var oe;(function(de){function Ce(X){return{label:X.label,documentation:X.documentation?b.fromStrict(X.documentation):void 0,parameters:Array.isArray(X.parameters)?X.parameters.map(Z.from):[],activeParameter:X.activeParameter}}de.from=Ce;function ce(X){return{label:X.label,documentation:y.isMarkdownString(X.documentation)?b.to(X.documentation):X.documentation,parameters:Array.isArray(X.parameters)?X.parameters.map(Z.to):[],activeParameter:X.activeParameter}}de.to=ce})(oe=e.SignatureInformation||(e.SignatureInformation={}));var be;(function(de){function Ce(X){return{activeSignature:X.activeSignature,activeParameter:X.activeParameter,signatures:Array.isArray(X.signatures)?X.signatures.map(oe.from):[]}}de.from=Ce;function ce(X){return{activeSignature:X.activeSignature,activeParameter:X.activeParameter,signatures:Array.isArray(X.signatures)?X.signatures.map(oe.to):[]}}de.to=ce})(be=e.SignatureHelp||(e.SignatureHelp={}));var Me;(function(de){function Ce(X){return{text:X.text,position:a.from(X.position),kind:Ve.from(X.kind??p.InlayHintKind.Other),whitespaceBefore:X.whitespaceBefore,whitespaceAfter:X.whitespaceAfter}}de.from=Ce;function ce(X){const De=new p.InlayHint(X.text,a.to(X.position),Ve.to(X.kind));return De.whitespaceAfter=X.whitespaceAfter,De.whitespaceBefore=X.whitespaceBefore,De}de.to=ce})(Me=e.InlayHint||(e.InlayHint={}));var Ve;(function(de){function Ce(X){return X}de.from=Ce;function ce(X){return X}de.to=ce})(Ve=e.InlayHintKind||(e.InlayHintKind={}));var Ge;(function(de){function Ce(X){return{range:r.from(X.range),url:X.target,tooltip:X.tooltip}}de.from=Ce;function ce(X){let De;if(X.url)try{De=typeof X.url=="string"?D.URI.parse(X.url,!0):D.URI.revive(X.url)}catch(Re){}return new p.DocumentLink(r.to(X.range),De)}de.to=ce})(Ge=e.DocumentLink||(e.DocumentLink={}));var Je;(function(de){function Ce(X){const De=new p.ColorPresentation(X.label);return X.textEdit&&(De.textEdit=M.to(X.textEdit)),X.additionalTextEdits&&(De.additionalTextEdits=X.additionalTextEdits.map(Re=>M.to(Re))),De}de.to=Ce;function ce(X){return{label:X.label,textEdit:X.textEdit?M.from(X.textEdit):void 0,additionalTextEdits:X.additionalTextEdits?X.additionalTextEdits.map(De=>M.from(De)):void 0}}de.from=ce})(Je=e.ColorPresentation||(e.ColorPresentation={}));var tt;(function(de){function Ce(X){return new p.Color(X[0],X[1],X[2],X[3])}de.to=Ce;function ce(X){return[X.red,X.green,X.blue,X.alpha]}de.from=ce})(tt=e.Color||(e.Color={}));var ot;(function(de){function Ce(X){return{range:r.from(X.range)}}de.from=Ce;function ce(X){return new p.SelectionRange(r.to(X.range))}de.to=ce})(ot=e.SelectionRange||(e.SelectionRange={}));var et;(function(de){function Ce(ce){switch(ce){case 2:return p.TextDocumentSaveReason.AfterDelay;case 1:return p.TextDocumentSaveReason.Manual;case 3:case 4:return p.TextDocumentSaveReason.FocusOut}}de.to=Ce})(et=e.TextDocumentSaveReason||(e.TextDocumentSaveReason={}));var it;(function(de){function Ce(X){switch(X){case p.TextEditorLineNumbersStyle.Off:return 0;case p.TextEditorLineNumbersStyle.Relative:return 2;case p.TextEditorLineNumbersStyle.On:default:return 1}}de.from=Ce;function ce(X){switch(X){case 0:return p.TextEditorLineNumbersStyle.Off;case 2:return p.TextEditorLineNumbersStyle.Relative;case 1:default:return p.TextEditorLineNumbersStyle.On}}de.to=ce})(it=e.TextEditorLineNumbersStyle||(e.TextEditorLineNumbersStyle={}));var ct;(function(de){function Ce(X){if(X===p.EndOfLine.CRLF)return 1;if(X===p.EndOfLine.LF)return 0}de.from=Ce;function ce(X){if(X===1)return p.EndOfLine.CRLF;if(X===0)return p.EndOfLine.LF}de.to=ce})(ct=e.EndOfLine||(e.EndOfLine={}));var pt;(function(de){function Ce(ce){if(typeof ce=="object")return ce.viewId;switch(ce){case p.ProgressLocation.SourceControl:return 3;case p.ProgressLocation.Window:return 10;case p.ProgressLocation.Notification:return 15}throw new Error("Unknown 'ProgressLocation'")}de.from=Ce})(pt=e.ProgressLocation||(e.ProgressLocation={}));var Pt;(function(de){function Ce(ce){const X={start:ce.start+1,end:ce.end+1};return ce.kind&&(X.kind=Ue.from(ce.kind)),X}de.from=Ce})(Pt=e.FoldingRange||(e.FoldingRange={}));var Ue;(function(de){function Ce(ce){if(ce)switch(ce){case p.FoldingRangeKind.Comment:return P.FoldingRangeKind.Comment;case p.FoldingRangeKind.Imports:return P.FoldingRangeKind.Imports;case p.FoldingRangeKind.Region:return P.FoldingRangeKind.Region}}de.from=Ce})(Ue=e.FoldingRangeKind||(e.FoldingRangeKind={}));var Rt;(function(de){function Ce(ce){if(ce)return{pinned:typeof ce.preview=="boolean"?!ce.preview:void 0,inactive:ce.background,preserveFocus:ce.preserveFocus,selection:typeof ce.selection=="object"?r.from(ce.selection):void 0,override:typeof ce.override=="boolean"?u.EditorResolution.DISABLED:void 0}}de.from=Ce})(Rt=e.TextEditorOpenOptions||(e.TextEditorOpenOptions={}));var J;(function(de){function Ce(X){return X instanceof p.RelativePattern||typeof X=="string"?X:ce(X)?new p.RelativePattern(X.base,X.pattern):X}de.from=Ce;function ce(X){const De=X;return De&&typeof De.base=="string"&&typeof De.pattern=="string"}})(J=e.GlobPattern||(e.GlobPattern={}));var ie;(function(de){function Ce(ce){if(ce){if(Array.isArray(ce))return ce.map(Ce);if(typeof ce=="string")return ce;{const X=ce;return{language:X.language,scheme:X.scheme,pattern:typeof X.pattern=="undefined"?void 0:J.from(X.pattern),exclusive:X.exclusive}}}else return}de.from=Ce})(ie=e.LanguageSelector||(e.LanguageSelector={}));var ge;(function(de){function Ce(X){return{start:X.start,end:X.end}}de.from=Ce;function ce(X){return new p.NotebookRange(X.start,X.end)}de.to=ce})(ge=e.NotebookRange||(e.NotebookRange={}));var te;(function(de){function Ce(X){return{timing:typeof X.runStartTime=="number"&&typeof X.runEndTime=="number"?{startTime:X.runStartTime,endTime:X.runEndTime}:void 0,executionOrder:X.executionOrder,success:X.lastRunSuccess}}de.to=Ce;function ce(X){return{lastRunSuccess:X.success,runStartTime:X.timing?.startTime,runEndTime:X.timing?.endTime,executionOrder:X.executionOrder}}de.from=ce})(te=e.NotebookCellExecutionSummary||(e.NotebookCellExecutionSummary={}));var Ee;(function(de){function Ce(X){switch(X){case p.NotebookCellKind.Markup:return v.CellKind.Markup;case p.NotebookCellKind.Code:default:return v.CellKind.Code}}de.from=Ce;function ce(X){switch(X){case v.CellKind.Markup:return p.NotebookCellKind.Markup;case v.CellKind.Code:default:return p.NotebookCellKind.Code}}de.to=ce})(Ee=e.NotebookCellKind||(e.NotebookCellKind={}));var Le;(function(de){function Ce(X){const De={metadata:X.metadata??Object.create(null),cells:[]};for(let Re of X.cells)p.NotebookCellData.validate(Re),De.cells.push(Oe.from(Re));return De}de.from=Ce;function ce(X){const De=new p.NotebookData(X.cells.map(Oe.to));return(0,S.isEmptyObject)(X.metadata)||(De.metadata=X.metadata),De}de.to=ce})(Le=e.NotebookData||(e.NotebookData={}));var Oe;(function(de){function Ce(X){return{cellKind:Ee.from(X.kind),language:X.languageId,mime:X.mime,source:X.value,metadata:X.metadata,internalMetadata:te.from(X.executionSummary??{}),outputs:X.outputs?X.outputs.map(Te.from):[]}}de.from=Ce;function ce(X){return new p.NotebookCellData(Ee.to(X.cellKind),X.source,X.language,X.mime,X.outputs?X.outputs.map(Te.to):void 0,X.metadata,X.internalMetadata?te.to(X.internalMetadata):void 0)}de.to=ce})(Oe=e.NotebookCellData||(e.NotebookCellData={}));var Xe;(function(de){function Ce(X){return{mime:X.mime,valueBytes:L.VSBuffer.wrap(X.data)}}de.from=Ce;function ce(X){return new p.NotebookCellOutputItem(X.valueBytes.buffer,X.mime)}de.to=ce})(Xe=e.NotebookCellOutputItem||(e.NotebookCellOutputItem={}));var Te;(function(de){function Ce(X){return{outputId:X.id,items:X.items.map(Xe.from),metadata:X.metadata}}de.from=Ce;function ce(X){const De=X.items.map(Xe.to);return new p.NotebookCellOutput(De,X.outputId,X.metadata)}de.to=ce})(Te=e.NotebookCellOutput||(e.NotebookCellOutput={}));var Ie;(function(de){function Ce(Re){if(Re!=null){if(Re instanceof p.RelativePattern||typeof Re=="string")return Re;if(De(Re))return new p.RelativePattern(Re.base,Re.pattern);if(X(Re))return{include:J.from(Re.include)||void 0,exclude:J.from(Re.exclude)||void 0}}}de.from=Ce;function ce(Re){return typeof Re=="string"?Re:De(Re)?{base:Re.base,pattern:Re.pattern}:{include:Re.include,exclude:Re.exclude}}de.to=ce;function X(Re){const Ze=Re,qe=J.from(Ze.include);if(!(qe&&qe instanceof p.RelativePattern||typeof qe=="string"))return!1;const dt=J.from(Ze.exclude);return!!(dt&&dt instanceof p.RelativePattern||typeof dt=="string")}function De(Re){const Ze=Re;return Ze&&typeof Ze.base=="string"&&typeof Ze.pattern=="string"}})(Ie=e.NotebookExclusiveDocumentPattern||(e.NotebookExclusiveDocumentPattern={}));var Se;(function(de){function Ce(ce){return{backgroundColor:ce.backgroundColor,borderColor:ce.borderColor,top:ce.top?x.from(ce.top):void 0}}de.from=Ce})(Se=e.NotebookDecorationRenderOptions||(e.NotebookDecorationRenderOptions={}));var le;(function(de){function Ce(ce,X,De){const Re=typeof ce.command=="string"?{title:"",command:ce.command}:ce.command;return{alignment:ce.alignment===p.NotebookCellStatusBarAlignment.Left?1:2,command:X.toInternal(Re,De),text:ce.text,tooltip:ce.tooltip,accessibilityInformation:ce.accessibilityInformation,priority:ce.priority}}de.from=Ce})(le=e.NotebookStatusBarItem||(e.NotebookStatusBarItem={}));var ue;(function(de){function Ce(ce){return{transientOutputs:ce?.transientOutputs??!1,transientCellMetadata:ce?.transientCellMetadata??{},transientDocumentMetadata:ce?.transientDocumentMetadata??{}}}de.from=Ce})(ue=e.NotebookDocumentContentOptions||(e.NotebookDocumentContentOptions={}));var we;(function(de){function Ce(X){return{uri:X.uri,provides:X.provides}}de.from=Ce;function ce(X){return new p.NotebookRendererScript(D.URI.revive(X.uri),X.provides)}de.to=ce})(we=e.NotebookRendererScript||(e.NotebookRendererScript={}));var _e;(function(de){function Ce(X){return{message:b.fromStrict(X.message)||"",type:0,expected:X.expectedOutput,actual:X.actualOutput,location:X.location?q.from(X.location):void 0}}de.from=Ce;function ce(X){const De=new p.TestMessage(typeof X.message=="string"?X.message:b.to(X.message));return De.actualOutput=X.actual,De.expectedOutput=X.expected,De.location=X.location?q.to(X.location):void 0,De}de.to=ce})(_e=e.TestMessage||(e.TestMessage={}));var Fe;(function(de){let Ce;(function(ce){ce.Delimiter="\0"})(Ce||(Ce={})),de.namespace=(ce,X)=>ce+"\0"+X,de.denamespace=ce=>{const X=ce.indexOf("\0");return{ctrlId:ce.slice(0,X),tagId:ce.slice(X+1)}}})(Fe=e.TestTag||(e.TestTag={}));var Ke;(function(de){function Ce(Re){const Ze=(0,f.getPrivateApiFor)(Re).controllerId;return{extId:w.TestId.fromExtHostTestItem(Re,Ze).toString(),label:Re.label,uri:Re.uri,tags:Re.tags.map(qe=>Fe.namespace(Ze,qe.id)),range:r.from(Re.range)||null,description:Re.description||null,error:Re.error&&b.fromStrict(Re.error)||null}}de.from=Ce;function ce(Re){return{parent:void 0,error:void 0,id:w.TestId.fromString(Re.extId).localId,label:Re.label,uri:D.URI.revive(Re.uri),tags:(Re.tags||[]).map(Ze=>{const{tagId:qe}=Fe.denamespace(Ze);return new p.TestTag(qe)}),range:r.to(Re.range||void 0),invalidateResults:()=>{},canResolveChildren:!1,busy:!1,description:Re.description||void 0}}de.toPlain=ce;function X(Re){const Ze=w.TestId.fromString(Re.extId),qe=new f.TestItemImpl(Ze.controllerId,Ze.localId,Re.label,D.URI.revive(Re.uri));return qe.range=r.to(Re.range||void 0),qe.description=Re.description||void 0,qe}function De(Re){let Ze;for(const qe of Re.tests){const dt=X(qe.item);(0,f.getPrivateApiFor)(dt).parent=Ze,Ze=dt}return Ze}de.toItemFromContext=De})(Ke=e.TestItem||(e.TestItem={})),function(de){function Ce(X){return{id:X.id}}de.from=Ce;function ce(X){return new p.TestTag(X.id)}de.to=ce}(Fe=e.TestTag||(e.TestTag={}));var $e;(function(de){const Ce=(X,De)=>{const Re={...Ke.toPlain(X.item),parent:void 0,taskStates:X.tasks.map(Ze=>({state:Ze.state,duration:Ze.duration,messages:Ze.messages.filter(qe=>qe.type===0).map(_e.to)})),children:X.children.map(Ze=>De.get(Ze)).filter(S.isDefined).map(Ze=>Ce(Ze,De))};for(const Ze of Re.children)Ze.parent=Re;return Re};function ce(X){const De=[],Re=new Map;for(const Ze of X.items)Re.set(Ze.item.extId,Ze),X.request.targets.some(qe=>qe.controllerId===Ze.controllerId&&qe.testIds.includes(Ze.item.extId))&&De.push(Ze);return{completedAt:X.completedAt,results:De.map(Ze=>Ce(Ze,Re))}}de.to=ce})($e=e.TestResults||(e.TestResults={}));var Qe;(function(de){function Ce(Re){return{covered:Re.covered,total:Re.covered}}function ce(Re){return"line"in Re?a.from(Re):r.from(Re)}function X(Re){return"branches"in Re?{count:Re.executionCount,location:ce(Re.location),type:1,branches:Re.branches.length?Re.branches.map(Ze=>({count:Ze.executionCount,location:Ze.location&&ce(Ze.location)})):void 0}:{type:0,count:Re.executionCount,location:ce(Re.location)}}de.fromDetailed=X;function De(Re){return{uri:Re.uri,statement:Ce(Re.statementCoverage),branch:Re.branchCoverage&&Ce(Re.branchCoverage),function:Re.functionCoverage&&Ce(Re.functionCoverage),details:Re.detailedCoverage?.map(X)}}de.fromFile=De})(Qe=e.TestCoverage||(e.TestCoverage={}));var st;(function(de){function Ce(ce){switch(ce){case 1:return p.CodeActionTriggerKind.Invoke;case 2:return p.CodeActionTriggerKind.Automatic}}de.to=Ce})(st=e.CodeActionTriggerKind||(e.CodeActionTriggerKind={}));var at;(function(de){function Ce(X){const De=new p.TypeHierarchyItem(U.to(X.kind),X.name,X.detail||"",D.URI.revive(X.uri),r.to(X.range),r.to(X.selectionRange));return De._sessionId=X._sessionId,De._itemId=X._itemId,De}de.to=Ce;function ce(X,De,Re){if(De=De??X._sessionId,Re=Re??X._itemId,De===void 0||Re===void 0)throw new Error("invalid item");return{_sessionId:De,_itemId:Re,kind:U.from(X.kind),name:X.name,detail:X.detail??"",uri:X.uri,range:r.from(X.range),selectionRange:r.from(X.selectionRange),tags:X.tags?.map(z.from)}}de.from=ce})(at=e.TypeHierarchyItem||(e.TypeHierarchyItem={}))}),define(pe[216],ve([0,1,2,15,7,17,93]),function(Y,e,m,L,y,C,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDocumentSaveParticipant=void 0;class k{constructor(D,R,P,u={timeout:1500,errors:3}){this._logService=D,this._documents=R,this._mainThreadBulkEdits=P,this._thresholds=u,this._callbacks=new i.LinkedList,this._badListeners=new WeakMap}dispose(){this._callbacks.clear()}getOnWillSaveTextDocumentEvent(D){return(R,P,u)=>{const f={dispose:this._callbacks.push([R,P,D])};return Array.isArray(u)&&u.push(f),f}}async $participateInSave(D,R){const P=m.URI.revive(D);let u=!1;const E=setTimeout(()=>u=!0,this._thresholds.timeout),f=[];try{for(let v of[...this._callbacks]){if(u)break;const w=this._documents.getDocument(P),I=await this._deliverEventAsyncAndBlameBadListeners(v,{document:w,reason:C.TextDocumentSaveReason.to(R)});f.push(I)}}finally{clearTimeout(E)}return f}_deliverEventAsyncAndBlameBadListeners([D,R,P],u){const E=this._badListeners.get(D);return typeof E=="number"&&E>this._thresholds.errors?Promise.resolve(!1):this._deliverEventAsync(P,D,R,u).then(()=>!0,f=>{if(this._logService.error(`onWillSaveTextDocument-listener from extension '${P.identifier.value}' threw ERROR`),this._logService.error(f),!(f instanceof Error)||f.message!=="concurrent_edits"){const v=this._badListeners.get(D);this._badListeners.set(D,v?v+1:1),typeof v=="number"&&v>this._thresholds.errors&&this._logService.info(`onWillSaveTextDocument-listener from extension '${P.identifier.value}' will now be IGNORED because of timeouts and/or errors`)}return!1})}_deliverEventAsync(D,R,P,u){const E=[],f=Date.now(),{document:v,reason:w}=u,{version:I}=v,p=Object.freeze({document:v,reason:w,waitUntil(s){if(Object.isFrozen(E))throw(0,L.illegalState)("waitUntil can not be called async");E.push(Promise.resolve(s))}});try{R.apply(P,[p])}catch(s){return Promise.reject(s)}return Object.freeze(E),new Promise((s,r)=>{const g=setTimeout(()=>r(new Error("timeout")),this._thresholds.timeout);return Promise.all(E).then(a=>{this._logService.debug(`onWillSaveTextDocument-listener from extension '${D.identifier.value}' finished after ${Date.now()-f}ms`),clearTimeout(g),s(a)}).catch(a=>{clearTimeout(g),r(a)})}).then(s=>{const r={edits:[]};for(const g of s)if(Array.isArray(g)&&g.every(a=>a instanceof y.TextEdit))for(const{newText:a,newEol:_,range:n}of g)r.edits.push({_type:2,resource:v.uri,edit:{range:n&&C.Range.from(n),text:a,eol:_&&C.EndOfLine.from(_)}});if(r.edits.length!==0)return I===v.version?this._mainThreadBulkEdits.$tryApplyWorkspaceEdit(r):Promise.reject(new Error("concurrent_edits"))})}}e.ExtHostDocumentSaveParticipant=k}),define(pe[217],ve([0,1,3,31,2,17,7]),function(Y,e,m,L,y,C,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostFileSystemEventService=void 0;class k{constructor(R,P,u,E,f){this._onDidCreate=new m.Emitter,this._onDidChange=new m.Emitter,this._onDidDelete=new m.Emitter,this._config=0,u&&(this._config+=1),E&&(this._config+=2),f&&(this._config+=4);const v=(0,L.parse)(P),w=R(I=>{if(!u)for(let p of I.created){const s=y.URI.revive(p);v(s.fsPath)&&this._onDidCreate.fire(s)}if(!E)for(let p of I.changed){const s=y.URI.revive(p);v(s.fsPath)&&this._onDidChange.fire(s)}if(!f)for(let p of I.deleted){const s=y.URI.revive(p);v(s.fsPath)&&this._onDidDelete.fire(s)}});this._disposable=i.Disposable.from(this._onDidCreate,this._onDidChange,this._onDidDelete,w)}get ignoreCreateEvents(){return Boolean(this._config&1)}get ignoreChangeEvents(){return Boolean(this._config&2)}get ignoreDeleteEvents(){return Boolean(this._config&4)}dispose(){this._disposable.dispose()}get onDidCreate(){return this._onDidCreate.event}get onDidChange(){return this._onDidChange.event}get onDidDelete(){return this._onDidDelete.event}}class S{constructor(R,P,u){this._logService=P,this._extHostDocumentsAndEditors=u,this._onFileSystemEvent=new m.Emitter,this._onDidRenameFile=new m.Emitter,this._onDidCreateFile=new m.Emitter,this._onDidDeleteFile=new m.Emitter,this._onWillRenameFile=new m.AsyncEmitter,this._onWillCreateFile=new m.AsyncEmitter,this._onWillDeleteFile=new m.AsyncEmitter,this.onDidRenameFile=this._onDidRenameFile.event,this.onDidCreateFile=this._onDidCreateFile.event,this.onDidDeleteFile=this._onDidDeleteFile.event}createFileSystemWatcher(R,P,u,E){return new k(this._onFileSystemEvent.event,R,P,u,E)}$onFileEvent(R){this._onFileSystemEvent.fire(R)}$onDidRunFileOperation(R,P){switch(R){case 2:this._onDidRenameFile.fire(Object.freeze({files:P.map(u=>({oldUri:y.URI.revive(u.source),newUri:y.URI.revive(u.target)}))}));break;case 1:this._onDidDeleteFile.fire(Object.freeze({files:P.map(u=>y.URI.revive(u.target))}));break;case 0:this._onDidCreateFile.fire(Object.freeze({files:P.map(u=>y.URI.revive(u.target))}));break;default:}}getOnWillRenameFileEvent(R){return this._createWillExecuteEvent(R,this._onWillRenameFile)}getOnWillCreateFileEvent(R){return this._createWillExecuteEvent(R,this._onWillCreateFile)}getOnWillDeleteFileEvent(R){return this._createWillExecuteEvent(R,this._onWillDeleteFile)}_createWillExecuteEvent(R,P){return(u,E,f)=>{const v=function(I){u.call(E,I)};return v.extension=R,P.event(v,void 0,f)}}async $onWillRunFileOperation(R,P,u,E){switch(R){case 2:return await this._fireWillEvent(this._onWillRenameFile,{files:P.map(f=>({oldUri:y.URI.revive(f.source),newUri:y.URI.revive(f.target)}))},u,E);case 1:return await this._fireWillEvent(this._onWillDeleteFile,{files:P.map(f=>y.URI.revive(f.target))},u,E);case 0:return await this._fireWillEvent(this._onWillCreateFile,{files:P.map(f=>y.URI.revive(f.target))},u,E)}}async _fireWillEvent(R,P,u,E){const f=new Set,v=[];if(await R.fireAsync(P,E,async(I,p)=>{const s=Date.now(),r=await Promise.resolve(I);r instanceof i.WorkspaceEdit&&(v.push(r),f.add(p.extension.displayName??p.extension.identifier.value)),Date.now()-s>u&&this._logService.warn("SLOW file-participant",p.extension.identifier)}),E.isCancellationRequested||v.length===0)return;const w={edits:[]};for(let I of v){let{edits:p}=C.WorkspaceEdit.from(I,this._extHostDocumentsAndEditors);w.edits=w.edits.concat(p)}return{edit:w,extensionNames:Array.from(f)}}}e.ExtHostFileSystemEventService=S}),define(pe[218],ve([0,1,10,25,2,17,7,125]),function(Y,e,m,L,y,C,i,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookDocument=e.ExtHostCell=void 0;class S{constructor(u,E,f,v){this.start=u,this.deletedCount=E,this.deletedItems=f,this.items=v}static asApiEvents(u){return u.map(E=>({start:E.start,deletedCount:E.deletedCount,deletedItems:E.deletedItems,items:E.items.map(f=>f.apiCell)}))}}class D{constructor(u,E,f){this.notebook=u,this._extHostDocument=E,this._cellData=f,this.handle=f.handle,this.uri=y.URI.revive(f.uri),this.cellKind=f.cellKind,this._outputs=f.outputs.map(C.NotebookCellOutput.to),this._internalMetadata=f.internalMetadata??{},this._metadata=Object.freeze(f.metadata??{}),this._previousResult=Object.freeze(C.NotebookCellExecutionSummary.to(f.internalMetadata??{}))}static asModelAddData(u,E){return{EOL:E.eol,lines:E.source,languageId:E.language,uri:E.uri,isDirty:!1,versionId:1,notebook:u}}get internalMetadata(){return this._internalMetadata}get apiCell(){if(!this._apiCell){const u=this,E=this._extHostDocument.getDocument(this.uri);if(!E)throw new Error(`MISSING extHostDocument for notebook cell: ${this.uri}`);this._apiCell=Object.freeze({get index(){return u.notebook.getCellIndex(u)},notebook:u.notebook.apiNotebook,kind:C.NotebookCellKind.to(this._cellData.cellKind),document:E.document,get mime(){return u._mime},set mime(f){u._mime=f},get outputs(){return u._outputs.slice(0)},get metadata(){return u._metadata},get executionSummary(){return u._previousResult}})}return this._apiCell}setOutputs(u){this._outputs=u.map(C.NotebookCellOutput.to)}setOutputItems(u,E,f){const v=f.map(C.NotebookCellOutputItem.to),w=this._outputs.find(I=>I.id===u);w&&(E||(w.items.length=0),w.items.push(...v))}setMetadata(u){this._metadata=Object.freeze(u)}setInternalMetadata(u){this._internalMetadata=u,this._previousResult=Object.freeze(C.NotebookCellExecutionSummary.to(u))}setMime(u){}}e.ExtHostCell=D;class R{constructor(u,E,f,v,w,I){this._proxy=u,this._textDocumentsAndEditors=E,this._textDocuments=f,this._emitter=v,this.uri=w,this.handle=R._handlePool++,this._cells=[],this._versionId=0,this._isDirty=!1,this._disposed=!1,this._notebookType=I.viewType,this._metadata=Object.freeze(I.metadata??Object.create(null)),this._spliceNotebookCells([[0,0,I.cells]],!0),this._versionId=I.versionId}dispose(){this._disposed=!0}get apiNotebook(){if(!this._notebook){const u=this;this._notebook={get uri(){return u.uri},get version(){return u._versionId},get notebookType(){return u._notebookType},get isDirty(){return u._isDirty},get isUntitled(){return u.uri.scheme===m.Schemas.untitled},get isClosed(){return u._disposed},get metadata(){return u._metadata},get cellCount(){return u._cells.length},cellAt(E){return E=u._validateIndex(E),u._cells[E].apiCell},getCells(E){return(E?u._getCells(E):u._cells).map(v=>v.apiCell)},save(){return u._save()}}}return this._notebook}updateBackup(u){this._backup?.delete(),this._backup=u}disposeBackup(){this._backup?.delete(),this._backup=void 0}acceptDocumentPropertiesChanged(u){u.metadata&&(this._metadata=Object.freeze({...this._metadata,...u.metadata}))}acceptDirty(u){this._isDirty=u}acceptModelChanged(u,E){this._versionId=u.versionId,this._isDirty=E;for(const f of u.rawEvents)f.kind===k.NotebookCellsChangeType.ModelChange?this._spliceNotebookCells(f.changes,!1):f.kind===k.NotebookCellsChangeType.Move?this._moveCell(f.index,f.newIdx):f.kind===k.NotebookCellsChangeType.Output?this._setCellOutputs(f.index,f.outputs):f.kind===k.NotebookCellsChangeType.OutputItem?this._setCellOutputItems(f.index,f.outputId,f.append,f.outputItems):f.kind===k.NotebookCellsChangeType.ChangeLanguage?this._changeCellLanguage(f.index,f.language):f.kind===k.NotebookCellsChangeType.ChangeCellMime?this._changeCellMime(f.index,f.mime):f.kind===k.NotebookCellsChangeType.ChangeCellMetadata?this._changeCellMetadata(f.index,f.metadata):f.kind===k.NotebookCellsChangeType.ChangeCellInternalMetadata&&this._changeCellInternalMetadata(f.index,f.internalMetadata)}_validateIndex(u){return u=u|0,u<0?0:u>=this._cells.length?this._cells.length-1:u}_validateRange(u){let E=u.start|0,f=u.end|0;return E<0&&(E=0),f>this._cells.length&&(f=this._cells.length),u.with({start:E,end:f})}_getCells(u){u=this._validateRange(u);const E=[];for(let f=u.start;f<u.end;f++)E.push(this._cells[f]);return E}async _save(){return this._disposed?Promise.reject(new Error("Notebook has been closed")):this._proxy.$trySaveNotebook(this.uri)}_spliceNotebookCells(u,E){if(this._disposed)return;const f=[],v=[],w=[];u.reverse().forEach(I=>{const s=I[2].map(a=>{const _=new D(this,this._textDocumentsAndEditors,a);return E||v.push(D.asModelAddData(this.apiNotebook,a)),_}),r=new S(I[0],I[1],[],s),g=this._cells.splice(I[0],I[1],...s);for(const a of g)w.push(a.uri),r.deletedItems.push(a.apiCell);f.push(r)}),this._textDocumentsAndEditors.acceptDocumentsAndEditorsDelta({addedDocuments:v,removedDocuments:w}),E||this._emitter.emitModelChange((0,L.deepFreeze)({document:this.apiNotebook,changes:S.asApiEvents(f)}))}_moveCell(u,E){const f=this._cells.splice(u,1);this._cells.splice(E,0,...f);const v=[new S(u,1,f.map(w=>w.apiCell),[]),new S(E,0,[],f)];this._emitter.emitModelChange((0,L.deepFreeze)({document:this.apiNotebook,changes:S.asApiEvents(v)}))}_setCellOutputs(u,E){const f=this._cells[u];f.setOutputs(E),this._emitter.emitCellOutputsChange((0,L.deepFreeze)({document:this.apiNotebook,cells:[f.apiCell]}))}_setCellOutputItems(u,E,f,v){const w=this._cells[u];w.setOutputItems(E,f,v),this._emitter.emitCellOutputsChange((0,L.deepFreeze)({document:this.apiNotebook,cells:[w.apiCell]}))}_changeCellLanguage(u,E){const f=this._cells[u];f.apiCell.document.languageId!==E&&this._textDocuments.$acceptModelModeChanged(f.uri,E)}_changeCellMime(u,E){const f=this._cells[u];f.apiCell.mime=E}_changeCellMetadata(u,E){const f=this._cells[u],v=f.apiCell.metadata;f.setMetadata(E);const w=f.apiCell.metadata;(0,L.equals)(v,w)||this._emitter.emitCellMetadataChange((0,L.deepFreeze)({document:this.apiNotebook,cell:f.apiCell}))}_changeCellInternalMetadata(u,E){const f=this._cells[u],v=f.internalMetadata;if(f.setInternalMetadata(E),v.runState!==E.runState){const w=E.runState??i.NotebookCellExecutionState.Idle;this._emitter.emitCellExecutionStateChange((0,L.deepFreeze)({document:this.apiNotebook,cell:f.apiCell,state:w}))}}getCellFromApiCell(u){return this._cells.find(E=>E.apiCell===u)}getCellFromIndex(u){return this._cells[u]}getCell(u){return this._cells.find(E=>E.handle===u)}getCellIndex(u){return this._cells.indexOf(u)}}e.ExtHostNotebookDocument=R,R._handlePool=0}),define(pe[128],ve([0,1,7,17,15]),function(Y,e,m,L,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookEditor=void 0;class C{constructor(S){this._finalized=!1,this._collectedEdits=[],this._documentVersionId=S}finalize(){return this._finalized=!0,{documentVersionId:this._documentVersionId,cellEdits:this._collectedEdits}}_throwIfFinalized(){if(this._finalized)throw new Error("Edit is only valid while callback runs")}replaceMetadata(S){this._throwIfFinalized(),this._collectedEdits.push({editType:5,metadata:S})}replaceCellMetadata(S,D){this._throwIfFinalized(),this._collectedEdits.push({editType:8,index:S,metadata:D})}replaceCells(S,D,R){this._throwIfFinalized(),!(S===D&&R.length===0)&&this._collectedEdits.push({editType:1,index:S,count:D-S,cells:R.map(L.NotebookCellData.from)})}}class i{constructor(S,D,R,P,u,E){this.id=S,this._proxy=D,this.notebookData=R,this._selections=[],this._visibleRanges=[],this._visible=!1,this._hasDecorationsForKey=new Set,this._selections=u,this._visibleRanges=P,this._viewColumn=E}get apiEditor(){if(!this._editor){const S=this;this._editor={get document(){return S.notebookData.apiNotebook},get selections(){return S._selections},set selections(D){if(!Array.isArray(D)||!D.every(m.NotebookRange.isNotebookRange))throw(0,y.illegalArgument)("selections");S._selections=D,S._trySetSelections(D)},get visibleRanges(){return S._visibleRanges},revealRange(D,R){S._proxy.$tryRevealRange(S.id,L.NotebookRange.from(D),R??m.NotebookEditorRevealType.Default)},get viewColumn(){return S._viewColumn},edit(D){const R=new C(this.document.version);return D(R),S._applyEdit(R.finalize())},setDecorations(D,R){return S.setDecorations(D,R)}},i.apiEditorsToExtHost.set(this._editor,this)}return this._editor}get visible(){return this._visible}_acceptVisibility(S){this._visible=S}_acceptVisibleRanges(S){this._visibleRanges=S}_acceptSelections(S){this._selections=S}_trySetSelections(S){this._proxy.$trySetSelections(this.id,S.map(L.NotebookRange.from))}_acceptViewColumn(S){this._viewColumn=S}_applyEdit(S){if(S.cellEdits.length===0)return Promise.resolve(!0);const D=[];let R=-1;for(let P=0;P<S.cellEdits.length;P++){if(R<0){D.push(S.cellEdits[P]),R++;continue}const E=D[R],f=S.cellEdits[P];if(E.editType===1&&f.editType===1&&E.index===f.index){E.cells.push(...S.cellEdits[P].cells),E.count+=S.cellEdits[P].count;continue}D.push(S.cellEdits[P]),R++}return this._proxy.$tryApplyEdits(this.id,S.documentVersionId,D)}setDecorations(S,D){if(!(D.isEmpty&&!this._hasDecorationsForKey.has(S.key)))return D.isEmpty?this._hasDecorationsForKey.delete(S.key):this._hasDecorationsForKey.add(S.key),this._proxy.$trySetDecorations(this.id,L.NotebookRange.from(D),S.key)}}e.ExtHostNotebookEditor=i,i.apiEditorsToExtHost=new WeakMap}),define(pe[219],ve([0,1,17,117,164,21,57,15]),function(Y,e,m,L,y,C,i,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostProgress=void 0;class S{constructor(u){this._handles=0,this._mapHandleToCancellationSource=new Map,this._proxy=u}async withProgress(u,E,f){const v=this._handles++,{title:w,location:I,cancellable:p}=E,s={label:(0,y.localize)(0,null,u.displayName||u.name),id:u.identifier.value};return this._proxy.$startProgress(v,{location:m.ProgressLocation.from(I),title:w,source:s,cancellable:p},u).catch(k.onUnexpectedExternalError),this._withProgress(v,f,!!p)}_withProgress(u,E,f){let v;f&&(v=new C.CancellationTokenSource,this._mapHandleToCancellationSource.set(u,v));const w=p=>{this._proxy.$progressEnd(p),this._mapHandleToCancellationSource.delete(p),v&&v.dispose()};let I;try{I=E(new R(this._proxy,u),f&&v?v.token:C.CancellationToken.None)}catch(p){throw w(u),p}return I.then(p=>w(u),p=>w(u)),I}$acceptProgressCanceled(u){const E=this._mapHandleToCancellationSource.get(u);E&&(E.cancel(),this._mapHandleToCancellationSource.delete(u))}}e.ExtHostProgress=S;function D(P,u){return P.message=u.message,typeof u.increment=="number"&&(typeof P.increment=="number"?P.increment+=u.increment:P.increment=u.increment),P}class R extends L.Progress{constructor(u,E){super(f=>this.throttledReport(f));this._proxy=u,this._handle=E}throttledReport(u){this._proxy.$progressReport(this._handle,u)}}je([(0,i.throttle)(100,(P,u)=>D(P,u),()=>Object.create(null))],R.prototype,"throttledReport",null)}),define(pe[129],ve([0,1,56,15,75,17,7]),function(Y,e,m,L,y,C,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTextEditor=e.ExtHostTextEditorOptions=e.TextEditorEdit=e.TextEditorDecorationType=void 0;class k{constructor(u,E,f){const v=k._Keys.nextId();u.$registerTextEditorDecorationType(E.identifier,v,C.DecorationRenderOptions.from(f)),this.value=Object.freeze({key:v,dispose(){u.$removeTextEditorDecorationType(v)}})}}e.TextEditorDecorationType=k,k._Keys=new y.IdGenerator("TextEditorDecorationType");class S{constructor(u,E){this._collectedEdits=[],this._setEndOfLine=void 0,this._finalized=!1,this._document=u,this._documentVersionId=u.version,this._undoStopBefore=E.undoStopBefore,this._undoStopAfter=E.undoStopAfter}finalize(){return this._finalized=!0,{documentVersionId:this._documentVersionId,edits:this._collectedEdits,setEndOfLine:this._setEndOfLine,undoStopBefore:this._undoStopBefore,undoStopAfter:this._undoStopAfter}}_throwIfFinalized(){if(this._finalized)throw new Error("Edit is only valid while callback runs")}replace(u,E){this._throwIfFinalized();let f=null;if(u instanceof i.Position)f=new i.Range(u,u);else if(u instanceof i.Range)f=u;else throw new Error("Unrecognized location");this._pushEdit(f,E,!1)}insert(u,E){this._throwIfFinalized(),this._pushEdit(new i.Range(u,u),E,!0)}delete(u){this._throwIfFinalized();let E=null;if(u instanceof i.Range)E=u;else throw new Error("Unrecognized location");this._pushEdit(E,null,!0)}_pushEdit(u,E,f){const v=this._document.validateRange(u);this._collectedEdits.push({range:v,text:E,forceMoveMarkers:f})}setEndOfLine(u){if(this._throwIfFinalized(),u!==i.EndOfLine.LF&&u!==i.EndOfLine.CRLF)throw(0,L.illegalArgument)("endOfLine");this._setEndOfLine=u}}e.TextEditorEdit=S;class D{constructor(u,E,f,v){this._proxy=u,this._id=E,this._accept(f),this._logService=v;const w=this;this.value={get tabSize(){return w._tabSize},set tabSize(I){w._setTabSize(I)},get insertSpaces(){return w._insertSpaces},set insertSpaces(I){w._setInsertSpaces(I)},get cursorStyle(){return w._cursorStyle},set cursorStyle(I){w._setCursorStyle(I)},get lineNumbers(){return w._lineNumbers},set lineNumbers(I){w._setLineNumbers(I)}}}_accept(u){this._tabSize=u.tabSize,this._insertSpaces=u.insertSpaces,this._cursorStyle=u.cursorStyle,this._lineNumbers=C.TextEditorLineNumbersStyle.to(u.lineNumbers)}_validateTabSize(u){if(u==="auto")return"auto";if(typeof u=="number"){const E=Math.floor(u);return E>0?E:null}if(typeof u=="string"){const E=parseInt(u,10);return isNaN(E)?null:E>0?E:null}return null}_setTabSize(u){const E=this._validateTabSize(u);if(E!==null){if(typeof E=="number"){if(this._tabSize===E)return;this._tabSize=E}this._warnOnError("setTabSize",this._proxy.$trySetOptions(this._id,{tabSize:E}))}}_validateInsertSpaces(u){return u==="auto"?"auto":u==="false"?!1:Boolean(u)}_setInsertSpaces(u){const E=this._validateInsertSpaces(u);if(typeof E=="boolean"){if(this._insertSpaces===E)return;this._insertSpaces=E}this._warnOnError("setInsertSpaces",this._proxy.$trySetOptions(this._id,{insertSpaces:E}))}_setCursorStyle(u){this._cursorStyle!==u&&(this._cursorStyle=u,this._warnOnError("setCursorStyle",this._proxy.$trySetOptions(this._id,{cursorStyle:u})))}_setLineNumbers(u){this._lineNumbers!==u&&(this._lineNumbers=u,this._warnOnError("setLineNumbers",this._proxy.$trySetOptions(this._id,{lineNumbers:C.TextEditorLineNumbersStyle.from(u)})))}assign(u){const E={};let f=!1;if(typeof u.tabSize!="undefined"){const v=this._validateTabSize(u.tabSize);v==="auto"?(f=!0,E.tabSize=v):typeof v=="number"&&this._tabSize!==v&&(this._tabSize=v,f=!0,E.tabSize=v)}if(typeof u.insertSpaces!="undefined"){const v=this._validateInsertSpaces(u.insertSpaces);v==="auto"?(f=!0,E.insertSpaces=v):this._insertSpaces!==v&&(this._insertSpaces=v,f=!0,E.insertSpaces=v)}typeof u.cursorStyle!="undefined"&&this._cursorStyle!==u.cursorStyle&&(this._cursorStyle=u.cursorStyle,f=!0,E.cursorStyle=u.cursorStyle),typeof u.lineNumbers!="undefined"&&this._lineNumbers!==u.lineNumbers&&(this._lineNumbers=u.lineNumbers,f=!0,E.lineNumbers=C.TextEditorLineNumbersStyle.from(u.lineNumbers)),f&&this._warnOnError("setOptions",this._proxy.$trySetOptions(this._id,E))}_warnOnError(u,E){E.catch(f=>{this._logService.warn(`ExtHostTextEditorOptions '${u}' failed:'`),this._logService.warn(f)})}}e.ExtHostTextEditorOptions=D;class R{constructor(u,E,f,v,w,I,p,s){this.id=u,this._proxy=E,this._logService=f,this._disposed=!1,this._hasDecorationsForKey=new Set,this._selections=w,this._options=new D(this._proxy,this.id,I,f),this._visibleRanges=p,this._viewColumn=s;const r=this;this.value=Object.freeze({get document(){return v.getValue()},set document(g){throw(0,L.readonly)("document")},get selection(){return r._selections&&r._selections[0]},set selection(g){if(!(g instanceof i.Selection))throw(0,L.illegalArgument)("selection");r._selections=[g],r._trySetSelection()},get selections(){return r._selections},set selections(g){if(!Array.isArray(g)||g.some(a=>!(a instanceof i.Selection)))throw(0,L.illegalArgument)("selections");r._selections=g,r._trySetSelection()},get visibleRanges(){return r._visibleRanges},set visibleRanges(g){throw(0,L.readonly)("visibleRanges")},get options(){return r._options.value},set options(g){r._disposed||r._options.assign(g)},get viewColumn(){return r._viewColumn},set viewColumn(g){throw(0,L.readonly)("viewColumn")},edit(g,a={undoStopBefore:!0,undoStopAfter:!0}){if(r._disposed)return Promise.reject(new Error("TextEditor#edit not possible on closed editors"));const _=new S(v.getValue(),a);return g(_),r._applyEdit(_)},insertSnippet(g,a,_={undoStopBefore:!0,undoStopAfter:!0}){if(r._disposed)return Promise.reject(new Error("TextEditor#insertSnippet not possible on closed editors"));let n;if(!a||Array.isArray(a)&&a.length===0)n=r._selections.map(t=>C.Range.from(t));else if(a instanceof i.Position){const{lineNumber:t,column:o}=C.Position.from(a);n=[{startLineNumber:t,startColumn:o,endLineNumber:t,endColumn:o}]}else if(a instanceof i.Range)n=[C.Range.from(a)];else{n=[];for(const t of a)if(t instanceof i.Range)n.push(C.Range.from(t));else{const{lineNumber:o,column:d}=C.Position.from(t);n.push({startLineNumber:o,startColumn:d,endLineNumber:o,endColumn:d})}}return E.$tryInsertSnippet(u,g.value,n,_)},setDecorations(g,a){const _=a.length===0;_&&!r._hasDecorationsForKey.has(g.key)||(_?r._hasDecorationsForKey.delete(g.key):r._hasDecorationsForKey.add(g.key),r._runOnProxy(()=>{if(C.isDecorationOptionsArr(a))return E.$trySetDecorations(u,g.key,C.fromRangeOrRangeWithMessage(a));{const n=new Array(4*a.length);for(let t=0,o=a.length;t<o;t++){const d=a[t];n[4*t]=d.start.line+1,n[4*t+1]=d.start.character+1,n[4*t+2]=d.end.line+1,n[4*t+3]=d.end.character+1}return E.$trySetDecorationsFast(u,g.key,n)}}))},revealRange(g,a){r._runOnProxy(()=>E.$tryRevealRange(u,C.Range.from(g),a||i.TextEditorRevealType.Default))},show(g){E.$tryShowEditor(u,C.ViewColumn.from(g))},hide(){E.$tryHideEditor(u)}})}dispose(){(0,m.ok)(!this._disposed),this._disposed=!0}_acceptOptions(u){(0,m.ok)(!this._disposed),this._options._accept(u)}_acceptVisibleRanges(u){(0,m.ok)(!this._disposed),this._visibleRanges=u}_acceptViewColumn(u){(0,m.ok)(!this._disposed),this._viewColumn=u}_acceptSelections(u){(0,m.ok)(!this._disposed),this._selections=u}async _trySetSelection(){const u=this._selections.map(C.Selection.from);return await this._runOnProxy(()=>this._proxy.$trySetSelections(this.id,u)),this.value}_applyEdit(u){const E=u.finalize();if(E.edits.length===0&&!E.setEndOfLine)return Promise.resolve(!0);const f=E.edits.map(w=>w.range);f.sort((w,I)=>w.end.line===I.end.line?w.end.character===I.end.character?w.start.line===I.start.line?w.start.character-I.start.character:w.start.line-I.start.line:w.end.character-I.end.character:w.end.line-I.end.line);for(let w=0,I=f.length-1;w<I;w++){const p=f[w].end;if(f[w+1].start.isBefore(p))return Promise.reject(new Error("Overlapping ranges are not allowed!"))}const v=E.edits.map(w=>({range:C.Range.from(w.range),text:w.text,forceMoveMarkers:w.forceMoveMarkers}));return this._proxy.$tryApplyEdits(this.id,E.documentVersionId,v,{setEndOfLine:typeof E.setEndOfLine=="number"?C.EndOfLine.from(E.setEndOfLine):void 0,undoStopBefore:E.undoStopBefore,undoStopAfter:E.undoStopAfter})}_runOnProxy(u){return this._disposed?(this._logService.warn("TextEditor is closed/disposed"),Promise.resolve(void 0)):u().then(()=>this,E=>(E instanceof Error&&E.name==="DISPOSED"||this._logService.warn(E),null))}}e.ExtHostTextEditor=R}),define(pe[220],ve([0,1,167,23,2,3,6,18,7,13,16,17,21,204]),function(Y,e,m,L,y,C,i,k,S,D,R,P,u,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTreeViews=void 0;function f(I,p){if((0,D.isString)(I))return{label:I};if(I&&typeof I=="object"&&typeof I.label=="string"){let s;return Array.isArray(I.highlights)&&(s=I.highlights.filter(r=>r.length===2&&typeof r[0]=="number"&&typeof r[1]=="number"),s=s.length?s:void 0),{label:I.label,highlights:s}}}class v{constructor(p,s,r){this._proxy=p,this.commands=s,this.logService=r,this.treeViews=new Map;function g(a){return a&&a.$treeViewId&&a.$treeItemHandle}s.registerArgumentProcessor({processArgument:a=>g(a)?this.convertArgument(a):Array.isArray(a)&&a.length>0?a.map(_=>g(_)?this.convertArgument(_):_):a})}registerTreeDataProvider(p,s,r){const g=this.createTreeView(p,{treeDataProvider:s},r);return{dispose:()=>g.dispose()}}createTreeView(p,s,r){if(!s||!s.treeDataProvider)throw new Error("Options with treeDataProvider is mandatory");const g=s.dragAndDropController?.supportedMimeTypes,a=this._proxy.$registerTreeViewDataProvider(p,{showCollapseAll:!!s.showCollapseAll,canSelectMany:!!s.canSelectMany,dragAndDropMimeTypes:g}),_=this.createExtHostTreeView(p,s,r);return{get onDidCollapseElement(){return _.onDidCollapseElement},get onDidExpandElement(){return _.onDidExpandElement},get selection(){return _.selectedElements},get onDidChangeSelection(){return _.onDidChangeSelection},get visible(){return _.visible},get onDidChangeVisibility(){return _.onDidChangeVisibility},get message(){return _.message},set message(n){_.message=n},get title(){return _.title},set title(n){_.title=n},get description(){return _.description},set description(n){_.description=n},reveal:(n,t)=>_.reveal(n,t),dispose:async()=>{await a,this.treeViews.delete(p),_.dispose()}}}$getChildren(p,s){const r=this.treeViews.get(p);return r?r.getChildren(s):Promise.reject(new Error((0,m.localize)(0,null,p)))}async $onDrop(p,s,r,g,a){const _=this.treeViews.get(p);if(!_)return Promise.reject(new Error((0,m.localize)(1,null,p)));const n=E.TreeDataTransferConverter.toITreeDataTransfer(s);if(g===p&&a){const t=await _.onWillDrop(a);t&&t.forEach((o,d)=>{o&&n.set(d,o)})}return _.onDrop(n,r)}async $hasResolve(p){const s=this.treeViews.get(p);if(!s)throw new Error((0,m.localize)(2,null,p));return s.hasResolve}$resolve(p,s,r){const g=this.treeViews.get(p);if(!g)throw new Error((0,m.localize)(3,null,p));return g.resolveTreeItem(s,r)}$setExpanded(p,s,r){const g=this.treeViews.get(p);if(!g)throw new Error((0,m.localize)(4,null,p));g.setExpanded(s,r)}$setSelection(p,s){const r=this.treeViews.get(p);if(!r)throw new Error((0,m.localize)(5,null,p));r.setSelection(s)}$setVisible(p,s){const r=this.treeViews.get(p);if(!r)throw new Error((0,m.localize)(6,null,p));r.setVisible(s)}createExtHostTreeView(p,s,r){const g=new w(p,s,this._proxy,this.commands.converter,this.logService,r);return this.treeViews.set(p,g),g}convertArgument(p){const s=this.treeViews.get(p.$treeViewId);return s?s.getExtensionElement(p.$treeItemHandle):null}}e.ExtHostTreeViews=v;class w extends i.Disposable{constructor(p,s,r,g,a,_){super();if(this.viewId=p,this.proxy=r,this.commands=g,this.logService=a,this.extension=_,this.roots=void 0,this.elements=new Map,this.nodes=new Map,this._visible=!1,this._selectedHandles=[],this._onDidExpandElement=this._register(new C.Emitter),this.onDidExpandElement=this._onDidExpandElement.event,this._onDidCollapseElement=this._register(new C.Emitter),this.onDidCollapseElement=this._onDidCollapseElement.event,this._onDidChangeSelection=this._register(new C.Emitter),this.onDidChangeSelection=this._onDidChangeSelection.event,this._onDidChangeVisibility=this._register(new C.Emitter),this.onDidChangeVisibility=this._onDidChangeVisibility.event,this._onDidChangeData=this._register(new C.Emitter),this.refreshPromise=Promise.resolve(),this.refreshQueue=Promise.resolve(),this._message="",this._title="",this._refreshCancellationSource=new u.CancellationTokenSource,_.contributes&&_.contributes.views)for(const o in _.contributes.views)for(const d of _.contributes.views[o])d.id===p&&(this._title=d.name);this.dataProvider=s.treeDataProvider,this.dndController=s.dragAndDropController,this.dataProvider.onDidChangeTreeData2?this._register(this.dataProvider.onDidChangeTreeData2(o=>this._onDidChangeData.fire({message:!1,element:o}))):this.dataProvider.onDidChangeTreeData&&this._register(this.dataProvider.onDidChangeTreeData(o=>this._onDidChangeData.fire({message:!1,element:o})));let n,t;this._register(C.Event.debounce(this._onDidChangeData.event,(o,d)=>(o||(o={message:!1,elements:[]}),d.element!==!1&&(n||(n=new Promise(c=>t=c),this.refreshPromise=this.refreshPromise.then(()=>n)),Array.isArray(d.element)?o.elements.push(...d.element):o.elements.push(d.element)),d.message&&(o.message=!0),o),200,!0)(({message:o,elements:d})=>{d.length&&(this.refreshQueue=this.refreshQueue.then(()=>{const c=t;return n=null,this.refresh(d).then(()=>c())})),o&&this.proxy.$setMessage(this.viewId,this._message)}))}get visible(){return this._visible}get selectedElements(){return this._selectedHandles.map(p=>this.getExtensionElement(p)).filter(p=>!(0,D.isUndefinedOrNull)(p))}async getChildren(p){const s=p?this.getExtensionElement(p):void 0;if(p&&!s)return this.logService.error(`No tree item with id '${p}' found.`),Promise.resolve([]);let r=this.getChildrenNodes(p);return r||(r=await this.fetchChildrenNodes(s)),r?r.map(g=>g.item):void 0}getExtensionElement(p){return this.elements.get(p)}reveal(p,s){s=s||{select:!0,focus:!1};const r=(0,D.isUndefinedOrNull)(s.select)?!0:s.select,g=(0,D.isUndefinedOrNull)(s.focus)?!1:s.focus,a=(0,D.isUndefinedOrNull)(s.expand)?!1:s.expand;return typeof this.dataProvider.getParent!="function"?Promise.reject(new Error("Required registered TreeDataProvider to implement 'getParent' method to access 'reveal' method")):p?this.refreshPromise.then(()=>this.resolveUnknownParentChain(p)).then(_=>this.resolveTreeNode(p,_[_.length-1]).then(n=>this.proxy.$reveal(this.viewId,{item:n.item,parentChain:_.map(t=>t.item)},{select:r,focus:g,expand:a})),_=>this.logService.error(_)):this.proxy.$reveal(this.viewId,void 0,{select:r,focus:g,expand:a})}get message(){return this._message}set message(p){this._message=p,this._onDidChangeData.fire({message:!0,element:!1})}get title(){return this._title}set title(p){this._title=p,this.proxy.$setTitle(this.viewId,p,this._description)}get description(){return this._description}set description(p){this._description=p,this.proxy.$setTitle(this.viewId,this._title,p)}setExpanded(p,s){const r=this.getExtensionElement(p);r&&(s?this._onDidExpandElement.fire(Object.freeze({element:r})):this._onDidCollapseElement.fire(Object.freeze({element:r})))}setSelection(p){(0,R.equals)(this._selectedHandles,p)||(this._selectedHandles=p,this._onDidChangeSelection.fire(Object.freeze({selection:this.selectedElements})))}setVisible(p){p!==this._visible&&(this._visible=p,this._onDidChangeVisibility.fire(Object.freeze({visible:this._visible})))}async onWillDrop(p){const s=[];for(const r of p){const g=this.getExtensionElement(r);g&&s.push(g)}if(!(!this.dndController?.onWillDrop||s.length===0))return this.dndController.onWillDrop(s)}async onDrop(p,s){const r=this.getExtensionElement(s);if(!!r)return(0,k.asPromise)(()=>this.dndController?.onDrop(p,r))}get hasResolve(){return!!this.dataProvider.resolveTreeItem}async resolveTreeItem(p,s){if(!this.dataProvider.resolveTreeItem)return;const r=this.elements.get(p);if(r){const g=this.nodes.get(r);if(g){const a=await this.dataProvider.resolveTreeItem(g.extensionItem,r,s)??g.extensionItem;return g.item.tooltip=this.getTooltip(a.tooltip),g.item.command=this.getCommand(g.disposableStore,a.command),g.item}}}resolveUnknownParentChain(p){return this.resolveParent(p).then(s=>s?this.resolveUnknownParentChain(s).then(r=>this.resolveTreeNode(s,r[r.length-1]).then(g=>(r.push(g),r))):Promise.resolve([]))}resolveParent(p){const s=this.nodes.get(p);return s?Promise.resolve(s.parent?this.elements.get(s.parent.item.handle):void 0):(0,k.asPromise)(()=>this.dataProvider.getParent(p))}resolveTreeNode(p,s){const r=this.nodes.get(p);return r?Promise.resolve(r):(0,k.asPromise)(()=>this.dataProvider.getTreeItem(p)).then(g=>this.createHandle(p,g,s,!0)).then(g=>this.getChildren(s?s.item.handle:void 0).then(()=>{const a=this.getExtensionElement(g);if(a){const _=this.nodes.get(a);if(_)return Promise.resolve(_)}throw new Error(`Cannot resolve tree item for element ${g}`)}))}getChildrenNodes(p){if(p){let s;if(typeof p=="string"){const r=this.getExtensionElement(p);s=r?this.nodes.get(r):void 0}else s=p;return s&&s.children||void 0}return this.roots}async fetchChildrenNodes(p){this.clearChildren(p);const s=new u.CancellationTokenSource(this._refreshCancellationSource.token);try{const r=p?this.nodes.get(p):void 0,g=await this.dataProvider.getChildren(p);if(s.token.isCancellationRequested)return;const a=await Promise.all((0,R.coalesce)(g||[]).map(async _=>{const n=await this.dataProvider.getTreeItem(_);return n&&!s.token.isCancellationRequested?this.createAndRegisterTreeNode(_,n,r):null}));return s.token.isCancellationRequested?void 0:(0,R.coalesce)(a)}finally{s.dispose()}}refresh(p){if(p.some(r=>!r))return this._refreshCancellationSource.dispose(!0),this._refreshCancellationSource=new u.CancellationTokenSource,this.clearAll(),this.proxy.$refresh(this.viewId);{const r=this.getHandlesToRefresh(p);if(r.length)return this.refreshHandles(r)}return Promise.resolve(void 0)}getHandlesToRefresh(p){const s=new Set,r=p.map(a=>this.nodes.get(a));for(const a of r)if(a&&!s.has(a.item.handle)){let _=a;for(;_&&_.parent&&r.findIndex(n=>_&&_.parent&&n&&n.item.handle===_.parent.item.handle)===-1;){const n=this.elements.get(_.parent.item.handle);_=n?this.nodes.get(n):void 0}_&&!_.parent&&s.add(a.item.handle)}const g=[];return s.forEach(a=>{const _=this.elements.get(a);if(_){const n=this.nodes.get(_);n&&(!n.parent||!s.has(n.parent.item.handle))&&g.push(a)}}),g}refreshHandles(p){const s={};return Promise.all(p.map(r=>this.refreshNode(r).then(g=>{g&&(s[r]=g.item)}))).then(()=>Object.keys(s).length?this.proxy.$refresh(this.viewId,s):void 0)}refreshNode(p){const s=this.getExtensionElement(p);if(s){const r=this.nodes.get(s);if(r)return this.clearChildren(s),(0,k.asPromise)(()=>this.dataProvider.getTreeItem(s)).then(g=>{if(g){const a=this.createTreeNode(s,g,r.parent);return this.updateNodeCache(s,a,r,r.parent),r.dispose(),a}return null})}return Promise.resolve(null)}createAndRegisterTreeNode(p,s,r){const g=this.createTreeNode(p,s,r);if(s.id&&this.elements.has(g.item.handle))throw new Error((0,m.localize)(7,null,s.id));return this.addNodeToCache(p,g),this.addNodeToParentCache(g,r),g}getTooltip(p){return S.MarkdownString.isMarkdownString(p)?P.MarkdownString.from(p):p}getCommand(p,s){return s?this.commands.toInternal(s,p):void 0}createTreeNode(p,s,r){const g=new i.DisposableStore,a=this.createHandle(p,s,r),_=this.getLightIconPath(s);return{item:{handle:a,parentHandle:r?r.item.handle:void 0,label:f(s.label,this.extension),description:s.description,resourceUri:s.resourceUri,tooltip:this.getTooltip(s.tooltip),command:this.getCommand(g,s.command),contextValue:s.contextValue,icon:_,iconDark:this.getDarkIconPath(s)||_,themeIcon:this.getThemeIcon(s),collapsibleState:(0,D.isUndefinedOrNull)(s.collapsibleState)?S.TreeItemCollapsibleState.None:s.collapsibleState,accessibilityInformation:s.accessibilityInformation},extensionItem:s,parent:r,children:void 0,disposableStore:g,dispose(){g.dispose()}}}getThemeIcon(p){return p.iconPath instanceof S.ThemeIcon?p.iconPath:void 0}createHandle(p,{id:s,label:r,resourceUri:g},a,_){if(s)return`${w.ID_HANDLE_PREFIX}/${s}`;const n=f(r,this.extension),t=a?a.item.handle:w.LABEL_HANDLE_PREFIX;let o=n?n.label:g?(0,L.basename)(g):"";o=o.indexOf("/")!==-1?o.replace("/","//"):o;const d=this.nodes.has(p)?this.nodes.get(p).item.handle:void 0,c=this.getChildrenNodes(a)||[];let h,l=0;do{if(h=`${t}/${l}:${o}`,_||!this.elements.has(h)||d===h)break;l++}while(l<=c.length);return h}getLightIconPath(p){if(p.iconPath&&!(p.iconPath instanceof S.ThemeIcon))return typeof p.iconPath=="string"||y.URI.isUri(p.iconPath)?this.getIconPath(p.iconPath):this.getIconPath(p.iconPath.light)}getDarkIconPath(p){if(p.iconPath&&!(p.iconPath instanceof S.ThemeIcon)&&p.iconPath.dark)return this.getIconPath(p.iconPath.dark)}getIconPath(p){return y.URI.isUri(p)?p:y.URI.file(p)}addNodeToCache(p,s){this.elements.set(s.item.handle,p),this.nodes.set(p,s)}updateNodeCache(p,s,r,g){this.elements.delete(s.item.handle),this.nodes.delete(p),s.item.handle!==r.item.handle&&this.elements.delete(r.item.handle),this.addNodeToCache(p,s);const a=this.getChildrenNodes(g)||[],_=a.filter(n=>n.item.handle===r.item.handle)[0];_&&a.splice(a.indexOf(_),1,s)}addNodeToParentCache(p,s){s?(s.children||(s.children=[]),s.children.push(p)):(this.roots||(this.roots=[]),this.roots.push(p))}clearChildren(p){if(p){const s=this.nodes.get(p);if(s){if(s.children)for(const r of s.children){const g=this.elements.get(r.item.handle);g&&this.clear(g)}s.children=void 0}}else this.clearAll()}clear(p){const s=this.nodes.get(p);if(s){if(s.children)for(const r of s.children){const g=this.elements.get(r.item.handle);g&&this.clear(g)}this.nodes.delete(p),this.elements.delete(s.item.handle),s.dispose()}}clearAll(){this.roots=void 0,this.elements.clear(),this.nodes.forEach(p=>p.dispose()),this.nodes.clear()}dispose(){this._refreshCancellationSource.dispose(),this.clearAll()}}w.LABEL_HANDLE_PREFIX="0",w.ID_HANDLE_PREFIX="1"}),define(pe[221],ve([0,1,18,3,6,13,63,17,126,89]),function(Y,e,m,L,y,C,i,k,S,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SingleUseTestCollection=void 0;class R extends y.Disposable{constructor(u){super();this.controllerId=u,this.debounceSendDiff=this._register(new m.RunOnceScheduler(()=>this.flushDiff(),200)),this.diffOpEmitter=this._register(new L.Emitter),this.root=new i.TestItemRootImpl(this.controllerId,this.controllerId),this.tree=new Map,this.tags=new Map,this.diff=[],this.onDidGenerateDiff=this.diffOpEmitter.event,this.root.canResolveChildren=!0,this.upsertItem(this.root,void 0)}set resolveHandler(u){this._resolveHandler=u;for(const E of this.tree.values())this.updateExpandability(E)}collectDiff(){const u=this.diff;return this.diff=[],u}pushDiff(u){const E=this.diff[this.diff.length-1];if(E&&u[0]===1){if(E[0]===1&&E[1].extId===u[1].extId){(0,S.applyTestItemUpdate)(E[1],u[1]);return}if(E[0]===0&&E[1].item.extId===u[1].extId){(0,S.applyTestItemUpdate)(E[1],u[1]);return}}this.diff.push(u),this.debounceSendDiff.isScheduled()||this.debounceSendDiff.schedule()}expand(u,E){const f=this.tree.get(u);if(!!f){if((f.expandLevels===void 0||E>f.expandLevels)&&(f.expandLevels=E),f.expand===1){const v=this.resolveChildren(f);return v.isOpen()?this.expandChildren(f,E-1):v.wait().then(()=>this.expandChildren(f,E-1))}else if(f.expand===3)return f.resolveBarrier?.isOpen()===!1?f.resolveBarrier.wait().then(()=>this.expandChildren(f,E-1)):this.expandChildren(f,E-1)}}dispose(){for(const u of this.tree.values())(0,i.getPrivateApiFor)(u.actual).listener=void 0;this.tree.clear(),this.diff=[],super.dispose()}onTestItemEvent(u,E){switch(E.op){case 2:this.pushDiff([4,u.fullId.toString()]);break;case 1:this.removeItem(D.TestId.joinToString(u.fullId,E.id));break;case 0:this.upsertItem(E.item,u);break;case 4:for(const p of E.ops)this.onTestItemEvent(u,p);break;case 3:const{key:f,value:v,previous:w}=E,I=u.fullId.toString();switch(f){case"canResolveChildren":this.updateExpandability(u);break;case"tags":this.diffTagRefs(v,w,I);break;case"range":this.pushDiff([1,{extId:I,item:{range:k.Range.from(v)}}]);break;case"error":this.pushDiff([1,{extId:I,item:{error:k.MarkdownString.fromStrict(v)||null}}]);break;default:this.pushDiff([1,{extId:I,item:{[f]:v??null}}]);break}break;default:(0,C.assertNever)(E)}}upsertItem(u,E){if(!(u instanceof i.TestItemImpl))throw new Error(`TestItems provided to the VS Code API must extend \`vscode.TestItem\`, but ${u.id} did not`);const f=D.TestId.fromExtHostTestItem(u,this.root.id,E?.actual),v=(0,i.getPrivateApiFor)(u);v.parent&&v.parent!==E?.actual&&v.parent.children.delete(u.id);let w=this.tree.get(f.toString());if(!w){w={fullId:f,actual:u,parent:E?f.parentId:null,expandLevels:E?.expandLevels?E.expandLevels-1:void 0,expand:0},u.tags.forEach(this.incrementTagRefs,this),this.tree.set(w.fullId.toString(),w),this.setItemParent(u,E),this.pushDiff([0,{parent:w.parent&&w.parent.toString(),controllerId:this.controllerId,expand:w.expand,item:k.TestItem.from(u)}]),this.connectItemAndChildren(u,w,E);return}if(w.actual===u){this.connectItem(u,w,E);return}const I=w.actual.children,p=w.actual,s=(0,i.diffTestItems)(p,u);(0,i.getPrivateApiFor)(p).listener=void 0,w.actual=u,w.expand=0;for(const[r,g]of s)this.onTestItemEvent(w,{op:3,key:r,value:g,previous:p[r]});this.connectItemAndChildren(u,w,E);for(const r of I)u.children.get(r.id)||this.removeItem(D.TestId.joinToString(f,r.id))}diffTagRefs(u,E,f){const v=new Set(E.map(w=>w.id));for(const w of u)v.delete(w.id)||this.incrementTagRefs(w);this.pushDiff([1,{extId:f,item:{tags:u.map(w=>k.TestTag.namespace(this.controllerId,w.id))}}]),v.forEach(this.decrementTagRefs,this)}incrementTagRefs(u){const E=this.tags.get(u.id);E?E.refCount++:(this.tags.set(u.id,{refCount:1}),this.pushDiff([5,{id:k.TestTag.namespace(this.controllerId,u.id),ctrlLabel:this.root.label}]))}decrementTagRefs(u){const E=this.tags.get(u);E&&!--E.refCount&&(this.tags.delete(u),this.pushDiff([6,k.TestTag.namespace(this.controllerId,u)]))}setItemParent(u,E){(0,i.getPrivateApiFor)(u).parent=E&&E.actual!==this.root?E.actual:void 0}connectItem(u,E,f){this.setItemParent(u,f);const v=(0,i.getPrivateApiFor)(u);v.parent=f?.actual,v.listener=w=>this.onTestItemEvent(E,w),this.updateExpandability(E)}connectItemAndChildren(u,E,f){this.connectItem(u,E,f);for(const v of u.children)this.upsertItem(v,E)}updateExpandability(u){let E;this._resolveHandler?u.resolveBarrier?E=u.resolveBarrier.isOpen()?3:2:E=u.actual.canResolveChildren?1:0:E=0,E!==u.expand&&(u.expand=E,this.pushDiff([1,{extId:u.fullId.toString(),expand:E}]),E===1&&u.expandLevels!==void 0&&this.resolveChildren(u))}expandChildren(u,E){if(E<0)return;const f=[];for(const v of u.actual.children){const w=this.expand(D.TestId.joinToString(u.fullId,v.id),E);(0,m.isThenable)(w)&&f.push(w)}if(f.length)return Promise.all(f).then(()=>{})}resolveChildren(u){if(u.resolveBarrier)return u.resolveBarrier;if(!this._resolveHandler){const w=new m.Barrier;return w.open(),w}u.expand=2,this.pushExpandStateUpdate(u);const E=u.resolveBarrier=new m.Barrier,f=w=>{console.error(`Unhandled error in resolveHandler of test controller "${this.controllerId}"`),u.actual!==this.root&&(u.actual.error=w.stack||w.message||String(w))};let v;try{v=this._resolveHandler(u.actual===this.root?void 0:u.actual)}catch(w){f(w)}return(0,m.isThenable)(v)?v.catch(f).then(()=>{E.open(),this.updateExpandability(u)}):(E.open(),this.updateExpandability(u)),u.resolveBarrier}pushExpandStateUpdate(u){this.pushDiff([1,{extId:u.fullId.toString(),expand:u.expand}])}removeItem(u){const E=this.tree.get(u);if(!E)throw new Error("attempting to remove non-existent child");this.pushDiff([2,u]);const f=[E];for(;f.length;){const v=f.pop();if(!!v){(0,i.getPrivateApiFor)(v.actual).listener=void 0;for(const w of v.actual.tags)this.decrementTagRefs(w.id);this.tree.delete(v.fullId.toString());for(const w of v.actual.children)f.push(this.tree.get(D.TestId.joinToString(v.fullId,w.id)))}}}flushDiff(){const u=this.collectDiff();u.length&&this.diffOpEmitter.fire(u)}}e.SingleUseTestCollection=R}),define(pe[222],ve([0,1,4,182]),function(Y,e,m,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IWorkbenchEnvironmentService=void 0,e.IWorkbenchEnvironmentService=(0,m.refineServiceDecorator)(L.IEnvironmentService)}),define(pe[223],ve([0,1,27,3,9]),function(Y,e,m,L,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionDescriptionRegistry=e.DeltaExtensionsResult=void 0;class C{constructor(R){this.removedDueToLooping=R}}e.DeltaExtensionsResult=C;class i{constructor(R){this._onDidChange=new L.Emitter,this.onDidChange=this._onDidChange.event,this._extensionDescriptions=R,this._initialize()}_initialize(){this._extensionDescriptions.sort(S),this._extensionsMap=new Map,this._extensionsArr=[],this._activationMap=new Map;for(const R of this._extensionDescriptions){if(this._extensionsMap.has(m.ExtensionIdentifier.toKey(R.identifier))){console.error("Extension `"+R.identifier.value+"` is already registered");continue}if(this._extensionsMap.set(m.ExtensionIdentifier.toKey(R.identifier),R),this._extensionsArr.push(R),Array.isArray(R.activationEvents))for(let P of R.activationEvents)P==="onUri"&&(P=`onUri:${m.ExtensionIdentifier.toKey(R.identifier)}`),this._activationMap.has(P)||this._activationMap.set(P,[]),this._activationMap.get(P).push(R)}}keepOnly(R){const P=new Set;R.forEach(u=>P.add(m.ExtensionIdentifier.toKey(u))),this._extensionDescriptions=this._extensionDescriptions.filter(u=>P.has(m.ExtensionIdentifier.toKey(u.identifier))),this._initialize(),this._onDidChange.fire(void 0)}deltaExtensions(R,P){R.length>0&&(this._extensionDescriptions=this._extensionDescriptions.concat(R));const u=i._findLoopingExtensions(this._extensionDescriptions);if(P=P.concat(u.map(E=>E.identifier)),P.length>0){const E=new Set;P.forEach(f=>E.add(m.ExtensionIdentifier.toKey(f))),this._extensionDescriptions=this._extensionDescriptions.filter(f=>!E.has(m.ExtensionIdentifier.toKey(f.identifier)))}return this._initialize(),this._onDidChange.fire(void 0),new C(u)}static _findLoopingExtensions(R){const P=new class{constructor(){this._arcs=new Map,this._nodesSet=new Set,this._nodesArr=[]}addNode(w){this._nodesSet.has(w)||(this._nodesSet.add(w),this._nodesArr.push(w))}addArc(w,I){this.addNode(w),this.addNode(I),this._arcs.has(w)?this._arcs.get(w).push(I):this._arcs.set(w,[I])}getArcs(w){return this._arcs.has(w)?this._arcs.get(w):[]}hasOnlyGoodArcs(w,I){const p=P.getArcs(w);for(let s=0;s<p.length;s++)if(!I.has(p[s]))return!1;return!0}getNodes(){return this._nodesArr}};let u=new Map;for(let w of R){const I=m.ExtensionIdentifier.toKey(w.identifier);if(u.set(I,w),w.extensionDependencies)for(let p of w.extensionDependencies){const s=m.ExtensionIdentifier.toKey(p);P.addArc(I,s)}}let E=new Set;P.getNodes().filter(w=>P.getArcs(w).length===0).forEach(w=>E.add(w));let f=P.getNodes().filter(w=>!E.has(w)),v;do{v=!1;for(let w=0;w<f.length;w++){const I=f[w];P.hasOnlyGoodArcs(I,E)&&(f.splice(w,1),w--,E.add(I),v=!0)}}while(v);return f.map(w=>u.get(w))}containsActivationEvent(R){return this._activationMap.has(R)}containsExtension(R){return this._extensionsMap.has(m.ExtensionIdentifier.toKey(R))}getExtensionDescriptionsForActivationEvent(R){const P=this._activationMap.get(R);return P?P.slice(0):[]}getAllExtensionDescriptions(){return this._extensionsArr.slice(0)}getExtensionDescription(R){const P=this._extensionsMap.get(m.ExtensionIdentifier.toKey(R));return P||void 0}}e.ExtensionDescriptionRegistry=i;var k;(function(D){D[D.Builtin=0]="Builtin",D[D.User=1]="User",D[D.Dev=2]="Dev"})(k||(k={}));function S(D,R){const P=D.isBuiltin?0:D.isUnderDevelopment?2:1,u=R.isBuiltin?0:R.isUnderDevelopment?2:1;if(P!==u)return P-u;const E=y.posix.basename(D.extensionLocation.path),f=y.posix.basename(R.extensionLocation.path);return E<f?-1:E>f?1:0}}),define(pe[224],ve([0,1,22]),function(Y,e,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isMessageOfType=e.createMessageOfType=e.MessageType=e.ExtensionHostExitCode=void 0;var L;(function(k){k[k.VersionMismatch=55]="VersionMismatch",k[k.UnexpectedError=81]="UnexpectedError"})(L=e.ExtensionHostExitCode||(e.ExtensionHostExitCode={}));var y;(function(k){k[k.Initialized=0]="Initialized",k[k.Ready=1]="Ready",k[k.Terminate=2]="Terminate"})(y=e.MessageType||(e.MessageType={}));function C(k){const S=m.VSBuffer.alloc(1);switch(k){case 0:S.writeUInt8(1,0);break;case 1:S.writeUInt8(2,0);break;case 2:S.writeUInt8(3,0);break}return S}e.createMessageOfType=C;function i(k,S){if(k.byteLength!==1)return!1;switch(k.readUInt8(0)){case 1:return S===0;case 2:return S===1;case 3:return S===2;default:return!1}}e.isMessageOfType=i}),define(pe[29],ve([0,1,3,2,4,27,193]),function(Y,e,m,L,y,C,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NullExtensionService=e.toExtensionDescription=e.toExtension=e.ActivationKind=e.ExtensionHostLogFileName=e.ExtensionPointContribution=e.ActivationTimes=e.checkProposedApiEnabled=e.isProposedApiEnabled=e.extensionHostKindToString=e.ExtensionHostKind=e.MissingExtensionDependency=e.extensionRunningLocationToString=e.ExtensionRunningLocation=e.IExtensionService=e.webWorkerExtHostConfig=e.nullExtensionDescription=void 0,e.nullExtensionDescription=Object.freeze({identifier:new C.ExtensionIdentifier("nullExtensionDescription"),name:"Null Extension Description",version:"0.0.0",publisher:"vscode",engines:{vscode:""},extensionLocation:L.URI.parse("void:location"),isBuiltin:!1}),e.webWorkerExtHostConfig="extensions.webWorker",e.IExtensionService=(0,y.createDecorator)("extensionService");var k;(function(r){r[r.None=0]="None",r[r.LocalProcess=1]="LocalProcess",r[r.LocalWebWorker=2]="LocalWebWorker",r[r.Remote=3]="Remote"})(k=e.ExtensionRunningLocation||(e.ExtensionRunningLocation={}));function S(r){switch(r){case 0:return"None";case 1:return"LocalProcess";case 2:return"LocalWebWorker";case 3:return"Remote"}}e.extensionRunningLocationToString=S;class D{constructor(g){this.dependency=g}}e.MissingExtensionDependency=D;var R;(function(r){r[r.LocalProcess=0]="LocalProcess",r[r.LocalWebWorker=1]="LocalWebWorker",r[r.Remote=2]="Remote"})(R=e.ExtensionHostKind||(e.ExtensionHostKind={}));function P(r){switch(r){case 0:return"LocalProcess";case 1:return"LocalWebWorker";case 2:return"Remote"}}e.extensionHostKindToString=P;function u(r,g){return r.enabledApiProposals?r.enabledApiProposals.includes(g):!1}e.isProposedApiEnabled=u;function E(r,g){if(!u(r,g))throw new Error(`Extension '${r.identifier.value}' CANNOT use API proposal: ${g}.
Its package.json#enabledApiProposals-property declares: ${r.enabledApiProposals?.join(", ")??"[]"} but NOT ${g}.
 The missing proposal MUST be added and you must start in extension development mode or use the following command line switch: --enable-proposed-api ${r.identifier.value}`)}e.checkProposedApiEnabled=E;class f{constructor(g,a,_,n){this.codeLoadingTime=g,this.activateCallTime=a,this.activateResolvedTime=_,this.activationReason=n}}e.ActivationTimes=f;class v{constructor(g,a){this.description=g,this.value=a}}e.ExtensionPointContribution=v,e.ExtensionHostLogFileName="exthost";var w;(function(r){r[r.Normal=0]="Normal",r[r.Immediate=1]="Immediate"})(w=e.ActivationKind||(e.ActivationKind={}));function I(r){return{type:r.isBuiltin?0:1,isBuiltin:r.isBuiltin||r.isUserBuiltin,identifier:{id:(0,i.getGalleryExtensionId)(r.publisher,r.name),uuid:r.uuid},manifest:r,location:r.extensionLocation}}e.toExtension=I;function p(r,g){return{identifier:new C.ExtensionIdentifier(r.identifier.id),isBuiltin:r.type===0,isUserBuiltin:r.type===1&&r.isBuiltin,isUnderDevelopment:!!g,extensionLocation:r.location,...r.manifest,uuid:r.identifier.uuid}}e.toExtensionDescription=p;class s{constructor(){this.onDidRegisterExtensions=m.Event.None,this.onDidChangeExtensionsStatus=m.Event.None,this.onDidChangeExtensions=m.Event.None,this.onWillActivateByEvent=m.Event.None,this.onDidChangeResponsiveChange=m.Event.None}activateByEvent(g){return Promise.resolve(void 0)}whenInstalledExtensionsRegistered(){return Promise.resolve(!0)}getExtensions(){return Promise.resolve([])}getExtension(){return Promise.resolve(void 0)}readExtensionPointContributions(g){return Promise.resolve(Object.create(null))}getExtensionsStatus(){return Object.create(null)}getInspectPort(g){return Promise.resolve(0)}stopExtensionHosts(){}async restartExtensionHost(){}async startExtensionHosts(){}async setRemoteEnvironment(g){}canAddExtension(){return!1}canRemoveExtension(){return!1}_activateById(g,a){return Promise.resolve()}_onWillActivateExtension(g){}_onDidActivateExtension(g,a,_,n,t){}_onDidActivateExtensionError(g,a){}_onExtensionRuntimeError(g,a){}_onExtensionHostExit(g){}}e.NullExtensionService=s}),define(pe[225],ve([0,1,15,27,29,11]),function(Y,e,m,L,y,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsActivator=e.FailedExtension=e.HostExtension=e.EmptyExtension=e.ActivatedExtension=e.ExtensionActivationTimesBuilder=e.ExtensionActivationTimes=void 0;const i=Promise.resolve(void 0);class k{constructor(v,w,I,p){this.startup=v,this.codeLoadingTime=w,this.activateCallTime=I,this.activateResolvedTime=p}}e.ExtensionActivationTimes=k,k.NONE=new k(!1,-1,-1,-1);class S{constructor(v){this._startup=v,this._codeLoadingStart=-1,this._codeLoadingStop=-1,this._activateCallStart=-1,this._activateCallStop=-1,this._activateResolveStart=-1,this._activateResolveStop=-1}_delta(v,w){return v===-1||w===-1?-1:w-v}build(){return new k(this._startup,this._delta(this._codeLoadingStart,this._codeLoadingStop),this._delta(this._activateCallStart,this._activateCallStop),this._delta(this._activateResolveStart,this._activateResolveStop))}codeLoadingStart(){this._codeLoadingStart=Date.now()}codeLoadingStop(){this._codeLoadingStop=Date.now()}activateCallStart(){this._activateCallStart=Date.now()}activateCallStop(){this._activateCallStop=Date.now()}activateResolveStart(){this._activateResolveStart=Date.now()}activateResolveStop(){this._activateResolveStop=Date.now()}}e.ExtensionActivationTimesBuilder=S;class D{constructor(v,w,I,p,s,r){this.activationFailed=v,this.activationFailedError=w,this.activationTimes=I,this.module=p,this.exports=s,this.subscriptions=r}}e.ActivatedExtension=D;class R extends D{constructor(v){super(!1,null,v,{activate:void 0,deactivate:void 0},void 0,[])}}e.EmptyExtension=R;class P extends D{constructor(){super(!1,null,k.NONE,{activate:void 0,deactivate:void 0},void 0,[])}}e.HostExtension=P;class u extends D{constructor(v){super(!0,v,k.NONE,{activate:void 0,deactivate:void 0},void 0,[])}}e.FailedExtension=u;let E=class{constructor(v,w,I,p,s){this._logService=s,this._isDisposed=!1,this._registry=v,this._resolvedExtensionsSet=new Set,w.forEach(r=>this._resolvedExtensionsSet.add(L.ExtensionIdentifier.toKey(r))),this._hostExtensionsMap=new Map,I.forEach(r=>this._hostExtensionsMap.set(L.ExtensionIdentifier.toKey(r),r)),this._host=p,this._activatingExtensions=new Map,this._activatedExtensions=new Map,this._alreadyActivatedEvents=Object.create(null)}dispose(){this._isDisposed=!0}isActivated(v){const w=L.ExtensionIdentifier.toKey(v);return this._activatedExtensions.has(w)}getActivatedExtension(v){const w=L.ExtensionIdentifier.toKey(v),I=this._activatedExtensions.get(w);if(!I)throw new Error("Extension `"+v.value+"` is not known or not activated");return I}activateByEvent(v,w){if(this._alreadyActivatedEvents[v])return i;const I=this._registry.getExtensionDescriptionsForActivationEvent(v);return this._activateExtensions(I.map(p=>({id:p.identifier,reason:{startup:w,extensionId:p.identifier,activationEvent:v}}))).then(()=>{this._alreadyActivatedEvents[v]=!0})}activateById(v,w){const I=this._registry.getExtensionDescription(v);if(!I)throw new Error("Extension `"+v+"` is not known");return this._activateExtensions([{id:I.identifier,reason:w}])}_handleActivateRequest(v,w,I){if(this._hostExtensionsMap.has(L.ExtensionIdentifier.toKey(v.id))){w[L.ExtensionIdentifier.toKey(v.id)]=v;return}const p=this._registry.getExtensionDescription(v.id);if(!p){const g=new Error(`Cannot activate unknown extension '${v.id.value}'`);this._host.onExtensionActivationError(v.id,g,new y.MissingExtensionDependency(v.id.value)),this._activatedExtensions.set(L.ExtensionIdentifier.toKey(v.id),new u(g));return}const s=typeof p.extensionDependencies=="undefined"?[]:p.extensionDependencies;let r=!0;for(let g=0,a=s.length;g<a;g++){const _=s[g];if(this._resolvedExtensionsSet.has(L.ExtensionIdentifier.toKey(_)))continue;const n=this._activatedExtensions.get(L.ExtensionIdentifier.toKey(_));if(n&&!n.activationFailed)continue;if(n&&n.activationFailed){const c=p.displayName||p.identifier.value,h=this._registry.getExtensionDescription(_),l=h&&h.displayName||_,b=new Error(`Cannot activate the '${c}' extension because its dependency '${l}' failed to activate`);b.detail=n.activationFailedError,this._host.onExtensionActivationError(p.identifier,b,null),this._activatedExtensions.set(L.ExtensionIdentifier.toKey(p.identifier),new u(b));return}if(this._hostExtensionsMap.has(L.ExtensionIdentifier.toKey(_))){r=!1,w[L.ExtensionIdentifier.toKey(_)]={id:this._hostExtensionsMap.get(L.ExtensionIdentifier.toKey(_)),reason:v.reason};continue}const t=this._registry.getExtensionDescription(_);if(t){if(!t.main&&!t.browser)continue;r=!1,w[L.ExtensionIdentifier.toKey(_)]={id:t.identifier,reason:v.reason};continue}const o=p.displayName||p.identifier.value,d=new Error(`Cannot activate the '${o}' extension because it depends on unknown extension '${_}'`);this._host.onExtensionActivationError(p.identifier,d,new y.MissingExtensionDependency(_)),this._activatedExtensions.set(L.ExtensionIdentifier.toKey(p.identifier),new u(d));return}r?w[L.ExtensionIdentifier.toKey(p.identifier)]=v:I.push(v)}_activateExtensions(v){if(v.length===0||(v=v.filter(s=>!this._activatedExtensions.has(L.ExtensionIdentifier.toKey(s.id))),v.length===0))return Promise.resolve(void 0);const w=Object.create(null),I=[];for(let s=0,r=v.length;s<r;s++)this._handleActivateRequest(v[s],w,I);for(let s=0,r=I.length;s<r;s++){const g=L.ExtensionIdentifier.toKey(I[s].id);w[g]&&delete w[g]}const p=Object.keys(w).map(s=>w[s]);return I.length===0?Promise.all(p.map(s=>this._activateExtension(s.id,s.reason))).then(s=>{}):this._activateExtensions(p).then(s=>this._activateExtensions(I))}_activateExtension(v,w){const I=L.ExtensionIdentifier.toKey(v);if(this._activatedExtensions.has(I))return Promise.resolve(void 0);const p=this._activatingExtensions.get(I);if(p)return p;const s=this._host.actualActivateExtension(v,w).then(void 0,r=>{const g=new Error;return r&&r.name&&(g.name=r.name),r&&r.message?g.message=`Activating extension '${v.value}' failed: ${r.message}.`:g.message=`Activating extension '${v.value}' failed: ${r}.`,r&&r.stack&&(g.stack=r.stack),this._isDisposed&&m.isPromiseCanceledError(r)?new u(r):(this._host.onExtensionActivationError(v,g,null),this._logService.error(`Activating extension ${v.value} failed due to an error:`),this._logService.error(r),new u(r))}).then(r=>{this._activatedExtensions.set(I,r),this._activatingExtensions.delete(I)});return this._activatingExtensions.set(I,s),s}};E=je([He(4,C.ILogService)],E),e.ExtensionsActivator=E}),define(pe[226],ve([0,1,11,26,29]),function(Y,e,m,L,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLogService=void 0;let C=class extends m.LogService{constructor(k,S){super(k.createLogger(S.logFile,{name:y.ExtensionHostLogFileName}))}};C=je([He(0,m.ILoggerService),He(1,L.IExtHostInitDataService)],C),e.ExtHostLogService=C}),define(pe[227],ve([0,1,15]),function(Y,e,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LazyPromise=void 0;class L{constructor(){this._actual=null,this._actualOk=null,this._actualErr=null,this._hasValue=!1,this._value=null,this._hasErr=!1,this._err=null}get[Symbol.toStringTag](){return this.toString()}_ensureActual(){return this._actual||(this._actual=new Promise((C,i)=>{this._actualOk=C,this._actualErr=i,this._hasValue&&this._actualOk(this._value),this._hasErr&&this._actualErr(this._err)})),this._actual}resolveOk(C){this._hasValue||this._hasErr||(this._hasValue=!0,this._value=C,this._actual&&this._actualOk(C))}resolveErr(C){this._hasValue||this._hasErr||(this._hasErr=!0,this._err=C,this._actual?this._actualErr(C):(0,m.onUnexpectedError)(C))}then(C,i){return this._ensureActual().then(C,i)}catch(C){return this._ensureActual().then(void 0,C)}finally(C){return this._ensureActual().finally(C)}}e.LazyPromise=L}),define(pe[53],ve([0,1]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SerializableObjectWithBuffers=e.getStringIdentifierForProxy=e.createExtHostContextProxyIdentifier=e.createMainContextProxyIdentifier=e.ProxyIdentifier=void 0;class m{constructor(D,R){this._proxyIdentifierBrand=void 0,this.isMain=D,this.sid=R,this.nid=++m.count}}e.ProxyIdentifier=m,m.count=0;const L=[];function y(S){const D=new m(!0,S);return L[D.nid]=D,D}e.createMainContextProxyIdentifier=y;function C(S){const D=new m(!1,S);return L[D.nid]=D,D}e.createExtHostContextProxyIdentifier=C;function i(S){return L[S].sid}e.getStringIdentifierForProxy=i;class k{constructor(D){this.value=D}}e.SerializableObjectWithBuffers=k}),define(pe[5],ve([0,1,59,2,53]),function(Y,e,m,L,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostContext=e.MainContext=e.ExtHostTestingResource=e.reviveWorkspaceEditDto=e.WorkspaceEditType=e.ISuggestResultDtoField=e.ISuggestDataDtoField=e.IdObject=e.ObjectIdentifier=e.CandidatePortSource=e.NotebookEditorRevealType=e.CellOutputKind=e.WebviewMessageArrayBufferViewType=e.WebviewEditorCapabilities=e.TextEditorRevealType=e.UIKind=void 0;var C;(function(s){s[s.Desktop=1]="Desktop",s[s.Web=2]="Web"})(C=e.UIKind||(e.UIKind={}));var i;(function(s){s[s.Default=0]="Default",s[s.InCenter=1]="InCenter",s[s.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",s[s.AtTop=3]="AtTop"})(i=e.TextEditorRevealType||(e.TextEditorRevealType={}));var k;(function(s){s[s.Editable=0]="Editable",s[s.SupportsHotExit=1]="SupportsHotExit"})(k=e.WebviewEditorCapabilities||(e.WebviewEditorCapabilities={}));var S;(function(s){s[s.Int8Array=1]="Int8Array",s[s.Uint8Array=2]="Uint8Array",s[s.Uint8ClampedArray=3]="Uint8ClampedArray",s[s.Int16Array=4]="Int16Array",s[s.Uint16Array=5]="Uint16Array",s[s.Int32Array=6]="Int32Array",s[s.Uint32Array=7]="Uint32Array",s[s.Float32Array=8]="Float32Array",s[s.Float64Array=9]="Float64Array",s[s.BigInt64Array=10]="BigInt64Array",s[s.BigUint64Array=11]="BigUint64Array"})(S=e.WebviewMessageArrayBufferViewType||(e.WebviewMessageArrayBufferViewType={}));var D;(function(s){s[s.Text=1]="Text",s[s.Error=2]="Error",s[s.Rich=3]="Rich"})(D=e.CellOutputKind||(e.CellOutputKind={}));var R;(function(s){s[s.Default=0]="Default",s[s.InCenter=1]="InCenter",s[s.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",s[s.AtTop=3]="AtTop"})(R=e.NotebookEditorRevealType||(e.NotebookEditorRevealType={}));var P;(function(s){s[s.None=0]="None",s[s.Process=1]="Process",s[s.Output=2]="Output"})(P=e.CandidatePortSource||(e.CandidatePortSource={}));var u;(function(s){s.name="$ident";function r(a,_){return Object.defineProperty(a,s.name,{value:_,enumerable:!0}),a}s.mixin=r;function g(a){return a[s.name]}s.of=g})(u=e.ObjectIdentifier||(e.ObjectIdentifier={}));class E{static mixin(r){return r._id=E._n++,r}}e.IdObject=E,E._n=0;var f;(function(s){s.label="a",s.kind="b",s.detail="c",s.documentation="d",s.sortText="e",s.filterText="f",s.preselect="g",s.insertText="h",s.insertTextRules="i",s.range="j",s.commitCharacters="k",s.additionalTextEdits="l",s.command="m",s.kindModifier="n"})(f=e.ISuggestDataDtoField||(e.ISuggestDataDtoField={}));var v;(function(s){s.defaultRanges="a",s.completions="b",s.isIncomplete="c",s.duration="d"})(v=e.ISuggestResultDtoField||(e.ISuggestResultDtoField={}));var w;(function(s){s[s.File=1]="File",s[s.Text=2]="Text",s[s.Cell=3]="Cell"})(w=e.WorkspaceEditType||(e.WorkspaceEditType={}));function I(s){if(s&&s.edits)for(const r of s.edits)typeof r.resource=="object"?r.resource=L.URI.revive(r.resource):(r.newUri=L.URI.revive(r.newUri),r.oldUri=L.URI.revive(r.oldUri)),r.metadata&&r.metadata.iconPath&&(r.metadata=(0,m.revive)(r.metadata));return s}e.reviveWorkspaceEditDto=I;var p;(function(s){s[s.Workspace=0]="Workspace",s[s.TextDocument=1]="TextDocument"})(p=e.ExtHostTestingResource||(e.ExtHostTestingResource={})),e.MainContext={MainThreadAuthentication:(0,y.createMainContextProxyIdentifier)("MainThreadAuthentication"),MainThreadBulkEdits:(0,y.createMainContextProxyIdentifier)("MainThreadBulkEdits"),MainThreadClipboard:(0,y.createMainContextProxyIdentifier)("MainThreadClipboard"),MainThreadCommands:(0,y.createMainContextProxyIdentifier)("MainThreadCommands"),MainThreadComments:(0,y.createMainContextProxyIdentifier)("MainThreadComments"),MainThreadConfiguration:(0,y.createMainContextProxyIdentifier)("MainThreadConfiguration"),MainThreadConsole:(0,y.createMainContextProxyIdentifier)("MainThreadConsole"),MainThreadDebugService:(0,y.createMainContextProxyIdentifier)("MainThreadDebugService"),MainThreadDecorations:(0,y.createMainContextProxyIdentifier)("MainThreadDecorations"),MainThreadDiagnostics:(0,y.createMainContextProxyIdentifier)("MainThreadDiagnostics"),MainThreadDialogs:(0,y.createMainContextProxyIdentifier)("MainThreadDiaglogs"),MainThreadDocuments:(0,y.createMainContextProxyIdentifier)("MainThreadDocuments"),MainThreadDocumentContentProviders:(0,y.createMainContextProxyIdentifier)("MainThreadDocumentContentProviders"),MainThreadTextEditors:(0,y.createMainContextProxyIdentifier)("MainThreadTextEditors"),MainThreadEditorInsets:(0,y.createMainContextProxyIdentifier)("MainThreadEditorInsets"),MainThreadEditorTabs:(0,y.createMainContextProxyIdentifier)("MainThreadEditorTabs"),MainThreadErrors:(0,y.createMainContextProxyIdentifier)("MainThreadErrors"),MainThreadTreeViews:(0,y.createMainContextProxyIdentifier)("MainThreadTreeViews"),MainThreadDownloadService:(0,y.createMainContextProxyIdentifier)("MainThreadDownloadService"),MainThreadKeytar:(0,y.createMainContextProxyIdentifier)("MainThreadKeytar"),MainThreadLanguageFeatures:(0,y.createMainContextProxyIdentifier)("MainThreadLanguageFeatures"),MainThreadLanguages:(0,y.createMainContextProxyIdentifier)("MainThreadLanguages"),MainThreadLogger:(0,y.createMainContextProxyIdentifier)("MainThreadLogger"),MainThreadMessageService:(0,y.createMainContextProxyIdentifier)("MainThreadMessageService"),MainThreadOutputService:(0,y.createMainContextProxyIdentifier)("MainThreadOutputService"),MainThreadProgress:(0,y.createMainContextProxyIdentifier)("MainThreadProgress"),MainThreadQuickOpen:(0,y.createMainContextProxyIdentifier)("MainThreadQuickOpen"),MainThreadStatusBar:(0,y.createMainContextProxyIdentifier)("MainThreadStatusBar"),MainThreadSecretState:(0,y.createMainContextProxyIdentifier)("MainThreadSecretState"),MainThreadStorage:(0,y.createMainContextProxyIdentifier)("MainThreadStorage"),MainThreadTelemetry:(0,y.createMainContextProxyIdentifier)("MainThreadTelemetry"),MainThreadTerminalService:(0,y.createMainContextProxyIdentifier)("MainThreadTerminalService"),MainThreadWebviews:(0,y.createMainContextProxyIdentifier)("MainThreadWebviews"),MainThreadWebviewPanels:(0,y.createMainContextProxyIdentifier)("MainThreadWebviewPanels"),MainThreadWebviewViews:(0,y.createMainContextProxyIdentifier)("MainThreadWebviewViews"),MainThreadCustomEditors:(0,y.createMainContextProxyIdentifier)("MainThreadCustomEditors"),MainThreadUrls:(0,y.createMainContextProxyIdentifier)("MainThreadUrls"),MainThreadUriOpeners:(0,y.createMainContextProxyIdentifier)("MainThreadUriOpeners"),MainThreadWorkspace:(0,y.createMainContextProxyIdentifier)("MainThreadWorkspace"),MainThreadFileSystem:(0,y.createMainContextProxyIdentifier)("MainThreadFileSystem"),MainThreadExtensionService:(0,y.createMainContextProxyIdentifier)("MainThreadExtensionService"),MainThreadSCM:(0,y.createMainContextProxyIdentifier)("MainThreadSCM"),MainThreadSearch:(0,y.createMainContextProxyIdentifier)("MainThreadSearch"),MainThreadTask:(0,y.createMainContextProxyIdentifier)("MainThreadTask"),MainThreadWindow:(0,y.createMainContextProxyIdentifier)("MainThreadWindow"),MainThreadLabelService:(0,y.createMainContextProxyIdentifier)("MainThreadLabelService"),MainThreadNotebook:(0,y.createMainContextProxyIdentifier)("MainThreadNotebook"),MainThreadNotebookDocuments:(0,y.createMainContextProxyIdentifier)("MainThreadNotebookDocumentsShape"),MainThreadNotebookEditors:(0,y.createMainContextProxyIdentifier)("MainThreadNotebookEditorsShape"),MainThreadNotebookKernels:(0,y.createMainContextProxyIdentifier)("MainThreadNotebookKernels"),MainThreadNotebookRenderers:(0,y.createMainContextProxyIdentifier)("MainThreadNotebookRenderers"),MainThreadInteractive:(0,y.createMainContextProxyIdentifier)("MainThreadInteractive"),MainThreadTheming:(0,y.createMainContextProxyIdentifier)("MainThreadTheming"),MainThreadTunnelService:(0,y.createMainContextProxyIdentifier)("MainThreadTunnelService"),MainThreadTimeline:(0,y.createMainContextProxyIdentifier)("MainThreadTimeline"),MainThreadTesting:(0,y.createMainContextProxyIdentifier)("MainThreadTesting")},e.ExtHostContext={ExtHostCommands:(0,y.createExtHostContextProxyIdentifier)("ExtHostCommands"),ExtHostConfiguration:(0,y.createExtHostContextProxyIdentifier)("ExtHostConfiguration"),ExtHostDiagnostics:(0,y.createExtHostContextProxyIdentifier)("ExtHostDiagnostics"),ExtHostDebugService:(0,y.createExtHostContextProxyIdentifier)("ExtHostDebugService"),ExtHostDecorations:(0,y.createExtHostContextProxyIdentifier)("ExtHostDecorations"),ExtHostDocumentsAndEditors:(0,y.createExtHostContextProxyIdentifier)("ExtHostDocumentsAndEditors"),ExtHostDocuments:(0,y.createExtHostContextProxyIdentifier)("ExtHostDocuments"),ExtHostDocumentContentProviders:(0,y.createExtHostContextProxyIdentifier)("ExtHostDocumentContentProviders"),ExtHostDocumentSaveParticipant:(0,y.createExtHostContextProxyIdentifier)("ExtHostDocumentSaveParticipant"),ExtHostEditors:(0,y.createExtHostContextProxyIdentifier)("ExtHostEditors"),ExtHostTreeViews:(0,y.createExtHostContextProxyIdentifier)("ExtHostTreeViews"),ExtHostFileSystem:(0,y.createExtHostContextProxyIdentifier)("ExtHostFileSystem"),ExtHostFileSystemInfo:(0,y.createExtHostContextProxyIdentifier)("ExtHostFileSystemInfo"),ExtHostFileSystemEventService:(0,y.createExtHostContextProxyIdentifier)("ExtHostFileSystemEventService"),ExtHostLanguages:(0,y.createExtHostContextProxyIdentifier)("ExtHostLanguages"),ExtHostLanguageFeatures:(0,y.createExtHostContextProxyIdentifier)("ExtHostLanguageFeatures"),ExtHostQuickOpen:(0,y.createExtHostContextProxyIdentifier)("ExtHostQuickOpen"),ExtHostExtensionService:(0,y.createExtHostContextProxyIdentifier)("ExtHostExtensionService"),ExtHostLogLevelServiceShape:(0,y.createExtHostContextProxyIdentifier)("ExtHostLogLevelServiceShape"),ExtHostTerminalService:(0,y.createExtHostContextProxyIdentifier)("ExtHostTerminalService"),ExtHostSCM:(0,y.createExtHostContextProxyIdentifier)("ExtHostSCM"),ExtHostSearch:(0,y.createExtHostContextProxyIdentifier)("ExtHostSearch"),ExtHostTask:(0,y.createExtHostContextProxyIdentifier)("ExtHostTask"),ExtHostWorkspace:(0,y.createExtHostContextProxyIdentifier)("ExtHostWorkspace"),ExtHostWindow:(0,y.createExtHostContextProxyIdentifier)("ExtHostWindow"),ExtHostWebviews:(0,y.createExtHostContextProxyIdentifier)("ExtHostWebviews"),ExtHostWebviewPanels:(0,y.createExtHostContextProxyIdentifier)("ExtHostWebviewPanels"),ExtHostCustomEditors:(0,y.createExtHostContextProxyIdentifier)("ExtHostCustomEditors"),ExtHostWebviewViews:(0,y.createExtHostContextProxyIdentifier)("ExtHostWebviewViews"),ExtHostEditorInsets:(0,y.createExtHostContextProxyIdentifier)("ExtHostEditorInsets"),ExtHostEditorTabs:(0,y.createExtHostContextProxyIdentifier)("ExtHostEditorTabs"),ExtHostProgress:(0,y.createMainContextProxyIdentifier)("ExtHostProgress"),ExtHostComments:(0,y.createMainContextProxyIdentifier)("ExtHostComments"),ExtHostSecretState:(0,y.createMainContextProxyIdentifier)("ExtHostSecretState"),ExtHostStorage:(0,y.createMainContextProxyIdentifier)("ExtHostStorage"),ExtHostUrls:(0,y.createExtHostContextProxyIdentifier)("ExtHostUrls"),ExtHostUriOpeners:(0,y.createExtHostContextProxyIdentifier)("ExtHostUriOpeners"),ExtHostOutputService:(0,y.createMainContextProxyIdentifier)("ExtHostOutputService"),ExtHosLabelService:(0,y.createMainContextProxyIdentifier)("ExtHostLabelService"),ExtHostNotebook:(0,y.createMainContextProxyIdentifier)("ExtHostNotebook"),ExtHostNotebookDocuments:(0,y.createMainContextProxyIdentifier)("ExtHostNotebookDocuments"),ExtHostNotebookEditors:(0,y.createMainContextProxyIdentifier)("ExtHostNotebookEditors"),ExtHostNotebookKernels:(0,y.createMainContextProxyIdentifier)("ExtHostNotebookKernels"),ExtHostNotebookRenderers:(0,y.createMainContextProxyIdentifier)("ExtHostNotebookRenderers"),ExtHostInteractive:(0,y.createMainContextProxyIdentifier)("ExtHostInteractive"),ExtHostTheming:(0,y.createMainContextProxyIdentifier)("ExtHostTheming"),ExtHostTunnelService:(0,y.createMainContextProxyIdentifier)("ExtHostTunnelService"),ExtHostAuthentication:(0,y.createMainContextProxyIdentifier)("ExtHostAuthentication"),ExtHostTimeline:(0,y.createMainContextProxyIdentifier)("ExtHostTimeline"),ExtHostTesting:(0,y.createMainContextProxyIdentifier)("ExtHostTesting"),ExtHostTelemetry:(0,y.createMainContextProxyIdentifier)("ExtHostTelemetry")}}),define(pe[90],ve([0,1,5,3,4]),function(Y,e,m,L,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostSecretState=e.ExtHostSecretState=void 0;class C{constructor(k){this._onDidChangePassword=new L.Emitter,this.onDidChangePassword=this._onDidChangePassword.event,this._proxy=k.getProxy(m.MainContext.MainThreadSecretState)}async $onDidChangePassword(k){this._onDidChangePassword.fire(k)}get(k,S){return this._proxy.$getPassword(k,S)}store(k,S,D){return this._proxy.$setPassword(k,S,D)}delete(k,S){return this._proxy.$deletePassword(k,S)}}e.ExtHostSecretState=C,e.IExtHostSecretState=(0,y.createDecorator)("IExtHostSecretState")}),define(pe[65],ve([0,1,4,11,5,14]),function(Y,e,m,L,y,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NullApiDeprecationService=e.ExtHostApiDeprecationService=e.IExtHostApiDeprecationService=void 0,e.IExtHostApiDeprecationService=(0,m.createDecorator)("IExtHostApiDeprecationService");let i=class{constructor(S,D){this._extHostLogService=D,this._reportedUsages=new Set,this._telemetryShape=S.getProxy(y.MainContext.MainThreadTelemetry)}report(S,D,R){const P=this.getUsageKey(S,D);this._reportedUsages.has(P)||(this._reportedUsages.add(P),D.isUnderDevelopment&&this._extHostLogService.warn(`[Deprecation Warning] '${S}' is deprecated. ${R}`),this._telemetryShape.$publicLog2("extHostDeprecatedApiUsage",{extensionId:D.identifier.value,apiId:S}))}getUsageKey(S,D){return`${S}-${D.identifier.value}`}};i=je([He(0,C.IExtHostRpcService),He(1,L.ILogService)],i),e.ExtHostApiDeprecationService=i,e.NullApiDeprecationService=Object.freeze(new class{report(k,S,D){}})}),define(pe[228],ve([0,1,3,5,7,27]),function(Y,e,m,L,y,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostAuthentication=void 0;class i{constructor(S){this._authenticationProviders=new Map,this._providers=[],this._onDidChangeSessions=new m.Emitter,this.onDidChangeSessions=this._onDidChangeSessions.event,this._inFlightRequests=new Map,this._proxy=S.getProxy(L.MainContext.MainThreadAuthentication)}$setProviders(S){return this._providers=S,Promise.resolve()}async getSession(S,D,R,P={}){const u=C.ExtensionIdentifier.toKey(S.identifier),E=this._inFlightRequests.get(u)||[],f=[...R].sort().join(" ");let v=E.find(w=>w.scopes===f);if(v)return v.result;{const w=this._getSession(S,u,D,R,P);v={scopes:f,result:w},E.push(v),this._inFlightRequests.set(u,E);try{await w}finally{const I=E.findIndex(p=>p.scopes===f);I>-1&&(E.splice(I),this._inFlightRequests.set(u,E))}return w}}async _getSession(S,D,R,P,u={}){await this._proxy.$ensureProvider(R);const E=S.displayName||S.name;return this._proxy.$getSession(R,P,D,E,u)}async removeSession(S,D){const R=this._authenticationProviders.get(S);return R?R.provider.removeSession(D):this._proxy.$removeSession(S,D)}registerAuthenticationProvider(S,D,R,P){if(this._authenticationProviders.get(S))throw new Error(`An authentication provider with id '${S}' is already registered.`);this._authenticationProviders.set(S,{label:D,provider:R,options:P??{supportsMultipleAccounts:!1}}),this._providers.find(E=>E.id===S)||this._providers.push({id:S,label:D});const u=R.onDidChangeSessions(E=>{this._proxy.$sendDidChangeSessions(S,{added:E.added??[],changed:E.changed??[],removed:E.removed??[]})});return this._proxy.$registerAuthenticationProvider(S,D,P?.supportsMultipleAccounts??!1),new y.Disposable(()=>{u.dispose(),this._authenticationProviders.delete(S);const E=this._providers.findIndex(f=>f.id===S);E>-1&&this._providers.splice(E),this._proxy.$unregisterAuthenticationProvider(S)})}$createSession(S,D){const R=this._authenticationProviders.get(S);if(R)return Promise.resolve(R.provider.createSession(D));throw new Error(`Unable to find authentication provider with handle: ${S}`)}$removeSession(S,D){const R=this._authenticationProviders.get(S);if(R)return Promise.resolve(R.provider.removeSession(D));throw new Error(`Unable to find authentication provider with handle: ${S}`)}$getSessions(S,D){const R=this._authenticationProviders.get(S);if(R)return Promise.resolve(R.provider.getSessions(D));throw new Error(`Unable to find authentication provider with handle: ${S}`)}$onDidChangeAuthenticationSessions(S,D){return this._onDidChangeSessions.fire({provider:{id:S,label:D}}),Promise.resolve()}}e.ExtHostAuthentication=i}),define(pe[229],ve([0,1,5,14,17]),function(Y,e,m,L,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostBulkEdits=void 0;let C=class{constructor(k,S){this._extHostDocumentsAndEditors=S,this._proxy=k.getProxy(m.MainContext.MainThreadBulkEdits)}applyWorkspaceEdit(k){const S=y.WorkspaceEdit.from(k,this._extHostDocumentsAndEditors);return this._proxy.$tryApplyWorkspaceEdit(S)}};C=je([He(0,L.IExtHostRpcService)],C),e.ExtHostBulkEdits=C}),define(pe[230],ve([0,1,5]),function(Y,e,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostClipboard=void 0;class L{constructor(C){const i=C.getProxy(m.MainContext.MainThreadClipboard);this.value=Object.freeze({readText(){return i.$readText()},writeText(k){return i.$writeText(k)}})}}e.ExtHostClipboard=L}),define(pe[38],ve([0,1,13,7,17,25,5,16,11,59,41,49,2,6,4,14,63,22,53,50]),function(Y,e,m,L,y,C,i,k,S,D,R,P,u,E,f,v,w,I,p,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ApiCommand=e.ApiCommandResult=e.ApiCommandArgument=e.CommandsConverter=e.IExtHostCommands=e.ExtHostCommands=void 0;let r=class{constructor(o,d){this._commands=new Map,this._apiCommands=new Map,this._proxy=o.getProxy(i.MainContext.MainThreadCommands),this._logService=d,this.converter=new g(this,c=>{const h=this._apiCommands.get(c);return h?.result===_.Void?h:void 0},d),this._argumentProcessors=[{processArgument(c){return(0,D.revive)(c)}},{processArgument(c){return(0,C.cloneAndChange)(c,function(h){if(R.Range.isIRange(h))return y.Range.to(h);if(P.Position.isIPosition(h))return y.Position.to(h);if(R.Range.isIRange(h.range)&&u.URI.isUri(h.uri))return y.location.to(h);if(h instanceof I.VSBuffer)return h.buffer.buffer;if(!Array.isArray(h))return h})}}]}registerArgumentProcessor(o){this._argumentProcessors.push(o)}registerApiCommand(o){const d=this.registerCommand(!1,o.id,async(...c)=>{const h=o.args.map((b,T)=>{if(!b.validate(c[T]))throw new Error(`Invalid argument '${b.name}' when running '${o.id}', received: ${c[T]}`);return b.convert(c[T])}),l=await this.executeCommand(o.internalId,...h);return o.result.convert(l,c,this.converter)},void 0,{description:o.description,args:o.args,returns:o.result.description});return this._apiCommands.set(o.id,o),new L.Disposable(()=>{d.dispose(),this._apiCommands.delete(o.id)})}registerCommand(o,d,c,h,l,b){if(this._logService.trace("ExtHostCommands#registerCommand",d),!d.trim().length)throw new Error("invalid id");if(this._commands.has(d))throw new Error(`command '${d}' already exists`);return this._commands.set(d,{callback:c,thisArg:h,description:l,extension:b}),o&&this._proxy.$registerCommand(d),new L.Disposable(()=>{this._commands.delete(d)&&o&&this._proxy.$unregisterCommand(d)})}executeCommand(o,...d){return this._logService.trace("ExtHostCommands#executeCommand",o),this._doExecuteCommand(o,d,!0)}async _doExecuteCommand(o,d,c){if(this._commands.has(o))return this._executeContributedCommand(o,d,!1);{let h=!1;const l=(0,C.cloneAndChange)(d,function(b){if(b instanceof L.Position)return y.Position.from(b);if(b instanceof L.Range)return y.Range.from(b);if(b instanceof L.Location)return y.location.from(b);if(L.NotebookRange.isNotebookRange(b))return y.NotebookRange.from(b);if(b instanceof ArrayBuffer)return h=!0,I.VSBuffer.wrap(new Uint8Array(b));if(b instanceof Uint8Array)return h=!0,I.VSBuffer.wrap(b);if(!Array.isArray(b))return b});try{const b=await this._proxy.$executeCommand(o,h?new p.SerializableObjectWithBuffers(l):l,c);return(0,D.revive)(b)}catch(b){if(b instanceof Error&&b.message==="$executeCommand:retry")return this._doExecuteCommand(o,d,!1);throw b}}}async _executeContributedCommand(o,d,c){const h=this._commands.get(o);if(!h)throw new Error("Unknown command");let{callback:l,thisArg:b,description:T}=h;if(T)for(let A=0;A<T.args.length;A++)try{(0,m.validateConstraint)(d[A],T.args[A].constraint)}catch(x){throw new Error(`Running the contributed command: '${o}' failed. Illegal argument '${T.args[A].name}' - ${T.args[A].description}`)}try{return await l.apply(b,d)}catch(A){if(o===this.converter.delegatingCommandId){const x=this.converter.getActualCommand(...d);x&&(o=x.command)}throw this._logService.error(A,o,h.extension?.identifier),c?new class extends Error{constructor(){super((0,s.toErrorMessage)(A));this.id=o,this.source=h.extension?.displayName??h.extension?.name}}:A}}$executeContributedCommand(o,...d){return this._logService.trace("ExtHostCommands#$executeContributedCommand",o),this._commands.has(o)?(d=d.map(c=>this._argumentProcessors.reduce((h,l)=>l.processArgument(h),c)),this._executeContributedCommand(o,d,!0)):Promise.reject(new Error(`Contributed command '${o}' does not exist.`))}getCommands(o=!1){return this._logService.trace("ExtHostCommands#getCommands",o),this._proxy.$getCommands().then(d=>(o&&(d=d.filter(c=>c[0]!=="_")),d))}$getContributedCommandHandlerDescriptions(){const o=Object.create(null);for(let[d,c]of this._commands){let{description:h}=c;h&&(o[d]=h)}return Promise.resolve(o)}};r=je([He(0,v.IExtHostRpcService),He(1,S.ILogService)],r),e.ExtHostCommands=r,e.IExtHostCommands=(0,f.createDecorator)("IExtHostCommands");class g{constructor(o,d,c){this._commands=o,this._lookupApiCommand=d,this._logService=c,this.delegatingCommandId=`_vscode_delegate_cmd_${Date.now().toString(36)}`,this._cache=new Map,this._cachIdPool=0,this._commands.registerCommand(!0,this.delegatingCommandId,this._executeConvertedCommand,this)}toInternal(o,d){if(!o)return;const c={$ident:void 0,id:o.command,title:o.title,tooltip:o.tooltip};if(!o.command)return c;const h=this._lookupApiCommand(o.command);if(h)c.id=h.internalId,c.arguments=h.args.map((l,b)=>l.convert(o.arguments&&o.arguments[b]));else if((0,k.isNonEmptyArray)(o.arguments)){const l=++this._cachIdPool;this._cache.set(l,o),d.add((0,E.toDisposable)(()=>{this._cache.delete(l),this._logService.trace("CommandsConverter#DISPOSE",l)})),c.$ident=l,c.id=this.delegatingCommandId,c.arguments=[l],this._logService.trace("CommandsConverter#CREATE",o.command,l)}return c}fromInternal(o){const d=i.ObjectIdentifier.of(o);return typeof d=="number"?this._cache.get(d):{command:o.id,title:o.title,arguments:o.arguments}}getActualCommand(...o){return this._cache.get(o[0])}_executeConvertedCommand(...o){const d=this.getActualCommand(...o);return this._logService.trace("CommandsConverter#EXECUTE",o[0],d?d.command:"MISSING"),d?this._commands.executeCommand(d.command,...d.arguments||[]):Promise.reject("actual command NOT FOUND")}}e.CommandsConverter=g;class a{constructor(o,d,c,h){this.name=o,this.description=d,this.validate=c,this.convert=h}optional(){return new a(this.name,`(optional) ${this.description}`,o=>o==null||this.validate(o),o=>o===void 0?void 0:o===null?null:this.convert(o))}with(o,d){return new a(o??this.name,d??this.description,this.validate,this.convert)}}e.ApiCommandArgument=a,a.Uri=new a("uri","Uri of a text document",t=>u.URI.isUri(t),t=>t),a.Position=new a("position","A position in a text document",t=>L.Position.isPosition(t),y.Position.from),a.Range=new a("range","A range in a text document",t=>L.Range.isRange(t),y.Range.from),a.Selection=new a("selection","A selection in a text document",t=>L.Selection.isSelection(t),y.Selection.from),a.Number=new a("number","",t=>typeof t=="number",t=>t),a.String=new a("string","",t=>typeof t=="string",t=>t),a.CallHierarchyItem=new a("item","A call hierarchy item",t=>t instanceof L.CallHierarchyItem,y.CallHierarchyItem.from),a.TypeHierarchyItem=new a("item","A type hierarchy item",t=>t instanceof L.TypeHierarchyItem,y.TypeHierarchyItem.from),a.TestItem=new a("testItem","A VS Code TestItem",t=>t instanceof w.TestItemImpl,y.TestItem.from);class _{constructor(o,d){this.description=o,this.convert=d}}e.ApiCommandResult=_,_.Void=new _("no result",t=>t);class n{constructor(o,d,c,h,l){this.id=o,this.internalId=d,this.description=c,this.args=h,this.result=l}}e.ApiCommand=n}),define(pe[231],ve([0,1,17,7,84,38,16,110]),function(Y,e,m,L,y,C,i,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostApiCommands=void 0;const S=[new C.ApiCommand("vscode.executeDocumentHighlights","_executeDocumentHighlights","Execute document highlight provider.",[C.ApiCommandArgument.Uri,C.ApiCommandArgument.Position],new C.ApiCommandResult("A promise that resolves to an array of DocumentHighlight-instances.",R(m.DocumentHighlight.to))),new C.ApiCommand("vscode.executeDocumentSymbolProvider","_executeDocumentSymbolProvider","Execute document symbol provider.",[C.ApiCommandArgument.Uri],new C.ApiCommandResult("A promise that resolves to an array of SymbolInformation and DocumentSymbol instances.",(u,E)=>{if((0,i.isFalsyOrEmpty)(u))return;class f extends L.SymbolInformation{static to(w){const I=new f(w.name,m.SymbolKind.to(w.kind),w.containerName||"",new L.Location(E[0],m.Range.to(w.range)));return I.detail=w.detail,I.range=I.location.range,I.selectionRange=m.Range.to(w.selectionRange),I.children=w.children?w.children.map(f.to):[],I}}return u.map(f.to)})),new C.ApiCommand("vscode.executeFormatDocumentProvider","_executeFormatDocumentProvider","Execute document format provider.",[C.ApiCommandArgument.Uri,new C.ApiCommandArgument("options","Formatting options",u=>!0,u=>u)],new C.ApiCommandResult("A promise that resolves to an array of TextEdits.",R(m.TextEdit.to))),new C.ApiCommand("vscode.executeFormatRangeProvider","_executeFormatRangeProvider","Execute range format provider.",[C.ApiCommandArgument.Uri,C.ApiCommandArgument.Range,new C.ApiCommandArgument("options","Formatting options",u=>!0,u=>u)],new C.ApiCommandResult("A promise that resolves to an array of TextEdits.",R(m.TextEdit.to))),new C.ApiCommand("vscode.executeFormatOnTypeProvider","_executeFormatOnTypeProvider","Execute format on type provider.",[C.ApiCommandArgument.Uri,C.ApiCommandArgument.Position,new C.ApiCommandArgument("ch","Trigger character",u=>typeof u=="string",u=>u),new C.ApiCommandArgument("options","Formatting options",u=>!0,u=>u)],new C.ApiCommandResult("A promise that resolves to an array of TextEdits.",R(m.TextEdit.to))),new C.ApiCommand("vscode.executeDefinitionProvider","_executeDefinitionProvider","Execute all definition providers.",[C.ApiCommandArgument.Uri,C.ApiCommandArgument.Position],new C.ApiCommandResult("A promise that resolves to an array of Location or LocationLink instances.",P)),new C.ApiCommand("vscode.executeTypeDefinitionProvider","_executeTypeDefinitionProvider","Execute all type definition providers.",[C.ApiCommandArgument.Uri,C.ApiCommandArgument.Position],new C.ApiCommandResult("A promise that resolves to an array of Location or LocationLink instances.",P)),new C.ApiCommand("vscode.executeDeclarationProvider","_executeDeclarationProvider","Execute all declaration providers.",[C.ApiCommandArgument.Uri,C.ApiCommandArgument.Position],new C.ApiCommandResult("A promise that resolves to an array of Location or LocationLink instances.",P)),new C.ApiCommand("vscode.executeImplementationProvider","_executeImplementationProvider","Execute all implementation providers.",[C.ApiCommandArgument.Uri,C.ApiCommandArgument.Position],new C.ApiCommandResult("A promise that resolves to an array of Location or LocationLink instances.",P)),new C.ApiCommand("vscode.executeReferenceProvider","_executeReferenceProvider","Execute all reference providers.",[C.ApiCommandArgument.Uri,C.ApiCommandArgument.Position],new C.ApiCommandResult("A promise that resolves to an array of Location-instances.",R(m.location.to))),new C.ApiCommand("vscode.executeHoverProvider","_executeHoverProvider","Execute all hover providers.",[C.ApiCommandArgument.Uri,C.ApiCommandArgument.Position],new C.ApiCommandResult("A promise that resolves to an array of Hover-instances.",R(m.Hover.to))),new C.ApiCommand("vscode.executeSelectionRangeProvider","_executeSelectionRangeProvider","Execute selection range provider.",[C.ApiCommandArgument.Uri,new C.ApiCommandArgument("position","A position in a text document",u=>Array.isArray(u)&&u.every(E=>L.Position.isPosition(E)),u=>u.map(m.Position.from))],new C.ApiCommandResult("A promise that resolves to an array of ranges.",u=>u.map(E=>{let f;for(const v of E.reverse())f=new L.SelectionRange(m.Range.to(v),f);return f}))),new C.ApiCommand("vscode.executeWorkspaceSymbolProvider","_executeWorkspaceSymbolProvider","Execute all workspace symbol providers.",[C.ApiCommandArgument.String.with("query","Search string")],new C.ApiCommandResult("A promise that resolves to an array of SymbolInformation-instances.",u=>u.map(m.WorkspaceSymbol.to))),new C.ApiCommand("vscode.prepareCallHierarchy","_executePrepareCallHierarchy","Prepare call hierarchy at a position inside a document",[C.ApiCommandArgument.Uri,C.ApiCommandArgument.Position],new C.ApiCommandResult("A CallHierarchyItem or undefined",u=>u.map(m.CallHierarchyItem.to))),new C.ApiCommand("vscode.provideIncomingCalls","_executeProvideIncomingCalls","Compute incoming calls for an item",[C.ApiCommandArgument.CallHierarchyItem],new C.ApiCommandResult("A CallHierarchyItem or undefined",u=>u.map(m.CallHierarchyIncomingCall.to))),new C.ApiCommand("vscode.provideOutgoingCalls","_executeProvideOutgoingCalls","Compute outgoing calls for an item",[C.ApiCommandArgument.CallHierarchyItem],new C.ApiCommandResult("A CallHierarchyItem or undefined",u=>u.map(m.CallHierarchyOutgoingCall.to))),new C.ApiCommand("vscode.prepareRename","_executePrepareRename","Execute the prepareRename of rename provider.",[C.ApiCommandArgument.Uri,C.ApiCommandArgument.Position],new C.ApiCommandResult("A promise that resolves to a range and placeholder text.",u=>{if(!!u)return{range:m.Range.to(u.range),placeholder:u.text}})),new C.ApiCommand("vscode.executeDocumentRenameProvider","_executeDocumentRenameProvider","Execute rename provider.",[C.ApiCommandArgument.Uri,C.ApiCommandArgument.Position,C.ApiCommandArgument.String.with("newName","The new symbol name")],new C.ApiCommandResult("A promise that resolves to a WorkspaceEdit.",u=>{if(!!u){if(u.rejectReason)throw new Error(u.rejectReason);return m.WorkspaceEdit.to(u)}})),new C.ApiCommand("vscode.executeLinkProvider","_executeLinkProvider","Execute document link provider.",[C.ApiCommandArgument.Uri,C.ApiCommandArgument.Number.with("linkResolveCount","Number of links that should be resolved, only when links are unresolved.").optional()],new C.ApiCommandResult("A promise that resolves to an array of DocumentLink-instances.",u=>u.map(m.DocumentLink.to))),new C.ApiCommand("vscode.provideDocumentSemanticTokensLegend","_provideDocumentSemanticTokensLegend","Provide semantic tokens legend for a document",[C.ApiCommandArgument.Uri],new C.ApiCommandResult("A promise that resolves to SemanticTokensLegend.",u=>{if(!!u)return new L.SemanticTokensLegend(u.tokenTypes,u.tokenModifiers)})),new C.ApiCommand("vscode.provideDocumentSemanticTokens","_provideDocumentSemanticTokens","Provide semantic tokens for a document",[C.ApiCommandArgument.Uri],new C.ApiCommandResult("A promise that resolves to SemanticTokens.",u=>{if(!u)return;const E=(0,k.decodeSemanticTokensDto)(u);if(E.type==="full")return new L.SemanticTokens(E.data,void 0)})),new C.ApiCommand("vscode.provideDocumentRangeSemanticTokensLegend","_provideDocumentRangeSemanticTokensLegend","Provide semantic tokens legend for a document range",[C.ApiCommandArgument.Uri,C.ApiCommandArgument.Range.optional()],new C.ApiCommandResult("A promise that resolves to SemanticTokensLegend.",u=>{if(!!u)return new L.SemanticTokensLegend(u.tokenTypes,u.tokenModifiers)})),new C.ApiCommand("vscode.provideDocumentRangeSemanticTokens","_provideDocumentRangeSemanticTokens","Provide semantic tokens for a document range",[C.ApiCommandArgument.Uri,C.ApiCommandArgument.Range],new C.ApiCommandResult("A promise that resolves to SemanticTokens.",u=>{if(!u)return;const E=(0,k.decodeSemanticTokensDto)(u);if(E.type==="full")return new L.SemanticTokens(E.data,void 0)})),new C.ApiCommand("vscode.executeCompletionItemProvider","_executeCompletionItemProvider","Execute completion item provider.",[C.ApiCommandArgument.Uri,C.ApiCommandArgument.Position,C.ApiCommandArgument.String.with("triggerCharacter","Trigger completion when the user types the character, like `,` or `(`").optional(),C.ApiCommandArgument.Number.with("itemResolveCount","Number of completions to resolve (too large numbers slow down completions)").optional()],new C.ApiCommandResult("A promise that resolves to a CompletionList-instance.",(u,E,f)=>{if(!u)return new L.CompletionList([]);const v=u.suggestions.map(w=>m.CompletionItem.to(w,f));return new L.CompletionList(v,u.incomplete)})),new C.ApiCommand("vscode.executeSignatureHelpProvider","_executeSignatureHelpProvider","Execute signature help provider.",[C.ApiCommandArgument.Uri,C.ApiCommandArgument.Position,C.ApiCommandArgument.String.with("triggerCharacter","Trigger signature help when the user types the character, like `,` or `(`").optional()],new C.ApiCommandResult("A promise that resolves to SignatureHelp.",u=>{if(u)return m.SignatureHelp.to(u)})),new C.ApiCommand("vscode.executeCodeLensProvider","_executeCodeLensProvider","Execute code lens provider.",[C.ApiCommandArgument.Uri,C.ApiCommandArgument.Number.with("itemResolveCount","Number of lenses that should be resolved and returned. Will only return resolved lenses, will impact performance)").optional()],new C.ApiCommandResult("A promise that resolves to an array of CodeLens-instances.",(u,E,f)=>R(v=>new L.CodeLens(m.Range.to(v.range),v.command&&f.fromInternal(v.command)))(u))),new C.ApiCommand("vscode.executeCodeActionProvider","_executeCodeActionProvider","Execute code action provider.",[C.ApiCommandArgument.Uri,new C.ApiCommandArgument("rangeOrSelection","Range in a text document. Some refactoring provider requires Selection object.",u=>L.Range.isRange(u),u=>L.Selection.isSelection(u)?m.Selection.from(u):m.Range.from(u)),C.ApiCommandArgument.String.with("kind","Code action kind to return code actions for").optional(),C.ApiCommandArgument.Number.with("itemResolveCount","Number of code actions to resolve (too large numbers slow down code actions)").optional()],new C.ApiCommandResult("A promise that resolves to an array of Command-instances.",(u,E,f)=>R(v=>{if(v._isSynthetic){if(!v.command)throw new Error("Synthetic code actions must have a command");return f.fromInternal(v.command)}else{const w=new L.CodeAction(v.title,v.kind?new L.CodeActionKind(v.kind):void 0);return v.edit&&(w.edit=m.WorkspaceEdit.to(v.edit)),v.command&&(w.command=f.fromInternal(v.command)),w.isPreferred=v.isPreferred,w}})(u))),new C.ApiCommand("vscode.executeDocumentColorProvider","_executeDocumentColorProvider","Execute document color provider.",[C.ApiCommandArgument.Uri],new C.ApiCommandResult("A promise that resolves to an array of ColorInformation objects.",u=>u?u.map(E=>new L.ColorInformation(m.Range.to(E.range),m.Color.to(E.color))):[])),new C.ApiCommand("vscode.executeColorPresentationProvider","_executeColorPresentationProvider","Execute color presentation provider.",[new C.ApiCommandArgument("color","The color to show and insert",u=>u instanceof L.Color,m.Color.from),new C.ApiCommandArgument("context","Context object with uri and range",u=>!0,u=>({uri:u.uri,range:m.Range.from(u.range)}))],new C.ApiCommandResult("A promise that resolves to an array of ColorPresentation objects.",u=>u?u.map(m.ColorPresentation.to):[])),new C.ApiCommand("vscode.executeInlayHintProvider","_executeInlayHintProvider","Execute inlay hints provider",[C.ApiCommandArgument.Uri,C.ApiCommandArgument.Range],new C.ApiCommandResult("A promise that resolves to an array of Inlay objects",u=>u.map(m.InlayHint.to))),new C.ApiCommand("vscode.resolveNotebookContentProviders","_resolveNotebookContentProvider","Resolve Notebook Content Providers",[],new C.ApiCommandResult("A promise that resolves to an array of NotebookContentProvider static info objects.",R(u=>({viewType:u.viewType,displayName:u.displayName,options:{transientOutputs:u.options.transientOutputs,transientCellMetadata:u.options.transientCellMetadata,transientDocumentMetadata:u.options.transientDocumentMetadata},filenamePattern:u.filenamePattern.map(E=>m.NotebookExclusiveDocumentPattern.to(E))})))),new C.ApiCommand("vscode.executeInlineValueProvider","_executeInlineValueProvider","Execute inline value provider",[C.ApiCommandArgument.Uri,C.ApiCommandArgument.Range],new C.ApiCommandResult("A promise that resolves to an array of InlineValue objects",u=>u.map(m.InlineValue.to))),new C.ApiCommand("vscode.open","_workbench.open","Opens the provided resource in the editor. Can be a text or binary file, or an http(s) URL. If you need more control over the options for opening a text file, use vscode.window.showTextDocument instead.",[C.ApiCommandArgument.Uri,new C.ApiCommandArgument("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",u=>u===void 0||typeof u=="number"||typeof u=="object",u=>u&&(typeof u=="number"?[u,void 0]:[m.ViewColumn.from(u.viewColumn),m.TextEditorOpenOptions.from(u)])).optional(),C.ApiCommandArgument.String.with("label","").optional()],C.ApiCommandResult.Void),new C.ApiCommand("vscode.openWith","_workbench.openWith","Opens the provided resource with a specific editor.",[C.ApiCommandArgument.Uri.with("resource","Resource to open"),C.ApiCommandArgument.String.with("viewId","Custom editor view id or 'default' to use VS Code's default editor"),new C.ApiCommandArgument("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",u=>u===void 0||typeof u=="number"||typeof u=="object",u=>u&&(typeof u=="number"?[u,void 0]:[m.ViewColumn.from(u.viewColumn),m.TextEditorOpenOptions.from(u)])).optional()],C.ApiCommandResult.Void),new C.ApiCommand("vscode.diff","_workbench.diff","Opens the provided resources in the diff editor to compare their contents.",[C.ApiCommandArgument.Uri.with("left","Left-hand side resource of the diff editor"),C.ApiCommandArgument.Uri.with("right","Right-hand side resource of the diff editor"),C.ApiCommandArgument.String.with("title","Human readable title for the diff editor").optional(),new C.ApiCommandArgument("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",u=>u===void 0||typeof u=="object",u=>u&&[m.ViewColumn.from(u.viewColumn),m.TextEditorOpenOptions.from(u)]).optional()],C.ApiCommandResult.Void),new C.ApiCommand("vscode.prepareTypeHierarchy","_executePrepareTypeHierarchy","Prepare type hierarchy at a position inside a document",[C.ApiCommandArgument.Uri,C.ApiCommandArgument.Position],new C.ApiCommandResult("A TypeHierarchyItem or undefined",u=>u.map(m.TypeHierarchyItem.to))),new C.ApiCommand("vscode.provideSupertypes","_executeProvideSupertypes","Compute supertypes for an item",[C.ApiCommandArgument.TypeHierarchyItem],new C.ApiCommandResult("A TypeHierarchyItem or undefined",u=>u.map(m.TypeHierarchyItem.to))),new C.ApiCommand("vscode.provideSubtypes","_executeProvideSubtypes","Compute subtypes for an item",[C.ApiCommandArgument.TypeHierarchyItem],new C.ApiCommandResult("A TypeHierarchyItem or undefined",u=>u.map(m.TypeHierarchyItem.to))),new C.ApiCommand("vscode.revealTestInExplorer","_revealTestInExplorer","Reveals a test instance in the explorer",[C.ApiCommandArgument.TestItem],C.ApiCommandResult.Void)];class D{static register(E){S.forEach(E.registerApiCommand,E)}}e.ExtHostApiCommands=D;function R(u){return E=>{if(Array.isArray(E))return E.map(u)}}function P(u){if(!Array.isArray(u))return;const E=[];for(const f of u)y.isLocationLink(f)?E.push(m.DefinitionLink.to(f)):E.push(m.location.to(f));return E}}),define(pe[232],ve([0,1,18,57,3,6,2,84,27,17,7,5]),function(Y,e,m,L,y,C,i,k,S,D,R,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createExtHostComments=void 0;function u(E,f,v){const w=E.getProxy(P.MainContext.MainThreadComments);class I{constructor(){this._commentControllers=new Map,this._commentControllersByExtension=new Map,f.registerArgumentProcessor({processArgument:t=>{if(t&&t.$mid===6){const o=this._commentControllers.get(t.handle);return o||t}else if(t&&t.$mid===7){const o=this._commentControllers.get(t.commentControlHandle);if(!o)return t;const d=o.getCommentThread(t.commentThreadHandle);return d||t}else if(t&&t.$mid===8){const o=this._commentControllers.get(t.thread.commentControlHandle);if(!o)return t;const d=o.getCommentThread(t.thread.commentThreadHandle);return d?{thread:d,text:t.text}:t}else if(t&&t.$mid===9){const o=this._commentControllers.get(t.thread.commentControlHandle);if(!o)return t;const d=o.getCommentThread(t.thread.commentThreadHandle);if(!d)return t;let c=t.commentUniqueId,h=d.getCommentByUniqueId(c);return h||t}else if(t&&t.$mid===10){const o=this._commentControllers.get(t.thread.commentControlHandle);if(!o)return t;const d=o.getCommentThread(t.thread.commentThreadHandle);if(!d)return t;let c=t.text,h=t.commentUniqueId,l=d.getCommentByUniqueId(h);return l?(l.body=c,l):t}return t}})}createCommentController(t,o,d){const c=I.handlePool++,h=new s(t,c,o,d);this._commentControllers.set(h.handle,h);const l=this._commentControllersByExtension.get(S.ExtensionIdentifier.toKey(t.identifier))||[];return l.push(h),this._commentControllersByExtension.set(S.ExtensionIdentifier.toKey(t.identifier),l),h.value}$createCommentThreadTemplate(t,o,d){const c=this._commentControllers.get(t);!c||c.$createCommentThreadTemplate(o,d)}async $updateCommentThreadTemplate(t,o,d){const c=this._commentControllers.get(t);!c||c.$updateCommentThreadTemplate(o,d)}$deleteCommentThread(t,o){const d=this._commentControllers.get(t);d&&d.$deleteCommentThread(o)}$provideCommentingRanges(t,o,d){const c=this._commentControllers.get(t);if(!c||!c.commentingRangeProvider)return Promise.resolve(void 0);const h=v.getDocument(i.URI.revive(o));return(0,m.asPromise)(()=>c.commentingRangeProvider.provideCommentingRanges(h,d)).then(l=>l?l.map(b=>D.Range.from(b)):void 0)}$toggleReaction(t,o,d,c,h){const l=this._commentControllers.get(t);return!l||!l.reactionHandler?Promise.resolve(void 0):(0,m.asPromise)(()=>{const b=l.getCommentThread(o);if(b){const T=b.getCommentByUniqueId(c.uniqueIdInThread);if(l!==void 0&&T&&l.reactionHandler)return l.reactionHandler(T,a(h))}return Promise.resolve(void 0)})}dispose(){}}I.handlePool=0;class p{constructor(t,o,d,c,h,l,b){this._commentControllerHandle=o,this._id=d,this._uri=c,this._range=h,this._comments=l,this.handle=p._handlePool++,this.commentHandle=0,this.modifications=Object.create(null),this._onDidUpdateCommentThread=new y.Emitter,this.onDidUpdateCommentThread=this._onDidUpdateCommentThread.event,this._canReply=!0,this._commentsMap=new Map,this._acceptInputDisposables=new C.MutableDisposable,this._acceptInputDisposables.value=new C.DisposableStore,this._id===void 0&&(this._id=`${t}.${this.handle}`),w.$createCommentThread(o,this.handle,this._id,this._uri,D.Range.from(this._range),b),this._localDisposables=[],this._isDiposed=!1,this._localDisposables.push(this.onDidUpdateCommentThread(()=>{this.eventuallyUpdateCommentThread()})),this.comments=l,this._localDisposables.push({dispose:()=>{w.$deleteCommentThread(o,this.handle)}});const T=this;this.value={get uri(){return T.uri},get range(){return T.range},set range(A){T.range=A},get comments(){return T.comments},set comments(A){T.comments=A},get collapsibleState(){return T.collapsibleState},set collapsibleState(A){T.collapsibleState=A},get canReply(){return T.canReply},set canReply(A){T.canReply=A},get contextValue(){return T.contextValue},set contextValue(A){T.contextValue=A},get label(){return T.label},set label(A){T.label=A},dispose:()=>{T.dispose()}}}set threadId(t){this._id=t}get threadId(){return this._id}get id(){return this._id}get resource(){return this._uri}get uri(){return this._uri}set range(t){t.isEqual(this._range)||(this._range=t,this.modifications.range=t,this._onDidUpdateCommentThread.fire())}get range(){return this._range}set canReply(t){this._canReply!==t&&(this._canReply=t,this.modifications.canReply=t,this._onDidUpdateCommentThread.fire())}get canReply(){return this._canReply}get label(){return this._label}set label(t){this._label=t,this.modifications.label=t,this._onDidUpdateCommentThread.fire()}get contextValue(){return this._contextValue}set contextValue(t){this._contextValue=t,this.modifications.contextValue=t,this._onDidUpdateCommentThread.fire()}get comments(){return this._comments}set comments(t){this._comments=t,this.modifications.comments=t,this._onDidUpdateCommentThread.fire()}get collapsibleState(){return this._collapseState}set collapsibleState(t){this._collapseState=t,this.modifications.collapsibleState=t,this._onDidUpdateCommentThread.fire()}get isDisposed(){return this._isDiposed}eventuallyUpdateCommentThread(){if(this._isDiposed)return;this._acceptInputDisposables.value||(this._acceptInputDisposables.value=new C.DisposableStore);const t=d=>Object.prototype.hasOwnProperty.call(this.modifications,d),o={};t("range")&&(o.range=D.Range.from(this._range)),t("label")&&(o.label=this.label),t("contextValue")&&(o.contextValue=this.contextValue??null),t("comments")&&(o.comments=this._comments.map(d=>r(this,d,this._commentsMap))),t("collapsibleState")&&(o.collapseState=_(this._collapseState)),t("canReply")&&(o.canReply=this.canReply),this.modifications={},w.$updateCommentThread(this._commentControllerHandle,this.handle,this._id,this._uri,o)}getCommentByUniqueId(t){for(let o of this._commentsMap){let d=o[0],c=o[1];if(t===c)return d}}dispose(){this._isDiposed=!0,this._acceptInputDisposables.dispose(),this._localDisposables.forEach(t=>t.dispose())}}p._handlePool=0,je([(0,L.debounce)(100)],p.prototype,"eventuallyUpdateCommentThread",null);class s{constructor(t,o,d,c){this._extension=t,this._handle=o,this._id=d,this._label=c,this._threads=new Map,w.$registerCommentController(this.handle,d,c);const h=this;this.value=Object.freeze({id:h.id,label:h.label,get options(){return h.options},set options(l){h.options=l},get commentingRangeProvider(){return h.commentingRangeProvider},set commentingRangeProvider(l){h.commentingRangeProvider=l},get reactionHandler(){return h.reactionHandler},set reactionHandler(l){h.reactionHandler=l},createCommentThread(l,b,T){return h.createCommentThread(l,b,T).value},dispose:()=>{h.dispose()}}),this._localDisposables=[],this._localDisposables.push({dispose:()=>{w.$unregisterCommentController(this.handle)}})}get id(){return this._id}get label(){return this._label}get handle(){return this._handle}get commentingRangeProvider(){return this._commentingRangeProvider}set commentingRangeProvider(t){this._commentingRangeProvider=t,w.$updateCommentingRanges(this.handle)}get reactionHandler(){return this._reactionHandler}set reactionHandler(t){this._reactionHandler=t,w.$updateCommentControllerFeatures(this.handle,{reactionHandler:!!t})}get options(){return this._options}set options(t){this._options=t,w.$updateCommentControllerFeatures(this.handle,{options:this._options})}createCommentThread(t,o,d,c){if(typeof t=="string"){const h=new p(this.id,this.handle,t,o,d,c,this._extension.identifier);return this._threads.set(h.handle,h),h}else{const h=new p(this.id,this.handle,void 0,t,o,d,this._extension.identifier);return this._threads.set(h.handle,h),h}}$createCommentThreadTemplate(t,o){const d=new p(this.id,this.handle,void 0,i.URI.revive(t),D.Range.to(o),[],this._extension.identifier);return d.collapsibleState=k.CommentThreadCollapsibleState.Expanded,this._threads.set(d.handle,d),d}$updateCommentThreadTemplate(t,o){let d=this._threads.get(t);d&&(d.range=D.Range.to(o))}$deleteCommentThread(t){let o=this._threads.get(t);o&&o.dispose(),this._threads.delete(t)}getCommentThread(t){return this._threads.get(t)}dispose(){this._threads.forEach(t=>{t.dispose()}),this._localDisposables.forEach(t=>t.dispose())}}function r(n,t,o){let d=o.get(t);d||(d=++n.commentHandle,o.set(t,d));const c=t.author&&t.author.iconPath?t.author.iconPath.toString():void 0;return{mode:t.mode,contextValue:t.contextValue,uniqueIdInThread:d,body:D.MarkdownString.from(t.body),userName:t.author.name,userIconPath:c,label:t.label,commentReactions:t.reactions?t.reactions.map(h=>g(h)):void 0}}function g(n){return{label:n.label,iconPath:n.iconPath?D.pathOrURIToURI(n.iconPath):void 0,count:n.count,hasReacted:n.authorHasReacted}}function a(n){return{label:n.label||"",count:n.count||0,iconPath:n.iconPath?i.URI.revive(n.iconPath):"",authorHasReacted:n.hasReacted||!1}}function _(n){if(n!==void 0)switch(n){case R.CommentThreadCollapsibleState.Expanded:return k.CommentThreadCollapsibleState.Expanded;case R.CommentThreadCollapsibleState.Collapsed:return k.CommentThreadCollapsibleState.Collapsed}return k.CommentThreadCollapsibleState.Collapsed}return new I}e.createExtHostComments=u}),define(pe[130],ve([0,1,2,5,7,4,14,11,16,8,9]),function(Y,e,m,L,y,C,i,k,S,D,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostDecorations=e.ExtHostDecorations=void 0;let P=class bi{constructor(E,f){this._logService=f,this._provider=new Map,this._proxy=E.getProxy(L.MainContext.MainThreadDecorations)}registerFileDecorationProvider(E,f){const v=bi._handlePool++;this._provider.set(v,{provider:E,extensionId:f}),this._proxy.$registerDecorationProvider(v,f.value);const w=E.onDidChangeFileDecorations&&E.onDidChangeFileDecorations(I=>{if(!I){this._proxy.$onDidChange(v,null);return}let p=(0,S.asArray)(I);if(p.length<=bi._maxEventSize){this._proxy.$onDidChange(v,p);return}this._logService.warn("[Decorations] CAPPING events from decorations provider",f.value,p.length);const s=p.map(a=>({uri:a,rank:(0,D.count)(a.path,"/")})),r=(0,S.groupBy)(s,(a,_)=>a.rank-_.rank||(0,D.compare)(a.uri.path,_.uri.path));let g=[];e:for(let a of r){let _;for(let n of a){let t=(0,R.dirname)(n.uri.path);if(_!==t&&(_=t,g.push(n.uri)>=bi._maxEventSize))break e}}this._proxy.$onDidChange(v,g)});return new y.Disposable(()=>{w?.dispose(),this._proxy.$unregisterDecorationProvider(v),this._provider.delete(v)})}async $provideDecorations(E,f,v){if(!this._provider.has(E))return Object.create(null);const w=Object.create(null),{provider:I,extensionId:p}=this._provider.get(E);return await Promise.all(f.map(async s=>{try{const{uri:r,id:g}=s,a=await Promise.resolve(I.provideFileDecoration(m.URI.revive(r),v));if(!a)return;try{y.FileDecoration.validate(a),w[g]=[a.propagate,a.tooltip,a.badge,a.color]}catch(_){this._logService.warn(`INVALID decoration from extension '${p.value}': ${_}`)}}catch(r){this._logService.error(r)}})),w}};P._handlePool=0,P._maxEventSize=250,P=je([He(0,i.IExtHostRpcService),He(1,k.ILogService)],P),e.ExtHostDecorations=P,e.IExtHostDecorations=(0,C.createDecorator)("IExtHostDecorations")});var nt=this&&this.__classPrivateFieldSet||function(Y,e,m,L,y){if(L==="m")throw new TypeError("Private method is not writable");if(L==="a"&&!y)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?Y!==e||!y:!e.has(Y))throw new TypeError("Cannot write private member to an object whose class did not declare it");return L==="a"?y.call(Y,m):y?y.value=m:e.set(Y,m),m},Ne=this&&this.__classPrivateFieldGet||function(Y,e,m,L){if(m==="a"&&!L)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?Y!==e||!L:!e.has(Y))throw new TypeError("Cannot read private member from an object whose class did not declare it");return m==="m"?L:m==="a"?L.call(Y):L?L.value:e.get(Y)};define(pe[233],ve([0,1,162,116,2,5,7,17,3,11,24,44]),function(Y,e,m,L,y,C,i,k,S,D,R,P){"use strict";var u,E,f;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDiagnostics=e.DiagnosticCollection=void 0;class v{constructor(p,s,r,g,a,_){this._name=p,this._owner=s,this._maxDiagnosticsPerFile=r,u.set(this,void 0),E.set(this,void 0),f.set(this,void 0),this._isDisposed=!1,nt(this,f,new R.ResourceMap(n=>g.getComparisonKey(n)),"f"),nt(this,u,a,"f"),nt(this,E,_,"f")}dispose(){this._isDisposed||(Ne(this,E,"f").fire([...Ne(this,f,"f").keys()]),Ne(this,u,"f")&&Ne(this,u,"f").$clear(this._owner),Ne(this,f,"f").clear(),this._isDisposed=!0)}get name(){return this._checkDisposed(),this._name}set(p,s){if(!p){this.clear();return}this._checkDisposed();let r=[];if(y.URI.isUri(p)){if(!s){this.delete(p);return}Ne(this,f,"f").set(p,s.slice()),r=[p]}else if(Array.isArray(p)){r=[];let a;p=[...p].sort(v._compareIndexedTuplesByUri);for(const _ of p){const[n,t]=_;if((!a||n.toString()!==a.toString())&&(a&&Ne(this,f,"f").get(a).length===0&&Ne(this,f,"f").delete(a),a=n,r.push(n),Ne(this,f,"f").set(n,[])),t){const o=Ne(this,f,"f").get(n);o&&o.push(...t)}else{const o=Ne(this,f,"f").get(n);o&&(o.length=0)}}}if(Ne(this,E,"f").fire(r),!Ne(this,u,"f"))return;const g=[];for(let a of r){let _=[];const n=Ne(this,f,"f").get(a);if(n)if(n.length>this._maxDiagnosticsPerFile){_=[];const t=[i.DiagnosticSeverity.Error,i.DiagnosticSeverity.Warning,i.DiagnosticSeverity.Information,i.DiagnosticSeverity.Hint];e:for(let o=0;o<4;o++)for(let d of n)if(d.severity===t[o]&&_.push(k.Diagnostic.from(d))===this._maxDiagnosticsPerFile)break e;_.push({severity:L.MarkerSeverity.Info,message:(0,m.localize)(0,null,n.length-this._maxDiagnosticsPerFile),startLineNumber:_[_.length-1].startLineNumber,startColumn:_[_.length-1].startColumn,endLineNumber:_[_.length-1].endLineNumber,endColumn:_[_.length-1].endColumn})}else _=n.map(t=>k.Diagnostic.from(t));g.push([a,_])}Ne(this,u,"f").$changeMany(this._owner,g)}delete(p){this._checkDisposed(),Ne(this,E,"f").fire([p]),Ne(this,f,"f").delete(p),Ne(this,u,"f")&&Ne(this,u,"f").$changeMany(this._owner,[[p,void 0]])}clear(){this._checkDisposed(),Ne(this,E,"f").fire([...Ne(this,f,"f").keys()]),Ne(this,f,"f").clear(),Ne(this,u,"f")&&Ne(this,u,"f").$clear(this._owner)}forEach(p,s){this._checkDisposed();for(let r of Ne(this,f,"f").keys())p.apply(s,[r,this.get(r),this])}get(p){this._checkDisposed();const s=Ne(this,f,"f").get(p);return Array.isArray(s)?Object.freeze(s.slice(0)):[]}has(p){return this._checkDisposed(),Array.isArray(Ne(this,f,"f").get(p))}_checkDisposed(){if(this._isDisposed)throw new Error("illegal state - object is disposed")}static _compareIndexedTuplesByUri(p,s){return p[0].toString()<s[0].toString()?-1:p[0].toString()>s[0].toString()?1:0}}e.DiagnosticCollection=v,u=new WeakMap,E=new WeakMap,f=new WeakMap;let w=class ri{constructor(p,s,r){this._logService=s,this._fileSystemInfoService=r,this._collections=new Map,this._onDidChangeDiagnostics=new S.DebounceEmitter({merge:g=>g.flat(),delay:50}),this.onDidChangeDiagnostics=S.Event.map(this._onDidChangeDiagnostics.event,ri._mapper),this._proxy=p.getProxy(C.MainContext.MainThreadDiagnostics)}static _mapper(p){const s=new R.ResourceMap;for(const r of p)s.set(r,r);return{uris:Object.freeze(Array.from(s.values()))}}createDiagnosticCollection(p,s){const{_collections:r,_proxy:g,_onDidChangeDiagnostics:a,_logService:_,_fileSystemInfoService:n}=this,t=new class{$changeMany(c,h){g.$changeMany(c,h),_.trace("[DiagnosticCollection] change many (extension, owner, uris)",p.value,c,h.length===0?"CLEARING":h)}$clear(c){g.$clear(c),_.trace("[DiagnosticCollection] remove all (extension, owner)",p.value,c)}dispose(){g.dispose()}};let o;if(!s)s="_generated_diagnostic_collection_name_#"+ri._idPool++,o=s;else if(!r.has(s))o=s;else{this._logService.warn(`DiagnosticCollection with name '${s}' does already exist.`);do o=s+ri._idPool++;while(r.has(o))}return new class extends v{constructor(){super(s,o,ri._maxDiagnosticsPerFile,n.extUri,t,a);r.set(o,this)}dispose(){super.dispose(),r.delete(o)}}}getDiagnostics(p){if(p)return this._getDiagnostics(p);{const s=new Map,r=[];for(const g of this._collections.values())g.forEach((a,_)=>{let n=s.get(a.toString());typeof n=="undefined"&&(n=r.length,s.set(a.toString(),n),r.push([a,[]])),r[n][1]=r[n][1].concat(..._)});return r}}_getDiagnostics(p){let s=[];for(let r of this._collections.values())r.has(p)&&(s=s.concat(r.get(p)));return s}$acceptMarkersChange(p){if(!this._mirrorCollection){const s="_generated_mirror",r=new v(s,s,ri._maxDiagnosticsPerFile,this._fileSystemInfoService.extUri,void 0,this._onDidChangeDiagnostics);this._collections.set(s,r),this._mirrorCollection=r}for(const[s,r]of p)this._mirrorCollection.set(y.URI.revive(s),r.map(k.Diagnostic.to))}};w._idPool=0,w._maxDiagnosticsPerFile=1e3,w=je([He(1,D.ILogService),He(2,P.IExtHostFileSystemInfo)],w),e.ExtHostDiagnostics=w}),define(pe[234],ve([0,1,2,5]),function(Y,e,m,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDialogs=void 0;class y{constructor(i){this._proxy=i.getProxy(L.MainContext.MainThreadDialogs)}showOpenDialog(i){return this._proxy.$showOpenDialog(i).then(k=>k?k.map(S=>m.URI.revive(S)):void 0)}showSaveDialog(i){return this._proxy.$showSaveDialog(i).then(k=>k?m.URI.revive(k):void 0)}}e.ExtHostDialogs=y}),define(pe[235],ve([0,1,15,2,7,5,10,21,8]),function(Y,e,m,L,y,C,i,k,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDocumentContentProvider=void 0;class D{constructor(P,u,E){this._documentsAndEditors=u,this._logService=E,this._documentContentProviders=new Map,this._proxy=P.getProxy(C.MainContext.MainThreadDocumentContentProviders)}registerTextDocumentContentProvider(P,u){if(Object.keys(i.Schemas).indexOf(P)>=0)throw new Error(`scheme '${P}' already registered`);const E=D._handlePool++;this._documentContentProviders.set(E,u),this._proxy.$registerTextContentProvider(E,P);let f;return typeof u.onDidChange=="function"&&(f=u.onDidChange(v=>{if(v.scheme!==P){this._logService.warn(`Provider for scheme '${P}' is firing event for schema '${v.scheme}' which will be IGNORED`);return}this._documentsAndEditors.getDocument(v)&&this.$provideTextDocumentContent(E,v).then(w=>{if(!w&&typeof w!="string")return;const I=this._documentsAndEditors.getDocument(v);if(!I)return;const p=(0,S.splitLines)(w);if(!I.equalLines(p))return this._proxy.$onVirtualDocumentChange(v,w)},m.onUnexpectedError)})),new y.Disposable(()=>{this._documentContentProviders.delete(E)&&this._proxy.$unregisterTextContentProvider(E),f&&(f.dispose(),f=void 0)})}$provideTextDocumentContent(P,u){const E=this._documentContentProviders.get(P);return E?Promise.resolve(E.provideTextDocumentContent(L.URI.revive(u),k.CancellationToken.None)):Promise.reject(new Error(`unsupported uri-scheme: ${u.scheme}`))}}e.ExtHostDocumentContentProvider=D,D._handlePool=0}),define(pe[236],ve([0,1,3,6,2,5,122,17,13,25,7]),function(Y,e,m,L,y,C,i,k,S,D,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDocuments=void 0;class P{constructor(E,f){this._onDidAddDocument=new m.Emitter,this._onDidRemoveDocument=new m.Emitter,this._onDidChangeDocument=new m.Emitter,this._onDidSaveDocument=new m.Emitter,this.onDidAddDocument=this._onDidAddDocument.event,this.onDidRemoveDocument=this._onDidRemoveDocument.event,this.onDidChangeDocument=this._onDidChangeDocument.event,this.onDidSaveDocument=this._onDidSaveDocument.event,this._toDispose=new L.DisposableStore,this._documentLoader=new Map,this._proxy=E.getProxy(C.MainContext.MainThreadDocuments),this._documentsAndEditors=f,this._documentsAndEditors.onDidRemoveDocuments(v=>{for(const w of v)this._onDidRemoveDocument.fire(w.document)},void 0,this._toDispose),this._documentsAndEditors.onDidAddDocuments(v=>{for(const w of v)this._onDidAddDocument.fire(w.document)},void 0,this._toDispose)}dispose(){this._toDispose.dispose()}getAllDocumentData(){return[...this._documentsAndEditors.allDocuments()]}getDocumentData(E){if(!E)return;const f=this._documentsAndEditors.getDocument(E);if(f)return f}getDocument(E){const f=this.getDocumentData(E);if(!f?.document)throw new Error(`Unable to retrieve document from URI '${E}'`);return f.document}ensureDocumentData(E){const f=this._documentsAndEditors.getDocument(E);if(f)return Promise.resolve(f);let v=this._documentLoader.get(E.toString());return v||(v=this._proxy.$tryOpenDocument(E).then(w=>{this._documentLoader.delete(E.toString());const I=y.URI.revive(w);return(0,S.assertIsDefined)(this._documentsAndEditors.getDocument(I))},w=>(this._documentLoader.delete(E.toString()),Promise.reject(w))),this._documentLoader.set(E.toString(),v)),v}createDocumentData(E){return this._proxy.$tryCreateDocument(E).then(f=>y.URI.revive(f))}$acceptModelModeChanged(E,f){const v=y.URI.revive(E),w=this._documentsAndEditors.getDocument(v);if(!w)throw new Error("unknown document");this._onDidRemoveDocument.fire(w.document),w._acceptLanguageId(f),this._onDidAddDocument.fire(w.document)}$acceptModelSaved(E){const f=y.URI.revive(E),v=this._documentsAndEditors.getDocument(f);if(!v)throw new Error("unknown document");this.$acceptDirtyStateChanged(E,!1),this._onDidSaveDocument.fire(v.document)}$acceptDirtyStateChanged(E,f){const v=y.URI.revive(E),w=this._documentsAndEditors.getDocument(v);if(!w)throw new Error("unknown document");w._acceptIsDirty(f),this._onDidChangeDocument.fire({document:w.document,contentChanges:[],reason:void 0})}$acceptModelChanged(E,f,v){const w=y.URI.revive(E),I=this._documentsAndEditors.getDocument(w);if(!I)throw new Error("unknown document");I._acceptIsDirty(v),I.onEvents(f);let p;f.isUndoing?p=R.TextDocumentChangeReason.Undo:f.isRedoing&&(p=R.TextDocumentChangeReason.Redo),this._onDidChangeDocument.fire((0,D.deepFreeze)({document:I.document,contentChanges:f.changes.map(s=>({range:k.Range.to(s.range),rangeOffset:s.rangeOffset,rangeLength:s.rangeLength,text:s.text})),reason:p}))}setWordDefinitionFor(E,f){(0,i.setWordDefinitionFor)(E,f)}}e.ExtHostDocuments=P}),define(pe[45],ve([0,1,56,3,6,2,4,5,122,14,129,17,11,24,10,76,140]),function(Y,e,m,L,y,C,i,k,S,D,R,P,u,E,f,v,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostDocumentsAndEditors=e.ExtHostDocumentsAndEditors=void 0;class I{constructor(r){this.value=r,this._count=0}ref(){this._count++}unref(){return--this._count==0}}let p=class{constructor(r,g){this._extHostRpc=r,this._logService=g,this._activeEditorId=null,this._editors=new Map,this._documents=new E.ResourceMap,this._onDidAddDocuments=new L.Emitter,this._onDidRemoveDocuments=new L.Emitter,this._onDidChangeVisibleTextEditors=new L.Emitter,this._onDidChangeActiveTextEditor=new L.Emitter,this.onDidAddDocuments=this._onDidAddDocuments.event,this.onDidRemoveDocuments=this._onDidRemoveDocuments.event,this.onDidChangeVisibleTextEditors=this._onDidChangeVisibleTextEditors.event,this.onDidChangeActiveTextEditor=this._onDidChangeActiveTextEditor.event}$acceptDocumentsAndEditorsDelta(r){this.acceptDocumentsAndEditorsDelta(r)}acceptDocumentsAndEditorsDelta(r){const g=[],a=[],_=[];if(r.removedDocuments)for(const n of r.removedDocuments){const t=C.URI.revive(n),o=this._documents.get(t);o?.unref()&&(this._documents.delete(t),g.push(o.value))}if(r.addedDocuments)for(const n of r.addedDocuments){const t=C.URI.revive(n.uri);let o=this._documents.get(t);if(o&&t.scheme!==f.Schemas.vscodeNotebookCell&&t.scheme!==f.Schemas.vscodeInteractiveInput)throw new Error(`document '${t} already exists!'`);o||(o=new I(new S.ExtHostDocumentData(this._extHostRpc.getProxy(k.MainContext.MainThreadDocuments),t,n.lines,n.EOL,n.versionId,n.languageId,n.isDirty,n.notebook)),this._documents.set(t,o),a.push(o.value)),o.ref()}if(r.removedEditors)for(const n of r.removedEditors){const t=this._editors.get(n);this._editors.delete(n),t&&_.push(t)}if(r.addedEditors)for(const n of r.addedEditors){const t=C.URI.revive(n.documentUri);m.ok(this._documents.has(t),`document '${t}' does not exist`),m.ok(!this._editors.has(n.id),`editor '${n.id}' already exists!`);const o=this._documents.get(t).value,d=new R.ExtHostTextEditor(n.id,this._extHostRpc.getProxy(k.MainContext.MainThreadTextEditors),this._logService,new w.Lazy(()=>o.document),n.selections.map(P.Selection.to),n.options,n.visibleRanges.map(c=>P.Range.to(c)),typeof n.editorPosition=="number"?P.ViewColumn.to(n.editorPosition):void 0);this._editors.set(n.id,d)}r.newActiveEditor!==void 0&&(m.ok(r.newActiveEditor===null||this._editors.has(r.newActiveEditor),`active editor '${r.newActiveEditor}' does not exist`),this._activeEditorId=r.newActiveEditor),(0,y.dispose)(g),(0,y.dispose)(_),r.removedDocuments&&this._onDidRemoveDocuments.fire(g),r.addedDocuments&&this._onDidAddDocuments.fire(a),(r.removedEditors||r.addedEditors)&&this._onDidChangeVisibleTextEditors.fire(this.allEditors().map(n=>n.value)),r.newActiveEditor!==void 0&&this._onDidChangeActiveTextEditor.fire(this.activeEditor())}getDocument(r){return this._documents.get(r)?.value}allDocuments(){return v.Iterable.map(this._documents.values(),r=>r.value)}getEditor(r){return this._editors.get(r)}activeEditor(r){if(!this._activeEditorId)return;const g=this._editors.get(this._activeEditorId);return r?g:g?.value}allEditors(){return[...this._editors.values()]}};p=je([He(0,D.IExtHostRpcService),He(1,u.ILogService)],p),e.ExtHostDocumentsAndEditors=p,e.IExtHostDocumentsAndEditors=(0,i.createDecorator)("IExtHostDocumentsAndEditors")}),define(pe[54],ve([0,1,17,5,2,3,4,14,18]),function(Y,e,m,L,y,C,i,k,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostEditorTabs=e.IExtHostEditorTabs=void 0,e.IExtHostEditorTabs=(0,i.createDecorator)("IExtHostEditorTabs");let D=class{constructor(P){this._onDidChangeTabs=new C.Emitter,this.onDidChangeTabs=this._onDidChangeTabs.event,this._onDidChangeActiveTab=new C.Emitter,this.onDidChangeActiveTab=this._onDidChangeActiveTab.event,this._tabs=[],this._proxy=P.getProxy(L.MainContext.MainThreadEditorTabs)}get tabs(){return this._tabs}get activeTab(){return this._activeTab}$acceptEditorTabs(P){let u=-1;this._tabs=P.map((f,v)=>(f.isActive&&(u=v),Object.freeze({label:f.label,viewColumn:m.ViewColumn.to(f.viewColumn),index:v,resource:y.URI.revive(f.resource),additionalResourcesAndViewIds:f.additionalResourcesAndViewIds.map(({resource:w,viewId:I})=>({resource:y.URI.revive(w),viewId:I})),viewId:f.editorId,isActive:f.isActive,move:async(w,I)=>{this._proxy.$moveTab(f,w,m.ViewColumn.from(I)),await(0,S.raceTimeout)(C.Event.toPromise(this._onDidChangeTabs.event),1e3)},close:async()=>{await this._proxy.$closeTab(f),await(0,S.raceTimeout)(C.Event.toPromise(this._onDidChangeTabs.event),1e3)}}))),this._tabs=this._tabs.sort((f,v)=>f.viewColumn===v.viewColumn?f.index-v.index:f.viewColumn-v.viewColumn);const E=this._activeTab;this._activeTab=u===-1?void 0:this._tabs[u],this._activeTab!==E&&this._onDidChangeActiveTab.fire(this._activeTab),this._onDidChangeTabs.fire(this._tabs)}};D=je([He(0,k.IExtHostRpcService)],D),e.ExtHostEditorTabs=D}),define(pe[237],ve([0,1,2,5,6,7,17,147,8,22,29]),function(Y,e,m,L,y,C,i,k,S,D,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostFileSystem=void 0;class P{constructor(){this._schemes=[]}add(f){this._stateMachine=void 0,this._schemes.push(f)}delete(f){const v=this._schemes.indexOf(f);v>=0&&(this._schemes.splice(v,1),this._stateMachine=void 0)}_initStateMachine(){if(!this._stateMachine){const f=this._schemes.sort(),v=[];let w,I,p=14,s=14;for(const r of f){let g=w?(0,S.commonPrefixLength)(w,r):0;for(g===0?I=1:I=s;g<r.length;g++)g+1===r.length?(p=s,s=9):s+=1,v.push([I,r.toUpperCase().charCodeAt(g),s]),v.push([I,r.toLowerCase().charCodeAt(g),s]),I=s;w=r,s=p}v.push([9,58,10]),v.push([10,47,12]),this._stateMachine=new k.StateMachine(v)}}provideDocumentLinks(f){this._initStateMachine();const v=[],w=k.LinkComputer.computeLinks({getLineContent(I){return f.lineAt(I-1).text},getLineCount(){return f.lineCount}},this._stateMachine);for(const I of w){const p=i.DocumentLink.to(I);p.target&&v.push(p)}return v}}class u{constructor(f,v){this._extHostLanguageFeatures=v,this._linkProvider=new P,this._fsProvider=new Map,this._registeredSchemes=new Set,this._watches=new Map,this._handlePool=0,this._proxy=f.getProxy(L.MainContext.MainThreadFileSystem)}dispose(){this._linkProviderRegistration?.dispose()}_registerLinkProviderIfNotYetRegistered(){this._linkProviderRegistration||(this._linkProviderRegistration=this._extHostLanguageFeatures.registerDocumentLinkProvider(void 0,"*",this._linkProvider))}registerFileSystemProvider(f,v,w,I={}){if(this._registeredSchemes.has(v))throw new Error(`a provider for the scheme '${v}' is already registered`);this._registerLinkProviderIfNotYetRegistered();const p=this._handlePool++;this._linkProvider.add(v),this._registeredSchemes.add(v),this._fsProvider.set(p,w);let s=2;I.isCaseSensitive&&(s+=1024),I.isReadonly&&(s+=2048),typeof w.copy=="function"&&(s+=8),typeof w.open=="function"&&typeof w.close=="function"&&typeof w.read=="function"&&typeof w.write=="function"&&((0,R.checkProposedApiEnabled)(f,"fsChunks"),s+=4),this._proxy.$registerFileSystemProvider(p,v,s).catch(g=>{console.error(`FAILED to register filesystem provider of ${f.identifier.value}-extension for the scheme ${v}`),console.error(g)});const r=w.onDidChangeFile(g=>{const a=[];for(const _ of g){let{uri:n,type:t}=_;if(n.scheme!==v)continue;let o;switch(t){case C.FileChangeType.Changed:o=0;break;case C.FileChangeType.Created:o=1;break;case C.FileChangeType.Deleted:o=2;break;default:throw new Error("Unknown FileChangeType")}a.push({resource:n,type:o})}this._proxy.$onFileSystemChange(p,a)});return(0,y.toDisposable)(()=>{r.dispose(),this._linkProvider.delete(v),this._registeredSchemes.delete(v),this._fsProvider.delete(p),this._proxy.$unregisterProvider(p)})}static _asIStat(f){const{type:v,ctime:w,mtime:I,size:p,permissions:s}=f;return{type:v,ctime:w,mtime:I,size:p,permissions:s}}$stat(f,v){return Promise.resolve(this._getFsProvider(f).stat(m.URI.revive(v))).then(w=>u._asIStat(w))}$readdir(f,v){return Promise.resolve(this._getFsProvider(f).readDirectory(m.URI.revive(v)))}$readFile(f,v){return Promise.resolve(this._getFsProvider(f).readFile(m.URI.revive(v))).then(w=>D.VSBuffer.wrap(w))}$writeFile(f,v,w,I){return Promise.resolve(this._getFsProvider(f).writeFile(m.URI.revive(v),w.buffer,I))}$delete(f,v,w){return Promise.resolve(this._getFsProvider(f).delete(m.URI.revive(v),w))}$rename(f,v,w,I){return Promise.resolve(this._getFsProvider(f).rename(m.URI.revive(v),m.URI.revive(w),I))}$copy(f,v,w,I){const p=this._getFsProvider(f);if(!p.copy)throw new Error('FileSystemProvider does not implement "copy"');return Promise.resolve(p.copy(m.URI.revive(v),m.URI.revive(w),I))}$mkdir(f,v){return Promise.resolve(this._getFsProvider(f).createDirectory(m.URI.revive(v)))}$watch(f,v,w,I){const p=this._getFsProvider(f).watch(m.URI.revive(w),I);this._watches.set(v,p)}$unwatch(f,v){const w=this._watches.get(v);w&&(w.dispose(),this._watches.delete(v))}$open(f,v,w){const I=this._getFsProvider(f);if(!I.open)throw new Error('FileSystemProvider does not implement "open"');return Promise.resolve(I.open(m.URI.revive(v),w))}$close(f,v){const w=this._getFsProvider(f);if(!w.close)throw new Error('FileSystemProvider does not implement "close"');return Promise.resolve(w.close(v))}$read(f,v,w,I){const p=this._getFsProvider(f);if(!p.read)throw new Error('FileSystemProvider does not implement "read"');const s=D.VSBuffer.alloc(I);return Promise.resolve(p.read(v,w,s.buffer,0,I)).then(r=>s.slice(0,r))}$write(f,v,w,I){const p=this._getFsProvider(f);if(!p.write)throw new Error('FileSystemProvider does not implement "write"');return Promise.resolve(p.write(v,w,I.buffer,0,I.byteLength))}_getFsProvider(f){const v=this._fsProvider.get(f);if(!v){const w=new Error;throw w.name="ENOPRO",w.message="no provider",w}return v}}e.ExtHostFileSystem=u}),define(pe[66],ve([0,1,5,42,7,22,4,14,44,6]),function(Y,e,m,L,y,C,i,k,S,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostConsumerFileSystem=e.ExtHostConsumerFileSystem=void 0;let R=class zt{constructor(u,E){this._fileSystemProvider=new Map,this._proxy=u.getProxy(m.MainContext.MainThreadFileSystem);const f=this;this.value=Object.freeze({async stat(v){try{const w=f._fileSystemProvider.get(v.scheme);if(!w)return await f._proxy.$stat(v);await f._proxy.$ensureActivation(v.scheme);const I=await w.stat(v);return{type:I.type,ctime:I.ctime,mtime:I.mtime,size:I.size,permissions:I.permissions}}catch(w){zt._handleError(w)}},async readDirectory(v){try{const w=f._fileSystemProvider.get(v.scheme);return w?(await f._proxy.$ensureActivation(v.scheme),(await w.readDirectory(v)).slice()):await f._proxy.$readdir(v)}catch(w){return zt._handleError(w)}},async createDirectory(v){try{return await f._proxy.$mkdir(v)}catch(w){return zt._handleError(w)}},async readFile(v){try{const w=f._fileSystemProvider.get(v.scheme);return w?(await f._proxy.$ensureActivation(v.scheme),(await w.readFile(v)).slice()):(await f._proxy.$readFile(v)).buffer}catch(w){return zt._handleError(w)}},async writeFile(v,w){try{return await f._proxy.$writeFile(v,C.VSBuffer.wrap(w))}catch(I){return zt._handleError(I)}},async delete(v,w){try{const I=f._fileSystemProvider.get(v.scheme);return I?(await f._proxy.$ensureActivation(v.scheme),await I.delete(v,{recursive:!1,...w})):await f._proxy.$delete(v,{recursive:!1,useTrash:!1,...w})}catch(I){return zt._handleError(I)}},async rename(v,w,I){try{return await f._proxy.$rename(v,w,{overwrite:!1,...I})}catch(p){return zt._handleError(p)}},async copy(v,w,I){try{return await f._proxy.$copy(v,w,{overwrite:!1,...I})}catch(p){return zt._handleError(p)}},isWritableFileSystem(v){const w=E.getCapabilities(v);if(typeof w=="number")return!(w&2048)}})}static _handleError(u){if(u instanceof y.FileSystemError)throw u;if(!(u instanceof Error))throw new y.FileSystemError(String(u));if(u.name==="ENOPRO")throw y.FileSystemError.Unavailable(u.message);switch(u.name){case L.FileSystemProviderErrorCode.FileExists:throw y.FileSystemError.FileExists(u.message);case L.FileSystemProviderErrorCode.FileNotFound:throw y.FileSystemError.FileNotFound(u.message);case L.FileSystemProviderErrorCode.FileNotADirectory:throw y.FileSystemError.FileNotADirectory(u.message);case L.FileSystemProviderErrorCode.FileIsADirectory:throw y.FileSystemError.FileIsADirectory(u.message);case L.FileSystemProviderErrorCode.NoPermissions:throw y.FileSystemError.NoPermissions(u.message);case L.FileSystemProviderErrorCode.Unavailable:throw y.FileSystemError.Unavailable(u.message);default:throw new y.FileSystemError(u.message,u.name)}}addFileSystemProvider(u,E){return this._fileSystemProvider.set(u,E),(0,D.toDisposable)(()=>this._fileSystemProvider.delete(u))}};R=je([He(0,k.IExtHostRpcService),He(1,S.IExtHostFileSystemInfo)],R),e.ExtHostConsumerFileSystem=R,e.IExtHostConsumerFileSystem=(0,i.createDecorator)("IExtHostConsumerFileSystem")}),define(pe[238],ve([0,1,2,38]),function(Y,e,m,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostInteractive=void 0;class y{constructor(i,k,S,D){this._extHostNotebooks=k,this._textDocumentsAndEditors=S,this._commands=D;const R=new L.ApiCommand("interactive.open","_interactive.open","Open interactive window and return notebook editor and input URI",[new L.ApiCommandArgument("showOptions","Show Options",P=>!0,P=>P),new L.ApiCommandArgument("resource","Interactive resource Uri",P=>!0,P=>P),new L.ApiCommandArgument("controllerId","Notebook controller Id",P=>!0,P=>P),new L.ApiCommandArgument("title","Interactive editor title",P=>!0,P=>P)],new L.ApiCommandResult("Notebook and input URI",P=>{if(P.notebookEditorId!==void 0){const u=this._extHostNotebooks.getEditorById(P.notebookEditorId);return{notebookUri:m.URI.revive(P.notebookUri),inputUri:m.URI.revive(P.inputUri),notebookEditor:u.apiEditor}}return{notebookUri:m.URI.revive(P.notebookUri),inputUri:m.URI.revive(P.inputUri)}}));this._commands.registerApiCommand(R)}$willAddInteractiveDocument(i,k,S,D){this._textDocumentsAndEditors.acceptDocumentsAndEditorsDelta({addedDocuments:[{EOL:k,lines:[""],languageId:S,uri:i,isDirty:!1,versionId:1,notebook:this._extHostNotebooks.getNotebookDocument(m.URI.revive(D))?.apiNotebook}]})}$willRemoveInteractiveDocument(i,k){this._textDocumentsAndEditors.acceptDocumentsAndEditorsDelta({removedDocuments:[i]})}}e.ExtHostInteractive=y}),define(pe[239],ve([0,1,6,5]),function(Y,e,m,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLabelService=void 0;class y{constructor(i){this._handlePool=0,this._proxy=i.getProxy(L.MainContext.MainThreadLabelService)}$registerResourceLabelFormatter(i){const k=this._handlePool++;return this._proxy.$registerResourceLabelFormatter(k,i),(0,m.toDisposable)(()=>{this._proxy.$unregisterResourceLabelFormatter(k)})}}e.ExtHostLabelService=y}),define(pe[240],ve([0,1,2,25,17,7,5,8,41,16,13,144,6,110,75,87,46,15,3]),function(Y,e,m,L,y,C,i,k,S,D,R,P,u,E,f,v,w,I,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLanguageFeatures=e.InlineCompletionController=e.DocumentRangeSemanticTokensAdapter=e.DocumentSemanticTokensAdapter=void 0;class s{constructor(Q,ee){this._documents=Q,this._provider=ee}async provideDocumentSymbols(Q,ee){const re=this._documents.getDocument(Q),he=await this._provider.provideDocumentSymbols(re,ee);if(!(0,D.isFalsyOrEmpty)(he))return he[0]instanceof C.DocumentSymbol?he.map(y.DocumentSymbol.from):s._asDocumentSymbolTree(he)}static _asDocumentSymbolTree(Q){Q=Q.slice(0).sort((he,Z)=>{let oe=he.location.range.start.compareTo(Z.location.range.start);return oe===0&&(oe=Z.location.range.end.compareTo(he.location.range.end)),oe});const ee=[],re=[];for(const he of Q){const Z={name:he.name||"!!MISSING: name!!",kind:y.SymbolKind.from(he.kind),tags:he.tags?.map(y.SymbolTag.from)||[],detail:"",containerName:he.containerName,range:y.Range.from(he.location.range),selectionRange:y.Range.from(he.location.range),children:[]};for(;;){if(re.length===0){re.push(Z),ee.push(Z);break}const oe=re[re.length-1];if(S.Range.containsRange(oe.range,Z.range)&&!S.Range.equalsRange(oe.range,Z.range)){oe.children&&oe.children.push(Z),re.push(Z);break}re.pop()}}return ee}}class r{constructor(Q,ee,re){this._documents=Q,this._commands=ee,this._provider=re,this._cache=new v.Cache("CodeLens"),this._disposables=new Map}async provideCodeLenses(Q,ee){const re=this._documents.getDocument(Q),he=await this._provider.provideCodeLenses(re,ee);if(!he||ee.isCancellationRequested)return;const Z=this._cache.add(he),oe=new u.DisposableStore;this._disposables.set(Z,oe);const be={cacheId:Z,lenses:[]};for(let Me=0;Me<he.length;Me++)be.lenses.push({cacheId:[Z,Me],range:y.Range.from(he[Me].range),command:this._commands.toInternal(he[Me].command,oe)});return be}async resolveCodeLens(Q,ee){const re=Q.cacheId&&this._cache.get(...Q.cacheId);if(!re)return;let he;if(typeof this._provider.resolveCodeLens!="function"||re.isResolved?he=re:he=await this._provider.resolveCodeLens(re,ee),he||(he=re),ee.isCancellationRequested)return;const Z=Q.cacheId&&this._disposables.get(Q.cacheId[0]);if(!!Z)return Q.command=this._commands.toInternal(he.command??r._badCmd,Z),Q}releaseCodeLenses(Q){this._disposables.get(Q)?.dispose(),this._disposables.delete(Q),this._cache.delete(Q)}}r._badCmd={command:"missing",title:"!!MISSING: command!!"};function g(ze){return Array.isArray(ze)?ze.map(y.DefinitionLink.from):ze?[y.DefinitionLink.from(ze)]:[]}class a{constructor(Q,ee){this._documents=Q,this._provider=ee}async provideDefinition(Q,ee,re){const he=this._documents.getDocument(Q),Z=y.Position.to(ee),oe=await this._provider.provideDefinition(he,Z,re);return g(oe)}}class _{constructor(Q,ee){this._documents=Q,this._provider=ee}async provideDeclaration(Q,ee,re){const he=this._documents.getDocument(Q),Z=y.Position.to(ee),oe=await this._provider.provideDeclaration(he,Z,re);return g(oe)}}class n{constructor(Q,ee){this._documents=Q,this._provider=ee}async provideImplementation(Q,ee,re){const he=this._documents.getDocument(Q),Z=y.Position.to(ee),oe=await this._provider.provideImplementation(he,Z,re);return g(oe)}}class t{constructor(Q,ee){this._documents=Q,this._provider=ee}async provideTypeDefinition(Q,ee,re){const he=this._documents.getDocument(Q),Z=y.Position.to(ee),oe=await this._provider.provideTypeDefinition(he,Z,re);return g(oe)}}class o{constructor(Q,ee){this._documents=Q,this._provider=ee}async provideHover(Q,ee,re){const he=this._documents.getDocument(Q),Z=y.Position.to(ee),oe=await this._provider.provideHover(he,Z,re);if(!(!oe||(0,D.isFalsyOrEmpty)(oe.contents)))return oe.range||(oe.range=he.getWordRangeAtPosition(Z)),oe.range||(oe.range=new C.Range(Z,Z)),y.Hover.from(oe)}}class d{constructor(Q,ee){this._documents=Q,this._provider=ee}async provideEvaluatableExpression(Q,ee,re){const he=this._documents.getDocument(Q),Z=y.Position.to(ee),oe=await this._provider.provideEvaluatableExpression(he,Z,re);if(oe)return y.EvaluatableExpression.from(oe)}}class c{constructor(Q,ee){this._documents=Q,this._provider=ee}async provideInlineValues(Q,ee,re,he){const Z=this._documents.getDocument(Q),oe=await this._provider.provideInlineValues(Z,y.Range.to(ee),y.InlineValueContext.to(re),he);if(Array.isArray(oe))return oe.map(be=>y.InlineValue.from(be))}}class h{constructor(Q,ee){this._documents=Q,this._provider=ee}async provideDocumentHighlights(Q,ee,re){const he=this._documents.getDocument(Q),Z=y.Position.to(ee),oe=await this._provider.provideDocumentHighlights(he,Z,re);if(Array.isArray(oe))return oe.map(y.DocumentHighlight.from)}}class l{constructor(Q,ee){this._documents=Q,this._provider=ee}async provideLinkedEditingRanges(Q,ee,re){const he=this._documents.getDocument(Q),Z=y.Position.to(ee),oe=await this._provider.provideLinkedEditingRanges(he,Z,re);if(oe&&Array.isArray(oe.ranges))return{ranges:(0,D.coalesce)(oe.ranges.map(y.Range.from)),wordPattern:oe.wordPattern}}}class b{constructor(Q,ee){this._documents=Q,this._provider=ee}async provideReferences(Q,ee,re,he){const Z=this._documents.getDocument(Q),oe=y.Position.to(ee),be=await this._provider.provideReferences(Z,oe,re,he);if(Array.isArray(be))return be.map(y.location.from)}}class T{constructor(Q,ee,re,he,Z,oe,be){this._documents=Q,this._commands=ee,this._diagnostics=re,this._provider=he,this._logService=Z,this._extension=oe,this._apiDeprecation=be,this._cache=new v.Cache("CodeAction"),this._disposables=new Map}async provideCodeActions(Q,ee,re,he){const Z=this._documents.getDocument(Q),oe=P.Selection.isISelection(ee)?y.Selection.to(ee):y.Range.to(ee),be=[];for(const ot of this._diagnostics.getDiagnostics(Q))if(oe.intersection(ot.range)&&be.push(ot)>T._maxCodeActionsPerFile)break;const Me={diagnostics:be,only:re.only?new C.CodeActionKind(re.only):void 0,triggerKind:y.CodeActionTriggerKind.to(re.trigger)},Ve=await this._provider.provideCodeActions(Z,oe,Me,he);if(!(0,D.isNonEmptyArray)(Ve)||he.isCancellationRequested)return;const Ge=this._cache.add(Ve),Je=new u.DisposableStore;this._disposables.set(Ge,Je);const tt=[];for(let ot=0;ot<Ve.length;ot++){const et=Ve[ot];!et||(T._isCommand(et)?(this._apiDeprecation.report("CodeActionProvider.provideCodeActions - return commands",this._extension,"Return 'CodeAction' instances instead."),tt.push({_isSynthetic:!0,title:et.title,command:this._commands.toInternal(et,Je)})):(Me.only&&(et.kind?Me.only.contains(et.kind)||this._logService.warn(`${this._extension.identifier.value} - Code actions of kind '${Me.only.value} 'requested but returned code action is of kind '${et.kind.value}'. Code action will be dropped. Please check 'CodeActionContext.only' to only return requested code actions.`):this._logService.warn(`${this._extension.identifier.value} - Code actions of kind '${Me.only.value} 'requested but returned code action does not have a 'kind'. Code action will be dropped. Please set 'CodeAction.kind'.`)),tt.push({cacheId:[Ge,ot],title:et.title,command:et.command&&this._commands.toInternal(et.command,Je),diagnostics:et.diagnostics&&et.diagnostics.map(y.Diagnostic.from),edit:et.edit&&y.WorkspaceEdit.from(et.edit),kind:et.kind&&et.kind.value,isPreferred:et.isPreferred,disabled:et.disabled?.reason})))}return{cacheId:Ge,actions:tt}}async resolveCodeAction(Q,ee){const[re,he]=Q,Z=this._cache.get(re,he);if(!Z||T._isCommand(Z)||!this._provider.resolveCodeAction)return;const oe=await this._provider.resolveCodeAction(Z,ee)??Z;return oe?.edit?y.WorkspaceEdit.from(oe.edit):void 0}releaseCodeActions(Q){this._disposables.get(Q)?.dispose(),this._disposables.delete(Q),this._cache.delete(Q)}static _isCommand(Q){return typeof Q.command=="string"&&typeof Q.title=="string"}}T._maxCodeActionsPerFile=1e3;class A{constructor(Q,ee){this._documents=Q,this._provider=ee}async provideDocumentFormattingEdits(Q,ee,re){const he=this._documents.getDocument(Q),Z=await this._provider.provideDocumentFormattingEdits(he,ee,re);if(Array.isArray(Z))return Z.map(y.TextEdit.from)}}class x{constructor(Q,ee){this._documents=Q,this._provider=ee}async provideDocumentRangeFormattingEdits(Q,ee,re,he){const Z=this._documents.getDocument(Q),oe=y.Range.to(ee),be=await this._provider.provideDocumentRangeFormattingEdits(Z,oe,re,he);if(Array.isArray(be))return be.map(y.TextEdit.from)}}class O{constructor(Q,ee){this._documents=Q,this._provider=ee,this.autoFormatTriggerCharacters=[]}async provideOnTypeFormattingEdits(Q,ee,re,he,Z){const oe=this._documents.getDocument(Q),be=y.Position.to(ee),Me=await this._provider.provideOnTypeFormattingEdits(oe,be,re,he,Z);if(Array.isArray(Me))return Me.map(y.TextEdit.from)}}class F{constructor(Q,ee){this._provider=Q,this._logService=ee,this._symbolCache=new Map,this._resultCache=new Map}async provideWorkspaceSymbols(Q,ee){const re=i.IdObject.mixin({symbols:[]}),he=await this._provider.provideWorkspaceSymbols(Q,ee);if((0,D.isNonEmptyArray)(he))for(const Z of he){if(!Z)continue;if(!Z.name){this._logService.warn("INVALID SymbolInformation, lacks name",Z);continue}const oe=i.IdObject.mixin(y.WorkspaceSymbol.from(Z));this._symbolCache.set(oe._id,Z),re.symbols.push(oe)}return re.symbols.length>0&&this._resultCache.set(re._id,[re.symbols[0]._id,re.symbols[re.symbols.length-1]._id]),re}async resolveWorkspaceSymbol(Q,ee){if(typeof this._provider.resolveWorkspaceSymbol!="function")return Q;const re=this._symbolCache.get(Q._id);if(re){const he=await this._provider.resolveWorkspaceSymbol(re,ee);return he&&(0,L.mixin)(Q,y.WorkspaceSymbol.from(he),!0)}}releaseWorkspaceSymbols(Q){const ee=this._resultCache.get(Q);if(ee){for(let[re,he]=ee;re<=he;re++)this._symbolCache.delete(re);this._resultCache.delete(Q)}}}class W{constructor(Q,ee,re){this._documents=Q,this._provider=ee,this._logService=re}static supportsResolving(Q){return typeof Q.prepareRename=="function"}async provideRenameEdits(Q,ee,re,he){const Z=this._documents.getDocument(Q),oe=y.Position.to(ee);try{const be=await this._provider.provideRenameEdits(Z,oe,re,he);return be?y.WorkspaceEdit.from(be):void 0}catch(be){const Me=W._asMessage(be);return Me?{rejectReason:Me,edits:void 0}:Promise.reject(be)}}async resolveRenameLocation(Q,ee,re){if(typeof this._provider.prepareRename!="function")return Promise.resolve(void 0);const he=this._documents.getDocument(Q),Z=y.Position.to(ee);try{const oe=await this._provider.prepareRename(he,Z,re);let be,Me;if(C.Range.isRange(oe)?(be=oe,Me=he.getText(oe)):(0,R.isObject)(oe)&&(be=oe.range,Me=oe.placeholder),!be||!Me)return;if(be.start.line>Z.line||be.end.line<Z.line){this._logService.warn("INVALID rename location: position line must be within range start/end lines");return}return{range:y.Range.from(be),text:Me}}catch(oe){const be=W._asMessage(oe);return be?{rejectReason:be,range:void 0,text:void 0}:Promise.reject(oe)}}static _asMessage(Q){return typeof Q=="string"?Q:Q instanceof Error&&typeof Q.message=="string"?Q.message:void 0}}class M{constructor(Q,ee){this.resultId=Q,this.tokens=ee}}class B{constructor(Q,ee){this._documents=Q,this._provider=ee,this._nextResultId=1,this._previousResults=new Map}async provideDocumentSemanticTokens(Q,ee,re){const he=this._documents.getDocument(Q),Z=ee!==0?this._previousResults.get(ee):null;let oe=typeof Z?.resultId=="string"&&typeof this._provider.provideDocumentSemanticTokensEdits=="function"?await this._provider.provideDocumentSemanticTokensEdits(he,Z.resultId,re):await this._provider.provideDocumentSemanticTokens(he,re);return Z&&this._previousResults.delete(ee),oe?(oe=B._fixProvidedSemanticTokens(oe),this._send(B._convertToEdits(Z,oe),oe)):null}async releaseDocumentSemanticColoring(Q){this._previousResults.delete(Q)}static _fixProvidedSemanticTokens(Q){return B._isSemanticTokens(Q)?B._isCorrectSemanticTokens(Q)?Q:new C.SemanticTokens(new Uint32Array(Q.data),Q.resultId):B._isSemanticTokensEdits(Q)?B._isCorrectSemanticTokensEdits(Q)?Q:new C.SemanticTokensEdits(Q.edits.map(ee=>new C.SemanticTokensEdit(ee.start,ee.deleteCount,ee.data?new Uint32Array(ee.data):ee.data)),Q.resultId):Q}static _isSemanticTokens(Q){return Q&&!!Q.data}static _isCorrectSemanticTokens(Q){return Q.data instanceof Uint32Array}static _isSemanticTokensEdits(Q){return Q&&Array.isArray(Q.edits)}static _isCorrectSemanticTokensEdits(Q){for(const ee of Q.edits)if(!(ee.data instanceof Uint32Array))return!1;return!0}static _convertToEdits(Q,ee){if(!B._isSemanticTokens(ee)||!Q||!Q.tokens)return ee;const re=Q.tokens,he=re.length,Z=ee.data,oe=Z.length;let be=0;const Me=Math.min(he,oe);for(;be<Me&&re[be]===Z[be];)be++;if(be===he&&be===oe)return new C.SemanticTokensEdits([],ee.resultId);let Ve=0;const Ge=Me-be;for(;Ve<Ge&&re[he-Ve-1]===Z[oe-Ve-1];)Ve++;return new C.SemanticTokensEdits([{start:be,deleteCount:he-be-Ve,data:Z.subarray(be,oe-Ve)}],ee.resultId)}_send(Q,ee){if(B._isSemanticTokens(Q)){const re=this._nextResultId++;return this._previousResults.set(re,new M(Q.resultId,Q.data)),(0,E.encodeSemanticTokensDto)({id:re,type:"full",data:Q.data})}if(B._isSemanticTokensEdits(Q)){const re=this._nextResultId++;return B._isSemanticTokens(ee)?this._previousResults.set(re,new M(ee.resultId,ee.data)):this._previousResults.set(re,new M(Q.resultId)),(0,E.encodeSemanticTokensDto)({id:re,type:"delta",deltas:(Q.edits||[]).map(he=>({start:he.start,deleteCount:he.deleteCount,data:he.data}))})}return null}}e.DocumentSemanticTokensAdapter=B;class U{constructor(Q,ee){this._documents=Q,this._provider=ee}async provideDocumentRangeSemanticTokens(Q,ee,re){const he=this._documents.getDocument(Q),Z=await this._provider.provideDocumentRangeSemanticTokens(he,y.Range.to(ee),re);return Z?this._send(Z):null}_send(Q){return(0,E.encodeSemanticTokensDto)({id:0,type:"full",data:Q.data})}}e.DocumentRangeSemanticTokensAdapter=U;class z{constructor(Q,ee,re,he,Z){this._documents=Q,this._commands=ee,this._provider=re,this._apiDeprecation=he,this._extension=Z,this._cache=new v.Cache("CompletionItem"),this._disposables=new Map}static supportsResolving(Q){return typeof Q.resolveCompletionItem=="function"}async provideCompletionItems(Q,ee,re,he){const Z=this._documents.getDocument(Q),oe=y.Position.to(ee),be=Z.getWordRangeAtPosition(oe)||new C.Range(oe,oe),Me=be.with({end:oe}),Ve=new w.StopWatch(!0),Ge=await this._provider.provideCompletionItems(Z,oe,he,y.CompletionContext.to(re));if(!Ge||he.isCancellationRequested)return;const Je=Array.isArray(Ge)?new C.CompletionList(Ge):Ge,tt=z.supportsResolving(this._provider)?this._cache.add(Je.items):this._cache.add([]),ot=new u.DisposableStore;this._disposables.set(tt,ot);const et=[],it={x:tt,b:et,a:{replace:y.Range.from(be),insert:y.Range.from(Me)},c:Je.isIncomplete||void 0,d:Ve.elapsed()};for(let ct=0;ct<Je.items.length;ct++){const pt=Je.items[ct],Pt=this._convertCompletionItem(pt,[tt,ct],Me,be);et.push(Pt)}return it}async resolveCompletionItem(Q,ee){if(typeof this._provider.resolveCompletionItem!="function")return;const re=this._cache.get(...Q);if(!re)return;const he=await this._provider.resolveCompletionItem(re,ee);if(!!he)return this._convertCompletionItem(he,Q)}releaseCompletionItems(Q){this._disposables.get(Q)?.dispose(),this._disposables.delete(Q),this._cache.delete(Q)}_convertCompletionItem(Q,ee,re,he){const Z=this._disposables.get(ee[0]);if(!Z)throw Error("DisposableStore is missing...");const oe={x:ee,a:Q.label,b:Q.kind!==void 0?y.CompletionItemKind.from(Q.kind):void 0,n:Q.tags&&Q.tags.map(y.CompletionItemTag.from),c:Q.detail,d:typeof Q.documentation=="undefined"?void 0:y.MarkdownString.fromStrict(Q.documentation),e:Q.sortText!==Q.label?Q.sortText:void 0,f:Q.filterText!==Q.label?Q.filterText:void 0,g:Q.preselect||void 0,i:Q.keepWhitespace?1:0,k:Q.commitCharacters,l:Q.additionalTextEdits&&Q.additionalTextEdits.map(y.TextEdit.from),m:this._commands.toInternal(Q.command,Z)};Q.textEdit?(this._apiDeprecation.report("CompletionItem.textEdit",this._extension,"Use 'CompletionItem.insertText' and 'CompletionItem.range' instead."),oe.h=Q.textEdit.newText):typeof Q.insertText=="string"?oe.h=Q.insertText:Q.insertText instanceof C.SnippetString&&(oe.h=Q.insertText.value,oe.i|=4);let be;return Q.textEdit?be=Q.textEdit.range:Q.range&&(be=Q.range),C.Range.isRange(be)?oe.j=y.Range.from(be):be&&(!re?.isEqual(be.inserting)||!he?.isEqual(be.replacing))&&(oe.j={insert:y.Range.from(be.inserting),replace:y.Range.from(be.replacing)}),oe}}class K{constructor(Q,ee,re){this._documents=Q,this._provider=ee,this._commands=re,this._cache=new v.Cache("InlineCompletionItem"),this._disposables=new Map}async provideInlineCompletions(Q,ee,re,he){const Z=this._documents.getDocument(Q),oe=y.Position.to(ee),be=await this._provider.provideInlineCompletionItems(Z,oe,{selectedCompletionInfo:re.selectedSuggestionInfo?{range:y.Range.to(re.selectedSuggestionInfo.range),text:re.selectedSuggestionInfo.text,isSnippetText:re.selectedSuggestionInfo.isSnippetText,completionKind:y.CompletionItemKind.to(re.selectedSuggestionInfo.completionKind)}:void 0,triggerKind:re.triggerKind},he);if(!be||he.isCancellationRequested)return;const Me=(0,R.isArray)(be)?{items:be}:be,Ve=this._cache.add(Me.items);let Ge;return{pid:Ve,items:Me.items.map((Je,tt)=>{let ot;return Je.command&&(Ge||(Ge=new u.DisposableStore,this._disposables.set(Ve,Ge)),ot=this._commands.toInternal(Je.command,Ge)),{text:Je.text,range:Je.range?y.Range.from(Je.range):void 0,command:ot,idx:tt}})}}disposeCompletions(Q){this._cache.delete(Q);const ee=this._disposables.get(Q);ee&&ee.clear(),this._disposables.delete(Q)}handleDidShowCompletionItem(Q,ee){const re=this._cache.get(Q,ee);re&&N.get(this._provider).fireOnDidShowCompletionItem({completionItem:re})}}class N{constructor(){this._onDidShowCompletionItemEmitter=new p.Emitter,this.onDidShowCompletionItem=this._onDidShowCompletionItemEmitter.event}static get(Q){let ee=N.map.get(Q);return ee||(ee=new N,N.map.set(Q,ee)),ee}fireOnDidShowCompletionItem(Q){this._onDidShowCompletionItemEmitter.fire(Q)}}e.InlineCompletionController=N,N.map=new WeakMap;class j{constructor(Q,ee){this._documents=Q,this._provider=ee,this._cache=new v.Cache("SignatureHelp")}async provideSignatureHelp(Q,ee,re,he){const Z=this._documents.getDocument(Q),oe=y.Position.to(ee),be=this.reviveContext(re),Me=await this._provider.provideSignatureHelp(Z,oe,he,be);if(Me){const Ve=this._cache.add([Me]);return{...y.SignatureHelp.from(Me),id:Ve}}}reviveContext(Q){let ee;if(Q.activeSignatureHelp){const re=y.SignatureHelp.to(Q.activeSignatureHelp),he=this._cache.get(Q.activeSignatureHelp.id,0);he?(ee=he,ee.activeSignature=re.activeSignature,ee.activeParameter=re.activeParameter):ee=re}return{...Q,activeSignatureHelp:ee}}releaseSignatureHelp(Q){this._cache.delete(Q)}}class H{constructor(Q,ee){this._documents=Q,this._provider=ee}async provideInlayHints(Q,ee,re){const he=this._documents.getDocument(Q),Z=await this._provider.provideInlayHints(he,y.Range.to(ee),re);return Z?{hints:Z.map(y.InlayHint.from)}:void 0}}class V{constructor(Q,ee){this._documents=Q,this._provider=ee,this._cache=new v.Cache("DocumentLink")}async provideLinks(Q,ee){const re=this._documents.getDocument(Q),he=await this._provider.provideDocumentLinks(re,ee);if(!(!Array.isArray(he)||he.length===0)&&!ee.isCancellationRequested){if(typeof this._provider.resolveDocumentLink!="function")return{links:he.filter(V._validateLink).map(y.DocumentLink.from)};{const Z=this._cache.add(he),oe={links:[],id:Z};for(let be=0;be<he.length;be++){if(!V._validateLink(he[be]))continue;const Me=y.DocumentLink.from(he[be]);Me.cacheId=[Z,be],oe.links.push(Me)}return oe}}}static _validateLink(Q){return Q.target&&Q.target.path.length>5e4?(console.warn("DROPPING link because it is too long"),!1):!0}async resolveLink(Q,ee){if(typeof this._provider.resolveDocumentLink!="function")return;const re=this._cache.get(...Q);if(!re)return;const he=await this._provider.resolveDocumentLink(re,ee);if(!(!he||!V._validateLink(he)))return y.DocumentLink.from(he)}releaseLinks(Q){this._cache.delete(Q)}}class q{constructor(Q,ee){this._documents=Q,this._provider=ee}async provideColors(Q,ee){const re=this._documents.getDocument(Q),he=await this._provider.provideDocumentColors(re,ee);return Array.isArray(he)?he.map(oe=>({color:y.Color.from(oe.color),range:y.Range.from(oe.range)})):[]}async provideColorPresentations(Q,ee,re){const he=this._documents.getDocument(Q),Z=y.Range.to(ee.range),oe=y.Color.to(ee.color),be=await this._provider.provideColorPresentations(oe,{document:he,range:Z},re);if(!!Array.isArray(be))return be.map(y.ColorPresentation.from)}}class ne{constructor(Q,ee){this._documents=Q,this._provider=ee}async provideFoldingRanges(Q,ee,re){const he=this._documents.getDocument(Q),Z=await this._provider.provideFoldingRanges(he,ee,re);if(!!Array.isArray(Z))return Z.map(y.FoldingRange.from)}}class fe{constructor(Q,ee,re){this._documents=Q,this._provider=ee,this._logService=re}async provideSelectionRanges(Q,ee,re){const he=this._documents.getDocument(Q),Z=ee.map(y.Position.to),oe=await this._provider.provideSelectionRanges(he,Z,re);if(!(0,D.isNonEmptyArray)(oe))return[];if(oe.length!==Z.length)return this._logService.warn("BAD selection ranges, provider must return ranges for each position"),[];const be=[];for(let Me=0;Me<Z.length;Me++){const Ve=[];be.push(Ve);let Ge=Z[Me],Je=oe[Me];for(;;){if(!Je.range.contains(Ge))throw new Error("INVALID selection range, must contain the previous range");if(Ve.push(y.SelectionRange.from(Je)),!Je.parent)break;Ge=Je.range,Je=Je.parent}}return be}}class ye{constructor(Q,ee){this._documents=Q,this._provider=ee,this._idPool=new f.IdGenerator(""),this._cache=new Map}async prepareSession(Q,ee,re){const he=this._documents.getDocument(Q),Z=y.Position.to(ee),oe=await this._provider.prepareCallHierarchy(he,Z,re);if(!oe)return;const be=this._idPool.nextId();return this._cache.set(be,new Map),Array.isArray(oe)?oe.map(Me=>this._cacheAndConvertItem(be,Me)):[this._cacheAndConvertItem(be,oe)]}async provideCallsTo(Q,ee,re){const he=this._itemFromCache(Q,ee);if(!he)throw new Error("missing call hierarchy item");const Z=await this._provider.provideCallHierarchyIncomingCalls(he,re);if(!!Z)return Z.map(oe=>({from:this._cacheAndConvertItem(Q,oe.from),fromRanges:oe.fromRanges.map(be=>y.Range.from(be))}))}async provideCallsFrom(Q,ee,re){const he=this._itemFromCache(Q,ee);if(!he)throw new Error("missing call hierarchy item");const Z=await this._provider.provideCallHierarchyOutgoingCalls(he,re);if(!!Z)return Z.map(oe=>({to:this._cacheAndConvertItem(Q,oe.to),fromRanges:oe.fromRanges.map(be=>y.Range.from(be))}))}releaseSession(Q){this._cache.delete(Q)}_cacheAndConvertItem(Q,ee){const re=this._cache.get(Q),he=y.CallHierarchyItem.from(ee,Q,re.size.toString(36));return re.set(he._itemId,ee),he}_itemFromCache(Q,ee){return this._cache.get(Q)?.get(ee)}}class ke{constructor(Q,ee){this._documents=Q,this._provider=ee,this._idPool=new f.IdGenerator(""),this._cache=new Map}async prepareSession(Q,ee,re){const he=this._documents.getDocument(Q),Z=y.Position.to(ee),oe=await this._provider.prepareTypeHierarchy(he,Z,re);if(!oe)return;const be=this._idPool.nextId();return this._cache.set(be,new Map),Array.isArray(oe)?oe.map(Me=>this._cacheAndConvertItem(be,Me)):[this._cacheAndConvertItem(be,oe)]}async provideSupertypes(Q,ee,re){const he=this._itemFromCache(Q,ee);if(!he)throw new Error("missing type hierarchy item");const Z=await this._provider.provideTypeHierarchySupertypes(he,re);if(!!Z)return Z.map(oe=>this._cacheAndConvertItem(Q,oe))}async provideSubtypes(Q,ee,re){const he=this._itemFromCache(Q,ee);if(!he)throw new Error("missing type hierarchy item");const Z=await this._provider.provideTypeHierarchySubtypes(he,re);if(!!Z)return Z.map(oe=>this._cacheAndConvertItem(Q,oe))}releaseSession(Q){this._cache.delete(Q)}_cacheAndConvertItem(Q,ee){const re=this._cache.get(Q),he=y.TypeHierarchyItem.from(ee,Q,re.size.toString(36));return re.set(he._itemId,ee),he}_itemFromCache(Q,ee){return this._cache.get(Q)?.get(ee)}}class Be{constructor(Q,ee){this.adapter=Q,this.extension=ee}}class We{constructor(Q,ee,re,he,Z,oe,be){this._adapter=new Map,this._uriTransformer=ee,this._proxy=Q.getProxy(i.MainContext.MainThreadLanguageFeatures),this._documents=re,this._commands=he,this._diagnostics=Z,this._logService=oe,this._apiDeprecation=be}_transformDocumentSelector(Q){return y.DocumentSelector.from(Q,this._uriTransformer)}_createDisposable(Q){return new C.Disposable(()=>{this._adapter.delete(Q),this._proxy.$unregister(Q)})}_nextHandle(){return We._handlePool++}_withAdapter(Q,ee,re,he,Z=!1){const oe=this._adapter.get(Q);if(!oe)return Promise.resolve(he);if(oe.adapter instanceof ee){let be;oe.extension&&(be=Date.now(),this._logService.trace(`[${oe.extension.identifier.value}] INVOKE provider '${ee.name}'`));const Me=re(oe.adapter,oe.extension),Ve=oe.extension;return Ve&&Promise.resolve(Me).then(()=>this._logService.trace(`[${Ve.identifier.value}] provider DONE after ${Date.now()-be}ms`),Ge=>{Z&&Ge instanceof I.CancellationError||(this._logService.error(`[${Ve.identifier.value}] provider FAILED`),this._logService.error(Ge))}),Me}return Promise.reject(new Error("no adapter found"))}_addNewAdapter(Q,ee){const re=this._nextHandle();return this._adapter.set(re,new Be(Q,ee)),re}static _extLabel(Q){return Q.displayName||Q.name}registerDocumentSymbolProvider(Q,ee,re,he){const Z=this._addNewAdapter(new s(this._documents,re),Q),oe=he&&he.label||We._extLabel(Q);return this._proxy.$registerDocumentSymbolProvider(Z,this._transformDocumentSelector(ee),oe),this._createDisposable(Z)}$provideDocumentSymbols(Q,ee,re){return this._withAdapter(Q,s,he=>he.provideDocumentSymbols(m.URI.revive(ee),re),void 0)}registerCodeLensProvider(Q,ee,re){const he=this._nextHandle(),Z=typeof re.onDidChangeCodeLenses=="function"?this._nextHandle():void 0;this._adapter.set(he,new Be(new r(this._documents,this._commands.converter,re),Q)),this._proxy.$registerCodeLensSupport(he,this._transformDocumentSelector(ee),Z);let oe=this._createDisposable(he);if(Z!==void 0){const be=re.onDidChangeCodeLenses(Me=>this._proxy.$emitCodeLensEvent(Z));oe=C.Disposable.from(oe,be)}return oe}$provideCodeLenses(Q,ee,re){return this._withAdapter(Q,r,he=>he.provideCodeLenses(m.URI.revive(ee),re),void 0)}$resolveCodeLens(Q,ee,re){return this._withAdapter(Q,r,he=>he.resolveCodeLens(ee,re),void 0)}$releaseCodeLenses(Q,ee){this._withAdapter(Q,r,re=>Promise.resolve(re.releaseCodeLenses(ee)),void 0)}registerDefinitionProvider(Q,ee,re){const he=this._addNewAdapter(new a(this._documents,re),Q);return this._proxy.$registerDefinitionSupport(he,this._transformDocumentSelector(ee)),this._createDisposable(he)}$provideDefinition(Q,ee,re,he){return this._withAdapter(Q,a,Z=>Z.provideDefinition(m.URI.revive(ee),re,he),[])}registerDeclarationProvider(Q,ee,re){const he=this._addNewAdapter(new _(this._documents,re),Q);return this._proxy.$registerDeclarationSupport(he,this._transformDocumentSelector(ee)),this._createDisposable(he)}$provideDeclaration(Q,ee,re,he){return this._withAdapter(Q,_,Z=>Z.provideDeclaration(m.URI.revive(ee),re,he),[])}registerImplementationProvider(Q,ee,re){const he=this._addNewAdapter(new n(this._documents,re),Q);return this._proxy.$registerImplementationSupport(he,this._transformDocumentSelector(ee)),this._createDisposable(he)}$provideImplementation(Q,ee,re,he){return this._withAdapter(Q,n,Z=>Z.provideImplementation(m.URI.revive(ee),re,he),[])}registerTypeDefinitionProvider(Q,ee,re){const he=this._addNewAdapter(new t(this._documents,re),Q);return this._proxy.$registerTypeDefinitionSupport(he,this._transformDocumentSelector(ee)),this._createDisposable(he)}$provideTypeDefinition(Q,ee,re,he){return this._withAdapter(Q,t,Z=>Z.provideTypeDefinition(m.URI.revive(ee),re,he),[])}registerHoverProvider(Q,ee,re,he){const Z=this._addNewAdapter(new o(this._documents,re),Q);return this._proxy.$registerHoverProvider(Z,this._transformDocumentSelector(ee)),this._createDisposable(Z)}$provideHover(Q,ee,re,he){return this._withAdapter(Q,o,Z=>Z.provideHover(m.URI.revive(ee),re,he),void 0)}registerEvaluatableExpressionProvider(Q,ee,re,he){const Z=this._addNewAdapter(new d(this._documents,re),Q);return this._proxy.$registerEvaluatableExpressionProvider(Z,this._transformDocumentSelector(ee)),this._createDisposable(Z)}$provideEvaluatableExpression(Q,ee,re,he){return this._withAdapter(Q,d,Z=>Z.provideEvaluatableExpression(m.URI.revive(ee),re,he),void 0)}registerInlineValuesProvider(Q,ee,re,he){const Z=typeof re.onDidChangeInlineValues=="function"?this._nextHandle():void 0,oe=this._addNewAdapter(new c(this._documents,re),Q);this._proxy.$registerInlineValuesProvider(oe,this._transformDocumentSelector(ee),Z);let be=this._createDisposable(oe);if(Z!==void 0){const Me=re.onDidChangeInlineValues(Ve=>this._proxy.$emitInlineValuesEvent(Z));be=C.Disposable.from(be,Me)}return be}$provideInlineValues(Q,ee,re,he,Z){return this._withAdapter(Q,c,oe=>oe.provideInlineValues(m.URI.revive(ee),re,he,Z),void 0)}registerDocumentHighlightProvider(Q,ee,re){const he=this._addNewAdapter(new h(this._documents,re),Q);return this._proxy.$registerDocumentHighlightProvider(he,this._transformDocumentSelector(ee)),this._createDisposable(he)}$provideDocumentHighlights(Q,ee,re,he){return this._withAdapter(Q,h,Z=>Z.provideDocumentHighlights(m.URI.revive(ee),re,he),void 0)}registerLinkedEditingRangeProvider(Q,ee,re){const he=this._addNewAdapter(new l(this._documents,re),Q);return this._proxy.$registerLinkedEditingRangeProvider(he,this._transformDocumentSelector(ee)),this._createDisposable(he)}$provideLinkedEditingRanges(Q,ee,re,he){return this._withAdapter(Q,l,async Z=>{const oe=await Z.provideLinkedEditingRanges(m.URI.revive(ee),re,he);if(oe)return{ranges:oe.ranges,wordPattern:oe.wordPattern?We._serializeRegExp(oe.wordPattern):void 0}},void 0)}registerReferenceProvider(Q,ee,re){const he=this._addNewAdapter(new b(this._documents,re),Q);return this._proxy.$registerReferenceSupport(he,this._transformDocumentSelector(ee)),this._createDisposable(he)}$provideReferences(Q,ee,re,he,Z){return this._withAdapter(Q,b,oe=>oe.provideReferences(m.URI.revive(ee),re,he,Z),void 0)}registerCodeActionProvider(Q,ee,re,he){const Z=new u.DisposableStore,oe=this._addNewAdapter(new T(this._documents,this._commands.converter,this._diagnostics,re,this._logService,Q,this._apiDeprecation),Q);return this._proxy.$registerQuickFixSupport(oe,this._transformDocumentSelector(ee),{providedKinds:he?.providedCodeActionKinds?.map(be=>be.value),documentation:he?.documentation?.map(be=>({kind:be.kind.value,command:this._commands.converter.toInternal(be.command,Z)}))},We._extLabel(Q),Boolean(re.resolveCodeAction)),Z.add(this._createDisposable(oe)),Z}$provideCodeActions(Q,ee,re,he,Z){return this._withAdapter(Q,T,oe=>oe.provideCodeActions(m.URI.revive(ee),re,he,Z),void 0)}$resolveCodeAction(Q,ee,re){return this._withAdapter(Q,T,he=>he.resolveCodeAction(ee,re),void 0)}$releaseCodeActions(Q,ee){this._withAdapter(Q,T,re=>Promise.resolve(re.releaseCodeActions(ee)),void 0)}registerDocumentFormattingEditProvider(Q,ee,re){const he=this._addNewAdapter(new A(this._documents,re),Q);return this._proxy.$registerDocumentFormattingSupport(he,this._transformDocumentSelector(ee),Q.identifier,Q.displayName||Q.name),this._createDisposable(he)}$provideDocumentFormattingEdits(Q,ee,re,he){return this._withAdapter(Q,A,Z=>Z.provideDocumentFormattingEdits(m.URI.revive(ee),re,he),void 0)}registerDocumentRangeFormattingEditProvider(Q,ee,re){const he=this._addNewAdapter(new x(this._documents,re),Q);return this._proxy.$registerRangeFormattingSupport(he,this._transformDocumentSelector(ee),Q.identifier,Q.displayName||Q.name),this._createDisposable(he)}$provideDocumentRangeFormattingEdits(Q,ee,re,he,Z){return this._withAdapter(Q,x,oe=>oe.provideDocumentRangeFormattingEdits(m.URI.revive(ee),re,he,Z),void 0)}registerOnTypeFormattingEditProvider(Q,ee,re,he){const Z=this._addNewAdapter(new O(this._documents,re),Q);return this._proxy.$registerOnTypeFormattingSupport(Z,this._transformDocumentSelector(ee),he,Q.identifier),this._createDisposable(Z)}$provideOnTypeFormattingEdits(Q,ee,re,he,Z,oe){return this._withAdapter(Q,O,be=>be.provideOnTypeFormattingEdits(m.URI.revive(ee),re,he,Z,oe),void 0)}registerWorkspaceSymbolProvider(Q,ee){const re=this._addNewAdapter(new F(ee,this._logService),Q);return this._proxy.$registerNavigateTypeSupport(re,typeof ee.resolveWorkspaceSymbol=="function"),this._createDisposable(re)}$provideWorkspaceSymbols(Q,ee,re){return this._withAdapter(Q,F,he=>he.provideWorkspaceSymbols(ee,re),{symbols:[]})}$resolveWorkspaceSymbol(Q,ee,re){return this._withAdapter(Q,F,he=>he.resolveWorkspaceSymbol(ee,re),void 0)}$releaseWorkspaceSymbols(Q,ee){this._withAdapter(Q,F,re=>re.releaseWorkspaceSymbols(ee),void 0)}registerRenameProvider(Q,ee,re){const he=this._addNewAdapter(new W(this._documents,re,this._logService),Q);return this._proxy.$registerRenameSupport(he,this._transformDocumentSelector(ee),W.supportsResolving(re)),this._createDisposable(he)}$provideRenameEdits(Q,ee,re,he,Z){return this._withAdapter(Q,W,oe=>oe.provideRenameEdits(m.URI.revive(ee),re,he,Z),void 0)}$resolveRenameLocation(Q,ee,re,he){return this._withAdapter(Q,W,Z=>Z.resolveRenameLocation(m.URI.revive(ee),re,he),void 0)}registerDocumentSemanticTokensProvider(Q,ee,re,he){const Z=this._nextHandle(),oe=typeof re.onDidChangeSemanticTokens=="function"?this._nextHandle():void 0;this._adapter.set(Z,new Be(new B(this._documents,re),Q)),this._proxy.$registerDocumentSemanticTokensProvider(Z,this._transformDocumentSelector(ee),he,oe);let be=this._createDisposable(Z);if(oe){const Me=re.onDidChangeSemanticTokens(Ve=>this._proxy.$emitDocumentSemanticTokensEvent(oe));be=C.Disposable.from(be,Me)}return be}$provideDocumentSemanticTokens(Q,ee,re,he){return this._withAdapter(Q,B,Z=>Z.provideDocumentSemanticTokens(m.URI.revive(ee),re,he),null,!0)}$releaseDocumentSemanticTokens(Q,ee){this._withAdapter(Q,B,re=>re.releaseDocumentSemanticColoring(ee),void 0)}registerDocumentRangeSemanticTokensProvider(Q,ee,re,he){const Z=this._addNewAdapter(new U(this._documents,re),Q);return this._proxy.$registerDocumentRangeSemanticTokensProvider(Z,this._transformDocumentSelector(ee),he),this._createDisposable(Z)}$provideDocumentRangeSemanticTokens(Q,ee,re,he){return this._withAdapter(Q,U,Z=>Z.provideDocumentRangeSemanticTokens(m.URI.revive(ee),re,he),null,!0)}registerCompletionItemProvider(Q,ee,re,he){const Z=this._addNewAdapter(new z(this._documents,this._commands.converter,re,this._apiDeprecation,Q),Q);return this._proxy.$registerSuggestSupport(Z,this._transformDocumentSelector(ee),he,z.supportsResolving(re),`${Q.identifier.value}(${he.join("")})`),this._createDisposable(Z)}$provideCompletionItems(Q,ee,re,he,Z){return this._withAdapter(Q,z,oe=>oe.provideCompletionItems(m.URI.revive(ee),re,he,Z),void 0)}$resolveCompletionItem(Q,ee,re){return this._withAdapter(Q,z,he=>he.resolveCompletionItem(ee,re),void 0)}$releaseCompletionItems(Q,ee){this._withAdapter(Q,z,re=>re.releaseCompletionItems(ee),void 0)}registerInlineCompletionsProvider(Q,ee,re){const he=this._addNewAdapter(new K(this._documents,re,this._commands.converter),Q);return this._proxy.$registerInlineCompletionsSupport(he,this._transformDocumentSelector(ee)),this._createDisposable(he)}$provideInlineCompletions(Q,ee,re,he,Z){return this._withAdapter(Q,K,oe=>oe.provideInlineCompletions(m.URI.revive(ee),re,he,Z),void 0)}$handleInlineCompletionDidShow(Q,ee,re){this._withAdapter(Q,K,async he=>{he.handleDidShowCompletionItem(ee,re)},void 0)}$freeInlineCompletionsList(Q,ee){this._withAdapter(Q,K,async re=>{re.disposeCompletions(ee)},void 0)}registerSignatureHelpProvider(Q,ee,re,he){const Z=Array.isArray(he)?{triggerCharacters:he,retriggerCharacters:[]}:he,oe=this._addNewAdapter(new j(this._documents,re),Q);return this._proxy.$registerSignatureHelpProvider(oe,this._transformDocumentSelector(ee),Z),this._createDisposable(oe)}$provideSignatureHelp(Q,ee,re,he,Z){return this._withAdapter(Q,j,oe=>oe.provideSignatureHelp(m.URI.revive(ee),re,he,Z),void 0)}$releaseSignatureHelp(Q,ee){this._withAdapter(Q,j,re=>re.releaseSignatureHelp(ee),void 0)}registerInlayHintsProvider(Q,ee,re){const he=typeof re.onDidChangeInlayHints=="function"?this._nextHandle():void 0,Z=this._addNewAdapter(new H(this._documents,re),Q);this._proxy.$registerInlayHintsProvider(Z,this._transformDocumentSelector(ee),he);let oe=this._createDisposable(Z);if(he!==void 0){const be=re.onDidChangeInlayHints(Me=>this._proxy.$emitInlayHintsEvent(he));oe=C.Disposable.from(oe,be)}return oe}$provideInlayHints(Q,ee,re,he){return this._withAdapter(Q,H,Z=>Z.provideInlayHints(m.URI.revive(ee),re,he),void 0)}registerDocumentLinkProvider(Q,ee,re){const he=this._addNewAdapter(new V(this._documents,re),Q);return this._proxy.$registerDocumentLinkProvider(he,this._transformDocumentSelector(ee),typeof re.resolveDocumentLink=="function"),this._createDisposable(he)}$provideDocumentLinks(Q,ee,re){return this._withAdapter(Q,V,he=>he.provideLinks(m.URI.revive(ee),re),void 0)}$resolveDocumentLink(Q,ee,re){return this._withAdapter(Q,V,he=>he.resolveLink(ee,re),void 0)}$releaseDocumentLinks(Q,ee){this._withAdapter(Q,V,re=>re.releaseLinks(ee),void 0)}registerColorProvider(Q,ee,re){const he=this._addNewAdapter(new q(this._documents,re),Q);return this._proxy.$registerDocumentColorProvider(he,this._transformDocumentSelector(ee)),this._createDisposable(he)}$provideDocumentColors(Q,ee,re){return this._withAdapter(Q,q,he=>he.provideColors(m.URI.revive(ee),re),[])}$provideColorPresentations(Q,ee,re,he){return this._withAdapter(Q,q,Z=>Z.provideColorPresentations(m.URI.revive(ee),re,he),void 0)}registerFoldingRangeProvider(Q,ee,re){const he=this._nextHandle(),Z=typeof re.onDidChangeFoldingRanges=="function"?this._nextHandle():void 0;this._adapter.set(he,new Be(new ne(this._documents,re),Q)),this._proxy.$registerFoldingRangeProvider(he,this._transformDocumentSelector(ee),Z);let oe=this._createDisposable(he);if(Z!==void 0){const be=re.onDidChangeFoldingRanges(()=>this._proxy.$emitFoldingRangeEvent(Z));oe=C.Disposable.from(oe,be)}return oe}$provideFoldingRanges(Q,ee,re,he){return this._withAdapter(Q,ne,Z=>Z.provideFoldingRanges(m.URI.revive(ee),re,he),void 0)}registerSelectionRangeProvider(Q,ee,re){const he=this._addNewAdapter(new fe(this._documents,re,this._logService),Q);return this._proxy.$registerSelectionRangeProvider(he,this._transformDocumentSelector(ee)),this._createDisposable(he)}$provideSelectionRanges(Q,ee,re,he){return this._withAdapter(Q,fe,Z=>Z.provideSelectionRanges(m.URI.revive(ee),re,he),[])}registerCallHierarchyProvider(Q,ee,re){const he=this._addNewAdapter(new ye(this._documents,re),Q);return this._proxy.$registerCallHierarchyProvider(he,this._transformDocumentSelector(ee)),this._createDisposable(he)}$prepareCallHierarchy(Q,ee,re,he){return this._withAdapter(Q,ye,Z=>Promise.resolve(Z.prepareSession(m.URI.revive(ee),re,he)),void 0)}$provideCallHierarchyIncomingCalls(Q,ee,re,he){return this._withAdapter(Q,ye,Z=>Z.provideCallsTo(ee,re,he),void 0)}$provideCallHierarchyOutgoingCalls(Q,ee,re,he){return this._withAdapter(Q,ye,Z=>Z.provideCallsFrom(ee,re,he),void 0)}$releaseCallHierarchy(Q,ee){this._withAdapter(Q,ye,re=>Promise.resolve(re.releaseSession(ee)),void 0)}registerTypeHierarchyProvider(Q,ee,re){const he=this._addNewAdapter(new ke(this._documents,re),Q);return this._proxy.$registerTypeHierarchyProvider(he,this._transformDocumentSelector(ee)),this._createDisposable(he)}$prepareTypeHierarchy(Q,ee,re,he){return this._withAdapter(Q,ke,Z=>Promise.resolve(Z.prepareSession(m.URI.revive(ee),re,he)),void 0)}$provideTypeHierarchySupertypes(Q,ee,re,he){return this._withAdapter(Q,ke,Z=>Z.provideSupertypes(ee,re,he),void 0)}$provideTypeHierarchySubtypes(Q,ee,re,he){return this._withAdapter(Q,ke,Z=>Z.provideSubtypes(ee,re,he),void 0)}$releaseTypeHierarchy(Q,ee){this._withAdapter(Q,ke,re=>Promise.resolve(re.releaseSession(ee)),void 0)}static _serializeRegExp(Q){return{pattern:Q.source,flags:(0,k.regExpFlags)(Q)}}static _serializeIndentationRule(Q){return{decreaseIndentPattern:We._serializeRegExp(Q.decreaseIndentPattern),increaseIndentPattern:We._serializeRegExp(Q.increaseIndentPattern),indentNextLinePattern:Q.indentNextLinePattern?We._serializeRegExp(Q.indentNextLinePattern):void 0,unIndentedLinePattern:Q.unIndentedLinePattern?We._serializeRegExp(Q.unIndentedLinePattern):void 0}}static _serializeOnEnterRule(Q){return{beforeText:We._serializeRegExp(Q.beforeText),afterText:Q.afterText?We._serializeRegExp(Q.afterText):void 0,previousLineText:Q.previousLineText?We._serializeRegExp(Q.previousLineText):void 0,action:Q.action}}static _serializeOnEnterRules(Q){return Q.map(We._serializeOnEnterRule)}setLanguageConfiguration(Q,ee,re){let{wordPattern:he}=re;if(he&&(0,k.regExpLeadsToEndlessLoop)(he))throw new Error(`Invalid language configuration: wordPattern '${he}' is not allowed to match the empty string.`);he?this._documents.setWordDefinitionFor(ee,he):this._documents.setWordDefinitionFor(ee,void 0),re.__electricCharacterSupport&&this._apiDeprecation.report("LanguageConfiguration.__electricCharacterSupport",Q,"Do not use."),re.__characterPairSupport&&this._apiDeprecation.report("LanguageConfiguration.__characterPairSupport",Q,"Do not use.");const Z=this._nextHandle(),oe={comments:re.comments,brackets:re.brackets,wordPattern:re.wordPattern?We._serializeRegExp(re.wordPattern):void 0,indentationRules:re.indentationRules?We._serializeIndentationRule(re.indentationRules):void 0,onEnterRules:re.onEnterRules?We._serializeOnEnterRules(re.onEnterRules):void 0,__electricCharacterSupport:re.__electricCharacterSupport,__characterPairSupport:re.__characterPairSupport};return this._proxy.$setLanguageConfiguration(Z,ee,oe),this._createDisposable(Z)}$setWordDefinitions(Q){for(const ee of Q)this._documents.setWordDefinitionFor(ee.languageId,new RegExp(ee.regexSource,ee.regexFlags))}}e.ExtHostLanguageFeatures=We,We._handlePool=0}),define(pe[241],ve([0,1,5,17,7,48,18,6]),function(Y,e,m,L,y,C,i,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLanguages=void 0;class S{constructor(R,P,u,E){this._documents=P,this._commands=u,this._uriTransformer=E,this._languageIds=[],this._handlePool=0,this._ids=new Set,this._proxy=R.getProxy(m.MainContext.MainThreadLanguages)}$acceptLanguageIds(R){this._languageIds=R}async getLanguages(){return this._languageIds.slice(0)}async changeLanguage(R,P){await this._proxy.$changeLanguage(R,P);const u=this._documents.getDocumentData(R);if(!u)throw new Error(`document '${R.toString}' NOT found`);return u.document}async tokenAtPosition(R,P){const u=R.version,E=L.Position.from(P),f=await this._proxy.$tokensAtPosition(R.uri,E),v={type:y.StandardTokenType.Other,range:R.getWordRangeAtPosition(P)??new y.Range(P.line,P.character,P.line,P.character)};if(!f)return v;const w={range:L.Range.to(f.range),type:L.TokenType.to(f.type)};return!w.range.contains(P)||u!==R.version?v:w}createLanguageStatusItem(R,P,u){const E=this._handlePool++,f=this._proxy,v=this._ids,w=`${R.identifier.value}/${P}`;if(v.has(w))throw new Error(`LanguageStatusItem with id '${P}' ALREADY exists`);v.add(w);const I={selector:u,id:P,name:R.displayName??R.name,severity:y.LanguageStatusSeverity.Information,command:void 0,text:"",detail:"",busy:!1};let p,s=new k.DisposableStore;const r=()=>{p?.dispose(),p=(0,i.disposableTimeout)(()=>{s.clear(),this._proxy.$setLanguageStatus(E,{id:w,name:I.name??R.displayName??R.name,source:R.displayName??R.name,selector:L.DocumentSelector.from(I.selector,this._uriTransformer),label:I.text,detail:I.detail??"",severity:I.severity===y.LanguageStatusSeverity.Error?C.default.Error:I.severity===y.LanguageStatusSeverity.Warning?C.default.Warning:C.default.Info,command:I.command&&this._commands.toInternal(I.command,s),accessibilityInfo:I.accessibilityInformation,busy:I.busy})},0)},g={dispose(){s.dispose(),p?.dispose(),f.$removeLanguageStatus(E),v.delete(w)},get id(){return I.id},get name(){return I.name},set name(a){I.name=a,r()},get selector(){return I.selector},set selector(a){I.selector=a,r()},get text(){return I.text},set text(a){I.text=a,r()},get detail(){return I.detail},set detail(a){I.detail=a,r()},get severity(){return I.severity},set severity(a){I.severity=a,r()},get accessibilityInformation(){return I.accessibilityInformation},set accessibilityInformation(a){I.accessibilityInformation=a,r()},get command(){return I.command},set command(a){I.command=a,r()},get busy(){return I.busy},set busy(a){I.busy=a,r()}};return r(),g}}e.ExtHostLanguages=S}),define(pe[131],ve([0,1,11,5,26,14,3]),function(Y,e,m,L,y,C,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLoggerService=void 0;let k=class extends m.AbstractLoggerService{constructor(R,P){const u=new i.Emitter;super(P.logLevel,u.event);this._proxy=R.getProxy(L.MainContext.MainThreadLogger),this._onDidChangeLogLevel=this._register(u)}$setLevel(R){this._onDidChangeLogLevel.fire(R)}doCreateLogger(R,P,u){return new S(this._proxy,R,P,u)}};k=je([He(0,C.IExtHostRpcService),He(1,y.IExtHostInitDataService)],k),e.ExtHostLoggerService=k;class S extends m.AbstractMessageLogger{constructor(R,P,u,E){super(E?.always);this.proxy=R,this.file=P,this.isLoggerCreated=!1,this.buffer=[],this.setLevel(u),this.proxy.$createLogger(P,E).then(()=>{this.doLog(this.buffer),this.isLoggerCreated=!0})}log(R,P){const u=[[R,P]];this.isLoggerCreated?this.doLog(u):this.buffer.push(...u)}doLog(R){this.proxy.$log(this.file,R)}}}),define(pe[242],ve([0,1,5,11,29]),function(Y,e,m,L,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostMessageService=void 0;function C(k){return k&&k.title}let i=class{constructor(S,D){this._logService=D,this._proxy=S.getProxy(m.MainContext.MainThreadMessageService)}showMessage(S,D,R,P,u){const E={extension:S};let f;typeof P=="string"||C(P)?f=[P,...u]:(E.modal=P?.modal,E.useCustom=P?.useCustom,E.detail=P?.detail,f=u),E.useCustom&&(0,y.checkProposedApiEnabled)(S,"resolvers");const v=[];for(let w=0;w<f.length;w++){const I=f[w];if(typeof I=="string")v.push({title:I,handle:w,isCloseAffordance:!1});else if(typeof I=="object"){let{title:p,isCloseAffordance:s}=I;v.push({title:p,isCloseAffordance:!!s,handle:w})}else this._logService.warn("Invalid message item:",I)}return this._proxy.$showMessage(D,R,E,v).then(w=>{if(typeof w=="number")return f[w]})}};i=je([He(1,L.ILogService)],i),e.ExtHostMessageService=i}),define(pe[243],ve([0,1,22,3,47,6,24,8,13,2,87,5,17,7,53,218,128]),function(Y,e,m,L,y,C,i,k,S,D,R,P,u,E,f,v,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookController=void 0;class I{constructor(s,r,g,a,_){this._textDocumentsAndEditors=g,this._textDocuments=a,this._extensionStoragePaths=_,this._notebookContentProviders=new Map,this._notebookStatusBarItemProviders=new Map,this._documents=new i.ResourceMap,this._editors=new Map,this._onDidChangeNotebookCells=new L.Emitter,this.onDidChangeNotebookCells=this._onDidChangeNotebookCells.event,this._onDidChangeCellOutputs=new L.Emitter,this.onDidChangeCellOutputs=this._onDidChangeCellOutputs.event,this._onDidChangeCellMetadata=new L.Emitter,this.onDidChangeCellMetadata=this._onDidChangeCellMetadata.event,this._onDidChangeActiveNotebookEditor=new L.Emitter,this.onDidChangeActiveNotebookEditor=this._onDidChangeActiveNotebookEditor.event,this._onDidChangeCellExecutionState=new L.Emitter,this.onDidChangeNotebookCellExecutionState=this._onDidChangeCellExecutionState.event,this._visibleNotebookEditors=[],this._onDidOpenNotebookDocument=new L.Emitter,this.onDidOpenNotebookDocument=this._onDidOpenNotebookDocument.event,this._onDidCloseNotebookDocument=new L.Emitter,this.onDidCloseNotebookDocument=this._onDidCloseNotebookDocument.event,this._onDidChangeVisibleNotebookEditors=new L.Emitter,this.onDidChangeVisibleNotebookEditors=this._onDidChangeVisibleNotebookEditors.event,this._statusBarCache=new R.Cache("NotebookCellStatusBarCache"),this._handlePool=0,this._notebookSerializer=new Map,this._backupIdPool=0,this._notebookProxy=s.getProxy(P.MainContext.MainThreadNotebook),this._notebookDocumentsProxy=s.getProxy(P.MainContext.MainThreadNotebookDocuments),this._notebookEditorsProxy=s.getProxy(P.MainContext.MainThreadNotebookEditors),this._commandsConverter=r.converter,r.registerArgumentProcessor({processArgument:n=>{if(n&&n.$mid===12){const t=n.notebookEditor?.notebookUri,o=n.cell.handle,c=this._documents.get(t)?.getCell(o);if(c)return c.apiCell}return n}})}get activeNotebookEditor(){return this._activeNotebookEditor?.apiEditor}get visibleNotebookEditors(){return this._visibleNotebookEditors.map(s=>s.apiEditor)}getEditorById(s){const r=this._editors.get(s);if(!r)throw new Error(`unknown text editor: ${s}. known editors: ${[...this._editors.keys()]} `);return r}getIdByEditor(s){for(const[r,g]of this._editors)if(g.apiEditor===s)return r}get notebookDocuments(){return[...this._documents.values()]}getNotebookDocument(s,r){const g=this._documents.get(s);if(!g&&!r)throw new Error(`NO notebook document for '${s}'`);return g}_getProviderData(s){const r=this._notebookContentProviders.get(s);if(!r)throw new Error(`NO provider for '${s}'`);return r}registerNotebookContentProvider(s,r,g,a,_){if((0,k.isFalsyOrWhitespace)(r))throw new Error("viewType cannot be empty or just whitespace");if(this._notebookContentProviders.has(r))throw new Error(`Notebook provider for '${r}' already registered`);this._notebookContentProviders.set(r,{extension:s,provider:g});let n;return g.onDidChangeNotebookContentOptions&&(n=g.onDidChangeNotebookContentOptions(()=>{const t=u.NotebookDocumentContentOptions.from(g.options);this._notebookProxy.$updateNotebookProviderOptions(r,t)})),this._notebookProxy.$registerNotebookProvider({id:s.identifier,location:s.extensionLocation},r,u.NotebookDocumentContentOptions.from(a),I._convertNotebookRegistrationData(s,_)),new E.Disposable(()=>{n?.dispose(),this._notebookContentProviders.delete(r),this._notebookProxy.$unregisterNotebookProvider(r)})}static _convertNotebookRegistrationData(s,r){if(!r)return;const g=r.filenamePattern.map(a=>u.NotebookExclusiveDocumentPattern.from(a)).filter(a=>a!==void 0);if(r.filenamePattern&&!g){console.warn(`Notebook content provider view options file name pattern is invalid ${r.filenamePattern}`);return}return{extension:s.identifier,providerDisplayName:s.displayName||s.name,displayName:r.displayName,filenamePattern:g,exclusive:r.exclusive||!1}}registerNotebookCellStatusBarItemProvider(s,r,g){const a=I._notebookStatusBarItemProviderHandlePool++,_=typeof g.onDidChangeCellStatusBarItems=="function"?I._notebookStatusBarItemProviderHandlePool++:void 0;this._notebookStatusBarItemProviders.set(a,g),this._notebookProxy.$registerNotebookCellStatusBarItemProvider(a,_,r);let n;return _!==void 0&&(n=g.onDidChangeCellStatusBarItems(t=>this._notebookProxy.$emitCellStatusBarEvent(_))),new E.Disposable(()=>{this._notebookStatusBarItemProviders.delete(a),this._notebookProxy.$unregisterNotebookCellStatusBarItemProvider(a,_),n&&n.dispose()})}async createNotebookDocument(s){const r=await this._notebookDocumentsProxy.$tryCreateNotebook({viewType:s.viewType,content:s.content&&u.NotebookData.from(s.content)});return D.URI.revive(r)}async openNotebookDocument(s){const r=this._documents.get(s);if(r)return r.apiNotebook;const g=await this._notebookDocumentsProxy.$tryOpenNotebook(s),a=this._documents.get(D.URI.revive(g));return(0,S.assertIsDefined)(a?.apiNotebook)}async showNotebookDocument(s,r){D.URI.isUri(s)&&(s=await this.openNotebookDocument(s));let g;typeof r=="object"?g={position:u.ViewColumn.from(r.viewColumn),preserveFocus:r.preserveFocus,selections:r.selections&&r.selections.map(u.NotebookRange.from),pinned:typeof r.preview=="boolean"?!r.preview:void 0}:g={preserveFocus:!1};const a=await this._notebookEditorsProxy.$tryShowNotebookDocument(s.uri,s.notebookType,g),_=a&&this._editors.get(a)?.apiEditor;if(_)return _;throw a?new Error(`Could NOT open editor for "${s.uri.toString()}" because another editor opened in the meantime.`):new Error(`Could NOT open editor for "${s.uri.toString()}".`)}async $provideNotebookCellStatusBarItems(s,r,g,a){const _=this._notebookStatusBarItemProviders.get(s),n=D.URI.revive(r),t=this._documents.get(n);if(!t||!_)return;const o=t.getCellFromIndex(g);if(!o)return;const d=await _.provideCellStatusBarItems(o.apiCell,a);if(!d)return;const c=new C.DisposableStore,h=this._statusBarCache.add([c]),b=(Array.isArray(d)?d:[d]).map(T=>u.NotebookStatusBarItem.from(T,this._commandsConverter,c));return{cacheId:h,items:b}}$releaseNotebookCellStatusBarItems(s){this._statusBarCache.delete(s)}registerNotebookSerializer(s,r,g,a,_){if((0,k.isFalsyOrWhitespace)(r))throw new Error("viewType cannot be empty or just whitespace");const n=this._handlePool++;return this._notebookSerializer.set(n,g),this._notebookProxy.$registerNotebookSerializer(n,{id:s.identifier,location:s.extensionLocation},r,u.NotebookDocumentContentOptions.from(a),I._convertNotebookRegistrationData(s,_)),(0,C.toDisposable)(()=>{this._notebookProxy.$unregisterNotebookSerializer(n)})}async $dataToNotebook(s,r,g){const a=this._notebookSerializer.get(s);if(!a)throw new Error("NO serializer found");const _=await a.deserializeNotebook(r.buffer,g);return new f.SerializableObjectWithBuffers(u.NotebookData.from(_))}async $notebookToData(s,r,g){const a=this._notebookSerializer.get(s);if(!a)throw new Error("NO serializer found");const _=await a.serializeNotebook(u.NotebookData.to(r.value),g);return m.VSBuffer.wrap(_)}async $openNotebook(s,r,g,a,_){const{provider:n}=this._getProviderData(s),t=await n.openNotebook(D.URI.revive(r),{backupId:g,untitledDocumentData:a?.buffer},_);return new f.SerializableObjectWithBuffers({metadata:t.metadata??Object.create(null),cells:t.cells.map(u.NotebookCellData.from)})}async $saveNotebook(s,r,g){const a=this.getNotebookDocument(D.URI.revive(r)),{provider:_}=this._getProviderData(s);return await _.saveNotebook(a.apiNotebook,g),!0}async $saveNotebookAs(s,r,g,a){const _=this.getNotebookDocument(D.URI.revive(r)),{provider:n}=this._getProviderData(s);return await n.saveNotebookAs(D.URI.revive(g),_.apiNotebook,a),!0}async $backupNotebook(s,r,g){const a=this.getNotebookDocument(D.URI.revive(r)),_=this._getProviderData(s),n=this._extensionStoragePaths.workspaceValue(_.extension)??this._extensionStoragePaths.globalValue(_.extension),t=String((0,y.hash)([a.uri.toString(),this._backupIdPool++])),o=D.URI.joinPath(n,t),d=await _.provider.backupNotebook(a.apiNotebook,{destination:o},g);return a.updateBackup(d),d.id}_createExtHostEditor(s,r,g){if(this._editors.has(r))throw new Error(`editor with id ALREADY EXSIST: ${r}`);const a=new w.ExtHostNotebookEditor(r,this._notebookEditorsProxy,s,g.visibleRanges.map(u.NotebookRange.to),g.selections.map(u.NotebookRange.to),typeof g.viewColumn=="number"?u.ViewColumn.to(g.viewColumn):void 0);this._editors.set(r,a)}$acceptDocumentAndEditorsDelta(s){if(s.value.removedDocuments)for(const g of s.value.removedDocuments){const a=D.URI.revive(g),_=this._documents.get(a);_&&(_.dispose(),this._documents.delete(a),this._textDocumentsAndEditors.$acceptDocumentsAndEditorsDelta({removedDocuments:_.apiNotebook.getCells().map(n=>n.document.uri)}),this._onDidCloseNotebookDocument.fire(_.apiNotebook));for(const n of this._editors.values())n.notebookData.uri.toString()===a.toString()&&this._editors.delete(n.id)}if(s.value.addedDocuments){const g=[];for(const a of s.value.addedDocuments){const _=D.URI.revive(a.uri);if(this._documents.has(_))throw new Error(`adding EXISTING notebook ${_} `);const n=this,t=new v.ExtHostNotebookDocument(this._notebookDocumentsProxy,this._textDocumentsAndEditors,this._textDocuments,{emitModelChange(o){n._onDidChangeNotebookCells.fire(o)},emitCellOutputsChange(o){n._onDidChangeCellOutputs.fire(o)},emitCellMetadataChange(o){n._onDidChangeCellMetadata.fire(o)},emitCellExecutionStateChange(o){n._onDidChangeCellExecutionState.fire(o)}},_,a);g.push(...a.cells.map(o=>v.ExtHostCell.asModelAddData(t.apiNotebook,o))),this._documents.get(_)?.dispose(),this._documents.set(_,t),this._textDocumentsAndEditors.$acceptDocumentsAndEditorsDelta({addedDocuments:g}),this._onDidOpenNotebookDocument.fire(t.apiNotebook)}}if(s.value.addedEditors)for(const g of s.value.addedEditors){if(this._editors.has(g.id))return;const a=D.URI.revive(g.documentUri),_=this._documents.get(a);_&&this._createExtHostEditor(_,g.id,g)}const r=[];if(s.value.removedEditors)for(const g of s.value.removedEditors){const a=this._editors.get(g);a&&(this._editors.delete(g),this._activeNotebookEditor?.id===a.id&&(this._activeNotebookEditor=void 0),r.push(a))}if(s.value.visibleEditors){this._visibleNotebookEditors=s.value.visibleEditors.map(a=>this._editors.get(a)).filter(a=>!!a);const g=new Set;this._visibleNotebookEditors.forEach(a=>g.add(a.id));for(const a of this._editors.values()){const _=g.has(a.id);a._acceptVisibility(_)}this._visibleNotebookEditors=[...this._editors.values()].map(a=>a).filter(a=>a.visible),this._onDidChangeVisibleNotebookEditors.fire(this.visibleNotebookEditors)}s.value.newActiveEditor===null?this._activeNotebookEditor=void 0:s.value.newActiveEditor&&(this._activeNotebookEditor=this._editors.get(s.value.newActiveEditor)),s.value.newActiveEditor!==void 0&&this._onDidChangeActiveNotebookEditor.fire(this._activeNotebookEditor?.apiEditor)}}e.ExtHostNotebookController=I,I._notebookStatusBarItemProviderHandlePool=0}),define(pe[244],ve([0,1,3,75,11,5,14,17]),function(Y,e,m,L,y,C,i,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookEditors=void 0;class S{constructor(P,u){const E=S._Keys.nextId();P.$registerNotebookEditorDecorationType(E,k.NotebookDecorationRenderOptions.from(u)),this.value={key:E,dispose(){P.$removeNotebookEditorDecorationType(E)}}}}S._Keys=new L.IdGenerator("NotebookEditorDecorationType");let D=class{constructor(P,u,E){this._logService=P,this._extHostRpc=u,this._notebooksAndEditors=E,this._onDidChangeNotebookEditorSelection=new m.Emitter,this._onDidChangeNotebookEditorVisibleRanges=new m.Emitter,this.onDidChangeNotebookEditorSelection=this._onDidChangeNotebookEditorSelection.event,this.onDidChangeNotebookEditorVisibleRanges=this._onDidChangeNotebookEditorVisibleRanges.event}createNotebookEditorDecorationType(P){return new S(this._extHostRpc.getProxy(C.MainContext.MainThreadNotebookEditors),P).value}$acceptEditorPropertiesChanged(P,u){this._logService.debug("ExtHostNotebook#$acceptEditorPropertiesChanged",P,u);const E=this._notebooksAndEditors.getEditorById(P);u.visibleRanges&&E._acceptVisibleRanges(u.visibleRanges.ranges.map(k.NotebookRange.to)),u.selections&&E._acceptSelections(u.selections.selections.map(k.NotebookRange.to)),u.visibleRanges&&this._onDidChangeNotebookEditorVisibleRanges.fire({notebookEditor:E.apiEditor,visibleRanges:E.apiEditor.visibleRanges}),u.selections&&this._onDidChangeNotebookEditorSelection.fire(Object.freeze({notebookEditor:E.apiEditor,selections:E.apiEditor.selections}))}$acceptEditorViewColumns(P){for(const u in P)this._notebooksAndEditors.getEditorById(u)._acceptViewColumn(k.ViewColumn.to(P[u]))}};D=je([He(0,y.ILogService),He(1,i.IExtHostRpcService)],D),e.ExtHostNotebookEditors=D}),define(pe[245],ve([0,1,16,18,21,3,6,24,2,27,11,5,38,17,7,88,210,29,53]),function(Y,e,m,L,y,C,i,k,S,D,R,P,u,E,f,v,w,I,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookKernels=void 0;let s=class{constructor(n,t,o,d,c){this._initData=t,this._extHostNotebook=o,this._commands=d,this._logService=c,this._activeExecutions=new k.ResourceMap,this._kernelData=new Map,this._handlePool=0,this._proxy=n.getProxy(P.MainContext.MainThreadNotebookKernels);const h=new u.ApiCommand("notebook.selectKernel","_notebook.selectKernel","Trigger kernel picker for specified notebook editor widget",[new u.ApiCommandArgument("options","Select kernel options",l=>!0,l=>{if(l&&"notebookEditor"in l&&"id"in l){const b=this._extHostNotebook.getIdByEditor(l.notebookEditor);return{id:l.id,extension:l.extension,notebookEditorId:b}}else if(l&&"notebookEditor"in l){const b=this._extHostNotebook.getIdByEditor(l.notebookEditor);if(b===void 0)throw new Error(`Cannot invoke 'notebook.selectKernel' for unrecognized notebook editor ${l.notebookEditor.document.uri.toString()}`);return{notebookEditorId:b}}return l})],u.ApiCommandResult.Void);this._commands.registerApiCommand(h)}createNotebookController(n,t,o,d,c,h){for(let j of this._kernelData.values())if(j.controller.id===t&&D.ExtensionIdentifier.equals(n.identifier,j.extensionId))throw new Error(`notebook controller with id '${t}' ALREADY exist`);const l=this._handlePool++,b=this;this._logService.trace(`NotebookController[${l}], CREATED by ${n.identifier.value}, ${t}`);const T=()=>console.warn(`NO execute handler from notebook controller '${W.id}' of extension: '${n.identifier}'`);let A=!1;const x=new i.DisposableStore,O=new C.Emitter,F=new C.Emitter,W={id:`${n.identifier.value}/${t}`,notebookType:o,extensionId:n.identifier,extensionLocation:n.extensionLocation,label:d||n.identifier.value,preloads:h?h.map(E.NotebookRendererScript.from):[]};let M=c??T,B;this._proxy.$addKernel(l,W).catch(j=>{console.log(j),A=!0});let U=0;const z=()=>{if(A)return;const j=++U;Promise.resolve().then(()=>{j===U&&this._proxy.$updateKernel(l,W)})},K=new k.ResourceMap,N={get id(){return t},get notebookType(){return W.notebookType},onDidChangeSelectedNotebooks:O.event,get label(){return W.label},set label(j){W.label=j??n.displayName??n.name,z()},get detail(){return W.detail??""},set detail(j){W.detail=j,z()},get description(){return W.description??""},set description(j){W.description=j,z()},get kind(){return(0,I.checkProposedApiEnabled)(n,"notebookControllerKind"),W.kind??""},set kind(j){(0,I.checkProposedApiEnabled)(n,"notebookControllerKind"),W.kind=j,z()},get supportedLanguages(){return W.supportedLanguages},set supportedLanguages(j){W.supportedLanguages=j,z()},get supportsExecutionOrder(){return W.supportsExecutionOrder??!1},set supportsExecutionOrder(j){W.supportsExecutionOrder=j,z()},get rendererScripts(){return W.preloads?W.preloads.map(E.NotebookRendererScript.to):[]},get executeHandler(){return M},set executeHandler(j){M=j??T},get interruptHandler(){return B},set interruptHandler(j){B=j,W.supportsInterrupt=Boolean(j),z()},createNotebookCellExecution(j){if(A)throw new Error("notebook controller is DISPOSED");if(!K.has(j.notebook.uri))throw b._logService.trace(`NotebookController[${l}] NOT associated to notebook, associated to THESE notebooks:`,Array.from(K.keys()).map(H=>H.toString())),new Error(`notebook controller is NOT associated to notebook: ${j.notebook.uri.toString()}`);return b._createNotebookCellExecution(j)},dispose:()=>{A||(this._logService.trace(`NotebookController[${l}], DISPOSED`),A=!0,this._kernelData.delete(l),x.dispose(),O.dispose(),F.dispose(),this._proxy.$removeKernel(l))},updateNotebookAffinity(j,H){b._proxy.$updateNotebookPriority(l,j.uri,H)},onDidReceiveMessage:F.event,postMessage(j,H){return(0,I.checkProposedApiEnabled)(n,"notebookMessaging"),b._proxy.$postMessage(l,H&&b._extHostNotebook.getIdByEditor(H),j)},asWebviewUri(j){return(0,I.checkProposedApiEnabled)(n,"notebookMessaging"),(0,v.asWebviewUri)(j,b._initData.remote)}};return this._kernelData.set(l,{extensionId:n.identifier,controller:N,onDidReceiveMessage:F,onDidChangeSelection:O,associatedNotebooks:K}),N}$acceptNotebookAssociation(n,t,o){const d=this._kernelData.get(n);if(d){const c=this._extHostNotebook.getNotebookDocument(S.URI.revive(t));o?d.associatedNotebooks.set(c.uri,!0):d.associatedNotebooks.delete(c.uri),this._logService.trace(`NotebookController[${n}] ASSOCIATE notebook`,c.uri.toString(),o),d.onDidChangeSelection.fire({selected:o,notebook:c.apiNotebook})}}async $executeCells(n,t,o){const d=this._kernelData.get(n);if(!d)return;const c=this._extHostNotebook.getNotebookDocument(S.URI.revive(t)),h=[];for(let l of o){const b=c.getCell(l);b&&h.push(b.apiCell)}try{this._logService.trace(`NotebookController[${n}] EXECUTE cells`,c.uri.toString(),h.length),await d.controller.executeHandler.call(d.controller,h,c.apiNotebook,d.controller)}catch(l){this._logService.error(`NotebookController[${n}] execute cells FAILED`,l),console.error(l)}}async $cancelCells(n,t,o){const d=this._kernelData.get(n);if(!d)return;const c=this._extHostNotebook.getNotebookDocument(S.URI.revive(t));if(d.controller.interruptHandler)await d.controller.interruptHandler.call(d.controller,c.apiNotebook);else for(let h of o){const l=c.getCell(h);l&&this._activeExecutions.get(l.uri)?.cancel()}}$acceptKernelMessageFromRenderer(n,t,o){const d=this._kernelData.get(n);if(!d)return;const c=this._extHostNotebook.getEditorById(t);d.onDidReceiveMessage.fire(Object.freeze({editor:c.apiEditor,message:o}))}_createNotebookCellExecution(n){if(n.index<0)throw new Error("CANNOT execute cell that has been REMOVED from notebook");const o=this._extHostNotebook.getNotebookDocument(n.notebook.uri).getCellFromApiCell(n);if(!o)throw new Error("invalid cell");if(this._activeExecutions.has(o.uri))throw new Error(`duplicate execution for ${o.uri}`);const d=new g(o.notebook,o,this._proxy);this._activeExecutions.set(o.uri,d);const c=d.onDidChangeState(()=>{d.state===r.Resolved&&(d.dispose(),c.dispose(),this._activeExecutions.delete(o.uri))});return d.asApiObject()}};s=je([He(4,R.ILogService)],s),e.ExtHostNotebookKernels=s;var r;(function(_){_[_.Init=0]="Init",_[_.Started=1]="Started",_[_.Resolved=2]="Resolved"})(r||(r={}));class g extends i.Disposable{constructor(n,t,o){super();this._document=n,this._cell=t,this._proxy=o,this._handle=g.HANDLE++,this._onDidChangeState=new C.Emitter,this.onDidChangeState=this._onDidChangeState.event,this._state=r.Init,this._tokenSource=this._register(new y.CancellationTokenSource),this._collector=new a(10,d=>this.update(d)),this._executionOrder=t.internalMetadata.executionOrder,this._proxy.$addExecution(this._handle,this._cell.notebook.uri,this._cell.handle)}get state(){return this._state}cancel(){this._tokenSource.cancel()}async updateSoon(n){await this._collector.addItem(n)}async update(n){const t=Array.isArray(n)?n:[n];return this._proxy.$updateExecutions(new p.SerializableObjectWithBuffers(t))}verifyStateForOutput(){if(this._state===r.Init)throw new Error("Must call start before modifying cell output");if(this._state===r.Resolved)throw new Error("Cannot modify cell output after calling resolve")}cellIndexToHandle(n){let t=this._cell;if(n&&(t=this._document.getCellFromApiCell(n)),!t)throw new Error("INVALID cell");return t.handle}validateAndConvertOutputs(n){return n.map(t=>{const o=f.NotebookCellOutput.ensureUniqueMimeTypes(t.items,!0);return o===t.items?E.NotebookCellOutput.from(t):E.NotebookCellOutput.from({items:o,id:t.id,metadata:t.metadata})})}async updateOutputs(n,t,o){const d=this.cellIndexToHandle(t),c=this.validateAndConvertOutputs((0,m.asArray)(n));return this.updateSoon({editType:w.CellExecutionUpdateType.Output,executionHandle:this._handle,cellHandle:d,append:o,outputs:c})}async updateOutputItems(n,t,o){return n=f.NotebookCellOutput.ensureUniqueMimeTypes((0,m.asArray)(n),!0),this.updateSoon({editType:w.CellExecutionUpdateType.OutputItems,executionHandle:this._handle,items:n.map(E.NotebookCellOutputItem.from),outputId:t.id,append:o})}asApiObject(){const n=this;return Object.freeze({get token(){return n._tokenSource.token},get cell(){return n._cell.apiCell},get executionOrder(){return n._executionOrder},set executionOrder(o){n._executionOrder=o,n.update([{editType:w.CellExecutionUpdateType.ExecutionState,executionHandle:n._handle,executionOrder:n._executionOrder}])},start(o){if(n._state===r.Resolved||n._state===r.Started)throw new Error("Cannot call start again");n._state=r.Started,n._onDidChangeState.fire(),n.update({editType:w.CellExecutionUpdateType.ExecutionState,executionHandle:n._handle,runStartTime:o})},end(o,d){if(n._state===r.Resolved)throw new Error("Cannot call resolve twice");n._state=r.Resolved,n._onDidChangeState.fire(),n.updateSoon({editType:w.CellExecutionUpdateType.Complete,executionHandle:n._handle,runEndTime:d,lastRunSuccess:o}),n._collector.flush(),n._proxy.$removeExecution(n._handle)},clearOutput(o){return n.verifyStateForOutput(),n.updateOutputs([],o,!1)},appendOutput(o,d){return n.verifyStateForOutput(),n.updateOutputs(o,d,!0)},replaceOutput(o,d){return n.verifyStateForOutput(),n.updateOutputs(o,d,!1)},appendOutputItems(o,d){return n.verifyStateForOutput(),n.updateOutputItems(o,d,!0)},replaceOutputItems(o,d){return n.verifyStateForOutput(),n.updateOutputItems(o,d,!1)}})}}g.HANDLE=0;class a{constructor(n,t){this.delay=n,this.callback=t,this.batch=[],this.startedTimer=Date.now()}addItem(n){return this.batch.push(n),this.currentDeferred||(this.currentDeferred=new L.DeferredPromise,this.startedTimer=Date.now(),(0,L.timeout)(this.delay).then(()=>this.flush())),Date.now()-this.startedTimer>this.delay?this.flush():this.currentDeferred.p}flush(){if(this.batch.length===0||!this.currentDeferred)return Promise.resolve();const n=this.currentDeferred;this.currentDeferred=void 0;const t=this.batch;return this.batch=[],this.callback(t).finally(()=>n.complete())}}}),define(pe[246],ve([0,1,3,5,128,29]),function(Y,e,m,L,y,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookRenderers=void 0;class i{constructor(S,D){this._extHostNotebook=D,this._rendererMessageEmitters=new Map,this.proxy=S.getProxy(L.MainContext.MainThreadNotebookRenderers)}$postRendererMessage(S,D,R){const P=this._extHostNotebook.getEditorById(S);this._rendererMessageEmitters.get(D)?.fire({editor:P.apiEditor,message:R})}createRendererMessaging(S,D){if(!S.contributes?.notebookRenderer?.some(E=>E.id===D))throw new Error(`Extensions may only call createRendererMessaging() for renderers they contribute (got ${D})`);const R=(0,C.isProposedApiEnabled)(S,"notebookEditor"),P=new WeakMap;return{onDidReceiveMessage:(E,f,v)=>{const w=R?E:I=>{const p={};P.set(p,I.editor),E({editor:p,message:I.message})};return this.getOrCreateEmitterFor(D).event(w,f,v)},postMessage:(E,f)=>{y.ExtHostNotebookEditor.apiEditorsToExtHost.has(E)&&([E,f]=[f,E]);const v=R?f:P.get(f),w=v&&y.ExtHostNotebookEditor.apiEditorsToExtHost.get(v);return this.proxy.$postMessage(w?.id,D,E)}}}getOrCreateEmitterFor(S){let D=this._rendererMessageEmitters.get(S);return D||(D=new m.Emitter({onLastListenerRemove:()=>{D?.dispose(),this._rendererMessageEmitters.delete(S)}}),this._rendererMessageEmitters.set(S,D),D)}}e.ExtHostNotebookRenderers=i}),define(pe[132],ve([0,1,5,6,4,14,11,211,66,26,44,151,22]),function(Y,e,m,L,y,C,i,k,S,D,R,P,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostOutputService=e.ExtHostOutputService=e.ExtHostOutputChannel=void 0;class E extends L.Disposable{constructor(w,I,p,s){super();this.id=w,this.name=I,this.logger=p,this.proxy=s,this.offset=0,this.visible=!1,this._disposed=!1}get disposed(){return this._disposed}appendLine(w){this.append(w+`
`)}append(w){this.write(w),this.visible&&(this.logger.flush(),this.proxy.$update(this.id,k.OutputChannelUpdateMode.Append))}clear(){const w=this.offset;this.logger.flush(),this.proxy.$update(this.id,k.OutputChannelUpdateMode.Clear,w)}replace(w){const I=this.offset;this.write(w),this.proxy.$update(this.id,k.OutputChannelUpdateMode.Replace,I),this.visible&&this.logger.flush()}show(w,I){this.logger.flush(),this.proxy.$reveal(this.id,!!(typeof w=="boolean"?w:I))}hide(){this.proxy.$close(this.id)}write(w){this.offset+=u.VSBuffer.fromString(w).byteLength,this.logger.info(w)}dispose(){super.dispose(),this._disposed||(this.proxy.$dispose(this.id),this._disposed=!0)}}e.ExtHostOutputChannel=E;let f=class{constructor(w,I,p,s,r){this.extHostFileSystem=p,this.extHostFileSystemInfo=s,this.loggerService=r,this.namePool=1,this.channels=new Map,this.visibleChannelId=null,this.proxy=w.getProxy(m.MainContext.MainThreadOutputService),this.outputsLocation=this.extHostFileSystemInfo.extUri.joinPath(I.logsLocation,`output_logging_${(0,P.toLocalISOString)(new Date).replace(/-|:|\.\d+Z$/g,"")}`)}$setVisibleChannel(w){this.visibleChannelId=w;for(const[I,p]of this.channels)p.visible=I===this.visibleChannelId}createOutputChannel(w,I){if(w=w.trim(),!w)throw new Error("illegal argument `name`. must not be falsy");const p=this.doCreateOutputChannel(w,I);return p.then(s=>{this.channels.set(s.id,s),s.visible=s.id===this.visibleChannelId}),this.createExtHostOutputChannel(w,p)}async doCreateOutputChannel(w,I){const p=await this.createOutputDirectory(),s=this.extHostFileSystemInfo.extUri.joinPath(p,`${this.namePool++}-${w.replace(/[\\/:\*\?"<>\|]/g,"")}.log`),r=this.loggerService.createLogger(s,{always:!0,donotRotate:!0,donotUseFormatters:!0}),g=await this.proxy.$register(w,!1,s,I.identifier.value);return new E(g,w,r,this.proxy)}createOutputDirectory(){return this.outputDirectoryPromise||(this.outputDirectoryPromise=this.extHostFileSystem.value.createDirectory(this.outputsLocation).then(()=>this.outputsLocation)),this.outputDirectoryPromise}createExtHostOutputChannel(w,I){let p=!1;const s=()=>{if(p)throw new Error("Channel has been closed")};return{get name(){return w},append(r){s(),I.then(g=>g.append(r))},appendLine(r){s(),I.then(g=>g.appendLine(r))},clear(){s(),I.then(r=>r.clear())},replace(r){s(),I.then(g=>g.replace(r))},show(r,g){s(),I.then(a=>a.show(r,g))},hide(){s(),I.then(r=>r.hide())},dispose(){p=!0,I.then(r=>r.dispose())}}}};f=je([He(0,C.IExtHostRpcService),He(1,D.IExtHostInitDataService),He(2,S.IExtHostConsumerFileSystem),He(3,R.IExtHostFileSystemInfo),He(4,i.ILoggerService)],f),e.ExtHostOutputService=f,e.IExtHostOutputService=(0,y.createDecorator)("IExtHostOutputService")}),define(pe[247],ve([0,1,18,21,3,6,5,2,7,15,16,48,86,29]),function(Y,e,m,L,y,C,i,k,S,D,R,P,u,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createExtHostQuickOpen=void 0;function f(v,w,I){const p=v.getProxy(i.MainContext.MainThreadQuickOpen);class s{constructor(c,h){this._sessions=new Map,this._instances=0,this._workspace=c,this._commands=h}showQuickPick(c,h,l=L.CancellationToken.None){this._onDidSelectItem=void 0;const b=Promise.resolve(c),T=++this._instances,A=p.$show(T,{title:h?.title,placeHolder:h?.placeHolder,matchOnDescription:h?.matchOnDescription,matchOnDetail:h?.matchOnDetail,ignoreFocusLost:h?.ignoreFocusOut,canPickMany:h?.canPickMany},l),x={},O=A.then(()=>x);return Promise.race([O,b]).then(F=>{if(F!==x)return b.then(W=>{const M=[];for(let B=0;B<W.length;B++){const U=W[B];typeof U=="string"?M.push({label:U,handle:B}):U.kind===S.QuickPickItemKind.Separator?M.push({type:"separator",label:U.label}):M.push({label:U.label,description:U.description,detail:U.detail,picked:U.picked,alwaysShow:U.alwaysShow,handle:B})}return h&&typeof h.onDidSelectItem=="function"&&(this._onDidSelectItem=B=>{h.onDidSelectItem(W[B])}),p.$setItems(T,M),A.then(B=>{if(typeof B=="number")return W[B];if(Array.isArray(B))return B.map(U=>W[U])})})}).then(void 0,F=>{if(!(0,D.isPromiseCanceledError)(F))return p.$setError(T,F),Promise.reject(F)})}$onItemSelected(c){this._onDidSelectItem&&this._onDidSelectItem(c)}showInput(c,h=L.CancellationToken.None){return this._validateInput=c?c.validateInput:void 0,p.$input(c,typeof this._validateInput=="function",h).then(void 0,l=>{if(!(0,D.isPromiseCanceledError)(l))return Promise.reject(l)})}$validateInput(c){return this._validateInput?(0,m.asPromise)(()=>this._validateInput(c)):Promise.resolve(void 0)}async showWorkspaceFolderPick(c,h=L.CancellationToken.None){const l=await this._commands.executeCommand("_workbench.pickWorkspaceFolder",[c]);if(!l)return;const b=await this._workspace.getWorkspaceFolders2();if(!!b)return b.find(T=>T.uri.toString()===l.uri.toString())}createQuickPick(c){const h=new t(c,()=>this._sessions.delete(h._id));return this._sessions.set(h._id,h),h}createInputBox(c){const h=new o(c,()=>this._sessions.delete(h._id));return this._sessions.set(h._id,h),h}$onDidChangeValue(c,h){const l=this._sessions.get(c);l&&l._fireDidChangeValue(h)}$onDidAccept(c){const h=this._sessions.get(c);h&&h._fireDidAccept()}$onDidChangeActive(c,h){const l=this._sessions.get(c);l instanceof t&&l._fireDidChangeActive(h)}$onDidChangeSelection(c,h){const l=this._sessions.get(c);l instanceof t&&l._fireDidChangeSelection(h)}$onDidTriggerButton(c,h){const l=this._sessions.get(c);l&&l._fireDidTriggerButton(h)}$onDidTriggerItemButton(c,h,l){const b=this._sessions.get(c);b instanceof t&&b._fireDidTriggerItemButton(h,l)}$onDidHide(c){const h=this._sessions.get(c);h&&h._fireDidHide()}}class r{constructor(c,h){this._extensionId=c,this._onDidDispose=h,this._id=t._nextId++,this._visible=!1,this._expectingHide=!1,this._enabled=!0,this._busy=!1,this._ignoreFocusOut=!0,this._value="",this._buttons=[],this._handlesToButtons=new Map,this._onDidAcceptEmitter=new y.Emitter,this._onDidChangeValueEmitter=new y.Emitter,this._onDidTriggerButtonEmitter=new y.Emitter,this._onDidHideEmitter=new y.Emitter,this._pendingUpdate={id:this._id},this._disposed=!1,this._disposables=[this._onDidTriggerButtonEmitter,this._onDidHideEmitter,this._onDidAcceptEmitter,this._onDidChangeValueEmitter],this.onDidChangeValue=this._onDidChangeValueEmitter.event,this.onDidAccept=this._onDidAcceptEmitter.event,this.onDidTriggerButton=this._onDidTriggerButtonEmitter.event,this.onDidHide=this._onDidHideEmitter.event}get title(){return this._title}set title(c){this._title=c,this.update({title:c})}get step(){return this._steps}set step(c){this._steps=c,this.update({step:c})}get totalSteps(){return this._totalSteps}set totalSteps(c){this._totalSteps=c,this.update({totalSteps:c})}get enabled(){return this._enabled}set enabled(c){this._enabled=c,this.update({enabled:c})}get busy(){return this._busy}set busy(c){this._busy=c,this.update({busy:c})}get ignoreFocusOut(){return this._ignoreFocusOut}set ignoreFocusOut(c){this._ignoreFocusOut=c,this.update({ignoreFocusOut:c})}get value(){return this._value}set value(c){this._value=c,this.update({value:c})}get placeholder(){return this._placeholder}set placeholder(c){this._placeholder=c,this.update({placeholder:c})}get buttons(){return this._buttons}set buttons(c){this._buttons=c.slice(),this._handlesToButtons.clear(),c.forEach((h,l)=>{const b=h===S.QuickInputButtons.Back?-1:l;this._handlesToButtons.set(b,h)}),this.update({buttons:c.map((h,l)=>({...n(h),tooltip:h.tooltip,handle:h===S.QuickInputButtons.Back?-1:l}))})}show(){this._visible=!0,this._expectingHide=!0,this.update({visible:!0})}hide(){this._visible=!1,this.update({visible:!1})}_fireDidAccept(){this._onDidAcceptEmitter.fire()}_fireDidChangeValue(c){this._value=c,this._onDidChangeValueEmitter.fire(c)}_fireDidTriggerButton(c){const h=this._handlesToButtons.get(c);h&&this._onDidTriggerButtonEmitter.fire(h)}_fireDidHide(){this._expectingHide&&(this._expectingHide=this._visible,this._onDidHideEmitter.fire())}dispose(){this._disposed||(this._disposed=!0,this._fireDidHide(),this._disposables=(0,C.dispose)(this._disposables),this._updateTimeout&&(clearTimeout(this._updateTimeout),this._updateTimeout=void 0),this._onDidDispose(),p.$dispose(this._id))}update(c){if(!this._disposed){for(const h of Object.keys(c)){const l=c[h];this._pendingUpdate[h]=l===void 0?null:l}"visible"in this._pendingUpdate?(this._updateTimeout&&(clearTimeout(this._updateTimeout),this._updateTimeout=void 0),this.dispatchUpdate()):this._visible&&!this._updateTimeout&&(this._updateTimeout=setTimeout(()=>{this._updateTimeout=void 0,this.dispatchUpdate()},0))}}dispatchUpdate(){p.$createOrUpdate(this._pendingUpdate),this._pendingUpdate={id:this._id}}}r._nextId=1;function g(d){if(d instanceof S.ThemeIcon)return{id:d.id};const c=_(d),h=a(d);return{dark:typeof c=="string"?k.URI.file(c):c,light:typeof h=="string"?k.URI.file(h):h}}function a(d){return typeof d=="object"&&"light"in d?d.light:d}function _(d){return typeof d=="object"&&"dark"in d?d.dark:d}function n(d){const c=g(d.iconPath);let h,l;return"id"in c?l=u.ThemeIcon.asClassName(c):h=c,{iconPath:h,iconClass:l}}class t extends r{constructor(c,h){super(c.identifier,h);this.extension=c,this._items=[],this._handlesToItems=new Map,this._itemsToHandles=new Map,this._canSelectMany=!1,this._matchOnDescription=!0,this._matchOnDetail=!0,this._sortByLabel=!0,this._keepScrollPosition=!1,this._activeItems=[],this._onDidChangeActiveEmitter=new y.Emitter,this._selectedItems=[],this._onDidChangeSelectionEmitter=new y.Emitter,this._onDidTriggerItemButtonEmitter=new y.Emitter,this.onDidChangeActive=this._onDidChangeActiveEmitter.event,this.onDidChangeSelection=this._onDidChangeSelectionEmitter.event,this.onDidTriggerItemButton=this._onDidTriggerItemButtonEmitter.event,this._disposables.push(this._onDidChangeActiveEmitter,this._onDidChangeSelectionEmitter,this._onDidTriggerItemButtonEmitter),this.update({type:"quickPick"})}get items(){return this._items}set items(c){c.some(l=>l.kind!==void 0)&&(0,E.checkProposedApiEnabled)(this.extension,"quickPickSeparators"),this._items=c.slice(),this._handlesToItems.clear(),this._itemsToHandles.clear(),c.forEach((l,b)=>{this._handlesToItems.set(b,l),this._itemsToHandles.set(l,b)});const h=[];for(let l=0;l<c.length;l++){const b=c[l];b.kind===S.QuickPickItemKind.Separator?h.push({type:"separator",label:b.label}):h.push({handle:l,label:b.label,description:b.description,detail:b.detail,picked:b.picked,alwaysShow:b.alwaysShow,buttons:b.buttons?.map((T,A)=>({...n(T),tooltip:T.tooltip,handle:A}))})}this.update({items:h})}get canSelectMany(){return this._canSelectMany}set canSelectMany(c){this._canSelectMany=c,this.update({canSelectMany:c})}get matchOnDescription(){return this._matchOnDescription}set matchOnDescription(c){this._matchOnDescription=c,this.update({matchOnDescription:c})}get matchOnDetail(){return this._matchOnDetail}set matchOnDetail(c){this._matchOnDetail=c,this.update({matchOnDetail:c})}get sortByLabel(){return this._sortByLabel}set sortByLabel(c){this._sortByLabel=c,this.update({sortByLabel:c})}get keepScrollPosition(){return this._keepScrollPosition}set keepScrollPosition(c){this._keepScrollPosition=c,this.update({keepScrollPosition:c})}get activeItems(){return this._activeItems}set activeItems(c){this._activeItems=c.filter(h=>this._itemsToHandles.has(h)),this.update({activeItems:this._activeItems.map(h=>this._itemsToHandles.get(h))})}get selectedItems(){return this._selectedItems}set selectedItems(c){this._selectedItems=c.filter(h=>this._itemsToHandles.has(h)),this.update({selectedItems:this._selectedItems.map(h=>this._itemsToHandles.get(h))})}_fireDidChangeActive(c){const h=(0,R.coalesce)(c.map(l=>this._handlesToItems.get(l)));this._activeItems=h,this._onDidChangeActiveEmitter.fire(h)}_fireDidChangeSelection(c){const h=(0,R.coalesce)(c.map(l=>this._handlesToItems.get(l)));this._selectedItems=h,this._onDidChangeSelectionEmitter.fire(h)}_fireDidTriggerItemButton(c,h){const l=this._handlesToItems.get(c);if(!l||!l.buttons||!l.buttons.length)return;const b=l.buttons[h];b&&this._onDidTriggerItemButtonEmitter.fire({button:b,item:l})}}class o extends r{constructor(c,h){super(c,h);this._password=!1,this.update({type:"inputBox"})}get password(){return this._password}set password(c){this._password=c,this.update({password:c})}get prompt(){return this._prompt}set prompt(c){this._prompt=c,this.update({prompt:c})}get validationMessage(){return this._validationMessage}set validationMessage(c){this._validationMessage=c,this.update({validationMessage:c,severity:c?P.default.Error:P.default.Ignore})}}return new s(w,I)}e.createExtHostQuickOpen=f}),define(pe[248],ve([0,1,2,3,57,6,18,5,16,99,11,27,86,17,29]),function(Y,e,m,L,y,C,i,k,S,D,R,P,u,E,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostSCM=e.ExtHostSCMInputBox=void 0;function v(d){if(d)return typeof d.iconPath=="string"?m.URI.file(d.iconPath):m.URI.isUri(d.iconPath)||u.ThemeIcon.isThemeIcon(d.iconPath)?d.iconPath:void 0}function w(d,c){if(!d.iconPath&&!c.iconPath)return 0;if(d.iconPath){if(!c.iconPath)return 1}else return-1;const h=typeof d.iconPath=="string"?d.iconPath:m.URI.isUri(d.iconPath)?d.iconPath.fsPath:d.iconPath.id,l=typeof c.iconPath=="string"?c.iconPath:m.URI.isUri(c.iconPath)?c.iconPath.fsPath:c.iconPath.id;return(0,D.comparePaths)(h,l)}function I(d,c){let h=0;if(d.strikeThrough!==c.strikeThrough)return d.strikeThrough?1:-1;if(d.faded!==c.faded)return d.faded?1:-1;if(d.tooltip!==c.tooltip)return(d.tooltip||"").localeCompare(c.tooltip||"");if(h=w(d,c),h!==0)return h;if(d.light&&c.light)h=w(d.light,c.light);else{if(d.light)return 1;if(c.light)return-1}if(h!==0)return h;if(d.dark&&c.dark)h=w(d.dark,c.dark);else{if(d.dark)return 1;if(c.dark)return-1}return h}function p(d,c){if(d.command!==c.command)return d.command<c.command?-1:1;if(d.title!==c.title)return d.title<c.title?-1:1;if(d.tooltip!==c.tooltip){if(d.tooltip!==void 0&&c.tooltip!==void 0)return d.tooltip<c.tooltip?-1:1;if(d.tooltip!==void 0)return 1;if(c.tooltip!==void 0)return-1}if(d.arguments===c.arguments)return 0;if(d.arguments)if(c.arguments){if(d.arguments.length!==c.arguments.length)return d.arguments.length-c.arguments.length}else return 1;else return-1;for(let h=0;h<d.arguments.length;h++){const l=d.arguments[h],b=c.arguments[h];if(l!==b)return l<b?-1:1}return 0}function s(d,c){let h=(0,D.comparePaths)(d.resourceUri.fsPath,c.resourceUri.fsPath,!0);if(h!==0)return h;if(d.command&&c.command)h=p(d.command,c.command);else{if(d.command)return 1;if(c.command)return-1}if(h!==0)return h;if(d.decorations&&c.decorations)h=I(d.decorations,c.decorations);else{if(d.decorations)return 1;if(c.decorations)return-1}return h}function r(d,c){for(let h=0;h<d.length;h++)if(d[h]!==c[h])return!1;return!0}function g(d,c){return d.command===c.command&&d.title===c.title&&d.tooltip===c.tooltip&&(d.arguments&&c.arguments?r(d.arguments,c.arguments):d.arguments===c.arguments)}function a(d,c){return(0,S.equals)(d,c,g)}class _{constructor(c,h,l){this._extension=c,this._proxy=h,this._sourceControlHandle=l,this._value="",this._onDidChange=new L.Emitter,this._placeholder="",this._visible=!0}get value(){return this._value}set value(c){this._proxy.$setInputBoxValue(this._sourceControlHandle,c),this.updateValue(c)}get onDidChange(){return this._onDidChange.event}get placeholder(){return this._placeholder}set placeholder(c){this._proxy.$setInputBoxPlaceholder(this._sourceControlHandle,c),this._placeholder=c}get validateInput(){return(0,f.checkProposedApiEnabled)(this._extension,"scmValidation"),this._validateInput}set validateInput(c){if((0,f.checkProposedApiEnabled)(this._extension,"scmValidation"),c&&typeof c!="function")throw new Error(`[${this._extension.identifier.value}]: Invalid SCM input box validation function`);this._validateInput=c,this._proxy.$setValidationProviderIsEnabled(this._sourceControlHandle,!!c)}get visible(){return this._visible}set visible(c){c=!!c,this._visible!==c&&(this._visible=c,this._proxy.$setInputBoxVisibility(this._sourceControlHandle,c))}showValidationMessage(c,h){(0,f.checkProposedApiEnabled)(this._extension,"scmValidation"),this._proxy.$showValidationMessage(this._sourceControlHandle,c,h)}$onInputBoxValueChange(c){this.updateValue(c)}updateValue(c){this._value=c,this._onDidChange.fire(c)}}e.ExtHostSCMInputBox=_;class n{constructor(c,h,l,b,T){this._proxy=c,this._commands=h,this._sourceControlHandle=l,this._id=b,this._label=T,this._resourceHandlePool=0,this._resourceStates=[],this._resourceStatesMap=new Map,this._resourceStatesCommandsMap=new Map,this._resourceStatesDisposablesMap=new Map,this._onDidUpdateResourceStates=new L.Emitter,this.onDidUpdateResourceStates=this._onDidUpdateResourceStates.event,this._disposed=!1,this._onDidDispose=new L.Emitter,this.onDidDispose=this._onDidDispose.event,this._handlesSnapshot=[],this._resourceSnapshot=[],this._hideWhenEmpty=void 0,this.handle=n._handlePool++}get disposed(){return this._disposed}get id(){return this._id}get label(){return this._label}set label(c){this._label=c,this._proxy.$updateGroupLabel(this._sourceControlHandle,this.handle,c)}get hideWhenEmpty(){return this._hideWhenEmpty}set hideWhenEmpty(c){this._hideWhenEmpty=c,this._proxy.$updateGroup(this._sourceControlHandle,this.handle,this.features)}get features(){return{hideWhenEmpty:this.hideWhenEmpty}}get resourceStates(){return[...this._resourceStates]}set resourceStates(c){this._resourceStates=[...c],this._onDidUpdateResourceStates.fire()}getResourceState(c){return this._resourceStatesMap.get(c)}$executeResourceCommand(c,h){const l=this._resourceStatesCommandsMap.get(c);return l?(0,i.asPromise)(()=>this._commands.executeCommand(l.command,...l.arguments||[],h)):Promise.resolve(void 0)}_takeResourceStateSnapshot(){const c=[...this._resourceStates].sort(s),l=(0,S.sortedDiff)(this._resourceSnapshot,c,s).map(A=>{const x=A.toInsert.map(O=>{const F=this._resourceHandlePool++;this._resourceStatesMap.set(F,O);const W=O.resourceUri;let M;if(O.command)if(O.command.command==="vscode.open"||O.command.command==="vscode.diff"){const ne=new C.DisposableStore;M=this._commands.converter.toInternal(O.command,ne),this._resourceStatesDisposablesMap.set(F,ne)}else this._resourceStatesCommandsMap.set(F,O.command);const B=v(O.decorations),U=O.decorations&&v(O.decorations.light)||B,z=O.decorations&&v(O.decorations.dark)||B,K=[U,z],N=O.decorations&&O.decorations.tooltip||"",j=O.decorations&&!!O.decorations.strikeThrough,H=O.decorations&&!!O.decorations.faded,V=O.contextValue||"";return{rawResource:[F,W,K,N,j,H,V,M],handle:F}});return{start:A.start,deleteCount:A.deleteCount,toInsert:x}}),b=l.map(({start:A,deleteCount:x,toInsert:O})=>[A,x,O.map(F=>F.rawResource)]),T=l.reverse();for(const{start:A,deleteCount:x,toInsert:O}of T){const F=O.map(M=>M.handle),W=this._handlesSnapshot.splice(A,x,...F);for(const M of W)this._resourceStatesMap.delete(M),this._resourceStatesCommandsMap.delete(M),this._resourceStatesDisposablesMap.get(M)?.dispose(),this._resourceStatesDisposablesMap.delete(M)}return this._resourceSnapshot=c,b}dispose(){this._disposed=!0,this._onDidDispose.fire()}}n._handlePool=0;class t{constructor(c,h,l,b,T,A){this._extension=c,this._proxy=h,this._commands=l,this._id=b,this._label=T,this._rootUri=A,this._groups=new Map,this._count=void 0,this._quickDiffProvider=void 0,this._commitTemplate=void 0,this._acceptInputDisposables=new C.MutableDisposable,this._acceptInputCommand=void 0,this._actionButtonDisposables=new C.MutableDisposable,this._statusBarDisposables=new C.MutableDisposable,this._statusBarCommands=void 0,this._selected=!1,this._onDidChangeSelection=new L.Emitter,this.onDidChangeSelection=this._onDidChangeSelection.event,this.handle=t._handlePool++,this.createdResourceGroups=new Map,this.updatedResourceGroups=new Set,this._inputBox=new _(c,this._proxy,this.handle),this._proxy.$registerSourceControl(this.handle,b,T,A)}get id(){return this._id}get label(){return this._label}get rootUri(){return this._rootUri}get inputBox(){return this._inputBox}get count(){return this._count}set count(c){this._count!==c&&(this._count=c,this._proxy.$updateSourceControl(this.handle,{count:c}))}get quickDiffProvider(){return this._quickDiffProvider}set quickDiffProvider(c){this._quickDiffProvider=c,this._proxy.$updateSourceControl(this.handle,{hasQuickDiffProvider:!!c})}get commitTemplate(){return this._commitTemplate}set commitTemplate(c){c!==this._commitTemplate&&(this._commitTemplate=c,this._proxy.$updateSourceControl(this.handle,{commitTemplate:c}))}get acceptInputCommand(){return this._acceptInputCommand}set acceptInputCommand(c){this._acceptInputDisposables.value=new C.DisposableStore,this._acceptInputCommand=c;const h=this._commands.converter.toInternal(c,this._acceptInputDisposables.value);this._proxy.$updateSourceControl(this.handle,{acceptInputCommand:h})}get actionButton(){return(0,f.checkProposedApiEnabled)(this._extension,"scmActionButton"),this._actionButton}set actionButton(c){(0,f.checkProposedApiEnabled)(this._extension,"scmActionButton"),this._actionButtonDisposables.value=new C.DisposableStore,this._actionButton=c;const h=c!==void 0?this._commands.converter.toInternal(this._actionButton,this._actionButtonDisposables.value):void 0;this._proxy.$updateSourceControl(this.handle,{actionButton:h??null})}get statusBarCommands(){return this._statusBarCommands}set statusBarCommands(c){if(this._statusBarCommands&&c&&a(this._statusBarCommands,c))return;this._statusBarDisposables.value=new C.DisposableStore,this._statusBarCommands=c;const h=(c||[]).map(l=>this._commands.converter.toInternal(l,this._statusBarDisposables.value));this._proxy.$updateSourceControl(this.handle,{statusBarCommands:h})}get selected(){return this._selected}createResourceGroup(c,h){const l=new n(this._proxy,this._commands,this.handle,c,h),b=L.Event.once(l.onDidDispose)(()=>this.createdResourceGroups.delete(l));return this.createdResourceGroups.set(l,b),this.eventuallyAddResourceGroups(),l}eventuallyAddResourceGroups(){const c=[],h=[];for(const[l,b]of this.createdResourceGroups){b.dispose();const T=l.onDidUpdateResourceStates(()=>{this.updatedResourceGroups.add(l),this.eventuallyUpdateResourceStates()});L.Event.once(l.onDidDispose)(()=>{this.updatedResourceGroups.delete(l),T.dispose(),this._groups.delete(l.handle),this._proxy.$unregisterGroup(this.handle,l.handle)}),c.push([l.handle,l.id,l.label,l.features]);const A=l._takeResourceStateSnapshot();A.length>0&&h.push([l.handle,A]),this._groups.set(l.handle,l)}this._proxy.$registerGroups(this.handle,c,h),this.createdResourceGroups.clear()}eventuallyUpdateResourceStates(){const c=[];this.updatedResourceGroups.forEach(h=>{const l=h._takeResourceStateSnapshot();l.length!==0&&c.push([h.handle,l])}),c.length>0&&this._proxy.$spliceResourceStates(this.handle,c),this.updatedResourceGroups.clear()}getResourceGroup(c){return this._groups.get(c)}setSelectionState(c){this._selected=c,this._onDidChangeSelection.fire(c)}dispose(){this._acceptInputDisposables.dispose(),this._actionButtonDisposables.dispose(),this._statusBarDisposables.dispose(),this._groups.forEach(c=>c.dispose()),this._proxy.$unregisterSourceControl(this.handle)}}t._handlePool=0,je([(0,y.debounce)(100)],t.prototype,"eventuallyAddResourceGroups",null),je([(0,y.debounce)(100)],t.prototype,"eventuallyUpdateResourceStates",null);let o=class Hi{constructor(c,h,l){this._commands=h,this.logService=l,this._sourceControls=new Map,this._sourceControlsByExtension=new Map,this._onDidChangeActiveProvider=new L.Emitter,this._proxy=c.getProxy(k.MainContext.MainThreadSCM),this._telemetry=c.getProxy(k.MainContext.MainThreadTelemetry),h.registerArgumentProcessor({processArgument:b=>{if(b&&b.$mid===3){const T=this._sourceControls.get(b.sourceControlHandle);if(!T)return b;const A=T.getResourceGroup(b.groupHandle);return A?A.getResourceState(b.handle):b}else if(b&&b.$mid===4){const T=this._sourceControls.get(b.sourceControlHandle);return T?T.getResourceGroup(b.groupHandle):b}else if(b&&b.$mid===5){const T=this._sourceControls.get(b.handle);return T||b}return b}})}get onDidChangeActiveProvider(){return this._onDidChangeActiveProvider.event}createSourceControl(c,h,l,b){this.logService.trace("ExtHostSCM#createSourceControl",c.identifier.value,h,l,b),this._telemetry.$publicLog2("api/scm/createSourceControl",{extensionId:c.identifier.value});const T=Hi._handlePool++,A=new t(c,this._proxy,this._commands,h,l,b);this._sourceControls.set(T,A);const x=this._sourceControlsByExtension.get(P.ExtensionIdentifier.toKey(c.identifier))||[];return x.push(A),this._sourceControlsByExtension.set(P.ExtensionIdentifier.toKey(c.identifier),x),A}getLastInputBox(c){this.logService.trace("ExtHostSCM#getLastInputBox",c.identifier.value);const h=this._sourceControlsByExtension.get(P.ExtensionIdentifier.toKey(c.identifier)),l=h&&h[h.length-1];return l&&l.inputBox}$provideOriginalResource(c,h,l){const b=m.URI.revive(h);this.logService.trace("ExtHostSCM#$provideOriginalResource",c,b.toString());const T=this._sourceControls.get(c);return!T||!T.quickDiffProvider||!T.quickDiffProvider.provideOriginalResource?Promise.resolve(null):(0,i.asPromise)(()=>T.quickDiffProvider.provideOriginalResource(b,l)).then(A=>A||null)}$onInputBoxValueChange(c,h){this.logService.trace("ExtHostSCM#$onInputBoxValueChange",c);const l=this._sourceControls.get(c);return l&&l.inputBox.$onInputBoxValueChange(h),Promise.resolve(void 0)}$executeResourceCommand(c,h,l,b){this.logService.trace("ExtHostSCM#$executeResourceCommand",c,h,l);const T=this._sourceControls.get(c);if(!T)return Promise.resolve(void 0);const A=T.getResourceGroup(h);return A?A.$executeResourceCommand(l,b):Promise.resolve(void 0)}$validateInput(c,h,l){this.logService.trace("ExtHostSCM#$validateInput",c);const b=this._sourceControls.get(c);return!b||!b.inputBox.validateInput?Promise.resolve(void 0):(0,i.asPromise)(()=>b.inputBox.validateInput(h,l)).then(T=>{if(!T)return Promise.resolve(void 0);const A=E.MarkdownString.fromStrict(T.message);return A?Promise.resolve([A,T.type]):Promise.resolve(void 0)})}$setSelectedSourceControl(c){return this.logService.trace("ExtHostSCM#$setSelectedSourceControl",c),c!==void 0&&this._sourceControls.get(c)?.setSelectionState(!0),this._selectedSourceControlHandle!==void 0&&this._sourceControls.get(this._selectedSourceControlHandle)?.setSelectionState(!1),this._selectedSourceControlHandle=c,Promise.resolve(void 0)}};o._handlePool=0,o=je([He(2,R.ILogService)],o),e.ExtHostSCM=o});var nt=this&&this.__classPrivateFieldSet||function(Y,e,m,L,y){if(L==="m")throw new TypeError("Private method is not writable");if(L==="a"&&!y)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?Y!==e||!y:!e.has(Y))throw new TypeError("Cannot write private member to an object whose class did not declare it");return L==="a"?y.call(Y,m):y?y.value=m:e.set(Y,m),m},Ne=this&&this.__classPrivateFieldGet||function(Y,e,m,L){if(m==="a"&&!L)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?Y!==e||!L:!e.has(Y))throw new TypeError("Cannot read private member from an object whose class did not declare it");return m==="m"?L:m==="a"?L.call(Y):L?L.value:e.get(Y)};define(pe[249],ve([0,1,7,5,165,6,17,13]),function(Y,e,m,L,y,C,i,k){"use strict";var S,D;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostStatusBar=e.ExtHostStatusBarEntry=void 0;class R{constructor(f,v,w,I,p=m.StatusBarAlignment.Left,s){S.set(this,void 0),D.set(this,void 0),this._disposed=!1,this._visible=!1,this._text="",this._internalCommandRegistration=new C.DisposableStore,nt(this,S,f,"f"),nt(this,D,v,"f"),this._entryId=R.ID_GEN++,this._extension=w,this._id=I,this._alignment=p,this._priority=this.validatePriority(s)}validatePriority(f){if(!!(0,k.isNumber)(f))return f===Number.POSITIVE_INFINITY?Number.MAX_VALUE:f===Number.NEGATIVE_INFINITY?-Number.MAX_VALUE:f}get id(){return this._id??this._extension.identifier.value}get alignment(){return this._alignment}get priority(){return this._priority}get text(){return this._text}get name(){return this._name}get tooltip(){return this._tooltip}get color(){return this._color}get backgroundColor(){return this._backgroundColor}get command(){return this._command?.fromApi}get accessibilityInformation(){return this._accessibilityInformation}set text(f){this._text=f,this.update()}set name(f){this._name=f,this.update()}set tooltip(f){this._tooltip=f,this.update()}set color(f){this._color=f,this.update()}set backgroundColor(f){f&&!R.ALLOWED_BACKGROUND_COLORS.has(f.id)&&(f=void 0),this._backgroundColor=f,this.update()}set command(f){this._command?.fromApi!==f&&(this._internalCommandRegistration.clear(),typeof f=="string"?this._command={fromApi:f,internal:Ne(this,D,"f").toInternal({title:"",command:f},this._internalCommandRegistration)}:f?this._command={fromApi:f,internal:Ne(this,D,"f").toInternal(f,this._internalCommandRegistration)}:this._command=void 0,this.update())}set accessibilityInformation(f){this._accessibilityInformation=f,this.update()}show(){this._visible=!0,this.update()}hide(){clearTimeout(this._timeoutHandle),this._visible=!1,Ne(this,S,"f").$dispose(this._entryId)}update(){this._disposed||!this._visible||(clearTimeout(this._timeoutHandle),this._timeoutHandle=setTimeout(()=>{this._timeoutHandle=void 0;let f;this._extension?this._id?f=`${this._extension.identifier.value}.${this._id}`:f=this._extension.identifier.value:f=this._id;let v;this._name?v=this._name:v=(0,y.localize)(0,null,this._extension.displayName||this._extension.name);let w=this._color;this._backgroundColor&&(w=R.ALLOWED_BACKGROUND_COLORS.get(this._backgroundColor.id));const I=this._tooltip?i.MarkdownString.fromStrict(this._tooltip):void 0;Ne(this,S,"f").$setEntry(this._entryId,f,v,this._text,I,this._command?.internal,w,this._backgroundColor,this._alignment===m.StatusBarAlignment.Left,this._priority,this._accessibilityInformation)},0))}dispose(){this.hide(),this._disposed=!0}}e.ExtHostStatusBarEntry=R,S=new WeakMap,D=new WeakMap,R.ID_GEN=0,R.ALLOWED_BACKGROUND_COLORS=new Map([["statusBarItem.errorBackground",new m.ThemeColor("statusBarItem.errorForeground")],["statusBarItem.warningBackground",new m.ThemeColor("statusBarItem.warningForeground")]]);class P{constructor(f){this._messages=[],this._item=f.createStatusBarEntry(void 0,"status.extensionMessage",m.StatusBarAlignment.Left,Number.MIN_VALUE),this._item.name=(0,y.localize)(1,null)}dispose(){this._messages.length=0,this._item.dispose()}setMessage(f){const v={message:f};return this._messages.unshift(v),this._update(),new m.Disposable(()=>{const w=this._messages.indexOf(v);w>=0&&(this._messages.splice(w,1),this._update())})}_update(){this._messages.length>0?(this._item.text=this._messages[0].message,this._item.show()):this._item.hide()}}class u{constructor(f,v){this._proxy=f.getProxy(L.MainContext.MainThreadStatusBar),this._commands=v,this._statusMessage=new P(this)}createStatusBarEntry(f,v,w,I){return new R(this._proxy,this._commands,f,v,w,I)}setStatusBarMessage(f,v){const w=this._statusMessage.setMessage(f);let I;return typeof v=="number"?I=setTimeout(()=>w.dispose(),v):typeof v!="undefined"&&v.then(()=>w.dispose(),()=>w.dispose()),new m.Disposable(()=>{w.dispose(),clearTimeout(I)})}}e.ExtHostStatusBar=u}),define(pe[91],ve([0,1,5,3,4]),function(Y,e,m,L,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostStorage=e.ExtHostStorage=void 0;class C{constructor(k){this._onDidChangeStorage=new L.Emitter,this.onDidChangeStorage=this._onDidChangeStorage.event,this._proxy=k.getProxy(m.MainContext.MainThreadStorage)}registerExtensionStorageKeysToSync(k,S){this._proxy.$registerExtensionStorageKeysToSync(k,S)}getValue(k,S,D){return this._proxy.$getValue(k,S).then(R=>R||D)}setValue(k,S,D){return this._proxy.$setValue(k,S,D)}$acceptValue(k,S,D){this._onDidChangeStorage.fire({shared:k,key:S,value:D})}}e.ExtHostStorage=C,e.IExtHostStorage=(0,y.createDecorator)("IExtHostStorage")}),define(pe[67],ve([0,1,4,26,11,66,2]),function(Y,e,m,L,y,C,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionStoragePaths=e.IExtensionStoragePaths=void 0,e.IExtensionStoragePaths=(0,m.createDecorator)("IExtensionStoragePaths");let k=class{constructor(D,R,P){this._logService=R,this._extHostFileSystem=P,this._workspace=D.workspace??void 0,this._environment=D.environment,this.whenReady=this._getOrCreateWorkspaceStoragePath().then(u=>this._value=u)}async _getWorkspaceStorageURI(D){return i.URI.joinPath(this._environment.workspaceStorageHome,D)}async _getOrCreateWorkspaceStoragePath(){if(!this._workspace)return Promise.resolve(void 0);const D=this._workspace.id,R=await this._getWorkspaceStorageURI(D);try{return await this._extHostFileSystem.value.stat(R),this._logService.trace("[ExtHostStorage] storage dir already exists",R),R}catch{}try{return this._logService.trace("[ExtHostStorage] creating dir and metadata-file",R),await this._extHostFileSystem.value.createDirectory(R),await this._extHostFileSystem.value.writeFile(i.URI.joinPath(R,"meta.json"),new TextEncoder().encode(JSON.stringify({id:this._workspace.id,configuration:i.URI.revive(this._workspace.configuration)?.toString(),name:this._workspace.name},void 0,2))),R}catch(P){this._logService.error("[ExtHostStorage]",P);return}}workspaceValue(D){if(this._value)return i.URI.joinPath(this._value,D.identifier.value)}globalValue(D){return i.URI.joinPath(this._environment.globalStorageHome,D.identifier.value.toLowerCase())}onWillDeactivateAll(){}};k=je([He(0,L.IExtHostInitDataService),He(1,y.ILogService),He(2,C.IExtHostConsumerFileSystem)],k),e.ExtensionStoragePaths=k}),define(pe[34],ve([0,1,3,5,4,2,14,6,7,166,15,213,21,32,195,86,13,18]),function(Y,e,m,L,y,C,i,k,S,D,R,P,u,E,f,v,w,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WorkerExtHostTerminalService=e.EnvironmentVariableCollection=e.BaseExtHostTerminalService=e.ExtHostPseudoterminal=e.ExtHostTerminal=e.IExtHostTerminalService=void 0,e.IExtHostTerminalService=(0,y.createDecorator)("IExtHostTerminalService");class p{constructor(d,c,h,l){this._proxy=d,this._id=c,this._creationOptions=h,this._name=l,this._disposed=!1,this._state={isInteractedWith:!1},this.isOpen=!1,this._creationOptions=Object.freeze(this._creationOptions),this._pidPromise=new Promise(T=>this._pidPromiseComplete=T);const b=this;this.value={get name(){return b._name||""},get processId(){return b._pidPromise},get creationOptions(){return b._creationOptions},get exitStatus(){return b._exitStatus},get state(){return b._state},sendText(T,A=!0){b._checkDisposed(),b._proxy.$sendText(b._id,T,A)},show(T){b._checkDisposed(),b._proxy.$show(b._id,T)},hide(){b._checkDisposed(),b._proxy.$hide(b._id)},dispose(){b._disposed||(b._disposed=!0,b._proxy.$dispose(b._id))},get dimensions(){if(!(b._cols===void 0||b._rows===void 0))return{columns:b._cols,rows:b._rows}}}}async create(d,c){if(typeof this._id!="string")throw new Error("Terminal has already been created");await this._proxy.$createTerminal(this._id,{name:d.name,shellPath:(0,w.withNullAsUndefined)(d.shellPath),shellArgs:(0,w.withNullAsUndefined)(d.shellArgs),cwd:(0,w.withNullAsUndefined)(d.cwd),env:(0,w.withNullAsUndefined)(d.env),icon:(0,w.withNullAsUndefined)(n(d.iconPath)),color:v.ThemeColor.isThemeColor(d.color)?d.color.id:void 0,initialText:(0,w.withNullAsUndefined)(d.message),strictEnv:(0,w.withNullAsUndefined)(d.strictEnv),hideFromUser:(0,w.withNullAsUndefined)(d.hideFromUser),isFeatureTerminal:(0,w.withNullAsUndefined)(c?.isFeatureTerminal),isExtensionOwnedTerminal:!0,useShellEnvironment:(0,w.withNullAsUndefined)(c?.useShellEnvironment),location:c?.location||this._serializeParentTerminal(d.location,c?.resolvedExtHostIdentifier)})}async createExtensionTerminal(d,c,h,l){if(typeof this._id!="string")throw new Error("Terminal has already been created");if(await this._proxy.$createTerminal(this._id,{name:this._name,isExtensionCustomPtyTerminal:!0,icon:h,color:v.ThemeColor.isThemeColor(l)?l.id:void 0,location:this._serializeParentTerminal(d,c)}),typeof this._id=="string")throw new Error("Terminal creation failed");return this._id}_serializeParentTerminal(d,c){return typeof d=="object"?"parentTerminal"in d&&d.parentTerminal&&c?{parentTerminal:c}:"viewColumn"in d?{viewColumn:d.viewColumn,preserveFocus:d.preserveFocus}:void 0:d}_checkDisposed(){if(this._disposed)throw new Error("Terminal has already been disposed")}set name(d){this._name=d}setExitCode(d){this._exitStatus=Object.freeze({code:d})}setDimensions(d,c){return d===this._cols&&c===this._rows||d===0||c===0?!1:(this._cols=d,this._rows=c,!0)}setInteractedWith(){return this._state.isInteractedWith?!1:(this._state={isInteractedWith:!0},!0)}_setProcessId(d){this._pidPromiseComplete?(this._pidPromiseComplete(d),this._pidPromiseComplete=void 0):this._pidPromise.then(c=>{c!==d&&(this._pidPromise=Promise.resolve(d))})}}e.ExtHostTerminal=p;class s{constructor(d){this._pty=d,this.id=0,this.shouldPersist=!1,this._capabilities=[],this._onProcessData=new m.Emitter,this.onProcessData=this._onProcessData.event,this._onProcessReady=new m.Emitter,this._onDidChangeProperty=new m.Emitter,this.onDidChangeProperty=this._onDidChangeProperty.event,this._onProcessExit=new m.Emitter,this.onProcessExit=this._onProcessExit.event}get capabilities(){return this._capabilities}get onProcessReady(){return this._onProcessReady.event}refreshProperty(d){throw new Error(`refreshProperty is not suppported in extension owned terminals. property: ${d}`)}updateProperty(d,c){throw new Error(`updateProperty is not suppported in extension owned terminals. property: ${d}, value: ${c}`)}async start(){}shutdown(){this._pty.close()}input(d){this._pty.handleInput?.(d)}resize(d,c){this._pty.setDimensions?.({columns:d,rows:c})}async processBinary(d){}acknowledgeDataEvent(d){}async setUnicodeVersion(d){}getInitialCwd(){return Promise.resolve("")}getCwd(){return Promise.resolve("")}getLatency(){return Promise.resolve(0)}startSendingEvents(d){this._pty.onDidWrite(c=>this._onProcessData.fire(c)),this._pty.onDidClose?.((c=void 0)=>{this._onProcessExit.fire(c===void 0?void 0:c)}),this._pty.onDidOverrideDimensions?.(c=>{c&&this._onDidChangeProperty.fire({type:"overrideDimensions",value:{cols:c.columns,rows:c.rows}})}),this._pty.onDidChangeName?.(c=>{this._onDidChangeProperty.fire({type:"title",value:c})}),this._pty.open(d||void 0),d&&this._pty.setDimensions?.(d),this._onProcessReady.fire({pid:-1,cwd:"",capabilities:this._capabilities})}}e.ExtHostPseudoterminal=s;let r=1,g=class extends k.Disposable{constructor(d,c){super();this._terminals=[],this._terminalProcesses=new Map,this._terminalProcessDisposables={},this._extensionTerminalAwaitingStart={},this._getTerminalPromises={},this._environmentVariableCollections=new Map,this._linkProviders=new Set,this._profileProviders=new Map,this._terminalLinkCache=new Map,this._terminalLinkCancellationSource=new Map,this._onDidCloseTerminal=new m.Emitter,this.onDidCloseTerminal=this._onDidCloseTerminal.event,this._onDidOpenTerminal=new m.Emitter,this.onDidOpenTerminal=this._onDidOpenTerminal.event,this._onDidChangeActiveTerminal=new m.Emitter,this.onDidChangeActiveTerminal=this._onDidChangeActiveTerminal.event,this._onDidChangeTerminalDimensions=new m.Emitter,this.onDidChangeTerminalDimensions=this._onDidChangeTerminalDimensions.event,this._onDidChangeTerminalState=new m.Emitter,this.onDidChangeTerminalState=this._onDidChangeTerminalState.event,this._proxy=c.getProxy(L.MainContext.MainThreadTerminalService),this._bufferer=new f.TerminalDataBufferer(this._proxy.$sendProcessData),this._onDidWriteTerminalData=new m.Emitter({onFirstListenerAdd:()=>this._proxy.$startSendingDataEvents(),onLastListenerRemove:()=>this._proxy.$stopSendingDataEvents()}),this._proxy.$registerProcessSupport(d),this._register({dispose:()=>{for(const[h,l]of this._terminalProcesses)l.shutdown(!0)}})}get activeTerminal(){return this._activeTerminal?.value}get terminals(){return this._terminals.map(d=>d.value)}get onDidWriteTerminalData(){return this._onDidWriteTerminalData.event}getDefaultShell(d){return(d?this._defaultAutomationProfile:this._defaultProfile)?.path||""}getDefaultShellArgs(d){return(d?this._defaultAutomationProfile:this._defaultProfile)?.args||[]}createExtensionTerminal(d,c){const h=new p(this._proxy,(0,E.generateUuid)(),d,d.name),l=new s(d.pty);return h.createExtensionTerminal(d.location,this._serializeParentTerminal(d,c).resolvedExtHostIdentifier,n(d.iconPath),t(d.color)).then(b=>{const T=this._setupExtHostProcessListeners(b,l);this._terminalProcessDisposables[b]=T}),this._terminals.push(h),h.value}_serializeParentTerminal(d,c){if(c=c||{},d.location&&typeof d.location=="object"&&"parentTerminal"in d.location){const h=d.location.parentTerminal;if(h){const l=this._terminals.find(b=>b.value===h);l&&(c.resolvedExtHostIdentifier=l._id)}}else d.location&&typeof d.location!="object"?c.location=d.location:c.location&&typeof c.location=="object"&&"splitActiveTerminal"in c.location&&(c.location={splitActiveTerminal:!0});return c}attachPtyToTerminal(d,c){if(!this._getTerminalById(d))throw new Error(`Cannot resolve terminal with id ${d} for virtual process`);const l=new s(c),b=this._setupExtHostProcessListeners(d,l);this._terminalProcessDisposables[d]=b}async $acceptActiveTerminalChanged(d){const c=this._activeTerminal;if(d===null){this._activeTerminal=void 0,c!==this._activeTerminal&&this._onDidChangeActiveTerminal.fire(this._activeTerminal);return}const h=this._getTerminalById(d);h&&(this._activeTerminal=h,c!==this._activeTerminal&&this._onDidChangeActiveTerminal.fire(this._activeTerminal.value))}async $acceptTerminalProcessData(d,c){const h=this._getTerminalById(d);h&&this._onDidWriteTerminalData.fire({terminal:h.value,data:c})}async $acceptTerminalDimensions(d,c,h){const l=this._getTerminalById(d);l&&l.setDimensions(c,h)&&this._onDidChangeTerminalDimensions.fire({terminal:l.value,dimensions:l.value.dimensions})}async $acceptTerminalMaximumDimensions(d,c,h){this._terminalProcesses.get(d)?.resize(c,h)}async $acceptTerminalTitleChange(d,c){const h=this._getTerminalById(d);h&&(h.name=c)}async $acceptTerminalClosed(d,c){const h=this._getTerminalObjectIndexById(this._terminals,d);if(h!==null){const l=this._terminals.splice(h,1)[0];l.setExitCode(c),this._onDidCloseTerminal.fire(l.value)}}$acceptTerminalOpened(d,c,h,l){if(c){const A=this._getTerminalObjectIndexById(this._terminals,c);if(A!==null){this._terminals[A]._id=d,this._onDidOpenTerminal.fire(this.terminals[A]),this._terminals[A].isOpen=!0;return}}const b={name:l.name,shellPath:l.executable,shellArgs:l.args,cwd:typeof l.cwd=="string"?l.cwd:C.URI.revive(l.cwd),env:l.env,hideFromUser:l.hideFromUser},T=new p(this._proxy,d,b,h);this._terminals.push(T),this._onDidOpenTerminal.fire(T.value),T.isOpen=!0}async $acceptTerminalProcessId(d,c){const h=this._getTerminalById(d);h&&h._setProcessId(c)}async $startExtensionTerminal(d,c){const h=this._getTerminalById(d);if(!h)return{message:(0,D.localize)(0,null,d)};h.isOpen||await new Promise(b=>{const T=this.onDidOpenTerminal(async A=>{A===h.value&&(T.dispose(),b())})});const l=this._terminalProcesses.get(d);l?l.startSendingEvents(c):this._extensionTerminalAwaitingStart[d]={initialDimensions:c}}_setupExtHostProcessListeners(d,c){const h=new k.DisposableStore;h.add(c.onProcessReady(b=>this._proxy.$sendProcessReady(d,b.pid,b.cwd))),h.add(c.onDidChangeProperty(b=>this._proxy.$sendProcessProperty(d,b))),this._bufferer.startBuffering(d,c.onProcessData),h.add(c.onProcessExit(b=>this._onProcessExit(d,b))),this._terminalProcesses.set(d,c);const l=this._extensionTerminalAwaitingStart[d];return l&&c instanceof s&&(c.startSendingEvents(l.initialDimensions),delete this._extensionTerminalAwaitingStart[d]),h}$acceptProcessAckDataEvent(d,c){this._terminalProcesses.get(d)?.acknowledgeDataEvent(c)}$acceptProcessInput(d,c){this._terminalProcesses.get(d)?.input(c)}$acceptTerminalInteraction(d){const c=this._getTerminalById(d);c?.setInteractedWith()&&this._onDidChangeTerminalState.fire(c.value)}$acceptProcessResize(d,c,h){try{this._terminalProcesses.get(d)?.resize(c,h)}catch(l){if(l.code!=="EPIPE"&&l.code!=="ERR_IPC_CHANNEL_CLOSED")throw l}}$acceptProcessShutdown(d,c){this._terminalProcesses.get(d)?.shutdown(c)}$acceptProcessRequestInitialCwd(d){this._terminalProcesses.get(d)?.getInitialCwd().then(c=>this._proxy.$sendProcessProperty(d,{type:"initialCwd",value:c}))}$acceptProcessRequestCwd(d){this._terminalProcesses.get(d)?.getCwd().then(c=>this._proxy.$sendProcessProperty(d,{type:"cwd",value:c}))}$acceptProcessRequestLatency(d){return d}registerLinkProvider(d){return this._linkProviders.add(d),this._linkProviders.size===1&&this._proxy.$startLinkProvider(),new S.Disposable(()=>{this._linkProviders.delete(d),this._linkProviders.size===0&&this._proxy.$stopLinkProvider()})}registerProfileProvider(d,c,h){if(this._profileProviders.has(c))throw new Error(`Terminal profile provider "${c}" already registered`);return this._profileProviders.set(c,h),this._proxy.$registerProfileProvider(c,d.identifier.value),new S.Disposable(()=>{this._profileProviders.delete(c),this._proxy.$unregisterProfileProvider(c)})}async $createContributedProfileTerminal(d,c){const h=new u.CancellationTokenSource().token;let l=await this._profileProviders.get(d)?.provideTerminalProfile(h);if(!h.isCancellationRequested){if(l&&!("options"in l)&&(l={options:l}),!l||!("options"in l))throw new Error(`No terminal profile options provided for id "${d}"`);if("pty"in l.options){this.createExtensionTerminal(l.options,c);return}this.createTerminalFromOptions(l.options,c)}}async $provideLinks(d,c){const h=this._getTerminalById(d);if(!h)return[];this._terminalLinkCache.delete(d);const l=this._terminalLinkCancellationSource.get(d);l&&l.dispose(!0);const b=new u.CancellationTokenSource;this._terminalLinkCancellationSource.set(d,b);const T=[],A={terminal:h.value,line:c},x=[];for(const W of this._linkProviders)x.push(I.Promises.withAsyncBody(async M=>{b.token.onCancellationRequested(()=>M({provider:W,links:[]}));const B=await W.provideTerminalLinks(A,b.token)||[];b.token.isCancellationRequested||M({provider:W,links:B})}));const O=await Promise.all(x);if(b.token.isCancellationRequested)return[];const F=new Map;for(const W of O)W&&W.links.length>0&&T.push(...W.links.map(M=>{const B={id:r++,startIndex:M.startIndex,length:M.length,label:M.tooltip};return F.set(B.id,{provider:W.provider,link:M}),B}));return this._terminalLinkCache.set(d,F),T}$activateLink(d,c){const h=this._terminalLinkCache.get(d)?.get(c);!h||h.provider.handleTerminalLink(h.link)}_onProcessExit(d,c){this._bufferer.stopBuffering(d),this._terminalProcesses.delete(d),delete this._extensionTerminalAwaitingStart[d];const h=this._terminalProcessDisposables[d];h&&(h.dispose(),delete this._terminalProcessDisposables[d]),this._proxy.$sendProcessExit(d,c)}_getTerminalById(d){return this._getTerminalObjectById(this._terminals,d)}_getTerminalObjectById(d,c){const h=this._getTerminalObjectIndexById(d,c);return h!==null?d[h]:null}_getTerminalObjectIndexById(d,c){let h=null;return d.some((l,b)=>l._id===c?(h=b,!0):!1),h}getEnvironmentVariableCollection(d){let c=this._environmentVariableCollections.get(d.identifier.value);return c||(c=new a,this._setEnvironmentVariableCollection(d.identifier.value,c)),c}_syncEnvironmentVariableCollection(d,c){const h=(0,P.serializeEnvironmentVariableCollection)(c.map);this._proxy.$setEnvironmentVariableCollection(d,c.persistent,h.length===0?void 0:h)}$initEnvironmentVariableCollections(d){d.forEach(c=>{const h=c[0],l=new a(c[1]);this._setEnvironmentVariableCollection(h,l)})}$acceptDefaultProfile(d,c){this._defaultProfile=d,this._defaultAutomationProfile=c}_setEnvironmentVariableCollection(d,c){this._environmentVariableCollections.set(d,c),c.onDidChangeCollection(()=>{this._syncEnvironmentVariableCollection(d,c)})}};g=je([He(1,i.IExtHostRpcService)],g),e.BaseExtHostTerminalService=g;class a{constructor(d){this.map=new Map,this._persistent=!0,this._onDidChangeCollection=new m.Emitter,this.map=new Map(d)}get persistent(){return this._persistent}set persistent(d){this._persistent=d,this._onDidChangeCollection.fire()}get onDidChangeCollection(){return this._onDidChangeCollection&&this._onDidChangeCollection.event}get size(){return this.map.size}replace(d,c){this._setIfDiffers(d,{value:c,type:S.EnvironmentVariableMutatorType.Replace})}append(d,c){this._setIfDiffers(d,{value:c,type:S.EnvironmentVariableMutatorType.Append})}prepend(d,c){this._setIfDiffers(d,{value:c,type:S.EnvironmentVariableMutatorType.Prepend})}_setIfDiffers(d,c){const h=this.map.get(d);(!h||h.value!==c.value||h.type!==c.type)&&(this.map.set(d,c),this._onDidChangeCollection.fire())}get(d){return this.map.get(d)}forEach(d,c){this.map.forEach((h,l)=>d.call(c,l,h,this))}delete(d){this.map.delete(d),this._onDidChangeCollection.fire()}clear(){this.map.clear(),this._onDidChangeCollection.fire()}}e.EnvironmentVariableCollection=a;let _=class extends g{constructor(d){super(!1,d)}createTerminal(d,c,h){throw new R.NotSupportedError}createTerminalFromOptions(d,c){throw new R.NotSupportedError}};_=je([He(0,i.IExtHostRpcService)],_),e.WorkerExtHostTerminalService=_;function n(o){if(!(!o||typeof o=="string"))return"id"in o?{id:o.id,color:o.color}:o}function t(o){return v.ThemeColor.isThemeColor(o)?o:void 0}});var nt=this&&this.__classPrivateFieldSet||function(Y,e,m,L,y){if(L==="m")throw new TypeError("Private method is not writable");if(L==="a"&&!y)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?Y!==e||!y:!e.has(Y))throw new TypeError("Cannot write private member to an object whose class did not declare it");return L==="a"?y.call(Y,m):y?y.value=m:e.set(Y,m),m},Ne=this&&this.__classPrivateFieldGet||function(Y,e,m,L){if(m==="a"&&!L)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?Y!==e||!L:!e.has(Y))throw new TypeError("Cannot read private member from an object whose class did not declare it");return m==="m"?L:m==="a"?L.call(Y):L?L.value:e.get(Y)};define(pe[250],ve([0,1,16,22,21,3,74,47,6,25,13,32,5,14,63,17,7,221,126,89]),function(Y,e,m,L,y,C,i,k,S,D,R,P,u,E,f,v,w,I,p,s){"use strict";var r;Object.defineProperty(e,"__esModule",{value:!0}),e.TestRunProfileImpl=e.MirroredTestCollection=e.TestRunDto=e.TestRunCoordinator=e.ExtHostTesting=void 0;let g=class{constructor(A,x){this.resultsChangedEmitter=new C.Emitter,this.controllers=new Map,this.onResultsChanged=this.resultsChangedEmitter.event,this.results=[],this.proxy=A.getProxy(u.MainContext.MainThreadTesting),this.observer=new h(this.proxy),this.runTracker=new _(this.proxy),x.registerArgumentProcessor({processArgument:O=>O?.$mid===13?v.TestItem.toItemFromContext(O):O})}createTestController(A,x){if(this.controllers.has(A))throw new Error(`Attempt to insert a duplicate controller with ID "${A}"`);const O=new S.DisposableStore,F=O.add(new I.SingleUseTestCollection(A));F.root.label=x;const W=new Map,M=this.proxy,B={items:F.root.children,get label(){return x},set label(z){x=z,F.root.label=z,M.$updateControllerLabel(A,x)},get id(){return A},createRunProfile:(z,K,N,j,H)=>{let V=(0,k.hash)(z);for(;W.has(V);)V++;const q=new l(this.proxy,A,V,z,K,N,j,H);return W.set(V,q),q},createTestItem(z,K,N){return new f.TestItemImpl(A,z,K,N)},createTestRun:(z,K,N=!0)=>this.runTracker.createTestRun(A,F,z,K,N),set resolveHandler(z){F.resolveHandler=z},get resolveHandler(){return F.resolveHandler},dispose:()=>{O.dispose()}};B.createRunConfiguration=B.createRunProfile,M.$registerTestController(A,x),O.add((0,S.toDisposable)(()=>M.$unregisterTestController(A)));const U={controller:B,collection:F,profiles:W};return this.controllers.set(A,U),O.add((0,S.toDisposable)(()=>this.controllers.delete(A))),O.add(F.onDidGenerateDiff(z=>M.$publishDiff(A,z))),B}createTestObserver(){return this.observer.checkout()}async runTests(A,x=y.CancellationToken.None){const O=n(A);if(!O)throw new Error("The request passed to `vscode.test.runTests` must include a profile");const F=this.controllers.get(O.controllerId);if(!F)throw new Error("Controller not found");await this.proxy.$runTests({targets:[{testIds:A.include?.map(W=>W.id)??[F.collection.root.id],profileGroup:b[O.kind],profileId:O.profileId,controllerId:O.controllerId}],exclude:A.exclude?.map(W=>W.id)},x)}$provideFileCoverage(A,x,O){return(0,m.mapFind)(this.runTracker.trackers,W=>W.id===A?W.getCoverage(x):void 0)?.provideFileCoverage(O)??Promise.resolve([])}$resolveFileCoverage(A,x,O,F){return(0,m.mapFind)(this.runTracker.trackers,M=>M.id===A?M.getCoverage(x):void 0)?.resolveFileCoverage(O,F)??Promise.resolve([])}$configureRunProfile(A,x){this.controllers.get(A)?.profiles.get(x)?.configureHandler?.()}$publishTestResults(A){this.results=Object.freeze(A.map(x=>(0,D.deepFreeze)(v.TestResults.to(x))).concat(this.results).sort((x,O)=>O.completedAt-x.completedAt).slice(0,32)),this.resultsChangedEmitter.fire()}async $expandTest(A,x){const O=this.controllers.get(s.TestId.fromString(A).controllerId)?.collection;O&&(await O.expand(A,x<0?Infinity:x),O.flushDiff())}$acceptDiff(A){this.observer.applyDiff(A)}async $runControllerTests(A,x){const O=this.controllers.get(A.controllerId);if(!O)return;const{collection:F,profiles:W}=O,M=W.get(A.profileId);if(!M)return;const B=A.testIds.map(N=>F.tree.get(N)).filter(R.isDefined),U=A.excludeExtIds.map(N=>O.collection.tree.get(N)).filter(R.isDefined).filter(N=>B.some(j=>j.fullId.compare(N.fullId)===2));if(!B.length)return;const z=new w.TestRunRequest(B.some(N=>N.actual instanceof f.TestItemRootImpl)?void 0:B.map(N=>N.actual),U.map(N=>N.actual),M),K=this.runTracker.prepareForMainThreadTestRun(z,t.fromInternal(A,O.collection),x);try{await M.runHandler(z,x)}finally{K.isRunning&&!x.isCancellationRequested&&await C.Event.toPromise(K.onEnd),K.dispose()}}$cancelExtensionTestRun(A){A===void 0?this.runTracker.cancelAllRuns():this.runTracker.cancelRunById(A)}};g=je([He(0,E.IExtHostRpcService)],g),e.ExtHostTesting=g;class a extends S.Disposable{constructor(A,x,O){super();this.dto=A,this.proxy=x,this.tasks=new Map,this.sharedTestIds=new Set,this.endEmitter=this._register(new C.Emitter),this.disposed=!1,this.onEnd=this.endEmitter.event,this.cts=this._register(new y.CancellationTokenSource(O)),this._register(this.cts.token.onCancellationRequested(()=>{for(const{run:F}of this.tasks.values())F.end()}))}get isRunning(){return this.tasks.size>0}get id(){return this.dto.id}getCoverage(A){return this.tasks.get(A)?.coverage}createRun(A){const x=this.dto.id,O=this.dto.controllerId,F=(0,P.generateUuid)(),W=new o(this.proxy,x,F),M=K=>(N,...j)=>{if(U){console.warn(`Setting the state of test "${N.id}" is a no-op after the run ends.`);return}!this.dto.isIncluded(N)||(this.ensureTestIsKnown(N),K(N,...j))},B=(K,N)=>{const j=N instanceof Array?N.map(v.TestMessage.from):[v.TestMessage.from(N)];if(K.uri&&K.range){const H={range:v.Range.from(K.range),uri:K.uri};for(const V of j)V.location=V.location||H}this.proxy.$appendTestMessagesInRun(x,F,s.TestId.fromExtHostTestItem(K,O).toString(),j)};let U=!1;const z={isPersisted:this.dto.isPersisted,token:this.cts.token,name:A,get coverageProvider(){return W.coverageProvider},set coverageProvider(K){W.coverageProvider=K},enqueued:M(K=>{this.proxy.$updateTestStateInRun(x,F,s.TestId.fromExtHostTestItem(K,O).toString(),1)}),skipped:M(K=>{this.proxy.$updateTestStateInRun(x,F,s.TestId.fromExtHostTestItem(K,O).toString(),5)}),started:M(K=>{this.proxy.$updateTestStateInRun(x,F,s.TestId.fromExtHostTestItem(K,O).toString(),2)}),errored:M((K,N,j)=>{B(K,N),this.proxy.$updateTestStateInRun(x,F,s.TestId.fromExtHostTestItem(K,O).toString(),6,j)}),failed:M((K,N,j)=>{B(K,N),this.proxy.$updateTestStateInRun(x,F,s.TestId.fromExtHostTestItem(K,O).toString(),4,j)}),passed:M((K,N)=>{this.proxy.$updateTestStateInRun(x,F,s.TestId.fromExtHostTestItem(K,this.dto.controllerId).toString(),3,N)}),appendOutput:(K,N,j)=>{U||(j&&(this.dto.isIncluded(j)?this.ensureTestIsKnown(j):j=void 0),this.proxy.$appendOutputToRun(x,F,L.VSBuffer.fromString(K),N&&v.location.from(N),j&&s.TestId.fromExtHostTestItem(j,O).toString()))},end:()=>{U||(U=!0,this.proxy.$finishedTestRunTask(x,F),this.tasks.delete(F),this.isRunning||this.dispose())}};return this.tasks.set(F,{run:z,coverage:W}),this.proxy.$startedTestRunTask(x,{id:F,name:A,running:!0}),z}dispose(){this.disposed||(this.disposed=!0,this.endEmitter.fire(),this.cts.cancel(),super.dispose())}ensureTestIsKnown(A){if(!(A instanceof f.TestItemImpl))throw new f.InvalidTestItemError(A.id);if(this.sharedTestIds.has(s.TestId.fromExtHostTestItem(A,this.dto.controllerId).toString()))return;const x=[],O=this.dto.colllection.root;for(;;){const F=v.TestItem.from(A);if(x.unshift(F),this.sharedTestIds.has(F.extId)||(this.sharedTestIds.add(F.extId),A===O))break;A=A.parent||O}this.proxy.$addTestsToRun(this.dto.controllerId,this.dto.id,x)}}class _{constructor(A){this.proxy=A,this.tracked=new Map}get trackers(){return this.tracked.values()}prepareForMainThreadTestRun(A,x,O){return this.getTracker(A,x,O)}cancelRunById(A){for(const x of this.tracked.values())if(x.id===A){x.dispose();return}}cancelAllRuns(){for(const A of this.tracked.values())A.dispose()}createTestRun(A,x,O,F,W){const M=this.tracked.get(O);if(M)return M.createRun(F);const B=t.fromPublic(A,x,O,W),U=n(O);this.proxy.$startedExtensionTestRun({controllerId:A,profile:U&&{group:b[U.kind],id:U.profileId},exclude:O.exclude?.map(K=>K.id)??[],id:B.id,include:O.include?.map(K=>K.id)??[x.root.id],persist:W});const z=this.getTracker(O,B);return z.onEnd(()=>this.proxy.$finishedExtensionTestRun(B.id)),z.createRun(F)}getTracker(A,x,O){const F=new a(x,this.proxy,O);return this.tracked.set(A,F),F.onEnd(()=>this.tracked.delete(A)),F}}e.TestRunCoordinator=_;const n=T=>{if(!!T.profile){if(!(T.profile instanceof l))throw new Error("TestRunRequest.profile is not an instance created from TestController.createRunProfile");return T.profile}};class t{constructor(A,x,O,F,W,M){this.controllerId=A,this.id=x,this.isPersisted=W,this.colllection=M,this.includePrefix=O.map(B=>B+"\0"),this.excludePrefix=F.map(B=>B+"\0")}static fromPublic(A,x,O,F){return new t(A,(0,P.generateUuid)(),O.include?.map(W=>s.TestId.fromExtHostTestItem(W,A).toString())??[A],O.exclude?.map(W=>s.TestId.fromExtHostTestItem(W,A).toString())??[],F,x)}static fromInternal(A,x){return new t(A.controllerId,A.runId,A.testIds,A.excludeExtIds,!0,x)}isIncluded(A){const x=s.TestId.fromExtHostTestItem(A,this.controllerId).toString()+"\0";for(const O of this.excludePrefix)if(x===O||x.startsWith(O))return!1;for(const O of this.includePrefix)if(x===O||x.startsWith(O))return!0;return!1}}e.TestRunDto=t;class o{constructor(A,x,O){this.proxy=A,this.runId=x,this.taskId=O}set coverageProvider(A){if(this._coverageProvider)throw new Error("The TestCoverageProvider cannot be replaced after being provided");!A||(this._coverageProvider=A,this.proxy.$signalCoverageAvailable(this.runId,this.taskId))}get coverageProvider(){return this._coverageProvider}async provideFileCoverage(A){if(!this._coverageProvider)return[];this.fileCoverage||(this.fileCoverage=(async()=>this._coverageProvider.provideFileCoverage(A))());try{return(await this.fileCoverage)?.map(v.TestCoverage.fromFile)??[]}catch(x){throw this.fileCoverage=void 0,x}}async resolveFileCoverage(A,x){const O=await this.fileCoverage;let F=O?.[A];return!this._coverageProvider||!O||!F?[]:(F.detailedCoverage||(F=O[A]=await this._coverageProvider.resolveFileCoverage?.(F,x)??F),F.detailedCoverage?.map(v.TestCoverage.fromDetailed)??[])}}class d extends p.IncrementalChangeCollector{constructor(A){super();this.emitter=A,this.added=new Set,this.updated=new Set,this.removed=new Set,this.alreadyRemoved=new Set}get isEmpty(){return this.added.size===0&&this.removed.size===0&&this.updated.size===0}add(A){this.added.add(A)}update(A){Object.assign(A.revived,v.TestItem.toPlain(A.item)),this.added.has(A)||this.updated.add(A)}remove(A){if(this.added.has(A)){this.added.delete(A);return}if(this.updated.delete(A),A.parent&&this.alreadyRemoved.has(A.parent)){this.alreadyRemoved.add(A.item.extId);return}this.removed.add(A)}getChangeEvent(){const{added:A,updated:x,removed:O}=this;return{get added(){return[...A].map(F=>F.revived)},get updated(){return[...x].map(F=>F.revived)},get removed(){return[...O].map(F=>F.revived)}}}complete(){this.isEmpty||this.emitter.fire(this.getChangeEvent())}}class c extends p.AbstractIncrementalTestCollection{constructor(){super(...arguments);this.changeEmitter=new C.Emitter,this.onDidChangeTests=this.changeEmitter.event}get rootTests(){return super.roots}getMirroredTestDataById(A){return this.items.get(A)}getMirroredTestDataByReference(A){return this.items.get(A.id)}createItem(A,x){return{...A,revived:v.TestItem.toPlain(A.item),depth:x?x.depth+1:0,children:new Set}}createChangeCollector(){return new d(this.changeEmitter)}}e.MirroredTestCollection=c;class h{constructor(A){this.proxy=A}checkout(){this.current||(this.current=this.createObserverData());const A=this.current;return A.observers++,{onDidChangeTest:A.tests.onDidChangeTests,get tests(){return[...A.tests.rootTests].map(x=>x.revived)},dispose:(0,i.once)(()=>{--A.observers==0&&(this.proxy.$unsubscribeFromDiffs(),this.current=void 0)})}}getMirroredTestDataByReference(A){return this.current?.tests.getMirroredTestDataByReference(A)}applyDiff(A){this.current?.tests.apply(A)}createObserverData(){const A=new c;return this.proxy.$subscribeToDiffs(),{observers:0,tests:A}}}class l{constructor(A,x,O,F,W,M,B=!1,U=void 0){this.controllerId=x,this.profileId=O,this._label=F,this.kind=W,this.runHandler=M,this._isDefault=B,this._tag=U,r.set(this,void 0),nt(this,r,A,"f");const z=b[W];if(typeof z!="number")throw new Error(`Unknown TestRunProfile.group ${W}`);Ne(this,r,"f").$publishTestRunProfile({profileId:O,controllerId:x,tag:U?v.TestTag.namespace(this.controllerId,U.id):null,label:F,group:z,isDefault:B,hasConfigurationHandler:!1})}get label(){return this._label}set label(A){A!==this._label&&(this._label=A,Ne(this,r,"f").$updateTestRunConfig(this.controllerId,this.profileId,{label:A}))}get isDefault(){return this._isDefault}set isDefault(A){A!==this._isDefault&&(this._isDefault=A,Ne(this,r,"f").$updateTestRunConfig(this.controllerId,this.profileId,{isDefault:A}))}get tag(){return this._tag}set tag(A){A?.id!==this._tag?.id&&(this._tag=A,Ne(this,r,"f").$updateTestRunConfig(this.controllerId,this.profileId,{tag:A?v.TestTag.namespace(this.controllerId,A.id):null}))}get configureHandler(){return this._configureHandler}set configureHandler(A){A!==this._configureHandler&&(this._configureHandler=A,Ne(this,r,"f").$updateTestRunConfig(this.controllerId,this.profileId,{hasConfigurationHandler:!!A}))}dispose(){Ne(this,r,"f").$removeTestProfile(this.controllerId,this.profileId)}}e.TestRunProfileImpl=l,r=new WeakMap;const b={[w.TestRunProfileKind.Coverage]:8,[w.TestRunProfileKind.Debug]:4,[w.TestRunProfileKind.Run]:2}}),define(pe[251],ve([0,1,3,16,5,129,17,7]),function(Y,e,m,L,y,C,i,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostEditors=void 0;class S{constructor(R,P){this._extHostDocumentsAndEditors=P,this._onDidChangeTextEditorSelection=new m.Emitter,this._onDidChangeTextEditorOptions=new m.Emitter,this._onDidChangeTextEditorVisibleRanges=new m.Emitter,this._onDidChangeTextEditorViewColumn=new m.Emitter,this._onDidChangeActiveTextEditor=new m.Emitter,this._onDidChangeVisibleTextEditors=new m.Emitter,this.onDidChangeTextEditorSelection=this._onDidChangeTextEditorSelection.event,this.onDidChangeTextEditorOptions=this._onDidChangeTextEditorOptions.event,this.onDidChangeTextEditorVisibleRanges=this._onDidChangeTextEditorVisibleRanges.event,this.onDidChangeTextEditorViewColumn=this._onDidChangeTextEditorViewColumn.event,this.onDidChangeActiveTextEditor=this._onDidChangeActiveTextEditor.event,this.onDidChangeVisibleTextEditors=this._onDidChangeVisibleTextEditors.event,this._proxy=R.getProxy(y.MainContext.MainThreadTextEditors),this._extHostDocumentsAndEditors.onDidChangeVisibleTextEditors(u=>this._onDidChangeVisibleTextEditors.fire(u)),this._extHostDocumentsAndEditors.onDidChangeActiveTextEditor(u=>this._onDidChangeActiveTextEditor.fire(u))}getActiveTextEditor(){return this._extHostDocumentsAndEditors.activeEditor()}getVisibleTextEditors(R){const P=this._extHostDocumentsAndEditors.allEditors();return R?P:P.map(u=>u.value)}async showTextDocument(R,P,u){let E;typeof P=="number"?E={position:i.ViewColumn.from(P),preserveFocus:u}:typeof P=="object"?E={position:i.ViewColumn.from(P.viewColumn),preserveFocus:P.preserveFocus,selection:typeof P.selection=="object"?i.Range.from(P.selection):void 0,pinned:typeof P.preview=="boolean"?!P.preview:void 0}:E={preserveFocus:!1};const f=await this._proxy.$tryShowTextDocument(R.uri,E),v=f&&this._extHostDocumentsAndEditors.getEditor(f);if(v)return v.value;throw f?new Error(`Could NOT open editor for "${R.uri.toString()}" because another editor opened in the meantime.`):new Error(`Could NOT open editor for "${R.uri.toString()}".`)}createTextEditorDecorationType(R,P){return new C.TextEditorDecorationType(this._proxy,R,P).value}$acceptEditorPropertiesChanged(R,P){const u=this._extHostDocumentsAndEditors.getEditor(R);if(!u)throw new Error("unknown text editor");if(P.options&&u._acceptOptions(P.options),P.selections){const E=P.selections.selections.map(i.Selection.to);u._acceptSelections(E)}if(P.visibleRanges){const E=L.coalesce(P.visibleRanges.map(i.Range.to));u._acceptVisibleRanges(E)}if(P.options&&this._onDidChangeTextEditorOptions.fire({textEditor:u.value,options:{...P.options,lineNumbers:i.TextEditorLineNumbersStyle.to(P.options.lineNumbers)}}),P.selections){const E=k.TextEditorSelectionChangeKind.fromValue(P.selections.source),f=P.selections.selections.map(i.Selection.to);this._onDidChangeTextEditorSelection.fire({textEditor:u.value,selections:f,kind:E})}if(P.visibleRanges){const E=L.coalesce(P.visibleRanges.map(i.Range.to));this._onDidChangeTextEditorVisibleRanges.fire({textEditor:u.value,visibleRanges:E})}}$acceptEditorPositionData(R){for(const P in R){const u=this._extHostDocumentsAndEditors.getEditor(P);if(!u)throw new Error("Unknown text editor");const E=i.ViewColumn.to(R[P]);u.value.viewColumn!==E&&(u._acceptViewColumn(E),this._onDidChangeTextEditorViewColumn.fire({textEditor:u.value,viewColumn:E}))}}getDiffInformation(R){return Promise.resolve(this._proxy.$getDiffInformation(R))}}e.ExtHostEditors=S}),define(pe[252],ve([0,1,2,4,5,6,7]),function(Y,e,m,L,y,C,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTimeline=e.IExtHostTimeline=void 0,e.IExtHostTimeline=(0,L.createDecorator)("IExtHostTimeline");class k{constructor(R,P){this._providers=new Map,this._itemsBySourceAndUriMap=new Map,this._proxy=R.getProxy(y.MainContext.MainThreadTimeline),P.registerArgumentProcessor({processArgument:u=>{if(u&&u.$mid===11){const E=u.uri===void 0?void 0:m.URI.revive(u.uri);return this._itemsBySourceAndUriMap.get(u.source)?.get(S(E))?.get(u.handle)}return u}})}async $getTimeline(R,P,u,E,f){return this._providers.get(R)?.provideTimeline(m.URI.revive(P),u,E,f)}registerTimelineProvider(R,P,u,E){const f=new C.DisposableStore,v=this.convertTimelineItem(P.id,E,f).bind(this);let w;P.onDidChange&&(w=P.onDidChange(p=>this._proxy.$emitTimelineChangeEvent({uri:void 0,reset:!0,...p,id:P.id}),this));const I=this._itemsBySourceAndUriMap;return this.registerTimelineProviderCore({...P,scheme:R,onDidChange:void 0,async provideTimeline(p,s,r,g){g?.resetCache&&(f.clear(),I.get(P.id)?.clear());const a=await P.provideTimeline(p,s,r);if(a==null)return;const _=v(p,g);return{...a,source:P.id,items:a.items.map(_)}},dispose(){for(const p of I.values())p.get(P.id)?.clear();w?.dispose(),f.dispose()}})}convertTimelineItem(R,P,u){return(E,f)=>{let v;if(f?.cacheResults){let w=this._itemsBySourceAndUriMap.get(R);w===void 0&&(w=new Map,this._itemsBySourceAndUriMap.set(R,w));const I=S(E);v=w.get(I),v===void 0&&(v=new Map,w.set(I,v))}return w=>{const{iconPath:I,...p}=w,s=`${R}|${w.id??w.timestamp}`;v?.set(s,w);let r,g,a;return w.iconPath&&(I instanceof i.ThemeIcon?a={id:I.id,color:I.color}:m.URI.isUri(I)?(r=I,g=I):{light:r,dark:g}=I),{...p,id:p.id??void 0,handle:s,source:R,command:w.command?P.toInternal(w.command,u):void 0,icon:r,iconDark:g,themeIcon:a,accessibilityInformation:w.accessibilityInformation}}}}registerTimelineProviderCore(R){if(this._providers.get(R.id))throw new Error(`Timeline Provider ${R.id} already exists.`);return this._proxy.$registerTimelineProvider({id:R.id,label:R.label,scheme:R.scheme}),this._providers.set(R.id,R),(0,C.toDisposable)(()=>{for(const u of this._itemsBySourceAndUriMap.values())u.get(R.id)?.clear();this._providers.delete(R.id),this._proxy.$unregisterTimelineProvider(R.id),R.dispose()})}}e.ExtHostTimeline=k;function S(D){return D?.toString()}}),define(pe[253],ve([0,1,6,10,2,5]),function(Y,e,m,L,y,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostUriOpeners=void 0;class i{constructor(S){this._openers=new Map,this._proxy=S.getProxy(C.MainContext.MainThreadUriOpeners)}registerExternalUriOpener(S,D,R,P){if(this._openers.has(D))throw new Error(`Opener with id '${D}' already registered`);const u=P.schemes.find(E=>!i.supportedSchemes.has(E));if(u)throw new Error(`Scheme '${u}' is not supported. Only http and https are currently supported.`);return this._openers.set(D,R),this._proxy.$registerUriOpener(D,P.schemes,S,P.label),(0,m.toDisposable)(()=>{this._openers.delete(D),this._proxy.$unregisterUriOpener(D)})}async $canOpenUri(S,D,R){const P=this._openers.get(S);if(!P)throw new Error(`Unknown opener with id: ${S}`);const u=y.URI.revive(D);return P.canOpenExternalUri(u,R)}async $openUri(S,D,R){const P=this._openers.get(S);if(!P)throw new Error(`Unknown opener id: '${S}'`);return P.openExternalUri(y.URI.revive(D.resolvedUri),{sourceUri:y.URI.revive(D.sourceUri)},R)}}e.ExtHostUriOpeners=i,i.supportedSchemes=new Set([L.Schemas.http,L.Schemas.https])}),define(pe[254],ve([0,1,5,2,6,15,27]),function(Y,e,m,L,y,C,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostUrls=void 0;class k{constructor(D){this.handles=new Set,this.handlers=new Map,this._proxy=D.getProxy(m.MainContext.MainThreadUrls)}registerUriHandler(D,R){if(this.handles.has(i.ExtensionIdentifier.toKey(D)))throw new Error(`Protocol handler already registered for extension ${D}`);const P=k.HandlePool++;return this.handles.add(i.ExtensionIdentifier.toKey(D)),this.handlers.set(P,R),this._proxy.$registerUriHandler(P,D),(0,y.toDisposable)(()=>{this.handles.delete(i.ExtensionIdentifier.toKey(D)),this.handlers.delete(P),this._proxy.$unregisterUriHandler(P)})}$handleExternalUri(D,R){const P=this.handlers.get(D);if(!P)return Promise.resolve(void 0);try{P.handleUri(L.URI.revive(R))}catch(u){(0,C.onUnexpectedError)(u)}return Promise.resolve(void 0)}async createAppUri(D){return L.URI.revive(await this._proxy.$createAppUri(D))}}e.ExtHostUrls=k,k.HandlePool=0});var nt=this&&this.__classPrivateFieldSet||function(Y,e,m,L,y){if(L==="m")throw new TypeError("Private method is not writable");if(L==="a"&&!y)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?Y!==e||!y:!e.has(Y))throw new TypeError("Cannot write private member to an object whose class did not declare it");return L==="a"?y.call(Y,m):y?y.value=m:e.set(Y,m),m},Ne=this&&this.__classPrivateFieldGet||function(Y,e,m,L){if(m==="a"&&!L)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?Y!==e||!L:!e.has(Y))throw new TypeError("Cannot read private member from an object whose class did not declare it");return m==="m"?L:m==="a"?L.call(Y):L?L.value:e.get(Y)};define(pe[68],ve([0,1,3,10,2,178,203,88,5]),function(Y,e,m,L,y,C,i,k,S){"use strict";var D,R,P,u,E,f,v,w,I,p,s,r;Object.defineProperty(e,"__esModule",{value:!0}),e.reviveOptions=e.serializeWebviewOptions=e.toExtensionData=e.ExtHostWebviews=e.shouldSerializeBuffersForPostMessage=e.ExtHostWebview=void 0;class g{constructor(h,l,b,T,A,x,O){D.set(this,void 0),R.set(this,void 0),P.set(this,void 0),u.set(this,void 0),E.set(this,void 0),f.set(this,void 0),v.set(this,""),w.set(this,void 0),I.set(this,!1),p.set(this,!1),s.set(this,!1),this._onMessageEmitter=new m.Emitter,this.onDidReceiveMessage=this._onMessageEmitter.event,r.set(this,new m.Emitter),this._onDidDispose=Ne(this,r,"f").event,nt(this,D,h,"f"),nt(this,R,l,"f"),nt(this,w,b,"f"),nt(this,u,T,"f"),nt(this,E,A,"f"),nt(this,f,x,"f"),nt(this,s,a(x),"f"),nt(this,P,O,"f")}dispose(){nt(this,I,!0,"f"),Ne(this,r,"f").fire(),Ne(this,r,"f").dispose(),this._onMessageEmitter.dispose()}asWebviewUri(h){return nt(this,p,!0,"f"),(0,k.asWebviewUri)(h,Ne(this,u,"f").remote)}get cspSource(){const h=Ne(this,f,"f").extensionLocation;if(h.scheme===L.Schemas.https||h.scheme===L.Schemas.http){let l=h.toString();return l.endsWith("/")||(l+="/"),l+" "+k.webviewGenericCspSource}return k.webviewGenericCspSource}get html(){return this.assertNotDisposed(),Ne(this,v,"f")}set html(h){this.assertNotDisposed(),Ne(this,v,"f")!==h&&(nt(this,v,h,"f"),!Ne(this,p,"f")&&/(["'])vscode-resource:([^\s'"]+?)(["'])/i.test(h)&&(nt(this,p,!0,"f"),Ne(this,P,"f").report("Webview vscode-resource: uris",Ne(this,f,"f"),"Please migrate to use the 'webview.asWebviewUri' api instead: https://aka.ms/vscode-webview-use-aswebviewuri")),Ne(this,R,"f").$setHtml(Ne(this,D,"f"),h))}get options(){return this.assertNotDisposed(),Ne(this,w,"f")}set options(h){this.assertNotDisposed(),Ne(this,R,"f").$setOptions(Ne(this,D,"f"),t(Ne(this,f,"f"),Ne(this,E,"f"),h)),nt(this,w,h,"f")}async postMessage(h){if(Ne(this,I,"f"))return!1;const l=(0,i.serializeWebviewMessage)(h,{serializeBuffersForPostMessage:Ne(this,s,"f")});return Ne(this,R,"f").$postMessage(Ne(this,D,"f"),l.message,...l.buffers)}assertNotDisposed(){if(Ne(this,I,"f"))throw new Error("Webview is disposed")}}e.ExtHostWebview=g,D=new WeakMap,R=new WeakMap,P=new WeakMap,u=new WeakMap,E=new WeakMap,f=new WeakMap,v=new WeakMap,w=new WeakMap,I=new WeakMap,p=new WeakMap,s=new WeakMap,r=new WeakMap;function a(c){try{const h=(0,C.normalizeVersion)((0,C.parseVersion)(c.engines.vscode));return!!h&&h.majorBase>=1&&h.minorBase>=57}catch{return!1}}e.shouldSerializeBuffersForPostMessage=a;class _{constructor(h,l,b,T,A){this.initData=l,this.workspace=b,this._logService=T,this._deprecationService=A,this._webviews=new Map,this._webviewProxy=h.getProxy(S.MainContext.MainThreadWebviews)}$onMessage(h,l,...b){const T=this.getWebview(h);if(T){const{message:A}=(0,i.deserializeWebviewMessage)(l,b);T._onMessageEmitter.fire(A)}}$onMissingCsp(h,l){this._logService.warn(`${l} created a webview without a content security policy: https://aka.ms/vscode-webview-missing-csp`)}createNewWebview(h,l,b){const T=new g(h,this._webviewProxy,o(l),this.initData,this.workspace,b,this._deprecationService);return this._webviews.set(h,T),T._onDidDispose(()=>{this._webviews.delete(h)}),T}deleteWebview(h){this._webviews.delete(h)}getWebview(h){return this._webviews.get(h)}}e.ExtHostWebviews=_;function n(c){return{id:c.identifier,location:c.extensionLocation}}e.toExtensionData=n;function t(c,h,l){return{enableCommandUris:l.enableCommandUris,enableScripts:l.enableScripts,enableForms:l.enableForms,portMapping:l.portMapping,localResourceRoots:l.localResourceRoots||d(c,h)}}e.serializeWebviewOptions=t;function o(c){return{enableCommandUris:c.enableCommandUris,enableScripts:c.enableScripts,enableForms:c.enableForms,portMapping:c.portMapping,localResourceRoots:c.localResourceRoots?.map(h=>y.URI.from(h))}}e.reviveOptions=o;function d(c,h){return[...(h?.getWorkspaceFolders()||[]).map(l=>l.uri),c.extensionLocation]}}),define(pe[255],ve([0,1,21,47,6,10,23,2,17,68,87,5,7]),function(Y,e,m,L,y,C,i,k,S,D,R,P,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostCustomEditors=void 0;class E{constructor(a,_){this.document=a,this._storagePath=_,this._backupCounter=1,this._edits=new R.Cache("custom documents")}addEdit(a){return this._edits.add([a])}async undo(a,_){await this.getEdit(a).undo(),_||this.disposeBackup()}async redo(a,_){await this.getEdit(a).redo(),_||this.disposeBackup()}disposeEdits(a){for(const _ of a)this._edits.delete(_)}getNewBackupUri(){if(!this._storagePath)throw new Error("Backup requires a valid storage path");const a=r(this.document.uri)+this._backupCounter++;return(0,i.joinPath)(this._storagePath,a)}updateBackup(a){this._backup?.delete(),this._backup=a}disposeBackup(){this._backup?.delete(),this._backup=void 0}getEdit(a){const _=this._edits.get(a,0);if(!_)throw new Error("No edit found");return _}}class f{constructor(){this._documents=new Map}get(a,_){return this._documents.get(this.key(a,_))}add(a,_,n){const t=this.key(a,_.uri);if(this._documents.has(t))throw new Error(`Document already exists for viewType:${a} resource:${_.uri}`);const o=new E(_,n);return this._documents.set(t,o),o}delete(a,_){const n=this.key(a,_.uri);this._documents.delete(n)}key(a,_){return`${a}@@@${_}`}}var v;(function(g){g[g.Text=0]="Text",g[g.Custom=1]="Custom"})(v||(v={}));class w{constructor(){this._providers=new Map}addTextProvider(a,_,n){return this.add(0,a,_,n)}addCustomProvider(a,_,n){return this.add(1,a,_,n)}get(a){return this._providers.get(a)}add(a,_,n,t){if(this._providers.has(_))throw new Error(`Provider for viewType:${_} already registered`);return this._providers.set(_,{type:a,extension:n,provider:t}),new u.Disposable(()=>this._providers.delete(_))}}class I{constructor(a,_,n,t,o){this._extHostDocuments=_,this._extensionStoragePaths=n,this._extHostWebview=t,this._extHostWebviewPanels=o,this._editorProviders=new w,this._documents=new f,this._proxy=a.getProxy(P.MainContext.MainThreadCustomEditors)}registerCustomEditorProvider(a,_,n,t){const o=new y.DisposableStore;return p(n)?(o.add(this._editorProviders.addTextProvider(_,a,n)),this._proxy.$registerTextEditorProvider((0,D.toExtensionData)(a),_,t.webviewOptions||{},{supportsMove:!!n.moveCustomTextEditor},(0,D.shouldSerializeBuffersForPostMessage)(a))):(o.add(this._editorProviders.addCustomProvider(_,a,n)),this.supportEditing(n)&&o.add(n.onDidChangeCustomDocument(d=>{const c=this.getCustomDocumentEntry(_,d.document.uri);if(s(d)){const h=c.addEdit(d);this._proxy.$onDidEdit(d.document.uri,_,h,d.label)}else this._proxy.$onContentChange(d.document.uri,_)})),this._proxy.$registerCustomEditorProvider((0,D.toExtensionData)(a),_,t.webviewOptions||{},!!t.supportsMultipleEditorsPerDocument,(0,D.shouldSerializeBuffersForPostMessage)(a))),u.Disposable.from(o,new u.Disposable(()=>{this._proxy.$unregisterEditorProvider(_)}))}async $createCustomDocument(a,_,n,t,o){const d=this._editorProviders.get(_);if(!d)throw new Error(`No provider found for '${_}'`);if(d.type!==1)throw new Error(`Invalid provide type for '${_}'`);const c=k.URI.revive(a),h=await d.provider.openCustomDocument(c,{backupId:n,untitledDocumentData:t?.buffer},o);let l;return this.supportEditing(d.provider)&&this._extensionStoragePaths&&(l=this._extensionStoragePaths.workspaceValue(d.extension)??this._extensionStoragePaths.globalValue(d.extension)),this._documents.add(_,h,l),{editable:this.supportEditing(d.provider)}}async $disposeCustomDocument(a,_){const n=this._editorProviders.get(_);if(!n)throw new Error(`No provider found for '${_}'`);if(n.type!==1)throw new Error(`Invalid provider type for '${_}'`);const t=k.URI.revive(a),{document:o}=this.getCustomDocumentEntry(_,t);this._documents.delete(_,o),o.dispose()}async $resolveWebviewEditor(a,_,n,t,o,d){const c=this._editorProviders.get(n);if(!c)throw new Error(`No provider found for '${n}'`);const h=S.ViewColumn.to(o),l=this._extHostWebview.createNewWebview(_,t.webviewOptions,c.extension),b=this._extHostWebviewPanels.createNewWebviewPanel(_,n,t.title,h,t.panelOptions,l),T=k.URI.revive(a);switch(c.type){case 1:{const{document:A}=this.getCustomDocumentEntry(n,T);return c.provider.resolveCustomEditor(A,b,d)}case 0:{const A=this._extHostDocuments.getDocument(T);return c.provider.resolveCustomTextEditor(A,b,d)}default:throw new Error("Unknown webview provider type")}}$disposeEdits(a,_,n){this.getCustomDocumentEntry(_,a).disposeEdits(n)}async $onMoveCustomEditor(a,_,n){const t=this._editorProviders.get(n);if(!t)throw new Error(`No provider found for '${n}'`);if(!t.provider.moveCustomTextEditor)throw new Error(`Provider does not implement move '${n}'`);const o=this._extHostWebviewPanels.getWebviewPanel(a);if(!o)throw new Error("No webview found");const d=k.URI.revive(_),c=this._extHostDocuments.getDocument(d);await t.provider.moveCustomTextEditor(c,o,m.CancellationToken.None)}async $undo(a,_,n,t){return this.getCustomDocumentEntry(_,a).undo(n,t)}async $redo(a,_,n,t){return this.getCustomDocumentEntry(_,a).redo(n,t)}async $revert(a,_,n){const t=this.getCustomDocumentEntry(_,a);await this.getCustomEditorProvider(_).revertCustomDocument(t.document,n),t.disposeBackup()}async $onSave(a,_,n){const t=this.getCustomDocumentEntry(_,a);await this.getCustomEditorProvider(_).saveCustomDocument(t.document,n),t.disposeBackup()}async $onSaveAs(a,_,n,t){const o=this.getCustomDocumentEntry(_,a);return this.getCustomEditorProvider(_).saveCustomDocumentAs(o.document,k.URI.revive(n),t)}async $backup(a,_,n){const t=this.getCustomDocumentEntry(_,a),d=await this.getCustomEditorProvider(_).backupCustomDocument(t.document,{destination:t.getNewBackupUri()},n);return t.updateBackup(d),d.id}getCustomDocumentEntry(a,_){const n=this._documents.get(a,k.URI.revive(_));if(!n)throw new Error("No custom document found");return n}getCustomEditorProvider(a){const n=this._editorProviders.get(a)?.provider;if(!n||!this.supportEditing(n))throw new Error("Custom document is not editable");return n}supportEditing(a){return!!a.onDidChangeCustomDocument}}e.ExtHostCustomEditors=I;function p(g){return typeof g.resolveCustomTextEditor=="function"}function s(g){return typeof g.undo=="function"&&typeof g.redo=="function"}function r(g){const a=g.scheme===C.Schemas.file||g.scheme===C.Schemas.untitled?g.fsPath:g.toString();return(0,L.hash)(a)+""}});var nt=this&&this.__classPrivateFieldSet||function(Y,e,m,L,y){if(L==="m")throw new TypeError("Private method is not writable");if(L==="a"&&!y)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?Y!==e||!y:!e.has(Y))throw new TypeError("Cannot write private member to an object whose class did not declare it");return L==="a"?y.call(Y,m):y?y.value=m:e.set(Y,m),m},Ne=this&&this.__classPrivateFieldGet||function(Y,e,m,L){if(m==="a"&&!L)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?Y!==e||!L:!e.has(Y))throw new TypeError("Cannot read private member from an object whose class did not declare it");return m==="m"?L:m==="a"?L.call(Y):L?L.value:e.get(Y)};define(pe[256],ve([0,1,3,6,2,32,17,68,5,7]),function(Y,e,m,L,y,C,i,k,S,D){"use strict";var R,P,u,E,f,v,w,I,p,s,r,g,a;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostWebviewPanels=void 0;class _ extends L.Disposable{constructor(d,c,h,l,b,T,A){super();R.set(this,void 0),P.set(this,void 0),u.set(this,void 0),E.set(this,void 0),f.set(this,void 0),v.set(this,void 0),w.set(this,void 0),I.set(this,void 0),p.set(this,!0),s.set(this,!0),r.set(this,!1),g.set(this,this._register(new m.Emitter)),this.onDidDispose=Ne(this,g,"f").event,a.set(this,this._register(new m.Emitter)),this.onDidChangeViewState=Ne(this,a,"f").event,nt(this,R,d,"f"),nt(this,P,c,"f"),nt(this,u,h,"f"),nt(this,f,T,"f"),nt(this,I,b,"f"),nt(this,v,l,"f"),nt(this,E,A,"f")}dispose(){Ne(this,r,"f")||(nt(this,r,!0,"f"),Ne(this,g,"f").fire(),Ne(this,P,"f").$disposeWebview(Ne(this,R,"f")),Ne(this,E,"f").dispose(),super.dispose())}get webview(){return this.assertNotDisposed(),Ne(this,E,"f")}get viewType(){return this.assertNotDisposed(),Ne(this,u,"f")}get title(){return this.assertNotDisposed(),Ne(this,v,"f")}set title(d){this.assertNotDisposed(),Ne(this,v,"f")!==d&&(nt(this,v,d,"f"),Ne(this,P,"f").$setTitle(Ne(this,R,"f"),d))}get iconPath(){return this.assertNotDisposed(),Ne(this,w,"f")}set iconPath(d){this.assertNotDisposed(),Ne(this,w,"f")!==d&&(nt(this,w,d,"f"),Ne(this,P,"f").$setIconPath(Ne(this,R,"f"),y.URI.isUri(d)?{light:d,dark:d}:d))}get options(){return Ne(this,f,"f")}get viewColumn(){if(this.assertNotDisposed(),!(typeof Ne(this,I,"f")=="number"&&Ne(this,I,"f")<0))return Ne(this,I,"f")}get active(){return this.assertNotDisposed(),Ne(this,s,"f")}get visible(){return this.assertNotDisposed(),Ne(this,p,"f")}_updateViewState(d){Ne(this,r,"f")||(this.active!==d.active||this.visible!==d.visible||this.viewColumn!==d.viewColumn)&&(nt(this,s,d.active,"f"),nt(this,p,d.visible,"f"),nt(this,I,d.viewColumn,"f"),Ne(this,a,"f").fire({webviewPanel:this}))}reveal(d,c){this.assertNotDisposed(),Ne(this,P,"f").$reveal(Ne(this,R,"f"),{viewColumn:d?i.ViewColumn.from(d):void 0,preserveFocus:!!c})}assertNotDisposed(){if(Ne(this,r,"f"))throw new Error("Webview is disposed")}}R=new WeakMap,P=new WeakMap,u=new WeakMap,E=new WeakMap,f=new WeakMap,v=new WeakMap,w=new WeakMap,I=new WeakMap,p=new WeakMap,s=new WeakMap,r=new WeakMap,g=new WeakMap,a=new WeakMap;class n{constructor(d,c,h){this.webviews=c,this.workspace=h,this._webviewPanels=new Map,this._serializers=new Map,this._proxy=d.getProxy(S.MainContext.MainThreadWebviewPanels)}static newHandle(){return(0,C.generateUuid)()}createWebviewPanel(d,c,h,l,b={}){const T=typeof l=="object"?l.viewColumn:l,A={viewColumn:i.ViewColumn.from(T),preserveFocus:typeof l=="object"&&!!l.preserveFocus},x=(0,k.shouldSerializeBuffersForPostMessage)(d),O=n.newHandle();this._proxy.$createWebviewPanel((0,k.toExtensionData)(d),O,c,{title:h,panelOptions:t(b),webviewOptions:(0,k.serializeWebviewOptions)(d,this.workspace,b),serializeBuffersForPostMessage:x},A);const F=this.webviews.createNewWebview(O,b,d);return this.createNewWebviewPanel(O,c,h,T,b,F)}$onDidChangeWebviewPanelViewStates(d){const c=Object.keys(d);c.sort((h,l)=>{const b=d[h],T=d[l];return b.active?1:T.active?-1:+b.visible-+T.visible});for(const h of c){const l=this.getWebviewPanel(h);if(!l)continue;const b=d[h];l._updateViewState({active:b.active,visible:b.visible,viewColumn:i.ViewColumn.to(b.position)})}}async $onDidDisposeWebviewPanel(d){this.getWebviewPanel(d)?.dispose(),this._webviewPanels.delete(d),this.webviews.deleteWebview(d)}registerWebviewPanelSerializer(d,c,h){if(this._serializers.has(c))throw new Error(`Serializer for '${c}' already registered`);return this._serializers.set(c,{serializer:h,extension:d}),this._proxy.$registerSerializer(c,{serializeBuffersForPostMessage:(0,k.shouldSerializeBuffersForPostMessage)(d)}),new D.Disposable(()=>{this._serializers.delete(c),this._proxy.$unregisterSerializer(c)})}async $deserializeWebviewPanel(d,c,h,l){const b=this._serializers.get(c);if(!b)throw new Error(`No serializer found for '${c}'`);const{serializer:T,extension:A}=b,x=this.webviews.createNewWebview(d,h.webviewOptions,A),O=this.createNewWebviewPanel(d,c,h.title,l,h.panelOptions,x);await T.deserializeWebviewPanel(O,h.state)}createNewWebviewPanel(d,c,h,l,b,T){const A=new _(d,this._proxy,c,h,l,b,T);return this._webviewPanels.set(d,A),A}getWebviewPanel(d){return this._webviewPanels.get(d)}}e.ExtHostWebviewPanels=n;function t(o){return{enableFindWidget:o.enableFindWidget,retainContextWhenHidden:o.retainContextWhenHidden}}});var nt=this&&this.__classPrivateFieldSet||function(Y,e,m,L,y){if(L==="m")throw new TypeError("Private method is not writable");if(L==="a"&&!y)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?Y!==e||!y:!e.has(Y))throw new TypeError("Cannot write private member to an object whose class did not declare it");return L==="a"?y.call(Y,m):y?y.value=m:e.set(Y,m),m},Ne=this&&this.__classPrivateFieldGet||function(Y,e,m,L){if(m==="a"&&!L)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?Y!==e||!L:!e.has(Y))throw new TypeError("Cannot read private member from an object whose class did not declare it");return m==="m"?L:m==="a"?L.call(Y):L?L.value:e.get(Y)};define(pe[257],ve([0,1,3,6,68,5,7]),function(Y,e,m,L,y,C,i){"use strict";var k,S,D,R,P,u,E,f,v,w;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostWebviewViews=void 0;class I extends L.Disposable{constructor(r,g,a,_,n,t){super();k.set(this,void 0),S.set(this,void 0),D.set(this,void 0),R.set(this,void 0),P.set(this,!1),u.set(this,void 0),E.set(this,void 0),f.set(this,void 0),v.set(this,this._register(new m.Emitter)),this.onDidChangeVisibility=Ne(this,v,"f").event,w.set(this,this._register(new m.Emitter)),this.onDidDispose=Ne(this,w,"f").event,nt(this,D,a,"f"),nt(this,E,_,"f"),nt(this,k,r,"f"),nt(this,S,g,"f"),nt(this,R,n,"f"),nt(this,u,t,"f")}dispose(){Ne(this,P,"f")||(nt(this,P,!0,"f"),Ne(this,w,"f").fire(),Ne(this,R,"f").dispose(),super.dispose())}get title(){return this.assertNotDisposed(),Ne(this,E,"f")}set title(r){this.assertNotDisposed(),Ne(this,E,"f")!==r&&(nt(this,E,r,"f"),Ne(this,S,"f").$setWebviewViewTitle(Ne(this,k,"f"),r))}get description(){return this.assertNotDisposed(),Ne(this,f,"f")}set description(r){this.assertNotDisposed(),Ne(this,f,"f")!==r&&(nt(this,f,r,"f"),Ne(this,S,"f").$setWebviewViewDescription(Ne(this,k,"f"),r))}get visible(){return Ne(this,u,"f")}get webview(){return Ne(this,R,"f")}get viewType(){return Ne(this,D,"f")}_setVisible(r){r===Ne(this,u,"f")||Ne(this,P,"f")||(nt(this,u,r,"f"),Ne(this,v,"f").fire())}show(r){this.assertNotDisposed(),Ne(this,S,"f").$show(Ne(this,k,"f"),!!r)}assertNotDisposed(){if(Ne(this,P,"f"))throw new Error("Webview is disposed")}}k=new WeakMap,S=new WeakMap,D=new WeakMap,R=new WeakMap,P=new WeakMap,u=new WeakMap,E=new WeakMap,f=new WeakMap,v=new WeakMap,w=new WeakMap;class p{constructor(r,g){this._extHostWebview=g,this._viewProviders=new Map,this._webviewViews=new Map,this._proxy=r.getProxy(C.MainContext.MainThreadWebviewViews)}registerWebviewViewProvider(r,g,a,_){if(this._viewProviders.has(g))throw new Error(`View provider for '${g}' already registered`);return this._viewProviders.set(g,{provider:a,extension:r}),this._proxy.$registerWebviewViewProvider((0,y.toExtensionData)(r),g,{retainContextWhenHidden:_?.retainContextWhenHidden,serializeBuffersForPostMessage:!1}),new i.Disposable(()=>{this._viewProviders.delete(g),this._proxy.$unregisterWebviewViewProvider(g)})}async $resolveWebviewView(r,g,a,_,n){const t=this._viewProviders.get(g);if(!t)throw new Error(`No view provider found for '${g}'`);const{provider:o,extension:d}=t,c=this._extHostWebview.createNewWebview(r,{},d),h=new I(r,this._proxy,g,a,c,!0);this._webviewViews.set(r,h),await o.resolveWebviewView(h,{state:_},n)}async $onDidChangeWebviewViewVisibility(r,g){this.getWebviewView(r)._setVisible(g)}async $disposeWebviewView(r){const g=this.getWebviewView(r);this._webviewViews.delete(r),g.dispose(),this._extHostWebview.deleteWebview(r)}getWebviewView(r){const g=this._webviewViews.get(r);if(!g)throw new Error("No webview found");return g}}e.ExtHostWebviewViews=p}),define(pe[133],ve([0,1,3,5,2,10,8,4,14]),function(Y,e,m,L,y,C,i,k,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostWindow=e.ExtHostWindow=void 0;let D=class zi{constructor(P){this._onDidChangeWindowState=new m.Emitter,this.onDidChangeWindowState=this._onDidChangeWindowState.event,this._state=zi.InitialState,this._proxy=P.getProxy(L.MainContext.MainThreadWindow),this._proxy.$getWindowVisibility().then(u=>this.$onDidChangeWindowFocus(u))}get state(){return this._state}$onDidChangeWindowFocus(P){P!==this._state.focused&&(this._state={...this._state,focused:P},this._onDidChangeWindowState.fire(this._state))}openUri(P,u){let E;if(typeof P=="string"){E=P;try{P=y.URI.parse(P)}catch(f){return Promise.reject(`Invalid uri - '${P}'`)}}return(0,i.isFalsyOrWhitespace)(P.scheme)?Promise.reject("Invalid scheme - cannot be empty"):P.scheme===C.Schemas.command?Promise.reject(`Invalid scheme '${P.scheme}'`):this._proxy.$openUri(P,E,u)}async asExternalUri(P,u){if((0,i.isFalsyOrWhitespace)(P.scheme))return Promise.reject("Invalid scheme - cannot be empty");const E=await this._proxy.$asExternalUri(P,u);return y.URI.from(E)}};D.InitialState={focused:!0},D=je([He(0,S.IExtHostRpcService)],D),e.ExtHostWindow=D,e.IExtHostWindow=(0,k.createDecorator)("IExtHostWindow")}),define(pe[258],ve([0,1,9,81,32,38,6,5,2,14]),function(Y,e,m,L,y,C,i,k,S,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDownloadService=void 0;let R=class extends i.Disposable{constructor(u,E){super();const f=u.getProxy(k.MainContext.MainThreadDownloadService);E.registerCommand(!1,"_workbench.downloadResource",async v=>{const w=S.URI.file((0,m.join)((0,L.tmpdir)(),(0,y.generateUuid)()));return await f.$download(v,w),w})}};R=je([He(0,D.IExtHostRpcService),He(1,C.IExtHostCommands)],R),e.ExtHostDownloadService=R}),define(pe[259],ve([0,1,131,10,187,32]),function(Y,e,m,L,y,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLoggerService=void 0;class i extends m.ExtHostLoggerService{doCreateLogger(S,D,R){return S.scheme===L.Schemas.file?new y.SpdLogLogger(R?.name||(0,C.generateUuid)(),S.fsPath,!R?.donotRotate,!!R?.donotUseFormatters,D):super.doCreateLogger(S,D,R)}}e.ExtHostLoggerService=i}),define(pe[260],ve([0,1,60,9,2,67,6,10,18,28]),function(Y,e,m,L,y,C,i,k,S,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionStoragePaths=void 0;class R extends C.ExtensionStoragePaths{constructor(){super(...arguments);this._workspaceStorageLock=null}async _getWorkspaceStorageURI(a){const _=await super._getWorkspaceStorageURI(a);if(_.scheme!==k.Schemas.file)return _;if(this._environment.skipWorkspaceStorageLock)return this._logService.info(`Skipping acquiring lock for ${_.fsPath}.`),_;const n=_.fsPath;let t=0;do{let o;t===0?o=n:o=/[/\\]$/.test(n)?`${n.substr(0,n.length-1)}-${t}`:`${n}-${t}`,await P(o);const d=L.join(o,"vscode.lock"),c=await v(this._logService,d,!1);if(c)return this._workspaceStorageLock=c,process.on("exit",()=>{c.dispose()}),y.URI.file(o);t++}while(t<10);return _}onWillDeactivateAll(){this._workspaceStorageLock&&this._workspaceStorageLock.setWillRelease(6e3)}}e.ExtensionStoragePaths=R;async function P(g){try{await D.Promises.stat(g);return}catch{}try{await D.Promises.mkdir(g,{recursive:!0})}catch{}}const u=1e3,E=10*60*1e3;class f extends i.Disposable{constructor(a,_){super();this.logService=a,this.filename=_,this._timer=this._register(new S.IntervalTimer),this._timer.cancelAndSet(async()=>{const n=await w(a,_);(!n||n.pid!==process.pid)&&(a.info(`Lock '${_}': The lock was lost unexpectedly.`),this._timer.cancel());try{await D.Promises.utimes(_,new Date,new Date)}catch(t){a.error(t),a.info(`Lock '${_}': Could not update mtime.`)}},u)}dispose(){super.dispose();try{m.unlinkSync(this.filename)}catch(a){}}async setWillRelease(a){this.logService.info(`Lock '${this.filename}': Marking the lockfile as scheduled to be released in ${a} ms.`);try{const _={pid:process.pid,willReleaseAt:Date.now()+a};await D.Promises.writeFile(this.filename,JSON.stringify(_),{flag:"w"})}catch(_){this.logService.error(_)}}}async function v(g,a,_){try{const t={pid:process.pid,willReleaseAt:0};await D.Promises.writeFile(a,JSON.stringify(t),{flag:"wx"})}catch(t){g.error(t)}const n=await w(g,a);return!n||n.pid!==process.pid?_?(g.info(`Lock '${a}': Could not acquire lock, giving up.`),null):(g.info(`Lock '${a}': Could not acquire lock, checking if the file is stale.`),s(g,a)):(g.info(`Lock '${a}': Lock acquired.`),new f(g,a))}async function w(g,a){let _;try{_=await D.Promises.readFile(a)}catch(n){return g.error(n),null}try{return JSON.parse(String(_))}catch(n){return g.error(n),null}}async function I(g,a){let _;try{_=await D.Promises.stat(a)}catch(n){return g.error(n),0}return _.mtime.getTime()}function p(g){try{return process.kill(g,0),!0}catch(a){return!1}}async function s(g,a){const _=await w(g,a);if(!_)return g.info(`Lock '${a}': Could not read pid of lock holder.`),r(g,a);if(_.willReleaseAt){let c=_.willReleaseAt-Date.now();if(c<5e3){for(c>0?g.info(`Lock '${a}': The lockfile is scheduled to be released in ${c} ms.`):g.info(`Lock '${a}': The lockfile is scheduled to have been released.`);c>0;){if(await(0,S.timeout)(Math.min(100,c)),await I(g,a)===0)return r(g,a);c=_.willReleaseAt-Date.now()}return r(g,a)}}if(!p(_.pid))return g.info(`Lock '${a}': The pid ${_.pid} appears to be gone.`),r(g,a);const n=await I(g,a),t=Date.now()-n;if(t<=E)return g.info(`Lock '${a}': The lock does not look stale, elapsed: ${t} ms, giving up.`),null;g.info(`Lock '${a}': The lock looks stale, waiting for 2s.`),await(0,S.timeout)(2e3);const o=await I(g,a),d=Date.now()-o;return d<=E?(g.info(`Lock '${a}': The lock does not look stale, elapsed: ${d} ms, giving up.`),null):(g.info(`Lock '${a}': The lock looks stale even after waiting for 2s.`),r(g,a))}async function r(g,a){g.info(`Lock '${a}': Deleting a stale lock.`);try{await D.Promises.unlink(a)}catch(_){}return v(g,a,!0)}}),define(pe[261],ve([0,1,32,14,34]),function(Y,e,m,L,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTerminalService=void 0;let C=class extends y.BaseExtHostTerminalService{constructor(k){super(!0,k)}createTerminal(k,S,D){return this.createTerminalFromOptions({name:k,shellPath:S,shellArgs:D})}createTerminalFromOptions(k,S){const D=new y.ExtHostTerminal(this._proxy,(0,m.generateUuid)(),k,k.name);return this._terminals.push(D),D.create(k,this._serializeParentTerminal(k,S)),D.value}};C=je([He(0,L.IExtHostRpcService)],C),e.ExtHostTerminalService=C}),define(pe[262],ve([0,1,5,14,170,6,26,2,37,23,28,7,12,52,3,120,77,11]),function(Y,e,m,L,y,C,i,k,S,D,R,P,u,E,f,v,w,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTunnelService=e.tryFindRootPorts=e.findPorts=e.getRootProcesses=e.loadConnectionTable=e.parseIpAddress=e.loadListeningPorts=e.getSockets=void 0;class p{constructor(h,l,b){this.remoteAddress=h,this.localAddress=l,this._dispose=b,this._onDispose=new f.Emitter,this.onDidDispose=this._onDispose.event}dispose(){return this._onDispose.fire(),this._dispose()}}function s(c){const h=c.trim().split(`
`),l=[];return h.forEach(T=>{const A=/\/proc\/(\d+)\/fd\/\d+ -> socket:\[(\d+)\]/.exec(T);A&&A.length>=3&&l.push({pid:parseInt(A[1],10),socket:parseInt(A[2],10)})}),l.reduce((T,A)=>(T[A.socket]=A,T),{})}e.getSockets=s;function r(...c){const h=[].concat(...c.map(a));return[...new Map(h.filter(l=>l.st==="0A").map(l=>{const b=l.local_address.split(":");return{socket:parseInt(l.inode,10),ip:g(b[0]),port:parseInt(b[1],16)}}).map(l=>[l.ip+":"+l.port,l])).values()]}e.loadListeningPorts=r;function g(c){let h="";if(c.length===8)for(let l=c.length-2;l>=0;l-=2)h+=parseInt(c.substr(l,2),16),l!==0&&(h+=".");else for(let l=c.length-4;l>=0;l-=4)h+=parseInt(c.substr(l,4),16).toString(16),l!==0&&(h+=":");return h}e.parseIpAddress=g;function a(c){const h=c.trim().split(`
`),l=h.shift().trim().split(/\s+/).filter(T=>T!=="rx_queue"&&T!=="tm->when");return h.map(T=>T.trim().split(/\s+/).reduce((A,x,O)=>(A[l[O]||O]=x,A),{}))}e.loadConnectionTable=a;function _(c){return!!c.match(/.*\.vscode-server-[a-zA-Z]+\/bin.*/)||c.indexOf("out/vs/server/main.js")!==-1||c.indexOf("_productName=VSCode")!==-1}function n(c){const h=c.trim().split(`
`),l=[];return h.forEach(b=>{const T=/^\d+\s+\D+\s+root\s+(\d+)\s+(\d+).+\d+\:\d+\:\d+\s+(.+)$/.exec(b);T&&T.length>=4&&l.push({pid:parseInt(T[1],10),ppid:parseInt(T[2]),cmd:T[3]})}),l}e.getRootProcesses=n;async function t(c,h,l){const b=l.reduce((A,x)=>(A[x.pid]=x,A),{}),T=[];return c.forEach(({socket:A,ip:x,port:O})=>{const F=h[A]?h[A].pid:void 0,W=F?b[F]?.cmd:void 0;F&&W&&!_(W)&&T.push({host:x,port:O,detail:W,pid:F})}),T}e.findPorts=t;function o(c,h,l){const b=new Map,T=n(h);for(const A of c){const x=l.get(A.port);if(x){b.set(A.port,x);continue}const O=T.find(F=>F.cmd.includes(`${A.port}`));if(O){let F=O,W;do W=T.find(M=>M.ppid===F.pid),W&&(F=W);while(W);b.set(A.port,{host:A.ip,port:A.port,pid:F.pid,detail:F.cmd,ppid:F.ppid})}else b.set(A.port,{host:A.ip,port:A.port,ppid:Number.MAX_VALUE})}return b}e.tryFindRootPorts=o;let d=class extends C.Disposable{constructor(h,l,b){super();this.logService=b,this._showCandidatePort=()=>Promise.resolve(!0),this._extensionTunnels=new Map,this._onDidChangeTunnels=new f.Emitter,this.onDidChangeTunnels=this._onDidChangeTunnels.event,this._candidateFindingEnabled=!1,this._foundRootPorts=new Map,this._providerHandleCounter=0,this._portAttributesProviders=new Map,this._proxy=h.getProxy(m.MainContext.MainThreadTunnelService),u.isLinux&&l.remote.isRemote&&l.remote.authority&&this._proxy.$setRemoteTunnelService(process.pid)}async openTunnel(h,l){this.logService.trace(`ForwardedPorts: (ExtHostTunnelService) ${h.identifier.value} called openTunnel API for ${l.remoteAddress.host}:${l.remoteAddress.port}.`);const b=await this._proxy.$openTunnel(l,h.displayName);if(b){const T=new p(b.remoteAddress,b.localAddress,()=>this._proxy.$closeTunnel(b.remoteAddress));return this._register(T),T}}async getTunnels(){return this._proxy.$getTunnels()}calculateDelay(h){return Math.max(h*20,2e3)}nextPortAttributesProviderHandle(){return this._providerHandleCounter++}registerPortsAttributesProvider(h,l){const b=this.nextPortAttributesProviderHandle();return this._portAttributesProviders.set(b,{selector:h,provider:l}),this._proxy.$registerPortsAttributesProvider(h,b),new P.Disposable(()=>{this._portAttributesProviders.delete(b),this._proxy.$unregisterPortsAttributesProvider(b)})}async $providePortAttributes(h,l,b,T,A){const x=[];for(const F of h){const W=this._portAttributesProviders.get(F);if(!W)return[];x.push(...await Promise.all(l.map(async M=>W.provider.providePortAttributes(M,b,T,A))))}const O=x.filter(F=>!!F);return O.length>0?O.map(F=>({autoForwardAction:F.autoForwardAction,port:F.port})):[]}async $registerCandidateFinder(h){if(h&&this._candidateFindingEnabled)return;this._candidateFindingEnabled=h;let l=new w.MovingAverage,b;for(;this._candidateFindingEnabled;){const T=new Date().getTime(),A=(await this.findCandidatePorts()).filter(O=>(0,v.isLocalhost)(O.host)||(0,v.isAllInterfaces)(O.host));this.logService.trace(`ForwardedPorts: (ExtHostTunnelService) found candidate ports ${A.map(O=>O.port).join(", ")}`);const x=new Date().getTime()-T;l.update(x),(!b||JSON.stringify(b)!==JSON.stringify(A))&&(b=A,await this._proxy.$onFoundNewCandidates(b)),await new Promise(O=>setTimeout(()=>O(),this.calculateDelay(l.value)))}}async setTunnelExtensionFunctions(h){if(h){if(h.candidatePortSource!==void 0&&this._proxy.$setCandidatePortSource(h.candidatePortSource),h.showCandidatePort&&(this._showCandidatePort=h.showCandidatePort,this._proxy.$setCandidateFilter()),h.tunnelFactory){this._forwardPortProvider=h.tunnelFactory;let l=h.tunnelFeatures?.privacyOptions??[];h.tunnelFeatures?.public&&l.length===0&&(l=[{id:"private",label:y.localize(0,null),themeIcon:"lock"},{id:"public",label:y.localize(1,null),themeIcon:"eye"}]),this._proxy.$setTunnelProvider({elevation:!!h.tunnelFeatures?.elevation,public:!!h.tunnelFeatures?.public,privacyOptions:l})}}else this._forwardPortProvider=void 0;return(0,C.toDisposable)(()=>{this._forwardPortProvider=void 0})}async $closeTunnel(h,l){if(this._extensionTunnels.has(h.host)){const b=this._extensionTunnels.get(h.host);b.has(h.port)&&(l&&b.get(h.port).disposeListener.dispose(),await b.get(h.port).tunnel.dispose(),b.delete(h.port))}}async $onDidTunnelsChange(){this._onDidChangeTunnels.fire()}async $forwardPort(h,l){if(this._forwardPortProvider)try{this.logService.trace("ForwardedPorts: (ExtHostTunnelService) Getting tunnel from provider.");const b=this._forwardPortProvider(h,l);if(this.logService.trace("ForwardedPorts: (ExtHostTunnelService) Got tunnel promise from provider."),b!==void 0){const T=await b;this.logService.trace("ForwardedPorts: (ExtHostTunnelService) Successfully awaited tunnel from provider."),this._extensionTunnels.has(h.remoteAddress.host)||this._extensionTunnels.set(h.remoteAddress.host,new Map);const A=this._register(T.onDidDispose(()=>(this.logService.trace("ForwardedPorts: (ExtHostTunnelService) Extension fired tunnel's onDidDispose."),this._proxy.$closeTunnel(T.remoteAddress))));return this._extensionTunnels.get(h.remoteAddress.host).set(h.remoteAddress.port,{tunnel:T,disposeListener:A}),E.TunnelDto.fromApiTunnel(T)}else this.logService.trace("ForwardedPorts: (ExtHostTunnelService) Tunnel is undefined")}catch(b){this.logService.trace("ForwardedPorts: (ExtHostTunnelService) tunnel provider error")}}async $applyCandidateFilter(h){const l=await Promise.all(h.map(T=>this._showCandidatePort(T.host,T.port,T.detail??""))),b=h.filter((T,A)=>l[A]);return this.logService.trace(`ForwardedPorts: (ExtHostTunnelService) filtered from ${h.map(T=>T.port).join(", ")} to ${b.map(T=>T.port).join(", ")}`),b}async findCandidatePorts(){let h="",l="";try{h=await R.Promises.readFile("/proc/net/tcp","utf8"),l=await R.Promises.readFile("/proc/net/tcp6","utf8")}catch(U){}const b=r(h,l),T=await new Promise(U=>{(0,S.exec)("ls -l /proc/[0-9]*/fd/[0-9]* | grep socket:",(z,K,N)=>{U(K)})}),A=s(T),x=await R.Promises.readdir("/proc"),O=[];for(let U of x)try{const z=Number(U),K=D.joinPath(k.URI.file("/proc"),U);if((await R.Promises.stat(K.fsPath)).isDirectory()&&!isNaN(z)){const j=await R.Promises.readlink(D.joinPath(K,"cwd").fsPath),H=await R.Promises.readFile(D.joinPath(K,"cmdline").fsPath,"utf8");O.push({pid:z,cwd:j,cmd:H})}}catch(z){}const F=[],W=b.filter(U=>{const z=A[U.socket];return z||F.push(U),z}),M=t(W,A,O);let B;if(this.logService.trace(`ForwardedPorts: (ExtHostTunnelService) number of possible root ports ${F.length}`),F.length>0){const U=await new Promise(z=>{(0,S.exec)("ps -F -A -l | grep root",(K,N,j)=>{z(N)})});this._foundRootPorts=o(F,U,this._foundRootPorts),B=Array.from(this._foundRootPorts.values()),this.logService.trace(`ForwardedPorts: (ExtHostTunnelService) heuristic ports ${B.join(", ")}`)}return M.then(U=>B?U.concat(B):U)}};d=je([He(0,L.IExtHostRpcService),He(1,i.IExtHostInitDataService),He(2,I.ILogService)],d),e.ExtHostTunnelService=d}),define(pe[263],ve([0,1,18,22,21,15,3,6,102,227,53]),function(Y,e,m,L,y,C,i,k,S,D,R){"use strict";var P;Object.defineProperty(e,"__esModule",{value:!0}),e.RPCProtocol=e.ResponsiveState=e.RequestInitiator=e.parseJsonAndRestoreBufferRefs=e.stringifyJsonWithBufferRefs=void 0;function u(b,T){try{return JSON.stringify(b,T)}catch(A){return"null"}}const E="$$ref$$",f={[E]:-1};class v{constructor(T,A){this.jsonString=T,this.referencedBuffers=A}}function w(b,T=null,A=!1){const x=[];return{jsonString:(A?u:JSON.stringify)(b,(F,W)=>{if(typeof W=="undefined")return f;if(typeof W=="object"){if(W instanceof L.VSBuffer){const M=x.push(W)-1;return{[E]:M}}if(T)return T(F,W)}return W}),referencedBuffers:x}}e.stringifyJsonWithBufferRefs=w;function I(b,T,A){return JSON.parse(b,(x,O)=>{if(O){const F=O[E];if(typeof F=="number")return T[F];if(A&&O.$mid===1)return A.transformIncoming(O)}return O})}e.parseJsonAndRestoreBufferRefs=I;function p(b,T){return JSON.stringify(b,T)}function s(b){return b?(T,A)=>A&&A.$mid===1?b.transformOutgoing(A):A:null}var r;(function(b){b[b.LocalSide=0]="LocalSide",b[b.OtherSide=1]="OtherSide"})(r=e.RequestInitiator||(e.RequestInitiator={}));var g;(function(b){b[b.Responsive=0]="Responsive",b[b.Unresponsive=1]="Unresponsive"})(g=e.ResponsiveState||(e.ResponsiveState={}));const a=()=>{},_=Symbol.for("rpcProtocol"),n=Symbol.for("rpcProxy");class t extends k.Disposable{constructor(T,A=null,x=null){super();this[P]=!0,this._onDidChangeResponsiveState=this._register(new i.Emitter),this.onDidChangeResponsiveState=this._onDidChangeResponsiveState.event,this._protocol=T,this._logger=A,this._uriTransformer=x,this._uriReplacer=s(this._uriTransformer),this._isDisposed=!1,this._locals=[],this._proxies=[];for(let O=0,F=R.ProxyIdentifier.count;O<F;O++)this._locals[O]=null,this._proxies[O]=null;this._lastMessageId=0,this._cancelInvokedHandlers=Object.create(null),this._pendingRPCReplies={},this._responsiveState=0,this._unacknowledgedCount=0,this._unresponsiveTime=0,this._asyncCheckUresponsive=this._register(new m.RunOnceScheduler(()=>this._checkUnresponsive(),1e3)),this._protocol.onMessage(O=>this._receiveOneMessage(O))}dispose(){this._isDisposed=!0,Object.keys(this._pendingRPCReplies).forEach(T=>{this._pendingRPCReplies[T].resolveErr(C.canceled())})}drain(){return typeof this._protocol.drain=="function"?this._protocol.drain():Promise.resolve()}_onWillSendRequest(T){this._unacknowledgedCount===0&&(this._unresponsiveTime=Date.now()+t.UNRESPONSIVE_TIME),this._unacknowledgedCount++,this._asyncCheckUresponsive.isScheduled()||this._asyncCheckUresponsive.schedule()}_onDidReceiveAcknowledge(T){this._unresponsiveTime=Date.now()+t.UNRESPONSIVE_TIME,this._unacknowledgedCount--,this._unacknowledgedCount===0&&this._asyncCheckUresponsive.cancel(),this._setResponsiveState(0)}_checkUnresponsive(){this._unacknowledgedCount!==0&&(Date.now()>this._unresponsiveTime?this._setResponsiveState(1):this._asyncCheckUresponsive.schedule())}_setResponsiveState(T){this._responsiveState!==T&&(this._responsiveState=T,this._onDidChangeResponsiveState.fire(this._responsiveState))}get responsiveState(){return this._responsiveState}transformIncomingURIs(T){return this._uriTransformer?(0,S.transformIncomingURIs)(T,this._uriTransformer):T}getProxy(T){const{nid:A,sid:x}=T;return this._proxies[A]||(this._proxies[A]=this._createProxy(A,x)),this._proxies[A]}_createProxy(T,A){let x={get:(O,F)=>(typeof F=="string"&&!O[F]&&F.charCodeAt(0)===36&&(O[F]=(...W)=>this._remoteCall(T,F,W)),F===n?A:O[F])};return new Proxy(Object.create(null),x)}set(T,A){return this._locals[T.nid]=A,A}assertRegistered(T){for(let A=0,x=T.length;A<x;A++){const O=T[A];if(!this._locals[O.nid])throw new Error(`Missing actor ${O.sid} (isMain: ${O.isMain})`)}}_receiveOneMessage(T){if(this._isDisposed)return;const A=T.byteLength,x=o.read(T,0),O=x.readUInt8(),F=x.readUInt32();switch(O){case 1:case 2:{let{rpcId:W,method:M,args:B}=c.deserializeRequestJSONArgs(x);this._uriTransformer&&(B=(0,S.transformIncomingURIs)(B,this._uriTransformer)),this._receiveRequest(A,F,W,M,B,O===2);break}case 3:case 4:{let{rpcId:W,method:M,args:B}=c.deserializeRequestMixedArgs(x);this._uriTransformer&&(B=(0,S.transformIncomingURIs)(B,this._uriTransformer)),this._receiveRequest(A,F,W,M,B,O===4);break}case 5:{this._logger&&this._logger.logIncoming(A,F,0,"ack"),this._onDidReceiveAcknowledge(F);break}case 6:{this._receiveCancel(A,F);break}case 7:{this._receiveReply(A,F,void 0);break}case 9:{let W=c.deserializeReplyOKJSON(x);this._uriTransformer&&(W=(0,S.transformIncomingURIs)(W,this._uriTransformer)),this._receiveReply(A,F,W);break}case 10:{const W=c.deserializeReplyOKJSONWithBuffers(x,this._uriTransformer);this._receiveReply(A,F,W);break}case 8:{let W=c.deserializeReplyOKVSBuffer(x);this._receiveReply(A,F,W);break}case 11:{let W=c.deserializeReplyErrError(x);this._uriTransformer&&(W=(0,S.transformIncomingURIs)(W,this._uriTransformer)),this._receiveReplyErr(A,F,W);break}case 12:{this._receiveReplyErr(A,F,void 0);break}default:console.error("received unexpected message"),console.error(T)}}_receiveRequest(T,A,x,O,F,W){this._logger&&this._logger.logIncoming(T,A,1,`receiveRequest ${(0,R.getStringIdentifierForProxy)(x)}.${O}(`,F);const M=String(A);let B,U;if(W){const K=new y.CancellationTokenSource;F.push(K.token),B=this._invokeHandler(x,O,F),U=()=>K.cancel()}else B=this._invokeHandler(x,O,F),U=a;this._cancelInvokedHandlers[M]=U;const z=c.serializeAcknowledged(A);this._logger&&this._logger.logOutgoing(z.byteLength,A,1,"ack"),this._protocol.send(z),B.then(K=>{delete this._cancelInvokedHandlers[M];const N=c.serializeReplyOK(A,K,this._uriReplacer);this._logger&&this._logger.logOutgoing(N.byteLength,A,1,"reply:",K),this._protocol.send(N)},K=>{delete this._cancelInvokedHandlers[M];const N=c.serializeReplyErr(A,K);this._logger&&this._logger.logOutgoing(N.byteLength,A,1,"replyErr:",K),this._protocol.send(N)})}_receiveCancel(T,A){this._logger&&this._logger.logIncoming(T,A,1,"receiveCancel");const x=String(A);this._cancelInvokedHandlers[x]&&this._cancelInvokedHandlers[x]()}_receiveReply(T,A,x){this._logger&&this._logger.logIncoming(T,A,0,"receiveReply:",x);const O=String(A);if(!this._pendingRPCReplies.hasOwnProperty(O))return;const F=this._pendingRPCReplies[O];delete this._pendingRPCReplies[O],F.resolveOk(x)}_receiveReplyErr(T,A,x){this._logger&&this._logger.logIncoming(T,A,0,"receiveReplyErr:",x);const O=String(A);if(!this._pendingRPCReplies.hasOwnProperty(O))return;const F=this._pendingRPCReplies[O];delete this._pendingRPCReplies[O];let W;x&&(x.$isError?(W=new Error,W.name=x.name,W.message=x.message,W.stack=x.stack):W=x),F.resolveErr(W)}_invokeHandler(T,A,x){try{return Promise.resolve(this._doInvokeHandler(T,A,x))}catch(O){return Promise.reject(O)}}_doInvokeHandler(T,A,x){const O=this._locals[T];if(!O)throw new Error("Unknown actor "+(0,R.getStringIdentifierForProxy)(T));let F=O[A];if(typeof F!="function")throw new Error("Unknown method "+A+" on actor "+(0,R.getStringIdentifierForProxy)(T));return F.apply(O,x)}_remoteCall(T,A,x){if(this._isDisposed)return Promise.reject(C.canceled());let O=null;if(x.length>0&&y.CancellationToken.isCancellationToken(x[x.length-1])&&(O=x.pop()),O&&O.isCancellationRequested)return Promise.reject(C.canceled());const F=c.serializeRequestArguments(x,this._uriReplacer),W=++this._lastMessageId,M=String(W),B=new D.LazyPromise;O&&O.onCancellationRequested(()=>{const z=c.serializeCancel(W);this._logger&&this._logger.logOutgoing(z.byteLength,W,0,"cancel"),this._protocol.send(c.serializeCancel(W))}),this._pendingRPCReplies[M]=B,this._onWillSendRequest(W);const U=c.serializeRequest(W,T,A,F,!!O);return this._logger&&this._logger.logOutgoing(U.byteLength,W,0,`request: ${(0,R.getStringIdentifierForProxy)(T)}.${A}(`,x),this._protocol.send(U),B}}e.RPCProtocol=t,P=_,t.UNRESPONSIVE_TIME=3*1e3;class o{constructor(T,A){this._buff=T,this._offset=A}static alloc(T,A,x){let O=new o(L.VSBuffer.alloc(x+1+4),0);return O.writeUInt8(T),O.writeUInt32(A),O}static read(T,A){return new o(T,A)}get buffer(){return this._buff}static sizeUInt8(){return 1}writeUInt8(T){this._buff.writeUInt8(T,this._offset),this._offset+=1}readUInt8(){const T=this._buff.readUInt8(this._offset);return this._offset+=1,T}writeUInt32(T){this._buff.writeUInt32BE(T,this._offset),this._offset+=4}readUInt32(){const T=this._buff.readUInt32BE(this._offset);return this._offset+=4,T}static sizeShortString(T){return 1+T.byteLength}writeShortString(T){this._buff.writeUInt8(T.byteLength,this._offset),this._offset+=1,this._buff.set(T,this._offset),this._offset+=T.byteLength}readShortString(){const T=this._buff.readUInt8(this._offset);this._offset+=1;const x=this._buff.slice(this._offset,this._offset+T).toString();return this._offset+=T,x}static sizeLongString(T){return 4+T.byteLength}writeLongString(T){this._buff.writeUInt32BE(T.byteLength,this._offset),this._offset+=4,this._buff.set(T,this._offset),this._offset+=T.byteLength}readLongString(){const T=this._buff.readUInt32BE(this._offset);this._offset+=4;const x=this._buff.slice(this._offset,this._offset+T).toString();return this._offset+=T,x}writeBuffer(T){this._buff.writeUInt32BE(T.byteLength,this._offset),this._offset+=4,this._buff.set(T,this._offset),this._offset+=T.byteLength}static sizeVSBuffer(T){return 4+T.byteLength}writeVSBuffer(T){this._buff.writeUInt32BE(T.byteLength,this._offset),this._offset+=4,this._buff.set(T,this._offset),this._offset+=T.byteLength}readVSBuffer(){const T=this._buff.readUInt32BE(this._offset);this._offset+=4;const A=this._buff.slice(this._offset,this._offset+T);return this._offset+=T,A}static sizeMixedArray(T){let A=0;A+=1;for(let x=0,O=T.length;x<O;x++){const F=T[x];switch(A+=1,F.type){case 1:A+=this.sizeLongString(F.value);break;case 2:A+=this.sizeVSBuffer(F.value);break;case 3:A+=this.sizeUInt32,A+=this.sizeLongString(F.value);for(let W=0;W<F.buffers.length;++W)A+=this.sizeVSBuffer(F.buffers[W]);break;case 4:break}}return A}writeMixedArray(T){this._buff.writeUInt8(T.length,this._offset),this._offset+=1;for(let A=0,x=T.length;A<x;A++){const O=T[A];switch(O.type){case 1:this.writeUInt8(1),this.writeLongString(O.value);break;case 2:this.writeUInt8(2),this.writeVSBuffer(O.value);break;case 3:this.writeUInt8(3),this.writeUInt32(O.buffers.length),this.writeLongString(O.value);for(let F=0;F<O.buffers.length;++F)this.writeBuffer(O.buffers[F]);break;case 4:this.writeUInt8(4);break}}}readMixedArray(){const T=this._buff.readUInt8(this._offset);this._offset+=1;let A=new Array(T);for(let x=0;x<T;x++)switch(this.readUInt8()){case 1:A[x]=this.readLongString();break;case 2:A[x]=this.readVSBuffer();break;case 3:const F=this.readUInt32(),W=this.readLongString(),M=[];for(let B=0;B<F;++B)M.push(this.readVSBuffer());A[x]=new R.SerializableObjectWithBuffers(I(W,M,null));break;case 4:A[x]=void 0;break}return A}}o.sizeUInt32=4;var d;(function(b){b[b.Simple=0]="Simple",b[b.Mixed=1]="Mixed"})(d||(d={}));class c{static _useMixedArgSerialization(T){for(let A=0,x=T.length;A<x;A++)if(T[A]instanceof L.VSBuffer||T[A]instanceof R.SerializableObjectWithBuffers||typeof T[A]=="undefined")return!0;return!1}static serializeRequestArguments(T,A){if(this._useMixedArgSerialization(T)){const x=[];for(let O=0,F=T.length;O<F;O++){const W=T[O];if(W instanceof L.VSBuffer)x[O]={type:2,value:W};else if(typeof W=="undefined")x[O]={type:4};else if(W instanceof R.SerializableObjectWithBuffers){const{jsonString:M,referencedBuffers:B}=w(W.value,A);x[O]={type:3,value:L.VSBuffer.fromString(M),buffers:B}}else x[O]={type:1,value:L.VSBuffer.fromString(p(W,A))}}return{type:1,args:x}}return{type:0,args:p(T,A)}}static serializeRequest(T,A,x,O,F){switch(O.type){case 0:return this._requestJSONArgs(T,A,x,O.args,F);case 1:return this._requestMixedArgs(T,A,x,O.args,F)}}static _requestJSONArgs(T,A,x,O,F){const W=L.VSBuffer.fromString(x),M=L.VSBuffer.fromString(O);let B=0;B+=o.sizeUInt8(),B+=o.sizeShortString(W),B+=o.sizeLongString(M);let U=o.alloc(F?2:1,T,B);return U.writeUInt8(A),U.writeShortString(W),U.writeLongString(M),U.buffer}static deserializeRequestJSONArgs(T){const A=T.readUInt8(),x=T.readShortString(),O=T.readLongString();return{rpcId:A,method:x,args:JSON.parse(O)}}static _requestMixedArgs(T,A,x,O,F){const W=L.VSBuffer.fromString(x);let M=0;M+=o.sizeUInt8(),M+=o.sizeShortString(W),M+=o.sizeMixedArray(O);let B=o.alloc(F?4:3,T,M);return B.writeUInt8(A),B.writeShortString(W),B.writeMixedArray(O),B.buffer}static deserializeRequestMixedArgs(T){const A=T.readUInt8(),x=T.readShortString(),O=T.readMixedArray(),F=new Array(O.length);for(let W=0,M=O.length;W<M;W++){const B=O[W];typeof B=="string"?F[W]=JSON.parse(B):F[W]=B}return{rpcId:A,method:x,args:F}}static serializeAcknowledged(T){return o.alloc(5,T,0).buffer}static serializeCancel(T){return o.alloc(6,T,0).buffer}static serializeReplyOK(T,A,x){if(typeof A=="undefined")return this._serializeReplyOKEmpty(T);if(A instanceof L.VSBuffer)return this._serializeReplyOKVSBuffer(T,A);if(A instanceof R.SerializableObjectWithBuffers){const{jsonString:O,referencedBuffers:F}=w(A.value,x,!0);return this._serializeReplyOKJSONWithBuffers(T,O,F)}else return this._serializeReplyOKJSON(T,u(A,x))}static _serializeReplyOKEmpty(T){return o.alloc(7,T,0).buffer}static _serializeReplyOKVSBuffer(T,A){let x=0;x+=o.sizeVSBuffer(A);let O=o.alloc(8,T,x);return O.writeVSBuffer(A),O.buffer}static deserializeReplyOKVSBuffer(T){return T.readVSBuffer()}static _serializeReplyOKJSON(T,A){const x=L.VSBuffer.fromString(A);let O=0;O+=o.sizeLongString(x);let F=o.alloc(9,T,O);return F.writeLongString(x),F.buffer}static _serializeReplyOKJSONWithBuffers(T,A,x){const O=L.VSBuffer.fromString(A);let F=0;F+=o.sizeUInt32,F+=o.sizeLongString(O);for(const M of x)F+=o.sizeVSBuffer(M);let W=o.alloc(10,T,F);W.writeUInt32(x.length),W.writeLongString(O);for(const M of x)W.writeBuffer(M);return W.buffer}static deserializeReplyOKJSON(T){const A=T.readLongString();return JSON.parse(A)}static deserializeReplyOKJSONWithBuffers(T,A){const x=T.readUInt32(),O=T.readLongString(),F=[];for(let W=0;W<x;++W)F.push(T.readVSBuffer());return new R.SerializableObjectWithBuffers(I(O,F,A))}static serializeReplyErr(T,A){return A?this._serializeReplyErrEror(T,A):this._serializeReplyErrEmpty(T)}static _serializeReplyErrEror(T,A){const x=L.VSBuffer.fromString(u(C.transformErrorForSerialization(A),null));let O=0;O+=o.sizeLongString(x);let F=o.alloc(11,T,O);return F.writeLongString(x),F.buffer}static deserializeReplyErrError(T){const A=T.readLongString();return JSON.parse(A)}static _serializeReplyErrEmpty(T){return o.alloc(12,T,0).buffer}}var h;(function(b){b[b.RequestJSONArgs=1]="RequestJSONArgs",b[b.RequestJSONArgsWithCancellation=2]="RequestJSONArgsWithCancellation",b[b.RequestMixedArgs=3]="RequestMixedArgs",b[b.RequestMixedArgsWithCancellation=4]="RequestMixedArgsWithCancellation",b[b.Acknowledged=5]="Acknowledged",b[b.Cancel=6]="Cancel",b[b.ReplyOKEmpty=7]="ReplyOKEmpty",b[b.ReplyOKVSBuffer=8]="ReplyOKVSBuffer",b[b.ReplyOKJSON=9]="ReplyOKJSON",b[b.ReplyOKJSONWithBuffers=10]="ReplyOKJSONWithBuffers",b[b.ReplyErrError=11]="ReplyErrError",b[b.ReplyErrEmpty=12]="ReplyErrEmpty"})(h||(h={}));var l;(function(b){b[b.String=1]="String",b[b.VSBuffer=2]="VSBuffer",b[b.SerializedObjectWithBuffers=3]="SerializedObjectWithBuffers",b[b.Undefined=4]="Undefined"})(l||(l={}))}),define(pe[264],ve([0,1,4]),function(Y,e,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IRemoteAgentService=e.RemoteExtensionLogFileName=void 0,e.RemoteExtensionLogFileName="remoteagent",e.IRemoteAgentService=(0,m.createDecorator)("remoteAgentService")}),define(pe[265],ve([0,1,10,9,12,2,4,62,43,222,264]),function(Y,e,m,L,y,C,i,k,S,D,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractPathService=e.IPathService=void 0,e.IPathService=(0,i.createDecorator)("pathService");let P=class Vi{constructor(E,f,v,w){this.localUserHome=E,this.remoteAgentService=f,this.environmentService=v,this.contextService=w,this.resolveOS=(async()=>(await this.remoteAgentService.getEnvironment())?.os||y.OS)(),this.resolveUserHome=(async()=>{const I=await this.remoteAgentService.getEnvironment();return this.maybeUnresolvedUserHome=I?.userHome||E})()}get defaultUriScheme(){return Vi.findDefaultUriScheme(this.environmentService,this.contextService)}static findDefaultUriScheme(E,f){if(E.remoteAuthority)return m.Schemas.vscodeRemote;const v=(0,k.getVirtualWorkspaceScheme)(f.getWorkspace());if(v)return v;const w=f.getWorkspace().folders[0];if(w)return w.uri.scheme;const I=f.getWorkspace().configuration;return I?I.scheme:m.Schemas.file}async userHome(E){return E?.preferLocal?this.localUserHome:this.resolveUserHome}get resolvedUserHome(){return this.maybeUnresolvedUserHome}get path(){return this.resolveOS.then(E=>E===1?L.win32:L.posix)}async fileURI(E){let f="";if(await this.resolveOS===1&&(E=E.replace(/\\/g,"/")),E[0]==="/"&&E[1]==="/"){const w=E.indexOf("/",2);w===-1?(f=E.substring(2),E="/"):(f=E.substring(2,w),E=E.substring(w)||"/")}return C.URI.from({scheme:m.Schemas.file,authority:f,path:E,query:"",fragment:""})}};P=je([He(1,R.IRemoteAgentService),He(2,D.IWorkbenchEnvironmentService),He(3,S.IWorkspaceContextService)],P),e.AbstractPathService=P}),define(pe[69],ve([0,1]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TextSearchCompleteMessageType=e.Range=e.Position=void 0;class m{constructor(i,k){this.line=i,this.character=k}isBefore(i){return!1}isBeforeOrEqual(i){return!1}isAfter(i){return!1}isAfterOrEqual(i){return!1}isEqual(i){return!1}compareTo(i){return 0}translate(i,k){return new m(0,0)}with(i){return new m(0,0)}}e.Position=m;class L{constructor(i,k,S,D){this.isEmpty=!1,this.isSingleLine=!1,this.start=new m(i,k),this.end=new m(S,D)}contains(i){return!1}isEqual(i){return!1}intersection(i){}union(i){return new L(0,0,0,0)}with(i){return new L(0,0,0,0)}}e.Range=L;var y;(function(C){C[C.Information=1]="Information",C[C.Warning=2]="Warning"})(y=e.TextSearchCompleteMessageType||(e.TextSearchCompleteMessageType={}))}),define(pe[33],ve([0,1,16,31,25,30,8,4,9,15,69,13]),function(Y,e,m,L,y,C,i,k,S,D,R,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.QueryGlobTester=e.resolvePatternsForProvider=e.SerializableFileMatch=e.isFilePatternMatch=e.isSerializedFileMatch=e.isSerializedSearchSuccess=e.isSerializedSearchComplete=e.serializeSearchError=e.deserializeSearchError=e.SearchError=e.SearchErrorCode=e.pathIncludedInQuery=e.getExcludes=e.SearchSortOrder=e.OneLineRange=e.SearchRange=e.TextSearchMatch=e.FileMatch=e.SearchCompletionExitCode=e.isProgressMessage=e.isFileMatch=e.resultIsMatch=e.QueryType=e.SearchProviderType=e.ISearchService=e.SEARCH_EXCLUDE_CONFIG=e.VIEW_ID=e.PANEL_ID=e.VIEWLET_ID=e.TextSearchCompleteMessageType=void 0,Object.defineProperty(e,"TextSearchCompleteMessageType",{enumerable:!0,get:function(){return R.TextSearchCompleteMessageType}}),e.VIEWLET_ID="workbench.view.search",e.PANEL_ID="workbench.panel.search",e.VIEW_ID="workbench.view.search",e.SEARCH_EXCLUDE_CONFIG="search.exclude";const u="\u27EA ",E=" characters skipped \u27EB",f=(u.length+E.length+5)*2;e.ISearchService=(0,k.createDecorator)("searchService");var v;(function(z){z[z.file=0]="file",z[z.text=1]="text"})(v=e.SearchProviderType||(e.SearchProviderType={}));var w;(function(z){z[z.File=1]="File",z[z.Text=2]="Text"})(w=e.QueryType||(e.QueryType={}));function I(z){return!!z.preview}e.resultIsMatch=I;function p(z){return!!z.resource}e.isFileMatch=p;function s(z){return!!z.message}e.isProgressMessage=s;var r;(function(z){z[z.Normal=0]="Normal",z[z.NewSearchStarted=1]="NewSearchStarted"})(r=e.SearchCompletionExitCode||(e.SearchCompletionExitCode={}));class g{constructor(K){this.resource=K,this.results=[]}}e.FileMatch=g;class a{constructor(K,N,j){this.ranges=N;const H=Array.isArray(N)?N:[N];if(j&&j.matchLines===1&&_(H)){K=(0,i.getNLines)(K,j.matchLines);let V="",q=0,ne=0;const fe=Math.floor(j.charsPerLine/5),ye=[];for(const ke of H){const Be=Math.max(ke.startColumn-fe,0),We=ke.startColumn+j.charsPerLine;if(Be>ne+fe+f){const ze=u+(Be-ne)+E;V+=ze+K.slice(Be,We),q+=Be-(ne+ze.length)}else V+=K.slice(ne,We);ye.push(new t(0,ke.startColumn-q,ke.endColumn-q)),ne=We}this.preview={text:V,matches:Array.isArray(this.ranges)?ye:ye[0]}}else{const V=Array.isArray(N)?N[0].startLineNumber:N.startLineNumber;this.preview={text:K,matches:(0,m.mapArrayOrNot)(N,q=>new n(q.startLineNumber-V,q.startColumn,q.endLineNumber-V,q.endColumn))}}}}e.TextSearchMatch=a;function _(z){const K=z[0].startLineNumber;for(const N of z)if(N.startLineNumber!==K||N.endLineNumber!==K)return!1;return!0}class n{constructor(K,N,j,H){this.startLineNumber=K,this.startColumn=N,this.endLineNumber=j,this.endColumn=H}}e.SearchRange=n;class t extends n{constructor(K,N,j){super(K,N,K,j)}}e.OneLineRange=t;var o;(function(z){z.Default="default",z.FileNames="fileNames",z.Type="type",z.Modified="modified",z.CountDescending="countDescending",z.CountAscending="countAscending"})(o=e.SearchSortOrder||(e.SearchSortOrder={}));function d(z,K=!0){const N=z&&z.files&&z.files.exclude,j=K&&z&&z.search&&z.search.exclude;if(!N&&!j)return;if(!N||!j)return N||j;let H=Object.create(null);return H=y.mixin(H,y.deepClone(N)),H=y.mixin(H,y.deepClone(j),!0),H}e.getExcludes=d;function c(z,K){return z.excludePattern&&L.match(z.excludePattern,K)?!1:z.includePattern||z.usingSearchPaths?z.includePattern&&L.match(z.includePattern,K)?!0:z.usingSearchPaths?!!z.folderQueries&&z.folderQueries.some(N=>{const j=N.folder.fsPath;if(C.isEqualOrParent(K,j)){const H=S.relative(j,K);return!N.includePattern||!!L.match(N.includePattern,H)}else return!1}):!1:!0}e.pathIncludedInQuery=c;var h;(function(z){z[z.unknownEncoding=1]="unknownEncoding",z[z.regexParseError=2]="regexParseError",z[z.globParseError=3]="globParseError",z[z.invalidLiteral=4]="invalidLiteral",z[z.rgProcessError=5]="rgProcessError",z[z.other=6]="other",z[z.canceled=7]="canceled"})(h=e.SearchErrorCode||(e.SearchErrorCode={}));class l extends Error{constructor(K,N){super(K);this.code=N}}e.SearchError=l;function b(z){const K=z.message;if((0,D.isPromiseCanceledError)(z))return new l(K,h.canceled);try{const N=JSON.parse(K);return new l(N.message,N.code)}catch(N){return new l(K,h.other)}}e.deserializeSearchError=b;function T(z){const K={message:z.message,code:z.code};return new Error(JSON.stringify(K))}e.serializeSearchError=T;function A(z){return z.type==="error"?!0:z.type==="success"}e.isSerializedSearchComplete=A;function x(z){return z.type==="success"}e.isSerializedSearchSuccess=x;function O(z){return!!z.path}e.isSerializedFileMatch=O;function F(z,K){const N=z.searchPath?z.searchPath:z.relativePath;return(0,i.fuzzyContains)(N,K)}e.isFilePatternMatch=F;class W{constructor(K){this.path=K,this.results=[]}addMatch(K){this.results.push(K)}serialize(){return{path:this.path,results:this.results,numMatches:this.results.length}}}e.SerializableFileMatch=W;function M(z,K){const N={...z||{},...K||{}};return Object.keys(N).filter(j=>{const H=N[j];return typeof H=="boolean"&&H})}e.resolvePatternsForProvider=M;class B{constructor(K,N){this._parsedIncludeExpression=null,this._excludeExpression={...K.excludePattern||{},...N.excludePattern||{}},this._parsedExcludeExpression=L.parse(this._excludeExpression);let j=K.includePattern;N.includePattern&&(j?j={...j,...N.includePattern}:j=N.includePattern),j&&(this._parsedIncludeExpression=L.parse(j))}matchesExcludesSync(K,N,j){return!!(this._parsedExcludeExpression&&this._parsedExcludeExpression(K,N,j))}includedInQuerySync(K,N,j){return!(this._parsedExcludeExpression&&this._parsedExcludeExpression(K,N,j)||this._parsedIncludeExpression&&!this._parsedIncludeExpression(K,N,j))}includedInQuery(K,N,j){const H=this._parsedExcludeExpression(K,N,j),V=()=>this._parsedIncludeExpression?!!this._parsedIncludeExpression(K,N,j):!0;return(0,P.isPromise)(H)?H.then(q=>q?!1:V()):V()}hasSiblingExcludeClauses(){return U(this._excludeExpression)}}e.QueryGlobTester=B;function U(z){for(const K in z)if(typeof z[K]!="boolean")return!0;return!1}}),define(pe[35],ve([0,1,16,18,21,3,24,10,77,23,8,13,2,168,4,11,188,43,44,26,14,7,33,5]),function(Y,e,m,L,y,C,i,k,S,D,R,P,u,E,f,v,w,I,p,s,r,g,a,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostWorkspace=e.ExtHostWorkspace=void 0;function n(T,A,x){return new D.ExtUri(O=>c(O,x)).isEqual(T,A)}function t(T,A,x){return n(T.uri,A.uri,x)?0:(0,R.compare)(T.uri.toString(),A.uri.toString())}function o(T,A,x){return T.index!==A.index?T.index<A.index?-1:1:n(T.uri,A.uri,x)?(0,R.compare)(T.name,A.name):(0,R.compare)(T.uri.toString(),A.uri.toString())}function d(T,A,x,O){const F=T.slice(0).sort((M,B)=>x(M,B,O)),W=A.slice(0).sort((M,B)=>x(M,B,O));return(0,m.delta)(F,W,(M,B)=>x(M,B,O))}function c(T,A){const x=A.getCapabilities(T.scheme);return!(x&&x&1024)}class h extends I.Workspace{constructor(A,x,O,F,W,M,B){super(A,O.map(U=>new I.WorkspaceFolder(U)),F,W,B);this._name=x,this._isUntitled=M,this._workspaceFolders=[],this._structure=i.TernarySearchTree.forUris(B),O.forEach(U=>{this._workspaceFolders.push(U),this._structure.set(U.uri,U)})}static toExtHostWorkspace(A,x,O,F){if(!A)return{workspace:null,added:[],removed:[]};const{id:W,name:M,folders:B,configuration:U,transient:z,isUntitled:K}=A,N=[],j=x;x?B.forEach((ne,fe)=>{const ye=u.URI.revive(ne.uri),ke=h._findFolder(O||x,ye,F);ke?(ke.name=ne.name,ke.index=ne.index,N.push(ke)):N.push({uri:ye,name:ne.name,index:fe})}):N.push(...B.map(({uri:ne,name:fe,index:ye})=>({uri:u.URI.revive(ne),name:fe,index:ye}))),N.sort((ne,fe)=>ne.index<fe.index?-1:1);const H=new h(W,M,N,!!z,U?u.URI.revive(U):null,!!K,ne=>c(ne,F)),{added:V,removed:q}=d(j?j.workspaceFolders:[],H.workspaceFolders,t,F);return{workspace:H,added:V,removed:q}}static _findFolder(A,x,O){for(let F=0;F<A.folders.length;F++){const W=A.workspaceFolders[F];if(n(W.uri,x,O))return W}}get name(){return this._name}get isUntitled(){return this._isUntitled}get workspaceFolders(){return this._workspaceFolders.slice(0)}getWorkspaceFolder(A,x){return x&&this._structure.get(A)&&(A=(0,D.dirname)(A)),this._structure.findSubstr(A)}resolveWorkspaceFolder(A){return this._structure.get(A)}}let l=class{constructor(A,x,O,F){this._onDidChangeWorkspace=new C.Emitter,this.onDidChangeWorkspace=this._onDidChangeWorkspace.event,this._onDidGrantWorkspaceTrust=new C.Emitter,this.onDidGrantWorkspaceTrust=this._onDidGrantWorkspaceTrust.event,this._activeSearchCallbacks=[],this._trusted=!1,this._logService=F,this._extHostFileSystemInfo=O,this._requestIdProvider=new S.Counter,this._barrier=new L.Barrier,this._proxy=A.getProxy(_.MainContext.MainThreadWorkspace),this._messageService=A.getProxy(_.MainContext.MainThreadMessageService);const W=x.workspace;this._confirmedWorkspace=W?new h(W.id,W.name,[],!!W.transient,W.configuration?u.URI.revive(W.configuration):null,!!W.isUntitled,M=>c(M,O)):void 0}$initializeWorkspace(A,x){this._trusted=x,this.$acceptWorkspaceData(A),this._barrier.open()}waitForInitializeCall(){return this._barrier.wait()}get workspace(){return this._actualWorkspace}get name(){return this._actualWorkspace?this._actualWorkspace.name:void 0}get workspaceFile(){if(this._actualWorkspace&&this._actualWorkspace.configuration)return this._actualWorkspace.isUntitled?u.URI.from({scheme:k.Schemas.untitled,path:(0,D.basename)((0,D.dirname)(this._actualWorkspace.configuration))}):this._actualWorkspace.configuration}get _actualWorkspace(){return this._unconfirmedWorkspace||this._confirmedWorkspace}getWorkspaceFolders(){if(!!this._actualWorkspace)return this._actualWorkspace.workspaceFolders.slice(0)}async getWorkspaceFolders2(){if(await this._barrier.wait(),!!this._actualWorkspace)return this._actualWorkspace.workspaceFolders.slice(0)}updateWorkspaceFolders(A,x,O,...F){const W=[];if(Array.isArray(F)&&F.forEach(K=>{u.URI.isUri(K.uri)&&!W.some(N=>n(N.uri,K.uri,this._extHostFileSystemInfo))&&W.push({uri:K.uri,name:K.name||(0,D.basenameOrAuthority)(K.uri)})}),this._unconfirmedWorkspace||[x,O].some(K=>typeof K!="number"||K<0)||O===0&&W.length===0)return!1;const M=this._actualWorkspace?this._actualWorkspace.workspaceFolders:[];if(x+O>M.length)return!1;const B=M.slice(0);B.splice(x,O,...W.map(K=>({uri:K.uri,name:K.name||(0,D.basenameOrAuthority)(K.uri),index:void 0})));for(let K=0;K<B.length;K++){const N=B[K];if(B.some((j,H)=>H!==K&&n(N.uri,j.uri,this._extHostFileSystemInfo)))return!1}B.forEach((K,N)=>K.index=N);const{added:U,removed:z}=d(M,B,o,this._extHostFileSystemInfo);if(U.length===0&&z.length===0)return!1;if(this._proxy){const K=A.displayName||A.name;this._proxy.$updateWorkspaceFolders(K,x,O,W).then(void 0,N=>{this._unconfirmedWorkspace=void 0,this._messageService.$showMessage(w.Severity.Error,(0,E.localize)(0,null,K,N.toString()),{extension:A},[])})}return this.trySetWorkspaceFolders(B),!0}getWorkspaceFolder(A,x){if(!!this._actualWorkspace)return this._actualWorkspace.getWorkspaceFolder(A,x)}async getWorkspaceFolder2(A,x){if(await this._barrier.wait(),!!this._actualWorkspace)return this._actualWorkspace.getWorkspaceFolder(A,x)}async resolveWorkspaceFolder(A){if(await this._barrier.wait(),!!this._actualWorkspace)return this._actualWorkspace.resolveWorkspaceFolder(A)}getPath(){if(!this._actualWorkspace)return;const{folders:A}=this._actualWorkspace;if(A.length!==0)return A[0].uri.fsPath}getRelativePath(A,x){let O,F="";if(typeof A=="string"?(O=u.URI.file(A),F=A):typeof A!="undefined"&&(O=A,F=A.fsPath),!O)return F;const W=this.getWorkspaceFolder(O,!0);if(!W)return F;typeof x=="undefined"&&this._actualWorkspace&&(x=this._actualWorkspace.folders.length>1);let M=(0,D.relativePath)(W.uri,O);return x&&W.name&&(M=`${W.name}/${M}`),M}trySetWorkspaceFolders(A){this._actualWorkspace&&(this._unconfirmedWorkspace=h.toExtHostWorkspace({id:this._actualWorkspace.id,name:this._actualWorkspace.name,configuration:this._actualWorkspace.configuration,folders:A,isUntitled:this._actualWorkspace.isUntitled},this._actualWorkspace,void 0,this._extHostFileSystemInfo).workspace||void 0)}$acceptWorkspaceData(A){const{workspace:x,added:O,removed:F}=h.toExtHostWorkspace(A,this._confirmedWorkspace,this._unconfirmedWorkspace,this._extHostFileSystemInfo);this._confirmedWorkspace=x||void 0,this._unconfirmedWorkspace=void 0,this._onDidChangeWorkspace.fire(Object.freeze({added:O,removed:F}))}findFiles(A,x,O,F,W=y.CancellationToken.None){this._logService.trace(`extHostWorkspace#findFiles: fileSearch, extension: ${F.value}, entryPoint: findFiles`);let M;if(x===null?M=!1:x&&(typeof x=="string"?M=x:M=x.pattern),W&&W.isCancellationRequested)return Promise.resolve([]);const{includePattern:B,folder:U}=b(A);return this._proxy.$startFileSearch((0,P.withUndefinedAsNull)(B),(0,P.withUndefinedAsNull)(U),(0,P.withUndefinedAsNull)(M),(0,P.withUndefinedAsNull)(O),W).then(z=>Array.isArray(z)?z.map(K=>u.URI.revive(K)):[])}async findTextInFiles(A,x,O,F,W=y.CancellationToken.None){this._logService.trace(`extHostWorkspace#findTextInFiles: textSearch, extension: ${F.value}, entryPoint: findTextInFiles`);const M=this._requestIdProvider.getNext(),B=typeof x.previewOptions=="undefined"?{matchLines:100,charsPerLine:1e4}:x.previewOptions,{includePattern:U,folder:z}=b(x.include),K=typeof x.exclude=="string"?x.exclude:x.exclude?x.exclude.pattern:void 0,N={ignoreSymlinks:typeof x.followSymlinks=="boolean"?!x.followSymlinks:void 0,disregardIgnoreFiles:typeof x.useIgnoreFiles=="boolean"?!x.useIgnoreFiles:void 0,disregardGlobalIgnoreFiles:typeof x.useGlobalIgnoreFiles=="boolean"?!x.useGlobalIgnoreFiles:void 0,disregardExcludeSettings:typeof x.useDefaultExcludes=="boolean"?!x.useDefaultExcludes:!0,fileEncoding:x.encoding,maxResults:x.maxResults,previewOptions:B,afterContext:x.afterContext,beforeContext:x.beforeContext,includePattern:U,excludePattern:K},j=!1;if(this._activeSearchCallbacks[M]=H=>{if(j)return;const V=u.URI.revive(H.resource);H.results.forEach(q=>{(0,a.resultIsMatch)(q)?O({uri:V,preview:{text:q.preview.text,matches:(0,m.mapArrayOrNot)(q.preview.matches,ne=>new g.Range(ne.startLineNumber,ne.startColumn,ne.endLineNumber,ne.endColumn))},ranges:(0,m.mapArrayOrNot)(q.ranges,ne=>new g.Range(ne.startLineNumber,ne.startColumn,ne.endLineNumber,ne.endColumn))}):O({uri:V,text:q.text,lineNumber:q.lineNumber})})},W.isCancellationRequested)return{};try{const H=await this._proxy.$startTextSearch(A,(0,P.withUndefinedAsNull)(z),N,M,W);return delete this._activeSearchCallbacks[M],H||{}}catch(H){throw delete this._activeSearchCallbacks[M],H}}$handleTextSearchResult(A,x){this._activeSearchCallbacks[x]&&this._activeSearchCallbacks[x](A)}saveAll(A){return this._proxy.$saveAll(A)}resolveProxy(A){return this._proxy.$resolveProxy(A)}get trusted(){return this._trusted}requestWorkspaceTrust(A){return this._proxy.$requestWorkspaceTrust(A)}$onDidGrantWorkspaceTrust(){this._trusted||(this._trusted=!0,this._onDidGrantWorkspaceTrust.fire())}};l=je([He(0,r.IExtHostRpcService),He(1,s.IExtHostInitDataService),He(2,p.IExtHostFileSystemInfo),He(3,v.ILogService)],l),e.ExtHostWorkspace=l,e.IExtHostWorkspace=(0,f.createDecorator)("IExtHostWorkspace");function b(T){let A,x;return T&&(typeof T=="string"?A=T:(A=T.pattern,x=T.baseFolder||u.URI.file(T.base))),{includePattern:A,folder:x}}}),define(pe[36],ve([0,1,25,3,35,5,7,192,118,13,18,4,14,11,2]),function(Y,e,m,L,y,C,i,k,S,D,R,P,u,E,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostConfiguration=e.ExtHostConfigProvider=e.ExtHostConfiguration=void 0;function v(_,n){if(n){const t=n.split(".");let o=_;for(let d=0;o&&d<t.length;d++)o=o[t[d]];return o}}function w(_){return _ instanceof f.URI}function I(_){return _&&_.uri instanceof f.URI&&_.languageId&&typeof _.languageId=="string"}function p(_){return _&&!_.uri&&_.languageId&&typeof _.languageId=="string"}function s(_){return _&&_.uri instanceof f.URI&&(!_.name||typeof _.name=="string")&&(!_.index||typeof _.index=="number")}function r(_){if(w(_))return{resource:_};if(I(_))return{resource:_.uri,overrideIdentifier:_.languageId};if(p(_))return{overrideIdentifier:_.languageId};if(s(_))return{resource:_.uri};if(_===null)return{resource:null}}let g=class{constructor(n,t,o){this._proxy=n.getProxy(C.MainContext.MainThreadConfiguration),this._extHostWorkspace=t,this._logService=o,this._barrier=new R.Barrier,this._actual=null}getConfigProvider(){return this._barrier.wait().then(n=>this._actual)}$initializeConfiguration(n){this._actual=new a(this._proxy,this._extHostWorkspace,n,this._logService),this._barrier.open()}$acceptConfigurationChanged(n,t){this.getConfigProvider().then(o=>o.$acceptConfigurationChanged(n,t))}};g=je([He(0,u.IExtHostRpcService),He(1,y.IExtHostWorkspace),He(2,E.ILogService)],g),e.ExtHostConfiguration=g;class a{constructor(n,t,o,d){this._onDidChangeConfiguration=new L.Emitter,this._proxy=n,this._logService=d,this._extHostWorkspace=t,this._configuration=k.Configuration.parse(o),this._configurationScopes=this._toMap(o.configurationScopes)}get onDidChangeConfiguration(){return this._onDidChangeConfiguration&&this._onDidChangeConfiguration.event}$acceptConfigurationChanged(n,t){const o={data:this._configuration.toData(),workspace:this._extHostWorkspace.workspace};this._configuration=k.Configuration.parse(n),this._configurationScopes=this._toMap(n.configurationScopes),this._onDidChangeConfiguration.fire(this._toConfigurationChangeEvent(t,o))}getConfiguration(n,t,o){const d=r(t)||{},c=this._toReadonlyValue(n?v(this._configuration.getValue(void 0,d,this._extHostWorkspace.workspace),n):this._configuration.getValue(void 0,d,this._extHostWorkspace.workspace));n&&this._validateConfigurationAccess(n,d,o?.identifier);function h(b){if(b==null)return null;if(typeof b=="boolean")return b?1:4;switch(b){case i.ConfigurationTarget.Global:return 1;case i.ConfigurationTarget.Workspace:return 4;case i.ConfigurationTarget.WorkspaceFolder:return 5}}const l={has(b){return typeof v(c,b)!="undefined"},get:(b,T)=>{this._validateConfigurationAccess(n?`${n}.${b}`:b,d,o?.identifier);let A=v(c,b);if(typeof A=="undefined")A=T;else{let x;const O=(F,W)=>{let M;const B=()=>{x=x||(0,m.deepClone)(c),M=M||v(x,W)};return(0,D.isObject)(F)?new Proxy(F,{get:(U,z)=>{if(typeof z=="string"&&z.toLowerCase()==="tojson")return B(),()=>M;if(x)return M=M||v(x,W),M[z];const K=U[z];return typeof z=="string"?O(K,`${W}.${z}`):K},set:(U,z,K)=>(B(),M&&(M[z]=K),!0),deleteProperty:(U,z)=>(B(),M&&delete M[z],!0),defineProperty:(U,z,K)=>(B(),M&&Object.defineProperty(M,z,K),!0)}):F};A=O(A,b)}return A},update:(b,T,A,x)=>{b=n?`${n}.${b}`:b;const O=h(A);return T!==void 0?this._proxy.$updateConfigurationOption(O,b,T,d,x):this._proxy.$removeConfigurationOption(O,b,d,x)},inspect:b=>{b=n?`${n}.${b}`:b;const T=(0,m.deepClone)(this._configuration.inspect(b,d,this._extHostWorkspace.workspace));if(T)return{key:b,defaultValue:T.default?.value,globalValue:T.user?.value,workspaceValue:T.workspace?.value,workspaceFolderValue:T.workspaceFolder?.value,defaultLanguageValue:T.default?.override,globalLanguageValue:T.user?.override,workspaceLanguageValue:T.workspace?.override,workspaceFolderLanguageValue:T.workspaceFolder?.override,languageIds:T.overrideIdentifiers}}};return typeof c=="object"&&(0,m.mixin)(l,c,!1),Object.freeze(l)}_toReadonlyValue(n){const t=o=>(0,D.isObject)(o)?new Proxy(o,{get:(d,c)=>t(d[c]),set:(d,c,h)=>{throw new Error(`TypeError: Cannot assign to read only property '${String(c)}' of object`)},deleteProperty:(d,c)=>{throw new Error(`TypeError: Cannot delete read only property '${String(c)}' of object`)},defineProperty:(d,c)=>{throw new Error(`TypeError: Cannot define property '${String(c)}' for a readonly object`)},setPrototypeOf:d=>{throw new Error("TypeError: Cannot set prototype for a readonly object")},isExtensible:()=>!1,preventExtensions:()=>!0}):o;return t(n)}_validateConfigurationAccess(n,t,o){const d=S.OVERRIDE_PROPERTY_REGEX.test(n)?4:this._configurationScopes.get(n),c=o?`[${o.value}] `:"";if(d===4){typeof t?.resource=="undefined"&&this._logService.warn(`${c}Accessing a resource scoped configuration without providing a resource is not expected. To get the effective value for '${n}', provide the URI of a resource or 'null' for any resource.`);return}if(d===3){t?.resource&&this._logService.warn(`${c}Accessing a window scoped configuration for a resource is not expected. To associate '${n}' to a resource, define its scope to 'resource' in configuration contributions in 'package.json'.`);return}}_toConfigurationChangeEvent(n,t){const o=new k.ConfigurationChangeEvent(n,t,this._configuration,this._extHostWorkspace.workspace);return Object.freeze({affectsConfiguration:(d,c)=>o.affectsConfiguration(d,r(c))})}_toMap(n){return n.reduce((t,o)=>(t.set(o[0],o[1]),t),new Map)}}e.ExtHostConfigProvider=a,e.IExtHostConfiguration=(0,P.createDecorator)("IExtHostConfiguration")});var nt=this&&this.__classPrivateFieldSet||function(Y,e,m,L,y){if(L==="m")throw new TypeError("Private method is not writable");if(L==="a"&&!y)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?Y!==e||!y:!e.has(Y))throw new TypeError("Cannot write private member to an object whose class did not declare it");return L==="a"?y.call(Y,m):y?y.value=m:e.set(Y,m),m},Ne=this&&this.__classPrivateFieldGet||function(Y,e,m,L){if(m==="a"&&!L)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?Y!==e||!L:!e.has(Y))throw new TypeError("Cannot read private member from an object whose class did not declare it");return m==="m"?L:m==="a"?L.call(Y):L?L.value:e.get(Y)};define(pe[70],ve([0,1,2,18,3,5,7,35,45,36,21,34,14,26,4,10,12,11,65,212,15]),function(Y,e,m,L,y,C,i,k,S,D,R,P,u,E,f,v,w,I,p,s,r){"use strict";var g;Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostTask=e.WorkerExtHostTask=e.ExtHostTaskBase=e.TaskExecutionDTO=e.TaskFilterDTO=e.TaskDTO=e.TaskGroupDTO=e.TaskHandleDTO=e.CustomExecutionDTO=e.ShellExecutionDTO=e.ShellExecutionOptionsDTO=e.ProcessExecutionDTO=e.ProcessExecutionOptionsDTO=e.TaskPresentationOptionsDTO=e.TaskDefinitionDTO=void 0;var a;(function(W){function M(U){if(U!=null)return U}W.from=M;function B(U){if(U!=null)return U}W.to=B})(a=e.TaskDefinitionDTO||(e.TaskDefinitionDTO={}));var _;(function(W){function M(U){if(U!=null)return U}W.from=M;function B(U){if(U!=null)return U}W.to=B})(_=e.TaskPresentationOptionsDTO||(e.TaskPresentationOptionsDTO={}));var n;(function(W){function M(U){if(U!=null)return U}W.from=M;function B(U){if(U!=null)return U}W.to=B})(n=e.ProcessExecutionOptionsDTO||(e.ProcessExecutionOptionsDTO={}));var t;(function(W){function M(z){if(z){const K=z;return K&&!!K.process}else return!1}W.is=M;function B(z){if(z==null)return;const K={process:z.process,args:z.args};return z.options&&(K.options=n.from(z.options)),K}W.from=B;function U(z){if(z!=null)return new i.ProcessExecution(z.process,z.args,z.options)}W.to=U})(t=e.ProcessExecutionDTO||(e.ProcessExecutionDTO={}));var o;(function(W){function M(U){if(U!=null)return U}W.from=M;function B(U){if(U!=null)return U}W.to=B})(o=e.ShellExecutionOptionsDTO||(e.ShellExecutionOptionsDTO={}));var d;(function(W){function M(z){if(z){const K=z;return K&&(!!K.commandLine||!!K.command)}else return!1}W.is=M;function B(z){if(z==null)return;const K={};return z.commandLine!==void 0?K.commandLine=z.commandLine:(K.command=z.command,K.args=z.args),z.options&&(K.options=o.from(z.options)),K}W.from=B;function U(z){if(!(z==null||z.command===void 0&&z.commandLine===void 0))return z.commandLine?new i.ShellExecution(z.commandLine,z.options):new i.ShellExecution(z.command,z.args?z.args:[],z.options)}W.to=U})(d=e.ShellExecutionDTO||(e.ShellExecutionDTO={}));var c;(function(W){function M(z){if(z){let K=z;return K&&K.customExecution==="customExecution"}else return!1}W.is=M;function B(z){return{customExecution:"customExecution"}}W.from=B;function U(z,K){return K.get(z)}W.to=U})(c=e.CustomExecutionDTO||(e.CustomExecutionDTO={}));var h;(function(W){function M(B,U){let z;return B.scope!==void 0&&typeof B.scope!="number"?z=B.scope.uri:B.scope!==void 0&&typeof B.scope=="number"&&(B.scope===i.TaskScope.Workspace&&U&&U.workspaceFile?z=U.workspaceFile:z=s.USER_TASKS_GROUP_KEY),{id:B._id,workspaceFolder:z}}W.from=M})(h=e.TaskHandleDTO||(e.TaskHandleDTO={}));var l;(function(W){function M(B){if(B!=null)return{_id:B.id,isDefault:B.isDefault}}W.from=M})(l=e.TaskGroupDTO||(e.TaskGroupDTO={}));var b;(function(W){function M(z,K){if(z==null)return[];const N=[];for(let j of z){const H=B(j,K);H&&N.push(H)}return N}W.fromMany=M;function B(z,K){if(z==null)return;let N;z.execution instanceof i.ProcessExecution?N=t.from(z.execution):z.execution instanceof i.ShellExecution?N=d.from(z.execution):z.execution&&z.execution instanceof i.CustomExecution&&(N=c.from(z.execution));const j=a.from(z.definition);let H;return z.scope?typeof z.scope=="number"?H=z.scope:H=z.scope.uri:H=i.TaskScope.Workspace,!j||!H?void 0:{_id:z._id,definition:j,name:z.name,source:{extensionId:K.identifier.value,label:z.source,scope:H},execution:N,isBackground:z.isBackground,group:l.from(z.group),presentationOptions:_.from(z.presentationOptions),problemMatchers:z.problemMatchers,hasDefinedMatchers:z.hasDefinedMatchers,runOptions:z.runOptions?z.runOptions:{reevaluateOnRerun:!0},detail:z.detail}}W.from=B;async function U(z,K,N){if(z==null)return;let j;t.is(z.execution)?j=t.to(z.execution):d.is(z.execution)?j=d.to(z.execution):c.is(z.execution)&&(j=c.to(z._id,N));const H=a.to(z.definition);let V;if(z.source&&(z.source.scope!==void 0?typeof z.source.scope=="number"?V=z.source.scope:V=await K.resolveWorkspaceFolder(m.URI.revive(z.source.scope)):V=i.TaskScope.Workspace),!H||!V)return;const q=new i.Task(H,V,z.name,z.source.label,j,z.problemMatchers);return z.isBackground!==void 0&&(q.isBackground=z.isBackground),z.group!==void 0&&(q.group=i.TaskGroup.from(z.group._id),q.group&&z.group.isDefault&&(q.group=new i.TaskGroup(q.group.id,q.group.label),z.group.isDefault&&(q.group.isDefault=z.group.isDefault))),z.presentationOptions&&(q.presentationOptions=_.to(z.presentationOptions)),z._id&&(q._id=z._id),z.detail&&(q.detail=z.detail),q}W.to=U})(b=e.TaskDTO||(e.TaskDTO={}));var T;(function(W){function M(U){return U}W.from=M;function B(U){if(!!U)return Object.assign(Object.create(null),U)}W.to=B})(T=e.TaskFilterDTO||(e.TaskFilterDTO={}));class A{constructor(M,B,U){this._id=B,this._task=U,g.set(this,void 0),nt(this,g,M,"f")}get task(){return this._task}terminate(){Ne(this,g,"f").terminateTask(this)}fireDidStartProcess(M){}fireDidEndProcess(M){}}g=new WeakMap;var x;(function(W){function M(B){return{id:B._id,task:void 0}}W.from=M})(x=e.TaskExecutionDTO||(e.TaskExecutionDTO={}));let O=class{constructor(M,B,U,z,K,N,j,H){this._onDidExecuteTask=new y.Emitter,this._onDidTerminateTask=new y.Emitter,this._onDidTaskProcessStarted=new y.Emitter,this._onDidTaskProcessEnded=new y.Emitter,this._proxy=M.getProxy(C.MainContext.MainThreadTask),this._workspaceProvider=U,this._editorService=z,this._configurationService=K,this._terminalService=N,this._handleCounter=0,this._handlers=new Map,this._taskExecutions=new Map,this._taskExecutionPromises=new Map,this._providedCustomExecutions2=new Map,this._notProvidedCustomExecutions=new Set,this._activeCustomExecutions2=new Map,this._logService=j,this._deprecationService=H,this._proxy.$registerSupportedExecutions(!0)}registerTaskProvider(M,B,U){if(!U)return new i.Disposable(()=>{});const z=this.nextHandle();return this._handlers.set(z,{type:B,provider:U,extension:M}),this._proxy.$registerTaskProvider(z,B),new i.Disposable(()=>{this._handlers.delete(z),this._proxy.$unregisterTaskProvider(z)})}registerTaskSystem(M,B){this._proxy.$registerTaskSystem(M,B)}fetchTasks(M){return this._proxy.$fetchTasks(T.from(M)).then(async B=>{const U=[];for(let z of B){const K=await b.to(z,this._workspaceProvider,this._providedCustomExecutions2);K&&U.push(K)}return U})}get taskExecutions(){const M=[];return this._taskExecutions.forEach(B=>M.push(B)),M}terminateTask(M){if(!(M instanceof A))throw new Error("No valid task execution provided");return this._proxy.$terminateTask(M._id)}get onDidStartTask(){return this._onDidExecuteTask.event}async $onDidStartTask(M,B,U){const z=this._providedCustomExecutions2.get(M.id);z&&(this._activeCustomExecutions2.set(M.id,z),this._terminalService.attachPtyToTerminal(B,await z.callback(U))),this._lastStartedTask=M.id,this._onDidExecuteTask.fire({execution:await this.getTaskExecution(M)})}get onDidEndTask(){return this._onDidTerminateTask.event}async $OnDidEndTask(M){const B=await this.getTaskExecution(M);this._taskExecutionPromises.delete(M.id),this._taskExecutions.delete(M.id),this.customExecutionComplete(M),this._onDidTerminateTask.fire({execution:B})}get onDidStartTaskProcess(){return this._onDidTaskProcessStarted.event}async $onDidStartTaskProcess(M){const B=await this.getTaskExecution(M.id);this._onDidTaskProcessStarted.fire({execution:B,processId:M.processId})}get onDidEndTaskProcess(){return this._onDidTaskProcessEnded.event}async $onDidEndTaskProcess(M){const B=await this.getTaskExecution(M.id);this._onDidTaskProcessEnded.fire({execution:B,exitCode:M.exitCode})}$provideTasks(M,B){const U=this._handlers.get(M);if(!U)return Promise.reject(new Error("no handler found"));const z=[],K=(0,L.asPromise)(()=>U.provider.provideTasks(R.CancellationToken.None)).then(N=>this.provideTasksInternal(B,z,U,N));return new Promise(N=>{K.then(j=>{Promise.all(z).then(()=>{N(j)})})})}async $resolveTask(M,B){const U=this._handlers.get(M);if(!U)return Promise.reject(new Error("no handler found"));if(B.definition.type!==U.type)throw new Error(`Unexpected: Task of type [${B.definition.type}] cannot be resolved by provider of type [${U.type}].`);const z=await b.to(B,this._workspaceProvider,this._providedCustomExecutions2);if(!z)throw new Error("Unexpected: Task cannot be resolved.");const K=await U.provider.resolveTask(z,R.CancellationToken.None);if(!K)return;this.checkDeprecation(K,U);const N=b.from(K,U.extension);if(!N)throw new Error("Unexpected: Task cannot be resolved.");if(K.definition!==z.definition)throw new Error("Unexpected: The resolved task definition must be the same object as the original task definition. The task definition cannot be changed.");return c.is(N.execution)&&await this.addCustomExecution(N,K,!0),await this.resolveTaskInternal(N)}nextHandle(){return this._handleCounter++}async addCustomExecution(M,B,U){const z=await this._proxy.$createTaskId(M);!U&&!this._providedCustomExecutions2.has(z)&&(this._notProvidedCustomExecutions.add(z),this._activeCustomExecutions2.set(z,B.execution)),this._providedCustomExecutions2.set(z,B.execution)}async getTaskExecution(M,B){if(typeof M=="string"){const K=this._taskExecutionPromises.get(M);if(!K)throw new Error("Unexpected: The specified task is missing an execution");return K}let U=this._taskExecutionPromises.get(M.id);if(U)return U;const z=new Promise((K,N)=>{function j(H,V,q){q?K(new A(H,V.id,q)):N("Unexpected: Task does not exist.")}B?j(this,M,B):b.to(M.task,this._workspaceProvider,this._providedCustomExecutions2).then(H=>j(this,M,H))});return this._taskExecutionPromises.set(M.id,z),z.then(K=>(this._taskExecutions.set(M.id,K),K),K=>Promise.reject(K))}checkDeprecation(M,B){M._deprecated&&this._deprecationService.report("Task.constructor",B.extension,"Use the Task constructor that takes a `scope` instead.")}customExecutionComplete(M){this._activeCustomExecutions2.get(M.id)&&this._activeCustomExecutions2.delete(M.id),this._notProvidedCustomExecutions.has(M.id)&&this._lastStartedTask!==M.id&&(this._providedCustomExecutions2.delete(M.id),this._notProvidedCustomExecutions.delete(M.id));let U=this._notProvidedCustomExecutions.values(),z=U.next();for(;!z.done;)!this._activeCustomExecutions2.has(z.value)&&this._lastStartedTask!==z.value&&(this._providedCustomExecutions2.delete(z.value),this._notProvidedCustomExecutions.delete(z.value)),z=U.next()}};O=je([He(0,u.IExtHostRpcService),He(1,E.IExtHostInitDataService),He(2,k.IExtHostWorkspace),He(3,S.IExtHostDocumentsAndEditors),He(4,D.IExtHostConfiguration),He(5,P.IExtHostTerminalService),He(6,I.ILogService),He(7,p.IExtHostApiDeprecationService)],O),e.ExtHostTaskBase=O;let F=class extends O{constructor(M,B,U,z,K,N,j,H){super(M,B,U,z,K,N,j,H);this.registerTaskSystem(v.Schemas.vscodeRemote,{scheme:v.Schemas.vscodeRemote,authority:"",platform:w.PlatformToString(0)})}async executeTask(M,B){if(!B.execution)throw new Error("Tasks to execute must include an execution");const U=b.from(B,M);if(U===void 0)throw new Error("Task is not valid");if(c.is(U.execution))await this.addCustomExecution(U,B,!1);else throw new r.NotSupportedError;const z=await this.getTaskExecution(await this._proxy.$getTaskExecution(U),B);return this._proxy.$executeTask(U).catch(K=>{throw new Error(K)}),z}provideTasksInternal(M,B,U,z){const K=[];if(z)for(let N of z){this.checkDeprecation(N,U),(!N.definition||!M[N.definition.type])&&this._logService.warn(`The task [${N.source}, ${N.name}] uses an undefined task type. The task will be ignored in the future.`);const j=b.from(N,U.extension);j&&c.is(j.execution)?(K.push(j),B.push(this.addCustomExecution(j,N,!0))):this._logService.warn("Only custom execution tasks supported.")}return{tasks:K,extension:U.extension}}async resolveTaskInternal(M){if(c.is(M.execution))return M;this._logService.warn("Only custom execution tasks supported.")}async $resolveVariables(M,B){return{process:void 0,variables:Object.create(null)}}async $jsonTasksSupported(){return!1}async $findExecutable(M,B,U){}};F=je([He(0,u.IExtHostRpcService),He(1,E.IExtHostInitDataService),He(2,k.IExtHostWorkspace),He(3,S.IExtHostDocumentsAndEditors),He(4,D.IExtHostConfiguration),He(5,P.IExtHostTerminalService),He(6,I.ILogService),He(7,p.IExtHostApiDeprecationService)],F),e.WorkerExtHostTask=F,e.IExtHostTask=(0,f.createDecorator)("IExtHostTask")}),define(pe[266],ve([0,1,16,73,31,80,24,10,9,23,8,13,2,145,174,115,43,127,265,33]),function(Y,e,m,L,y,C,i,k,S,D,R,P,u,E,f,v,w,I,p,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.resolveResourcesForSearchIncludes=e.QueryBuilder=void 0;let r=class{constructor(h,l,b,T){this.configurationService=h,this.workspaceContextService=l,this.editorGroupsService=b,this.pathService=T}text(h,l,b={}){h=this.getContentPattern(h,b);const T=this.configurationService.getValue(),A=l&&l.some(O=>!this.configurationService.getValue({resource:O}).search.useRipgrep);return{...this.commonQuery(l?.map(w.toWorkspaceFolder),b),type:2,contentPattern:h,previewOptions:b.previewOptions,maxFileSize:b.maxFileSize,usePCRE2:T.search.usePCRE2||A||!1,beforeContext:b.beforeContext,afterContext:b.afterContext,userDisabledExcludesAndIgnoreFiles:b.disregardExcludeSettings&&b.disregardIgnoreFiles}}getContentPattern(h,l){const b=this.configurationService.getValue();h.isRegExp&&(h.pattern=h.pattern.replace(/\r?\n/g,"\\n"));const T={...h,wordSeparators:b.editor.wordSeparators};return this.isCaseSensitive(h,l)&&(T.isCaseSensitive=!0),this.isMultiline(h)&&(T.isMultiline=!0),T}file(h,l={}){return{...this.commonQuery(h,l),type:1,filePattern:l.filePattern?l.filePattern.trim():l.filePattern,exists:l.exists,sortByScore:l.sortByScore,cacheKey:l.cacheKey}}handleIncludeExclude(h,l){return h?(h=Array.isArray(h)?h.map(t):t(h),l?this.parseSearchPaths(h):{pattern:a(...Array.isArray(h)?h:[h])}):{}}commonQuery(h=[],l={}){const b=this.handleIncludeExclude(l.includePattern,l.expandPatterns),T=this.handleIncludeExclude(l.excludePattern,l.expandPatterns),A=h.length>1,x=(b.searchPaths&&b.searchPaths.length?b.searchPaths.map(W=>this.getFolderQueryForSearchPath(W,l,T)):h.map(W=>this.getFolderQueryForRoot(W,l,T,A))).filter(W=>!!W),O={_reason:l._reason,folderQueries:x,usingSearchPaths:!!(b.searchPaths&&b.searchPaths.length),extraFileResources:l.extraFileResources,excludePattern:T.pattern,includePattern:b.pattern,onlyOpenEditors:l.onlyOpenEditors,maxResults:l.maxResults};if(l.onlyOpenEditors){const M=m.coalesce(m.flatten(this.editorGroupsService.groups.map(U=>U.editors.map(z=>z.resource)))).filter(U=>(0,s.pathIncludedInQuery)(O,U.fsPath)),B=this.commonQueryFromFileList(M);return{...O,...B}}const F=l.extraFileResources&&l.extraFileResources.filter(W=>(0,s.pathIncludedInQuery)(O,W.fsPath));return O.extraFileResources=F&&F.length?F:void 0,O}commonQueryFromFileList(h){const l=[],b=new i.ResourceMap,T={};let A=!1;return h.forEach(x=>{if(x.scheme===k.Schemas.walkThrough)return;if((0,D.isAbsolutePath)(x)){const F=this.workspaceContextService.getWorkspaceFolder(x)?.uri??x.with({path:S.dirname(x.fsPath)});let W=b.get(F);W||(A=!0,W={folder:F,includePattern:{}},l.push(W),b.set(F,W));const M=S.relative(F.fsPath,x.fsPath);(0,P.assertIsDefined)(W.includePattern)[M.replace(/\\/g,"/")]=!0}else x.fsPath&&(A=!0,T[x.fsPath]=!0)}),{folderQueries:l,includePattern:T,usingSearchPaths:!0,excludePattern:A?void 0:{"**/*":!0}}}isCaseSensitive(h,l){if(l.isSmartCase){if(h.isRegExp){if(R.containsUppercaseCharacter(h.pattern,!0))return!0}else if(R.containsUppercaseCharacter(h.pattern))return!0}return!!h.isCaseSensitive}isMultiline(h){return h.isMultiline||h.isRegExp&&(0,E.isMultilineRegexSource)(h.pattern)||h.pattern.indexOf(`
`)>=0?!0:!!h.isMultiline}parseSearchPaths(h){const l=B=>S.isAbsolute(B)||/^\.\.?([\/\\]|$)/.test(B),T=(Array.isArray(h)?h:_(h)).map(B=>{const U=this.pathService.resolvedUserHome;return U?(0,C.untildify)(B,U.scheme===k.Schemas.file?U.fsPath:U.path):B}),A=L.groupBy(T,B=>l(B)?"searchPaths":"exprSegments"),x=(A.exprSegments||[]).map(B=>R.rtrim(B,"/")).map(B=>R.rtrim(B,"\\")).map(B=>(B[0]==="."&&(B="*"+B),n(B))),O={},F=this.expandSearchPathPatterns(A.searchPaths||[]);F&&F.length&&(O.searchPaths=F);const W=m.flatten(x),M=a(...W);return M&&(O.pattern=M),O}getExcludesForFolder(h,l){return l.disregardExcludeSettings?void 0:(0,s.getExcludes)(h,!l.disregardSearchExcludeSettings)}expandSearchPathPatterns(h){if(!h||!h.length)return[];const l=m.flatten(h.map(T=>{let{pathPortion:A,globPortion:x}=g(T);x&&(x=o(x));const O=this.expandOneSearchPath(A);return m.flatten(O.map(F=>this.resolveOneSearchPathPattern(F,x)))})),b=new Map;return l.forEach(T=>{const A=T.searchPath.toString(),x=b.get(A);x?T.pattern&&(x.pattern=x.pattern||{},x.pattern[T.pattern]=!0):b.set(A,{searchPath:T.searchPath,pattern:T.pattern?a(T.pattern):void 0})}),Array.from(b.values())}expandOneSearchPath(h){if(S.isAbsolute(h)){const l=this.workspaceContextService.getWorkspace().folders;return l[0]&&l[0].uri.scheme!==k.Schemas.file?[{searchPath:l[0].uri.with({path:h})}]:[{searchPath:u.URI.file(S.normalize(h))}]}if(this.workspaceContextService.getWorkbenchState()===2){const l=this.workspaceContextService.getWorkspace().folders[0].uri;if(h=t(h),h.startsWith("../")||h===".."){const T=S.posix.resolve(l.path,h);return[{searchPath:l.with({path:T})}]}const b=o(h);return[{searchPath:l,pattern:b}]}else{if(h==="./"||h===".\\")return[];{const l=h.replace(/^\.[\/\\]/,""),T=this.workspaceContextService.getWorkspace().folders.map(A=>{const x=l.match(new RegExp(`^${R.escapeRegExpCharacters(A.name)}(?:/(.*)|$)`));return x?{match:x,folder:A}:null}).filter(P.isDefined);if(T.length)return T.map(A=>{const x=A.match[1];return{searchPath:A.folder.uri,pattern:x&&o(x)}});{const A=h.match(/\.[\/\\](.+)[\/\\]?/),x=A?A[1]:h,O=f.localize(0,null,x);throw new Error(O)}}}}resolveOneSearchPathPattern(h,l){const b=h.pattern&&l?`${h.pattern}/${l}`:h.pattern||l,T=[{searchPath:h.searchPath,pattern:b}];return b&&!b.endsWith("**")&&T.push({searchPath:h.searchPath,pattern:b+"/**"}),T}getFolderQueryForSearchPath(h,l,b){const T=this.getFolderQueryForRoot((0,w.toWorkspaceFolder)(h.searchPath),l,b,!1);return T?{...T,includePattern:h.pattern}:null}getFolderQueryForRoot(h,l,b,T){let A;const x=u.URI.isUri(h)?h:h.uri;if(b.searchPaths){const B=b.searchPaths.filter(U=>(0,D.isEqual)(U.searchPath,x))[0];if(B&&!B.pattern)return null;B&&(A=B.pattern)}const O=this.configurationService.getValue({resource:x}),W={...this.getExcludesForFolder(O,l)||{},...A||{}},M=u.URI.isUri(h)?(0,D.basename)(h):h.name;return{folder:x,folderName:T?M:void 0,excludePattern:Object.keys(W).length>0?W:void 0,fileEncoding:O.files&&O.files.encoding,disregardIgnoreFiles:typeof l.disregardIgnoreFiles=="boolean"?l.disregardIgnoreFiles:!O.search.useIgnoreFiles,disregardGlobalIgnoreFiles:typeof l.disregardGlobalIgnoreFiles=="boolean"?l.disregardGlobalIgnoreFiles:!O.search.useGlobalIgnoreFiles,ignoreSymlinks:typeof l.ignoreSymlinks=="boolean"?l.ignoreSymlinks:!O.search.followSymlinks}}};r=je([He(0,v.IConfigurationService),He(1,w.IWorkspaceContextService),He(2,I.IEditorGroupsService),He(3,p.IPathService)],r),e.QueryBuilder=r;function g(c){const h=c.match(/[\*\{\}\(\)\[\]\?]/);if(h){const l=h.index,b=c.substr(0,l).match(/[/|\\][^/\\]*$/);if(b){let T=c.substr(0,b.index);return T.match(/[/\\]/)||(T+="/"),{pathPortion:T,globPortion:c.substr((b.index||0)+1)}}}return{pathPortion:c}}function a(...c){return c.length?c.reduce((h,l)=>(h[l]=!0,h),Object.create(null)):void 0}function _(c){return y.splitGlobAware(c,",").map(h=>h.trim()).filter(h=>!!h.length)}function n(c){return[`**/${c}/**`,`**/${c}`].map(l=>l.replace(/\*\*\/\*\*/g,"**"))}function t(c){return c.replace(/\\/g,"/")}function o(c){return t(c).replace(/^\.\//,"").replace(/\/+$/g,"")}function d(c,h){c=m.distinct(c,T=>T.toString());const l=[],b=h.getWorkspace();return c&&c.forEach(T=>{let A;if(h.getWorkbenchState()===2)A=(0,D.relativePath)(b.folders[0].uri,T),A&&A!=="."&&(A="./"+A);else{const x=h.getWorkspaceFolder(T);if(x){const O=x.name;if(b.folders.filter(W=>W.name===O).length===1){const W=(0,D.relativePath)(x.uri,T);W===""?A=`./${x.name}`:A=`./${x.name}/${W}`}else A=T.fsPath}}A&&l.push(A)}),l}e.resolveResourcesForSearchIncludes=d}),define(pe[267],ve([0,1,23,2,21,15,4,266,33,43]),function(Y,e,m,L,y,C,i,k,S,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.checkGlobFileExists=e.checkActivateWorkspaceContainsExtension=void 0;const R=7e3;function P(v,w){const I=w.activationEvents;if(!I)return Promise.resolve(void 0);const p=[],s=[];for(const t of I)if(/^workspaceContains:/.test(t)){const o=t.substr("workspaceContains:".length);o.indexOf("*")>=0||o.indexOf("?")>=0||v.forceUsingSearch?s.push(o):p.push(o)}if(p.length===0&&s.length===0)return Promise.resolve(void 0);let r;const g=new Promise((t,o)=>{r=t}),a=t=>r({activationEvent:t}),_=Promise.all(p.map(t=>u(v,t,a))).then(()=>{}),n=E(v,w.identifier,s,a);return Promise.all([_,n]).then(()=>{r(void 0)}),g}e.checkActivateWorkspaceContainsExtension=P;async function u(v,w,I){for(const p of v.folders)if(await v.exists(m.joinPath(L.URI.revive(p),w))){I(`workspaceContains:${w}`);return}}async function E(v,w,I,p){if(I.length===0)return Promise.resolve(void 0);const s=new y.CancellationTokenSource,r=v.checkExists(v.folders,I,s.token),g=setTimeout(async()=>{s.cancel(),v.logService.info(`Not activating extension '${w.value}': Timed out while searching for 'workspaceContains' pattern ${I.join(",")}`)},R);let a=!1;try{a=await r}catch(_){C.isPromiseCanceledError(_)||C.onUnexpectedError(_)}s.dispose(),clearTimeout(g),a&&p(`workspaceContains:${I.join(",")}`)}function f(v,w,I,p){const s=v.get(i.IInstantiationService),r=v.get(S.ISearchService),a=s.createInstance(k.QueryBuilder).file(w.map(_=>(0,D.toWorkspaceFolder)(L.URI.revive(_))),{_reason:"checkExists",includePattern:I,exists:!0});return r.fileSearch(a,p).then(_=>!!_.limitHit,_=>C.isPromiseCanceledError(_)?!1:Promise.reject(_))}e.checkGlobFileExists=f});var nt=this&&this.__classPrivateFieldSet||function(Y,e,m,L,y){if(L==="m")throw new TypeError("Private method is not writable");if(L==="a"&&!y)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?Y!==e||!y:!e.has(Y))throw new TypeError("Cannot write private member to an object whose class did not declare it");return L==="a"?y.call(Y,m):y?y.value=m:e.set(Y,m),m},Ne=this&&this.__classPrivateFieldGet||function(Y,e,m,L){if(m==="a"&&!L)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?Y!==e||!L:!e.has(Y))throw new TypeError("Cannot read private member from an object whose class did not declare it");return m==="m"?L:m==="a"?L.call(Y):L?L.value:e.get(Y)};define(pe[39],ve([0,1,163,9,71,23,18,6,24,2,11,5,36,225,91,35,29,223,15,27,22,198,7,119,4,26,67,14,85,52,34,3,267,90,200,10]),function(Y,e,m,L,y,C,i,k,S,D,R,P,u,E,f,v,w,I,p,s,r,g,a,_,n,t,o,d,c,h,l,b,T,A,x,O){"use strict";var F,W,M;Object.defineProperty(e,"__esModule",{value:!0}),e.Extension=e.IExtHostExtensionService=e.AbstractExtHostExtensionService=e.IHostUtils=void 0,e.IHostUtils=(0,n.createDecorator)("IHostUtils");let B=class ji extends k.Disposable{constructor(N,j,H,V,q,ne,fe,ye,ke,Be){super();this._onDidChangeRemoteConnectionData=this._register(new b.Emitter),this.onDidChangeRemoteConnectionData=this._onDidChangeRemoteConnectionData.event,this._hostUtils=j,this._extHostContext=H,this._initData=fe,this._extHostWorkspace=V,this._extHostConfiguration=q,this._logService=ne,this._extHostTunnelService=ke,this._extHostTerminalService=Be,this._mainThreadWorkspaceProxy=this._extHostContext.getProxy(P.MainContext.MainThreadWorkspace),this._mainThreadTelemetryProxy=this._extHostContext.getProxy(P.MainContext.MainThreadTelemetry),this._mainThreadExtensionsProxy=this._extHostContext.getProxy(P.MainContext.MainThreadExtensionService),this._almostReadyToRunExtensions=new i.Barrier,this._readyToStartExtensionHost=new i.Barrier,this._readyToRunExtensions=new i.Barrier,this._eagerExtensionsActivated=new i.Barrier,this._registry=new I.ExtensionDescriptionRegistry(this._initData.extensions),this._storage=new f.ExtHostStorage(this._extHostContext),this._secretState=new A.ExtHostSecretState(this._extHostContext),this._storagePath=ye,this._instaService=N.createChild(new c.ServiceCollection([f.IExtHostStorage,this._storage],[A.IExtHostSecretState,this._secretState]));const We=new Set;this._initData.hostExtensions.forEach(ze=>We.add(s.ExtensionIdentifier.toKey(ze))),this._activator=this._register(new E.ExtensionsActivator(this._registry,this._initData.resolvedExtensions,this._initData.hostExtensions,{onExtensionActivationError:(ze,Q,ee)=>{this._mainThreadExtensionsProxy.$onExtensionActivationError(ze,p.transformErrorForSerialization(Q),ee)},actualActivateExtension:async(ze,Q)=>{if(We.has(s.ExtensionIdentifier.toKey(ze)))return await this._mainThreadExtensionsProxy.$activateExtension(ze,Q),new E.HostExtension;const ee=this._registry.getExtensionDescription(ze);return this._activateExtension(ee,Q)}},this._logService)),this._extensionPathIndex=null,this._resolvers=Object.create(null),this._started=!1,this._remoteConnectionData=this._initData.remote.connectionData}getRemoteConnectionData(){return this._remoteConnectionData}async initialize(){try{await this._beforeAlmostReadyToRunExtensions(),this._almostReadyToRunExtensions.open(),await this._extHostWorkspace.waitForInitializeCall(),y.mark("code/extHost/ready"),this._readyToStartExtensionHost.open(),this._initData.autoStart&&this._startExtensionHost()}catch(N){p.onUnexpectedError(N)}}async deactivateAll(){this._storagePath.onWillDeactivateAll();let N=[];try{N=this._registry.getAllExtensionDescriptions().map(q=>q.identifier).filter(q=>this.isActivated(q)).map(q=>this._deactivate(q))}catch(j){}await Promise.all(N)}isActivated(N){return this._readyToRunExtensions.isOpen()?this._activator.isActivated(N):!1}_activateByEvent(N,j){return this._activator.activateByEvent(N,j)}_activateById(N,j){return this._activator.activateById(N,j)}activateByIdWithErrors(N,j){return this._activateById(N,j).then(()=>{const H=this._activator.getActivatedExtension(N);if(H.activationFailed)return Promise.reject(H.activationFailedError)})}getExtensionRegistry(){return this._readyToRunExtensions.wait().then(N=>this._registry)}getExtensionExports(N){return this._readyToRunExtensions.isOpen()?this._activator.getActivatedExtension(N).exports:null}async _realPathExtensionUri(N){if(N.scheme!==O.Schemas.file)return N;const j=await this._hostUtils.realpath(N.fsPath);return D.URI.file(j)}async getExtensionPathIndex(){return this._extensionPathIndex||(this._extensionPathIndex=(async()=>{const N=S.TernarySearchTree.forUris(j=>C.extUriBiasedIgnorePathCase.ignorePathCasing(j));for(const j of this._registry.getAllExtensionDescriptions())if(this._getEntryPoint(j)){const H=await this._realPathExtensionUri(j.extensionLocation);N.set(H,j)}return N})()),this._extensionPathIndex}_deactivate(N){let j=Promise.resolve(void 0);if(!this._readyToRunExtensions.isOpen()||!this._activator.isActivated(N))return j;const H=this._activator.getActivatedExtension(N);if(!H)return j;try{typeof H.module.deactivate=="function"&&(j=Promise.resolve(H.module.deactivate()).then(void 0,V=>(this._logService.error(V),Promise.resolve(void 0))))}catch(V){this._logService.error(V)}try{(0,k.dispose)(H.subscriptions)}catch(V){this._logService.error(V)}return j}async _activateExtension(N,j){return this._initData.remote.isRemote?this._mainThreadExtensionsProxy.$onWillActivateExtension(N.identifier):await this._mainThreadExtensionsProxy.$onWillActivateExtension(N.identifier),this._doActivateExtension(N,j).then(H=>{const V=H.activationTimes;return this._mainThreadExtensionsProxy.$onDidActivateExtension(N.identifier,V.codeLoadingTime,V.activateCallTime,V.activateResolvedTime,j),this._logExtensionActivationTimes(N,j,"success",V),H},H=>{throw this._logExtensionActivationTimes(N,j,"failure"),H})}_logExtensionActivationTimes(N,j,H,V){const q=U(N,j);this._mainThreadTelemetryProxy.$publicLog2("extensionActivationTimes",{...q,...V||{},outcome:H})}_doActivateExtension(N,j){const H=U(N,j);this._mainThreadTelemetryProxy.$publicLog2("activatePlugin",H);const V=this._getEntryPoint(N);if(!V)return Promise.resolve(new E.EmptyExtension(E.ExtensionActivationTimes.NONE));this._logService.info(`ExtensionService#_doActivateExtension ${N.identifier.value}, startup: ${j.startup}, activationEvent: '${j.activationEvent}'${N.identifier.value!==j.extensionId.value?`, root cause: ${j.extensionId.value}`:""}`),this._logService.flush();const q=new E.ExtensionActivationTimesBuilder(j.startup);return Promise.all([this._loadCommonJSModule(N.identifier,(0,C.joinPath)(N.extensionLocation,V),q),this._loadExtensionContext(N)]).then(ne=>(y.mark(`code/extHost/willActivateExtension/${N.identifier.value}`),ji._callActivate(this._logService,N.identifier,ne[0],ne[1],q))).then(ne=>(y.mark(`code/extHost/didActivateExtension/${N.identifier.value}`),ne))}_loadExtensionContext(N){const j=new g.ExtensionGlobalMemento(N,this._storage),H=new g.ExtensionMemento(N.identifier.value,!1,this._storage),V=new x.ExtensionSecrets(N,this._secretState),q=N.isUnderDevelopment?this._initData.environment.extensionTestsLocationURI?a.ExtensionMode.Test:a.ExtensionMode.Development:a.ExtensionMode.Production,ne=this._initData.remote.isRemote?a.ExtensionKind.Workspace:a.ExtensionKind.UI;return this._logService.trace(`ExtensionService#loadExtensionContext ${N.identifier.value}`),Promise.all([j.whenReady,H.whenReady,this._storagePath.whenReady]).then(()=>{const fe=this;let ye;return Object.freeze({globalState:j,workspaceState:H,secrets:V,subscriptions:[],get extensionUri(){return N.extensionLocation},get extensionPath(){return N.extensionLocation.fsPath},asAbsolutePath(ke){return L.join(N.extensionLocation.fsPath,ke)},get storagePath(){return fe._storagePath.workspaceValue(N)?.fsPath},get globalStoragePath(){return fe._storagePath.globalValue(N).fsPath},get logPath(){return L.join(fe._initData.logsLocation.fsPath,N.identifier.value)},get logUri(){return D.URI.joinPath(fe._initData.logsLocation,N.identifier.value)},get storageUri(){return fe._storagePath.workspaceValue(N)},get globalStorageUri(){return fe._storagePath.globalValue(N)},get extensionMode(){return q},get extension(){return ye===void 0&&(ye=new z(fe,N.identifier,N,ne)),ye},get extensionRuntime(){return(0,w.checkProposedApiEnabled)(N,"extensionRuntime"),fe.extensionRuntime},get environmentVariableCollection(){return fe._extHostTerminalService.getEnvironmentVariableCollection(N)}})})}static _callActivate(N,j,H,V,q){return H=H||{activate:void 0,deactivate:void 0},this._callActivateOptional(N,j,H,V,q).then(ne=>new E.ActivatedExtension(!1,null,q.build(),H,ne,V.subscriptions))}static _callActivateOptional(N,j,H,V,q){if(typeof H.activate=="function")try{q.activateCallStart(),N.trace(`ExtensionService#_callActivateOptional ${j.value}`);const ne=typeof global=="object"?global:self,fe=H.activate.apply(ne,[V]);return q.activateCallStop(),q.activateResolveStart(),Promise.resolve(fe).then(ye=>(q.activateResolveStop(),ye))}catch(ne){return Promise.reject(ne)}else return Promise.resolve(H)}_activateOneStartupFinished(N,j){this._activateById(N.identifier,{startup:!1,extensionId:N.identifier,activationEvent:j}).then(void 0,H=>{this._logService.error(H)})}_activateAllStartupFinished(){this._mainThreadExtensionsProxy.$setPerformanceMarks(y.getMarks());for(const N of this._registry.getAllExtensionDescriptions())if(N.activationEvents)for(const j of N.activationEvents)j==="onStartupFinished"&&this._activateOneStartupFinished(N,j)}_handleEagerExtensions(){const N=this._activateByEvent("*",!0).then(void 0,q=>{this._logService.error(q)});this._register(this._extHostWorkspace.onDidChangeWorkspace(q=>this._handleWorkspaceContainsEagerExtensions(q.added)));const j=this._extHostWorkspace.workspace?this._extHostWorkspace.workspace.folders:[],H=this._handleWorkspaceContainsEagerExtensions(j),V=Promise.all([N,H]).then(()=>{});return Promise.race([V,(0,i.timeout)(1e4)]).then(()=>{this._activateAllStartupFinished()}),V}_handleWorkspaceContainsEagerExtensions(N){return N.length===0?Promise.resolve(void 0):Promise.all(this._registry.getAllExtensionDescriptions().map(j=>this._handleWorkspaceContainsEagerExtension(N,j))).then(()=>{})}async _handleWorkspaceContainsEagerExtension(N,j){if(this.isActivated(j.identifier))return;const H=!this._initData.remote.isRemote&&!!this._initData.remote.authority,V={logService:this._logService,folders:N.map(ne=>ne.uri),forceUsingSearch:H,exists:ne=>this._hostUtils.exists(ne.fsPath),checkExists:(ne,fe,ye)=>this._mainThreadWorkspaceProxy.$checkExists(ne,fe,ye)},q=await(0,T.checkActivateWorkspaceContainsExtension)(V,j);if(!!q)return this._activateById(j.identifier,{startup:!0,extensionId:j.identifier,activationEvent:q.activationEvent}).then(void 0,ne=>this._logService.error(ne))}async $extensionTestsExecute(){await this._eagerExtensionsActivated.wait();try{return await this._doHandleExtensionTests()}catch(N){throw console.error(N),N}}async _doHandleExtensionTests(){const{extensionDevelopmentLocationURI:N,extensionTestsLocationURI:j}=this._initData.environment;if(!N||!j)throw new Error(m.localize(0,null));const H=await this._loadCommonJSModule(null,j,new E.ExtensionActivationTimesBuilder(!1));if(!H||typeof H.run!="function")throw new Error(m.localize(1,null,j.toString()));return new Promise((V,q)=>{const ne=(ke,Be)=>{ke?q(ke):V(typeof Be=="number"&&Be>0?1:0)},fe=(0,C.originalFSPath)(j),ye=H.run(fe,ne);ye&&ye.then&&ye.then(()=>{V(0)}).catch(ke=>{q(ke.toString())})})}async $extensionTestsExit(N){this._logService.info(`Extension host terminating: test runner requested exit with code ${N}`),this._hostUtils.pid&&this._logService.info(`Extension host with pid ${this._hostUtils.pid} exiting with code ${N}`),this._logService.flush(),this._hostUtils.exit(N)}_startExtensionHost(){if(this._started)throw new Error("Extension host is already started!");return this._started=!0,this._readyToStartExtensionHost.wait().then(()=>this._readyToRunExtensions.open()).then(()=>this._handleEagerExtensions()).then(()=>{this._eagerExtensionsActivated.open(),this._logService.info("Eager extensions activated")})}registerRemoteAuthorityResolver(N,j){return this._resolvers[N]=j,(0,k.toDisposable)(()=>{delete this._resolvers[N]})}async _activateAndGetResolver(N){const j=N.indexOf("+");if(j===-1)throw new Error("Not an authority that can be resolved!");const H=N.substr(0,j);return await this._almostReadyToRunExtensions.wait(),await this._activateByEvent(`onResolveRemoteAuthority:${H}`,!1),{authorityPrefix:H,resolver:this._resolvers[H]}}async $resolveAuthority(N,j){const{authorityPrefix:H,resolver:V}=await this._activateAndGetResolver(N);if(!V)return{type:"error",error:{code:_.RemoteAuthorityResolverErrorCode.NoResolverFound,message:`No remote extension installed to resolve ${H}.`,detail:void 0}};try{this._register(await this._extHostTunnelService.setTunnelExtensionFunctions(V)),y.mark(`code/extHost/willResolveAuthority/${H}`);const q=await V.resolve(N,{resolveAttempt:j});y.mark(`code/extHost/didResolveAuthorityOK/${H}`);const ne={authority:N,host:q.host,port:q.port,connectionToken:q.connectionToken},fe={extensionHostEnv:q.extensionHostEnv,isTrusted:q.isTrusted,authenticationSession:q.authenticationSessionForInitializingExtensions?{id:q.authenticationSessionForInitializingExtensions.id,providerId:q.authenticationSessionForInitializingExtensions.providerId}:void 0};return{type:"ok",value:{authority:ne,options:fe,tunnelInformation:{environmentTunnels:q.environmentTunnels}}}}catch(q){if(y.mark(`code/extHost/didResolveAuthorityError/${H}`),q instanceof a.RemoteAuthorityResolverError)return{type:"error",error:{code:q._code,message:q._message,detail:q._detail}};throw q}}async $getCanonicalURI(N,j){const{authorityPrefix:H,resolver:V}=await this._activateAndGetResolver(N);if(!V)throw new Error(`Cannot get canonical URI because no remote extension is installed to resolve ${H}`);const q=D.URI.revive(j);if(typeof V.getCanonicalURI=="undefined")return q;const ne=await(0,i.asPromise)(()=>V.getCanonicalURI(q));return ne||q}$startExtensionHost(N){return this._registry.keepOnly(N),this._startExtensionHost()}$activateByEvent(N,j){return j===1?this._activateByEvent(N,!1):this._readyToRunExtensions.wait().then(H=>this._activateByEvent(N,!1))}async $activate(N,j){return await this._readyToRunExtensions.wait(),this._registry.getExtensionDescription(N)?(await this._activateById(N,j),!0):!1}async $deltaExtensions(N,j){N.forEach(V=>V.extensionLocation=D.URI.revive(V.extensionLocation));const H=await this.getExtensionPathIndex();return await Promise.all(j.map(async V=>{const q=this._registry.getExtensionDescription(V);q&&H.delete(await this._realPathExtensionUri(q.extensionLocation))})),await Promise.all(N.map(async V=>{const q=await this._realPathExtensionUri(V.extensionLocation);H.set(q,V)})),this._registry.deltaExtensions(N,j),Promise.resolve(void 0)}async $test_latency(N){return N}async $test_up(N){return N.byteLength}async $test_down(N){let j=r.VSBuffer.alloc(N),H=Math.random()%256;for(let V=0;V<N;V++)j.writeUInt8(H,V);return j}async $updateRemoteConnectionData(N){this._remoteConnectionData=N,this._onDidChangeRemoteConnectionData.fire()}};B=je([He(0,n.IInstantiationService),He(1,e.IHostUtils),He(2,d.IExtHostRpcService),He(3,v.IExtHostWorkspace),He(4,u.IExtHostConfiguration),He(5,R.ILogService),He(6,t.IExtHostInitDataService),He(7,o.IExtensionStoragePaths),He(8,h.IExtHostTunnelService),He(9,l.IExtHostTerminalService)],B),e.AbstractExtHostExtensionService=B;function U(K,N){return{id:K.identifier.value,name:K.name,extensionVersion:K.version,publisherDisplayName:K.publisher,activationEvents:K.activationEvents?K.activationEvents.join(","):null,isBuiltin:K.isBuiltin,reason:N.activationEvent,reasonId:N.extensionId.value}}e.IExtHostExtensionService=(0,n.createDecorator)("IExtHostExtensionService");class z{constructor(N,j,H,V){F.set(this,void 0),W.set(this,void 0),M.set(this,void 0),nt(this,F,N,"f"),nt(this,W,j,"f"),nt(this,M,H.identifier,"f"),this.id=H.identifier.value,this.extensionUri=H.extensionLocation,this.extensionPath=L.normalize((0,C.originalFSPath)(H.extensionLocation)),this.packageJSON=H,this.extensionKind=V}get isActive(){return Ne(this,F,"f").isActivated(Ne(this,M,"f"))}get exports(){if(this.packageJSON.api!=="none")return Ne(this,F,"f").getExtensionExports(Ne(this,M,"f"))}activate(){return Ne(this,F,"f").activateByIdWithErrors(Ne(this,M,"f"),{startup:!1,extensionId:Ne(this,W,"f"),activationEvent:"api"}).then(()=>this.exports)}}e.Extension=z,F=new WeakMap,W=new WeakMap,M=new WeakMap}),define(pe[55],ve([0,1,9,2,3,18,5,7,123,35,39,45,214,36,207,14,4,13,40,54]),function(Y,e,m,L,y,C,i,k,S,D,R,P,u,E,f,v,w,I,p,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WorkerExtHostDebugService=e.ExtHostVariableResolverService=e.ExtHostDebugConsole=e.ExtHostDebugSession=e.ExtHostDebugServiceBase=e.IExtHostDebugService=void 0,e.IExtHostDebugService=(0,w.createDecorator)("IExtHostDebugService");let r=class{constructor(c,h,l,b,T,A){this._workspaceService=h,this._extensionService=l,this._editorsService=b,this._configurationService=T,this._editorTabs=A,this._debugSessions=new Map,this._configProviderHandleCounter=0,this._configProviders=[],this._adapterFactoryHandleCounter=0,this._adapterFactories=[],this._trackerFactoryHandleCounter=0,this._trackerFactories=[],this._debugAdapters=new Map,this._debugAdaptersTrackers=new Map,this._onDidStartDebugSession=new y.Emitter,this._onDidTerminateDebugSession=new y.Emitter,this._onDidChangeActiveDebugSession=new y.Emitter,this._onDidReceiveDebugSessionCustomEvent=new y.Emitter,this._debugServiceProxy=c.getProxy(i.MainContext.MainThreadDebugService),this._onDidChangeBreakpoints=new y.Emitter({onFirstListenerAdd:()=>{this.startBreakpoints()}}),this._activeDebugConsole=new a(this._debugServiceProxy),this._breakpoints=new Map,this._breakpointEventsActive=!1,this._extensionService.getExtensionRegistry().then(x=>{x.onDidChange(O=>{this.registerAllDebugTypes(x)}),this.registerAllDebugTypes(x)})}get onDidStartDebugSession(){return this._onDidStartDebugSession.event}get onDidTerminateDebugSession(){return this._onDidTerminateDebugSession.event}get onDidChangeActiveDebugSession(){return this._onDidChangeActiveDebugSession.event}get activeDebugSession(){return this._activeDebugSession}get onDidReceiveDebugSessionCustomEvent(){return this._onDidReceiveDebugSessionCustomEvent.event}get activeDebugConsole(){return this._activeDebugConsole.value}asDebugSourceUri(c,h){const l=c;if(typeof l.sourceReference=="number"&&l.sourceReference>0){let b=`debug:${encodeURIComponent(l.path||"")}`,T="?";return h&&(b+=`${T}session=${encodeURIComponent(h.id)}`,T="&"),b+=`${T}ref=${l.sourceReference}`,L.URI.parse(b)}else{if(l.path)return L.URI.file(l.path);throw new Error("cannot create uri from DAP 'source' object; properties 'path' and 'sourceReference' are both missing.")}}registerAllDebugTypes(c){const h=[];for(const l of c.getAllExtensionDescriptions())if(l.contributes){const b=l.contributes.debuggers;if(b&&b.length>0)for(const T of b)(0,f.isDebuggerMainContribution)(T)&&h.push(T.type)}this._debugServiceProxy.$registerDebugTypes(h)}get onDidChangeBreakpoints(){return this._onDidChangeBreakpoints.event}get breakpoints(){this.startBreakpoints();const c=[];return this._breakpoints.forEach(h=>c.push(h)),c}addBreakpoints(c){this.startBreakpoints();const h=c.filter(T=>{const A=T.id;return this._breakpoints.has(A)?!1:(this._breakpoints.set(A,T),!0)});this.fireBreakpointChanges(h,[],[]);const l=[],b=new Map;for(const T of h)if(T instanceof k.SourceBreakpoint){let A=b.get(T.location.uri.toString());A||(A={type:"sourceMulti",uri:T.location.uri,lines:[]},b.set(T.location.uri.toString(),A),l.push(A)),A.lines.push({id:T.id,enabled:T.enabled,condition:T.condition,hitCondition:T.hitCondition,logMessage:T.logMessage,line:T.location.range.start.line,character:T.location.range.start.character})}else T instanceof k.FunctionBreakpoint&&l.push({type:"function",id:T.id,enabled:T.enabled,hitCondition:T.hitCondition,logMessage:T.logMessage,condition:T.condition,functionName:T.functionName});return this._debugServiceProxy.$registerBreakpoints(l)}removeBreakpoints(c){this.startBreakpoints();const h=c.filter(A=>this._breakpoints.delete(A.id));this.fireBreakpointChanges([],h,[]);const l=h.filter(A=>A instanceof k.SourceBreakpoint).map(A=>A.id),b=h.filter(A=>A instanceof k.FunctionBreakpoint).map(A=>A.id),T=h.filter(A=>A instanceof k.DataBreakpoint).map(A=>A.id);return this._debugServiceProxy.$unregisterBreakpoints(l,b,T)}startDebugging(c,h,l){return this._debugServiceProxy.$startDebugging(c?c.uri:void 0,h,{parentSessionID:l.parentSession?l.parentSession.id:void 0,lifecycleManagedByParent:l.lifecycleManagedByParent,repl:l.consoleMode===k.DebugConsoleMode.MergeWithParent?"mergeWithParent":"separate",noDebug:l.noDebug,compact:l.compact,debugUI:l.debugUI,suppressSaveBeforeStart:l.suppressSaveBeforeStart})}stopDebugging(c){return this._debugServiceProxy.$stopDebugging(c?c.id:void 0)}registerDebugConfigurationProvider(c,h,l){if(!h)return new k.Disposable(()=>{});const b=this._configProviderHandleCounter++;return this._configProviders.push({type:c,handle:b,provider:h}),this._debugServiceProxy.$registerDebugConfigurationProvider(c,l,!!h.provideDebugConfigurations,!!h.resolveDebugConfiguration,!!h.resolveDebugConfigurationWithSubstitutedVariables,b),new k.Disposable(()=>{this._configProviders=this._configProviders.filter(T=>T.provider!==h),this._debugServiceProxy.$unregisterDebugConfigurationProvider(b)})}registerDebugAdapterDescriptorFactory(c,h,l){if(!l)return new k.Disposable(()=>{});if(!this.definesDebugType(c,h))throw new Error(`a DebugAdapterDescriptorFactory can only be registered from the extension that defines the '${h}' debugger.`);if(this.getAdapterDescriptorFactoryByType(h))throw new Error("a DebugAdapterDescriptorFactory can only be registered once per a type.");const b=this._adapterFactoryHandleCounter++;return this._adapterFactories.push({type:h,handle:b,factory:l}),this._debugServiceProxy.$registerDebugAdapterDescriptorFactory(h,b),new k.Disposable(()=>{this._adapterFactories=this._adapterFactories.filter(T=>T.factory!==l),this._debugServiceProxy.$unregisterDebugAdapterDescriptorFactory(b)})}registerDebugAdapterTrackerFactory(c,h){if(!h)return new k.Disposable(()=>{});const l=this._trackerFactoryHandleCounter++;return this._trackerFactories.push({type:c,handle:l,factory:h}),new k.Disposable(()=>{this._trackerFactories=this._trackerFactories.filter(b=>b.factory!==h)})}async $runInTerminal(c,h){return Promise.resolve(void 0)}async $substituteVariables(c,h){if(!this._variableResolver){const[T,A]=await Promise.all([this._workspaceService.getWorkspaceFolders2(),this._configurationService.getConfigProvider()]);this._variableResolver=this.createVariableResolver(T||[],this._editorsService,A)}let l;const b=await this.getFolder(c);return b&&(l={uri:b.uri,name:b.name,index:b.index,toResource:()=>{throw new Error("Not implemented")}}),this._variableResolver.resolveAnyAsync(l,h)}createDebugAdapter(c,h){if(c.type==="implementation")return new t(c.implementation)}createSignService(){}async $startDASession(c,h){const l=this,b=await this.getSession(h);return this.getAdapterDescriptor(this.getAdapterDescriptorFactoryByType(b.type),b).then(T=>{if(!T)throw new Error(`Couldn't find a debug adapter descriptor for debug type '${b.type}' (extension might have failed to activate)`);const A=this.convertToDto(T),x=this.createDebugAdapter(A,b);if(!x)throw new Error(`Couldn't create a debug adapter for type '${b.type}'.`);const O=x;return this._debugAdapters.set(c,O),this.getDebugAdapterTrackers(b).then(F=>(F&&this._debugAdaptersTrackers.set(c,F),O.onMessage(async W=>{if(W.type==="request"&&W.command==="handshake"){const M=W,B={type:"response",seq:0,command:M.command,request_seq:M.seq,success:!0};this._signService||(this._signService=this.createSignService());try{if(this._signService){const U=await this._signService.sign(M.arguments.value);B.body={signature:U},O.sendResponse(B)}else throw new Error("no signer")}catch(U){B.success=!1,B.message=U.message,O.sendResponse(B)}}else F&&F.onDidSendMessage&&F.onDidSendMessage(W),W=(0,f.convertToVSCPaths)(W,!0),l._debugServiceProxy.$acceptDAMessage(c,W)}),O.onError(W=>{F&&F.onError&&F.onError(W),this._debugServiceProxy.$acceptDAError(c,W.name,W.message,W.stack)}),O.onExit(W=>{F&&F.onExit&&F.onExit((0,I.withNullAsUndefined)(W),void 0),this._debugServiceProxy.$acceptDAExit(c,(0,I.withNullAsUndefined)(W),void 0)}),F&&F.onWillStartSession&&F.onWillStartSession(),O.startSession()))})}$sendDAMessage(c,h){h=(0,f.convertToDAPaths)(h,!1);const l=this._debugAdaptersTrackers.get(c);l&&l.onWillReceiveMessage&&l.onWillReceiveMessage(h);const b=this._debugAdapters.get(c);b&&b.sendMessage(h)}$stopDASession(c){const h=this._debugAdaptersTrackers.get(c);this._debugAdaptersTrackers.delete(c),h&&h.onWillStopSession&&h.onWillStopSession();const l=this._debugAdapters.get(c);return this._debugAdapters.delete(c),l?l.stopSession():Promise.resolve(void 0)}$acceptBreakpointsDelta(c){const h=[],l=[],b=[];if(c.added)for(const T of c.added){const A=T.id;if(A&&!this._breakpoints.has(A)){let x;if(T.type==="function")x=new k.FunctionBreakpoint(T.functionName,T.enabled,T.condition,T.hitCondition,T.logMessage);else if(T.type==="data")x=new k.DataBreakpoint(T.label,T.dataId,T.canPersist,T.enabled,T.hitCondition,T.condition,T.logMessage);else{const O=L.URI.revive(T.uri);x=new k.SourceBreakpoint(new k.Location(O,new k.Position(T.line,T.character)),T.enabled,T.condition,T.hitCondition,T.logMessage)}x._id=A,this._breakpoints.set(A,x),h.push(x)}}if(c.removed)for(const T of c.removed){const A=this._breakpoints.get(T);A&&(this._breakpoints.delete(T),l.push(A))}if(c.changed){for(const T of c.changed)if(T.id){const A=this._breakpoints.get(T.id);if(A){if(A instanceof k.FunctionBreakpoint&&T.type==="function"){const x=A;x.enabled=T.enabled,x.condition=T.condition,x.hitCondition=T.hitCondition,x.logMessage=T.logMessage,x.functionName=T.functionName}else if(A instanceof k.SourceBreakpoint&&T.type==="source"){const x=A;x.enabled=T.enabled,x.condition=T.condition,x.hitCondition=T.hitCondition,x.logMessage=T.logMessage,x.location=new k.Location(L.URI.revive(T.uri),new k.Position(T.line,T.character))}b.push(A)}}}this.fireBreakpointChanges(h,l,b)}$provideDebugConfigurations(c,h,l){return(0,C.asPromise)(async()=>{const b=this.getConfigProviderByHandle(c);if(!b)throw new Error("no DebugConfigurationProvider found");if(!b.provideDebugConfigurations)throw new Error("DebugConfigurationProvider has no method provideDebugConfigurations");const T=await this.getFolder(h);return b.provideDebugConfigurations(T,l)}).then(b=>{if(!b)throw new Error("nothing returned from DebugConfigurationProvider.provideDebugConfigurations");return b})}$resolveDebugConfiguration(c,h,l,b){return(0,C.asPromise)(async()=>{const T=this.getConfigProviderByHandle(c);if(!T)throw new Error("no DebugConfigurationProvider found");if(!T.resolveDebugConfiguration)throw new Error("DebugConfigurationProvider has no method resolveDebugConfiguration");const A=await this.getFolder(h);return T.resolveDebugConfiguration(A,l,b)})}$resolveDebugConfigurationWithSubstitutedVariables(c,h,l,b){return(0,C.asPromise)(async()=>{const T=this.getConfigProviderByHandle(c);if(!T)throw new Error("no DebugConfigurationProvider found");if(!T.resolveDebugConfigurationWithSubstitutedVariables)throw new Error("DebugConfigurationProvider has no method resolveDebugConfigurationWithSubstitutedVariables");const A=await this.getFolder(h);return T.resolveDebugConfigurationWithSubstitutedVariables(A,l,b)})}async $provideDebugAdapter(c,h){const l=this.getAdapterDescriptorFactoryByHandle(c);if(!l)return Promise.reject(new Error("no adapter descriptor factory found for handle"));const b=await this.getSession(h);return this.getAdapterDescriptor(l,b).then(T=>{if(!T)throw new Error(`Couldn't find a debug adapter descriptor for debug type '${b.type}'`);return this.convertToDto(T)})}async $acceptDebugSessionStarted(c){const h=await this.getSession(c);this._onDidStartDebugSession.fire(h)}async $acceptDebugSessionTerminated(c){const h=await this.getSession(c);h&&(this._onDidTerminateDebugSession.fire(h),this._debugSessions.delete(h.id))}async $acceptDebugSessionActiveChanged(c){this._activeDebugSession=c?await this.getSession(c):void 0,this._onDidChangeActiveDebugSession.fire(this._activeDebugSession)}async $acceptDebugSessionNameChanged(c,h){const l=await this.getSession(c);l&&l._acceptNameChanged(h)}async $acceptDebugSessionCustomEvent(c,h){const b={session:await this.getSession(c),event:h.event,body:h.body};this._onDidReceiveDebugSessionCustomEvent.fire(b)}convertToDto(c){if(c instanceof k.DebugAdapterExecutable)return{type:"executable",command:c.command,args:c.args,options:c.options};if(c instanceof k.DebugAdapterServer)return{type:"server",port:c.port,host:c.host};if(c instanceof k.DebugAdapterNamedPipeServer)return{type:"pipeServer",path:c.path};if(c instanceof k.DebugAdapterInlineImplementation)return{type:"implementation",implementation:c.implementation};throw new Error("convertToDto unexpected type")}getAdapterDescriptorFactoryByType(c){const h=this._adapterFactories.filter(l=>l.type===c);if(h.length>0)return h[0].factory}getAdapterDescriptorFactoryByHandle(c){const h=this._adapterFactories.filter(l=>l.handle===c);if(h.length>0)return h[0].factory}getConfigProviderByHandle(c){const h=this._configProviders.filter(l=>l.handle===c);if(h.length>0)return h[0].provider}definesDebugType(c,h){if(c.contributes){const l=c.contributes.debuggers;if(l&&l.length>0){for(const b of l)if(b.label&&b.type&&b.type===h)return!0}}return!1}getDebugAdapterTrackers(c){const l=c.configuration.type,b=this._trackerFactories.filter(T=>T.type===l||T.type==="*").map(T=>(0,C.asPromise)(()=>T.factory.createDebugAdapterTracker(c)).then(A=>A,A=>null));return Promise.race([Promise.all(b).then(T=>{const A=T.filter(x=>!!x);if(A.length>0)return new n(A)}),new Promise((T,A)=>{const x=setTimeout(()=>{clearTimeout(x),A(new Error("timeout"))},1e3)})]).catch(T=>{})}async getAdapterDescriptor(c,h){const l=h.configuration.debugServer;if(typeof l=="number")return Promise.resolve(new k.DebugAdapterServer(l));if(c){const T=await this._extensionService.getExtensionRegistry();return(0,C.asPromise)(()=>c.createDebugAdapterDescriptor(h,this.daExecutableFromPackage(h,T))).then(A=>{if(A)return A})}const b=await this._extensionService.getExtensionRegistry();return Promise.resolve(this.daExecutableFromPackage(h,b))}daExecutableFromPackage(c,h){}startBreakpoints(){this._breakpointEventsActive||(this._breakpointEventsActive=!0,this._debugServiceProxy.$startBreakpointEvents())}fireBreakpointChanges(c,h,l){(c.length>0||h.length>0||l.length>0)&&this._onDidChangeBreakpoints.fire(Object.freeze({added:c,removed:h,changed:l}))}async getSession(c){if(c)if(typeof c=="string"){const h=this._debugSessions.get(c);if(h)return h}else{let h=this._debugSessions.get(c.id);if(!h){const l=await this.getFolder(c.folderUri),b=c.parent?this._debugSessions.get(c.parent):void 0;h=new g(this._debugServiceProxy,c.id,c.type,c.name,l,c.configuration,b),this._debugSessions.set(h.id,h),this._debugServiceProxy.$sessionCached(h.id)}return h}throw new Error("cannot find session")}getFolder(c){if(c){const h=L.URI.revive(c);return this._workspaceService.resolveWorkspaceFolder(h)}return Promise.resolve(void 0)}};r=je([He(0,v.IExtHostRpcService),He(1,D.IExtHostWorkspace),He(2,R.IExtHostExtensionService),He(3,P.IExtHostDocumentsAndEditors),He(4,E.IExtHostConfiguration),He(5,s.IExtHostEditorTabs)],r),e.ExtHostDebugServiceBase=r;class g{constructor(c,h,l,b,T,A,x){this._debugServiceProxy=c,this._id=h,this._type=l,this._name=b,this._workspaceFolder=T,this._configuration=A,this._parentSession=x}get id(){return this._id}get type(){return this._type}get name(){return this._name}set name(c){this._name=c,this._debugServiceProxy.$setDebugSessionName(this._id,c)}get parentSession(){return this._parentSession}_acceptNameChanged(c){this._name=c}get workspaceFolder(){return this._workspaceFolder}get configuration(){return this._configuration}customRequest(c,h){return this._debugServiceProxy.$customDebugAdapterRequest(this._id,c,h)}getDebugProtocolBreakpoint(c){return this._debugServiceProxy.$getDebugProtocolBreakpoint(this._id,c.id)}}e.ExtHostDebugSession=g;class a{constructor(c){this.value=Object.freeze({append(h){c.$appendDebugConsole(h)},appendLine(h){this.append(h+`
`)}})}}e.ExtHostDebugConsole=a;class _ extends u.AbstractVariableResolverService{constructor(c,h,l,b,T){function A(){if(h){const x=h.activeEditor();if(x)return x.document.uri;const O=b.tabs.filter(F=>F.isActive);if(O.length>0){const F=O[0].resource;return F&&(F.primary||F.secondary)?F.primary??F.secondary:O[0].resource}}}super({getFolderUri:x=>{const O=c.filter(F=>F.name===x);if(O&&O.length>0)return O[0].uri},getWorkspaceFolderCount:()=>c.length,getConfigurationValue:(x,O)=>l.getConfiguration(void 0,x).get(O),getAppRoot:()=>p.cwd(),getExecPath:()=>p.env.VSCODE_EXEC_PATH,getFilePath:()=>{const x=A();if(x)return m.normalize(x.fsPath)},getWorkspaceFolderPathForFile:()=>{if(T){const x=A();if(x){const O=T.getWorkspaceFolder(x);if(O)return m.normalize(O.uri.fsPath)}}},getSelectedText:()=>{if(h){const x=h.activeEditor();if(x&&!x.selection.isEmpty)return x.document.getText(x.selection)}},getLineNumber:()=>{if(h){const x=h.activeEditor();if(x)return String(x.selection.end.line+1)}}},void 0,Promise.resolve(p.env))}}e.ExtHostVariableResolverService=_;class n{constructor(c){this.trackers=c}onWillStartSession(){this.trackers.forEach(c=>c.onWillStartSession?c.onWillStartSession():void 0)}onWillReceiveMessage(c){this.trackers.forEach(h=>h.onWillReceiveMessage?h.onWillReceiveMessage(c):void 0)}onDidSendMessage(c){this.trackers.forEach(h=>h.onDidSendMessage?h.onDidSendMessage(c):void 0)}onWillStopSession(){this.trackers.forEach(c=>c.onWillStopSession?c.onWillStopSession():void 0)}onError(c){this.trackers.forEach(h=>h.onError?h.onError(c):void 0)}onExit(c,h){this.trackers.forEach(l=>l.onExit?l.onExit(c,h):void 0)}}class t extends S.AbstractDebugAdapter{constructor(c){super();this.implementation=c,c.onDidSendMessage(h=>{this.acceptMessage(h)})}startSession(){return Promise.resolve(void 0)}sendMessage(c){this.implementation.handleMessage(c)}stopSession(){return this.implementation.dispose(),Promise.resolve(void 0)}}let o=class extends r{constructor(c,h,l,b,T,A){super(c,h,l,b,T,A)}createVariableResolver(c,h,l){return new _(c,h,l,this._editorTabs)}};o=je([He(0,v.IExtHostRpcService),He(1,D.IExtHostWorkspace),He(2,R.IExtHostExtensionService),He(3,P.IExtHostDocumentsAndEditors),He(4,E.IExtHostConfiguration),He(5,s.IExtHostEditorTabs)],o),e.WorkerExtHostDebugService=o}),define(pe[268],ve([0,1,71,2,5,36,29,27,14,26,4,39,40,11]),function(Y,e,m,L,y,C,i,k,S,D,R,P,u,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RequireInterceptor=void 0;let f=class{constructor(s,r,g,a,_,n,t){this._apiFactory=s,this._extensionRegistry=r,this._instaService=g,this._extHostConfiguration=a,this._extHostExtensionService=_,this._initData=n,this._logService=t,this._factories=new Map,this._alternatives=[]}async install(){this._installInterceptor(),m.mark("code/extHost/willWaitForConfig");const s=await this._extHostConfiguration.getConfigProvider();m.mark("code/extHost/didWaitForConfig");const r=await this._extHostExtensionService.getExtensionPathIndex();this.register(new v(this._apiFactory,r,this._extensionRegistry,s,this._logService)),this.register(this._instaService.createInstance(w,r)),this._initData.remote.isRemote&&this.register(this._instaService.createInstance(I,r,this._initData.environment.appUriScheme))}register(s){if(Array.isArray(s.nodeModuleName))for(let r of s.nodeModuleName)this._factories.set(r,s);else this._factories.set(s.nodeModuleName,s);typeof s.alternativeModuleName=="function"&&this._alternatives.push(r=>s.alternativeModuleName(r))}};f=je([He(2,R.IInstantiationService),He(3,C.IExtHostConfiguration),He(4,P.IExtHostExtensionService),He(5,D.IExtHostInitDataService),He(6,E.ILogService)],f),e.RequireInterceptor=f;class v{constructor(s,r,g,a,_){this._apiFactory=s,this._extensionPaths=r,this._extensionRegistry=g,this._configProvider=a,this._logService=_,this.nodeModuleName="vscode",this._extApiImpl=new Map}load(s,r){const g=this._extensionPaths.findSubstr(r);if(g){let a=this._extApiImpl.get(k.ExtensionIdentifier.toKey(g.identifier));return a||(a=this._apiFactory(g,this._extensionRegistry,this._configProvider),this._extApiImpl.set(k.ExtensionIdentifier.toKey(g.identifier),a)),a}if(!this._defaultApiImpl){let a="";this._extensionPaths.forEach((_,n)=>a+=`	${n} -> ${_.identifier.value}
`),this._logService.warn(`Could not identify extension for 'vscode' require call from ${r}. These are the extension path mappings: 
${a}`),this._defaultApiImpl=this._apiFactory(i.nullExtensionDescription,this._extensionRegistry,this._configProvider)}return this._defaultApiImpl}}let w=class{constructor(s,r,g){this._extensionPaths=s,this.nodeModuleName="keytar",this._mainThreadTelemetry=r.getProxy(y.MainContext.MainThreadTelemetry);const{environment:a}=g,_=r.getProxy(y.MainContext.MainThreadKeytar);if(a.appRoot){let n=a.appRoot.fsPath;u.platform==="win32"&&(n=n.replace(/\\/g,"/")),n[n.length-1]==="/"&&(n=n.substr(0,n.length-1)),this.alternativeNames=new Set,this.alternativeNames.add(`${n}/node_modules.asar/keytar`),this.alternativeNames.add(`${n}/node_modules/keytar`)}this._impl={getPassword:(n,t)=>_.$getPassword(n,t),setPassword:(n,t,o)=>_.$setPassword(n,t,o),deletePassword:(n,t)=>_.$deletePassword(n,t),findPassword:n=>_.$findPassword(n),findCredentials(n){return _.$findCredentials(n)}}}load(s,r){const g=this._extensionPaths.findSubstr(r);return this._mainThreadTelemetry.$publicLog2("shimming.keytar",{extension:g?.identifier.value??"unknown_extension"}),this._impl}alternativeModuleName(s){const r=s.length;if(r<=7||!this.alternativeNames)return;const g=r-7;if((s.charAt(g)==="/"||s.charAt(g)==="\\")&&s.endsWith("keytar")&&(s=s.replace(/\\/g,"/"),this.alternativeNames.has(s)))return"keytar"}};w=je([He(1,S.IExtHostRpcService),He(2,D.IExtHostInitDataService)],w);let I=class{constructor(s,r,g){this._extensionPaths=s,this._appUriScheme=r,this.nodeModuleName=["open","opn"],this._mainThreadTelemetry=g.getProxy(y.MainContext.MainThreadTelemetry);const a=g.getProxy(y.MainContext.MainThreadWindow);this._impl=(_,n)=>{const t=L.URI.parse(_);return n?this.callOriginal(_,n):t.scheme==="http"||t.scheme==="https"?a.$openUri(t,_,{allowTunneling:!0}):t.scheme==="mailto"||t.scheme===this._appUriScheme?a.$openUri(t,_,{}):this.callOriginal(_,n)}}load(s,r,g){const a=this._extensionPaths.findSubstr(r);return a&&(this._extensionId=a.identifier.value,this.sendShimmingTelemetry()),this._original=g(s),this._impl}callOriginal(s,r){return this.sendNoForwardTelemetry(),this._original(s,r)}sendShimmingTelemetry(){!this._extensionId||this._mainThreadTelemetry.$publicLog2("shimming.open",{extension:this._extensionId})}sendNoForwardTelemetry(){!this._extensionId||this._mainThreadTelemetry.$publicLog2("shimming.open.call.noForward",{extension:this._extensionId})}};I=je([He(2,S.IExtHostRpcService)],I)}),define(pe[269],ve([0,1,169,12,7,208,35,39,45,36,34,14,55,194,18,209,54]),function(Y,e,m,L,y,C,i,k,S,D,R,P,u,E,f,v,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDebugService=void 0;let I=class extends u.ExtHostDebugServiceBase{constructor(r,g,a,_,n,t,o){super(r,g,a,_,n,o);this._terminalService=t,this._integratedTerminalInstances=new p}createDebugAdapter(r,g){switch(r.type){case"server":return new C.SocketDebugAdapter(r);case"pipeServer":return new C.NamedPipeDebugAdapter(r);case"executable":return new C.ExecutableDebugAdapter(r,g.type)}return super.createDebugAdapter(r,g)}daExecutableFromPackage(r,g){const a=C.ExecutableDebugAdapter.platformAdapterExecutable(g.getAllExtensionDescriptions(),r.type);if(a)return new y.DebugAdapterExecutable(a.command,a.args,a.options)}createSignService(){return new E.SignService}async $runInTerminal(r,g){if(r.kind==="integrated"){this._terminalDisposedListener||(this._terminalDisposedListener=this._terminalService.onDidCloseTerminal(A=>{this._integratedTerminalInstances.onTerminalClosed(A)}));const a=await this._configurationService.getConfigProvider(),_=this._terminalService.getDefaultShell(!0),n=this._terminalService.getDefaultShellArgs(!0),t=r.title||m.localize(0,null),o=JSON.stringify({shell:_,shellArgs:n});let d=await this._integratedTerminalInstances.checkout(o,t),c,h=!1;if(d)c=r.cwd;else{const A={shellPath:_,shellArgs:n,cwd:r.cwd,name:t,iconPath:new y.ThemeIcon("debug")};h=!0,d=this._terminalService.createTerminalFromOptions(A,{isFeatureTerminal:!0,useShellEnvironment:!0}),this._integratedTerminalInstances.insert(d,o)}d.show(!0);const l=await d.processId;h?await new Promise(A=>setTimeout(A,1e3)):a.getConfiguration("debug.terminal").get("clearBeforeReusing")&&(_.indexOf("powershell")>=0||_.indexOf("pwsh")>=0||_.indexOf("cmd.exe")>=0?d.sendText("cls"):_.indexOf("bash")>=0?d.sendText("clear"):L.isWindows?d.sendText("cls"):d.sendText("clear"));const b=(0,v.prepareCommand)(_,r.args,c,r.env);d.sendText(b);const T=this.onDidTerminateDebugSession(A=>{A.id===g&&(this._integratedTerminalInstances.free(d),T.dispose())});return l}else if(r.kind==="external")return(0,v.runInExternalTerminal)(r,await this._configurationService.getConfigProvider());return super.$runInTerminal(r,g)}createVariableResolver(r,g,a){return new u.ExtHostVariableResolverService(r,g,a,this._editorTabs,this._workspaceService)}};I=je([He(0,P.IExtHostRpcService),He(1,i.IExtHostWorkspace),He(2,k.IExtHostExtensionService),He(3,S.IExtHostDocumentsAndEditors),He(4,D.IExtHostConfiguration),He(5,R.IExtHostTerminalService),He(6,w.IExtHostEditorTabs)],I),e.ExtHostDebugService=I;class p{constructor(){this._terminalInstances=new Map}async checkout(r,g){const _=[...this._terminalInstances.entries()].map(([n,t])=>(0,f.createCancelablePromise)(async o=>{if(n.name!==g||t.lastUsedAt!==-1&&await(0,v.hasChildProcesses)(await n.processId))return null;const d=Date.now();return t.lastUsedAt+p.minUseDelay>d||o.isCancellationRequested||t.config!==r?null:(t.lastUsedAt=d,n)}));return await(0,f.firstParallel)(_,n=>!!n)}insert(r,g){this._terminalInstances.set(r,{lastUsedAt:Date.now(),config:g})}free(r){const g=this._terminalInstances.get(r);g&&(g.lastUsedAt=-1)}onTerminalClosed(r){this._terminalInstances.delete(r)}}p.minUseDelay=1e3}),define(pe[270],ve([0,1,9,2,112,35,55,45,36,43,34,14,26,70,10,11,65,54,23,81]),function(Y,e,m,L,y,C,i,k,S,D,R,P,u,E,f,v,w,I,p,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTask=void 0;let r=class extends E.ExtHostTaskBase{constructor(a,_,n,t,o,d,c,h,l){super(a,_,n,t,o,d,c,h);this.workspaceService=n,this.editorTabs=l,_.remote.isRemote&&_.remote.authority?this.registerTaskSystem(f.Schemas.vscodeRemote,{scheme:f.Schemas.vscodeRemote,authority:_.remote.authority,platform:process.platform}):this.registerTaskSystem(f.Schemas.file,{scheme:f.Schemas.file,authority:"",platform:process.platform}),this._proxy.$registerSupportedExecutions(!0,!0,!0)}async executeTask(a,_){const n=_;if(!_.execution&&n._id===void 0)throw new Error("Tasks to execute must include an execution");if(n._id!==void 0){const t=E.TaskHandleDTO.from(n,this.workspaceService),o=await this._proxy.$getTaskExecution(t);if(o.task===void 0)throw new Error("Task from execution DTO is undefined");const d=await this.getTaskExecution(o,_);return this._proxy.$executeTask(t).catch(()=>{}),d}else{const t=E.TaskDTO.from(_,a);if(t===void 0)return Promise.reject(new Error("Task is not valid"));E.CustomExecutionDTO.is(t.execution)&&await this.addCustomExecution(t,_,!1);const o=await this.getTaskExecution(await this._proxy.$getTaskExecution(t),_);return this._proxy.$executeTask(t).catch(()=>{}),o}}provideTasksInternal(a,_,n,t){const o=[];if(t)for(let d of t){this.checkDeprecation(d,n),(!d.definition||!a[d.definition.type])&&this._logService.warn(`The task [${d.source}, ${d.name}] uses an undefined task type. The task will be ignored in the future.`);const c=E.TaskDTO.from(d,n.extension);c&&(o.push(c),E.CustomExecutionDTO.is(c.execution)&&_.push(this.addCustomExecution(c,d,!0)))}return{tasks:o,extension:n.extension}}async resolveTaskInternal(a){return a}async getVariableResolver(a){if(this._variableResolver===void 0){const _=await this._configurationService.getConfigProvider();this._variableResolver=new i.ExtHostVariableResolverService(a,this._editorService,_,this.editorTabs,this.workspaceService)}return this._variableResolver}async getAFolder(a){let _=a&&a.length>0?a[0]:void 0;if(!_){const n=L.URI.file((0,s.homedir)());_=new D.WorkspaceFolder({uri:n,name:p.basename(n),index:0})}return{uri:_.uri,name:_.name,index:_.index,toResource:()=>{throw new Error("Not implemented")}}}async $resolveVariables(a,_){const n=L.URI.revive(a),t={process:void 0,variables:Object.create(null)},o=await this._workspaceProvider.resolveWorkspaceFolder(n),d=await this._workspaceProvider.getWorkspaceFolders2()??[],c=await this.getVariableResolver(d),h=o?{uri:o.uri,name:o.name,index:o.index,toResource:()=>{throw new Error("Not implemented")}}:await this.getAFolder(d);for(let l of _.variables)t.variables[l]=await c.resolveAsync(h,l);if(_.process!==void 0){let l;if(_.process.path!==void 0){l=_.process.path.split(m.delimiter);for(let b=0;b<l.length;b++)l[b]=await c.resolveAsync(h,l[b])}t.process=await y.win32.findExecutable(await c.resolveAsync(h,_.process.name),_.process.cwd!==void 0?await c.resolveAsync(h,_.process.cwd):void 0,l)}return t}async $jsonTasksSupported(){return!0}async $findExecutable(a,_,n){return y.win32.findExecutable(a,_,n)}};r=je([He(0,P.IExtHostRpcService),He(1,u.IExtHostInitDataService),He(2,C.IExtHostWorkspace),He(3,k.IExtHostDocumentsAndEditors),He(4,S.IExtHostConfiguration),He(5,R.IExtHostTerminalService),He(6,v.ILogService),He(7,w.IExtHostApiDeprecationService),He(8,I.IExtHostEditorTabs)],r),e.ExtHostTask=r}),define(pe[271],ve([0,1,18,15,71,6,2,5,263,11,83,85,26,186,14,64,39,34]),function(Y,e,m,L,y,C,i,k,S,D,R,P,u,E,f,v,w,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionHostMain=void 0;class p{constructor(r,g,a,_){this._disposables=new C.DisposableStore,this._isTerminating=!1,this._hostUtils=a,this._rpcProtocol=new S.RPCProtocol(r,null,_),g=p._transform(g,this._rpcProtocol);const n=new P.ServiceCollection(...(0,R.getSingletonServiceDescriptors)());n.set(u.IExtHostInitDataService,{_serviceBrand:void 0,...g}),n.set(f.IExtHostRpcService,new f.ExtHostRpcService(this._rpcProtocol)),n.set(v.IURITransformerService,new v.URITransformerService(_)),n.set(w.IHostUtils,a);const t=new E.InstantiationService(n,!0);this._disposables.add(t.invokeFunction(h=>h.get(I.IExtHostTerminalService))),this._disposables.add(t.invokeFunction(h=>h.get(w.IExtHostExtensionService))),this._logService=t.invokeFunction(h=>h.get(D.ILogService)),y.mark("code/extHost/didCreateServices"),this._hostUtils.pid?this._logService.info(`Extension host with pid ${this._hostUtils.pid} started`):this._logService.info("Extension host started"),this._logService.trace("initData",g),this._extensionService=t.invokeFunction(h=>h.get(w.IExtHostExtensionService)),this._extensionService.initialize(),Error.stackTraceLimit=100;const o=new WeakMap;this._extensionService.getExtensionPathIndex().then(h=>{Error.prepareStackTrace=(l,b)=>{let T="",A,x;for(const O of b)T+=`
	at ${O.toString()}`,x=O.getFileName(),!A&&x&&(A=h.findSubstr(i.URI.file(x)));return o.set(l,A),`${l.name||"Error"}: ${l.message||""}${T}`}});const d=this._rpcProtocol.getProxy(k.MainContext.MainThreadExtensionService),c=this._rpcProtocol.getProxy(k.MainContext.MainThreadErrors);L.setUnexpectedErrorHandler(h=>{const l=L.transformErrorForSerialization(h),b=o.get(h);b?d.$onExtensionRuntimeError(b.identifier,l):c.$onUnexpectedError(l)})}terminate(r){if(this._isTerminating)return;this._isTerminating=!0,this._logService.info(`extension host terminating: ${r}`),this._logService.flush(),this._disposables.dispose(),L.setUnexpectedErrorHandler(a=>{this._logService.error(a)}),this._rpcProtocol.dispose();const g=this._extensionService.deactivateAll();Promise.race([(0,m.timeout)(5e3),g]).finally(()=>{this._hostUtils.pid?this._logService.info(`Extension host with pid ${this._hostUtils.pid} exiting with code 0`):this._logService.info("Extension host exiting with code 0"),this._logService.flush(),this._logService.dispose(),this._hostUtils.exit(0)})}static _transform(r,g){r.extensions.forEach(_=>_.extensionLocation=i.URI.revive(g.transformIncomingURIs(_.extensionLocation))),r.environment.appRoot=i.URI.revive(g.transformIncomingURIs(r.environment.appRoot));const a=r.environment.extensionDevelopmentLocationURI;return a&&(r.environment.extensionDevelopmentLocationURI=a.map(_=>i.URI.revive(g.transformIncomingURIs(_)))),r.environment.extensionTestsLocationURI=i.URI.revive(g.transformIncomingURIs(r.environment.extensionTestsLocationURI)),r.environment.globalStorageHome=i.URI.revive(g.transformIncomingURIs(r.environment.globalStorageHome)),r.environment.workspaceStorageHome=i.URI.revive(g.transformIncomingURIs(r.environment.workspaceStorageHome)),r.logsLocation=i.URI.revive(g.transformIncomingURIs(r.logsLocation)),r.logFile=i.URI.revive(g.transformIncomingURIs(r.logFile)),r.workspace=g.transformIncomingURIs(r.workspace),r}}e.ExtensionHostMain=p}),define(pe[272],ve([0,1,9,21,50,31,23,46,33]),function(Y,e,m,L,y,C,i,k,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileSearchManager=void 0;class D{constructor(u,E,f){this.config=u,this.provider=E,this.sessionToken=f,this.isLimitHit=!1,this.resultCount=0,this.isCanceled=!1,this.filePattern=u.filePattern,this.includePattern=u.includePattern&&C.parse(u.includePattern),this.maxResults=u.maxResults||void 0,this.exists=u.exists,this.activeCancellationTokens=new Set,this.globalExcludePattern=u.excludePattern&&C.parse(u.excludePattern)}cancel(){this.isCanceled=!0,this.activeCancellationTokens.forEach(u=>u.cancel()),this.activeCancellationTokens=new Set}search(u){const E=this.config.folderQueries||[];return new Promise((f,v)=>{const w=I=>{this.resultCount++,u(I)};if(this.isCanceled)return f({limitHit:this.isLimitHit});this.config.extraFileResources&&this.config.extraFileResources.forEach(I=>{const p=I.toString(),s=m.basename(p);this.globalExcludePattern&&this.globalExcludePattern(p,s)||this.matchFile(w,{base:I,basename:s})}),Promise.all(E.map(I=>this.searchInFolder(I,w))).then(I=>{f({limitHit:this.isLimitHit,stats:I[0]||void 0})},I=>{v(new Error((0,y.toErrorMessage)(I)))})})}async searchInFolder(u,E){const f=new L.CancellationTokenSource,v=this.getSearchOptionsForFolder(u),w=this.initDirectoryTree(),I=new S.QueryGlobTester(this.config,u),p=!I.hasSiblingExcludeClauses();let s;try{this.activeCancellationTokens.add(f),s=k.StopWatch.create();const r=await this.provider.provideFileSearchResults({pattern:this.config.filePattern||""},v,f.token),g=s.elapsed(),a=k.StopWatch.create();return this.isCanceled&&!this.isLimitHit||(r&&r.forEach(_=>{const n=m.posix.relative(u.folder.path,_.path);if(p){const t=m.basename(_.path);this.matchFile(E,{base:u.folder,relativePath:n,basename:t});return}this.addDirectoryEntries(w,u.folder,n,E)}),this.isCanceled&&!this.isLimitHit)?null:(this.matchDirectoryTree(w,I,E),{providerTime:g,postProcessTime:a.elapsed()})}finally{f.dispose(),this.activeCancellationTokens.delete(f)}}getSearchOptionsForFolder(u){const E=(0,S.resolvePatternsForProvider)(this.config.includePattern,u.includePattern),f=(0,S.resolvePatternsForProvider)(this.config.excludePattern,u.excludePattern);return{folder:u.folder,excludes:f,includes:E,useIgnoreFiles:!u.disregardIgnoreFiles,useGlobalIgnoreFiles:!u.disregardGlobalIgnoreFiles,followSymlinks:!u.ignoreSymlinks,maxResults:this.config.maxResults,session:this.sessionToken}}initDirectoryTree(){const u={rootEntries:[],pathToEntries:Object.create(null)};return u.pathToEntries["."]=u.rootEntries,u}addDirectoryEntries({pathToEntries:u},E,f,v){if(f===this.filePattern){const I=m.basename(this.filePattern);this.matchFile(v,{base:E,relativePath:this.filePattern,basename:I})}function w(I){const p=m.basename(I),s=m.dirname(I);let r=u[s];r||(r=u[s]=[],w(s)),r.push({base:E,relativePath:I,basename:p})}w(f)}matchDirectoryTree({rootEntries:u,pathToEntries:E},f,v){const w=this,I=this.filePattern;function p(s){const r=C.hasSiblingFn(()=>s.map(g=>g.basename));for(let g=0,a=s.length;g<a;g++){const _=s[g],{relativePath:n,basename:t}=_;if(f.matchesExcludesSync(n,t,I!==t?r:void 0))continue;const o=E[n];if(o)p(o);else{if(n===I)continue;w.matchFile(v,_)}if(w.isLimitHit)break}}p(u)}matchFile(u,E){(!this.includePattern||E.relativePath&&this.includePattern(E.relativePath,E.basename))&&((this.exists||this.maxResults&&this.resultCount>=this.maxResults)&&(this.isLimitHit=!0,this.cancel()),this.isLimitHit||u(E))}}class R{constructor(){this.sessions=new Map}fileSearch(u,E,f,v){const w=this.getSessionTokenSource(u.cacheKey),I=new D(u,E,w&&w.token);let p=0;const s=r=>{p+=r.length,f(r.map(g=>this.rawMatchToSearchItem(g)))};return this.doSearch(I,R.BATCH_SIZE,s,v).then(r=>({limitHit:r.limitHit,stats:{fromCache:!1,type:"fileSearchProvider",resultCount:p,detailStats:r.stats}}))}clearCache(u){const E=this.getSessionTokenSource(u);E&&E.cancel()}getSessionTokenSource(u){if(!!u)return this.sessions.has(u)||this.sessions.set(u,new L.CancellationTokenSource),this.sessions.get(u)}rawMatchToSearchItem(u){return u.relativePath?{resource:i.joinPath(u.base,u.relativePath)}:{resource:u.base}}doSearch(u,E,f,v){v.onCancellationRequested(()=>{u.cancel()});const w=p=>{p&&(I.push(p),E>0&&I.length>=E&&(f(I),I=[]))};let I=[];return u.search(w).then(p=>(I.length&&f(I),p),p=>(I.length&&f(I),Promise.reject(p)))}}e.FileSearchManager=R,R.BATCH_SIZE=512}),define(pe[134],ve([0,1,16,21,50,31,10,9,23,13,2,33]),function(Y,e,m,L,y,C,i,k,S,D,R,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.BatchedCollector=e.extensionResultIsMatch=e.TextSearchResultsCollector=e.TextSearchManager=void 0;class u{constructor(s,r,g,a){this.query=s,this.provider=r,this.fileUtils=g,this.processType=a,this.collector=null,this.isLimitHit=!1,this.resultCount=0}search(s,r){const g=this.query.folderQueries||[],a=new L.CancellationTokenSource;return r.onCancellationRequested(()=>a.cancel()),new Promise((_,n)=>{this.collector=new f(s);let t=!1;const o=(d,c)=>{if(!t&&!this.isLimitHit){const h=this.resultSize(d);w(d)&&typeof this.query.maxResults=="number"&&this.resultCount+h>this.query.maxResults&&(this.isLimitHit=!0,t=!0,a.cancel(),d=this.trimResultToSize(d,this.query.maxResults-this.resultCount));const l=this.resultSize(d);this.resultCount+=l,(l>0||!w(d))&&this.collector.add(d,c)}};Promise.all(g.map((d,c)=>this.searchInFolder(d,h=>o(h,c),a.token))).then(d=>{a.dispose(),this.collector.flush();const c=d.some(h=>!!h&&!!h.limitHit);_({limitHit:this.isLimitHit||c,messages:(0,m.flatten)(d.map(h=>h?.message?(0,D.isArray)(h.message)?h.message:[h.message]:[])),stats:{type:this.processType}})},d=>{a.dispose();const c=(0,y.toErrorMessage)(d);n(new Error(c))})})}resultSize(s){return w(s)?Array.isArray(s.ranges)?s.ranges.length:1:0}trimResultToSize(s,r){const g=Array.isArray(s.ranges)?s.ranges:[s.ranges],a=Array.isArray(s.preview.matches)?s.preview.matches:[s.preview.matches];return{ranges:g.slice(0,r),preview:{matches:a.slice(0,r),text:s.preview.text},uri:s.uri}}async searchInFolder(s,r,g){const a=new P.QueryGlobTester(this.query,s),_=[],n={report:d=>{if(!this.validateProviderResult(d))return;const c=s.folder.scheme===i.Schemas.file?C.hasSiblingPromiseFn(()=>this.fileUtils.readdir(S.dirname(d.uri))):void 0,h=S.relativePath(s.folder,d.uri);if(h){const l=a.includedInQuery(h,k.basename(h),c);(0,D.isPromise)(l)?_.push(l.then(b=>{b&&r(d)})):l&&r(d)}}},t=this.getSearchOptionsForFolder(s),o=await this.provider.provideTextSearchResults(E(this.query.contentPattern),t,n,g);return _.length&&await Promise.all(_),o}validateProviderResult(s){if(w(s)){if(Array.isArray(s.ranges)){if(!Array.isArray(s.preview.matches))return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same type."),!1;if(s.preview.matches.length!==s.ranges.length)return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same length."),!1}else if(Array.isArray(s.preview.matches))return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same length."),!1}return!0}getSearchOptionsForFolder(s){const r=(0,P.resolvePatternsForProvider)(this.query.includePattern,s.includePattern),g=(0,P.resolvePatternsForProvider)(this.query.excludePattern,s.excludePattern),a={folder:R.URI.from(s.folder),excludes:g,includes:r,useIgnoreFiles:!s.disregardIgnoreFiles,useGlobalIgnoreFiles:!s.disregardGlobalIgnoreFiles,followSymlinks:!s.ignoreSymlinks,encoding:s.fileEncoding&&this.fileUtils.toCanonicalName(s.fileEncoding),maxFileSize:this.query.maxFileSize,maxResults:this.query.maxResults,previewOptions:this.query.previewOptions,afterContext:this.query.afterContext,beforeContext:this.query.beforeContext};return a.usePCRE2=this.query.usePCRE2,a}}e.TextSearchManager=u;function E(p){return{isCaseSensitive:p.isCaseSensitive||!1,isRegExp:p.isRegExp||!1,isWordMatch:p.isWordMatch||!1,isMultiline:p.isMultiline||!1,pattern:p.pattern}}class f{constructor(s){this._onResult=s,this._currentFolderIdx=-1,this._currentFileMatch=null,this._batchedCollector=new I(512,r=>this.sendItems(r))}add(s,r){this._currentFileMatch&&(this._currentFolderIdx!==r||!S.isEqual(this._currentUri,s.uri))&&(this.pushToCollector(),this._currentFileMatch=null),this._currentFileMatch||(this._currentFolderIdx=r,this._currentFileMatch={resource:s.uri,results:[]}),this._currentFileMatch.results.push(v(s))}pushToCollector(){const s=this._currentFileMatch&&this._currentFileMatch.results?this._currentFileMatch.results.length:0;this._batchedCollector.addItem(this._currentFileMatch,s)}flush(){this.pushToCollector(),this._batchedCollector.flush()}sendItems(s){this._onResult(s)}}e.TextSearchResultsCollector=f;function v(p){return w(p)?{preview:{matches:(0,m.mapArrayOrNot)(p.preview.matches,s=>({startLineNumber:s.start.line,startColumn:s.start.character,endLineNumber:s.end.line,endColumn:s.end.character})),text:p.preview.text},ranges:(0,m.mapArrayOrNot)(p.ranges,s=>({startLineNumber:s.start.line,startColumn:s.start.character,endLineNumber:s.end.line,endColumn:s.end.character}))}:{text:p.text,lineNumber:p.lineNumber}}function w(p){return!!p.preview}e.extensionResultIsMatch=w;class I{constructor(s,r){this.maxBatchSize=s,this.cb=r,this.totalNumberCompleted=0,this.batch=[],this.batchSize=0}addItem(s,r){!s||this.addItemToBatch(s,r)}addItems(s,r){!s||this.addItemsToBatch(s,r)}addItemToBatch(s,r){this.batch.push(s),this.batchSize+=r,this.onUpdate()}addItemsToBatch(s,r){this.batch=this.batch.concat(s),this.batchSize+=r,this.onUpdate()}onUpdate(){this.totalNumberCompleted<I.START_BATCH_AFTER_COUNT?this.flush():this.batchSize>=this.maxBatchSize?this.flush():this.timeoutHandle||(this.timeoutHandle=setTimeout(()=>{this.flush()},I.TIMEOUT))}flush(){this.batchSize&&(this.totalNumberCompleted+=this.batchSize,this.cb(this.batch),this.batch=[],this.batchSize=0,this.timeoutHandle&&(clearTimeout(this.timeoutHandle),this.timeoutHandle=0))}}e.BatchedCollector=I,I.TIMEOUT=4e3,I.START_BATCH_AFTER_COUNT=50}),define(pe[72],ve([0,1,6,5,4,272,14,64,11,2,134]),function(Y,e,m,L,y,C,i,k,S,D,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.reviveQuery=e.ExtHostSearch=e.IExtHostSearch=void 0,e.IExtHostSearch=(0,y.createDecorator)("IExtHostSearch");let P=class{constructor(v,w,I){this.extHostRpc=v,this._uriTransformer=w,this._logService=I,this._proxy=this.extHostRpc.getProxy(L.MainContext.MainThreadSearch),this._handlePool=0,this._textSearchProvider=new Map,this._textSearchUsedSchemes=new Set,this._fileSearchProvider=new Map,this._fileSearchUsedSchemes=new Set,this._fileSearchManager=new C.FileSearchManager}_transformScheme(v){return this._uriTransformer.transformOutgoingScheme(v)}registerTextSearchProvider(v,w){if(this._textSearchUsedSchemes.has(v))throw new Error(`a text search provider for the scheme '${v}' is already registered`);this._textSearchUsedSchemes.add(v);const I=this._handlePool++;return this._textSearchProvider.set(I,w),this._proxy.$registerTextSearchProvider(I,this._transformScheme(v)),(0,m.toDisposable)(()=>{this._textSearchUsedSchemes.delete(v),this._textSearchProvider.delete(I),this._proxy.$unregisterProvider(I)})}registerFileSearchProvider(v,w){if(this._fileSearchUsedSchemes.has(v))throw new Error(`a file search provider for the scheme '${v}' is already registered`);this._fileSearchUsedSchemes.add(v);const I=this._handlePool++;return this._fileSearchProvider.set(I,w),this._proxy.$registerFileSearchProvider(I,this._transformScheme(v)),(0,m.toDisposable)(()=>{this._fileSearchUsedSchemes.delete(v),this._fileSearchProvider.delete(I),this._proxy.$unregisterProvider(I)})}$provideFileSearchResults(v,w,I,p){const s=u(I),r=this._fileSearchProvider.get(v);if(r)return this._fileSearchManager.fileSearch(s,r,g=>{this._proxy.$handleFileMatch(v,w,g.map(a=>a.resource))},p);throw new Error("unknown provider: "+v)}$clearCache(v){return this._fileSearchManager.clearCache(v),Promise.resolve(void 0)}$provideTextSearchResults(v,w,I,p){const s=this._textSearchProvider.get(v);if(!s||!s.provideTextSearchResults)throw new Error(`Unknown provider ${v}`);const r=u(I);return this.createTextSearchManager(r,s).search(a=>this._proxy.$handleTextMatch(v,w,a),p)}$enableExtensionHostSearch(){}createTextSearchManager(v,w){return new R.TextSearchManager(v,w,{readdir:I=>Promise.resolve([]),toCanonicalName:I=>I},"textSearchProvider")}};P=je([He(0,i.IExtHostRpcService),He(1,k.IURITransformerService),He(2,S.ILogService)],P),e.ExtHostSearch=P;function u(f){return{...f,folderQueries:f.folderQueries&&f.folderQueries.map(E),extraFileResources:f.extraFileResources&&f.extraFileResources.map(v=>D.URI.revive(v))}}e.reviveQuery=u;function E(f){return{...f,folder:D.URI.revive(f.folder)}}}),define(pe[273],ve([0,1,21,15,3,48,2,113,108,146,82,42,5,231,230,38,232,36,233,234,235,216,236,45,39,237,217,240,241,242,132,219,247,248,249,91,34,251,220,17,7,254,68,133,35,73,205,239,62,130,70,55,72,11,64,14,26,243,202,52,65,228,252,201,67,66,257,255,256,229,44,250,253,90,54,121,245,69,246,10,189,244,199,238,6,29]),function(Y,e,m,L,y,C,i,k,S,D,R,P,u,E,f,v,w,I,p,s,r,g,a,_,n,t,o,d,c,h,l,b,T,A,x,O,F,W,M,B,U,z,K,N,j,H,V,q,ne,fe,ye,ke,Be,We,ze,Q,ee,re,he,Z,oe,be,Me,Ve,Ge,Je,tt,ot,et,it,ct,pt,Pt,Ue,Rt,J,ie,ge,te,Ee,Le,Oe,Xe,Te,Ie,Se){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createApiFactoryAndRegisterActors=void 0;function le(ue){const we=ue.get(ee.IExtHostInitDataService),_e=ue.get(ct.IExtHostFileSystemInfo),Fe=ue.get(Je.IExtHostConsumerFileSystem),Ke=ue.get(n.IExtHostExtensionService),$e=ue.get(j.IExtHostWorkspace),Qe=ue.get(J.IExtHostTelemetry),st=ue.get(I.IExtHostConfiguration),at=ue.get(ze.IURITransformerService),de=ue.get(Q.IExtHostRpcService),Ce=ue.get(O.IExtHostStorage),ce=ue.get(Ge.IExtensionStoragePaths),X=ue.get(We.ILoggerService),De=ue.get(We.ILogService),Re=ue.get(Z.IExtHostTunnelService),Ze=ue.get(oe.IExtHostApiDeprecationService),qe=ue.get(N.IExtHostWindow),dt=ue.get(Ue.IExtHostSecretState),wt=ue.get(Rt.IExtHostEditorTabs);de.set(u.ExtHostContext.ExtHostFileSystemInfo,_e),de.set(u.ExtHostContext.ExtHostLogLevelServiceShape,X),de.set(u.ExtHostContext.ExtHostWorkspace,$e),de.set(u.ExtHostContext.ExtHostConfiguration,st),de.set(u.ExtHostContext.ExtHostExtensionService,Ke),de.set(u.ExtHostContext.ExtHostStorage,Ce),de.set(u.ExtHostContext.ExtHostTunnelService,Re),de.set(u.ExtHostContext.ExtHostWindow,qe),de.set(u.ExtHostContext.ExtHostSecretState,dt),de.set(u.ExtHostContext.ExtHostTelemetry,Qe),de.set(u.ExtHostContext.ExtHostEditorTabs,wt);const yt=de.set(u.ExtHostContext.ExtHostDecorations,ue.get(fe.IExtHostDecorations)),bt=de.set(u.ExtHostContext.ExtHostDocumentsAndEditors,ue.get(_.IExtHostDocumentsAndEditors)),ft=de.set(u.ExtHostContext.ExtHostCommands,ue.get(v.IExtHostCommands)),vt=de.set(u.ExtHostContext.ExtHostTerminalService,ue.get(F.IExtHostTerminalService)),St=de.set(u.ExtHostContext.ExtHostDebugService,ue.get(ke.IExtHostDebugService)),Ot=de.set(u.ExtHostContext.ExtHostSearch,ue.get(Be.IExtHostSearch)),It=de.set(u.ExtHostContext.ExtHostTask,ue.get(ye.IExtHostTask)),Tt=de.set(u.ExtHostContext.ExtHostOutputService,ue.get(l.IExtHostOutputService)),Lt=de.set(u.ExtHostContext.ExtHostUrls,new z.ExtHostUrls(de)),_t=de.set(u.ExtHostContext.ExtHostDocuments,new a.ExtHostDocuments(de,bt)),Mt=de.set(u.ExtHostContext.ExtHostDocumentContentProviders,new r.ExtHostDocumentContentProvider(de,bt,De)),Nt=de.set(u.ExtHostContext.ExtHostDocumentSaveParticipant,new g.ExtHostDocumentSaveParticipant(De,_t,de.getProxy(u.MainContext.MainThreadBulkEdits))),Et=de.set(u.ExtHostContext.ExtHostNotebook,new re.ExtHostNotebookController(de,ft,bt,_t,ce)),Wt=de.set(u.ExtHostContext.ExtHostNotebookDocuments,new Xe.ExtHostNotebookDocuments(De,Et)),jt=de.set(u.ExtHostContext.ExtHostNotebookEditors,new Oe.ExtHostNotebookEditors(De,de,Et)),si=de.set(u.ExtHostContext.ExtHostNotebookKernels,new ie.ExtHostNotebookKernels(de,we,Et,ft,De)),oi=de.set(u.ExtHostContext.ExtHostNotebookRenderers,new te.ExtHostNotebookRenderers(de,Et)),At=de.set(u.ExtHostContext.ExtHostEditors,new W.ExtHostEditors(de,bt)),Xt=de.set(u.ExtHostContext.ExtHostTreeViews,new M.ExtHostTreeViews(de.getProxy(u.MainContext.MainThreadTreeViews),ft,De)),ai=de.set(u.ExtHostContext.ExtHostEditorInsets,new V.ExtHostEditorInsets(de.getProxy(u.MainContext.MainThreadEditorInsets),At,we)),Yt=de.set(u.ExtHostContext.ExtHostDiagnostics,new p.ExtHostDiagnostics(de,De,_e)),Vt=de.set(u.ExtHostContext.ExtHostLanguages,new c.ExtHostLanguages(de,_t,ft.converter,at)),gt=de.set(u.ExtHostContext.ExtHostLanguageFeatures,new d.ExtHostLanguageFeatures(de,at,_t,ft,Yt,De,Ze)),ci=de.set(u.ExtHostContext.ExtHostFileSystem,new t.ExtHostFileSystem(de,gt)),Ut=de.set(u.ExtHostContext.ExtHostFileSystemEventService,new o.ExtHostFileSystemEventService(de,De,bt)),qt=de.set(u.ExtHostContext.ExtHostQuickOpen,(0,T.createExtHostQuickOpen)(de,$e,ft)),Jt=de.set(u.ExtHostContext.ExtHostSCM,new A.ExtHostSCM(de,ft,De)),li=de.set(u.ExtHostContext.ExtHostComments,(0,w.createExtHostComments)(de,ft,_t)),fi=de.set(u.ExtHostContext.ExtHostProgress,new b.ExtHostProgress(de.getProxy(u.MainContext.MainThreadProgress))),Ei=de.set(u.ExtHostContext.ExtHosLabelService,new q.ExtHostLabelService(de)),mi=de.set(u.ExtHostContext.ExtHostTheming,new he.ExtHostTheming(de)),Zt=de.set(u.ExtHostContext.ExtHostAuthentication,new be.ExtHostAuthentication(de)),_i=de.set(u.ExtHostContext.ExtHostTimeline,new Me.ExtHostTimeline(de,ft)),Gt=de.set(u.ExtHostContext.ExtHostWebviews,new K.ExtHostWebviews(de,{remote:we.remote},$e,De,Ze)),Kt=de.set(u.ExtHostContext.ExtHostWebviewPanels,new et.ExtHostWebviewPanels(de,Gt,$e)),Si=de.set(u.ExtHostContext.ExtHostCustomEditors,new ot.ExtHostCustomEditors(de,_t,ce,Gt,Kt)),Ci=de.set(u.ExtHostContext.ExtHostWebviewViews,new tt.ExtHostWebviewViews(de,Gt)),Qt=de.set(u.ExtHostContext.ExtHostTesting,new pt.ExtHostTesting(de,ft)),yi=de.set(u.ExtHostContext.ExtHostUriOpeners,new Pt.ExtHostUriOpeners(de));de.set(u.ExtHostContext.ExtHostInteractive,new Te.ExtHostInteractive(de,Et,bt,ft));const ei=(0,H.values)(u.ExtHostContext);de.assertRegistered(ei);const Di=new it.ExtHostBulkEdits(de,bt),ki=new f.ExtHostClipboard(de),ui=new h.ExtHostMessageService(de,De),ti=new s.ExtHostDialogs(de),gi=new x.ExtHostStatusBar(de,ft.converter);return E.ExtHostApiCommands.register(ft),function(xe,xt,pi){const mt=function(){let se=!xe.isUnderDevelopment;function me(){se||(De.info(`Extension '${xe.identifier.value}' uses a document selector without scheme. Learn more about this: https://go.microsoft.com/fwlink/?linkid=872305`),se=!0)}return function Ae(ut){if(Array.isArray(ut))ut.forEach(Ae);else if(typeof ut=="string")me();else{const Ct=ut;typeof Ct.scheme=="undefined"&&me(),typeof Ct.exclusive=="boolean"&&(0,Se.checkProposedApiEnabled)(xe,"documentFiltersExclusive")}return ut}}(),ii={getSession(se,me,Ae){return Zt.getSession(xe,se,me,Ae)},async hasSession(se,me){return(0,Se.checkProposedApiEnabled)(xe,"authSession"),!!await Zt.getSession(xe,se,me,{silent:!0})},get onDidChangeSessions(){return Zt.onDidChangeSessions},registerAuthenticationProvider(se,me,Ae,ut){return Zt.registerAuthenticationProvider(se,me,Ae,ut)}},Ii={registerCommand(se,me,Ae){return ft.registerCommand(!0,se,me,Ae,void 0,xe)},registerTextEditorCommand(se,me,Ae){return ft.registerCommand(!0,se,(...ut)=>{const Ct=At.getActiveTextEditor();if(!Ct){De.warn("Cannot execute "+se+" because there is no active text editor.");return}return Ct.edit(Dt=>{me.apply(Ae,[Ct,Dt,...ut])}).then(Dt=>{Dt||De.warn("Edits from command "+se+" were not applied.")},Dt=>{De.warn("An error occurred while running command "+se,Dt)})},void 0,void 0,xe)},registerDiffInformationCommand:(se,me,Ae)=>((0,Se.checkProposedApiEnabled)(xe,"diffCommand"),ft.registerCommand(!0,se,async(...ut)=>{const Ct=bt.activeEditor(!0);if(!Ct){De.warn("Cannot execute "+se+" because there is no active text editor.");return}const Dt=await At.getDiffInformation(Ct.id);me.apply(Ae,[Dt,...ut])},void 0,void 0,xe)),executeCommand(se,...me){return ft.executeCommand(se,...me)},getCommands(se=!1){return ft.getCommands(se)}},vi={get machineId(){return we.telemetryInfo.machineId},get sessionId(){return we.telemetryInfo.sessionId},get language(){return we.environment.appLanguage},get appName(){return we.environment.appName},get appRoot(){return we.environment.appRoot?.fsPath??""},get appHost(){return we.environment.appHost},get uriScheme(){return we.environment.appUriScheme},get clipboard(){return ki.value},get shell(){return vt.getDefaultShell(!1)},get isTelemetryEnabled(){return Qe.getTelemetryEnabled()},get onDidChangeTelemetryEnabled(){return Qe.onDidChangeTelemetryEnabled},get isNewAppInstall(){const se=Date.now()-new Date(we.telemetryInfo.firstSessionDate).getTime();return isNaN(se)?!1:se<1e3*60*60*24},openExternal(se,me){return qe.openUri(se,{allowTunneling:!!we.remote.authority,allowContributedOpeners:me?.allowContributedOpeners})},async asExternalUri(se){if(se.scheme===we.environment.appUriScheme)return Lt.createAppUri(se);try{return await qe.asExternalUri(se,{allowTunneling:!!we.remote.authority})}catch(me){if((0,Le.matchesScheme)(se,Ee.Schemas.http)||(0,Le.matchesScheme)(se,Ee.Schemas.https))return se;throw me}},get remoteName(){return(0,ne.getRemoteName)(we.remote.authority)},get remoteAuthority(){return(0,Se.checkProposedApiEnabled)(xe,"resolvers"),we.remote.authority},get uiKind(){return we.uiKind}};we.environment.extensionTestsLocationURI||Object.freeze(vi);const wi=we.remote.isRemote?U.ExtensionKind.Workspace:U.ExtensionKind.UI,Pi={createTestController(se,me){return Qt.createTestController(se,me)},createTestObserver(){return(0,Se.checkProposedApiEnabled)(xe,"testObserver"),Qt.createTestObserver()},runTests(se){return(0,Se.checkProposedApiEnabled)(xe,"testObserver"),Qt.runTests(se)},get onDidChangeTestResults(){return(0,Se.checkProposedApiEnabled)(xe,"testObserver"),Qt.onResultsChanged},get testResults(){return(0,Se.checkProposedApiEnabled)(xe,"testObserver"),Qt.results}},Ti={getExtension(se){const me=xt.getExtensionDescription(se);if(me)return new n.Extension(Ke,xe.identifier,me,wi)},get all(){return xt.getAllExtensionDescriptions().map(se=>new n.Extension(Ke,xe.identifier,se,wi))},get onDidChange(){return xt.onDidChange}},Ai={createDiagnosticCollection(se){return Yt.createDiagnosticCollection(xe.identifier,se)},get onDidChangeDiagnostics(){return Yt.onDidChangeDiagnostics},getDiagnostics:se=>Yt.getDiagnostics(se),getLanguages(){return Vt.getLanguages()},setTextDocumentLanguage(se,me){return Vt.changeLanguage(se.uri,me)},match(se,me){return(0,R.score)(B.LanguageSelector.from(se),me.uri,me.languageId,!0)},registerCodeActionsProvider(se,me,Ae){return gt.registerCodeActionProvider(xe,mt(se),me,Ae)},registerCodeLensProvider(se,me){return gt.registerCodeLensProvider(xe,mt(se),me)},registerDefinitionProvider(se,me){return gt.registerDefinitionProvider(xe,mt(se),me)},registerDeclarationProvider(se,me){return gt.registerDeclarationProvider(xe,mt(se),me)},registerImplementationProvider(se,me){return gt.registerImplementationProvider(xe,mt(se),me)},registerTypeDefinitionProvider(se,me){return gt.registerTypeDefinitionProvider(xe,mt(se),me)},registerHoverProvider(se,me){return gt.registerHoverProvider(xe,mt(se),me,xe.identifier)},registerEvaluatableExpressionProvider(se,me){return gt.registerEvaluatableExpressionProvider(xe,mt(se),me,xe.identifier)},registerInlineValuesProvider(se,me){return gt.registerInlineValuesProvider(xe,mt(se),me,xe.identifier)},registerDocumentHighlightProvider(se,me){return gt.registerDocumentHighlightProvider(xe,mt(se),me)},registerLinkedEditingRangeProvider(se,me){return gt.registerLinkedEditingRangeProvider(xe,mt(se),me)},registerReferenceProvider(se,me){return gt.registerReferenceProvider(xe,mt(se),me)},registerRenameProvider(se,me){return gt.registerRenameProvider(xe,mt(se),me)},registerDocumentSymbolProvider(se,me,Ae){return gt.registerDocumentSymbolProvider(xe,mt(se),me,Ae)},registerWorkspaceSymbolProvider(se){return gt.registerWorkspaceSymbolProvider(xe,se)},registerDocumentFormattingEditProvider(se,me){return gt.registerDocumentFormattingEditProvider(xe,mt(se),me)},registerDocumentRangeFormattingEditProvider(se,me){return gt.registerDocumentRangeFormattingEditProvider(xe,mt(se),me)},registerOnTypeFormattingEditProvider(se,me,Ae,...ut){return gt.registerOnTypeFormattingEditProvider(xe,mt(se),me,[Ae].concat(ut))},registerDocumentSemanticTokensProvider(se,me,Ae){return gt.registerDocumentSemanticTokensProvider(xe,mt(se),me,Ae)},registerDocumentRangeSemanticTokensProvider(se,me,Ae){return gt.registerDocumentRangeSemanticTokensProvider(xe,mt(se),me,Ae)},registerSignatureHelpProvider(se,me,Ae,...ut){return typeof Ae=="object"?gt.registerSignatureHelpProvider(xe,mt(se),me,Ae):gt.registerSignatureHelpProvider(xe,mt(se),me,typeof Ae=="undefined"?[]:[Ae,...ut])},registerCompletionItemProvider(se,me,...Ae){return gt.registerCompletionItemProvider(xe,mt(se),me,Ae)},registerInlineCompletionItemProvider(se,me){return(0,Se.checkProposedApiEnabled)(xe,"inlineCompletions"),gt.registerInlineCompletionsProvider(xe,mt(se),me)},registerDocumentLinkProvider(se,me){return gt.registerDocumentLinkProvider(xe,mt(se),me)},registerColorProvider(se,me){return gt.registerColorProvider(xe,mt(se),me)},registerFoldingRangeProvider(se,me){return gt.registerFoldingRangeProvider(xe,mt(se),me)},registerSelectionRangeProvider(se,me){return gt.registerSelectionRangeProvider(xe,se,me)},registerCallHierarchyProvider(se,me){return gt.registerCallHierarchyProvider(xe,se,me)},registerTypeHierarchyProvider(se,me){return gt.registerTypeHierarchyProvider(xe,se,me)},setLanguageConfiguration:(se,me)=>gt.setLanguageConfiguration(xe,se,me),getTokenInformationAtPosition(se,me){return(0,Se.checkProposedApiEnabled)(xe,"tokenInformation"),Vt.tokenAtPosition(se,me)},registerInlayHintsProvider(se,me){return(0,Se.checkProposedApiEnabled)(xe,"inlayHints"),gt.registerInlayHintsProvider(xe,se,me)},createLanguageStatusItem(se,me){return(0,Se.checkProposedApiEnabled)(xe,"languageStatus"),Vt.createLanguageStatusItem(xe,se,me)}},Ri={get activeTextEditor(){return At.getActiveTextEditor()},get visibleTextEditors(){return At.getVisibleTextEditors()},get activeTerminal(){return vt.activeTerminal},get terminals(){return vt.terminals},async showTextDocument(se,me,Ae){const ut=await(i.URI.isUri(se)?Promise.resolve(ni.openTextDocument(se)):Promise.resolve(se));return At.showTextDocument(ut,me,Ae)},createTextEditorDecorationType(se){return At.createTextEditorDecorationType(xe,se)},onDidChangeActiveTextEditor(se,me,Ae){return At.onDidChangeActiveTextEditor(se,me,Ae)},onDidChangeVisibleTextEditors(se,me,Ae){return At.onDidChangeVisibleTextEditors(se,me,Ae)},onDidChangeTextEditorSelection(se,me,Ae){return At.onDidChangeTextEditorSelection(se,me,Ae)},onDidChangeTextEditorOptions(se,me,Ae){return At.onDidChangeTextEditorOptions(se,me,Ae)},onDidChangeTextEditorVisibleRanges(se,me,Ae){return At.onDidChangeTextEditorVisibleRanges(se,me,Ae)},onDidChangeTextEditorViewColumn(se,me,Ae){return At.onDidChangeTextEditorViewColumn(se,me,Ae)},onDidCloseTerminal(se,me,Ae){return vt.onDidCloseTerminal(se,me,Ae)},onDidOpenTerminal(se,me,Ae){return vt.onDidOpenTerminal(se,me,Ae)},onDidChangeActiveTerminal(se,me,Ae){return vt.onDidChangeActiveTerminal(se,me,Ae)},onDidChangeTerminalDimensions(se,me,Ae){return(0,Se.checkProposedApiEnabled)(xe,"terminalDimensions"),vt.onDidChangeTerminalDimensions(se,me,Ae)},onDidChangeTerminalState(se,me,Ae){return vt.onDidChangeTerminalState(se,me,Ae)},onDidWriteTerminalData(se,me,Ae){return(0,Se.checkProposedApiEnabled)(xe,"terminalDataWriteEvent"),vt.onDidWriteTerminalData(se,me,Ae)},get state(){return qe.state},onDidChangeWindowState(se,me,Ae){return qe.onDidChangeWindowState(se,me,Ae)},showInformationMessage(se,...me){return ui.showMessage(xe,C.default.Info,se,me[0],me.slice(1))},showWarningMessage(se,...me){return ui.showMessage(xe,C.default.Warning,se,me[0],me.slice(1))},showErrorMessage(se,...me){return ui.showMessage(xe,C.default.Error,se,me[0],me.slice(1))},showQuickPick(se,me,Ae){return Array.isArray(se)&&se.some(ut=>ut.kind!==void 0)&&(0,Se.checkProposedApiEnabled)(xe,"quickPickSeparators"),qt.showQuickPick(se,me,Ae)},showWorkspaceFolderPick(se){return qt.showWorkspaceFolderPick(se)},showInputBox(se,me){return qt.showInput(se,me)},showOpenDialog(se){return ti.showOpenDialog(se)},showSaveDialog(se){return ti.showSaveDialog(se)},createStatusBarItem(se,me,Ae){let ut,Ct,Dt;return typeof se=="string"?(ut=se,Ct=me,Dt=Ae):(Ct=se,Dt=me),gi.createStatusBarEntry(xe,ut,Ct,Dt)},setStatusBarMessage(se,me){return gi.setStatusBarMessage(se,me)},withScmProgress(se){return Ze.report("window.withScmProgress",xe,"Use 'withProgress' instead."),fi.withProgress(xe,{location:U.ProgressLocation.SourceControl},(me,Ae)=>se({report(ut){}}))},withProgress(se,me){return fi.withProgress(xe,se,me)},createOutputChannel(se){return Tt.createOutputChannel(se,xe)},createWebviewPanel(se,me,Ae,ut){return Kt.createWebviewPanel(xe,se,me,Ae,ut)},createWebviewTextEditorInset(se,me,Ae,ut){return(0,Se.checkProposedApiEnabled)(xe,"editorInsets"),ai.createWebviewEditorInset(se,me,Ae,ut,xe)},createTerminal(se,me,Ae){return typeof se=="object"?("location"in se&&(0,Se.checkProposedApiEnabled)(xe,"terminalLocation"),"pty"in se?vt.createExtensionTerminal(se):vt.createTerminalFromOptions(se)):vt.createTerminal(se,me,Ae)},registerTerminalLinkProvider(se){return vt.registerLinkProvider(se)},registerTerminalProfileProvider(se,me){return vt.registerProfileProvider(xe,se,me)},registerTreeDataProvider(se,me){return Xt.registerTreeDataProvider(se,me,xe)},createTreeView(se,me){return Xt.createTreeView(se,me,xe)},registerWebviewPanelSerializer:(se,me)=>Kt.registerWebviewPanelSerializer(xe,se,me),registerCustomEditorProvider:(se,me,Ae={})=>Si.registerCustomEditorProvider(xe,se,me,Ae),registerFileDecorationProvider(se){return yt.registerFileDecorationProvider(se,xe.identifier)},registerUriHandler(se){return Lt.registerUriHandler(xe.identifier,se)},createQuickPick(){return qt.createQuickPick(xe)},createInputBox(){return qt.createInputBox(xe.identifier)},get activeColorTheme(){return mi.activeColorTheme},onDidChangeActiveColorTheme(se,me,Ae){return mi.onDidChangeActiveColorTheme(se,me,Ae)},registerWebviewViewProvider(se,me,Ae){return Ci.registerWebviewViewProvider(xe,se,me,Ae?.webviewOptions)},get activeNotebookEditor(){return(0,Se.checkProposedApiEnabled)(xe,"notebookEditor"),Et.activeNotebookEditor},onDidChangeActiveNotebookEditor(se,me,Ae){return(0,Se.checkProposedApiEnabled)(xe,"notebookEditor"),Et.onDidChangeActiveNotebookEditor(se,me,Ae)},get visibleNotebookEditors(){return(0,Se.checkProposedApiEnabled)(xe,"notebookEditor"),Et.visibleNotebookEditors},get onDidChangeVisibleNotebookEditors(){return(0,Se.checkProposedApiEnabled)(xe,"notebookEditor"),Et.onDidChangeVisibleNotebookEditors},onDidChangeNotebookEditorSelection(se,me,Ae){return(0,Se.checkProposedApiEnabled)(xe,"notebookEditor"),jt.onDidChangeNotebookEditorSelection(se,me,Ae)},onDidChangeNotebookEditorVisibleRanges(se,me,Ae){return(0,Se.checkProposedApiEnabled)(xe,"notebookEditor"),jt.onDidChangeNotebookEditorVisibleRanges(se,me,Ae)},showNotebookDocument(se,me){return(0,Se.checkProposedApiEnabled)(xe,"notebookEditor"),Et.showNotebookDocument(se,me)},registerExternalUriOpener(se,me,Ae){return(0,Se.checkProposedApiEnabled)(xe,"externalUriOpener"),yi.registerExternalUriOpener(xe.identifier,se,me,Ae)},get tabs(){return(0,Se.checkProposedApiEnabled)(xe,"tabs"),wt.tabs},get activeTab(){return(0,Se.checkProposedApiEnabled)(xe,"tabs"),wt.activeTab},get onDidChangeTabs(){return(0,Se.checkProposedApiEnabled)(xe,"tabs"),wt.onDidChangeTabs},get onDidChangeActiveTab(){return(0,Se.checkProposedApiEnabled)(xe,"tabs"),wt.onDidChangeActiveTab},getInlineCompletionItemController(se){return(0,Se.checkProposedApiEnabled)(xe,"inlineCompletions"),d.InlineCompletionController.get(se)}},ni={get rootPath(){return Ze.report("workspace.rootPath",xe,"Please use 'workspace.workspaceFolders' instead. More details: https://aka.ms/vscode-eliminating-rootpath"),$e.getPath()},set rootPath(se){throw L.readonly()},getWorkspaceFolder(se){return $e.getWorkspaceFolder(se)},get workspaceFolders(){return $e.getWorkspaceFolders()},get name(){return $e.name},set name(se){throw L.readonly()},get workspaceFile(){return $e.workspaceFile},set workspaceFile(se){throw L.readonly()},updateWorkspaceFolders:(se,me,...Ae)=>$e.updateWorkspaceFolders(xe,se,me||0,...Ae),onDidChangeWorkspaceFolders:function(se,me,Ae){return $e.onDidChangeWorkspace(se,me,Ae)},asRelativePath:(se,me)=>$e.getRelativePath(se,me),findFiles:(se,me,Ae,ut)=>$e.findFiles(B.GlobPattern.from(se),B.GlobPattern.from(me),Ae,xe.identifier,ut),findTextInFiles:(se,me,Ae,ut)=>{(0,Se.checkProposedApiEnabled)(xe,"findTextInFiles");let Ct,Dt;return typeof me=="object"?(Ct=me,Dt=Ae):(Ct={},Dt=me,ut=Ae),$e.findTextInFiles(se,Ct||{},Dt,xe.identifier,ut)},saveAll:se=>$e.saveAll(se),applyEdit(se){return Di.applyWorkspaceEdit(se)},createFileSystemWatcher:(se,me,Ae,ut)=>Ut.createFileSystemWatcher(B.GlobPattern.from(se),me,Ae,ut),get textDocuments(){return _t.getAllDocumentData().map(se=>se.document)},set textDocuments(se){throw L.readonly()},openTextDocument(se){let me;const Ae=se;if(typeof se=="string")me=Promise.resolve(i.URI.file(se));else if(i.URI.isUri(se))me=Promise.resolve(se);else if(!Ae||typeof Ae=="object")me=_t.createDocumentData(Ae);else throw new Error("illegal argument - uriOrFileNameOrOptions");return me.then(ut=>_t.ensureDocumentData(ut).then(Ct=>Ct.document))},onDidOpenTextDocument:(se,me,Ae)=>_t.onDidAddDocument(se,me,Ae),onDidCloseTextDocument:(se,me,Ae)=>_t.onDidRemoveDocument(se,me,Ae),onDidChangeTextDocument:(se,me,Ae)=>_t.onDidChangeDocument(se,me,Ae),onDidSaveTextDocument:(se,me,Ae)=>_t.onDidSaveDocument(se,me,Ae),onWillSaveTextDocument:(se,me,Ae)=>Nt.getOnWillSaveTextDocumentEvent(xe)(se,me,Ae),get notebookDocuments(){return Et.notebookDocuments.map(se=>se.apiNotebook)},async openNotebookDocument(se,me){let Ae;if(i.URI.isUri(se))Ae=se,await Et.openNotebookDocument(se);else if(typeof se=="string")Ae=i.URI.revive(await Et.createNotebookDocument({viewType:se,content:me}));else throw new Error("Invalid arguments");return Et.getNotebookDocument(Ae).apiNotebook},get onDidOpenNotebookDocument(){return Et.onDidOpenNotebookDocument},get onDidCloseNotebookDocument(){return Et.onDidCloseNotebookDocument},registerNotebookSerializer(se,me,Ae,ut){return Et.registerNotebookSerializer(xe,se,me,Ae,(0,Se.isProposedApiEnabled)(xe,"notebookLiveShare")?ut:void 0)},registerNotebookContentProvider:(se,me,Ae,ut)=>((0,Se.checkProposedApiEnabled)(xe,"notebookContentProvider"),Et.registerNotebookContentProvider(xe,se,me,Ae,(0,Se.isProposedApiEnabled)(xe,"notebookLiveShare")?ut:void 0)),onDidChangeConfiguration:(se,me,Ae)=>pi.onDidChangeConfiguration(se,me,Ae),getConfiguration(se,me){return me=arguments.length===1?void 0:me,pi.getConfiguration(se,me,xe)},registerTextDocumentContentProvider(se,me){return Mt.registerTextDocumentContentProvider(se,me)},registerTaskProvider:(se,me)=>(Ze.report("window.registerTaskProvider",xe,"Use the corresponding function on the 'tasks' namespace instead"),It.registerTaskProvider(xe,se,me)),registerFileSystemProvider(se,me,Ae){return(0,Ie.combinedDisposable)(ci.registerFileSystemProvider(xe,se,me,Ae),Fe.addFileSystemProvider(se,me))},get fs(){return Fe.value},registerFileSearchProvider:(se,me)=>((0,Se.checkProposedApiEnabled)(xe,"fileSearchProvider"),Ot.registerFileSearchProvider(se,me)),registerTextSearchProvider:(se,me)=>((0,Se.checkProposedApiEnabled)(xe,"textSearchProvider"),Ot.registerTextSearchProvider(se,me)),registerRemoteAuthorityResolver:(se,me)=>((0,Se.checkProposedApiEnabled)(xe,"resolvers"),Ke.registerRemoteAuthorityResolver(se,me)),registerResourceLabelFormatter:se=>((0,Se.checkProposedApiEnabled)(xe,"resolvers"),Ei.$registerResourceLabelFormatter(se)),onDidCreateFiles:(se,me,Ae)=>Ut.onDidCreateFile(se,me,Ae),onDidDeleteFiles:(se,me,Ae)=>Ut.onDidDeleteFile(se,me,Ae),onDidRenameFiles:(se,me,Ae)=>Ut.onDidRenameFile(se,me,Ae),onWillCreateFiles:(se,me,Ae)=>Ut.getOnWillCreateFileEvent(xe)(se,me,Ae),onWillDeleteFiles:(se,me,Ae)=>Ut.getOnWillDeleteFileEvent(xe)(se,me,Ae),onWillRenameFiles:(se,me,Ae)=>Ut.getOnWillRenameFileEvent(xe)(se,me,Ae),openTunnel:se=>((0,Se.checkProposedApiEnabled)(xe,"resolvers"),Re.openTunnel(xe,se).then(me=>{if(!me)throw new Error("cannot open tunnel");return me})),get tunnels(){return(0,Se.checkProposedApiEnabled)(xe,"resolvers"),Re.getTunnels()},onDidChangeTunnels:(se,me,Ae)=>((0,Se.checkProposedApiEnabled)(xe,"resolvers"),Re.onDidChangeTunnels(se,me,Ae)),registerPortAttributesProvider:(se,me)=>((0,Se.checkProposedApiEnabled)(xe,"portsAttributes"),Re.registerPortsAttributesProvider(se,me)),registerTimelineProvider:(se,me)=>((0,Se.checkProposedApiEnabled)(xe,"timeline"),_i.registerTimelineProvider(se,me,xe.identifier,ft.converter)),get isTrusted(){return $e.trusted},requestWorkspaceTrust:se=>((0,Se.checkProposedApiEnabled)(xe,"workspaceTrust"),$e.requestWorkspaceTrust(se)),onDidGrantWorkspaceTrust:(se,me,Ae)=>$e.onDidGrantWorkspaceTrust(se,me,Ae)},Li={get inputBox(){return Ze.report("scm.inputBox",xe,"Use 'SourceControl.inputBox' instead"),Jt.getLastInputBox(xe)},createSourceControl(se,me,Ae){return Jt.createSourceControl(xe,se,me,Ae)}},Fi={createCommentController(se,me){return li.createCommentController(xe,se,me)}},Mi={get activeDebugSession(){return St.activeDebugSession},get activeDebugConsole(){return St.activeDebugConsole},get breakpoints(){return St.breakpoints},onDidStartDebugSession(se,me,Ae){return St.onDidStartDebugSession(se,me,Ae)},onDidTerminateDebugSession(se,me,Ae){return St.onDidTerminateDebugSession(se,me,Ae)},onDidChangeActiveDebugSession(se,me,Ae){return St.onDidChangeActiveDebugSession(se,me,Ae)},onDidReceiveDebugSessionCustomEvent(se,me,Ae){return St.onDidReceiveDebugSessionCustomEvent(se,me,Ae)},onDidChangeBreakpoints(se,me,Ae){return St.onDidChangeBreakpoints(se,me,Ae)},registerDebugConfigurationProvider(se,me,Ae){return St.registerDebugConfigurationProvider(se,me,Ae||U.DebugConfigurationProviderTriggerKind.Initial)},registerDebugAdapterDescriptorFactory(se,me){return St.registerDebugAdapterDescriptorFactory(xe,se,me)},registerDebugAdapterTrackerFactory(se,me){return St.registerDebugAdapterTrackerFactory(se,me)},startDebugging(se,me,Ae){return!Ae||typeof Ae=="object"&&"configuration"in Ae?St.startDebugging(se,me,{parentSession:Ae}):St.startDebugging(se,me,Ae||{})},stopDebugging(se){return St.stopDebugging(se)},addBreakpoints(se){return St.addBreakpoints(se)},removeBreakpoints(se){return St.removeBreakpoints(se)},asDebugSourceUri(se,me){return St.asDebugSourceUri(se,me)}},Oi={registerTaskProvider:(se,me)=>It.registerTaskProvider(xe,se,me),fetchTasks:se=>It.fetchTasks(se),executeTask:se=>It.executeTask(xe,se),get taskExecutions(){return It.taskExecutions},onDidStartTask:(se,me,Ae)=>It.onDidStartTask(se,me,Ae),onDidEndTask:(se,me,Ae)=>It.onDidEndTask(se,me,Ae),onDidStartTaskProcess:(se,me,Ae)=>It.onDidStartTaskProcess(se,me,Ae),onDidEndTaskProcess:(se,me,Ae)=>It.onDidEndTaskProcess(se,me,Ae)},Ni={createNotebookController(se,me,Ae,ut,Ct){return si.createNotebookController(xe,se,me,Ae,ut,(0,Se.isProposedApiEnabled)(xe,"notebookMessaging")?Ct:void 0)},registerNotebookCellStatusBarItemProvider:(se,me)=>Et.registerNotebookCellStatusBarItemProvider(xe,se,me),get onDidSaveNotebookDocument(){return(0,Se.checkProposedApiEnabled)(xe,"notebookEditor"),Wt.onDidSaveNotebookDocument},createNotebookEditorDecorationType(se){return(0,Se.checkProposedApiEnabled)(xe,"notebookEditorDecorationType"),jt.createNotebookEditorDecorationType(se)},createRendererMessaging(se){return oi.createRendererMessaging(xe,se)},onDidChangeNotebookDocumentMetadata(se,me,Ae){return(0,Se.checkProposedApiEnabled)(xe,"notebookEditor"),Wt.onDidChangeNotebookDocumentMetadata(se,me,Ae)},onDidChangeNotebookCells(se,me,Ae){return(0,Se.checkProposedApiEnabled)(xe,"notebookEditor"),Et.onDidChangeNotebookCells(se,me,Ae)},onDidChangeNotebookCellExecutionState(se,me,Ae){return(0,Se.checkProposedApiEnabled)(xe,"notebookCellExecutionState"),Et.onDidChangeNotebookCellExecutionState(se,me,Ae)},onDidChangeCellOutputs(se,me,Ae){return(0,Se.checkProposedApiEnabled)(xe,"notebookEditor"),Et.onDidChangeCellOutputs(se,me,Ae)},onDidChangeCellMetadata(se,me,Ae){return(0,Se.checkProposedApiEnabled)(xe,"notebookEditor"),Et.onDidChangeCellMetadata(se,me,Ae)},createConcatTextDocument(se,me){return(0,Se.checkProposedApiEnabled)(xe,"notebookConcatTextDocument"),new Ve.ExtHostNotebookConcatDocument(Et,_t,se,me)}};return{version:we.version,authentication:ii,commands:Ii,comments:Fi,debug:Mi,env:vi,extensions:Ti,languages:Ai,notebooks:Ni,scm:Li,tasks:Oi,tests:Pi,window:Ri,workspace:ni,Breakpoint:U.Breakpoint,CallHierarchyIncomingCall:U.CallHierarchyIncomingCall,CallHierarchyItem:U.CallHierarchyItem,CallHierarchyOutgoingCall:U.CallHierarchyOutgoingCall,CancellationError:L.CancellationError,CancellationTokenSource:m.CancellationTokenSource,CandidatePortSource:u.CandidatePortSource,CodeAction:U.CodeAction,CodeActionKind:U.CodeActionKind,CodeActionTriggerKind:U.CodeActionTriggerKind,CodeLens:U.CodeLens,Color:U.Color,ColorInformation:U.ColorInformation,ColorPresentation:U.ColorPresentation,ColorThemeKind:U.ColorThemeKind,CommentMode:U.CommentMode,CommentThreadCollapsibleState:U.CommentThreadCollapsibleState,CompletionItem:U.CompletionItem,CompletionItemKind:U.CompletionItemKind,CompletionItemTag:U.CompletionItemTag,CompletionList:U.CompletionList,CompletionTriggerKind:U.CompletionTriggerKind,ConfigurationTarget:U.ConfigurationTarget,CustomExecution:U.CustomExecution,DebugAdapterExecutable:U.DebugAdapterExecutable,DebugAdapterInlineImplementation:U.DebugAdapterInlineImplementation,DebugAdapterNamedPipeServer:U.DebugAdapterNamedPipeServer,DebugAdapterServer:U.DebugAdapterServer,DebugConfigurationProviderTriggerKind:U.DebugConfigurationProviderTriggerKind,DebugConsoleMode:U.DebugConsoleMode,DecorationRangeBehavior:U.DecorationRangeBehavior,Diagnostic:U.Diagnostic,DiagnosticRelatedInformation:U.DiagnosticRelatedInformation,DiagnosticSeverity:U.DiagnosticSeverity,DiagnosticTag:U.DiagnosticTag,Disposable:U.Disposable,DocumentHighlight:U.DocumentHighlight,DocumentHighlightKind:U.DocumentHighlightKind,DocumentLink:U.DocumentLink,DocumentSymbol:U.DocumentSymbol,EndOfLine:U.EndOfLine,EnvironmentVariableMutatorType:U.EnvironmentVariableMutatorType,EvaluatableExpression:U.EvaluatableExpression,InlineValueText:U.InlineValueText,InlineValueVariableLookup:U.InlineValueVariableLookup,InlineValueEvaluatableExpression:U.InlineValueEvaluatableExpression,InlineCompletionTriggerKind:U.InlineCompletionTriggerKind,EventEmitter:y.Emitter,ExtensionKind:U.ExtensionKind,ExtensionMode:U.ExtensionMode,ExternalUriOpenerPriority:U.ExternalUriOpenerPriority,FileChangeType:U.FileChangeType,FileDecoration:U.FileDecoration,FileSystemError:U.FileSystemError,FileType:P.FileType,FilePermission:P.FilePermission,FoldingRange:U.FoldingRange,FoldingRangeKind:U.FoldingRangeKind,FunctionBreakpoint:U.FunctionBreakpoint,InlineCompletionItem:U.InlineSuggestion,InlineCompletionList:U.InlineSuggestions,Hover:U.Hover,IndentAction:D.IndentAction,Location:U.Location,MarkdownString:U.MarkdownString,OverviewRulerLane:S.OverviewRulerLane,ParameterInformation:U.ParameterInformation,PortAutoForwardAction:U.PortAutoForwardAction,Position:U.Position,ProcessExecution:U.ProcessExecution,ProgressLocation:U.ProgressLocation,QuickInputButtons:U.QuickInputButtons,Range:U.Range,RelativePattern:U.RelativePattern,Selection:U.Selection,SelectionRange:U.SelectionRange,SemanticTokens:U.SemanticTokens,SemanticTokensBuilder:U.SemanticTokensBuilder,SemanticTokensEdit:U.SemanticTokensEdit,SemanticTokensEdits:U.SemanticTokensEdits,SemanticTokensLegend:U.SemanticTokensLegend,ShellExecution:U.ShellExecution,ShellQuoting:U.ShellQuoting,SignatureHelp:U.SignatureHelp,SignatureHelpTriggerKind:U.SignatureHelpTriggerKind,SignatureInformation:U.SignatureInformation,SnippetString:U.SnippetString,SourceBreakpoint:U.SourceBreakpoint,StandardTokenType:U.StandardTokenType,StatusBarAlignment:U.StatusBarAlignment,SymbolInformation:U.SymbolInformation,SymbolKind:U.SymbolKind,SymbolTag:U.SymbolTag,Task:U.Task,TaskGroup:U.TaskGroup,TaskPanelKind:U.TaskPanelKind,TaskRevealKind:U.TaskRevealKind,TaskScope:U.TaskScope,TerminalLink:U.TerminalLink,TerminalLocation:U.TerminalLocation,TerminalProfile:U.TerminalProfile,TextDocumentSaveReason:U.TextDocumentSaveReason,TextEdit:U.TextEdit,TextEditorCursorStyle:k.TextEditorCursorStyle,TextEditorLineNumbersStyle:U.TextEditorLineNumbersStyle,TextEditorRevealType:U.TextEditorRevealType,TextEditorSelectionChangeKind:U.TextEditorSelectionChangeKind,TextDocumentChangeReason:U.TextDocumentChangeReason,ThemeColor:U.ThemeColor,ThemeIcon:U.ThemeIcon,TreeItem:U.TreeItem,TreeItemCollapsibleState:U.TreeItemCollapsibleState,TypeHierarchyItem:U.TypeHierarchyItem,UIKind:u.UIKind,Uri:i.URI,ViewColumn:U.ViewColumn,WorkspaceEdit:U.WorkspaceEdit,InlayHint:U.InlayHint,InlayHintKind:U.InlayHintKind,RemoteAuthorityResolverError:U.RemoteAuthorityResolverError,ResolvedAuthority:U.ResolvedAuthority,SourceControlInputBoxValidationType:U.SourceControlInputBoxValidationType,ExtensionRuntime:U.ExtensionRuntime,TimelineItem:U.TimelineItem,NotebookRange:U.NotebookRange,NotebookCellKind:U.NotebookCellKind,NotebookCellExecutionState:U.NotebookCellExecutionState,NotebookCellData:U.NotebookCellData,NotebookData:U.NotebookData,NotebookRendererScript:U.NotebookRendererScript,NotebookCellStatusBarAlignment:U.NotebookCellStatusBarAlignment,NotebookEditorRevealType:U.NotebookEditorRevealType,NotebookCellOutput:U.NotebookCellOutput,NotebookCellOutputItem:U.NotebookCellOutputItem,NotebookCellStatusBarItem:U.NotebookCellStatusBarItem,NotebookControllerAffinity:U.NotebookControllerAffinity,PortAttributes:U.PortAttributes,LinkedEditingRanges:U.LinkedEditingRanges,TestResultState:U.TestResultState,TestRunRequest:U.TestRunRequest,TestMessage:U.TestMessage,TestTag:U.TestTag,TestRunProfileKind:U.TestRunProfileKind,TextSearchCompleteMessageType:ge.TextSearchCompleteMessageType,TreeDataTransfer:U.TreeDataTransfer,TreeDataTransferItem:U.TreeDataTransferItem,CoveredCount:U.CoveredCount,FileCoverage:U.FileCoverage,StatementCoverage:U.StatementCoverage,BranchCoverage:U.BranchCoverage,FunctionCoverage:U.FunctionCoverage,WorkspaceTrustState:U.WorkspaceTrustState,LanguageStatusSeverity:U.LanguageStatusSeverity,QuickPickItemKind:U.QuickPickItemKind}}}e.createApiFactoryAndRegisterActors=le}),define(pe[274],ve([0,1,83,132,35,130,36,38,45,34,70,55,72,91,52,65,133,66,44,90,121,54,131,11,226]),function(Y,e,m,L,y,C,i,k,S,D,R,P,u,E,f,v,w,I,p,s,r,g,a,_,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),(0,m.registerSingleton)(_.ILoggerService,a.ExtHostLoggerService),(0,m.registerSingleton)(_.ILogService,n.ExtHostLogService),(0,m.registerSingleton)(v.IExtHostApiDeprecationService,v.ExtHostApiDeprecationService),(0,m.registerSingleton)(k.IExtHostCommands,k.ExtHostCommands),(0,m.registerSingleton)(i.IExtHostConfiguration,i.ExtHostConfiguration),(0,m.registerSingleton)(I.IExtHostConsumerFileSystem,I.ExtHostConsumerFileSystem),(0,m.registerSingleton)(P.IExtHostDebugService,P.WorkerExtHostDebugService),(0,m.registerSingleton)(C.IExtHostDecorations,C.ExtHostDecorations),(0,m.registerSingleton)(S.IExtHostDocumentsAndEditors,S.ExtHostDocumentsAndEditors),(0,m.registerSingleton)(p.IExtHostFileSystemInfo,p.ExtHostFileSystemInfo),(0,m.registerSingleton)(L.IExtHostOutputService,L.ExtHostOutputService),(0,m.registerSingleton)(u.IExtHostSearch,u.ExtHostSearch),(0,m.registerSingleton)(E.IExtHostStorage,E.ExtHostStorage),(0,m.registerSingleton)(R.IExtHostTask,R.WorkerExtHostTask),(0,m.registerSingleton)(D.IExtHostTerminalService,D.WorkerExtHostTerminalService),(0,m.registerSingleton)(f.IExtHostTunnelService,f.ExtHostTunnelService),(0,m.registerSingleton)(w.IExtHostWindow,w.ExtHostWindow),(0,m.registerSingleton)(y.IExtHostWorkspace,y.ExtHostWorkspace),(0,m.registerSingleton)(s.IExtHostSecretState,s.ExtHostSecretState),(0,m.registerSingleton)(r.IExtHostTelemetry,r.ExtHostTelemetry),(0,m.registerSingleton)(g.IExtHostEditorTabs,g.ExtHostEditorTabs)}),define(pe[92],ve([0,1,16,11,33,69]),function(Y,e,m,L,y,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.OutputChannel=e.createTextSearchResult=e.anchorGlob=void 0;function i(P){return P.startsWith("**")||P.startsWith("/")?P:`/${P}`}e.anchorGlob=i;function k(P,u,E,f){const v=(0,m.mapArrayOrNot)(E,S),w=new y.TextSearchMatch(u,v,f),I=w.preview.matches;return{ranges:(0,m.mapArrayOrNot)(v,D),uri:P,preview:{text:w.preview.text,matches:(0,m.mapArrayOrNot)(I,D)}}}e.createTextSearchResult=k;function S(P){return new y.SearchRange(P.start.line,P.start.character,P.end.line,P.end.character)}function D(P){return new C.Range(P.startLineNumber,P.startColumn,P.endLineNumber,P.endColumn)}let R=class{constructor(u,E){this.prefix=u,this.logService=E}appendLine(u){this.logService.debug(`${this.prefix}#search`,u)}};R=je([He(1,L.ILogService)],R),e.OutputChannel=R}),define(pe[275],ve([0,1,95,22]),function(Y,e,m,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SUPPORTED_ENCODINGS=e.detectEncodingFromBuffer=e.toCanonicalName=e.detectEncodingByBOMFromBuffer=e.toNodeEncoding=e.encodingExists=e.toEncodeReadable=e.toDecodeStream=e.UTF8_BOM=e.UTF16le_BOM=e.UTF16be_BOM=e.isUTFEncoding=e.UTF16le=e.UTF16be=e.UTF8_with_bom=e.UTF8=void 0,e.UTF8="utf8",e.UTF8_with_bom="utf8bom",e.UTF16be="utf16be",e.UTF16le="utf16le";function y(a){return[e.UTF8,e.UTF8_with_bom,e.UTF16be,e.UTF16le].some(_=>_===a)}e.isUTFEncoding=y,e.UTF16be_BOM=[254,255],e.UTF16le_BOM=[255,254],e.UTF8_BOM=[239,187,191];const C=512,i=512,k=512*8,S=512*128;class D{constructor(_){this.iconvLiteDecoder=_}static async create(_){let n;if(_!==e.UTF8)n=(await new Promise((o,d)=>{Y(["iconv-lite-umd"],o,d)})).getDecoder(E(_));else{const t=new TextDecoder;n={write(o){return t.decode(o,{stream:!0})},end(){return t.decode()}}}return new D(n)}write(_){return this.iconvLiteDecoder.write(_)}end(){return this.iconvLiteDecoder.end()}}function R(a,_){const n=_.minBytesRequiredForDetection??_.guessEncoding?k:i;return new Promise((t,o)=>{const d=(0,m.newWriteableStream)(T=>T.join("")),c=[];let h=0,l;const b=async()=>{try{const T=await g({buffer:L.VSBuffer.concat(c),bytesRead:h},_.guessEncoding);T.encoding=await _.overwriteEncoding(T.encoding),l=await D.create(T.encoding);const A=l.write(L.VSBuffer.concat(c).buffer);d.write(A),c.length=0,h=0,t({stream:d,detected:T})}catch(T){o(T)}};(0,m.listenStream)(a,{onData:async T=>{l?d.write(l.write(T.buffer)):(c.push(T),h+=T.byteLength,h>=n&&(a.pause(),await b(),setTimeout(()=>a.resume())))},onError:T=>d.error(T),onEnd:async()=>{l||await b(),d.end(l?.end())}})})}e.toDecodeStream=R;async function P(a,_,n){const o=(await new Promise((h,l)=>{Y(["iconv-lite-umd"],h,l)})).getEncoder(E(_),n);let d=!1,c=!1;return{read(){if(c)return null;const h=a.read();if(typeof h!="string"){if(c=!0,!d&&n?.addBOM)switch(_){case e.UTF8:case e.UTF8_with_bom:return L.VSBuffer.wrap(Uint8Array.from(e.UTF8_BOM));case e.UTF16be:return L.VSBuffer.wrap(Uint8Array.from(e.UTF16be_BOM));case e.UTF16le:return L.VSBuffer.wrap(Uint8Array.from(e.UTF16le_BOM))}const l=o.end();return l&&l.length>0?(d=!0,L.VSBuffer.wrap(l)):null}return d=!0,L.VSBuffer.wrap(o.write(h))}}}e.toEncodeReadable=P;async function u(a){return(await new Promise((n,t)=>{Y(["iconv-lite-umd"],n,t)})).encodingExists(E(a))}e.encodingExists=u;function E(a){return a===e.UTF8_with_bom||a===null?e.UTF8:a}e.toNodeEncoding=E;function f(a,_){if(!a||_<e.UTF16be_BOM.length)return null;const n=a.readUInt8(0),t=a.readUInt8(1);if(n===e.UTF16be_BOM[0]&&t===e.UTF16be_BOM[1])return e.UTF16be;if(n===e.UTF16le_BOM[0]&&t===e.UTF16le_BOM[1])return e.UTF16le;if(_<e.UTF8_BOM.length)return null;const o=a.readUInt8(2);return n===e.UTF8_BOM[0]&&t===e.UTF8_BOM[1]&&o===e.UTF8_BOM[2]?e.UTF8_with_bom:null}e.detectEncodingByBOMFromBuffer=f;const v=["ascii","utf-16","utf-32"];async function w(a){const _=await new Promise((c,h)=>{Y(["jschardet"],c,h)}),n=a.slice(0,S),t=s(n.buffer),o=_.detect(t);if(!o||!o.encoding)return null;const d=o.encoding.toLowerCase();return 0<=v.indexOf(d)?null:p(o.encoding)}const I={ibm866:"cp866",big5:"cp950"};function p(a){const _=a.replace(/[^a-zA-Z0-9]/g,"").toLowerCase();return I[_]||_}function s(a){let _="";for(let n=0;n<a.length;n++)_+=String.fromCharCode(a[n]);return _}function r(a){switch(a){case"shiftjis":return"shift-jis";case"utf16le":return"utf-16le";case"utf16be":return"utf-16be";case"big5hkscs":return"big5-hkscs";case"eucjp":return"euc-jp";case"euckr":return"euc-kr";case"koi8r":return"koi8-r";case"koi8u":return"koi8-u";case"macroman":return"x-mac-roman";case"utf8bom":return"utf8";default:const _=a.match(/windows(\d+)/);return _?"windows-"+_[1]:a}}e.toCanonicalName=r;function g({buffer:a,bytesRead:_},n){let t=f(a,_),o=!1;if(t!==e.UTF16be&&t!==e.UTF16le&&a){let d=!0,c=!0,h=!1;for(let l=0;l<_&&l<C;l++){const b=l%2==1,T=a.readUInt8(l)===0;if(T&&(h=!0),d&&(b&&!T||!b&&T)&&(d=!1),c&&(b&&T||!b&&!T)&&(c=!1),T&&!d&&!c)break}h&&(d?t=e.UTF16le:c?t=e.UTF16be:o=!0)}return n&&!o&&!t&&a?w(a.slice(0,_)).then(d=>({seemsBinary:!1,encoding:d})):{seemsBinary:o,encoding:t}}e.detectEncodingFromBuffer=g,e.SUPPORTED_ENCODINGS={utf8:{labelLong:"UTF-8",labelShort:"UTF-8",order:1,alias:"utf8bom"},utf8bom:{labelLong:"UTF-8 with BOM",labelShort:"UTF-8 with BOM",encodeOnly:!0,order:2,alias:"utf8"},utf16le:{labelLong:"UTF-16 LE",labelShort:"UTF-16 LE",order:3},utf16be:{labelLong:"UTF-16 BE",labelShort:"UTF-16 BE",order:4},windows1252:{labelLong:"Western (Windows 1252)",labelShort:"Windows 1252",order:5},iso88591:{labelLong:"Western (ISO 8859-1)",labelShort:"ISO 8859-1",order:6},iso88593:{labelLong:"Western (ISO 8859-3)",labelShort:"ISO 8859-3",order:7},iso885915:{labelLong:"Western (ISO 8859-15)",labelShort:"ISO 8859-15",order:8},macroman:{labelLong:"Western (Mac Roman)",labelShort:"Mac Roman",order:9},cp437:{labelLong:"DOS (CP 437)",labelShort:"CP437",order:10},windows1256:{labelLong:"Arabic (Windows 1256)",labelShort:"Windows 1256",order:11},iso88596:{labelLong:"Arabic (ISO 8859-6)",labelShort:"ISO 8859-6",order:12},windows1257:{labelLong:"Baltic (Windows 1257)",labelShort:"Windows 1257",order:13},iso88594:{labelLong:"Baltic (ISO 8859-4)",labelShort:"ISO 8859-4",order:14},iso885914:{labelLong:"Celtic (ISO 8859-14)",labelShort:"ISO 8859-14",order:15},windows1250:{labelLong:"Central European (Windows 1250)",labelShort:"Windows 1250",order:16},iso88592:{labelLong:"Central European (ISO 8859-2)",labelShort:"ISO 8859-2",order:17},cp852:{labelLong:"Central European (CP 852)",labelShort:"CP 852",order:18},windows1251:{labelLong:"Cyrillic (Windows 1251)",labelShort:"Windows 1251",order:19},cp866:{labelLong:"Cyrillic (CP 866)",labelShort:"CP 866",order:20},iso88595:{labelLong:"Cyrillic (ISO 8859-5)",labelShort:"ISO 8859-5",order:21},koi8r:{labelLong:"Cyrillic (KOI8-R)",labelShort:"KOI8-R",order:22},koi8u:{labelLong:"Cyrillic (KOI8-U)",labelShort:"KOI8-U",order:23},iso885913:{labelLong:"Estonian (ISO 8859-13)",labelShort:"ISO 8859-13",order:24},windows1253:{labelLong:"Greek (Windows 1253)",labelShort:"Windows 1253",order:25},iso88597:{labelLong:"Greek (ISO 8859-7)",labelShort:"ISO 8859-7",order:26},windows1255:{labelLong:"Hebrew (Windows 1255)",labelShort:"Windows 1255",order:27},iso88598:{labelLong:"Hebrew (ISO 8859-8)",labelShort:"ISO 8859-8",order:28},iso885910:{labelLong:"Nordic (ISO 8859-10)",labelShort:"ISO 8859-10",order:29},iso885916:{labelLong:"Romanian (ISO 8859-16)",labelShort:"ISO 8859-16",order:30},windows1254:{labelLong:"Turkish (Windows 1254)",labelShort:"Windows 1254",order:31},iso88599:{labelLong:"Turkish (ISO 8859-9)",labelShort:"ISO 8859-9",order:32},windows1258:{labelLong:"Vietnamese (Windows 1258)",labelShort:"Windows 1258",order:33},gbk:{labelLong:"Simplified Chinese (GBK)",labelShort:"GBK",order:34},gb18030:{labelLong:"Simplified Chinese (GB18030)",labelShort:"GB18030",order:35},cp950:{labelLong:"Traditional Chinese (Big5)",labelShort:"Big5",order:36},big5hkscs:{labelLong:"Traditional Chinese (Big5-HKSCS)",labelShort:"Big5-HKSCS",order:37},shiftjis:{labelLong:"Japanese (Shift JIS)",labelShort:"Shift JIS",order:38},eucjp:{labelLong:"Japanese (EUC-JP)",labelShort:"EUC-JP",order:39},euckr:{labelLong:"Korean (EUC-KR)",labelShort:"EUC-KR",order:40},windows874:{labelLong:"Thai (Windows 874)",labelShort:"Windows 874",order:41},iso885911:{labelLong:"Latin/Thai (ISO 8859-11)",labelShort:"ISO 8859-11",order:42},koi8ru:{labelLong:"Cyrillic (KOI8-RU)",labelShort:"KOI8-RU",order:43},koi8t:{labelLong:"Tajik (KOI8-T)",labelShort:"KOI8-T",order:44},gb2312:{labelLong:"Simplified Chinese (GB 2312)",labelShort:"GB 2312",order:45},cp865:{labelLong:"Nordic DOS (CP 865)",labelShort:"CP 865",order:46},cp850:{labelLong:"Western European DOS (CP 850)",labelShort:"CP 850",order:47}}}),define(pe[135],ve([0,1,275,28,134]),function(Y,e,m,L,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeTextSearchManager=void 0;class C extends y.TextSearchManager{constructor(k,S,D=L,R="searchProcess"){super(k,S,{readdir:P=>D.Promises.readdir(P.fsPath),toCanonicalName:P=>(0,m.toCanonicalName)(P)},R)}}e.NativeTextSearchManager=C}),define(pe[276],ve([0,1,277,291,292,2,293]),function(Y,e,m,L,y,C,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.connectProxyResolver=void 0;function k(P,u,E,f,v,w){const I=w.environment.useHostProxy,p=typeof I=="boolean"?I:!w.remote.isRemote,s=(0,i.createProxyResolver)({resolveProxy:g=>P.resolveProxy(g),getHttpProxySetting:()=>u.getConfiguration("http").get("proxy"),log:(g,a,..._)=>{switch(g){case i.LogLevel.Trace:f.trace(a,..._);break;case i.LogLevel.Debug:f.debug(a,..._);break;case i.LogLevel.Info:f.info(a,..._);break;case i.LogLevel.Warning:f.warn(a,..._);break;case i.LogLevel.Error:f.error(a,..._);break;case i.LogLevel.Critical:f.critical(a,..._);break;case i.LogLevel.Off:break;default:n(g,a,_);break}function n(t,o,...d){f.error("Unknown log level",t),f.error(o,...d)}},getLogLevel:()=>f.getLevel(),proxyResolveTelemetry:g=>{v.$publicLog2("resolveProxy",g)},useHostProxy:p,env:process.env}),r=S(u,s);return R(E,r)}e.connectProxyResolver=k;function S(P,u){const E={config:P.getConfiguration("http").get("proxySupport")||"off"};P.onDidChangeConfiguration(v=>{E.config=P.getConfiguration("http").get("proxySupport")||"off"});const f={config:!!P.getConfiguration("http").get("systemCertificates")};return P.onDidChangeConfiguration(v=>{f.config=!!P.getConfiguration("http").get("systemCertificates")}),{http:{off:Object.assign({},m,(0,i.createHttpPatch)(m,u,{config:"off"},f,!0)),on:Object.assign({},m,(0,i.createHttpPatch)(m,u,{config:"on"},f,!0)),override:Object.assign({},m,(0,i.createHttpPatch)(m,u,{config:"override"},f,!0)),onRequest:Object.assign({},m,(0,i.createHttpPatch)(m,u,E,f,!0)),default:Object.assign(m,(0,i.createHttpPatch)(m,u,E,f,!1))},https:{off:Object.assign({},L,(0,i.createHttpPatch)(L,u,{config:"off"},f,!0)),on:Object.assign({},L,(0,i.createHttpPatch)(L,u,{config:"on"},f,!0)),override:Object.assign({},L,(0,i.createHttpPatch)(L,u,{config:"override"},f,!0)),onRequest:Object.assign({},L,(0,i.createHttpPatch)(L,u,E,f,!0)),default:Object.assign(L,(0,i.createHttpPatch)(L,u,E,f,!1))},tls:Object.assign(y,(0,i.createTlsPatch)(y))}}const D=new Map;function R(P,u){return P.getExtensionPathIndex().then(E=>{const f=Y.__$__nodeRequire("module"),v=f._load;f._load=function(I,p,s){if(I==="tls")return u.tls;if(I!=="http"&&I!=="https")return v.apply(this,arguments);const r=u[I],g=E.findSubstr(C.URI.file(p.filename));let a=D.get(g);if(a||D.set(g,a={}),!a[I]){let _=r.default;a[I]={..._}}return a[I]}})}}),define(pe[278],ve([0,1,37,9,79,30,12,8,92,279]),function(Y,e,m,L,y,C,i,k,S,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.fixDriveC=e.getAbsoluteGlob=e.foldersToIncludeGlobs=e.foldersToRgExcludeGlobs=e.spawnRipgrepCmd=void 0;const R=D.rgPath.replace(/\bnode_modules\.asar\b/,"node_modules.asar.unpacked");function P(s,r,g,a){const _=u(s,r,g,a),n=r.folder.fsPath;return{cmd:m.spawn(R,_.args,{cwd:n}),rgDiskPath:R,siblingClauses:_.siblingClauses,rgArgs:_,cwd:n}}e.spawnRipgrepCmd=P;function u(s,r,g,a){const _=["--files","--hidden","--case-sensitive"];f([r],g,!1).forEach(t=>{const o=(0,S.anchorGlob)(t);if(_.push("-g",o),i.isMacintosh){const d=(0,y.normalizeNFD)(o);d!==o&&_.push("-g",d)}});const n=E([r],a,void 0,!1);return n.globArgs.forEach(t=>{const o=`!${(0,S.anchorGlob)(t)}`;if(_.push("-g",o),i.isMacintosh){const d=(0,y.normalizeNFD)(o);d!==o&&_.push("-g",d)}}),r.disregardIgnoreFiles!==!1?_.push("--no-ignore"):_.push("--no-ignore-parent"),r.ignoreSymlinks||_.push("--follow"),s.exists&&_.push("--quiet"),_.push("--no-config"),r.disregardGlobalIgnoreFiles&&_.push("--no-ignore-global"),{args:_,siblingClauses:n.siblingClauses}}function E(s,r,g,a=!0){const _=[];let n={};return s.forEach(t=>{const o=Object.assign({},t.excludePattern||{},r||{}),d=v(o,a?t.folder.fsPath:void 0,g);_.push(...d.globArgs),d.siblingClauses&&(n=Object.assign(n,d.siblingClauses))}),{globArgs:_,siblingClauses:n}}e.foldersToRgExcludeGlobs=E;function f(s,r,g=!0){const a=[];return s.forEach(_=>{const n=Object.assign({},r||{},_.includePattern||{}),t=v(n,g?_.folder.fsPath:void 0);a.push(...t.globArgs)}),a}e.foldersToIncludeGlobs=f;function v(s,r,g){const a=[],_={};return Object.keys(s).forEach(n=>{if(g&&g.has(n)||!n)return;const t=s[n];n=I(r?w(r,n):n),n.startsWith("\\\\")?n="\\\\"+n.substr(2).replace(/\\/g,"/"):n=n.replace(/\\/g,"/"),typeof t=="boolean"&&t?(n.startsWith("\\\\")&&(n+="**"),a.push(p(n))):t&&t.when&&(_[n]=t)}),{globArgs:a,siblingClauses:_}}function w(s,r){return L.isAbsolute(r)?r:L.join(s,r)}e.getAbsoluteGlob=w;function I(s){return s=k.rtrim(s,"\\"),k.rtrim(s,"/")}function p(s){return C.getRoot(s).toLowerCase()==="c:/"?s.replace(/^c:[/\\]/i,"/"):s}e.fixDriveC=p}),define(pe[280],ve([0,1,37,60,9,103,16,50,31,79,30,12,46,8,13,28,33,278,100]),function(Y,e,m,L,y,C,i,k,S,D,R,P,u,E,f,v,w,I,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.rgErrorMsgForDisplay=e.Engine=e.FileWalker=void 0;const s=new Set;process.on("exit",()=>{s.forEach(n=>n())});class r{constructor(t){this.normalizedFilePatternLowercase=null,this.maxFilesize=null,this.isCanceled=!1,this.fileWalkSW=null,this.cmdSW=null,this.cmdResultCount=0,this.config=t,this.filePattern=t.filePattern||"",this.includePattern=t.includePattern&&S.parse(t.includePattern),this.maxResults=t.maxResults||null,this.exists=!!t.exists,this.walkedPaths=Object.create(null),this.resultCount=0,this.isLimitHit=!1,this.directoriesWalked=0,this.filesWalked=0,this.errors=[],this.filePattern&&(this.normalizedFilePatternLowercase=(0,p.prepareQuery)(this.filePattern).normalizedLowercase),this.globalExcludePattern=t.excludePattern&&S.parse(t.excludePattern),this.folderExcludePatterns=new Map,t.folderQueries.forEach(o=>{const d=Object.assign({},o.excludePattern||{},this.config.excludePattern||{}),c=o.folder.fsPath;t.folderQueries.map(h=>h.folder.fsPath).filter(h=>h!==c).forEach(h=>{(0,R.isEqualOrParent)(h,c)&&(d[y.relative(c,h)]=!0)}),this.folderExcludePatterns.set(c,new a(d,c))})}cancel(){this.isCanceled=!0,s.forEach(t=>t())}walk(t,o,d,c,h){if(this.fileWalkSW=u.StopWatch.create(!1),this.isCanceled)return h(null,this.isLimitHit);o.forEach(l=>{const b=y.basename(l.fsPath);this.globalExcludePattern&&this.globalExcludePattern(l.fsPath,b)||this.matchFile(d,{relativePath:l.fsPath,searchPath:void 0})}),this.cmdSW=u.StopWatch.create(!1),this.parallel(t,(l,b)=>{this.call(this.cmdTraversal,this,l,d,c,T=>{if(T){const A=(0,k.toErrorMessage)(T);console.error(A),this.errors.push(A),b(T,void 0)}else b(null,void 0)})},(l,b)=>{this.fileWalkSW.stop();const T=l?i.coalesce(l)[0]:null;h(T,this.isLimitHit)})}parallel(t,o,d){const c=new Array(t.length),h=new Array(t.length);let l=!1,b=0;if(t.length===0)return d(null,[]);t.forEach((T,A)=>{o(T,(x,O)=>{if(x?(l=!0,c[A]=null,h[A]=x):(c[A]=O,h[A]=null),++b===t.length)return d(l?h:null,c)})})}call(t,o,...d){try{t.apply(o,d)}catch(c){d[d.length-1](c)}}cmdTraversal(t,o,d,c){const h=t.folder.fsPath,l=P.isMacintosh;let b;const T=()=>b&&b.kill();s.add(T);let A=U=>{s.delete(T),A=()=>{},c(U)},x="";const O=this.initDirectoryTree();let F;const W=(0,I.spawnRipgrepCmd)(this.config,t,this.config.includePattern,this.folderExcludePatterns.get(t.folder.fsPath).expression);b=W.cmd,F=!Object.keys(W.siblingClauses).length;const M=W.rgArgs.args.map(U=>U.match(/^-/)?U:`'${U}'`).join(" ");let B=`${W.rgDiskPath} ${M}
 - cwd: ${W.cwd}`;W.rgArgs.siblingClauses&&(B+=`
 - Sibling clauses: ${JSON.stringify(W.rgArgs.siblingClauses)}`),d({message:B}),this.cmdResultCount=0,this.collectStdout(b,"utf8",d,(U,z,K)=>{if(U){A(U);return}if(this.isLimitHit){A();return}const j=(x+(l?D.normalizeNFC(z||""):z)).split(`
`);if(K){const H=j.length;j[H-1]=j[H-1].trim(),j[H-1]||j.pop()}else x=j.pop()||"";if(j.length&&j[0].indexOf(`
`)!==-1){A(new Error("Splitting up files failed"));return}if(this.cmdResultCount+=j.length,F){for(const H of j)if(this.matchFile(o,{base:h,relativePath:H,searchPath:this.getSearchPath(t,H)}),this.isLimitHit){T();break}(K||this.isLimitHit)&&A();return}this.addDirectoryEntries(t,O,h,j,o),K&&(this.matchDirectoryTree(O,h,o),A())})}spawnFindCmd(t){const o=this.folderExcludePatterns.get(t.folder.fsPath),d=o.getBasenameTerms(),c=o.getPathTerms(),h=["-L","."];if(d.length||c.length){h.push("-not","(","(");for(const l of d)h.push("-name",l),h.push("-o");for(const l of c)h.push("-path",l),h.push("-o");h.pop(),h.push(")","-prune",")")}return h.push("-type","f"),m.spawn("find",h,{cwd:t.folder.fsPath})}readStdout(t,o,d){let c="";this.collectStdout(t,o,()=>{},(h,l,b)=>{if(h){d(h);return}c+=l,b&&d(null,c)})}collectStdout(t,o,d,c){let h=(T,A,x)=>{(T||x)&&(h=()=>{},this.cmdSW&&this.cmdSW.stop()),c(T,A,x)},l=!1;t.stdout?(this.forwardData(t.stdout,o,h),t.stdout.once("data",()=>l=!0)):d({message:"stdout is null"});let b;t.stderr?b=this.collectData(t.stderr):d({message:"stderr is null"}),t.on("error",T=>{h(T)}),t.on("close",T=>{let A;!l&&(A=this.decodeData(b,o))&&_(A)?h(new Error(`command failed with error code ${T}: ${this.decodeData(b,o)}`)):(this.exists&&T===0&&(this.isLimitHit=!0),h(null,"",!0))})}forwardData(t,o,d){const c=new C.StringDecoder(o);return t.on("data",h=>{d(null,c.write(h))}),c}collectData(t){const o=[];return t.on("data",d=>{o.push(d)}),o}decodeData(t,o){const d=new C.StringDecoder(o);return t.map(c=>d.write(c)).join("")}initDirectoryTree(){const t={rootEntries:[],pathToEntries:Object.create(null)};return t.pathToEntries["."]=t.rootEntries,t}addDirectoryEntries(t,{pathToEntries:o},d,c,h){c.indexOf(this.filePattern)!==-1&&this.matchFile(h,{base:d,relativePath:this.filePattern,searchPath:this.getSearchPath(t,this.filePattern)});const l=b=>{const T=y.basename(b),A=y.dirname(b);let x=o[A];x||(x=o[A]=[],l(A)),x.push({base:d,relativePath:b,basename:T,searchPath:this.getSearchPath(t,b)})};c.forEach(l)}matchDirectoryTree({rootEntries:t,pathToEntries:o},d,c){const h=this,l=this.folderExcludePatterns.get(d),b=this.filePattern;function T(A){h.directoriesWalked++;const x=S.hasSiblingFn(()=>A.map(O=>O.basename));for(let O=0,F=A.length;O<F;O++){const W=A[O],{relativePath:M,basename:B}=W;if(l.test(M,B,b!==B?x:void 0))continue;const U=o[M];if(U)T(U);else{if(h.filesWalked++,M===b)continue;h.matchFile(c,W)}if(h.isLimitHit)break}}T(t)}getStats(){return{cmdTime:this.cmdSW.elapsed(),fileWalkTime:this.fileWalkSW.elapsed(),directoriesWalked:this.directoriesWalked,filesWalked:this.filesWalked,cmdResultCount:this.cmdResultCount}}doWalk(t,o,d,c,h){const l=t.folder,b=S.hasSiblingFn(()=>d);this.parallel(d,(T,A)=>{if(this.isCanceled||this.isLimitHit)return A(null);const x=o?[o,T].join(y.sep):T;if(this.folderExcludePatterns.get(t.folder.fsPath).test(x,T,this.config.filePattern!==T?b:void 0))return A(null);const O=[l.fsPath,x].join(y.sep);L.lstat(O,(F,W)=>{if(F||this.isCanceled||this.isLimitHit)return A(null);this.statLinkIfNeeded(O,W,(M,B)=>M||this.isCanceled||this.isLimitHit?A(null):B.isDirectory()?(this.directoriesWalked++,this.realPathIfNeeded(O,W,(U,z)=>U||this.isCanceled||this.isLimitHit||(z=z||"",this.walkedPaths[z])?A(null):(this.walkedPaths[z]=!0,v.Promises.readdir(O).then(K=>{if(this.isCanceled||this.isLimitHit)return A(null);this.doWalk(t,x,K,c,N=>A(N||null))},K=>{A(null)})))):(this.filesWalked++,x===this.filePattern||this.maxFilesize&&f.isNumber(B.size)&&B.size>this.maxFilesize||this.matchFile(c,{base:l.fsPath,relativePath:x,searchPath:this.getSearchPath(t,x)}),A(null,void 0)))})},T=>{const A=T&&i.coalesce(T);return h(A&&A.length>0?A[0]:void 0)})}matchFile(t,o){this.isFileMatch(o)&&(!this.includePattern||this.includePattern(o.relativePath,y.basename(o.relativePath)))&&(this.resultCount++,(this.exists||this.maxResults&&this.resultCount>this.maxResults)&&(this.isLimitHit=!0),this.isLimitHit||t(o))}isFileMatch(t){if(this.filePattern){if(this.filePattern==="*")return!0;if(this.normalizedFilePatternLowercase)return(0,w.isFilePatternMatch)(t,this.normalizedFilePatternLowercase)}return!0}statLinkIfNeeded(t,o,d){return o.isSymbolicLink()?L.stat(t,d):d(null,o)}realPathIfNeeded(t,o,d){return o.isSymbolicLink()?L.realpath(t,(c,h)=>c?d(c):d(null,h)):d(null,t)}getSearchPath(t,o){return t.folderName?y.join(t.folderName,o):o}}e.FileWalker=r;class g{constructor(t){this.folderQueries=t.folderQueries,this.extraFiles=t.extraFileResources||[],this.walker=new r(t)}search(t,o,d){this.walker.walk(this.folderQueries,this.extraFiles,t,o,(c,h)=>{d(c,{limitHit:h,stats:this.walker.getStats(),messages:[]})})}cancel(){this.walker.cancel()}}e.Engine=g;class a{constructor(t,o){this.expression=t,this.root=o,this.init(t)}init(t){let o,d;Object.keys(t).filter(c=>t[c]).forEach(c=>{y.isAbsolute(c)?(o=o||S.getEmptyExpression(),o[c]=t[c]):(d=d||S.getEmptyExpression(),d[c]=t[c])}),this.absoluteParsedExpr=o&&S.parse(o,{trimForExclusions:!0}),this.relativeParsedExpr=d&&S.parse(d,{trimForExclusions:!0})}test(t,o,d){return this.relativeParsedExpr&&this.relativeParsedExpr(t,o,d)||this.absoluteParsedExpr&&this.absoluteParsedExpr(y.join(this.root,t),o,d)}getBasenameTerms(){const t=[];return this.absoluteParsedExpr&&t.push(...S.getBasenameTerms(this.absoluteParsedExpr)),this.relativeParsedExpr&&t.push(...S.getBasenameTerms(this.relativeParsedExpr)),t}getPathTerms(){const t=[];return this.absoluteParsedExpr&&t.push(...S.getPathTerms(this.absoluteParsedExpr)),this.relativeParsedExpr&&t.push(...S.getPathTerms(this.relativeParsedExpr)),t}}function _(n){const t=n.trim().split(`
`),o=t[0].trim();if(o.startsWith("Error parsing regex"))return o;if(o.startsWith("regex parse error"))return E.uppercaseFirstLetter(t[t.length-1].trim());if(o.startsWith("error parsing glob")||o.startsWith("unsupported encoding"))return o.charAt(0).toUpperCase()+o.substr(1);if(o==="Literal '\\n' not allowed.")return"Literal '\\n' currently not supported";if(o.startsWith("Literal "))return o}e.rgErrorMsgForDisplay=_}),define(pe[136],ve([0,1,37,294,103,16,73,31,9,8,2,33,69,295,279,92]),function(Y,e,m,L,y,C,i,k,S,D,R,P,u,E,f,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.fixNewline=e.fixRegexNewline=e.unicodeEscapesToPCRE2=e.spreadGlobComponents=e.RipgrepParser=e.buildRegexParseError=e.rgErrorMsgForDisplay=e.RipgrepTextSearchEngine=void 0;const w=f.rgPath.replace(/\bnode_modules\.asar\b/,"node_modules.asar.unpacked");class I{constructor(l){this.outputChannel=l}provideTextSearchResults(l,b,T,A){return this.outputChannel.appendLine(`provideTextSearchResults ${l.pattern}, ${JSON.stringify({...b,folder:b.folder.toString()})}`),new Promise((x,O)=>{A.onCancellationRequested(()=>N());const F=_(l,b),W=b.folder.fsPath,M=F.map(ne=>ne.match(/^-/)?ne:`'${ne}'`).join(" ");this.outputChannel.appendLine(`${w} ${M}
 - cwd: ${W}`);let B=m.spawn(w,F,{cwd:W});B.on("error",ne=>{console.error(ne),this.outputChannel.appendLine("Error: "+(ne&&ne.message)),O((0,P.serializeSearchError)(new P.SearchError(ne&&ne.message,P.SearchErrorCode.rgProcessError)))});let U=!1;const z=new r(b.maxResults,W,b.previewOptions);z.on("result",ne=>{U=!0,H="",T.report(ne)});let K=!1;const N=()=>{K=!0,B&&B.kill(),z&&z.cancel()};let j=!1;z.on("hitLimit",()=>{j=!0,N()});let H="";B.stdout.on("data",ne=>{z.handleData(ne),U||(H+=ne)});let V=!1;B.stdout.once("data",()=>V=!0);let q="";B.stderr.on("data",ne=>{const fe=ne.toString();this.outputChannel.appendLine(fe),q+=fe}),B.on("close",()=>{if(this.outputChannel.appendLine(V?"Got data from stdout":"No data from stdout"),this.outputChannel.appendLine(U?"Got result from parser":"No result from parser"),H&&this.outputChannel.appendLine(`Got data without result: ${H}`),this.outputChannel.appendLine(""),K)x({limitHit:j});else{z.flush(),B=null;let ne;q&&!V&&(ne=p(q))?O((0,P.serializeSearchError)(new P.SearchError(ne.message,ne.code))):x({limitHit:j})}})})}}e.RipgrepTextSearchEngine=I;function p(h){const l=h.split(`
`),b=l[0].trim();if(l.some(A=>A.startsWith("regex parse error")))return new P.SearchError(s(l),P.SearchErrorCode.regexParseError);const T=b.match(/grep config error: unknown encoding: (.*)/);if(T)return new P.SearchError(`Unknown encoding: ${T[1]}`,P.SearchErrorCode.unknownEncoding);if(b.startsWith("error parsing glob"))return new P.SearchError(b.charAt(0).toUpperCase()+b.substr(1),P.SearchErrorCode.globParseError);if(b.startsWith("the literal"))return new P.SearchError(b.charAt(0).toUpperCase()+b.substr(1),P.SearchErrorCode.invalidLiteral);if(b.startsWith("PCRE2: error compiling pattern"))return new P.SearchError(b,P.SearchErrorCode.regexParseError)}e.rgErrorMsgForDisplay=p;function s(h){const l=["Regex parse error"],b=h.filter(T=>T.startsWith("PCRE2:"));if(b.length>=1){const T=b[0].replace("PCRE2:","");if(T.indexOf(":")!==-1&&T.split(":").length>=2){const A=T.split(":")[1];l.push(":"+A)}}return l.join("")}e.buildRegexParseError=s;class r extends L.EventEmitter{constructor(l,b,T){super();this.maxResults=l,this.rootFolder=b,this.previewOptions=T,this.remainder="",this.isDone=!1,this.hitLimit=!1,this.numResults=0,this.stringDecoder=new y.StringDecoder}cancel(){this.isDone=!0}flush(){this.handleDecodedData(this.stringDecoder.end())}on(l,b){return super.on(l,b),this}handleData(l){if(this.isDone)return;const b=typeof l=="string"?l:this.stringDecoder.write(l);this.handleDecodedData(b)}handleDecodedData(l){let b=l.indexOf(`
`);const T=this.remainder+l;if(b>=0)b+=this.remainder.length;else{this.remainder=T;return}let A=0;for(;b>=0;)this.handleLine(T.substring(A,b).trim()),A=b+1,b=T.indexOf(`
`,A);this.remainder=T.substring(A)}handleLine(l){if(this.isDone||!l)return;let b;try{b=JSON.parse(l)}catch(T){throw new Error(`malformed line from rg: ${l}`)}if(b.type==="match"){const T=g(b.data.path),A=R.URI.file(S.join(this.rootFolder,T)),x=this.createTextSearchMatch(b.data,A);this.onResult(x),this.hitLimit&&(this.cancel(),this.emit("hitLimit"))}else if(b.type==="context"){const T=g(b.data.path),A=R.URI.file(S.join(this.rootFolder,T));this.createTextSearchContext(b.data,A).forEach(O=>this.onResult(O))}}createTextSearchMatch(l,b){const T=l.line_number-1,A=g(l.lines),x=Buffer.from(A);let O=0,F=0,W=T;l.submatches.length===0&&l.submatches.push(A.length?{start:0,end:1,match:{text:A[0]}}:{start:0,end:0,match:{text:""}});const M=(0,C.coalesce)(l.submatches.map((B,U)=>{if(this.hitLimit)return null;this.numResults++,this.numResults>=this.maxResults&&(this.hitLimit=!0);const z=g(B.match),K=x.slice(O,B.start).toString().length,N=F+K,j=a(z),H=W,V=j.numLines+H,q=j.numLines>0?j.lastLineLength:j.lastLineLength+N;return O=B.end,F=q,W=V,new u.Range(H,N,V,q)}));return(0,v.createTextSearchResult)(b,A,M,this.previewOptions)}createTextSearchContext(l,b){const T=g(l.lines),A=l.line_number;return T.replace(/\r?\n$/,"").split(`
`).map((x,O)=>({text:x,uri:b,lineNumber:A+O}))}onResult(l){this.emit("result",l)}}e.RipgrepParser=r;function g(h){return h.bytes?Buffer.from(h.bytes,"base64").toString():h.text}function a(h){const l=/\n/g;let b=0,T=-1,A;for(;A=l.exec(h);)b++,T=A.index;const x=T>=0?h.length-T-1:h.length;return{numLines:b,lastLineLength:x}}function _(h,l){const b=["--hidden"];b.push(h.isCaseSensitive?"--case-sensitive":"--ignore-case");const{doubleStarIncludes:T,otherIncludes:A}=(0,i.groupBy)(l.includes,O=>O.startsWith("**")?"doubleStarIncludes":"otherIncludes");if(A&&A.length){const O=new Set;A.forEach(F=>{O.add(F)}),b.push("-g","!*"),O.forEach(F=>{n(F).map(v.anchorGlob).forEach(W=>{b.push("-g",W)})})}T&&T.length&&T.forEach(O=>{b.push("-g",O)}),l.excludes.map(v.anchorGlob).forEach(O=>b.push("-g",`!${O}`)),l.maxFileSize&&b.push("--max-filesize",l.maxFileSize+""),l.useIgnoreFiles?b.push("--no-ignore-parent"):b.push("--no-ignore"),l.followSymlinks&&b.push("--follow"),l.encoding&&l.encoding!=="utf8"&&b.push("--encoding",l.encoding),h.pattern==="--"&&(h.isRegExp=!0,h.pattern="\\-\\-"),h.isMultiline&&!h.isRegExp&&(h.pattern=(0,D.escapeRegExpCharacters)(h.pattern),h.isRegExp=!0),l.usePCRE2&&b.push("--pcre2"),b.push("--crlf"),h.isRegExp&&(h.pattern=t(h.pattern),b.push("--auto-hybrid-regex"));let x;if(h.isWordMatch){const F=(0,D.createRegExp)(h.pattern,!!h.isRegExp,{wholeWord:h.isWordMatch}).source.replace(/\\\//g,"/");b.push("--regexp",F)}else if(h.isRegExp){let O=d(h.pattern);O=c(O),b.push("--regexp",O)}else x=h.pattern,b.push("--fixed-strings");return b.push("--no-config"),l.useGlobalIgnoreFiles||b.push("--no-ignore-global"),b.push("--json"),h.isMultiline&&b.push("--multiline"),l.beforeContext&&b.push("--before-context",l.beforeContext+""),l.afterContext&&b.push("--after-context",l.afterContext+""),b.push("--"),x&&b.push(x),b.push("."),b}function n(h){const l=(0,k.splitGlobAware)(h,"/");return l.map((b,T)=>l.slice(0,T+1).join("/"))}e.spreadGlobComponents=n;function t(h){const l=/((?:[^\\]|^)(?:\\\\)*)\\u([a-z0-9]{4})/gi;for(;h.match(l);)h=h.replace(l,"$1\\x{$2}");const b=/((?:[^\\]|^)(?:\\\\)*)\\u\{([a-z0-9]{4})\}/gi;for(;h.match(b);)h=h.replace(b,"$1\\x{$2}");return h}e.unicodeEscapesToPCRE2=t;const o=h=>h.type==="Assertion"&&h.kind==="lookbehind";function d(h){let l;try{l=new E.RegExpParser().parsePattern(h)}catch{return h}let b="",T=0;const A=(F,W,M)=>{b+=h.slice(T,F)+M,T=W},x=[];return new E.RegExpVisitor({onCharacterEnter(F){if(F.raw!=="\\n")return;const W=x[0];if(!W)A(F.start,F.end,"\\r?\\n");else if(!x.some(o))if(W.type==="CharacterClass")if(W.negate){const M=h.slice(W.start+2,F.start)+h.slice(F.end,W.end-1);if(W.parent?.type==="Quantifier"){const B=W.parent;A(B.start,B.end,(M?`[^${M}]`:".")+(B.greedy?"+":"*"))}else A(W.start,W.end,"(?!\\r?\\n"+(M?`|[${M}]`:"")+")")}else{const M=h.slice(W.start+1,F.start)+h.slice(F.end,W.end-1);A(W.start,W.end,M===""?"\\r?\\n":`(?:[${M}]|\\r?\\n)`)}else W.type==="Quantifier"&&A(F.start,F.end,"(?:\\r?\\n)")},onQuantifierEnter(F){x.unshift(F)},onQuantifierLeave(){x.shift()},onCharacterClassRangeEnter(F){x.unshift(F)},onCharacterClassRangeLeave(){x.shift()},onCharacterClassEnter(F){x.unshift(F)},onCharacterClassLeave(){x.shift()},onAssertionEnter(F){o(F)&&x.push(F)},onAssertionLeave(F){x[0]===F&&x.shift()}}).visit(l),b+=h.slice(T),b}e.fixRegexNewline=d;function c(h){return h.replace(/\n/g,"\\r?\\n")}e.fixNewline=c}),define(pe[281],ve([0,1,21,136,117,10]),function(Y,e,m,L,y,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RipgrepSearchProvider=void 0;class i{constructor(D){this.outputChannel=D,this.inProgress=new Set,process.once("exit",()=>this.dispose())}provideTextSearchResults(D,R,P,u){const E=new L.RipgrepTextSearchEngine(this.outputChannel);if(R.folder.scheme===C.Schemas.userData){const f={...R,folder:R.folder.with({scheme:C.Schemas.file})},v=new y.Progress(w=>P.report({...w,uri:w.uri.with({scheme:R.folder.scheme})}));return this.withToken(u,w=>E.provideTextSearchResults(D,f,v,w))}else return this.withToken(u,f=>E.provideTextSearchResults(D,R,P,f))}async withToken(D,R){const P=k(D);this.inProgress.add(P);const u=await R(P.token);return this.inProgress.delete(P),u}dispose(){this.inProgress.forEach(D=>D.cancel())}}e.RipgrepSearchProvider=i;function k(S){const D=new m.CancellationTokenSource;return S.onCancellationRequested(()=>D.cancel()),D}}),define(pe[282],ve([0,1,28,136,135]),function(Y,e,m,L,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TextSearchEngineAdapter=void 0;class C{constructor(S){this.query=S}search(S,D,R){if((!this.query.folderQueries||!this.query.folderQueries.length)&&(!this.query.extraFileResources||!this.query.extraFileResources.length))return Promise.resolve({type:"success",limitHit:!1,stats:{type:"searchProcess"}});const P={appendLine(E){R({message:E})}},u=new y.NativeTextSearchManager(this.query,new L.RipgrepTextSearchEngine(P),m);return new Promise((E,f)=>u.search(v=>{D(v.map(i))},S).then(v=>E({limitHit:v.limitHit,type:"success",stats:v.stats}),f))}}e.TextSearchEngineAdapter=C;function i(k){return{path:k.resource&&k.resource.fsPath,results:k.results,numMatches:(k.results||[]).reduce((S,D)=>{if(D.ranges){const R=D;return S+(Array.isArray(R.ranges)?R.ranges.length:1)}else return S+1},0)}}}),define(pe[283],ve([0,1,16,18,15,3,100,9,46,2,42,33,280,282]),function(Y,e,m,L,y,C,i,k,S,D,R,P,u,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SearchService=void 0;class f{constructor(r="searchProcess"){this.processType=r,this.caches=Object.create(null)}fileSearch(r){let g;const a=I(r),_=new C.Emitter({onFirstListenerDidAdd:()=>{g=(0,L.createCancelablePromise)(n=>this.doFileSearchWithEngine(u.Engine,a,t=>_.fire(t),n)),g.then(n=>_.fire(n),n=>_.fire({type:"error",error:{message:n.message,stack:n.stack}}))},onLastListenerRemove:()=>{g.cancel()}});return _.event}textSearch(r){let g;const a=I(r),_=new C.Emitter({onFirstListenerDidAdd:()=>{g=(0,L.createCancelablePromise)(n=>this.ripgrepTextSearch(a,t=>_.fire(t),n)),g.then(n=>_.fire(n),n=>_.fire({type:"error",error:{message:n.message,stack:n.stack}}))},onLastListenerRemove:()=>{g.cancel()}});return _.event}ripgrepTextSearch(r,g,a){return r.maxFileSize=(0,R.getPlatformLimits)(process.arch==="ia32"?0:1).maxFileSize,new E.TextSearchEngineAdapter(r).search(a,g,g)}doFileSearch(r,g,a){return this.doFileSearchWithEngine(u.Engine,r,g,a)}doFileSearchWithEngine(r,g,a,_,n=f.BATCH_SIZE){let t=0;const o=c=>{Array.isArray(c)?(t+=c.length,a(c.map(h=>this.rawMatchToSearchItem(h)))):c.relativePath?(t++,a(this.rawMatchToSearchItem(c))):a(c)};if(g.sortByScore){let c=this.trySortedSearchFromCache(g,o,_);if(!c){const h=g.maxResults?Object.assign({},g,{maxResults:null}):g,l=new r(h);c=this.doSortedSearch(l,g,a,o,_)}return new Promise((h,l)=>{c.then(([b,T])=>{const A=T.map(x=>this.rawMatchToSearchItem(x));this.sendProgress(A,a,n),h(b)},l)})}const d=new r(g);return this.doSearch(d,o,n,_).then(c=>({limitHit:c.limitHit,type:"success",stats:{detailStats:c.stats,type:this.processType,fromCache:!1,resultCount:t,sortingTime:void 0}}))}rawMatchToSearchItem(r){return{path:r.base?(0,k.join)(r.base,r.relativePath):r.relativePath}}doSortedSearch(r,g,a,_,n){const t=new C.Emitter;let o=(0,L.createCancelablePromise)(c=>{let h=[];const l=b=>{Array.isArray(b)?h=b:(_(b),t.fire(b))};return this.doSearch(r,l,-1,c).then(b=>[b,h])}),d;if(g.cacheKey){d=this.getOrCreateCache(g.cacheKey);const c={promise:o,event:t.event,resolved:!1};d.resultsToSearchCache[g.filePattern||""]=c,o.then(()=>{c.resolved=!0},h=>{delete d.resultsToSearchCache[g.filePattern||""]}),o=this.preventCancellation(o)}return o.then(([c,h])=>{const l=d?d.scorerCache:Object.create(null),b=(typeof g.maxResults!="number"||g.maxResults>0)&&S.StopWatch.create(!1);return this.sortResults(g,h,l,n).then(T=>{const A=b?b.elapsed():-1;return[{type:"success",stats:{detailStats:c.stats,sortingTime:A,fromCache:!1,type:this.processType,workspaceFolderCount:g.folderQueries.length,resultCount:T.length},messages:c.messages,limitHit:c.limitHit||typeof g.maxResults=="number"&&h.length>g.maxResults},T]})})}getOrCreateCache(r){const g=this.caches[r];return g||(this.caches[r]=new v)}trySortedSearchFromCache(r,g,a){const _=r.cacheKey&&this.caches[r.cacheKey];if(!_)return;const n=this.getResultsFromCache(_,r.filePattern||"",g,a);if(n)return n.then(([t,o,d])=>{const c=S.StopWatch.create(!1);return this.sortResults(r,o,_.scorerCache,a).then(h=>{const l=c.elapsed(),b={fromCache:!0,detailStats:d,type:this.processType,resultCount:o.length,sortingTime:l};return[{type:"success",limitHit:t.limitHit||typeof r.maxResults=="number"&&o.length>r.maxResults,stats:b},h]})})}sortResults(r,g,a,_){const n=(0,i.prepareQuery)(r.filePattern||""),t=(d,c)=>(0,i.compareItemsByFuzzyScore)(d,c,n,!0,w,a),o=typeof r.maxResults=="number"?r.maxResults:Number.MAX_VALUE;return m.topAsync(g,t,o,1e4,_)}sendProgress(r,g,a){if(a&&a>0)for(let _=0;_<r.length;_+=a)g(r.slice(_,_+a));else g(r)}getResultsFromCache(r,g,a,_){const n=S.StopWatch.create(!1),t=g.indexOf(k.sep)>=0;let o;for(const l in r.resultsToSearchCache)if(g.startsWith(l)){if(t&&l.indexOf(k.sep)<0&&l!=="")continue;const b=r.resultsToSearchCache[l];o={promise:this.preventCancellation(b.promise),event:b.event,resolved:b.resolved};break}if(!o)return null;const d=n.elapsed(),c=S.StopWatch.create(!1),h=o.event(a);return _&&_.onCancellationRequested(()=>{h.dispose()}),o.promise.then(([l,b])=>{if(_&&_.isCancellationRequested)throw(0,y.canceled)();const T=[],A=(0,i.prepareQuery)(g).normalizedLowercase;for(const x of b)!(0,P.isFilePatternMatch)(x,A)||T.push(x);return[l,T,{cacheWasResolved:o.resolved,cacheLookupTime:d,cacheFilterTime:c.elapsed(),cacheEntryCount:b.length}]})}doSearch(r,g,a,_){return new Promise((n,t)=>{let o=[];_&&_.onCancellationRequested(()=>r.cancel()),r.search(d=>{d&&(a?(o.push(d),a>0&&o.length>=a&&(g(o),o=[])):g(d))},d=>{g(d)},(d,c)=>{o.length&&g(o),d?t(d):n(c)})})}clearCache(r){return delete this.caches[r],Promise.resolve(void 0)}preventCancellation(r){return new class{get[Symbol.toStringTag](){return this.toString()}cancel(){}then(g,a){return r.then(g,a)}catch(g){return this.then(void 0,g)}finally(g){return r.finally(g)}}}}e.SearchService=f,f.BATCH_SIZE=512;class v{constructor(){this.resultsToSearchCache=Object.create(null),this.scorerCache=Object.create(null)}}const w=new class{getItemLabel(s){return(0,k.basename)(s.relativePath)}getItemDescription(s){return(0,k.dirname)(s.relativePath)}getItemPath(s){return s.relativePath}};function I(s){return{...s,folderQueries:s.folderQueries&&s.folderQueries.map(p),extraFileResources:s.extraFileResources&&s.extraFileResources.map(r=>D.URI.revive(r))}}function p(s){return{...s,folder:D.URI.revive(s.folder)}}}),define(pe[284],ve([0,1,6,10,2,28,11,26,14,72,64,33,283,281,92,135]),function(Y,e,m,L,y,C,i,k,S,D,R,P,u,E,f,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeExtHostSearch=void 0;let w=class extends D.ExtHostSearch{constructor(p,s,r,g){super(p,r,g);this._pfs=C,this._internalFileSearchHandle=-1,this._internalFileSearchProvider=null,this._registeredEHSearchProvider=!1;const a=new f.OutputChannel("RipgrepSearchUD",this._logService);this.registerTextSearchProvider(L.Schemas.userData,new E.RipgrepSearchProvider(a)),s.remote.isRemote&&s.remote.authority&&this._registerEHSearchProviders()}$enableExtensionHostSearch(){this._registerEHSearchProviders()}_registerEHSearchProviders(){if(this._registeredEHSearchProvider)return;this._registeredEHSearchProvider=!0;const p=new f.OutputChannel("RipgrepSearchEH",this._logService);this.registerTextSearchProvider(L.Schemas.file,new E.RipgrepSearchProvider(p)),this.registerInternalFileSearchProvider(L.Schemas.file,new u.SearchService("fileSearchProvider"))}registerInternalFileSearchProvider(p,s){const r=this._handlePool++;return this._internalFileSearchProvider=s,this._internalFileSearchHandle=r,this._proxy.$registerFileSearchProvider(r,this._transformScheme(p)),(0,m.toDisposable)(()=>{this._internalFileSearchProvider=null,this._proxy.$unregisterProvider(r)})}$provideFileSearchResults(p,s,r,g){const a=(0,D.reviveQuery)(r);return p===this._internalFileSearchHandle?this.doInternalFileSearch(p,s,a,g):super.$provideFileSearchResults(p,s,r,g)}doInternalFileSearch(p,s,r,g){const a=_=>{if((0,P.isSerializedFileMatch)(_)&&(_=[_]),Array.isArray(_)){this._proxy.$handleFileMatch(p,s,_.map(n=>y.URI.file(n.path)));return}_.message&&this._logService.debug("ExtHostSearch",_.message)};if(!this._internalFileSearchProvider)throw new Error("No internal file search handler");return this._internalFileSearchProvider.doFileSearch(r,a,g)}$clearCache(p){return this._internalFileSearchProvider&&this._internalFileSearchProvider.clearCache(p),super.$clearCache(p)}createTextSearchManager(p,s){return new v.NativeTextSearchManager(p,s,void 0,"textSearchProvider")}};w=je([He(0,S.IExtHostRpcService),He(1,k.IExtHostInitDataService),He(2,R.IURITransformerService),He(3,i.ILogService)],w),e.NativeExtHostSearch=w}),define(pe[137],ve([0,1,296,124,81,22,15,3,6,9,12,32,105,106,297]),function(Y,e,m,L,y,C,i,k,S,D,R,P,u,E,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.connect=e.serve=e.Server=e.createStaticIPCHandle=e.createRandomIPCHandle=e.XDG_RUNTIME_DIR=e.WebSocketNodeSocket=e.NodeSocket=void 0;class v{constructor(b,T=""){this.debugLabel=T,this.socket=b,this.traceSocketEvent("created",{type:"NodeSocket"}),this._errorListener=A=>{if(this.traceSocketEvent("error",{code:A?.code,message:A?.message}),A){if(A.code==="EPIPE")return;(0,i.onUnexpectedError)(A)}},this.socket.on("error",this._errorListener)}traceSocketEvent(b,T){E.SocketDiagnostics.traceSocketEvent(this.socket,this.debugLabel,b,T)}dispose(){this.socket.off("error",this._errorListener),this.socket.destroy()}onData(b){const T=A=>{this.traceSocketEvent("read",A),b(C.VSBuffer.wrap(A))};return this.socket.on("data",T),{dispose:()=>this.socket.off("data",T)}}onClose(b){const T=A=>{this.traceSocketEvent("close",{hadError:A}),b({type:0,hadError:A,error:void 0})};return this.socket.on("close",T),{dispose:()=>this.socket.off("close",T)}}onEnd(b){const T=()=>{this.traceSocketEvent("nodeEndReceived"),b()};return this.socket.on("end",T),{dispose:()=>this.socket.off("end",T)}}write(b){if(!this.socket.destroyed)try{this.traceSocketEvent("write",b),this.socket.write(b.buffer,T=>{if(T){if(T.code==="EPIPE")return;(0,i.onUnexpectedError)(T)}})}catch(T){if(T.code==="EPIPE")return;(0,i.onUnexpectedError)(T)}}end(){this.traceSocketEvent("nodeEndSent"),this.socket.end()}drain(){return this.traceSocketEvent("nodeDrainBegin"),new Promise((b,T)=>{if(this.socket.bufferSize===0){this.traceSocketEvent("nodeDrainEnd"),b();return}const A=()=>{this.socket.off("close",A),this.socket.off("end",A),this.socket.off("error",A),this.socket.off("timeout",A),this.socket.off("drain",A),this.traceSocketEvent("nodeDrainEnd"),b()};this.socket.on("close",A),this.socket.on("end",A),this.socket.on("error",A),this.socket.on("timeout",A),this.socket.on("drain",A)})}}e.NodeSocket=v;var w;(function(l){l[l.MinHeaderByteSize=2]="MinHeaderByteSize"})(w||(w={}));var I;(function(l){l[l.PeekHeader=1]="PeekHeader",l[l.ReadHeader=2]="ReadHeader",l[l.ReadBody=3]="ReadBody",l[l.Fin=4]="Fin"})(I||(I={}));class p extends S.Disposable{constructor(b,T,A,x){super();this._onData=this._register(new k.Emitter),this._onClose=this._register(new k.Emitter),this._isEnded=!1,this._state={state:1,readLen:2,fin:0,compressed:!1,firstFrameOfMessage:!0,mask:0},this.socket=b,this.traceSocketEvent("created",{type:"WebSocketNodeSocket",permessageDeflate:T,inflateBytesLength:A?.byteLength||0,recordInflateBytes:x}),this._flowManager=this._register(new s(this,T,A,x,this._onData,(O,F)=>this._write(O,F))),this._register(this._flowManager.onError(O=>{console.error(O),(0,i.onUnexpectedError)(O),this._onClose.fire({type:0,hadError:!0,error:O})})),this._incomingData=new E.ChunkStream,this._register(this.socket.onData(O=>this._acceptChunk(O))),this._register(this.socket.onClose(O=>this._onClose.fire(O)))}get permessageDeflate(){return this._flowManager.permessageDeflate}get recordedInflateBytes(){return this._flowManager.recordedInflateBytes}traceSocketEvent(b,T){this.socket.traceSocketEvent(b,T)}dispose(){this._flowManager.isProcessingWriteQueue()?this._register(this._flowManager.onDidFinishProcessingWriteQueue(()=>{this.dispose()})):(this.socket.dispose(),super.dispose())}onData(b){return this._onData.event(b)}onClose(b){return this._onClose.event(b)}onEnd(b){return this.socket.onEnd(b)}write(b){this._flowManager.writeMessage(b)}_write(b,T){if(this._isEnded)return;this.traceSocketEvent("webSocketNodeSocketWrite",b);let A=2;b.byteLength<126?A+=0:b.byteLength<2**16?A+=2:A+=8;const x=C.VSBuffer.alloc(A);if(T?x.writeUInt8(194,0):x.writeUInt8(130,0),b.byteLength<126)x.writeUInt8(b.byteLength,1);else if(b.byteLength<2**16){x.writeUInt8(126,1);let O=1;x.writeUInt8(b.byteLength>>>8&255,++O),x.writeUInt8(b.byteLength>>>0&255,++O)}else{x.writeUInt8(127,1);let O=1;x.writeUInt8(0,++O),x.writeUInt8(0,++O),x.writeUInt8(0,++O),x.writeUInt8(0,++O),x.writeUInt8(b.byteLength>>>24&255,++O),x.writeUInt8(b.byteLength>>>16&255,++O),x.writeUInt8(b.byteLength>>>8&255,++O),x.writeUInt8(b.byteLength>>>0&255,++O)}this.socket.write(C.VSBuffer.concat([x,b]))}end(){this._isEnded=!0,this.socket.end()}_acceptChunk(b){if(b.byteLength!==0){for(this._incomingData.acceptChunk(b);this._incomingData.byteLength>=this._state.readLen;)if(this._state.state===1){const T=this._incomingData.peek(this._state.readLen),A=T.readUInt8(0),x=(A&128)>>>7,O=(A&64)>>>6,F=T.readUInt8(1),W=(F&128)>>>7,M=F&127;this._state.state=2,this._state.readLen=2+(W?4:0)+(M===126?2:0)+(M===127?8:0),this._state.fin=x,this._state.firstFrameOfMessage&&(this._state.compressed=Boolean(O)),this._state.firstFrameOfMessage=Boolean(x),this._state.mask=0,this.traceSocketEvent("webSocketNodeSocketPeekedHeader",{headerSize:this._state.readLen,compressed:this._state.compressed,fin:this._state.fin})}else if(this._state.state===2){const T=this._incomingData.read(this._state.readLen),A=T.readUInt8(1),x=(A&128)>>>7;let O=A&127,F=1;O===126?O=T.readUInt8(++F)*2**8+T.readUInt8(++F):O===127&&(O=T.readUInt8(++F)*0+T.readUInt8(++F)*0+T.readUInt8(++F)*0+T.readUInt8(++F)*0+T.readUInt8(++F)*2**24+T.readUInt8(++F)*2**16+T.readUInt8(++F)*2**8+T.readUInt8(++F));let W=0;x&&(W=T.readUInt8(++F)*2**24+T.readUInt8(++F)*2**16+T.readUInt8(++F)*2**8+T.readUInt8(++F)),this._state.state=3,this._state.readLen=O,this._state.mask=W,this.traceSocketEvent("webSocketNodeSocketPeekedHeader",{bodySize:this._state.readLen,compressed:this._state.compressed,fin:this._state.fin,mask:this._state.mask})}else if(this._state.state===3){const T=this._incomingData.read(this._state.readLen);this.traceSocketEvent("webSocketNodeSocketReadData",T),a(T,this._state.mask),this.traceSocketEvent("webSocketNodeSocketUnmaskedData",T),this._state.state=1,this._state.readLen=2,this._state.mask=0,this._flowManager.acceptFrame(T,this._state.compressed,!!this._state.fin)}}}async drain(){this.traceSocketEvent("webSocketNodeSocketDrainBegin"),this._flowManager.isProcessingWriteQueue()&&await k.Event.toPromise(this._flowManager.onDidFinishProcessingWriteQueue),await this.socket.drain(),this.traceSocketEvent("webSocketNodeSocketDrainEnd")}}e.WebSocketNodeSocket=p;class s extends S.Disposable{constructor(b,T,A,x,O,F){super();this._tracer=b,this._onData=O,this._writeFn=F,this._onError=this._register(new k.Emitter),this.onError=this._onError.event,this._writeQueue=[],this._readQueue=[],this._onDidFinishProcessingWriteQueue=this._register(new k.Emitter),this.onDidFinishProcessingWriteQueue=this._onDidFinishProcessingWriteQueue.event,this._isProcessingWriteQueue=!1,this._isProcessingReadQueue=!1,T?(this._zlibInflateStream=this._register(new r(this._tracer,x,A,{windowBits:15})),this._zlibDeflateStream=this._register(new g(this._tracer,{windowBits:15})),this._register(this._zlibInflateStream.onError(W=>this._onError.fire(W))),this._register(this._zlibDeflateStream.onError(W=>this._onError.fire(W)))):(this._zlibInflateStream=null,this._zlibDeflateStream=null)}get permessageDeflate(){return Boolean(this._zlibInflateStream&&this._zlibDeflateStream)}get recordedInflateBytes(){return this._zlibInflateStream?this._zlibInflateStream.recordedInflateBytes:C.VSBuffer.alloc(0)}writeMessage(b){this._writeQueue.push(b),this._processWriteQueue()}async _processWriteQueue(){if(!this._isProcessingWriteQueue){for(this._isProcessingWriteQueue=!0;this._writeQueue.length>0;){const b=this._writeQueue.shift();if(this._zlibDeflateStream){const T=await this._deflateMessage(this._zlibDeflateStream,b);this._writeFn(T,!0)}else this._writeFn(b,!1)}this._isProcessingWriteQueue=!1,this._onDidFinishProcessingWriteQueue.fire()}}isProcessingWriteQueue(){return this._isProcessingWriteQueue}_deflateMessage(b,T){return new Promise((A,x)=>{b.write(T),b.flush(O=>A(O))})}acceptFrame(b,T,A){this._readQueue.push({data:b,isCompressed:T,isLastFrameOfMessage:A}),this._processReadQueue()}async _processReadQueue(){if(!this._isProcessingReadQueue){for(this._isProcessingReadQueue=!0;this._readQueue.length>0;){const b=this._readQueue.shift();if(this._zlibInflateStream&&b.isCompressed){const T=await this._inflateFrame(this._zlibInflateStream,b.data,b.isLastFrameOfMessage);this._onData.fire(T)}else this._onData.fire(b.data)}this._isProcessingReadQueue=!1}}_inflateFrame(b,T,A){return new Promise((x,O)=>{b.write(T),A&&b.write(C.VSBuffer.fromByteArray([0,0,255,255])),b.flush(F=>x(F))})}}class r extends S.Disposable{constructor(b,T,A,x){super();this._tracer=b,this._recordInflateBytes=T,this._onError=this._register(new k.Emitter),this.onError=this._onError.event,this._recordedInflateBytes=[],this._pendingInflateData=[],this._zlibInflate=f.createInflateRaw(x),this._zlibInflate.on("error",O=>{this._tracer.traceSocketEvent("zlibInflateError",{message:O?.message,code:O?.code}),this._onError.fire(O)}),this._zlibInflate.on("data",O=>{this._tracer.traceSocketEvent("zlibInflateData",O),this._pendingInflateData.push(C.VSBuffer.wrap(O))}),A&&(this._tracer.traceSocketEvent("zlibInflateInitialWrite",A.buffer),this._zlibInflate.write(A.buffer),this._zlibInflate.flush(()=>{this._tracer.traceSocketEvent("zlibInflateInitialFlushFired"),this._pendingInflateData.length=0}))}get recordedInflateBytes(){return this._recordInflateBytes?C.VSBuffer.concat(this._recordedInflateBytes):C.VSBuffer.alloc(0)}write(b){this._recordInflateBytes&&this._recordedInflateBytes.push(b.clone()),this._tracer.traceSocketEvent("zlibInflateWrite",b),this._zlibInflate.write(b.buffer)}flush(b){this._zlibInflate.flush(()=>{this._tracer.traceSocketEvent("zlibInflateFlushFired");const T=C.VSBuffer.concat(this._pendingInflateData);this._pendingInflateData.length=0,b(T)})}}class g extends S.Disposable{constructor(b,T){super();this._tracer=b,this._onError=this._register(new k.Emitter),this.onError=this._onError.event,this._pendingDeflateData=[],this._zlibDeflate=f.createDeflateRaw({windowBits:15}),this._zlibDeflate.on("error",A=>{this._tracer.traceSocketEvent("zlibDeflateError",{message:A?.message,code:A?.code}),this._onError.fire(A)}),this._zlibDeflate.on("data",A=>{this._tracer.traceSocketEvent("zlibDeflateData",A),this._pendingDeflateData.push(C.VSBuffer.wrap(A))})}write(b){this._tracer.traceSocketEvent("zlibDeflateWrite",b.buffer),this._zlibDeflate.write(b.buffer)}flush(b){this._zlibDeflate.flush(2,()=>{this._tracer.traceSocketEvent("zlibDeflateFlushFired");let T=C.VSBuffer.concat(this._pendingDeflateData);this._pendingDeflateData.length=0,T=T.slice(0,T.byteLength-4),b(T)})}}function a(l,b){if(b===0)return;let T=l.byteLength>>>2;for(let M=0;M<T;M++){const B=l.readUInt32BE(M*4);l.writeUInt32BE(B^b,M*4)}let A=T*4,x=l.byteLength-A;const O=b>>>24&255,F=b>>>16&255,W=b>>>8&255;x>=1&&l.writeUInt8(l.readUInt8(A)^O,A),x>=2&&l.writeUInt8(l.readUInt8(A+1)^F,A+1),x>=3&&l.writeUInt8(l.readUInt8(A+2)^W,A+2)}e.XDG_RUNTIME_DIR=process.env.XDG_RUNTIME_DIR;const _={[2]:107,[1]:103};function n(){const l=(0,P.generateUuid)();if(process.platform==="win32")return`\\\\.\\pipe\\vscode-ipc-${l}-sock`;let b;return e.XDG_RUNTIME_DIR?b=(0,D.join)(e.XDG_RUNTIME_DIR,`vscode-ipc-${l}.sock`):b=(0,D.join)((0,y.tmpdir)(),`vscode-ipc-${l}.sock`),o(b),b}e.createRandomIPCHandle=n;function t(l,b,T){const A=(0,m.createHash)("md5").update(l).digest("hex");if(process.platform==="win32")return`\\\\.\\pipe\\${A}-${T}-${b}-sock`;let x;return e.XDG_RUNTIME_DIR&&!process.env.VSCODE_PORTABLE?x=(0,D.join)(e.XDG_RUNTIME_DIR,`vscode-${A.substr(0,8)}-${T}-${b}.sock`):x=(0,D.join)(l,`${T}-${b}.sock`),o(x),x}e.createStaticIPCHandle=t;function o(l){const b=_[R.platform];typeof b=="number"&&l.length>=b&&console.warn(`WARNING: IPC handle "${l}" is longer than ${b} chars, try a shorter --user-data-dir`)}class d extends u.IPCServer{constructor(b){super(d.toClientConnectionEvent(b));this.server=b}static toClientConnectionEvent(b){const T=k.Event.fromNodeEventEmitter(b,"connection");return k.Event.map(T,A=>({protocol:new E.Protocol(new v(A,"ipc-server-connection")),onDidClientDisconnect:k.Event.once(k.Event.fromNodeEventEmitter(A,"close"))}))}dispose(){super.dispose(),this.server&&(this.server.close(),this.server=null)}}e.Server=d;function c(l){return new Promise((b,T)=>{const A=(0,L.createServer)();A.on("error",T),A.listen(l,()=>{A.removeListener("error",T),b(new d(A))})})}e.serve=c;function h(l,b){return new Promise((T,A)=>{const x=(0,L.createConnection)(l,()=>{x.removeListener("error",A),T(E.Client.fromSocket(new v(x,`ipc-client${b}`),b))});x.once("error",A)})}e.connect=h}),define(pe[285],ve([0,1,137,277,60,38,2,197,11]),function(Y,e,m,L,y,C,i,k,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CLIServer=e.CLIServerBase=void 0;class D{constructor(u,E,f){this._commands=u,this.logService=E,this._ipcHandlePath=f,this._server=L.createServer((v,w)=>this.onRequest(v,w)),this.setup().catch(v=>(E.error(v),""))}get ipcHandlePath(){return this._ipcHandlePath}async setup(){try{this._server.listen(this.ipcHandlePath),this._server.on("error",u=>this.logService.error(u))}catch(u){this.logService.error("Could not start open from terminal server.")}return this._ipcHandlePath}onRequest(u,E){const f=[];u.setEncoding("utf8"),u.on("data",v=>f.push(v)),u.on("end",()=>{const v=JSON.parse(f.join(""));switch(v.type){case"open":this.open(v,E);break;case"openExternal":this.openExternal(v,E);break;case"status":this.getStatus(v,E);break;case"extensionManagement":this.manageExtensions(v,E).catch(this.logService.error);break;default:E.writeHead(404),E.write(`Unknown message type: ${v.type}`,w=>{w&&this.logService.error(w)}),E.end();break}})}open(u,E){const{fileURIs:f,folderURIs:v,forceNewWindow:w,diffMode:I,addMode:p,forceReuseWindow:s,gotoLineMode:r,waitMarkerFilePath:g,remoteAuthority:a}=u,_=[];if(Array.isArray(v))for(const d of v)try{_.push({folderUri:i.URI.parse(d)})}catch(c){}if(Array.isArray(f))for(const d of f)try{(0,k.hasWorkspaceFileExtension)(d)?_.push({workspaceUri:i.URI.parse(d)}):_.push({fileUri:i.URI.parse(d)})}catch(c){}const n=g?i.URI.file(g):void 0,o={forceNewWindow:w,diffMode:I,addMode:p,gotoLineMode:r,forceReuseWindow:s,preferNewWindow:!s&&!n&&!p,waitMarkerFileURI:n,remoteAuthority:a};this._commands.executeCommand("_remoteCLI.windowOpen",_,o),E.writeHead(200),E.end()}async openExternal(u,E){for(const f of u.uris){const v=i.URI.parse(f),w=v.scheme==="file"?v:f;await this._commands.executeCommand("_remoteCLI.openExternal",w)}E.writeHead(200),E.end()}async manageExtensions(u,E){try{const f=I=>I?.map(p=>/\.vsix$/i.test(p)?i.URI.parse(p):p),v={list:u.list,install:f(u.install),uninstall:f(u.uninstall),force:u.force},w=await this._commands.executeCommand("_remoteCLI.manageExtensions",v);E.writeHead(200),E.write(w)}catch(f){E.writeHead(500),E.write(String(f),v=>{v&&this.logService.error(v)})}E.end()}async getStatus(u,E){try{const f=await this._commands.executeCommand("_remoteCLI.getSystemStatus");E.writeHead(200),E.write(f),E.end()}catch(f){E.writeHead(500),E.write(String(f),v=>{v&&this.logService.error(v)}),E.end()}}dispose(){this._server.close(),this._ipcHandlePath&&process.platform!=="win32"&&y.existsSync(this._ipcHandlePath)&&y.unlinkSync(this._ipcHandlePath)}}e.CLIServerBase=D;let R=class extends D{constructor(u,E){super(u,E,(0,m.createRandomIPCHandle)())}};R=je([He(0,C.IExtHostCommands),He(1,S.ILogService)],R),e.CLIServer=R}),define(pe[286],ve([0,1,71,273,268,5,276,39,258,2,10,7,285,104]),function(Y,e,m,L,y,C,i,k,S,D,R,P,u,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostExtensionService=void 0;class f extends y.RequireInterceptor{_installInterceptor(){const I=this,p=Y.__$__nodeRequire("module"),s=p._load;p._load=function(g,a,_){for(let n of I._alternatives){let t=n(g);if(t){g=t;break}}return I._factories.has(g)?I._factories.get(g).load(g,D.URI.file((0,E.realpathSync)(a.filename)),n=>s.apply(this,[n,a,_])):s.apply(this,arguments)}}}class v extends k.AbstractExtHostExtensionService{constructor(){super(...arguments);this.extensionRuntime=P.ExtensionRuntime.Node}async _beforeAlmostReadyToRunExtensions(){const I=this._instaService.invokeFunction(L.createApiFactoryAndRegisterActors);if(this._instaService.createInstance(S.ExtHostDownloadService),this._initData.remote.isRemote&&this._initData.remote.authority){const a=this._instaService.createInstance(u.CLIServer);process.env.VSCODE_IPC_HOOK_CLI=a.ipcHandlePath}await this._instaService.createInstance(f,I,this._registry).install(),m.mark("code/extHost/didInitAPI");const s=await this._extHostConfiguration.getConfigProvider();await(0,i.connectProxyResolver)(this._extHostWorkspace,s,this,this._logService,this._mainThreadTelemetryProxy,this._initData),m.mark("code/extHost/didInitProxyResolver");const r=process.send,g=this._extHostContext.getProxy(C.MainContext.MainThreadConsole);process.send=(...a)=>a.length===0||!a[0]||a[0].type!=="__$console"?r.apply(process,a):(g.$logExtensionHostMessage(a[0]),!1)}_getEntryPoint(I){return I.main}_loadCommonJSModule(I,p,s){if(p.scheme!==R.Schemas.file)throw new Error(`Cannot load URI: '${p}', must be of file-scheme`);let r=null;s.codeLoadingStart(),this._logService.trace(`ExtensionService#loadCommonJSModule ${p.toString(!0)}`),this._logService.flush();try{I&&m.mark(`code/extHost/willLoadExtensionCode/${I.value}`),r=Y.__$__nodeRequire(p.fsPath)}catch(g){return Promise.reject(g)}finally{I&&m.mark(`code/extHost/didLoadExtensionCode/${I.value}`),s.codeLoadingStop()}return Promise.resolve(r)}async $setRemoteEnvironment(I){if(!!this._initData.remote.isRemote)for(const p in I){const s=I[p];s===null?delete process.env[p]:process.env[p]=s}}}e.ExtHostExtensionService=v}),define(pe[287],ve([0,1,83,261,270,269,284,286,262,55,39,72,70,34,52,67,260,259,11]),function(Y,e,m,L,y,C,i,k,S,D,R,P,u,E,f,v,w,I,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),(0,m.registerSingleton)(R.IExtHostExtensionService,k.ExtHostExtensionService),(0,m.registerSingleton)(p.ILoggerService,I.ExtHostLoggerService),(0,m.registerSingleton)(v.IExtensionStoragePaths,w.ExtensionStoragePaths),(0,m.registerSingleton)(D.IExtHostDebugService,C.ExtHostDebugService),(0,m.registerSingleton)(P.IExtHostSearch,i.NativeExtHostSearch),(0,m.registerSingleton)(u.IExtHostTask,y.ExtHostTask),(0,m.registerSingleton)(E.IExtHostTerminalService,L.ExtHostTerminalService),(0,m.registerSingleton)(f.IExtHostTunnelService,S.ExtHostTunnelService)}),define(pe[288],ve([0,1,124,298,71,15,106,137,190,224,271,22,102,28,104,18,113,274,287]),function(Y,e,m,L,y,C,i,k,S,D,R,P,u,E,f,v,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.startExtensionHostProcess=void 0,function(){for(let o=0;o<process.execArgv.length;o++)process.execArgv[o]==="--inspect-port=0"&&(process.execArgv.splice(o,1),o--)}();const I=L(process.argv.slice(2),{string:["uriTransformerPath","useHostProxy"],boolean:["skipWorkspaceStorageLock"]});(function(){const t=Y.__$__nodeRequire("module"),o=t._load;t._load=function(d){if(d==="natives")throw new Error('Either the extension or a NPM dependency is using the "natives" node module which is unsupported as it can cause a crash of the extension host. Click [here](https://go.microsoft.com/fwlink/?linkid=871887) to find out more');return o.apply(this,arguments)}})();const p=process.exit.bind(process);function s(t){process.exit=function(o){if(t)p(o);else{const d=new Error("An extension called process.exit() and this was prevented.");console.warn(d.stack)}},process.crash=function(){const o=new Error("An extension called process.crash() and this was prevented.");console.warn(o.stack)}}let r=function(t){p()};function g(){if(process.env.VSCODE_EXTHOST_WILL_SEND_SOCKET)return new Promise((t,o)=>{let d=null,c=setTimeout(()=>{r("VSCODE_EXTHOST_IPC_SOCKET timeout")},6e4);const h=108e5,l=3e5,b=new v.ProcessTimeRunOnceScheduler(()=>r("renderer disconnected for too long (1)"),h),T=new v.ProcessTimeRunOnceScheduler(()=>r("renderer disconnected for too long (2)"),l);process.on("message",(x,O)=>{if(x&&x.type==="VSCODE_EXTHOST_IPC_SOCKET"){O.setNoDelay(!0);const F=P.VSBuffer.wrap(Buffer.from(x.initialDataChunk,"base64"));let W;if(x.skipWebSocketFrames)W=new k.NodeSocket(O,"extHost-socket");else{const M=P.VSBuffer.wrap(Buffer.from(x.inflateBytes,"base64"));W=new k.WebSocketNodeSocket(new k.NodeSocket(O,"extHost-socket"),x.permessageDeflate,M,!1)}d?(b.cancel(),T.cancel(),d.beginAcceptReconnection(W,F),d.endAcceptReconnection(),d.sendResume()):(clearTimeout(c),d=new i.PersistentProtocol(W,F),d.sendResume(),d.onDidDispose(()=>r("renderer disconnected")),t(d),d.onSocketClose(()=>{b.schedule()}))}if(x&&x.type==="VSCODE_EXTHOST_IPC_REDUCE_GRACE_TIME"){if(T.isScheduled())return;b.isScheduled()&&T.schedule()}});const A={type:"VSCODE_EXTHOST_IPC_READY"};process.send&&process.send(A)});{const t=process.env.VSCODE_IPC_HOOK_EXTHOST;return new Promise((o,d)=>{const c=m.createConnection(t,()=>{c.removeListener("error",d),o(new i.PersistentProtocol(new k.NodeSocket(c,"extHost-renderer")))});c.once("error",d),c.on("close",()=>{r("renderer closed the socket")})})}}async function a(){const t=await g();return new class{constructor(){this._onMessage=new i.BufferedEmitter,this.onMessage=this._onMessage.event,this._terminating=!1,t.onMessage(o=>{(0,D.isMessageOfType)(o,2)?(this._terminating=!0,r("received terminate message from renderer")):this._onMessage.fire(o)})}send(o){this._terminating||t.send(o)}drain(){return t.drain()}}}function _(t){return new Promise(o=>{const d=t.onMessage(c=>{d.dispose();const h=JSON.parse(c.toString()),l=h.commit,b=S.default.commit;l&&b&&l!==b&&p(55);let T=0;setInterval(function(){try{process.kill(h.parentPid,0),T=0}catch(x){x&&x.code==="EPERM"?(T++,T>=3&&r(`parent process ${h.parentPid} does not exist anymore (3 x EPERM): ${x.message} (code: ${x.code}) (errno: ${x.errno})`)):r(`parent process ${h.parentPid} does not exist anymore: ${x.message} (code: ${x.code}) (errno: ${x.errno})`)}},1e3);let A;try{A=Y.__$__nodeRequire("native-watchdog"),A.start(h.parentPid)}catch(x){(0,C.onUnexpectedError)(x)}t.send((0,D.createMessageOfType)(0)),o({protocol:t,initData:h})});t.send((0,D.createMessageOfType)(1))})}async function n(){const t=[];process.on("unhandledRejection",(T,A)=>{t.push(A),setTimeout(()=>{const x=t.indexOf(A);x>=0&&A.catch(O=>{t.splice(x,1),(0,C.isPromiseCanceledError)(O)||(console.warn(`rejected promise not handled within 1 second: ${O}`),O&&O.stack&&console.warn(`stack trace: ${O.stack}`),T&&(0,C.onUnexpectedError)(T))})},1e3)}),process.on("rejectionHandled",T=>{const A=t.indexOf(T);A>=0&&t.splice(A,1)}),process.on("uncaughtException",function(T){(0,C.onUnexpectedError)(T)}),y.mark("code/extHost/willConnectToRenderer");const o=await a();y.mark("code/extHost/didConnectToRenderer");const d=await _(o);y.mark("code/extHost/didWaitForInitData");const{initData:c}=d;s(!!c.environment.extensionTestsLocationURI),c.environment.useHostProxy=I.useHostProxy!==void 0?I.useHostProxy!=="false":void 0,c.environment.skipWorkspaceStorageLock=(0,w.boolean)(I.skipWorkspaceStorageLock,!1);const h=new class{constructor(){this.pid=process.pid}exit(A){p(A)}exists(A){return E.Promises.exists(A)}realpath(A){return(0,f.realpath)(A)}};let l=null;if(c.remote.authority&&I.uriTransformerPath)try{const A=Y.__$__nodeRequire(I.uriTransformerPath)(c.remote.authority);l=new u.URITransformer(A)}catch(T){console.error(T)}const b=new R.ExtensionHostMain(d.protocol,c,h,l);r=T=>b.terminate(T)}e.startExtensionHostProcess=n}),define(pe[299],ve([0,1,288]),function(Y,e,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),(0,m.startExtensionHostProcess)().catch(L=>console.log(L))})}).call(this);

//# sourceMappingURL=https://ticino.blob.core.windows.net/sourcemaps/899d46d82c4c95423fb7e10e68eba52050e30ba3/core/vs/workbench/services/extensions/node/extensionHostProcess.js.map
