/*!--------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/(function(){var Ee=["require","exports","vs/base/common/uri","vs/base/common/event","vs/platform/instantiation/common/instantiation","vs/workbench/api/common/extHost.protocol","vs/base/common/lifecycle","vs/workbench/api/common/extHostTypes","vs/workbench/api/common/extHostTypeConverters","vs/base/common/strings","vs/base/common/network","vs/base/common/types","vs/platform/log/common/log","vs/workbench/api/common/extHostRpcService","vs/base/common/async","vs/base/common/errors","vs/base/common/arrays","vs/base/common/path","vs/nls","vs/nls!vs/workbench/services/extensions/worker/extensionHostWorker","vs/base/common/cancellation","vs/base/common/map","vs/base/common/buffer","vs/base/common/platform","vs/base/common/resources","vs/platform/extensions/common/extensions","vs/base/common/objects","vs/workbench/services/extensions/common/extensions","vs/workbench/api/common/extHostInitDataService","vs/base/common/glob","vs/workbench/api/common/extHostFileSystemInfo","vs/workbench/api/common/extHostWorkspace","vs/workbench/api/common/extHostConfiguration","vs/workbench/api/common/extHostExtensionService","vs/base/common/severity","vs/base/common/uuid","vs/platform/registry/common/platform","vs/workbench/services/extensions/common/proxyIdentifier","vs/workbench/api/common/extHostCommands","vs/workbench/api/common/extHostTerminalService","vs/workbench/services/search/common/search","vs/base/common/assert","vs/base/common/extpath","vs/base/common/errorMessage","vs/platform/contextkey/common/contextkey","vs/platform/files/common/files","vs/platform/workspace/common/workspace","vs/workbench/api/common/extHostTestingPrivateApi","vs/workbench/api/common/extHostDocumentsAndEditors","vs/workbench/api/common/extHostFileSystemConsumer","vs/workbench/api/common/extHostWebview","vs/base/common/decorators","vs/base/common/idGenerator","vs/base/common/codicons","vs/base/common/marshalling","vs/editor/common/modes/languageSelector","vs/platform/instantiation/common/extensions","vs/base/common/hash","vs/editor/common/modes","vs/editor/common/core/range","vs/platform/instantiation/common/serviceCollection","vs/platform/remote/common/remoteHosts","vs/platform/theme/common/themeService","vs/workbench/api/common/cache","vs/workbench/api/common/extHostTunnelService","vs/workbench/api/common/extHostUriTransformerService","vs/workbench/api/common/shared/webview","vs/workbench/contrib/testing/common/testId","vs/workbench/api/common/exHostSecretState","vs/workbench/api/common/extHostApiDeprecationService","vs/workbench/api/common/extHostEditorTabs","vs/workbench/api/common/extHostStorage","vs/workbench/api/common/extHostStoragePaths","vs/base/common/performance","vs/base/common/collections","vs/base/common/numbers","vs/base/common/htmlContent","vs/base/common/labels","vs/base/common/mime","vs/editor/common/services/semanticTokensDto","vs/platform/instantiation/common/descriptors","vs/platform/configuration/common/configuration","vs/platform/markers/common/markers","vs/platform/configuration/common/configurationRegistry","vs/platform/remote/common/remoteAuthorityResolver","vs/workbench/api/common/extHostTelemetry","vs/workbench/api/common/extHostDocumentData","vs/workbench/contrib/notebook/common/notebookCommon","vs/workbench/contrib/testing/common/testCollection","vs/base/common/process","vs/workbench/services/editor/common/editorGroupsService","vs/workbench/api/common/extHostNotebookEditor","vs/workbench/api/common/extHostTextEditor","vs/workbench/api/common/extHostDecorations","vs/workbench/api/common/extHostOutput","vs/workbench/api/common/extHostWindow","vs/workbench/services/search/common/searchExtTypes","vs/workbench/api/common/extHostTask","vs/workbench/api/common/extHostDebugService","vs/workbench/api/common/extHostSearch","vs/base/common/json","vs/base/common/lazy","vs/base/common/stream","vs/base/common/filters","vs/base/common/iconLabels","vs/base/common/comparers","vs/base/common/uriIpc","vs/editor/common/modes/languageConfiguration","vs/editor/common/modes/tokenizationRegistry","vs/nls!vs/base/common/date","vs/base/common/date","vs/nls!vs/base/common/errorMessage","vs/nls!vs/editor/common/config/editorOptions","vs/editor/common/config/editorOptions","vs/editor/common/model/wordHelper","vs/nls!vs/platform/configuration/common/configurationRegistry","vs/nls!vs/platform/extensions/common/extensionValidator","vs/nls!vs/platform/files/common/files","vs/nls!vs/platform/markers/common/markers","vs/nls!vs/workbench/api/common/extHostDiagnostics","vs/nls!vs/workbench/api/common/extHostExtensionService","vs/nls!vs/workbench/api/common/extHostProgress","vs/nls!vs/workbench/api/common/extHostStatusBar","vs/nls!vs/workbench/api/common/extHostTerminalService","vs/nls!vs/workbench/api/common/extHostTreeViews","vs/nls!vs/workbench/api/common/extHostWorkspace","vs/nls!vs/workbench/common/editor","vs/nls!vs/workbench/contrib/debug/common/abstractDebugAdapter","vs/nls!vs/workbench/contrib/search/common/queryBuilder","vs/nls!vs/workbench/contrib/tasks/common/taskService","vs/nls!vs/workbench/services/configurationResolver/common/variableResolver","vs/platform/editor/common/editor","vs/platform/extensions/common/extensionValidator","vs/platform/instantiation/common/graph","vs/editor/common/services/modelService","vs/editor/common/modes/languageFeatureRegistry","vs/platform/environment/common/environment","vs/platform/instantiation/common/instantiationService","vs/platform/notification/common/notification","vs/platform/opener/common/opener","vs/platform/progress/common/progress","vs/platform/jsonschemas/common/jsonContributionRegistry","vs/platform/configuration/common/configurationModels","vs/platform/extensionManagement/common/extensionManagementUtil","vs/platform/remote/common/tunnel","vs/platform/terminal/common/terminalDataBuffering","vs/platform/theme/common/theme","vs/workbench/api/common/extHostMemento","vs/workbench/api/common/extHostNotebookDocuments","vs/workbench/api/common/extHostSecrets","vs/workbench/api/common/extHostNotebookConcatDocument","vs/workbench/api/common/extHostTheming","vs/workbench/api/common/extHostWebviewMessaging","vs/workbench/api/common/shared/treeDataTransfer","vs/workbench/api/common/extHostCodeInsets","vs/workbench/common/editor","vs/workbench/contrib/debug/common/abstractDebugAdapter","vs/workbench/contrib/debug/common/debugUtils","vs/base/common/iterator","vs/workbench/contrib/notebook/common/notebookExecutionService","vs/workbench/contrib/output/common/output","vs/workbench/contrib/tasks/common/taskService","vs/workbench/contrib/terminal/common/environmentVariableShared","vs/workbench/services/configurationResolver/common/variableResolver","vs/workbench/services/editor/common/editorService","vs/workbench/api/common/extHostDocumentSaveParticipant","vs/workbench/api/common/extHostFileSystemEventService","vs/workbench/api/common/extHostNotebookDocument","vs/workbench/api/common/extHostProgress","vs/workbench/api/common/extHostTreeViews","vs/workbench/contrib/testing/common/ownedTestCollection","vs/workbench/services/environment/common/environmentService","vs/workbench/services/extensions/common/extensionDescriptionRegistry","vs/workbench/services/extensions/common/extensionHostProtocol","vs/workbench/api/common/extHostExtensionActivator","vs/workbench/api/common/extHostLogService","vs/workbench/services/extensions/common/lazyPromise","vs/workbench/api/common/extHostAuthentication","vs/workbench/api/common/extHostBulkEdits","vs/workbench/api/common/extHostClipboard","vs/workbench/api/common/extHostApiCommands","vs/workbench/api/common/extHostComments","vs/workbench/api/common/extHostDiagnostics","vs/workbench/api/common/extHostDialogs","vs/workbench/api/common/extHostDocumentContentProviders","vs/workbench/api/common/extHostDocuments","vs/workbench/api/common/extHostFileSystem","vs/workbench/api/common/extHostInteractive","vs/workbench/api/common/extHostLabelService","vs/workbench/api/common/extHostLanguageFeatures","vs/base/common/stopwatch","vs/workbench/api/common/extHostLanguages","vs/workbench/api/common/extHostLoggerService","vs/workbench/api/common/extHostMessageService","vs/workbench/api/common/extHostNotebook","vs/workbench/api/common/extHostNotebookEditors","vs/workbench/api/common/extHostNotebookKernels","vs/workbench/api/common/extHostNotebookRenderers","vs/workbench/api/common/extHostQuickOpen","vs/workbench/api/common/extHostSCM","vs/workbench/api/common/extHostStatusBar","vs/workbench/api/common/extHostTesting","vs/workbench/api/common/extHostTextEditors","vs/workbench/api/common/extHostTimeline","vs/workbench/api/common/extHostUriOpener","vs/workbench/api/common/extHostUrls","vs/workbench/api/common/extHostCustomEditors","vs/workbench/api/common/extHostWebviewPanels","vs/workbench/api/common/extHostWebviewView","vs/workbench/services/extensions/common/rpcProtocol","vs/workbench/services/extensions/worker/polyfillNestedWorker","vs/workbench/services/remote/common/remoteAgentService","vs/workbench/services/path/common/pathService","vs/workbench/contrib/search/common/queryBuilder","vs/workbench/api/common/shared/workspaceContains","vs/workbench/api/common/extHostRequireInterceptor","vs/workbench/services/extensions/common/extensionHostMain","vs/workbench/services/search/common/fileSearchManager","vs/workbench/services/search/common/textSearchManager","vs/workbench/api/common/extHost.api.impl","vs/workbench/api/common/extHost.common.services","vs/workbench/api/worker/extHostExtensionService","vs/workbench/api/worker/extHost.worker.services","vs/editor/common/model/mirrorTextModel","vs/editor/common/viewModel/prefixSumComputer","vs/base/common/marked/marked","vs/base/common/linkedList","vs/editor/common/core/position","vs/editor/common/modes/linkComputer","vs/editor/common/core/selection","vs/base/common/functional","vs/editor/common/model/textModelSearch","vs/editor/common/model","vs/workbench/services/extensions/worker/extensionHostWorker"],_e=function(re){for(var e=[],c=0,F=re.length;c<F;c++)e[c]=Ee[re[c]];return e};define(Ee[41],_e([0,1]),function(re,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ok=void 0;function c(F,w){if(!F)throw new Error(w?`Assertion failed (${w})`:"Assertion Failed")}e.ok=c}),define(Ee[74],_e([0,1]),function(re,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SetMap=e.diffMaps=e.diffSets=e.fromMap=e.groupBy=e.forEach=e.values=void 0;const c=Object.prototype.hasOwnProperty;function F(R){const _=[];for(let n in R)c.call(R,n)&&_.push(R[n]);return _}e.values=F;function w(R,_){for(let n in R)if(c.call(R,n)&&_({key:n,value:R[n]},function(){delete R[n]})===!1)return}e.forEach=w;function P(R,_){const n=Object.create(null);for(const m of R){const o=_(m);let d=n[o];d||(d=n[o]=[]),d.push(m)}return n}e.groupBy=P;function t(R){const _=Object.create(null);return R&&R.forEach((n,m)=>{_[m]=n}),_}e.fromMap=t;function T(R,_){const n=[],m=[];for(let o of R)_.has(o)||n.push(o);for(let o of _)R.has(o)||m.push(o);return{removed:n,added:m}}e.diffSets=T;function C(R,_){const n=[],m=[];for(let[o,d]of R)_.has(o)||n.push(d);for(let[o,d]of _)R.has(o)||m.push(d);return{removed:n,added:m}}e.diffMaps=C;class k{constructor(){this.map=new Map}add(_,n){let m=this.map.get(_);m||(m=new Set,this.map.set(_,m)),m.add(n)}delete(_,n){const m=this.map.get(_);!m||(m.delete(n),m.size===0&&this.map.delete(_))}forEach(_,n){const m=this.map.get(_);!m||m.forEach(n)}}e.SetMap=k}),define(Ee[51],_e([0,1]),function(re,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.throttle=e.debounce=e.memoize=e.createDecorator=void 0;function c(t){return(T,C,k)=>{let R=null,_=null;if(typeof k.value=="function"?(R="value",_=k.value):typeof k.get=="function"&&(R="get",_=k.get),!_)throw new Error("not supported");k[R]=t(_,C)}}e.createDecorator=c;function F(t,T,C){let k=null,R=null;if(typeof C.value=="function"?(k="value",R=C.value,R.length!==0&&console.warn("Memoize should only be used in functions with zero parameters")):typeof C.get=="function"&&(k="get",R=C.get),!R)throw new Error("not supported");const _=`$memoize$${T}`;C[k]=function(...n){return this.hasOwnProperty(_)||Object.defineProperty(this,_,{configurable:!1,enumerable:!1,writable:!1,value:R.apply(this,n)}),this[_]}}e.memoize=F;function w(t,T,C){return c((k,R)=>{const _=`$debounce$${R}`,n=`$debounce$result$${R}`;return function(...m){this[n]||(this[n]=C?C():void 0),clearTimeout(this[_]),T&&(this[n]=T(this[n],...m),m=[this[n]]),this[_]=setTimeout(()=>{k.apply(this,m),this[n]=C?C():void 0},t)}})}e.debounce=w;function P(t,T,C){return c((k,R)=>{const _=`$throttle$timer$${R}`,n=`$throttle$result$${R}`,m=`$throttle$lastRun$${R}`,o=`$throttle$pending$${R}`;return function(...d){if(this[n]||(this[n]=C?C():void 0),(this[m]===null||this[m]===void 0)&&(this[m]=-Number.MAX_VALUE),T&&(this[n]=T(this[n],...d)),this[o])return;const u=this[m]+t;u<=Date.now()?(this[m]=Date.now(),k.apply(this,[this[n]]),this[n]=C?C():void 0):(this[o]=!0,this[_]=setTimeout(()=>{this[o]=!1,this[m]=Date.now(),k.apply(this,[this[n]]),this[n]=C?C():void 0},u-Date.now()))}})}e.throttle=P}),define(Ee[52],_e([0,1]),function(re,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.defaultGenerator=e.IdGenerator=void 0;class c{constructor(w){this._prefix=w,this._lastId=0}nextId(){return this._prefix+ ++this._lastId}}e.IdGenerator=c,e.defaultGenerator=new c("id#")}),define(Ee[100],_e([0,1]),function(re,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getNodeType=e.stripComments=e.visit=e.findNodeAtOffset=e.contains=e.getNodeValue=e.getNodePath=e.findNodeAtLocation=e.parseTree=e.parse=e.getLocation=e.createScanner=e.ParseOptions=e.ParseErrorCode=e.SyntaxKind=e.ScanError=void 0;var c;(function(l){l[l.None=0]="None",l[l.UnexpectedEndOfComment=1]="UnexpectedEndOfComment",l[l.UnexpectedEndOfString=2]="UnexpectedEndOfString",l[l.UnexpectedEndOfNumber=3]="UnexpectedEndOfNumber",l[l.InvalidUnicode=4]="InvalidUnicode",l[l.InvalidEscapeCharacter=5]="InvalidEscapeCharacter",l[l.InvalidCharacter=6]="InvalidCharacter"})(c=e.ScanError||(e.ScanError={}));var F;(function(l){l[l.OpenBraceToken=1]="OpenBraceToken",l[l.CloseBraceToken=2]="CloseBraceToken",l[l.OpenBracketToken=3]="OpenBracketToken",l[l.CloseBracketToken=4]="CloseBracketToken",l[l.CommaToken=5]="CommaToken",l[l.ColonToken=6]="ColonToken",l[l.NullKeyword=7]="NullKeyword",l[l.TrueKeyword=8]="TrueKeyword",l[l.FalseKeyword=9]="FalseKeyword",l[l.StringLiteral=10]="StringLiteral",l[l.NumericLiteral=11]="NumericLiteral",l[l.LineCommentTrivia=12]="LineCommentTrivia",l[l.BlockCommentTrivia=13]="BlockCommentTrivia",l[l.LineBreakTrivia=14]="LineBreakTrivia",l[l.Trivia=15]="Trivia",l[l.Unknown=16]="Unknown",l[l.EOF=17]="EOF"})(F=e.SyntaxKind||(e.SyntaxKind={}));var w;(function(l){l[l.InvalidSymbol=1]="InvalidSymbol",l[l.InvalidNumberFormat=2]="InvalidNumberFormat",l[l.PropertyNameExpected=3]="PropertyNameExpected",l[l.ValueExpected=4]="ValueExpected",l[l.ColonExpected=5]="ColonExpected",l[l.CommaExpected=6]="CommaExpected",l[l.CloseBraceExpected=7]="CloseBraceExpected",l[l.CloseBracketExpected=8]="CloseBracketExpected",l[l.EndOfFileExpected=9]="EndOfFileExpected",l[l.InvalidCommentToken=10]="InvalidCommentToken",l[l.UnexpectedEndOfComment=11]="UnexpectedEndOfComment",l[l.UnexpectedEndOfString=12]="UnexpectedEndOfString",l[l.UnexpectedEndOfNumber=13]="UnexpectedEndOfNumber",l[l.InvalidUnicode=14]="InvalidUnicode",l[l.InvalidEscapeCharacter=15]="InvalidEscapeCharacter",l[l.InvalidCharacter=16]="InvalidCharacter"})(w=e.ParseErrorCode||(e.ParseErrorCode={}));var P;(function(l){l.DEFAULT={allowTrailingComma:!0}})(P=e.ParseOptions||(e.ParseOptions={}));function t(l,M=!1){let r=0,i=l.length,p="",f=0,s=16,v=0;function a(x){let N=0,z=0;for(;N<x;){const H=l.charCodeAt(r);if(H>=48&&H<=57)z=z*16+H-48;else if(H>=65&&H<=70)z=z*16+H-65+10;else if(H>=97&&H<=102)z=z*16+H-97+10;else break;r++,N++}return N<x&&(z=-1),z}function E(x){r=x,p="",f=0,s=16,v=0}function I(){const x=r;if(l.charCodeAt(r)===48)r++;else for(r++;r<l.length&&k(l.charCodeAt(r));)r++;if(r<l.length&&l.charCodeAt(r)===46)if(r++,r<l.length&&k(l.charCodeAt(r)))for(r++;r<l.length&&k(l.charCodeAt(r));)r++;else return v=3,l.substring(x,r);let N=r;if(r<l.length&&(l.charCodeAt(r)===69||l.charCodeAt(r)===101))if(r++,(r<l.length&&l.charCodeAt(r)===43||l.charCodeAt(r)===45)&&r++,r<l.length&&k(l.charCodeAt(r))){for(r++;r<l.length&&k(l.charCodeAt(r));)r++;N=r}else v=3;return l.substring(x,N)}function D(){let x="",N=r;for(;;){if(r>=i){x+=l.substring(N,r),v=2;break}const z=l.charCodeAt(r);if(z===34){x+=l.substring(N,r),r++;break}if(z===92){if(x+=l.substring(N,r),r++,r>=i){v=2;break}switch(l.charCodeAt(r++)){case 34:x+='"';break;case 92:x+="\\";break;case 47:x+="/";break;case 98:x+="\b";break;case 102:x+="\f";break;case 110:x+=`
`;break;case 114:x+="\r";break;case 116:x+="	";break;case 117:const q=a(4);q>=0?x+=String.fromCharCode(q):v=4;break;default:v=5}N=r;continue}if(z>=0&&z<=31)if(C(z)){x+=l.substring(N,r),v=2;break}else v=6;r++}return x}function B(){if(p="",v=0,f=r,r>=i)return f=i,s=17;let x=l.charCodeAt(r);if(T(x)){do r++,p+=String.fromCharCode(x),x=l.charCodeAt(r);while(T(x));return s=15}if(C(x))return r++,p+=String.fromCharCode(x),x===13&&l.charCodeAt(r)===10&&(r++,p+=`
`),s=14;switch(x){case 123:return r++,s=1;case 125:return r++,s=2;case 91:return r++,s=3;case 93:return r++,s=4;case 58:return r++,s=6;case 44:return r++,s=5;case 34:return r++,p=D(),s=10;case 47:const N=r-1;if(l.charCodeAt(r+1)===47){for(r+=2;r<i&&!C(l.charCodeAt(r));)r++;return p=l.substring(N,r),s=12}if(l.charCodeAt(r+1)===42){r+=2;const z=i-1;let H=!1;for(;r<z;){if(l.charCodeAt(r)===42&&l.charCodeAt(r+1)===47){r+=2,H=!0;break}r++}return H||(r++,v=1),p=l.substring(N,r),s=13}return p+=String.fromCharCode(x),r++,s=16;case 45:if(p+=String.fromCharCode(x),r++,r===i||!k(l.charCodeAt(r)))return s=16;case 48:case 49:case 50:case 51:case 52:case 53:case 54:case 55:case 56:case 57:return p+=I(),s=11;default:for(;r<i&&L(x);)r++,x=l.charCodeAt(r);if(f!==r){switch(p=l.substring(f,r),p){case"true":return s=8;case"false":return s=9;case"null":return s=7}return s=16}return p+=String.fromCharCode(x),r++,s=16}}function L(x){if(T(x)||C(x))return!1;switch(x){case 125:case 93:case 123:case 91:case 34:case 58:case 44:case 47:return!1}return!0}function y(){let x;do x=B();while(x>=12&&x<=15);return x}return{setPosition:E,getPosition:()=>r,scan:M?y:B,getToken:()=>s,getTokenValue:()=>p,getTokenOffset:()=>f,getTokenLength:()=>r-f,getTokenError:()=>v}}e.createScanner=t;function T(l){return l===32||l===9||l===11||l===12||l===160||l===5760||l>=8192&&l<=8203||l===8239||l===8287||l===12288||l===65279}function C(l){return l===10||l===13||l===8232||l===8233}function k(l){return l>=48&&l<=57}var R;(function(l){l[l.nullCharacter=0]="nullCharacter",l[l.maxAsciiCharacter=127]="maxAsciiCharacter",l[l.lineFeed=10]="lineFeed",l[l.carriageReturn=13]="carriageReturn",l[l.lineSeparator=8232]="lineSeparator",l[l.paragraphSeparator=8233]="paragraphSeparator",l[l.nextLine=133]="nextLine",l[l.space=32]="space",l[l.nonBreakingSpace=160]="nonBreakingSpace",l[l.enQuad=8192]="enQuad",l[l.emQuad=8193]="emQuad",l[l.enSpace=8194]="enSpace",l[l.emSpace=8195]="emSpace",l[l.threePerEmSpace=8196]="threePerEmSpace",l[l.fourPerEmSpace=8197]="fourPerEmSpace",l[l.sixPerEmSpace=8198]="sixPerEmSpace",l[l.figureSpace=8199]="figureSpace",l[l.punctuationSpace=8200]="punctuationSpace",l[l.thinSpace=8201]="thinSpace",l[l.hairSpace=8202]="hairSpace",l[l.zeroWidthSpace=8203]="zeroWidthSpace",l[l.narrowNoBreakSpace=8239]="narrowNoBreakSpace",l[l.ideographicSpace=12288]="ideographicSpace",l[l.mathematicalSpace=8287]="mathematicalSpace",l[l.ogham=5760]="ogham",l[l._=95]="_",l[l.$=36]="$",l[l._0=48]="_0",l[l._1=49]="_1",l[l._2=50]="_2",l[l._3=51]="_3",l[l._4=52]="_4",l[l._5=53]="_5",l[l._6=54]="_6",l[l._7=55]="_7",l[l._8=56]="_8",l[l._9=57]="_9",l[l.a=97]="a",l[l.b=98]="b",l[l.c=99]="c",l[l.d=100]="d",l[l.e=101]="e",l[l.f=102]="f",l[l.g=103]="g",l[l.h=104]="h",l[l.i=105]="i",l[l.j=106]="j",l[l.k=107]="k",l[l.l=108]="l",l[l.m=109]="m",l[l.n=110]="n",l[l.o=111]="o",l[l.p=112]="p",l[l.q=113]="q",l[l.r=114]="r",l[l.s=115]="s",l[l.t=116]="t",l[l.u=117]="u",l[l.v=118]="v",l[l.w=119]="w",l[l.x=120]="x",l[l.y=121]="y",l[l.z=122]="z",l[l.A=65]="A",l[l.B=66]="B",l[l.C=67]="C",l[l.D=68]="D",l[l.E=69]="E",l[l.F=70]="F",l[l.G=71]="G",l[l.H=72]="H",l[l.I=73]="I",l[l.J=74]="J",l[l.K=75]="K",l[l.L=76]="L",l[l.M=77]="M",l[l.N=78]="N",l[l.O=79]="O",l[l.P=80]="P",l[l.Q=81]="Q",l[l.R=82]="R",l[l.S=83]="S",l[l.T=84]="T",l[l.U=85]="U",l[l.V=86]="V",l[l.W=87]="W",l[l.X=88]="X",l[l.Y=89]="Y",l[l.Z=90]="Z",l[l.ampersand=38]="ampersand",l[l.asterisk=42]="asterisk",l[l.at=64]="at",l[l.backslash=92]="backslash",l[l.bar=124]="bar",l[l.caret=94]="caret",l[l.closeBrace=125]="closeBrace",l[l.closeBracket=93]="closeBracket",l[l.closeParen=41]="closeParen",l[l.colon=58]="colon",l[l.comma=44]="comma",l[l.dot=46]="dot",l[l.doubleQuote=34]="doubleQuote",l[l.equals=61]="equals",l[l.exclamation=33]="exclamation",l[l.greaterThan=62]="greaterThan",l[l.lessThan=60]="lessThan",l[l.minus=45]="minus",l[l.openBrace=123]="openBrace",l[l.openBracket=91]="openBracket",l[l.openParen=40]="openParen",l[l.percent=37]="percent",l[l.plus=43]="plus",l[l.question=63]="question",l[l.semicolon=59]="semicolon",l[l.singleQuote=39]="singleQuote",l[l.slash=47]="slash",l[l.tilde=126]="tilde",l[l.backspace=8]="backspace",l[l.formFeed=12]="formFeed",l[l.byteOrderMark=65279]="byteOrderMark",l[l.tab=9]="tab",l[l.verticalTab=11]="verticalTab"})(R||(R={}));function _(l,M){const r=[],i=new Object;let p;const f={value:{},offset:0,length:0,type:"object",parent:void 0};let s=!1;function v(a,E,I,D){f.value=a,f.offset=E,f.length=I,f.type=D,f.colonOffset=void 0,p=f}try{h(l,{onObjectBegin:(a,E)=>{if(M<=a)throw i;p=void 0,s=M>a,r.push("")},onObjectProperty:(a,E,I)=>{if(M<E||(v(a,E,I,"property"),r[r.length-1]=a,M<=E+I))throw i},onObjectEnd:(a,E)=>{if(M<=a)throw i;p=void 0,r.pop()},onArrayBegin:(a,E)=>{if(M<=a)throw i;p=void 0,r.push(0)},onArrayEnd:(a,E)=>{if(M<=a)throw i;p=void 0,r.pop()},onLiteralValue:(a,E,I)=>{if(M<E||(v(a,E,I,A(a)),M<=E+I))throw i},onSeparator:(a,E,I)=>{if(M<=E)throw i;if(a===":"&&p&&p.type==="property")p.colonOffset=E,s=!1,p=void 0;else if(a===","){const D=r[r.length-1];typeof D=="number"?r[r.length-1]=D+1:(s=!0,r[r.length-1]=""),p=void 0}}})}catch(a){if(a!==i)throw a}return{path:r,previousNode:p,isAtPropertyKey:s,matches:a=>{let E=0;for(let I=0;E<a.length&&I<r.length;I++)if(a[E]===r[I]||a[E]==="*")E++;else if(a[E]!=="**")return!1;return E===a.length}}}e.getLocation=_;function n(l,M=[],r=P.DEFAULT){let i=null,p=[];const f=[];function s(a){Array.isArray(p)?p.push(a):i!==null&&(p[i]=a)}return h(l,{onObjectBegin:()=>{const a={};s(a),f.push(p),p=a,i=null},onObjectProperty:a=>{i=a},onObjectEnd:()=>{p=f.pop()},onArrayBegin:()=>{const a=[];s(a),f.push(p),p=a,i=null},onArrayEnd:()=>{p=f.pop()},onLiteralValue:s,onError:(a,E,I)=>{M.push({error:a,offset:E,length:I})}},r),p[0]}e.parse=n;function m(l,M=[],r=P.DEFAULT){let i={type:"array",offset:-1,length:-1,children:[],parent:void 0};function p(a){i.type==="property"&&(i.length=a-i.offset,i=i.parent)}function f(a){return i.children.push(a),a}h(l,{onObjectBegin:a=>{i=f({type:"object",offset:a,length:-1,parent:i,children:[]})},onObjectProperty:(a,E,I)=>{i=f({type:"property",offset:E,length:-1,parent:i,children:[]}),i.children.push({type:"string",value:a,offset:E,length:I,parent:i})},onObjectEnd:(a,E)=>{i.length=a+E-i.offset,i=i.parent,p(a+E)},onArrayBegin:(a,E)=>{i=f({type:"array",offset:a,length:-1,parent:i,children:[]})},onArrayEnd:(a,E)=>{i.length=a+E-i.offset,i=i.parent,p(a+E)},onLiteralValue:(a,E,I)=>{f({type:A(a),offset:E,length:I,parent:i,value:a}),p(E+I)},onSeparator:(a,E,I)=>{i.type==="property"&&(a===":"?i.colonOffset=E:a===","&&p(E))},onError:(a,E,I)=>{M.push({error:a,offset:E,length:I})}},r);const v=i.children[0];return v&&delete v.parent,v}e.parseTree=m;function o(l,M){if(!l)return;let r=l;for(let i of M)if(typeof i=="string"){if(r.type!=="object"||!Array.isArray(r.children))return;let p=!1;for(const f of r.children)if(Array.isArray(f.children)&&f.children[0].value===i){r=f.children[1],p=!0;break}if(!p)return}else{const p=i;if(r.type!=="array"||p<0||!Array.isArray(r.children)||p>=r.children.length)return;r=r.children[p]}return r}e.findNodeAtLocation=o;function d(l){if(!l.parent||!l.parent.children)return[];const M=d(l.parent);if(l.parent.type==="property"){const r=l.parent.children[0].value;M.push(r)}else if(l.parent.type==="array"){const r=l.parent.children.indexOf(l);r!==-1&&M.push(r)}return M}e.getNodePath=d;function u(l){switch(l.type){case"array":return l.children.map(u);case"object":const M=Object.create(null);for(let r of l.children){const i=r.children[1];i&&(M[r.children[0].value]=u(i))}return M;case"null":case"string":case"number":case"boolean":return l.value;default:return}}e.getNodeValue=u;function S(l,M,r=!1){return M>=l.offset&&M<l.offset+l.length||r&&M===l.offset+l.length}e.contains=S;function b(l,M,r=!1){if(S(l,M,r)){const i=l.children;if(Array.isArray(i))for(let p=0;p<i.length&&i[p].offset<=M;p++){const f=b(i[p],M,r);if(f)return f}return l}}e.findNodeAtOffset=b;function h(l,M,r=P.DEFAULT){const i=t(l,!1);function p(ie){return ie?()=>ie(i.getTokenOffset(),i.getTokenLength()):()=>!0}function f(ie){return ie?we=>ie(we,i.getTokenOffset(),i.getTokenLength()):()=>!0}const s=p(M.onObjectBegin),v=f(M.onObjectProperty),a=p(M.onObjectEnd),E=p(M.onArrayBegin),I=p(M.onArrayEnd),D=f(M.onLiteralValue),B=f(M.onSeparator),L=p(M.onComment),y=f(M.onError),x=r&&r.disallowComments,N=r&&r.allowTrailingComma;function z(){for(;;){const ie=i.scan();switch(i.getTokenError()){case 4:H(14);break;case 5:H(15);break;case 3:H(13);break;case 1:x||H(11);break;case 2:H(12);break;case 6:H(16);break}switch(ie){case 12:case 13:x?H(10):L();break;case 16:H(1);break;case 15:case 14:break;default:return ie}}}function H(ie,we=[],Me=[]){if(y(ie),we.length+Me.length>0){let Re=i.getToken();for(;Re!==17;){if(we.indexOf(Re)!==-1){z();break}else if(Me.indexOf(Re)!==-1)break;Re=z()}}}function q(ie){const we=i.getTokenValue();return ie?D(we):v(we),z(),!0}function ue(){switch(i.getToken()){case 11:let ie=0;try{ie=JSON.parse(i.getTokenValue()),typeof ie!="number"&&(H(2),ie=0)}catch(we){H(2)}D(ie);break;case 7:D(null);break;case 8:D(!0);break;case 9:D(!1);break;default:return!1}return z(),!0}function K(){return i.getToken()!==10?(H(3,[],[2,5]),!1):(q(!1),i.getToken()===6?(B(":"),z(),Y()||H(4,[],[2,5])):H(5,[],[2,5]),!0)}function ce(){s(),z();let ie=!1;for(;i.getToken()!==2&&i.getToken()!==17;){if(i.getToken()===5){if(ie||H(4,[],[]),B(","),z(),i.getToken()===2&&N)break}else ie&&H(6,[],[]);K()||H(4,[],[2,5]),ie=!0}return a(),i.getToken()!==2?H(7,[2],[]):z(),!0}function de(){E(),z();let ie=!1;for(;i.getToken()!==4&&i.getToken()!==17;){if(i.getToken()===5){if(ie||H(4,[],[]),B(","),z(),i.getToken()===4&&N)break}else ie&&H(6,[],[]);Y()||H(4,[],[4,5]),ie=!0}return I(),i.getToken()!==4?H(8,[4],[]):z(),!0}function Y(){switch(i.getToken()){case 3:return de();case 1:return ce();case 10:return q(!0);default:return ue()}}return z(),i.getToken()===17?r.allowEmptyContent?!0:(H(4,[],[]),!1):Y()?(i.getToken()!==17&&H(9,[],[]),!0):(H(4,[],[]),!1)}e.visit=h;function g(l,M){let r=t(l),i=[],p,f=0,s;do switch(s=r.getPosition(),p=r.scan(),p){case 12:case 13:case 17:f!==s&&i.push(l.substring(f,s)),M!==void 0&&i.push(r.getTokenValue().replace(/[^\r\n]/g,M)),f=r.getPosition();break}while(p!==17);return i.join("")}e.stripComments=g;function A(l){switch(typeof l){case"boolean":return"boolean";case"number":return"number";case"string":return"string";case"object":{if(l){if(Array.isArray(l))return"array"}else return"null";return"object"}default:return"null"}}e.getNodeType=A}),define(Ee[101],_e([0,1]),function(re,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Lazy=void 0;class c{constructor(w){this.executor=w,this._didRun=!1}hasValue(){return this._didRun}getValue(){if(!this._didRun)try{this._value=this.executor()}catch(w){this._error=w}finally{this._didRun=!0}if(this._error)throw this._error;return this._value}get rawValue(){return this._value}map(w){return new c(()=>w(this.getValue()))}}e.Lazy=c}),function(re,e){typeof exports=="object"&&typeof module!="undefined"?module.exports=e():typeof define=="function"&&define.amd?define("vs/base/common/marked/marked",e):(re=typeof globalThis!="undefined"?globalThis:re||self,re.marked=e())}(this,function(){"use strict";function re(Ie,Se){for(var ve=0;ve<Se.length;ve++){var oe=Se[ve];oe.enumerable=oe.enumerable||!1,oe.configurable=!0,"value"in oe&&(oe.writable=!0),Object.defineProperty(Ie,oe.key,oe)}}function e(Ie,Se,ve){return Se&&re(Ie.prototype,Se),ve&&re(Ie,ve),Ie}function c(Ie,Se){if(!!Ie){if(typeof Ie=="string")return F(Ie,Se);var ve=Object.prototype.toString.call(Ie).slice(8,-1);if(ve==="Object"&&Ie.constructor&&(ve=Ie.constructor.name),ve==="Map"||ve==="Set")return Array.from(Ie);if(ve==="Arguments"||/^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(ve))return F(Ie,Se)}}function F(Ie,Se){(Se==null||Se>Ie.length)&&(Se=Ie.length);for(var ve=0,oe=new Array(Se);ve<Se;ve++)oe[ve]=Ie[ve];return oe}function w(Ie,Se){var ve=typeof Symbol!="undefined"&&Ie[Symbol.iterator]||Ie["@@iterator"];if(ve)return(ve=ve.call(Ie)).next.bind(ve);if(Array.isArray(Ie)||(ve=c(Ie))||Se&&Ie&&typeof Ie.length=="number"){ve&&(Ie=ve);var oe=0;return function(){return oe>=Ie.length?{done:!0}:{done:!1,value:Ie[oe++]}}}throw new TypeError(`Invalid attempt to iterate non-iterable instance.
In order to be iterable, non-array objects must have a [Symbol.iterator]() method.`)}var P={exports:{}};function t(){return{baseUrl:null,breaks:!1,extensions:null,gfm:!0,headerIds:!0,headerPrefix:"",highlight:null,langPrefix:"language-",mangle:!0,pedantic:!1,renderer:null,sanitize:!1,sanitizer:null,silent:!1,smartLists:!1,smartypants:!1,tokenizer:null,walkTokens:null,xhtml:!1}}function T(Ie){P.exports.defaults=Ie}P.exports={defaults:t(),getDefaults:t,changeDefaults:T};var C=/[&<>"']/,k=/[&<>"']/g,R=/[<>"']|&(?!#?\w+;)/,_=/[<>"']|&(?!#?\w+;)/g,n={"&":"&amp;","<":"&lt;",">":"&gt;",'"':"&quot;","'":"&#39;"},m=function(Se){return n[Se]};function o(Ie,Se){if(Se){if(C.test(Ie))return Ie.replace(k,m)}else if(R.test(Ie))return Ie.replace(_,m);return Ie}var d=/&(#(?:\d+)|(?:#x[0-9A-Fa-f]+)|(?:\w+));?/ig;function u(Ie){return Ie.replace(d,function(Se,ve){return ve=ve.toLowerCase(),ve==="colon"?":":ve.charAt(0)==="#"?ve.charAt(1)==="x"?String.fromCharCode(parseInt(ve.substring(2),16)):String.fromCharCode(+ve.substring(1)):""})}var S=/(^|[^\[])\^/g;function b(Ie,Se){Ie=Ie.source||Ie,Se=Se||"";var ve={replace:function(se,fe){return fe=fe.source||fe,fe=fe.replace(S,"$1"),Ie=Ie.replace(se,fe),ve},getRegex:function(){return new RegExp(Ie,Se)}};return ve}var h=/[^\w:]/g,g=/^$|^[a-z][a-z0-9+.-]*:|^[?#]/i;function A(Ie,Se,ve){if(Ie){var oe;try{oe=decodeURIComponent(u(ve)).replace(h,"").toLowerCase()}catch(se){return null}if(oe.indexOf("javascript:")===0||oe.indexOf("vbscript:")===0||oe.indexOf("data:")===0)return null}Se&&!g.test(ve)&&(ve=p(Se,ve));try{ve=encodeURI(ve).replace(/%25/g,"%")}catch(se){return null}return ve}var l={},M=/^[^:]+:\/*[^/]*$/,r=/^([^:]+:)[\s\S]*$/,i=/^([^:]+:\/*[^/]*)[\s\S]*$/;function p(Ie,Se){l[" "+Ie]||(M.test(Ie)?l[" "+Ie]=Ie+"/":l[" "+Ie]=a(Ie,"/",!0)),Ie=l[" "+Ie];var ve=Ie.indexOf(":")===-1;return Se.substring(0,2)==="//"?ve?Se:Ie.replace(r,"$1")+Se:Se.charAt(0)==="/"?ve?Se:Ie.replace(i,"$1")+Se:Ie+Se}var f={exec:function(){}};function s(Ie){for(var Se=1,ve,oe;Se<arguments.length;Se++){ve=arguments[Se];for(oe in ve)Object.prototype.hasOwnProperty.call(ve,oe)&&(Ie[oe]=ve[oe])}return Ie}function v(Ie,Se){var ve=Ie.replace(/\|/g,function(fe,ge,ke){for(var ze=!1,Oe=ge;--Oe>=0&&ke[Oe]==="\\";)ze=!ze;return ze?"|":" |"}),oe=ve.split(/ \|/),se=0;if(oe[0].trim()||oe.shift(),oe[oe.length-1].trim()||oe.pop(),oe.length>Se)oe.splice(Se);else for(;oe.length<Se;)oe.push("");for(;se<oe.length;se++)oe[se]=oe[se].trim().replace(/\\\|/g,"|");return oe}function a(Ie,Se,ve){var oe=Ie.length;if(oe===0)return"";for(var se=0;se<oe;){var fe=Ie.charAt(oe-se-1);if(fe===Se&&!ve)se++;else if(fe!==Se&&ve)se++;else break}return Ie.substr(0,oe-se)}function E(Ie,Se){if(Ie.indexOf(Se[1])===-1)return-1;for(var ve=Ie.length,oe=0,se=0;se<ve;se++)if(Ie[se]==="\\")se++;else if(Ie[se]===Se[0])oe++;else if(Ie[se]===Se[1]&&(oe--,oe<0))return se;return-1}function I(Ie){Ie&&Ie.sanitize&&!Ie.silent&&console.warn("marked(): sanitize and sanitizer parameters are deprecated since version 0.7.0, should not be used and will be removed in the future. Read more here: https://marked.js.org/#/USING_ADVANCED.md#options")}function D(Ie,Se){if(Se<1)return"";for(var ve="";Se>1;)Se&1&&(ve+=Ie),Se>>=1,Ie+=Ie;return ve+Ie}var B={escape:o,unescape:u,edit:b,cleanUrl:A,resolveUrl:p,noopTest:f,merge:s,splitCells:v,rtrim:a,findClosingBracket:E,checkSanitizeDeprecation:I,repeatString:D},L=P.exports.defaults,y=B.rtrim,x=B.splitCells,N=B.escape,z=B.findClosingBracket;function H(Ie,Se,ve,oe){var se=Se.href,fe=Se.title?N(Se.title):null,ge=Ie[1].replace(/\\([\[\]])/g,"$1");if(Ie[0].charAt(0)!=="!"){oe.state.inLink=!0;var ke={type:"link",raw:ve,href:se,title:fe,text:ge,tokens:oe.inlineTokens(ge,[])};return oe.state.inLink=!1,ke}else return{type:"image",raw:ve,href:se,title:fe,text:N(ge)}}function q(Ie,Se){var ve=Ie.match(/^(\s+)(?:```)/);if(ve===null)return Se;var oe=ve[1];return Se.split(`
`).map(function(se){var fe=se.match(/^\s+/);if(fe===null)return se;var ge=fe[0];return ge.length>=oe.length?se.slice(oe.length):se}).join(`
`)}var ue=function(){function Ie(ve){this.options=ve||L}var Se=Ie.prototype;return Se.space=function(oe){var se=this.rules.block.newline.exec(oe);if(se)return se[0].length>1?{type:"space",raw:se[0]}:{raw:`
`}},Se.code=function(oe){var se=this.rules.block.code.exec(oe);if(se){var fe=se[0].replace(/^ {1,4}/gm,"");return{type:"code",raw:se[0],codeBlockStyle:"indented",text:this.options.pedantic?fe:y(fe,`
`)}}},Se.fences=function(oe){var se=this.rules.block.fences.exec(oe);if(se){var fe=se[0],ge=q(fe,se[3]||"");return{type:"code",raw:fe,lang:se[2]?se[2].trim():se[2],text:ge}}},Se.heading=function(oe){var se=this.rules.block.heading.exec(oe);if(se){var fe=se[2].trim();if(/#$/.test(fe)){var ge=y(fe,"#");(this.options.pedantic||!ge||/ $/.test(ge))&&(fe=ge.trim())}var ke={type:"heading",raw:se[0],depth:se[1].length,text:fe,tokens:[]};return this.lexer.inline(ke.text,ke.tokens),ke}},Se.hr=function(oe){var se=this.rules.block.hr.exec(oe);if(se)return{type:"hr",raw:se[0]}},Se.blockquote=function(oe){var se=this.rules.block.blockquote.exec(oe);if(se){var fe=se[0].replace(/^ *> ?/gm,"");return{type:"blockquote",raw:se[0],tokens:this.lexer.blockTokens(fe,[]),text:fe}}},Se.list=function(oe){var se=this.rules.block.list.exec(oe);if(se){var fe,ge,ke,ze,Oe,Ve,it,rt,ne,pe,ee=se[1].trim(),W=ee.length>1,be={type:"list",raw:"",ordered:W,start:W?+ee.slice(0,-1):"",loose:!1,items:[]};ee=W?"\\d{1,9}\\"+ee.slice(-1):"\\"+ee,this.options.pedantic&&(ee=W?ee:"[*+-]");for(var De=new RegExp("^( {0,3}"+ee+")((?: [^\\n]*| *)(?:\\n[^\\n]*)*(?:\\n|$))");oe&&!(this.rules.block.hr.test(oe)||!(se=De.exec(oe)));){ne=se[2].split(`
`),this.options.pedantic?(ze=2,pe=ne[0].trimLeft()):(ze=se[2].search(/[^ ]/),ze=se[1].length+(ze>4?1:ze),pe=ne[0].slice(ze-se[1].length)),Ve=!1,fe=se[0],!ne[0]&&/^ *$/.test(ne[1])&&(fe=se[1]+ne.slice(0,2).join(`
`)+`
`,be.loose=!0,ne=[]);var qe=new RegExp("^ {0,"+Math.min(3,ze-1)+"}(?:[*+-]|\\d{1,9}[.)])");for(Oe=1;Oe<ne.length;Oe++){if(rt=ne[Oe],this.options.pedantic&&(rt=rt.replace(/^ {1,4}(?=( {4})*[^ ])/g,"  ")),qe.test(rt)){fe=se[1]+ne.slice(0,Oe).join(`
`)+`
`;break}if(!Ve){rt.trim()||(Ve=!0),rt.search(/[^ ]/)>=ze?pe+=`
`+rt.slice(ze):pe+=`
`+rt;continue}if(rt.search(/[^ ]/)>=ze||!rt.trim()){pe+=`
`+rt.slice(ze);continue}else{fe=se[1]+ne.slice(0,Oe).join(`
`)+`
`;break}}be.loose||(it?be.loose=!0:/\n *\n *$/.test(fe)&&(it=!0)),this.options.gfm&&(ge=/^\[[ xX]\] /.exec(pe),ge&&(ke=ge[0]!=="[ ] ",pe=pe.replace(/^\[[ xX]\] +/,""))),be.items.push({type:"list_item",raw:fe,task:!!ge,checked:ke,loose:!1,text:pe}),be.raw+=fe,oe=oe.slice(fe.length)}be.items[be.items.length-1].raw=fe.trimRight(),be.items[be.items.length-1].text=pe.trimRight(),be.raw=be.raw.trimRight();var xe=be.items.length;for(Oe=0;Oe<xe;Oe++)this.lexer.state.top=!1,be.items[Oe].tokens=this.lexer.blockTokens(be.items[Oe].text,[]),be.items[Oe].tokens.some(function(ut){return ut.type==="space"})&&(be.loose=!0,be.items[Oe].loose=!0);return be}},Se.html=function(oe){var se=this.rules.block.html.exec(oe);if(se){var fe={type:"html",raw:se[0],pre:!this.options.sanitizer&&(se[1]==="pre"||se[1]==="script"||se[1]==="style"),text:se[0]};return this.options.sanitize&&(fe.type="paragraph",fe.text=this.options.sanitizer?this.options.sanitizer(se[0]):N(se[0]),fe.tokens=[],this.lexer.inline(fe.text,fe.tokens)),fe}},Se.def=function(oe){var se=this.rules.block.def.exec(oe);if(se){se[3]&&(se[3]=se[3].substring(1,se[3].length-1));var fe=se[1].toLowerCase().replace(/\s+/g," ");return{type:"def",tag:fe,raw:se[0],href:se[2],title:se[3]}}},Se.table=function(oe){var se=this.rules.block.table.exec(oe);if(se){var fe={type:"table",header:x(se[1]).map(function(it){return{text:it}}),align:se[2].replace(/^ *|\| *$/g,"").split(/ *\| */),rows:se[3]?se[3].replace(/\n$/,"").split(`
`):[]};if(fe.header.length===fe.align.length){fe.raw=se[0];var ge=fe.align.length,ke,ze,Oe,Ve;for(ke=0;ke<ge;ke++)/^ *-+: *$/.test(fe.align[ke])?fe.align[ke]="right":/^ *:-+: *$/.test(fe.align[ke])?fe.align[ke]="center":/^ *:-+ *$/.test(fe.align[ke])?fe.align[ke]="left":fe.align[ke]=null;for(ge=fe.rows.length,ke=0;ke<ge;ke++)fe.rows[ke]=x(fe.rows[ke],fe.header.length).map(function(it){return{text:it}});for(ge=fe.header.length,ze=0;ze<ge;ze++)fe.header[ze].tokens=[],this.lexer.inlineTokens(fe.header[ze].text,fe.header[ze].tokens);for(ge=fe.rows.length,ze=0;ze<ge;ze++)for(Ve=fe.rows[ze],Oe=0;Oe<Ve.length;Oe++)Ve[Oe].tokens=[],this.lexer.inlineTokens(Ve[Oe].text,Ve[Oe].tokens);return fe}}},Se.lheading=function(oe){var se=this.rules.block.lheading.exec(oe);if(se){var fe={type:"heading",raw:se[0],depth:se[2].charAt(0)==="="?1:2,text:se[1],tokens:[]};return this.lexer.inline(fe.text,fe.tokens),fe}},Se.paragraph=function(oe){var se=this.rules.block.paragraph.exec(oe);if(se){var fe={type:"paragraph",raw:se[0],text:se[1].charAt(se[1].length-1)===`
`?se[1].slice(0,-1):se[1],tokens:[]};return this.lexer.inline(fe.text,fe.tokens),fe}},Se.text=function(oe){var se=this.rules.block.text.exec(oe);if(se){var fe={type:"text",raw:se[0],text:se[0],tokens:[]};return this.lexer.inline(fe.text,fe.tokens),fe}},Se.escape=function(oe){var se=this.rules.inline.escape.exec(oe);if(se)return{type:"escape",raw:se[0],text:N(se[1])}},Se.tag=function(oe){var se=this.rules.inline.tag.exec(oe);if(se)return!this.lexer.state.inLink&&/^<a /i.test(se[0])?this.lexer.state.inLink=!0:this.lexer.state.inLink&&/^<\/a>/i.test(se[0])&&(this.lexer.state.inLink=!1),!this.lexer.state.inRawBlock&&/^<(pre|code|kbd|script)(\s|>)/i.test(se[0])?this.lexer.state.inRawBlock=!0:this.lexer.state.inRawBlock&&/^<\/(pre|code|kbd|script)(\s|>)/i.test(se[0])&&(this.lexer.state.inRawBlock=!1),{type:this.options.sanitize?"text":"html",raw:se[0],inLink:this.lexer.state.inLink,inRawBlock:this.lexer.state.inRawBlock,text:this.options.sanitize?this.options.sanitizer?this.options.sanitizer(se[0]):N(se[0]):se[0]}},Se.link=function(oe){var se=this.rules.inline.link.exec(oe);if(se){var fe=se[2].trim();if(!this.options.pedantic&&/^</.test(fe)){if(!/>$/.test(fe))return;var ge=y(fe.slice(0,-1),"\\");if((fe.length-ge.length)%2==0)return}else{var ke=z(se[2],"()");if(ke>-1){var ze=se[0].indexOf("!")===0?5:4,Oe=ze+se[1].length+ke;se[2]=se[2].substring(0,ke),se[0]=se[0].substring(0,Oe).trim(),se[3]=""}}var Ve=se[2],it="";if(this.options.pedantic){var rt=/^([^'"]*[^\s])\s+(['"])(.*)\2/.exec(Ve);rt&&(Ve=rt[1],it=rt[3])}else it=se[3]?se[3].slice(1,-1):"";return Ve=Ve.trim(),/^</.test(Ve)&&(this.options.pedantic&&!/>$/.test(fe)?Ve=Ve.slice(1):Ve=Ve.slice(1,-1)),H(se,{href:Ve&&Ve.replace(this.rules.inline._escapes,"$1"),title:it&&it.replace(this.rules.inline._escapes,"$1")},se[0],this.lexer)}},Se.reflink=function(oe,se){var fe;if((fe=this.rules.inline.reflink.exec(oe))||(fe=this.rules.inline.nolink.exec(oe))){var ge=(fe[2]||fe[1]).replace(/\s+/g," ");if(ge=se[ge.toLowerCase()],!ge||!ge.href){var ke=fe[0].charAt(0);return{type:"text",raw:ke,text:ke}}return H(fe,ge,fe[0],this.lexer)}},Se.emStrong=function(oe,se,fe){fe===void 0&&(fe="");var ge=this.rules.inline.emStrong.lDelim.exec(oe);if(!!ge&&!(ge[3]&&fe.match(/(?:[0-9A-Za-z\xAA\xB2\xB3\xB5\xB9\xBA\xBC-\xBE\xC0-\xD6\xD8-\xF6\xF8-\u02C1\u02C6-\u02D1\u02E0-\u02E4\u02EC\u02EE\u0370-\u0374\u0376\u0377\u037A-\u037D\u037F\u0386\u0388-\u038A\u038C\u038E-\u03A1\u03A3-\u03F5\u03F7-\u0481\u048A-\u052F\u0531-\u0556\u0559\u0560-\u0588\u05D0-\u05EA\u05EF-\u05F2\u0620-\u064A\u0660-\u0669\u066E\u066F\u0671-\u06D3\u06D5\u06E5\u06E6\u06EE-\u06FC\u06FF\u0710\u0712-\u072F\u074D-\u07A5\u07B1\u07C0-\u07EA\u07F4\u07F5\u07FA\u0800-\u0815\u081A\u0824\u0828\u0840-\u0858\u0860-\u086A\u08A0-\u08B4\u08B6-\u08C7\u0904-\u0939\u093D\u0950\u0958-\u0961\u0966-\u096F\u0971-\u0980\u0985-\u098C\u098F\u0990\u0993-\u09A8\u09AA-\u09B0\u09B2\u09B6-\u09B9\u09BD\u09CE\u09DC\u09DD\u09DF-\u09E1\u09E6-\u09F1\u09F4-\u09F9\u09FC\u0A05-\u0A0A\u0A0F\u0A10\u0A13-\u0A28\u0A2A-\u0A30\u0A32\u0A33\u0A35\u0A36\u0A38\u0A39\u0A59-\u0A5C\u0A5E\u0A66-\u0A6F\u0A72-\u0A74\u0A85-\u0A8D\u0A8F-\u0A91\u0A93-\u0AA8\u0AAA-\u0AB0\u0AB2\u0AB3\u0AB5-\u0AB9\u0ABD\u0AD0\u0AE0\u0AE1\u0AE6-\u0AEF\u0AF9\u0B05-\u0B0C\u0B0F\u0B10\u0B13-\u0B28\u0B2A-\u0B30\u0B32\u0B33\u0B35-\u0B39\u0B3D\u0B5C\u0B5D\u0B5F-\u0B61\u0B66-\u0B6F\u0B71-\u0B77\u0B83\u0B85-\u0B8A\u0B8E-\u0B90\u0B92-\u0B95\u0B99\u0B9A\u0B9C\u0B9E\u0B9F\u0BA3\u0BA4\u0BA8-\u0BAA\u0BAE-\u0BB9\u0BD0\u0BE6-\u0BF2\u0C05-\u0C0C\u0C0E-\u0C10\u0C12-\u0C28\u0C2A-\u0C39\u0C3D\u0C58-\u0C5A\u0C60\u0C61\u0C66-\u0C6F\u0C78-\u0C7E\u0C80\u0C85-\u0C8C\u0C8E-\u0C90\u0C92-\u0CA8\u0CAA-\u0CB3\u0CB5-\u0CB9\u0CBD\u0CDE\u0CE0\u0CE1\u0CE6-\u0CEF\u0CF1\u0CF2\u0D04-\u0D0C\u0D0E-\u0D10\u0D12-\u0D3A\u0D3D\u0D4E\u0D54-\u0D56\u0D58-\u0D61\u0D66-\u0D78\u0D7A-\u0D7F\u0D85-\u0D96\u0D9A-\u0DB1\u0DB3-\u0DBB\u0DBD\u0DC0-\u0DC6\u0DE6-\u0DEF\u0E01-\u0E30\u0E32\u0E33\u0E40-\u0E46\u0E50-\u0E59\u0E81\u0E82\u0E84\u0E86-\u0E8A\u0E8C-\u0EA3\u0EA5\u0EA7-\u0EB0\u0EB2\u0EB3\u0EBD\u0EC0-\u0EC4\u0EC6\u0ED0-\u0ED9\u0EDC-\u0EDF\u0F00\u0F20-\u0F33\u0F40-\u0F47\u0F49-\u0F6C\u0F88-\u0F8C\u1000-\u102A\u103F-\u1049\u1050-\u1055\u105A-\u105D\u1061\u1065\u1066\u106E-\u1070\u1075-\u1081\u108E\u1090-\u1099\u10A0-\u10C5\u10C7\u10CD\u10D0-\u10FA\u10FC-\u1248\u124A-\u124D\u1250-\u1256\u1258\u125A-\u125D\u1260-\u1288\u128A-\u128D\u1290-\u12B0\u12B2-\u12B5\u12B8-\u12BE\u12C0\u12C2-\u12C5\u12C8-\u12D6\u12D8-\u1310\u1312-\u1315\u1318-\u135A\u1369-\u137C\u1380-\u138F\u13A0-\u13F5\u13F8-\u13FD\u1401-\u166C\u166F-\u167F\u1681-\u169A\u16A0-\u16EA\u16EE-\u16F8\u1700-\u170C\u170E-\u1711\u1720-\u1731\u1740-\u1751\u1760-\u176C\u176E-\u1770\u1780-\u17B3\u17D7\u17DC\u17E0-\u17E9\u17F0-\u17F9\u1810-\u1819\u1820-\u1878\u1880-\u1884\u1887-\u18A8\u18AA\u18B0-\u18F5\u1900-\u191E\u1946-\u196D\u1970-\u1974\u1980-\u19AB\u19B0-\u19C9\u19D0-\u19DA\u1A00-\u1A16\u1A20-\u1A54\u1A80-\u1A89\u1A90-\u1A99\u1AA7\u1B05-\u1B33\u1B45-\u1B4B\u1B50-\u1B59\u1B83-\u1BA0\u1BAE-\u1BE5\u1C00-\u1C23\u1C40-\u1C49\u1C4D-\u1C7D\u1C80-\u1C88\u1C90-\u1CBA\u1CBD-\u1CBF\u1CE9-\u1CEC\u1CEE-\u1CF3\u1CF5\u1CF6\u1CFA\u1D00-\u1DBF\u1E00-\u1F15\u1F18-\u1F1D\u1F20-\u1F45\u1F48-\u1F4D\u1F50-\u1F57\u1F59\u1F5B\u1F5D\u1F5F-\u1F7D\u1F80-\u1FB4\u1FB6-\u1FBC\u1FBE\u1FC2-\u1FC4\u1FC6-\u1FCC\u1FD0-\u1FD3\u1FD6-\u1FDB\u1FE0-\u1FEC\u1FF2-\u1FF4\u1FF6-\u1FFC\u2070\u2071\u2074-\u2079\u207F-\u2089\u2090-\u209C\u2102\u2107\u210A-\u2113\u2115\u2119-\u211D\u2124\u2126\u2128\u212A-\u212D\u212F-\u2139\u213C-\u213F\u2145-\u2149\u214E\u2150-\u2189\u2460-\u249B\u24EA-\u24FF\u2776-\u2793\u2C00-\u2C2E\u2C30-\u2C5E\u2C60-\u2CE4\u2CEB-\u2CEE\u2CF2\u2CF3\u2CFD\u2D00-\u2D25\u2D27\u2D2D\u2D30-\u2D67\u2D6F\u2D80-\u2D96\u2DA0-\u2DA6\u2DA8-\u2DAE\u2DB0-\u2DB6\u2DB8-\u2DBE\u2DC0-\u2DC6\u2DC8-\u2DCE\u2DD0-\u2DD6\u2DD8-\u2DDE\u2E2F\u3005-\u3007\u3021-\u3029\u3031-\u3035\u3038-\u303C\u3041-\u3096\u309D-\u309F\u30A1-\u30FA\u30FC-\u30FF\u3105-\u312F\u3131-\u318E\u3192-\u3195\u31A0-\u31BF\u31F0-\u31FF\u3220-\u3229\u3248-\u324F\u3251-\u325F\u3280-\u3289\u32B1-\u32BF\u3400-\u4DBF\u4E00-\u9FFC\uA000-\uA48C\uA4D0-\uA4FD\uA500-\uA60C\uA610-\uA62B\uA640-\uA66E\uA67F-\uA69D\uA6A0-\uA6EF\uA717-\uA71F\uA722-\uA788\uA78B-\uA7BF\uA7C2-\uA7CA\uA7F5-\uA801\uA803-\uA805\uA807-\uA80A\uA80C-\uA822\uA830-\uA835\uA840-\uA873\uA882-\uA8B3\uA8D0-\uA8D9\uA8F2-\uA8F7\uA8FB\uA8FD\uA8FE\uA900-\uA925\uA930-\uA946\uA960-\uA97C\uA984-\uA9B2\uA9CF-\uA9D9\uA9E0-\uA9E4\uA9E6-\uA9FE\uAA00-\uAA28\uAA40-\uAA42\uAA44-\uAA4B\uAA50-\uAA59\uAA60-\uAA76\uAA7A\uAA7E-\uAAAF\uAAB1\uAAB5\uAAB6\uAAB9-\uAABD\uAAC0\uAAC2\uAADB-\uAADD\uAAE0-\uAAEA\uAAF2-\uAAF4\uAB01-\uAB06\uAB09-\uAB0E\uAB11-\uAB16\uAB20-\uAB26\uAB28-\uAB2E\uAB30-\uAB5A\uAB5C-\uAB69\uAB70-\uABE2\uABF0-\uABF9\uAC00-\uD7A3\uD7B0-\uD7C6\uD7CB-\uD7FB\uF900-\uFA6D\uFA70-\uFAD9\uFB00-\uFB06\uFB13-\uFB17\uFB1D\uFB1F-\uFB28\uFB2A-\uFB36\uFB38-\uFB3C\uFB3E\uFB40\uFB41\uFB43\uFB44\uFB46-\uFBB1\uFBD3-\uFD3D\uFD50-\uFD8F\uFD92-\uFDC7\uFDF0-\uFDFB\uFE70-\uFE74\uFE76-\uFEFC\uFF10-\uFF19\uFF21-\uFF3A\uFF41-\uFF5A\uFF66-\uFFBE\uFFC2-\uFFC7\uFFCA-\uFFCF\uFFD2-\uFFD7\uFFDA-\uFFDC]|\uD800[\uDC00-\uDC0B\uDC0D-\uDC26\uDC28-\uDC3A\uDC3C\uDC3D\uDC3F-\uDC4D\uDC50-\uDC5D\uDC80-\uDCFA\uDD07-\uDD33\uDD40-\uDD78\uDD8A\uDD8B\uDE80-\uDE9C\uDEA0-\uDED0\uDEE1-\uDEFB\uDF00-\uDF23\uDF2D-\uDF4A\uDF50-\uDF75\uDF80-\uDF9D\uDFA0-\uDFC3\uDFC8-\uDFCF\uDFD1-\uDFD5]|\uD801[\uDC00-\uDC9D\uDCA0-\uDCA9\uDCB0-\uDCD3\uDCD8-\uDCFB\uDD00-\uDD27\uDD30-\uDD63\uDE00-\uDF36\uDF40-\uDF55\uDF60-\uDF67]|\uD802[\uDC00-\uDC05\uDC08\uDC0A-\uDC35\uDC37\uDC38\uDC3C\uDC3F-\uDC55\uDC58-\uDC76\uDC79-\uDC9E\uDCA7-\uDCAF\uDCE0-\uDCF2\uDCF4\uDCF5\uDCFB-\uDD1B\uDD20-\uDD39\uDD80-\uDDB7\uDDBC-\uDDCF\uDDD2-\uDE00\uDE10-\uDE13\uDE15-\uDE17\uDE19-\uDE35\uDE40-\uDE48\uDE60-\uDE7E\uDE80-\uDE9F\uDEC0-\uDEC7\uDEC9-\uDEE4\uDEEB-\uDEEF\uDF00-\uDF35\uDF40-\uDF55\uDF58-\uDF72\uDF78-\uDF91\uDFA9-\uDFAF]|\uD803[\uDC00-\uDC48\uDC80-\uDCB2\uDCC0-\uDCF2\uDCFA-\uDD23\uDD30-\uDD39\uDE60-\uDE7E\uDE80-\uDEA9\uDEB0\uDEB1\uDF00-\uDF27\uDF30-\uDF45\uDF51-\uDF54\uDFB0-\uDFCB\uDFE0-\uDFF6]|\uD804[\uDC03-\uDC37\uDC52-\uDC6F\uDC83-\uDCAF\uDCD0-\uDCE8\uDCF0-\uDCF9\uDD03-\uDD26\uDD36-\uDD3F\uDD44\uDD47\uDD50-\uDD72\uDD76\uDD83-\uDDB2\uDDC1-\uDDC4\uDDD0-\uDDDA\uDDDC\uDDE1-\uDDF4\uDE00-\uDE11\uDE13-\uDE2B\uDE80-\uDE86\uDE88\uDE8A-\uDE8D\uDE8F-\uDE9D\uDE9F-\uDEA8\uDEB0-\uDEDE\uDEF0-\uDEF9\uDF05-\uDF0C\uDF0F\uDF10\uDF13-\uDF28\uDF2A-\uDF30\uDF32\uDF33\uDF35-\uDF39\uDF3D\uDF50\uDF5D-\uDF61]|\uD805[\uDC00-\uDC34\uDC47-\uDC4A\uDC50-\uDC59\uDC5F-\uDC61\uDC80-\uDCAF\uDCC4\uDCC5\uDCC7\uDCD0-\uDCD9\uDD80-\uDDAE\uDDD8-\uDDDB\uDE00-\uDE2F\uDE44\uDE50-\uDE59\uDE80-\uDEAA\uDEB8\uDEC0-\uDEC9\uDF00-\uDF1A\uDF30-\uDF3B]|\uD806[\uDC00-\uDC2B\uDCA0-\uDCF2\uDCFF-\uDD06\uDD09\uDD0C-\uDD13\uDD15\uDD16\uDD18-\uDD2F\uDD3F\uDD41\uDD50-\uDD59\uDDA0-\uDDA7\uDDAA-\uDDD0\uDDE1\uDDE3\uDE00\uDE0B-\uDE32\uDE3A\uDE50\uDE5C-\uDE89\uDE9D\uDEC0-\uDEF8]|\uD807[\uDC00-\uDC08\uDC0A-\uDC2E\uDC40\uDC50-\uDC6C\uDC72-\uDC8F\uDD00-\uDD06\uDD08\uDD09\uDD0B-\uDD30\uDD46\uDD50-\uDD59\uDD60-\uDD65\uDD67\uDD68\uDD6A-\uDD89\uDD98\uDDA0-\uDDA9\uDEE0-\uDEF2\uDFB0\uDFC0-\uDFD4]|\uD808[\uDC00-\uDF99]|\uD809[\uDC00-\uDC6E\uDC80-\uDD43]|[\uD80C\uD81C-\uD820\uD822\uD840-\uD868\uD86A-\uD86C\uD86F-\uD872\uD874-\uD879\uD880-\uD883][\uDC00-\uDFFF]|\uD80D[\uDC00-\uDC2E]|\uD811[\uDC00-\uDE46]|\uD81A[\uDC00-\uDE38\uDE40-\uDE5E\uDE60-\uDE69\uDED0-\uDEED\uDF00-\uDF2F\uDF40-\uDF43\uDF50-\uDF59\uDF5B-\uDF61\uDF63-\uDF77\uDF7D-\uDF8F]|\uD81B[\uDE40-\uDE96\uDF00-\uDF4A\uDF50\uDF93-\uDF9F\uDFE0\uDFE1\uDFE3]|\uD821[\uDC00-\uDFF7]|\uD823[\uDC00-\uDCD5\uDD00-\uDD08]|\uD82C[\uDC00-\uDD1E\uDD50-\uDD52\uDD64-\uDD67\uDD70-\uDEFB]|\uD82F[\uDC00-\uDC6A\uDC70-\uDC7C\uDC80-\uDC88\uDC90-\uDC99]|\uD834[\uDEE0-\uDEF3\uDF60-\uDF78]|\uD835[\uDC00-\uDC54\uDC56-\uDC9C\uDC9E\uDC9F\uDCA2\uDCA5\uDCA6\uDCA9-\uDCAC\uDCAE-\uDCB9\uDCBB\uDCBD-\uDCC3\uDCC5-\uDD05\uDD07-\uDD0A\uDD0D-\uDD14\uDD16-\uDD1C\uDD1E-\uDD39\uDD3B-\uDD3E\uDD40-\uDD44\uDD46\uDD4A-\uDD50\uDD52-\uDEA5\uDEA8-\uDEC0\uDEC2-\uDEDA\uDEDC-\uDEFA\uDEFC-\uDF14\uDF16-\uDF34\uDF36-\uDF4E\uDF50-\uDF6E\uDF70-\uDF88\uDF8A-\uDFA8\uDFAA-\uDFC2\uDFC4-\uDFCB\uDFCE-\uDFFF]|\uD838[\uDD00-\uDD2C\uDD37-\uDD3D\uDD40-\uDD49\uDD4E\uDEC0-\uDEEB\uDEF0-\uDEF9]|\uD83A[\uDC00-\uDCC4\uDCC7-\uDCCF\uDD00-\uDD43\uDD4B\uDD50-\uDD59]|\uD83B[\uDC71-\uDCAB\uDCAD-\uDCAF\uDCB1-\uDCB4\uDD01-\uDD2D\uDD2F-\uDD3D\uDE00-\uDE03\uDE05-\uDE1F\uDE21\uDE22\uDE24\uDE27\uDE29-\uDE32\uDE34-\uDE37\uDE39\uDE3B\uDE42\uDE47\uDE49\uDE4B\uDE4D-\uDE4F\uDE51\uDE52\uDE54\uDE57\uDE59\uDE5B\uDE5D\uDE5F\uDE61\uDE62\uDE64\uDE67-\uDE6A\uDE6C-\uDE72\uDE74-\uDE77\uDE79-\uDE7C\uDE7E\uDE80-\uDE89\uDE8B-\uDE9B\uDEA1-\uDEA3\uDEA5-\uDEA9\uDEAB-\uDEBB]|\uD83C[\uDD00-\uDD0C]|\uD83E[\uDFF0-\uDFF9]|\uD869[\uDC00-\uDEDD\uDF00-\uDFFF]|\uD86D[\uDC00-\uDF34\uDF40-\uDFFF]|\uD86E[\uDC00-\uDC1D\uDC20-\uDFFF]|\uD873[\uDC00-\uDEA1\uDEB0-\uDFFF]|\uD87A[\uDC00-\uDFE0]|\uD87E[\uDC00-\uDE1D]|\uD884[\uDC00-\uDF4A])/))){var ke=ge[1]||ge[2]||"";if(!ke||ke&&(fe===""||this.rules.inline.punctuation.exec(fe))){var ze=ge[0].length-1,Oe,Ve,it=ze,rt=0,ne=ge[0][0]==="*"?this.rules.inline.emStrong.rDelimAst:this.rules.inline.emStrong.rDelimUnd;for(ne.lastIndex=0,se=se.slice(-1*oe.length+ze);(ge=ne.exec(se))!=null;)if(Oe=ge[1]||ge[2]||ge[3]||ge[4]||ge[5]||ge[6],!!Oe){if(Ve=Oe.length,ge[3]||ge[4]){it+=Ve;continue}else if((ge[5]||ge[6])&&ze%3&&!((ze+Ve)%3)){rt+=Ve;continue}if(it-=Ve,!(it>0)){if(Ve=Math.min(Ve,Ve+it+rt),Math.min(ze,Ve)%2){var pe=oe.slice(1,ze+ge.index+Ve);return{type:"em",raw:oe.slice(0,ze+ge.index+Ve+1),text:pe,tokens:this.lexer.inlineTokens(pe,[])}}var ee=oe.slice(2,ze+ge.index+Ve-1);return{type:"strong",raw:oe.slice(0,ze+ge.index+Ve+1),text:ee,tokens:this.lexer.inlineTokens(ee,[])}}}}}},Se.codespan=function(oe){var se=this.rules.inline.code.exec(oe);if(se){var fe=se[2].replace(/\n/g," "),ge=/[^ ]/.test(fe),ke=/^ /.test(fe)&&/ $/.test(fe);return ge&&ke&&(fe=fe.substring(1,fe.length-1)),fe=N(fe,!0),{type:"codespan",raw:se[0],text:fe}}},Se.br=function(oe){var se=this.rules.inline.br.exec(oe);if(se)return{type:"br",raw:se[0]}},Se.del=function(oe){var se=this.rules.inline.del.exec(oe);if(se)return{type:"del",raw:se[0],text:se[2],tokens:this.lexer.inlineTokens(se[2],[])}},Se.autolink=function(oe,se){var fe=this.rules.inline.autolink.exec(oe);if(fe){var ge,ke;return fe[2]==="@"?(ge=N(this.options.mangle?se(fe[1]):fe[1]),ke="mailto:"+ge):(ge=N(fe[1]),ke=ge),{type:"link",raw:fe[0],text:ge,href:ke,tokens:[{type:"text",raw:ge,text:ge}]}}},Se.url=function(oe,se){var fe;if(fe=this.rules.inline.url.exec(oe)){var ge,ke;if(fe[2]==="@")ge=N(this.options.mangle?se(fe[0]):fe[0]),ke="mailto:"+ge;else{var ze;do ze=fe[0],fe[0]=this.rules.inline._backpedal.exec(fe[0])[0];while(ze!==fe[0]);ge=N(fe[0]),fe[1]==="www."?ke="http://"+ge:ke=ge}return{type:"link",raw:fe[0],text:ge,href:ke,tokens:[{type:"text",raw:ge,text:ge}]}}},Se.inlineText=function(oe,se){var fe=this.rules.inline.text.exec(oe);if(fe){var ge;return this.lexer.state.inRawBlock?ge=this.options.sanitize?this.options.sanitizer?this.options.sanitizer(fe[0]):N(fe[0]):fe[0]:ge=N(this.options.smartypants?se(fe[0]):fe[0]),{type:"text",raw:fe[0],text:ge}}},Ie}(),K=B.noopTest,ce=B.edit,de=B.merge,Y={newline:/^(?: *(?:\n|$))+/,code:/^( {4}[^\n]+(?:\n(?: *(?:\n|$))*)?)+/,fences:/^ {0,3}(`{3,}(?=[^`\n]*\n)|~{3,})([^\n]*)\n(?:|([\s\S]*?)\n)(?: {0,3}\1[~`]* *(?=\n|$)|$)/,hr:/^ {0,3}((?:- *){3,}|(?:_ *){3,}|(?:\* *){3,})(?:\n+|$)/,heading:/^ {0,3}(#{1,6})(?=\s|$)(.*)(?:\n+|$)/,blockquote:/^( {0,3}> ?(paragraph|[^\n]*)(?:\n|$))+/,list:/^( {0,3}bull)( [^\n]+?)?(?:\n|$)/,html:"^ {0,3}(?:<(script|pre|style|textarea)[\\s>][\\s\\S]*?(?:</\\1>[^\\n]*\\n+|$)|comment[^\\n]*(\\n+|$)|<\\?[\\s\\S]*?(?:\\?>\\n*|$)|<![A-Z][\\s\\S]*?(?:>\\n*|$)|<!\\[CDATA\\[[\\s\\S]*?(?:\\]\\]>\\n*|$)|</?(tag)(?: +|\\n|/?>)[\\s\\S]*?(?:(?:\\n *)+\\n|$)|<(?!script|pre|style|textarea)([a-z][\\w-]*)(?:attribute)*? */?>(?=[ \\t]*(?:\\n|$))[\\s\\S]*?(?:(?:\\n *)+\\n|$)|</(?!script|pre|style|textarea)[a-z][\\w-]*\\s*>(?=[ \\t]*(?:\\n|$))[\\s\\S]*?(?:(?:\\n *)+\\n|$))",def:/^ {0,3}\[(label)\]: *\n? *<?([^\s>]+)>?(?:(?: +\n? *| *\n *)(title))? *(?:\n+|$)/,table:K,lheading:/^([^\n]+)\n {0,3}(=+|-+) *(?:\n+|$)/,_paragraph:/^([^\n]+(?:\n(?!hr|heading|lheading|blockquote|fences|list|html| +\n)[^\n]+)*)/,text:/^[^\n]+/};Y._label=/(?!\s*\])(?:\\[\[\]]|[^\[\]])+/,Y._title=/(?:"(?:\\"?|[^"\\])*"|'[^'\n]*(?:\n[^'\n]+)*\n?'|\([^()]*\))/,Y.def=ce(Y.def).replace("label",Y._label).replace("title",Y._title).getRegex(),Y.bullet=/(?:[*+-]|\d{1,9}[.)])/,Y.listItemStart=ce(/^( *)(bull) */).replace("bull",Y.bullet).getRegex(),Y.list=ce(Y.list).replace(/bull/g,Y.bullet).replace("hr","\\n+(?=\\1?(?:(?:- *){3,}|(?:_ *){3,}|(?:\\* *){3,})(?:\\n+|$))").replace("def","\\n+(?="+Y.def.source+")").getRegex(),Y._tag="address|article|aside|base|basefont|blockquote|body|caption|center|col|colgroup|dd|details|dialog|dir|div|dl|dt|fieldset|figcaption|figure|footer|form|frame|frameset|h[1-6]|head|header|hr|html|iframe|legend|li|link|main|menu|menuitem|meta|nav|noframes|ol|optgroup|option|p|param|section|source|summary|table|tbody|td|tfoot|th|thead|title|tr|track|ul",Y._comment=/<!--(?!-?>)[\s\S]*?(?:-->|$)/,Y.html=ce(Y.html,"i").replace("comment",Y._comment).replace("tag",Y._tag).replace("attribute",/ +[a-zA-Z:_][\w.:-]*(?: *= *"[^"\n]*"| *= *'[^'\n]*'| *= *[^\s"'=<>`]+)?/).getRegex(),Y.paragraph=ce(Y._paragraph).replace("hr",Y.hr).replace("heading"," {0,3}#{1,6} ").replace("|lheading","").replace("blockquote"," {0,3}>").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",Y._tag).getRegex(),Y.blockquote=ce(Y.blockquote).replace("paragraph",Y.paragraph).getRegex(),Y.normal=de({},Y),Y.gfm=de({},Y.normal,{table:"^ *([^\\n ].*\\|.*)\\n {0,3}(?:\\| *)?(:?-+:? *(?:\\| *:?-+:? *)*)\\|?(?:\\n((?:(?! *\\n|hr|heading|blockquote|code|fences|list|html).*(?:\\n|$))*)\\n*|$)"}),Y.gfm.table=ce(Y.gfm.table).replace("hr",Y.hr).replace("heading"," {0,3}#{1,6} ").replace("blockquote"," {0,3}>").replace("code"," {4}[^\\n]").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",Y._tag).getRegex(),Y.pedantic=de({},Y.normal,{html:ce(`^ *(?:comment *(?:\\n|\\s*$)|<(tag)[\\s\\S]+?</\\1> *(?:\\n{2,}|\\s*$)|<tag(?:"[^"]*"|'[^']*'|\\s[^'"/>\\s]*)*?/?> *(?:\\n{2,}|\\s*$))`).replace("comment",Y._comment).replace(/tag/g,"(?!(?:a|em|strong|small|s|cite|q|dfn|abbr|data|time|code|var|samp|kbd|sub|sup|i|b|u|mark|ruby|rt|rp|bdi|bdo|span|br|wbr|ins|del|img)\\b)\\w+(?!:|[^\\w\\s@]*@)\\b").getRegex(),def:/^ *\[([^\]]+)\]: *<?([^\s>]+)>?(?: +(["(][^\n]+[")]))? *(?:\n+|$)/,heading:/^(#{1,6})(.*)(?:\n+|$)/,fences:K,paragraph:ce(Y.normal._paragraph).replace("hr",Y.hr).replace("heading",` *#{1,6} *[^
]`).replace("lheading",Y.lheading).replace("blockquote"," {0,3}>").replace("|fences","").replace("|list","").replace("|html","").getRegex()});var ie={escape:/^\\([!"#$%&'()*+,\-./:;<=>?@\[\]\\^_`{|}~])/,autolink:/^<(scheme:[^\s\x00-\x1f<>]*|email)>/,url:K,tag:"^comment|^</[a-zA-Z][\\w:-]*\\s*>|^<[a-zA-Z][\\w-]*(?:attribute)*?\\s*/?>|^<\\?[\\s\\S]*?\\?>|^<![a-zA-Z]+\\s[\\s\\S]*?>|^<!\\[CDATA\\[[\\s\\S]*?\\]\\]>",link:/^!?\[(label)\]\(\s*(href)(?:\s+(title))?\s*\)/,reflink:/^!?\[(label)\]\[(?!\s*\])((?:\\[\[\]]?|[^\[\]\\])+)\]/,nolink:/^!?\[(?!\s*\])((?:\[[^\[\]]*\]|\\[\[\]]|[^\[\]])*)\](?:\[\])?/,reflinkSearch:"reflink|nolink(?!\\()",emStrong:{lDelim:/^(?:\*+(?:([punct_])|[^\s*]))|^_+(?:([punct*])|([^\s_]))/,rDelimAst:/\_\_[^_*]*?\*[^_*]*?\_\_|[punct_](\*+)(?=[\s]|$)|[^punct*_\s](\*+)(?=[punct_\s]|$)|[punct_\s](\*+)(?=[^punct*_\s])|[\s](\*+)(?=[punct_])|[punct_](\*+)(?=[punct_])|[^punct*_\s](\*+)(?=[^punct*_\s])/,rDelimUnd:/\*\*[^_*]*?\_[^_*]*?\*\*|[punct*](\_+)(?=[\s]|$)|[^punct*_\s](\_+)(?=[punct*\s]|$)|[punct*\s](\_+)(?=[^punct*_\s])|[\s](\_+)(?=[punct*])|[punct*](\_+)(?=[punct*])/},code:/^(`+)([^`]|[^`][\s\S]*?[^`])\1(?!`)/,br:/^( {2,}|\\)\n(?!\s*$)/,del:K,text:/^(`+|[^`])(?:(?= {2,}\n)|[\s\S]*?(?:(?=[\\<!\[`*_]|\b_|$)|[^ ](?= {2,}\n)))/,punctuation:/^([\spunctuation])/};ie._punctuation="!\"#$%&'()+\\-.,/:;<=>?@\\[\\]`^{|}~",ie.punctuation=ce(ie.punctuation).replace(/punctuation/g,ie._punctuation).getRegex(),ie.blockSkip=/\[[^\]]*?\]\([^\)]*?\)|`[^`]*?`|<[^>]*?>/g,ie.escapedEmSt=/\\\*|\\_/g,ie._comment=ce(Y._comment).replace("(?:-->|$)","-->").getRegex(),ie.emStrong.lDelim=ce(ie.emStrong.lDelim).replace(/punct/g,ie._punctuation).getRegex(),ie.emStrong.rDelimAst=ce(ie.emStrong.rDelimAst,"g").replace(/punct/g,ie._punctuation).getRegex(),ie.emStrong.rDelimUnd=ce(ie.emStrong.rDelimUnd,"g").replace(/punct/g,ie._punctuation).getRegex(),ie._escapes=/\\([!"#$%&'()*+,\-./:;<=>?@\[\]\\^_`{|}~])/g,ie._scheme=/[a-zA-Z][a-zA-Z0-9+.-]{1,31}/,ie._email=/[a-zA-Z0-9.!#$%&'*+/=?^_`{|}~-]+(@)[a-zA-Z0-9](?:[a-zA-Z0-9-]{0,61}[a-zA-Z0-9])?(?:\.[a-zA-Z0-9](?:[a-zA-Z0-9-]{0,61}[a-zA-Z0-9])?)+(?![-_])/,ie.autolink=ce(ie.autolink).replace("scheme",ie._scheme).replace("email",ie._email).getRegex(),ie._attribute=/\s+[a-zA-Z:_][\w.:-]*(?:\s*=\s*"[^"]*"|\s*=\s*'[^']*'|\s*=\s*[^\s"'=<>`]+)?/,ie.tag=ce(ie.tag).replace("comment",ie._comment).replace("attribute",ie._attribute).getRegex(),ie._label=/(?:\[(?:\\.|[^\[\]\\])*\]|\\.|`[^`]*`|[^\[\]\\`])*?/,ie._href=/<(?:\\.|[^\n<>\\])+>|[^\s\x00-\x1f]*/,ie._title=/"(?:\\"?|[^"\\])*"|'(?:\\'?|[^'\\])*'|\((?:\\\)?|[^)\\])*\)/,ie.link=ce(ie.link).replace("label",ie._label).replace("href",ie._href).replace("title",ie._title).getRegex(),ie.reflink=ce(ie.reflink).replace("label",ie._label).getRegex(),ie.reflinkSearch=ce(ie.reflinkSearch,"g").replace("reflink",ie.reflink).replace("nolink",ie.nolink).getRegex(),ie.normal=de({},ie),ie.pedantic=de({},ie.normal,{strong:{start:/^__|\*\*/,middle:/^__(?=\S)([\s\S]*?\S)__(?!_)|^\*\*(?=\S)([\s\S]*?\S)\*\*(?!\*)/,endAst:/\*\*(?!\*)/g,endUnd:/__(?!_)/g},em:{start:/^_|\*/,middle:/^()\*(?=\S)([\s\S]*?\S)\*(?!\*)|^_(?=\S)([\s\S]*?\S)_(?!_)/,endAst:/\*(?!\*)/g,endUnd:/_(?!_)/g},link:ce(/^!?\[(label)\]\((.*?)\)/).replace("label",ie._label).getRegex(),reflink:ce(/^!?\[(label)\]\s*\[([^\]]*)\]/).replace("label",ie._label).getRegex()}),ie.gfm=de({},ie.normal,{escape:ce(ie.escape).replace("])","~|])").getRegex(),_extended_email:/[A-Za-z0-9._+-]+(@)[a-zA-Z0-9-_]+(?:\.[a-zA-Z0-9-_]*[a-zA-Z0-9])+(?![-_])/,url:/^((?:ftp|https?):\/\/|www\.)(?:[a-zA-Z0-9\-]+\.?)+[^\s<]*|^email/,_backpedal:/(?:[^?!.,:;*_~()&]+|\([^)]*\)|&(?![a-zA-Z0-9]+;$)|[?!.,:;*_~)]+(?!$))+/,del:/^(~~?)(?=[^\s~])([\s\S]*?[^\s~])\1(?=[^~]|$)/,text:/^([`~]+|[^`~])(?:(?= {2,}\n)|(?=[a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-]+@)|[\s\S]*?(?:(?=[\\<!\[`*~_]|\b_|https?:\/\/|ftp:\/\/|www\.|$)|[^ ](?= {2,}\n)|[^a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-](?=[a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-]+@)))/}),ie.gfm.url=ce(ie.gfm.url,"i").replace("email",ie.gfm._extended_email).getRegex(),ie.breaks=de({},ie.gfm,{br:ce(ie.br).replace("{2,}","*").getRegex(),text:ce(ie.gfm.text).replace("\\b_","\\b_| {2,}\\n").replace(/\{2,\}/g,"*").getRegex()});var we={block:Y,inline:ie},Me=ue,Re=P.exports.defaults,Be=we.block,Qe=we.inline,Ge=B.repeatString;function Xe(Ie){return Ie.replace(/---/g,"\u2014").replace(/--/g,"\u2013").replace(/(^|[-\u2014/(\[{"\s])'/g,"$1\u2018").replace(/'/g,"\u2019").replace(/(^|[-\u2014/(\[{\u2018\s])"/g,"$1\u201C").replace(/"/g,"\u201D").replace(/\.{3}/g,"\u2026")}function $(Ie){var Se="",ve,oe,se=Ie.length;for(ve=0;ve<se;ve++)oe=Ie.charCodeAt(ve),Math.random()>.5&&(oe="x"+oe.toString(16)),Se+="&#"+oe+";";return Se}var G=function(){function Ie(ve){this.tokens=[],this.tokens.links=Object.create(null),this.options=ve||Re,this.options.tokenizer=this.options.tokenizer||new Me,this.tokenizer=this.options.tokenizer,this.tokenizer.options=this.options,this.tokenizer.lexer=this,this.inlineQueue=[],this.state={inLink:!1,inRawBlock:!1,top:!0};var oe={block:Be.normal,inline:Qe.normal};this.options.pedantic?(oe.block=Be.pedantic,oe.inline=Qe.pedantic):this.options.gfm&&(oe.block=Be.gfm,this.options.breaks?oe.inline=Qe.breaks:oe.inline=Qe.gfm),this.tokenizer.rules=oe}Ie.lex=function(oe,se){var fe=new Ie(se);return fe.lex(oe)},Ie.lexInline=function(oe,se){var fe=new Ie(se);return fe.inlineTokens(oe)};var Se=Ie.prototype;return Se.lex=function(oe){oe=oe.replace(/\r\n|\r/g,`
`).replace(/\t/g,"    "),this.blockTokens(oe,this.tokens);for(var se;se=this.inlineQueue.shift();)this.inlineTokens(se.src,se.tokens);return this.tokens},Se.blockTokens=function(oe,se){var fe=this;se===void 0&&(se=[]),this.options.pedantic&&(oe=oe.replace(/^ +$/gm,""));for(var ge,ke,ze,Oe;oe;)if(!(this.options.extensions&&this.options.extensions.block&&this.options.extensions.block.some(function(it){return(ge=it.call({lexer:fe},oe,se))?(oe=oe.substring(ge.raw.length),se.push(ge),!0):!1}))){if(ge=this.tokenizer.space(oe)){oe=oe.substring(ge.raw.length),ge.type&&se.push(ge);continue}if(ge=this.tokenizer.code(oe)){oe=oe.substring(ge.raw.length),ke=se[se.length-1],ke&&(ke.type==="paragraph"||ke.type==="text")?(ke.raw+=`
`+ge.raw,ke.text+=`
`+ge.text,this.inlineQueue[this.inlineQueue.length-1].src=ke.text):se.push(ge);continue}if(ge=this.tokenizer.fences(oe)){oe=oe.substring(ge.raw.length),se.push(ge);continue}if(ge=this.tokenizer.heading(oe)){oe=oe.substring(ge.raw.length),se.push(ge);continue}if(ge=this.tokenizer.hr(oe)){oe=oe.substring(ge.raw.length),se.push(ge);continue}if(ge=this.tokenizer.blockquote(oe)){oe=oe.substring(ge.raw.length),se.push(ge);continue}if(ge=this.tokenizer.list(oe)){oe=oe.substring(ge.raw.length),se.push(ge);continue}if(ge=this.tokenizer.html(oe)){oe=oe.substring(ge.raw.length),se.push(ge);continue}if(ge=this.tokenizer.def(oe)){oe=oe.substring(ge.raw.length),ke=se[se.length-1],ke&&(ke.type==="paragraph"||ke.type==="text")?(ke.raw+=`
`+ge.raw,ke.text+=`
`+ge.raw,this.inlineQueue[this.inlineQueue.length-1].src=ke.text):this.tokens.links[ge.tag]||(this.tokens.links[ge.tag]={href:ge.href,title:ge.title});continue}if(ge=this.tokenizer.table(oe)){oe=oe.substring(ge.raw.length),se.push(ge);continue}if(ge=this.tokenizer.lheading(oe)){oe=oe.substring(ge.raw.length),se.push(ge);continue}if(ze=oe,this.options.extensions&&this.options.extensions.startBlock&&function(){var it=Infinity,rt=oe.slice(1),ne=void 0;fe.options.extensions.startBlock.forEach(function(pe){ne=pe.call({lexer:this},rt),typeof ne=="number"&&ne>=0&&(it=Math.min(it,ne))}),it<Infinity&&it>=0&&(ze=oe.substring(0,it+1))}(),this.state.top&&(ge=this.tokenizer.paragraph(ze))){ke=se[se.length-1],Oe&&ke.type==="paragraph"?(ke.raw+=`
`+ge.raw,ke.text+=`
`+ge.text,this.inlineQueue.pop(),this.inlineQueue[this.inlineQueue.length-1].src=ke.text):se.push(ge),Oe=ze.length!==oe.length,oe=oe.substring(ge.raw.length);continue}if(ge=this.tokenizer.text(oe)){oe=oe.substring(ge.raw.length),ke=se[se.length-1],ke&&ke.type==="text"?(ke.raw+=`
`+ge.raw,ke.text+=`
`+ge.text,this.inlineQueue.pop(),this.inlineQueue[this.inlineQueue.length-1].src=ke.text):se.push(ge);continue}if(oe){var Ve="Infinite loop on byte: "+oe.charCodeAt(0);if(this.options.silent){console.error(Ve);break}else throw new Error(Ve)}}return this.state.top=!0,se},Se.inline=function(oe,se){this.inlineQueue.push({src:oe,tokens:se})},Se.inlineTokens=function(oe,se){var fe=this;se===void 0&&(se=[]);var ge,ke,ze,Oe=oe,Ve,it,rt;if(this.tokens.links){var ne=Object.keys(this.tokens.links);if(ne.length>0)for(;(Ve=this.tokenizer.rules.inline.reflinkSearch.exec(Oe))!=null;)ne.includes(Ve[0].slice(Ve[0].lastIndexOf("[")+1,-1))&&(Oe=Oe.slice(0,Ve.index)+"["+Ge("a",Ve[0].length-2)+"]"+Oe.slice(this.tokenizer.rules.inline.reflinkSearch.lastIndex))}for(;(Ve=this.tokenizer.rules.inline.blockSkip.exec(Oe))!=null;)Oe=Oe.slice(0,Ve.index)+"["+Ge("a",Ve[0].length-2)+"]"+Oe.slice(this.tokenizer.rules.inline.blockSkip.lastIndex);for(;(Ve=this.tokenizer.rules.inline.escapedEmSt.exec(Oe))!=null;)Oe=Oe.slice(0,Ve.index)+"++"+Oe.slice(this.tokenizer.rules.inline.escapedEmSt.lastIndex);for(;oe;)if(it||(rt=""),it=!1,!(this.options.extensions&&this.options.extensions.inline&&this.options.extensions.inline.some(function(ee){return(ge=ee.call({lexer:fe},oe,se))?(oe=oe.substring(ge.raw.length),se.push(ge),!0):!1}))){if(ge=this.tokenizer.escape(oe)){oe=oe.substring(ge.raw.length),se.push(ge);continue}if(ge=this.tokenizer.tag(oe)){oe=oe.substring(ge.raw.length),ke=se[se.length-1],ke&&ge.type==="text"&&ke.type==="text"?(ke.raw+=ge.raw,ke.text+=ge.text):se.push(ge);continue}if(ge=this.tokenizer.link(oe)){oe=oe.substring(ge.raw.length),se.push(ge);continue}if(ge=this.tokenizer.reflink(oe,this.tokens.links)){oe=oe.substring(ge.raw.length),ke=se[se.length-1],ke&&ge.type==="text"&&ke.type==="text"?(ke.raw+=ge.raw,ke.text+=ge.text):se.push(ge);continue}if(ge=this.tokenizer.emStrong(oe,Oe,rt)){oe=oe.substring(ge.raw.length),se.push(ge);continue}if(ge=this.tokenizer.codespan(oe)){oe=oe.substring(ge.raw.length),se.push(ge);continue}if(ge=this.tokenizer.br(oe)){oe=oe.substring(ge.raw.length),se.push(ge);continue}if(ge=this.tokenizer.del(oe)){oe=oe.substring(ge.raw.length),se.push(ge);continue}if(ge=this.tokenizer.autolink(oe,$)){oe=oe.substring(ge.raw.length),se.push(ge);continue}if(!this.state.inLink&&(ge=this.tokenizer.url(oe,$))){oe=oe.substring(ge.raw.length),se.push(ge);continue}if(ze=oe,this.options.extensions&&this.options.extensions.startInline&&function(){var ee=Infinity,W=oe.slice(1),be=void 0;fe.options.extensions.startInline.forEach(function(De){be=De.call({lexer:this},W),typeof be=="number"&&be>=0&&(ee=Math.min(ee,be))}),ee<Infinity&&ee>=0&&(ze=oe.substring(0,ee+1))}(),ge=this.tokenizer.inlineText(ze,Xe)){oe=oe.substring(ge.raw.length),ge.raw.slice(-1)!=="_"&&(rt=ge.raw.slice(-1)),it=!0,ke=se[se.length-1],ke&&ke.type==="text"?(ke.raw+=ge.raw,ke.text+=ge.text):se.push(ge);continue}if(oe){var pe="Infinite loop on byte: "+oe.charCodeAt(0);if(this.options.silent){console.error(pe);break}else throw new Error(pe)}}return se},e(Ie,null,[{key:"rules",get:function(){return{block:Be,inline:Qe}}}]),Ie}(),J=P.exports.defaults,ae=B.cleanUrl,j=B.escape,te=function(){function Ie(ve){this.options=ve||J}var Se=Ie.prototype;return Se.code=function(oe,se,fe){var ge=(se||"").match(/\S*/)[0];if(this.options.highlight){var ke=this.options.highlight(oe,ge);ke!=null&&ke!==oe&&(fe=!0,oe=ke)}return oe=oe.replace(/\n$/,"")+`
`,ge?'<pre><code class="'+this.options.langPrefix+j(ge,!0)+'">'+(fe?oe:j(oe,!0))+`</code></pre>
`:"<pre><code>"+(fe?oe:j(oe,!0))+`</code></pre>
`},Se.blockquote=function(oe){return`<blockquote>
`+oe+`</blockquote>
`},Se.html=function(oe){return oe},Se.heading=function(oe,se,fe,ge){return this.options.headerIds?"<h"+se+' id="'+this.options.headerPrefix+ge.slug(fe)+'">'+oe+"</h"+se+`>
`:"<h"+se+">"+oe+"</h"+se+`>
`},Se.hr=function(){return this.options.xhtml?`<hr/>
`:`<hr>
`},Se.list=function(oe,se,fe){var ge=se?"ol":"ul",ke=se&&fe!==1?' start="'+fe+'"':"";return"<"+ge+ke+`>
`+oe+"</"+ge+`>
`},Se.listitem=function(oe){return"<li>"+oe+`</li>
`},Se.checkbox=function(oe){return"<input "+(oe?'checked="" ':"")+'disabled="" type="checkbox"'+(this.options.xhtml?" /":"")+"> "},Se.paragraph=function(oe){return"<p>"+oe+`</p>
`},Se.table=function(oe,se){return se&&(se="<tbody>"+se+"</tbody>"),`<table>
<thead>
`+oe+`</thead>
`+se+`</table>
`},Se.tablerow=function(oe){return`<tr>
`+oe+`</tr>
`},Se.tablecell=function(oe,se){var fe=se.header?"th":"td",ge=se.align?"<"+fe+' align="'+se.align+'">':"<"+fe+">";return ge+oe+"</"+fe+`>
`},Se.strong=function(oe){return"<strong>"+oe+"</strong>"},Se.em=function(oe){return"<em>"+oe+"</em>"},Se.codespan=function(oe){return"<code>"+oe+"</code>"},Se.br=function(){return this.options.xhtml?"<br/>":"<br>"},Se.del=function(oe){return"<del>"+oe+"</del>"},Se.link=function(oe,se,fe){if(oe=ae(this.options.sanitize,this.options.baseUrl,oe),oe===null)return fe;var ge='<a href="'+j(oe)+'"';return se&&(ge+=' title="'+se+'"'),ge+=">"+fe+"</a>",ge},Se.image=function(oe,se,fe){if(oe=ae(this.options.sanitize,this.options.baseUrl,oe),oe===null)return fe;var ge='<img src="'+oe+'" alt="'+fe+'"';return se&&(ge+=' title="'+se+'"'),ge+=this.options.xhtml?"/>":">",ge},Se.text=function(oe){return oe},Ie}(),me=function(){function Ie(){}var Se=Ie.prototype;return Se.strong=function(oe){return oe},Se.em=function(oe){return oe},Se.codespan=function(oe){return oe},Se.del=function(oe){return oe},Se.html=function(oe){return oe},Se.text=function(oe){return oe},Se.link=function(oe,se,fe){return""+fe},Se.image=function(oe,se,fe){return""+fe},Se.br=function(){return""},Ie}(),Pe=function(){function Ie(){this.seen={}}var Se=Ie.prototype;return Se.serialize=function(oe){return oe.toLowerCase().trim().replace(/<[!\/a-z].*?>/ig,"").replace(/[\u2000-\u206F\u2E00-\u2E7F\\'!"#$%&()*+,./:;<=>?@[\]^`{|}~]/g,"").replace(/\s/g,"-")},Se.getNextSafeSlug=function(oe,se){var fe=oe,ge=0;if(this.seen.hasOwnProperty(fe)){ge=this.seen[oe];do ge++,fe=oe+"-"+ge;while(this.seen.hasOwnProperty(fe))}return se||(this.seen[oe]=ge,this.seen[fe]=0),fe},Se.slug=function(oe,se){se===void 0&&(se={});var fe=this.serialize(oe);return this.getNextSafeSlug(fe,se.dryrun)},Ie}(),Ne=te,He=me,Ye=Pe,et=P.exports.defaults,st=B.unescape,Je=function(){function Ie(ve){this.options=ve||et,this.options.renderer=this.options.renderer||new Ne,this.renderer=this.options.renderer,this.renderer.options=this.options,this.textRenderer=new He,this.slugger=new Ye}Ie.parse=function(oe,se){var fe=new Ie(se);return fe.parse(oe)},Ie.parseInline=function(oe,se){var fe=new Ie(se);return fe.parseInline(oe)};var Se=Ie.prototype;return Se.parse=function(oe,se){se===void 0&&(se=!0);var fe="",ge,ke,ze,Oe,Ve,it,rt,ne,pe,ee,W,be,De,qe,xe,ut,vt,Ct,bt,ht=oe.length;for(ge=0;ge<ht;ge++){if(ee=oe[ge],this.options.extensions&&this.options.extensions.renderers&&this.options.extensions.renderers[ee.type]&&(bt=this.options.extensions.renderers[ee.type].call({parser:this},ee),bt!==!1||!["space","hr","heading","code","table","blockquote","list","html","paragraph","text"].includes(ee.type))){fe+=bt||"";continue}switch(ee.type){case"space":continue;case"hr":{fe+=this.renderer.hr();continue}case"heading":{fe+=this.renderer.heading(this.parseInline(ee.tokens),ee.depth,st(this.parseInline(ee.tokens,this.textRenderer)),this.slugger);continue}case"code":{fe+=this.renderer.code(ee.text,ee.lang,ee.escaped);continue}case"table":{for(ne="",rt="",Oe=ee.header.length,ke=0;ke<Oe;ke++)rt+=this.renderer.tablecell(this.parseInline(ee.header[ke].tokens),{header:!0,align:ee.align[ke]});for(ne+=this.renderer.tablerow(rt),pe="",Oe=ee.rows.length,ke=0;ke<Oe;ke++){for(it=ee.rows[ke],rt="",Ve=it.length,ze=0;ze<Ve;ze++)rt+=this.renderer.tablecell(this.parseInline(it[ze].tokens),{header:!1,align:ee.align[ze]});pe+=this.renderer.tablerow(rt)}fe+=this.renderer.table(ne,pe);continue}case"blockquote":{pe=this.parse(ee.tokens),fe+=this.renderer.blockquote(pe);continue}case"list":{for(W=ee.ordered,be=ee.start,De=ee.loose,Oe=ee.items.length,pe="",ke=0;ke<Oe;ke++)xe=ee.items[ke],ut=xe.checked,vt=xe.task,qe="",xe.task&&(Ct=this.renderer.checkbox(ut),De?xe.tokens.length>0&&xe.tokens[0].type==="paragraph"?(xe.tokens[0].text=Ct+" "+xe.tokens[0].text,xe.tokens[0].tokens&&xe.tokens[0].tokens.length>0&&xe.tokens[0].tokens[0].type==="text"&&(xe.tokens[0].tokens[0].text=Ct+" "+xe.tokens[0].tokens[0].text)):xe.tokens.unshift({type:"text",text:Ct}):qe+=Ct),qe+=this.parse(xe.tokens,De),pe+=this.renderer.listitem(qe,vt,ut);fe+=this.renderer.list(pe,W,be);continue}case"html":{fe+=this.renderer.html(ee.text);continue}case"paragraph":{fe+=this.renderer.paragraph(this.parseInline(ee.tokens));continue}case"text":{for(pe=ee.tokens?this.parseInline(ee.tokens):ee.text;ge+1<ht&&oe[ge+1].type==="text";)ee=oe[++ge],pe+=`
`+(ee.tokens?this.parseInline(ee.tokens):ee.text);fe+=se?this.renderer.paragraph(pe):pe;continue}default:{var gt='Token with "'+ee.type+'" type was not found.';if(this.options.silent){console.error(gt);return}else throw new Error(gt)}}}return fe},Se.parseInline=function(oe,se){se=se||this.renderer;var fe="",ge,ke,ze,Oe=oe.length;for(ge=0;ge<Oe;ge++){if(ke=oe[ge],this.options.extensions&&this.options.extensions.renderers&&this.options.extensions.renderers[ke.type]&&(ze=this.options.extensions.renderers[ke.type].call({parser:this},ke),ze!==!1||!["escape","html","link","image","strong","em","codespan","br","del","text"].includes(ke.type))){fe+=ze||"";continue}switch(ke.type){case"escape":{fe+=se.text(ke.text);break}case"html":{fe+=se.html(ke.text);break}case"link":{fe+=se.link(ke.href,ke.title,this.parseInline(ke.tokens,se));break}case"image":{fe+=se.image(ke.href,ke.title,ke.text);break}case"strong":{fe+=se.strong(this.parseInline(ke.tokens,se));break}case"em":{fe+=se.em(this.parseInline(ke.tokens,se));break}case"codespan":{fe+=se.codespan(ke.text);break}case"br":{fe+=se.br();break}case"del":{fe+=se.del(this.parseInline(ke.tokens,se));break}case"text":{fe+=se.text(ke.text);break}default:{var Ve='Token with "'+ke.type+'" type was not found.';if(this.options.silent){console.error(Ve);return}else throw new Error(Ve)}}}return fe},Ie}(),nt=G,ct=Je,pt=ue,Ft=te,Fe=me,Mt=Pe,V=B.merge,Q=B.checkSanitizeDeprecation,he=B.escape,Le=P.exports.getDefaults,We=P.exports.changeDefaults,ot=P.exports.defaults;function Ke(Ie,Se,ve){if(typeof Ie=="undefined"||Ie===null)throw new Error("marked(): input parameter is undefined or null");if(typeof Ie!="string")throw new Error("marked(): input parameter is of type "+Object.prototype.toString.call(Ie)+", string expected");if(typeof Se=="function"&&(ve=Se,Se=null),Se=V({},Ke.defaults,Se||{}),Q(Se),ve){var oe=Se.highlight,se;try{se=nt.lex(Ie,Se)}catch(ze){return ve(ze)}var fe=function(Oe){var Ve;if(!Oe)try{Se.walkTokens&&Ke.walkTokens(se,Se.walkTokens),Ve=ct.parse(se,Se)}catch(it){Oe=it}return Se.highlight=oe,Oe?ve(Oe):ve(null,Ve)};if(!oe||oe.length<3||(delete Se.highlight,!se.length))return fe();var ge=0;Ke.walkTokens(se,function(ze){ze.type==="code"&&(ge++,setTimeout(function(){oe(ze.text,ze.lang,function(Oe,Ve){if(Oe)return fe(Oe);Ve!=null&&Ve!==ze.text&&(ze.text=Ve,ze.escaped=!0),ge--,ge===0&&fe()})},0))}),ge===0&&fe();return}try{var ke=nt.lex(Ie,Se);return Se.walkTokens&&Ke.walkTokens(ke,Se.walkTokens),ct.parse(ke,Se)}catch(ze){if(ze.message+=`
Please report this to https://github.com/markedjs/marked.`,Se.silent)return"<p>An error occurred:</p><pre>"+he(ze.message+"",!0)+"</pre>";throw ze}}Ke.options=Ke.setOptions=function(Ie){return V(Ke.defaults,Ie),We(Ke.defaults),Ke},Ke.getDefaults=Le,Ke.defaults=ot,Ke.use=function(){for(var Ie=this,Se=arguments.length,ve=new Array(Se),oe=0;oe<Se;oe++)ve[oe]=arguments[oe];var se=V.apply(void 0,[{}].concat(ve)),fe=Ke.defaults.extensions||{renderers:{},childTokens:{}},ge;ve.forEach(function(ke){if(ke.extensions&&(ge=!0,ke.extensions.forEach(function(Oe){if(!Oe.name)throw new Error("extension name required");if(Oe.renderer){var Ve=fe.renderers?fe.renderers[Oe.name]:null;Ve?fe.renderers[Oe.name]=function(){for(var it=arguments.length,rt=new Array(it),ne=0;ne<it;ne++)rt[ne]=arguments[ne];var pe=Oe.renderer.apply(this,rt);return pe===!1&&(pe=Ve.apply(this,rt)),pe}:fe.renderers[Oe.name]=Oe.renderer}if(Oe.tokenizer){if(!Oe.level||Oe.level!=="block"&&Oe.level!=="inline")throw new Error("extension level must be 'block' or 'inline'");fe[Oe.level]?fe[Oe.level].unshift(Oe.tokenizer):fe[Oe.level]=[Oe.tokenizer],Oe.start&&(Oe.level==="block"?fe.startBlock?fe.startBlock.push(Oe.start):fe.startBlock=[Oe.start]:Oe.level==="inline"&&(fe.startInline?fe.startInline.push(Oe.start):fe.startInline=[Oe.start]))}Oe.childTokens&&(fe.childTokens[Oe.name]=Oe.childTokens)})),ke.renderer&&function(){var Oe=Ke.defaults.renderer||new Ft,Ve=function(ne){var pe=Oe[ne];Oe[ne]=function(){for(var ee=arguments.length,W=new Array(ee),be=0;be<ee;be++)W[be]=arguments[be];var De=ke.renderer[ne].apply(Oe,W);return De===!1&&(De=pe.apply(Oe,W)),De}};for(var it in ke.renderer)Ve(it);se.renderer=Oe}(),ke.tokenizer&&function(){var Oe=Ke.defaults.tokenizer||new pt,Ve=function(ne){var pe=Oe[ne];Oe[ne]=function(){for(var ee=arguments.length,W=new Array(ee),be=0;be<ee;be++)W[be]=arguments[be];var De=ke.tokenizer[ne].apply(Oe,W);return De===!1&&(De=pe.apply(Oe,W)),De}};for(var it in ke.tokenizer)Ve(it);se.tokenizer=Oe}(),ke.walkTokens){var ze=Ke.defaults.walkTokens;se.walkTokens=function(Oe){ke.walkTokens.call(Ie,Oe),ze&&ze(Oe)}}ge&&(se.extensions=fe),Ke.setOptions(se)})},Ke.walkTokens=function(Ie,Se){for(var ve=function(){var ge=se.value;switch(Se(ge),ge.type){case"table":{for(var ke=w(ge.header),ze;!(ze=ke()).done;){var Oe=ze.value;Ke.walkTokens(Oe.tokens,Se)}for(var Ve=w(ge.rows),it;!(it=Ve()).done;)for(var rt=it.value,ne=w(rt),pe;!(pe=ne()).done;){var ee=pe.value;Ke.walkTokens(ee.tokens,Se)}break}case"list":{Ke.walkTokens(ge.items,Se);break}default:Ke.defaults.extensions&&Ke.defaults.extensions.childTokens&&Ke.defaults.extensions.childTokens[ge.type]?Ke.defaults.extensions.childTokens[ge.type].forEach(function(W){Ke.walkTokens(ge[W],Se)}):ge.tokens&&Ke.walkTokens(ge.tokens,Se)}},oe=w(Ie),se;!(se=oe()).done;)ve()},Ke.parseInline=function(Ie,Se){if(typeof Ie=="undefined"||Ie===null)throw new Error("marked.parseInline(): input parameter is undefined or null");if(typeof Ie!="string")throw new Error("marked.parseInline(): input parameter is of type "+Object.prototype.toString.call(Ie)+", string expected");Se=V({},Ke.defaults,Se||{}),Q(Se);try{var ve=nt.lexInline(Ie,Se);return Se.walkTokens&&Ke.walkTokens(ve,Se.walkTokens),ct.parseInline(ve,Se)}catch(oe){if(oe.message+=`
Please report this to https://github.com/markedjs/marked.`,Se.silent)return"<p>An error occurred:</p><pre>"+he(oe.message+"",!0)+"</pre>";throw oe}},Ke.Parser=ct,Ke.parser=ct.parse,Ke.Renderer=Ft,Ke.TextRenderer=Fe,Ke.Lexer=nt,Ke.lexer=nt.lex,Ke.Tokenizer=pt,Ke.Slugger=Mt,Ke.parse=Ke;var _t=Ke;return _t}),define(Ee[75],_e([0,1]),function(re,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.MovingAverage=e.Counter=e.rot=e.clamp=void 0;function c(t,T,C){return Math.min(Math.max(t,T),C)}e.clamp=c;function F(t,T){return(T+t%T)%T}e.rot=F;class w{constructor(){this._next=0}getNext(){return this._next++}}e.Counter=w;class P{constructor(){this._n=1,this._val=0}update(T){return this._val=this._val+(T-this._val)/this._n,this._n+=1,this}get value(){return this._val}}e.MovingAverage=P}),function(){function re(w){const P=[];typeof w=="number"&&P.push("code/timeOrigin",w);function t(C){P.push(C,Date.now())}function T(){const C=[];for(let k=0;k<P.length;k+=2)C.push({name:P[k],startTime:P[k+1]});return C}return{mark:t,getMarks:T}}function e(){if(typeof performance=="object"&&typeof performance.mark=="function"&&!performance.nodeTiming)return typeof performance.timeOrigin!="number"&&!performance.timing?re():{mark(w){performance.mark(w)},getMarks(){let w=performance.timeOrigin;typeof w!="number"&&(w=performance.timing.navigationStart||performance.timing.redirectStart||performance.timing.fetchStart);const P=[{name:"code/timeOrigin",startTime:Math.round(w)}];for(const t of performance.getEntriesByType("mark"))P.push({name:t.name,startTime:Math.round(w+t.startTime)});return P}};if(typeof process=="object"){const w=Math.round((require.nodeRequire||require)("perf_hooks").performance.timeOrigin);return re(w)}else return console.trace("perf-util loaded in UNKNOWN environment"),re()}function c(w){return w.MonacoPerformanceMarks||(w.MonacoPerformanceMarks=e()),w.MonacoPerformanceMarks}var F;typeof global=="object"?F=global:typeof self=="object"?F=self:F={},typeof define=="function"?define("vs/base/common/performance",[],function(){return c(F)}):typeof module=="object"&&typeof module.exports=="object"?module.exports=c(F):(console.trace("perf-util defined in UNKNOWN context (neither requirejs or commonjs)"),F.perf=c(F))}(),define(Ee[53],_e([0,1,3]),function(re,e,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CSSIcon=e.getClassNamesArray=e.Codicon=e.getCodiconAriaLabel=e.iconRegistry=void 0;class F{constructor(){this._icons=new Map,this._onDidRegister=new c.Emitter}add(R){const _=this._icons.get(R.id);_?R.description?_.description=R.description:console.error(`Duplicate registration of codicon ${R.id}`):(this._icons.set(R.id,R),this._onDidRegister.fire(R))}get(R){return this._icons.get(R)}get all(){return this._icons.values()}get onDidRegister(){return this._onDidRegister.event}}const w=new F;e.iconRegistry=w;function P(k){return k?k.replace(/\$\((.*?)\)/g,(R,_)=>` ${_} `).trim():""}e.getCodiconAriaLabel=P;class t{constructor(R,_,n){this.id=R,this.definition=_,this.description=n,w.add(this)}get classNames(){return"codicon codicon-"+this.id}get classNamesArray(){return["codicon","codicon-"+this.id]}get cssSelector(){return".codicon.codicon-"+this.id}}e.Codicon=t,t.add=new t("add",{fontCharacter:"\\ea60"}),t.plus=new t("plus",t.add.definition),t.gistNew=new t("gist-new",t.add.definition),t.repoCreate=new t("repo-create",t.add.definition),t.lightbulb=new t("lightbulb",{fontCharacter:"\\ea61"}),t.lightBulb=new t("light-bulb",{fontCharacter:"\\ea61"}),t.repo=new t("repo",{fontCharacter:"\\ea62"}),t.repoDelete=new t("repo-delete",{fontCharacter:"\\ea62"}),t.gistFork=new t("gist-fork",{fontCharacter:"\\ea63"}),t.repoForked=new t("repo-forked",{fontCharacter:"\\ea63"}),t.gitPullRequest=new t("git-pull-request",{fontCharacter:"\\ea64"}),t.gitPullRequestAbandoned=new t("git-pull-request-abandoned",{fontCharacter:"\\ea64"}),t.recordKeys=new t("record-keys",{fontCharacter:"\\ea65"}),t.keyboard=new t("keyboard",{fontCharacter:"\\ea65"}),t.tag=new t("tag",{fontCharacter:"\\ea66"}),t.tagAdd=new t("tag-add",{fontCharacter:"\\ea66"}),t.tagRemove=new t("tag-remove",{fontCharacter:"\\ea66"}),t.person=new t("person",{fontCharacter:"\\ea67"}),t.personFollow=new t("person-follow",{fontCharacter:"\\ea67"}),t.personOutline=new t("person-outline",{fontCharacter:"\\ea67"}),t.personFilled=new t("person-filled",{fontCharacter:"\\ea67"}),t.gitBranch=new t("git-branch",{fontCharacter:"\\ea68"}),t.gitBranchCreate=new t("git-branch-create",{fontCharacter:"\\ea68"}),t.gitBranchDelete=new t("git-branch-delete",{fontCharacter:"\\ea68"}),t.sourceControl=new t("source-control",{fontCharacter:"\\ea68"}),t.mirror=new t("mirror",{fontCharacter:"\\ea69"}),t.mirrorPublic=new t("mirror-public",{fontCharacter:"\\ea69"}),t.star=new t("star",{fontCharacter:"\\ea6a"}),t.starAdd=new t("star-add",{fontCharacter:"\\ea6a"}),t.starDelete=new t("star-delete",{fontCharacter:"\\ea6a"}),t.starEmpty=new t("star-empty",{fontCharacter:"\\ea6a"}),t.comment=new t("comment",{fontCharacter:"\\ea6b"}),t.commentAdd=new t("comment-add",{fontCharacter:"\\ea6b"}),t.alert=new t("alert",{fontCharacter:"\\ea6c"}),t.warning=new t("warning",{fontCharacter:"\\ea6c"}),t.search=new t("search",{fontCharacter:"\\ea6d"}),t.searchSave=new t("search-save",{fontCharacter:"\\ea6d"}),t.logOut=new t("log-out",{fontCharacter:"\\ea6e"}),t.signOut=new t("sign-out",{fontCharacter:"\\ea6e"}),t.logIn=new t("log-in",{fontCharacter:"\\ea6f"}),t.signIn=new t("sign-in",{fontCharacter:"\\ea6f"}),t.eye=new t("eye",{fontCharacter:"\\ea70"}),t.eyeUnwatch=new t("eye-unwatch",{fontCharacter:"\\ea70"}),t.eyeWatch=new t("eye-watch",{fontCharacter:"\\ea70"}),t.circleFilled=new t("circle-filled",{fontCharacter:"\\ea71"}),t.primitiveDot=new t("primitive-dot",{fontCharacter:"\\ea71"}),t.closeDirty=new t("close-dirty",{fontCharacter:"\\ea71"}),t.debugBreakpoint=new t("debug-breakpoint",{fontCharacter:"\\ea71"}),t.debugBreakpointDisabled=new t("debug-breakpoint-disabled",{fontCharacter:"\\ea71"}),t.debugHint=new t("debug-hint",{fontCharacter:"\\ea71"}),t.primitiveSquare=new t("primitive-square",{fontCharacter:"\\ea72"}),t.edit=new t("edit",{fontCharacter:"\\ea73"}),t.pencil=new t("pencil",{fontCharacter:"\\ea73"}),t.info=new t("info",{fontCharacter:"\\ea74"}),t.issueOpened=new t("issue-opened",{fontCharacter:"\\ea74"}),t.gistPrivate=new t("gist-private",{fontCharacter:"\\ea75"}),t.gitForkPrivate=new t("git-fork-private",{fontCharacter:"\\ea75"}),t.lock=new t("lock",{fontCharacter:"\\ea75"}),t.mirrorPrivate=new t("mirror-private",{fontCharacter:"\\ea75"}),t.close=new t("close",{fontCharacter:"\\ea76"}),t.removeClose=new t("remove-close",{fontCharacter:"\\ea76"}),t.x=new t("x",{fontCharacter:"\\ea76"}),t.repoSync=new t("repo-sync",{fontCharacter:"\\ea77"}),t.sync=new t("sync",{fontCharacter:"\\ea77"}),t.clone=new t("clone",{fontCharacter:"\\ea78"}),t.desktopDownload=new t("desktop-download",{fontCharacter:"\\ea78"}),t.beaker=new t("beaker",{fontCharacter:"\\ea79"}),t.microscope=new t("microscope",{fontCharacter:"\\ea79"}),t.vm=new t("vm",{fontCharacter:"\\ea7a"}),t.deviceDesktop=new t("device-desktop",{fontCharacter:"\\ea7a"}),t.file=new t("file",{fontCharacter:"\\ea7b"}),t.fileText=new t("file-text",{fontCharacter:"\\ea7b"}),t.more=new t("more",{fontCharacter:"\\ea7c"}),t.ellipsis=new t("ellipsis",{fontCharacter:"\\ea7c"}),t.kebabHorizontal=new t("kebab-horizontal",{fontCharacter:"\\ea7c"}),t.mailReply=new t("mail-reply",{fontCharacter:"\\ea7d"}),t.reply=new t("reply",{fontCharacter:"\\ea7d"}),t.organization=new t("organization",{fontCharacter:"\\ea7e"}),t.organizationFilled=new t("organization-filled",{fontCharacter:"\\ea7e"}),t.organizationOutline=new t("organization-outline",{fontCharacter:"\\ea7e"}),t.newFile=new t("new-file",{fontCharacter:"\\ea7f"}),t.fileAdd=new t("file-add",{fontCharacter:"\\ea7f"}),t.newFolder=new t("new-folder",{fontCharacter:"\\ea80"}),t.fileDirectoryCreate=new t("file-directory-create",{fontCharacter:"\\ea80"}),t.trash=new t("trash",{fontCharacter:"\\ea81"}),t.trashcan=new t("trashcan",{fontCharacter:"\\ea81"}),t.history=new t("history",{fontCharacter:"\\ea82"}),t.clock=new t("clock",{fontCharacter:"\\ea82"}),t.folder=new t("folder",{fontCharacter:"\\ea83"}),t.fileDirectory=new t("file-directory",{fontCharacter:"\\ea83"}),t.symbolFolder=new t("symbol-folder",{fontCharacter:"\\ea83"}),t.logoGithub=new t("logo-github",{fontCharacter:"\\ea84"}),t.markGithub=new t("mark-github",{fontCharacter:"\\ea84"}),t.github=new t("github",{fontCharacter:"\\ea84"}),t.terminal=new t("terminal",{fontCharacter:"\\ea85"}),t.console=new t("console",{fontCharacter:"\\ea85"}),t.repl=new t("repl",{fontCharacter:"\\ea85"}),t.zap=new t("zap",{fontCharacter:"\\ea86"}),t.symbolEvent=new t("symbol-event",{fontCharacter:"\\ea86"}),t.error=new t("error",{fontCharacter:"\\ea87"}),t.stop=new t("stop",{fontCharacter:"\\ea87"}),t.variable=new t("variable",{fontCharacter:"\\ea88"}),t.symbolVariable=new t("symbol-variable",{fontCharacter:"\\ea88"}),t.array=new t("array",{fontCharacter:"\\ea8a"}),t.symbolArray=new t("symbol-array",{fontCharacter:"\\ea8a"}),t.symbolModule=new t("symbol-module",{fontCharacter:"\\ea8b"}),t.symbolPackage=new t("symbol-package",{fontCharacter:"\\ea8b"}),t.symbolNamespace=new t("symbol-namespace",{fontCharacter:"\\ea8b"}),t.symbolObject=new t("symbol-object",{fontCharacter:"\\ea8b"}),t.symbolMethod=new t("symbol-method",{fontCharacter:"\\ea8c"}),t.symbolFunction=new t("symbol-function",{fontCharacter:"\\ea8c"}),t.symbolConstructor=new t("symbol-constructor",{fontCharacter:"\\ea8c"}),t.symbolBoolean=new t("symbol-boolean",{fontCharacter:"\\ea8f"}),t.symbolNull=new t("symbol-null",{fontCharacter:"\\ea8f"}),t.symbolNumeric=new t("symbol-numeric",{fontCharacter:"\\ea90"}),t.symbolNumber=new t("symbol-number",{fontCharacter:"\\ea90"}),t.symbolStructure=new t("symbol-structure",{fontCharacter:"\\ea91"}),t.symbolStruct=new t("symbol-struct",{fontCharacter:"\\ea91"}),t.symbolParameter=new t("symbol-parameter",{fontCharacter:"\\ea92"}),t.symbolTypeParameter=new t("symbol-type-parameter",{fontCharacter:"\\ea92"}),t.symbolKey=new t("symbol-key",{fontCharacter:"\\ea93"}),t.symbolText=new t("symbol-text",{fontCharacter:"\\ea93"}),t.symbolReference=new t("symbol-reference",{fontCharacter:"\\ea94"}),t.goToFile=new t("go-to-file",{fontCharacter:"\\ea94"}),t.symbolEnum=new t("symbol-enum",{fontCharacter:"\\ea95"}),t.symbolValue=new t("symbol-value",{fontCharacter:"\\ea95"}),t.symbolRuler=new t("symbol-ruler",{fontCharacter:"\\ea96"}),t.symbolUnit=new t("symbol-unit",{fontCharacter:"\\ea96"}),t.activateBreakpoints=new t("activate-breakpoints",{fontCharacter:"\\ea97"}),t.archive=new t("archive",{fontCharacter:"\\ea98"}),t.arrowBoth=new t("arrow-both",{fontCharacter:"\\ea99"}),t.arrowDown=new t("arrow-down",{fontCharacter:"\\ea9a"}),t.arrowLeft=new t("arrow-left",{fontCharacter:"\\ea9b"}),t.arrowRight=new t("arrow-right",{fontCharacter:"\\ea9c"}),t.arrowSmallDown=new t("arrow-small-down",{fontCharacter:"\\ea9d"}),t.arrowSmallLeft=new t("arrow-small-left",{fontCharacter:"\\ea9e"}),t.arrowSmallRight=new t("arrow-small-right",{fontCharacter:"\\ea9f"}),t.arrowSmallUp=new t("arrow-small-up",{fontCharacter:"\\eaa0"}),t.arrowUp=new t("arrow-up",{fontCharacter:"\\eaa1"}),t.bell=new t("bell",{fontCharacter:"\\eaa2"}),t.bold=new t("bold",{fontCharacter:"\\eaa3"}),t.book=new t("book",{fontCharacter:"\\eaa4"}),t.bookmark=new t("bookmark",{fontCharacter:"\\eaa5"}),t.debugBreakpointConditionalUnverified=new t("debug-breakpoint-conditional-unverified",{fontCharacter:"\\eaa6"}),t.debugBreakpointConditional=new t("debug-breakpoint-conditional",{fontCharacter:"\\eaa7"}),t.debugBreakpointConditionalDisabled=new t("debug-breakpoint-conditional-disabled",{fontCharacter:"\\eaa7"}),t.debugBreakpointDataUnverified=new t("debug-breakpoint-data-unverified",{fontCharacter:"\\eaa8"}),t.debugBreakpointData=new t("debug-breakpoint-data",{fontCharacter:"\\eaa9"}),t.debugBreakpointDataDisabled=new t("debug-breakpoint-data-disabled",{fontCharacter:"\\eaa9"}),t.debugBreakpointLogUnverified=new t("debug-breakpoint-log-unverified",{fontCharacter:"\\eaaa"}),t.debugBreakpointLog=new t("debug-breakpoint-log",{fontCharacter:"\\eaab"}),t.debugBreakpointLogDisabled=new t("debug-breakpoint-log-disabled",{fontCharacter:"\\eaab"}),t.briefcase=new t("briefcase",{fontCharacter:"\\eaac"}),t.broadcast=new t("broadcast",{fontCharacter:"\\eaad"}),t.browser=new t("browser",{fontCharacter:"\\eaae"}),t.bug=new t("bug",{fontCharacter:"\\eaaf"}),t.calendar=new t("calendar",{fontCharacter:"\\eab0"}),t.caseSensitive=new t("case-sensitive",{fontCharacter:"\\eab1"}),t.check=new t("check",{fontCharacter:"\\eab2"}),t.checklist=new t("checklist",{fontCharacter:"\\eab3"}),t.chevronDown=new t("chevron-down",{fontCharacter:"\\eab4"}),t.dropDownButton=new t("drop-down-button",t.chevronDown.definition),t.chevronLeft=new t("chevron-left",{fontCharacter:"\\eab5"}),t.chevronRight=new t("chevron-right",{fontCharacter:"\\eab6"}),t.chevronUp=new t("chevron-up",{fontCharacter:"\\eab7"}),t.chromeClose=new t("chrome-close",{fontCharacter:"\\eab8"}),t.chromeMaximize=new t("chrome-maximize",{fontCharacter:"\\eab9"}),t.chromeMinimize=new t("chrome-minimize",{fontCharacter:"\\eaba"}),t.chromeRestore=new t("chrome-restore",{fontCharacter:"\\eabb"}),t.circleOutline=new t("circle-outline",{fontCharacter:"\\eabc"}),t.debugBreakpointUnverified=new t("debug-breakpoint-unverified",{fontCharacter:"\\eabc"}),t.circleSlash=new t("circle-slash",{fontCharacter:"\\eabd"}),t.circuitBoard=new t("circuit-board",{fontCharacter:"\\eabe"}),t.clearAll=new t("clear-all",{fontCharacter:"\\eabf"}),t.clippy=new t("clippy",{fontCharacter:"\\eac0"}),t.closeAll=new t("close-all",{fontCharacter:"\\eac1"}),t.cloudDownload=new t("cloud-download",{fontCharacter:"\\eac2"}),t.cloudUpload=new t("cloud-upload",{fontCharacter:"\\eac3"}),t.code=new t("code",{fontCharacter:"\\eac4"}),t.collapseAll=new t("collapse-all",{fontCharacter:"\\eac5"}),t.colorMode=new t("color-mode",{fontCharacter:"\\eac6"}),t.commentDiscussion=new t("comment-discussion",{fontCharacter:"\\eac7"}),t.compareChanges=new t("compare-changes",{fontCharacter:"\\eafd"}),t.creditCard=new t("credit-card",{fontCharacter:"\\eac9"}),t.dash=new t("dash",{fontCharacter:"\\eacc"}),t.dashboard=new t("dashboard",{fontCharacter:"\\eacd"}),t.database=new t("database",{fontCharacter:"\\eace"}),t.debugContinue=new t("debug-continue",{fontCharacter:"\\eacf"}),t.debugDisconnect=new t("debug-disconnect",{fontCharacter:"\\ead0"}),t.debugPause=new t("debug-pause",{fontCharacter:"\\ead1"}),t.debugRestart=new t("debug-restart",{fontCharacter:"\\ead2"}),t.debugStart=new t("debug-start",{fontCharacter:"\\ead3"}),t.debugStepInto=new t("debug-step-into",{fontCharacter:"\\ead4"}),t.debugStepOut=new t("debug-step-out",{fontCharacter:"\\ead5"}),t.debugStepOver=new t("debug-step-over",{fontCharacter:"\\ead6"}),t.debugStop=new t("debug-stop",{fontCharacter:"\\ead7"}),t.debug=new t("debug",{fontCharacter:"\\ead8"}),t.deviceCameraVideo=new t("device-camera-video",{fontCharacter:"\\ead9"}),t.deviceCamera=new t("device-camera",{fontCharacter:"\\eada"}),t.deviceMobile=new t("device-mobile",{fontCharacter:"\\eadb"}),t.diffAdded=new t("diff-added",{fontCharacter:"\\eadc"}),t.diffIgnored=new t("diff-ignored",{fontCharacter:"\\eadd"}),t.diffModified=new t("diff-modified",{fontCharacter:"\\eade"}),t.diffRemoved=new t("diff-removed",{fontCharacter:"\\eadf"}),t.diffRenamed=new t("diff-renamed",{fontCharacter:"\\eae0"}),t.diff=new t("diff",{fontCharacter:"\\eae1"}),t.discard=new t("discard",{fontCharacter:"\\eae2"}),t.editorLayout=new t("editor-layout",{fontCharacter:"\\eae3"}),t.emptyWindow=new t("empty-window",{fontCharacter:"\\eae4"}),t.exclude=new t("exclude",{fontCharacter:"\\eae5"}),t.extensions=new t("extensions",{fontCharacter:"\\eae6"}),t.eyeClosed=new t("eye-closed",{fontCharacter:"\\eae7"}),t.fileBinary=new t("file-binary",{fontCharacter:"\\eae8"}),t.fileCode=new t("file-code",{fontCharacter:"\\eae9"}),t.fileMedia=new t("file-media",{fontCharacter:"\\eaea"}),t.filePdf=new t("file-pdf",{fontCharacter:"\\eaeb"}),t.fileSubmodule=new t("file-submodule",{fontCharacter:"\\eaec"}),t.fileSymlinkDirectory=new t("file-symlink-directory",{fontCharacter:"\\eaed"}),t.fileSymlinkFile=new t("file-symlink-file",{fontCharacter:"\\eaee"}),t.fileZip=new t("file-zip",{fontCharacter:"\\eaef"}),t.files=new t("files",{fontCharacter:"\\eaf0"}),t.filter=new t("filter",{fontCharacter:"\\eaf1"}),t.flame=new t("flame",{fontCharacter:"\\eaf2"}),t.foldDown=new t("fold-down",{fontCharacter:"\\eaf3"}),t.foldUp=new t("fold-up",{fontCharacter:"\\eaf4"}),t.fold=new t("fold",{fontCharacter:"\\eaf5"}),t.folderActive=new t("folder-active",{fontCharacter:"\\eaf6"}),t.folderOpened=new t("folder-opened",{fontCharacter:"\\eaf7"}),t.gear=new t("gear",{fontCharacter:"\\eaf8"}),t.gift=new t("gift",{fontCharacter:"\\eaf9"}),t.gistSecret=new t("gist-secret",{fontCharacter:"\\eafa"}),t.gist=new t("gist",{fontCharacter:"\\eafb"}),t.gitCommit=new t("git-commit",{fontCharacter:"\\eafc"}),t.gitCompare=new t("git-compare",{fontCharacter:"\\eafd"}),t.gitMerge=new t("git-merge",{fontCharacter:"\\eafe"}),t.githubAction=new t("github-action",{fontCharacter:"\\eaff"}),t.githubAlt=new t("github-alt",{fontCharacter:"\\eb00"}),t.globe=new t("globe",{fontCharacter:"\\eb01"}),t.grabber=new t("grabber",{fontCharacter:"\\eb02"}),t.graph=new t("graph",{fontCharacter:"\\eb03"}),t.gripper=new t("gripper",{fontCharacter:"\\eb04"}),t.heart=new t("heart",{fontCharacter:"\\eb05"}),t.home=new t("home",{fontCharacter:"\\eb06"}),t.horizontalRule=new t("horizontal-rule",{fontCharacter:"\\eb07"}),t.hubot=new t("hubot",{fontCharacter:"\\eb08"}),t.inbox=new t("inbox",{fontCharacter:"\\eb09"}),t.issueClosed=new t("issue-closed",{fontCharacter:"\\eba4"}),t.issueReopened=new t("issue-reopened",{fontCharacter:"\\eb0b"}),t.issues=new t("issues",{fontCharacter:"\\eb0c"}),t.italic=new t("italic",{fontCharacter:"\\eb0d"}),t.jersey=new t("jersey",{fontCharacter:"\\eb0e"}),t.json=new t("json",{fontCharacter:"\\eb0f"}),t.kebabVertical=new t("kebab-vertical",{fontCharacter:"\\eb10"}),t.key=new t("key",{fontCharacter:"\\eb11"}),t.law=new t("law",{fontCharacter:"\\eb12"}),t.lightbulbAutofix=new t("lightbulb-autofix",{fontCharacter:"\\eb13"}),t.linkExternal=new t("link-external",{fontCharacter:"\\eb14"}),t.link=new t("link",{fontCharacter:"\\eb15"}),t.listOrdered=new t("list-ordered",{fontCharacter:"\\eb16"}),t.listUnordered=new t("list-unordered",{fontCharacter:"\\eb17"}),t.liveShare=new t("live-share",{fontCharacter:"\\eb18"}),t.loading=new t("loading",{fontCharacter:"\\eb19"}),t.location=new t("location",{fontCharacter:"\\eb1a"}),t.mailRead=new t("mail-read",{fontCharacter:"\\eb1b"}),t.mail=new t("mail",{fontCharacter:"\\eb1c"}),t.markdown=new t("markdown",{fontCharacter:"\\eb1d"}),t.megaphone=new t("megaphone",{fontCharacter:"\\eb1e"}),t.mention=new t("mention",{fontCharacter:"\\eb1f"}),t.milestone=new t("milestone",{fontCharacter:"\\eb20"}),t.mortarBoard=new t("mortar-board",{fontCharacter:"\\eb21"}),t.move=new t("move",{fontCharacter:"\\eb22"}),t.multipleWindows=new t("multiple-windows",{fontCharacter:"\\eb23"}),t.mute=new t("mute",{fontCharacter:"\\eb24"}),t.noNewline=new t("no-newline",{fontCharacter:"\\eb25"}),t.note=new t("note",{fontCharacter:"\\eb26"}),t.octoface=new t("octoface",{fontCharacter:"\\eb27"}),t.openPreview=new t("open-preview",{fontCharacter:"\\eb28"}),t.package_=new t("package",{fontCharacter:"\\eb29"}),t.paintcan=new t("paintcan",{fontCharacter:"\\eb2a"}),t.pin=new t("pin",{fontCharacter:"\\eb2b"}),t.play=new t("play",{fontCharacter:"\\eb2c"}),t.run=new t("run",{fontCharacter:"\\eb2c"}),t.plug=new t("plug",{fontCharacter:"\\eb2d"}),t.preserveCase=new t("preserve-case",{fontCharacter:"\\eb2e"}),t.preview=new t("preview",{fontCharacter:"\\eb2f"}),t.project=new t("project",{fontCharacter:"\\eb30"}),t.pulse=new t("pulse",{fontCharacter:"\\eb31"}),t.question=new t("question",{fontCharacter:"\\eb32"}),t.quote=new t("quote",{fontCharacter:"\\eb33"}),t.radioTower=new t("radio-tower",{fontCharacter:"\\eb34"}),t.reactions=new t("reactions",{fontCharacter:"\\eb35"}),t.references=new t("references",{fontCharacter:"\\eb36"}),t.refresh=new t("refresh",{fontCharacter:"\\eb37"}),t.regex=new t("regex",{fontCharacter:"\\eb38"}),t.remoteExplorer=new t("remote-explorer",{fontCharacter:"\\eb39"}),t.remote=new t("remote",{fontCharacter:"\\eb3a"}),t.remove=new t("remove",{fontCharacter:"\\eb3b"}),t.replaceAll=new t("replace-all",{fontCharacter:"\\eb3c"}),t.replace=new t("replace",{fontCharacter:"\\eb3d"}),t.repoClone=new t("repo-clone",{fontCharacter:"\\eb3e"}),t.repoForcePush=new t("repo-force-push",{fontCharacter:"\\eb3f"}),t.repoPull=new t("repo-pull",{fontCharacter:"\\eb40"}),t.repoPush=new t("repo-push",{fontCharacter:"\\eb41"}),t.report=new t("report",{fontCharacter:"\\eb42"}),t.requestChanges=new t("request-changes",{fontCharacter:"\\eb43"}),t.rocket=new t("rocket",{fontCharacter:"\\eb44"}),t.rootFolderOpened=new t("root-folder-opened",{fontCharacter:"\\eb45"}),t.rootFolder=new t("root-folder",{fontCharacter:"\\eb46"}),t.rss=new t("rss",{fontCharacter:"\\eb47"}),t.ruby=new t("ruby",{fontCharacter:"\\eb48"}),t.saveAll=new t("save-all",{fontCharacter:"\\eb49"}),t.saveAs=new t("save-as",{fontCharacter:"\\eb4a"}),t.save=new t("save",{fontCharacter:"\\eb4b"}),t.screenFull=new t("screen-full",{fontCharacter:"\\eb4c"}),t.screenNormal=new t("screen-normal",{fontCharacter:"\\eb4d"}),t.searchStop=new t("search-stop",{fontCharacter:"\\eb4e"}),t.server=new t("server",{fontCharacter:"\\eb50"}),t.settingsGear=new t("settings-gear",{fontCharacter:"\\eb51"}),t.settings=new t("settings",{fontCharacter:"\\eb52"}),t.shield=new t("shield",{fontCharacter:"\\eb53"}),t.smiley=new t("smiley",{fontCharacter:"\\eb54"}),t.sortPrecedence=new t("sort-precedence",{fontCharacter:"\\eb55"}),t.splitHorizontal=new t("split-horizontal",{fontCharacter:"\\eb56"}),t.splitVertical=new t("split-vertical",{fontCharacter:"\\eb57"}),t.squirrel=new t("squirrel",{fontCharacter:"\\eb58"}),t.starFull=new t("star-full",{fontCharacter:"\\eb59"}),t.starHalf=new t("star-half",{fontCharacter:"\\eb5a"}),t.symbolClass=new t("symbol-class",{fontCharacter:"\\eb5b"}),t.symbolColor=new t("symbol-color",{fontCharacter:"\\eb5c"}),t.symbolConstant=new t("symbol-constant",{fontCharacter:"\\eb5d"}),t.symbolEnumMember=new t("symbol-enum-member",{fontCharacter:"\\eb5e"}),t.symbolField=new t("symbol-field",{fontCharacter:"\\eb5f"}),t.symbolFile=new t("symbol-file",{fontCharacter:"\\eb60"}),t.symbolInterface=new t("symbol-interface",{fontCharacter:"\\eb61"}),t.symbolKeyword=new t("symbol-keyword",{fontCharacter:"\\eb62"}),t.symbolMisc=new t("symbol-misc",{fontCharacter:"\\eb63"}),t.symbolOperator=new t("symbol-operator",{fontCharacter:"\\eb64"}),t.symbolProperty=new t("symbol-property",{fontCharacter:"\\eb65"}),t.wrench=new t("wrench",{fontCharacter:"\\eb65"}),t.wrenchSubaction=new t("wrench-subaction",{fontCharacter:"\\eb65"}),t.symbolSnippet=new t("symbol-snippet",{fontCharacter:"\\eb66"}),t.tasklist=new t("tasklist",{fontCharacter:"\\eb67"}),t.telescope=new t("telescope",{fontCharacter:"\\eb68"}),t.textSize=new t("text-size",{fontCharacter:"\\eb69"}),t.threeBars=new t("three-bars",{fontCharacter:"\\eb6a"}),t.thumbsdown=new t("thumbsdown",{fontCharacter:"\\eb6b"}),t.thumbsup=new t("thumbsup",{fontCharacter:"\\eb6c"}),t.tools=new t("tools",{fontCharacter:"\\eb6d"}),t.triangleDown=new t("triangle-down",{fontCharacter:"\\eb6e"}),t.triangleLeft=new t("triangle-left",{fontCharacter:"\\eb6f"}),t.triangleRight=new t("triangle-right",{fontCharacter:"\\eb70"}),t.triangleUp=new t("triangle-up",{fontCharacter:"\\eb71"}),t.twitter=new t("twitter",{fontCharacter:"\\eb72"}),t.unfold=new t("unfold",{fontCharacter:"\\eb73"}),t.unlock=new t("unlock",{fontCharacter:"\\eb74"}),t.unmute=new t("unmute",{fontCharacter:"\\eb75"}),t.unverified=new t("unverified",{fontCharacter:"\\eb76"}),t.verified=new t("verified",{fontCharacter:"\\eb77"}),t.versions=new t("versions",{fontCharacter:"\\eb78"}),t.vmActive=new t("vm-active",{fontCharacter:"\\eb79"}),t.vmOutline=new t("vm-outline",{fontCharacter:"\\eb7a"}),t.vmRunning=new t("vm-running",{fontCharacter:"\\eb7b"}),t.watch=new t("watch",{fontCharacter:"\\eb7c"}),t.whitespace=new t("whitespace",{fontCharacter:"\\eb7d"}),t.wholeWord=new t("whole-word",{fontCharacter:"\\eb7e"}),t.window=new t("window",{fontCharacter:"\\eb7f"}),t.wordWrap=new t("word-wrap",{fontCharacter:"\\eb80"}),t.zoomIn=new t("zoom-in",{fontCharacter:"\\eb81"}),t.zoomOut=new t("zoom-out",{fontCharacter:"\\eb82"}),t.listFilter=new t("list-filter",{fontCharacter:"\\eb83"}),t.listFlat=new t("list-flat",{fontCharacter:"\\eb84"}),t.listSelection=new t("list-selection",{fontCharacter:"\\eb85"}),t.selection=new t("selection",{fontCharacter:"\\eb85"}),t.listTree=new t("list-tree",{fontCharacter:"\\eb86"}),t.debugBreakpointFunctionUnverified=new t("debug-breakpoint-function-unverified",{fontCharacter:"\\eb87"}),t.debugBreakpointFunction=new t("debug-breakpoint-function",{fontCharacter:"\\eb88"}),t.debugBreakpointFunctionDisabled=new t("debug-breakpoint-function-disabled",{fontCharacter:"\\eb88"}),t.debugStackframeActive=new t("debug-stackframe-active",{fontCharacter:"\\eb89"}),t.debugStackframeDot=new t("debug-stackframe-dot",{fontCharacter:"\\eb8a"}),t.debugStackframe=new t("debug-stackframe",{fontCharacter:"\\eb8b"}),t.debugStackframeFocused=new t("debug-stackframe-focused",{fontCharacter:"\\eb8b"}),t.debugBreakpointUnsupported=new t("debug-breakpoint-unsupported",{fontCharacter:"\\eb8c"}),t.symbolString=new t("symbol-string",{fontCharacter:"\\eb8d"}),t.debugReverseContinue=new t("debug-reverse-continue",{fontCharacter:"\\eb8e"}),t.debugStepBack=new t("debug-step-back",{fontCharacter:"\\eb8f"}),t.debugRestartFrame=new t("debug-restart-frame",{fontCharacter:"\\eb90"}),t.callIncoming=new t("call-incoming",{fontCharacter:"\\eb92"}),t.callOutgoing=new t("call-outgoing",{fontCharacter:"\\eb93"}),t.menu=new t("menu",{fontCharacter:"\\eb94"}),t.expandAll=new t("expand-all",{fontCharacter:"\\eb95"}),t.feedback=new t("feedback",{fontCharacter:"\\eb96"}),t.groupByRefType=new t("group-by-ref-type",{fontCharacter:"\\eb97"}),t.ungroupByRefType=new t("ungroup-by-ref-type",{fontCharacter:"\\eb98"}),t.account=new t("account",{fontCharacter:"\\eb99"}),t.bellDot=new t("bell-dot",{fontCharacter:"\\eb9a"}),t.debugConsole=new t("debug-console",{fontCharacter:"\\eb9b"}),t.library=new t("library",{fontCharacter:"\\eb9c"}),t.output=new t("output",{fontCharacter:"\\eb9d"}),t.runAll=new t("run-all",{fontCharacter:"\\eb9e"}),t.syncIgnored=new t("sync-ignored",{fontCharacter:"\\eb9f"}),t.pinned=new t("pinned",{fontCharacter:"\\eba0"}),t.githubInverted=new t("github-inverted",{fontCharacter:"\\eba1"}),t.debugAlt=new t("debug-alt",{fontCharacter:"\\eb91"}),t.serverProcess=new t("server-process",{fontCharacter:"\\eba2"}),t.serverEnvironment=new t("server-environment",{fontCharacter:"\\eba3"}),t.pass=new t("pass",{fontCharacter:"\\eba4"}),t.stopCircle=new t("stop-circle",{fontCharacter:"\\eba5"}),t.playCircle=new t("play-circle",{fontCharacter:"\\eba6"}),t.record=new t("record",{fontCharacter:"\\eba7"}),t.debugAltSmall=new t("debug-alt-small",{fontCharacter:"\\eba8"}),t.vmConnect=new t("vm-connect",{fontCharacter:"\\eba9"}),t.cloud=new t("cloud",{fontCharacter:"\\ebaa"}),t.merge=new t("merge",{fontCharacter:"\\ebab"}),t.exportIcon=new t("export",{fontCharacter:"\\ebac"}),t.graphLeft=new t("graph-left",{fontCharacter:"\\ebad"}),t.magnet=new t("magnet",{fontCharacter:"\\ebae"}),t.notebook=new t("notebook",{fontCharacter:"\\ebaf"}),t.redo=new t("redo",{fontCharacter:"\\ebb0"}),t.checkAll=new t("check-all",{fontCharacter:"\\ebb1"}),t.pinnedDirty=new t("pinned-dirty",{fontCharacter:"\\ebb2"}),t.passFilled=new t("pass-filled",{fontCharacter:"\\ebb3"}),t.circleLargeFilled=new t("circle-large-filled",{fontCharacter:"\\ebb4"}),t.circleLargeOutline=new t("circle-large-outline",{fontCharacter:"\\ebb5"}),t.combine=new t("combine",{fontCharacter:"\\ebb6"}),t.gather=new t("gather",{fontCharacter:"\\ebb6"}),t.table=new t("table",{fontCharacter:"\\ebb7"}),t.variableGroup=new t("variable-group",{fontCharacter:"\\ebb8"}),t.typeHierarchy=new t("type-hierarchy",{fontCharacter:"\\ebb9"}),t.typeHierarchySub=new t("type-hierarchy-sub",{fontCharacter:"\\ebba"}),t.typeHierarchySuper=new t("type-hierarchy-super",{fontCharacter:"\\ebbb"}),t.gitPullRequestCreate=new t("git-pull-request-create",{fontCharacter:"\\ebbc"}),t.runAbove=new t("run-above",{fontCharacter:"\\ebbd"}),t.runBelow=new t("run-below",{fontCharacter:"\\ebbe"}),t.notebookTemplate=new t("notebook-template",{fontCharacter:"\\ebbf"}),t.debugRerun=new t("debug-rerun",{fontCharacter:"\\ebc0"}),t.workspaceTrusted=new t("workspace-trusted",{fontCharacter:"\\ebc1"}),t.workspaceUntrusted=new t("workspace-untrusted",{fontCharacter:"\\ebc2"}),t.workspaceUnspecified=new t("workspace-unspecified",{fontCharacter:"\\ebc3"}),t.terminalCmd=new t("terminal-cmd",{fontCharacter:"\\ebc4"}),t.terminalDebian=new t("terminal-debian",{fontCharacter:"\\ebc5"}),t.terminalLinux=new t("terminal-linux",{fontCharacter:"\\ebc6"}),t.terminalPowershell=new t("terminal-powershell",{fontCharacter:"\\ebc7"}),t.terminalTmux=new t("terminal-tmux",{fontCharacter:"\\ebc8"}),t.terminalUbuntu=new t("terminal-ubuntu",{fontCharacter:"\\ebc9"}),t.terminalBash=new t("terminal-bash",{fontCharacter:"\\ebca"}),t.arrowSwap=new t("arrow-swap",{fontCharacter:"\\ebcb"}),t.copy=new t("copy",{fontCharacter:"\\ebcc"}),t.personAdd=new t("person-add",{fontCharacter:"\\ebcd"}),t.filterFilled=new t("filter-filled",{fontCharacter:"\\ebce"}),t.wand=new t("wand",{fontCharacter:"\\ebcf"}),t.debugLineByLine=new t("debug-line-by-line",{fontCharacter:"\\ebd0"}),t.inspect=new t("inspect",{fontCharacter:"\\ebd1"}),t.layers=new t("layers",{fontCharacter:"\\ebd2"}),t.layersDot=new t("layers-dot",{fontCharacter:"\\ebd3"}),t.layersActive=new t("layers-active",{fontCharacter:"\\ebd4"}),t.compass=new t("compass",{fontCharacter:"\\ebd5"}),t.compassDot=new t("compass-dot",{fontCharacter:"\\ebd6"}),t.compassActive=new t("compass-active",{fontCharacter:"\\ebd7"}),t.azure=new t("azure",{fontCharacter:"\\ebd8"}),t.issueDraft=new t("issue-draft",{fontCharacter:"\\ebd9"}),t.gitPullRequestClosed=new t("git-pull-request-closed",{fontCharacter:"\\ebda"}),t.gitPullRequestDraft=new t("git-pull-request-draft",{fontCharacter:"\\ebdb"}),t.debugAll=new t("debug-all",{fontCharacter:"\\ebdc"}),t.debugCoverage=new t("debug-coverage",{fontCharacter:"\\ebdd"}),t.runErrors=new t("run-errors",{fontCharacter:"\\ebde"}),t.folderLibrary=new t("folder-library",{fontCharacter:"\\ebdf"}),t.debugContinueSmall=new t("debug-continue-small",{fontCharacter:"\\ebe0"}),t.beakerStop=new t("beaker-stop",{fontCharacter:"\\ebe1"}),t.graphLine=new t("graph-line",{fontCharacter:"\\ebe2"}),t.graphScatter=new t("graph-scatter",{fontCharacter:"\\ebe3"}),t.pieChart=new t("pie-chart",{fontCharacter:"\\ebe4"}),t.bracket=new t("bracket",t.json.definition),t.bracketDot=new t("bracket-dot",{fontCharacter:"\\ebe5"}),t.bracketError=new t("bracket-error",{fontCharacter:"\\ebe6"}),t.lockSmall=new t("lock-small",{fontCharacter:"\\ebe7"}),t.azureDevops=new t("azure-devops",{fontCharacter:"\\ebe8"}),t.verifiedFilled=new t("verified-filled",{fontCharacter:"\\ebe9"}),t.newLine=new t("newline",{fontCharacter:"\\ebea"}),t.layout=new t("layout",{fontCharacter:"\\ebeb"}),t.dialogError=new t("dialog-error",t.error.definition),t.dialogWarning=new t("dialog-warning",t.warning.definition),t.dialogInfo=new t("dialog-info",t.info.definition),t.dialogClose=new t("dialog-close",t.close.definition),t.treeItemExpanded=new t("tree-item-expanded",t.chevronDown.definition),t.treeFilterOnTypeOn=new t("tree-filter-on-type-on",t.listFilter.definition),t.treeFilterOnTypeOff=new t("tree-filter-on-type-off",t.listSelection.definition),t.treeFilterClear=new t("tree-filter-clear",t.close.definition),t.treeItemLoading=new t("tree-item-loading",t.loading.definition),t.menuSelection=new t("menu-selection",t.check.definition),t.menuSubmenu=new t("menu-submenu",t.chevronRight.definition),t.menuBarMore=new t("menubar-more",t.more.definition),t.scrollbarButtonLeft=new t("scrollbar-button-left",t.triangleLeft.definition),t.scrollbarButtonRight=new t("scrollbar-button-right",t.triangleRight.definition),t.scrollbarButtonUp=new t("scrollbar-button-up",t.triangleUp.definition),t.scrollbarButtonDown=new t("scrollbar-button-down",t.triangleDown.definition),t.toolBarMore=new t("toolbar-more",t.more.definition),t.quickInputBack=new t("quick-input-back",t.arrowLeft.definition);function T(k,R){const _=["codicon","codicon-"+k];return R&&_.push("codicon-modifier-"+R),_}e.getClassNamesArray=T;var C;(function(k){k.iconNameSegment="[A-Za-z0-9]+",k.iconNameExpression="[A-Za-z0-9-]+",k.iconModifierExpression="~[A-Za-z]+",k.iconNameCharacter="[A-Za-z0-9~-]";const R=new RegExp(`^(${k.iconNameExpression})(${k.iconModifierExpression})?$`);function _(o){if(o instanceof t)return["codicon","codicon-"+o.id];const d=R.exec(o.id);if(!d)return _(t.error);let[,u,S]=d;const b=["codicon","codicon-"+u];return S&&b.push("codicon-modifier-"+S.substr(1)),b}k.asClassNameArray=_;function n(o){return _(o).join(" ")}k.asClassName=n;function m(o){return"."+_(o).join(".")}k.asCSSSelector=m})(C=e.CSSIcon||(e.CSSIcon={}))}),define(Ee[102],_e([0,1,15,6]),function(re,e,c,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.prefixedStream=e.prefixedReadable=e.transform=e.toReadable=e.emptyStream=e.toStream=e.peekStream=e.listenStream=e.consumeStream=e.peekReadable=e.consumeReadable=e.newWriteableStream=e.isReadableBufferedStream=e.isReadableStream=void 0;function w(h){const g=h;return g?[g.on,g.pause,g.resume,g.destroy].every(A=>typeof A=="function"):!1}e.isReadableStream=w;function P(h){const g=h;return g?w(g.stream)&&Array.isArray(g.buffer)&&typeof g.ended=="boolean":!1}e.isReadableBufferedStream=P;function t(h,g){return new T(h,g)}e.newWriteableStream=t;class T{constructor(g,A){this.reducer=g,this.options=A,this.state={flowing:!1,ended:!1,destroyed:!1},this.buffer={data:[],error:[]},this.listeners={data:[],error:[],end:[]},this.pendingWritePromises=[]}pause(){this.state.destroyed||(this.state.flowing=!1)}resume(){this.state.destroyed||this.state.flowing||(this.state.flowing=!0,this.flowData(),this.flowErrors(),this.flowEnd())}write(g){if(!this.state.destroyed){if(this.state.flowing)this.emitData(g);else if(this.buffer.data.push(g),typeof this.options?.highWaterMark=="number"&&this.buffer.data.length>this.options.highWaterMark)return new Promise(A=>this.pendingWritePromises.push(A))}}error(g){this.state.destroyed||(this.state.flowing?this.emitError(g):this.buffer.error.push(g))}end(g){this.state.destroyed||(typeof g!="undefined"&&this.write(g),this.state.flowing?(this.emitEnd(),this.destroy()):this.state.ended=!0)}emitData(g){this.listeners.data.slice(0).forEach(A=>A(g))}emitError(g){this.listeners.error.length===0?(0,c.onUnexpectedError)(g):this.listeners.error.slice(0).forEach(A=>A(g))}emitEnd(){this.listeners.end.slice(0).forEach(g=>g())}on(g,A){if(!this.state.destroyed)switch(g){case"data":this.listeners.data.push(A),this.resume();break;case"end":this.listeners.end.push(A),this.state.flowing&&this.flowEnd()&&this.destroy();break;case"error":this.listeners.error.push(A),this.state.flowing&&this.flowErrors();break}}removeListener(g,A){if(this.state.destroyed)return;let l;switch(g){case"data":l=this.listeners.data;break;case"end":l=this.listeners.end;break;case"error":l=this.listeners.error;break}if(l){const M=l.indexOf(A);M>=0&&l.splice(M,1)}}flowData(){if(this.buffer.data.length>0){const g=this.reducer(this.buffer.data);this.emitData(g),this.buffer.data.length=0;const A=[...this.pendingWritePromises];this.pendingWritePromises.length=0,A.forEach(l=>l())}}flowErrors(){if(this.listeners.error.length>0){for(const g of this.buffer.error)this.emitError(g);this.buffer.error.length=0}}flowEnd(){return this.state.ended?(this.emitEnd(),this.listeners.end.length>0):!1}destroy(){this.state.destroyed||(this.state.destroyed=!0,this.state.ended=!0,this.buffer.data.length=0,this.buffer.error.length=0,this.listeners.data.length=0,this.listeners.error.length=0,this.listeners.end.length=0,this.pendingWritePromises.length=0)}}function C(h,g){const A=[];let l;for(;(l=h.read())!==null;)A.push(l);return g(A)}e.consumeReadable=C;function k(h,g,A){const l=[];let M;for(;(M=h.read())!==null&&l.length<A;)l.push(M);return M===null&&l.length>0?g(l):{read:()=>{if(l.length>0)return l.shift();if(typeof M!="undefined"){const r=M;return M=void 0,r}return h.read()}}}e.peekReadable=k;function R(h,g){return new Promise((A,l)=>{const M=[];_(h,{onData:r=>{g&&M.push(r)},onError:r=>{g?l(r):A(void 0)},onEnd:()=>{A(g?g(M):void 0)}})})}e.consumeStream=R;function _(h,g){h.on("error",A=>g.onError(A)),h.on("end",()=>g.onEnd()),h.on("data",A=>g.onData(A))}e.listenStream=_;function n(h,g){return new Promise((A,l)=>{const M=new F.DisposableStore,r=[],i=s=>{if(r.push(s),r.length>g)return M.dispose(),h.pause(),A({stream:h,buffer:r,ended:!1})},p=s=>l(s),f=()=>A({stream:h,buffer:r,ended:!0});M.add((0,F.toDisposable)(()=>h.removeListener("error",p))),h.on("error",p),M.add((0,F.toDisposable)(()=>h.removeListener("end",f))),h.on("end",f),M.add((0,F.toDisposable)(()=>h.removeListener("data",i))),h.on("data",i)})}e.peekStream=n;function m(h,g){const A=t(g);return A.end(h),A}e.toStream=m;function o(){const h=t(()=>{throw new Error("not supported")});return h.end(),h}e.emptyStream=o;function d(h){let g=!1;return{read:()=>g?null:(g=!0,h)}}e.toReadable=d;function u(h,g,A){const l=t(A);return _(h,{onData:M=>l.write(g.data(M)),onError:M=>l.error(g.error?g.error(M):M),onEnd:()=>l.end()}),l}e.transform=u;function S(h,g,A){let l=!1;return{read:()=>{const M=g.read();return l?M:(l=!0,M!==null?A([h,M]):h)}}}e.prefixedReadable=S;function b(h,g,A){let l=!1;const M=t(A);return _(g,{onData:r=>l?M.write(r):(l=!0,M.write(A([h,r]))),onError:r=>M.error(r),onEnd:()=>{l||(l=!0,M.write(h)),M.end()}}),M}e.prefixedStream=b}),define(Ee[22],_e([0,1,102]),function(re,e,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.prefixedBufferStream=e.prefixedBufferReadable=e.newWriteableBufferStream=e.streamToBufferReadableStream=e.bufferToStream=e.bufferedStreamToBuffer=e.streamToBuffer=e.bufferToReadable=e.readableToBuffer=e.writeUInt8=e.readUInt8=e.writeUInt32LE=e.readUInt32LE=e.writeUInt32BE=e.readUInt32BE=e.writeUInt16LE=e.readUInt16LE=e.VSBuffer=void 0;const F=typeof Buffer!="undefined";let w,P;class t{constructor(i){this.buffer=i,this.byteLength=this.buffer.byteLength}static alloc(i){return F?new t(Buffer.allocUnsafe(i)):new t(new Uint8Array(i))}static wrap(i){return F&&!Buffer.isBuffer(i)&&(i=Buffer.from(i.buffer,i.byteOffset,i.byteLength)),new t(i)}static fromString(i,p){return!(p?.dontUseNodeBuffer||!1)&&F?new t(Buffer.from(i)):(w||(w=new TextEncoder),new t(w.encode(i)))}static fromByteArray(i){const p=t.alloc(i.length);for(let f=0,s=i.length;f<s;f++)p.buffer[f]=i[f];return p}static concat(i,p){if(typeof p=="undefined"){p=0;for(let v=0,a=i.length;v<a;v++)p+=i[v].byteLength}const f=t.alloc(p);let s=0;for(let v=0,a=i.length;v<a;v++){const E=i[v];f.set(E,s),s+=E.byteLength}return f}clone(){const i=t.alloc(this.byteLength);return i.set(this),i}toString(){return F?this.buffer.toString():(P||(P=new TextDecoder),P.decode(this.buffer))}slice(i,p){return new t(this.buffer.subarray(i,p))}set(i,p){if(i instanceof t)this.buffer.set(i.buffer,p);else if(i instanceof Uint8Array)this.buffer.set(i,p);else if(i instanceof ArrayBuffer)this.buffer.set(new Uint8Array(i),p);else if(ArrayBuffer.isView(i))this.buffer.set(new Uint8Array(i.buffer,i.byteOffset,i.byteLength),p);else throw new Error("Unkown argument 'array'")}readUInt32BE(i){return k(this.buffer,i)}writeUInt32BE(i,p){R(this.buffer,i,p)}readUInt32LE(i){return _(this.buffer,i)}writeUInt32LE(i,p){n(this.buffer,i,p)}readUInt8(i){return m(this.buffer,i)}writeUInt8(i,p){o(this.buffer,i,p)}}e.VSBuffer=t;function T(r,i){return r[i+0]<<0>>>0|r[i+1]<<8>>>0}e.readUInt16LE=T;function C(r,i,p){r[p+0]=i&255,i=i>>>8,r[p+1]=i&255}e.writeUInt16LE=C;function k(r,i){return r[i]*2**24+r[i+1]*2**16+r[i+2]*2**8+r[i+3]}e.readUInt32BE=k;function R(r,i,p){r[p+3]=i,i=i>>>8,r[p+2]=i,i=i>>>8,r[p+1]=i,i=i>>>8,r[p]=i}e.writeUInt32BE=R;function _(r,i){return r[i+0]<<0>>>0|r[i+1]<<8>>>0|r[i+2]<<16>>>0|r[i+3]<<24>>>0}e.readUInt32LE=_;function n(r,i,p){r[p+0]=i&255,i=i>>>8,r[p+1]=i&255,i=i>>>8,r[p+2]=i&255,i=i>>>8,r[p+3]=i&255}e.writeUInt32LE=n;function m(r,i){return r[i]}e.readUInt8=m;function o(r,i,p){r[p]=i}e.writeUInt8=o;function d(r){return c.consumeReadable(r,i=>t.concat(i))}e.readableToBuffer=d;function u(r){return c.toReadable(r)}e.bufferToReadable=u;function S(r){return c.consumeStream(r,i=>t.concat(i))}e.streamToBuffer=S;async function b(r){return r.ended?t.concat(r.buffer):t.concat([...r.buffer,await S(r.stream)])}e.bufferedStreamToBuffer=b;function h(r){return c.toStream(r,i=>t.concat(i))}e.bufferToStream=h;function g(r){return c.transform(r,{data:i=>typeof i=="string"?t.fromString(i):t.wrap(i)},i=>t.concat(i))}e.streamToBufferReadableStream=g;function A(r){return c.newWriteableStream(i=>t.concat(i),r)}e.newWriteableBufferStream=A;function l(r,i){return c.prefixedReadable(r,i,p=>t.concat(p))}e.prefixedBufferReadable=l;function M(r,i){return c.prefixedStream(r,i,p=>t.concat(p))}e.prefixedBufferStream=M});var Ze=this&&this.__classPrivateFieldSet||function(re,e,c,F,w){if(F==="m")throw new TypeError("Private method is not writable");if(F==="a"&&!w)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?re!==e||!w:!e.has(re))throw new TypeError("Cannot write private member to an object whose class did not declare it");return F==="a"?w.call(re,c):w?w.value=c:e.set(re,c),c},Te=this&&this.__classPrivateFieldGet||function(re,e,c,F){if(c==="a"&&!F)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?re!==e||!F:!e.has(re))throw new TypeError("Cannot read private member from an object whose class did not declare it");return c==="m"?F:c==="a"?F.call(re):F?F.value:e.get(re)};define(Ee[21],_e([0,1,16,9]),function(re,e,c,F){"use strict";var w,P,t;Object.defineProperty(e,"__esModule",{value:!0}),e.ReadonlyMapView=e.LRUCache=e.LinkedMap=e.Touch=e.ResourceMap=e.TernarySearchTree=e.UriIterator=e.PathIterator=e.ConfigKeysIterator=e.StringIterator=e.setToString=e.mapToString=e.getOrSet=void 0;function T(r,i,p){let f=r.get(i);return f===void 0&&(f=p,r.set(i,f)),f}e.getOrSet=T;function C(r){const i=[];return r.forEach((p,f)=>{i.push(`${f} => ${p}`)}),`Map(${r.size}) {${i.join(", ")}}`}e.mapToString=C;function k(r){const i=[];return r.forEach(p=>{i.push(p)}),`Set(${r.size}) {${i.join(", ")}}`}e.setToString=k;class R{constructor(){this._value="",this._pos=0}reset(i){return this._value=i,this._pos=0,this}next(){return this._pos+=1,this}hasNext(){return this._pos<this._value.length-1}cmp(i){const p=i.charCodeAt(0),f=this._value.charCodeAt(this._pos);return p-f}value(){return this._value[this._pos]}}e.StringIterator=R;class _{constructor(i=!0){this._caseSensitive=i}reset(i){return this._value=i,this._from=0,this._to=0,this.next()}hasNext(){return this._to<this._value.length}next(){this._from=this._to;let i=!0;for(;this._to<this._value.length;this._to++)if(this._value.charCodeAt(this._to)===46)if(i)this._from++;else break;else i=!1;return this}cmp(i){return this._caseSensitive?(0,F.compareSubstring)(i,this._value,0,i.length,this._from,this._to):(0,F.compareSubstringIgnoreCase)(i,this._value,0,i.length,this._from,this._to)}value(){return this._value.substring(this._from,this._to)}}e.ConfigKeysIterator=_;class n{constructor(i=!0,p=!0){this._splitOnBackslash=i,this._caseSensitive=p}reset(i){return this._value=i.replace(/\\$|\/$/,""),this._from=0,this._to=0,this.next()}hasNext(){return this._to<this._value.length}next(){this._from=this._to;let i=!0;for(;this._to<this._value.length;this._to++){const p=this._value.charCodeAt(this._to);if(p===47||this._splitOnBackslash&&p===92)if(i)this._from++;else break;else i=!1}return this}cmp(i){return this._caseSensitive?(0,F.compareSubstring)(i,this._value,0,i.length,this._from,this._to):(0,F.compareSubstringIgnoreCase)(i,this._value,0,i.length,this._from,this._to)}value(){return this._value.substring(this._from,this._to)}}e.PathIterator=n;var m;(function(r){r[r.Scheme=1]="Scheme",r[r.Authority=2]="Authority",r[r.Path=3]="Path",r[r.Query=4]="Query",r[r.Fragment=5]="Fragment"})(m||(m={}));class o{constructor(i){this._ignorePathCasing=i,this._states=[],this._stateIdx=0}reset(i){return this._value=i,this._states=[],this._value.scheme&&this._states.push(1),this._value.authority&&this._states.push(2),this._value.path&&(this._pathIterator=new n(!1,!this._ignorePathCasing(i)),this._pathIterator.reset(i.path),this._pathIterator.value()&&this._states.push(3)),this._value.query&&this._states.push(4),this._value.fragment&&this._states.push(5),this._stateIdx=0,this}next(){return this._states[this._stateIdx]===3&&this._pathIterator.hasNext()?this._pathIterator.next():this._stateIdx+=1,this}hasNext(){return this._states[this._stateIdx]===3&&this._pathIterator.hasNext()||this._stateIdx<this._states.length-1}cmp(i){if(this._states[this._stateIdx]===1)return(0,F.compareIgnoreCase)(i,this._value.scheme);if(this._states[this._stateIdx]===2)return(0,F.compareIgnoreCase)(i,this._value.authority);if(this._states[this._stateIdx]===3)return this._pathIterator.cmp(i);if(this._states[this._stateIdx]===4)return(0,F.compare)(i,this._value.query);if(this._states[this._stateIdx]===5)return(0,F.compare)(i,this._value.fragment);throw new Error}value(){if(this._states[this._stateIdx]===1)return this._value.scheme;if(this._states[this._stateIdx]===2)return this._value.authority;if(this._states[this._stateIdx]===3)return this._pathIterator.value();if(this._states[this._stateIdx]===4)return this._value.query;if(this._states[this._stateIdx]===5)return this._value.fragment;throw new Error}}e.UriIterator=o;class d{constructor(){this.height=1}isEmpty(){return!this.left&&!this.mid&&!this.right&&!this.value}rotateLeft(){const i=this.right;return this.right=i.left,i.left=this,this.updateHeight(),i.updateHeight(),i}rotateRight(){const i=this.left;return this.left=i.right,i.right=this,this.updateHeight(),i.updateHeight(),i}updateHeight(){this.height=1+Math.max(this.heightLeft,this.heightRight)}balanceFactor(){return this.heightRight-this.heightLeft}get heightLeft(){return this.left?.height??0}get heightRight(){return this.right?.height??0}}var u;(function(r){r[r.Left=-1]="Left",r[r.Mid=0]="Mid",r[r.Right=1]="Right"})(u||(u={}));class S{constructor(i){this._iter=i}static forUris(i=()=>!1){return new S(new o(i))}static forPaths(){return new S(new n)}static forStrings(){return new S(new R)}static forConfigKeys(){return new S(new _)}clear(){this._root=void 0}fill(i,p){if(p){const f=p.slice(0);(0,c.shuffle)(f);for(let s of f)this.set(s,i)}else{const f=i.slice(0);(0,c.shuffle)(f);for(let s of f)this.set(s[0],s[1])}}set(i,p){const f=this._iter.reset(i);let s;this._root||(this._root=new d,this._root.segment=f.value());const v=[];for(s=this._root;;){const E=f.cmp(s.segment);if(E>0)s.left||(s.left=new d,s.left.segment=f.value()),v.push([-1,s]),s=s.left;else if(E<0)s.right||(s.right=new d,s.right.segment=f.value()),v.push([1,s]),s=s.right;else if(f.hasNext())f.next(),s.mid||(s.mid=new d,s.mid.segment=f.value()),v.push([0,s]),s=s.mid;else break}const a=s.value;s.value=p,s.key=i;for(let E=v.length-1;E>=0;E--){const I=v[E][1];I.updateHeight();const D=I.balanceFactor();if(D<-1||D>1){const B=v[E][0],L=v[E+1][0];if(B===1&&L===1)v[E][1]=I.rotateLeft();else if(B===-1&&L===-1)v[E][1]=I.rotateRight();else if(B===1&&L===-1)I.right=v[E+1][1]=v[E+1][1].rotateRight(),v[E][1]=I.rotateLeft();else if(B===-1&&L===1)I.left=v[E+1][1]=v[E+1][1].rotateLeft(),v[E][1]=I.rotateRight();else throw new Error;if(E>0)switch(v[E-1][0]){case-1:v[E-1][1].left=v[E][1];break;case 1:v[E-1][1].right=v[E][1];break;case 0:v[E-1][1].mid=v[E][1];break}else this._root=v[0][1]}}return a}get(i){return this._getNode(i)?.value}_getNode(i){const p=this._iter.reset(i);let f=this._root;for(;f;){const s=p.cmp(f.segment);if(s>0)f=f.left;else if(s<0)f=f.right;else if(p.hasNext())p.next(),f=f.mid;else break}return f}has(i){const p=this._getNode(i);return!(p?.value===void 0&&p?.mid===void 0)}delete(i){return this._delete(i,!1)}deleteSuperstr(i){return this._delete(i,!0)}_delete(i,p){const f=this._iter.reset(i),s=[];let v=this._root;for(;v;){const a=f.cmp(v.segment);if(a>0)s.push([-1,v]),v=v.left;else if(a<0)s.push([1,v]),v=v.right;else if(f.hasNext())f.next(),s.push([0,v]),v=v.mid;else break}if(!!v){if(p?(v.left=void 0,v.mid=void 0,v.right=void 0,v.height=1):(v.key=void 0,v.value=void 0),!v.mid&&!v.value)if(v.left&&v.right){const a=this._min(v.right),{key:E,value:I,segment:D}=a;this._delete(a.key,!1),v.key=E,v.value=I,v.segment=D}else{const a=v.left??v.right;if(s.length>0){const[E,I]=s[s.length-1];switch(E){case-1:I.left=a;break;case 0:I.mid=a;break;case 1:I.right=a;break}}else this._root=a}for(let a=s.length-1;a>=0;a--){const E=s[a][1];E.updateHeight();const I=E.balanceFactor();if(I>1?(E.right.balanceFactor()>=0||(E.right=s[a+1][1]=s[a+1][1].rotateRight()),s[a][1]=E.rotateLeft()):I<-1&&(E.left.balanceFactor()<=0||(E.left=s[a+1][1]=s[a+1][1].rotateLeft()),s[a][1]=E.rotateRight()),a>0)switch(s[a-1][0]){case-1:s[a-1][1].left=s[a][1];break;case 1:s[a-1][1].right=s[a][1];break;case 0:s[a-1][1].mid=s[a][1];break}else this._root=s[0][1]}}}_min(i){for(;i.left;)i=i.left;return i}findSubstr(i){const p=this._iter.reset(i);let f=this._root,s;for(;f;){const v=p.cmp(f.segment);if(v>0)f=f.left;else if(v<0)f=f.right;else if(p.hasNext())p.next(),s=f.value||s,f=f.mid;else break}return f&&f.value||s}findSuperstr(i){const p=this._iter.reset(i);let f=this._root;for(;f;){const s=p.cmp(f.segment);if(s>0)f=f.left;else if(s<0)f=f.right;else if(p.hasNext())p.next(),f=f.mid;else return f.mid?this._entries(f.mid):void 0}}forEach(i){for(const[p,f]of this)i(f,p)}*[Symbol.iterator](){yield*this._entries(this._root)}*_entries(i){!i||(i.left&&(yield*this._entries(i.left)),i.value&&(yield[i.key,i.value]),i.mid&&(yield*this._entries(i.mid)),i.right&&(yield*this._entries(i.right)))}_isBalanced(){const i=p=>{if(!p)return!0;const f=p.balanceFactor();return f<-1||f>1?!1:i(p.left)&&i(p.right)};return i(this._root)}}e.TernarySearchTree=S;class b{constructor(i,p){this.uri=i,this.value=p}}class h{constructor(i,p){this[w]="ResourceMap",i instanceof h?(this.map=new Map(i.map),this.toKey=p??h.defaultToKey):(this.map=new Map,this.toKey=i??h.defaultToKey)}set(i,p){return this.map.set(this.toKey(i),new b(i,p)),this}get(i){return this.map.get(this.toKey(i))?.value}has(i){return this.map.has(this.toKey(i))}get size(){return this.map.size}clear(){this.map.clear()}delete(i){return this.map.delete(this.toKey(i))}forEach(i,p){typeof p!="undefined"&&(i=i.bind(p));for(let[f,s]of this.map)i(s.value,s.uri,this)}*values(){for(let i of this.map.values())yield i.value}*keys(){for(let i of this.map.values())yield i.uri}*entries(){for(let i of this.map.values())yield[i.uri,i.value]}*[(w=Symbol.toStringTag,Symbol.iterator)](){for(let[,i]of this.map)yield[i.uri,i.value]}}e.ResourceMap=h,h.defaultToKey=r=>r.toString();var g;(function(r){r[r.None=0]="None",r[r.AsOld=1]="AsOld",r[r.AsNew=2]="AsNew"})(g=e.Touch||(e.Touch={}));class A{constructor(){this[P]="LinkedMap",this._map=new Map,this._head=void 0,this._tail=void 0,this._size=0,this._state=0}clear(){this._map.clear(),this._head=void 0,this._tail=void 0,this._size=0,this._state++}isEmpty(){return!this._head&&!this._tail}get size(){return this._size}get first(){return this._head?.value}get last(){return this._tail?.value}has(i){return this._map.has(i)}get(i,p=0){const f=this._map.get(i);if(!!f)return p!==0&&this.touch(f,p),f.value}set(i,p,f=0){let s=this._map.get(i);if(s)s.value=p,f!==0&&this.touch(s,f);else{switch(s={key:i,value:p,next:void 0,previous:void 0},f){case 0:this.addItemLast(s);break;case 1:this.addItemFirst(s);break;case 2:this.addItemLast(s);break;default:this.addItemLast(s);break}this._map.set(i,s),this._size++}return this}delete(i){return!!this.remove(i)}remove(i){const p=this._map.get(i);if(!!p)return this._map.delete(i),this.removeItem(p),this._size--,p.value}shift(){if(!this._head&&!this._tail)return;if(!this._head||!this._tail)throw new Error("Invalid list");const i=this._head;return this._map.delete(i.key),this.removeItem(i),this._size--,i.value}forEach(i,p){const f=this._state;let s=this._head;for(;s;){if(p?i.bind(p)(s.value,s.key,this):i(s.value,s.key,this),this._state!==f)throw new Error("LinkedMap got modified during iteration.");s=s.next}}keys(){const i=this,p=this._state;let f=this._head;const s={[Symbol.iterator](){return s},next(){if(i._state!==p)throw new Error("LinkedMap got modified during iteration.");if(f){const v={value:f.key,done:!1};return f=f.next,v}else return{value:void 0,done:!0}}};return s}values(){const i=this,p=this._state;let f=this._head;const s={[Symbol.iterator](){return s},next(){if(i._state!==p)throw new Error("LinkedMap got modified during iteration.");if(f){const v={value:f.value,done:!1};return f=f.next,v}else return{value:void 0,done:!0}}};return s}entries(){const i=this,p=this._state;let f=this._head;const s={[Symbol.iterator](){return s},next(){if(i._state!==p)throw new Error("LinkedMap got modified during iteration.");if(f){const v={value:[f.key,f.value],done:!1};return f=f.next,v}else return{value:void 0,done:!0}}};return s}[(P=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}trimOld(i){if(i>=this.size)return;if(i===0){this.clear();return}let p=this._head,f=this.size;for(;p&&f>i;)this._map.delete(p.key),p=p.next,f--;this._head=p,this._size=f,p&&(p.previous=void 0),this._state++}addItemFirst(i){if(!this._head&&!this._tail)this._tail=i;else if(this._head)i.next=this._head,this._head.previous=i;else throw new Error("Invalid list");this._head=i,this._state++}addItemLast(i){if(!this._head&&!this._tail)this._head=i;else if(this._tail)i.previous=this._tail,this._tail.next=i;else throw new Error("Invalid list");this._tail=i,this._state++}removeItem(i){if(i===this._head&&i===this._tail)this._head=void 0,this._tail=void 0;else if(i===this._head){if(!i.next)throw new Error("Invalid list");i.next.previous=void 0,this._head=i.next}else if(i===this._tail){if(!i.previous)throw new Error("Invalid list");i.previous.next=void 0,this._tail=i.previous}else{const p=i.next,f=i.previous;if(!p||!f)throw new Error("Invalid list");p.previous=f,f.next=p}i.next=void 0,i.previous=void 0,this._state++}touch(i,p){if(!this._head||!this._tail)throw new Error("Invalid list");if(!(p!==1&&p!==2)){if(p===1){if(i===this._head)return;const f=i.next,s=i.previous;i===this._tail?(s.next=void 0,this._tail=s):(f.previous=s,s.next=f),i.previous=void 0,i.next=this._head,this._head.previous=i,this._head=i,this._state++}else if(p===2){if(i===this._tail)return;const f=i.next,s=i.previous;i===this._head?(f.previous=void 0,this._head=f):(f.previous=s,s.next=f),i.next=void 0,i.previous=this._tail,this._tail.next=i,this._tail=i,this._state++}}}toJSON(){const i=[];return this.forEach((p,f)=>{i.push([f,p])}),i}fromJSON(i){this.clear();for(const[p,f]of i)this.set(p,f)}}e.LinkedMap=A;class l extends A{constructor(i,p=1){super();this._limit=i,this._ratio=Math.min(Math.max(0,p),1)}get limit(){return this._limit}set limit(i){this._limit=i,this.checkTrim()}get ratio(){return this._ratio}set ratio(i){this._ratio=Math.min(Math.max(0,i),1),this.checkTrim()}get(i,p=2){return super.get(i,p)}peek(i){return super.get(i,0)}set(i,p){return super.set(i,p,2),this.checkTrim(),this}checkTrim(){this.size>this._limit&&this.trimOld(Math.round(this._limit*this._ratio))}}e.LRUCache=l;class M{constructor(i){t.set(this,void 0),Ze(this,t,i,"f")}get size(){return Te(this,t,"f").size}forEach(i,p){Te(this,t,"f").forEach(i,p)}get(i){return Te(this,t,"f").get(i)}has(i){return Te(this,t,"f").has(i)}entries(){return Te(this,t,"f").entries()}keys(){return Te(this,t,"f").keys()}values(){return Te(this,t,"f").values()}[(t=new WeakMap,Symbol.iterator)](){return Te(this,t,"f").entries()}}e.ReadonlyMapView=M}),define(Ee[103],_e([0,1,21,9]),function(re,e,c,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.fuzzyScoreGraceful=e.fuzzyScoreGracefulAggressive=e.fuzzyScore=e.FuzzyScore=e.isPatternInWord=e.createMatches=e.anyScore=e.matchesFuzzy2=e.matchesFuzzy=e.matchesWords=e.matchesCamelCase=e.isUpper=e.matchesSubString=e.matchesContiguousSubString=e.matchesPrefix=e.matchesStrictPrefix=e.or=void 0;function w(...j){return function(te,me){for(let Pe=0,Ne=j.length;Pe<Ne;Pe++){const He=j[Pe](te,me);if(He)return He}return null}}e.or=w,e.matchesStrictPrefix=P.bind(void 0,!1),e.matchesPrefix=P.bind(void 0,!0);function P(j,te,me){if(!me||me.length<te.length)return null;let Pe;return j?Pe=F.startsWithIgnoreCase(me,te):Pe=me.indexOf(te)===0,Pe?te.length>0?[{start:0,end:te.length}]:[]:null}function t(j,te){const me=te.toLowerCase().indexOf(j.toLowerCase());return me===-1?null:[{start:me,end:me+j.length}]}e.matchesContiguousSubString=t;function T(j,te){return C(j.toLowerCase(),te.toLowerCase(),0,0)}e.matchesSubString=T;function C(j,te,me,Pe){if(me===j.length)return[];if(Pe===te.length)return null;if(j[me]===te[Pe]){let Ne=null;return(Ne=C(j,te,me+1,Pe+1))?S({start:Pe,end:Pe+1},Ne):null}return C(j,te,me,Pe+1)}function k(j){return 97<=j&&j<=122}function R(j){return 65<=j&&j<=90}e.isUpper=R;function _(j){return 48<=j&&j<=57}function n(j){return j===32||j===9||j===10||j===13}const m=new Set;"()[]{}<>`'\"-/;:,.?!".split("").forEach(j=>m.add(j.charCodeAt(0)));function o(j){return n(j)||m.has(j)}function d(j,te){return j===te||o(j)&&o(te)}function u(j){return k(j)||R(j)||_(j)}function S(j,te){return te.length===0?te=[j]:j.end===te[0].start?te[0].start=j.start:te.unshift(j),te}function b(j,te){for(let me=te;me<j.length;me++){const Pe=j.charCodeAt(me);if(R(Pe)||_(Pe)||me>0&&!u(j.charCodeAt(me-1)))return me}return j.length}function h(j,te,me,Pe){if(me===j.length)return[];if(Pe===te.length)return null;if(j[me]!==te[Pe].toLowerCase())return null;{let Ne=null,He=Pe+1;for(Ne=h(j,te,me+1,Pe+1);!Ne&&(He=b(te,He))<te.length;)Ne=h(j,te,me+1,He),He++;return Ne===null?null:S({start:Pe,end:Pe+1},Ne)}}function g(j){let te=0,me=0,Pe=0,Ne=0,He=0;for(let nt=0;nt<j.length;nt++)He=j.charCodeAt(nt),R(He)&&te++,k(He)&&me++,u(He)&&Pe++,_(He)&&Ne++;const Ye=te/j.length,et=me/j.length,st=Pe/j.length,Je=Ne/j.length;return{upperPercent:Ye,lowerPercent:et,alphaPercent:st,numericPercent:Je}}function A(j){const{upperPercent:te,lowerPercent:me}=j;return me===0&&te>.6}function l(j){const{upperPercent:te,lowerPercent:me,alphaPercent:Pe,numericPercent:Ne}=j;return me>.2&&te<.8&&Pe>.6&&Ne<.2}function M(j){let te=0,me=0,Pe=0,Ne=0;for(let He=0;He<j.length;He++)Pe=j.charCodeAt(He),R(Pe)&&te++,k(Pe)&&me++,n(Pe)&&Ne++;return(te===0||me===0)&&Ne===0?j.length<=30:te<=5}function r(j,te){if(!te||(te=te.trim(),te.length===0)||!M(j)||te.length>60)return null;const me=g(te);if(!l(me)){if(!A(me))return null;te=te.toLowerCase()}let Pe=null,Ne=0;for(j=j.toLowerCase();Ne<te.length&&(Pe=h(j,te,0,Ne))===null;)Ne=b(te,Ne+1);return Pe}e.matchesCamelCase=r;function i(j,te,me=!1){if(!te||te.length===0)return null;let Pe=null,Ne=0;for(j=j.toLowerCase(),te=te.toLowerCase();Ne<te.length&&(Pe=p(j,te,0,Ne,me))===null;)Ne=f(te,Ne+1);return Pe}e.matchesWords=i;function p(j,te,me,Pe,Ne){if(me===j.length)return[];if(Pe===te.length)return null;if(d(j.charCodeAt(me),te.charCodeAt(Pe))){let He=null,Ye=Pe+1;if(He=p(j,te,me+1,Pe+1,Ne),!Ne)for(;!He&&(Ye=f(te,Ye))<te.length;)He=p(j,te,me+1,Ye,Ne),Ye++;return He===null?null:S({start:Pe,end:Pe+1},He)}else return null}function f(j,te){for(let me=te;me<j.length;me++)if(o(j.charCodeAt(me))||me>0&&o(j.charCodeAt(me-1)))return me;return j.length}const s=w(e.matchesPrefix,r,t),v=w(e.matchesPrefix,r,T),a=new c.LRUCache(1e4);function E(j,te,me=!1){if(typeof j!="string"||typeof te!="string")return null;let Pe=a.get(j);Pe||(Pe=new RegExp(F.convertSimple2RegExpPattern(j),"i"),a.set(j,Pe));const Ne=Pe.exec(te);return Ne?[{start:Ne.index,end:Ne.index+Ne[0].length}]:me?v(j,te):s(j,te)}e.matchesFuzzy=E;function I(j,te){const me=Qe(j,j.toLowerCase(),0,te,te.toLowerCase(),0,!0);return me?B(me):null}e.matchesFuzzy2=I;function D(j,te,me,Pe,Ne,He){const Ye=Math.min(13,j.length);for(;me<Ye;me++){const et=Qe(j,te,me,Pe,Ne,He,!1);if(et)return et}return[0,He]}e.anyScore=D;function B(j){if(typeof j=="undefined")return[];const te=[],me=j[1];for(let Pe=j.length-1;Pe>1;Pe--){const Ne=j[Pe]+me,He=te[te.length-1];He&&He.end===Ne?He.end=Ne+1:te.push({start:Ne,end:Ne+1})}return te}e.createMatches=B;const L=128;function y(){const j=[],te=[];for(let me=0;me<=L;me++)te[me]=0;for(let me=0;me<=L;me++)j.push(te.slice(0));return j}function x(j){const te=[];for(let me=0;me<=j;me++)te[me]=0;return te}const N=x(2*L),z=x(2*L),H=y(),q=y(),ue=y(),K=!1;function ce(j,te,me,Pe,Ne){function He(et,st,Je=" "){for(;et.length<st;)et=Je+et;return et}let Ye=` |   |${Pe.split("").map(et=>He(et,3)).join("|")}
`;for(let et=0;et<=me;et++)et===0?Ye+=" |":Ye+=`${te[et-1]}|`,Ye+=j[et].slice(0,Ne+1).map(st=>He(st.toString(),3)).join("|")+`
`;return Ye}function de(j,te,me,Pe){j=j.substr(te),me=me.substr(Pe),console.log(ce(q,j,j.length,me,me.length)),console.log(ce(ue,j,j.length,me,me.length)),console.log(ce(H,j,j.length,me,me.length))}function Y(j,te){if(te<0||te>=j.length)return!1;const me=j.codePointAt(te);switch(me){case 95:case 45:case 46:case 32:case 47:case 92:case 39:case 34:case 58:case 36:case 60:case 40:case 91:return!0;case void 0:return!1;default:return!!F.isEmojiImprecise(me)}}function ie(j,te){if(te<0||te>=j.length)return!1;switch(j.charCodeAt(te)){case 32:case 9:return!0;default:return!1}}function we(j,te,me){return te[j]!==me[j]}function Me(j,te,me,Pe,Ne,He,Ye=!1){for(;te<me&&Ne<He;)j[te]===Pe[Ne]&&(Ye&&(N[te]=Ne),te+=1),Ne+=1;return te===me}e.isPatternInWord=Me;var Re;(function(j){j[j.Diag=1]="Diag",j[j.Left=2]="Left",j[j.LeftLeft=3]="LeftLeft"})(Re||(Re={}));var Be;(function(j){j.Default=[-100,0];function te(me){return!me||me.length===2&&me[0]===-100&&me[1]===0}j.isDefault=te})(Be=e.FuzzyScore||(e.FuzzyScore={}));function Qe(j,te,me,Pe,Ne,He,Ye){const et=j.length>L?L:j.length,st=Pe.length>L?L:Pe.length;if(me>=et||He>=st||et-me>st-He||!Me(te,me,et,Ne,He,st,!0))return;Ge(et,st,me,He,te,Ne);let Je=1,nt=1,ct=me,pt=He;const Ft=[!1];for(Je=1,ct=me;ct<et;Je++,ct++){const he=N[ct],Le=z[ct],We=ct+1<et?z[ct+1]:st;for(nt=he-He+1,pt=he;pt<We;nt++,pt++){let ot=Number.MIN_SAFE_INTEGER,Ke=!1;pt<=Le&&(ot=Xe(j,te,ct,me,Pe,Ne,pt,st,He,H[Je-1][nt-1]===0,Ft));let _t=0;ot!==Number.MAX_SAFE_INTEGER&&(Ke=!0,_t=ot+q[Je-1][nt-1]);const Ie=pt>he,Se=Ie?q[Je][nt-1]+(H[Je][nt-1]>0?-5:0):0,ve=pt>he+1&&H[Je][nt-1]>0,oe=ve?q[Je][nt-2]+(H[Je][nt-2]>0?-5:0):0;if(ve&&(!Ie||oe>=Se)&&(!Ke||oe>=_t))q[Je][nt]=oe,ue[Je][nt]=3,H[Je][nt]=0;else if(Ie&&(!Ke||Se>=_t))q[Je][nt]=Se,ue[Je][nt]=2,H[Je][nt]=0;else if(Ke)q[Je][nt]=_t,ue[Je][nt]=1,H[Je][nt]=H[Je-1][nt-1]+1;else throw new Error("not possible")}}if(K&&de(j,me,Pe,He),!Ft[0]&&!Ye)return;Je--,nt--;const Fe=[q[Je][nt],He];let Mt=0,V=0;for(;Je>=1;){let he=nt;do{const Le=ue[Je][he];if(Le===3)he=he-2;else if(Le===2)he=he-1;else break}while(he>=1);Mt>1&&te[me+Je-1]===Ne[He+nt-1]&&!we(he+He-1,Pe,Ne)&&Mt+1>H[Je][he]&&(he=nt),he===nt?Mt++:Mt=1,V||(V=he),Je--,nt=he-1,Fe.push(nt)}st===et&&(Fe[0]+=2);const Q=V-et;return Fe[0]-=Q,Fe}e.fuzzyScore=Qe;function Ge(j,te,me,Pe,Ne,He){let Ye=j-1,et=te-1;for(;Ye>=me&&et>=Pe;)Ne[Ye]===He[et]&&(z[Ye]=et,Ye--),et--}function Xe(j,te,me,Pe,Ne,He,Ye,et,st,Je,nt){if(te[me]!==He[Ye])return Number.MIN_SAFE_INTEGER;let ct=1,pt=!1;return Ye===me-Pe?ct=j[me]===Ne[Ye]?7:5:we(Ye,Ne,He)&&(Ye===0||!we(Ye-1,Ne,He))?(ct=j[me]===Ne[Ye]?7:5,pt=!0):Y(He,Ye)&&(Ye===0||!Y(He,Ye-1))?ct=5:(Y(He,Ye-1)||ie(He,Ye-1))&&(ct=5,pt=!0),ct>1&&me===Pe&&(nt[0]=!0),pt||(pt=we(Ye,Ne,He)||Y(He,Ye-1)||ie(He,Ye-1)),me===Pe?Ye>st&&(ct-=pt?3:5):Je?ct+=pt?2:0:ct+=pt?0:1,Ye+1===et&&(ct-=pt?3:5),ct}function $(j,te,me,Pe,Ne,He,Ye){return J(j,te,me,Pe,Ne,He,!0,Ye)}e.fuzzyScoreGracefulAggressive=$;function G(j,te,me,Pe,Ne,He,Ye){return J(j,te,me,Pe,Ne,He,!1,Ye)}e.fuzzyScoreGraceful=G;function J(j,te,me,Pe,Ne,He,Ye,et){let st=Qe(j,te,me,Pe,Ne,He,et);if(st&&!Ye)return st;if(j.length>=3){const Je=Math.min(7,j.length-1);for(let nt=me+1;nt<Je;nt++){const ct=ae(j,nt);if(ct){const pt=Qe(ct,ct.toLowerCase(),me,Pe,Ne,He,et);pt&&(pt[0]-=3,(!st||pt[0]>st[0])&&(st=pt))}}}return st}function ae(j,te){if(te+1>=j.length)return;const me=j[te],Pe=j[te+1];if(me!==Pe)return j.slice(0,te)+Pe+me+j.slice(te+2)}}),define(Ee[104],_e([0,1,53,103,9]),function(re,e,c,F,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.matchesFuzzyIconAware=e.parseLabelWithIcons=e.stripIcons=e.markdownEscapeEscapedIcons=e.escapeIcons=e.iconStartMarker=void 0,e.iconStartMarker="$(";const P=new RegExp(`\\$\\(${c.CSSIcon.iconNameExpression}(?:${c.CSSIcon.iconModifierExpression})?\\)`,"g"),t=new RegExp(c.CSSIcon.iconNameCharacter),T=new RegExp(`(\\\\)?${P.source}`,"g");function C(u){return u.replace(T,(S,b)=>b?S:`\\${S}`)}e.escapeIcons=C;const k=new RegExp(`\\\\${P.source}`,"g");function R(u){return u.replace(k,S=>`\\${S}`)}e.markdownEscapeEscapedIcons=R;const _=new RegExp(`(\\s)?(\\\\)?${P.source}(\\s)?`,"g");function n(u){return u.indexOf(e.iconStartMarker)===-1?u:u.replace(_,(S,b,h,g)=>h?S:b||g||"")}e.stripIcons=n;function m(u){const S=u.indexOf(e.iconStartMarker);return S===-1?{text:u}:o(u,S)}e.parseLabelWithIcons=m;function o(u,S){const b=[];let h="";function g(s){if(s){h+=s;for(const v of s)b.push(M)}}let A=-1,l="",M=0,r,i,p=S;const f=u.length;for(g(u.substr(0,S));p<f;)r=u[p],i=u[p+1],r===e.iconStartMarker[0]&&i===e.iconStartMarker[1]?(A=p,g(l),l=e.iconStartMarker,p++):r===")"&&A!==-1?(M+=p-A+1,A=-1,l=""):A!==-1?t.test(r)?l+=r:(g(l),A=-1,l=""):g(r),p++;return g(l),{text:h,iconOffsets:b}}function d(u,S,b=!1){const{text:h,iconOffsets:g}=S;if(!g||g.length===0)return(0,F.matchesFuzzy)(u,h,b);const A=(0,w.ltrim)(h," "),l=h.length-A.length,M=(0,F.matchesFuzzy)(u,A,b);if(M)for(const r of M){const i=g[r.start+l]+l;r.start+=i,r.end+=i}return M}e.matchesFuzzyIconAware=d}),define(Ee[76],_e([0,1,15,104]),function(re,e,c,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parseHrefAndDimensions=e.removeMarkdownEscapes=e.escapeMarkdownSyntaxTokens=e.markdownStringEqual=e.isMarkdownString=e.isEmptyMarkdownString=e.MarkdownString=e.MarkdownStringTextNewlineStyle=void 0;var w;(function(n){n[n.Paragraph=0]="Paragraph",n[n.Break=1]="Break"})(w=e.MarkdownStringTextNewlineStyle||(e.MarkdownStringTextNewlineStyle={}));class P{constructor(m="",o=!1){if(this.value=m,typeof this.value!="string")throw(0,c.illegalArgument)("value");typeof o=="boolean"?(this.isTrusted=o,this.supportThemeIcons=!1,this.supportHtml=!1):(this.isTrusted=o.isTrusted??void 0,this.supportThemeIcons=o.supportThemeIcons??!1,this.supportHtml=o.supportHtml??!1)}appendText(m,o=0){return this.value+=k(this.supportThemeIcons?(0,F.escapeIcons)(m):m).replace(/([ \t]+)/g,(d,u)=>"&nbsp;".repeat(u.length)).replace(/\>/gm,"\\>").replace(/\n/g,o===1?`\\
`:`

`),this}appendMarkdown(m){return this.value+=m,this}appendCodeblock(m,o){return this.value+="\n```",this.value+=m,this.value+=`
`,this.value+=o,this.value+="\n```\n",this}}e.MarkdownString=P;function t(n){return T(n)?!n.value:Array.isArray(n)?n.every(t):!0}e.isEmptyMarkdownString=t;function T(n){return n instanceof P?!0:n&&typeof n=="object"?typeof n.value=="string"&&(typeof n.isTrusted=="boolean"||n.isTrusted===void 0)&&(typeof n.supportThemeIcons=="boolean"||n.supportThemeIcons===void 0):!1}e.isMarkdownString=T;function C(n,m){return n===m?!0:!n||!m?!1:n.value===m.value&&n.isTrusted===m.isTrusted&&n.supportThemeIcons===m.supportThemeIcons}e.markdownStringEqual=C;function k(n){return n.replace(/[\\`*_{}[\]()#+\-!]/g,"\\$&")}e.escapeMarkdownSyntaxTokens=k;function R(n){return n&&n.replace(/\\([\\`*_{}[\]()#+\-.!])/g,"$1")}e.removeMarkdownEscapes=R;function _(n){const m=[],o=n.split("|").map(u=>u.trim());n=o[0];const d=o[1];if(d){const u=/height=(\d+)/.exec(d),S=/width=(\d+)/.exec(d),b=u?u[1]:"",h=S?S[1]:"",g=isFinite(parseInt(h)),A=isFinite(parseInt(b));g&&m.push(`width="${h}"`),A&&m.push(`height="${b}"`)}return{href:n,dimensions:m}}e.parseHrefAndDimensions=_}),define(Ee[34],_e([0,1,9]),function(re,e,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0});var F;(function(w){w[w.Ignore=0]="Ignore",w[w.Info=1]="Info",w[w.Warning=2]="Warning",w[w.Error=3]="Error"})(F||(F={})),function(w){const P="error",t="warning",T="warn",C="info",k="ignore";function R(n){return n?c.equalsIgnoreCase(P,n)?w.Error:c.equalsIgnoreCase(t,n)||c.equalsIgnoreCase(T,n)?w.Warning:c.equalsIgnoreCase(C,n)?w.Info:w.Ignore:w.Ignore}w.fromValue=R;function _(n){switch(n){case w.Error:return P;case w.Warning:return t;case w.Info:return C;default:return k}}w.toString=_}(F||(F={})),e.default=F}),define(Ee[42],_e([0,1,17,23,9,11]),function(re,e,c,F,w,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parseLineAndColumnAware=e.indexOfPath=e.getDriveLetter=e.hasDriveLetter=e.isRootOrDriveLetter=e.sanitizeFilePath=e.isWindowsDriveLetter=e.isEqualOrParent=e.isEqual=e.isValidBasename=e.isUNC=e.getRoot=e.toPosixPath=e.toSlashes=e.isPathSeparator=void 0;function t(r){return r===47||r===92}e.isPathSeparator=t;function T(r){return r.replace(/[\\/]/g,c.posix.sep)}e.toSlashes=T;function C(r){return r.indexOf("/")===-1&&(r=T(r)),/^[a-zA-Z]:(\/|$)/.test(r)&&(r="/"+r),r}e.toPosixPath=C;function k(r,i=c.posix.sep){if(!r)return"";const p=r.length,f=r.charCodeAt(0);if(t(f)){if(t(r.charCodeAt(1))&&!t(r.charCodeAt(2))){let v=3;const a=v;for(;v<p&&!t(r.charCodeAt(v));v++);if(a!==v&&!t(r.charCodeAt(v+1))){for(v+=1;v<p;v++)if(t(r.charCodeAt(v)))return r.slice(0,v+1).replace(/[\\/]/g,i)}}return i}else if(S(f)&&r.charCodeAt(1)===58)return t(r.charCodeAt(2))?r.slice(0,2)+i:r.slice(0,2);let s=r.indexOf("://");if(s!==-1){for(s+=3;s<p;s++)if(t(r.charCodeAt(s)))return r.slice(0,s+1)}return""}e.getRoot=k;function R(r){if(!F.isWindows||!r||r.length<5)return!1;let i=r.charCodeAt(0);if(i!==92||(i=r.charCodeAt(1),i!==92))return!1;let p=2;const f=p;for(;p<r.length&&(i=r.charCodeAt(p),i!==92);p++);return!(f===p||(i=r.charCodeAt(p+1),isNaN(i)||i===92))}e.isUNC=R;const _=/[\\/:\*\?"<>\|]/g,n=/[\\/]/g,m=/^(con|prn|aux|clock\$|nul|lpt[0-9]|com[0-9])(\.(.*?))?$/i;function o(r,i=F.isWindows){const p=i?_:n;return!(!r||r.length===0||/^\s+$/.test(r)||(p.lastIndex=0,p.test(r))||i&&m.test(r)||r==="."||r===".."||i&&r[r.length-1]==="."||i&&r.length!==r.trim().length||r.length>255)}e.isValidBasename=o;function d(r,i,p){const f=r===i;return!p||f?f:!r||!i?!1:(0,w.equalsIgnoreCase)(r,i)}e.isEqual=d;function u(r,i,p,f=c.sep){if(r===i)return!0;if(!r||!i||i.length>r.length)return!1;if(p){if(!(0,w.startsWithIgnoreCase)(r,i))return!1;if(i.length===r.length)return!0;let v=i.length;return i.charAt(i.length-1)===f&&v--,r.charAt(v)===f}return i.charAt(i.length-1)!==f&&(i+=f),r.indexOf(i)===0}e.isEqualOrParent=u;function S(r){return r>=65&&r<=90||r>=97&&r<=122}e.isWindowsDriveLetter=S;function b(r,i){return F.isWindows&&r.endsWith(":")&&(r+=c.sep),(0,c.isAbsolute)(r)||(r=(0,c.join)(i,r)),r=(0,c.normalize)(r),F.isWindows?(r=(0,w.rtrim)(r,c.sep),r.endsWith(":")&&(r+=c.sep)):(r=(0,w.rtrim)(r,c.sep),r||(r=c.sep)),r}e.sanitizeFilePath=b;function h(r){const i=(0,c.normalize)(r);return F.isWindows?r.length>3?!1:g(i)&&(r.length===2||i.charCodeAt(2)===92):i===c.posix.sep}e.isRootOrDriveLetter=h;function g(r,i){return(i!==void 0?i:F.isWindows)?S(r.charCodeAt(0))&&r.charCodeAt(1)===58:!1}e.hasDriveLetter=g;function A(r){return g(r)?r[0]:void 0}e.getDriveLetter=A;function l(r,i,p){return i.length>r.length?-1:r===i?0:(p&&(r=r.toLowerCase(),i=i.toLowerCase()),r.indexOf(i))}e.indexOfPath=l;function M(r){const i=r.split(":");let p,f,s;if(i.forEach(v=>{const a=Number(v);(0,P.isNumber)(a)?f===void 0?f=a:s===void 0&&(s=a):p=p?[p,v].join(":"):v}),!p)throw new Error("Format for `--goto` should be: `FILE:LINE(:COLUMN)`");return{path:p,line:f!==void 0?f:void 0,column:s!==void 0?s:f!==void 0?1:void 0}}e.parseLineAndColumnAware=M}),define(Ee[54],_e([0,1,22,9,2]),function(re,e,c,F,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.revive=e.MarshalledId=e.parse=e.stringify=void 0;function P(R){return JSON.stringify(R,C)}e.stringify=P;function t(R){let _=JSON.parse(R);return _=k(_),_}e.parse=t;var T;(function(R){R[R.Uri=1]="Uri",R[R.Regexp=2]="Regexp",R[R.ScmResource=3]="ScmResource",R[R.ScmResourceGroup=4]="ScmResourceGroup",R[R.ScmProvider=5]="ScmProvider",R[R.CommentController=6]="CommentController",R[R.CommentThread=7]="CommentThread",R[R.CommentThreadReply=8]="CommentThreadReply",R[R.CommentNode=9]="CommentNode",R[R.CommentThreadNode=10]="CommentThreadNode",R[R.TimelineActionContext=11]="TimelineActionContext",R[R.NotebookCellActionContext=12]="NotebookCellActionContext",R[R.TestItemContext=13]="TestItemContext"})(T=e.MarshalledId||(e.MarshalledId={}));function C(R,_){return _ instanceof RegExp?{$mid:2,source:_.source,flags:(0,F.regExpFlags)(_)}:_}function k(R,_=0){if(!R||_>200)return R;if(typeof R=="object"){switch(R.$mid){case 1:return w.URI.revive(R);case 2:return new RegExp(R.source,R.flags)}if(R instanceof c.VSBuffer||R instanceof Uint8Array)return R;if(Array.isArray(R))for(let n=0;n<R.length;++n)R[n]=k(R[n],_+1);else for(const n in R)Object.hasOwnProperty.call(R,n)&&(R[n]=k(R[n],_+1))}return R}e.revive=k}),define(Ee[10],_e([0,1,23,2]),function(re,e,c,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileAccess=e.RemoteAuthorities=e.Schemas=void 0;var w;(function(T){T.inMemory="inmemory",T.vscode="vscode",T.internal="private",T.walkThrough="walkThrough",T.walkThroughSnippet="walkThroughSnippet",T.http="http",T.https="https",T.file="file",T.mailto="mailto",T.untitled="untitled",T.data="data",T.command="command",T.vscodeRemote="vscode-remote",T.vscodeRemoteResource="vscode-remote-resource",T.userData="vscode-userdata",T.vscodeCustomEditor="vscode-custom-editor",T.vscodeNotebook="vscode-notebook",T.vscodeNotebookCell="vscode-notebook-cell",T.vscodeNotebookCellMetadata="vscode-notebook-cell-metadata",T.vscodeNotebookCellOutput="vscode-notebook-cell-output",T.vscodeInteractive="vscode-interactive",T.vscodeInteractiveInput="vscode-interactive-input",T.vscodeSettings="vscode-settings",T.vscodeWorkspaceTrust="vscode-workspace-trust",T.vscodeTerminal="vscode-terminal",T.webviewPanel="webview-panel",T.vscodeWebview="vscode-webview",T.extension="extension",T.vscodeFileResource="vscode-file",T.tmp="tmp",T.vsls="vsls"})(w=e.Schemas||(e.Schemas={}));class P{constructor(){this._hosts=Object.create(null),this._ports=Object.create(null),this._connectionTokens=Object.create(null),this._preferredWebSchema="http",this._delegate=null}setPreferredWebSchema(C){this._preferredWebSchema=C}setDelegate(C){this._delegate=C}set(C,k,R){this._hosts[C]=k,this._ports[C]=R}setConnectionToken(C,k){this._connectionTokens[C]=k}rewrite(C){if(this._delegate)return this._delegate(C);const k=C.authority;let R=this._hosts[k];R&&R.indexOf(":")!==-1&&(R=`[${R}]`);const _=this._ports[k],n=this._connectionTokens[k];let m=`path=${encodeURIComponent(C.path)}`;return typeof n=="string"&&(m+=`&tkn=${encodeURIComponent(n)}`),F.URI.from({scheme:c.isWeb?this._preferredWebSchema:w.vscodeRemoteResource,authority:`${R}:${_}`,path:"/vscode-remote-resource",query:m})}}e.RemoteAuthorities=new P;class t{asBrowserUri(C,k){const R=this.toUri(C,k);return R.scheme===w.vscodeRemote?e.RemoteAuthorities.rewrite(R):R.scheme===w.file&&(c.isNative||typeof c.globals.importScripts=="function"&&c.globals.origin===`${w.vscodeFileResource}://${t.FALLBACK_AUTHORITY}`)?R.with({scheme:w.vscodeFileResource,authority:R.authority||t.FALLBACK_AUTHORITY,query:null,fragment:null}):R}asFileUri(C,k){const R=this.toUri(C,k);return R.scheme===w.vscodeFileResource?R.with({scheme:w.file,authority:R.authority!==t.FALLBACK_AUTHORITY?R.authority:null,query:null,fragment:null}):R}toUri(C,k){return F.URI.isUri(C)?C:F.URI.parse(k.toUrl(C))}}t.FALLBACK_AUTHORITY="vscode-app",e.FileAccess=new t}),define(Ee[24],_e([0,1,42,10,17,23,9,2]),function(re,e,c,F,w,P,t,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toLocalResource=e.DataUri=e.distinctParents=e.addTrailingPathSeparator=e.removeTrailingPathSeparator=e.hasTrailingPathSeparator=e.isEqualAuthority=e.isAbsolutePath=e.resolvePath=e.relativePath=e.normalizePath=e.joinPath=e.dirname=e.extname=e.basename=e.basenameOrAuthority=e.getComparisonKey=e.isEqualOrParent=e.isEqual=e.extUriIgnorePathCase=e.extUriBiasedIgnorePathCase=e.extUri=e.ExtUri=e.originalFSPath=void 0;function C(m){return(0,T.uriToFsPath)(m,!0)}e.originalFSPath=C;class k{constructor(o){this._ignorePathCasing=o}compare(o,d,u=!1){return o===d?0:(0,t.compare)(this.getComparisonKey(o,u),this.getComparisonKey(d,u))}isEqual(o,d,u=!1){return o===d?!0:!o||!d?!1:this.getComparisonKey(o,u)===this.getComparisonKey(d,u)}getComparisonKey(o,d=!1){return o.with({path:this._ignorePathCasing(o)?o.path.toLowerCase():void 0,fragment:d?null:void 0}).toString()}ignorePathCasing(o){return this._ignorePathCasing(o)}isEqualOrParent(o,d,u=!1){if(o.scheme===d.scheme){if(o.scheme===F.Schemas.file)return c.isEqualOrParent(C(o),C(d),this._ignorePathCasing(o))&&o.query===d.query&&(u||o.fragment===d.fragment);if((0,e.isEqualAuthority)(o.authority,d.authority))return c.isEqualOrParent(o.path,d.path,this._ignorePathCasing(o),"/")&&o.query===d.query&&(u||o.fragment===d.fragment)}return!1}joinPath(o,...d){return T.URI.joinPath(o,...d)}basenameOrAuthority(o){return(0,e.basename)(o)||o.authority}basename(o){return w.posix.basename(o.path)}extname(o){return w.posix.extname(o.path)}dirname(o){if(o.path.length===0)return o;let d;return o.scheme===F.Schemas.file?d=T.URI.file(w.dirname(C(o))).path:(d=w.posix.dirname(o.path),o.authority&&d.length&&d.charCodeAt(0)!==47&&(console.error(`dirname("${o.toString})) resulted in a relative path`),d="/")),o.with({path:d})}normalizePath(o){if(!o.path.length)return o;let d;return o.scheme===F.Schemas.file?d=T.URI.file(w.normalize(C(o))).path:d=w.posix.normalize(o.path),o.with({path:d})}relativePath(o,d){if(o.scheme!==d.scheme||!(0,e.isEqualAuthority)(o.authority,d.authority))return;if(o.scheme===F.Schemas.file){const b=w.relative(C(o),C(d));return P.isWindows?c.toSlashes(b):b}let u=o.path||"/",S=d.path||"/";if(this._ignorePathCasing(o)){let b=0;for(const h=Math.min(u.length,S.length);b<h&&!(u.charCodeAt(b)!==S.charCodeAt(b)&&u.charAt(b).toLowerCase()!==S.charAt(b).toLowerCase());b++);u=S.substr(0,b)+u.substr(b)}return w.posix.relative(u,S)}resolvePath(o,d){if(o.scheme===F.Schemas.file){const u=T.URI.file(w.resolve(C(o),d));return o.with({authority:u.authority,path:u.path})}return d=c.toPosixPath(d),o.with({path:w.posix.resolve(o.path,d)})}isAbsolutePath(o){return!!o.path&&o.path[0]==="/"}isEqualAuthority(o,d){return o===d||o!==void 0&&d!==void 0&&(0,t.equalsIgnoreCase)(o,d)}hasTrailingPathSeparator(o,d=w.sep){if(o.scheme===F.Schemas.file){const u=C(o);return u.length>c.getRoot(u).length&&u[u.length-1]===d}else{const u=o.path;return u.length>1&&u.charCodeAt(u.length-1)===47&&!/^[a-zA-Z]:(\/$|\\$)/.test(o.fsPath)}}removeTrailingPathSeparator(o,d=w.sep){return(0,e.hasTrailingPathSeparator)(o,d)?o.with({path:o.path.substr(0,o.path.length-1)}):o}addTrailingPathSeparator(o,d=w.sep){let u=!1;if(o.scheme===F.Schemas.file){const S=C(o);u=S!==void 0&&S.length===c.getRoot(S).length&&S[S.length-1]===d}else{d="/";const S=o.path;u=S.length===1&&S.charCodeAt(S.length-1)===47}return!u&&!(0,e.hasTrailingPathSeparator)(o,d)?o.with({path:o.path+"/"}):o}}e.ExtUri=k,e.extUri=new k(()=>!1),e.extUriBiasedIgnorePathCase=new k(m=>m.scheme===F.Schemas.file?!P.isLinux:!0),e.extUriIgnorePathCase=new k(m=>!0),e.isEqual=e.extUri.isEqual.bind(e.extUri),e.isEqualOrParent=e.extUri.isEqualOrParent.bind(e.extUri),e.getComparisonKey=e.extUri.getComparisonKey.bind(e.extUri),e.basenameOrAuthority=e.extUri.basenameOrAuthority.bind(e.extUri),e.basename=e.extUri.basename.bind(e.extUri),e.extname=e.extUri.extname.bind(e.extUri),e.dirname=e.extUri.dirname.bind(e.extUri),e.joinPath=e.extUri.joinPath.bind(e.extUri),e.normalizePath=e.extUri.normalizePath.bind(e.extUri),e.relativePath=e.extUri.relativePath.bind(e.extUri),e.resolvePath=e.extUri.resolvePath.bind(e.extUri),e.isAbsolutePath=e.extUri.isAbsolutePath.bind(e.extUri),e.isEqualAuthority=e.extUri.isEqualAuthority.bind(e.extUri),e.hasTrailingPathSeparator=e.extUri.hasTrailingPathSeparator.bind(e.extUri),e.removeTrailingPathSeparator=e.extUri.removeTrailingPathSeparator.bind(e.extUri),e.addTrailingPathSeparator=e.extUri.addTrailingPathSeparator.bind(e.extUri);function R(m,o){const d=[];for(let u=0;u<m.length;u++){const S=o(m[u]);m.some((b,h)=>h===u?!1:(0,e.isEqualOrParent)(S,o(b)))||d.push(m[u])}return d}e.distinctParents=R;var _;(function(m){m.META_DATA_LABEL="label",m.META_DATA_DESCRIPTION="description",m.META_DATA_SIZE="size",m.META_DATA_MIME="mime";function o(d){const u=new Map;d.path.substring(d.path.indexOf(";")+1,d.path.lastIndexOf(";")).split(";").forEach(h=>{const[g,A]=h.split(":");g&&A&&u.set(g,A)});const b=d.path.substring(0,d.path.indexOf(";"));return b&&u.set(m.META_DATA_MIME,b),u}m.parseMetaData=o})(_=e.DataUri||(e.DataUri={}));function n(m,o,d){if(o){let u=m.path;return u&&u[0]!==w.posix.sep&&(u=w.posix.sep+u),m.with({scheme:d,authority:o,path:u})}return m.with({scheme:d})}e.toLocalResource=n}),define(Ee[14],_e([0,1,20,15,3,6,24,23]),function(re,e,c,F,w,P,t,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createCancelableAsyncIterable=e.CancelableAsyncIterableObject=e.AsyncIterableObject=e.Promises=e.DeferredPromise=e.IntervalCounter=e.TaskSequentializer=e.retry=e.IdleValue=e.runWhenIdle=e.ThrottledWorker=e.RunOnceWorker=e.ProcessTimeRunOnceScheduler=e.RunOnceScheduler=e.IntervalTimer=e.TimeoutTimer=e.ResourceQueue=e.Queue=e.Limiter=e.firstParallel=e.first=e.sequence=e.disposableTimeout=e.timeout=e.AutoOpenBarrier=e.Barrier=e.ThrottledDelayer=e.Delayer=e.SequencerByKey=e.Sequencer=e.Throttler=e.asPromise=e.raceTimeout=e.raceCancellablePromises=e.raceCancellation=e.createCancelablePromise=e.isThenable=void 0;function C(de){return!!de&&typeof de.then=="function"}e.isThenable=C;function k(de){const Y=new c.CancellationTokenSource,ie=de(Y.token),we=new Promise((Me,Re)=>{const Be=Y.token.onCancellationRequested(()=>{Be.dispose(),Y.dispose(),Re((0,F.canceled)())});Promise.resolve(ie).then(Qe=>{Be.dispose(),Y.dispose(),Me(Qe)},Qe=>{Be.dispose(),Y.dispose(),Re(Qe)})});return new class{cancel(){Y.cancel()}then(Me,Re){return we.then(Me,Re)}catch(Me){return this.then(void 0,Me)}finally(Me){return we.finally(Me)}}}e.createCancelablePromise=k;function R(de,Y,ie){return Promise.race([de,new Promise(we=>Y.onCancellationRequested(()=>we(ie)))])}e.raceCancellation=R;async function _(de){let Y=-1;const ie=de.map((Me,Re)=>Me.then(Be=>(Y=Re,Be))),we=await Promise.race(ie);return de.forEach((Me,Re)=>{Re!==Y&&Me.cancel()}),we}e.raceCancellablePromises=_;function n(de,Y,ie){let we;const Me=setTimeout(()=>{we?.(void 0),ie?.()},Y);return Promise.race([de.finally(()=>clearTimeout(Me)),new Promise(Re=>we=Re)])}e.raceTimeout=n;function m(de){return new Promise((Y,ie)=>{const we=de();C(we)?we.then(Y,ie):Y(we)})}e.asPromise=m;class o{constructor(){this.activePromise=null,this.queuedPromise=null,this.queuedPromiseFactory=null}queue(Y){if(this.activePromise){if(this.queuedPromiseFactory=Y,!this.queuedPromise){const ie=()=>{this.queuedPromise=null;const we=this.queue(this.queuedPromiseFactory);return this.queuedPromiseFactory=null,we};this.queuedPromise=new Promise(we=>{this.activePromise.then(ie,ie).then(we)})}return new Promise((ie,we)=>{this.queuedPromise.then(ie,we)})}return this.activePromise=Y(),new Promise((ie,we)=>{this.activePromise.then(Me=>{this.activePromise=null,ie(Me)},Me=>{this.activePromise=null,we(Me)})})}}e.Throttler=o;class d{constructor(){this.current=Promise.resolve(null)}queue(Y){return this.current=this.current.then(()=>Y(),()=>Y())}}e.Sequencer=d;class u{constructor(){this.promiseMap=new Map}queue(Y,ie){const Me=(this.promiseMap.get(Y)??Promise.resolve()).catch(()=>{}).then(ie).finally(()=>{this.promiseMap.get(Y)===Me&&this.promiseMap.delete(Y)});return this.promiseMap.set(Y,Me),Me}}e.SequencerByKey=u;class S{constructor(Y){this.defaultDelay=Y,this.timeout=null,this.completionPromise=null,this.doResolve=null,this.doReject=null,this.task=null}trigger(Y,ie=this.defaultDelay){return this.task=Y,this.cancelTimeout(),this.completionPromise||(this.completionPromise=new Promise((we,Me)=>{this.doResolve=we,this.doReject=Me}).then(()=>{if(this.completionPromise=null,this.doResolve=null,this.task){const we=this.task;return this.task=null,we()}})),this.timeout=setTimeout(()=>{this.timeout=null,this.doResolve&&this.doResolve(null)},ie),this.completionPromise}isTriggered(){return this.timeout!==null}cancel(){this.cancelTimeout(),this.completionPromise&&(this.doReject&&this.doReject((0,F.canceled)()),this.completionPromise=null)}cancelTimeout(){this.timeout!==null&&(clearTimeout(this.timeout),this.timeout=null)}dispose(){this.cancel()}}e.Delayer=S;class b{constructor(Y){this.delayer=new S(Y),this.throttler=new o}trigger(Y,ie){return this.delayer.trigger(()=>this.throttler.queue(Y),ie)}isTriggered(){return this.delayer.isTriggered()}cancel(){this.delayer.cancel()}dispose(){this.delayer.dispose()}}e.ThrottledDelayer=b;class h{constructor(){this._isOpen=!1,this._promise=new Promise((Y,ie)=>{this._completePromise=Y})}isOpen(){return this._isOpen}open(){this._isOpen=!0,this._completePromise(!0)}wait(){return this._promise}}e.Barrier=h;class g extends h{constructor(Y){super();this._timeout=setTimeout(()=>this.open(),Y)}open(){clearTimeout(this._timeout),super.open()}}e.AutoOpenBarrier=g;function A(de,Y){return Y?new Promise((ie,we)=>{const Me=setTimeout(()=>{Re.dispose(),ie()},de),Re=Y.onCancellationRequested(()=>{clearTimeout(Me),Re.dispose(),we((0,F.canceled)())})}):k(ie=>A(de,ie))}e.timeout=A;function l(de,Y=0){const ie=setTimeout(de,Y);return(0,P.toDisposable)(()=>clearTimeout(ie))}e.disposableTimeout=l;function M(de){const Y=[];let ie=0;const we=de.length;function Me(){return ie<we?de[ie++]():null}function Re(Be){Be!=null&&Y.push(Be);const Qe=Me();return Qe?Qe.then(Re):Promise.resolve(Y)}return Promise.resolve(null).then(Re)}e.sequence=M;function r(de,Y=we=>!!we,ie=null){let we=0;const Me=de.length,Re=()=>{if(we>=Me)return Promise.resolve(ie);const Be=de[we++];return Promise.resolve(Be()).then(Ge=>Y(Ge)?Promise.resolve(Ge):Re())};return Re()}e.first=r;function i(de,Y=we=>!!we,ie=null){if(de.length===0)return Promise.resolve(ie);let we=de.length;const Me=()=>{we=-1;for(const Re of de)Re.cancel?.()};return new Promise((Re,Be)=>{for(const Qe of de)Qe.then(Ge=>{--we>=0&&Y(Ge)?(Me(),Re(Ge)):we===0&&Re(ie)}).catch(Ge=>{--we>=0&&(Me(),Be(Ge))})})}e.firstParallel=i;class p{constructor(Y){this._size=0,this.maxDegreeOfParalellism=Y,this.outstandingPromises=[],this.runningPromises=0,this._onFinished=new w.Emitter}get onFinished(){return this._onFinished.event}get size(){return this._size}queue(Y){return this._size++,new Promise((ie,we)=>{this.outstandingPromises.push({factory:Y,c:ie,e:we}),this.consume()})}consume(){for(;this.outstandingPromises.length&&this.runningPromises<this.maxDegreeOfParalellism;){const Y=this.outstandingPromises.shift();this.runningPromises++;const ie=Y.factory();ie.then(Y.c,Y.e),ie.then(()=>this.consumed(),()=>this.consumed())}}consumed(){this._size--,this.runningPromises--,this.outstandingPromises.length>0?this.consume():this._onFinished.fire()}dispose(){this._onFinished.dispose()}}e.Limiter=p;class f extends p{constructor(){super(1)}}e.Queue=f;class s{constructor(){this.queues=new Map}queueFor(Y,ie=t.extUri){const we=ie.getComparisonKey(Y);let Me=this.queues.get(we);return Me||(Me=new f,w.Event.once(Me.onFinished)(()=>{Me?.dispose(),this.queues.delete(we)}),this.queues.set(we,Me)),Me}dispose(){this.queues.forEach(Y=>Y.dispose()),this.queues.clear()}}e.ResourceQueue=s;class v{constructor(Y,ie){this._token=-1,typeof Y=="function"&&typeof ie=="number"&&this.setIfNotSet(Y,ie)}dispose(){this.cancel()}cancel(){this._token!==-1&&(clearTimeout(this._token),this._token=-1)}cancelAndSet(Y,ie){this.cancel(),this._token=setTimeout(()=>{this._token=-1,Y()},ie)}setIfNotSet(Y,ie){this._token===-1&&(this._token=setTimeout(()=>{this._token=-1,Y()},ie))}}e.TimeoutTimer=v;class a{constructor(){this._token=-1}dispose(){this.cancel()}cancel(){this._token!==-1&&(clearInterval(this._token),this._token=-1)}cancelAndSet(Y,ie){this.cancel(),this._token=setInterval(()=>{Y()},ie)}}e.IntervalTimer=a;class E{constructor(Y,ie){this.timeoutToken=-1,this.runner=Y,this.timeout=ie,this.timeoutHandler=this.onTimeout.bind(this)}dispose(){this.cancel(),this.runner=null}cancel(){this.isScheduled()&&(clearTimeout(this.timeoutToken),this.timeoutToken=-1)}schedule(Y=this.timeout){this.cancel(),this.timeoutToken=setTimeout(this.timeoutHandler,Y)}get delay(){return this.timeout}set delay(Y){this.timeout=Y}isScheduled(){return this.timeoutToken!==-1}onTimeout(){this.timeoutToken=-1,this.runner&&this.doRun()}doRun(){this.runner&&this.runner()}}e.RunOnceScheduler=E;class I{constructor(Y,ie){ie%1e3!=0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${ie}ms is not a multiple of 1000ms.`),this.runner=Y,this.timeout=ie,this.counter=0,this.intervalToken=-1,this.intervalHandler=this.onInterval.bind(this)}dispose(){this.cancel(),this.runner=null}cancel(){this.isScheduled()&&(clearInterval(this.intervalToken),this.intervalToken=-1)}schedule(Y=this.timeout){Y%1e3!=0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${Y}ms is not a multiple of 1000ms.`),this.cancel(),this.counter=Math.ceil(Y/1e3),this.intervalToken=setInterval(this.intervalHandler,1e3)}isScheduled(){return this.intervalToken!==-1}onInterval(){this.counter--,!(this.counter>0)&&(clearInterval(this.intervalToken),this.intervalToken=-1,this.runner&&this.runner())}}e.ProcessTimeRunOnceScheduler=I;class D extends E{constructor(Y,ie){super(Y,ie);this.units=[]}work(Y){this.units.push(Y),this.isScheduled()||this.schedule()}doRun(){const Y=this.units;this.units=[],this.runner&&this.runner(Y)}dispose(){this.units=[],super.dispose()}}e.RunOnceWorker=D;class B extends P.Disposable{constructor(Y,ie,we,Me){super();this.maxWorkChunkSize=Y,this.maxPendingWork=ie,this.throttleDelay=we,this.handler=Me,this.pendingWork=[],this.throttler=this._register(new P.MutableDisposable),this.disposed=!1}get pending(){return this.pendingWork.length}work(Y){if(this.disposed)return!1;if(typeof this.maxPendingWork=="number"){if(this.throttler.value){if(this.pending+Y.length>this.maxPendingWork)return!1}else if(this.pending+Y.length-this.maxWorkChunkSize>this.maxPendingWork)return!1}return this.pendingWork.push(...Y),this.throttler.value||this.doWork(),!0}doWork(){this.handler(this.pendingWork.splice(0,this.maxWorkChunkSize)),this.pendingWork.length>0&&(this.throttler.value=new E(()=>{this.throttler.clear(),this.doWork()},this.throttleDelay),this.throttler.value.schedule())}dispose(){super.dispose(),this.disposed=!0}}e.ThrottledWorker=B,function(){typeof requestIdleCallback!="function"||typeof cancelIdleCallback!="function"?e.runWhenIdle=de=>{(0,T.setTimeout0)(()=>{if(Y)return;const ie=Date.now()+3;de(Object.freeze({didTimeout:!0,timeRemaining(){return Math.max(0,ie-Date.now())}}))});let Y=!1;return{dispose(){Y||(Y=!0)}}}:e.runWhenIdle=(de,Y)=>{const ie=requestIdleCallback(de,typeof Y=="number"?{timeout:Y}:void 0);let we=!1;return{dispose(){we||(we=!0,cancelIdleCallback(ie))}}}}();class L{constructor(Y){this._didRun=!1,this._executor=()=>{try{this._value=Y()}catch(ie){this._error=ie}finally{this._didRun=!0}},this._handle=(0,e.runWhenIdle)(()=>this._executor())}dispose(){this._handle.dispose()}get value(){if(this._didRun||(this._handle.dispose(),this._executor()),this._error)throw this._error;return this._value}get isInitialized(){return this._didRun}}e.IdleValue=L;async function y(de,Y,ie){let we;for(let Me=0;Me<ie;Me++)try{return await de()}catch(Re){we=Re,await A(Y)}throw we}e.retry=y;class x{hasPending(Y){return this._pending?typeof Y=="number"?this._pending.taskId===Y:!!this._pending:!1}get pending(){return this._pending?this._pending.promise:void 0}cancelPending(){this._pending?.cancel()}setPending(Y,ie,we){return this._pending={taskId:Y,cancel:()=>we?.(),promise:ie},ie.then(()=>this.donePending(Y),()=>this.donePending(Y)),ie}donePending(Y){this._pending&&Y===this._pending.taskId&&(this._pending=void 0,this.triggerNext())}triggerNext(){if(this._next){const Y=this._next;this._next=void 0,Y.run().then(Y.promiseResolve,Y.promiseReject)}}setNext(Y){if(this._next)this._next.run=Y;else{let ie,we;const Me=new Promise((Re,Be)=>{ie=Re,we=Be});this._next={run:Y,promise:Me,promiseResolve:ie,promiseReject:we}}return this._next.promise}}e.TaskSequentializer=x;class N{constructor(Y,ie=()=>Date.now()){this.interval=Y,this.nowFn=ie,this.lastIncrementTime=0,this.value=0}increment(){const Y=this.nowFn();return Y-this.lastIncrementTime>this.interval&&(this.lastIncrementTime=Y,this.value=0),this.value++,this.value}}e.IntervalCounter=N;class z{constructor(){this.rejected=!1,this.resolved=!1,this.p=new Promise((Y,ie)=>{this.completeCallback=Y,this.errorCallback=ie})}get isRejected(){return this.rejected}get isResolved(){return this.resolved}get isSettled(){return this.rejected||this.resolved}complete(Y){return new Promise(ie=>{this.completeCallback(Y),this.resolved=!0,ie()})}error(Y){return new Promise(ie=>{this.errorCallback(Y),this.rejected=!0,ie()})}cancel(){new Promise(Y=>{this.errorCallback((0,F.canceled)()),this.rejected=!0,Y()})}}e.DeferredPromise=z;var H;(function(de){async function Y(we){let Me;const Re=await Promise.all(we.map(Be=>Be.then(Qe=>Qe,Qe=>{Me||(Me=Qe)})));if(typeof Me!="undefined")throw Me;return Re}de.settled=Y;function ie(we){return new Promise(async(Me,Re)=>{try{await we(Me,Re)}catch(Be){Re(Be)}})}de.withAsyncBody=ie})(H=e.Promises||(e.Promises={}));var q;(function(de){de[de.Initial=0]="Initial",de[de.DoneOK=1]="DoneOK",de[de.DoneError=2]="DoneError"})(q||(q={}));class ue{constructor(Y){this._state=0,this._results=[],this._error=null,this._onStateChanged=new w.Emitter,queueMicrotask(async()=>{const ie={emitOne:we=>this.emitOne(we),emitMany:we=>this.emitMany(we),reject:we=>this.reject(we)};try{await Promise.resolve(Y(ie)),this.resolve()}catch(we){this.reject(we)}finally{ie.emitOne=void 0,ie.emitMany=void 0,ie.reject=void 0}})}static fromArray(Y){return new ue(ie=>{ie.emitMany(Y)})}static fromPromise(Y){return new ue(async ie=>{ie.emitMany(await Y)})}static fromPromises(Y){return new ue(async ie=>{await Promise.all(Y.map(async we=>ie.emitOne(await we)))})}static merge(Y){return new ue(async ie=>{await Promise.all(Y.map(async we=>{for await(const Me of we)ie.emitOne(Me)}))})}[Symbol.asyncIterator](){let Y=0;return{next:async()=>{do{if(this._state===2)throw this._error;if(Y<this._results.length)return{done:!1,value:this._results[Y++]};if(this._state===1)return{done:!0,value:void 0};await w.Event.toPromise(this._onStateChanged.event)}while(!0)}}}static map(Y,ie){return new ue(async we=>{for await(const Me of Y)we.emitOne(ie(Me))})}map(Y){return ue.map(this,Y)}static filter(Y,ie){return new ue(async we=>{for await(const Me of Y)ie(Me)&&we.emitOne(Me)})}filter(Y){return ue.filter(this,Y)}static coalesce(Y){return ue.filter(Y,ie=>!!ie)}coalesce(){return ue.coalesce(this)}static async toPromise(Y){const ie=[];for await(const we of Y)ie.push(we);return ie}toPromise(){return ue.toPromise(this)}emitOne(Y){this._state===0&&(this._results.push(Y),this._onStateChanged.fire())}emitMany(Y){this._state===0&&(this._results=this._results.concat(Y),this._onStateChanged.fire())}resolve(){this._state===0&&(this._state=1,this._onStateChanged.fire())}reject(Y){this._state===0&&(this._state=2,this._error=Y,this._onStateChanged.fire())}}e.AsyncIterableObject=ue,ue.EMPTY=ue.fromArray([]);class K extends ue{constructor(Y,ie){super(ie);this._source=Y}cancel(){this._source.cancel()}}e.CancelableAsyncIterableObject=K;function ce(de){const Y=new c.CancellationTokenSource,ie=de(Y.token);return new K(Y,async we=>{const Me=Y.token.onCancellationRequested(()=>{Me.dispose(),Y.dispose(),we.reject((0,F.canceled)())});try{for await(const Re of ie){if(Y.token.isCancellationRequested)return;we.emitOne(Re)}Me.dispose(),Y.dispose()}catch(Re){Me.dispose(),Y.dispose(),we.reject(Re)}})}e.createCancelableAsyncIterable=ce}),define(Ee[105],_e([0,1,14,17]),function(re,e,c,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.compareByPrefix=e.compareAnything=e.comparePaths=e.compareFileExtensionsUnicode=e.compareFileExtensionsLower=e.compareFileExtensionsUpper=e.compareFileExtensionsDefault=e.compareFileExtensions=e.noIntlCompareFileNames=e.compareFileNamesUnicode=e.compareFileNamesLower=e.compareFileNamesUpper=e.compareFileNamesDefault=e.compareFileNames=void 0;const w=new c.IdleValue(()=>{const a=new Intl.Collator(void 0,{numeric:!0,sensitivity:"base"});return{collator:a,collatorIsNumeric:a.resolvedOptions().numeric}}),P=new c.IdleValue(()=>({collator:new Intl.Collator(void 0,{numeric:!0})})),t=new c.IdleValue(()=>({collator:new Intl.Collator(void 0,{numeric:!0,sensitivity:"accent"})}));function T(a,E,I=!1){const D=a||"",B=E||"",L=w.value.collator.compare(D,B);return w.value.collatorIsNumeric&&L===0&&D!==B?D<B?-1:1:L}e.compareFileNames=T;function C(a,E){const I=P.value.collator;return a=a||"",E=E||"",A(I,a,E)}e.compareFileNamesDefault=C;function k(a,E){const I=P.value.collator;return a=a||"",E=E||"",i(a,E)||A(I,a,E)}e.compareFileNamesUpper=k;function R(a,E){const I=P.value.collator;return a=a||"",E=E||"",r(a,E)||A(I,a,E)}e.compareFileNamesLower=R;function _(a,E){return a=a||"",E=E||"",a===E?0:a<E?-1:1}e.compareFileNamesUnicode=_;function n(a,E,I=!1){I||(a=a&&a.toLowerCase(),E=E&&E.toLowerCase());const[D,B]=h(a),[L,y]=h(E);return D!==L?D<L?-1:1:B===y?0:B<y?-1:1}e.noIntlCompareFileNames=n;function m(a,E){const[I,D]=h(a),[B,L]=h(E);let y=w.value.collator.compare(D,L);if(y===0){if(w.value.collatorIsNumeric&&D!==L)return D<L?-1:1;if(y=w.value.collator.compare(I,B),w.value.collatorIsNumeric&&y===0&&I!==B)return I<B?-1:1}return y}e.compareFileExtensions=m;function o(a,E){a=a||"",E=E||"";const I=g(a),D=g(E),B=P.value.collator,L=t.value.collator;return A(L,I,D)||A(B,a,E)}e.compareFileExtensionsDefault=o;function d(a,E){a=a||"",E=E||"";const I=g(a),D=g(E),B=P.value.collator,L=t.value.collator;return A(L,I,D)||i(a,E)||A(B,a,E)}e.compareFileExtensionsUpper=d;function u(a,E){a=a||"",E=E||"";const I=g(a),D=g(E),B=P.value.collator,L=t.value.collator;return A(L,I,D)||r(a,E)||A(B,a,E)}e.compareFileExtensionsLower=u;function S(a,E){a=a||"",E=E||"";const I=g(a).toLowerCase(),D=g(E).toLowerCase();return I!==D?I<D?-1:1:a!==E?a<E?-1:1:0}e.compareFileExtensionsUnicode=S;const b=/^(.*?)(\.([^.]*))?$/;function h(a,E=!1){const I=a?b.exec(a):[];let D=[I&&I[1]||"",I&&I[3]||""];return E&&(!D[0]&&D[1]||D[0]&&D[0].charAt(0)===".")&&(D=[D[0]+"."+D[1],""]),D}function g(a){const E=a?b.exec(a):[];return E&&E[1]&&E[1].charAt(0)!=="."&&E[3]||""}function A(a,E,I){let D=a.compare(E,I);return D!==0?D:E.length!==I.length?E.length<I.length?-1:1:0}function l(a){const E=a.charAt(0);return E.toLocaleUpperCase()!==E}function M(a){const E=a.charAt(0);return E.toLocaleLowerCase()!==E}function r(a,E){return l(a)&&M(E)?-1:M(a)&&l(E)?1:0}function i(a,E){return M(a)&&l(E)?-1:l(a)&&M(E)?1:0}function p(a,E,I=!1){return I||(a=a&&a.toLowerCase(),E=E&&E.toLowerCase()),a===E?0:a<E?-1:1}function f(a,E,I=!1){const D=a.split(F.sep),B=E.split(F.sep),L=D.length-1,y=B.length-1;let x,N;for(let z=0;;z++){if(x=L===z,N=y===z,x&&N)return T(D[z],B[z],I);if(x)return-1;if(N)return 1;const H=p(D[z],B[z],I);if(H!==0)return H}}e.comparePaths=f;function s(a,E,I){const D=a.toLowerCase(),B=E.toLowerCase(),L=v(a,E,I);if(L)return L;const y=D.endsWith(I),x=B.endsWith(I);if(y!==x)return y?-1:1;const N=T(D,B);return N!==0?N:D.localeCompare(B)}e.compareAnything=s;function v(a,E,I){const D=a.toLowerCase(),B=E.toLowerCase(),L=D.startsWith(I),y=B.startsWith(I);if(L!==y)return L?-1:1;if(L&&y){if(D.length<B.length)return-1;if(D.length>B.length)return 1}return 0}e.compareByPrefix=v}),define(Ee[29],_e([0,1,14,42,21,17,9]),function(re,e,c,F,w,P,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getPathTerms=e.getBasenameTerms=e.isRelativePattern=e.hasSiblingFn=e.hasSiblingPromiseFn=e.parse=e.match=e.splitGlobAware=e.getEmptyExpression=void 0;function T(){return Object.create(null)}e.getEmptyExpression=T;const C="**",k="/",R="[/\\\\]",_="[^/\\\\]",n=/\//g;function m(K){switch(K){case 0:return"";case 1:return`${_}*?`;default:return`(?:${R}|${_}+${R}|${R}${_}+)*?`}}function o(K,ce){if(!K)return[];const de=[];let Y=!1,ie=!1,we="";for(const Me of K){switch(Me){case ce:if(!Y&&!ie){de.push(we),we="";continue}break;case"{":Y=!0;break;case"}":Y=!1;break;case"[":ie=!0;break;case"]":ie=!1;break}we+=Me}return we&&de.push(we),de}e.splitGlobAware=o;function d(K){if(!K)return"";let ce="";const de=o(K,k);if(de.every(Y=>Y===C))ce=".*";else{let Y=!1;de.forEach((ie,we)=>{if(ie===C){Y||(ce+=m(2),Y=!0);return}let Me=!1,Re="",Be=!1,Qe="";for(const Ge of ie){if(Ge!=="}"&&Me){Re+=Ge;continue}if(Be&&(Ge!=="]"||!Qe)){let Xe;Ge==="-"?Xe=Ge:(Ge==="^"||Ge==="!")&&!Qe?Xe="^":Ge===k?Xe="":Xe=t.escapeRegExpCharacters(Ge),Qe+=Xe;continue}switch(Ge){case"{":Me=!0;continue;case"[":Be=!0;continue;case"}":ce+=`(?:${o(Re,",").map(G=>d(G)).join("|")})`,Me=!1,Re="";break;case"]":ce+="["+Qe+"]",Be=!1,Qe="";break;case"?":ce+=_;continue;case"*":ce+=m(1);continue;default:ce+=t.escapeRegExpCharacters(Ge)}}we<de.length-1&&(de[we+1]!==C||we+2<de.length)&&(ce+=R),Y=!1})}return ce}const u=/^\*\*\/\*\.[\w\.-]+$/,S=/^\*\*\/([\w\.-]+)\/?$/,b=/^{\*\*\/[\*\.]?[\w\.-]+\/?(,\*\*\/[\*\.]?[\w\.-]+\/?)*}$/,h=/^{\*\*\/[\*\.]?[\w\.-]+(\/(\*\*)?)?(,\*\*\/[\*\.]?[\w\.-]+(\/(\*\*)?)?)*}$/,g=/^\*\*((\/[\w\.-]+)+)\/?$/,A=/^([\w\.-]+(\/[\w\.-]+)*)\/?$/,l=new w.LRUCache(1e4),M=function(){return!1},r=function(){return null};function i(K,ce){if(!K)return r;let de;typeof K!="string"?de=K.pattern:de=K,de=de.trim();const Y=`${de}_${!!ce.trimForExclusions}`;let ie=l.get(Y);if(ie)return p(ie,K);let we;if(u.test(de)){const Me=de.substr(4);ie=function(Re,Be){return typeof Re=="string"&&Re.endsWith(Me)?de:null}}else(we=S.exec(f(de,ce)))?ie=s(we[1],de):(ce.trimForExclusions?h:b).test(de)?ie=v(de,ce):(we=g.exec(f(de,ce)))?ie=a(we[1].substr(1),de,!0):(we=A.exec(f(de,ce)))?ie=a(we[1],de,!1):ie=E(de);return l.set(Y,ie),p(ie,K)}function p(K,ce){return typeof ce=="string"?K:function(de,Y){return F.isEqualOrParent(de,ce.base)?K(P.relative(ce.base,de),Y):null}}function f(K,ce){return ce.trimForExclusions&&K.endsWith("/**")?K.substr(0,K.length-2):K}function s(K,ce){const de=`/${K}`,Y=`\\${K}`,ie=function(Me,Re){return typeof Me!="string"?null:Re?Re===K?ce:null:Me===K||Me.endsWith(de)||Me.endsWith(Y)?ce:null},we=[K];return ie.basenames=we,ie.patterns=[ce],ie.allBasenames=we,ie}function v(K,ce){const de=ue(K.slice(1,-1).split(",").map(Re=>i(Re,ce)).filter(Re=>Re!==r),K),Y=de.length;if(!Y)return r;if(Y===1)return de[0];const ie=function(Re,Be){for(let Qe=0,Ge=de.length;Qe<Ge;Qe++)if(de[Qe](Re,Be))return K;return null},we=de.find(Re=>!!Re.allBasenames);we&&(ie.allBasenames=we.allBasenames);const Me=de.reduce((Re,Be)=>Be.allPaths?Re.concat(Be.allPaths):Re,[]);return Me.length&&(ie.allPaths=Me),ie}function a(K,ce,de){const Y=P.sep===P.posix.sep,ie=Y?K:K.replace(n,P.sep),we=P.sep+ie,Me=P.posix.sep+K,Re=de?function(Be,Qe){return typeof Be=="string"&&(Be===ie||Be.endsWith(we)||!Y&&(Be===K||Be.endsWith(Me)))?ce:null}:function(Be,Qe){return typeof Be=="string"&&(Be===ie||!Y&&Be===K)?ce:null};return Re.allPaths=[(de?"*/":"./")+K],Re}function E(K){try{const ce=new RegExp(`^${d(K)}$`);return function(de){return ce.lastIndex=0,typeof de=="string"&&ce.test(de)?K:null}}catch(ce){return r}}function I(K,ce,de){return!K||typeof ce!="string"?!1:D(K)(ce,void 0,de)}e.match=I;function D(K,ce={}){if(!K)return M;if(typeof K=="string"||x(K)){const de=i(K,ce);if(de===r)return M;const Y=function(ie,we){return!!de(ie,we)};return de.allBasenames&&(Y.allBasenames=de.allBasenames),de.allPaths&&(Y.allPaths=de.allPaths),Y}return H(K,ce)}e.parse=D;function B(K){if(!K)return;let ce;return de=>(ce||(ce=(K()||Promise.resolve([])).then(Y=>Y?y(Y):{})),ce.then(Y=>!!Y[de]))}e.hasSiblingPromiseFn=B;function L(K){if(!K)return;let ce;return de=>{if(!ce){const Y=K();ce=Y?y(Y):{}}return!!ce[de]}}e.hasSiblingFn=L;function y(K){const ce={};for(const de of K)ce[de]=!0;return ce}function x(K){const ce=K;return ce&&typeof ce.base=="string"&&typeof ce.pattern=="string"}e.isRelativePattern=x;function N(K){return K.allBasenames||[]}e.getBasenameTerms=N;function z(K){return K.allPaths||[]}e.getPathTerms=z;function H(K,ce){const de=ue(Object.getOwnPropertyNames(K).map(Re=>q(Re,K[Re],ce)).filter(Re=>Re!==r)),Y=de.length;if(!Y)return r;if(!de.some(Re=>!!Re.requiresSiblings)){if(Y===1)return de[0];const Re=function(Ge,Xe){for(let $=0,G=de.length;$<G;$++){const J=de[$](Ge,Xe);if(J)return J}return null},Be=de.find(Ge=>!!Ge.allBasenames);Be&&(Re.allBasenames=Be.allBasenames);const Qe=de.reduce((Ge,Xe)=>Xe.allPaths?Ge.concat(Xe.allPaths):Ge,[]);return Qe.length&&(Re.allPaths=Qe),Re}const ie=function(Re,Be,Qe){let Ge;for(let Xe=0,$=de.length;Xe<$;Xe++){const G=de[Xe];G.requiresSiblings&&Qe&&(Be||(Be=P.basename(Re)),Ge||(Ge=Be.substr(0,Be.length-P.extname(Re).length)));const J=G(Re,Be,Ge,Qe);if(J)return J}return null},we=de.find(Re=>!!Re.allBasenames);we&&(ie.allBasenames=we.allBasenames);const Me=de.reduce((Re,Be)=>Be.allPaths?Re.concat(Be.allPaths):Re,[]);return Me.length&&(ie.allPaths=Me),ie}function q(K,ce,de){if(ce===!1)return r;const Y=i(K,de);if(Y===r)return r;if(typeof ce=="boolean")return Y;if(ce){const ie=ce.when;if(typeof ie=="string"){const we=(Me,Re,Be,Qe)=>{if(!Qe||!Y(Me,Re))return null;const Ge=ie.replace("$(basename)",Be),Xe=Qe(Ge);return(0,c.isThenable)(Xe)?Xe.then($=>$?K:null):Xe?K:null};return we.requiresSiblings=!0,we}}return Y}function ue(K,ce){const de=K.filter(Re=>!!Re.basenames);if(de.length<2)return K;const Y=de.reduce((Re,Be)=>{const Qe=Be.basenames;return Qe?Re.concat(Qe):Re},[]);let ie;if(ce){ie=[];for(let Re=0,Be=Y.length;Re<Be;Re++)ie.push(ce)}else ie=de.reduce((Re,Be)=>{const Qe=Be.patterns;return Qe?Re.concat(Qe):Re},[]);const we=function(Re,Be){if(typeof Re!="string")return null;if(!Be){let Ge;for(Ge=Re.length;Ge>0;Ge--){const Xe=Re.charCodeAt(Ge-1);if(Xe===47||Xe===92)break}Be=Re.substr(Ge)}const Qe=Y.indexOf(Be);return Qe!==-1?ie[Qe]:null};we.basenames=Y,we.patterns=ie,we.allBasenames=Y;const Me=K.filter(Re=>!Re.basenames);return Me.push(we),Me}}),define(Ee[77],_e([0,1,42,10,17,23,24,9,2]),function(re,e,c,F,w,P,t,T,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.splitName=e.unmnemonicLabel=e.mnemonicButtonLabel=e.mnemonicMenuLabel=e.template=e.shorten=e.untildify=e.tildify=e.normalizeDriveLetter=e.getBaseLabel=e.getPathLabel=void 0;function k(i,p,f){if(typeof i=="string"&&(i=C.URI.file(i)),f){const v=f.getWorkspaceFolder(i);if(v){const a=f.getWorkspace().folders.length>1;let E;if((0,t.isEqual)(v.uri,i)?E="":E=(0,t.relativePath)(v.uri,i),a){const I=v.name?v.name:(0,t.basename)(v.uri);E=E?I+" \u2022 "+E:I}return E}}if(i.scheme!==F.Schemas.file&&i.scheme!==F.Schemas.untitled)return i.with({query:null,fragment:null}).toString(!0);if((0,c.hasDriveLetter)(i.fsPath))return(0,w.normalize)(_(i.fsPath));let s=(0,w.normalize)(i.fsPath);return!P.isWindows&&p?.userHome&&(s=m(s,p.userHome.fsPath)),s}e.getPathLabel=k;function R(i){if(!i)return;typeof i=="string"&&(i=C.URI.file(i));const p=(0,t.basename)(i)||(i.scheme===F.Schemas.file?i.fsPath:i.path);return P.isWindows&&(0,c.isRootOrDriveLetter)(p)?_(p):p}e.getBaseLabel=R;function _(i,p){return(0,c.hasDriveLetter)(i,p)?i.charAt(0).toUpperCase()+i.slice(1):i}e.normalizeDriveLetter=_;let n=Object.create(null);function m(i,p){if(P.isWindows||!i||!p)return i;let f=n.original===p?n.normalized:void 0;return f||(f=`${(0,T.rtrim)(p,w.posix.sep)}${w.posix.sep}`,n={original:p,normalized:f}),(P.isLinux?i.startsWith(f):(0,T.startsWithIgnoreCase)(i,f))&&(i=`~/${i.substr(f.length)}`),i}e.tildify=m;function o(i,p){return i.replace(/^~($|\/|\\)/,`${p}$1`)}e.untildify=o;const d="\u2026",u="\\\\",S="~";function b(i,p=w.sep){const f=new Array(i.length);let s=!1;for(let v=0;v<i.length;v++){let a=i[v];if(a===""){f[v]=`.${p}`;continue}if(!a){f[v]=a;continue}s=!0;let E="";a.indexOf(u)===0?(E=a.substr(0,a.indexOf(u)+u.length),a=a.substr(a.indexOf(u)+u.length)):a.indexOf(p)===0?(E=a.substr(0,a.indexOf(p)+p.length),a=a.substr(a.indexOf(p)+p.length)):a.indexOf(S)===0&&(E=a.substr(0,a.indexOf(S)+S.length),a=a.substr(a.indexOf(S)+S.length));const I=a.split(p);for(let D=1;s&&D<=I.length;D++)for(let B=I.length-D;s&&B>=0;B--){s=!1;let L=I.slice(B,B+D).join(p);for(let y=0;!s&&y<i.length;y++)if(y!==v&&i[y]&&i[y].indexOf(L)>-1){const x=B+D===I.length,N=B>0&&i[y].indexOf(p)>-1?p+L:L,z=i[y].endsWith(N);s=!x||z}if(!s){let y="";(I[0].endsWith(":")||E!=="")&&(B===1&&(B=0,D++,L=I[0]+p+L),B>0&&(y=I[0]+p),y=E+y),B>0&&(y=y+d+p),y=y+L,B+D<I.length&&(y=y+p+d),f[v]=y}}s&&(f[v]=a)}return f}e.shorten=b;var h;(function(i){i[i.TEXT=0]="TEXT",i[i.VARIABLE=1]="VARIABLE",i[i.SEPARATOR=2]="SEPARATOR"})(h||(h={}));function g(i,p=Object.create(null)){const f=[];let s=!1,v="";for(const a of i)if(a==="$"||s&&a==="{")v&&f.push({value:v,type:h.TEXT}),v="",s=!0;else if(a==="}"&&s){const E=p[v];if(typeof E=="string")E.length&&f.push({value:E,type:h.VARIABLE});else if(E){const I=f[f.length-1];(!I||I.type!==h.SEPARATOR)&&f.push({value:E.label,type:h.SEPARATOR})}v="",s=!1}else v+=a;return v&&!s&&f.push({value:v,type:h.TEXT}),f.filter((a,E)=>{if(a.type===h.SEPARATOR){const I=f[E-1],D=f[E+1];return[I,D].every(B=>B&&(B.type===h.VARIABLE||B.type===h.TEXT)&&B.value.length>0)}return!0}).map(a=>a.value).join("")}e.template=g;function A(i,p){return P.isMacintosh||p?i.replace(/\(&&\w\)|&&/g,"").replace(/&/g,P.isMacintosh?"&":"&&"):i.replace(/&&|&/g,f=>f==="&"?"&&":"&")}e.mnemonicMenuLabel=A;function l(i,p){return P.isMacintosh||p?i.replace(/\(&&\w\)|&&/g,""):P.isWindows?i.replace(/&&|&/g,f=>f==="&"?"&&":"&"):i.replace(/&&/g,"_")}e.mnemonicButtonLabel=l;function M(i){return i.replace(/&/g,"&&")}e.unmnemonicLabel=M;function r(i){const p=i.indexOf("/")!==-1?w.posix:w.win32,f=p.basename(i),s=p.dirname(i);return f.length?{name:f,parentPath:s}:{name:s,parentPath:""}}e.splitName=r}),define(Ee[78],_e([0,1,29,10,17,24,9]),function(re,e,c,F,w,P,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.normalizeMimeType=e.getExtensionForMimeType=e.getMediaMime=e.getMediaOrTextMime=e.isUnspecific=e.guessMimeTypes=e.clearTextMimes=e.registerTextMime=e.Mimes=void 0;var T;(function(i){i.text="text/plain",i.binary="application/octet-stream",i.unknown="application/unknown",i.markdown="text/markdown",i.latex="text/latex"})(T=e.Mimes||(e.Mimes={}));let C=[],k=[],R=[];function _(i,p=!1){const f=n(i);C.push(f),f.userConfigured?R.push(f):k.push(f),p&&!f.userConfigured&&C.forEach(s=>{s.mime===f.mime||s.userConfigured||(f.extension&&s.extension===f.extension&&console.warn(`Overwriting extension <<${f.extension}>> to now point to mime <<${f.mime}>>`),f.filename&&s.filename===f.filename&&console.warn(`Overwriting filename <<${f.filename}>> to now point to mime <<${f.mime}>>`),f.filepattern&&s.filepattern===f.filepattern&&console.warn(`Overwriting filepattern <<${f.filepattern}>> to now point to mime <<${f.mime}>>`),f.firstline&&s.firstline===f.firstline&&console.warn(`Overwriting firstline <<${f.firstline}>> to now point to mime <<${f.mime}>>`))})}e.registerTextMime=_;function n(i){return{id:i.id,mime:i.mime,filename:i.filename,extension:i.extension,filepattern:i.filepattern,firstline:i.firstline,userConfigured:i.userConfigured,filenameLowercase:i.filename?i.filename.toLowerCase():void 0,extensionLowercase:i.extension?i.extension.toLowerCase():void 0,filepatternLowercase:i.filepattern?(0,c.parse)(i.filepattern.toLowerCase()):void 0,filepatternOnPath:i.filepattern?i.filepattern.indexOf(w.posix.sep)>=0:!1}}function m(i){i?(C=C.filter(p=>!p.userConfigured),R=[]):(C=[],k=[],R=[])}e.clearTextMimes=m;function o(i,p){let f;if(i)switch(i.scheme){case F.Schemas.file:f=i.fsPath;break;case F.Schemas.data:f=P.DataUri.parseMetaData(i).get(P.DataUri.META_DATA_LABEL);break;default:f=i.path}if(!f)return[T.unknown];f=f.toLowerCase();const s=(0,w.basename)(f),v=d(f,s,R);if(v)return[v,T.text];const a=d(f,s,k);if(a)return[a,T.text];if(p){const E=u(p);if(E)return[E,T.text]}return[T.unknown]}e.guessMimeTypes=o;function d(i,p,f){let s=null,v=null,a=null;for(let E=f.length-1;E>=0;E--){const I=f[E];if(p===I.filenameLowercase){s=I;break}if(I.filepattern&&(!v||I.filepattern.length>v.filepattern.length)){const D=I.filepatternOnPath?i:p;I.filepatternLowercase?.(D)&&(v=I)}I.extension&&(!a||I.extension.length>a.extension.length)&&p.endsWith(I.extensionLowercase)&&(a=I)}return s?s.mime:v?v.mime:a?a.mime:null}function u(i){if((0,t.startsWithUTF8BOM)(i)&&(i=i.substr(1)),i.length>0)for(let p=C.length-1;p>=0;p--){const f=C[p];if(!f.firstline)continue;const s=i.match(f.firstline);if(s&&s.length>0)return f.mime}return null}function S(i){return i?typeof i=="string"?i===T.binary||i===T.text||i===T.unknown:i.length===1&&S(i[0]):!0}e.isUnspecific=S;const b={".css":"text/css",".csv":"text/csv",".htm":"text/html",".html":"text/html",".ics":"text/calendar",".js":"text/javascript",".mjs":"text/javascript",".txt":"text/plain",".xml":"text/xml"},h={".aac":"audio/x-aac",".avi":"video/x-msvideo",".bmp":"image/bmp",".flv":"video/x-flv",".gif":"image/gif",".ico":"image/x-icon",".jpe":"image/jpg",".jpeg":"image/jpg",".jpg":"image/jpg",".m1v":"video/mpeg",".m2a":"audio/mpeg",".m2v":"video/mpeg",".m3a":"audio/mpeg",".mid":"audio/midi",".midi":"audio/midi",".mk3d":"video/x-matroska",".mks":"video/x-matroska",".mkv":"video/x-matroska",".mov":"video/quicktime",".movie":"video/x-sgi-movie",".mp2":"audio/mpeg",".mp2a":"audio/mpeg",".mp3":"audio/mpeg",".mp4":"video/mp4",".mp4a":"audio/mp4",".mp4v":"video/mp4",".mpe":"video/mpeg",".mpeg":"video/mpeg",".mpg":"video/mpeg",".mpg4":"video/mp4",".mpga":"audio/mpeg",".oga":"audio/ogg",".ogg":"audio/ogg",".ogv":"video/ogg",".png":"image/png",".psd":"image/vnd.adobe.photoshop",".qt":"video/quicktime",".spx":"audio/ogg",".svg":"image/svg+xml",".tga":"image/x-tga",".tif":"image/tiff",".tiff":"image/tiff",".wav":"audio/x-wav",".webm":"video/webm",".webp":"image/webp",".wma":"audio/x-ms-wma",".wmv":"video/x-ms-wmv",".woff":"application/font-woff"};function g(i){const p=(0,w.extname)(i),f=b[p.toLowerCase()];return f!==void 0?f:A(i)}e.getMediaOrTextMime=g;function A(i){const p=(0,w.extname)(i);return h[p.toLowerCase()]}e.getMediaMime=A;function l(i){for(const p in h)if(h[p]===i)return p}e.getExtensionForMimeType=l;const M=/^(.+)\/(.+?)(;.+)?$/;function r(i,p){const f=M.exec(i);return f?`${f[1].toLowerCase()}/${f[2].toLowerCase()}${f[3]??""}`:p?void 0:i}e.normalizeMimeType=r}),define(Ee[106],_e([0,1,2]),function(re,e,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.transformAndReviveIncomingURIs=e.transformIncomingURIs=e.transformOutgoingURIs=e.DefaultURITransformer=e.URITransformer=void 0;function F(R){return R.toJSON()}class w{constructor(_){this._uriTransformer=_}transformIncoming(_){const n=this._uriTransformer.transformIncoming(_);return n===_?_:F(c.URI.from(n))}transformOutgoing(_){const n=this._uriTransformer.transformOutgoing(_);return n===_?_:F(c.URI.from(n))}transformOutgoingURI(_){const n=this._uriTransformer.transformOutgoing(_);return n===_?_:c.URI.from(n)}transformOutgoingScheme(_){return this._uriTransformer.transformOutgoingScheme(_)}}e.URITransformer=w,e.DefaultURITransformer=new class{transformIncoming(R){return R}transformOutgoing(R){return R}transformOutgoingURI(R){return R}transformOutgoingScheme(R){return R}};function P(R,_,n){if(!R||n>200)return null;if(typeof R=="object"){if(R instanceof c.URI)return _.transformOutgoing(R);for(let m in R)if(Object.hasOwnProperty.call(R,m)){const o=P(R[m],_,n+1);o!==null&&(R[m]=o)}}return null}function t(R,_){const n=P(R,_,0);return n===null?R:n}e.transformOutgoingURIs=t;function T(R,_,n,m){if(!R||m>200)return null;if(typeof R=="object"){if(R.$mid===1)return n?c.URI.revive(_.transformIncoming(R)):_.transformIncoming(R);for(let o in R)if(Object.hasOwnProperty.call(R,o)){const d=T(R[o],_,n,m+1);d!==null&&(R[o]=d)}}return null}function C(R,_){const n=T(R,_,!1,0);return n===null?R:n}e.transformIncomingURIs=C;function k(R,_){const n=T(R,_,!0,0);return n===null?R:n}e.transformAndReviveIncomingURIs=k}),define(Ee[35],_e([0,1]),function(re,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.generateUuid=e.isUUID=void 0;const c=/^[0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12}$/i;function F(C){return c.test(C)}e.isUUID=F;const w=new Uint8Array(16),P=[];for(let C=0;C<256;C++)P.push(C.toString(16).padStart(2,"0"));let t;typeof crypto=="object"&&typeof crypto.getRandomValues=="function"?t=crypto.getRandomValues.bind(crypto):t=function(C){for(let k=0;k<C.length;k++)C[k]=Math.floor(Math.random()*256);return C};function T(){t(w),w[6]=w[6]&15|64,w[8]=w[8]&63|128;let C=0,k="";return k+=P[w[C++]],k+=P[w[C++]],k+=P[w[C++]],k+=P[w[C++]],k+="-",k+=P[w[C++]],k+=P[w[C++]],k+="-",k+=P[w[C++]],k+=P[w[C++]],k+="-",k+=P[w[C++]],k+=P[w[C++]],k+="-",k+=P[w[C++]],k+=P[w[C++]],k+=P[w[C++]],k+=P[w[C++]],k+=P[w[C++]],k+=P[w[C++]],k}e.generateUuid=T}),define(Ee[107],_e([0,1]),function(re,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AutoClosingPairs=e.StandardAutoClosingPairConditional=e.IndentAction=void 0;var c;(function(t){t[t.None=0]="None",t[t.Indent=1]="Indent",t[t.IndentOutdent=2]="IndentOutdent",t[t.Outdent=3]="Outdent"})(c=e.IndentAction||(e.IndentAction={}));class F{constructor(T){if(this._neutralCharacter=null,this._neutralCharacterSearched=!1,this.open=T.open,this.close=T.close,this._standardTokenMask=0,Array.isArray(T.notIn))for(let C=0,k=T.notIn.length;C<k;C++)switch(T.notIn[C]){case"string":this._standardTokenMask|=2;break;case"comment":this._standardTokenMask|=1;break;case"regex":this._standardTokenMask|=4;break}}isOK(T){return(this._standardTokenMask&T)==0}shouldAutoClose(T,C){if(T.getTokenCount()===0)return!0;const k=T.findTokenIndexAtOffset(C-2),R=T.getStandardTokenType(k);return this.isOK(R)}_findNeutralCharacterInRange(T,C){for(let k=T;k<=C;k++){const R=String.fromCharCode(k);if(!this.open.includes(R)&&!this.close.includes(R))return R}return null}findNeutralCharacter(){return this._neutralCharacterSearched||(this._neutralCharacterSearched=!0,this._neutralCharacter||(this._neutralCharacter=this._findNeutralCharacterInRange(48,57)),this._neutralCharacter||(this._neutralCharacter=this._findNeutralCharacterInRange(97,122)),this._neutralCharacter||(this._neutralCharacter=this._findNeutralCharacterInRange(65,90))),this._neutralCharacter}}e.StandardAutoClosingPairConditional=F;class w{constructor(T){this.autoClosingPairsOpenByStart=new Map,this.autoClosingPairsOpenByEnd=new Map,this.autoClosingPairsCloseByStart=new Map,this.autoClosingPairsCloseByEnd=new Map,this.autoClosingPairsCloseSingleChar=new Map;for(const C of T)P(this.autoClosingPairsOpenByStart,C.open.charAt(0),C),P(this.autoClosingPairsOpenByEnd,C.open.charAt(C.open.length-1),C),P(this.autoClosingPairsCloseByStart,C.close.charAt(0),C),P(this.autoClosingPairsCloseByEnd,C.close.charAt(C.close.length-1),C),C.close.length===1&&C.open.length===1&&P(this.autoClosingPairsCloseSingleChar,C.close,C)}}e.AutoClosingPairs=w;function P(t,T,C){t.has(T)?t.get(T).push(C):t.set(T,[C])}}),define(Ee[55],_e([0,1,29,17]),function(re,e,c,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.score=void 0;function w(P,t,T,C){if(Array.isArray(P)){let k=0;for(const R of P){const _=w(R,t,T,C);if(_===10)return _;_>k&&(k=_)}return k}else{if(typeof P=="string")return C?P==="*"?5:P===T?10:0:0;if(P){const{language:k,pattern:R,scheme:_,hasAccessToAllModels:n}=P;if(!C&&!n)return 0;let m=0;if(_)if(_===t.scheme)m=10;else if(_==="*")m=5;else return 0;if(k)if(k===T)m=10;else if(k==="*")m=Math.max(m,5);else return 0;if(R){let o;if(typeof R=="string"?o=R:o={...R,base:(0,F.normalize)(R.base)},o===t.fsPath||(0,c.match)(o,t.fsPath))m=10;else return 0}return m}else return 0}}e.score=w}),define(Ee[108],_e([0,1,3,6]),function(re,e,c,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TokenizationRegistryImpl=void 0;class w{constructor(){this._map=new Map,this._promises=new Map,this._onDidChange=new c.Emitter,this.onDidChange=this._onDidChange.event,this._colorMap=null}fire(t){this._onDidChange.fire({changedLanguages:t,changedColorMap:!1})}register(t,T){return this._map.set(t,T),this.fire([t]),(0,F.toDisposable)(()=>{this._map.get(t)===T&&(this._map.delete(t),this.fire([t]))})}registerPromise(t,T){let C=null,k=!1;return this._promises.set(t,T.then(R=>{this._promises.delete(t),!(k||!R)&&(C=this.register(t,R))})),(0,F.toDisposable)(()=>{k=!0,C&&C.dispose()})}getPromise(t){const T=this.get(t);if(T)return Promise.resolve(T);const C=this._promises.get(t);return C?C.then(k=>this.get(t)):null}get(t){return this._map.get(t)||null}setColorMap(t){this._colorMap=t,this._onDidChange.fire({changedLanguages:Array.from(this._map.keys()),changedColorMap:!0})}getColorMap(){return this._colorMap}getDefaultBackground(){return this._colorMap&&this._colorMap.length>2?this._colorMap[2]:null}}e.TokenizationRegistryImpl=w}),define(Ee[79],_e([0,1,22,23]),function(re,e,c,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.decodeSemanticTokensDto=e.encodeSemanticTokensDto=void 0;var w;(function(_){_[_.Full=1]="Full",_[_.Delta=2]="Delta"})(w||(w={}));function P(_){for(let n=0,m=_.length;n<m;n+=4){const o=_[n+0],d=_[n+1],u=_[n+2],S=_[n+3];_[n+0]=S,_[n+1]=u,_[n+2]=d,_[n+3]=o}}function t(_){const n=new Uint8Array(_.buffer,_.byteOffset,_.length*4);return F.isLittleEndian()||P(n),c.VSBuffer.wrap(n)}function T(_){const n=_.buffer;if(F.isLittleEndian()||P(n),n.byteOffset%4==0)return new Uint32Array(n.buffer,n.byteOffset,n.length/4);{const m=new Uint8Array(n.byteLength);return m.set(n),new Uint32Array(m.buffer,m.byteOffset,m.length/4)}}function C(_){const n=new Uint32Array(k(_));let m=0;if(n[m++]=_.id,_.type==="full")n[m++]=1,n[m++]=_.data.length,n.set(_.data,m),m+=_.data.length;else{n[m++]=2,n[m++]=_.deltas.length;for(const o of _.deltas)n[m++]=o.start,n[m++]=o.deleteCount,o.data?(n[m++]=o.data.length,n.set(o.data,m),m+=o.data.length):n[m++]=0}return t(n)}e.encodeSemanticTokensDto=C;function k(_){let n=0;if(n+=1+1,_.type==="full")n+=1+_.data.length;else{n+=1,n+=(1+1+1)*_.deltas.length;for(const m of _.deltas)m.data&&(n+=m.data.length)}return n}function R(_){const n=T(_);let m=0;const o=n[m++];if(n[m++]===1){const b=n[m++],h=n.subarray(m,m+b);return m+=b,{id:o,type:"full",data:h}}const u=n[m++];let S=[];for(let b=0;b<u;b++){const h=n[m++],g=n[m++],A=n[m++];let l;A>0&&(l=n.subarray(m,m+A),m+=A),S[b]={start:h,deleteCount:g,data:l}}return{id:o,type:"delta",deltas:S}}e.decodeSemanticTokensDto=R}),define(Ee[109],_e([18,19]),function(re,e){return re.create("vs/base/common/date",e)}),define(Ee[110],_e([0,1,109]),function(re,e,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toLocalISOString=e.fromNow=void 0;const F=60,w=F*60,P=w*24,t=P*7,T=P*30,C=P*365;function k(_,n){typeof _!="number"&&(_=_.getTime());const m=Math.round((new Date().getTime()-_)/1e3);if(m<-30)return(0,c.localize)(0,null,k(new Date().getTime()+m*1e3,!1));if(m<30)return(0,c.localize)(1,null);let o;return m<F?(o=m,n?o===1?(0,c.localize)(2,null,o):(0,c.localize)(3,null,o):o===1?(0,c.localize)(4,null,o):(0,c.localize)(5,null,o)):m<w?(o=Math.floor(m/F),n?o===1?(0,c.localize)(6,null,o):(0,c.localize)(7,null,o):o===1?(0,c.localize)(8,null,o):(0,c.localize)(9,null,o)):m<P?(o=Math.floor(m/w),n?o===1?(0,c.localize)(10,null,o):(0,c.localize)(11,null,o):o===1?(0,c.localize)(12,null,o):(0,c.localize)(13,null,o)):m<t?(o=Math.floor(m/P),n?o===1?(0,c.localize)(14,null,o):(0,c.localize)(15,null,o):o===1?(0,c.localize)(16,null,o):(0,c.localize)(17,null,o)):m<T?(o=Math.floor(m/t),n?o===1?(0,c.localize)(18,null,o):(0,c.localize)(19,null,o):o===1?(0,c.localize)(20,null,o):(0,c.localize)(21,null,o)):m<C?(o=Math.floor(m/T),n?o===1?(0,c.localize)(22,null,o):(0,c.localize)(23,null,o):o===1?(0,c.localize)(24,null,o):(0,c.localize)(25,null,o)):(o=Math.floor(m/C),n?o===1?(0,c.localize)(26,null,o):(0,c.localize)(27,null,o):o===1?(0,c.localize)(28,null,o):(0,c.localize)(29,null,o))}e.fromNow=k;function R(_){return _.getFullYear()+"-"+String(_.getMonth()+1).padStart(2,"0")+"-"+String(_.getDate()).padStart(2,"0")+"T"+String(_.getHours()).padStart(2,"0")+":"+String(_.getMinutes()).padStart(2,"0")+":"+String(_.getSeconds()).padStart(2,"0")+"."+(_.getMilliseconds()/1e3).toFixed(3).slice(2,5)+"Z"}e.toLocalISOString=R}),define(Ee[111],_e([18,19]),function(re,e){return re.create("vs/base/common/errorMessage",e)}),define(Ee[43],_e([0,1,16,11,111]),function(re,e,c,F,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toErrorMessage=void 0;function P(k,R){return R&&(k.stack||k.stacktrace)?w.localize(0,null,T(k),t(k.stack)||t(k.stacktrace)):T(k)}function t(k){return Array.isArray(k)?k.join(`
`):k}function T(k){return typeof k.code=="string"&&typeof k.errno=="number"&&typeof k.syscall=="string"?w.localize(1,null,k.message):k.message||w.localize(2,null)}function C(k=null,R=!1){if(!k)return w.localize(3,null);if(Array.isArray(k)){const _=c.coalesce(k),n=C(_[0],R);return _.length>1?w.localize(4,null,n,_.length):n}if(F.isString(k))return k;if(k.detail){const _=k.detail;if(_.error)return P(_.error,R);if(_.exception)return P(_.exception,R)}return k.stack?P(k,R):k.message?k.message:w.localize(5,null)}e.toErrorMessage=C}),define(Ee[112],_e([18,19]),function(re,e){return re.create("vs/editor/common/config/editorOptions",e)}),define(Ee[113],_e([0,1,112,23,114,16,26]),function(re,e,c,F,w,P,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EditorOptions=e.EditorOption=e.editorOptionsRegistry=e.EDITOR_MODEL_DEFAULTS=e.EDITOR_FONT_DEFAULTS=e.WrappingIndent=e.unicodeHighlightConfigKeys=e.inUntrustedWorkspace=e.filterValidationDecorations=e.RenderLineNumbersType=e.EditorLayoutInfoComputer=e.RenderMinimap=e.EditorFontLigatures=e.cursorStyleToString=e.TextEditorCursorStyle=e.TextEditorCursorBlinkingStyle=e.stringSet=e.clampedInt=e.boolean=e.ApplyUpdateResult=e.ComputeOptionsMemory=e.ValidatedEditorOptions=e.ConfigurationChangedEvent=e.MINIMAP_GUTTER_WIDTH=e.EditorAutoIndentStrategy=void 0;var T;(function(V){V[V.None=0]="None",V[V.Keep=1]="Keep",V[V.Brackets=2]="Brackets",V[V.Advanced=3]="Advanced",V[V.Full=4]="Full"})(T=e.EditorAutoIndentStrategy||(e.EditorAutoIndentStrategy={})),e.MINIMAP_GUTTER_WIDTH=8;class C{constructor(Q){this._values=Q}hasChanged(Q){return this._values[Q]}}e.ConfigurationChangedEvent=C;class k{constructor(){this._values=[]}_read(Q){return this._values[Q]}get(Q){return this._values[Q]}_write(Q,he){this._values[Q]=he}}e.ValidatedEditorOptions=k;class R{constructor(){this.stableMinimapLayoutInput=null,this.stableFitMaxMinimapScale=0,this.stableFitRemainingWidth=0}}e.ComputeOptionsMemory=R;class _{constructor(Q,he,Le,We){this.id=Q,this.name=he,this.defaultValue=Le,this.schema=We}applyUpdate(Q,he){return m(Q,he)}compute(Q,he,Le){return Le}}class n{constructor(Q,he){this.newValue=Q,this.didChange=he}}e.ApplyUpdateResult=n;function m(V,Q){if(typeof V!="object"||typeof Q!="object"||!V||!Q)return new n(Q,V!==Q);if(Array.isArray(V)||Array.isArray(Q)){const Le=Array.isArray(V)&&Array.isArray(Q)&&P.equals(V,Q);return new n(Q,Le)}let he=!1;for(let Le in Q)if(Q.hasOwnProperty(Le)){const We=m(V[Le],Q[Le]);We.didChange&&(V[Le]=We.newValue,he=!0)}return new n(V,he)}class o{constructor(Q,he=null){this.schema=void 0,this.id=Q,this.name="_never_",this.defaultValue=void 0,this.deps=he}applyUpdate(Q,he){return m(Q,he)}validate(Q){return this.defaultValue}}class d{constructor(Q,he,Le,We){this.id=Q,this.name=he,this.defaultValue=Le,this.schema=We}applyUpdate(Q,he){return m(Q,he)}validate(Q){return typeof Q=="undefined"?this.defaultValue:Q}compute(Q,he,Le){return Le}}function u(V,Q){return typeof V=="undefined"?Q:V==="false"?!1:Boolean(V)}e.boolean=u;class S extends d{constructor(Q,he,Le,We=void 0){typeof We!="undefined"&&(We.type="boolean",We.default=Le),super(Q,he,Le,We)}validate(Q){return u(Q,this.defaultValue)}}function b(V,Q,he,Le){if(typeof V=="undefined")return Q;let We=parseInt(V,10);return isNaN(We)?Q:(We=Math.max(he,We),We=Math.min(Le,We),We|0)}e.clampedInt=b;class h extends d{constructor(Q,he,Le,We,ot,Ke=void 0){typeof Ke!="undefined"&&(Ke.type="integer",Ke.default=Le,Ke.minimum=We,Ke.maximum=ot),super(Q,he,Le,Ke),this.minimum=We,this.maximum=ot}static clampedInt(Q,he,Le,We){return b(Q,he,Le,We)}validate(Q){return h.clampedInt(Q,this.defaultValue,this.minimum,this.maximum)}}class g extends d{constructor(Q,he,Le,We,ot){typeof ot!="undefined"&&(ot.type="number",ot.default=Le),super(Q,he,Le,ot),this.validationFn=We}static clamp(Q,he,Le){return Q<he?he:Q>Le?Le:Q}static float(Q,he){if(typeof Q=="number")return Q;if(typeof Q=="undefined")return he;const Le=parseFloat(Q);return isNaN(Le)?he:Le}validate(Q){return this.validationFn(g.float(Q,this.defaultValue))}}class A extends d{static string(Q,he){return typeof Q!="string"?he:Q}constructor(Q,he,Le,We=void 0){typeof We!="undefined"&&(We.type="string",We.default=Le),super(Q,he,Le,We)}validate(Q){return A.string(Q,this.defaultValue)}}function l(V,Q,he){return typeof V!="string"||he.indexOf(V)===-1?Q:V}e.stringSet=l;class M extends d{constructor(Q,he,Le,We,ot=void 0){typeof ot!="undefined"&&(ot.type="string",ot.enum=We,ot.default=Le),super(Q,he,Le,ot),this._allowedValues=We}validate(Q){return l(Q,this.defaultValue,this._allowedValues)}}class r extends _{constructor(Q,he,Le,We,ot,Ke,_t=void 0){typeof _t!="undefined"&&(_t.type="string",_t.enum=ot,_t.default=We),super(Q,he,Le,_t),this._allowedValues=ot,this._convert=Ke}validate(Q){return typeof Q!="string"?this.defaultValue:this._allowedValues.indexOf(Q)===-1?this.defaultValue:this._convert(Q)}}function i(V){switch(V){case"none":return 0;case"keep":return 1;case"brackets":return 2;case"advanced":return 3;case"full":return 4}}class p extends _{constructor(){super(2,"accessibilitySupport",0,{type:"string",enum:["auto","on","off"],enumDescriptions:[c.localize(0,null),c.localize(1,null),c.localize(2,null)],default:"auto",description:c.localize(3,null)})}validate(Q){switch(Q){case"auto":return 0;case"off":return 1;case"on":return 2}return this.defaultValue}compute(Q,he,Le){return Le===0?Q.accessibilitySupport:Le}}class f extends _{constructor(){const Q={insertSpace:!0,ignoreEmptyLines:!0};super(19,"comments",Q,{"editor.comments.insertSpace":{type:"boolean",default:Q.insertSpace,description:c.localize(4,null)},"editor.comments.ignoreEmptyLines":{type:"boolean",default:Q.ignoreEmptyLines,description:c.localize(5,null)}})}validate(Q){if(!Q||typeof Q!="object")return this.defaultValue;const he=Q;return{insertSpace:u(he.insertSpace,this.defaultValue.insertSpace),ignoreEmptyLines:u(he.ignoreEmptyLines,this.defaultValue.ignoreEmptyLines)}}}var s;(function(V){V[V.Hidden=0]="Hidden",V[V.Blink=1]="Blink",V[V.Smooth=2]="Smooth",V[V.Phase=3]="Phase",V[V.Expand=4]="Expand",V[V.Solid=5]="Solid"})(s=e.TextEditorCursorBlinkingStyle||(e.TextEditorCursorBlinkingStyle={}));function v(V){switch(V){case"blink":return 1;case"smooth":return 2;case"phase":return 3;case"expand":return 4;case"solid":return 5}}var a;(function(V){V[V.Line=1]="Line",V[V.Block=2]="Block",V[V.Underline=3]="Underline",V[V.LineThin=4]="LineThin",V[V.BlockOutline=5]="BlockOutline",V[V.UnderlineThin=6]="UnderlineThin"})(a=e.TextEditorCursorStyle||(e.TextEditorCursorStyle={}));function E(V){switch(V){case a.Line:return"line";case a.Block:return"block";case a.Underline:return"underline";case a.LineThin:return"line-thin";case a.BlockOutline:return"block-outline";case a.UnderlineThin:return"underline-thin"}}e.cursorStyleToString=E;function I(V){switch(V){case"line":return a.Line;case"block":return a.Block;case"underline":return a.Underline;case"line-thin":return a.LineThin;case"block-outline":return a.BlockOutline;case"underline-thin":return a.UnderlineThin}}class D extends o{constructor(){super(127,[65,33])}compute(Q,he,Le){const We=["monaco-editor"];return he.get(33)&&We.push(he.get(33)),Q.extraEditorClassName&&We.push(Q.extraEditorClassName),he.get(65)==="default"?We.push("mouse-default"):he.get(65)==="copy"&&We.push("mouse-copy"),he.get(99)&&We.push("showUnused"),he.get(125)&&We.push("showDeprecated"),We.join(" ")}}class B extends S{constructor(){super(32,"emptySelectionClipboard",!0,{description:c.localize(6,null)})}compute(Q,he,Le){return Le&&Q.emptySelectionClipboard}}class L extends _{constructor(){const Q={cursorMoveOnType:!0,seedSearchStringFromSelection:"always",autoFindInSelection:"never",globalFindClipboard:!1,addExtraSpaceOnTop:!0,loop:!0};super(35,"find",Q,{"editor.find.cursorMoveOnType":{type:"boolean",default:Q.cursorMoveOnType,description:c.localize(7,null)},"editor.find.seedSearchStringFromSelection":{type:"string",enum:["never","always","selection"],default:Q.seedSearchStringFromSelection,enumDescriptions:[c.localize(8,null),c.localize(9,null),c.localize(10,null)],description:c.localize(11,null)},"editor.find.autoFindInSelection":{type:"string",enum:["never","always","multiline"],default:Q.autoFindInSelection,enumDescriptions:[c.localize(12,null),c.localize(13,null),c.localize(14,null)],description:c.localize(15,null)},"editor.find.globalFindClipboard":{type:"boolean",default:Q.globalFindClipboard,description:c.localize(16,null),included:F.isMacintosh},"editor.find.addExtraSpaceOnTop":{type:"boolean",default:Q.addExtraSpaceOnTop,description:c.localize(17,null)},"editor.find.loop":{type:"boolean",default:Q.loop,description:c.localize(18,null)}})}validate(Q){if(!Q||typeof Q!="object")return this.defaultValue;const he=Q;return{cursorMoveOnType:u(he.cursorMoveOnType,this.defaultValue.cursorMoveOnType),seedSearchStringFromSelection:typeof Q.seedSearchStringFromSelection=="boolean"?Q.seedSearchStringFromSelection?"always":"never":l(he.seedSearchStringFromSelection,this.defaultValue.seedSearchStringFromSelection,["never","always","selection"]),autoFindInSelection:typeof Q.autoFindInSelection=="boolean"?Q.autoFindInSelection?"always":"never":l(he.autoFindInSelection,this.defaultValue.autoFindInSelection,["never","always","multiline"]),globalFindClipboard:u(he.globalFindClipboard,this.defaultValue.globalFindClipboard),addExtraSpaceOnTop:u(he.addExtraSpaceOnTop,this.defaultValue.addExtraSpaceOnTop),loop:u(he.loop,this.defaultValue.loop)}}}class y extends _{constructor(){super(44,"fontLigatures",y.OFF,{anyOf:[{type:"boolean",description:c.localize(19,null)},{type:"string",description:c.localize(20,null)}],description:c.localize(21,null),default:!1})}validate(Q){return typeof Q=="undefined"?this.defaultValue:typeof Q=="string"?Q==="false"?y.OFF:Q==="true"?y.ON:Q:Boolean(Q)?y.ON:y.OFF}}e.EditorFontLigatures=y,y.OFF='"liga" off, "calt" off',y.ON='"liga" on, "calt" on';class x extends o{constructor(){super(43)}compute(Q,he,Le){return Q.fontInfo}}class N extends d{constructor(){super(45,"fontSize",e.EDITOR_FONT_DEFAULTS.fontSize,{type:"number",minimum:6,maximum:100,default:e.EDITOR_FONT_DEFAULTS.fontSize,description:c.localize(22,null)})}validate(Q){let he=g.float(Q,this.defaultValue);return he===0?e.EDITOR_FONT_DEFAULTS.fontSize:g.clamp(he,6,100)}compute(Q,he,Le){return Q.fontInfo.fontSize}}class z extends _{constructor(){super(46,"fontWeight",e.EDITOR_FONT_DEFAULTS.fontWeight,{anyOf:[{type:"number",minimum:z.MINIMUM_VALUE,maximum:z.MAXIMUM_VALUE,errorMessage:c.localize(23,null)},{type:"string",pattern:"^(normal|bold|1000|[1-9][0-9]{0,2})$"},{enum:z.SUGGESTION_VALUES}],default:e.EDITOR_FONT_DEFAULTS.fontWeight,description:c.localize(24,null)})}validate(Q){return Q==="normal"||Q==="bold"?Q:String(h.clampedInt(Q,e.EDITOR_FONT_DEFAULTS.fontWeight,z.MINIMUM_VALUE,z.MAXIMUM_VALUE))}}z.SUGGESTION_VALUES=["normal","bold","100","200","300","400","500","600","700","800","900"],z.MINIMUM_VALUE=1,z.MAXIMUM_VALUE=1e3;class H extends _{constructor(){const Q={multiple:"peek",multipleDefinitions:"peek",multipleTypeDefinitions:"peek",multipleDeclarations:"peek",multipleImplementations:"peek",multipleReferences:"peek",alternativeDefinitionCommand:"editor.action.goToReferences",alternativeTypeDefinitionCommand:"editor.action.goToReferences",alternativeDeclarationCommand:"editor.action.goToReferences",alternativeImplementationCommand:"",alternativeReferenceCommand:""},he={type:"string",enum:["peek","gotoAndPeek","goto"],default:Q.multiple,enumDescriptions:[c.localize(25,null),c.localize(26,null),c.localize(27,null)]},Le=["","editor.action.referenceSearch.trigger","editor.action.goToReferences","editor.action.peekImplementation","editor.action.goToImplementation","editor.action.peekTypeDefinition","editor.action.goToTypeDefinition","editor.action.peekDeclaration","editor.action.revealDeclaration","editor.action.peekDefinition","editor.action.revealDefinitionAside","editor.action.revealDefinition"];super(50,"gotoLocation",Q,{"editor.gotoLocation.multiple":{deprecationMessage:c.localize(28,null)},"editor.gotoLocation.multipleDefinitions":{description:c.localize(29,null),...he},"editor.gotoLocation.multipleTypeDefinitions":{description:c.localize(30,null),...he},"editor.gotoLocation.multipleDeclarations":{description:c.localize(31,null),...he},"editor.gotoLocation.multipleImplementations":{description:c.localize(32,null),...he},"editor.gotoLocation.multipleReferences":{description:c.localize(33,null),...he},"editor.gotoLocation.alternativeDefinitionCommand":{type:"string",default:Q.alternativeDefinitionCommand,enum:Le,description:c.localize(34,null)},"editor.gotoLocation.alternativeTypeDefinitionCommand":{type:"string",default:Q.alternativeTypeDefinitionCommand,enum:Le,description:c.localize(35,null)},"editor.gotoLocation.alternativeDeclarationCommand":{type:"string",default:Q.alternativeDeclarationCommand,enum:Le,description:c.localize(36,null)},"editor.gotoLocation.alternativeImplementationCommand":{type:"string",default:Q.alternativeImplementationCommand,enum:Le,description:c.localize(37,null)},"editor.gotoLocation.alternativeReferenceCommand":{type:"string",default:Q.alternativeReferenceCommand,enum:Le,description:c.localize(38,null)}})}validate(Q){if(!Q||typeof Q!="object")return this.defaultValue;const he=Q;return{multiple:l(he.multiple,this.defaultValue.multiple,["peek","gotoAndPeek","goto"]),multipleDefinitions:he.multipleDefinitions??l(he.multipleDefinitions,"peek",["peek","gotoAndPeek","goto"]),multipleTypeDefinitions:he.multipleTypeDefinitions??l(he.multipleTypeDefinitions,"peek",["peek","gotoAndPeek","goto"]),multipleDeclarations:he.multipleDeclarations??l(he.multipleDeclarations,"peek",["peek","gotoAndPeek","goto"]),multipleImplementations:he.multipleImplementations??l(he.multipleImplementations,"peek",["peek","gotoAndPeek","goto"]),multipleReferences:he.multipleReferences??l(he.multipleReferences,"peek",["peek","gotoAndPeek","goto"]),alternativeDefinitionCommand:A.string(he.alternativeDefinitionCommand,this.defaultValue.alternativeDefinitionCommand),alternativeTypeDefinitionCommand:A.string(he.alternativeTypeDefinitionCommand,this.defaultValue.alternativeTypeDefinitionCommand),alternativeDeclarationCommand:A.string(he.alternativeDeclarationCommand,this.defaultValue.alternativeDeclarationCommand),alternativeImplementationCommand:A.string(he.alternativeImplementationCommand,this.defaultValue.alternativeImplementationCommand),alternativeReferenceCommand:A.string(he.alternativeReferenceCommand,this.defaultValue.alternativeReferenceCommand)}}}class q extends _{constructor(){const Q={enabled:!0,delay:300,sticky:!0,above:!0};super(52,"hover",Q,{"editor.hover.enabled":{type:"boolean",default:Q.enabled,description:c.localize(39,null)},"editor.hover.delay":{type:"number",default:Q.delay,description:c.localize(40,null)},"editor.hover.sticky":{type:"boolean",default:Q.sticky,description:c.localize(41,null)},"editor.hover.above":{type:"boolean",default:Q.above,description:c.localize(42,null)}})}validate(Q){if(!Q||typeof Q!="object")return this.defaultValue;const he=Q;return{enabled:u(he.enabled,this.defaultValue.enabled),delay:h.clampedInt(he.delay,this.defaultValue.delay,0,1e4),sticky:u(he.sticky,this.defaultValue.sticky),above:u(he.above,this.defaultValue.above)}}}var ue;(function(V){V[V.None=0]="None",V[V.Text=1]="Text",V[V.Blocks=2]="Blocks"})(ue=e.RenderMinimap||(e.RenderMinimap={}));class K extends o{constructor(){super(130,[49,57,37,64,91,59,60,93,117,120,121,122,2])}compute(Q,he,Le){return K.computeLayout(he,{memory:Q.memory,outerWidth:Q.outerWidth,outerHeight:Q.outerHeight,isDominatedByLongLines:Q.isDominatedByLongLines,lineHeight:Q.fontInfo.lineHeight,viewLineCount:Q.viewLineCount,lineNumbersDigitCount:Q.lineNumbersDigitCount,typicalHalfwidthCharacterWidth:Q.fontInfo.typicalHalfwidthCharacterWidth,maxDigitWidth:Q.fontInfo.maxDigitWidth,pixelRatio:Q.pixelRatio})}static computeContainedMinimapLineCount(Q){const he=Q.height/Q.lineHeight,Le=Q.scrollBeyondLastLine?he-1:0,We=(Q.viewLineCount+Le)/(Q.pixelRatio*Q.height),ot=Math.floor(Q.viewLineCount/We);return{typicalViewportLineCount:he,extraLinesBeyondLastLine:Le,desiredRatio:We,minimapLineCount:ot}}static _computeMinimapLayout(Q,he){const Le=Q.outerWidth,We=Q.outerHeight,ot=Q.pixelRatio;if(!Q.minimap.enabled)return{renderMinimap:0,minimapLeft:0,minimapWidth:0,minimapHeightIsEditorHeight:!1,minimapIsSampling:!1,minimapScale:1,minimapLineHeight:1,minimapCanvasInnerWidth:0,minimapCanvasInnerHeight:Math.floor(ot*We),minimapCanvasOuterWidth:0,minimapCanvasOuterHeight:We};const Ke=he.stableMinimapLayoutInput,_t=Ke&&Q.outerHeight===Ke.outerHeight&&Q.lineHeight===Ke.lineHeight&&Q.typicalHalfwidthCharacterWidth===Ke.typicalHalfwidthCharacterWidth&&Q.pixelRatio===Ke.pixelRatio&&Q.scrollBeyondLastLine===Ke.scrollBeyondLastLine&&Q.minimap.enabled===Ke.minimap.enabled&&Q.minimap.side===Ke.minimap.side&&Q.minimap.size===Ke.minimap.size&&Q.minimap.showSlider===Ke.minimap.showSlider&&Q.minimap.renderCharacters===Ke.minimap.renderCharacters&&Q.minimap.maxColumn===Ke.minimap.maxColumn&&Q.minimap.scale===Ke.minimap.scale&&Q.verticalScrollbarWidth===Ke.verticalScrollbarWidth&&Q.isViewportWrapping===Ke.isViewportWrapping,Ie=Q.lineHeight,Se=Q.typicalHalfwidthCharacterWidth,ve=Q.scrollBeyondLastLine,oe=Q.minimap.renderCharacters;let se=ot>=2?Math.round(Q.minimap.scale*2):Q.minimap.scale;const fe=Q.minimap.maxColumn,ge=Q.minimap.size,ke=Q.minimap.side,ze=Q.verticalScrollbarWidth,Oe=Q.viewLineCount,Ve=Q.remainingWidth,it=Q.isViewportWrapping,rt=oe?2:3;let ne=Math.floor(ot*We);const pe=ne/ot;let ee=!1,W=!1,be=rt*se,De=se/ot,qe=1;if(ge==="fill"||ge==="fit"){const{typicalViewportLineCount:gt,extraLinesBeyondLastLine:yt,desiredRatio:Lt,minimapLineCount:It}=K.computeContainedMinimapLineCount({viewLineCount:Oe,scrollBeyondLastLine:ve,height:We,lineHeight:Ie,pixelRatio:ot});if(Oe/It>1)ee=!0,W=!0,se=1,be=1,De=se/ot;else{let At=!1,Et=se+1;if(ge==="fit"){const Ot=Math.ceil((Oe+yt)*be);it&&_t&&Ve<=he.stableFitRemainingWidth?(At=!0,Et=he.stableFitMaxMinimapScale):At=Ot>ne}if(ge==="fill"||At){ee=!0;const Ot=se;be=Math.min(Ie*ot,Math.max(1,Math.floor(1/Lt))),it&&_t&&Ve<=he.stableFitRemainingWidth&&(Et=he.stableFitMaxMinimapScale),se=Math.min(Et,Math.max(1,Math.floor(be/rt))),se>Ot&&(qe=Math.min(2,se/Ot)),De=se/ot/qe,ne=Math.ceil(Math.max(gt,Oe+yt)*be),it?(he.stableMinimapLayoutInput=Q,he.stableFitRemainingWidth=Ve,he.stableFitMaxMinimapScale=se):(he.stableMinimapLayoutInput=null,he.stableFitRemainingWidth=0)}}}const xe=Math.floor(fe*De),ut=Math.min(xe,Math.max(0,Math.floor((Ve-ze-2)*De/(Se+De)))+e.MINIMAP_GUTTER_WIDTH);let vt=Math.floor(ot*ut);const Ct=vt/ot;vt=Math.floor(vt*qe);const bt=oe?1:2,ht=ke==="left"?0:Le-ut-ze;return{renderMinimap:bt,minimapLeft:ht,minimapWidth:ut,minimapHeightIsEditorHeight:ee,minimapIsSampling:W,minimapScale:se,minimapLineHeight:be,minimapCanvasInnerWidth:vt,minimapCanvasInnerHeight:ne,minimapCanvasOuterWidth:Ct,minimapCanvasOuterHeight:pe}}static computeLayout(Q,he){const Le=he.outerWidth|0,We=he.outerHeight|0,ot=he.lineHeight|0,Ke=he.lineNumbersDigitCount|0,_t=he.typicalHalfwidthCharacterWidth,Ie=he.maxDigitWidth,Se=he.pixelRatio,ve=he.viewLineCount,oe=Q.get(122),se=oe==="inherit"?Q.get(121):oe,fe=se==="inherit"?Q.get(117):se,ge=Q.get(120),ke=Q.get(2),ze=he.isDominatedByLongLines,Oe=Q.get(49),Ve=Q.get(59).renderType!==0,it=Q.get(60),rt=Q.get(93),ne=Q.get(64),pe=Q.get(91),ee=pe.verticalScrollbarSize,W=pe.verticalHasArrows,be=pe.arrowSize,De=pe.horizontalScrollbarSize,qe=Q.get(57),xe=Q.get(37);let ut;if(typeof qe=="string"&&/^\d+(\.\d+)?ch$/.test(qe)){const $t=parseFloat(qe.substr(0,qe.length-2));ut=h.clampedInt($t*_t,0,0,1e3)}else ut=h.clampedInt(qe,0,0,1e3);xe&&(ut+=16);let vt=0;if(Ve){const $t=Math.max(Ke,it);vt=Math.round($t*Ie)}let Ct=0;Oe&&(Ct=ot);let bt=0,ht=bt+Ct,gt=ht+vt,yt=gt+ut;const Lt=Le-Ct-vt-ut;let It=!1,Pt=!1,At=-1;ke!==2&&(se==="inherit"&&ze?(It=!0,Pt=!0):fe==="on"||fe==="bounded"?Pt=!0:fe==="wordWrapColumn"&&(At=ge));const Et=K._computeMinimapLayout({outerWidth:Le,outerHeight:We,lineHeight:ot,typicalHalfwidthCharacterWidth:_t,pixelRatio:Se,scrollBeyondLastLine:rt,minimap:ne,verticalScrollbarWidth:ee,viewLineCount:ve,remainingWidth:Lt,isViewportWrapping:Pt},he.memory||new R);Et.renderMinimap!==0&&Et.minimapLeft===0&&(bt+=Et.minimapWidth,ht+=Et.minimapWidth,gt+=Et.minimapWidth,yt+=Et.minimapWidth);const Ot=Lt-Et.minimapWidth,Nt=Math.max(1,Math.floor((Ot-ee-2)/_t)),wt=W?be:0;return Pt&&(At=Math.max(1,Nt),fe==="bounded"&&(At=Math.min(At,ge))),{width:Le,height:We,glyphMarginLeft:bt,glyphMarginWidth:Ct,lineNumbersLeft:ht,lineNumbersWidth:vt,decorationsLeft:gt,decorationsWidth:ut,contentLeft:yt,contentWidth:Ot,minimap:Et,viewportColumn:Nt,isWordWrapMinified:It,isViewportWrapping:Pt,wrappingColumn:At,verticalScrollbarWidth:ee,horizontalScrollbarHeight:De,overviewRuler:{top:wt,width:ee,height:We-2*wt,right:0}}}}e.EditorLayoutInfoComputer=K;class ce extends _{constructor(){const Q={enabled:!0};super(56,"lightbulb",Q,{"editor.lightbulb.enabled":{type:"boolean",default:Q.enabled,description:c.localize(43,null)}})}validate(Q){return!Q||typeof Q!="object"?this.defaultValue:{enabled:u(Q.enabled,this.defaultValue.enabled)}}}class de extends _{constructor(){const Q={enabled:!0,fontSize:0,fontFamily:""};super(126,"inlayHints",Q,{"editor.inlayHints.enabled":{type:"boolean",default:Q.enabled,description:c.localize(44,null)},"editor.inlayHints.fontSize":{type:"number",default:Q.fontSize,markdownDescription:c.localize(45,null)},"editor.inlayHints.fontFamily":{type:"string",default:Q.fontFamily,markdownDescription:c.localize(46,null)}})}validate(Q){if(!Q||typeof Q!="object")return this.defaultValue;const he=Q;return{enabled:u(he.enabled,this.defaultValue.enabled),fontSize:h.clampedInt(he.fontSize,this.defaultValue.fontSize,0,100),fontFamily:A.string(he.fontFamily,this.defaultValue.fontFamily)}}}class Y extends g{constructor(){super(58,"lineHeight",e.EDITOR_FONT_DEFAULTS.lineHeight,Q=>g.clamp(Q,0,150),{markdownDescription:c.localize(47,null)})}compute(Q,he,Le){return Q.fontInfo.lineHeight}}class ie extends _{constructor(){const Q={enabled:!0,size:"proportional",side:"right",showSlider:"mouseover",renderCharacters:!0,maxColumn:120,scale:1};super(64,"minimap",Q,{"editor.minimap.enabled":{type:"boolean",default:Q.enabled,description:c.localize(48,null)},"editor.minimap.size":{type:"string",enum:["proportional","fill","fit"],enumDescriptions:[c.localize(49,null),c.localize(50,null),c.localize(51,null)],default:Q.size,description:c.localize(52,null)},"editor.minimap.side":{type:"string",enum:["left","right"],default:Q.side,description:c.localize(53,null)},"editor.minimap.showSlider":{type:"string",enum:["always","mouseover"],default:Q.showSlider,description:c.localize(54,null)},"editor.minimap.scale":{type:"number",default:Q.scale,minimum:1,maximum:3,enum:[1,2,3],description:c.localize(55,null)},"editor.minimap.renderCharacters":{type:"boolean",default:Q.renderCharacters,description:c.localize(56,null)},"editor.minimap.maxColumn":{type:"number",default:Q.maxColumn,description:c.localize(57,null)}})}validate(Q){if(!Q||typeof Q!="object")return this.defaultValue;const he=Q;return{enabled:u(he.enabled,this.defaultValue.enabled),size:l(he.size,this.defaultValue.size,["proportional","fill","fit"]),side:l(he.side,this.defaultValue.side,["right","left"]),showSlider:l(he.showSlider,this.defaultValue.showSlider,["always","mouseover"]),renderCharacters:u(he.renderCharacters,this.defaultValue.renderCharacters),scale:h.clampedInt(he.scale,1,1,3),maxColumn:h.clampedInt(he.maxColumn,this.defaultValue.maxColumn,1,1e4)}}}function we(V){return V==="ctrlCmd"?F.isMacintosh?"metaKey":"ctrlKey":"altKey"}class Me extends _{constructor(){super(74,"padding",{top:0,bottom:0},{"editor.padding.top":{type:"number",default:0,minimum:0,maximum:1e3,description:c.localize(58,null)},"editor.padding.bottom":{type:"number",default:0,minimum:0,maximum:1e3,description:c.localize(59,null)}})}validate(Q){if(!Q||typeof Q!="object")return this.defaultValue;const he=Q;return{top:h.clampedInt(he.top,0,0,1e3),bottom:h.clampedInt(he.bottom,0,0,1e3)}}}class Re extends _{constructor(){const Q={enabled:!0,cycle:!1};super(75,"parameterHints",Q,{"editor.parameterHints.enabled":{type:"boolean",default:Q.enabled,description:c.localize(60,null)},"editor.parameterHints.cycle":{type:"boolean",default:Q.cycle,description:c.localize(61,null)}})}validate(Q){if(!Q||typeof Q!="object")return this.defaultValue;const he=Q;return{enabled:u(he.enabled,this.defaultValue.enabled),cycle:u(he.cycle,this.defaultValue.cycle)}}}class Be extends o{constructor(){super(128)}compute(Q,he,Le){return Q.pixelRatio}}class Qe extends _{constructor(){const Q={other:!0,comments:!1,strings:!1};super(78,"quickSuggestions",Q,{anyOf:[{type:"boolean"},{type:"object",properties:{strings:{type:"boolean",default:Q.strings,description:c.localize(62,null)},comments:{type:"boolean",default:Q.comments,description:c.localize(63,null)},other:{type:"boolean",default:Q.other,description:c.localize(64,null)}}}],default:Q,description:c.localize(65,null)});this.defaultValue=Q}validate(Q){if(typeof Q=="boolean")return Q;if(Q&&typeof Q=="object"){const he=Q,Le={other:u(he.other,this.defaultValue.other),comments:u(he.comments,this.defaultValue.comments),strings:u(he.strings,this.defaultValue.strings)};return Le.other&&Le.comments&&Le.strings?!0:!Le.other&&!Le.comments&&!Le.strings?!1:Le}return this.defaultValue}}var Ge;(function(V){V[V.Off=0]="Off",V[V.On=1]="On",V[V.Relative=2]="Relative",V[V.Interval=3]="Interval",V[V.Custom=4]="Custom"})(Ge=e.RenderLineNumbersType||(e.RenderLineNumbersType={}));class Xe extends _{constructor(){super(59,"lineNumbers",{renderType:1,renderFn:null},{type:"string",enum:["off","on","relative","interval"],enumDescriptions:[c.localize(66,null),c.localize(67,null),c.localize(68,null),c.localize(69,null)],default:"on",description:c.localize(70,null)})}validate(Q){let he=this.defaultValue.renderType,Le=this.defaultValue.renderFn;return typeof Q!="undefined"&&(typeof Q=="function"?(he=4,Le=Q):Q==="interval"?he=3:Q==="relative"?he=2:Q==="on"?he=1:he=0),{renderType:he,renderFn:Le}}}function $(V){const Q=V.get(86);return Q==="editable"?V.get(80):Q!=="on"}e.filterValidationDecorations=$;class G extends _{constructor(){const Q=[],he={type:"number",description:c.localize(71,null)};super(90,"rulers",Q,{type:"array",items:{anyOf:[he,{type:["object"],properties:{column:he,color:{type:"string",description:c.localize(72,null),format:"color-hex"}}}]},default:Q,description:c.localize(73,null)})}validate(Q){if(Array.isArray(Q)){let he=[];for(let Le of Q)if(typeof Le=="number")he.push({column:h.clampedInt(Le,0,0,1e4),color:null});else if(Le&&typeof Le=="object"){const We=Le;he.push({column:h.clampedInt(We.column,0,0,1e4),color:We.color})}return he.sort((Le,We)=>Le.column-We.column),he}return this.defaultValue}}function J(V,Q){if(typeof V!="string")return Q;switch(V){case"hidden":return 2;case"visible":return 3;default:return 1}}class ae extends _{constructor(){const Q={vertical:1,horizontal:1,arrowSize:11,useShadows:!0,verticalHasArrows:!1,horizontalHasArrows:!1,horizontalScrollbarSize:12,horizontalSliderSize:12,verticalScrollbarSize:14,verticalSliderSize:14,handleMouseWheel:!0,alwaysConsumeMouseWheel:!0,scrollByPage:!1};super(91,"scrollbar",Q,{"editor.scrollbar.vertical":{type:"string",enum:["auto","visible","hidden"],enumDescriptions:[c.localize(74,null),c.localize(75,null),c.localize(76,null)],default:"auto",description:c.localize(77,null)},"editor.scrollbar.horizontal":{type:"string",enum:["auto","visible","hidden"],enumDescriptions:[c.localize(78,null),c.localize(79,null),c.localize(80,null)],default:"auto",description:c.localize(81,null)},"editor.scrollbar.verticalScrollbarSize":{type:"number",default:Q.verticalScrollbarSize,description:c.localize(82,null)},"editor.scrollbar.horizontalScrollbarSize":{type:"number",default:Q.horizontalScrollbarSize,description:c.localize(83,null)},"editor.scrollbar.scrollByPage":{type:"boolean",default:Q.scrollByPage,description:c.localize(84,null)}})}validate(Q){if(!Q||typeof Q!="object")return this.defaultValue;const he=Q,Le=h.clampedInt(he.horizontalScrollbarSize,this.defaultValue.horizontalScrollbarSize,0,1e3),We=h.clampedInt(he.verticalScrollbarSize,this.defaultValue.verticalScrollbarSize,0,1e3);return{arrowSize:h.clampedInt(he.arrowSize,this.defaultValue.arrowSize,0,1e3),vertical:J(he.vertical,this.defaultValue.vertical),horizontal:J(he.horizontal,this.defaultValue.horizontal),useShadows:u(he.useShadows,this.defaultValue.useShadows),verticalHasArrows:u(he.verticalHasArrows,this.defaultValue.verticalHasArrows),horizontalHasArrows:u(he.horizontalHasArrows,this.defaultValue.horizontalHasArrows),handleMouseWheel:u(he.handleMouseWheel,this.defaultValue.handleMouseWheel),alwaysConsumeMouseWheel:u(he.alwaysConsumeMouseWheel,this.defaultValue.alwaysConsumeMouseWheel),horizontalScrollbarSize:Le,horizontalSliderSize:h.clampedInt(he.horizontalSliderSize,Le,0,1e3),verticalScrollbarSize:We,verticalSliderSize:h.clampedInt(he.verticalSliderSize,We,0,1e3),scrollByPage:u(he.scrollByPage,this.defaultValue.scrollByPage)}}}e.inUntrustedWorkspace="inUntrustedWorkspace",e.unicodeHighlightConfigKeys={allowedCharacters:"editor.unicodeHighlight.allowedCharacters",invisibleCharacters:"editor.unicodeHighlight.invisibleCharacters",nonBasicASCII:"editor.unicodeHighlight.nonBasicASCII",ambiguousCharacters:"editor.unicodeHighlight.ambiguousCharacters",includeComments:"editor.unicodeHighlight.includeComments"};class j extends _{constructor(){const Q={nonBasicASCII:e.inUntrustedWorkspace,invisibleCharacters:!0,ambiguousCharacters:!0,includeComments:e.inUntrustedWorkspace,allowedCharacters:{}};super(112,"unicodeHighlight",Q,{[e.unicodeHighlightConfigKeys.nonBasicASCII]:{restricted:!0,type:["boolean","string"],enum:[!0,!1,e.inUntrustedWorkspace],default:Q.nonBasicASCII,description:c.localize(85,null)},[e.unicodeHighlightConfigKeys.invisibleCharacters]:{restricted:!0,type:"boolean",default:Q.invisibleCharacters,description:c.localize(86,null)},[e.unicodeHighlightConfigKeys.ambiguousCharacters]:{restricted:!0,type:"boolean",default:Q.ambiguousCharacters,description:c.localize(87,null)},[e.unicodeHighlightConfigKeys.includeComments]:{restricted:!0,type:["boolean","string"],enum:[!0,!1,e.inUntrustedWorkspace],default:Q.includeComments,description:c.localize(88,null)},[e.unicodeHighlightConfigKeys.allowedCharacters]:{restricted:!0,type:"object",default:Q.allowedCharacters,description:c.localize(89,null),additionalProperties:{type:"boolean"}}})}applyUpdate(Q,he){let Le=!1;he.allowedCharacters&&(t.equals(Q.allowedCharacters,he.allowedCharacters)||(Q={...Q,allowedCharacters:he.allowedCharacters},Le=!0));const We=super.applyUpdate(Q,he);return Le?new n(We.newValue,!0):We}validate(Q){if(!Q||typeof Q!="object")return this.defaultValue;const he=Q;return{nonBasicASCII:Ne(he.nonBasicASCII,e.inUntrustedWorkspace,[!0,!1,e.inUntrustedWorkspace]),invisibleCharacters:u(he.invisibleCharacters,this.defaultValue.invisibleCharacters),ambiguousCharacters:u(he.ambiguousCharacters,this.defaultValue.ambiguousCharacters),includeComments:Ne(he.includeComments,e.inUntrustedWorkspace,[!0,!1,e.inUntrustedWorkspace]),allowedCharacters:this.validateAllowedCharacters(Q.allowedCharacters,this.defaultValue.allowedCharacters)}}validateAllowedCharacters(Q,he){if(typeof Q!="object"||!Q)return he;const Le={};for(const[We,ot]of Object.entries(Q))ot===!0&&(Le[We]=!0);return Le}}class te extends _{constructor(){const Q={enabled:!0,mode:"subwordSmart"};super(54,"inlineSuggest",Q,{"editor.inlineSuggest.enabled":{type:"boolean",default:Q.enabled,description:c.localize(90,null)}})}validate(Q){if(!Q||typeof Q!="object")return this.defaultValue;const he=Q;return{enabled:u(he.enabled,this.defaultValue.enabled),mode:l(he.mode,this.defaultValue.mode,["prefix","subword","subwordSmart"])}}}class me extends _{constructor(){const Q={enabled:e.EDITOR_MODEL_DEFAULTS.bracketPairColorizationOptions.enabled};super(12,"bracketPairColorization",Q,{"editor.bracketPairColorization.enabled":{type:"boolean",default:Q.enabled,description:c.localize(91,null)}})}validate(Q){return!Q||typeof Q!="object"?this.defaultValue:{enabled:u(Q.enabled,this.defaultValue.enabled)}}}class Pe extends _{constructor(){const Q={bracketPairs:!1,bracketPairsHorizontal:"active",highlightActiveBracketPair:!0,indentation:!0,highlightActiveIndentation:!0};super(13,"guides",Q,{"editor.guides.bracketPairs":{type:["boolean","string"],enum:[!0,"active",!1],enumDescriptions:[c.localize(92,null),c.localize(93,null),c.localize(94,null)],default:Q.bracketPairs,description:c.localize(95,null)},"editor.guides.bracketPairsHorizontal":{type:["boolean","string"],enum:[!0,"active",!1],enumDescriptions:[c.localize(96,null),c.localize(97,null),c.localize(98,null)],default:Q.bracketPairsHorizontal,description:c.localize(99,null)},"editor.guides.highlightActiveBracketPair":{type:"boolean",default:Q.highlightActiveBracketPair,description:c.localize(100,null)},"editor.guides.indentation":{type:"boolean",default:Q.indentation,description:c.localize(101,null)},"editor.guides.highlightActiveIndentation":{type:"boolean",default:Q.highlightActiveIndentation,description:c.localize(102,null)}})}validate(Q){if(!Q||typeof Q!="object")return this.defaultValue;const he=Q;return{bracketPairs:Ne(he.bracketPairs,this.defaultValue.bracketPairs,[!0,!1,"active"]),bracketPairsHorizontal:Ne(he.bracketPairsHorizontal,this.defaultValue.bracketPairsHorizontal,[!0,!1,"active"]),highlightActiveBracketPair:u(he.highlightActiveBracketPair,this.defaultValue.highlightActiveBracketPair),indentation:u(he.indentation,this.defaultValue.indentation),highlightActiveIndentation:u(he.highlightActiveIndentation,this.defaultValue.highlightActiveIndentation)}}}function Ne(V,Q,he){const Le=he.indexOf(V);return Le===-1?Q:he[Le]}class He extends _{constructor(){const Q={insertMode:"insert",filterGraceful:!0,snippetsPreventQuickSuggestions:!0,localityBonus:!1,shareSuggestSelections:!1,showIcons:!0,showStatusBar:!1,preview:!1,previewMode:"subwordSmart",showInlineDetails:!0,showMethods:!0,showFunctions:!0,showConstructors:!0,showDeprecated:!0,showFields:!0,showVariables:!0,showClasses:!0,showStructs:!0,showInterfaces:!0,showModules:!0,showProperties:!0,showEvents:!0,showOperators:!0,showUnits:!0,showValues:!0,showConstants:!0,showEnums:!0,showEnumMembers:!0,showKeywords:!0,showWords:!0,showColors:!0,showFiles:!0,showReferences:!0,showFolders:!0,showTypeParameters:!0,showSnippets:!0,showUsers:!0,showIssues:!0};super(105,"suggest",Q,{"editor.suggest.insertMode":{type:"string",enum:["insert","replace"],enumDescriptions:[c.localize(103,null),c.localize(104,null)],default:Q.insertMode,description:c.localize(105,null)},"editor.suggest.filterGraceful":{type:"boolean",default:Q.filterGraceful,description:c.localize(106,null)},"editor.suggest.localityBonus":{type:"boolean",default:Q.localityBonus,description:c.localize(107,null)},"editor.suggest.shareSuggestSelections":{type:"boolean",default:Q.shareSuggestSelections,markdownDescription:c.localize(108,null)},"editor.suggest.snippetsPreventQuickSuggestions":{type:"boolean",default:Q.snippetsPreventQuickSuggestions,description:c.localize(109,null)},"editor.suggest.showIcons":{type:"boolean",default:Q.showIcons,description:c.localize(110,null)},"editor.suggest.showStatusBar":{type:"boolean",default:Q.showStatusBar,description:c.localize(111,null)},"editor.suggest.preview":{type:"boolean",default:Q.preview,description:c.localize(112,null)},"editor.suggest.showInlineDetails":{type:"boolean",default:Q.showInlineDetails,description:c.localize(113,null)},"editor.suggest.maxVisibleSuggestions":{type:"number",deprecationMessage:c.localize(114,null)},"editor.suggest.filteredTypes":{type:"object",deprecationMessage:c.localize(115,null)},"editor.suggest.showMethods":{type:"boolean",default:!0,markdownDescription:c.localize(116,null)},"editor.suggest.showFunctions":{type:"boolean",default:!0,markdownDescription:c.localize(117,null)},"editor.suggest.showConstructors":{type:"boolean",default:!0,markdownDescription:c.localize(118,null)},"editor.suggest.showDeprecated":{type:"boolean",default:!0,markdownDescription:c.localize(119,null)},"editor.suggest.showFields":{type:"boolean",default:!0,markdownDescription:c.localize(120,null)},"editor.suggest.showVariables":{type:"boolean",default:!0,markdownDescription:c.localize(121,null)},"editor.suggest.showClasses":{type:"boolean",default:!0,markdownDescription:c.localize(122,null)},"editor.suggest.showStructs":{type:"boolean",default:!0,markdownDescription:c.localize(123,null)},"editor.suggest.showInterfaces":{type:"boolean",default:!0,markdownDescription:c.localize(124,null)},"editor.suggest.showModules":{type:"boolean",default:!0,markdownDescription:c.localize(125,null)},"editor.suggest.showProperties":{type:"boolean",default:!0,markdownDescription:c.localize(126,null)},"editor.suggest.showEvents":{type:"boolean",default:!0,markdownDescription:c.localize(127,null)},"editor.suggest.showOperators":{type:"boolean",default:!0,markdownDescription:c.localize(128,null)},"editor.suggest.showUnits":{type:"boolean",default:!0,markdownDescription:c.localize(129,null)},"editor.suggest.showValues":{type:"boolean",default:!0,markdownDescription:c.localize(130,null)},"editor.suggest.showConstants":{type:"boolean",default:!0,markdownDescription:c.localize(131,null)},"editor.suggest.showEnums":{type:"boolean",default:!0,markdownDescription:c.localize(132,null)},"editor.suggest.showEnumMembers":{type:"boolean",default:!0,markdownDescription:c.localize(133,null)},"editor.suggest.showKeywords":{type:"boolean",default:!0,markdownDescription:c.localize(134,null)},"editor.suggest.showWords":{type:"boolean",default:!0,markdownDescription:c.localize(135,null)},"editor.suggest.showColors":{type:"boolean",default:!0,markdownDescription:c.localize(136,null)},"editor.suggest.showFiles":{type:"boolean",default:!0,markdownDescription:c.localize(137,null)},"editor.suggest.showReferences":{type:"boolean",default:!0,markdownDescription:c.localize(138,null)},"editor.suggest.showCustomcolors":{type:"boolean",default:!0,markdownDescription:c.localize(139,null)},"editor.suggest.showFolders":{type:"boolean",default:!0,markdownDescription:c.localize(140,null)},"editor.suggest.showTypeParameters":{type:"boolean",default:!0,markdownDescription:c.localize(141,null)},"editor.suggest.showSnippets":{type:"boolean",default:!0,markdownDescription:c.localize(142,null)},"editor.suggest.showUsers":{type:"boolean",default:!0,markdownDescription:c.localize(143,null)},"editor.suggest.showIssues":{type:"boolean",default:!0,markdownDescription:c.localize(144,null)}})}validate(Q){if(!Q||typeof Q!="object")return this.defaultValue;const he=Q;return{insertMode:l(he.insertMode,this.defaultValue.insertMode,["insert","replace"]),filterGraceful:u(he.filterGraceful,this.defaultValue.filterGraceful),snippetsPreventQuickSuggestions:u(he.snippetsPreventQuickSuggestions,this.defaultValue.filterGraceful),localityBonus:u(he.localityBonus,this.defaultValue.localityBonus),shareSuggestSelections:u(he.shareSuggestSelections,this.defaultValue.shareSuggestSelections),showIcons:u(he.showIcons,this.defaultValue.showIcons),showStatusBar:u(he.showStatusBar,this.defaultValue.showStatusBar),preview:u(he.preview,this.defaultValue.preview),previewMode:l(he.previewMode,this.defaultValue.previewMode,["prefix","subword","subwordSmart"]),showInlineDetails:u(he.showInlineDetails,this.defaultValue.showInlineDetails),showMethods:u(he.showMethods,this.defaultValue.showMethods),showFunctions:u(he.showFunctions,this.defaultValue.showFunctions),showConstructors:u(he.showConstructors,this.defaultValue.showConstructors),showDeprecated:u(he.showDeprecated,this.defaultValue.showDeprecated),showFields:u(he.showFields,this.defaultValue.showFields),showVariables:u(he.showVariables,this.defaultValue.showVariables),showClasses:u(he.showClasses,this.defaultValue.showClasses),showStructs:u(he.showStructs,this.defaultValue.showStructs),showInterfaces:u(he.showInterfaces,this.defaultValue.showInterfaces),showModules:u(he.showModules,this.defaultValue.showModules),showProperties:u(he.showProperties,this.defaultValue.showProperties),showEvents:u(he.showEvents,this.defaultValue.showEvents),showOperators:u(he.showOperators,this.defaultValue.showOperators),showUnits:u(he.showUnits,this.defaultValue.showUnits),showValues:u(he.showValues,this.defaultValue.showValues),showConstants:u(he.showConstants,this.defaultValue.showConstants),showEnums:u(he.showEnums,this.defaultValue.showEnums),showEnumMembers:u(he.showEnumMembers,this.defaultValue.showEnumMembers),showKeywords:u(he.showKeywords,this.defaultValue.showKeywords),showWords:u(he.showWords,this.defaultValue.showWords),showColors:u(he.showColors,this.defaultValue.showColors),showFiles:u(he.showFiles,this.defaultValue.showFiles),showReferences:u(he.showReferences,this.defaultValue.showReferences),showFolders:u(he.showFolders,this.defaultValue.showFolders),showTypeParameters:u(he.showTypeParameters,this.defaultValue.showTypeParameters),showSnippets:u(he.showSnippets,this.defaultValue.showSnippets),showUsers:u(he.showUsers,this.defaultValue.showUsers),showIssues:u(he.showIssues,this.defaultValue.showIssues)}}}class Ye extends _{constructor(){super(101,"smartSelect",{selectLeadingAndTrailingWhitespace:!0},{"editor.smartSelect.selectLeadingAndTrailingWhitespace":{description:c.localize(145,null),default:!0,type:"boolean"}})}validate(Q){return!Q||typeof Q!="object"?this.defaultValue:{selectLeadingAndTrailingWhitespace:u(Q.selectLeadingAndTrailingWhitespace,this.defaultValue.selectLeadingAndTrailingWhitespace)}}}class et extends o{constructor(){super(129,[80])}compute(Q,he,Le){return he.get(80)?!0:Q.tabFocusMode}}var st;(function(V){V[V.None=0]="None",V[V.Same=1]="Same",V[V.Indent=2]="Indent",V[V.DeepIndent=3]="DeepIndent"})(st=e.WrappingIndent||(e.WrappingIndent={}));function Je(V){switch(V){case"none":return 0;case"same":return 1;case"indent":return 2;case"deepIndent":return 3}}class nt extends o{constructor(){super(131,[130])}compute(Q,he,Le){const We=he.get(130);return{isDominatedByLongLines:Q.isDominatedByLongLines,isWordWrapMinified:We.isWordWrapMinified,isViewportWrapping:We.isViewportWrapping,wrappingColumn:We.wrappingColumn}}}const ct="Consolas, 'Courier New', monospace",pt="Menlo, Monaco, 'Courier New', monospace",Ft="'Droid Sans Mono', 'monospace', monospace, 'Droid Sans Fallback'";e.EDITOR_FONT_DEFAULTS={fontFamily:F.isMacintosh?pt:F.isLinux?Ft:ct,fontWeight:"normal",fontSize:F.isMacintosh?12:14,lineHeight:0,letterSpacing:0},e.EDITOR_MODEL_DEFAULTS={tabSize:4,indentSize:4,insertSpaces:!0,detectIndentation:!0,trimAutoWhitespace:!0,largeFileOptimizations:!0,bracketPairColorizationOptions:{enabled:!1}},e.editorOptionsRegistry=[];function Fe(V){return e.editorOptionsRegistry[V.id]=V,V}var Mt;(function(V){V[V.acceptSuggestionOnCommitCharacter=0]="acceptSuggestionOnCommitCharacter",V[V.acceptSuggestionOnEnter=1]="acceptSuggestionOnEnter",V[V.accessibilitySupport=2]="accessibilitySupport",V[V.accessibilityPageSize=3]="accessibilityPageSize",V[V.ariaLabel=4]="ariaLabel",V[V.autoClosingBrackets=5]="autoClosingBrackets",V[V.autoClosingDelete=6]="autoClosingDelete",V[V.autoClosingOvertype=7]="autoClosingOvertype",V[V.autoClosingQuotes=8]="autoClosingQuotes",V[V.autoIndent=9]="autoIndent",V[V.automaticLayout=10]="automaticLayout",V[V.autoSurround=11]="autoSurround",V[V.bracketPairColorization=12]="bracketPairColorization",V[V.guides=13]="guides",V[V.codeLens=14]="codeLens",V[V.codeLensFontFamily=15]="codeLensFontFamily",V[V.codeLensFontSize=16]="codeLensFontSize",V[V.colorDecorators=17]="colorDecorators",V[V.columnSelection=18]="columnSelection",V[V.comments=19]="comments",V[V.contextmenu=20]="contextmenu",V[V.copyWithSyntaxHighlighting=21]="copyWithSyntaxHighlighting",V[V.cursorBlinking=22]="cursorBlinking",V[V.cursorSmoothCaretAnimation=23]="cursorSmoothCaretAnimation",V[V.cursorStyle=24]="cursorStyle",V[V.cursorSurroundingLines=25]="cursorSurroundingLines",V[V.cursorSurroundingLinesStyle=26]="cursorSurroundingLinesStyle",V[V.cursorWidth=27]="cursorWidth",V[V.disableLayerHinting=28]="disableLayerHinting",V[V.disableMonospaceOptimizations=29]="disableMonospaceOptimizations",V[V.domReadOnly=30]="domReadOnly",V[V.dragAndDrop=31]="dragAndDrop",V[V.emptySelectionClipboard=32]="emptySelectionClipboard",V[V.extraEditorClassName=33]="extraEditorClassName",V[V.fastScrollSensitivity=34]="fastScrollSensitivity",V[V.find=35]="find",V[V.fixedOverflowWidgets=36]="fixedOverflowWidgets",V[V.folding=37]="folding",V[V.foldingStrategy=38]="foldingStrategy",V[V.foldingHighlight=39]="foldingHighlight",V[V.foldingImportsByDefault=40]="foldingImportsByDefault",V[V.unfoldOnClickAfterEndOfLine=41]="unfoldOnClickAfterEndOfLine",V[V.fontFamily=42]="fontFamily",V[V.fontInfo=43]="fontInfo",V[V.fontLigatures=44]="fontLigatures",V[V.fontSize=45]="fontSize",V[V.fontWeight=46]="fontWeight",V[V.formatOnPaste=47]="formatOnPaste",V[V.formatOnType=48]="formatOnType",V[V.glyphMargin=49]="glyphMargin",V[V.gotoLocation=50]="gotoLocation",V[V.hideCursorInOverviewRuler=51]="hideCursorInOverviewRuler",V[V.hover=52]="hover",V[V.inDiffEditor=53]="inDiffEditor",V[V.inlineSuggest=54]="inlineSuggest",V[V.letterSpacing=55]="letterSpacing",V[V.lightbulb=56]="lightbulb",V[V.lineDecorationsWidth=57]="lineDecorationsWidth",V[V.lineHeight=58]="lineHeight",V[V.lineNumbers=59]="lineNumbers",V[V.lineNumbersMinChars=60]="lineNumbersMinChars",V[V.linkedEditing=61]="linkedEditing",V[V.links=62]="links",V[V.matchBrackets=63]="matchBrackets",V[V.minimap=64]="minimap",V[V.mouseStyle=65]="mouseStyle",V[V.mouseWheelScrollSensitivity=66]="mouseWheelScrollSensitivity",V[V.mouseWheelZoom=67]="mouseWheelZoom",V[V.multiCursorMergeOverlapping=68]="multiCursorMergeOverlapping",V[V.multiCursorModifier=69]="multiCursorModifier",V[V.multiCursorPaste=70]="multiCursorPaste",V[V.occurrencesHighlight=71]="occurrencesHighlight",V[V.overviewRulerBorder=72]="overviewRulerBorder",V[V.overviewRulerLanes=73]="overviewRulerLanes",V[V.padding=74]="padding",V[V.parameterHints=75]="parameterHints",V[V.peekWidgetDefaultFocus=76]="peekWidgetDefaultFocus",V[V.definitionLinkOpensInPeek=77]="definitionLinkOpensInPeek",V[V.quickSuggestions=78]="quickSuggestions",V[V.quickSuggestionsDelay=79]="quickSuggestionsDelay",V[V.readOnly=80]="readOnly",V[V.renameOnType=81]="renameOnType",V[V.renderControlCharacters=82]="renderControlCharacters",V[V.renderFinalNewline=83]="renderFinalNewline",V[V.renderLineHighlight=84]="renderLineHighlight",V[V.renderLineHighlightOnlyWhenFocus=85]="renderLineHighlightOnlyWhenFocus",V[V.renderValidationDecorations=86]="renderValidationDecorations",V[V.renderWhitespace=87]="renderWhitespace",V[V.revealHorizontalRightPadding=88]="revealHorizontalRightPadding",V[V.roundedSelection=89]="roundedSelection",V[V.rulers=90]="rulers",V[V.scrollbar=91]="scrollbar",V[V.scrollBeyondLastColumn=92]="scrollBeyondLastColumn",V[V.scrollBeyondLastLine=93]="scrollBeyondLastLine",V[V.scrollPredominantAxis=94]="scrollPredominantAxis",V[V.selectionClipboard=95]="selectionClipboard",V[V.selectionHighlight=96]="selectionHighlight",V[V.selectOnLineNumbers=97]="selectOnLineNumbers",V[V.showFoldingControls=98]="showFoldingControls",V[V.showUnused=99]="showUnused",V[V.snippetSuggestions=100]="snippetSuggestions",V[V.smartSelect=101]="smartSelect",V[V.smoothScrolling=102]="smoothScrolling",V[V.stickyTabStops=103]="stickyTabStops",V[V.stopRenderingLineAfter=104]="stopRenderingLineAfter",V[V.suggest=105]="suggest",V[V.suggestFontSize=106]="suggestFontSize",V[V.suggestLineHeight=107]="suggestLineHeight",V[V.suggestOnTriggerCharacters=108]="suggestOnTriggerCharacters",V[V.suggestSelection=109]="suggestSelection",V[V.tabCompletion=110]="tabCompletion",V[V.tabIndex=111]="tabIndex",V[V.unicodeHighlighting=112]="unicodeHighlighting",V[V.unusualLineTerminators=113]="unusualLineTerminators",V[V.useShadowDOM=114]="useShadowDOM",V[V.useTabStops=115]="useTabStops",V[V.wordSeparators=116]="wordSeparators",V[V.wordWrap=117]="wordWrap",V[V.wordWrapBreakAfterCharacters=118]="wordWrapBreakAfterCharacters",V[V.wordWrapBreakBeforeCharacters=119]="wordWrapBreakBeforeCharacters",V[V.wordWrapColumn=120]="wordWrapColumn",V[V.wordWrapOverride1=121]="wordWrapOverride1",V[V.wordWrapOverride2=122]="wordWrapOverride2",V[V.wrappingIndent=123]="wrappingIndent",V[V.wrappingStrategy=124]="wrappingStrategy",V[V.showDeprecated=125]="showDeprecated",V[V.inlayHints=126]="inlayHints",V[V.editorClassName=127]="editorClassName",V[V.pixelRatio=128]="pixelRatio",V[V.tabFocusMode=129]="tabFocusMode",V[V.layoutInfo=130]="layoutInfo",V[V.wrappingInfo=131]="wrappingInfo"})(Mt=e.EditorOption||(e.EditorOption={})),e.EditorOptions={acceptSuggestionOnCommitCharacter:Fe(new S(0,"acceptSuggestionOnCommitCharacter",!0,{markdownDescription:c.localize(146,null)})),acceptSuggestionOnEnter:Fe(new M(1,"acceptSuggestionOnEnter","on",["on","smart","off"],{markdownEnumDescriptions:["",c.localize(147,null),""],markdownDescription:c.localize(148,null)})),accessibilitySupport:Fe(new p),accessibilityPageSize:Fe(new h(3,"accessibilityPageSize",10,1,1073741824,{description:c.localize(149,null)})),ariaLabel:Fe(new A(4,"ariaLabel",c.localize(150,null))),autoClosingBrackets:Fe(new M(5,"autoClosingBrackets","languageDefined",["always","languageDefined","beforeWhitespace","never"],{enumDescriptions:["",c.localize(151,null),c.localize(152,null),""],description:c.localize(153,null)})),autoClosingDelete:Fe(new M(6,"autoClosingDelete","auto",["always","auto","never"],{enumDescriptions:["",c.localize(154,null),""],description:c.localize(155,null)})),autoClosingOvertype:Fe(new M(7,"autoClosingOvertype","auto",["always","auto","never"],{enumDescriptions:["",c.localize(156,null),""],description:c.localize(157,null)})),autoClosingQuotes:Fe(new M(8,"autoClosingQuotes","languageDefined",["always","languageDefined","beforeWhitespace","never"],{enumDescriptions:["",c.localize(158,null),c.localize(159,null),""],description:c.localize(160,null)})),autoIndent:Fe(new r(9,"autoIndent",4,"full",["none","keep","brackets","advanced","full"],i,{enumDescriptions:[c.localize(161,null),c.localize(162,null),c.localize(163,null),c.localize(164,null),c.localize(165,null)],description:c.localize(166,null)})),automaticLayout:Fe(new S(10,"automaticLayout",!1)),autoSurround:Fe(new M(11,"autoSurround","languageDefined",["languageDefined","quotes","brackets","never"],{enumDescriptions:[c.localize(167,null),c.localize(168,null),c.localize(169,null),""],description:c.localize(170,null)})),bracketPairColorization:Fe(new me),bracketPairGuides:Fe(new Pe),stickyTabStops:Fe(new S(103,"stickyTabStops",!1,{description:c.localize(171,null)})),codeLens:Fe(new S(14,"codeLens",!0,{description:c.localize(172,null)})),codeLensFontFamily:Fe(new A(15,"codeLensFontFamily","",{description:c.localize(173,null)})),codeLensFontSize:Fe(new h(16,"codeLensFontSize",0,0,100,{type:"number",default:0,minimum:0,maximum:100,markdownDescription:c.localize(174,null)})),colorDecorators:Fe(new S(17,"colorDecorators",!0,{description:c.localize(175,null)})),columnSelection:Fe(new S(18,"columnSelection",!1,{description:c.localize(176,null)})),comments:Fe(new f),contextmenu:Fe(new S(20,"contextmenu",!0)),copyWithSyntaxHighlighting:Fe(new S(21,"copyWithSyntaxHighlighting",!0,{description:c.localize(177,null)})),cursorBlinking:Fe(new r(22,"cursorBlinking",1,"blink",["blink","smooth","phase","expand","solid"],v,{description:c.localize(178,null)})),cursorSmoothCaretAnimation:Fe(new S(23,"cursorSmoothCaretAnimation",!1,{description:c.localize(179,null)})),cursorStyle:Fe(new r(24,"cursorStyle",a.Line,"line",["line","block","underline","line-thin","block-outline","underline-thin"],I,{description:c.localize(180,null)})),cursorSurroundingLines:Fe(new h(25,"cursorSurroundingLines",0,0,1073741824,{description:c.localize(181,null)})),cursorSurroundingLinesStyle:Fe(new M(26,"cursorSurroundingLinesStyle","default",["default","all"],{enumDescriptions:[c.localize(182,null),c.localize(183,null)],description:c.localize(184,null)})),cursorWidth:Fe(new h(27,"cursorWidth",0,0,1073741824,{markdownDescription:c.localize(185,null)})),disableLayerHinting:Fe(new S(28,"disableLayerHinting",!1)),disableMonospaceOptimizations:Fe(new S(29,"disableMonospaceOptimizations",!1)),domReadOnly:Fe(new S(30,"domReadOnly",!1)),dragAndDrop:Fe(new S(31,"dragAndDrop",!0,{description:c.localize(186,null)})),emptySelectionClipboard:Fe(new B),extraEditorClassName:Fe(new A(33,"extraEditorClassName","")),fastScrollSensitivity:Fe(new g(34,"fastScrollSensitivity",5,V=>V<=0?5:V,{markdownDescription:c.localize(187,null)})),find:Fe(new L),fixedOverflowWidgets:Fe(new S(36,"fixedOverflowWidgets",!1)),folding:Fe(new S(37,"folding",!0,{description:c.localize(188,null)})),foldingStrategy:Fe(new M(38,"foldingStrategy","auto",["auto","indentation"],{enumDescriptions:[c.localize(189,null),c.localize(190,null)],description:c.localize(191,null)})),foldingHighlight:Fe(new S(39,"foldingHighlight",!0,{description:c.localize(192,null)})),foldingImportsByDefault:Fe(new S(40,"foldingImportsByDefault",!1,{description:c.localize(193,null)})),unfoldOnClickAfterEndOfLine:Fe(new S(41,"unfoldOnClickAfterEndOfLine",!1,{description:c.localize(194,null)})),fontFamily:Fe(new A(42,"fontFamily",e.EDITOR_FONT_DEFAULTS.fontFamily,{description:c.localize(195,null)})),fontInfo:Fe(new x),fontLigatures2:Fe(new y),fontSize:Fe(new N),fontWeight:Fe(new z),formatOnPaste:Fe(new S(47,"formatOnPaste",!1,{description:c.localize(196,null)})),formatOnType:Fe(new S(48,"formatOnType",!1,{description:c.localize(197,null)})),glyphMargin:Fe(new S(49,"glyphMargin",!0,{description:c.localize(198,null)})),gotoLocation:Fe(new H),hideCursorInOverviewRuler:Fe(new S(51,"hideCursorInOverviewRuler",!1,{description:c.localize(199,null)})),hover:Fe(new q),inDiffEditor:Fe(new S(53,"inDiffEditor",!1)),letterSpacing:Fe(new g(55,"letterSpacing",e.EDITOR_FONT_DEFAULTS.letterSpacing,V=>g.clamp(V,-5,20),{description:c.localize(200,null)})),lightbulb:Fe(new ce),lineDecorationsWidth:Fe(new d(57,"lineDecorationsWidth",10)),lineHeight:Fe(new Y),lineNumbers:Fe(new Xe),lineNumbersMinChars:Fe(new h(60,"lineNumbersMinChars",5,1,300)),linkedEditing:Fe(new S(61,"linkedEditing",!1,{description:c.localize(201,null)})),links:Fe(new S(62,"links",!0,{description:c.localize(202,null)})),matchBrackets:Fe(new M(63,"matchBrackets","always",["always","near","never"],{description:c.localize(203,null)})),minimap:Fe(new ie),mouseStyle:Fe(new M(65,"mouseStyle","text",["text","default","copy"])),mouseWheelScrollSensitivity:Fe(new g(66,"mouseWheelScrollSensitivity",1,V=>V===0?1:V,{markdownDescription:c.localize(204,null)})),mouseWheelZoom:Fe(new S(67,"mouseWheelZoom",!1,{markdownDescription:c.localize(205,null)})),multiCursorMergeOverlapping:Fe(new S(68,"multiCursorMergeOverlapping",!0,{description:c.localize(206,null)})),multiCursorModifier:Fe(new r(69,"multiCursorModifier","altKey","alt",["ctrlCmd","alt"],we,{markdownEnumDescriptions:[c.localize(207,null),c.localize(208,null)],markdownDescription:c.localize(209,null)})),multiCursorPaste:Fe(new M(70,"multiCursorPaste","spread",["spread","full"],{markdownEnumDescriptions:[c.localize(210,null),c.localize(211,null)],markdownDescription:c.localize(212,null)})),occurrencesHighlight:Fe(new S(71,"occurrencesHighlight",!0,{description:c.localize(213,null)})),overviewRulerBorder:Fe(new S(72,"overviewRulerBorder",!0,{description:c.localize(214,null)})),overviewRulerLanes:Fe(new h(73,"overviewRulerLanes",3,0,3)),padding:Fe(new Me),parameterHints:Fe(new Re),peekWidgetDefaultFocus:Fe(new M(76,"peekWidgetDefaultFocus","tree",["tree","editor"],{enumDescriptions:[c.localize(215,null),c.localize(216,null)],description:c.localize(217,null)})),definitionLinkOpensInPeek:Fe(new S(77,"definitionLinkOpensInPeek",!1,{description:c.localize(218,null)})),quickSuggestions:Fe(new Qe),quickSuggestionsDelay:Fe(new h(79,"quickSuggestionsDelay",10,0,1073741824,{description:c.localize(219,null)})),readOnly:Fe(new S(80,"readOnly",!1)),renameOnType:Fe(new S(81,"renameOnType",!1,{description:c.localize(220,null),markdownDeprecationMessage:c.localize(221,null)})),renderControlCharacters:Fe(new S(82,"renderControlCharacters",!0,{description:c.localize(222,null),restricted:!0})),renderFinalNewline:Fe(new S(83,"renderFinalNewline",!0,{description:c.localize(223,null)})),renderLineHighlight:Fe(new M(84,"renderLineHighlight","line",["none","gutter","line","all"],{enumDescriptions:["","","",c.localize(224,null)],description:c.localize(225,null)})),renderLineHighlightOnlyWhenFocus:Fe(new S(85,"renderLineHighlightOnlyWhenFocus",!1,{description:c.localize(226,null)})),renderValidationDecorations:Fe(new M(86,"renderValidationDecorations","editable",["editable","on","off"])),renderWhitespace:Fe(new M(87,"renderWhitespace","selection",["none","boundary","selection","trailing","all"],{enumDescriptions:["",c.localize(227,null),c.localize(228,null),c.localize(229,null),""],description:c.localize(230,null)})),revealHorizontalRightPadding:Fe(new h(88,"revealHorizontalRightPadding",30,0,1e3)),roundedSelection:Fe(new S(89,"roundedSelection",!0,{description:c.localize(231,null)})),rulers:Fe(new G),scrollbar:Fe(new ae),scrollBeyondLastColumn:Fe(new h(92,"scrollBeyondLastColumn",5,0,1073741824,{description:c.localize(232,null)})),scrollBeyondLastLine:Fe(new S(93,"scrollBeyondLastLine",!0,{description:c.localize(233,null)})),scrollPredominantAxis:Fe(new S(94,"scrollPredominantAxis",!0,{description:c.localize(234,null)})),selectionClipboard:Fe(new S(95,"selectionClipboard",!0,{description:c.localize(235,null),included:F.isLinux})),selectionHighlight:Fe(new S(96,"selectionHighlight",!0,{description:c.localize(236,null)})),selectOnLineNumbers:Fe(new S(97,"selectOnLineNumbers",!0)),showFoldingControls:Fe(new M(98,"showFoldingControls","mouseover",["always","mouseover"],{enumDescriptions:[c.localize(237,null),c.localize(238,null)],description:c.localize(239,null)})),showUnused:Fe(new S(99,"showUnused",!0,{description:c.localize(240,null)})),showDeprecated:Fe(new S(125,"showDeprecated",!0,{description:c.localize(241,null)})),inlayHints:Fe(new de),snippetSuggestions:Fe(new M(100,"snippetSuggestions","inline",["top","bottom","inline","none"],{enumDescriptions:[c.localize(242,null),c.localize(243,null),c.localize(244,null),c.localize(245,null)],description:c.localize(246,null)})),smartSelect:Fe(new Ye),smoothScrolling:Fe(new S(102,"smoothScrolling",!1,{description:c.localize(247,null)})),stopRenderingLineAfter:Fe(new h(104,"stopRenderingLineAfter",1e4,-1,1073741824)),suggest:Fe(new He),inlineSuggest:Fe(new te),suggestFontSize:Fe(new h(106,"suggestFontSize",0,0,1e3,{markdownDescription:c.localize(248,null)})),suggestLineHeight:Fe(new h(107,"suggestLineHeight",0,0,1e3,{markdownDescription:c.localize(249,null)})),suggestOnTriggerCharacters:Fe(new S(108,"suggestOnTriggerCharacters",!0,{description:c.localize(250,null)})),suggestSelection:Fe(new M(109,"suggestSelection","recentlyUsed",["first","recentlyUsed","recentlyUsedByPrefix"],{markdownEnumDescriptions:[c.localize(251,null),c.localize(252,null),c.localize(253,null)],description:c.localize(254,null)})),tabCompletion:Fe(new M(110,"tabCompletion","off",["on","off","onlySnippets"],{enumDescriptions:[c.localize(255,null),c.localize(256,null),c.localize(257,null)],description:c.localize(258,null)})),tabIndex:Fe(new h(111,"tabIndex",0,-1,1073741824)),unicodeHighlight:Fe(new j),unusualLineTerminators:Fe(new M(113,"unusualLineTerminators","prompt",["auto","off","prompt"],{enumDescriptions:[c.localize(259,null),c.localize(260,null),c.localize(261,null)],description:c.localize(262,null)})),useShadowDOM:Fe(new S(114,"useShadowDOM",!0)),useTabStops:Fe(new S(115,"useTabStops",!0,{description:c.localize(263,null)})),wordSeparators:Fe(new A(116,"wordSeparators",w.USUAL_WORD_SEPARATORS,{description:c.localize(264,null)})),wordWrap:Fe(new M(117,"wordWrap","off",["off","on","wordWrapColumn","bounded"],{markdownEnumDescriptions:[c.localize(265,null),c.localize(266,null),c.localize(267,null),c.localize(268,null)],description:c.localize(269,null)})),wordWrapBreakAfterCharacters:Fe(new A(118,"wordWrapBreakAfterCharacters"," 	})]?|/&.,;\xA2\xB0\u2032\u2033\u2030\u2103\u3001\u3002\uFF61\uFF64\uFFE0\uFF0C\uFF0E\uFF1A\uFF1B\uFF1F\uFF01\uFF05\u30FB\uFF65\u309D\u309E\u30FD\u30FE\u30FC\u30A1\u30A3\u30A5\u30A7\u30A9\u30C3\u30E3\u30E5\u30E7\u30EE\u30F5\u30F6\u3041\u3043\u3045\u3047\u3049\u3063\u3083\u3085\u3087\u308E\u3095\u3096\u31F0\u31F1\u31F2\u31F3\u31F4\u31F5\u31F6\u31F7\u31F8\u31F9\u31FA\u31FB\u31FC\u31FD\u31FE\u31FF\u3005\u303B\uFF67\uFF68\uFF69\uFF6A\uFF6B\uFF6C\uFF6D\uFF6E\uFF6F\uFF70\u201D\u3009\u300B\u300D\u300F\u3011\u3015\uFF09\uFF3D\uFF5D\uFF63")),wordWrapBreakBeforeCharacters:Fe(new A(119,"wordWrapBreakBeforeCharacters","([{\u2018\u201C\u3008\u300A\u300C\u300E\u3010\u3014\uFF08\uFF3B\uFF5B\uFF62\xA3\xA5\uFF04\uFFE1\uFFE5+\uFF0B")),wordWrapColumn:Fe(new h(120,"wordWrapColumn",80,1,1073741824,{markdownDescription:c.localize(270,null)})),wordWrapOverride1:Fe(new M(121,"wordWrapOverride1","inherit",["off","on","inherit"])),wordWrapOverride2:Fe(new M(122,"wordWrapOverride2","inherit",["off","on","inherit"])),wrappingIndent:Fe(new r(123,"wrappingIndent",1,"same",["none","same","indent","deepIndent"],Je,{enumDescriptions:[c.localize(271,null),c.localize(272,null),c.localize(273,null),c.localize(274,null)],description:c.localize(275,null)})),wrappingStrategy:Fe(new M(124,"wrappingStrategy","simple",["simple","advanced"],{enumDescriptions:[c.localize(276,null),c.localize(277,null)],description:c.localize(278,null)})),editorClassName:Fe(new D),pixelRatio:Fe(new Be),tabFocusMode:Fe(new et),layoutInfo:Fe(new K),wrappingInfo:Fe(new nt)}}),define(Ee[115],_e([18,19]),function(re,e){return re.create("vs/platform/configuration/common/configurationRegistry",e)}),define(Ee[116],_e([18,19]),function(re,e){return re.create("vs/platform/extensions/common/extensionValidator",e)}),define(Ee[117],_e([18,19]),function(re,e){return re.create("vs/platform/files/common/files",e)}),define(Ee[118],_e([18,19]),function(re,e){return re.create("vs/platform/markers/common/markers",e)}),define(Ee[119],_e([18,19]),function(re,e){return re.create("vs/workbench/api/common/extHostDiagnostics",e)}),define(Ee[120],_e([18,19]),function(re,e){return re.create("vs/workbench/api/common/extHostExtensionService",e)}),define(Ee[121],_e([18,19]),function(re,e){return re.create("vs/workbench/api/common/extHostProgress",e)}),define(Ee[122],_e([18,19]),function(re,e){return re.create("vs/workbench/api/common/extHostStatusBar",e)}),define(Ee[123],_e([18,19]),function(re,e){return re.create("vs/workbench/api/common/extHostTerminalService",e)}),define(Ee[124],_e([18,19]),function(re,e){return re.create("vs/workbench/api/common/extHostTreeViews",e)}),define(Ee[125],_e([18,19]),function(re,e){return re.create("vs/workbench/api/common/extHostWorkspace",e)}),define(Ee[126],_e([18,19]),function(re,e){return re.create("vs/workbench/common/editor",e)}),define(Ee[127],_e([18,19]),function(re,e){return re.create("vs/workbench/contrib/debug/common/abstractDebugAdapter",e)}),define(Ee[128],_e([18,19]),function(re,e){return re.create("vs/workbench/contrib/search/common/queryBuilder",e)}),define(Ee[129],_e([18,19]),function(re,e){return re.create("vs/workbench/contrib/tasks/common/taskService",e)}),define(Ee[130],_e([18,19]),function(re,e){return re.create("vs/workbench/services/configurationResolver/common/variableResolver",e)}),define(Ee[131],_e([0,1]),function(re,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TextEditorSelectionRevealType=e.EditorOpenContext=e.EditorResolution=e.EditorActivation=void 0;var c;(function(t){t[t.ACTIVATE=1]="ACTIVATE",t[t.RESTORE=2]="RESTORE",t[t.PRESERVE=3]="PRESERVE"})(c=e.EditorActivation||(e.EditorActivation={}));var F;(function(t){t[t.PICK=0]="PICK",t[t.DISABLED=1]="DISABLED",t[t.EXCLUSIVE_ONLY=2]="EXCLUSIVE_ONLY"})(F=e.EditorResolution||(e.EditorResolution={}));var w;(function(t){t[t.API=0]="API",t[t.USER=1]="USER"})(w=e.EditorOpenContext||(e.EditorOpenContext={}));var P;(function(t){t[t.Center=0]="Center",t[t.CenterIfOutsideViewport=1]="CenterIfOutsideViewport",t[t.NearTop=2]="NearTop",t[t.NearTopIfOutsideViewport=3]="NearTopIfOutsideViewport"})(P=e.TextEditorSelectionRevealType||(e.TextEditorSelectionRevealType={}))}),define(Ee[132],_e([0,1,116]),function(re,e,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isEngineValid=e.isValidExtensionVersion=e.isValidVersion=e.normalizeVersion=e.parseVersion=e.isValidVersionStr=void 0;const F=/^(\^|>=)?((\d+)|x)\.((\d+)|x)\.((\d+)|x)(\-.*)?$/,w=/^-(\d{4})(\d{2})(\d{2})$/;function P(n){return n=n.trim(),n==="*"||F.test(n)}e.isValidVersionStr=P;function t(n){if(!P(n))return null;if(n=n.trim(),n==="*")return{hasCaret:!1,hasGreaterEquals:!1,majorBase:0,majorMustEqual:!1,minorBase:0,minorMustEqual:!1,patchBase:0,patchMustEqual:!1,preRelease:null};let m=n.match(F);return m?{hasCaret:m[1]==="^",hasGreaterEquals:m[1]===">=",majorBase:m[2]==="x"?0:parseInt(m[2],10),majorMustEqual:m[2]!=="x",minorBase:m[4]==="x"?0:parseInt(m[4],10),minorMustEqual:m[4]!=="x",patchBase:m[6]==="x"?0:parseInt(m[6],10),patchMustEqual:m[6]!=="x",preRelease:m[8]||null}:null}e.parseVersion=t;function T(n){if(!n)return null;let m=n.majorBase,o=n.majorMustEqual,d=n.minorBase,u=n.minorMustEqual,S=n.patchBase,b=n.patchMustEqual;n.hasCaret&&(m===0||(u=!1),b=!1);let h=0;if(n.preRelease){const g=w.exec(n.preRelease);if(g){const[,A,l,M]=g;h=Date.UTC(Number(A),Number(l)-1,Number(M))}}return{majorBase:m,majorMustEqual:o,minorBase:d,minorMustEqual:u,patchBase:S,patchMustEqual:b,isMinimum:n.hasGreaterEquals,notBefore:h}}e.normalizeVersion=T;function C(n,m,o){let d;typeof n=="string"?d=T(t(n)):d=n;let u;m instanceof Date?u=m.getTime():typeof m=="string"&&(u=new Date(m).getTime());let S;if(typeof o=="string"?S=T(t(o)):S=o,!d||!S)return!1;let b=d.majorBase,h=d.minorBase,g=d.patchBase,A=S.majorBase,l=S.minorBase,M=S.patchBase,r=S.notBefore,i=S.majorMustEqual,p=S.minorMustEqual,f=S.patchMustEqual;return S.isMinimum?b>A?!0:b<A?!1:h>l?!0:h<l||u&&u<r?!1:g>=M:(b===1&&A===0&&(!i||!p||!f)&&(A=1,l=0,M=0,i=!0,p=!1,f=!1),b<A?!1:b>A?!i:h<l?!1:h>l?!p:g<M?!1:g>M?!f:!(u&&u<r))}e.isValidVersion=C;function k(n,m,o,d){return o.isBuiltin||typeof o.main=="undefined"?!0:_(n,m,o.engines.vscode,d)}e.isValidExtensionVersion=k;function R(n,m,o){return n==="*"||_(m,o,n)}e.isEngineValid=R;function _(n,m,o,d=[]){let u=T(t(o));if(!u)return d.push(c.localize(0,null,o)),!1;if(u.majorBase===0){if(!u.majorMustEqual||!u.minorMustEqual)return d.push(c.localize(1,null,o)),!1}else if(!u.majorMustEqual)return d.push(c.localize(2,null,o)),!1;return C(n,m,u)?!0:(d.push(c.localize(3,null,n,o)),!1)}}),define(Ee[80],_e([0,1]),function(re,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SyncDescriptor=void 0;class c{constructor(w,P=[],t=!1){this.ctor=w,this.staticArguments=P,this.supportsDelayedInstantiation=t}}e.SyncDescriptor=c}),define(Ee[56],_e([0,1,80]),function(re,e,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getSingletonServiceDescriptors=e.registerSingleton=void 0;const F=[];function w(t,T,C){T instanceof c.SyncDescriptor||(T=new c.SyncDescriptor(T,[],C)),F.push([t,T])}e.registerSingleton=w;function P(){return F}e.getSingletonServiceDescriptors=P}),define(Ee[133],_e([0,1]),function(re,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Graph=e.Node=void 0;class c{constructor(P){this.incoming=new Map,this.outgoing=new Map,this.data=P}}e.Node=c;class F{constructor(P){this._hashFn=P,this._nodes=new Map}roots(){const P=[];for(let t of this._nodes.values())t.outgoing.size===0&&P.push(t);return P}insertEdge(P,t){const T=this.lookupOrInsertNode(P),C=this.lookupOrInsertNode(t);T.outgoing.set(this._hashFn(t),C),C.incoming.set(this._hashFn(P),T)}removeNode(P){const t=this._hashFn(P);this._nodes.delete(t);for(let T of this._nodes.values())T.outgoing.delete(t),T.incoming.delete(t)}lookupOrInsertNode(P){const t=this._hashFn(P);let T=this._nodes.get(t);return T||(T=new c(P),this._nodes.set(t,T)),T}lookup(P){return this._nodes.get(this._hashFn(P))}isEmpty(){return this._nodes.size===0}toString(){let P=[];for(let[t,T]of this._nodes)P.push(`${t}, (incoming)[${[...T.incoming.keys()].join(", ")}], (outgoing)[${[...T.outgoing.keys()].join(",")}]`);return P.join(`
`)}findCycleSlow(){for(let[P,t]of this._nodes){const T=new Set([P]),C=this._findCycle(t,T);if(C)return C}}_findCycle(P,t){for(let[T,C]of P.outgoing){if(t.has(T))return[...t,T].join(" -> ");t.add(T);const k=this._findCycle(C,t);if(k)return k;t.delete(T)}}}e.Graph=F}),define(Ee[4],_e([0,1]),function(re,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.refineServiceDecorator=e.createDecorator=e.IInstantiationService=e._util=void 0;var c;(function(t){t.serviceIds=new Map,t.DI_TARGET="$di$target",t.DI_DEPENDENCIES="$di$dependencies";function T(C){return C[t.DI_DEPENDENCIES]||[]}t.getServiceDependencies=T})(c=e._util||(e._util={})),e.IInstantiationService=w("instantiationService");function F(t,T,C,k){T[c.DI_TARGET]===T?T[c.DI_DEPENDENCIES].push({id:t,index:C,optional:k}):(T[c.DI_DEPENDENCIES]=[{id:t,index:C,optional:k}],T[c.DI_TARGET]=T)}function w(t){if(c.serviceIds.has(t))return c.serviceIds.get(t);const T=function(C,k,R){if(arguments.length!==3)throw new Error("@IServiceName-decorator can only be used to decorate a parameter");F(T,C,R,!1)};return T.toString=()=>t,c.serviceIds.set(t,T),T}e.createDecorator=w;function P(t){return t}e.refineServiceDecorator=P}),define(Ee[134],_e([0,1,4]),function(re,e,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.shouldSynchronizeModel=e.IModelService=void 0,e.IModelService=(0,c.createDecorator)("modelService");function F(w){return!w.isTooLargeForSyncing()&&!w.isForSimpleWidget}e.shouldSynchronizeModel=F}),define(Ee[135],_e([0,1,3,57,6,21,75,55,134]),function(re,e,c,F,w,P,t,T,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LanguageFeatureRequestDelays=e.LanguageFeatureRegistry=void 0;function k(d){return typeof d=="string"?!1:Array.isArray(d)?d.every(k):!!d.exclusive}class R{constructor(){this._clock=0,this._entries=[],this._onDidChange=new c.Emitter}get onDidChange(){return this._onDidChange.event}register(u,S){let b={selector:u,provider:S,_score:-1,_time:this._clock++};return this._entries.push(b),this._lastCandidate=void 0,this._onDidChange.fire(this._entries.length),(0,w.toDisposable)(()=>{if(b){let h=this._entries.indexOf(b);h>=0&&(this._entries.splice(h,1),this._lastCandidate=void 0,this._onDidChange.fire(this._entries.length),b=void 0)}})}has(u){return this.all(u).length>0}all(u){if(!u)return[];this._updateScores(u);const S=[];for(let b of this._entries)b._score>0&&S.push(b.provider);return S}ordered(u){const S=[];return this._orderedForEach(u,b=>S.push(b.provider)),S}orderedGroups(u){const S=[];let b,h;return this._orderedForEach(u,g=>{b&&h===g._score?b.push(g.provider):(h=g._score,b=[g.provider],S.push(b))}),S}_orderedForEach(u,S){if(!!u){this._updateScores(u);for(const b of this._entries)b._score>0&&S(b)}}_updateScores(u){let S={uri:u.uri.toString(),language:u.getLanguageId()};if(!(this._lastCandidate&&this._lastCandidate.language===S.language&&this._lastCandidate.uri===S.uri)){this._lastCandidate=S;for(let b of this._entries)if(b._score=(0,T.score)(b.selector,u.uri,u.getLanguageId(),(0,C.shouldSynchronizeModel)(u)),k(b.selector)&&b._score>0){for(let h of this._entries)h._score=0;b._score=1e3;break}this._entries.sort(R._compareByScoreAndTime)}}static _compareByScoreAndTime(u,S){return u._score<S._score?1:u._score>S._score?-1:u._time<S._time?1:u._time>S._time?-1:0}}e.LanguageFeatureRegistry=R;const _=new WeakMap;let n=0;function m(d){let u=_.get(d);return u===void 0&&(u=++n,_.set(d,u)),u}class o{constructor(u,S,b=Number.MAX_SAFE_INTEGER){this._registry=u,this.min=S,this.max=b,this._cache=new P.LRUCache(50,.7)}_key(u){return u.id+this._registry.all(u).reduce((S,b)=>(0,F.doHash)(m(b),S),0)}_clamp(u){return u===void 0?this.min:Math.min(this.max,Math.max(this.min,Math.floor(u*1.3)))}get(u){const S=this._key(u),b=this._cache.get(S);return this._clamp(b?.value)}update(u,S){const b=this._key(u);let h=this._cache.get(b);return h||(h=new t.MovingAverage,this._cache.set(b,h)),h.update(S),this.get(u)}}e.LanguageFeatureRequestDelays=o}),define(Ee[58],_e([0,1,2,59,135,108,53]),function(re,e,c,F,w,P,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExternalUriOpenerPriority=e.TokenizationRegistry=e.DocumentRangeSemanticTokensProviderRegistry=e.DocumentSemanticTokensProviderRegistry=e.FoldingRangeProviderRegistry=e.SelectionRangeRegistry=e.ColorProviderRegistry=e.LinkProviderRegistry=e.OnTypeFormattingEditProviderRegistry=e.DocumentRangeFormattingEditProviderRegistry=e.DocumentFormattingEditProviderRegistry=e.CodeActionProviderRegistry=e.InlayHintsProviderRegistry=e.CodeLensProviderRegistry=e.TypeDefinitionProviderRegistry=e.ImplementationProviderRegistry=e.DeclarationProviderRegistry=e.DefinitionProviderRegistry=e.LinkedEditingRangeProviderRegistry=e.DocumentHighlightProviderRegistry=e.DocumentSymbolProviderRegistry=e.InlineValuesProviderRegistry=e.EvaluatableExpressionProviderRegistry=e.HoverProviderRegistry=e.SignatureHelpProviderRegistry=e.InlineCompletionsProviderRegistry=e.CompletionProviderRegistry=e.RenameProviderRegistry=e.ReferenceProviderRegistry=e.InlayHintKind=e.CommentMode=e.CommentThreadCollapsibleState=e.FoldingRangeKind=e.SymbolKinds=e.SymbolTag=e.SymbolKind=e.isLocationLink=e.DocumentHighlightKind=e.SignatureHelpTriggerKind=e.CodeActionTriggerType=e.InlineCompletionTriggerKind=e.CompletionTriggerKind=e.CompletionItemInsertTextRule=e.CompletionItemTag=e.completionKindFromString=e.completionKindToCssClass=e.CompletionItemKind=e.TokenMetadata=e.MetadataConsts=e.StandardTokenType=e.ColorId=e.FontStyle=e.LanguageId=void 0;var T;(function(a){a[a.Null=0]="Null",a[a.PlainText=1]="PlainText"})(T=e.LanguageId||(e.LanguageId={}));var C;(function(a){a[a.NotSet=-1]="NotSet",a[a.None=0]="None",a[a.Italic=1]="Italic",a[a.Bold=2]="Bold",a[a.Underline=4]="Underline"})(C=e.FontStyle||(e.FontStyle={}));var k;(function(a){a[a.None=0]="None",a[a.DefaultForeground=1]="DefaultForeground",a[a.DefaultBackground=2]="DefaultBackground"})(k=e.ColorId||(e.ColorId={}));var R;(function(a){a[a.Other=0]="Other",a[a.Comment=1]="Comment",a[a.String=2]="String",a[a.RegEx=4]="RegEx"})(R=e.StandardTokenType||(e.StandardTokenType={}));var _;(function(a){a[a.LANGUAGEID_MASK=255]="LANGUAGEID_MASK",a[a.TOKEN_TYPE_MASK=1792]="TOKEN_TYPE_MASK",a[a.FONT_STYLE_MASK=14336]="FONT_STYLE_MASK",a[a.FOREGROUND_MASK=8372224]="FOREGROUND_MASK",a[a.BACKGROUND_MASK=4286578688]="BACKGROUND_MASK",a[a.ITALIC_MASK=2048]="ITALIC_MASK",a[a.BOLD_MASK=4096]="BOLD_MASK",a[a.UNDERLINE_MASK=8192]="UNDERLINE_MASK",a[a.SEMANTIC_USE_ITALIC=1]="SEMANTIC_USE_ITALIC",a[a.SEMANTIC_USE_BOLD=2]="SEMANTIC_USE_BOLD",a[a.SEMANTIC_USE_UNDERLINE=4]="SEMANTIC_USE_UNDERLINE",a[a.SEMANTIC_USE_FOREGROUND=8]="SEMANTIC_USE_FOREGROUND",a[a.SEMANTIC_USE_BACKGROUND=16]="SEMANTIC_USE_BACKGROUND",a[a.LANGUAGEID_OFFSET=0]="LANGUAGEID_OFFSET",a[a.TOKEN_TYPE_OFFSET=8]="TOKEN_TYPE_OFFSET",a[a.FONT_STYLE_OFFSET=11]="FONT_STYLE_OFFSET",a[a.FOREGROUND_OFFSET=14]="FOREGROUND_OFFSET",a[a.BACKGROUND_OFFSET=23]="BACKGROUND_OFFSET"})(_=e.MetadataConsts||(e.MetadataConsts={}));class n{static getLanguageId(E){return(E&255)>>>0}static getTokenType(E){return(E&1792)>>>8}static getFontStyle(E){return(E&14336)>>>11}static getForeground(E){return(E&8372224)>>>14}static getBackground(E){return(E&4286578688)>>>23}static getClassNameFromMetadata(E){let I=this.getForeground(E),D="mtk"+I,B=this.getFontStyle(E);return B&1&&(D+=" mtki"),B&2&&(D+=" mtkb"),B&4&&(D+=" mtku"),D}static getInlineStyleFromMetadata(E,I){const D=this.getForeground(E),B=this.getFontStyle(E);let L=`color: ${I[D]};`;return B&1&&(L+="font-style: italic;"),B&2&&(L+="font-weight: bold;"),B&4&&(L+="text-decoration: underline;"),L}}e.TokenMetadata=n;var m;(function(a){a[a.Method=0]="Method",a[a.Function=1]="Function",a[a.Constructor=2]="Constructor",a[a.Field=3]="Field",a[a.Variable=4]="Variable",a[a.Class=5]="Class",a[a.Struct=6]="Struct",a[a.Interface=7]="Interface",a[a.Module=8]="Module",a[a.Property=9]="Property",a[a.Event=10]="Event",a[a.Operator=11]="Operator",a[a.Unit=12]="Unit",a[a.Value=13]="Value",a[a.Constant=14]="Constant",a[a.Enum=15]="Enum",a[a.EnumMember=16]="EnumMember",a[a.Keyword=17]="Keyword",a[a.Text=18]="Text",a[a.Color=19]="Color",a[a.File=20]="File",a[a.Reference=21]="Reference",a[a.Customcolor=22]="Customcolor",a[a.Folder=23]="Folder",a[a.TypeParameter=24]="TypeParameter",a[a.User=25]="User",a[a.Issue=26]="Issue",a[a.Snippet=27]="Snippet"})(m=e.CompletionItemKind||(e.CompletionItemKind={})),e.completionKindToCssClass=function(){let a=Object.create(null);return a[0]="symbol-method",a[1]="symbol-function",a[2]="symbol-constructor",a[3]="symbol-field",a[4]="symbol-variable",a[5]="symbol-class",a[6]="symbol-struct",a[7]="symbol-interface",a[8]="symbol-module",a[9]="symbol-property",a[10]="symbol-event",a[11]="symbol-operator",a[12]="symbol-unit",a[13]="symbol-value",a[14]="symbol-constant",a[15]="symbol-enum",a[16]="symbol-enum-member",a[17]="symbol-keyword",a[27]="symbol-snippet",a[18]="symbol-text",a[19]="symbol-color",a[20]="symbol-file",a[21]="symbol-reference",a[22]="symbol-customcolor",a[23]="symbol-folder",a[24]="symbol-type-parameter",a[25]="account",a[26]="issues",function(E){const I=a[E];let D=I&&t.iconRegistry.get(I);return D||(console.info("No codicon found for CompletionItemKind "+E),D=t.Codicon.symbolProperty),D.classNames}}(),e.completionKindFromString=function(){let a=Object.create(null);return a.method=0,a.function=1,a.constructor=2,a.field=3,a.variable=4,a.class=5,a.struct=6,a.interface=7,a.module=8,a.property=9,a.event=10,a.operator=11,a.unit=12,a.value=13,a.constant=14,a.enum=15,a["enum-member"]=16,a.enumMember=16,a.keyword=17,a.snippet=27,a.text=18,a.color=19,a.file=20,a.reference=21,a.customcolor=22,a.folder=23,a["type-parameter"]=24,a.typeParameter=24,a.account=25,a.issue=26,function(E,I){let D=a[E];return typeof D=="undefined"&&!I&&(D=9),D}}();var o;(function(a){a[a.Deprecated=1]="Deprecated"})(o=e.CompletionItemTag||(e.CompletionItemTag={}));var d;(function(a){a[a.KeepWhitespace=1]="KeepWhitespace",a[a.InsertAsSnippet=4]="InsertAsSnippet"})(d=e.CompletionItemInsertTextRule||(e.CompletionItemInsertTextRule={}));var u;(function(a){a[a.Invoke=0]="Invoke",a[a.TriggerCharacter=1]="TriggerCharacter",a[a.TriggerForIncompleteCompletions=2]="TriggerForIncompleteCompletions"})(u=e.CompletionTriggerKind||(e.CompletionTriggerKind={}));var S;(function(a){a[a.Automatic=0]="Automatic",a[a.Explicit=1]="Explicit"})(S=e.InlineCompletionTriggerKind||(e.InlineCompletionTriggerKind={}));var b;(function(a){a[a.Invoke=1]="Invoke",a[a.Auto=2]="Auto"})(b=e.CodeActionTriggerType||(e.CodeActionTriggerType={}));var h;(function(a){a[a.Invoke=1]="Invoke",a[a.TriggerCharacter=2]="TriggerCharacter",a[a.ContentChange=3]="ContentChange"})(h=e.SignatureHelpTriggerKind||(e.SignatureHelpTriggerKind={}));var g;(function(a){a[a.Text=0]="Text",a[a.Read=1]="Read",a[a.Write=2]="Write"})(g=e.DocumentHighlightKind||(e.DocumentHighlightKind={}));function A(a){return a&&c.URI.isUri(a.uri)&&F.Range.isIRange(a.range)&&(F.Range.isIRange(a.originSelectionRange)||F.Range.isIRange(a.targetSelectionRange))}e.isLocationLink=A;var l;(function(a){a[a.File=0]="File",a[a.Module=1]="Module",a[a.Namespace=2]="Namespace",a[a.Package=3]="Package",a[a.Class=4]="Class",a[a.Method=5]="Method",a[a.Property=6]="Property",a[a.Field=7]="Field",a[a.Constructor=8]="Constructor",a[a.Enum=9]="Enum",a[a.Interface=10]="Interface",a[a.Function=11]="Function",a[a.Variable=12]="Variable",a[a.Constant=13]="Constant",a[a.String=14]="String",a[a.Number=15]="Number",a[a.Boolean=16]="Boolean",a[a.Array=17]="Array",a[a.Object=18]="Object",a[a.Key=19]="Key",a[a.Null=20]="Null",a[a.EnumMember=21]="EnumMember",a[a.Struct=22]="Struct",a[a.Event=23]="Event",a[a.Operator=24]="Operator",a[a.TypeParameter=25]="TypeParameter"})(l=e.SymbolKind||(e.SymbolKind={}));var M;(function(a){a[a.Deprecated=1]="Deprecated"})(M=e.SymbolTag||(e.SymbolTag={}));var r;(function(a){const E=new Map;E.set("file",0),E.set("module",1),E.set("namespace",2),E.set("package",3),E.set("class",4),E.set("method",5),E.set("property",6),E.set("field",7),E.set("constructor",8),E.set("enum",9),E.set("interface",10),E.set("function",11),E.set("variable",12),E.set("constant",13),E.set("string",14),E.set("number",15),E.set("boolean",16),E.set("array",17),E.set("object",18),E.set("key",19),E.set("null",20),E.set("enum-member",21),E.set("struct",22),E.set("event",23),E.set("operator",24),E.set("type-parameter",25);const I=new Map;I.set(0,"file"),I.set(1,"module"),I.set(2,"namespace"),I.set(3,"package"),I.set(4,"class"),I.set(5,"method"),I.set(6,"property"),I.set(7,"field"),I.set(8,"constructor"),I.set(9,"enum"),I.set(10,"interface"),I.set(11,"function"),I.set(12,"variable"),I.set(13,"constant"),I.set(14,"string"),I.set(15,"number"),I.set(16,"boolean"),I.set(17,"array"),I.set(18,"object"),I.set(19,"key"),I.set(20,"null"),I.set(21,"enum-member"),I.set(22,"struct"),I.set(23,"event"),I.set(24,"operator"),I.set(25,"type-parameter");function D(y){return E.get(y)}a.fromString=D;function B(y){return I.get(y)}a.toString=B;function L(y,x){const N=I.get(y);let z=N&&t.iconRegistry.get("symbol-"+N);return z||(console.info("No codicon found for SymbolKind "+y),z=t.Codicon.symbolProperty),`${x?"inline":"block"} ${z.classNames}`}a.toCssClassName=L})(r=e.SymbolKinds||(e.SymbolKinds={}));class i{constructor(E){this.value=E}}e.FoldingRangeKind=i,i.Comment=new i("comment"),i.Imports=new i("imports"),i.Region=new i("region");var p;(function(a){a[a.Collapsed=0]="Collapsed",a[a.Expanded=1]="Expanded"})(p=e.CommentThreadCollapsibleState||(e.CommentThreadCollapsibleState={}));var f;(function(a){a[a.Editing=0]="Editing",a[a.Preview=1]="Preview"})(f=e.CommentMode||(e.CommentMode={}));var s;(function(a){a[a.Other=0]="Other",a[a.Type=1]="Type",a[a.Parameter=2]="Parameter"})(s=e.InlayHintKind||(e.InlayHintKind={})),e.ReferenceProviderRegistry=new w.LanguageFeatureRegistry,e.RenameProviderRegistry=new w.LanguageFeatureRegistry,e.CompletionProviderRegistry=new w.LanguageFeatureRegistry,e.InlineCompletionsProviderRegistry=new w.LanguageFeatureRegistry,e.SignatureHelpProviderRegistry=new w.LanguageFeatureRegistry,e.HoverProviderRegistry=new w.LanguageFeatureRegistry,e.EvaluatableExpressionProviderRegistry=new w.LanguageFeatureRegistry,e.InlineValuesProviderRegistry=new w.LanguageFeatureRegistry,e.DocumentSymbolProviderRegistry=new w.LanguageFeatureRegistry,e.DocumentHighlightProviderRegistry=new w.LanguageFeatureRegistry,e.LinkedEditingRangeProviderRegistry=new w.LanguageFeatureRegistry,e.DefinitionProviderRegistry=new w.LanguageFeatureRegistry,e.DeclarationProviderRegistry=new w.LanguageFeatureRegistry,e.ImplementationProviderRegistry=new w.LanguageFeatureRegistry,e.TypeDefinitionProviderRegistry=new w.LanguageFeatureRegistry,e.CodeLensProviderRegistry=new w.LanguageFeatureRegistry,e.InlayHintsProviderRegistry=new w.LanguageFeatureRegistry,e.CodeActionProviderRegistry=new w.LanguageFeatureRegistry,e.DocumentFormattingEditProviderRegistry=new w.LanguageFeatureRegistry,e.DocumentRangeFormattingEditProviderRegistry=new w.LanguageFeatureRegistry,e.OnTypeFormattingEditProviderRegistry=new w.LanguageFeatureRegistry,e.LinkProviderRegistry=new w.LanguageFeatureRegistry,e.ColorProviderRegistry=new w.LanguageFeatureRegistry,e.SelectionRangeRegistry=new w.LanguageFeatureRegistry,e.FoldingRangeProviderRegistry=new w.LanguageFeatureRegistry,e.DocumentSemanticTokensProviderRegistry=new w.LanguageFeatureRegistry,e.DocumentRangeSemanticTokensProviderRegistry=new w.LanguageFeatureRegistry,e.TokenizationRegistry=new P.TokenizationRegistryImpl;var v;(function(a){a[a.None=0]="None",a[a.Option=1]="Option",a[a.Default=2]="Default",a[a.Preferred=3]="Preferred"})(v=e.ExternalUriOpenerPriority||(e.ExternalUriOpenerPriority={}))}),define(Ee[81],_e([0,1,11,2,4]),function(re,e,c,F,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getMigratedSettingValue=e.merge=e.getConfigurationValue=e.removeFromValueTree=e.addToValueTree=e.toValuesTree=e.ConfigurationTargetToString=e.ConfigurationTarget=e.isConfigurationUpdateOverrides=e.isConfigurationOverrides=e.IConfigurationService=void 0,e.IConfigurationService=(0,w.createDecorator)("configurationService");function P(u){return u&&typeof u=="object"&&(!u.overrideIdentifier||typeof u.overrideIdentifier=="string")&&(!u.resource||u.resource instanceof F.URI)}e.isConfigurationOverrides=P;function t(u){return u&&typeof u=="object"&&(!u.overrideIdentifiers||c.isArray(u.overrideIdentifiers))&&!u.overrideIdentifier&&(!u.resource||u.resource instanceof F.URI)}e.isConfigurationUpdateOverrides=t;var T;(function(u){u[u.USER=1]="USER",u[u.USER_LOCAL=2]="USER_LOCAL",u[u.USER_REMOTE=3]="USER_REMOTE",u[u.WORKSPACE=4]="WORKSPACE",u[u.WORKSPACE_FOLDER=5]="WORKSPACE_FOLDER",u[u.DEFAULT=6]="DEFAULT",u[u.MEMORY=7]="MEMORY"})(T=e.ConfigurationTarget||(e.ConfigurationTarget={}));function C(u){switch(u){case 1:return"USER";case 2:return"USER_LOCAL";case 3:return"USER_REMOTE";case 4:return"WORKSPACE";case 5:return"WORKSPACE_FOLDER";case 6:return"DEFAULT";case 7:return"MEMORY"}}e.ConfigurationTargetToString=C;function k(u,S){const b=Object.create(null);for(let h in u)R(b,h,u[h],S);return b}e.toValuesTree=k;function R(u,S,b,h){const g=S.split("."),A=g.pop();let l=u;for(let M=0;M<g.length;M++){let r=g[M],i=l[r];switch(typeof i){case"undefined":i=l[r]=Object.create(null);break;case"object":break;default:h(`Ignoring ${S} as ${g.slice(0,M+1).join(".")} is ${JSON.stringify(i)}`);return}l=i}if(typeof l=="object"&&l!==null)try{l[A]=b}catch(M){h(`Ignoring ${S} as ${g.join(".")} is ${JSON.stringify(l)}`)}else h(`Ignoring ${S} as ${g.join(".")} is ${JSON.stringify(l)}`)}e.addToValueTree=R;function _(u,S){const b=S.split(".");n(u,b)}e.removeFromValueTree=_;function n(u,S){const b=S.shift();if(S.length===0){delete u[b];return}if(Object.keys(u).indexOf(b)!==-1){const h=u[b];typeof h=="object"&&!Array.isArray(h)&&(n(h,S),Object.keys(h).length===0&&delete u[b])}}function m(u,S,b){function h(l,M){let r=l;for(const i of M){if(typeof r!="object"||r===null)return;r=r[i]}return r}const g=S.split("."),A=h(u,g);return typeof A=="undefined"?b:A}e.getConfigurationValue=m;function o(u,S,b){Object.keys(S).forEach(h=>{h!=="__proto__"&&(h in u?c.isObject(u[h])&&c.isObject(S[h])?o(u[h],S[h],b):b&&(u[h]=S[h]):u[h]=S[h])})}e.merge=o;function d(u,S,b){const h=u.inspect(S),g=u.inspect(b);return typeof h.userValue!="undefined"||typeof h.workspaceValue!="undefined"||typeof h.workspaceFolderValue!="undefined"?h.value:typeof g.userValue!="undefined"||typeof g.workspaceValue!="undefined"||typeof g.workspaceFolderValue!="undefined"?g.value:h.defaultValue}e.getMigratedSettingValue=d}),define(Ee[44],_e([0,1,23,9,4]),function(re,e,c,F,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.implies=e.SET_CONTEXT_COMMAND_ID=e.IContextKeyService=e.RawContextKey=e.ContextKeyNotRegexExpr=e.ContextKeyRegexExpr=e.ContextKeySmallerEqualsExpr=e.ContextKeySmallerExpr=e.ContextKeyGreaterEqualsExpr=e.ContextKeyGreaterExpr=e.ContextKeyNotExpr=e.ContextKeyNotEqualsExpr=e.ContextKeyNotInExpr=e.ContextKeyInExpr=e.ContextKeyEqualsExpr=e.ContextKeyDefinedExpr=e.ContextKeyTrueExpr=e.ContextKeyFalseExpr=e.expressionsAreEqualWithConstantSubstitution=e.ContextKeyExpr=e.ContextKeyExprType=void 0;let P=c.userAgent||"";const t=new Map;t.set("false",!1),t.set("true",!0),t.set("isMac",c.isMacintosh),t.set("isLinux",c.isLinux),t.set("isWindows",c.isWindows),t.set("isWeb",c.isWeb),t.set("isMacNative",c.isMacintosh&&!c.isWeb),t.set("isEdge",P.indexOf("Edg/")>=0),t.set("isFirefox",P.indexOf("Firefox")>=0),t.set("isChrome",P.indexOf("Chrome")>=0),t.set("isSafari",P.indexOf("Safari")>=0);const T=Object.prototype.hasOwnProperty;var C;(function(L){L[L.False=0]="False",L[L.True=1]="True",L[L.Defined=2]="Defined",L[L.Not=3]="Not",L[L.Equals=4]="Equals",L[L.NotEquals=5]="NotEquals",L[L.And=6]="And",L[L.Regex=7]="Regex",L[L.NotRegex=8]="NotRegex",L[L.Or=9]="Or",L[L.In=10]="In",L[L.NotIn=11]="NotIn",L[L.Greater=12]="Greater",L[L.GreaterEquals=13]="GreaterEquals",L[L.Smaller=14]="Smaller",L[L.SmallerEquals=15]="SmallerEquals"})(C=e.ContextKeyExprType||(e.ContextKeyExprType={}));class k{static false(){return n.INSTANCE}static true(){return m.INSTANCE}static has(y){return o.create(y)}static equals(y,x){return d.create(y,x)}static notEquals(y,x){return b.create(y,x)}static regex(y,x){return i.create(y,x)}static in(y,x){return u.create(y,x)}static not(y){return h.create(y)}static and(...y){return s.create(y,null)}static or(...y){return v.create(y,null,!0)}static greater(y,x){return A.create(y,x)}static greaterEquals(y,x){return l.create(y,x)}static smaller(y,x){return M.create(y,x)}static smallerEquals(y,x){return r.create(y,x)}static deserialize(y,x=!1){if(!!y)return this._deserializeOrExpression(y,x)}static _deserializeOrExpression(y,x){let N=y.split("||");return v.create(N.map(z=>this._deserializeAndExpression(z,x)),null,!0)}static _deserializeAndExpression(y,x){let N=y.split("&&");return s.create(N.map(z=>this._deserializeOne(z,x)),null)}static _deserializeOne(y,x){if(y=y.trim(),y.indexOf("!=")>=0){let N=y.split("!=");return b.create(N[0].trim(),this._deserializeValue(N[1],x))}if(y.indexOf("==")>=0){let N=y.split("==");return d.create(N[0].trim(),this._deserializeValue(N[1],x))}if(y.indexOf("=~")>=0){let N=y.split("=~");return i.create(N[0].trim(),this._deserializeRegexValue(N[1],x))}if(y.indexOf(" in ")>=0){let N=y.split(" in ");return u.create(N[0].trim(),N[1].trim())}if(/^[^<=>]+>=[^<=>]+$/.test(y)){const N=y.split(">=");return l.create(N[0].trim(),N[1].trim())}if(/^[^<=>]+>[^<=>]+$/.test(y)){const N=y.split(">");return A.create(N[0].trim(),N[1].trim())}if(/^[^<=>]+<=[^<=>]+$/.test(y)){const N=y.split("<=");return r.create(N[0].trim(),N[1].trim())}if(/^[^<=>]+<[^<=>]+$/.test(y)){const N=y.split("<");return M.create(N[0].trim(),N[1].trim())}return/^\!\s*/.test(y)?h.create(y.substr(1).trim()):o.create(y)}static _deserializeValue(y,x){if(y=y.trim(),y==="true")return!0;if(y==="false")return!1;let N=/^'([^']*)'$/.exec(y);return N?N[1].trim():y}static _deserializeRegexValue(y,x){if((0,F.isFalsyOrWhitespace)(y)){if(x)throw new Error("missing regexp-value for =~-expression");return console.warn("missing regexp-value for =~-expression"),null}let N=y.indexOf("/"),z=y.lastIndexOf("/");if(N===z||N<0){if(x)throw new Error(`bad regexp-value '${y}', missing /-enclosure`);return console.warn(`bad regexp-value '${y}', missing /-enclosure`),null}let H=y.slice(N+1,z),q=y[z+1]==="i"?"i":"";try{return new RegExp(H,q)}catch(ue){if(x)throw new Error(`bad regexp-value '${y}', parse error: ${ue}`);return console.warn(`bad regexp-value '${y}', parse error: ${ue}`),null}}}e.ContextKeyExpr=k;function R(L,y){const x=L?L.substituteConstants():void 0,N=y?y.substituteConstants():void 0;return!x&&!N?!0:!x||!N?!1:x.equals(N)}e.expressionsAreEqualWithConstantSubstitution=R;function _(L,y){return L.cmp(y)}class n{constructor(){this.type=0}cmp(y){return this.type-y.type}equals(y){return y.type===this.type}substituteConstants(){return this}evaluate(y){return!1}serialize(){return"false"}keys(){return[]}map(y){return this}negate(){return m.INSTANCE}}e.ContextKeyFalseExpr=n,n.INSTANCE=new n;class m{constructor(){this.type=1}cmp(y){return this.type-y.type}equals(y){return y.type===this.type}substituteConstants(){return this}evaluate(y){return!0}serialize(){return"true"}keys(){return[]}map(y){return this}negate(){return n.INSTANCE}}e.ContextKeyTrueExpr=m,m.INSTANCE=new m;class o{constructor(y,x){this.key=y,this.negated=x,this.type=2}static create(y,x=null){const N=t.get(y);return typeof N=="boolean"?N?m.INSTANCE:n.INSTANCE:new o(y,x)}cmp(y){return y.type!==this.type?this.type-y.type:E(this.key,y.key)}equals(y){return y.type===this.type?this.key===y.key:!1}substituteConstants(){const y=t.get(this.key);return typeof y=="boolean"?y?m.INSTANCE:n.INSTANCE:this}evaluate(y){return!!y.getValue(this.key)}serialize(){return this.key}keys(){return[this.key]}map(y){return y.mapDefined(this.key)}negate(){return this.negated||(this.negated=h.create(this.key,this)),this.negated}}e.ContextKeyDefinedExpr=o;class d{constructor(y,x,N){this.key=y,this.value=x,this.negated=N,this.type=4}static create(y,x,N=null){if(typeof x=="boolean")return x?o.create(y,N):h.create(y,N);const z=t.get(y);return typeof z=="boolean"?x===(z?"true":"false")?m.INSTANCE:n.INSTANCE:new d(y,x,N)}cmp(y){return y.type!==this.type?this.type-y.type:I(this.key,this.value,y.key,y.value)}equals(y){return y.type===this.type?this.key===y.key&&this.value===y.value:!1}substituteConstants(){const y=t.get(this.key);if(typeof y=="boolean"){const x=y?"true":"false";return this.value===x?m.INSTANCE:n.INSTANCE}return this}evaluate(y){return y.getValue(this.key)==this.value}serialize(){return`${this.key} == '${this.value}'`}keys(){return[this.key]}map(y){return y.mapEquals(this.key,this.value)}negate(){return this.negated||(this.negated=b.create(this.key,this.value,this)),this.negated}}e.ContextKeyEqualsExpr=d;class u{constructor(y,x){this.key=y,this.valueKey=x,this.type=10,this.negated=null}static create(y,x){return new u(y,x)}cmp(y){return y.type!==this.type?this.type-y.type:I(this.key,this.valueKey,y.key,y.valueKey)}equals(y){return y.type===this.type?this.key===y.key&&this.valueKey===y.valueKey:!1}substituteConstants(){return this}evaluate(y){const x=y.getValue(this.valueKey),N=y.getValue(this.key);return Array.isArray(x)?x.indexOf(N)>=0:typeof N=="string"&&typeof x=="object"&&x!==null?T.call(x,N):!1}serialize(){return`${this.key} in '${this.valueKey}'`}keys(){return[this.key,this.valueKey]}map(y){return y.mapIn(this.key,this.valueKey)}negate(){return this.negated||(this.negated=S.create(this)),this.negated}}e.ContextKeyInExpr=u;class S{constructor(y){this._actual=y,this.type=11}static create(y){return new S(y)}cmp(y){return y.type!==this.type?this.type-y.type:this._actual.cmp(y._actual)}equals(y){return y.type===this.type?this._actual.equals(y._actual):!1}substituteConstants(){return this}evaluate(y){return!this._actual.evaluate(y)}serialize(){throw new Error("Method not implemented.")}keys(){return this._actual.keys()}map(y){return new S(this._actual.map(y))}negate(){return this._actual}}e.ContextKeyNotInExpr=S;class b{constructor(y,x,N){this.key=y,this.value=x,this.negated=N,this.type=5}static create(y,x,N=null){if(typeof x=="boolean")return x?h.create(y,N):o.create(y,N);const z=t.get(y);return typeof z=="boolean"?x===(z?"true":"false")?n.INSTANCE:m.INSTANCE:new b(y,x,N)}cmp(y){return y.type!==this.type?this.type-y.type:I(this.key,this.value,y.key,y.value)}equals(y){return y.type===this.type?this.key===y.key&&this.value===y.value:!1}substituteConstants(){const y=t.get(this.key);if(typeof y=="boolean"){const x=y?"true":"false";return this.value===x?n.INSTANCE:m.INSTANCE}return this}evaluate(y){return y.getValue(this.key)!=this.value}serialize(){return`${this.key} != '${this.value}'`}keys(){return[this.key]}map(y){return y.mapNotEquals(this.key,this.value)}negate(){return this.negated||(this.negated=d.create(this.key,this.value,this)),this.negated}}e.ContextKeyNotEqualsExpr=b;class h{constructor(y,x){this.key=y,this.negated=x,this.type=3}static create(y,x=null){const N=t.get(y);return typeof N=="boolean"?N?n.INSTANCE:m.INSTANCE:new h(y,x)}cmp(y){return y.type!==this.type?this.type-y.type:E(this.key,y.key)}equals(y){return y.type===this.type?this.key===y.key:!1}substituteConstants(){const y=t.get(this.key);return typeof y=="boolean"?y?n.INSTANCE:m.INSTANCE:this}evaluate(y){return!y.getValue(this.key)}serialize(){return`!${this.key}`}keys(){return[this.key]}map(y){return y.mapNot(this.key)}negate(){return this.negated||(this.negated=o.create(this.key,this)),this.negated}}e.ContextKeyNotExpr=h;function g(L,y){if(typeof L=="string"){const x=parseFloat(L);isNaN(x)||(L=x)}return typeof L=="string"||typeof L=="number"?y(L):n.INSTANCE}class A{constructor(y,x,N){this.key=y,this.value=x,this.negated=N,this.type=12}static create(y,x,N=null){return g(x,z=>new A(y,z,N))}cmp(y){return y.type!==this.type?this.type-y.type:I(this.key,this.value,y.key,y.value)}equals(y){return y.type===this.type?this.key===y.key&&this.value===y.value:!1}substituteConstants(){return this}evaluate(y){return typeof this.value=="string"?!1:parseFloat(y.getValue(this.key))>this.value}serialize(){return`${this.key} > ${this.value}`}keys(){return[this.key]}map(y){return y.mapGreater(this.key,this.value)}negate(){return this.negated||(this.negated=r.create(this.key,this.value,this)),this.negated}}e.ContextKeyGreaterExpr=A;class l{constructor(y,x,N){this.key=y,this.value=x,this.negated=N,this.type=13}static create(y,x,N=null){return g(x,z=>new l(y,z,N))}cmp(y){return y.type!==this.type?this.type-y.type:I(this.key,this.value,y.key,y.value)}equals(y){return y.type===this.type?this.key===y.key&&this.value===y.value:!1}substituteConstants(){return this}evaluate(y){return typeof this.value=="string"?!1:parseFloat(y.getValue(this.key))>=this.value}serialize(){return`${this.key} >= ${this.value}`}keys(){return[this.key]}map(y){return y.mapGreaterEquals(this.key,this.value)}negate(){return this.negated||(this.negated=M.create(this.key,this.value,this)),this.negated}}e.ContextKeyGreaterEqualsExpr=l;class M{constructor(y,x,N){this.key=y,this.value=x,this.negated=N,this.type=14}static create(y,x,N=null){return g(x,z=>new M(y,z,N))}cmp(y){return y.type!==this.type?this.type-y.type:I(this.key,this.value,y.key,y.value)}equals(y){return y.type===this.type?this.key===y.key&&this.value===y.value:!1}substituteConstants(){return this}evaluate(y){return typeof this.value=="string"?!1:parseFloat(y.getValue(this.key))<this.value}serialize(){return`${this.key} < ${this.value}`}keys(){return[this.key]}map(y){return y.mapSmaller(this.key,this.value)}negate(){return this.negated||(this.negated=l.create(this.key,this.value,this)),this.negated}}e.ContextKeySmallerExpr=M;class r{constructor(y,x,N){this.key=y,this.value=x,this.negated=N,this.type=15}static create(y,x,N=null){return g(x,z=>new r(y,z,N))}cmp(y){return y.type!==this.type?this.type-y.type:I(this.key,this.value,y.key,y.value)}equals(y){return y.type===this.type?this.key===y.key&&this.value===y.value:!1}substituteConstants(){return this}evaluate(y){return typeof this.value=="string"?!1:parseFloat(y.getValue(this.key))<=this.value}serialize(){return`${this.key} <= ${this.value}`}keys(){return[this.key]}map(y){return y.mapSmallerEquals(this.key,this.value)}negate(){return this.negated||(this.negated=A.create(this.key,this.value,this)),this.negated}}e.ContextKeySmallerEqualsExpr=r;class i{constructor(y,x){this.key=y,this.regexp=x,this.type=7,this.negated=null}static create(y,x){return new i(y,x)}cmp(y){if(y.type!==this.type)return this.type-y.type;if(this.key<y.key)return-1;if(this.key>y.key)return 1;const x=this.regexp?this.regexp.source:"",N=y.regexp?y.regexp.source:"";return x<N?-1:x>N?1:0}equals(y){if(y.type===this.type){const x=this.regexp?this.regexp.source:"",N=y.regexp?y.regexp.source:"";return this.key===y.key&&x===N}return!1}substituteConstants(){return this}evaluate(y){let x=y.getValue(this.key);return this.regexp?this.regexp.test(x):!1}serialize(){const y=this.regexp?`/${this.regexp.source}/${this.regexp.ignoreCase?"i":""}`:"/invalid/";return`${this.key} =~ ${y}`}keys(){return[this.key]}map(y){return y.mapRegex(this.key,this.regexp)}negate(){return this.negated||(this.negated=p.create(this)),this.negated}}e.ContextKeyRegexExpr=i;class p{constructor(y){this._actual=y,this.type=8}static create(y){return new p(y)}cmp(y){return y.type!==this.type?this.type-y.type:this._actual.cmp(y._actual)}equals(y){return y.type===this.type?this._actual.equals(y._actual):!1}substituteConstants(){return this}evaluate(y){return!this._actual.evaluate(y)}serialize(){throw new Error("Method not implemented.")}keys(){return this._actual.keys()}map(y){return new p(this._actual.map(y))}negate(){return this._actual}}e.ContextKeyNotRegexExpr=p;function f(L){let y=null;for(let x=0,N=L.length;x<N;x++){const z=L[x].substituteConstants();if(L[x]!==z&&y===null){y=[];for(let H=0;H<x;H++)y[H]=L[H]}y!==null&&(y[x]=z)}return y===null?L:y}class s{constructor(y,x){this.expr=y,this.negated=x,this.type=6}static create(y,x){return s._normalizeArr(y,x)}cmp(y){if(y.type!==this.type)return this.type-y.type;if(this.expr.length<y.expr.length)return-1;if(this.expr.length>y.expr.length)return 1;for(let x=0,N=this.expr.length;x<N;x++){const z=_(this.expr[x],y.expr[x]);if(z!==0)return z}return 0}equals(y){if(y.type===this.type){if(this.expr.length!==y.expr.length)return!1;for(let x=0,N=this.expr.length;x<N;x++)if(!this.expr[x].equals(y.expr[x]))return!1;return!0}return!1}substituteConstants(){const y=f(this.expr);return y===this.expr?this:s.create(y,this.negated)}evaluate(y){for(let x=0,N=this.expr.length;x<N;x++)if(!this.expr[x].evaluate(y))return!1;return!0}static _normalizeArr(y,x){const N=[];let z=!1;for(const H of y)if(!!H){if(H.type===1){z=!0;continue}if(H.type===0)return n.INSTANCE;if(H.type===6){N.push(...H.expr);continue}N.push(H)}if(N.length===0&&z)return m.INSTANCE;if(N.length!==0){if(N.length===1)return N[0];N.sort(_);for(let H=1;H<N.length;H++)N[H-1].equals(N[H])&&(N.splice(H,1),H--);if(N.length===1)return N[0];for(;N.length>1;){const H=N[N.length-1];if(H.type!==9)break;N.pop();const q=N.pop(),ue=N.length===0,K=v.create(H.expr.map(ce=>s.create([ce,q],null)),null,ue);K&&(N.push(K),N.sort(_))}return N.length===1?N[0]:new s(N,x)}}serialize(){return this.expr.map(y=>y.serialize()).join(" && ")}keys(){const y=[];for(let x of this.expr)y.push(...x.keys());return y}map(y){return new s(this.expr.map(x=>x.map(y)),null)}negate(){if(!this.negated){const y=[];for(let x of this.expr)y.push(x.negate());this.negated=v.create(y,this,!0)}return this.negated}}class v{constructor(y,x){this.expr=y,this.negated=x,this.type=9}static create(y,x,N){return v._normalizeArr(y,x,N)}cmp(y){if(y.type!==this.type)return this.type-y.type;if(this.expr.length<y.expr.length)return-1;if(this.expr.length>y.expr.length)return 1;for(let x=0,N=this.expr.length;x<N;x++){const z=_(this.expr[x],y.expr[x]);if(z!==0)return z}return 0}equals(y){if(y.type===this.type){if(this.expr.length!==y.expr.length)return!1;for(let x=0,N=this.expr.length;x<N;x++)if(!this.expr[x].equals(y.expr[x]))return!1;return!0}return!1}substituteConstants(){const y=f(this.expr);return y===this.expr?this:v.create(y,this.negated,!1)}evaluate(y){for(let x=0,N=this.expr.length;x<N;x++)if(this.expr[x].evaluate(y))return!0;return!1}static _normalizeArr(y,x,N){let z=[],H=!1;if(y){for(let q=0,ue=y.length;q<ue;q++){const K=y[q];if(!!K){if(K.type===0){H=!0;continue}if(K.type===1)return m.INSTANCE;if(K.type===9){z=z.concat(K.expr);continue}z.push(K)}}if(z.length===0&&H)return n.INSTANCE;z.sort(_)}if(z.length!==0){if(z.length===1)return z[0];for(let q=1;q<z.length;q++)z[q-1].equals(z[q])&&(z.splice(q,1),q--);if(z.length===1)return z[0];if(N){for(let q=0;q<z.length;q++)for(let ue=q+1;ue<z.length;ue++)D(z[q],z[ue])&&(z.splice(ue,1),ue--);if(z.length===1)return z[0]}return new v(z,x)}}serialize(){return this.expr.map(y=>y.serialize()).join(" || ")}keys(){const y=[];for(let x of this.expr)y.push(...x.keys());return y}map(y){return new v(this.expr.map(x=>x.map(y)),null)}negate(){if(!this.negated){let y=[];for(let x of this.expr)y.push(x.negate());for(;y.length>1;){const x=y.shift(),N=y.shift(),z=[];for(const q of B(x))for(const ue of B(N))z.push(s.create([q,ue],null));const H=y.length===0;y.unshift(v.create(z,null,H))}this.negated=y[0]}return this.negated}}class a extends o{constructor(y,x,N){super(y,null);this._defaultValue=x,typeof N=="object"?a._info.push({...N,key:y}):N!==!0&&a._info.push({key:y,description:N,type:x!=null?typeof x:void 0})}static all(){return a._info.values()}bindTo(y){return y.createKey(this.key,this._defaultValue)}getValue(y){return y.getContextKeyValue(this.key)}toNegated(){return this.negate()}isEqualTo(y){return d.create(this.key,y)}notEqualsTo(y){return b.create(this.key,y)}}e.RawContextKey=a,a._info=[],e.IContextKeyService=(0,w.createDecorator)("contextKeyService"),e.SET_CONTEXT_COMMAND_ID="setContext";function E(L,y){return L<y?-1:L>y?1:0}function I(L,y,x,N){return L<x?-1:L>x?1:y<N?-1:y>N?1:0}function D(L,y){if(y.type===6&&L.type!==9&&L.type!==6){for(const z of y.expr)if(L.equals(z))return!0}const x=L.negate(),N=B(x).concat(B(y));N.sort(_);for(let z=0;z<N.length;z++){const q=N[z].negate();for(let ue=z+1;ue<N.length;ue++){const K=N[ue];if(q.equals(K))return!0}}return!1}e.implies=D;function B(L){return L.type===9?L.expr:[L]}}),define(Ee[136],_e([0,1,4]),function(re,e,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.INativeEnvironmentService=e.IEnvironmentService=void 0,e.IEnvironmentService=(0,c.createDecorator)("environmentService"),e.INativeEnvironmentService=(0,c.refineServiceDecorator)(e.IEnvironmentService)}),define(Ee[45],_e([0,1,21,17,9,11,2,117,4]),function(re,e,c,F,w,P,t,T,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getPlatformLimits=e.Arch=e.ByteSize=e.FALLBACK_MAX_MEMORY_SIZE_MB=e.MIN_MAX_MEMORY_SIZE_MB=e.whenProviderRegistered=e.etag=e.ETAG_DISABLED=e.FileKind=e.FILES_EXCLUDE_CONFIG=e.FILES_ASSOCIATIONS_CONFIG=e.HotExitConfiguration=e.AutoSaveConfiguration=e.FileOperationResult=e.NotModifiedSinceFileOperationError=e.FileOperationError=e.isParent=e.FileChangesEvent=e.FileChangeType=e.FileOperationEvent=e.FileOperation=e.toFileOperationResult=e.toFileSystemProviderErrorCode=e.markAsFileSystemProviderError=e.ensureFileSystemProviderError=e.createFileSystemProviderError=e.FileSystemProviderError=e.FileSystemProviderErrorCode=e.hasFileReadStreamCapability=e.hasOpenReadWriteCloseCapability=e.hasFileFolderCopyCapability=e.hasReadWriteCapability=e.FileSystemProviderCapabilities=e.FilePermission=e.FileType=e.isFileOpenForWriteOptions=e.IFileService=void 0,e.IFileService=(0,C.createDecorator)("fileService");function k(N){return N.create===!0}e.isFileOpenForWriteOptions=k;var R;(function(N){N[N.Unknown=0]="Unknown",N[N.File=1]="File",N[N.Directory=2]="Directory",N[N.SymbolicLink=64]="SymbolicLink"})(R=e.FileType||(e.FileType={}));var _;(function(N){N[N.Readonly=1]="Readonly"})(_=e.FilePermission||(e.FilePermission={}));var n;(function(N){N[N.FileReadWrite=2]="FileReadWrite",N[N.FileOpenReadWriteClose=4]="FileOpenReadWriteClose",N[N.FileReadStream=16]="FileReadStream",N[N.FileFolderCopy=8]="FileFolderCopy",N[N.PathCaseSensitive=1024]="PathCaseSensitive",N[N.Readonly=2048]="Readonly",N[N.Trash=4096]="Trash",N[N.FileWriteUnlock=8192]="FileWriteUnlock"})(n=e.FileSystemProviderCapabilities||(e.FileSystemProviderCapabilities={}));function m(N){return!!(N.capabilities&2)}e.hasReadWriteCapability=m;function o(N){return!!(N.capabilities&8)}e.hasFileFolderCopyCapability=o;function d(N){return!!(N.capabilities&4)}e.hasOpenReadWriteCloseCapability=d;function u(N){return!!(N.capabilities&16)}e.hasFileReadStreamCapability=u;var S;(function(N){N.FileExists="EntryExists",N.FileNotFound="EntryNotFound",N.FileNotADirectory="EntryNotADirectory",N.FileIsADirectory="EntryIsADirectory",N.FileExceedsMemoryLimit="EntryExceedsMemoryLimit",N.FileTooLarge="EntryTooLarge",N.FileWriteLocked="EntryWriteLocked",N.NoPermissions="NoPermissions",N.Unavailable="Unavailable",N.Unknown="Unknown"})(S=e.FileSystemProviderErrorCode||(e.FileSystemProviderErrorCode={}));class b extends Error{constructor(z,H){super(z);this.code=H}}e.FileSystemProviderError=b;function h(N,z){const H=new b(N.toString(),z);return A(H,z),H}e.createFileSystemProviderError=h;function g(N){return N||h((0,T.localize)(0,null),S.Unknown)}e.ensureFileSystemProviderError=g;function A(N,z){return N.name=z?`${z} (FileSystemError)`:"FileSystemError",N}e.markAsFileSystemProviderError=A;function l(N){if(!N)return S.Unknown;if(N instanceof b)return N.code;const z=/^(.+) \(FileSystemError\)$/.exec(N.name);if(!z)return S.Unknown;switch(z[1]){case S.FileExists:return S.FileExists;case S.FileIsADirectory:return S.FileIsADirectory;case S.FileNotADirectory:return S.FileNotADirectory;case S.FileNotFound:return S.FileNotFound;case S.FileExceedsMemoryLimit:return S.FileExceedsMemoryLimit;case S.FileTooLarge:return S.FileTooLarge;case S.FileWriteLocked:return S.FileWriteLocked;case S.NoPermissions:return S.NoPermissions;case S.Unavailable:return S.Unavailable}return S.Unknown}e.toFileSystemProviderErrorCode=l;function M(N){if(N instanceof v)return N.fileOperationResult;switch(l(N)){case S.FileNotFound:return 1;case S.FileIsADirectory:return 0;case S.FileNotADirectory:return 10;case S.FileWriteLocked:return 5;case S.NoPermissions:return 6;case S.FileExists:return 4;case S.FileExceedsMemoryLimit:return 9;case S.FileTooLarge:return 7;default:return 11}}e.toFileOperationResult=M;var r;(function(N){N[N.CREATE=0]="CREATE",N[N.DELETE=1]="DELETE",N[N.MOVE=2]="MOVE",N[N.COPY=3]="COPY"})(r=e.FileOperation||(e.FileOperation={}));class i{constructor(z,H,q){this.resource=z,this.operation=H,this.target=q}isOperation(z){return this.operation===z}}e.FileOperationEvent=i;var p;(function(N){N[N.UPDATED=0]="UPDATED",N[N.ADDED=1]="ADDED",N[N.DELETED=2]="DELETED"})(p=e.FileChangeType||(e.FileChangeType={}));class f{constructor(z,H){this.added=void 0,this.updated=void 0,this.deleted=void 0;const q=new Map;for(const ue of z){const K=q.get(ue.type);K?K.push([ue.resource,ue]):q.set(ue.type,[[ue.resource,ue]])}for(const[ue,K]of q)switch(ue){case 1:this.added=c.TernarySearchTree.forUris(()=>H),this.added.fill(K);break;case 0:this.updated=c.TernarySearchTree.forUris(()=>H),this.updated.fill(K);break;case 2:this.deleted=c.TernarySearchTree.forUris(()=>H),this.deleted.fill(K);break}}contains(z,...H){return this.doContains(z,{includeChildren:!1},...H)}affects(z,...H){return this.doContains(z,{includeChildren:!0},...H)}doContains(z,H,...q){if(!z)return!1;const ue=q.length>0;return!!((!ue||q.includes(1))&&(this.added?.get(z)||H.includeChildren&&this.added?.findSuperstr(z))||(!ue||q.includes(0))&&(this.updated?.get(z)||H.includeChildren&&this.updated?.findSuperstr(z))||(!ue||q.includes(2))&&(this.deleted?.findSubstr(z)||H.includeChildren&&this.deleted?.findSuperstr(z)))}gotAdded(){return!!this.added}gotDeleted(){return!!this.deleted}gotUpdated(){return!!this.updated}get rawAdded(){return this.added}get rawDeleted(){return this.deleted}}e.FileChangesEvent=f;function s(N,z,H){return!N||!z||N===z||z.length>N.length?!1:(z.charAt(z.length-1)!==F.sep&&(z+=F.sep),H?(0,w.startsWithIgnoreCase)(N,z):N.indexOf(z)===0)}e.isParent=s;class v extends Error{constructor(z,H,q){super(z);this.fileOperationResult=H,this.options=q}}e.FileOperationError=v;class a extends v{constructor(z,H,q){super(z,2,q);this.stat=H}}e.NotModifiedSinceFileOperationError=a;var E;(function(N){N[N.FILE_IS_DIRECTORY=0]="FILE_IS_DIRECTORY",N[N.FILE_NOT_FOUND=1]="FILE_NOT_FOUND",N[N.FILE_NOT_MODIFIED_SINCE=2]="FILE_NOT_MODIFIED_SINCE",N[N.FILE_MODIFIED_SINCE=3]="FILE_MODIFIED_SINCE",N[N.FILE_MOVE_CONFLICT=4]="FILE_MOVE_CONFLICT",N[N.FILE_WRITE_LOCKED=5]="FILE_WRITE_LOCKED",N[N.FILE_PERMISSION_DENIED=6]="FILE_PERMISSION_DENIED",N[N.FILE_TOO_LARGE=7]="FILE_TOO_LARGE",N[N.FILE_INVALID_PATH=8]="FILE_INVALID_PATH",N[N.FILE_EXCEEDS_MEMORY_LIMIT=9]="FILE_EXCEEDS_MEMORY_LIMIT",N[N.FILE_NOT_DIRECTORY=10]="FILE_NOT_DIRECTORY",N[N.FILE_OTHER_ERROR=11]="FILE_OTHER_ERROR"})(E=e.FileOperationResult||(e.FileOperationResult={})),e.AutoSaveConfiguration={OFF:"off",AFTER_DELAY:"afterDelay",ON_FOCUS_CHANGE:"onFocusChange",ON_WINDOW_CHANGE:"onWindowChange"},e.HotExitConfiguration={OFF:"off",ON_EXIT:"onExit",ON_EXIT_AND_WINDOW_CLOSE:"onExitAndWindowClose"},e.FILES_ASSOCIATIONS_CONFIG="files.associations",e.FILES_EXCLUDE_CONFIG="files.exclude";var I;(function(N){N[N.FILE=0]="FILE",N[N.FOLDER=1]="FOLDER",N[N.ROOT_FOLDER=2]="ROOT_FOLDER"})(I=e.FileKind||(e.FileKind={})),e.ETAG_DISABLED="";function D(N){if(!(typeof N.size!="number"||typeof N.mtime!="number"))return N.mtime.toString(29)+N.size.toString(31)}e.etag=D;async function B(N,z){if(!z.hasProvider(t.URI.from({scheme:N.scheme})))return new Promise(H=>{const q=z.onDidChangeFileSystemProviderRegistrations(ue=>{ue.scheme===N.scheme&&ue.added&&(q.dispose(),H())})})}e.whenProviderRegistered=B,e.MIN_MAX_MEMORY_SIZE_MB=2048,e.FALLBACK_MAX_MEMORY_SIZE_MB=4096;class L{static formatSize(z){return(0,P.isNumber)(z)||(z=0),z<L.KB?(0,T.localize)(1,null,z.toFixed(0)):z<L.MB?(0,T.localize)(2,null,(z/L.KB).toFixed(2)):z<L.GB?(0,T.localize)(3,null,(z/L.MB).toFixed(2)):z<L.TB?(0,T.localize)(4,null,(z/L.GB).toFixed(2)):(0,T.localize)(5,null,(z/L.TB).toFixed(2))}}e.ByteSize=L,L.KB=1024,L.MB=L.KB*L.KB,L.GB=L.MB*L.KB,L.TB=L.GB*L.KB;var y;(function(N){N[N.IA32=0]="IA32",N[N.OTHER=1]="OTHER"})(y=e.Arch||(e.Arch={}));function x(N){return{maxFileSize:N===0?300*L.MB:16*L.GB,maxHeapSize:N===0?700*L.MB:2*700*L.MB}}e.getPlatformLimits=x}),define(Ee[60],_e([0,1]),function(re,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ServiceCollection=void 0;class c{constructor(...w){this._entries=new Map;for(let[P,t]of w)this.set(P,t)}set(w,P){const t=this._entries.get(w);return this._entries.set(w,P),t}has(w){return this._entries.has(w)}get(w){return this._entries.get(w)}}e.ServiceCollection=c}),define(Ee[137],_e([0,1,14,15,80,133,4,60]),function(re,e,c,F,w,P,t,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InstantiationService=void 0;const C=!1;class k extends Error{constructor(o){super("cyclic dependency between services");this.message=o.findCycleSlow()??`UNABLE to detect cycle, dumping graph: 
${o.toString()}`}}class R{constructor(o=new T.ServiceCollection,d=!1,u){this._activeInstantiations=new Set,this._services=o,this._strict=d,this._parent=u,this._services.set(t.IInstantiationService,this)}createChild(o){return new R(o,this._strict,this)}invokeFunction(o,...d){let u=n.traceInvocation(o),S=!1;try{return o({get:h=>{if(S)throw(0,F.illegalState)("service accessor is only valid during the invocation of its target method");const g=this._getOrCreateServiceInstance(h,u);if(!g)throw new Error(`[invokeFunction] unknown service '${h}'`);return g}},...d)}finally{S=!0,u.stop()}}createInstance(o,...d){let u,S;return o instanceof w.SyncDescriptor?(u=n.traceCreation(o.ctor),S=this._createInstance(o.ctor,o.staticArguments.concat(d),u)):(u=n.traceCreation(o),S=this._createInstance(o,d,u)),u.stop(),S}_createInstance(o,d=[],u){let S=t._util.getServiceDependencies(o).sort((g,A)=>g.index-A.index),b=[];for(const g of S){let A=this._getOrCreateServiceInstance(g.id,u);if(!A&&this._strict&&!g.optional)throw new Error(`[createInstance] ${o.name} depends on UNKNOWN service ${g.id}.`);b.push(A)}let h=S.length>0?S[0].index:d.length;if(d.length!==h){console.warn(`[createInstance] First service dependency of ${o.name} at position ${h+1} conflicts with ${d.length} static arguments`);let g=h-d.length;g>0?d=d.concat(new Array(g)):d=d.slice(0,h)}return new o(...[...d,...b])}_setServiceInstance(o,d){if(this._services.get(o)instanceof w.SyncDescriptor)this._services.set(o,d);else if(this._parent)this._parent._setServiceInstance(o,d);else throw new Error("illegalState - setting UNKNOWN service instance")}_getServiceInstanceOrDescriptor(o){let d=this._services.get(o);return!d&&this._parent?this._parent._getServiceInstanceOrDescriptor(o):d}_getOrCreateServiceInstance(o,d){let u=this._getServiceInstanceOrDescriptor(o);return u instanceof w.SyncDescriptor?this._safeCreateAndCacheServiceInstance(o,u,d.branch(o,!0)):(d.branch(o,!1),u)}_safeCreateAndCacheServiceInstance(o,d,u){if(this._activeInstantiations.has(o))throw new Error(`illegal state - RECURSIVELY instantiating service '${o}'`);this._activeInstantiations.add(o);try{return this._createAndCacheServiceInstance(o,d,u)}finally{this._activeInstantiations.delete(o)}}_createAndCacheServiceInstance(o,d,u){const S=new P.Graph(g=>g.id.toString());let b=0;const h=[{id:o,desc:d,_trace:u}];for(;h.length;){const g=h.pop();if(S.lookupOrInsertNode(g),b++>1e3)throw new k(S);for(let A of t._util.getServiceDependencies(g.desc.ctor)){let l=this._getServiceInstanceOrDescriptor(A.id);if(!l&&!A.optional&&console.warn(`[createInstance] ${o} depends on ${A.id} which is NOT registered.`),l instanceof w.SyncDescriptor){const M={id:A.id,desc:l,_trace:g._trace.branch(A.id,!0)};S.insertEdge(g,M),h.push(M)}}}for(;;){const g=S.roots();if(g.length===0){if(!S.isEmpty())throw new k(S);break}for(const{data:A}of g){if(this._getServiceInstanceOrDescriptor(A.id)instanceof w.SyncDescriptor){const M=this._createServiceInstanceWithOwner(A.id,A.desc.ctor,A.desc.staticArguments,A.desc.supportsDelayedInstantiation,A._trace);this._setServiceInstance(A.id,M)}S.removeNode(A)}}return this._getServiceInstanceOrDescriptor(o)}_createServiceInstanceWithOwner(o,d,u=[],S,b){if(this._services.get(o)instanceof w.SyncDescriptor)return this._createServiceInstance(d,u,S,b);if(this._parent)return this._parent._createServiceInstanceWithOwner(o,d,u,S,b);throw new Error(`illegalState - creating UNKNOWN service instance ${d.name}`)}_createServiceInstance(o,d=[],u,S){if(u){const b=new c.IdleValue(()=>this._createInstance(o,d,S));return new Proxy(Object.create(null),{get(h,g){if(g in h)return h[g];let A=b.value,l=A[g];return typeof l!="function"||(l=l.bind(A),h[g]=l),l},set(h,g,A){return b.value[g]=A,!0}})}else return this._createInstance(o,d,S)}}e.InstantiationService=R;var _;(function(m){m[m.Creation=0]="Creation",m[m.Invocation=1]="Invocation",m[m.Branch=2]="Branch"})(_||(_={}));class n{constructor(o,d){this.type=o,this.name=d,this._start=Date.now(),this._dep=[]}static traceInvocation(o){return C?new n(1,o.name||o.toString().substring(0,42).replace(/\n/g,"")):n._None}static traceCreation(o){return C?new n(0,o.name):n._None}branch(o,d){let u=new n(2,o.toString());return this._dep.push([o,d,u]),u}stop(){let o=Date.now()-this._start;n._totals+=o;let d=!1;function u(b,h){let g=[],A=new Array(b+1).join("	");for(const[l,M,r]of h._dep)if(M&&r){d=!0,g.push(`${A}CREATES -> ${l}`);let i=u(b+1,r);i&&g.push(i)}else g.push(`${A}uses -> ${l}`);return g.join(`
`)}let S=[`${this.type===0?"CREATE":"CALL"} ${this.name}`,`${u(1,this)}`,`DONE, took ${o.toFixed(2)}ms (grand total ${n._totals.toFixed(2)}ms)`];(o>2||d)&&console.log(S.join(`
`))}}n._None=new class extends n{constructor(){super(-1,null)}stop(){}branch(){return this}},n._totals=0}),define(Ee[12],_e([0,1,43,3,6,23,4]),function(re,e,c,F,w,P,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LogLevelToString=e.parseLogLevel=e.getLogLevel=e.NullLogService=e.AbstractLoggerService=e.LogService=e.MultiplexLogService=e.AdapterLogger=e.ConsoleLogger=e.ConsoleMainLogger=e.AbstractMessageLogger=e.AbstractLogger=e.format=e.log=e.DEFAULT_LOG_LEVEL=e.LogLevel=e.ILoggerService=e.ILogService=void 0,e.ILogService=(0,t.createDecorator)("logService"),e.ILoggerService=(0,t.createDecorator)("loggerService");function T(){return new Date().toISOString()}var C;(function(M){M[M.Trace=0]="Trace",M[M.Debug=1]="Debug",M[M.Info=2]="Info",M[M.Warning=3]="Warning",M[M.Error=4]="Error",M[M.Critical=5]="Critical",M[M.Off=6]="Off"})(C=e.LogLevel||(e.LogLevel={})),e.DEFAULT_LOG_LEVEL=C.Info;function k(M,r,i){switch(r){case C.Trace:M.trace(i);break;case C.Debug:M.debug(i);break;case C.Info:M.info(i);break;case C.Warning:M.warn(i);break;case C.Error:M.error(i);break;case C.Critical:M.critical(i);break;default:throw new Error("Invalid log level")}}e.log=k;function R(M){let r="";for(let i=0;i<M.length;i++){let p=M[i];if(typeof p=="object")try{p=JSON.stringify(p)}catch(f){}r+=(i>0?" ":"")+p}return r}e.format=R;class _ extends w.Disposable{constructor(){super(...arguments);this.level=e.DEFAULT_LOG_LEVEL,this._onDidChangeLogLevel=this._register(new F.Emitter),this.onDidChangeLogLevel=this._onDidChangeLogLevel.event}setLevel(r){this.level!==r&&(this.level=r,this._onDidChangeLogLevel.fire(this.level))}getLevel(){return this.level}}e.AbstractLogger=_;class n extends _{constructor(r){super();this.logAlways=r}checkLogLevel(r){return this.logAlways||this.getLevel()<=r}trace(r,...i){this.checkLogLevel(C.Trace)&&this.log(C.Trace,R([r,...i]))}debug(r,...i){this.checkLogLevel(C.Debug)&&this.log(C.Debug,R([r,...i]))}info(r,...i){this.checkLogLevel(C.Info)&&this.log(C.Info,R([r,...i]))}warn(r,...i){this.checkLogLevel(C.Warning)&&this.log(C.Warning,R([r,...i]))}error(r,...i){if(this.checkLogLevel(C.Error))if(r instanceof Error){const p=Array.prototype.slice.call(arguments);p[0]=r.stack,this.log(C.Error,R(p))}else this.log(C.Error,R([r,...i]))}critical(r,...i){this.checkLogLevel(C.Critical)&&this.log(C.Critical,R([r,...i]))}flush(){}}e.AbstractMessageLogger=n;class m extends _{constructor(r=e.DEFAULT_LOG_LEVEL){super();this.setLevel(r),this.useColors=!P.isWindows}trace(r,...i){this.getLevel()<=C.Trace&&(this.useColors?console.log(`[90m[main ${T()}][0m`,r,...i):console.log(`[main ${T()}]`,r,...i))}debug(r,...i){this.getLevel()<=C.Debug&&(this.useColors?console.log(`[90m[main ${T()}][0m`,r,...i):console.log(`[main ${T()}]`,r,...i))}info(r,...i){this.getLevel()<=C.Info&&(this.useColors?console.log(`[90m[main ${T()}][0m`,r,...i):console.log(`[main ${T()}]`,r,...i))}warn(r,...i){this.getLevel()<=C.Warning&&(this.useColors?console.warn(`[93m[main ${T()}][0m`,r,...i):console.warn(`[main ${T()}]`,r,...i))}error(r,...i){this.getLevel()<=C.Error&&(this.useColors?console.error(`[91m[main ${T()}][0m`,r,...i):console.error(`[main ${T()}]`,r,...i))}critical(r,...i){this.getLevel()<=C.Critical&&(this.useColors?console.error(`[90m[main ${T()}][0m`,r,...i):console.error(`[main ${T()}]`,r,...i))}dispose(){}flush(){}}e.ConsoleMainLogger=m;class o extends _{constructor(r=e.DEFAULT_LOG_LEVEL){super();this.setLevel(r)}trace(r,...i){this.getLevel()<=C.Trace&&console.log("%cTRACE","color: #888",r,...i)}debug(r,...i){this.getLevel()<=C.Debug&&console.log("%cDEBUG","background: #eee; color: #888",r,...i)}info(r,...i){this.getLevel()<=C.Info&&console.log("%c INFO","color: #33f",r,...i)}warn(r,...i){this.getLevel()<=C.Warning&&console.log("%c WARN","color: #993",r,...i)}error(r,...i){this.getLevel()<=C.Error&&console.log("%c  ERR","color: #f33",r,...i)}critical(r,...i){this.getLevel()<=C.Critical&&console.log("%cCRITI","background: #f33; color: white",r,...i)}dispose(){}flush(){}}e.ConsoleLogger=o;class d extends _{constructor(r,i=e.DEFAULT_LOG_LEVEL){super();this.adapter=r,this.setLevel(i)}trace(r,...i){this.getLevel()<=C.Trace&&this.adapter.log(C.Trace,[this.extractMessage(r),...i])}debug(r,...i){this.getLevel()<=C.Debug&&this.adapter.log(C.Debug,[this.extractMessage(r),...i])}info(r,...i){this.getLevel()<=C.Info&&this.adapter.log(C.Info,[this.extractMessage(r),...i])}warn(r,...i){this.getLevel()<=C.Warning&&this.adapter.log(C.Warning,[this.extractMessage(r),...i])}error(r,...i){this.getLevel()<=C.Error&&this.adapter.log(C.Error,[this.extractMessage(r),...i])}critical(r,...i){this.getLevel()<=C.Critical&&this.adapter.log(C.Critical,[this.extractMessage(r),...i])}extractMessage(r){return typeof r=="string"?r:(0,c.toErrorMessage)(r,this.getLevel()<=C.Trace)}dispose(){}flush(){}}e.AdapterLogger=d;class u extends _{constructor(r){super();this.logServices=r,r.length&&this.setLevel(r[0].getLevel())}setLevel(r){for(const i of this.logServices)i.setLevel(r);super.setLevel(r)}trace(r,...i){for(const p of this.logServices)p.trace(r,...i)}debug(r,...i){for(const p of this.logServices)p.debug(r,...i)}info(r,...i){for(const p of this.logServices)p.info(r,...i)}warn(r,...i){for(const p of this.logServices)p.warn(r,...i)}error(r,...i){for(const p of this.logServices)p.error(r,...i)}critical(r,...i){for(const p of this.logServices)p.critical(r,...i)}flush(){for(const r of this.logServices)r.flush()}dispose(){for(const r of this.logServices)r.dispose()}}e.MultiplexLogService=u;class S extends w.Disposable{constructor(r){super();this.logger=r,this._register(r)}get onDidChangeLogLevel(){return this.logger.onDidChangeLogLevel}setLevel(r){this.logger.setLevel(r)}getLevel(){return this.logger.getLevel()}trace(r,...i){this.logger.trace(r,...i)}debug(r,...i){this.logger.debug(r,...i)}info(r,...i){this.logger.info(r,...i)}warn(r,...i){this.logger.warn(r,...i)}error(r,...i){this.logger.error(r,...i)}critical(r,...i){this.logger.critical(r,...i)}flush(){this.logger.flush()}}e.LogService=S;class b extends w.Disposable{constructor(r,i){super();this.logLevel=r,this.loggers=new Map,this.logLevelChangeableLoggers=[],this._register(i(p=>{this.logLevel=p,this.logLevelChangeableLoggers.forEach(f=>f.setLevel(p))}))}getLogger(r){return this.loggers.get(r.toString())}createLogger(r,i){let p=this.loggers.get(r.toString());return p||(p=this.doCreateLogger(r,i?.always?C.Trace:this.logLevel,i),this.loggers.set(r.toString(),p),i?.always||this.logLevelChangeableLoggers.push(p)),p}dispose(){this.logLevelChangeableLoggers.splice(0,this.logLevelChangeableLoggers.length),this.loggers.forEach(r=>r.dispose()),this.loggers.clear(),super.dispose()}}e.AbstractLoggerService=b;class h{constructor(){this.onDidChangeLogLevel=new F.Emitter().event}setLevel(r){}getLevel(){return C.Info}trace(r,...i){}debug(r,...i){}info(r,...i){}warn(r,...i){}error(r,...i){}critical(r,...i){}dispose(){}flush(){}}e.NullLogService=h;function g(M){if(M.verbose)return C.Trace;if(typeof M.logLevel=="string"){const r=A(M.logLevel.toLowerCase());if(r!==void 0)return r}return e.DEFAULT_LOG_LEVEL}e.getLogLevel=g;function A(M){switch(M){case"trace":return C.Trace;case"debug":return C.Debug;case"info":return C.Info;case"warn":return C.Warning;case"error":return C.Error;case"critical":return C.Critical;case"off":return C.Off}}e.parseLogLevel=A;function l(M){switch(M){case C.Trace:return"trace";case C.Debug:return"debug";case C.Info:return"info";case C.Warning:return"warn";case C.Error:return"error";case C.Critical:return"critical";case C.Off:return"off"}}e.LogLevelToString=l}),define(Ee[82],_e([0,1,34,118,4]),function(re,e,c,F,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IMarkerService=e.IMarkerData=e.MarkerSeverity=e.MarkerTag=void 0;var P;(function(C){C[C.Unnecessary=1]="Unnecessary",C[C.Deprecated=2]="Deprecated"})(P=e.MarkerTag||(e.MarkerTag={}));var t;(function(C){C[C.Hint=1]="Hint",C[C.Info=2]="Info",C[C.Warning=4]="Warning",C[C.Error=8]="Error"})(t=e.MarkerSeverity||(e.MarkerSeverity={})),function(C){function k(o,d){return d-o}C.compare=k;const R=Object.create(null);R[C.Error]=(0,F.localize)(0,null),R[C.Warning]=(0,F.localize)(1,null),R[C.Info]=(0,F.localize)(2,null);function _(o){return R[o]||""}C.toString=_;function n(o){switch(o){case c.default.Error:return C.Error;case c.default.Warning:return C.Warning;case c.default.Info:return C.Info;case c.default.Ignore:return C.Hint}}C.fromSeverity=n;function m(o){switch(o){case C.Error:return c.default.Error;case C.Warning:return c.default.Warning;case C.Info:return c.default.Info;case C.Hint:return c.default.Ignore}}C.toSeverity=m}(t=e.MarkerSeverity||(e.MarkerSeverity={}));var T;(function(C){const k="";function R(n){return _(n,!0)}C.makeKey=R;function _(n,m){let o=[k];return n.source?o.push(n.source.replace("\xA6","\\\xA6")):o.push(k),n.code?typeof n.code=="string"?o.push(n.code.replace("\xA6","\\\xA6")):o.push(n.code.value.replace("\xA6","\\\xA6")):o.push(k),n.severity!==void 0&&n.severity!==null?o.push(t.toString(n.severity)):o.push(k),n.message&&m?o.push(n.message.replace("\xA6","\\\xA6")):o.push(k),n.startLineNumber!==void 0&&n.startLineNumber!==null?o.push(n.startLineNumber.toString()):o.push(k),n.startColumn!==void 0&&n.startColumn!==null?o.push(n.startColumn.toString()):o.push(k),n.endLineNumber!==void 0&&n.endLineNumber!==null?o.push(n.endLineNumber.toString()):o.push(k),n.endColumn!==void 0&&n.endColumn!==null?o.push(n.endColumn.toString()):o.push(k),o.push(k),o.join("\xA6")}C.makeKeyOptionalMessage=_})(T=e.IMarkerData||(e.IMarkerData={})),e.IMarkerService=(0,w.createDecorator)("markerService")}),define(Ee[138],_e([0,1,3,34,4]),function(re,e,c,F,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NoOpProgress=e.NoOpNotification=e.NotificationsFilter=e.NeverShowAgainScope=e.INotificationService=e.Severity=void 0,e.Severity=F.default,e.INotificationService=(0,w.createDecorator)("notificationService");var P;(function(k){k[k.WORKSPACE=0]="WORKSPACE",k[k.GLOBAL=1]="GLOBAL"})(P=e.NeverShowAgainScope||(e.NeverShowAgainScope={}));var t;(function(k){k[k.OFF=0]="OFF",k[k.SILENT=1]="SILENT",k[k.ERROR=2]="ERROR"})(t=e.NotificationsFilter||(e.NotificationsFilter={}));class T{constructor(){this.progress=new C,this.onDidClose=c.Event.None,this.onDidChangeVisibility=c.Event.None}updateSeverity(R){}updateMessage(R){}updateActions(R){}close(){}}e.NoOpNotification=T;class C{infinite(){}done(){}total(R){}worked(R){}}e.NoOpProgress=C}),define(Ee[139],_e([0,1,6,9,2,4]),function(re,e,c,F,w,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.matchesSomeScheme=e.matchesScheme=e.NullOpenerService=e.IOpenerService=void 0,e.IOpenerService=(0,P.createDecorator)("openerService"),e.NullOpenerService=Object.freeze({_serviceBrand:void 0,registerOpener(){return c.Disposable.None},registerValidator(){return c.Disposable.None},registerExternalUriResolver(){return c.Disposable.None},setDefaultExternalOpener(){},registerExternalOpener(){return c.Disposable.None},async open(){return!1},async resolveExternalUri(C){return{resolved:C,dispose(){}}}});function t(C,k){return w.URI.isUri(C)?(0,F.equalsIgnoreCase)(C.scheme,k):(0,F.startsWithIgnoreCase)(C,k+":")}e.matchesScheme=t;function T(C,...k){return k.some(R=>t(C,R))}e.matchesSomeScheme=T});var Ue=this&&this.__decorate||function(re,e,c,F){var w=arguments.length,P=w<3?e:F===null?F=Object.getOwnPropertyDescriptor(e,c):F,t;if(typeof Reflect=="object"&&typeof Reflect.decorate=="function")P=Reflect.decorate(re,e,c,F);else for(var T=re.length-1;T>=0;T--)(t=re[T])&&(P=(w<3?t(P):w>3?t(e,c,P):t(e,c))||P);return w>3&&P&&Object.defineProperty(e,c,P),P},$e=this&&this.__param||function(re,e){return function(c,F){e(c,F,re)}};define(Ee[140],_e([0,1,14,20,6,4]),function(re,e,c,F,w,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IEditorProgressService=e.LongRunningOperation=e.UnmanagedProgress=e.Progress=e.emptyProgressRunner=e.ProgressLocation=e.IProgressService=void 0,e.IProgressService=(0,P.createDecorator)("progressService");var t;(function(R){R[R.Explorer=1]="Explorer",R[R.Scm=3]="Scm",R[R.Extensions=5]="Extensions",R[R.Window=10]="Window",R[R.Notification=15]="Notification",R[R.Dialog=20]="Dialog"})(t=e.ProgressLocation||(e.ProgressLocation={})),e.emptyProgressRunner=Object.freeze({total(){},worked(){},done(){}});class T{constructor(_){this.callback=_}get value(){return this._value}report(_){this._value=_,this.callback(this._value)}}e.Progress=T,T.None=Object.freeze({report(){}});let C=class extends w.Disposable{constructor(_,n){super();this.deferred=new c.DeferredPromise,n.withProgress(_,m=>(this.reporter=m,this.lastStep&&m.report(this.lastStep),this.deferred.p)),this._register((0,w.toDisposable)(()=>this.deferred.complete()))}report(_){this.reporter?this.reporter.report(_):this.lastStep=_}};C=Ue([$e(1,e.IProgressService)],C),e.UnmanagedProgress=C;class k extends w.Disposable{constructor(_){super();this.progressIndicator=_,this.currentOperationId=0,this.currentOperationDisposables=this._register(new w.DisposableStore)}start(_){this.stop();const n=++this.currentOperationId,m=new F.CancellationTokenSource;return this.currentProgressTimeout=setTimeout(()=>{n===this.currentOperationId&&(this.currentProgressRunner=this.progressIndicator.show(!0))},_),this.currentOperationDisposables.add((0,w.toDisposable)(()=>clearTimeout(this.currentProgressTimeout))),this.currentOperationDisposables.add((0,w.toDisposable)(()=>m.cancel())),this.currentOperationDisposables.add((0,w.toDisposable)(()=>this.currentProgressRunner?this.currentProgressRunner.done():void 0)),{id:n,token:m.token,stop:()=>this.doStop(n),isCurrent:()=>this.currentOperationId===n}}stop(){this.doStop(this.currentOperationId)}doStop(_){this.currentOperationId===_&&this.currentOperationDisposables.clear()}}e.LongRunningOperation=k,e.IEditorProgressService=(0,P.createDecorator)("editorProgressService")}),define(Ee[36],_e([0,1,41,11]),function(re,e,c,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Registry=void 0;class w{constructor(){this.data=new Map}add(t,T){c.ok(F.isString(t)),c.ok(F.isObject(T)),c.ok(!this.data.has(t),"There is already an extension with this id"),this.data.set(t,T)}knows(t){return this.data.has(t)}as(t){return this.data.get(t)||null}}e.Registry=new w}),define(Ee[141],_e([0,1,3,36]),function(re,e,c,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Extensions=void 0,e.Extensions={JSONContribution:"base.contributions.json"};function w(T){return T.length>0&&T.charAt(T.length-1)==="#"?T.substring(0,T.length-1):T}class P{constructor(){this._onDidChangeSchema=new c.Emitter,this.onDidChangeSchema=this._onDidChangeSchema.event,this.schemasById={}}registerSchema(C,k){this.schemasById[w(C)]=k,this._onDidChangeSchema.fire(C)}notifySchemaChanged(C){this._onDidChangeSchema.fire(C)}getSchemaContributions(){return{schemas:this.schemasById}}}const t=new P;F.Registry.add(e.Extensions.JSONContribution,t)}),define(Ee[83],_e([0,1,16,3,11,115,141,36]),function(re,e,c,F,w,P,t,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getScopes=e.validateProperty=e.getDefaultValue=e.keyFromOverrideIdentifiers=e.overrideIdentifiersFromKey=e.OVERRIDE_PROPERTY_REGEX=e.OVERRIDE_PROPERTY_PATTERN=e.configurationDefaultsSchemaId=e.resourceLanguageSettingsSchemaId=e.resourceSettings=e.windowSettings=e.machineOverridableSettings=e.machineSettings=e.applicationSettings=e.allSettings=e.ConfigurationScope=e.Extensions=e.EditPresentationTypes=void 0;var C;(function(g){g.Multiline="multilineText",g.Singleline="singlelineText"})(C=e.EditPresentationTypes||(e.EditPresentationTypes={})),e.Extensions={Configuration:"base.contributions.configuration"};var k;(function(g){g[g.APPLICATION=1]="APPLICATION",g[g.MACHINE=2]="MACHINE",g[g.WINDOW=3]="WINDOW",g[g.RESOURCE=4]="RESOURCE",g[g.LANGUAGE_OVERRIDABLE=5]="LANGUAGE_OVERRIDABLE",g[g.MACHINE_OVERRIDABLE=6]="MACHINE_OVERRIDABLE"})(k=e.ConfigurationScope||(e.ConfigurationScope={})),e.allSettings={properties:{},patternProperties:{}},e.applicationSettings={properties:{},patternProperties:{}},e.machineSettings={properties:{},patternProperties:{}},e.machineOverridableSettings={properties:{},patternProperties:{}},e.windowSettings={properties:{},patternProperties:{}},e.resourceSettings={properties:{},patternProperties:{}},e.resourceLanguageSettingsSchemaId="vscode://schemas/settings/resourceLanguage",e.configurationDefaultsSchemaId="vscode://schemas/settings/configurationDefaults";const R=T.Registry.as(t.Extensions.JSONContribution);class _{constructor(){this.overrideIdentifiers=new Set,this._onDidSchemaChange=new F.Emitter,this.onDidSchemaChange=this._onDidSchemaChange.event,this._onDidUpdateConfiguration=new F.Emitter,this.onDidUpdateConfiguration=this._onDidUpdateConfiguration.event,this.configurationDefaultsOverrides=new Map,this.defaultLanguageConfigurationOverridesNode={id:"defaultOverrides",title:P.localize(0,null),properties:{}},this.configurationContributors=[this.defaultLanguageConfigurationOverridesNode],this.resourceLanguageSettingsSchema={properties:{},patternProperties:{},additionalProperties:!1,errorMessage:"Unknown editor configuration setting",allowTrailingCommas:!0,allowComments:!0},this.configurationProperties={},this.excludedConfigurationProperties={},R.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this.registerOverridePropertyPatternKey()}registerConfiguration(A,l=!0){this.registerConfigurations([A],l)}registerConfigurations(A,l=!0){const M=this.doRegisterConfigurations(A,l);R.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:M})}deregisterConfigurations(A){const l=this.doDeregisterConfigurations(A);R.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:l})}updateConfigurations({add:A,remove:l}){const M=[];M.push(...this.doDeregisterConfigurations(l)),M.push(...this.doRegisterConfigurations(A,!1)),R.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:(0,c.distinct)(M)})}registerDefaultConfigurations(A){const l=[],M=[];for(const{overrides:r,source:i}of A)for(const p in r)if(l.push(p),e.OVERRIDE_PROPERTY_REGEX.test(p)){const f={...this.configurationDefaultsOverrides.get(p)?.value||{},...r[p]};this.configurationDefaultsOverrides.set(p,{source:i,value:f});const s={type:"object",default:f,description:P.localize(1,null,p),$ref:e.resourceLanguageSettingsSchemaId,defaultDefaultValue:f,source:w.isString(i)?void 0:i};M.push(...o(p)),this.configurationProperties[p]=s,this.defaultLanguageConfigurationOverridesNode.properties[p]=s}else{this.configurationDefaultsOverrides.set(p,{value:r[p],source:i});const f=this.configurationProperties[p];f&&(this.updatePropertyDefaultValue(p,f),this.updateSchema(p,f))}this.registerOverrideIdentifiers(M),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:l,defaultsOverrides:!0})}deregisterDefaultConfigurations(A){const l=[];for(const{overrides:M,source:r}of A)for(const i in M){const p=this.configurationDefaultsOverrides.get(i),f=w.isString(r)?r:r?.id,s=w.isString(p?.source)?p?.source:p?.source?.id;if(f===s)if(l.push(i),this.configurationDefaultsOverrides.delete(i),e.OVERRIDE_PROPERTY_REGEX.test(i))delete this.configurationProperties[i],delete this.defaultLanguageConfigurationOverridesNode.properties[i];else{const v=this.configurationProperties[i];v&&(this.updatePropertyDefaultValue(i,v),this.updateSchema(i,v))}}this.updateOverridePropertyPatternKey(),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:l,defaultsOverrides:!0})}notifyConfigurationSchemaUpdated(...A){this._onDidSchemaChange.fire()}registerOverrideIdentifiers(A){for(const l of A)this.overrideIdentifiers.add(l);this.updateOverridePropertyPatternKey()}doRegisterConfigurations(A,l){const M=[];return A.forEach(r=>{M.push(...this.validateAndRegisterProperties(r,l,r.extensionInfo,r.restrictedProperties)),this.configurationContributors.push(r),this.registerJSONConfiguration(r)}),M}doDeregisterConfigurations(A){const l=[],M=r=>{if(r.properties)for(const i in r.properties)l.push(i),delete this.configurationProperties[i],this.removeFromSchema(i,r.properties[i]);r.allOf&&r.allOf.forEach(i=>M(i))};for(const r of A){M(r);const i=this.configurationContributors.indexOf(r);i!==-1&&this.configurationContributors.splice(i,1)}return l}validateAndRegisterProperties(A,l=!0,M,r,i=3){i=w.isUndefinedOrNull(A.scope)?i:A.scope;let p=[],f=A.properties;if(f)for(let v in f){if(l&&b(v)){delete f[v];continue}const a=f[v];if(a.source=M,a.defaultDefaultValue=f[v].default,this.updatePropertyDefaultValue(v,a),e.OVERRIDE_PROPERTY_REGEX.test(v)?a.scope=void 0:(a.scope=w.isUndefinedOrNull(a.scope)?i:a.scope,a.restricted=w.isUndefinedOrNull(a.restricted)?!!r?.includes(v):a.restricted),f[v].hasOwnProperty("included")&&!f[v].included){this.excludedConfigurationProperties[v]=f[v],delete f[v];continue}else this.configurationProperties[v]=f[v];!f[v].deprecationMessage&&f[v].markdownDeprecationMessage&&(f[v].deprecationMessage=f[v].markdownDeprecationMessage),p.push(v)}let s=A.allOf;if(s)for(let v of s)p.push(...this.validateAndRegisterProperties(v,l,M,r,i));return p}getConfigurations(){return this.configurationContributors}getConfigurationProperties(){return this.configurationProperties}getExcludedConfigurationProperties(){return this.excludedConfigurationProperties}getConfigurationDefaultsOverrides(){return this.configurationDefaultsOverrides}registerJSONConfiguration(A){const l=M=>{let r=M.properties;if(r)for(const p in r)this.updateSchema(p,r[p]);let i=M.allOf;i&&i.forEach(l)};l(A)}updateSchema(A,l){switch(e.allSettings.properties[A]=l,l.scope){case 1:e.applicationSettings.properties[A]=l;break;case 2:e.machineSettings.properties[A]=l;break;case 6:e.machineOverridableSettings.properties[A]=l;break;case 3:e.windowSettings.properties[A]=l;break;case 4:e.resourceSettings.properties[A]=l;break;case 5:e.resourceSettings.properties[A]=l,this.resourceLanguageSettingsSchema.properties[A]=l;break}}removeFromSchema(A,l){switch(delete e.allSettings.properties[A],l.scope){case 1:delete e.applicationSettings.properties[A];break;case 2:delete e.machineSettings.properties[A];break;case 6:delete e.machineOverridableSettings.properties[A];break;case 3:delete e.windowSettings.properties[A];break;case 4:case 5:delete e.resourceSettings.properties[A],delete this.resourceLanguageSettingsSchema.properties[A];break}}updateOverridePropertyPatternKey(){for(const A of this.overrideIdentifiers.values()){const l=`[${A}]`,M={type:"object",description:P.localize(2,null),errorMessage:P.localize(3,null),$ref:e.resourceLanguageSettingsSchemaId};this.updatePropertyDefaultValue(l,M),e.allSettings.properties[l]=M,e.applicationSettings.properties[l]=M,e.machineSettings.properties[l]=M,e.machineOverridableSettings.properties[l]=M,e.windowSettings.properties[l]=M,e.resourceSettings.properties[l]=M}this._onDidSchemaChange.fire()}registerOverridePropertyPatternKey(){const A={type:"object",description:P.localize(4,null),errorMessage:P.localize(5,null),$ref:e.resourceLanguageSettingsSchemaId};e.allSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=A,e.applicationSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=A,e.machineSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=A,e.machineOverridableSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=A,e.windowSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=A,e.resourceSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=A,this._onDidSchemaChange.fire()}updatePropertyDefaultValue(A,l){const M=this.configurationDefaultsOverrides.get(A);let r=M?.value,i=M?.source;w.isUndefined(r)&&(r=l.defaultDefaultValue,i=void 0),w.isUndefined(r)&&(r=u(l.type)),l.default=r,l.defaultValueSource=i}}const n="\\[([^\\]]+)\\]",m=new RegExp(n,"g");e.OVERRIDE_PROPERTY_PATTERN=`^(${n})+$`,e.OVERRIDE_PROPERTY_REGEX=new RegExp(e.OVERRIDE_PROPERTY_PATTERN);function o(g){const A=[];if(e.OVERRIDE_PROPERTY_REGEX.test(g)){let l=m.exec(g);for(;l?.length;){const M=l[1].trim();M&&A.push(M),l=m.exec(g)}}return(0,c.distinct)(A)}e.overrideIdentifiersFromKey=o;function d(g){return g.reduce((A,l)=>`${A}[${l}]`,"")}e.keyFromOverrideIdentifiers=d;function u(g){switch(Array.isArray(g)?g[0]:g){case"boolean":return!1;case"integer":case"number":return 0;case"string":return"";case"array":return[];case"object":return{};default:return null}}e.getDefaultValue=u;const S=new _;T.Registry.add(e.Extensions.Configuration,S);function b(g){return g.trim()?e.OVERRIDE_PROPERTY_REGEX.test(g)?P.localize(7,null,g):S.getConfigurationProperties()[g]!==void 0?P.localize(8,null,g):null:P.localize(6,null)}e.validateProperty=b;function h(){const g=[],A=S.getConfigurationProperties();for(const l of Object.keys(A))g.push([l,A[l].scope]);return g.push(["launch",4]),g.push(["task",4]),g}e.getScopes=h}),define(Ee[142],_e([0,1,16,3,100,6,21,26,11,2,81,83,36]),function(re,e,c,F,w,P,t,T,C,k,R,_,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AllKeysConfigurationChangeEvent=e.ConfigurationChangeEvent=e.mergeChanges=e.Configuration=e.UserSettings=e.ConfigurationModelParser=e.DefaultConfigurationModel=e.ConfigurationModel=void 0;class m{constructor(r={},i=[],p=[]){this._contents=r,this._keys=i,this._overrides=p,this.isFrozen=!1,this.overrideConfigurations=new Map}get contents(){return this.checkAndFreeze(this._contents)}get overrides(){return this.checkAndFreeze(this._overrides)}get keys(){return this.checkAndFreeze(this._keys)}isEmpty(){return this._keys.length===0&&Object.keys(this._contents).length===0&&this._overrides.length===0}getValue(r){return r?(0,R.getConfigurationValue)(this.contents,r):this.contents}getOverrideValue(r,i){const p=this.getContentsForOverrideIdentifer(i);return p?r?(0,R.getConfigurationValue)(p,r):p:void 0}getKeysForOverrideIdentifier(r){const i=[];for(const p of this.overrides)p.identifiers.includes(r)&&i.push(...p.keys);return c.distinct(i)}getAllOverrideIdentifiers(){const r=[];for(const i of this.overrides)r.push(...i.identifiers);return c.distinct(r)}override(r){let i=this.overrideConfigurations.get(r);return i||(i=this.createOverrideConfigurationModel(r),this.overrideConfigurations.set(r,i)),i}merge(...r){const i=T.deepClone(this.contents),p=T.deepClone(this.overrides),f=[...this.keys];for(const s of r){this.mergeContents(i,s.contents);for(const v of s.overrides){const[a]=p.filter(E=>c.equals(E.identifiers,v.identifiers));a?(this.mergeContents(a.contents,v.contents),a.keys.push(...v.keys),a.keys=c.distinct(a.keys)):p.push(T.deepClone(v))}for(const v of s.keys)f.indexOf(v)===-1&&f.push(v)}return new m(i,f,p)}freeze(){return this.isFrozen=!0,this}createOverrideConfigurationModel(r){const i=this.getContentsForOverrideIdentifer(r);if(!i||typeof i!="object"||!Object.keys(i).length)return this;let p={};for(const f of c.distinct([...Object.keys(this.contents),...Object.keys(i)])){let s=this.contents[f],v=i[f];v&&(typeof s=="object"&&typeof v=="object"?(s=T.deepClone(s),this.mergeContents(s,v)):s=v),p[f]=s}return new m(p,this.keys,this.overrides)}mergeContents(r,i){for(const p of Object.keys(i)){if(p in r&&C.isObject(r[p])&&C.isObject(i[p])){this.mergeContents(r[p],i[p]);continue}r[p]=T.deepClone(i[p])}}checkAndFreeze(r){return this.isFrozen&&!Object.isFrozen(r)?T.deepFreeze(r):r}getContentsForOverrideIdentifer(r){let i=null,p=null;const f=s=>{s&&(p?this.mergeContents(p,s):p=T.deepClone(s))};for(const s of this.overrides)c.equals(s.identifiers,[r])?i=s.contents:s.identifiers.includes(r)&&f(s.contents);return f(i),p}toJSON(){return{contents:this.contents,overrides:this.overrides,keys:this.keys}}setValue(r,i){this.addKey(r),(0,R.addToValueTree)(this.contents,r,i,p=>{throw new Error(p)})}removeValue(r){this.removeKey(r)&&(0,R.removeFromValueTree)(this.contents,r)}addKey(r){let i=this.keys.length;for(let p=0;p<i;p++)r.indexOf(this.keys[p])===0&&(i=p);this.keys.splice(i,1,r)}removeKey(r){let i=this.keys.indexOf(r);return i!==-1?(this.keys.splice(i,1),!0):!1}}e.ConfigurationModel=m;class o extends m{constructor(r={}){const i=n.Registry.as(_.Extensions.Configuration).getConfigurationProperties(),p=Object.keys(i),f=Object.create(null),s=[];for(const v in i){const a=r[v],E=a!==void 0?a:i[v].default;(0,R.addToValueTree)(f,v,E,I=>console.error(`Conflict in default settings: ${I}`))}for(const v of Object.keys(f))_.OVERRIDE_PROPERTY_REGEX.test(v)&&s.push({identifiers:(0,_.overrideIdentifiersFromKey)(v),keys:Object.keys(f[v]),contents:(0,R.toValuesTree)(f[v],a=>console.error(`Conflict in default settings file: ${a}`))});super(f,p,s)}}e.DefaultConfigurationModel=o;class d{constructor(r){this._name=r,this._raw=null,this._configurationModel=null,this._restrictedConfigurations=[],this._parseErrors=[]}get configurationModel(){return this._configurationModel||new m}get restrictedConfigurations(){return this._restrictedConfigurations}get errors(){return this._parseErrors}parse(r,i){if(!C.isUndefinedOrNull(r)){const p=this.doParseContent(r);this.parseRaw(p,i)}}reparse(r){this._raw&&this.parseRaw(this._raw,r)}parseRaw(r,i){this._raw=r;const{contents:p,keys:f,overrides:s,restricted:v}=this.doParseRaw(r,i);this._configurationModel=new m(p,f,s),this._restrictedConfigurations=v||[]}doParseContent(r){let i={},p=null,f=[],s=[],v=[];function a(I){Array.isArray(f)?f.push(I):p!==null&&(f[p]=I)}let E={onObjectBegin:()=>{let I={};a(I),s.push(f),f=I,p=null},onObjectProperty:I=>{p=I},onObjectEnd:()=>{f=s.pop()},onArrayBegin:()=>{let I=[];a(I),s.push(f),f=I,p=null},onArrayEnd:()=>{f=s.pop()},onLiteralValue:a,onError:(I,D,B)=>{v.push({error:I,offset:D,length:B})}};if(r)try{w.visit(r,E),i=f[0]||{}}catch(I){console.error(`Error while parsing settings file ${this._name}: ${I}`),this._parseErrors=[I]}return i}doParseRaw(r,i){const p=n.Registry.as(_.Extensions.Configuration).getConfigurationProperties(),f=this.filter(r,p,!0,i);r=f.raw;const s=(0,R.toValuesTree)(r,E=>console.error(`Conflict in settings file ${this._name}: ${E}`)),v=Object.keys(r),a=this.toOverrides(r,E=>console.error(`Conflict in settings file ${this._name}: ${E}`));return{contents:s,keys:v,overrides:a,restricted:f.restricted}}filter(r,i,p,f){if(!f?.scopes&&!f?.skipRestricted)return{raw:r,restricted:[]};const s={},v=[];for(let a in r)if(_.OVERRIDE_PROPERTY_REGEX.test(a)&&p){const E=this.filter(r[a],i,!1,f);s[a]=E.raw,v.push(...E.restricted)}else{const E=i[a],I=E?typeof E.scope!="undefined"?E.scope:3:void 0;E?.restricted&&v.push(a),(I===void 0||f.scopes===void 0||f.scopes.includes(I))&&(f.skipRestricted&&E?.restricted||(s[a]=r[a]))}return{raw:s,restricted:v}}toOverrides(r,i){const p=[];for(const f of Object.keys(r))if(_.OVERRIDE_PROPERTY_REGEX.test(f)){const s={};for(const v in r[f])s[v]=r[f][v];p.push({identifiers:(0,_.overrideIdentifiersFromKey)(f),keys:Object.keys(s),contents:(0,R.toValuesTree)(s,i)})}return p}}e.ConfigurationModelParser=d;class u extends P.Disposable{constructor(r,i,p,f){super();this.userSettingsResource=r,this.scopes=i,this.fileService=f,this._onDidChange=this._register(new F.Emitter),this.onDidChange=this._onDidChange.event,this.parser=new d(this.userSettingsResource.toString()),this.parseOptions={scopes:this.scopes},this._register(this.fileService.watch(p.dirname(this.userSettingsResource))),this._register(this.fileService.watch(this.userSettingsResource)),this._register(F.Event.filter(this.fileService.onDidFilesChange,s=>s.contains(this.userSettingsResource))(()=>this._onDidChange.fire()))}async loadConfiguration(){try{const r=await this.fileService.readFile(this.userSettingsResource);return this.parser.parse(r.value.toString()||"{}",this.parseOptions),this.parser.configurationModel}catch(r){return new m}}reparse(){return this.parser.reparse(this.parseOptions),this.parser.configurationModel}getRestrictedSettings(){return this.parser.restrictedConfigurations}}e.UserSettings=u;class S{constructor(r,i,p=new m,f=new m,s=new t.ResourceMap,v=new m,a=new t.ResourceMap,E=!0){this._defaultConfiguration=r,this._localUserConfiguration=i,this._remoteUserConfiguration=p,this._workspaceConfiguration=f,this._folderConfigurations=s,this._memoryConfiguration=v,this._memoryConfigurationByResource=a,this._freeze=E,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations=new t.ResourceMap,this._userConfiguration=null}getValue(r,i,p){return this.getConsolidateConfigurationModel(i,p).getValue(r)}updateValue(r,i,p={}){let f;p.resource?(f=this._memoryConfigurationByResource.get(p.resource),f||(f=new m,this._memoryConfigurationByResource.set(p.resource,f))):f=this._memoryConfiguration,i===void 0?f.removeValue(r):f.setValue(r,i),p.resource||(this._workspaceConsolidatedConfiguration=null)}inspect(r,i,p){const f=this.getConsolidateConfigurationModel(i,p),s=this.getFolderConfigurationModelForResource(i.resource,p),v=i.resource?this._memoryConfigurationByResource.get(i.resource)||this._memoryConfiguration:this._memoryConfiguration,a=i.overrideIdentifier?this._defaultConfiguration.freeze().override(i.overrideIdentifier).getValue(r):this._defaultConfiguration.freeze().getValue(r),E=i.overrideIdentifier?this.userConfiguration.freeze().override(i.overrideIdentifier).getValue(r):this.userConfiguration.freeze().getValue(r),I=i.overrideIdentifier?this.localUserConfiguration.freeze().override(i.overrideIdentifier).getValue(r):this.localUserConfiguration.freeze().getValue(r),D=i.overrideIdentifier?this.remoteUserConfiguration.freeze().override(i.overrideIdentifier).getValue(r):this.remoteUserConfiguration.freeze().getValue(r),B=p?i.overrideIdentifier?this._workspaceConfiguration.freeze().override(i.overrideIdentifier).getValue(r):this._workspaceConfiguration.freeze().getValue(r):void 0,L=s?i.overrideIdentifier?s.freeze().override(i.overrideIdentifier).getValue(r):s.freeze().getValue(r):void 0,y=i.overrideIdentifier?v.override(i.overrideIdentifier).getValue(r):v.getValue(r),x=f.getValue(r),N=c.distinct(c.flatten(f.overrides.map(z=>z.identifiers))).filter(z=>f.getOverrideValue(r,z)!==void 0);return{defaultValue:a,userValue:E,userLocalValue:I,userRemoteValue:D,workspaceValue:B,workspaceFolderValue:L,memoryValue:y,value:x,default:a!==void 0?{value:this._defaultConfiguration.freeze().getValue(r),override:i.overrideIdentifier?this._defaultConfiguration.freeze().getOverrideValue(r,i.overrideIdentifier):void 0}:void 0,user:E!==void 0?{value:this.userConfiguration.freeze().getValue(r),override:i.overrideIdentifier?this.userConfiguration.freeze().getOverrideValue(r,i.overrideIdentifier):void 0}:void 0,userLocal:I!==void 0?{value:this.localUserConfiguration.freeze().getValue(r),override:i.overrideIdentifier?this.localUserConfiguration.freeze().getOverrideValue(r,i.overrideIdentifier):void 0}:void 0,userRemote:D!==void 0?{value:this.remoteUserConfiguration.freeze().getValue(r),override:i.overrideIdentifier?this.remoteUserConfiguration.freeze().getOverrideValue(r,i.overrideIdentifier):void 0}:void 0,workspace:B!==void 0?{value:this._workspaceConfiguration.freeze().getValue(r),override:i.overrideIdentifier?this._workspaceConfiguration.freeze().getOverrideValue(r,i.overrideIdentifier):void 0}:void 0,workspaceFolder:L!==void 0?{value:s?.freeze().getValue(r),override:i.overrideIdentifier?s?.freeze().getOverrideValue(r,i.overrideIdentifier):void 0}:void 0,memory:y!==void 0?{value:v.getValue(r),override:i.overrideIdentifier?v.getOverrideValue(r,i.overrideIdentifier):void 0}:void 0,overrideIdentifiers:N.length?N:void 0}}keys(r){const i=this.getFolderConfigurationModelForResource(void 0,r);return{default:this._defaultConfiguration.freeze().keys,user:this.userConfiguration.freeze().keys,workspace:this._workspaceConfiguration.freeze().keys,workspaceFolder:i?i.freeze().keys:[]}}updateDefaultConfiguration(r){this._defaultConfiguration=r,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateLocalUserConfiguration(r){this._localUserConfiguration=r,this._userConfiguration=null,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateRemoteUserConfiguration(r){this._remoteUserConfiguration=r,this._userConfiguration=null,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateWorkspaceConfiguration(r){this._workspaceConfiguration=r,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateFolderConfiguration(r,i){this._folderConfigurations.set(r,i),this._foldersConsolidatedConfigurations.delete(r)}deleteFolderConfiguration(r){this.folderConfigurations.delete(r),this._foldersConsolidatedConfigurations.delete(r)}compareAndUpdateDefaultConfiguration(r,i){const p=[];if(!i){const{added:f,updated:s,removed:v}=A(this._defaultConfiguration,r);i=[...f,...s,...v]}for(const f of i)for(const s of(0,_.overrideIdentifiersFromKey)(f)){const v=this._defaultConfiguration.getKeysForOverrideIdentifier(s),a=r.getKeysForOverrideIdentifier(s),E=[...a.filter(I=>v.indexOf(I)===-1),...v.filter(I=>a.indexOf(I)===-1),...v.filter(I=>!T.equals(this._defaultConfiguration.override(s).getValue(I),r.override(s).getValue(I)))];p.push([s,E])}return this.updateDefaultConfiguration(r),{keys:i,overrides:p}}compareAndUpdateLocalUserConfiguration(r){const{added:i,updated:p,removed:f,overrides:s}=A(this.localUserConfiguration,r),v=[...i,...p,...f];return v.length&&this.updateLocalUserConfiguration(r),{keys:v,overrides:s}}compareAndUpdateRemoteUserConfiguration(r){const{added:i,updated:p,removed:f,overrides:s}=A(this.remoteUserConfiguration,r);let v=[...i,...p,...f];return v.length&&this.updateRemoteUserConfiguration(r),{keys:v,overrides:s}}compareAndUpdateWorkspaceConfiguration(r){const{added:i,updated:p,removed:f,overrides:s}=A(this.workspaceConfiguration,r);let v=[...i,...p,...f];return v.length&&this.updateWorkspaceConfiguration(r),{keys:v,overrides:s}}compareAndUpdateFolderConfiguration(r,i){const p=this.folderConfigurations.get(r),{added:f,updated:s,removed:v,overrides:a}=A(p,i);let E=[...f,...s,...v];return(E.length||!p)&&this.updateFolderConfiguration(r,i),{keys:E,overrides:a}}compareAndDeleteFolderConfiguration(r){const i=this.folderConfigurations.get(r);if(!i)throw new Error("Unknown folder");this.deleteFolderConfiguration(r);const{added:p,updated:f,removed:s,overrides:v}=A(i,void 0);return{keys:[...p,...f,...s],overrides:v}}get defaults(){return this._defaultConfiguration}get userConfiguration(){return this._userConfiguration||(this._userConfiguration=this._remoteUserConfiguration.isEmpty()?this._localUserConfiguration:this._localUserConfiguration.merge(this._remoteUserConfiguration),this._freeze&&this._userConfiguration.freeze()),this._userConfiguration}get localUserConfiguration(){return this._localUserConfiguration}get remoteUserConfiguration(){return this._remoteUserConfiguration}get workspaceConfiguration(){return this._workspaceConfiguration}get folderConfigurations(){return this._folderConfigurations}getConsolidateConfigurationModel(r,i){let p=this.getConsolidatedConfigurationModelForResource(r,i);return r.overrideIdentifier?p.override(r.overrideIdentifier):p}getConsolidatedConfigurationModelForResource({resource:r},i){let p=this.getWorkspaceConsolidatedConfiguration();if(i&&r){const f=i.getFolder(r);f&&(p=this.getFolderConsolidatedConfiguration(f.uri)||p);const s=this._memoryConfigurationByResource.get(r);s&&(p=p.merge(s))}return p}getWorkspaceConsolidatedConfiguration(){return this._workspaceConsolidatedConfiguration||(this._workspaceConsolidatedConfiguration=this._defaultConfiguration.merge(this.userConfiguration,this._workspaceConfiguration,this._memoryConfiguration),this._freeze&&(this._workspaceConfiguration=this._workspaceConfiguration.freeze())),this._workspaceConsolidatedConfiguration}getFolderConsolidatedConfiguration(r){let i=this._foldersConsolidatedConfigurations.get(r);if(!i){const p=this.getWorkspaceConsolidatedConfiguration(),f=this._folderConfigurations.get(r);f?(i=p.merge(f),this._freeze&&(i=i.freeze()),this._foldersConsolidatedConfigurations.set(r,i)):i=p}return i}getFolderConfigurationModelForResource(r,i){if(i&&r){const p=i.getFolder(r);if(p)return this._folderConfigurations.get(p.uri)}}toData(){return{defaults:{contents:this._defaultConfiguration.contents,overrides:this._defaultConfiguration.overrides,keys:this._defaultConfiguration.keys},user:{contents:this.userConfiguration.contents,overrides:this.userConfiguration.overrides,keys:this.userConfiguration.keys},workspace:{contents:this._workspaceConfiguration.contents,overrides:this._workspaceConfiguration.overrides,keys:this._workspaceConfiguration.keys},folders:[...this._folderConfigurations.keys()].reduce((r,i)=>{const{contents:p,overrides:f,keys:s}=this._folderConfigurations.get(i);return r.push([i,{contents:p,overrides:f,keys:s}]),r},[])}}allKeys(){const r=new Set;return this._defaultConfiguration.freeze().keys.forEach(i=>r.add(i)),this.userConfiguration.freeze().keys.forEach(i=>r.add(i)),this._workspaceConfiguration.freeze().keys.forEach(i=>r.add(i)),this._folderConfigurations.forEach(i=>i.freeze().keys.forEach(p=>r.add(p))),[...r.values()]}allOverrideIdentifiers(){const r=new Set;return this._defaultConfiguration.freeze().getAllOverrideIdentifiers().forEach(i=>r.add(i)),this.userConfiguration.freeze().getAllOverrideIdentifiers().forEach(i=>r.add(i)),this._workspaceConfiguration.freeze().getAllOverrideIdentifiers().forEach(i=>r.add(i)),this._folderConfigurations.forEach(i=>i.freeze().getAllOverrideIdentifiers().forEach(p=>r.add(p))),[...r.values()]}getAllKeysForOverrideIdentifier(r){const i=new Set;return this._defaultConfiguration.getKeysForOverrideIdentifier(r).forEach(p=>i.add(p)),this.userConfiguration.getKeysForOverrideIdentifier(r).forEach(p=>i.add(p)),this._workspaceConfiguration.getKeysForOverrideIdentifier(r).forEach(p=>i.add(p)),this._folderConfigurations.forEach(p=>p.getKeysForOverrideIdentifier(r).forEach(f=>i.add(f))),[...i.values()]}static parse(r){const i=this.parseConfigurationModel(r.defaults),p=this.parseConfigurationModel(r.user),f=this.parseConfigurationModel(r.workspace),s=r.folders.reduce((v,a)=>(v.set(k.URI.revive(a[0]),this.parseConfigurationModel(a[1])),v),new t.ResourceMap);return new S(i,p,new m,f,s,new m,new t.ResourceMap,!1)}static parseConfigurationModel(r){return new m(r.contents,r.keys,r.overrides).freeze()}}e.Configuration=S;function b(...M){if(M.length===0)return{keys:[],overrides:[]};if(M.length===1)return M[0];const r=new Set,i=new Map;for(const f of M)f.keys.forEach(s=>r.add(s)),f.overrides.forEach(([s,v])=>{const a=(0,t.getOrSet)(i,s,new Set);v.forEach(E=>a.add(E))});const p=[];return i.forEach((f,s)=>p.push([s,[...f.values()]])),{keys:[...r.values()],overrides:p}}e.mergeChanges=b;class h{constructor(r,i,p,f){this.change=r,this.previous=i,this.currentConfiguraiton=p,this.currentWorkspace=f,this._previousConfiguration=void 0;const s=new Set;r.keys.forEach(a=>s.add(a)),r.overrides.forEach(([,a])=>a.forEach(E=>s.add(E))),this.affectedKeys=[...s.values()];const v=new m;this.affectedKeys.forEach(a=>v.setValue(a,{})),this.affectedKeysTree=v.contents}get previousConfiguration(){return!this._previousConfiguration&&this.previous&&(this._previousConfiguration=S.parse(this.previous.data)),this._previousConfiguration}affectsConfiguration(r,i){if(this.doesAffectedKeysTreeContains(this.affectedKeysTree,r)){if(i){const p=this.previousConfiguration?this.previousConfiguration.getValue(r,i,this.previous?.workspace):void 0,f=this.currentConfiguraiton.getValue(r,i,this.currentWorkspace);return!T.equals(p,f)}return!0}return!1}doesAffectedKeysTreeContains(r,i){let p=(0,R.toValuesTree)({[i]:!0},()=>{}),f;for(;typeof p=="object"&&(f=Object.keys(p)[0]);){if(r=r[f],!r)return!1;p=p[f]}return!0}}e.ConfigurationChangeEvent=h;class g extends h{constructor(r,i,p,f){super({keys:r.allKeys(),overrides:[]},void 0,r,i);this.source=p,this.sourceConfig=f}}e.AllKeysConfigurationChangeEvent=g;function A(M,r){const{added:i,removed:p,updated:f}=l(r,M),s=[],v=M?.getAllOverrideIdentifiers()||[],a=r?.getAllOverrideIdentifiers()||[];if(r){const E=a.filter(I=>!v.includes(I));for(const I of E)s.push([I,r.getKeysForOverrideIdentifier(I)])}if(M){const E=v.filter(I=>!a.includes(I));for(const I of E)s.push([I,M.getKeysForOverrideIdentifier(I)])}if(r&&M){for(const E of v)if(a.includes(E)){const I=l({contents:M.getOverrideValue(void 0,E)||{},keys:M.getKeysForOverrideIdentifier(E)},{contents:r.getOverrideValue(void 0,E)||{},keys:r.getKeysForOverrideIdentifier(E)});s.push([E,[...I.added,...I.removed,...I.updated]])}}return{added:i,removed:p,updated:f,overrides:s}}function l(M,r){const i=M?r?M.keys.filter(s=>r.keys.indexOf(s)===-1):[...M.keys]:[],p=r?M?r.keys.filter(s=>M.keys.indexOf(s)===-1):[...r.keys]:[],f=[];if(M&&r){for(const s of r.keys)if(M.keys.indexOf(s)!==-1){const v=(0,R.getConfigurationValue)(r.contents,s),a=(0,R.getConfigurationValue)(M.contents,s);T.equals(v,a)||f.push(s)}}return{added:i,removed:p,updated:f}}}),define(Ee[84],_e([0,1,4]),function(re,e,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RemoteAuthorityResolverError=e.RemoteAuthorityResolverErrorCode=e.IRemoteAuthorityResolverService=void 0,e.IRemoteAuthorityResolverService=(0,c.createDecorator)("remoteAuthorityResolverService");var F;(function(P){P.Unknown="Unknown",P.NotAvailable="NotAvailable",P.TemporarilyNotAvailable="TemporarilyNotAvailable",P.NoResolverFound="NoResolverFound"})(F=e.RemoteAuthorityResolverErrorCode||(e.RemoteAuthorityResolverErrorCode={}));class w extends Error{constructor(t,T=F.Unknown,C){super(t);this._message=t,this._code=T,this._detail=C,this.isHandled=T===F.NotAvailable&&C===!0,typeof Object.setPrototypeOf=="function"&&Object.setPrototypeOf(this,w.prototype)}static isTemporarilyNotAvailable(t){return t instanceof w&&t._code===F.TemporarilyNotAvailable}static isNoResolverFound(t){return t instanceof w&&t._code===F.NoResolverFound}static isHandled(t){return t instanceof w&&t.isHandled}}e.RemoteAuthorityResolverError=w}),define(Ee[61],_e([0,1,10]),function(re,e,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isVirtualWorkspace=e.getVirtualWorkspaceScheme=e.getVirtualWorkspaceLocation=e.isVirtualResource=e.getRemoteName=e.getRemoteAuthority=void 0;function F(k){return k.scheme===c.Schemas.vscodeRemote?k.authority:void 0}e.getRemoteAuthority=F;function w(k){if(!k)return;const R=k.indexOf("+");return R<0?k:k.substr(0,R)}e.getRemoteName=w;function P(k){return k.scheme!==c.Schemas.file&&k.scheme!==c.Schemas.vscodeRemote}e.isVirtualResource=P;function t(k){if(k.folders.length)return k.folders.every(R=>P(R.uri))?k.folders[0].uri:void 0;if(k.configuration&&P(k.configuration))return k.configuration}e.getVirtualWorkspaceLocation=t;function T(k){return t(k)?.scheme}e.getVirtualWorkspaceScheme=T;function C(k){return t(k)!==void 0}e.isVirtualWorkspace=C}),define(Ee[25],_e([0,1,9,4,61]),function(re,e,c,F,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IBuiltinExtensionsScannerService=e.isResolverExtension=e.isAuthenticationProviderExtension=e.isLanguagePackExtension=e.ExtensionIdentifier=e.ExtensionType=e.EXTENSION_CATEGORIES=e.isIExtensionIdentifier=e.getWorkspaceSupportTypeMessage=e.ALL_EXTENSION_KINDS=e.BUILTIN_MANIFEST_CACHE_FILE=e.USER_MANIFEST_CACHE_FILE=e.MANIFEST_CACHE_FOLDER=void 0,e.MANIFEST_CACHE_FOLDER="CachedExtensions",e.USER_MANIFEST_CACHE_FILE="user",e.BUILTIN_MANIFEST_CACHE_FILE="builtin",e.ALL_EXTENSION_KINDS=["ui","workspace","web"];function P(n){if(typeof n=="object"&&n!==null&&n.supported!==!0)return n.description}e.getWorkspaceSupportTypeMessage=P;function t(n){return n&&typeof n=="object"&&typeof n.id=="string"&&(!n.uuid||typeof n.uuid=="string")}e.isIExtensionIdentifier=t,e.EXTENSION_CATEGORIES=["Azure","Data Science","Debuggers","Extension Packs","Education","Formatters","Keymaps","Language Packs","Linters","Machine Learning","Notebooks","Programming Languages","SCM Providers","Snippets","Testing","Themes","Visualization","Other"];var T;(function(n){n[n.System=0]="System",n[n.User=1]="User"})(T=e.ExtensionType||(e.ExtensionType={}));class C{constructor(m){this.value=m,this._lower=m.toLowerCase()}static equals(m,o){if(typeof m=="undefined"||m===null)return typeof o=="undefined"||o===null;if(typeof o=="undefined"||o===null)return!1;if(typeof m=="string"||typeof o=="string"){let d=typeof m=="string"?m:m.value,u=typeof o=="string"?o:o.value;return c.equalsIgnoreCase(d,u)}return m._lower===o._lower}static toKey(m){return typeof m=="string"?m.toLowerCase():m._lower}}e.ExtensionIdentifier=C;function k(n){return n.contributes&&n.contributes.localizations?n.contributes.localizations.length>0:!1}e.isLanguagePackExtension=k;function R(n){return n.contributes&&n.contributes.authentication?n.contributes.authentication.length>0:!1}e.isAuthenticationProviderExtension=R;function _(n,m){if(m){const o=`onResolveRemoteAuthority:${(0,w.getRemoteName)(m)}`;return n.activationEvents?.indexOf(o)!==-1}return!1}e.isResolverExtension=_,e.IBuiltinExtensionsScannerService=(0,F.createDecorator)("IBuiltinExtensionsScannerService")}),define(Ee[143],_e([0,1,9,25]),function(re,e,c,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getExtensionDependencies=e.getMaliciousExtensionsSet=e.BetterMergeId=e.getGalleryExtensionTelemetryData=e.getLocalExtensionTelemetryData=e.groupByExtension=e.getGalleryExtensionId=e.adoptToGalleryExtensionId=e.getExtensionId=e.ExtensionIdentifierWithVersion=e.areSameExtensions=void 0;function w(o,d){return o.uuid&&d.uuid?o.uuid===d.uuid:o.id===d.id?!0:(0,c.compareIgnoreCase)(o.id,d.id)===0}e.areSameExtensions=w;class P{constructor(d,u){this.version=u,this.id=d.id,this.uuid=d.uuid}key(){return`${this.id}-${this.version}`}equals(d){return d instanceof P?w(this,d)&&this.version===d.version:!1}}e.ExtensionIdentifierWithVersion=P;function t(o,d){return`${o}.${d}`}e.getExtensionId=t;function T(o){return o.toLocaleLowerCase()}e.adoptToGalleryExtensionId=T;function C(o,d){return T(t(o,d))}e.getGalleryExtensionId=C;function k(o,d){const u=[],S=b=>{for(const h of u)if(h.some(g=>w(d(g),d(b))))return h;return null};for(const b of o){const h=S(b);h?h.push(b):u.push([b])}return u}e.groupByExtension=k;function R(o){return{id:o.identifier.id,name:o.manifest.name,galleryId:null,publisherId:o.publisherId,publisherName:o.manifest.publisher,publisherDisplayName:o.publisherDisplayName,dependencies:o.manifest.extensionDependencies&&o.manifest.extensionDependencies.length>0}}e.getLocalExtensionTelemetryData=R;function _(o){return{id:o.identifier.id,name:o.name,galleryId:o.identifier.uuid,publisherId:o.publisherId,publisherName:o.publisher,publisherDisplayName:o.publisherDisplayName,isPreReleaseVersion:o.properties.isPreReleaseVersion,dependencies:!!(o.properties.dependencies&&o.properties.dependencies.length>0),...o.telemetryData}}e.getGalleryExtensionTelemetryData=_,e.BetterMergeId=new F.ExtensionIdentifier("pprice.better-merge");function n(o){const d=new Set;if(o.malicious)for(const u of o.malicious)d.add(u.id);return d}e.getMaliciousExtensionsSet=n;function m(o,d){const u=[],S=d.manifest.extensionDependencies?.slice(0)??[];for(;S.length;){const b=S.shift();if(b&&u.every(h=>!w(h.identifier,{id:b}))){const h=o.filter(g=>w(g.identifier,{id:b}));h.length===1&&(u.push(h[0]),S.push(...h[0].manifest.extensionDependencies?.slice(0)??[]))}}return u}e.getExtensionDependencies=m}),define(Ee[144],_e([0,1,3,23,4,12]),function(re,e,c,F,w,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractTunnelService=e.isPortPrivileged=e.isAllInterfaces=e.ALL_INTERFACES_ADDRESSES=e.isLocalhost=e.LOCALHOST_ADDRESSES=e.extractLocalHostUriMetaDataForPortMapping=e.ProvidedOnAutoForward=e.TunnelPrivacyId=e.TunnelProtocol=e.ISharedTunnelsService=e.ITunnelService=void 0,e.ITunnelService=(0,w.createDecorator)("tunnelService"),e.ISharedTunnelsService=(0,w.createDecorator)("sharedTunnelsService");var t;(function(o){o.Http="http",o.Https="https"})(t=e.TunnelProtocol||(e.TunnelProtocol={}));var T;(function(o){o.ConstantPrivate="constantPrivate",o.Private="private",o.Public="public"})(T=e.TunnelPrivacyId||(e.TunnelPrivacyId={}));var C;(function(o){o[o.Notify=1]="Notify",o[o.OpenBrowser=2]="OpenBrowser",o[o.OpenPreview=3]="OpenPreview",o[o.Silent=4]="Silent",o[o.Ignore=5]="Ignore",o[o.OpenBrowserOnce=6]="OpenBrowserOnce"})(C=e.ProvidedOnAutoForward||(e.ProvidedOnAutoForward={}));function k(o){if(o.scheme!=="http"&&o.scheme!=="https")return;const d=/^(localhost|127\.0\.0\.1|0\.0\.0\.0):(\d+)$/.exec(o.authority);if(!!d)return{address:d[1],port:+d[2]}}e.extractLocalHostUriMetaDataForPortMapping=k,e.LOCALHOST_ADDRESSES=["localhost","127.0.0.1","0:0:0:0:0:0:0:1","::1"];function R(o){return e.LOCALHOST_ADDRESSES.indexOf(o)>=0}e.isLocalhost=R,e.ALL_INTERFACES_ADDRESSES=["0.0.0.0","0:0:0:0:0:0:0:0","::"];function _(o){return e.ALL_INTERFACES_ADDRESSES.indexOf(o)>=0}e.isAllInterfaces=_;function n(o,d){return d?d!==1&&o<1024:!F.isWindows&&o<1024}e.isPortPrivileged=n;let m=class{constructor(d){this.logService=d,this._onTunnelOpened=new c.Emitter,this.onTunnelOpened=this._onTunnelOpened.event,this._onTunnelClosed=new c.Emitter,this.onTunnelClosed=this._onTunnelClosed.event,this._onAddedTunnelProvider=new c.Emitter,this.onAddedTunnelProvider=this._onAddedTunnelProvider.event,this._tunnels=new Map,this._canElevate=!1,this._privacyOptions=[]}get hasTunnelProvider(){return!!this._tunnelProvider}setTunnelProvider(d,u){return this._tunnelProvider=d,d?(this._canElevate=u.elevation,this._privacyOptions=u.privacyOptions,this._onAddedTunnelProvider.fire(),{dispose:()=>{this._tunnelProvider=void 0,this._canElevate=!1,this._privacyOptions=[]}}):(this._canElevate=!1,this._privacyOptions=[],this._onAddedTunnelProvider.fire(),{dispose:()=>{}})}get canElevate(){return this._canElevate}get canChangePrivacy(){return this._privacyOptions.length>0}get privacyOptions(){return this._privacyOptions}get tunnels(){return this.getTunnels()}async getTunnels(){const d=[],u=Array.from(this._tunnels.values());for(let S of u){const b=Array.from(S.values());for(let h of b){const g=await h.value;g&&d.push(g)}}return d}async dispose(){for(const d of this._tunnels.values()){for(const{value:u}of d.values())await u.then(S=>S?.dispose());d.clear()}this._tunnels.clear()}openTunnel(d,u,S,b,h=!1,g=T.Private,A){if(this.logService.trace(`ForwardedPorts: (TunnelService) openTunnel request for ${u}:${S} on local port ${b}.`),!d)return;u||(u="localhost");const l=this.retainOrCreateTunnel(d,u,S,b,h,g,A);return l?l.then(M=>{if(!M){this.logService.trace("ForwardedPorts: (TunnelService) New tunnel is undefined."),this.removeEmptyTunnelFromMap(u,S);return}this.logService.trace("ForwardedPorts: (TunnelService) New tunnel established.");const r=this.makeTunnel(M);return(M.tunnelRemoteHost!==u||M.tunnelRemotePort!==S)&&this.logService.warn("ForwardedPorts: (TunnelService) Created tunnel does not match requirements of requested tunnel. Host or port mismatch."),this._onTunnelOpened.fire(r),r}):(this.logService.trace("ForwardedPorts: (TunnelService) Tunnel was not created."),l)}makeTunnel(d){return{tunnelRemotePort:d.tunnelRemotePort,tunnelRemoteHost:d.tunnelRemoteHost,tunnelLocalPort:d.tunnelLocalPort,localAddress:d.localAddress,privacy:d.privacy,protocol:d.protocol,dispose:async()=>{this.logService.trace(`ForwardedPorts: (TunnelService) dispose request for ${d.tunnelRemoteHost}:${d.tunnelRemotePort} `);const u=this._tunnels.get(d.tunnelRemoteHost);if(u){const S=u.get(d.tunnelRemotePort);S&&(S.refcount--,await this.tryDisposeTunnel(d.tunnelRemoteHost,d.tunnelRemotePort,S))}}}}async tryDisposeTunnel(d,u,S){if(S.refcount<=0){this.logService.trace(`ForwardedPorts: (TunnelService) Tunnel is being disposed ${d}:${u}.`);const b=S.value.then(async h=>{h&&(await h.dispose(!0),this._onTunnelClosed.fire({host:h.tunnelRemoteHost,port:h.tunnelRemotePort}))});return this._tunnels.has(d)&&this._tunnels.get(d).delete(u),b}}async closeTunnel(d,u){this.logService.trace(`ForwardedPorts: (TunnelService) close request for ${d}:${u} `);const S=this._tunnels.get(d);if(S&&S.has(u)){const b=S.get(u);b.refcount=0,await this.tryDisposeTunnel(d,u,b)}}addTunnelToMap(d,u,S){this._tunnels.has(d)||this._tunnels.set(d,new Map),this._tunnels.get(d).set(u,{refcount:1,value:S})}async removeEmptyTunnelFromMap(d,u){const S=this._tunnels.get(d);S&&(await S.get(u)||S.delete(u),S.size===0&&this._tunnels.delete(d))}getTunnelFromMap(d,u){let S=[d];R(d)?(S.push(...e.LOCALHOST_ADDRESSES),S.push(...e.ALL_INTERFACES_ADDRESSES)):_(d)&&S.push(...e.ALL_INTERFACES_ADDRESSES);const b=S.map(h=>this._tunnels.get(h));for(const h of b){const g=h?.get(u);if(g)return g}}canTunnel(d){return!!k(d)}createWithProvider(d,u,S,b,h,g,A){this.logService.trace(`ForwardedPorts: (TunnelService) Creating tunnel with provider ${u}:${S} on local port ${b}.`);const M={elevationRequired:h?n(b===void 0?S:b):!1},r={remoteAddress:{host:u,port:S},localAddressPort:b,privacy:g,public:g!==T.Private,protocol:A},i=d.forwardPort(r,M);return this.logService.trace("ForwardedPorts: (TunnelService) Tunnel created by provider."),i&&this.addTunnelToMap(u,S,i),i}};m=Ue([$e(0,P.ILogService)],m),e.AbstractTunnelService=m}),define(Ee[145],_e([0,1]),function(re,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TerminalDataBufferer=void 0;class c{constructor(w){this._callback=w,this._terminalBufferMap=new Map}dispose(){for(const w of this._terminalBufferMap.values())w.dispose()}startBuffering(w,P,t=5){let T;return T=P(C=>{const k=typeof C=="string"?C:C.data;let R=this._terminalBufferMap.get(w);if(R){R.data.push(k);return}const _=setTimeout(()=>this.flushBuffer(w),t);R={data:[k],timeoutId:_,dispose:()=>{clearTimeout(_),this.flushBuffer(w),T.dispose()}},this._terminalBufferMap.set(w,R)}),T}stopBuffering(w){const P=this._terminalBufferMap.get(w);P&&P.dispose()}flushBuffer(w){const P=this._terminalBufferMap.get(w);P&&(this._terminalBufferMap.delete(w),this._callback(w,P.data.join("")))}}e.TerminalDataBufferer=c}),define(Ee[146],_e([0,1]),function(re,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ColorScheme=void 0;var c;(function(F){F.DARK="dark",F.LIGHT="light",F.HIGH_CONTRAST="hc"})(c=e.ColorScheme||(e.ColorScheme={}))}),define(Ee[62],_e([0,1,53,3,6,4,36,146]),function(re,e,c,F,w,P,t,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Themable=e.registerThemingParticipant=e.Extensions=e.getThemeTypeSelector=e.FolderThemeIcon=e.FileThemeIcon=e.ThemeIcon=e.themeColorFromId=e.ThemeColor=e.IThemeService=void 0,e.IThemeService=(0,P.createDecorator)("themeService");var C;(function(u){function S(b){return b&&typeof b=="object"&&typeof b.id=="string"}u.isThemeColor=S})(C=e.ThemeColor||(e.ThemeColor={}));function k(u){return{id:u}}e.themeColorFromId=k;var R;(function(u){function S(r){return r&&typeof r=="object"&&typeof r.id=="string"&&(typeof r.color=="undefined"||C.isThemeColor(r.color))}u.isThemeIcon=S;const b=new RegExp(`^\\$\\((${c.CSSIcon.iconNameExpression}(?:${c.CSSIcon.iconModifierExpression})?)\\)$`);function h(r){const i=b.exec(r);if(!i)return;let[,p]=i;return{id:p}}u.fromString=h;function g(r,i){let p=r.id;const f=p.lastIndexOf("~");return f!==-1&&(p=p.substring(0,f)),i&&(p=`${p}~${i}`),{id:p}}u.modify=g;function A(r){const i=r.id.lastIndexOf("~");if(i!==-1)return r.id.substring(i+1)}u.getModifier=A;function l(r,i){return r.id===i.id&&r.color?.id===i.color?.id}u.isEqual=l;function M(r,i){return{id:r.id,color:i?k(i):void 0}}u.asThemeIcon=M,u.asClassNameArray=c.CSSIcon.asClassNameArray,u.asClassName=c.CSSIcon.asClassName,u.asCSSSelector=c.CSSIcon.asCSSSelector})(R=e.ThemeIcon||(e.ThemeIcon={})),e.FileThemeIcon=c.Codicon.file,e.FolderThemeIcon=c.Codicon.folder;function _(u){switch(u){case T.ColorScheme.DARK:return"vs-dark";case T.ColorScheme.HIGH_CONTRAST:return"hc-black";default:return"vs"}}e.getThemeTypeSelector=_,e.Extensions={ThemingContribution:"base.contributions.theming"};class n{constructor(){this.themingParticipants=[],this.themingParticipants=[],this.onThemingParticipantAddedEmitter=new F.Emitter}onColorThemeChange(S){return this.themingParticipants.push(S),this.onThemingParticipantAddedEmitter.fire(S),(0,w.toDisposable)(()=>{const b=this.themingParticipants.indexOf(S);this.themingParticipants.splice(b,1)})}get onThemingParticipantAdded(){return this.onThemingParticipantAddedEmitter.event}getThemingParticipants(){return this.themingParticipants}}let m=new n;t.Registry.add(e.Extensions.ThemingContribution,m);function o(u){return m.onColorThemeChange(u)}e.registerThemingParticipant=o;class d extends w.Disposable{constructor(S){super();this.themeService=S,this.theme=S.getColorTheme(),this._register(this.themeService.onDidColorThemeChange(b=>this.onThemeChange(b)))}onThemeChange(S){this.theme=S,this.updateStyles()}updateStyles(){}getColor(S,b){let h=this.theme.getColor(S);return h&&b&&(h=b(h,this.theme)),h?h.toString():null}}e.Themable=d}),define(Ee[46],_e([0,1,21,24,2,4]),function(re,e,c,F,w,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toWorkspaceFolder=e.WorkspaceFolder=e.Workspace=e.isWorkspaceFolder=e.isWorkspace=e.WorkbenchState=e.IWorkspaceContextService=void 0,e.IWorkspaceContextService=(0,P.createDecorator)("contextService");var t;(function(n){n[n.EMPTY=1]="EMPTY",n[n.FOLDER=2]="FOLDER",n[n.WORKSPACE=3]="WORKSPACE"})(t=e.WorkbenchState||(e.WorkbenchState={}));function T(n){const m=n;return!!(m&&typeof m=="object"&&typeof m.id=="string"&&Array.isArray(m.folders))}e.isWorkspace=T;function C(n){const m=n;return!!(m&&typeof m=="object"&&w.URI.isUri(m.uri)&&typeof m.name=="string"&&typeof m.toResource=="function")}e.isWorkspaceFolder=C;class k{constructor(m,o,d,u,S){this._id=m,this._transient=d,this._configuration=u,this._ignorePathCasing=S,this._foldersMap=c.TernarySearchTree.forUris(this._ignorePathCasing),this.folders=o}update(m){this._id=m.id,this._configuration=m.configuration,this._transient=m.transient,this._ignorePathCasing=m._ignorePathCasing,this.folders=m.folders}get folders(){return this._folders}set folders(m){this._folders=m,this.updateFoldersMap()}get id(){return this._id}get transient(){return this._transient}get configuration(){return this._configuration}set configuration(m){this._configuration=m}getFolder(m){return m&&this._foldersMap.findSubstr(m.with({scheme:m.scheme,authority:m.authority,path:m.path}))||null}updateFoldersMap(){this._foldersMap=c.TernarySearchTree.forUris(this._ignorePathCasing);for(const m of this.folders)this._foldersMap.set(m.uri,m)}toJSON(){return{id:this.id,folders:this.folders,transient:this.transient,configuration:this.configuration}}}e.Workspace=k;class R{constructor(m,o){this.raw=o,this.uri=m.uri,this.index=m.index,this.name=m.name}toResource(m){return(0,F.joinPath)(this.uri,m)}toJSON(){return{uri:this.uri,name:this.name,index:this.index}}}e.WorkspaceFolder=R;function _(n){return new R({uri:n,index:0,name:(0,F.basenameOrAuthority)(n)},{uri:n.toString()})}e.toWorkspaceFolder=_}),define(Ee[63],_e([0,1]),function(re,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Cache=void 0;class c{constructor(w){this.id=w,this._data=new Map,this._idPool=1}add(w){const P=this._idPool++;return this._data.set(P,w),this.logDebugInfo(),P}get(w,P){return this._data.has(w)?this._data.get(w)[P]:void 0}delete(w){this._data.delete(w),this.logDebugInfo()}logDebugInfo(){!c.enableDebugLogging||console.log(`${this.id} cache size - ${this._data.size}`)}}e.Cache=c,c.enableDebugLogging=!1}),define(Ee[30],_e([0,1,10,24,4]),function(re,e,c,F,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostFileSystemInfo=e.ExtHostFileSystemInfo=void 0;class P{constructor(){this._systemSchemes=new Set(Object.keys(c.Schemas)),this._providerInfo=new Map,this.extUri=new F.ExtUri(T=>{const C=this._providerInfo.get(T.scheme);return!(C===void 0||C&1024)})}$acceptProviderInfos(T,C){C===null?this._providerInfo.delete(T):this._providerInfo.set(T,C)}isFreeScheme(T){return!this._providerInfo.has(T)&&!this._systemSchemes.has(T)}getCapabilities(T){return this._providerInfo.get(T)}}e.ExtHostFileSystemInfo=P,e.IExtHostFileSystemInfo=(0,w.createDecorator)("IExtHostFileSystemInfo")}),define(Ee[28],_e([0,1,4]),function(re,e,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostInitDataService=void 0,e.IExtHostInitDataService=(0,c.createDecorator)("IExtHostInitDataService")}),define(Ee[147],_e([0,1,14]),function(re,e,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionGlobalMemento=e.ExtensionMemento=void 0;class F{constructor(t,T,C){this._deferredPromises=new Map,this._id=t,this._shared=T,this._storage=C,this._init=this._storage.getValue(this._shared,this._id,Object.create(null)).then(k=>(this._value=k,this)),this._storageListener=this._storage.onDidChangeStorage(k=>{k.shared===this._shared&&k.key===this._id&&(this._value=k.value)}),this._scheduler=new c.RunOnceScheduler(()=>{const k=this._deferredPromises;this._deferredPromises=new Map,(async()=>{try{await this._storage.setValue(this._shared,this._id,this._value);for(const R of k.values())R.complete()}catch(R){for(const _ of k.values())_.error(R)}})()},0)}keys(){return Object.entries(this._value??{}).filter(([,t])=>t!==void 0).map(([t])=>t)}get whenReady(){return this._init}get(t,T){let C=this._value[t];return typeof C=="undefined"&&(C=T),C}update(t,T){this._value[t]=T;let C=this._deferredPromises.get(t);if(C!==void 0)return C.p;const k=new c.DeferredPromise;return this._deferredPromises.set(t,k),this._scheduler.isScheduled()||this._scheduler.schedule(),k.p}dispose(){this._storageListener.dispose()}}e.ExtensionMemento=F;class w extends F{constructor(t,T){super(t.identifier.value,!0,T);this._extension=t}setKeysForSync(t){this._storage.registerExtensionStorageKeysToSync({id:this._id,version:this._extension.version},t)}}e.ExtensionGlobalMemento=w}),define(Ee[148],_e([0,1,3,2,12]),function(re,e,c,F,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookDocuments=void 0;let P=class{constructor(T,C){this._logService=T,this._notebooksAndEditors=C,this._onDidChangeNotebookDocumentMetadata=new c.Emitter,this.onDidChangeNotebookDocumentMetadata=this._onDidChangeNotebookDocumentMetadata.event,this._onDidSaveNotebookDocument=new c.Emitter,this.onDidSaveNotebookDocument=this._onDidSaveNotebookDocument.event}$acceptModelChanged(T,C,k){this._notebooksAndEditors.getNotebookDocument(F.URI.revive(T)).acceptModelChanged(C.value,k)}$acceptDirtyStateChanged(T,C){this._notebooksAndEditors.getNotebookDocument(F.URI.revive(T)).acceptDirty(C)}$acceptModelSaved(T){const C=this._notebooksAndEditors.getNotebookDocument(F.URI.revive(T));this._onDidSaveNotebookDocument.fire(C.apiNotebook)}$acceptDocumentPropertiesChanged(T,C){this._logService.debug("ExtHostNotebook#$acceptDocumentPropertiesChanged",T.path,C);const k=this._notebooksAndEditors.getNotebookDocument(F.URI.revive(T));k.acceptDocumentPropertiesChanged(C),C.metadata&&this._onDidChangeNotebookDocumentMetadata.fire({document:k.apiNotebook})}};P=Ue([$e(0,w.ILogService)],P),e.ExtHostNotebookDocuments=P}),define(Ee[13],_e([0,1,4]),function(re,e,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostRpcService=e.IExtHostRpcService=void 0,e.IExtHostRpcService=(0,c.createDecorator)("IExtHostRpcService");class F{constructor(P){this.getProxy=P.getProxy.bind(P),this.set=P.set.bind(P),this.assertRegistered=P.assertRegistered.bind(P),this.drain=P.drain.bind(P)}}e.ExtHostRpcService=F});var Ze=this&&this.__classPrivateFieldSet||function(re,e,c,F,w){if(F==="m")throw new TypeError("Private method is not writable");if(F==="a"&&!w)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?re!==e||!w:!e.has(re))throw new TypeError("Cannot write private member to an object whose class did not declare it");return F==="a"?w.call(re,c):w?w.value=c:e.set(re,c),c},Te=this&&this.__classPrivateFieldGet||function(re,e,c,F){if(c==="a"&&!F)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?re!==e||!F:!e.has(re))throw new TypeError("Cannot read private member from an object whose class did not declare it");return c==="m"?F:c==="a"?F.call(re):F?F.value:e.get(re)};define(Ee[149],_e([0,1,25,3]),function(re,e,c,F){"use strict";var w;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionSecrets=void 0;class P{constructor(T,C){w.set(this,void 0),this._onDidChange=new F.Emitter,this.onDidChange=this._onDidChange.event,this._id=c.ExtensionIdentifier.toKey(T.identifier),Ze(this,w,C,"f"),Te(this,w,"f").onDidChangePassword(k=>{k.extensionId===this._id&&this._onDidChange.fire({key:k.key})})}get(T){return Te(this,w,"f").get(this._id,T)}store(T,C){return Te(this,w,"f").store(this._id,T,C)}delete(T){return Te(this,w,"f").delete(this._id,T)}}e.ExtensionSecrets=P,w=new WeakMap}),define(Ee[85],_e([0,1,4,3]),function(re,e,c,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostTelemetry=e.ExtHostTelemetry=void 0;class w{constructor(){this._onDidChangeTelemetryEnabled=new F.Emitter,this.onDidChangeTelemetryEnabled=this._onDidChangeTelemetryEnabled.event,this._enabled=!1}getTelemetryEnabled(){return this._enabled}$initializeTelemetryEnabled(t){this._enabled=t}$onDidChangeTelemetryEnabled(t){this._enabled=t,this._onDidChangeTelemetryEnabled.fire(t)}}e.ExtHostTelemetry=w,e.IExtHostTelemetry=(0,c.createDecorator)("IExtHostTelemetry")}),define(Ee[47],_e([0,1]),function(re,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TestItemRootImpl=e.TestItemImpl=e.MixedTestItemController=e.InvalidTestItemError=e.DuplicateTestItemError=e.diffTestItems=e.getPrivateApiFor=e.createPrivateApiFor=e.ExtHostTestItemEventOp=void 0;var c;(function(b){b[b.Upsert=0]="Upsert",b[b.RemoveChild=1]="RemoveChild",b[b.Invalidated=2]="Invalidated",b[b.SetProp=3]="SetProp",b[b.Bulk=4]="Bulk"})(c=e.ExtHostTestItemEventOp||(e.ExtHostTestItemEventOp={}));const F=new WeakMap,w=(b,h)=>{const g={controllerId:h};return F.set(b,g),g};e.createPrivateApiFor=w;const P=b=>F.get(b);e.getPrivateApiFor=P;const t=(b,h,g,A)=>{let l=g;return{enumerable:!0,configurable:!1,get(){return l},set(M){if(!A(l,M)){const r=l;l=M,b.listener?.({op:3,key:h,value:M,previous:r})}}}},T=(b,h)=>b===h,C={range:(b,h)=>b===h?!0:!b||!h?!1:b.isEqual(h),label:T,description:T,busy:T,error:T,canResolveChildren:T,tags:(b,h)=>!(b.length!==h.length||b.some(g=>!h.find(A=>g.id===A.id)))},k=Object.keys(C),R=(b,h)=>({range:t(b,"range",void 0,C.range),label:t(b,"label",h,C.label),description:t(b,"description",void 0,C.description),canResolveChildren:t(b,"canResolveChildren",!1,C.canResolveChildren),busy:t(b,"busy",!1,C.busy),error:t(b,"error",void 0,C.error),tags:t(b,"tags",[],C.tags)}),_=(b,h)=>{const g=new Map;for(const A of k)C[A](b[A],h[A])||g.set(A,h[A]);return g};e.diffTestItems=_;class n extends Error{constructor(h){super(`Attempted to insert a duplicate test item ID ${h}`)}}e.DuplicateTestItemError=n;class m extends Error{constructor(h){super(`TestItem with ID "${h}" is invalid. Make sure to create it from the createTestItem method.`)}}e.InvalidTestItemError=m;class o extends Error{constructor(h,g,A){super(`TestItem with ID "${h}" is from controller "${g}" and cannot be added as a child of an item from controller "${A}".`)}}e.MixedTestItemController=o;const d=b=>{const h=(0,e.getPrivateApiFor)(b);let g=new Map;return{get size(){return g.size},forEach(A,l){for(const M of g.values())A.call(l,M,this)},replace(A){const l=new Map,M=new Set(g.keys()),r={op:4,ops:[]};for(const i of A){if(!(i instanceof u))throw new m(i.id);const p=(0,e.getPrivateApiFor)(i).controllerId;if(p!==h.controllerId)throw new o(i.id,p,h.controllerId);if(l.has(i.id))throw new n(i.id);l.set(i.id,i),M.delete(i.id),r.ops.push({op:0,item:i})}for(const i of M.keys())r.ops.push({op:1,id:i});h.listener?.(r),g=l},add(A){if(!(A instanceof u))throw new m(A.id);g.set(A.id,A),h.listener?.({op:0,item:A})},delete(A){g.delete(A)&&h.listener?.({op:1,id:A})},get(A){return g.get(A)},toJSON(){return Array.from(g.values())},[Symbol.iterator](){return g.values()}}};class u{constructor(h,g,A,l){if(g.includes("\0"))throw new Error(`Test IDs may not include the ${JSON.stringify(g)} symbol`);const M=(0,e.createPrivateApiFor)(this,h);Object.defineProperties(this,{id:{value:g,enumerable:!0,writable:!1},uri:{value:l,enumerable:!0,writable:!1},parent:{enumerable:!1,get(){return M.parent instanceof S?void 0:M.parent}},children:{value:d(this),enumerable:!0,writable:!1},...R(M,A)})}invalidateResults(){(0,e.getPrivateApiFor)(this).listener?.({op:2})}}e.TestItemImpl=u;class S extends u{constructor(h,g){super(h,h,g,void 0)}}e.TestItemRootImpl=S}),define(Ee[64],_e([0,1,4,144,3,13]),function(re,e,c,F,w,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTunnelService=e.IExtHostTunnelService=e.TunnelDto=void 0;var t;(function(C){function k(_){return{remoteAddress:_.remoteAddress,localAddress:_.localAddress,public:!!_.public,privacy:_.privacy??(_.public?F.TunnelPrivacyId.Public:F.TunnelPrivacyId.Private),protocol:_.protocol}}C.fromApiTunnel=k;function R(_){return{remoteAddress:{host:_.tunnelRemoteHost,port:_.tunnelRemotePort},localAddress:_.localAddress,public:_.privacy!==F.TunnelPrivacyId.ConstantPrivate&&_.privacy!==F.TunnelPrivacyId.ConstantPrivate,privacy:_.privacy,protocol:_.protocol}}C.fromServiceTunnel=R})(t=e.TunnelDto||(e.TunnelDto={})),e.IExtHostTunnelService=(0,c.createDecorator)("IExtHostTunnelService");let T=class{constructor(k){this.onDidChangeTunnels=new w.Emitter().event}async $applyCandidateFilter(k){return k}async openTunnel(k,R){}async getTunnels(){return[]}async setTunnelExtensionFunctions(k){return{dispose:()=>{}}}registerPortsAttributesProvider(k,R){return{dispose:()=>{}}}async $providePortAttributes(k,R,_,n,m){return[]}async $forwardPort(k,R){}async $closeTunnel(k){}async $onDidTunnelsChange(){}async $registerCandidateFinder(){}};T=Ue([$e(0,P.IExtHostRpcService)],T),e.ExtHostTunnelService=T});var Ze=this&&this.__classPrivateFieldSet||function(re,e,c,F,w){if(F==="m")throw new TypeError("Private method is not writable");if(F==="a"&&!w)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?re!==e||!w:!e.has(re))throw new TypeError("Cannot write private member to an object whose class did not declare it");return F==="a"?w.call(re,c):w?w.value=c:e.set(re,c),c},Te=this&&this.__classPrivateFieldGet||function(re,e,c,F){if(c==="a"&&!F)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?re!==e||!F:!e.has(re))throw new TypeError("Cannot read private member from an object whose class did not declare it");return c==="m"?F:c==="a"?F.call(re):F?F.value:e.get(re)};define(Ee[7],_e([0,1,16,15,76,21,78,9,11,2,35,45,84]),function(re,e,c,F,w,P,t,T,C,k,R,_,n){"use strict";var m,o,d,u,S,b,h,g,A,l,M,r,i,p,f,s,v,a,E,I;Object.defineProperty(e,"__esModule",{value:!0}),e.TypeHierarchyItem=e.PortAutoForwardAction=e.WorkspaceTrustState=e.ExternalUriOpenerPriority=e.FunctionCoverage=e.BranchCoverage=e.StatementCoverage=e.FileCoverage=e.CoveredCount=e.TestTag=e.TestMessage=e.TestRunRequest=e.TestRunProfileKind=e.TestResultState=e.PortAttributes=e.LinkedEditingRanges=e.StandardTokenType=e.ExtensionRuntime=e.ExtensionMode=e.TimelineItem=e.NotebookRendererScript=e.NotebookControllerAffinity=e.NotebookCellStatusBarItem=e.NotebookEditorRevealType=e.NotebookCellStatusBarAlignment=e.NotebookCellExecutionState=e.NotebookCellKind=e.NotebookCellOutput=e.NotebookCellOutputItem=e.NotebookData=e.NotebookCellData=e.NotebookRange=e.ColorThemeKind=e.ColorTheme=e.FileDecoration=e.ExtensionKind=e.QuickPickItemKind=e.QuickInputButtons=e.DebugConfigurationProviderTriggerKind=e.DebugConsoleMode=e.SemanticTokensEdits=e.SemanticTokensEdit=e.SemanticTokens=e.SemanticTokensBuilder=e.SemanticTokensLegend=e.CommentMode=e.CommentThreadCollapsibleState=e.FoldingRangeKind=e.FoldingRange=e.FileSystemError=e.FileChangeType=e.InlineValueContext=e.InlineValueEvaluatableExpression=e.InlineValueVariableLookup=e.InlineValueText=e.InlineCompletionTriggerKind=e.EvaluatableExpression=e.DebugAdapterInlineImplementation=e.DebugAdapterNamedPipeServer=e.DebugAdapterServer=e.DebugAdapterExecutable=e.DataBreakpoint=e.FunctionBreakpoint=e.SourceBreakpoint=e.Breakpoint=e.RelativePattern=e.ConfigurationTarget=e.ThemeColor=e.ThemeIcon=e.TreeDataTransfer=e.TreeDataTransferItem=e.TreeItemCollapsibleState=e.TreeItem=e.ProgressLocation=e.Task=e.CustomExecution=e.TaskScope=e.ShellQuoting=e.ShellExecution=e.ProcessExecution=e.TaskGroup=e.TaskPanelKind=e.TaskRevealKind=e.TerminalProfile=e.TerminalLocation=e.TerminalLink=e.SourceControlInputBoxValidationType=e.ColorFormat=e.ColorPresentation=e.ColorInformation=e.Color=e.DocumentLink=e.DecorationRangeBehavior=e.TextDocumentChangeReason=e.TextEditorSelectionChangeKind=e.TextEditorRevealType=e.TextDocumentSaveReason=e.TextEditorLineNumbersStyle=e.StatusBarAlignment=e.ViewColumn=e.InlineSuggestions=e.InlineSuggestion=e.CompletionList=e.CompletionItem=e.CompletionItemTag=e.CompletionItemKind=e.CompletionTriggerKind=e.InlayHint=e.InlayHintKind=e.SignatureHelpTriggerKind=e.SignatureHelp=e.SignatureInformation=e.ParameterInformation=e.MarkdownString=e.CodeLens=e.LanguageStatusSeverity=e.CallHierarchyOutgoingCall=e.CallHierarchyIncomingCall=e.CallHierarchyItem=e.SelectionRange=e.CodeActionKind=e.CodeAction=e.CodeActionTriggerKind=e.DocumentSymbol=e.SymbolInformation=e.SymbolTag=e.SymbolKind=e.DocumentHighlight=e.DocumentHighlightKind=e.Hover=e.Diagnostic=e.DiagnosticRelatedInformation=e.Location=e.DiagnosticSeverity=e.DiagnosticTag=e.SnippetString=e.WorkspaceEdit=e.FileEditType=e.TextEdit=e.EnvironmentVariableMutatorType=e.EndOfLine=e.RemoteAuthorityResolverError=e.ResolvedAuthority=e.Selection=e.Range=e.Position=e.Disposable=void 0;function D(U){function O(){return Reflect.construct(U,arguments,this.constructor)}return Object.defineProperty(O,"name",Object.getOwnPropertyDescriptor(U,"name")),Object.setPrototypeOf(O,U),Object.setPrototypeOf(O.prototype,U.prototype),O}let B=S=class{constructor(O){m.set(this,void 0),Ze(this,m,O,"f")}static from(...O){let Z=O;return new S(function(){if(Z){for(const ye of Z)ye&&typeof ye.dispose=="function"&&ye.dispose();Z=void 0}})}dispose(){typeof Te(this,m,"f")=="function"&&(Te(this,m,"f").call(this),Ze(this,m,void 0,"f"))}};m=new WeakMap,B=S=Ue([D],B),e.Disposable=B;let L=b=class{constructor(O,Z){if(O<0)throw(0,F.illegalArgument)("line must be non-negative");if(Z<0)throw(0,F.illegalArgument)("character must be non-negative");this._line=O,this._character=Z}static Min(...O){if(O.length===0)throw new TypeError;let Z=O[0];for(let ye=1;ye<O.length;ye++){const je=O[ye];je.isBefore(Z)&&(Z=je)}return Z}static Max(...O){if(O.length===0)throw new TypeError;let Z=O[0];for(let ye=1;ye<O.length;ye++){const je=O[ye];je.isAfter(Z)&&(Z=je)}return Z}static isPosition(O){if(!O)return!1;if(O instanceof b)return!0;let{line:Z,character:ye}=O;return typeof Z=="number"&&typeof ye=="number"}get line(){return this._line}get character(){return this._character}isBefore(O){return this._line<O._line?!0:O._line<this._line?!1:this._character<O._character}isBeforeOrEqual(O){return this._line<O._line?!0:O._line<this._line?!1:this._character<=O._character}isAfter(O){return!this.isBeforeOrEqual(O)}isAfterOrEqual(O){return!this.isBefore(O)}isEqual(O){return this._line===O._line&&this._character===O._character}compareTo(O){return this._line<O._line?-1:this._line>O.line?1:this._character<O._character?-1:this._character>O._character?1:0}translate(O,Z=0){if(O===null||Z===null)throw(0,F.illegalArgument)();let ye;return typeof O=="undefined"?ye=0:typeof O=="number"?ye=O:(ye=typeof O.lineDelta=="number"?O.lineDelta:0,Z=typeof O.characterDelta=="number"?O.characterDelta:0),ye===0&&Z===0?this:new b(this.line+ye,this.character+Z)}with(O,Z=this.character){if(O===null||Z===null)throw(0,F.illegalArgument)();let ye;return typeof O=="undefined"?ye=this.line:typeof O=="number"?ye=O:(ye=typeof O.line=="number"?O.line:this.line,Z=typeof O.character=="number"?O.character:this.character),ye===this.line&&Z===this.character?this:new b(ye,Z)}toJSON(){return{line:this.line,character:this.character}}};L=b=Ue([D],L),e.Position=L;let y=h=class{constructor(O,Z,ye,je){let tt,at;if(typeof O=="number"&&typeof Z=="number"&&typeof ye=="number"&&typeof je=="number"?(tt=new L(O,Z),at=new L(ye,je)):O instanceof L&&Z instanceof L&&(tt=O,at=Z),!tt||!at)throw new Error("Invalid arguments");tt.isBefore(at)?(this._start=tt,this._end=at):(this._start=at,this._end=tt)}static isRange(O){return O instanceof h?!0:O?L.isPosition(O.start)&&L.isPosition(O.end):!1}get start(){return this._start}get end(){return this._end}contains(O){return O instanceof h?this.contains(O._start)&&this.contains(O._end):O instanceof L?!(O.isBefore(this._start)||this._end.isBefore(O)):!1}isEqual(O){return this._start.isEqual(O._start)&&this._end.isEqual(O._end)}intersection(O){const Z=L.Max(O.start,this._start),ye=L.Min(O.end,this._end);if(!Z.isAfter(ye))return new h(Z,ye)}union(O){if(this.contains(O))return this;if(O.contains(this))return O;const Z=L.Min(O.start,this._start),ye=L.Max(O.end,this.end);return new h(Z,ye)}get isEmpty(){return this._start.isEqual(this._end)}get isSingleLine(){return this._start.line===this._end.line}with(O,Z=this.end){if(O===null||Z===null)throw(0,F.illegalArgument)();let ye;return O?L.isPosition(O)?ye=O:(ye=O.start||this.start,Z=O.end||this.end):ye=this.start,ye.isEqual(this._start)&&Z.isEqual(this.end)?this:new h(ye,Z)}toJSON(){return[this.start,this.end]}};y=h=Ue([D],y),e.Range=y;let x=g=class extends y{constructor(O,Z,ye,je){let tt,at;if(typeof O=="number"&&typeof Z=="number"&&typeof ye=="number"&&typeof je=="number"?(tt=new L(O,Z),at=new L(ye,je)):O instanceof L&&Z instanceof L&&(tt=O,at=Z),!tt||!at)throw new Error("Invalid arguments");super(tt,at);this._anchor=tt,this._active=at}static isSelection(O){return O instanceof g?!0:O?y.isRange(O)&&L.isPosition(O.anchor)&&L.isPosition(O.active)&&typeof O.isReversed=="boolean":!1}get anchor(){return this._anchor}get active(){return this._active}get isReversed(){return this._anchor===this._end}toJSON(){return{start:this.start,end:this.end,active:this.active,anchor:this.anchor}}};x=g=Ue([D],x),e.Selection=x;class N{constructor(O,Z,ye){if(typeof O!="string"||O.length===0)throw(0,F.illegalArgument)("host");if(typeof Z!="number"||Z===0||Math.round(Z)!==Z)throw(0,F.illegalArgument)("port");if(typeof ye!="undefined"&&(typeof ye!="string"||ye.length===0||!/^[0-9A-Za-z\-]+$/.test(ye)))throw(0,F.illegalArgument)("connectionToken");this.host=O,this.port=Math.round(Z),this.connectionToken=ye}}e.ResolvedAuthority=N;class z extends Error{constructor(O,Z=n.RemoteAuthorityResolverErrorCode.Unknown,ye){super(O);this._message=O,this._code=Z,this._detail=ye,typeof Object.setPrototypeOf=="function"&&Object.setPrototypeOf(this,z.prototype)}static NotAvailable(O,Z){return new z(O,n.RemoteAuthorityResolverErrorCode.NotAvailable,Z)}static TemporarilyNotAvailable(O){return new z(O,n.RemoteAuthorityResolverErrorCode.TemporarilyNotAvailable)}}e.RemoteAuthorityResolverError=z;var H;(function(U){U[U.LF=1]="LF",U[U.CRLF=2]="CRLF"})(H=e.EndOfLine||(e.EndOfLine={}));var q;(function(U){U[U.Replace=1]="Replace",U[U.Append=2]="Append",U[U.Prepend=3]="Prepend"})(q=e.EnvironmentVariableMutatorType||(e.EnvironmentVariableMutatorType={}));let ue=A=class{constructor(O,Z){this._range=O,this._newText=Z}static isTextEdit(O){return O instanceof A?!0:O?y.isRange(O)&&typeof O.newText=="string":!1}static replace(O,Z){return new A(O,Z)}static insert(O,Z){return A.replace(new y(O,O),Z)}static delete(O){return A.replace(O,"")}static setEndOfLine(O){const Z=new A(new y(new L(0,0),new L(0,0)),"");return Z.newEol=O,Z}get range(){return this._range}set range(O){if(O&&!y.isRange(O))throw(0,F.illegalArgument)("range");this._range=O}get newText(){return this._newText||""}set newText(O){if(O&&typeof O!="string")throw(0,F.illegalArgument)("newText");this._newText=O}get newEol(){return this._newEol}set newEol(O){if(O&&typeof O!="number")throw(0,F.illegalArgument)("newEol");this._newEol=O}toJSON(){return{range:this.range,newText:this.newText,newEol:this._newEol}}};ue=A=Ue([D],ue),e.TextEdit=ue;var K;(function(U){U[U.File=1]="File",U[U.Text=2]="Text",U[U.Cell=3]="Cell",U[U.CellReplace=5]="CellReplace"})(K=e.FileEditType||(e.FileEditType={}));let ce=class{constructor(){this._edits=[]}_allEntries(){return this._edits}renameFile(O,Z,ye,je){this._edits.push({_type:1,from:O,to:Z,options:ye,metadata:je})}createFile(O,Z,ye){this._edits.push({_type:1,from:void 0,to:O,options:Z,metadata:ye})}deleteFile(O,Z,ye){this._edits.push({_type:1,from:O,to:void 0,options:Z,metadata:ye})}replaceNotebookMetadata(O,Z,ye){this._edits.push({_type:3,metadata:ye,uri:O,edit:{editType:5,metadata:Z},notebookMetadata:Z})}replaceNotebookCells(O,Z,ye,je,tt){let at,dt,kt=[],Rt;if(Ae.isNotebookRange(Z)&&Ut.isNotebookCellDataArray(ye)&&!Ut.isNotebookCellDataArray(je)?(at=Z.start,dt=Z.end,kt=ye,Rt=je):typeof Z=="number"&&typeof ye=="number"&&Ut.isNotebookCellDataArray(je)&&(at=Z,dt=ye,kt=je,Rt=tt),at===void 0||dt===void 0)throw new Error("Invalid arguments");(at!==dt||kt.length>0)&&this._edits.push({_type:5,uri:O,index:at,count:dt-at,cells:kt,metadata:Rt})}replaceNotebookCellMetadata(O,Z,ye,je){this._edits.push({_type:3,metadata:je,uri:O,edit:{editType:8,index:Z,metadata:ye}})}replace(O,Z,ye,je){this._edits.push({_type:2,uri:O,edit:new ue(Z,ye),metadata:je})}insert(O,Z,ye,je){this.replace(O,new y(Z,Z),ye,je)}delete(O,Z,ye){this.replace(O,Z,"",ye)}has(O){return this._edits.some(Z=>Z._type===2&&Z.uri.toString()===O.toString())}set(O,Z){if(Z)for(const ye of Z)ye&&this._edits.push({_type:2,uri:O,edit:ye});else{for(let ye=0;ye<this._edits.length;ye++){const je=this._edits[ye];je._type===2&&je.uri.toString()===O.toString()&&(this._edits[ye]=void 0)}(0,c.coalesceInPlace)(this._edits)}}get(O){const Z=[];for(let ye of this._edits)ye._type===2&&ye.uri.toString()===O.toString()&&Z.push(ye.edit);return Z}entries(){const O=new P.ResourceMap;for(let Z of this._edits)if(Z._type===2){let ye=O.get(Z.uri);ye||(ye=[Z.uri,[]],O.set(Z.uri,ye)),ye[1].push(Z.edit)}return[...O.values()]}get size(){return this.entries().length}toJSON(){return this.entries()}};ce=Ue([D],ce),e.WorkspaceEdit=ce;let de=l=class{constructor(O){this._tabstop=1,this.value=O||""}static isSnippetString(O){return O instanceof l?!0:O?typeof O.value=="string":!1}static _escape(O){return O.replace(/\$|}|\\/g,"\\$&")}appendText(O){return this.value+=l._escape(O),this}appendTabstop(O=this._tabstop++){return this.value+="$",this.value+=O,this}appendPlaceholder(O,Z=this._tabstop++){if(typeof O=="function"){const ye=new l;ye._tabstop=this._tabstop,O(ye),this._tabstop=ye._tabstop,O=ye.value}else O=l._escape(O);return this.value+="${",this.value+=Z,this.value+=":",this.value+=O,this.value+="}",this}appendChoice(O,Z=this._tabstop++){const ye=O.map(je=>je.replace(/\$|}|\\|,/g,"\\$&")).join(",");return this.value+="${",this.value+=Z,this.value+="|",this.value+=ye,this.value+="|}",this}appendVariable(O,Z){if(typeof Z=="function"){const ye=new l;ye._tabstop=this._tabstop,Z(ye),this._tabstop=ye._tabstop,Z=ye.value}else typeof Z=="string"&&(Z=Z.replace(/\$|}/g,"\\$&"));return this.value+="${",this.value+=O,Z&&(this.value+=":",this.value+=Z),this.value+="}",this}};de=l=Ue([D],de),e.SnippetString=de;var Y;(function(U){U[U.Unnecessary=1]="Unnecessary",U[U.Deprecated=2]="Deprecated"})(Y=e.DiagnosticTag||(e.DiagnosticTag={}));var ie;(function(U){U[U.Hint=3]="Hint",U[U.Information=2]="Information",U[U.Warning=1]="Warning",U[U.Error=0]="Error"})(ie=e.DiagnosticSeverity||(e.DiagnosticSeverity={}));let we=M=class{constructor(O,Z){if(this.uri=O,Z)if(Z instanceof y)this.range=Z;else if(Z instanceof L)this.range=new y(Z,Z);else throw new Error("Illegal argument")}static isLocation(O){return O instanceof M?!0:O?y.isRange(O.range)&&k.URI.isUri(O.uri):!1}toJSON(){return{uri:this.uri,range:this.range}}};we=M=Ue([D],we),e.Location=we;let Me=class{constructor(O,Z){this.location=O,this.message=Z}static is(O){return O?typeof O.message=="string"&&O.location&&y.isRange(O.location.range)&&k.URI.isUri(O.location.uri):!1}static isEqual(O,Z){return O===Z?!0:!O||!Z?!1:O.message===Z.message&&O.location.range.isEqual(Z.location.range)&&O.location.uri.toString()===Z.location.uri.toString()}};Me=Ue([D],Me),e.DiagnosticRelatedInformation=Me;let Re=class{constructor(O,Z,ye=ie.Error){if(!y.isRange(O))throw new TypeError("range must be set");if(!Z)throw new TypeError("message must be set");this.range=O,this.message=Z,this.severity=ye}toJSON(){return{severity:ie[this.severity],message:this.message,range:this.range,source:this.source,code:this.code}}static isEqual(O,Z){return O===Z?!0:!O||!Z?!1:O.message===Z.message&&O.severity===Z.severity&&O.code===Z.code&&O.severity===Z.severity&&O.source===Z.source&&O.range.isEqual(Z.range)&&(0,c.equals)(O.tags,Z.tags)&&(0,c.equals)(O.relatedInformation,Z.relatedInformation,Me.isEqual)}};Re=Ue([D],Re),e.Diagnostic=Re;let Be=class{constructor(O,Z){if(!O)throw new Error("Illegal argument, contents must be defined");Array.isArray(O)?this.contents=O:this.contents=[O],this.range=Z}};Be=Ue([D],Be),e.Hover=Be;var Qe;(function(U){U[U.Text=0]="Text",U[U.Read=1]="Read",U[U.Write=2]="Write"})(Qe=e.DocumentHighlightKind||(e.DocumentHighlightKind={}));let Ge=class{constructor(O,Z=Qe.Text){this.range=O,this.kind=Z}toJSON(){return{range:this.range,kind:Qe[this.kind]}}};Ge=Ue([D],Ge),e.DocumentHighlight=Ge;var Xe;(function(U){U[U.File=0]="File",U[U.Module=1]="Module",U[U.Namespace=2]="Namespace",U[U.Package=3]="Package",U[U.Class=4]="Class",U[U.Method=5]="Method",U[U.Property=6]="Property",U[U.Field=7]="Field",U[U.Constructor=8]="Constructor",U[U.Enum=9]="Enum",U[U.Interface=10]="Interface",U[U.Function=11]="Function",U[U.Variable=12]="Variable",U[U.Constant=13]="Constant",U[U.String=14]="String",U[U.Number=15]="Number",U[U.Boolean=16]="Boolean",U[U.Array=17]="Array",U[U.Object=18]="Object",U[U.Key=19]="Key",U[U.Null=20]="Null",U[U.EnumMember=21]="EnumMember",U[U.Struct=22]="Struct",U[U.Event=23]="Event",U[U.Operator=24]="Operator",U[U.TypeParameter=25]="TypeParameter"})(Xe=e.SymbolKind||(e.SymbolKind={}));var $;(function(U){U[U.Deprecated=1]="Deprecated"})($=e.SymbolTag||(e.SymbolTag={}));let G=r=class{constructor(O,Z,ye,je,tt){this.name=O,this.kind=Z,this.containerName=tt,typeof ye=="string"&&(this.containerName=ye),je instanceof we?this.location=je:ye instanceof y&&(this.location=new we(je,ye)),r.validate(this)}static validate(O){if(!O.name)throw new Error("name must not be falsy")}toJSON(){return{name:this.name,kind:Xe[this.kind],location:this.location,containerName:this.containerName}}};G=r=Ue([D],G),e.SymbolInformation=G;let J=i=class{constructor(O,Z,ye,je,tt){this.name=O,this.detail=Z,this.kind=ye,this.range=je,this.selectionRange=tt,this.children=[],i.validate(this)}static validate(O){if(!O.name)throw new Error("name must not be falsy");if(!O.range.contains(O.selectionRange))throw new Error("selectionRange must be contained in fullRange");O.children&&O.children.forEach(i.validate)}};J=i=Ue([D],J),e.DocumentSymbol=J;var ae;(function(U){U[U.Invoke=1]="Invoke",U[U.Automatic=2]="Automatic"})(ae=e.CodeActionTriggerKind||(e.CodeActionTriggerKind={}));let j=class{constructor(O,Z){this.title=O,this.kind=Z}};j=Ue([D],j),e.CodeAction=j;let te=p=class{constructor(O){this.value=O}append(O){return new p(this.value?this.value+p.sep+O:O)}intersects(O){return this.contains(O)||O.contains(this)}contains(O){return this.value===O.value||O.value.startsWith(this.value+p.sep)}};te.sep=".",te=p=Ue([D],te),e.CodeActionKind=te,te.Empty=new te(""),te.QuickFix=te.Empty.append("quickfix"),te.Refactor=te.Empty.append("refactor"),te.RefactorExtract=te.Refactor.append("extract"),te.RefactorInline=te.Refactor.append("inline"),te.RefactorRewrite=te.Refactor.append("rewrite"),te.Source=te.Empty.append("source"),te.SourceOrganizeImports=te.Source.append("organizeImports"),te.SourceFixAll=te.Source.append("fixAll");let me=class{constructor(O,Z){if(this.range=O,this.parent=Z,Z&&!Z.range.contains(this.range))throw new Error("Invalid argument: parent must contain this range")}};me=Ue([D],me),e.SelectionRange=me;class Pe{constructor(O,Z,ye,je,tt,at){this.kind=O,this.name=Z,this.detail=ye,this.uri=je,this.range=tt,this.selectionRange=at}}e.CallHierarchyItem=Pe;class Ne{constructor(O,Z){this.fromRanges=Z,this.from=O}}e.CallHierarchyIncomingCall=Ne;class He{constructor(O,Z){this.fromRanges=Z,this.to=O}}e.CallHierarchyOutgoingCall=He;var Ye;(function(U){U[U.Information=0]="Information",U[U.Warning=1]="Warning",U[U.Error=2]="Error"})(Ye=e.LanguageStatusSeverity||(e.LanguageStatusSeverity={}));let et=class{constructor(O,Z){this.range=O,this.command=Z}get isResolved(){return!!this.command}};et=Ue([D],et),e.CodeLens=et;let st=f=class{constructor(O,Z=!1){o.set(this,void 0),Ze(this,o,new w.MarkdownString(O,{supportThemeIcons:Z}),"f")}static isMarkdownString(O){return O instanceof f?!0:O&&O.appendCodeblock&&O.appendMarkdown&&O.appendText&&O.value!==void 0}get value(){return Te(this,o,"f").value}set value(O){Te(this,o,"f").value=O}get isTrusted(){return Te(this,o,"f").isTrusted}set isTrusted(O){Te(this,o,"f").isTrusted=O}get supportThemeIcons(){return Te(this,o,"f").supportThemeIcons}set supportThemeIcons(O){Te(this,o,"f").supportThemeIcons=O}get supportHtml(){return Te(this,o,"f").supportHtml}set supportHtml(O){Te(this,o,"f").supportHtml=O}appendText(O){return Te(this,o,"f").appendText(O),this}appendMarkdown(O){return Te(this,o,"f").appendMarkdown(O),this}appendCodeblock(O,Z){return Te(this,o,"f").appendCodeblock(Z??"",O),this}};o=new WeakMap,st=f=Ue([D],st),e.MarkdownString=st;let Je=class{constructor(O,Z){this.label=O,this.documentation=Z}};Je=Ue([D],Je),e.ParameterInformation=Je;let nt=class{constructor(O,Z){this.label=O,this.documentation=Z,this.parameters=[]}};nt=Ue([D],nt),e.SignatureInformation=nt;let ct=class{constructor(){this.activeSignature=0,this.activeParameter=0,this.signatures=[]}};ct=Ue([D],ct),e.SignatureHelp=ct;var pt;(function(U){U[U.Invoke=1]="Invoke",U[U.TriggerCharacter=2]="TriggerCharacter",U[U.ContentChange=3]="ContentChange"})(pt=e.SignatureHelpTriggerKind||(e.SignatureHelpTriggerKind={}));var Ft;(function(U){U[U.Other=0]="Other",U[U.Type=1]="Type",U[U.Parameter=2]="Parameter"})(Ft=e.InlayHintKind||(e.InlayHintKind={}));let Fe=class{constructor(O,Z,ye){this.text=O,this.position=Z,this.kind=ye}};Fe=Ue([D],Fe),e.InlayHint=Fe;var Mt;(function(U){U[U.Invoke=0]="Invoke",U[U.TriggerCharacter=1]="TriggerCharacter",U[U.TriggerForIncompleteCompletions=2]="TriggerForIncompleteCompletions"})(Mt=e.CompletionTriggerKind||(e.CompletionTriggerKind={}));var V;(function(U){U[U.Text=0]="Text",U[U.Method=1]="Method",U[U.Function=2]="Function",U[U.Constructor=3]="Constructor",U[U.Field=4]="Field",U[U.Variable=5]="Variable",U[U.Class=6]="Class",U[U.Interface=7]="Interface",U[U.Module=8]="Module",U[U.Property=9]="Property",U[U.Unit=10]="Unit",U[U.Value=11]="Value",U[U.Enum=12]="Enum",U[U.Keyword=13]="Keyword",U[U.Snippet=14]="Snippet",U[U.Color=15]="Color",U[U.File=16]="File",U[U.Reference=17]="Reference",U[U.Folder=18]="Folder",U[U.EnumMember=19]="EnumMember",U[U.Constant=20]="Constant",U[U.Struct=21]="Struct",U[U.Event=22]="Event",U[U.Operator=23]="Operator",U[U.TypeParameter=24]="TypeParameter",U[U.User=25]="User",U[U.Issue=26]="Issue"})(V=e.CompletionItemKind||(e.CompletionItemKind={}));var Q;(function(U){U[U.Deprecated=1]="Deprecated"})(Q=e.CompletionItemTag||(e.CompletionItemTag={}));let he=class{constructor(O,Z){this.label=O,this.kind=Z}toJSON(){return{label:this.label,kind:this.kind&&V[this.kind],detail:this.detail,documentation:this.documentation,sortText:this.sortText,filterText:this.filterText,preselect:this.preselect,insertText:this.insertText,textEdit:this.textEdit}}};he=Ue([D],he),e.CompletionItem=he;let Le=class{constructor(O=[],Z=!1){this.items=O,this.isIncomplete=Z}};Le=Ue([D],Le),e.CompletionList=Le;let We=class{constructor(O,Z,ye){this.text=O,this.range=Z,this.command=ye}};We=Ue([D],We),e.InlineSuggestion=We;let ot=class{constructor(O){this.items=O}};ot=Ue([D],ot),e.InlineSuggestions=ot;var Ke;(function(U){U[U.Active=-1]="Active",U[U.Beside=-2]="Beside",U[U.One=1]="One",U[U.Two=2]="Two",U[U.Three=3]="Three",U[U.Four=4]="Four",U[U.Five=5]="Five",U[U.Six=6]="Six",U[U.Seven=7]="Seven",U[U.Eight=8]="Eight",U[U.Nine=9]="Nine"})(Ke=e.ViewColumn||(e.ViewColumn={}));var _t;(function(U){U[U.Left=1]="Left",U[U.Right=2]="Right"})(_t=e.StatusBarAlignment||(e.StatusBarAlignment={}));var Ie;(function(U){U[U.Off=0]="Off",U[U.On=1]="On",U[U.Relative=2]="Relative"})(Ie=e.TextEditorLineNumbersStyle||(e.TextEditorLineNumbersStyle={}));var Se;(function(U){U[U.Manual=1]="Manual",U[U.AfterDelay=2]="AfterDelay",U[U.FocusOut=3]="FocusOut"})(Se=e.TextDocumentSaveReason||(e.TextDocumentSaveReason={}));var ve;(function(U){U[U.Default=0]="Default",U[U.InCenter=1]="InCenter",U[U.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",U[U.AtTop=3]="AtTop"})(ve=e.TextEditorRevealType||(e.TextEditorRevealType={}));var oe;(function(U){U[U.Keyboard=1]="Keyboard",U[U.Mouse=2]="Mouse",U[U.Command=3]="Command"})(oe=e.TextEditorSelectionChangeKind||(e.TextEditorSelectionChangeKind={}));var se;(function(U){U[U.Undo=1]="Undo",U[U.Redo=2]="Redo"})(se=e.TextDocumentChangeReason||(e.TextDocumentChangeReason={}));var fe;(function(U){U[U.OpenOpen=0]="OpenOpen",U[U.ClosedClosed=1]="ClosedClosed",U[U.OpenClosed=2]="OpenClosed",U[U.ClosedOpen=3]="ClosedOpen"})(fe=e.DecorationRangeBehavior||(e.DecorationRangeBehavior={})),function(U){function O(Z){switch(Z){case"keyboard":return U.Keyboard;case"mouse":return U.Mouse;case"api":return U.Command}}U.fromValue=O}(oe=e.TextEditorSelectionChangeKind||(e.TextEditorSelectionChangeKind={}));let ge=class{constructor(O,Z){if(Z&&!k.URI.isUri(Z))throw(0,F.illegalArgument)("target");if(!y.isRange(O)||O.isEmpty)throw(0,F.illegalArgument)("range");this.range=O,this.target=Z}};ge=Ue([D],ge),e.DocumentLink=ge;let ke=class{constructor(O,Z,ye,je){this.red=O,this.green=Z,this.blue=ye,this.alpha=je}};ke=Ue([D],ke),e.Color=ke;let ze=class{constructor(O,Z){if(Z&&!(Z instanceof ke))throw(0,F.illegalArgument)("color");if(!y.isRange(O)||O.isEmpty)throw(0,F.illegalArgument)("range");this.range=O,this.color=Z}};ze=Ue([D],ze),e.ColorInformation=ze;let Oe=class{constructor(O){if(!O||typeof O!="string")throw(0,F.illegalArgument)("label");this.label=O}};Oe=Ue([D],Oe),e.ColorPresentation=Oe;var Ve;(function(U){U[U.RGB=0]="RGB",U[U.HEX=1]="HEX",U[U.HSL=2]="HSL"})(Ve=e.ColorFormat||(e.ColorFormat={}));var it;(function(U){U[U.Error=0]="Error",U[U.Warning=1]="Warning",U[U.Information=2]="Information"})(it=e.SourceControlInputBoxValidationType||(e.SourceControlInputBoxValidationType={}));class rt{constructor(O,Z,ye){if(this.startIndex=O,this.length=Z,this.tooltip=ye,typeof O!="number"||O<0)throw(0,F.illegalArgument)("startIndex");if(typeof Z!="number"||Z<1)throw(0,F.illegalArgument)("length");if(ye!==void 0&&typeof ye!="string")throw(0,F.illegalArgument)("tooltip")}}e.TerminalLink=rt;var ne;(function(U){U[U.Panel=1]="Panel",U[U.Editor=2]="Editor"})(ne=e.TerminalLocation||(e.TerminalLocation={}));class pe{constructor(O){this.options=O,typeof O!="object"&&(0,F.illegalArgument)("options")}}e.TerminalProfile=pe;var ee;(function(U){U[U.Always=1]="Always",U[U.Silent=2]="Silent",U[U.Never=3]="Never"})(ee=e.TaskRevealKind||(e.TaskRevealKind={}));var W;(function(U){U[U.Shared=1]="Shared",U[U.Dedicated=2]="Dedicated",U[U.New=3]="New"})(W=e.TaskPanelKind||(e.TaskPanelKind={}));let be=s=class{constructor(O,Z){if(this.label=Z,typeof O!="string"||typeof Z!="string")throw(0,F.illegalArgument)("name");this._id=O}static from(O){switch(O){case"clean":return s.Clean;case"build":return s.Build;case"rebuild":return s.Rebuild;case"test":return s.Test;default:return}}get id(){return this._id}};be.Clean=new s("clean","Clean"),be.Build=new s("build","Build"),be.Rebuild=new s("rebuild","Rebuild"),be.Test=new s("test","Test"),be=s=Ue([D],be),e.TaskGroup=be;function De(U){let O="";for(let Z=0;Z<U.length;Z++)O+=U[Z].replace(/,/g,",,")+",";return O}let qe=class{constructor(O,Z,ye){if(typeof O!="string")throw(0,F.illegalArgument)("process");this._args=[],this._process=O,Z!==void 0&&(Array.isArray(Z)?(this._args=Z,this._options=ye):this._options=Z)}get process(){return this._process}set process(O){if(typeof O!="string")throw(0,F.illegalArgument)("process");this._process=O}get args(){return this._args}set args(O){Array.isArray(O)||(O=[]),this._args=O}get options(){return this._options}set options(O){this._options=O}computeId(){const O=[];if(O.push("process"),this._process!==void 0&&O.push(this._process),this._args&&this._args.length>0)for(let Z of this._args)O.push(Z);return De(O)}};qe=Ue([D],qe),e.ProcessExecution=qe;let xe=class{constructor(O,Z,ye){if(this._args=[],Array.isArray(Z)){if(!O)throw(0,F.illegalArgument)("command can't be undefined or null");if(typeof O!="string"&&typeof O.value!="string")throw(0,F.illegalArgument)("command");this._command=O,this._args=Z,this._options=ye}else{if(typeof O!="string")throw(0,F.illegalArgument)("commandLine");this._commandLine=O,this._options=Z}}get commandLine(){return this._commandLine}set commandLine(O){if(typeof O!="string")throw(0,F.illegalArgument)("commandLine");this._commandLine=O}get command(){return this._command?this._command:""}set command(O){if(typeof O!="string"&&typeof O.value!="string")throw(0,F.illegalArgument)("command");this._command=O}get args(){return this._args}set args(O){this._args=O||[]}get options(){return this._options}set options(O){this._options=O}computeId(){const O=[];if(O.push("shell"),this._commandLine!==void 0&&O.push(this._commandLine),this._command!==void 0&&O.push(typeof this._command=="string"?this._command:this._command.value),this._args&&this._args.length>0)for(let Z of this._args)O.push(typeof Z=="string"?Z:Z.value);return De(O)}};xe=Ue([D],xe),e.ShellExecution=xe;var ut;(function(U){U[U.Escape=1]="Escape",U[U.Strong=2]="Strong",U[U.Weak=3]="Weak"})(ut=e.ShellQuoting||(e.ShellQuoting={}));var vt;(function(U){U[U.Global=1]="Global",U[U.Workspace=2]="Workspace"})(vt=e.TaskScope||(e.TaskScope={}));class Ct{constructor(O){this._callback=O}computeId(){return"customExecution"+(0,R.generateUuid)()}set callback(O){this._callback=O}get callback(){return this._callback}}e.CustomExecution=Ct;let bt=v=class{constructor(O,Z,ye,je,tt,at){this.__deprecated=!1,this._definition=this.definition=O;let dt;typeof Z=="string"?(this._name=this.name=Z,this._source=this.source=ye,this.execution=je,dt=tt,this.__deprecated=!0):Z===vt.Global||Z===vt.Workspace?(this.target=Z,this._name=this.name=ye,this._source=this.source=je,this.execution=tt,dt=at):(this.target=Z,this._name=this.name=ye,this._source=this.source=je,this.execution=tt,dt=at),typeof dt=="string"?(this._problemMatchers=[dt],this._hasDefinedMatchers=!0):Array.isArray(dt)?(this._problemMatchers=dt,this._hasDefinedMatchers=!0):(this._problemMatchers=[],this._hasDefinedMatchers=!1),this._isBackground=!1,this._presentationOptions=Object.create(null),this._runOptions=Object.create(null)}get _id(){return this.__id}set _id(O){this.__id=O}get _deprecated(){return this.__deprecated}clear(){this.__id!==void 0&&(this.__id=void 0,this._scope=void 0,this.computeDefinitionBasedOnExecution())}computeDefinitionBasedOnExecution(){this._execution instanceof qe?this._definition={type:v.ProcessType,id:this._execution.computeId()}:this._execution instanceof xe?this._definition={type:v.ShellType,id:this._execution.computeId()}:this._execution instanceof Ct?this._definition={type:v.ExtensionCallbackType,id:this._execution.computeId()}:this._definition={type:v.EmptyType,id:(0,R.generateUuid)()}}get definition(){return this._definition}set definition(O){if(O==null)throw(0,F.illegalArgument)("Kind can't be undefined or null");this.clear(),this._definition=O}get scope(){return this._scope}set target(O){this.clear(),this._scope=O}get name(){return this._name}set name(O){if(typeof O!="string")throw(0,F.illegalArgument)("name");this.clear(),this._name=O}get execution(){return this._execution}set execution(O){O===null&&(O=void 0),this.clear(),this._execution=O;const Z=this._definition.type;(v.EmptyType===Z||v.ProcessType===Z||v.ShellType===Z||v.ExtensionCallbackType===Z)&&this.computeDefinitionBasedOnExecution()}get problemMatchers(){return this._problemMatchers}set problemMatchers(O){if(Array.isArray(O))this.clear(),this._problemMatchers=O,this._hasDefinedMatchers=!0;else{this.clear(),this._problemMatchers=[],this._hasDefinedMatchers=!1;return}}get hasDefinedMatchers(){return this._hasDefinedMatchers}get isBackground(){return this._isBackground}set isBackground(O){O!==!0&&O!==!1&&(O=!1),this.clear(),this._isBackground=O}get source(){return this._source}set source(O){if(typeof O!="string"||O.length===0)throw(0,F.illegalArgument)("source must be a string of length > 0");this.clear(),this._source=O}get group(){return this._group}set group(O){O===null&&(O=void 0),this.clear(),this._group=O}get detail(){return this._detail}set detail(O){O===null&&(O=void 0),this._detail=O}get presentationOptions(){return this._presentationOptions}set presentationOptions(O){O==null&&(O=Object.create(null)),this.clear(),this._presentationOptions=O}get runOptions(){return this._runOptions}set runOptions(O){O==null&&(O=Object.create(null)),this.clear(),this._runOptions=O}};bt.ExtensionCallbackType="customExecution",bt.ProcessType="process",bt.ShellType="shell",bt.EmptyType="$empty",bt=v=Ue([D],bt),e.Task=bt;var ht;(function(U){U[U.SourceControl=1]="SourceControl",U[U.Window=10]="Window",U[U.Notification=15]="Notification"})(ht=e.ProgressLocation||(e.ProgressLocation={}));let gt=class{constructor(O,Z=yt.None){this.collapsibleState=Z,k.URI.isUri(O)?this.resourceUri=O:this.label=O}};gt=Ue([D],gt),e.TreeItem=gt;var yt;(function(U){U[U.None=0]="None",U[U.Collapsed=1]="Collapsed",U[U.Expanded=2]="Expanded"})(yt=e.TreeItemCollapsibleState||(e.TreeItemCollapsibleState={}));let Lt=class{constructor(O){this._value=O}async asString(){return JSON.stringify(this._value)}};Lt=Ue([D],Lt),e.TreeDataTransferItem=Lt;let It=class{constructor(){this._items=new Map}get(O){return this._items.get(O)}set(O,Z){this._items.set(O,Z)}forEach(O){this._items.forEach(O)}};It=Ue([D],It),e.TreeDataTransfer=It;let Pt=class{constructor(O,Z){this.id=O,this.color=Z}};Pt=Ue([D],Pt),e.ThemeIcon=Pt,Pt.File=new Pt("file"),Pt.Folder=new Pt("folder");let At=class{constructor(O){this.id=O}};At=Ue([D],At),e.ThemeColor=At;var Et;(function(U){U[U.Global=1]="Global",U[U.Workspace=2]="Workspace",U[U.WorkspaceFolder=3]="WorkspaceFolder"})(Et=e.ConfigurationTarget||(e.ConfigurationTarget={}));let Ot=class{constructor(O,Z){if(typeof O!="string"&&(!O||!k.URI.isUri(O)&&!k.URI.isUri(O.uri)))throw(0,F.illegalArgument)("base");if(typeof Z!="string")throw(0,F.illegalArgument)("pattern");typeof O=="string"?(this.baseFolder=k.URI.file(O),this.base=O):k.URI.isUri(O)?(this.baseFolder=O,this.base=O.fsPath):(this.baseFolder=O.uri,this.base=O.uri.fsPath),this.pattern=Z}};Ot=Ue([D],Ot),e.RelativePattern=Ot;let Nt=class{constructor(O,Z,ye,je){this.enabled=typeof O=="boolean"?O:!0,typeof Z=="string"&&(this.condition=Z),typeof ye=="string"&&(this.hitCondition=ye),typeof je=="string"&&(this.logMessage=je)}get id(){return this._id||(this._id=(0,R.generateUuid)()),this._id}};Nt=Ue([D],Nt),e.Breakpoint=Nt;let wt=class extends Nt{constructor(O,Z,ye,je,tt){super(Z,ye,je,tt);if(O===null)throw(0,F.illegalArgument)("location");this.location=O}};wt=Ue([D],wt),e.SourceBreakpoint=wt;let $t=class extends Nt{constructor(O,Z,ye,je,tt){super(Z,ye,je,tt);this.functionName=O}};$t=Ue([D],$t),e.FunctionBreakpoint=$t;let jt=class extends Nt{constructor(O,Z,ye,je,tt,at,dt){super(je,tt,at,dt);if(!Z)throw(0,F.illegalArgument)("dataId");this.label=O,this.dataId=Z,this.canPersist=ye}};jt=Ue([D],jt),e.DataBreakpoint=jt;let oi=class{constructor(O,Z,ye){this.command=O,this.args=Z||[],this.options=ye}};oi=Ue([D],oi),e.DebugAdapterExecutable=oi;let si=class{constructor(O,Z){this.port=O,this.host=Z}};si=Ue([D],si),e.DebugAdapterServer=si;let Tt=class{constructor(O){this.path=O}};Tt=Ue([D],Tt),e.DebugAdapterNamedPipeServer=Tt;let Yt=class{constructor(O){this.implementation=O}};Yt=Ue([D],Yt),e.DebugAdapterInlineImplementation=Yt;let ai=class{constructor(O,Z){this.range=O,this.expression=Z}};ai=Ue([D],ai),e.EvaluatableExpression=ai;var Xt;(function(U){U[U.Automatic=0]="Automatic",U[U.Explicit=1]="Explicit"})(Xt=e.InlineCompletionTriggerKind||(e.InlineCompletionTriggerKind={}));let Vt=class{constructor(O,Z){this.range=O,this.text=Z}};Vt=Ue([D],Vt),e.InlineValueText=Vt;let mt=class{constructor(O,Z,ye=!0){this.range=O,this.variableName=Z,this.caseSensitiveLookup=ye}};mt=Ue([D],mt),e.InlineValueVariableLookup=mt;let ci=class{constructor(O,Z){this.range=O,this.expression=Z}};ci=Ue([D],ci),e.InlineValueEvaluatableExpression=ci;let xt=class{constructor(O,Z){this.frameId=O,this.stoppedLocation=Z}};xt=Ue([D],xt),e.InlineValueContext=xt;var qt;(function(U){U[U.Changed=1]="Changed",U[U.Created=2]="Created",U[U.Deleted=3]="Deleted"})(qt=e.FileChangeType||(e.FileChangeType={}));let Jt=a=class extends Error{constructor(O,Z=_.FileSystemProviderErrorCode.Unknown,ye){super(k.URI.isUri(O)?O.toString(!0):O);this.code=ye?.name??"Unknown",(0,_.markAsFileSystemProviderError)(this,Z),typeof Object.setPrototypeOf=="function"&&Object.setPrototypeOf(this,a.prototype),typeof Error.captureStackTrace=="function"&&typeof ye=="function"&&Error.captureStackTrace(this,ye)}static FileExists(O){return new a(O,_.FileSystemProviderErrorCode.FileExists,a.FileExists)}static FileNotFound(O){return new a(O,_.FileSystemProviderErrorCode.FileNotFound,a.FileNotFound)}static FileNotADirectory(O){return new a(O,_.FileSystemProviderErrorCode.FileNotADirectory,a.FileNotADirectory)}static FileIsADirectory(O){return new a(O,_.FileSystemProviderErrorCode.FileIsADirectory,a.FileIsADirectory)}static NoPermissions(O){return new a(O,_.FileSystemProviderErrorCode.NoPermissions,a.NoPermissions)}static Unavailable(O){return new a(O,_.FileSystemProviderErrorCode.Unavailable,a.Unavailable)}};Jt=a=Ue([D],Jt),e.FileSystemError=Jt;let li=class{constructor(O,Z,ye){this.start=O,this.end=Z,this.kind=ye}};li=Ue([D],li),e.FoldingRange=li;var fi;(function(U){U[U.Comment=1]="Comment",U[U.Imports=2]="Imports",U[U.Region=3]="Region"})(fi=e.FoldingRangeKind||(e.FoldingRangeKind={}));var Ei;(function(U){U[U.Collapsed=0]="Collapsed",U[U.Expanded=1]="Expanded"})(Ei=e.CommentThreadCollapsibleState||(e.CommentThreadCollapsibleState={}));var mi;(function(U){U[U.Editing=0]="Editing",U[U.Preview=1]="Preview"})(mi=e.CommentMode||(e.CommentMode={}));class Zt{constructor(O,Z=[]){this.tokenTypes=O,this.tokenModifiers=Z}}e.SemanticTokensLegend=Zt;function _i(U){return typeof U=="undefined"||(0,C.isStringArray)(U)}class Gt{constructor(O){if(this._prevLine=0,this._prevChar=0,this._dataIsSortedAndDeltaEncoded=!0,this._data=[],this._dataLen=0,this._tokenTypeStrToInt=new Map,this._tokenModifierStrToInt=new Map,this._hasLegend=!1,O){this._hasLegend=!0;for(let Z=0,ye=O.tokenTypes.length;Z<ye;Z++)this._tokenTypeStrToInt.set(O.tokenTypes[Z],Z);for(let Z=0,ye=O.tokenModifiers.length;Z<ye;Z++)this._tokenModifierStrToInt.set(O.tokenModifiers[Z],Z)}}push(O,Z,ye,je,tt){if(typeof O=="number"&&typeof Z=="number"&&typeof ye=="number"&&typeof je=="number"&&(typeof tt=="number"||typeof tt=="undefined"))return typeof tt=="undefined"&&(tt=0),this._pushEncoded(O,Z,ye,je,tt);if(y.isRange(O)&&typeof Z=="string"&&_i(ye))return this._push(O,Z,ye);throw(0,F.illegalArgument)()}_push(O,Z,ye){if(!this._hasLegend)throw new Error("Legend must be provided in constructor");if(O.start.line!==O.end.line)throw new Error("`range` cannot span multiple lines");if(!this._tokenTypeStrToInt.has(Z))throw new Error("`tokenType` is not in the provided legend");const je=O.start.line,tt=O.start.character,at=O.end.character-O.start.character,dt=this._tokenTypeStrToInt.get(Z);let kt=0;if(ye)for(const Rt of ye){if(!this._tokenModifierStrToInt.has(Rt))throw new Error("`tokenModifier` is not in the provided legend");const Bt=this._tokenModifierStrToInt.get(Rt);kt|=1<<Bt>>>0}this._pushEncoded(je,tt,at,dt,kt)}_pushEncoded(O,Z,ye,je,tt){if(this._dataIsSortedAndDeltaEncoded&&(O<this._prevLine||O===this._prevLine&&Z<this._prevChar)){this._dataIsSortedAndDeltaEncoded=!1;const kt=this._data.length/5|0;let Rt=0,Bt=0;for(let Ht=0;Ht<kt;Ht++){let zt=this._data[5*Ht],di=this._data[5*Ht+1];zt===0?(zt=Rt,di+=Bt):zt+=Rt,this._data[5*Ht]=zt,this._data[5*Ht+1]=di,Rt=zt,Bt=di}}let at=O,dt=Z;this._dataIsSortedAndDeltaEncoded&&this._dataLen>0&&(at-=this._prevLine,at===0&&(dt-=this._prevChar)),this._data[this._dataLen++]=at,this._data[this._dataLen++]=dt,this._data[this._dataLen++]=ye,this._data[this._dataLen++]=je,this._data[this._dataLen++]=tt,this._prevLine=O,this._prevChar=Z}static _sortAndDeltaEncode(O){let Z=[];const ye=O.length/5|0;for(let dt=0;dt<ye;dt++)Z[dt]=dt;Z.sort((dt,kt)=>{const Rt=O[5*dt],Bt=O[5*kt];if(Rt===Bt){const Ht=O[5*dt+1],zt=O[5*kt+1];return Ht-zt}return Rt-Bt});const je=new Uint32Array(O.length);let tt=0,at=0;for(let dt=0;dt<ye;dt++){const kt=5*Z[dt],Rt=O[kt+0],Bt=O[kt+1],Ht=O[kt+2],zt=O[kt+3],di=O[kt+4],Hi=Rt-tt,Yi=Hi===0?Bt-at:Bt,hi=5*dt;je[hi+0]=Hi,je[hi+1]=Yi,je[hi+2]=Ht,je[hi+3]=zt,je[hi+4]=di,tt=Rt,at=Bt}return je}build(O){return this._dataIsSortedAndDeltaEncoded?new Kt(new Uint32Array(this._data),O):new Kt(Gt._sortAndDeltaEncode(this._data),O)}}e.SemanticTokensBuilder=Gt;class Kt{constructor(O,Z){this.resultId=Z,this.data=O}}e.SemanticTokens=Kt;class yi{constructor(O,Z,ye){this.start=O,this.deleteCount=Z,this.data=ye}}e.SemanticTokensEdit=yi;class Si{constructor(O,Z){this.resultId=Z,this.edits=O}}e.SemanticTokensEdits=Si;var Qt;(function(U){U[U.Separate=0]="Separate",U[U.MergeWithParent=1]="MergeWithParent"})(Qt=e.DebugConsoleMode||(e.DebugConsoleMode={}));var Ci;(function(U){U[U.Initial=1]="Initial",U[U.Dynamic=2]="Dynamic"})(Ci=e.DebugConfigurationProviderTriggerKind||(e.DebugConfigurationProviderTriggerKind={}));let ei=class{constructor(){}};ei.Back={iconPath:new Pt("arrow-left")},ei=Ue([D],ei),e.QuickInputButtons=ei;var Di;(function(U){U[U.Default=1]="Default",U[U.Separator=2]="Separator"})(Di=e.QuickPickItemKind||(e.QuickPickItemKind={}));var ki;(function(U){U[U.UI=1]="UI",U[U.Workspace=2]="Workspace"})(ki=e.ExtensionKind||(e.ExtensionKind={}));class ui{constructor(O,Z,ye){this.badge=O,this.tooltip=Z,this.color=ye}static validate(O){if(O.badge){let Z=(0,T.nextCharLength)(O.badge,0);if(Z<O.badge.length&&(Z+=(0,T.nextCharLength)(O.badge,Z)),O.badge.length>Z)throw new Error("The 'badge'-property must be undefined or a short character")}if(!O.color&&!O.badge&&!O.tooltip)throw new Error("The decoration is empty");return!0}}e.FileDecoration=ui;let ti=class{constructor(O){this.kind=O}};ti=Ue([D],ti),e.ColorTheme=ti;var gi;(function(U){U[U.Light=1]="Light",U[U.Dark=2]="Dark",U[U.HighContrast=3]="HighContrast"})(gi=e.ColorThemeKind||(e.ColorThemeKind={}));class Ae{constructor(O,Z){if(O<0)throw(0,F.illegalArgument)("start must be positive");if(Z<0)throw(0,F.illegalArgument)("end must be positive");O<=Z?(this._start=O,this._end=Z):(this._start=Z,this._end=O)}static isNotebookRange(O){return O instanceof Ae?!0:O?typeof O.start=="number"&&typeof O.end=="number":!1}get start(){return this._start}get end(){return this._end}get isEmpty(){return this._start===this._end}with(O){let Z=this._start,ye=this._end;return O.start!==void 0&&(Z=O.start),O.end!==void 0&&(ye=O.end),Z===this._start&&ye===this._end?this:new Ae(Z,ye)}}e.NotebookRange=Ae;class Ut{constructor(O,Z,ye,je,tt,at,dt){this.kind=O,this.value=Z,this.languageId=ye,this.mime=je,this.outputs=tt??[],this.metadata=at,this.executionSummary=dt,Ut.validate(this)}static validate(O){if(typeof O.kind!="number")throw new Error("NotebookCellData MUST have 'kind' property");if(typeof O.value!="string")throw new Error("NotebookCellData MUST have 'value' property");if(typeof O.languageId!="string")throw new Error("NotebookCellData MUST have 'languageId' property")}static isNotebookCellDataArray(O){return Array.isArray(O)&&O.every(Z=>Ut.isNotebookCellData(Z))}static isNotebookCellData(O){return!0}}e.NotebookCellData=Ut;class pi{constructor(O){this.cells=O}}e.NotebookData=pi;class ft{constructor(O,Z){this.data=O,this.mime=Z;const ye=(0,t.normalizeMimeType)(Z,!0);if(!ye)throw new Error(`INVALID mime type: ${Z}. Must be in the format "type/subtype[;optionalparameter]"`);this.mime=ye}static isNotebookCellOutputItem(O){return O instanceof ft?!0:O?typeof O.mime=="string"&&O.data instanceof Uint8Array:!1}static error(O){const Z={name:O.name,message:O.message,stack:O.stack};return ft.json(Z,"application/vnd.code.notebook.error")}static stdout(O){return ft.text(O,"application/vnd.code.notebook.stdout")}static stderr(O){return ft.text(O,"application/vnd.code.notebook.stderr")}static bytes(O,Z="application/octet-stream"){return new ft(O,Z)}static text(O,Z=t.Mimes.text){const ye=Te(ft,d,"f",u).encode(String(O));return new ft(ye,Z)}static json(O,Z="application/json"){const ye=JSON.stringify(O,void 0,"	");return ft.text(ye,Z)}}e.NotebookCellOutputItem=ft,d=ft,u={value:new TextEncoder};class ii{constructor(O,Z,ye){this.items=ii.ensureUniqueMimeTypes(O,!0),typeof Z=="string"?(this.id=Z,this.metadata=ye):(this.id=(0,R.generateUuid)(),this.metadata=Z??ye)}static isNotebookCellOutput(O){return O instanceof ii?!0:!O||typeof O!="object"?!1:typeof O.id=="string"&&(0,C.isArray)(O.items)}static ensureUniqueMimeTypes(O,Z=!1){const ye=new Set,je=new Set;for(let tt=0;tt<O.length;tt++){const at=O[tt],dt=(0,t.normalizeMimeType)(at.mime);if(!ye.has(dt)){ye.add(dt);continue}je.add(tt),Z&&console.warn(`DUPLICATED mime type '${at.mime}' will be dropped`)}return je.size===0?O:O.filter((tt,at)=>!je.has(at))}}e.NotebookCellOutput=ii;var Ii;(function(U){U[U.Markup=1]="Markup",U[U.Code=2]="Code"})(Ii=e.NotebookCellKind||(e.NotebookCellKind={}));var vi;(function(U){U[U.Idle=1]="Idle",U[U.Pending=2]="Pending",U[U.Executing=3]="Executing"})(vi=e.NotebookCellExecutionState||(e.NotebookCellExecutionState={}));var bi;(function(U){U[U.Left=1]="Left",U[U.Right=2]="Right"})(bi=e.NotebookCellStatusBarAlignment||(e.NotebookCellStatusBarAlignment={}));var Pi;(function(U){U[U.Default=0]="Default",U[U.InCenter=1]="InCenter",U[U.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",U[U.AtTop=3]="AtTop"})(Pi=e.NotebookEditorRevealType||(e.NotebookEditorRevealType={}));class Ti{constructor(O,Z){this.text=O,this.alignment=Z}}e.NotebookCellStatusBarItem=Ti;var Ai;(function(U){U[U.Default=1]="Default",U[U.Preferred=2]="Preferred"})(Ai=e.NotebookControllerAffinity||(e.NotebookControllerAffinity={}));class Ri{constructor(O,Z=[]){this.uri=O,this.provides=(0,c.asArray)(Z)}}e.NotebookRendererScript=Ri;let ni=class{constructor(O,Z){this.label=O,this.timestamp=Z}};ni=Ue([D],ni),e.TimelineItem=ni;var Fi;(function(U){U[U.Production=1]="Production",U[U.Development=2]="Development",U[U.Test=3]="Test"})(Fi=e.ExtensionMode||(e.ExtensionMode={}));var Mi;(function(U){U[U.Node=1]="Node",U[U.Webworker=2]="Webworker"})(Mi=e.ExtensionRuntime||(e.ExtensionRuntime={}));var Oi;(function(U){U[U.Other=0]="Other",U[U.Comment=1]="Comment",U[U.String=2]="String",U[U.RegEx=4]="RegEx"})(Oi=e.StandardTokenType||(e.StandardTokenType={}));class Li{constructor(O,Z){this.ranges=O,this.wordPattern=Z}}e.LinkedEditingRanges=Li;class Ni{constructor(O,Z){this._port=O,this._autoForwardAction=Z}get port(){return this._port}get autoForwardAction(){return this._autoForwardAction}}e.PortAttributes=Ni;var X;(function(U){U[U.Queued=1]="Queued",U[U.Running=2]="Running",U[U.Passed=3]="Passed",U[U.Failed=4]="Failed",U[U.Skipped=5]="Skipped",U[U.Errored=6]="Errored"})(X=e.TestResultState||(e.TestResultState={}));var le;(function(U){U[U.Run=1]="Run",U[U.Debug=2]="Debug",U[U.Coverage=3]="Coverage"})(le=e.TestRunProfileKind||(e.TestRunProfileKind={}));let Ce=class{constructor(O=void 0,Z=void 0,ye=void 0){this.include=O,this.exclude=Z,this.profile=ye}};Ce=Ue([D],Ce),e.TestRunRequest=Ce;let lt=E=class{constructor(O){this.message=O}static diff(O,Z,ye){const je=new E(O);return je.expectedOutput=Z,je.actualOutput=ye,je}};lt=E=Ue([D],lt),e.TestMessage=lt;let St=class{constructor(O){this.id=O}};St=Ue([D],St),e.TestTag=St;let Dt=class{constructor(O,Z){this.covered=O,this.total=Z}};Dt=Ue([D],Dt),e.CoveredCount=Dt;let xi=I=class{constructor(O,Z,ye,je){this.uri=O,this.statementCoverage=Z,this.branchCoverage=ye,this.functionCoverage=je}static fromDetails(O,Z){const ye=new Dt(0,0),je=new Dt(0,0),tt=new Dt(0,0);for(const dt of Z)if("branches"in dt){ye.total+=1,ye.covered+=dt.executionCount>0?1:0;for(const kt of dt.branches)je.total+=1,je.covered+=kt.executionCount>0?1:0}else tt.total+=1,tt.covered+=dt.executionCount>0?1:0;const at=new I(O,ye,je.total>0?je:void 0,tt.total>0?tt:void 0);return at.detailedCoverage=Z,at}};xi=I=Ue([D],xi),e.FileCoverage=xi;let Ui=class{constructor(O,Z,ye=[]){this.executionCount=O,this.location=Z,this.branches=ye}};Ui=Ue([D],Ui),e.StatementCoverage=Ui;let Bi=class{constructor(O,Z){this.executionCount=O,this.location=Z}};Bi=Ue([D],Bi),e.BranchCoverage=Bi;let $i=class{constructor(O,Z){this.executionCount=O,this.location=Z}};$i=Ue([D],$i),e.FunctionCoverage=$i;var qi;(function(U){U[U.None=0]="None",U[U.Option=1]="Option",U[U.Default=2]="Default",U[U.Preferred=3]="Preferred"})(qi=e.ExternalUriOpenerPriority||(e.ExternalUriOpenerPriority={}));var Gi;(function(U){U[U.Untrusted=0]="Untrusted",U[U.Trusted=1]="Trusted",U[U.Unspecified=2]="Unspecified"})(Gi=e.WorkspaceTrustState||(e.WorkspaceTrustState={}));var Ki;(function(U){U[U.Notify=1]="Notify",U[U.OpenBrowser=2]="OpenBrowser",U[U.OpenPreview=3]="OpenPreview",U[U.Silent=4]="Silent",U[U.Ignore=5]="Ignore",U[U.OpenBrowserOnce=6]="OpenBrowserOnce"})(Ki=e.PortAutoForwardAction||(e.PortAutoForwardAction={}));class Qi{constructor(O,Z,ye,je,tt,at){this.kind=O,this.name=Z,this.detail=ye,this.uri=je,this.range=tt,this.selectionRange=at}}e.TypeHierarchyItem=Qi}),define(Ee[86],_e([0,1,41,10,9,223,114,7,16]),function(re,e,c,F,w,P,t,T,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDocumentLine=e.ExtHostDocumentData=e.getWordDefinitionFor=e.setWordDefinitionFor=void 0;const k=new Map;function R(o,d){d?k.set(o,d):k.delete(o)}e.setWordDefinitionFor=R;function _(o){return k.get(o)}e.getWordDefinitionFor=_;class n extends P.MirrorTextModel{constructor(d,u,S,b,h,g,A,l){super(u,S,b,h);this._proxy=d,this._languageId=g,this._isDirty=A,this._notebook=l,this._isDisposed=!1}dispose(){(0,c.ok)(!this._isDisposed),this._isDisposed=!0,this._isDirty=!1}equalLines(d){return(0,C.equals)(this._lines,d)}get document(){if(!this._document){const d=this;this._document={get uri(){return d._uri},get fileName(){return d._uri.fsPath},get isUntitled(){return d._uri.scheme===F.Schemas.untitled},get languageId(){return d._languageId},get version(){return d._versionId},get isClosed(){return d._isDisposed},get isDirty(){return d._isDirty},get notebook(){return d._notebook},save(){return d._save()},getText(u){return u?d._getTextInRange(u):d.getText()},get eol(){return d._eol===`
`?T.EndOfLine.LF:T.EndOfLine.CRLF},get lineCount(){return d._lines.length},lineAt(u){return d._lineAt(u)},offsetAt(u){return d._offsetAt(u)},positionAt(u){return d._positionAt(u)},validateRange(u){return d._validateRange(u)},validatePosition(u){return d._validatePosition(u)},getWordRangeAtPosition(u,S){return d._getWordRangeAtPosition(u,S)}}}return Object.freeze(this._document)}_acceptLanguageId(d){(0,c.ok)(!this._isDisposed),this._languageId=d}_acceptIsDirty(d){(0,c.ok)(!this._isDisposed),this._isDirty=d}_save(){return this._isDisposed?Promise.reject(new Error("Document has been closed")):this._proxy.$trySaveDocument(this._uri)}_getTextInRange(d){const u=this._validateRange(d);if(u.isEmpty)return"";if(u.isSingleLine)return this._lines[u.start.line].substring(u.start.character,u.end.character);const S=this._eol,b=u.start.line,h=u.end.line,g=[];g.push(this._lines[b].substring(u.start.character));for(let A=b+1;A<h;A++)g.push(this._lines[A]);return g.push(this._lines[h].substring(0,u.end.character)),g.join(S)}_lineAt(d){let u;if(d instanceof T.Position?u=d.line:typeof d=="number"&&(u=d),typeof u!="number"||u<0||u>=this._lines.length||Math.floor(u)!==u)throw new Error("Illegal value for `line`");return new m(u,this._lines[u],u===this._lines.length-1)}_offsetAt(d){return d=this._validatePosition(d),this._ensureLineStarts(),this._lineStarts.getPrefixSum(d.line-1)+d.character}_positionAt(d){d=Math.floor(d),d=Math.max(0,d),this._ensureLineStarts();const u=this._lineStarts.getIndexOf(d),S=this._lines[u.index].length;return new T.Position(u.index,Math.min(u.remainder,S))}_validateRange(d){if(!(d instanceof T.Range))throw new Error("Invalid argument");const u=this._validatePosition(d.start),S=this._validatePosition(d.end);return u===d.start&&S===d.end?d:new T.Range(u.line,u.character,S.line,S.character)}_validatePosition(d){if(!(d instanceof T.Position))throw new Error("Invalid argument");if(this._lines.length===0)return d.with(0,0);let{line:u,character:S}=d,b=!1;if(u<0)u=0,S=0,b=!0;else if(u>=this._lines.length)u=this._lines.length-1,S=this._lines[u].length,b=!0;else{const h=this._lines[u].length;S<0?(S=0,b=!0):S>h&&(S=h,b=!0)}return b?new T.Position(u,S):d}_getWordRangeAtPosition(d,u){const S=this._validatePosition(d);if(!u)u=_(this._languageId);else if((0,w.regExpLeadsToEndlessLoop)(u))throw new Error(`[getWordRangeAtPosition]: ignoring custom regexp '${u.source}' because it matches the empty string.`);const b=(0,t.getWordAtText)(S.character+1,(0,t.ensureValidWordDefinition)(u),this._lines[S.line],0);if(b)return new T.Range(S.line,b.startColumn-1,S.line,b.endColumn-1)}}e.ExtHostDocumentData=n;class m{constructor(d,u,S){this._line=d,this._text=u,this._isLastLine=S}get lineNumber(){return this._line}get text(){return this._text}get range(){return new T.Range(this._line,0,this._line,this._text.length)}get rangeIncludingLineBreak(){return this._isLastLine?this.range:new T.Range(this._line,0,this._line+1,0)}get firstNonWhitespaceCharacterIndex(){return/^(\s*)/.exec(this._text)[1].length}get isEmptyOrWhitespace(){return this.firstNonWhitespaceCharacterIndex===this._text.length}}e.ExtHostDocumentLine=m}),define(Ee[150],_e([0,1,7,3,224,6,55,21,2,35]),function(re,e,c,F,w,P,t,T,C,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookConcatDocument=void 0;class R{constructor(n,m,o,d){this._notebook=o,this._selector=d,this._disposables=new P.DisposableStore,this._isClosed=!1,this._versionId=0,this._onDidChange=new F.Emitter,this.onDidChange=this._onDidChange.event,this.uri=C.URI.from({scheme:"vscode-concat-doc",path:(0,k.generateUuid)()}),this._init(),this._disposables.add(m.onDidChangeDocument(S=>{const b=this._cellUris.get(S.document.uri);b!==void 0&&(this._cellLengths.setValue(b,this._cells[b].document.getText().length+1),this._cellLines.setValue(b,this._cells[b].document.lineCount),this._versionId+=1,this._onDidChange.fire(void 0))}));const u=S=>{S===this._notebook&&(this._init(),this._versionId+=1,this._onDidChange.fire(void 0))};this._disposables.add(n.onDidChangeNotebookCells(S=>u(S.document)))}dispose(){this._disposables.dispose(),this._isClosed=!0}get isClosed(){return this._isClosed}_init(){this._cells=[],this._cellUris=new T.ResourceMap;const n=[],m=[];for(const o of this._notebook.getCells())o.kind===c.NotebookCellKind.Code&&(!this._selector||(0,t.score)(this._selector,o.document.uri,o.document.languageId,!0))&&(this._cellUris.set(o.document.uri,this._cells.length),this._cells.push(o),n.push(o.document.getText().length+1),m.push(o.document.lineCount));this._cellLengths=new w.PrefixSumComputer(new Uint32Array(n)),this._cellLines=new w.PrefixSumComputer(new Uint32Array(m))}get version(){return this._versionId}getText(n){if(!n){let b="";for(const h of this._cells)b+=h.document.getText()+`
`;return b=b.slice(0,-1),b}if(n.isEmpty)return"";const m=this.locationAt(n.start),o=this.locationAt(n.end),d=this._cellUris.get(m.uri),u=this._cellUris.get(o.uri);if(d===void 0||u===void 0)return"";if(d===u)return this._cells[d].document.getText(new c.Range(m.range.start,o.range.end));const S=[this._cells[d].document.getText(new c.Range(m.range.start,new c.Position(this._cells[d].document.lineCount,0)))];for(let b=d+1;b<u;b++)S.push(this._cells[b].document.getText());return S.push(this._cells[u].document.getText(new c.Range(new c.Position(0,0),o.range.end))),S.join(`
`)}offsetAt(n){const m=this._cellLines.getIndexOf(n.line),o=this._cellLengths.getPrefixSum(m.index-1),d=this._cells[m.index].document.offsetAt(n.with(m.remainder));return o+d}positionAt(n){if(typeof n=="number"){const o=this._cellLengths.getIndexOf(n),d=this._cellLines.getPrefixSum(o.index-1);return this._cells[o.index].document.positionAt(o.remainder).translate(d)}const m=this._cellUris.get(n.uri);if(m!==void 0){const o=this._cellLines.getPrefixSum(m-1);return new c.Position(o+n.range.start.line,n.range.start.character)}return new c.Position(0,0)}locationAt(n){c.Range.isRange(n)||(n=new c.Range(n,n));const m=this._cellLines.getIndexOf(n.start.line);let o=m;n.isEmpty||(o=this._cellLines.getIndexOf(n.end.line));const d=new c.Position(m.remainder,n.start.character),u=new c.Position(o.remainder,n.end.character),S=new c.Range(d,u),b=this._cells[m.index];return new c.Location(b.document.uri,b.document.validateRange(S))}contains(n){return this._cellUris.has(n)}validateRange(n){const m=this.validatePosition(n.start),o=this.validatePosition(n.end);return n.with(m,o)}validatePosition(n){const m=this._cellLines.getIndexOf(n.line),o=new c.Position(m.remainder,n.character),d=this._cells[m.index].document.validatePosition(o),u=this._cellLines.getPrefixSum(m.index-1);return new c.Position(u+d.line,d.character)}}e.ExtHostNotebookConcatDocument=R}),define(Ee[151],_e([0,1,7,13,3]),function(re,e,c,F,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTheming=void 0;let P=class{constructor(T){this._actual=new c.ColorTheme(c.ColorThemeKind.Dark),this._onDidChangeActiveColorTheme=new w.Emitter}get activeColorTheme(){return this._actual}$onColorThemeChange(T){let C=T==="light"?c.ColorThemeKind.Light:T==="dark"?c.ColorThemeKind.Dark:c.ColorThemeKind.HighContrast;this._actual=new c.ColorTheme(C),this._onDidChangeActiveColorTheme.fire(this._actual)}get onDidChangeActiveColorTheme(){return this._onDidChangeActiveColorTheme.event}};P=Ue([$e(0,F.IExtHostRpcService)],P),e.ExtHostTheming=P}),define(Ee[65],_e([0,1,4]),function(re,e,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.URITransformerService=e.IURITransformerService=void 0,e.IURITransformerService=(0,c.createDecorator)("IURITransformerService");class F{constructor(P){P?(this.transformIncoming=P.transformIncoming.bind(P),this.transformOutgoing=P.transformOutgoing.bind(P),this.transformOutgoingURI=P.transformOutgoingURI.bind(P),this.transformOutgoingScheme=P.transformOutgoingScheme.bind(P)):(this.transformIncoming=t=>t,this.transformOutgoing=t=>t,this.transformOutgoingURI=t=>t,this.transformOutgoingScheme=t=>t)}}e.URITransformerService=F}),define(Ee[152],_e([0,1,22]),function(re,e,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.deserializeWebviewMessage=e.serializeWebviewMessage=void 0;class F{constructor(){this.buffers=[]}add(C){let k=this.buffers.indexOf(C);return k<0&&(k=this.buffers.length,this.buffers.push(C)),k}}function w(T,C){if(C.serializeBuffersForPostMessage){const k=new F,R=(m,o)=>{if(o instanceof ArrayBuffer){const d=k.add(o);return{$$vscode_array_buffer_reference$$:!0,index:d}}else if(ArrayBuffer.isView(o)){const d=P(o);if(d){const u=k.add(o.buffer);return{$$vscode_array_buffer_reference$$:!0,index:u,view:{type:d,byteLength:o.byteLength,byteOffset:o.byteOffset}}}}return o},_=JSON.stringify(T,R),n=k.buffers.map(m=>{const o=new Uint8Array(m);return c.VSBuffer.wrap(o)});return{message:_,buffers:n}}else return{message:JSON.stringify(T),buffers:[]}}e.serializeWebviewMessage=w;function P(T){switch(T.constructor.name){case"Int8Array":return 1;case"Uint8Array":return 2;case"Uint8ClampedArray":return 3;case"Int16Array":return 4;case"Uint16Array":return 5;case"Int32Array":return 6;case"Uint32Array":return 7;case"Float32Array":return 8;case"Float64Array":return 9;case"BigInt64Array":return 10;case"BigUint64Array":return 11}}function t(T,C){const k=C.map(n=>{const m=new ArrayBuffer(n.byteLength);return new Uint8Array(m).set(n.buffer),m}),R=C.length?(n,m)=>{if(typeof m=="object"&&m.$$vscode_array_buffer_reference$$){const o=m,{index:d}=o,u=k[d];if(o.view)switch(o.view.type){case 1:return new Int8Array(u,o.view.byteOffset,o.view.byteLength/Int8Array.BYTES_PER_ELEMENT);case 2:return new Uint8Array(u,o.view.byteOffset,o.view.byteLength/Uint8Array.BYTES_PER_ELEMENT);case 3:return new Uint8ClampedArray(u,o.view.byteOffset,o.view.byteLength/Uint8ClampedArray.BYTES_PER_ELEMENT);case 4:return new Int16Array(u,o.view.byteOffset,o.view.byteLength/Int16Array.BYTES_PER_ELEMENT);case 5:return new Uint16Array(u,o.view.byteOffset,o.view.byteLength/Uint16Array.BYTES_PER_ELEMENT);case 6:return new Int32Array(u,o.view.byteOffset,o.view.byteLength/Int32Array.BYTES_PER_ELEMENT);case 7:return new Uint32Array(u,o.view.byteOffset,o.view.byteLength/Uint32Array.BYTES_PER_ELEMENT);case 8:return new Float32Array(u,o.view.byteOffset,o.view.byteLength/Float32Array.BYTES_PER_ELEMENT);case 9:return new Float64Array(u,o.view.byteOffset,o.view.byteLength/Float64Array.BYTES_PER_ELEMENT);case 10:return new BigInt64Array(u,o.view.byteOffset,o.view.byteLength/BigInt64Array.BYTES_PER_ELEMENT);case 11:return new BigUint64Array(u,o.view.byteOffset,o.view.byteLength/BigUint64Array.BYTES_PER_ELEMENT);default:throw new Error("Unknown array buffer view type")}return u}return m}:void 0;return{message:JSON.parse(T,R),arrayBuffers:k}}e.deserializeWebviewMessage=t}),define(Ee[153],_e([0,1]),function(re,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TreeDataTransferConverter=void 0;var c;(function(F){function w(t){const T=new Map;return t.types.forEach((C,k)=>{T.set(C,{asString:async()=>t.items[k].asString})}),T}F.toITreeDataTransfer=w;async function P(t){const T={types:[],items:[]},C=Array.from(t.entries());for(const k of C)T.types.push(k[0]),T.items.push({asString:await k[1].asString()});return T}F.toTreeDataTransferDTO=P})(c=e.TreeDataTransferConverter||(e.TreeDataTransferConverter={}))}),define(Ee[66],_e([0,1,10,2]),function(re,e,c,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.decodeAuthority=e.asWebviewUri=e.webviewGenericCspSource=e.webviewRootResourceAuthority=e.webviewResourceBaseHost=void 0,e.webviewResourceBaseHost="vscode-webview.net",e.webviewRootResourceAuthority=`vscode-resource.${e.webviewResourceBaseHost}`,e.webviewGenericCspSource=`https://*.${e.webviewResourceBaseHost}`;function w(T,C){return T.scheme===c.Schemas.http||T.scheme===c.Schemas.https?T:(C&&C.authority&&C.isRemote&&T.scheme===c.Schemas.file&&(T=F.URI.from({scheme:c.Schemas.vscodeRemote,authority:C.authority,path:T.path})),F.URI.from({scheme:c.Schemas.https,authority:`${T.scheme}+${P(T.authority)}.${e.webviewRootResourceAuthority}`,path:T.path,fragment:T.fragment,query:T.query}))}e.asWebviewUri=w;function P(T){return T.replace(/./g,C=>{const k=C.charCodeAt(0);return k>=97&&k<=122||k>=65&&k<=90||k>=48&&k<=57?C:"-"+k.toString(16).padStart(4,"0")})}function t(T){return T.replace(/-([0-9a-f]{4})/g,(C,k)=>String.fromCharCode(parseInt(k,16)))}e.decodeAuthority=t}),define(Ee[154],_e([0,1,3,6,66]),function(re,e,c,F,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostEditorInsets=void 0;class P{constructor(T,C,k){this._proxy=T,this._editors=C,this._initData=k,this._handlePool=0,this._disposables=new F.DisposableStore,this._insets=new Map,this._disposables.add(C.onDidChangeVisibleTextEditors(()=>{const R=C.getVisibleTextEditors();for(const _ of this._insets.values())R.indexOf(_.editor)<0&&_.inset.dispose()}))}dispose(){this._insets.forEach(T=>T.inset.dispose()),this._disposables.dispose()}createWebviewEditorInset(T,C,k,R,_){let n;for(const h of this._editors.getVisibleTextEditors(!0))if(h.value===T){n=h;break}if(!n)throw new Error("not a visible editor");const m=this,o=this._handlePool++,d=new c.Emitter,u=new c.Emitter,S=new class{constructor(){this._html="",this._options=Object.create(null)}asWebviewUri(h){return(0,w.asWebviewUri)(h,m._initData.remote)}get cspSource(){return w.webviewGenericCspSource}set options(h){this._options=h,m._proxy.$setOptions(o,h)}get options(){return this._options}set html(h){this._html=h,m._proxy.$setHtml(o,h)}get html(){return this._html}get onDidReceiveMessage(){return d.event}postMessage(h){return m._proxy.$postMessage(o,h)}},b=new class{constructor(){this.editor=T,this.line=C,this.height=k,this.webview=S,this.onDidDispose=u.event}dispose(){m._insets.has(o)&&(m._insets.delete(o),m._proxy.$disposeEditorInset(o),u.fire(),u.dispose(),d.dispose())}};return this._proxy.$createEditorInset(o,n.id,n.value.document.uri,C+1,k,R||{},_.identifier,_.extensionLocation),this._insets.set(o,{editor:T,inset:b,onDidReceiveMessage:d}),b}$onDidDispose(T){const C=this._insets.get(T);C&&C.inset.dispose()}$onDidReceiveMessage(T,C){const k=this._insets.get(T);k&&k.onDidReceiveMessage.fire(C)}}e.ExtHostEditorInsets=P}),define(Ee[155],_e([0,1,126,11,2,6,4,44,36,45,16,10]),function(re,e,c,F,w,P,t,T,C,k,R,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EditorsOrder=e.pathsToEditors=e.CloseDirection=e.EditorResourceAccessor=e.SideBySideEditor=e.EditorCloseContext=e.isEditorIdentifier=e.isEditorInputWithOptionsAndGroup=e.isEditorInputWithOptions=e.isDiffEditorInput=e.isSideBySideEditorInput=e.isEditorInput=e.AbstractEditorInput=e.EditorInputCapabilities=e.SaveReason=e.Verbosity=e.isUntitledResourceEditorInput=e.isResourceSideBySideEditorInput=e.isResourceDiffEditorInput=e.isResourceEditorInput=e.findViewStateForEditor=e.BINARY_DIFF_EDITOR_ID=e.TEXT_DIFF_EDITOR_ID=e.SIDE_BY_SIDE_EDITOR_ID=e.EditorAreaVisibleContext=e.SplitEditorsVertically=e.IsCenteredLayoutContext=e.InEditorZenModeContext=e.EditorsVisibleContext=e.SingleEditorGroupsContext=e.MultipleEditorGroupsContext=e.ActiveEditorGroupLockedContext=e.ActiveEditorGroupLastContext=e.ActiveEditorGroupIndexContext=e.ActiveEditorGroupEmptyContext=e.EditorGroupEditorsCountContext=e.SideBySideEditorActiveContext=e.TextCompareEditorActiveContext=e.TextCompareEditorVisibleContext=e.ActiveEditorAvailableEditorIdsContext=e.ActiveEditorContext=e.ActiveEditorCanSplitInGroupContext=e.ActiveEditorCanRevertContext=e.ActiveEditorReadonlyContext=e.ActiveEditorStickyContext=e.ActiveEditorPinnedContext=e.ActiveEditorDirtyContext=e.DEFAULT_EDITOR_ASSOCIATION=e.EditorExtensions=void 0,e.EditorExtensions={EditorPane:"workbench.contributions.editors",EditorFactory:"workbench.contributions.editor.inputFactories"},e.DEFAULT_EDITOR_ASSOCIATION={id:"default",displayName:(0,c.localize)(0,null),providerDisplayName:(0,c.localize)(1,null)},e.ActiveEditorDirtyContext=new T.RawContextKey("activeEditorIsDirty",!1,(0,c.localize)(2,null)),e.ActiveEditorPinnedContext=new T.RawContextKey("activeEditorIsNotPreview",!1,(0,c.localize)(3,null)),e.ActiveEditorStickyContext=new T.RawContextKey("activeEditorIsPinned",!1,(0,c.localize)(4,null)),e.ActiveEditorReadonlyContext=new T.RawContextKey("activeEditorIsReadonly",!1,(0,c.localize)(5,null)),e.ActiveEditorCanRevertContext=new T.RawContextKey("activeEditorCanRevert",!1,(0,c.localize)(6,null)),e.ActiveEditorCanSplitInGroupContext=new T.RawContextKey("activeEditorCanSplitInGroup",!0),e.ActiveEditorContext=new T.RawContextKey("activeEditor",null,{type:"string",description:(0,c.localize)(7,null)}),e.ActiveEditorAvailableEditorIdsContext=new T.RawContextKey("activeEditorAvailableEditorIds","",(0,c.localize)(8,null)),e.TextCompareEditorVisibleContext=new T.RawContextKey("textCompareEditorVisible",!1,(0,c.localize)(9,null)),e.TextCompareEditorActiveContext=new T.RawContextKey("textCompareEditorActive",!1,(0,c.localize)(10,null)),e.SideBySideEditorActiveContext=new T.RawContextKey("sideBySideEditorActive",!1,(0,c.localize)(11,null)),e.EditorGroupEditorsCountContext=new T.RawContextKey("groupEditorsCount",0,(0,c.localize)(12,null)),e.ActiveEditorGroupEmptyContext=new T.RawContextKey("activeEditorGroupEmpty",!1,(0,c.localize)(13,null)),e.ActiveEditorGroupIndexContext=new T.RawContextKey("activeEditorGroupIndex",0,(0,c.localize)(14,null)),e.ActiveEditorGroupLastContext=new T.RawContextKey("activeEditorGroupLast",!1,(0,c.localize)(15,null)),e.ActiveEditorGroupLockedContext=new T.RawContextKey("activeEditorGroupLocked",!1,(0,c.localize)(16,null)),e.MultipleEditorGroupsContext=new T.RawContextKey("multipleEditorGroups",!1,(0,c.localize)(17,null)),e.SingleEditorGroupsContext=e.MultipleEditorGroupsContext.toNegated(),e.EditorsVisibleContext=new T.RawContextKey("editorIsOpen",!1,(0,c.localize)(18,null)),e.InEditorZenModeContext=new T.RawContextKey("inZenMode",!1,(0,c.localize)(19,null)),e.IsCenteredLayoutContext=new T.RawContextKey("isCenteredLayout",!1,(0,c.localize)(20,null)),e.SplitEditorsVertically=new T.RawContextKey("splitEditorsVertically",!1,(0,c.localize)(21,null)),e.EditorAreaVisibleContext=new T.RawContextKey("editorAreaVisible",!0,(0,c.localize)(22,null)),e.SIDE_BY_SIDE_EDITOR_ID="workbench.editor.sidebysideEditor",e.TEXT_DIFF_EDITOR_ID="workbench.editors.textDiffEditor",e.BINARY_DIFF_EDITOR_ID="workbench.editors.binaryResourceDiffEditor";function n(L,y,x){for(const N of x.visibleEditorPanes)if(N.group.id===y&&L.matches(N.input))return N.getViewState()}e.findViewStateForEditor=n;function m(L){if(A(L))return!1;const y=L;return w.URI.isUri(y?.resource)}e.isResourceEditorInput=m;function o(L){if(A(L))return!1;const y=L;return y?.original!==void 0&&y.modified!==void 0}e.isResourceDiffEditorInput=o;function d(L){if(A(L)||o(L))return!1;const y=L;return y?.primary!==void 0&&y.secondary!==void 0}e.isResourceSideBySideEditorInput=d;function u(L){if(A(L))return!1;const y=L;return y?y.resource===void 0||y.resource.scheme===_.Schemas.untitled||y.forceUntitled===!0:!1}e.isUntitledResourceEditorInput=u;var S;(function(L){L[L.SHORT=0]="SHORT",L[L.MEDIUM=1]="MEDIUM",L[L.LONG=2]="LONG"})(S=e.Verbosity||(e.Verbosity={}));var b;(function(L){L[L.EXPLICIT=1]="EXPLICIT",L[L.AUTO=2]="AUTO",L[L.FOCUS_CHANGE=3]="FOCUS_CHANGE",L[L.WINDOW_CHANGE=4]="WINDOW_CHANGE"})(b=e.SaveReason||(e.SaveReason={}));var h;(function(L){L[L.None=0]="None",L[L.Readonly=2]="Readonly",L[L.Untitled=4]="Untitled",L[L.Singleton=8]="Singleton",L[L.RequiresTrust=16]="RequiresTrust",L[L.CanSplitInGroup=32]="CanSplitInGroup",L[L.ForceDescription=64]="ForceDescription"})(h=e.EditorInputCapabilities||(e.EditorInputCapabilities={}));class g extends P.Disposable{}e.AbstractEditorInput=g;function A(L){return L instanceof g}e.isEditorInput=A;function l(L){const y=L;return w.URI.isUri(y?.preferredResource)}function M(L){const y=L;return A(y?.primary)&&A(y?.secondary)}e.isSideBySideEditorInput=M;function r(L){const y=L;return A(y?.modified)&&A(y?.original)}e.isDiffEditorInput=r;function i(L){return A(L?.editor)}e.isEditorInputWithOptions=i;function p(L){const y=L;return i(L)&&y?.group!==void 0}e.isEditorInputWithOptionsAndGroup=p;function f(L){const y=L;return typeof y?.groupId=="number"&&A(y.editor)}e.isEditorIdentifier=f;var s;(function(L){L[L.UNKNOWN=0]="UNKNOWN",L[L.REPLACE=1]="REPLACE",L[L.MOVE=2]="MOVE",L[L.UNPIN=3]="UNPIN"})(s=e.EditorCloseContext||(e.EditorCloseContext={}));var v;(function(L){L[L.PRIMARY=1]="PRIMARY",L[L.SECONDARY=2]="SECONDARY",L[L.BOTH=3]="BOTH",L[L.ANY=4]="ANY"})(v=e.SideBySideEditor||(e.SideBySideEditor={}));class a{getOriginalUri(y,x){if(!y)return;if(x?.supportSideBySide){const{primary:z,secondary:H}=this.getSideEditors(y);if(z&&H){if(x?.supportSideBySide===v.BOTH)return{primary:this.getOriginalUri(z,{filterByScheme:x.filterByScheme}),secondary:this.getOriginalUri(H,{filterByScheme:x.filterByScheme})};if(x?.supportSideBySide===v.ANY)return this.getOriginalUri(z,{filterByScheme:x.filterByScheme})??this.getOriginalUri(H,{filterByScheme:x.filterByScheme});y=x.supportSideBySide===v.PRIMARY?z:H}}if(o(y)||d(y))return;const N=l(y)?y.preferredResource:y.resource;return!N||!x||!x.filterByScheme?N:this.filterUri(N,x.filterByScheme)}getSideEditors(y){return M(y)||d(y)?{primary:y.primary,secondary:y.secondary}:r(y)||o(y)?{primary:y.modified,secondary:y.original}:{primary:void 0,secondary:void 0}}getCanonicalUri(y,x){if(!y)return;if(x?.supportSideBySide){const{primary:z,secondary:H}=this.getSideEditors(y);if(z&&H){if(x?.supportSideBySide===v.BOTH)return{primary:this.getCanonicalUri(z,{filterByScheme:x.filterByScheme}),secondary:this.getCanonicalUri(H,{filterByScheme:x.filterByScheme})};if(x?.supportSideBySide===v.ANY)return this.getCanonicalUri(z,{filterByScheme:x.filterByScheme})??this.getCanonicalUri(H,{filterByScheme:x.filterByScheme});y=x.supportSideBySide===v.PRIMARY?z:H}}if(o(y)||d(y))return;const N=y.resource;return!N||!x||!x.filterByScheme?N:this.filterUri(N,x.filterByScheme)}filterUri(y,x){if(Array.isArray(x)){if(x.some(N=>y.scheme===N))return y}else if(x===y.scheme)return y}}e.EditorResourceAccessor=new a;var E;(function(L){L[L.LEFT=0]="LEFT",L[L.RIGHT=1]="RIGHT"})(E=e.CloseDirection||(e.CloseDirection={}));class I{constructor(){this.editorSerializerConstructors=new Map,this.editorSerializerInstances=new Map}start(y){const x=this.instantiationService=y.get(t.IInstantiationService);for(const[N,z]of this.editorSerializerConstructors)this.createEditorSerializer(N,z,x);this.editorSerializerConstructors.clear()}createEditorSerializer(y,x,N){const z=N.createInstance(x);this.editorSerializerInstances.set(y,z)}registerFileEditorFactory(y){if(this.fileEditorFactory)throw new Error("Can only register one file editor factory.");this.fileEditorFactory=y}getFileEditorFactory(){return(0,F.assertIsDefined)(this.fileEditorFactory)}registerEditorSerializer(y,x){if(this.editorSerializerConstructors.has(y)||this.editorSerializerInstances.has(y))throw new Error(`A editor serializer with type ID '${y}' was already registered.`);return this.instantiationService?this.createEditorSerializer(y,x,this.instantiationService):this.editorSerializerConstructors.set(y,x),(0,P.toDisposable)(()=>{this.editorSerializerConstructors.delete(y),this.editorSerializerInstances.delete(y)})}getEditorSerializer(y){return this.editorSerializerInstances.get(typeof y=="string"?y:y.typeId)}}C.Registry.add(e.EditorExtensions.EditorFactory,new I);async function D(L,y){if(!L||!L.length)return[];const x=await Promise.all(L.map(async N=>{const z=w.URI.revive(N.fileUri);if(!z||!await y.canHandleResource(z))return;let q=N.exists,ue=N.type;if(typeof q!="boolean"||typeof ue!="number")try{ue=(await y.resolve(z)).isDirectory?k.FileType.Directory:k.FileType.Unknown,q=!0}catch{q=!1}if(!q&&N.openOnlyIfExists||ue===k.FileType.Directory)return;const K={selection:q?N.selection:void 0,pinned:!0,override:N.editorOverrideId};let ce;return q?ce={resource:z,options:K}:ce={resource:z,options:K,forceUntitled:!0},ce}));return(0,R.coalesce)(x)}e.pathsToEditors=D;var B;(function(L){L[L.MOST_RECENTLY_ACTIVE=0]="MOST_RECENTLY_ACTIVE",L[L.SEQUENTIAL=1]="SEQUENTIAL"})(B=e.EditorsOrder||(e.EditorsOrder={}))}),define(Ee[156],_e([0,1,3,14,127]),function(re,e,c,F,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractDebugAdapter=void 0;class P{constructor(){this.pendingRequests=new Map,this.queue=[],this._onError=new c.Emitter,this._onExit=new c.Emitter,this.sequence=1}get onError(){return this._onError.event}get onExit(){return this._onExit.event}onMessage(T){this.messageCallback&&this._onError.fire(new Error("attempt to set more than one 'Message' callback")),this.messageCallback=T}onEvent(T){this.eventCallback&&this._onError.fire(new Error("attempt to set more than one 'Event' callback")),this.eventCallback=T}onRequest(T){this.requestCallback&&this._onError.fire(new Error("attempt to set more than one 'Request' callback")),this.requestCallback=T}sendResponse(T){T.seq>0?this._onError.fire(new Error(`attempt to send more than one response for command ${T.command}`)):this.internalSend("response",T)}sendRequest(T,C,k,R){const _={command:T};if(C&&Object.keys(C).length>0&&(_.arguments=C),this.internalSend("request",_),typeof R=="number"){const n=setTimeout(()=>{clearTimeout(n);const m=this.pendingRequests.get(_.seq);if(m){this.pendingRequests.delete(_.seq);const o={type:"response",seq:0,request_seq:_.seq,success:!1,command:T,message:(0,w.localize)(0,null,R,T)};m(o)}},R)}return k&&this.pendingRequests.set(_.seq,k),_.seq}acceptMessage(T){this.messageCallback?this.messageCallback(T):(this.queue.push(T),this.queue.length===1&&this.processQueue())}needsTaskBoundaryBetween(T,C){return T.type!=="event"||C.type!=="event"}async processQueue(){let T;for(;this.queue.length;){if((!T||this.needsTaskBoundaryBetween(this.queue[0],T))&&await(0,F.timeout)(0),T=this.queue.shift(),!T)return;switch(T.type){case"event":this.eventCallback&&this.eventCallback(T);break;case"request":this.requestCallback&&this.requestCallback(T);break;case"response":const C=T,k=this.pendingRequests.get(C.request_seq);k&&(this.pendingRequests.delete(C.request_seq),k(C));break}}}internalSend(T,C){C.type=T,C.seq=this.sequence++,this.sendMessage(C)}async cancelPendingRequests(){if(this.pendingRequests.size===0)return Promise.resolve();const T=new Map;this.pendingRequests.forEach((C,k)=>T.set(k,C)),await(0,F.timeout)(500),T.forEach((C,k)=>{C({type:"response",seq:0,request_seq:k,success:!1,command:"canceled",message:"canceled"}),this.pendingRequests.delete(k)})}getPendingRequestIds(){return Array.from(this.pendingRequests.keys())}dispose(){this.queue=[]}}e.AbstractDebugAdapter=P}),define(Ee[157],_e([0,1,9,2,17,26,10]),function(re,e,c,F,w,P,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.saveAllBeforeDebugStart=e.getVisibleAndSorted=e.convertToVSCPaths=e.convertToDAPaths=e.isUri=e.getExactExpressionStartAndEnd=e.isDebuggerMainContribution=e.getExtensionHostDebugSession=e.isSessionAttach=e.filterExceptionsFromTelemetry=e.formatPII=void 0;const T=/{([^}]+)}/g;function C(r,i,p){return r.replace(T,function(f,s){return i&&s.length>0&&s[0]!=="_"?f:p&&p.hasOwnProperty(s)?p[s]:f})}e.formatPII=C;function k(r){const i={};for(const p of Object.keys(r))p.startsWith("!")||(i[p]=r[p]);return i}e.filterExceptionsFromTelemetry=k;function R(r){return r.configuration.request==="attach"&&!_(r)&&(!r.parentSession||R(r.parentSession))}e.isSessionAttach=R;function _(r){let i=r.configuration.type;if(!!i)return i==="vslsShare"&&(i=r.configuration.adapterProxy.configuration.type),(0,c.equalsIgnoreCase)(i,"extensionhost")||(0,c.equalsIgnoreCase)(i,"pwa-extensionhost")?r:r.parentSession?_(r.parentSession):void 0}e.getExtensionHostDebugSession=_;function n(r){return r.type&&(r.label||r.program||r.runtime)}e.isDebuggerMainContribution=n;function m(r,i,p){let f,s=0,v=/([^()\[\]{}<>\s+\-/%~#^;=|,`!]|\->)+/g,a=null;for(;a=v.exec(r);){let E=a.index+1,I=E+a[0].length;if(E<=i&&I>=p){f=a[0],s=E;break}}if(f){let E=/\w+/g,I=null;for(;(I=E.exec(f))&&!(I.index+1+s+I[0].length>=p););I&&(f=f.substring(0,E.lastIndex))}return f?{start:s,end:s+f.length-1}:{start:0,end:0}}e.getExactExpressionStartAndEnd=m;const o=/^[a-zA-Z][a-zA-Z0-9\+\-\.]+:/;function d(r){return!!(r&&r.match(o))}e.isUri=d;function u(r){if(typeof r.path=="string"&&!(typeof r.sourceReference=="number"&&r.sourceReference>0)){if(d(r.path))return F.URI.parse(r.path);if((0,w.isAbsolute)(r.path))return F.URI.file(r.path)}return r.path}function S(r){if(typeof r.path=="object"){const i=F.URI.revive(r.path);if(i)return i.scheme===t.Schemas.file?i.fsPath:i.toString()}return r.path}function b(r,i){const p=i?u:S,f=(0,P.deepClone)(r);return g(f,(s,v)=>{s&&v&&(v.path=p(v))}),f}e.convertToDAPaths=b;function h(r,i){const p=i?u:S,f=(0,P.deepClone)(r);return g(f,(s,v)=>{!s&&v&&(v.path=p(v))}),f}e.convertToVSCPaths=h;function g(r,i){switch(r.type){case"event":const p=r;switch(p.event){case"output":i(!1,p.body.source);break;case"loadedSource":i(!1,p.body.source);break;case"breakpoint":i(!1,p.body.breakpoint.source);break;default:break}break;case"request":const f=r;switch(f.command){case"setBreakpoints":i(!0,f.arguments.source);break;case"breakpointLocations":i(!0,f.arguments.source);break;case"source":i(!0,f.arguments.source);break;case"gotoTargets":i(!0,f.arguments.source);break;case"launchVSCode":f.arguments.args.forEach(v=>i(!1,v));break;default:break}break;case"response":const s=r;if(s.success&&s.body)switch(s.command){case"stackTrace":s.body.stackFrames.forEach(v=>i(!1,v.source));break;case"loadedSources":s.body.sources.forEach(v=>i(!1,v));break;case"scopes":s.body.scopes.forEach(v=>i(!1,v.source));break;case"setFunctionBreakpoints":s.body.breakpoints.forEach(v=>i(!1,v.source));break;case"setBreakpoints":s.body.breakpoints.forEach(v=>i(!1,v.source));break;default:break}break}}function A(r){return r.filter(i=>!i.presentation?.hidden).sort((i,p)=>i.presentation?p.presentation?i.presentation.group?p.presentation.group?i.presentation.group!==p.presentation.group?i.presentation.group.localeCompare(p.presentation.group):l(i.presentation.order,p.presentation.order):-1:p.presentation.group?1:l(i.presentation.order,p.presentation.order):-1:p.presentation?1:0)}e.getVisibleAndSorted=A;function l(r,i){return typeof r!="number"?typeof i!="number"?0:1:typeof i!="number"?-1:r-i}async function M(r,i){const p=r.getValue("debug.saveBeforeStart",{overrideIdentifier:i.activeTextEditorMode});if(p!=="none"&&(await i.saveAll(),p==="allEditorsInActiveGroup")){const f=i.activeEditorPane;f&&await i.save({editor:f.input,groupId:f.group.id})}await r.reloadConfiguration()}e.saveAllBeforeDebugStart=M}),define(Ee[87],_e([0,1,29,158,78,10,17,23,44]),function(re,e,c,F,w,P,t,T,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NotebookWorkingCopyTypeIdentifier=e.CellStatusbarAlignment=e.NotebookSetting=e.CellSequence=e.notebookDocumentFilterMatch=e.isDocumentExcludePattern=e.NotebookEditorPriority=e.NOTEBOOK_EDITOR_CURSOR_BOUNDARY=e.diff=e.MimeTypeDisplayOrder=e.mimeTypeIsMergeable=e.mimeTypeSupportedByCore=e.mimeTypeIsAlwaysSecure=e.CellUri=e.CellEditType=e.SelectionStateType=e.NotebookCellsChangeType=e.RendererMessagingSpec=e.NotebookRendererMatch=e.NotebookCellExecutionState=e.NotebookRunState=e.RENDERER_NOT_AVAILABLE=e.BUILTIN_RENDERER_ID=e.RENDERER_EQUIVALENT_EXTENSIONS=e.ACCESSIBLE_NOTEBOOK_DISPLAY_ORDER=e.NOTEBOOK_DISPLAY_ORDER=e.CellKind=void 0;var k;(function(E){E[E.Markup=1]="Markup",E[E.Code=2]="Code"})(k=e.CellKind||(e.CellKind={})),e.NOTEBOOK_DISPLAY_ORDER=["application/json","application/javascript","text/html","image/svg+xml",w.Mimes.latex,w.Mimes.markdown,"image/png","image/jpeg",w.Mimes.text],e.ACCESSIBLE_NOTEBOOK_DISPLAY_ORDER=[w.Mimes.latex,w.Mimes.markdown,"application/json",w.Mimes.text,"text/html","image/svg+xml","image/png","image/jpeg"],e.RENDERER_EQUIVALENT_EXTENSIONS=new Map([["ms-toolsai.jupyter",new Set(["jupyter-notebook","interactive"])],["ms-toolsai.jupyter-renderers",new Set(["jupyter-notebook","interactive"])]]),e.BUILTIN_RENDERER_ID="_builtin",e.RENDERER_NOT_AVAILABLE="_notAvailable";var R;(function(E){E[E.Running=1]="Running",E[E.Idle=2]="Idle"})(R=e.NotebookRunState||(e.NotebookRunState={}));var _;(function(E){E[E.Pending=2]="Pending",E[E.Executing=3]="Executing"})(_=e.NotebookCellExecutionState||(e.NotebookCellExecutionState={}));var n;(function(E){E[E.WithHardKernelDependency=0]="WithHardKernelDependency",E[E.WithOptionalKernelDependency=1]="WithOptionalKernelDependency",E[E.Pure=2]="Pure",E[E.Never=3]="Never"})(n=e.NotebookRendererMatch||(e.NotebookRendererMatch={}));var m;(function(E){E.Always="always",E.Never="never",E.Optional="optional"})(m=e.RendererMessagingSpec||(e.RendererMessagingSpec={}));var o;(function(E){E[E.ModelChange=1]="ModelChange",E[E.Move=2]="Move",E[E.ChangeLanguage=5]="ChangeLanguage",E[E.Initialize=6]="Initialize",E[E.ChangeCellMetadata=7]="ChangeCellMetadata",E[E.Output=8]="Output",E[E.OutputItem=9]="OutputItem",E[E.ChangeCellContent=10]="ChangeCellContent",E[E.ChangeDocumentMetadata=11]="ChangeDocumentMetadata",E[E.ChangeCellInternalMetadata=12]="ChangeCellInternalMetadata",E[E.ChangeCellMime=13]="ChangeCellMime",E[E.Unknown=100]="Unknown"})(o=e.NotebookCellsChangeType||(e.NotebookCellsChangeType={}));var d;(function(E){E[E.Handle=0]="Handle",E[E.Index=1]="Index"})(d=e.SelectionStateType||(e.SelectionStateType={}));var u;(function(E){E[E.Replace=1]="Replace",E[E.Output=2]="Output",E[E.Metadata=3]="Metadata",E[E.CellLanguage=4]="CellLanguage",E[E.DocumentMetadata=5]="DocumentMetadata",E[E.Move=6]="Move",E[E.OutputItems=7]="OutputItems",E[E.PartialMetadata=8]="PartialMetadata",E[E.PartialInternalMetadata=9]="PartialInternalMetadata"})(u=e.CellEditType||(e.CellEditType={}));var S;(function(E){E.scheme=P.Schemas.vscodeNotebookCell;const I=/^ch(\d{7,})/;function D(z,H){return z.with({scheme:E.scheme,fragment:`ch${H.toString().padStart(7,"0")}${z.scheme!==P.Schemas.file?z.scheme:""}`})}E.generate=D;function B(z){if(z.scheme!==E.scheme)return;const H=I.exec(z.fragment);return H?{handle:Number(H[1]),notebook:z.with({scheme:z.fragment.substr(H[0].length)||P.Schemas.file,fragment:null})}:void 0}E.parse=B;function L(z,H,q){return z.with({scheme:P.Schemas.vscodeNotebookCellOutput,fragment:`ch${H.toString().padStart(7,"0")},${q??""},${z.scheme!==P.Schemas.file?z.scheme:""}`})}E.generateCellOutputUri=L;function y(z){if(z.scheme!==P.Schemas.vscodeNotebookCellOutput)return;const H=/^ch(\d{7,})\,([0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12})?\,(.*)$/i.exec(z.fragment);if(!H)return;const q=Number(H[1]),ue=H[2]&&H[2]!==""?H[2]:void 0,K=H[3];return{handle:q,outputId:ue,notebook:z.with({scheme:K||P.Schemas.file,fragment:null})}}E.parseCellOutputUri=y;function x(z,H,q){return z.with({scheme:q,fragment:`ch${H.toString().padStart(7,"0")}${z.scheme!==P.Schemas.file?z.scheme:""}`})}E.generateCellUri=x;function N(z,H){if(z.scheme!==H)return;const q=I.exec(z.fragment);return q?{handle:Number(q[1]),notebook:z.with({scheme:z.fragment.substr(q[0].length)||P.Schemas.file,fragment:null})}:void 0}E.parseCellUri=N})(S=e.CellUri||(e.CellUri={}));const b=new Map([["application/javascript",{supportedByCore:!0}],["image/png",{alwaysSecure:!0,supportedByCore:!0}],["image/jpeg",{alwaysSecure:!0,supportedByCore:!0}],["image/git",{alwaysSecure:!0,supportedByCore:!0}],["image/svg+xml",{supportedByCore:!0}],["application/json",{alwaysSecure:!0,supportedByCore:!0}],[w.Mimes.latex,{alwaysSecure:!0,supportedByCore:!0}],[w.Mimes.text,{alwaysSecure:!0,supportedByCore:!0}],["text/html",{supportedByCore:!0}],["text/x-javascript",{alwaysSecure:!0,supportedByCore:!0}],["application/vnd.code.notebook.error",{alwaysSecure:!0,supportedByCore:!0}],["application/vnd.code.notebook.stdout",{alwaysSecure:!0,supportedByCore:!0,mergeable:!0}],["application/vnd.code.notebook.stderr",{alwaysSecure:!0,supportedByCore:!0,mergeable:!0}]]);function h(E){return b.get(E)?.alwaysSecure??!1}e.mimeTypeIsAlwaysSecure=h;function g(E){return b.get(E)?.supportedByCore??!1}e.mimeTypeSupportedByCore=g;function A(E){return b.get(E)?.mergeable??!1}e.mimeTypeIsMergeable=A;const l=E=>T.isWindows?E.replace(/\//g,"\\"):E;class M{constructor(I=[],D=e.NOTEBOOK_DISPLAY_ORDER){this.defaultOrder=D,this.order=[...new Set(I)].map(B=>({pattern:B,matches:c.parse(l(B))}))}sort(I){const D=new Map(F.Iterable.map(I,L=>[L,l(L)]));let B=[];for(const{matches:L}of this.order)for(const[y,x]of D)if(L(x)){B.push(y),D.delete(y);break}return D.size&&(B=B.concat([...D.keys()].sort((L,y)=>this.defaultOrder.indexOf(L)-this.defaultOrder.indexOf(y)))),B}prioritize(I,D){const B=this.findIndex(I);if(B===-1){this.order.unshift({pattern:I,matches:c.parse(l(I))});return}const L=new Set(D.map(x=>this.findIndex(x,B)));L.delete(-1);const y=Array.from(L).sort();this.order.splice(B+1,0,...y.map(x=>this.order[x]));for(let x=y.length-1;x>=0;x--)this.order.splice(y[x],1)}toArray(){return this.order.map(I=>I.pattern)}findIndex(I,D=this.order.length){const B=l(I);for(let L=0;L<D;L++)if(this.order[L].matches(B))return L;return-1}}e.MimeTypeDisplayOrder=M;function r(E,I,D,B=(L,y)=>L===y){const L=[];function y(z,H,q){if(H===0&&q.length===0)return;const ue=L[L.length-1];ue&&ue.start+ue.deleteCount===z?(ue.deleteCount+=H,ue.toInsert.push(...q)):L.push({start:z,deleteCount:H,toInsert:q})}let x=0,N=0;for(;;){if(x===E.length){y(x,0,I.slice(N));break}if(N===I.length){y(x,E.length-x,[]);break}const z=E[x],H=I[N];if(B(z,H)){x+=1,N+=1;continue}D(H)?(y(x,1,[]),x+=1):(y(x,0,[H]),N+=1)}return L}e.diff=r,e.NOTEBOOK_EDITOR_CURSOR_BOUNDARY=new C.RawContextKey("notebookEditorCursorAtBoundary","none");var i;(function(E){E.default="default",E.option="option"})(i=e.NotebookEditorPriority||(e.NotebookEditorPriority={}));function p(E){const I=E;return!!((typeof I.include=="string"||c.isRelativePattern(I.include))&&(typeof I.exclude=="string"||c.isRelativePattern(I.exclude)))}e.isDocumentExcludePattern=p;function f(E,I,D){if(Array.isArray(E.viewType)&&E.viewType.indexOf(I)>=0||E.viewType===I)return!0;if(E.filenamePattern){let B=p(E.filenamePattern)?E.filenamePattern.include:E.filenamePattern,L=p(E.filenamePattern)?E.filenamePattern.exclude:void 0;if(c.match(B,(0,t.basename)(D.fsPath).toLowerCase()))return!(L&&c.match(L,(0,t.basename)(D.fsPath).toLowerCase()))}return!1}e.notebookDocumentFilterMatch=f;class s{constructor(I){this.textModel=I}getElements(){const I=new Int32Array(this.textModel.cells.length);for(let D=0;D<this.textModel.cells.length;D++)I[D]=this.textModel.cells[D].getHashValue();return I}}e.CellSequence=s,e.NotebookSetting={displayOrder:"notebook.displayOrder",cellToolbarLocation:"notebook.cellToolbarLocation",cellToolbarVisibility:"notebook.cellToolbarVisibility",showCellStatusBar:"notebook.showCellStatusBar",textDiffEditorPreview:"notebook.diff.enablePreview",experimentalInsertToolbarAlignment:"notebook.experimental.insertToolbarAlignment",compactView:"notebook.compactView",focusIndicator:"notebook.cellFocusIndicator",insertToolbarLocation:"notebook.insertToolbarLocation",globalToolbar:"notebook.globalToolbar",undoRedoPerCell:"notebook.undoRedoPerCell",consolidatedOutputButton:"notebook.consolidatedOutputButton",showFoldingControls:"notebook.showFoldingControls",dragAndDropEnabled:"notebook.dragAndDropEnabled",cellEditorOptionsCustomizations:"notebook.editorOptionsCustomizations",consolidatedRunButton:"notebook.consolidatedRunButton",openGettingStarted:"notebook.experimental.openGettingStarted",textOutputLineLimit:"notebook.output.textLineLimit",globalToolbarShowLabel:"notebook.globalToolbarShowLabel",markupFontSize:"notebook.markup.fontSize"};var v;(function(E){E[E.Left=1]="Left",E[E.Right=2]="Right"})(v=e.CellStatusbarAlignment||(e.CellStatusbarAlignment={}));class a{static create(I){return`${a._prefix}${I}`}static parse(I){if(I.startsWith(a._prefix))return I.substr(a._prefix.length)}}e.NotebookWorkingCopyTypeIdentifier=a,a._prefix="notebook/"}),define(Ee[159],_e([0,1,4]),function(re,e,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.INotebookExecutionService=e.CellExecutionUpdateType=void 0;var F;(function(w){w[w.Output=1]="Output",w[w.OutputItems=2]="OutputItems",w[w.ExecutionState=3]="ExecutionState",w[w.Complete=4]="Complete"})(F=e.CellExecutionUpdateType||(e.CellExecutionUpdateType={})),e.INotebookExecutionService=(0,c.createDecorator)("INotebookExecutionService")}),define(Ee[160],_e([0,1,4,44]),function(re,e,c,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.OutputChannelUpdateMode=e.IOutputService=e.CONTEXT_OUTPUT_SCROLL_LOCK=e.CONTEXT_ACTIVE_LOG_OUTPUT=e.CONTEXT_IN_OUTPUT=e.MAX_OUTPUT_LENGTH=e.OUTPUT_SERVICE_ID=e.OUTPUT_VIEW_ID=e.LOG_MODE_ID=e.LOG_SCHEME=e.LOG_MIME=e.OUTPUT_MODE_ID=e.OUTPUT_SCHEME=e.OUTPUT_MIME=void 0,e.OUTPUT_MIME="text/x-code-output",e.OUTPUT_SCHEME="output",e.OUTPUT_MODE_ID="Log",e.LOG_MIME="text/x-code-log-output",e.LOG_SCHEME="log",e.LOG_MODE_ID="log",e.OUTPUT_VIEW_ID="workbench.panel.output",e.OUTPUT_SERVICE_ID="outputService",e.MAX_OUTPUT_LENGTH=1e4*100,e.CONTEXT_IN_OUTPUT=new F.RawContextKey("inOutput",!1),e.CONTEXT_ACTIVE_LOG_OUTPUT=new F.RawContextKey("activeLogOutput",!1),e.CONTEXT_OUTPUT_SCROLL_LOCK=new F.RawContextKey("outputView.scrollLock",!1),e.IOutputService=(0,c.createDecorator)(e.OUTPUT_SERVICE_ID);var w;(function(P){P[P.Append=1]="Append",P[P.Replace=2]="Replace",P[P.Clear=3]="Clear"})(w=e.OutputChannelUpdateMode||(e.OutputChannelUpdateMode={}))}),define(Ee[161],_e([0,1,129,4,44]),function(re,e,c,F,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.USER_TASKS_GROUP_KEY=e.ITaskService=e.ProcessExecutionSupportedContext=e.ShellExecutionSupportedContext=e.CustomExecutionSupportedContext=void 0,e.CustomExecutionSupportedContext=new w.RawContextKey("customExecutionSupported",!0,c.localize(0,null)),e.ShellExecutionSupportedContext=new w.RawContextKey("shellExecutionSupported",!1,c.localize(1,null)),e.ProcessExecutionSupportedContext=new w.RawContextKey("processExecutionSupported",!1,c.localize(2,null)),e.ITaskService=(0,F.createDecorator)("taskService"),e.USER_TASKS_GROUP_KEY="settings"}),define(Ee[162],_e([0,1]),function(re,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.deserializeEnvironmentVariableCollection=e.serializeEnvironmentVariableCollection=void 0;function c(w){return[...w.entries()]}e.serializeEnvironmentVariableCollection=c;function F(w){return new Map(w)}e.deserializeEnvironmentVariableCollection=F}),define(Ee[88],_e([0,1]),function(re,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractIncrementalTestCollection=e.IncrementalChangeCollector=e.TestDiffOpType=e.DetailType=e.applyTestItemUpdate=e.TestItemExpandState=e.TestMessageType=e.testRunProfileBitsetList=e.TestRunProfileBitset=e.TestResultState=void 0;var c;(function(_){_[_.Unset=0]="Unset",_[_.Queued=1]="Queued",_[_.Running=2]="Running",_[_.Passed=3]="Passed",_[_.Failed=4]="Failed",_[_.Skipped=5]="Skipped",_[_.Errored=6]="Errored"})(c=e.TestResultState||(e.TestResultState={}));var F;(function(_){_[_.Run=2]="Run",_[_.Debug=4]="Debug",_[_.Coverage=8]="Coverage",_[_.HasNonDefaultProfile=16]="HasNonDefaultProfile",_[_.HasConfigurable=32]="HasConfigurable"})(F=e.TestRunProfileBitset||(e.TestRunProfileBitset={})),e.testRunProfileBitsetList=[2,4,8,16];var w;(function(_){_[_.Error=0]="Error",_[_.Info=1]="Info"})(w=e.TestMessageType||(e.TestMessageType={}));var P;(function(_){_[_.NotExpandable=0]="NotExpandable",_[_.Expandable=1]="Expandable",_[_.BusyExpanding=2]="BusyExpanding",_[_.Expanded=3]="Expanded"})(P=e.TestItemExpandState||(e.TestItemExpandState={}));const t=(_,n)=>{n.expand!==void 0&&(_.expand=n.expand),n.item!==void 0&&(_.item=_.item?Object.assign(_.item,n.item):n.item)};e.applyTestItemUpdate=t;var T;(function(_){_[_.Function=0]="Function",_[_.Statement=1]="Statement"})(T=e.DetailType||(e.DetailType={}));var C;(function(_){_[_.Add=0]="Add",_[_.Update=1]="Update",_[_.Remove=2]="Remove",_[_.IncrementPendingExtHosts=3]="IncrementPendingExtHosts",_[_.Retire=4]="Retire",_[_.AddTag=5]="AddTag",_[_.RemoveTag=6]="RemoveTag"})(C=e.TestDiffOpType||(e.TestDiffOpType={}));class k{add(n){}update(n){}remove(n,m){}complete(){}}e.IncrementalChangeCollector=k;class R{constructor(){this._tags=new Map,this.items=new Map,this.roots=new Set,this.busyControllerCount=0,this.pendingRootCount=0,this.tags=this._tags}apply(n){const m=this.createChangeCollector();for(const o of n)switch(o[0]){case 0:{const d=o[1];if(d.parent){if(this.items.has(d.parent)){const u=this.items.get(d.parent);u.children.add(d.item.extId);const S=this.createItem(d,u);this.items.set(d.item.extId,S),m.add(S)}}else{const u=this.createItem(d);this.roots.add(u),this.items.set(d.item.extId,u),m.add(u)}d.expand===2&&this.busyControllerCount++;break}case 1:{const d=o[1],u=this.items.get(d.extId);if(!u)break;d.expand!==void 0&&(u.expand===2&&this.busyControllerCount--,d.expand===2&&this.busyControllerCount++),(0,e.applyTestItemUpdate)(u,d),m.update(u);break}case 2:{const d=this.items.get(o[1]);if(!d)break;d.parent?this.items.get(d.parent).children.delete(d.item.extId):this.roots.delete(d);const u=[[o[1]]];for(;u.length;)for(const S of u.pop()){const b=this.items.get(S);b&&(u.push(b.children),this.items.delete(S),m.remove(b,b!==d),b.expand===2&&this.busyControllerCount--)}break}case 4:this.retireTest(o[1]);break;case 3:this.updatePendingRoots(o[1]);break;case 5:this._tags.set(o[1].id,o[1]);break;case 6:this._tags.delete(o[1]);break}m.complete()}retireTest(n){}updatePendingRoots(n){this.pendingRootCount+=n}createChangeCollector(){return new k}}e.AbstractIncrementalTestCollection=R}),define(Ee[67],_e([0,1]),function(re,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TestId=e.TestPosition=e.TestIdPathParts=void 0;var c;(function(P){P.Delimiter="\0"})(c=e.TestIdPathParts||(e.TestIdPathParts={}));var F;(function(P){P[P.IsSame=0]="IsSame",P[P.Disconnected=1]="Disconnected",P[P.IsChild=2]="IsChild",P[P.IsParent=3]="IsParent"})(F=e.TestPosition||(e.TestPosition={}));class w{constructor(t,T=t.length){if(this.path=t,this.viewEnd=T,t.length===0||T<1)throw new Error("cannot create test with empty path")}static fromExtHostTestItem(t,T,C=t.parent){if(t.id===T)return new w([T]);let k=[t.id];for(let R=C;R&&R.id!==T;R=R.parent)k.push(R.id);return k.push(T),new w(k.reverse())}static isRoot(t){return!t.includes("\0")}static fromString(t){return new w(t.split("\0"))}static join(t,T){return new w([...t.path,T])}static joinToString(t,T){return t.toString()+"\0"+T}static compare(t,T){return t===T?0:T.startsWith(t+"\0")?2:t.startsWith(T+"\0")?3:1}get parentId(){return this.viewEnd>1?new w(this.path,this.viewEnd-1):this}get localId(){return this.path[this.viewEnd-1]}get controllerId(){return this.path[0]}get isRoot(){return this.viewEnd===1}*idsFromRoot(){for(let t=1;t<=this.viewEnd;t++)yield new w(this.path,t)}compare(t){if(typeof t=="string")return w.compare(this.toString(),t);for(let T=0;T<t.viewEnd&&T<this.viewEnd;T++)if(t.path[T]!==this.path[T])return 1;return t.viewEnd>this.viewEnd?2:t.viewEnd<this.viewEnd?3:0}toJSON(){return this.toString()}toString(){if(!this.stringifed){this.stringifed=this.path[0];for(let t=1;t<this.viewEnd;t++)this.stringifed+="\0",this.stringifed+=this.path[t]}return this.stringifed}}e.TestId=w}),define(Ee[163],_e([0,1,17,89,11,26,23,77,130]),function(re,e,c,F,w,P,t,T,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractVariableResolverService=void 0;class k{constructor(_,n,m){this._contributedVariables=new Map,this._context=_,this._labelService=n,m&&(this._envVariablesPromise=m.then(o=>this.prepareEnv(o)))}prepareEnv(_){if(t.isWindows){const n=Object.create(null);return Object.keys(_).forEach(m=>{n[m.toLowerCase()]=_[m]}),n}return _}resolveWithEnvironment(_,n,m){return this.recursiveResolve(this.prepareEnv(_),n?n.uri:void 0,m)}async resolveAsync(_,n){return this.recursiveResolve(await this._envVariablesPromise,_?_.uri:void 0,n)}async resolveAnyBase(_,n,m,o){const d=P.deepClone(n);return t.isWindows&&d.windows?Object.keys(d.windows).forEach(u=>d[u]=d.windows[u]):t.isMacintosh&&d.osx?Object.keys(d.osx).forEach(u=>d[u]=d.osx[u]):t.isLinux&&d.linux&&Object.keys(d.linux).forEach(u=>d[u]=d.linux[u]),delete d.windows,delete d.osx,delete d.linux,this.recursiveResolve(await this._envVariablesPromise,_?_.uri:void 0,d,m,o)}async resolveAnyAsync(_,n,m){return this.resolveAnyBase(_,n,m)}async resolveAnyMap(_,n,m){const o=new Map;return{newConfig:await this.resolveAnyBase(_,n,m,o),resolvedVariables:o}}resolveWithInteractionReplace(_,n,m,o){throw new Error("resolveWithInteractionReplace not implemented.")}resolveWithInteraction(_,n,m,o){throw new Error("resolveWithInteraction not implemented.")}contributeVariable(_,n){if(this._contributedVariables.has(_))throw new Error("Variable "+_+" is contributed twice.");this._contributedVariables.set(_,n)}recursiveResolve(_,n,m,o,d){if(w.isString(m))return this.resolveString(_,n,m,o,d);if(w.isArray(m))return m.map(u=>this.recursiveResolve(_,n,u,o,d));if(w.isObject(m)){let u=Object.create(null);return Object.keys(m).forEach(S=>{const b=this.resolveString(_,n,S,o,d);u[b]=this.recursiveResolve(_,n,m[S],o,d)}),u}return m}resolveString(_,n,m,o,d){return m.replace(k.VARIABLE_REGEXP,(S,b)=>{if(b.includes(k.VARIABLE_LHS))return S;let h=this.evaluateSingleVariable(_,S,b,n,o);return d&&d.set(b,h),h!==S&&w.isString(h)&&h.match(k.VARIABLE_REGEXP)&&(h=this.resolveString(_,n,h,o,d)),h})}fsPath(_){return this._labelService?this._labelService.getUriLabel(_,{noPrefix:!0}):_.fsPath}evaluateSingleVariable(_,n,m,o,d){let u;const S=m.split(":");S.length>1&&(m=S[0],u=S[1]);const b=()=>{const A=this._context.getFilePath();if(A)return A;throw new Error((0,C.localize)(0,null,n))},h=()=>{const A=b();if(this._context.getWorkspaceFolderPathForFile){const l=this._context.getWorkspaceFolderPathForFile();if(l)return l}throw new Error((0,C.localize)(1,null,n,c.basename(A)))},g=()=>{if(u){const A=this._context.getFolderUri(u);if(A)return A;throw new Error((0,C.localize)(2,null,n,u))}if(o)return o;throw this._context.getWorkspaceFolderCount()>1?new Error((0,C.localize)(3,null,n)):new Error((0,C.localize)(4,null,n))};switch(m){case"env":if(u){if(_){const A=_[t.isWindows?u.toLowerCase():u];if(w.isString(A))return A}return""}throw new Error((0,C.localize)(5,null,n));case"config":if(u){const A=this._context.getConfigurationValue(o,u);if(w.isUndefinedOrNull(A))throw new Error((0,C.localize)(6,null,n,u));if(w.isObject(A))throw new Error((0,C.localize)(7,null,n,u));return A}throw new Error((0,C.localize)(8,null,n));case"command":return this.resolveFromMap(n,u,d,"command");case"input":return this.resolveFromMap(n,u,d,"input");default:switch(m){case"workspaceRoot":case"workspaceFolder":return(0,T.normalizeDriveLetter)(this.fsPath(g()));case"cwd":return o||u?(0,T.normalizeDriveLetter)(this.fsPath(g())):F.cwd();case"workspaceRootFolderName":case"workspaceFolderBasename":return c.basename(this.fsPath(g()));case"lineNumber":const A=this._context.getLineNumber();if(A)return A;throw new Error((0,C.localize)(9,null,n));case"selectedText":const l=this._context.getSelectedText();if(l)return l;throw new Error((0,C.localize)(10,null,n));case"file":return b();case"fileWorkspaceFolder":return h();case"relativeFile":return o||u?c.relative(this.fsPath(g()),b()):b();case"relativeFileDirname":const M=c.dirname(b());if(o||u){const f=c.relative(this.fsPath(g()),M);return f.length===0?".":f}return M;case"fileDirname":return c.dirname(b());case"fileExtname":return c.extname(b());case"fileBasename":return c.basename(b());case"fileBasenameNoExtension":const r=c.basename(b());return r.slice(0,r.length-c.extname(r).length);case"fileDirnameBasename":return c.basename(c.dirname(b()));case"execPath":const i=this._context.getExecPath();return i||n;case"execInstallFolder":const p=this._context.getAppRoot();return p||n;case"pathSeparator":return c.sep;default:try{const f=u?`${m}:${u}`:m;return this.resolveFromMap(n,f,d,void 0)}catch(f){return n}}}}resolveFromMap(_,n,m,o){if(n&&m){const d=o===void 0?m[n]:m[o+":"+n];if(typeof d=="string")return d;throw new Error((0,C.localize)(11,null,_))}return _}}e.AbstractVariableResolverService=k,k.VARIABLE_LHS="${",k.VARIABLE_REGEXP=/\$\{(.*?)\}/g}),define(Ee[90],_e([0,1,4,155]),function(re,e,c,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.preferredSideBySideGroupDirection=e.isEditorGroup=e.OpenEditorContext=e.GroupChangeKind=e.GroupsOrder=e.isEditorReplacement=e.MergeGroupMode=e.GroupsArrangement=e.GroupLocation=e.GroupOrientation=e.GroupDirection=e.IEditorGroupsService=void 0,e.IEditorGroupsService=(0,c.createDecorator)("editorGroupsService");var w;(function(d){d[d.UP=0]="UP",d[d.DOWN=1]="DOWN",d[d.LEFT=2]="LEFT",d[d.RIGHT=3]="RIGHT"})(w=e.GroupDirection||(e.GroupDirection={}));var P;(function(d){d[d.HORIZONTAL=0]="HORIZONTAL",d[d.VERTICAL=1]="VERTICAL"})(P=e.GroupOrientation||(e.GroupOrientation={}));var t;(function(d){d[d.FIRST=0]="FIRST",d[d.LAST=1]="LAST",d[d.NEXT=2]="NEXT",d[d.PREVIOUS=3]="PREVIOUS"})(t=e.GroupLocation||(e.GroupLocation={}));var T;(function(d){d[d.MINIMIZE_OTHERS=0]="MINIMIZE_OTHERS",d[d.EVEN=1]="EVEN",d[d.TOGGLE=2]="TOGGLE"})(T=e.GroupsArrangement||(e.GroupsArrangement={}));var C;(function(d){d[d.COPY_EDITORS=0]="COPY_EDITORS",d[d.MOVE_EDITORS=1]="MOVE_EDITORS"})(C=e.MergeGroupMode||(e.MergeGroupMode={}));function k(d){const u=d;return(0,F.isEditorInput)(u?.editor)&&(0,F.isEditorInput)(u?.replacement)}e.isEditorReplacement=k;var R;(function(d){d[d.CREATION_TIME=0]="CREATION_TIME",d[d.MOST_RECENTLY_ACTIVE=1]="MOST_RECENTLY_ACTIVE",d[d.GRID_APPEARANCE=2]="GRID_APPEARANCE"})(R=e.GroupsOrder||(e.GroupsOrder={}));var _;(function(d){d[d.GROUP_ACTIVE=0]="GROUP_ACTIVE",d[d.GROUP_INDEX=1]="GROUP_INDEX",d[d.GROUP_LOCKED=2]="GROUP_LOCKED",d[d.EDITOR_OPEN=3]="EDITOR_OPEN",d[d.EDITOR_CLOSE=4]="EDITOR_CLOSE",d[d.EDITOR_MOVE=5]="EDITOR_MOVE",d[d.EDITOR_ACTIVE=6]="EDITOR_ACTIVE",d[d.EDITOR_LABEL=7]="EDITOR_LABEL",d[d.EDITOR_CAPABILITIES=8]="EDITOR_CAPABILITIES",d[d.EDITOR_PIN=9]="EDITOR_PIN",d[d.EDITOR_STICKY=10]="EDITOR_STICKY",d[d.EDITOR_DIRTY=11]="EDITOR_DIRTY"})(_=e.GroupChangeKind||(e.GroupChangeKind={}));var n;(function(d){d[d.NEW_EDITOR=1]="NEW_EDITOR",d[d.MOVE_EDITOR=2]="MOVE_EDITOR",d[d.COPY_EDITOR=3]="COPY_EDITOR"})(n=e.OpenEditorContext||(e.OpenEditorContext={}));function m(d){const u=d;return!!u&&typeof u.id=="number"&&Array.isArray(u.editors)}e.isEditorGroup=m;function o(d){return d.getValue("workbench.editor.openSideBySideDirection")==="down"?1:3}e.preferredSideBySideGroupDirection=o}),define(Ee[164],_e([0,1,4,90]),function(re,e,c,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isPreferredGroup=e.SIDE_GROUP=e.ACTIVE_GROUP=e.IEditorService=void 0,e.IEditorService=(0,c.createDecorator)("editorService"),e.ACTIVE_GROUP=-1,e.SIDE_GROUP=-2;function w(P){const t=P;return typeof P=="number"||(0,F.isEditorGroup)(t)}e.isPreferredGroup=w}),define(Ee[8],_e([0,1,16,22,76,225,54,26,11,2,59,58,131,82,47,87,67,164,7]),function(re,e,c,F,w,P,t,T,C,k,R,_,n,m,o,d,u,S,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TypeHierarchyItem=e.CodeActionTriggerKind=e.TestCoverage=e.TestResults=e.TestItem=e.TestTag=e.TestMessage=e.NotebookRendererScript=e.NotebookDocumentContentOptions=e.NotebookStatusBarItem=e.NotebookDecorationRenderOptions=e.NotebookExclusiveDocumentPattern=e.NotebookCellOutput=e.NotebookCellOutputItem=e.NotebookCellData=e.NotebookData=e.NotebookCellKind=e.NotebookCellExecutionSummary=e.NotebookRange=e.LanguageSelector=e.GlobPattern=e.TextEditorOpenOptions=e.FoldingRangeKind=e.FoldingRange=e.ProgressLocation=e.EndOfLine=e.TextEditorLineNumbersStyle=e.TextDocumentSaveReason=e.SelectionRange=e.Color=e.ColorPresentation=e.DocumentLink=e.InlayHintKind=e.InlayHint=e.SignatureHelp=e.SignatureInformation=e.ParameterInformation=e.CompletionItem=e.CompletionItemKind=e.CompletionItemTag=e.CompletionContext=e.CompletionTriggerKind=e.DocumentHighlight=e.InlineValueContext=e.InlineValue=e.EvaluatableExpression=e.Hover=e.DefinitionLink=e.location=e.CallHierarchyOutgoingCall=e.CallHierarchyIncomingCall=e.CallHierarchyItem=e.DocumentSymbol=e.WorkspaceSymbol=e.SymbolTag=e.SymbolKind=e.WorkspaceEdit=e.TextEdit=e.DecorationRenderOptions=e.DecorationRangeBehavior=e.ThemableDecorationRenderOptions=e.ThemableDecorationAttachmentRenderOptions=e.pathOrURIToURI=e.fromRangeOrRangeWithMessage=e.MarkdownString=e.isDecorationOptionsArr=e.ViewColumn=e.DiagnosticSeverity=e.DiagnosticRelatedInformation=e.Diagnostic=e.DiagnosticTag=e.DocumentSelector=e.Position=e.TokenType=e.Range=e.Selection=void 0;var h;(function(ne){function pe(W){const{selectionStartLineNumber:be,selectionStartColumn:De,positionLineNumber:qe,positionColumn:xe}=W,ut=new b.Position(be-1,De-1),vt=new b.Position(qe-1,xe-1);return new b.Selection(ut,vt)}ne.to=pe;function ee(W){const{anchor:be,active:De}=W;return{selectionStartLineNumber:be.line+1,selectionStartColumn:be.character+1,positionLineNumber:De.line+1,positionColumn:De.character+1}}ne.from=ee})(h=e.Selection||(e.Selection={}));var g;(function(ne){function pe(W){if(!W)return;const{start:be,end:De}=W;return{startLineNumber:be.line+1,startColumn:be.character+1,endLineNumber:De.line+1,endColumn:De.character+1}}ne.from=pe;function ee(W){if(!W)return;const{startLineNumber:be,startColumn:De,endLineNumber:qe,endColumn:xe}=W;return new b.Range(be-1,De-1,qe-1,xe-1)}ne.to=ee})(g=e.Range||(e.Range={}));var A;(function(ne){function pe(ee){switch(ee){case 1:return b.StandardTokenType.Comment;case 0:return b.StandardTokenType.Other;case 4:return b.StandardTokenType.RegEx;case 2:return b.StandardTokenType.String}}ne.to=pe})(A=e.TokenType||(e.TokenType={}));var l;(function(ne){function pe(W){return new b.Position(W.lineNumber-1,W.column-1)}ne.to=pe;function ee(W){return{lineNumber:W.line+1,column:W.character+1}}ne.from=ee})(l=e.Position||(e.Position={}));var M;(function(ne){function pe(be,De){return(0,c.coalesce)((0,c.asArray)(be).map(qe=>ee(qe,De)))}ne.from=pe;function ee(be,De){if(typeof be=="string")return{$serialized:!0,language:be};if(be)return{$serialized:!0,language:be.language,scheme:W(be.scheme,De),pattern:typeof be.pattern=="undefined"?void 0:V.from(be.pattern),exclusive:be.exclusive}}function W(be,De){return De&&typeof be=="string"?De.transformOutgoingScheme(be):be}})(M=e.DocumentSelector||(e.DocumentSelector={}));var r;(function(ne){function pe(W){switch(W){case b.DiagnosticTag.Unnecessary:return 1;case b.DiagnosticTag.Deprecated:return 2}}ne.from=pe;function ee(W){switch(W){case 1:return b.DiagnosticTag.Unnecessary;case 2:return b.DiagnosticTag.Deprecated;default:return}}ne.to=ee})(r=e.DiagnosticTag||(e.DiagnosticTag={}));var i;(function(ne){function pe(W){let be;return W.code&&((0,C.isString)(W.code)||(0,C.isNumber)(W.code)?be=String(W.code):be={value:String(W.code.value),target:W.code.target}),{...g.from(W.range),message:W.message,source:W.source,code:be,severity:f.from(W.severity),relatedInformation:W.relatedInformation&&W.relatedInformation.map(p.from),tags:Array.isArray(W.tags)?(0,c.coalesce)(W.tags.map(r.from)):void 0}}ne.from=pe;function ee(W){const be=new b.Diagnostic(g.to(W),W.message,f.to(W.severity));return be.source=W.source,be.code=(0,C.isString)(W.code)?W.code:W.code?.value,be.relatedInformation=W.relatedInformation&&W.relatedInformation.map(p.to),be.tags=W.tags&&(0,c.coalesce)(W.tags.map(r.to)),be}ne.to=ee})(i=e.Diagnostic||(e.Diagnostic={}));var p;(function(ne){function pe(W){return{...g.from(W.location.range),message:W.message,resource:W.location.uri}}ne.from=pe;function ee(W){return new b.DiagnosticRelatedInformation(new b.Location(W.resource,g.to(W)),W.message)}ne.to=ee})(p=e.DiagnosticRelatedInformation||(e.DiagnosticRelatedInformation={}));var f;(function(ne){function pe(W){switch(W){case b.DiagnosticSeverity.Error:return m.MarkerSeverity.Error;case b.DiagnosticSeverity.Warning:return m.MarkerSeverity.Warning;case b.DiagnosticSeverity.Information:return m.MarkerSeverity.Info;case b.DiagnosticSeverity.Hint:return m.MarkerSeverity.Hint}return m.MarkerSeverity.Error}ne.from=pe;function ee(W){switch(W){case m.MarkerSeverity.Info:return b.DiagnosticSeverity.Information;case m.MarkerSeverity.Warning:return b.DiagnosticSeverity.Warning;case m.MarkerSeverity.Error:return b.DiagnosticSeverity.Error;case m.MarkerSeverity.Hint:return b.DiagnosticSeverity.Hint;default:return b.DiagnosticSeverity.Error}}ne.to=ee})(f=e.DiagnosticSeverity||(e.DiagnosticSeverity={}));var s;(function(ne){function pe(W){return typeof W=="number"&&W>=b.ViewColumn.One?W-1:W===b.ViewColumn.Beside?S.SIDE_GROUP:S.ACTIVE_GROUP}ne.from=pe;function ee(W){if(typeof W=="number"&&W>=0)return W+1;throw new Error("invalid 'EditorGroupColumn'")}ne.to=ee})(s=e.ViewColumn||(e.ViewColumn={}));function v(ne){return typeof ne.range!="undefined"}function a(ne){return ne.length===0?!0:!!v(ne[0])}e.isDecorationOptionsArr=a;var E;(function(ne){function pe(xe){return xe.map(ne.from)}ne.fromMany=pe;function ee(xe){return xe&&typeof xe=="object"&&typeof xe.language=="string"&&typeof xe.value=="string"}function W(xe){let ut;if(ee(xe)){const{language:ht,value:gt}=xe;ut={value:"```"+ht+`
`+gt+"\n```\n"}}else b.MarkdownString.isMarkdownString(xe)?ut={value:xe.value,isTrusted:xe.isTrusted,supportThemeIcons:xe.supportThemeIcons,supportHtml:xe.supportHtml}:typeof xe=="string"?ut={value:xe}:ut={value:""};const vt=Object.create(null);ut.uris=vt;const Ct=ht=>{try{let gt=k.URI.parse(ht,!0);gt=gt.with({query:be(gt.query,vt)}),vt[ht]=gt}catch(gt){}return""},bt=new P.Renderer;return bt.link=Ct,bt.image=ht=>Ct(w.parseHrefAndDimensions(ht).href),P(ut.value,{renderer:bt}),ut}ne.from=W;function be(xe,ut){if(!xe)return xe;let vt;try{vt=(0,t.parse)(xe)}catch(bt){}if(!vt)return xe;let Ct=!1;return vt=(0,T.cloneAndChange)(vt,bt=>{if(k.URI.isUri(bt)){const ht=`__uri_${Math.random().toString(16).slice(2,8)}`;return ut[ht]=bt,Ct=!0,ht}else return}),Ct?JSON.stringify(vt):xe}function De(xe){const ut=new b.MarkdownString(xe.value,xe.supportThemeIcons);return ut.isTrusted=xe.isTrusted,ut.supportHtml=xe.supportHtml,ut}ne.to=De;function qe(xe){if(!!xe)return typeof xe=="string"?xe:ne.from(xe)}ne.fromStrict=qe})(E=e.MarkdownString||(e.MarkdownString={}));function I(ne){return a(ne)?ne.map(pe=>({range:g.from(pe.range),hoverMessage:Array.isArray(pe.hoverMessage)?E.fromMany(pe.hoverMessage):pe.hoverMessage?E.from(pe.hoverMessage):void 0,renderOptions:pe.renderOptions})):ne.map(pe=>({range:g.from(pe)}))}e.fromRangeOrRangeWithMessage=I;function D(ne){return typeof ne=="undefined"?ne:typeof ne=="string"?k.URI.file(ne):ne}e.pathOrURIToURI=D;var B;(function(ne){function pe(ee){return typeof ee=="undefined"?ee:{contentText:ee.contentText,contentIconPath:ee.contentIconPath?D(ee.contentIconPath):void 0,border:ee.border,borderColor:ee.borderColor,fontStyle:ee.fontStyle,fontWeight:ee.fontWeight,textDecoration:ee.textDecoration,color:ee.color,backgroundColor:ee.backgroundColor,margin:ee.margin,width:ee.width,height:ee.height}}ne.from=pe})(B=e.ThemableDecorationAttachmentRenderOptions||(e.ThemableDecorationAttachmentRenderOptions={}));var L;(function(ne){function pe(ee){return typeof ee=="undefined"?ee:{backgroundColor:ee.backgroundColor,outline:ee.outline,outlineColor:ee.outlineColor,outlineStyle:ee.outlineStyle,outlineWidth:ee.outlineWidth,border:ee.border,borderColor:ee.borderColor,borderRadius:ee.borderRadius,borderSpacing:ee.borderSpacing,borderStyle:ee.borderStyle,borderWidth:ee.borderWidth,fontStyle:ee.fontStyle,fontWeight:ee.fontWeight,textDecoration:ee.textDecoration,cursor:ee.cursor,color:ee.color,opacity:ee.opacity,letterSpacing:ee.letterSpacing,gutterIconPath:ee.gutterIconPath?D(ee.gutterIconPath):void 0,gutterIconSize:ee.gutterIconSize,overviewRulerColor:ee.overviewRulerColor,before:ee.before?B.from(ee.before):void 0,after:ee.after?B.from(ee.after):void 0}}ne.from=pe})(L=e.ThemableDecorationRenderOptions||(e.ThemableDecorationRenderOptions={}));var y;(function(ne){function pe(ee){if(typeof ee=="undefined")return ee;switch(ee){case b.DecorationRangeBehavior.OpenOpen:return 0;case b.DecorationRangeBehavior.ClosedClosed:return 1;case b.DecorationRangeBehavior.OpenClosed:return 2;case b.DecorationRangeBehavior.ClosedOpen:return 3}}ne.from=pe})(y=e.DecorationRangeBehavior||(e.DecorationRangeBehavior={}));var x;(function(ne){function pe(ee){return{isWholeLine:ee.isWholeLine,rangeBehavior:ee.rangeBehavior?y.from(ee.rangeBehavior):void 0,overviewRulerLane:ee.overviewRulerLane,light:ee.light?L.from(ee.light):void 0,dark:ee.dark?L.from(ee.dark):void 0,backgroundColor:ee.backgroundColor,outline:ee.outline,outlineColor:ee.outlineColor,outlineStyle:ee.outlineStyle,outlineWidth:ee.outlineWidth,border:ee.border,borderColor:ee.borderColor,borderRadius:ee.borderRadius,borderSpacing:ee.borderSpacing,borderStyle:ee.borderStyle,borderWidth:ee.borderWidth,fontStyle:ee.fontStyle,fontWeight:ee.fontWeight,textDecoration:ee.textDecoration,cursor:ee.cursor,color:ee.color,opacity:ee.opacity,letterSpacing:ee.letterSpacing,gutterIconPath:ee.gutterIconPath?D(ee.gutterIconPath):void 0,gutterIconSize:ee.gutterIconSize,overviewRulerColor:ee.overviewRulerColor,before:ee.before?B.from(ee.before):void 0,after:ee.after?B.from(ee.after):void 0}}ne.from=pe})(x=e.DecorationRenderOptions||(e.DecorationRenderOptions={}));var N;(function(ne){function pe(W){return{text:W.newText,eol:W.newEol&&ct.from(W.newEol),range:g.from(W.range)}}ne.from=pe;function ee(W){const be=new b.TextEdit(g.to(W.range),W.text);return be.newEol=typeof W.eol=="undefined"?void 0:ct.to(W.eol),be}ne.to=ee})(N=e.TextEdit||(e.TextEdit={}));var z;(function(ne){function pe(W,be,De){const qe={edits:[]};if(W instanceof b.WorkspaceEdit)for(let xe of W._allEntries())if(xe._type===1)qe.edits.push({_type:1,oldUri:xe.from,newUri:xe.to,options:xe.options,metadata:xe.metadata});else if(xe._type===2){const ut=be?.getDocument(xe.uri);qe.edits.push({_type:2,resource:xe.uri,edit:N.from(xe.edit),modelVersionId:ut?.version,metadata:xe.metadata})}else xe._type===3?qe.edits.push({_type:3,metadata:xe.metadata,resource:xe.uri,edit:xe.edit,notebookMetadata:xe.notebookMetadata,notebookVersionId:De?.getNotebookDocument(xe.uri,!0)?.apiNotebook.version}):xe._type===5&&qe.edits.push({_type:3,metadata:xe.metadata,resource:xe.uri,notebookVersionId:De?.getNotebookDocument(xe.uri,!0)?.apiNotebook.version,edit:{editType:1,index:xe.index,count:xe.count,cells:xe.cells.map(Ke.from)}});return qe}ne.from=pe;function ee(W){const be=new b.WorkspaceEdit;for(const De of W.edits)De.edit?be.replace(k.URI.revive(De.resource),g.to(De.edit.range),De.edit.text):be.renameFile(k.URI.revive(De.oldUri),k.URI.revive(De.newUri),De.options);return be}ne.to=ee})(z=e.WorkspaceEdit||(e.WorkspaceEdit={}));var H;(function(ne){const pe=Object.create(null);pe[b.SymbolKind.File]=0,pe[b.SymbolKind.Module]=1,pe[b.SymbolKind.Namespace]=2,pe[b.SymbolKind.Package]=3,pe[b.SymbolKind.Class]=4,pe[b.SymbolKind.Method]=5,pe[b.SymbolKind.Property]=6,pe[b.SymbolKind.Field]=7,pe[b.SymbolKind.Constructor]=8,pe[b.SymbolKind.Enum]=9,pe[b.SymbolKind.Interface]=10,pe[b.SymbolKind.Function]=11,pe[b.SymbolKind.Variable]=12,pe[b.SymbolKind.Constant]=13,pe[b.SymbolKind.String]=14,pe[b.SymbolKind.Number]=15,pe[b.SymbolKind.Boolean]=16,pe[b.SymbolKind.Array]=17,pe[b.SymbolKind.Object]=18,pe[b.SymbolKind.Key]=19,pe[b.SymbolKind.Null]=20,pe[b.SymbolKind.EnumMember]=21,pe[b.SymbolKind.Struct]=22,pe[b.SymbolKind.Event]=23,pe[b.SymbolKind.Operator]=24,pe[b.SymbolKind.TypeParameter]=25;function ee(be){return typeof pe[be]=="number"?pe[be]:6}ne.from=ee;function W(be){for(const De in pe)if(pe[De]===be)return Number(De);return b.SymbolKind.Property}ne.to=W})(H=e.SymbolKind||(e.SymbolKind={}));var q;(function(ne){function pe(W){switch(W){case b.SymbolTag.Deprecated:return 1}}ne.from=pe;function ee(W){switch(W){case 1:return b.SymbolTag.Deprecated}}ne.to=ee})(q=e.SymbolTag||(e.SymbolTag={}));var ue;(function(ne){function pe(W){return{name:W.name,kind:H.from(W.kind),tags:W.tags&&W.tags.map(q.from),containerName:W.containerName,location:ie.from(W.location)}}ne.from=pe;function ee(W){const be=new b.SymbolInformation(W.name,H.to(W.kind),W.containerName,ie.to(W.location));return be.tags=W.tags&&W.tags.map(q.to),be}ne.to=ee})(ue=e.WorkspaceSymbol||(e.WorkspaceSymbol={}));var K;(function(ne){function pe(W){const be={name:W.name||"!!MISSING: name!!",detail:W.detail,range:g.from(W.range),selectionRange:g.from(W.selectionRange),kind:H.from(W.kind),tags:W.tags?.map(q.from)??[]};return W.children&&(be.children=W.children.map(pe)),be}ne.from=pe;function ee(W){const be=new b.DocumentSymbol(W.name,W.detail,H.to(W.kind),g.to(W.range),g.to(W.selectionRange));return(0,c.isNonEmptyArray)(W.tags)&&(be.tags=W.tags.map(q.to)),W.children&&(be.children=W.children.map(ee)),be}ne.to=ee})(K=e.DocumentSymbol||(e.DocumentSymbol={}));var ce;(function(ne){function pe(W){const be=new b.CallHierarchyItem(H.to(W.kind),W.name,W.detail||"",k.URI.revive(W.uri),g.to(W.range),g.to(W.selectionRange));return be._sessionId=W._sessionId,be._itemId=W._itemId,be}ne.to=pe;function ee(W,be,De){if(be=be??W._sessionId,De=De??W._itemId,be===void 0||De===void 0)throw new Error("invalid item");return{_sessionId:be,_itemId:De,name:W.name,detail:W.detail,kind:H.from(W.kind),uri:W.uri,range:g.from(W.range),selectionRange:g.from(W.selectionRange),tags:W.tags?.map(q.from)}}ne.from=ee})(ce=e.CallHierarchyItem||(e.CallHierarchyItem={}));var de;(function(ne){function pe(ee){return new b.CallHierarchyIncomingCall(ce.to(ee.from),ee.fromRanges.map(W=>g.to(W)))}ne.to=pe})(de=e.CallHierarchyIncomingCall||(e.CallHierarchyIncomingCall={}));var Y;(function(ne){function pe(ee){return new b.CallHierarchyOutgoingCall(ce.to(ee.to),ee.fromRanges.map(W=>g.to(W)))}ne.to=pe})(Y=e.CallHierarchyOutgoingCall||(e.CallHierarchyOutgoingCall={}));var ie;(function(ne){function pe(W){return{range:W.range&&g.from(W.range),uri:W.uri}}ne.from=pe;function ee(W){return new b.Location(k.URI.revive(W.uri),g.to(W.range))}ne.to=ee})(ie=e.location||(e.location={}));var we;(function(ne){function pe(W){const be=W,De=W;return{originSelectionRange:be.originSelectionRange?g.from(be.originSelectionRange):void 0,uri:be.targetUri?be.targetUri:De.uri,range:g.from(be.targetRange?be.targetRange:De.range),targetSelectionRange:be.targetSelectionRange?g.from(be.targetSelectionRange):void 0}}ne.from=pe;function ee(W){return{targetUri:k.URI.revive(W.uri),targetRange:g.to(W.range),targetSelectionRange:W.targetSelectionRange?g.to(W.targetSelectionRange):void 0,originSelectionRange:W.originSelectionRange?g.to(W.originSelectionRange):void 0}}ne.to=ee})(we=e.DefinitionLink||(e.DefinitionLink={}));var Me;(function(ne){function pe(W){return{range:g.from(W.range),contents:E.fromMany(W.contents)}}ne.from=pe;function ee(W){return new b.Hover(W.contents.map(E.to),g.to(W.range))}ne.to=ee})(Me=e.Hover||(e.Hover={}));var Re;(function(ne){function pe(W){return{range:g.from(W.range),expression:W.expression}}ne.from=pe;function ee(W){return new b.EvaluatableExpression(g.to(W.range),W.expression)}ne.to=ee})(Re=e.EvaluatableExpression||(e.EvaluatableExpression={}));var Be;(function(ne){function pe(W){if(W instanceof b.InlineValueText)return{type:"text",range:g.from(W.range),text:W.text};if(W instanceof b.InlineValueVariableLookup)return{type:"variable",range:g.from(W.range),variableName:W.variableName,caseSensitiveLookup:W.caseSensitiveLookup};if(W instanceof b.InlineValueEvaluatableExpression)return{type:"expression",range:g.from(W.range),expression:W.expression};throw new Error("Unknown 'InlineValue' type")}ne.from=pe;function ee(W){switch(W.type){case"text":return{range:g.to(W.range),text:W.text};case"variable":return{range:g.to(W.range),variableName:W.variableName,caseSensitiveLookup:W.caseSensitiveLookup};case"expression":return{range:g.to(W.range),expression:W.expression}}}ne.to=ee})(Be=e.InlineValue||(e.InlineValue={}));var Qe;(function(ne){function pe(W){return{frameId:W.frameId,stoppedLocation:g.from(W.stoppedLocation)}}ne.from=pe;function ee(W){return new b.InlineValueContext(W.frameId,g.to(W.stoppedLocation))}ne.to=ee})(Qe=e.InlineValueContext||(e.InlineValueContext={}));var Ge;(function(ne){function pe(W){return{range:g.from(W.range),kind:W.kind}}ne.from=pe;function ee(W){return new b.DocumentHighlight(g.to(W.range),W.kind)}ne.to=ee})(Ge=e.DocumentHighlight||(e.DocumentHighlight={}));var Xe;(function(ne){function pe(ee){switch(ee){case 1:return b.CompletionTriggerKind.TriggerCharacter;case 2:return b.CompletionTriggerKind.TriggerForIncompleteCompletions;case 0:default:return b.CompletionTriggerKind.Invoke}}ne.to=pe})(Xe=e.CompletionTriggerKind||(e.CompletionTriggerKind={}));var $;(function(ne){function pe(ee){return{triggerKind:Xe.to(ee.triggerKind),triggerCharacter:ee.triggerCharacter}}ne.to=pe})($=e.CompletionContext||(e.CompletionContext={}));var G;(function(ne){function pe(W){switch(W){case b.CompletionItemTag.Deprecated:return 1}}ne.from=pe;function ee(W){switch(W){case 1:return b.CompletionItemTag.Deprecated}}ne.to=ee})(G=e.CompletionItemTag||(e.CompletionItemTag={}));var J;(function(ne){const pe=new Map([[b.CompletionItemKind.Method,0],[b.CompletionItemKind.Function,1],[b.CompletionItemKind.Constructor,2],[b.CompletionItemKind.Field,3],[b.CompletionItemKind.Variable,4],[b.CompletionItemKind.Class,5],[b.CompletionItemKind.Interface,7],[b.CompletionItemKind.Struct,6],[b.CompletionItemKind.Module,8],[b.CompletionItemKind.Property,9],[b.CompletionItemKind.Unit,12],[b.CompletionItemKind.Value,13],[b.CompletionItemKind.Constant,14],[b.CompletionItemKind.Enum,15],[b.CompletionItemKind.EnumMember,16],[b.CompletionItemKind.Keyword,17],[b.CompletionItemKind.Snippet,27],[b.CompletionItemKind.Text,18],[b.CompletionItemKind.Color,19],[b.CompletionItemKind.File,20],[b.CompletionItemKind.Reference,21],[b.CompletionItemKind.Folder,23],[b.CompletionItemKind.Event,10],[b.CompletionItemKind.Operator,11],[b.CompletionItemKind.TypeParameter,24],[b.CompletionItemKind.Issue,26],[b.CompletionItemKind.User,25]]);function ee(De){return pe.get(De)??9}ne.from=ee;const W=new Map([[0,b.CompletionItemKind.Method],[1,b.CompletionItemKind.Function],[2,b.CompletionItemKind.Constructor],[3,b.CompletionItemKind.Field],[4,b.CompletionItemKind.Variable],[5,b.CompletionItemKind.Class],[7,b.CompletionItemKind.Interface],[6,b.CompletionItemKind.Struct],[8,b.CompletionItemKind.Module],[9,b.CompletionItemKind.Property],[12,b.CompletionItemKind.Unit],[13,b.CompletionItemKind.Value],[14,b.CompletionItemKind.Constant],[15,b.CompletionItemKind.Enum],[16,b.CompletionItemKind.EnumMember],[17,b.CompletionItemKind.Keyword],[27,b.CompletionItemKind.Snippet],[18,b.CompletionItemKind.Text],[19,b.CompletionItemKind.Color],[20,b.CompletionItemKind.File],[21,b.CompletionItemKind.Reference],[23,b.CompletionItemKind.Folder],[10,b.CompletionItemKind.Event],[11,b.CompletionItemKind.Operator],[24,b.CompletionItemKind.TypeParameter],[25,b.CompletionItemKind.User],[26,b.CompletionItemKind.Issue]]);function be(De){return W.get(De)??b.CompletionItemKind.Property}ne.to=be})(J=e.CompletionItemKind||(e.CompletionItemKind={}));var ae;(function(ne){function pe(ee,W){const be=new b.CompletionItem(ee.label);return be.insertText=ee.insertText,be.kind=J.to(ee.kind),be.tags=ee.tags?.map(G.to),be.detail=ee.detail,be.documentation=w.isMarkdownString(ee.documentation)?E.to(ee.documentation):ee.documentation,be.sortText=ee.sortText,be.filterText=ee.filterText,be.preselect=ee.preselect,be.commitCharacters=ee.commitCharacters,R.Range.isIRange(ee.range)?be.range=g.to(ee.range):typeof ee.range=="object"&&(be.range={inserting:g.to(ee.range.insert),replacing:g.to(ee.range.replace)}),be.keepWhitespace=typeof ee.insertTextRules=="undefined"?!1:Boolean(ee.insertTextRules&1),typeof ee.insertTextRules!="undefined"&&ee.insertTextRules&4?be.insertText=new b.SnippetString(ee.insertText):(be.insertText=ee.insertText,be.textEdit=be.range instanceof b.Range?new b.TextEdit(be.range,be.insertText):void 0),ee.additionalTextEdits&&ee.additionalTextEdits.length>0&&(be.additionalTextEdits=ee.additionalTextEdits.map(De=>N.to(De))),be.command=W&&ee.command?W.fromInternal(ee.command):void 0,be}ne.to=pe})(ae=e.CompletionItem||(e.CompletionItem={}));var j;(function(ne){function pe(W){return{label:W.label,documentation:W.documentation?E.fromStrict(W.documentation):void 0}}ne.from=pe;function ee(W){return{label:W.label,documentation:w.isMarkdownString(W.documentation)?E.to(W.documentation):W.documentation}}ne.to=ee})(j=e.ParameterInformation||(e.ParameterInformation={}));var te;(function(ne){function pe(W){return{label:W.label,documentation:W.documentation?E.fromStrict(W.documentation):void 0,parameters:Array.isArray(W.parameters)?W.parameters.map(j.from):[],activeParameter:W.activeParameter}}ne.from=pe;function ee(W){return{label:W.label,documentation:w.isMarkdownString(W.documentation)?E.to(W.documentation):W.documentation,parameters:Array.isArray(W.parameters)?W.parameters.map(j.to):[],activeParameter:W.activeParameter}}ne.to=ee})(te=e.SignatureInformation||(e.SignatureInformation={}));var me;(function(ne){function pe(W){return{activeSignature:W.activeSignature,activeParameter:W.activeParameter,signatures:Array.isArray(W.signatures)?W.signatures.map(te.from):[]}}ne.from=pe;function ee(W){return{activeSignature:W.activeSignature,activeParameter:W.activeParameter,signatures:Array.isArray(W.signatures)?W.signatures.map(te.to):[]}}ne.to=ee})(me=e.SignatureHelp||(e.SignatureHelp={}));var Pe;(function(ne){function pe(W){return{text:W.text,position:l.from(W.position),kind:Ne.from(W.kind??b.InlayHintKind.Other),whitespaceBefore:W.whitespaceBefore,whitespaceAfter:W.whitespaceAfter}}ne.from=pe;function ee(W){const be=new b.InlayHint(W.text,l.to(W.position),Ne.to(W.kind));return be.whitespaceAfter=W.whitespaceAfter,be.whitespaceBefore=W.whitespaceBefore,be}ne.to=ee})(Pe=e.InlayHint||(e.InlayHint={}));var Ne;(function(ne){function pe(W){return W}ne.from=pe;function ee(W){return W}ne.to=ee})(Ne=e.InlayHintKind||(e.InlayHintKind={}));var He;(function(ne){function pe(W){return{range:g.from(W.range),url:W.target,tooltip:W.tooltip}}ne.from=pe;function ee(W){let be;if(W.url)try{be=typeof W.url=="string"?k.URI.parse(W.url,!0):k.URI.revive(W.url)}catch(De){}return new b.DocumentLink(g.to(W.range),be)}ne.to=ee})(He=e.DocumentLink||(e.DocumentLink={}));var Ye;(function(ne){function pe(W){const be=new b.ColorPresentation(W.label);return W.textEdit&&(be.textEdit=N.to(W.textEdit)),W.additionalTextEdits&&(be.additionalTextEdits=W.additionalTextEdits.map(De=>N.to(De))),be}ne.to=pe;function ee(W){return{label:W.label,textEdit:W.textEdit?N.from(W.textEdit):void 0,additionalTextEdits:W.additionalTextEdits?W.additionalTextEdits.map(be=>N.from(be)):void 0}}ne.from=ee})(Ye=e.ColorPresentation||(e.ColorPresentation={}));var et;(function(ne){function pe(W){return new b.Color(W[0],W[1],W[2],W[3])}ne.to=pe;function ee(W){return[W.red,W.green,W.blue,W.alpha]}ne.from=ee})(et=e.Color||(e.Color={}));var st;(function(ne){function pe(W){return{range:g.from(W.range)}}ne.from=pe;function ee(W){return new b.SelectionRange(g.to(W.range))}ne.to=ee})(st=e.SelectionRange||(e.SelectionRange={}));var Je;(function(ne){function pe(ee){switch(ee){case 2:return b.TextDocumentSaveReason.AfterDelay;case 1:return b.TextDocumentSaveReason.Manual;case 3:case 4:return b.TextDocumentSaveReason.FocusOut}}ne.to=pe})(Je=e.TextDocumentSaveReason||(e.TextDocumentSaveReason={}));var nt;(function(ne){function pe(W){switch(W){case b.TextEditorLineNumbersStyle.Off:return 0;case b.TextEditorLineNumbersStyle.Relative:return 2;case b.TextEditorLineNumbersStyle.On:default:return 1}}ne.from=pe;function ee(W){switch(W){case 0:return b.TextEditorLineNumbersStyle.Off;case 2:return b.TextEditorLineNumbersStyle.Relative;case 1:default:return b.TextEditorLineNumbersStyle.On}}ne.to=ee})(nt=e.TextEditorLineNumbersStyle||(e.TextEditorLineNumbersStyle={}));var ct;(function(ne){function pe(W){if(W===b.EndOfLine.CRLF)return 1;if(W===b.EndOfLine.LF)return 0}ne.from=pe;function ee(W){if(W===1)return b.EndOfLine.CRLF;if(W===0)return b.EndOfLine.LF}ne.to=ee})(ct=e.EndOfLine||(e.EndOfLine={}));var pt;(function(ne){function pe(ee){if(typeof ee=="object")return ee.viewId;switch(ee){case b.ProgressLocation.SourceControl:return 3;case b.ProgressLocation.Window:return 10;case b.ProgressLocation.Notification:return 15}throw new Error("Unknown 'ProgressLocation'")}ne.from=pe})(pt=e.ProgressLocation||(e.ProgressLocation={}));var Ft;(function(ne){function pe(ee){const W={start:ee.start+1,end:ee.end+1};return ee.kind&&(W.kind=Fe.from(ee.kind)),W}ne.from=pe})(Ft=e.FoldingRange||(e.FoldingRange={}));var Fe;(function(ne){function pe(ee){if(ee)switch(ee){case b.FoldingRangeKind.Comment:return _.FoldingRangeKind.Comment;case b.FoldingRangeKind.Imports:return _.FoldingRangeKind.Imports;case b.FoldingRangeKind.Region:return _.FoldingRangeKind.Region}}ne.from=pe})(Fe=e.FoldingRangeKind||(e.FoldingRangeKind={}));var Mt;(function(ne){function pe(ee){if(ee)return{pinned:typeof ee.preview=="boolean"?!ee.preview:void 0,inactive:ee.background,preserveFocus:ee.preserveFocus,selection:typeof ee.selection=="object"?g.from(ee.selection):void 0,override:typeof ee.override=="boolean"?n.EditorResolution.DISABLED:void 0}}ne.from=pe})(Mt=e.TextEditorOpenOptions||(e.TextEditorOpenOptions={}));var V;(function(ne){function pe(W){return W instanceof b.RelativePattern||typeof W=="string"?W:ee(W)?new b.RelativePattern(W.base,W.pattern):W}ne.from=pe;function ee(W){const be=W;return be&&typeof be.base=="string"&&typeof be.pattern=="string"}})(V=e.GlobPattern||(e.GlobPattern={}));var Q;(function(ne){function pe(ee){if(ee){if(Array.isArray(ee))return ee.map(pe);if(typeof ee=="string")return ee;{const W=ee;return{language:W.language,scheme:W.scheme,pattern:typeof W.pattern=="undefined"?void 0:V.from(W.pattern),exclusive:W.exclusive}}}else return}ne.from=pe})(Q=e.LanguageSelector||(e.LanguageSelector={}));var he;(function(ne){function pe(W){return{start:W.start,end:W.end}}ne.from=pe;function ee(W){return new b.NotebookRange(W.start,W.end)}ne.to=ee})(he=e.NotebookRange||(e.NotebookRange={}));var Le;(function(ne){function pe(W){return{timing:typeof W.runStartTime=="number"&&typeof W.runEndTime=="number"?{startTime:W.runStartTime,endTime:W.runEndTime}:void 0,executionOrder:W.executionOrder,success:W.lastRunSuccess}}ne.to=pe;function ee(W){return{lastRunSuccess:W.success,runStartTime:W.timing?.startTime,runEndTime:W.timing?.endTime,executionOrder:W.executionOrder}}ne.from=ee})(Le=e.NotebookCellExecutionSummary||(e.NotebookCellExecutionSummary={}));var We;(function(ne){function pe(W){switch(W){case b.NotebookCellKind.Markup:return d.CellKind.Markup;case b.NotebookCellKind.Code:default:return d.CellKind.Code}}ne.from=pe;function ee(W){switch(W){case d.CellKind.Markup:return b.NotebookCellKind.Markup;case d.CellKind.Code:default:return b.NotebookCellKind.Code}}ne.to=ee})(We=e.NotebookCellKind||(e.NotebookCellKind={}));var ot;(function(ne){function pe(W){const be={metadata:W.metadata??Object.create(null),cells:[]};for(let De of W.cells)b.NotebookCellData.validate(De),be.cells.push(Ke.from(De));return be}ne.from=pe;function ee(W){const be=new b.NotebookData(W.cells.map(Ke.to));return(0,C.isEmptyObject)(W.metadata)||(be.metadata=W.metadata),be}ne.to=ee})(ot=e.NotebookData||(e.NotebookData={}));var Ke;(function(ne){function pe(W){return{cellKind:We.from(W.kind),language:W.languageId,mime:W.mime,source:W.value,metadata:W.metadata,internalMetadata:Le.from(W.executionSummary??{}),outputs:W.outputs?W.outputs.map(Ie.from):[]}}ne.from=pe;function ee(W){return new b.NotebookCellData(We.to(W.cellKind),W.source,W.language,W.mime,W.outputs?W.outputs.map(Ie.to):void 0,W.metadata,W.internalMetadata?Le.to(W.internalMetadata):void 0)}ne.to=ee})(Ke=e.NotebookCellData||(e.NotebookCellData={}));var _t;(function(ne){function pe(W){return{mime:W.mime,valueBytes:F.VSBuffer.wrap(W.data)}}ne.from=pe;function ee(W){return new b.NotebookCellOutputItem(W.valueBytes.buffer,W.mime)}ne.to=ee})(_t=e.NotebookCellOutputItem||(e.NotebookCellOutputItem={}));var Ie;(function(ne){function pe(W){return{outputId:W.id,items:W.items.map(_t.from),metadata:W.metadata}}ne.from=pe;function ee(W){const be=W.items.map(_t.to);return new b.NotebookCellOutput(be,W.outputId,W.metadata)}ne.to=ee})(Ie=e.NotebookCellOutput||(e.NotebookCellOutput={}));var Se;(function(ne){function pe(De){if(De!=null){if(De instanceof b.RelativePattern||typeof De=="string")return De;if(be(De))return new b.RelativePattern(De.base,De.pattern);if(W(De))return{include:V.from(De.include)||void 0,exclude:V.from(De.exclude)||void 0}}}ne.from=pe;function ee(De){return typeof De=="string"?De:be(De)?{base:De.base,pattern:De.pattern}:{include:De.include,exclude:De.exclude}}ne.to=ee;function W(De){const qe=De,xe=V.from(qe.include);if(!(xe&&xe instanceof b.RelativePattern||typeof xe=="string"))return!1;const ut=V.from(qe.exclude);return!!(ut&&ut instanceof b.RelativePattern||typeof ut=="string")}function be(De){const qe=De;return qe&&typeof qe.base=="string"&&typeof qe.pattern=="string"}})(Se=e.NotebookExclusiveDocumentPattern||(e.NotebookExclusiveDocumentPattern={}));var ve;(function(ne){function pe(ee){return{backgroundColor:ee.backgroundColor,borderColor:ee.borderColor,top:ee.top?B.from(ee.top):void 0}}ne.from=pe})(ve=e.NotebookDecorationRenderOptions||(e.NotebookDecorationRenderOptions={}));var oe;(function(ne){function pe(ee,W,be){const De=typeof ee.command=="string"?{title:"",command:ee.command}:ee.command;return{alignment:ee.alignment===b.NotebookCellStatusBarAlignment.Left?1:2,command:W.toInternal(De,be),text:ee.text,tooltip:ee.tooltip,accessibilityInformation:ee.accessibilityInformation,priority:ee.priority}}ne.from=pe})(oe=e.NotebookStatusBarItem||(e.NotebookStatusBarItem={}));var se;(function(ne){function pe(ee){return{transientOutputs:ee?.transientOutputs??!1,transientCellMetadata:ee?.transientCellMetadata??{},transientDocumentMetadata:ee?.transientDocumentMetadata??{}}}ne.from=pe})(se=e.NotebookDocumentContentOptions||(e.NotebookDocumentContentOptions={}));var fe;(function(ne){function pe(W){return{uri:W.uri,provides:W.provides}}ne.from=pe;function ee(W){return new b.NotebookRendererScript(k.URI.revive(W.uri),W.provides)}ne.to=ee})(fe=e.NotebookRendererScript||(e.NotebookRendererScript={}));var ge;(function(ne){function pe(W){return{message:E.fromStrict(W.message)||"",type:0,expected:W.expectedOutput,actual:W.actualOutput,location:W.location?ie.from(W.location):void 0}}ne.from=pe;function ee(W){const be=new b.TestMessage(typeof W.message=="string"?W.message:E.to(W.message));return be.actualOutput=W.actual,be.expectedOutput=W.expected,be.location=W.location?ie.to(W.location):void 0,be}ne.to=ee})(ge=e.TestMessage||(e.TestMessage={}));var ke;(function(ne){let pe;(function(ee){ee.Delimiter="\0"})(pe||(pe={})),ne.namespace=(ee,W)=>ee+"\0"+W,ne.denamespace=ee=>{const W=ee.indexOf("\0");return{ctrlId:ee.slice(0,W),tagId:ee.slice(W+1)}}})(ke=e.TestTag||(e.TestTag={}));var ze;(function(ne){function pe(De){const qe=(0,o.getPrivateApiFor)(De).controllerId;return{extId:u.TestId.fromExtHostTestItem(De,qe).toString(),label:De.label,uri:De.uri,tags:De.tags.map(xe=>ke.namespace(qe,xe.id)),range:g.from(De.range)||null,description:De.description||null,error:De.error&&E.fromStrict(De.error)||null}}ne.from=pe;function ee(De){return{parent:void 0,error:void 0,id:u.TestId.fromString(De.extId).localId,label:De.label,uri:k.URI.revive(De.uri),tags:(De.tags||[]).map(qe=>{const{tagId:xe}=ke.denamespace(qe);return new b.TestTag(xe)}),range:g.to(De.range||void 0),invalidateResults:()=>{},canResolveChildren:!1,busy:!1,description:De.description||void 0}}ne.toPlain=ee;function W(De){const qe=u.TestId.fromString(De.extId),xe=new o.TestItemImpl(qe.controllerId,qe.localId,De.label,k.URI.revive(De.uri));return xe.range=g.to(De.range||void 0),xe.description=De.description||void 0,xe}function be(De){let qe;for(const xe of De.tests){const ut=W(xe.item);(0,o.getPrivateApiFor)(ut).parent=qe,qe=ut}return qe}ne.toItemFromContext=be})(ze=e.TestItem||(e.TestItem={})),function(ne){function pe(W){return{id:W.id}}ne.from=pe;function ee(W){return new b.TestTag(W.id)}ne.to=ee}(ke=e.TestTag||(e.TestTag={}));var Oe;(function(ne){const pe=(W,be)=>{const De={...ze.toPlain(W.item),parent:void 0,taskStates:W.tasks.map(qe=>({state:qe.state,duration:qe.duration,messages:qe.messages.filter(xe=>xe.type===0).map(ge.to)})),children:W.children.map(qe=>be.get(qe)).filter(C.isDefined).map(qe=>pe(qe,be))};for(const qe of De.children)qe.parent=De;return De};function ee(W){const be=[],De=new Map;for(const qe of W.items)De.set(qe.item.extId,qe),W.request.targets.some(xe=>xe.controllerId===qe.controllerId&&xe.testIds.includes(qe.item.extId))&&be.push(qe);return{completedAt:W.completedAt,results:be.map(qe=>pe(qe,De))}}ne.to=ee})(Oe=e.TestResults||(e.TestResults={}));var Ve;(function(ne){function pe(De){return{covered:De.covered,total:De.covered}}function ee(De){return"line"in De?l.from(De):g.from(De)}function W(De){return"branches"in De?{count:De.executionCount,location:ee(De.location),type:1,branches:De.branches.length?De.branches.map(qe=>({count:qe.executionCount,location:qe.location&&ee(qe.location)})):void 0}:{type:0,count:De.executionCount,location:ee(De.location)}}ne.fromDetailed=W;function be(De){return{uri:De.uri,statement:pe(De.statementCoverage),branch:De.branchCoverage&&pe(De.branchCoverage),function:De.functionCoverage&&pe(De.functionCoverage),details:De.detailedCoverage?.map(W)}}ne.fromFile=be})(Ve=e.TestCoverage||(e.TestCoverage={}));var it;(function(ne){function pe(ee){switch(ee){case 1:return b.CodeActionTriggerKind.Invoke;case 2:return b.CodeActionTriggerKind.Automatic}}ne.to=pe})(it=e.CodeActionTriggerKind||(e.CodeActionTriggerKind={}));var rt;(function(ne){function pe(W){const be=new b.TypeHierarchyItem(H.to(W.kind),W.name,W.detail||"",k.URI.revive(W.uri),g.to(W.range),g.to(W.selectionRange));return be._sessionId=W._sessionId,be._itemId=W._itemId,be}ne.to=pe;function ee(W,be,De){if(be=be??W._sessionId,De=De??W._itemId,be===void 0||De===void 0)throw new Error("invalid item");return{_sessionId:be,_itemId:De,kind:H.from(W.kind),name:W.name,detail:W.detail??"",uri:W.uri,range:g.from(W.range),selectionRange:g.from(W.selectionRange),tags:W.tags?.map(q.from)}}ne.from=ee})(rt=e.TypeHierarchyItem||(e.TypeHierarchyItem={}))}),define(Ee[165],_e([0,1,2,15,7,8,226]),function(re,e,c,F,w,P,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDocumentSaveParticipant=void 0;class T{constructor(k,R,_,n={timeout:1500,errors:3}){this._logService=k,this._documents=R,this._mainThreadBulkEdits=_,this._thresholds=n,this._callbacks=new t.LinkedList,this._badListeners=new WeakMap}dispose(){this._callbacks.clear()}getOnWillSaveTextDocumentEvent(k){return(R,_,n)=>{const o={dispose:this._callbacks.push([R,_,k])};return Array.isArray(n)&&n.push(o),o}}async $participateInSave(k,R){const _=c.URI.revive(k);let n=!1;const m=setTimeout(()=>n=!0,this._thresholds.timeout),o=[];try{for(let d of[...this._callbacks]){if(n)break;const u=this._documents.getDocument(_),S=await this._deliverEventAsyncAndBlameBadListeners(d,{document:u,reason:P.TextDocumentSaveReason.to(R)});o.push(S)}}finally{clearTimeout(m)}return o}_deliverEventAsyncAndBlameBadListeners([k,R,_],n){const m=this._badListeners.get(k);return typeof m=="number"&&m>this._thresholds.errors?Promise.resolve(!1):this._deliverEventAsync(_,k,R,n).then(()=>!0,o=>{if(this._logService.error(`onWillSaveTextDocument-listener from extension '${_.identifier.value}' threw ERROR`),this._logService.error(o),!(o instanceof Error)||o.message!=="concurrent_edits"){const d=this._badListeners.get(k);this._badListeners.set(k,d?d+1:1),typeof d=="number"&&d>this._thresholds.errors&&this._logService.info(`onWillSaveTextDocument-listener from extension '${_.identifier.value}' will now be IGNORED because of timeouts and/or errors`)}return!1})}_deliverEventAsync(k,R,_,n){const m=[],o=Date.now(),{document:d,reason:u}=n,{version:S}=d,b=Object.freeze({document:d,reason:u,waitUntil(h){if(Object.isFrozen(m))throw(0,F.illegalState)("waitUntil can not be called async");m.push(Promise.resolve(h))}});try{R.apply(_,[b])}catch(h){return Promise.reject(h)}return Object.freeze(m),new Promise((h,g)=>{const A=setTimeout(()=>g(new Error("timeout")),this._thresholds.timeout);return Promise.all(m).then(l=>{this._logService.debug(`onWillSaveTextDocument-listener from extension '${k.identifier.value}' finished after ${Date.now()-o}ms`),clearTimeout(A),h(l)}).catch(l=>{clearTimeout(A),g(l)})}).then(h=>{const g={edits:[]};for(const A of h)if(Array.isArray(A)&&A.every(l=>l instanceof w.TextEdit))for(const{newText:l,newEol:M,range:r}of A)g.edits.push({_type:2,resource:d.uri,edit:{range:r&&P.Range.from(r),text:l,eol:M&&P.EndOfLine.from(M)}});if(g.edits.length!==0)return S===d.version?this._mainThreadBulkEdits.$tryApplyWorkspaceEdit(g):Promise.reject(new Error("concurrent_edits"))})}}e.ExtHostDocumentSaveParticipant=T}),define(Ee[166],_e([0,1,3,29,2,8,7]),function(re,e,c,F,w,P,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostFileSystemEventService=void 0;class T{constructor(R,_,n,m,o){this._onDidCreate=new c.Emitter,this._onDidChange=new c.Emitter,this._onDidDelete=new c.Emitter,this._config=0,n&&(this._config+=1),m&&(this._config+=2),o&&(this._config+=4);const d=(0,F.parse)(_),u=R(S=>{if(!n)for(let b of S.created){const h=w.URI.revive(b);d(h.fsPath)&&this._onDidCreate.fire(h)}if(!m)for(let b of S.changed){const h=w.URI.revive(b);d(h.fsPath)&&this._onDidChange.fire(h)}if(!o)for(let b of S.deleted){const h=w.URI.revive(b);d(h.fsPath)&&this._onDidDelete.fire(h)}});this._disposable=t.Disposable.from(this._onDidCreate,this._onDidChange,this._onDidDelete,u)}get ignoreCreateEvents(){return Boolean(this._config&1)}get ignoreChangeEvents(){return Boolean(this._config&2)}get ignoreDeleteEvents(){return Boolean(this._config&4)}dispose(){this._disposable.dispose()}get onDidCreate(){return this._onDidCreate.event}get onDidChange(){return this._onDidChange.event}get onDidDelete(){return this._onDidDelete.event}}class C{constructor(R,_,n){this._logService=_,this._extHostDocumentsAndEditors=n,this._onFileSystemEvent=new c.Emitter,this._onDidRenameFile=new c.Emitter,this._onDidCreateFile=new c.Emitter,this._onDidDeleteFile=new c.Emitter,this._onWillRenameFile=new c.AsyncEmitter,this._onWillCreateFile=new c.AsyncEmitter,this._onWillDeleteFile=new c.AsyncEmitter,this.onDidRenameFile=this._onDidRenameFile.event,this.onDidCreateFile=this._onDidCreateFile.event,this.onDidDeleteFile=this._onDidDeleteFile.event}createFileSystemWatcher(R,_,n,m){return new T(this._onFileSystemEvent.event,R,_,n,m)}$onFileEvent(R){this._onFileSystemEvent.fire(R)}$onDidRunFileOperation(R,_){switch(R){case 2:this._onDidRenameFile.fire(Object.freeze({files:_.map(n=>({oldUri:w.URI.revive(n.source),newUri:w.URI.revive(n.target)}))}));break;case 1:this._onDidDeleteFile.fire(Object.freeze({files:_.map(n=>w.URI.revive(n.target))}));break;case 0:this._onDidCreateFile.fire(Object.freeze({files:_.map(n=>w.URI.revive(n.target))}));break;default:}}getOnWillRenameFileEvent(R){return this._createWillExecuteEvent(R,this._onWillRenameFile)}getOnWillCreateFileEvent(R){return this._createWillExecuteEvent(R,this._onWillCreateFile)}getOnWillDeleteFileEvent(R){return this._createWillExecuteEvent(R,this._onWillDeleteFile)}_createWillExecuteEvent(R,_){return(n,m,o)=>{const d=function(S){n.call(m,S)};return d.extension=R,_.event(d,void 0,o)}}async $onWillRunFileOperation(R,_,n,m){switch(R){case 2:return await this._fireWillEvent(this._onWillRenameFile,{files:_.map(o=>({oldUri:w.URI.revive(o.source),newUri:w.URI.revive(o.target)}))},n,m);case 1:return await this._fireWillEvent(this._onWillDeleteFile,{files:_.map(o=>w.URI.revive(o.target))},n,m);case 0:return await this._fireWillEvent(this._onWillCreateFile,{files:_.map(o=>w.URI.revive(o.target))},n,m)}}async _fireWillEvent(R,_,n,m){const o=new Set,d=[];if(await R.fireAsync(_,m,async(S,b)=>{const h=Date.now(),g=await Promise.resolve(S);g instanceof t.WorkspaceEdit&&(d.push(g),o.add(b.extension.displayName??b.extension.identifier.value)),Date.now()-h>n&&this._logService.warn("SLOW file-participant",b.extension.identifier)}),m.isCancellationRequested||d.length===0)return;const u={edits:[]};for(let S of d){let{edits:b}=P.WorkspaceEdit.from(S,this._extHostDocumentsAndEditors);u.edits=u.edits.concat(b)}return{edit:u,extensionNames:Array.from(o)}}}e.ExtHostFileSystemEventService=C}),define(Ee[167],_e([0,1,10,26,2,8,7,87]),function(re,e,c,F,w,P,t,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookDocument=e.ExtHostCell=void 0;class C{constructor(n,m,o,d){this.start=n,this.deletedCount=m,this.deletedItems=o,this.items=d}static asApiEvents(n){return n.map(m=>({start:m.start,deletedCount:m.deletedCount,deletedItems:m.deletedItems,items:m.items.map(o=>o.apiCell)}))}}class k{constructor(n,m,o){this.notebook=n,this._extHostDocument=m,this._cellData=o,this.handle=o.handle,this.uri=w.URI.revive(o.uri),this.cellKind=o.cellKind,this._outputs=o.outputs.map(P.NotebookCellOutput.to),this._internalMetadata=o.internalMetadata??{},this._metadata=Object.freeze(o.metadata??{}),this._previousResult=Object.freeze(P.NotebookCellExecutionSummary.to(o.internalMetadata??{}))}static asModelAddData(n,m){return{EOL:m.eol,lines:m.source,languageId:m.language,uri:m.uri,isDirty:!1,versionId:1,notebook:n}}get internalMetadata(){return this._internalMetadata}get apiCell(){if(!this._apiCell){const n=this,m=this._extHostDocument.getDocument(this.uri);if(!m)throw new Error(`MISSING extHostDocument for notebook cell: ${this.uri}`);this._apiCell=Object.freeze({get index(){return n.notebook.getCellIndex(n)},notebook:n.notebook.apiNotebook,kind:P.NotebookCellKind.to(this._cellData.cellKind),document:m.document,get mime(){return n._mime},set mime(o){n._mime=o},get outputs(){return n._outputs.slice(0)},get metadata(){return n._metadata},get executionSummary(){return n._previousResult}})}return this._apiCell}setOutputs(n){this._outputs=n.map(P.NotebookCellOutput.to)}setOutputItems(n,m,o){const d=o.map(P.NotebookCellOutputItem.to),u=this._outputs.find(S=>S.id===n);u&&(m||(u.items.length=0),u.items.push(...d))}setMetadata(n){this._metadata=Object.freeze(n)}setInternalMetadata(n){this._internalMetadata=n,this._previousResult=Object.freeze(P.NotebookCellExecutionSummary.to(n))}setMime(n){}}e.ExtHostCell=k;class R{constructor(n,m,o,d,u,S){this._proxy=n,this._textDocumentsAndEditors=m,this._textDocuments=o,this._emitter=d,this.uri=u,this.handle=R._handlePool++,this._cells=[],this._versionId=0,this._isDirty=!1,this._disposed=!1,this._notebookType=S.viewType,this._metadata=Object.freeze(S.metadata??Object.create(null)),this._spliceNotebookCells([[0,0,S.cells]],!0),this._versionId=S.versionId}dispose(){this._disposed=!0}get apiNotebook(){if(!this._notebook){const n=this;this._notebook={get uri(){return n.uri},get version(){return n._versionId},get notebookType(){return n._notebookType},get isDirty(){return n._isDirty},get isUntitled(){return n.uri.scheme===c.Schemas.untitled},get isClosed(){return n._disposed},get metadata(){return n._metadata},get cellCount(){return n._cells.length},cellAt(m){return m=n._validateIndex(m),n._cells[m].apiCell},getCells(m){return(m?n._getCells(m):n._cells).map(d=>d.apiCell)},save(){return n._save()}}}return this._notebook}updateBackup(n){this._backup?.delete(),this._backup=n}disposeBackup(){this._backup?.delete(),this._backup=void 0}acceptDocumentPropertiesChanged(n){n.metadata&&(this._metadata=Object.freeze({...this._metadata,...n.metadata}))}acceptDirty(n){this._isDirty=n}acceptModelChanged(n,m){this._versionId=n.versionId,this._isDirty=m;for(const o of n.rawEvents)o.kind===T.NotebookCellsChangeType.ModelChange?this._spliceNotebookCells(o.changes,!1):o.kind===T.NotebookCellsChangeType.Move?this._moveCell(o.index,o.newIdx):o.kind===T.NotebookCellsChangeType.Output?this._setCellOutputs(o.index,o.outputs):o.kind===T.NotebookCellsChangeType.OutputItem?this._setCellOutputItems(o.index,o.outputId,o.append,o.outputItems):o.kind===T.NotebookCellsChangeType.ChangeLanguage?this._changeCellLanguage(o.index,o.language):o.kind===T.NotebookCellsChangeType.ChangeCellMime?this._changeCellMime(o.index,o.mime):o.kind===T.NotebookCellsChangeType.ChangeCellMetadata?this._changeCellMetadata(o.index,o.metadata):o.kind===T.NotebookCellsChangeType.ChangeCellInternalMetadata&&this._changeCellInternalMetadata(o.index,o.internalMetadata)}_validateIndex(n){return n=n|0,n<0?0:n>=this._cells.length?this._cells.length-1:n}_validateRange(n){let m=n.start|0,o=n.end|0;return m<0&&(m=0),o>this._cells.length&&(o=this._cells.length),n.with({start:m,end:o})}_getCells(n){n=this._validateRange(n);const m=[];for(let o=n.start;o<n.end;o++)m.push(this._cells[o]);return m}async _save(){return this._disposed?Promise.reject(new Error("Notebook has been closed")):this._proxy.$trySaveNotebook(this.uri)}_spliceNotebookCells(n,m){if(this._disposed)return;const o=[],d=[],u=[];n.reverse().forEach(S=>{const h=S[2].map(l=>{const M=new k(this,this._textDocumentsAndEditors,l);return m||d.push(k.asModelAddData(this.apiNotebook,l)),M}),g=new C(S[0],S[1],[],h),A=this._cells.splice(S[0],S[1],...h);for(const l of A)u.push(l.uri),g.deletedItems.push(l.apiCell);o.push(g)}),this._textDocumentsAndEditors.acceptDocumentsAndEditorsDelta({addedDocuments:d,removedDocuments:u}),m||this._emitter.emitModelChange((0,F.deepFreeze)({document:this.apiNotebook,changes:C.asApiEvents(o)}))}_moveCell(n,m){const o=this._cells.splice(n,1);this._cells.splice(m,0,...o);const d=[new C(n,1,o.map(u=>u.apiCell),[]),new C(m,0,[],o)];this._emitter.emitModelChange((0,F.deepFreeze)({document:this.apiNotebook,changes:C.asApiEvents(d)}))}_setCellOutputs(n,m){const o=this._cells[n];o.setOutputs(m),this._emitter.emitCellOutputsChange((0,F.deepFreeze)({document:this.apiNotebook,cells:[o.apiCell]}))}_setCellOutputItems(n,m,o,d){const u=this._cells[n];u.setOutputItems(m,o,d),this._emitter.emitCellOutputsChange((0,F.deepFreeze)({document:this.apiNotebook,cells:[u.apiCell]}))}_changeCellLanguage(n,m){const o=this._cells[n];o.apiCell.document.languageId!==m&&this._textDocuments.$acceptModelModeChanged(o.uri,m)}_changeCellMime(n,m){const o=this._cells[n];o.apiCell.mime=m}_changeCellMetadata(n,m){const o=this._cells[n],d=o.apiCell.metadata;o.setMetadata(m);const u=o.apiCell.metadata;(0,F.equals)(d,u)||this._emitter.emitCellMetadataChange((0,F.deepFreeze)({document:this.apiNotebook,cell:o.apiCell}))}_changeCellInternalMetadata(n,m){const o=this._cells[n],d=o.internalMetadata;if(o.setInternalMetadata(m),d.runState!==m.runState){const u=m.runState??t.NotebookCellExecutionState.Idle;this._emitter.emitCellExecutionStateChange((0,F.deepFreeze)({document:this.apiNotebook,cell:o.apiCell,state:u}))}}getCellFromApiCell(n){return this._cells.find(m=>m.apiCell===n)}getCellFromIndex(n){return this._cells[n]}getCell(n){return this._cells.find(m=>m.handle===n)}getCellIndex(n){return this._cells.indexOf(n)}}e.ExtHostNotebookDocument=R,R._handlePool=0}),define(Ee[91],_e([0,1,7,8,15]),function(re,e,c,F,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookEditor=void 0;class P{constructor(C){this._finalized=!1,this._collectedEdits=[],this._documentVersionId=C}finalize(){return this._finalized=!0,{documentVersionId:this._documentVersionId,cellEdits:this._collectedEdits}}_throwIfFinalized(){if(this._finalized)throw new Error("Edit is only valid while callback runs")}replaceMetadata(C){this._throwIfFinalized(),this._collectedEdits.push({editType:5,metadata:C})}replaceCellMetadata(C,k){this._throwIfFinalized(),this._collectedEdits.push({editType:8,index:C,metadata:k})}replaceCells(C,k,R){this._throwIfFinalized(),!(C===k&&R.length===0)&&this._collectedEdits.push({editType:1,index:C,count:k-C,cells:R.map(F.NotebookCellData.from)})}}class t{constructor(C,k,R,_,n,m){this.id=C,this._proxy=k,this.notebookData=R,this._selections=[],this._visibleRanges=[],this._visible=!1,this._hasDecorationsForKey=new Set,this._selections=n,this._visibleRanges=_,this._viewColumn=m}get apiEditor(){if(!this._editor){const C=this;this._editor={get document(){return C.notebookData.apiNotebook},get selections(){return C._selections},set selections(k){if(!Array.isArray(k)||!k.every(c.NotebookRange.isNotebookRange))throw(0,w.illegalArgument)("selections");C._selections=k,C._trySetSelections(k)},get visibleRanges(){return C._visibleRanges},revealRange(k,R){C._proxy.$tryRevealRange(C.id,F.NotebookRange.from(k),R??c.NotebookEditorRevealType.Default)},get viewColumn(){return C._viewColumn},edit(k){const R=new P(this.document.version);return k(R),C._applyEdit(R.finalize())},setDecorations(k,R){return C.setDecorations(k,R)}},t.apiEditorsToExtHost.set(this._editor,this)}return this._editor}get visible(){return this._visible}_acceptVisibility(C){this._visible=C}_acceptVisibleRanges(C){this._visibleRanges=C}_acceptSelections(C){this._selections=C}_trySetSelections(C){this._proxy.$trySetSelections(this.id,C.map(F.NotebookRange.from))}_acceptViewColumn(C){this._viewColumn=C}_applyEdit(C){if(C.cellEdits.length===0)return Promise.resolve(!0);const k=[];let R=-1;for(let _=0;_<C.cellEdits.length;_++){if(R<0){k.push(C.cellEdits[_]),R++;continue}const m=k[R],o=C.cellEdits[_];if(m.editType===1&&o.editType===1&&m.index===o.index){m.cells.push(...C.cellEdits[_].cells),m.count+=C.cellEdits[_].count;continue}k.push(C.cellEdits[_]),R++}return this._proxy.$tryApplyEdits(this.id,C.documentVersionId,k)}setDecorations(C,k){if(!(k.isEmpty&&!this._hasDecorationsForKey.has(C.key)))return k.isEmpty?this._hasDecorationsForKey.delete(C.key):this._hasDecorationsForKey.add(C.key),this._proxy.$trySetDecorations(this.id,F.NotebookRange.from(k),C.key)}}e.ExtHostNotebookEditor=t,t.apiEditorsToExtHost=new WeakMap}),define(Ee[168],_e([0,1,8,140,121,20,51,15]),function(re,e,c,F,w,P,t,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostProgress=void 0;class C{constructor(n){this._handles=0,this._mapHandleToCancellationSource=new Map,this._proxy=n}async withProgress(n,m,o){const d=this._handles++,{title:u,location:S,cancellable:b}=m,h={label:(0,w.localize)(0,null,n.displayName||n.name),id:n.identifier.value};return this._proxy.$startProgress(d,{location:c.ProgressLocation.from(S),title:u,source:h,cancellable:b},n).catch(T.onUnexpectedExternalError),this._withProgress(d,o,!!b)}_withProgress(n,m,o){let d;o&&(d=new P.CancellationTokenSource,this._mapHandleToCancellationSource.set(n,d));const u=b=>{this._proxy.$progressEnd(b),this._mapHandleToCancellationSource.delete(b),d&&d.dispose()};let S;try{S=m(new R(this._proxy,n),o&&d?d.token:P.CancellationToken.None)}catch(b){throw u(n),b}return S.then(b=>u(n),b=>u(n)),S}$acceptProgressCanceled(n){const m=this._mapHandleToCancellationSource.get(n);m&&(m.cancel(),this._mapHandleToCancellationSource.delete(n))}}e.ExtHostProgress=C;function k(_,n){return _.message=n.message,typeof n.increment=="number"&&(typeof _.increment=="number"?_.increment+=n.increment:_.increment=n.increment),_}class R extends F.Progress{constructor(n,m){super(o=>this.throttledReport(o));this._proxy=n,this._handle=m}throttledReport(n){this._proxy.$progressReport(this._handle,n)}}Ue([(0,t.throttle)(100,(_,n)=>k(_,n),()=>Object.create(null))],R.prototype,"throttledReport",null)}),define(Ee[92],_e([0,1,41,15,52,8,7]),function(re,e,c,F,w,P,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTextEditor=e.ExtHostTextEditorOptions=e.TextEditorEdit=e.TextEditorDecorationType=void 0;class T{constructor(n,m,o){const d=T._Keys.nextId();n.$registerTextEditorDecorationType(m.identifier,d,P.DecorationRenderOptions.from(o)),this.value=Object.freeze({key:d,dispose(){n.$removeTextEditorDecorationType(d)}})}}e.TextEditorDecorationType=T,T._Keys=new w.IdGenerator("TextEditorDecorationType");class C{constructor(n,m){this._collectedEdits=[],this._setEndOfLine=void 0,this._finalized=!1,this._document=n,this._documentVersionId=n.version,this._undoStopBefore=m.undoStopBefore,this._undoStopAfter=m.undoStopAfter}finalize(){return this._finalized=!0,{documentVersionId:this._documentVersionId,edits:this._collectedEdits,setEndOfLine:this._setEndOfLine,undoStopBefore:this._undoStopBefore,undoStopAfter:this._undoStopAfter}}_throwIfFinalized(){if(this._finalized)throw new Error("Edit is only valid while callback runs")}replace(n,m){this._throwIfFinalized();let o=null;if(n instanceof t.Position)o=new t.Range(n,n);else if(n instanceof t.Range)o=n;else throw new Error("Unrecognized location");this._pushEdit(o,m,!1)}insert(n,m){this._throwIfFinalized(),this._pushEdit(new t.Range(n,n),m,!0)}delete(n){this._throwIfFinalized();let m=null;if(n instanceof t.Range)m=n;else throw new Error("Unrecognized location");this._pushEdit(m,null,!0)}_pushEdit(n,m,o){const d=this._document.validateRange(n);this._collectedEdits.push({range:d,text:m,forceMoveMarkers:o})}setEndOfLine(n){if(this._throwIfFinalized(),n!==t.EndOfLine.LF&&n!==t.EndOfLine.CRLF)throw(0,F.illegalArgument)("endOfLine");this._setEndOfLine=n}}e.TextEditorEdit=C;class k{constructor(n,m,o,d){this._proxy=n,this._id=m,this._accept(o),this._logService=d;const u=this;this.value={get tabSize(){return u._tabSize},set tabSize(S){u._setTabSize(S)},get insertSpaces(){return u._insertSpaces},set insertSpaces(S){u._setInsertSpaces(S)},get cursorStyle(){return u._cursorStyle},set cursorStyle(S){u._setCursorStyle(S)},get lineNumbers(){return u._lineNumbers},set lineNumbers(S){u._setLineNumbers(S)}}}_accept(n){this._tabSize=n.tabSize,this._insertSpaces=n.insertSpaces,this._cursorStyle=n.cursorStyle,this._lineNumbers=P.TextEditorLineNumbersStyle.to(n.lineNumbers)}_validateTabSize(n){if(n==="auto")return"auto";if(typeof n=="number"){const m=Math.floor(n);return m>0?m:null}if(typeof n=="string"){const m=parseInt(n,10);return isNaN(m)?null:m>0?m:null}return null}_setTabSize(n){const m=this._validateTabSize(n);if(m!==null){if(typeof m=="number"){if(this._tabSize===m)return;this._tabSize=m}this._warnOnError("setTabSize",this._proxy.$trySetOptions(this._id,{tabSize:m}))}}_validateInsertSpaces(n){return n==="auto"?"auto":n==="false"?!1:Boolean(n)}_setInsertSpaces(n){const m=this._validateInsertSpaces(n);if(typeof m=="boolean"){if(this._insertSpaces===m)return;this._insertSpaces=m}this._warnOnError("setInsertSpaces",this._proxy.$trySetOptions(this._id,{insertSpaces:m}))}_setCursorStyle(n){this._cursorStyle!==n&&(this._cursorStyle=n,this._warnOnError("setCursorStyle",this._proxy.$trySetOptions(this._id,{cursorStyle:n})))}_setLineNumbers(n){this._lineNumbers!==n&&(this._lineNumbers=n,this._warnOnError("setLineNumbers",this._proxy.$trySetOptions(this._id,{lineNumbers:P.TextEditorLineNumbersStyle.from(n)})))}assign(n){const m={};let o=!1;if(typeof n.tabSize!="undefined"){const d=this._validateTabSize(n.tabSize);d==="auto"?(o=!0,m.tabSize=d):typeof d=="number"&&this._tabSize!==d&&(this._tabSize=d,o=!0,m.tabSize=d)}if(typeof n.insertSpaces!="undefined"){const d=this._validateInsertSpaces(n.insertSpaces);d==="auto"?(o=!0,m.insertSpaces=d):this._insertSpaces!==d&&(this._insertSpaces=d,o=!0,m.insertSpaces=d)}typeof n.cursorStyle!="undefined"&&this._cursorStyle!==n.cursorStyle&&(this._cursorStyle=n.cursorStyle,o=!0,m.cursorStyle=n.cursorStyle),typeof n.lineNumbers!="undefined"&&this._lineNumbers!==n.lineNumbers&&(this._lineNumbers=n.lineNumbers,o=!0,m.lineNumbers=P.TextEditorLineNumbersStyle.from(n.lineNumbers)),o&&this._warnOnError("setOptions",this._proxy.$trySetOptions(this._id,m))}_warnOnError(n,m){m.catch(o=>{this._logService.warn(`ExtHostTextEditorOptions '${n}' failed:'`),this._logService.warn(o)})}}e.ExtHostTextEditorOptions=k;class R{constructor(n,m,o,d,u,S,b,h){this.id=n,this._proxy=m,this._logService=o,this._disposed=!1,this._hasDecorationsForKey=new Set,this._selections=u,this._options=new k(this._proxy,this.id,S,o),this._visibleRanges=b,this._viewColumn=h;const g=this;this.value=Object.freeze({get document(){return d.getValue()},set document(A){throw(0,F.readonly)("document")},get selection(){return g._selections&&g._selections[0]},set selection(A){if(!(A instanceof t.Selection))throw(0,F.illegalArgument)("selection");g._selections=[A],g._trySetSelection()},get selections(){return g._selections},set selections(A){if(!Array.isArray(A)||A.some(l=>!(l instanceof t.Selection)))throw(0,F.illegalArgument)("selections");g._selections=A,g._trySetSelection()},get visibleRanges(){return g._visibleRanges},set visibleRanges(A){throw(0,F.readonly)("visibleRanges")},get options(){return g._options.value},set options(A){g._disposed||g._options.assign(A)},get viewColumn(){return g._viewColumn},set viewColumn(A){throw(0,F.readonly)("viewColumn")},edit(A,l={undoStopBefore:!0,undoStopAfter:!0}){if(g._disposed)return Promise.reject(new Error("TextEditor#edit not possible on closed editors"));const M=new C(d.getValue(),l);return A(M),g._applyEdit(M)},insertSnippet(A,l,M={undoStopBefore:!0,undoStopAfter:!0}){if(g._disposed)return Promise.reject(new Error("TextEditor#insertSnippet not possible on closed editors"));let r;if(!l||Array.isArray(l)&&l.length===0)r=g._selections.map(i=>P.Range.from(i));else if(l instanceof t.Position){const{lineNumber:i,column:p}=P.Position.from(l);r=[{startLineNumber:i,startColumn:p,endLineNumber:i,endColumn:p}]}else if(l instanceof t.Range)r=[P.Range.from(l)];else{r=[];for(const i of l)if(i instanceof t.Range)r.push(P.Range.from(i));else{const{lineNumber:p,column:f}=P.Position.from(i);r.push({startLineNumber:p,startColumn:f,endLineNumber:p,endColumn:f})}}return m.$tryInsertSnippet(n,A.value,r,M)},setDecorations(A,l){const M=l.length===0;M&&!g._hasDecorationsForKey.has(A.key)||(M?g._hasDecorationsForKey.delete(A.key):g._hasDecorationsForKey.add(A.key),g._runOnProxy(()=>{if(P.isDecorationOptionsArr(l))return m.$trySetDecorations(n,A.key,P.fromRangeOrRangeWithMessage(l));{const r=new Array(4*l.length);for(let i=0,p=l.length;i<p;i++){const f=l[i];r[4*i]=f.start.line+1,r[4*i+1]=f.start.character+1,r[4*i+2]=f.end.line+1,r[4*i+3]=f.end.character+1}return m.$trySetDecorationsFast(n,A.key,r)}}))},revealRange(A,l){g._runOnProxy(()=>m.$tryRevealRange(n,P.Range.from(A),l||t.TextEditorRevealType.Default))},show(A){m.$tryShowEditor(n,P.ViewColumn.from(A))},hide(){m.$tryHideEditor(n)}})}dispose(){(0,c.ok)(!this._disposed),this._disposed=!0}_acceptOptions(n){(0,c.ok)(!this._disposed),this._options._accept(n)}_acceptVisibleRanges(n){(0,c.ok)(!this._disposed),this._visibleRanges=n}_acceptViewColumn(n){(0,c.ok)(!this._disposed),this._viewColumn=n}_acceptSelections(n){(0,c.ok)(!this._disposed),this._selections=n}async _trySetSelection(){const n=this._selections.map(P.Selection.from);return await this._runOnProxy(()=>this._proxy.$trySetSelections(this.id,n)),this.value}_applyEdit(n){const m=n.finalize();if(m.edits.length===0&&!m.setEndOfLine)return Promise.resolve(!0);const o=m.edits.map(u=>u.range);o.sort((u,S)=>u.end.line===S.end.line?u.end.character===S.end.character?u.start.line===S.start.line?u.start.character-S.start.character:u.start.line-S.start.line:u.end.character-S.end.character:u.end.line-S.end.line);for(let u=0,S=o.length-1;u<S;u++){const b=o[u].end;if(o[u+1].start.isBefore(b))return Promise.reject(new Error("Overlapping ranges are not allowed!"))}const d=m.edits.map(u=>({range:P.Range.from(u.range),text:u.text,forceMoveMarkers:u.forceMoveMarkers}));return this._proxy.$tryApplyEdits(this.id,m.documentVersionId,d,{setEndOfLine:typeof m.setEndOfLine=="number"?P.EndOfLine.from(m.setEndOfLine):void 0,undoStopBefore:m.undoStopBefore,undoStopAfter:m.undoStopAfter})}_runOnProxy(n){return this._disposed?(this._logService.warn("TextEditor is closed/disposed"),Promise.resolve(void 0)):n().then(()=>this,m=>(m instanceof Error&&m.name==="DISPOSED"||this._logService.warn(m),null))}}e.ExtHostTextEditor=R}),define(Ee[169],_e([0,1,124,24,2,3,6,14,7,11,16,8,20,153]),function(re,e,c,F,w,P,t,T,C,k,R,_,n,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTreeViews=void 0;function o(S,b){if((0,k.isString)(S))return{label:S};if(S&&typeof S=="object"&&typeof S.label=="string"){let h;return Array.isArray(S.highlights)&&(h=S.highlights.filter(g=>g.length===2&&typeof g[0]=="number"&&typeof g[1]=="number"),h=h.length?h:void 0),{label:S.label,highlights:h}}}class d{constructor(b,h,g){this._proxy=b,this.commands=h,this.logService=g,this.treeViews=new Map;function A(l){return l&&l.$treeViewId&&l.$treeItemHandle}h.registerArgumentProcessor({processArgument:l=>A(l)?this.convertArgument(l):Array.isArray(l)&&l.length>0?l.map(M=>A(M)?this.convertArgument(M):M):l})}registerTreeDataProvider(b,h,g){const A=this.createTreeView(b,{treeDataProvider:h},g);return{dispose:()=>A.dispose()}}createTreeView(b,h,g){if(!h||!h.treeDataProvider)throw new Error("Options with treeDataProvider is mandatory");const A=h.dragAndDropController?.supportedMimeTypes,l=this._proxy.$registerTreeViewDataProvider(b,{showCollapseAll:!!h.showCollapseAll,canSelectMany:!!h.canSelectMany,dragAndDropMimeTypes:A}),M=this.createExtHostTreeView(b,h,g);return{get onDidCollapseElement(){return M.onDidCollapseElement},get onDidExpandElement(){return M.onDidExpandElement},get selection(){return M.selectedElements},get onDidChangeSelection(){return M.onDidChangeSelection},get visible(){return M.visible},get onDidChangeVisibility(){return M.onDidChangeVisibility},get message(){return M.message},set message(r){M.message=r},get title(){return M.title},set title(r){M.title=r},get description(){return M.description},set description(r){M.description=r},reveal:(r,i)=>M.reveal(r,i),dispose:async()=>{await l,this.treeViews.delete(b),M.dispose()}}}$getChildren(b,h){const g=this.treeViews.get(b);return g?g.getChildren(h):Promise.reject(new Error((0,c.localize)(0,null,b)))}async $onDrop(b,h,g,A,l){const M=this.treeViews.get(b);if(!M)return Promise.reject(new Error((0,c.localize)(1,null,b)));const r=m.TreeDataTransferConverter.toITreeDataTransfer(h);if(A===b&&l){const i=await M.onWillDrop(l);i&&i.forEach((p,f)=>{p&&r.set(f,p)})}return M.onDrop(r,g)}async $hasResolve(b){const h=this.treeViews.get(b);if(!h)throw new Error((0,c.localize)(2,null,b));return h.hasResolve}$resolve(b,h,g){const A=this.treeViews.get(b);if(!A)throw new Error((0,c.localize)(3,null,b));return A.resolveTreeItem(h,g)}$setExpanded(b,h,g){const A=this.treeViews.get(b);if(!A)throw new Error((0,c.localize)(4,null,b));A.setExpanded(h,g)}$setSelection(b,h){const g=this.treeViews.get(b);if(!g)throw new Error((0,c.localize)(5,null,b));g.setSelection(h)}$setVisible(b,h){const g=this.treeViews.get(b);if(!g)throw new Error((0,c.localize)(6,null,b));g.setVisible(h)}createExtHostTreeView(b,h,g){const A=new u(b,h,this._proxy,this.commands.converter,this.logService,g);return this.treeViews.set(b,A),A}convertArgument(b){const h=this.treeViews.get(b.$treeViewId);return h?h.getExtensionElement(b.$treeItemHandle):null}}e.ExtHostTreeViews=d;class u extends t.Disposable{constructor(b,h,g,A,l,M){super();if(this.viewId=b,this.proxy=g,this.commands=A,this.logService=l,this.extension=M,this.roots=void 0,this.elements=new Map,this.nodes=new Map,this._visible=!1,this._selectedHandles=[],this._onDidExpandElement=this._register(new P.Emitter),this.onDidExpandElement=this._onDidExpandElement.event,this._onDidCollapseElement=this._register(new P.Emitter),this.onDidCollapseElement=this._onDidCollapseElement.event,this._onDidChangeSelection=this._register(new P.Emitter),this.onDidChangeSelection=this._onDidChangeSelection.event,this._onDidChangeVisibility=this._register(new P.Emitter),this.onDidChangeVisibility=this._onDidChangeVisibility.event,this._onDidChangeData=this._register(new P.Emitter),this.refreshPromise=Promise.resolve(),this.refreshQueue=Promise.resolve(),this._message="",this._title="",this._refreshCancellationSource=new n.CancellationTokenSource,M.contributes&&M.contributes.views)for(const p in M.contributes.views)for(const f of M.contributes.views[p])f.id===b&&(this._title=f.name);this.dataProvider=h.treeDataProvider,this.dndController=h.dragAndDropController,this.dataProvider.onDidChangeTreeData2?this._register(this.dataProvider.onDidChangeTreeData2(p=>this._onDidChangeData.fire({message:!1,element:p}))):this.dataProvider.onDidChangeTreeData&&this._register(this.dataProvider.onDidChangeTreeData(p=>this._onDidChangeData.fire({message:!1,element:p})));let r,i;this._register(P.Event.debounce(this._onDidChangeData.event,(p,f)=>(p||(p={message:!1,elements:[]}),f.element!==!1&&(r||(r=new Promise(s=>i=s),this.refreshPromise=this.refreshPromise.then(()=>r)),Array.isArray(f.element)?p.elements.push(...f.element):p.elements.push(f.element)),f.message&&(p.message=!0),p),200,!0)(({message:p,elements:f})=>{f.length&&(this.refreshQueue=this.refreshQueue.then(()=>{const s=i;return r=null,this.refresh(f).then(()=>s())})),p&&this.proxy.$setMessage(this.viewId,this._message)}))}get visible(){return this._visible}get selectedElements(){return this._selectedHandles.map(b=>this.getExtensionElement(b)).filter(b=>!(0,k.isUndefinedOrNull)(b))}async getChildren(b){const h=b?this.getExtensionElement(b):void 0;if(b&&!h)return this.logService.error(`No tree item with id '${b}' found.`),Promise.resolve([]);let g=this.getChildrenNodes(b);return g||(g=await this.fetchChildrenNodes(h)),g?g.map(A=>A.item):void 0}getExtensionElement(b){return this.elements.get(b)}reveal(b,h){h=h||{select:!0,focus:!1};const g=(0,k.isUndefinedOrNull)(h.select)?!0:h.select,A=(0,k.isUndefinedOrNull)(h.focus)?!1:h.focus,l=(0,k.isUndefinedOrNull)(h.expand)?!1:h.expand;return typeof this.dataProvider.getParent!="function"?Promise.reject(new Error("Required registered TreeDataProvider to implement 'getParent' method to access 'reveal' method")):b?this.refreshPromise.then(()=>this.resolveUnknownParentChain(b)).then(M=>this.resolveTreeNode(b,M[M.length-1]).then(r=>this.proxy.$reveal(this.viewId,{item:r.item,parentChain:M.map(i=>i.item)},{select:g,focus:A,expand:l})),M=>this.logService.error(M)):this.proxy.$reveal(this.viewId,void 0,{select:g,focus:A,expand:l})}get message(){return this._message}set message(b){this._message=b,this._onDidChangeData.fire({message:!0,element:!1})}get title(){return this._title}set title(b){this._title=b,this.proxy.$setTitle(this.viewId,b,this._description)}get description(){return this._description}set description(b){this._description=b,this.proxy.$setTitle(this.viewId,this._title,b)}setExpanded(b,h){const g=this.getExtensionElement(b);g&&(h?this._onDidExpandElement.fire(Object.freeze({element:g})):this._onDidCollapseElement.fire(Object.freeze({element:g})))}setSelection(b){(0,R.equals)(this._selectedHandles,b)||(this._selectedHandles=b,this._onDidChangeSelection.fire(Object.freeze({selection:this.selectedElements})))}setVisible(b){b!==this._visible&&(this._visible=b,this._onDidChangeVisibility.fire(Object.freeze({visible:this._visible})))}async onWillDrop(b){const h=[];for(const g of b){const A=this.getExtensionElement(g);A&&h.push(A)}if(!(!this.dndController?.onWillDrop||h.length===0))return this.dndController.onWillDrop(h)}async onDrop(b,h){const g=this.getExtensionElement(h);if(!!g)return(0,T.asPromise)(()=>this.dndController?.onDrop(b,g))}get hasResolve(){return!!this.dataProvider.resolveTreeItem}async resolveTreeItem(b,h){if(!this.dataProvider.resolveTreeItem)return;const g=this.elements.get(b);if(g){const A=this.nodes.get(g);if(A){const l=await this.dataProvider.resolveTreeItem(A.extensionItem,g,h)??A.extensionItem;return A.item.tooltip=this.getTooltip(l.tooltip),A.item.command=this.getCommand(A.disposableStore,l.command),A.item}}}resolveUnknownParentChain(b){return this.resolveParent(b).then(h=>h?this.resolveUnknownParentChain(h).then(g=>this.resolveTreeNode(h,g[g.length-1]).then(A=>(g.push(A),g))):Promise.resolve([]))}resolveParent(b){const h=this.nodes.get(b);return h?Promise.resolve(h.parent?this.elements.get(h.parent.item.handle):void 0):(0,T.asPromise)(()=>this.dataProvider.getParent(b))}resolveTreeNode(b,h){const g=this.nodes.get(b);return g?Promise.resolve(g):(0,T.asPromise)(()=>this.dataProvider.getTreeItem(b)).then(A=>this.createHandle(b,A,h,!0)).then(A=>this.getChildren(h?h.item.handle:void 0).then(()=>{const l=this.getExtensionElement(A);if(l){const M=this.nodes.get(l);if(M)return Promise.resolve(M)}throw new Error(`Cannot resolve tree item for element ${A}`)}))}getChildrenNodes(b){if(b){let h;if(typeof b=="string"){const g=this.getExtensionElement(b);h=g?this.nodes.get(g):void 0}else h=b;return h&&h.children||void 0}return this.roots}async fetchChildrenNodes(b){this.clearChildren(b);const h=new n.CancellationTokenSource(this._refreshCancellationSource.token);try{const g=b?this.nodes.get(b):void 0,A=await this.dataProvider.getChildren(b);if(h.token.isCancellationRequested)return;const l=await Promise.all((0,R.coalesce)(A||[]).map(async M=>{const r=await this.dataProvider.getTreeItem(M);return r&&!h.token.isCancellationRequested?this.createAndRegisterTreeNode(M,r,g):null}));return h.token.isCancellationRequested?void 0:(0,R.coalesce)(l)}finally{h.dispose()}}refresh(b){if(b.some(g=>!g))return this._refreshCancellationSource.dispose(!0),this._refreshCancellationSource=new n.CancellationTokenSource,this.clearAll(),this.proxy.$refresh(this.viewId);{const g=this.getHandlesToRefresh(b);if(g.length)return this.refreshHandles(g)}return Promise.resolve(void 0)}getHandlesToRefresh(b){const h=new Set,g=b.map(l=>this.nodes.get(l));for(const l of g)if(l&&!h.has(l.item.handle)){let M=l;for(;M&&M.parent&&g.findIndex(r=>M&&M.parent&&r&&r.item.handle===M.parent.item.handle)===-1;){const r=this.elements.get(M.parent.item.handle);M=r?this.nodes.get(r):void 0}M&&!M.parent&&h.add(l.item.handle)}const A=[];return h.forEach(l=>{const M=this.elements.get(l);if(M){const r=this.nodes.get(M);r&&(!r.parent||!h.has(r.parent.item.handle))&&A.push(l)}}),A}refreshHandles(b){const h={};return Promise.all(b.map(g=>this.refreshNode(g).then(A=>{A&&(h[g]=A.item)}))).then(()=>Object.keys(h).length?this.proxy.$refresh(this.viewId,h):void 0)}refreshNode(b){const h=this.getExtensionElement(b);if(h){const g=this.nodes.get(h);if(g)return this.clearChildren(h),(0,T.asPromise)(()=>this.dataProvider.getTreeItem(h)).then(A=>{if(A){const l=this.createTreeNode(h,A,g.parent);return this.updateNodeCache(h,l,g,g.parent),g.dispose(),l}return null})}return Promise.resolve(null)}createAndRegisterTreeNode(b,h,g){const A=this.createTreeNode(b,h,g);if(h.id&&this.elements.has(A.item.handle))throw new Error((0,c.localize)(7,null,h.id));return this.addNodeToCache(b,A),this.addNodeToParentCache(A,g),A}getTooltip(b){return C.MarkdownString.isMarkdownString(b)?_.MarkdownString.from(b):b}getCommand(b,h){return h?this.commands.toInternal(h,b):void 0}createTreeNode(b,h,g){const A=new t.DisposableStore,l=this.createHandle(b,h,g),M=this.getLightIconPath(h);return{item:{handle:l,parentHandle:g?g.item.handle:void 0,label:o(h.label,this.extension),description:h.description,resourceUri:h.resourceUri,tooltip:this.getTooltip(h.tooltip),command:this.getCommand(A,h.command),contextValue:h.contextValue,icon:M,iconDark:this.getDarkIconPath(h)||M,themeIcon:this.getThemeIcon(h),collapsibleState:(0,k.isUndefinedOrNull)(h.collapsibleState)?C.TreeItemCollapsibleState.None:h.collapsibleState,accessibilityInformation:h.accessibilityInformation},extensionItem:h,parent:g,children:void 0,disposableStore:A,dispose(){A.dispose()}}}getThemeIcon(b){return b.iconPath instanceof C.ThemeIcon?b.iconPath:void 0}createHandle(b,{id:h,label:g,resourceUri:A},l,M){if(h)return`${u.ID_HANDLE_PREFIX}/${h}`;const r=o(g,this.extension),i=l?l.item.handle:u.LABEL_HANDLE_PREFIX;let p=r?r.label:A?(0,F.basename)(A):"";p=p.indexOf("/")!==-1?p.replace("/","//"):p;const f=this.nodes.has(b)?this.nodes.get(b).item.handle:void 0,s=this.getChildrenNodes(l)||[];let v,a=0;do{if(v=`${i}/${a}:${p}`,M||!this.elements.has(v)||f===v)break;a++}while(a<=s.length);return v}getLightIconPath(b){if(b.iconPath&&!(b.iconPath instanceof C.ThemeIcon))return typeof b.iconPath=="string"||w.URI.isUri(b.iconPath)?this.getIconPath(b.iconPath):this.getIconPath(b.iconPath.light)}getDarkIconPath(b){if(b.iconPath&&!(b.iconPath instanceof C.ThemeIcon)&&b.iconPath.dark)return this.getIconPath(b.iconPath.dark)}getIconPath(b){return w.URI.isUri(b)?b:w.URI.file(b)}addNodeToCache(b,h){this.elements.set(h.item.handle,b),this.nodes.set(b,h)}updateNodeCache(b,h,g,A){this.elements.delete(h.item.handle),this.nodes.delete(b),h.item.handle!==g.item.handle&&this.elements.delete(g.item.handle),this.addNodeToCache(b,h);const l=this.getChildrenNodes(A)||[],M=l.filter(r=>r.item.handle===g.item.handle)[0];M&&l.splice(l.indexOf(M),1,h)}addNodeToParentCache(b,h){h?(h.children||(h.children=[]),h.children.push(b)):(this.roots||(this.roots=[]),this.roots.push(b))}clearChildren(b){if(b){const h=this.nodes.get(b);if(h){if(h.children)for(const g of h.children){const A=this.elements.get(g.item.handle);A&&this.clear(A)}h.children=void 0}}else this.clearAll()}clear(b){const h=this.nodes.get(b);if(h){if(h.children)for(const g of h.children){const A=this.elements.get(g.item.handle);A&&this.clear(A)}this.nodes.delete(b),this.elements.delete(h.item.handle),h.dispose()}}clearAll(){this.roots=void 0,this.elements.clear(),this.nodes.forEach(b=>b.dispose()),this.nodes.clear()}dispose(){this._refreshCancellationSource.dispose(),this.clearAll()}}u.LABEL_HANDLE_PREFIX="0",u.ID_HANDLE_PREFIX="1"}),define(Ee[170],_e([0,1,14,3,6,11,47,8,88,67]),function(re,e,c,F,w,P,t,T,C,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SingleUseTestCollection=void 0;class R extends w.Disposable{constructor(n){super();this.controllerId=n,this.debounceSendDiff=this._register(new c.RunOnceScheduler(()=>this.flushDiff(),200)),this.diffOpEmitter=this._register(new F.Emitter),this.root=new t.TestItemRootImpl(this.controllerId,this.controllerId),this.tree=new Map,this.tags=new Map,this.diff=[],this.onDidGenerateDiff=this.diffOpEmitter.event,this.root.canResolveChildren=!0,this.upsertItem(this.root,void 0)}set resolveHandler(n){this._resolveHandler=n;for(const m of this.tree.values())this.updateExpandability(m)}collectDiff(){const n=this.diff;return this.diff=[],n}pushDiff(n){const m=this.diff[this.diff.length-1];if(m&&n[0]===1){if(m[0]===1&&m[1].extId===n[1].extId){(0,C.applyTestItemUpdate)(m[1],n[1]);return}if(m[0]===0&&m[1].item.extId===n[1].extId){(0,C.applyTestItemUpdate)(m[1],n[1]);return}}this.diff.push(n),this.debounceSendDiff.isScheduled()||this.debounceSendDiff.schedule()}expand(n,m){const o=this.tree.get(n);if(!!o){if((o.expandLevels===void 0||m>o.expandLevels)&&(o.expandLevels=m),o.expand===1){const d=this.resolveChildren(o);return d.isOpen()?this.expandChildren(o,m-1):d.wait().then(()=>this.expandChildren(o,m-1))}else if(o.expand===3)return o.resolveBarrier?.isOpen()===!1?o.resolveBarrier.wait().then(()=>this.expandChildren(o,m-1)):this.expandChildren(o,m-1)}}dispose(){for(const n of this.tree.values())(0,t.getPrivateApiFor)(n.actual).listener=void 0;this.tree.clear(),this.diff=[],super.dispose()}onTestItemEvent(n,m){switch(m.op){case 2:this.pushDiff([4,n.fullId.toString()]);break;case 1:this.removeItem(k.TestId.joinToString(n.fullId,m.id));break;case 0:this.upsertItem(m.item,n);break;case 4:for(const b of m.ops)this.onTestItemEvent(n,b);break;case 3:const{key:o,value:d,previous:u}=m,S=n.fullId.toString();switch(o){case"canResolveChildren":this.updateExpandability(n);break;case"tags":this.diffTagRefs(d,u,S);break;case"range":this.pushDiff([1,{extId:S,item:{range:T.Range.from(d)}}]);break;case"error":this.pushDiff([1,{extId:S,item:{error:T.MarkdownString.fromStrict(d)||null}}]);break;default:this.pushDiff([1,{extId:S,item:{[o]:d??null}}]);break}break;default:(0,P.assertNever)(m)}}upsertItem(n,m){if(!(n instanceof t.TestItemImpl))throw new Error(`TestItems provided to the VS Code API must extend \`vscode.TestItem\`, but ${n.id} did not`);const o=k.TestId.fromExtHostTestItem(n,this.root.id,m?.actual),d=(0,t.getPrivateApiFor)(n);d.parent&&d.parent!==m?.actual&&d.parent.children.delete(n.id);let u=this.tree.get(o.toString());if(!u){u={fullId:o,actual:n,parent:m?o.parentId:null,expandLevels:m?.expandLevels?m.expandLevels-1:void 0,expand:0},n.tags.forEach(this.incrementTagRefs,this),this.tree.set(u.fullId.toString(),u),this.setItemParent(n,m),this.pushDiff([0,{parent:u.parent&&u.parent.toString(),controllerId:this.controllerId,expand:u.expand,item:T.TestItem.from(n)}]),this.connectItemAndChildren(n,u,m);return}if(u.actual===n){this.connectItem(n,u,m);return}const S=u.actual.children,b=u.actual,h=(0,t.diffTestItems)(b,n);(0,t.getPrivateApiFor)(b).listener=void 0,u.actual=n,u.expand=0;for(const[g,A]of h)this.onTestItemEvent(u,{op:3,key:g,value:A,previous:b[g]});this.connectItemAndChildren(n,u,m);for(const g of S)n.children.get(g.id)||this.removeItem(k.TestId.joinToString(o,g.id))}diffTagRefs(n,m,o){const d=new Set(m.map(u=>u.id));for(const u of n)d.delete(u.id)||this.incrementTagRefs(u);this.pushDiff([1,{extId:o,item:{tags:n.map(u=>T.TestTag.namespace(this.controllerId,u.id))}}]),d.forEach(this.decrementTagRefs,this)}incrementTagRefs(n){const m=this.tags.get(n.id);m?m.refCount++:(this.tags.set(n.id,{refCount:1}),this.pushDiff([5,{id:T.TestTag.namespace(this.controllerId,n.id),ctrlLabel:this.root.label}]))}decrementTagRefs(n){const m=this.tags.get(n);m&&!--m.refCount&&(this.tags.delete(n),this.pushDiff([6,T.TestTag.namespace(this.controllerId,n)]))}setItemParent(n,m){(0,t.getPrivateApiFor)(n).parent=m&&m.actual!==this.root?m.actual:void 0}connectItem(n,m,o){this.setItemParent(n,o);const d=(0,t.getPrivateApiFor)(n);d.parent=o?.actual,d.listener=u=>this.onTestItemEvent(m,u),this.updateExpandability(m)}connectItemAndChildren(n,m,o){this.connectItem(n,m,o);for(const d of n.children)this.upsertItem(d,m)}updateExpandability(n){let m;this._resolveHandler?n.resolveBarrier?m=n.resolveBarrier.isOpen()?3:2:m=n.actual.canResolveChildren?1:0:m=0,m!==n.expand&&(n.expand=m,this.pushDiff([1,{extId:n.fullId.toString(),expand:m}]),m===1&&n.expandLevels!==void 0&&this.resolveChildren(n))}expandChildren(n,m){if(m<0)return;const o=[];for(const d of n.actual.children){const u=this.expand(k.TestId.joinToString(n.fullId,d.id),m);(0,c.isThenable)(u)&&o.push(u)}if(o.length)return Promise.all(o).then(()=>{})}resolveChildren(n){if(n.resolveBarrier)return n.resolveBarrier;if(!this._resolveHandler){const u=new c.Barrier;return u.open(),u}n.expand=2,this.pushExpandStateUpdate(n);const m=n.resolveBarrier=new c.Barrier,o=u=>{console.error(`Unhandled error in resolveHandler of test controller "${this.controllerId}"`),n.actual!==this.root&&(n.actual.error=u.stack||u.message||String(u))};let d;try{d=this._resolveHandler(n.actual===this.root?void 0:n.actual)}catch(u){o(u)}return(0,c.isThenable)(d)?d.catch(o).then(()=>{m.open(),this.updateExpandability(n)}):(m.open(),this.updateExpandability(n)),n.resolveBarrier}pushExpandStateUpdate(n){this.pushDiff([1,{extId:n.fullId.toString(),expand:n.expand}])}removeItem(n){const m=this.tree.get(n);if(!m)throw new Error("attempting to remove non-existent child");this.pushDiff([2,n]);const o=[m];for(;o.length;){const d=o.pop();if(!!d){(0,t.getPrivateApiFor)(d.actual).listener=void 0;for(const u of d.actual.tags)this.decrementTagRefs(u.id);this.tree.delete(d.fullId.toString());for(const u of d.actual.children)o.push(this.tree.get(k.TestId.joinToString(d.fullId,u.id)))}}}flushDiff(){const n=this.collectDiff();n.length&&this.diffOpEmitter.fire(n)}}e.SingleUseTestCollection=R}),define(Ee[171],_e([0,1,4,136]),function(re,e,c,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IWorkbenchEnvironmentService=void 0,e.IWorkbenchEnvironmentService=(0,c.refineServiceDecorator)(F.IEnvironmentService)}),define(Ee[172],_e([0,1,25,3,17]),function(re,e,c,F,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionDescriptionRegistry=e.DeltaExtensionsResult=void 0;class P{constructor(R){this.removedDueToLooping=R}}e.DeltaExtensionsResult=P;class t{constructor(R){this._onDidChange=new F.Emitter,this.onDidChange=this._onDidChange.event,this._extensionDescriptions=R,this._initialize()}_initialize(){this._extensionDescriptions.sort(C),this._extensionsMap=new Map,this._extensionsArr=[],this._activationMap=new Map;for(const R of this._extensionDescriptions){if(this._extensionsMap.has(c.ExtensionIdentifier.toKey(R.identifier))){console.error("Extension `"+R.identifier.value+"` is already registered");continue}if(this._extensionsMap.set(c.ExtensionIdentifier.toKey(R.identifier),R),this._extensionsArr.push(R),Array.isArray(R.activationEvents))for(let _ of R.activationEvents)_==="onUri"&&(_=`onUri:${c.ExtensionIdentifier.toKey(R.identifier)}`),this._activationMap.has(_)||this._activationMap.set(_,[]),this._activationMap.get(_).push(R)}}keepOnly(R){const _=new Set;R.forEach(n=>_.add(c.ExtensionIdentifier.toKey(n))),this._extensionDescriptions=this._extensionDescriptions.filter(n=>_.has(c.ExtensionIdentifier.toKey(n.identifier))),this._initialize(),this._onDidChange.fire(void 0)}deltaExtensions(R,_){R.length>0&&(this._extensionDescriptions=this._extensionDescriptions.concat(R));const n=t._findLoopingExtensions(this._extensionDescriptions);if(_=_.concat(n.map(m=>m.identifier)),_.length>0){const m=new Set;_.forEach(o=>m.add(c.ExtensionIdentifier.toKey(o))),this._extensionDescriptions=this._extensionDescriptions.filter(o=>!m.has(c.ExtensionIdentifier.toKey(o.identifier)))}return this._initialize(),this._onDidChange.fire(void 0),new P(n)}static _findLoopingExtensions(R){const _=new class{constructor(){this._arcs=new Map,this._nodesSet=new Set,this._nodesArr=[]}addNode(u){this._nodesSet.has(u)||(this._nodesSet.add(u),this._nodesArr.push(u))}addArc(u,S){this.addNode(u),this.addNode(S),this._arcs.has(u)?this._arcs.get(u).push(S):this._arcs.set(u,[S])}getArcs(u){return this._arcs.has(u)?this._arcs.get(u):[]}hasOnlyGoodArcs(u,S){const b=_.getArcs(u);for(let h=0;h<b.length;h++)if(!S.has(b[h]))return!1;return!0}getNodes(){return this._nodesArr}};let n=new Map;for(let u of R){const S=c.ExtensionIdentifier.toKey(u.identifier);if(n.set(S,u),u.extensionDependencies)for(let b of u.extensionDependencies){const h=c.ExtensionIdentifier.toKey(b);_.addArc(S,h)}}let m=new Set;_.getNodes().filter(u=>_.getArcs(u).length===0).forEach(u=>m.add(u));let o=_.getNodes().filter(u=>!m.has(u)),d;do{d=!1;for(let u=0;u<o.length;u++){const S=o[u];_.hasOnlyGoodArcs(S,m)&&(o.splice(u,1),u--,m.add(S),d=!0)}}while(d);return o.map(u=>n.get(u))}containsActivationEvent(R){return this._activationMap.has(R)}containsExtension(R){return this._extensionsMap.has(c.ExtensionIdentifier.toKey(R))}getExtensionDescriptionsForActivationEvent(R){const _=this._activationMap.get(R);return _?_.slice(0):[]}getAllExtensionDescriptions(){return this._extensionsArr.slice(0)}getExtensionDescription(R){const _=this._extensionsMap.get(c.ExtensionIdentifier.toKey(R));return _||void 0}}e.ExtensionDescriptionRegistry=t;var T;(function(k){k[k.Builtin=0]="Builtin",k[k.User=1]="User",k[k.Dev=2]="Dev"})(T||(T={}));function C(k,R){const _=k.isBuiltin?0:k.isUnderDevelopment?2:1,n=R.isBuiltin?0:R.isUnderDevelopment?2:1;if(_!==n)return _-n;const m=w.posix.basename(k.extensionLocation.path),o=w.posix.basename(R.extensionLocation.path);return m<o?-1:m>o?1:0}}),define(Ee[173],_e([0,1,22]),function(re,e,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isMessageOfType=e.createMessageOfType=e.MessageType=e.ExtensionHostExitCode=void 0;var F;(function(T){T[T.VersionMismatch=55]="VersionMismatch",T[T.UnexpectedError=81]="UnexpectedError"})(F=e.ExtensionHostExitCode||(e.ExtensionHostExitCode={}));var w;(function(T){T[T.Initialized=0]="Initialized",T[T.Ready=1]="Ready",T[T.Terminate=2]="Terminate"})(w=e.MessageType||(e.MessageType={}));function P(T){const C=c.VSBuffer.alloc(1);switch(T){case 0:C.writeUInt8(1,0);break;case 1:C.writeUInt8(2,0);break;case 2:C.writeUInt8(3,0);break}return C}e.createMessageOfType=P;function t(T,C){if(T.byteLength!==1)return!1;switch(T.readUInt8(0)){case 1:return C===0;case 2:return C===1;case 3:return C===2;default:return!1}}e.isMessageOfType=t}),define(Ee[27],_e([0,1,3,2,4,25,143]),function(re,e,c,F,w,P,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NullExtensionService=e.toExtensionDescription=e.toExtension=e.ActivationKind=e.ExtensionHostLogFileName=e.ExtensionPointContribution=e.ActivationTimes=e.checkProposedApiEnabled=e.isProposedApiEnabled=e.extensionHostKindToString=e.ExtensionHostKind=e.MissingExtensionDependency=e.extensionRunningLocationToString=e.ExtensionRunningLocation=e.IExtensionService=e.webWorkerExtHostConfig=e.nullExtensionDescription=void 0,e.nullExtensionDescription=Object.freeze({identifier:new P.ExtensionIdentifier("nullExtensionDescription"),name:"Null Extension Description",version:"0.0.0",publisher:"vscode",engines:{vscode:""},extensionLocation:F.URI.parse("void:location"),isBuiltin:!1}),e.webWorkerExtHostConfig="extensions.webWorker",e.IExtensionService=(0,w.createDecorator)("extensionService");var T;(function(g){g[g.None=0]="None",g[g.LocalProcess=1]="LocalProcess",g[g.LocalWebWorker=2]="LocalWebWorker",g[g.Remote=3]="Remote"})(T=e.ExtensionRunningLocation||(e.ExtensionRunningLocation={}));function C(g){switch(g){case 0:return"None";case 1:return"LocalProcess";case 2:return"LocalWebWorker";case 3:return"Remote"}}e.extensionRunningLocationToString=C;class k{constructor(A){this.dependency=A}}e.MissingExtensionDependency=k;var R;(function(g){g[g.LocalProcess=0]="LocalProcess",g[g.LocalWebWorker=1]="LocalWebWorker",g[g.Remote=2]="Remote"})(R=e.ExtensionHostKind||(e.ExtensionHostKind={}));function _(g){switch(g){case 0:return"LocalProcess";case 1:return"LocalWebWorker";case 2:return"Remote"}}e.extensionHostKindToString=_;function n(g,A){return g.enabledApiProposals?g.enabledApiProposals.includes(A):!1}e.isProposedApiEnabled=n;function m(g,A){if(!n(g,A))throw new Error(`Extension '${g.identifier.value}' CANNOT use API proposal: ${A}.
Its package.json#enabledApiProposals-property declares: ${g.enabledApiProposals?.join(", ")??"[]"} but NOT ${A}.
 The missing proposal MUST be added and you must start in extension development mode or use the following command line switch: --enable-proposed-api ${g.identifier.value}`)}e.checkProposedApiEnabled=m;class o{constructor(A,l,M,r){this.codeLoadingTime=A,this.activateCallTime=l,this.activateResolvedTime=M,this.activationReason=r}}e.ActivationTimes=o;class d{constructor(A,l){this.description=A,this.value=l}}e.ExtensionPointContribution=d,e.ExtensionHostLogFileName="exthost";var u;(function(g){g[g.Normal=0]="Normal",g[g.Immediate=1]="Immediate"})(u=e.ActivationKind||(e.ActivationKind={}));function S(g){return{type:g.isBuiltin?0:1,isBuiltin:g.isBuiltin||g.isUserBuiltin,identifier:{id:(0,t.getGalleryExtensionId)(g.publisher,g.name),uuid:g.uuid},manifest:g,location:g.extensionLocation}}e.toExtension=S;function b(g,A){return{identifier:new P.ExtensionIdentifier(g.identifier.id),isBuiltin:g.type===0,isUserBuiltin:g.type===1&&g.isBuiltin,isUnderDevelopment:!!A,extensionLocation:g.location,...g.manifest,uuid:g.identifier.uuid}}e.toExtensionDescription=b;class h{constructor(){this.onDidRegisterExtensions=c.Event.None,this.onDidChangeExtensionsStatus=c.Event.None,this.onDidChangeExtensions=c.Event.None,this.onWillActivateByEvent=c.Event.None,this.onDidChangeResponsiveChange=c.Event.None}activateByEvent(A){return Promise.resolve(void 0)}whenInstalledExtensionsRegistered(){return Promise.resolve(!0)}getExtensions(){return Promise.resolve([])}getExtension(){return Promise.resolve(void 0)}readExtensionPointContributions(A){return Promise.resolve(Object.create(null))}getExtensionsStatus(){return Object.create(null)}getInspectPort(A){return Promise.resolve(0)}stopExtensionHosts(){}async restartExtensionHost(){}async startExtensionHosts(){}async setRemoteEnvironment(A){}canAddExtension(){return!1}canRemoveExtension(){return!1}_activateById(A,l){return Promise.resolve()}_onWillActivateExtension(A){}_onDidActivateExtension(A,l,M,r,i){}_onDidActivateExtensionError(A,l){}_onExtensionRuntimeError(A,l){}_onExtensionHostExit(A){}}e.NullExtensionService=h}),define(Ee[174],_e([0,1,15,25,27,12]),function(re,e,c,F,w,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsActivator=e.FailedExtension=e.HostExtension=e.EmptyExtension=e.ActivatedExtension=e.ExtensionActivationTimesBuilder=e.ExtensionActivationTimes=void 0;const t=Promise.resolve(void 0);class T{constructor(d,u,S,b){this.startup=d,this.codeLoadingTime=u,this.activateCallTime=S,this.activateResolvedTime=b}}e.ExtensionActivationTimes=T,T.NONE=new T(!1,-1,-1,-1);class C{constructor(d){this._startup=d,this._codeLoadingStart=-1,this._codeLoadingStop=-1,this._activateCallStart=-1,this._activateCallStop=-1,this._activateResolveStart=-1,this._activateResolveStop=-1}_delta(d,u){return d===-1||u===-1?-1:u-d}build(){return new T(this._startup,this._delta(this._codeLoadingStart,this._codeLoadingStop),this._delta(this._activateCallStart,this._activateCallStop),this._delta(this._activateResolveStart,this._activateResolveStop))}codeLoadingStart(){this._codeLoadingStart=Date.now()}codeLoadingStop(){this._codeLoadingStop=Date.now()}activateCallStart(){this._activateCallStart=Date.now()}activateCallStop(){this._activateCallStop=Date.now()}activateResolveStart(){this._activateResolveStart=Date.now()}activateResolveStop(){this._activateResolveStop=Date.now()}}e.ExtensionActivationTimesBuilder=C;class k{constructor(d,u,S,b,h,g){this.activationFailed=d,this.activationFailedError=u,this.activationTimes=S,this.module=b,this.exports=h,this.subscriptions=g}}e.ActivatedExtension=k;class R extends k{constructor(d){super(!1,null,d,{activate:void 0,deactivate:void 0},void 0,[])}}e.EmptyExtension=R;class _ extends k{constructor(){super(!1,null,T.NONE,{activate:void 0,deactivate:void 0},void 0,[])}}e.HostExtension=_;class n extends k{constructor(d){super(!0,d,T.NONE,{activate:void 0,deactivate:void 0},void 0,[])}}e.FailedExtension=n;let m=class{constructor(d,u,S,b,h){this._logService=h,this._isDisposed=!1,this._registry=d,this._resolvedExtensionsSet=new Set,u.forEach(g=>this._resolvedExtensionsSet.add(F.ExtensionIdentifier.toKey(g))),this._hostExtensionsMap=new Map,S.forEach(g=>this._hostExtensionsMap.set(F.ExtensionIdentifier.toKey(g),g)),this._host=b,this._activatingExtensions=new Map,this._activatedExtensions=new Map,this._alreadyActivatedEvents=Object.create(null)}dispose(){this._isDisposed=!0}isActivated(d){const u=F.ExtensionIdentifier.toKey(d);return this._activatedExtensions.has(u)}getActivatedExtension(d){const u=F.ExtensionIdentifier.toKey(d),S=this._activatedExtensions.get(u);if(!S)throw new Error("Extension `"+d.value+"` is not known or not activated");return S}activateByEvent(d,u){if(this._alreadyActivatedEvents[d])return t;const S=this._registry.getExtensionDescriptionsForActivationEvent(d);return this._activateExtensions(S.map(b=>({id:b.identifier,reason:{startup:u,extensionId:b.identifier,activationEvent:d}}))).then(()=>{this._alreadyActivatedEvents[d]=!0})}activateById(d,u){const S=this._registry.getExtensionDescription(d);if(!S)throw new Error("Extension `"+d+"` is not known");return this._activateExtensions([{id:S.identifier,reason:u}])}_handleActivateRequest(d,u,S){if(this._hostExtensionsMap.has(F.ExtensionIdentifier.toKey(d.id))){u[F.ExtensionIdentifier.toKey(d.id)]=d;return}const b=this._registry.getExtensionDescription(d.id);if(!b){const A=new Error(`Cannot activate unknown extension '${d.id.value}'`);this._host.onExtensionActivationError(d.id,A,new w.MissingExtensionDependency(d.id.value)),this._activatedExtensions.set(F.ExtensionIdentifier.toKey(d.id),new n(A));return}const h=typeof b.extensionDependencies=="undefined"?[]:b.extensionDependencies;let g=!0;for(let A=0,l=h.length;A<l;A++){const M=h[A];if(this._resolvedExtensionsSet.has(F.ExtensionIdentifier.toKey(M)))continue;const r=this._activatedExtensions.get(F.ExtensionIdentifier.toKey(M));if(r&&!r.activationFailed)continue;if(r&&r.activationFailed){const s=b.displayName||b.identifier.value,v=this._registry.getExtensionDescription(M),a=v&&v.displayName||M,E=new Error(`Cannot activate the '${s}' extension because its dependency '${a}' failed to activate`);E.detail=r.activationFailedError,this._host.onExtensionActivationError(b.identifier,E,null),this._activatedExtensions.set(F.ExtensionIdentifier.toKey(b.identifier),new n(E));return}if(this._hostExtensionsMap.has(F.ExtensionIdentifier.toKey(M))){g=!1,u[F.ExtensionIdentifier.toKey(M)]={id:this._hostExtensionsMap.get(F.ExtensionIdentifier.toKey(M)),reason:d.reason};continue}const i=this._registry.getExtensionDescription(M);if(i){if(!i.main&&!i.browser)continue;g=!1,u[F.ExtensionIdentifier.toKey(M)]={id:i.identifier,reason:d.reason};continue}const p=b.displayName||b.identifier.value,f=new Error(`Cannot activate the '${p}' extension because it depends on unknown extension '${M}'`);this._host.onExtensionActivationError(b.identifier,f,new w.MissingExtensionDependency(M)),this._activatedExtensions.set(F.ExtensionIdentifier.toKey(b.identifier),new n(f));return}g?u[F.ExtensionIdentifier.toKey(b.identifier)]=d:S.push(d)}_activateExtensions(d){if(d.length===0||(d=d.filter(h=>!this._activatedExtensions.has(F.ExtensionIdentifier.toKey(h.id))),d.length===0))return Promise.resolve(void 0);const u=Object.create(null),S=[];for(let h=0,g=d.length;h<g;h++)this._handleActivateRequest(d[h],u,S);for(let h=0,g=S.length;h<g;h++){const A=F.ExtensionIdentifier.toKey(S[h].id);u[A]&&delete u[A]}const b=Object.keys(u).map(h=>u[h]);return S.length===0?Promise.all(b.map(h=>this._activateExtension(h.id,h.reason))).then(h=>{}):this._activateExtensions(b).then(h=>this._activateExtensions(S))}_activateExtension(d,u){const S=F.ExtensionIdentifier.toKey(d);if(this._activatedExtensions.has(S))return Promise.resolve(void 0);const b=this._activatingExtensions.get(S);if(b)return b;const h=this._host.actualActivateExtension(d,u).then(void 0,g=>{const A=new Error;return g&&g.name&&(A.name=g.name),g&&g.message?A.message=`Activating extension '${d.value}' failed: ${g.message}.`:A.message=`Activating extension '${d.value}' failed: ${g}.`,g&&g.stack&&(A.stack=g.stack),this._isDisposed&&c.isPromiseCanceledError(g)?new n(g):(this._host.onExtensionActivationError(d,A,null),this._logService.error(`Activating extension ${d.value} failed due to an error:`),this._logService.error(g),new n(g))}).then(g=>{this._activatedExtensions.set(S,g),this._activatingExtensions.delete(S)});return this._activatingExtensions.set(S,h),h}};m=Ue([$e(4,P.ILogService)],m),e.ExtensionsActivator=m}),define(Ee[175],_e([0,1,12,28,27]),function(re,e,c,F,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLogService=void 0;let P=class extends c.LogService{constructor(T,C){super(T.createLogger(C.logFile,{name:w.ExtensionHostLogFileName}))}};P=Ue([$e(0,c.ILoggerService),$e(1,F.IExtHostInitDataService)],P),e.ExtHostLogService=P}),define(Ee[176],_e([0,1,15]),function(re,e,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LazyPromise=void 0;class F{constructor(){this._actual=null,this._actualOk=null,this._actualErr=null,this._hasValue=!1,this._value=null,this._hasErr=!1,this._err=null}get[Symbol.toStringTag](){return this.toString()}_ensureActual(){return this._actual||(this._actual=new Promise((P,t)=>{this._actualOk=P,this._actualErr=t,this._hasValue&&this._actualOk(this._value),this._hasErr&&this._actualErr(this._err)})),this._actual}resolveOk(P){this._hasValue||this._hasErr||(this._hasValue=!0,this._value=P,this._actual&&this._actualOk(P))}resolveErr(P){this._hasValue||this._hasErr||(this._hasErr=!0,this._err=P,this._actual?this._actualErr(P):(0,c.onUnexpectedError)(P))}then(P,t){return this._ensureActual().then(P,t)}catch(P){return this._ensureActual().then(void 0,P)}finally(P){return this._ensureActual().finally(P)}}e.LazyPromise=F}),define(Ee[37],_e([0,1]),function(re,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SerializableObjectWithBuffers=e.getStringIdentifierForProxy=e.createExtHostContextProxyIdentifier=e.createMainContextProxyIdentifier=e.ProxyIdentifier=void 0;class c{constructor(k,R){this._proxyIdentifierBrand=void 0,this.isMain=k,this.sid=R,this.nid=++c.count}}e.ProxyIdentifier=c,c.count=0;const F=[];function w(C){const k=new c(!0,C);return F[k.nid]=k,k}e.createMainContextProxyIdentifier=w;function P(C){const k=new c(!1,C);return F[k.nid]=k,k}e.createExtHostContextProxyIdentifier=P;function t(C){return F[C].sid}e.getStringIdentifierForProxy=t;class T{constructor(k){this.value=k}}e.SerializableObjectWithBuffers=T}),define(Ee[5],_e([0,1,54,2,37]),function(re,e,c,F,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostContext=e.MainContext=e.ExtHostTestingResource=e.reviveWorkspaceEditDto=e.WorkspaceEditType=e.ISuggestResultDtoField=e.ISuggestDataDtoField=e.IdObject=e.ObjectIdentifier=e.CandidatePortSource=e.NotebookEditorRevealType=e.CellOutputKind=e.WebviewMessageArrayBufferViewType=e.WebviewEditorCapabilities=e.TextEditorRevealType=e.UIKind=void 0;var P;(function(h){h[h.Desktop=1]="Desktop",h[h.Web=2]="Web"})(P=e.UIKind||(e.UIKind={}));var t;(function(h){h[h.Default=0]="Default",h[h.InCenter=1]="InCenter",h[h.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",h[h.AtTop=3]="AtTop"})(t=e.TextEditorRevealType||(e.TextEditorRevealType={}));var T;(function(h){h[h.Editable=0]="Editable",h[h.SupportsHotExit=1]="SupportsHotExit"})(T=e.WebviewEditorCapabilities||(e.WebviewEditorCapabilities={}));var C;(function(h){h[h.Int8Array=1]="Int8Array",h[h.Uint8Array=2]="Uint8Array",h[h.Uint8ClampedArray=3]="Uint8ClampedArray",h[h.Int16Array=4]="Int16Array",h[h.Uint16Array=5]="Uint16Array",h[h.Int32Array=6]="Int32Array",h[h.Uint32Array=7]="Uint32Array",h[h.Float32Array=8]="Float32Array",h[h.Float64Array=9]="Float64Array",h[h.BigInt64Array=10]="BigInt64Array",h[h.BigUint64Array=11]="BigUint64Array"})(C=e.WebviewMessageArrayBufferViewType||(e.WebviewMessageArrayBufferViewType={}));var k;(function(h){h[h.Text=1]="Text",h[h.Error=2]="Error",h[h.Rich=3]="Rich"})(k=e.CellOutputKind||(e.CellOutputKind={}));var R;(function(h){h[h.Default=0]="Default",h[h.InCenter=1]="InCenter",h[h.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",h[h.AtTop=3]="AtTop"})(R=e.NotebookEditorRevealType||(e.NotebookEditorRevealType={}));var _;(function(h){h[h.None=0]="None",h[h.Process=1]="Process",h[h.Output=2]="Output"})(_=e.CandidatePortSource||(e.CandidatePortSource={}));var n;(function(h){h.name="$ident";function g(l,M){return Object.defineProperty(l,h.name,{value:M,enumerable:!0}),l}h.mixin=g;function A(l){return l[h.name]}h.of=A})(n=e.ObjectIdentifier||(e.ObjectIdentifier={}));class m{static mixin(g){return g._id=m._n++,g}}e.IdObject=m,m._n=0;var o;(function(h){h.label="a",h.kind="b",h.detail="c",h.documentation="d",h.sortText="e",h.filterText="f",h.preselect="g",h.insertText="h",h.insertTextRules="i",h.range="j",h.commitCharacters="k",h.additionalTextEdits="l",h.command="m",h.kindModifier="n"})(o=e.ISuggestDataDtoField||(e.ISuggestDataDtoField={}));var d;(function(h){h.defaultRanges="a",h.completions="b",h.isIncomplete="c",h.duration="d"})(d=e.ISuggestResultDtoField||(e.ISuggestResultDtoField={}));var u;(function(h){h[h.File=1]="File",h[h.Text=2]="Text",h[h.Cell=3]="Cell"})(u=e.WorkspaceEditType||(e.WorkspaceEditType={}));function S(h){if(h&&h.edits)for(const g of h.edits)typeof g.resource=="object"?g.resource=F.URI.revive(g.resource):(g.newUri=F.URI.revive(g.newUri),g.oldUri=F.URI.revive(g.oldUri)),g.metadata&&g.metadata.iconPath&&(g.metadata=(0,c.revive)(g.metadata));return h}e.reviveWorkspaceEditDto=S;var b;(function(h){h[h.Workspace=0]="Workspace",h[h.TextDocument=1]="TextDocument"})(b=e.ExtHostTestingResource||(e.ExtHostTestingResource={})),e.MainContext={MainThreadAuthentication:(0,w.createMainContextProxyIdentifier)("MainThreadAuthentication"),MainThreadBulkEdits:(0,w.createMainContextProxyIdentifier)("MainThreadBulkEdits"),MainThreadClipboard:(0,w.createMainContextProxyIdentifier)("MainThreadClipboard"),MainThreadCommands:(0,w.createMainContextProxyIdentifier)("MainThreadCommands"),MainThreadComments:(0,w.createMainContextProxyIdentifier)("MainThreadComments"),MainThreadConfiguration:(0,w.createMainContextProxyIdentifier)("MainThreadConfiguration"),MainThreadConsole:(0,w.createMainContextProxyIdentifier)("MainThreadConsole"),MainThreadDebugService:(0,w.createMainContextProxyIdentifier)("MainThreadDebugService"),MainThreadDecorations:(0,w.createMainContextProxyIdentifier)("MainThreadDecorations"),MainThreadDiagnostics:(0,w.createMainContextProxyIdentifier)("MainThreadDiagnostics"),MainThreadDialogs:(0,w.createMainContextProxyIdentifier)("MainThreadDiaglogs"),MainThreadDocuments:(0,w.createMainContextProxyIdentifier)("MainThreadDocuments"),MainThreadDocumentContentProviders:(0,w.createMainContextProxyIdentifier)("MainThreadDocumentContentProviders"),MainThreadTextEditors:(0,w.createMainContextProxyIdentifier)("MainThreadTextEditors"),MainThreadEditorInsets:(0,w.createMainContextProxyIdentifier)("MainThreadEditorInsets"),MainThreadEditorTabs:(0,w.createMainContextProxyIdentifier)("MainThreadEditorTabs"),MainThreadErrors:(0,w.createMainContextProxyIdentifier)("MainThreadErrors"),MainThreadTreeViews:(0,w.createMainContextProxyIdentifier)("MainThreadTreeViews"),MainThreadDownloadService:(0,w.createMainContextProxyIdentifier)("MainThreadDownloadService"),MainThreadKeytar:(0,w.createMainContextProxyIdentifier)("MainThreadKeytar"),MainThreadLanguageFeatures:(0,w.createMainContextProxyIdentifier)("MainThreadLanguageFeatures"),MainThreadLanguages:(0,w.createMainContextProxyIdentifier)("MainThreadLanguages"),MainThreadLogger:(0,w.createMainContextProxyIdentifier)("MainThreadLogger"),MainThreadMessageService:(0,w.createMainContextProxyIdentifier)("MainThreadMessageService"),MainThreadOutputService:(0,w.createMainContextProxyIdentifier)("MainThreadOutputService"),MainThreadProgress:(0,w.createMainContextProxyIdentifier)("MainThreadProgress"),MainThreadQuickOpen:(0,w.createMainContextProxyIdentifier)("MainThreadQuickOpen"),MainThreadStatusBar:(0,w.createMainContextProxyIdentifier)("MainThreadStatusBar"),MainThreadSecretState:(0,w.createMainContextProxyIdentifier)("MainThreadSecretState"),MainThreadStorage:(0,w.createMainContextProxyIdentifier)("MainThreadStorage"),MainThreadTelemetry:(0,w.createMainContextProxyIdentifier)("MainThreadTelemetry"),MainThreadTerminalService:(0,w.createMainContextProxyIdentifier)("MainThreadTerminalService"),MainThreadWebviews:(0,w.createMainContextProxyIdentifier)("MainThreadWebviews"),MainThreadWebviewPanels:(0,w.createMainContextProxyIdentifier)("MainThreadWebviewPanels"),MainThreadWebviewViews:(0,w.createMainContextProxyIdentifier)("MainThreadWebviewViews"),MainThreadCustomEditors:(0,w.createMainContextProxyIdentifier)("MainThreadCustomEditors"),MainThreadUrls:(0,w.createMainContextProxyIdentifier)("MainThreadUrls"),MainThreadUriOpeners:(0,w.createMainContextProxyIdentifier)("MainThreadUriOpeners"),MainThreadWorkspace:(0,w.createMainContextProxyIdentifier)("MainThreadWorkspace"),MainThreadFileSystem:(0,w.createMainContextProxyIdentifier)("MainThreadFileSystem"),MainThreadExtensionService:(0,w.createMainContextProxyIdentifier)("MainThreadExtensionService"),MainThreadSCM:(0,w.createMainContextProxyIdentifier)("MainThreadSCM"),MainThreadSearch:(0,w.createMainContextProxyIdentifier)("MainThreadSearch"),MainThreadTask:(0,w.createMainContextProxyIdentifier)("MainThreadTask"),MainThreadWindow:(0,w.createMainContextProxyIdentifier)("MainThreadWindow"),MainThreadLabelService:(0,w.createMainContextProxyIdentifier)("MainThreadLabelService"),MainThreadNotebook:(0,w.createMainContextProxyIdentifier)("MainThreadNotebook"),MainThreadNotebookDocuments:(0,w.createMainContextProxyIdentifier)("MainThreadNotebookDocumentsShape"),MainThreadNotebookEditors:(0,w.createMainContextProxyIdentifier)("MainThreadNotebookEditorsShape"),MainThreadNotebookKernels:(0,w.createMainContextProxyIdentifier)("MainThreadNotebookKernels"),MainThreadNotebookRenderers:(0,w.createMainContextProxyIdentifier)("MainThreadNotebookRenderers"),MainThreadInteractive:(0,w.createMainContextProxyIdentifier)("MainThreadInteractive"),MainThreadTheming:(0,w.createMainContextProxyIdentifier)("MainThreadTheming"),MainThreadTunnelService:(0,w.createMainContextProxyIdentifier)("MainThreadTunnelService"),MainThreadTimeline:(0,w.createMainContextProxyIdentifier)("MainThreadTimeline"),MainThreadTesting:(0,w.createMainContextProxyIdentifier)("MainThreadTesting")},e.ExtHostContext={ExtHostCommands:(0,w.createExtHostContextProxyIdentifier)("ExtHostCommands"),ExtHostConfiguration:(0,w.createExtHostContextProxyIdentifier)("ExtHostConfiguration"),ExtHostDiagnostics:(0,w.createExtHostContextProxyIdentifier)("ExtHostDiagnostics"),ExtHostDebugService:(0,w.createExtHostContextProxyIdentifier)("ExtHostDebugService"),ExtHostDecorations:(0,w.createExtHostContextProxyIdentifier)("ExtHostDecorations"),ExtHostDocumentsAndEditors:(0,w.createExtHostContextProxyIdentifier)("ExtHostDocumentsAndEditors"),ExtHostDocuments:(0,w.createExtHostContextProxyIdentifier)("ExtHostDocuments"),ExtHostDocumentContentProviders:(0,w.createExtHostContextProxyIdentifier)("ExtHostDocumentContentProviders"),ExtHostDocumentSaveParticipant:(0,w.createExtHostContextProxyIdentifier)("ExtHostDocumentSaveParticipant"),ExtHostEditors:(0,w.createExtHostContextProxyIdentifier)("ExtHostEditors"),ExtHostTreeViews:(0,w.createExtHostContextProxyIdentifier)("ExtHostTreeViews"),ExtHostFileSystem:(0,w.createExtHostContextProxyIdentifier)("ExtHostFileSystem"),ExtHostFileSystemInfo:(0,w.createExtHostContextProxyIdentifier)("ExtHostFileSystemInfo"),ExtHostFileSystemEventService:(0,w.createExtHostContextProxyIdentifier)("ExtHostFileSystemEventService"),ExtHostLanguages:(0,w.createExtHostContextProxyIdentifier)("ExtHostLanguages"),ExtHostLanguageFeatures:(0,w.createExtHostContextProxyIdentifier)("ExtHostLanguageFeatures"),ExtHostQuickOpen:(0,w.createExtHostContextProxyIdentifier)("ExtHostQuickOpen"),ExtHostExtensionService:(0,w.createExtHostContextProxyIdentifier)("ExtHostExtensionService"),ExtHostLogLevelServiceShape:(0,w.createExtHostContextProxyIdentifier)("ExtHostLogLevelServiceShape"),ExtHostTerminalService:(0,w.createExtHostContextProxyIdentifier)("ExtHostTerminalService"),ExtHostSCM:(0,w.createExtHostContextProxyIdentifier)("ExtHostSCM"),ExtHostSearch:(0,w.createExtHostContextProxyIdentifier)("ExtHostSearch"),ExtHostTask:(0,w.createExtHostContextProxyIdentifier)("ExtHostTask"),ExtHostWorkspace:(0,w.createExtHostContextProxyIdentifier)("ExtHostWorkspace"),ExtHostWindow:(0,w.createExtHostContextProxyIdentifier)("ExtHostWindow"),ExtHostWebviews:(0,w.createExtHostContextProxyIdentifier)("ExtHostWebviews"),ExtHostWebviewPanels:(0,w.createExtHostContextProxyIdentifier)("ExtHostWebviewPanels"),ExtHostCustomEditors:(0,w.createExtHostContextProxyIdentifier)("ExtHostCustomEditors"),ExtHostWebviewViews:(0,w.createExtHostContextProxyIdentifier)("ExtHostWebviewViews"),ExtHostEditorInsets:(0,w.createExtHostContextProxyIdentifier)("ExtHostEditorInsets"),ExtHostEditorTabs:(0,w.createExtHostContextProxyIdentifier)("ExtHostEditorTabs"),ExtHostProgress:(0,w.createMainContextProxyIdentifier)("ExtHostProgress"),ExtHostComments:(0,w.createMainContextProxyIdentifier)("ExtHostComments"),ExtHostSecretState:(0,w.createMainContextProxyIdentifier)("ExtHostSecretState"),ExtHostStorage:(0,w.createMainContextProxyIdentifier)("ExtHostStorage"),ExtHostUrls:(0,w.createExtHostContextProxyIdentifier)("ExtHostUrls"),ExtHostUriOpeners:(0,w.createExtHostContextProxyIdentifier)("ExtHostUriOpeners"),ExtHostOutputService:(0,w.createMainContextProxyIdentifier)("ExtHostOutputService"),ExtHosLabelService:(0,w.createMainContextProxyIdentifier)("ExtHostLabelService"),ExtHostNotebook:(0,w.createMainContextProxyIdentifier)("ExtHostNotebook"),ExtHostNotebookDocuments:(0,w.createMainContextProxyIdentifier)("ExtHostNotebookDocuments"),ExtHostNotebookEditors:(0,w.createMainContextProxyIdentifier)("ExtHostNotebookEditors"),ExtHostNotebookKernels:(0,w.createMainContextProxyIdentifier)("ExtHostNotebookKernels"),ExtHostNotebookRenderers:(0,w.createMainContextProxyIdentifier)("ExtHostNotebookRenderers"),ExtHostInteractive:(0,w.createMainContextProxyIdentifier)("ExtHostInteractive"),ExtHostTheming:(0,w.createMainContextProxyIdentifier)("ExtHostTheming"),ExtHostTunnelService:(0,w.createMainContextProxyIdentifier)("ExtHostTunnelService"),ExtHostAuthentication:(0,w.createMainContextProxyIdentifier)("ExtHostAuthentication"),ExtHostTimeline:(0,w.createMainContextProxyIdentifier)("ExtHostTimeline"),ExtHostTesting:(0,w.createMainContextProxyIdentifier)("ExtHostTesting"),ExtHostTelemetry:(0,w.createMainContextProxyIdentifier)("ExtHostTelemetry")}}),define(Ee[68],_e([0,1,5,3,4]),function(re,e,c,F,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostSecretState=e.ExtHostSecretState=void 0;class P{constructor(T){this._onDidChangePassword=new F.Emitter,this.onDidChangePassword=this._onDidChangePassword.event,this._proxy=T.getProxy(c.MainContext.MainThreadSecretState)}async $onDidChangePassword(T){this._onDidChangePassword.fire(T)}get(T,C){return this._proxy.$getPassword(T,C)}store(T,C,k){return this._proxy.$setPassword(T,C,k)}delete(T,C){return this._proxy.$deletePassword(T,C)}}e.ExtHostSecretState=P,e.IExtHostSecretState=(0,w.createDecorator)("IExtHostSecretState")}),define(Ee[69],_e([0,1,4,12,5,13]),function(re,e,c,F,w,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NullApiDeprecationService=e.ExtHostApiDeprecationService=e.IExtHostApiDeprecationService=void 0,e.IExtHostApiDeprecationService=(0,c.createDecorator)("IExtHostApiDeprecationService");let t=class{constructor(C,k){this._extHostLogService=k,this._reportedUsages=new Set,this._telemetryShape=C.getProxy(w.MainContext.MainThreadTelemetry)}report(C,k,R){const _=this.getUsageKey(C,k);this._reportedUsages.has(_)||(this._reportedUsages.add(_),k.isUnderDevelopment&&this._extHostLogService.warn(`[Deprecation Warning] '${C}' is deprecated. ${R}`),this._telemetryShape.$publicLog2("extHostDeprecatedApiUsage",{extensionId:k.identifier.value,apiId:C}))}getUsageKey(C,k){return`${C}-${k.identifier.value}`}};t=Ue([$e(0,P.IExtHostRpcService),$e(1,F.ILogService)],t),e.ExtHostApiDeprecationService=t,e.NullApiDeprecationService=Object.freeze(new class{report(T,C,k){}})}),define(Ee[177],_e([0,1,3,5,7,25]),function(re,e,c,F,w,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostAuthentication=void 0;class t{constructor(C){this._authenticationProviders=new Map,this._providers=[],this._onDidChangeSessions=new c.Emitter,this.onDidChangeSessions=this._onDidChangeSessions.event,this._inFlightRequests=new Map,this._proxy=C.getProxy(F.MainContext.MainThreadAuthentication)}$setProviders(C){return this._providers=C,Promise.resolve()}async getSession(C,k,R,_={}){const n=P.ExtensionIdentifier.toKey(C.identifier),m=this._inFlightRequests.get(n)||[],o=[...R].sort().join(" ");let d=m.find(u=>u.scopes===o);if(d)return d.result;{const u=this._getSession(C,n,k,R,_);d={scopes:o,result:u},m.push(d),this._inFlightRequests.set(n,m);try{await u}finally{const S=m.findIndex(b=>b.scopes===o);S>-1&&(m.splice(S),this._inFlightRequests.set(n,m))}return u}}async _getSession(C,k,R,_,n={}){await this._proxy.$ensureProvider(R);const m=C.displayName||C.name;return this._proxy.$getSession(R,_,k,m,n)}async removeSession(C,k){const R=this._authenticationProviders.get(C);return R?R.provider.removeSession(k):this._proxy.$removeSession(C,k)}registerAuthenticationProvider(C,k,R,_){if(this._authenticationProviders.get(C))throw new Error(`An authentication provider with id '${C}' is already registered.`);this._authenticationProviders.set(C,{label:k,provider:R,options:_??{supportsMultipleAccounts:!1}}),this._providers.find(m=>m.id===C)||this._providers.push({id:C,label:k});const n=R.onDidChangeSessions(m=>{this._proxy.$sendDidChangeSessions(C,{added:m.added??[],changed:m.changed??[],removed:m.removed??[]})});return this._proxy.$registerAuthenticationProvider(C,k,_?.supportsMultipleAccounts??!1),new w.Disposable(()=>{n.dispose(),this._authenticationProviders.delete(C);const m=this._providers.findIndex(o=>o.id===C);m>-1&&this._providers.splice(m),this._proxy.$unregisterAuthenticationProvider(C)})}$createSession(C,k){const R=this._authenticationProviders.get(C);if(R)return Promise.resolve(R.provider.createSession(k));throw new Error(`Unable to find authentication provider with handle: ${C}`)}$removeSession(C,k){const R=this._authenticationProviders.get(C);if(R)return Promise.resolve(R.provider.removeSession(k));throw new Error(`Unable to find authentication provider with handle: ${C}`)}$getSessions(C,k){const R=this._authenticationProviders.get(C);if(R)return Promise.resolve(R.provider.getSessions(k));throw new Error(`Unable to find authentication provider with handle: ${C}`)}$onDidChangeAuthenticationSessions(C,k){return this._onDidChangeSessions.fire({provider:{id:C,label:k}}),Promise.resolve()}}e.ExtHostAuthentication=t}),define(Ee[178],_e([0,1,5,13,8]),function(re,e,c,F,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostBulkEdits=void 0;let P=class{constructor(T,C){this._extHostDocumentsAndEditors=C,this._proxy=T.getProxy(c.MainContext.MainThreadBulkEdits)}applyWorkspaceEdit(T){const C=w.WorkspaceEdit.from(T,this._extHostDocumentsAndEditors);return this._proxy.$tryApplyWorkspaceEdit(C)}};P=Ue([$e(0,F.IExtHostRpcService)],P),e.ExtHostBulkEdits=P}),define(Ee[179],_e([0,1,5]),function(re,e,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostClipboard=void 0;class F{constructor(P){const t=P.getProxy(c.MainContext.MainThreadClipboard);this.value=Object.freeze({readText(){return t.$readText()},writeText(T){return t.$writeText(T)}})}}e.ExtHostClipboard=F}),define(Ee[38],_e([0,1,11,7,8,26,5,16,12,54,59,227,2,6,4,13,47,22,37,43]),function(re,e,c,F,w,P,t,T,C,k,R,_,n,m,o,d,u,S,b,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ApiCommand=e.ApiCommandResult=e.ApiCommandArgument=e.CommandsConverter=e.IExtHostCommands=e.ExtHostCommands=void 0;let g=class{constructor(p,f){this._commands=new Map,this._apiCommands=new Map,this._proxy=p.getProxy(t.MainContext.MainThreadCommands),this._logService=f,this.converter=new A(this,s=>{const v=this._apiCommands.get(s);return v?.result===M.Void?v:void 0},f),this._argumentProcessors=[{processArgument(s){return(0,k.revive)(s)}},{processArgument(s){return(0,P.cloneAndChange)(s,function(v){if(R.Range.isIRange(v))return w.Range.to(v);if(_.Position.isIPosition(v))return w.Position.to(v);if(R.Range.isIRange(v.range)&&n.URI.isUri(v.uri))return w.location.to(v);if(v instanceof S.VSBuffer)return v.buffer.buffer;if(!Array.isArray(v))return v})}}]}registerArgumentProcessor(p){this._argumentProcessors.push(p)}registerApiCommand(p){const f=this.registerCommand(!1,p.id,async(...s)=>{const v=p.args.map((E,I)=>{if(!E.validate(s[I]))throw new Error(`Invalid argument '${E.name}' when running '${p.id}', received: ${s[I]}`);return E.convert(s[I])}),a=await this.executeCommand(p.internalId,...v);return p.result.convert(a,s,this.converter)},void 0,{description:p.description,args:p.args,returns:p.result.description});return this._apiCommands.set(p.id,p),new F.Disposable(()=>{f.dispose(),this._apiCommands.delete(p.id)})}registerCommand(p,f,s,v,a,E){if(this._logService.trace("ExtHostCommands#registerCommand",f),!f.trim().length)throw new Error("invalid id");if(this._commands.has(f))throw new Error(`command '${f}' already exists`);return this._commands.set(f,{callback:s,thisArg:v,description:a,extension:E}),p&&this._proxy.$registerCommand(f),new F.Disposable(()=>{this._commands.delete(f)&&p&&this._proxy.$unregisterCommand(f)})}executeCommand(p,...f){return this._logService.trace("ExtHostCommands#executeCommand",p),this._doExecuteCommand(p,f,!0)}async _doExecuteCommand(p,f,s){if(this._commands.has(p))return this._executeContributedCommand(p,f,!1);{let v=!1;const a=(0,P.cloneAndChange)(f,function(E){if(E instanceof F.Position)return w.Position.from(E);if(E instanceof F.Range)return w.Range.from(E);if(E instanceof F.Location)return w.location.from(E);if(F.NotebookRange.isNotebookRange(E))return w.NotebookRange.from(E);if(E instanceof ArrayBuffer)return v=!0,S.VSBuffer.wrap(new Uint8Array(E));if(E instanceof Uint8Array)return v=!0,S.VSBuffer.wrap(E);if(!Array.isArray(E))return E});try{const E=await this._proxy.$executeCommand(p,v?new b.SerializableObjectWithBuffers(a):a,s);return(0,k.revive)(E)}catch(E){if(E instanceof Error&&E.message==="$executeCommand:retry")return this._doExecuteCommand(p,f,!1);throw E}}}async _executeContributedCommand(p,f,s){const v=this._commands.get(p);if(!v)throw new Error("Unknown command");let{callback:a,thisArg:E,description:I}=v;if(I)for(let D=0;D<I.args.length;D++)try{(0,c.validateConstraint)(f[D],I.args[D].constraint)}catch(B){throw new Error(`Running the contributed command: '${p}' failed. Illegal argument '${I.args[D].name}' - ${I.args[D].description}`)}try{return await a.apply(E,f)}catch(D){if(p===this.converter.delegatingCommandId){const B=this.converter.getActualCommand(...f);B&&(p=B.command)}throw this._logService.error(D,p,v.extension?.identifier),s?new class extends Error{constructor(){super((0,h.toErrorMessage)(D));this.id=p,this.source=v.extension?.displayName??v.extension?.name}}:D}}$executeContributedCommand(p,...f){return this._logService.trace("ExtHostCommands#$executeContributedCommand",p),this._commands.has(p)?(f=f.map(s=>this._argumentProcessors.reduce((v,a)=>a.processArgument(v),s)),this._executeContributedCommand(p,f,!0)):Promise.reject(new Error(`Contributed command '${p}' does not exist.`))}getCommands(p=!1){return this._logService.trace("ExtHostCommands#getCommands",p),this._proxy.$getCommands().then(f=>(p&&(f=f.filter(s=>s[0]!=="_")),f))}$getContributedCommandHandlerDescriptions(){const p=Object.create(null);for(let[f,s]of this._commands){let{description:v}=s;v&&(p[f]=v)}return Promise.resolve(p)}};g=Ue([$e(0,d.IExtHostRpcService),$e(1,C.ILogService)],g),e.ExtHostCommands=g,e.IExtHostCommands=(0,o.createDecorator)("IExtHostCommands");class A{constructor(p,f,s){this._commands=p,this._lookupApiCommand=f,this._logService=s,this.delegatingCommandId=`_vscode_delegate_cmd_${Date.now().toString(36)}`,this._cache=new Map,this._cachIdPool=0,this._commands.registerCommand(!0,this.delegatingCommandId,this._executeConvertedCommand,this)}toInternal(p,f){if(!p)return;const s={$ident:void 0,id:p.command,title:p.title,tooltip:p.tooltip};if(!p.command)return s;const v=this._lookupApiCommand(p.command);if(v)s.id=v.internalId,s.arguments=v.args.map((a,E)=>a.convert(p.arguments&&p.arguments[E]));else if((0,T.isNonEmptyArray)(p.arguments)){const a=++this._cachIdPool;this._cache.set(a,p),f.add((0,m.toDisposable)(()=>{this._cache.delete(a),this._logService.trace("CommandsConverter#DISPOSE",a)})),s.$ident=a,s.id=this.delegatingCommandId,s.arguments=[a],this._logService.trace("CommandsConverter#CREATE",p.command,a)}return s}fromInternal(p){const f=t.ObjectIdentifier.of(p);return typeof f=="number"?this._cache.get(f):{command:p.id,title:p.title,arguments:p.arguments}}getActualCommand(...p){return this._cache.get(p[0])}_executeConvertedCommand(...p){const f=this.getActualCommand(...p);return this._logService.trace("CommandsConverter#EXECUTE",p[0],f?f.command:"MISSING"),f?this._commands.executeCommand(f.command,...f.arguments||[]):Promise.reject("actual command NOT FOUND")}}e.CommandsConverter=A;class l{constructor(p,f,s,v){this.name=p,this.description=f,this.validate=s,this.convert=v}optional(){return new l(this.name,`(optional) ${this.description}`,p=>p==null||this.validate(p),p=>p===void 0?void 0:p===null?null:this.convert(p))}with(p,f){return new l(p??this.name,f??this.description,this.validate,this.convert)}}e.ApiCommandArgument=l,l.Uri=new l("uri","Uri of a text document",i=>n.URI.isUri(i),i=>i),l.Position=new l("position","A position in a text document",i=>F.Position.isPosition(i),w.Position.from),l.Range=new l("range","A range in a text document",i=>F.Range.isRange(i),w.Range.from),l.Selection=new l("selection","A selection in a text document",i=>F.Selection.isSelection(i),w.Selection.from),l.Number=new l("number","",i=>typeof i=="number",i=>i),l.String=new l("string","",i=>typeof i=="string",i=>i),l.CallHierarchyItem=new l("item","A call hierarchy item",i=>i instanceof F.CallHierarchyItem,w.CallHierarchyItem.from),l.TypeHierarchyItem=new l("item","A type hierarchy item",i=>i instanceof F.TypeHierarchyItem,w.TypeHierarchyItem.from),l.TestItem=new l("testItem","A VS Code TestItem",i=>i instanceof u.TestItemImpl,w.TestItem.from);class M{constructor(p,f){this.description=p,this.convert=f}}e.ApiCommandResult=M,M.Void=new M("no result",i=>i);class r{constructor(p,f,s,v,a){this.id=p,this.internalId=f,this.description=s,this.args=v,this.result=a}}e.ApiCommand=r}),define(Ee[180],_e([0,1,8,7,58,38,16,79]),function(re,e,c,F,w,P,t,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostApiCommands=void 0;const C=[new P.ApiCommand("vscode.executeDocumentHighlights","_executeDocumentHighlights","Execute document highlight provider.",[P.ApiCommandArgument.Uri,P.ApiCommandArgument.Position],new P.ApiCommandResult("A promise that resolves to an array of DocumentHighlight-instances.",R(c.DocumentHighlight.to))),new P.ApiCommand("vscode.executeDocumentSymbolProvider","_executeDocumentSymbolProvider","Execute document symbol provider.",[P.ApiCommandArgument.Uri],new P.ApiCommandResult("A promise that resolves to an array of SymbolInformation and DocumentSymbol instances.",(n,m)=>{if((0,t.isFalsyOrEmpty)(n))return;class o extends F.SymbolInformation{static to(u){const S=new o(u.name,c.SymbolKind.to(u.kind),u.containerName||"",new F.Location(m[0],c.Range.to(u.range)));return S.detail=u.detail,S.range=S.location.range,S.selectionRange=c.Range.to(u.selectionRange),S.children=u.children?u.children.map(o.to):[],S}}return n.map(o.to)})),new P.ApiCommand("vscode.executeFormatDocumentProvider","_executeFormatDocumentProvider","Execute document format provider.",[P.ApiCommandArgument.Uri,new P.ApiCommandArgument("options","Formatting options",n=>!0,n=>n)],new P.ApiCommandResult("A promise that resolves to an array of TextEdits.",R(c.TextEdit.to))),new P.ApiCommand("vscode.executeFormatRangeProvider","_executeFormatRangeProvider","Execute range format provider.",[P.ApiCommandArgument.Uri,P.ApiCommandArgument.Range,new P.ApiCommandArgument("options","Formatting options",n=>!0,n=>n)],new P.ApiCommandResult("A promise that resolves to an array of TextEdits.",R(c.TextEdit.to))),new P.ApiCommand("vscode.executeFormatOnTypeProvider","_executeFormatOnTypeProvider","Execute format on type provider.",[P.ApiCommandArgument.Uri,P.ApiCommandArgument.Position,new P.ApiCommandArgument("ch","Trigger character",n=>typeof n=="string",n=>n),new P.ApiCommandArgument("options","Formatting options",n=>!0,n=>n)],new P.ApiCommandResult("A promise that resolves to an array of TextEdits.",R(c.TextEdit.to))),new P.ApiCommand("vscode.executeDefinitionProvider","_executeDefinitionProvider","Execute all definition providers.",[P.ApiCommandArgument.Uri,P.ApiCommandArgument.Position],new P.ApiCommandResult("A promise that resolves to an array of Location or LocationLink instances.",_)),new P.ApiCommand("vscode.executeTypeDefinitionProvider","_executeTypeDefinitionProvider","Execute all type definition providers.",[P.ApiCommandArgument.Uri,P.ApiCommandArgument.Position],new P.ApiCommandResult("A promise that resolves to an array of Location or LocationLink instances.",_)),new P.ApiCommand("vscode.executeDeclarationProvider","_executeDeclarationProvider","Execute all declaration providers.",[P.ApiCommandArgument.Uri,P.ApiCommandArgument.Position],new P.ApiCommandResult("A promise that resolves to an array of Location or LocationLink instances.",_)),new P.ApiCommand("vscode.executeImplementationProvider","_executeImplementationProvider","Execute all implementation providers.",[P.ApiCommandArgument.Uri,P.ApiCommandArgument.Position],new P.ApiCommandResult("A promise that resolves to an array of Location or LocationLink instances.",_)),new P.ApiCommand("vscode.executeReferenceProvider","_executeReferenceProvider","Execute all reference providers.",[P.ApiCommandArgument.Uri,P.ApiCommandArgument.Position],new P.ApiCommandResult("A promise that resolves to an array of Location-instances.",R(c.location.to))),new P.ApiCommand("vscode.executeHoverProvider","_executeHoverProvider","Execute all hover providers.",[P.ApiCommandArgument.Uri,P.ApiCommandArgument.Position],new P.ApiCommandResult("A promise that resolves to an array of Hover-instances.",R(c.Hover.to))),new P.ApiCommand("vscode.executeSelectionRangeProvider","_executeSelectionRangeProvider","Execute selection range provider.",[P.ApiCommandArgument.Uri,new P.ApiCommandArgument("position","A position in a text document",n=>Array.isArray(n)&&n.every(m=>F.Position.isPosition(m)),n=>n.map(c.Position.from))],new P.ApiCommandResult("A promise that resolves to an array of ranges.",n=>n.map(m=>{let o;for(const d of m.reverse())o=new F.SelectionRange(c.Range.to(d),o);return o}))),new P.ApiCommand("vscode.executeWorkspaceSymbolProvider","_executeWorkspaceSymbolProvider","Execute all workspace symbol providers.",[P.ApiCommandArgument.String.with("query","Search string")],new P.ApiCommandResult("A promise that resolves to an array of SymbolInformation-instances.",n=>n.map(c.WorkspaceSymbol.to))),new P.ApiCommand("vscode.prepareCallHierarchy","_executePrepareCallHierarchy","Prepare call hierarchy at a position inside a document",[P.ApiCommandArgument.Uri,P.ApiCommandArgument.Position],new P.ApiCommandResult("A CallHierarchyItem or undefined",n=>n.map(c.CallHierarchyItem.to))),new P.ApiCommand("vscode.provideIncomingCalls","_executeProvideIncomingCalls","Compute incoming calls for an item",[P.ApiCommandArgument.CallHierarchyItem],new P.ApiCommandResult("A CallHierarchyItem or undefined",n=>n.map(c.CallHierarchyIncomingCall.to))),new P.ApiCommand("vscode.provideOutgoingCalls","_executeProvideOutgoingCalls","Compute outgoing calls for an item",[P.ApiCommandArgument.CallHierarchyItem],new P.ApiCommandResult("A CallHierarchyItem or undefined",n=>n.map(c.CallHierarchyOutgoingCall.to))),new P.ApiCommand("vscode.prepareRename","_executePrepareRename","Execute the prepareRename of rename provider.",[P.ApiCommandArgument.Uri,P.ApiCommandArgument.Position],new P.ApiCommandResult("A promise that resolves to a range and placeholder text.",n=>{if(!!n)return{range:c.Range.to(n.range),placeholder:n.text}})),new P.ApiCommand("vscode.executeDocumentRenameProvider","_executeDocumentRenameProvider","Execute rename provider.",[P.ApiCommandArgument.Uri,P.ApiCommandArgument.Position,P.ApiCommandArgument.String.with("newName","The new symbol name")],new P.ApiCommandResult("A promise that resolves to a WorkspaceEdit.",n=>{if(!!n){if(n.rejectReason)throw new Error(n.rejectReason);return c.WorkspaceEdit.to(n)}})),new P.ApiCommand("vscode.executeLinkProvider","_executeLinkProvider","Execute document link provider.",[P.ApiCommandArgument.Uri,P.ApiCommandArgument.Number.with("linkResolveCount","Number of links that should be resolved, only when links are unresolved.").optional()],new P.ApiCommandResult("A promise that resolves to an array of DocumentLink-instances.",n=>n.map(c.DocumentLink.to))),new P.ApiCommand("vscode.provideDocumentSemanticTokensLegend","_provideDocumentSemanticTokensLegend","Provide semantic tokens legend for a document",[P.ApiCommandArgument.Uri],new P.ApiCommandResult("A promise that resolves to SemanticTokensLegend.",n=>{if(!!n)return new F.SemanticTokensLegend(n.tokenTypes,n.tokenModifiers)})),new P.ApiCommand("vscode.provideDocumentSemanticTokens","_provideDocumentSemanticTokens","Provide semantic tokens for a document",[P.ApiCommandArgument.Uri],new P.ApiCommandResult("A promise that resolves to SemanticTokens.",n=>{if(!n)return;const m=(0,T.decodeSemanticTokensDto)(n);if(m.type==="full")return new F.SemanticTokens(m.data,void 0)})),new P.ApiCommand("vscode.provideDocumentRangeSemanticTokensLegend","_provideDocumentRangeSemanticTokensLegend","Provide semantic tokens legend for a document range",[P.ApiCommandArgument.Uri,P.ApiCommandArgument.Range.optional()],new P.ApiCommandResult("A promise that resolves to SemanticTokensLegend.",n=>{if(!!n)return new F.SemanticTokensLegend(n.tokenTypes,n.tokenModifiers)})),new P.ApiCommand("vscode.provideDocumentRangeSemanticTokens","_provideDocumentRangeSemanticTokens","Provide semantic tokens for a document range",[P.ApiCommandArgument.Uri,P.ApiCommandArgument.Range],new P.ApiCommandResult("A promise that resolves to SemanticTokens.",n=>{if(!n)return;const m=(0,T.decodeSemanticTokensDto)(n);if(m.type==="full")return new F.SemanticTokens(m.data,void 0)})),new P.ApiCommand("vscode.executeCompletionItemProvider","_executeCompletionItemProvider","Execute completion item provider.",[P.ApiCommandArgument.Uri,P.ApiCommandArgument.Position,P.ApiCommandArgument.String.with("triggerCharacter","Trigger completion when the user types the character, like `,` or `(`").optional(),P.ApiCommandArgument.Number.with("itemResolveCount","Number of completions to resolve (too large numbers slow down completions)").optional()],new P.ApiCommandResult("A promise that resolves to a CompletionList-instance.",(n,m,o)=>{if(!n)return new F.CompletionList([]);const d=n.suggestions.map(u=>c.CompletionItem.to(u,o));return new F.CompletionList(d,n.incomplete)})),new P.ApiCommand("vscode.executeSignatureHelpProvider","_executeSignatureHelpProvider","Execute signature help provider.",[P.ApiCommandArgument.Uri,P.ApiCommandArgument.Position,P.ApiCommandArgument.String.with("triggerCharacter","Trigger signature help when the user types the character, like `,` or `(`").optional()],new P.ApiCommandResult("A promise that resolves to SignatureHelp.",n=>{if(n)return c.SignatureHelp.to(n)})),new P.ApiCommand("vscode.executeCodeLensProvider","_executeCodeLensProvider","Execute code lens provider.",[P.ApiCommandArgument.Uri,P.ApiCommandArgument.Number.with("itemResolveCount","Number of lenses that should be resolved and returned. Will only return resolved lenses, will impact performance)").optional()],new P.ApiCommandResult("A promise that resolves to an array of CodeLens-instances.",(n,m,o)=>R(d=>new F.CodeLens(c.Range.to(d.range),d.command&&o.fromInternal(d.command)))(n))),new P.ApiCommand("vscode.executeCodeActionProvider","_executeCodeActionProvider","Execute code action provider.",[P.ApiCommandArgument.Uri,new P.ApiCommandArgument("rangeOrSelection","Range in a text document. Some refactoring provider requires Selection object.",n=>F.Range.isRange(n),n=>F.Selection.isSelection(n)?c.Selection.from(n):c.Range.from(n)),P.ApiCommandArgument.String.with("kind","Code action kind to return code actions for").optional(),P.ApiCommandArgument.Number.with("itemResolveCount","Number of code actions to resolve (too large numbers slow down code actions)").optional()],new P.ApiCommandResult("A promise that resolves to an array of Command-instances.",(n,m,o)=>R(d=>{if(d._isSynthetic){if(!d.command)throw new Error("Synthetic code actions must have a command");return o.fromInternal(d.command)}else{const u=new F.CodeAction(d.title,d.kind?new F.CodeActionKind(d.kind):void 0);return d.edit&&(u.edit=c.WorkspaceEdit.to(d.edit)),d.command&&(u.command=o.fromInternal(d.command)),u.isPreferred=d.isPreferred,u}})(n))),new P.ApiCommand("vscode.executeDocumentColorProvider","_executeDocumentColorProvider","Execute document color provider.",[P.ApiCommandArgument.Uri],new P.ApiCommandResult("A promise that resolves to an array of ColorInformation objects.",n=>n?n.map(m=>new F.ColorInformation(c.Range.to(m.range),c.Color.to(m.color))):[])),new P.ApiCommand("vscode.executeColorPresentationProvider","_executeColorPresentationProvider","Execute color presentation provider.",[new P.ApiCommandArgument("color","The color to show and insert",n=>n instanceof F.Color,c.Color.from),new P.ApiCommandArgument("context","Context object with uri and range",n=>!0,n=>({uri:n.uri,range:c.Range.from(n.range)}))],new P.ApiCommandResult("A promise that resolves to an array of ColorPresentation objects.",n=>n?n.map(c.ColorPresentation.to):[])),new P.ApiCommand("vscode.executeInlayHintProvider","_executeInlayHintProvider","Execute inlay hints provider",[P.ApiCommandArgument.Uri,P.ApiCommandArgument.Range],new P.ApiCommandResult("A promise that resolves to an array of Inlay objects",n=>n.map(c.InlayHint.to))),new P.ApiCommand("vscode.resolveNotebookContentProviders","_resolveNotebookContentProvider","Resolve Notebook Content Providers",[],new P.ApiCommandResult("A promise that resolves to an array of NotebookContentProvider static info objects.",R(n=>({viewType:n.viewType,displayName:n.displayName,options:{transientOutputs:n.options.transientOutputs,transientCellMetadata:n.options.transientCellMetadata,transientDocumentMetadata:n.options.transientDocumentMetadata},filenamePattern:n.filenamePattern.map(m=>c.NotebookExclusiveDocumentPattern.to(m))})))),new P.ApiCommand("vscode.executeInlineValueProvider","_executeInlineValueProvider","Execute inline value provider",[P.ApiCommandArgument.Uri,P.ApiCommandArgument.Range],new P.ApiCommandResult("A promise that resolves to an array of InlineValue objects",n=>n.map(c.InlineValue.to))),new P.ApiCommand("vscode.open","_workbench.open","Opens the provided resource in the editor. Can be a text or binary file, or an http(s) URL. If you need more control over the options for opening a text file, use vscode.window.showTextDocument instead.",[P.ApiCommandArgument.Uri,new P.ApiCommandArgument("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",n=>n===void 0||typeof n=="number"||typeof n=="object",n=>n&&(typeof n=="number"?[n,void 0]:[c.ViewColumn.from(n.viewColumn),c.TextEditorOpenOptions.from(n)])).optional(),P.ApiCommandArgument.String.with("label","").optional()],P.ApiCommandResult.Void),new P.ApiCommand("vscode.openWith","_workbench.openWith","Opens the provided resource with a specific editor.",[P.ApiCommandArgument.Uri.with("resource","Resource to open"),P.ApiCommandArgument.String.with("viewId","Custom editor view id or 'default' to use VS Code's default editor"),new P.ApiCommandArgument("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",n=>n===void 0||typeof n=="number"||typeof n=="object",n=>n&&(typeof n=="number"?[n,void 0]:[c.ViewColumn.from(n.viewColumn),c.TextEditorOpenOptions.from(n)])).optional()],P.ApiCommandResult.Void),new P.ApiCommand("vscode.diff","_workbench.diff","Opens the provided resources in the diff editor to compare their contents.",[P.ApiCommandArgument.Uri.with("left","Left-hand side resource of the diff editor"),P.ApiCommandArgument.Uri.with("right","Right-hand side resource of the diff editor"),P.ApiCommandArgument.String.with("title","Human readable title for the diff editor").optional(),new P.ApiCommandArgument("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",n=>n===void 0||typeof n=="object",n=>n&&[c.ViewColumn.from(n.viewColumn),c.TextEditorOpenOptions.from(n)]).optional()],P.ApiCommandResult.Void),new P.ApiCommand("vscode.prepareTypeHierarchy","_executePrepareTypeHierarchy","Prepare type hierarchy at a position inside a document",[P.ApiCommandArgument.Uri,P.ApiCommandArgument.Position],new P.ApiCommandResult("A TypeHierarchyItem or undefined",n=>n.map(c.TypeHierarchyItem.to))),new P.ApiCommand("vscode.provideSupertypes","_executeProvideSupertypes","Compute supertypes for an item",[P.ApiCommandArgument.TypeHierarchyItem],new P.ApiCommandResult("A TypeHierarchyItem or undefined",n=>n.map(c.TypeHierarchyItem.to))),new P.ApiCommand("vscode.provideSubtypes","_executeProvideSubtypes","Compute subtypes for an item",[P.ApiCommandArgument.TypeHierarchyItem],new P.ApiCommandResult("A TypeHierarchyItem or undefined",n=>n.map(c.TypeHierarchyItem.to))),new P.ApiCommand("vscode.revealTestInExplorer","_revealTestInExplorer","Reveals a test instance in the explorer",[P.ApiCommandArgument.TestItem],P.ApiCommandResult.Void)];class k{static register(m){C.forEach(m.registerApiCommand,m)}}e.ExtHostApiCommands=k;function R(n){return m=>{if(Array.isArray(m))return m.map(n)}}function _(n){if(!Array.isArray(n))return;const m=[];for(const o of n)w.isLocationLink(o)?m.push(c.DefinitionLink.to(o)):m.push(c.location.to(o));return m}}),define(Ee[181],_e([0,1,14,51,3,6,2,58,25,8,7,5]),function(re,e,c,F,w,P,t,T,C,k,R,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createExtHostComments=void 0;function n(m,o,d){const u=m.getProxy(_.MainContext.MainThreadComments);class S{constructor(){this._commentControllers=new Map,this._commentControllersByExtension=new Map,o.registerArgumentProcessor({processArgument:i=>{if(i&&i.$mid===6){const p=this._commentControllers.get(i.handle);return p||i}else if(i&&i.$mid===7){const p=this._commentControllers.get(i.commentControlHandle);if(!p)return i;const f=p.getCommentThread(i.commentThreadHandle);return f||i}else if(i&&i.$mid===8){const p=this._commentControllers.get(i.thread.commentControlHandle);if(!p)return i;const f=p.getCommentThread(i.thread.commentThreadHandle);return f?{thread:f,text:i.text}:i}else if(i&&i.$mid===9){const p=this._commentControllers.get(i.thread.commentControlHandle);if(!p)return i;const f=p.getCommentThread(i.thread.commentThreadHandle);if(!f)return i;let s=i.commentUniqueId,v=f.getCommentByUniqueId(s);return v||i}else if(i&&i.$mid===10){const p=this._commentControllers.get(i.thread.commentControlHandle);if(!p)return i;const f=p.getCommentThread(i.thread.commentThreadHandle);if(!f)return i;let s=i.text,v=i.commentUniqueId,a=f.getCommentByUniqueId(v);return a?(a.body=s,a):i}return i}})}createCommentController(i,p,f){const s=S.handlePool++,v=new h(i,s,p,f);this._commentControllers.set(v.handle,v);const a=this._commentControllersByExtension.get(C.ExtensionIdentifier.toKey(i.identifier))||[];return a.push(v),this._commentControllersByExtension.set(C.ExtensionIdentifier.toKey(i.identifier),a),v.value}$createCommentThreadTemplate(i,p,f){const s=this._commentControllers.get(i);!s||s.$createCommentThreadTemplate(p,f)}async $updateCommentThreadTemplate(i,p,f){const s=this._commentControllers.get(i);!s||s.$updateCommentThreadTemplate(p,f)}$deleteCommentThread(i,p){const f=this._commentControllers.get(i);f&&f.$deleteCommentThread(p)}$provideCommentingRanges(i,p,f){const s=this._commentControllers.get(i);if(!s||!s.commentingRangeProvider)return Promise.resolve(void 0);const v=d.getDocument(t.URI.revive(p));return(0,c.asPromise)(()=>s.commentingRangeProvider.provideCommentingRanges(v,f)).then(a=>a?a.map(E=>k.Range.from(E)):void 0)}$toggleReaction(i,p,f,s,v){const a=this._commentControllers.get(i);return!a||!a.reactionHandler?Promise.resolve(void 0):(0,c.asPromise)(()=>{const E=a.getCommentThread(p);if(E){const I=E.getCommentByUniqueId(s.uniqueIdInThread);if(a!==void 0&&I&&a.reactionHandler)return a.reactionHandler(I,l(v))}return Promise.resolve(void 0)})}dispose(){}}S.handlePool=0;class b{constructor(i,p,f,s,v,a,E){this._commentControllerHandle=p,this._id=f,this._uri=s,this._range=v,this._comments=a,this.handle=b._handlePool++,this.commentHandle=0,this.modifications=Object.create(null),this._onDidUpdateCommentThread=new w.Emitter,this.onDidUpdateCommentThread=this._onDidUpdateCommentThread.event,this._canReply=!0,this._commentsMap=new Map,this._acceptInputDisposables=new P.MutableDisposable,this._acceptInputDisposables.value=new P.DisposableStore,this._id===void 0&&(this._id=`${i}.${this.handle}`),u.$createCommentThread(p,this.handle,this._id,this._uri,k.Range.from(this._range),E),this._localDisposables=[],this._isDiposed=!1,this._localDisposables.push(this.onDidUpdateCommentThread(()=>{this.eventuallyUpdateCommentThread()})),this.comments=a,this._localDisposables.push({dispose:()=>{u.$deleteCommentThread(p,this.handle)}});const I=this;this.value={get uri(){return I.uri},get range(){return I.range},set range(D){I.range=D},get comments(){return I.comments},set comments(D){I.comments=D},get collapsibleState(){return I.collapsibleState},set collapsibleState(D){I.collapsibleState=D},get canReply(){return I.canReply},set canReply(D){I.canReply=D},get contextValue(){return I.contextValue},set contextValue(D){I.contextValue=D},get label(){return I.label},set label(D){I.label=D},dispose:()=>{I.dispose()}}}set threadId(i){this._id=i}get threadId(){return this._id}get id(){return this._id}get resource(){return this._uri}get uri(){return this._uri}set range(i){i.isEqual(this._range)||(this._range=i,this.modifications.range=i,this._onDidUpdateCommentThread.fire())}get range(){return this._range}set canReply(i){this._canReply!==i&&(this._canReply=i,this.modifications.canReply=i,this._onDidUpdateCommentThread.fire())}get canReply(){return this._canReply}get label(){return this._label}set label(i){this._label=i,this.modifications.label=i,this._onDidUpdateCommentThread.fire()}get contextValue(){return this._contextValue}set contextValue(i){this._contextValue=i,this.modifications.contextValue=i,this._onDidUpdateCommentThread.fire()}get comments(){return this._comments}set comments(i){this._comments=i,this.modifications.comments=i,this._onDidUpdateCommentThread.fire()}get collapsibleState(){return this._collapseState}set collapsibleState(i){this._collapseState=i,this.modifications.collapsibleState=i,this._onDidUpdateCommentThread.fire()}get isDisposed(){return this._isDiposed}eventuallyUpdateCommentThread(){if(this._isDiposed)return;this._acceptInputDisposables.value||(this._acceptInputDisposables.value=new P.DisposableStore);const i=f=>Object.prototype.hasOwnProperty.call(this.modifications,f),p={};i("range")&&(p.range=k.Range.from(this._range)),i("label")&&(p.label=this.label),i("contextValue")&&(p.contextValue=this.contextValue??null),i("comments")&&(p.comments=this._comments.map(f=>g(this,f,this._commentsMap))),i("collapsibleState")&&(p.collapseState=M(this._collapseState)),i("canReply")&&(p.canReply=this.canReply),this.modifications={},u.$updateCommentThread(this._commentControllerHandle,this.handle,this._id,this._uri,p)}getCommentByUniqueId(i){for(let p of this._commentsMap){let f=p[0],s=p[1];if(i===s)return f}}dispose(){this._isDiposed=!0,this._acceptInputDisposables.dispose(),this._localDisposables.forEach(i=>i.dispose())}}b._handlePool=0,Ue([(0,F.debounce)(100)],b.prototype,"eventuallyUpdateCommentThread",null);class h{constructor(i,p,f,s){this._extension=i,this._handle=p,this._id=f,this._label=s,this._threads=new Map,u.$registerCommentController(this.handle,f,s);const v=this;this.value=Object.freeze({id:v.id,label:v.label,get options(){return v.options},set options(a){v.options=a},get commentingRangeProvider(){return v.commentingRangeProvider},set commentingRangeProvider(a){v.commentingRangeProvider=a},get reactionHandler(){return v.reactionHandler},set reactionHandler(a){v.reactionHandler=a},createCommentThread(a,E,I){return v.createCommentThread(a,E,I).value},dispose:()=>{v.dispose()}}),this._localDisposables=[],this._localDisposables.push({dispose:()=>{u.$unregisterCommentController(this.handle)}})}get id(){return this._id}get label(){return this._label}get handle(){return this._handle}get commentingRangeProvider(){return this._commentingRangeProvider}set commentingRangeProvider(i){this._commentingRangeProvider=i,u.$updateCommentingRanges(this.handle)}get reactionHandler(){return this._reactionHandler}set reactionHandler(i){this._reactionHandler=i,u.$updateCommentControllerFeatures(this.handle,{reactionHandler:!!i})}get options(){return this._options}set options(i){this._options=i,u.$updateCommentControllerFeatures(this.handle,{options:this._options})}createCommentThread(i,p,f,s){if(typeof i=="string"){const v=new b(this.id,this.handle,i,p,f,s,this._extension.identifier);return this._threads.set(v.handle,v),v}else{const v=new b(this.id,this.handle,void 0,i,p,f,this._extension.identifier);return this._threads.set(v.handle,v),v}}$createCommentThreadTemplate(i,p){const f=new b(this.id,this.handle,void 0,t.URI.revive(i),k.Range.to(p),[],this._extension.identifier);return f.collapsibleState=T.CommentThreadCollapsibleState.Expanded,this._threads.set(f.handle,f),f}$updateCommentThreadTemplate(i,p){let f=this._threads.get(i);f&&(f.range=k.Range.to(p))}$deleteCommentThread(i){let p=this._threads.get(i);p&&p.dispose(),this._threads.delete(i)}getCommentThread(i){return this._threads.get(i)}dispose(){this._threads.forEach(i=>{i.dispose()}),this._localDisposables.forEach(i=>i.dispose())}}function g(r,i,p){let f=p.get(i);f||(f=++r.commentHandle,p.set(i,f));const s=i.author&&i.author.iconPath?i.author.iconPath.toString():void 0;return{mode:i.mode,contextValue:i.contextValue,uniqueIdInThread:f,body:k.MarkdownString.from(i.body),userName:i.author.name,userIconPath:s,label:i.label,commentReactions:i.reactions?i.reactions.map(v=>A(v)):void 0}}function A(r){return{label:r.label,iconPath:r.iconPath?k.pathOrURIToURI(r.iconPath):void 0,count:r.count,hasReacted:r.authorHasReacted}}function l(r){return{label:r.label||"",count:r.count||0,iconPath:r.iconPath?t.URI.revive(r.iconPath):"",authorHasReacted:r.hasReacted||!1}}function M(r){if(r!==void 0)switch(r){case R.CommentThreadCollapsibleState.Expanded:return T.CommentThreadCollapsibleState.Expanded;case R.CommentThreadCollapsibleState.Collapsed:return T.CommentThreadCollapsibleState.Collapsed}return T.CommentThreadCollapsibleState.Collapsed}return new S}e.createExtHostComments=n}),define(Ee[93],_e([0,1,2,5,7,4,13,12,16,9,17]),function(re,e,c,F,w,P,t,T,C,k,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostDecorations=e.ExtHostDecorations=void 0;let _=class wi{constructor(m,o){this._logService=o,this._provider=new Map,this._proxy=m.getProxy(F.MainContext.MainThreadDecorations)}registerFileDecorationProvider(m,o){const d=wi._handlePool++;this._provider.set(d,{provider:m,extensionId:o}),this._proxy.$registerDecorationProvider(d,o.value);const u=m.onDidChangeFileDecorations&&m.onDidChangeFileDecorations(S=>{if(!S){this._proxy.$onDidChange(d,null);return}let b=(0,C.asArray)(S);if(b.length<=wi._maxEventSize){this._proxy.$onDidChange(d,b);return}this._logService.warn("[Decorations] CAPPING events from decorations provider",o.value,b.length);const h=b.map(l=>({uri:l,rank:(0,k.count)(l.path,"/")})),g=(0,C.groupBy)(h,(l,M)=>l.rank-M.rank||(0,k.compare)(l.uri.path,M.uri.path));let A=[];e:for(let l of g){let M;for(let r of l){let i=(0,R.dirname)(r.uri.path);if(M!==i&&(M=i,A.push(r.uri)>=wi._maxEventSize))break e}}this._proxy.$onDidChange(d,A)});return new w.Disposable(()=>{u?.dispose(),this._proxy.$unregisterDecorationProvider(d),this._provider.delete(d)})}async $provideDecorations(m,o,d){if(!this._provider.has(m))return Object.create(null);const u=Object.create(null),{provider:S,extensionId:b}=this._provider.get(m);return await Promise.all(o.map(async h=>{try{const{uri:g,id:A}=h,l=await Promise.resolve(S.provideFileDecoration(c.URI.revive(g),d));if(!l)return;try{w.FileDecoration.validate(l),u[A]=[l.propagate,l.tooltip,l.badge,l.color]}catch(M){this._logService.warn(`INVALID decoration from extension '${b.value}': ${M}`)}}catch(g){this._logService.error(g)}})),u}};_._handlePool=0,_._maxEventSize=250,_=Ue([$e(0,t.IExtHostRpcService),$e(1,T.ILogService)],_),e.ExtHostDecorations=_,e.IExtHostDecorations=(0,P.createDecorator)("IExtHostDecorations")});var Ze=this&&this.__classPrivateFieldSet||function(re,e,c,F,w){if(F==="m")throw new TypeError("Private method is not writable");if(F==="a"&&!w)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?re!==e||!w:!e.has(re))throw new TypeError("Cannot write private member to an object whose class did not declare it");return F==="a"?w.call(re,c):w?w.value=c:e.set(re,c),c},Te=this&&this.__classPrivateFieldGet||function(re,e,c,F){if(c==="a"&&!F)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?re!==e||!F:!e.has(re))throw new TypeError("Cannot read private member from an object whose class did not declare it");return c==="m"?F:c==="a"?F.call(re):F?F.value:e.get(re)};define(Ee[182],_e([0,1,119,82,2,5,7,8,3,12,21,30]),function(re,e,c,F,w,P,t,T,C,k,R,_){"use strict";var n,m,o;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDiagnostics=e.DiagnosticCollection=void 0;class d{constructor(b,h,g,A,l,M){this._name=b,this._owner=h,this._maxDiagnosticsPerFile=g,n.set(this,void 0),m.set(this,void 0),o.set(this,void 0),this._isDisposed=!1,Ze(this,o,new R.ResourceMap(r=>A.getComparisonKey(r)),"f"),Ze(this,n,l,"f"),Ze(this,m,M,"f")}dispose(){this._isDisposed||(Te(this,m,"f").fire([...Te(this,o,"f").keys()]),Te(this,n,"f")&&Te(this,n,"f").$clear(this._owner),Te(this,o,"f").clear(),this._isDisposed=!0)}get name(){return this._checkDisposed(),this._name}set(b,h){if(!b){this.clear();return}this._checkDisposed();let g=[];if(w.URI.isUri(b)){if(!h){this.delete(b);return}Te(this,o,"f").set(b,h.slice()),g=[b]}else if(Array.isArray(b)){g=[];let l;b=[...b].sort(d._compareIndexedTuplesByUri);for(const M of b){const[r,i]=M;if((!l||r.toString()!==l.toString())&&(l&&Te(this,o,"f").get(l).length===0&&Te(this,o,"f").delete(l),l=r,g.push(r),Te(this,o,"f").set(r,[])),i){const p=Te(this,o,"f").get(r);p&&p.push(...i)}else{const p=Te(this,o,"f").get(r);p&&(p.length=0)}}}if(Te(this,m,"f").fire(g),!Te(this,n,"f"))return;const A=[];for(let l of g){let M=[];const r=Te(this,o,"f").get(l);if(r)if(r.length>this._maxDiagnosticsPerFile){M=[];const i=[t.DiagnosticSeverity.Error,t.DiagnosticSeverity.Warning,t.DiagnosticSeverity.Information,t.DiagnosticSeverity.Hint];e:for(let p=0;p<4;p++)for(let f of r)if(f.severity===i[p]&&M.push(T.Diagnostic.from(f))===this._maxDiagnosticsPerFile)break e;M.push({severity:F.MarkerSeverity.Info,message:(0,c.localize)(0,null,r.length-this._maxDiagnosticsPerFile),startLineNumber:M[M.length-1].startLineNumber,startColumn:M[M.length-1].startColumn,endLineNumber:M[M.length-1].endLineNumber,endColumn:M[M.length-1].endColumn})}else M=r.map(i=>T.Diagnostic.from(i));A.push([l,M])}Te(this,n,"f").$changeMany(this._owner,A)}delete(b){this._checkDisposed(),Te(this,m,"f").fire([b]),Te(this,o,"f").delete(b),Te(this,n,"f")&&Te(this,n,"f").$changeMany(this._owner,[[b,void 0]])}clear(){this._checkDisposed(),Te(this,m,"f").fire([...Te(this,o,"f").keys()]),Te(this,o,"f").clear(),Te(this,n,"f")&&Te(this,n,"f").$clear(this._owner)}forEach(b,h){this._checkDisposed();for(let g of Te(this,o,"f").keys())b.apply(h,[g,this.get(g),this])}get(b){this._checkDisposed();const h=Te(this,o,"f").get(b);return Array.isArray(h)?Object.freeze(h.slice(0)):[]}has(b){return this._checkDisposed(),Array.isArray(Te(this,o,"f").get(b))}_checkDisposed(){if(this._isDisposed)throw new Error("illegal state - object is disposed")}static _compareIndexedTuplesByUri(b,h){return b[0].toString()<h[0].toString()?-1:b[0].toString()>h[0].toString()?1:0}}e.DiagnosticCollection=d,n=new WeakMap,m=new WeakMap,o=new WeakMap;let u=class ri{constructor(b,h,g){this._logService=h,this._fileSystemInfoService=g,this._collections=new Map,this._onDidChangeDiagnostics=new C.DebounceEmitter({merge:A=>A.flat(),delay:50}),this.onDidChangeDiagnostics=C.Event.map(this._onDidChangeDiagnostics.event,ri._mapper),this._proxy=b.getProxy(P.MainContext.MainThreadDiagnostics)}static _mapper(b){const h=new R.ResourceMap;for(const g of b)h.set(g,g);return{uris:Object.freeze(Array.from(h.values()))}}createDiagnosticCollection(b,h){const{_collections:g,_proxy:A,_onDidChangeDiagnostics:l,_logService:M,_fileSystemInfoService:r}=this,i=new class{$changeMany(s,v){A.$changeMany(s,v),M.trace("[DiagnosticCollection] change many (extension, owner, uris)",b.value,s,v.length===0?"CLEARING":v)}$clear(s){A.$clear(s),M.trace("[DiagnosticCollection] remove all (extension, owner)",b.value,s)}dispose(){A.dispose()}};let p;if(!h)h="_generated_diagnostic_collection_name_#"+ri._idPool++,p=h;else if(!g.has(h))p=h;else{this._logService.warn(`DiagnosticCollection with name '${h}' does already exist.`);do p=h+ri._idPool++;while(g.has(p))}return new class extends d{constructor(){super(h,p,ri._maxDiagnosticsPerFile,r.extUri,i,l);g.set(p,this)}dispose(){super.dispose(),g.delete(p)}}}getDiagnostics(b){if(b)return this._getDiagnostics(b);{const h=new Map,g=[];for(const A of this._collections.values())A.forEach((l,M)=>{let r=h.get(l.toString());typeof r=="undefined"&&(r=g.length,h.set(l.toString(),r),g.push([l,[]])),g[r][1]=g[r][1].concat(...M)});return g}}_getDiagnostics(b){let h=[];for(let g of this._collections.values())g.has(b)&&(h=h.concat(g.get(b)));return h}$acceptMarkersChange(b){if(!this._mirrorCollection){const h="_generated_mirror",g=new d(h,h,ri._maxDiagnosticsPerFile,this._fileSystemInfoService.extUri,void 0,this._onDidChangeDiagnostics);this._collections.set(h,g),this._mirrorCollection=g}for(const[h,g]of b)this._mirrorCollection.set(w.URI.revive(h),g.map(T.Diagnostic.to))}};u._idPool=0,u._maxDiagnosticsPerFile=1e3,u=Ue([$e(1,k.ILogService),$e(2,_.IExtHostFileSystemInfo)],u),e.ExtHostDiagnostics=u}),define(Ee[183],_e([0,1,2,5]),function(re,e,c,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDialogs=void 0;class w{constructor(t){this._proxy=t.getProxy(F.MainContext.MainThreadDialogs)}showOpenDialog(t){return this._proxy.$showOpenDialog(t).then(T=>T?T.map(C=>c.URI.revive(C)):void 0)}showSaveDialog(t){return this._proxy.$showSaveDialog(t).then(T=>T?c.URI.revive(T):void 0)}}e.ExtHostDialogs=w}),define(Ee[184],_e([0,1,15,2,7,5,10,20,9]),function(re,e,c,F,w,P,t,T,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDocumentContentProvider=void 0;class k{constructor(_,n,m){this._documentsAndEditors=n,this._logService=m,this._documentContentProviders=new Map,this._proxy=_.getProxy(P.MainContext.MainThreadDocumentContentProviders)}registerTextDocumentContentProvider(_,n){if(Object.keys(t.Schemas).indexOf(_)>=0)throw new Error(`scheme '${_}' already registered`);const m=k._handlePool++;this._documentContentProviders.set(m,n),this._proxy.$registerTextContentProvider(m,_);let o;return typeof n.onDidChange=="function"&&(o=n.onDidChange(d=>{if(d.scheme!==_){this._logService.warn(`Provider for scheme '${_}' is firing event for schema '${d.scheme}' which will be IGNORED`);return}this._documentsAndEditors.getDocument(d)&&this.$provideTextDocumentContent(m,d).then(u=>{if(!u&&typeof u!="string")return;const S=this._documentsAndEditors.getDocument(d);if(!S)return;const b=(0,C.splitLines)(u);if(!S.equalLines(b))return this._proxy.$onVirtualDocumentChange(d,u)},c.onUnexpectedError)})),new w.Disposable(()=>{this._documentContentProviders.delete(m)&&this._proxy.$unregisterTextContentProvider(m),o&&(o.dispose(),o=void 0)})}$provideTextDocumentContent(_,n){const m=this._documentContentProviders.get(_);return m?Promise.resolve(m.provideTextDocumentContent(F.URI.revive(n),T.CancellationToken.None)):Promise.reject(new Error(`unsupported uri-scheme: ${n.scheme}`))}}e.ExtHostDocumentContentProvider=k,k._handlePool=0}),define(Ee[185],_e([0,1,3,6,2,5,86,8,11,26,7]),function(re,e,c,F,w,P,t,T,C,k,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDocuments=void 0;class _{constructor(m,o){this._onDidAddDocument=new c.Emitter,this._onDidRemoveDocument=new c.Emitter,this._onDidChangeDocument=new c.Emitter,this._onDidSaveDocument=new c.Emitter,this.onDidAddDocument=this._onDidAddDocument.event,this.onDidRemoveDocument=this._onDidRemoveDocument.event,this.onDidChangeDocument=this._onDidChangeDocument.event,this.onDidSaveDocument=this._onDidSaveDocument.event,this._toDispose=new F.DisposableStore,this._documentLoader=new Map,this._proxy=m.getProxy(P.MainContext.MainThreadDocuments),this._documentsAndEditors=o,this._documentsAndEditors.onDidRemoveDocuments(d=>{for(const u of d)this._onDidRemoveDocument.fire(u.document)},void 0,this._toDispose),this._documentsAndEditors.onDidAddDocuments(d=>{for(const u of d)this._onDidAddDocument.fire(u.document)},void 0,this._toDispose)}dispose(){this._toDispose.dispose()}getAllDocumentData(){return[...this._documentsAndEditors.allDocuments()]}getDocumentData(m){if(!m)return;const o=this._documentsAndEditors.getDocument(m);if(o)return o}getDocument(m){const o=this.getDocumentData(m);if(!o?.document)throw new Error(`Unable to retrieve document from URI '${m}'`);return o.document}ensureDocumentData(m){const o=this._documentsAndEditors.getDocument(m);if(o)return Promise.resolve(o);let d=this._documentLoader.get(m.toString());return d||(d=this._proxy.$tryOpenDocument(m).then(u=>{this._documentLoader.delete(m.toString());const S=w.URI.revive(u);return(0,C.assertIsDefined)(this._documentsAndEditors.getDocument(S))},u=>(this._documentLoader.delete(m.toString()),Promise.reject(u))),this._documentLoader.set(m.toString(),d)),d}createDocumentData(m){return this._proxy.$tryCreateDocument(m).then(o=>w.URI.revive(o))}$acceptModelModeChanged(m,o){const d=w.URI.revive(m),u=this._documentsAndEditors.getDocument(d);if(!u)throw new Error("unknown document");this._onDidRemoveDocument.fire(u.document),u._acceptLanguageId(o),this._onDidAddDocument.fire(u.document)}$acceptModelSaved(m){const o=w.URI.revive(m),d=this._documentsAndEditors.getDocument(o);if(!d)throw new Error("unknown document");this.$acceptDirtyStateChanged(m,!1),this._onDidSaveDocument.fire(d.document)}$acceptDirtyStateChanged(m,o){const d=w.URI.revive(m),u=this._documentsAndEditors.getDocument(d);if(!u)throw new Error("unknown document");u._acceptIsDirty(o),this._onDidChangeDocument.fire({document:u.document,contentChanges:[],reason:void 0})}$acceptModelChanged(m,o,d){const u=w.URI.revive(m),S=this._documentsAndEditors.getDocument(u);if(!S)throw new Error("unknown document");S._acceptIsDirty(d),S.onEvents(o);let b;o.isUndoing?b=R.TextDocumentChangeReason.Undo:o.isRedoing&&(b=R.TextDocumentChangeReason.Redo),this._onDidChangeDocument.fire((0,k.deepFreeze)({document:S.document,contentChanges:o.changes.map(h=>({range:T.Range.to(h.range),rangeOffset:h.rangeOffset,rangeLength:h.rangeLength,text:h.text})),reason:b}))}setWordDefinitionFor(m,o){(0,t.setWordDefinitionFor)(m,o)}}e.ExtHostDocuments=_}),define(Ee[48],_e([0,1,41,3,6,2,4,5,86,13,92,8,12,21,10,158,101]),function(re,e,c,F,w,P,t,T,C,k,R,_,n,m,o,d,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostDocumentsAndEditors=e.ExtHostDocumentsAndEditors=void 0;class S{constructor(g){this.value=g,this._count=0}ref(){this._count++}unref(){return--this._count==0}}let b=class{constructor(g,A){this._extHostRpc=g,this._logService=A,this._activeEditorId=null,this._editors=new Map,this._documents=new m.ResourceMap,this._onDidAddDocuments=new F.Emitter,this._onDidRemoveDocuments=new F.Emitter,this._onDidChangeVisibleTextEditors=new F.Emitter,this._onDidChangeActiveTextEditor=new F.Emitter,this.onDidAddDocuments=this._onDidAddDocuments.event,this.onDidRemoveDocuments=this._onDidRemoveDocuments.event,this.onDidChangeVisibleTextEditors=this._onDidChangeVisibleTextEditors.event,this.onDidChangeActiveTextEditor=this._onDidChangeActiveTextEditor.event}$acceptDocumentsAndEditorsDelta(g){this.acceptDocumentsAndEditorsDelta(g)}acceptDocumentsAndEditorsDelta(g){const A=[],l=[],M=[];if(g.removedDocuments)for(const r of g.removedDocuments){const i=P.URI.revive(r),p=this._documents.get(i);p?.unref()&&(this._documents.delete(i),A.push(p.value))}if(g.addedDocuments)for(const r of g.addedDocuments){const i=P.URI.revive(r.uri);let p=this._documents.get(i);if(p&&i.scheme!==o.Schemas.vscodeNotebookCell&&i.scheme!==o.Schemas.vscodeInteractiveInput)throw new Error(`document '${i} already exists!'`);p||(p=new S(new C.ExtHostDocumentData(this._extHostRpc.getProxy(T.MainContext.MainThreadDocuments),i,r.lines,r.EOL,r.versionId,r.languageId,r.isDirty,r.notebook)),this._documents.set(i,p),l.push(p.value)),p.ref()}if(g.removedEditors)for(const r of g.removedEditors){const i=this._editors.get(r);this._editors.delete(r),i&&M.push(i)}if(g.addedEditors)for(const r of g.addedEditors){const i=P.URI.revive(r.documentUri);c.ok(this._documents.has(i),`document '${i}' does not exist`),c.ok(!this._editors.has(r.id),`editor '${r.id}' already exists!`);const p=this._documents.get(i).value,f=new R.ExtHostTextEditor(r.id,this._extHostRpc.getProxy(T.MainContext.MainThreadTextEditors),this._logService,new u.Lazy(()=>p.document),r.selections.map(_.Selection.to),r.options,r.visibleRanges.map(s=>_.Range.to(s)),typeof r.editorPosition=="number"?_.ViewColumn.to(r.editorPosition):void 0);this._editors.set(r.id,f)}g.newActiveEditor!==void 0&&(c.ok(g.newActiveEditor===null||this._editors.has(g.newActiveEditor),`active editor '${g.newActiveEditor}' does not exist`),this._activeEditorId=g.newActiveEditor),(0,w.dispose)(A),(0,w.dispose)(M),g.removedDocuments&&this._onDidRemoveDocuments.fire(A),g.addedDocuments&&this._onDidAddDocuments.fire(l),(g.removedEditors||g.addedEditors)&&this._onDidChangeVisibleTextEditors.fire(this.allEditors().map(r=>r.value)),g.newActiveEditor!==void 0&&this._onDidChangeActiveTextEditor.fire(this.activeEditor())}getDocument(g){return this._documents.get(g)?.value}allDocuments(){return d.Iterable.map(this._documents.values(),g=>g.value)}getEditor(g){return this._editors.get(g)}activeEditor(g){if(!this._activeEditorId)return;const A=this._editors.get(this._activeEditorId);return g?A:A?.value}allEditors(){return[...this._editors.values()]}};b=Ue([$e(0,k.IExtHostRpcService),$e(1,n.ILogService)],b),e.ExtHostDocumentsAndEditors=b,e.IExtHostDocumentsAndEditors=(0,t.createDecorator)("IExtHostDocumentsAndEditors")}),define(Ee[70],_e([0,1,8,5,2,3,4,13,14]),function(re,e,c,F,w,P,t,T,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostEditorTabs=e.IExtHostEditorTabs=void 0,e.IExtHostEditorTabs=(0,t.createDecorator)("IExtHostEditorTabs");let k=class{constructor(_){this._onDidChangeTabs=new P.Emitter,this.onDidChangeTabs=this._onDidChangeTabs.event,this._onDidChangeActiveTab=new P.Emitter,this.onDidChangeActiveTab=this._onDidChangeActiveTab.event,this._tabs=[],this._proxy=_.getProxy(F.MainContext.MainThreadEditorTabs)}get tabs(){return this._tabs}get activeTab(){return this._activeTab}$acceptEditorTabs(_){let n=-1;this._tabs=_.map((o,d)=>(o.isActive&&(n=d),Object.freeze({label:o.label,viewColumn:c.ViewColumn.to(o.viewColumn),index:d,resource:w.URI.revive(o.resource),additionalResourcesAndViewIds:o.additionalResourcesAndViewIds.map(({resource:u,viewId:S})=>({resource:w.URI.revive(u),viewId:S})),viewId:o.editorId,isActive:o.isActive,move:async(u,S)=>{this._proxy.$moveTab(o,u,c.ViewColumn.from(S)),await(0,C.raceTimeout)(P.Event.toPromise(this._onDidChangeTabs.event),1e3)},close:async()=>{await this._proxy.$closeTab(o),await(0,C.raceTimeout)(P.Event.toPromise(this._onDidChangeTabs.event),1e3)}}))),this._tabs=this._tabs.sort((o,d)=>o.viewColumn===d.viewColumn?o.index-d.index:o.viewColumn-d.viewColumn);const m=this._activeTab;this._activeTab=n===-1?void 0:this._tabs[n],this._activeTab!==m&&this._onDidChangeActiveTab.fire(this._activeTab),this._onDidChangeTabs.fire(this._tabs)}};k=Ue([$e(0,T.IExtHostRpcService)],k),e.ExtHostEditorTabs=k}),define(Ee[186],_e([0,1,2,5,6,7,8,228,9,22,27]),function(re,e,c,F,w,P,t,T,C,k,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostFileSystem=void 0;class _{constructor(){this._schemes=[]}add(o){this._stateMachine=void 0,this._schemes.push(o)}delete(o){const d=this._schemes.indexOf(o);d>=0&&(this._schemes.splice(d,1),this._stateMachine=void 0)}_initStateMachine(){if(!this._stateMachine){const o=this._schemes.sort(),d=[];let u,S,b=14,h=14;for(const g of o){let A=u?(0,C.commonPrefixLength)(u,g):0;for(A===0?S=1:S=h;A<g.length;A++)A+1===g.length?(b=h,h=9):h+=1,d.push([S,g.toUpperCase().charCodeAt(A),h]),d.push([S,g.toLowerCase().charCodeAt(A),h]),S=h;u=g,h=b}d.push([9,58,10]),d.push([10,47,12]),this._stateMachine=new T.StateMachine(d)}}provideDocumentLinks(o){this._initStateMachine();const d=[],u=T.LinkComputer.computeLinks({getLineContent(S){return o.lineAt(S-1).text},getLineCount(){return o.lineCount}},this._stateMachine);for(const S of u){const b=t.DocumentLink.to(S);b.target&&d.push(b)}return d}}class n{constructor(o,d){this._extHostLanguageFeatures=d,this._linkProvider=new _,this._fsProvider=new Map,this._registeredSchemes=new Set,this._watches=new Map,this._handlePool=0,this._proxy=o.getProxy(F.MainContext.MainThreadFileSystem)}dispose(){this._linkProviderRegistration?.dispose()}_registerLinkProviderIfNotYetRegistered(){this._linkProviderRegistration||(this._linkProviderRegistration=this._extHostLanguageFeatures.registerDocumentLinkProvider(void 0,"*",this._linkProvider))}registerFileSystemProvider(o,d,u,S={}){if(this._registeredSchemes.has(d))throw new Error(`a provider for the scheme '${d}' is already registered`);this._registerLinkProviderIfNotYetRegistered();const b=this._handlePool++;this._linkProvider.add(d),this._registeredSchemes.add(d),this._fsProvider.set(b,u);let h=2;S.isCaseSensitive&&(h+=1024),S.isReadonly&&(h+=2048),typeof u.copy=="function"&&(h+=8),typeof u.open=="function"&&typeof u.close=="function"&&typeof u.read=="function"&&typeof u.write=="function"&&((0,R.checkProposedApiEnabled)(o,"fsChunks"),h+=4),this._proxy.$registerFileSystemProvider(b,d,h).catch(A=>{console.error(`FAILED to register filesystem provider of ${o.identifier.value}-extension for the scheme ${d}`),console.error(A)});const g=u.onDidChangeFile(A=>{const l=[];for(const M of A){let{uri:r,type:i}=M;if(r.scheme!==d)continue;let p;switch(i){case P.FileChangeType.Changed:p=0;break;case P.FileChangeType.Created:p=1;break;case P.FileChangeType.Deleted:p=2;break;default:throw new Error("Unknown FileChangeType")}l.push({resource:r,type:p})}this._proxy.$onFileSystemChange(b,l)});return(0,w.toDisposable)(()=>{g.dispose(),this._linkProvider.delete(d),this._registeredSchemes.delete(d),this._fsProvider.delete(b),this._proxy.$unregisterProvider(b)})}static _asIStat(o){const{type:d,ctime:u,mtime:S,size:b,permissions:h}=o;return{type:d,ctime:u,mtime:S,size:b,permissions:h}}$stat(o,d){return Promise.resolve(this._getFsProvider(o).stat(c.URI.revive(d))).then(u=>n._asIStat(u))}$readdir(o,d){return Promise.resolve(this._getFsProvider(o).readDirectory(c.URI.revive(d)))}$readFile(o,d){return Promise.resolve(this._getFsProvider(o).readFile(c.URI.revive(d))).then(u=>k.VSBuffer.wrap(u))}$writeFile(o,d,u,S){return Promise.resolve(this._getFsProvider(o).writeFile(c.URI.revive(d),u.buffer,S))}$delete(o,d,u){return Promise.resolve(this._getFsProvider(o).delete(c.URI.revive(d),u))}$rename(o,d,u,S){return Promise.resolve(this._getFsProvider(o).rename(c.URI.revive(d),c.URI.revive(u),S))}$copy(o,d,u,S){const b=this._getFsProvider(o);if(!b.copy)throw new Error('FileSystemProvider does not implement "copy"');return Promise.resolve(b.copy(c.URI.revive(d),c.URI.revive(u),S))}$mkdir(o,d){return Promise.resolve(this._getFsProvider(o).createDirectory(c.URI.revive(d)))}$watch(o,d,u,S){const b=this._getFsProvider(o).watch(c.URI.revive(u),S);this._watches.set(d,b)}$unwatch(o,d){const u=this._watches.get(d);u&&(u.dispose(),this._watches.delete(d))}$open(o,d,u){const S=this._getFsProvider(o);if(!S.open)throw new Error('FileSystemProvider does not implement "open"');return Promise.resolve(S.open(c.URI.revive(d),u))}$close(o,d){const u=this._getFsProvider(o);if(!u.close)throw new Error('FileSystemProvider does not implement "close"');return Promise.resolve(u.close(d))}$read(o,d,u,S){const b=this._getFsProvider(o);if(!b.read)throw new Error('FileSystemProvider does not implement "read"');const h=k.VSBuffer.alloc(S);return Promise.resolve(b.read(d,u,h.buffer,0,S)).then(g=>h.slice(0,g))}$write(o,d,u,S){const b=this._getFsProvider(o);if(!b.write)throw new Error('FileSystemProvider does not implement "write"');return Promise.resolve(b.write(d,u,S.buffer,0,S.byteLength))}_getFsProvider(o){const d=this._fsProvider.get(o);if(!d){const u=new Error;throw u.name="ENOPRO",u.message="no provider",u}return d}}e.ExtHostFileSystem=n}),define(Ee[49],_e([0,1,5,45,7,22,4,13,30,6]),function(re,e,c,F,w,P,t,T,C,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostConsumerFileSystem=e.ExtHostConsumerFileSystem=void 0;let R=class Wt{constructor(n,m){this._fileSystemProvider=new Map,this._proxy=n.getProxy(c.MainContext.MainThreadFileSystem);const o=this;this.value=Object.freeze({async stat(d){try{const u=o._fileSystemProvider.get(d.scheme);if(!u)return await o._proxy.$stat(d);await o._proxy.$ensureActivation(d.scheme);const S=await u.stat(d);return{type:S.type,ctime:S.ctime,mtime:S.mtime,size:S.size,permissions:S.permissions}}catch(u){Wt._handleError(u)}},async readDirectory(d){try{const u=o._fileSystemProvider.get(d.scheme);return u?(await o._proxy.$ensureActivation(d.scheme),(await u.readDirectory(d)).slice()):await o._proxy.$readdir(d)}catch(u){return Wt._handleError(u)}},async createDirectory(d){try{return await o._proxy.$mkdir(d)}catch(u){return Wt._handleError(u)}},async readFile(d){try{const u=o._fileSystemProvider.get(d.scheme);return u?(await o._proxy.$ensureActivation(d.scheme),(await u.readFile(d)).slice()):(await o._proxy.$readFile(d)).buffer}catch(u){return Wt._handleError(u)}},async writeFile(d,u){try{return await o._proxy.$writeFile(d,P.VSBuffer.wrap(u))}catch(S){return Wt._handleError(S)}},async delete(d,u){try{const S=o._fileSystemProvider.get(d.scheme);return S?(await o._proxy.$ensureActivation(d.scheme),await S.delete(d,{recursive:!1,...u})):await o._proxy.$delete(d,{recursive:!1,useTrash:!1,...u})}catch(S){return Wt._handleError(S)}},async rename(d,u,S){try{return await o._proxy.$rename(d,u,{overwrite:!1,...S})}catch(b){return Wt._handleError(b)}},async copy(d,u,S){try{return await o._proxy.$copy(d,u,{overwrite:!1,...S})}catch(b){return Wt._handleError(b)}},isWritableFileSystem(d){const u=m.getCapabilities(d);if(typeof u=="number")return!(u&2048)}})}static _handleError(n){if(n instanceof w.FileSystemError)throw n;if(!(n instanceof Error))throw new w.FileSystemError(String(n));if(n.name==="ENOPRO")throw w.FileSystemError.Unavailable(n.message);switch(n.name){case F.FileSystemProviderErrorCode.FileExists:throw w.FileSystemError.FileExists(n.message);case F.FileSystemProviderErrorCode.FileNotFound:throw w.FileSystemError.FileNotFound(n.message);case F.FileSystemProviderErrorCode.FileNotADirectory:throw w.FileSystemError.FileNotADirectory(n.message);case F.FileSystemProviderErrorCode.FileIsADirectory:throw w.FileSystemError.FileIsADirectory(n.message);case F.FileSystemProviderErrorCode.NoPermissions:throw w.FileSystemError.NoPermissions(n.message);case F.FileSystemProviderErrorCode.Unavailable:throw w.FileSystemError.Unavailable(n.message);default:throw new w.FileSystemError(n.message,n.name)}}addFileSystemProvider(n,m){return this._fileSystemProvider.set(n,m),(0,k.toDisposable)(()=>this._fileSystemProvider.delete(n))}};R=Ue([$e(0,T.IExtHostRpcService),$e(1,C.IExtHostFileSystemInfo)],R),e.ExtHostConsumerFileSystem=R,e.IExtHostConsumerFileSystem=(0,t.createDecorator)("IExtHostConsumerFileSystem")}),define(Ee[187],_e([0,1,2,38]),function(re,e,c,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostInteractive=void 0;class w{constructor(t,T,C,k){this._extHostNotebooks=T,this._textDocumentsAndEditors=C,this._commands=k;const R=new F.ApiCommand("interactive.open","_interactive.open","Open interactive window and return notebook editor and input URI",[new F.ApiCommandArgument("showOptions","Show Options",_=>!0,_=>_),new F.ApiCommandArgument("resource","Interactive resource Uri",_=>!0,_=>_),new F.ApiCommandArgument("controllerId","Notebook controller Id",_=>!0,_=>_),new F.ApiCommandArgument("title","Interactive editor title",_=>!0,_=>_)],new F.ApiCommandResult("Notebook and input URI",_=>{if(_.notebookEditorId!==void 0){const n=this._extHostNotebooks.getEditorById(_.notebookEditorId);return{notebookUri:c.URI.revive(_.notebookUri),inputUri:c.URI.revive(_.inputUri),notebookEditor:n.apiEditor}}return{notebookUri:c.URI.revive(_.notebookUri),inputUri:c.URI.revive(_.inputUri)}}));this._commands.registerApiCommand(R)}$willAddInteractiveDocument(t,T,C,k){this._textDocumentsAndEditors.acceptDocumentsAndEditorsDelta({addedDocuments:[{EOL:T,lines:[""],languageId:C,uri:t,isDirty:!1,versionId:1,notebook:this._extHostNotebooks.getNotebookDocument(c.URI.revive(k))?.apiNotebook}]})}$willRemoveInteractiveDocument(t,T){this._textDocumentsAndEditors.acceptDocumentsAndEditorsDelta({removedDocuments:[t]})}}e.ExtHostInteractive=w}),define(Ee[188],_e([0,1,6,5]),function(re,e,c,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLabelService=void 0;class w{constructor(t){this._handlePool=0,this._proxy=t.getProxy(F.MainContext.MainThreadLabelService)}$registerResourceLabelFormatter(t){const T=this._handlePool++;return this._proxy.$registerResourceLabelFormatter(T,t),(0,c.toDisposable)(()=>{this._proxy.$unregisterResourceLabelFormatter(T)})}}e.ExtHostLabelService=w}),define(Ee[189],_e([0,1,2,26,8,7,5,9,59,16,11,229,6,79,52,63,190,15,3]),function(re,e,c,F,w,P,t,T,C,k,R,_,n,m,o,d,u,S,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLanguageFeatures=e.InlineCompletionController=e.DocumentRangeSemanticTokensAdapter=e.DocumentSemanticTokensAdapter=void 0;class h{constructor($,G){this._documents=$,this._provider=G}async provideDocumentSymbols($,G){const J=this._documents.getDocument($),ae=await this._provider.provideDocumentSymbols(J,G);if(!(0,k.isFalsyOrEmpty)(ae))return ae[0]instanceof P.DocumentSymbol?ae.map(w.DocumentSymbol.from):h._asDocumentSymbolTree(ae)}static _asDocumentSymbolTree($){$=$.slice(0).sort((ae,j)=>{let te=ae.location.range.start.compareTo(j.location.range.start);return te===0&&(te=j.location.range.end.compareTo(ae.location.range.end)),te});const G=[],J=[];for(const ae of $){const j={name:ae.name||"!!MISSING: name!!",kind:w.SymbolKind.from(ae.kind),tags:ae.tags?.map(w.SymbolTag.from)||[],detail:"",containerName:ae.containerName,range:w.Range.from(ae.location.range),selectionRange:w.Range.from(ae.location.range),children:[]};for(;;){if(J.length===0){J.push(j),G.push(j);break}const te=J[J.length-1];if(C.Range.containsRange(te.range,j.range)&&!C.Range.equalsRange(te.range,j.range)){te.children&&te.children.push(j),J.push(j);break}J.pop()}}return G}}class g{constructor($,G,J){this._documents=$,this._commands=G,this._provider=J,this._cache=new d.Cache("CodeLens"),this._disposables=new Map}async provideCodeLenses($,G){const J=this._documents.getDocument($),ae=await this._provider.provideCodeLenses(J,G);if(!ae||G.isCancellationRequested)return;const j=this._cache.add(ae),te=new n.DisposableStore;this._disposables.set(j,te);const me={cacheId:j,lenses:[]};for(let Pe=0;Pe<ae.length;Pe++)me.lenses.push({cacheId:[j,Pe],range:w.Range.from(ae[Pe].range),command:this._commands.toInternal(ae[Pe].command,te)});return me}async resolveCodeLens($,G){const J=$.cacheId&&this._cache.get(...$.cacheId);if(!J)return;let ae;if(typeof this._provider.resolveCodeLens!="function"||J.isResolved?ae=J:ae=await this._provider.resolveCodeLens(J,G),ae||(ae=J),G.isCancellationRequested)return;const j=$.cacheId&&this._disposables.get($.cacheId[0]);if(!!j)return $.command=this._commands.toInternal(ae.command??g._badCmd,j),$}releaseCodeLenses($){this._disposables.get($)?.dispose(),this._disposables.delete($),this._cache.delete($)}}g._badCmd={command:"missing",title:"!!MISSING: command!!"};function A(Xe){return Array.isArray(Xe)?Xe.map(w.DefinitionLink.from):Xe?[w.DefinitionLink.from(Xe)]:[]}class l{constructor($,G){this._documents=$,this._provider=G}async provideDefinition($,G,J){const ae=this._documents.getDocument($),j=w.Position.to(G),te=await this._provider.provideDefinition(ae,j,J);return A(te)}}class M{constructor($,G){this._documents=$,this._provider=G}async provideDeclaration($,G,J){const ae=this._documents.getDocument($),j=w.Position.to(G),te=await this._provider.provideDeclaration(ae,j,J);return A(te)}}class r{constructor($,G){this._documents=$,this._provider=G}async provideImplementation($,G,J){const ae=this._documents.getDocument($),j=w.Position.to(G),te=await this._provider.provideImplementation(ae,j,J);return A(te)}}class i{constructor($,G){this._documents=$,this._provider=G}async provideTypeDefinition($,G,J){const ae=this._documents.getDocument($),j=w.Position.to(G),te=await this._provider.provideTypeDefinition(ae,j,J);return A(te)}}class p{constructor($,G){this._documents=$,this._provider=G}async provideHover($,G,J){const ae=this._documents.getDocument($),j=w.Position.to(G),te=await this._provider.provideHover(ae,j,J);if(!(!te||(0,k.isFalsyOrEmpty)(te.contents)))return te.range||(te.range=ae.getWordRangeAtPosition(j)),te.range||(te.range=new P.Range(j,j)),w.Hover.from(te)}}class f{constructor($,G){this._documents=$,this._provider=G}async provideEvaluatableExpression($,G,J){const ae=this._documents.getDocument($),j=w.Position.to(G),te=await this._provider.provideEvaluatableExpression(ae,j,J);if(te)return w.EvaluatableExpression.from(te)}}class s{constructor($,G){this._documents=$,this._provider=G}async provideInlineValues($,G,J,ae){const j=this._documents.getDocument($),te=await this._provider.provideInlineValues(j,w.Range.to(G),w.InlineValueContext.to(J),ae);if(Array.isArray(te))return te.map(me=>w.InlineValue.from(me))}}class v{constructor($,G){this._documents=$,this._provider=G}async provideDocumentHighlights($,G,J){const ae=this._documents.getDocument($),j=w.Position.to(G),te=await this._provider.provideDocumentHighlights(ae,j,J);if(Array.isArray(te))return te.map(w.DocumentHighlight.from)}}class a{constructor($,G){this._documents=$,this._provider=G}async provideLinkedEditingRanges($,G,J){const ae=this._documents.getDocument($),j=w.Position.to(G),te=await this._provider.provideLinkedEditingRanges(ae,j,J);if(te&&Array.isArray(te.ranges))return{ranges:(0,k.coalesce)(te.ranges.map(w.Range.from)),wordPattern:te.wordPattern}}}class E{constructor($,G){this._documents=$,this._provider=G}async provideReferences($,G,J,ae){const j=this._documents.getDocument($),te=w.Position.to(G),me=await this._provider.provideReferences(j,te,J,ae);if(Array.isArray(me))return me.map(w.location.from)}}class I{constructor($,G,J,ae,j,te,me){this._documents=$,this._commands=G,this._diagnostics=J,this._provider=ae,this._logService=j,this._extension=te,this._apiDeprecation=me,this._cache=new d.Cache("CodeAction"),this._disposables=new Map}async provideCodeActions($,G,J,ae){const j=this._documents.getDocument($),te=_.Selection.isISelection(G)?w.Selection.to(G):w.Range.to(G),me=[];for(const st of this._diagnostics.getDiagnostics($))if(te.intersection(st.range)&&me.push(st)>I._maxCodeActionsPerFile)break;const Pe={diagnostics:me,only:J.only?new P.CodeActionKind(J.only):void 0,triggerKind:w.CodeActionTriggerKind.to(J.trigger)},Ne=await this._provider.provideCodeActions(j,te,Pe,ae);if(!(0,k.isNonEmptyArray)(Ne)||ae.isCancellationRequested)return;const He=this._cache.add(Ne),Ye=new n.DisposableStore;this._disposables.set(He,Ye);const et=[];for(let st=0;st<Ne.length;st++){const Je=Ne[st];!Je||(I._isCommand(Je)?(this._apiDeprecation.report("CodeActionProvider.provideCodeActions - return commands",this._extension,"Return 'CodeAction' instances instead."),et.push({_isSynthetic:!0,title:Je.title,command:this._commands.toInternal(Je,Ye)})):(Pe.only&&(Je.kind?Pe.only.contains(Je.kind)||this._logService.warn(`${this._extension.identifier.value} - Code actions of kind '${Pe.only.value} 'requested but returned code action is of kind '${Je.kind.value}'. Code action will be dropped. Please check 'CodeActionContext.only' to only return requested code actions.`):this._logService.warn(`${this._extension.identifier.value} - Code actions of kind '${Pe.only.value} 'requested but returned code action does not have a 'kind'. Code action will be dropped. Please set 'CodeAction.kind'.`)),et.push({cacheId:[He,st],title:Je.title,command:Je.command&&this._commands.toInternal(Je.command,Ye),diagnostics:Je.diagnostics&&Je.diagnostics.map(w.Diagnostic.from),edit:Je.edit&&w.WorkspaceEdit.from(Je.edit),kind:Je.kind&&Je.kind.value,isPreferred:Je.isPreferred,disabled:Je.disabled?.reason})))}return{cacheId:He,actions:et}}async resolveCodeAction($,G){const[J,ae]=$,j=this._cache.get(J,ae);if(!j||I._isCommand(j)||!this._provider.resolveCodeAction)return;const te=await this._provider.resolveCodeAction(j,G)??j;return te?.edit?w.WorkspaceEdit.from(te.edit):void 0}releaseCodeActions($){this._disposables.get($)?.dispose(),this._disposables.delete($),this._cache.delete($)}static _isCommand($){return typeof $.command=="string"&&typeof $.title=="string"}}I._maxCodeActionsPerFile=1e3;class D{constructor($,G){this._documents=$,this._provider=G}async provideDocumentFormattingEdits($,G,J){const ae=this._documents.getDocument($),j=await this._provider.provideDocumentFormattingEdits(ae,G,J);if(Array.isArray(j))return j.map(w.TextEdit.from)}}class B{constructor($,G){this._documents=$,this._provider=G}async provideDocumentRangeFormattingEdits($,G,J,ae){const j=this._documents.getDocument($),te=w.Range.to(G),me=await this._provider.provideDocumentRangeFormattingEdits(j,te,J,ae);if(Array.isArray(me))return me.map(w.TextEdit.from)}}class L{constructor($,G){this._documents=$,this._provider=G,this.autoFormatTriggerCharacters=[]}async provideOnTypeFormattingEdits($,G,J,ae,j){const te=this._documents.getDocument($),me=w.Position.to(G),Pe=await this._provider.provideOnTypeFormattingEdits(te,me,J,ae,j);if(Array.isArray(Pe))return Pe.map(w.TextEdit.from)}}class y{constructor($,G){this._provider=$,this._logService=G,this._symbolCache=new Map,this._resultCache=new Map}async provideWorkspaceSymbols($,G){const J=t.IdObject.mixin({symbols:[]}),ae=await this._provider.provideWorkspaceSymbols($,G);if((0,k.isNonEmptyArray)(ae))for(const j of ae){if(!j)continue;if(!j.name){this._logService.warn("INVALID SymbolInformation, lacks name",j);continue}const te=t.IdObject.mixin(w.WorkspaceSymbol.from(j));this._symbolCache.set(te._id,j),J.symbols.push(te)}return J.symbols.length>0&&this._resultCache.set(J._id,[J.symbols[0]._id,J.symbols[J.symbols.length-1]._id]),J}async resolveWorkspaceSymbol($,G){if(typeof this._provider.resolveWorkspaceSymbol!="function")return $;const J=this._symbolCache.get($._id);if(J){const ae=await this._provider.resolveWorkspaceSymbol(J,G);return ae&&(0,F.mixin)($,w.WorkspaceSymbol.from(ae),!0)}}releaseWorkspaceSymbols($){const G=this._resultCache.get($);if(G){for(let[J,ae]=G;J<=ae;J++)this._symbolCache.delete(J);this._resultCache.delete($)}}}class x{constructor($,G,J){this._documents=$,this._provider=G,this._logService=J}static supportsResolving($){return typeof $.prepareRename=="function"}async provideRenameEdits($,G,J,ae){const j=this._documents.getDocument($),te=w.Position.to(G);try{const me=await this._provider.provideRenameEdits(j,te,J,ae);return me?w.WorkspaceEdit.from(me):void 0}catch(me){const Pe=x._asMessage(me);return Pe?{rejectReason:Pe,edits:void 0}:Promise.reject(me)}}async resolveRenameLocation($,G,J){if(typeof this._provider.prepareRename!="function")return Promise.resolve(void 0);const ae=this._documents.getDocument($),j=w.Position.to(G);try{const te=await this._provider.prepareRename(ae,j,J);let me,Pe;if(P.Range.isRange(te)?(me=te,Pe=ae.getText(te)):(0,R.isObject)(te)&&(me=te.range,Pe=te.placeholder),!me||!Pe)return;if(me.start.line>j.line||me.end.line<j.line){this._logService.warn("INVALID rename location: position line must be within range start/end lines");return}return{range:w.Range.from(me),text:Pe}}catch(te){const me=x._asMessage(te);return me?{rejectReason:me,range:void 0,text:void 0}:Promise.reject(te)}}static _asMessage($){return typeof $=="string"?$:$ instanceof Error&&typeof $.message=="string"?$.message:void 0}}class N{constructor($,G){this.resultId=$,this.tokens=G}}class z{constructor($,G){this._documents=$,this._provider=G,this._nextResultId=1,this._previousResults=new Map}async provideDocumentSemanticTokens($,G,J){const ae=this._documents.getDocument($),j=G!==0?this._previousResults.get(G):null;let te=typeof j?.resultId=="string"&&typeof this._provider.provideDocumentSemanticTokensEdits=="function"?await this._provider.provideDocumentSemanticTokensEdits(ae,j.resultId,J):await this._provider.provideDocumentSemanticTokens(ae,J);return j&&this._previousResults.delete(G),te?(te=z._fixProvidedSemanticTokens(te),this._send(z._convertToEdits(j,te),te)):null}async releaseDocumentSemanticColoring($){this._previousResults.delete($)}static _fixProvidedSemanticTokens($){return z._isSemanticTokens($)?z._isCorrectSemanticTokens($)?$:new P.SemanticTokens(new Uint32Array($.data),$.resultId):z._isSemanticTokensEdits($)?z._isCorrectSemanticTokensEdits($)?$:new P.SemanticTokensEdits($.edits.map(G=>new P.SemanticTokensEdit(G.start,G.deleteCount,G.data?new Uint32Array(G.data):G.data)),$.resultId):$}static _isSemanticTokens($){return $&&!!$.data}static _isCorrectSemanticTokens($){return $.data instanceof Uint32Array}static _isSemanticTokensEdits($){return $&&Array.isArray($.edits)}static _isCorrectSemanticTokensEdits($){for(const G of $.edits)if(!(G.data instanceof Uint32Array))return!1;return!0}static _convertToEdits($,G){if(!z._isSemanticTokens(G)||!$||!$.tokens)return G;const J=$.tokens,ae=J.length,j=G.data,te=j.length;let me=0;const Pe=Math.min(ae,te);for(;me<Pe&&J[me]===j[me];)me++;if(me===ae&&me===te)return new P.SemanticTokensEdits([],G.resultId);let Ne=0;const He=Pe-me;for(;Ne<He&&J[ae-Ne-1]===j[te-Ne-1];)Ne++;return new P.SemanticTokensEdits([{start:me,deleteCount:ae-me-Ne,data:j.subarray(me,te-Ne)}],G.resultId)}_send($,G){if(z._isSemanticTokens($)){const J=this._nextResultId++;return this._previousResults.set(J,new N($.resultId,$.data)),(0,m.encodeSemanticTokensDto)({id:J,type:"full",data:$.data})}if(z._isSemanticTokensEdits($)){const J=this._nextResultId++;return z._isSemanticTokens(G)?this._previousResults.set(J,new N(G.resultId,G.data)):this._previousResults.set(J,new N($.resultId)),(0,m.encodeSemanticTokensDto)({id:J,type:"delta",deltas:($.edits||[]).map(ae=>({start:ae.start,deleteCount:ae.deleteCount,data:ae.data}))})}return null}}e.DocumentSemanticTokensAdapter=z;class H{constructor($,G){this._documents=$,this._provider=G}async provideDocumentRangeSemanticTokens($,G,J){const ae=this._documents.getDocument($),j=await this._provider.provideDocumentRangeSemanticTokens(ae,w.Range.to(G),J);return j?this._send(j):null}_send($){return(0,m.encodeSemanticTokensDto)({id:0,type:"full",data:$.data})}}e.DocumentRangeSemanticTokensAdapter=H;class q{constructor($,G,J,ae,j){this._documents=$,this._commands=G,this._provider=J,this._apiDeprecation=ae,this._extension=j,this._cache=new d.Cache("CompletionItem"),this._disposables=new Map}static supportsResolving($){return typeof $.resolveCompletionItem=="function"}async provideCompletionItems($,G,J,ae){const j=this._documents.getDocument($),te=w.Position.to(G),me=j.getWordRangeAtPosition(te)||new P.Range(te,te),Pe=me.with({end:te}),Ne=new u.StopWatch(!0),He=await this._provider.provideCompletionItems(j,te,ae,w.CompletionContext.to(J));if(!He||ae.isCancellationRequested)return;const Ye=Array.isArray(He)?new P.CompletionList(He):He,et=q.supportsResolving(this._provider)?this._cache.add(Ye.items):this._cache.add([]),st=new n.DisposableStore;this._disposables.set(et,st);const Je=[],nt={x:et,b:Je,a:{replace:w.Range.from(me),insert:w.Range.from(Pe)},c:Ye.isIncomplete||void 0,d:Ne.elapsed()};for(let ct=0;ct<Ye.items.length;ct++){const pt=Ye.items[ct],Ft=this._convertCompletionItem(pt,[et,ct],Pe,me);Je.push(Ft)}return nt}async resolveCompletionItem($,G){if(typeof this._provider.resolveCompletionItem!="function")return;const J=this._cache.get(...$);if(!J)return;const ae=await this._provider.resolveCompletionItem(J,G);if(!!ae)return this._convertCompletionItem(ae,$)}releaseCompletionItems($){this._disposables.get($)?.dispose(),this._disposables.delete($),this._cache.delete($)}_convertCompletionItem($,G,J,ae){const j=this._disposables.get(G[0]);if(!j)throw Error("DisposableStore is missing...");const te={x:G,a:$.label,b:$.kind!==void 0?w.CompletionItemKind.from($.kind):void 0,n:$.tags&&$.tags.map(w.CompletionItemTag.from),c:$.detail,d:typeof $.documentation=="undefined"?void 0:w.MarkdownString.fromStrict($.documentation),e:$.sortText!==$.label?$.sortText:void 0,f:$.filterText!==$.label?$.filterText:void 0,g:$.preselect||void 0,i:$.keepWhitespace?1:0,k:$.commitCharacters,l:$.additionalTextEdits&&$.additionalTextEdits.map(w.TextEdit.from),m:this._commands.toInternal($.command,j)};$.textEdit?(this._apiDeprecation.report("CompletionItem.textEdit",this._extension,"Use 'CompletionItem.insertText' and 'CompletionItem.range' instead."),te.h=$.textEdit.newText):typeof $.insertText=="string"?te.h=$.insertText:$.insertText instanceof P.SnippetString&&(te.h=$.insertText.value,te.i|=4);let me;return $.textEdit?me=$.textEdit.range:$.range&&(me=$.range),P.Range.isRange(me)?te.j=w.Range.from(me):me&&(!J?.isEqual(me.inserting)||!ae?.isEqual(me.replacing))&&(te.j={insert:w.Range.from(me.inserting),replace:w.Range.from(me.replacing)}),te}}class ue{constructor($,G,J){this._documents=$,this._provider=G,this._commands=J,this._cache=new d.Cache("InlineCompletionItem"),this._disposables=new Map}async provideInlineCompletions($,G,J,ae){const j=this._documents.getDocument($),te=w.Position.to(G),me=await this._provider.provideInlineCompletionItems(j,te,{selectedCompletionInfo:J.selectedSuggestionInfo?{range:w.Range.to(J.selectedSuggestionInfo.range),text:J.selectedSuggestionInfo.text,isSnippetText:J.selectedSuggestionInfo.isSnippetText,completionKind:w.CompletionItemKind.to(J.selectedSuggestionInfo.completionKind)}:void 0,triggerKind:J.triggerKind},ae);if(!me||ae.isCancellationRequested)return;const Pe=(0,R.isArray)(me)?{items:me}:me,Ne=this._cache.add(Pe.items);let He;return{pid:Ne,items:Pe.items.map((Ye,et)=>{let st;return Ye.command&&(He||(He=new n.DisposableStore,this._disposables.set(Ne,He)),st=this._commands.toInternal(Ye.command,He)),{text:Ye.text,range:Ye.range?w.Range.from(Ye.range):void 0,command:st,idx:et}})}}disposeCompletions($){this._cache.delete($);const G=this._disposables.get($);G&&G.clear(),this._disposables.delete($)}handleDidShowCompletionItem($,G){const J=this._cache.get($,G);J&&K.get(this._provider).fireOnDidShowCompletionItem({completionItem:J})}}class K{constructor(){this._onDidShowCompletionItemEmitter=new b.Emitter,this.onDidShowCompletionItem=this._onDidShowCompletionItemEmitter.event}static get($){let G=K.map.get($);return G||(G=new K,K.map.set($,G)),G}fireOnDidShowCompletionItem($){this._onDidShowCompletionItemEmitter.fire($)}}e.InlineCompletionController=K,K.map=new WeakMap;class ce{constructor($,G){this._documents=$,this._provider=G,this._cache=new d.Cache("SignatureHelp")}async provideSignatureHelp($,G,J,ae){const j=this._documents.getDocument($),te=w.Position.to(G),me=this.reviveContext(J),Pe=await this._provider.provideSignatureHelp(j,te,ae,me);if(Pe){const Ne=this._cache.add([Pe]);return{...w.SignatureHelp.from(Pe),id:Ne}}}reviveContext($){let G;if($.activeSignatureHelp){const J=w.SignatureHelp.to($.activeSignatureHelp),ae=this._cache.get($.activeSignatureHelp.id,0);ae?(G=ae,G.activeSignature=J.activeSignature,G.activeParameter=J.activeParameter):G=J}return{...$,activeSignatureHelp:G}}releaseSignatureHelp($){this._cache.delete($)}}class de{constructor($,G){this._documents=$,this._provider=G}async provideInlayHints($,G,J){const ae=this._documents.getDocument($),j=await this._provider.provideInlayHints(ae,w.Range.to(G),J);return j?{hints:j.map(w.InlayHint.from)}:void 0}}class Y{constructor($,G){this._documents=$,this._provider=G,this._cache=new d.Cache("DocumentLink")}async provideLinks($,G){const J=this._documents.getDocument($),ae=await this._provider.provideDocumentLinks(J,G);if(!(!Array.isArray(ae)||ae.length===0)&&!G.isCancellationRequested){if(typeof this._provider.resolveDocumentLink!="function")return{links:ae.filter(Y._validateLink).map(w.DocumentLink.from)};{const j=this._cache.add(ae),te={links:[],id:j};for(let me=0;me<ae.length;me++){if(!Y._validateLink(ae[me]))continue;const Pe=w.DocumentLink.from(ae[me]);Pe.cacheId=[j,me],te.links.push(Pe)}return te}}}static _validateLink($){return $.target&&$.target.path.length>5e4?(console.warn("DROPPING link because it is too long"),!1):!0}async resolveLink($,G){if(typeof this._provider.resolveDocumentLink!="function")return;const J=this._cache.get(...$);if(!J)return;const ae=await this._provider.resolveDocumentLink(J,G);if(!(!ae||!Y._validateLink(ae)))return w.DocumentLink.from(ae)}releaseLinks($){this._cache.delete($)}}class ie{constructor($,G){this._documents=$,this._provider=G}async provideColors($,G){const J=this._documents.getDocument($),ae=await this._provider.provideDocumentColors(J,G);return Array.isArray(ae)?ae.map(te=>({color:w.Color.from(te.color),range:w.Range.from(te.range)})):[]}async provideColorPresentations($,G,J){const ae=this._documents.getDocument($),j=w.Range.to(G.range),te=w.Color.to(G.color),me=await this._provider.provideColorPresentations(te,{document:ae,range:j},J);if(!!Array.isArray(me))return me.map(w.ColorPresentation.from)}}class we{constructor($,G){this._documents=$,this._provider=G}async provideFoldingRanges($,G,J){const ae=this._documents.getDocument($),j=await this._provider.provideFoldingRanges(ae,G,J);if(!!Array.isArray(j))return j.map(w.FoldingRange.from)}}class Me{constructor($,G,J){this._documents=$,this._provider=G,this._logService=J}async provideSelectionRanges($,G,J){const ae=this._documents.getDocument($),j=G.map(w.Position.to),te=await this._provider.provideSelectionRanges(ae,j,J);if(!(0,k.isNonEmptyArray)(te))return[];if(te.length!==j.length)return this._logService.warn("BAD selection ranges, provider must return ranges for each position"),[];const me=[];for(let Pe=0;Pe<j.length;Pe++){const Ne=[];me.push(Ne);let He=j[Pe],Ye=te[Pe];for(;;){if(!Ye.range.contains(He))throw new Error("INVALID selection range, must contain the previous range");if(Ne.push(w.SelectionRange.from(Ye)),!Ye.parent)break;He=Ye.range,Ye=Ye.parent}}return me}}class Re{constructor($,G){this._documents=$,this._provider=G,this._idPool=new o.IdGenerator(""),this._cache=new Map}async prepareSession($,G,J){const ae=this._documents.getDocument($),j=w.Position.to(G),te=await this._provider.prepareCallHierarchy(ae,j,J);if(!te)return;const me=this._idPool.nextId();return this._cache.set(me,new Map),Array.isArray(te)?te.map(Pe=>this._cacheAndConvertItem(me,Pe)):[this._cacheAndConvertItem(me,te)]}async provideCallsTo($,G,J){const ae=this._itemFromCache($,G);if(!ae)throw new Error("missing call hierarchy item");const j=await this._provider.provideCallHierarchyIncomingCalls(ae,J);if(!!j)return j.map(te=>({from:this._cacheAndConvertItem($,te.from),fromRanges:te.fromRanges.map(me=>w.Range.from(me))}))}async provideCallsFrom($,G,J){const ae=this._itemFromCache($,G);if(!ae)throw new Error("missing call hierarchy item");const j=await this._provider.provideCallHierarchyOutgoingCalls(ae,J);if(!!j)return j.map(te=>({to:this._cacheAndConvertItem($,te.to),fromRanges:te.fromRanges.map(me=>w.Range.from(me))}))}releaseSession($){this._cache.delete($)}_cacheAndConvertItem($,G){const J=this._cache.get($),ae=w.CallHierarchyItem.from(G,$,J.size.toString(36));return J.set(ae._itemId,G),ae}_itemFromCache($,G){return this._cache.get($)?.get(G)}}class Be{constructor($,G){this._documents=$,this._provider=G,this._idPool=new o.IdGenerator(""),this._cache=new Map}async prepareSession($,G,J){const ae=this._documents.getDocument($),j=w.Position.to(G),te=await this._provider.prepareTypeHierarchy(ae,j,J);if(!te)return;const me=this._idPool.nextId();return this._cache.set(me,new Map),Array.isArray(te)?te.map(Pe=>this._cacheAndConvertItem(me,Pe)):[this._cacheAndConvertItem(me,te)]}async provideSupertypes($,G,J){const ae=this._itemFromCache($,G);if(!ae)throw new Error("missing type hierarchy item");const j=await this._provider.provideTypeHierarchySupertypes(ae,J);if(!!j)return j.map(te=>this._cacheAndConvertItem($,te))}async provideSubtypes($,G,J){const ae=this._itemFromCache($,G);if(!ae)throw new Error("missing type hierarchy item");const j=await this._provider.provideTypeHierarchySubtypes(ae,J);if(!!j)return j.map(te=>this._cacheAndConvertItem($,te))}releaseSession($){this._cache.delete($)}_cacheAndConvertItem($,G){const J=this._cache.get($),ae=w.TypeHierarchyItem.from(G,$,J.size.toString(36));return J.set(ae._itemId,G),ae}_itemFromCache($,G){return this._cache.get($)?.get(G)}}class Qe{constructor($,G){this.adapter=$,this.extension=G}}class Ge{constructor($,G,J,ae,j,te,me){this._adapter=new Map,this._uriTransformer=G,this._proxy=$.getProxy(t.MainContext.MainThreadLanguageFeatures),this._documents=J,this._commands=ae,this._diagnostics=j,this._logService=te,this._apiDeprecation=me}_transformDocumentSelector($){return w.DocumentSelector.from($,this._uriTransformer)}_createDisposable($){return new P.Disposable(()=>{this._adapter.delete($),this._proxy.$unregister($)})}_nextHandle(){return Ge._handlePool++}_withAdapter($,G,J,ae,j=!1){const te=this._adapter.get($);if(!te)return Promise.resolve(ae);if(te.adapter instanceof G){let me;te.extension&&(me=Date.now(),this._logService.trace(`[${te.extension.identifier.value}] INVOKE provider '${G.name}'`));const Pe=J(te.adapter,te.extension),Ne=te.extension;return Ne&&Promise.resolve(Pe).then(()=>this._logService.trace(`[${Ne.identifier.value}] provider DONE after ${Date.now()-me}ms`),He=>{j&&He instanceof S.CancellationError||(this._logService.error(`[${Ne.identifier.value}] provider FAILED`),this._logService.error(He))}),Pe}return Promise.reject(new Error("no adapter found"))}_addNewAdapter($,G){const J=this._nextHandle();return this._adapter.set(J,new Qe($,G)),J}static _extLabel($){return $.displayName||$.name}registerDocumentSymbolProvider($,G,J,ae){const j=this._addNewAdapter(new h(this._documents,J),$),te=ae&&ae.label||Ge._extLabel($);return this._proxy.$registerDocumentSymbolProvider(j,this._transformDocumentSelector(G),te),this._createDisposable(j)}$provideDocumentSymbols($,G,J){return this._withAdapter($,h,ae=>ae.provideDocumentSymbols(c.URI.revive(G),J),void 0)}registerCodeLensProvider($,G,J){const ae=this._nextHandle(),j=typeof J.onDidChangeCodeLenses=="function"?this._nextHandle():void 0;this._adapter.set(ae,new Qe(new g(this._documents,this._commands.converter,J),$)),this._proxy.$registerCodeLensSupport(ae,this._transformDocumentSelector(G),j);let te=this._createDisposable(ae);if(j!==void 0){const me=J.onDidChangeCodeLenses(Pe=>this._proxy.$emitCodeLensEvent(j));te=P.Disposable.from(te,me)}return te}$provideCodeLenses($,G,J){return this._withAdapter($,g,ae=>ae.provideCodeLenses(c.URI.revive(G),J),void 0)}$resolveCodeLens($,G,J){return this._withAdapter($,g,ae=>ae.resolveCodeLens(G,J),void 0)}$releaseCodeLenses($,G){this._withAdapter($,g,J=>Promise.resolve(J.releaseCodeLenses(G)),void 0)}registerDefinitionProvider($,G,J){const ae=this._addNewAdapter(new l(this._documents,J),$);return this._proxy.$registerDefinitionSupport(ae,this._transformDocumentSelector(G)),this._createDisposable(ae)}$provideDefinition($,G,J,ae){return this._withAdapter($,l,j=>j.provideDefinition(c.URI.revive(G),J,ae),[])}registerDeclarationProvider($,G,J){const ae=this._addNewAdapter(new M(this._documents,J),$);return this._proxy.$registerDeclarationSupport(ae,this._transformDocumentSelector(G)),this._createDisposable(ae)}$provideDeclaration($,G,J,ae){return this._withAdapter($,M,j=>j.provideDeclaration(c.URI.revive(G),J,ae),[])}registerImplementationProvider($,G,J){const ae=this._addNewAdapter(new r(this._documents,J),$);return this._proxy.$registerImplementationSupport(ae,this._transformDocumentSelector(G)),this._createDisposable(ae)}$provideImplementation($,G,J,ae){return this._withAdapter($,r,j=>j.provideImplementation(c.URI.revive(G),J,ae),[])}registerTypeDefinitionProvider($,G,J){const ae=this._addNewAdapter(new i(this._documents,J),$);return this._proxy.$registerTypeDefinitionSupport(ae,this._transformDocumentSelector(G)),this._createDisposable(ae)}$provideTypeDefinition($,G,J,ae){return this._withAdapter($,i,j=>j.provideTypeDefinition(c.URI.revive(G),J,ae),[])}registerHoverProvider($,G,J,ae){const j=this._addNewAdapter(new p(this._documents,J),$);return this._proxy.$registerHoverProvider(j,this._transformDocumentSelector(G)),this._createDisposable(j)}$provideHover($,G,J,ae){return this._withAdapter($,p,j=>j.provideHover(c.URI.revive(G),J,ae),void 0)}registerEvaluatableExpressionProvider($,G,J,ae){const j=this._addNewAdapter(new f(this._documents,J),$);return this._proxy.$registerEvaluatableExpressionProvider(j,this._transformDocumentSelector(G)),this._createDisposable(j)}$provideEvaluatableExpression($,G,J,ae){return this._withAdapter($,f,j=>j.provideEvaluatableExpression(c.URI.revive(G),J,ae),void 0)}registerInlineValuesProvider($,G,J,ae){const j=typeof J.onDidChangeInlineValues=="function"?this._nextHandle():void 0,te=this._addNewAdapter(new s(this._documents,J),$);this._proxy.$registerInlineValuesProvider(te,this._transformDocumentSelector(G),j);let me=this._createDisposable(te);if(j!==void 0){const Pe=J.onDidChangeInlineValues(Ne=>this._proxy.$emitInlineValuesEvent(j));me=P.Disposable.from(me,Pe)}return me}$provideInlineValues($,G,J,ae,j){return this._withAdapter($,s,te=>te.provideInlineValues(c.URI.revive(G),J,ae,j),void 0)}registerDocumentHighlightProvider($,G,J){const ae=this._addNewAdapter(new v(this._documents,J),$);return this._proxy.$registerDocumentHighlightProvider(ae,this._transformDocumentSelector(G)),this._createDisposable(ae)}$provideDocumentHighlights($,G,J,ae){return this._withAdapter($,v,j=>j.provideDocumentHighlights(c.URI.revive(G),J,ae),void 0)}registerLinkedEditingRangeProvider($,G,J){const ae=this._addNewAdapter(new a(this._documents,J),$);return this._proxy.$registerLinkedEditingRangeProvider(ae,this._transformDocumentSelector(G)),this._createDisposable(ae)}$provideLinkedEditingRanges($,G,J,ae){return this._withAdapter($,a,async j=>{const te=await j.provideLinkedEditingRanges(c.URI.revive(G),J,ae);if(te)return{ranges:te.ranges,wordPattern:te.wordPattern?Ge._serializeRegExp(te.wordPattern):void 0}},void 0)}registerReferenceProvider($,G,J){const ae=this._addNewAdapter(new E(this._documents,J),$);return this._proxy.$registerReferenceSupport(ae,this._transformDocumentSelector(G)),this._createDisposable(ae)}$provideReferences($,G,J,ae,j){return this._withAdapter($,E,te=>te.provideReferences(c.URI.revive(G),J,ae,j),void 0)}registerCodeActionProvider($,G,J,ae){const j=new n.DisposableStore,te=this._addNewAdapter(new I(this._documents,this._commands.converter,this._diagnostics,J,this._logService,$,this._apiDeprecation),$);return this._proxy.$registerQuickFixSupport(te,this._transformDocumentSelector(G),{providedKinds:ae?.providedCodeActionKinds?.map(me=>me.value),documentation:ae?.documentation?.map(me=>({kind:me.kind.value,command:this._commands.converter.toInternal(me.command,j)}))},Ge._extLabel($),Boolean(J.resolveCodeAction)),j.add(this._createDisposable(te)),j}$provideCodeActions($,G,J,ae,j){return this._withAdapter($,I,te=>te.provideCodeActions(c.URI.revive(G),J,ae,j),void 0)}$resolveCodeAction($,G,J){return this._withAdapter($,I,ae=>ae.resolveCodeAction(G,J),void 0)}$releaseCodeActions($,G){this._withAdapter($,I,J=>Promise.resolve(J.releaseCodeActions(G)),void 0)}registerDocumentFormattingEditProvider($,G,J){const ae=this._addNewAdapter(new D(this._documents,J),$);return this._proxy.$registerDocumentFormattingSupport(ae,this._transformDocumentSelector(G),$.identifier,$.displayName||$.name),this._createDisposable(ae)}$provideDocumentFormattingEdits($,G,J,ae){return this._withAdapter($,D,j=>j.provideDocumentFormattingEdits(c.URI.revive(G),J,ae),void 0)}registerDocumentRangeFormattingEditProvider($,G,J){const ae=this._addNewAdapter(new B(this._documents,J),$);return this._proxy.$registerRangeFormattingSupport(ae,this._transformDocumentSelector(G),$.identifier,$.displayName||$.name),this._createDisposable(ae)}$provideDocumentRangeFormattingEdits($,G,J,ae,j){return this._withAdapter($,B,te=>te.provideDocumentRangeFormattingEdits(c.URI.revive(G),J,ae,j),void 0)}registerOnTypeFormattingEditProvider($,G,J,ae){const j=this._addNewAdapter(new L(this._documents,J),$);return this._proxy.$registerOnTypeFormattingSupport(j,this._transformDocumentSelector(G),ae,$.identifier),this._createDisposable(j)}$provideOnTypeFormattingEdits($,G,J,ae,j,te){return this._withAdapter($,L,me=>me.provideOnTypeFormattingEdits(c.URI.revive(G),J,ae,j,te),void 0)}registerWorkspaceSymbolProvider($,G){const J=this._addNewAdapter(new y(G,this._logService),$);return this._proxy.$registerNavigateTypeSupport(J,typeof G.resolveWorkspaceSymbol=="function"),this._createDisposable(J)}$provideWorkspaceSymbols($,G,J){return this._withAdapter($,y,ae=>ae.provideWorkspaceSymbols(G,J),{symbols:[]})}$resolveWorkspaceSymbol($,G,J){return this._withAdapter($,y,ae=>ae.resolveWorkspaceSymbol(G,J),void 0)}$releaseWorkspaceSymbols($,G){this._withAdapter($,y,J=>J.releaseWorkspaceSymbols(G),void 0)}registerRenameProvider($,G,J){const ae=this._addNewAdapter(new x(this._documents,J,this._logService),$);return this._proxy.$registerRenameSupport(ae,this._transformDocumentSelector(G),x.supportsResolving(J)),this._createDisposable(ae)}$provideRenameEdits($,G,J,ae,j){return this._withAdapter($,x,te=>te.provideRenameEdits(c.URI.revive(G),J,ae,j),void 0)}$resolveRenameLocation($,G,J,ae){return this._withAdapter($,x,j=>j.resolveRenameLocation(c.URI.revive(G),J,ae),void 0)}registerDocumentSemanticTokensProvider($,G,J,ae){const j=this._nextHandle(),te=typeof J.onDidChangeSemanticTokens=="function"?this._nextHandle():void 0;this._adapter.set(j,new Qe(new z(this._documents,J),$)),this._proxy.$registerDocumentSemanticTokensProvider(j,this._transformDocumentSelector(G),ae,te);let me=this._createDisposable(j);if(te){const Pe=J.onDidChangeSemanticTokens(Ne=>this._proxy.$emitDocumentSemanticTokensEvent(te));me=P.Disposable.from(me,Pe)}return me}$provideDocumentSemanticTokens($,G,J,ae){return this._withAdapter($,z,j=>j.provideDocumentSemanticTokens(c.URI.revive(G),J,ae),null,!0)}$releaseDocumentSemanticTokens($,G){this._withAdapter($,z,J=>J.releaseDocumentSemanticColoring(G),void 0)}registerDocumentRangeSemanticTokensProvider($,G,J,ae){const j=this._addNewAdapter(new H(this._documents,J),$);return this._proxy.$registerDocumentRangeSemanticTokensProvider(j,this._transformDocumentSelector(G),ae),this._createDisposable(j)}$provideDocumentRangeSemanticTokens($,G,J,ae){return this._withAdapter($,H,j=>j.provideDocumentRangeSemanticTokens(c.URI.revive(G),J,ae),null,!0)}registerCompletionItemProvider($,G,J,ae){const j=this._addNewAdapter(new q(this._documents,this._commands.converter,J,this._apiDeprecation,$),$);return this._proxy.$registerSuggestSupport(j,this._transformDocumentSelector(G),ae,q.supportsResolving(J),`${$.identifier.value}(${ae.join("")})`),this._createDisposable(j)}$provideCompletionItems($,G,J,ae,j){return this._withAdapter($,q,te=>te.provideCompletionItems(c.URI.revive(G),J,ae,j),void 0)}$resolveCompletionItem($,G,J){return this._withAdapter($,q,ae=>ae.resolveCompletionItem(G,J),void 0)}$releaseCompletionItems($,G){this._withAdapter($,q,J=>J.releaseCompletionItems(G),void 0)}registerInlineCompletionsProvider($,G,J){const ae=this._addNewAdapter(new ue(this._documents,J,this._commands.converter),$);return this._proxy.$registerInlineCompletionsSupport(ae,this._transformDocumentSelector(G)),this._createDisposable(ae)}$provideInlineCompletions($,G,J,ae,j){return this._withAdapter($,ue,te=>te.provideInlineCompletions(c.URI.revive(G),J,ae,j),void 0)}$handleInlineCompletionDidShow($,G,J){this._withAdapter($,ue,async ae=>{ae.handleDidShowCompletionItem(G,J)},void 0)}$freeInlineCompletionsList($,G){this._withAdapter($,ue,async J=>{J.disposeCompletions(G)},void 0)}registerSignatureHelpProvider($,G,J,ae){const j=Array.isArray(ae)?{triggerCharacters:ae,retriggerCharacters:[]}:ae,te=this._addNewAdapter(new ce(this._documents,J),$);return this._proxy.$registerSignatureHelpProvider(te,this._transformDocumentSelector(G),j),this._createDisposable(te)}$provideSignatureHelp($,G,J,ae,j){return this._withAdapter($,ce,te=>te.provideSignatureHelp(c.URI.revive(G),J,ae,j),void 0)}$releaseSignatureHelp($,G){this._withAdapter($,ce,J=>J.releaseSignatureHelp(G),void 0)}registerInlayHintsProvider($,G,J){const ae=typeof J.onDidChangeInlayHints=="function"?this._nextHandle():void 0,j=this._addNewAdapter(new de(this._documents,J),$);this._proxy.$registerInlayHintsProvider(j,this._transformDocumentSelector(G),ae);let te=this._createDisposable(j);if(ae!==void 0){const me=J.onDidChangeInlayHints(Pe=>this._proxy.$emitInlayHintsEvent(ae));te=P.Disposable.from(te,me)}return te}$provideInlayHints($,G,J,ae){return this._withAdapter($,de,j=>j.provideInlayHints(c.URI.revive(G),J,ae),void 0)}registerDocumentLinkProvider($,G,J){const ae=this._addNewAdapter(new Y(this._documents,J),$);return this._proxy.$registerDocumentLinkProvider(ae,this._transformDocumentSelector(G),typeof J.resolveDocumentLink=="function"),this._createDisposable(ae)}$provideDocumentLinks($,G,J){return this._withAdapter($,Y,ae=>ae.provideLinks(c.URI.revive(G),J),void 0)}$resolveDocumentLink($,G,J){return this._withAdapter($,Y,ae=>ae.resolveLink(G,J),void 0)}$releaseDocumentLinks($,G){this._withAdapter($,Y,J=>J.releaseLinks(G),void 0)}registerColorProvider($,G,J){const ae=this._addNewAdapter(new ie(this._documents,J),$);return this._proxy.$registerDocumentColorProvider(ae,this._transformDocumentSelector(G)),this._createDisposable(ae)}$provideDocumentColors($,G,J){return this._withAdapter($,ie,ae=>ae.provideColors(c.URI.revive(G),J),[])}$provideColorPresentations($,G,J,ae){return this._withAdapter($,ie,j=>j.provideColorPresentations(c.URI.revive(G),J,ae),void 0)}registerFoldingRangeProvider($,G,J){const ae=this._nextHandle(),j=typeof J.onDidChangeFoldingRanges=="function"?this._nextHandle():void 0;this._adapter.set(ae,new Qe(new we(this._documents,J),$)),this._proxy.$registerFoldingRangeProvider(ae,this._transformDocumentSelector(G),j);let te=this._createDisposable(ae);if(j!==void 0){const me=J.onDidChangeFoldingRanges(()=>this._proxy.$emitFoldingRangeEvent(j));te=P.Disposable.from(te,me)}return te}$provideFoldingRanges($,G,J,ae){return this._withAdapter($,we,j=>j.provideFoldingRanges(c.URI.revive(G),J,ae),void 0)}registerSelectionRangeProvider($,G,J){const ae=this._addNewAdapter(new Me(this._documents,J,this._logService),$);return this._proxy.$registerSelectionRangeProvider(ae,this._transformDocumentSelector(G)),this._createDisposable(ae)}$provideSelectionRanges($,G,J,ae){return this._withAdapter($,Me,j=>j.provideSelectionRanges(c.URI.revive(G),J,ae),[])}registerCallHierarchyProvider($,G,J){const ae=this._addNewAdapter(new Re(this._documents,J),$);return this._proxy.$registerCallHierarchyProvider(ae,this._transformDocumentSelector(G)),this._createDisposable(ae)}$prepareCallHierarchy($,G,J,ae){return this._withAdapter($,Re,j=>Promise.resolve(j.prepareSession(c.URI.revive(G),J,ae)),void 0)}$provideCallHierarchyIncomingCalls($,G,J,ae){return this._withAdapter($,Re,j=>j.provideCallsTo(G,J,ae),void 0)}$provideCallHierarchyOutgoingCalls($,G,J,ae){return this._withAdapter($,Re,j=>j.provideCallsFrom(G,J,ae),void 0)}$releaseCallHierarchy($,G){this._withAdapter($,Re,J=>Promise.resolve(J.releaseSession(G)),void 0)}registerTypeHierarchyProvider($,G,J){const ae=this._addNewAdapter(new Be(this._documents,J),$);return this._proxy.$registerTypeHierarchyProvider(ae,this._transformDocumentSelector(G)),this._createDisposable(ae)}$prepareTypeHierarchy($,G,J,ae){return this._withAdapter($,Be,j=>Promise.resolve(j.prepareSession(c.URI.revive(G),J,ae)),void 0)}$provideTypeHierarchySupertypes($,G,J,ae){return this._withAdapter($,Be,j=>j.provideSupertypes(G,J,ae),void 0)}$provideTypeHierarchySubtypes($,G,J,ae){return this._withAdapter($,Be,j=>j.provideSubtypes(G,J,ae),void 0)}$releaseTypeHierarchy($,G){this._withAdapter($,Be,J=>Promise.resolve(J.releaseSession(G)),void 0)}static _serializeRegExp($){return{pattern:$.source,flags:(0,T.regExpFlags)($)}}static _serializeIndentationRule($){return{decreaseIndentPattern:Ge._serializeRegExp($.decreaseIndentPattern),increaseIndentPattern:Ge._serializeRegExp($.increaseIndentPattern),indentNextLinePattern:$.indentNextLinePattern?Ge._serializeRegExp($.indentNextLinePattern):void 0,unIndentedLinePattern:$.unIndentedLinePattern?Ge._serializeRegExp($.unIndentedLinePattern):void 0}}static _serializeOnEnterRule($){return{beforeText:Ge._serializeRegExp($.beforeText),afterText:$.afterText?Ge._serializeRegExp($.afterText):void 0,previousLineText:$.previousLineText?Ge._serializeRegExp($.previousLineText):void 0,action:$.action}}static _serializeOnEnterRules($){return $.map(Ge._serializeOnEnterRule)}setLanguageConfiguration($,G,J){let{wordPattern:ae}=J;if(ae&&(0,T.regExpLeadsToEndlessLoop)(ae))throw new Error(`Invalid language configuration: wordPattern '${ae}' is not allowed to match the empty string.`);ae?this._documents.setWordDefinitionFor(G,ae):this._documents.setWordDefinitionFor(G,void 0),J.__electricCharacterSupport&&this._apiDeprecation.report("LanguageConfiguration.__electricCharacterSupport",$,"Do not use."),J.__characterPairSupport&&this._apiDeprecation.report("LanguageConfiguration.__characterPairSupport",$,"Do not use.");const j=this._nextHandle(),te={comments:J.comments,brackets:J.brackets,wordPattern:J.wordPattern?Ge._serializeRegExp(J.wordPattern):void 0,indentationRules:J.indentationRules?Ge._serializeIndentationRule(J.indentationRules):void 0,onEnterRules:J.onEnterRules?Ge._serializeOnEnterRules(J.onEnterRules):void 0,__electricCharacterSupport:J.__electricCharacterSupport,__characterPairSupport:J.__characterPairSupport};return this._proxy.$setLanguageConfiguration(j,G,te),this._createDisposable(j)}$setWordDefinitions($){for(const G of $)this._documents.setWordDefinitionFor(G.languageId,new RegExp(G.regexSource,G.regexFlags))}}e.ExtHostLanguageFeatures=Ge,Ge._handlePool=0}),define(Ee[191],_e([0,1,5,8,7,34,14,6]),function(re,e,c,F,w,P,t,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLanguages=void 0;class C{constructor(R,_,n,m){this._documents=_,this._commands=n,this._uriTransformer=m,this._languageIds=[],this._handlePool=0,this._ids=new Set,this._proxy=R.getProxy(c.MainContext.MainThreadLanguages)}$acceptLanguageIds(R){this._languageIds=R}async getLanguages(){return this._languageIds.slice(0)}async changeLanguage(R,_){await this._proxy.$changeLanguage(R,_);const n=this._documents.getDocumentData(R);if(!n)throw new Error(`document '${R.toString}' NOT found`);return n.document}async tokenAtPosition(R,_){const n=R.version,m=F.Position.from(_),o=await this._proxy.$tokensAtPosition(R.uri,m),d={type:w.StandardTokenType.Other,range:R.getWordRangeAtPosition(_)??new w.Range(_.line,_.character,_.line,_.character)};if(!o)return d;const u={range:F.Range.to(o.range),type:F.TokenType.to(o.type)};return!u.range.contains(_)||n!==R.version?d:u}createLanguageStatusItem(R,_,n){const m=this._handlePool++,o=this._proxy,d=this._ids,u=`${R.identifier.value}/${_}`;if(d.has(u))throw new Error(`LanguageStatusItem with id '${_}' ALREADY exists`);d.add(u);const S={selector:n,id:_,name:R.displayName??R.name,severity:w.LanguageStatusSeverity.Information,command:void 0,text:"",detail:"",busy:!1};let b,h=new T.DisposableStore;const g=()=>{b?.dispose(),b=(0,t.disposableTimeout)(()=>{h.clear(),this._proxy.$setLanguageStatus(m,{id:u,name:S.name??R.displayName??R.name,source:R.displayName??R.name,selector:F.DocumentSelector.from(S.selector,this._uriTransformer),label:S.text,detail:S.detail??"",severity:S.severity===w.LanguageStatusSeverity.Error?P.default.Error:S.severity===w.LanguageStatusSeverity.Warning?P.default.Warning:P.default.Info,command:S.command&&this._commands.toInternal(S.command,h),accessibilityInfo:S.accessibilityInformation,busy:S.busy})},0)},A={dispose(){h.dispose(),b?.dispose(),o.$removeLanguageStatus(m),d.delete(u)},get id(){return S.id},get name(){return S.name},set name(l){S.name=l,g()},get selector(){return S.selector},set selector(l){S.selector=l,g()},get text(){return S.text},set text(l){S.text=l,g()},get detail(){return S.detail},set detail(l){S.detail=l,g()},get severity(){return S.severity},set severity(l){S.severity=l,g()},get accessibilityInformation(){return S.accessibilityInformation},set accessibilityInformation(l){S.accessibilityInformation=l,g()},get command(){return S.command},set command(l){S.command=l,g()},get busy(){return S.busy},set busy(l){S.busy=l,g()}};return g(),A}}e.ExtHostLanguages=C}),define(Ee[192],_e([0,1,12,5,28,13,3]),function(re,e,c,F,w,P,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLoggerService=void 0;let T=class extends c.AbstractLoggerService{constructor(R,_){const n=new t.Emitter;super(_.logLevel,n.event);this._proxy=R.getProxy(F.MainContext.MainThreadLogger),this._onDidChangeLogLevel=this._register(n)}$setLevel(R){this._onDidChangeLogLevel.fire(R)}doCreateLogger(R,_,n){return new C(this._proxy,R,_,n)}};T=Ue([$e(0,P.IExtHostRpcService),$e(1,w.IExtHostInitDataService)],T),e.ExtHostLoggerService=T;class C extends c.AbstractMessageLogger{constructor(R,_,n,m){super(m?.always);this.proxy=R,this.file=_,this.isLoggerCreated=!1,this.buffer=[],this.setLevel(n),this.proxy.$createLogger(_,m).then(()=>{this.doLog(this.buffer),this.isLoggerCreated=!0})}log(R,_){const n=[[R,_]];this.isLoggerCreated?this.doLog(n):this.buffer.push(...n)}doLog(R){this.proxy.$log(this.file,R)}}}),define(Ee[193],_e([0,1,5,12,27]),function(re,e,c,F,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostMessageService=void 0;function P(T){return T&&T.title}let t=class{constructor(C,k){this._logService=k,this._proxy=C.getProxy(c.MainContext.MainThreadMessageService)}showMessage(C,k,R,_,n){const m={extension:C};let o;typeof _=="string"||P(_)?o=[_,...n]:(m.modal=_?.modal,m.useCustom=_?.useCustom,m.detail=_?.detail,o=n),m.useCustom&&(0,w.checkProposedApiEnabled)(C,"resolvers");const d=[];for(let u=0;u<o.length;u++){const S=o[u];if(typeof S=="string")d.push({title:S,handle:u,isCloseAffordance:!1});else if(typeof S=="object"){let{title:b,isCloseAffordance:h}=S;d.push({title:b,isCloseAffordance:!!h,handle:u})}else this._logService.warn("Invalid message item:",S)}return this._proxy.$showMessage(k,R,m,d).then(u=>{if(typeof u=="number")return o[u]})}};t=Ue([$e(1,F.ILogService)],t),e.ExtHostMessageService=t}),define(Ee[194],_e([0,1,22,3,57,6,21,9,11,2,63,5,8,7,37,167,91]),function(re,e,c,F,w,P,t,T,C,k,R,_,n,m,o,d,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookController=void 0;class S{constructor(h,g,A,l,M){this._textDocumentsAndEditors=A,this._textDocuments=l,this._extensionStoragePaths=M,this._notebookContentProviders=new Map,this._notebookStatusBarItemProviders=new Map,this._documents=new t.ResourceMap,this._editors=new Map,this._onDidChangeNotebookCells=new F.Emitter,this.onDidChangeNotebookCells=this._onDidChangeNotebookCells.event,this._onDidChangeCellOutputs=new F.Emitter,this.onDidChangeCellOutputs=this._onDidChangeCellOutputs.event,this._onDidChangeCellMetadata=new F.Emitter,this.onDidChangeCellMetadata=this._onDidChangeCellMetadata.event,this._onDidChangeActiveNotebookEditor=new F.Emitter,this.onDidChangeActiveNotebookEditor=this._onDidChangeActiveNotebookEditor.event,this._onDidChangeCellExecutionState=new F.Emitter,this.onDidChangeNotebookCellExecutionState=this._onDidChangeCellExecutionState.event,this._visibleNotebookEditors=[],this._onDidOpenNotebookDocument=new F.Emitter,this.onDidOpenNotebookDocument=this._onDidOpenNotebookDocument.event,this._onDidCloseNotebookDocument=new F.Emitter,this.onDidCloseNotebookDocument=this._onDidCloseNotebookDocument.event,this._onDidChangeVisibleNotebookEditors=new F.Emitter,this.onDidChangeVisibleNotebookEditors=this._onDidChangeVisibleNotebookEditors.event,this._statusBarCache=new R.Cache("NotebookCellStatusBarCache"),this._handlePool=0,this._notebookSerializer=new Map,this._backupIdPool=0,this._notebookProxy=h.getProxy(_.MainContext.MainThreadNotebook),this._notebookDocumentsProxy=h.getProxy(_.MainContext.MainThreadNotebookDocuments),this._notebookEditorsProxy=h.getProxy(_.MainContext.MainThreadNotebookEditors),this._commandsConverter=g.converter,g.registerArgumentProcessor({processArgument:r=>{if(r&&r.$mid===12){const i=r.notebookEditor?.notebookUri,p=r.cell.handle,s=this._documents.get(i)?.getCell(p);if(s)return s.apiCell}return r}})}get activeNotebookEditor(){return this._activeNotebookEditor?.apiEditor}get visibleNotebookEditors(){return this._visibleNotebookEditors.map(h=>h.apiEditor)}getEditorById(h){const g=this._editors.get(h);if(!g)throw new Error(`unknown text editor: ${h}. known editors: ${[...this._editors.keys()]} `);return g}getIdByEditor(h){for(const[g,A]of this._editors)if(A.apiEditor===h)return g}get notebookDocuments(){return[...this._documents.values()]}getNotebookDocument(h,g){const A=this._documents.get(h);if(!A&&!g)throw new Error(`NO notebook document for '${h}'`);return A}_getProviderData(h){const g=this._notebookContentProviders.get(h);if(!g)throw new Error(`NO provider for '${h}'`);return g}registerNotebookContentProvider(h,g,A,l,M){if((0,T.isFalsyOrWhitespace)(g))throw new Error("viewType cannot be empty or just whitespace");if(this._notebookContentProviders.has(g))throw new Error(`Notebook provider for '${g}' already registered`);this._notebookContentProviders.set(g,{extension:h,provider:A});let r;return A.onDidChangeNotebookContentOptions&&(r=A.onDidChangeNotebookContentOptions(()=>{const i=n.NotebookDocumentContentOptions.from(A.options);this._notebookProxy.$updateNotebookProviderOptions(g,i)})),this._notebookProxy.$registerNotebookProvider({id:h.identifier,location:h.extensionLocation},g,n.NotebookDocumentContentOptions.from(l),S._convertNotebookRegistrationData(h,M)),new m.Disposable(()=>{r?.dispose(),this._notebookContentProviders.delete(g),this._notebookProxy.$unregisterNotebookProvider(g)})}static _convertNotebookRegistrationData(h,g){if(!g)return;const A=g.filenamePattern.map(l=>n.NotebookExclusiveDocumentPattern.from(l)).filter(l=>l!==void 0);if(g.filenamePattern&&!A){console.warn(`Notebook content provider view options file name pattern is invalid ${g.filenamePattern}`);return}return{extension:h.identifier,providerDisplayName:h.displayName||h.name,displayName:g.displayName,filenamePattern:A,exclusive:g.exclusive||!1}}registerNotebookCellStatusBarItemProvider(h,g,A){const l=S._notebookStatusBarItemProviderHandlePool++,M=typeof A.onDidChangeCellStatusBarItems=="function"?S._notebookStatusBarItemProviderHandlePool++:void 0;this._notebookStatusBarItemProviders.set(l,A),this._notebookProxy.$registerNotebookCellStatusBarItemProvider(l,M,g);let r;return M!==void 0&&(r=A.onDidChangeCellStatusBarItems(i=>this._notebookProxy.$emitCellStatusBarEvent(M))),new m.Disposable(()=>{this._notebookStatusBarItemProviders.delete(l),this._notebookProxy.$unregisterNotebookCellStatusBarItemProvider(l,M),r&&r.dispose()})}async createNotebookDocument(h){const g=await this._notebookDocumentsProxy.$tryCreateNotebook({viewType:h.viewType,content:h.content&&n.NotebookData.from(h.content)});return k.URI.revive(g)}async openNotebookDocument(h){const g=this._documents.get(h);if(g)return g.apiNotebook;const A=await this._notebookDocumentsProxy.$tryOpenNotebook(h),l=this._documents.get(k.URI.revive(A));return(0,C.assertIsDefined)(l?.apiNotebook)}async showNotebookDocument(h,g){k.URI.isUri(h)&&(h=await this.openNotebookDocument(h));let A;typeof g=="object"?A={position:n.ViewColumn.from(g.viewColumn),preserveFocus:g.preserveFocus,selections:g.selections&&g.selections.map(n.NotebookRange.from),pinned:typeof g.preview=="boolean"?!g.preview:void 0}:A={preserveFocus:!1};const l=await this._notebookEditorsProxy.$tryShowNotebookDocument(h.uri,h.notebookType,A),M=l&&this._editors.get(l)?.apiEditor;if(M)return M;throw l?new Error(`Could NOT open editor for "${h.uri.toString()}" because another editor opened in the meantime.`):new Error(`Could NOT open editor for "${h.uri.toString()}".`)}async $provideNotebookCellStatusBarItems(h,g,A,l){const M=this._notebookStatusBarItemProviders.get(h),r=k.URI.revive(g),i=this._documents.get(r);if(!i||!M)return;const p=i.getCellFromIndex(A);if(!p)return;const f=await M.provideCellStatusBarItems(p.apiCell,l);if(!f)return;const s=new P.DisposableStore,v=this._statusBarCache.add([s]),E=(Array.isArray(f)?f:[f]).map(I=>n.NotebookStatusBarItem.from(I,this._commandsConverter,s));return{cacheId:v,items:E}}$releaseNotebookCellStatusBarItems(h){this._statusBarCache.delete(h)}registerNotebookSerializer(h,g,A,l,M){if((0,T.isFalsyOrWhitespace)(g))throw new Error("viewType cannot be empty or just whitespace");const r=this._handlePool++;return this._notebookSerializer.set(r,A),this._notebookProxy.$registerNotebookSerializer(r,{id:h.identifier,location:h.extensionLocation},g,n.NotebookDocumentContentOptions.from(l),S._convertNotebookRegistrationData(h,M)),(0,P.toDisposable)(()=>{this._notebookProxy.$unregisterNotebookSerializer(r)})}async $dataToNotebook(h,g,A){const l=this._notebookSerializer.get(h);if(!l)throw new Error("NO serializer found");const M=await l.deserializeNotebook(g.buffer,A);return new o.SerializableObjectWithBuffers(n.NotebookData.from(M))}async $notebookToData(h,g,A){const l=this._notebookSerializer.get(h);if(!l)throw new Error("NO serializer found");const M=await l.serializeNotebook(n.NotebookData.to(g.value),A);return c.VSBuffer.wrap(M)}async $openNotebook(h,g,A,l,M){const{provider:r}=this._getProviderData(h),i=await r.openNotebook(k.URI.revive(g),{backupId:A,untitledDocumentData:l?.buffer},M);return new o.SerializableObjectWithBuffers({metadata:i.metadata??Object.create(null),cells:i.cells.map(n.NotebookCellData.from)})}async $saveNotebook(h,g,A){const l=this.getNotebookDocument(k.URI.revive(g)),{provider:M}=this._getProviderData(h);return await M.saveNotebook(l.apiNotebook,A),!0}async $saveNotebookAs(h,g,A,l){const M=this.getNotebookDocument(k.URI.revive(g)),{provider:r}=this._getProviderData(h);return await r.saveNotebookAs(k.URI.revive(A),M.apiNotebook,l),!0}async $backupNotebook(h,g,A){const l=this.getNotebookDocument(k.URI.revive(g)),M=this._getProviderData(h),r=this._extensionStoragePaths.workspaceValue(M.extension)??this._extensionStoragePaths.globalValue(M.extension),i=String((0,w.hash)([l.uri.toString(),this._backupIdPool++])),p=k.URI.joinPath(r,i),f=await M.provider.backupNotebook(l.apiNotebook,{destination:p},A);return l.updateBackup(f),f.id}_createExtHostEditor(h,g,A){if(this._editors.has(g))throw new Error(`editor with id ALREADY EXSIST: ${g}`);const l=new u.ExtHostNotebookEditor(g,this._notebookEditorsProxy,h,A.visibleRanges.map(n.NotebookRange.to),A.selections.map(n.NotebookRange.to),typeof A.viewColumn=="number"?n.ViewColumn.to(A.viewColumn):void 0);this._editors.set(g,l)}$acceptDocumentAndEditorsDelta(h){if(h.value.removedDocuments)for(const A of h.value.removedDocuments){const l=k.URI.revive(A),M=this._documents.get(l);M&&(M.dispose(),this._documents.delete(l),this._textDocumentsAndEditors.$acceptDocumentsAndEditorsDelta({removedDocuments:M.apiNotebook.getCells().map(r=>r.document.uri)}),this._onDidCloseNotebookDocument.fire(M.apiNotebook));for(const r of this._editors.values())r.notebookData.uri.toString()===l.toString()&&this._editors.delete(r.id)}if(h.value.addedDocuments){const A=[];for(const l of h.value.addedDocuments){const M=k.URI.revive(l.uri);if(this._documents.has(M))throw new Error(`adding EXISTING notebook ${M} `);const r=this,i=new d.ExtHostNotebookDocument(this._notebookDocumentsProxy,this._textDocumentsAndEditors,this._textDocuments,{emitModelChange(p){r._onDidChangeNotebookCells.fire(p)},emitCellOutputsChange(p){r._onDidChangeCellOutputs.fire(p)},emitCellMetadataChange(p){r._onDidChangeCellMetadata.fire(p)},emitCellExecutionStateChange(p){r._onDidChangeCellExecutionState.fire(p)}},M,l);A.push(...l.cells.map(p=>d.ExtHostCell.asModelAddData(i.apiNotebook,p))),this._documents.get(M)?.dispose(),this._documents.set(M,i),this._textDocumentsAndEditors.$acceptDocumentsAndEditorsDelta({addedDocuments:A}),this._onDidOpenNotebookDocument.fire(i.apiNotebook)}}if(h.value.addedEditors)for(const A of h.value.addedEditors){if(this._editors.has(A.id))return;const l=k.URI.revive(A.documentUri),M=this._documents.get(l);M&&this._createExtHostEditor(M,A.id,A)}const g=[];if(h.value.removedEditors)for(const A of h.value.removedEditors){const l=this._editors.get(A);l&&(this._editors.delete(A),this._activeNotebookEditor?.id===l.id&&(this._activeNotebookEditor=void 0),g.push(l))}if(h.value.visibleEditors){this._visibleNotebookEditors=h.value.visibleEditors.map(l=>this._editors.get(l)).filter(l=>!!l);const A=new Set;this._visibleNotebookEditors.forEach(l=>A.add(l.id));for(const l of this._editors.values()){const M=A.has(l.id);l._acceptVisibility(M)}this._visibleNotebookEditors=[...this._editors.values()].map(l=>l).filter(l=>l.visible),this._onDidChangeVisibleNotebookEditors.fire(this.visibleNotebookEditors)}h.value.newActiveEditor===null?this._activeNotebookEditor=void 0:h.value.newActiveEditor&&(this._activeNotebookEditor=this._editors.get(h.value.newActiveEditor)),h.value.newActiveEditor!==void 0&&this._onDidChangeActiveNotebookEditor.fire(this._activeNotebookEditor?.apiEditor)}}e.ExtHostNotebookController=S,S._notebookStatusBarItemProviderHandlePool=0}),define(Ee[195],_e([0,1,3,52,12,5,13,8]),function(re,e,c,F,w,P,t,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookEditors=void 0;class C{constructor(_,n){const m=C._Keys.nextId();_.$registerNotebookEditorDecorationType(m,T.NotebookDecorationRenderOptions.from(n)),this.value={key:m,dispose(){_.$removeNotebookEditorDecorationType(m)}}}}C._Keys=new F.IdGenerator("NotebookEditorDecorationType");let k=class{constructor(_,n,m){this._logService=_,this._extHostRpc=n,this._notebooksAndEditors=m,this._onDidChangeNotebookEditorSelection=new c.Emitter,this._onDidChangeNotebookEditorVisibleRanges=new c.Emitter,this.onDidChangeNotebookEditorSelection=this._onDidChangeNotebookEditorSelection.event,this.onDidChangeNotebookEditorVisibleRanges=this._onDidChangeNotebookEditorVisibleRanges.event}createNotebookEditorDecorationType(_){return new C(this._extHostRpc.getProxy(P.MainContext.MainThreadNotebookEditors),_).value}$acceptEditorPropertiesChanged(_,n){this._logService.debug("ExtHostNotebook#$acceptEditorPropertiesChanged",_,n);const m=this._notebooksAndEditors.getEditorById(_);n.visibleRanges&&m._acceptVisibleRanges(n.visibleRanges.ranges.map(T.NotebookRange.to)),n.selections&&m._acceptSelections(n.selections.selections.map(T.NotebookRange.to)),n.visibleRanges&&this._onDidChangeNotebookEditorVisibleRanges.fire({notebookEditor:m.apiEditor,visibleRanges:m.apiEditor.visibleRanges}),n.selections&&this._onDidChangeNotebookEditorSelection.fire(Object.freeze({notebookEditor:m.apiEditor,selections:m.apiEditor.selections}))}$acceptEditorViewColumns(_){for(const n in _)this._notebooksAndEditors.getEditorById(n)._acceptViewColumn(T.ViewColumn.to(_[n]))}};k=Ue([$e(0,w.ILogService),$e(1,t.IExtHostRpcService)],k),e.ExtHostNotebookEditors=k}),define(Ee[196],_e([0,1,16,14,20,3,6,21,2,25,12,5,38,8,7,66,159,27,37]),function(re,e,c,F,w,P,t,T,C,k,R,_,n,m,o,d,u,S,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookKernels=void 0;let h=class{constructor(r,i,p,f,s){this._initData=i,this._extHostNotebook=p,this._commands=f,this._logService=s,this._activeExecutions=new T.ResourceMap,this._kernelData=new Map,this._handlePool=0,this._proxy=r.getProxy(_.MainContext.MainThreadNotebookKernels);const v=new n.ApiCommand("notebook.selectKernel","_notebook.selectKernel","Trigger kernel picker for specified notebook editor widget",[new n.ApiCommandArgument("options","Select kernel options",a=>!0,a=>{if(a&&"notebookEditor"in a&&"id"in a){const E=this._extHostNotebook.getIdByEditor(a.notebookEditor);return{id:a.id,extension:a.extension,notebookEditorId:E}}else if(a&&"notebookEditor"in a){const E=this._extHostNotebook.getIdByEditor(a.notebookEditor);if(E===void 0)throw new Error(`Cannot invoke 'notebook.selectKernel' for unrecognized notebook editor ${a.notebookEditor.document.uri.toString()}`);return{notebookEditorId:E}}return a})],n.ApiCommandResult.Void);this._commands.registerApiCommand(v)}createNotebookController(r,i,p,f,s,v){for(let ce of this._kernelData.values())if(ce.controller.id===i&&k.ExtensionIdentifier.equals(r.identifier,ce.extensionId))throw new Error(`notebook controller with id '${i}' ALREADY exist`);const a=this._handlePool++,E=this;this._logService.trace(`NotebookController[${a}], CREATED by ${r.identifier.value}, ${i}`);const I=()=>console.warn(`NO execute handler from notebook controller '${x.id}' of extension: '${r.identifier}'`);let D=!1;const B=new t.DisposableStore,L=new P.Emitter,y=new P.Emitter,x={id:`${r.identifier.value}/${i}`,notebookType:p,extensionId:r.identifier,extensionLocation:r.extensionLocation,label:f||r.identifier.value,preloads:v?v.map(m.NotebookRendererScript.from):[]};let N=s??I,z;this._proxy.$addKernel(a,x).catch(ce=>{console.log(ce),D=!0});let H=0;const q=()=>{if(D)return;const ce=++H;Promise.resolve().then(()=>{ce===H&&this._proxy.$updateKernel(a,x)})},ue=new T.ResourceMap,K={get id(){return i},get notebookType(){return x.notebookType},onDidChangeSelectedNotebooks:L.event,get label(){return x.label},set label(ce){x.label=ce??r.displayName??r.name,q()},get detail(){return x.detail??""},set detail(ce){x.detail=ce,q()},get description(){return x.description??""},set description(ce){x.description=ce,q()},get kind(){return(0,S.checkProposedApiEnabled)(r,"notebookControllerKind"),x.kind??""},set kind(ce){(0,S.checkProposedApiEnabled)(r,"notebookControllerKind"),x.kind=ce,q()},get supportedLanguages(){return x.supportedLanguages},set supportedLanguages(ce){x.supportedLanguages=ce,q()},get supportsExecutionOrder(){return x.supportsExecutionOrder??!1},set supportsExecutionOrder(ce){x.supportsExecutionOrder=ce,q()},get rendererScripts(){return x.preloads?x.preloads.map(m.NotebookRendererScript.to):[]},get executeHandler(){return N},set executeHandler(ce){N=ce??I},get interruptHandler(){return z},set interruptHandler(ce){z=ce,x.supportsInterrupt=Boolean(ce),q()},createNotebookCellExecution(ce){if(D)throw new Error("notebook controller is DISPOSED");if(!ue.has(ce.notebook.uri))throw E._logService.trace(`NotebookController[${a}] NOT associated to notebook, associated to THESE notebooks:`,Array.from(ue.keys()).map(de=>de.toString())),new Error(`notebook controller is NOT associated to notebook: ${ce.notebook.uri.toString()}`);return E._createNotebookCellExecution(ce)},dispose:()=>{D||(this._logService.trace(`NotebookController[${a}], DISPOSED`),D=!0,this._kernelData.delete(a),B.dispose(),L.dispose(),y.dispose(),this._proxy.$removeKernel(a))},updateNotebookAffinity(ce,de){E._proxy.$updateNotebookPriority(a,ce.uri,de)},onDidReceiveMessage:y.event,postMessage(ce,de){return(0,S.checkProposedApiEnabled)(r,"notebookMessaging"),E._proxy.$postMessage(a,de&&E._extHostNotebook.getIdByEditor(de),ce)},asWebviewUri(ce){return(0,S.checkProposedApiEnabled)(r,"notebookMessaging"),(0,d.asWebviewUri)(ce,E._initData.remote)}};return this._kernelData.set(a,{extensionId:r.identifier,controller:K,onDidReceiveMessage:y,onDidChangeSelection:L,associatedNotebooks:ue}),K}$acceptNotebookAssociation(r,i,p){const f=this._kernelData.get(r);if(f){const s=this._extHostNotebook.getNotebookDocument(C.URI.revive(i));p?f.associatedNotebooks.set(s.uri,!0):f.associatedNotebooks.delete(s.uri),this._logService.trace(`NotebookController[${r}] ASSOCIATE notebook`,s.uri.toString(),p),f.onDidChangeSelection.fire({selected:p,notebook:s.apiNotebook})}}async $executeCells(r,i,p){const f=this._kernelData.get(r);if(!f)return;const s=this._extHostNotebook.getNotebookDocument(C.URI.revive(i)),v=[];for(let a of p){const E=s.getCell(a);E&&v.push(E.apiCell)}try{this._logService.trace(`NotebookController[${r}] EXECUTE cells`,s.uri.toString(),v.length),await f.controller.executeHandler.call(f.controller,v,s.apiNotebook,f.controller)}catch(a){this._logService.error(`NotebookController[${r}] execute cells FAILED`,a),console.error(a)}}async $cancelCells(r,i,p){const f=this._kernelData.get(r);if(!f)return;const s=this._extHostNotebook.getNotebookDocument(C.URI.revive(i));if(f.controller.interruptHandler)await f.controller.interruptHandler.call(f.controller,s.apiNotebook);else for(let v of p){const a=s.getCell(v);a&&this._activeExecutions.get(a.uri)?.cancel()}}$acceptKernelMessageFromRenderer(r,i,p){const f=this._kernelData.get(r);if(!f)return;const s=this._extHostNotebook.getEditorById(i);f.onDidReceiveMessage.fire(Object.freeze({editor:s.apiEditor,message:p}))}_createNotebookCellExecution(r){if(r.index<0)throw new Error("CANNOT execute cell that has been REMOVED from notebook");const p=this._extHostNotebook.getNotebookDocument(r.notebook.uri).getCellFromApiCell(r);if(!p)throw new Error("invalid cell");if(this._activeExecutions.has(p.uri))throw new Error(`duplicate execution for ${p.uri}`);const f=new A(p.notebook,p,this._proxy);this._activeExecutions.set(p.uri,f);const s=f.onDidChangeState(()=>{f.state===g.Resolved&&(f.dispose(),s.dispose(),this._activeExecutions.delete(p.uri))});return f.asApiObject()}};h=Ue([$e(4,R.ILogService)],h),e.ExtHostNotebookKernels=h;var g;(function(M){M[M.Init=0]="Init",M[M.Started=1]="Started",M[M.Resolved=2]="Resolved"})(g||(g={}));class A extends t.Disposable{constructor(r,i,p){super();this._document=r,this._cell=i,this._proxy=p,this._handle=A.HANDLE++,this._onDidChangeState=new P.Emitter,this.onDidChangeState=this._onDidChangeState.event,this._state=g.Init,this._tokenSource=this._register(new w.CancellationTokenSource),this._collector=new l(10,f=>this.update(f)),this._executionOrder=i.internalMetadata.executionOrder,this._proxy.$addExecution(this._handle,this._cell.notebook.uri,this._cell.handle)}get state(){return this._state}cancel(){this._tokenSource.cancel()}async updateSoon(r){await this._collector.addItem(r)}async update(r){const i=Array.isArray(r)?r:[r];return this._proxy.$updateExecutions(new b.SerializableObjectWithBuffers(i))}verifyStateForOutput(){if(this._state===g.Init)throw new Error("Must call start before modifying cell output");if(this._state===g.Resolved)throw new Error("Cannot modify cell output after calling resolve")}cellIndexToHandle(r){let i=this._cell;if(r&&(i=this._document.getCellFromApiCell(r)),!i)throw new Error("INVALID cell");return i.handle}validateAndConvertOutputs(r){return r.map(i=>{const p=o.NotebookCellOutput.ensureUniqueMimeTypes(i.items,!0);return p===i.items?m.NotebookCellOutput.from(i):m.NotebookCellOutput.from({items:p,id:i.id,metadata:i.metadata})})}async updateOutputs(r,i,p){const f=this.cellIndexToHandle(i),s=this.validateAndConvertOutputs((0,c.asArray)(r));return this.updateSoon({editType:u.CellExecutionUpdateType.Output,executionHandle:this._handle,cellHandle:f,append:p,outputs:s})}async updateOutputItems(r,i,p){return r=o.NotebookCellOutput.ensureUniqueMimeTypes((0,c.asArray)(r),!0),this.updateSoon({editType:u.CellExecutionUpdateType.OutputItems,executionHandle:this._handle,items:r.map(m.NotebookCellOutputItem.from),outputId:i.id,append:p})}asApiObject(){const r=this;return Object.freeze({get token(){return r._tokenSource.token},get cell(){return r._cell.apiCell},get executionOrder(){return r._executionOrder},set executionOrder(p){r._executionOrder=p,r.update([{editType:u.CellExecutionUpdateType.ExecutionState,executionHandle:r._handle,executionOrder:r._executionOrder}])},start(p){if(r._state===g.Resolved||r._state===g.Started)throw new Error("Cannot call start again");r._state=g.Started,r._onDidChangeState.fire(),r.update({editType:u.CellExecutionUpdateType.ExecutionState,executionHandle:r._handle,runStartTime:p})},end(p,f){if(r._state===g.Resolved)throw new Error("Cannot call resolve twice");r._state=g.Resolved,r._onDidChangeState.fire(),r.updateSoon({editType:u.CellExecutionUpdateType.Complete,executionHandle:r._handle,runEndTime:f,lastRunSuccess:p}),r._collector.flush(),r._proxy.$removeExecution(r._handle)},clearOutput(p){return r.verifyStateForOutput(),r.updateOutputs([],p,!1)},appendOutput(p,f){return r.verifyStateForOutput(),r.updateOutputs(p,f,!0)},replaceOutput(p,f){return r.verifyStateForOutput(),r.updateOutputs(p,f,!1)},appendOutputItems(p,f){return r.verifyStateForOutput(),r.updateOutputItems(p,f,!0)},replaceOutputItems(p,f){return r.verifyStateForOutput(),r.updateOutputItems(p,f,!1)}})}}A.HANDLE=0;class l{constructor(r,i){this.delay=r,this.callback=i,this.batch=[],this.startedTimer=Date.now()}addItem(r){return this.batch.push(r),this.currentDeferred||(this.currentDeferred=new F.DeferredPromise,this.startedTimer=Date.now(),(0,F.timeout)(this.delay).then(()=>this.flush())),Date.now()-this.startedTimer>this.delay?this.flush():this.currentDeferred.p}flush(){if(this.batch.length===0||!this.currentDeferred)return Promise.resolve();const r=this.currentDeferred;this.currentDeferred=void 0;const i=this.batch;return this.batch=[],this.callback(i).finally(()=>r.complete())}}}),define(Ee[197],_e([0,1,3,5,91,27]),function(re,e,c,F,w,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookRenderers=void 0;class t{constructor(C,k){this._extHostNotebook=k,this._rendererMessageEmitters=new Map,this.proxy=C.getProxy(F.MainContext.MainThreadNotebookRenderers)}$postRendererMessage(C,k,R){const _=this._extHostNotebook.getEditorById(C);this._rendererMessageEmitters.get(k)?.fire({editor:_.apiEditor,message:R})}createRendererMessaging(C,k){if(!C.contributes?.notebookRenderer?.some(m=>m.id===k))throw new Error(`Extensions may only call createRendererMessaging() for renderers they contribute (got ${k})`);const R=(0,P.isProposedApiEnabled)(C,"notebookEditor"),_=new WeakMap;return{onDidReceiveMessage:(m,o,d)=>{const u=R?m:S=>{const b={};_.set(b,S.editor),m({editor:b,message:S.message})};return this.getOrCreateEmitterFor(k).event(u,o,d)},postMessage:(m,o)=>{w.ExtHostNotebookEditor.apiEditorsToExtHost.has(m)&&([m,o]=[o,m]);const d=R?o:_.get(o),u=d&&w.ExtHostNotebookEditor.apiEditorsToExtHost.get(d);return this.proxy.$postMessage(u?.id,k,m)}}}getOrCreateEmitterFor(C){let k=this._rendererMessageEmitters.get(C);return k||(k=new c.Emitter({onLastListenerRemove:()=>{k?.dispose(),this._rendererMessageEmitters.delete(C)}}),this._rendererMessageEmitters.set(C,k),k)}}e.ExtHostNotebookRenderers=t}),define(Ee[94],_e([0,1,5,6,4,13,12,160,49,28,30,110,22]),function(re,e,c,F,w,P,t,T,C,k,R,_,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostOutputService=e.ExtHostOutputService=e.ExtHostOutputChannel=void 0;class m extends F.Disposable{constructor(u,S,b,h){super();this.id=u,this.name=S,this.logger=b,this.proxy=h,this.offset=0,this.visible=!1,this._disposed=!1}get disposed(){return this._disposed}appendLine(u){this.append(u+`
`)}append(u){this.write(u),this.visible&&(this.logger.flush(),this.proxy.$update(this.id,T.OutputChannelUpdateMode.Append))}clear(){const u=this.offset;this.logger.flush(),this.proxy.$update(this.id,T.OutputChannelUpdateMode.Clear,u)}replace(u){const S=this.offset;this.write(u),this.proxy.$update(this.id,T.OutputChannelUpdateMode.Replace,S),this.visible&&this.logger.flush()}show(u,S){this.logger.flush(),this.proxy.$reveal(this.id,!!(typeof u=="boolean"?u:S))}hide(){this.proxy.$close(this.id)}write(u){this.offset+=n.VSBuffer.fromString(u).byteLength,this.logger.info(u)}dispose(){super.dispose(),this._disposed||(this.proxy.$dispose(this.id),this._disposed=!0)}}e.ExtHostOutputChannel=m;let o=class{constructor(u,S,b,h,g){this.extHostFileSystem=b,this.extHostFileSystemInfo=h,this.loggerService=g,this.namePool=1,this.channels=new Map,this.visibleChannelId=null,this.proxy=u.getProxy(c.MainContext.MainThreadOutputService),this.outputsLocation=this.extHostFileSystemInfo.extUri.joinPath(S.logsLocation,`output_logging_${(0,_.toLocalISOString)(new Date).replace(/-|:|\.\d+Z$/g,"")}`)}$setVisibleChannel(u){this.visibleChannelId=u;for(const[S,b]of this.channels)b.visible=S===this.visibleChannelId}createOutputChannel(u,S){if(u=u.trim(),!u)throw new Error("illegal argument `name`. must not be falsy");const b=this.doCreateOutputChannel(u,S);return b.then(h=>{this.channels.set(h.id,h),h.visible=h.id===this.visibleChannelId}),this.createExtHostOutputChannel(u,b)}async doCreateOutputChannel(u,S){const b=await this.createOutputDirectory(),h=this.extHostFileSystemInfo.extUri.joinPath(b,`${this.namePool++}-${u.replace(/[\\/:\*\?"<>\|]/g,"")}.log`),g=this.loggerService.createLogger(h,{always:!0,donotRotate:!0,donotUseFormatters:!0}),A=await this.proxy.$register(u,!1,h,S.identifier.value);return new m(A,u,g,this.proxy)}createOutputDirectory(){return this.outputDirectoryPromise||(this.outputDirectoryPromise=this.extHostFileSystem.value.createDirectory(this.outputsLocation).then(()=>this.outputsLocation)),this.outputDirectoryPromise}createExtHostOutputChannel(u,S){let b=!1;const h=()=>{if(b)throw new Error("Channel has been closed")};return{get name(){return u},append(g){h(),S.then(A=>A.append(g))},appendLine(g){h(),S.then(A=>A.appendLine(g))},clear(){h(),S.then(g=>g.clear())},replace(g){h(),S.then(A=>A.replace(g))},show(g,A){h(),S.then(l=>l.show(g,A))},hide(){h(),S.then(g=>g.hide())},dispose(){b=!0,S.then(g=>g.dispose())}}}};o=Ue([$e(0,P.IExtHostRpcService),$e(1,k.IExtHostInitDataService),$e(2,C.IExtHostConsumerFileSystem),$e(3,R.IExtHostFileSystemInfo),$e(4,t.ILoggerService)],o),e.ExtHostOutputService=o,e.IExtHostOutputService=(0,w.createDecorator)("IExtHostOutputService")}),define(Ee[198],_e([0,1,14,20,3,6,5,2,7,15,16,34,62,27]),function(re,e,c,F,w,P,t,T,C,k,R,_,n,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createExtHostQuickOpen=void 0;function o(d,u,S){const b=d.getProxy(t.MainContext.MainThreadQuickOpen);class h{constructor(s,v){this._sessions=new Map,this._instances=0,this._workspace=s,this._commands=v}showQuickPick(s,v,a=F.CancellationToken.None){this._onDidSelectItem=void 0;const E=Promise.resolve(s),I=++this._instances,D=b.$show(I,{title:v?.title,placeHolder:v?.placeHolder,matchOnDescription:v?.matchOnDescription,matchOnDetail:v?.matchOnDetail,ignoreFocusLost:v?.ignoreFocusOut,canPickMany:v?.canPickMany},a),B={},L=D.then(()=>B);return Promise.race([L,E]).then(y=>{if(y!==B)return E.then(x=>{const N=[];for(let z=0;z<x.length;z++){const H=x[z];typeof H=="string"?N.push({label:H,handle:z}):H.kind===C.QuickPickItemKind.Separator?N.push({type:"separator",label:H.label}):N.push({label:H.label,description:H.description,detail:H.detail,picked:H.picked,alwaysShow:H.alwaysShow,handle:z})}return v&&typeof v.onDidSelectItem=="function"&&(this._onDidSelectItem=z=>{v.onDidSelectItem(x[z])}),b.$setItems(I,N),D.then(z=>{if(typeof z=="number")return x[z];if(Array.isArray(z))return z.map(H=>x[H])})})}).then(void 0,y=>{if(!(0,k.isPromiseCanceledError)(y))return b.$setError(I,y),Promise.reject(y)})}$onItemSelected(s){this._onDidSelectItem&&this._onDidSelectItem(s)}showInput(s,v=F.CancellationToken.None){return this._validateInput=s?s.validateInput:void 0,b.$input(s,typeof this._validateInput=="function",v).then(void 0,a=>{if(!(0,k.isPromiseCanceledError)(a))return Promise.reject(a)})}$validateInput(s){return this._validateInput?(0,c.asPromise)(()=>this._validateInput(s)):Promise.resolve(void 0)}async showWorkspaceFolderPick(s,v=F.CancellationToken.None){const a=await this._commands.executeCommand("_workbench.pickWorkspaceFolder",[s]);if(!a)return;const E=await this._workspace.getWorkspaceFolders2();if(!!E)return E.find(I=>I.uri.toString()===a.uri.toString())}createQuickPick(s){const v=new i(s,()=>this._sessions.delete(v._id));return this._sessions.set(v._id,v),v}createInputBox(s){const v=new p(s,()=>this._sessions.delete(v._id));return this._sessions.set(v._id,v),v}$onDidChangeValue(s,v){const a=this._sessions.get(s);a&&a._fireDidChangeValue(v)}$onDidAccept(s){const v=this._sessions.get(s);v&&v._fireDidAccept()}$onDidChangeActive(s,v){const a=this._sessions.get(s);a instanceof i&&a._fireDidChangeActive(v)}$onDidChangeSelection(s,v){const a=this._sessions.get(s);a instanceof i&&a._fireDidChangeSelection(v)}$onDidTriggerButton(s,v){const a=this._sessions.get(s);a&&a._fireDidTriggerButton(v)}$onDidTriggerItemButton(s,v,a){const E=this._sessions.get(s);E instanceof i&&E._fireDidTriggerItemButton(v,a)}$onDidHide(s){const v=this._sessions.get(s);v&&v._fireDidHide()}}class g{constructor(s,v){this._extensionId=s,this._onDidDispose=v,this._id=i._nextId++,this._visible=!1,this._expectingHide=!1,this._enabled=!0,this._busy=!1,this._ignoreFocusOut=!0,this._value="",this._buttons=[],this._handlesToButtons=new Map,this._onDidAcceptEmitter=new w.Emitter,this._onDidChangeValueEmitter=new w.Emitter,this._onDidTriggerButtonEmitter=new w.Emitter,this._onDidHideEmitter=new w.Emitter,this._pendingUpdate={id:this._id},this._disposed=!1,this._disposables=[this._onDidTriggerButtonEmitter,this._onDidHideEmitter,this._onDidAcceptEmitter,this._onDidChangeValueEmitter],this.onDidChangeValue=this._onDidChangeValueEmitter.event,this.onDidAccept=this._onDidAcceptEmitter.event,this.onDidTriggerButton=this._onDidTriggerButtonEmitter.event,this.onDidHide=this._onDidHideEmitter.event}get title(){return this._title}set title(s){this._title=s,this.update({title:s})}get step(){return this._steps}set step(s){this._steps=s,this.update({step:s})}get totalSteps(){return this._totalSteps}set totalSteps(s){this._totalSteps=s,this.update({totalSteps:s})}get enabled(){return this._enabled}set enabled(s){this._enabled=s,this.update({enabled:s})}get busy(){return this._busy}set busy(s){this._busy=s,this.update({busy:s})}get ignoreFocusOut(){return this._ignoreFocusOut}set ignoreFocusOut(s){this._ignoreFocusOut=s,this.update({ignoreFocusOut:s})}get value(){return this._value}set value(s){this._value=s,this.update({value:s})}get placeholder(){return this._placeholder}set placeholder(s){this._placeholder=s,this.update({placeholder:s})}get buttons(){return this._buttons}set buttons(s){this._buttons=s.slice(),this._handlesToButtons.clear(),s.forEach((v,a)=>{const E=v===C.QuickInputButtons.Back?-1:a;this._handlesToButtons.set(E,v)}),this.update({buttons:s.map((v,a)=>({...r(v),tooltip:v.tooltip,handle:v===C.QuickInputButtons.Back?-1:a}))})}show(){this._visible=!0,this._expectingHide=!0,this.update({visible:!0})}hide(){this._visible=!1,this.update({visible:!1})}_fireDidAccept(){this._onDidAcceptEmitter.fire()}_fireDidChangeValue(s){this._value=s,this._onDidChangeValueEmitter.fire(s)}_fireDidTriggerButton(s){const v=this._handlesToButtons.get(s);v&&this._onDidTriggerButtonEmitter.fire(v)}_fireDidHide(){this._expectingHide&&(this._expectingHide=this._visible,this._onDidHideEmitter.fire())}dispose(){this._disposed||(this._disposed=!0,this._fireDidHide(),this._disposables=(0,P.dispose)(this._disposables),this._updateTimeout&&(clearTimeout(this._updateTimeout),this._updateTimeout=void 0),this._onDidDispose(),b.$dispose(this._id))}update(s){if(!this._disposed){for(const v of Object.keys(s)){const a=s[v];this._pendingUpdate[v]=a===void 0?null:a}"visible"in this._pendingUpdate?(this._updateTimeout&&(clearTimeout(this._updateTimeout),this._updateTimeout=void 0),this.dispatchUpdate()):this._visible&&!this._updateTimeout&&(this._updateTimeout=setTimeout(()=>{this._updateTimeout=void 0,this.dispatchUpdate()},0))}}dispatchUpdate(){b.$createOrUpdate(this._pendingUpdate),this._pendingUpdate={id:this._id}}}g._nextId=1;function A(f){if(f instanceof C.ThemeIcon)return{id:f.id};const s=M(f),v=l(f);return{dark:typeof s=="string"?T.URI.file(s):s,light:typeof v=="string"?T.URI.file(v):v}}function l(f){return typeof f=="object"&&"light"in f?f.light:f}function M(f){return typeof f=="object"&&"dark"in f?f.dark:f}function r(f){const s=A(f.iconPath);let v,a;return"id"in s?a=n.ThemeIcon.asClassName(s):v=s,{iconPath:v,iconClass:a}}class i extends g{constructor(s,v){super(s.identifier,v);this.extension=s,this._items=[],this._handlesToItems=new Map,this._itemsToHandles=new Map,this._canSelectMany=!1,this._matchOnDescription=!0,this._matchOnDetail=!0,this._sortByLabel=!0,this._keepScrollPosition=!1,this._activeItems=[],this._onDidChangeActiveEmitter=new w.Emitter,this._selectedItems=[],this._onDidChangeSelectionEmitter=new w.Emitter,this._onDidTriggerItemButtonEmitter=new w.Emitter,this.onDidChangeActive=this._onDidChangeActiveEmitter.event,this.onDidChangeSelection=this._onDidChangeSelectionEmitter.event,this.onDidTriggerItemButton=this._onDidTriggerItemButtonEmitter.event,this._disposables.push(this._onDidChangeActiveEmitter,this._onDidChangeSelectionEmitter,this._onDidTriggerItemButtonEmitter),this.update({type:"quickPick"})}get items(){return this._items}set items(s){s.some(a=>a.kind!==void 0)&&(0,m.checkProposedApiEnabled)(this.extension,"quickPickSeparators"),this._items=s.slice(),this._handlesToItems.clear(),this._itemsToHandles.clear(),s.forEach((a,E)=>{this._handlesToItems.set(E,a),this._itemsToHandles.set(a,E)});const v=[];for(let a=0;a<s.length;a++){const E=s[a];E.kind===C.QuickPickItemKind.Separator?v.push({type:"separator",label:E.label}):v.push({handle:a,label:E.label,description:E.description,detail:E.detail,picked:E.picked,alwaysShow:E.alwaysShow,buttons:E.buttons?.map((I,D)=>({...r(I),tooltip:I.tooltip,handle:D}))})}this.update({items:v})}get canSelectMany(){return this._canSelectMany}set canSelectMany(s){this._canSelectMany=s,this.update({canSelectMany:s})}get matchOnDescription(){return this._matchOnDescription}set matchOnDescription(s){this._matchOnDescription=s,this.update({matchOnDescription:s})}get matchOnDetail(){return this._matchOnDetail}set matchOnDetail(s){this._matchOnDetail=s,this.update({matchOnDetail:s})}get sortByLabel(){return this._sortByLabel}set sortByLabel(s){this._sortByLabel=s,this.update({sortByLabel:s})}get keepScrollPosition(){return this._keepScrollPosition}set keepScrollPosition(s){this._keepScrollPosition=s,this.update({keepScrollPosition:s})}get activeItems(){return this._activeItems}set activeItems(s){this._activeItems=s.filter(v=>this._itemsToHandles.has(v)),this.update({activeItems:this._activeItems.map(v=>this._itemsToHandles.get(v))})}get selectedItems(){return this._selectedItems}set selectedItems(s){this._selectedItems=s.filter(v=>this._itemsToHandles.has(v)),this.update({selectedItems:this._selectedItems.map(v=>this._itemsToHandles.get(v))})}_fireDidChangeActive(s){const v=(0,R.coalesce)(s.map(a=>this._handlesToItems.get(a)));this._activeItems=v,this._onDidChangeActiveEmitter.fire(v)}_fireDidChangeSelection(s){const v=(0,R.coalesce)(s.map(a=>this._handlesToItems.get(a)));this._selectedItems=v,this._onDidChangeSelectionEmitter.fire(v)}_fireDidTriggerItemButton(s,v){const a=this._handlesToItems.get(s);if(!a||!a.buttons||!a.buttons.length)return;const E=a.buttons[v];E&&this._onDidTriggerItemButtonEmitter.fire({button:E,item:a})}}class p extends g{constructor(s,v){super(s,v);this._password=!1,this.update({type:"inputBox"})}get password(){return this._password}set password(s){this._password=s,this.update({password:s})}get prompt(){return this._prompt}set prompt(s){this._prompt=s,this.update({prompt:s})}get validationMessage(){return this._validationMessage}set validationMessage(s){this._validationMessage=s,this.update({validationMessage:s,severity:s?_.default.Error:_.default.Ignore})}}return new h(u,S)}e.createExtHostQuickOpen=o}),define(Ee[199],_e([0,1,2,3,51,6,14,5,16,105,12,25,62,8,27]),function(re,e,c,F,w,P,t,T,C,k,R,_,n,m,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostSCM=e.ExtHostSCMInputBox=void 0;function d(f){if(f)return typeof f.iconPath=="string"?c.URI.file(f.iconPath):c.URI.isUri(f.iconPath)||n.ThemeIcon.isThemeIcon(f.iconPath)?f.iconPath:void 0}function u(f,s){if(!f.iconPath&&!s.iconPath)return 0;if(f.iconPath){if(!s.iconPath)return 1}else return-1;const v=typeof f.iconPath=="string"?f.iconPath:c.URI.isUri(f.iconPath)?f.iconPath.fsPath:f.iconPath.id,a=typeof s.iconPath=="string"?s.iconPath:c.URI.isUri(s.iconPath)?s.iconPath.fsPath:s.iconPath.id;return(0,k.comparePaths)(v,a)}function S(f,s){let v=0;if(f.strikeThrough!==s.strikeThrough)return f.strikeThrough?1:-1;if(f.faded!==s.faded)return f.faded?1:-1;if(f.tooltip!==s.tooltip)return(f.tooltip||"").localeCompare(s.tooltip||"");if(v=u(f,s),v!==0)return v;if(f.light&&s.light)v=u(f.light,s.light);else{if(f.light)return 1;if(s.light)return-1}if(v!==0)return v;if(f.dark&&s.dark)v=u(f.dark,s.dark);else{if(f.dark)return 1;if(s.dark)return-1}return v}function b(f,s){if(f.command!==s.command)return f.command<s.command?-1:1;if(f.title!==s.title)return f.title<s.title?-1:1;if(f.tooltip!==s.tooltip){if(f.tooltip!==void 0&&s.tooltip!==void 0)return f.tooltip<s.tooltip?-1:1;if(f.tooltip!==void 0)return 1;if(s.tooltip!==void 0)return-1}if(f.arguments===s.arguments)return 0;if(f.arguments)if(s.arguments){if(f.arguments.length!==s.arguments.length)return f.arguments.length-s.arguments.length}else return 1;else return-1;for(let v=0;v<f.arguments.length;v++){const a=f.arguments[v],E=s.arguments[v];if(a!==E)return a<E?-1:1}return 0}function h(f,s){let v=(0,k.comparePaths)(f.resourceUri.fsPath,s.resourceUri.fsPath,!0);if(v!==0)return v;if(f.command&&s.command)v=b(f.command,s.command);else{if(f.command)return 1;if(s.command)return-1}if(v!==0)return v;if(f.decorations&&s.decorations)v=S(f.decorations,s.decorations);else{if(f.decorations)return 1;if(s.decorations)return-1}return v}function g(f,s){for(let v=0;v<f.length;v++)if(f[v]!==s[v])return!1;return!0}function A(f,s){return f.command===s.command&&f.title===s.title&&f.tooltip===s.tooltip&&(f.arguments&&s.arguments?g(f.arguments,s.arguments):f.arguments===s.arguments)}function l(f,s){return(0,C.equals)(f,s,A)}class M{constructor(s,v,a){this._extension=s,this._proxy=v,this._sourceControlHandle=a,this._value="",this._onDidChange=new F.Emitter,this._placeholder="",this._visible=!0}get value(){return this._value}set value(s){this._proxy.$setInputBoxValue(this._sourceControlHandle,s),this.updateValue(s)}get onDidChange(){return this._onDidChange.event}get placeholder(){return this._placeholder}set placeholder(s){this._proxy.$setInputBoxPlaceholder(this._sourceControlHandle,s),this._placeholder=s}get validateInput(){return(0,o.checkProposedApiEnabled)(this._extension,"scmValidation"),this._validateInput}set validateInput(s){if((0,o.checkProposedApiEnabled)(this._extension,"scmValidation"),s&&typeof s!="function")throw new Error(`[${this._extension.identifier.value}]: Invalid SCM input box validation function`);this._validateInput=s,this._proxy.$setValidationProviderIsEnabled(this._sourceControlHandle,!!s)}get visible(){return this._visible}set visible(s){s=!!s,this._visible!==s&&(this._visible=s,this._proxy.$setInputBoxVisibility(this._sourceControlHandle,s))}showValidationMessage(s,v){(0,o.checkProposedApiEnabled)(this._extension,"scmValidation"),this._proxy.$showValidationMessage(this._sourceControlHandle,s,v)}$onInputBoxValueChange(s){this.updateValue(s)}updateValue(s){this._value=s,this._onDidChange.fire(s)}}e.ExtHostSCMInputBox=M;class r{constructor(s,v,a,E,I){this._proxy=s,this._commands=v,this._sourceControlHandle=a,this._id=E,this._label=I,this._resourceHandlePool=0,this._resourceStates=[],this._resourceStatesMap=new Map,this._resourceStatesCommandsMap=new Map,this._resourceStatesDisposablesMap=new Map,this._onDidUpdateResourceStates=new F.Emitter,this.onDidUpdateResourceStates=this._onDidUpdateResourceStates.event,this._disposed=!1,this._onDidDispose=new F.Emitter,this.onDidDispose=this._onDidDispose.event,this._handlesSnapshot=[],this._resourceSnapshot=[],this._hideWhenEmpty=void 0,this.handle=r._handlePool++}get disposed(){return this._disposed}get id(){return this._id}get label(){return this._label}set label(s){this._label=s,this._proxy.$updateGroupLabel(this._sourceControlHandle,this.handle,s)}get hideWhenEmpty(){return this._hideWhenEmpty}set hideWhenEmpty(s){this._hideWhenEmpty=s,this._proxy.$updateGroup(this._sourceControlHandle,this.handle,this.features)}get features(){return{hideWhenEmpty:this.hideWhenEmpty}}get resourceStates(){return[...this._resourceStates]}set resourceStates(s){this._resourceStates=[...s],this._onDidUpdateResourceStates.fire()}getResourceState(s){return this._resourceStatesMap.get(s)}$executeResourceCommand(s,v){const a=this._resourceStatesCommandsMap.get(s);return a?(0,t.asPromise)(()=>this._commands.executeCommand(a.command,...a.arguments||[],v)):Promise.resolve(void 0)}_takeResourceStateSnapshot(){const s=[...this._resourceStates].sort(h),a=(0,C.sortedDiff)(this._resourceSnapshot,s,h).map(D=>{const B=D.toInsert.map(L=>{const y=this._resourceHandlePool++;this._resourceStatesMap.set(y,L);const x=L.resourceUri;let N;if(L.command)if(L.command.command==="vscode.open"||L.command.command==="vscode.diff"){const we=new P.DisposableStore;N=this._commands.converter.toInternal(L.command,we),this._resourceStatesDisposablesMap.set(y,we)}else this._resourceStatesCommandsMap.set(y,L.command);const z=d(L.decorations),H=L.decorations&&d(L.decorations.light)||z,q=L.decorations&&d(L.decorations.dark)||z,ue=[H,q],K=L.decorations&&L.decorations.tooltip||"",ce=L.decorations&&!!L.decorations.strikeThrough,de=L.decorations&&!!L.decorations.faded,Y=L.contextValue||"";return{rawResource:[y,x,ue,K,ce,de,Y,N],handle:y}});return{start:D.start,deleteCount:D.deleteCount,toInsert:B}}),E=a.map(({start:D,deleteCount:B,toInsert:L})=>[D,B,L.map(y=>y.rawResource)]),I=a.reverse();for(const{start:D,deleteCount:B,toInsert:L}of I){const y=L.map(N=>N.handle),x=this._handlesSnapshot.splice(D,B,...y);for(const N of x)this._resourceStatesMap.delete(N),this._resourceStatesCommandsMap.delete(N),this._resourceStatesDisposablesMap.get(N)?.dispose(),this._resourceStatesDisposablesMap.delete(N)}return this._resourceSnapshot=s,E}dispose(){this._disposed=!0,this._onDidDispose.fire()}}r._handlePool=0;class i{constructor(s,v,a,E,I,D){this._extension=s,this._proxy=v,this._commands=a,this._id=E,this._label=I,this._rootUri=D,this._groups=new Map,this._count=void 0,this._quickDiffProvider=void 0,this._commitTemplate=void 0,this._acceptInputDisposables=new P.MutableDisposable,this._acceptInputCommand=void 0,this._actionButtonDisposables=new P.MutableDisposable,this._statusBarDisposables=new P.MutableDisposable,this._statusBarCommands=void 0,this._selected=!1,this._onDidChangeSelection=new F.Emitter,this.onDidChangeSelection=this._onDidChangeSelection.event,this.handle=i._handlePool++,this.createdResourceGroups=new Map,this.updatedResourceGroups=new Set,this._inputBox=new M(s,this._proxy,this.handle),this._proxy.$registerSourceControl(this.handle,E,I,D)}get id(){return this._id}get label(){return this._label}get rootUri(){return this._rootUri}get inputBox(){return this._inputBox}get count(){return this._count}set count(s){this._count!==s&&(this._count=s,this._proxy.$updateSourceControl(this.handle,{count:s}))}get quickDiffProvider(){return this._quickDiffProvider}set quickDiffProvider(s){this._quickDiffProvider=s,this._proxy.$updateSourceControl(this.handle,{hasQuickDiffProvider:!!s})}get commitTemplate(){return this._commitTemplate}set commitTemplate(s){s!==this._commitTemplate&&(this._commitTemplate=s,this._proxy.$updateSourceControl(this.handle,{commitTemplate:s}))}get acceptInputCommand(){return this._acceptInputCommand}set acceptInputCommand(s){this._acceptInputDisposables.value=new P.DisposableStore,this._acceptInputCommand=s;const v=this._commands.converter.toInternal(s,this._acceptInputDisposables.value);this._proxy.$updateSourceControl(this.handle,{acceptInputCommand:v})}get actionButton(){return(0,o.checkProposedApiEnabled)(this._extension,"scmActionButton"),this._actionButton}set actionButton(s){(0,o.checkProposedApiEnabled)(this._extension,"scmActionButton"),this._actionButtonDisposables.value=new P.DisposableStore,this._actionButton=s;const v=s!==void 0?this._commands.converter.toInternal(this._actionButton,this._actionButtonDisposables.value):void 0;this._proxy.$updateSourceControl(this.handle,{actionButton:v??null})}get statusBarCommands(){return this._statusBarCommands}set statusBarCommands(s){if(this._statusBarCommands&&s&&l(this._statusBarCommands,s))return;this._statusBarDisposables.value=new P.DisposableStore,this._statusBarCommands=s;const v=(s||[]).map(a=>this._commands.converter.toInternal(a,this._statusBarDisposables.value));this._proxy.$updateSourceControl(this.handle,{statusBarCommands:v})}get selected(){return this._selected}createResourceGroup(s,v){const a=new r(this._proxy,this._commands,this.handle,s,v),E=F.Event.once(a.onDidDispose)(()=>this.createdResourceGroups.delete(a));return this.createdResourceGroups.set(a,E),this.eventuallyAddResourceGroups(),a}eventuallyAddResourceGroups(){const s=[],v=[];for(const[a,E]of this.createdResourceGroups){E.dispose();const I=a.onDidUpdateResourceStates(()=>{this.updatedResourceGroups.add(a),this.eventuallyUpdateResourceStates()});F.Event.once(a.onDidDispose)(()=>{this.updatedResourceGroups.delete(a),I.dispose(),this._groups.delete(a.handle),this._proxy.$unregisterGroup(this.handle,a.handle)}),s.push([a.handle,a.id,a.label,a.features]);const D=a._takeResourceStateSnapshot();D.length>0&&v.push([a.handle,D]),this._groups.set(a.handle,a)}this._proxy.$registerGroups(this.handle,s,v),this.createdResourceGroups.clear()}eventuallyUpdateResourceStates(){const s=[];this.updatedResourceGroups.forEach(v=>{const a=v._takeResourceStateSnapshot();a.length!==0&&s.push([v.handle,a])}),s.length>0&&this._proxy.$spliceResourceStates(this.handle,s),this.updatedResourceGroups.clear()}getResourceGroup(s){return this._groups.get(s)}setSelectionState(s){this._selected=s,this._onDidChangeSelection.fire(s)}dispose(){this._acceptInputDisposables.dispose(),this._actionButtonDisposables.dispose(),this._statusBarDisposables.dispose(),this._groups.forEach(s=>s.dispose()),this._proxy.$unregisterSourceControl(this.handle)}}i._handlePool=0,Ue([(0,w.debounce)(100)],i.prototype,"eventuallyAddResourceGroups",null),Ue([(0,w.debounce)(100)],i.prototype,"eventuallyUpdateResourceStates",null);let p=class zi{constructor(s,v,a){this._commands=v,this.logService=a,this._sourceControls=new Map,this._sourceControlsByExtension=new Map,this._onDidChangeActiveProvider=new F.Emitter,this._proxy=s.getProxy(T.MainContext.MainThreadSCM),this._telemetry=s.getProxy(T.MainContext.MainThreadTelemetry),v.registerArgumentProcessor({processArgument:E=>{if(E&&E.$mid===3){const I=this._sourceControls.get(E.sourceControlHandle);if(!I)return E;const D=I.getResourceGroup(E.groupHandle);return D?D.getResourceState(E.handle):E}else if(E&&E.$mid===4){const I=this._sourceControls.get(E.sourceControlHandle);return I?I.getResourceGroup(E.groupHandle):E}else if(E&&E.$mid===5){const I=this._sourceControls.get(E.handle);return I||E}return E}})}get onDidChangeActiveProvider(){return this._onDidChangeActiveProvider.event}createSourceControl(s,v,a,E){this.logService.trace("ExtHostSCM#createSourceControl",s.identifier.value,v,a,E),this._telemetry.$publicLog2("api/scm/createSourceControl",{extensionId:s.identifier.value});const I=zi._handlePool++,D=new i(s,this._proxy,this._commands,v,a,E);this._sourceControls.set(I,D);const B=this._sourceControlsByExtension.get(_.ExtensionIdentifier.toKey(s.identifier))||[];return B.push(D),this._sourceControlsByExtension.set(_.ExtensionIdentifier.toKey(s.identifier),B),D}getLastInputBox(s){this.logService.trace("ExtHostSCM#getLastInputBox",s.identifier.value);const v=this._sourceControlsByExtension.get(_.ExtensionIdentifier.toKey(s.identifier)),a=v&&v[v.length-1];return a&&a.inputBox}$provideOriginalResource(s,v,a){const E=c.URI.revive(v);this.logService.trace("ExtHostSCM#$provideOriginalResource",s,E.toString());const I=this._sourceControls.get(s);return!I||!I.quickDiffProvider||!I.quickDiffProvider.provideOriginalResource?Promise.resolve(null):(0,t.asPromise)(()=>I.quickDiffProvider.provideOriginalResource(E,a)).then(D=>D||null)}$onInputBoxValueChange(s,v){this.logService.trace("ExtHostSCM#$onInputBoxValueChange",s);const a=this._sourceControls.get(s);return a&&a.inputBox.$onInputBoxValueChange(v),Promise.resolve(void 0)}$executeResourceCommand(s,v,a,E){this.logService.trace("ExtHostSCM#$executeResourceCommand",s,v,a);const I=this._sourceControls.get(s);if(!I)return Promise.resolve(void 0);const D=I.getResourceGroup(v);return D?D.$executeResourceCommand(a,E):Promise.resolve(void 0)}$validateInput(s,v,a){this.logService.trace("ExtHostSCM#$validateInput",s);const E=this._sourceControls.get(s);return!E||!E.inputBox.validateInput?Promise.resolve(void 0):(0,t.asPromise)(()=>E.inputBox.validateInput(v,a)).then(I=>{if(!I)return Promise.resolve(void 0);const D=m.MarkdownString.fromStrict(I.message);return D?Promise.resolve([D,I.type]):Promise.resolve(void 0)})}$setSelectedSourceControl(s){return this.logService.trace("ExtHostSCM#$setSelectedSourceControl",s),s!==void 0&&this._sourceControls.get(s)?.setSelectionState(!0),this._selectedSourceControlHandle!==void 0&&this._sourceControls.get(this._selectedSourceControlHandle)?.setSelectionState(!1),this._selectedSourceControlHandle=s,Promise.resolve(void 0)}};p._handlePool=0,p=Ue([$e(2,R.ILogService)],p),e.ExtHostSCM=p});var Ze=this&&this.__classPrivateFieldSet||function(re,e,c,F,w){if(F==="m")throw new TypeError("Private method is not writable");if(F==="a"&&!w)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?re!==e||!w:!e.has(re))throw new TypeError("Cannot write private member to an object whose class did not declare it");return F==="a"?w.call(re,c):w?w.value=c:e.set(re,c),c},Te=this&&this.__classPrivateFieldGet||function(re,e,c,F){if(c==="a"&&!F)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?re!==e||!F:!e.has(re))throw new TypeError("Cannot read private member from an object whose class did not declare it");return c==="m"?F:c==="a"?F.call(re):F?F.value:e.get(re)};define(Ee[200],_e([0,1,7,5,122,6,8,11]),function(re,e,c,F,w,P,t,T){"use strict";var C,k;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostStatusBar=e.ExtHostStatusBarEntry=void 0;class R{constructor(o,d,u,S,b=c.StatusBarAlignment.Left,h){C.set(this,void 0),k.set(this,void 0),this._disposed=!1,this._visible=!1,this._text="",this._internalCommandRegistration=new P.DisposableStore,Ze(this,C,o,"f"),Ze(this,k,d,"f"),this._entryId=R.ID_GEN++,this._extension=u,this._id=S,this._alignment=b,this._priority=this.validatePriority(h)}validatePriority(o){if(!!(0,T.isNumber)(o))return o===Number.POSITIVE_INFINITY?Number.MAX_VALUE:o===Number.NEGATIVE_INFINITY?-Number.MAX_VALUE:o}get id(){return this._id??this._extension.identifier.value}get alignment(){return this._alignment}get priority(){return this._priority}get text(){return this._text}get name(){return this._name}get tooltip(){return this._tooltip}get color(){return this._color}get backgroundColor(){return this._backgroundColor}get command(){return this._command?.fromApi}get accessibilityInformation(){return this._accessibilityInformation}set text(o){this._text=o,this.update()}set name(o){this._name=o,this.update()}set tooltip(o){this._tooltip=o,this.update()}set color(o){this._color=o,this.update()}set backgroundColor(o){o&&!R.ALLOWED_BACKGROUND_COLORS.has(o.id)&&(o=void 0),this._backgroundColor=o,this.update()}set command(o){this._command?.fromApi!==o&&(this._internalCommandRegistration.clear(),typeof o=="string"?this._command={fromApi:o,internal:Te(this,k,"f").toInternal({title:"",command:o},this._internalCommandRegistration)}:o?this._command={fromApi:o,internal:Te(this,k,"f").toInternal(o,this._internalCommandRegistration)}:this._command=void 0,this.update())}set accessibilityInformation(o){this._accessibilityInformation=o,this.update()}show(){this._visible=!0,this.update()}hide(){clearTimeout(this._timeoutHandle),this._visible=!1,Te(this,C,"f").$dispose(this._entryId)}update(){this._disposed||!this._visible||(clearTimeout(this._timeoutHandle),this._timeoutHandle=setTimeout(()=>{this._timeoutHandle=void 0;let o;this._extension?this._id?o=`${this._extension.identifier.value}.${this._id}`:o=this._extension.identifier.value:o=this._id;let d;this._name?d=this._name:d=(0,w.localize)(0,null,this._extension.displayName||this._extension.name);let u=this._color;this._backgroundColor&&(u=R.ALLOWED_BACKGROUND_COLORS.get(this._backgroundColor.id));const S=this._tooltip?t.MarkdownString.fromStrict(this._tooltip):void 0;Te(this,C,"f").$setEntry(this._entryId,o,d,this._text,S,this._command?.internal,u,this._backgroundColor,this._alignment===c.StatusBarAlignment.Left,this._priority,this._accessibilityInformation)},0))}dispose(){this.hide(),this._disposed=!0}}e.ExtHostStatusBarEntry=R,C=new WeakMap,k=new WeakMap,R.ID_GEN=0,R.ALLOWED_BACKGROUND_COLORS=new Map([["statusBarItem.errorBackground",new c.ThemeColor("statusBarItem.errorForeground")],["statusBarItem.warningBackground",new c.ThemeColor("statusBarItem.warningForeground")]]);class _{constructor(o){this._messages=[],this._item=o.createStatusBarEntry(void 0,"status.extensionMessage",c.StatusBarAlignment.Left,Number.MIN_VALUE),this._item.name=(0,w.localize)(1,null)}dispose(){this._messages.length=0,this._item.dispose()}setMessage(o){const d={message:o};return this._messages.unshift(d),this._update(),new c.Disposable(()=>{const u=this._messages.indexOf(d);u>=0&&(this._messages.splice(u,1),this._update())})}_update(){this._messages.length>0?(this._item.text=this._messages[0].message,this._item.show()):this._item.hide()}}class n{constructor(o,d){this._proxy=o.getProxy(F.MainContext.MainThreadStatusBar),this._commands=d,this._statusMessage=new _(this)}createStatusBarEntry(o,d,u,S){return new R(this._proxy,this._commands,o,d,u,S)}setStatusBarMessage(o,d){const u=this._statusMessage.setMessage(o);let S;return typeof d=="number"?S=setTimeout(()=>u.dispose(),d):typeof d!="undefined"&&d.then(()=>u.dispose(),()=>u.dispose()),new c.Disposable(()=>{u.dispose(),clearTimeout(S)})}}e.ExtHostStatusBar=n}),define(Ee[71],_e([0,1,5,3,4]),function(re,e,c,F,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostStorage=e.ExtHostStorage=void 0;class P{constructor(T){this._onDidChangeStorage=new F.Emitter,this.onDidChangeStorage=this._onDidChangeStorage.event,this._proxy=T.getProxy(c.MainContext.MainThreadStorage)}registerExtensionStorageKeysToSync(T,C){this._proxy.$registerExtensionStorageKeysToSync(T,C)}getValue(T,C,k){return this._proxy.$getValue(T,C).then(R=>R||k)}setValue(T,C,k){return this._proxy.$setValue(T,C,k)}$acceptValue(T,C,k){this._onDidChangeStorage.fire({shared:T,key:C,value:k})}}e.ExtHostStorage=P,e.IExtHostStorage=(0,w.createDecorator)("IExtHostStorage")}),define(Ee[72],_e([0,1,4,28,12,49,2]),function(re,e,c,F,w,P,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionStoragePaths=e.IExtensionStoragePaths=void 0,e.IExtensionStoragePaths=(0,c.createDecorator)("IExtensionStoragePaths");let T=class{constructor(k,R,_){this._logService=R,this._extHostFileSystem=_,this._workspace=k.workspace??void 0,this._environment=k.environment,this.whenReady=this._getOrCreateWorkspaceStoragePath().then(n=>this._value=n)}async _getWorkspaceStorageURI(k){return t.URI.joinPath(this._environment.workspaceStorageHome,k)}async _getOrCreateWorkspaceStoragePath(){if(!this._workspace)return Promise.resolve(void 0);const k=this._workspace.id,R=await this._getWorkspaceStorageURI(k);try{return await this._extHostFileSystem.value.stat(R),this._logService.trace("[ExtHostStorage] storage dir already exists",R),R}catch{}try{return this._logService.trace("[ExtHostStorage] creating dir and metadata-file",R),await this._extHostFileSystem.value.createDirectory(R),await this._extHostFileSystem.value.writeFile(t.URI.joinPath(R,"meta.json"),new TextEncoder().encode(JSON.stringify({id:this._workspace.id,configuration:t.URI.revive(this._workspace.configuration)?.toString(),name:this._workspace.name},void 0,2))),R}catch(_){this._logService.error("[ExtHostStorage]",_);return}}workspaceValue(k){if(this._value)return t.URI.joinPath(this._value,k.identifier.value)}globalValue(k){return t.URI.joinPath(this._environment.globalStorageHome,k.identifier.value.toLowerCase())}onWillDeactivateAll(){}};T=Ue([$e(0,F.IExtHostInitDataService),$e(1,w.ILogService),$e(2,P.IExtHostConsumerFileSystem)],T),e.ExtensionStoragePaths=T}),define(Ee[39],_e([0,1,3,5,4,2,13,6,7,123,15,162,20,35,145,62,11,14]),function(re,e,c,F,w,P,t,T,C,k,R,_,n,m,o,d,u,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WorkerExtHostTerminalService=e.EnvironmentVariableCollection=e.BaseExtHostTerminalService=e.ExtHostPseudoterminal=e.ExtHostTerminal=e.IExtHostTerminalService=void 0,e.IExtHostTerminalService=(0,w.createDecorator)("IExtHostTerminalService");class b{constructor(f,s,v,a){this._proxy=f,this._id=s,this._creationOptions=v,this._name=a,this._disposed=!1,this._state={isInteractedWith:!1},this.isOpen=!1,this._creationOptions=Object.freeze(this._creationOptions),this._pidPromise=new Promise(I=>this._pidPromiseComplete=I);const E=this;this.value={get name(){return E._name||""},get processId(){return E._pidPromise},get creationOptions(){return E._creationOptions},get exitStatus(){return E._exitStatus},get state(){return E._state},sendText(I,D=!0){E._checkDisposed(),E._proxy.$sendText(E._id,I,D)},show(I){E._checkDisposed(),E._proxy.$show(E._id,I)},hide(){E._checkDisposed(),E._proxy.$hide(E._id)},dispose(){E._disposed||(E._disposed=!0,E._proxy.$dispose(E._id))},get dimensions(){if(!(E._cols===void 0||E._rows===void 0))return{columns:E._cols,rows:E._rows}}}}async create(f,s){if(typeof this._id!="string")throw new Error("Terminal has already been created");await this._proxy.$createTerminal(this._id,{name:f.name,shellPath:(0,u.withNullAsUndefined)(f.shellPath),shellArgs:(0,u.withNullAsUndefined)(f.shellArgs),cwd:(0,u.withNullAsUndefined)(f.cwd),env:(0,u.withNullAsUndefined)(f.env),icon:(0,u.withNullAsUndefined)(r(f.iconPath)),color:d.ThemeColor.isThemeColor(f.color)?f.color.id:void 0,initialText:(0,u.withNullAsUndefined)(f.message),strictEnv:(0,u.withNullAsUndefined)(f.strictEnv),hideFromUser:(0,u.withNullAsUndefined)(f.hideFromUser),isFeatureTerminal:(0,u.withNullAsUndefined)(s?.isFeatureTerminal),isExtensionOwnedTerminal:!0,useShellEnvironment:(0,u.withNullAsUndefined)(s?.useShellEnvironment),location:s?.location||this._serializeParentTerminal(f.location,s?.resolvedExtHostIdentifier)})}async createExtensionTerminal(f,s,v,a){if(typeof this._id!="string")throw new Error("Terminal has already been created");if(await this._proxy.$createTerminal(this._id,{name:this._name,isExtensionCustomPtyTerminal:!0,icon:v,color:d.ThemeColor.isThemeColor(a)?a.id:void 0,location:this._serializeParentTerminal(f,s)}),typeof this._id=="string")throw new Error("Terminal creation failed");return this._id}_serializeParentTerminal(f,s){return typeof f=="object"?"parentTerminal"in f&&f.parentTerminal&&s?{parentTerminal:s}:"viewColumn"in f?{viewColumn:f.viewColumn,preserveFocus:f.preserveFocus}:void 0:f}_checkDisposed(){if(this._disposed)throw new Error("Terminal has already been disposed")}set name(f){this._name=f}setExitCode(f){this._exitStatus=Object.freeze({code:f})}setDimensions(f,s){return f===this._cols&&s===this._rows||f===0||s===0?!1:(this._cols=f,this._rows=s,!0)}setInteractedWith(){return this._state.isInteractedWith?!1:(this._state={isInteractedWith:!0},!0)}_setProcessId(f){this._pidPromiseComplete?(this._pidPromiseComplete(f),this._pidPromiseComplete=void 0):this._pidPromise.then(s=>{s!==f&&(this._pidPromise=Promise.resolve(f))})}}e.ExtHostTerminal=b;class h{constructor(f){this._pty=f,this.id=0,this.shouldPersist=!1,this._capabilities=[],this._onProcessData=new c.Emitter,this.onProcessData=this._onProcessData.event,this._onProcessReady=new c.Emitter,this._onDidChangeProperty=new c.Emitter,this.onDidChangeProperty=this._onDidChangeProperty.event,this._onProcessExit=new c.Emitter,this.onProcessExit=this._onProcessExit.event}get capabilities(){return this._capabilities}get onProcessReady(){return this._onProcessReady.event}refreshProperty(f){throw new Error(`refreshProperty is not suppported in extension owned terminals. property: ${f}`)}updateProperty(f,s){throw new Error(`updateProperty is not suppported in extension owned terminals. property: ${f}, value: ${s}`)}async start(){}shutdown(){this._pty.close()}input(f){this._pty.handleInput?.(f)}resize(f,s){this._pty.setDimensions?.({columns:f,rows:s})}async processBinary(f){}acknowledgeDataEvent(f){}async setUnicodeVersion(f){}getInitialCwd(){return Promise.resolve("")}getCwd(){return Promise.resolve("")}getLatency(){return Promise.resolve(0)}startSendingEvents(f){this._pty.onDidWrite(s=>this._onProcessData.fire(s)),this._pty.onDidClose?.((s=void 0)=>{this._onProcessExit.fire(s===void 0?void 0:s)}),this._pty.onDidOverrideDimensions?.(s=>{s&&this._onDidChangeProperty.fire({type:"overrideDimensions",value:{cols:s.columns,rows:s.rows}})}),this._pty.onDidChangeName?.(s=>{this._onDidChangeProperty.fire({type:"title",value:s})}),this._pty.open(f||void 0),f&&this._pty.setDimensions?.(f),this._onProcessReady.fire({pid:-1,cwd:"",capabilities:this._capabilities})}}e.ExtHostPseudoterminal=h;let g=1,A=class extends T.Disposable{constructor(f,s){super();this._terminals=[],this._terminalProcesses=new Map,this._terminalProcessDisposables={},this._extensionTerminalAwaitingStart={},this._getTerminalPromises={},this._environmentVariableCollections=new Map,this._linkProviders=new Set,this._profileProviders=new Map,this._terminalLinkCache=new Map,this._terminalLinkCancellationSource=new Map,this._onDidCloseTerminal=new c.Emitter,this.onDidCloseTerminal=this._onDidCloseTerminal.event,this._onDidOpenTerminal=new c.Emitter,this.onDidOpenTerminal=this._onDidOpenTerminal.event,this._onDidChangeActiveTerminal=new c.Emitter,this.onDidChangeActiveTerminal=this._onDidChangeActiveTerminal.event,this._onDidChangeTerminalDimensions=new c.Emitter,this.onDidChangeTerminalDimensions=this._onDidChangeTerminalDimensions.event,this._onDidChangeTerminalState=new c.Emitter,this.onDidChangeTerminalState=this._onDidChangeTerminalState.event,this._proxy=s.getProxy(F.MainContext.MainThreadTerminalService),this._bufferer=new o.TerminalDataBufferer(this._proxy.$sendProcessData),this._onDidWriteTerminalData=new c.Emitter({onFirstListenerAdd:()=>this._proxy.$startSendingDataEvents(),onLastListenerRemove:()=>this._proxy.$stopSendingDataEvents()}),this._proxy.$registerProcessSupport(f),this._register({dispose:()=>{for(const[v,a]of this._terminalProcesses)a.shutdown(!0)}})}get activeTerminal(){return this._activeTerminal?.value}get terminals(){return this._terminals.map(f=>f.value)}get onDidWriteTerminalData(){return this._onDidWriteTerminalData.event}getDefaultShell(f){return(f?this._defaultAutomationProfile:this._defaultProfile)?.path||""}getDefaultShellArgs(f){return(f?this._defaultAutomationProfile:this._defaultProfile)?.args||[]}createExtensionTerminal(f,s){const v=new b(this._proxy,(0,m.generateUuid)(),f,f.name),a=new h(f.pty);return v.createExtensionTerminal(f.location,this._serializeParentTerminal(f,s).resolvedExtHostIdentifier,r(f.iconPath),i(f.color)).then(E=>{const I=this._setupExtHostProcessListeners(E,a);this._terminalProcessDisposables[E]=I}),this._terminals.push(v),v.value}_serializeParentTerminal(f,s){if(s=s||{},f.location&&typeof f.location=="object"&&"parentTerminal"in f.location){const v=f.location.parentTerminal;if(v){const a=this._terminals.find(E=>E.value===v);a&&(s.resolvedExtHostIdentifier=a._id)}}else f.location&&typeof f.location!="object"?s.location=f.location:s.location&&typeof s.location=="object"&&"splitActiveTerminal"in s.location&&(s.location={splitActiveTerminal:!0});return s}attachPtyToTerminal(f,s){if(!this._getTerminalById(f))throw new Error(`Cannot resolve terminal with id ${f} for virtual process`);const a=new h(s),E=this._setupExtHostProcessListeners(f,a);this._terminalProcessDisposables[f]=E}async $acceptActiveTerminalChanged(f){const s=this._activeTerminal;if(f===null){this._activeTerminal=void 0,s!==this._activeTerminal&&this._onDidChangeActiveTerminal.fire(this._activeTerminal);return}const v=this._getTerminalById(f);v&&(this._activeTerminal=v,s!==this._activeTerminal&&this._onDidChangeActiveTerminal.fire(this._activeTerminal.value))}async $acceptTerminalProcessData(f,s){const v=this._getTerminalById(f);v&&this._onDidWriteTerminalData.fire({terminal:v.value,data:s})}async $acceptTerminalDimensions(f,s,v){const a=this._getTerminalById(f);a&&a.setDimensions(s,v)&&this._onDidChangeTerminalDimensions.fire({terminal:a.value,dimensions:a.value.dimensions})}async $acceptTerminalMaximumDimensions(f,s,v){this._terminalProcesses.get(f)?.resize(s,v)}async $acceptTerminalTitleChange(f,s){const v=this._getTerminalById(f);v&&(v.name=s)}async $acceptTerminalClosed(f,s){const v=this._getTerminalObjectIndexById(this._terminals,f);if(v!==null){const a=this._terminals.splice(v,1)[0];a.setExitCode(s),this._onDidCloseTerminal.fire(a.value)}}$acceptTerminalOpened(f,s,v,a){if(s){const D=this._getTerminalObjectIndexById(this._terminals,s);if(D!==null){this._terminals[D]._id=f,this._onDidOpenTerminal.fire(this.terminals[D]),this._terminals[D].isOpen=!0;return}}const E={name:a.name,shellPath:a.executable,shellArgs:a.args,cwd:typeof a.cwd=="string"?a.cwd:P.URI.revive(a.cwd),env:a.env,hideFromUser:a.hideFromUser},I=new b(this._proxy,f,E,v);this._terminals.push(I),this._onDidOpenTerminal.fire(I.value),I.isOpen=!0}async $acceptTerminalProcessId(f,s){const v=this._getTerminalById(f);v&&v._setProcessId(s)}async $startExtensionTerminal(f,s){const v=this._getTerminalById(f);if(!v)return{message:(0,k.localize)(0,null,f)};v.isOpen||await new Promise(E=>{const I=this.onDidOpenTerminal(async D=>{D===v.value&&(I.dispose(),E())})});const a=this._terminalProcesses.get(f);a?a.startSendingEvents(s):this._extensionTerminalAwaitingStart[f]={initialDimensions:s}}_setupExtHostProcessListeners(f,s){const v=new T.DisposableStore;v.add(s.onProcessReady(E=>this._proxy.$sendProcessReady(f,E.pid,E.cwd))),v.add(s.onDidChangeProperty(E=>this._proxy.$sendProcessProperty(f,E))),this._bufferer.startBuffering(f,s.onProcessData),v.add(s.onProcessExit(E=>this._onProcessExit(f,E))),this._terminalProcesses.set(f,s);const a=this._extensionTerminalAwaitingStart[f];return a&&s instanceof h&&(s.startSendingEvents(a.initialDimensions),delete this._extensionTerminalAwaitingStart[f]),v}$acceptProcessAckDataEvent(f,s){this._terminalProcesses.get(f)?.acknowledgeDataEvent(s)}$acceptProcessInput(f,s){this._terminalProcesses.get(f)?.input(s)}$acceptTerminalInteraction(f){const s=this._getTerminalById(f);s?.setInteractedWith()&&this._onDidChangeTerminalState.fire(s.value)}$acceptProcessResize(f,s,v){try{this._terminalProcesses.get(f)?.resize(s,v)}catch(a){if(a.code!=="EPIPE"&&a.code!=="ERR_IPC_CHANNEL_CLOSED")throw a}}$acceptProcessShutdown(f,s){this._terminalProcesses.get(f)?.shutdown(s)}$acceptProcessRequestInitialCwd(f){this._terminalProcesses.get(f)?.getInitialCwd().then(s=>this._proxy.$sendProcessProperty(f,{type:"initialCwd",value:s}))}$acceptProcessRequestCwd(f){this._terminalProcesses.get(f)?.getCwd().then(s=>this._proxy.$sendProcessProperty(f,{type:"cwd",value:s}))}$acceptProcessRequestLatency(f){return f}registerLinkProvider(f){return this._linkProviders.add(f),this._linkProviders.size===1&&this._proxy.$startLinkProvider(),new C.Disposable(()=>{this._linkProviders.delete(f),this._linkProviders.size===0&&this._proxy.$stopLinkProvider()})}registerProfileProvider(f,s,v){if(this._profileProviders.has(s))throw new Error(`Terminal profile provider "${s}" already registered`);return this._profileProviders.set(s,v),this._proxy.$registerProfileProvider(s,f.identifier.value),new C.Disposable(()=>{this._profileProviders.delete(s),this._proxy.$unregisterProfileProvider(s)})}async $createContributedProfileTerminal(f,s){const v=new n.CancellationTokenSource().token;let a=await this._profileProviders.get(f)?.provideTerminalProfile(v);if(!v.isCancellationRequested){if(a&&!("options"in a)&&(a={options:a}),!a||!("options"in a))throw new Error(`No terminal profile options provided for id "${f}"`);if("pty"in a.options){this.createExtensionTerminal(a.options,s);return}this.createTerminalFromOptions(a.options,s)}}async $provideLinks(f,s){const v=this._getTerminalById(f);if(!v)return[];this._terminalLinkCache.delete(f);const a=this._terminalLinkCancellationSource.get(f);a&&a.dispose(!0);const E=new n.CancellationTokenSource;this._terminalLinkCancellationSource.set(f,E);const I=[],D={terminal:v.value,line:s},B=[];for(const x of this._linkProviders)B.push(S.Promises.withAsyncBody(async N=>{E.token.onCancellationRequested(()=>N({provider:x,links:[]}));const z=await x.provideTerminalLinks(D,E.token)||[];E.token.isCancellationRequested||N({provider:x,links:z})}));const L=await Promise.all(B);if(E.token.isCancellationRequested)return[];const y=new Map;for(const x of L)x&&x.links.length>0&&I.push(...x.links.map(N=>{const z={id:g++,startIndex:N.startIndex,length:N.length,label:N.tooltip};return y.set(z.id,{provider:x.provider,link:N}),z}));return this._terminalLinkCache.set(f,y),I}$activateLink(f,s){const v=this._terminalLinkCache.get(f)?.get(s);!v||v.provider.handleTerminalLink(v.link)}_onProcessExit(f,s){this._bufferer.stopBuffering(f),this._terminalProcesses.delete(f),delete this._extensionTerminalAwaitingStart[f];const v=this._terminalProcessDisposables[f];v&&(v.dispose(),delete this._terminalProcessDisposables[f]),this._proxy.$sendProcessExit(f,s)}_getTerminalById(f){return this._getTerminalObjectById(this._terminals,f)}_getTerminalObjectById(f,s){const v=this._getTerminalObjectIndexById(f,s);return v!==null?f[v]:null}_getTerminalObjectIndexById(f,s){let v=null;return f.some((a,E)=>a._id===s?(v=E,!0):!1),v}getEnvironmentVariableCollection(f){let s=this._environmentVariableCollections.get(f.identifier.value);return s||(s=new l,this._setEnvironmentVariableCollection(f.identifier.value,s)),s}_syncEnvironmentVariableCollection(f,s){const v=(0,_.serializeEnvironmentVariableCollection)(s.map);this._proxy.$setEnvironmentVariableCollection(f,s.persistent,v.length===0?void 0:v)}$initEnvironmentVariableCollections(f){f.forEach(s=>{const v=s[0],a=new l(s[1]);this._setEnvironmentVariableCollection(v,a)})}$acceptDefaultProfile(f,s){this._defaultProfile=f,this._defaultAutomationProfile=s}_setEnvironmentVariableCollection(f,s){this._environmentVariableCollections.set(f,s),s.onDidChangeCollection(()=>{this._syncEnvironmentVariableCollection(f,s)})}};A=Ue([$e(1,t.IExtHostRpcService)],A),e.BaseExtHostTerminalService=A;class l{constructor(f){this.map=new Map,this._persistent=!0,this._onDidChangeCollection=new c.Emitter,this.map=new Map(f)}get persistent(){return this._persistent}set persistent(f){this._persistent=f,this._onDidChangeCollection.fire()}get onDidChangeCollection(){return this._onDidChangeCollection&&this._onDidChangeCollection.event}get size(){return this.map.size}replace(f,s){this._setIfDiffers(f,{value:s,type:C.EnvironmentVariableMutatorType.Replace})}append(f,s){this._setIfDiffers(f,{value:s,type:C.EnvironmentVariableMutatorType.Append})}prepend(f,s){this._setIfDiffers(f,{value:s,type:C.EnvironmentVariableMutatorType.Prepend})}_setIfDiffers(f,s){const v=this.map.get(f);(!v||v.value!==s.value||v.type!==s.type)&&(this.map.set(f,s),this._onDidChangeCollection.fire())}get(f){return this.map.get(f)}forEach(f,s){this.map.forEach((v,a)=>f.call(s,a,v,this))}delete(f){this.map.delete(f),this._onDidChangeCollection.fire()}clear(){this.map.clear(),this._onDidChangeCollection.fire()}}e.EnvironmentVariableCollection=l;let M=class extends A{constructor(f){super(!1,f)}createTerminal(f,s,v){throw new R.NotSupportedError}createTerminalFromOptions(f,s){throw new R.NotSupportedError}};M=Ue([$e(0,t.IExtHostRpcService)],M),e.WorkerExtHostTerminalService=M;function r(p){if(!(!p||typeof p=="string"))return"id"in p?{id:p.id,color:p.color}:p}function i(p){return d.ThemeColor.isThemeColor(p)?p:void 0}});var Ze=this&&this.__classPrivateFieldSet||function(re,e,c,F,w){if(F==="m")throw new TypeError("Private method is not writable");if(F==="a"&&!w)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?re!==e||!w:!e.has(re))throw new TypeError("Cannot write private member to an object whose class did not declare it");return F==="a"?w.call(re,c):w?w.value=c:e.set(re,c),c},Te=this&&this.__classPrivateFieldGet||function(re,e,c,F){if(c==="a"&&!F)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?re!==e||!F:!e.has(re))throw new TypeError("Cannot read private member from an object whose class did not declare it");return c==="m"?F:c==="a"?F.call(re):F?F.value:e.get(re)};define(Ee[201],_e([0,1,16,22,20,3,230,57,6,26,11,35,5,13,47,8,7,170,88,67]),function(re,e,c,F,w,P,t,T,C,k,R,_,n,m,o,d,u,S,b,h){"use strict";var g;Object.defineProperty(e,"__esModule",{value:!0}),e.TestRunProfileImpl=e.MirroredTestCollection=e.TestRunDto=e.TestRunCoordinator=e.ExtHostTesting=void 0;let A=class{constructor(D,B){this.resultsChangedEmitter=new P.Emitter,this.controllers=new Map,this.onResultsChanged=this.resultsChangedEmitter.event,this.results=[],this.proxy=D.getProxy(n.MainContext.MainThreadTesting),this.observer=new v(this.proxy),this.runTracker=new M(this.proxy),B.registerArgumentProcessor({processArgument:L=>L?.$mid===13?d.TestItem.toItemFromContext(L):L})}createTestController(D,B){if(this.controllers.has(D))throw new Error(`Attempt to insert a duplicate controller with ID "${D}"`);const L=new C.DisposableStore,y=L.add(new S.SingleUseTestCollection(D));y.root.label=B;const x=new Map,N=this.proxy,z={items:y.root.children,get label(){return B},set label(q){B=q,y.root.label=q,N.$updateControllerLabel(D,B)},get id(){return D},createRunProfile:(q,ue,K,ce,de)=>{let Y=(0,T.hash)(q);for(;x.has(Y);)Y++;const ie=new a(this.proxy,D,Y,q,ue,K,ce,de);return x.set(Y,ie),ie},createTestItem(q,ue,K){return new o.TestItemImpl(D,q,ue,K)},createTestRun:(q,ue,K=!0)=>this.runTracker.createTestRun(D,y,q,ue,K),set resolveHandler(q){y.resolveHandler=q},get resolveHandler(){return y.resolveHandler},dispose:()=>{L.dispose()}};z.createRunConfiguration=z.createRunProfile,N.$registerTestController(D,B),L.add((0,C.toDisposable)(()=>N.$unregisterTestController(D)));const H={controller:z,collection:y,profiles:x};return this.controllers.set(D,H),L.add((0,C.toDisposable)(()=>this.controllers.delete(D))),L.add(y.onDidGenerateDiff(q=>N.$publishDiff(D,q))),z}createTestObserver(){return this.observer.checkout()}async runTests(D,B=w.CancellationToken.None){const L=r(D);if(!L)throw new Error("The request passed to `vscode.test.runTests` must include a profile");const y=this.controllers.get(L.controllerId);if(!y)throw new Error("Controller not found");await this.proxy.$runTests({targets:[{testIds:D.include?.map(x=>x.id)??[y.collection.root.id],profileGroup:E[L.kind],profileId:L.profileId,controllerId:L.controllerId}],exclude:D.exclude?.map(x=>x.id)},B)}$provideFileCoverage(D,B,L){return(0,c.mapFind)(this.runTracker.trackers,x=>x.id===D?x.getCoverage(B):void 0)?.provideFileCoverage(L)??Promise.resolve([])}$resolveFileCoverage(D,B,L,y){return(0,c.mapFind)(this.runTracker.trackers,N=>N.id===D?N.getCoverage(B):void 0)?.resolveFileCoverage(L,y)??Promise.resolve([])}$configureRunProfile(D,B){this.controllers.get(D)?.profiles.get(B)?.configureHandler?.()}$publishTestResults(D){this.results=Object.freeze(D.map(B=>(0,k.deepFreeze)(d.TestResults.to(B))).concat(this.results).sort((B,L)=>L.completedAt-B.completedAt).slice(0,32)),this.resultsChangedEmitter.fire()}async $expandTest(D,B){const L=this.controllers.get(h.TestId.fromString(D).controllerId)?.collection;L&&(await L.expand(D,B<0?Infinity:B),L.flushDiff())}$acceptDiff(D){this.observer.applyDiff(D)}async $runControllerTests(D,B){const L=this.controllers.get(D.controllerId);if(!L)return;const{collection:y,profiles:x}=L,N=x.get(D.profileId);if(!N)return;const z=D.testIds.map(K=>y.tree.get(K)).filter(R.isDefined),H=D.excludeExtIds.map(K=>L.collection.tree.get(K)).filter(R.isDefined).filter(K=>z.some(ce=>ce.fullId.compare(K.fullId)===2));if(!z.length)return;const q=new u.TestRunRequest(z.some(K=>K.actual instanceof o.TestItemRootImpl)?void 0:z.map(K=>K.actual),H.map(K=>K.actual),N),ue=this.runTracker.prepareForMainThreadTestRun(q,i.fromInternal(D,L.collection),B);try{await N.runHandler(q,B)}finally{ue.isRunning&&!B.isCancellationRequested&&await P.Event.toPromise(ue.onEnd),ue.dispose()}}$cancelExtensionTestRun(D){D===void 0?this.runTracker.cancelAllRuns():this.runTracker.cancelRunById(D)}};A=Ue([$e(0,m.IExtHostRpcService)],A),e.ExtHostTesting=A;class l extends C.Disposable{constructor(D,B,L){super();this.dto=D,this.proxy=B,this.tasks=new Map,this.sharedTestIds=new Set,this.endEmitter=this._register(new P.Emitter),this.disposed=!1,this.onEnd=this.endEmitter.event,this.cts=this._register(new w.CancellationTokenSource(L)),this._register(this.cts.token.onCancellationRequested(()=>{for(const{run:y}of this.tasks.values())y.end()}))}get isRunning(){return this.tasks.size>0}get id(){return this.dto.id}getCoverage(D){return this.tasks.get(D)?.coverage}createRun(D){const B=this.dto.id,L=this.dto.controllerId,y=(0,_.generateUuid)(),x=new p(this.proxy,B,y),N=ue=>(K,...ce)=>{if(H){console.warn(`Setting the state of test "${K.id}" is a no-op after the run ends.`);return}!this.dto.isIncluded(K)||(this.ensureTestIsKnown(K),ue(K,...ce))},z=(ue,K)=>{const ce=K instanceof Array?K.map(d.TestMessage.from):[d.TestMessage.from(K)];if(ue.uri&&ue.range){const de={range:d.Range.from(ue.range),uri:ue.uri};for(const Y of ce)Y.location=Y.location||de}this.proxy.$appendTestMessagesInRun(B,y,h.TestId.fromExtHostTestItem(ue,L).toString(),ce)};let H=!1;const q={isPersisted:this.dto.isPersisted,token:this.cts.token,name:D,get coverageProvider(){return x.coverageProvider},set coverageProvider(ue){x.coverageProvider=ue},enqueued:N(ue=>{this.proxy.$updateTestStateInRun(B,y,h.TestId.fromExtHostTestItem(ue,L).toString(),1)}),skipped:N(ue=>{this.proxy.$updateTestStateInRun(B,y,h.TestId.fromExtHostTestItem(ue,L).toString(),5)}),started:N(ue=>{this.proxy.$updateTestStateInRun(B,y,h.TestId.fromExtHostTestItem(ue,L).toString(),2)}),errored:N((ue,K,ce)=>{z(ue,K),this.proxy.$updateTestStateInRun(B,y,h.TestId.fromExtHostTestItem(ue,L).toString(),6,ce)}),failed:N((ue,K,ce)=>{z(ue,K),this.proxy.$updateTestStateInRun(B,y,h.TestId.fromExtHostTestItem(ue,L).toString(),4,ce)}),passed:N((ue,K)=>{this.proxy.$updateTestStateInRun(B,y,h.TestId.fromExtHostTestItem(ue,this.dto.controllerId).toString(),3,K)}),appendOutput:(ue,K,ce)=>{H||(ce&&(this.dto.isIncluded(ce)?this.ensureTestIsKnown(ce):ce=void 0),this.proxy.$appendOutputToRun(B,y,F.VSBuffer.fromString(ue),K&&d.location.from(K),ce&&h.TestId.fromExtHostTestItem(ce,L).toString()))},end:()=>{H||(H=!0,this.proxy.$finishedTestRunTask(B,y),this.tasks.delete(y),this.isRunning||this.dispose())}};return this.tasks.set(y,{run:q,coverage:x}),this.proxy.$startedTestRunTask(B,{id:y,name:D,running:!0}),q}dispose(){this.disposed||(this.disposed=!0,this.endEmitter.fire(),this.cts.cancel(),super.dispose())}ensureTestIsKnown(D){if(!(D instanceof o.TestItemImpl))throw new o.InvalidTestItemError(D.id);if(this.sharedTestIds.has(h.TestId.fromExtHostTestItem(D,this.dto.controllerId).toString()))return;const B=[],L=this.dto.colllection.root;for(;;){const y=d.TestItem.from(D);if(B.unshift(y),this.sharedTestIds.has(y.extId)||(this.sharedTestIds.add(y.extId),D===L))break;D=D.parent||L}this.proxy.$addTestsToRun(this.dto.controllerId,this.dto.id,B)}}class M{constructor(D){this.proxy=D,this.tracked=new Map}get trackers(){return this.tracked.values()}prepareForMainThreadTestRun(D,B,L){return this.getTracker(D,B,L)}cancelRunById(D){for(const B of this.tracked.values())if(B.id===D){B.dispose();return}}cancelAllRuns(){for(const D of this.tracked.values())D.dispose()}createTestRun(D,B,L,y,x){const N=this.tracked.get(L);if(N)return N.createRun(y);const z=i.fromPublic(D,B,L,x),H=r(L);this.proxy.$startedExtensionTestRun({controllerId:D,profile:H&&{group:E[H.kind],id:H.profileId},exclude:L.exclude?.map(ue=>ue.id)??[],id:z.id,include:L.include?.map(ue=>ue.id)??[B.root.id],persist:x});const q=this.getTracker(L,z);return q.onEnd(()=>this.proxy.$finishedExtensionTestRun(z.id)),q.createRun(y)}getTracker(D,B,L){const y=new l(B,this.proxy,L);return this.tracked.set(D,y),y.onEnd(()=>this.tracked.delete(D)),y}}e.TestRunCoordinator=M;const r=I=>{if(!!I.profile){if(!(I.profile instanceof a))throw new Error("TestRunRequest.profile is not an instance created from TestController.createRunProfile");return I.profile}};class i{constructor(D,B,L,y,x,N){this.controllerId=D,this.id=B,this.isPersisted=x,this.colllection=N,this.includePrefix=L.map(z=>z+"\0"),this.excludePrefix=y.map(z=>z+"\0")}static fromPublic(D,B,L,y){return new i(D,(0,_.generateUuid)(),L.include?.map(x=>h.TestId.fromExtHostTestItem(x,D).toString())??[D],L.exclude?.map(x=>h.TestId.fromExtHostTestItem(x,D).toString())??[],y,B)}static fromInternal(D,B){return new i(D.controllerId,D.runId,D.testIds,D.excludeExtIds,!0,B)}isIncluded(D){const B=h.TestId.fromExtHostTestItem(D,this.controllerId).toString()+"\0";for(const L of this.excludePrefix)if(B===L||B.startsWith(L))return!1;for(const L of this.includePrefix)if(B===L||B.startsWith(L))return!0;return!1}}e.TestRunDto=i;class p{constructor(D,B,L){this.proxy=D,this.runId=B,this.taskId=L}set coverageProvider(D){if(this._coverageProvider)throw new Error("The TestCoverageProvider cannot be replaced after being provided");!D||(this._coverageProvider=D,this.proxy.$signalCoverageAvailable(this.runId,this.taskId))}get coverageProvider(){return this._coverageProvider}async provideFileCoverage(D){if(!this._coverageProvider)return[];this.fileCoverage||(this.fileCoverage=(async()=>this._coverageProvider.provideFileCoverage(D))());try{return(await this.fileCoverage)?.map(d.TestCoverage.fromFile)??[]}catch(B){throw this.fileCoverage=void 0,B}}async resolveFileCoverage(D,B){const L=await this.fileCoverage;let y=L?.[D];return!this._coverageProvider||!L||!y?[]:(y.detailedCoverage||(y=L[D]=await this._coverageProvider.resolveFileCoverage?.(y,B)??y),y.detailedCoverage?.map(d.TestCoverage.fromDetailed)??[])}}class f extends b.IncrementalChangeCollector{constructor(D){super();this.emitter=D,this.added=new Set,this.updated=new Set,this.removed=new Set,this.alreadyRemoved=new Set}get isEmpty(){return this.added.size===0&&this.removed.size===0&&this.updated.size===0}add(D){this.added.add(D)}update(D){Object.assign(D.revived,d.TestItem.toPlain(D.item)),this.added.has(D)||this.updated.add(D)}remove(D){if(this.added.has(D)){this.added.delete(D);return}if(this.updated.delete(D),D.parent&&this.alreadyRemoved.has(D.parent)){this.alreadyRemoved.add(D.item.extId);return}this.removed.add(D)}getChangeEvent(){const{added:D,updated:B,removed:L}=this;return{get added(){return[...D].map(y=>y.revived)},get updated(){return[...B].map(y=>y.revived)},get removed(){return[...L].map(y=>y.revived)}}}complete(){this.isEmpty||this.emitter.fire(this.getChangeEvent())}}class s extends b.AbstractIncrementalTestCollection{constructor(){super(...arguments);this.changeEmitter=new P.Emitter,this.onDidChangeTests=this.changeEmitter.event}get rootTests(){return super.roots}getMirroredTestDataById(D){return this.items.get(D)}getMirroredTestDataByReference(D){return this.items.get(D.id)}createItem(D,B){return{...D,revived:d.TestItem.toPlain(D.item),depth:B?B.depth+1:0,children:new Set}}createChangeCollector(){return new f(this.changeEmitter)}}e.MirroredTestCollection=s;class v{constructor(D){this.proxy=D}checkout(){this.current||(this.current=this.createObserverData());const D=this.current;return D.observers++,{onDidChangeTest:D.tests.onDidChangeTests,get tests(){return[...D.tests.rootTests].map(B=>B.revived)},dispose:(0,t.once)(()=>{--D.observers==0&&(this.proxy.$unsubscribeFromDiffs(),this.current=void 0)})}}getMirroredTestDataByReference(D){return this.current?.tests.getMirroredTestDataByReference(D)}applyDiff(D){this.current?.tests.apply(D)}createObserverData(){const D=new s;return this.proxy.$subscribeToDiffs(),{observers:0,tests:D}}}class a{constructor(D,B,L,y,x,N,z=!1,H=void 0){this.controllerId=B,this.profileId=L,this._label=y,this.kind=x,this.runHandler=N,this._isDefault=z,this._tag=H,g.set(this,void 0),Ze(this,g,D,"f");const q=E[x];if(typeof q!="number")throw new Error(`Unknown TestRunProfile.group ${x}`);Te(this,g,"f").$publishTestRunProfile({profileId:L,controllerId:B,tag:H?d.TestTag.namespace(this.controllerId,H.id):null,label:y,group:q,isDefault:z,hasConfigurationHandler:!1})}get label(){return this._label}set label(D){D!==this._label&&(this._label=D,Te(this,g,"f").$updateTestRunConfig(this.controllerId,this.profileId,{label:D}))}get isDefault(){return this._isDefault}set isDefault(D){D!==this._isDefault&&(this._isDefault=D,Te(this,g,"f").$updateTestRunConfig(this.controllerId,this.profileId,{isDefault:D}))}get tag(){return this._tag}set tag(D){D?.id!==this._tag?.id&&(this._tag=D,Te(this,g,"f").$updateTestRunConfig(this.controllerId,this.profileId,{tag:D?d.TestTag.namespace(this.controllerId,D.id):null}))}get configureHandler(){return this._configureHandler}set configureHandler(D){D!==this._configureHandler&&(this._configureHandler=D,Te(this,g,"f").$updateTestRunConfig(this.controllerId,this.profileId,{hasConfigurationHandler:!!D}))}dispose(){Te(this,g,"f").$removeTestProfile(this.controllerId,this.profileId)}}e.TestRunProfileImpl=a,g=new WeakMap;const E={[u.TestRunProfileKind.Coverage]:8,[u.TestRunProfileKind.Debug]:4,[u.TestRunProfileKind.Run]:2}}),define(Ee[202],_e([0,1,3,16,5,92,8,7]),function(re,e,c,F,w,P,t,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostEditors=void 0;class C{constructor(R,_){this._extHostDocumentsAndEditors=_,this._onDidChangeTextEditorSelection=new c.Emitter,this._onDidChangeTextEditorOptions=new c.Emitter,this._onDidChangeTextEditorVisibleRanges=new c.Emitter,this._onDidChangeTextEditorViewColumn=new c.Emitter,this._onDidChangeActiveTextEditor=new c.Emitter,this._onDidChangeVisibleTextEditors=new c.Emitter,this.onDidChangeTextEditorSelection=this._onDidChangeTextEditorSelection.event,this.onDidChangeTextEditorOptions=this._onDidChangeTextEditorOptions.event,this.onDidChangeTextEditorVisibleRanges=this._onDidChangeTextEditorVisibleRanges.event,this.onDidChangeTextEditorViewColumn=this._onDidChangeTextEditorViewColumn.event,this.onDidChangeActiveTextEditor=this._onDidChangeActiveTextEditor.event,this.onDidChangeVisibleTextEditors=this._onDidChangeVisibleTextEditors.event,this._proxy=R.getProxy(w.MainContext.MainThreadTextEditors),this._extHostDocumentsAndEditors.onDidChangeVisibleTextEditors(n=>this._onDidChangeVisibleTextEditors.fire(n)),this._extHostDocumentsAndEditors.onDidChangeActiveTextEditor(n=>this._onDidChangeActiveTextEditor.fire(n))}getActiveTextEditor(){return this._extHostDocumentsAndEditors.activeEditor()}getVisibleTextEditors(R){const _=this._extHostDocumentsAndEditors.allEditors();return R?_:_.map(n=>n.value)}async showTextDocument(R,_,n){let m;typeof _=="number"?m={position:t.ViewColumn.from(_),preserveFocus:n}:typeof _=="object"?m={position:t.ViewColumn.from(_.viewColumn),preserveFocus:_.preserveFocus,selection:typeof _.selection=="object"?t.Range.from(_.selection):void 0,pinned:typeof _.preview=="boolean"?!_.preview:void 0}:m={preserveFocus:!1};const o=await this._proxy.$tryShowTextDocument(R.uri,m),d=o&&this._extHostDocumentsAndEditors.getEditor(o);if(d)return d.value;throw o?new Error(`Could NOT open editor for "${R.uri.toString()}" because another editor opened in the meantime.`):new Error(`Could NOT open editor for "${R.uri.toString()}".`)}createTextEditorDecorationType(R,_){return new P.TextEditorDecorationType(this._proxy,R,_).value}$acceptEditorPropertiesChanged(R,_){const n=this._extHostDocumentsAndEditors.getEditor(R);if(!n)throw new Error("unknown text editor");if(_.options&&n._acceptOptions(_.options),_.selections){const m=_.selections.selections.map(t.Selection.to);n._acceptSelections(m)}if(_.visibleRanges){const m=F.coalesce(_.visibleRanges.map(t.Range.to));n._acceptVisibleRanges(m)}if(_.options&&this._onDidChangeTextEditorOptions.fire({textEditor:n.value,options:{..._.options,lineNumbers:t.TextEditorLineNumbersStyle.to(_.options.lineNumbers)}}),_.selections){const m=T.TextEditorSelectionChangeKind.fromValue(_.selections.source),o=_.selections.selections.map(t.Selection.to);this._onDidChangeTextEditorSelection.fire({textEditor:n.value,selections:o,kind:m})}if(_.visibleRanges){const m=F.coalesce(_.visibleRanges.map(t.Range.to));this._onDidChangeTextEditorVisibleRanges.fire({textEditor:n.value,visibleRanges:m})}}$acceptEditorPositionData(R){for(const _ in R){const n=this._extHostDocumentsAndEditors.getEditor(_);if(!n)throw new Error("Unknown text editor");const m=t.ViewColumn.to(R[_]);n.value.viewColumn!==m&&(n._acceptViewColumn(m),this._onDidChangeTextEditorViewColumn.fire({textEditor:n.value,viewColumn:m}))}}getDiffInformation(R){return Promise.resolve(this._proxy.$getDiffInformation(R))}}e.ExtHostEditors=C}),define(Ee[203],_e([0,1,2,4,5,6,7]),function(re,e,c,F,w,P,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTimeline=e.IExtHostTimeline=void 0,e.IExtHostTimeline=(0,F.createDecorator)("IExtHostTimeline");class T{constructor(R,_){this._providers=new Map,this._itemsBySourceAndUriMap=new Map,this._proxy=R.getProxy(w.MainContext.MainThreadTimeline),_.registerArgumentProcessor({processArgument:n=>{if(n&&n.$mid===11){const m=n.uri===void 0?void 0:c.URI.revive(n.uri);return this._itemsBySourceAndUriMap.get(n.source)?.get(C(m))?.get(n.handle)}return n}})}async $getTimeline(R,_,n,m,o){return this._providers.get(R)?.provideTimeline(c.URI.revive(_),n,m,o)}registerTimelineProvider(R,_,n,m){const o=new P.DisposableStore,d=this.convertTimelineItem(_.id,m,o).bind(this);let u;_.onDidChange&&(u=_.onDidChange(b=>this._proxy.$emitTimelineChangeEvent({uri:void 0,reset:!0,...b,id:_.id}),this));const S=this._itemsBySourceAndUriMap;return this.registerTimelineProviderCore({..._,scheme:R,onDidChange:void 0,async provideTimeline(b,h,g,A){A?.resetCache&&(o.clear(),S.get(_.id)?.clear());const l=await _.provideTimeline(b,h,g);if(l==null)return;const M=d(b,A);return{...l,source:_.id,items:l.items.map(M)}},dispose(){for(const b of S.values())b.get(_.id)?.clear();u?.dispose(),o.dispose()}})}convertTimelineItem(R,_,n){return(m,o)=>{let d;if(o?.cacheResults){let u=this._itemsBySourceAndUriMap.get(R);u===void 0&&(u=new Map,this._itemsBySourceAndUriMap.set(R,u));const S=C(m);d=u.get(S),d===void 0&&(d=new Map,u.set(S,d))}return u=>{const{iconPath:S,...b}=u,h=`${R}|${u.id??u.timestamp}`;d?.set(h,u);let g,A,l;return u.iconPath&&(S instanceof t.ThemeIcon?l={id:S.id,color:S.color}:c.URI.isUri(S)?(g=S,A=S):{light:g,dark:A}=S),{...b,id:b.id??void 0,handle:h,source:R,command:u.command?_.toInternal(u.command,n):void 0,icon:g,iconDark:A,themeIcon:l,accessibilityInformation:u.accessibilityInformation}}}}registerTimelineProviderCore(R){if(this._providers.get(R.id))throw new Error(`Timeline Provider ${R.id} already exists.`);return this._proxy.$registerTimelineProvider({id:R.id,label:R.label,scheme:R.scheme}),this._providers.set(R.id,R),(0,P.toDisposable)(()=>{for(const n of this._itemsBySourceAndUriMap.values())n.get(R.id)?.clear();this._providers.delete(R.id),this._proxy.$unregisterTimelineProvider(R.id),R.dispose()})}}e.ExtHostTimeline=T;function C(k){return k?.toString()}}),define(Ee[204],_e([0,1,6,10,2,5]),function(re,e,c,F,w,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostUriOpeners=void 0;class t{constructor(C){this._openers=new Map,this._proxy=C.getProxy(P.MainContext.MainThreadUriOpeners)}registerExternalUriOpener(C,k,R,_){if(this._openers.has(k))throw new Error(`Opener with id '${k}' already registered`);const n=_.schemes.find(m=>!t.supportedSchemes.has(m));if(n)throw new Error(`Scheme '${n}' is not supported. Only http and https are currently supported.`);return this._openers.set(k,R),this._proxy.$registerUriOpener(k,_.schemes,C,_.label),(0,c.toDisposable)(()=>{this._openers.delete(k),this._proxy.$unregisterUriOpener(k)})}async $canOpenUri(C,k,R){const _=this._openers.get(C);if(!_)throw new Error(`Unknown opener with id: ${C}`);const n=w.URI.revive(k);return _.canOpenExternalUri(n,R)}async $openUri(C,k,R){const _=this._openers.get(C);if(!_)throw new Error(`Unknown opener id: '${C}'`);return _.openExternalUri(w.URI.revive(k.resolvedUri),{sourceUri:w.URI.revive(k.sourceUri)},R)}}e.ExtHostUriOpeners=t,t.supportedSchemes=new Set([F.Schemas.http,F.Schemas.https])}),define(Ee[205],_e([0,1,5,2,6,15,25]),function(re,e,c,F,w,P,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostUrls=void 0;class T{constructor(k){this.handles=new Set,this.handlers=new Map,this._proxy=k.getProxy(c.MainContext.MainThreadUrls)}registerUriHandler(k,R){if(this.handles.has(t.ExtensionIdentifier.toKey(k)))throw new Error(`Protocol handler already registered for extension ${k}`);const _=T.HandlePool++;return this.handles.add(t.ExtensionIdentifier.toKey(k)),this.handlers.set(_,R),this._proxy.$registerUriHandler(_,k),(0,w.toDisposable)(()=>{this.handles.delete(t.ExtensionIdentifier.toKey(k)),this.handlers.delete(_),this._proxy.$unregisterUriHandler(_)})}$handleExternalUri(k,R){const _=this.handlers.get(k);if(!_)return Promise.resolve(void 0);try{_.handleUri(F.URI.revive(R))}catch(n){(0,P.onUnexpectedError)(n)}return Promise.resolve(void 0)}async createAppUri(k){return F.URI.revive(await this._proxy.$createAppUri(k))}}e.ExtHostUrls=T,T.HandlePool=0});var Ze=this&&this.__classPrivateFieldSet||function(re,e,c,F,w){if(F==="m")throw new TypeError("Private method is not writable");if(F==="a"&&!w)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?re!==e||!w:!e.has(re))throw new TypeError("Cannot write private member to an object whose class did not declare it");return F==="a"?w.call(re,c):w?w.value=c:e.set(re,c),c},Te=this&&this.__classPrivateFieldGet||function(re,e,c,F){if(c==="a"&&!F)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?re!==e||!F:!e.has(re))throw new TypeError("Cannot read private member from an object whose class did not declare it");return c==="m"?F:c==="a"?F.call(re):F?F.value:e.get(re)};define(Ee[50],_e([0,1,3,10,2,132,152,66,5]),function(re,e,c,F,w,P,t,T,C){"use strict";var k,R,_,n,m,o,d,u,S,b,h,g;Object.defineProperty(e,"__esModule",{value:!0}),e.reviveOptions=e.serializeWebviewOptions=e.toExtensionData=e.ExtHostWebviews=e.shouldSerializeBuffersForPostMessage=e.ExtHostWebview=void 0;class A{constructor(v,a,E,I,D,B,L){k.set(this,void 0),R.set(this,void 0),_.set(this,void 0),n.set(this,void 0),m.set(this,void 0),o.set(this,void 0),d.set(this,""),u.set(this,void 0),S.set(this,!1),b.set(this,!1),h.set(this,!1),this._onMessageEmitter=new c.Emitter,this.onDidReceiveMessage=this._onMessageEmitter.event,g.set(this,new c.Emitter),this._onDidDispose=Te(this,g,"f").event,Ze(this,k,v,"f"),Ze(this,R,a,"f"),Ze(this,u,E,"f"),Ze(this,n,I,"f"),Ze(this,m,D,"f"),Ze(this,o,B,"f"),Ze(this,h,l(B),"f"),Ze(this,_,L,"f")}dispose(){Ze(this,S,!0,"f"),Te(this,g,"f").fire(),Te(this,g,"f").dispose(),this._onMessageEmitter.dispose()}asWebviewUri(v){return Ze(this,b,!0,"f"),(0,T.asWebviewUri)(v,Te(this,n,"f").remote)}get cspSource(){const v=Te(this,o,"f").extensionLocation;if(v.scheme===F.Schemas.https||v.scheme===F.Schemas.http){let a=v.toString();return a.endsWith("/")||(a+="/"),a+" "+T.webviewGenericCspSource}return T.webviewGenericCspSource}get html(){return this.assertNotDisposed(),Te(this,d,"f")}set html(v){this.assertNotDisposed(),Te(this,d,"f")!==v&&(Ze(this,d,v,"f"),!Te(this,b,"f")&&/(["'])vscode-resource:([^\s'"]+?)(["'])/i.test(v)&&(Ze(this,b,!0,"f"),Te(this,_,"f").report("Webview vscode-resource: uris",Te(this,o,"f"),"Please migrate to use the 'webview.asWebviewUri' api instead: https://aka.ms/vscode-webview-use-aswebviewuri")),Te(this,R,"f").$setHtml(Te(this,k,"f"),v))}get options(){return this.assertNotDisposed(),Te(this,u,"f")}set options(v){this.assertNotDisposed(),Te(this,R,"f").$setOptions(Te(this,k,"f"),i(Te(this,o,"f"),Te(this,m,"f"),v)),Ze(this,u,v,"f")}async postMessage(v){if(Te(this,S,"f"))return!1;const a=(0,t.serializeWebviewMessage)(v,{serializeBuffersForPostMessage:Te(this,h,"f")});return Te(this,R,"f").$postMessage(Te(this,k,"f"),a.message,...a.buffers)}assertNotDisposed(){if(Te(this,S,"f"))throw new Error("Webview is disposed")}}e.ExtHostWebview=A,k=new WeakMap,R=new WeakMap,_=new WeakMap,n=new WeakMap,m=new WeakMap,o=new WeakMap,d=new WeakMap,u=new WeakMap,S=new WeakMap,b=new WeakMap,h=new WeakMap,g=new WeakMap;function l(s){try{const v=(0,P.normalizeVersion)((0,P.parseVersion)(s.engines.vscode));return!!v&&v.majorBase>=1&&v.minorBase>=57}catch{return!1}}e.shouldSerializeBuffersForPostMessage=l;class M{constructor(v,a,E,I,D){this.initData=a,this.workspace=E,this._logService=I,this._deprecationService=D,this._webviews=new Map,this._webviewProxy=v.getProxy(C.MainContext.MainThreadWebviews)}$onMessage(v,a,...E){const I=this.getWebview(v);if(I){const{message:D}=(0,t.deserializeWebviewMessage)(a,E);I._onMessageEmitter.fire(D)}}$onMissingCsp(v,a){this._logService.warn(`${a} created a webview without a content security policy: https://aka.ms/vscode-webview-missing-csp`)}createNewWebview(v,a,E){const I=new A(v,this._webviewProxy,p(a),this.initData,this.workspace,E,this._deprecationService);return this._webviews.set(v,I),I._onDidDispose(()=>{this._webviews.delete(v)}),I}deleteWebview(v){this._webviews.delete(v)}getWebview(v){return this._webviews.get(v)}}e.ExtHostWebviews=M;function r(s){return{id:s.identifier,location:s.extensionLocation}}e.toExtensionData=r;function i(s,v,a){return{enableCommandUris:a.enableCommandUris,enableScripts:a.enableScripts,enableForms:a.enableForms,portMapping:a.portMapping,localResourceRoots:a.localResourceRoots||f(s,v)}}e.serializeWebviewOptions=i;function p(s){return{enableCommandUris:s.enableCommandUris,enableScripts:s.enableScripts,enableForms:s.enableForms,portMapping:s.portMapping,localResourceRoots:s.localResourceRoots?.map(v=>w.URI.from(v))}}e.reviveOptions=p;function f(s,v){return[...(v?.getWorkspaceFolders()||[]).map(a=>a.uri),s.extensionLocation]}}),define(Ee[206],_e([0,1,20,57,6,10,24,2,8,50,63,5,7]),function(re,e,c,F,w,P,t,T,C,k,R,_,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostCustomEditors=void 0;class m{constructor(l,M){this.document=l,this._storagePath=M,this._backupCounter=1,this._edits=new R.Cache("custom documents")}addEdit(l){return this._edits.add([l])}async undo(l,M){await this.getEdit(l).undo(),M||this.disposeBackup()}async redo(l,M){await this.getEdit(l).redo(),M||this.disposeBackup()}disposeEdits(l){for(const M of l)this._edits.delete(M)}getNewBackupUri(){if(!this._storagePath)throw new Error("Backup requires a valid storage path");const l=g(this.document.uri)+this._backupCounter++;return(0,t.joinPath)(this._storagePath,l)}updateBackup(l){this._backup?.delete(),this._backup=l}disposeBackup(){this._backup?.delete(),this._backup=void 0}getEdit(l){const M=this._edits.get(l,0);if(!M)throw new Error("No edit found");return M}}class o{constructor(){this._documents=new Map}get(l,M){return this._documents.get(this.key(l,M))}add(l,M,r){const i=this.key(l,M.uri);if(this._documents.has(i))throw new Error(`Document already exists for viewType:${l} resource:${M.uri}`);const p=new m(M,r);return this._documents.set(i,p),p}delete(l,M){const r=this.key(l,M.uri);this._documents.delete(r)}key(l,M){return`${l}@@@${M}`}}var d;(function(A){A[A.Text=0]="Text",A[A.Custom=1]="Custom"})(d||(d={}));class u{constructor(){this._providers=new Map}addTextProvider(l,M,r){return this.add(0,l,M,r)}addCustomProvider(l,M,r){return this.add(1,l,M,r)}get(l){return this._providers.get(l)}add(l,M,r,i){if(this._providers.has(M))throw new Error(`Provider for viewType:${M} already registered`);return this._providers.set(M,{type:l,extension:r,provider:i}),new n.Disposable(()=>this._providers.delete(M))}}class S{constructor(l,M,r,i,p){this._extHostDocuments=M,this._extensionStoragePaths=r,this._extHostWebview=i,this._extHostWebviewPanels=p,this._editorProviders=new u,this._documents=new o,this._proxy=l.getProxy(_.MainContext.MainThreadCustomEditors)}registerCustomEditorProvider(l,M,r,i){const p=new w.DisposableStore;return b(r)?(p.add(this._editorProviders.addTextProvider(M,l,r)),this._proxy.$registerTextEditorProvider((0,k.toExtensionData)(l),M,i.webviewOptions||{},{supportsMove:!!r.moveCustomTextEditor},(0,k.shouldSerializeBuffersForPostMessage)(l))):(p.add(this._editorProviders.addCustomProvider(M,l,r)),this.supportEditing(r)&&p.add(r.onDidChangeCustomDocument(f=>{const s=this.getCustomDocumentEntry(M,f.document.uri);if(h(f)){const v=s.addEdit(f);this._proxy.$onDidEdit(f.document.uri,M,v,f.label)}else this._proxy.$onContentChange(f.document.uri,M)})),this._proxy.$registerCustomEditorProvider((0,k.toExtensionData)(l),M,i.webviewOptions||{},!!i.supportsMultipleEditorsPerDocument,(0,k.shouldSerializeBuffersForPostMessage)(l))),n.Disposable.from(p,new n.Disposable(()=>{this._proxy.$unregisterEditorProvider(M)}))}async $createCustomDocument(l,M,r,i,p){const f=this._editorProviders.get(M);if(!f)throw new Error(`No provider found for '${M}'`);if(f.type!==1)throw new Error(`Invalid provide type for '${M}'`);const s=T.URI.revive(l),v=await f.provider.openCustomDocument(s,{backupId:r,untitledDocumentData:i?.buffer},p);let a;return this.supportEditing(f.provider)&&this._extensionStoragePaths&&(a=this._extensionStoragePaths.workspaceValue(f.extension)??this._extensionStoragePaths.globalValue(f.extension)),this._documents.add(M,v,a),{editable:this.supportEditing(f.provider)}}async $disposeCustomDocument(l,M){const r=this._editorProviders.get(M);if(!r)throw new Error(`No provider found for '${M}'`);if(r.type!==1)throw new Error(`Invalid provider type for '${M}'`);const i=T.URI.revive(l),{document:p}=this.getCustomDocumentEntry(M,i);this._documents.delete(M,p),p.dispose()}async $resolveWebviewEditor(l,M,r,i,p,f){const s=this._editorProviders.get(r);if(!s)throw new Error(`No provider found for '${r}'`);const v=C.ViewColumn.to(p),a=this._extHostWebview.createNewWebview(M,i.webviewOptions,s.extension),E=this._extHostWebviewPanels.createNewWebviewPanel(M,r,i.title,v,i.panelOptions,a),I=T.URI.revive(l);switch(s.type){case 1:{const{document:D}=this.getCustomDocumentEntry(r,I);return s.provider.resolveCustomEditor(D,E,f)}case 0:{const D=this._extHostDocuments.getDocument(I);return s.provider.resolveCustomTextEditor(D,E,f)}default:throw new Error("Unknown webview provider type")}}$disposeEdits(l,M,r){this.getCustomDocumentEntry(M,l).disposeEdits(r)}async $onMoveCustomEditor(l,M,r){const i=this._editorProviders.get(r);if(!i)throw new Error(`No provider found for '${r}'`);if(!i.provider.moveCustomTextEditor)throw new Error(`Provider does not implement move '${r}'`);const p=this._extHostWebviewPanels.getWebviewPanel(l);if(!p)throw new Error("No webview found");const f=T.URI.revive(M),s=this._extHostDocuments.getDocument(f);await i.provider.moveCustomTextEditor(s,p,c.CancellationToken.None)}async $undo(l,M,r,i){return this.getCustomDocumentEntry(M,l).undo(r,i)}async $redo(l,M,r,i){return this.getCustomDocumentEntry(M,l).redo(r,i)}async $revert(l,M,r){const i=this.getCustomDocumentEntry(M,l);await this.getCustomEditorProvider(M).revertCustomDocument(i.document,r),i.disposeBackup()}async $onSave(l,M,r){const i=this.getCustomDocumentEntry(M,l);await this.getCustomEditorProvider(M).saveCustomDocument(i.document,r),i.disposeBackup()}async $onSaveAs(l,M,r,i){const p=this.getCustomDocumentEntry(M,l);return this.getCustomEditorProvider(M).saveCustomDocumentAs(p.document,T.URI.revive(r),i)}async $backup(l,M,r){const i=this.getCustomDocumentEntry(M,l),f=await this.getCustomEditorProvider(M).backupCustomDocument(i.document,{destination:i.getNewBackupUri()},r);return i.updateBackup(f),f.id}getCustomDocumentEntry(l,M){const r=this._documents.get(l,T.URI.revive(M));if(!r)throw new Error("No custom document found");return r}getCustomEditorProvider(l){const r=this._editorProviders.get(l)?.provider;if(!r||!this.supportEditing(r))throw new Error("Custom document is not editable");return r}supportEditing(l){return!!l.onDidChangeCustomDocument}}e.ExtHostCustomEditors=S;function b(A){return typeof A.resolveCustomTextEditor=="function"}function h(A){return typeof A.undo=="function"&&typeof A.redo=="function"}function g(A){const l=A.scheme===P.Schemas.file||A.scheme===P.Schemas.untitled?A.fsPath:A.toString();return(0,F.hash)(l)+""}});var Ze=this&&this.__classPrivateFieldSet||function(re,e,c,F,w){if(F==="m")throw new TypeError("Private method is not writable");if(F==="a"&&!w)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?re!==e||!w:!e.has(re))throw new TypeError("Cannot write private member to an object whose class did not declare it");return F==="a"?w.call(re,c):w?w.value=c:e.set(re,c),c},Te=this&&this.__classPrivateFieldGet||function(re,e,c,F){if(c==="a"&&!F)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?re!==e||!F:!e.has(re))throw new TypeError("Cannot read private member from an object whose class did not declare it");return c==="m"?F:c==="a"?F.call(re):F?F.value:e.get(re)};define(Ee[207],_e([0,1,3,6,2,35,8,50,5,7]),function(re,e,c,F,w,P,t,T,C,k){"use strict";var R,_,n,m,o,d,u,S,b,h,g,A,l;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostWebviewPanels=void 0;class M extends F.Disposable{constructor(f,s,v,a,E,I,D){super();R.set(this,void 0),_.set(this,void 0),n.set(this,void 0),m.set(this,void 0),o.set(this,void 0),d.set(this,void 0),u.set(this,void 0),S.set(this,void 0),b.set(this,!0),h.set(this,!0),g.set(this,!1),A.set(this,this._register(new c.Emitter)),this.onDidDispose=Te(this,A,"f").event,l.set(this,this._register(new c.Emitter)),this.onDidChangeViewState=Te(this,l,"f").event,Ze(this,R,f,"f"),Ze(this,_,s,"f"),Ze(this,n,v,"f"),Ze(this,o,I,"f"),Ze(this,S,E,"f"),Ze(this,d,a,"f"),Ze(this,m,D,"f")}dispose(){Te(this,g,"f")||(Ze(this,g,!0,"f"),Te(this,A,"f").fire(),Te(this,_,"f").$disposeWebview(Te(this,R,"f")),Te(this,m,"f").dispose(),super.dispose())}get webview(){return this.assertNotDisposed(),Te(this,m,"f")}get viewType(){return this.assertNotDisposed(),Te(this,n,"f")}get title(){return this.assertNotDisposed(),Te(this,d,"f")}set title(f){this.assertNotDisposed(),Te(this,d,"f")!==f&&(Ze(this,d,f,"f"),Te(this,_,"f").$setTitle(Te(this,R,"f"),f))}get iconPath(){return this.assertNotDisposed(),Te(this,u,"f")}set iconPath(f){this.assertNotDisposed(),Te(this,u,"f")!==f&&(Ze(this,u,f,"f"),Te(this,_,"f").$setIconPath(Te(this,R,"f"),w.URI.isUri(f)?{light:f,dark:f}:f))}get options(){return Te(this,o,"f")}get viewColumn(){if(this.assertNotDisposed(),!(typeof Te(this,S,"f")=="number"&&Te(this,S,"f")<0))return Te(this,S,"f")}get active(){return this.assertNotDisposed(),Te(this,h,"f")}get visible(){return this.assertNotDisposed(),Te(this,b,"f")}_updateViewState(f){Te(this,g,"f")||(this.active!==f.active||this.visible!==f.visible||this.viewColumn!==f.viewColumn)&&(Ze(this,h,f.active,"f"),Ze(this,b,f.visible,"f"),Ze(this,S,f.viewColumn,"f"),Te(this,l,"f").fire({webviewPanel:this}))}reveal(f,s){this.assertNotDisposed(),Te(this,_,"f").$reveal(Te(this,R,"f"),{viewColumn:f?t.ViewColumn.from(f):void 0,preserveFocus:!!s})}assertNotDisposed(){if(Te(this,g,"f"))throw new Error("Webview is disposed")}}R=new WeakMap,_=new WeakMap,n=new WeakMap,m=new WeakMap,o=new WeakMap,d=new WeakMap,u=new WeakMap,S=new WeakMap,b=new WeakMap,h=new WeakMap,g=new WeakMap,A=new WeakMap,l=new WeakMap;class r{constructor(f,s,v){this.webviews=s,this.workspace=v,this._webviewPanels=new Map,this._serializers=new Map,this._proxy=f.getProxy(C.MainContext.MainThreadWebviewPanels)}static newHandle(){return(0,P.generateUuid)()}createWebviewPanel(f,s,v,a,E={}){const I=typeof a=="object"?a.viewColumn:a,D={viewColumn:t.ViewColumn.from(I),preserveFocus:typeof a=="object"&&!!a.preserveFocus},B=(0,T.shouldSerializeBuffersForPostMessage)(f),L=r.newHandle();this._proxy.$createWebviewPanel((0,T.toExtensionData)(f),L,s,{title:v,panelOptions:i(E),webviewOptions:(0,T.serializeWebviewOptions)(f,this.workspace,E),serializeBuffersForPostMessage:B},D);const y=this.webviews.createNewWebview(L,E,f);return this.createNewWebviewPanel(L,s,v,I,E,y)}$onDidChangeWebviewPanelViewStates(f){const s=Object.keys(f);s.sort((v,a)=>{const E=f[v],I=f[a];return E.active?1:I.active?-1:+E.visible-+I.visible});for(const v of s){const a=this.getWebviewPanel(v);if(!a)continue;const E=f[v];a._updateViewState({active:E.active,visible:E.visible,viewColumn:t.ViewColumn.to(E.position)})}}async $onDidDisposeWebviewPanel(f){this.getWebviewPanel(f)?.dispose(),this._webviewPanels.delete(f),this.webviews.deleteWebview(f)}registerWebviewPanelSerializer(f,s,v){if(this._serializers.has(s))throw new Error(`Serializer for '${s}' already registered`);return this._serializers.set(s,{serializer:v,extension:f}),this._proxy.$registerSerializer(s,{serializeBuffersForPostMessage:(0,T.shouldSerializeBuffersForPostMessage)(f)}),new k.Disposable(()=>{this._serializers.delete(s),this._proxy.$unregisterSerializer(s)})}async $deserializeWebviewPanel(f,s,v,a){const E=this._serializers.get(s);if(!E)throw new Error(`No serializer found for '${s}'`);const{serializer:I,extension:D}=E,B=this.webviews.createNewWebview(f,v.webviewOptions,D),L=this.createNewWebviewPanel(f,s,v.title,a,v.panelOptions,B);await I.deserializeWebviewPanel(L,v.state)}createNewWebviewPanel(f,s,v,a,E,I){const D=new M(f,this._proxy,s,v,a,E,I);return this._webviewPanels.set(f,D),D}getWebviewPanel(f){return this._webviewPanels.get(f)}}e.ExtHostWebviewPanels=r;function i(p){return{enableFindWidget:p.enableFindWidget,retainContextWhenHidden:p.retainContextWhenHidden}}});var Ze=this&&this.__classPrivateFieldSet||function(re,e,c,F,w){if(F==="m")throw new TypeError("Private method is not writable");if(F==="a"&&!w)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?re!==e||!w:!e.has(re))throw new TypeError("Cannot write private member to an object whose class did not declare it");return F==="a"?w.call(re,c):w?w.value=c:e.set(re,c),c},Te=this&&this.__classPrivateFieldGet||function(re,e,c,F){if(c==="a"&&!F)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?re!==e||!F:!e.has(re))throw new TypeError("Cannot read private member from an object whose class did not declare it");return c==="m"?F:c==="a"?F.call(re):F?F.value:e.get(re)};define(Ee[208],_e([0,1,3,6,50,5,7]),function(re,e,c,F,w,P,t){"use strict";var T,C,k,R,_,n,m,o,d,u;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostWebviewViews=void 0;class S extends F.Disposable{constructor(g,A,l,M,r,i){super();T.set(this,void 0),C.set(this,void 0),k.set(this,void 0),R.set(this,void 0),_.set(this,!1),n.set(this,void 0),m.set(this,void 0),o.set(this,void 0),d.set(this,this._register(new c.Emitter)),this.onDidChangeVisibility=Te(this,d,"f").event,u.set(this,this._register(new c.Emitter)),this.onDidDispose=Te(this,u,"f").event,Ze(this,k,l,"f"),Ze(this,m,M,"f"),Ze(this,T,g,"f"),Ze(this,C,A,"f"),Ze(this,R,r,"f"),Ze(this,n,i,"f")}dispose(){Te(this,_,"f")||(Ze(this,_,!0,"f"),Te(this,u,"f").fire(),Te(this,R,"f").dispose(),super.dispose())}get title(){return this.assertNotDisposed(),Te(this,m,"f")}set title(g){this.assertNotDisposed(),Te(this,m,"f")!==g&&(Ze(this,m,g,"f"),Te(this,C,"f").$setWebviewViewTitle(Te(this,T,"f"),g))}get description(){return this.assertNotDisposed(),Te(this,o,"f")}set description(g){this.assertNotDisposed(),Te(this,o,"f")!==g&&(Ze(this,o,g,"f"),Te(this,C,"f").$setWebviewViewDescription(Te(this,T,"f"),g))}get visible(){return Te(this,n,"f")}get webview(){return Te(this,R,"f")}get viewType(){return Te(this,k,"f")}_setVisible(g){g===Te(this,n,"f")||Te(this,_,"f")||(Ze(this,n,g,"f"),Te(this,d,"f").fire())}show(g){this.assertNotDisposed(),Te(this,C,"f").$show(Te(this,T,"f"),!!g)}assertNotDisposed(){if(Te(this,_,"f"))throw new Error("Webview is disposed")}}T=new WeakMap,C=new WeakMap,k=new WeakMap,R=new WeakMap,_=new WeakMap,n=new WeakMap,m=new WeakMap,o=new WeakMap,d=new WeakMap,u=new WeakMap;class b{constructor(g,A){this._extHostWebview=A,this._viewProviders=new Map,this._webviewViews=new Map,this._proxy=g.getProxy(P.MainContext.MainThreadWebviewViews)}registerWebviewViewProvider(g,A,l,M){if(this._viewProviders.has(A))throw new Error(`View provider for '${A}' already registered`);return this._viewProviders.set(A,{provider:l,extension:g}),this._proxy.$registerWebviewViewProvider((0,w.toExtensionData)(g),A,{retainContextWhenHidden:M?.retainContextWhenHidden,serializeBuffersForPostMessage:!1}),new t.Disposable(()=>{this._viewProviders.delete(A),this._proxy.$unregisterWebviewViewProvider(A)})}async $resolveWebviewView(g,A,l,M,r){const i=this._viewProviders.get(A);if(!i)throw new Error(`No view provider found for '${A}'`);const{provider:p,extension:f}=i,s=this._extHostWebview.createNewWebview(g,{},f),v=new S(g,this._proxy,A,l,s,!0);this._webviewViews.set(g,v),await p.resolveWebviewView(v,{state:M},r)}async $onDidChangeWebviewViewVisibility(g,A){this.getWebviewView(g)._setVisible(A)}async $disposeWebviewView(g){const A=this.getWebviewView(g);this._webviewViews.delete(g),A.dispose(),this._extHostWebview.deleteWebview(g)}getWebviewView(g){const A=this._webviewViews.get(g);if(!A)throw new Error("No webview found");return A}}e.ExtHostWebviewViews=b}),define(Ee[95],_e([0,1,3,5,2,10,9,4,13]),function(re,e,c,F,w,P,t,T,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostWindow=e.ExtHostWindow=void 0;let k=class Wi{constructor(_){this._onDidChangeWindowState=new c.Emitter,this.onDidChangeWindowState=this._onDidChangeWindowState.event,this._state=Wi.InitialState,this._proxy=_.getProxy(F.MainContext.MainThreadWindow),this._proxy.$getWindowVisibility().then(n=>this.$onDidChangeWindowFocus(n))}get state(){return this._state}$onDidChangeWindowFocus(_){_!==this._state.focused&&(this._state={...this._state,focused:_},this._onDidChangeWindowState.fire(this._state))}openUri(_,n){let m;if(typeof _=="string"){m=_;try{_=w.URI.parse(_)}catch(o){return Promise.reject(`Invalid uri - '${_}'`)}}return(0,t.isFalsyOrWhitespace)(_.scheme)?Promise.reject("Invalid scheme - cannot be empty"):_.scheme===P.Schemas.command?Promise.reject(`Invalid scheme '${_.scheme}'`):this._proxy.$openUri(_,m,n)}async asExternalUri(_,n){if((0,t.isFalsyOrWhitespace)(_.scheme))return Promise.reject("Invalid scheme - cannot be empty");const m=await this._proxy.$asExternalUri(_,n);return w.URI.from(m)}};k.InitialState={focused:!0},k=Ue([$e(0,C.IExtHostRpcService)],k),e.ExtHostWindow=k,e.IExtHostWindow=(0,T.createDecorator)("IExtHostWindow")}),define(Ee[209],_e([0,1,14,22,20,15,3,6,106,176,37]),function(re,e,c,F,w,P,t,T,C,k,R){"use strict";var _;Object.defineProperty(e,"__esModule",{value:!0}),e.RPCProtocol=e.ResponsiveState=e.RequestInitiator=e.parseJsonAndRestoreBufferRefs=e.stringifyJsonWithBufferRefs=void 0;function n(E,I){try{return JSON.stringify(E,I)}catch(D){return"null"}}const m="$$ref$$",o={[m]:-1};class d{constructor(I,D){this.jsonString=I,this.referencedBuffers=D}}function u(E,I=null,D=!1){const B=[];return{jsonString:(D?n:JSON.stringify)(E,(y,x)=>{if(typeof x=="undefined")return o;if(typeof x=="object"){if(x instanceof F.VSBuffer){const N=B.push(x)-1;return{[m]:N}}if(I)return I(y,x)}return x}),referencedBuffers:B}}e.stringifyJsonWithBufferRefs=u;function S(E,I,D){return JSON.parse(E,(B,L)=>{if(L){const y=L[m];if(typeof y=="number")return I[y];if(D&&L.$mid===1)return D.transformIncoming(L)}return L})}e.parseJsonAndRestoreBufferRefs=S;function b(E,I){return JSON.stringify(E,I)}function h(E){return E?(I,D)=>D&&D.$mid===1?E.transformOutgoing(D):D:null}var g;(function(E){E[E.LocalSide=0]="LocalSide",E[E.OtherSide=1]="OtherSide"})(g=e.RequestInitiator||(e.RequestInitiator={}));var A;(function(E){E[E.Responsive=0]="Responsive",E[E.Unresponsive=1]="Unresponsive"})(A=e.ResponsiveState||(e.ResponsiveState={}));const l=()=>{},M=Symbol.for("rpcProtocol"),r=Symbol.for("rpcProxy");class i extends T.Disposable{constructor(I,D=null,B=null){super();this[_]=!0,this._onDidChangeResponsiveState=this._register(new t.Emitter),this.onDidChangeResponsiveState=this._onDidChangeResponsiveState.event,this._protocol=I,this._logger=D,this._uriTransformer=B,this._uriReplacer=h(this._uriTransformer),this._isDisposed=!1,this._locals=[],this._proxies=[];for(let L=0,y=R.ProxyIdentifier.count;L<y;L++)this._locals[L]=null,this._proxies[L]=null;this._lastMessageId=0,this._cancelInvokedHandlers=Object.create(null),this._pendingRPCReplies={},this._responsiveState=0,this._unacknowledgedCount=0,this._unresponsiveTime=0,this._asyncCheckUresponsive=this._register(new c.RunOnceScheduler(()=>this._checkUnresponsive(),1e3)),this._protocol.onMessage(L=>this._receiveOneMessage(L))}dispose(){this._isDisposed=!0,Object.keys(this._pendingRPCReplies).forEach(I=>{this._pendingRPCReplies[I].resolveErr(P.canceled())})}drain(){return typeof this._protocol.drain=="function"?this._protocol.drain():Promise.resolve()}_onWillSendRequest(I){this._unacknowledgedCount===0&&(this._unresponsiveTime=Date.now()+i.UNRESPONSIVE_TIME),this._unacknowledgedCount++,this._asyncCheckUresponsive.isScheduled()||this._asyncCheckUresponsive.schedule()}_onDidReceiveAcknowledge(I){this._unresponsiveTime=Date.now()+i.UNRESPONSIVE_TIME,this._unacknowledgedCount--,this._unacknowledgedCount===0&&this._asyncCheckUresponsive.cancel(),this._setResponsiveState(0)}_checkUnresponsive(){this._unacknowledgedCount!==0&&(Date.now()>this._unresponsiveTime?this._setResponsiveState(1):this._asyncCheckUresponsive.schedule())}_setResponsiveState(I){this._responsiveState!==I&&(this._responsiveState=I,this._onDidChangeResponsiveState.fire(this._responsiveState))}get responsiveState(){return this._responsiveState}transformIncomingURIs(I){return this._uriTransformer?(0,C.transformIncomingURIs)(I,this._uriTransformer):I}getProxy(I){const{nid:D,sid:B}=I;return this._proxies[D]||(this._proxies[D]=this._createProxy(D,B)),this._proxies[D]}_createProxy(I,D){let B={get:(L,y)=>(typeof y=="string"&&!L[y]&&y.charCodeAt(0)===36&&(L[y]=(...x)=>this._remoteCall(I,y,x)),y===r?D:L[y])};return new Proxy(Object.create(null),B)}set(I,D){return this._locals[I.nid]=D,D}assertRegistered(I){for(let D=0,B=I.length;D<B;D++){const L=I[D];if(!this._locals[L.nid])throw new Error(`Missing actor ${L.sid} (isMain: ${L.isMain})`)}}_receiveOneMessage(I){if(this._isDisposed)return;const D=I.byteLength,B=p.read(I,0),L=B.readUInt8(),y=B.readUInt32();switch(L){case 1:case 2:{let{rpcId:x,method:N,args:z}=s.deserializeRequestJSONArgs(B);this._uriTransformer&&(z=(0,C.transformIncomingURIs)(z,this._uriTransformer)),this._receiveRequest(D,y,x,N,z,L===2);break}case 3:case 4:{let{rpcId:x,method:N,args:z}=s.deserializeRequestMixedArgs(B);this._uriTransformer&&(z=(0,C.transformIncomingURIs)(z,this._uriTransformer)),this._receiveRequest(D,y,x,N,z,L===4);break}case 5:{this._logger&&this._logger.logIncoming(D,y,0,"ack"),this._onDidReceiveAcknowledge(y);break}case 6:{this._receiveCancel(D,y);break}case 7:{this._receiveReply(D,y,void 0);break}case 9:{let x=s.deserializeReplyOKJSON(B);this._uriTransformer&&(x=(0,C.transformIncomingURIs)(x,this._uriTransformer)),this._receiveReply(D,y,x);break}case 10:{const x=s.deserializeReplyOKJSONWithBuffers(B,this._uriTransformer);this._receiveReply(D,y,x);break}case 8:{let x=s.deserializeReplyOKVSBuffer(B);this._receiveReply(D,y,x);break}case 11:{let x=s.deserializeReplyErrError(B);this._uriTransformer&&(x=(0,C.transformIncomingURIs)(x,this._uriTransformer)),this._receiveReplyErr(D,y,x);break}case 12:{this._receiveReplyErr(D,y,void 0);break}default:console.error("received unexpected message"),console.error(I)}}_receiveRequest(I,D,B,L,y,x){this._logger&&this._logger.logIncoming(I,D,1,`receiveRequest ${(0,R.getStringIdentifierForProxy)(B)}.${L}(`,y);const N=String(D);let z,H;if(x){const ue=new w.CancellationTokenSource;y.push(ue.token),z=this._invokeHandler(B,L,y),H=()=>ue.cancel()}else z=this._invokeHandler(B,L,y),H=l;this._cancelInvokedHandlers[N]=H;const q=s.serializeAcknowledged(D);this._logger&&this._logger.logOutgoing(q.byteLength,D,1,"ack"),this._protocol.send(q),z.then(ue=>{delete this._cancelInvokedHandlers[N];const K=s.serializeReplyOK(D,ue,this._uriReplacer);this._logger&&this._logger.logOutgoing(K.byteLength,D,1,"reply:",ue),this._protocol.send(K)},ue=>{delete this._cancelInvokedHandlers[N];const K=s.serializeReplyErr(D,ue);this._logger&&this._logger.logOutgoing(K.byteLength,D,1,"replyErr:",ue),this._protocol.send(K)})}_receiveCancel(I,D){this._logger&&this._logger.logIncoming(I,D,1,"receiveCancel");const B=String(D);this._cancelInvokedHandlers[B]&&this._cancelInvokedHandlers[B]()}_receiveReply(I,D,B){this._logger&&this._logger.logIncoming(I,D,0,"receiveReply:",B);const L=String(D);if(!this._pendingRPCReplies.hasOwnProperty(L))return;const y=this._pendingRPCReplies[L];delete this._pendingRPCReplies[L],y.resolveOk(B)}_receiveReplyErr(I,D,B){this._logger&&this._logger.logIncoming(I,D,0,"receiveReplyErr:",B);const L=String(D);if(!this._pendingRPCReplies.hasOwnProperty(L))return;const y=this._pendingRPCReplies[L];delete this._pendingRPCReplies[L];let x;B&&(B.$isError?(x=new Error,x.name=B.name,x.message=B.message,x.stack=B.stack):x=B),y.resolveErr(x)}_invokeHandler(I,D,B){try{return Promise.resolve(this._doInvokeHandler(I,D,B))}catch(L){return Promise.reject(L)}}_doInvokeHandler(I,D,B){const L=this._locals[I];if(!L)throw new Error("Unknown actor "+(0,R.getStringIdentifierForProxy)(I));let y=L[D];if(typeof y!="function")throw new Error("Unknown method "+D+" on actor "+(0,R.getStringIdentifierForProxy)(I));return y.apply(L,B)}_remoteCall(I,D,B){if(this._isDisposed)return Promise.reject(P.canceled());let L=null;if(B.length>0&&w.CancellationToken.isCancellationToken(B[B.length-1])&&(L=B.pop()),L&&L.isCancellationRequested)return Promise.reject(P.canceled());const y=s.serializeRequestArguments(B,this._uriReplacer),x=++this._lastMessageId,N=String(x),z=new k.LazyPromise;L&&L.onCancellationRequested(()=>{const q=s.serializeCancel(x);this._logger&&this._logger.logOutgoing(q.byteLength,x,0,"cancel"),this._protocol.send(s.serializeCancel(x))}),this._pendingRPCReplies[N]=z,this._onWillSendRequest(x);const H=s.serializeRequest(x,I,D,y,!!L);return this._logger&&this._logger.logOutgoing(H.byteLength,x,0,`request: ${(0,R.getStringIdentifierForProxy)(I)}.${D}(`,B),this._protocol.send(H),z}}e.RPCProtocol=i,_=M,i.UNRESPONSIVE_TIME=3*1e3;class p{constructor(I,D){this._buff=I,this._offset=D}static alloc(I,D,B){let L=new p(F.VSBuffer.alloc(B+1+4),0);return L.writeUInt8(I),L.writeUInt32(D),L}static read(I,D){return new p(I,D)}get buffer(){return this._buff}static sizeUInt8(){return 1}writeUInt8(I){this._buff.writeUInt8(I,this._offset),this._offset+=1}readUInt8(){const I=this._buff.readUInt8(this._offset);return this._offset+=1,I}writeUInt32(I){this._buff.writeUInt32BE(I,this._offset),this._offset+=4}readUInt32(){const I=this._buff.readUInt32BE(this._offset);return this._offset+=4,I}static sizeShortString(I){return 1+I.byteLength}writeShortString(I){this._buff.writeUInt8(I.byteLength,this._offset),this._offset+=1,this._buff.set(I,this._offset),this._offset+=I.byteLength}readShortString(){const I=this._buff.readUInt8(this._offset);this._offset+=1;const B=this._buff.slice(this._offset,this._offset+I).toString();return this._offset+=I,B}static sizeLongString(I){return 4+I.byteLength}writeLongString(I){this._buff.writeUInt32BE(I.byteLength,this._offset),this._offset+=4,this._buff.set(I,this._offset),this._offset+=I.byteLength}readLongString(){const I=this._buff.readUInt32BE(this._offset);this._offset+=4;const B=this._buff.slice(this._offset,this._offset+I).toString();return this._offset+=I,B}writeBuffer(I){this._buff.writeUInt32BE(I.byteLength,this._offset),this._offset+=4,this._buff.set(I,this._offset),this._offset+=I.byteLength}static sizeVSBuffer(I){return 4+I.byteLength}writeVSBuffer(I){this._buff.writeUInt32BE(I.byteLength,this._offset),this._offset+=4,this._buff.set(I,this._offset),this._offset+=I.byteLength}readVSBuffer(){const I=this._buff.readUInt32BE(this._offset);this._offset+=4;const D=this._buff.slice(this._offset,this._offset+I);return this._offset+=I,D}static sizeMixedArray(I){let D=0;D+=1;for(let B=0,L=I.length;B<L;B++){const y=I[B];switch(D+=1,y.type){case 1:D+=this.sizeLongString(y.value);break;case 2:D+=this.sizeVSBuffer(y.value);break;case 3:D+=this.sizeUInt32,D+=this.sizeLongString(y.value);for(let x=0;x<y.buffers.length;++x)D+=this.sizeVSBuffer(y.buffers[x]);break;case 4:break}}return D}writeMixedArray(I){this._buff.writeUInt8(I.length,this._offset),this._offset+=1;for(let D=0,B=I.length;D<B;D++){const L=I[D];switch(L.type){case 1:this.writeUInt8(1),this.writeLongString(L.value);break;case 2:this.writeUInt8(2),this.writeVSBuffer(L.value);break;case 3:this.writeUInt8(3),this.writeUInt32(L.buffers.length),this.writeLongString(L.value);for(let y=0;y<L.buffers.length;++y)this.writeBuffer(L.buffers[y]);break;case 4:this.writeUInt8(4);break}}}readMixedArray(){const I=this._buff.readUInt8(this._offset);this._offset+=1;let D=new Array(I);for(let B=0;B<I;B++)switch(this.readUInt8()){case 1:D[B]=this.readLongString();break;case 2:D[B]=this.readVSBuffer();break;case 3:const y=this.readUInt32(),x=this.readLongString(),N=[];for(let z=0;z<y;++z)N.push(this.readVSBuffer());D[B]=new R.SerializableObjectWithBuffers(S(x,N,null));break;case 4:D[B]=void 0;break}return D}}p.sizeUInt32=4;var f;(function(E){E[E.Simple=0]="Simple",E[E.Mixed=1]="Mixed"})(f||(f={}));class s{static _useMixedArgSerialization(I){for(let D=0,B=I.length;D<B;D++)if(I[D]instanceof F.VSBuffer||I[D]instanceof R.SerializableObjectWithBuffers||typeof I[D]=="undefined")return!0;return!1}static serializeRequestArguments(I,D){if(this._useMixedArgSerialization(I)){const B=[];for(let L=0,y=I.length;L<y;L++){const x=I[L];if(x instanceof F.VSBuffer)B[L]={type:2,value:x};else if(typeof x=="undefined")B[L]={type:4};else if(x instanceof R.SerializableObjectWithBuffers){const{jsonString:N,referencedBuffers:z}=u(x.value,D);B[L]={type:3,value:F.VSBuffer.fromString(N),buffers:z}}else B[L]={type:1,value:F.VSBuffer.fromString(b(x,D))}}return{type:1,args:B}}return{type:0,args:b(I,D)}}static serializeRequest(I,D,B,L,y){switch(L.type){case 0:return this._requestJSONArgs(I,D,B,L.args,y);case 1:return this._requestMixedArgs(I,D,B,L.args,y)}}static _requestJSONArgs(I,D,B,L,y){const x=F.VSBuffer.fromString(B),N=F.VSBuffer.fromString(L);let z=0;z+=p.sizeUInt8(),z+=p.sizeShortString(x),z+=p.sizeLongString(N);let H=p.alloc(y?2:1,I,z);return H.writeUInt8(D),H.writeShortString(x),H.writeLongString(N),H.buffer}static deserializeRequestJSONArgs(I){const D=I.readUInt8(),B=I.readShortString(),L=I.readLongString();return{rpcId:D,method:B,args:JSON.parse(L)}}static _requestMixedArgs(I,D,B,L,y){const x=F.VSBuffer.fromString(B);let N=0;N+=p.sizeUInt8(),N+=p.sizeShortString(x),N+=p.sizeMixedArray(L);let z=p.alloc(y?4:3,I,N);return z.writeUInt8(D),z.writeShortString(x),z.writeMixedArray(L),z.buffer}static deserializeRequestMixedArgs(I){const D=I.readUInt8(),B=I.readShortString(),L=I.readMixedArray(),y=new Array(L.length);for(let x=0,N=L.length;x<N;x++){const z=L[x];typeof z=="string"?y[x]=JSON.parse(z):y[x]=z}return{rpcId:D,method:B,args:y}}static serializeAcknowledged(I){return p.alloc(5,I,0).buffer}static serializeCancel(I){return p.alloc(6,I,0).buffer}static serializeReplyOK(I,D,B){if(typeof D=="undefined")return this._serializeReplyOKEmpty(I);if(D instanceof F.VSBuffer)return this._serializeReplyOKVSBuffer(I,D);if(D instanceof R.SerializableObjectWithBuffers){const{jsonString:L,referencedBuffers:y}=u(D.value,B,!0);return this._serializeReplyOKJSONWithBuffers(I,L,y)}else return this._serializeReplyOKJSON(I,n(D,B))}static _serializeReplyOKEmpty(I){return p.alloc(7,I,0).buffer}static _serializeReplyOKVSBuffer(I,D){let B=0;B+=p.sizeVSBuffer(D);let L=p.alloc(8,I,B);return L.writeVSBuffer(D),L.buffer}static deserializeReplyOKVSBuffer(I){return I.readVSBuffer()}static _serializeReplyOKJSON(I,D){const B=F.VSBuffer.fromString(D);let L=0;L+=p.sizeLongString(B);let y=p.alloc(9,I,L);return y.writeLongString(B),y.buffer}static _serializeReplyOKJSONWithBuffers(I,D,B){const L=F.VSBuffer.fromString(D);let y=0;y+=p.sizeUInt32,y+=p.sizeLongString(L);for(const N of B)y+=p.sizeVSBuffer(N);let x=p.alloc(10,I,y);x.writeUInt32(B.length),x.writeLongString(L);for(const N of B)x.writeBuffer(N);return x.buffer}static deserializeReplyOKJSON(I){const D=I.readLongString();return JSON.parse(D)}static deserializeReplyOKJSONWithBuffers(I,D){const B=I.readUInt32(),L=I.readLongString(),y=[];for(let x=0;x<B;++x)y.push(I.readVSBuffer());return new R.SerializableObjectWithBuffers(S(L,y,D))}static serializeReplyErr(I,D){return D?this._serializeReplyErrEror(I,D):this._serializeReplyErrEmpty(I)}static _serializeReplyErrEror(I,D){const B=F.VSBuffer.fromString(n(P.transformErrorForSerialization(D),null));let L=0;L+=p.sizeLongString(B);let y=p.alloc(11,I,L);return y.writeLongString(B),y.buffer}static deserializeReplyErrError(I){const D=I.readLongString();return JSON.parse(D)}static _serializeReplyErrEmpty(I){return p.alloc(12,I,0).buffer}}var v;(function(E){E[E.RequestJSONArgs=1]="RequestJSONArgs",E[E.RequestJSONArgsWithCancellation=2]="RequestJSONArgsWithCancellation",E[E.RequestMixedArgs=3]="RequestMixedArgs",E[E.RequestMixedArgsWithCancellation=4]="RequestMixedArgsWithCancellation",E[E.Acknowledged=5]="Acknowledged",E[E.Cancel=6]="Cancel",E[E.ReplyOKEmpty=7]="ReplyOKEmpty",E[E.ReplyOKVSBuffer=8]="ReplyOKVSBuffer",E[E.ReplyOKJSON=9]="ReplyOKJSON",E[E.ReplyOKJSONWithBuffers=10]="ReplyOKJSONWithBuffers",E[E.ReplyErrError=11]="ReplyErrError",E[E.ReplyErrEmpty=12]="ReplyErrEmpty"})(v||(v={}));var a;(function(E){E[E.String=1]="String",E[E.VSBuffer=2]="VSBuffer",E[E.SerializedObjectWithBuffers=3]="SerializedObjectWithBuffers",E[E.Undefined=4]="Undefined"})(a||(a={}))}),define(Ee[210],_e([0,1]),function(re,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NestedWorker=void 0;const c=function(P){const t=T=>{self.removeEventListener("message",t);const C=T.data;Object.defineProperties(self,{postMessage:{value(k,R){C.postMessage(k,R)}},onmessage:{get(){return C.onmessage},set(k){C.onmessage=k}}}),C.addEventListener("message",k=>{self.dispatchEvent(new MessageEvent("message",{data:k.data}))}),C.start(),self.Worker=class{constructor(){throw new TypeError("Nested workers from within nested worker are NOT supported.")}},importScripts(P)};self.addEventListener("message",t)}.toString();class F extends EventTarget{constructor(P,t,T){super();this.onmessage=null,this.onmessageerror=null,this.onerror=null;const C=`((${c})('${t}'))`,k=new Blob([C],{type:"application/javascript"}),R=URL.createObjectURL(k),_=new MessageChannel,n=R,m={type:"_newWorker",id:n,port:_.port2,url:R,options:T};P(m,[_.port2]),this.postMessage=_.port1.postMessage.bind(_.port1),this.terminate=()=>{const o={type:"_terminateWorker",id:n};_.port1.postMessage(o),URL.revokeObjectURL(R),_.port1.close(),_.port2.close()},Object.defineProperties(this,{onmessage:{get(){return _.port1.onmessage},set(o){_.port1.onmessage=o}},onmessageerror:{get(){return _.port1.onmessageerror},set(o){_.port1.onmessageerror=o}}}),_.port1.addEventListener("messageerror",o=>{const d=new MessageEvent("messageerror",{data:o.data});this.dispatchEvent(d)}),_.port1.addEventListener("message",o=>{const d=new MessageEvent("message",{data:o.data});this.dispatchEvent(d)}),_.port1.start()}}e.NestedWorker=F}),define(Ee[211],_e([0,1,4]),function(re,e,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IRemoteAgentService=e.RemoteExtensionLogFileName=void 0,e.RemoteExtensionLogFileName="remoteagent",e.IRemoteAgentService=(0,c.createDecorator)("remoteAgentService")}),define(Ee[212],_e([0,1,10,17,23,2,4,61,46,171,211]),function(re,e,c,F,w,P,t,T,C,k,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractPathService=e.IPathService=void 0,e.IPathService=(0,t.createDecorator)("pathService");let _=class Vi{constructor(m,o,d,u){this.localUserHome=m,this.remoteAgentService=o,this.environmentService=d,this.contextService=u,this.resolveOS=(async()=>(await this.remoteAgentService.getEnvironment())?.os||w.OS)(),this.resolveUserHome=(async()=>{const S=await this.remoteAgentService.getEnvironment();return this.maybeUnresolvedUserHome=S?.userHome||m})()}get defaultUriScheme(){return Vi.findDefaultUriScheme(this.environmentService,this.contextService)}static findDefaultUriScheme(m,o){if(m.remoteAuthority)return c.Schemas.vscodeRemote;const d=(0,T.getVirtualWorkspaceScheme)(o.getWorkspace());if(d)return d;const u=o.getWorkspace().folders[0];if(u)return u.uri.scheme;const S=o.getWorkspace().configuration;return S?S.scheme:c.Schemas.file}async userHome(m){return m?.preferLocal?this.localUserHome:this.resolveUserHome}get resolvedUserHome(){return this.maybeUnresolvedUserHome}get path(){return this.resolveOS.then(m=>m===1?F.win32:F.posix)}async fileURI(m){let o="";if(await this.resolveOS===1&&(m=m.replace(/\\/g,"/")),m[0]==="/"&&m[1]==="/"){const u=m.indexOf("/",2);u===-1?(o=m.substring(2),m="/"):(o=m.substring(2,u),m=m.substring(u)||"/")}return P.URI.from({scheme:c.Schemas.file,authority:o,path:m,query:"",fragment:""})}};_=Ue([$e(1,R.IRemoteAgentService),$e(2,k.IWorkbenchEnvironmentService),$e(3,C.IWorkspaceContextService)],_),e.AbstractPathService=_}),define(Ee[96],_e([0,1]),function(re,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TextSearchCompleteMessageType=e.Range=e.Position=void 0;class c{constructor(t,T){this.line=t,this.character=T}isBefore(t){return!1}isBeforeOrEqual(t){return!1}isAfter(t){return!1}isAfterOrEqual(t){return!1}isEqual(t){return!1}compareTo(t){return 0}translate(t,T){return new c(0,0)}with(t){return new c(0,0)}}e.Position=c;class F{constructor(t,T,C,k){this.isEmpty=!1,this.isSingleLine=!1,this.start=new c(t,T),this.end=new c(C,k)}contains(t){return!1}isEqual(t){return!1}intersection(t){}union(t){return new F(0,0,0,0)}with(t){return new F(0,0,0,0)}}e.Range=F;var w;(function(P){P[P.Information=1]="Information",P[P.Warning=2]="Warning"})(w=e.TextSearchCompleteMessageType||(e.TextSearchCompleteMessageType={}))}),define(Ee[40],_e([0,1,16,29,26,42,9,4,17,15,96,11]),function(re,e,c,F,w,P,t,T,C,k,R,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.QueryGlobTester=e.resolvePatternsForProvider=e.SerializableFileMatch=e.isFilePatternMatch=e.isSerializedFileMatch=e.isSerializedSearchSuccess=e.isSerializedSearchComplete=e.serializeSearchError=e.deserializeSearchError=e.SearchError=e.SearchErrorCode=e.pathIncludedInQuery=e.getExcludes=e.SearchSortOrder=e.OneLineRange=e.SearchRange=e.TextSearchMatch=e.FileMatch=e.SearchCompletionExitCode=e.isProgressMessage=e.isFileMatch=e.resultIsMatch=e.QueryType=e.SearchProviderType=e.ISearchService=e.SEARCH_EXCLUDE_CONFIG=e.VIEW_ID=e.PANEL_ID=e.VIEWLET_ID=e.TextSearchCompleteMessageType=void 0,Object.defineProperty(e,"TextSearchCompleteMessageType",{enumerable:!0,get:function(){return R.TextSearchCompleteMessageType}}),e.VIEWLET_ID="workbench.view.search",e.PANEL_ID="workbench.panel.search",e.VIEW_ID="workbench.view.search",e.SEARCH_EXCLUDE_CONFIG="search.exclude";const n="\u27EA ",m=" characters skipped \u27EB",o=(n.length+m.length+5)*2;e.ISearchService=(0,T.createDecorator)("searchService");var d;(function(q){q[q.file=0]="file",q[q.text=1]="text"})(d=e.SearchProviderType||(e.SearchProviderType={}));var u;(function(q){q[q.File=1]="File",q[q.Text=2]="Text"})(u=e.QueryType||(e.QueryType={}));function S(q){return!!q.preview}e.resultIsMatch=S;function b(q){return!!q.resource}e.isFileMatch=b;function h(q){return!!q.message}e.isProgressMessage=h;var g;(function(q){q[q.Normal=0]="Normal",q[q.NewSearchStarted=1]="NewSearchStarted"})(g=e.SearchCompletionExitCode||(e.SearchCompletionExitCode={}));class A{constructor(ue){this.resource=ue,this.results=[]}}e.FileMatch=A;class l{constructor(ue,K,ce){this.ranges=K;const de=Array.isArray(K)?K:[K];if(ce&&ce.matchLines===1&&M(de)){ue=(0,t.getNLines)(ue,ce.matchLines);let Y="",ie=0,we=0;const Me=Math.floor(ce.charsPerLine/5),Re=[];for(const Be of de){const Qe=Math.max(Be.startColumn-Me,0),Ge=Be.startColumn+ce.charsPerLine;if(Qe>we+Me+o){const Xe=n+(Qe-we)+m;Y+=Xe+ue.slice(Qe,Ge),ie+=Qe-(we+Xe.length)}else Y+=ue.slice(we,Ge);Re.push(new i(0,Be.startColumn-ie,Be.endColumn-ie)),we=Ge}this.preview={text:Y,matches:Array.isArray(this.ranges)?Re:Re[0]}}else{const Y=Array.isArray(K)?K[0].startLineNumber:K.startLineNumber;this.preview={text:ue,matches:(0,c.mapArrayOrNot)(K,ie=>new r(ie.startLineNumber-Y,ie.startColumn,ie.endLineNumber-Y,ie.endColumn))}}}}e.TextSearchMatch=l;function M(q){const ue=q[0].startLineNumber;for(const K of q)if(K.startLineNumber!==ue||K.endLineNumber!==ue)return!1;return!0}class r{constructor(ue,K,ce,de){this.startLineNumber=ue,this.startColumn=K,this.endLineNumber=ce,this.endColumn=de}}e.SearchRange=r;class i extends r{constructor(ue,K,ce){super(ue,K,ue,ce)}}e.OneLineRange=i;var p;(function(q){q.Default="default",q.FileNames="fileNames",q.Type="type",q.Modified="modified",q.CountDescending="countDescending",q.CountAscending="countAscending"})(p=e.SearchSortOrder||(e.SearchSortOrder={}));function f(q,ue=!0){const K=q&&q.files&&q.files.exclude,ce=ue&&q&&q.search&&q.search.exclude;if(!K&&!ce)return;if(!K||!ce)return K||ce;let de=Object.create(null);return de=w.mixin(de,w.deepClone(K)),de=w.mixin(de,w.deepClone(ce),!0),de}e.getExcludes=f;function s(q,ue){return q.excludePattern&&F.match(q.excludePattern,ue)?!1:q.includePattern||q.usingSearchPaths?q.includePattern&&F.match(q.includePattern,ue)?!0:q.usingSearchPaths?!!q.folderQueries&&q.folderQueries.some(K=>{const ce=K.folder.fsPath;if(P.isEqualOrParent(ue,ce)){const de=C.relative(ce,ue);return!K.includePattern||!!F.match(K.includePattern,de)}else return!1}):!1:!0}e.pathIncludedInQuery=s;var v;(function(q){q[q.unknownEncoding=1]="unknownEncoding",q[q.regexParseError=2]="regexParseError",q[q.globParseError=3]="globParseError",q[q.invalidLiteral=4]="invalidLiteral",q[q.rgProcessError=5]="rgProcessError",q[q.other=6]="other",q[q.canceled=7]="canceled"})(v=e.SearchErrorCode||(e.SearchErrorCode={}));class a extends Error{constructor(ue,K){super(ue);this.code=K}}e.SearchError=a;function E(q){const ue=q.message;if((0,k.isPromiseCanceledError)(q))return new a(ue,v.canceled);try{const K=JSON.parse(ue);return new a(K.message,K.code)}catch(K){return new a(ue,v.other)}}e.deserializeSearchError=E;function I(q){const ue={message:q.message,code:q.code};return new Error(JSON.stringify(ue))}e.serializeSearchError=I;function D(q){return q.type==="error"?!0:q.type==="success"}e.isSerializedSearchComplete=D;function B(q){return q.type==="success"}e.isSerializedSearchSuccess=B;function L(q){return!!q.path}e.isSerializedFileMatch=L;function y(q,ue){const K=q.searchPath?q.searchPath:q.relativePath;return(0,t.fuzzyContains)(K,ue)}e.isFilePatternMatch=y;class x{constructor(ue){this.path=ue,this.results=[]}addMatch(ue){this.results.push(ue)}serialize(){return{path:this.path,results:this.results,numMatches:this.results.length}}}e.SerializableFileMatch=x;function N(q,ue){const K={...q||{},...ue||{}};return Object.keys(K).filter(ce=>{const de=K[ce];return typeof de=="boolean"&&de})}e.resolvePatternsForProvider=N;class z{constructor(ue,K){this._parsedIncludeExpression=null,this._excludeExpression={...ue.excludePattern||{},...K.excludePattern||{}},this._parsedExcludeExpression=F.parse(this._excludeExpression);let ce=ue.includePattern;K.includePattern&&(ce?ce={...ce,...K.includePattern}:ce=K.includePattern),ce&&(this._parsedIncludeExpression=F.parse(ce))}matchesExcludesSync(ue,K,ce){return!!(this._parsedExcludeExpression&&this._parsedExcludeExpression(ue,K,ce))}includedInQuerySync(ue,K,ce){return!(this._parsedExcludeExpression&&this._parsedExcludeExpression(ue,K,ce)||this._parsedIncludeExpression&&!this._parsedIncludeExpression(ue,K,ce))}includedInQuery(ue,K,ce){const de=this._parsedExcludeExpression(ue,K,ce),Y=()=>this._parsedIncludeExpression?!!this._parsedIncludeExpression(ue,K,ce):!0;return(0,_.isPromise)(de)?de.then(ie=>ie?!1:Y()):Y()}hasSiblingExcludeClauses(){return H(this._excludeExpression)}}e.QueryGlobTester=z;function H(q){for(const ue in q)if(typeof q[ue]!="boolean")return!0;return!1}}),define(Ee[31],_e([0,1,16,14,20,3,21,10,75,24,9,11,2,125,4,12,138,46,30,28,13,7,40,5]),function(re,e,c,F,w,P,t,T,C,k,R,_,n,m,o,d,u,S,b,h,g,A,l,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostWorkspace=e.ExtHostWorkspace=void 0;function r(I,D,B){return new k.ExtUri(L=>s(L,B)).isEqual(I,D)}function i(I,D,B){return r(I.uri,D.uri,B)?0:(0,R.compare)(I.uri.toString(),D.uri.toString())}function p(I,D,B){return I.index!==D.index?I.index<D.index?-1:1:r(I.uri,D.uri,B)?(0,R.compare)(I.name,D.name):(0,R.compare)(I.uri.toString(),D.uri.toString())}function f(I,D,B,L){const y=I.slice(0).sort((N,z)=>B(N,z,L)),x=D.slice(0).sort((N,z)=>B(N,z,L));return(0,c.delta)(y,x,(N,z)=>B(N,z,L))}function s(I,D){const B=D.getCapabilities(I.scheme);return!(B&&B&1024)}class v extends S.Workspace{constructor(D,B,L,y,x,N,z){super(D,L.map(H=>new S.WorkspaceFolder(H)),y,x,z);this._name=B,this._isUntitled=N,this._workspaceFolders=[],this._structure=t.TernarySearchTree.forUris(z),L.forEach(H=>{this._workspaceFolders.push(H),this._structure.set(H.uri,H)})}static toExtHostWorkspace(D,B,L,y){if(!D)return{workspace:null,added:[],removed:[]};const{id:x,name:N,folders:z,configuration:H,transient:q,isUntitled:ue}=D,K=[],ce=B;B?z.forEach((we,Me)=>{const Re=n.URI.revive(we.uri),Be=v._findFolder(L||B,Re,y);Be?(Be.name=we.name,Be.index=we.index,K.push(Be)):K.push({uri:Re,name:we.name,index:Me})}):K.push(...z.map(({uri:we,name:Me,index:Re})=>({uri:n.URI.revive(we),name:Me,index:Re}))),K.sort((we,Me)=>we.index<Me.index?-1:1);const de=new v(x,N,K,!!q,H?n.URI.revive(H):null,!!ue,we=>s(we,y)),{added:Y,removed:ie}=f(ce?ce.workspaceFolders:[],de.workspaceFolders,i,y);return{workspace:de,added:Y,removed:ie}}static _findFolder(D,B,L){for(let y=0;y<D.folders.length;y++){const x=D.workspaceFolders[y];if(r(x.uri,B,L))return x}}get name(){return this._name}get isUntitled(){return this._isUntitled}get workspaceFolders(){return this._workspaceFolders.slice(0)}getWorkspaceFolder(D,B){return B&&this._structure.get(D)&&(D=(0,k.dirname)(D)),this._structure.findSubstr(D)}resolveWorkspaceFolder(D){return this._structure.get(D)}}let a=class{constructor(D,B,L,y){this._onDidChangeWorkspace=new P.Emitter,this.onDidChangeWorkspace=this._onDidChangeWorkspace.event,this._onDidGrantWorkspaceTrust=new P.Emitter,this.onDidGrantWorkspaceTrust=this._onDidGrantWorkspaceTrust.event,this._activeSearchCallbacks=[],this._trusted=!1,this._logService=y,this._extHostFileSystemInfo=L,this._requestIdProvider=new C.Counter,this._barrier=new F.Barrier,this._proxy=D.getProxy(M.MainContext.MainThreadWorkspace),this._messageService=D.getProxy(M.MainContext.MainThreadMessageService);const x=B.workspace;this._confirmedWorkspace=x?new v(x.id,x.name,[],!!x.transient,x.configuration?n.URI.revive(x.configuration):null,!!x.isUntitled,N=>s(N,L)):void 0}$initializeWorkspace(D,B){this._trusted=B,this.$acceptWorkspaceData(D),this._barrier.open()}waitForInitializeCall(){return this._barrier.wait()}get workspace(){return this._actualWorkspace}get name(){return this._actualWorkspace?this._actualWorkspace.name:void 0}get workspaceFile(){if(this._actualWorkspace&&this._actualWorkspace.configuration)return this._actualWorkspace.isUntitled?n.URI.from({scheme:T.Schemas.untitled,path:(0,k.basename)((0,k.dirname)(this._actualWorkspace.configuration))}):this._actualWorkspace.configuration}get _actualWorkspace(){return this._unconfirmedWorkspace||this._confirmedWorkspace}getWorkspaceFolders(){if(!!this._actualWorkspace)return this._actualWorkspace.workspaceFolders.slice(0)}async getWorkspaceFolders2(){if(await this._barrier.wait(),!!this._actualWorkspace)return this._actualWorkspace.workspaceFolders.slice(0)}updateWorkspaceFolders(D,B,L,...y){const x=[];if(Array.isArray(y)&&y.forEach(ue=>{n.URI.isUri(ue.uri)&&!x.some(K=>r(K.uri,ue.uri,this._extHostFileSystemInfo))&&x.push({uri:ue.uri,name:ue.name||(0,k.basenameOrAuthority)(ue.uri)})}),this._unconfirmedWorkspace||[B,L].some(ue=>typeof ue!="number"||ue<0)||L===0&&x.length===0)return!1;const N=this._actualWorkspace?this._actualWorkspace.workspaceFolders:[];if(B+L>N.length)return!1;const z=N.slice(0);z.splice(B,L,...x.map(ue=>({uri:ue.uri,name:ue.name||(0,k.basenameOrAuthority)(ue.uri),index:void 0})));for(let ue=0;ue<z.length;ue++){const K=z[ue];if(z.some((ce,de)=>de!==ue&&r(K.uri,ce.uri,this._extHostFileSystemInfo)))return!1}z.forEach((ue,K)=>ue.index=K);const{added:H,removed:q}=f(N,z,p,this._extHostFileSystemInfo);if(H.length===0&&q.length===0)return!1;if(this._proxy){const ue=D.displayName||D.name;this._proxy.$updateWorkspaceFolders(ue,B,L,x).then(void 0,K=>{this._unconfirmedWorkspace=void 0,this._messageService.$showMessage(u.Severity.Error,(0,m.localize)(0,null,ue,K.toString()),{extension:D},[])})}return this.trySetWorkspaceFolders(z),!0}getWorkspaceFolder(D,B){if(!!this._actualWorkspace)return this._actualWorkspace.getWorkspaceFolder(D,B)}async getWorkspaceFolder2(D,B){if(await this._barrier.wait(),!!this._actualWorkspace)return this._actualWorkspace.getWorkspaceFolder(D,B)}async resolveWorkspaceFolder(D){if(await this._barrier.wait(),!!this._actualWorkspace)return this._actualWorkspace.resolveWorkspaceFolder(D)}getPath(){if(!this._actualWorkspace)return;const{folders:D}=this._actualWorkspace;if(D.length!==0)return D[0].uri.fsPath}getRelativePath(D,B){let L,y="";if(typeof D=="string"?(L=n.URI.file(D),y=D):typeof D!="undefined"&&(L=D,y=D.fsPath),!L)return y;const x=this.getWorkspaceFolder(L,!0);if(!x)return y;typeof B=="undefined"&&this._actualWorkspace&&(B=this._actualWorkspace.folders.length>1);let N=(0,k.relativePath)(x.uri,L);return B&&x.name&&(N=`${x.name}/${N}`),N}trySetWorkspaceFolders(D){this._actualWorkspace&&(this._unconfirmedWorkspace=v.toExtHostWorkspace({id:this._actualWorkspace.id,name:this._actualWorkspace.name,configuration:this._actualWorkspace.configuration,folders:D,isUntitled:this._actualWorkspace.isUntitled},this._actualWorkspace,void 0,this._extHostFileSystemInfo).workspace||void 0)}$acceptWorkspaceData(D){const{workspace:B,added:L,removed:y}=v.toExtHostWorkspace(D,this._confirmedWorkspace,this._unconfirmedWorkspace,this._extHostFileSystemInfo);this._confirmedWorkspace=B||void 0,this._unconfirmedWorkspace=void 0,this._onDidChangeWorkspace.fire(Object.freeze({added:L,removed:y}))}findFiles(D,B,L,y,x=w.CancellationToken.None){this._logService.trace(`extHostWorkspace#findFiles: fileSearch, extension: ${y.value}, entryPoint: findFiles`);let N;if(B===null?N=!1:B&&(typeof B=="string"?N=B:N=B.pattern),x&&x.isCancellationRequested)return Promise.resolve([]);const{includePattern:z,folder:H}=E(D);return this._proxy.$startFileSearch((0,_.withUndefinedAsNull)(z),(0,_.withUndefinedAsNull)(H),(0,_.withUndefinedAsNull)(N),(0,_.withUndefinedAsNull)(L),x).then(q=>Array.isArray(q)?q.map(ue=>n.URI.revive(ue)):[])}async findTextInFiles(D,B,L,y,x=w.CancellationToken.None){this._logService.trace(`extHostWorkspace#findTextInFiles: textSearch, extension: ${y.value}, entryPoint: findTextInFiles`);const N=this._requestIdProvider.getNext(),z=typeof B.previewOptions=="undefined"?{matchLines:100,charsPerLine:1e4}:B.previewOptions,{includePattern:H,folder:q}=E(B.include),ue=typeof B.exclude=="string"?B.exclude:B.exclude?B.exclude.pattern:void 0,K={ignoreSymlinks:typeof B.followSymlinks=="boolean"?!B.followSymlinks:void 0,disregardIgnoreFiles:typeof B.useIgnoreFiles=="boolean"?!B.useIgnoreFiles:void 0,disregardGlobalIgnoreFiles:typeof B.useGlobalIgnoreFiles=="boolean"?!B.useGlobalIgnoreFiles:void 0,disregardExcludeSettings:typeof B.useDefaultExcludes=="boolean"?!B.useDefaultExcludes:!0,fileEncoding:B.encoding,maxResults:B.maxResults,previewOptions:z,afterContext:B.afterContext,beforeContext:B.beforeContext,includePattern:H,excludePattern:ue},ce=!1;if(this._activeSearchCallbacks[N]=de=>{if(ce)return;const Y=n.URI.revive(de.resource);de.results.forEach(ie=>{(0,l.resultIsMatch)(ie)?L({uri:Y,preview:{text:ie.preview.text,matches:(0,c.mapArrayOrNot)(ie.preview.matches,we=>new A.Range(we.startLineNumber,we.startColumn,we.endLineNumber,we.endColumn))},ranges:(0,c.mapArrayOrNot)(ie.ranges,we=>new A.Range(we.startLineNumber,we.startColumn,we.endLineNumber,we.endColumn))}):L({uri:Y,text:ie.text,lineNumber:ie.lineNumber})})},x.isCancellationRequested)return{};try{const de=await this._proxy.$startTextSearch(D,(0,_.withUndefinedAsNull)(q),K,N,x);return delete this._activeSearchCallbacks[N],de||{}}catch(de){throw delete this._activeSearchCallbacks[N],de}}$handleTextSearchResult(D,B){this._activeSearchCallbacks[B]&&this._activeSearchCallbacks[B](D)}saveAll(D){return this._proxy.$saveAll(D)}resolveProxy(D){return this._proxy.$resolveProxy(D)}get trusted(){return this._trusted}requestWorkspaceTrust(D){return this._proxy.$requestWorkspaceTrust(D)}$onDidGrantWorkspaceTrust(){this._trusted||(this._trusted=!0,this._onDidGrantWorkspaceTrust.fire())}};a=Ue([$e(0,g.IExtHostRpcService),$e(1,h.IExtHostInitDataService),$e(2,b.IExtHostFileSystemInfo),$e(3,d.ILogService)],a),e.ExtHostWorkspace=a,e.IExtHostWorkspace=(0,o.createDecorator)("IExtHostWorkspace");function E(I){let D,B;return I&&(typeof I=="string"?D=I:(D=I.pattern,B=I.baseFolder||n.URI.file(I.base))),{includePattern:D,folder:B}}}),define(Ee[32],_e([0,1,26,3,31,5,7,142,83,11,14,4,13,12,2]),function(re,e,c,F,w,P,t,T,C,k,R,_,n,m,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostConfiguration=e.ExtHostConfigProvider=e.ExtHostConfiguration=void 0;function d(M,r){if(r){const i=r.split(".");let p=M;for(let f=0;p&&f<i.length;f++)p=p[i[f]];return p}}function u(M){return M instanceof o.URI}function S(M){return M&&M.uri instanceof o.URI&&M.languageId&&typeof M.languageId=="string"}function b(M){return M&&!M.uri&&M.languageId&&typeof M.languageId=="string"}function h(M){return M&&M.uri instanceof o.URI&&(!M.name||typeof M.name=="string")&&(!M.index||typeof M.index=="number")}function g(M){if(u(M))return{resource:M};if(S(M))return{resource:M.uri,overrideIdentifier:M.languageId};if(b(M))return{overrideIdentifier:M.languageId};if(h(M))return{resource:M.uri};if(M===null)return{resource:null}}let A=class{constructor(r,i,p){this._proxy=r.getProxy(P.MainContext.MainThreadConfiguration),this._extHostWorkspace=i,this._logService=p,this._barrier=new R.Barrier,this._actual=null}getConfigProvider(){return this._barrier.wait().then(r=>this._actual)}$initializeConfiguration(r){this._actual=new l(this._proxy,this._extHostWorkspace,r,this._logService),this._barrier.open()}$acceptConfigurationChanged(r,i){this.getConfigProvider().then(p=>p.$acceptConfigurationChanged(r,i))}};A=Ue([$e(0,n.IExtHostRpcService),$e(1,w.IExtHostWorkspace),$e(2,m.ILogService)],A),e.ExtHostConfiguration=A;class l{constructor(r,i,p,f){this._onDidChangeConfiguration=new F.Emitter,this._proxy=r,this._logService=f,this._extHostWorkspace=i,this._configuration=T.Configuration.parse(p),this._configurationScopes=this._toMap(p.configurationScopes)}get onDidChangeConfiguration(){return this._onDidChangeConfiguration&&this._onDidChangeConfiguration.event}$acceptConfigurationChanged(r,i){const p={data:this._configuration.toData(),workspace:this._extHostWorkspace.workspace};this._configuration=T.Configuration.parse(r),this._configurationScopes=this._toMap(r.configurationScopes),this._onDidChangeConfiguration.fire(this._toConfigurationChangeEvent(i,p))}getConfiguration(r,i,p){const f=g(i)||{},s=this._toReadonlyValue(r?d(this._configuration.getValue(void 0,f,this._extHostWorkspace.workspace),r):this._configuration.getValue(void 0,f,this._extHostWorkspace.workspace));r&&this._validateConfigurationAccess(r,f,p?.identifier);function v(E){if(E==null)return null;if(typeof E=="boolean")return E?1:4;switch(E){case t.ConfigurationTarget.Global:return 1;case t.ConfigurationTarget.Workspace:return 4;case t.ConfigurationTarget.WorkspaceFolder:return 5}}const a={has(E){return typeof d(s,E)!="undefined"},get:(E,I)=>{this._validateConfigurationAccess(r?`${r}.${E}`:E,f,p?.identifier);let D=d(s,E);if(typeof D=="undefined")D=I;else{let B;const L=(y,x)=>{let N;const z=()=>{B=B||(0,c.deepClone)(s),N=N||d(B,x)};return(0,k.isObject)(y)?new Proxy(y,{get:(H,q)=>{if(typeof q=="string"&&q.toLowerCase()==="tojson")return z(),()=>N;if(B)return N=N||d(B,x),N[q];const ue=H[q];return typeof q=="string"?L(ue,`${x}.${q}`):ue},set:(H,q,ue)=>(z(),N&&(N[q]=ue),!0),deleteProperty:(H,q)=>(z(),N&&delete N[q],!0),defineProperty:(H,q,ue)=>(z(),N&&Object.defineProperty(N,q,ue),!0)}):y};D=L(D,E)}return D},update:(E,I,D,B)=>{E=r?`${r}.${E}`:E;const L=v(D);return I!==void 0?this._proxy.$updateConfigurationOption(L,E,I,f,B):this._proxy.$removeConfigurationOption(L,E,f,B)},inspect:E=>{E=r?`${r}.${E}`:E;const I=(0,c.deepClone)(this._configuration.inspect(E,f,this._extHostWorkspace.workspace));if(I)return{key:E,defaultValue:I.default?.value,globalValue:I.user?.value,workspaceValue:I.workspace?.value,workspaceFolderValue:I.workspaceFolder?.value,defaultLanguageValue:I.default?.override,globalLanguageValue:I.user?.override,workspaceLanguageValue:I.workspace?.override,workspaceFolderLanguageValue:I.workspaceFolder?.override,languageIds:I.overrideIdentifiers}}};return typeof s=="object"&&(0,c.mixin)(a,s,!1),Object.freeze(a)}_toReadonlyValue(r){const i=p=>(0,k.isObject)(p)?new Proxy(p,{get:(f,s)=>i(f[s]),set:(f,s,v)=>{throw new Error(`TypeError: Cannot assign to read only property '${String(s)}' of object`)},deleteProperty:(f,s)=>{throw new Error(`TypeError: Cannot delete read only property '${String(s)}' of object`)},defineProperty:(f,s)=>{throw new Error(`TypeError: Cannot define property '${String(s)}' for a readonly object`)},setPrototypeOf:f=>{throw new Error("TypeError: Cannot set prototype for a readonly object")},isExtensible:()=>!1,preventExtensions:()=>!0}):p;return i(r)}_validateConfigurationAccess(r,i,p){const f=C.OVERRIDE_PROPERTY_REGEX.test(r)?4:this._configurationScopes.get(r),s=p?`[${p.value}] `:"";if(f===4){typeof i?.resource=="undefined"&&this._logService.warn(`${s}Accessing a resource scoped configuration without providing a resource is not expected. To get the effective value for '${r}', provide the URI of a resource or 'null' for any resource.`);return}if(f===3){i?.resource&&this._logService.warn(`${s}Accessing a window scoped configuration for a resource is not expected. To associate '${r}' to a resource, define its scope to 'resource' in configuration contributions in 'package.json'.`);return}}_toConfigurationChangeEvent(r,i){const p=new T.ConfigurationChangeEvent(r,i,this._configuration,this._extHostWorkspace.workspace);return Object.freeze({affectsConfiguration:(f,s)=>p.affectsConfiguration(f,g(s))})}_toMap(r){return r.reduce((i,p)=>(i.set(p[0],p[1]),i),new Map)}}e.ExtHostConfigProvider=l,e.IExtHostConfiguration=(0,_.createDecorator)("IExtHostConfiguration")});var Ze=this&&this.__classPrivateFieldSet||function(re,e,c,F,w){if(F==="m")throw new TypeError("Private method is not writable");if(F==="a"&&!w)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?re!==e||!w:!e.has(re))throw new TypeError("Cannot write private member to an object whose class did not declare it");return F==="a"?w.call(re,c):w?w.value=c:e.set(re,c),c},Te=this&&this.__classPrivateFieldGet||function(re,e,c,F){if(c==="a"&&!F)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?re!==e||!F:!e.has(re))throw new TypeError("Cannot read private member from an object whose class did not declare it");return c==="m"?F:c==="a"?F.call(re):F?F.value:e.get(re)};define(Ee[97],_e([0,1,2,14,3,5,7,31,48,32,20,39,13,28,4,10,23,12,69,161,15]),function(re,e,c,F,w,P,t,T,C,k,R,_,n,m,o,d,u,S,b,h,g){"use strict";var A;Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostTask=e.WorkerExtHostTask=e.ExtHostTaskBase=e.TaskExecutionDTO=e.TaskFilterDTO=e.TaskDTO=e.TaskGroupDTO=e.TaskHandleDTO=e.CustomExecutionDTO=e.ShellExecutionDTO=e.ShellExecutionOptionsDTO=e.ProcessExecutionDTO=e.ProcessExecutionOptionsDTO=e.TaskPresentationOptionsDTO=e.TaskDefinitionDTO=void 0;var l;(function(x){function N(H){if(H!=null)return H}x.from=N;function z(H){if(H!=null)return H}x.to=z})(l=e.TaskDefinitionDTO||(e.TaskDefinitionDTO={}));var M;(function(x){function N(H){if(H!=null)return H}x.from=N;function z(H){if(H!=null)return H}x.to=z})(M=e.TaskPresentationOptionsDTO||(e.TaskPresentationOptionsDTO={}));var r;(function(x){function N(H){if(H!=null)return H}x.from=N;function z(H){if(H!=null)return H}x.to=z})(r=e.ProcessExecutionOptionsDTO||(e.ProcessExecutionOptionsDTO={}));var i;(function(x){function N(q){if(q){const ue=q;return ue&&!!ue.process}else return!1}x.is=N;function z(q){if(q==null)return;const ue={process:q.process,args:q.args};return q.options&&(ue.options=r.from(q.options)),ue}x.from=z;function H(q){if(q!=null)return new t.ProcessExecution(q.process,q.args,q.options)}x.to=H})(i=e.ProcessExecutionDTO||(e.ProcessExecutionDTO={}));var p;(function(x){function N(H){if(H!=null)return H}x.from=N;function z(H){if(H!=null)return H}x.to=z})(p=e.ShellExecutionOptionsDTO||(e.ShellExecutionOptionsDTO={}));var f;(function(x){function N(q){if(q){const ue=q;return ue&&(!!ue.commandLine||!!ue.command)}else return!1}x.is=N;function z(q){if(q==null)return;const ue={};return q.commandLine!==void 0?ue.commandLine=q.commandLine:(ue.command=q.command,ue.args=q.args),q.options&&(ue.options=p.from(q.options)),ue}x.from=z;function H(q){if(!(q==null||q.command===void 0&&q.commandLine===void 0))return q.commandLine?new t.ShellExecution(q.commandLine,q.options):new t.ShellExecution(q.command,q.args?q.args:[],q.options)}x.to=H})(f=e.ShellExecutionDTO||(e.ShellExecutionDTO={}));var s;(function(x){function N(q){if(q){let ue=q;return ue&&ue.customExecution==="customExecution"}else return!1}x.is=N;function z(q){return{customExecution:"customExecution"}}x.from=z;function H(q,ue){return ue.get(q)}x.to=H})(s=e.CustomExecutionDTO||(e.CustomExecutionDTO={}));var v;(function(x){function N(z,H){let q;return z.scope!==void 0&&typeof z.scope!="number"?q=z.scope.uri:z.scope!==void 0&&typeof z.scope=="number"&&(z.scope===t.TaskScope.Workspace&&H&&H.workspaceFile?q=H.workspaceFile:q=h.USER_TASKS_GROUP_KEY),{id:z._id,workspaceFolder:q}}x.from=N})(v=e.TaskHandleDTO||(e.TaskHandleDTO={}));var a;(function(x){function N(z){if(z!=null)return{_id:z.id,isDefault:z.isDefault}}x.from=N})(a=e.TaskGroupDTO||(e.TaskGroupDTO={}));var E;(function(x){function N(q,ue){if(q==null)return[];const K=[];for(let ce of q){const de=z(ce,ue);de&&K.push(de)}return K}x.fromMany=N;function z(q,ue){if(q==null)return;let K;q.execution instanceof t.ProcessExecution?K=i.from(q.execution):q.execution instanceof t.ShellExecution?K=f.from(q.execution):q.execution&&q.execution instanceof t.CustomExecution&&(K=s.from(q.execution));const ce=l.from(q.definition);let de;return q.scope?typeof q.scope=="number"?de=q.scope:de=q.scope.uri:de=t.TaskScope.Workspace,!ce||!de?void 0:{_id:q._id,definition:ce,name:q.name,source:{extensionId:ue.identifier.value,label:q.source,scope:de},execution:K,isBackground:q.isBackground,group:a.from(q.group),presentationOptions:M.from(q.presentationOptions),problemMatchers:q.problemMatchers,hasDefinedMatchers:q.hasDefinedMatchers,runOptions:q.runOptions?q.runOptions:{reevaluateOnRerun:!0},detail:q.detail}}x.from=z;async function H(q,ue,K){if(q==null)return;let ce;i.is(q.execution)?ce=i.to(q.execution):f.is(q.execution)?ce=f.to(q.execution):s.is(q.execution)&&(ce=s.to(q._id,K));const de=l.to(q.definition);let Y;if(q.source&&(q.source.scope!==void 0?typeof q.source.scope=="number"?Y=q.source.scope:Y=await ue.resolveWorkspaceFolder(c.URI.revive(q.source.scope)):Y=t.TaskScope.Workspace),!de||!Y)return;const ie=new t.Task(de,Y,q.name,q.source.label,ce,q.problemMatchers);return q.isBackground!==void 0&&(ie.isBackground=q.isBackground),q.group!==void 0&&(ie.group=t.TaskGroup.from(q.group._id),ie.group&&q.group.isDefault&&(ie.group=new t.TaskGroup(ie.group.id,ie.group.label),q.group.isDefault&&(ie.group.isDefault=q.group.isDefault))),q.presentationOptions&&(ie.presentationOptions=M.to(q.presentationOptions)),q._id&&(ie._id=q._id),q.detail&&(ie.detail=q.detail),ie}x.to=H})(E=e.TaskDTO||(e.TaskDTO={}));var I;(function(x){function N(H){return H}x.from=N;function z(H){if(!!H)return Object.assign(Object.create(null),H)}x.to=z})(I=e.TaskFilterDTO||(e.TaskFilterDTO={}));class D{constructor(N,z,H){this._id=z,this._task=H,A.set(this,void 0),Ze(this,A,N,"f")}get task(){return this._task}terminate(){Te(this,A,"f").terminateTask(this)}fireDidStartProcess(N){}fireDidEndProcess(N){}}A=new WeakMap;var B;(function(x){function N(z){return{id:z._id,task:void 0}}x.from=N})(B=e.TaskExecutionDTO||(e.TaskExecutionDTO={}));let L=class{constructor(N,z,H,q,ue,K,ce,de){this._onDidExecuteTask=new w.Emitter,this._onDidTerminateTask=new w.Emitter,this._onDidTaskProcessStarted=new w.Emitter,this._onDidTaskProcessEnded=new w.Emitter,this._proxy=N.getProxy(P.MainContext.MainThreadTask),this._workspaceProvider=H,this._editorService=q,this._configurationService=ue,this._terminalService=K,this._handleCounter=0,this._handlers=new Map,this._taskExecutions=new Map,this._taskExecutionPromises=new Map,this._providedCustomExecutions2=new Map,this._notProvidedCustomExecutions=new Set,this._activeCustomExecutions2=new Map,this._logService=ce,this._deprecationService=de,this._proxy.$registerSupportedExecutions(!0)}registerTaskProvider(N,z,H){if(!H)return new t.Disposable(()=>{});const q=this.nextHandle();return this._handlers.set(q,{type:z,provider:H,extension:N}),this._proxy.$registerTaskProvider(q,z),new t.Disposable(()=>{this._handlers.delete(q),this._proxy.$unregisterTaskProvider(q)})}registerTaskSystem(N,z){this._proxy.$registerTaskSystem(N,z)}fetchTasks(N){return this._proxy.$fetchTasks(I.from(N)).then(async z=>{const H=[];for(let q of z){const ue=await E.to(q,this._workspaceProvider,this._providedCustomExecutions2);ue&&H.push(ue)}return H})}get taskExecutions(){const N=[];return this._taskExecutions.forEach(z=>N.push(z)),N}terminateTask(N){if(!(N instanceof D))throw new Error("No valid task execution provided");return this._proxy.$terminateTask(N._id)}get onDidStartTask(){return this._onDidExecuteTask.event}async $onDidStartTask(N,z,H){const q=this._providedCustomExecutions2.get(N.id);q&&(this._activeCustomExecutions2.set(N.id,q),this._terminalService.attachPtyToTerminal(z,await q.callback(H))),this._lastStartedTask=N.id,this._onDidExecuteTask.fire({execution:await this.getTaskExecution(N)})}get onDidEndTask(){return this._onDidTerminateTask.event}async $OnDidEndTask(N){const z=await this.getTaskExecution(N);this._taskExecutionPromises.delete(N.id),this._taskExecutions.delete(N.id),this.customExecutionComplete(N),this._onDidTerminateTask.fire({execution:z})}get onDidStartTaskProcess(){return this._onDidTaskProcessStarted.event}async $onDidStartTaskProcess(N){const z=await this.getTaskExecution(N.id);this._onDidTaskProcessStarted.fire({execution:z,processId:N.processId})}get onDidEndTaskProcess(){return this._onDidTaskProcessEnded.event}async $onDidEndTaskProcess(N){const z=await this.getTaskExecution(N.id);this._onDidTaskProcessEnded.fire({execution:z,exitCode:N.exitCode})}$provideTasks(N,z){const H=this._handlers.get(N);if(!H)return Promise.reject(new Error("no handler found"));const q=[],ue=(0,F.asPromise)(()=>H.provider.provideTasks(R.CancellationToken.None)).then(K=>this.provideTasksInternal(z,q,H,K));return new Promise(K=>{ue.then(ce=>{Promise.all(q).then(()=>{K(ce)})})})}async $resolveTask(N,z){const H=this._handlers.get(N);if(!H)return Promise.reject(new Error("no handler found"));if(z.definition.type!==H.type)throw new Error(`Unexpected: Task of type [${z.definition.type}] cannot be resolved by provider of type [${H.type}].`);const q=await E.to(z,this._workspaceProvider,this._providedCustomExecutions2);if(!q)throw new Error("Unexpected: Task cannot be resolved.");const ue=await H.provider.resolveTask(q,R.CancellationToken.None);if(!ue)return;this.checkDeprecation(ue,H);const K=E.from(ue,H.extension);if(!K)throw new Error("Unexpected: Task cannot be resolved.");if(ue.definition!==q.definition)throw new Error("Unexpected: The resolved task definition must be the same object as the original task definition. The task definition cannot be changed.");return s.is(K.execution)&&await this.addCustomExecution(K,ue,!0),await this.resolveTaskInternal(K)}nextHandle(){return this._handleCounter++}async addCustomExecution(N,z,H){const q=await this._proxy.$createTaskId(N);!H&&!this._providedCustomExecutions2.has(q)&&(this._notProvidedCustomExecutions.add(q),this._activeCustomExecutions2.set(q,z.execution)),this._providedCustomExecutions2.set(q,z.execution)}async getTaskExecution(N,z){if(typeof N=="string"){const ue=this._taskExecutionPromises.get(N);if(!ue)throw new Error("Unexpected: The specified task is missing an execution");return ue}let H=this._taskExecutionPromises.get(N.id);if(H)return H;const q=new Promise((ue,K)=>{function ce(de,Y,ie){ie?ue(new D(de,Y.id,ie)):K("Unexpected: Task does not exist.")}z?ce(this,N,z):E.to(N.task,this._workspaceProvider,this._providedCustomExecutions2).then(de=>ce(this,N,de))});return this._taskExecutionPromises.set(N.id,q),q.then(ue=>(this._taskExecutions.set(N.id,ue),ue),ue=>Promise.reject(ue))}checkDeprecation(N,z){N._deprecated&&this._deprecationService.report("Task.constructor",z.extension,"Use the Task constructor that takes a `scope` instead.")}customExecutionComplete(N){this._activeCustomExecutions2.get(N.id)&&this._activeCustomExecutions2.delete(N.id),this._notProvidedCustomExecutions.has(N.id)&&this._lastStartedTask!==N.id&&(this._providedCustomExecutions2.delete(N.id),this._notProvidedCustomExecutions.delete(N.id));let H=this._notProvidedCustomExecutions.values(),q=H.next();for(;!q.done;)!this._activeCustomExecutions2.has(q.value)&&this._lastStartedTask!==q.value&&(this._providedCustomExecutions2.delete(q.value),this._notProvidedCustomExecutions.delete(q.value)),q=H.next()}};L=Ue([$e(0,n.IExtHostRpcService),$e(1,m.IExtHostInitDataService),$e(2,T.IExtHostWorkspace),$e(3,C.IExtHostDocumentsAndEditors),$e(4,k.IExtHostConfiguration),$e(5,_.IExtHostTerminalService),$e(6,S.ILogService),$e(7,b.IExtHostApiDeprecationService)],L),e.ExtHostTaskBase=L;let y=class extends L{constructor(N,z,H,q,ue,K,ce,de){super(N,z,H,q,ue,K,ce,de);this.registerTaskSystem(d.Schemas.vscodeRemote,{scheme:d.Schemas.vscodeRemote,authority:"",platform:u.PlatformToString(0)})}async executeTask(N,z){if(!z.execution)throw new Error("Tasks to execute must include an execution");const H=E.from(z,N);if(H===void 0)throw new Error("Task is not valid");if(s.is(H.execution))await this.addCustomExecution(H,z,!1);else throw new g.NotSupportedError;const q=await this.getTaskExecution(await this._proxy.$getTaskExecution(H),z);return this._proxy.$executeTask(H).catch(ue=>{throw new Error(ue)}),q}provideTasksInternal(N,z,H,q){const ue=[];if(q)for(let K of q){this.checkDeprecation(K,H),(!K.definition||!N[K.definition.type])&&this._logService.warn(`The task [${K.source}, ${K.name}] uses an undefined task type. The task will be ignored in the future.`);const ce=E.from(K,H.extension);ce&&s.is(ce.execution)?(ue.push(ce),z.push(this.addCustomExecution(ce,K,!0))):this._logService.warn("Only custom execution tasks supported.")}return{tasks:ue,extension:H.extension}}async resolveTaskInternal(N){if(s.is(N.execution))return N;this._logService.warn("Only custom execution tasks supported.")}async $resolveVariables(N,z){return{process:void 0,variables:Object.create(null)}}async $jsonTasksSupported(){return!1}async $findExecutable(N,z,H){}};y=Ue([$e(0,n.IExtHostRpcService),$e(1,m.IExtHostInitDataService),$e(2,T.IExtHostWorkspace),$e(3,C.IExtHostDocumentsAndEditors),$e(4,k.IExtHostConfiguration),$e(5,_.IExtHostTerminalService),$e(6,S.ILogService),$e(7,b.IExtHostApiDeprecationService)],y),e.WorkerExtHostTask=y,e.IExtHostTask=(0,o.createDecorator)("IExtHostTask")}),define(Ee[213],_e([0,1,16,74,29,77,21,10,17,24,9,11,2,231,128,81,46,90,212,40]),function(re,e,c,F,w,P,t,T,C,k,R,_,n,m,o,d,u,S,b,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.resolveResourcesForSearchIncludes=e.QueryBuilder=void 0;let g=class{constructor(v,a,E,I){this.configurationService=v,this.workspaceContextService=a,this.editorGroupsService=E,this.pathService=I}text(v,a,E={}){v=this.getContentPattern(v,E);const I=this.configurationService.getValue(),D=a&&a.some(L=>!this.configurationService.getValue({resource:L}).search.useRipgrep);return{...this.commonQuery(a?.map(u.toWorkspaceFolder),E),type:2,contentPattern:v,previewOptions:E.previewOptions,maxFileSize:E.maxFileSize,usePCRE2:I.search.usePCRE2||D||!1,beforeContext:E.beforeContext,afterContext:E.afterContext,userDisabledExcludesAndIgnoreFiles:E.disregardExcludeSettings&&E.disregardIgnoreFiles}}getContentPattern(v,a){const E=this.configurationService.getValue();v.isRegExp&&(v.pattern=v.pattern.replace(/\r?\n/g,"\\n"));const I={...v,wordSeparators:E.editor.wordSeparators};return this.isCaseSensitive(v,a)&&(I.isCaseSensitive=!0),this.isMultiline(v)&&(I.isMultiline=!0),I}file(v,a={}){return{...this.commonQuery(v,a),type:1,filePattern:a.filePattern?a.filePattern.trim():a.filePattern,exists:a.exists,sortByScore:a.sortByScore,cacheKey:a.cacheKey}}handleIncludeExclude(v,a){return v?(v=Array.isArray(v)?v.map(i):i(v),a?this.parseSearchPaths(v):{pattern:l(...Array.isArray(v)?v:[v])}):{}}commonQuery(v=[],a={}){const E=this.handleIncludeExclude(a.includePattern,a.expandPatterns),I=this.handleIncludeExclude(a.excludePattern,a.expandPatterns),D=v.length>1,B=(E.searchPaths&&E.searchPaths.length?E.searchPaths.map(x=>this.getFolderQueryForSearchPath(x,a,I)):v.map(x=>this.getFolderQueryForRoot(x,a,I,D))).filter(x=>!!x),L={_reason:a._reason,folderQueries:B,usingSearchPaths:!!(E.searchPaths&&E.searchPaths.length),extraFileResources:a.extraFileResources,excludePattern:I.pattern,includePattern:E.pattern,onlyOpenEditors:a.onlyOpenEditors,maxResults:a.maxResults};if(a.onlyOpenEditors){const N=c.coalesce(c.flatten(this.editorGroupsService.groups.map(H=>H.editors.map(q=>q.resource)))).filter(H=>(0,h.pathIncludedInQuery)(L,H.fsPath)),z=this.commonQueryFromFileList(N);return{...L,...z}}const y=a.extraFileResources&&a.extraFileResources.filter(x=>(0,h.pathIncludedInQuery)(L,x.fsPath));return L.extraFileResources=y&&y.length?y:void 0,L}commonQueryFromFileList(v){const a=[],E=new t.ResourceMap,I={};let D=!1;return v.forEach(B=>{if(B.scheme===T.Schemas.walkThrough)return;if((0,k.isAbsolutePath)(B)){const y=this.workspaceContextService.getWorkspaceFolder(B)?.uri??B.with({path:C.dirname(B.fsPath)});let x=E.get(y);x||(D=!0,x={folder:y,includePattern:{}},a.push(x),E.set(y,x));const N=C.relative(y.fsPath,B.fsPath);(0,_.assertIsDefined)(x.includePattern)[N.replace(/\\/g,"/")]=!0}else B.fsPath&&(D=!0,I[B.fsPath]=!0)}),{folderQueries:a,includePattern:I,usingSearchPaths:!0,excludePattern:D?void 0:{"**/*":!0}}}isCaseSensitive(v,a){if(a.isSmartCase){if(v.isRegExp){if(R.containsUppercaseCharacter(v.pattern,!0))return!0}else if(R.containsUppercaseCharacter(v.pattern))return!0}return!!v.isCaseSensitive}isMultiline(v){return v.isMultiline||v.isRegExp&&(0,m.isMultilineRegexSource)(v.pattern)||v.pattern.indexOf(`
`)>=0?!0:!!v.isMultiline}parseSearchPaths(v){const a=z=>C.isAbsolute(z)||/^\.\.?([\/\\]|$)/.test(z),I=(Array.isArray(v)?v:M(v)).map(z=>{const H=this.pathService.resolvedUserHome;return H?(0,P.untildify)(z,H.scheme===T.Schemas.file?H.fsPath:H.path):z}),D=F.groupBy(I,z=>a(z)?"searchPaths":"exprSegments"),B=(D.exprSegments||[]).map(z=>R.rtrim(z,"/")).map(z=>R.rtrim(z,"\\")).map(z=>(z[0]==="."&&(z="*"+z),r(z))),L={},y=this.expandSearchPathPatterns(D.searchPaths||[]);y&&y.length&&(L.searchPaths=y);const x=c.flatten(B),N=l(...x);return N&&(L.pattern=N),L}getExcludesForFolder(v,a){return a.disregardExcludeSettings?void 0:(0,h.getExcludes)(v,!a.disregardSearchExcludeSettings)}expandSearchPathPatterns(v){if(!v||!v.length)return[];const a=c.flatten(v.map(I=>{let{pathPortion:D,globPortion:B}=A(I);B&&(B=p(B));const L=this.expandOneSearchPath(D);return c.flatten(L.map(y=>this.resolveOneSearchPathPattern(y,B)))})),E=new Map;return a.forEach(I=>{const D=I.searchPath.toString(),B=E.get(D);B?I.pattern&&(B.pattern=B.pattern||{},B.pattern[I.pattern]=!0):E.set(D,{searchPath:I.searchPath,pattern:I.pattern?l(I.pattern):void 0})}),Array.from(E.values())}expandOneSearchPath(v){if(C.isAbsolute(v)){const a=this.workspaceContextService.getWorkspace().folders;return a[0]&&a[0].uri.scheme!==T.Schemas.file?[{searchPath:a[0].uri.with({path:v})}]:[{searchPath:n.URI.file(C.normalize(v))}]}if(this.workspaceContextService.getWorkbenchState()===2){const a=this.workspaceContextService.getWorkspace().folders[0].uri;if(v=i(v),v.startsWith("../")||v===".."){const I=C.posix.resolve(a.path,v);return[{searchPath:a.with({path:I})}]}const E=p(v);return[{searchPath:a,pattern:E}]}else{if(v==="./"||v===".\\")return[];{const a=v.replace(/^\.[\/\\]/,""),I=this.workspaceContextService.getWorkspace().folders.map(D=>{const B=a.match(new RegExp(`^${R.escapeRegExpCharacters(D.name)}(?:/(.*)|$)`));return B?{match:B,folder:D}:null}).filter(_.isDefined);if(I.length)return I.map(D=>{const B=D.match[1];return{searchPath:D.folder.uri,pattern:B&&p(B)}});{const D=v.match(/\.[\/\\](.+)[\/\\]?/),B=D?D[1]:v,L=o.localize(0,null,B);throw new Error(L)}}}}resolveOneSearchPathPattern(v,a){const E=v.pattern&&a?`${v.pattern}/${a}`:v.pattern||a,I=[{searchPath:v.searchPath,pattern:E}];return E&&!E.endsWith("**")&&I.push({searchPath:v.searchPath,pattern:E+"/**"}),I}getFolderQueryForSearchPath(v,a,E){const I=this.getFolderQueryForRoot((0,u.toWorkspaceFolder)(v.searchPath),a,E,!1);return I?{...I,includePattern:v.pattern}:null}getFolderQueryForRoot(v,a,E,I){let D;const B=n.URI.isUri(v)?v:v.uri;if(E.searchPaths){const z=E.searchPaths.filter(H=>(0,k.isEqual)(H.searchPath,B))[0];if(z&&!z.pattern)return null;z&&(D=z.pattern)}const L=this.configurationService.getValue({resource:B}),x={...this.getExcludesForFolder(L,a)||{},...D||{}},N=n.URI.isUri(v)?(0,k.basename)(v):v.name;return{folder:B,folderName:I?N:void 0,excludePattern:Object.keys(x).length>0?x:void 0,fileEncoding:L.files&&L.files.encoding,disregardIgnoreFiles:typeof a.disregardIgnoreFiles=="boolean"?a.disregardIgnoreFiles:!L.search.useIgnoreFiles,disregardGlobalIgnoreFiles:typeof a.disregardGlobalIgnoreFiles=="boolean"?a.disregardGlobalIgnoreFiles:!L.search.useGlobalIgnoreFiles,ignoreSymlinks:typeof a.ignoreSymlinks=="boolean"?a.ignoreSymlinks:!L.search.followSymlinks}}};g=Ue([$e(0,d.IConfigurationService),$e(1,u.IWorkspaceContextService),$e(2,S.IEditorGroupsService),$e(3,b.IPathService)],g),e.QueryBuilder=g;function A(s){const v=s.match(/[\*\{\}\(\)\[\]\?]/);if(v){const a=v.index,E=s.substr(0,a).match(/[/|\\][^/\\]*$/);if(E){let I=s.substr(0,E.index);return I.match(/[/\\]/)||(I+="/"),{pathPortion:I,globPortion:s.substr((E.index||0)+1)}}}return{pathPortion:s}}function l(...s){return s.length?s.reduce((v,a)=>(v[a]=!0,v),Object.create(null)):void 0}function M(s){return w.splitGlobAware(s,",").map(v=>v.trim()).filter(v=>!!v.length)}function r(s){return[`**/${s}/**`,`**/${s}`].map(a=>a.replace(/\*\*\/\*\*/g,"**"))}function i(s){return s.replace(/\\/g,"/")}function p(s){return i(s).replace(/^\.\//,"").replace(/\/+$/g,"")}function f(s,v){s=c.distinct(s,I=>I.toString());const a=[],E=v.getWorkspace();return s&&s.forEach(I=>{let D;if(v.getWorkbenchState()===2)D=(0,k.relativePath)(E.folders[0].uri,I),D&&D!=="."&&(D="./"+D);else{const B=v.getWorkspaceFolder(I);if(B){const L=B.name;if(E.folders.filter(x=>x.name===L).length===1){const x=(0,k.relativePath)(B.uri,I);x===""?D=`./${B.name}`:D=`./${B.name}/${x}`}else D=I.fsPath}}D&&a.push(D)}),a}e.resolveResourcesForSearchIncludes=f}),define(Ee[214],_e([0,1,24,2,20,15,4,213,40,46]),function(re,e,c,F,w,P,t,T,C,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.checkGlobFileExists=e.checkActivateWorkspaceContainsExtension=void 0;const R=7e3;function _(d,u){const S=u.activationEvents;if(!S)return Promise.resolve(void 0);const b=[],h=[];for(const i of S)if(/^workspaceContains:/.test(i)){const p=i.substr("workspaceContains:".length);p.indexOf("*")>=0||p.indexOf("?")>=0||d.forceUsingSearch?h.push(p):b.push(p)}if(b.length===0&&h.length===0)return Promise.resolve(void 0);let g;const A=new Promise((i,p)=>{g=i}),l=i=>g({activationEvent:i}),M=Promise.all(b.map(i=>n(d,i,l))).then(()=>{}),r=m(d,u.identifier,h,l);return Promise.all([M,r]).then(()=>{g(void 0)}),A}e.checkActivateWorkspaceContainsExtension=_;async function n(d,u,S){for(const b of d.folders)if(await d.exists(c.joinPath(F.URI.revive(b),u))){S(`workspaceContains:${u}`);return}}async function m(d,u,S,b){if(S.length===0)return Promise.resolve(void 0);const h=new w.CancellationTokenSource,g=d.checkExists(d.folders,S,h.token),A=setTimeout(async()=>{h.cancel(),d.logService.info(`Not activating extension '${u.value}': Timed out while searching for 'workspaceContains' pattern ${S.join(",")}`)},R);let l=!1;try{l=await g}catch(M){P.isPromiseCanceledError(M)||P.onUnexpectedError(M)}h.dispose(),clearTimeout(A),l&&b(`workspaceContains:${S.join(",")}`)}function o(d,u,S,b){const h=d.get(t.IInstantiationService),g=d.get(C.ISearchService),l=h.createInstance(T.QueryBuilder).file(u.map(M=>(0,k.toWorkspaceFolder)(F.URI.revive(M))),{_reason:"checkExists",includePattern:S,exists:!0});return g.fileSearch(l,b).then(M=>!!M.limitHit,M=>P.isPromiseCanceledError(M)?!1:Promise.reject(M))}e.checkGlobFileExists=o});var Ze=this&&this.__classPrivateFieldSet||function(re,e,c,F,w){if(F==="m")throw new TypeError("Private method is not writable");if(F==="a"&&!w)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?re!==e||!w:!e.has(re))throw new TypeError("Cannot write private member to an object whose class did not declare it");return F==="a"?w.call(re,c):w?w.value=c:e.set(re,c),c},Te=this&&this.__classPrivateFieldGet||function(re,e,c,F){if(c==="a"&&!F)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?re!==e||!F:!e.has(re))throw new TypeError("Cannot read private member from an object whose class did not declare it");return c==="m"?F:c==="a"?F.call(re):F?F.value:e.get(re)};define(Ee[33],_e([0,1,120,17,73,24,14,6,21,2,12,5,32,174,71,31,27,172,15,25,22,147,7,84,4,28,72,13,60,64,39,3,214,68,149,10]),function(re,e,c,F,w,P,t,T,C,k,R,_,n,m,o,d,u,S,b,h,g,A,l,M,r,i,p,f,s,v,a,E,I,D,B,L){"use strict";var y,x,N;Object.defineProperty(e,"__esModule",{value:!0}),e.Extension=e.IExtHostExtensionService=e.AbstractExtHostExtensionService=e.IHostUtils=void 0,e.IHostUtils=(0,r.createDecorator)("IHostUtils");let z=class ji extends T.Disposable{constructor(K,ce,de,Y,ie,we,Me,Re,Be,Qe){super();this._onDidChangeRemoteConnectionData=this._register(new E.Emitter),this.onDidChangeRemoteConnectionData=this._onDidChangeRemoteConnectionData.event,this._hostUtils=ce,this._extHostContext=de,this._initData=Me,this._extHostWorkspace=Y,this._extHostConfiguration=ie,this._logService=we,this._extHostTunnelService=Be,this._extHostTerminalService=Qe,this._mainThreadWorkspaceProxy=this._extHostContext.getProxy(_.MainContext.MainThreadWorkspace),this._mainThreadTelemetryProxy=this._extHostContext.getProxy(_.MainContext.MainThreadTelemetry),this._mainThreadExtensionsProxy=this._extHostContext.getProxy(_.MainContext.MainThreadExtensionService),this._almostReadyToRunExtensions=new t.Barrier,this._readyToStartExtensionHost=new t.Barrier,this._readyToRunExtensions=new t.Barrier,this._eagerExtensionsActivated=new t.Barrier,this._registry=new S.ExtensionDescriptionRegistry(this._initData.extensions),this._storage=new o.ExtHostStorage(this._extHostContext),this._secretState=new D.ExtHostSecretState(this._extHostContext),this._storagePath=Re,this._instaService=K.createChild(new s.ServiceCollection([o.IExtHostStorage,this._storage],[D.IExtHostSecretState,this._secretState]));const Ge=new Set;this._initData.hostExtensions.forEach(Xe=>Ge.add(h.ExtensionIdentifier.toKey(Xe))),this._activator=this._register(new m.ExtensionsActivator(this._registry,this._initData.resolvedExtensions,this._initData.hostExtensions,{onExtensionActivationError:(Xe,$,G)=>{this._mainThreadExtensionsProxy.$onExtensionActivationError(Xe,b.transformErrorForSerialization($),G)},actualActivateExtension:async(Xe,$)=>{if(Ge.has(h.ExtensionIdentifier.toKey(Xe)))return await this._mainThreadExtensionsProxy.$activateExtension(Xe,$),new m.HostExtension;const G=this._registry.getExtensionDescription(Xe);return this._activateExtension(G,$)}},this._logService)),this._extensionPathIndex=null,this._resolvers=Object.create(null),this._started=!1,this._remoteConnectionData=this._initData.remote.connectionData}getRemoteConnectionData(){return this._remoteConnectionData}async initialize(){try{await this._beforeAlmostReadyToRunExtensions(),this._almostReadyToRunExtensions.open(),await this._extHostWorkspace.waitForInitializeCall(),w.mark("code/extHost/ready"),this._readyToStartExtensionHost.open(),this._initData.autoStart&&this._startExtensionHost()}catch(K){b.onUnexpectedError(K)}}async deactivateAll(){this._storagePath.onWillDeactivateAll();let K=[];try{K=this._registry.getAllExtensionDescriptions().map(ie=>ie.identifier).filter(ie=>this.isActivated(ie)).map(ie=>this._deactivate(ie))}catch(ce){}await Promise.all(K)}isActivated(K){return this._readyToRunExtensions.isOpen()?this._activator.isActivated(K):!1}_activateByEvent(K,ce){return this._activator.activateByEvent(K,ce)}_activateById(K,ce){return this._activator.activateById(K,ce)}activateByIdWithErrors(K,ce){return this._activateById(K,ce).then(()=>{const de=this._activator.getActivatedExtension(K);if(de.activationFailed)return Promise.reject(de.activationFailedError)})}getExtensionRegistry(){return this._readyToRunExtensions.wait().then(K=>this._registry)}getExtensionExports(K){return this._readyToRunExtensions.isOpen()?this._activator.getActivatedExtension(K).exports:null}async _realPathExtensionUri(K){if(K.scheme!==L.Schemas.file)return K;const ce=await this._hostUtils.realpath(K.fsPath);return k.URI.file(ce)}async getExtensionPathIndex(){return this._extensionPathIndex||(this._extensionPathIndex=(async()=>{const K=C.TernarySearchTree.forUris(ce=>P.extUriBiasedIgnorePathCase.ignorePathCasing(ce));for(const ce of this._registry.getAllExtensionDescriptions())if(this._getEntryPoint(ce)){const de=await this._realPathExtensionUri(ce.extensionLocation);K.set(de,ce)}return K})()),this._extensionPathIndex}_deactivate(K){let ce=Promise.resolve(void 0);if(!this._readyToRunExtensions.isOpen()||!this._activator.isActivated(K))return ce;const de=this._activator.getActivatedExtension(K);if(!de)return ce;try{typeof de.module.deactivate=="function"&&(ce=Promise.resolve(de.module.deactivate()).then(void 0,Y=>(this._logService.error(Y),Promise.resolve(void 0))))}catch(Y){this._logService.error(Y)}try{(0,T.dispose)(de.subscriptions)}catch(Y){this._logService.error(Y)}return ce}async _activateExtension(K,ce){return this._initData.remote.isRemote?this._mainThreadExtensionsProxy.$onWillActivateExtension(K.identifier):await this._mainThreadExtensionsProxy.$onWillActivateExtension(K.identifier),this._doActivateExtension(K,ce).then(de=>{const Y=de.activationTimes;return this._mainThreadExtensionsProxy.$onDidActivateExtension(K.identifier,Y.codeLoadingTime,Y.activateCallTime,Y.activateResolvedTime,ce),this._logExtensionActivationTimes(K,ce,"success",Y),de},de=>{throw this._logExtensionActivationTimes(K,ce,"failure"),de})}_logExtensionActivationTimes(K,ce,de,Y){const ie=H(K,ce);this._mainThreadTelemetryProxy.$publicLog2("extensionActivationTimes",{...ie,...Y||{},outcome:de})}_doActivateExtension(K,ce){const de=H(K,ce);this._mainThreadTelemetryProxy.$publicLog2("activatePlugin",de);const Y=this._getEntryPoint(K);if(!Y)return Promise.resolve(new m.EmptyExtension(m.ExtensionActivationTimes.NONE));this._logService.info(`ExtensionService#_doActivateExtension ${K.identifier.value}, startup: ${ce.startup}, activationEvent: '${ce.activationEvent}'${K.identifier.value!==ce.extensionId.value?`, root cause: ${ce.extensionId.value}`:""}`),this._logService.flush();const ie=new m.ExtensionActivationTimesBuilder(ce.startup);return Promise.all([this._loadCommonJSModule(K.identifier,(0,P.joinPath)(K.extensionLocation,Y),ie),this._loadExtensionContext(K)]).then(we=>(w.mark(`code/extHost/willActivateExtension/${K.identifier.value}`),ji._callActivate(this._logService,K.identifier,we[0],we[1],ie))).then(we=>(w.mark(`code/extHost/didActivateExtension/${K.identifier.value}`),we))}_loadExtensionContext(K){const ce=new A.ExtensionGlobalMemento(K,this._storage),de=new A.ExtensionMemento(K.identifier.value,!1,this._storage),Y=new B.ExtensionSecrets(K,this._secretState),ie=K.isUnderDevelopment?this._initData.environment.extensionTestsLocationURI?l.ExtensionMode.Test:l.ExtensionMode.Development:l.ExtensionMode.Production,we=this._initData.remote.isRemote?l.ExtensionKind.Workspace:l.ExtensionKind.UI;return this._logService.trace(`ExtensionService#loadExtensionContext ${K.identifier.value}`),Promise.all([ce.whenReady,de.whenReady,this._storagePath.whenReady]).then(()=>{const Me=this;let Re;return Object.freeze({globalState:ce,workspaceState:de,secrets:Y,subscriptions:[],get extensionUri(){return K.extensionLocation},get extensionPath(){return K.extensionLocation.fsPath},asAbsolutePath(Be){return F.join(K.extensionLocation.fsPath,Be)},get storagePath(){return Me._storagePath.workspaceValue(K)?.fsPath},get globalStoragePath(){return Me._storagePath.globalValue(K).fsPath},get logPath(){return F.join(Me._initData.logsLocation.fsPath,K.identifier.value)},get logUri(){return k.URI.joinPath(Me._initData.logsLocation,K.identifier.value)},get storageUri(){return Me._storagePath.workspaceValue(K)},get globalStorageUri(){return Me._storagePath.globalValue(K)},get extensionMode(){return ie},get extension(){return Re===void 0&&(Re=new q(Me,K.identifier,K,we)),Re},get extensionRuntime(){return(0,u.checkProposedApiEnabled)(K,"extensionRuntime"),Me.extensionRuntime},get environmentVariableCollection(){return Me._extHostTerminalService.getEnvironmentVariableCollection(K)}})})}static _callActivate(K,ce,de,Y,ie){return de=de||{activate:void 0,deactivate:void 0},this._callActivateOptional(K,ce,de,Y,ie).then(we=>new m.ActivatedExtension(!1,null,ie.build(),de,we,Y.subscriptions))}static _callActivateOptional(K,ce,de,Y,ie){if(typeof de.activate=="function")try{ie.activateCallStart(),K.trace(`ExtensionService#_callActivateOptional ${ce.value}`);const we=typeof global=="object"?global:self,Me=de.activate.apply(we,[Y]);return ie.activateCallStop(),ie.activateResolveStart(),Promise.resolve(Me).then(Re=>(ie.activateResolveStop(),Re))}catch(we){return Promise.reject(we)}else return Promise.resolve(de)}_activateOneStartupFinished(K,ce){this._activateById(K.identifier,{startup:!1,extensionId:K.identifier,activationEvent:ce}).then(void 0,de=>{this._logService.error(de)})}_activateAllStartupFinished(){this._mainThreadExtensionsProxy.$setPerformanceMarks(w.getMarks());for(const K of this._registry.getAllExtensionDescriptions())if(K.activationEvents)for(const ce of K.activationEvents)ce==="onStartupFinished"&&this._activateOneStartupFinished(K,ce)}_handleEagerExtensions(){const K=this._activateByEvent("*",!0).then(void 0,ie=>{this._logService.error(ie)});this._register(this._extHostWorkspace.onDidChangeWorkspace(ie=>this._handleWorkspaceContainsEagerExtensions(ie.added)));const ce=this._extHostWorkspace.workspace?this._extHostWorkspace.workspace.folders:[],de=this._handleWorkspaceContainsEagerExtensions(ce),Y=Promise.all([K,de]).then(()=>{});return Promise.race([Y,(0,t.timeout)(1e4)]).then(()=>{this._activateAllStartupFinished()}),Y}_handleWorkspaceContainsEagerExtensions(K){return K.length===0?Promise.resolve(void 0):Promise.all(this._registry.getAllExtensionDescriptions().map(ce=>this._handleWorkspaceContainsEagerExtension(K,ce))).then(()=>{})}async _handleWorkspaceContainsEagerExtension(K,ce){if(this.isActivated(ce.identifier))return;const de=!this._initData.remote.isRemote&&!!this._initData.remote.authority,Y={logService:this._logService,folders:K.map(we=>we.uri),forceUsingSearch:de,exists:we=>this._hostUtils.exists(we.fsPath),checkExists:(we,Me,Re)=>this._mainThreadWorkspaceProxy.$checkExists(we,Me,Re)},ie=await(0,I.checkActivateWorkspaceContainsExtension)(Y,ce);if(!!ie)return this._activateById(ce.identifier,{startup:!0,extensionId:ce.identifier,activationEvent:ie.activationEvent}).then(void 0,we=>this._logService.error(we))}async $extensionTestsExecute(){await this._eagerExtensionsActivated.wait();try{return await this._doHandleExtensionTests()}catch(K){throw console.error(K),K}}async _doHandleExtensionTests(){const{extensionDevelopmentLocationURI:K,extensionTestsLocationURI:ce}=this._initData.environment;if(!K||!ce)throw new Error(c.localize(0,null));const de=await this._loadCommonJSModule(null,ce,new m.ExtensionActivationTimesBuilder(!1));if(!de||typeof de.run!="function")throw new Error(c.localize(1,null,ce.toString()));return new Promise((Y,ie)=>{const we=(Be,Qe)=>{Be?ie(Be):Y(typeof Qe=="number"&&Qe>0?1:0)},Me=(0,P.originalFSPath)(ce),Re=de.run(Me,we);Re&&Re.then&&Re.then(()=>{Y(0)}).catch(Be=>{ie(Be.toString())})})}async $extensionTestsExit(K){this._logService.info(`Extension host terminating: test runner requested exit with code ${K}`),this._hostUtils.pid&&this._logService.info(`Extension host with pid ${this._hostUtils.pid} exiting with code ${K}`),this._logService.flush(),this._hostUtils.exit(K)}_startExtensionHost(){if(this._started)throw new Error("Extension host is already started!");return this._started=!0,this._readyToStartExtensionHost.wait().then(()=>this._readyToRunExtensions.open()).then(()=>this._handleEagerExtensions()).then(()=>{this._eagerExtensionsActivated.open(),this._logService.info("Eager extensions activated")})}registerRemoteAuthorityResolver(K,ce){return this._resolvers[K]=ce,(0,T.toDisposable)(()=>{delete this._resolvers[K]})}async _activateAndGetResolver(K){const ce=K.indexOf("+");if(ce===-1)throw new Error("Not an authority that can be resolved!");const de=K.substr(0,ce);return await this._almostReadyToRunExtensions.wait(),await this._activateByEvent(`onResolveRemoteAuthority:${de}`,!1),{authorityPrefix:de,resolver:this._resolvers[de]}}async $resolveAuthority(K,ce){const{authorityPrefix:de,resolver:Y}=await this._activateAndGetResolver(K);if(!Y)return{type:"error",error:{code:M.RemoteAuthorityResolverErrorCode.NoResolverFound,message:`No remote extension installed to resolve ${de}.`,detail:void 0}};try{this._register(await this._extHostTunnelService.setTunnelExtensionFunctions(Y)),w.mark(`code/extHost/willResolveAuthority/${de}`);const ie=await Y.resolve(K,{resolveAttempt:ce});w.mark(`code/extHost/didResolveAuthorityOK/${de}`);const we={authority:K,host:ie.host,port:ie.port,connectionToken:ie.connectionToken},Me={extensionHostEnv:ie.extensionHostEnv,isTrusted:ie.isTrusted,authenticationSession:ie.authenticationSessionForInitializingExtensions?{id:ie.authenticationSessionForInitializingExtensions.id,providerId:ie.authenticationSessionForInitializingExtensions.providerId}:void 0};return{type:"ok",value:{authority:we,options:Me,tunnelInformation:{environmentTunnels:ie.environmentTunnels}}}}catch(ie){if(w.mark(`code/extHost/didResolveAuthorityError/${de}`),ie instanceof l.RemoteAuthorityResolverError)return{type:"error",error:{code:ie._code,message:ie._message,detail:ie._detail}};throw ie}}async $getCanonicalURI(K,ce){const{authorityPrefix:de,resolver:Y}=await this._activateAndGetResolver(K);if(!Y)throw new Error(`Cannot get canonical URI because no remote extension is installed to resolve ${de}`);const ie=k.URI.revive(ce);if(typeof Y.getCanonicalURI=="undefined")return ie;const we=await(0,t.asPromise)(()=>Y.getCanonicalURI(ie));return we||ie}$startExtensionHost(K){return this._registry.keepOnly(K),this._startExtensionHost()}$activateByEvent(K,ce){return ce===1?this._activateByEvent(K,!1):this._readyToRunExtensions.wait().then(de=>this._activateByEvent(K,!1))}async $activate(K,ce){return await this._readyToRunExtensions.wait(),this._registry.getExtensionDescription(K)?(await this._activateById(K,ce),!0):!1}async $deltaExtensions(K,ce){K.forEach(Y=>Y.extensionLocation=k.URI.revive(Y.extensionLocation));const de=await this.getExtensionPathIndex();return await Promise.all(ce.map(async Y=>{const ie=this._registry.getExtensionDescription(Y);ie&&de.delete(await this._realPathExtensionUri(ie.extensionLocation))})),await Promise.all(K.map(async Y=>{const ie=await this._realPathExtensionUri(Y.extensionLocation);de.set(ie,Y)})),this._registry.deltaExtensions(K,ce),Promise.resolve(void 0)}async $test_latency(K){return K}async $test_up(K){return K.byteLength}async $test_down(K){let ce=g.VSBuffer.alloc(K),de=Math.random()%256;for(let Y=0;Y<K;Y++)ce.writeUInt8(de,Y);return ce}async $updateRemoteConnectionData(K){this._remoteConnectionData=K,this._onDidChangeRemoteConnectionData.fire()}};z=Ue([$e(0,r.IInstantiationService),$e(1,e.IHostUtils),$e(2,f.IExtHostRpcService),$e(3,d.IExtHostWorkspace),$e(4,n.IExtHostConfiguration),$e(5,R.ILogService),$e(6,i.IExtHostInitDataService),$e(7,p.IExtensionStoragePaths),$e(8,v.IExtHostTunnelService),$e(9,a.IExtHostTerminalService)],z),e.AbstractExtHostExtensionService=z;function H(ue,K){return{id:ue.identifier.value,name:ue.name,extensionVersion:ue.version,publisherDisplayName:ue.publisher,activationEvents:ue.activationEvents?ue.activationEvents.join(","):null,isBuiltin:ue.isBuiltin,reason:K.activationEvent,reasonId:K.extensionId.value}}e.IExtHostExtensionService=(0,r.createDecorator)("IExtHostExtensionService");class q{constructor(K,ce,de,Y){y.set(this,void 0),x.set(this,void 0),N.set(this,void 0),Ze(this,y,K,"f"),Ze(this,x,ce,"f"),Ze(this,N,de.identifier,"f"),this.id=de.identifier.value,this.extensionUri=de.extensionLocation,this.extensionPath=F.normalize((0,P.originalFSPath)(de.extensionLocation)),this.packageJSON=de,this.extensionKind=Y}get isActive(){return Te(this,y,"f").isActivated(Te(this,N,"f"))}get exports(){if(this.packageJSON.api!=="none")return Te(this,y,"f").getExtensionExports(Te(this,N,"f"))}activate(){return Te(this,y,"f").activateByIdWithErrors(Te(this,N,"f"),{startup:!1,extensionId:Te(this,x,"f"),activationEvent:"api"}).then(()=>this.exports)}}e.Extension=q,y=new WeakMap,x=new WeakMap,N=new WeakMap}),define(Ee[98],_e([0,1,17,2,3,14,5,7,156,31,33,48,163,32,157,13,4,11,89,70]),function(re,e,c,F,w,P,t,T,C,k,R,_,n,m,o,d,u,S,b,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WorkerExtHostDebugService=e.ExtHostVariableResolverService=e.ExtHostDebugConsole=e.ExtHostDebugSession=e.ExtHostDebugServiceBase=e.IExtHostDebugService=void 0,e.IExtHostDebugService=(0,u.createDecorator)("IExtHostDebugService");let g=class{constructor(s,v,a,E,I,D){this._workspaceService=v,this._extensionService=a,this._editorsService=E,this._configurationService=I,this._editorTabs=D,this._debugSessions=new Map,this._configProviderHandleCounter=0,this._configProviders=[],this._adapterFactoryHandleCounter=0,this._adapterFactories=[],this._trackerFactoryHandleCounter=0,this._trackerFactories=[],this._debugAdapters=new Map,this._debugAdaptersTrackers=new Map,this._onDidStartDebugSession=new w.Emitter,this._onDidTerminateDebugSession=new w.Emitter,this._onDidChangeActiveDebugSession=new w.Emitter,this._onDidReceiveDebugSessionCustomEvent=new w.Emitter,this._debugServiceProxy=s.getProxy(t.MainContext.MainThreadDebugService),this._onDidChangeBreakpoints=new w.Emitter({onFirstListenerAdd:()=>{this.startBreakpoints()}}),this._activeDebugConsole=new l(this._debugServiceProxy),this._breakpoints=new Map,this._breakpointEventsActive=!1,this._extensionService.getExtensionRegistry().then(B=>{B.onDidChange(L=>{this.registerAllDebugTypes(B)}),this.registerAllDebugTypes(B)})}get onDidStartDebugSession(){return this._onDidStartDebugSession.event}get onDidTerminateDebugSession(){return this._onDidTerminateDebugSession.event}get onDidChangeActiveDebugSession(){return this._onDidChangeActiveDebugSession.event}get activeDebugSession(){return this._activeDebugSession}get onDidReceiveDebugSessionCustomEvent(){return this._onDidReceiveDebugSessionCustomEvent.event}get activeDebugConsole(){return this._activeDebugConsole.value}asDebugSourceUri(s,v){const a=s;if(typeof a.sourceReference=="number"&&a.sourceReference>0){let E=`debug:${encodeURIComponent(a.path||"")}`,I="?";return v&&(E+=`${I}session=${encodeURIComponent(v.id)}`,I="&"),E+=`${I}ref=${a.sourceReference}`,F.URI.parse(E)}else{if(a.path)return F.URI.file(a.path);throw new Error("cannot create uri from DAP 'source' object; properties 'path' and 'sourceReference' are both missing.")}}registerAllDebugTypes(s){const v=[];for(const a of s.getAllExtensionDescriptions())if(a.contributes){const E=a.contributes.debuggers;if(E&&E.length>0)for(const I of E)(0,o.isDebuggerMainContribution)(I)&&v.push(I.type)}this._debugServiceProxy.$registerDebugTypes(v)}get onDidChangeBreakpoints(){return this._onDidChangeBreakpoints.event}get breakpoints(){this.startBreakpoints();const s=[];return this._breakpoints.forEach(v=>s.push(v)),s}addBreakpoints(s){this.startBreakpoints();const v=s.filter(I=>{const D=I.id;return this._breakpoints.has(D)?!1:(this._breakpoints.set(D,I),!0)});this.fireBreakpointChanges(v,[],[]);const a=[],E=new Map;for(const I of v)if(I instanceof T.SourceBreakpoint){let D=E.get(I.location.uri.toString());D||(D={type:"sourceMulti",uri:I.location.uri,lines:[]},E.set(I.location.uri.toString(),D),a.push(D)),D.lines.push({id:I.id,enabled:I.enabled,condition:I.condition,hitCondition:I.hitCondition,logMessage:I.logMessage,line:I.location.range.start.line,character:I.location.range.start.character})}else I instanceof T.FunctionBreakpoint&&a.push({type:"function",id:I.id,enabled:I.enabled,hitCondition:I.hitCondition,logMessage:I.logMessage,condition:I.condition,functionName:I.functionName});return this._debugServiceProxy.$registerBreakpoints(a)}removeBreakpoints(s){this.startBreakpoints();const v=s.filter(D=>this._breakpoints.delete(D.id));this.fireBreakpointChanges([],v,[]);const a=v.filter(D=>D instanceof T.SourceBreakpoint).map(D=>D.id),E=v.filter(D=>D instanceof T.FunctionBreakpoint).map(D=>D.id),I=v.filter(D=>D instanceof T.DataBreakpoint).map(D=>D.id);return this._debugServiceProxy.$unregisterBreakpoints(a,E,I)}startDebugging(s,v,a){return this._debugServiceProxy.$startDebugging(s?s.uri:void 0,v,{parentSessionID:a.parentSession?a.parentSession.id:void 0,lifecycleManagedByParent:a.lifecycleManagedByParent,repl:a.consoleMode===T.DebugConsoleMode.MergeWithParent?"mergeWithParent":"separate",noDebug:a.noDebug,compact:a.compact,debugUI:a.debugUI,suppressSaveBeforeStart:a.suppressSaveBeforeStart})}stopDebugging(s){return this._debugServiceProxy.$stopDebugging(s?s.id:void 0)}registerDebugConfigurationProvider(s,v,a){if(!v)return new T.Disposable(()=>{});const E=this._configProviderHandleCounter++;return this._configProviders.push({type:s,handle:E,provider:v}),this._debugServiceProxy.$registerDebugConfigurationProvider(s,a,!!v.provideDebugConfigurations,!!v.resolveDebugConfiguration,!!v.resolveDebugConfigurationWithSubstitutedVariables,E),new T.Disposable(()=>{this._configProviders=this._configProviders.filter(I=>I.provider!==v),this._debugServiceProxy.$unregisterDebugConfigurationProvider(E)})}registerDebugAdapterDescriptorFactory(s,v,a){if(!a)return new T.Disposable(()=>{});if(!this.definesDebugType(s,v))throw new Error(`a DebugAdapterDescriptorFactory can only be registered from the extension that defines the '${v}' debugger.`);if(this.getAdapterDescriptorFactoryByType(v))throw new Error("a DebugAdapterDescriptorFactory can only be registered once per a type.");const E=this._adapterFactoryHandleCounter++;return this._adapterFactories.push({type:v,handle:E,factory:a}),this._debugServiceProxy.$registerDebugAdapterDescriptorFactory(v,E),new T.Disposable(()=>{this._adapterFactories=this._adapterFactories.filter(I=>I.factory!==a),this._debugServiceProxy.$unregisterDebugAdapterDescriptorFactory(E)})}registerDebugAdapterTrackerFactory(s,v){if(!v)return new T.Disposable(()=>{});const a=this._trackerFactoryHandleCounter++;return this._trackerFactories.push({type:s,handle:a,factory:v}),new T.Disposable(()=>{this._trackerFactories=this._trackerFactories.filter(E=>E.factory!==v)})}async $runInTerminal(s,v){return Promise.resolve(void 0)}async $substituteVariables(s,v){if(!this._variableResolver){const[I,D]=await Promise.all([this._workspaceService.getWorkspaceFolders2(),this._configurationService.getConfigProvider()]);this._variableResolver=this.createVariableResolver(I||[],this._editorsService,D)}let a;const E=await this.getFolder(s);return E&&(a={uri:E.uri,name:E.name,index:E.index,toResource:()=>{throw new Error("Not implemented")}}),this._variableResolver.resolveAnyAsync(a,v)}createDebugAdapter(s,v){if(s.type==="implementation")return new i(s.implementation)}createSignService(){}async $startDASession(s,v){const a=this,E=await this.getSession(v);return this.getAdapterDescriptor(this.getAdapterDescriptorFactoryByType(E.type),E).then(I=>{if(!I)throw new Error(`Couldn't find a debug adapter descriptor for debug type '${E.type}' (extension might have failed to activate)`);const D=this.convertToDto(I),B=this.createDebugAdapter(D,E);if(!B)throw new Error(`Couldn't create a debug adapter for type '${E.type}'.`);const L=B;return this._debugAdapters.set(s,L),this.getDebugAdapterTrackers(E).then(y=>(y&&this._debugAdaptersTrackers.set(s,y),L.onMessage(async x=>{if(x.type==="request"&&x.command==="handshake"){const N=x,z={type:"response",seq:0,command:N.command,request_seq:N.seq,success:!0};this._signService||(this._signService=this.createSignService());try{if(this._signService){const H=await this._signService.sign(N.arguments.value);z.body={signature:H},L.sendResponse(z)}else throw new Error("no signer")}catch(H){z.success=!1,z.message=H.message,L.sendResponse(z)}}else y&&y.onDidSendMessage&&y.onDidSendMessage(x),x=(0,o.convertToVSCPaths)(x,!0),a._debugServiceProxy.$acceptDAMessage(s,x)}),L.onError(x=>{y&&y.onError&&y.onError(x),this._debugServiceProxy.$acceptDAError(s,x.name,x.message,x.stack)}),L.onExit(x=>{y&&y.onExit&&y.onExit((0,S.withNullAsUndefined)(x),void 0),this._debugServiceProxy.$acceptDAExit(s,(0,S.withNullAsUndefined)(x),void 0)}),y&&y.onWillStartSession&&y.onWillStartSession(),L.startSession()))})}$sendDAMessage(s,v){v=(0,o.convertToDAPaths)(v,!1);const a=this._debugAdaptersTrackers.get(s);a&&a.onWillReceiveMessage&&a.onWillReceiveMessage(v);const E=this._debugAdapters.get(s);E&&E.sendMessage(v)}$stopDASession(s){const v=this._debugAdaptersTrackers.get(s);this._debugAdaptersTrackers.delete(s),v&&v.onWillStopSession&&v.onWillStopSession();const a=this._debugAdapters.get(s);return this._debugAdapters.delete(s),a?a.stopSession():Promise.resolve(void 0)}$acceptBreakpointsDelta(s){const v=[],a=[],E=[];if(s.added)for(const I of s.added){const D=I.id;if(D&&!this._breakpoints.has(D)){let B;if(I.type==="function")B=new T.FunctionBreakpoint(I.functionName,I.enabled,I.condition,I.hitCondition,I.logMessage);else if(I.type==="data")B=new T.DataBreakpoint(I.label,I.dataId,I.canPersist,I.enabled,I.hitCondition,I.condition,I.logMessage);else{const L=F.URI.revive(I.uri);B=new T.SourceBreakpoint(new T.Location(L,new T.Position(I.line,I.character)),I.enabled,I.condition,I.hitCondition,I.logMessage)}B._id=D,this._breakpoints.set(D,B),v.push(B)}}if(s.removed)for(const I of s.removed){const D=this._breakpoints.get(I);D&&(this._breakpoints.delete(I),a.push(D))}if(s.changed){for(const I of s.changed)if(I.id){const D=this._breakpoints.get(I.id);if(D){if(D instanceof T.FunctionBreakpoint&&I.type==="function"){const B=D;B.enabled=I.enabled,B.condition=I.condition,B.hitCondition=I.hitCondition,B.logMessage=I.logMessage,B.functionName=I.functionName}else if(D instanceof T.SourceBreakpoint&&I.type==="source"){const B=D;B.enabled=I.enabled,B.condition=I.condition,B.hitCondition=I.hitCondition,B.logMessage=I.logMessage,B.location=new T.Location(F.URI.revive(I.uri),new T.Position(I.line,I.character))}E.push(D)}}}this.fireBreakpointChanges(v,a,E)}$provideDebugConfigurations(s,v,a){return(0,P.asPromise)(async()=>{const E=this.getConfigProviderByHandle(s);if(!E)throw new Error("no DebugConfigurationProvider found");if(!E.provideDebugConfigurations)throw new Error("DebugConfigurationProvider has no method provideDebugConfigurations");const I=await this.getFolder(v);return E.provideDebugConfigurations(I,a)}).then(E=>{if(!E)throw new Error("nothing returned from DebugConfigurationProvider.provideDebugConfigurations");return E})}$resolveDebugConfiguration(s,v,a,E){return(0,P.asPromise)(async()=>{const I=this.getConfigProviderByHandle(s);if(!I)throw new Error("no DebugConfigurationProvider found");if(!I.resolveDebugConfiguration)throw new Error("DebugConfigurationProvider has no method resolveDebugConfiguration");const D=await this.getFolder(v);return I.resolveDebugConfiguration(D,a,E)})}$resolveDebugConfigurationWithSubstitutedVariables(s,v,a,E){return(0,P.asPromise)(async()=>{const I=this.getConfigProviderByHandle(s);if(!I)throw new Error("no DebugConfigurationProvider found");if(!I.resolveDebugConfigurationWithSubstitutedVariables)throw new Error("DebugConfigurationProvider has no method resolveDebugConfigurationWithSubstitutedVariables");const D=await this.getFolder(v);return I.resolveDebugConfigurationWithSubstitutedVariables(D,a,E)})}async $provideDebugAdapter(s,v){const a=this.getAdapterDescriptorFactoryByHandle(s);if(!a)return Promise.reject(new Error("no adapter descriptor factory found for handle"));const E=await this.getSession(v);return this.getAdapterDescriptor(a,E).then(I=>{if(!I)throw new Error(`Couldn't find a debug adapter descriptor for debug type '${E.type}'`);return this.convertToDto(I)})}async $acceptDebugSessionStarted(s){const v=await this.getSession(s);this._onDidStartDebugSession.fire(v)}async $acceptDebugSessionTerminated(s){const v=await this.getSession(s);v&&(this._onDidTerminateDebugSession.fire(v),this._debugSessions.delete(v.id))}async $acceptDebugSessionActiveChanged(s){this._activeDebugSession=s?await this.getSession(s):void 0,this._onDidChangeActiveDebugSession.fire(this._activeDebugSession)}async $acceptDebugSessionNameChanged(s,v){const a=await this.getSession(s);a&&a._acceptNameChanged(v)}async $acceptDebugSessionCustomEvent(s,v){const E={session:await this.getSession(s),event:v.event,body:v.body};this._onDidReceiveDebugSessionCustomEvent.fire(E)}convertToDto(s){if(s instanceof T.DebugAdapterExecutable)return{type:"executable",command:s.command,args:s.args,options:s.options};if(s instanceof T.DebugAdapterServer)return{type:"server",port:s.port,host:s.host};if(s instanceof T.DebugAdapterNamedPipeServer)return{type:"pipeServer",path:s.path};if(s instanceof T.DebugAdapterInlineImplementation)return{type:"implementation",implementation:s.implementation};throw new Error("convertToDto unexpected type")}getAdapterDescriptorFactoryByType(s){const v=this._adapterFactories.filter(a=>a.type===s);if(v.length>0)return v[0].factory}getAdapterDescriptorFactoryByHandle(s){const v=this._adapterFactories.filter(a=>a.handle===s);if(v.length>0)return v[0].factory}getConfigProviderByHandle(s){const v=this._configProviders.filter(a=>a.handle===s);if(v.length>0)return v[0].provider}definesDebugType(s,v){if(s.contributes){const a=s.contributes.debuggers;if(a&&a.length>0){for(const E of a)if(E.label&&E.type&&E.type===v)return!0}}return!1}getDebugAdapterTrackers(s){const a=s.configuration.type,E=this._trackerFactories.filter(I=>I.type===a||I.type==="*").map(I=>(0,P.asPromise)(()=>I.factory.createDebugAdapterTracker(s)).then(D=>D,D=>null));return Promise.race([Promise.all(E).then(I=>{const D=I.filter(B=>!!B);if(D.length>0)return new r(D)}),new Promise((I,D)=>{const B=setTimeout(()=>{clearTimeout(B),D(new Error("timeout"))},1e3)})]).catch(I=>{})}async getAdapterDescriptor(s,v){const a=v.configuration.debugServer;if(typeof a=="number")return Promise.resolve(new T.DebugAdapterServer(a));if(s){const I=await this._extensionService.getExtensionRegistry();return(0,P.asPromise)(()=>s.createDebugAdapterDescriptor(v,this.daExecutableFromPackage(v,I))).then(D=>{if(D)return D})}const E=await this._extensionService.getExtensionRegistry();return Promise.resolve(this.daExecutableFromPackage(v,E))}daExecutableFromPackage(s,v){}startBreakpoints(){this._breakpointEventsActive||(this._breakpointEventsActive=!0,this._debugServiceProxy.$startBreakpointEvents())}fireBreakpointChanges(s,v,a){(s.length>0||v.length>0||a.length>0)&&this._onDidChangeBreakpoints.fire(Object.freeze({added:s,removed:v,changed:a}))}async getSession(s){if(s)if(typeof s=="string"){const v=this._debugSessions.get(s);if(v)return v}else{let v=this._debugSessions.get(s.id);if(!v){const a=await this.getFolder(s.folderUri),E=s.parent?this._debugSessions.get(s.parent):void 0;v=new A(this._debugServiceProxy,s.id,s.type,s.name,a,s.configuration,E),this._debugSessions.set(v.id,v),this._debugServiceProxy.$sessionCached(v.id)}return v}throw new Error("cannot find session")}getFolder(s){if(s){const v=F.URI.revive(s);return this._workspaceService.resolveWorkspaceFolder(v)}return Promise.resolve(void 0)}};g=Ue([$e(0,d.IExtHostRpcService),$e(1,k.IExtHostWorkspace),$e(2,R.IExtHostExtensionService),$e(3,_.IExtHostDocumentsAndEditors),$e(4,m.IExtHostConfiguration),$e(5,h.IExtHostEditorTabs)],g),e.ExtHostDebugServiceBase=g;class A{constructor(s,v,a,E,I,D,B){this._debugServiceProxy=s,this._id=v,this._type=a,this._name=E,this._workspaceFolder=I,this._configuration=D,this._parentSession=B}get id(){return this._id}get type(){return this._type}get name(){return this._name}set name(s){this._name=s,this._debugServiceProxy.$setDebugSessionName(this._id,s)}get parentSession(){return this._parentSession}_acceptNameChanged(s){this._name=s}get workspaceFolder(){return this._workspaceFolder}get configuration(){return this._configuration}customRequest(s,v){return this._debugServiceProxy.$customDebugAdapterRequest(this._id,s,v)}getDebugProtocolBreakpoint(s){return this._debugServiceProxy.$getDebugProtocolBreakpoint(this._id,s.id)}}e.ExtHostDebugSession=A;class l{constructor(s){this.value=Object.freeze({append(v){s.$appendDebugConsole(v)},appendLine(v){this.append(v+`
`)}})}}e.ExtHostDebugConsole=l;class M extends n.AbstractVariableResolverService{constructor(s,v,a,E,I){function D(){if(v){const B=v.activeEditor();if(B)return B.document.uri;const L=E.tabs.filter(y=>y.isActive);if(L.length>0){const y=L[0].resource;return y&&(y.primary||y.secondary)?y.primary??y.secondary:L[0].resource}}}super({getFolderUri:B=>{const L=s.filter(y=>y.name===B);if(L&&L.length>0)return L[0].uri},getWorkspaceFolderCount:()=>s.length,getConfigurationValue:(B,L)=>a.getConfiguration(void 0,B).get(L),getAppRoot:()=>b.cwd(),getExecPath:()=>b.env.VSCODE_EXEC_PATH,getFilePath:()=>{const B=D();if(B)return c.normalize(B.fsPath)},getWorkspaceFolderPathForFile:()=>{if(I){const B=D();if(B){const L=I.getWorkspaceFolder(B);if(L)return c.normalize(L.uri.fsPath)}}},getSelectedText:()=>{if(v){const B=v.activeEditor();if(B&&!B.selection.isEmpty)return B.document.getText(B.selection)}},getLineNumber:()=>{if(v){const B=v.activeEditor();if(B)return String(B.selection.end.line+1)}}},void 0,Promise.resolve(b.env))}}e.ExtHostVariableResolverService=M;class r{constructor(s){this.trackers=s}onWillStartSession(){this.trackers.forEach(s=>s.onWillStartSession?s.onWillStartSession():void 0)}onWillReceiveMessage(s){this.trackers.forEach(v=>v.onWillReceiveMessage?v.onWillReceiveMessage(s):void 0)}onDidSendMessage(s){this.trackers.forEach(v=>v.onDidSendMessage?v.onDidSendMessage(s):void 0)}onWillStopSession(){this.trackers.forEach(s=>s.onWillStopSession?s.onWillStopSession():void 0)}onError(s){this.trackers.forEach(v=>v.onError?v.onError(s):void 0)}onExit(s,v){this.trackers.forEach(a=>a.onExit?a.onExit(s,v):void 0)}}class i extends C.AbstractDebugAdapter{constructor(s){super();this.implementation=s,s.onDidSendMessage(v=>{this.acceptMessage(v)})}startSession(){return Promise.resolve(void 0)}sendMessage(s){this.implementation.handleMessage(s)}stopSession(){return this.implementation.dispose(),Promise.resolve(void 0)}}let p=class extends g{constructor(s,v,a,E,I,D){super(s,v,a,E,I,D)}createVariableResolver(s,v,a){return new M(s,v,a,this._editorTabs)}};p=Ue([$e(0,d.IExtHostRpcService),$e(1,k.IExtHostWorkspace),$e(2,R.IExtHostExtensionService),$e(3,_.IExtHostDocumentsAndEditors),$e(4,m.IExtHostConfiguration),$e(5,h.IExtHostEditorTabs)],p),e.WorkerExtHostDebugService=p}),define(Ee[215],_e([0,1,73,2,5,32,27,25,13,28,4,33,89,12]),function(re,e,c,F,w,P,t,T,C,k,R,_,n,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RequireInterceptor=void 0;let o=class{constructor(h,g,A,l,M,r,i){this._apiFactory=h,this._extensionRegistry=g,this._instaService=A,this._extHostConfiguration=l,this._extHostExtensionService=M,this._initData=r,this._logService=i,this._factories=new Map,this._alternatives=[]}async install(){this._installInterceptor(),c.mark("code/extHost/willWaitForConfig");const h=await this._extHostConfiguration.getConfigProvider();c.mark("code/extHost/didWaitForConfig");const g=await this._extHostExtensionService.getExtensionPathIndex();this.register(new d(this._apiFactory,g,this._extensionRegistry,h,this._logService)),this.register(this._instaService.createInstance(u,g)),this._initData.remote.isRemote&&this.register(this._instaService.createInstance(S,g,this._initData.environment.appUriScheme))}register(h){if(Array.isArray(h.nodeModuleName))for(let g of h.nodeModuleName)this._factories.set(g,h);else this._factories.set(h.nodeModuleName,h);typeof h.alternativeModuleName=="function"&&this._alternatives.push(g=>h.alternativeModuleName(g))}};o=Ue([$e(2,R.IInstantiationService),$e(3,P.IExtHostConfiguration),$e(4,_.IExtHostExtensionService),$e(5,k.IExtHostInitDataService),$e(6,m.ILogService)],o),e.RequireInterceptor=o;class d{constructor(h,g,A,l,M){this._apiFactory=h,this._extensionPaths=g,this._extensionRegistry=A,this._configProvider=l,this._logService=M,this.nodeModuleName="vscode",this._extApiImpl=new Map}load(h,g){const A=this._extensionPaths.findSubstr(g);if(A){let l=this._extApiImpl.get(T.ExtensionIdentifier.toKey(A.identifier));return l||(l=this._apiFactory(A,this._extensionRegistry,this._configProvider),this._extApiImpl.set(T.ExtensionIdentifier.toKey(A.identifier),l)),l}if(!this._defaultApiImpl){let l="";this._extensionPaths.forEach((M,r)=>l+=`	${r} -> ${M.identifier.value}
`),this._logService.warn(`Could not identify extension for 'vscode' require call from ${g}. These are the extension path mappings: 
${l}`),this._defaultApiImpl=this._apiFactory(t.nullExtensionDescription,this._extensionRegistry,this._configProvider)}return this._defaultApiImpl}}let u=class{constructor(h,g,A){this._extensionPaths=h,this.nodeModuleName="keytar",this._mainThreadTelemetry=g.getProxy(w.MainContext.MainThreadTelemetry);const{environment:l}=A,M=g.getProxy(w.MainContext.MainThreadKeytar);if(l.appRoot){let r=l.appRoot.fsPath;n.platform==="win32"&&(r=r.replace(/\\/g,"/")),r[r.length-1]==="/"&&(r=r.substr(0,r.length-1)),this.alternativeNames=new Set,this.alternativeNames.add(`${r}/node_modules.asar/keytar`),this.alternativeNames.add(`${r}/node_modules/keytar`)}this._impl={getPassword:(r,i)=>M.$getPassword(r,i),setPassword:(r,i,p)=>M.$setPassword(r,i,p),deletePassword:(r,i)=>M.$deletePassword(r,i),findPassword:r=>M.$findPassword(r),findCredentials(r){return M.$findCredentials(r)}}}load(h,g){const A=this._extensionPaths.findSubstr(g);return this._mainThreadTelemetry.$publicLog2("shimming.keytar",{extension:A?.identifier.value??"unknown_extension"}),this._impl}alternativeModuleName(h){const g=h.length;if(g<=7||!this.alternativeNames)return;const A=g-7;if((h.charAt(A)==="/"||h.charAt(A)==="\\")&&h.endsWith("keytar")&&(h=h.replace(/\\/g,"/"),this.alternativeNames.has(h)))return"keytar"}};u=Ue([$e(1,C.IExtHostRpcService),$e(2,k.IExtHostInitDataService)],u);let S=class{constructor(h,g,A){this._extensionPaths=h,this._appUriScheme=g,this.nodeModuleName=["open","opn"],this._mainThreadTelemetry=A.getProxy(w.MainContext.MainThreadTelemetry);const l=A.getProxy(w.MainContext.MainThreadWindow);this._impl=(M,r)=>{const i=F.URI.parse(M);return r?this.callOriginal(M,r):i.scheme==="http"||i.scheme==="https"?l.$openUri(i,M,{allowTunneling:!0}):i.scheme==="mailto"||i.scheme===this._appUriScheme?l.$openUri(i,M,{}):this.callOriginal(M,r)}}load(h,g,A){const l=this._extensionPaths.findSubstr(g);return l&&(this._extensionId=l.identifier.value,this.sendShimmingTelemetry()),this._original=A(h),this._impl}callOriginal(h,g){return this.sendNoForwardTelemetry(),this._original(h,g)}sendShimmingTelemetry(){!this._extensionId||this._mainThreadTelemetry.$publicLog2("shimming.open",{extension:this._extensionId})}sendNoForwardTelemetry(){!this._extensionId||this._mainThreadTelemetry.$publicLog2("shimming.open.call.noForward",{extension:this._extensionId})}};S=Ue([$e(2,C.IExtHostRpcService)],S)}),define(Ee[216],_e([0,1,14,15,73,6,2,5,209,12,56,60,28,137,13,65,33,39]),function(re,e,c,F,w,P,t,T,C,k,R,_,n,m,o,d,u,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionHostMain=void 0;class b{constructor(g,A,l,M){this._disposables=new P.DisposableStore,this._isTerminating=!1,this._hostUtils=l,this._rpcProtocol=new C.RPCProtocol(g,null,M),A=b._transform(A,this._rpcProtocol);const r=new _.ServiceCollection(...(0,R.getSingletonServiceDescriptors)());r.set(n.IExtHostInitDataService,{_serviceBrand:void 0,...A}),r.set(o.IExtHostRpcService,new o.ExtHostRpcService(this._rpcProtocol)),r.set(d.IURITransformerService,new d.URITransformerService(M)),r.set(u.IHostUtils,l);const i=new m.InstantiationService(r,!0);this._disposables.add(i.invokeFunction(v=>v.get(S.IExtHostTerminalService))),this._disposables.add(i.invokeFunction(v=>v.get(u.IExtHostExtensionService))),this._logService=i.invokeFunction(v=>v.get(k.ILogService)),w.mark("code/extHost/didCreateServices"),this._hostUtils.pid?this._logService.info(`Extension host with pid ${this._hostUtils.pid} started`):this._logService.info("Extension host started"),this._logService.trace("initData",A),this._extensionService=i.invokeFunction(v=>v.get(u.IExtHostExtensionService)),this._extensionService.initialize(),Error.stackTraceLimit=100;const p=new WeakMap;this._extensionService.getExtensionPathIndex().then(v=>{Error.prepareStackTrace=(a,E)=>{let I="",D,B;for(const L of E)I+=`
	at ${L.toString()}`,B=L.getFileName(),!D&&B&&(D=v.findSubstr(t.URI.file(B)));return p.set(a,D),`${a.name||"Error"}: ${a.message||""}${I}`}});const f=this._rpcProtocol.getProxy(T.MainContext.MainThreadExtensionService),s=this._rpcProtocol.getProxy(T.MainContext.MainThreadErrors);F.setUnexpectedErrorHandler(v=>{const a=F.transformErrorForSerialization(v),E=p.get(v);E?f.$onExtensionRuntimeError(E.identifier,a):s.$onUnexpectedError(a)})}terminate(g){if(this._isTerminating)return;this._isTerminating=!0,this._logService.info(`extension host terminating: ${g}`),this._logService.flush(),this._disposables.dispose(),F.setUnexpectedErrorHandler(l=>{this._logService.error(l)}),this._rpcProtocol.dispose();const A=this._extensionService.deactivateAll();Promise.race([(0,c.timeout)(5e3),A]).finally(()=>{this._hostUtils.pid?this._logService.info(`Extension host with pid ${this._hostUtils.pid} exiting with code 0`):this._logService.info("Extension host exiting with code 0"),this._logService.flush(),this._logService.dispose(),this._hostUtils.exit(0)})}static _transform(g,A){g.extensions.forEach(M=>M.extensionLocation=t.URI.revive(A.transformIncomingURIs(M.extensionLocation))),g.environment.appRoot=t.URI.revive(A.transformIncomingURIs(g.environment.appRoot));const l=g.environment.extensionDevelopmentLocationURI;return l&&(g.environment.extensionDevelopmentLocationURI=l.map(M=>t.URI.revive(A.transformIncomingURIs(M)))),g.environment.extensionTestsLocationURI=t.URI.revive(A.transformIncomingURIs(g.environment.extensionTestsLocationURI)),g.environment.globalStorageHome=t.URI.revive(A.transformIncomingURIs(g.environment.globalStorageHome)),g.environment.workspaceStorageHome=t.URI.revive(A.transformIncomingURIs(g.environment.workspaceStorageHome)),g.logsLocation=t.URI.revive(A.transformIncomingURIs(g.logsLocation)),g.logFile=t.URI.revive(A.transformIncomingURIs(g.logFile)),g.workspace=A.transformIncomingURIs(g.workspace),g}}e.ExtensionHostMain=b}),define(Ee[217],_e([0,1,17,20,43,29,24,190,40]),function(re,e,c,F,w,P,t,T,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileSearchManager=void 0;class k{constructor(n,m,o){this.config=n,this.provider=m,this.sessionToken=o,this.isLimitHit=!1,this.resultCount=0,this.isCanceled=!1,this.filePattern=n.filePattern,this.includePattern=n.includePattern&&P.parse(n.includePattern),this.maxResults=n.maxResults||void 0,this.exists=n.exists,this.activeCancellationTokens=new Set,this.globalExcludePattern=n.excludePattern&&P.parse(n.excludePattern)}cancel(){this.isCanceled=!0,this.activeCancellationTokens.forEach(n=>n.cancel()),this.activeCancellationTokens=new Set}search(n){const m=this.config.folderQueries||[];return new Promise((o,d)=>{const u=S=>{this.resultCount++,n(S)};if(this.isCanceled)return o({limitHit:this.isLimitHit});this.config.extraFileResources&&this.config.extraFileResources.forEach(S=>{const b=S.toString(),h=c.basename(b);this.globalExcludePattern&&this.globalExcludePattern(b,h)||this.matchFile(u,{base:S,basename:h})}),Promise.all(m.map(S=>this.searchInFolder(S,u))).then(S=>{o({limitHit:this.isLimitHit,stats:S[0]||void 0})},S=>{d(new Error((0,w.toErrorMessage)(S)))})})}async searchInFolder(n,m){const o=new F.CancellationTokenSource,d=this.getSearchOptionsForFolder(n),u=this.initDirectoryTree(),S=new C.QueryGlobTester(this.config,n),b=!S.hasSiblingExcludeClauses();let h;try{this.activeCancellationTokens.add(o),h=T.StopWatch.create();const g=await this.provider.provideFileSearchResults({pattern:this.config.filePattern||""},d,o.token),A=h.elapsed(),l=T.StopWatch.create();return this.isCanceled&&!this.isLimitHit||(g&&g.forEach(M=>{const r=c.posix.relative(n.folder.path,M.path);if(b){const i=c.basename(M.path);this.matchFile(m,{base:n.folder,relativePath:r,basename:i});return}this.addDirectoryEntries(u,n.folder,r,m)}),this.isCanceled&&!this.isLimitHit)?null:(this.matchDirectoryTree(u,S,m),{providerTime:A,postProcessTime:l.elapsed()})}finally{o.dispose(),this.activeCancellationTokens.delete(o)}}getSearchOptionsForFolder(n){const m=(0,C.resolvePatternsForProvider)(this.config.includePattern,n.includePattern),o=(0,C.resolvePatternsForProvider)(this.config.excludePattern,n.excludePattern);return{folder:n.folder,excludes:o,includes:m,useIgnoreFiles:!n.disregardIgnoreFiles,useGlobalIgnoreFiles:!n.disregardGlobalIgnoreFiles,followSymlinks:!n.ignoreSymlinks,maxResults:this.config.maxResults,session:this.sessionToken}}initDirectoryTree(){const n={rootEntries:[],pathToEntries:Object.create(null)};return n.pathToEntries["."]=n.rootEntries,n}addDirectoryEntries({pathToEntries:n},m,o,d){if(o===this.filePattern){const S=c.basename(this.filePattern);this.matchFile(d,{base:m,relativePath:this.filePattern,basename:S})}function u(S){const b=c.basename(S),h=c.dirname(S);let g=n[h];g||(g=n[h]=[],u(h)),g.push({base:m,relativePath:S,basename:b})}u(o)}matchDirectoryTree({rootEntries:n,pathToEntries:m},o,d){const u=this,S=this.filePattern;function b(h){const g=P.hasSiblingFn(()=>h.map(A=>A.basename));for(let A=0,l=h.length;A<l;A++){const M=h[A],{relativePath:r,basename:i}=M;if(o.matchesExcludesSync(r,i,S!==i?g:void 0))continue;const p=m[r];if(p)b(p);else{if(r===S)continue;u.matchFile(d,M)}if(u.isLimitHit)break}}b(n)}matchFile(n,m){(!this.includePattern||m.relativePath&&this.includePattern(m.relativePath,m.basename))&&((this.exists||this.maxResults&&this.resultCount>=this.maxResults)&&(this.isLimitHit=!0,this.cancel()),this.isLimitHit||n(m))}}class R{constructor(){this.sessions=new Map}fileSearch(n,m,o,d){const u=this.getSessionTokenSource(n.cacheKey),S=new k(n,m,u&&u.token);let b=0;const h=g=>{b+=g.length,o(g.map(A=>this.rawMatchToSearchItem(A)))};return this.doSearch(S,R.BATCH_SIZE,h,d).then(g=>({limitHit:g.limitHit,stats:{fromCache:!1,type:"fileSearchProvider",resultCount:b,detailStats:g.stats}}))}clearCache(n){const m=this.getSessionTokenSource(n);m&&m.cancel()}getSessionTokenSource(n){if(!!n)return this.sessions.has(n)||this.sessions.set(n,new F.CancellationTokenSource),this.sessions.get(n)}rawMatchToSearchItem(n){return n.relativePath?{resource:t.joinPath(n.base,n.relativePath)}:{resource:n.base}}doSearch(n,m,o,d){d.onCancellationRequested(()=>{n.cancel()});const u=b=>{b&&(S.push(b),m>0&&S.length>=m&&(o(S),S=[]))};let S=[];return n.search(u).then(b=>(S.length&&o(S),b),b=>(S.length&&o(S),Promise.reject(b)))}}e.FileSearchManager=R,R.BATCH_SIZE=512}),define(Ee[218],_e([0,1,16,20,43,29,10,17,24,11,2,40]),function(re,e,c,F,w,P,t,T,C,k,R,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.BatchedCollector=e.extensionResultIsMatch=e.TextSearchResultsCollector=e.TextSearchManager=void 0;class n{constructor(h,g,A,l){this.query=h,this.provider=g,this.fileUtils=A,this.processType=l,this.collector=null,this.isLimitHit=!1,this.resultCount=0}search(h,g){const A=this.query.folderQueries||[],l=new F.CancellationTokenSource;return g.onCancellationRequested(()=>l.cancel()),new Promise((M,r)=>{this.collector=new o(h);let i=!1;const p=(f,s)=>{if(!i&&!this.isLimitHit){const v=this.resultSize(f);u(f)&&typeof this.query.maxResults=="number"&&this.resultCount+v>this.query.maxResults&&(this.isLimitHit=!0,i=!0,l.cancel(),f=this.trimResultToSize(f,this.query.maxResults-this.resultCount));const a=this.resultSize(f);this.resultCount+=a,(a>0||!u(f))&&this.collector.add(f,s)}};Promise.all(A.map((f,s)=>this.searchInFolder(f,v=>p(v,s),l.token))).then(f=>{l.dispose(),this.collector.flush();const s=f.some(v=>!!v&&!!v.limitHit);M({limitHit:this.isLimitHit||s,messages:(0,c.flatten)(f.map(v=>v?.message?(0,k.isArray)(v.message)?v.message:[v.message]:[])),stats:{type:this.processType}})},f=>{l.dispose();const s=(0,w.toErrorMessage)(f);r(new Error(s))})})}resultSize(h){return u(h)?Array.isArray(h.ranges)?h.ranges.length:1:0}trimResultToSize(h,g){const A=Array.isArray(h.ranges)?h.ranges:[h.ranges],l=Array.isArray(h.preview.matches)?h.preview.matches:[h.preview.matches];return{ranges:A.slice(0,g),preview:{matches:l.slice(0,g),text:h.preview.text},uri:h.uri}}async searchInFolder(h,g,A){const l=new _.QueryGlobTester(this.query,h),M=[],r={report:f=>{if(!this.validateProviderResult(f))return;const s=h.folder.scheme===t.Schemas.file?P.hasSiblingPromiseFn(()=>this.fileUtils.readdir(C.dirname(f.uri))):void 0,v=C.relativePath(h.folder,f.uri);if(v){const a=l.includedInQuery(v,T.basename(v),s);(0,k.isPromise)(a)?M.push(a.then(E=>{E&&g(f)})):a&&g(f)}}},i=this.getSearchOptionsForFolder(h),p=await this.provider.provideTextSearchResults(m(this.query.contentPattern),i,r,A);return M.length&&await Promise.all(M),p}validateProviderResult(h){if(u(h)){if(Array.isArray(h.ranges)){if(!Array.isArray(h.preview.matches))return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same type."),!1;if(h.preview.matches.length!==h.ranges.length)return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same length."),!1}else if(Array.isArray(h.preview.matches))return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same length."),!1}return!0}getSearchOptionsForFolder(h){const g=(0,_.resolvePatternsForProvider)(this.query.includePattern,h.includePattern),A=(0,_.resolvePatternsForProvider)(this.query.excludePattern,h.excludePattern),l={folder:R.URI.from(h.folder),excludes:A,includes:g,useIgnoreFiles:!h.disregardIgnoreFiles,useGlobalIgnoreFiles:!h.disregardGlobalIgnoreFiles,followSymlinks:!h.ignoreSymlinks,encoding:h.fileEncoding&&this.fileUtils.toCanonicalName(h.fileEncoding),maxFileSize:this.query.maxFileSize,maxResults:this.query.maxResults,previewOptions:this.query.previewOptions,afterContext:this.query.afterContext,beforeContext:this.query.beforeContext};return l.usePCRE2=this.query.usePCRE2,l}}e.TextSearchManager=n;function m(b){return{isCaseSensitive:b.isCaseSensitive||!1,isRegExp:b.isRegExp||!1,isWordMatch:b.isWordMatch||!1,isMultiline:b.isMultiline||!1,pattern:b.pattern}}class o{constructor(h){this._onResult=h,this._currentFolderIdx=-1,this._currentFileMatch=null,this._batchedCollector=new S(512,g=>this.sendItems(g))}add(h,g){this._currentFileMatch&&(this._currentFolderIdx!==g||!C.isEqual(this._currentUri,h.uri))&&(this.pushToCollector(),this._currentFileMatch=null),this._currentFileMatch||(this._currentFolderIdx=g,this._currentFileMatch={resource:h.uri,results:[]}),this._currentFileMatch.results.push(d(h))}pushToCollector(){const h=this._currentFileMatch&&this._currentFileMatch.results?this._currentFileMatch.results.length:0;this._batchedCollector.addItem(this._currentFileMatch,h)}flush(){this.pushToCollector(),this._batchedCollector.flush()}sendItems(h){this._onResult(h)}}e.TextSearchResultsCollector=o;function d(b){return u(b)?{preview:{matches:(0,c.mapArrayOrNot)(b.preview.matches,h=>({startLineNumber:h.start.line,startColumn:h.start.character,endLineNumber:h.end.line,endColumn:h.end.character})),text:b.preview.text},ranges:(0,c.mapArrayOrNot)(b.ranges,h=>({startLineNumber:h.start.line,startColumn:h.start.character,endLineNumber:h.end.line,endColumn:h.end.character}))}:{text:b.text,lineNumber:b.lineNumber}}function u(b){return!!b.preview}e.extensionResultIsMatch=u;class S{constructor(h,g){this.maxBatchSize=h,this.cb=g,this.totalNumberCompleted=0,this.batch=[],this.batchSize=0}addItem(h,g){!h||this.addItemToBatch(h,g)}addItems(h,g){!h||this.addItemsToBatch(h,g)}addItemToBatch(h,g){this.batch.push(h),this.batchSize+=g,this.onUpdate()}addItemsToBatch(h,g){this.batch=this.batch.concat(h),this.batchSize+=g,this.onUpdate()}onUpdate(){this.totalNumberCompleted<S.START_BATCH_AFTER_COUNT?this.flush():this.batchSize>=this.maxBatchSize?this.flush():this.timeoutHandle||(this.timeoutHandle=setTimeout(()=>{this.flush()},S.TIMEOUT))}flush(){this.batchSize&&(this.totalNumberCompleted+=this.batchSize,this.cb(this.batch),this.batch=[],this.batchSize=0,this.timeoutHandle&&(clearTimeout(this.timeoutHandle),this.timeoutHandle=0))}}e.BatchedCollector=S,S.TIMEOUT=4e3,S.START_BATCH_AFTER_COUNT=50}),define(Ee[99],_e([0,1,6,5,4,217,13,65,12,2,218]),function(re,e,c,F,w,P,t,T,C,k,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.reviveQuery=e.ExtHostSearch=e.IExtHostSearch=void 0,e.IExtHostSearch=(0,w.createDecorator)("IExtHostSearch");let _=class{constructor(d,u,S){this.extHostRpc=d,this._uriTransformer=u,this._logService=S,this._proxy=this.extHostRpc.getProxy(F.MainContext.MainThreadSearch),this._handlePool=0,this._textSearchProvider=new Map,this._textSearchUsedSchemes=new Set,this._fileSearchProvider=new Map,this._fileSearchUsedSchemes=new Set,this._fileSearchManager=new P.FileSearchManager}_transformScheme(d){return this._uriTransformer.transformOutgoingScheme(d)}registerTextSearchProvider(d,u){if(this._textSearchUsedSchemes.has(d))throw new Error(`a text search provider for the scheme '${d}' is already registered`);this._textSearchUsedSchemes.add(d);const S=this._handlePool++;return this._textSearchProvider.set(S,u),this._proxy.$registerTextSearchProvider(S,this._transformScheme(d)),(0,c.toDisposable)(()=>{this._textSearchUsedSchemes.delete(d),this._textSearchProvider.delete(S),this._proxy.$unregisterProvider(S)})}registerFileSearchProvider(d,u){if(this._fileSearchUsedSchemes.has(d))throw new Error(`a file search provider for the scheme '${d}' is already registered`);this._fileSearchUsedSchemes.add(d);const S=this._handlePool++;return this._fileSearchProvider.set(S,u),this._proxy.$registerFileSearchProvider(S,this._transformScheme(d)),(0,c.toDisposable)(()=>{this._fileSearchUsedSchemes.delete(d),this._fileSearchProvider.delete(S),this._proxy.$unregisterProvider(S)})}$provideFileSearchResults(d,u,S,b){const h=n(S),g=this._fileSearchProvider.get(d);if(g)return this._fileSearchManager.fileSearch(h,g,A=>{this._proxy.$handleFileMatch(d,u,A.map(l=>l.resource))},b);throw new Error("unknown provider: "+d)}$clearCache(d){return this._fileSearchManager.clearCache(d),Promise.resolve(void 0)}$provideTextSearchResults(d,u,S,b){const h=this._textSearchProvider.get(d);if(!h||!h.provideTextSearchResults)throw new Error(`Unknown provider ${d}`);const g=n(S);return this.createTextSearchManager(g,h).search(l=>this._proxy.$handleTextMatch(d,u,l),b)}$enableExtensionHostSearch(){}createTextSearchManager(d,u){return new R.TextSearchManager(d,u,{readdir:S=>Promise.resolve([]),toCanonicalName:S=>S},"textSearchProvider")}};_=Ue([$e(0,t.IExtHostRpcService),$e(1,T.IURITransformerService),$e(2,C.ILogService)],_),e.ExtHostSearch=_;function n(o){return{...o,folderQueries:o.folderQueries&&o.folderQueries.map(m),extraFileResources:o.extraFileResources&&o.extraFileResources.map(d=>k.URI.revive(d))}}e.reviveQuery=n;function m(o){return{...o,folder:k.URI.revive(o.folder)}}}),define(Ee[219],_e([0,1,20,15,3,34,2,113,232,107,55,45,5,180,179,38,181,32,182,183,184,165,185,48,33,186,166,189,191,193,94,168,198,199,200,71,39,202,169,8,7,205,50,95,31,74,154,188,61,93,97,98,99,12,65,13,28,194,151,64,69,177,203,150,72,49,208,206,207,178,30,201,204,68,70,85,196,96,197,10,139,195,148,187,6,27]),function(re,e,c,F,w,P,t,T,C,k,R,_,n,m,o,d,u,S,b,h,g,A,l,M,r,i,p,f,s,v,a,E,I,D,B,L,y,x,N,z,H,q,ue,K,ce,de,Y,ie,we,Me,Re,Be,Qe,Ge,Xe,$,G,J,ae,j,te,me,Pe,Ne,He,Ye,et,st,Je,nt,ct,pt,Ft,Fe,Mt,V,Q,he,Le,We,ot,Ke,_t,Ie,Se,ve){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createApiFactoryAndRegisterActors=void 0;function oe(se){const fe=se.get(G.IExtHostInitDataService),ge=se.get(ct.IExtHostFileSystemInfo),ke=se.get(Ye.IExtHostConsumerFileSystem),ze=se.get(r.IExtHostExtensionService),Oe=se.get(ce.IExtHostWorkspace),Ve=se.get(V.IExtHostTelemetry),it=se.get(S.IExtHostConfiguration),rt=se.get(Xe.IURITransformerService),ne=se.get($.IExtHostRpcService),pe=se.get(L.IExtHostStorage),ee=se.get(He.IExtensionStoragePaths),W=se.get(Ge.ILoggerService),be=se.get(Ge.ILogService),De=se.get(j.IExtHostTunnelService),qe=se.get(te.IExtHostApiDeprecationService),xe=se.get(K.IExtHostWindow),ut=se.get(Fe.IExtHostSecretState),vt=se.get(Mt.IExtHostEditorTabs);ne.set(n.ExtHostContext.ExtHostFileSystemInfo,ge),ne.set(n.ExtHostContext.ExtHostLogLevelServiceShape,W),ne.set(n.ExtHostContext.ExtHostWorkspace,Oe),ne.set(n.ExtHostContext.ExtHostConfiguration,it),ne.set(n.ExtHostContext.ExtHostExtensionService,ze),ne.set(n.ExtHostContext.ExtHostStorage,pe),ne.set(n.ExtHostContext.ExtHostTunnelService,De),ne.set(n.ExtHostContext.ExtHostWindow,xe),ne.set(n.ExtHostContext.ExtHostSecretState,ut),ne.set(n.ExtHostContext.ExtHostTelemetry,Ve),ne.set(n.ExtHostContext.ExtHostEditorTabs,vt);const Ct=ne.set(n.ExtHostContext.ExtHostDecorations,se.get(Me.IExtHostDecorations)),bt=ne.set(n.ExtHostContext.ExtHostDocumentsAndEditors,se.get(M.IExtHostDocumentsAndEditors)),ht=ne.set(n.ExtHostContext.ExtHostCommands,se.get(d.IExtHostCommands)),gt=ne.set(n.ExtHostContext.ExtHostTerminalService,se.get(y.IExtHostTerminalService)),yt=ne.set(n.ExtHostContext.ExtHostDebugService,se.get(Be.IExtHostDebugService)),Lt=ne.set(n.ExtHostContext.ExtHostSearch,se.get(Qe.IExtHostSearch)),It=ne.set(n.ExtHostContext.ExtHostTask,se.get(Re.IExtHostTask)),Pt=ne.set(n.ExtHostContext.ExtHostOutputService,se.get(a.IExtHostOutputService)),At=ne.set(n.ExtHostContext.ExtHostUrls,new q.ExtHostUrls(ne)),Et=ne.set(n.ExtHostContext.ExtHostDocuments,new l.ExtHostDocuments(ne,bt)),Ot=ne.set(n.ExtHostContext.ExtHostDocumentContentProviders,new g.ExtHostDocumentContentProvider(ne,bt,be)),Nt=ne.set(n.ExtHostContext.ExtHostDocumentSaveParticipant,new A.ExtHostDocumentSaveParticipant(be,Et,ne.getProxy(n.MainContext.MainThreadBulkEdits))),wt=ne.set(n.ExtHostContext.ExtHostNotebook,new J.ExtHostNotebookController(ne,ht,bt,Et,ee)),$t=ne.set(n.ExtHostContext.ExtHostNotebookDocuments,new _t.ExtHostNotebookDocuments(be,wt)),jt=ne.set(n.ExtHostContext.ExtHostNotebookEditors,new Ke.ExtHostNotebookEditors(be,ne,wt)),oi=ne.set(n.ExtHostContext.ExtHostNotebookKernels,new Q.ExtHostNotebookKernels(ne,fe,wt,ht,be)),si=ne.set(n.ExtHostContext.ExtHostNotebookRenderers,new Le.ExtHostNotebookRenderers(ne,wt)),Tt=ne.set(n.ExtHostContext.ExtHostEditors,new x.ExtHostEditors(ne,bt)),Yt=ne.set(n.ExtHostContext.ExtHostTreeViews,new N.ExtHostTreeViews(ne.getProxy(n.MainContext.MainThreadTreeViews),ht,be)),ai=ne.set(n.ExtHostContext.ExtHostEditorInsets,new Y.ExtHostEditorInsets(ne.getProxy(n.MainContext.MainThreadEditorInsets),Tt,fe)),Xt=ne.set(n.ExtHostContext.ExtHostDiagnostics,new b.ExtHostDiagnostics(ne,be,ge)),Vt=ne.set(n.ExtHostContext.ExtHostLanguages,new s.ExtHostLanguages(ne,Et,ht.converter,rt)),mt=ne.set(n.ExtHostContext.ExtHostLanguageFeatures,new f.ExtHostLanguageFeatures(ne,rt,Et,ht,Xt,be,qe)),ci=ne.set(n.ExtHostContext.ExtHostFileSystem,new i.ExtHostFileSystem(ne,mt)),xt=ne.set(n.ExtHostContext.ExtHostFileSystemEventService,new p.ExtHostFileSystemEventService(ne,be,bt)),qt=ne.set(n.ExtHostContext.ExtHostQuickOpen,(0,I.createExtHostQuickOpen)(ne,Oe,ht)),Jt=ne.set(n.ExtHostContext.ExtHostSCM,new D.ExtHostSCM(ne,ht,be)),li=ne.set(n.ExtHostContext.ExtHostComments,(0,u.createExtHostComments)(ne,ht,Et)),fi=ne.set(n.ExtHostContext.ExtHostProgress,new E.ExtHostProgress(ne.getProxy(n.MainContext.MainThreadProgress))),Ei=ne.set(n.ExtHostContext.ExtHosLabelService,new ie.ExtHostLabelService(ne)),mi=ne.set(n.ExtHostContext.ExtHostTheming,new ae.ExtHostTheming(ne)),Zt=ne.set(n.ExtHostContext.ExtHostAuthentication,new me.ExtHostAuthentication(ne)),_i=ne.set(n.ExtHostContext.ExtHostTimeline,new Pe.ExtHostTimeline(ne,ht)),Gt=ne.set(n.ExtHostContext.ExtHostWebviews,new ue.ExtHostWebviews(ne,{remote:fe.remote},Oe,be,qe)),Kt=ne.set(n.ExtHostContext.ExtHostWebviewPanels,new Je.ExtHostWebviewPanels(ne,Gt,Oe)),yi=ne.set(n.ExtHostContext.ExtHostCustomEditors,new st.ExtHostCustomEditors(ne,Et,ee,Gt,Kt)),Si=ne.set(n.ExtHostContext.ExtHostWebviewViews,new et.ExtHostWebviewViews(ne,Gt)),Qt=ne.set(n.ExtHostContext.ExtHostTesting,new pt.ExtHostTesting(ne,ht)),Ci=ne.set(n.ExtHostContext.ExtHostUriOpeners,new Ft.ExtHostUriOpeners(ne));ne.set(n.ExtHostContext.ExtHostInteractive,new Ie.ExtHostInteractive(ne,wt,bt,ht));const ei=(0,de.values)(n.ExtHostContext);ne.assertRegistered(ei);const Di=new nt.ExtHostBulkEdits(ne,bt),ki=new o.ExtHostClipboard(ne),ui=new v.ExtHostMessageService(ne,be),ti=new h.ExtHostDialogs(ne),gi=new B.ExtHostStatusBar(ne,ht.converter);return m.ExtHostApiCommands.register(ht),function(Ae,Ut,pi){const ft=function(){let X=!Ae.isUnderDevelopment;function le(){X||(be.info(`Extension '${Ae.identifier.value}' uses a document selector without scheme. Learn more about this: https://go.microsoft.com/fwlink/?linkid=872305`),X=!0)}return function Ce(lt){if(Array.isArray(lt))lt.forEach(Ce);else if(typeof lt=="string")le();else{const St=lt;typeof St.scheme=="undefined"&&le(),typeof St.exclusive=="boolean"&&(0,ve.checkProposedApiEnabled)(Ae,"documentFiltersExclusive")}return lt}}(),ii={getSession(X,le,Ce){return Zt.getSession(Ae,X,le,Ce)},async hasSession(X,le){return(0,ve.checkProposedApiEnabled)(Ae,"authSession"),!!await Zt.getSession(Ae,X,le,{silent:!0})},get onDidChangeSessions(){return Zt.onDidChangeSessions},registerAuthenticationProvider(X,le,Ce,lt){return Zt.registerAuthenticationProvider(X,le,Ce,lt)}},Ii={registerCommand(X,le,Ce){return ht.registerCommand(!0,X,le,Ce,void 0,Ae)},registerTextEditorCommand(X,le,Ce){return ht.registerCommand(!0,X,(...lt)=>{const St=Tt.getActiveTextEditor();if(!St){be.warn("Cannot execute "+X+" because there is no active text editor.");return}return St.edit(Dt=>{le.apply(Ce,[St,Dt,...lt])}).then(Dt=>{Dt||be.warn("Edits from command "+X+" were not applied.")},Dt=>{be.warn("An error occurred while running command "+X,Dt)})},void 0,void 0,Ae)},registerDiffInformationCommand:(X,le,Ce)=>((0,ve.checkProposedApiEnabled)(Ae,"diffCommand"),ht.registerCommand(!0,X,async(...lt)=>{const St=bt.activeEditor(!0);if(!St){be.warn("Cannot execute "+X+" because there is no active text editor.");return}const Dt=await Tt.getDiffInformation(St.id);le.apply(Ce,[Dt,...lt])},void 0,void 0,Ae)),executeCommand(X,...le){return ht.executeCommand(X,...le)},getCommands(X=!1){return ht.getCommands(X)}},vi={get machineId(){return fe.telemetryInfo.machineId},get sessionId(){return fe.telemetryInfo.sessionId},get language(){return fe.environment.appLanguage},get appName(){return fe.environment.appName},get appRoot(){return fe.environment.appRoot?.fsPath??""},get appHost(){return fe.environment.appHost},get uriScheme(){return fe.environment.appUriScheme},get clipboard(){return ki.value},get shell(){return gt.getDefaultShell(!1)},get isTelemetryEnabled(){return Ve.getTelemetryEnabled()},get onDidChangeTelemetryEnabled(){return Ve.onDidChangeTelemetryEnabled},get isNewAppInstall(){const X=Date.now()-new Date(fe.telemetryInfo.firstSessionDate).getTime();return isNaN(X)?!1:X<1e3*60*60*24},openExternal(X,le){return xe.openUri(X,{allowTunneling:!!fe.remote.authority,allowContributedOpeners:le?.allowContributedOpeners})},async asExternalUri(X){if(X.scheme===fe.environment.appUriScheme)return At.createAppUri(X);try{return await xe.asExternalUri(X,{allowTunneling:!!fe.remote.authority})}catch(le){if((0,ot.matchesScheme)(X,We.Schemas.http)||(0,ot.matchesScheme)(X,We.Schemas.https))return X;throw le}},get remoteName(){return(0,we.getRemoteName)(fe.remote.authority)},get remoteAuthority(){return(0,ve.checkProposedApiEnabled)(Ae,"resolvers"),fe.remote.authority},get uiKind(){return fe.uiKind}};fe.environment.extensionTestsLocationURI||Object.freeze(vi);const bi=fe.remote.isRemote?H.ExtensionKind.Workspace:H.ExtensionKind.UI,Pi={createTestController(X,le){return Qt.createTestController(X,le)},createTestObserver(){return(0,ve.checkProposedApiEnabled)(Ae,"testObserver"),Qt.createTestObserver()},runTests(X){return(0,ve.checkProposedApiEnabled)(Ae,"testObserver"),Qt.runTests(X)},get onDidChangeTestResults(){return(0,ve.checkProposedApiEnabled)(Ae,"testObserver"),Qt.onResultsChanged},get testResults(){return(0,ve.checkProposedApiEnabled)(Ae,"testObserver"),Qt.results}},Ti={getExtension(X){const le=Ut.getExtensionDescription(X);if(le)return new r.Extension(ze,Ae.identifier,le,bi)},get all(){return Ut.getAllExtensionDescriptions().map(X=>new r.Extension(ze,Ae.identifier,X,bi))},get onDidChange(){return Ut.onDidChange}},Ai={createDiagnosticCollection(X){return Xt.createDiagnosticCollection(Ae.identifier,X)},get onDidChangeDiagnostics(){return Xt.onDidChangeDiagnostics},getDiagnostics:X=>Xt.getDiagnostics(X),getLanguages(){return Vt.getLanguages()},setTextDocumentLanguage(X,le){return Vt.changeLanguage(X.uri,le)},match(X,le){return(0,R.score)(z.LanguageSelector.from(X),le.uri,le.languageId,!0)},registerCodeActionsProvider(X,le,Ce){return mt.registerCodeActionProvider(Ae,ft(X),le,Ce)},registerCodeLensProvider(X,le){return mt.registerCodeLensProvider(Ae,ft(X),le)},registerDefinitionProvider(X,le){return mt.registerDefinitionProvider(Ae,ft(X),le)},registerDeclarationProvider(X,le){return mt.registerDeclarationProvider(Ae,ft(X),le)},registerImplementationProvider(X,le){return mt.registerImplementationProvider(Ae,ft(X),le)},registerTypeDefinitionProvider(X,le){return mt.registerTypeDefinitionProvider(Ae,ft(X),le)},registerHoverProvider(X,le){return mt.registerHoverProvider(Ae,ft(X),le,Ae.identifier)},registerEvaluatableExpressionProvider(X,le){return mt.registerEvaluatableExpressionProvider(Ae,ft(X),le,Ae.identifier)},registerInlineValuesProvider(X,le){return mt.registerInlineValuesProvider(Ae,ft(X),le,Ae.identifier)},registerDocumentHighlightProvider(X,le){return mt.registerDocumentHighlightProvider(Ae,ft(X),le)},registerLinkedEditingRangeProvider(X,le){return mt.registerLinkedEditingRangeProvider(Ae,ft(X),le)},registerReferenceProvider(X,le){return mt.registerReferenceProvider(Ae,ft(X),le)},registerRenameProvider(X,le){return mt.registerRenameProvider(Ae,ft(X),le)},registerDocumentSymbolProvider(X,le,Ce){return mt.registerDocumentSymbolProvider(Ae,ft(X),le,Ce)},registerWorkspaceSymbolProvider(X){return mt.registerWorkspaceSymbolProvider(Ae,X)},registerDocumentFormattingEditProvider(X,le){return mt.registerDocumentFormattingEditProvider(Ae,ft(X),le)},registerDocumentRangeFormattingEditProvider(X,le){return mt.registerDocumentRangeFormattingEditProvider(Ae,ft(X),le)},registerOnTypeFormattingEditProvider(X,le,Ce,...lt){return mt.registerOnTypeFormattingEditProvider(Ae,ft(X),le,[Ce].concat(lt))},registerDocumentSemanticTokensProvider(X,le,Ce){return mt.registerDocumentSemanticTokensProvider(Ae,ft(X),le,Ce)},registerDocumentRangeSemanticTokensProvider(X,le,Ce){return mt.registerDocumentRangeSemanticTokensProvider(Ae,ft(X),le,Ce)},registerSignatureHelpProvider(X,le,Ce,...lt){return typeof Ce=="object"?mt.registerSignatureHelpProvider(Ae,ft(X),le,Ce):mt.registerSignatureHelpProvider(Ae,ft(X),le,typeof Ce=="undefined"?[]:[Ce,...lt])},registerCompletionItemProvider(X,le,...Ce){return mt.registerCompletionItemProvider(Ae,ft(X),le,Ce)},registerInlineCompletionItemProvider(X,le){return(0,ve.checkProposedApiEnabled)(Ae,"inlineCompletions"),mt.registerInlineCompletionsProvider(Ae,ft(X),le)},registerDocumentLinkProvider(X,le){return mt.registerDocumentLinkProvider(Ae,ft(X),le)},registerColorProvider(X,le){return mt.registerColorProvider(Ae,ft(X),le)},registerFoldingRangeProvider(X,le){return mt.registerFoldingRangeProvider(Ae,ft(X),le)},registerSelectionRangeProvider(X,le){return mt.registerSelectionRangeProvider(Ae,X,le)},registerCallHierarchyProvider(X,le){return mt.registerCallHierarchyProvider(Ae,X,le)},registerTypeHierarchyProvider(X,le){return mt.registerTypeHierarchyProvider(Ae,X,le)},setLanguageConfiguration:(X,le)=>mt.setLanguageConfiguration(Ae,X,le),getTokenInformationAtPosition(X,le){return(0,ve.checkProposedApiEnabled)(Ae,"tokenInformation"),Vt.tokenAtPosition(X,le)},registerInlayHintsProvider(X,le){return(0,ve.checkProposedApiEnabled)(Ae,"inlayHints"),mt.registerInlayHintsProvider(Ae,X,le)},createLanguageStatusItem(X,le){return(0,ve.checkProposedApiEnabled)(Ae,"languageStatus"),Vt.createLanguageStatusItem(Ae,X,le)}},Ri={get activeTextEditor(){return Tt.getActiveTextEditor()},get visibleTextEditors(){return Tt.getVisibleTextEditors()},get activeTerminal(){return gt.activeTerminal},get terminals(){return gt.terminals},async showTextDocument(X,le,Ce){const lt=await(t.URI.isUri(X)?Promise.resolve(ni.openTextDocument(X)):Promise.resolve(X));return Tt.showTextDocument(lt,le,Ce)},createTextEditorDecorationType(X){return Tt.createTextEditorDecorationType(Ae,X)},onDidChangeActiveTextEditor(X,le,Ce){return Tt.onDidChangeActiveTextEditor(X,le,Ce)},onDidChangeVisibleTextEditors(X,le,Ce){return Tt.onDidChangeVisibleTextEditors(X,le,Ce)},onDidChangeTextEditorSelection(X,le,Ce){return Tt.onDidChangeTextEditorSelection(X,le,Ce)},onDidChangeTextEditorOptions(X,le,Ce){return Tt.onDidChangeTextEditorOptions(X,le,Ce)},onDidChangeTextEditorVisibleRanges(X,le,Ce){return Tt.onDidChangeTextEditorVisibleRanges(X,le,Ce)},onDidChangeTextEditorViewColumn(X,le,Ce){return Tt.onDidChangeTextEditorViewColumn(X,le,Ce)},onDidCloseTerminal(X,le,Ce){return gt.onDidCloseTerminal(X,le,Ce)},onDidOpenTerminal(X,le,Ce){return gt.onDidOpenTerminal(X,le,Ce)},onDidChangeActiveTerminal(X,le,Ce){return gt.onDidChangeActiveTerminal(X,le,Ce)},onDidChangeTerminalDimensions(X,le,Ce){return(0,ve.checkProposedApiEnabled)(Ae,"terminalDimensions"),gt.onDidChangeTerminalDimensions(X,le,Ce)},onDidChangeTerminalState(X,le,Ce){return gt.onDidChangeTerminalState(X,le,Ce)},onDidWriteTerminalData(X,le,Ce){return(0,ve.checkProposedApiEnabled)(Ae,"terminalDataWriteEvent"),gt.onDidWriteTerminalData(X,le,Ce)},get state(){return xe.state},onDidChangeWindowState(X,le,Ce){return xe.onDidChangeWindowState(X,le,Ce)},showInformationMessage(X,...le){return ui.showMessage(Ae,P.default.Info,X,le[0],le.slice(1))},showWarningMessage(X,...le){return ui.showMessage(Ae,P.default.Warning,X,le[0],le.slice(1))},showErrorMessage(X,...le){return ui.showMessage(Ae,P.default.Error,X,le[0],le.slice(1))},showQuickPick(X,le,Ce){return Array.isArray(X)&&X.some(lt=>lt.kind!==void 0)&&(0,ve.checkProposedApiEnabled)(Ae,"quickPickSeparators"),qt.showQuickPick(X,le,Ce)},showWorkspaceFolderPick(X){return qt.showWorkspaceFolderPick(X)},showInputBox(X,le){return qt.showInput(X,le)},showOpenDialog(X){return ti.showOpenDialog(X)},showSaveDialog(X){return ti.showSaveDialog(X)},createStatusBarItem(X,le,Ce){let lt,St,Dt;return typeof X=="string"?(lt=X,St=le,Dt=Ce):(St=X,Dt=le),gi.createStatusBarEntry(Ae,lt,St,Dt)},setStatusBarMessage(X,le){return gi.setStatusBarMessage(X,le)},withScmProgress(X){return qe.report("window.withScmProgress",Ae,"Use 'withProgress' instead."),fi.withProgress(Ae,{location:H.ProgressLocation.SourceControl},(le,Ce)=>X({report(lt){}}))},withProgress(X,le){return fi.withProgress(Ae,X,le)},createOutputChannel(X){return Pt.createOutputChannel(X,Ae)},createWebviewPanel(X,le,Ce,lt){return Kt.createWebviewPanel(Ae,X,le,Ce,lt)},createWebviewTextEditorInset(X,le,Ce,lt){return(0,ve.checkProposedApiEnabled)(Ae,"editorInsets"),ai.createWebviewEditorInset(X,le,Ce,lt,Ae)},createTerminal(X,le,Ce){return typeof X=="object"?("location"in X&&(0,ve.checkProposedApiEnabled)(Ae,"terminalLocation"),"pty"in X?gt.createExtensionTerminal(X):gt.createTerminalFromOptions(X)):gt.createTerminal(X,le,Ce)},registerTerminalLinkProvider(X){return gt.registerLinkProvider(X)},registerTerminalProfileProvider(X,le){return gt.registerProfileProvider(Ae,X,le)},registerTreeDataProvider(X,le){return Yt.registerTreeDataProvider(X,le,Ae)},createTreeView(X,le){return Yt.createTreeView(X,le,Ae)},registerWebviewPanelSerializer:(X,le)=>Kt.registerWebviewPanelSerializer(Ae,X,le),registerCustomEditorProvider:(X,le,Ce={})=>yi.registerCustomEditorProvider(Ae,X,le,Ce),registerFileDecorationProvider(X){return Ct.registerFileDecorationProvider(X,Ae.identifier)},registerUriHandler(X){return At.registerUriHandler(Ae.identifier,X)},createQuickPick(){return qt.createQuickPick(Ae)},createInputBox(){return qt.createInputBox(Ae.identifier)},get activeColorTheme(){return mi.activeColorTheme},onDidChangeActiveColorTheme(X,le,Ce){return mi.onDidChangeActiveColorTheme(X,le,Ce)},registerWebviewViewProvider(X,le,Ce){return Si.registerWebviewViewProvider(Ae,X,le,Ce?.webviewOptions)},get activeNotebookEditor(){return(0,ve.checkProposedApiEnabled)(Ae,"notebookEditor"),wt.activeNotebookEditor},onDidChangeActiveNotebookEditor(X,le,Ce){return(0,ve.checkProposedApiEnabled)(Ae,"notebookEditor"),wt.onDidChangeActiveNotebookEditor(X,le,Ce)},get visibleNotebookEditors(){return(0,ve.checkProposedApiEnabled)(Ae,"notebookEditor"),wt.visibleNotebookEditors},get onDidChangeVisibleNotebookEditors(){return(0,ve.checkProposedApiEnabled)(Ae,"notebookEditor"),wt.onDidChangeVisibleNotebookEditors},onDidChangeNotebookEditorSelection(X,le,Ce){return(0,ve.checkProposedApiEnabled)(Ae,"notebookEditor"),jt.onDidChangeNotebookEditorSelection(X,le,Ce)},onDidChangeNotebookEditorVisibleRanges(X,le,Ce){return(0,ve.checkProposedApiEnabled)(Ae,"notebookEditor"),jt.onDidChangeNotebookEditorVisibleRanges(X,le,Ce)},showNotebookDocument(X,le){return(0,ve.checkProposedApiEnabled)(Ae,"notebookEditor"),wt.showNotebookDocument(X,le)},registerExternalUriOpener(X,le,Ce){return(0,ve.checkProposedApiEnabled)(Ae,"externalUriOpener"),Ci.registerExternalUriOpener(Ae.identifier,X,le,Ce)},get tabs(){return(0,ve.checkProposedApiEnabled)(Ae,"tabs"),vt.tabs},get activeTab(){return(0,ve.checkProposedApiEnabled)(Ae,"tabs"),vt.activeTab},get onDidChangeTabs(){return(0,ve.checkProposedApiEnabled)(Ae,"tabs"),vt.onDidChangeTabs},get onDidChangeActiveTab(){return(0,ve.checkProposedApiEnabled)(Ae,"tabs"),vt.onDidChangeActiveTab},getInlineCompletionItemController(X){return(0,ve.checkProposedApiEnabled)(Ae,"inlineCompletions"),f.InlineCompletionController.get(X)}},ni={get rootPath(){return qe.report("workspace.rootPath",Ae,"Please use 'workspace.workspaceFolders' instead. More details: https://aka.ms/vscode-eliminating-rootpath"),Oe.getPath()},set rootPath(X){throw F.readonly()},getWorkspaceFolder(X){return Oe.getWorkspaceFolder(X)},get workspaceFolders(){return Oe.getWorkspaceFolders()},get name(){return Oe.name},set name(X){throw F.readonly()},get workspaceFile(){return Oe.workspaceFile},set workspaceFile(X){throw F.readonly()},updateWorkspaceFolders:(X,le,...Ce)=>Oe.updateWorkspaceFolders(Ae,X,le||0,...Ce),onDidChangeWorkspaceFolders:function(X,le,Ce){return Oe.onDidChangeWorkspace(X,le,Ce)},asRelativePath:(X,le)=>Oe.getRelativePath(X,le),findFiles:(X,le,Ce,lt)=>Oe.findFiles(z.GlobPattern.from(X),z.GlobPattern.from(le),Ce,Ae.identifier,lt),findTextInFiles:(X,le,Ce,lt)=>{(0,ve.checkProposedApiEnabled)(Ae,"findTextInFiles");let St,Dt;return typeof le=="object"?(St=le,Dt=Ce):(St={},Dt=le,lt=Ce),Oe.findTextInFiles(X,St||{},Dt,Ae.identifier,lt)},saveAll:X=>Oe.saveAll(X),applyEdit(X){return Di.applyWorkspaceEdit(X)},createFileSystemWatcher:(X,le,Ce,lt)=>xt.createFileSystemWatcher(z.GlobPattern.from(X),le,Ce,lt),get textDocuments(){return Et.getAllDocumentData().map(X=>X.document)},set textDocuments(X){throw F.readonly()},openTextDocument(X){let le;const Ce=X;if(typeof X=="string")le=Promise.resolve(t.URI.file(X));else if(t.URI.isUri(X))le=Promise.resolve(X);else if(!Ce||typeof Ce=="object")le=Et.createDocumentData(Ce);else throw new Error("illegal argument - uriOrFileNameOrOptions");return le.then(lt=>Et.ensureDocumentData(lt).then(St=>St.document))},onDidOpenTextDocument:(X,le,Ce)=>Et.onDidAddDocument(X,le,Ce),onDidCloseTextDocument:(X,le,Ce)=>Et.onDidRemoveDocument(X,le,Ce),onDidChangeTextDocument:(X,le,Ce)=>Et.onDidChangeDocument(X,le,Ce),onDidSaveTextDocument:(X,le,Ce)=>Et.onDidSaveDocument(X,le,Ce),onWillSaveTextDocument:(X,le,Ce)=>Nt.getOnWillSaveTextDocumentEvent(Ae)(X,le,Ce),get notebookDocuments(){return wt.notebookDocuments.map(X=>X.apiNotebook)},async openNotebookDocument(X,le){let Ce;if(t.URI.isUri(X))Ce=X,await wt.openNotebookDocument(X);else if(typeof X=="string")Ce=t.URI.revive(await wt.createNotebookDocument({viewType:X,content:le}));else throw new Error("Invalid arguments");return wt.getNotebookDocument(Ce).apiNotebook},get onDidOpenNotebookDocument(){return wt.onDidOpenNotebookDocument},get onDidCloseNotebookDocument(){return wt.onDidCloseNotebookDocument},registerNotebookSerializer(X,le,Ce,lt){return wt.registerNotebookSerializer(Ae,X,le,Ce,(0,ve.isProposedApiEnabled)(Ae,"notebookLiveShare")?lt:void 0)},registerNotebookContentProvider:(X,le,Ce,lt)=>((0,ve.checkProposedApiEnabled)(Ae,"notebookContentProvider"),wt.registerNotebookContentProvider(Ae,X,le,Ce,(0,ve.isProposedApiEnabled)(Ae,"notebookLiveShare")?lt:void 0)),onDidChangeConfiguration:(X,le,Ce)=>pi.onDidChangeConfiguration(X,le,Ce),getConfiguration(X,le){return le=arguments.length===1?void 0:le,pi.getConfiguration(X,le,Ae)},registerTextDocumentContentProvider(X,le){return Ot.registerTextDocumentContentProvider(X,le)},registerTaskProvider:(X,le)=>(qe.report("window.registerTaskProvider",Ae,"Use the corresponding function on the 'tasks' namespace instead"),It.registerTaskProvider(Ae,X,le)),registerFileSystemProvider(X,le,Ce){return(0,Se.combinedDisposable)(ci.registerFileSystemProvider(Ae,X,le,Ce),ke.addFileSystemProvider(X,le))},get fs(){return ke.value},registerFileSearchProvider:(X,le)=>((0,ve.checkProposedApiEnabled)(Ae,"fileSearchProvider"),Lt.registerFileSearchProvider(X,le)),registerTextSearchProvider:(X,le)=>((0,ve.checkProposedApiEnabled)(Ae,"textSearchProvider"),Lt.registerTextSearchProvider(X,le)),registerRemoteAuthorityResolver:(X,le)=>((0,ve.checkProposedApiEnabled)(Ae,"resolvers"),ze.registerRemoteAuthorityResolver(X,le)),registerResourceLabelFormatter:X=>((0,ve.checkProposedApiEnabled)(Ae,"resolvers"),Ei.$registerResourceLabelFormatter(X)),onDidCreateFiles:(X,le,Ce)=>xt.onDidCreateFile(X,le,Ce),onDidDeleteFiles:(X,le,Ce)=>xt.onDidDeleteFile(X,le,Ce),onDidRenameFiles:(X,le,Ce)=>xt.onDidRenameFile(X,le,Ce),onWillCreateFiles:(X,le,Ce)=>xt.getOnWillCreateFileEvent(Ae)(X,le,Ce),onWillDeleteFiles:(X,le,Ce)=>xt.getOnWillDeleteFileEvent(Ae)(X,le,Ce),onWillRenameFiles:(X,le,Ce)=>xt.getOnWillRenameFileEvent(Ae)(X,le,Ce),openTunnel:X=>((0,ve.checkProposedApiEnabled)(Ae,"resolvers"),De.openTunnel(Ae,X).then(le=>{if(!le)throw new Error("cannot open tunnel");return le})),get tunnels(){return(0,ve.checkProposedApiEnabled)(Ae,"resolvers"),De.getTunnels()},onDidChangeTunnels:(X,le,Ce)=>((0,ve.checkProposedApiEnabled)(Ae,"resolvers"),De.onDidChangeTunnels(X,le,Ce)),registerPortAttributesProvider:(X,le)=>((0,ve.checkProposedApiEnabled)(Ae,"portsAttributes"),De.registerPortsAttributesProvider(X,le)),registerTimelineProvider:(X,le)=>((0,ve.checkProposedApiEnabled)(Ae,"timeline"),_i.registerTimelineProvider(X,le,Ae.identifier,ht.converter)),get isTrusted(){return Oe.trusted},requestWorkspaceTrust:X=>((0,ve.checkProposedApiEnabled)(Ae,"workspaceTrust"),Oe.requestWorkspaceTrust(X)),onDidGrantWorkspaceTrust:(X,le,Ce)=>Oe.onDidGrantWorkspaceTrust(X,le,Ce)},Fi={get inputBox(){return qe.report("scm.inputBox",Ae,"Use 'SourceControl.inputBox' instead"),Jt.getLastInputBox(Ae)},createSourceControl(X,le,Ce){return Jt.createSourceControl(Ae,X,le,Ce)}},Mi={createCommentController(X,le){return li.createCommentController(Ae,X,le)}},Oi={get activeDebugSession(){return yt.activeDebugSession},get activeDebugConsole(){return yt.activeDebugConsole},get breakpoints(){return yt.breakpoints},onDidStartDebugSession(X,le,Ce){return yt.onDidStartDebugSession(X,le,Ce)},onDidTerminateDebugSession(X,le,Ce){return yt.onDidTerminateDebugSession(X,le,Ce)},onDidChangeActiveDebugSession(X,le,Ce){return yt.onDidChangeActiveDebugSession(X,le,Ce)},onDidReceiveDebugSessionCustomEvent(X,le,Ce){return yt.onDidReceiveDebugSessionCustomEvent(X,le,Ce)},onDidChangeBreakpoints(X,le,Ce){return yt.onDidChangeBreakpoints(X,le,Ce)},registerDebugConfigurationProvider(X,le,Ce){return yt.registerDebugConfigurationProvider(X,le,Ce||H.DebugConfigurationProviderTriggerKind.Initial)},registerDebugAdapterDescriptorFactory(X,le){return yt.registerDebugAdapterDescriptorFactory(Ae,X,le)},registerDebugAdapterTrackerFactory(X,le){return yt.registerDebugAdapterTrackerFactory(X,le)},startDebugging(X,le,Ce){return!Ce||typeof Ce=="object"&&"configuration"in Ce?yt.startDebugging(X,le,{parentSession:Ce}):yt.startDebugging(X,le,Ce||{})},stopDebugging(X){return yt.stopDebugging(X)},addBreakpoints(X){return yt.addBreakpoints(X)},removeBreakpoints(X){return yt.removeBreakpoints(X)},asDebugSourceUri(X,le){return yt.asDebugSourceUri(X,le)}},Li={registerTaskProvider:(X,le)=>It.registerTaskProvider(Ae,X,le),fetchTasks:X=>It.fetchTasks(X),executeTask:X=>It.executeTask(Ae,X),get taskExecutions(){return It.taskExecutions},onDidStartTask:(X,le,Ce)=>It.onDidStartTask(X,le,Ce),onDidEndTask:(X,le,Ce)=>It.onDidEndTask(X,le,Ce),onDidStartTaskProcess:(X,le,Ce)=>It.onDidStartTaskProcess(X,le,Ce),onDidEndTaskProcess:(X,le,Ce)=>It.onDidEndTaskProcess(X,le,Ce)},Ni={createNotebookController(X,le,Ce,lt,St){return oi.createNotebookController(Ae,X,le,Ce,lt,(0,ve.isProposedApiEnabled)(Ae,"notebookMessaging")?St:void 0)},registerNotebookCellStatusBarItemProvider:(X,le)=>wt.registerNotebookCellStatusBarItemProvider(Ae,X,le),get onDidSaveNotebookDocument(){return(0,ve.checkProposedApiEnabled)(Ae,"notebookEditor"),$t.onDidSaveNotebookDocument},createNotebookEditorDecorationType(X){return(0,ve.checkProposedApiEnabled)(Ae,"notebookEditorDecorationType"),jt.createNotebookEditorDecorationType(X)},createRendererMessaging(X){return si.createRendererMessaging(Ae,X)},onDidChangeNotebookDocumentMetadata(X,le,Ce){return(0,ve.checkProposedApiEnabled)(Ae,"notebookEditor"),$t.onDidChangeNotebookDocumentMetadata(X,le,Ce)},onDidChangeNotebookCells(X,le,Ce){return(0,ve.checkProposedApiEnabled)(Ae,"notebookEditor"),wt.onDidChangeNotebookCells(X,le,Ce)},onDidChangeNotebookCellExecutionState(X,le,Ce){return(0,ve.checkProposedApiEnabled)(Ae,"notebookCellExecutionState"),wt.onDidChangeNotebookCellExecutionState(X,le,Ce)},onDidChangeCellOutputs(X,le,Ce){return(0,ve.checkProposedApiEnabled)(Ae,"notebookEditor"),wt.onDidChangeCellOutputs(X,le,Ce)},onDidChangeCellMetadata(X,le,Ce){return(0,ve.checkProposedApiEnabled)(Ae,"notebookEditor"),wt.onDidChangeCellMetadata(X,le,Ce)},createConcatTextDocument(X,le){return(0,ve.checkProposedApiEnabled)(Ae,"notebookConcatTextDocument"),new Ne.ExtHostNotebookConcatDocument(wt,Et,X,le)}};return{version:fe.version,authentication:ii,commands:Ii,comments:Mi,debug:Oi,env:vi,extensions:Ti,languages:Ai,notebooks:Ni,scm:Fi,tasks:Li,tests:Pi,window:Ri,workspace:ni,Breakpoint:H.Breakpoint,CallHierarchyIncomingCall:H.CallHierarchyIncomingCall,CallHierarchyItem:H.CallHierarchyItem,CallHierarchyOutgoingCall:H.CallHierarchyOutgoingCall,CancellationError:F.CancellationError,CancellationTokenSource:c.CancellationTokenSource,CandidatePortSource:n.CandidatePortSource,CodeAction:H.CodeAction,CodeActionKind:H.CodeActionKind,CodeActionTriggerKind:H.CodeActionTriggerKind,CodeLens:H.CodeLens,Color:H.Color,ColorInformation:H.ColorInformation,ColorPresentation:H.ColorPresentation,ColorThemeKind:H.ColorThemeKind,CommentMode:H.CommentMode,CommentThreadCollapsibleState:H.CommentThreadCollapsibleState,CompletionItem:H.CompletionItem,CompletionItemKind:H.CompletionItemKind,CompletionItemTag:H.CompletionItemTag,CompletionList:H.CompletionList,CompletionTriggerKind:H.CompletionTriggerKind,ConfigurationTarget:H.ConfigurationTarget,CustomExecution:H.CustomExecution,DebugAdapterExecutable:H.DebugAdapterExecutable,DebugAdapterInlineImplementation:H.DebugAdapterInlineImplementation,DebugAdapterNamedPipeServer:H.DebugAdapterNamedPipeServer,DebugAdapterServer:H.DebugAdapterServer,DebugConfigurationProviderTriggerKind:H.DebugConfigurationProviderTriggerKind,DebugConsoleMode:H.DebugConsoleMode,DecorationRangeBehavior:H.DecorationRangeBehavior,Diagnostic:H.Diagnostic,DiagnosticRelatedInformation:H.DiagnosticRelatedInformation,DiagnosticSeverity:H.DiagnosticSeverity,DiagnosticTag:H.DiagnosticTag,Disposable:H.Disposable,DocumentHighlight:H.DocumentHighlight,DocumentHighlightKind:H.DocumentHighlightKind,DocumentLink:H.DocumentLink,DocumentSymbol:H.DocumentSymbol,EndOfLine:H.EndOfLine,EnvironmentVariableMutatorType:H.EnvironmentVariableMutatorType,EvaluatableExpression:H.EvaluatableExpression,InlineValueText:H.InlineValueText,InlineValueVariableLookup:H.InlineValueVariableLookup,InlineValueEvaluatableExpression:H.InlineValueEvaluatableExpression,InlineCompletionTriggerKind:H.InlineCompletionTriggerKind,EventEmitter:w.Emitter,ExtensionKind:H.ExtensionKind,ExtensionMode:H.ExtensionMode,ExternalUriOpenerPriority:H.ExternalUriOpenerPriority,FileChangeType:H.FileChangeType,FileDecoration:H.FileDecoration,FileSystemError:H.FileSystemError,FileType:_.FileType,FilePermission:_.FilePermission,FoldingRange:H.FoldingRange,FoldingRangeKind:H.FoldingRangeKind,FunctionBreakpoint:H.FunctionBreakpoint,InlineCompletionItem:H.InlineSuggestion,InlineCompletionList:H.InlineSuggestions,Hover:H.Hover,IndentAction:k.IndentAction,Location:H.Location,MarkdownString:H.MarkdownString,OverviewRulerLane:C.OverviewRulerLane,ParameterInformation:H.ParameterInformation,PortAutoForwardAction:H.PortAutoForwardAction,Position:H.Position,ProcessExecution:H.ProcessExecution,ProgressLocation:H.ProgressLocation,QuickInputButtons:H.QuickInputButtons,Range:H.Range,RelativePattern:H.RelativePattern,Selection:H.Selection,SelectionRange:H.SelectionRange,SemanticTokens:H.SemanticTokens,SemanticTokensBuilder:H.SemanticTokensBuilder,SemanticTokensEdit:H.SemanticTokensEdit,SemanticTokensEdits:H.SemanticTokensEdits,SemanticTokensLegend:H.SemanticTokensLegend,ShellExecution:H.ShellExecution,ShellQuoting:H.ShellQuoting,SignatureHelp:H.SignatureHelp,SignatureHelpTriggerKind:H.SignatureHelpTriggerKind,SignatureInformation:H.SignatureInformation,SnippetString:H.SnippetString,SourceBreakpoint:H.SourceBreakpoint,StandardTokenType:H.StandardTokenType,StatusBarAlignment:H.StatusBarAlignment,SymbolInformation:H.SymbolInformation,SymbolKind:H.SymbolKind,SymbolTag:H.SymbolTag,Task:H.Task,TaskGroup:H.TaskGroup,TaskPanelKind:H.TaskPanelKind,TaskRevealKind:H.TaskRevealKind,TaskScope:H.TaskScope,TerminalLink:H.TerminalLink,TerminalLocation:H.TerminalLocation,TerminalProfile:H.TerminalProfile,TextDocumentSaveReason:H.TextDocumentSaveReason,TextEdit:H.TextEdit,TextEditorCursorStyle:T.TextEditorCursorStyle,TextEditorLineNumbersStyle:H.TextEditorLineNumbersStyle,TextEditorRevealType:H.TextEditorRevealType,TextEditorSelectionChangeKind:H.TextEditorSelectionChangeKind,TextDocumentChangeReason:H.TextDocumentChangeReason,ThemeColor:H.ThemeColor,ThemeIcon:H.ThemeIcon,TreeItem:H.TreeItem,TreeItemCollapsibleState:H.TreeItemCollapsibleState,TypeHierarchyItem:H.TypeHierarchyItem,UIKind:n.UIKind,Uri:t.URI,ViewColumn:H.ViewColumn,WorkspaceEdit:H.WorkspaceEdit,InlayHint:H.InlayHint,InlayHintKind:H.InlayHintKind,RemoteAuthorityResolverError:H.RemoteAuthorityResolverError,ResolvedAuthority:H.ResolvedAuthority,SourceControlInputBoxValidationType:H.SourceControlInputBoxValidationType,ExtensionRuntime:H.ExtensionRuntime,TimelineItem:H.TimelineItem,NotebookRange:H.NotebookRange,NotebookCellKind:H.NotebookCellKind,NotebookCellExecutionState:H.NotebookCellExecutionState,NotebookCellData:H.NotebookCellData,NotebookData:H.NotebookData,NotebookRendererScript:H.NotebookRendererScript,NotebookCellStatusBarAlignment:H.NotebookCellStatusBarAlignment,NotebookEditorRevealType:H.NotebookEditorRevealType,NotebookCellOutput:H.NotebookCellOutput,NotebookCellOutputItem:H.NotebookCellOutputItem,NotebookCellStatusBarItem:H.NotebookCellStatusBarItem,NotebookControllerAffinity:H.NotebookControllerAffinity,PortAttributes:H.PortAttributes,LinkedEditingRanges:H.LinkedEditingRanges,TestResultState:H.TestResultState,TestRunRequest:H.TestRunRequest,TestMessage:H.TestMessage,TestTag:H.TestTag,TestRunProfileKind:H.TestRunProfileKind,TextSearchCompleteMessageType:he.TextSearchCompleteMessageType,TreeDataTransfer:H.TreeDataTransfer,TreeDataTransferItem:H.TreeDataTransferItem,CoveredCount:H.CoveredCount,FileCoverage:H.FileCoverage,StatementCoverage:H.StatementCoverage,BranchCoverage:H.BranchCoverage,FunctionCoverage:H.FunctionCoverage,WorkspaceTrustState:H.WorkspaceTrustState,LanguageStatusSeverity:H.LanguageStatusSeverity,QuickPickItemKind:H.QuickPickItemKind}}}e.createApiFactoryAndRegisterActors=oe}),define(Ee[220],_e([0,1,56,94,31,93,32,38,48,39,97,98,99,71,64,69,95,49,30,68,85,70,192,12,175]),function(re,e,c,F,w,P,t,T,C,k,R,_,n,m,o,d,u,S,b,h,g,A,l,M,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),(0,c.registerSingleton)(M.ILoggerService,l.ExtHostLoggerService),(0,c.registerSingleton)(M.ILogService,r.ExtHostLogService),(0,c.registerSingleton)(d.IExtHostApiDeprecationService,d.ExtHostApiDeprecationService),(0,c.registerSingleton)(T.IExtHostCommands,T.ExtHostCommands),(0,c.registerSingleton)(t.IExtHostConfiguration,t.ExtHostConfiguration),(0,c.registerSingleton)(S.IExtHostConsumerFileSystem,S.ExtHostConsumerFileSystem),(0,c.registerSingleton)(_.IExtHostDebugService,_.WorkerExtHostDebugService),(0,c.registerSingleton)(P.IExtHostDecorations,P.ExtHostDecorations),(0,c.registerSingleton)(C.IExtHostDocumentsAndEditors,C.ExtHostDocumentsAndEditors),(0,c.registerSingleton)(b.IExtHostFileSystemInfo,b.ExtHostFileSystemInfo),(0,c.registerSingleton)(F.IExtHostOutputService,F.ExtHostOutputService),(0,c.registerSingleton)(n.IExtHostSearch,n.ExtHostSearch),(0,c.registerSingleton)(m.IExtHostStorage,m.ExtHostStorage),(0,c.registerSingleton)(R.IExtHostTask,R.WorkerExtHostTask),(0,c.registerSingleton)(k.IExtHostTerminalService,k.WorkerExtHostTerminalService),(0,c.registerSingleton)(o.IExtHostTunnelService,o.ExtHostTunnelService),(0,c.registerSingleton)(u.IExtHostWindow,u.ExtHostWindow),(0,c.registerSingleton)(w.IExtHostWorkspace,w.ExtHostWorkspace),(0,c.registerSingleton)(h.IExtHostSecretState,h.ExtHostSecretState),(0,c.registerSingleton)(g.IExtHostTelemetry,g.ExtHostTelemetry),(0,c.registerSingleton)(A.IExtHostEditorTabs,A.ExtHostEditorTabs)}),define(Ee[221],_e([0,1,219,33,215,7,14,5,10]),function(re,e,c,F,w,P,t,T,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostExtensionService=void 0;var k;(function(o){const d=self.trustedTypes?.createPolicy("TrustedFunctionWorkaround",{createScript:(S,...b)=>{b.forEach(l=>{if(!self.trustedTypes?.isScript(l))throw new Error("TrustedScripts only, please")});const h=b.slice(0,-1).join(","),g=b.pop().toString();return`(function anonymous(${h}) {${g}
})`}});function u(...S){return d?self.eval(d.createScript("",...S)):new Function(...S)}o.create=u})(k||(k={}));class R extends w.RequireInterceptor{_installInterceptor(){}getModule(d,u){for(let S of this._alternatives){let b=S(d);if(b){d=b;break}}if(this._factories.has(d))return this._factories.get(d).load(d,u,()=>{throw new Error("CANNOT LOAD MODULE from here.")})}}class _ extends F.AbstractExtHostExtensionService{constructor(){super(...arguments);this.extensionRuntime=P.ExtensionRuntime.Webworker}async _beforeAlmostReadyToRunExtensions(){const d=this._extHostContext.getProxy(T.MainContext.MainThreadConsole);m(d,this._initData.environment.isExtensionDevelopmentDebug);const u=this._instaService.invokeFunction(c.createApiFactoryAndRegisterActors);this._fakeModules=this._instaService.createInstance(R,u,this._registry),await this._fakeModules.install(),performance.mark("code/extHost/didInitAPI"),await this._waitForDebuggerAttachment()}_getEntryPoint(d){return d.browser}async _loadCommonJSModule(d,u,S){u=u.with({path:n(u.path,".js")}),d&&performance.mark(`code/extHost/willFetchExtensionCode/${d.value}`);const b=await fetch(C.FileAccess.asBrowserUri(u).toString(!0));if(d&&performance.mark(`code/extHost/didFetchExtensionCode/${d.value}`),b.status!==200)throw new Error(b.statusText);const h=await b.text(),g=`${u.toString(!0)}#vscode-extension`,A=`${h}
//# sourceURL=${g}`;let l;try{l=k.create(_._ttpExtensionScripts?.createScript("module")??"module",_._ttpExtensionScripts?.createScript("exports")??"exports",_._ttpExtensionScripts?.createScript("require")??"require",_._ttpExtensionScripts?.createScript(A)??A)}catch(p){throw console.error(d?`Loading code for extension ${d.value} failed: ${p.message}`:`Loading code failed: ${p.message}`),console.error(`${u.toString(!0)}${typeof p.line=="number"?` line ${p.line}`:""}${typeof p.column=="number"?` column ${p.column}`:""}`),console.error(p),p}const M={},r={exports:M},i=p=>{const f=this._fakeModules.getModule(p,u);if(f===void 0)throw new Error(`Cannot load module '${p}'`);return f};try{return S.codeLoadingStart(),d&&performance.mark(`code/extHost/willLoadExtensionCode/${d.value}`),l(r,M,i),r.exports!==M?r.exports:M}finally{d&&performance.mark(`code/extHost/didLoadExtensionCode/${d.value}`),S.codeLoadingStop()}}async $setRemoteEnvironment(d){}async _waitForDebuggerAttachment(d=5e3){if(!this._initData.environment.isExtensionDevelopmentDebug)return;const u=Date.now()+d;for(;Date.now()<u&&!("__jsDebugIsReady"in globalThis);)await(0,t.timeout)(10)}}e.ExtHostExtensionService=_,_._ttpExtensionScripts=self.trustedTypes?.createPolicy("ExtensionScripts",{createScript:o=>o});function n(o,d){return o.endsWith(d)?o:o+d}function m(o,d){u("info","log"),u("log","log"),u("warn","warn"),u("error","error");function u(h,g){const A=console[h];console[h]=function(){o.$logExtensionHostMessage({type:"__$console",severity:g,arguments:b(arguments)}),d&&A.apply(console,arguments)}}const S=1e5;function b(h){const g=[],A=[];if(h.length)for(let l=0;l<h.length;l++){if(typeof h[l]=="undefined")h[l]="undefined";else if(h[l]instanceof Error){const M=h[l];M.stack?h[l]=M.stack:h[l]=M.toString()}A.push(h[l])}try{const l=JSON.stringify(A,function(M,r){if(r&&typeof r=="object"){if(g.indexOf(r)!==-1)return"[Circular]";g.push(r)}return r});return l.length>S?"Output omitted for a large object that exceeds the limits":l}catch(l){return`Output omitted for an object that cannot be inspected ('${l.toString()}')`}}}}),define(Ee[222],_e([0,1,56,33,72,221]),function(re,e,c,F,w,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),(0,c.registerSingleton)(F.IExtHostExtensionService,P.ExtHostExtensionService),(0,c.registerSingleton)(w.IExtensionStoragePaths,w.ExtensionStoragePaths)}),define(Ee[233],_e([0,1,22,3,173,216,210,17,73,10,2,220,222]),function(re,e,c,F,w,P,t,T,C,k,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.create=void 0;const _=self.close.bind(self);self.close=()=>console.trace("'close' has been blocked");const n=postMessage.bind(self);self.postMessage=()=>console.trace("'postMessage' has been blocked");const m=fetch.bind(self);if(self.fetch=function(h,g){return h instanceof Request||/^file:/i.test(String(h))&&(h=k.FileAccess.asBrowserUri(R.URI.parse(String(h))).toString(!0)),m(h,g)},self.XMLHttpRequest=class extends XMLHttpRequest{open(h,g,A,l,M){return/^file:/i.test(g.toString())&&(g=k.FileAccess.asBrowserUri(R.URI.parse(g.toString())).toString(!0)),super.open(h,g,A??!0,l,M)}},self.importScripts=()=>{throw new Error("'importScripts' has been blocked")},self.addEventListener=()=>console.trace("'addEventListener' has been blocked"),self.AMDLoader=void 0,self.NLSLoaderPlugin=void 0,self.define=void 0,self.require=void 0,self.webkitRequestFileSystem=void 0,self.webkitRequestFileSystemSync=void 0,self.webkitResolveLocalFileSystemSyncURL=void 0,self.webkitResolveLocalFileSystemURL=void 0,self.Worker){const h=self.trustedTypes?.createPolicy("extensionHostWorker",{createScriptURL:A=>A}),g=self.Worker;Worker=function(A,l){/^file:/i.test(A.toString())&&(A=k.FileAccess.asBrowserUri(R.URI.parse(A.toString())).toString(!0));const r=`(${function(s){function v(D){return typeof D=="string"||D instanceof URL?String(D).replace(/^file:\/\//i,"vscode-file://vscode-app"):D}const a=fetch.bind(self);self.fetch=function(D,B){return D instanceof Request?a(D,B):a(v(D),B)},self.XMLHttpRequest=class extends XMLHttpRequest{open(D,B,L,y,x){return super.open(D,v(B),L??!0,y,x)}};const E=importScripts.bind(self);self.importScripts=(...D)=>{E(...D.map(v))};const I=self.trustedTypes?self.trustedTypes.createPolicy("extensionHostWorker",{createScriptURL:D=>D}):void 0;E(I?I.createScriptURL(s):s)}.toString()}('${A}'))`;l=l||{},l.name=l.name||T.basename(A.toString());const i=new Blob([r],{type:"application/javascript"}),p=URL.createObjectURL(i);return new g(h?h.createScriptURL(p):p,l)}}else self.Worker=class extends t.NestedWorker{constructor(h,g){super(n,h,{name:T.basename(h.toString()),...g})}};const o=new class{constructor(){this.pid=void 0}exit(h){_()}async exists(h){return!0}async realpath(h){return h}};class d{constructor(){const g=new MessageChannel,A=new F.Emitter;let l=!1;n(g.port2,[g.port2]),g.port1.onmessage=M=>{const{data:r}=M;if(!(r instanceof ArrayBuffer)){console.warn("UNKNOWN data received",r);return}const i=c.VSBuffer.wrap(new Uint8Array(r,0,r.byteLength));if((0,w.isMessageOfType)(i,2)){l=!0,S("received terminate message from renderer");return}A.fire(i)},this.protocol={onMessage:A.event,send:M=>{if(!l){const r=M.buffer.buffer.slice(M.buffer.byteOffset,M.buffer.byteOffset+M.buffer.byteLength);g.port1.postMessage(r,[r])}}}}}function u(h){return new Promise(g=>{const A=h.onMessage(l=>{A.dispose();const M=JSON.parse(l.toString());h.send((0,w.createMessageOfType)(0)),g({protocol:h,initData:M})});h.send((0,w.createMessageOfType)(1))})}let S=h=>_();function b(){const h=new d;C.mark("code/extHost/willConnectToRenderer"),u(h.protocol).then(g=>{C.mark("code/extHost/didWaitForInitData");const A=new P.ExtensionHostMain(g.protocol,g.initData,o,null);S=l=>A.terminate(l)})}e.create=b})}).call(this);

//# sourceMappingURL=https://ticino.blob.core.windows.net/sourcemaps/899d46d82c4c95423fb7e10e68eba52050e30ba3/core/vs/workbench/services/extensions/worker/extensionHostWorker.js.map
